/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/errors","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/strings","vs/base/common/arrays","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/platform/environment/common/environment","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/request/common/request","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/marshalling","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/environment/node/environmentService","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","@vscode/policy-watcher","https","zlib","vs/code/electron-main/main"],se=function(X){for(var e=[],P=0,A=X.length;P<A;P++)e[P]=ie[X[P]];return e};define(ie[126],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function P(k,g){const d=Math.pow(10,g);return Math.round(k*d)/d}class A{constructor(g,d,y,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,d))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=P(Math.max(Math.min(1,b),0),3)}static equals(g,d){return g.r===d.r&&g.g===d.g&&g.b===d.b&&g.a===d.a}}e.RGBA=A;class n{constructor(g,d,y,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=P(Math.max(Math.min(1,d),0),3),this.l=P(Math.max(Math.min(1,y),0),3),this.a=P(Math.max(Math.min(1,b),0),3)}static equals(g,d){return g.h===d.h&&g.s===d.s&&g.l===d.l&&g.a===d.a}static fromRGBA(g){const d=g.r/255,y=g.g/255,b=g.b/255,I=g.a,u=Math.max(d,y,b),w=Math.min(d,y,b);let S=0,s=0;const h=(w+u)/2,f=u-w;if(f>0){switch(s=Math.min(h<=.5?f/(2*h):f/(2-2*h),1),u){case d:S=(y-b)/f+(y<b?6:0);break;case y:S=(b-d)/f+2;break;case b:S=(d-y)/f+4;break}S*=60,S=Math.round(S)}return new n(S,s,h,I)}static i(g,d,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?g+(d-g)*6*y:y<1/2?d:y<2/3?g+(d-g)*(2/3-y)*6:g}static toRGBA(g){const d=g.h/360,{s:y,l:b,a:I}=g;let u,w,S;if(y===0)u=w=S=b;else{const s=b<.5?b*(1+y):b+y-b*y,h=2*b-s;u=n.i(h,s,d+1/3),w=n.i(h,s,d),S=n.i(h,s,d-1/3)}return new A(Math.round(u*255),Math.round(w*255),Math.round(S*255),I)}}e.HSLA=n;class R{constructor(g,d,y,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=P(Math.max(Math.min(1,d),0),3),this.v=P(Math.max(Math.min(1,y),0),3),this.a=P(Math.max(Math.min(1,b),0),3)}static equals(g,d){return g.h===d.h&&g.s===d.s&&g.v===d.v&&g.a===d.a}static fromRGBA(g){const d=g.r/255,y=g.g/255,b=g.b/255,I=Math.max(d,y,b),u=Math.min(d,y,b),w=I-u,S=I===0?0:w/I;let s;return w===0?s=0:I===d?s=((y-b)/w%6+6)%6:I===y?s=(b-d)/w+2:s=(d-y)/w+4,new R(Math.round(s*60),S,I,g.a)}static toRGBA(g){const{h:d,s:y,v:b,a:I}=g,u=b*y,w=u*(1-Math.abs(d/60%2-1)),S=b-u;let[s,h,f]=[0,0,0];return d<60?(s=u,h=w):d<120?(s=w,h=u):d<180?(h=u,f=w):d<240?(h=w,f=u):d<300?(s=w,f=u):d<=360&&(s=u,f=w),s=Math.round((s+S)*255),h=Math.round((h+S)*255),f=Math.round((f+S)*255),new A(s,h,f,I)}}e.HSVA=R;class D{static fromHex(g){return D.Format.CSS.parseHex(g)||D.red}static equals(g,d){return!g&&!d?!0:!g||!d?!1:g.equals(d)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(g){if(g)if(g instanceof A)this.rgba=g;else if(g instanceof n)this.i=g,this.rgba=n.toRGBA(g);else if(g instanceof R)this.j=g,this.rgba=R.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(g){return!!g&&A.equals(this.rgba,g.rgba)&&n.equals(this.hsla,g.hsla)&&R.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=D.k(this.rgba.r),d=D.k(this.rgba.g),y=D.k(this.rgba.b),b=.2126*g+.7152*d+.0722*y;return P(b,4)}static k(g){const d=g/255;return d<=.03928?d/12.92:Math.pow((d+.055)/1.055,2.4)}getContrastRatio(g){const d=this.getRelativeLuminance(),y=g.getRelativeLuminance();return d>y?(d+.05)/(y+.05):(y+.05)/(d+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const d=this.getRelativeLuminance(),y=g.getRelativeLuminance();return d>y}isDarkerThan(g){const d=this.getRelativeLuminance(),y=g.getRelativeLuminance();return d<y}lighten(g){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:d,g:y,b,a:I}=this.rgba;return new D(new A(d,y,b,I*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const d=g.rgba,y=this.rgba.a,b=d.a,I=y+b*(1-y);if(I<1e-6)return D.transparent;const u=this.rgba.r*y/I+d.r*b*(1-y)/I,w=this.rgba.g*y/I+d.g*b*(1-y)/I,S=this.rgba.b*y/I+d.b*b*(1-y)/I;return new D(new A(u,w,S,I))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:d,g:y,b,a:I}=this.rgba;return new D(new A(g.rgba.r-I*(g.rgba.r-d),g.rgba.g-I*(g.rgba.g-y),g.rgba.b-I*(g.rgba.b-b),1))}flatten(...g){const d=g.reduceRight((y,b)=>D.o(b,y));return D.o(this,d)}static o(g,d){const y=1-g.rgba.a;return new D(new A(y*d.rgba.r+g.rgba.a*g.rgba.r,y*d.rgba.g+g.rgba.a*g.rgba.g,y*d.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(g,d,y){if(g.isLighterThan(d))return g;y=y||.5;const b=g.getRelativeLuminance(),I=d.getRelativeLuminance();return y=y*(I-b)/I,g.lighten(y)}static getDarkerColor(g,d,y){if(g.isDarkerThan(d))return g;y=y||.5;const b=g.getRelativeLuminance(),I=d.getRelativeLuminance();return y=y*(b-I)/b,g.darken(y)}}D.white=new D(new A(255,255,255,1)),D.black=new D(new A(0,0,0,1)),D.red=new D(new A(255,0,0,1)),D.blue=new D(new A(0,0,255,1)),D.green=new D(new A(0,255,0,1)),D.cyan=new D(new A(0,255,255,1)),D.lightgrey=new D(new A(211,211,211,1)),D.transparent=new D(new A(0,0,0,0)),e.Color=D,function(k){let g;(function(d){let y;(function(b){function I(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:k.Format.CSS.formatRGBA(t)}b.formatRGB=I;function u(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}b.formatRGBA=u;function w(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(t)}b.formatHSL=w;function S(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}b.formatHSLA=S;function s(t){const c=t.toString(16);return c.length!==2?"0"+c:c}function h(t){return`#${s(t.rgba.r)}${s(t.rgba.g)}${s(t.rgba.b)}`}b.formatHex=h;function f(t,c=!1){return c&&t.rgba.a===1?k.Format.CSS.formatHex(t):`#${s(t.rgba.r)}${s(t.rgba.g)}${s(t.rgba.b)}${s(Math.round(t.rgba.a*255))}`}b.formatHexA=f;function p(t){return t.isOpaque()?k.Format.CSS.formatHex(t):k.Format.CSS.formatRGBA(t)}b.format=p;function v(t){const c=t.length;if(c===0||t.charCodeAt(0)!==35)return null;if(c===7){const i=16*C(t.charCodeAt(1))+C(t.charCodeAt(2)),o=16*C(t.charCodeAt(3))+C(t.charCodeAt(4)),r=16*C(t.charCodeAt(5))+C(t.charCodeAt(6));return new k(new A(i,o,r,1))}if(c===9){const i=16*C(t.charCodeAt(1))+C(t.charCodeAt(2)),o=16*C(t.charCodeAt(3))+C(t.charCodeAt(4)),r=16*C(t.charCodeAt(5))+C(t.charCodeAt(6)),l=16*C(t.charCodeAt(7))+C(t.charCodeAt(8));return new k(new A(i,o,r,l/255))}if(c===4){const i=C(t.charCodeAt(1)),o=C(t.charCodeAt(2)),r=C(t.charCodeAt(3));return new k(new A(16*i+i,16*o+o,16*r+r))}if(c===5){const i=C(t.charCodeAt(1)),o=C(t.charCodeAt(2)),r=C(t.charCodeAt(3)),l=C(t.charCodeAt(4));return new k(new A(16*i+i,16*o+o,16*r+r,(16*l+l)/255))}return null}b.parseHex=v;function C(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=d.CSS||(d.CSS={}))})(g=k.Format||(k.Format={}))}(D=e.Color||(e.Color={})),e.Color=D}),define(ie[55],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function P(D){return(k,g,d)=>{let y=null,b=null;if(typeof d.value=="function"?(y="value",b=d.value):typeof d.get=="function"&&(y="get",b=d.get),!b)throw new Error("not supported");d[y]=D(b,g)}}function A(D,k,g){let d=null,y=null;if(typeof g.value=="function"?(d="value",y=g.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(d="get",y=g.get),!y)throw new Error("not supported");const b=`$memoize$${k}`;g[d]=function(...I){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,I)}),this[b]}}e.memoize=A;function n(D,k,g){return P((d,y)=>{const b=`$debounce$${y}`,I=`$debounce$result$${y}`;return function(...u){this[I]||(this[I]=g?g():void 0),clearTimeout(this[b]),k&&(this[I]=k(this[I],...u),u=[this[I]]),this[b]=setTimeout(()=>{d.apply(this,u),this[I]=g?g():void 0},D)}})}e.debounce=n;function R(D,k,g){return P((d,y)=>{const b=`$throttle$timer$${y}`,I=`$throttle$result$${y}`,u=`$throttle$lastRun$${y}`,w=`$throttle$pending$${y}`;return function(...S){if(this[I]||(this[I]=g?g():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),k&&(this[I]=k(this[I],...S)),this[w])return;const s=this[u]+D;s<=Date.now()?(this[u]=Date.now(),d.apply(this,[this[I]]),this[I]=g?g():void 0):(this[w]=!0,this[b]=setTimeout(()=>{this[w]=!1,this[u]=Date.now(),d.apply(this,[this[I]]),this[I]=g?g():void 0},s-Date.now()))}})}e.throttle=R}),define(ie[13],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class P{constructor(){this.b=[],this.a=function(c){setTimeout(()=>{throw c.stack?v.isErrorNoTelemetry(c)?new v(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.b.push(c),()=>{this.d(c)}}c(c){this.b.forEach(i=>{i(c)})}d(c){this.b.splice(this.b.indexOf(c),1)}setUnexpectedErrorHandler(c){this.a=c}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(c){this.a(c),this.c(c)}onUnexpectedExternalError(c){this.a(c)}}e.ErrorHandler=P,e.errorHandler=new P;function A(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=A;function n(t){if(!t||typeof t!="object")return!1;const c=t;return c.code==="EPIPE"&&c.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=n;function R(t){d(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=R;function D(t){d(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=D;function k(t){if(t instanceof Error){const{name:c,message:i}=t,o=t.stacktrace||t.stack;return{$isError:!0,name:c,message:i,stack:o,noTelemetry:v.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=k;const g="Canceled";function d(t){return t instanceof y?!0:t instanceof Error&&t.name===g&&t.message===g}e.isCancellationError=d;class y extends Error{constructor(){super(g),this.name=this.message}}e.CancellationError=y;function b(){const t=new Error(g);return t.name=t.message,t}e.canceled=b;function I(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=I;function u(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=u;function w(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function S(t){const c=new Error(`${t} has been disposed`);return c.name="DISPOSED",c}e.disposed=S;function s(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=s;class h extends Error{constructor(c){super("NotImplemented"),c&&(this.message=c)}}e.NotImplementedError=h;class f extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}e.NotSupportedError=f;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class v extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof v)return c;const i=new v;return i.message=c.message,i.stack=c.stack,i}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}e.ErrorNoTelemetry=v;class C extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype);debugger}}e.BugIndicatingError=C}),define(ie[26],se([0,1,13]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(B,Y=0){return B[B.length-(1+Y)]}e.tail=A;function n(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=n;function R(B,Y,Z=(ce,fe)=>ce===fe){if(B===Y)return!0;if(!B||!Y||B.length!==Y.length)return!1;for(let ce=0,fe=B.length;ce<fe;ce++)if(!Z(B[ce],Y[ce]))return!1;return!0}e.equals=R;function D(B,Y){const Z=B.length-1;Y<Z&&(B[Y]=B[Z]),B.pop()}e.removeFastWithoutKeepingOrder=D;function k(B,Y,Z){return g(B.length,ce=>Z(B[ce],Y))}e.binarySearch=k;function g(B,Y){let Z=0,ce=B-1;for(;Z<=ce;){const fe=(Z+ce)/2|0,De=Y(fe);if(De<0)Z=fe+1;else if(De>0)ce=fe-1;else return fe}return-(Z+1)}e.binarySearch2=g;function d(B,Y){let Z=0,ce=B.length;if(ce===0)return 0;for(;Z<ce;){const fe=Math.floor((Z+ce)/2);Y(B[fe])?ce=fe:Z=fe+1}return Z}e.findFirstInSorted=d;function y(B,Y,Z){if(B=B|0,B>=Y.length)throw new TypeError("invalid index");const ce=Y[Math.floor(Y.length*Math.random())],fe=[],De=[],Re=[];for(const Ce of Y){const Oe=Z(Ce,ce);Oe<0?fe.push(Ce):Oe>0?De.push(Ce):Re.push(Ce)}return B<fe.length?y(B,fe,Z):B<fe.length+Re.length?Re[0]:y(B-(fe.length+Re.length),De,Z)}e.quickSelect=y;function b(B,Y){const Z=[];let ce;for(const fe of B.slice(0).sort(Y))!ce||Y(ce[0],fe)!==0?(ce=[fe],Z.push(ce)):ce.push(fe);return Z}e.groupBy=b;function I(B,Y,Z){const ce=[];function fe(Ce,Oe,$e){if(Oe===0&&$e.length===0)return;const ge=ce[ce.length-1];ge&&ge.start+ge.deleteCount===Ce?(ge.deleteCount+=Oe,ge.toInsert.push(...$e)):ce.push({start:Ce,deleteCount:Oe,toInsert:$e})}let De=0,Re=0;for(;;){if(De===B.length){fe(De,0,Y.slice(Re));break}if(Re===Y.length){fe(De,B.length-De,[]);break}const Ce=B[De],Oe=Y[Re],$e=Z(Ce,Oe);$e===0?(De+=1,Re+=1):$e<0?(fe(De,1,[]),De+=1):$e>0&&(fe(De,0,[Oe]),Re+=1)}return ce}e.sortedDiff=I;function u(B,Y,Z){const ce=I(B,Y,Z),fe=[],De=[];for(const Re of ce)fe.push(...B.slice(Re.start,Re.start+Re.deleteCount)),De.push(...Re.toInsert);return{removed:fe,added:De}}e.delta=u;function w(B,Y,Z){if(Z===0)return[];const ce=B.slice(0,Z).sort(Y);return s(B,Y,ce,Z,B.length),ce}e.top=w;function S(B,Y,Z,ce,fe){return Z===0?Promise.resolve([]):new Promise((De,Re)=>{(async()=>{const Ce=B.length,Oe=B.slice(0,Z).sort(Y);for(let $e=Z,ge=Math.min(Z+ce,Ce);$e<Ce;$e=ge,ge=Math.min(ge+ce,Ce)){if($e>Z&&await new Promise(pe=>setTimeout(pe)),fe&&fe.isCancellationRequested)throw new P.CancellationError;s(B,Y,Oe,$e,ge)}return Oe})().then(De,Re)})}e.topAsync=S;function s(B,Y,Z,ce,fe){for(const De=Z.length;ce<fe;ce++){const Re=B[ce];if(Y(Re,Z[De-1])<0){Z.pop();const Ce=d(Z,Oe=>Y(Re,Oe)<0);Z.splice(Ce,0,Re)}}}function h(B){return B.filter(Y=>!!Y)}e.coalesce=h;function f(B){let Y=0;for(let Z=0;Z<B.length;Z++)B[Z]&&(B[Y]=B[Z],Y+=1);B.length=Y}e.coalesceInPlace=f;function p(B,Y,Z){B.splice(Z,0,B.splice(Y,1)[0])}e.move=p;function v(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=v;function C(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=C;function t(B,Y=Z=>Z){const Z=new Set;return B.filter(ce=>{const fe=Y(ce);return Z.has(fe)?!1:(Z.add(fe),!0)})}e.distinct=t;function c(B){const Y=new Set;return Z=>{const ce=B(Z);return Y.has(ce)?!1:(Y.add(ce),!0)}}e.uniqueFilter=c;function i(B,Y){const Z=o(B,Y);if(Z!==-1)return B[Z]}e.findLast=i;function o(B,Y){for(let Z=B.length-1;Z>=0;Z--){const ce=B[Z];if(Y(ce))return Z}return-1}e.lastIndex=o;function r(B,Y){return B.length>0?B[0]:Y}e.firstOrDefault=r;function l(B,Y){return B.length>0?B[B.length-1]:Y}e.lastOrDefault=l;function a(B,Y,Z=(ce,fe)=>ce===fe){let ce=0;for(let fe=0,De=Math.min(B.length,Y.length);fe<De&&Z(B[fe],Y[fe]);fe++)ce++;return ce}e.commonPrefixLength=a;function m(B){return[].concat(...B)}e.flatten=m;function E(B,Y){let Z=typeof Y=="number"?B:0;typeof Y=="number"?Z=B:(Z=0,Y=B);const ce=[];if(Z<=Y)for(let fe=Z;fe<Y;fe++)ce.push(fe);else for(let fe=Z;fe>Y;fe--)ce.push(fe);return ce}e.range=E;function M(B,Y,Z){return B.reduce((ce,fe)=>(ce[Y(fe)]=Z?Z(fe):fe,ce),Object.create(null))}e.index=M;function T(B,Y){return B.push(Y),()=>N(B,Y)}e.insert=T;function N(B,Y){const Z=B.indexOf(Y);if(Z>-1)return B.splice(Z,1),Y}e.remove=N;function z(B,Y,Z){const ce=B.slice(0,Y),fe=B.slice(Y);return ce.concat(Z,fe)}e.arrayInsert=z;function K(B,Y){let Z;if(typeof Y=="number"){let ce=Y;Z=()=>{const fe=Math.sin(ce++)*179426549;return fe-Math.floor(fe)}}else Z=Math.random;for(let ce=B.length-1;ce>0;ce-=1){const fe=Math.floor(Z()*(ce+1)),De=B[ce];B[ce]=B[fe],B[fe]=De}}e.shuffle=K;function ae(B,Y){const Z=B.indexOf(Y);Z>-1&&(B.splice(Z,1),B.unshift(Y))}e.pushToStart=ae;function le(B,Y){const Z=B.indexOf(Y);Z>-1&&(B.splice(Z,1),B.push(Y))}e.pushToEnd=le;function te(B,Y){for(const Z of Y)B.push(Z)}e.pushMany=te;function F(B,Y){return Array.isArray(B)?B.map(Y):Y(B)}e.mapArrayOrNot=F;function $(B){return Array.isArray(B)?B:[B]}e.asArray=$;function V(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=V;function x(B,Y){for(const Z of B){const ce=Y(Z);if(ce!==void 0)return ce}}e.mapFind=x;function H(B,Y,Z){const ce=G(B,Y),fe=B.length,De=Z.length;B.length=fe+De;for(let Re=fe-1;Re>=ce;Re--)B[Re+De]=B[Re];for(let Re=0;Re<De;Re++)B[Re+ce]=Z[Re]}e.insertInto=H;function O(B,Y,Z,ce){const fe=G(B,Y),De=B.splice(fe,Z);return H(B,fe,ce),De}e.splice=O;function G(B,Y){return Y<0?Math.max(Y+B.length,0):Math.min(Y,B.length)}var _;(function(B){function Y(fe){return fe<0}B.isLessThan=Y;function Z(fe){return fe>0}B.isGreaterThan=Z;function ce(fe){return fe===0}B.isNeitherLessOrGreaterThan=ce,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(_=e.CompareResult||(e.CompareResult={}));function re(B,Y){return(Z,ce)=>Y(B(Z),B(ce))}e.compareBy=re;function oe(...B){return(Y,Z)=>{for(const ce of B){const fe=ce(Y,Z);if(!_.isNeitherLessOrGreaterThan(fe))return fe}return _.neitherLessOrGreaterThan}}e.tieBreakComparators=oe;const L=(B,Y)=>B-Y;e.numberComparator=L;function W(B,Y){if(B.length===0)return;let Z=B[0];for(let ce=1;ce<B.length;ce++){const fe=B[ce];Y(fe,Z)>0&&(Z=fe)}return Z}e.findMaxBy=W;function U(B,Y){if(B.length===0)return;let Z=B[0];for(let ce=1;ce<B.length;ce++){const fe=B[ce];Y(fe,Z)>=0&&(Z=fe)}return Z}e.findLastMaxBy=U;function j(B,Y){return W(B,(Z,ce)=>-Y(Z,ce))}e.findMinBy=j;class q{constructor(Y){this.f=Y,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let Z=this.c;for(;Z<this.f.length&&Y(this.f[Z]);)Z++;const ce=Z===this.c?null:this.f.slice(this.c,Z);return this.c=Z,ce}takeFromEndWhile(Y){let Z=this.d;for(;Z>=0&&Y(this.f[Z]);)Z--;const ce=Z===this.d?null:this.f.slice(Z+1,this.d+1);return this.d=Z,ce}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Y=this.f[this.c];return this.c++,Y}removeLast(){const Y=this.f[this.d];return this.d--,Y}takeCount(Y){const Z=this.f.slice(this.c,this.c+Y);return this.c+=Y,Z}}e.ArrayQueue=q;class J{constructor(Y){this.iterate=Y}forEach(Y){this.iterate(Z=>(Y(Z),!0))}toArray(){const Y=[];return this.iterate(Z=>(Y.push(Z),!0)),Y}filter(Y){return new J(Z=>this.iterate(ce=>Y(ce)?Z(ce):!0))}map(Y){return new J(Z=>this.iterate(ce=>Z(Y(ce))))}some(Y){let Z=!1;return this.iterate(ce=>(Z=Y(ce),!Z)),Z}findFirst(Y){let Z;return this.iterate(ce=>Y(ce)?(Z=ce,!1):!0),Z}findLast(Y){let Z;return this.iterate(ce=>(Y(ce)&&(Z=ce),!0)),Z}findLastMaxBy(Y){let Z,ce=!0;return this.iterate(fe=>((ce||_.isGreaterThan(Y(fe,Z)))&&(ce=!1,Z=fe),!0)),Z}}J.empty=new J(B=>{}),e.CallbackIterable=J}),define(ie[127],se([0,1,13]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(g,d){if(!g)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}e.ok=A;function n(g,d="Unreachable"){throw new Error(d)}e.assertNever=n;function R(g){if(!g)throw new P.BugIndicatingError("Assertion Failed")}e.assert=R;function D(g){if(!g()){debugger;g(),(0,P.onUnexpectedError)(new P.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function k(g,d){let y=0;for(;y<g.length-1;){const b=g[y],I=g[y+1];if(!d(b,I))return!1;y++}return!0}e.checkAdjacentItems=k}),define(ie[50],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function P(A){const n=this;let R=!1,D;return function(){return R||(R=!0,D=A.apply(n,arguments)),D}}e.once=P}),define(ie[70],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(A){function n(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}A.is=n;const R=Object.freeze([]);function D(){return R}A.empty=D;function*k(v){yield v}A.single=k;function g(v){return n(v)?v:k(v)}A.wrap=g;function d(v){return v||R}A.from=d;function y(v){return!v||v[Symbol.iterator]().next().done===!0}A.isEmpty=y;function b(v){return v[Symbol.iterator]().next().value}A.first=b;function I(v,C){for(const t of v)if(C(t))return!0;return!1}A.some=I;function u(v,C){for(const t of v)if(C(t))return t}A.find=u;function*w(v,C){for(const t of v)C(t)&&(yield t)}A.filter=w;function*S(v,C){let t=0;for(const c of v)yield C(c,t++)}A.map=S;function*s(...v){for(const C of v)for(const t of C)yield t}A.concat=s;function h(v,C,t){let c=t;for(const i of v)c=C(c,i);return c}A.reduce=h;function*f(v,C,t=v.length){for(C<0&&(C+=v.length),t<0?t+=v.length:t>v.length&&(t=v.length);C<t;C++)yield v[C]}A.slice=f;function p(v,C=Number.POSITIVE_INFINITY){const t=[];if(C===0)return[t,v];const c=v[Symbol.iterator]();for(let i=0;i<C;i++){const o=c.next();if(o.done)return[t,A.empty()];t.push(o.value)}return[t,{[Symbol.iterator](){return c}}]}A.consume=p})(P=e.Iterable||(e.Iterable={}))}),define(ie[43],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var n;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(n=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(t,c=!1){let i=0;const o=t.length;let r="",l=0,a=16,m=0;function E(le){let te=0,F=0;for(;te<le;){const $=t.charCodeAt(i);if($>=48&&$<=57)F=F*16+$-48;else if($>=65&&$<=70)F=F*16+$-65+10;else if($>=97&&$<=102)F=F*16+$-97+10;else break;i++,te++}return te<le&&(F=-1),F}function M(le){i=le,r="",l=0,a=16,m=0}function T(){const le=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&d(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&d(t.charCodeAt(i)))for(i++;i<t.length&&d(t.charCodeAt(i));)i++;else return m=3,t.substring(le,i);let te=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&d(t.charCodeAt(i))){for(i++;i<t.length&&d(t.charCodeAt(i));)i++;te=i}else m=3;return t.substring(le,te)}function N(){let le="",te=i;for(;;){if(i>=o){le+=t.substring(te,i),m=2;break}const F=t.charCodeAt(i);if(F===34){le+=t.substring(te,i),i++;break}if(F===92){if(le+=t.substring(te,i),i++,i>=o){m=2;break}switch(t.charCodeAt(i++)){case 34:le+='"';break;case 92:le+="\\";break;case 47:le+="/";break;case 98:le+="\b";break;case 102:le+="\f";break;case 110:le+=`
`;break;case 114:le+="\r";break;case 116:le+="	";break;case 117:{const V=E(4);V>=0?le+=String.fromCharCode(V):m=4;break}default:m=5}te=i;continue}if(F>=0&&F<=31)if(g(F)){le+=t.substring(te,i),m=2;break}else m=6;i++}return le}function z(){if(r="",m=0,l=i,i>=o)return l=o,a=17;let le=t.charCodeAt(i);if(k(le)){do i++,r+=String.fromCharCode(le),le=t.charCodeAt(i);while(k(le));return a=15}if(g(le))return i++,r+=String.fromCharCode(le),le===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),a=14;switch(le){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,r=N(),a=10;case 47:{const te=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<o&&!g(t.charCodeAt(i));)i++;return r=t.substring(te,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const F=o-1;let $=!1;for(;i<F;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,$=!0;break}i++}return $||(i++,m=1),r=t.substring(te,i),a=13}return r+=String.fromCharCode(le),i++,a=16}case 45:if(r+=String.fromCharCode(le),i++,i===o||!d(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=T(),a=11;default:for(;i<o&&K(le);)i++,le=t.charCodeAt(i);if(l!==i){switch(r=t.substring(l,i),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(le),i++,a=16}}function K(le){if(k(le)||g(le))return!1;switch(le){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ae(){let le;do le=z();while(le>=12&&le<=15);return le}return{setPosition:M,getPosition:()=>i,scan:c?ae:z,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>l,getTokenLength:()=>i-l,getTokenError:()=>m}}e.createScanner=D;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var y;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(y||(y={}));function b(t,c){const i=[],o=new Object;let r;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function m(E,M,T,N){l.value=E,l.offset=M,l.length=T,l.type=N,l.colonOffset=void 0,r=l}try{p(t,{onObjectBegin:(E,M)=>{if(c<=E)throw o;r=void 0,a=c>E,i.push("")},onObjectProperty:(E,M,T)=>{if(c<M||(m(E,M,T,"property"),i[i.length-1]=E,c<=M+T))throw o},onObjectEnd:(E,M)=>{if(c<=E)throw o;r=void 0,i.pop()},onArrayBegin:(E,M)=>{if(c<=E)throw o;r=void 0,i.push(0)},onArrayEnd:(E,M)=>{if(c<=E)throw o;r=void 0,i.pop()},onLiteralValue:(E,M,T)=>{if(c<M||(m(E,M,T,C(E)),c<=M+T))throw o},onSeparator:(E,M,T)=>{if(c<=M)throw o;if(E===":"&&r&&r.type==="property")r.colonOffset=M,a=!1,r=void 0;else if(E===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(a=!0,i[i.length-1]=""),r=void 0}}})}catch(E){if(E!==o)throw E}return{path:i,previousNode:r,isAtPropertyKey:a,matches:E=>{let M=0;for(let T=0;M<E.length&&T<i.length;T++)if(E[M]===i[T]||E[M]==="*")M++;else if(E[M]!=="**")return!1;return M===E.length}}}e.getLocation=b;function I(t,c=[],i=R.DEFAULT){let o=null,r=[];const l=[];function a(E){Array.isArray(r)?r.push(E):o!==null&&(r[o]=E)}return p(t,{onObjectBegin:()=>{const E={};a(E),l.push(r),r=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const E=[];a(E),l.push(r),r=E,o=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:a,onError:(E,M,T)=>{c.push({error:E,offset:M,length:T})}},i),r[0]}e.parse=I;function u(t,c=[],i=R.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(E){o.type==="property"&&(o.length=E-o.offset,o=o.parent)}function l(E){return o.children.push(E),E}p(t,{onObjectBegin:E=>{o=l({type:"object",offset:E,length:-1,parent:o,children:[]})},onObjectProperty:(E,M,T)=>{o=l({type:"property",offset:M,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:E,offset:M,length:T,parent:o})},onObjectEnd:(E,M)=>{o.length=E+M-o.offset,o=o.parent,r(E+M)},onArrayBegin:(E,M)=>{o=l({type:"array",offset:E,length:-1,parent:o,children:[]})},onArrayEnd:(E,M)=>{o.length=E+M-o.offset,o=o.parent,r(E+M)},onLiteralValue:(E,M,T)=>{l({type:C(E),offset:M,length:T,parent:o,value:E}),r(M+T)},onSeparator:(E,M,T)=>{o.type==="property"&&(E===":"?o.colonOffset=M:E===","&&r(M))},onError:(E,M,T)=>{c.push({error:E,offset:M,length:T})}},i);const m=o.children[0];return m&&delete m.parent,m}e.parseTree=u;function w(t,c){if(!t)return;let i=t;for(const o of c)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const l of i.children)if(Array.isArray(l.children)&&l.children[0].value===o){i=l.children[1],r=!0;break}if(!r)return}else{const r=o;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=w;function S(t){if(!t.parent||!t.parent.children)return[];const c=S(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;c.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&c.push(i)}return c}e.getNodePath=S;function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const c=Object.create(null);for(const i of t.children){const o=i.children[1];o&&(c[i.children[0].value]=s(o))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=s;function h(t,c,i=!1){return c>=t.offset&&c<t.offset+t.length||i&&c===t.offset+t.length}e.contains=h;function f(t,c,i=!1){if(h(t,c,i)){const o=t.children;if(Array.isArray(o))for(let r=0;r<o.length&&o[r].offset<=c;r++){const l=f(o[r],c,i);if(l)return l}return t}}e.findNodeAtOffset=f;function p(t,c,i=R.DEFAULT){const o=D(t,!1);function r(re){return re?()=>re(o.getTokenOffset(),o.getTokenLength()):()=>!0}function l(re){return re?oe=>re(oe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const a=r(c.onObjectBegin),m=l(c.onObjectProperty),E=r(c.onObjectEnd),M=r(c.onArrayBegin),T=r(c.onArrayEnd),N=l(c.onLiteralValue),z=l(c.onSeparator),K=r(c.onComment),ae=l(c.onError),le=i&&i.disallowComments,te=i&&i.allowTrailingComma;function F(){for(;;){const re=o.scan();switch(o.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:le||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(re){case 12:case 13:le?$(10):K();break;case 16:$(1);break;case 15:case 14:break;default:return re}}}function $(re,oe=[],L=[]){if(ae(re),oe.length+L.length>0){let W=o.getToken();for(;W!==17;){if(oe.indexOf(W)!==-1){F();break}else if(L.indexOf(W)!==-1)break;W=F()}}}function V(re){const oe=o.getTokenValue();return re?N(oe):m(oe),F(),!0}function x(){switch(o.getToken()){case 11:{let re=0;try{re=JSON.parse(o.getTokenValue()),typeof re!="number"&&($(2),re=0)}catch{$(2)}N(re);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return F(),!0}function H(){return o.getToken()!==10?($(3,[],[2,5]),!1):(V(!1),o.getToken()===6?(z(":"),F(),_()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function O(){a(),F();let re=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(re||$(4,[],[]),z(","),F(),o.getToken()===2&&te)break}else re&&$(6,[],[]);H()||$(4,[],[2,5]),re=!0}return E(),o.getToken()!==2?$(7,[2],[]):F(),!0}function G(){M(),F();let re=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(re||$(4,[],[]),z(","),F(),o.getToken()===4&&te)break}else re&&$(6,[],[]);_()||$(4,[],[4,5]),re=!0}return T(),o.getToken()!==4?$(8,[4],[]):F(),!0}function _(){switch(o.getToken()){case 3:return G();case 1:return O();case 10:return V(!0);default:return x()}}return F(),o.getToken()===17?i.allowEmptyContent?!0:($(4,[],[]),!1):_()?(o.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=p;function v(t,c){const i=D(t),o=[];let r,l=0,a;do switch(a=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:l!==a&&o.push(t.substring(l,a)),c!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,c)),l=i.getPosition();break}while(r!==17);return o.join("")}e.stripComments=v;function C(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(ie[128],se([0,1,43]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function A(d,y,b){let I,u,w,S,s;if(y){for(S=y.offset,s=S+y.length,w=S;w>0&&!g(d,w-1);)w--;let a=s;for(;a<d.length&&!g(d,a);)a++;u=d.substring(w,a),I=D(u,b)}else u=d,I=0,w=0,S=0,s=d.length;const h=k(b,d);let f=!1,p=0,v;b.insertSpaces?v=R(" ",b.tabSize||4):v="	";const C=(0,P.createScanner)(u,!1);let t=!1;function c(){return h+R(v,I+p)}function i(){let a=C.scan();for(f=!1;a===15||a===14;)f=f||a===14,a=C.scan();return t=a===16||C.getTokenError()!==0,a}const o=[];function r(a,m,E){!t&&m<s&&E>S&&d.substring(m,E)!==a&&o.push({offset:m,length:E-m,content:a})}let l=i();if(l!==17){const a=C.getTokenOffset()+w,m=R(v,I);r(m,w,a)}for(;l!==17;){let a=C.getTokenOffset()+C.getTokenLength()+w,m=i(),E="";for(;!f&&(m===12||m===13);){const T=C.getTokenOffset()+w;r(" ",a,T),a=C.getTokenOffset()+C.getTokenLength()+w,E=m===12?c():"",m=i()}if(m===2)l!==1&&(p--,E=c());else if(m===4)l!==3&&(p--,E=c());else{switch(l){case 3:case 1:p++,E=c();break;case 5:case 12:E=c();break;case 13:f?E=c():E=" ";break;case 6:E=" ";break;case 10:if(m===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?E=" ":m!==5&&m!==17&&(t=!0);break;case 16:t=!0;break}f&&(m===12||m===13)&&(E=c())}const M=C.getTokenOffset()+w;r(E,a,M),l=m}return o}e.format=A;function n(d,y){const b=JSON.stringify(d,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?b.replace(/\r\n|\r|\n/g,y.eol):b}e.toFormattedString=n;function R(d,y){let b="";for(let I=0;I<y;I++)b+=d;return b}function D(d,y){let b=0,I=0;const u=y.tabSize||4;for(;b<d.length;){const w=d.charAt(b);if(w===" ")I++;else if(w==="	")I+=u;else break;b++}return Math.floor(I/u)}function k(d,y){for(let b=0;b<y.length;b++){const I=y.charAt(b);if(I==="\r")return b+1<y.length&&y.charAt(b+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return d&&d.eol||`
`}e.getEOL=k;function g(d,y){return`\r
`.indexOf(d.charAt(y))!==-1}e.isEOL=g}),define(ie[129],se([0,1,43,128]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function n(d,y,b){return R(d,y,void 0,b)}e.removeProperty=n;function R(d,y,b,I,u){const w=y.slice(),S=[],s=(0,P.parseTree)(d,S);let h,f;for(;w.length>0&&(f=w.pop(),h=(0,P.findNodeAtLocation)(s,w),h===void 0&&b!==void 0);)typeof f=="string"?b={[f]:b}:b=[b];if(h)if(h.type==="object"&&typeof f=="string"&&Array.isArray(h.children)){const p=(0,P.findNodeAtLocation)(h,[f]);if(p!==void 0)if(b===void 0){if(!p.parent)throw new Error("Malformed AST");const v=h.children.indexOf(p.parent);let C,t=p.parent.offset+p.parent.length;if(v>0){const c=h.children[v-1];C=c.offset+c.length}else C=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return D(d,{offset:C,length:t-C,content:""},I)}else return D(d,{offset:p.offset,length:p.length,content:JSON.stringify(b)},I);else{if(b===void 0)return[];const v=`${JSON.stringify(f)}: ${JSON.stringify(b)}`,C=u?u(h.children.map(c=>c.children[0].value)):h.children.length;let t;if(C>0){const c=h.children[C-1];t={offset:c.offset+c.length,length:0,content:","+v}}else h.children.length===0?t={offset:h.offset+1,length:0,content:v}:t={offset:h.offset+1,length:0,content:v+","};return D(d,t,I)}}else if(h.type==="array"&&typeof f=="number"&&Array.isArray(h.children))if(b!==void 0){const p=`${JSON.stringify(b)}`;let v;if(h.children.length===0||f===0)v={offset:h.offset+1,length:0,content:h.children.length===0?p:p+","};else{const C=f===-1||f>h.children.length?h.children.length:f,t=h.children[C-1];v={offset:t.offset+t.length,length:0,content:","+p}}return D(d,v,I)}else{const p=f,v=h.children[p];let C;if(h.children.length===1)C={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===p){const t=h.children[p-1],c=t.offset+t.length,i=h.offset+h.length;C={offset:c,length:i-2-c,content:""}}else C={offset:v.offset,length:h.children[p+1].offset-v.offset,content:""};return D(d,C,I)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${h.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return D(d,{offset:s?s.offset:0,length:s?s.length:0,content:JSON.stringify(b)},I)}}e.setProperty=R;function D(d,y,b){let I=k(d,y),u=y.offset,w=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;u>0&&!(0,A.isEOL)(I,u-1);)u--;for(;w<I.length&&!(0,A.isEOL)(I,w);)w++}const S=(0,A.format)(I,{offset:u,length:w-u},b);for(let h=S.length-1;h>=0;h--){const f=S[h];I=k(I,f),u=Math.min(u,f.offset),w=Math.max(w,f.offset+f.length),w+=f.content.length-f.length}const s=d.length-(I.length-w)-u;return[{offset:u,length:s,content:I.substring(u,w)}]}e.withFormatting=D;function k(d,y){return d.substring(0,y.offset)+y.content+d.substring(y.offset+y.length)}e.applyEdit=k;function g(d,y){const b=y.slice(0).sort((u,w)=>{const S=u.offset-w.offset;return S===0?u.length-w.length:S});let I=d.length;for(let u=b.length-1;u>=0;u--){const w=b[u];if(w.offset+w.length<=I)d=k(d,w);else throw new Error("Overlapping edit");I=w.offset}return d}e.applyEdits=g}),define(ie[130],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class P{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=P}),define(ie[2],se([0,1,50,70]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const n=!1;let R=null;function D(l){R=l}if(e.setDisposableTracker=D,n){const l="__is_disposable_tracked__";D(new class{trackDisposable(a){const m=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[l]||console.log(m)},3e3)}setParent(a,m){if(a&&a!==f.None)try{a[l]=!0}catch{}}markAsDisposed(a){if(a&&a!==f.None)try{a[l]=!0}catch{}}markAsSingleton(a){}})}function k(l){return R?.trackDisposable(l),l}function g(l){R?.markAsDisposed(l)}function d(l,a){R?.setParent(l,a)}function y(l,a){if(!!R)for(const m of l)R.setParent(m,a)}function b(l){return R?.markAsSingleton(l),l}e.markAsSingleton=b;function I(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=I;function u(l){if(A.Iterable.is(l)){const a=[];for(const m of l)if(m)try{m.dispose()}catch(E){a.push(E)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=u;function w(l){for(const a of l)I(a)&&a.dispose();return[]}e.disposeIfDisposable=w;function S(...l){const a=s(()=>u(l));return y(l,a),a}e.combinedDisposable=S;function s(l){const a=k({dispose:(0,P.once)(()=>{g(a),l()})});return a}e.toDisposable=s;class h{constructor(){this.c=new Set,this.f=!1,k(this)}dispose(){this.f||(g(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{u(this.c)}finally{this.c.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return d(a,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(a),a}}h.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=h;class f{constructor(){this.q=new h,k(this),d(this.q,this)}dispose(){g(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}f.None=Object.freeze({dispose(){}}),e.Disposable=f;class p{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&d(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&d(a,null),a}}e.MutableDisposable=p;class v{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=v;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(a){let m=a;return this.unset=()=>m=void 0,this.isset=()=>m!==void 0,this.dispose=()=>{m&&(m(),m=void 0,g(this))},this}}e.SafeDisposable=C;class t{constructor(){this.a=new Map}acquire(a,...m){let E=this.a.get(a);E||(E={counter:0,object:this.b(a,...m)},this.a.set(a,E));const{object:M}=E,T=(0,P.once)(()=>{--E.counter===0&&(this.c(a,E.object),this.a.delete(a))});return E.counter++,{object:M,dispose:T}}}e.ReferenceCollection=t;class c{constructor(a){this.a=a}async acquire(a,...m){const E=this.a.acquire(a,...m);try{return{object:await E.object,dispose:()=>E.dispose()}}catch(M){throw E.dispose(),M}}}e.AsyncReferenceCollection=c;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function o(l){const a=new h;try{l(a)}finally{a.dispose()}}e.disposeOnReturn=o;class r{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get(a){return this.a.get(a)}set(a,m,E=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),E||this.a.get(a)?.dispose(),this.a.set(a,m)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(ie[99],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class P{constructor(R){this.element=R,this.next=P.Undefined,this.prev=P.Undefined}}P.Undefined=new P(void 0);class A{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let R=this.a;for(;R!==P.Undefined;){const D=R.next;R.prev=P.Undefined,R.next=P.Undefined,R=D}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,D){const k=new P(R);if(this.a===P.Undefined)this.a=k,this.b=k;else if(D){const d=this.b;this.b=k,k.prev=d,d.next=k}else{const d=this.a;this.a=k,k.next=d,d.prev=k}this.c+=1;let g=!1;return()=>{g||(g=!0,this.e(k))}}shift(){if(this.a!==P.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==P.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==P.Undefined&&R.next!==P.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===P.Undefined&&R.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):R.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):R.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==P.Undefined;)yield R.element,R=R.next}}e.LinkedList=A}),define(ie[35],se([0,1]),function(X,e){"use strict";var P,A,n;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(S,s,h){let f=S.get(s);return f===void 0&&(f=h,S.set(s,f)),f}e.getOrSet=R;function D(S){const s=[];return S.forEach((h,f)=>{s.push(`${f} => ${h}`)}),`Map(${S.size}) {${s.join(", ")}}`}e.mapToString=D;function k(S){const s=[];return S.forEach(h=>{s.push(h)}),`Set(${S.size}) {${s.join(", ")}}`}e.setToString=k;class g{constructor(s,h){this.uri=s,this.value=h}}class d{constructor(s,h){this[P]="ResourceMap",s instanceof d?(this.b=new Map(s.b),this.c=h??d.a):(this.b=new Map,this.c=s??d.a)}set(s,h){return this.b.set(this.c(s),new g(s,h)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,h){typeof h<"u"&&(s=s.bind(h));for(const[f,p]of this.b)s(p.value,p.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}d.a=S=>S.toString(),e.ResourceMap=d;class y{constructor(s,h){this[A]="ResourceSet",!s||typeof s=="function"?this.a=new d(s):(this.a=new d(h),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,h){this.a.forEach((f,p)=>s.call(h,p,p,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=y;var b;(function(S){S[S.None=0]="None",S[S.AsOld=1]="AsOld",S[S.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class I{constructor(){this[n]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,h=0){const f=this.a.get(s);if(!!f)return h!==0&&this.j(f,h),f.value}set(s,h,f=0){let p=this.a.get(s);if(p)p.value=h,f!==0&&this.j(p,f);else{switch(p={key:s,value:h,next:void 0,previous:void 0},f){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(s,p),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const h=this.a.get(s);if(!!h)return this.a.delete(s),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,h){const f=this.e;let p=this.b;for(;p;){if(h?s.bind(h)(p.value,p.key,this):s(p.value,p.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const s=this,h=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(s.e!==h)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:f.key,done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return p}values(){const s=this,h=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(s.e!==h)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:f.value,done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return p}entries(){const s=this,h=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(s.e!==h)throw new Error("LinkedMap got modified during iteration.");if(f){const v={value:[f.key,f.value],done:!1};return f=f.next,v}else return{value:void 0,done:!0}}};return p}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let h=this.b,f=this.size;for(;h&&f>s;)this.a.delete(h.key),h=h.next,f--;this.b=h,this.d=f,h&&(h.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const h=s.next,f=s.previous;if(!h||!f)throw new Error("Invalid list");h.previous=f,f.next=h}s.next=void 0,s.previous=void 0,this.e++}j(s,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(s===this.b)return;const f=s.next,p=s.previous;s===this.c?(p.next=void 0,this.c=p):(f.previous=p,p.next=f),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(h===2){if(s===this.c)return;const f=s.next,p=s.previous;s===this.b?(f.previous=void 0,this.b=f):(f.previous=p,p.next=f),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((h,f)=>{s.push([f,h])}),s}fromJSON(s){this.clear();for(const[h,f]of s)this.set(h,f)}}e.LinkedMap=I;class u extends I{constructor(s,h=1){super(),this.k=s,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,h=2){return super.get(s,h)}peek(s){return super.get(s,0)}set(s,h){return super.set(s,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=u;class w{constructor(){this.a=new Map}add(s){return this.a.set(s,(this.a.get(s)||0)+1),this}delete(s){let h=this.a.get(s)||0;return h===0?!1:(h--,h===0?this.a.delete(s):this.a.set(s,h),!0)}has(s){return this.a.has(s)}}e.CounterSet=w}),define(ie[80],se([0,1,35]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new P.LRUCache(1e4);function n(d){return g(d,"NFC",A)}e.normalizeNFC=n;const R=new P.LRUCache(1e4);function D(d){return g(d,"NFD",R)}e.normalizeNFD=D;const k=/[^\u0000-\u0080]/;function g(d,y,b){if(!d)return d;const I=b.get(d);if(I)return I;let u;return k.test(d)?u=d.normalize(y):u=d,b.set(d,u),u}e.removeAccents=function(){const d=/[\u0300-\u036f]/g;return function(y){return D(y).replace(d,"")}}()}),define(ie[131],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function P(k,g,d){return Math.min(Math.max(k,g),d)}e.clamp=P;function A(k,g){return(g+k%g)%g}e.rot=A;class n{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=n;class R{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class D{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const d=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function X(n){const R=[];typeof n=="number"&&R.push("code/timeOrigin",n);function D(g){R.push(g,Date.now())}function k(){const g=[];for(let d=0;d<R.length;d+=2)g.push({name:R[d],startTime:R[d+1]});return g}return{mark:D,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(n){performance.mark(n)},getMarks(){let n=performance.timeOrigin;typeof n!="number"&&(n=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(n)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(n+D.startTime)});return R}};if(typeof process=="object"){const n=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(n)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function P(n){return n.MonacoPerformanceMarks||(n.MonacoPerformanceMarks=e()),n.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=P(A))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var A in P)(typeof exports=="object"?exports:X)[A]=P[A]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function P(A){if(e[A])return e[A].exports;var n=e[A]={i:A,l:!1,exports:{}};return X[A].call(n.exports,n,n.exports,P),n.l=!0,n.exports}return P.m=X,P.c=e,P.d=function(A,n,R){P.o(A,n)||Object.defineProperty(A,n,{enumerable:!0,get:R})},P.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},P.t=function(A,n){if(1&n&&(A=P(A)),8&n||4&n&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(P.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&n&&typeof A!="string")for(var D in A)P.d(R,D,function(k){return A[k]}.bind(null,D));return R},P.n=function(A){var n=A&&A.__esModule?function(){return A.default}:function(){return A};return P.d(n,"a",n),n},P.o=function(A,n){return Object.prototype.hasOwnProperty.call(A,n)},P.p="",P(P.s=0)}([function(X,e,P){(function(A){var n;e=X.exports=L,n=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ne=Array.prototype.slice.call(arguments,0);ne.unshift("SEMVER"),console.log.apply(console,ne)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],g=e.src=[],d=0,y=d++;g[y]="0|[1-9]\\d*";var b=d++;g[b]="[0-9]+";var I=d++;g[I]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=d++;g[u]="("+g[y]+")\\.("+g[y]+")\\.("+g[y]+")";var w=d++;g[w]="("+g[b]+")\\.("+g[b]+")\\.("+g[b]+")";var S=d++;g[S]="(?:"+g[y]+"|"+g[I]+")";var s=d++;g[s]="(?:"+g[b]+"|"+g[I]+")";var h=d++;g[h]="(?:-("+g[S]+"(?:\\."+g[S]+")*))";var f=d++;g[f]="(?:-?("+g[s]+"(?:\\."+g[s]+")*))";var p=d++;g[p]="[0-9A-Za-z-]+";var v=d++;g[v]="(?:\\+("+g[p]+"(?:\\."+g[p]+")*))";var C=d++,t="v?"+g[u]+g[h]+"?"+g[v]+"?";g[C]="^"+t+"$";var c="[v=\\s]*"+g[w]+g[f]+"?"+g[v]+"?",i=d++;g[i]="^"+c+"$";var o=d++;g[o]="((?:<|>)?=?)";var r=d++;g[r]=g[b]+"|x|X|\\*";var l=d++;g[l]=g[y]+"|x|X|\\*";var a=d++;g[a]="[v=\\s]*("+g[l]+")(?:\\.("+g[l]+")(?:\\.("+g[l]+")(?:"+g[h]+")?"+g[v]+"?)?)?";var m=d++;g[m]="[v=\\s]*("+g[r]+")(?:\\.("+g[r]+")(?:\\.("+g[r]+")(?:"+g[f]+")?"+g[v]+"?)?)?";var E=d++;g[E]="^"+g[o]+"\\s*"+g[a]+"$";var M=d++;g[M]="^"+g[o]+"\\s*"+g[m]+"$";var T=d++;g[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=d++;g[N]="(?:~>?)";var z=d++;g[z]="(\\s*)"+g[N]+"\\s+",k[z]=new RegExp(g[z],"g");var K=d++;g[K]="^"+g[N]+g[a]+"$";var ae=d++;g[ae]="^"+g[N]+g[m]+"$";var le=d++;g[le]="(?:\\^)";var te=d++;g[te]="(\\s*)"+g[le]+"\\s+",k[te]=new RegExp(g[te],"g");var F=d++;g[F]="^"+g[le]+g[a]+"$";var $=d++;g[$]="^"+g[le]+g[m]+"$";var V=d++;g[V]="^"+g[o]+"\\s*("+c+")$|^$";var x=d++;g[x]="^"+g[o]+"\\s*("+t+")$|^$";var H=d++;g[H]="(\\s*)"+g[o]+"\\s*("+c+"|"+g[a]+")",k[H]=new RegExp(g[H],"g");var O=d++;g[O]="^\\s*("+g[a]+")\\s+-\\s+("+g[a]+")\\s*$";var G=d++;g[G]="^\\s*("+g[m]+")\\s+-\\s+("+g[m]+")\\s*$";var _=d++;g[_]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)n(re,g[re]),k[re]||(k[re]=new RegExp(g[re]));function oe(ne,he){if(ne instanceof L)return ne;if(typeof ne!="string"||ne.length>R||!(he?k[i]:k[C]).test(ne))return null;try{return new L(ne,he)}catch{return null}}function L(ne,he){if(ne instanceof L){if(ne.loose===he)return ne;ne=ne.version}else if(typeof ne!="string")throw new TypeError("Invalid Version: "+ne);if(ne.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(ne,he);n("SemVer",ne,he),this.loose=he;var de=ne.trim().match(he?k[i]:k[C]);if(!de)throw new TypeError("Invalid Version: "+ne);if(this.raw=ne,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Me=+Ie;if(Me>=0&&Me<D)return Me}return Ie}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=oe,e.valid=function(ne,he){var de=oe(ne,he);return de?de.version:null},e.clean=function(ne,he){var de=oe(ne.trim().replace(/^[=v]+/,""),he);return de?de.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(ne){return n("SemVer.compare",this.version,this.loose,ne),ne instanceof L||(ne=new L(ne,this.loose)),this.compareMain(ne)||this.comparePre(ne)},L.prototype.compareMain=function(ne){return ne instanceof L||(ne=new L(ne,this.loose)),U(this.major,ne.major)||U(this.minor,ne.minor)||U(this.patch,ne.patch)},L.prototype.comparePre=function(ne){if(ne instanceof L||(ne=new L(ne,this.loose)),this.prerelease.length&&!ne.prerelease.length)return-1;if(!this.prerelease.length&&ne.prerelease.length)return 1;if(!this.prerelease.length&&!ne.prerelease.length)return 0;var he=0;do{var de=this.prerelease[he],Ie=ne.prerelease[he];if(n("prerelease compare",he,de,Ie),de===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(de===void 0)return-1;if(de!==Ie)return U(de,Ie)}while(++he)},L.prototype.inc=function(ne,he){switch(ne){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+ne)}return this.format(),this.raw=this.version,this},e.inc=function(ne,he,de,Ie){typeof de=="string"&&(Ie=de,de=void 0);try{return new L(ne,de).inc(he,Ie).version}catch{return null}},e.diff=function(ne,he){if(B(ne,he))return null;var de=oe(ne),Ie=oe(he);if(de.prerelease.length||Ie.prerelease.length){for(var Me in de)if((Me==="major"||Me==="minor"||Me==="patch")&&de[Me]!==Ie[Me])return"pre"+Me;return"prerelease"}for(var Me in de)if((Me==="major"||Me==="minor"||Me==="patch")&&de[Me]!==Ie[Me])return Me},e.compareIdentifiers=U;var W=/^[0-9]+$/;function U(ne,he){var de=W.test(ne),Ie=W.test(he);return de&&Ie&&(ne=+ne,he=+he),de&&!Ie?-1:Ie&&!de?1:ne<he?-1:ne>he?1:0}function j(ne,he,de){return new L(ne,de).compare(new L(he,de))}function q(ne,he,de){return j(ne,he,de)>0}function J(ne,he,de){return j(ne,he,de)<0}function B(ne,he,de){return j(ne,he,de)===0}function Y(ne,he,de){return j(ne,he,de)!==0}function Z(ne,he,de){return j(ne,he,de)>=0}function ce(ne,he,de){return j(ne,he,de)<=0}function fe(ne,he,de,Ie){var Me;switch(he){case"===":typeof ne=="object"&&(ne=ne.version),typeof de=="object"&&(de=de.version),Me=ne===de;break;case"!==":typeof ne=="object"&&(ne=ne.version),typeof de=="object"&&(de=de.version),Me=ne!==de;break;case"":case"=":case"==":Me=B(ne,de,Ie);break;case"!=":Me=Y(ne,de,Ie);break;case">":Me=q(ne,de,Ie);break;case">=":Me=Z(ne,de,Ie);break;case"<":Me=J(ne,de,Ie);break;case"<=":Me=ce(ne,de,Ie);break;default:throw new TypeError("Invalid operator: "+he)}return Me}function De(ne,he){if(ne instanceof De){if(ne.loose===he)return ne;ne=ne.value}if(!(this instanceof De))return new De(ne,he);n("comparator",ne,he),this.loose=he,this.parse(ne),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,n("comp",this)}e.rcompareIdentifiers=function(ne,he){return U(he,ne)},e.major=function(ne,he){return new L(ne,he).major},e.minor=function(ne,he){return new L(ne,he).minor},e.patch=function(ne,he){return new L(ne,he).patch},e.compare=j,e.compareLoose=function(ne,he){return j(ne,he,!0)},e.rcompare=function(ne,he,de){return j(he,ne,de)},e.sort=function(ne,he){return ne.sort(function(de,Ie){return e.compare(de,Ie,he)})},e.rsort=function(ne,he){return ne.sort(function(de,Ie){return e.rcompare(de,Ie,he)})},e.gt=q,e.lt=J,e.eq=B,e.neq=Y,e.gte=Z,e.lte=ce,e.cmp=fe,e.Comparator=De;var Re={};function Ce(ne,he){if(ne instanceof Ce)return ne.loose===he?ne:new Ce(ne.raw,he);if(ne instanceof De)return new Ce(ne.value,he);if(!(this instanceof Ce))return new Ce(ne,he);if(this.loose=he,this.raw=ne,this.set=ne.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ne);this.format()}function Oe(ne){return!ne||ne.toLowerCase()==="x"||ne==="*"}function $e(ne,he,de,Ie,Me,Te,Fe,je,ze,We,He,Q,ue){return((he=Oe(de)?"":Oe(Ie)?">="+de+".0.0":Oe(Me)?">="+de+"."+Ie+".0":">="+he)+" "+(je=Oe(ze)?"":Oe(We)?"<"+(+ze+1)+".0.0":Oe(He)?"<"+ze+"."+(+We+1)+".0":Q?"<="+ze+"."+We+"."+He+"-"+Q:"<="+je)).trim()}function ge(ne,he){for(var de=0;de<ne.length;de++)if(!ne[de].test(he))return!1;if(he.prerelease.length){for(de=0;de<ne.length;de++)if(n(ne[de].semver),ne[de].semver!==Re&&ne[de].semver.prerelease.length>0){var Ie=ne[de].semver;if(Ie.major===he.major&&Ie.minor===he.minor&&Ie.patch===he.patch)return!0}return!1}return!0}function pe(ne,he,de){try{he=new Ce(he,de)}catch{return!1}return he.test(ne)}function Le(ne,he,de,Ie){var Me,Te,Fe,je,ze;switch(ne=new L(ne,Ie),he=new Ce(he,Ie),de){case">":Me=q,Te=ce,Fe=J,je=">",ze=">=";break;case"<":Me=J,Te=Z,Fe=q,je="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(ne,he,Ie))return!1;for(var We=0;We<he.set.length;++We){var He=he.set[We],Q=null,ue=null;if(He.forEach(function(me){me.semver===Re&&(me=new De(">=0.0.0")),Q=Q||me,ue=ue||me,Me(me.semver,Q.semver,Ie)?Q=me:Fe(me.semver,ue.semver,Ie)&&(ue=me)}),Q.operator===je||Q.operator===ze||(!ue.operator||ue.operator===je)&&Te(ne,ue.semver)||ue.operator===ze&&Fe(ne,ue.semver))return!1}return!0}De.prototype.parse=function(ne){var he=this.loose?k[V]:k[x],de=ne.match(he);if(!de)throw new TypeError("Invalid comparator: "+ne);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new L(de[2],this.loose):this.semver=Re},De.prototype.toString=function(){return this.value},De.prototype.test=function(ne){return n("Comparator.test",ne,this.loose),this.semver===Re||(typeof ne=="string"&&(ne=new L(ne,this.loose)),fe(ne,this.operator,this.semver,this.loose))},De.prototype.intersects=function(ne,he){if(!(ne instanceof De))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Ce(ne.value,he),pe(this.value,de,he);if(ne.operator==="")return de=new Ce(this.value,he),pe(ne.semver,de,he);var Ie=!(this.operator!==">="&&this.operator!==">"||ne.operator!==">="&&ne.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||ne.operator!=="<="&&ne.operator!=="<"),Te=this.semver.version===ne.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||ne.operator!==">="&&ne.operator!=="<="),je=fe(this.semver,"<",ne.semver,he)&&(this.operator===">="||this.operator===">")&&(ne.operator==="<="||ne.operator==="<"),ze=fe(this.semver,">",ne.semver,he)&&(this.operator==="<="||this.operator==="<")&&(ne.operator===">="||ne.operator===">");return Ie||Me||Te&&Fe||je||ze},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(ne){return ne.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(ne){var he=this.loose;ne=ne.trim(),n("range",ne,he);var de=he?k[G]:k[O];ne=ne.replace(de,$e),n("hyphen replace",ne),ne=ne.replace(k[H],"$1$2$3"),n("comparator trim",ne,k[H]),ne=(ne=(ne=ne.replace(k[z],"$1~")).replace(k[te],"$1^")).split(/\s+/).join(" ");var Ie=he?k[V]:k[x],Me=ne.split(" ").map(function(Te){return function(Fe,je){return n("comp",Fe),Fe=function(ze,We){return ze.trim().split(/\s+/).map(function(He){return function(Q,ue){n("caret",Q,ue);var me=ue?k[$]:k[F];return Q.replace(me,function(be,we,Ae,Ue,Ve){var Ge;return n("caret",Q,be,we,Ae,Ue,Ve),Oe(we)?Ge="":Oe(Ae)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Oe(Ue)?Ge=we==="0"?">="+we+"."+Ae+".0 <"+we+"."+(+Ae+1)+".0":">="+we+"."+Ae+".0 <"+(+we+1)+".0.0":Ve?(n("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=we==="0"?Ae==="0"?">="+we+"."+Ae+"."+Ue+Ve+" <"+we+"."+Ae+"."+(+Ue+1):">="+we+"."+Ae+"."+Ue+Ve+" <"+we+"."+(+Ae+1)+".0":">="+we+"."+Ae+"."+Ue+Ve+" <"+(+we+1)+".0.0"):(n("no pr"),Ge=we==="0"?Ae==="0"?">="+we+"."+Ae+"."+Ue+" <"+we+"."+Ae+"."+(+Ue+1):">="+we+"."+Ae+"."+Ue+" <"+we+"."+(+Ae+1)+".0":">="+we+"."+Ae+"."+Ue+" <"+(+we+1)+".0.0"),n("caret return",Ge),Ge})}(He,We)}).join(" ")}(Fe,je),n("caret",Fe),Fe=function(ze,We){return ze.trim().split(/\s+/).map(function(He){return function(Q,ue){var me=ue?k[ae]:k[K];return Q.replace(me,function(be,we,Ae,Ue,Ve){var Ge;return n("tilde",Q,be,we,Ae,Ue,Ve),Oe(we)?Ge="":Oe(Ae)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Oe(Ue)?Ge=">="+we+"."+Ae+".0 <"+we+"."+(+Ae+1)+".0":Ve?(n("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=">="+we+"."+Ae+"."+Ue+Ve+" <"+we+"."+(+Ae+1)+".0"):Ge=">="+we+"."+Ae+"."+Ue+" <"+we+"."+(+Ae+1)+".0",n("tilde return",Ge),Ge})}(He,We)}).join(" ")}(Fe,je),n("tildes",Fe),Fe=function(ze,We){return n("replaceXRanges",ze,We),ze.split(/\s+/).map(function(He){return function(Q,ue){Q=Q.trim();var me=ue?k[M]:k[E];return Q.replace(me,function(be,we,Ae,Ue,Ve,Ge){n("xRange",Q,be,we,Ae,Ue,Ve,Ge);var Ke=Oe(Ae),Ye=Ke||Oe(Ue),Ze=Ye||Oe(Ve);return we==="="&&Ze&&(we=""),Ke?be=we===">"||we==="<"?"<0.0.0":"*":we&&Ze?(Ye&&(Ue=0),Ze&&(Ve=0),we===">"?(we=">=",Ye?(Ae=+Ae+1,Ue=0,Ve=0):Ze&&(Ue=+Ue+1,Ve=0)):we==="<="&&(we="<",Ye?Ae=+Ae+1:Ue=+Ue+1),be=we+Ae+"."+Ue+"."+Ve):Ye?be=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":Ze&&(be=">="+Ae+"."+Ue+".0 <"+Ae+"."+(+Ue+1)+".0"),n("xRange return",be),be})}(He,We)}).join(" ")}(Fe,je),n("xrange",Fe),Fe=function(ze,We){return n("replaceStars",ze,We),ze.trim().replace(k[_],"")}(Fe,je),n("stars",Fe),Fe}(Te,he)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(Te){return!!Te.match(Ie)})),Me=Me.map(function(Te){return new De(Te,he)})},Ce.prototype.intersects=function(ne,he){if(!(ne instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Ie){return ne.set.some(function(Me){return Me.every(function(Te){return Ie.intersects(Te,he)})})})})},e.toComparators=function(ne,he){return new Ce(ne,he).set.map(function(de){return de.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(ne){if(!ne)return!1;typeof ne=="string"&&(ne=new L(ne,this.loose));for(var he=0;he<this.set.length;he++)if(ge(this.set[he],ne))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(ne,he,de){var Ie=null,Me=null;try{var Te=new Ce(he,de)}catch{return null}return ne.forEach(function(Fe){Te.test(Fe)&&(Ie&&Me.compare(Fe)!==-1||(Me=new L(Ie=Fe,de)))}),Ie},e.minSatisfying=function(ne,he,de){var Ie=null,Me=null;try{var Te=new Ce(he,de)}catch{return null}return ne.forEach(function(Fe){Te.test(Fe)&&(Ie&&Me.compare(Fe)!==1||(Me=new L(Ie=Fe,de)))}),Ie},e.validRange=function(ne,he){try{return new Ce(ne,he).range||"*"}catch{return null}},e.ltr=function(ne,he,de){return Le(ne,he,"<",de)},e.gtr=function(ne,he,de){return Le(ne,he,">",de)},e.outside=Le,e.prerelease=function(ne,he){var de=oe(ne,he);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(ne,he,de){return ne=new Ce(ne,de),he=new Ce(he,de),ne.intersects(he)},e.coerce=function(ne){if(ne instanceof L)return ne;if(typeof ne!="string")return null;var he=ne.match(k[T]);return he==null?null:oe((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,P(1))},function(X,e){var P,A,n=X.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function k(s){if(P===setTimeout)return setTimeout(s,0);if((P===R||!P)&&setTimeout)return P=setTimeout,setTimeout(s,0);try{return P(s,0)}catch{try{return P.call(null,s,0)}catch{return P.call(this,s,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:R}catch{P=R}try{A=typeof clearTimeout=="function"?clearTimeout:D}catch{A=D}})();var g,d=[],y=!1,b=-1;function I(){y&&g&&(y=!1,g.length?d=g.concat(d):b=-1,d.length&&u())}function u(){if(!y){var s=k(I);y=!0;for(var h=d.length;h;){for(g=d,d=[];++b<h;)g&&g[b].run();b=-1,h=d.length}g=null,y=!1,function(f){if(A===clearTimeout)return clearTimeout(f);if((A===D||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(f);try{A(f)}catch{try{return A.call(null,f)}catch{return A.call(this,f)}}}(s)}}function w(s,h){this.fun=s,this.array=h}function S(){}n.nextTick=function(s){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];d.push(new w(s,h)),d.length!==1||y||k(u)},w.prototype.run=function(){this.fun.apply(null,this.array)},n.title="browser",n.browser=!0,n.env={},n.argv=[],n.version="",n.versions={},n.on=S,n.addListener=S,n.once=S,n.off=S,n.removeListener=S,n.removeAllListeners=S,n.emit=S,n.prependListener=S,n.prependOnceListener=S,n.listeners=function(s){return[]},n.binding=function(s){throw new Error("process.binding is not supported")},n.cwd=function(){return"/"},n.chdir=function(s){throw new Error("process.chdir is not supported")},n.umask=function(){return 0}}])}),define(ie[132],se([0,1]),function(X,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class A{constructor(k,g,d){this.level=k,this.key=g,this.value=d,this.forward=[]}}const n=void 0;class R{constructor(k,g=2**16){this.comparator=k,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new A(this.c,n,n)}get size(){return this.f}clear(){this.e=new A(this.c,n,n)}has(k){return Boolean(R.g(this,k,this.comparator))}get(k){return R.g(this,k,this.comparator)?.value}set(k,g){return R.h(this,k,g,this.comparator)&&(this.f+=1),this}delete(k){const g=R.k(this,k,this.comparator);return g&&(this.f-=1),g}forEach(k,g){let d=this.e.forward[0];for(;d;)k.call(g,d.value,d.key,this),d=d.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",g=this.e.forward[0];for(;g;)k+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return k}static g(k,g,d){let y=k.e;for(let b=k.d-1;b>=0;b--)for(;y.forward[b]&&d(y.forward[b].key,g)<0;)y=y.forward[b];if(y=y.forward[0],y&&d(y.key,g)===0)return y}static h(k,g,d,y){const b=[];let I=k.e;for(let u=k.d-1;u>=0;u--){for(;I.forward[u]&&y(I.forward[u].key,g)<0;)I=I.forward[u];b[u]=I}if(I=I.forward[0],I&&y(I.key,g)===0)return I.value=d,!1;{const u=R.j(k);if(u>k.d){for(let w=k.d;w<u;w++)b[w]=k.e;k.d=u}I=new A(u,g,d);for(let w=0;w<u;w++)I.forward[w]=b[w].forward[w],b[w].forward[w]=I;return!0}}static j(k,g=.5){let d=1;for(;Math.random()<g&&d<k.c;)d+=1;return d}static k(k,g,d){const y=[];let b=k.e;for(let I=k.d-1;I>=0;I--){for(;b.forward[I]&&d(b.forward[I].key,g)<0;)b=b.forward[I];y[I]=b}if(b=b.forward[0],!b||d(b.key,g)!==0)return!1;for(let I=0;I<k.d&&y[I].forward[I]===b;I++)y[I].forward[I]=b.forward[I];for(;k.d>0&&k.e.forward[k.d-1]===n;)k.d-=1;return!0}}e.SkipList=R}),define(ie[59],se([0,1,13,2]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function n(v){const C=v;return C?typeof C.read=="function":!1}e.isReadable=n;function R(v){const C=v;return C?[C.on,C.pause,C.resume,C.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function D(v){const C=v;return C?R(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.isReadableBufferedStream=D;function k(v,C){return new g(v,C)}e.newWriteableStream=k;class g{constructor(C,t){this.e=C,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(C){if(!this.a.destroyed){if(this.a.flowing)this.g(C);else if(this.b.data.push(C),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(C){this.a.destroyed||(this.a.flowing?this.h(C):this.b.error.push(C))}end(C){this.a.destroyed||(typeof C<"u"&&this.write(C),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(C){this.c.data.slice(0).forEach(t=>t(C))}h(C){this.c.error.length===0?(0,P.onUnexpectedError)(C):this.c.error.slice(0).forEach(t=>t(C))}i(){this.c.end.slice(0).forEach(C=>C())}on(C,t){if(!this.a.destroyed)switch(C){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(C,t){if(this.a.destroyed)return;let c;switch(C){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const i=c.indexOf(t);i>=0&&c.splice(i,1)}}j(){if(this.b.data.length>0){const C=this.e(this.b.data);this.g(C),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const C of this.b.error)this.h(C);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(v,C){const t=[];let c;for(;(c=v.read())!==null;)t.push(c);return C(t)}e.consumeReadable=d;function y(v,C,t){const c=[];let i;for(;(i=v.read())!==null&&c.length<t;)c.push(i);return i===null&&c.length>0?C(c):{read:()=>{if(c.length>0)return c.shift();if(typeof i<"u"){const o=i;return i=void 0,o}return v.read()}}}e.peekReadable=y;function b(v,C){return new Promise((t,c)=>{const i=[];I(v,{onData:o=>{C&&i.push(o)},onError:o=>{C?c(o):t(void 0)},onEnd:()=>{t(C?C(i):void 0)}})})}e.consumeStream=b;function I(v,C){let t=!1;return v.on("error",c=>{t||C.onError(c)}),v.on("end",()=>{t||C.onEnd()}),v.on("data",c=>{t||C.onData(c)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=I;function u(v,C){return new Promise((t,c)=>{const i=new A.DisposableStore,o=[],r=m=>{if(o.push(m),o.length>C)return i.dispose(),v.pause(),t({stream:v,buffer:o,ended:!1})},l=m=>c(m),a=()=>t({stream:v,buffer:o,ended:!0});i.add((0,A.toDisposable)(()=>v.removeListener("error",l))),v.on("error",l),i.add((0,A.toDisposable)(()=>v.removeListener("end",a))),v.on("end",a),i.add((0,A.toDisposable)(()=>v.removeListener("data",r))),v.on("data",r)})}e.peekStream=u;function w(v,C){const t=k(C);return t.end(v),t}e.toStream=w;function S(){const v=k(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=S;function s(v){let C=!1;return{read:()=>C?null:(C=!0,v)}}e.toReadable=s;function h(v,C,t){const c=k(t);return I(v,{onData:i=>c.write(C.data(i)),onError:i=>c.error(C.error?C.error(i):i),onEnd:()=>c.end()}),c}e.transform=h;function f(v,C,t){let c=!1;return{read:()=>{const i=C.read();return c?i:(c=!0,i!==null?t([v,i]):v)}}}e.prefixedReadable=f;function p(v,C,t){let c=!1;const i=k(t);return I(C,{onData:o=>c?i.write(o):(c=!0,i.write(t([v,o]))),onError:o=>i.error(o),onEnd:()=>{c||(c=!0,i.write(v)),i.end()}}),i}e.prefixedStream=p}),define(ie[17],se([0,1,59]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let n,R;class D{static alloc(m){return A?new D(Buffer.allocUnsafe(m)):new D(new Uint8Array(m))}static wrap(m){return A&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new D(m)}static fromString(m,E){return!(E?.dontUseNodeBuffer||!1)&&A?new D(Buffer.from(m)):(n||(n=new TextEncoder),new D(n.encode(m)))}static fromByteArray(m){const E=D.alloc(m.length);for(let M=0,T=m.length;M<T;M++)E.buffer[M]=m[M];return E}static concat(m,E){if(typeof E>"u"){E=0;for(let N=0,z=m.length;N<z;N++)E+=m[N].byteLength}const M=D.alloc(E);let T=0;for(let N=0,z=m.length;N<z;N++){const K=m[N];M.set(K,T),T+=K.byteLength}return M}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=D.alloc(this.byteLength);return m.set(this),m}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(m,E){return new D(this.buffer.subarray(m,E))}set(m,E){if(m instanceof D)this.buffer.set(m.buffer,E);else if(m instanceof Uint8Array)this.buffer.set(m,E);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),E);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return d(this.buffer,m)}writeUInt32BE(m,E){y(this.buffer,m,E)}readUInt32LE(m){return b(this.buffer,m)}writeUInt32LE(m,E){I(this.buffer,m,E)}readUInt8(m){return u(this.buffer,m)}writeUInt8(m,E){w(this.buffer,m,E)}}e.VSBuffer=D;function k(a,m){return a[m+0]<<0>>>0|a[m+1]<<8>>>0}e.readUInt16LE=k;function g(a,m,E){a[E+0]=m&255,m=m>>>8,a[E+1]=m&255}e.writeUInt16LE=g;function d(a,m){return a[m]*2**24+a[m+1]*2**16+a[m+2]*2**8+a[m+3]}e.readUInt32BE=d;function y(a,m,E){a[E+3]=m,m=m>>>8,a[E+2]=m,m=m>>>8,a[E+1]=m,m=m>>>8,a[E]=m}e.writeUInt32BE=y;function b(a,m){return a[m+0]<<0>>>0|a[m+1]<<8>>>0|a[m+2]<<16>>>0|a[m+3]<<24>>>0}e.readUInt32LE=b;function I(a,m,E){a[E+0]=m&255,m=m>>>8,a[E+1]=m&255,m=m>>>8,a[E+2]=m&255,m=m>>>8,a[E+3]=m&255}e.writeUInt32LE=I;function u(a,m){return a[m]}e.readUInt8=u;function w(a,m,E){a[E]=m}e.writeUInt8=w;function S(a){return P.consumeReadable(a,m=>D.concat(m))}e.readableToBuffer=S;function s(a){return P.toReadable(a)}e.bufferToReadable=s;function h(a){return P.consumeStream(a,m=>D.concat(m))}e.streamToBuffer=h;async function f(a){return a.ended?D.concat(a.buffer):D.concat([...a.buffer,await h(a.stream)])}e.bufferedStreamToBuffer=f;function p(a){return P.toStream(a,m=>D.concat(m))}e.bufferToStream=p;function v(a){return P.transform(a,{data:m=>typeof m=="string"?D.fromString(m):D.wrap(m)},m=>D.concat(m))}e.streamToBufferReadableStream=v;function C(a){return P.newWriteableStream(m=>D.concat(m),a)}e.newWriteableBufferStream=C;function t(a,m){return P.prefixedReadable(a,m,E=>D.concat(E))}e.prefixedBufferReadable=t;function c(a,m){return P.prefixedStream(a,m,E=>D.concat(E))}e.prefixedBufferStream=c;function i(a){let m=0,E=0,M=0;const T=new Uint8Array(Math.floor(a.length/4*3)),N=K=>{switch(E){case 3:T[M++]=m|K,E=0;break;case 2:T[M++]=m|K>>>2,m=K<<6,E=3;break;case 1:T[M++]=m|K>>>4,m=K<<4,E=2;break;default:m=K<<2,E=1}};for(let K=0;K<a.length;K++){const ae=a.charCodeAt(K);if(ae>=65&&ae<=90)N(ae-65);else if(ae>=97&&ae<=122)N(ae-97+26);else if(ae>=48&&ae<=57)N(ae-48+52);else if(ae===43||ae===45)N(62);else if(ae===47||ae===95)N(63);else{if(ae===61)break;throw new SyntaxError(`Unexpected base64 character ${a[K]}`)}}const z=M;for(;E>0;)N(0);return D.wrap(T).slice(0,z)}e.decodeBase64=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:a},m=!0,E=!1){const M=E?r:o;let T="";const N=a.byteLength%3;let z=0;for(;z<a.byteLength-N;z+=3){const K=a[z+0],ae=a[z+1],le=a[z+2];T+=M[K>>>2],T+=M[(K<<4|ae>>>4)&63],T+=M[(ae<<2|le>>>6)&63],T+=M[le&63]}if(N===1){const K=a[z+0];T+=M[K>>>2],T+=M[K<<4&63],m&&(T+="==")}else if(N===2){const K=a[z+0],ae=a[z+1];T+=M[K>>>2],T+=M[(K<<4|ae>>>4)&63],T+=M[ae<<2&63],m&&(T+="=")}return T}e.encodeBase64=l}),define(ie[133],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ie[10],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function P(c){return typeof c=="string"}e.isString=P;function A(c){return Array.isArray(c)&&c.every(i=>P(i))}e.isStringArray=A;function n(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=n;function R(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}e.isTypedArray=R;function D(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=D;function k(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=k;function g(c){return c===!0||c===!1}e.isBoolean=g;function d(c){return typeof c>"u"}e.isUndefined=d;function y(c){return!b(c)}e.isDefined=y;function b(c){return d(c)||c===null}e.isUndefinedOrNull=b;function I(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=I;function u(c){if(b(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=u;function w(...c){const i=[];for(let o=0;o<c.length;o++){const r=c[o];if(b(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(r)}return i}e.assertAllDefined=w;const S=Object.prototype.hasOwnProperty;function s(c){if(!n(c))return!1;for(const i in c)if(S.call(c,i))return!1;return!0}e.isEmptyObject=s;function h(c){return typeof c=="function"}e.isFunction=h;function f(...c){return c.length>0&&c.every(h)}e.areFunctions=f;function p(c,i){const o=Math.min(c.length,i.length);for(let r=0;r<o;r++)v(c[r],i[r])}e.validateConstraints=p;function v(c,i){if(P(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(h(i)){try{if(c instanceof i)return}catch{}if(!b(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=v;function C(c){return c===null?void 0:c}e.withNullAsUndefined=C;function t(c){return typeof c>"u"?null:c}e.withUndefinedAsNull=t}),define(ie[134],se([0,1,10]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function n(k,g){if((0,P.isString)(g)){const d=A[g];if(d===void 0)throw new Error(`${k} references an unknown codicon: ${g}`);g=d}return A[k]=g,{id:k}}function R(){return A}e.getCodiconFontCharacters=R;function D(){return Object.values(e.Codicon)}e.getAllCodicons=D,e.Codicon={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package_:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(ie[37],se([0,1,10]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([p,v])=>{f[p]=v&&typeof v=="object"?A(v):v}),f}e.deepClone=A;function n(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const p=f.shift();Object.freeze(p);for(const v in p)if(R.call(p,v)){const C=p[v];typeof C=="object"&&!Object.isFrozen(C)&&!(0,P.isTypedArray)(C)&&f.push(C)}}return h}e.deepFreeze=n;const R=Object.prototype.hasOwnProperty;function D(h,f){return k(h,f,new Set)}e.cloneAndChange=D;function k(h,f,p){if((0,P.isUndefinedOrNull)(h))return h;const v=f(h);if(typeof v<"u")return v;if(Array.isArray(h)){const C=[];for(const t of h)C.push(k(t,f,p));return C}if((0,P.isObject)(h)){if(p.has(h))throw new Error("Cannot clone recursive data-structure");p.add(h);const C={};for(const t in h)R.call(h,t)&&(C[t]=k(h[t],f,p));return p.delete(h),C}return h}function g(h,f,p=!0){return(0,P.isObject)(h)?((0,P.isObject)(f)&&Object.keys(f).forEach(v=>{v in h?p&&((0,P.isObject)(h[v])&&(0,P.isObject)(f[v])?g(h[v],f[v],p):h[v]=f[v]):h[v]=f[v]}),h):f}e.mixin=g;function d(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let p,v;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(p=0;p<h.length;p++)if(!d(h[p],f[p]))return!1}else{const C=[];for(v in h)C.push(v);C.sort();const t=[];for(v in f)t.push(v);if(t.sort(),!d(C,t))return!1;for(p=0;p<C.length;p++)if(!d(h[C[p]],f[C[p]]))return!1}return!0}e.equals=d;function y(h){const f=new Set;return JSON.stringify(h,(p,v)=>{if((0,P.isObject)(v)||Array.isArray(v)){if(f.has(v))return"[Circular]";f.add(v)}return v})}e.safeStringify=y;function b(h,f){const p=Object.create(null);return!h||!f||Object.keys(f).forEach(C=>{const t=h[C],c=f[C];d(t,c)||(p[C]=c)}),p}e.distinct=b;function I(h,f){const p=f.toLowerCase(),v=Object.keys(h).find(C=>C.toLowerCase()===p);return v?h[v]:h[f]}e.getCaseInsensitive=I;function u(h,f){const p=Object.create(null);for(const[v,C]of Object.entries(h))f(v,C)&&(p[v]=C);return p}e.filter=u;function w(h){let f=[],p=Object.getPrototypeOf(h);for(;Object.prototype!==p;)f=f.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return f}e.getAllPropertyNames=w;function S(h){const f=[];for(const p of w(h))typeof h[p]=="function"&&f.push(p);return f}e.getAllMethodNames=S;function s(h,f){const p=C=>function(){const t=Array.prototype.slice.call(arguments,0);return f(C,t)},v={};for(const C of h)v[C]=p(C);return v}e.createProxyObject=s}),define(ie[135],se([0,1,134]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(D){function k(g){return g&&typeof g=="object"&&typeof g.id=="string"}D.isThemeColor=k})(A=e.ThemeColor||(e.ThemeColor={}));function n(D){return{id:D}}e.themeColorFromId=n;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function g(f){const p=k.exec(f.id);if(!p)return g(P.Codicon.error);const[,v,C]=p,t=["codicon","codicon-"+v];return C&&t.push("codicon-modifier-"+C.substring(1)),t}D.asClassNameArray=g;function d(f){return g(f).join(" ")}D.asClassName=d;function y(f){return"."+g(f).join(".")}D.asCSSSelector=y;function b(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||A.isThemeColor(f.color))}D.isThemeIcon=b;const I=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function u(f){const p=I.exec(f);if(!p)return;const[,v]=p;return{id:v}}D.fromString=u;function w(f){return{id:f}}D.fromId=w;function S(f,p){let v=f.id;const C=v.lastIndexOf("~");return C!==-1&&(v=v.substring(0,C)),p&&(v=`${v}~${p}`),{id:v}}D.modify=S;function s(f){const p=f.id.lastIndexOf("~");if(p!==-1)return f.id.substring(p+1)}D.getModifier=s;function h(f,p){return f.id===p.id&&f.color?.id===p.color?.id}D.isEqual=h})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(ie[31],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(n){return P.test(n)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(k){for(let g=0;g<k.length;g++)k[g]=Math.floor(Math.random()*256);return k};const R=new Uint8Array(16),D=[];for(let k=0;k<256;k++)D.push(k.toString(16).padStart(2,"0"));return function(){n(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let g=0,d="";return d+=D[R[g++]],d+=D[R[g++]],d+=D[R[g++]],d+=D[R[g++]],d+="-",d+=D[R[g++]],d+=D[R[g++]],d+="-",d+=D[R[g++]],d+=D[R[g++]],d+="-",d+=D[R[g++]],d+=D[R[g++]],d+="-",d+=D[R[g++]],d+=D[R[g++]],d+=D[R[g++]],d+=D[R[g++]],d+=D[R[g++]],d+=D[R[g++]],d}}()}),define(ie[136],se([0,1,81,41,50]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(D,k){if(await new Promise((y,b)=>{const I=A.createReadStream(D),u=P.createHash("sha1");I.pipe(u);const w=(0,n.once)((S,s)=>{I.removeAllListeners(),u.removeAllListeners(),S?b(S):y(s)});I.once("error",w),I.once("end",w),u.once("error",w),u.once("data",S=>w(void 0,S.toString("hex")))})!==k)throw new Error("Hash mismatch")}e.checksum=R}),define(ie[137],se([0,1,27]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function n(D){const k=D.replace(/\-/g,":").toLowerCase();return!A.has(k)}function R(){const D=(0,P.networkInterfaces)();for(const k in D){const g=D[k];if(g){for(const{mac:d}of g)if(n(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(ie[100],se([0,1,82]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function A(k,g,d,y=1){let b=!1;return new Promise(I=>{const u=setTimeout(()=>{if(!b)return b=!0,I(0)},d);n(k,g,y,w=>{if(!b)return b=!0,clearTimeout(u),I(w)})})}e.findFreePort=A;function n(k,g,d,y){if(g===0)return y(0);const b=new P.Socket;b.once("connect",()=>(D(b),n(k+d,g-1,d,y))),b.once("data",()=>{}),b.once("error",I=>(D(b),I.code!=="ECONNREFUSED"?n(k+d,g-1,d,y):y(k))),b.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(k,g,d,y="127.0.0.1"){let b=!1,I,u=1;const w=P.createServer({pauseOnConnect:!0});function S(s,h){b||(b=!0,w.removeAllListeners(),w.close(),I&&clearTimeout(I),h(s))}return new Promise(s=>{I=setTimeout(()=>{S(0,s)},d),w.on("listening",()=>{S(k,s)}),w.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&u<g?(k++,u++,w.listen(k,y)):S(0,s)}),w.on("close",()=>{S(0,s)}),w.listen(k,y)})}e.findFreePortFaster=R;function D(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(g){console.error(g)}}}),define(ie[138],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ie[139],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class P{constructor(n,R){this.a=n,this.onMessage=R}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=P}),define(ie[42],se([0,1,15,13]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class n{constructor(){this.a=new WeakMap}on(D,k){const g=(d,...y)=>{this.b(D,d)&&k(d,...y)};return this.a.set(k,g),P.ipcMain.on(D,g),this}once(D,k){return P.ipcMain.once(D,(g,...d)=>{this.b(D,g)&&k(g,...d)}),this}handle(D,k){return P.ipcMain.handle(D,(g,...d)=>this.b(D,g)?k(g,...d):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return P.ipcMain.removeHandler(D),this}removeListener(D,k){const g=this.a.get(k);return g&&(P.ipcMain.removeListener(D,g),this.a.delete(k)),this}b(D,k){if(!D||!D.startsWith("vscode:"))return(0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const g=k.senderFrame,d=g.url;if(!d)return!0;let y="unknown";try{y=new URL(d).host}catch{return(0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${d}'.`),!1}return y!=="vscode-app"?((0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${y}'.`),!1):g.parent!==null?((0,A.onUnexpectedError)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new n}),define(ie[140],se([0,1,15,42,10,138]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){A.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(g,d,y,b,I)=>{const u=k(g,b,y);u.popup({window:(0,n.withNullAsUndefined)(P.BrowserWindow.fromWebContents(g.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{u&&g.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=D;function k(g,d,y){const b=new P.Menu;return y.forEach(I=>{let u;I.type==="separator"?u=new P.MenuItem({type:I.type}):Array.isArray(I.submenu)?u=new P.MenuItem({submenu:k(g,d,I.submenu),label:I.label}):u=new P.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(w,S,s)=>g.sender.send(d,I.id,s)}),b.append(u)}),b}}),define(ie[141],se([12,11]),function(X,e){return X.create("vs/base/common/date",e)}),define(ie[142],se([0,1,141]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,n=A*60,R=n*24,D=R*7,k=R*30,g=R*365;function d(b,I,u,w){typeof b!="number"&&(b=b.getTime());const S=Math.round((new Date().getTime()-b)/1e3);if(S<-30)return(0,P.localize)(0,null,d(new Date().getTime()+S*1e3,!1));if(!w&&S<30)return(0,P.localize)(1,null);let s;return S<A?(s=S,I?s===1?u?(0,P.localize)(2,null,s):(0,P.localize)(3,null,s):u?(0,P.localize)(4,null,s):(0,P.localize)(5,null,s):s===1?u?(0,P.localize)(6,null,s):(0,P.localize)(7,null,s):u?(0,P.localize)(8,null,s):(0,P.localize)(9,null,s)):S<n?(s=Math.floor(S/A),I?s===1?u?(0,P.localize)(10,null,s):(0,P.localize)(11,null,s):u?(0,P.localize)(12,null,s):(0,P.localize)(13,null,s):s===1?u?(0,P.localize)(14,null,s):(0,P.localize)(15,null,s):u?(0,P.localize)(16,null,s):(0,P.localize)(17,null,s)):S<R?(s=Math.floor(S/n),I?s===1?u?(0,P.localize)(18,null,s):(0,P.localize)(19,null,s):u?(0,P.localize)(20,null,s):(0,P.localize)(21,null,s):s===1?u?(0,P.localize)(22,null,s):(0,P.localize)(23,null,s):u?(0,P.localize)(24,null,s):(0,P.localize)(25,null,s)):S<D?(s=Math.floor(S/R),I?s===1?(0,P.localize)(26,null,s):(0,P.localize)(27,null,s):s===1?(0,P.localize)(28,null,s):(0,P.localize)(29,null,s)):S<k?(s=Math.floor(S/D),I?s===1?u?(0,P.localize)(30,null,s):(0,P.localize)(31,null,s):u?(0,P.localize)(32,null,s):(0,P.localize)(33,null,s):s===1?u?(0,P.localize)(34,null,s):(0,P.localize)(35,null,s):u?(0,P.localize)(36,null,s):(0,P.localize)(37,null,s)):S<g?(s=Math.floor(S/k),I?s===1?u?(0,P.localize)(38,null,s):(0,P.localize)(39,null,s):u?(0,P.localize)(40,null,s):(0,P.localize)(41,null,s):s===1?u?(0,P.localize)(42,null,s):(0,P.localize)(43,null,s):u?(0,P.localize)(44,null,s):(0,P.localize)(45,null,s)):(s=Math.floor(S/g),I?s===1?u?(0,P.localize)(46,null,s):(0,P.localize)(47,null,s):u?(0,P.localize)(48,null,s):(0,P.localize)(49,null,s):s===1?u?(0,P.localize)(50,null,s):(0,P.localize)(51,null,s):u?(0,P.localize)(52,null,s):(0,P.localize)(53,null,s))}e.fromNow=d;function y(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(ie[143],se([12,11]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ie[44],se([0,1,26,10,143]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(b,I){return I&&(b.stack||b.stacktrace)?n.localize(0,null,k(b),D(b.stack)||D(b.stacktrace)):k(b)}function D(b){return Array.isArray(b)?b.join(`
`):b}function k(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?n.localize(1,null,b.message):b.message||n.localize(2,null)}function g(b=null,I=!1){if(!b)return n.localize(3,null);if(Array.isArray(b)){const u=P.coalesce(b),w=g(u[0],I);return u.length>1?n.localize(4,null,w,u.length):w}if(A.isString(b))return b;if(b.detail){const u=b.detail;if(u.error)return R(u.error,I);if(u.exception)return R(u.exception,I)}return b.stack?R(b,I):b.message?b.message:n.localize(5,null)}e.toErrorMessage=g;function d(b){const I=b;return I instanceof Error&&Array.isArray(I.actions)}e.isErrorWithActions=d;function y(b,I){let u;return typeof b=="string"?u=new Error(b):u=b,u.actions=I,u}e.createErrorWithActions=y}),define(ie[144],se([12,11]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(ie[145],se([0,1,144]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function A(n){switch(n){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.getParseErrorMessage=A}),define(ie[146],se([12,11]),function(X,e){return X.create("vs/base/common/platform",e)}),define(ie[4],se([0,1,146]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,n=!1,R=!1,D=!1,k=!1,g=!1,d=!1,y=!1,b=!1,I=!1,u,w=e.LANGUAGE_DEFAULT,S,s;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const f=typeof h?.versions?.electron=="string",p=f&&h?.type==="renderer";if(typeof navigator=="object"&&!p)s=navigator.userAgent,A=s.indexOf("Windows")>=0,n=s.indexOf("Macintosh")>=0,y=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=s.indexOf("Linux")>=0,I=s?.indexOf("Mobi")>=0,g=!0,u=P.getConfiguredDefaultLocale(P.localize(0,null))||e.LANGUAGE_DEFAULT,w=u;else if(typeof h=="object"){A=h.platform==="win32",n=h.platform==="darwin",R=h.platform==="linux",D=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,d=f,b=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT;const a=h.env.VSCODE_NLS_CONFIG;if(a)try{const m=JSON.parse(a),E=m.availableLanguages["*"];u=m.locale,w=E||e.LANGUAGE_DEFAULT,S=m._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var v;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function C(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=C;let t=0;n?t=1:A?t=3:R&&(t=2),e.isWindows=A,e.isMacintosh=n,e.isLinux=R,e.isLinuxSnap=D,e.isNative=k,e.isElectron=d,e.isWeb=g,e.isWebWorker=g&&typeof e.globals.importScripts=="function",e.isIOS=y,e.isMobile=I,e.isCI=b,e.platform=t,e.userAgent=s,e.language=w;var c;(function(a){function m(){return e.language}a.value=m;function E(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=E;function M(){return e.language==="en"}a.isDefault=M})(c=e.Language||(e.Language={})),e.locale=u,e.translationsConfigFile=S,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let M=0,T=a.length;M<T;M++){const N=a[M];if(N.id===E.data.vscodeScheduleAsyncWork){a.splice(M,1),N.callback();return}}});let m=0;return E=>{const M=++m;a.push({id:M,callback:E}),e.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return a=>setTimeout(a)})();var i;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=n||y?2:A?1:3;let o=!0,r=!1;function l(){if(!r){r=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,o=new Uint16Array(a.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ie[36],se([0,1,4]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.process<"u"){const n=P.globals.vscode.process;A={get platform(){return n.platform},get arch(){return n.arch},get env(){return n.env},cwd(){return n.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return P.isWindows?"win32":P.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(ie[9],se([0,1,36]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,n=97,R=90,D=122,k=46,g=47,d=92,y=58,b=63;class I extends Error{constructor(c,i,o){let r;typeof i=="string"&&i.indexOf("not ")===0?(r="must not be",i=i.replace(/^not /,"")):r="must be";const l=c.indexOf(".")!==-1?"property":"argument";let a=`The "${c}" ${l} ${r} of type ${i}`;a+=`. Received type ${typeof o}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function u(t,c){if(t===null||typeof t!="object")throw new I(c,"Object",t)}function w(t,c){if(typeof t!="string")throw new I(c,"string",t)}const S=P.platform==="win32";function s(t){return t===g||t===d}function h(t){return t===g}function f(t){return t>=A&&t<=R||t>=n&&t<=D}function p(t,c,i,o){let r="",l=0,a=-1,m=0,E=0;for(let M=0;M<=t.length;++M){if(M<t.length)E=t.charCodeAt(M);else{if(o(E))break;E=g}if(o(E)){if(!(a===M-1||m===1))if(m===2){if(r.length<2||l!==2||r.charCodeAt(r.length-1)!==k||r.charCodeAt(r.length-2)!==k){if(r.length>2){const T=r.lastIndexOf(i);T===-1?(r="",l=0):(r=r.slice(0,T),l=r.length-1-r.lastIndexOf(i)),a=M,m=0;continue}else if(r.length!==0){r="",l=0,a=M,m=0;continue}}c&&(r+=r.length>0?`${i}..`:"..",l=2)}else r.length>0?r+=`${i}${t.slice(a+1,M)}`:r=t.slice(a+1,M),l=M-a-1;a=M,m=0}else E===k&&m!==-1?++m:m=-1}return r}function v(t,c){u(c,"pathObject");const i=c.dir||c.root,o=c.base||`${c.name||""}${c.ext||""}`;return i?i===c.root?`${i}${o}`:`${i}${t}${o}`:o}e.win32={resolve(...t){let c="",i="",o=!1;for(let r=t.length-1;r>=-1;r--){let l;if(r>=0){if(l=t[r],w(l,"path"),l.length===0)continue}else c.length===0?l=P.cwd():(l=P.env[`=${c}`]||P.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==c.toLowerCase()&&l.charCodeAt(2)===d)&&(l=`${c}\\`));const a=l.length;let m=0,E="",M=!1;const T=l.charCodeAt(0);if(a===1)s(T)&&(m=1,M=!0);else if(s(T))if(M=!0,s(l.charCodeAt(1))){let N=2,z=N;for(;N<a&&!s(l.charCodeAt(N));)N++;if(N<a&&N!==z){const K=l.slice(z,N);for(z=N;N<a&&s(l.charCodeAt(N));)N++;if(N<a&&N!==z){for(z=N;N<a&&!s(l.charCodeAt(N));)N++;(N===a||N!==z)&&(E=`\\\\${K}\\${l.slice(z,N)}`,m=N)}}}else m=1;else f(T)&&l.charCodeAt(1)===y&&(E=l.slice(0,2),m=2,a>2&&s(l.charCodeAt(2))&&(M=!0,m=3));if(E.length>0)if(c.length>0){if(E.toLowerCase()!==c.toLowerCase())continue}else c=E;if(o){if(c.length>0)break}else if(i=`${l.slice(m)}\\${i}`,o=M,M&&c.length>0)break}return i=p(i,!o,"\\",s),o?`${c}\\${i}`:`${c}${i}`||"."},normalize(t){w(t,"path");const c=t.length;if(c===0)return".";let i=0,o,r=!1;const l=t.charCodeAt(0);if(c===1)return h(l)?"\\":t;if(s(l))if(r=!0,s(t.charCodeAt(1))){let m=2,E=m;for(;m<c&&!s(t.charCodeAt(m));)m++;if(m<c&&m!==E){const M=t.slice(E,m);for(E=m;m<c&&s(t.charCodeAt(m));)m++;if(m<c&&m!==E){for(E=m;m<c&&!s(t.charCodeAt(m));)m++;if(m===c)return`\\\\${M}\\${t.slice(E)}\\`;m!==E&&(o=`\\\\${M}\\${t.slice(E,m)}`,i=m)}}}else i=1;else f(l)&&t.charCodeAt(1)===y&&(o=t.slice(0,2),i=2,c>2&&s(t.charCodeAt(2))&&(r=!0,i=3));let a=i<c?p(t.slice(i),!r,"\\",s):"";return a.length===0&&!r&&(a="."),a.length>0&&s(t.charCodeAt(c-1))&&(a+="\\"),o===void 0?r?`\\${a}`:a:r?`${o}\\${a}`:`${o}${a}`},isAbsolute(t){w(t,"path");const c=t.length;if(c===0)return!1;const i=t.charCodeAt(0);return s(i)||c>2&&f(i)&&t.charCodeAt(1)===y&&s(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,i;for(let l=0;l<t.length;++l){const a=t[l];w(a,"path"),a.length>0&&(c===void 0?c=i=a:c+=`\\${a}`)}if(c===void 0)return".";let o=!0,r=0;if(typeof i=="string"&&s(i.charCodeAt(0))){++r;const l=i.length;l>1&&s(i.charCodeAt(1))&&(++r,l>2&&(s(i.charCodeAt(2))?++r:o=!1))}if(o){for(;r<c.length&&s(c.charCodeAt(r));)r++;r>=2&&(c=`\\${c.slice(r)}`)}return e.win32.normalize(c)},relative(t,c){if(w(t,"from"),w(c,"to"),t===c)return"";const i=e.win32.resolve(t),o=e.win32.resolve(c);if(i===o||(t=i.toLowerCase(),c=o.toLowerCase(),t===c))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===d;)r++;let l=t.length;for(;l-1>r&&t.charCodeAt(l-1)===d;)l--;const a=l-r;let m=0;for(;m<c.length&&c.charCodeAt(m)===d;)m++;let E=c.length;for(;E-1>m&&c.charCodeAt(E-1)===d;)E--;const M=E-m,T=a<M?a:M;let N=-1,z=0;for(;z<T;z++){const ae=t.charCodeAt(r+z);if(ae!==c.charCodeAt(m+z))break;ae===d&&(N=z)}if(z!==T){if(N===-1)return o}else{if(M>T){if(c.charCodeAt(m+z)===d)return o.slice(m+z+1);if(z===2)return o.slice(m+z)}a>T&&(t.charCodeAt(r+z)===d?N=z:z===2&&(N=3)),N===-1&&(N=0)}let K="";for(z=r+N+1;z<=l;++z)(z===l||t.charCodeAt(z)===d)&&(K+=K.length===0?"..":"\\..");return m+=N,K.length>0?`${K}${o.slice(m,E)}`:(o.charCodeAt(m)===d&&++m,o.slice(m,E))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.win32.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===d){if(c.charCodeAt(1)===d){const i=c.charCodeAt(2);if(i!==b&&i!==k)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(f(c.charCodeAt(0))&&c.charCodeAt(1)===y&&c.charCodeAt(2)===d)return`\\\\?\\${c}`;return t},dirname(t){w(t,"path");const c=t.length;if(c===0)return".";let i=-1,o=0;const r=t.charCodeAt(0);if(c===1)return s(r)?t:".";if(s(r)){if(i=o=1,s(t.charCodeAt(1))){let m=2,E=m;for(;m<c&&!s(t.charCodeAt(m));)m++;if(m<c&&m!==E){for(E=m;m<c&&s(t.charCodeAt(m));)m++;if(m<c&&m!==E){for(E=m;m<c&&!s(t.charCodeAt(m));)m++;if(m===c)return t;m!==E&&(i=o=m+1)}}}}else f(r)&&t.charCodeAt(1)===y&&(i=c>2&&s(t.charCodeAt(2))?3:2,o=i);let l=-1,a=!0;for(let m=c-1;m>=o;--m)if(s(t.charCodeAt(m))){if(!a){l=m;break}}else a=!1;if(l===-1){if(i===-1)return".";l=i}return t.slice(0,l)},basename(t,c){c!==void 0&&w(c,"ext"),w(t,"path");let i=0,o=-1,r=!0,l;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===y&&(i=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let a=c.length-1,m=-1;for(l=t.length-1;l>=i;--l){const E=t.charCodeAt(l);if(s(E)){if(!r){i=l+1;break}}else m===-1&&(r=!1,m=l+1),a>=0&&(E===c.charCodeAt(a)?--a===-1&&(o=l):(a=-1,o=m))}return i===o?o=m:o===-1&&(o=t.length),t.slice(i,o)}for(l=t.length-1;l>=i;--l)if(s(t.charCodeAt(l))){if(!r){i=l+1;break}}else o===-1&&(r=!1,o=l+1);return o===-1?"":t.slice(i,o)},extname(t){w(t,"path");let c=0,i=-1,o=0,r=-1,l=!0,a=0;t.length>=2&&t.charCodeAt(1)===y&&f(t.charCodeAt(0))&&(c=o=2);for(let m=t.length-1;m>=c;--m){const E=t.charCodeAt(m);if(s(E)){if(!l){o=m+1;break}continue}r===-1&&(l=!1,r=m+1),E===k?i===-1?i=m:a!==1&&(a=1):i!==-1&&(a=-1)}return i===-1||r===-1||a===0||a===1&&i===r-1&&i===o+1?"":t.slice(i,r)},format:v.bind(null,"\\"),parse(t){w(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.length;let o=0,r=t.charCodeAt(0);if(i===1)return s(r)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(s(r)){if(o=1,s(t.charCodeAt(1))){let N=2,z=N;for(;N<i&&!s(t.charCodeAt(N));)N++;if(N<i&&N!==z){for(z=N;N<i&&s(t.charCodeAt(N));)N++;if(N<i&&N!==z){for(z=N;N<i&&!s(t.charCodeAt(N));)N++;N===i?o=N:N!==z&&(o=N+1)}}}}else if(f(r)&&t.charCodeAt(1)===y){if(i<=2)return c.root=c.dir=t,c;if(o=2,s(t.charCodeAt(2))){if(i===3)return c.root=c.dir=t,c;o=3}}o>0&&(c.root=t.slice(0,o));let l=-1,a=o,m=-1,E=!0,M=t.length-1,T=0;for(;M>=o;--M){if(r=t.charCodeAt(M),s(r)){if(!E){a=M+1;break}continue}m===-1&&(E=!1,m=M+1),r===k?l===-1?l=M:T!==1&&(T=1):l!==-1&&(T=-1)}return m!==-1&&(l===-1||T===0||T===1&&l===m-1&&l===a+1?c.base=c.name=t.slice(a,m):(c.name=t.slice(a,l),c.base=t.slice(a,m),c.ext=t.slice(l,m))),a>0&&a!==o?c.dir=t.slice(0,a-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(S){const t=/\\/g;return()=>{const c=P.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>P.cwd()})();e.posix={resolve(...t){let c="",i=!1;for(let o=t.length-1;o>=-1&&!i;o--){const r=o>=0?t[o]:C();w(r,"path"),r.length!==0&&(c=`${r}/${c}`,i=r.charCodeAt(0)===g)}return c=p(c,!i,"/",h),i?`/${c}`:c.length>0?c:"."},normalize(t){if(w(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===g,i=t.charCodeAt(t.length-1)===g;return t=p(t,!c,"/",h),t.length===0?c?"/":i?"./":".":(i&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return w(t,"path"),t.length>0&&t.charCodeAt(0)===g},join(...t){if(t.length===0)return".";let c;for(let i=0;i<t.length;++i){const o=t[i];w(o,"path"),o.length>0&&(c===void 0?c=o:c+=`/${o}`)}return c===void 0?".":e.posix.normalize(c)},relative(t,c){if(w(t,"from"),w(c,"to"),t===c||(t=e.posix.resolve(t),c=e.posix.resolve(c),t===c))return"";const i=1,o=t.length,r=o-i,l=1,a=c.length-l,m=r<a?r:a;let E=-1,M=0;for(;M<m;M++){const N=t.charCodeAt(i+M);if(N!==c.charCodeAt(l+M))break;N===g&&(E=M)}if(M===m)if(a>m){if(c.charCodeAt(l+M)===g)return c.slice(l+M+1);if(M===0)return c.slice(l+M)}else r>m&&(t.charCodeAt(i+M)===g?E=M:M===0&&(E=0));let T="";for(M=i+E+1;M<=o;++M)(M===o||t.charCodeAt(M)===g)&&(T+=T.length===0?"..":"/..");return`${T}${c.slice(l+E)}`},toNamespacedPath(t){return t},dirname(t){if(w(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===g;let i=-1,o=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===g){if(!o){i=r;break}}else o=!1;return i===-1?c?"/":".":c&&i===1?"//":t.slice(0,i)},basename(t,c){c!==void 0&&w(c,"ext"),w(t,"path");let i=0,o=-1,r=!0,l;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let a=c.length-1,m=-1;for(l=t.length-1;l>=0;--l){const E=t.charCodeAt(l);if(E===g){if(!r){i=l+1;break}}else m===-1&&(r=!1,m=l+1),a>=0&&(E===c.charCodeAt(a)?--a===-1&&(o=l):(a=-1,o=m))}return i===o?o=m:o===-1&&(o=t.length),t.slice(i,o)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===g){if(!r){i=l+1;break}}else o===-1&&(r=!1,o=l+1);return o===-1?"":t.slice(i,o)},extname(t){w(t,"path");let c=-1,i=0,o=-1,r=!0,l=0;for(let a=t.length-1;a>=0;--a){const m=t.charCodeAt(a);if(m===g){if(!r){i=a+1;break}continue}o===-1&&(r=!1,o=a+1),m===k?c===-1?c=a:l!==1&&(l=1):c!==-1&&(l=-1)}return c===-1||o===-1||l===0||l===1&&c===o-1&&c===i+1?"":t.slice(c,o)},format:v.bind(null,"/"),parse(t){w(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.charCodeAt(0)===g;let o;i?(c.root="/",o=1):o=0;let r=-1,l=0,a=-1,m=!0,E=t.length-1,M=0;for(;E>=o;--E){const T=t.charCodeAt(E);if(T===g){if(!m){l=E+1;break}continue}a===-1&&(m=!1,a=E+1),T===k?r===-1?r=E:M!==1&&(M=1):r!==-1&&(M=-1)}if(a!==-1){const T=l===0&&i?1:l;r===-1||M===0||M===1&&r===a-1&&r===l+1?c.base=c.name=t.slice(T,a):(c.name=t.slice(T,r),c.base=t.slice(T,a),c.ext=t.slice(r,a))}return l>0?c.dir=t.slice(0,l-1):i&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=S?e.win32.normalize:e.posix.normalize,e.isAbsolute=S?e.win32.isAbsolute:e.posix.isAbsolute,e.join=S?e.win32.join:e.posix.join,e.resolve=S?e.win32.resolve:e.posix.resolve,e.relative=S?e.win32.relative:e.posix.relative,e.dirname=S?e.win32.dirname:e.posix.dirname,e.basename=S?e.win32.basename:e.posix.basename,e.extname=S?e.win32.extname:e.posix.extname,e.format=S?e.win32.format:e.posix.format,e.parse=S?e.win32.parse:e.posix.parse,e.toNamespacedPath=S?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=S?e.win32.sep:e.posix.sep,e.delimiter=S?e.win32.delimiter:e.posix.delimiter}),define(ie[71],se([0,1,4]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var n;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(k,...g){const d=g.reduce((I,u)=>(I[u]=!0,I),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(I=>!d[I]).forEach(I=>{for(let u=0;u<y.length;u++)if(I.search(y[u])!==-1){delete k[I];break}})}e.sanitizeProcessEnvironment=R;function D(k){!k||(delete k.DEBUG,P.isMacintosh&&delete k.DYLD_LIBRARY_PATH,P.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(ie[72],se([0,1,4]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=P.globals.performance&&typeof P.globals.performance.now=="function";class n{static create(D=!0){return new n(D)}constructor(D){this.a=A&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?P.globals.performance.now():Date.now()}}e.StopWatch=n}),define(ie[3],se([0,1,13,50,2,99,72]),function(X,e,P,A,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,g=!1;var d;(function(l){l.None=()=>n.Disposable.None;function a(j){if(g){const{onDidAddListener:q}=j,J=w.create();let B=0;j.onDidAddListener=()=>{++B===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),J.print()),q?.()}}}function m(j,q){return te(j,()=>{},0,void 0,!0,void 0,q)}l.defer=m;function E(j){return(q,J=null,B)=>{let Y=!1,Z;return Z=j(ce=>{if(!Y)return Z?Z.dispose():Y=!0,q.call(J,ce)},null,B),Y&&Z.dispose(),Z}}l.once=E;function M(j,q,J){return le((B,Y=null,Z)=>j(ce=>B.call(Y,q(ce)),null,Z),J)}l.map=M;function T(j,q,J){return le((B,Y=null,Z)=>j(ce=>{q(ce),B.call(Y,ce)},null,Z),J)}l.forEach=T;function N(j,q,J){return le((B,Y=null,Z)=>j(ce=>q(ce)&&B.call(Y,ce),null,Z),J)}l.filter=N;function z(j){return j}l.signal=z;function K(...j){return(q,J=null,B)=>(0,n.combinedDisposable)(...j.map(Y=>Y(Z=>q.call(J,Z),null,B)))}l.any=K;function ae(j,q,J,B){let Y=J;return M(j,Z=>(Y=q(Y,Z),Y),B)}l.reduce=ae;function le(j,q){let J;const B={onWillAddFirstListener(){J=j(Y.fire,Y)},onDidRemoveLastListener(){J?.dispose()}};q||a(B);const Y=new s(B);return q?.add(Y),Y.event}function te(j,q,J=100,B=!1,Y=!1,Z,ce){let fe,De,Re,Ce=0,Oe;const $e={leakWarningThreshold:Z,onWillAddFirstListener(){fe=j(pe=>{Ce++,De=q(De,pe),B&&!Re&&(ge.fire(De),De=void 0),Oe=()=>{const Le=De;De=void 0,Re=void 0,(!B||Ce>1)&&ge.fire(Le),Ce=0},typeof J=="number"?(clearTimeout(Re),Re=setTimeout(Oe,J)):Re===void 0&&(Re=0,queueMicrotask(Oe))})},onWillRemoveListener(){Y&&Ce>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,fe.dispose()}};ce||a($e);const ge=new s($e);return ce?.add(ge),ge.event}l.debounce=te;function F(j,q=0,J){return l.debounce(j,(B,Y)=>B?(B.push(Y),B):[Y],q,void 0,!0,void 0,J)}l.accumulate=F;function $(j,q=(B,Y)=>B===Y,J){let B=!0,Y;return N(j,Z=>{const ce=B||!q(Z,Y);return B=!1,Y=Z,ce},J)}l.latch=$;function V(j,q,J){return[l.filter(j,q,J),l.filter(j,B=>!q(B),J)]}l.split=V;function x(j,q=!1,J=[]){let B=J.slice(),Y=j(fe=>{B?B.push(fe):ce.fire(fe)});const Z=()=>{B?.forEach(fe=>ce.fire(fe)),B=null},ce=new s({onWillAddFirstListener(){Y||(Y=j(fe=>ce.fire(fe)))},onDidAddFirstListener(){B&&(q?setTimeout(Z):Z())},onDidRemoveLastListener(){Y&&Y.dispose(),Y=null}});return ce.event}l.buffer=x;class H{constructor(q){this.event=q,this.c=new n.DisposableStore}map(q){return new H(M(this.event,q,this.c))}forEach(q){return new H(T(this.event,q,this.c))}filter(q){return new H(N(this.event,q,this.c))}reduce(q,J){return new H(ae(this.event,q,J,this.c))}latch(){return new H($(this.event,void 0,this.c))}debounce(q,J=100,B=!1,Y=!1,Z){return new H(te(this.event,q,J,B,Y,Z,this.c))}on(q,J,B){return this.event(q,J,B)}once(q,J,B){return E(this.event)(q,J,B)}dispose(){this.c.dispose()}}function O(j){return new H(j)}l.chain=O;function G(j,q,J=B=>B){const B=(...fe)=>ce.fire(J(...fe)),Y=()=>j.on(q,B),Z=()=>j.removeListener(q,B),ce=new s({onWillAddFirstListener:Y,onDidRemoveLastListener:Z});return ce.event}l.fromNodeEventEmitter=G;function _(j,q,J=B=>B){const B=(...fe)=>ce.fire(J(...fe)),Y=()=>j.addEventListener(q,B),Z=()=>j.removeEventListener(q,B),ce=new s({onWillAddFirstListener:Y,onDidRemoveLastListener:Z});return ce.event}l.fromDOMEventEmitter=_;function re(j){return new Promise(q=>E(j)(q))}l.toPromise=re;function oe(j,q){return q(void 0),j(J=>q(J))}l.runAndSubscribe=oe;function L(j,q){let J=null;function B(Z){J?.dispose(),J=new n.DisposableStore,q(Z,J)}B(void 0);const Y=j(Z=>B(Z));return(0,n.toDisposable)(()=>{Y.dispose(),J?.dispose()})}l.runAndSubscribeWithStore=L;class W{constructor(q,J){this.obs=q,this.c=0,this.d=!1;const B={onWillAddFirstListener:()=>{q.addObserver(this)},onDidRemoveLastListener:()=>{q.removeObserver(this)}};J||a(B),this.emitter=new s(B),J&&J.add(this.emitter)}beginUpdate(q){this.c++}handleChange(q,J){this.d=!0}endUpdate(q){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function U(j,q){return new W(j,q).emitter.event}l.fromObservable=U})(d=e.Event||(e.Event={}));class y{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${y.c++}`,y.all.add(this)}start(a){this.d=new D.StopWatch(!0),this.listenerCount=a}stop(){if(this.d){const a=this.d.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this.d=void 0}}}y.all=new Set,y.c=0,e.EventProfiling=y;let b=-1;function I(l){const a=b;return b=l,{dispose(){b=a}}}e.setGlobalLeakWarningThreshold=I;class u{constructor(a,m=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=m,this.d=0}dispose(){this.c?.clear()}check(a,m){const E=this.threshold;if(E<=0||m<E)return;this.c||(this.c=new Map);const M=this.c.get(a.value)||0;if(this.c.set(a.value,M+1),this.d-=1,this.d<=0){this.d=E*.5;let T,N=0;for(const[z,K]of this.c)(!T||N<K)&&(T=z,N=K);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${N}):`),console.warn(T)}return()=>{const T=this.c.get(a.value)||0;this.c.set(a.value,T-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(a,m,E){this.callback=a,this.callbackThis=m,this.stack=E,this.subscription=new n.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class s{constructor(a){this.j=!1,this.d=a,this.f=b>0||this.d?.leakWarningThreshold?new u(this.d?.leakWarningThreshold??b):void 0,this.g=this.d?._profName?new y(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const a=Array.from(this.q);queueMicrotask(()=>{for(const m of a)m.subscription.isset()&&(m.subscription.unset(),m.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(a,m,E)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.Disposable.None;const M=this.q.isEmpty();M&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=w.create(),T=this.f.check(N,this.q.size+1)),k&&(N=N??w.create());const z=new S(a,m,N),K=this.q.push(z);M&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,a,m);const ae=z.subscription.set(()=>{T?.(),this.j||(this.d?.onWillRemoveListener?.(this),K(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return E instanceof n.DisposableStore?E.add(ae):Array.isArray(E)&&E.push(ae),ae}),this.l}fire(a){if(this.q){this.m||(this.m=new f);for(const m of this.q)this.m.push(this,m,a);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=s;class h{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(a,m,E){this.c.push(new p(a,m,E))}clear(a){const m=new R.LinkedList;for(const E of this.c)E.emitter!==a&&m.push(E);this.c=m}deliver(){for(;this.c.size>0;){const a=this.c.shift();try{a.listener.invoke(a.event)}catch(m){(0,P.onUnexpectedError)(m)}}}}e.EventDeliveryQueue=h;class f extends h{clear(a){this.c.clear()}}class p{constructor(a,m,E){this.emitter=a,this.listener=m,this.event=E}}class v extends s{async fireAsync(a,m,E){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const M of this.q)this.c.push([M,a]);for(;this.c.size>0&&!m.isCancellationRequested;){const[M,T]=this.c.shift(),N=[],z={...T,token:m,waitUntil:K=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");E&&(K=E(K,M.callback)),N.push(K)}};try{M.invoke(z)}catch(K){(0,P.onUnexpectedError)(K);continue}Object.freeze(N),await Promise.allSettled(N).then(K=>{for(const ae of K)ae.status==="rejected"&&(0,P.onUnexpectedError)(ae.reason)})}}}}e.AsyncEmitter=v;class C extends s{constructor(a){super(a),this.h=0,this.s=new R.LinkedList,this.t=a?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const a=Array.from(this.s);this.s.clear(),super.fire(this.t(a))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(a){this.q&&(this.h!==0?this.s.push(a):super.fire(a))}}e.PauseableEmitter=C;class t extends C{constructor(a){super(a),this.c=a.delay??100}fire(a){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(a)}}e.DebounceEmitter=t;class c extends s{constructor(a){super(a),this.c=[],this.h=a?.merge}fire(a){!this.hasListeners()||(this.c.push(a),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(m=>super.fire(m)),this.c=[]}))}}e.MicrotaskEmitter=c;class i{constructor(){this.d=!1,this.f=[],this.c=new s({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(a){const m={event:a,listener:null};this.f.push(m),this.d&&this.j(m);const E=()=>{this.d&&this.k(m);const M=this.f.indexOf(m);this.f.splice(M,1)};return(0,n.toDisposable)((0,A.once)(E))}g(){this.d=!0,this.f.forEach(a=>this.j(a))}h(){this.d=!1,this.f.forEach(a=>this.k(a))}j(a){a.listener=a.event(m=>this.c.fire(m))}k(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class o{constructor(){this.c=[]}wrapEvent(a){return(m,E,M)=>a(T=>{const N=this.c[this.c.length-1];N?N.push(()=>m.call(E,T)):m.call(E,T)},void 0,M)}bufferEvents(a){const m=[];this.c.push(m);const E=a();return this.c.pop(),m.forEach(M=>M()),E}}e.EventBufferer=o;class r{constructor(){this.c=!1,this.d=d.None,this.f=n.Disposable.None,this.g=new s({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(a){this.d=a,this.c&&(this.f.dispose(),this.f=a(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(ie[22],se([0,1,3]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(k,g){const d=setTimeout(k.bind(g),0);return{dispose(){clearTimeout(d)}}});var n;(function(k){function g(d){return d===k.None||d===k.Cancelled||d instanceof R?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}k.isCancellationToken=g,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(n=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new P.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(g){this.a=void 0,this.b=void 0,this.b=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=n.Cancelled}dispose(g=!1){g&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=n.None}}e.CancellationTokenSource=D}),define(ie[147],se([0,1,22]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new P.CancellationTokenSource,g=this.b(k.token);return this.a={promise:g,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=A;class n{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const g=JSON.stringify(k);return this.b!==g&&(this.b=g,this.a=this.c(k)),this.a}}e.LRUCachedFunction=n;class R{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const g=this.b(k);return this.a.set(k,g),g}}e.CachedFunction=R}),define(ie[25],se([0,1,147,130]),function(X,e,P,A){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function k(Q,...ue){return ue.length===0?Q:Q.replace(D,function(me,be){const we=parseInt(be,10);return isNaN(we)||we<0||we>=ue.length?me:ue[we]})}e.format=k;const g=/{([^}]+)}/g;function d(Q,ue){return Q.replace(g,(me,be)=>ue[be]??me)}e.format2=d;function y(Q){return Q.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=y;function b(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function I(Q,ue){let me=0;const be=ue.charCodeAt(0);for(let we=Q.length-1;we>=0;we--)Q.charCodeAt(we)===be&&me++;return me}e.count=I;function u(Q,ue,me="\u2026"){return Q.length<=ue?Q:`${Q.substr(0,ue)}${me}`}e.truncate=u;function w(Q,ue=" "){const me=S(Q,ue);return s(me,ue)}e.trim=w;function S(Q,ue){if(!Q||!ue)return Q;const me=ue.length;if(me===0||Q.length===0)return Q;let be=0;for(;Q.indexOf(ue,be)===be;)be=be+me;return Q.substring(be)}e.ltrim=S;function s(Q,ue){if(!Q||!ue)return Q;const me=ue.length,be=Q.length;if(me===0||be===0)return Q;let we=be,Ae=-1;for(;Ae=Q.lastIndexOf(ue,we-1),!(Ae===-1||Ae+me!==we);){if(Ae===0)return"";we=Ae}return Q.substring(0,we)}e.rtrim=s;function h(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function f(Q){return Q.replace(/\*/g,"")}e.stripWildcards=f;function p(Q,ue,me={}){if(!Q)throw new Error("Cannot create regex from empty string");ue||(Q=b(Q)),me.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let be="";return me.global&&(be+="g"),me.matchCase||(be+="i"),me.multiline&&(be+="m"),me.unicode&&(be+="u"),new RegExp(Q,be)}e.createRegExp=p;function v(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function C(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=C;function t(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=t;function c(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=c;function i(Q){for(let ue=0,me=Q.length;ue<me;ue++){const be=Q.charCodeAt(ue);if(be!==32&&be!==9)return ue}return-1}e.firstNonWhitespaceIndex=i;function o(Q,ue=0,me=Q.length){for(let be=ue;be<me;be++){const we=Q.charCodeAt(be);if(we!==32&&we!==9)return Q.substring(ue,be)}return Q.substring(ue,me)}e.getLeadingWhitespace=o;function r(Q,ue=Q.length-1){for(let me=ue;me>=0;me--){const be=Q.charCodeAt(me);if(be!==32&&be!==9)return me}return-1}e.lastNonWhitespaceIndex=r;function l(Q,ue,me){const be=[];let we=0;for(const Ae of Q.matchAll(ue)){if(be.push(Q.slice(we,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");we=Ae.index+Ae[0].length,be.push(me(Ae[0],...Ae.slice(1),Ae.index,Q,Ae.groups))}return be.push(Q.slice(we)),Promise.all(be).then(Ae=>Ae.join(""))}e.replaceAsync=l;function a(Q,ue){return Q<ue?-1:Q>ue?1:0}e.compare=a;function m(Q,ue,me=0,be=Q.length,we=0,Ae=ue.length){for(;me<be&&we<Ae;me++,we++){const Ge=Q.charCodeAt(me),Ke=ue.charCodeAt(we);if(Ge<Ke)return-1;if(Ge>Ke)return 1}const Ue=be-me,Ve=Ae-we;return Ue<Ve?-1:Ue>Ve?1:0}e.compareSubstring=m;function E(Q,ue){return M(Q,ue,0,Q.length,0,ue.length)}e.compareIgnoreCase=E;function M(Q,ue,me=0,be=Q.length,we=0,Ae=ue.length){for(;me<be&&we<Ae;me++,we++){let Ge=Q.charCodeAt(me),Ke=ue.charCodeAt(we);if(Ge===Ke)continue;if(Ge>=128||Ke>=128)return m(Q.toLowerCase(),ue.toLowerCase(),me,be,we,Ae);N(Ge)&&(Ge-=32),N(Ke)&&(Ke-=32);const Ye=Ge-Ke;if(Ye!==0)return Ye}const Ue=be-me,Ve=Ae-we;return Ue<Ve?-1:Ue>Ve?1:0}e.compareSubstringIgnoreCase=M;function T(Q){return Q>=48&&Q<=57}e.isAsciiDigit=T;function N(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=N;function z(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=z;function K(Q,ue){return Q.length===ue.length&&M(Q,ue)===0}e.equalsIgnoreCase=K;function ae(Q,ue){const me=ue.length;return ue.length>Q.length?!1:M(Q,ue,0,me)===0}e.startsWithIgnoreCase=ae;function le(Q,ue){const me=Math.min(Q.length,ue.length);let be;for(be=0;be<me;be++)if(Q.charCodeAt(be)!==ue.charCodeAt(be))return be;return me}e.commonPrefixLength=le;function te(Q,ue){const me=Math.min(Q.length,ue.length);let be;const we=Q.length-1,Ae=ue.length-1;for(be=0;be<me;be++)if(Q.charCodeAt(we-be)!==ue.charCodeAt(Ae-be))return be;return me}e.commonSuffixLength=te;function F(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=F;function $(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=$;function V(Q,ue){return(Q-55296<<10)+(ue-56320)+65536}e.computeCodePoint=V;function x(Q,ue,me){const be=Q.charCodeAt(me);if(F(be)&&me+1<ue){const we=Q.charCodeAt(me+1);if($(we))return V(be,we)}return be}e.getNextCodePoint=x;function H(Q,ue){const me=Q.charCodeAt(ue-1);if($(me)&&ue>1){const be=Q.charCodeAt(ue-2);if(F(be))return V(be,me)}return me}class O{get offset(){return this.e}constructor(ue,me=0){this.c=ue,this.d=ue.length,this.e=me}setOffset(ue){this.e=ue}prevCodePoint(){const ue=H(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=x(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=O;class G{get offset(){return this.c.offset}constructor(ue,me=0){this.c=new O(ue,me)}nextGraphemeLength(){const ue=Ie.getInstance(),me=this.c,be=me.offset;let we=ue.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ae=me.offset,Ue=ue.getGraphemeBreakType(me.nextCodePoint());if(he(we,Ue)){me.setOffset(Ae);break}we=Ue}return me.offset-be}prevGraphemeLength(){const ue=Ie.getInstance(),me=this.c,be=me.offset;let we=ue.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ae=me.offset,Ue=ue.getGraphemeBreakType(me.prevCodePoint());if(he(Ue,we)){me.setOffset(Ae);break}we=Ue}return be-me.offset}eol(){return this.c.eol()}}e.GraphemeIterator=G;function _(Q,ue){return new G(Q,ue).nextGraphemeLength()}e.nextCharLength=_;function re(Q,ue){return new G(Q,ue).prevGraphemeLength()}e.prevCharLength=re;function oe(Q,ue){ue>0&&$(Q.charCodeAt(ue))&&ue--;const me=ue+_(Q,ue);return[me-re(Q,me),me]}e.getCharContainingOffset=oe;function L(Q){const ue=new G(Q);let me=0;for(;!ue.eol();)me++,ue.nextGraphemeLength();return me}e.charCount=L;let W;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(Q){return W||(W=U()),W.test(Q)}e.containsRTL=j;const q=/^[\t\n\r\x20-\x7E]*$/;function J(Q){return q.test(Q)}e.isBasicASCII=J,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=B;function Y(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=Y;function Z(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=Z;function ce(Q,ue){if(Q.length<ue)return Q;const me=/\b/g;let be=0;for(;me.test(Q)&&!(Q.length-me.lastIndex<ue);)be=me.lastIndex,me.lastIndex+=1;return Q.substring(be).replace(/^\s/,"")}e.lcut=ce;const fe=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function De(Q){return Q&&(Q=Q.replace(fe,"")),Q}e.removeAnsiEscapeCodes=De,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function Ce(Q){return Re(Q)?Q.substr(1):Q}e.stripUTF8BOM=Ce;function Oe(Q,ue){if(!Q||!ue||Q.length<ue.length)return!1;const me=ue.length,be=Q.toLowerCase();let we=0,Ae=-1;for(;we<me;){const Ue=be.indexOf(ue[we],Ae+1);if(Ue<0)return!1;Ae=Ue,we++}return!0}e.fuzzyContains=Oe;function $e(Q,ue=!1){return Q?(ue&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=$e;function ge(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=ge;function pe(Q,ue=1){if(ue===0)return"";let me=-1;do me=Q.indexOf(`
`,me+1),ue--;while(ue>0&&me>=0);return me===-1?Q:(Q[me-1]==="\r"&&me--,Q.substr(0,me))}e.getNLines=pe;function Le(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}e.singleLetterHash=Le;function ne(Q){return Ie.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=ne;function he(Q,ue){return Q===0?ue!==5&&ue!==7:Q===2&&ue===3?!1:Q===4||Q===2||Q===3||ue===4||ue===2||ue===3?!0:!(Q===8&&(ue===8||ue===9||ue===11||ue===12)||(Q===11||Q===9)&&(ue===9||ue===10)||(Q===12||Q===10)&&ue===10||ue===5||ue===13||ue===7||Q===1||Q===13&&ue===14||Q===6&&ue===6)}var de;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(de=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Me()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const me=this.d,be=me.length/3;let we=1;for(;we<=be;)if(ue<me[3*we])we=2*we;else if(ue>me[3*we+1])we=2*we+1;else return me[3*we+2];return 0}}Ie.c=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(Q,ue){if(Q===0)return 0;const me=Fe(Q,ue);if(me!==void 0)return me;const be=new O(ue,Q);return be.prevCodePoint(),be.offset}e.getLeftDeleteOffset=Te;function Fe(Q,ue){const me=new O(ue,Q);let be=me.prevCodePoint();for(;je(be)||be===65039||be===8419;){if(me.offset===0)return;be=me.prevCodePoint()}if(!Z(be))return;let we=me.offset;return we>0&&me.prevCodePoint()===8205&&(we=me.offset),we}function je(Q){return 127995<=Q&&Q<=127999}var ze;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class We{static getInstance(ue){return We.d.get(Array.from(ue))}static getLocales(){return We.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}n=We,We.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),We.d=new P.LRUCachedFunction(Q=>{function ue(Ke){const Ye=new Map;for(let Ze=0;Ze<Ke.length;Ze+=2)Ye.set(Ke[Ze],Ke[Ze+1]);return Ye}function me(Ke,Ye){const Ze=new Map(Ke);for(const[rt,ct]of Ye)Ze.set(rt,ct);return Ze}function be(Ke,Ye){if(!Ke)return Ye;const Ze=new Map;for(const[rt,ct]of Ke)Ye.has(rt)&&Ze.set(rt,ct);return Ze}const we=n.c.value;let Ae=Q.filter(Ke=>!Ke.startsWith("_")&&Ke in we);Ae.length===0&&(Ae=["_default"]);let Ue;for(const Ke of Ae){const Ye=ue(we[Ke]);Ue=be(Ue,Ye)}const Ve=ue(we._common),Ge=me(Ve,Ue);return new We(Ge)}),We.e=new A.Lazy(()=>Object.keys(We.c.value).filter(Q=>!Q.startsWith("_"))),e.AmbiguousCharacters=We;class He{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(He.c())),this.d}static isInvisibleCharacter(ue){return He.e().has(ue)}static get codePoints(){return He.e()}}He.d=void 0,e.InvisibleCharacters=He}),define(ie[32],se([0,1,9,4,25,10]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function k(r){return r.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=k;function g(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=g;function d(r,l=P.posix.sep){if(!r)return"";const a=r.length,m=r.charCodeAt(0);if(D(m)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let M=3;const T=M;for(;M<a&&!D(r.charCodeAt(M));M++);if(T!==M&&!D(r.charCodeAt(M+1))){for(M+=1;M<a;M++)if(D(r.charCodeAt(M)))return r.slice(0,M+1).replace(/[\\/]/g,l)}}return l}else if(h(m)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+l:r.slice(0,2);let E=r.indexOf("://");if(E!==-1){for(E+=3;E<a;E++)if(D(r.charCodeAt(E)))return r.slice(0,E+1)}return""}e.getRoot=d;function y(r){if(!A.isWindows||!r||r.length<5)return!1;let l=r.charCodeAt(0);if(l!==92||(l=r.charCodeAt(1),l!==92))return!1;let a=2;const m=a;for(;a<r.length&&(l=r.charCodeAt(a),l!==92);a++);return!(m===a||(l=r.charCodeAt(a+1),isNaN(l)||l===92))}e.isUNC=y;const b=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(r,l=A.isWindows){const a=l?b:I;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||l&&u.test(r)||r==="."||r===".."||l&&r[r.length-1]==="."||l&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=w;function S(r,l,a){const m=r===l;return!a||m?m:!r||!l?!1:(0,n.equalsIgnoreCase)(r,l)}e.isEqual=S;function s(r,l,a,m=P.sep){if(r===l)return!0;if(!r||!l||l.length>r.length)return!1;if(a){if(!(0,n.startsWithIgnoreCase)(r,l))return!1;if(l.length===r.length)return!0;let M=l.length;return l.charAt(l.length-1)===m&&M--,r.charAt(M)===m}return l.charAt(l.length-1)!==m&&(l+=m),r.indexOf(l)===0}e.isEqualOrParent=s;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=h;function f(r,l){return A.isWindows&&r.endsWith(":")&&(r+=P.sep),(0,P.isAbsolute)(r)||(r=(0,P.join)(l,r)),r=(0,P.normalize)(r),A.isWindows?(r=(0,n.rtrim)(r,P.sep),r.endsWith(":")&&(r+=P.sep)):(r=(0,n.rtrim)(r,P.sep),r||(r=P.sep)),r}e.sanitizeFilePath=f;function p(r){const l=(0,P.normalize)(r);return A.isWindows?r.length>3?!1:v(l)&&(r.length===2||l.charCodeAt(2)===92):l===P.posix.sep}e.isRootOrDriveLetter=p;function v(r,l=A.isWindows){return l?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function C(r){return v(r)?r[0]:void 0}e.getDriveLetter=C;function t(r,l,a){return l.length>r.length?-1:r===l?0:(a&&(r=r.toLowerCase(),l=l.toLowerCase()),r.indexOf(l))}e.indexOfPath=t;function c(r){const l=r.split(":");let a,m,E;for(const M of l){const T=Number(M);(0,R.isNumber)(T)?m===void 0?m=T:E===void 0&&(E=T):a=a?[a,M].join(":"):M}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:m!==void 0?m:void 0,column:E!==void 0?E:m!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(r,l,a=8){let m="";for(let M=0;M<a;M++)m+=i.charAt(Math.floor(Math.random()*i.length));let E;return l?E=`${l}-${m}`:E=m,r?(0,P.join)(r,E):E}e.randomPath=o}),define(ie[60],se([0,1,25]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(h){return n(h,0)}e.hash=A;function n(h,f){switch(typeof h){case"object":return h===null?R(349,f):Array.isArray(h)?g(h,f):d(h,f);case"string":return k(h,f);case"boolean":return D(h,f);case"number":return R(h,f);case"undefined":return R(937,f);default:return R(617,f)}}e.doHash=n;function R(h,f){return(f<<5)-f+h|0}e.numberHash=R;function D(h,f){return R(h?433:863,f)}function k(h,f){f=R(149417,f);for(let p=0,v=h.length;p<v;p++)f=R(h.charCodeAt(p),f);return f}e.stringHash=k;function g(h,f){return f=R(104579,f),h.reduce((p,v)=>n(v,p),f)}function d(h,f){return f=R(181387,f),Object.keys(h).sort().reduce((p,v)=>(p=k(v,p),n(h[v],p)),f)}class y{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=n(f,this.g),this.g}}e.Hasher=y;var b;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function I(h,f,p=32){const v=p-f,C=~((1<<v)-1);return(h<<f|(C&h)>>>v)>>>0}function u(h,f=0,p=h.byteLength,v=0){for(let C=0;C<p;C++)h[f+C]=v}function w(h,f,p="0"){for(;h.length<f;)h=p+h;return h}function S(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(p=>p.toString(16).padStart(2,"0")).join(""):w((h>>>0).toString(16),f/4)}e.toHexString=S;class s{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const p=f.length;if(p===0)return;const v=this.p;let C=this.r,t=this.u,c,i;for(t!==0?(c=t,i=-1,t=0):(c=f.charCodeAt(0),i=0);;){let o=c;if(P.isHighSurrogate(c))if(i+1<p){const r=f.charCodeAt(i+1);P.isLowSurrogate(r)?(i++,o=P.computeCodePoint(c,r)):o=65533}else{t=c;break}else P.isLowSurrogate(c)&&(o=65533);if(C=this.w(v,C,o),i++,i<p)c=f.charCodeAt(i);else break}this.r=C,this.u=t}w(f,p,v){return v<128?f[p++]=v:v<2048?(f[p++]=192|(v&1984)>>>6,f[p++]=128|(v&63)>>>0):v<65536?(f[p++]=224|(v&61440)>>>12,f[p++]=128|(v&4032)>>>6,f[p++]=128|(v&63)>>>0):(f[p++]=240|(v&1835008)>>>18,f[p++]=128|(v&258048)>>>12,f[p++]=128|(v&4032)>>>6,f[p++]=128|(v&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),S(this.h)+S(this.l)+S(this.m)+S(this.n)+S(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=s.g,p=this.q;for(let a=0;a<64;a+=4)f.setUint32(a,p.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)f.setUint32(a,I(f.getUint32(a-12,!1)^f.getUint32(a-32,!1)^f.getUint32(a-56,!1)^f.getUint32(a-64,!1),1),!1);let v=this.h,C=this.l,t=this.m,c=this.n,i=this.o,o,r,l;for(let a=0;a<80;a++)a<20?(o=C&t|~C&c,r=1518500249):a<40?(o=C^t^c,r=1859775393):a<60?(o=C&t|C&c|t&c,r=2400959708):(o=C^t^c,r=3395469782),l=I(v,5)+o+i+r+f.getUint32(a*4,!1)&4294967295,i=c,c=t,t=I(C,30),C=v,v=l;this.h=this.h+v&4294967295,this.l=this.l+C&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+i&4294967295}}s.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=s}),define(ie[73],se([0,1,25]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(n){n[n.Ignore=0]="Ignore",n[n.Info=1]="Info",n[n.Warning=2]="Warning",n[n.Error=3]="Error"})(A||(A={})),function(n){const R="error",D="warning",k="warn",g="info",d="ignore";function y(I){return I?P.equalsIgnoreCase(R,I)?n.Error:P.equalsIgnoreCase(D,I)||P.equalsIgnoreCase(k,I)?n.Warning:P.equalsIgnoreCase(g,I)?n.Info:n.Ignore:n.Ignore}n.fromValue=y;function b(I){switch(I){case n.Error:return R;case n.Warning:return D;case n.Info:return g;default:return d}}n.toString=b}(A||(A={})),e.default=A}),define(ie[61],se([0,1,26,25]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class n{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const w=u.charCodeAt(0),S=this.b.charCodeAt(this.c);return w-S}value(){return this.b[this.c]}}e.StringIterator=n;class R{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,A.compareSubstring)(u,this.b,0,u.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class D{constructor(u=!0,w=!0){this.f=u,this.g=w}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let w=u.length-1;w>=0;w--,this.c--){const S=this.b.charCodeAt(w);if(!(S===47||this.f&&S===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,A.compareSubstring)(u,this.b,0,u.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var k;(function(I){I[I.Scheme=1]="Scheme",I[I.Authority=2]="Authority",I[I.Path=3]="Path",I[I.Query=4]="Query",I[I.Fragment=5]="Fragment"})(k||(k={}));class g{constructor(u,w){this.f=u,this.g=w,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(u,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,A.compare)(u,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=g;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(I){I[I.Left=-1]="Left",I[I.Mid=0]="Mid",I[I.Right=1]="Right"})(y||(y={}));class b{static forUris(u=()=>!1,w=()=>!1){return new b(new g(u,w))}static forPaths(u=!1){return new b(new D(void 0,!u))}static forStrings(){return new b(new n)}static forConfigKeys(){return new b(new R)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,w){if(w){const S=w.slice(0);(0,P.shuffle)(S);for(const s of S)this.set(s,u)}else{const S=u.slice(0);(0,P.shuffle)(S);for(const s of S)this.set(s[0],s[1])}}set(u,w){const S=this.b.reset(u);let s;this.c||(this.c=new d,this.c.segment=S.value());const h=[];for(s=this.c;;){const p=S.cmp(s.segment);if(p>0)s.left||(s.left=new d,s.left.segment=S.value()),h.push([-1,s]),s=s.left;else if(p<0)s.right||(s.right=new d,s.right.segment=S.value()),h.push([1,s]),s=s.right;else if(S.hasNext())S.next(),s.mid||(s.mid=new d,s.mid.segment=S.value()),h.push([0,s]),s=s.mid;else break}const f=s.value;s.value=w,s.key=u;for(let p=h.length-1;p>=0;p--){const v=h[p][1];v.updateHeight();const C=v.balanceFactor();if(C<-1||C>1){const t=h[p][0],c=h[p+1][0];if(t===1&&c===1)h[p][1]=v.rotateLeft();else if(t===-1&&c===-1)h[p][1]=v.rotateRight();else if(t===1&&c===-1)v.right=h[p+1][1]=h[p+1][1].rotateRight(),h[p][1]=v.rotateLeft();else if(t===-1&&c===1)v.left=h[p+1][1]=h[p+1][1].rotateLeft(),h[p][1]=v.rotateRight();else throw new Error;if(p>0)switch(h[p-1][0]){case-1:h[p-1][1].left=h[p][1];break;case 1:h[p-1][1].right=h[p][1];break;case 0:h[p-1][1].mid=h[p][1];break}else this.c=h[0][1]}}return f}get(u){return this.d(u)?.value}d(u){const w=this.b.reset(u);let S=this.c;for(;S;){const s=w.cmp(S.segment);if(s>0)S=S.left;else if(s<0)S=S.right;else if(w.hasNext())w.next(),S=S.mid;else break}return S}has(u){const w=this.d(u);return!(w?.value===void 0&&w?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,w){const S=this.b.reset(u),s=[];let h=this.c;for(;h;){const f=S.cmp(h.segment);if(f>0)s.push([-1,h]),h=h.left;else if(f<0)s.push([1,h]),h=h.right;else if(S.hasNext())S.next(),s.push([0,h]),h=h.mid;else break}if(!!h){if(w?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const f=this.f(h.right);if(f.key){const{key:p,value:v,segment:C}=f;this.e(f.key,!1),h.key=p,h.value=v,h.segment=C}}else{const f=h.left??h.right;if(s.length>0){const[p,v]=s[s.length-1];switch(p){case-1:v.left=f;break;case 0:v.mid=f;break;case 1:v.right=f;break}}else this.c=f}for(let f=s.length-1;f>=0;f--){const p=s[f][1];p.updateHeight();const v=p.balanceFactor();if(v>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),s[f][1]=p.rotateLeft()):v<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),s[f][1]=p.rotateRight()),f>0)switch(s[f-1][0]){case-1:s[f-1][1].left=s[f][1];break;case 1:s[f-1][1].right=s[f][1];break;case 0:s[f-1][1].mid=s[f][1];break}else this.c=s[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const w=this.b.reset(u);let S=this.c,s;for(;S;){const h=w.cmp(S.segment);if(h>0)S=S.left;else if(h<0)S=S.right;else if(w.hasNext())w.next(),s=S.value||s,S=S.mid;else break}return S&&S.value||s}findSuperstr(u){return this.g(u,!1)}g(u,w){const S=this.b.reset(u);let s=this.c;for(;s;){const h=S.cmp(s.segment);if(h>0)s=s.left;else if(h<0)s=s.right;else if(S.hasNext())S.next(),s=s.mid;else return s.mid?this.h(s.mid):w?s.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[w,S]of this)u(S,w)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const w=[];return this.j(u,w),w[Symbol.iterator]()}j(u,w){!u||(u.left&&this.j(u.left,w),u.value&&w.push([u.key,u.value]),u.mid&&this.j(u.mid,w),u.right&&this.j(u.right,w))}_isBalanced(){const u=w=>{if(!w)return!0;const S=w.balanceFactor();return S<-1||S>1?!1:u(w.left)&&u(w.right)};return u(this.c)}}e.TernarySearchTree=b}),define(ie[8],se([0,1,9,4]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const n=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function k(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!n.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(i,o){return!i&&!o?"file":i}function d(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==b&&(o=b+o):o=b;break}return o}const y="",b="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(o){return o instanceof u?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,r,l,a,m,E=!1){typeof o=="object"?(this.scheme=o.scheme||y,this.authority=o.authority||y,this.path=o.path||y,this.query=o.query||y,this.fragment=o.fragment||y):(this.scheme=g(o,E),this.authority=r||y,this.path=d(this.scheme,l||y),this.query=a||y,this.fragment=m||y,k(this,E))}get fsPath(){return p(this,!1)}with(o){if(!o)return this;let{scheme:r,authority:l,path:a,query:m,fragment:E}=o;return r===void 0?r=this.scheme:r===null&&(r=y),l===void 0?l=this.authority:l===null&&(l=y),a===void 0?a=this.path:a===null&&(a=y),m===void 0?m=this.query:m===null&&(m=y),E===void 0?E=this.fragment:E===null&&(E=y),r===this.scheme&&l===this.authority&&a===this.path&&m===this.query&&E===this.fragment?this:new S(r,l,a,m,E)}static parse(o,r=!1){const l=I.exec(o);return l?new S(l[2]||y,c(l[4]||y),c(l[5]||y),c(l[7]||y),c(l[9]||y),r):new S(y,y,y,y,y)}static file(o){let r=y;if(A.isWindows&&(o=o.replace(/\\/g,b)),o[0]===b&&o[1]===b){const l=o.indexOf(b,2);l===-1?(r=o.substring(2),o=b):(r=o.substring(2,l),o=o.substring(l)||b)}return new S("file",r,o,y,y)}static from(o){const r=new S(o.scheme,o.authority,o.path,o.query,o.fragment);return k(r,!0),r}static joinPath(o,...r){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return A.isWindows&&o.scheme==="file"?l=u.file(P.win32.join(p(o,!0),...r)).path:l=P.posix.join(o.path,...r),o.with({path:l})}toString(o=!1){return v(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof u)return o;{const r=new S(o);return r._formatted=o.external,r._fsPath=o._sep===w?o.fsPath:null,r}}else return o}}e.URI=u;const w=A.isWindows?1:void 0;class S extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(o=!1){return o?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=w),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,o,r){let l,a=-1;for(let m=0;m<i.length;m++){const E=i.charCodeAt(m);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||o&&E===47||r&&E===91||r&&E===93||r&&E===58)a!==-1&&(l+=encodeURIComponent(i.substring(a,m)),a=-1),l!==void 0&&(l+=i.charAt(m));else{l===void 0&&(l=i.substr(0,m));const M=s[E];M!==void 0?(a!==-1&&(l+=encodeURIComponent(i.substring(a,m)),a=-1),l+=M):a===-1&&(a=m)}}return a!==-1&&(l+=encodeURIComponent(i.substring(a))),l!==void 0?l:i}function f(i){let o;for(let r=0;r<i.length;r++){const l=i.charCodeAt(r);l===35||l===63?(o===void 0&&(o=i.substr(0,r)),o+=s[l]):o!==void 0&&(o+=i[r])}return o!==void 0?o:i}function p(i,o){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,A.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=p;function v(i,o){const r=o?f:h;let l="",{scheme:a,authority:m,path:E,query:M,fragment:T}=i;if(a&&(l+=a,l+=":"),(m||a==="file")&&(l+=b,l+=b),m){let N=m.indexOf("@");if(N!==-1){const z=m.substr(0,N);m=m.substr(N+1),N=z.lastIndexOf(":"),N===-1?l+=r(z,!1,!1):(l+=r(z.substr(0,N),!1,!1),l+=":",l+=r(z.substr(N+1),!1,!0)),l+="@"}m=m.toLowerCase(),N=m.lastIndexOf(":"),N===-1?l+=r(m,!1,!0):(l+=r(m.substr(0,N),!1,!0),l+=m.substr(N))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const N=E.charCodeAt(1);N>=65&&N<=90&&(E=`/${String.fromCharCode(N+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const N=E.charCodeAt(0);N>=65&&N<=90&&(E=`${String.fromCharCode(N+32)}:${E.substr(2)}`)}l+=r(E,!0,!1)}return M&&(l+="?",l+=r(M,!1,!1)),T&&(l+="#",l+=o?T:h(T,!1,!1)),l}function C(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+C(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(t)?i.replace(t,o=>C(o)):i}}),define(ie[148],se([0,1,8]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(d){const y=d;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=A;function n(d){const y=[];let b;try{const I=JSON.parse(d.arguments),u=I[I.length-1];u&&u.__$stack&&(I.pop(),b=u.__$stack),y.push(...I)}catch{y.push("Unable to log remote console arguments",d.arguments)}return{args:y,stack:b}}e.parse=n;function R(d){if(typeof d!="string")return R(n(d).stack);const y=d;if(y){const b=D(y),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(I&&I.length===4)return{uri:P.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=R;function D(d){if(!d)return d;const y=d.indexOf(`
`);return y===-1?d:d.substring(0,y)}function k(d,y){const{args:b,stack:I}=n(d),u=typeof b[0]=="string"&&b.length===1;let w=D(I);w&&(w=`(${w.trim()})`);let S=[];if(typeof b[0]=="string"?w&&u?S=[`%c[${y}] %c${b[0]} %c${w}`,g("blue"),g(""),g("grey")]:S=[`%c[${y}] %c${b[0]}`,g("blue"),g(""),...b.slice(1)]:S=[`%c[${y}]%`,g("blue"),...b],w&&!u&&S.push(w),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,S)}e.log=k;function g(d){return`color: ${d}`}}),define(ie[83],se([0,1,17,25,8]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(d){return JSON.stringify(d,k)}e.stringify=R;function D(d){let y=JSON.parse(d);return y=g(y),y}e.parse=D;function k(d,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,A.regExpFlags)(y)}:y}function g(d,y=0){if(!d||y>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return n.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 16:return new Date(d.source)}if(d instanceof P.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let b=0;b<d.length;++b)d[b]=g(d[b],y+1);else for(const b in d)Object.hasOwnProperty.call(d,b)&&(d[b]=g(d[b],y+1))}return d}e.revive=g}),define(ie[14],se([0,1,13,4,8]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractive="vscode-interactive",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(y){this.d=y}setDelegate(y){this.e=y}setServerRootPath(y){this.f=`${y}/${R.vscodeRemoteResource}`}set(y,b,I){this.a[y]=b,this.b[y]=I}setConnectionToken(y,b){this.c[y]=b}getPreferredWebSchema(){return this.d}rewrite(y){if(this.e)try{return this.e(y)}catch(s){return P.onUnexpectedError(s),y}const b=y.authority;let I=this.a[b];I&&I.indexOf(":")!==-1&&I.indexOf("[")===-1&&(I=`[${I}]`);const u=this.b[b],w=this.c[b];let S=`path=${encodeURIComponent(y.path)}`;return typeof w=="string"&&(S+=`&${e.connectionTokenQueryName}=${encodeURIComponent(w)}`),n.URI.from({scheme:A.isWeb?this.d:R.vscodeRemoteResource,authority:`${I}:${u}`,path:this.f,query:S})}}e.RemoteAuthorities=new D,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(y){const b=this.b(y,X);return this.uriToBrowserUri(b)}uriToBrowserUri(y){return y.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===R.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${R.vscodeFileResource}://${k.a}`)?y.with({scheme:R.vscodeFileResource,authority:y.authority||k.a,query:null,fragment:null}):y}asFileUri(y){const b=this.b(y,X);return this.uriToFileUri(b)}uriToFileUri(y){return y.scheme===R.vscodeFileResource?y.with({scheme:R.file,authority:y.authority!==k.a?y.authority:null,query:null,fragment:null}):y}b(y,b){return n.URI.isUri(y)?y:n.URI.parse(b.toUrl(y))}}k.a="vscode-app",e.FileAccess=new k;var g;(function(d){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(y.get("3"));const b="vscode-coi";function I(w){let S;typeof w=="string"?S=new URL(w).searchParams:w instanceof URL?S=w.searchParams:n.URI.isUri(w)&&(S=new URL(w.toString(!0)).searchParams);const s=S?.get(b);if(!!s)return y.get(s)}d.getHeadersFromQuery=I;function u(w,S,s){if(!globalThis.crossOriginIsolated)return;const h=S&&s?"3":s?"2":"1";w instanceof URLSearchParams?w.set(b,h):w[b]=h}d.addSearchParam=u})(g=e.COI||(e.COI={}))}),define(ie[18],se([0,1,32,14,9,4,25,8]),function(X,e,P,A,n,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(u){return(0,k.uriToFsPath)(u,!0)}e.originalFSPath=g;class d{constructor(w){this.a=w}compare(w,S,s=!1){return w===S?0:(0,D.compare)(this.getComparisonKey(w,s),this.getComparisonKey(S,s))}isEqual(w,S,s=!1){return w===S?!0:!w||!S?!1:this.getComparisonKey(w,s)===this.getComparisonKey(S,s)}getComparisonKey(w,S=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,S,s=!1){if(w.scheme===S.scheme){if(w.scheme===A.Schemas.file)return P.isEqualOrParent(g(w),g(S),this.a(w))&&w.query===S.query&&(s||w.fragment===S.fragment);if((0,e.isEqualAuthority)(w.authority,S.authority))return P.isEqualOrParent(w.path,S.path,this.a(w),"/")&&w.query===S.query&&(s||w.fragment===S.fragment)}return!1}joinPath(w,...S){return k.URI.joinPath(w,...S)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return n.posix.basename(w.path)}extname(w){return n.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let S;return w.scheme===A.Schemas.file?S=k.URI.file(n.dirname(g(w))).path:(S=n.posix.dirname(w.path),w.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),S="/")),w.with({path:S})}normalizePath(w){if(!w.path.length)return w;let S;return w.scheme===A.Schemas.file?S=k.URI.file(n.normalize(g(w))).path:S=n.posix.normalize(w.path),w.with({path:S})}relativePath(w,S){if(w.scheme!==S.scheme||!(0,e.isEqualAuthority)(w.authority,S.authority))return;if(w.scheme===A.Schemas.file){const f=n.relative(g(w),g(S));return R.isWindows?P.toSlashes(f):f}let s=w.path||"/";const h=S.path||"/";if(this.a(w)){let f=0;for(const p=Math.min(s.length,h.length);f<p&&!(s.charCodeAt(f)!==h.charCodeAt(f)&&s.charAt(f).toLowerCase()!==h.charAt(f).toLowerCase());f++);s=h.substr(0,f)+s.substr(f)}return n.posix.relative(s,h)}resolvePath(w,S){if(w.scheme===A.Schemas.file){const s=k.URI.file(n.resolve(g(w),S));return w.with({authority:s.authority,path:s.path})}return S=P.toPosixPath(S),w.with({path:n.posix.resolve(w.path,S)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,S){return w===S||w!==void 0&&S!==void 0&&(0,D.equalsIgnoreCase)(w,S)}hasTrailingPathSeparator(w,S=n.sep){if(w.scheme===A.Schemas.file){const s=g(w);return s.length>P.getRoot(s).length&&s[s.length-1]===S}else{const s=w.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,S=n.sep){return(0,e.hasTrailingPathSeparator)(w,S)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,S=n.sep){let s=!1;if(w.scheme===A.Schemas.file){const h=g(w);s=h!==void 0&&h.length===P.getRoot(h).length&&h[h.length-1]===S}else{S="/";const h=w.path;s=h.length===1&&h.charCodeAt(h.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(w,S)?w.with({path:w.path+"/"}):w}}e.ExtUri=d,e.extUri=new d(()=>!1),e.extUriBiasedIgnorePathCase=new d(u=>u.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new d(u=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(u,w){const S=[];for(let s=0;s<u.length;s++){const h=w(u[s]);u.some((f,p)=>p===s?!1:(0,e.isEqualOrParent)(h,w(f)))||S.push(u[s])}return S}e.distinctParents=y;var b;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function w(S){const s=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(p=>{const[v,C]=p.split(":");v&&C&&s.set(v,C)});const f=S.path.substring(0,S.path.indexOf(";"));return f&&s.set(u.META_DATA_MIME,f),s}u.parseMetaData=w})(b=e.DataUri||(e.DataUri={}));function I(u,w,S){if(w){let s=u.path;return s&&s[0]!==n.posix.sep&&(s=n.posix.sep+s),u.with({scheme:S,authority:w,path:s})}return u.with({scheme:S})}e.toLocalResource=I}),define(ie[7],se([0,1,22,13,3,2,18,4,133]),function(X,e,P,A,n,R,D,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(L){return!!L&&typeof L.then=="function"}e.isThenable=d;function y(L){const W=new P.CancellationTokenSource,U=L(W.token),j=new Promise((q,J)=>{const B=W.token.onCancellationRequested(()=>{B.dispose(),W.dispose(),J(new A.CancellationError)});Promise.resolve(U).then(Y=>{B.dispose(),W.dispose(),q(Y)},Y=>{B.dispose(),W.dispose(),J(Y)})});return new class{cancel(){W.cancel()}then(q,J){return j.then(q,J)}catch(q){return this.then(void 0,q)}finally(q){return j.finally(q)}}}e.createCancelablePromise=y;function b(L,W,U){return new Promise((j,q)=>{const J=W.onCancellationRequested(()=>{J.dispose(),j(U)});L.then(j,q).finally(()=>J.dispose())})}e.raceCancellation=b;function I(L,W){return new Promise((U,j)=>{const q=W.onCancellationRequested(()=>{q.dispose(),j(new A.CancellationError)});L.then(U,j).finally(()=>q.dispose())})}e.raceCancellationError=I;async function u(L){let W=-1;const U=L.map((q,J)=>q.then(B=>(W=J,B))),j=await Promise.race(U);return L.forEach((q,J)=>{J!==W&&q.cancel()}),j}e.raceCancellablePromises=u;function w(L,W,U){let j;const q=setTimeout(()=>{j?.(void 0),U?.()},W);return Promise.race([L.finally(()=>clearTimeout(q)),new Promise(J=>j=J)])}e.raceTimeout=w;function S(L){return new Promise((W,U)=>{const j=L();d(j)?j.then(W,U):W(j)})}e.asPromise=S;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(W){if(this.a){if(this.d=W,!this.b){const U=()=>{this.b=null;const j=this.queue(this.d);return this.d=null,j};this.b=new Promise(j=>{this.a.then(U,U).then(j)})}return new Promise((U,j)=>{this.b.then(U,j)})}return this.a=W(),new Promise((U,j)=>{this.a.then(q=>{this.a=null,U(q)},q=>{this.a=null,j(q)})})}}e.Throttler=s;class h{constructor(){this.a=Promise.resolve(null)}queue(W){return this.a=this.a.then(()=>W(),()=>W())}}e.Sequencer=h;class f{constructor(){this.a=new Map}queue(W,U){const q=(this.a.get(W)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(W)===q&&this.a.delete(W)});return this.a.set(W,q),q}}e.SequencerByKey=f;const p=(L,W)=>{let U=!0;const j=setTimeout(()=>{U=!1,W()},L);return{isTriggered:()=>U,dispose:()=>{clearTimeout(j),U=!1}}},v=L=>{let W=!0;return queueMicrotask(()=>{W&&(W=!1,L())}),{isTriggered:()=>W,dispose:()=>{W=!1}}};class C{constructor(W){this.defaultDelay=W,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(W,U=this.defaultDelay){this.g=W,this.h(),this.b||(this.b=new Promise((q,J)=>{this.d=q,this.f=J}).then(()=>{if(this.b=null,this.d=null,this.g){const q=this.g;return this.g=null,q()}}));const j=()=>{this.a=null,this.d?.(null)};return this.a=U===g.MicrotaskDelay?v(j):p(U,j),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=C;class t{constructor(W){this.a=new C(W),this.b=new s}trigger(W,U){return this.a.trigger(()=>this.b.queue(W),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class c{constructor(){this.a=!1,this.b=new Promise((W,U)=>{this.d=W})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=c;class i extends c{constructor(W){super(),this.f=setTimeout(()=>this.open(),W)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function o(L,W){return W?new Promise((U,j)=>{const q=setTimeout(()=>{J.dispose(),U()},L),J=W.onCancellationRequested(()=>{clearTimeout(q),J.dispose(),j(new A.CancellationError)})}):y(U=>o(L,U))}e.timeout=o;function r(L,W=0){const U=setTimeout(L,W);return(0,R.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=r;function l(L){const W=[];let U=0;const j=L.length;function q(){return U<j?L[U++]():null}function J(B){B!=null&&W.push(B);const Y=q();return Y?Y.then(J):Promise.resolve(W)}return Promise.resolve(null).then(J)}e.sequence=l;function a(L,W=j=>!!j,U=null){let j=0;const q=L.length,J=()=>{if(j>=q)return Promise.resolve(U);const B=L[j++];return Promise.resolve(B()).then(Z=>W(Z)?Promise.resolve(Z):J())};return J()}e.first=a;function m(L,W=j=>!!j,U=null){if(L.length===0)return Promise.resolve(U);let j=L.length;const q=()=>{j=-1;for(const J of L)J.cancel?.()};return new Promise((J,B)=>{for(const Y of L)Y.then(Z=>{--j>=0&&W(Z)?(q(),J(Z)):j===0&&J(U)}).catch(Z=>{--j>=0&&(q(),B(Z))})})}e.firstParallel=m;class E{constructor(W){this.a=0,this.d=W,this.f=[],this.b=0,this.g=new n.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(W){return this.a++,new Promise((U,j)=>{this.f.push({factory:W,c:U,e:j}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const W=this.f.shift();this.b++;const U=W.factory();U.then(W.c,W.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=E;class M extends E{constructor(){super(1)}}e.Queue=M;class T{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const W=new H;return this.b.add(W),W.p}d(){for(const[,W]of this.a)if(W.size>0)return!1;return!0}queueFor(W,U=D.extUri){const j=U.getComparisonKey(W);let q=this.a.get(j);return q||(q=new M,n.Event.once(q.onDrained)(()=>{q?.dispose(),this.a.delete(j),this.f()}),this.a.set(j,q)),q}f(){!this.d()||this.g()}g(){for(const W of this.b)W.complete();this.b.clear()}dispose(){for(const[,W]of this.a)W.dispose();this.a.clear(),this.g()}}e.ResourceQueue=T;class N{constructor(W,U){this.a=-1,typeof W=="function"&&typeof U=="number"&&this.setIfNotSet(W,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(W,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,W()},U)}setIfNotSet(W,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,W()},U))}}e.TimeoutTimer=N;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(W,U){this.cancel(),this.a=setInterval(()=>{W()},U)}}e.IntervalTimer=z;class K{constructor(W,U){this.b=-1,this.a=W,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(W=this.d){this.cancel(),this.b=setTimeout(this.f,W)}get delay(){return this.d}set delay(W){this.d=W}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class ae{constructor(W,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=W,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(W=this.b){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(W/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=ae;class le extends K{constructor(W,U){super(W,U),this.j=[]}work(W){this.j.push(W),this.isScheduled()||this.schedule()}h(){const W=this.j;this.j=[],this.a?.(W)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=le;class te extends R.Disposable{constructor(W,U){super(),this.g=W,this.h=U,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(W){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+W.length>this.g.maxBufferedWork)return!1}else if(this.pending+W.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of W)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=te,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=L=>{(0,k.setTimeout0)(()=>{if(W)return;const U=Date.now()+15;L(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.runWhenIdle=(L,W)=>{const U=requestIdleCallback(L,typeof W=="number"?{timeout:W}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(U))}}}}();class F{constructor(W){this.d=!1,this.a=()=>{try{this.f=W()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function $(L,W,U){let j;for(let q=0;q<U;q++)try{return await L()}catch(J){j=J,await o(W)}throw j}e.retry=$;class V{hasPending(W){return this.a?typeof W=="number"?this.a.taskId===W:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(W,U,j){return this.a={taskId:W,cancel:()=>j?.(),promise:U},U.then(()=>this.d(W),()=>this.d(W)),U}d(W){this.a&&W===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const W=this.b;this.b=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this.b)this.b.run=W;else{let U,j;const q=new Promise((J,B)=>{U=J,j=B});this.b={run:W,promise:q,promiseResolve:U,promiseReject:j}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=V;class x{constructor(W,U=()=>Date.now()){this.d=W,this.f=U,this.a=0,this.b=0}increment(){const W=this.f();return W-this.a>this.d&&(this.a=W,this.b=0),this.b++,this.b}}e.IntervalCounter=x;class H{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((W,U)=>{this.a=W,this.b=U})}complete(W){return new Promise(U=>{this.a(W),this.f=!0,U()})}error(W){return new Promise(U=>{this.b(W),this.d=!0,U()})}cancel(){new Promise(W=>{this.b(new A.CancellationError),this.d=!0,W()})}}e.DeferredPromise=H;var O;(function(L){async function W(j){let q;const J=await Promise.all(j.map(B=>B.then(Y=>Y,Y=>{q||(q=Y)})));if(typeof q<"u")throw q;return J}L.settled=W;function U(j){return new Promise(async(q,J)=>{try{await j(q,J)}catch(B){J(B)}})}L.withAsyncBody=U})(O=e.Promises||(e.Promises={}));var G;(function(L){L[L.Initial=0]="Initial",L[L.DoneOK=1]="DoneOK",L[L.DoneError=2]="DoneError"})(G||(G={}));class _{static fromArray(W){return new _(U=>{U.emitMany(W)})}static fromPromise(W){return new _(async U=>{U.emitMany(await W)})}static fromPromises(W){return new _(async U=>{await Promise.all(W.map(async j=>U.emitOne(await j)))})}static merge(W){return new _(async U=>{await Promise.all(W.map(async j=>{for await(const q of j)U.emitOne(q)}))})}constructor(W){this.a=0,this.b=[],this.d=null,this.f=new n.Emitter,queueMicrotask(async()=>{const U={emitOne:j=>this.g(j),emitMany:j=>this.h(j),reject:j=>this.k(j)};try{await Promise.resolve(W(U)),this.j()}catch(j){this.k(j)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let W=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(W<this.b.length)return{done:!1,value:this.b[W++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(W,U){return new _(async j=>{for await(const q of W)j.emitOne(U(q))})}map(W){return _.map(this,W)}static filter(W,U){return new _(async j=>{for await(const q of W)U(q)&&j.emitOne(q)})}filter(W){return _.filter(this,W)}static coalesce(W){return _.filter(W,U=>!!U)}coalesce(){return _.coalesce(this)}static async toPromise(W){const U=[];for await(const j of W)U.push(j);return U}toPromise(){return _.toPromise(this)}g(W){this.a===0&&(this.b.push(W),this.f.fire())}h(W){this.a===0&&(this.b=this.b.concat(W),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(W){this.a===0&&(this.a=2,this.d=W,this.f.fire())}}_.EMPTY=_.fromArray([]),e.AsyncIterableObject=_;class re extends _{constructor(W,U){super(U),this.l=W}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=re;function oe(L){const W=new P.CancellationTokenSource,U=L(W.token);return new re(W,async j=>{const q=W.token.onCancellationRequested(()=>{q.dispose(),W.dispose(),j.reject(new A.CancellationError)});try{for await(const J of U){if(W.token.isCancellationRequested)return;j.emitOne(J)}q.dispose(),W.dispose()}catch(J){q.dispose(),W.dispose(),j.reject(J)}})}e.createCancelableAsyncIterable=oe}),define(ie[101],se([0,1,26,7,32,35,9,4,25]),function(X,e,P,A,n,R,D,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function d(){return Object.create(null)}e.getEmptyExpression=d,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",b="[^/\\\\]",I=/\//g;function u(x,H){switch(x){case 0:return"";case 1:return`${b}*?`;default:return`(?:${y}|${b}+${y}${H?`|${y}${b}+`:""})*?`}}function w(x,H){if(!x)return[];const O=[];let G=!1,_=!1,re="";for(const oe of x){switch(oe){case H:if(!G&&!_){O.push(re),re="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":_=!0;break;case"]":_=!1;break}re+=oe}return re&&O.push(re),O}e.splitGlobAware=w;function S(x){if(!x)return"";let H="";const O=w(x,e.GLOB_SPLIT);if(O.every(G=>G===e.GLOBSTAR))H=".*";else{let G=!1;O.forEach((_,re)=>{if(_===e.GLOBSTAR){if(G)return;H+=u(2,re===O.length-1)}else{let oe=!1,L="",W=!1,U="";for(const j of _){if(j!=="}"&&oe){L+=j;continue}if(W&&(j!=="]"||!U)){let q;j==="-"?q=j:(j==="^"||j==="!")&&!U?q="^":j===e.GLOB_SPLIT?q="":q=(0,g.escapeRegExpCharacters)(j),U+=q;continue}switch(j){case"{":oe=!0;continue;case"[":W=!0;continue;case"}":{H+=`(?:${w(L,",").map(B=>S(B)).join("|")})`,oe=!1,L="";break}case"]":{H+="["+U+"]",W=!1,U="";break}case"?":H+=b;continue;case"*":H+=u(1);continue;default:H+=(0,g.escapeRegExpCharacters)(j)}}re<O.length-1&&(O[re+1]!==e.GLOBSTAR||re+2<O.length)&&(H+=y)}G=_===e.GLOBSTAR})}return H}const s=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),c=function(){return!1},i=function(){return null};function o(x,H){if(!x)return i;let O;typeof x!="string"?O=x.pattern:O=x,O=O.trim();const G=`${O}_${!!H.trimForExclusions}`;let _=t.get(G);if(_)return r(_,x);let re;return s.test(O)?_=a(O.substr(4),O):(re=h.exec(l(O,H)))?_=m(re[1],O):(H.trimForExclusions?p:f).test(O)?_=E(O,H):(re=v.exec(l(O,H)))?_=M(re[1].substr(1),O,!0):(re=C.exec(l(O,H)))?_=M(re[1],O,!1):_=T(O),t.set(G,_),r(_,x)}function r(x,H){if(typeof H=="string")return x;const O=function(G,_){return(0,n.isEqualOrParent)(G,H.base,!k.isLinux)?x((0,g.ltrim)(G.substr(H.base.length),D.sep),_):null};return O.allBasenames=x.allBasenames,O.allPaths=x.allPaths,O.basenames=x.basenames,O.patterns=x.patterns,O}function l(x,H){return H.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function a(x,H){return function(O,G){return typeof O=="string"&&O.endsWith(x)?H:null}}function m(x,H){const O=`/${x}`,G=`\\${x}`,_=function(oe,L){return typeof oe!="string"?null:L?L===x?H:null:oe===x||oe.endsWith(O)||oe.endsWith(G)?H:null},re=[x];return _.basenames=re,_.patterns=[H],_.allBasenames=re,_}function E(x,H){const O=$(x.slice(1,-1).split(",").map(L=>o(L,H)).filter(L=>L!==i),x),G=O.length;if(!G)return i;if(G===1)return O[0];const _=function(L,W){for(let U=0,j=O.length;U<j;U++)if(O[U](L,W))return x;return null},re=O.find(L=>!!L.allBasenames);re&&(_.allBasenames=re.allBasenames);const oe=O.reduce((L,W)=>W.allPaths?L.concat(W.allPaths):L,[]);return oe.length&&(_.allPaths=oe),_}function M(x,H,O){const G=D.sep===D.posix.sep,_=G?x:x.replace(I,D.sep),re=D.sep+_,oe=D.posix.sep+x;let L;return O?L=function(W,U){return typeof W=="string"&&(W===_||W.endsWith(re)||!G&&(W===x||W.endsWith(oe)))?H:null}:L=function(W,U){return typeof W=="string"&&(W===_||!G&&W===x)?H:null},L.allPaths=[(O?"*/":"./")+x],L}function T(x){try{const H=new RegExp(`^${S(x)}$`);return function(O){return H.lastIndex=0,typeof O=="string"&&H.test(O)?x:null}}catch{return i}}function N(x,H,O){return!x||typeof H!="string"?!1:z(x)(H,void 0,O)}e.match=N;function z(x,H={}){if(!x)return c;if(typeof x=="string"||K(x)){const O=o(x,H);if(O===i)return c;const G=function(_,re){return!!O(_,re)};return O.allBasenames&&(G.allBasenames=O.allBasenames),O.allPaths&&(G.allPaths=O.allPaths),G}return te(x,H)}e.parse=z;function K(x){const H=x;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=K;function ae(x){return x.allBasenames||[]}e.getBasenameTerms=ae;function le(x){return x.allPaths||[]}e.getPathTerms=le;function te(x,H){const O=$(Object.getOwnPropertyNames(x).map(L=>F(L,x[L],H)).filter(L=>L!==i)),G=O.length;if(!G)return i;if(!O.some(L=>!!L.requiresSiblings)){if(G===1)return O[0];const L=function(j,q){let J;for(let B=0,Y=O.length;B<Y;B++){const Z=O[B](j,q);if(typeof Z=="string")return Z;(0,A.isThenable)(Z)&&(J||(J=[]),J.push(Z))}return J?(async()=>{for(const B of J){const Y=await B;if(typeof Y=="string")return Y}return null})():null},W=O.find(j=>!!j.allBasenames);W&&(L.allBasenames=W.allBasenames);const U=O.reduce((j,q)=>q.allPaths?j.concat(q.allPaths):j,[]);return U.length&&(L.allPaths=U),L}const _=function(L,W,U){let j,q;for(let J=0,B=O.length;J<B;J++){const Y=O[J];Y.requiresSiblings&&U&&(W||(W=(0,D.basename)(L)),j||(j=W.substr(0,W.length-(0,D.extname)(L).length)));const Z=Y(L,W,j,U);if(typeof Z=="string")return Z;(0,A.isThenable)(Z)&&(q||(q=[]),q.push(Z))}return q?(async()=>{for(const J of q){const B=await J;if(typeof B=="string")return B}return null})():null},re=O.find(L=>!!L.allBasenames);re&&(_.allBasenames=re.allBasenames);const oe=O.reduce((L,W)=>W.allPaths?L.concat(W.allPaths):L,[]);return oe.length&&(_.allPaths=oe),_}function F(x,H,O){if(H===!1)return i;const G=o(x,O);if(G===i)return i;if(typeof H=="boolean")return G;if(H){const _=H.when;if(typeof _=="string"){const re=(oe,L,W,U)=>{if(!U||!G(oe,L))return null;const j=_.replace("$(basename)",()=>W),q=U(j);return(0,A.isThenable)(q)?q.then(J=>J?x:null):q?x:null};return re.requiresSiblings=!0,re}}return G}function $(x,H){const O=x.filter(L=>!!L.basenames);if(O.length<2)return x;const G=O.reduce((L,W)=>{const U=W.basenames;return U?L.concat(U):L},[]);let _;if(H){_=[];for(let L=0,W=G.length;L<W;L++)_.push(H)}else _=O.reduce((L,W)=>{const U=W.patterns;return U?L.concat(U):L},[]);const re=function(L,W){if(typeof L!="string")return null;if(!W){let j;for(j=L.length;j>0;j--){const q=L.charCodeAt(j-1);if(q===47||q===92)break}W=L.substr(j)}const U=G.indexOf(W);return U!==-1?_[U]:null};re.basenames=G,re.patterns=_,re.allBasenames=G;const oe=x.filter(L=>!L.basenames);return oe.push(re),oe}function V(x,H){return(0,P.equals)(x,H,(O,G)=>typeof O=="string"&&typeof G=="string"?O===G:typeof O!="string"&&typeof G!="string"?O.base===G.base&&O.pattern===G.pattern:!1)}e.patternsEquals=V}),define(ie[45],se([0,1,26,32,9,4,18,25]),function(X,e,P,A,n,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function g(i,o){const{os:r,tildify:l,relative:a}=o;if(a){const M=d(i,a,r);if(typeof M=="string")return M}let m=i.fsPath;if(r===1&&!R.isWindows?m=m.replace(/\//g,"\\"):r!==1&&R.isWindows&&(m=m.replace(/\\/g,"/")),r!==1&&l?.userHome){const M=l.userHome.fsPath;let T;i.scheme!==l.userHome.scheme&&i.path.startsWith(n.posix.sep)?T=l.userHome.with({path:i.path}).fsPath:T=i.fsPath,m=I(T,M,r)}return(r===1?n.win32:n.posix).normalize(y(m,r===1))}e.getPathLabel=g;function d(i,o,r){const l=r===1?n.win32:n.posix,a=r===3?D.extUri:D.extUriIgnorePathCase,m=o.getWorkspace(),E=(0,P.firstOrDefault)(m.folders);if(!E)return;i.scheme!==E.uri.scheme&&i.path.startsWith(n.posix.sep)&&(i=E.uri.with({path:i.path}));const M=o.getWorkspaceFolder(i);if(!M)return;let T;if(a.isEqual(M.uri,i)?T="":T=a.relativePath(M.uri,i)??"",T&&(T=l.normalize(T)),m.folders.length>1&&!o.noPrefix){const N=M.name?M.name:a.basenameOrAuthority(M.uri);T=T?`${N} \u2022 ${T}`:N}return T}function y(i,o=R.isWindows){return(0,A.hasDriveLetter)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=y;let b=Object.create(null);function I(i,o,r=R.OS){if(r===1||!i||!o)return i;let l=b.original===o?b.normalized:void 0;l||(l=o,R.isWindows&&(l=(0,A.toSlashes)(l)),l=`${(0,k.rtrim)(l,n.posix.sep)}${n.posix.sep}`,b={original:o,normalized:l});let a=i;return R.isWindows&&(a=(0,A.toSlashes)(a)),(r===3?a.startsWith(l):(0,k.startsWithIgnoreCase)(a,l))?`~/${a.substr(l.length)}`:i}e.tildify=I;function u(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=u;const w="\u2026",S="\\\\",s="~";function h(i,o=n.sep){const r=new Array(i.length);let l=!1;for(let a=0;a<i.length;a++){const m=i[a];if(m===""){r[a]=`.${o}`;continue}if(!m){r[a]=m;continue}l=!0;let E="",M=m;M.indexOf(S)===0?(E=M.substr(0,M.indexOf(S)+S.length),M=M.substr(M.indexOf(S)+S.length)):M.indexOf(o)===0?(E=M.substr(0,M.indexOf(o)+o.length),M=M.substr(M.indexOf(o)+o.length)):M.indexOf(s)===0&&(E=M.substr(0,M.indexOf(s)+s.length),M=M.substr(M.indexOf(s)+s.length));const T=M.split(o);for(let N=1;l&&N<=T.length;N++)for(let z=T.length-N;l&&z>=0;z--){l=!1;let K=T.slice(z,z+N).join(o);for(let ae=0;!l&&ae<i.length;ae++)if(ae!==a&&i[ae]&&i[ae].indexOf(K)>-1){const le=z+N===T.length,te=z>0&&i[ae].indexOf(o)>-1?o+K:K,F=i[ae].endsWith(te);l=!le||F}if(!l){let ae="";(T[0].endsWith(":")||E!=="")&&(z===1&&(z=0,N++,K=T[0]+o+K),z>0&&(ae=T[0]+o),ae=E+ae),z>0&&(ae=ae+w+o),ae=ae+K,z+N<T.length&&(ae=ae+o+w),r[a]=ae}}l&&(r[a]=m)}return r}e.shorten=h;var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function p(i,o=Object.create(null)){const r=[];let l=!1,a="";for(const m of i)if(m==="$"||l&&m==="{")a&&r.push({value:a,type:f.TEXT}),a="",l=!0;else if(m==="}"&&l){const E=o[a];if(typeof E=="string")E.length&&r.push({value:E,type:f.VARIABLE});else if(E){const M=r[r.length-1];(!M||M.type!==f.SEPARATOR)&&r.push({value:E.label,type:f.SEPARATOR})}a="",l=!1}else a+=m;return a&&!l&&r.push({value:a,type:f.TEXT}),r.filter((m,E)=>{if(m.type===f.SEPARATOR){const M=r[E-1],T=r[E+1];return[M,T].every(N=>N&&(N.type===f.VARIABLE||N.type===f.TEXT)&&N.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=p;function v(i,o){return R.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function C(i,o){return R.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,r=>r==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=C;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function c(i){const o=i.indexOf("/")!==-1?n.posix:n.win32,r=o.basename(i),l=o.dirname(i);return r.length?{name:r,parentPath:l}:{name:l,parentPath:""}}e.splitName=c}),define(ie[149],se([0,1,17,8]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(b){return b.toJSON()}class R{constructor(I){this.a=I}transformIncoming(I){const u=this.a.transformIncoming(I);return u===I?I:n(A.URI.from(u))}transformOutgoing(I){const u=this.a.transformOutgoing(I);return u===I?I:n(A.URI.from(u))}transformOutgoingURI(I){const u=this.a.transformOutgoing(I);return u===I?I:A.URI.from(u)}transformOutgoingScheme(I){return this.a.transformOutgoingScheme(I)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function D(b,I,u){if(!b||u>200)return null;if(typeof b=="object"){if(b instanceof A.URI)return I.transformOutgoing(b);for(const w in b)if(Object.hasOwnProperty.call(b,w)){const S=D(b[w],I,u+1);S!==null&&(b[w]=S)}}return null}function k(b,I){const u=D(b,I,0);return u===null?b:u}e.transformOutgoingURIs=k;function g(b,I,u,w){if(!b||w>200)return null;if(typeof b=="object"){if(b.$mid===1)return u?A.URI.revive(I.transformIncoming(b)):I.transformIncoming(b);if(b instanceof P.VSBuffer)return null;for(const S in b)if(Object.hasOwnProperty.call(b,S)){const s=g(b[S],I,u,w+1);s!==null&&(b[S]=s)}}return null}function d(b,I){const u=g(b,I,!1,0);return u===null?b:u}e.transformIncomingURIs=d;function y(b,I){const u=g(b,I,!0,0);return u===null?b:u}e.transformAndReviveIncomingURIs=y}),define(ie[84],se([0,1,27,13,61,31,137]),function(X,e,P,A,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(y){return this.a||(this.a=n.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,b=0;const I=(0,P.networkInterfaces)();for(const u in I){const w=I[u];if(w)for(const{mac:S,internal:s}of w)s||(b+=1,this.c(S.toUpperCase())&&(y+=1))}this.b=b>0?y/b:0}return this.b}};let k;async function g(){return k||(k=(async()=>await d()||R.generateUuid())()),k}e.getMachineId=g;async function d(){try{const y=await new Promise((I,u)=>{X(["crypto"],I,u)}),b=(0,D.getMac)();return y.createHash("sha256").update(b,"utf8").digest("hex")}catch(y){A.onUnexpectedError(y);return}}}),define(ie[23],se([0,1,41,27,150,7,32,80,9,4,18,8]),function(X,e,P,A,n,R,D,k,g,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var I;(function(te){te[te.UNLINK=0]="UNLINK",te[te.MOVE=1]="MOVE"})(I=e.RimRafMode||(e.RimRafMode={}));async function u(te,F=I.UNLINK){if((0,D.isRootOrDriveLetter)(te))throw new Error("rimraf - will refuse to recursively delete root");return F===I.UNLINK?S(te):w(te)}async function w(te){try{const F=(0,D.randomPath)((0,A.tmpdir)());try{await P.promises.rename(te,F)}catch($){return $.code==="ENOENT"?void 0:S(te)}S(F).catch($=>{})}catch(F){if(F.code!=="ENOENT")throw F}}async function S(te){return(0,n.promisify)(P.rm)(te,{recursive:!0,force:!0,maxRetries:3})}function s(te){if((0,D.isRootOrDriveLetter)(te))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(te,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=s;async function h(te,F){return v(await(F?f(te):(0,n.promisify)(P.readdir)(te)))}async function f(te){try{return await(0,n.promisify)(P.readdir)(te,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const F=[],$=await h(te);for(const V of $){let x=!1,H=!1,O=!1;try{const G=await e.Promises.lstat((0,g.join)(te,V));x=G.isFile(),H=G.isDirectory(),O=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}F.push({name:V,isFile:()=>x,isDirectory:()=>H,isSymbolicLink:()=>O})}return F}function p(te){return v(P.readdirSync(te))}e.readdirSync=p;function v(te){return te.map(F=>typeof F=="string"?d.isMacintosh?(0,k.normalizeNFC)(F):F:(F.name=d.isMacintosh?(0,k.normalizeNFC)(F.name):F.name,F))}async function C(te){const F=await h(te),$=[];for(const V of F)await c.existsDirectory((0,g.join)(te,V))&&$.push(V);return $}function t(te,F=1e3){return new Promise($=>{let V=!1;const x=setInterval(()=>{V||(V=!0,P.access(te,H=>{V=!1,H&&(clearInterval(x),$(void 0))}))},F)})}e.whenDeleted=t;var c;(function(te){async function F(x){let H;try{if(H=await e.Promises.lstat(x),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(d.isWindows&&O.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw G}throw O}}te.stat=F;async function $(x){try{const{stat:H,symbolicLink:O}=await te.stat(x);return H.isFile()&&O?.dangling!==!0}catch{}return!1}te.existsFile=$;async function V(x){try{const{stat:H,symbolicLink:O}=await te.stat(x);return H.isDirectory()&&O?.dangling!==!0}catch{}return!1}te.existsDirectory=V})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function o(te,F,$){return i.queueFor(b.URI.file(te),y.extUriBiasedIgnorePathCase).queue(()=>{const V=E($);return new Promise((x,H)=>a(te,F,V,O=>O?H(O):x()))})}let r=!0;function l(te){r=te}e.configureFlushOnWrite=l;function a(te,F,$,V){if(!r)return P.writeFile(te,F,{mode:$.mode,flag:$.flag},V);P.open(te,$.flag,$.mode,(x,H)=>{if(x)return V(x);P.writeFile(H,F,O=>{if(O)return P.close(H,()=>V(O));P.fdatasync(H,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),l(!1)),P.close(H,_=>V(_))))})})}function m(te,F,$){const V=E($);if(!r)return P.writeFileSync(te,F,{mode:V.mode,flag:V.flag});const x=P.openSync(te,V.flag,V.mode);try{P.writeFileSync(x,F);try{P.fdatasyncSync(x)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),l(!1)}}finally{P.closeSync(x)}}e.writeFileSync=m;function E(te){return te?{mode:typeof te.mode=="number"?te.mode:438,flag:typeof te.flag=="string"?te.flag:"w"}:{mode:438,flag:"w"}}async function M(te,F){if(te!==F)try{await e.Promises.rename(te,F)}catch($){if(te.toLowerCase()!==F.toLowerCase()&&$.code==="EXDEV"||te.endsWith("."))await T(te,F,{preserveSymlinks:!1}),await u(te,I.MOVE);else throw $}}async function T(te,F,$){return z(te,F,{root:{source:te,target:F},options:$,handledSourcePaths:new Set})}const N=511;async function z(te,F,$){if($.handledSourcePaths.has(te))return;$.handledSourcePaths.add(te);const{stat:V,symbolicLink:x}=await c.stat(te);if(x){if($.options.preserveSymlinks)try{return await le(te,F,$)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(x.dangling)return}return V.isDirectory()?K(te,F,V.mode&N,$):ae(te,F,V.mode&N)}async function K(te,F,$,V){await e.Promises.mkdir(F,{recursive:!0,mode:$});const x=await h(te);for(const H of x)await z((0,g.join)(te,H),(0,g.join)(F,H),V)}async function ae(te,F,$){await e.Promises.copyFile(te,F),await e.Promises.chmod(F,$)}async function le(te,F,$){let V=await e.Promises.readlink(te);(0,D.isEqualOrParent)(V,$.root.source,!d.isLinux)&&(V=(0,g.join)($.root.target,V.substr($.root.source.length+1))),await e.Promises.symlink(V,F)}e.Promises=new class{get access(){return(0,n.promisify)(P.access)}get stat(){return(0,n.promisify)(P.stat)}get lstat(){return(0,n.promisify)(P.lstat)}get utimes(){return(0,n.promisify)(P.utimes)}get read(){return(te,F,$,V,x)=>new Promise((H,O)=>{P.read(te,F,$,V,x,(G,_,re)=>G?O(G):H({bytesRead:_,buffer:re}))})}get readFile(){return(0,n.promisify)(P.readFile)}get write(){return(te,F,$,V,x)=>new Promise((H,O)=>{P.write(te,F,$,V,x,(G,_,re)=>G?O(G):H({bytesWritten:_,buffer:re}))})}get appendFile(){return(0,n.promisify)(P.appendFile)}get fdatasync(){return(0,n.promisify)(P.fdatasync)}get truncate(){return(0,n.promisify)(P.truncate)}get rename(){return(0,n.promisify)(P.rename)}get copyFile(){return(0,n.promisify)(P.copyFile)}get open(){return(0,n.promisify)(P.open)}get close(){return(0,n.promisify)(P.close)}get symlink(){return(0,n.promisify)(P.symlink)}get readlink(){return(0,n.promisify)(P.readlink)}get chmod(){return(0,n.promisify)(P.chmod)}get mkdir(){return(0,n.promisify)(P.mkdir)}get unlink(){return(0,n.promisify)(P.unlink)}get rmdir(){return(0,n.promisify)(P.rmdir)}get realpath(){return(0,n.promisify)(P.realpath)}async exists(te){try{return await e.Promises.access(te),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return C}get writeFile(){return o}get rm(){return u}get move(){return M}get copy(){return T}}}),define(ie[102],se([0,1,41,9,4,25,23]),function(X,e,P,A,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(I){if(n.isLinux)return I;const u=(0,A.dirname)(I);if(I===u)return I;const w=((0,A.basename)(I)||I).toLowerCase();try{const s=(0,D.readdirSync)(u).filter(h=>h.toLowerCase()===w);if(s.length===1){const h=k(u);if(h)return(0,A.join)(h,s[0])}else if(s.length>1){const h=s.indexOf(w);if(h>=0){const f=k(u);if(f)return(0,A.join)(f,s[h])}}}catch{}return null}e.realcaseSync=k;async function g(I){if(n.isLinux)return I;const u=(0,A.dirname)(I);if(I===u)return I;const w=((0,A.basename)(I)||I).toLowerCase();try{const s=(await D.Promises.readdir(u)).filter(h=>h.toLowerCase()===w);if(s.length===1){const h=await g(u);if(h)return(0,A.join)(h,s[0])}else if(s.length>1){const h=s.indexOf(w);if(h>=0){const f=await g(u);if(f)return(0,A.join)(f,s[h])}}}catch{}return null}e.realcase=g;async function d(I){try{return await D.Promises.realpath(I)}catch{const w=b(I);return await D.Promises.access(w,P.constants.R_OK),w}}e.realpath=d;function y(I){try{return P.realpathSync(I)}catch{const w=b(I);return P.accessSync(w,P.constants.R_OK),w}}e.realpathSync=y;function b(I){return(0,R.rtrim)((0,A.normalize)(I),A.sep)}}),define(ie[151],se([0,1,27,9,23]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var g;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(g||(g={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class b{constructor(C,t,c){this.exePath=C,this.displayName=t,this.a=c}async exists(){return this.a===void 0&&(this.a=await n.SymlinkSupport.existsFile(this.exePath)),this.a}}function I({useAlternateBitness:v=!1}={}){return v?d===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:v=!1,findPreview:C=!1}={}){const t=I({useAlternateBitness:v});if(!t)return null;const c=A.join(t,"PowerShell");if(!await n.SymlinkSupport.existsDirectory(c))return null;let i=-1,o=null;for(const a of await n.Promises.readdir(c)){let m=-1;if(C){const M=a.indexOf("-");if(M<0)continue;const T=a.substring(0,M);if(!R.test(T)||a.substring(M+1)!=="preview")continue;m=parseInt(T,10)}else{if(!R.test(a))continue;m=parseInt(a,10)}if(m<=i)continue;const E=A.join(c,a,"pwsh.exe");!await n.SymlinkSupport.existsFile(E)||(o=E,i=m)}if(!o)return null;const r=t.includes("x86")?" (x86)":"",l=C?" Preview":"";return new b(o,`PowerShell${l}${r}`,!0)}async function w({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const C=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await n.SymlinkSupport.existsDirectory(C))return null;const{pwshMsixDirRegex:t,pwshMsixName:c}=v?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await n.Promises.readdir(C))if(t.test(i)){const o=A.join(C,i,"pwsh.exe");return new b(o,c)}return null}function S(){const v=A.join(P.homedir(),".dotnet","tools","pwsh.exe");return new b(v,".NET Core PowerShell Global Tool")}function s(){const v=A.join(process.env.windir,d===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(v,"Windows PowerShell",!0)}async function*h(){let v=await u();v&&(yield v),v=await u({useAlternateBitness:!0}),v&&(yield v),v=await w(),v&&(yield v),v=S(),v&&(yield v),v=await u({findPreview:!0}),v&&(yield v),v=await w({findPreview:!0}),v&&(yield v),v=await u({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=s(),v&&(yield v)}async function*f(){for await(const v of h())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=f;async function p(){for await(const v of f())return v;return null}e.getFirstAvailablePowerShellInstallation=p}),define(ie[85],se([0,1,9,4,36,71,10,23]),function(X,e,P,A,n,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function g(b=n.env){return b.comspec||"cmd.exe"}e.getWindowsShell=g;function d(b){let I=[],u=!1;const w=function(S){if(u){I.push(S);return}(!b.send(S,h=>{if(h&&console.error(h),u=!1,I.length>0){const f=I.slice(0);I=[],f.forEach(p=>w(p))}})||A.isWindows)&&(u=!0)};return{send:w}}e.createQueuedSender=d;var y;(function(b){async function I(u,w,S){if(P.isAbsolute(u))return u;if(w===void 0&&(w=n.cwd()),P.dirname(u)!=="."||(S===void 0&&D.isString(n.env.PATH)&&(S=n.env.PATH.split(P.delimiter)),S===void 0||S.length===0))return P.join(w,u);async function h(f){if(await k.Promises.exists(f)){let p;try{p=await k.Promises.stat(f)}catch(v){v.message.startsWith("EACCES")&&(p=await k.Promises.lstat(f))}return p?!p.isDirectory():!1}return!1}for(const f of S){let p;if(P.isAbsolute(f)?p=P.join(f,u):p=P.join(w,f,u),await h(p))return p;let v=p+".com";if(await h(v)||(v=p+".exe",await h(v)))return v}return P.join(w,u)}b.findExecutable=I})(y=e.win32||(e.win32={}))}),define(ie[103],se([0,1,46,14]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function n(D){return new Promise((k,g)=>{let d;const y=new Map;function b(u,w,S,s,h){const f=y.get(w);if(u===D||f){const p={name:I(S),cmd:S,pid:u,ppid:w,load:s,mem:h};y.set(u,p),u===D&&(d=p),f&&(f.children||(f.children=[]),f.children.push(p),f.children.length>1&&(f.children=f.children.sort((v,C)=>v.pid-C.pid)))}}function I(u){const w=/--vscode-window-kind=shared-process/i,S=/--vscode-window-kind=issue-reporter/i,s=/--vscode-window-kind=process-explorer/i,h=/--utility-sub-type=network/i,f=/--vscode-utility-kind=extensionHost/i,p=/--vscode-utility-kind=fileWatcher/i,v=/--vscode-utility-kind=shared-process/i,C=/--ms-enable-electron-run-as-node/i,t=/--crashes-directory/i,c=/\\pipe\\winpty-control/i,i=/conhost\.exe/i,o=/--type=([a-zA-Z-]+)/;if(t.exec(u))return"electron-crash-reporter";if(c.exec(u))return"winpty-process";if(i.exec(u))return"console-window-host (Windows internal process)";let r=o.exec(u);if(r&&r.length===2)return r[1]==="renderer"?w.exec(u)?"shared-process":S.exec(u)?"issue-reporter":s.exec(u)?"process-explorer":"window":r[1]==="utility"?h.exec(u)?"utility-network-service":f.exec(u)?"extension-host":p.exec(u)?"file-watcher":v.exec(u)?"shared-process":"utility-process":r[1]==="extensionHost"?"extension-host":r[1];const l=/[a-zA-Z-]+\.js/g;let a="";do r=l.exec(u),r&&(a+=r+" ");while(r);return a&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${a})`:C.exec(u)?`electron-nodejs (${u})`:u}if(process.platform==="win32"){const u=w=>w.indexOf("\\\\?\\")===0||w.indexOf("\\??\\")===0?w.substr(4):w.indexOf('"\\\\?\\')===0||w.indexOf('"\\??\\')===0?'"'+w.substr(5):w;new Promise((w,S)=>{X(["windows-process-tree"],w,S)}).then(w=>{w.getProcessList(D,S=>{if(!S){g(new Error(`Root process ${D} not found`));return}w.getProcessCpuUsage(S,s=>{const h=new Map;s.forEach(f=>{const p=u(f.commandLine||"");h.set(f.pid,{name:I(p),cmd:p,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),d=h.get(D),d?(h.forEach(f=>{const p=h.get(f.ppid);p&&(p.children||(p.children=[]),p.children.push(f))}),h.forEach(f=>{f.children&&(f.children=f.children.sort((p,v)=>p.pid-v.pid))}),k(d)):g(new Error(`Root process ${D} not found`))})},w.ProcessDataFlag.CommandLine|w.ProcessDataFlag.Memory)})}else{let u=function(){let w=[d];const S=[];for(;w.length;){const h=w.shift();h&&(S.push(h.pid),h.children&&(w=w.concat(h.children)))}let s=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);s+=" "+S.join(" "),(0,P.exec)(s,{},(h,f,p)=>{if(h||p)g(h||new Error(p.toString()));else{const v=f.toString().split(`
`);for(let C=0;C<S.length;C++){const t=y.get(S[C]);t.load=parseFloat(v[C])}if(!d){g(new Error(`Root process ${D} not found`));return}k(d)}})};(0,P.exec)("which ps",{},(w,S,s)=>{if(w||s)if(process.platform!=="linux")g(w||new Error(s.toString()));else{const h=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(h,{},(f,p,v)=>{f||v?g(f||new Error(v.toString())):(R(p,b),u())})}else{const h=S.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${h} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,v,C)=>{p||C&&!C.includes("screen size is bogus")?g(p||new Error(C.toString())):(R(v,b),process.platform==="linux"?u():d?k(d):g(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=n;function R(D,k){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=D.toString().split(`
`);for(const y of d){const b=g.exec(y.trim());b&&b.length===6&&k(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(ie[152],se([0,1,27,4,151,85]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(b,I){return b===1?A.isWindows?y():R.getWindowsShell(I):g(b,I)}e.getSystemShell=D;let k=null;function g(b,I){if(A.isLinux&&b===2||A.isMacintosh&&b===3)return"/bin/bash";if(!k){let u;if(A.isWindows)u="/bin/bash";else{if(u=I.SHELL,!u)try{u=(0,P.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}k=u}return k}let d=null;async function y(){return d||(d=(await(0,n.getFirstAvailablePowerShellInstallation)()).exePath),d}});var ye=this&&this.__decorate||function(X,e,P,A){var n=arguments.length,R=n<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,P):A,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(X,e,P,A);else for(var k=X.length-1;k>=0;k--)(D=X[k])&&(R=(n<3?D(R):n>3?D(e,P,R):D(e,P))||R);return n>3&&R&&Object.defineProperty(e,P,R),R};define(ie[47],se([0,1,26,7,17,22,55,13,3,2,83,25,10]),function(X,e,P,A,n,R,D,k,g,d,y,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var u;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(u||(u={}));function w(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(S||(S={}));function s(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(h||(h={}));function f(H){let O=0;for(let G=0;;G+=7){const _=H.read(1);if(O|=(_.buffer[0]&127)<<G,!(_.buffer[0]&128))return O}}const p=i(0);function v(H,O){if(O===0){H.write(p);return}let G=0;for(let re=O;re!==0;re=re>>>7)G++;const _=n.VSBuffer.alloc(G);for(let re=0;O!==0;re++)_.buffer[re]=O&127,O=O>>>7,O>0&&(_.buffer[re]|=128);H.write(_)}class C{constructor(O){this.b=O,this.a=0}read(O){const G=this.b.slice(this.a,this.a+O);return this.a+=G.byteLength,G}}e.BufferReader=C;class t{constructor(){this.a=[]}get buffer(){return n.VSBuffer.concat(this.a)}write(O){this.a.push(O)}}e.BufferWriter=t;var c;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(c||(c={}));function i(H){const O=n.VSBuffer.alloc(1);return O.writeUInt8(H,0),O}const o={Undefined:i(c.Undefined),String:i(c.String),Buffer:i(c.Buffer),VSBuffer:i(c.VSBuffer),Array:i(c.Array),Object:i(c.Object),Uint:i(c.Int)},r=typeof Buffer<"u";function l(H,O){if(typeof O>"u")H.write(o.Undefined);else if(typeof O=="string"){const G=n.VSBuffer.fromString(O);H.write(o.String),v(H,G.byteLength),H.write(G)}else if(r&&Buffer.isBuffer(O)){const G=n.VSBuffer.wrap(O);H.write(o.Buffer),v(H,G.byteLength),H.write(G)}else if(O instanceof n.VSBuffer)H.write(o.VSBuffer),v(H,O.byteLength),H.write(O);else if(Array.isArray(O)){H.write(o.Array),v(H,O.length);for(const G of O)l(H,G)}else if(typeof O=="number"&&(O|0)===O)H.write(o.Uint),v(H,O);else{const G=n.VSBuffer.fromString(JSON.stringify(O));H.write(o.Object),v(H,G.byteLength),H.write(G)}}e.serialize=l;function a(H){switch(H.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return H.read(f(H)).toString();case c.Buffer:return H.read(f(H)).buffer;case c.VSBuffer:return H.read(f(H));case c.Array:{const G=f(H),_=[];for(let re=0;re<G;re++)_.push(a(H));return _}case c.Object:return JSON.parse(H.read(f(H)).toString());case c.Int:return f(H)}}e.deserialize=a;class m{constructor(O,G,_=null,re=1e3){this.h=O,this.j=G,this.k=_,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(O,G){this.b.set(O,G),setTimeout(()=>this.w(O),0)}m(O){switch(O.type){case 200:{const G=this.o([O.type]);this.k?.logOutgoing(G,0,1,s(O.type));return}case 201:case 202:case 204:case 203:{const G=this.o([O.type,O.id],O.data);this.k?.logOutgoing(G,O.id,1,s(O.type),O.data);return}}}o(O,G=void 0){const _=new t;return l(_,O),l(_,G),this.p(_.buffer)}p(O){try{return this.h.send(O),O.byteLength}catch{return 0}}q(O){const G=new C(O),_=a(G),re=a(G),oe=_[0];switch(oe){case 100:return this.k?.logIncoming(O.byteLength,_[1],1,`${w(oe)}: ${_[2]}.${_[3]}`,re),this.s({type:oe,id:_[1],channelName:_[2],name:_[3],arg:re});case 102:return this.k?.logIncoming(O.byteLength,_[1],1,`${w(oe)}: ${_[2]}.${_[3]}`,re),this.t({type:oe,id:_[1],channelName:_[2],name:_[3],arg:re});case 101:return this.k?.logIncoming(O.byteLength,_[1],1,`${w(oe)}`),this.u({type:oe,id:_[1]});case 103:return this.k?.logIncoming(O.byteLength,_[1],1,`${w(oe)}`),this.u({type:oe,id:_[1]})}}s(O){const G=this.b.get(O.channelName);if(!G){this.v(O);return}const _=new R.CancellationTokenSource;let re;try{re=G.call(this.j,O.name,O.arg,_.token)}catch(W){re=Promise.reject(W)}const oe=O.id;re.then(W=>{this.m({id:oe,data:W,type:201}),this.d.delete(O.id)},W=>{W instanceof Error?this.m({id:oe,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.m({id:oe,data:W,type:203}),this.d.delete(O.id)});const L=(0,d.toDisposable)(()=>_.cancel());this.d.set(O.id,L)}t(O){const G=this.b.get(O.channelName);if(!G){this.v(O);return}const _=O.id,oe=G.listen(this.j,O.name,O.arg)(L=>this.m({id:_,data:L,type:204}));this.d.set(O.id,oe)}u(O){const G=this.d.get(O.id);G&&(G.dispose(),this.d.delete(O.id))}v(O){let G=this.g.get(O.channelName);G||(G=[],this.g.set(O.channelName,G));const _=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.m({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);G.push({request:O,timeoutTimer:_})}w(O){const G=this.g.get(O);if(G){for(const _ of G)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.s(_.request);break;case 102:this.t(_.request);break}this.g.delete(O)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=m;var E;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));class M{constructor(O,G=null){this.l=O,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(_=>this.s(_)),this.j=G}getChannel(O){const G=this;return{call(_,re,oe){return G.a?Promise.reject(new k.CancellationError):G.m(O,_,re,oe)},listen(_,re){return G.a?g.Event.None:G.o(O,_,re)}}}m(O,G,_,re=R.CancellationToken.None){const oe=this.g++,W={id:oe,type:100,channelName:O,name:G,arg:_};if(re.isCancellationRequested)return Promise.reject(new k.CancellationError);let U;return new Promise((q,J)=>{if(re.isCancellationRequested)return J(new k.CancellationError);const B=()=>{const fe=De=>{switch(De.type){case 201:this.f.delete(oe),q(De.data);break;case 202:{this.f.delete(oe);const Re=new Error(De.data.message);Re.stack=Array.isArray(De.data.stack)?De.data.stack.join(`
`):De.data.stack,Re.name=De.data.name,J(Re);break}case 203:this.f.delete(oe),J(De.data);break}};this.f.set(oe,fe),this.p(W)};let Y=null;this.b===h.Idle?B():(Y=(0,A.createCancelablePromise)(fe=>this.u()),Y.then(()=>{Y=null,B()}));const Z=()=>{Y?(Y.cancel(),Y=null):this.p({id:oe,type:101}),J(new k.CancellationError)},ce=re.onCancellationRequested(Z);U=(0,d.combinedDisposable)((0,d.toDisposable)(Z),ce),this.d.add(U)}).finally(()=>{this.d.delete(U)})}o(O,G,_){const re=this.g++,L={id:re,type:102,channelName:O,name:G,arg:_};let W=null;const U=new g.Emitter({onWillAddFirstListener:()=>{W=(0,A.createCancelablePromise)(q=>this.u()),W.then(()=>{W=null,this.d.add(U),this.p(L)})},onDidRemoveLastListener:()=>{W?(W.cancel(),W=null):(this.d.delete(U),this.p({id:re,type:103}))}}),j=q=>U.fire(q.data);return this.f.set(re,j),U.event}p(O){switch(O.type){case 100:case 102:{const G=this.q([O.type,O.id,O.channelName,O.name],O.arg);this.j?.logOutgoing(G,O.id,0,`${w(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const G=this.q([O.type,O.id]);this.j?.logOutgoing(G,O.id,0,w(O.type));return}}}q(O,G=void 0){const _=new t;return l(_,O),l(_,G),this.r(_.buffer)}r(O){try{return this.l.send(O),O.byteLength}catch{return 0}}s(O){const G=new C(O),_=a(G),re=a(G),oe=_[0];switch(oe){case 200:return this.j?.logIncoming(O.byteLength,0,0,s(oe)),this.t({type:_[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(O.byteLength,_[1],0,s(oe),re),this.t({type:_[0],id:_[1],data:re})}}t(O){if(O.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(O.id)?.(O)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.dispose)(this.d.values()),this.d.clear()}}ye([D.memoize],M.prototype,"onDidInitializePromise",null),e.ChannelClient=M;class T{get connections(){const O=[];return this.f.forEach(G=>O.push(G)),O}constructor(O){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,O(({protocol:G,onDidClientDisconnect:_})=>{g.Event.once(G.onMessage)(oe=>{const L=new C(oe),W=a(L),U=new m(G,W),j=new M(G);this.a.forEach((J,B)=>U.registerChannel(B,J));const q={channelServer:U,channelClient:j,ctx:W};this.f.add(q),this.g.fire(q),_(()=>{U.dispose(),j.dispose(),this.f.delete(q),this.h.fire(q)})})})}getChannel(O,G){const _=this;return{call(re,oe,L){let W;if((0,I.isFunction)(G)){const j=(0,P.getRandomElement)(_.connections.filter(G));W=j?Promise.resolve(j):g.Event.toPromise(g.Event.filter(_.onDidAddConnection,G))}else W=G.routeCall(_,re,oe);const U=W.then(j=>j.channelClient.getChannel(O));return z(U).call(re,oe,L)},listen(re,oe){if((0,I.isFunction)(G))return _.j(O,G,re,oe);const L=G.routeEvent(_,re,oe).then(W=>W.channelClient.getChannel(O));return z(L).listen(re,oe)}}}j(O,G,_,re){const oe=this;let L=new d.DisposableStore;const W=new g.Emitter({onWillAddFirstListener:()=>{L=new d.DisposableStore;const U=new g.EventMultiplexer,j=new Map,q=B=>{const Z=B.channelClient.getChannel(O).listen(_,re),ce=U.add(Z);j.set(B,ce)},J=B=>{const Y=j.get(B);!Y||(Y.dispose(),j.delete(B))};oe.connections.filter(G).forEach(q),g.Event.filter(oe.onDidAddConnection,G)(q,void 0,L),oe.onDidRemoveConnection(J,void 0,L),U.event(W.fire,W,L),L.add(U)},onDidRemoveLastListener:()=>{L.dispose()}});return W.event}registerChannel(O,G){this.a.set(O,G),this.f.forEach(_=>{_.channelServer.registerChannel(O,G)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class N{constructor(O,G,_=null){const re=new t;l(re,G),O.send(re.buffer),this.a=new M(O,_),this.d=new m(O,G,_)}getChannel(O){return this.a.getChannel(O)}registerChannel(O,G){this.d.registerChannel(O,G)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function z(H){return{call(O,G,_){return H.then(re=>re.call(O,G,_))},listen(O,G){const _=new g.Relay;return H.then(re=>_.input=re.listen(O,G)),_.event}}}e.getDelayedChannel=z;function K(H){let O=!1;return{call(G,_,re){return O?H.call(G,_,re):(0,A.timeout)(0).then(()=>O=!0).then(()=>H.call(G,_,re))},listen(G,_){if(O)return H.listen(G,_);const re=new g.Relay;return(0,A.timeout)(0).then(()=>O=!0).then(()=>re.input=H.listen(G,_)),re.event}}}e.getNextTickChannel=K;class ae{constructor(O){this.a=O}routeCall(O){return this.b(O)}routeEvent(O){return this.b(O)}async b(O){for(const G of O.connections)if(await Promise.resolve(this.a(G.ctx)))return Promise.resolve(G);return await g.Event.toPromise(O.onDidAddConnection),await this.b(O)}}e.StaticRouter=ae;var le;(function(H){function O(oe,L){const W=oe,U=L&&L.disableMarshalling,j=new Map;for(const q in W)_(q)&&j.set(q,g.Event.buffer(W[q],!0));return new class{listen(q,J,B){const Y=j.get(J);if(Y)return Y;if(re(J)){const Z=W[J];if(typeof Z=="function")return Z.call(W,B)}throw new Error(`Event not found: ${J}`)}call(q,J,B){const Y=W[J];if(typeof Y=="function"){if(!U&&Array.isArray(B))for(let Z=0;Z<B.length;Z++)B[Z]=(0,y.revive)(B[Z]);return Y.apply(W,B)}throw new Error(`Method not found: ${J}`)}}}H.fromService=O;function G(oe,L){const W=L&&L.disableMarshalling;return new Proxy({},{get(U,j){if(typeof j=="string")return L?.properties?.has(j)?L.properties.get(j):re(j)?function(q){return oe.listen(j,q)}:_(j)?oe.listen(j):async function(...q){let J;L&&!(0,I.isUndefinedOrNull)(L.context)?J=[L.context,...q]:J=q;const B=await oe.call(j,J);return W?B:(0,y.revive)(B)};throw new Error(`Property not found: ${String(j)}`)}})}H.toService=G;function _(oe){return oe[0]==="o"&&oe[1]==="n"&&b.isUpperAsciiLetter(oe.charCodeAt(2))}function re(oe){return/^onDynamic/.test(oe)&&b.isUpperAsciiLetter(oe.charCodeAt(9))}})(le=e.ProxyChannel||(e.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const O=H.toString();if(O!=="[object Object]")return O}return H}function $(H){return Array.isArray(H)?H.map(F):F(H)}function V(H,O,G,_,re,oe,L){L=$(L);const W=te[re],U=W[_%W.length];let j=[`%c[${H}]%c[${String(O).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(oe)?(j=j.concat(L),j.push(")")):j.push(L),console.log.apply(console,j)}class x{constructor(O,G){this.d=O,this.f=G,this.a=0,this.b=0}logOutgoing(O,G,_,re,oe){this.b+=O,V(this.d,this.b,O,G,_,re,oe)}logIncoming(O,G,_,re,oe){this.a+=O,V(this.f,this.a,O,G,_,re,oe)}}e.IPCLogger=x}),define(ie[153],se([0,1,17,3,47]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(g){this.a=g,this.onMessage=A.Event.fromDOMEventEmitter(this.a,"message",d=>P.VSBuffer.wrap(d.data)),g.start()}send(g){this.a.postMessage(g.buffer)}disconnect(){this.a.close()}}e.Protocol=R;class D extends n.IPCClient{constructor(g,d){const y=new R(g);super(y,d),this.b=y}dispose(){this.b.disconnect()}}e.Client=D}),define(ie[104],se([0,1,7,17,3,2,47]),function(X,e,P,A,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(M){M.Created="created",M.Read="read",M.Write="write",M.Open="open",M.Error="error",M.Close="close",M.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",M.NodeEndReceived="nodeEndReceived",M.NodeEndSent="nodeEndSent",M.NodeDrainBegin="nodeDrainBegin",M.NodeDrainEnd="nodeDrainEnd",M.zlibInflateError="zlibInflateError",M.zlibInflateData="zlibInflateData",M.zlibInflateInitialWrite="zlibInflateInitialWrite",M.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",M.zlibInflateWrite="zlibInflateWrite",M.zlibInflateFlushFired="zlibInflateFlushFired",M.zlibDeflateError="zlibDeflateError",M.zlibDeflateData="zlibDeflateData",M.zlibDeflateWrite="zlibDeflateWrite",M.zlibDeflateFlushFired="zlibDeflateFlushFired",M.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",M.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",M.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",M.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",M.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",M.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",M.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",M.ProtocolHeaderRead="protocolHeaderRead",M.ProtocolMessageRead="protocolMessageRead",M.ProtocolHeaderWrite="protocolHeaderWrite",M.ProtocolMessageWrite="protocolMessageWrite",M.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var g;(function(M){M.enableDiagnostics=!1,M.records=[];const T=new WeakMap;let N=0;function z(ae,le){if(!T.has(ae)){const te=String(++N);T.set(ae,te)}return T.get(ae)}function K(ae,le,te,F){if(!M.enableDiagnostics)return;const $=z(ae,le);if(F instanceof A.VSBuffer||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const V=A.VSBuffer.alloc(F.byteLength);V.set(F),M.records.push({timestamp:Date.now(),id:$,label:le,type:te,buff:V})}else M.records.push({timestamp:Date.now(),id:$,label:le,type:te,data:F})}M.traceSocketEvent=K})(g=e.SocketDiagnostics||(e.SocketDiagnostics={}));var d;(function(M){M[M.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",M[M.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let y=null;function b(){return y||(y=A.VSBuffer.alloc(0)),y}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,N){if(T===0)return b();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const le=this.a[0];return N&&(this.a.shift(),this.b-=T),le}if(this.a[0].byteLength>T){const le=this.a[0].slice(0,T);return N&&(this.a[0]=this.a[0].slice(T),this.b-=T),le}const z=A.VSBuffer.alloc(T);let K=0,ae=0;for(;T>0;){const le=this.a[ae];if(le.byteLength>T){const te=le.slice(0,T);z.set(te,K),K+=T,N&&(this.a[ae]=le.slice(T),this.b-=T),T-=T}else z.set(le,K),K+=le.byteLength,N?(this.a.shift(),this.b-=le.byteLength):ae++,T-=le.byteLength}return z}}e.ChunkStream=I;var u;(function(M){M[M.None=0]="None",M[M.Regular=1]="Regular",M[M.Control=2]="Control",M[M.Ack=3]="Ack",M[M.Disconnect=5]="Disconnect",M[M.ReplayRequest=6]="ReplayRequest",M[M.Pause=7]="Pause",M[M.Resume=8]="Resume",M[M.KeepAlive=9]="KeepAlive",M[M.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",M[M.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(u||(u={}));function w(M){switch(M){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var S;(function(M){M[M.HeaderLength=13]="HeaderLength",M[M.AcknowledgeTime=2e3]="AcknowledgeTime",M[M.TimeoutTime=2e4]="TimeoutTime",M[M.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",M[M.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",M[M.KeepAliveSendTime=5e3]="KeepAliveSendTime",M[M.LatencySampleTime=6e4]="LatencySampleTime",M[M.LatencySampleCount=5]="LatencySampleCount",M[M.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",M[M.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(S=e.ProtocolConstants||(e.ProtocolConstants={}));class s{constructor(T,N,z,K){this.type=T,this.id=N,this.ack=z,this.data=K,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends R.Disposable{constructor(T){super(),this.f=this.B(new n.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new I,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const z=this.g.messageType,K=this.g.id,ae=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new s(z,K,ae,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=A.VSBuffer.alloc(13);N.writeUInt8(T.type,0),N.writeUInt32BE(T.id,1),N.writeUInt32BE(T.ack,5),N.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:w(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j(N,T.data)}g(T,N){const z=this.f===0;return this.d.push(T,N),this.f+=T.byteLength+N.byteLength,z}h(){const T=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,N){this.g(T,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class p extends R.Disposable{constructor(T){super(),this.f=new n.Emitter,this.onMessage=this.f.event,this.g=new n.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.B(new f(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new s(1,0,0,T))}}e.Protocol=p;class v extends D.IPCClient{static fromSocket(T,N){return new v(new p(T),N)}get onDidDispose(){return this.b.onDidDispose}constructor(T,N,z=null){super(T,N,z),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=v;class C{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new n.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=C;class t{constructor(T){this.data=T,this.next=null}}class c{constructor(){this.a=null,this.b=null}length(){let T=0,N=this.a;for(;N;)N=N.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let N=0,z=this.a;for(;z;)T[N++]=z.data,z=z.next;return T}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const N=new t(T);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const T=Date.now();for(let N=0;N<i.a;N++)this.c[N]=T-1e3*N;setInterval(()=>{for(let N=i.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),N=(1+i.a)*1e3;let z=0;for(let K=0;K<i.a;K++)T-this.c[K]<=N&&z++;return 1-z/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var o;(function(M){M[M.Good=0]="Good",M[M.Poor=1]="Poor"})(o=e.ConnectionHealth||(e.ConnectionHealth={}));function r(M){switch(M){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class l{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=l;class a{constructor(T,N){this.roundTripTime=T,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=a;class m{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new C,this.onControlMessage=this.x.event,this.y=new C,this.onMessage=this.y.event,this.z=new C,this.onDidDispose=this.z.event,this.A=new C,this.onSocketClose=this.A.event,this.B=new C,this.onSocketTimeout=this.B.event,this.C=new C,this.onHighRoundTripTime=this.C.event,this.D=new C,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??i.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new c,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=T.socket,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new E),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new s(5,0,0,b());this.p.write(T),this.p.flush()}sendPause(){const T=new s(7,0,0,b());this.p.write(T)}sendResume(){const T=new s(8,0,0,b());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,N){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(z=>this.E(z))),this.t.add(this.o.onClose(z=>this.A.fire(z))),this.r=this.t.add(new E),this.t.add(this.r.onSendLatencyRequest(z=>this.J(z))),this.t.add(this.r.onHighRoundTripTime(z=>this.C.fire(z))),this.t.add(this.r.onDidChangeConnectionHealth(z=>this.D.fire(z))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new s(3,0,this.h,b());this.p.write(T);const N=this.b.toArray();for(let z=0,K=N.length;z<K;z++)this.p.write(N[z]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const N=this.b.peek();if(N&&N.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new s(6,0,0,b())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let z=0,K=N.length;z<K;z++)this.p.write(N[z]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const N=++this.c;this.h=this.g;const z=new s(1,N,this.h,T);this.b.push(z),this.a||(this.p.write(z),this.G())}sendControl(T){const N=new s(2,0,0,T);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),N=Date.now()-T.writtenTime,z=Date.now()-this.q.lastReadTime,K=Date.now()-this.n;if(N>=2e4&&z>=2e4&&K>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:z});return}const ae=Math.max(2e4-N,2e4-z,2e4-K,500);this.f=setTimeout(()=>{this.f=null,this.G()},ae)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new s(3,0,this.h,b());this.p.write(T)}I(){this.h=this.g;const T=new s(9,0,this.h,b());this.p.write(T)}J(T){this.h=this.g;const N=new s(10,0,this.h,T);this.p.write(N)}K(T){this.h=this.g;const N=new s(11,0,this.h,T);this.p.write(N)}}e.PersistentProtocol=m;class E extends R.Disposable{constructor(){super(),this.a=this.B(new n.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new n.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new n.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new P.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,N=A.VSBuffer.alloc(4);N.writeUInt32BE(T,0),this.a.fire(N)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const N=T.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const z=Date.now()-this.g,K=this.k++;this.j[K%this.j.length]=z;const ae=this.l,le=this.j.filter(te=>te>=1e3).length;this.l=le>=3?1:0,z>1e3&&this.b.fire(new a(z,le)),ae!==this.l&&this.c.fire(this.l)}}}),define(ie[154],se([0,1,42,17,3,2,47,139]),function(X,e,P,A,n,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function g(y,b){const I=n.Event.fromNodeEventEmitter(P.validatedIpcMain,b,(w,S)=>({event:w,message:S})),u=n.Event.filter(I,({event:w})=>w.sender.id===y);return n.Event.map(u,({message:w})=>w&&A.VSBuffer.wrap(w))}class d extends D.IPCServer{static d(){const b=n.Event.fromNodeEventEmitter(P.validatedIpcMain,"vscode:hello",({sender:I})=>I);return n.Event.map(b,I=>{const u=I.id;d.b.get(u)?.dispose();const S=new n.Emitter;d.b.set(u,(0,R.toDisposable)(()=>S.fire()));const s=g(u,"vscode:message"),h=n.Event.any(n.Event.signal(g(u,"vscode:disconnect")),S.event);return{protocol:new k.Protocol(I,s),onDidClientDisconnect:h}})}constructor(){super(d.d())}}d.b=new Map,e.Server=d}),define(ie[105],se([0,1,42,3,31,153]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class D extends R.Client{constructor(d,y){super({addEventListener:(b,I)=>d.addListener(b,I),removeEventListener:(b,I)=>d.removeListener(b,I),postMessage:b=>d.postMessage(b),start:()=>d.start(),close:()=>d.close()},y)}}e.Client=D;async function k(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const d=(0,n.generateUuid)();g.webContents.send("vscode:createMessageChannel",d);const y=A.Event.fromNodeEventEmitter(P.validatedIpcMain,"vscode:createMessageChannelResult",(I,u)=>({nonce:u,port:I.ports[0]})),{port:b}=await A.Event.toPromise(A.Event.once(A.Event.filter(y,I=>I.nonce===d)));return b}e.connect=k}),define(ie[155],se([0,1,46,7,17,22,148,13,3,2,37,85,71,47]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends u.ChannelServer{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",f=>n.VSBuffer.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=w;class S{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const p=f&&f.timeout?f.timeout:6e4;this.b=new A.Delayer(p),this.d=null,this.f=null}getChannel(h){const f=this;return{call(p,v,C){return f.k(h,p,v,C)},listen(p,v){return f.l(h,p,v)}}}k(h,f,p,v=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(k.canceled());this.b.cancel();const C=this.n(h),t=(0,A.createCancelablePromise)(o=>C.call(f,p,o)),c=v.onCancellationRequested(()=>t.cancel()),i=(0,d.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{c.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,f,p){if(!this.b)return g.Event.None;this.b.cancel();let v;const C=new g.Emitter({onWillAddFirstListener:()=>{v=this.n(h).listen(f,p)(C.fire,C),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return C.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,I.removeDangerousEnvVariables)(f.env),this.d=(0,P.fork)(this.i,h,f);const p=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,D.isRemoteConsoleLog)(r)){(0,D.log)(r,`IPC Library: ${this.j.serverName}`);return}p.fire(n.VSBuffer.wrap(Buffer.from(r,"base64")))});const C=this.j.useQueue?(0,b.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&C.send(r.buffer.toString("base64")),c=p.event,i={send:t,onMessage:c};this.f=new u.ChannelClient(i);const o=()=>this.o();process.once("exit",o),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,l)=>{process.removeListener("exit",o),this.c.forEach(a=>(0,d.dispose)(a)),this.c.clear(),r!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:l})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=S}),define(ie[86],se([0,1,17,13,3,2,9,4,31,47,104]),function(X,e,P,A,n,R,D,k,g,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class I{traceSocketEvent(a,m){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,m)}constructor(a,m=""){this.f=!0,this.debugLabel=m,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=E=>{if(this.traceSocketEvent("error",{code:E?.code,message:E?.message}),E){if(E.code==="EPIPE")return;(0,A.onUnexpectedError)(E)}},this.socket.on("error",this.a),this.b=E=>{this.traceSocketEvent("close",{hadError:E}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(a){const m=E=>{this.traceSocketEvent("read",E),a(P.VSBuffer.wrap(E))};return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(a){const m=E=>{a({type:0,hadError:E,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(a){const m=()=>{a()};return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(a){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,A.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,A.onUnexpectedError)(m)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,m)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=I;var u;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize",l[l.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(u||(u={}));var w;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(w||(w={}));class S extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(a,m){this.socket.traceSocketEvent(a,m)}constructor(a,m,E,M){super(),this.f=this.B(new n.Emitter),this.g=this.B(new n.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:m,inflateBytesLength:E?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new s(this,m,E,M,this.f,(T,N)=>this.k(T,N))),this.B(this.a.onError(T=>{console.error(T),(0,A.onUnexpectedError)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new y.ChunkStream,this.B(this.socket.onData(T=>this.l(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await n.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this.f.event(a)}onClose(a){return this.g.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){let m=0;for(;m<a.byteLength;)this.a.writeMessage(a.slice(m,Math.min(m+262144,a.byteLength))),m+=262144}k(a,m){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let E=2;a.byteLength<126?E+=0:a.byteLength<2**16?E+=2:E+=8;const M=P.VSBuffer.alloc(E);if(m?M.writeUInt8(194,0):M.writeUInt8(130,0),a.byteLength<126)M.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){M.writeUInt8(126,1);let T=1;M.writeUInt8(a.byteLength>>>8&255,++T),M.writeUInt8(a.byteLength>>>0&255,++T)}else{M.writeUInt8(127,1);let T=1;M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(0,++T),M.writeUInt8(a.byteLength>>>24&255,++T),M.writeUInt8(a.byteLength>>>16&255,++T),M.writeUInt8(a.byteLength>>>8&255,++T),M.writeUInt8(a.byteLength>>>0&255,++T)}this.socket.write(P.VSBuffer.concat([M,a]))}end(){this.h=!0,this.socket.end()}l(a){if(a.byteLength!==0){for(this.b.acceptChunk(a);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const m=this.b.peek(this.j.readLen),E=m.readUInt8(0),M=(E&128)>>>7,T=(E&64)>>>6,N=m.readUInt8(1),z=(N&128)>>>7,K=N&127;this.j.state=2,this.j.readLen=2+(z?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(T)),this.j.firstFrameOfMessage=Boolean(M),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const m=this.b.read(this.j.readLen),E=m.readUInt8(1),M=(E&128)>>>7;let T=E&127,N=1;T===126?T=m.readUInt8(++N)*2**8+m.readUInt8(++N):T===127&&(T=m.readUInt8(++N)*0+m.readUInt8(++N)*0+m.readUInt8(++N)*0+m.readUInt8(++N)*0+m.readUInt8(++N)*2**24+m.readUInt8(++N)*2**16+m.readUInt8(++N)*2**8+m.readUInt8(++N));let z=0;M&&(z=m.readUInt8(++N)*2**24+m.readUInt8(++N)*2**16+m.readUInt8(++N)*2**8+m.readUInt8(++N)),this.j.state=3,this.j.readLen=T,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const m=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",m),p(m,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",m),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(m,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await n.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class s extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:P.VSBuffer.alloc(0)}constructor(a,m,E,M,T,N){super(),this.l=a,this.m=T,this.n=N,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new n.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new n.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,m?(this.b=this.B(new h(this.l,M,E,{windowBits:15})),this.f=this.B(new f(this.l,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(a){this.g.push(a),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const a=this.g.shift();if(this.f){const m=await this.s(this.f,a);this.n(m,!0)}else this.n(a,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(a,m){return new Promise((E,M)=>{a.write(m),a.flush(T=>E(T))})}acceptFrame(a,m,E){this.h.push({data:a,isCompressed:m,isLastFrameOfMessage:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const a=this.h.shift();if(this.b&&a.isCompressed){const m=await this.w(this.b,a.data,a.isLastFrameOfMessage);this.m.fire(m)}else this.m.fire(a.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(a,m,E){return new Promise((M,T)=>{a.write(m),E&&a.write(P.VSBuffer.fromByteArray([0,0,255,255])),a.flush(N=>M(N))})}}class h extends R.Disposable{get recordedInflateBytes(){return this.j?P.VSBuffer.concat(this.f):P.VSBuffer.alloc(0)}constructor(a,m,E,M){super(),this.h=a,this.j=m,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=b().zlib.createInflateRaw(M),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(P.VSBuffer.wrap(T))}),E&&(this.h.traceSocketEvent("zlibInflateInitialWrite",E.buffer),this.b.write(E.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(a){this.j&&this.f.push(a.clone()),this.h.traceSocketEvent("zlibInflateWrite",a),this.b.write(a.buffer)}flush(a){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const m=P.VSBuffer.concat(this.g);this.g.length=0,a(m)})}}class f extends R.Disposable{constructor(a,m){super(),this.g=a,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.b=b().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",E=>{this.g.traceSocketEvent("zlibDeflateError",{message:E?.message,code:E?.code}),this.a.fire(E)}),this.b.on("data",E=>{this.g.traceSocketEvent("zlibDeflateData",E),this.f.push(P.VSBuffer.wrap(E))})}write(a){this.g.traceSocketEvent("zlibDeflateWrite",a.buffer),this.b.write(a.buffer)}flush(a){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let m=P.VSBuffer.concat(this.f);this.f.length=0,m=m.slice(0,m.byteLength-4),a(m)})}}function p(l,a){if(a===0)return;const m=l.byteLength>>>2;for(let K=0;K<m;K++){const ae=l.readUInt32BE(K*4);l.writeUInt32BE(ae^a,K*4)}const E=m*4,M=l.byteLength-E,T=a>>>24&255,N=a>>>16&255,z=a>>>8&255;M>=1&&l.writeUInt8(l.readUInt8(E)^T,E),M>=2&&l.writeUInt8(l.readUInt8(E+1)^N,E+1),M>=3&&l.writeUInt8(l.readUInt8(E+2)^z,E+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const v={[2]:107,[1]:103};function C(){const l=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;const a=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:b().os.tmpdir(),m=(0,D.join)(a,`vscode-ipc-${l}.sock`);return c(m),m}e.createRandomIPCHandle=C;function t(l,a,m){const E=b().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${m}-${a}-sock`;const M=m.substr(0,4),T=a.substr(0,6),N=E.substr(0,8);let z;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?z=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${N}-${M}-${T}.sock`):z=(0,D.join)(l,`${M}-${T}.sock`),c(z),z}e.createStaticIPCHandle=t;function c(l){const a=v[k.platform];typeof a=="number"&&l.length>=a&&console.warn(`WARNING: IPC handle "${l}" is longer than ${a} chars, try a shorter --user-data-dir`)}class i extends d.IPCServer{static b(a){const m=n.Event.fromNodeEventEmitter(a,"connection");return n.Event.map(m,E=>({protocol:new y.Protocol(new I(E,"ipc-server-connection")),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(E,"close"))}))}constructor(a){super(i.b(a)),this.d=a}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function o(l){return new Promise((a,m)=>{const E=b().net.createServer();E.on("error",m),E.listen(l,()=>{E.removeListener("error",m),a(new i(E))})})}e.serve=o;function r(l,a){return new Promise((m,E)=>{const M=b().net.createConnection(l,()=>{M.removeListener("error",E),m(y.Client.fromSocket(new I(M,`ipc-client${a}`),a))});M.once("error",E)})}e.connect=r}),define(ie[106],se([0,1,7,3,2,10]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D=e.StorageHint||(e.StorageHint={}));function k(b){const I=b;return I?.changed instanceof Map||I?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var g;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class d extends n.Disposable{constructor(I,u=Object.create(null)){super(),this.m=I,this.n=u,this.b=this.B(new A.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new P.ThrottledDelayer(d.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(I=>this.r(I)))}r(I){I.changed?.forEach((u,w)=>this.s(w,u)),I.deleted?.forEach(u=>this.s(u,void 0))}s(I,u){if(this.c===g.Closed)return;let w=!1;(0,R.isUndefinedOrNull)(u)?w=this.f.delete(I):this.f.get(I)!==u&&(this.f.set(I,u),w=!0),w&&this.b.fire(I)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(I,u){const w=this.f.get(I);return(0,R.isUndefinedOrNull)(w)?u:w}getBoolean(I,u){const w=this.get(I);return(0,R.isUndefinedOrNull)(w)?u:w==="true"}getNumber(I,u){const w=this.get(I);return(0,R.isUndefinedOrNull)(w)?u:parseInt(w,10)}async set(I,u){if(this.c===g.Closed)return;if((0,R.isUndefinedOrNull)(u))return this.delete(I);const w=String(u);if(this.f.get(I)!==w)return this.f.set(I,w),this.j.set(I,w),this.h.delete(I),this.b.fire(I),this.w()}async delete(I){if(!(this.c===g.Closed||!this.f.delete(I)))return this.h.has(I)||this.h.add(I),this.j.delete(I),this.b.fire(I),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const I={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(I).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(I){if(!!this.u)return this.w(I)}async w(I){return this.g.trigger(()=>this.v(),I)}async whenFlushed(){if(!!this.u)return new Promise(I=>this.l.push(I))}isInMemory(){return this.n.hint===D.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}d.a=100,e.Storage=d;class y{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(I){I.insert?.forEach((u,w)=>this.a.set(w,u)),I.delete?.forEach(u=>this.a.delete(u))}async close(){}}e.InMemoryStorageDatabase=y}),define(ie[156],se([0,1,7,3,35,9,23]),function(X,e,P,A,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class k{get onDidChangeItemsExternal(){return A.Event.None}constructor(y,b=Object.create(null)){this.g=y,this.h=b,this.c=(0,R.basename)(this.g),this.d=new g(this.h.logging),this.f=this.n(this.g)}async getItems(){const y=await this.f,b=new Map;return(await this.s(y,"SELECT * FROM ItemTable")).forEach(u=>b.set(u.key,u.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${b.size} rows`),b}async updateItems(y){const b=await this.f;return this.j(b,y)}j(y,b){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${b.insert?(0,n.mapToString)(b.insert):"0"}), delete(${b.delete?(0,n.setToString)(b.delete):"0"})`),this.t(y,()=>{const I=b.insert,u=b.delete;if(I&&I.size>0){const w=[];w.push([]);let S=0;I.forEach((s,h)=>{let f=w[S];f.length>k.b&&(S++,f=[],w.push(f)),f.push(h,s)}),w.forEach(s=>{this.u(y,`INSERT INTO ItemTable VALUES ${new Array(s.length/2).fill("(?,?)").join(",")}`,h=>h.run(s),()=>{const h=[];let f=0;return I.forEach((p,v)=>{h.push(v),f+=p.length}),`Keys: ${h.join(", ")} Length: ${f}`})})}if(u&&u.size){const w=[];w.push([]);let S=0;u.forEach(s=>{let h=w[S];h.length>k.b&&(S++,h=[],w.push(h)),h.push(s)}),w.forEach(s=>{this.u(y,`DELETE FROM ItemTable WHERE key IN (${new Array(s.length).fill("?").join(",")})`,h=>h.run(s),()=>{const h=[];return u.forEach(f=>{h.push(f)}),`Keys: ${h.join(", ")}`})})}})}async close(y){this.d.trace(`[storage ${this.c}] close()`);const b=await this.f;return this.k(b,y)}k(y,b){return new Promise((I,u)=>{y.db.close(w=>(w&&this.o(y,`[storage ${this.c}] close(): ${w}`),this.g===k.IN_MEMORY_PATH?I():!y.isErroneous&&!y.isInMemory?this.l().then(I,S=>(this.d.error(`[storage ${this.c}] backup(): ${S}`),I())):typeof b=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(S=>{const s=()=>this.k(S,void 0);return this.j(S,{insert:b()}).then(()=>s(),h=>(s(),Promise.reject(h)))})).then(I,u):u(w||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const y=this.m(this.g);return D.Promises.copy(this.g,y,{preserveSymlinks:!1})}m(y){return`${y}.backup`}async checkIntegrity(y){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${y})`);const b=await this.f,I=await this.r(b,y?"PRAGMA integrity_check":"PRAGMA quick_check"),u=y?I.integrity_check:I.quick_check;return b.isErroneous?`${u} (last error: ${b.lastError})`:b.isInMemory?`${u} (in-memory!)`:u}async n(y,b=!0){this.d.trace(`[storage ${this.c}] open(${y}, retryOnBusy: ${b})`);try{return await this.p(y)}catch(I){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${I}`),I.code==="SQLITE_BUSY"&&b)return await(0,P.timeout)(k.a),this.n(y,!1);try{await D.Promises.unlink(y);try{await D.Promises.rename(this.m(y),y)}catch{}return await this.p(y)}catch(u){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${u}`),this.p(k.IN_MEMORY_PATH)}}}o(y,b){y.isErroneous=!0,y.lastError=b,this.d.error(b)}p(y){return new Promise((b,I)=>{new Promise((u,w)=>{X(["@vscode/sqlite3"],u,w)}).then(u=>{const w={db:new(this.d.isTracing?u.verbose().Database:u.Database)(y,S=>S?w.db&&S.code!=="SQLITE_CANTOPEN"?w.db.close(()=>I(S)):I(S):this.q(w,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(w),s=>w.db.close(()=>I(s)))),isInMemory:y===k.IN_MEMORY_PATH};w.db.on("error",S=>this.o(w,`[storage ${this.c}] Error (event): ${S}`)),this.d.isTracing&&w.db.on("trace",S=>this.d.trace(`[storage ${this.c}] Trace (event): ${S}`))},I)})}q(y,b){return new Promise((I,u)=>{y.db.exec(b,w=>w?(this.o(y,`[storage ${this.c}] exec(): ${w}`),u(w)):I())})}r(y,b){return new Promise((I,u)=>{y.db.get(b,(w,S)=>w?(this.o(y,`[storage ${this.c}] get(): ${w}`),u(w)):I(S))})}s(y,b){return new Promise((I,u)=>{y.db.all(b,(w,S)=>w?(this.o(y,`[storage ${this.c}] all(): ${w}`),u(w)):I(S))})}t(y,b){return new Promise((I,u)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),b(),y.db.run("END TRANSACTION",w=>w?(this.o(y,`[storage ${this.c}] transaction(): ${w}`),u(w)):I())})})}u(y,b,I,u){const w=y.db.prepare(b),S=s=>{this.o(y,`[storage ${this.c}] prepare(): ${s} (${b}). Details: ${u()}`)};w.on("error",S),I(w),w.finalize(s=>{s&&S(s),w.removeListener("error",S)})}}k.IN_MEMORY_PATH=":memory:",k.a=2e3,k.b=256,e.SQLiteStorageDatabase=k;class g{constructor(y){y&&typeof y.logTrace=="function"&&process.env[g.VSCODE_TRACE_STORAGE]&&(this.a=y.logTrace),y&&typeof y.logError=="function"&&(this.b=y.logError)}get isTracing(){return!!this.a}trace(y){this.a?.(y)}error(y){this.b?.(y)}}g.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ie[157],se([12,11]),function(X,e){return X.create("vs/code/electron-main/app",e)}),define(ie[158],se([12,11]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[159],se([12,11]),function(X,e){return X.create("vs/platform/dialogs/common/dialogs",e)}),define(ie[160],se([12,11]),function(X,e){return X.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ie[161],se([12,11]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(ie[162],se([12,11]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(ie[163],se([12,11]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[164],se([12,11]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[165],se([12,11]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[166],se([12,11]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[167],se([12,11]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ie[168],se([12,11]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(ie[169],se([12,11]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ie[170],se([12,11]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(ie[171],se([12,11]),function(X,e){return X.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ie[172],se([12,11]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[173],se([12,11]),function(X,e){return X.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ie[174],se([12,11]),function(X,e){return X.create("vs/platform/menubar/electron-main/menubar",e)}),define(ie[175],se([12,11]),function(X,e){return X.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ie[176],se([12,11]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(ie[177],se([12,11]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(ie[178],se([12,11]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[179],se([12,11]),function(X,e){return X.create("vs/platform/update/common/update.config.contribution",e)}),define(ie[180],se([12,11]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[181],se([12,11]),function(X,e){return X.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ie[182],se([12,11]),function(X,e){return X.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ie[183],se([12,11]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(ie[184],se([12,11]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ie[185],se([12,11]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ie[186],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function P(n){return n&&n.hasOwnProperty("folderUri")}e.isFolderBackupInfo=P;function A(n){return n&&n.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=A}),define(ie[187],se([0,1,8]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function A(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=A;function n(D){let k=[];try{Array.isArray(D.workspaces)&&(k=D.workspaces.map(g=>({workspace:{id:g.id,configPath:P.URI.parse(g.configURIPath)},remoteAuthority:g.remoteAuthority})))}catch{}return k}e.deserializeWorkspaceInfos=n;function R(D){let k=[];try{Array.isArray(D.folders)&&(k=D.folders.map(g=>({folderUri:P.URI.parse(g.folderUri),remoteAuthority:g.remoteAuthority})))}catch{}return k}e.deserializeFolderInfos=R}),define(ie[188],se([0,1,13]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var A;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(A=e.TokenType||(e.TokenType={}));class n{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(D){if(D.type!==19)throw(0,P.illegalArgument)(`expected an error token but got ${JSON.stringify(D)}`);switch(D.lexeme){case"=":return`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you mean '||'?`;default:{const k=D.lexeme;return k&&k.length>1&&k.startsWith("'")?`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you forget to close the string?`:k&&k.length>1&&k.endsWith("'")?`Unexpected token '${D.lexeme}' at offset ${D.offset}. Did you forget to open the string?`:`Unexpected token '${D.lexeme}' at offset ${D.offset}`}}}static getLexeme(D){switch(D.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return D.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return D.lexeme;case 18:return D.lexeme;case 19:return D.lexeme;case 20:return"EOF";default:throw(0,P.illegalState)(`unhandled token type: ${JSON.stringify(D)}; have you forgotten to add a case?`)}}get errorTokens(){return this.g}reset(D){return this.c=D,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:this.k(this.h(61)?4:2);break;case 39:this.o();break;case 47:this.q();break;case 61:this.h(61)?this.k(3):this.h(126)?this.k(9):this.l();break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l();break;case 124:this.h(124)?this.k(16):this.l();break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(D){return this.r()||this.c.charCodeAt(this.e)!==D?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(D){this.f.push({type:D,offset:this.d})}l(){const D={type:19,offset:this.d,lexeme:this.c.substring(this.d,this.e)};this.g.push(D),this.f.push(D)}n(){this.m.lastIndex=this.d;const D=this.m.exec(this.c);if(D){this.e=this.d+D[0].length;const k=this.c.substring(this.d,this.e),g=n.b.get(k);g?this.k(g):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l();return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let D=this.e,k=!1,g=!1;for(;;){if(D>=this.c.length){this.e=D,this.l();return}const y=this.c.charCodeAt(D);if(k)k=!1;else if(y===47&&!g){D++;break}else y===91?g=!0:y===92?k=!0:y===93&&(g=!1);D++}for(;D<this.c.length&&n.a.has(this.c.charCodeAt(D));)D++;this.e=D;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}n.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0))),n.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=n}),define(ie[189],se([0,1,3,2]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class n{constructor(){this.a=new P.Emitter,this.b=new P.Emitter,this.c=new P.Emitter,this.d=new P.Emitter}call(k,g,d){switch(g){case"close":return Promise.resolve(this.a.fire({sessionId:d[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:d[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:d[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:d[0],port:d[1],subId:d[2]}))}throw new Error("Method not implemented.")}listen(k,g,d){switch(g){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}n.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=n;class R extends A.Disposable{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,g,d){this.b.call("attach",[k,g,d])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,g){this.b.call("terminate",[k,g])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,g){return this.b.call("openExtensionDevelopmentHostWindow",[k,g])}}e.ExtensionHostDebugChannelClient=R}),define(ie[190],se([0,1,142,55,14,9,36,18,8]),function(X,e,P,A,n,R,D,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class d{get appRoot(){return(0,R.dirname)(n.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",u)}return g.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(g.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=D.env.VSCODE_PORTABLE;return u?g.URI.file((0,R.join)(u,"argv.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,R.resolve)(u):(0,R.normalize)((0,R.join)(n.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?g.URI.file((0,R.resolve)(u)):g.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,R.resolve)(u);const w=D.env.VSCODE_EXTENSIONS;if(w)return w;const S=D.env.VSCODE_PORTABLE;return S?(0,R.join)(S,"extensions"):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(w=>/^[^:/?#]+?:\/\//.test(w)?g.URI.parse(w):g.URI.file((0,R.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?g.URI.parse(u):g.URI.file((0,R.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(u))}get extensionLogLevel(){const u=[];for(const w of this.args.log||[]){const S=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(w);S&&S[1]&&S[2]&&u.push([S[1],S[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=D.env.VSCODE_PORTABLE;return u?g.URI.file((0,R.join)(u,"policy.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,w,S){this.a=u,this.b=w,this.c=S,this.editSessionId=this.args.editSessionId}}ye([A.memoize],d.prototype,"appRoot",null),ye([A.memoize],d.prototype,"userHome",null),ye([A.memoize],d.prototype,"userDataPath",null),ye([A.memoize],d.prototype,"appSettingsHome",null),ye([A.memoize],d.prototype,"tmpDir",null),ye([A.memoize],d.prototype,"cacheHome",null),ye([A.memoize],d.prototype,"stateResource",null),ye([A.memoize],d.prototype,"userRoamingDataHome",null),ye([A.memoize],d.prototype,"userDataSyncHome",null),ye([A.memoize],d.prototype,"sync",null),ye([A.memoize],d.prototype,"machineSettingsResource",null),ye([A.memoize],d.prototype,"workspaceStorageHome",null),ye([A.memoize],d.prototype,"localHistoryHome",null),ye([A.memoize],d.prototype,"keyboardLayoutResource",null),ye([A.memoize],d.prototype,"argvResource",null),ye([A.memoize],d.prototype,"isExtensionDevelopment",null),ye([A.memoize],d.prototype,"untitledWorkspacesHome",null),ye([A.memoize],d.prototype,"installSourcePath",null),ye([A.memoize],d.prototype,"builtinExtensionsPath",null),ye([A.memoize],d.prototype,"extensionsPath",null),ye([A.memoize],d.prototype,"extensionDevelopmentLocationURI",null),ye([A.memoize],d.prototype,"extensionDevelopmentKind",null),ye([A.memoize],d.prototype,"extensionTestsLocationURI",null),ye([A.memoize],d.prototype,"debugExtensionHost",null),ye([A.memoize],d.prototype,"logLevel",null),ye([A.memoize],d.prototype,"extensionLogLevel",null),ye([A.memoize],d.prototype,"serviceMachineIdResource",null),ye([A.memoize],d.prototype,"disableTelemetry",null),ye([A.memoize],d.prototype,"disableWorkspaceTrust",null),ye([A.memoize],d.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=d;function y(I,u){return b(I["inspect-extensions"],I["inspect-brk-extensions"],5870,u,I.debugId,I.extensionEnvironment)}e.parseExtensionHostDebugPort=y;function b(I,u,w,S,s,h){const p=Number(u||I)||(S?null:w),v=p?Boolean(!!u):!1;let C;if(h)try{C=JSON.parse(h)}catch{}return{port:p,break:v,debugId:s,env:C}}e.parseDebugParams=b}),define(ie[107],se([0,1,288,4,161]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,n.localize)(0,null),e:(0,n.localize)(1,null),t:(0,n.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,n.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,n.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,n.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,n.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,n.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,n.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,n.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,n.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,n.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,n.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,n.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,n.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,n.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,n.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,n.localize)(17,null)},category:{type:"string",cat:"e",description:(0,n.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,n.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,n.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,n.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,n.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,n.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,n.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,n.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,n.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,n.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,n.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,n.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,n.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,n.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,n.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,n.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,n.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,n.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(S,s,h=D){const f=S.find(l=>l.length>0&&l[0]!=="-"),p={},v=["_"],C=[],t={};let c;for(const l in s){const a=s[l];a.type==="subcommand"?l===f&&(c=a):(a.alias&&(p[l]=a.alias),a.type==="string"||a.type==="string[]"?(v.push(l),a.deprecates&&v.push(...a.deprecates)):a.type==="boolean"&&(C.push(l),a.deprecates&&C.push(...a.deprecates)),a.global&&(t[l]=a))}if(c&&f){const l=t;for(const M in c.options)l[M]=c.options[M];const a=S.filter(M=>M!==f),m=h.getSubcommandReporter?h.getSubcommandReporter(f):void 0,E=k(a,l,m);return{[f]:E,_:[]}}const i=P(S,{string:v,boolean:C,alias:p}),o={},r=i;o._=i._.map(l=>String(l)).filter(l=>l.length>0),delete r._;for(const l in s){const a=s[l];if(a.type==="subcommand")continue;a.alias&&delete r[a.alias];let m=r[l];if(a.deprecates)for(const E of a.deprecates)r.hasOwnProperty(E)&&(m||(m=r[E],m&&h.onDeprecatedOption(E,a.deprecationMessage||(0,n.localize)(36,null,l))),delete r[E]);if(typeof m<"u"){if(a.type==="string[]"){if(Array.isArray(m)||(m=[m]),!a.allowEmptyValue){const E=m.filter(M=>M.length>0);E.length!==m.length&&(h.onEmptyValue(l),m=E.length>0?E:void 0)}}else a.type==="string"&&(Array.isArray(m)?(m=m.pop(),h.onMultipleValues(l,m)):!m&&!a.allowEmptyValue&&(h.onEmptyValue(l),m=void 0));o[l]=m,a.deprecationMessage&&h.onDeprecatedOption(l,a.deprecationMessage)}delete r[l]}for(const l in r)h.onUnknownOption(l);return o}e.parseArgs=k;function g(S,s){let h="";return s.args&&(Array.isArray(s.args)?h=` <${s.args.join("> <")}>`:h=` <${s.args}>`),s.alias?`-${s.alias} --${S}${h}`:`--${S}${h}`}function d(S,s){const h=[];for(const f in S){const p=S[f],v=g(f,p);h.push([v,p.description])}return y(h,s)}e.formatOptions=d;function y(S,s){const f=S.reduce((C,t)=>Math.max(C,t[0].length),12)+2+1;if(s-f<25)return S.reduce((C,t)=>C.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const p=s-f-1,v=[];for(const C of S){const t=C[0],c=I(C[1],p),i=b(f-t.length-2);v.push("  "+t+i+c[0]);for(let o=1;o<c.length;o++)v.push(b(f)+c[o])}return v}function b(S){return" ".repeat(S)}function I(S,s){const h=[];for(;S.length;){const f=S.length<s?S.length:S.lastIndexOf(" ",s),p=S.slice(0,f).trim();S=S.slice(f),h.push(p)}return h}function u(S,s,h,f,p){const v=process.stdout.isTTY&&process.stdout.columns||80,C=p?.noInputFiles!==!0?`[${(0,n.localize)(37,null)}...]`:"",t=[`${S} ${h}`];t.push(""),t.push(`${(0,n.localize)(38,null)}: ${s} [${(0,n.localize)(39,null)}]${C}`),t.push(""),p?.noPipe!==!0&&(A.isWindows?t.push((0,n.localize)(40,null,s)):t.push((0,n.localize)(41,null,s)),t.push(""));const c={},i=[];for(const o in f){const r=f[o];if(r.type==="subcommand")r.description&&i.push({command:o,description:r.description});else if(r.description&&r.cat){let l=c[r.cat];l||(c[r.cat]=l={}),l[o]=r}}for(const o in c){const r=o,l=c[r];l&&(t.push(R[r]),t.push(...d(l,v)),t.push(""))}return i.length&&(t.push((0,n.localize)(42,null)),t.push(...y(i.map(o=>[o.command,o.description]),v)),t.push("")),t.join(`
`)}e.buildHelpMessage=u;function w(S,s){return`${S||(0,n.localize)(43,null)}
${s||(0,n.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=w}),define(ie[191],se([0,1,82,189,107]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends A.ExtensionHostDebugBroadcastChannel{constructor(k){super(),this.f=k}call(k,g,d){return g==="openExtensionDevelopmentHostWindow"?this.g(d[0],d[1]):super.call(k,g,d)}async g(k,g){const d=(0,n.parseArgs)(k,n.OPTIONS);d.debugRenderer=g;const y=d.extensionDevelopmentPath;if(!y)return{success:!1};const[b]=await this.f.openExtensionDevelopmentHostWindow(y,{context:5,cli:d,forceProfile:d.profile,forceTempProfile:d["profile-temp"]});if(!g)return{success:!0};const I=b.win;if(!I)return{success:!0};const u=I.webContents.debugger;let w=u.isAttached()?1/0:0;const S=(0,P.createServer)(s=>{w++===0&&u.attach();let h=!1;const f=C=>{h||s.write(JSON.stringify(C)+"\0")},p=(C,t,c,i)=>f({method:t,params:c,sessionId:i});I.on("close",()=>{u.removeListener("message",p),s.end(),h=!0}),u.addListener("message",p);let v=Buffer.alloc(0);s.on("data",C=>{v=Buffer.concat([v,C]);for(let t=v.indexOf(0);t!==-1;t=v.indexOf(0)){let c;try{const i=v.slice(0,t).toString("utf8");v=v.slice(t+1),c=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}u.sendCommand(c.method,c.params,c.sessionId).then(i=>f({id:c.id,sessionId:c.sessionId,result:i})).catch(i=>f({id:c.id,sessionId:c.sessionId,error:{code:0,message:i.message}}))}}),s.on("error",C=>{console.error("error on cdp pipe:",C)}),s.on("close",()=>{h=!0,--w===0&&u.detach()})});return await new Promise(s=>S.listen(0,s)),I.on("close",()=>S.close()),{rendererDebugPort:S.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(ie[62],se([0,1,289,162,107]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function D(I,u){const w=(v,C)=>{console.warn((0,A.localize)(0,null,v,C))},S=v=>{console.warn((0,A.localize)(1,null,v))},s=(v,C)=>{console.warn((0,A.localize)(2,null,v,C))},h=v=>({onUnknownOption:C=>{v!=="tunnel"&&console.warn((0,A.localize)(3,null,C,v))},onMultipleValues:w,onEmptyValue:S,onDeprecatedOption:s,getSubcommandReporter:v!=="tunnel"?h:void 0}),f={onUnknownOption:v=>{console.warn((0,A.localize)(4,null,v))},onMultipleValues:w,onEmptyValue:S,onDeprecatedOption:s,getSubcommandReporter:h},p=(0,n.parseArgs)(I,n.OPTIONS,u?f:void 0);return p.goto&&p._.forEach(v=>P(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,A.localize)(5,null))),p["max-memory"]&&P(parseInt(p["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),p}function k(I){const u=I.findIndex(w=>!/^-/.test(w));if(u>-1)return[...I.slice(0,u),...I.slice(u+1)]}function g(I){let[,...u]=I;process.env.VSCODE_DEV&&(u=k(u)||[]);const w=!b(process.env);return D(u,w)}e.parseMainProcessArgv=g;function d(I){let[,,...u]=I;return process.env.VSCODE_DEV&&(u=k(u)||[]),D(u,!0)}e.parseCLIProcessArgv=d;function y(I,...u){const w=I.indexOf("--");return w===-1?I.push(...u):I.splice(w,0,...u),I}e.addArg=y;function b(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function X(e,P,A){function n(D,k){const g=R(D,k),d=[g];return e.isAbsolute(g)||d.unshift(A),e.resolve(...d)}function R(D,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,k);const y=D["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(b,"AppData","Roaming")}break;case"darwin":d=e.join(P.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,k)}return{getUserDataPath:n}}if(typeof define=="function")define(ie[192],se([193,27,36]),function(e,P,A){return X(e,P,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=X(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[108],se([0,1,27,190,192]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class R extends A.AbstractNativeEnvironmentService{constructor(d,y){super(d,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,n.getUserDataPath)(d,y.nameShort)},y)}}e.NativeEnvironmentService=R;function D(g,d){return(0,A.parseDebugParams)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,d,g.extensionEnvironment)}e.parsePtyHostDebugPort=D;function k(g,d){return(0,A.parseDebugParams)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,d,g.extensionEnvironment)}e.parseSharedProcessDebugPort=k}),define(ie[194],se([0,1,41,27,32]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(D){const k=(0,n.randomPath)((0,A.tmpdir)());try{return(0,P.writeFileSync)(k,""),D&&console.log(`Marker file for --wait created: ${k}`),k}catch(g){D&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.createWaitMarkerFileSync=R}),define(ie[195],se([0,1,10,164]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function n(D,k,g){try{R(D,k,g)}catch(d){console.error(d?.message??d)}return D}e.localizeManifest=n;function R(D,k,g){const d=(y,b,I)=>{const u=y[b];if((0,P.isString)(u)){const w=u,S=w.length;if(S>1&&w[0]==="%"&&w[S-1]==="%"){const s=w.substr(1,S-2);let h=k[s];h===void 0&&g&&(h=g[s]);const f=typeof h=="string"?h:h?.message,p=g?.[s],v=typeof p=="string"?p:p?.message;if(!f){v||console.warn(`[${D.name}]: ${(0,A.localize)(0,null,s)}`);return}if(I&&(b==="title"||b==="category")&&v&&v!==f){const C={value:f,original:v};y[b]=C}else y[b]=f}}else if((0,P.isObject)(u))for(const w in u)u.hasOwnProperty(w)&&(w==="commands"?d(u,w,!0):d(u,w,I));else if(Array.isArray(u))for(let w=0;w<u.length;w++)d(u,w,I)};for(const y in D)D.hasOwnProperty(y)&&d(D,y)}}),define(ie[196],se([0,1,18,73,166,197]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function g(h){return h=h.trim(),h==="*"||D.test(h)}e.isValidVersionStr=g;function d(h){if(!g(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(D);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=d;function y(h){if(!h)return null;const f=h.majorBase,p=h.majorMustEqual,v=h.minorBase;let C=h.minorMustEqual;const t=h.patchBase;let c=h.patchMustEqual;h.hasCaret&&(f===0||(C=!1),c=!1);let i=0;if(h.preRelease){const o=k.exec(h.preRelease);if(o){const[,r,l,a]=o;i=Date.UTC(Number(r),Number(l)-1,Number(a))}}return{majorBase:f,majorMustEqual:p,minorBase:v,minorMustEqual:C,patchBase:t,patchMustEqual:c,isMinimum:h.hasGreaterEquals,notBefore:i}}e.normalizeVersion=y;function b(h,f,p){let v;typeof h=="string"?v=y(d(h)):v=h;let C;f instanceof Date?C=f.getTime():typeof f=="string"&&(C=new Date(f).getTime());let t;if(typeof p=="string"?t=y(d(p)):t=p,!v||!t)return!1;const c=v.majorBase,i=v.minorBase,o=v.patchBase;let r=t.majorBase,l=t.minorBase,a=t.patchBase;const m=t.notBefore;let E=t.majorMustEqual,M=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?c>r?!0:c<r?!1:i>l?!0:i<l||C&&C<m?!1:o>=a:(c===1&&r===0&&(!E||!M||!T)&&(r=1,l=0,a=0,E=!0,M=!1,T=!1),c<r?!1:c>r?!E:i<l?!1:i>l?!M:o<a?!1:o>a?!T:!(C&&C<m))}e.isValidVersion=b;function I(h,f,p,v,C){const t=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return t.push([A.default.Error,n.localize(0,null)]),t;if(typeof v.name!="string")return t.push([A.default.Error,n.localize(1,null,"name")]),t;if(typeof v.version!="string")return t.push([A.default.Error,n.localize(2,null,"version")]),t;if(!v.engines)return t.push([A.default.Error,n.localize(3,null,"engines")]),t;if(typeof v.engines.vscode!="string")return t.push([A.default.Error,n.localize(4,null,"engines.vscode")]),t;if(typeof v.extensionDependencies<"u"&&!s(v.extensionDependencies))return t.push([A.default.Error,n.localize(5,null,"extensionDependencies")]),t;if(typeof v.activationEvents<"u"){if(!s(v.activationEvents))return t.push([A.default.Error,n.localize(6,null,"activationEvents")]),t;if(typeof v.main>"u"&&typeof v.browser>"u")return t.push([A.default.Error,n.localize(7,null,"activationEvents","main")]),t}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&t.push([A.default.Warning,n.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return t.push([A.default.Error,n.localize(9,null,"main")]),t;{const o=(0,P.joinPath)(p,v.main);(0,P.isEqualOrParent)(o,p)||t.push([A.default.Warning,n.localize(10,null,o.path,p.path)])}if(typeof v.activationEvents>"u")return t.push([A.default.Error,n.localize(11,null,"activationEvents","main")]),t}if(typeof v.browser<"u"){if(typeof v.browser!="string")return t.push([A.default.Error,n.localize(12,null,"browser")]),t;{const o=(0,P.joinPath)(p,v.browser);(0,P.isEqualOrParent)(o,p)||t.push([A.default.Warning,n.localize(13,null,o.path,p.path)])}if(typeof v.activationEvents>"u")return t.push([A.default.Error,n.localize(14,null,"activationEvents","browser")]),t}if(!R.valid(v.version))return t.push([A.default.Error,n.localize(15,null)]),t;const c=[];if(!u(h,f,v,C,c))for(const o of c)t.push([A.default.Error,o]);return t}e.validateExtensionManifest=I;function u(h,f,p,v,C){return v||typeof p.main>"u"&&typeof p.browser>"u"?!0:S(h,f,p.engines.vscode,C)}e.isValidExtensionVersion=u;function w(h,f,p){return h==="*"||S(f,p,h)}e.isEngineValid=w;function S(h,f,p,v=[]){const C=y(d(p));if(!C)return v.push(n.localize(16,null,p)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return v.push(n.localize(17,null,p)),!1}else if(!C.majorMustEqual)return v.push(n.localize(18,null,p)),!1;return b(h,f,C)?!0:(v.push(n.localize(19,null,h,p)),!1)}function s(h){if(!Array.isArray(h))return!1;for(let f=0,p=h.length;f<p;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ie[198],se([0,1,17,31]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function n(R,D,k){let g=k&&k.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const y=(await D.readFile(R.serviceMachineIdResource)).value.toString();g=(0,A.isUUID)(y)?y:null}catch{g=null}if(!g){g=(0,A.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,P.VSBuffer.fromString(g))}catch{}}return k?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=n}),define(ie[74],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class P{constructor(n,R=[],D=!1){this.ctor=n,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=P}),define(ie[199],se([0,1,74]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var n;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(n=e.InstantiationType||(e.InstantiationType={}));function R(k,g,d){g instanceof P.SyncDescriptor||(g=new P.SyncDescriptor(g,[],Boolean(d))),A.push([k,g])}e.registerSingleton=R;function D(){return A}e.getSingletonServiceDescriptors=D}),define(ie[200],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class P{constructor(R,D){this.key=R,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=P;class A{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const D of this.a.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const k=this.lookupOrInsertNode(R),g=this.lookupOrInsertNode(D);k.outgoing.set(g.key,g),g.incoming.set(k.key,k)}removeNode(R){const D=this.b(R);this.a.delete(D);for(const k of this.a.values())k.outgoing.delete(D),k.incoming.delete(D)}lookupOrInsertNode(R){const D=this.b(R);let k=this.a.get(D);return k||(k=new P(D,R),this.a.set(D,k)),k}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[D,k]of this.a)R.push(`${D}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this.a){const k=new Set([R]),g=this.c(D,k);if(g)return g}}c(R,D){for(const[k,g]of R.outgoing){if(D.has(k))return[...D,k].join(" -> ");D.add(k);const d=this.c(g,D);if(d)return d;D.delete(k)}}}e.Graph=A}),define(ie[6],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var P;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function k(g){return g[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=k})(P=e._util||(e._util={})),e.IInstantiationService=n("instantiationService");function A(D,k,g){k[P.DI_TARGET]===k?k[P.DI_DEPENDENCIES].push({id:D,index:g}):(k[P.DI_DEPENDENCIES]=[{id:D,index:g}],k[P.DI_TARGET]=k)}function n(D){if(P.serviceIds.has(D))return P.serviceIds.get(D);const k=function(g,d,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(k,g,y)};return k.toString=()=>D,P.serviceIds.set(D,k),k}e.createDecorator=n;function R(D){return D}e.refineServiceDecorator=R}),define(ie[63],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,P.createDecorator)("backupMainService")}),define(ie[19],se([0,1,10,8,6]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,n.createDecorator)("configurationService");function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof A.URI)}e.isConfigurationOverrides=R;function D(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=D;var k;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function d(s,h){const f=Object.create(null);for(const p in s)y(f,p,s[p],h);return f}e.toValuesTree=d;function y(s,h,f,p){const v=h.split("."),C=v.pop();let t=s;for(let c=0;c<v.length;c++){const i=v[c];let o=t[i];switch(typeof o){case"undefined":o=t[i]=Object.create(null);break;case"object":break;default:p(`Ignoring ${h} as ${v.slice(0,c+1).join(".")} is ${JSON.stringify(o)}`);return}t=o}if(typeof t=="object"&&t!==null)try{t[C]=f}catch{p(`Ignoring ${h} as ${v.join(".")} is ${JSON.stringify(t)}`)}else p(`Ignoring ${h} as ${v.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=y;function b(s,h){const f=h.split(".");I(s,f)}e.removeFromValueTree=b;function I(s,h){const f=h.shift();if(h.length===0){delete s[f];return}if(Object.keys(s).indexOf(f)!==-1){const p=s[f];typeof p=="object"&&!Array.isArray(p)&&(I(p,h),Object.keys(p).length===0&&delete s[f])}}function u(s,h,f){function p(t,c){let i=t;for(const o of c){if(typeof i!="object"||i===null)return;i=i[o]}return i}const v=h.split("."),C=p(s,v);return typeof C>"u"?f:C}e.getConfigurationValue=u;function w(s,h,f){Object.keys(h).forEach(p=>{p!=="__proto__"&&(p in s?P.isObject(s[p])&&P.isObject(h[p])?w(s[p],h[p],f):f&&(s[p]=h[p]):s[p]=h[p])})}e.merge=w;function S(s){return s.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=S}),define(ie[201],se([0,1,4,25,188,6]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",P.isMacintosh),D.set("isLinux",P.isLinux),D.set("isWindows",P.isWindows),D.set("isWeb",P.isWeb),D.set("isMacNative",P.isMacintosh&&!P.isWeb),D.set("isEdge",P.isEdge),D.set("isFirefox",P.isFirefox),D.set("isChrome",P.isChrome),D.set("isSafari",P.isSafari);const k=Object.prototype.hasOwnProperty;var g;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(g=e.ContextKeyExprType||(e.ContextKeyExprType={}));class d{static false(){return w.INSTANCE}static true(){return S.INSTANCE}static has(F){return s.create(F)}static equals(F,$){return h.create(F,$)}static notEquals(F,$){return v.create(F,$)}static regex(F,$){return l.create(F,$)}static in(F,$){return f.create(F,$)}static notIn(F,$){return p.create(F,$)}static not(F){return C.create(F)}static and(...F){return E.create(F,null,!0)}static or(...F){return M.create(F,null,!0)}static greater(F,$){return c.create(F,$)}static greaterEquals(F,$){return i.create(F,$)}static smaller(F,$){return o.create(F,$)}static smallerEquals(F,$){return r.create(F,$)}static deserializeOrErrorNew(F){if(!F)return{type:"error",lexingErrors:[],parsingErrors:[]};const $=new b,V=$.parse(F);return V===void 0?{type:"error",lexingErrors:$.lexingErrors.map(x=>n.Scanner.reportError(x)),parsingErrors:$.parsingErrors}:{type:"ok",expr:V}}static deserialize(F){if(!!F)return this.c(F)}static c(F){const $=F.split("||");return M.create($.map(V=>this.d(V)),null,!0)}static d(F){const $=F.split("&&");return E.create($.map(V=>this.f(V)),null,!0)}static f(F){if(F=F.trim(),F.indexOf("!=")>=0){const $=F.split("!=");return v.create($[0].trim(),this.g($[1]))}if(F.indexOf("==")>=0){const $=F.split("==");return h.create($[0].trim(),this.g($[1]))}if(F.indexOf("=~")>=0){const $=F.split("=~");return l.create($[0].trim(),this.h($[1]))}if(F.indexOf(" not in ")>=0){const $=F.split(" not in ");return p.create($[0].trim(),this.g($[1]))}if(F.indexOf(" in ")>=0){const $=F.split(" in ");return f.create($[0].trim(),this.g($[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const $=F.split(">=");return i.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const $=F.split(">");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const $=F.split("<=");return r.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const $=F.split("<");return o.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(F)?C.create(F.substr(1).trim()):s.create(F)}static g(F){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const $=/^'([^']*)'$/.exec(F);return $?$[1].trim():F}static h(F){if((0,A.isFalsyOrWhitespace)(F))return null;const $=F.indexOf("/"),V=F.lastIndexOf("/");if($===V||$<0)return null;const x=F.slice($+1,V),H=F[V+1]==="i"?"i":"";try{return new RegExp(x,H)}catch{return null}}}e.ContextKeyExpr=d;class y extends Error{}class b{constructor(){this.c=new n.Scanner,this.d=[],this.f=0,this.g=[]}get lexingErrors(){return this.c.errorTokens}get parsingErrors(){return this.g}parse(F){if(F===""){this.g.push("Expected an expression but got an empty string");return}this.d=this.c.reset(F).scan(),this.f=0,this.g=[];try{const $=this.h();if(!this.D())throw this.z(this.C());return $}catch($){if(!($ instanceof y)){const V=this.C();this.g.push(`Unexpected error: ${$} for token ${n.Scanner.getLexeme(V)} at offset ${V.offset}.`)}return}}h(){return this.k()}k(){const F=[this.l()];for(;this.v(16);){const $=this.l();F.push($)}return F.length===1?F[0]:d.or(...F)}l(){const F=[this.o()];for(;this.v(15);){const $=this.o();F.push($)}return F.length===1?F[0]:d.and(...F)}o(){if(this.v(2)){const F=this.C();switch(F.type){case 17:return this.w(),d.not(F.lexeme);case 11:return this.w(),d.false();case 12:return this.w(),d.true();default:throw this.y("KEY, 'true', or 'false'",F)}}return this.s()}s(){const F=this.C();switch(F.type){case 11:return this.w(),d.true();case 12:return this.w(),d.false();case 0:{this.w();const $=this.h();return this.x(1,"')'"),$}case 17:{const $=F.lexeme;if(this.w(),this.v(9)){const x=this.C();switch(x.type){case 10:case 19:{const H=[x.lexeme];this.w();let O=this.C(),G=0;for(let W=0;W<x.lexeme.length;W++)x.lexeme.charCodeAt(W)===40?G++:x.lexeme.charCodeAt(W)===41&&G--;for(;!this.D()&&O.type!==15&&O.type!==16;){switch(O.type){case 0:G++;break;case 1:G--;break;case 10:case 18:for(let W=0;W<O.lexeme.length;W++)O.lexeme.charCodeAt(W)===40?G++:x.lexeme.charCodeAt(W)===41&&G--}if(G<0)break;H.push(n.Scanner.getLexeme(O)),this.w(),O=this.C()}const _=H.join(""),re=_.lastIndexOf("/"),oe=re===_.length-1?void 0:_.substring(re+1),L=new RegExp(_.substring(1,re),oe);return d.regex($,L)}case 18:{const H=x.lexeme;this.w();let O=null;if(!(0,A.isFalsyOrWhitespace)(H)){const G=H.indexOf("/"),_=H.lastIndexOf("/");if(G!==_&&G>=0){const re=H.slice(G+1,_),oe=H[_+1]==="i"?"i":"";try{O=new RegExp(re,oe)}catch{}}}if(O===null)throw this.y("REGEX",x);return l.create($,O)}default:throw this.y("REGEX",this.C())}}if(this.v(14)){this.x(13,"'in' after 'not'");const x=this.t();return d.notIn($,x)}switch(this.C().type){case 3:{this.w();const x=this.t();switch(x){case"true":return d.has($);case"false":return d.not($);default:return d.equals($,x)}}case 4:{this.w();const x=this.t();switch(x){case"true":return d.not($);case"false":return d.has($);default:return d.notEquals($,x)}}case 5:return this.w(),o.create($,this.t());case 6:return this.w(),r.create($,this.t());case 7:return this.w(),c.create($,this.t());case 8:return this.w(),i.create($,this.t());case 13:return this.w(),d.in($,this.t());default:return d.has($)}}default:throw this.y("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this.C())}}t(){const F=this.C();switch(F.type){case 17:case 18:return this.w(),F.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(F){return this.B(F)?(this.w(),!0):!1}w(){return this.D()||this.f++,this.u()}x(F,$){if(this.B(F))return this.w();throw this.y($,this.C())}y(F,$){return this.A(`Expected ${F} but got '${n.Scanner.getLexeme($)}' at offset ${$.offset}.`)}z(F){return this.A(`Unexpected '${n.Scanner.getLexeme(F)}' at offset ${F.offset}.`)}A(F){return this.g.push(F),new y}B(F){return this.C().type===F}C(){return this.d[this.f]}D(){return this.C().type===20}}e.Parser=b;function I(te,F){const $=te?te.substituteConstants():void 0,V=F?F.substituteConstants():void 0;return!$&&!V?!0:!$||!V?!1:$.equals(V)}e.expressionsAreEqualWithConstantSubstitution=I;function u(te,F){return te.cmp(F)}class w{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return S.INSTANCE}}w.INSTANCE=new w,e.ContextKeyFalseExpr=w;class S{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return w.INSTANCE}}S.INSTANCE=new S,e.ContextKeyTrueExpr=S;class s{static create(F,$=null){const V=D.get(F);return typeof V=="boolean"?V?S.INSTANCE:w.INSTANCE:new s(F,$)}constructor(F,$){this.key=F,this.c=$,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:N(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=D.get(this.key);return typeof F=="boolean"?F?S.INSTANCE:w.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=s;class h{static create(F,$,V=null){if(typeof $=="boolean")return $?s.create(F,V):C.create(F,V);const x=D.get(F);return typeof x=="boolean"?$===(x?"true":"false")?S.INSTANCE:w.INSTANCE:new h(F,$,V)}constructor(F,$,V){this.c=F,this.d=$,this.f=V,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:z(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=D.get(this.c);if(typeof F=="boolean"){const $=F?"true":"false";return this.d===$?S.INSTANCE:w.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class f{static create(F,$){return new f(F,$)}constructor(F,$){this.d=F,this.f=$,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:z(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const $=F.getValue(this.f),V=F.getValue(this.d);return Array.isArray($)?$.includes(V):typeof V=="string"&&typeof $=="object"&&$!==null?k.call($,V):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=f;class p{static create(F,$){return new p(F,$)}constructor(F,$){this.d=F,this.f=$,this.type=11,this.c=f.create(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=p;class v{static create(F,$,V=null){if(typeof $=="boolean")return $?C.create(F,V):s.create(F,V);const x=D.get(F);return typeof x=="boolean"?$===(x?"true":"false")?w.INSTANCE:S.INSTANCE:new v(F,$,V)}constructor(F,$,V){this.c=F,this.d=$,this.f=V,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:z(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=D.get(this.c);if(typeof F=="boolean"){const $=F?"true":"false";return this.d===$?w.INSTANCE:S.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=v;class C{static create(F,$=null){const V=D.get(F);return typeof V=="boolean"?V?w.INSTANCE:S.INSTANCE:new C(F,$)}constructor(F,$){this.c=F,this.d=$,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:N(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=D.get(this.c);return typeof F=="boolean"?F?w.INSTANCE:S.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=s.create(this.c,this)),this.d}}e.ContextKeyNotExpr=C;function t(te,F){if(typeof te=="string"){const $=parseFloat(te);isNaN($)||(te=$)}return typeof te=="string"||typeof te=="number"?F(te):w.INSTANCE}class c{static create(F,$,V=null){return t($,x=>new c(F,x,V))}constructor(F,$,V){this.c=F,this.d=$,this.f=V,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:z(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=c;class i{static create(F,$,V=null){return t($,x=>new i(F,x,V))}constructor(F,$,V){this.c=F,this.d=$,this.f=V,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:z(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=i;class o{static create(F,$,V=null){return t($,x=>new o(F,x,V))}constructor(F,$,V){this.c=F,this.d=$,this.f=V,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:z(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=o;class r{static create(F,$,V=null){return t($,x=>new r(F,x,V))}constructor(F,$,V){this.c=F,this.d=$,this.f=V,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:z(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=c.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class l{static create(F,$){return new l(F,$)}constructor(F,$){this.d=F,this.f=$,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const $=this.f?this.f.source:"",V=F.f?F.f.source:"";return $<V?-1:$>V?1:0}equals(F){if(F.type===this.type){const $=this.f?this.f.source:"",V=F.f?F.f.source:"";return this.d===F.d&&$===V}return!1}substituteConstants(){return this}evaluate(F){const $=F.getValue(this.d);return this.f?this.f.test($):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=a.create(this)),this.c}}e.ContextKeyRegexExpr=l;class a{static create(F){return new a(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new a(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=a;function m(te){let F=null;for(let $=0,V=te.length;$<V;$++){const x=te[$].substituteConstants();if(te[$]!==x&&F===null){F=[];for(let H=0;H<$;H++)F[H]=te[H]}F!==null&&(F[$]=x)}return F===null?te:F}class E{static create(F,$,V){return E.d(F,$,V)}constructor(F,$){this.expr=F,this.c=$,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,V=this.expr.length;$<V;$++){const x=u(this.expr[$],F.expr[$]);if(x!==0)return x}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,V=this.expr.length;$<V;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=m(this.expr);return F===this.expr?this:E.create(F,this.c,!1)}evaluate(F){for(let $=0,V=this.expr.length;$<V;$++)if(!this.expr[$].evaluate(F))return!1;return!0}static d(F,$,V){const x=[];let H=!1;for(const O of F)if(!!O){if(O.type===1){H=!0;continue}if(O.type===0)return w.INSTANCE;if(O.type===6){x.push(...O.expr);continue}x.push(O)}if(x.length===0&&H)return S.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(u);for(let O=1;O<x.length;O++)x[O-1].equals(x[O])&&(x.splice(O,1),O--);if(x.length===1)return x[0];for(;x.length>1;){const O=x[x.length-1];if(O.type!==9)break;x.pop();const G=x.pop(),_=x.length===0,re=M.create(O.expr.map(oe=>E.create([oe,G],null,V)),null,_);re&&(x.push(re),x.sort(u))}if(x.length===1)return x[0];if(V){for(let O=0;O<x.length;O++)for(let G=O+1;G<x.length;G++)if(x[O].negate().equals(x[G]))return w.INSTANCE;if(x.length===1)return x[0]}return new E(x,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const $ of this.expr)F.push(...$.keys());return F}map(F){return new E(this.expr.map($=>$.map(F)),null)}negate(){if(!this.c){const F=[];for(const $ of this.expr)F.push($.negate());this.c=M.create(F,this,!0)}return this.c}}class M{static create(F,$,V){return M.d(F,$,V)}constructor(F,$){this.expr=F,this.c=$,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,V=this.expr.length;$<V;$++){const x=u(this.expr[$],F.expr[$]);if(x!==0)return x}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,V=this.expr.length;$<V;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=m(this.expr);return F===this.expr?this:M.create(F,this.c,!1)}evaluate(F){for(let $=0,V=this.expr.length;$<V;$++)if(this.expr[$].evaluate(F))return!0;return!1}static d(F,$,V){let x=[],H=!1;if(F){for(let O=0,G=F.length;O<G;O++){const _=F[O];if(!!_){if(_.type===0){H=!0;continue}if(_.type===1)return S.INSTANCE;if(_.type===9){x=x.concat(_.expr);continue}x.push(_)}}if(x.length===0&&H)return w.INSTANCE;x.sort(u)}if(x.length!==0){if(x.length===1)return x[0];for(let O=1;O<x.length;O++)x[O-1].equals(x[O])&&(x.splice(O,1),O--);if(x.length===1)return x[0];if(V){for(let O=0;O<x.length;O++)for(let G=O+1;G<x.length;G++)if(x[O].negate().equals(x[G]))return S.INSTANCE;if(x.length===1)return x[0]}return new M(x,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const $ of this.expr)F.push(...$.keys());return F}map(F){return new M(this.expr.map($=>$.map(F)),null)}negate(){if(!this.c){const F=[];for(const $ of this.expr)F.push($.negate());for(;F.length>1;){const $=F.shift(),V=F.shift(),x=[];for(const H of le($))for(const O of le(V))x.push(E.create([H,O],null,!1));F.unshift(M.create(x,null,!1))}this.c=M.create(F,this,!0)}return this.c}}class T extends s{static all(){return T.d.values()}constructor(F,$,V){super(F,null),this.f=$,typeof V=="object"?T.d.push({...V,key:F}):V!==!0&&T.d.push({key:F,description:V,type:$!=null?typeof $:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return h.create(this.key,F)}notEqualsTo(F){return v.create(this.key,F)}}T.d=[],e.RawContextKey=T,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function N(te,F){return te<F?-1:te>F?1:0}function z(te,F,$,V){return te<$?-1:te>$?1:F<V?-1:F>V?1:0}function K(te,F){if(te.type===0||F.type===1)return!0;if(te.type===9)return F.type===9?ae(te.expr,F.expr):!1;if(F.type===9){for(const $ of F.expr)if(K(te,$))return!0;return!1}if(te.type===6){if(F.type===6)return ae(F.expr,te.expr);for(const $ of te.expr)if(K($,F))return!0;return!1}return te.equals(F)}e.implies=K;function ae(te,F){let $=0,V=0;for(;$<te.length&&V<F.length;){const x=te[$].cmp(F[V]);if(x<0)return!1;x===0&&$++,V++}return $===te.length}function le(te){return te.type===9?te.expr:[te]}}),define(ie[75],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,P.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,P.createDecorator)("credentialsMainService");class A{constructor(){this.a={}}async getPassword(R,D){return this.a[R]?.[D]??null}async setPassword(R,D,k){this.a[R]=this.a[R]??{},this.a[R][D]=k}async deletePassword(R,D){return this.a[R]?.[D]?(delete this.a[R][D],Object.keys(this.a[R]).length===0&&delete this.a[R],!0):!1}async findPassword(R){return JSON.stringify(this.a[R])??null}async findCredentials(R){const D=[];for(const k of Object.keys(this.a[R]||{}))D.push({account:k,password:this.a[R][k]});return D}async clear(){this.a={}}}e.InMemoryCredentialsProvider=A}),define(ie[87],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,P.createDecorator)(e.ID);function A(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=A;class n{async getPerformanceInfo(D,k){return{}}async getSystemInfo(D,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,k){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.NullDiagnosticsService=n}),define(ie[88],se([0,1,18,73,159,6,45,4,37]),function(X,e,P,A,n,R,D,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,R.createDecorator)("dialogService");var d;(function(S){S[S.Confirmation=1]="Confirmation",S[S.Prompt=2]="Prompt",S[S.Input=3]="Input"})(d||(d={}));class y{a(s){return this.d(s,d.Confirmation)}b(s){return this.d(s,d.Prompt)}c(s){return this.d(s,d.Input)}d(s,h){const f=[];switch(h){case d.Confirmation:{const p=s;p.primaryButton?f.push(p.primaryButton):f.push((0,n.localize)(0,null)),p.cancelButton?f.push(p.cancelButton):f.push((0,n.localize)(1,null));break}case d.Prompt:{const p=s;Array.isArray(p.buttons)&&p.buttons.length>0&&f.push(...p.buttons.map(v=>v.label)),p.cancelButton&&(p.cancelButton===!0?f.push((0,n.localize)(2,null)):typeof p.cancelButton=="string"?f.push(p.cancelButton):p.cancelButton.label?f.push(p.cancelButton.label):f.push((0,n.localize)(3,null))),f.length===0&&f.push((0,n.localize)(4,null));break}case d.Input:{const p=s;p.primaryButton?f.push(p.primaryButton):f.push((0,n.localize)(5,null)),p.cancelButton?f.push(p.cancelButton):f.push((0,n.localize)(6,null));break}}return f}e(s){if(typeof s=="string")return s;if(typeof s=="number")return s===A.default.Info?"info":s===A.default.Error?"error":s===A.default.Warning?"warning":"none"}async f(s,h,f){const p=[...s.buttons??[]];return s.cancelButton&&typeof s.cancelButton!="string"&&typeof s.cancelButton!="boolean"&&p.push(s.cancelButton),{result:await p[h]?.run({checkboxChecked:f}),checkboxChecked:f}}}e.AbstractDialogHandler=y,e.IFileDialogService=(0,R.createDecorator)("fileDialogService");var b;(function(S){S[S.SAVE=0]="SAVE",S[S.DONT_SAVE=1]="DONT_SAVE",S[S.CANCEL=2]="CANCEL"})(b=e.ConfirmResult||(e.ConfirmResult={}));const I=10;function u(S){const s=[];return s.push(...S.slice(0,I).map(h=>typeof h=="string"?h:(0,P.basename)(h))),S.length>I&&(S.length-I===1?s.push((0,n.localize)(7,null)):s.push((0,n.localize)(8,null,S.length-I))),s.push(""),s.join(`
`)}e.getFileNamesMessage=u;function w(S,s){const h=(0,g.deepClone)(S);let f=(h.buttons??[]).map(t=>(0,D.mnemonicButtonLabel)(t)),p=(S.buttons||[]).map((t,c)=>c),v=0,C=h.cancelId??f.length-1;if(f.length>1){const t=typeof C=="number"?f[C]:void 0;if(k.isLinux||k.isMacintosh){if(typeof t=="string"&&f.length>1&&C!==1){f.splice(C,1),f.splice(1,0,t);const c=p[C];p.splice(C,1),p.splice(1,0,c),C=1}k.isLinux&&f.length>1&&(f=f.reverse(),p=p.reverse(),v=f.length-1,typeof t=="string"&&(C=v-1))}else if(k.isWindows&&typeof t=="string"&&f.length>1&&C!==f.length-1){f.splice(C,1),f.push(t);const c=p[C];p.splice(C,1),p.push(c),C=f.length-1}}return h.buttons=f,h.defaultId=v,h.cancelId=C,h.noLink=!0,h.title=h.title||s.nameLong,{options:h,buttonIndeces:p}}e.massageMessageBoxOptions=w}),define(ie[109],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,P.createDecorator)("encryptionMainService")}),define(ie[34],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,P.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,P.refineServiceDecorator)(e.IEnvironmentService)}),define(ie[28],se([0,1,55,9,86,34,108,6]),function(X,e,P,A,n,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(R.IEnvironmentService);class g extends D.NativeEnvironmentService{get cachedLanguagesPath(){return(0,A.join)(this.userDataPath,"clp")}get backupHome(){return(0,A.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,A.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ye([P.memoize],g.prototype,"cachedLanguagesPath",null),ye([P.memoize],g.prototype,"backupHome",null),ye([P.memoize],g.prototype,"mainIPCHandle",null),ye([P.memoize],g.prototype,"mainLockfile",null),ye([P.memoize],g.prototype,"disableUpdates",null),ye([P.memoize],g.prototype,"disableKeytar",null),ye([P.memoize],g.prototype,"crossOriginIsolated",null),ye([P.memoize],g.prototype,"codeCachePath",null),ye([P.memoize],g.prototype,"useCodeCache",null),e.EnvironmentMainService=g}),define(ie[110],se([0,1,163,6]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function n(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function R(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(h,f){switch(h){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function k(h,f){return f==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function g(h,f,p){return k(f,p)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===p?!0:d(p).includes(h)}e.isTargetPlatformCompatible=g;function d(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=d;function y(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=y;var b;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var I;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(I=e.SortOrder||(e.SortOrder={}));var u;(function(h){h.Install="install",h.Uninstall="uninstall"})(u=e.StatisticType||(e.StatisticType={}));var w;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var S;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class s extends Error{constructor(f,p){super(f),this.code=p,this.name=p}}e.ExtensionManagementError=s,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,P.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,P.localize)(1,null),original:"Preferences"}}),define(ie[202],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,P.createDecorator)("extensionUrlTrustService")}),define(ie[203],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,P.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ie[111],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,P.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,P.createDecorator)("externalTerminal")}),define(ie[204],se([0,1,46,14,9,4,71,23,85,167,111]),function(X,e,P,A,n,R,D,k,g,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=d.localize(0,null);class I{async getDefaultTerminalForPlatforms(){return{windows:u.getDefaultTerminalWindows(),linux:await S.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class u extends I{openTerminal(v,C){return this.spawnTerminal(P,v,g.getWindowsShell(),C)}spawnTerminal(v,C,t,c){const i=C.windowsExec||u.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const o=n.basename(i,".exe").toLowerCase();if(o==="cmder")return v.spawn(i,c?[c]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return i.indexOf(" ")>=0&&r.push('""'),r.push(i),o==="wt"&&r.push("-d ."),new Promise((l,a)=>{const m=s(process),E=v.spawn(t,r,{cwd:c,env:m});E.on("error",a),E.on("exit",()=>l())})}runInTerminal(v,C,t,c,i){const o="windowsExec"in i&&i.windowsExec?i.windowsExec:u.getDefaultTerminalWindows();return new Promise((r,l)=>{const a=`"${C} - ${b}"`,m=`""${t.join('" "')}" & pause"`,E=Object.assign({},s(process),c);Object.keys(E).filter(K=>E[K]===null).forEach(K=>delete E[K]);const M={cwd:C,env:E,windowsVerbatimArguments:!0};let T,N;n.basename(o,".exe")==="wt"?(T=o,N=["-d",".",u.b,"/c",m]):(T=u.b,N=["/c","start",a,"/wait",o,"/c",m]),P.spawn(T,N,M).on("error",K=>{l(h(K))}),r(void 0)})}static getDefaultTerminalWindows(){if(!u.d){const v=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");u.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${v?"Sysnative":"System32"}\\cmd.exe`}return u.d}}u.b="cmd.exe",e.WindowsExternalTerminalService=u;class w extends I{openTerminal(v,C){return this.spawnTerminal(P,v,C)}runInTerminal(v,C,t,c,i){const o=i.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((r,l)=>{if(o===y.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const a=o===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",E=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`).fsPath,"-t",v||b,"-w",C];for(const N of t)E.push("-a"),E.push(N);if(c){const N=Object.assign({},s(process),c);for(const z in N){const K=N[z];K===null?(E.push("-u"),E.push(z)):(E.push("-e"),E.push(`${z}=${K}`))}}let M="";const T=P.spawn(w.b,E);T.on("error",N=>{l(h(N))}),T.stderr.on("data",N=>{M+=N.toString()}),T.on("exit",N=>{if(N===0)r(void 0);else if(M){const z=M.split(`
`,1);l(new Error(z[0]))}else l(new Error(d.localize(1,null,a,N)))})}else l(new Error(d.localize(2,null,o)))})}spawnTerminal(v,C,t){const c=C.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((i,o)=>{const r=["-a",c];t&&r.push(t);const l=s(process),a=v.spawn("/usr/bin/open",r,{cwd:t,env:l});a.on("error",o),a.on("exit",()=>i())})}}w.b="/usr/bin/osascript",e.MacExternalTerminalService=w;class S extends I{openTerminal(v,C){return this.spawnTerminal(P,v,C)}runInTerminal(v,C,t,c,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):S.getDefaultTerminalLinuxReady();return new Promise((r,l)=>{const a=[];o.then(m=>{m.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const E=`${f(t)}; echo; read -p "${S.b}" -n1;`;a.push(`''${E}''`);const M=Object.assign({},s(process),c);Object.keys(M).filter(K=>M[K]===null).forEach(K=>delete M[K]);const T={cwd:C,env:M};let N="";const z=P.spawn(m,a,T);z.on("error",K=>{l(h(K))}),z.stderr.on("data",K=>{N+=K.toString()}),z.on("exit",K=>{if(K===0)r(void 0);else if(N){const ae=N.split(`
`,1);l(new Error(ae[0]))}else l(new Error(d.localize(4,null,m,K)))})})})}static async getDefaultTerminalLinuxReady(){if(!S.d)if(!R.isLinux)S.d=Promise.resolve("xterm");else{const v=await k.Promises.exists("/etc/debian_version");S.d=new Promise(C=>{v?C("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?C("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?C("konsole"):process.env.COLORTERM?C(process.env.COLORTERM):process.env.TERM?C(process.env.TERM):C("xterm")})}return S.d}spawnTerminal(v,C,t){const c=C.linuxExec?Promise.resolve(C.linuxExec):S.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{c.then(r=>{const l=s(process),a=v.spawn(r,[],{cwd:t,env:l});a.on("error",o),a.on("exit",()=>i())})})}}S.b=d.localize(3,null),e.LinuxExternalTerminalService=S;function s(p){const v={...p.env};return(0,D.sanitizeProcessEnvironment)(v),v}function h(p){return"errno"in p&&p.errno==="ENOENT"&&"path"in p&&typeof p.path=="string"?new Error(d.localize(5,null,p.path)):p}function f(p){let v="";for(const C of p)C.indexOf(" ")>=0?v+='"'+C+'"':v+=C,v+=" ";return v}}),define(ie[16],se([0,1,61,9,25,10,8,169,6,4,14]),function(X,e,P,A,n,R,D,k,g,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,g.createDecorator)("fileService");function b(O){return O.create===!0}e.isFileOpenForWriteOptions=b;var I;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var u;(function(O){O[O.Readonly=1]="Readonly"})(u=e.FilePermission||(e.FilePermission={}));var w;(function(O){O[O.None=0]="None",O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock",O[O.FileAtomicRead=16384]="FileAtomicRead",O[O.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=S;function s(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=s;function h(O){return!!(O.capabilities&32768)}e.hasFileCloneCapability=h;function f(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function p(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=p;function v(O){return S(O)?!!(O.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var C;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(G,_){const re=new t(G.toString(),_);return o(re,_),re}constructor(G,_){super(G),this.code=_}}e.FileSystemProviderError=t;function c(O,G){return t.create(O,G)}e.createFileSystemProviderError=c;function i(O){return O||c((0,k.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=i;function o(O,G){return O.name=G?`${G} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=o;function r(O){if(!O)return C.Unknown;if(O instanceof t)return O.code;const G=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!G)return C.Unknown;switch(G[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=r;function l(O){if(O instanceof N)return O.fileOperationResult;switch(r(O)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var a;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY",O[O.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class m{constructor(G,_,re){this.resource=G,this.operation=_,this.target=re}isOperation(G){return this.operation===G}}e.FileOperationEvent=m;var E;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(E=e.FileChangeType||(e.FileChangeType={}));class M{constructor(G,_){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const re=new Map;for(const oe of G){const L=re.get(oe.type);switch(L?L.push([oe.resource,oe]):re.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,L]of re)switch(oe){case 1:this.a=P.TernarySearchTree.forUris(()=>_),this.a.fill(L);break;case 0:this.b=P.TernarySearchTree.forUris(()=>_),this.b.fill(L);break;case 2:this.c=P.TernarySearchTree.forUris(()=>_),this.c.fill(L);break}}contains(G,..._){return this.d(G,{includeChildren:!1},..._)}affects(G,..._){return this.d(G,{includeChildren:!0},..._)}d(G,_,...re){if(!G)return!1;const oe=re.length>0;return!!((!oe||re.includes(1))&&(this.a?.get(G)||_.includeChildren&&this.a?.findSuperstr(G))||(!oe||re.includes(0))&&(this.b?.get(G)||_.includeChildren&&this.b?.findSuperstr(G))||(!oe||re.includes(2))&&(this.c?.findSubstr(G)||_.includeChildren&&this.c?.findSuperstr(G)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=M;function T(O,G,_){return!O||!G||O===G||G.length>O.length?!1:(G.charAt(G.length-1)!==A.sep&&(G+=A.sep),_?(0,n.startsWithIgnoreCase)(O,G):O.indexOf(G)===0)}e.isParent=T;class N extends Error{constructor(G,_,re){super(G),this.fileOperationResult=_,this.options=re}}e.FileOperationError=N;class z extends N{constructor(G,_,re,oe){super(G,_,oe),this.fileOperationResult=_,this.size=re}}e.TooLargeFileOperationError=z;class K extends N{constructor(G,_,re){super(G,2,re),this.stat=_}}e.NotModifiedSinceFileOperationError=K;var ae;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ae=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var le;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(le=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function te(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=te;async function F(O,G){if(!G.hasProvider(D.URI.from({scheme:O.scheme})))return new Promise(_=>{const re=G.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===O.scheme&&oe.added&&(re.dispose(),_())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(G){return(0,R.isNumber)(G)||(G=0),G<$.KB?(0,k.localize)(1,null,G.toFixed(0)):G<$.MB?(0,k.localize)(2,null,(G/$.KB).toFixed(2)):G<$.GB?(0,k.localize)(3,null,(G/$.MB).toFixed(2)):G<$.TB?(0,k.localize)(4,null,(G/$.GB).toFixed(2)):(0,k.localize)(5,null,(G/$.TB).toFixed(2))}}$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB,e.ByteSize=$;var V;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function x(O){return{maxFileSize:O===0?300*$.MB:16*$.GB,maxHeapSize:O===0?700*$.MB:2*700*$.MB}}e.getPlatformFileLimits=x;function H(O){const G=typeof O=="string"||O?.scheme===y.Schemas.vscodeRemote;return typeof O!="string"&&O?.scheme===y.Schemas.file?1024*$.MB:G?10*$.MB:d.isWeb?50*$.MB:1024*$.MB}e.getLargeFileConfirmationLimit=H}),define(ie[205],se([0,1,17,44,13,3,2,59,8,31,16]),function(X,e,P,A,n,R,D,k,g,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends D.Disposable{constructor(u,w){super(),this.a=u,this.b=w,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.h=(0,d.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,w){const{buffer:S}=await this.a.call("readFile",[u,w]);return S}readFileStream(u,w,S){const s=(0,k.newWriteableStream)(f=>P.VSBuffer.concat(f.map(p=>P.VSBuffer.wrap(p))).buffer),h=this.a.listen("readFileStream",[u,w])(f=>{if(f instanceof P.VSBuffer)s.write(f.buffer);else{if(f==="end")s.end();else{let p;if(f instanceof Error)p=f;else{const v=f;p=(0,y.createFileSystemProviderError)(v.message??(0,A.toErrorMessage)(v),v.code??y.FileSystemProviderErrorCode.Unknown)}s.error(p),s.end()}h.dispose()}});return S.onCancellationRequested(()=>{s.error((0,n.canceled)()),s.end(),h.dispose()}),s}writeFile(u,w,S){return this.a.call("writeFile",[u,P.VSBuffer.wrap(w),S])}open(u,w){return this.a.call("open",[u,w])}close(u){return this.a.call("close",[u])}async read(u,w,S,s,h){const[f,p]=await this.a.call("read",[u,w,h]);return S.set(f.buffer.slice(0,p),s),p}write(u,w,S,s,h){return this.a.call("write",[u,w,P.VSBuffer.wrap(S),s,h])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,w){return this.a.call("delete",[u,w])}rename(u,w,S){return this.a.call("rename",[u,w,S])}copy(u,w,S){return this.a.call("copy",[u,w,S])}cloneFile(u,w){return this.a.call("cloneFile",[u,w])}i(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const w=u;this.f.fire(w.map(S=>({resource:g.URI.revive(S.resource),type:S.type})))}else{const w=u;this.g.fire(w)}}))}watch(u,w){const S=(0,d.generateUuid)();return this.a.call("watch",[this.h,S,u,w]),(0,D.toDisposable)(()=>this.a.call("unwatch",[this.h,S]))}}e.DiskFileSystemProviderClient=b}),define(ie[112],se([0,1,17,13,170,16]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(y,b,I,u,w,S){let s;try{await k(y,b,I,u,w,S)}catch(h){s=h}finally{s&&w.errorTransformer&&(s=w.errorTransformer(s)),typeof s<"u"&&I.error(s),I.end()}}e.readFileIntoStream=D;async function k(y,b,I,u,w,S){g(S);const s=await y.open(b,{create:!1});try{g(S);let h=0,f=0,p=w&&typeof w.length=="number"?w.length:void 0,v=P.VSBuffer.alloc(Math.min(w.bufferSize,typeof p=="number"?p:w.bufferSize)),C=w&&typeof w.position=="number"?w.position:0,t=0;do f=await y.read(s,C,v.buffer,t,v.byteLength-t),C+=f,t+=f,h+=f,typeof p=="number"&&(p-=f),t===v.byteLength&&(await I.write(u(v)),v=P.VSBuffer.alloc(Math.min(w.bufferSize,typeof p=="number"?p:w.bufferSize)),t=0);while(f>0&&(typeof p!="number"||p>0)&&g(S)&&d(h,w));if(t>0){let c=t;typeof p=="number"&&(c=Math.min(t,p)),I.write(u(v.slice(0,c)))}}catch(h){throw(0,R.ensureFileSystemProviderError)(h)}finally{await y.close(s)}}function g(y){if(y.isCancellationRequested)throw(0,A.canceled)();return!0}function d(y,b){if(b?.limits){if(typeof b.limits.memory=="number"&&y>b.limits.memory)throw(0,R.createFileSystemProviderError)((0,n.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&y>b.limits.size)throw(0,R.createFileSystemProviderError)((0,n.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ie[76],se([0,1,101,2,9,4,8,16]),function(X,e,P,A,n,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function g(h){return h.recursive===!0}e.isRecursiveWatchRequest=g;class d extends A.Disposable{constructor(f,p,v,C){super(),this.h=f,this.i=p,this.j=v,this.k=C,this.c=this.B(new A.MutableDisposable),this.f=void 0,this.g=0}m(){const f=new A.DisposableStore;this.c.value=f,this.b=this.l(f),this.b.setVerboseLogging(this.j),f.add(this.b.onDidChangeFile(p=>this.h(p))),f.add(this.b.onDidLogMessage(p=>this.i(p))),f.add(this.b.onDidError(p=>this.n(p)))}n(f){this.k.restartOnError?this.g<d.a&&this.f?(this.r(`restarting watcher after error: ${f}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${f}`):this.r(f)}p(f){this.g++,this.m(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.j=f,await this.b?.setVerboseLogging(f)}r(f){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${f}`})}s(f){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}d.a=5,e.AbstractWatcherClient=d;class y extends d{constructor(f,p,v){super(f,p,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=y;class b extends d{constructor(f,p,v){super(f,p,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function I(h){return h.map(f=>({type:f.type,resource:D.URI.file(f.path)}))}e.toFileChanges=I;function u(h){const f=new s;for(const p of h)f.processEvent(p);return f.coalesce()}e.coalesceEvents=u;function w(h,f){return typeof f=="string"&&!f.startsWith(P.GLOBSTAR)&&!(0,n.isAbsolute)(f)?{base:h,pattern:f}:f}e.normalizeWatcherPattern=w;function S(h,f){const p=[];for(const v of f)p.push((0,P.parse)(w(h,v)));return p}e.parseWatcherPatterns=S;class s{constructor(){this.a=new Set,this.b=new Map}c(f){return R.isLinux?f.path:f.path.toLowerCase()}processEvent(f){const p=this.b.get(this.c(f));let v=!1;if(p){const C=p.type,t=f.type;p.path!==f.path&&(f.type===2||f.type===1)?v=!0:C===1&&t===2?(this.b.delete(this.c(f)),this.a.delete(p)):C===2&&t===1?p.type=0:C===1&&t===0||(p.type=t)}else v=!0;v&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],p=[];return Array.from(this.a).filter(v=>v.type!==2?(f.push(v),!1):!0).sort((v,C)=>v.path.length-C.path.length).filter(v=>p.some(C=>(0,k.isParent)(v.path,C,!R.isLinux))?!1:(p.push(v.path),!0)).concat(f)}}}),define(ie[206],se([0,1,41,7,22,32,2,80,9,4,102,23,76]),function(X,e,P,A,n,R,D,k,g,d,y,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class u extends D.Disposable{constructor(s,h,f,p){super(),this.j=s,this.k=h,this.l=f,this.m=p,this.c=this.B(new A.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},v=>this.k(v))),this.f=this.B(new A.RunOnceWorker(v=>this.u(v),u.b)),this.g=(0,I.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,I.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new n.CancellationTokenSource,this.ready=this.n()}async n(){try{const s=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const h=await b.Promises.stat(s);this.B(await this.s(s,h.isDirectory()))}catch(s){s.code!=="ENOENT"?this.w(s):this.z(s)}}async r(s){let h=s.path;try{h=await b.Promises.realpath(s.path),s.path===h&&(h=await(0,y.realcase)(s.path)??s.path),s.path!==h&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${s.path}, real: ${h})`)}catch{}return h}async s(s,h){if(d.isMacintosh&&(0,R.isEqualOrParent)(s,"/Volumes/",!0))return this.w(`Refusing to watch ${s} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const f=new n.CancellationTokenSource(this.i.token),p=new D.DisposableStore;try{const v=(0,g.basename)(s),C=(0,P.watch)(s);p.add((0,D.toDisposable)(()=>{C.removeAllListeners(),C.close()})),this.z(`Started watching: '${s}'`);const t=new Set;if(h)try{for(const i of await b.Promises.readdir(s))t.add(i)}catch(i){this.w(i)}const c=new Map;p.add((0,D.toDisposable)(()=>{for(const[,i]of c)i.dispose();c.clear()})),C.on("error",(i,o)=>{this.w(`Failed to watch ${s} for changes using fs.watch() (${i}, ${o})`),this.dispose()}),C.on("change",(i,o)=>{if(f.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${o}`);let r="";if(o&&(r=o.toString(),d.isMacintosh&&(r=(0,k.normalizeNFC)(r))),!(!r||i!=="change"&&i!=="rename"))if(h)if(i==="rename"){c.get(r)?.dispose();const l=setTimeout(async()=>{if(c.delete(r),r===v&&!await b.Promises.exists(s)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.v((0,g.join)(s,r));if(f.token.isCancellationRequested)return;let m;a?t.has(r)?m=0:(m=1,t.add(r)):(t.delete(r),m=2),this.t({path:(0,g.join)(this.j.path,r),type:m})},u.a);c.set(r,(0,D.toDisposable)(()=>clearTimeout(l)))}else{let l;t.has(r)?l=0:(l=1,t.add(r)),this.t({path:(0,g.join)(this.j.path,r),type:l})}else if(i==="rename"||r!==v){const l=setTimeout(async()=>{const a=await b.Promises.exists(s);f.token.isCancellationRequested||(a?(this.t({path:this.j.path,type:0},!0),p.add(await this.s(s,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},u.a);p.clear(),p.add((0,D.toDisposable)(()=>clearTimeout(l)))}else this.t({path:this.j.path,type:0},!0)})}catch(v){await b.Promises.exists(s)&&!f.token.isCancellationRequested&&this.w(`Failed to watch ${s} for changes using fs.watch() (${v.toString()})`)}return(0,D.toDisposable)(()=>{f.dispose(!0),p.dispose()})}t(s,h=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.path}`),!h&&this.g.some(f=>f(s.path))?this.m&&this.z(` >> ignored (excluded) ${s.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(f=>f(s.path))?this.m&&this.z(` >> ignored (not included) ${s.path}`):this.f.work(s))}u(s){const h=(0,I.coalesceEvents)(s);if(h.length>0){if(this.m)for(const p of h)this.z(`>> normalized ${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`);this.c.work(h)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(s){if(d.isLinux)return b.Promises.exists(s);try{const h=(0,g.basename)(s);return(await b.Promises.readdir((0,g.dirname)(s))).some(p=>p===h)}catch(h){return this.z(h),!1}}setVerboseLogging(s){this.m=s}w(s){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${s}`})}y(s){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${s}`})}z(s){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${s}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}u.a=100,u.b=75,e.NodeJSFileWatcherLibrary=u;async function w(S,s,h,f,p=512){const v=await b.Promises.open(S,"r"),C=Buffer.allocUnsafe(p),t=new n.CancellationTokenSource(f);let c,i=!1;const o={path:S,excludes:[],recursive:!1},r=new u(o,l=>{(async()=>{for(const{type:a}of l)if(a===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:m}=await b.Promises.read(v,C,0,p,null);if(!m||t.token.isCancellationRequested)break;s(C.slice(0,m))}}catch(m){c=new Error(m),t.dispose(!0)}finally{i=!1}}})()});return await r.ready,h(),new Promise((l,a)=>{t.token.onCancellationRequested(async()=>{r.dispose();try{await b.Promises.close(v)}catch(m){c=new Error(m)}c?a(c):l()})})}e.watchFileContents=w}),define(ie[207],se([0,1,3,101,2,4,206]),function(X,e,P,A,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new P.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new P.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(d){const y=this.i(d),b=y.filter(u=>{const w=this.c.get(u.path);return w?!(0,A.patternsEquals)(w.request.excludes,u.excludes)||!(0,A.patternsEquals)(w.request.includes,u.includes):!0}),I=Array.from(this.c.values()).filter(({request:u})=>!y.find(w=>w.path===u.path&&(0,A.patternsEquals)(w.excludes,u.excludes)&&(0,A.patternsEquals)(w.includes,u.includes))).map(({request:u})=>u.path);b.length&&this.j(`Request to start watching: ${b.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),I.length&&this.j(`Request to stop watching: ${I.join(",")}`);for(const u of I)this.h(u);for(const u of b)this.g(u)}g(d){const y=new D.NodeJSFileWatcherLibrary(d,I=>this.a.fire(I),I=>this.b.fire(I),this.f),b={request:d,instance:y};this.c.set(d.path,b)}async stop(){for(const[d]of this.c)this.h(d);this.c.clear()}h(d){const y=this.c.get(d);y&&(this.c.delete(d),y.instance.dispose())}i(d){const y=new Map;for(const b of d){const I=R.isLinux?b.path:b.path.toLowerCase();y.set(I,b)}return Array.from(y.values())}async setVerboseLogging(d){this.f=d;for(const[,y]of this.c)y.instance.setVerboseLogging(d)}j(d){this.f&&this.b.fire({type:"trace",message:this.k(d)})}k(d,y){return y?`[File Watcher (node.js)] ${d} (path: ${y.request.path})`:`[File Watcher (node.js)] ${d}`}}e.NodeJSWatcher=k}),define(ie[208],se([0,1,76,207]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class n extends P.AbstractNonRecursiveWatcherClient{constructor(D,k,g){super(D,k,g),this.m()}l(){return new A.NodeJSWatcher}}e.NodeJSWatcherClient=n}),define(ie[209],se([0,1,14,47,155,76]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends R.AbstractUniversalWatcherClient{constructor(g,d,y){super(g,d,y),this.m()}l(g){const d=g.add(new n.Client(P.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(d.onDidProcessExit(({code:y,signal:b})=>this.n(`terminated by itself with code ${y}, signal: ${b}`))),A.ProxyChannel.toService((0,A.getNextTickChannel)(d.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(ie[89],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class P{constructor(...n){this.a=new Map;for(const[R,D]of n)this.set(R,D)}set(n,R){const D=this.a.get(n);return this.a.set(n,R),D}has(n){return this.a.has(n)}get(n){return this.a.get(n)}}e.ServiceCollection=P}),define(ie[210],se([0,1,7,13,2,74,200,6,89,99]),function(X,e,P,A,n,R,D,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class b extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class I{constructor(s=new g.ServiceCollection,h=!1,f,p=y){this.f=s,this.g=h,this.h=f,this.i=p,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=p?f?._globalGraph??new D.Graph(v=>v):void 0}createChild(s){return new I(s,this.g,this,this.i)}invokeFunction(s,...h){const f=w.traceInvocation(this.i,s);let p=!1;try{return s({get:C=>{if(p)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(C,f);if(!t)throw new Error(`[invokeFunction] unknown service '${C}'`);return t}},...h)}finally{p=!0,f.stop()}}createInstance(s,...h){let f,p;return s instanceof R.SyncDescriptor?(f=w.traceCreation(this.i,s.ctor),p=this.j(s.ctor,s.staticArguments.concat(h),f)):(f=w.traceCreation(this.i,s),p=this.j(s,h,f)),f.stop(),p}j(s,h=[],f){const p=k._util.getServiceDependencies(s).sort((t,c)=>t.index-c.index),v=[];for(const t of p){const c=this.m(t.id,f);c||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),v.push(c)}const C=p.length>0?p[0].index:h.length;if(h.length!==C){console.trace(`[createInstance] First service dependency of ${s.name} at position ${C+1} conflicts with ${h.length} static arguments`);const t=C-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,C)}return Reflect.construct(s,h.concat(v))}k(s,h){if(this.f.get(s)instanceof R.SyncDescriptor)this.f.set(s,h);else if(this.h)this.h.k(s,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const h=this.f.get(s);return!h&&this.h?this.h.l(s):h}m(s,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const f=this.l(s);return f instanceof R.SyncDescriptor?this.q(s,f,h.branch(s,!0)):(h.branch(s,!1),f)}q(s,h,f){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,h,f)}finally{this.o.delete(s)}}r(s,h,f){const p=new D.Graph(t=>t.id.toString());let v=0;const C=[{id:s,desc:h,_trace:f}];for(;C.length;){const t=C.pop();if(p.lookupOrInsertNode(t),v++>1e3)throw new b(p);for(const c of k._util.getServiceDependencies(t.desc.ctor)){const i=this.l(c.id);if(i||this.u(`[createInstance] ${s} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),i instanceof R.SyncDescriptor){const o={id:c.id,desc:i,_trace:t._trace.branch(c.id,!0)};p.insertEdge(t,o),C.push(o)}}}for(;;){const t=p.roots();if(t.length===0){if(!p.isEmpty())throw new b(p);break}for(const{data:c}of t){if(this.l(c.id)instanceof R.SyncDescriptor){const o=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,o)}p.removeNode(c)}}return this.l(s)}s(s,h,f=[],p,v){if(this.f.get(s)instanceof R.SyncDescriptor)return this.t(s,h,f,p,v);if(this.h)return this.h.s(s,h,f,p,v);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(s,h,f=[],p,v){if(p){const C=new I(void 0,this.g,this,this.i);C.c=String(s);const t=new Map,c=new P.IdleValue(()=>{const i=C.j(h,f,v);for(const[o,r]of t){const l=i[o];if(typeof l=="function")for(const a of r)l.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,o){if(!c.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let a=t.get(o);return a||(a=new d.LinkedList,t.set(o,a)),(E,M,T)=>{const N=a.push([E,M,T]);return(0,n.toDisposable)(N)}}if(o in i)return i[o];const r=c.value;let l=r[o];return typeof l!="function"||(l=l.bind(r),i[o]=l),l},set(i,o,r){return c.value[o]=r,!0},getPrototypeOf(i){return h.prototype}})}else return this.j(h,f,v)}u(s,h){if(h&&console.warn(s),this.g)throw new Error(s)}}e.InstantiationService=I;var u;(function(S){S[S.None=0]="None",S[S.Creation=1]="Creation",S[S.Invocation=2]="Invocation",S[S.Branch=3]="Branch"})(u||(u={}));class w{static traceInvocation(s,h){return s?new w(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(s,h){return s?new w(1,h.name):w.c}constructor(s,h){this.type=s,this.name=h,this.g=Date.now(),this.h=[]}branch(s,h){const f=new w(3,s.toString());return this.h.push([s,h,f]),f}stop(){const s=Date.now()-this.g;w.f+=s;let h=!1;function f(v,C){const t=[],c=new Array(v+1).join("	");for(const[i,o,r]of C.h)if(o&&r){h=!0,t.push(`${c}CREATES -> ${i}`);const l=f(v+1,r);l&&t.push(l)}else t.push(`${c}uses -> ${i}`);return t.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(s>2||h)&&w.all.add(p.join(`
`))}}w.all=new Set,w.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}},w.f=0,e.Trace=w}),define(ie[5],se([0,1,44,3,2,35,4,18,10,8,201,6]),function(X,e,P,A,n,R,D,k,g,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function I(){return new Date().toISOString()}function u(m){return(0,g.isNumber)(m)}e.isLogLevel=u;var w;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function S(m,E,M){switch(E){case w.Trace:m.trace(M);break;case w.Debug:m.debug(M);break;case w.Info:m.info(M);break;case w.Warning:m.warn(M);break;case w.Error:m.error(M);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=S;function s(m){let E="";for(let M=0;M<m.length;M++){let T=m[M];if(typeof T=="object")try{T=JSON.stringify(T)}catch{}E+=(M>0?" ":"")+T}return E}e.format=s;class h extends n.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==w.Off&&this.b<=E}}e.AbstractLogger=h;class f extends h{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...M){this.f(w.Trace)&&this.g(w.Trace,s([E,...M]))}debug(E,...M){this.f(w.Debug)&&this.g(w.Debug,s([E,...M]))}info(E,...M){this.f(w.Info)&&this.g(w.Info,s([E,...M]))}warn(E,...M){this.f(w.Warning)&&this.g(w.Warning,s([E,...M]))}error(E,...M){if(this.f(w.Error))if(E instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=E.stack,this.g(w.Error,s(T))}else this.g(w.Error,s([E,...M]))}flush(){}}e.AbstractMessageLogger=f;class p extends h{constructor(E=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(E),this.g=!D.isWindows}trace(E,...M){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,E,...M):console.log(`[main ${I()}]`,E,...M))}debug(E,...M){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,E,...M):console.log(`[main ${I()}]`,E,...M))}info(E,...M){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,E,...M):console.log(`[main ${I()}]`,E,...M))}warn(E,...M){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,E,...M):console.warn(`[main ${I()}]`,E,...M))}error(E,...M){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,E,...M):console.error(`[main ${I()}]`,E,...M))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class v extends h{constructor(E=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(E)}trace(E,...M){this.f(w.Trace)&&console.log("%cTRACE","color: #888",E,...M)}debug(E,...M){this.f(w.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",E,...M)}info(E,...M){this.f(w.Info)&&console.log("%c INFO","color: #33f",E,...M)}warn(E,...M){this.f(w.Warning)&&console.log("%c WARN","color: #993",E,...M)}error(E,...M){this.f(w.Error)&&console.log("%c  ERR","color: #f33",E,...M)}dispose(){}flush(){}}e.ConsoleLogger=v;class C extends h{constructor(E,M=e.DEFAULT_LOG_LEVEL){super(),this.g=E,this.setLevel(M)}trace(E,...M){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(E),...M])}debug(E,...M){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(E),...M])}info(E,...M){this.f(w.Info)&&this.g.log(w.Info,[this.h(E),...M])}warn(E,...M){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(E),...M])}error(E,...M){this.f(w.Error)&&this.g.log(w.Error,[this.h(E),...M])}h(E){return typeof E=="string"?E:(0,P.toErrorMessage)(E,this.f(w.Trace))}dispose(){}flush(){}}e.AdapterLogger=C;class t extends h{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const M of this.g)M.setLevel(E);super.setLevel(E)}trace(E,...M){for(const T of this.g)T.trace(E,...M)}debug(E,...M){for(const T of this.g)T.debug(E,...M)}info(E,...M){for(const T of this.g)T.info(E,...M)}warn(E,...M){for(const T of this.g)T.warn(E,...M)}error(E,...M){for(const T of this.g)T.error(E,...M)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.MultiplexLogger=t;class c extends n.Disposable{constructor(E,M,T){if(super(),this.h=E,this.j=M,this.b=new R.ResourceMap,this.c=this.B(new A.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeVisibility=this.g.event,T)for(const N of T)this.b.set(N.resource,{logger:void 0,info:N})}k(E){return(0,g.isString)(E)?[...this.b.values()].find(M=>M.info.id===E):this.b.get(E)}getLogger(E){return this.k(E)?.logger}createLogger(E,M){const T=this.l(E);let N=this.b.get(T)?.logger;const z=M?.logLevel==="always"?w.Trace:M?.logLevel;N||(N=this.m(T,z??this.getLogLevel(T)??this.h,M));const K={logger:N,info:{resource:T,id:M?.id??T.toString(),logLevel:z,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(K.info),this.b.set(T,K),N}l(E){return(0,g.isString)(E)?(0,k.joinPath)(this.j,`${E}.log`):E}setLogLevel(E,M){if(d.URI.isUri(E)){const T=E,N=M,z=this.b.get(T);z&&N!==z.info.logLevel&&(z.info.logLevel=N===this.h?void 0:N,z.logger?.setLevel(N),this.b.set(z.info.resource,z),this.f.fire([T,N]))}else{this.h=E;for(const[T,N]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,M){const T=this.k(E);T&&M!==!T.info.hidden&&(T.info.hidden=!M,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,M]))}getLogLevel(E){let M;return E&&(M=this.b.get(E)?.info.logLevel),M??this.h}registerLogger(E){const M=this.b.get(E.resource);M?M.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const M=this.b.get(E);M&&(M.logger&&M.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=c;class i{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(E){}getLevel(){return w.Info}trace(E,...M){}debug(E,...M){}info(E,...M){}warn(E,...M){}error(E,...M){}critical(E,...M){}dispose(){}flush(){}}e.NullLogger=i;class o extends i{}e.NullLogService=o;function r(m){if(m.verbose)return w.Trace;if(typeof m.logLevel=="string"){const E=a(m.logLevel.toLowerCase());if(E!==void 0)return E}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function l(m){switch(m){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.LogLevelToString=l;function a(m){switch(m){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.parseLogLevel=a,e.CONTEXT_LOG_LEVEL=new y.RawContextKey("logLevel",l(w.Info))});var ee=this&&this.__param||function(X,e){return function(P,A){e(P,A,X)}};define(ie[211],se([0,1,75,3,2,5,4,7]),function(X,e,P,A,n,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let g=class ut extends n.Disposable{constructor(y){super(),this.g=y,this.c=this.B(new A.Emitter),this.onDidChangePassword=this.c.event}async getPassword(y,b){this.g.trace("Getting password from keytar:",y,b);let I;try{I=await this.h()}catch{return null}const u=await(0,k.retry)(()=>I.getPassword(y,b),50,3);if(!u)return this.g.trace("Did not get a password from keytar for account:",b),u;let w,S;try{const s=JSON.parse(u);w=s.content,S=s.hasNextChunk}catch{}if(!w||!S)return this.g.trace("Got password from keytar for account:",b),u;try{let s=1;for(;S;){const h=await(0,k.retry)(()=>I.getPassword(y,`${b}-${s}`),50,3),f=JSON.parse(h);w+=f.content,S=f.hasNextChunk,s++}return this.g.trace(`Got ${s}-chunked password from keytar for account:`,b),w}catch(s){return this.g.error(s),u}}async setPassword(y,b,I){this.g.trace("Setting password using keytar:",y,b);let u;try{u=await this.h()}catch(w){throw this.i?.(w),w}if(D.isWindows&&I.length>ut.a){let w=0,S=0,s=!0;for(;s;){const h=I.substring(w,w+ut.b);w+=ut.b,s=I.length-w>0;const f={content:h,hasNextChunk:s};await(0,k.retry)(()=>u.setPassword(y,S?`${b}-${S}`:b,JSON.stringify(f)),50,3),S++}this.g.trace(`Got${S?` ${S}-chunked`:""} password from keytar for account:`,b)}else await(0,k.retry)(()=>u.setPassword(y,b,I),50,3),this.g.trace("Got password from keytar for account:",b);this.c.fire({service:y,account:b})}async deletePassword(y,b){this.g.trace("Deleting password using keytar:",y,b);let I;try{I=await this.h()}catch(h){throw this.i?.(h),h}const u=await I.getPassword(y,b);if(!u)return this.g.trace("Did not get a password to delete from keytar for account:",b),!1;let w,S;try{const h=JSON.parse(u);w=h.content,S=h.hasNextChunk}catch{}let s=0;if(w&&S)try{for(s++;S;){const h=`${b}-${s}`,f=await I.getPassword(y,h);await I.deletePassword(y,h),S=JSON.parse(f).hasNextChunk,s++}}catch(h){this.g.error(h)}return await I.deletePassword(y,b)?(this.c.fire({service:y,account:b}),this.g.trace(`Deleted${s?` ${s}-chunked`:""} password from keytar for account:`,b),!0):(this.g.trace(`Keytar failed to delete${s?` ${s}-chunked`:""} password for account:`,b),!1)}async findPassword(y){let b;try{b=await this.h()}catch{return null}return await b.findPassword(y)}async findCredentials(y){let b;try{b=await this.h()}catch{return[]}return await b.findCredentials(y)}clear(){return this.f instanceof P.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};g.a=2500,g.b=g.a-100,g=ye([ee(0,R.ILogService)],g),e.BaseCredentialsMainService=g}),define(ie[212],se([0,1,5]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let A=class{constructor(R,D){this.a=R,this.b=D}c(){return new Promise((R,D)=>X(["vscode-encrypt"],R,D))}async encrypt(R){let D;try{D=await this.c()}catch{return R}try{return D.encrypt(this.a,R)}catch(k){return this.b.error(k),R}}async decrypt(R){let D;try{D=await this.c()}catch{return R}try{return D.decrypt(this.a,R)}catch(k){return this.b.error(k),R}}};A=ye([ee(1,P.ILogService)],A),e.EncryptionMainService=A}),define(ie[213],se([0,1,26,7,13,3,2,9,76,5]),function(X,e,P,A,n,R,D,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends D.Disposable{constructor(I,u){super(),this.a=I,this.b=u,this.c=this.B(new R.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new A.ThrottledDelayer(0)),this.s=[],this.t=this.B(new A.ThrottledDelayer(0))}watch(I,u){return u.recursive||this.b?.watcher?.forceUniversal?this.l(I,u):this.u(I,u)}l(I,u){const w={path:this.C(I),excludes:u.excludes,includes:u.includes,recursive:u.recursive},S=(0,P.insert)(this.j,w);return this.m(),(0,D.toDisposable)(()=>{S(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(I=>(0,n.onUnexpectedError)(I))}n(){this.h||(this.h=this.B(this.p(u=>this.c.fire((0,g.toFileChanges)(u)),u=>this.z(u),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const I=this.b?.watcher?.recursive?.usePolling;if(I===!0)for(const u of this.j)(0,g.isRecursiveWatchRequest)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(I))for(const u of this.j)(0,g.isRecursiveWatchRequest)(u)&&I.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(I,u){const w={path:this.C(I),excludes:u.excludes,includes:u.includes,recursive:!1},S=(0,P.insert)(this.s,w);return this.v(),(0,D.toDisposable)(()=>{S(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(I=>(0,n.onUnexpectedError)(I))}w(){return this.r||(this.r=this.B(this.y(I=>this.c.fire((0,g.toFileChanges)(I)),I=>this.z(I),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.r.watch(this.s)}z(I){I.type==="error"&&this.g.fire(I.message),this.a[I.type](I.message)}C(I){return(0,k.normalize)(I.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(ie[214],se([0,1,26,7,17,22,3,60,70,2,61,14,64,18,59,168,16,112,5,13]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends d.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new D.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new D.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new D.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new A.ResourceQueue)}registerProvider(t,c){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${t}`);const i=new d.DisposableStore;return this.h.set(t,c),this.c.fire({added:!0,scheme:t,provider:c}),i.add(c.onDidChangeFile(o=>this.R.fire(new s.FileChangesEvent(o,!this.O(c))))),typeof c.onDidWatchError=="function"&&i.add(c.onDidWatchError(o=>this.S.fire(new Error(o)))),i.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:t}))),(0,d.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:c}),this.h.delete(t),(0,d.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const c=[];this.f.fire({scheme:t,join(i){c.push(i)}}),!this.h.has(t)&&await A.Promises.settled(c)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,c){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&c)}listCapabilities(){return g.Iterable.map(this.h,([t,c])=>({scheme:t,capabilities:c.capabilities}))}async j(t){if(!(0,u.isAbsolutePath)(t))throw new s.FileOperationError((0,S.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const c=this.h.get(t.scheme);if(!c){const i=new p.ErrorNoTelemetry;throw i.message=(0,S.localize)(1,null,t.toString()),i}return c}async k(t){const c=await this.j(t);if((0,s.hasOpenReadWriteCloseCapability)(c)||(0,s.hasReadWriteCapability)(c)||(0,s.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const c=await this.j(t);if((0,s.hasOpenReadWriteCloseCapability)(c)||(0,s.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,c){try{return await this.n(t,c)}catch(i){throw(0,s.toFileSystemProviderErrorCode)(i)===s.FileSystemProviderErrorCode.FileNotFound?new s.FileOperationError((0,S.localize)(2,null,this.nb(t)),1):(0,s.ensureFileSystemProviderError)(i)}}async n(t,c){const i=await this.j(t),o=this.O(i),r=c?.resolveTo,l=c?.resolveSingleChildDescendants,a=c?.resolveMetadata,m=await i.stat(t);let E;return this.p(i,t,m,void 0,!!a,(M,T)=>(E||(E=y.TernarySearchTree.forUris(()=>!o),E.set(t,!0),r&&E.fill(!0,r)),E.get(M.resource)||E.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&l?T===1:!1))}async p(t,c,i,o,r,l){const{providerExtUri:a}=this.N(t),m={resource:c,name:a.basename(c),isFile:(i.type&s.FileType.File)!==0,isDirectory:(i.type&s.FileType.Directory)!==0,isSymbolicLink:(i.type&s.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&s.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,s.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(m.isDirectory&&l(m,o)){try{const E=await t.readdir(c),M=await A.Promises.settled(E.map(async([T,N])=>{try{const z=a.joinPath(c,T),K=r?await t.stat(z):{type:N};return await this.p(t,z,K,E.length,r,l)}catch(z){return this.b.trace(z),null}}));m.children=(0,P.coalesce)(M)}catch(E){this.b.trace(E),m.children=[]}return m}return m}async resolveAll(t){return A.Promises.settled(t.map(async c=>{try{return{stat:await this.n(c.resource,c.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const c=await this.j(t),i=await c.stat(t);return this.p(c,t,i,void 0,!0,()=>!1)}async exists(t){const c=await this.j(t);try{return!!await c.stat(t)}catch{return!1}}async canCreateFile(t,c){try{await this.r(t,c)}catch(i){return i}return!0}async r(t,c){if(!c?.overwrite&&await this.exists(t))throw new s.FileOperationError((0,S.localize)(3,null,this.nb(t)),3,c)}async createFile(t,c=n.VSBuffer.fromString(""),i){await this.r(t,i);const o=await this.writeFile(t,c);return this.m.fire(new s.FileOperationEvent(t,0,o)),o}async writeFile(t,c,i){const o=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(o);try{await this.s(o,t,i)||await this.P(o,r.dirname(t));let a;if((0,s.hasReadWriteCapability)(o)&&!(c instanceof n.VSBuffer))if((0,w.isReadableStream)(c)){const m=await(0,w.peekStream)(c,3);m.ended?a=n.VSBuffer.concat(m.buffer):a=m}else a=(0,w.peekReadable)(c,m=>n.VSBuffer.concat(m),3);else a=c;!(0,s.hasOpenReadWriteCloseCapability)(o)||(0,s.hasReadWriteCapability)(o)&&a instanceof n.VSBuffer?await this.cb(o,t,i,a):await this.Y(o,t,i,a instanceof n.VSBuffer?(0,n.bufferToReadable)(a):a),this.m.fire(new s.FileOperationEvent(t,4))}catch(l){throw new s.FileOperationError((0,S.localize)(4,null,this.nb(t),(0,s.ensureFileSystemProviderError)(l).toString()),(0,s.toFileOperationResult)(l),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,c,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,S.localize)(5,null,this.nb(c)));let r;try{r=await t.stat(c)}catch{return}if((r.type&s.FileType.Directory)!==0)throw new s.FileOperationError((0,S.localize)(6,null,this.nb(c)),0,i);if(this.mb(c,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==s.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,s.etag)({mtime:i.mtime,size:r.size}))throw new s.FileOperationError((0,S.localize)(7,null),3,i);return r}async readFile(t,c,i){const o=await this.k(t);return c?.atomic?this.t(o,t,c,i):this.u(o,t,c,i)}async t(t,c,i,o){return new Promise((r,l)=>{this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{try{const a=await this.u(t,c,i,o);r(a)}catch(a){l(a)}})})}async u(t,c,i,o){const r=await this.v(t,c,{...i,preferUnbuffered:!0},o);return{...r,value:await(0,n.streamToBuffer)(r.value)}}async readFileStream(t,c,i){const o=await this.k(t);return this.v(o,t,c,i)}async v(t,c,i,o){const r=new R.CancellationTokenSource(o),l=this.F(c,i).then(m=>m,m=>{throw r.cancel(),m});let a;try{return typeof i?.etag=="string"&&i.etag!==s.ETAG_DISABLED&&await l,i?.atomic&&(0,s.hasFileAtomicReadCapability)(t)||!((0,s.hasOpenReadWriteCloseCapability)(t)||(0,s.hasFileReadStreamCapability)(t))||(0,s.hasReadWriteCapability)(t)&&i?.preferUnbuffered?a=this.D(t,c,i):(0,s.hasFileReadStreamCapability)(t)?a=this.z(t,c,r.token,i):a=this.C(t,c,r.token,i),{...await l,value:a}}catch(m){throw a&&await(0,w.consumeStream)(a),this.w(m,c,i)}}w(t,c,i){const o=(0,S.localize)(8,null,this.nb(c),(0,s.ensureFileSystemProviderError)(t).toString());return t instanceof s.NotModifiedSinceFileOperationError?new s.NotModifiedSinceFileOperationError(o,t.stat,i):t instanceof s.TooLargeFileOperationError?new s.TooLargeFileOperationError(o,t.fileOperationResult,t.size,t.options):new s.FileOperationError(o,(0,s.toFileOperationResult)(t),i)}z(t,c,i,o=Object.create(null)){const r=t.readFileStream(c,o,i);return(0,w.transform)(r,{data:l=>l instanceof n.VSBuffer?l:n.VSBuffer.wrap(l),error:l=>this.w(l,c,o)},l=>n.VSBuffer.concat(l))}C(t,c,i,o=Object.create(null)){const r=(0,n.newWriteableBufferStream)();return(0,h.readFileIntoStream)(t,c,r,l=>l,{...o,bufferSize:this.a,errorTransformer:l=>this.w(l,c,o)},i),r}D(t,c,i){const o=(0,w.newWriteableStream)(r=>n.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,s.hasFileAtomicReadCapability)(t)?r=await t.readFile(c,{atomic:!0}):r=await t.readFile(c),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(c,r.byteLength,i),o.end(n.VSBuffer.wrap(r))}catch(r){o.error(r),o.end()}})(),o}async F(t,c){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new s.FileOperationError((0,S.localize)(9,null,this.nb(t)),0,c);if(typeof c?.etag=="string"&&c.etag!==s.ETAG_DISABLED&&c.etag===i.etag)throw new s.NotModifiedSinceFileOperationError((0,S.localize)(10,null),i,c);return this.G(t,i.size,c),i}G(t,c,i){if(i?.limits){let o;if(typeof i.limits.memory=="number"&&c>i.limits.memory&&(o=9),typeof i.limits.size=="number"&&c>i.limits.size&&(o=7),typeof o=="number")throw new s.TooLargeFileOperationError((0,S.localize)(11,null,this.nb(t)),o,c,i)}}async canMove(t,c,i){return this.H(t,c,"move",i)}async canCopy(t,c,i){return this.H(t,c,"copy",i)}async H(t,c,i,o){if(t.toString()!==c.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),l=this.lb(await this.l(c),c);await this.M(r,t,l,c,i,o)}catch(r){return r}return!0}async move(t,c,i){const o=this.lb(await this.l(t),t),r=this.lb(await this.l(c),c),l=await this.I(o,t,r,c,"move",!!i),a=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new s.FileOperationEvent(t,l==="move"?2:3,a)),a}async copy(t,c,i){const o=await this.k(t),r=this.lb(await this.l(c),c),l=await this.I(o,t,r,c,"copy",!!i),a=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new s.FileOperationEvent(t,l==="copy"?3:2,a)),a}async I(t,c,i,o,r,l){if(c.toString()===o.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:m}=await this.M(t,c,i,o,r,l);if(a&&!m&&l&&await this.del(o,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(o)),r==="copy"){if(t===i&&(0,s.hasFileFolderCopyCapability)(t))await t.copy(c,o,{overwrite:l});else{const E=await this.resolve(c);E.isDirectory?await this.L(t,E,i,o):await this.J(t,c,i,o)}return r}else return t===i?(await t.rename(c,o,{overwrite:l}),r):(await this.I(t,c,i,o,"copy",l),await this.del(c,{recursive:!0}),"copy")}async J(t,c,i,o){if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(i))return this.eb(t,c,i,o);if((0,s.hasOpenReadWriteCloseCapability)(t)&&(0,s.hasReadWriteCapability)(i))return this.kb(t,c,i,o);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasOpenReadWriteCloseCapability)(i))return this.ib(t,c,i,o);if((0,s.hasReadWriteCapability)(t)&&(0,s.hasReadWriteCapability)(i))return this.gb(t,c,i,o)}async L(t,c,i,o){await i.mkdir(o),Array.isArray(c.children)&&await A.Promises.settled(c.children.map(async r=>{const l=this.N(i).providerExtUri.joinPath(o,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,l):this.J(t,r.resource,i,l)}))}async M(t,c,i,o,r,l){let a=!1;if(t===i){const{providerExtUri:E,isPathCaseSensitive:M}=this.N(t);if(M||(a=E.isEqual(c,o)),a&&r==="copy")throw new Error((0,S.localize)(12,null,this.nb(c),this.nb(o)));if(!a&&E.isEqualOrParent(o,c))throw new Error((0,S.localize)(13,null,this.nb(c),this.nb(o)))}const m=await this.exists(o);if(m&&!a){if(!l)throw new s.FileOperationError((0,S.localize)(14,null,this.nb(c),this.nb(o)),4);if(t===i){const{providerExtUri:E}=this.N(t);if(E.isEqualOrParent(c,o))throw new Error((0,S.localize)(15,null,this.nb(c),this.nb(o)))}}return{exists:m,isSameResourceWithDifferentPathCase:a}}N(t){const c=this.O(t);return{providerExtUri:c?u.extUri:u.extUriIgnorePathCase,isPathCaseSensitive:c}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const c=this.lb(await this.j(t),t);await this.P(c,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new s.FileOperationEvent(t,0,i)),i}async P(t,c){const i=[],{providerExtUri:o}=this.N(t);for(;!o.isEqual(c,o.dirname(c));)try{if(((await t.stat(c)).type&s.FileType.Directory)===0)throw new Error((0,S.localize)(16,null,this.nb(c)));break}catch(r){if((0,s.toFileSystemProviderErrorCode)(r)!==s.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(o.basename(c)),c=o.dirname(c)}for(let r=i.length-1;r>=0;r--){c=o.joinPath(c,i[r]);try{await t.mkdir(c)}catch(l){if((0,s.toFileSystemProviderErrorCode)(l)!==s.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(t,c){try{await this.Q(t,c)}catch(i){return i}return!0}async Q(t,c){const i=this.lb(await this.j(t),t);if(!!c?.useTrash&&!(i.capabilities&4096))throw new Error((0,S.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new s.FileOperationError((0,S.localize)(18,null,this.nb(t)),1);if(!!!c?.recursive){const a=await this.resolve(t);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,S.localize)(19,null,this.nb(t)))}return i}async del(t,c){const i=await this.Q(t,c),o=!!c?.useTrash,r=!!c?.recursive;await i.delete(t,{recursive:r,useTrash:o}),this.m.fire(new s.FileOperationEvent(t,1))}async cloneFile(t,c){const i=await this.j(t),o=this.lb(await this.l(c),c);if(i===o&&this.N(i).providerExtUri.isEqual(t,c))return;if(i===o&&(0,s.hasFileCloneCapability)(i))return i.cloneFile(t,c);await this.P(o,this.N(o).providerExtUri.dirname(c));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===o&&(0,s.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,c,{overwrite:!0})):r.queue(()=>this.J(i,t,o,c))}watch(t,c={recursive:!1,excludes:[]}){const i=new d.DisposableStore;let o=!1,r=()=>{o=!0};return i.add((0,d.toDisposable)(()=>r())),(async()=>{try{const l=await this.W(t,c);o?(0,d.dispose)(l):r=()=>(0,d.dispose)(l)}catch(l){this.b.error(l)}})(),i}async W(t,c){const i=await this.j(t),o=(0,k.hash)([this.N(i).providerExtUri.getComparisonKey(t),c]);let r=this.U.get(o);return r||(r={count:0,disposable:i.watch(t,c)},this.U.set(o,r)),r.count+=1,(0,d.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,d.dispose)(r.disposable),this.U.delete(o)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,d.dispose)(t.disposable);this.U.clear()}async Y(t,c,i,o){return this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(c,{create:!0,unlock:i?.unlock??!1});try{(0,w.isReadableStream)(o)||(0,w.isReadableBufferedStream)(o)?await this.Z(t,r,o):await this.ab(t,r,o)}catch(l){throw(0,s.ensureFileSystemProviderError)(l)}finally{await t.close(r)}})}async Z(t,c,i){let o=0,r;if((0,w.isReadableBufferedStream)(i)){if(i.buffer.length>0){const l=n.VSBuffer.concat(i.buffer);await this.bb(t,c,l,l.byteLength,o,0),o+=l.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((l,a)=>{(0,w.listenStream)(r,{onData:async m=>{r.pause();try{await this.bb(t,c,m,m.byteLength,o,0)}catch(E){return a(E)}o+=m.byteLength,setTimeout(()=>r.resume())},onError:m=>a(m),onEnd:()=>l()})})}async ab(t,c,i){let o=0,r;for(;(r=i.read())!==null;)await this.bb(t,c,r,r.byteLength,o,0),o+=r.byteLength}async bb(t,c,i,o,r,l){let a=0;for(;a<o;)a+=await t.write(c,r+a,i.buffer,l+a,o-a)}async cb(t,c,i,o){return this.X.queueFor(c,this.N(t).providerExtUri).queue(()=>this.db(t,c,i,o))}async db(t,c,i,o){let r;o instanceof n.VSBuffer?r=o:(0,w.isReadableStream)(o)?r=await(0,n.streamToBuffer)(o):(0,w.isReadableBufferedStream)(o)?r=await(0,n.bufferedStreamToBuffer)(o):r=(0,n.readableToBuffer)(o),await t.writeFile(c,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,c,i,o){return this.X.queueFor(o,this.N(i).providerExtUri).queue(()=>this.fb(t,c,i,o))}async fb(t,c,i,o){let r,l;try{r=await t.open(c,{create:!1}),l=await i.open(o,{create:!0,unlock:!1});const a=n.VSBuffer.alloc(this.a);let m=0,E=0,M=0;do M=await t.read(r,m,a.buffer,E,a.byteLength-E),await this.bb(i,l,a,M,m,E),m+=M,E+=M,E===a.byteLength&&(E=0);while(M>0)}catch(a){throw(0,s.ensureFileSystemProviderError)(a)}finally{await A.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async gb(t,c,i,o){return this.X.queueFor(o,this.N(i).providerExtUri).queue(()=>this.hb(t,c,i,o))}async hb(t,c,i,o){return i.writeFile(o,await t.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async ib(t,c,i,o){return this.X.queueFor(o,this.N(i).providerExtUri).queue(()=>this.jb(t,c,i,o))}async jb(t,c,i,o){const r=await i.open(o,{create:!0,unlock:!1});try{const l=await t.readFile(c);await this.bb(i,r,n.VSBuffer.wrap(l),l.byteLength,0,0)}catch(l){throw(0,s.ensureFileSystemProviderError)(l)}finally{await i.close(r)}}async kb(t,c,i,o){const r=await(0,n.streamToBuffer)(this.C(t,c,R.CancellationToken.None));await this.cb(i,o,void 0,r)}lb(t,c){if(t.capabilities&2048)throw new s.FileOperationError((0,S.localize)(20,null,this.nb(c)),6);return t}mb(t,c){if((c.permissions??0)&s.FilePermission.Readonly)throw new s.FileOperationError((0,S.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===b.Schemas.file?t.fsPath:t.toString(!0)}};v=ye([ee(0,f.ILogService)],v),e.FileService=v}),define(ie[90],se([0,1,41,290,7,35,17,3,32,2,9,4,18,59,23,172,16,112,213,44,209,208]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,A.gracefulify)(P)}catch(c){console.error(`Error enabling graceful-fs: ${(0,p.toErrorMessage)(c)}`)}})();class t extends f.AbstractDiskFileSystemProvider{constructor(i,o){super(i,o),this.onDidChangeCapabilities=k.Event.None,this.H=new R.ResourceMap(r=>I.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,b.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:o,symbolicLink:r}=await w.SymlinkSupport.stat(this.C(i));return{type:this.G(o,r),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.Y(o)}}async readdir(i){try{const o=await w.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(o.map(async l=>{try{let a;l.isSymbolicLink()?a=(await this.stat((0,I.joinPath)(i,l.name))).type:a=this.G(l),r.push([l.name,a])}catch(a){this.a.trace(a)}})),r}catch(o){throw this.Y(o)}}G(i,o){let r;return o?.dangling?r=s.FileType.Unknown:i.isFile()?r=s.FileType.File:i.isDirectory()?r=s.FileType.Directory:r=s.FileType.Unknown,o&&(r|=s.FileType.SymbolicLink),r}async I(i){const o=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await r.wait();const l=new n.Barrier;return this.H.set(i,l),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,d.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.H.get(i)===l&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),l.open()})}async readFile(i,o){let r;try{o?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const l=this.C(i);return await w.Promises.readFile(l)}catch(l){throw this.Y(l)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,o,r){const l=(0,u.newWriteableStream)(a=>D.VSBuffer.concat(a.map(m=>D.VSBuffer.wrap(m))).buffer);return(0,h.readFileIntoStream)(this,i,l,a=>a.buffer,{...o,bufferSize:256*1024},r),l}async writeFile(i,o,r){let l;try{const a=this.C(i);if(!r.create||!r.overwrite){if(await w.Promises.exists(a)){if(!r.overwrite)throw(0,s.createFileSystemProviderError)((0,S.localize)(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,s.createFileSystemProviderError)((0,S.localize)(1,null),s.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(l,0,o,0,o.byteLength)}catch(a){throw await this.Z(i,a)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(i){t.O=i}async open(i,o){const r=this.C(i);let l;(0,s.isFileOpenForWriteOptions)(o)&&(l=await this.I(i));let a;try{if((0,s.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:E}=await w.SymlinkSupport.stat(r);E.mode&128||await w.Promises.chmod(r,E.mode|128)}catch(E){this.a.trace(E)}let m;if((0,s.isFileOpenForWriteOptions)(o)){if(b.isWindows)try{await w.Promises.truncate(r,0),m="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}m||(m="w")}else m="r";a=await w.Promises.open(r,m)}catch(m){throw l?.dispose(),(0,s.isFileOpenForWriteOptions)(o)?await this.Z(i,m):this.Y(m)}if(this.L.set(a,0),(0,s.isFileOpenForWriteOptions)(o)&&this.N.set(a,i),l){const m=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.M.set(a,l),m&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),m.dispose())}return a}async close(i){const o=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await w.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await w.Promises.close(i)}catch(r){throw this.Y(r)}finally{o&&(this.M.get(i)===o&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),o.dispose())}}async read(i,o,r,l,a){const m=this.P(i,o);let E=null;try{E=(await w.Promises.read(i,r,l,a,m)).bytesRead}catch(M){throw this.Y(M)}finally{this.Q(i,m,E)}return E}P(i,o){return o===this.L.get(i)?null:o}Q(i,o,r){const l=this.L.get(i);typeof l=="number"&&(typeof o=="number"||(typeof r=="number"?this.L.set(i,l+r):this.L.delete(i)))}async write(i,o,r,l,a){return(0,n.retry)(()=>this.R(i,o,r,l,a),100,3)}async R(i,o,r,l,a){const m=this.P(i,o);let E=null;try{E=(await w.Promises.write(i,r,l,a,m)).bytesWritten}catch(M){throw await this.Z(this.N.get(i),M)}finally{this.Q(i,m,E)}return E}async mkdir(i){try{await w.Promises.mkdir(this.C(i))}catch(o){throw this.Y(o)}}async delete(i,o){try{const r=this.C(i);o.recursive?await w.Promises.rm(r,w.RimRafMode.MOVE):await w.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,o,r){const l=this.C(i),a=this.C(o);if(l!==a)try{await this.S(i,o,"move",r.overwrite),await w.Promises.move(l,a)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,S.localize)(2,null,(0,y.basename)(l),(0,y.basename)((0,y.dirname)(a)),m.toString()))),this.Y(m)}}async copy(i,o,r){const l=this.C(i),a=this.C(o);if(l!==a)try{await this.S(i,o,"copy",r.overwrite),await w.Promises.copy(l,a,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,S.localize)(3,null,(0,y.basename)(l),(0,y.basename)((0,y.dirname)(a)),m.toString()))),this.Y(m)}}async S(i,o,r,l){const a=this.C(i),m=this.C(o);let E=!1;if(!!(this.capabilities&1024)||(E=(0,g.isEqual)(a,m,!0)),E&&r==="copy")throw(0,s.createFileSystemProviderError)((0,S.localize)(4,null),s.FileSystemProviderErrorCode.FileExists);if(!E&&await w.Promises.exists(m)){if(!l)throw(0,s.createFileSystemProviderError)((0,S.localize)(5,null),s.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(i,o){return this.U(i,o,!1)}async U(i,o,r){const l=this.C(i),a=this.C(o),m=!!(this.capabilities&1024);if((0,g.isEqual)(l,a,!m))return;const E=new d.DisposableStore;try{const[M,T]=await Promise.all([this.I(i),this.I(o)]);E.add(M),E.add(T),r&&await w.Promises.mkdir((0,y.dirname)(a),{recursive:!0}),await w.Promises.copyFile(l,a)}catch(M){if(M.code==="ENOENT"&&!r)return this.U(i,o,!0);throw this.Y(M)}finally{E.dispose()}}p(i,o,r){return new v.UniversalWatcherClient(l=>i(l),l=>o(l),r)}y(i,o,r){return new C.NodeJSWatcherClient(l=>i(l),l=>o(l),r)}Y(i){if(i instanceof s.FileSystemProviderError)return i;let o;switch(i.code){case"ENOENT":o=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=s.FileSystemProviderErrorCode.NoPermissions;break;default:o=s.FileSystemProviderErrorCode.Unknown}return(0,s.createFileSystemProviderError)(i,o)}async Z(i,o){let r=this.Y(o);if(i&&r.code===s.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await w.SymlinkSupport.stat(this.C(i));l.mode&128||(r=(0,s.createFileSystemProviderError)(o,s.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return r}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(ie[215],se([0,1,3,90,2,17,59,22]),function(X,e,P,A,n,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class g extends n.Disposable{constructor(b,I){super(),this.a=b,this.b=I,this.w=new Map,this.y=new Map}call(b,I,u){const w=this.c(b);switch(I){case"stat":return this.g(w,u[0]);case"readdir":return this.h(w,u[0]);case"open":return this.l(w,u[0],u[1]);case"close":return this.m(u[0]);case"read":return this.n(u[0],u[1],u[2]);case"readFile":return this.i(w,u[0],u[1]);case"write":return this.p(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.k(w,u[0],u[1],u[2]);case"rename":return this.t(w,u[0],u[1],u[2]);case"copy":return this.u(w,u[0],u[1],u[2]);case"cloneFile":return this.v(w,u[0],u[1]);case"mkdir":return this.r(w,u[0]);case"delete":return this.s(w,u[0],u[1]);case"watch":return this.C(w,u[0],u[1],u[2],u[3]);case"unwatch":return this.D(u[0],u[1])}throw new Error(`IPC Command ${I} not found`)}listen(b,I,u){const w=this.c(b);switch(I){case"fileChange":return this.z(w,u[0]);case"readFileStream":return this.j(w,u[0],u[1])}throw new Error(`Unknown event ${I}`)}g(b,I){const u=this.f(b,I,!0);return this.a.stat(u)}h(b,I){const u=this.f(b,I);return this.a.readdir(u)}async i(b,I,u){const w=this.f(b,I,!0),S=await this.a.readFile(w,u);return R.VSBuffer.wrap(S)}j(b,I,u){const w=this.f(b,I,!0),S=new k.CancellationTokenSource,s=new P.Emitter({onDidRemoveLastListener:()=>{S.cancel()}}),h=this.a.readFileStream(w,u,S.token);return(0,D.listenStream)(h,{onData:f=>s.fire(R.VSBuffer.wrap(f)),onError:f=>s.fire(f),onEnd:()=>{s.fire("end"),s.dispose(),S.dispose()}}),s.event}k(b,I,u,w){const S=this.f(b,I);return this.a.writeFile(S,u.buffer,w)}l(b,I,u){const w=this.f(b,I,!0);return this.a.open(w,u)}m(b){return this.a.close(b)}async n(b,I,u){const w=R.VSBuffer.alloc(u),S=0,s=await this.a.read(b,I,w.buffer,S,u);return[w,s]}p(b,I,u,w,S){return this.a.write(b,I,u.buffer,w,S)}r(b,I){const u=this.f(b,I);return this.a.mkdir(u)}s(b,I,u){const w=this.f(b,I);return this.a.delete(w,u)}t(b,I,u,w){const S=this.f(b,I),s=this.f(b,u);return this.a.rename(S,s,w)}u(b,I,u,w){const S=this.f(b,I),s=this.f(b,u);return this.a.copy(S,s,w)}v(b,I,u){const w=this.f(b,I),S=this.f(b,u);return this.a.cloneFile(w,S)}z(b,I){const u=new P.Emitter({onWillAddFirstListener:()=>{this.w.set(I,this.F(b,u))},onDidRemoveLastListener:()=>{(0,n.dispose)(this.w.get(I)),this.w.delete(I)}});return u.event}async C(b,I,u,w,S){const s=this.w.get(I);if(s){const h=this.f(b,w),f=s.watch(u,h,S);this.y.set(I+u,f)}}async D(b,I){const u=b+I,w=this.y.get(u);w&&((0,n.dispose)(w),this.y.delete(u))}dispose(){super.dispose();for(const[,b]of this.y)b.dispose();this.y.clear();for(const[,b]of this.w)b.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=g;class d extends n.Disposable{constructor(b,I,u,w){super(),this.c=b,this.f=u,this.g=w,this.a=new Map,this.b=this.B(new A.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(I)}h(b){const I=this.B(new P.Emitter);this.B(I.event(u=>{b.fire(u.map(w=>({resource:this.c.transformOutgoingURI(w.resource),type:w.type})))})),this.B(this.b.onDidChangeFile(u=>I.fire(u))),this.B(this.b.onDidWatchError(u=>b.fire(u)))}i(b){}j(b){}watch(b,I,u){const w=this.j(this.g);return Array.isArray(w)&&(u.excludes=[...u.excludes,...w]),this.a.set(b,this.b.watch(I,u)),(0,n.toDisposable)(()=>{(0,n.dispose)(this.a.get(b)),this.a.delete(b)})}dispose(){super.dispose();for(const[,b]of this.a)b.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=d}),define(ie[216],se([0,1,15,171,4,8,16,9,215,149]),function(X,e,P,A,n,R,D,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class y extends g.AbstractDiskFileSystemProviderChannel{constructor(u,w,S){super(u,w),this.G=S}c(u){return d.DefaultURITransformer}f(u,w){return R.URI.revive(w)}async s(u,w,S){if(!S.useTrash)return super.s(u,w,S);const s=this.f(u,w),h=(0,k.normalize)(s.fsPath);try{await P.shell.trashItem(h)}catch{throw(0,D.createFileSystemProviderError)(n.isWindows?(0,A.localize)(0,null,(0,k.basename)(h)):(0,A.localize)(1,null,(0,k.basename)(h)),D.FileSystemProviderErrorCode.Unknown)}}F(u,w){return new b(u,w,this.b,this.G)}}e.DiskFileSystemProviderChannel=y;class b extends g.AbstractSessionFileWatcher{watch(u,w,S){if(S.recursive)throw(0,D.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(u,w,S)}}}),define(ie[217],se([0,1,5]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class A extends P.AbstractMessageLogger{constructor(R=P.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(D=>{this.l?.setLevel(D)}))}set logger(R){this.l=R;for(const{level:D,message:k}of this.k)(0,P.log)(R,D,k);this.k=[]}g(R,D){this.l?(0,P.log)(this.l,R,D):this.getLevel()<=R&&this.k.push({level:R,message:D})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=A}),define(ie[218],se([0,1,2,5]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class n extends P.Disposable{constructor(D,k=[]){super(),this.a=new A.MultiplexLogger([D,...k]),this.B(D.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...k){this.a.trace(D,...k)}debug(D,...k){this.a.debug(D,...k)}info(D,...k){this.a.info(D,...k)}warn(D,...k){this.a.warn(D,...k)}error(D,...k){this.a.error(D,...k)}flush(){this.a.flush()}}e.LogService=n}),define(ie[219],se([0,1,35,8,5]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class R{constructor(k){this.b=k,this.a=new P.ResourceMap}listen(k,g,d){switch(g){case"onDidChangeLoggers":return d?this.b.getOnDidChangeLoggersEvent(d):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return d?this.b.getOnDidChangeLogLevelEvent(d):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return d?this.b.getOnDidChangeVisibilityEvent(d):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${g}`)}async call(k,g,d){switch(g){case"createLogger":this.c(A.URI.revive(d[0]),d[1],d[2]);return;case"log":return this.e(A.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1]);case"setLogLevel":return(0,n.isLogLevel)(d[0])?this.b.setLogLevel(d[0]):this.b.setLogLevel(A.URI.revive(d[0]),d[1]);case"setVisibility":return this.b.setVisibility(A.URI.revive(d[0]),d[1]);case"registerLogger":return this.b.registerLogger({...d[0],resource:A.URI.revive(d[0].resource)},d[1]);case"deregisterLogger":return this.b.deregisterLogger(A.URI.revive(d[0]))}throw new Error(`Call not found: ${g}`)}c(k,g,d){this.a.set(k,this.b.createLogger(k,g,d))}d(k,g){let d=console.log;switch(k){case n.LogLevel.Error:d=console.error;break;case n.LogLevel.Warning:d=console.warn;break;case n.LogLevel.Info:d=console.info;break}d.call(console,...g)}e(k,g){const d=this.a.get(k);if(!d)throw new Error("Create the logger before logging");for(const[y,b]of g)(0,n.log)(d,y,b)}}e.LoggerChannel=R}),define(ie[220],se([0,1,16,5]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var n;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(n||(n={}));async function R(d,y,b,I,u){try{const w=await new Promise((s,h)=>{X(["spdlog"],s,h)});w.setFlushOn(n.Trace);const S=await w.createAsyncRotatingLogger(d,y,b,I);return u?S.clearFormatters():S.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),S}catch(w){console.error(w)}return null}function D(d,y,b){switch(y){case A.LogLevel.Trace:d.trace(b);break;case A.LogLevel.Debug:d.debug(b);break;case A.LogLevel.Info:d.info(b);break;case A.LogLevel.Warning:d.warn(b);break;case A.LogLevel.Error:d.error(b);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function k(d,y){switch(y){case A.LogLevel.Trace:d.setLevel(n.Trace);break;case A.LogLevel.Debug:d.setLevel(n.Debug);break;case A.LogLevel.Info:d.setLevel(n.Info);break;case A.LogLevel.Warning:d.setLevel(n.Warning);break;case A.LogLevel.Error:d.setLevel(n.Error);break;case A.LogLevel.Off:d.setLevel(n.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class g extends A.AbstractMessageLogger{constructor(y,b,I,u,w){super(),this.k=[],this.setLevel(w),this.l=this.n(y,b,I,u),this.B(this.onDidChangeLogLevel(S=>{this.m&&k(this.m,S)}))}async n(y,b,I,u){const w=I?6:1,S=30/w*P.ByteSize.MB,s=await R(y,b,S,w,u);if(s){this.m=s,k(this.m,this.getLevel());for(const{level:h,message:f}of this.k)D(this.m,h,f);this.k=[]}}g(y,b){this.m?D(this.m,y,b):this.getLevel()<=y&&this.k.push({level:y,message:b})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=g}),define(ie[221],se([0,1,31,5,220]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class R extends A.AbstractLoggerService{m(k,g,d){return new n.SpdLogLogger((0,P.generateUuid)(),k.fsPath,!d?.donotRotate,!!d?.donotUseFormatters,g)}}e.LoggerService=R}),define(ie[65],se([0,1,35,3,6,5,221]),function(X,e,P,A,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,n.refineServiceDecorator)(R.ILoggerService);class k extends D.LoggerService{constructor(){super(...arguments),this.p=new P.ResourceMap}createLogger(d,y,b){const I=this.l(d);b!==void 0&&this.p.set(I,b);try{return super.createLogger(I,y)}catch(u){throw this.p.delete(I),u}}registerLogger(d,y){y!==void 0&&this.p.set(d.resource,y),super.registerLogger(d)}deregisterLogger(d){this.p.delete(d),super.deregisterLogger(d)}getRegisteredLoggers(d){const y=[];for(const b of super.getRegisteredLoggers())d===this.p.get(b.resource)&&y.push(b);return y}getOnDidChangeLogLevelEvent(d){return A.Event.filter(this.onDidChangeLogLevel,y=>(0,R.isLogLevel)(y)||this.s(y[0],d))}getOnDidChangeVisibilityEvent(d){return A.Event.filter(this.onDidChangeVisibility,([y])=>this.s(y,d))}getOnDidChangeLoggersEvent(d){return A.Event.filter(A.Event.map(this.onDidChangeLoggers,y=>({added:[...y.added].filter(I=>this.s(I.resource,d)),removed:[...y.removed].filter(I=>this.s(I.resource,d))})),y=>y.added.length>0||y.removed.length>0)}deregisterLoggers(d){for(const[y,b]of this.p)b===d&&this.deregisterLogger(y)}s(d,y){const b=this.p.get(d);return b===void 0||b===y}dispose(){super.dispose(),this.p.clear()}}e.LoggerMainService=k}),define(ie[222],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function P(D){return D.submenu!==void 0}e.isMenubarMenuItemSubmenu=P;function A(D){return D.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=A;function n(D){return D.uri!==void 0}e.isMenubarMenuItemRecentAction=n;function R(D){return!P(D)&&!A(D)&&!n(D)}e.isMenubarMenuItemAction=R}),define(ie[38],se([0,1,3,70,2,6]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class D extends n.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const y=Object.keys(this.f).length;return this.f={...d,...this.f},y!==Object.keys(this.f).length&&await this.i(d),A.Iterable.reduce(this.g.entries(),(b,[I,u])=>({...b,[I]:u}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(d,[y,b])=>({...d,[y]:{definition:b,value:this.g.get(y)}}),{})}}e.AbstractPolicyService=D;class k{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(ie[223],se([0,1,7,3,70,10,16,5,38]),function(X,e,P,A,n,R,D,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function d(b,I){const u=[];for(const w of new Set(n.Iterable.concat(b.keys(),I.keys())))b.get(w)!==I.get(w)&&u.push(w);return u}let y=class extends g.AbstractPolicyService{constructor(I,u,w){super(),this.j=I,this.k=u,this.l=w,this.c=this.B(new P.ThrottledDelayer(500));const S=A.Event.filter(u.onDidFilesChange,s=>s.affects(I));this.B(u.watch(I)),this.B(S(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const I=new Map;try{const u=await this.k.readFile(this.j),w=JSON.parse(u.value.toString());if(!(0,R.isObject)(w))throw new Error("Policy file isn't a JSON object");for(const S of Object.keys(w))this.f[S]&&I.set(S,w[S])}catch(u){u.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",u)}return I}async p(){const I=await this.n(),u=d(this.g,I);this.g=I,u.length>0&&this.h.fire(u)}};y=ye([ee(1,D.IFileService),ee(2,k.ILogService)],y),e.FilePolicyService=y}),define(ie[224],se([0,1,3,2,38]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(g){this.b=g,this.a=new A.DisposableStore}listen(g,d){switch(d){case"onDidChange":return P.Event.map(this.b.onDidChange,y=>y.reduce((b,I)=>({...b,[I]:this.b.getPolicyValue(I)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(g,d,y){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(y)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.PolicyChannel=R;class D extends n.AbstractPolicyService{constructor(g,d){super(),this.a=d;for(const y in g){const{definition:b,value:I}=g[y];this.f[y]=b,I!==void 0&&this.g.set(y,I)}this.a.listen("onDidChange")(y=>{for(const b in y){const I=y[b];I===null?this.g.delete(b):this.g.set(b,I)}this.h.fire(Object.keys(y))})}async i(g){const d=await this.a.call("updatePolicyDefinitions",g);for(const y in d)this.g.set(y,d[y])}}e.PolicyChannelClient=D}),define(ie[225],se([0,1,38,7,291,2,5]),function(X,e,P,A,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends P.AbstractPolicyService{constructor(d,y){super(),this.j=d,this.k=y,this.a=new A.Throttler,this.b=this.B(new R.MutableDisposable)}async i(d){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(d).length} policy definitions`),await this.a.queue(()=>new Promise((y,b)=>{try{this.b.value=(0,n.createWatcher)(this.k,d,I=>{this.m(I),y()})}catch(I){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",I),b(I)}}))}m(d){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(d)}`);for(const y in d){const b=d[y];b===void 0?this.g.delete(y):this.g.set(y,b)}this.h.fire(Object.keys(d))}};k=ye([ee(0,D.ILogService)],k),e.NativePolicyService=k}),define(ie[66],se([0,1,4,36]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof P.globals.vscode<"u"&&typeof P.globals.vscode.context<"u"){const R=P.globals.vscode.context.configuration();if(R)n=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(n=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`,serverDataFolderName:n.serverDataFolderName?`${n.serverDataFolderName}-dev`:void 0}),!n.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(n,{version:R.version})}}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=n}),define(ie[21],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,P.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ie[226],se([0,1,81,5,21]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(k,g){this.b=k,this.c=g,this.a=new Map}async isExtensionUrlTrusted(k,g){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const d=/^(.*)#([^#]+)$/.exec(g);if(!d)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",g),!1;const[,y,b]=d;let I=this.a.get(k);if(!I){if(I=this.b.trustedExtensionUrlPublicKeys[k],!I||I.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",k),!1;this.a.set(k,[...I])}const u=Buffer.from(decodeURIComponent(b),"base64");if(u.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",g),!1;const w=u.slice(0,6),S=u.readUIntBE(0,6),s=Date.now()-S;if(s<0||s>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",g),!1;const h=u.slice(6),f=P.createVerify("SHA256");f.write(w),f.write(Buffer.from(y)),f.end();for(let p=0;p<I.length;p++){let v=I[p];if(v!==null){if(typeof v=="string")try{v=P.createPublicKey({key:Buffer.from(v,"base64"),format:"der",type:"spki"}),I[p]=v}catch(C){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${p+1} for ${k}:`,C),I[p]=null;continue}if(f.verify(v,h))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",g),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",g),!1}};R=ye([ee(0,n.IProductService),ee(1,A.ILogService)],R),e.ExtensionUrlTrustService=R}),define(ie[227],se([0,1,7,5]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let n=class{constructor(D,k,g){this.a=D,this.b=k,this.c=g}async inspect(D){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.timeout)(D);const g=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),g.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};n=ye([ee(2,A.ILogService)],n),e.WindowProfiler=n}),define(ie[67],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,P.createDecorator)("protocolMainService")}),define(ie[51],se([0,1,127,10]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class n{constructor(){this.a=new Map}add(D,k){P.ok(A.isString(D)),P.ok(A.isObject(k)),P.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,k)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new n}),define(ie[228],se([0,1,3,51]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function n(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class R{constructor(){this.b=new P.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,d){this.a[n(g)]=d,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const D=new R;A.Registry.add(e.Extensions.JSONContribution,D)}),define(ie[68],se([0,1,26,3,10,158,19,228,51]),function(X,e,P,A,n,R,D,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=g.Registry.as(k.Extensions.JSONContribution);class I{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const i=new Set;this.n(t,c,i),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const c=new Set;this.o(t,c),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const i=new Set;this.o(c,i),this.n(t,!1,i),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const i=[];for(const{overrides:o,source:r}of t)for(const l in o)if(c.add(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const a=this.a.get(l),m=a?.valuesSources??new Map;if(r)for(const N of Object.keys(o[l]))m.set(N,r);const E={...a?.value||{},...o[l]};this.a.set(l,{source:r,value:E,valuesSources:m});const M=(0,D.getLanguageTagSettingPlainKey)(l),T={type:"object",default:E,description:R.localize(1,null,M),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:n.isString(r)?void 0:r,defaultValueSource:r};i.push(...S(l)),this.d[l]=T,this.b.properties[l]=T}else{this.a.set(l,{value:o[l],source:r});const a=this.d[l];a&&(this.w(l,a),this.r(l,a))}this.m(i)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:i,source:o}of t)for(const r in i){const l=this.a.get(r),a=n.isString(o)?o:o?.id,m=n.isString(l?.source)?l?.source:l?.source?.id;if(a===m)if(c.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const E=this.d[r];E&&(this.w(r,E),this.r(r,E))}}this.u()}deltaConfiguration(t){let c=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,i){t.forEach(o=>{this.p(o,c,o.extensionInfo,o.restrictedProperties,void 0,i),this.c.push(o),this.q(o)})}o(t,c){const i=o=>{if(o.properties)for(const r in o.properties){c.add(r);const l=this.d[r];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[r],this.s(r,o.properties[r])}o.allOf?.forEach(r=>i(r))};for(const o of t){i(o);const r=this.c.indexOf(o);r!==-1&&this.c.splice(r,1)}}p(t,c=!0,i,o,r=3,l){r=n.isUndefinedOrNull(t.scope)?r:t.scope;const a=t.properties;if(a)for(const E in a){const M=a[E];if(c&&p(E,M)){delete a[E];continue}if(M.source=i,M.defaultDefaultValue=a[E].default,this.w(E,M),e.OVERRIDE_PROPERTY_REGEX.test(E)?M.scope=void 0:(M.scope=n.isUndefinedOrNull(M.scope)?r:M.scope,M.restricted=n.isUndefinedOrNull(M.restricted)?!!o?.includes(E):M.restricted),a[E].hasOwnProperty("included")&&!a[E].included){this.f[E]=a[E],delete a[E];continue}else this.d[E]=a[E],a[E].policy?.name&&this.e.set(a[E].policy.name,E);!a[E].deprecationMessage&&a[E].markdownDeprecationMessage&&(a[E].deprecationMessage=a[E].markdownDeprecationMessage),l.add(E)}const m=t.allOf;if(m)for(const E of m)this.p(E,c,i,o,r,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=i=>{const o=i.properties;if(o)for(const l in o)this.r(l,o[l]);i.allOf?.forEach(c)};c(t)}r(t,c){switch(e.allSettings.properties[t]=c,c.scope){case 1:e.applicationSettings.properties[t]=c;break;case 2:e.machineSettings.properties[t]=c;break;case 6:e.machineOverridableSettings.properties[t]=c;break;case 3:e.windowSettings.properties[t]=c;break;case 4:e.resourceSettings.properties[t]=c;break;case 5:e.resourceSettings.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.allSettings.properties[t],c.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(c,i),e.allSettings.properties[c]=i,e.applicationSettings.properties[c]=i,e.machineSettings.properties[c]=i,e.machineOverridableSettings.properties[c]=i,e.windowSettings.properties[c]=i,e.resourceSettings.properties[c]=i}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,c){const i=this.a.get(t);let o=i?.value,r=i?.source;n.isUndefined(o)&&(o=c.defaultDefaultValue,r=void 0),n.isUndefined(o)&&(o=h(c.type)),c.default=o,c.defaultValueSource=r}}const u="\\[([^\\]]+)\\]",w=new RegExp(u,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${u})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(C){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(C)){let c=w.exec(C);for(;c?.length;){const i=c[1].trim();i&&t.push(i),c=w.exec(C)}}return(0,P.distinct)(t)}e.overrideIdentifiersFromKey=S;function s(C){return C.reduce((t,c)=>`${t}[${c}]`,"")}e.keyFromOverrideIdentifiers=s;function h(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const f=new I;g.Registry.add(e.Extensions.Configuration,f);function p(C,t){return C.trim()?e.OVERRIDE_PROPERTY_REGEX.test(C)?R.localize(7,null,C):f.getConfigurationProperties()[C]!==void 0?R.localize(8,null,C):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,C,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=p;function v(){const C=[],t=f.getConfigurationProperties();for(const c of Object.keys(t))C.push([c,t[c].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=v}),define(ie[113],se([0,1,26,3,43,2,35,37,10,8,19,68,51]),function(X,e,P,A,n,R,D,k,g,d,y,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function u(c){return Object.isFrozen(c)?c:k.deepFreeze(c)}class w{constructor(i={},o=[],r=[],l){this.b=i,this.c=o,this.d=r,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(o=>{if(o instanceof w)return o;const r=new S("");return r.parseRaw(o),r.configurationModel});this.f=i.reduce((o,r)=>r===o?r:o.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,y.getConfigurationValue)(this.contents,i):this.contents}inspect(i,o){const r=this.rawConfiguration.getValue(i),l=o?this.rawConfiguration.getOverrideValue(i,o):void 0,a=o?this.rawConfiguration.override(o).getValue(i):r;return{value:r,override:l,merged:a}}getOverrideValue(i,o){const r=this.i(o);return r?i?(0,y.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const o=[];for(const r of this.overrides)r.identifiers.includes(i)&&o.push(...r.keys);return P.distinct(o)}getAllOverrideIdentifiers(){const i=[];for(const o of this.overrides)i.push(...o.identifiers);return P.distinct(i)}override(i){let o=this.a.get(i);return o||(o=this.g(i),this.a.set(i,o)),o}merge(...i){const o=k.deepClone(this.contents),r=k.deepClone(this.overrides),l=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const m of i)if(a.push(...m.raw?.length?m.raw:[m]),!m.isEmpty()){this.h(o,m.contents);for(const E of m.overrides){const[M]=r.filter(T=>P.equals(T.identifiers,E.identifiers));M?(this.h(M.contents,E.contents),M.keys.push(...E.keys),M.keys=P.distinct(M.keys)):r.push(k.deepClone(E))}for(const E of m.keys)l.indexOf(E)===-1&&l.push(E)}return new w(o,l,r,a.every(m=>m instanceof w)?void 0:a)}g(i){const o=this.i(i);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const r={};for(const l of P.distinct([...Object.keys(this.contents),...Object.keys(o)])){let a=this.contents[l];const m=o[l];m&&(typeof a=="object"&&typeof m=="object"?(a=k.deepClone(a),this.h(a,m)):a=m),r[l]=a}return new w(r,this.keys,this.overrides)}h(i,o){for(const r of Object.keys(o)){if(r in i&&g.isObject(i[r])&&g.isObject(o[r])){this.h(i[r],o[r]);continue}i[r]=k.deepClone(o[r])}}i(i){let o=null,r=null;const l=a=>{a&&(r?this.h(r,a):r=k.deepClone(a))};for(const a of this.overrides)P.equals(a.identifiers,[i])?o=a.contents:a.identifiers.includes(i)&&l(a.contents);return l(o),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,o){this.j(i,o,!0)}setValue(i,o){this.j(i,o,!1)}removeValue(i){const o=this.keys.indexOf(i);o!==-1&&(this.keys.splice(o,1),(0,y.removeFromValueTree)(this.contents,i),b.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>P.equals(r.identifiers,(0,b.overrideIdentifiersFromKey)(i))),1))}j(i,o,r){(0,y.addToValueTree)(this.contents,i,o,l=>console.error(l)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),b.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,y.toValuesTree)(this.contents[i],l=>console.error(l))})}}e.ConfigurationModel=w;class S{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,o){if(!g.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,o)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,o){this.a=i;const{contents:r,keys:l,overrides:a,restricted:m,hasExcludedProperties:E}=this.h(i,o);this.b=new w(r,l,a,E?[i]:void 0),this.c=m||[]}g(i){let o={},r=null,l=[];const a=[],m=[];function E(T){Array.isArray(l)?l.push(T):r!==null&&(l[r]=T)}const M={onObjectBegin:()=>{const T={};E(T),a.push(l),l=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{l=a.pop()},onArrayBegin:()=>{const T=[];E(T),a.push(l),l=T,r=null},onArrayEnd:()=>{l=a.pop()},onLiteralValue:E,onError:(T,N,z)=>{m.push({error:T,offset:N,length:z})}};if(i)try{n.visit(i,M),o=l[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return o}h(i,o){const r=I.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),l=this.i(i,r,!0,o);i=l.raw;const a=(0,y.toValuesTree)(i,M=>console.error(`Conflict in settings file ${this.f}: ${M}`)),m=Object.keys(i),E=this.j(i,M=>console.error(`Conflict in settings file ${this.f}: ${M}`));return{contents:a,keys:m,overrides:E,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(i,o,r,l){let a=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:a};const m={},E=[];for(const M in i)if(b.OVERRIDE_PROPERTY_REGEX.test(M)&&r){const T=this.i(i[M],o,!1,l);m[M]=T.raw,a=a||T.hasExcludedProperties,E.push(...T.restricted)}else{const T=o[M],N=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&E.push(M),(N===void 0||l.scopes===void 0||l.scopes.includes(N))&&!(l.skipRestricted&&T?.restricted)?m[M]=i[M]:a=!0}return{raw:m,restricted:E,hasExcludedProperties:a}}j(i,o){const r=[];for(const l of Object.keys(i))if(b.OVERRIDE_PROPERTY_REGEX.test(l)){const a={};for(const m in i[l])a[m]=i[l][m];r.push({identifiers:(0,b.overrideIdentifiersFromKey)(l),keys:Object.keys(a),contents:(0,y.toValuesTree)(a,o)})}return r}}e.ConfigurationModelParser=S;class s extends R.Disposable{constructor(i,o,r,l){super(),this.f=i,this.g=o,this.h=l,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new S(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&r.isEqual(a.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new w}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=s;class h{constructor(i,o,r,l,a,m,E,M,T,N,z,K,ae){this.a=i,this.b=o,this.c=r,this.overrideIdentifiers=l,this.d=a,this.f=m,this.g=E,this.h=M,this.i=T,this.j=N,this.k=z,this.l=K,this.m=ae}get value(){return u(this.c)}n(i,o,r){const l=i.inspect(o,r);return{get value(){return u(l.value)},get override(){return u(l.override)},get merged(){return u(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(i,o,r,l,a=new w,m=new w,E=new D.ResourceMap,M=new w,T=new D.ResourceMap){this.c=i,this.d=o,this.f=r,this.g=l,this.h=a,this.i=m,this.j=E,this.l=M,this.m=T,this.a=null,this.b=new D.ResourceMap,this.n=null}getValue(i,o,r){return this.q(i,o,r).getValue(i)}updateValue(i,o,r={}){let l;r.resource?(l=this.m.get(r.resource),l||(l=new w,this.m.set(r.resource,l))):l=this.l,o===void 0?l.removeValue(i):l.setValue(i,o),r.resource||(this.a=null)}inspect(i,o,r){const l=this.q(i,o,r),a=this.u(o.resource,r),m=o.resource?this.m.get(o.resource)||this.l:this.l,E=new Set;for(const M of l.overrides)for(const T of M.identifiers)l.getOverrideValue(i,T)!==void 0&&E.add(T);return new h(i,o,l.getValue(i),E.size?[...E]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,a||void 0,m)}keys(i){const o=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,o){this.j.set(i,o),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,o){const r=[];if(!o){const{added:l,updated:a,removed:m}=C(this.c,i);o=[...l,...a,...m]}for(const l of o)for(const a of(0,b.overrideIdentifiersFromKey)(l)){const m=this.c.getKeysForOverrideIdentifier(a),E=i.getKeysForOverrideIdentifier(a),M=[...E.filter(T=>m.indexOf(T)===-1),...m.filter(T=>E.indexOf(T)===-1),...m.filter(T=>!k.equals(this.c.override(a).getValue(T),i.override(a).getValue(T)))];r.push([a,M])}return this.updateDefaultConfiguration(i),{keys:o,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:o,updated:r,removed:l}=C(this.d,i),a=[...o,...r,...l];return a.length&&this.updatePolicyConfiguration(i),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:o,updated:r,removed:l,overrides:a}=C(this.applicationConfiguration,i),m=[...o,...r,...l];return m.length&&this.updateApplicationConfiguration(i),{keys:m,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:o,updated:r,removed:l,overrides:a}=C(this.localUserConfiguration,i),m=[...o,...r,...l];return m.length&&this.updateLocalUserConfiguration(i),{keys:m,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:o,updated:r,removed:l,overrides:a}=C(this.remoteUserConfiguration,i),m=[...o,...r,...l];return m.length&&this.updateRemoteUserConfiguration(i),{keys:m,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:o,updated:r,removed:l,overrides:a}=C(this.workspaceConfiguration,i),m=[...o,...r,...l];return m.length&&this.updateWorkspaceConfiguration(i),{keys:m,overrides:a}}compareAndUpdateFolderConfiguration(i,o){const r=this.p.get(i),{added:l,updated:a,removed:m,overrides:E}=C(r,o),M=[...l,...a,...m];return(M.length||!r)&&this.updateFolderConfiguration(i,o),{keys:M,overrides:E}}compareAndDeleteFolderConfiguration(i){const o=this.p.get(i);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:l,removed:a,overrides:m}=C(o,void 0);return{keys:[...r,...l,...a],overrides:m}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,o,r){let l=this.r(o,r);return o.overrideIdentifier&&(l=l.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(l=l.merge(this.d)),l}r({resource:i},o){let r=this.s();if(o&&i){const l=o.getFolder(i);l&&(r=this.t(l.uri)||r);const a=this.m.get(i);a&&(r=r.merge(a))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let o=this.b.get(i);if(!o){const r=this.s(),l=this.j.get(i);l?(o=r.merge(l),this.b.set(i,o)):o=r}return o}u(i,o){if(o&&i){const r=o.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,o)=>{const{contents:r,overrides:l,keys:a}=this.j.get(o);return i.push([o,{contents:r,overrides:l,keys:a}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(o=>i.add(o)),this.userConfiguration.keys.forEach(o=>i.add(o)),this.i.keys.forEach(o=>i.add(o)),this.j.forEach(o=>o.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>i.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const o=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>o.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(l=>o.add(l))),[...o.values()]}static parse(i){const o=this.x(i.defaults),r=this.x(i.policy),l=this.x(i.application),a=this.x(i.user),m=this.x(i.workspace),E=i.folders.reduce((M,T)=>(M.set(d.URI.revive(T[0]),this.x(T[1])),M),new D.ResourceMap);return new f(o,r,l,a,new w,m,E,new w,new D.ResourceMap)}static x(i){return new w(i.contents,i.keys,i.overrides)}}e.Configuration=f;function p(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,o=new Map;for(const l of c)l.keys.forEach(a=>i.add(a)),l.overrides.forEach(([a,m])=>{const E=(0,D.getOrSet)(o,a,new Set);m.forEach(M=>E.add(M))});const r=[];return o.forEach((l,a)=>r.push([a,[...l.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=p;class v{constructor(i,o,r,l){this.change=i,this.f=o,this.g=r,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of i.keys)this.affectedKeys.add(a);for(const[,a]of i.overrides)for(const m of a)this.affectedKeys.add(m);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(i,o){const r=this.a+i,l=this.d.indexOf(r);if(l<0)return!1;const a=l+r.length;if(a>=this.d.length)return!1;const m=this.d.charCodeAt(a);if(m!==this.b&&m!==this.c)return!1;if(o){const E=this.previousConfiguration?this.previousConfiguration.getValue(i,o,this.f?.workspace):void 0,M=this.g.getValue(i,o,this.h);return!k.equals(E,M)}return!0}}e.ConfigurationChangeEvent=v;function C(c,i){const{added:o,removed:r,updated:l}=t(i?.rawConfiguration,c?.rawConfiguration),a=[],m=c?.getAllOverrideIdentifiers()||[],E=i?.getAllOverrideIdentifiers()||[];if(i){const M=E.filter(T=>!m.includes(T));for(const T of M)a.push([T,i.getKeysForOverrideIdentifier(T)])}if(c){const M=m.filter(T=>!E.includes(T));for(const T of M)a.push([T,c.getKeysForOverrideIdentifier(T)])}if(i&&c){for(const M of m)if(E.includes(M)){const T=t({contents:c.getOverrideValue(void 0,M)||{},keys:c.getKeysForOverrideIdentifier(M)},{contents:i.getOverrideValue(void 0,M)||{},keys:i.getKeysForOverrideIdentifier(M)});a.push([M,[...T.added,...T.removed,...T.updated]])}}return{added:o,removed:r,updated:l,overrides:a}}function t(c,i){const o=c?i?c.keys.filter(a=>i.keys.indexOf(a)===-1):[...c.keys]:[],r=i?c?i.keys.filter(a=>c.keys.indexOf(a)===-1):[...i.keys]:[],l=[];if(c&&i){for(const a of i.keys)if(c.keys.indexOf(a)!==-1){const m=(0,y.getConfigurationValue)(i.contents,a),E=(0,y.getConfigurationValue)(c.contents,a);k.equals(m,E)||l.push(a)}}return{added:o,removed:r,updated:l}}}),define(ie[229],se([0,1,26,3,2,37,10,113,68,5,38,51]),function(X,e,P,A,n,R,D,k,g,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class I extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:s,defaultsOverrides:h})=>this.c(Array.from(s),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(s,h){this.h(s,b.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:s})}f(){return{}}g(){this.b=new k.ConfigurationModel;const s=b.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(s),s)}h(s,h){const f=this.f();for(const p of s){const v=f[p],C=h[p];v!==void 0?this.b.addValue(p,v):C?this.b.addValue(p,C.default):this.b.removeValue(p)}}}e.DefaultConfiguration=I;class u{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new k.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=u;let w=class extends n.Disposable{get configurationModel(){return this.b}constructor(s,h,f){super(),this.c=s,this.f=h,this.g=f,this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(s=>this.i(s))),this.B(this.c.onDidChangeConfiguration(async({properties:s})=>this.j(await this.h(s),!0))),this.b}async h(s){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",s);const h={},f=[],p=b.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const v of s){const C=p[v];if(!C){f.push(v);continue}if(C.policy){if(C.type!=="string"&&C.type!=="number"){this.g.warn(`Policy ${C.policy.name} has unsupported type ${C.type}`);continue}f.push(v),h[C.policy.name]={type:C.type}}}return(0,D.isEmptyObject)(h)||await this.f.updatePolicyDefinitions(h),f}i(s){this.g.trace("PolicyConfiguration#onDidChangePolicies",s);const h=b.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),f=(0,P.coalesce)(s.map(p=>h.get(p)));this.j(f,!0)}j(s,h){this.g.trace("PolicyConfiguration#update",s);const f=b.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),p=[],v=this.b.isEmpty();for(const C of s){const t=f[C]?.policy?.name;if(t){const c=this.f.getPolicyValue(t);(v?c!==void 0:!(0,R.equals)(this.b.getValue(C),c))&&p.push([C,c])}else this.b.getValue(C)!==void 0&&p.push([C,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const C=this.b;this.b=new k.ConfigurationModel;for(const t of C.keys)this.b.setValue(t,C.getValue(t));for(const[t,c]of p)c===void 0?this.b.removeValue(t):this.b.setValue(t,c);h&&this.a.fire(this.b)}}};w=ye([ee(1,y.IPolicyService),ee(2,d.ILogService)],w),e.PolicyConfiguration=w}),define(ie[230],se([0,1,7,3,2,18,19,113,229,38]),function(X,e,P,A,n,R,D,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends n.Disposable{constructor(I,u,w,S){super(),this.i=I,this.h=this.B(new A.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=w instanceof d.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,w,S)),this.f=this.B(new k.UserSettings(this.i,void 0,R.extUriBiasedIgnorePathCase,u)),this.a=new k.Configuration(this.b.configurationModel,this.c.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.g=this.B(new P.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:h})=>this.k(s,h))),this.B(this.c.onDidChangeConfiguration(s=>this.l(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[I,u,w]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new k.Configuration(I,u,new k.ConfigurationModel,w)}getConfigurationData(){return this.a.toData()}getValue(I,u){const w=typeof I=="string"?I:void 0,S=(0,D.isConfigurationOverrides)(I)?I:(0,D.isConfigurationOverrides)(u)?u:{};return this.a.getValue(w,S,void 0)}updateValue(I,u,w,S){return Promise.reject(new Error("not supported"))}inspect(I){return this.a.inspect(I,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const I=await this.f.loadConfiguration();this.j(I)}j(I){const u=this.a.toData(),w=this.a.compareAndUpdateLocalUserConfiguration(I);this.m(w,u,2)}k(I,u){const w=this.a.toData(),S=this.a.compareAndUpdateDefaultConfiguration(I,u);this.m(S,w,7)}l(I){const u=this.a.toData(),w=this.a.compareAndUpdatePolicyConfiguration(I);this.m(w,u,7)}m(I,u,w){const S=new k.ConfigurationChangeEvent(I,{data:u},this.a);S.source=w,S.sourceConfig=this.n(w),this.h.fire(S)}n(I){switch(I){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(ie[231],se([0,1,13,6]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var n;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends P.ErrorNoTelemetry{static isNotAvailable(g){return g instanceof R&&g._code===n.NotAvailable}static isTemporarilyNotAvailable(g){return g instanceof R&&g._code===n.TemporarilyNotAvailable}static isNoResolverFound(g){return g instanceof R&&g._code===n.NoResolverFound}static isHandled(g){return g instanceof R&&g.isHandled}constructor(g,d=n.Unknown,y){super(g),this._message=g,this._code=d,this._detail=y,this.isHandled=d===n.NotAvailable&&y===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function D(k){const g=k.indexOf("+");return g===-1?k:k.substring(0,g)}e.getRemoteAuthorityPrefix=D}),define(ie[56],se([0,1,14]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(d){return d.scheme===P.Schemas.vscodeRemote?d.authority:void 0}e.getRemoteAuthority=A;function n(d){if(!d)return;const y=d.indexOf("+");return y<0?d:d.substr(0,y)}e.getRemoteName=n;function R(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(d){const{host:y,port:b}=g(d);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:y,port:b}}e.parseAuthorityWithPort=D;function k(d,y){let{host:b,port:I}=g(d);return typeof I>"u"&&(I=y),{host:b,port:I}}e.parseAuthorityWithOptionalPort=k;function g(d){const y=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const b=d.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const I=d.match(/(.*):(\d+)$/);return I?{host:I[1],port:parseInt(I[2],10)}:{host:d,port:void 0}}}),define(ie[114],se([0,1,25,6,56]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var k;(function(S){S.WIN32_X64="win32-x64",S.WIN32_IA32="win32-ia32",S.WIN32_ARM64="win32-arm64",S.LINUX_X64="linux-x64",S.LINUX_ARM64="linux-arm64",S.LINUX_ARMHF="linux-armhf",S.ALPINE_X64="alpine-x64",S.ALPINE_ARM64="alpine-arm64",S.DARWIN_X64="darwin-x64",S.DARWIN_ARM64="darwin-arm64",S.WEB="web",S.UNIVERSAL="universal",S.UNKNOWN="unknown",S.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));class g{constructor(s){this.value=s,this.c=s.toLowerCase()}static equals(s,h){if(typeof s>"u"||s===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof s=="string"||typeof h=="string"){const f=typeof s=="string"?s:s.value,p=typeof h=="string"?h:h.value;return P.equalsIgnoreCase(f,p)}return s.c===h.c}static toKey(s){return typeof s=="string"?s.toLowerCase():s.c}}e.ExtensionIdentifier=g;class d{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const h of s)this.add(h)}add(s){this.c.add(g.toKey(s))}delete(s){return this.c.delete(g.toKey(s))}has(s){return this.c.has(g.toKey(s))}}e.ExtensionIdentifierSet=d;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(g.toKey(s))}get(s){return this.c.get(g.toKey(s))}has(s){return this.c.has(g.toKey(s))}set(s,h){this.c.set(g.toKey(s),h)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=y;function b(S){return I(S)}e.isApplicationScopedExtension=b;function I(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function u(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=u;function w(S,s){if(s){const h=`onResolveRemoteAuthority:${(0,n.getRemoteName)(s)}`;return!!S.activationEvents?.includes(h)}return!1}e.isResolverExtension=w,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(ie[232],se([0,1,7,17,22,13,3,2,64,72,31,104,231,56]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const w=30*1e3;var S;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(S=e.ConnectionType||(e.ConnectionType={}));function s(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(U){const j=new n.CancellationTokenSource;return setTimeout(()=>j.cancel(),U),j.token}function f(U,j){if(U.isCancellationRequested||j.isCancellationRequested)return n.CancellationToken.Cancelled;const q=new n.CancellationTokenSource;return U.onCancellationRequested(()=>q.cancel()),j.onCancellationRequested(()=>q.cancel()),q.token}class p{get didTimeout(){return this.c==="timedout"}constructor(j){this.c="pending",this.d=new k.DisposableStore,this.promise=new Promise((q,J)=>{this.f=q,this.g=J}),j.isCancellationRequested?this.h():this.d.add(j.onCancellationRequested(()=>this.h()))}registerDisposable(j){this.c==="pending"?this.d.add(j):j.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(j))}reject(j){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(j))}}function v(U,j){const q=new p(j);return q.registerDisposable(U.onControlMessage(J=>{const B=JSON.parse(J.toString()),Y=G(B);Y?q.reject(Y):q.resolve(B)})),q.promise}function C(U,j,q,J,B,Y,Z,ce,fe){const De=new p(fe),Re=d.StopWatch.create(!1);return U.info(`Creating a socket (${ce})...`),g.mark(`code/willCreateSocket/${Z}`),j.connect(q,J,B,Y,ce,(Ce,Oe)=>{De.didTimeout?(g.mark(`code/didCreateSocketError/${Z}`),U.info(`Creating a socket (${ce}) finished after ${Re.elapsed()} ms, but this is too late and has timed out already.`),Ce&&U.error(Ce),Oe?.dispose()):Ce||!Oe?(g.mark(`code/didCreateSocketError/${Z}`),U.info(`Creating a socket (${ce}) returned an error after ${Re.elapsed()} ms.`),De.reject(Ce)):(g.mark(`code/didCreateSocketOK/${Z}`),U.info(`Creating a socket (${ce}) was successful after ${Re.elapsed()} ms.`),De.resolve(Oe))}),De.promise}function t(U,j){const q=new p(j);return U.then(J=>{q.didTimeout||q.resolve(J)},J=>{q.didTimeout||q.reject(J)}),q.promise}async function c(U,j,q,J){const B=L(U,j);U.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await C(U.logService,U.socketFactory,U.host,U.port,(0,u.getRemoteServerRootPath)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,s(j),`renderer-${s(j)}-${U.reconnectionToken}`,J)}catch(Re){throw U.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),U.logService.error(Re),Re}U.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let Z,ce;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(Y,null),Z=U.reconnectionProtocol,ce=!1):(Z=new b.PersistentProtocol({socket:Y,measureRoundTripTime:!0}),ce=!0),U.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const fe=await t(U.signService.createNewMessage((0,y.generateUuid)()),J),De={type:"auth",auth:U.connectionToken||"00000000000000000000",data:fe.data};Z.sendControl(A.VSBuffer.fromString(JSON.stringify(De)));try{const Re=await v(Z,f(J,h(1e4)));if(Re.type!=="sign"||typeof Re.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(U.logService.trace(`${B} 4/6. received SignRequest control message.`),!await t(U.signService.validate(fe,Re.signedData),J)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const Oe=await t(U.signService.sign(Re.data),J),$e={type:"connectionType",commit:U.commit,signedData:Oe,desiredConnectionType:j};return q&&($e.args=q),U.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(A.VSBuffer.fromString(JSON.stringify($e))),{protocol:Z,ownsProtocol:ce}}catch(Re){throw Re&&Re.code==="ETIMEDOUT"&&(U.logService.error(`${B} the handshake timed out. Error:`),U.logService.error(Re)),Re&&Re.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${B} received error control message when negotiating connection. Error:`),U.logService.error(Re)),ce&&O(Z),Re}}async function i(U,j,q,J){const B=Date.now(),Y=L(U,j),{protocol:Z,ownsProtocol:ce}=await c(U,j,q,J),fe=new p(J);return fe.registerDisposable(Z.onControlMessage(De=>{const Re=JSON.parse(De.toString()),Ce=G(Re);Ce?(U.logService.error(`${Y} received error control message when negotiating connection. Error:`),U.logService.error(Ce),ce&&O(Z),fe.reject(Ce)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${W(B)}!`),fe.resolve({protocol:Z,firstMessage:Re}))})),fe.promise}async function o(U,j){const{protocol:q}=await i(U,1,void 0,j);return{protocol:q}}async function r(U,j,q){const{protocol:J,firstMessage:B}=await i(U,2,j,q),Y=B&&B.debugPort;return{protocol:J,debugPort:Y}}async function l(U,j,q){const J=Date.now(),B=L(U,3),{protocol:Y}=await c(U,3,j,q);return U.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${W(J)}!`),Y}async function a(U,j,q){const{host:J,port:B,connectionToken:Y}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,host:J,port:B,connectionToken:Y,reconnectionToken:j,reconnectionProtocol:q,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function m(U,j,q){return M(U,async J=>{const{protocol:B}=await o(J,n.CancellationToken.None);return new x(U,j,q,J.reconnectionToken,B)})}e.connectRemoteAgentManagement=m;async function E(U,j){return M(U,async q=>{const{protocol:J,debugPort:B}=await r(q,j,n.CancellationToken.None);return new H(U,j,q.reconnectionToken,J,B)})}e.connectRemoteAgentExtensionHost=E;async function M(U,j){for(let J=1;;J++)try{const B=(0,y.generateUuid)(),Y=await a(U,B,null);return await j(Y)}catch(B){if(J<5)U.logService.error(`[remote-connection][attempt ${J}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(B);else throw U.logService.error(`[remote-connection][attempt ${J}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(B),V.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(B)),B}}async function T(U,j,q){const J=await a(U,(0,y.generateUuid)(),null);return await l(J,{host:j,port:q},n.CancellationToken.None)}e.connectRemoteAgentTunnel=T;function N(U){return(0,P.createCancelablePromise)(j=>new Promise((q,J)=>{const B=setTimeout(q,U*1e3);j.onCancellationRequested(()=>{clearTimeout(B),q()})}))}var z;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain",U[U.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(z=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class K{constructor(j,q){this.reconnectionToken=j,this.millisSinceLastIncomingData=q,this.type=0}}e.ConnectionLostEvent=K;class ae{constructor(j,q,J,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=q,this.durationSeconds=J,this.c=B,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=ae;class le{constructor(j,q,J){this.reconnectionToken=j,this.millisSinceLastIncomingData=q,this.attempt=J,this.type=2}}e.ReconnectionRunningEvent=le;class te{constructor(j,q,J){this.reconnectionToken=j,this.millisSinceLastIncomingData=q,this.attempt=J,this.type=4}}e.ConnectionGainEvent=te;class F{constructor(j,q){this.reconnectionToken=j,this.connectionHealth=q,this.type=5}}e.ConnectionHealthChangedEvent=F;class ${constructor(j,q,J,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=q,this.attempt=J,this.handled=B,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class V extends k.Disposable{static triggerPermanentFailure(j,q,J){this._permanentFailure=!0,this.f=j,this.g=q,this.h=J,this.i.forEach(B=>B.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(j=>j.s())}static debugPauseSocketWriting(){this.i.forEach(j=>j.w())}get k(){return this.c||V._permanentFailure}constructor(j,q,J,B,Y){super(),this.n=j,this.p=q,this.reconnectionToken=J,this.protocol=B,this.r=Y,this.j=this.B(new D.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new te(this.reconnectionToken,0,0)),this.B(B.onSocketClose(Z=>{const ce=oe(this.n,this.reconnectionToken,!0);Z?Z.type===0?(this.p.logService.info(`${ce} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this.p.logService.error(Z.error)):(this.p.logService.info(`${ce} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this.p.logService.error(Z.event)):this.p.logService.info(`${ce} received socket close event.`),this.s()})),this.B(B.onSocketTimeout(Z=>{const ce=oe(this.n,this.reconnectionToken,!0);this.p.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this.s()})),this.B(B.onHighRoundTripTime(Z=>{const ce=re(this.n,this.reconnectionToken);this.p.logService.info(`${ce} high roundtrip time: ${Z.roundTripTime}ms (${Z.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(B.onDidChangeConnectionHealth(Z=>{this.j.fire(new F(this.reconnectionToken,Z))})),V.i.push(this),this.B((0,k.toDisposable)(()=>{const Z=V.i.indexOf(this);Z>=0&&V.i.splice(Z,1)})),this.k&&this.v(V.f,V.g,V.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const j=oe(this.n,this.reconnectionToken,!0);this.p.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const q=[0,5,5,10,10,10,10,10,30];let J=-1;do{J++;const B=J<q.length?q[J]:q[q.length-1];try{if(B>0){const Z=N(B);this.j.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,Z)),this.p.logService.info(`${j} waiting for ${B} seconds before reconnecting...`);try{await Z}catch{}}if(this.k){this.p.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1)),this.p.logService.info(`${j} resolving connection...`);const Y=await a(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${j} connecting to ${Y.host}:${Y.port}...`),await this.y(Y,h(w)),this.p.logService.info(`${j} reconnected!`),this.j.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(Y),this.u(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(J>360){this.p.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(Y),this.u(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Y)){this.p.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this.p.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Y);continue}if((0,R.isCancellationError)(Y)){this.p.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Y);continue}if(Y instanceof I.RemoteAuthorityResolverError){this.p.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(Y),this.u(this.protocol.getMillisSinceLastIncomingData(),J+1,I.RemoteAuthorityResolverError.isHandled(Y));break}this.p.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(Y),this.u(this.protocol.getMillisSinceLastIncomingData(),J+1,!1);break}}while(!this.k&&!this.m)}u(j,q,J){this.r?V.triggerPermanentFailure(j,q,J):this.v(j,q,J)}v(j,q,J){this.j.fire(new $(this.reconnectionToken,j,q,J)),O(this.protocol)}w(){this.protocol.pauseSocketWriting()}}V._permanentFailure=!1,V.f=0,V.g=0,V.h=!1,V.i=[],e.PersistentConnection=V;class x extends V{constructor(j,q,J,B,Y){super(1,j,B,Y,!0),this.client=this.B(new b.Client(Y,{remoteAuthority:q,clientId:J},j.ipcLogger))}async y(j,q){await o(j,q)}}e.ManagementPersistentConnection=x;class H extends V{constructor(j,q,J,B,Y){super(2,j,J,B,!1),this.z=q,this.debugPort=Y}async y(j,q){await r(j,this.z,q)}}e.ExtensionHostPersistentConnection=H;function O(U){try{U.acceptDisconnect();const j=U.getSocket();U.dispose(),j.dispose()}catch(j){(0,R.onUnexpectedError)(j)}}function G(U){if(U&&U.type==="error"){const j=new Error(`Connection error: ${U.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function _(U,j){for(;U.length<j;)U+=" ";return U}function re(U,j){return`[remote-connection][${_(s(U),13)}][${j.substr(0,5)}\u2026]`}function oe(U,j,q){return`${re(U,j)}[${q?"reconnect":"initial"}]`}function L(U,j){return`${oe(j,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function W(U){return`${Date.now()-U} ms`}}),define(ie[233],se([0,1,82,86]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(n,R,D,k,g,d){const y=I=>d(I,void 0),b=P.createConnection({host:n,port:R},()=>{b.removeListener("error",y);const I=Buffer.alloc(16);for(let s=0;s<16;s++)I[s]=Math.round(Math.random()*256);const u=I.toString("base64"),w=[`GET ws://${/:/.test(n)?`[${n}]`:n}:${R}${D}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${u}`];b.write(w.join(`\r
`)+`\r
\r
`);const S=s=>{s.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",S),d(void 0,new A.NodeSocket(b,g)))};b.on("data",S)});b.setNoDelay(!0),b.once("error",y)}}}),define(ie[234],se([0,1,27,46,41,193]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let D;async function k(u=!1){return(D===void 0||u)&&(D=g()),D}e.hasWSLFeatureInstalled=k;async function g(){const u=d();if(u===void 0)return!1;if(u>=22e3){const w=b();if(w)return new Promise(S=>{A.execFile(w,["--status"],s=>S(!s))})}else{const w=I();if(w)try{if((await n.promises.stat(w)).isFile())return!0}catch{}}return!1}function d(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(u)return parseInt(u[3])}function y(u){const w=process.env.SystemRoot;if(w){const S=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(w,S?"Sysnative":"System32",u)}}function b(){return y("wsl.exe")}function I(){return y("lxss\\LxssManager.dll")}}),define(ie[52],se([0,1,17,13,2,176,68,6,5,51]),function(X,e,P,A,n,R,D,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");class y extends n.Disposable{constructor(v,C){super(),this.b=0,this.a=C.createLogger("request",{name:v?(0,R.localize)(0,null):(0,R.localize)(1,null),when:g.CONTEXT_LOG_LEVEL.isEqualTo((0,g.LogLevelToString)(g.LogLevel.Trace)).serialize()})}async c(v,C,t){const c=`${v} #${++this.b}: ${C.url}`;this.a.trace(`${c} - begin`,C.type,C.headers);try{const i=await t();return this.a.trace(`${c} - end`,C.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${c} - error`,C.type,(0,A.getErrorMessage)(i)),i}}}e.AbstractRequestService=y;function b(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=b;function I(p){return p.res.statusCode===204}async function u(p){return I(p)?null:(await(0,P.streamToBuffer)(p.stream)).toString()}e.asText=u;async function w(p){if(!b(p))throw new Error("Server returned "+p.res.statusCode);return u(p)}e.asTextOrError=w;async function S(p){if(!b(p))throw new Error("Server returned "+p.res.statusCode);if(I(p))return null;const C=(await(0,P.streamToBuffer)(p.stream)).toString();try{return JSON.parse(C)}catch(t){throw t.message+=`:
`+C,t}}e.asJson=S;function s(p){f(p)}e.updateProxyConfigurationsScope=s;let h;function f(p){const v=d.Registry.as(D.Extensions.Configuration),C=h;h={id:"http",order:15,title:(0,R.localize)(2,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0}}},v.updateConfigurations({add:[h],remove:C?[C]:[]})}f(2)}),define(ie[235],se([0,1,17,22]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class n{constructor(k){this.a=k}listen(k,g){throw new Error("Invalid listen")}call(k,g,d,y=A.CancellationToken.None){switch(g){case"request":return this.a.request(d[0],y).then(async({res:b,stream:I})=>{const u=await(0,P.streamToBuffer)(I);return[{statusCode:b.statusCode,headers:b.headers},u]});case"resolveProxy":return this.a.resolveProxy(d[0])}throw new Error("Invalid call")}}e.RequestChannel=n;class R{constructor(k){this.a=k}async request(k,g){const[d,y]=await this.a.call("request",[k],g);return{res:d,stream:(0,P.bufferToStream)(y)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}}e.RequestChannelClient=R}),define(ie[236],se([0,1,237,10]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function n(D,k){return D.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:D.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function R(D,k,g={}){const d=(0,P.parse)(D),y=g.proxyUrl||n(d,k);if(!y)return null;const b=(0,P.parse)(y);if(!/^https?:$/.test(b.protocol||""))return null;const I={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,A.isBoolean)(g.strictSSL)?g.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((u,w)=>{X(["http-proxy-agent"],u,w)}))(I):new(await new Promise((u,w)=>{X(["https-proxy-agent"],u,w)}))(I)}e.getProxyAgent=R}),define(ie[115],se([0,1,46,9,177,22,44,13,4,31,152,62,7,131]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let w;async function S(h,f,p,v){return p["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(v)&&!p["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(v)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=I.Promises.withAsyncBody(async(C,t)=>{const c=new R.CancellationTokenSource;let i=1e4;const o=h.getValue("application.shellEnvironmentResolutionTimeout");typeof o=="number"&&(i=(0,u.clamp)(o,1,120)*1e3);const r=setTimeout(()=>{c.dispose(!0),t(new Error((0,n.localize)(0,null)))},i);try{C(await s(f,c.token))}catch(l){!(0,k.isCancellationError)(l)&&!c.token.isCancellationRequested?t(new Error((0,n.localize)(1,null,(0,D.toErrorMessage)(l)))):C({})}finally{clearTimeout(r),c.dispose()}})),w)}e.getResolvedShellEnv=S;async function s(h,f){const p=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",p);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",v);const C=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(C+"({.*})"+C),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",c);const i=await(0,y.getSystemShell)(g.OS,c);return h.trace("getUnixShellEnvironment#shell",i),new Promise((o,r)=>{if(f.isCancellationRequested)return r(new k.CancellationError);const l=(0,A.basename)(i);let a,m;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(a=`& '${process.execPath}' ${E} -p '''${C}'' + JSON.stringify(process.env) + ''${C}'''`,m=["-Login","-Command"]):(a=`'${process.execPath}' ${E} -p '"${C}" + JSON.stringify(process.env) + "${C}"'`,l==="tcsh"||l==="csh"?m=["-ic"]:m=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(m),a);const M=(0,P.spawn)(i,[...m,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});f.onCancellationRequested(()=>(M.kill(),r(new k.CancellationError))),M.on("error",z=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(z)),r(z)});const T=[];M.stdout.on("data",z=>T.push(z));const N=[];M.stderr.on("data",z=>N.push(z)),M.on("close",(z,K)=>{const ae=Buffer.concat(T).toString("utf8");h.trace("getUnixShellEnvironment#raw",ae);const le=Buffer.concat(N).toString("utf8");if(le.trim()&&h.trace("getUnixShellEnvironment#stderr",le),z||K)return r(new Error((0,n.localize)(2,null,z,K)));const te=t.exec(ae),F=te?te[1]:"{}";try{const $=JSON.parse(F);p?$.ELECTRON_RUN_AS_NODE=p:delete $.ELECTRON_RUN_AS_NODE,v?$.ELECTRON_NO_ATTACH_CONSOLE=v:delete $.ELECTRON_NO_ATTACH_CONSOLE,delete $.VSCODE_RESOLVING_ENVIRONMENT,delete $.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",$),o($)}catch($){h.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)($)),r($)}})})}}),define(ie[91],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,P.createDecorator)(e.SIGN_SERVICE_ID)}),define(ie[238],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class P{constructor(){this.b=new Map}c(){return new Promise((n,R)=>X(["vsda"],n,R))}async createNewMessage(n){try{const R=await this.c(),D=new R.validator;if(D){const k=String(P.a++);return this.b.set(k,D),{id:k,data:D.createNewMessage(n)}}}catch{}return{id:"",data:n}}async validate(n,R){if(!n.id)return!0;const D=this.b.get(n.id);if(!D)return!1;this.b.delete(n.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(n){try{const R=await this.c(),D=new R.signer;if(D)return D.sign(n)}catch{}return n}}P.a=1,e.SignService=P}),define(ie[33],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,P.createDecorator)("stateReadService"),e.IStateService=(0,P.createDecorator)("stateService")}),define(ie[20],se([0,1,15,42,7,3,2,4,36,10,6,5,33,28]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,y.createDecorator)("lifecycleMainService");var w;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(w=e.ShutdownReason||(e.ShutdownReason={}));var S;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})(S=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let s=class ht extends D.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(f,p,v){super(),this.v=f,this.w=p,this.y=v,this.c=this.B(new R.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new R.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(ht.b),this.j&&this.w.removeItem(ht.b)}C(){const f=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.isMacintosh&&this.n===0&&this.D(1))};P.app.addListener("before-quit",f);const p=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!k.isMacintosh)&&P.app.quit()};P.app.addListener("window-all-closed",p),P.app.once("will-quit",v=>{this.L("Lifecycle#app.on(will-quit) - begin"),v.preventDefault(),this.D(1).finally(()=>{this.L("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.H(!1),P.app.removeListener("before-quit",f),P.app.removeListener("window-all-closed",p),this.L("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}D(f){if(this.s)return this.s;const p=this.v;this.L("Lifecycle#onWillShutdown.fire()");const v=[];return this.f.fire({reason:f,join(C,t){p.trace(`Lifecycle#onWillShutdown - begin '${C}'`),v.push(t.finally(()=>{p.trace(`Lifecycle#onWillShutdown - end '${C}'`)}))}}),this.s=(async()=>{try{await n.Promises.settled(v)}catch(C){this.v.error(C)}try{await this.w.close()}catch(C){this.v.error(C)}})(),this.s}set phase(f){if(f<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===f)return;this.L(`lifecycle (main): phase changed (value: ${f})`),this.k=f;const p=this.u.get(this.k);p&&(p.open(),this.u.delete(this.k))}async when(f){if(f<=this.k)return;let p=this.u.get(f);p||(p=new n.Barrier,this.u.set(f,p)),await p.wait()}registerWindow(f){const p=new D.DisposableStore;this.n++,p.add(f.onWillLoad(C=>this.g.fire({window:f,workspace:C.workspace,reason:C.reason})));const v=(0,d.assertIsDefined)(f.win);v.on("close",C=>{const t=f.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${f.id}`),C.preventDefault(),this.unload(f,1).then(c=>{if(c){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(f),f.close()})}),v.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${f.id}`),this.n--,p.dispose(),this.n===0&&(!k.isMacintosh||this.i)&&this.D(1)})}async reload(f,p){await this.unload(f,3)||f.reload(p)}unload(f,p){const v=this.t.get(f.id);if(v)return v;const C=this.F(f,p).finally(()=>{this.t.delete(f.id)});return this.t.set(f.id,C),C}async F(f,p){if(!f.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${f.id}`);const v=this.i?2:p,C=await this.I(f,v);return C?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${f.id})`),this.G(C)):(await this.J(f,v),!1)}G(f){return f?(this.H(!0),this.i=!1,!0):!1}H(f){this.r&&(this.r(f),this.r=void 0,this.p=void 0)}I(f,p){return new Promise(v=>{const C=this.m++,t=`vscode:ok${C}`,c=`vscode:cancel${C}`;A.validatedIpcMain.once(t,()=>{v(!1)}),A.validatedIpcMain.once(c,()=>{v(!0)}),f.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:c,reason:p})})}J(f,p){return new Promise(v=>{const t=`vscode:reply${this.m++}`;A.validatedIpcMain.once(t,()=>v()),f.send("vscode:onWillUnload",{replyChannel:t,reason:p})})}quit(f){return this.L(`Lifecycle#quit() - begin (willRestart: ${f})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(f&&this.w.setItem(ht.b,!0),this.p=new Promise(p=>{this.r=p,this.L("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.p)}L(f){this.y.args["enable-smoke-test-driver"]?this.v.info(f):this.v.trace(f)}async relaunch(f){this.L("Lifecycle#relaunch()");const p=process.argv.slice(1);if(f?.addArgs&&p.push(...f.addArgs),f?.removeArgs)for(const t of f.removeArgs){const c=p.indexOf(t);c>=0&&p.splice(c,1)}const v=()=>{try{if(k.isWindows){const t=(0,g.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:p})};P.app.once("quit",v),await this.quit(!0)&&P.app.removeListener("quit",v)}async kill(f){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const p of P.BrowserWindow.getAllWindows())if(p&&!p.isDestroyed()){let v;p.webContents&&!p.webContents.isDestroyed()?v=new Promise(C=>p.once("closed",C)):v=Promise.resolve(),p.destroy(),await v}})()]),P.app.exit(f)}};s.b="lifecycle.quitAndRestart",s=ye([ee(0,b.ILogService),ee(1,I.IStateService),ee(2,u.IEnvironmentMainService)],s),e.LifecycleMainService=s}),define(ie[239],se([0,1,4,3,2,6,20]),function(X,e,P,A,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let k=class extends n.Disposable{constructor(y){super(),this.a=this.B(new A.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,y.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const y=await new Promise((b,I)=>{X(["native-keymap"],b,I)});this.c=g(y),P.isCI||y.onDidChangeKeyboardLayout(()=>{this.c=g(y),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};k=ye([ee(0,D.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function g(d){const y=d.getKeyMap(),b=d.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:b}}}),define(ie[116],se([0,1,7,17,10,34,16,5]),function(X,e,P,A,n,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var g;(function(I){I[I.IMMEDIATE=0]="IMMEDIATE",I[I.DELAYED=1]="DELAYED"})(g=e.SaveStrategy||(e.SaveStrategy={}));class d{constructor(u,w,S,s){this.f=u,this.g=S,this.h=s,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=w===0?void 0:new P.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(u){u.fileOperationResult!==1&&this.g.error(u)}}getItem(u,w){const S=this.a[u];return(0,n.isUndefinedOrNull)(S)?w:S}setItem(u,w){this.setItems([{key:u,data:w}])}setItems(u){let w=!1;for(const{key:S,data:s}of u)this.a[S]!==s&&((0,n.isUndefinedOrNull)(s)?(0,n.isUndefined)(this.a[S])||(this.a[S]=void 0,w=!0):(this.a[S]=s,w=!0));w&&this.j()}removeItem(u){(0,n.isUndefined)(this.a[u])||(this.a[u]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const u=JSON.stringify(this.a,null,4);if(u!==this.b)try{await this.h.writeFile(this.f,A.VSBuffer.fromString(u)),this.b=u}catch(w){this.g.error(w)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=d;let y=class{constructor(u,w,S,s){this.a=new d(w.stateResource,u,S,s)}async init(){await this.a.init()}getItem(u,w){return this.a.getItem(u,w)}};y=ye([ee(1,R.IEnvironmentService),ee(2,k.ILogService),ee(3,D.IFileService)],y),e.StateReadonlyService=y;class b extends y{setItem(u,w){this.a.setItem(u,w)}setItems(u){this.a.setItems(u)}removeItem(u){this.a.removeItem(u)}close(){return this.a.close()}}e.StateService=b}),define(ie[92],se([0,1,4,36,8,31]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(d){if(P.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function k(d,y,b,I,u,w,S,s,h,f){const p=Object.create(null);p["common.machineId"]=S,p.sessionID=(0,R.generateUuid)()+Date.now(),p.commitHash=u,p.version=w,p["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,P.PlatformToString)(P.platform),p["common.nodePlatform"]=A.platform,p["common.nodeArch"]=I,p["common.product"]=f||"desktop",s&&(p["common.msftInternal"]=s);let v=0;const C=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-C,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),P.isLinuxSnap&&(p["common.snap"]="true");const t=D(b);t&&(p["common.platformDetail"]=t);try{const c=await d.readFile(n.URI.file(h));p["common.source"]=c.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=k;function g(d){const y=A.env.USERDNSDOMAIN;if(!y)return!1;const b=y.toLowerCase();return d.some(I=>b===I)}e.verifyMicrosoftInternalDomain=g}),define(ie[24],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,P.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,P.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var n;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(n=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ie[240],se([0,1,27,7,43,14,9,4,8,84,23,103,87,16,21,24]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const s=new Map;async function h(t,c){const i=`${t}::${c.join(":")}`,o=s.get(i);if(o)return o;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,a=new Map,m=2e4;function E(T,N,z,K){const ae=N.substring(T.length+1);return A.Promises.withAsyncBody(async le=>{let te;try{te=await y.Promises.readdir(N,{withFileTypes:!0})}catch{le();return}if(K.count>=m){K.count+=te.length,K.maxReached=!0,le();return}let F=te.length;if(F===0){le();return}let $=te;K.count+te.length>m&&(K.maxReached=!0,F=m-K.count,$=te.slice(0,F)),K.count+=te.length;for(const V of $)if(V.isDirectory()){if(z.includes(V.name)||await E(T,(0,D.join)(N,V.name),z,K),--F===0){le();return}}else{const x=V.name.lastIndexOf(".");if(x>=0){const H=V.name.substring(x+1);H&&l.set(H,(l.get(H)??0)+1)}for(const H of r)H.relativePathPattern?.test(ae)!==!1&&H.filePattern.test(V.name)&&a.set(H.tag,(a.get(H.tag)??0)+1);if(--F===0){le();return}}})}const M=A.Promises.withAsyncBody(async T=>{const N={count:0,maxReached:!1};await E(t,t,c,N);const z=await v(t);T({configFiles:f(a),fileTypes:f(l),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:z})});return s.set(i,M),M}e.collectWorkspaceStats=h;function f(t){return Array.from(t.entries(),([c,i])=>({name:c,count:i})).sort((c,i)=>i.count-c.count)}function p(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(P.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.virtualMachineHint.value()*100)}%`},c=P.cpus();return c&&c.length>0&&(t.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),t}e.getMachineInfo=p;async function v(t){try{const c=new Map,i=(0,D.join)(t,".vscode","launch.json"),o=await y.Promises.readFile(i),r=[],l=(0,n.parse)(o.toString(),r);if(r.length)return console.log(`Unable to parse ${i}`),[];if((0,n.getNodeType)(l)==="object"&&l.configurations)for(const a of l.configurations){const m=a.type;m&&(c.has(m)?c.set(m,c.get(m)+1):c.set(m,1))}return f(c)}catch{return[]}}e.collectLaunchConfigs=v;let C=class{constructor(c,i){this.c=c,this.d=i}f(c){const i=[];return i.push(`OS Version:       ${c.os}`),i.push(`CPUs:             ${c.cpus}`),i.push(`Memory (System):  ${c.memory}`),i.push(`VM:               ${c.vmHint}`),i.join(`
`)}g(c){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const o=P.cpus();return o&&o.length>0&&i.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),i.push(`Memory (System):  ${(P.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(P.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||i.push(`Load (avg):       ${P.loadavg().map(r=>Math.round(r)).join(", ")}`),i.push(`VM:               ${Math.round(d.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${c.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(c,i){return Promise.all([(0,b.listProcesses)(c.mainPID),this.k(c)]).then(async o=>{let[r,l]=o,a=this.m(c,r);return i.forEach(m=>{if((0,I.isRemoteDiagnosticError)(m))a+=`
${m.errorMessage}`,l+=`
${m.errorMessage}`;else if(a+=`

Remote: ${m.hostName}`,m.processes&&(a+=`
${this.m(c,m.processes)}`),m.workspaceMetadata){l+=`
|  Remote: ${m.hostName}`;for(const E of Object.keys(m.workspaceMetadata)){const M=m.workspaceMetadata[E];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),l+=`|    Folder (${E}): ${T}`,l+=this.h(M)}}}),{processInfo:a,workspaceInfo:l}})}async getSystemInfo(c,i){const{memory:o,vmHint:r,os:l,cpus:a}=p(),m={os:l,memory:o,cpus:a,vmHint:r,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:i};return k.isWindows||(m.load=`${P.loadavg().map(E=>Math.round(E)).join(", ")}`),k.isLinux&&(m.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(m)}async getDiagnostics(c,i){const o=[];return(0,b.listProcesses)(c.mainPID).then(async r=>(o.push(""),o.push(this.g(c)),o.push(""),o.push(this.m(c,r)),c.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.k(c))),i.forEach(l=>{if((0,I.isRemoteDiagnosticError)(l))o.push(`
${l.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${l.hostName}`),o.push(this.f(l.machineInfo)),l.processes&&o.push(this.m(c,l.processes)),l.workspaceMetadata)for(const a of Object.keys(l.workspaceMetadata)){const m=l.workspaceMetadata[a];let E=`${m.fileCount} files`;m.maxFilesReached&&(E=`more than ${E}`),o.push(`Folder (${a}): ${E}`),o.push(this.h(m))}}),o.push(""),o.push(""),o.join(`
`)))}h(c){const i=[];let r=0;const l=(M,T)=>{const N=` ${M}(${T})`;r+N.length>60?(i.push(a),a="|                 ",r=a.length):r+=N.length,a+=N};let a="|      File types:";const m=10,E=c.fileTypes.length>m?m:c.fileTypes.length;for(let M=0;M<E;M++){const T=c.fileTypes[M];l(T.name,T.count)}if(i.push(a),c.configFiles.length>=0&&(a="|      Conf files:",r=0,c.configFiles.forEach(M=>{l(M.name,M.count)}),i.push(a)),c.launchConfigFiles.length>0){let M="|      Launch Configs:";c.launchConfigFiles.forEach(T=>{M+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),i.push(M)}return i.join(`
`)}j(c){const i=Math.max(...Object.keys(c).map(o=>o.length));return Object.keys(c).map(o=>`${o}:  ${" ".repeat(i-o.length)}  ${c[o]}`).join(`
                  `)}k(c){const i=[],o=[];return c.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(i.push(`|  Window (${r.title})`),r.folderURIs.forEach(l=>{const a=g.URI.revive(l);if(a.scheme===R.Schemas.file){const m=a.fsPath;o.push(h(m,["node_modules",".git"]).then(E=>{let M=`${E.fileCount} files`;E.maxFilesReached&&(M=`more than ${M}`),i.push(`|    Folder (${(0,D.basename)(m)}): ${M}`),i.push(this.h(E))}).catch(E=>{i.push(`|      Error: Unable to collect workspace stats for folder ${m} (${E.toString()})`)}))}else i.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(r=>i.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}m(c,i){const o=new Map;c.windows.forEach(l=>o.set(l.pid,l.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),i&&this.n(c.mainPID,o,r,i,0),r.join(`
`)}n(c,i,o,r,l){const a=l===0;let m;a?m=r.pid===c?`${this.d.applicationName} main`:"remote agent":(m=`${"  ".repeat(l)} ${r.name}`,r.name==="window"&&(m=`${m} (${i.get(r.pid)})`));const E=process.platform==="win32"?r.mem:P.totalmem()*(r.mem/100);o.push(`${r.load.toFixed(0).padStart(5," ")}	${(E/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${m}`),Array.isArray(r.children)&&r.children.forEach(M=>this.n(c,i,o,M,l+1))}async getWorkspaceFileExtensions(c){const i=new Set;for(const{uri:o}of c.folders){const r=g.URI.revive(o);if(r.scheme!==R.Schemas.file)continue;const l=r.fsPath;try{(await h(l,["node_modules",".git"])).fileTypes.forEach(m=>i.add(m.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(c){for(const{uri:i}of c.folders){const o=g.URI.revive(i);if(o.scheme!==R.Schemas.file)continue;const r=o.fsPath;try{const l=await h(r,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),l.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),l.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),l.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};C=ye([ee(0,S.ITelemetryService),ee(1,w.IProductService)],C),e.DiagnosticsService=C}),define(ie[241],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class P{constructor(R){this.b=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:k,data:g}){return this.b.forEach(d=>d.log(k,g)),Promise.resolve(null)}}e.TelemetryAppenderChannel=P;class A{constructor(R){this.b=R}log(R,D){return this.b.call("log",{eventName:R,data:D}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(ie[48],se([0,1,37,10,3,19,56,92,24]),function(X,e,P,A,n,R,D,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class d{constructor(a){this.value=a}}e.TelemetryTrustedValue=d;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,m){return Promise.resolve(void 0)}publicLog2(a,m){return this.publicLog(a,m)}publicLogError(a,m){return Promise.resolve(void 0)}publicLogError2(a,m){return this.publicLogError(a,m)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class b{async publicLog(a,m,E){}async publicLogError(a,m,E){}}e.NullEndpointTelemetryService=b,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function I(l,a){return n.Event.debounce(a.onDidChangeConfiguration,(E,M)=>{const T=E?new Set([...E.affectedKeys,...M.affectedKeys]):M.affectedKeys;return{...M,affectedKeys:T}},1e3,!0)(E=>{E.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(E.source),configurationKeys:v(E.affectedKeys)})})}e.configurationTelemetry=I;function u(l,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!l.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=u;function w(l,a){return!(a.isBuilt||a.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}e.isLoggingOnly=w;function S(l){const a=l.getValue(g.TELEMETRY_SETTING_ID),m=l.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(l.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||m===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function s(l){const a={},m={},E={};p(l,E);for(let M in E){M=M.length>150?M.substr(M.length-149):M;const T=E[M];typeof T=="number"?m[M]=T:typeof T=="boolean"?m[M]=T?1:0:typeof T=="string"?(T.length>8192&&console.warn(`Telemetry property: ${M} has been trimmed to 8192, the original length is ${T.length}`),a[M]=T.substring(0,8191)):typeof T<"u"&&T!==null&&(a[M]=T)}return{properties:a,measurements:m}}e.validateTelemetryData=s;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(l){if(!l)return"none";const a=(0,D.getRemoteName)(l);return h.has(a)?a:"other"}e.cleanRemoteAuthority=f;function p(l,a,m=0,E){if(!!l)for(const M of Object.getOwnPropertyNames(l)){const T=l[M],N=E?E+M:M;Array.isArray(T)?a[N]=(0,P.safeStringify)(T):T instanceof Date?a[N]=T.toISOString():(0,A.isObject)(T)?m<2?p(T,a,m+1,N+"."):a[N]=(0,P.safeStringify)(T):a[N]=T}}function v(l){if(!l)return[];const a=[];return C(a,"",l),a}function C(l,a,m){m&&typeof m=="object"&&!Array.isArray(m)?Object.keys(m).forEach(E=>C(l,a?`${a}.${E}`:E,m[E])):l.push(a)}function t(l,a){const m=l.msftInternalDomains||[],E=a.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(m)||E}e.isInternalTelemetry=t;function c(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=c;function i(l,a){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let m=l;const E=[];for(const z of a)for(;;){const K=z.exec(l);if(!K)break;E.push([K.index,z.lastIndex])}const M=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,T=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(m="";;){const z=T.exec(l);if(!z)break;const K=E.some(([ae,le])=>z.index<le&&ae<T.lastIndex);!M.test(z[0])&&!K&&(m+=l.substring(N,z.index)+"<REDACTED: user-file-path>",N=T.lastIndex)}return N<l.length&&(m+=l.substr(N)),m}function o(l){if(!l)return l;const a=l.toLowerCase(),m=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const E of m)if(E.regex.test(a))return`<REDACTED: ${E.label}>`;return l}function r(l,a){return(0,P.cloneAndChange)(l,m=>{if(m instanceof d)return m.value;if(typeof m=="string"){let E=m.replaceAll("%20"," ");E=i(E,a);for(const M of a)E=E.replace(M,"");return E=o(E),E}})}e.cleanData=r}),define(ie[117],se([0,1,25,110,114,4,8,13,36,48]),function(X,e,P,A,n,R,D,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function y(i,o){return i.uuid&&o.uuid?i.uuid===o.uuid:i.id===o.id?!0:(0,P.compareIgnoreCase)(i.id,o.id)===0}e.areSameExtensions=y;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class I{static create(o){const r=o.manifest?o.manifest.version:o.version,l=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new I(o.identifier,r,l)}static parse(o){const r=b.exec(o);return r&&r[1]&&r[2]?new I({id:r[1]},r[2],r[4]||void 0):null}constructor(o,r,l="undefined"){this.version=r,this.targetPlatform=l,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof I?y(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=I;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(i){const o=u.exec(i);return o&&o[1]?[s(o[1]),o[2]]:[s(i),void 0]}e.getIdAndVersion=w;function S(i,o){return`${i}.${o}`}e.getExtensionId=S;function s(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=s;function h(i,o){return s(S(i,o))}e.getGalleryExtensionId=h;function f(i,o){const r=[],l=a=>{for(const m of r)if(m.some(E=>y(o(E),o(a))))return m;return null};for(const a of i){const m=l(a);m?m.push(a):r.push([a])}return r}e.groupByExtension=f;function p(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function v(i){return{id:new d.TelemetryTrustedValue(i.identifier.id),name:new d.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function C(i,o){const r=[],l=o.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const a=l.shift();if(a&&r.every(m=>!y(m.identifier,{id:a}))){const m=i.filter(E=>y(E.identifier,{id:a}));m.length===1&&(r.push(m[0]),l.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=C;async function t(i,o){if(!R.isLinux)return!1;let r;try{r=(await i.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){o.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(a))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(i,o){const r=await t(i,o),l=(0,A.getTargetPlatform)(r?"alpine":R.platform,g.arch);return o.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=c}),define(ie[242],se([0,1,198,48]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function n(R,D,k,g,d,y,b){const I={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${D.nameShort})`};if((0,A.supportsTelemetry)(D,k)&&(0,A.getTelemetryLevel)(g)===3){const u=await(0,P.getServiceMachineId)(k,d,y),{machineId:w}=await b.getTelemetryInfo();I["X-Market-User-Id"]=u,I["VSCode-SessionId"]=w||u}return I}e.resolveMarketplaceHeaders=n}),define(ie[243],se([0,1,13,37,48]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",D="https://mobile.events.data.microsoft.com/ping";async function k(d,y,b){const I=await new Promise((h,f)=>{X(["@microsoft/1ds-core-js"],h,f)}),u=await new Promise((h,f)=>{X(["@microsoft/1ds-post-js"],h,f)}),w=new I.AppInsightsCore,S=new u.PostChannel,s={instrumentationKey:d,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[S]]};if(b){s.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:b};s.extensionConfig[S.identifier]=h}return w.initialize(s,[]),w.addTelemetryInitializer(h=>{y&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),w}class g{constructor(y,b,I,u,w){this.e=y,this.f=b,this.g=I,this.h=w,this.c=R,this.d=D,this.g||(this.g={}),typeof u=="function"?this.a=u():this.a=u,this.b=null}i(y){if(!!this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(b=>{y(b)},b=>{(0,P.onUnexpectedError)(b),console.error(b)})}}log(y,b){if(!this.a)return;b=(0,A.mixin)(b,this.g),b=(0,n.validateTelemetryData)(b);const I=this.f+"/"+y;try{this.i(u=>{u.pluginVersionString=b?.properties.version??"Unknown",u.track({name:I,baseData:{name:I,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(ie[118],se([0,1,2,37,4,25,178,19,68,66,21,51,24,48]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(h,f,p){this.k=f,this.l=p,this.d={},this.i=new P.DisposableStore,this.j=[],this.b=h.appenders,this.c=h.commonProperties||Promise.resolve({}),this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,R.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(I.TELEMETRY_SETTING_ID)||v.affectsConfiguration(I.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(I.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,u.getTelemetryLevel)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const p=f.usage?3:f.error?2:0;h=Math.min(h,p)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const h=await this.c,f=h.sessionID,p=h["common.machineId"],v=h["common.firstSessionDate"],C=h["common.msftInternal"];return{sessionId:f,machineId:p,firstSessionDate:v,msftInternal:C}}dispose(){this.i.dispose()}n(h,f,p){return this.g<f?Promise.resolve(void 0):this.c.then(v=>{p=(0,A.mixin)(p,this.d),p=(0,u.cleanData)(p,this.j),p=(0,A.mixin)(p,v),this.b.forEach(C=>C.log(h,p))},v=>{console.error(v)})}publicLog(h,f){return this.n(h,3,f)}publicLog2(h,f){return this.publicLog(h,f)}publicLogError(h,f){return this.h?this.n(h,2,f):Promise.resolve(void 0)}publicLogError2(h,f){return this.publicLogError(h,f)}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=ye([ee(1,k.IConfigurationService),ee(2,y.IProductService)],w),e.TelemetryService=w;function S(){const s=(0,D.localize)(0,null,d.default.nameLong),h=d.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=n.isWeb?"":(0,D.localize)(3,null),p=(0,D.localize)(4,null),v=(0,D.localize)(5,null),C=(0,D.localize)(6,null),t=(0,D.localize)(7,null),c=`
|       | ${p} | ${v} | ${C} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,D.localize)(8,null);return`
${s} ${h} ${f}

&nbsp;

${t}
${c}

&nbsp;

${i}
`}b.Registry.as(g.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(g.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,D.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,D.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[244],se([0,1,292,243]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class n extends A.AbstractOneDataSystemAppender{constructor(D,k,g,d){const y={sendPOST:(b,I)=>{const u={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const w=P.request(b.urlString,u,S=>{S.on("data",function(s){I(S.statusCode??200,S.headers,s.toString())}),S.on("error",function(s){I(0,{})})});w.write(b.data),w.end()}catch{I(0,{})}}};super(D,k,g,d,y)}}e.OneDataSystemAppender=n}),define(ie[245],se([0,1,4,84,24]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function R(D){let k=D.getItem(n.machineIdKey);return(typeof k!="string"||P.isMacintosh&&k==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(k=await(0,A.getMachineId)()),k}e.resolveMachineId=R}),define(ie[119],se([0,1,24,245]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function n(R){const D=await(0,A.resolveMachineId)(R);return R.setItem(P.machineIdKey,D),D}e.resolveMachineId=n}),define(ie[69],se([0,1,15,3,2,4,19,6,33]),function(X,e,P,A,n,R,D,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const d="#FFFFFF",y="#1E1E1E",b="#000000",I="#FFFFFF",u="theme",w="themeBackground",S="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let s=class extends n.Disposable{constructor(f,p){super(),this.b=f,this.c=p,this.a=this.B(new A.Emitter),this.onDidChangeColorScheme=this.a.event,P.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return f.dark?b:I;let p=this.b.getItem(w,null);if(!p)switch(this.b.getItem(u,"vs-dark").split(" ")[0]){case"vs":p=d;break;case"hc-black":p=b;break;case"hc-light":p=I;break;default:p=y}return R.isMacintosh&&p.toUpperCase()===y&&(p="#171717"),p}saveWindowSplash(f,p){this.b.setItems([{key:u,data:p.baseTheme},{key:w,data:p.colorInfo.background},{key:S,data:p}]),typeof f=="number"&&this.f(f,p)}f(f,p){for(const v of P.BrowserWindow.getAllWindows())if(v.id===f){v.setBackgroundColor(p.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(S)}};s=ye([ee(0,g.IStateService),ee(1,D.IConfigurationService)],s),e.ThemeMainService=s}),define(ie[120],se([0,1,3,19,6,5]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,n.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,n.createDecorator)("sharedTunnelsService");var D;(function(S){S.Http="http",S.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var g;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(g=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function d(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=d,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=b;function I(S,s,h,f){if(h===1)return!1;if(h===2&&b(s)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(p?.length===4&&parseInt(p[1])>=18)return!1}return S<1024}e.isPortPrivileged=I;class u{constructor(s,h,f){this.remoteAddress=s,this.localAddress=h,this.b=f,this.a=new P.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=u;let w=class{constructor(s,h){this.i=s,this.j=h,this.a=new P.Emitter,this.onTunnelOpened=this.a.event,this.b=new P.Emitter,this.onTunnelClosed=this.b.event,this.c=new P.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const s=this.j.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.e=s,s?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.f=s.elevation,this.g=s.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const s=[],h=Array.from(this.d.values());for(const f of h){const p=Array.from(f.values());for(const v of p){const C=await v.value;C&&s.push(C)}}return s}async dispose(){for(const s of this.d.values()){for(const{value:h}of s.values())await h.then(f=>f?.dispose());s.clear()}this.d.clear()}setEnvironmentTunnel(s,h,f,p,v){this.o(s,h,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:h,localAddress:f,privacy:p,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,h){(b(s)||y(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const f=this.q(s,h);if(f)return++f.refcount,f.value}openTunnel(s,h,f,p,v,C=!1,t,c){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${f} on local port ${v}.`),!s)return;if(h||(h="localhost"),p||(p=this.k),this.e&&this.h.has(f)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(s,h,f,p,v,C,t,c);return i?i.then(o=>{if(!o){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,f);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.m(o);return(o.tunnelRemoteHost!==h||o.tunnelRemotePort!==f)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(r),r}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const h=this.d.get(s.tunnelRemoteHost);if(h){const f=h.get(s.tunnelRemotePort);f&&(f.refcount--,await this.n(s.tunnelRemoteHost,s.tunnelRemotePort,f))}}}}async n(s,h,f){if(f.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${h}.`);const p=f.value.then(async v=>{v&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.d.has(s)&&this.d.get(s).delete(h),p}}async closeTunnel(s,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${h} `);const f=this.d.get(s);if(f&&f.has(h)){const p=f.get(h);p.refcount=0,await this.n(s,h,p)}}o(s,h,f){this.d.has(s)||this.d.set(s,new Map),this.d.get(s).set(h,{refcount:1,value:f})}async p(s,h){const f=this.d.get(s);f&&(await f.get(h)||f.delete(h),f.size===0&&this.d.delete(s))}q(s,h){const f=[s];y(s)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):b(s)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const p=f.map(v=>this.d.get(v));for(const v of p){const C=v?.get(h);if(C)return C}}canTunnel(s){return!!d(s)}s(s,h,f,p,v,C,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${f} on local port ${p}.`);const c=f;this.h.add(c);const i=p===void 0?f:p,o={elevationRequired:v?this.isPortPrivileged(i):!1},r={remoteAddress:{host:h,port:f},localAddressPort:p,privacy:C,public:C?C!==k.Private:void 0,protocol:t},l=s.forwardPort(r,o);return l?(this.o(h,f,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(c)})):this.h.delete(c),l}};w=ye([ee(0,R.ILogService),ee(1,A.IConfigurationService)],w),e.AbstractTunnelService=w}),define(ie[246],se([0,1,82,27,100,233,7,2,19,5,21,232,120,91,4]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(v,C,t,c,i){let o;for(let r=3;r&&(o?.dispose(),o=await new s(v,C,t,c,i).waitForReady(),!(i&&n.BROWSER_RESTRICTED_PORTS[i]||!n.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));r--);return o}class s extends k.Disposable{constructor(C,t,c,i,o){super(),this.j=t,this.k=o,this.privacy=I.TunnelPrivacyId.Private,this.i=new Map,this.a=C,this.b=P.createServer(),this.c=new D.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=r=>this.l(r),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const C=this.k??this.tunnelRemotePort,t=(0,I.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let c=await(0,n.findFreePortFaster)(C,2,1e3,t),i=null;return this.b.listen(c,this.j),await this.c.wait(),i=this.b.address(),i||(c=0,this.b.listen(c,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(C){C.pause();const t=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,b.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=c.getSocket().socket,o=c.readEntireBuffer();c.dispose(),o.byteLength>0&&C.write(o.buffer),C.on("end",()=>{C.localAddress&&this.i.delete(C.localAddress),i.end()}),C.on("close",()=>i.end()),C.on("error",()=>{C.localAddress&&this.i.delete(C.localAddress),i.destroy()}),i.on("end",()=>C.end()),i.on("close",()=>C.end()),i.on("error",()=>{C.destroy()}),C.pipe(i),i.pipe(C),C.localAddress&&this.i.set(C.localAddress,()=>{C.end(),i.end()})}}let h=class extends I.AbstractTunnelService{constructor(C,t,c,i,o){super(t,o),this.t=C,this.u=c,this.v=i}isPortPrivileged(C){return(0,I.isPortPrivileged)(C,this.k,w.OS,A.release())}r(C,t,c,i,o,r,l,a){const m=this.q(t,c);if(m)return++m.refcount,m.value;if(this.e)return this.s(this.e,t,c,o,r,l,a);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${c} on local port ${o}.`);const E={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:C,signService:this.u,logService:this.i,ipcLogger:null},M=S(E,i,t,c,o);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,c,M),M}}};h=ye([ee(1,d.ILogService),ee(2,u.ISignService),ee(3,y.IProductService),ee(4,g.IConfigurationService)],h),e.BaseTunnelService=h;let f=class extends h{constructor(C,t,c,i){super(R.nodeSocketFactory,C,t,c,i)}};f=ye([ee(0,d.ILogService),ee(1,u.ISignService),ee(2,y.IProductService),ee(3,g.IConfigurationService)],f),e.TunnelService=f;let p=class extends k.Disposable{constructor(C,t,c,i){super(),this.b=C,this.c=t,this.f=c,this.g=i,this.a=new Map}async openTunnel(C,t,c,i,o,r,l,a,m){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${i} on local port ${r}.`),!this.a.has(C)){const E=new f(this.b,this.f,this.c,this.g);this.B(E),this.a.set(C,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(C))})}return this.a.get(C).openTunnel(t,c,i,o,r,l,a,m)}};p=ye([ee(0,d.ILogService),ee(1,y.IProductService),ee(2,u.ISignService),ee(3,g.IConfigurationService)],p),e.SharedTunnelsService=p}),define(ie[49],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var A;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(A=e.StateType||(e.StateType={}));var n;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(n=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,D)=>({type:"idle",updateType:R,error:D}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,P.createDecorator)("updateService")}),define(ie[247],se([0,1,4,179,68,51]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(n.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:P.isWindows&&!P.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ie[248],se([0,1,3,49]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class n{constructor(k){this.a=k}listen(k,g){switch(g){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${g}`)}call(k,g,d){switch(g){case"checkForUpdates":return this.a.checkForUpdates(d);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(d)}throw new Error(`Call not found: ${g}`)}}e.UpdateChannel=n;class R{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new P.Emitter,this.onStateChange=this.a.event,this.b=A.State.Uninitialized,this.c.listen("onStateChange")(g=>this.state=g),this.c.call("_getInitialState").then(g=>this.state=g)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.UpdateChannelClient=R}),define(ie[93],se([0,1,7,22,3,19,28,20,5,21,52,49]),function(X,e,P,A,n,R,D,k,g,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(w,S,s){return`${s.updateUrl}/api/update/${w}/${S}/${s.commit}`}e.createUpdateURL=I;let u=class{get state(){return this.b}d(S){this.j.info("update#setState",S.type),this.b=S,this.c.fire(S)}constructor(S,s,h,f,p,v){this.f=S,this.g=s,this.h=h,this.i=f,this.j=p,this.k=v,this.b=b.State.Uninitialized,this.c=new n.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const S=this.g.getValue("update.mode"),s=this.l(S);if(!s){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.r(s),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(b.State.Idle(this.p())),S==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}S==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.m(30*1e3).then(void 0,h=>this.j.error(h))}l(S){return S==="none"?void 0:this.k.quality}m(S=60*60*1e3){return(0,P.timeout)(S).then(()=>this.checkForUpdates(!1)).then(()=>this.m(60*60*1e3))}async checkForUpdates(S){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.s(S)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.n(this.state)}async n(S){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.o()}async o(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(S=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${S}`),!S&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.q())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},A.CancellationToken.None)).res.statusCode===204}catch(s){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(s);return}}async _applySpecificUpdate(S){}p(){return 1}q(){}};u=ye([ee(0,k.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,D.IEnvironmentMainService),ee(3,y.IRequestService),ee(4,g.ILogService),ee(5,d.IProductService)],u),e.AbstractUpdateService=u}),define(ie[249],se([0,1,15,55,3,2,19,28,20,5,21,52,24,49,93]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let S=class extends w.AbstractUpdateService{get u(){return n.Event.fromNodeEventEmitter(P.autoUpdater,"error",(h,f)=>f)}get v(){return n.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get w(){return n.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(h,f,p)=>({url:f,version:p,productVersion:p}))}get x(){return n.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(h,f,p,v)=>({releaseNotes:f,version:p,productVersion:p,date:v}))}constructor(h,f,p,v,C,t,c){super(h,f,v,C,t,c),this.y=p,this.t=new R.DisposableStore}async initialize(){await super.initialize(),this.u(this.z,this,this.t),this.w(this.C,this,this.t),this.x(this.D,this,this.t),this.v(this.E,this,this.t)}z(h){this.j.error("UpdateService error:",h);const p=(this.state.type==="checking for updates"?this.state.explicit:!0)?h:void 0;this.d(u.State.Idle(1,p))}r(h){let f;this.k.darwinUniversalAssetId?f=this.k.darwinUniversalAssetId:f=process.arch==="x64"?"darwin":"darwin-arm64";const p=(0,w.createUpdateURL)(f,h,this.k);try{P.autoUpdater.setFeedURL({url:p})}catch(v){this.j.error("Failed to set update feed URL",v);return}return p}s(h){this.d(u.State.CheckingForUpdates(h)),P.autoUpdater.checkForUpdates()}C(h){this.state.type==="checking for updates"&&this.d(u.State.Downloading(h))}D(h){this.state.type==="downloading"&&(this.y.publicLog2("update:downloaded",{version:h.version}),this.d(u.State.Ready(h)))}E(){this.state.type==="checking for updates"&&(this.y.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(u.State.Idle(1)))}q(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.t.dispose()}};ye([A.memoize],S.prototype,"u",null),ye([A.memoize],S.prototype,"v",null),ye([A.memoize],S.prototype,"w",null),ye([A.memoize],S.prototype,"x",null),S=ye([ee(0,g.ILifecycleMainService),ee(1,D.IConfigurationService),ee(2,I.ITelemetryService),ee(3,k.IEnvironmentMainService),ee(4,b.IRequestService),ee(5,d.ILogService),ee(6,y.IProductService)],S),e.DarwinUpdateService=S}),define(ie[250],se([0,1,46,41,7,3,9,28,20,5,24,49]),function(X,e,P,A,n,R,D,k,g,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{get state(){return this.a}d(S){this.g.info("update#setState",S.type),this.a=S,this.b.fire(S)}constructor(S,s,h){if(this.f=S,this.g=h,this.a=b.State.Uninitialized,this.b=new R.Emitter,this.onStateChange=this.b.event,s.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(b.State.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(S=60*60*1e3){return(0,n.timeout)(S).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(S){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(S)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(S){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(S=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${S}`),!S&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(S){}};I=ye([ee(0,g.ILifecycleMainService),ee(1,k.IEnvironmentMainService),ee(2,d.ILogService)],I);let u=class extends I{constructor(S,s,h,f,p,v){super(h,f,p),this.o=S,this.p=s,this.q=v;const C=(0,A.watch)(D.dirname(this.o)),t=R.Event.fromNodeEventEmitter(C,"change",(r,l)=>l),c=R.Event.filter(t,r=>r==="current"),o=R.Event.debounce(c,(r,l)=>l,2e3)(()=>this.checkForUpdates(!1));h.onWillShutdown(()=>{o.dispose(),C.close()})}m(){this.d(b.State.CheckingForUpdates(!1)),this.u().then(S=>{S?this.d(b.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.State.Idle(2)))},S=>{this.g.error(S),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.State.Idle(2,S.message||S))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+D.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const S=await new Promise((h,f)=>(0,A.realpath)(`${D.dirname(this.o)}/current`,(p,v)=>p?f(p):h(v))),s=D.basename(S);return this.p!==s}isLatestVersion(){return this.u().then(void 0,S=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};u=ye([ee(2,g.ILifecycleMainService),ee(3,k.IEnvironmentMainService),ee(4,d.ILogService),ee(5,y.ITelemetryService)],u),e.SnapUpdateService=u}),define(ie[39],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,P.createDecorator)("IUriIdentityService")}),define(ie[251],se([0,1,39,199,16,18,132,3,2]),function(X,e,P,A,n,R,D,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class d{constructor(I){this.uri=I,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let y=class{constructor(I){this.g=I,this.c=new g.DisposableStore,this.f=2**16;const u=new Map,w=S=>{let s=u.get(S.scheme);return s===void 0&&(s=I.hasProvider(S)&&!this.g.hasCapability(S,1024),u.set(S.scheme,s)),s};this.c.add(k.Event.any(I.onDidChangeFileSystemProviderRegistrations,I.onDidChangeFileSystemProviderCapabilities)(S=>{u.delete(S.scheme)})),this.extUri=new R.ExtUri(w),this.d=new D.SkipList((S,s)=>this.extUri.compare(S,s,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(I){this.g.hasProvider(I)&&(I=(0,R.normalizePath)(I));const u=this.d.get(I);return u?u.touch().uri.with({fragment:I.fragment}):(this.d.set(I,new d(I)),this.h(),I)}h(){if(this.d.size<this.f)return;const I=[...this.d.entries()].sort((w,S)=>w[1].time<S[1].time?1:w[1].time>S[1].time?-1:0);d._clock=0,this.d.clear();const u=this.f*.5;for(let w=0;w<u;w++)this.d.set(I[w][0],I[w][1].touch())}};y=ye([ee(0,n.IFileService)],y),e.UriIdentityService=y,(0,A.registerSingleton)(P.IUriIdentityService,y,1)}),define(ie[121],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,P.createDecorator)("urlService")}),define(ie[252],se([0,1,8]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class A{constructor(k){this.a=k}listen(k,g){throw new Error(`Event not found: ${g}`)}call(k,g,d){switch(g){case"handleURL":return this.a.handleURL(P.URI.revive(d[0]),d[1])}throw new Error(`Call not found: ${g}`)}}e.URLHandlerChannel=A;class n{constructor(k){this.a=k}handleURL(k,g){return this.a.call("handleURL",[k.toJSON(),g])}}e.URLHandlerChannelClient=n;class R{constructor(k,g){this.a=k,this.b=g}async routeCall(k,g,d,y){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(Array.isArray(d)&&d.length>0){const b=P.URI.revive(d[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",b.toString(!0)),b.query){const I=/\bwindowId=(\d+)/.exec(b.query);if(I){const u=I[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${u}"`,b.toString(!0));const w=new RegExp(`window:${u}`),S=k.connections.find(s=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",s.ctx),w.test(s.ctx)));if(S)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",b.toString(!0)),S;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",b.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",b.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(k,g,d,y)}routeEvent(k,g){throw new Error(`Event not found: ${g}`)}}e.URLHandlerRouter=R}),define(ie[253],se([0,1,7,2,8,21]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class D extends A.Disposable{constructor(){super(...arguments),this.a=new Set}open(d,y){const b=[...this.a.values()];return(0,P.first)(b.map(I=>()=>I.handleURL(d,y)),void 0,!1).then(I=>I||!1)}registerHandler(d){return this.a.add(d),(0,A.toDisposable)(()=>this.a.delete(d))}}e.AbstractURLService=D;let k=class extends D{constructor(d){super(),this.b=d}create(d){let{authority:y,path:b,query:I,fragment:u}=d||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&b&&b.indexOf("/")!==0&&(b=`/${b}`),n.URI.from({scheme:this.b.urlProtocol,authority:y,path:b,query:I,fragment:u})}};k=ye([ee(0,R.IProductService)],k),e.NativeURLService=k}),define(ie[254],se([0,1,15,7,3,2,4,8]),function(X,e,P,A,n,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class g{constructor(y,b,I,u,w,S){if(this.f=b,this.g=S,this.a=[],this.b=0,this.c=R.Disposable.None,this.d=new R.DisposableStore,y&&(S.trace("ElectronURLListener initialUrisToHandle:",y.map(f=>f.originalUrl)),this.a=y),D.isWindows){const f=u.isBuilt?[]:[`"${u.appRoot}"`];f.push("--open-url","--"),P.app.setAsDefaultProtocolClient(w.urlProtocol,process.execPath,f)}const s=n.Event.map(n.Event.fromNodeEventEmitter(P.app,"open-url",(f,p)=>({event:f,url:p})),({event:f,url:p})=>(f.preventDefault(),p));this.d.add(s(f=>{const p=this.h(f);!p||this.f.open(p,{originalUrl:f})})),I.getWindows().filter(f=>f.isReady).length>0?(S.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(S.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),n.Event.once(I.onDidSignalReadyWindow)(this.i,this,this.d))}h(y){try{return k.URI.parse(y)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const y=[];for(const b of this.a)await this.f.open(b.uri,{originalUrl:b.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",b.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",b.originalUrl),y.push(b));y.length!==0&&(this.a=y,this.c=(0,A.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=g}),define(ie[255],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(ie[256],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,P.createDecorator)("webviewManagerService")}),define(ie[257],se([0,1,15,2,14,8]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class D extends A.Disposable{constructor(){super();const g=this.b.bind(this);P.protocol.registerFileProtocol(n.Schemas.vscodeWebview,g)}b(g,d){try{const y=R.URI.parse(g.url),b=D.a.get(y.path);if(typeof b=="string"){const I=`vs/workbench/contrib/webview/browser/pre/${b}`,u=n.FileAccess.asFileUri(I);return d({path:decodeURIComponent(u.fsPath),headers:{...n.COI.getHeadersFromQuery(g.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return d({error:-10})}catch{}return d({error:-2})}}D.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]]),e.WebviewProtocolProvider=D}),define(ie[77],se([0,1,4]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(y){return!!y.workspaceUri}e.isWorkspaceToOpen=A;function n(y){return!!y.folderUri}e.isFolderToOpen=n;function R(y){return!!y.fileUri}e.isFileToOpen=R;function D(y){const b=k(y),I=y.getValue("window.menuBarVisibility");return I==="default"||b==="native"&&I==="compact"||P.isMacintosh&&P.isNative?"classic":I}e.getMenuBarVisibility=D;function k(y){if(P.isWeb)return"custom";const b=y.getValue("window");if(b){if(P.isMacintosh&&b.nativeTabs===!0||P.isMacintosh&&b.nativeFullScreen===!1)return"native";const w=b.titleBarStyle;if(w==="native"||w==="custom")return w}return P.isLinux?"native":"custom"}e.getTitleBarStyle=k;function g(y){if(!P.isWindows||P.isWeb||k(y)==="native")return!1;const b=y.getValue("window.experimental.windowControlsOverlay.enabled");return typeof b=="boolean"?b:!0}e.useWindowControlsOverlay=g;function d(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=d}),define(ie[122],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var P;(function(k){k[k.INITIAL=1]="INITIAL",k[k.LOAD=2]="LOAD",k[k.RELOAD=3]="RELOAD"})(P=e.LoadReason||(e.LoadReason={}));var A;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(A=e.UnloadReason||(e.UnloadReason={}));const n=function(k=1){return{width:1024,height:768,mode:k}};e.defaultWindowState=n;var R;(function(k){k[k.Maximized=0]="Maximized",k[k.Normal=1]="Normal",k[k.Minimized=2]="Minimized",k[k.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var D;(function(k){k[k.UNRESPONSIVE=1]="UNRESPONSIVE",k[k.PROCESS_GONE=2]="PROCESS_GONE",k[k.LOAD=3]="LOAD"})(D=e.WindowError||(e.WindowError={}))}),define(ie[30],se([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,P.createDecorator)("windowsMainService");var A;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(A=e.OpenContext||(e.OpenContext={}))}),define(ie[258],se([0,1,15,22,3,60,2,31,75,109,5,21,30]),function(X,e,P,A,n,R,D,k,g,d,y,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var u;(function(S){S[S.Initial=1]="Initial",S[S.StoredCredentialsUsed=2]="StoredCredentialsUsed",S[S.LoginDialogShown=3]="LoginDialogShown"})(u||(u={}));let w=class extends D.Disposable{constructor(s,h,f,p,v){super(),this.g=s,this.h=h,this.i=f,this.j=p,this.k=v,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=u.Initial,this.f=void 0,this.l()}l(){const s=n.Event.fromNodeEventEmitter(P.app,"login",(h,f,p,v,C)=>({event:h,webContents:f,req:p,authInfo:v,callback:C}));this.B(s(this.m,this))}async m({event:s,authInfo:h,req:f,callback:p}){if(!h.isProxy)return;if(!this.b&&this.c===u.LoginDialogShown&&f.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}s.preventDefault();let v;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),v=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(h);try{v=await this.b}finally{this.b=void 0}}p(v?.username,v?.password)}async n(s){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const h=await this.p(s);if(h)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),h;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(s){this.g.trace("auth#doResolveProxyCredentials - enter",s);const h=String((0,R.hash)({scheme:s.scheme,host:s.host,port:s.port}));let f,p;try{const c=await this.i.getPassword(this.a,h);if(c){const i=JSON.parse(await this.j.decrypt(c));f=i.username,p=i.password}}catch(c){this.g.error(c)}if(this.c!==u.StoredCredentialsUsed&&typeof f=="string"&&typeof p=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=u.StoredCredentialsUsed,{username:f,password:p};const v=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!v){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${v.id} to handle proxy login`);const C={authInfo:s,username:this.f?.username??f,password:this.f?.password??p,replyChannel:`vscode:proxyAuthResponse:${(0,k.generateUuid)()}`};v.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,C),this.c=u.LoginDialogShown;const t=await new Promise(c=>{const i=async(o,r,l)=>{if(r===C.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${v.id}`),v.win?.webContents.off("ipc-message",i),l){const a={username:l.username,password:l.password};try{if(l.remember){const m=await this.j.encrypt(JSON.stringify(a));await this.i.setPassword(this.a,h,m)}else await this.i.deletePassword(this.a,h)}catch(m){this.g.error(m)}c({username:a.username,password:a.password})}else c(void 0)};v.win?.webContents.on("ipc-message",i)});return this.f=t,t}};w=ye([ee(0,y.ILogService),ee(1,I.IWindowsMainService),ee(2,g.ICredentialsMainService),ee(3,d.IEncryptionMainService),ee(4,b.IProductService)],w),e.ProxyAuthHandler=w}),define(ie[259],se([0,1,75,5,34,21,30,211]),function(X,e,P,A,n,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let g=class extends k.BaseCredentialsMainService{constructor(y,b,I,u){super(y),this.j=b,this.k=I,this.l=u,this.i=w=>{this.l.sendToFocused("vscode:showCredentialsError",w.message??w)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new P.InMemoryCredentialsProvider,this.f;const y=await new Promise((b,I)=>{X(["keytar"],b,I)});return await y.findCredentials("test-keytar-loads"),this.f=y,this.f}};g=ye([ee(0,A.ILogService),ee(1,n.INativeEnvironmentService),ee(2,R.IProductService),ee(3,D.IWindowsMainService)],g),e.CredentialsNativeMainService=g}),define(ie[260],se([0,1,15,26,4,8,23,19,62,6,5,121,30]),function(X,e,P,A,n,R,D,k,g,d,y,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,d.createDecorator)(e.ID);let u=class{constructor(S,s,h,f){this.a=S,this.b=s,this.c=h,this.d=f}async start(S,s){this.a.trace("Received data from other instance: ",S,s),n.isMacintosh&&P.app.focus({steal:!0});const h=this.e(S);if(h.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const p=(0,A.firstOrDefault)(await this.b.openEmptyWindow({context:4}));p&&(f=p.ready())}f.then(()=>{for(const{uri:p,originalUrl:v}of h)this.c.open(p,{originalUrl:v})})}else return this.f(S,s)}e(S){return S["open-url"]&&S._urls&&S._urls.length>0?(0,A.coalesce)(S._urls.map(s=>{try{return{uri:R.URI.parse(s),originalUrl:s}}catch{return null}})):[]}async f(S,s){const h=(0,g.isLaunchedFromCli)(s)?0:4;let f=[];const p=S.wait&&S.waitMarkerFilePath?R.URI.file(S.waitMarkerFilePath):void 0,v=S.remote||void 0,C={context:h,cli:S,userEnv:s,waitMarkerFileURI:p,remoteAuthority:v,forceProfile:S.profile,forceTempProfile:S["profile-temp"]};if(S.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(S.extensionDevelopmentPath,C);else if(!S._.length&&!S["folder-uri"]&&!S["file-uri"]){let t=!1;if(S["new-window"]||S["unity-launch"]||C.forceProfile||C.forceTempProfile)t=!0;else if(S["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!n.isMacintosh}if(t)f=await this.b.open({...C,forceNewWindow:!0,forceEmpty:!0});else{const c=this.b.getLastActiveWindow();c?(this.b.openExistingWindow(c,C),f=[c]):f=await this.b.open({...C,forceEmpty:!0})}}else f=await this.b.open({...C,forceNewWindow:S["new-window"],preferNewWindow:!S["reuse-window"]&&!S.wait,forceReuseWindow:S["reuse-window"],diffMode:S.diff,mergeMode:S.merge,addMode:S.add,noRecentEntry:!!S["skip-add-to-recently-opened"],gotoLineMode:S.goto});if(p&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,D.whenDeleted)(p.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};u=ye([ee(0,y.ILogService),ee(1,I.IWindowsMainService),ee(2,b.IURLService),ee(3,k.IConfigurationService)],u),e.LaunchMainService=u}),define(ie[94],se([0,1,15,2,3,5,261,7,14,30,73,24,20,71,37]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;let S=class It extends A.Disposable{constructor(f,p,v){super(),this.m=f,this.n=p,this.p=v,this.b=String(++It.a),this.c=this.B(new n.Emitter),this.onStdout=this.c.event,this.f=this.B(new n.Emitter),this.onStderr=this.f.event,this.g=this.B(new n.Emitter),this.onMessage=this.g.event,this.h=this.B(new n.Emitter),this.onExit=this.h.event,this.i=this.B(new n.Emitter),this.onCrash=this.i.event,this.j=void 0,this.k=void 0,this.l=void 0}r(f,p){let v;switch(this.l?.correlationId?v=`[UtilityProcess id: ${this.l?.correlationId}, type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${f}`:v=`[UtilityProcess type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${f}`,p){case y.default.Error:this.m.error(v);break;case y.default.Warning:this.m.warn(v);break;case y.default.Info:this.m.info(v);break}}s(){return this.j?(this.r("Cannot start utility process because it is already running...",y.default.Error),!1):!0}start(f){const p=this.t(f,!1);return p&&f.payload&&this.postMessage(f.payload),p}t(f,p){if(!this.s())return!1;this.l=f;const v=`${this.l.type}-${this.b}`,C=g.FileAccess.asFileUri("bootstrap-fork.js").fsPath,t=this.l.args??[],c=this.l.execArgv??[],i=this.l.allowLoadingUnsignedLibraries,o="pipe",r=this.u(f,p);return this.r("creating new...",y.default.Info),this.j=P.utilityProcess.fork(C,t,{serviceName:v,env:r,execArgv:c,allowLoadingUnsignedLibraries:i,stdio:o}),this.v(this.j,this.l,v,p),!0}u(f,p){const v=f.env?{...f.env}:{...(0,w.deepClone)(process.env)};v.VSCODE_AMD_ENTRYPOINT=f.entryPoint,typeof f.parentLifecycleBound=="number"&&(v.VSCODE_PARENT_PID=String(f.parentLifecycleBound)),p&&(v.VSCODE_CRASH_REPORTER_SANDBOXED_HINT="1"),v.VSCODE_CRASH_REPORTER_PROCESS_TYPE=f.type,(0,u.removeDangerousEnvVariables)(v);for(const C of Object.keys(v))v[C]=String(v[C]);return v}v(f,p,v,C){if(f.stdout){const t=new D.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(f.stdout,"data")(c=>this.c.fire(typeof c=="string"?c:t.write(c))))}if(f.stderr){const t=new D.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(f.stderr,"data")(c=>this.f.fire(typeof c=="string"?c:t.write(c))))}this.B(n.Event.fromNodeEventEmitter(f,"message")(t=>this.g.fire(t))),this.B(n.Event.fromNodeEventEmitter(f,"spawn")(()=>{this.k=f.pid,this.r("successfully created",y.default.Info)})),this.B(n.Event.fromNodeEventEmitter(f,"exit")(t=>{this.r(`received exit event with code ${t}`,y.default.Info),this.h.fire({pid:this.k,code:t,signal:"unknown"}),this.w()})),this.B(n.Event.fromNodeEventEmitter(P.app,"child-process-gone",(t,c)=>({event:t,details:c}))(({details:t})=>{t.type==="Utility"&&t.name===v&&(this.r(`crashed with code ${t.exitCode} and reason '${t.reason}'`,y.default.Error),this.n.publicLog2("utilityprocesscrash",{type:p.type,reason:t.reason,code:t.exitCode,sandboxed:C?"1":"0"}),this.i.fire({pid:this.k,code:t.exitCode,reason:t.reason}),this.w())}))}once(f,p){const v=this.B(this.g.event(C=>{C===f&&(v.dispose(),p())}))}postMessage(f,p){!this.j||this.j.postMessage(f,p)}connect(f){const{port1:p,port2:v}=new P.MessageChannelMain;return this.postMessage(f,[v]),p}enableInspectPort(){if(!this.j||typeof this.k!="number")return!1;this.r("enabling inspect port",y.default.Info);const f=process;return typeof f._debugProcess=="function"?(f._debugProcess(this.k),!0):!1}kill(){if(!this.j)return;this.r("attempting to kill the process...",y.default.Info),this.j.kill()?(this.r("successfully killed the process",y.default.Info),this.w()):this.r("unable to kill the process",y.default.Warning)}w(){this.j=void 0}async waitForExit(f){!this.j||(this.r("waiting to exit...",y.default.Info),await Promise.race([n.Event.toPromise(this.onExit),(0,k.timeout)(f)]),this.j&&(this.r(`did not exit within ${f}ms, will kill it now...`,y.default.Info),this.kill()))}};S.a=0,S=ye([ee(0,R.ILogService),ee(1,b.ITelemetryService),ee(2,I.ILifecycleMainService)],S),e.UtilityProcess=S;let s=class extends S{constructor(f,p,v,C){super(f,v,C),this.y=p}start(f){const p=this.y.getWindowById(f.responseWindowId);if(!p?.win||p.win.isDestroyed()||p.win.webContents.isDestroyed())return this.r("Refusing to start utility process because requesting window cannot be found or is destroyed...",y.default.Error),!0;if(!super.t(f,p.isSandboxed))return!1;this.z(p.win,f);const C=this.connect(f.payload);return p.win.webContents.postMessage(f.responseChannel,f.responseNonce,[C]),!0}z(f,p){p.windowLifecycleBound&&(this.B(n.Event.filter(this.p.onWillLoadWindow,v=>v.window.win===f)(()=>this.kill())),this.B(n.Event.fromNodeEventEmitter(f,"closed")(()=>this.kill())))}};s=ye([ee(0,R.ILogService),ee(1,d.IWindowsMainService),ee(2,b.ITelemetryService),ee(3,I.ILifecycleMainService)],s),e.WindowUtilityProcess=s}),define(ie[262],se([0,1,13,2,3,5,20,72,46,261,7,14,37,4,36,94,30,24]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let f=class Pt{constructor(C,t,c,i){this.d=C,this.f=t,this.g=c,this.h=i,this.c=!1,this.b=new Map,this.f.onWillShutdown(o=>{this.c=!0,o.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(C){const t=this.b.get(C);if(!t)throw new Error("Unknown extension host!");return t}onDynamicStdout(C){return this.i(C).onStdout}onDynamicStderr(C){return this.i(C).onStderr}onDynamicMessage(C){return this.i(C).onMessage}onDynamicError(C){const t=this.i(C);return t instanceof S.WindowUtilityProcess?n.Event.None:t.onError}onDynamicExit(C){return this.i(C).onExit}async createExtensionHost(C){if(this.c)throw(0,P.canceled)();const t=String(++Pt.a);let c;return C?c=new S.WindowUtilityProcess(this.d,this.g,this.h,this.f):c=new p(t,this.d),this.b.set(t,c),c.onExit(({pid:i,code:o,signal:r})=>{this.d.info(`Extension host with pid ${i} exited with code: ${o}, signal: ${r}.`),setTimeout(()=>{c.dispose(),this.b.delete(t)})}),{id:t}}async start(C,t){if(this.c)throw(0,P.canceled)();this.i(C).start({...t,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:t.execArgv,allowLoadingUnsignedLibraries:!0,correlationId:C})}async enableInspectPort(C){if(this.c)throw(0,P.canceled)();const t=this.b.get(C);return t?t.enableInspectPort():!1}async kill(C){if(this.c)throw(0,P.canceled)();const t=this.b.get(C);!t||t.kill()}async _killAllNow(){for(const[,C]of this.b)C.kill()}async _waitForAllExit(C){const t=[];for(const[,c]of this.b)t.push(c.waitForExit(C));return y.Promises.settled(t).then(()=>{})}};f.a=0,f=ye([ee(0,R.ILogService),ee(1,D.ILifecycleMainService),ee(2,s.IWindowsMainService),ee(3,h.ITelemetryService)],f),e.ExtensionHostStarter=f;let p=class extends A.Disposable{constructor(C,t){super(),this.id=C,this.c=t,this._onStdout=this.B(new n.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new n.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new n.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new n.Emitter),this.onError=this._onError.event,this._onExit=this.B(new n.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(C){u.isCI&&this.c.info("Calling fork to start extension host...");const t=k.StopWatch.create(!1);this.a=(0,g.fork)(b.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,I.mixin)({cwd:(0,w.cwd)()},C));const c=t.elapsed(),i=this.a.pid;this.c.info(`Starting extension host with pid ${i} (fork() took ${c} ms).`);const o=new d.StringDecoder("utf-8");this.a.stdout?.on("data",l=>{const a=typeof l=="string"?l:o.write(l);this._onStdout.fire(a)});const r=new d.StringDecoder("utf-8");this.a.stderr?.on("data",l=>{const a=typeof l=="string"?l:r.write(l);this._onStderr.fire(a)}),this.a.on("message",l=>{this._onMessage.fire(l)}),this.a.on("error",l=>{this._onError.fire({error:(0,P.transformErrorForSerialization)(l)})}),this.a.on("exit",(l,a)=>{this.b=!0,this._onExit.fire({pid:i,code:l,signal:a})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):u.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(C){if(!this.a)return;const t=this.a.pid;this.c.info(`Waiting for extension host with pid ${t} to exit.`),await Promise.race([n.Event.toPromise(this.onExit),(0,y.timeout)(C)]),this.b||(this.c.info(`Extension host with pid ${t} did not exit within ${C}ms.`),this.a.kill())}};p=ye([ee(1,R.ILogService)],p)}),define(ie[263],se([0,1,2,6,5,30,94,24,60,3,7,20]),function(X,e,P,A,n,R,D,k,g,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,A.createDecorator)("utilityProcessWorker");let I=class extends P.Disposable{constructor(S,s,h,f){super(),this.b=S,this.c=s,this.f=h,this.g=f,this.a=new Map}async createWorker(S){const s=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${s})`);const h=this.h(S);this.a.has(h)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${s})`),this.disposeWorker(S));const f=new u(this.b,this.c,this.f,this.g,S);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(h,f);const p=new y.DeferredPromise;return d.Event.once(f.onDidTerminate)(v=>{v.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${v.code}, signal: ${v.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${v.code}, signal: ${v.signal}`),this.a.delete(h),p.complete({reason:v})}),p.p}h(S){return(0,g.hash)({moduleId:S.process.moduleId,windowId:S.reply.windowId})}async disposeWorker(S){const s=this.h(S),h=this.a.get(s);!h||(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),h.kill(),this.a.delete(s))}};I=ye([ee(0,n.ILogService),ee(1,R.IWindowsMainService),ee(2,k.ITelemetryService),ee(3,b.ILifecycleMainService)],I),e.UtilityProcessWorkerMainService=I;let u=class extends P.Disposable{constructor(S,s,h,f,p){super(),this.c=S,this.f=s,this.g=h,this.h=f,this.i=p,this.a=this.B(new d.Emitter),this.onDidTerminate=this.a.event,this.b=new D.WindowUtilityProcess(this.c,this.f,this.g,this.h),this.j()}j(){this.B(this.b.onExit(S=>this.a.fire({code:S.code,signal:S.signal}))),this.B(this.b.onCrash(S=>this.a.fire({code:S.code,signal:"ECRASH"})))}spawn(){const s=this.f.getWindowById(this.i.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.i.process.type,entryPoint:this.i.process.moduleId,parentLifecycleBound:s,windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce})}kill(){this.b.kill()}};u=ye([ee(0,n.ILogService),ee(1,R.IWindowsMainService),ee(2,k.ITelemetryService),ee(3,b.ILifecycleMainService)],u)}),define(ie[264],se([0,1,15,3,2,257,30]),function(X,e,P,A,n,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let k=class extends n.Disposable{constructor(d){super(),this.b=d,this.a=this.B(new A.Emitter),this.onFoundInFrame=this.a.event,this.B(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(d,y){let b;if(typeof d.windowId=="number"){const{windowId:I}=d,u=this.b.getWindowById(I);if(!u?.win)throw new Error(`Invalid windowId: ${I}`);b=u.win.webContents}else{const{webContentsId:I}=d;if(b=P.webContents.fromId(I),!b)throw new Error(`Invalid webContentsId: ${I}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(y)}async findInFrame(d,y,b,I){const w=this.c(d,y);if(typeof w.findInFrame=="function"){w.findInFrame(b,{findNext:I.findNext,forward:I.forward});const S=(s,h)=>{h.finalUpdate&&(this.a.fire(h),w.removeListener("found-in-frame",S))};w.on("found-in-frame",S)}}async stopFindInFrame(d,y,b){const u=this.c(d,y);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}c(d,y){const b=this.b.getWindowById(d.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${d}`);const I=b.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===y);if(!I)throw new Error(`Unknown frame: ${y}`);return I}};k=ye([ee(0,D.IWindowsMainService)],k),e.WebviewMainService=k}),define(ie[265],se([0,1,7,3,2]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends n.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:g,getActiveWindowId:d}){super(),this.a=this.B(new n.DisposableStore),A.Event.latch(A.Event.any(k,g))(this.f,this,this.a),this.b=(0,P.createCancelablePromise)(()=>d()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=R}),define(ie[29],se([0,1,183,9,61,18,8,6,14]),function(X,e,P,A,n,R,D,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function d(o){const r=o;return typeof r?.id=="string"&&D.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=d;function y(o){return typeof o?.id=="string"&&!d(o)&&!I(o)}e.isEmptyWorkspaceIdentifier=y,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(o,r){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,A.basename)(o)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=o;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=b;function I(o){const r=o;return typeof r?.id=="string"&&D.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=I;function u(o){const r=o;if(r?.uri)return{id:r.id,uri:D.URI.revive(r.uri)};const l=o;if(l?.configPath)return{id:l.id,configPath:D.URI.revive(l.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=u;var w;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(w=e.WorkbenchState||(e.WorkbenchState={}));function S(o){const r=o;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=S;function s(o){const r=o;return!!(r&&typeof r=="object"&&D.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=s;class h{constructor(r,l,a,m,E){this.h=r,this.j=a,this.k=m,this.l=E,this.c=n.TernarySearchTree.forUris(this.l,()=>!0),this.folders=l}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=n.TernarySearchTree.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class f{constructor(r,l){this.raw=l,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,R.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function p(o){return new f({uri:o,index:0,name:(0,R.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(o,r){return R.extUriBiasedIgnorePathCase.isEqualOrParent(o,r.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function C(o){let r;return D.URI.isUri(o)?r=o:r=o.configuration,r?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=C,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(o){return o.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function c(o,r){return!v(o,r)&&!C(o)}e.isSavedWorkspace=c;function i(o){return(typeof o=="string"?(0,A.extname)(o):(0,R.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ie[57],se([0,1,15,7,60,45,2,80,4,10,23,160,88,6,5,21,29]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,u.createDecorator)("dialogMainService");let h=class{constructor(p,v){this.d=p,this.e=v,this.a=new Map,this.b=new Map,this.c=new A.Queue}pickFileFolder(p,v){return this.f({...p,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},v)}pickFolder(p,v){return this.f({...p,pickFolders:!0,title:(0,b.localize)(1,null)},v)}pickFile(p,v){return this.f({...p,pickFiles:!0,title:(0,b.localize)(2,null)},v)}pickWorkspace(p,v){const C=(0,b.localize)(3,null),t=(0,R.mnemonicButtonLabel)((0,b.localize)(4,null)),c=s.WORKSPACE_FILTER;return this.f({...p,pickFiles:!0,title:C,filters:c,buttonLabel:t},v)}async f(p,v){const C={title:p.title,buttonLabel:p.buttonLabel,filters:p.filters,defaultPath:p.defaultPath};(typeof p.pickFiles=="boolean"||typeof p.pickFolders=="boolean")&&(C.properties=void 0,p.pickFiles&&p.pickFolders&&(C.properties=["multiSelections","openDirectory","openFile","createDirectory"])),C.properties||(C.properties=["multiSelections",p.pickFolders?"openDirectory":"openFile","createDirectory"]),g.isMacintosh&&C.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(C,(0,d.withNullAsUndefined)(v||P.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(p){if(p){let v=this.b.get(p.id);return v||(v=new A.Queue,this.b.set(p.id,v)),v}else return this.c}showMessageBox(p,v){return this.g(v).queue(async()=>{const{options:C,buttonIndeces:t}=(0,I.massageMessageBoxOptions)(p,this.e);let c;return v?c=await P.dialog.showMessageBox(v,C):c=await P.dialog.showMessageBox(C),{response:t[c.response],checkboxChecked:c.checkboxChecked}})}async showSaveDialog(p,v){const C=this.j(p,v);if(!C)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(v).queue(async()=>{let t;return v?t=await P.dialog.showSaveDialog(v,p):t=await P.dialog.showSaveDialog(p),t.filePath=this.h(t.filePath),t})}finally{(0,D.dispose)(C)}}h(p){return p&&g.isMacintosh&&(p=(0,k.normalizeNFC)(p)),p}i(p){return p.map(v=>this.h(v))}async showOpenDialog(p,v){p.defaultPath&&(await y.Promises.exists(p.defaultPath)||(p.defaultPath=void 0));const C=this.j(p,v);if(!C)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(v).queue(async()=>{let t;return v?t=await P.dialog.showOpenDialog(v,p):t=await P.dialog.showOpenDialog(p),t.filePaths=this.i(t.filePaths),t})}finally{(0,D.dispose)(C)}}j(p,v){if(!v)return D.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",p);let C=this.a.get(v.id);C||(C=new Set,this.a.set(v.id,C));const t=(0,n.hash)(p);if(!C.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",p),C.add(t),(0,D.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",p),C?.delete(t),C?.size===0&&this.a.delete(v.id)})}};h=ye([ee(0,w.ILogService),ee(1,S.IProductService)],h),e.DialogMainService=h}),define(ie[266],se([0,1,3,2,83,29]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends A.Disposable{constructor(g,d){super(),this.f=g,this.g=d,this.b=this.B(new P.Emitter),this.c=new Map,this.h(d.applicationStorage,this.b)}h(g,d){this.B(P.Event.debounce(g.onDidChangeStorage,(y,b)=>(y?y.push(b):y=[b],y),D.a)(y=>{y.length&&d.fire(this.i(y,g))}))}i(g,d){const y=new Map,b=new Set;return g.forEach(I=>{const u=d.get(I.key);typeof u=="string"?y.set(I.key,u):b.add(I.key)}),{changed:Array.from(y.entries()),deleted:Array.from(b.values())}}listen(g,d,y){switch(d){case"onDidChangeStorage":{const b=y.profile?(0,n.revive)(y.profile):void 0;if(!b)return this.b.event;let I=this.c.get(b.id);return I||(I=this.B(new P.Emitter),this.h(this.g.profileStorage(b),I),this.c.set(b.id,I)),I.event}}throw new Error(`Event not found: ${d}`)}async call(g,d,y){const b=y.profile?(0,n.revive)(y.profile):void 0,I=(0,R.reviveIdentifier)(y.workspace),u=await this.j(b,I);switch(d){case"getItems":return Array.from(u.items.entries());case"updateItems":{const w=y;if(w.insert)for(const[S,s]of w.insert)u.set(S,s);w.delete?.forEach(S=>u.delete(S));break}case"isUsed":{const w=y.payload;if(typeof w=="string")return this.g.isUsed(w)}default:throw new Error(`Call not found: ${d}`)}}async j(g,d){let y;d?y=this.g.workspaceStorage(d):g?y=this.g.profileStorage(g):y=this.g.applicationStorage;try{await y.init()}catch(b){this.f.error(`StorageIPC#init: Unable to init ${d?"workspace":g?"profile":"application"} storage due to ${b}`)}return y}}D.a=100,e.StorageDatabaseChannel=D}),define(ie[40],se([0,1,60,3,2,18,8,180,34,16,6,5,29,35,39,7,31,25,10]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function p(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&D.URI.isUri(o.location)&&D.URI.isUri(o.globalStorageHome)&&D.URI.isUri(o.settingsResource)&&D.URI.isUri(o.keybindingsResource)&&D.URI.isUri(o.tasksResource)&&D.URI.isUri(o.snippetsHome)&&D.URI.isUri(o.extensionsResource))}e.isUserDataProfile=p,e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function v(i,o){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:D.URI.revive(i.location).with({scheme:o}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:o}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:o}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:o}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:o}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:o}),extensionsResource:D.URI.revive(i.extensionsResource)?.with({scheme:o}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=v;function C(i,o,r,l){return{id:i,name:o,location:r,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,R.joinPath)(r,"globalStorage"),settingsResource:(0,R.joinPath)(r,"settings.json"),keybindingsResource:(0,R.joinPath)(r,"keybindings.json"),tasksResource:(0,R.joinPath)(r,"tasks.json"),snippetsHome:(0,R.joinPath)(r,"snippets"),extensionsResource:(0,R.joinPath)(r,"extensions.json"),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=C;let t=class extends n.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(o,r,l,a){super(),this.m=o,this.n=r,this.r=l,this.s=a,this.f=!0,this.g=this.B(new A.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new A.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new A.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new A.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new u.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(o){this.f!==o&&(this.t=void 0,this.f=o)}isEnabled(){return this.f}get u(){if(!this.t){const o=[];if(this.f)try{for(const m of this.I()){if(!m.name||!(0,f.isString)(m.name)||!m.location){this.s.warn("Skipping the invalid stored profile",m.location||m.name);continue}o.push(C((0,R.basename)(m.location),m.name,m.location,{shortName:m.shortName,useDefaultFlags:m.useDefaultFlags}))}}catch(m){this.s.error(m)}const r=new u.ResourceMap,l=new Map,a=this.v();if(o.unshift({...a,extensionsResource:this.N()??a.extensionsResource,isDefault:!0}),o.length)try{const m=this.L();if(m.workspaces)for(const[E,M]of Object.entries(m.workspaces)){const T=D.URI.parse(E),N=o.find(z=>z.id===M);N&&r.set(T,N)}if(m.emptyWindows)for(const[E,M]of Object.entries(m.emptyWindows)){const T=o.find(N=>N.id===M);T&&l.set(E,T)}}catch(m){this.s.error(m)}this.t={profiles:o,workspaces:r,emptyWindows:l}}return this.t}v(){return C("__default__profile__",(0,k.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(o){const r="Temp",l=new RegExp(`${(0,h.escapeRegExpCharacters)(r)}\\s(\\d+)`);let a=0;for(const E of this.profiles){const M=l.exec(E.name),T=M?parseInt(M[1]):0;a=T>a?T:a}const m=`${r} ${a+1}`;return this.createProfile((0,P.hash)((0,s.generateUuid)()).toString(16),m,{transient:!0},o)}async createNamedProfile(o,r,l){return this.createProfile((0,P.hash)((0,s.generateUuid)()).toString(16),o,r,l)}async createProfile(o,r,l,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.w(o,r,l);return a&&await this.setProfileForWorkspace(a,m),m}async w(o,r,l){if(!(0,f.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(r);return a||(a=(async()=>{try{const m=this.profiles.find(T=>T.name===r||T.id===o);if(m)return m;const E=C(o,r,(0,R.joinPath)(this.profilesHome,o),l);await this.n.createFolder(E.location);const M=[];return this.h.fire({profile:E,join(T){M.push(T)}}),await S.Promises.settled(M),this.C([E],[],[]),E}finally{this.k.delete(r)}})(),this.k.set(r,a)),a}async updateProfile(o,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(a=>a.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);return l=C(l.id,r.name??l.name,l.location,{shortName:r.shortName??l.shortName,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags}),this.C([],[],[l]),l}async removeProfile(o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(o.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(a=>a.id===o.id);if(!r)throw new Error(`Profile '${o.name}' does not exist`);const l=[];this.i.fire({profile:r,join(a){l.push(a)}});try{await Promise.allSettled(l)}catch(a){this.s.error(a)}for(const a of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(a)?.id&&this.u.emptyWindows.delete(a);for(const a of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.G(),this.C([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(a){this.s.error(a)}}async setProfileForWorkspace(o,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(a=>a.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.F(o,l)}unsetWorkspace(o,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(o,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const o=await this.n.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.r.extUri.isEqual(l.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.l.profiles.filter(r=>!this.z(r));await Promise.allSettled(o.map(r=>this.removeProfile(r)))}getProfileForWorkspace(o){const r=this.y(o);return D.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}y(o){return(0,I.isSingleFolderWorkspaceIdentifier)(o)?o.uri:(0,I.isWorkspaceIdentifier)(o)?o.configPath:o.id}z(o){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,o.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,o.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,o.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,o.location)))}C(o,r,l){const a=[...this.profiles,...o],m=[];this.l.profiles=[];for(let E of a)E.isDefault||r.some(M=>E.id===M.id)||(E=l.find(M=>E.id===M.id)??E,E.isTransient?this.l.profiles.push(E):m.push({location:E.location,name:E.name,shortName:E.shortName,useDefaultFlags:E.useDefaultFlags}));this.J(m),this.t=void 0,this.D(o,r,l)}D(o,r,l){this.g.fire({added:o,removed:r,updated:l,all:this.profiles})}F(o,r,l){l=r?.isTransient?!0:l,l||this.F(o,void 0,!0);const a=this.y(o),m=l?this.l:this.u;D.URI.isUri(a)?(m.workspaces.delete(a),r&&m.workspaces.set(a,r)):(m.emptyWindows.delete(a),r&&m.emptyWindows.set(a,r)),l||this.G()}G(){const o={};for(const[l,a]of this.u.workspaces.entries())o[l.toString()]=a.id;const r={};for(const[l,a]of this.u.emptyWindows.entries())r[l.toString()]=a.id;this.M({workspaces:o,emptyWindows:r}),this.t=void 0}H(o){const r={},l=this.v();if(o.workspaces)for(const[m,E]of Object.entries(o.workspaces)){const M=D.URI.parse(E);r[m]=this.r.extUri.isEqual(M,l.location)?l.id:this.r.extUri.basename(M)}const a={};if(o.emptyWindows)for(const[m,E]of Object.entries(o.emptyWindows)){const M=D.URI.parse(E);a[m]=this.r.extUri.isEqual(M,l.location)?l.id:this.r.extUri.basename(M)}return{workspaces:r,emptyWindows:a}}I(){return[]}J(o){throw new Error("not implemented")}L(){return{}}M(o){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ye([ee(0,g.IEnvironmentService),ee(1,d.IFileService),ee(2,w.IUriIdentityService),ee(3,b.ILogService)],t),e.UserDataProfilesService=t;class c extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(o){this.a=o}L(){return this.Q}M(o){this.Q=o}}e.InMemoryUserDataProfilesService=c}),define(ie[78],se([0,1,7,17,2,3,35,8,110,117,16,6,5,40,39,10,13,24]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class p extends Error{constructor(i,o){super(i),this.code=o}}e.ExtensionsProfileScanningError=p,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let v=class extends n.Disposable{constructor(i,o,r,l,a,m){super(),this.i=i,this.j=o,this.k=r,this.l=l,this.m=a,this.n=m,this.b=this.B(new R.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new R.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new D.ResourceMap}scanProfileExtensions(i,o){return this.p(i,void 0,o)}async addExtensionsToProfile(i,o){const r=[],l=[];try{return await this.p(o,a=>{const m=[];for(const E of a)i.some(([M])=>(0,d.areSameExtensions)(M.identifier,E.identifier)&&M.manifest.version!==E.version)?r.push(E):m.push(E);for(const[E,M]of i)if(!m.some(T=>(0,d.areSameExtensions)(T.identifier,E.identifier)&&T.version===E.manifest.version)){const T={identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:M};l.push(T),m.push(T)}return l.length&&this.b.fire({extensions:l,profileLocation:o}),r.length&&this.f.fire({extensions:r,profileLocation:o}),m}),l.length&&this.c.fire({extensions:l,profileLocation:o}),r.length&&this.g.fire({extensions:r,profileLocation:o}),l}catch(a){throw l.length&&this.c.fire({extensions:l,error:a,profileLocation:o}),r.length&&this.g.fire({extensions:r,error:a,profileLocation:o}),a}}async updateMetadata(i,o){const r=[];return await this.p(o,l=>{const a=[];for(const m of l){const E=i.find(([M])=>(0,d.areSameExtensions)(M.identifier,m.identifier)&&M.manifest.version===m.version);E&&(m.metadata={...m.metadata,...E[1]},r.push(m)),a.push(m)}return a}),r}async removeExtensionFromProfile(i,o){const r=[];this.f.fire({extensions:r,profileLocation:o});try{await this.p(o,l=>{const a=[];for(const m of l)(0,d.areSameExtensions)(m.identifier,i.identifier)?r.push(m):a.push(m);return r.length&&this.f.fire({extensions:r,profileLocation:o}),a}),r.length&&this.g.fire({extensions:r,profileLocation:o})}catch(l){throw r.length&&this.g.fire({extensions:r,error:l,profileLocation:o}),l}}async p(i,o,r){return this.w(i).queue(async()=>{let l=[],a;try{const m=await this.j.readFile(i);a=JSON.parse(m.value.toString().trim()||"[]")}catch(m){if((0,y.toFileOperationResult)(m)!==1)throw m;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(a=await this.v()),!a&&r?.bailOutWhenFileNotFound)throw new p((0,s.getErrorMessage)(m),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.r(i);let m=!1;for(const E of a){C(E)||this.r(i);let M;if((0,S.isString)(E.relativeLocation)&&E.relativeLocation)M=this.t(E.relativeLocation);else if((0,S.isString)(E.location))M=this.t(E.location),m=!0,E.relativeLocation=E.location,E.location=M.toJSON();else{M=k.URI.revive(E.location);const T=this.s(M);T&&(m=!0,E.relativeLocation=T)}l.push({identifier:E.identifier,location:M,version:E.version,metadata:E.metadata})}m&&await this.j.writeFile(i,A.VSBuffer.fromString(JSON.stringify(a)))}if(o){l=o(l);const m=l.map(E=>({identifier:E.identifier,version:E.version,location:E.location.toJSON(),relativeLocation:this.s(E.location),metadata:E.metadata}));await this.j.writeFile(i,A.VSBuffer.fromString(JSON.stringify(m)))}return l})}r(i){const o=new p(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:o.code}),o}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),o=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let r;try{r=(await this.j.readFile(i)).value.toString()}catch(a){if((0,y.toFileOperationResult)(a)===1)return;throw a}this.n.info("Migrating extensions from old default profile location",i.toString());let l;try{const a=JSON.parse(r);Array.isArray(a)&&a.every(m=>C(m))?l=a:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.n.error(a)}if(l)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify(l)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(a){if((0,y.toFileOperationResult)(a)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw a}try{await this.j.del(i)}catch(a){(0,y.toFileOperationResult)(a)!==1&&this.n.error(a)}try{await this.j.del(o)}catch(a){(0,y.toFileOperationResult)(a)!==1&&this.n.error(a)}return l})()),this.u}w(i){let o=this.h.get(i);return o||(o=new P.Queue,this.h.set(i,o)),o}};v=ye([ee(1,y.IFileService),ee(2,u.IUserDataProfilesService),ee(3,w.IUriIdentityService),ee(4,h.ITelemetryService),ee(5,I.ILogService)],v),e.AbstractExtensionsProfileScannerService=v;function C(c){return(0,S.isObject)(c)&&(0,g.isIExtensionIdentifier)(c.identifier)&&(t(c.location)||(0,S.isString)(c.location)&&c.location)&&((0,S.isUndefined)(c.relativeLocation)||(0,S.isString)(c.relativeLocation))&&c.version&&(0,S.isString)(c.version)}function t(c){return c?(0,S.isString)(c.path)&&(0,S.isString)(c.scheme):!1}}),define(ie[123],se([0,1,26,7,37,17,13,43,145,2,14,9,4,18,197,73,10,8,165,34,117,114,196,16,6,5,21,3,83,78,40,39,195]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p,v,C,t,c,i,o,r,l,a,m,E,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var N;(function($){function V(x,H){if(x===H)return!0;const O=Object.keys(x),G=new Set;for(const _ of Object.keys(H))G.add(_);if(O.length!==G.size)return!1;for(const _ of O){if(x[_]!==H[_])return!1;G.delete(_)}return G.size===0}$.equals=V})(N=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let z=class extends d.Disposable{constructor(V,x,H,O,G,_,re,oe,L,W,U,j){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=x,this.l=H,this.m=O,this.n=G,this.p=_,this.r=re,this.s=oe,this.t=L,this.u=W,this.v=U,this.w=j,this.g=this.B(new l.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,u.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(le,(0,u.joinPath)(this.m,C.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(le,(0,u.joinPath)(this.m,C.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ae,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,v.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(V,x,H){const[O,G]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(x)]),_=H?await this.scanExtensionsUnderDevelopment(V,[...O,...G]):[];return this.F(O,G,_,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const x=[];x.push(this.G(!!V.useCache,V.language)),x.push(this.H(V.language,!!V.checkControlFile));const[H,O]=await Promise.all(x);return this.D([...H,...O],0,V,!1)}async scanUserExtensions(V){const x=V.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",x);const H=this.v.extUri.isEqual(V.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,O=await this.J(x,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,H),G=V.useCache&&!O.devMode&&O.excludeObsolete?this.j:this.k;let _;try{_=await G.scanExtensions(O)}catch(re){if(re instanceof m.ExtensionsProfileScanningError&&re.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),_=await G.scanExtensions(O);else throw re}return _=await this.D(_,1,V,!0),this.s.trace("Scanned user extensions:",_.length),_}async scanExtensionsUnderDevelopment(V,x){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const H=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(O=>O.scheme===y.Schemas.file).map(async O=>{const G=await this.J(O,!1,1,!0,V.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(G)).map(re=>(re.type=x.find(oe=>(0,v.areSameExtensions)(oe.identifier,re.identifier))?.type??re.type,this.k.validate(re,G)))}))).flat();return this.D(H,"development",V,!0)}return[]}async scanExistingExtension(V,x,H){const O=await this.J(V,!1,x,!0,H.language,!0,void 0),G=await this.k.scanExtension(O);return!G||!H.includeInvalid&&!G.isValid?null:G}async scanOneOrMultipleExtensions(V,x,H){const O=await this.J(V,!1,x,!0,H.language,!0,void 0),G=await this.k.scanOneOrMultipleExtensions(O);return this.D(G,x,H,!0)}async scanMetadata(V){const x=(0,u.joinPath)(V,"package.json"),H=(await this.r.readFile(x)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(V,x){const H=(0,u.joinPath)(V,"package.json"),O=(await this.r.readFile(H)).value.toString(),G=JSON.parse(O);x.isMachineScoped=x.isMachineScoped||void 0,x.isBuiltin=x.isBuiltin||void 0,G.__metadata={...G.__metadata,...x},await this.r.writeFile((0,u.joinPath)(V,"package.json"),R.VSBuffer.fromString(JSON.stringify(G,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof m.ExtensionsProfileScanningError&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw V}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.p.addExtensionsToProfile(V.map(x=>[x,x.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify([])))}catch(x){(0,c.toFileOperationResult)(x)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(x))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.s.error(V)}finally{this.z=void 0}})()),this.z}async D(V,x,H,O){return H.includeAllVersions||(V=this.F(x===0?V:void 0,x===1?V:void 0,x==="development"?V:void 0,await this.getTargetPlatform(),O)),H.includeInvalid||(V=V.filter(G=>G.isValid)),V.sort((G,_)=>{const re=b.basename(G.location.fsPath),oe=b.basename(_.location.fsPath);return re<oe?-1:re>oe?1:0})}F(V,x,H,O,G){const _=(oe,L,W)=>{if(oe.isValid&&!L.isValid)return!1;if(oe.isValid===L.isValid){if(G&&w.gt(oe.manifest.version,L.manifest.version))return this.s.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if(w.eq(oe.manifest.version,L.manifest.version)){if(oe.type===0)return this.s.debug(`Skipping extension ${L.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===O)return this.s.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return W?this.s.warn(`Overwriting user extension ${oe.location.path} with ${L.location.path}.`):this.s.debug(`Overwriting user extension ${oe.location.path} with ${L.location.path}.`),!0},re=new C.ExtensionIdentifierMap;return V?.forEach(oe=>{const L=re.get(oe.identifier.id);(!L||_(L,oe,!1))&&re.set(oe.identifier.id,oe)}),x?.forEach(oe=>{const L=re.get(oe.identifier.id);if(!L&&V&&oe.type===0){this.s.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!L||_(L,oe,!1))&&re.set(oe.identifier.id,oe)}),H?.forEach(oe=>{const L=re.get(oe.identifier.id);(!L||_(L,oe,!0))&&re.set(oe.identifier.id,oe),re.set(oe.identifier.id,oe)}),[...re.values()]}async G(V,x){this.s.trace("Started scanning system extensions");const H=await this.J(this.systemExtensionsLocation,!1,0,!0,x,!0,void 0),G=await(V&&!H.devMode?this.i:this.k).scanExtensions(H);return this.s.trace("Scanned system extensions:",G.length),G}async H(V,x){const H=this.t.isBuilt?[]:this.u.builtInExtensions;if(!H?.length)return[];this.s.trace("Started scanning dev system extensions");const O=x?await this.I():{},G=[],_=h.URI.file(b.normalize(b.join(y.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of H){const L=O[oe.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":G.push((0,u.joinPath)(_,oe.name));break;default:G.push(h.URI.file(L));break}}const re=await Promise.all(G.map(async oe=>this.k.scanExtension(await this.J(oe,!1,0,!0,V,!0,void 0))));return this.s.trace("Scanned dev system extensions:",re.length),(0,P.coalesce)(re)}async I(){try{const V=await this.r.readFile(this.l);return JSON.parse(V.value.toString())}catch{return{}}}async J(V,x,H,O,G,_,re){const oe=await this.f(G??I.language),L=await this.L(V),W=x&&!this.v.extUri.isEqual(V,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,U=W?await this.L(W):void 0;return new K(V,L,W,U,x,re,H,O,_,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,G,oe)}async L(V){try{const x=await this.r.stat(V);if(typeof x.mtime=="number")return x.mtime}catch{}}};z=ye([ee(4,E.IUserDataProfilesService),ee(5,m.IExtensionsProfileScannerService),ee(6,c.IFileService),ee(7,o.ILogService),ee(8,p.IEnvironmentService),ee(9,r.IProductService),ee(10,M.IUriIdentityService),ee(11,i.IInstantiationService)],z),e.AbstractExtensionsScannerService=z;class K{constructor(V,x,H,O,G,_,re,oe,L,W,U,j,q,J,B){this.location=V,this.mtime=x,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=O,this.profile=G,this.profileScanOptions=_,this.type=re,this.excludeObsolete=oe,this.validate=L,this.productVersion=W,this.productDate=U,this.productCommit=j,this.devMode=q,this.language=J,this.translations=B}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,x){return(0,u.isEqual)(V.location,x.location)&&V.mtime===x.mtime&&(0,u.isEqual)(V.applicationExtensionslocation,x.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===x.applicationExtensionslocationMtime&&V.profile===x.profile&&n.equals(V.profileScanOptions,x.profileScanOptions)&&V.type===x.type&&V.excludeObsolete===x.excludeObsolete&&V.validate===x.validate&&V.productVersion===x.productVersion&&V.productDate===x.productDate&&V.productCommit===x.productCommit&&V.devMode===x.devMode&&V.language===x.language&&N.equals(V.translations,x.translations)}}e.ExtensionScannerInput=K;let ae=class extends d.Disposable{constructor(V,x,H,O,G){super(),this.f=V,this.g=x,this.h=H,this.i=O,this.j=G}async scanExtensions(V){const x=V.profile?await this.l(V):await this.k(V);let H={};if(V.excludeObsolete&&V.type===1)try{const O=(await this.i.readFile(this.f)).value.toString();H=JSON.parse(O)}catch{}return(0,s.isEmptyObject)(H)?x:x.filter(O=>!H[v.ExtensionKey.create(O).toString()])}async k(V){const x=await this.i.resolve(V.location);if(!x.children?.length)return[];const H=await Promise.all(x.children.map(async O=>{if(!O.isDirectory||V.type===1&&(0,u.basename)(O.resource).indexOf(".")===0)return null;const G=new K(O.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(G)}));return(0,P.coalesce)(H).sort((O,G)=>O.location.path<G.location.path?-1:1)}async l(V){let x=await this.m(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){x=x.filter(O=>!O.metadata?.isApplicationScoped);const H=await this.m(V.applicationExtensionslocation,O=>!!O.metadata?.isApplicationScoped,V);x.push(...H)}return x}async m(V,x,H){const O=await this.g.scanProfileExtensions(V,H.profileScanOptions);if(!O.length)return[];const G=await Promise.all(O.map(async _=>{if(x(_)){const re=new K(_.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(re,_.metadata)}return null}));return(0,P.coalesce)(G)}async scanOneOrMultipleExtensions(V){try{if(await this.i.exists((0,u.joinPath)(V.location,"package.json"))){const x=await this.scanExtension(V);return x?[x]:[]}else return await this.scanExtensions(V)}catch(x){return this.j.error(`Error scanning extensions at ${V.location.path}:`,(0,D.getErrorMessage)(x)),[]}}async scanExtension(V,x){try{let H=await this.scanExtensionManifest(V.location);if(H){H.publisher||(H.publisher=C.UNDEFINED_PUBLISHER),x=x??H.__metadata,delete H.__metadata;const O=(0,v.getGalleryExtensionId)(H.publisher,H.name),G=x?.id?{id:O,uuid:x.id}:{id:O},_=x?.isSystem?0:V.type,re=_===0||!!x?.isBuiltin;H=await this.n(V.location,H,K.createNlsConfiguration(V));const oe={type:_,identifier:G,manifest:H,location:V.location,isBuiltin:re,targetPlatform:x?.targetPlatform??"undefined",metadata:x,isValid:!0,validations:[]};return V.validate?this.validate(oe,V):oe}}catch(H){V.type!==0&&this.j.error(H)}return null}validate(V,x){let H=!0;const O=(0,t.validateExtensionManifest)(x.productVersion,x.productDate,x.location,V.manifest,V.isBuiltin);for(const[G,_]of O)G===S.default.Error&&(H=!1,this.j.error(this.t(x.location,_)));return V.isValid=H,V.validations=O,V}async scanExtensionManifest(V){const x=(0,u.joinPath)(V,"package.json");let H;try{H=(await this.i.readFile(x)).value.toString()}catch(G){return(0,c.toFileOperationResult)(G)!==1&&this.j.error(this.t(V,(0,f.localize)(0,null,x.path,G.message))),null}let O;try{O=JSON.parse(H)}catch{const _=[];(0,k.parse)(H,_);for(const re of _)this.j.error(this.t(V,(0,f.localize)(1,null,x.path,re.offset,re.length,(0,g.getParseErrorMessage)(re.error))));return null}return(0,k.getNodeType)(O)!=="object"?(this.j.error(this.t(V,(0,f.localize)(2,null,x.path))),null):O}async n(V,x,H){const O=await this.p(V,x,H);if(O)try{const G=[],_=await this.r(O.default,G);if(G.length>0)return G.forEach(oe=>{this.j.error(this.t(V,(0,f.localize)(3,null,O.default?.path,(0,g.getParseErrorMessage)(oe.error))))}),x;if((0,k.getNodeType)(O)!=="object")return this.j.error(this.t(V,(0,f.localize)(4,null,O.default?.path))),x;const re=O.values||Object.create(null);return(0,T.localizeManifest)(x,re,_)}catch{}return x}async p(V,x,H){const O=(0,u.joinPath)(V,"package.nls.json"),G=(L,W)=>{W.forEach(U=>{this.j.error(this.t(V,(0,f.localize)(5,null,L?.path,(0,g.getParseErrorMessage)(U.error))))})},_=L=>{this.j.error(this.t(V,(0,f.localize)(6,null,L?.path)))},re=`${x.publisher}.${x.name}`,oe=H.translations[re];if(oe)try{const L=h.URI.file(oe),W=(await this.i.readFile(L)).value.toString(),U=[],j=(0,k.parse)(W,U);return U.length>0?(G(L,U),{values:void 0,default:O}):(0,k.getNodeType)(j)!=="object"?(_(L),{values:void 0,default:O}):{values:j.contents?j.contents.package:void 0,default:O}}catch{return{values:void 0,default:O}}else{if(!await this.i.exists(O))return;let W;try{W=await this.s(V,H)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const U=(await this.i.readFile(W.localized)).value.toString(),j=[],q=(0,k.parse)(U,j);return j.length>0?(G(W.localized,j),{values:void 0,default:W.original}):(0,k.getNodeType)(q)!=="object"?(_(W.localized),{values:void 0,default:W.original}):{values:q,default:W.original}}catch{return{values:void 0,default:W.original}}}}async r(V,x){if(V)try{const H=(await this.i.readFile(V)).value.toString();return(0,k.parse)(H,x)}catch{}}s(V,x){return new Promise((H,O)=>{const G=_=>{const re=(0,u.joinPath)(V,`package.nls.${_}.json`);this.i.exists(re).then(oe=>{oe&&H({localized:re,original:(0,u.joinPath)(V,"package.nls.json")});const L=_.lastIndexOf("-");L===-1?H({localized:(0,u.joinPath)(V,"package.nls.json"),original:null}):(_=_.substring(0,L),G(_))})};if(x.devMode||x.pseudo||!x.language)return H({localized:(0,u.joinPath)(V,"package.nls.json"),original:null});G(x.language)})}t(V,x){return`[${V.path}]: ${x}`}};ae=ye([ee(1,m.IExtensionsProfileScannerService),ee(2,M.IUriIdentityService),ee(3,c.IFileService),ee(4,o.ILogService)],ae);let le=class extends ae{constructor(V,x,H,O,G,_){super(x,H,O,G,_),this.y=V,this.v=this.B(new A.ThrottledDelayer(3e3)),this.w=this.B(new l.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(V){const x=await this.z();if(this.u=V,x&&x.input&&K.equals(x.input,this.u))return this.j.debug("Using cached extensions scan result",V.location.toString()),this.v.trigger(()=>this.D()),x.result.map(O=>(O.location=h.URI.revive(O.location),O));const H=await super.scanExtensions(V);return await this.C({input:V,result:H}),H}async z(){try{const V=await this.i.readFile(this.y),x=JSON.parse(V.value.toString());return{result:x.result,input:(0,a.revive)(x.input)}}catch(V){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,D.getErrorMessage)(V))}return null}async C(V){try{await this.i.writeFile(this.y,R.VSBuffer.fromString(JSON.stringify(V)))}catch(x){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,D.getErrorMessage)(x))}}async D(){if(!this.u)return;const V=await this.z();if(!V)return;const x=V.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!n.equals(H,x))try{await this.i.del(this.y),this.w.fire()}catch(O){this.j.error(O)}}};le=ye([ee(2,m.IExtensionsProfileScannerService),ee(3,M.IUriIdentityService),ee(4,c.IFileService),ee(5,o.ILogService)],le);function te($,V){const x=(0,v.getExtensionId)($.manifest.publisher,$.manifest.name);return{id:x,identifier:new C.ExtensionIdentifier(x),isBuiltin:$.type===0,isUserBuiltin:$.type===1&&$.isBuiltin,isUnderDevelopment:V,extensionLocation:$.location,uuid:$.identifier.uuid,targetPlatform:$.targetPlatform,...$.manifest}}e.toExtensionDescription=te;class F extends z{constructor(V,x,H,O,G,_,re,oe,L,W,U,j){super(V,x,(0,u.joinPath)(H,".vscode-oss-dev","extensions","control.json"),(0,u.joinPath)(O,C.MANIFEST_CACHE_FOLDER),G,_,re,oe,L,W,U,j),this.M=(async()=>{if(I.translationsConfigFile)try{const q=await this.r.readFile(h.URI.file(I.translationsConfigFile));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}f(V){return this.M}}e.NativeExtensionsScannerService=F}),define(ie[267],se([0,1,5,40,39,24,78,16,34,8]),function(X,e,P,A,n,R,D,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let y=class extends D.AbstractExtensionsProfileScannerService{constructor(I,u,w,S,s,h){super(d.URI.file(I.extensionsPath),u,w,S,s,h)}};y=ye([ee(0,g.INativeEnvironmentService),ee(1,k.IFileService),ee(2,A.IUserDataProfilesService),ee(3,n.IUriIdentityService),ee(4,R.ITelemetryService),ee(5,P.ILogService)],y),e.ExtensionsProfileScannerService=y}),define(ie[268],se([0,1,8,34,78,123,16,6,5,21,39,40]),function(X,e,P,A,n,R,D,k,g,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let I=class extends R.NativeExtensionsScannerService{constructor(w,S,s,h,f,p,v,C){super(P.URI.file(f.builtinExtensionsPath),P.URI.file(f.extensionsPath),f.userHome,P.URI.file(f.userDataPath),w,S,s,h,f,p,v,C)}};I=ye([ee(0,b.IUserDataProfilesService),ee(1,n.IExtensionsProfileScannerService),ee(2,D.IFileService),ee(3,g.ILogService),ee(4,A.INativeEnvironmentService),ee(5,d.IProductService),ee(6,y.IUriIdentityService),ee(7,k.IInstantiationService)],I),e.ExtensionsScannerService=I}),define(ie[269],se([0,1,15,2,14,9,4,61,8,31,42,34,5,40]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let w=class extends A.Disposable{constructor(s,h,f){super(),this.c=s,this.f=f,this.a=k.TernarySearchTree.forPaths(!D.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(s.appRoot),this.addValidFileRoot(s.extensionsPath),this.addValidFileRoot(h.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(s.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:s}=P.session;s.protocol.registerFileProtocol(n.Schemas.vscodeFileResource,(h,f)=>this.i(h,f)),s.protocol.interceptFileProtocol(n.Schemas.file,(h,f)=>this.h(h,f)),this.B((0,A.toDisposable)(()=>{s.protocol.unregisterProtocol(n.Schemas.vscodeFileResource),s.protocol.uninterceptProtocol(n.Schemas.file)}))}addValidFileRoot(s){const h=(0,R.normalize)(s);return this.a.get(h)?A.Disposable.None:(this.a.set(h,!0),(0,A.toDisposable)(()=>this.a.delete(h)))}h(s,h){const f=g.URI.parse(s.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${n.Schemas.file}: protocol (original URL: ${s.url})`),h({error:-3})}i(s,h){const f=this.j(s);let p;return this.c.crossOriginIsolated&&((0,R.basename)(f)==="workbench.html"||(0,R.basename)(f)==="workbench-dev.html"?p=n.COI.CoopAndCoep:p=n.COI.getHeadersFromQuery(s.url)),this.a.findSubstr(f)?h({path:f,headers:p}):this.b.has((0,R.extname)(f).toLowerCase())?h({path:f}):(this.f.error(`${n.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${n.Schemas.vscodeFileResource}: protocol (original URL: ${s.url})`),h({error:-3}))}j(s){const h=g.URI.parse(s.url),f=n.FileAccess.uriToFileUri(h);return(0,R.normalize)(f.fsPath)}createIPCObjectUrl(){let s;const h=g.URI.from({scheme:"vscode",path:(0,d.generateUuid)()}),f=h.toString(),p=async()=>s;return y.validatedIpcMain.handle(f,p),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:h,update:v=>s=v,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),y.validatedIpcMain.removeHandler(f)}}}};w=ye([ee(0,b.INativeEnvironmentService),ee(1,u.IUserDataProfilesService),ee(2,I.ILogService)],w),e.ProtocolMainService=w}),define(ie[270],se([0,1,15,42,7,3,2,14,10,105,28,20,5,66,67,69,44,40,38,65,94,19,48,108]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p,v,C,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let i=class extends D.Disposable{constructor(r,l,a,m,E,M,T,N,z,K,ae){super(),this.i=r,this.j=l,this.k=a,this.l=m,this.m=E,this.n=M,this.r=T,this.s=N,this.t=z,this.u=K,this.v=ae,this.a=this.B(new R.Emitter),this.onDidError=R.Event.buffer(this.a.event),this.b=new n.Barrier,this.c=void 0,this.f=void 0,this.g=void 0,this.h=(()=>{let le=!1;const te=this.v.getValue("window.experimental.sharedProcessUseUtilityProcess");return typeof te=="boolean"?le=te:le=typeof u.default.quality=="string"&&u.default.quality!=="stable",le})(),this.F=void 0,this.G=void 0,this.w(),this.h&&this.n.info("[SharedProcess] using utility process")}w(){A.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(r,l)=>this.y(r,l)),A.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(r,l)=>this.z(r,l)),this.B(this.m.onWillShutdown(()=>this.C()))}async y(r,l){this.n.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.b.isOpen()||this.b.open(),await this.whenReady();const a=await this.connect();if(r.sender.isDestroyed())return a.close();r.sender.postMessage("vscode:createSharedProcessMessageChannelResult",l,[a])}z(r,l){this.n.trace("[SharedProcess] onWorkerConnection",l);const a=new D.DisposableStore,m=M=>{!this.O()||(this.n.trace(`[SharedProcess] disposing worker (reason: '${M}')`,l),a.dispose(),this.D("vscode:electron-main->shared-process=disposeWorker",l))},E=P.BrowserWindow.fromId(l.reply.windowId);if(!E||E.isDestroyed()||E.webContents.isDestroyed()||!l.reply.channel){m("unavailable");return}a.add(R.Event.filter(this.m.onWillLoadWindow,M=>M.window.win===E)(()=>m("load"))),a.add(R.Event.fromNodeEventEmitter(E,"closed")(()=>m("closed"))),E.webContents.postMessage(l.reply.channel,l.reply.nonce,r.ports)}C(){if(this.n.trace("[SharedProcess] onWillShutdown"),this.g)this.g.postMessage("vscode:electron-main->shared-process=exit"),this.g=void 0;else{const r=this.c;if(!r)return;this.D("vscode:electron-main->shared-process=exit"),this.f&&(r.removeListener("close",this.f),this.f=void 0),setTimeout(()=>{try{this.n.trace("[SharedProcess] onWillShutdown window.close()"),r.close()}catch(l){this.n.trace(`[SharedProcess] onWillShutdown window.close() error: ${l}`)}this.c=void 0},0)}}D(r,...l){if(!this.O()){this.n.warn(`Sending IPC message to channel '${r}' for shared process that is destroyed`);return}try{this.c?.webContents.send(r,...l)}catch(a){this.n.warn(`Error sending IPC message to channel '${r}' of shared process: ${(0,s.toErrorMessage)(a)}`)}}whenReady(){return this.F||(this.F=(async()=>{await this.H;const r=new n.DeferredPromise;this.g?this.g.once("vscode:shared-process->electron-main=init-done",()=>r.complete()):A.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>r.complete()),await r.p,this.n.trace("[SharedProcess] Overall ready")})()),this.F}get H(){return this.G||(this.G=(async()=>{await this.b.wait(),this.I();const r=new n.DeferredPromise;this.g?this.g.once("vscode:shared-process->electron-main=ipc-ready",()=>r.complete()):A.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>r.complete()),await r.p,this.n.trace("[SharedProcess] IPC ready")})()),this.G}I(){this.h?this.J():this.L(),this.N()}J(){this.g=this.B(new v.UtilityProcess(this.n,t.NullTelemetryService,this.m));const r=(0,c.parseSharedProcessDebugPort)(this.k.args,this.k.isBuilt);let l;r.port&&(l=["--nolazy"],r.break?l.push(`--inspect-brk=${r.port}`):l.push(`--inspect=${r.port}`)),this.g.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.M(),execArgv:l})}L(){const r=this.B(this.u.createIPCObjectUrl());this.c=new P.BrowserWindow({show:!1,backgroundColor:this.t.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.k.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),r.update(this.M()),this.c.loadURL(k.FileAccess.asBrowserUri(`vs/code/node/sharedProcess/sharedProcess${this.k.isBuilt?"":"-dev"}.html`).toString(!0))}M(){return{machineId:this.i,windowId:this.c?.id??-1,appRoot:this.k.appRoot,codeCachePath:this.k.codeCachePath,profiles:{home:this.l.profilesHome,all:this.l.profiles},userEnv:this.j,args:this.k.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),product:u.default,policiesData:this.s.serialize()}}N(){this.c?(this.f=r=>{this.n.trace("SharedProcess#close prevented"),r.preventDefault(),this.c?.isVisible()&&this.c.hide()},this.c.on("close",this.f),this.c.webContents.on("render-process-gone",(r,l)=>this.a.fire({type:2,details:l})),this.c.on("unresponsive",()=>this.a.fire({type:1})),this.c.webContents.on("did-fail-load",(r,l,a)=>this.a.fire({type:3,details:{reason:a,exitCode:l}}))):this.g&&this.B(this.g.onCrash(r=>this.a.fire({type:2,details:{reason:r.reason,exitCode:r.code}})))}async connect(){return await this.H,this.g?this.g.connect():(0,d.connect)((0,g.assertIsDefined)(this.c))}async toggle(){await this.H,this.c&&(this.c.isVisible()?(this.c.webContents.closeDevTools(),this.c.hide()):(this.c.show(),this.c.webContents.openDevTools()))}isVisible(){return this.c?.isVisible()??!1}usingUtilityProcess(){return!!this.g}O(){const r=this.c;return r?!r.isDestroyed()&&!r.webContents.isDestroyed():!1}};i=ye([ee(2,y.IEnvironmentMainService),ee(3,h.IUserDataProfilesService),ee(4,b.ILifecycleMainService),ee(5,I.ILogService),ee(6,p.ILoggerMainService),ee(7,f.IPolicyService),ee(8,S.IThemeMainService),ee(9,w.IProtocolMainService),ee(10,C.IConfigurationService)],i),e.SharedProcess=i}),define(ie[95],se([0,1,7,3,2,64,10,106,6,40]),function(X,e,P,A,n,R,D,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var y;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var I;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));function u(f){const p=f.get(e.TARGET_KEY);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}e.loadKeyTargets=u;class w extends n.Disposable{constructor(p={flushInterval:w.a}){super(),this.j=p,this.b=this.B(new A.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new A.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new P.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new n.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,P.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,n.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.J()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(p,v){if(v===e.TARGET_KEY){switch(p){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:v,target:this.F(p)[v]})}r(p){this.f.fire({reason:p})}get(p,v,C){return this.L(v)?.get(p,C)}getBoolean(p,v,C){return this.L(v)?.getBoolean(p,C)}getNumber(p,v,C){return this.L(v)?.getNumber(p,C)}store(p,v,C,t){if((0,D.isUndefinedOrNull)(v)){this.remove(p,C);return}this.t(()=>{this.u(p,C,t),this.L(C)?.set(p,v)})}remove(p,v){this.t(()=>{this.u(p,v,void 0),this.L(v)?.delete(p)})}t(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,v){const C=[],t=this.F(p);for(const c of Object.keys(t))t[c]===v&&C.push(c);return C}u(p,v,C){const t=this.F(v);typeof C=="number"?t[p]!==C&&(t[p]=C,this.L(v)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[p]=="number"&&(delete t[p],this.L(v)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(p){switch(p){case-1:return this.D;case 0:return this.z;default:return this.w}}G(p){const v=this.L(p);return v?u(v):Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=y.NONE){this.f.fire({reason:p});const v=this.L(-1),C=this.L(0),t=this.L(1);switch(p){case y.NONE:await P.Promises.settled([v?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await P.Promises.settled([v?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.L(-1)?.items??new Map,v=this.L(0)?.items??new Map,C=this.L(1)?.items??new Map;return h(p,v,C,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(p,v){return this.r(y.NONE),(0,d.isUserDataProfile)(p)?this.N(p,v):this.O(p,v)}H(p,v){return!(p.id===v.id||S(v)&&S(p))}I(p,v,C,t){this.t(()=>{if(t)for(const[c,i]of p)v.set(c,i);else{const c=new Set;for(const[i,o]of p)c.add(i),v.get(i)!==o&&this.n(C,i);for(const[i]of v.items)c.has(i)||this.n(C,i)}})}}w.a=60*1e3,e.AbstractStorageService=w;function S(f){return f.isDefault||!!f.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class s extends w{constructor(){super(),this.p=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(p=>this.n(1,p))),this.B(this.P.onDidChangeStorage(p=>this.n(0,p))),this.B(this.p.onDidChangeStorage(p=>this.n(-1,p)))}L(p){switch(p){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(p){return!1}}e.InMemoryStorageService=s;async function h(f,p,v,C,t,c){const i=N=>{try{return JSON.parse(N)}catch{return N}},o=new Map,r=new Map;f.forEach((N,z)=>{o.set(z,N),r.set(z,i(N))});const l=new Map,a=new Map;p.forEach((N,z)=>{l.set(z,N),a.set(z,i(N))});const m=new Map,E=new Map;v.forEach((N,z)=>{m.set(z,N),E.set(z,i(N))}),console.group(C!==t?`Storage: Application (path: ${C})`:`Storage: Application & Profile (path: ${C}, default profile)`);const M=[];if(o.forEach((N,z)=>{M.push({key:z,value:N})}),console.table(M),console.groupEnd(),console.log(r),C!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];l.forEach((z,K)=>{N.push({key:K,value:z})}),console.table(N),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${c})`);const T=[];m.forEach((N,z)=>{T.push({key:z,value:N})}),console.table(T),console.groupEnd(),console.log(E)}e.logStorage=h}),define(ie[271],se([0,1,26,7,3,2,9,72,8,23,106,156,5,95,24,29]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class s extends R.Disposable{get storage(){return this.f}constructor(c,i){super(),this.j=c,this.k=i,this.b=this.B(new n.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new n.Emitter),this.onDidCloseStorage=this.c.event,this.f=new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new A.DeferredPromise,this.whenInit=this.h.p,this.i=y.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===y.StorageState.None)try{const c=await this.n();this.f.dispose(),this.f=c,this.B(c.onDidChangeStorage(o=>this.b.fire({key:o}))),await this.m(c);const i=c.getBoolean(u.IS_NEW_KEY);i===void 0?c.set(u.IS_NEW_KEY,!0):i&&c.set(u.IS_NEW_KEY,!1)}catch(c){this.j.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.i=y.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===I.LogLevel.Trace?c=>this.j.trace(c):void 0,logError:c=>this.j.error(c)}}m(c){return c.init()}get items(){return this.f.items}get(c,i){return this.f.get(c,i)}set(c,i){return this.f.set(c,i)}delete(c){return this.f.delete(c)}async close(){const c=new k.StopWatch(!1);await this.s(),c.stop(),c.elapsed()>s.a&&await this.r(c),this.c.fire()}async r(c){if(!!this.path)try{const i=(0,P.top)(Array.from(this.f.items.entries()).map(([r,l])=>({key:r,length:l.length})),(r,l)=>l.length-r.length,5).map(r=>`${r.key}:${r.length}`).join(", "),o=(await this.k.stat(g.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${o}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=y.StorageState.Closed,await this.f.close()}}s.a=2e3;class h extends s{get path(){if(!this.v.useInMemoryStorage)return(0,D.join)(this.u.globalStorageHome.fsPath,h.t)}constructor(c,i,o,r){super(o,r),this.u=c,this.v=i}async n(){return new y.Storage(new b.SQLiteStorageDatabase(this.path??b.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:y.StorageHint.STORAGE_IN_MEMORY})}}h.t="state.vscdb";class f extends h{constructor(c,i,o,r){super(c,i,o,r)}}e.ProfileStorageMain=f;class p extends h{constructor(c,i,o,r){super(i.defaultProfile,c,o,r)}async m(c){await super.m(c),this.z(c)}z(c){c.get(w.firstSessionDateStorageKey,void 0)===void 0&&c.set(w.firstSessionDateStorageKey,new Date().toUTCString());const o=c.get(w.currentSessionDateStorageKey,void 0),r=new Date().toUTCString();c.set(w.lastSessionDateStorageKey,typeof o>"u"?null:o),c.set(w.currentSessionDateStorageKey,r)}}e.ApplicationStorageMain=p;class v extends s{get path(){if(!this.w.useInMemoryStorage)return(0,D.join)(this.y.workspaceStorageHome.fsPath,this.v.id,v.t)}constructor(c,i,o,r,l){super(o,l),this.v=c,this.w=i,this.y=r}async n(){const{storageFilePath:c,wasCreated:i}=await this.C();return new y.Storage(new b.SQLiteStorageDatabase(c,{logging:this.l()}),{hint:this.w.useInMemoryStorage?y.StorageHint.STORAGE_IN_MEMORY:i?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:b.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const c=(0,D.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,D.join)(c,v.t);return await d.Promises.exists(c)?{storageFilePath:i,wasCreated:!1}:(await d.Promises.mkdir(c,{recursive:!0}),this.D(c),{storageFilePath:i,wasCreated:!0})}async D(c){let i;if((0,S.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,S.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const o=(0,D.join)(c,v.u);await d.Promises.exists(o)||await d.Promises.writeFile(o,JSON.stringify(i,void 0,2))}catch(o){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}v.t="state.vscdb",v.u="workspace.json",e.WorkspaceStorageMain=v;class C extends s{get path(){}async n(){return new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=C}),define(ie[272],se([0,1,3,2,95]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends A.Disposable{constructor(k,g,d){super(),this.b=k,this.c=g,this.f=d;const y=this.B(new A.MutableDisposable);this.a=this.B(new P.Emitter({onWillAddFirstListener:()=>y.value=this.g(),onDidRemoveLastListener:()=>y.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new A.DisposableStore;return k.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(g,d)=>(g?g.push(d.key):g=[d.key],g),100)(g=>this.h(g))),k.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(g,d)=>{g||(g=new Map);let y=g.get(d.profile.id);return y||g.set(d.profile.id,y={profile:d.profile,keys:[],storage:d.storage}),y.keys.push(d.key),g},100)(g=>this.i(g))),k}h(k){const g=k.includes(n.TARGET_KEY)?[this.c.defaultProfile]:[],d=[];if(k=k.filter(y=>y!==n.TARGET_KEY),k.length){const y=(0,n.loadKeyTargets)(this.b.applicationStorage.storage);d.push({profile:this.c.defaultProfile,changes:k.map(b=>({key:b,scope:0,target:y[b]}))})}this.j(g,d)}i(k){const g=[],d=new Map;for(const[y,b]of k.entries()){b.keys.includes(n.TARGET_KEY)&&g.push(b.profile);const I=b.keys.filter(u=>u!==n.TARGET_KEY);if(I.length){const u=(0,n.loadKeyTargets)(b.storage.storage);d.set(y,{profile:b.profile,changes:I.map(w=>({key:w,scope:0,target:u[w]}))})}}this.j(g,[...d.values()])}j(k,g){(k.length||g.length)&&this.a.fire({valueChanges:g,targetChanges:k})}listen(k,g,d){switch(g){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${g}`)}async call(k,g){throw new Error(`Call not found: ${g}`)}}e.ProfileStorageChangesListenerChannel=R}),define(ie[273],se([0,1,8,34,16,5,33,39,40,10,116]),function(X,e,P,A,n,R,D,k,g,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let b=class dt extends g.UserDataProfilesService{constructor(S,s,h,f,p){super(h,f,s,p),this.O=S,this.P=h}I(){return this.O.getItem(dt.b,[]).map(s=>({...s,location:(0,d.isString)(s.location)?this.r.extUri.joinPath(this.profilesHome,s.location):P.URI.revive(s.location)}))}L(){const S=this.O.getItem(dt.c,{});return this.O.getItem(dt.a,!1)?S:this.H(S)}N(){return this.r.extUri.joinPath(P.URI.file(this.P.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};b.a="profileAssociationsMigration",b=ye([ee(0,D.IStateReadService),ee(1,k.IUriIdentityService),ee(2,A.INativeEnvironmentService),ee(3,n.IFileService),ee(4,R.ILogService)],b),e.UserDataProfilesReadonlyService=b;let I=class st extends b{constructor(S,s,h,f,p){super(S,s,h,f,p),this.U=S}J(S){S.length?this.U.setItem(st.b,S.map(s=>({...s,location:this.r.extUri.basename(s.location)}))):this.U.removeItem(st.b)}I(){const S=super.I();return this.U.getItem("userDataProfilesMigration",!1)||(this.J(S),this.U.setItem("userDataProfilesMigration",!0)),S}M(S){S.emptyWindows||S.workspaces?this.U.setItem(st.c,S):this.U.removeItem(st.c)}L(){const S="workspaceAndProfileInfo",s=this.U.getItem(S,void 0);if(s){this.U.removeItem(S);const f=s.reduce((p,{workspace:v,profile:C})=>(p[P.URI.revive(v).toString()]=P.URI.revive(C).toString(),p),{});this.U.setItem(st.c,{workspaces:f})}const h=super.L();return this.U.getItem(st.a,!1)||(this.M(h),this.U.setItem(st.a,!0)),h}};I=ye([ee(0,D.IStateService),ee(1,k.IUriIdentityService),ee(2,A.INativeEnvironmentService),ee(3,n.IFileService),ee(4,R.ILogService)],I),e.UserDataProfilesService=I;let u=class extends I{constructor(S,s,h,f){super(new y.StateService(0,s,f,h),S,s,h,f)}async init(){return await this.U.init(),super.init()}};u=ye([ee(0,k.IUriIdentityService),ee(1,A.INativeEnvironmentService),ee(2,n.IFileService),ee(3,R.ILogService)],u),e.ServerUserDataProfilesService=u}),define(ie[53],se([0,1,34,16,6,5,39,40,273,33]),function(X,e,P,A,n,R,D,k,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,n.refineServiceDecorator)(k.IUserDataProfilesService);let y=class extends g.UserDataProfilesService{constructor(I,u,w,S,s){super(I,u,w,S,s)}getAssociatedEmptyWindows(){const I=[];for(const u of this.u.emptyWindows.keys())I.push({id:u});return I}};y=ye([ee(0,d.IStateService),ee(1,D.IUriIdentityService),ee(2,P.INativeEnvironmentService),ee(3,A.IFileService),ee(4,R.ILogService)],y),e.UserDataProfilesMainService=y}),define(ie[96],se([0,1,8,50,3,2,34,16,6,20,5,95,271,40,53,39]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,g.createDecorator)("storageMainService");let s=class extends R.Disposable{constructor(p,v,C,t,c,i){super(),this.c=p,this.f=v,this.g=C,this.h=t,this.i=c,this.j=i,this.a=void 0,this.b=this.B(new n.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(p=>{p.window.profile&&this.profileStorage(p.window.profile).init(),p.workspace&&this.workspaceStorage(p.workspace).init()})),this.B(this.h.onWillShutdown(p=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=p.reason,p.join("applicationStorage",this.applicationStorage.close());for(const[,v]of this.n)p.join("profileStorage",v.close());for(const[,v]of this.r)p.join("workspaceStorage",v.close())})),this.B(this.g.onWillCreateProfile(p=>{p.join((async()=>{await this.i.exists(p.profile.globalStorageHome)||await this.i.createFolder(p.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(p=>{const v=this.n.get(p.profile.id);v&&p.join(v.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const p=new I.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,A.once)(p.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),p}profileStorage(p){if((0,b.isProfileUsingDefaultStorage)(p))return this.applicationStorage;let v=this.n.get(p.id);if(!v){this.c.trace(`StorageMainService: creating profile storage (${p.name})`),v=this.p(p),this.n.set(p.id,v);const C=this.B(v.onDidChangeStorage(t=>this.b.fire({...t,storage:v,profile:p})));(0,A.once)(v.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${p.name})`),this.n.delete(p.id),C.dispose()})}return v}p(p){return this.a===2?new I.InMemoryStorageMain(this.c,this.i):new I.ProfileStorageMain(p,this.k(),this.c,this.i)}workspaceStorage(p){let v=this.r.get(p.id);return v||(this.c.trace(`StorageMainService: creating workspace storage (${p.id})`),v=this.s(p),this.r.set(p.id,v),(0,A.once)(v.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${p.id})`),this.r.delete(p.id)})),v}s(p){return this.a===2?new I.InMemoryStorageMain(this.c,this.i):new I.WorkspaceStorageMain(p,this.k(),this.c,this.f,this.i)}isUsed(p){const v=P.URI.file(p);for(const C of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!C.path&&this.j.extUri.isEqualOrParent(P.URI.file(C.path),v))return!0;return!1}};s=ye([ee(0,y.ILogService),ee(1,D.IEnvironmentService),ee(2,w.IUserDataProfilesMainService),ee(3,d.ILifecycleMainService),ee(4,k.IFileService),ee(5,S.IUriIdentityService)],s),e.StorageMainService=s,e.IApplicationStorageMainService=(0,g.createDecorator)("applicationStorageMainService");let h=class extends b.AbstractStorageService{constructor(p,v){super(),this.p=p,this.s=v,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(p){if(p===-1)return this.s.applicationStorage.storage}M(p){if(p===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};h=ye([ee(0,u.IUserDataProfilesService),ee(1,e.IStorageMainService)],h),e.ApplicationStorageMainService=h}),define(ie[274],se([0,1,2,20,53,29,7,30]),function(X,e,P,A,n,R,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let g=class extends P.Disposable{constructor(y,b,I){super(),this.a=b,this.b=I,this.B(y.onWillLoadWindow(u=>{u.reason===2&&this.c(u.window)})),this.B(y.onBeforeCloseWindow(u=>this.c(u))),this.B(new D.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(y){const b=this.f(y),I=this.a.getProfileForWorkspace(b);I?.isTransient&&(this.a.unsetWorkspace(b,I.isTransient),I.isTransient&&await this.a.cleanUpTransientProfiles())}f(y){return y.openedWorkspace??(0,R.toWorkspaceIdentifier)(y.backupPath,y.isExtensionDevelopmentHost)}g(){const y=this.a.getAssociatedEmptyWindows();if(y.length===0)return;const b=this.b.getWindows().map(I=>this.f(I));for(const I of y)b.some(u=>u.id===I.id)||this.a.unsetWorkspace(I,!1)}};g=ye([ee(0,A.ILifecycleMainService),ee(1,n.IUserDataProfilesMainService),ee(2,k.IWindowsMainService)],g),e.UserDataProfilesHandler=g}),define(ie[124],se([0,1,18,8,29]),function(X,e,P,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(g,d,y){for(const I of g){const u=I.openedWorkspace;if((0,n.isWorkspaceIdentifier)(u)){const w=await y(u);if(w){if(w.folders.some(S=>P.extUriBiasedIgnorePathCase.isEqualOrParent(d,S.uri)))return I}else if(P.extUriBiasedIgnorePathCase.isEqualOrParent(d,u.configPath))return I}}const b=g.filter(I=>(0,n.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqualOrParent(d,I.openedWorkspace.uri));if(b.length)return b.sort((I,u)=>-(I.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function D(g,d){for(const y of g)if((0,n.isWorkspaceIdentifier)(y.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,d)||(0,n.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,d))return y}e.findWindowOnWorkspaceOrFolder=D;function k(g,d){const y=b=>d.some(I=>P.extUriBiasedIgnorePathCase.isEqual(A.URI.file(I),A.URI.file(b)));for(const b of g)if(b.config?.extensionDevelopmentPath?.some(I=>y(I)))return b}e.findWindowOnExtensionDevelopmentPath=k}),define(ie[275],se([0,1,15,2,4,18,8,19,20,5,33,30,122,29]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let w=class wt extends A.Disposable{get state(){return this.b}constructor(v,C,t,c,i){super(),this.g=v,this.h=C,this.i=t,this.j=c,this.k=i,this.b=S(this.h.getItem(wt.a)),this.c=void 0,this.f=!1,this.l()}l(){P.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(v=>this.p(v)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(v=>{v.newCount-v.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(v=>this.p(v))}m(){this.f=!0,this.n()}n(){const v=new Set,C={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!C.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(o=>!o.isExtensionDevelopmentHost)),i&&(C.lastActiveWindow=this.r(i),C.lastActiveWindow.uiState.mode===3&&v.add(C.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(C.lastPluginDevelopmentHostWindow=this.r(t),C.lastPluginDevelopmentHostWindow.uiState.mode===3&&(v.has(C.lastPluginDevelopmentHostWindow.uiState.display)?n.isMacintosh&&!t.win?.isSimpleFullScreen()&&(C.lastPluginDevelopmentHostWindow.uiState.mode=1):v.add(C.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(C.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const o=this.r(i);return o.uiState.mode===3&&(v.has(o.uiState.display)?n.isMacintosh&&o.windowId!==C.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(o.uiState.mode=1):v.add(o.uiState.display)),o}));const c=h(C);this.h.setItem(wt.a,c),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",c)}p(v){if(this.i.quitRequested)return;const C=this.r(v);v.isExtensionDevelopmentHost&&!v.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=C:!v.isExtensionDevelopmentHost&&v.openedWorkspace&&this.b.openedWindows.forEach(t=>{const c=(0,u.isWorkspaceIdentifier)(v.openedWorkspace)&&t.workspace?.id===v.openedWorkspace.id,i=(0,u.isSingleFolderWorkspaceIdentifier)(v.openedWorkspace)&&t.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(t.folderUri,v.openedWorkspace.uri);(c||i)&&(t.uiState=C.uiState)}),this.g.getWindowCount()===1&&(this.c=C)}r(v){return{windowId:v.id,workspace:(0,u.isWorkspaceIdentifier)(v.openedWorkspace)?v.openedWorkspace:void 0,folderUri:(0,u.isSingleFolderWorkspaceIdentifier)(v.openedWorkspace)?v.openedWorkspace.uri:void 0,backupPath:v.backupPath,remoteAuthority:v.remoteAuthority,uiState:v.serializeWindowState()}}getNewWindowState(v){const C=this.s(v),t=this.k.getValue("window");if(C.mode===3){let c;C.hasDefaultState?c=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):c=!!(this.i.wasRestarted||t?.restoreFullscreen),c||(C.mode=1)}return C}s(v){const C=this.g.getLastActiveWindow();if(!v.extensionTestsPath){if(!!v.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const l=v.workspace;if((0,u.isWorkspaceIdentifier)(l)){const m=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===l.id).map(E=>E.uiState);if(m.length)return m[0]}if((0,u.isSingleFolderWorkspaceIdentifier)(l)){const m=this.state.openedWindows.filter(E=>E.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(E.folderUri,l.uri)).map(E=>E.uiState);if(m.length)return m[0]}else if(v.backupPath){const m=this.state.openedWindows.filter(E=>E.backupPath===v.backupPath).map(E=>E.uiState);if(m.length)return m[0]}const a=this.c||this.state.lastActiveWindow;if(!C&&a)return a.uiState}let t;const c=P.screen.getAllDisplays();if(c.length===1)t=c[0];else{if(n.isMacintosh){const l=P.screen.getCursorScreenPoint();t=P.screen.getDisplayNearestPoint(l)}!t&&C&&(t=P.screen.getDisplayMatching(C.getBounds())),t||(t=P.screen.getPrimaryDisplay()||c[0])}let i=(0,I.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const o=this.k.getValue("window");let r=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")i.mode=0,r=!1;else if(o.newWindowDimensions==="fullscreen")i.mode=3,r=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&C){const l=C.serializeWindowState();l.mode===3?i.mode=3:i=l,r=i.mode!==3&&o.newWindowDimensions==="offset"}}return r&&(i=this.t(i)),i.hasDefaultState=!0,i}t(v){if(this.g.getWindows().length===0)return v;v.x=typeof v.x=="number"?v.x:0,v.y=typeof v.y=="number"?v.y:0;const C=this.g.getWindows().map(t=>t.getBounds());for(;C.some(t=>t.x===v.x||t.y===v.y);)v.x+=30,v.y+=30;return v}};w.a="windowsState",w=ye([ee(0,b.IWindowsMainService),ee(1,y.IStateService),ee(2,g.ILifecycleMainService),ee(3,d.ILogService),ee(4,k.IConfigurationService)],w),e.WindowsStateHandler=w;function S(p){const v={openedWindows:[]},C=p||{openedWindows:[]};return C.lastActiveWindow&&(v.lastActiveWindow=s(C.lastActiveWindow)),C.lastPluginDevelopmentHostWindow&&(v.lastPluginDevelopmentHostWindow=s(C.lastPluginDevelopmentHostWindow)),Array.isArray(C.openedWindows)&&(v.openedWindows=C.openedWindows.map(t=>s(t))),v}e.restoreWindowsState=S;function s(p){const v={uiState:p.uiState};return p.backupPath&&(v.backupPath=p.backupPath),p.remoteAuthority&&(v.remoteAuthority=p.remoteAuthority),p.folder&&(v.folderUri=D.URI.parse(p.folder)),p.workspaceIdentifier&&(v.workspace={id:p.workspaceIdentifier.id,configPath:D.URI.parse(p.workspaceIdentifier.configURIPath)}),v}function h(p){return{lastActiveWindow:p.lastActiveWindow&&f(p.lastActiveWindow),lastPluginDevelopmentHostWindow:p.lastPluginDevelopmentHostWindow&&f(p.lastPluginDevelopmentHostWindow),openedWindows:p.openedWindows.map(v=>f(v))}}e.getWindowsStateStoreData=h;function f(p){return{workspaceIdentifier:p.workspace&&{id:p.workspace.id,configURIPath:p.workspace.configPath.toString()},folder:p.folderUri&&p.folderUri.toString(),backupPath:p.backupPath,remoteAuthority:p.remoteAuthority,uiState:p.uiState}}}),define(ie[97],se([0,1,32,43,129,45,14,9,4,18,8,6,56,29]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function w(E){return E.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function S(E){return E.hasOwnProperty("folderUri")}e.isRecentFolder=S;function s(E){return E.hasOwnProperty("fileUri")}e.isRecentFile=s;function h(E){return f(E)||p(E)}e.isStoredWorkspaceFolder=h;function f(E){const M=E;return typeof M?.path=="string"&&(!M.name||typeof M.name=="string")}function p(E){const M=E;return typeof M?.uri=="string"&&(!M.name||typeof M.name=="string")}function v(E,M,T,N,z){if(E.scheme!==N.scheme)return{name:T,uri:E.toString(!0)};let K=M?void 0:z.relativePath(N,E);if(K!==void 0)K.length===0?K=".":g.isWindows&&(K=C(K));else if(E.scheme===D.Schemas.file)K=E.fsPath,g.isWindows&&(K=C(K));else if(z.isEqualAuthority(E.authority,N.authority))K=E.path;else return{name:T,uri:E.toString(!0)};return{name:T,path:K}}e.getStoredWorkspaceFolder=v;function C(E){return E=(0,R.normalizeDriveLetter)(E),(0,P.isUNC)(E)||(E=(0,P.toSlashes)(E)),E}function t(E,M,T){const N=[],z=new Set,K=T.dirname(M);for(const ae of E){let le;if(f(ae))ae.path&&(le=T.resolvePath(K,ae.path));else if(p(ae))try{le=y.URI.parse(ae.uri),le.path[0]!==k.posix.sep&&(le=le.with({path:k.posix.sep+le.path}))}catch(te){console.warn(te)}if(le){const te=T.getComparisonKey(le);if(!z.has(te)){z.add(te);const F=ae.name||T.basenameOrAuthority(le);N.push(new u.WorkspaceFolder({uri:le,name:F,index:N.length},ae))}}}return N}e.toWorkspaceFolders=t;function c(E,M,T,N,z){const K=i(M,E),ae=z.dirname(M),le=z.dirname(N),te=[];for(const x of K.folders){const H=f(x)?z.resolvePath(ae,x.path):y.URI.parse(x.uri);let O;T?O=!1:O=!f(x)||(0,k.isAbsolute)(x.path),te.push(v(H,O,x.name,le,z))}const F={insertSpaces:!1,tabSize:4,eol:g.isLinux||g.isMacintosh?`
`:`\r
`},$=n.setProperty(E,["folders"],te,F);let V=n.applyEdits(E,$);return(0,d.isEqualAuthority)(K.remoteAuthority,(0,I.getRemoteAuthority)(N))&&(V=n.applyEdits(V,n.removeProperty(V,["remoteAuthority"],F))),V}e.rewriteWorkspaceFileForNewLocation=c;function i(E,M){const T=A.parse(M);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(N=>h(N));else throw new Error(`${E} looks like an invalid workspace file.`);return T}function o(E){return E.workspace&&typeof E.workspace=="object"&&typeof E.workspace.id=="string"&&typeof E.workspace.configPath=="string"}function r(E){return typeof E.folderUri=="string"}function l(E){return typeof E.fileUri=="string"}function a(E,M){const T={workspaces:[],files:[]};if(E){const N=function(K,ae){for(let le=0;le<K.length;le++)try{ae(K[le],le)}catch(te){M.warn(`Error restoring recent entry ${JSON.stringify(K[le])}: ${te.toString()}. Skip entry.`)}},z=E;Array.isArray(z.entries)&&N(z.entries,K=>{const ae=K.label,le=K.remoteAuthority;o(K)?T.workspaces.push({label:ae,remoteAuthority:le,workspace:{id:K.workspace.id,configPath:y.URI.parse(K.workspace.configPath)}}):r(K)?T.workspaces.push({label:ae,remoteAuthority:le,folderUri:y.URI.parse(K.folderUri)}):l(K)&&T.files.push({label:ae,remoteAuthority:le,fileUri:y.URI.parse(K.fileUri)})})}return T}e.restoreRecentlyOpened=a;function m(E){const M={entries:[]};for(const T of E.workspaces)S(T)?M.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):M.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of E.files)M.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return M}e.toStoreData=m}),define(ie[98],se([0,1,81,14,4,18]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function D(d){function y(){let b=d.scheme===A.Schemas.file?(0,R.originalFSPath)(d):d.toString();return n.isLinux||(b=b.toLowerCase()),(0,P.createHash)("md5").update(b).digest("hex")}return{id:y(),configPath:d}}e.getWorkspaceIdentifier=D;function k(d,y){function b(){if(d.scheme!==A.Schemas.file)return(0,P.createHash)("md5").update(d.toString()).digest("hex");if(!y)return;let u;return n.isLinux?u=y.ino:n.isMacintosh?u=y.birthtime.getTime():n.isWindows&&(typeof y.birthtimeMs=="number"?u=Math.floor(y.birthtimeMs):u=y.birthtime.getTime()),(0,P.createHash)("md5").update(d.fsPath).update(u?String(u):"").digest("hex")}const I=b();if(typeof I=="string")return{id:I,uri:d}}e.getSingleFolderWorkspaceIdentifier=k;function g(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=g}),define(ie[276],se([0,1,81,32,14,9,4,18,23,187,19,28,33,16,5,186,29,98]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let f=class yt{constructor(v,C,t,c){this.j=v,this.k=C,this.l=t,this.m=c,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.extUriBiasedIgnorePathCase,this.i={isEqual:(i,o)=>(0,A.isEqual)(i,o,!D.isLinux)}}async initialize(){const v=this.m.getItem(yt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(v.emptyWindows),this.d=await this.u((0,d.deserializeWorkspaceInfos)(v)),this.e=await this.v((0,d.deserializeFolderInfos)(v)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==u.HotExitConfiguration.OFF}q(){return this.s()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(v,C){this.d.some(c=>v.workspace.id===c.workspace.id)||(this.d.push(v),this.C());const t=(0,R.join)(this.c,v.workspace.id);return C?this.t(t,C).then(()=>t):t}async t(v,C){if(await g.Promises.exists(v)&&await this.z(v),await g.Promises.exists(C))try{await g.Promises.rename(C,v)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(v){return this.e.some(C=>this.h.isEqual(v.folderUri,C.folderUri))||(this.e.push(v),this.C()),(0,R.join)(this.c,this.D(v))}registerEmptyWindowBackup(v){return this.g.some(C=>!!C.backupFolder&&this.i.isEqual(C.backupFolder,v.backupFolder))||(this.g.push(v),this.C()),(0,R.join)(this.c,v.backupFolder)}async u(v){if(!Array.isArray(v))return[];const C=new Set,t=[];for(const c of v){const i=c.workspace;if(!(0,s.isWorkspaceIdentifier)(i))return[];if(!C.has(i.id)){C.add(i.id);const o=(0,R.join)(this.c,i.id);await this.B(o)?i.configPath.scheme!==n.Schemas.file||await g.Promises.exists(i.configPath.fsPath)?t.push(c):await this.z(o):await this.x(o)}}return t}async v(v){if(!Array.isArray(v))return[];const C=[],t=new Set;for(const c of v){const i=c.folderUri,o=this.h.getComparisonKey(i);if(!t.has(o)){t.add(o);const r=(0,R.join)(this.c,this.D(c));await this.B(r)?i.scheme!==n.Schemas.file||await g.Promises.exists(i.fsPath)?C.push(c):await this.z(r):await this.x(r)}}return C}async w(v){if(!Array.isArray(v))return[];const C=[],t=new Set;for(const c of v){const i=c.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const o=(0,R.join)(this.c,i);await this.B(o)?C.push(c):await this.x(o)}}return C}async x(v){try{await g.Promises.rm(v,g.RimRafMode.MOVE)}catch(C){this.l.error(`Backup: Could not delete stale backup: ${C.toString()}`)}}y(){let v=(0,h.createEmptyWorkspaceIdentifier)();for(;this.g.some(C=>!!C.backupFolder&&this.i.isEqual(C.backupFolder,v.id));)v=(0,h.createEmptyWorkspaceIdentifier)();return{backupFolder:v.id}}async z(v){const C=this.y(),t=(0,R.join)(this.c,C.backupFolder);try{await g.Promises.rename(v,t)}catch(c){return this.l.error(`Backup: Could not rename backup folder: ${c.toString()}`),!1}return this.g.push(C),!0}async getDirtyWorkspaces(){const v=[];for(const C of this.d)await this.A(C)&&v.push(C);for(const C of this.e)await this.A(C)&&v.push(C);return v}A(v){let C;return(0,d.isEmptyWindowBackupInfo)(v)?C=(0,R.join)(this.c,v.backupFolder):(0,S.isFolderBackupInfo)(v)?C=(0,R.join)(this.c,this.D(v)):C=(0,R.join)(this.c,v.workspace.id),this.B(C)}async B(v){try{const C=await g.Promises.readdir(v);for(const t of C)try{if((await g.Promises.readdir((0,R.join)(v,t))).length>0)return!0}catch{}}catch{}return!1}C(){const v={workspaces:this.d.map(({workspace:C,remoteAuthority:t})=>{const c={id:C.id,configURIPath:C.configPath.toString()};return t&&(c.remoteAuthority=t),c}),folders:this.e.map(({folderUri:C,remoteAuthority:t})=>{const c={folderUri:C.toString()};return t&&(c.remoteAuthority=t),c}),emptyWindows:this.g.map(({backupFolder:C,remoteAuthority:t})=>{const c={backupFolder:C};return t&&(c.remoteAuthority=t),c})};this.m.setItem(yt.a,v)}D(v){const C=v.folderUri;let t;return C.scheme===n.Schemas.file?t=D.isLinux?C.fsPath:C.fsPath.toLowerCase():t=C.toString().toLowerCase(),(0,P.createHash)("md5").update(t).digest("hex")}};f.a="backupWorkspaces",f=ye([ee(0,b.IEnvironmentMainService),ee(1,y.IConfigurationService),ee(2,w.ILogService),ee(3,I.IStateService)],f),e.BackupMainService=f}),define(ie[54],se([0,1,15,3,43,2,14,9,18,10,23,185,63,57,28,6,5,53,124,29,97,98]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,S.createDecorator)("workspacesManagementMainService");let t=class extends R.Disposable{constructor(i,o,r,l,a){super(),this.g=i,this.h=o,this.i=r,this.j=l,this.k=a,this.a=this.B(new A.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new A.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const i=(await y.Promises.readdir(this.c.fsPath)).map(o=>(0,g.joinPath)(this.c,o,p.UNTITLED_WORKSPACE_NAME));for(const o of i){const r=(0,C.getWorkspaceIdentifier)(o),l=await this.resolveLocalWorkspace(o);l?this.f.push({workspace:r,remoteAuthority:l.remoteAuthority}):await this.deleteUntitledWorkspace(r)}}catch(i){i.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${i}).`)}}resolveLocalWorkspace(i){return this.l(i,o=>y.Promises.readFile(o,"utf8"))}l(i,o){if(!!this.m(i)&&i.scheme===D.Schemas.file)try{const r=o(i.fsPath);return r instanceof Promise?r.then(l=>this.n(i,l),l=>{}):this.n(i,r)}catch{return}}m(i){return(0,p.isUntitledWorkspace)(i,this.g)||(0,p.hasWorkspaceFileExtension)(i)}n(i,o){try{const r=this.p(i,o),l=(0,C.getWorkspaceIdentifier)(i);return{id:l.id,configPath:l.configPath,folders:(0,v.toWorkspaceFolders)(r.folders,l.configPath,g.extUriBiasedIgnorePathCase),remoteAuthority:r.remoteAuthority,transient:r.transient}}catch(r){this.h.warn(r.toString())}}p(i,o){const r=(0,n.parse)(o);if(r&&Array.isArray(r.folders))r.folders=r.folders.filter(l=>(0,v.isStoredWorkspaceFolder)(l));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return r}async createUntitledWorkspace(i,o){const{workspace:r,storedWorkspace:l}=this.r(i,o),a=r.configPath.fsPath;return await y.Promises.mkdir((0,k.dirname)(a),{recursive:!0}),await y.Promises.writeFile(a,JSON.stringify(l,null,"	")),this.f.push({workspace:r,remoteAuthority:o}),r}r(i=[],o){const r=(Date.now()+Math.round(Math.random()*1e3)).toString(),l=(0,g.joinPath)(this.c,r),a=(0,g.joinPath)(l,p.UNTITLED_WORKSPACE_NAME),m=[];for(const E of i)m.push((0,v.getStoredWorkspaceFolder)(E.uri,!0,E.name,l,g.extUriBiasedIgnorePathCase));return{workspace:(0,C.getWorkspaceIdentifier)(a),storedWorkspace:{folders:m,remoteAuthority:o}}}async getWorkspaceIdentifier(i){return(0,C.getWorkspaceIdentifier)(i)}isUntitledWorkspace(i){return(0,p.isUntitledWorkspace)(i.configPath,this.g)}async deleteUntitledWorkspace(i){!this.isUntitledWorkspace(i)||(await this.s(i),this.i.isEnabled()&&this.i.unsetWorkspace(i),this.a.fire(i))}async s(i){const o=(0,g.originalFSPath)(i.configPath);try{await y.Promises.rm((0,k.dirname)(o));const r=(0,k.join)(this.g.workspaceStorageHome.fsPath,i.id);await y.Promises.exists(r)&&await y.Promises.writeFile((0,k.join)(r,"obsolete"),""),this.f=this.f.filter(l=>l.workspace.id!==i.id)}catch(r){this.h.warn(`Unable to delete untitled workspace ${o} (${r}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(i,o,r){if(!i||!i.win||!i.isReady||!await this.t(i,o,r))return;const a=await this.u(i,(0,C.getWorkspaceIdentifier)(r));if(!!a)return this.b.fire({window:i,workspace:a.workspace}),a}async t(i,o,r){return r?(0,p.isWorkspaceIdentifier)(i.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,r)?!1:(0,f.findWindowOnWorkspaceOrFolder)(o,r)?(await this.k.showMessageBox({type:"info",buttons:[(0,b.localize)(0,null)],message:(0,b.localize)(1,null,(0,g.basename)(r)),detail:(0,b.localize)(2,null)},(0,d.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow())),!1):!0:!0}async u(i,o){if(!i.config)return;i.focus();let r;return i.config.extensionDevelopmentPath||(i.config.backupPath?r=await this.j.registerWorkspaceBackup({workspace:o,remoteAuthority:i.remoteAuthority},i.config.backupPath):r=this.j.registerWorkspaceBackup({workspace:o,remoteAuthority:i.remoteAuthority})),(0,p.isWorkspaceIdentifier)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=o,i.config.backupPath=r,{workspace:o,backupPath:r}}};t=ye([ee(0,w.IEnvironmentMainService),ee(1,s.ILogService),ee(2,h.IUserDataProfilesMainService),ee(3,I.IBackupMainService),ee(4,u.IDialogMainService)],t),e.WorkspacesManagementMainService=t}),define(ie[125],se([0,1,15,42,22,6,30,29,54,10,5]),function(X,e,P,A,n,R,D,k,g,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let b=class{constructor(u,w,S){this.a=u,this.b=w,this.c=S}async getRemoteDiagnostics(u){const w=this.a.getWindows();return(await Promise.all(w.map(async s=>{const h=s.remoteAuthority;if(!h)return;const f=`vscode:getDiagnosticInfoResponse${s.id}`,p={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?await this.f(s):void 0};return new Promise(v=>{s.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:f,args:p}),A.validatedIpcMain.once(f,(C,t)=>{t||v({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),v(t)}),setTimeout(()=>{v({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(s=>!!s)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const u=[];for(const w of P.BrowserWindow.getAllWindows()){const S=this.a.getWindowById(w.id);S?u.push(await this.d(S)):u.push(this.e(w))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(u){const w=await this.f(u),S=(0,d.assertIsDefined)(u.win);return this.e(S,w,u.remoteAuthority)}e(u,w=[],S){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:w,remoteAuthority:S}}async f(u){const w=[],S=u.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(S))w.push(S.uri);else if((0,k.isWorkspaceIdentifier)(S)){const s=await this.b.resolveLocalWorkspace(S.configPath);s&&s.folders.forEach(f=>{w.push(f.uri)})}return w}};b=ye([ee(0,D.IWindowsMainService),ee(1,g.IWorkspacesManagementMainService),ee(2,y.ILogService)],b),e.DiagnosticsMainService=b}),define(ie[58],se([0,1,46,15,27,150,55,3,2,14,9,4,8,102,84,23,100,175,57,28,6,20,5,21,69,30,29,54,17,234,227,33]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p,v,C,t,c,i,o,r,l,a,m,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,v.createDecorator)("nativeHostMainService");let T=class extends g.Disposable{constructor(z,K,ae,le,te,F,$,V,x,H){super(),this.a=z,this.b=K,this.c=ae,this.f=le,this.g=te,this.h=F,this.i=$,this.j=V,this.k=x,this.l=H,this.onDidOpenWindow=k.Event.map(this.b.onDidOpenWindow,O=>O.id),this.onDidTriggerSystemContextMenu=k.Event.filter(k.Event.map(this.b.onDidTriggerSystemContextMenu,({window:O,x:G,y:_})=>({windowId:O.id,x:G,y:_})),({windowId:O})=>!!this.b.getWindowById(O)),this.onDidMaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(A.app,"browser-window-maximize",(O,G)=>G.id),O=>!!this.b.getWindowById(O)),this.onDidUnmaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(A.app,"browser-window-unmaximize",(O,G)=>G.id),O=>!!this.b.getWindowById(O)),this.onDidBlurWindow=k.Event.filter(k.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(O,G)=>G.id),O=>!!this.b.getWindowById(O)),this.onDidFocusWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),O=>!!O),O=>O.id),k.Event.filter(k.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(O,G)=>G.id),O=>!!this.b.getWindowById(O))),this.onDidResumeOS=k.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new k.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(O,G,_)=>_),O=>!(Array.isArray(O)&&O.length===1&&O[0]==="workArea")),k.Event.fromNodeEventEmitter(A.screen,"display-added"),k.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(K=>({id:K.id,workspace:K.openedWorkspace??(0,r.toWorkspaceIdentifier)(K.backupPath,K.isExtensionDevelopmentHost),title:K.win?.getTitle()??"",filename:K.getRepresentedFilename(),dirty:K.isDocumentEdited()}))}async getWindowCount(z){return this.b.getWindowCount()}async getActiveWindowId(z){const K=A.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(K)return K.id}openWindow(z,K,ae){return Array.isArray(K)?this.n(z,K,ae):this.p(z,K)}async n(z,K,ae=Object.create(null)){K.length>0&&await this.b.open({context:5,contextWindowId:z,urisToOpen:K,cli:this.g.args,forceNewWindow:ae.forceNewWindow,forceReuseWindow:ae.forceReuseWindow,preferNewWindow:ae.preferNewWindow,diffMode:ae.diffMode,mergeMode:ae.mergeMode,addMode:ae.addMode,gotoLineMode:ae.gotoLineMode,noRecentEntry:ae.noRecentEntry,waitMarkerFileURI:ae.waitMarkerFileURI,remoteAuthority:ae.remoteAuthority||void 0,forceProfile:ae.forceProfile,forceTempProfile:ae.forceTempProfile})}async p(z,K){await this.b.openEmptyWindow({context:5,contextWindowId:z},K)}async toggleFullScreen(z){this.w(z)?.toggleFullScreen()}async handleTitleDoubleClick(z){this.w(z)?.handleTitleDoubleClick()}async isMaximized(z){const K=this.w(z);return K?.win?K.win.isMaximized():!1}async maximizeWindow(z){const K=this.w(z);K?.win&&K.win.maximize()}async unmaximizeWindow(z){const K=this.w(z);K?.win&&K.win.unmaximize()}async minimizeWindow(z){const K=this.w(z);K?.win&&K.win.minimize()}async updateWindowControls(z,K){const ae=this.w(z);ae&&ae.updateWindowControls(K)}async focusWindow(z,K){K&&typeof K.windowId=="number"&&(z=K.windowId),this.w(z)?.focus({force:K?.force??!1})}async setMinimumSize(z,K,ae){const le=this.w(z);if(le?.win){const[te,F]=le.win.getSize(),[$,V]=le.win.getMinimumSize(),[x,H]=[K??$,ae??V],[O,G]=[Math.max(te,x),Math.max(F,H)];($!==x||V!==H)&&le.win.setMinimumSize(x,H),(te!==O||F!==G)&&le.win.setSize(O,G)}}async saveWindowSplash(z,K){this.j.saveWindowSplash(z,K)}async installShellCommand(z){const{source:K,target:ae}=await this.r();try{const{symbolicLink:le}=await S.SymlinkSupport.stat(K);if(le&&!le.dangling){const te=await(0,u.realpath)(K);if(ae===te)return}await S.Promises.unlink(K)}catch(le){if(le.code!=="ENOENT")throw le}try{await S.Promises.symlink(ae,K)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:te}=await this.showMessageBox(z,{type:"info",message:(0,h.localize)(0,null,this.i.nameShort),buttons:[(0,h.localize)(1,null),(0,h.localize)(2,null)]});if(te===0)try{const F=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ae}' '${K}'\\" with administrator privileges"`;await(0,R.promisify)(P.exec)(F)}catch{throw new Error((0,h.localize)(3,null,K))}}}async uninstallShellCommand(z){const{source:K}=await this.r();try{await S.Promises.unlink(K)}catch(ae){switch(ae.code){case"EACCES":{const{response:le}=await this.showMessageBox(z,{type:"info",message:(0,h.localize)(4,null,this.i.nameShort),buttons:[(0,h.localize)(5,null),(0,h.localize)(6,null)]});if(le===0)try{const te=`osascript -e "do shell script \\"rm '${K}'\\" with administrator privileges"`;await(0,R.promisify)(P.exec)(te)}catch{throw new Error((0,h.localize)(7,null,K))}break}case"ENOENT":break;default:throw ae}}}async r(){const z=(0,y.resolve)(this.g.appRoot,"bin","code"),K=`/usr/local/bin/${this.i.applicationName}`;if(!await S.Promises.exists(z))throw new Error((0,h.localize)(8,null,z));return{source:K,target:z}}async showMessageBox(z,K){return this.c.showMessageBox(K,this.s(z))}async showSaveDialog(z,K){return this.c.showSaveDialog(K,this.s(z))}async showOpenDialog(z,K){return this.c.showOpenDialog(K,this.s(z))}s(z){const K=this.w(z);if(K?.win)return K.win}async pickFileFolderAndOpen(z,K){const ae=await this.c.pickFileFolder(K);ae&&await this.t(await Promise.all(ae.map(async le=>await S.SymlinkSupport.existsDirectory(le)?{folderUri:I.URI.file(le)}:{fileUri:I.URI.file(le)})),K,z)}async pickFolderAndOpen(z,K){const ae=await this.c.pickFolder(K);ae&&await this.t(ae.map(le=>({folderUri:I.URI.file(le)})),K,z)}async pickFileAndOpen(z,K){const ae=await this.c.pickFile(K);ae&&await this.t(ae.map(le=>({fileUri:I.URI.file(le)})),K,z)}async pickWorkspaceAndOpen(z,K){const ae=await this.c.pickWorkspace(K);ae&&await this.t(ae.map(le=>({workspaceUri:I.URI.file(le)})),K,z)}async t(z,K,ae){await this.b.open({context:3,contextWindowId:ae,cli:this.g.args,urisToOpen:z,forceNewWindow:K.forceNewWindow})}async showItemInFolder(z,K){A.shell.showItemInFolder(K)}async setRepresentedFilename(z,K){this.w(z)?.setRepresentedFilename(K)}async setDocumentEdited(z,K){this.w(z)?.setDocumentEdited(K)}async openExternal(z,K){return b.isLinuxSnap?this.u(K):A.shell.openExternal(K),!0}u(z){const K=process.env.GDK_PIXBUF_MODULE_FILE,ae=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,A.shell.openExternal(z),process.env.GDK_PIXBUF_MODULE_FILE=K,process.env.GDK_PIXBUF_MODULEDIR=ae}moveItemToTrash(z,K){return A.shell.trashItem(K)}async isAdmin(){let z;return b.isWindows?z=(await new Promise((K,ae)=>{X(["native-is-elevated"],K,ae)}))():z=process.getuid()===0,z}async writeElevated(z,K,ae,le){const te=await new Promise((F,$)=>{X(["@vscode/sudo-prompt"],F,$)});return new Promise((F,$)=>{const V=[`"${this.v}"`];le?.unlock&&V.push("--file-chmod"),V.push("--file-write",`"${K.fsPath}"`,`"${ae.fsPath}"`);const x={name:this.i.nameLong.replace("-",""),icns:b.isMacintosh&&this.g.isBuilt?(0,y.join)((0,y.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};te.exec(V.join(" "),x,(H,O,G)=>{O&&this.h.trace(`[sudo-prompt] received stdout: ${O}`),G&&this.h.trace(`[sudo-prompt] received stderr: ${G}`),H?$(H):F(void 0)})})}get v(){return b.isWindows?this.g.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,y.join)(this.g.appRoot,"scripts","code-cli.bat"):b.isLinux?this.g.isBuilt?(0,y.join)((0,y.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,y.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,y.join)(this.g.appRoot,"bin","code"):(0,y.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,n.totalmem)(),freemem:(0,n.freemem)(),loadavg:(0,n.loadavg)()}}async getOSProperties(){return{arch:(0,n.arch)(),platform:(0,n.platform)(),release:(0,n.release)(),type:(0,n.type)(),cpus:(0,n.cpus)()}}async getOSVirtualMachineHint(){return w.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return b.isWindows&&(0,m.hasWSLFeatureInstalled)()}async killProcess(z,K,ae){process.kill(K,ae)}async readClipboardText(z,K){return A.clipboard.readText(K)}async writeClipboardText(z,K,ae){return A.clipboard.writeText(K,ae)}async readClipboardFindText(z){return A.clipboard.readFindText()}async writeClipboardFindText(z,K){return A.clipboard.writeFindText(K)}async writeClipboardBuffer(z,K,ae,le){return A.clipboard.writeBuffer(K,Buffer.from(ae.buffer),le)}async readClipboardBuffer(z,K){return a.VSBuffer.wrap(A.clipboard.readBuffer(K))}async hasClipboard(z,K,ae){return A.clipboard.has(K,ae)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(z,K){this.w(z)?.updateTouchBar(K)}async notifyReady(z){this.w(z)?.setReady()}async relaunch(z,K){return this.f.relaunch(K)}async reload(z,K){const ae=this.w(z);if(ae){if((0,r.isWorkspaceIdentifier)(ae.openedWorkspace)){const le=ae.openedWorkspace.configPath;if(le.scheme===d.Schemas.file&&(await this.l.resolveLocalWorkspace(le))?.transient)return this.openWindow(ae.id,{forceReuseWindow:!0})}return this.f.reload(ae,K?.disableExtensions!==void 0?{_:[],"disable-extensions":K.disableExtensions}:void 0)}}async closeWindow(z){this.closeWindowById(z,z)}async closeWindowById(z,K){const ae=this.w(K);if(ae?.win)return ae.win.close()}async quit(z){const K=this.b.getLastActiveWindow();K?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&K.win?K.win.close():this.f.quit()}async exit(z,K){await this.f.kill(K)}async resolveProxy(z,K){return this.w(z)?.win?.webContents?.session?.resolveProxy(K)}findFreePort(z,K,ae,le,te=1){return(0,s.findFreePort)(K,ae,le,te)}async openDevTools(z,K){const ae=this.w(z);ae?.win&&ae.win.webContents.openDevTools(K)}async toggleDevTools(z){const K=this.w(z);K?.win&&K.win.webContents.toggleDevTools()}async sendInputEvent(z,K){const ae=this.w(z);ae?.win&&(K.type==="mouseDown"||K.type==="mouseUp")&&ae.win.webContents.sendInputEvent(K)}async enableSandbox(z,K){K?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(z,K,ae){const le=this.w(z);if(!le||!le.win)throw new Error;return await new E.WindowProfiler(le.win,K,this.h).inspect(ae)}async windowsGetStringRegKey(z,K,ae,le){if(!b.isWindows)return;const te=await new Promise((F,$)=>{X(["@vscode/windows-registry"],F,$)});try{return te.GetStringRegKey(K,ae,le)}catch{return}}w(z){if(typeof z=="number")return this.b.getWindowById(z)}};ye([D.memoize],T.prototype,"v",null),T=ye([ee(1,o.IWindowsMainService),ee(2,f.IDialogMainService),ee(3,C.ILifecycleMainService),ee(4,p.IEnvironmentMainService),ee(5,t.ILogService),ee(6,c.IProductService),ee(7,i.IThemeMainService),ee(8,M.IStateService),ee(9,l.IWorkspacesManagementMainService)],T),e.NativeHostMainService=T}),define(ie[277],se([0,1,15,42,27,2,14,4,103,173,87,125,57,28,6,5,58,66,21,67,77,32,10,33]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p,v,C,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,w.createDecorator)("issueMainService");const i="issue.processExplorerWindowState";let o=class kt{constructor(a,m,E,M,T,N,z,K,ae,le){this.g=a,this.h=m,this.i=E,this.j=M,this.k=T,this.l=N,this.m=z,this.n=K,this.o=ae,this.p=le,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){A.validatedIpcMain.on("vscode:issueSystemInfoRequest",async a=>{const[m,E]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),M=await this.j.getSystemInfo(m,E);this.r(a,"vscode:issueSystemInfoResponse",M)}),A.validatedIpcMain.on("vscode:listProcesses",async a=>{const m=[];try{m.push({name:(0,d.localize)(0,null),rootProcess:await(0,g.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(M=>{(0,y.isRemoteDiagnosticError)(M)?m.push({name:M.hostName,rootProcess:M}):M.processes&&m.push({name:M.hostName,rootProcess:M.processes})})}catch(E){this.i.error(`Listing processes failed: ${E}`)}this.r(a,"vscode:listProcessesResponse",m)}),A.validatedIpcMain.on("vscode:issueReporterClipboard",async a=>{if(this.b){const{response:m}=await this.l.showMessageBox({type:"warning",message:(0,d.localize)(1,null),buttons:[(0,d.localize)(2,null),(0,d.localize)(3,null)]},this.b);this.r(a,"vscode:issueReporterClipboardResponse",m===0)}}),A.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async a=>{const m=await this.v();this.r(a,"vscode:issuePerformanceInfoResponse",m)}),A.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{if(this.b){const{response:a}=await this.l.showMessageBox({type:"warning",message:(0,d.localize)(4,null),buttons:[(0,d.localize)(5,null),(0,d.localize)(6,null)]},this.b);a===0&&this.b&&(this.b.destroy(),this.b=null)}}),A.validatedIpcMain.on("vscode:workbenchCommand",(a,m)=>{const{id:E,from:M,args:T}=m;let N;switch(M){case"issueReporter":N=this.c;break;case"processExplorer":N=this.f;break;default:throw new Error(`Unexpected command source: ${M}`)}N?.webContents.send("vscode:runAction",{id:E,from:M,args:T})}),A.validatedIpcMain.on("vscode:openExternal",(a,m)=>{this.m.openExternal(void 0,m)}),A.validatedIpcMain.on("vscode:closeIssueReporter",a=>{this.b?.close()}),A.validatedIpcMain.on("vscode:closeProcessExplorer",a=>{this.d?.close()}),A.validatedIpcMain.on("vscode:windowsInfoRequest",async a=>{const m=await this.k.getMainDiagnostics();this.r(a,"vscode:windowsInfoResponse",m.windows)})}r(a,m,...E){a.sender.isDestroyed()||a.sender.send(m,...E)}async openReporter(a){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const m=new R.DisposableStore,E=m.add(this.n.createIPCObjectUrl()),M=this.u(this.c,700,800);this.b=this.t(M,E,{backgroundColor:a.styles.backgroundColor,title:(0,d.localize)(7,null),zoomLevel:a.zoomLevel,alwaysOnTop:!1},"issue-reporter"),E.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:a,disableExtensions:!!this.h.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:h.default}),this.b.loadURL(D.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,m.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,m.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(a){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const m=new R.DisposableStore,E=m.add(this.n.createIPCObjectUrl()),M=this.p.getItem(i,void 0),T=r(M)?M:this.u(this.f,800,500);this.d=this.t(T,E,{backgroundColor:a.styles.backgroundColor,title:(0,d.localize)(8,null),zoomLevel:a.zoomLevel,alwaysOnTop:!0},"process-explorer"),E.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:a,product:h.default}),this.d.loadURL(D.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,m.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,m.dispose())});const N=()=>{if(!this.d)return;const z=this.d.getSize(),K=this.d.getPosition();if(!z||!K)return;const ae={width:z[0],height:z[1],x:K[0],y:K[1]};this.p.setItem(i,ae)};this.d.on("moved",N),this.d.on("resized",N)}this.d&&this.s(this.d)}s(a){a.isMinimized()&&a.restore(),a.focus()}t(a,m,E,M){const T=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:a.width,height:a.height,minWidth:300,minHeight:200,x:a.x,y:a.y,title:E.title,backgroundColor:E.backgroundColor||kt.a,webPreferences:{preload:D.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${m.resource.toString()}`,`--vscode-window-kind=${M}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,v.zoomLevelToZoomFactor)(E.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:E.alwaysOnTop,experimentalDarkMode:!0});return T.setMenuBarVisibility(!1),T}async getSystemStatus(){const[a,m]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(a,m)}u(a,m,E){let M;const T=P.screen.getAllDisplays();if(T.length===1)M=T[0];else{if(k.isMacintosh){const K=P.screen.getCursorScreenPoint();M=P.screen.getDisplayNearestPoint(K)}!M&&a&&(M=P.screen.getDisplayMatching(a.getBounds())),M||(M=P.screen.getPrimaryDisplay()||T[0])}const N=M.bounds,z={width:m,height:E,x:N.x+N.width/2-m/2,y:N.y+N.height/2-E/2};return N.width>0&&N.height>0&&(z.x<N.x&&(z.x=N.x),z.y<N.y&&(z.y=N.y),z.x>N.x+N.width&&(z.x=N.x),z.y>N.y+N.height&&(z.y=N.y),z.width>N.width&&(z.width=N.width),z.height>N.height&&(z.height=N.height)),z}async v(){try{const[a,m]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(a,m)}catch(a){throw this.i.warn("issueService#getPerformanceInfo ",a.message),a}}async stopTracing(){if(!this.h.args.trace)return;const a=await P.contentTracing.stopRecording(`${(0,C.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,d.localize)(9,null),detail:(0,d.localize)(10,null,a),buttons:[(0,d.localize)(11,null)]},(0,t.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,a)}};o.a="#1E1E1E",o=ye([ee(1,u.IEnvironmentMainService),ee(2,S.ILogService),ee(3,y.IDiagnosticsService),ee(4,b.IDiagnosticsMainService),ee(5,I.IDialogMainService),ee(6,s.INativeHostMainService),ee(7,p.IProtocolMainService),ee(8,f.IProductService),ee(9,c.IStateService)],o),e.IssueMainService=o;function r(l){return typeof l!="object"||l===null?!1:"x"in l&&"y"in l&&"width"in l&&"height"in l}}),define(ie[278],se([0,1,22,19,28,20,5,58,21,52,24,49,93]),function(X,e,P,A,n,R,D,k,g,d,y,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let u=class extends I.AbstractUpdateService{constructor(S,s,h,f,p,v,C,t){super(S,s,f,p,v,t),this.e=h,this.t=C}r(S){return(0,I.createUpdateURL)(`linux-${process.arch}`,S,this.k)}s(S){!this.a||(this.d(b.State.CheckingForUpdates(S)),this.i.request({url:this.a},P.CancellationToken.None).then(d.asJson).then(s=>{!s||!s.url||!s.version||!s.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!S}),this.d(b.State.Idle(1))):this.d(b.State.AvailableForDownload(s))}).then(void 0,s=>{this.j.error(s),this.e.publicLog2("update:notAvailable",{explicit:!!S});const h=S?s.message||s:void 0;this.d(b.State.Idle(1,h))}))}async n(S){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.t.openExternal(void 0,this.k.downloadUrl):S.update.url&&this.t.openExternal(void 0,S.update.url),this.d(b.State.Idle(1))}};u=ye([ee(0,R.ILifecycleMainService),ee(1,A.IConfigurationService),ee(2,y.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,D.ILogService),ee(6,k.INativeHostMainService),ee(7,g.IProductService)],u),e.LinuxUpdateService=u}),define(ie[279],se([0,1,46,41,27,7,22,55,9,8,136,23,19,28,16,20,5,58,21,52,24,49,93]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p,v,C,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function c(l,a=1e3){for(;!l();)await(0,R.timeout)(a)}let i;function o(){return typeof i>"u"&&(i=A.existsSync(g.join(g.dirname(process.execPath),"unins000.exe"))?0:1),i}let r=class extends t.AbstractUpdateService{get cachePath(){const a=g.join((0,n.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return b.Promises.mkdir(a,{recursive:!0}).then(()=>a)}constructor(a,m,E,M,T,N,z,K,ae){super(a,m,M,T,N,ae),this.t=E,this.u=z,this.v=K}async initialize(){if(this.k.target==="user"&&await this.v.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}r(a){let m="win32";return process.arch!=="ia32"&&(m+=`-${process.arch}`),o()===1?m+="-archive":this.k.target==="user"&&(m+="-user"),(0,t.createUpdateURL)(m,a,this.k)}s(a){!this.a||(this.d(C.State.CheckingForUpdates(a)),this.i.request({url:this.a},D.CancellationToken.None).then(p.asJson).then(m=>{const E=o();return!m||!m.url||!m.version||!m.productVersion?(this.t.publicLog2("update:notAvailable",{explicit:!!a}),this.d(C.State.Idle(E)),Promise.resolve(null)):E===1?(this.d(C.State.AvailableForDownload(m)),Promise.resolve(null)):(this.d(C.State.Downloading(m)),this.A(m.version).then(()=>this.z(m.version).then(M=>b.Promises.exists(M).then(T=>{if(T)return Promise.resolve(M);const N=m.url,z=m.hash,K=`${M}.tmp`;return this.i.request({url:N},D.CancellationToken.None).then(ae=>this.u.writeFile(d.URI.file(K),ae.stream)).then(z?()=>(0,y.checksum)(K,m.hash):()=>{}).then(()=>b.Promises.rename(K,M)).then(()=>M)})).then(M=>{const T=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:M},T&&m.supportsFastUpdate?this.k.target==="user"?this.o():this.d(C.State.Downloaded(m)):this.d(C.State.Ready(m))})))}).then(void 0,m=>{this.j.error(m),this.t.publicLog2("update:notAvailable",{explicit:!!a});const E=a?m.message||m:void 0;this.d(C.State.Idle(o(),E))}))}async n(a){a.update.url&&this.v.openExternal(void 0,a.update.url),this.d(C.State.Idle(o()))}async z(a){const m=await this.cachePath;return g.join(m,`CodeSetup-${this.k.quality}-${a}.exe`)}async A(a=null){const m=a?N=>!new RegExp(`${this.k.quality}-${a}\\.exe$`).test(N):()=>!0,E=await this.cachePath,T=(await b.Promises.readdir(E)).filter(m).map(async N=>{try{await b.Promises.unlink(g.join(E,N))}catch{}});await Promise.all(T)}async o(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const a=this.state.update;this.d(C.State.Updating(a));const m=await this.cachePath;this.e.updateFilePath=g.join(m,`CodeSetup-${this.k.quality}-${a.version}.flag`),await b.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(C.State.Idle(o()))});const M=`${this.k.win32MutexName}-ready`,T=await new Promise((N,z)=>{X(["windows-mutex"],N,z)});c(()=>T.isActive(M)).then(()=>this.d(C.State.Ready(a)))}q(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?A.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}p(){return o()}async _applySpecificUpdate(a){if(this.state.type!=="idle")return;const m=this.g.getValue("update.enableWindowsBackgroundUpdates"),E={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!m};this.d(C.State.Downloading(E)),this.e={packagePath:a},m?this.k.target==="user"?this.o():this.d(C.State.Downloaded(E)):this.d(C.State.Ready(E))}};ye([k.memoize],r.prototype,"cachePath",null),r=ye([ee(0,S.ILifecycleMainService),ee(1,I.IConfigurationService),ee(2,v.ITelemetryService),ee(3,u.IEnvironmentMainService),ee(4,p.IRequestService),ee(5,s.ILogService),ee(6,w.IFileService),ee(7,h.INativeHostMainService),ee(8,f.IProductService)],r),e.Win32UpdateService=r}),define(ie[280],se([0,1,15,7,22,44,3,2,14,9,64,4,8,181,63,19,57,28,62,16,20,5,21,67,242,96,24,135,69,77,30,29,54,122,126,38,33,53,58,244,118,48,92,27,119,65]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p,v,C,t,c,i,o,r,l,a,m,E,M,T,N,z,K,ae,le,te,F,$,V,x,H,O,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var _;(function(oe){oe[oe.NONE=0]="NONE",oe[oe.NAVIGATING=1]="NAVIGATING",oe[oe.READY=2]="READY"})(_||(_={}));let re=class ot extends k.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get isSandboxed(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const L=this.Q.profiles.find(W=>W.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.Q.getProfileForWorkspace(this.config.workspace??(0,M.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.Q.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(L,W,U,j,q,J,B,Y,Z,ce,fe,De,Re,Ce,Oe,$e,ge,pe,Le,ne,he){super(),this.M=W,this.N=U,this.O=j,this.P=q,this.Q=J,this.R=B,this.S=Y,this.U=Z,this.W=ce,this.X=fe,this.Y=De,this.Z=Re,this.ab=Ce,this.bb=Oe,this.db=$e,this.eb=ge,this.fb=pe,this.gb=Le,this.hb=ne,this.ib=he,this.c=this.B(new D.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new D.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new D.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new D.Emitter),this.onDidClose=this.h.event,this.j=this.B(new D.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.n=!1,this.u=void 0,this.v=void 0,this.C=!1,this.D=[],this.F=[],this.G=void 0,this.H=void 0,this.I=this.B(this.fb.createIPCObjectUrl()),this.L=!1,this.jb=0;let de=!1;{const[Ie,Me]=this.ub(L.state);this.s=Ie,this.M.trace("window#ctor: using window state",Ie);const Te=this.s.mode===0||this.s.mode===3;typeof ot.b>"u"&&(ot.b=this.hb.getItem("window.experimental.useSandbox",!1));const Fe=this.W.getValue("window");typeof Fe?.experimental?.useSandbox=="boolean"?de=Fe.experimental.useSandbox:this.eb.quality==="stable"&&ot.b?de=!0:de=typeof this.eb.quality=="string"&&this.eb.quality!=="stable",this.n=de;const je={width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y,backgroundColor:this.X.getBackgroundColor(),minWidth:m.WindowMinimumSize.WIDTH,minHeight:m.WindowMinimumSize.HEIGHT,show:!Te,title:this.eb.nameLong,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.I.resource.toString()}`],v8CacheOptions:this.O.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,m.zoomLevelToZoomFactor)(Fe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...de?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};b.isLinux?je.icon=(0,d.join)(this.O.appRoot,"resources/linux/code.png"):b.isWindows&&!this.O.isBuilt&&(je.icon=(0,d.join)(this.O.appRoot,"resources/win32/code_150x150.png")),b.isMacintosh&&!this.Bb()&&(je.fullscreenable=!1),b.isMacintosh&&(je.acceptFirstMouse=!0,Fe?.clickThroughInactive===!1&&(je.acceptFirstMouse=!1));const ze=b.isMacintosh&&Fe?.nativeTabs===!0;ze&&(je.tabbingIdentifier=this.eb.nameShort);const We=(0,m.getTitleBarStyle)(this.W)==="custom";if(We&&(je.titleBarStyle="hidden",b.isMacintosh||(je.frame=!1),(0,m.useWindowControlsOverlay)(this.W))){const He=this.X.getWindowSplash()?.colorInfo.titleBarBackground??this.X.getBackgroundColor(),Q=z.Color.fromHex(He).isDarker()?"#FFFFFF":"#000000";je.titleBarOverlay={height:29,color:He,symbolColor:Q},this.C=!0}if((0,y.mark)("code/willCreateCodeBrowserWindow"),this.l=new P.BrowserWindow(je),(0,y.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,b.isMacintosh&&We&&this.l.setSheetOffset(22),We&&(b.isWindows&&(0,m.useWindowControlsOverlay)(this.W)||b.isMacintosh)){const He=this.hb.getItem(ot.a);He&&this.updateWindowControls({height:He})}b.isWindows&&We&&this.l.hookWindowMessage(278,()=>{const[Q,ue]=this.l.getPosition(),me=P.screen.getCursorScreenPoint(),be=me.x-Q,we=me.y-ue;return(()=>!(be>30&&we>=0&&we<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:be,y:we})),0}),(b.isMacintosh||b.isWindows)&&Me&&(!ze||P.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(He=>typeof He=="number")&&this.l.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),Te&&((0,y.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.s.mode===3&&this.xb(!0),this.l.show(),(0,y.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.O.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.rb(),this.Fb(),this.kb(de)}setRepresentedFilename(L){b.isMacintosh?this.l.setRepresentedFilename(L):this.w=L}getRepresentedFilename(){return b.isMacintosh?this.l.getRepresentedFilename():this.w}setDocumentEdited(L){b.isMacintosh&&this.l.setDocumentEdited(L),this.z=L}isDocumentEdited(){return b.isMacintosh?this.l.isDocumentEdited():!!this.z}focus(L){b.isMacintosh&&L?.force&&P.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.M.trace(`window#load: window reported ready (id: ${this.k})`),this.jb=2;this.D.length;)this.D.pop()(this);this.f.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.D.push(L)})}get isReady(){return this.jb===2}get whenClosedOrLoaded(){return new Promise(L=>{function W(){U.dispose(),j.dispose(),L()}const U=this.onDidClose(()=>W()),j=this.onWillLoad(()=>W())})}kb(L){this.l.on("unresponsive",()=>this.nb(1,{sandboxed:L})),this.l.webContents.on("render-process-gone",(U,j)=>this.nb(2,{...j,sandboxed:L})),this.l.webContents.on("did-fail-load",(U,j,q)=>this.nb(3,{reason:q,exitCode:j,sandboxed:L})),this.l.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.J&&(this.r=this.J,this.J=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",U=>{this.r&&(this.r.maximized=!0),P.app.emit("browser-window-maximize",U,this.l)}),this.l.on("unmaximize",U=>{this.r&&(this.r.maximized=!1),P.app.emit("browser-window-unmaximize",U,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",n.CancellationToken.None),this.v?.complete(),this.v=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",n.CancellationToken.None),this.v?.complete(),this.v=void 0}),this.B(this.W.onDidChangeConfiguration(U=>this.rb(U))),this.B(this.Y.onDidDeleteUntitledWorkspace(U=>this.qb(U)));const W=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:W},async(U,j)=>{const q=await this.mb();j({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,q)})})}mb(){return this.lb||(this.lb=(0,i.resolveMarketplaceHeaders)(this.eb.version,this.eb,this.O,this.W,this.R,this.S,this.ab)),this.lb}async nb(L,W){switch(L){case 2:this.M.error(`CodeWindow: renderer process gone (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.M.error("CodeWindow: detected unresponsive");break;case 3:this.M.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:L,reason:W?.reason,code:W?.exitCode,sandboxed:W?.sandboxed?"1":"0"}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.O.args["enable-smoke-test-driver"]){await this.pb(!1,!1),this.db.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const{response:U,checkboxChecked:j}=await this.bb.showMessageBox({type:"warning",buttons:[(0,u.localize)(0,null),(0,u.localize)(1,null),(0,u.localize)(2,null)],message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null),checkboxLabel:this.r?.workspace?(0,u.localize)(5,null):void 0},this.l);if(U!==2){const q=U===0;await this.pb(q,j)}}else if(L===2)if(b.isWindows&&W?.reason==="launch-failed"&&W.exitCode===18&&await this.ib.isAdmin(void 0))await this.ob(W);else{let U;W?U=(0,u.localize)(7,null,W.reason,W.exitCode??"<unknown>"):U=(0,u.localize)(6,null);const{response:j,checkboxChecked:q}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,u.localize)(8,null):(0,u.localize)(9,null),(0,u.localize)(10,null)],message:U,detail:this.r?.workspace?(0,u.localize)(11,null):(0,u.localize)(12,null),checkboxLabel:this.r?.workspace?(0,u.localize)(13,null):void 0},this.l),J=j===0;await this.pb(J,q)}break}}async ob(L){const W=[],U=(0,V.isInternalTelemetry)(this.eb,this.W);if((0,V.supportsTelemetry)(this.eb,this.O)){this.eb.aiConfig&&this.eb.aiConfig.ariaKey&&W.push(new F.OneDataSystemAppender(U,"monacoworkbench",null,this.eb.aiConfig.ariaKey));const{installSourcePath:q}=this.O,J=await(0,O.resolveMachineId)(this.hb),B={appenders:W,sendErrorTelemetry:!1,commonProperties:(0,x.resolveCommonProperties)(this.R,(0,H.release)(),(0,H.hostname)(),process.arch,this.eb.commit,this.eb.version,J,U,q),piiPaths:(0,V.getPiiPathsFromEnvironment)(this.O)};await new $.TelemetryService(B,this.W,this.eb).publicLog2("windowadminerror",{reason:L.reason,code:L.exitCode})}const{response:j}=await this.bb.showMessageBox({type:"error",buttons:[(0,u.localize)(14,null),(0,u.localize)(15,null)],message:(0,u.localize)(16,null),detail:(0,u.localize)(17,null,this.eb.nameLong)},this.l);j===0&&await this.ib.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(W.map(q=>q.flush())),await this.pb(!1,!1)}async pb(L,W){const U=this.r?.workspace;if(W&&U)try{const j=this.U.workspaceStorage(U);await j.init(),j.delete("memento/workbench.parts.editor"),await j.close()}catch(j){this.M.error(j)}if(this.j.fire(),this.l?.destroy(),L&&this.r){let j,q;(0,M.isSingleFolderWorkspaceIdentifier)(U)?j={folderUri:U.uri}:(0,M.isWorkspaceIdentifier)(U)?j={workspaceUri:U.configPath}:q=!0;const[J]=await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.O.args,_:[]},urisToOpen:j?[j]:void 0,forceEmpty:q,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});J.focus()}}qb(L){this.r?.workspace?.id===L.id&&(this.r.workspace=void 0)}rb(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const W=this.Cb();W!==this.t&&(this.t=W,this.Db(W))}if(!L||L.affectsConfiguration("http.proxy")){let W=(this.W.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;W?.endsWith("/")&&(W=W.substr(0,W.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((W||"").indexOf("@")===-1&&(W!==this.G||U!==this.H)){this.G=W,this.H=U;const j=W||"",q=U?`${U},<local>`:"<local>";this.M.trace(`Setting proxy to '${j}', bypassing '${q}'`),this.l.webContents.session.setProxy({proxyRules:j,proxyBypassRules:q,pacScript:""})}}}addTabbedWindow(L){b.isMacintosh&&L.win&&this.l.addTabbedWindow(L.win)}load(L,W=Object.create(null)){this.M.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!W.isReload||!this.Z.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.eb.nameLong)),this.sb(L,W),this.jb===0?this.r=L:this.J=L,this.jb=1,this.l.loadURL(g.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.O.isBuilt?"":"-dev"}.html`).toString(!0));const U=this.L;this.L=!0,!this.O.isBuilt&&!this.O.extensionTestsLocationURI&&this.B(new A.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:L.workspace,reason:W.isReload?3:U?2:1})}sb(L,W){const U=(this.r??this.J)?.userEnv;if(U){const j=(0,f.isLaunchedFromCli)(U)&&!(0,f.isLaunchedFromCli)(L.userEnv),q=this.isExtensionDevelopmentHost;(j||q)&&(L.userEnv={...U,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(L["disable-extensions"]=W.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.l.isMaximized(),L.partsSplash=this.X.getWindowSplash(),(0,y.mark)("code/willOpenNewWindow"),L.perfMarks=(0,y.getMarks)(),this.I.update(L)}async reload(L){const W=Object.assign({},this.r);W.workspace=await this.tb(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&L&&(W.verbose=L.verbose,W.debugId=L.debugId,W.extensionEnvironment=L.extensionEnvironment,W["inspect-extensions"]=L["inspect-extensions"],W["inspect-brk-extensions"]=L["inspect-brk-extensions"],W["extensions-dir"]=L["extensions-dir"]),W.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),W.isInitialStartup=!1,W.policiesData=this.P.serialize(),W.continueOn=this.O.continueOn,W.profiles={all:this.Q.profiles,profile:this.profile||this.Q.defaultProfile,home:this.Q.profilesHome},W.logLevel=this.N.getLogLevel(),W.loggers={window:this.N.getRegisteredLoggers(this.id),global:this.N.getRegisteredLoggers()},this.load(W,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async tb(L){if((0,M.isWorkspaceIdentifier)(L.workspace)){const W=L.workspace.configPath;if(W.scheme===g.Schemas.file&&!await this.R.exists(W))return}else if((0,M.isSingleFolderWorkspaceIdentifier)(L.workspace)){const W=L.workspace.uri;if(W.scheme===g.Schemas.file&&!await this.R.exists(W))return}return L.workspace}serializeWindowState(){if(!this.l)return(0,N.defaultWindowState)();if(this.isFullScreen){let U;try{U=P.screen.getDisplayMatching(this.getBounds())}catch{}const j=(0,N.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.s.width||j.width,height:this.s.height||j.height,x:this.s.x||0,y:this.s.y||0}}const L=Object.create(null);let W;if(!b.isMacintosh&&this.l.isMaximized()?W=0:W=1,W===0?L.mode=0:L.mode=1,W===1||W===0){let U;W===1?U=this.getBounds():U=this.l.getNormalBounds(),L.x=U.x,L.y=U.y,L.width=U.width,L.height=U.height}return L}updateWindowControls(L){if(L.height&&this.hb.setItem(ot.a,L.height),b.isWindows&&this.C)this.l.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(b.isMacintosh&&L.height!==void 0){const W=(L.height-15)/2;this.l.setTrafficLightPosition({x:W,y:W})}}ub(L){(0,y.mark)("code/willRestoreCodeWindowState");let W=!1;if(L)try{const U=P.screen.getAllDisplays();W=U.length>1,L=this.vb(L,U)}catch(U){this.M.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,y.mark)("code/didRestoreCodeWindowState"),[L||(0,N.defaultWindowState)(),W]}vb(L,W){if(this.M.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,L),typeof L.x!="number"||typeof L.y!="number"||typeof L.width!="number"||typeof L.height!="number"){this.M.trace("window#validateWindowState: unexpected type of state values");return}if(L.width<=0||L.height<=0){this.M.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const q=this.wb(W[0]);if(q){let J=function(){!L||typeof L.x!="number"||typeof L.y!="number"||!q||(L.x<q.x&&(L.x=q.x),L.y<q.y&&(L.y=q.y))};this.M.trace("window#validateWindowState: 1 monitor working area",q),J(),L.width>q.width&&(L.width=q.width),L.height>q.height&&(L.height=q.height),L.x>q.x+q.width-128&&(L.x=q.x+q.width-L.width),L.y>q.y+q.height-128&&(L.y=q.y+q.height-L.height),J()}return L}if(L.display&&L.mode===3){const q=W.find(J=>J.id===L.display);if(q&&typeof q.bounds?.x=="number"&&typeof q.bounds?.y=="number"){this.M.trace("window#validateWindowState: restoring fullscreen to previous display");const J=(0,N.defaultWindowState)(3);return J.x=q.bounds.x,J.y=q.bounds.y,J}}let U,j;try{U=P.screen.getDisplayMatching({x:L.x,y:L.y,width:L.width,height:L.height}),j=this.wb(U)}catch{}if(U&&j&&L.x+L.width>j.x&&L.y+L.height>j.y&&L.x<j.x+j.width&&L.y<j.y+j.height)return this.M.trace("window#validateWindowState: multi-monitor working area",j),L}wb(L){if(L.workArea.width>0&&L.workArea.height>0)return L.workArea;if(L.bounds.width>0&&L.bounds.height>0)return L.bounds}getBounds(){const[L,W]=this.l.getPosition(),[U,j]=this.l.getSize();return{x:L,y:W,width:U,height:j}}toggleFullScreen(){this.xb(!this.isFullScreen)}xb(L){this.Bb()?this.yb(L):this.Ab(L),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",n.CancellationToken.None),this.t&&this.Db(this.t,!1)}get isFullScreen(){return b.isMacintosh&&typeof this.u=="boolean"?this.u:this.l.isFullScreen()||this.l.isSimpleFullScreen()}yb(L){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.zb(L)}zb(L){b.isMacintosh&&(this.u=L,this.v=new A.DeferredPromise,Promise.race([this.v.p,(0,A.timeout)(1e3)]).finally(()=>this.u=void 0)),this.l.setFullScreen(L)}Ab(L){this.l.isFullScreen()&&this.zb(!1),this.l.setSimpleFullScreen(L),this.l.webContents.focus()}Bb(){const L=this.W.getValue("window");return!L||typeof L.nativeFullScreen!="boolean"||L.nativeTabs?!0:L.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Cb(){let L=(0,m.getMenuBarVisibility)(this.W);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Db(L,W=!0){b.isMacintosh||(L==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,u.localize)(18,null)),L==="hidden"?setTimeout(()=>{this.Eb(L)}):this.Eb(L))}Eb(L){const W=this.isFullScreen;switch(L){case"classic":this.l.setMenuBarVisibility(!W),this.l.autoHideMenuBar=W;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.isMacintosh)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(L,W,...U){this.isReady?this.send(L,...U):this.ready().then(()=>{W.isCancellationRequested||this.send(L,...U)})}send(L,...W){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.M.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.l.webContents.send(L,...W)}catch(U){this.M.warn(`Error sending IPC message to channel '${L}' of window ${this.k}: ${(0,R.toErrorMessage)(U)}`)}}}updateTouchBar(L){!b.isMacintosh||this.F.forEach((W,U)=>{const j=L[U];W.segments=this.Hb(j)})}Fb(){if(!!b.isMacintosh){for(let L=0;L<10;L++){const W=this.Gb();this.F.push(W)}this.l.setTouchBar(new P.TouchBar({items:this.F}))}}Gb(L=[]){const W=this.Hb(L),U=new P.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:j=>{this.sendWhenReady("vscode:runAction",n.CancellationToken.None,{id:U.segments[j].id,from:"touchbar"})}});return U}Hb(L=[]){return L.map(U=>{let j;U.icon&&!l.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===g.Schemas.file&&(j=P.nativeImage.createFromPath(I.URI.revive(U.icon.dark).fsPath),j.isEmpty()&&(j=void 0));let q;return typeof U.title=="string"?q=U.title:q=U.title.value,{id:U.id,label:j?void 0:q,icon:j}})}dispose(){super.dispose(),this.N.deregisterLoggers(this.id),this.l=null}};re.a="windowControlHeight",re.b=void 0,re=ye([ee(1,C.ILogService),ee(2,G.ILoggerMainService),ee(3,h.IEnvironmentMainService),ee(4,K.IPolicyService),ee(5,le.IUserDataProfilesMainService),ee(6,p.IFileService),ee(7,o.IApplicationStorageMainService),ee(8,o.IStorageMainService),ee(9,S.IConfigurationService),ee(10,a.IThemeMainService),ee(11,T.IWorkspacesManagementMainService),ee(12,w.IBackupMainService),ee(13,r.ITelemetryService),ee(14,s.IDialogMainService),ee(15,v.ILifecycleMainService),ee(16,t.IProductService),ee(17,c.IProtocolMainService),ee(18,E.IWindowsMainService),ee(19,ae.IStateService),ee(20,te.INativeHostMainService)],re),e.CodeWindow=re}),define(ie[79],se([0,1,15,26,7,3,45,2,14,4,18,8,23,184,6,20,5,96,97,29,54,35]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,w.createDecorator)("workspacesHistoryMainService");let t=class tt extends k.Disposable{constructor(i,o,r,l){super(),this.f=i,this.g=o,this.h=r,this.j=l,this.c=this.B(new R.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new n.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let o=[],r=[];for(const a of i)if((0,f.isRecentWorkspace)(a))!this.g.isUntitledWorkspace(a.workspace)&&!this.r(o,a.workspace)&&o.push(a);else if((0,f.isRecentFolder)(a))this.s(o,a.folderUri)||o.push(a);else{const m=this.t(r,a.fileUri),E=a.fileUri.scheme===g.Schemas.file&&tt.y.indexOf((0,y.basename)(a.fileUri))>=0;!m&&!E&&(r.push(a),d.isWindows&&a.fileUri.scheme===g.Schemas.file&&P.app.addRecentDocument(a.fileUri.fsPath))}const l=await this.l({workspaces:o,files:r});o=l.workspaces,r=l.files,o.length>tt.a&&(o.length=tt.a),r.length>tt.a&&(r.length=tt.a),await this.n({workspaces:o,files:r}),this.c.fire(),d.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const o=m=>{const E=this.p(m);for(const M of i)if(y.extUriBiasedIgnorePathCase.isEqual(M,E))return!1;return!0},r=await this.getRecentlyOpened(),l=r.workspaces.filter(o),a=r.files.filter(o);(l.length!==r.workspaces.length||a.length!==r.files.length)&&(await this.n({files:a,workspaces:l}),this.c.fire(),d.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const o=new C.ResourceMap(a=>y.extUriBiasedIgnorePathCase.getComparisonKey(a));if(i?.workspaces)for(const a of i.workspaces)o.set(this.p(a),a);const r=new C.ResourceMap(a=>y.extUriBiasedIgnorePathCase.getComparisonKey(a));if(i?.files)for(const a of i.files)r.set(this.p(a),a);const l=await this.m();for(const a of l.workspaces){const m=o.get(this.p(a));m?m.label=m.label??a.label:o.set(this.p(a),a)}for(const a of l.files){const m=r.get(this.p(a));m?m.label=m.label??a.label:r.set(this.p(a),a)}return{workspaces:[...o.values()],files:[...r.values()]}}async m(){await this.j.whenReady;let i;const o=this.j.get(tt.b,-1);if(typeof o=="string")try{i=JSON.parse(o)}catch(r){this.f.error("Unexpected error parsing opened paths list",r)}return(0,f.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(tt.b,JSON.stringify((0,f.toStoreData)(i)),-1,1)}p(i){return(0,f.isRecentFolder)(i)?i.folderUri:(0,f.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,o){return!!i.find(r=>(0,f.isRecentWorkspace)(r)&&r.workspace.id===o.id)}s(i,o){return!!i.find(r=>(0,f.isRecentFolder)(r)&&y.extUriBiasedIgnorePathCase.isEqual(r.folderUri,o))}t(i,o){return!!i.find(r=>y.extUriBiasedIgnorePathCase.isEqual(r.fileUri,o))}async C(){!d.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!d.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(0,null),description:(0,u.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const o=[];for(const a of P.app.getJumpListSettings().removedItems){const m=a.args;if(m){const E=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(m);E&&o.push(b.URI.parse(E[2]))}}await this.removeRecentlyOpened(o);let r=!1;const l=(0,A.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.w).map(a=>{const m=(0,f.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:E,description:M}=this.F(m,a.label);let T;return b.URI.isUri(m)?T=`--folder-uri "${m.toString()}"`:(r=!0,T=`--file-uri "${m.configPath.toString()}"`),{type:"task",title:E.substr(0,255),description:M.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));l.length>0&&i.push({type:"custom",name:r?(0,u.localize)(2,null):(0,u.localize)(3,null),items:l})}i.push({type:"recent"});try{const o=P.app.setJumpList(i);o&&o!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${o}`)}catch(o){this.f.warn("updateWindowsJumpList#setJumpList",o)}}F(i,o){if(o)return{title:(0,D.splitName)(o).name,description:o};if(b.URI.isUri(i))return{title:(0,y.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,u.localize)(4,null),description:""};let r=(0,y.basename)(i.configPath);return r.endsWith(p.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-p.WORKSPACE_EXTENSION.length-1)),{title:(0,u.localize)(5,null,r),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,D.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!d.isMacintosh)return;P.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),o=[];let r=0;for(let a=0;a<i.workspaces.length&&r<tt.u;a++){const m=this.p(i.workspaces[a]);if(m.scheme===g.Schemas.file){const E=(0,y.originalFSPath)(m);await I.Promises.exists(E)&&(o.push(E),r++)}}const l=[];for(let a=0;a<i.files.length&&r<tt.v;a++){const m=this.p(i.files[a]);if(m.scheme===g.Schemas.file){const E=(0,y.originalFSPath)(m);if(tt.y.includes((0,y.basename)(m))||o.includes(E))continue;await I.Promises.exists(E)&&(l.push(E),r++)}}l.reverse().forEach(a=>P.app.addRecentDocument(a)),o.reverse().forEach(a=>P.app.addRecentDocument(a))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.u=7,t.v=10,t.w=7,t.y=["COMMIT_EDITMSG","MERGE_MSG"],t=ye([ee(0,s.ILogService),ee(1,v.IWorkspacesManagementMainService),ee(2,S.ILifecycleMainService),ee(3,h.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(ie[281],se([0,1,15,7,22,45,4,8,174,19,28,20,5,222,58,21,33,24,49,77,30,79]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let c=class bt{constructor(r,l,a,m,E,M,T,N,z,K,ae){this.n=r,this.o=l,this.p=a,this.q=m,this.r=E,this.s=M,this.t=T,this.u=N,this.v=z,this.w=K,this.x=ae,this.m=Object.create(null),this.g=new A.RunOnceScheduler(()=>this.E(),0),this.h=new A.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.isMacintosh||(0,p.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const r=this.t.getItem(bt.a);r&&(r.menus&&(this.k=r.menus),r.keybindings&&(this.l=r.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(M,T,N)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.newWindow"]=(M,T,N)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(M,T,N)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(M,T,N)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(M,T,N)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const r=this.x.twitterUrl;r&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(r,"openTwitterUrl"));const l=this.x.requestFeatureUrl;l&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(l,"openUserVoiceUrl"));const a=this.x.reportIssueUrl;a&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(a,"openReportIssues"));const m=this.x.licenseUrl;m&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.language){const M=m.indexOf("?")>0?"&":"?";this.Z(`${m}${M}lang=${D.language}`,"openLicenseUrl")}else this.Z(m,"openLicenseUrl")});const E=this.x.privacyStatementUrl;E&&m&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(E,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(r=>this.F(r)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const r=this.o.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get C(){if(!D.isMacintosh)return!1;const r=this.o.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,l){this.k=r.menus,this.l=r.keybindings,this.t.setItem(bt.a,r),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(r){!D.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.d=r.newCount===0,this.D())}G(){!D.isMacintosh||(this.f=!P.BrowserWindow.getFocusedWindow(),this.D())}H(){const r=P.Menu.getApplicationMenu();if(r&&this.j.push(r),Object.keys(this.k).length===0){P.Menu.setApplicationMenu(D.isMacintosh?new P.Menu:null);return}const l=new P.Menu;let a;if(D.isMacintosh){const E=new P.Menu;a=new P.MenuItem({label:this.x.nameShort,submenu:E}),this.I(E),l.append(a)}if(D.isMacintosh&&!this.c){this.c=!0;const E=new P.Menu;E.append(new P.MenuItem({label:this.bb(g.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(E)}if(this.K("File")){const E=new P.Menu,M=new P.MenuItem({label:this.bb(g.localize(1,null)),submenu:E});this.M(E,"File"),l.append(M)}if(this.K("Edit")){const E=new P.Menu,M=new P.MenuItem({label:this.bb(g.localize(2,null)),submenu:E});this.M(E,"Edit"),l.append(M)}if(this.K("Selection")){const E=new P.Menu,M=new P.MenuItem({label:this.bb(g.localize(3,null)),submenu:E});this.M(E,"Selection"),l.append(M)}if(this.K("View")){const E=new P.Menu,M=new P.MenuItem({label:this.bb(g.localize(4,null)),submenu:E});this.M(E,"View"),l.append(M)}if(this.K("Go")){const E=new P.Menu,M=new P.MenuItem({label:this.bb(g.localize(5,null)),submenu:E});this.M(E,"Go"),l.append(M)}if(this.K("Run")){const E=new P.Menu,M=new P.MenuItem({label:this.bb(g.localize(6,null)),submenu:E});this.M(E,"Run"),l.append(M)}if(this.K("Terminal")){const E=new P.Menu,M=new P.MenuItem({label:this.bb(g.localize(7,null)),submenu:E});this.M(E,"Terminal"),l.append(M)}let m;if(this.K("Window")){const E=new P.Menu;m=new P.MenuItem({label:this.bb(g.localize(8,null)),submenu:E,role:"window"}),this.S(E)}if(m&&l.append(m),this.K("Help")){const E=new P.Menu,M=new P.MenuItem({label:this.bb(g.localize(9,null)),submenu:E,role:"help"});this.M(E,"Help"),l.append(M)}l.items&&l.items.length>0?P.Menu.setApplicationMenu(l):P.Menu.setApplicationMenu(null),this.h.schedule()}I(r){const l=this.U(g.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),a=this.T();let m;if(this.K("Preferences")){const le=new P.Menu;this.M(le,"Preferences"),m=new P.MenuItem({label:this.bb(g.localize(11,null)),submenu:le})}const E=new P.Menu,M=new P.MenuItem({label:g.localize(12,null),role:"services",submenu:E}),T=new P.MenuItem({label:g.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),N=new P.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new P.MenuItem({label:g.localize(15,null),role:"unhide"}),K=new P.MenuItem(this.Y("workbench.action.quit",{label:g.localize(16,null,this.x.nameLong),click:async(le,te,F)=>{const $=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!P.BrowserWindow.getFocusedWindow()||$?.isMinimized())&&await this.J(F)&&this.w.quit(void 0)}})),ae=[l];ae.push(...a),m&&ae.push(i(),m),ae.push(i(),M,i(),T,N,z,i(),K),ae.forEach(le=>r.append(le))}async J(r){if(this.p.getWindowCount()===0)return!0;const l=this.o.getValue("window.confirmBeforeClose");if(l==="always"||l==="keyboardOnly"&&this.Q(r)){const{response:a}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[g.localize(17,null),g.localize(18,null)],message:g.localize(19,null)});return a===0}return!0}K(r){if(!D.isMacintosh&&(0,p.getTitleBarStyle)(this.o)==="custom")return!1;switch(r){case"File":case"Help":if(D.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[r];case"Window":if(D.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[r]}}L(r,l){l.forEach(a=>{if((0,u.isMenubarMenuItemSeparator)(a))r.append(i());else if((0,u.isMenubarMenuItemSubmenu)(a)){const m=new P.Menu,E=new P.MenuItem({label:this.bb(a.label),submenu:m});this.L(m,a.submenu.items),r.append(E)}else(0,u.isMenubarMenuItemRecentAction)(a)?r.append(this.O(a)):(0,u.isMenubarMenuItemAction)(a)&&(a.id==="workbench.action.showAboutDialog"&&this.N(r),D.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[a.id]?r.append(new P.MenuItem(this.Y(a.id,{label:this.bb(a.label),click:this.m[a.id]}))):r.append(this.U(a.label,a.id,!1,a.checked)):r.append(this.U(a.label,a.id,a.enabled!==!1,!!a.checked)):r.append(this.U(a.label,a.id,a.enabled!==!1,!!a.checked)))})}M(r,l){this.k&&this.k[l]&&this.L(r,this.k[l].items)}N(r){const l=this.T();l.length&&(l.forEach(a=>r.append(a)),r.append(i()))}O(r){const l=k.URI.revive(r.uri),a=r.id,m=a==="openRecentFile"?{fileUri:l}:a==="openRecentWorkspace"?{workspaceUri:l}:{folderUri:l};return new P.MenuItem(this.Y(a,{label:r.label,click:async(E,M,T)=>{const N=this.P(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[m],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:r.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([l])}},!1))}P(r){return!!(r&&(!D.isMacintosh&&(r.ctrlKey||r.shiftKey)||D.isMacintosh&&(r.metaKey||r.altKey)))}Q(r){return!!(r.triggeredByAccelerator||r.altKey||r.ctrlKey||r.metaKey||r.shiftKey)}R(r,l,a){const m={label:this.bb(r),role:a,enabled:!0};return new P.MenuItem(this.X(l,m))}S(r){const l=new P.MenuItem({label:g.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),a=new P.MenuItem({label:g.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),m=new P.MenuItem({label:g.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),E=this.U(g.localize(23,null),"workbench.action.switchWindow"),M=[];this.C&&(M.push(i()),M.push(this.U(g.localize(24,null),"workbench.action.newWindowTab")),M.push(this.R(g.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.R(g.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.R(g.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.R(g.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[l,a,i(),E,...M,i(),m].forEach(T=>r.append(T))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new P.MenuItem({label:this.bb(g.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:g.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.bb(g.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:g.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.bb(g.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:g.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.bb(g.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(r,l,a,m){const E=this.bb(r),M=typeof l=="function"?l:(ae,le,te)=>{const F=ae?ae.userSettingsLabel:null;let $=l;Array.isArray(l)&&($=this.P(te)?l[1]:l[0]),F&&te.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:F}):this.W({type:"commandId",commandId:$})},T=typeof a=="boolean"?a:this.p.getWindowCount()>0,N=typeof m=="boolean"?m:!1,z={label:E,click:M,enabled:T};N&&(z.type="checkbox",z.checked=N);let K;return typeof l=="string"?K=l:Array.isArray(l)&&(K=l[0]),D.isMacintosh&&(K==="editor.action.clipboardCutAction"?z.role="cut":K==="editor.action.clipboardCopyAction"?z.role="copy":K==="editor.action.clipboardPasteAction"&&(z.role="paste"),K==="undo"?z.click=this.V(M,{inDevTools:ae=>ae.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):K==="redo"?z.click=this.V(M,{inDevTools:ae=>ae.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):K==="editor.action.selectAll"&&(z.click=this.V(M,{inDevTools:ae=>ae.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.X(K,z))}V(r,l){return(a,m,E)=>{const M=P.BrowserWindow.getFocusedWindow();if(!M)return l.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return l.inDevTools(M.webContents.devToolsWebContents);r(a,m||M,E)}}W(r){let l=P.BrowserWindow.getFocusedWindow();if(!l){const m=this.p.getLastActiveWindow();m?.isMinimized()&&(l=m.win)}const a=l?this.p.getWindowById(l.id):void 0;if(a){if(this.v.trace("menubar#runActionInRenderer",r),D.isMacintosh&&!this.q.isBuilt&&!a.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const m={id:r.commandId,from:"menu"};a.sendWhenReady("vscode:runAction",n.CancellationToken.None,m)}else{const m={userSettingsLabel:r.userSettingsLabel};a.sendWhenReady("vscode:runKeybinding",n.CancellationToken.None,m)}}else this.v.trace("menubar#runActionInRenderer: no active window found",r)}X(r,l){const a=typeof r=="string"?this.l[r]:void 0;if(a?.label){if(a.isNative!==!1)l.accelerator=a.label,l.userSettingsLabel=a.userSettingsLabel;else if(typeof l.label=="string"){const m=l.label.indexOf("[");m>=0?l.label=`${l.label.substr(0,m)} [${a.label}]`:l.label=`${l.label} [${a.label}]`}}else l.accelerator=void 0;return l}Y(r,l,a=!l.accelerator){a&&(l=this.X(r,l));const m=l.click;return l.click=(E,M,T)=>{this.ab(r),m?.(E,M,T)},l}Z(r,l){this.w.openExternal(void 0,r),this.ab(l)}ab(r){this.r.publicLog2("workbenchActionExecuted",{id:r,from:t})}bb(r){return(0,R.mnemonicMenuLabel)(r,!this.B)}};c.a="lastKnownMenubarData",c=ye([ee(0,f.IUpdateService),ee(1,d.IConfigurationService),ee(2,v.IWindowsMainService),ee(3,y.IEnvironmentMainService),ee(4,h.ITelemetryService),ee(5,C.IWorkspacesHistoryMainService),ee(6,s.IStateService),ee(7,b.ILifecycleMainService),ee(8,I.ILogService),ee(9,w.INativeHostMainService),ee(10,S.IProductService)],c),e.Menubar=c;function i(){return new P.MenuItem({type:"separator"})}}),define(ie[282],se([0,1,6,20,5,281]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,P.createDecorator)("menubarMainService");let D=class{constructor(g,d,y){this.b=g,this.c=d,this.d=y,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.Menubar)}async updateMenubar(g,d){this.d.trace("menubarService#updateMenubar",g),(await this.a).updateMenu(d,g)}};D=ye([ee(0,P.IInstantiationService),ee(1,A.ILifecycleMainService),ee(2,n.ILogService)],D),e.MenubarMainService=D}),define(ie[283],se([0,1,15,23,27,26,22,3,32,50,45,2,14,9,64,4,36,18,10,8,182,63,19,57,28,16,6,20,5,66,67,56,33,77,280,124,275,29,98,79,54,69,38,53,65]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p,v,C,t,c,i,o,r,l,a,m,E,M,T,N,z,K,ae,le,te,F,$,V,x,H,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function G(oe){return(0,le.isWorkspaceIdentifier)(oe?.workspace)}function _(oe){return(0,le.isSingleFolderWorkspaceIdentifier)(oe?.workspace)}let re=class at extends b.Disposable{constructor(L,W,U,j,q,J,B,Y,Z,ce,fe,De,Re,Ce,Oe,$e,ge,pe){super(),this.k=L,this.l=W,this.m=U,this.n=j,this.r=q,this.s=J,this.t=B,this.u=Y,this.v=Z,this.w=ce,this.z=fe,this.C=De,this.D=Re,this.F=Ce,this.G=Oe,this.H=$e,this.I=ge,this.J=pe,this.b=this.B(new k.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new k.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new k.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new k.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ae.WindowsStateHandler(this,this.r,this.v,this.m,this.z)),this.L()}L(){this.B(this.D.onDidEnterWorkspace(L=>this.c.fire(L.window))),this.B(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const W=new b.DisposableStore;if(W.add(k.Event.any(L.onDidClose,L.onDidDestroy)(()=>W.dispose())),L.config.extensionDevelopmentPath)for(const U of L.config.extensionDevelopmentPath)W.add(this.I.addValidFileRoot(U));L.config.extensionTestsPath&&W.add(this.I.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,W){const U=this.t.args,j=W?.remoteAuthority||void 0,q=!0,J=W?.forceReuseWindow,B=!J;return this.open({...L,cli:U,forceEmpty:q,forceNewWindow:B,forceReuseWindow:J,remoteAuthority:j})}openExistingWindow(L,W){L.focus(),this.M(W,[L])}async open(L){this.m.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const W=[],U=[],j=[],q=[],J=[];let B,Y=0;const Z=await this.S(L);this.m.trace("windowsManager#open pathsToOpen",Z);for(const Ce of Z)_(Ce)?L.addMode?W.push(Ce):U.push(Ce):G(Ce)?j.push(Ce):Ce.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ce.remoteAuthority}),B.filesToOpenOrCreate.push(Ce)):Ce.backupPath?J.push({backupFolder:(0,u.basename)(Ce.backupPath),remoteAuthority:Ce.remoteAuthority}):Y++;L.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),L.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&L.waitMarkerFileURI&&(B.filesToWait={paths:(0,R.coalesce)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(q.push(...this.D.getUntitledWorkspaces()),j.push(...q),J.push(...this.w.getEmptyWindowBackups())):J.length=0;const{windows:ce,filesOpenedInWindow:fe}=await this.N(L,j,U,J,Y,B,W);if(this.m.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${j.length}, foldersToOpen: ${U.length}, emptyToRestore: ${J.length}, emptyToOpen: ${Y})`),ce.length>1)if(fe)fe.focus();else{const Ce=this.j.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Oe=!0,$e=!0;if(Ce){const ge=ce.filter(pe=>this.j.state.lastActiveWindow&&pe.backupPath===this.j.state.lastActiveWindow.backupPath);ge.length&&(ge[0].focus(),Oe=!1,$e=!1)}if(Oe)for(let ge=ce.length-1;ge>=0;ge--){const pe=ce[ge];if(!(pe.openedWorkspace&&q.some(Le=>pe.openedWorkspace&&Le.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&J.some(Le=>pe.backupPath&&Le.backupFolder===(0,u.basename)(pe.backupPath)))){pe.focus(),$e=!1;break}}$e&&ce[ce.length-1].focus()}const De=B&&B.filesToDiff.length>0,Re=B&&B.filesToMerge.length>0;if(!ce.some(Ce=>Ce.isExtensionDevelopmentHost)&&!De&&!Re&&!L.noRecentEntry){const Ce=[];for(const Oe of Z)G(Oe)&&!Oe.transient?Ce.push({label:Oe.label,workspace:Oe.workspace,remoteAuthority:Oe.remoteAuthority}):_(Oe)?Ce.push({label:Oe.label,folderUri:Oe.workspace.uri,remoteAuthority:Oe.remoteAuthority}):Oe.fileUri&&Ce.push({label:Oe.label,fileUri:Oe.fileUri,remoteAuthority:Oe.remoteAuthority});this.C.addRecentlyOpened(Ce)}return this.M(L,ce),ce}M(L,W){const U=L.waitMarkerFileURI;L.context===0&&U&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.H.del(U)}catch{}})()}async N(L,W,U,j,q,J,B){const Y=[];let Z;function ce(ge,pe){Y.push(ge),pe&&(Z=ge,J=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:De}=this.fb(L);if(!L.initialStartup&&B.length>0){const ge=B[0].remoteAuthority,pe=this.kb(ge);pe&&ce(this.P(pe,B.map(Le=>Le.workspace.uri)))}const Re=U.length+W.length+j.length;if(J&&Re===0){const ge=J.filesToOpenOrCreate[0]||J.filesToDiff[0]||J.filesToMerge[3],pe=this.getWindows().filter(ne=>J&&(0,h.isEqualAuthority)(ne.remoteAuthority,J.remoteAuthority));let Le;ge?.fileUri&&!De&&((L.context===4||L.context===0||L.context===1)&&(Le=await(0,K.findWindowOnFile)(pe,ge.fileUri,async ne=>ne.configPath.scheme===I.Schemas.file?this.D.resolveLocalWorkspace(ne.configPath):void 0)),Le||(Le=this.lb(pe))),Le?(0,le.isWorkspaceIdentifier)(Le.openedWorkspace)?W.push({workspace:Le.openedWorkspace,remoteAuthority:Le.remoteAuthority}):(0,le.isSingleFolderWorkspaceIdentifier)(Le.openedWorkspace)?U.push({workspace:Le.openedWorkspace,remoteAuthority:Le.remoteAuthority}):ce(this.O(L,Le,J),!0):ce(await this.gb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:J,forceNewWindow:!0,remoteAuthority:J.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile}),!0)}const Ce=(0,R.distinct)(W,ge=>ge.workspace.id);if(Ce.length>0){const ge=(0,R.coalesce)(Ce.map(pe=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(ge.length>0){const pe=ge[0],Le=(0,h.isEqualAuthority)(J?.remoteAuthority,pe.remoteAuthority)?J:void 0;ce(this.O(L,pe,Le),!!Le),fe=!0}for(const pe of Ce){if(ge.some(he=>he.openedWorkspace&&he.openedWorkspace.id===pe.workspace.id))continue;const Le=pe.remoteAuthority,ne=(0,h.isEqualAuthority)(J?.remoteAuthority,Le)?J:void 0;ce(await this.R(L,pe,fe,ne),!!ne),fe=!0}}const Oe=(0,R.distinct)(U,ge=>h.extUriBiasedIgnorePathCase.getComparisonKey(ge.workspace.uri));if(Oe.length>0){const ge=(0,R.coalesce)(Oe.map(pe=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(ge.length>0){const pe=ge[0],Le=(0,h.isEqualAuthority)(J?.remoteAuthority,pe.remoteAuthority)?J:void 0;ce(this.O(L,pe,Le),!!Le),fe=!0}for(const pe of Oe){if(ge.some(he=>(0,le.isSingleFolderWorkspaceIdentifier)(he.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(he.openedWorkspace.uri,pe.workspace.uri)))continue;const Le=pe.remoteAuthority,ne=(0,h.isEqualAuthority)(J?.remoteAuthority,Le)?J:void 0;ce(await this.R(L,pe,fe,ne),!!ne),fe=!0}}const $e=(0,R.distinct)(j,ge=>ge.backupFolder);if($e.length>0)for(const ge of $e){const pe=ge.remoteAuthority,Le=(0,h.isEqualAuthority)(J?.remoteAuthority,pe)?J:void 0;ce(await this.Q(L,!0,pe,Le,ge),!!Le),fe=!0}if(Y.length===0||J){J&&!q&&q++;const ge=J?J.remoteAuthority:L.remoteAuthority;for(let pe=0;pe<q;pe++)ce(await this.Q(L,fe,ge,J),!!J),fe=!0}return{windows:(0,R.distinct)(Y),filesOpenedInWindow:Z}}O(L,W,U){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:U}),W.focus();const j={filesToOpenOrCreate:U?.filesToOpenOrCreate,filesToDiff:U?.filesToDiff,filesToMerge:U?.filesToMerge,filesToWait:U?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",D.CancellationToken.None,j),W}P(L,W){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),L.focus();const U={foldersToAdd:W};return L.sendWhenReady("vscode:addFolders",D.CancellationToken.None,U),L}Q(L,W,U,j,q){this.m.trace("windowsManager#doOpenEmpty",{restore:!!q,remoteAuthority:U,filesToOpen:j,forceNewWindow:W});let J;return!W&&typeof L.contextWindowId=="number"&&(J=this.getWindowById(L.contextWindowId)),this.gb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:U,forceNewWindow:W,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:j,windowToUse:J,emptyWindowBackupInfo:q,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}R(L,W,U,j,q){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:j}),!U&&!q&&typeof L.contextWindowId=="number"&&(q=this.getWindowById(L.contextWindowId)),this.gb({workspace:W.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:j,windowToUse:q,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}async S(L){let W,U=!1,j=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(W=await this.U(L),U=!0):L.forceEmpty?W=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(W=await this.W(L.cli),W.length===0&&W.push(Object.create(null)),U=!0):(W=await this.Y(),W.length===0&&W.push(Object.create(null)),j=!0),!L.addMode&&U){const q=W.filter(J=>_(J));if(q.length>1){const J=q[0].remoteAuthority;if(q.every(B=>(0,h.isEqualAuthority)(B.remoteAuthority,J))){const B=await this.D.createUntitledWorkspace(q.map(Y=>({uri:Y.workspace.uri})));W.push({workspace:B,remoteAuthority:J}),W=W.filter(Y=>!_(Y))}}}if(L.initialStartup&&!j&&this.z.getValue("window")?.restoreWindows==="preserve"){const q=await this.Y();W.unshift(...q.filter(J=>G(J)||_(J)||J.backupPath))}return W}async U(L){const W={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},U=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async j=>{const q=await this.ab(j,W);if(q)return q.label=j.label,q;const J=this.cb(j);this.G.showMessageBox({type:"info",buttons:[(0,v.localize)(0,null)],message:J.scheme===I.Schemas.file?(0,v.localize)(1,null):(0,v.localize)(2,null),detail:J.scheme===I.Schemas.file?(0,v.localize)(3,null,(0,y.getPathLabel)(J,{os:S.OS,tildify:this.t})):(0,v.localize)(4,null,J.toString(!0))},(0,f.withNullAsUndefined)(P.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(U)}async W(L){const W=[],U={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},j=L["folder-uri"];if(j){const B=await Promise.all(j.map(Y=>{const Z=this.X(Y);if(!!Z)return this.ab({folderUri:Z},U)}));W.push(...(0,R.coalesce)(B))}const q=L["file-uri"];if(q){const B=await Promise.all(q.map(Y=>{const Z=this.X(Y);if(!!Z)return this.ab((0,le.hasWorkspaceFileExtension)(Y)?{workspaceUri:Z}:{fileUri:Z},U)}));W.push(...(0,R.coalesce)(B))}const J=await Promise.all(L._.map(B=>U.remoteAuthority?this.eb(B,U):this.db(B,U)));return W.push(...(0,R.coalesce)(J)),W}X(L){try{const W=p.URI.parse(L);if(!W.scheme){this.m.error(`Invalid URI input string, scheme missing: ${L}`);return}return W}catch(W){this.m.error(`Invalid URI input string: ${L}, ${W.message}`)}}async Y(){const L=this.Z();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];L!=="one"&&W.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&W.push(this.j.state.lastActiveWindow);const U=await Promise.all(W.map(async j=>{if(j.workspace){const q=await this.ab({workspaceUri:j.workspace.configPath},{remoteAuthority:j.remoteAuthority,rejectTransientWorkspaces:!0});if(G(q))return q}else if(j.folderUri){const q=await this.ab({folderUri:j.folderUri},{remoteAuthority:j.remoteAuthority});if(_(q))return q}else if(L!=="folders"&&j.backupPath)return{backupPath:j.backupPath,remoteAuthority:j.remoteAuthority}}));return(0,R.coalesce)(U)}}}Z(){let L;return this.v.wasRestarted?L="all":(L=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async ab(L,W=Object.create(null)){const U=this.cb(L);return U.scheme===I.Schemas.file?((0,N.isFileToOpen)(L)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.db(U.fsPath,W)):this.bb(L,W)}bb(L,W){let U=this.cb(L);const j=(0,M.getRemoteAuthority)(U)||W.remoteAuthority;if(U=(0,h.removeTrailingPathSeparator)((0,h.normalizePath)(U)),(0,N.isFileToOpen)(L)){if(W.gotoLineMode){const{path:q,line:J,column:B}=(0,g.parseLineAndColumnAware)(U.path);return{fileUri:U.with({path:q}),options:{selection:J?{startLineNumber:J,startColumn:B||1}:void 0},remoteAuthority:j}}return{fileUri:U,remoteAuthority:j}}else if((0,N.isWorkspaceToOpen)(L))return{workspace:(0,te.getWorkspaceIdentifier)(U),remoteAuthority:j};return{workspace:(0,te.getSingleFolderWorkspaceIdentifier)(U),remoteAuthority:j}}cb(L){return(0,N.isWorkspaceToOpen)(L)?L.workspaceUri:(0,N.isFolderToOpen)(L)?L.folderUri:L.fileUri}async db(L,W){let U,j;W.gotoLineMode&&({path:L,line:U,column:j}=(0,g.parseLineAndColumnAware)(L)),L=(0,g.sanitizeFilePath)((0,u.normalize)(L),(0,s.cwd)());try{const q=await A.Promises.stat(L);if(q.isFile()){if(!W.forceOpenWorkspaceAsFile){const J=await this.D.resolveLocalWorkspace(p.URI.file(L));if(J)return J.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:J.id,configPath:J.configPath},type:o.FileType.File,exists:!0,remoteAuthority:J.remoteAuthority,transient:J.transient}}return{fileUri:p.URI.file(L),type:o.FileType.File,exists:!0,options:{selection:U?{startLineNumber:U,startColumn:j||1}:void 0}}}else{if(q.isDirectory())return{workspace:(0,te.getSingleFolderWorkspaceIdentifier)(p.URI.file(L),q),type:o.FileType.Directory,exists:!0};if(!S.isWindows&&L==="/dev/null")return{fileUri:p.URI.file(L),type:o.FileType.File,exists:!0}}}catch{const J=p.URI.file(L);if(this.C.removeRecentlyOpened([J]),W.ignoreFileNotFound)return{fileUri:J,type:o.FileType.File,exists:!1}}}eb(L,W){const U=L.charCodeAt(0),j=W.remoteAuthority;let q,J;W.gotoLineMode&&({path:L,line:q,column:J}=(0,g.parseLineAndColumnAware)(L)),U!==47&&((0,g.isWindowsDriveLetter)(U)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,g.toSlashes)(L)),L=`/${L}`);const B=p.URI.from({scheme:I.Schemas.vscodeRemote,authority:j,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,le.hasWorkspaceFileExtension)(L))return W.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:q?{startLineNumber:q,startColumn:J||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,te.getWorkspaceIdentifier)(B),remoteAuthority:j};if(W.gotoLineMode||u.posix.basename(L).indexOf(".")!==-1)return{fileUri:B,options:{selection:q?{startLineNumber:q,startColumn:J||1}:void 0},remoteAuthority:j}}return{workspace:(0,te.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:j}}fb(L){const W=this.z.getValue("window"),U=W?.openFoldersInNewWindow||"default",j=W?.openFilesInNewWindow||"off";let q=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(U==="on"||U==="off")&&(q=U==="on");let J=!1;return L.forceNewWindow||L.forceReuseWindow?J=!!L.forceNewWindow&&!L.forceReuseWindow:(S.isMacintosh?L.context===1&&(J=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(J=!0),!L.cli.extensionDevelopmentPath&&(j==="on"||j==="off")&&(J=j==="on")),{openFolderInNewWindow:!!q,openFilesInNewWindow:J}}async openExtensionDevelopmentHostWindow(L,W){const U=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(U)return this.v.reload(U,W.cli),U.focus(),[U];let j=W.cli["folder-uri"]||[],q=W.cli["file-uri"]||[],J=W.cli._;if(!J.length&&!j.length&&!q.length&&!W.cli.extensionTestsPath){const Z=this.j.state.lastPluginDevelopmentHostWindow,ce=Z?.workspace??Z?.folderUri;ce&&(p.URI.isUri(ce)?ce.scheme===I.Schemas.file?J=[ce.fsPath]:j=[ce.toString()]:ce.configPath.scheme===I.Schemas.file?J=[(0,h.originalFSPath)(ce.configPath)]:q=[ce.configPath.toString()])}let B=W.remoteAuthority;for(const Z of L)if(Z.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ce=p.URI.parse(Z),fe=(0,M.getRemoteAuthority)(ce);fe&&(B?(0,h.isEqualAuthority)(fe,B)||this.m.error("more than one extension development path authority"):B=fe)}J=J.filter(Z=>{const ce=p.URI.file(Z);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:(0,h.isEqualAuthority)((0,M.getRemoteAuthority)(ce),B)}),j=j.filter(Z=>{const ce=this.X(Z);return ce&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,h.isEqualAuthority)((0,M.getRemoteAuthority)(ce),B):!1}),q=q.filter(Z=>{const ce=this.X(Z);return ce&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ce)?!1:ce?(0,h.isEqualAuthority)((0,M.getRemoteAuthority)(ce),B):!1}),W.cli._=J,W.cli["folder-uri"]=j,W.cli["file-uri"]=q;const Y={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:!J.length&&!j.length&&!q.length,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:B,forceProfile:W.forceProfile,forceTempProfile:W.forceTempProfile};return this.open(Y)}async gb(L){const W=this.z.getValue("window"),U=this.getLastActiveWindow(),j=U?.profile??this.u.defaultProfile;let q;!L.forceNewWindow&&!L.forceNewTabbedWindow&&(q=L.windowToUse||U,q&&q.focus());let J=!1;typeof W?.experimental?.sharedProcessUseUtilityProcess=="boolean"?J=W.experimental.sharedProcessUseUtilityProcess:J=typeof m.default.quality=="string"&&m.default.quality!=="stable";const B={...this.t.args,...L.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,u.join)(this.t.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.u.profilesHome,all:this.u.profiles,profile:j},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.l,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsHome.fsPath,product:m.default,isInitialStartup:L.initialStartup,perfMarks:(0,w.getMarks)(),os:{release:(0,n.release)(),hostname:(0,n.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn,preferUtilityProcess:J};if(q){const Y=q.config;!B.extensionDevelopmentPath&&Y?.extensionDevelopmentPath&&(B.extensionDevelopmentPath=Y.extensionDevelopmentPath,B.extensionDevelopmentKind=Y.extensionDevelopmentKind,B["enable-proposed-api"]=Y["enable-proposed-api"],B.verbose=Y.verbose,B["inspect-extensions"]=Y["inspect-extensions"],B["inspect-brk-extensions"]=Y["inspect-brk-extensions"],B.debugId=Y.debugId,B.extensionEnvironment=Y.extensionEnvironment,B["extensions-dir"]=Y["extensions-dir"],B["disable-extensions"]=Y["disable-extensions"]),B.loggers=Y?.loggers??B.loggers}else{const Y=this.j.getNewWindowState(B);(0,w.mark)("code/willCreateCodeWindow");const Z=q=this.F.createInstance(z.CodeWindow,{state:Y,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,w.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(Z),at.a.push(Z),this.b.fire(Z),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,d.once)(Z.onDidSignalReady)(()=>this.c.fire(Z)),(0,d.once)(Z.onDidClose)(()=>this.jb(Z)),(0,d.once)(Z.onDidDestroy)(()=>this.f.fire(Z)),Z.onDidTriggerSystemContextMenu(({x:fe,y:De})=>this.h.fire({window:Z,x:fe,y:De}));const ce=(0,f.assertIsDefined)(Z.win?.webContents);ce.removeAllListeners("devtools-reload-page"),ce.on("devtools-reload-page",()=>this.v.reload(Z)),this.v.registerWindow(Z)}return B.windowId=q.id,q.isReady?this.v.unload(q,4).then(async Y=>{Y||await this.hb(q,B,L,j)}):await this.hb(q,B,L,j),q}async hb(L,W,U,j){if(W.extensionDevelopmentPath||((0,le.isWorkspaceIdentifier)(W.workspace)?W.backupPath=this.w.registerWorkspaceBackup({workspace:W.workspace,remoteAuthority:W.remoteAuthority}):(0,le.isSingleFolderWorkspaceIdentifier)(W.workspace)?W.backupPath=this.w.registerFolderBackup({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority}):W.backupPath=this.w.registerEmptyWindowBackup({backupFolder:U.emptyWindowBackupInfo?.backupFolder??(0,te.createEmptyWorkspaceIdentifier)().id,remoteAuthority:W.remoteAuthority})),this.u.isEnabled()){const q=W.workspace??(0,le.toWorkspaceIdentifier)(W.backupPath,!1),J=this.ib(U,q,j),B=J instanceof Promise?await J:J;W.profiles.profile=B,W.extensionDevelopmentPath||await this.u.setProfileForWorkspace(q,B)}L.load(W)}ib(L,W,U){return L.forceProfile?this.u.profiles.find(j=>j.name===L.forceProfile)??this.u.createNamedProfile(L.forceProfile):L.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(W)??U}jb(L){const W=at.a.indexOf(L);at.a.splice(W,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=P.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(L){return this.lb(this.getWindows().filter(W=>(0,h.isEqualAuthority)(W.remoteAuthority,L)))}lb(L){const W=Math.max.apply(Math,L.map(U=>U.lastFocusTime));return L.find(U=>U.lastFocusTime===W)}sendToFocused(L,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,D.CancellationToken.None,...W)}sendToAll(L,W,U){for(const j of this.getWindows())U&&U.indexOf(j.id)>=0||j.sendWhenReady(L,D.CancellationToken.None,W)}getWindows(){return at.a}getWindowCount(){return at.a.length}getWindowById(L){const W=this.getWindows().filter(U=>U.id===L);return(0,R.firstOrDefault)(W)}getWindowByWebContents(L){const W=P.BrowserWindow.fromWebContents(L);if(!!W)return this.getWindowById(W.id)}};re.a=[],re=ye([ee(2,a.ILogService),ee(3,O.ILoggerMainService),ee(4,T.IStateService),ee(5,x.IPolicyService),ee(6,i.IEnvironmentMainService),ee(7,H.IUserDataProfilesMainService),ee(8,l.ILifecycleMainService),ee(9,C.IBackupMainService),ee(10,t.IConfigurationService),ee(11,F.IWorkspacesHistoryMainService),ee(12,$.IWorkspacesManagementMainService),ee(13,r.IInstantiationService),ee(14,c.IDialogMainService),ee(15,o.IFileService),ee(16,E.IProtocolMainService),ee(17,V.IThemeMainService)],re),e.WindowsMainService=re}),define(ie[284],se([0,1,63,30,79,54]),function(X,e,P,A,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let D=class{constructor(g,d,y,b){this.a=g,this.b=d,this.c=y,this.d=b,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(g,d){const y=this.b.getWindowById(g);if(y)return this.a.enterWorkspace(y,this.b.getWindows(),d)}createUntitledWorkspace(g,d,y){return this.a.createUntitledWorkspace(d,y)}deleteUntitledWorkspace(g,d){return this.a.deleteUntitledWorkspace(d)}getWorkspaceIdentifier(g,d){return this.a.getWorkspaceIdentifier(d)}getRecentlyOpened(g){return this.c.getRecentlyOpened()}addRecentlyOpened(g,d){return this.c.addRecentlyOpened(d)}removeRecentlyOpened(g,d){return this.c.removeRecentlyOpened(d)}clearRecentlyOpened(g){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};D=ye([ee(0,R.IWorkspacesManagementMainService),ee(1,A.IWindowsMainService),ee(2,n.IWorkspacesHistoryMainService),ee(3,P.IBackupMainService)],D),e.WorkspacesMainService=D}),define(ie[285],se([0,1,15,42,27,17,44,13,32,50,43,45,2,14,9,4,10,8,31,140,47,154,105,258,157,63,276,19,75,191,87,125,57,109,212,28,62,115,202,226,203,262,111,204,205,16,216,90,74,6,89,277,239,260,20,5,282,58,21,56,270,91,33,266,96,92,24,241,118,48,49,248,249,278,250,279,121,252,253,254,256,264,30,283,265,29,97,79,284,54,259,38,224,53,235,52,78,123,268,274,272,7,119,267,219,65,88,263,255]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p,v,C,t,c,i,o,r,l,a,m,E,M,T,N,z,K,ae,le,te,F,$,V,x,H,O,G,_,re,oe,L,W,U,j,q,J,B,Y,Z,ce,fe,De,Re,Ce,Oe,$e,ge,pe,Le,ne,he,de,Ie,Me,Te,Fe,je,ze,We,He,Q,ue,me,be,we,Ae,Ue,Ve,Ge,Ke,Ye,Ze,rt,ct,ft,Ct,Dt,Rt,Mt,At,Lt,Ot,gt,Tt,Ft,Wt,Ut,Nt,mt,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let pt=class extends I.Disposable{constructor(Pe,Ee,ve,Se,ke,Be,Xe,Qe,qe,Ne,xe){super(),this.c=Pe,this.f=Ee,this.g=ve,this.h=Se,this.i=ke,this.j=Be,this.k=Xe,this.l=Qe,this.m=qe,this.n=Ne,this.p=xe,this.r(),this.s()}r(){const Pe=qe=>qe?.startsWith(`${u.Schemas.vscodeWebview}://`),Ee=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((qe,Ne,xe,Je)=>Pe(Je.requestingUrl)?xe(Ee.has(Ne)):xe(!1)),P.session.defaultSession.setPermissionCheckHandler((qe,Ne,xe,Je)=>Pe(Je.requestingUrl)?Ee.has(Ne):!1);const ve=new Set([u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemoteResource,"devtools"]),Se=qe=>{for(let Ne=qe;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${u.Schemas.vscodeWebview}://`))return!0;return!1},ke=qe=>qe.resourceType==="xhr"||Se(qe.frame),Be=qe=>{const Ne=qe.frame;if(!Ne||!this.a)return!1;const xe=P.BrowserWindow.getAllWindows();for(const Je of xe)if(Ne.processId===Je.webContents.mainFrame.processId)return!0;return!1},Xe=(qe,Ne)=>{if(qe.path!=="/index.html")return!0;const xe=Ne.frame;if(!xe||!this.a)return!1;for(const Je of this.a.getWindows())if(Je.win&&xe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((qe,Ne)=>{const xe=h.URI.parse(qe.url);return xe.scheme===u.Schemas.vscodeWebview&&!Xe(xe,qe)?(this.h.error("Blocked vscode-webview request",qe.url),Ne({cancel:!0})):xe.scheme===u.Schemas.vscodeFileResource&&!Be(qe)?(this.h.error("Blocked vscode-file request",qe.url),Ne({cancel:!0})):xe.path.endsWith(".svg")&&!ve.has(xe.scheme)?Ne({cancel:!ke(qe)}):Ne({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((qe,Ne)=>{const xe=qe.responseHeaders,Je=xe["content-type"]||xe["Content-Type"];if(Je&&Array.isArray(Je)){const _e=h.URI.parse(qe.url);if(_e.path.endsWith(".svg")&&ve.has(_e.scheme))return xe["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:xe});if(!_e.path.endsWith(u.Schemas.vscodeRemoteResource)&&Je.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!ke(qe)})}return Ne({cancel:!1})});const Qe=P.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.i.codeCachePath&&Qe.setCodeCachePath((0,w.join)(this.i.codeCachePath,"chrome"))}s(){(0,k.setUnexpectedErrorHandler)(ve=>this.u(ve)),process.on("uncaughtException",ve=>(0,k.onUnexpectedError)(ve)),process.on("unhandledRejection",ve=>(0,k.onUnexpectedError)(ve)),this.j.onWillShutdown(()=>this.dispose()),(0,p.registerContextMenuListener)(),P.app.on("accessibility-support-changed",(ve,Se)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Se)}),P.app.on("activate",async(ve,Se)=>{this.h.trace("app#activate"),Se||await this.a?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(ve,Se)=>{Se.on("will-navigate",ke=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),Se.setWindowOpenHandler(({url:ke})=>(this.b?.openExternal(void 0,ke),{action:"deny"}))});let Pe=[],Ee;P.app.on("open-file",(ve,Se)=>{this.h.trace("app#open-file: ",Se),ve.preventDefault(),Pe.push((0,Ue.hasWorkspaceFileExtension)(Se)?{workspaceUri:h.URI.file(Se)}:{fileUri:h.URI.file(Se)}),Ee!==void 0&&(clearTimeout(Ee),Ee=void 0),Ee=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ee=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),A.validatedIpcMain.handle("vscode:fetchShellEnv",ve=>{const Se=this.a?.getWindowByWebContents(ve.sender);let ke,Be;return Se?.config?(ke=Se.config,Be={...process.env,...Se.config.userEnv}):(ke=this.i.args,Be=process.env),this.M(ke,Be,!1)}),A.validatedIpcMain.handle("vscode:writeNlsFile",(ve,Se,ke)=>{const Be=this.t([Se]);if(!Be||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(Be,R.VSBuffer.fromString(ke))}),A.validatedIpcMain.handle("vscode:readNlsFile",async(ve,...Se)=>{const ke=this.t(Se);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(ke)).value.toString()}),A.validatedIpcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),A.validatedIpcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),A.validatedIpcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}t(Pe){let Ee;for(const ve of Pe)typeof ve=="string"&&(typeof Ee!="string"?Ee=ve:Ee=(0,w.join)(Ee,ve));if(!(typeof Ee!="string"||!(0,w.isAbsolute)(Ee)||!(0,g.isEqualOrParent)(Ee,this.i.cachedLanguagesPath,!S.isLinux)))return h.URI.file(Ee)}u(Pe){if(Pe){const Ee={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ee))}this.h.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.h.error(Pe.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Pe=this.n.win32AppUserModelId;S.isWindows&&Pe&&P.app.setAppUserModelId(Pe);try{S.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const Ee=new C.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&Ee.dispose()}),this.h.trace("Resolving machine identifier...");const ve=await(0,Tt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${ve}`);const{sharedProcess:Se,sharedProcessReady:ke,sharedProcessClient:Be}=this.D(ve),Xe=await this.F(ve,Se,ke);this.B(Xe.createInstance(c.ProxyAuthHandler)),this.B(Xe.createInstance(Lt.UserDataProfilesHandler)),Xe.invokeFunction(Ne=>this.G(Ne,Ee,Be));const Qe=Xe.invokeFunction(Ne=>this.v(Ne,Ee));this.j.phase=2,await Xe.invokeFunction(Ne=>this.H(Ne,Qe)),this.j.phase=3,Xe.invokeFunction(Ne=>this.I(Ne,Se)),this.B(new gt.RunOnceScheduler(()=>{this.B((0,gt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Pe,Ee){const ve=this.a=Pe.get(be.IWindowsMainService),Se=Pe.get(ze.IURLService),ke=this.b=Pe.get(Z.INativeHostMainService),Be=this;Se.registerHandler({async handleURL(Je,_e){return Be.C(ve,Se,Je,_e)}});const Xe=this.B(new Ae.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Qe=new v.StaticRouter(Je=>Xe.getActiveClientId().then(_e=>Je===_e)),qe=new We.URLHandlerRouter(Qe,this.h),Ne=Ee.getChannel("urlHandler",qe);Se.registerHandler(new We.URLHandlerChannelClient(Ne));const xe=this.w();return this.B(new Q.ElectronURLListener(xe?.urls,Se,ve,this.i,this.n,this.h)),xe}w(){const Pe=this.i.args["open-url"]?this.i.args._urls||[]:[];Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Pe);const Ee=global.getOpenUrls()||[];if(Ee.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ee),Pe.length+Ee.length===0)return;const ve=[];return{urls:[...Pe,...Ee].map(ke=>{try{return{uri:h.URI.parse(ke),originalUrl:ke}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",ke);return}}).filter(ke=>{if(!ke)return!1;if(this.y(ke.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",ke.uri.toString(!0)),!1;const Be=this.z(ke.uri);return Be?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",ke.uri.toString(!0),Be),ve.push(Be),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",ke.uri.toString(!0)),!0)}),openables:ve}}y(Pe){if(Pe.authority===u.Schemas.file&&S.isWindows){const{options:Ee,buttonIndeces:ve}=(0,Nt.massageMessageBoxOptions)({type:"question",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,b.getPathLabel)(Pe,{os:S.OS,tildify:this.i}),this.n.nameShort),detail:(0,i.localize)(3,null)},this.n);if(ve[P.dialog.showMessageBoxSync(Ee)]===1)return!0}return!1}z(Pe){if(!!Pe.path){if(Pe.authority===u.Schemas.file){const Ee=h.URI.file(Pe.fsPath);return(0,Ue.hasWorkspaceFileExtension)(Ee)?{workspaceUri:Ee}:{fileUri:Ee}}else if(Pe.authority===u.Schemas.vscodeRemote){const Ee=Pe.path.indexOf(w.posix.sep,1);if(Ee!==-1){const ve=Pe.path.substring(1,Ee),Se=Pe.path.substring(Ee),ke=h.URI.from({scheme:u.Schemas.vscodeRemote,authority:ve,path:Se,query:Pe.query,fragment:Pe.fragment});return(0,Ue.hasWorkspaceFileExtension)(Se)?{workspaceUri:ke}:/:[\d]+$/.test(Se)?{fileUri:ke}:{folderUri:ke}}}}}async C(Pe,Ee,ve,Se){if(this.h.trace("app#handleProtocolUrl():",ve.toString(!0),Se),ve.scheme===this.n.urlProtocol&&ve.path==="workspace"&&(ve=ve.with({authority:"file",path:h.URI.parse(ve.query).path,query:""})),this.y(ve))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",ve.toString(!0)),!0;let ke=!1;const Be=new URLSearchParams(ve.query);Be.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ve.toString(!0)),Be.delete("windowId"),ve=ve.with({query:Be.toString()}),ke=!0):S.isMacintosh&&Pe.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ve.toString(!0)),ke=!0);const Xe=Be.get("continueOn");Xe!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ve.toString(!0)),Be.delete("continueOn"),ve=ve.with({query:Be.toString()}),this.i.continueOn=Xe??void 0);const Qe=this.z(ve);if(Qe){this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,ve.toString(!0));const[qe]=await Pe.open({context:5,cli:{...this.i.args},urisToOpen:[Qe],forceNewWindow:ke,gotoLineMode:!0});return qe.focus(),!0}if(ke){this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ve.toString(!0));const[qe]=await Pe.open({context:5,cli:{...this.i.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,fe.getRemoteAuthority)(ve)});return await qe.ready(),Ee.open(ve,Se)}return this.h.trace("app#handleProtocolUrl(): not handled",ve.toString(!0),Se),!1}D(Pe){const Ee=this.B(this.g.createInstance(De.SharedProcess,Pe,this.f)),ve=(async()=>{this.h.trace("Main->SharedProcess#connect");const ke=await Ee.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new t.Client(ke,"main")})(),Se=(async()=>(await Ee.whenReady(),ve))();return{sharedProcess:Ee,sharedProcessReady:Se,sharedProcessClient:ve}}async F(Pe,Ee,ve){const Se=new W.ServiceCollection;switch(process.platform){case"win32":Se.set(de.IUpdateService,new oe.SyncDescriptor(je.Win32UpdateService));break;case"linux":S.isLinuxSnap?Se.set(de.IUpdateService,new oe.SyncDescriptor(Fe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(de.IUpdateService,new oe.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Se.set(de.IUpdateService,new oe.SyncDescriptor(Me.DarwinUpdateService));break}Se.set(be.IWindowsMainService,new oe.SyncDescriptor(we.WindowsMainService,[Pe,this.f],!1));const ke=new T.DialogMainService(this.h,this.n);Se.set(T.IDialogMainService,ke),Se.set(q.ILaunchMainService,new oe.SyncDescriptor(q.LaunchMainService,void 0,!1)),Se.set(M.IDiagnosticsMainService,new oe.SyncDescriptor(M.DiagnosticsMainService,void 0,!1)),Se.set(E.IDiagnosticsService,v.ProxyChannel.toService((0,v.getDelayedChannel)(ve.then(Qe=>Qe.getChannel("diagnostics"))))),Se.set(U.IIssueMainService,new oe.SyncDescriptor(U.IssueMainService,[this.f])),Se.set(N.IEncryptionMainService,new oe.SyncDescriptor(z.EncryptionMainService,[Pe])),Se.set(j.IKeyboardLayoutMainService,new oe.SyncDescriptor(j.KeyboardLayoutMainService)),Se.set(Z.INativeHostMainService,new oe.SyncDescriptor(Z.NativeHostMainService,[Ee],!1)),Se.set(a.ICredentialsMainService,new oe.SyncDescriptor(Ze.CredentialsNativeMainService)),Se.set(ue.IWebviewManagerService,new oe.SyncDescriptor(me.WebviewMainService)),Se.set(Y.IMenubarMainService,new oe.SyncDescriptor(Y.MenubarMainService)),Se.set(te.IExtensionUrlTrustService,new oe.SyncDescriptor(F.ExtensionUrlTrustService)),Se.set($.IExtensionHostStarter,new oe.SyncDescriptor(V.ExtensionHostStarter)),Se.set($e.IStorageMainService,new oe.SyncDescriptor($e.StorageMainService)),Se.set($e.IApplicationStorageMainService,new oe.SyncDescriptor($e.ApplicationStorageMainService)),S.isWindows?Se.set(x.IExternalTerminalMainService,new oe.SyncDescriptor(H.WindowsExternalTerminalService)):S.isMacintosh?Se.set(x.IExternalTerminalMainService,new oe.SyncDescriptor(H.MacExternalTerminalService)):S.isLinux&&Se.set(x.IExternalTerminalMainService,new oe.SyncDescriptor(H.LinuxExternalTerminalService));const Be=new r.BackupMainService(this.i,this.k,this.h,this.l);Se.set(o.IBackupMainService,Be);const Xe=new Ye.WorkspacesManagementMainService(this.i,this.h,this.p,Be,ke);if(Se.set(Ye.IWorkspacesManagementMainService,Xe),Se.set(Ve.IWorkspacesService,new oe.SyncDescriptor(Ke.WorkspacesMainService,void 0,!1)),Se.set(Ge.IWorkspacesHistoryMainService,new oe.SyncDescriptor(Ge.WorkspacesHistoryMainService,void 0,!1)),Se.set(ze.IURLService,new oe.SyncDescriptor(He.NativeURLService,void 0,!1)),(0,he.supportsTelemetry)(this.n,this.i)){const Qe=(0,he.isInternalTelemetry)(this.n,this.k),qe=(0,v.getDelayedChannel)(ve.then(nt=>nt.getChannel("telemetryAppender"))),Ne=new Le.TelemetryAppenderClient(qe),xe=(0,ge.resolveCommonProperties)(this.m,(0,n.release)(),(0,n.hostname)(),process.arch,this.n.commit,this.n.version,Pe,Qe,this.i.installSourcePath),Je=(0,he.getPiiPathsFromEnvironment)(this.i),_e={appenders:[Ne],commonProperties:xe,piiPaths:Je,sendErrorTelemetry:!0};Se.set(pe.ITelemetryService,new oe.SyncDescriptor(ne.TelemetryService,[_e],!1))}else Se.set(pe.ITelemetryService,he.NullTelemetryService);return Se.set(Rt.IExtensionsProfileScannerService,new oe.SyncDescriptor(Ft.ExtensionsProfileScannerService,void 0,!0)),Se.set(Mt.IExtensionsScannerService,new oe.SyncDescriptor(At.ExtensionsScannerService,void 0,!0)),Se.set(mt.IUtilityProcessWorkerMainService,new oe.SyncDescriptor(mt.UtilityProcessWorkerMainService,void 0,!0)),await gt.Promises.settled([Be.initialize(),Xe.initialize()]),this.g.createChild(Se)}G(Pe,Ee,ve){const Se=v.ProxyChannel.fromService(Pe.get(q.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Se);const ke=v.ProxyChannel.fromService(Pe.get(M.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",ke);const Be=new ct.PolicyChannel(Pe.get(rt.IPolicyService));Ee.registerChannel("policy",Be),ve.then(et=>et.registerChannel("policy",Be));const Xe=this.m.getProvider(u.Schemas.file);(0,s.assertType)(Xe instanceof re.DiskFileSystemProvider);const Qe=new _.DiskFileSystemProviderChannel(Xe,this.h,this.i);Ee.registerChannel(O.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe),ve.then(et=>et.registerChannel(O.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe));const qe=v.ProxyChannel.fromService(Pe.get(ft.IUserDataProfilesMainService));Ee.registerChannel("userDataProfiles",qe),ve.then(et=>et.registerChannel("userDataProfiles",qe));const Ne=new Ct.RequestChannel(Pe.get(Dt.IRequestService));ve.then(et=>et.registerChannel("request",Ne));const xe=new Ie.UpdateChannel(Pe.get(de.IUpdateService));Ee.registerChannel("update",xe);const Je=v.ProxyChannel.fromService(Pe.get(U.IIssueMainService));Ee.registerChannel("issue",Je);const _e=v.ProxyChannel.fromService(Pe.get(N.IEncryptionMainService));Ee.registerChannel("encryption",_e);const nt=v.ProxyChannel.fromService(Pe.get(a.ICredentialsMainService));Ee.registerChannel("credentials",nt);const it=v.ProxyChannel.fromService(Pe.get(Re.ISignService));Ee.registerChannel("sign",it);const lt=v.ProxyChannel.fromService(Pe.get(j.IKeyboardLayoutMainService));Ee.registerChannel("keyboardLayout",lt),this.b=Pe.get(Z.INativeHostMainService);const vt=v.ProxyChannel.fromService(this.b);Ee.registerChannel("nativeHost",vt),ve.then(et=>et.registerChannel("nativeHost",vt));const Bt=v.ProxyChannel.fromService(Pe.get(Ve.IWorkspacesService));Ee.registerChannel("workspaces",Bt);const $t=v.ProxyChannel.fromService(Pe.get(Y.IMenubarMainService));Ee.registerChannel("menubar",$t);const zt=v.ProxyChannel.fromService(Pe.get(ze.IURLService));Ee.registerChannel("url",zt);const qt=v.ProxyChannel.fromService(Pe.get(te.IExtensionUrlTrustService));Ee.registerChannel("extensionUrlTrust",qt);const Ht=v.ProxyChannel.fromService(Pe.get(ue.IWebviewManagerService));Ee.registerChannel("webview",Ht);const St=this.B(new Oe.StorageDatabaseChannel(this.h,Pe.get($e.IStorageMainService)));Ee.registerChannel("storage",St),ve.then(et=>et.registerChannel("storage",St));const Vt=this.B(new Ot.ProfileStorageChangesListenerChannel(Pe.get($e.IStorageMainService),Pe.get(ft.IUserDataProfilesMainService),this.h));ve.then(et=>et.registerChannel("profileStorageListener",Vt));const xt=v.ProxyChannel.fromService(Pe.get(x.IExternalTerminalMainService));Ee.registerChannel("externalTerminal",xt);const Et=new Wt.LoggerChannel(Pe.get(Ut.ILoggerMainService));Ee.registerChannel("logger",Et),ve.then(et=>et.registerChannel("logger",Et));const Gt=new m.ElectronExtensionHostDebugBroadcastChannel(Pe.get(be.IWindowsMainService));Ee.registerChannel("extensionhostdebugservice",Gt);const Kt=v.ProxyChannel.fromService(Pe.get($.IExtensionHostStarter));Ee.registerChannel($.ipcExtensionHostStarterChannelName,Kt);const Xt=v.ProxyChannel.fromService(Pe.get(mt.IUtilityProcessWorkerMainService));Ee.registerChannel(jt.ipcUtilityProcessWorkerChannelName,Xt)}async H(Pe,Ee){const ve=this.a=Pe.get(be.IWindowsMainService),Se=(0,ae.isLaunchedFromCli)(process.env)?0:4,ke=this.i.args;if(Ee){if(Ee.openables.length>0)return ve.open({context:Se,cli:ke,urisToOpen:Ee.openables,gotoLineMode:!0,initialStartup:!0});if(Ee.urls.length>0)for(const it of Ee.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),ve.open({context:Se,cli:ke,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Be=global.macOpenFiles,Xe=ke._.length,Qe=!!ke["folder-uri"],qe=!!ke["file-uri"],Ne=ke["skip-add-to-recently-opened"]===!0,xe=ke.wait&&ke.waitMarkerFilePath?h.URI.file(ke.waitMarkerFilePath):void 0,Je=ke.remote||void 0,_e=ke.profile,nt=ke["profile-temp"];if(!Xe&&!Qe&&!qe){if(ke["new-window"]||_e||nt)return ve.open({context:Se,cli:ke,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt});if(Be.length)return ve.open({context:1,cli:ke,urisToOpen:Be.map(it=>(0,Ue.hasWorkspaceFileExtension)(it)?{workspaceUri:h.URI.file(it)}:{fileUri:h.URI.file(it)}),noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0})}return ve.open({context:Se,cli:ke,forceNewWindow:ke["new-window"]||!Xe&&ke["unity-launch"],diffMode:ke.diff,mergeMode:ke.merge,noRecentEntry:Ne,waitMarkerFileURI:xe,gotoLineMode:ke.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt})}I(Pe,Ee){const ve=Pe.get(pe.ITelemetryService),Se=Pe.get(de.IUpdateService);this.L(ve,Ee),this.J(),P.protocol.registerHttpProtocol(u.Schemas.vscodeRemoteResource,(ke,Be)=>{Be({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})}),(Se instanceof je.Win32UpdateService||Se instanceof Te.LinuxUpdateService||Se instanceof Me.DarwinUpdateService)&&Se.initialize(),this.M(this.i.args,process.env,!0),this.N()}async J(){const Pe=this.n.win32MutexName;if(S.isWindows&&Pe)try{const Ee=await new Promise((Se,ke)=>{X(["windows-mutex"],Se,ke)}),ve=new Ee.Mutex(Pe);(0,d.once)(this.j.onWillShutdown)(()=>ve.release())}catch(Ee){this.h.error(Ee)}}L(Pe,Ee){let ve=!1;(0,d.once)(this.j.onWillShutdown)(()=>ve=!0),this.B(Ee.onDidError(({type:Se,details:ke})=>{switch(Se){case 2:this.h.error(`[SharedProcess] renderer process gone (reason: ${ke?.reason||"<unknown>"}, code: ${ke?.exitCode||"<unknown>"})`);break;case 1:this.h.error("[SharedProcess]  detected unresponsive");break;case 3:this.h.error(`[SharedProcess]  failed to load (reason: ${ke?.reason||"<unknown>"}, code: ${ke?.exitCode||"<unknown>"})`);break}Pe.publicLog2("sharedprocesserror",{type:Se,reason:ke?.reason,code:ke?.exitCode,visible:Ee.isVisible(),utilityprocess:Ee.usingUtilityProcess()?"1":"0",shuttingdown:ve})}))}async M(Pe,Ee,ve){try{return await(0,le.getResolvedShellEnv)(this.k,this.h,Pe,Ee)}catch(Se){const ke=(0,D.toErrorMessage)(Se);ve?this.a?.sendToFocused("vscode:showResolveShellEnvError",ke):this.h.error(ke)}return{}}async N(){try{const Ee=(await this.m.readFile(this.i.argvResource)).value.toString(),ve=JSON.parse((0,y.stripComments)(Ee)),ke=(0,he.getTelemetryLevel)(this.k)>=1;if(ve["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,f.generateUuid)()}"`,"}"],Xe=Ee.substring(0,Ee.length-2).concat(`,
`,Be.join(`
`));await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(Xe))}else{const Be=Ee.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${ke},`);Be!==Ee&&await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(Be))}}catch(Pe){this.h.error(Pe)}}};pt=ye([ee(2,L.IInstantiationService),ee(3,B.ILogService),ee(4,K.IEnvironmentMainService),ee(5,J.ILifecycleMainService),ee(6,l.IConfigurationService),ee(7,Ce.IStateService),ee(8,G.IFileService),ee(9,ce.IProductService),ee(10,ft.IUserDataProfilesMainService)],pt),e.CodeApplication=pt}),define(ie[286],se([0,1,237,7,17,13,10,19,34,115,5,52,236,293]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let w=class extends b.AbstractRequestService{constructor(s,h,f,p){super(!!h.isRemoteServer,p),this.j=s,this.k=h,this.l=f,this.m(),this.B(s.onDidChangeConfiguration(v=>{v.affectsConfiguration("http")&&this.m()}))}m(){const s=this.j.getValue("http");this.f=s?.proxy,this.g=!!s?.proxyStrictSSL,this.h=s?.proxyAuthorization}async request(s,h){const{f,g:p}=this;let v;try{v=await(0,d.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(c){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,R.getErrorMessage)(c)))}const C={...process.env,...v},t=s.agent?s.agent:await(0,I.getProxyAgent)(s.url||"",C,{proxyUrl:f,strictSSL:p});return s.agent=t,s.strictSSL=p,this.h&&(s.headers={...s.headers||{},"Proxy-Authorization":this.h}),this.p(s,h)}async n(s){return((0,P.parse)(s.url).protocol==="https:"?await new Promise((p,v)=>{X(["https"],p,v)}):await new Promise((p,v)=>{X(["http"],p,v)})).request}p(s,h){return this.c(s.isChromiumNetwork?"electron":"node",s,()=>A.Promises.withAsyncBody(async(f,p)=>{const v=(0,P.parse)(s.url),C=s.getRawRequest?s.getRawRequest(s):await this.n(s),t={hostname:v.hostname,port:v.port?parseInt(v.port):v.protocol==="https:"?443:80,protocol:v.protocol,path:v.path,method:s.type||"GET",headers:s.headers,agent:s.agent,rejectUnauthorized:(0,D.isBoolean)(s.strictSSL)?s.strictSSL:!0};s.user&&s.password&&(t.auth=s.user+":"+s.password);const c=C(t,i=>{const o=(0,D.isNumber)(s.followRedirects)?s.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)this.p({...s,url:i.headers.location,followRedirects:o-1},h).then(f,p);else{let r=i;!s.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,u.createGunzip)())),f({res:i,stream:(0,n.streamToBufferReadableStream)(r)})}});c.on("error",p),s.timeout&&c.setTimeout(s.timeout),s.isChromiumNetwork&&c.removeHeader("Content-Length"),s.data&&typeof s.data=="string"&&c.write(s.data),c.end(),h.onCancellationRequested(()=>{c.abort(),p(new R.CancellationError)})}))}async resolveProxy(s){}};w=ye([ee(0,k.IConfigurationService),ee(1,g.INativeEnvironmentService),ee(2,y.ILogService),ee(3,y.ILoggerService)],w),e.RequestService=w}),define(ie[287],se([0,1,15,286]),function(X,e,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function n(D){return P.net.request}class R extends A.RequestService{request(k,g){return super.request({...k||{},getRawRequest:n,isChromiumNetwork:!0},g)}}e.RequestMainService=R}),define(ie[294],se([0,1,15,41,8,26,7,44,13,32,50,45,14,9,64,4,36,25,23,47,86,285,11,19,230,240,28,62,194,16,214,90,74,210,89,20,217,5,66,21,67,269,120,246,52,287,91,238,33,48,69,53,38,225,223,2,39,251,65,218,88,116,247]),function(X,e,P,A,n,R,D,k,g,d,y,b,I,u,w,S,s,h,f,p,v,C,t,c,i,o,r,l,a,m,E,M,T,N,z,K,ae,le,te,F,$,V,x,H,O,G,_,re,oe,L,W,U,j,q,J,B,Y,Z,ce,fe,De,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ce{main(){try{this.a()}catch(ge){console.error(ge.message),P.app.exit(1)}}async a(){(0,g.setUnexpectedErrorHandler)(Te=>console.error(Te));const[ge,pe,Le,ne,he,de,Ie,Me]=this.b();try{try{await this.d(Le,Me,ne,he,Ie)}catch(Te){throw this.f(Le,Ie,Te),Te}await ge.invokeFunction(async Te=>{const Fe=Te.get(le.ILogService),je=Te.get(K.ILifecycleMainService),ze=Te.get(m.IFileService),We=Te.get(le.ILoggerService),He=await this.e(Fe,Le,je,ge,Ie,!0);return f.Promises.writeFile(Le.mainLockfile,String(process.pid)).catch(Q=>{Fe.warn(`app#startup(): Error writing main lockfile: ${Q.stack}`)}),de.logger=We.createLogger("main",{name:(0,t.localize)(0,null)}),(0,y.once)(je.onWillShutdown)(Q=>{ze.dispose(),ne.dispose(),Q.join("instanceLockfile",f.Promises.unlink(Le.mainLockfile).catch(()=>{}))}),ge.createInstance(C.CodeApplication,He,pe).startup()})}catch(Te){ge.invokeFunction(this.i,Te)}}b(){const ge=new z.ServiceCollection,pe=new B.DisposableStore;process.once("exit",()=>pe.dispose());const Le={_serviceBrand:void 0,...te.default};ge.set(F.IProductService,Le);const ne=new r.EnvironmentMainService(this.j(),Le),he=this.c(ne);ge.set(r.IEnvironmentMainService,ne);const de=new ce.LoggerMainService((0,le.getLogLevel)(ne),ne.logsHome);ge.set(ce.ILoggerMainService,de);const Ie=new ae.BufferLogger(de.getLogLevel()),Me=pe.add(new fe.LogService(Ie,[new le.ConsoleMainLogger(de.getLogLevel())]));ge.set(le.ILogService,Me);const Te=new E.FileService(Me);ge.set(m.IFileService,Te);const Fe=new M.DiskFileSystemProvider(Me);Te.registerProvider(I.Schemas.file,Fe);const je=new Z.UriIdentityService(Te);ge.set(Y.IUriIdentityService,je);const ze=new Re.StateService(1,ne,Me,Te);ge.set(oe.IStateReadService,ze),ge.set(oe.IStateService,ze);const We=new U.UserDataProfilesMainService(ze,je,ne,Te,Me);ge.set(U.IUserDataProfilesMainService,We);const He=S.isWindows&&Le.win32RegValueName?pe.add(new q.NativePolicyService(Me,Le.win32RegValueName)):ne.policyFile?pe.add(new J.FilePolicyService(ne.policyFile,Te,Me)):new j.NullPolicyService;ge.set(j.IPolicyService,He);const Q=new i.ConfigurationService(We.defaultProfile.settingsResource,Te,He,Me);return ge.set(c.IConfigurationService,Q),ge.set(K.ILifecycleMainService,new T.SyncDescriptor(K.LifecycleMainService,void 0,!1)),ge.set(O.IRequestService,new T.SyncDescriptor(G.RequestMainService,void 0,!0)),ge.set(W.IThemeMainService,new T.SyncDescriptor(W.ThemeMainService)),ge.set(_.ISignService,new T.SyncDescriptor(re.SignService,void 0,!1)),ge.set(x.ITunnelService,new T.SyncDescriptor(H.TunnelService)),ge.set($.IProtocolMainService,new V.ProtocolMainService(ne,We,Me)),[new N.InstantiationService(ge,!0),he,ne,Q,ze,Ie,Le,We]}c(ge){const pe={VSCODE_IPC_HOOK:ge.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Le=>{const ne=process.env[Le];typeof ne=="string"&&(pe[Le]=ne)}),Object.assign(process.env,pe),pe}async d(ge,pe,Le,ne,he){await D.Promises.settled([Promise.all([ge.extensionsPath,ge.codeCachePath,ge.logsHome.fsPath,pe.defaultProfile.globalStorageHome.fsPath,ge.workspaceStorageHome.fsPath,ge.localHistoryHome.fsPath,ge.backupHome].map(de=>de?f.Promises.mkdir(de,{recursive:!0}):void 0)),ne.init(),Le.initialize()]),pe.init()}async e(ge,pe,Le,ne,he,de){let Ie;try{(0,w.mark)("code/willStartMainServer"),Ie=await(0,v.serve)(pe.mainIPCHandle),(0,w.mark)("code/didStartMainServer"),(0,y.once)(Le.onWillShutdown)(()=>Ie.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.f(pe,he,Me),Me;let Te;try{Te=await(0,v.connect)(pe.mainIPCHandle,"main")}catch(We){if(!de||S.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.g((0,t.localize)(1,null,he.nameShort),(0,t.localize)(2,null),he),We;try{(0,A.unlinkSync)(pe.mainIPCHandle)}catch(He){throw ge.warn("Could not delete obsolete instance handle",He),He}return this.e(ge,pe,Le,ne,he,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const We=`Running extension tests from the command line is currently only supported if no other instance of ${he.nameShort} is running.`;throw ge.error(We),Te.dispose(),new Error(We)}let Fe;!pe.args.wait&&!pe.args.status&&(Fe=setTimeout(()=>{this.g((0,t.localize)(3,null,he.nameShort),(0,t.localize)(4,null),he)},1e4));const je=p.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),ze=p.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return ne.invokeFunction(async()=>{const We=new o.DiagnosticsService(L.NullTelemetryService,he),He=await ze.getMainDiagnostics(),Q=await ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ue=await We.getDiagnostics(He,Q);throw console.log(ue),new g.ExpectedError});throw S.isWindows&&await this.h(je,ge),ge.trace("Sending env to running instance..."),await je.start(pe.args,process.env),Te.dispose(),Fe&&clearTimeout(Fe),new g.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw ge.warn(`Warning: The --status argument can only be used if ${he.nameShort} is already running. Please run it again after {0} has started.`),new g.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ie}f(ge,pe,Le){if(Le.code==="EACCES"||Le.code==="EPERM"){const ne=(0,R.coalesce)([ge.userDataPath,ge.extensionsPath,v.XDG_RUNTIME_DIR]).map(he=>(0,b.getPathLabel)(n.URI.file(he),{os:S.OS,tildify:ge}));this.g((0,t.localize)(5,null),(0,t.localize)(6,null,(0,k.toErrorMessage)(Le),ne.join(`
`)),pe)}}g(ge,pe,Le){P.dialog.showMessageBoxSync((0,De.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:ge,detail:pe},Le).options)}async h(ge,pe){if(S.isWindows){const Le=await ge.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Le);try{(await new Promise((ne,he)=>{X(["windows-foreground-love"],ne,he)})).allowSetForegroundWindow(Le)}catch(ne){pe.error(ne)}}}i(ge,pe){const Le=ge.get(le.ILogService),ne=ge.get(K.ILifecycleMainService);let he=0;pe&&(pe.isExpected?pe.message&&Le.trace(pe.message):(he=1,pe.stack?Le.error(pe.stack):Le.error(`Startup error: ${pe.toString()}`))),ne.kill(he)}j(){const ge=this.k((0,l.parseMainProcessArgv)(process.argv));if(ge.wait&&!ge.waitMarkerFilePath){const pe=(0,a.createWaitMarkerFileSync)(ge.verbose);pe&&((0,l.addArg)(process.argv,"--waitMarkerFilePath",pe),ge.waitMarkerFilePath=pe)}return ge}k(ge){if(ge["open-url"]&&(ge._urls=ge._,ge._=[]),!ge.remote){const pe=this.l(ge._,ge.goto);ge._=pe}return ge}l(ge,pe){const Le=(0,s.cwd)(),ne=ge.map(Ie=>{let Me=String(Ie),Te;pe&&(Te=(0,d.parseLineAndColumnAware)(Me),Me=Te.path),Me&&(Me=this.m(Le,Me));const Fe=(0,d.sanitizeFilePath)(Me,Le),je=(0,u.basename)(Fe);return je&&!(0,d.isValidBasename)(je)?null:pe&&Te?(Te.path=Fe,this.n(Te)):Fe}),he=S.isWindows||S.isMacintosh,de=(0,R.distinct)(ne,Ie=>Ie&&he?Ie.toLowerCase():Ie||"");return(0,R.coalesce)(de)}m(ge,pe){return S.isWindows&&(pe=(0,h.rtrim)(pe,'"')),pe=(0,h.trim)((0,h.trim)(pe," "),"	"),S.isWindows&&(pe=(0,u.resolve)(ge,pe),pe=(0,h.rtrim)(pe,".")),pe}n(ge){const pe=[ge.path];return typeof ge.line=="number"&&pe.push(String(ge.line)),typeof ge.column=="number"&&pe.push(String(ge.column)),pe.join(":")}}new Ce().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e4a11014fd91da8f2d82ba144097df21a483334d/core/vs/code/electron-main/main.js.map
