/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/platform/log/common/log","vs/base/common/async","vs/base/common/errors","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/nls","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(H){for(var e=[],N=0,L=H.length;N<L;N++)e[N]=ne[H[N]];return e};define(ne[49],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function N(I){return(P,d,c)=>{let k=null,w=null;if(typeof c.value=="function"?(k="value",w=c.value):typeof c.get=="function"&&(k="get",w=c.get),!w)throw new Error("not supported");c[k]=I(w,d)}}function L(I,P,d){let c=null,k=null;if(typeof d.value=="function"?(c="value",k=d.value,k.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(c="get",k=d.get),!k)throw new Error("not supported");const w=`$memoize$${P}`;d[c]=function(...v){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:k.apply(this,v)}),this[w]}}e.memoize=L;function D(I,P,d){return N((c,k)=>{const w=`$debounce$${k}`,v=`$debounce$result$${k}`;return function(...S){this[v]||(this[v]=d?d():void 0),clearTimeout(this[w]),P&&(this[v]=P(this[v],...S),S=[this[v]]),this[w]=setTimeout(()=>{c.apply(this,S),this[v]=d?d():void 0},I)}})}e.debounce=D;function R(I,P,d){return N((c,k)=>{const w=`$throttle$timer$${k}`,v=`$throttle$result$${k}`,S=`$throttle$lastRun$${k}`,E=`$throttle$pending$${k}`;return function(...T){if(this[v]||(this[v]=d?d():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...T)),this[E])return;const l=this[S]+I;l<=Date.now()?(this[S]=Date.now(),c.apply(this,[this[v]]),this[v]=d?d():void 0):(this[E]=!0,this[w]=setTimeout(()=>{this[E]=!1,this[S]=Date.now(),c.apply(this,[this[v]]),this[v]=d?d():void 0},l-Date.now()))}})}e.throttle=R}),define(ne[70],re([0,1,7]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(d,c){if(!d)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=L;function D(d,c="Unreachable"){throw new Error(c)}e.assertNever=D;function R(d){if(!d)throw new N.BugIndicatingError("Assertion Failed")}e.assert=R;function I(d){if(!d()){debugger;d(),(0,N.onUnexpectedError)(new N.BugIndicatingError("Assertion Failed"))}}e.assertFn=I;function P(d,c){let k=0;for(;k<d.length-1;){const w=d[k],v=d[k+1];if(!c(w,v))return!1;k++}return!0}e.checkAdjacentItems=P}),define(ne[50],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var N;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(N=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function I(t,s=!1){let i=0;const n=t.length;let r="",a=0,o=16,h=0;function f(ae){let Y=0,y=0;for(;Y<ae;){const M=t.charCodeAt(i);if(M>=48&&M<=57)y=y*16+M-48;else if(M>=65&&M<=70)y=y*16+M-65+10;else if(M>=97&&M<=102)y=y*16+M-97+10;else break;i++,Y++}return Y<ae&&(y=-1),y}function O(ae){i=ae,r="",a=0,o=16,h=0}function x(){const ae=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return h=3,t.substring(ae,i);let Y=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;Y=i}else h=3;return t.substring(ae,Y)}function _(){let ae="",Y=i;for(;;){if(i>=n){ae+=t.substring(Y,i),h=2;break}const y=t.charCodeAt(i);if(y===34){ae+=t.substring(Y,i),i++;break}if(y===92){if(ae+=t.substring(Y,i),i++,i>=n){h=2;break}switch(t.charCodeAt(i++)){case 34:ae+='"';break;case 92:ae+="\\";break;case 47:ae+="/";break;case 98:ae+="\b";break;case 102:ae+="\f";break;case 110:ae+=`
`;break;case 114:ae+="\r";break;case 116:ae+="	";break;case 117:{const U=f(4);U>=0?ae+=String.fromCharCode(U):h=4;break}default:h=5}Y=i;continue}if(y>=0&&y<=31)if(d(y)){ae+=t.substring(Y,i),h=2;break}else h=6;i++}return ae}function ee(){if(r="",h=0,a=i,i>=n)return a=n,o=17;let ae=t.charCodeAt(i);if(P(ae)){do i++,r+=String.fromCharCode(ae),ae=t.charCodeAt(i);while(P(ae));return o=15}if(d(ae))return i++,r+=String.fromCharCode(ae),ae===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),o=14;switch(ae){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,r=_(),o=10;case 47:{const Y=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!d(t.charCodeAt(i));)i++;return r=t.substring(Y,i),o=12}if(t.charCodeAt(i+1)===42){i+=2;const y=n-1;let M=!1;for(;i<y;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,M=!0;break}i++}return M||(i++,h=1),r=t.substring(Y,i),o=13}return r+=String.fromCharCode(ae),i++,o=16}case 45:if(r+=String.fromCharCode(ae),i++,i===n||!c(t.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=x(),o=11;default:for(;i<n&&se(ae);)i++,ae=t.charCodeAt(i);if(a!==i){switch(r=t.substring(a,i),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(ae),i++,o=16}}function se(ae){if(P(ae)||d(ae))return!1;switch(ae){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let ae;do ae=ee();while(ae>=12&&ae<=15);return ae}return{setPosition:O,getPosition:()=>i,scan:s?oe:ee,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>h}}e.createScanner=I;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var k;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(k||(k={}));function w(t,s){const i=[],n=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function h(f,O,x,_){a.value=f,a.offset=O,a.length=x,a.type=_,a.colonOffset=void 0,r=a}try{p(t,{onObjectBegin:(f,O)=>{if(s<=f)throw n;r=void 0,o=s>f,i.push("")},onObjectProperty:(f,O,x)=>{if(s<O||(h(f,O,x,"property"),i[i.length-1]=f,s<=O+x))throw n},onObjectEnd:(f,O)=>{if(s<=f)throw n;r=void 0,i.pop()},onArrayBegin:(f,O)=>{if(s<=f)throw n;r=void 0,i.push(0)},onArrayEnd:(f,O)=>{if(s<=f)throw n;r=void 0,i.pop()},onLiteralValue:(f,O,x)=>{if(s<O||(h(f,O,x,b(f)),s<=O+x))throw n},onSeparator:(f,O,x)=>{if(s<=O)throw n;if(f===":"&&r&&r.type==="property")r.colonOffset=O,o=!1,r=void 0;else if(f===","){const _=i[i.length-1];typeof _=="number"?i[i.length-1]=_+1:(o=!0,i[i.length-1]=""),r=void 0}}})}catch(f){if(f!==n)throw f}return{path:i,previousNode:r,isAtPropertyKey:o,matches:f=>{let O=0;for(let x=0;O<f.length&&x<i.length;x++)if(f[O]===i[x]||f[O]==="*")O++;else if(f[O]!=="**")return!1;return O===f.length}}}e.getLocation=w;function v(t,s=[],i=R.DEFAULT){let n=null,r=[];const a=[];function o(f){Array.isArray(r)?r.push(f):n!==null&&(r[n]=f)}return p(t,{onObjectBegin:()=>{const f={};o(f),a.push(r),r=f,n=null},onObjectProperty:f=>{n=f},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const f=[];o(f),a.push(r),r=f,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:o,onError:(f,O,x)=>{s.push({error:f,offset:O,length:x})}},i),r[0]}e.parse=v;function S(t,s=[],i=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(f){n.type==="property"&&(n.length=f-n.offset,n=n.parent)}function a(f){return n.children.push(f),f}p(t,{onObjectBegin:f=>{n=a({type:"object",offset:f,length:-1,parent:n,children:[]})},onObjectProperty:(f,O,x)=>{n=a({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:f,offset:O,length:x,parent:n})},onObjectEnd:(f,O)=>{n.length=f+O-n.offset,n=n.parent,r(f+O)},onArrayBegin:(f,O)=>{n=a({type:"array",offset:f,length:-1,parent:n,children:[]})},onArrayEnd:(f,O)=>{n.length=f+O-n.offset,n=n.parent,r(f+O)},onLiteralValue:(f,O,x)=>{a({type:b(f),offset:O,length:x,parent:n,value:f}),r(O+x)},onSeparator:(f,O,x)=>{n.type==="property"&&(f===":"?n.colonOffset=O:f===","&&r(O))},onError:(f,O,x)=>{s.push({error:f,offset:O,length:x})}},i);const h=n.children[0];return h&&delete h.parent,h}e.parseTree=S;function E(t,s){if(!t)return;let i=t;for(const n of s)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=E;function T(t){if(!t.parent||!t.parent.children)return[];const s=T(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}e.getNodePath=T;function l(t){switch(t.type){case"array":return t.children.map(l);case"object":{const s=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(s[i.children[0].value]=l(n))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=l;function u(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}e.contains=u;function m(t,s,i=!1){if(u(t,s,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const a=m(n[r],s,i);if(a)return a}return t}}e.findNodeAtOffset=m;function p(t,s,i=R.DEFAULT){const n=I(t,!1);function r(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(K){return K?J=>K(J,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=r(s.onObjectBegin),h=a(s.onObjectProperty),f=r(s.onObjectEnd),O=r(s.onArrayBegin),x=r(s.onArrayEnd),_=a(s.onLiteralValue),ee=a(s.onSeparator),se=r(s.onComment),oe=a(s.onError),ae=i&&i.disallowComments,Y=i&&i.allowTrailingComma;function y(){for(;;){const K=n.scan();switch(n.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:ae||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(K){case 12:case 13:ae?M(10):se();break;case 16:M(1);break;case 15:case 14:break;default:return K}}}function M(K,J=[],F=[]){if(oe(K),J.length+F.length>0){let C=n.getToken();for(;C!==17;){if(J.indexOf(C)!==-1){y();break}else if(F.indexOf(C)!==-1)break;C=y()}}}function U(K){const J=n.getTokenValue();return K?_(J):h(J),y(),!0}function $(){switch(n.getToken()){case 11:{let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(M(2),K=0)}catch{M(2)}_(K);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return y(),!0}function V(){return n.getToken()!==10?(M(3,[],[2,5]),!1):(U(!1),n.getToken()===6?(ee(":"),y(),G()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function j(){o(),y();let K=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(K||M(4,[],[]),ee(","),y(),n.getToken()===2&&Y)break}else K&&M(6,[],[]);V()||M(4,[],[2,5]),K=!0}return f(),n.getToken()!==2?M(7,[2],[]):y(),!0}function W(){O(),y();let K=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(K||M(4,[],[]),ee(","),y(),n.getToken()===4&&Y)break}else K&&M(6,[],[]);G()||M(4,[],[4,5]),K=!0}return x(),n.getToken()!==4?M(8,[4],[]):y(),!0}function G(){switch(n.getToken()){case 3:return W();case 1:return j();case 10:return U(!0);default:return $()}}return y(),n.getToken()===17?i.allowEmptyContent?!0:(M(4,[],[]),!1):G()?(n.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=p;function g(t,s){const i=I(t),n=[];let r,a=0,o;do switch(o=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:a!==o&&n.push(t.substring(a,o)),s!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,s)),a=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=g;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(ne[71],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function N(P,d,c){return Math.min(Math.max(P,d),c)}e.clamp=N;function L(P,d){return(d+P%d)%d}e.rot=L;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class R{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class I{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const c=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=I}),function(){function H(D){const R=[];typeof D=="number"&&R.push("code/timeOrigin",D);function I(d){R.push(d,Date.now())}function P(){const d=[];for(let c=0;c<R.length;c+=2)d.push({name:R[c],startTime:R[c+1]});return d}return{mark:I,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const I of performance.getEntriesByType("mark"))R.push({name:I.name,startTime:Math.round(D+I.startTime)});return R}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function N(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=N(L))}(),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var N=e();for(var L in N)(typeof exports=="object"?exports:H)[L]=N[L]}}(typeof self<"u"?self:this,function(){return function(H){var e={};function N(L){if(e[L])return e[L].exports;var D=e[L]={i:L,l:!1,exports:{}};return H[L].call(D.exports,D,D.exports,N),D.l=!0,D.exports}return N.m=H,N.c=e,N.d=function(L,D,R){N.o(L,D)||Object.defineProperty(L,D,{enumerable:!0,get:R})},N.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},N.t=function(L,D){if(1&D&&(L=N(L)),8&D||4&D&&typeof L=="object"&&L&&L.__esModule)return L;var R=Object.create(null);if(N.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:L}),2&D&&typeof L!="string")for(var I in L)N.d(R,I,function(P){return L[P]}.bind(null,I));return R},N.n=function(L){var D=L&&L.__esModule?function(){return L.default}:function(){return L};return N.d(D,"a",D),D},N.o=function(L,D){return Object.prototype.hasOwnProperty.call(L,D)},N.p="",N(N.s=0)}([function(H,e,N){(function(L){var D;e=H.exports=F,D=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],d=e.src=[],c=0,k=c++;d[k]="0|[1-9]\\d*";var w=c++;d[w]="[0-9]+";var v=c++;d[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=c++;d[S]="("+d[k]+")\\.("+d[k]+")\\.("+d[k]+")";var E=c++;d[E]="("+d[w]+")\\.("+d[w]+")\\.("+d[w]+")";var T=c++;d[T]="(?:"+d[k]+"|"+d[v]+")";var l=c++;d[l]="(?:"+d[w]+"|"+d[v]+")";var u=c++;d[u]="(?:-("+d[T]+"(?:\\."+d[T]+")*))";var m=c++;d[m]="(?:-?("+d[l]+"(?:\\."+d[l]+")*))";var p=c++;d[p]="[0-9A-Za-z-]+";var g=c++;d[g]="(?:\\+("+d[p]+"(?:\\."+d[p]+")*))";var b=c++,t="v?"+d[S]+d[u]+"?"+d[g]+"?";d[b]="^"+t+"$";var s="[v=\\s]*"+d[E]+d[m]+"?"+d[g]+"?",i=c++;d[i]="^"+s+"$";var n=c++;d[n]="((?:<|>)?=?)";var r=c++;d[r]=d[w]+"|x|X|\\*";var a=c++;d[a]=d[k]+"|x|X|\\*";var o=c++;d[o]="[v=\\s]*("+d[a]+")(?:\\.("+d[a]+")(?:\\.("+d[a]+")(?:"+d[u]+")?"+d[g]+"?)?)?";var h=c++;d[h]="[v=\\s]*("+d[r]+")(?:\\.("+d[r]+")(?:\\.("+d[r]+")(?:"+d[m]+")?"+d[g]+"?)?)?";var f=c++;d[f]="^"+d[n]+"\\s*"+d[o]+"$";var O=c++;d[O]="^"+d[n]+"\\s*"+d[h]+"$";var x=c++;d[x]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=c++;d[_]="(?:~>?)";var ee=c++;d[ee]="(\\s*)"+d[_]+"\\s+",P[ee]=new RegExp(d[ee],"g");var se=c++;d[se]="^"+d[_]+d[o]+"$";var oe=c++;d[oe]="^"+d[_]+d[h]+"$";var ae=c++;d[ae]="(?:\\^)";var Y=c++;d[Y]="(\\s*)"+d[ae]+"\\s+",P[Y]=new RegExp(d[Y],"g");var y=c++;d[y]="^"+d[ae]+d[o]+"$";var M=c++;d[M]="^"+d[ae]+d[h]+"$";var U=c++;d[U]="^"+d[n]+"\\s*("+s+")$|^$";var $=c++;d[$]="^"+d[n]+"\\s*("+t+")$|^$";var V=c++;d[V]="(\\s*)"+d[n]+"\\s*("+s+"|"+d[o]+")",P[V]=new RegExp(d[V],"g");var j=c++;d[j]="^\\s*("+d[o]+")\\s+-\\s+("+d[o]+")\\s*$";var W=c++;d[W]="^\\s*("+d[h]+")\\s+-\\s+("+d[h]+")\\s*$";var G=c++;d[G]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)D(K,d[K]),P[K]||(P[K]=new RegExp(d[K]));function J(q,X){if(q instanceof F)return q;if(typeof q!="string"||q.length>R||!(X?P[i]:P[b]).test(q))return null;try{return new F(q,X)}catch{return null}}function F(q,X){if(q instanceof F){if(q.loose===X)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof F))return new F(q,X);D("SemVer",q,X),this.loose=X;var te=q.trim().match(X?P[i]:P[b]);if(!te)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+te[1],this.minor=+te[2],this.patch=+te[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");te[4]?this.prerelease=te[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var ye=+he;if(ye>=0&&ye<I)return ye}return he}):this.prerelease=[],this.build=te[5]?te[5].split("."):[],this.format()}e.parse=J,e.valid=function(q,X){var te=J(q,X);return te?te.version:null},e.clean=function(q,X){var te=J(q.trim().replace(/^[=v]+/,""),X);return te?te.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(q){return D("SemVer.compare",this.version,this.loose,q),q instanceof F||(q=new F(q,this.loose)),this.compareMain(q)||this.comparePre(q)},F.prototype.compareMain=function(q){return q instanceof F||(q=new F(q,this.loose)),A(this.major,q.major)||A(this.minor,q.minor)||A(this.patch,q.patch)},F.prototype.comparePre=function(q){if(q instanceof F||(q=new F(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var X=0;do{var te=this.prerelease[X],he=q.prerelease[X];if(D("prerelease compare",X,te,he),te===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(te===void 0)return-1;if(te!==he)return A(te,he)}while(++X)},F.prototype.inc=function(q,X){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",X);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",X);break;case"prepatch":this.prerelease.length=0,this.inc("patch",X),this.inc("pre",X);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",X),this.inc("pre",X);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var te=this.prerelease.length;--te>=0;)typeof this.prerelease[te]=="number"&&(this.prerelease[te]++,te=-2);te===-1&&this.prerelease.push(0)}X&&(this.prerelease[0]===X?isNaN(this.prerelease[1])&&(this.prerelease=[X,0]):this.prerelease=[X,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,X,te,he){typeof te=="string"&&(he=te,te=void 0);try{return new F(q,te).inc(X,he).version}catch{return null}},e.diff=function(q,X){if(Z(q,X))return null;var te=J(q),he=J(X);if(te.prerelease.length||he.prerelease.length){for(var ye in te)if((ye==="major"||ye==="minor"||ye==="patch")&&te[ye]!==he[ye])return"pre"+ye;return"prerelease"}for(var ye in te)if((ye==="major"||ye==="minor"||ye==="patch")&&te[ye]!==he[ye])return ye},e.compareIdentifiers=A;var C=/^[0-9]+$/;function A(q,X){var te=C.test(q),he=C.test(X);return te&&he&&(q=+q,X=+X),te&&!he?-1:he&&!te?1:q<X?-1:q>X?1:0}function z(q,X,te){return new F(q,te).compare(new F(X,te))}function B(q,X,te){return z(q,X,te)>0}function Q(q,X,te){return z(q,X,te)<0}function Z(q,X,te){return z(q,X,te)===0}function le(q,X,te){return z(q,X,te)!==0}function ue(q,X,te){return z(q,X,te)>=0}function Ee(q,X,te){return z(q,X,te)<=0}function pe(q,X,te,he){var ye;switch(X){case"===":typeof q=="object"&&(q=q.version),typeof te=="object"&&(te=te.version),ye=q===te;break;case"!==":typeof q=="object"&&(q=q.version),typeof te=="object"&&(te=te.version),ye=q!==te;break;case"":case"=":case"==":ye=Z(q,te,he);break;case"!=":ye=le(q,te,he);break;case">":ye=B(q,te,he);break;case">=":ye=ue(q,te,he);break;case"<":ye=Q(q,te,he);break;case"<=":ye=Ee(q,te,he);break;default:throw new TypeError("Invalid operator: "+X)}return ye}function fe(q,X){if(q instanceof fe){if(q.loose===X)return q;q=q.value}if(!(this instanceof fe))return new fe(q,X);D("comparator",q,X),this.loose=X,this.parse(q),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(q,X){return A(X,q)},e.major=function(q,X){return new F(q,X).major},e.minor=function(q,X){return new F(q,X).minor},e.patch=function(q,X){return new F(q,X).patch},e.compare=z,e.compareLoose=function(q,X){return z(q,X,!0)},e.rcompare=function(q,X,te){return z(X,q,te)},e.sort=function(q,X){return q.sort(function(te,he){return e.compare(te,he,X)})},e.rsort=function(q,X){return q.sort(function(te,he){return e.rcompare(te,he,X)})},e.gt=B,e.lt=Q,e.eq=Z,e.neq=le,e.gte=ue,e.lte=Ee,e.cmp=pe,e.Comparator=fe;var ge={};function me(q,X){if(q instanceof me)return q.loose===X?q:new me(q.raw,X);if(q instanceof fe)return new me(q.value,X);if(!(this instanceof me))return new me(q,X);if(this.loose=X,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(te){return this.parseRange(te.trim())},this).filter(function(te){return te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function ce(q){return!q||q.toLowerCase()==="x"||q==="*"}function ve(q,X,te,he,ye,Oe,Ie,Ae,De,Ne,Ue,Re,Te){return((X=ce(te)?"":ce(he)?">="+te+".0.0":ce(ye)?">="+te+"."+he+".0":">="+X)+" "+(Ae=ce(De)?"":ce(Ne)?"<"+(+De+1)+".0.0":ce(Ue)?"<"+De+"."+(+Ne+1)+".0":Re?"<="+De+"."+Ne+"."+Ue+"-"+Re:"<="+Ae)).trim()}function Se(q,X){for(var te=0;te<q.length;te++)if(!q[te].test(X))return!1;if(X.prerelease.length){for(te=0;te<q.length;te++)if(D(q[te].semver),q[te].semver!==ge&&q[te].semver.prerelease.length>0){var he=q[te].semver;if(he.major===X.major&&he.minor===X.minor&&he.patch===X.patch)return!0}return!1}return!0}function Le(q,X,te){try{X=new me(X,te)}catch{return!1}return X.test(q)}function Fe(q,X,te,he){var ye,Oe,Ie,Ae,De;switch(q=new F(q,he),X=new me(X,he),te){case">":ye=B,Oe=Ee,Ie=Q,Ae=">",De=">=";break;case"<":ye=Q,Oe=ue,Ie=B,Ae="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(q,X,he))return!1;for(var Ne=0;Ne<X.set.length;++Ne){var Ue=X.set[Ne],Re=null,Te=null;if(Ue.forEach(function(Ce){Ce.semver===ge&&(Ce=new fe(">=0.0.0")),Re=Re||Ce,Te=Te||Ce,ye(Ce.semver,Re.semver,he)?Re=Ce:Ie(Ce.semver,Te.semver,he)&&(Te=Ce)}),Re.operator===Ae||Re.operator===De||(!Te.operator||Te.operator===Ae)&&Oe(q,Te.semver)||Te.operator===De&&Ie(q,Te.semver))return!1}return!0}fe.prototype.parse=function(q){var X=this.loose?P[U]:P[$],te=q.match(X);if(!te)throw new TypeError("Invalid comparator: "+q);this.operator=te[1],this.operator==="="&&(this.operator=""),te[2]?this.semver=new F(te[2],this.loose):this.semver=ge},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(q){return D("Comparator.test",q,this.loose),this.semver===ge||(typeof q=="string"&&(q=new F(q,this.loose)),pe(q,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(q,X){if(!(q instanceof fe))throw new TypeError("a Comparator is required");var te;if(this.operator==="")return te=new me(q.value,X),Le(this.value,te,X);if(q.operator==="")return te=new me(this.value,X),Le(q.semver,te,X);var he=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Oe=this.semver.version===q.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Ae=pe(this.semver,"<",q.semver,X)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),De=pe(this.semver,">",q.semver,X)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return he||ye||Oe&&Ie||Ae||De},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(q){var X=this.loose;q=q.trim(),D("range",q,X);var te=X?P[W]:P[j];q=q.replace(te,ve),D("hyphen replace",q),q=q.replace(P[V],"$1$2$3"),D("comparator trim",q,P[V]),q=(q=(q=q.replace(P[ee],"$1~")).replace(P[Y],"$1^")).split(/\s+/).join(" ");var he=X?P[U]:P[$],ye=q.split(" ").map(function(Oe){return function(Ie,Ae){return D("comp",Ie),Ie=function(De,Ne){return De.trim().split(/\s+/).map(function(Ue){return function(Re,Te){D("caret",Re,Te);var Ce=Te?P[M]:P[y];return Re.replace(Ce,function(je,we,be,Pe,ke){var Me;return D("caret",Re,je,we,be,Pe,ke),ce(we)?Me="":ce(be)?Me=">="+we+".0.0 <"+(+we+1)+".0.0":ce(Pe)?Me=we==="0"?">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0":">="+we+"."+be+".0 <"+(+we+1)+".0.0":ke?(D("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Me=we==="0"?be==="0"?">="+we+"."+be+"."+Pe+ke+" <"+we+"."+be+"."+(+Pe+1):">="+we+"."+be+"."+Pe+ke+" <"+we+"."+(+be+1)+".0":">="+we+"."+be+"."+Pe+ke+" <"+(+we+1)+".0.0"):(D("no pr"),Me=we==="0"?be==="0"?">="+we+"."+be+"."+Pe+" <"+we+"."+be+"."+(+Pe+1):">="+we+"."+be+"."+Pe+" <"+we+"."+(+be+1)+".0":">="+we+"."+be+"."+Pe+" <"+(+we+1)+".0.0"),D("caret return",Me),Me})}(Ue,Ne)}).join(" ")}(Ie,Ae),D("caret",Ie),Ie=function(De,Ne){return De.trim().split(/\s+/).map(function(Ue){return function(Re,Te){var Ce=Te?P[oe]:P[se];return Re.replace(Ce,function(je,we,be,Pe,ke){var Me;return D("tilde",Re,je,we,be,Pe,ke),ce(we)?Me="":ce(be)?Me=">="+we+".0.0 <"+(+we+1)+".0.0":ce(Pe)?Me=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0":ke?(D("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Me=">="+we+"."+be+"."+Pe+ke+" <"+we+"."+(+be+1)+".0"):Me=">="+we+"."+be+"."+Pe+" <"+we+"."+(+be+1)+".0",D("tilde return",Me),Me})}(Ue,Ne)}).join(" ")}(Ie,Ae),D("tildes",Ie),Ie=function(De,Ne){return D("replaceXRanges",De,Ne),De.split(/\s+/).map(function(Ue){return function(Re,Te){Re=Re.trim();var Ce=Te?P[O]:P[f];return Re.replace(Ce,function(je,we,be,Pe,ke,Me){D("xRange",Re,je,we,be,Pe,ke,Me);var We=ce(be),$e=We||ce(Pe),xe=$e||ce(ke);return we==="="&&xe&&(we=""),We?je=we===">"||we==="<"?"<0.0.0":"*":we&&xe?($e&&(Pe=0),xe&&(ke=0),we===">"?(we=">=",$e?(be=+be+1,Pe=0,ke=0):xe&&(Pe=+Pe+1,ke=0)):we==="<="&&(we="<",$e?be=+be+1:Pe=+Pe+1),je=we+be+"."+Pe+"."+ke):$e?je=">="+be+".0.0 <"+(+be+1)+".0.0":xe&&(je=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0"),D("xRange return",je),je})}(Ue,Ne)}).join(" ")}(Ie,Ae),D("xrange",Ie),Ie=function(De,Ne){return D("replaceStars",De,Ne),De.trim().replace(P[G],"")}(Ie,Ae),D("stars",Ie),Ie}(Oe,X)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Oe){return!!Oe.match(he)})),ye=ye.map(function(Oe){return new fe(Oe,X)})},me.prototype.intersects=function(q,X){if(!(q instanceof me))throw new TypeError("a Range is required");return this.set.some(function(te){return te.every(function(he){return q.set.some(function(ye){return ye.every(function(Oe){return he.intersects(Oe,X)})})})})},e.toComparators=function(q,X){return new me(q,X).set.map(function(te){return te.map(function(he){return he.value}).join(" ").trim().split(" ")})},me.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new F(q,this.loose));for(var X=0;X<this.set.length;X++)if(Se(this.set[X],q))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(q,X,te){var he=null,ye=null;try{var Oe=new me(X,te)}catch{return null}return q.forEach(function(Ie){Oe.test(Ie)&&(he&&ye.compare(Ie)!==-1||(ye=new F(he=Ie,te)))}),he},e.minSatisfying=function(q,X,te){var he=null,ye=null;try{var Oe=new me(X,te)}catch{return null}return q.forEach(function(Ie){Oe.test(Ie)&&(he&&ye.compare(Ie)!==1||(ye=new F(he=Ie,te)))}),he},e.validRange=function(q,X){try{return new me(q,X).range||"*"}catch{return null}},e.ltr=function(q,X,te){return Fe(q,X,"<",te)},e.gtr=function(q,X,te){return Fe(q,X,">",te)},e.outside=Fe,e.prerelease=function(q,X){var te=J(q,X);return te&&te.prerelease.length?te.prerelease:null},e.intersects=function(q,X,te){return q=new me(q,te),X=new me(X,te),q.intersects(X)},e.coerce=function(q){if(q instanceof F)return q;if(typeof q!="string")return null;var X=q.match(P[x]);return X==null?null:J((X[1]||"0")+"."+(X[2]||"0")+"."+(X[3]||"0"))}}).call(this,N(1))},function(H,e){var N,L,D=H.exports={};function R(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function P(l){if(N===setTimeout)return setTimeout(l,0);if((N===R||!N)&&setTimeout)return N=setTimeout,setTimeout(l,0);try{return N(l,0)}catch{try{return N.call(null,l,0)}catch{return N.call(this,l,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:R}catch{N=R}try{L=typeof clearTimeout=="function"?clearTimeout:I}catch{L=I}})();var d,c=[],k=!1,w=-1;function v(){k&&d&&(k=!1,d.length?c=d.concat(c):w=-1,c.length&&S())}function S(){if(!k){var l=P(v);k=!0;for(var u=c.length;u;){for(d=c,c=[];++w<u;)d&&d[w].run();w=-1,u=c.length}d=null,k=!1,function(m){if(L===clearTimeout)return clearTimeout(m);if((L===I||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(m);try{L(m)}catch{try{return L.call(null,m)}catch{return L.call(this,m)}}}(l)}}function E(l,u){this.fun=l,this.array=u}function T(){}D.nextTick=function(l){var u=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)u[m-1]=arguments[m];c.push(new E(l,u)),c.length!==1||k||P(S)},E.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=T,D.addListener=T,D.once=T,D.off=T,D.removeListener=T,D.removeAllListeners=T,D.emit=T,D.prependListener=T,D.prependOnceListener=T,D.listeners=function(l){return[]},D.binding=function(l){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(l){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ne[72],re([0,1]),function(H,e){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(P,d,c){this.level=P,this.key=d,this.value=c,this.forward=[]}}const D=void 0;class R{constructor(P,d=2**16){this.comparator=P,this[N]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new L(this.c,D,D)}get size(){return this.f}clear(){this.e=new L(this.c,D,D)}has(P){return Boolean(R.g(this,P,this.comparator))}get(P){return R.g(this,P,this.comparator)?.value}set(P,d){return R.h(this,P,d,this.comparator)&&(this.f+=1),this}delete(P){const d=R.k(this,P,this.comparator);return d&&(this.f-=1),d}forEach(P,d){let c=this.e.forward[0];for(;c;)P.call(d,c.value,c.key,this),c=c.forward[0]}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",d=this.e.forward[0];for(;d;)P+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return P}static g(P,d,c){let k=P.e;for(let w=P.d-1;w>=0;w--)for(;k.forward[w]&&c(k.forward[w].key,d)<0;)k=k.forward[w];if(k=k.forward[0],k&&c(k.key,d)===0)return k}static h(P,d,c,k){const w=[];let v=P.e;for(let S=P.d-1;S>=0;S--){for(;v.forward[S]&&k(v.forward[S].key,d)<0;)v=v.forward[S];w[S]=v}if(v=v.forward[0],v&&k(v.key,d)===0)return v.value=c,!1;{const S=R.j(P);if(S>P.d){for(let E=P.d;E<S;E++)w[E]=P.e;P.d=S}v=new L(S,d,c);for(let E=0;E<S;E++)v.forward[E]=w[E].forward[E],w[E].forward[E]=v;return!0}}static j(P,d=.5){let c=1;for(;Math.random()<d&&c<P.c;)c+=1;return c}static k(P,d,c){const k=[];let w=P.e;for(let v=P.d-1;v>=0;v--){for(;w.forward[v]&&c(w.forward[v].key,d)<0;)w=w.forward[v];k[v]=w}if(w=w.forward[0],!w||c(w.key,d)!==0)return!1;for(let v=0;v<P.d&&k[v].forward[v]===w;v++)k[v].forward[v]=w.forward[v];for(;P.d>0&&P.e.forward[P.d-1]===D;)P.d-=1;return!0}}e.SkipList=R}),define(ne[44],re([0,1,7,2]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(g){const b=g;return b?typeof b.read=="function":!1}e.isReadable=D;function R(g){const b=g;return b?[b.on,b.pause,b.resume,b.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function I(g){const b=g;return b?R(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.isReadableBufferedStream=I;function P(g,b){return new d(g,b)}e.newWriteableStream=P;class d{constructor(b,t){this.e=b,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(t=>t(b))}h(b){this.c.error.length===0?(0,N.onUnexpectedError)(b):this.c.error.slice(0).forEach(t=>t(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,t){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(b,t){if(this.a.destroyed)return;let s;switch(b){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const i=s.indexOf(t);i>=0&&s.splice(i,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(g,b){const t=[];let s;for(;(s=g.read())!==null;)t.push(s);return b(t)}e.consumeReadable=c;function k(g,b,t){const s=[];let i;for(;(i=g.read())!==null&&s.length<t;)s.push(i);return i===null&&s.length>0?b(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return g.read()}}}e.peekReadable=k;function w(g,b){return new Promise((t,s)=>{const i=[];v(g,{onData:n=>{b&&i.push(n)},onError:n=>{b?s(n):t(void 0)},onEnd:()=>{t(b?b(i):void 0)}})})}e.consumeStream=w;function v(g,b){let t=!1;return g.on("error",s=>{t||b.onError(s)}),g.on("end",()=>{t||b.onEnd()}),g.on("data",s=>{t||b.onData(s)}),(0,L.toDisposable)(()=>t=!0)}e.listenStream=v;function S(g,b){return new Promise((t,s)=>{const i=new L.DisposableStore,n=[],r=h=>{if(n.push(h),n.length>b)return i.dispose(),g.pause(),t({stream:g,buffer:n,ended:!1})},a=h=>s(h),o=()=>t({stream:g,buffer:n,ended:!0});i.add((0,L.toDisposable)(()=>g.removeListener("error",a))),g.on("error",a),i.add((0,L.toDisposable)(()=>g.removeListener("end",o))),g.on("end",o),i.add((0,L.toDisposable)(()=>g.removeListener("data",r))),g.on("data",r)})}e.peekStream=S;function E(g,b){const t=P(b);return t.end(g),t}e.toStream=E;function T(){const g=P(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=T;function l(g){let b=!1;return{read:()=>b?null:(b=!0,g)}}e.toReadable=l;function u(g,b,t){const s=P(t);return v(g,{onData:i=>s.write(b.data(i)),onError:i=>s.error(b.error?b.error(i):i),onEnd:()=>s.end()}),s}e.transform=u;function m(g,b,t){let s=!1;return{read:()=>{const i=b.read();return s?i:(s=!0,i!==null?t([g,i]):g)}}}e.prefixedReadable=m;function p(g,b,t){let s=!1;const i=P(t);return v(b,{onData:n=>s?i.write(n):(s=!0,i.write(t([g,n]))),onError:n=>i.error(n),onEnd:()=>{s||(s=!0,i.write(g)),i.end()}}),i}e.prefixedStream=p}),define(ne[14],re([0,1,44]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer<"u";let D,R;class I{static alloc(h){return L?new I(Buffer.allocUnsafe(h)):new I(new Uint8Array(h))}static wrap(h){return L&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new I(h)}static fromString(h,f){return!(f?.dontUseNodeBuffer||!1)&&L?new I(Buffer.from(h)):(D||(D=new TextEncoder),new I(D.encode(h)))}static fromByteArray(h){const f=I.alloc(h.length);for(let O=0,x=h.length;O<x;O++)f.buffer[O]=h[O];return f}static concat(h,f){if(typeof f>"u"){f=0;for(let _=0,ee=h.length;_<ee;_++)f+=h[_].byteLength}const O=I.alloc(f);let x=0;for(let _=0,ee=h.length;_<ee;_++){const se=h[_];O.set(se,x),x+=se.byteLength}return O}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=I.alloc(this.byteLength);return h.set(this),h}toString(){return L?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(h,f){return new I(this.buffer.subarray(h,f))}set(h,f){if(h instanceof I)this.buffer.set(h.buffer,f);else if(h instanceof Uint8Array)this.buffer.set(h,f);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),f);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return c(this.buffer,h)}writeUInt32BE(h,f){k(this.buffer,h,f)}readUInt32LE(h){return w(this.buffer,h)}writeUInt32LE(h,f){v(this.buffer,h,f)}readUInt8(h){return S(this.buffer,h)}writeUInt8(h,f){E(this.buffer,h,f)}}e.VSBuffer=I;function P(o,h){return o[h+0]<<0>>>0|o[h+1]<<8>>>0}e.readUInt16LE=P;function d(o,h,f){o[f+0]=h&255,h=h>>>8,o[f+1]=h&255}e.writeUInt16LE=d;function c(o,h){return o[h]*2**24+o[h+1]*2**16+o[h+2]*2**8+o[h+3]}e.readUInt32BE=c;function k(o,h,f){o[f+3]=h,h=h>>>8,o[f+2]=h,h=h>>>8,o[f+1]=h,h=h>>>8,o[f]=h}e.writeUInt32BE=k;function w(o,h){return o[h+0]<<0>>>0|o[h+1]<<8>>>0|o[h+2]<<16>>>0|o[h+3]<<24>>>0}e.readUInt32LE=w;function v(o,h,f){o[f+0]=h&255,h=h>>>8,o[f+1]=h&255,h=h>>>8,o[f+2]=h&255,h=h>>>8,o[f+3]=h&255}e.writeUInt32LE=v;function S(o,h){return o[h]}e.readUInt8=S;function E(o,h,f){o[f]=h}e.writeUInt8=E;function T(o){return N.consumeReadable(o,h=>I.concat(h))}e.readableToBuffer=T;function l(o){return N.toReadable(o)}e.bufferToReadable=l;function u(o){return N.consumeStream(o,h=>I.concat(h))}e.streamToBuffer=u;async function m(o){return o.ended?I.concat(o.buffer):I.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=m;function p(o){return N.toStream(o,h=>I.concat(h))}e.bufferToStream=p;function g(o){return N.transform(o,{data:h=>typeof h=="string"?I.fromString(h):I.wrap(h)},h=>I.concat(h))}e.streamToBufferReadableStream=g;function b(o){return N.newWriteableStream(h=>I.concat(h),o)}e.newWriteableBufferStream=b;function t(o,h){return N.prefixedReadable(o,h,f=>I.concat(f))}e.prefixedBufferReadable=t;function s(o,h){return N.prefixedStream(o,h,f=>I.concat(f))}e.prefixedBufferStream=s;function i(o){let h=0,f=0,O=0;const x=new Uint8Array(Math.floor(o.length/4*3)),_=se=>{switch(f){case 3:x[O++]=h|se,f=0;break;case 2:x[O++]=h|se>>>2,h=se<<6,f=3;break;case 1:x[O++]=h|se>>>4,h=se<<4,f=2;break;default:h=se<<2,f=1}};for(let se=0;se<o.length;se++){const oe=o.charCodeAt(se);if(oe>=65&&oe<=90)_(oe-65);else if(oe>=97&&oe<=122)_(oe-97+26);else if(oe>=48&&oe<=57)_(oe-48+52);else if(oe===43||oe===45)_(62);else if(oe===47||oe===95)_(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${o[se]}`)}}const ee=O;for(;f>0;)_(0);return I.wrap(x).slice(0,ee)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:o},h=!0,f=!1){const O=f?r:n;let x="";const _=o.byteLength%3;let ee=0;for(;ee<o.byteLength-_;ee+=3){const se=o[ee+0],oe=o[ee+1],ae=o[ee+2];x+=O[se>>>2],x+=O[(se<<4|oe>>>4)&63],x+=O[(oe<<2|ae>>>6)&63],x+=O[ae&63]}if(_===1){const se=o[ee+0];x+=O[se>>>2],x+=O[se<<4&63],h&&(x+="==")}else if(_===2){const se=o[ee+0],oe=o[ee+1];x+=O[se>>>2],x+=O[(se<<4|oe>>>4)&63],x+=O[oe<<2&63],h&&(x+="=")}return x}e.encodeBase64=a}),define(ne[30],re([0,1,3]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([p,g])=>{m[p]=g&&typeof g=="object"?L(g):g}),m}e.deepClone=L;function D(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const p=m.shift();Object.freeze(p);for(const g in p)if(R.call(p,g)){const b=p[g];typeof b=="object"&&!Object.isFrozen(b)&&!(0,N.isTypedArray)(b)&&m.push(b)}}return u}e.deepFreeze=D;const R=Object.prototype.hasOwnProperty;function I(u,m){return P(u,m,new Set)}e.cloneAndChange=I;function P(u,m,p){if((0,N.isUndefinedOrNull)(u))return u;const g=m(u);if(typeof g<"u")return g;if(Array.isArray(u)){const b=[];for(const t of u)b.push(P(t,m,p));return b}if((0,N.isObject)(u)){if(p.has(u))throw new Error("Cannot clone recursive data-structure");p.add(u);const b={};for(const t in u)R.call(u,t)&&(b[t]=P(u[t],m,p));return p.delete(u),b}return u}function d(u,m,p=!0){return(0,N.isObject)(u)?((0,N.isObject)(m)&&Object.keys(m).forEach(g=>{g in u?p&&((0,N.isObject)(u[g])&&(0,N.isObject)(m[g])?d(u[g],m[g],p):u[g]=m[g]):u[g]=m[g]}),u):m}e.mixin=d;function c(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let p,g;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(p=0;p<u.length;p++)if(!c(u[p],m[p]))return!1}else{const b=[];for(g in u)b.push(g);b.sort();const t=[];for(g in m)t.push(g);if(t.sort(),!c(b,t))return!1;for(p=0;p<b.length;p++)if(!c(u[b[p]],m[b[p]]))return!1}return!0}e.equals=c;function k(u){const m=new Set;return JSON.stringify(u,(p,g)=>{if((0,N.isObject)(g)||Array.isArray(g)){if(m.has(g))return"[Circular]";m.add(g)}return g})}e.safeStringify=k;function w(u,m){const p=Object.create(null);return!u||!m||Object.keys(m).forEach(b=>{const t=u[b],s=m[b];c(t,s)||(p[b]=s)}),p}e.distinct=w;function v(u,m){const p=m.toLowerCase(),g=Object.keys(u).find(b=>b.toLowerCase()===p);return g?u[g]:u[m]}e.getCaseInsensitive=v;function S(u,m){const p=Object.create(null);for(const[g,b]of Object.entries(u))m(g,b)&&(p[g]=b);return p}e.filter=S;function E(u){let m=[],p=Object.getPrototypeOf(u);for(;Object.prototype!==p;)m=m.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return m}e.getAllPropertyNames=E;function T(u){const m=[];for(const p of E(u))typeof u[p]=="function"&&m.push(p);return m}e.getAllMethodNames=T;function l(u,m){const p=b=>function(){const t=Array.prototype.slice.call(arguments,0);return m(b,t)},g={};for(const b of u)g[b]=p(b);return g}e.createProxyObject=l}),define(ne[28],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const N=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(D){return N.test(D)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(P){for(let d=0;d<P.length;d++)P[d]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),I=[];for(let P=0;P<256;P++)I.push(P.toString(16).padStart(2,"0"));return function(){D(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let d=0,c="";return c+=I[R[d++]],c+=I[R[d++]],c+=I[R[d++]],c+=I[R[d++]],c+="-",c+=I[R[d++]],c+=I[R[d++]],c+="-",c+=I[R[d++]],c+=I[R[d++]],c+="-",c+=I[R[d++]],c+=I[R[d++]],c+="-",c+=I[R[d++]],c+=I[R[d++]],c+=I[R[d++]],c+=I[R[d++]],c+=I[R[d++]],c+=I[R[d++]],c}}()}),define(ne[73],re([0,1,33]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(I){const P=I.replace(/\-/g,":").toLowerCase();return!L.has(P)}function R(){const I=(0,N.networkInterfaces)();for(const P in I){const d=I[P];if(d){for(const{mac:c}of d)if(D(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(ne[74],re([10,8]),function(H,e){return H.create("vs/base/common/date",e)}),define(ne[75],re([0,1,74]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,R=D*24,I=R*7,P=R*30,d=R*365;function c(w,v,S,E){typeof w!="number"&&(w=w.getTime());const T=Math.round((new Date().getTime()-w)/1e3);if(T<-30)return(0,N.localize)(0,null,c(new Date().getTime()+T*1e3,!1));if(!E&&T<30)return(0,N.localize)(1,null);let l;return T<L?(l=T,v?l===1?S?(0,N.localize)(2,null,l):(0,N.localize)(3,null,l):S?(0,N.localize)(4,null,l):(0,N.localize)(5,null,l):l===1?S?(0,N.localize)(6,null,l):(0,N.localize)(7,null,l):S?(0,N.localize)(8,null,l):(0,N.localize)(9,null,l)):T<D?(l=Math.floor(T/L),v?l===1?S?(0,N.localize)(10,null,l):(0,N.localize)(11,null,l):S?(0,N.localize)(12,null,l):(0,N.localize)(13,null,l):l===1?S?(0,N.localize)(14,null,l):(0,N.localize)(15,null,l):S?(0,N.localize)(16,null,l):(0,N.localize)(17,null,l)):T<R?(l=Math.floor(T/D),v?l===1?S?(0,N.localize)(18,null,l):(0,N.localize)(19,null,l):S?(0,N.localize)(20,null,l):(0,N.localize)(21,null,l):l===1?S?(0,N.localize)(22,null,l):(0,N.localize)(23,null,l):S?(0,N.localize)(24,null,l):(0,N.localize)(25,null,l)):T<I?(l=Math.floor(T/R),v?l===1?(0,N.localize)(26,null,l):(0,N.localize)(27,null,l):l===1?(0,N.localize)(28,null,l):(0,N.localize)(29,null,l)):T<P?(l=Math.floor(T/I),v?l===1?S?(0,N.localize)(30,null,l):(0,N.localize)(31,null,l):S?(0,N.localize)(32,null,l):(0,N.localize)(33,null,l):l===1?S?(0,N.localize)(34,null,l):(0,N.localize)(35,null,l):S?(0,N.localize)(36,null,l):(0,N.localize)(37,null,l)):T<d?(l=Math.floor(T/P),v?l===1?S?(0,N.localize)(38,null,l):(0,N.localize)(39,null,l):S?(0,N.localize)(40,null,l):(0,N.localize)(41,null,l):l===1?S?(0,N.localize)(42,null,l):(0,N.localize)(43,null,l):S?(0,N.localize)(44,null,l):(0,N.localize)(45,null,l)):(l=Math.floor(T/d),v?l===1?S?(0,N.localize)(46,null,l):(0,N.localize)(47,null,l):S?(0,N.localize)(48,null,l):(0,N.localize)(49,null,l):l===1?S?(0,N.localize)(50,null,l):(0,N.localize)(51,null,l):S?(0,N.localize)(52,null,l):(0,N.localize)(53,null,l))}e.fromNow=c;function k(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=k}),define(ne[76],re([10,8]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,76]),function(H,e,N,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(w,v){return v&&(w.stack||w.stacktrace)?D.localize(0,null,P(w),I(w.stack)||I(w.stacktrace)):P(w)}function I(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?D.localize(1,null,w.message):w.message||D.localize(2,null)}function d(w=null,v=!1){if(!w)return D.localize(3,null);if(Array.isArray(w)){const S=N.coalesce(w),E=d(S[0],v);return S.length>1?D.localize(4,null,E,S.length):E}if(L.isString(w))return w;if(w.detail){const S=w.detail;if(S.error)return R(S.error,v);if(S.exception)return R(S.exception,v)}return w.stack?R(w,v):w.message?w.message:D.localize(5,null)}e.toErrorMessage=d;function c(w){const v=w;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=c;function k(w,v){let S;return typeof w=="string"?S=new Error(w):S=w,S.actions=v,S}e.createErrorWithActions=k}),define(ne[77],re([10,8]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(ne[78],re([0,1,77]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function L(D){switch(D){case 1:return(0,N.localize)(0,null);case 2:return(0,N.localize)(1,null);case 3:return(0,N.localize)(2,null);case 4:return(0,N.localize)(3,null);case 5:return(0,N.localize)(4,null);case 6:return(0,N.localize)(5,null);case 7:return(0,N.localize)(6,null);case 8:return(0,N.localize)(7,null);case 9:return(0,N.localize)(8,null);default:return""}}e.getParseErrorMessage=L}),define(ne[51],re([0,1,12]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(L=e.Source||(e.Source={}));var D;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...d){const c=d.reduce((v,S)=>(v[S]=!0,v),{}),k=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(v=>!c[v]).forEach(v=>{for(let S=0;S<k.length;S++)if(v.search(k[S])!==-1){delete P[v];break}})}e.sanitizeProcessEnvironment=R;function I(P){!P||(delete P.DEBUG,N.isMacintosh&&delete P.DYLD_LIBRARY_PATH,N.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=I}),define(ne[52],re([0,1,29]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(u){return D(u,0)}e.hash=L;function D(u,m){switch(typeof u){case"object":return u===null?R(349,m):Array.isArray(u)?d(u,m):c(u,m);case"string":return P(u,m);case"boolean":return I(u,m);case"number":return R(u,m);case"undefined":return R(937,m);default:return R(617,m)}}e.doHash=D;function R(u,m){return(m<<5)-m+u|0}e.numberHash=R;function I(u,m){return R(u?433:863,m)}function P(u,m){m=R(149417,m);for(let p=0,g=u.length;p<g;p++)m=R(u.charCodeAt(p),m);return m}e.stringHash=P;function d(u,m){return m=R(104579,m),u.reduce((p,g)=>D(g,p),m)}function c(u,m){return m=R(181387,m),Object.keys(u).sort().reduce((p,g)=>(p=P(g,p),D(u[g],p)),m)}class k{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=D(m,this.g),this.g}}e.Hasher=k;var w;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function v(u,m,p=32){const g=p-m,b=~((1<<g)-1);return(u<<m|(b&u)>>>g)>>>0}function S(u,m=0,p=u.byteLength,g=0){for(let b=0;b<p;b++)u[m+b]=g}function E(u,m,p="0"){for(;u.length<m;)u=p+u;return u}function T(u,m=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(p=>p.toString(16).padStart(2,"0")).join(""):E((u>>>0).toString(16),m/4)}e.toHexString=T;class l{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const p=m.length;if(p===0)return;const g=this.p;let b=this.r,t=this.u,s,i;for(t!==0?(s=t,i=-1,t=0):(s=m.charCodeAt(0),i=0);;){let n=s;if(N.isHighSurrogate(s))if(i+1<p){const r=m.charCodeAt(i+1);N.isLowSurrogate(r)?(i++,n=N.computeCodePoint(s,r)):n=65533}else{t=s;break}else N.isLowSurrogate(s)&&(n=65533);if(b=this.w(g,b,n),i++,i<p)s=m.charCodeAt(i);else break}this.r=b,this.u=t}w(m,p,g){return g<128?m[p++]=g:g<2048?(m[p++]=192|(g&1984)>>>6,m[p++]=128|(g&63)>>>0):g<65536?(m[p++]=224|(g&61440)>>>12,m[p++]=128|(g&4032)>>>6,m[p++]=128|(g&63)>>>0):(m[p++]=240|(g&1835008)>>>18,m[p++]=128|(g&258048)>>>12,m[p++]=128|(g&4032)>>>6,m[p++]=128|(g&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),T(this.h)+T(this.l)+T(this.m)+T(this.n)+T(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=l.g,p=this.q;for(let o=0;o<64;o+=4)m.setUint32(o,p.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)m.setUint32(o,v(m.getUint32(o-12,!1)^m.getUint32(o-32,!1)^m.getUint32(o-56,!1)^m.getUint32(o-64,!1),1),!1);let g=this.h,b=this.l,t=this.m,s=this.n,i=this.o,n,r,a;for(let o=0;o<80;o++)o<20?(n=b&t|~b&s,r=1518500249):o<40?(n=b^t^s,r=1859775393):o<60?(n=b&t|b&s|t&s,r=2400959708):(n=b^t^s,r=3395469782),a=v(g,5)+n+i+r+m.getUint32(o*4,!1)&4294967295,i=s,s=t,t=v(b,30),b=g,g=a;this.h=this.h+g&4294967295,this.l=this.l+b&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+i&4294967295}}l.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=l}),define(ne[53],re([0,1,29]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(L||(L={})),function(D){const R="error",I="warning",P="warn",d="info",c="ignore";function k(v){return v?N.equalsIgnoreCase(R,v)?D.Error:N.equalsIgnoreCase(I,v)||N.equalsIgnoreCase(P,v)?D.Warning:N.equalsIgnoreCase(d,v)?D.Info:D.Ignore:D.Ignore}D.fromValue=k;function w(v){switch(v){case D.Error:return R;case D.Warning:return I;case D.Info:return d;default:return c}}D.toString=w}(L||(L={})),e.default=L}),define(ne[79],re([0,1,11]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(c){const k=c;return k&&typeof k.type=="string"&&typeof k.severity=="string"}e.isRemoteConsoleLog=L;function D(c){const k=[];let w;try{const v=JSON.parse(c.arguments),S=v[v.length-1];S&&S.__$stack&&(v.pop(),w=S.__$stack),k.push(...v)}catch{k.push("Unable to log remote console arguments",c.arguments)}return{args:k,stack:w}}e.parse=D;function R(c){if(typeof c!="string")return R(D(c).stack);const k=c;if(k){const w=I(k),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(v&&v.length===4)return{uri:N.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=R;function I(c){if(!c)return c;const k=c.indexOf(`
`);return k===-1?c:c.substring(0,k)}function P(c,k){const{args:w,stack:v}=D(c),S=typeof w[0]=="string"&&w.length===1;let E=I(v);E&&(E=`(${E.trim()})`);let T=[];if(typeof w[0]=="string"?E&&S?T=[`%c[${k}] %c${w[0]} %c${E}`,d("blue"),d(""),d("grey")]:T=[`%c[${k}] %c${w[0]}`,d("blue"),d(""),...w.slice(1)]:T=[`%c[${k}]%`,d("blue"),...w],E&&!S&&T.push(E),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,T)}e.log=P;function d(c){return`color: ${c}`}}),define(ne[54],re([0,1,14,29,11]),function(H,e,N,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(c){return JSON.stringify(c,P)}e.stringify=R;function I(c){let k=JSON.parse(c);return k=d(k),k}e.parse=I;function P(c,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:(0,L.regExpFlags)(k)}:k}function d(c,k=0){if(!c||k>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return D.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof N.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let w=0;w<c.length;++w)c[w]=d(c[w],k+1);else for(const w in c)Object.hasOwnProperty.call(c,w)&&(c[w]=d(c[w],k+1))}return c}e.revive=d}),define(ne[80],re([0,1,33,7,55,28,73]),function(H,e,N,L,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(k){return this.a||(this.a=D.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(k)}value(){if(this.b===void 0){let k=0,w=0;const v=(0,N.networkInterfaces)();for(const S in v){const E=v[S];if(E)for(const{mac:T,internal:l}of E)l||(w+=1,this.c(T.toUpperCase())&&(k+=1))}this.b=w>0?k/w:0}return this.b}};let P;async function d(){return P||(P=(async()=>await c()||R.generateUuid())()),P}e.getMachineId=d;async function c(){try{const k=await new Promise((v,S)=>{H(["crypto"],v,S)}),w=(0,I.getMac)();return k.createHash("sha256").update(w,"utf8").digest("hex")}catch(k){L.onUnexpectedError(k);return}}}),define(ne[81],re([0,1,33,15,20]),function(H,e,N,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,I=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var d;(function(g){g[g.x64=0]="x64",g[g.x86=1]="x86",g[g.ARM=2]="ARM"})(d||(d={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let k;process.env.PROCESSOR_ARCHITEW6432?k=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?k=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?k=1:k=0;class w{constructor(b,t,s){this.exePath=b,this.displayName=t,this.a=s}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:g=!1}={}){return g?c===0?process.env["ProgramFiles(x86)"]||null:k===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:g=!1,findPreview:b=!1}={}){const t=v({useAlternateBitness:g});if(!t)return null;const s=L.join(t,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(s))return null;let i=-1,n=null;for(const o of await D.Promises.readdir(s)){let h=-1;if(b){const O=o.indexOf("-");if(O<0)continue;const x=o.substring(0,O);if(!R.test(x)||o.substring(O+1)!=="preview")continue;h=parseInt(x,10)}else{if(!R.test(o))continue;h=parseInt(o,10)}if(h<=i)continue;const f=L.join(s,o,"pwsh.exe");!await D.SymlinkSupport.existsFile(f)||(n=f,i=h)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",a=b?" Preview":"";return new w(n,`PowerShell${a}${r}`,!0)}async function E({findPreview:g}={}){if(!process.env.LOCALAPPDATA)return null;const b=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(b))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=g?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const i of await D.Promises.readdir(b))if(t.test(i)){const n=L.join(b,i,"pwsh.exe");return new w(n,s)}return null}function T(){const g=L.join(N.homedir(),".dotnet","tools","pwsh.exe");return new w(g,".NET Core PowerShell Global Tool")}function l(){const g=L.join(process.env.windir,c===1&&k!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(g,"Windows PowerShell",!0)}async function*u(){let g=await S();g&&(yield g),g=await S({useAlternateBitness:!0}),g&&(yield g),g=await E(),g&&(yield g),g=T(),g&&(yield g),g=await S({findPreview:!0}),g&&(yield g),g=await E({findPreview:!0}),g&&(yield g),g=await S({useAlternateBitness:!0,findPreview:!0}),g&&(yield g),g=l(),g&&(yield g)}async function*m(){for await(const g of u())await g.exists()&&(yield g)}e.enumeratePowerShellInstallations=m;async function p(){for await(const g of m())return g;return null}e.getFirstAvailablePowerShellInstallation=p}),define(ne[56],re([0,1,15,12,35,51,3,20]),function(H,e,N,L,D,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function d(w=D.env){return w.comspec||"cmd.exe"}e.getWindowsShell=d;function c(w){let v=[],S=!1;const E=function(T){if(S){v.push(T);return}(!w.send(T,u=>{if(u&&console.error(u),S=!1,v.length>0){const m=v.slice(0);v=[],m.forEach(p=>E(p))}})||L.isWindows)&&(S=!0)};return{send:E}}e.createQueuedSender=c;var k;(function(w){async function v(S,E,T){if(N.isAbsolute(S))return S;if(E===void 0&&(E=D.cwd()),N.dirname(S)!=="."||(T===void 0&&I.isString(D.env.PATH)&&(T=D.env.PATH.split(N.delimiter)),T===void 0||T.length===0))return N.join(E,S);async function u(m){if(await P.Promises.exists(m)){let p;try{p=await P.Promises.stat(m)}catch(g){g.message.startsWith("EACCES")&&(p=await P.Promises.lstat(m))}return p?!p.isDirectory():!1}return!1}for(const m of T){let p;if(N.isAbsolute(m)?p=N.join(m,S):p=N.join(E,m,S),await u(p))return p;let g=p+".com";if(await u(g)||(g=p+".exe",await u(g)))return g}return N.join(E,S)}w.findExecutable=v})(k=e.win32||(e.win32={}))}),define(ne[82],re([0,1,33,12,81,56]),function(H,e,N,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function I(w,v){return w===1?L.isWindows?k():R.getWindowsShell(v):d(w,v)}e.getSystemShell=I;let P=null;function d(w,v){if(L.isLinux&&w===2||L.isMacintosh&&w===3)return"/bin/bash";if(!P){let S;if(L.isWindows)S="/bin/bash";else{if(S=v.SHELL,!S)try{S=(0,N.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}P=S}return P}let c=null;async function k(){return c||(c=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),c}});var de=this&&this.__decorate||function(H,e,N,L){var D=arguments.length,R=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,N):L,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(H,e,N,L);else for(var P=H.length-1;P>=0;P--)(I=H[P])&&(R=(D<3?I(R):D>3?I(e,N,R):I(e,N))||R);return D>3&&R&&Object.defineProperty(e,N,R),R};define(ne[57],re([0,1,19,6,14,23,49,7,4,2,54,29,3]),function(H,e,N,L,D,R,I,P,d,c,k,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var S;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(S||(S={}));function E(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var T;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(T||(T={}));function l(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(u||(u={}));function m(V){let j=0;for(let W=0;;W+=7){const G=V.read(1);if(j|=(G.buffer[0]&127)<<W,!(G.buffer[0]&128))return j}}const p=i(0);function g(V,j){if(j===0){V.write(p);return}let W=0;for(let K=j;K!==0;K=K>>>7)W++;const G=D.VSBuffer.alloc(W);for(let K=0;j!==0;K++)G.buffer[K]=j&127,j=j>>>7,j>0&&(G.buffer[K]|=128);V.write(G)}class b{constructor(j){this.b=j,this.a=0}read(j){const W=this.b.slice(this.a,this.a+j);return this.a+=W.byteLength,W}}e.BufferReader=b;class t{constructor(){this.a=[]}get buffer(){return D.VSBuffer.concat(this.a)}write(j){this.a.push(j)}}e.BufferWriter=t;var s;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(s||(s={}));function i(V){const j=D.VSBuffer.alloc(1);return j.writeUInt8(V,0),j}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object),Uint:i(s.Int)},r=typeof Buffer<"u";function a(V,j){if(typeof j>"u")V.write(n.Undefined);else if(typeof j=="string"){const W=D.VSBuffer.fromString(j);V.write(n.String),g(V,W.byteLength),V.write(W)}else if(r&&Buffer.isBuffer(j)){const W=D.VSBuffer.wrap(j);V.write(n.Buffer),g(V,W.byteLength),V.write(W)}else if(j instanceof D.VSBuffer)V.write(n.VSBuffer),g(V,j.byteLength),V.write(j);else if(Array.isArray(j)){V.write(n.Array),g(V,j.length);for(const W of j)a(V,W)}else if(typeof j=="number"&&(j|0)===j)V.write(n.Uint),g(V,j);else{const W=D.VSBuffer.fromString(JSON.stringify(j));V.write(n.Object),g(V,W.byteLength),V.write(W)}}e.serialize=a;function o(V){switch(V.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return V.read(m(V)).toString();case s.Buffer:return V.read(m(V)).buffer;case s.VSBuffer:return V.read(m(V));case s.Array:{const W=m(V),G=[];for(let K=0;K<W;K++)G.push(o(V));return G}case s.Object:return JSON.parse(V.read(m(V)).toString());case s.Int:return m(V)}}e.deserialize=o;class h{constructor(j,W,G=null,K=1e3){this.h=j,this.j=W,this.k=G,this.l=K,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(J=>this.q(J)),this.m({type:200})}registerChannel(j,W){this.b.set(j,W),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case 200:{const W=this.o([j.type]);this.k?.logOutgoing(W,0,1,l(j.type));return}case 201:case 202:case 204:case 203:{const W=this.o([j.type,j.id],j.data);this.k?.logOutgoing(W,j.id,1,l(j.type),j.data);return}}}o(j,W=void 0){const G=new t;return a(G,j),a(G,W),this.p(G.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const W=new b(j),G=o(W),K=o(W),J=G[0];switch(J){case 100:return this.k?.logIncoming(j.byteLength,G[1],1,`${E(J)}: ${G[2]}.${G[3]}`,K),this.s({type:J,id:G[1],channelName:G[2],name:G[3],arg:K});case 102:return this.k?.logIncoming(j.byteLength,G[1],1,`${E(J)}: ${G[2]}.${G[3]}`,K),this.t({type:J,id:G[1],channelName:G[2],name:G[3],arg:K});case 101:return this.k?.logIncoming(j.byteLength,G[1],1,`${E(J)}`),this.u({type:J,id:G[1]});case 103:return this.k?.logIncoming(j.byteLength,G[1],1,`${E(J)}`),this.u({type:J,id:G[1]})}}s(j){const W=this.b.get(j.channelName);if(!W){this.v(j);return}const G=new R.CancellationTokenSource;let K;try{K=W.call(this.j,j.name,j.arg,G.token)}catch(C){K=Promise.reject(C)}const J=j.id;K.then(C=>{this.m({id:J,data:C,type:201}),this.d.delete(j.id)},C=>{C instanceof Error?this.m({id:J,data:{message:C.message,name:C.name,stack:C.stack?C.stack.split?C.stack.split(`
`):C.stack:void 0},type:202}):this.m({id:J,data:C,type:203}),this.d.delete(j.id)});const F=(0,c.toDisposable)(()=>G.cancel());this.d.set(j.id,F)}t(j){const W=this.b.get(j.channelName);if(!W){this.v(j);return}const G=j.id,J=W.listen(this.j,j.name,j.arg)(F=>this.m({id:G,data:F,type:204}));this.d.set(j.id,J)}u(j){const W=this.d.get(j.id);W&&(W.dispose(),this.d.delete(j.id))}v(j){let W=this.g.get(j.channelName);W||(W=[],this.g.set(j.channelName,W));const G=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);W.push({request:j,timeoutTimer:G})}w(j){const W=this.g.get(j);if(W){for(const G of W)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=h;var f;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class O{constructor(j,W=null){this.l=j,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=W}getChannel(j){const W=this;return{call(G,K,J){return W.a?Promise.reject(new P.CancellationError):W.m(j,G,K,J)},listen(G,K){return W.a?d.Event.None:W.o(j,G,K)}}}m(j,W,G,K=R.CancellationToken.None){const J=this.g++,C={id:J,type:100,channelName:j,name:W,arg:G};if(K.isCancellationRequested)return Promise.reject(new P.CancellationError);let A;return new Promise((B,Q)=>{if(K.isCancellationRequested)return Q(new P.CancellationError);const Z=()=>{const pe=fe=>{switch(fe.type){case 201:this.f.delete(J),B(fe.data);break;case 202:{this.f.delete(J);const ge=new Error(fe.data.message);ge.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ge.name=fe.data.name,Q(ge);break}case 203:this.f.delete(J),Q(fe.data);break}};this.f.set(J,pe),this.p(C)};let le=null;this.b===u.Idle?Z():(le=(0,L.createCancelablePromise)(pe=>this.u()),le.then(()=>{le=null,Z()}));const ue=()=>{le?(le.cancel(),le=null):this.p({id:J,type:101}),Q(new P.CancellationError)},Ee=K.onCancellationRequested(ue);A=(0,c.combinedDisposable)((0,c.toDisposable)(ue),Ee),this.d.add(A)}).finally(()=>{this.d.delete(A)})}o(j,W,G){const K=this.g++,F={id:K,type:102,channelName:j,name:W,arg:G};let C=null;const A=new d.Emitter({onWillAddFirstListener:()=>{C=(0,L.createCancelablePromise)(B=>this.u()),C.then(()=>{C=null,this.d.add(A),this.p(F)})},onDidRemoveLastListener:()=>{C?(C.cancel(),C=null):(this.d.delete(A),this.p({id:K,type:103}))}}),z=B=>A.fire(B.data);return this.f.set(K,z),A.event}p(j){switch(j.type){case 100:case 102:{const W=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(W,j.id,0,`${E(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const W=this.q([j.type,j.id]);this.j?.logOutgoing(W,j.id,0,E(j.type));return}}}q(j,W=void 0){const G=new t;return a(G,j),a(G,W),this.r(G.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const W=new b(j),G=o(W),K=o(W),J=G[0];switch(J){case 200:return this.j?.logIncoming(j.byteLength,0,0,l(J)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(j.byteLength,G[1],0,l(J),K),this.t({type:G[0],id:G[1],data:K})}}t(j){if(j.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}de([I.memoize],O.prototype,"onDidInitializePromise",null),e.ChannelClient=O;class x{get connections(){const j=[];return this.f.forEach(W=>j.push(W)),j}constructor(j){this.a=new Map,this.f=new Set,this.g=new d.Emitter,this.onDidAddConnection=this.g.event,this.h=new d.Emitter,this.onDidRemoveConnection=this.h.event,j(({protocol:W,onDidClientDisconnect:G})=>{d.Event.once(W.onMessage)(J=>{const F=new b(J),C=o(F),A=new h(W,C),z=new O(W);this.a.forEach((Q,Z)=>A.registerChannel(Z,Q));const B={channelServer:A,channelClient:z,ctx:C};this.f.add(B),this.g.fire(B),G(()=>{A.dispose(),z.dispose(),this.f.delete(B),this.h.fire(B)})})})}getChannel(j,W){const G=this;return{call(K,J,F){let C;if((0,v.isFunction)(W)){const z=(0,N.getRandomElement)(G.connections.filter(W));C=z?Promise.resolve(z):d.Event.toPromise(d.Event.filter(G.onDidAddConnection,W))}else C=W.routeCall(G,K,J);const A=C.then(z=>z.channelClient.getChannel(j));return ee(A).call(K,J,F)},listen(K,J){if((0,v.isFunction)(W))return G.j(j,W,K,J);const F=W.routeEvent(G,K,J).then(C=>C.channelClient.getChannel(j));return ee(F).listen(K,J)}}}j(j,W,G,K){const J=this;let F=new c.DisposableStore;const C=new d.Emitter({onWillAddFirstListener:()=>{F=new c.DisposableStore;const A=new d.EventMultiplexer,z=new Map,B=Z=>{const ue=Z.channelClient.getChannel(j).listen(G,K),Ee=A.add(ue);z.set(Z,Ee)},Q=Z=>{const le=z.get(Z);!le||(le.dispose(),z.delete(Z))};J.connections.filter(W).forEach(B),d.Event.filter(J.onDidAddConnection,W)(B,void 0,F),J.onDidRemoveConnection(Q,void 0,F),A.event(C.fire,C,F),F.add(A)},onDidRemoveLastListener:()=>{F.dispose()}});return C.event}registerChannel(j,W){this.a.set(j,W),this.f.forEach(G=>{G.channelServer.registerChannel(j,W)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=x;class _{constructor(j,W,G=null){const K=new t;a(K,W),j.send(K.buffer),this.a=new O(j,G),this.d=new h(j,W,G)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,W){this.d.registerChannel(j,W)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=_;function ee(V){return{call(j,W,G){return V.then(K=>K.call(j,W,G))},listen(j,W){const G=new d.Relay;return V.then(K=>G.input=K.listen(j,W)),G.event}}}e.getDelayedChannel=ee;function se(V){let j=!1;return{call(W,G,K){return j?V.call(W,G,K):(0,L.timeout)(0).then(()=>j=!0).then(()=>V.call(W,G,K))},listen(W,G){if(j)return V.listen(W,G);const K=new d.Relay;return(0,L.timeout)(0).then(()=>j=!0).then(()=>K.input=V.listen(W,G)),K.event}}}e.getNextTickChannel=se;class oe{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const W of j.connections)if(await Promise.resolve(this.a(W.ctx)))return Promise.resolve(W);return await d.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.StaticRouter=oe;var ae;(function(V){function j(J,F){const C=J,A=F&&F.disableMarshalling,z=new Map;for(const B in C)G(B)&&z.set(B,d.Event.buffer(C[B],!0));return new class{listen(B,Q,Z){const le=z.get(Q);if(le)return le;if(K(Q)){const ue=C[Q];if(typeof ue=="function")return ue.call(C,Z)}throw new Error(`Event not found: ${Q}`)}call(B,Q,Z){const le=C[Q];if(typeof le=="function"){if(!A&&Array.isArray(Z))for(let ue=0;ue<Z.length;ue++)Z[ue]=(0,k.revive)(Z[ue]);return le.apply(C,Z)}throw new Error(`Method not found: ${Q}`)}}}V.fromService=j;function W(J,F){const C=F&&F.disableMarshalling;return new Proxy({},{get(A,z){if(typeof z=="string")return F?.properties?.has(z)?F.properties.get(z):K(z)?function(B){return J.listen(z,B)}:G(z)?J.listen(z):async function(...B){let Q;F&&!(0,v.isUndefinedOrNull)(F.context)?Q=[F.context,...B]:Q=B;const Z=await J.call(z,Q);return C?Z:(0,k.revive)(Z)};throw new Error(`Property not found: ${String(z)}`)}})}V.toService=W;function G(J){return J[0]==="o"&&J[1]==="n"&&w.isUpperAsciiLetter(J.charCodeAt(2))}function K(J){return/^onDynamic/.test(J)&&w.isUpperAsciiLetter(J.charCodeAt(9))}})(ae=e.ProxyChannel||(e.ProxyChannel={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function y(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const j=V.toString();if(j!=="[object Object]")return j}return V}function M(V){return Array.isArray(V)?V.map(y):y(V)}function U(V,j,W,G,K,J,F){F=M(F);const C=Y[K],A=C[G%C.length];let z=[`%c[${V}]%c[${String(j).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(J)?(z=z.concat(F),z.push(")")):z.push(F),console.log.apply(console,z)}class ${constructor(j,W){this.d=j,this.f=W,this.a=0,this.b=0}logOutgoing(j,W,G,K,J){this.b+=j,U(this.d,this.b,j,W,G,K,J)}logIncoming(j,W,G,K,J){this.a+=j,U(this.f,this.a,j,W,G,K,J)}}e.IPCLogger=$}),define(ne[83],re([0,1,58,6,14,23,79,7,4,2,30,56,51,57]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class E extends S.ChannelServer{constructor(u){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",m=>D.VSBuffer.wrap(Buffer.from(m,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=E;class T{constructor(u,m){this.i=u,this.j=m,this.c=new Set,this.g=new Map,this.h=new d.Emitter,this.onDidProcessExit=this.h.event;const p=m&&m.timeout?m.timeout:6e4;this.b=new L.Delayer(p),this.d=null,this.f=null}getChannel(u){const m=this;return{call(p,g,b){return m.k(u,p,g,b)},listen(p,g){return m.l(u,p,g)}}}k(u,m,p,g=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const b=this.n(u),t=(0,L.createCancelablePromise)(n=>b.call(m,p,n)),s=g.onCancellationRequested(()=>t.cancel()),i=(0,c.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{s.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,m,p){if(!this.b)return d.Event.None;this.b.cancel();let g;const b=new d.Emitter({onWillAddFirstListener:()=>{g=this.n(u).listen(m,p)(b.fire,b),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return b.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,k.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(m.env),this.d=(0,N.fork)(this.i,u,m);const p=new d.Emitter;d.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,I.isRemoteConsoleLog)(r)){(0,I.log)(r,`IPC Library: ${this.j.serverName}`);return}p.fire(D.VSBuffer.wrap(Buffer.from(r,"base64")))});const b=this.j.useQueue?(0,w.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&b.send(r.buffer.toString("base64")),s=p.event,i={send:t,onMessage:s};this.f=new S.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,a)=>{process.removeListener("exit",n),this.c.forEach(o=>(0,c.dispose)(o)),this.c.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:a})})}return this.f}n(u){let m=this.g.get(u);return m||(m=this.m.getChannel(u),this.g.set(u,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=T}),define(ne[84],re([0,1,6,4,2,3]),function(H,e,N,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var I;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I=e.StorageHint||(e.StorageHint={}));function P(w){const v=w;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var d;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(d=e.StorageState||(e.StorageState={}));class c extends D.Disposable{constructor(v,S=Object.create(null)){super(),this.m=v,this.n=S,this.b=this.B(new L.Emitter),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=new N.ThrottledDelayer(c.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(v=>this.r(v)))}r(v){v.changed?.forEach((S,E)=>this.s(E,S)),v.deleted?.forEach(S=>this.s(S,void 0))}s(v,S){if(this.c===d.Closed)return;let E=!1;(0,R.isUndefinedOrNull)(S)?E=this.f.delete(v):this.f.get(v)!==S&&(this.f.set(v,S),E=!0),E&&this.b.fire(v)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.n.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(v,S){const E=this.f.get(v);return(0,R.isUndefinedOrNull)(E)?S:E}getBoolean(v,S){const E=this.get(v);return(0,R.isUndefinedOrNull)(E)?S:E==="true"}getNumber(v,S){const E=this.get(v);return(0,R.isUndefinedOrNull)(E)?S:parseInt(E,10)}async set(v,S){if(this.c===d.Closed)return;if((0,R.isUndefinedOrNull)(S))return this.delete(v);const E=String(S);if(this.f.get(v)!==E)return this.f.set(v,E),this.j.set(v,E),this.h.delete(v),this.b.fire(v),this.w()}async delete(v){if(!(this.c===d.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire(v),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=d.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(v).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(v){if(!!this.u)return this.w(v)}async w(v){return this.g.trigger(()=>this.v(),v)}async whenFlushed(){if(!!this.u)return new Promise(v=>this.l.push(v))}isInMemory(){return this.n.hint===I.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}c.a=100,e.Storage=c;class k{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((S,E)=>this.a.set(E,S)),v.delete?.forEach(S=>this.a.delete(S))}async close(){}}e.InMemoryStorageDatabase=k}),define(ne[85],re([10,8]),function(H,e){return H.create("vs/base/node/zip",e)}),define(ne[86],re([10,8]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[87],re([10,8]),function(H,e){return H.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[88],re([10,8]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[89],re([10,8]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[90],re([10,8]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[91],re([10,8]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[92],re([10,8]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[93],re([10,8]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[94],re([10,8]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[95],re([10,8]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(ne[96],re([10,8]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(ne[97],re([10,8]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[98],re([10,8]),function(H,e){return H.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[99],re([10,8]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(ne[100],re([10,8]),function(H,e){return H.create("vs/platform/shell/node/shellEnv",e)}),define(ne[101],re([10,8]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[102],re([10,8]),function(H,e){return H.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[103],re([10,8]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(ne[104],re([0,1,7]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var L;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(L=e.TokenType||(e.TokenType={}));class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(I){if(I.type!==19)throw(0,N.illegalArgument)(`expected an error token but got ${JSON.stringify(I)}`);switch(I.lexeme){case"=":return`Unexpected token '${I.lexeme}' at offset ${I.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${I.lexeme}' at offset ${I.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${I.lexeme}' at offset ${I.offset}. Did you mean '||'?`;default:{const P=I.lexeme;return P&&P.length>1&&P.startsWith("'")?`Unexpected token '${I.lexeme}' at offset ${I.offset}. Did you forget to close the string?`:P&&P.length>1&&P.endsWith("'")?`Unexpected token '${I.lexeme}' at offset ${I.offset}. Did you forget to open the string?`:`Unexpected token '${I.lexeme}' at offset ${I.offset}`}}}static getLexeme(I){switch(I.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return I.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return I.lexeme;case 18:return I.lexeme;case 19:return I.lexeme;case 20:return"EOF";default:throw(0,N.illegalState)(`unhandled token type: ${JSON.stringify(I)}; have you forgotten to add a case?`)}}get errorTokens(){return this.g}reset(I){return this.c=I,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:this.k(this.h(61)?4:2);break;case 39:this.o();break;case 47:this.q();break;case 61:this.h(61)?this.k(3):this.h(126)?this.k(9):this.l();break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l();break;case 124:this.h(124)?this.k(16):this.l();break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(I){return this.r()||this.c.charCodeAt(this.e)!==I?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(I){this.f.push({type:I,offset:this.d})}l(){const I={type:19,offset:this.d,lexeme:this.c.substring(this.d,this.e)};this.g.push(I),this.f.push(I)}n(){this.m.lastIndex=this.d;const I=this.m.exec(this.c);if(I){this.e=this.d+I[0].length;const P=this.c.substring(this.d,this.e),d=D.b.get(P);d?this.k(d):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l();return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let I=this.e,P=!1,d=!1;for(;;){if(I>=this.c.length){this.e=I,this.l();return}const k=this.c.charCodeAt(I);if(P)P=!1;else if(k===47&&!d){I++;break}else k===91?d=!0:k===92?P=!0:k===93&&(d=!1);I++}for(;I<this.c.length&&D.a.has(this.c.charCodeAt(I));)I++;this.e=I;const c=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}D.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0))),D.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=D}),define(ne[105],re([0,1,75,49,16,15,35,17,11]),function(H,e,N,L,D,R,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,R.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const S=(0,N.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",S)}return d.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(d.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=I.env.VSCODE_PORTABLE;return S?d.URI.file((0,R.join)(S,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,R.resolve)(S):(0,R.normalize)((0,R.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const S=this.args["extensions-download-dir"];return S?d.URI.file((0,R.resolve)(S)):d.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,R.resolve)(S);const E=I.env.VSCODE_EXTENSIONS;if(E)return E;const T=I.env.VSCODE_PORTABLE;return T?(0,R.join)(T,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(E=>/^[^:/?#]+?:\/\//.test(E)?d.URI.parse(E):d.URI.file((0,R.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?d.URI.parse(S):d.URI.file((0,R.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return k(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(S=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(S))}get extensionLogLevel(){const S=[];for(const E of this.args.log||[]){const T=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(E);T&&T[1]&&T[2]&&S.push([T[1],T[2]])}return S.length?S:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=I.env.VSCODE_PORTABLE;return S?d.URI.file((0,R.join)(S,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(S){this.args.continueOn=S}get args(){return this.a}constructor(S,E,T){this.a=S,this.b=E,this.c=T,this.editSessionId=this.args.editSessionId}}de([L.memoize],c.prototype,"appRoot",null),de([L.memoize],c.prototype,"userHome",null),de([L.memoize],c.prototype,"userDataPath",null),de([L.memoize],c.prototype,"appSettingsHome",null),de([L.memoize],c.prototype,"tmpDir",null),de([L.memoize],c.prototype,"cacheHome",null),de([L.memoize],c.prototype,"stateResource",null),de([L.memoize],c.prototype,"userRoamingDataHome",null),de([L.memoize],c.prototype,"userDataSyncHome",null),de([L.memoize],c.prototype,"sync",null),de([L.memoize],c.prototype,"machineSettingsResource",null),de([L.memoize],c.prototype,"workspaceStorageHome",null),de([L.memoize],c.prototype,"localHistoryHome",null),de([L.memoize],c.prototype,"keyboardLayoutResource",null),de([L.memoize],c.prototype,"argvResource",null),de([L.memoize],c.prototype,"isExtensionDevelopment",null),de([L.memoize],c.prototype,"untitledWorkspacesHome",null),de([L.memoize],c.prototype,"installSourcePath",null),de([L.memoize],c.prototype,"builtinExtensionsPath",null),de([L.memoize],c.prototype,"extensionsPath",null),de([L.memoize],c.prototype,"extensionDevelopmentLocationURI",null),de([L.memoize],c.prototype,"extensionDevelopmentKind",null),de([L.memoize],c.prototype,"extensionTestsLocationURI",null),de([L.memoize],c.prototype,"debugExtensionHost",null),de([L.memoize],c.prototype,"logLevel",null),de([L.memoize],c.prototype,"extensionLogLevel",null),de([L.memoize],c.prototype,"serviceMachineIdResource",null),de([L.memoize],c.prototype,"disableTelemetry",null),de([L.memoize],c.prototype,"disableWorkspaceTrust",null),de([L.memoize],c.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=c;function k(v,S){return w(v["inspect-extensions"],v["inspect-brk-extensions"],5870,S,v.debugId,v.extensionEnvironment)}e.parseExtensionHostDebugPort=k;function w(v,S,E,T,l,u){const p=Number(S||v)||(T?null:E),g=p?Boolean(!!S):!1;let b;if(u)try{b=JSON.parse(u)}catch{}return{port:p,break:g,debugId:l,env:b}}e.parseDebugParams=w}),function(){"use strict";function H(e,N,L){function D(I,P){const d=R(I,P),c=[d];return e.isAbsolute(d)||c.unshift(L),e.resolve(...c)}function R(I,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,P);const k=I["user-data-dir"];if(k)return k;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(w,"AppData","Roaming")}break;case"darwin":c=e.join(N.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(N.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,P)}return{getUserDataPath:D}}if(typeof define=="function")define(ne[106],re([159,33,35]),function(e,N,L){return H(e,N,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),N=require("os");module.exports=H(e,N,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[107],re([0,1,33,105,106]),function(H,e,N,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class R extends L.AbstractNativeEnvironmentService{constructor(c,k){super(c,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,D.getUserDataPath)(c,k.nameShort)},k)}}e.NativeEnvironmentService=R;function I(d,c){return(0,L.parseDebugParams)(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,c,d.extensionEnvironment)}e.parsePtyHostDebugPort=I;function P(d,c){return(0,L.parseDebugParams)(d["inspect-sharedprocess"],d["inspect-brk-sharedprocess"],5879,c,d.extensionEnvironment)}e.parseSharedProcessDebugPort=P}),define(ne[108],re([0,1,3,90]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(I,P,d){try{R(I,P,d)}catch(c){console.error(c?.message??c)}return I}e.localizeManifest=D;function R(I,P,d){const c=(k,w,v)=>{const S=k[w];if((0,N.isString)(S)){const E=S,T=E.length;if(T>1&&E[0]==="%"&&E[T-1]==="%"){const l=E.substr(1,T-2);let u=P[l];u===void 0&&d&&(u=d[l]);const m=typeof u=="string"?u:u?.message,p=d?.[l],g=typeof p=="string"?p:p?.message;if(!m){g||console.warn(`[${I.name}]: ${(0,L.localize)(0,null,l)}`);return}if(v&&(w==="title"||w==="category")&&g&&g!==m){const b={value:m,original:g};k[w]=b}else k[w]=m}}else if((0,N.isObject)(S))for(const E in S)S.hasOwnProperty(E)&&(E==="commands"?c(S,E,!0):c(S,E,v));else if(Array.isArray(S))for(let E=0;E<S.length;E++)c(S,E,v)};for(const k in I)I.hasOwnProperty(k)&&c(I,k)}}),define(ne[45],re([0,1,17,53,94,41]),function(H,e,N,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function d(u){return u=u.trim(),u==="*"||I.test(u)}e.isValidVersionStr=d;function c(u){if(!d(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=u.match(I);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=c;function k(u){if(!u)return null;const m=u.majorBase,p=u.majorMustEqual,g=u.minorBase;let b=u.minorMustEqual;const t=u.patchBase;let s=u.patchMustEqual;u.hasCaret&&(m===0||(b=!1),s=!1);let i=0;if(u.preRelease){const n=P.exec(u.preRelease);if(n){const[,r,a,o]=n;i=Date.UTC(Number(r),Number(a)-1,Number(o))}}return{majorBase:m,majorMustEqual:p,minorBase:g,minorMustEqual:b,patchBase:t,patchMustEqual:s,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=k;function w(u,m,p){let g;typeof u=="string"?g=k(c(u)):g=u;let b;m instanceof Date?b=m.getTime():typeof m=="string"&&(b=new Date(m).getTime());let t;if(typeof p=="string"?t=k(c(p)):t=p,!g||!t)return!1;const s=g.majorBase,i=g.minorBase,n=g.patchBase;let r=t.majorBase,a=t.minorBase,o=t.patchBase;const h=t.notBefore;let f=t.majorMustEqual,O=t.minorMustEqual,x=t.patchMustEqual;return t.isMinimum?s>r?!0:s<r?!1:i>a?!0:i<a||b&&b<h?!1:n>=o:(s===1&&r===0&&(!f||!O||!x)&&(r=1,a=0,o=0,f=!0,O=!1,x=!1),s<r?!1:s>r?!f:i<a?!1:i>a?!O:n<o?!1:n>o?!x:!(b&&b<h))}e.isValidVersion=w;function v(u,m,p,g,b){const t=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return t.push([L.default.Error,D.localize(0,null)]),t;if(typeof g.name!="string")return t.push([L.default.Error,D.localize(1,null,"name")]),t;if(typeof g.version!="string")return t.push([L.default.Error,D.localize(2,null,"version")]),t;if(!g.engines)return t.push([L.default.Error,D.localize(3,null,"engines")]),t;if(typeof g.engines.vscode!="string")return t.push([L.default.Error,D.localize(4,null,"engines.vscode")]),t;if(typeof g.extensionDependencies<"u"&&!l(g.extensionDependencies))return t.push([L.default.Error,D.localize(5,null,"extensionDependencies")]),t;if(typeof g.activationEvents<"u"){if(!l(g.activationEvents))return t.push([L.default.Error,D.localize(6,null,"activationEvents")]),t;if(typeof g.main>"u"&&typeof g.browser>"u")return t.push([L.default.Error,D.localize(7,null,"activationEvents","main")]),t}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&t.push([L.default.Warning,D.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return t.push([L.default.Error,D.localize(9,null,"main")]),t;{const n=(0,N.joinPath)(p,g.main);(0,N.isEqualOrParent)(n,p)||t.push([L.default.Warning,D.localize(10,null,n.path,p.path)])}if(typeof g.activationEvents>"u")return t.push([L.default.Error,D.localize(11,null,"activationEvents","main")]),t}if(typeof g.browser<"u"){if(typeof g.browser!="string")return t.push([L.default.Error,D.localize(12,null,"browser")]),t;{const n=(0,N.joinPath)(p,g.browser);(0,N.isEqualOrParent)(n,p)||t.push([L.default.Warning,D.localize(13,null,n.path,p.path)])}if(typeof g.activationEvents>"u")return t.push([L.default.Error,D.localize(14,null,"activationEvents","browser")]),t}if(!R.valid(g.version))return t.push([L.default.Error,D.localize(15,null)]),t;const s=[];if(!S(u,m,g,b,s))for(const n of s)t.push([L.default.Error,n]);return t}e.validateExtensionManifest=v;function S(u,m,p,g,b){return g||typeof p.main>"u"&&typeof p.browser>"u"?!0:T(u,m,p.engines.vscode,b)}e.isValidExtensionVersion=S;function E(u,m,p){return u==="*"||T(m,p,u)}e.isEngineValid=E;function T(u,m,p,g=[]){const b=k(c(p));if(!b)return g.push(D.localize(16,null,p)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return g.push(D.localize(17,null,p)),!1}else if(!b.majorMustEqual)return g.push(D.localize(18,null,p)),!1;return w(u,m,b)?!0:(g.push(D.localize(19,null,u,p)),!1)}function l(u){if(!Array.isArray(u))return!1;for(let m=0,p=u.length;m<p;m++)if(typeof u[m]!="string")return!1;return!0}}),define(ne[109],re([0,1,14,28]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(R,I,P){let d=P&&P.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const k=(await I.readFile(R.serviceMachineIdResource)).value.toString();d=(0,L.isUUID)(k)?k:null}catch{d=null}if(!d){d=(0,L.generateUuid)();try{await I.writeFile(R.serviceMachineIdResource,N.VSBuffer.fromString(d))}catch{}}return P?.store("storage.serviceMachineId",d,-1,1),d}e.getServiceMachineId=D}),define(ne[46],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class N{constructor(D,R=[],I=!1){this.ctor=D,this.staticArguments=R,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=N}),define(ne[110],re([0,1,46]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var D;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function R(P,d,c){d instanceof N.SyncDescriptor||(d=new N.SyncDescriptor(d,[],Boolean(c))),L.push([P,d])}e.registerSingleton=R;function I(){return L}e.getSingletonServiceDescriptors=I}),define(ne[111],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class N{constructor(R,I){this.key=R,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.Node=N;class L{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const I of this.a.values())I.outgoing.size===0&&R.push(I);return R}insertEdge(R,I){const P=this.lookupOrInsertNode(R),d=this.lookupOrInsertNode(I);P.outgoing.set(d.key,d),d.incoming.set(P.key,P)}removeNode(R){const I=this.b(R);this.a.delete(I);for(const P of this.a.values())P.outgoing.delete(I),P.incoming.delete(I)}lookupOrInsertNode(R){const I=this.b(R);let P=this.a.get(I);return P||(P=new N(I,R),this.a.set(I,P)),P}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[I,P]of this.a)R.push(`${I}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,I]of this.a){const P=new Set([R]),d=this.c(I,P);if(d)return d}}c(R,I){for(const[P,d]of R.outgoing){if(I.has(P))return[...I,P].join(" -> ");I.add(P);const c=this.c(d,I);if(c)return c;I.delete(P)}}}e.Graph=L}),define(ne[24],re([0,1,3,11,9]),function(H,e,N,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function R(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof L.URI)}e.isConfigurationOverrides=R;function I(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=I;var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=d;function c(l,u){const m=Object.create(null);for(const p in l)k(m,p,l[p],u);return m}e.toValuesTree=c;function k(l,u,m,p){const g=u.split("."),b=g.pop();let t=l;for(let s=0;s<g.length;s++){const i=g[s];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:p(`Ignoring ${u} as ${g.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[b]=m}catch{p(`Ignoring ${u} as ${g.join(".")} is ${JSON.stringify(t)}`)}else p(`Ignoring ${u} as ${g.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=k;function w(l,u){const m=u.split(".");v(l,m)}e.removeFromValueTree=w;function v(l,u){const m=u.shift();if(u.length===0){delete l[m];return}if(Object.keys(l).indexOf(m)!==-1){const p=l[m];typeof p=="object"&&!Array.isArray(p)&&(v(p,u),Object.keys(p).length===0&&delete l[m])}}function S(l,u,m){function p(t,s){let i=t;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const g=u.split("."),b=p(l,g);return typeof b>"u"?m:b}e.getConfigurationValue=S;function E(l,u,m){Object.keys(u).forEach(p=>{p!=="__proto__"&&(p in l?N.isObject(l[p])&&N.isObject(u[p])?E(l[p],u[p],m):m&&(l[p]=u[p]):l[p]=u[p])})}e.merge=E;function T(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=T}),define(ne[112],re([0,1,12,29,104,9]),function(H,e,N,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",N.isMacintosh),I.set("isLinux",N.isLinux),I.set("isWindows",N.isWindows),I.set("isWeb",N.isWeb),I.set("isMacNative",N.isMacintosh&&!N.isWeb),I.set("isEdge",N.isEdge),I.set("isFirefox",N.isFirefox),I.set("isChrome",N.isChrome),I.set("isSafari",N.isSafari);const P=Object.prototype.hasOwnProperty;var d;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(d=e.ContextKeyExprType||(e.ContextKeyExprType={}));class c{static false(){return E.INSTANCE}static true(){return T.INSTANCE}static has(y){return l.create(y)}static equals(y,M){return u.create(y,M)}static notEquals(y,M){return g.create(y,M)}static regex(y,M){return a.create(y,M)}static in(y,M){return m.create(y,M)}static notIn(y,M){return p.create(y,M)}static not(y){return b.create(y)}static and(...y){return f.create(y,null,!0)}static or(...y){return O.create(y,null,!0)}static greater(y,M){return s.create(y,M)}static greaterEquals(y,M){return i.create(y,M)}static smaller(y,M){return n.create(y,M)}static smallerEquals(y,M){return r.create(y,M)}static deserializeOrErrorNew(y){if(!y)return{type:"error",lexingErrors:[],parsingErrors:[]};const M=new w,U=M.parse(y);return U===void 0?{type:"error",lexingErrors:M.lexingErrors.map($=>D.Scanner.reportError($)),parsingErrors:M.parsingErrors}:{type:"ok",expr:U}}static deserialize(y){if(!!y)return this.c(y)}static c(y){const M=y.split("||");return O.create(M.map(U=>this.d(U)),null,!0)}static d(y){const M=y.split("&&");return f.create(M.map(U=>this.f(U)),null,!0)}static f(y){if(y=y.trim(),y.indexOf("!=")>=0){const M=y.split("!=");return g.create(M[0].trim(),this.g(M[1]))}if(y.indexOf("==")>=0){const M=y.split("==");return u.create(M[0].trim(),this.g(M[1]))}if(y.indexOf("=~")>=0){const M=y.split("=~");return a.create(M[0].trim(),this.h(M[1]))}if(y.indexOf(" not in ")>=0){const M=y.split(" not in ");return p.create(M[0].trim(),this.g(M[1]))}if(y.indexOf(" in ")>=0){const M=y.split(" in ");return m.create(M[0].trim(),this.g(M[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const M=y.split(">=");return i.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const M=y.split(">");return s.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const M=y.split("<=");return r.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const M=y.split("<");return n.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(y)?b.create(y.substr(1).trim()):l.create(y)}static g(y){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;const M=/^'([^']*)'$/.exec(y);return M?M[1].trim():y}static h(y){if((0,L.isFalsyOrWhitespace)(y))return null;const M=y.indexOf("/"),U=y.lastIndexOf("/");if(M===U||M<0)return null;const $=y.slice(M+1,U),V=y[U+1]==="i"?"i":"";try{return new RegExp($,V)}catch{return null}}}e.ContextKeyExpr=c;class k extends Error{}class w{constructor(){this.c=new D.Scanner,this.d=[],this.f=0,this.g=[]}get lexingErrors(){return this.c.errorTokens}get parsingErrors(){return this.g}parse(y){if(y===""){this.g.push("Expected an expression but got an empty string");return}this.d=this.c.reset(y).scan(),this.f=0,this.g=[];try{const M=this.h();if(!this.D())throw this.z(this.C());return M}catch(M){if(!(M instanceof k)){const U=this.C();this.g.push(`Unexpected error: ${M} for token ${D.Scanner.getLexeme(U)} at offset ${U.offset}.`)}return}}h(){return this.k()}k(){const y=[this.l()];for(;this.v(16);){const M=this.l();y.push(M)}return y.length===1?y[0]:c.or(...y)}l(){const y=[this.o()];for(;this.v(15);){const M=this.o();y.push(M)}return y.length===1?y[0]:c.and(...y)}o(){if(this.v(2)){const y=this.C();switch(y.type){case 17:return this.w(),c.not(y.lexeme);case 11:return this.w(),c.false();case 12:return this.w(),c.true();default:throw this.y("KEY, 'true', or 'false'",y)}}return this.s()}s(){const y=this.C();switch(y.type){case 11:return this.w(),c.true();case 12:return this.w(),c.false();case 0:{this.w();const M=this.h();return this.x(1,"')'"),M}case 17:{const M=y.lexeme;if(this.w(),this.v(9)){const $=this.C();switch($.type){case 10:case 19:{const V=[$.lexeme];this.w();let j=this.C(),W=0;for(let C=0;C<$.lexeme.length;C++)$.lexeme.charCodeAt(C)===40?W++:$.lexeme.charCodeAt(C)===41&&W--;for(;!this.D()&&j.type!==15&&j.type!==16;){switch(j.type){case 0:W++;break;case 1:W--;break;case 10:case 18:for(let C=0;C<j.lexeme.length;C++)j.lexeme.charCodeAt(C)===40?W++:$.lexeme.charCodeAt(C)===41&&W--}if(W<0)break;V.push(D.Scanner.getLexeme(j)),this.w(),j=this.C()}const G=V.join(""),K=G.lastIndexOf("/"),J=K===G.length-1?void 0:G.substring(K+1),F=new RegExp(G.substring(1,K),J);return c.regex(M,F)}case 18:{const V=$.lexeme;this.w();let j=null;if(!(0,L.isFalsyOrWhitespace)(V)){const W=V.indexOf("/"),G=V.lastIndexOf("/");if(W!==G&&W>=0){const K=V.slice(W+1,G),J=V[G+1]==="i"?"i":"";try{j=new RegExp(K,J)}catch{}}}if(j===null)throw this.y("REGEX",$);return a.create(M,j)}default:throw this.y("REGEX",this.C())}}if(this.v(14)){this.x(13,"'in' after 'not'");const $=this.t();return c.notIn(M,$)}switch(this.C().type){case 3:{this.w();const $=this.t();switch($){case"true":return c.has(M);case"false":return c.not(M);default:return c.equals(M,$)}}case 4:{this.w();const $=this.t();switch($){case"true":return c.not(M);case"false":return c.has(M);default:return c.notEquals(M,$)}}case 5:return this.w(),n.create(M,this.t());case 6:return this.w(),r.create(M,this.t());case 7:return this.w(),s.create(M,this.t());case 8:return this.w(),i.create(M,this.t());case 13:return this.w(),c.in(M,this.t());default:return c.has(M)}}default:throw this.y("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this.C())}}t(){const y=this.C();switch(y.type){case 17:case 18:return this.w(),y.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(y){return this.B(y)?(this.w(),!0):!1}w(){return this.D()||this.f++,this.u()}x(y,M){if(this.B(y))return this.w();throw this.y(M,this.C())}y(y,M){return this.A(`Expected ${y} but got '${D.Scanner.getLexeme(M)}' at offset ${M.offset}.`)}z(y){return this.A(`Unexpected '${D.Scanner.getLexeme(y)}' at offset ${y.offset}.`)}A(y){return this.g.push(y),new k}B(y){return this.C().type===y}C(){return this.d[this.f]}D(){return this.C().type===20}}e.Parser=w;function v(Y,y){const M=Y?Y.substituteConstants():void 0,U=y?y.substituteConstants():void 0;return!M&&!U?!0:!M||!U?!1:M.equals(U)}e.expressionsAreEqualWithConstantSubstitution=v;function S(Y,y){return Y.cmp(y)}class E{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return T.INSTANCE}}E.INSTANCE=new E,e.ContextKeyFalseExpr=E;class T{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return E.INSTANCE}}T.INSTANCE=new T,e.ContextKeyTrueExpr=T;class l{static create(y,M=null){const U=I.get(y);return typeof U=="boolean"?U?T.INSTANCE:E.INSTANCE:new l(y,M)}constructor(y,M){this.key=y,this.c=M,this.type=2}cmp(y){return y.type!==this.type?this.type-y.type:_(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=I.get(this.key);return typeof y=="boolean"?y?T.INSTANCE:E.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.c||(this.c=b.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=l;class u{static create(y,M,U=null){if(typeof M=="boolean")return M?l.create(y,U):b.create(y,U);const $=I.get(y);return typeof $=="boolean"?M===($?"true":"false")?T.INSTANCE:E.INSTANCE:new u(y,M,U)}constructor(y,M,U){this.c=y,this.d=M,this.f=U,this.type=4}cmp(y){return y.type!==this.type?this.type-y.type:ee(this.c,this.d,y.c,y.d)}equals(y){return y.type===this.type?this.c===y.c&&this.d===y.d:!1}substituteConstants(){const y=I.get(this.c);if(typeof y=="boolean"){const M=y?"true":"false";return this.d===M?T.INSTANCE:E.INSTANCE}return this}evaluate(y){return y.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(y){return y.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=u;class m{static create(y,M){return new m(y,M)}constructor(y,M){this.d=y,this.f=M,this.type=10,this.c=null}cmp(y){return y.type!==this.type?this.type-y.type:ee(this.d,this.f,y.d,y.f)}equals(y){return y.type===this.type?this.d===y.d&&this.f===y.f:!1}substituteConstants(){return this}evaluate(y){const M=y.getValue(this.f),U=y.getValue(this.d);return Array.isArray(M)?M.includes(U):typeof U=="string"&&typeof M=="object"&&M!==null?P.call(M,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(y){return y.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=m;class p{static create(y,M){return new p(y,M)}constructor(y,M){this.d=y,this.f=M,this.type=11,this.c=m.create(y,M)}cmp(y){return y.type!==this.type?this.type-y.type:this.c.cmp(y.c)}equals(y){return y.type===this.type?this.c.equals(y.c):!1}substituteConstants(){return this}evaluate(y){return!this.c.evaluate(y)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(y){return y.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=p;class g{static create(y,M,U=null){if(typeof M=="boolean")return M?b.create(y,U):l.create(y,U);const $=I.get(y);return typeof $=="boolean"?M===($?"true":"false")?E.INSTANCE:T.INSTANCE:new g(y,M,U)}constructor(y,M,U){this.c=y,this.d=M,this.f=U,this.type=5}cmp(y){return y.type!==this.type?this.type-y.type:ee(this.c,this.d,y.c,y.d)}equals(y){return y.type===this.type?this.c===y.c&&this.d===y.d:!1}substituteConstants(){const y=I.get(this.c);if(typeof y=="boolean"){const M=y?"true":"false";return this.d===M?E.INSTANCE:T.INSTANCE}return this}evaluate(y){return y.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(y){return y.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=g;class b{static create(y,M=null){const U=I.get(y);return typeof U=="boolean"?U?E.INSTANCE:T.INSTANCE:new b(y,M)}constructor(y,M){this.c=y,this.d=M,this.type=3}cmp(y){return y.type!==this.type?this.type-y.type:_(this.c,y.c)}equals(y){return y.type===this.type?this.c===y.c:!1}substituteConstants(){const y=I.get(this.c);return typeof y=="boolean"?y?E.INSTANCE:T.INSTANCE:this}evaluate(y){return!y.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(y){return y.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.ContextKeyNotExpr=b;function t(Y,y){if(typeof Y=="string"){const M=parseFloat(Y);isNaN(M)||(Y=M)}return typeof Y=="string"||typeof Y=="number"?y(Y):E.INSTANCE}class s{static create(y,M,U=null){return t(M,$=>new s(y,$,U))}constructor(y,M,U){this.c=y,this.d=M,this.f=U,this.type=12}cmp(y){return y.type!==this.type?this.type-y.type:ee(this.c,this.d,y.c,y.d)}equals(y){return y.type===this.type?this.c===y.c&&this.d===y.d:!1}substituteConstants(){return this}evaluate(y){return typeof this.d=="string"?!1:parseFloat(y.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(y){return y.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=s;class i{static create(y,M,U=null){return t(M,$=>new i(y,$,U))}constructor(y,M,U){this.c=y,this.d=M,this.f=U,this.type=13}cmp(y){return y.type!==this.type?this.type-y.type:ee(this.c,this.d,y.c,y.d)}equals(y){return y.type===this.type?this.c===y.c&&this.d===y.d:!1}substituteConstants(){return this}evaluate(y){return typeof this.d=="string"?!1:parseFloat(y.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(y){return y.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=i;class n{static create(y,M,U=null){return t(M,$=>new n(y,$,U))}constructor(y,M,U){this.c=y,this.d=M,this.f=U,this.type=14}cmp(y){return y.type!==this.type?this.type-y.type:ee(this.c,this.d,y.c,y.d)}equals(y){return y.type===this.type?this.c===y.c&&this.d===y.d:!1}substituteConstants(){return this}evaluate(y){return typeof this.d=="string"?!1:parseFloat(y.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(y){return y.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class r{static create(y,M,U=null){return t(M,$=>new r(y,$,U))}constructor(y,M,U){this.c=y,this.d=M,this.f=U,this.type=15}cmp(y){return y.type!==this.type?this.type-y.type:ee(this.c,this.d,y.c,y.d)}equals(y){return y.type===this.type?this.c===y.c&&this.d===y.d:!1}substituteConstants(){return this}evaluate(y){return typeof this.d=="string"?!1:parseFloat(y.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(y){return y.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class a{static create(y,M){return new a(y,M)}constructor(y,M){this.d=y,this.f=M,this.type=7,this.c=null}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.d<y.d)return-1;if(this.d>y.d)return 1;const M=this.f?this.f.source:"",U=y.f?y.f.source:"";return M<U?-1:M>U?1:0}equals(y){if(y.type===this.type){const M=this.f?this.f.source:"",U=y.f?y.f.source:"";return this.d===y.d&&M===U}return!1}substituteConstants(){return this}evaluate(y){const M=y.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const y=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${y}`}keys(){return[this.d]}map(y){return y.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=o.create(this)),this.c}}e.ContextKeyRegexExpr=a;class o{static create(y){return new o(y)}constructor(y){this.c=y,this.type=8}cmp(y){return y.type!==this.type?this.type-y.type:this.c.cmp(y.c)}equals(y){return y.type===this.type?this.c.equals(y.c):!1}substituteConstants(){return this}evaluate(y){return!this.c.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(y){return new o(this.c.map(y))}negate(){return this.c}}e.ContextKeyNotRegexExpr=o;function h(Y){let y=null;for(let M=0,U=Y.length;M<U;M++){const $=Y[M].substituteConstants();if(Y[M]!==$&&y===null){y=[];for(let V=0;V<M;V++)y[V]=Y[V]}y!==null&&(y[M]=$)}return y===null?Y:y}class f{static create(y,M,U){return f.d(y,M,U)}constructor(y,M){this.expr=y,this.c=M,this.type=6}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let M=0,U=this.expr.length;M<U;M++){const $=S(this.expr[M],y.expr[M]);if($!==0)return $}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].equals(y.expr[M]))return!1;return!0}return!1}substituteConstants(){const y=h(this.expr);return y===this.expr?this:f.create(y,this.c,!1)}evaluate(y){for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].evaluate(y))return!1;return!0}static d(y,M,U){const $=[];let V=!1;for(const j of y)if(!!j){if(j.type===1){V=!0;continue}if(j.type===0)return E.INSTANCE;if(j.type===6){$.push(...j.expr);continue}$.push(j)}if($.length===0&&V)return T.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(S);for(let j=1;j<$.length;j++)$[j-1].equals($[j])&&($.splice(j,1),j--);if($.length===1)return $[0];for(;$.length>1;){const j=$[$.length-1];if(j.type!==9)break;$.pop();const W=$.pop(),G=$.length===0,K=O.create(j.expr.map(J=>f.create([J,W],null,U)),null,G);K&&($.push(K),$.sort(S))}if($.length===1)return $[0];if(U){for(let j=0;j<$.length;j++)for(let W=j+1;W<$.length;W++)if($[j].negate().equals($[W]))return E.INSTANCE;if($.length===1)return $[0]}return new f($,M)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(const M of this.expr)y.push(...M.keys());return y}map(y){return new f(this.expr.map(M=>M.map(y)),null)}negate(){if(!this.c){const y=[];for(const M of this.expr)y.push(M.negate());this.c=O.create(y,this,!0)}return this.c}}class O{static create(y,M,U){return O.d(y,M,U)}constructor(y,M){this.expr=y,this.c=M,this.type=9}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let M=0,U=this.expr.length;M<U;M++){const $=S(this.expr[M],y.expr[M]);if($!==0)return $}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let M=0,U=this.expr.length;M<U;M++)if(!this.expr[M].equals(y.expr[M]))return!1;return!0}return!1}substituteConstants(){const y=h(this.expr);return y===this.expr?this:O.create(y,this.c,!1)}evaluate(y){for(let M=0,U=this.expr.length;M<U;M++)if(this.expr[M].evaluate(y))return!0;return!1}static d(y,M,U){let $=[],V=!1;if(y){for(let j=0,W=y.length;j<W;j++){const G=y[j];if(!!G){if(G.type===0){V=!0;continue}if(G.type===1)return T.INSTANCE;if(G.type===9){$=$.concat(G.expr);continue}$.push(G)}}if($.length===0&&V)return E.INSTANCE;$.sort(S)}if($.length!==0){if($.length===1)return $[0];for(let j=1;j<$.length;j++)$[j-1].equals($[j])&&($.splice(j,1),j--);if($.length===1)return $[0];if(U){for(let j=0;j<$.length;j++)for(let W=j+1;W<$.length;W++)if($[j].negate().equals($[W]))return T.INSTANCE;if($.length===1)return $[0]}return new O($,M)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(const M of this.expr)y.push(...M.keys());return y}map(y){return new O(this.expr.map(M=>M.map(y)),null)}negate(){if(!this.c){const y=[];for(const M of this.expr)y.push(M.negate());for(;y.length>1;){const M=y.shift(),U=y.shift(),$=[];for(const V of ae(M))for(const j of ae(U))$.push(f.create([V,j],null,!1));y.unshift(O.create($,null,!1))}this.c=O.create(y,this,!0)}return this.c}}class x extends l{static all(){return x.d.values()}constructor(y,M,U){super(y,null),this.f=M,typeof U=="object"?x.d.push({...U,key:y}):U!==!0&&x.d.push({key:y,description:U,type:M!=null?typeof M:void 0})}bindTo(y){return y.createKey(this.key,this.f)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return u.create(this.key,y)}notEqualsTo(y){return g.create(this.key,y)}}x.d=[],e.RawContextKey=x,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function _(Y,y){return Y<y?-1:Y>y?1:0}function ee(Y,y,M,U){return Y<M?-1:Y>M?1:y<U?-1:y>U?1:0}function se(Y,y){if(Y.type===0||y.type===1)return!0;if(Y.type===9)return y.type===9?oe(Y.expr,y.expr):!1;if(y.type===9){for(const M of y.expr)if(se(Y,M))return!0;return!1}if(Y.type===6){if(y.type===6)return oe(y.expr,Y.expr);for(const M of Y.expr)if(se(M,y))return!0;return!1}return Y.equals(y)}e.implies=se;function oe(Y,y){let M=0,U=0;for(;M<Y.length&&U<y.length;){const $=Y[M].cmp(y[U]);if($<0)return!1;$===0&&M++,U++}return M===Y.length}function ae(Y){return Y.type===9?Y.expr:[Y]}}),define(ne[59],re([0,1,9]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,N.createDecorator)("downloadService")}),define(ne[18],re([0,1,9]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,N.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,N.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[21],re([0,1,88,9]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function D(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function R(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function I(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function P(u,m){return m==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function d(u,m,p){return P(m,p)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===p?!0:c(p).includes(u)}e.isTargetPlatformCompatible=d;function c(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function k(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=k;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var v;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var S;(function(u){u.Install="install",u.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var E;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var T;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(T=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class l extends Error{constructor(m,p){super(m),this.code=p,this.name=p}}e.ExtensionManagementError=l,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,N.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,N.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,9]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,N.createDecorator)("IExtensionSignatureVerificationService");class L{b(){return this.a||(this.a=new Promise((R,I)=>H(["node-vsce-sign"],async P=>R(P),I))),this.a}async verify(R,I,P){let d;try{d=await this.b()}catch{return!1}return d.verify(R,I,P)}}e.ExtensionSignatureVerificationService=L}),define(ne[61],re([0,1,14,7,96,13]),function(H,e,N,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function I(k,w,v,S,E,T){let l;try{await P(k,w,v,S,E,T)}catch(u){l=u}finally{l&&E.errorTransformer&&(l=E.errorTransformer(l)),typeof l<"u"&&v.error(l),v.end()}}e.readFileIntoStream=I;async function P(k,w,v,S,E,T){d(T);const l=await k.open(w,{create:!1});try{d(T);let u=0,m=0,p=E&&typeof E.length=="number"?E.length:void 0,g=N.VSBuffer.alloc(Math.min(E.bufferSize,typeof p=="number"?p:E.bufferSize)),b=E&&typeof E.position=="number"?E.position:0,t=0;do m=await k.read(l,b,g.buffer,t,g.byteLength-t),b+=m,t+=m,u+=m,typeof p=="number"&&(p-=m),t===g.byteLength&&(await v.write(S(g)),g=N.VSBuffer.alloc(Math.min(E.bufferSize,typeof p=="number"?p:E.bufferSize)),t=0);while(m>0&&(typeof p!="number"||p>0)&&d(T)&&c(u,E));if(t>0){let s=t;typeof p=="number"&&(s=Math.min(t,p)),v.write(S(g.slice(0,s)))}}catch(u){throw(0,R.ensureFileSystemProviderError)(u)}finally{await k.close(l)}}function d(k){if(k.isCancellationRequested)throw(0,L.canceled)();return!0}function c(k,w){if(w?.limits){if(typeof w.limits.memory=="number"&&k>w.limits.memory)throw(0,R.createFileSystemProviderError)((0,D.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&k>w.limits.size)throw(0,R.createFileSystemProviderError)((0,D.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[113],re([0,1,4,160,2,12,161]),function(H,e,N,L,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new N.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new N.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=N.Event.None,this.c=new Map,this.f=!1}async watch(c){const k=this.i(c),w=k.filter(S=>{const E=this.c.get(S.path);return E?!(0,L.patternsEquals)(E.request.excludes,S.excludes)||!(0,L.patternsEquals)(E.request.includes,S.includes):!0}),v=Array.from(this.c.values()).filter(({request:S})=>!k.find(E=>E.path===S.path&&(0,L.patternsEquals)(E.excludes,S.excludes)&&(0,L.patternsEquals)(E.includes,S.includes))).map(({request:S})=>S.path);w.length&&this.j(`Request to start watching: ${w.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"})`).join(",")}`),v.length&&this.j(`Request to stop watching: ${v.join(",")}`);for(const S of v)this.h(S);for(const S of w)this.g(S)}g(c){const k=new I.NodeJSFileWatcherLibrary(c,v=>this.a.fire(v),v=>this.b.fire(v),this.f),w={request:c,instance:k};this.c.set(c.path,w)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const k=this.c.get(c);k&&(this.c.delete(c),k.instance.dispose())}i(c){const k=new Map;for(const w of c){const v=R.isLinux?w.path:w.path.toLowerCase();k.set(v,w)}return Array.from(k.values())}async setVerboseLogging(c){this.f=c;for(const[,k]of this.c)k.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,k){return k?`[File Watcher (node.js)] ${c} (path: ${k.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=P}),define(ne[114],re([0,1,62,113]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends N.AbstractNonRecursiveWatcherClient{constructor(I,P,d){super(I,P,d),this.m()}l(){return new L.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(ne[115],re([0,1,16,57,83,62]),function(H,e,N,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class I extends R.AbstractUniversalWatcherClient{constructor(d,c,k){super(d,c,k),this.m()}l(d){const c=d.add(new D.Client(N.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(c.onDidProcessExit(({code:k,signal:w})=>this.n(`terminated by itself with code ${k}, signal: ${w}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=I}),define(ne[63],re([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class N{constructor(...D){this.a=new Map;for(const[R,I]of D)this.set(R,I)}set(D,R){const I=this.a.get(D);return this.a.set(D,R),I}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=N}),define(ne[116],re([0,1,6,7,2,46,111,9,63,162]),function(H,e,N,L,D,R,I,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const k=!1;class w extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class v{constructor(l=new d.ServiceCollection,u=!1,m,p=k){this.f=l,this.g=u,this.h=m,this.i=p,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=p?m?._globalGraph??new I.Graph(g=>g):void 0}createChild(l){return new v(l,this.g,this,this.i)}invokeFunction(l,...u){const m=E.traceInvocation(this.i,l);let p=!1;try{return l({get:b=>{if(p)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(b,m);if(!t)throw new Error(`[invokeFunction] unknown service '${b}'`);return t}},...u)}finally{p=!0,m.stop()}}createInstance(l,...u){let m,p;return l instanceof R.SyncDescriptor?(m=E.traceCreation(this.i,l.ctor),p=this.j(l.ctor,l.staticArguments.concat(u),m)):(m=E.traceCreation(this.i,l),p=this.j(l,u,m)),m.stop(),p}j(l,u=[],m){const p=P._util.getServiceDependencies(l).sort((t,s)=>t.index-s.index),g=[];for(const t of p){const s=this.m(t.id,m);s||this.u(`[createInstance] ${l.name} depends on UNKNOWN service ${t.id}.`,!1),g.push(s)}const b=p.length>0?p[0].index:u.length;if(u.length!==b){console.trace(`[createInstance] First service dependency of ${l.name} at position ${b+1} conflicts with ${u.length} static arguments`);const t=b-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,b)}return Reflect.construct(l,u.concat(g))}k(l,u){if(this.f.get(l)instanceof R.SyncDescriptor)this.f.set(l,u);else if(this.h)this.h.k(l,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(l){const u=this.f.get(l);return!u&&this.h?this.h.l(l):u}m(l,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(l));const m=this.l(l);return m instanceof R.SyncDescriptor?this.q(l,m,u.branch(l,!0)):(u.branch(l,!1),m)}q(l,u,m){if(this.o.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this.o.add(l);try{return this.r(l,u,m)}finally{this.o.delete(l)}}r(l,u,m){const p=new I.Graph(t=>t.id.toString());let g=0;const b=[{id:l,desc:u,_trace:m}];for(;b.length;){const t=b.pop();if(p.lookupOrInsertNode(t),g++>1e3)throw new w(p);for(const s of P._util.getServiceDependencies(t.desc.ctor)){const i=this.l(s.id);if(i||this.u(`[createInstance] ${l} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),i instanceof R.SyncDescriptor){const n={id:s.id,desc:i,_trace:t._trace.branch(s.id,!0)};p.insertEdge(t,n),b.push(n)}}}for(;;){const t=p.roots();if(t.length===0){if(!p.isEmpty())throw new w(p);break}for(const{data:s}of t){if(this.l(s.id)instanceof R.SyncDescriptor){const n=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,n)}p.removeNode(s)}}return this.l(l)}s(l,u,m=[],p,g){if(this.f.get(l)instanceof R.SyncDescriptor)return this.t(l,u,m,p,g);if(this.h)return this.h.s(l,u,m,p,g);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(l,u,m=[],p,g){if(p){const b=new v(void 0,this.g,this,this.i);b.c=String(l);const t=new Map,s=new N.IdleValue(()=>{const i=b.j(u,m,g);for(const[n,r]of t){const a=i[n];if(typeof a=="function")for(const o of r)a.apply(i,o)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=t.get(n);return o||(o=new c.LinkedList,t.set(n,o)),(f,O,x)=>{const _=o.push([f,O,x]);return(0,D.toDisposable)(_)}}if(n in i)return i[n];const r=s.value;let a=r[n];return typeof a!="function"||(a=a.bind(r),i[n]=a),a},set(i,n,r){return s.value[n]=r,!0},getPrototypeOf(i){return u.prototype}})}else return this.j(u,m,g)}u(l,u){if(u&&console.warn(l),this.g)throw new Error(l)}}e.InstantiationService=v;var S;(function(T){T[T.None=0]="None",T[T.Creation=1]="Creation",T[T.Invocation=2]="Invocation",T[T.Branch=3]="Branch"})(S||(S={}));class E{static traceInvocation(l,u){return l?new E(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(l,u){return l?new E(1,u.name):E.c}constructor(l,u){this.type=l,this.name=u,this.g=Date.now(),this.h=[]}branch(l,u){const m=new E(3,l.toString());return this.h.push([l,u,m]),m}stop(){const l=Date.now()-this.g;E.f+=l;let u=!1;function m(g,b){const t=[],s=new Array(g+1).join("	");for(const[i,n,r]of b.h)if(n&&r){u=!0,t.push(`${s}CREATES -> ${i}`);const a=m(g+1,r);a&&t.push(a)}else t.push(`${s}uses -> ${i}`);return t.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(l>2||u)&&E.all.add(p.join(`
`))}}E.all=new Set,E.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}},E.f=0,e.Trace=E});var ie=this&&this.__param||function(H,e){return function(N,L){e(N,L,H)}};define(ne[64],re([0,1,23,2,12,98,21,9]),function(H,e,N,L,D,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function d(k){return k.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=d,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let c=class extends L.Disposable{constructor(w){super(),this.c=w}async getAvailableLanguages(){const w=new N.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let v;try{v=await this.c.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const E=v.firstPage.filter(T=>T.properties.localizedLanguages?.length&&T.tags.some(l=>l.startsWith("lp-"))).map(T=>{const l=T.properties.localizedLanguages?.[0],u=d(T);return{...this.f(u,l,T),extensionId:T.identifier.id,galleryExtension:T}});return E.push(this.f("en","English")),E}f(w,v,S){const E=v??w;let T;if(E!==w&&(T=`(${w})`),w.toLowerCase()===D.language.toLowerCase()&&(T??="",T+=(0,R.localize)(0,null)),S?.installCount){T??="";const l=S.installCount;let u;l>1e6?u=`${Math.floor(l/1e5)/10}M`:l>1e3?u=`${Math.floor(l/1e3)}K`:u=String(l),T+=` $(cloud-download) ${u}`}return{id:w,label:E,description:T}}};c=de([ie(0,I.IExtensionGalleryService)],c),e.LanguagePackBaseService=c}),define(ne[5],re([0,1,34,4,2,36,12,17,3,11,112,9]),function(H,e,N,L,D,R,I,P,d,c,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function v(){return new Date().toISOString()}function S(h){return(0,d.isNumber)(h)}e.isLogLevel=S;var E;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function T(h,f,O){switch(f){case E.Trace:h.trace(O);break;case E.Debug:h.debug(O);break;case E.Info:h.info(O);break;case E.Warning:h.warn(O);break;case E.Error:h.error(O);break;case E.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=T;function l(h){let f="";for(let O=0;O<h.length;O++){let x=h[O];if(typeof x=="object")try{x=JSON.stringify(x)}catch{}f+=(O>0?" ":"")+x}return f}e.format=l;class u extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==E.Off&&this.b<=f}}e.AbstractLogger=u;class m extends u{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...O){this.f(E.Trace)&&this.g(E.Trace,l([f,...O]))}debug(f,...O){this.f(E.Debug)&&this.g(E.Debug,l([f,...O]))}info(f,...O){this.f(E.Info)&&this.g(E.Info,l([f,...O]))}warn(f,...O){this.f(E.Warning)&&this.g(E.Warning,l([f,...O]))}error(f,...O){if(this.f(E.Error))if(f instanceof Error){const x=Array.prototype.slice.call(arguments);x[0]=f.stack,this.g(E.Error,l(x))}else this.g(E.Error,l([f,...O]))}flush(){}}e.AbstractMessageLogger=m;class p extends u{constructor(f=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(f),this.g=!I.isWindows}trace(f,...O){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,f,...O):console.log(`[main ${v()}]`,f,...O))}debug(f,...O){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,f,...O):console.log(`[main ${v()}]`,f,...O))}info(f,...O){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,f,...O):console.log(`[main ${v()}]`,f,...O))}warn(f,...O){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,f,...O):console.warn(`[main ${v()}]`,f,...O))}error(f,...O){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,f,...O):console.error(`[main ${v()}]`,f,...O))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class g extends u{constructor(f=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(f)}trace(f,...O){this.f(E.Trace)&&console.log("%cTRACE","color: #888",f,...O)}debug(f,...O){this.f(E.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",f,...O)}info(f,...O){this.f(E.Info)&&console.log("%c INFO","color: #33f",f,...O)}warn(f,...O){this.f(E.Warning)&&console.log("%c WARN","color: #993",f,...O)}error(f,...O){this.f(E.Error)&&console.log("%c  ERR","color: #f33",f,...O)}dispose(){}flush(){}}e.ConsoleLogger=g;class b extends u{constructor(f,O=e.DEFAULT_LOG_LEVEL){super(),this.g=f,this.setLevel(O)}trace(f,...O){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(f),...O])}debug(f,...O){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(f),...O])}info(f,...O){this.f(E.Info)&&this.g.log(E.Info,[this.h(f),...O])}warn(f,...O){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(f),...O])}error(f,...O){this.f(E.Error)&&this.g.log(E.Error,[this.h(f),...O])}h(f){return typeof f=="string"?f:(0,N.toErrorMessage)(f,this.f(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=b;class t extends u{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const O of this.g)O.setLevel(f);super.setLevel(f)}trace(f,...O){for(const x of this.g)x.trace(f,...O)}debug(f,...O){for(const x of this.g)x.debug(f,...O)}info(f,...O){for(const x of this.g)x.info(f,...O)}warn(f,...O){for(const x of this.g)x.warn(f,...O)}error(f,...O){for(const x of this.g)x.error(f,...O)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.MultiplexLogger=t;class s extends D.Disposable{constructor(f,O,x){if(super(),this.h=f,this.j=O,this.b=new R.ResourceMap,this.c=this.B(new L.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeVisibility=this.g.event,x)for(const _ of x)this.b.set(_.resource,{logger:void 0,info:_})}k(f){return(0,d.isString)(f)?[...this.b.values()].find(O=>O.info.id===f):this.b.get(f)}getLogger(f){return this.k(f)?.logger}createLogger(f,O){const x=this.l(f);let _=this.b.get(x)?.logger;const ee=O?.logLevel==="always"?E.Trace:O?.logLevel;_||(_=this.m(x,ee??this.getLogLevel(x)??this.h,O));const se={logger:_,info:{resource:x,id:O?.id??x.toString(),logLevel:ee,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(se.info),this.b.set(x,se),_}l(f){return(0,d.isString)(f)?(0,P.joinPath)(this.j,`${f}.log`):f}setLogLevel(f,O){if(c.URI.isUri(f)){const x=f,_=O,ee=this.b.get(x);ee&&_!==ee.info.logLevel&&(ee.info.logLevel=_===this.h?void 0:_,ee.logger?.setLevel(_),this.b.set(ee.info.resource,ee),this.f.fire([x,_]))}else{this.h=f;for(const[x,_]of this.b.entries())this.b.get(x)?.info.logLevel===void 0&&_.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,O){const x=this.k(f);x&&O!==!x.info.hidden&&(x.info.hidden=!O,this.b.set(x.info.resource,x),this.g.fire([x.info.resource,O]))}getLogLevel(f){let O;return f&&(O=this.b.get(f)?.info.logLevel),O??this.h}registerLogger(f){const O=this.b.get(f.resource);O?O.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const O=this.b.get(f);O&&(O.logger&&O.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=s;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(f){}getLevel(){return E.Info}trace(f,...O){}debug(f,...O){}info(f,...O){}warn(f,...O){}error(f,...O){}critical(f,...O){}dispose(){}flush(){}}e.NullLogger=i;class n extends i{}e.NullLogService=n;function r(h){if(h.verbose)return E.Trace;if(typeof h.logLevel=="string"){const f=o(h.logLevel.toLowerCase());if(f!==void 0)return f}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function a(h){switch(h){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=a;function o(h){switch(h){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=o,e.CONTEXT_LOG_LEVEL=new k.RawContextKey("logLevel",a(E.Info))}),define(ne[117],re([0,1,19,6,7,4,2,15,62,5]),function(H,e,N,L,D,R,I,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class k extends I.Disposable{constructor(v,S){super(),this.a=v,this.b=S,this.c=this.B(new R.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new L.ThrottledDelayer(0)),this.s=[],this.t=this.B(new L.ThrottledDelayer(0))}watch(v,S){return S.recursive||this.b?.watcher?.forceUniversal?this.l(v,S):this.u(v,S)}l(v,S){const E={path:this.C(v),excludes:S.excludes,includes:S.includes,recursive:S.recursive},T=(0,N.insert)(this.j,E);return this.m(),(0,I.toDisposable)(()=>{T(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(v=>(0,D.onUnexpectedError)(v))}n(){this.h||(this.h=this.B(this.p(S=>this.c.fire((0,d.toFileChanges)(S)),S=>this.z(S),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const S of this.j)(0,d.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const S of this.j)(0,d.isRecursiveWatchRequest)(S)&&v.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(v,S){const E={path:this.C(v),excludes:S.excludes,includes:S.includes,recursive:!1},T=(0,N.insert)(this.s,E);return this.v(),(0,I.toDisposable)(()=>{T(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(v=>(0,D.onUnexpectedError)(v))}w(){return this.r||(this.r=this.B(this.y(v=>this.c.fire((0,d.toFileChanges)(v)),v=>this.z(v),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.r.watch(this.s)}z(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}C(v){return(0,P.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=k}),define(ne[118],re([0,1,19,6,14,23,4,52,65,2,55,16,119,17,44,95,13,61,5,7]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S,E,T,l,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends c.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new I.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new I.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new I.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new I.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new L.ResourceQueue)}registerProvider(t,s){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${t}`);const i=new c.DisposableStore;return this.h.set(t,s),this.c.fire({added:!0,scheme:t,provider:s}),i.add(s.onDidChangeFile(n=>this.R.fire(new l.FileChangesEvent(n,!this.O(s))))),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:t}))),(0,c.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:s}),this.h.delete(t),(0,c.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const s=[];this.f.fire({scheme:t,join(i){s.push(i)}}),!this.h.has(t)&&await L.Promises.settled(s)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,s){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return d.Iterable.map(this.h,([t,s])=>({scheme:t,capabilities:s.capabilities}))}async j(t){if(!(0,S.isAbsolutePath)(t))throw new l.FileOperationError((0,T.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const s=this.h.get(t.scheme);if(!s){const i=new p.ErrorNoTelemetry;throw i.message=(0,T.localize)(1,null,t.toString()),i}return s}async k(t){const s=await this.j(t);if((0,l.hasOpenReadWriteCloseCapability)(s)||(0,l.hasReadWriteCapability)(s)||(0,l.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const s=await this.j(t);if((0,l.hasOpenReadWriteCloseCapability)(s)||(0,l.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,s){try{return await this.n(t,s)}catch(i){throw(0,l.toFileSystemProviderErrorCode)(i)===l.FileSystemProviderErrorCode.FileNotFound?new l.FileOperationError((0,T.localize)(2,null,this.nb(t)),1):(0,l.ensureFileSystemProviderError)(i)}}async n(t,s){const i=await this.j(t),n=this.O(i),r=s?.resolveTo,a=s?.resolveSingleChildDescendants,o=s?.resolveMetadata,h=await i.stat(t);let f;return this.p(i,t,h,void 0,!!o,(O,x)=>(f||(f=k.TernarySearchTree.forUris(()=>!n),f.set(t,!0),r&&f.fill(!0,r)),f.get(O.resource)||f.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&a?x===1:!1))}async p(t,s,i,n,r,a){const{providerExtUri:o}=this.N(t),h={resource:s,name:o.basename(s),isFile:(i.type&l.FileType.File)!==0,isDirectory:(i.type&l.FileType.Directory)!==0,isSymbolicLink:(i.type&l.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&l.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,l.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(h.isDirectory&&a(h,n)){try{const f=await t.readdir(s),O=await L.Promises.settled(f.map(async([x,_])=>{try{const ee=o.joinPath(s,x),se=r?await t.stat(ee):{type:_};return await this.p(t,ee,se,f.length,r,a)}catch(ee){return this.b.trace(ee),null}}));h.children=(0,N.coalesce)(O)}catch(f){this.b.trace(f),h.children=[]}return h}return h}async resolveAll(t){return L.Promises.settled(t.map(async s=>{try{return{stat:await this.n(s.resource,s.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const s=await this.j(t),i=await s.stat(t);return this.p(s,t,i,void 0,!0,()=>!1)}async exists(t){const s=await this.j(t);try{return!!await s.stat(t)}catch{return!1}}async canCreateFile(t,s){try{await this.r(t,s)}catch(i){return i}return!0}async r(t,s){if(!s?.overwrite&&await this.exists(t))throw new l.FileOperationError((0,T.localize)(3,null,this.nb(t)),3,s)}async createFile(t,s=D.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,s);return this.m.fire(new l.FileOperationEvent(t,0,n)),n}async writeFile(t,s,i){const n=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(n);try{await this.s(n,t,i)||await this.P(n,r.dirname(t));let o;if((0,l.hasReadWriteCapability)(n)&&!(s instanceof D.VSBuffer))if((0,E.isReadableStream)(s)){const h=await(0,E.peekStream)(s,3);h.ended?o=D.VSBuffer.concat(h.buffer):o=h}else o=(0,E.peekReadable)(s,h=>D.VSBuffer.concat(h),3);else o=s;!(0,l.hasOpenReadWriteCloseCapability)(n)||(0,l.hasReadWriteCapability)(n)&&o instanceof D.VSBuffer?await this.cb(n,t,i,o):await this.Y(n,t,i,o instanceof D.VSBuffer?(0,D.bufferToReadable)(o):o),this.m.fire(new l.FileOperationEvent(t,4))}catch(a){throw new l.FileOperationError((0,T.localize)(4,null,this.nb(t),(0,l.ensureFileSystemProviderError)(a).toString()),(0,l.toFileOperationResult)(a),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,s,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,T.localize)(5,null,this.nb(s)));let r;try{r=await t.stat(s)}catch{return}if((r.type&l.FileType.Directory)!==0)throw new l.FileOperationError((0,T.localize)(6,null,this.nb(s)),0,i);if(this.mb(s,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==l.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,l.etag)({mtime:i.mtime,size:r.size}))throw new l.FileOperationError((0,T.localize)(7,null),3,i);return r}async readFile(t,s,i){const n=await this.k(t);return s?.atomic?this.t(n,t,s,i):this.u(n,t,s,i)}async t(t,s,i,n){return new Promise((r,a)=>{this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{try{const o=await this.u(t,s,i,n);r(o)}catch(o){a(o)}})})}async u(t,s,i,n){const r=await this.v(t,s,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,D.streamToBuffer)(r.value)}}async readFileStream(t,s,i){const n=await this.k(t);return this.v(n,t,s,i)}async v(t,s,i,n){const r=new R.CancellationTokenSource(n),a=this.F(s,i).then(h=>h,h=>{throw r.cancel(),h});let o;try{return typeof i?.etag=="string"&&i.etag!==l.ETAG_DISABLED&&await a,i?.atomic&&(0,l.hasFileAtomicReadCapability)(t)||!((0,l.hasOpenReadWriteCloseCapability)(t)||(0,l.hasFileReadStreamCapability)(t))||(0,l.hasReadWriteCapability)(t)&&i?.preferUnbuffered?o=this.D(t,s,i):(0,l.hasFileReadStreamCapability)(t)?o=this.z(t,s,r.token,i):o=this.C(t,s,r.token,i),{...await a,value:o}}catch(h){throw o&&await(0,E.consumeStream)(o),this.w(h,s,i)}}w(t,s,i){const n=(0,T.localize)(8,null,this.nb(s),(0,l.ensureFileSystemProviderError)(t).toString());return t instanceof l.NotModifiedSinceFileOperationError?new l.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof l.TooLargeFileOperationError?new l.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new l.FileOperationError(n,(0,l.toFileOperationResult)(t),i)}z(t,s,i,n=Object.create(null)){const r=t.readFileStream(s,n,i);return(0,E.transform)(r,{data:a=>a instanceof D.VSBuffer?a:D.VSBuffer.wrap(a),error:a=>this.w(a,s,n)},a=>D.VSBuffer.concat(a))}C(t,s,i,n=Object.create(null)){const r=(0,D.newWriteableBufferStream)();return(0,u.readFileIntoStream)(t,s,r,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>this.w(a,s,n)},i),r}D(t,s,i){const n=(0,E.newWriteableStream)(r=>D.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,l.hasFileAtomicReadCapability)(t)?r=await t.readFile(s,{atomic:!0}):r=await t.readFile(s),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(s,r.byteLength,i),n.end(D.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(t,s){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new l.FileOperationError((0,T.localize)(9,null,this.nb(t)),0,s);if(typeof s?.etag=="string"&&s.etag!==l.ETAG_DISABLED&&s.etag===i.etag)throw new l.NotModifiedSinceFileOperationError((0,T.localize)(10,null),i,s);return this.G(t,i.size,s),i}G(t,s,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&s>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&s>i.limits.size&&(n=7),typeof n=="number")throw new l.TooLargeFileOperationError((0,T.localize)(11,null,this.nb(t)),n,s,i)}}async canMove(t,s,i){return this.H(t,s,"move",i)}async canCopy(t,s,i){return this.H(t,s,"copy",i)}async H(t,s,i,n){if(t.toString()!==s.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),a=this.lb(await this.l(s),s);await this.M(r,t,a,s,i,n)}catch(r){return r}return!0}async move(t,s,i){const n=this.lb(await this.l(t),t),r=this.lb(await this.l(s),s),a=await this.I(n,t,r,s,"move",!!i),o=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new l.FileOperationEvent(t,a==="move"?2:3,o)),o}async copy(t,s,i){const n=await this.k(t),r=this.lb(await this.l(s),s),a=await this.I(n,t,r,s,"copy",!!i),o=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new l.FileOperationEvent(t,a==="copy"?3:2,o)),o}async I(t,s,i,n,r,a){if(s.toString()===n.toString())return r;const{exists:o,isSameResourceWithDifferentPathCase:h}=await this.M(t,s,i,n,r,a);if(o&&!h&&a&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,l.hasFileFolderCopyCapability)(t))await t.copy(s,n,{overwrite:a});else{const f=await this.resolve(s);f.isDirectory?await this.L(t,f,i,n):await this.J(t,s,i,n)}return r}else return t===i?(await t.rename(s,n,{overwrite:a}),r):(await this.I(t,s,i,n,"copy",a),await this.del(s,{recursive:!0}),"copy")}async J(t,s,i,n){if((0,l.hasOpenReadWriteCloseCapability)(t)&&(0,l.hasOpenReadWriteCloseCapability)(i))return this.eb(t,s,i,n);if((0,l.hasOpenReadWriteCloseCapability)(t)&&(0,l.hasReadWriteCapability)(i))return this.kb(t,s,i,n);if((0,l.hasReadWriteCapability)(t)&&(0,l.hasOpenReadWriteCloseCapability)(i))return this.ib(t,s,i,n);if((0,l.hasReadWriteCapability)(t)&&(0,l.hasReadWriteCapability)(i))return this.gb(t,s,i,n)}async L(t,s,i,n){await i.mkdir(n),Array.isArray(s.children)&&await L.Promises.settled(s.children.map(async r=>{const a=this.N(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,a):this.J(t,r.resource,i,a)}))}async M(t,s,i,n,r,a){let o=!1;if(t===i){const{providerExtUri:f,isPathCaseSensitive:O}=this.N(t);if(O||(o=f.isEqual(s,n)),o&&r==="copy")throw new Error((0,T.localize)(12,null,this.nb(s),this.nb(n)));if(!o&&f.isEqualOrParent(n,s))throw new Error((0,T.localize)(13,null,this.nb(s),this.nb(n)))}const h=await this.exists(n);if(h&&!o){if(!a)throw new l.FileOperationError((0,T.localize)(14,null,this.nb(s),this.nb(n)),4);if(t===i){const{providerExtUri:f}=this.N(t);if(f.isEqualOrParent(s,n))throw new Error((0,T.localize)(15,null,this.nb(s),this.nb(n)))}}return{exists:h,isSameResourceWithDifferentPathCase:o}}N(t){const s=this.O(t);return{providerExtUri:s?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:s}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const s=this.lb(await this.j(t),t);await this.P(s,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new l.FileOperationEvent(t,0,i)),i}async P(t,s){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(s,n.dirname(s));)try{if(((await t.stat(s)).type&l.FileType.Directory)===0)throw new Error((0,T.localize)(16,null,this.nb(s)));break}catch(r){if((0,l.toFileSystemProviderErrorCode)(r)!==l.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(s)),s=n.dirname(s)}for(let r=i.length-1;r>=0;r--){s=n.joinPath(s,i[r]);try{await t.mkdir(s)}catch(a){if((0,l.toFileSystemProviderErrorCode)(a)!==l.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,s){try{await this.Q(t,s)}catch(i){return i}return!0}async Q(t,s){const i=this.lb(await this.j(t),t);if(!!s?.useTrash&&!(i.capabilities&4096))throw new Error((0,T.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new l.FileOperationError((0,T.localize)(18,null,this.nb(t)),1);if(!!!s?.recursive){const o=await this.resolve(t);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,T.localize)(19,null,this.nb(t)))}return i}async del(t,s){const i=await this.Q(t,s),n=!!s?.useTrash,r=!!s?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this.m.fire(new l.FileOperationEvent(t,1))}async cloneFile(t,s){const i=await this.j(t),n=this.lb(await this.l(s),s);if(i===n&&this.N(i).providerExtUri.isEqual(t,s))return;if(i===n&&(0,l.hasFileCloneCapability)(i))return i.cloneFile(t,s);await this.P(n,this.N(n).providerExtUri.dirname(s));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,l.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,s,{overwrite:!0})):r.queue(()=>this.J(i,t,n,s))}watch(t,s={recursive:!1,excludes:[]}){const i=new c.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,c.toDisposable)(()=>r())),(async()=>{try{const a=await this.W(t,s);n?(0,c.dispose)(a):r=()=>(0,c.dispose)(a)}catch(a){this.b.error(a)}})(),i}async W(t,s){const i=await this.j(t),n=(0,P.hash)([this.N(i).providerExtUri.getComparisonKey(t),s]);let r=this.U.get(n);return r||(r={count:0,disposable:i.watch(t,s)},this.U.set(n,r)),r.count+=1,(0,c.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,c.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,c.dispose)(t.disposable);this.U.clear()}async Y(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,E.isReadableStream)(n)||(0,E.isReadableBufferedStream)(n)?await this.Z(t,r,n):await this.ab(t,r,n)}catch(a){throw(0,l.ensureFileSystemProviderError)(a)}finally{await t.close(r)}})}async Z(t,s,i){let n=0,r;if((0,E.isReadableBufferedStream)(i)){if(i.buffer.length>0){const a=D.VSBuffer.concat(i.buffer);await this.bb(t,s,a,a.byteLength,n,0),n+=a.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((a,o)=>{(0,E.listenStream)(r,{onData:async h=>{r.pause();try{await this.bb(t,s,h,h.byteLength,n,0)}catch(f){return o(f)}n+=h.byteLength,setTimeout(()=>r.resume())},onError:h=>o(h),onEnd:()=>a()})})}async ab(t,s,i){let n=0,r;for(;(r=i.read())!==null;)await this.bb(t,s,r,r.byteLength,n,0),n+=r.byteLength}async bb(t,s,i,n,r,a){let o=0;for(;o<n;)o+=await t.write(s,r+o,i.buffer,a+o,n-o)}async cb(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.db(t,s,i,n))}async db(t,s,i,n){let r;n instanceof D.VSBuffer?r=n:(0,E.isReadableStream)(n)?r=await(0,D.streamToBuffer)(n):(0,E.isReadableBufferedStream)(n)?r=await(0,D.bufferedStreamToBuffer)(n):r=(0,D.readableToBuffer)(n),await t.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,s,i,n))}async fb(t,s,i,n){let r,a;try{r=await t.open(s,{create:!1}),a=await i.open(n,{create:!0,unlock:!1});const o=D.VSBuffer.alloc(this.a);let h=0,f=0,O=0;do O=await t.read(r,h,o.buffer,f,o.byteLength-f),await this.bb(i,a,o,O,h,f),h+=O,f+=O,f===o.byteLength&&(f=0);while(O>0)}catch(o){throw(0,l.ensureFileSystemProviderError)(o)}finally{await L.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async gb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,s,i,n))}async hb(t,s,i,n){return i.writeFile(n,await t.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async ib(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,s,i,n))}async jb(t,s,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const a=await t.readFile(s);await this.bb(i,r,D.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,l.ensureFileSystemProviderError)(a)}finally{await i.close(r)}}async kb(t,s,i,n){const r=await(0,D.streamToBuffer)(this.C(t,s,R.CancellationToken.None));await this.cb(i,n,void 0,r)}lb(t,s){if(t.capabilities&2048)throw new l.FileOperationError((0,T.localize)(20,null,this.nb(s)),6);return t}mb(t,s){if((s.permissions??0)&l.FilePermission.Readonly)throw new l.FileOperationError((0,T.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===w.Schemas.file?t.fsPath:t.toString(!0)}};g=de([ie(0,m.ILogService)],g),e.FileService=g}),define(ne[120],re([0,1,121,163,6,36,14,4,164,2,15,12,17,44,20,97,13,61,117,34,115,114]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S,E,T,l,u,m,p,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(N)}catch(s){console.error(`Error enabling graceful-fs: ${(0,p.toErrorMessage)(s)}`)}})();class t extends m.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=P.Event.None,this.H=new R.ResourceMap(r=>v.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,w.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:r}=await E.SymlinkSupport.stat(this.C(i));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await E.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async a=>{try{let o;a.isSymbolicLink()?o=(await this.stat((0,v.joinPath)(i,a.name))).type:o=this.G(a),r.push([a.name,o])}catch(o){this.a.trace(o)}})),r}catch(n){throw this.Y(n)}}G(i,n){let r;return n?.dangling?r=l.FileType.Unknown:i.isFile()?r=l.FileType.File:i.isDirectory()?r=l.FileType.Directory:r=l.FileType.Unknown,n&&(r|=l.FileType.SymbolicLink),r}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const a=new D.Barrier;return this.H.set(i,a),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===a&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const a=this.C(i);return await E.Promises.readFile(a)}catch(a){throw this.Y(a)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,r){const a=(0,S.newWriteableStream)(o=>I.VSBuffer.concat(o.map(h=>I.VSBuffer.wrap(h))).buffer);return(0,u.readFileIntoStream)(this,i,a,o=>o.buffer,{...n,bufferSize:256*1024},r),a}async writeFile(i,n,r){let a;try{const o=this.C(i);if(!r.create||!r.overwrite){if(await E.Promises.exists(o)){if(!r.overwrite)throw(0,l.createFileSystemProviderError)((0,T.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,l.createFileSystemProviderError)((0,T.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(o){throw await this.Z(i,o)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const r=this.C(i);let a;(0,l.isFileOpenForWriteOptions)(n)&&(a=await this.I(i));let o;try{if((0,l.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:f}=await E.SymlinkSupport.stat(r);f.mode&128||await E.Promises.chmod(r,f.mode|128)}catch(f){this.a.trace(f)}let h;if((0,l.isFileOpenForWriteOptions)(n)){if(w.isWindows)try{await E.Promises.truncate(r,0),h="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}h||(h="w")}else h="r";o=await E.Promises.open(r,h)}catch(h){throw a?.dispose(),(0,l.isFileOpenForWriteOptions)(n)?await this.Z(i,h):this.Y(h)}if(this.L.set(o,0),(0,l.isFileOpenForWriteOptions)(n)&&this.N.set(o,i),a){const h=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${r})`),this.M.set(o,a),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${r})`),h.dispose())}return o}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await E.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await E.Promises.close(i)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,a,o){const h=this.P(i,n);let f=null;try{f=(await E.Promises.read(i,r,a,o,h)).bytesRead}catch(O){throw this.Y(O)}finally{this.Q(i,h,f)}return f}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,r){const a=this.L.get(i);typeof a=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(i,a+r):this.L.delete(i)))}async write(i,n,r,a,o){return(0,D.retry)(()=>this.R(i,n,r,a,o),100,3)}async R(i,n,r,a,o){const h=this.P(i,n);let f=null;try{f=(await E.Promises.write(i,r,a,o,h)).bytesWritten}catch(O){throw await this.Z(this.N.get(i),O)}finally{this.Q(i,h,f)}return f}async mkdir(i){try{await E.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const r=this.C(i);n.recursive?await E.Promises.rm(r,E.RimRafMode.MOVE):await E.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,n,r){const a=this.C(i),o=this.C(n);if(a!==o)try{await this.S(i,n,"move",r.overwrite),await E.Promises.move(a,o)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,T.localize)(2,null,(0,k.basename)(a),(0,k.basename)((0,k.dirname)(o)),h.toString()))),this.Y(h)}}async copy(i,n,r){const a=this.C(i),o=this.C(n);if(a!==o)try{await this.S(i,n,"copy",r.overwrite),await E.Promises.copy(a,o,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,T.localize)(3,null,(0,k.basename)(a),(0,k.basename)((0,k.dirname)(o)),h.toString()))),this.Y(h)}}async S(i,n,r,a){const o=this.C(i),h=this.C(n);let f=!1;if(!!(this.capabilities&1024)||(f=(0,d.isEqual)(o,h,!0)),f&&r==="copy")throw(0,l.createFileSystemProviderError)((0,T.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!f&&await E.Promises.exists(h)){if(!a)throw(0,l.createFileSystemProviderError)((0,T.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,r){const a=this.C(i),o=this.C(n),h=!!(this.capabilities&1024);if((0,d.isEqual)(a,o,!h))return;const f=new c.DisposableStore;try{const[O,x]=await Promise.all([this.I(i),this.I(n)]);f.add(O),f.add(x),r&&await E.Promises.mkdir((0,k.dirname)(o),{recursive:!0}),await E.Promises.copyFile(a,o)}catch(O){if(O.code==="ENOENT"&&!r)return this.U(i,n,!0);throw this.Y(O)}finally{f.dispose()}}p(i,n,r){return new g.UniversalWatcherClient(a=>i(a),a=>n(a),r)}y(i,n,r){return new b.NodeJSWatcherClient(a=>i(a),a=>n(a),r)}Y(i){if(i instanceof l.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=l.FileSystemProviderErrorCode.NoPermissions;break;default:n=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(i,n)}async Z(i,n){let r=this.Y(n);if(i&&r.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await E.SymlinkSupport.stat(this.C(i));a.mode&128||(r=(0,l.createFileSystemProviderError)(n,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return r}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(ne[122],re([0,1,2,5]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends N.Disposable{constructor(I,P=[]){super(),this.a=new L.MultiplexLogger([I,...P]),this.B(I.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...P){this.a.trace(I,...P)}debug(I,...P){this.a.debug(I,...P)}info(I,...P){this.a.info(I,...P)}warn(I,...P){this.a.warn(I,...P)}error(I,...P){this.a.error(I,...P)}flush(){this.a.flush()}}e.LogService=D}),define(ne[123],re([0,1,13,5]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var D;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(D||(D={}));async function R(c,k,w,v,S){try{const E=await new Promise((l,u)=>{H(["spdlog"],l,u)});E.setFlushOn(D.Trace);const T=await E.createAsyncRotatingLogger(c,k,w,v);return S?T.clearFormatters():T.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),T}catch(E){console.error(E)}return null}function I(c,k,w){switch(k){case L.LogLevel.Trace:c.trace(w);break;case L.LogLevel.Debug:c.debug(w);break;case L.LogLevel.Info:c.info(w);break;case L.LogLevel.Warning:c.warn(w);break;case L.LogLevel.Error:c.error(w);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${k}`)}}function P(c,k){switch(k){case L.LogLevel.Trace:c.setLevel(D.Trace);break;case L.LogLevel.Debug:c.setLevel(D.Debug);break;case L.LogLevel.Info:c.setLevel(D.Info);break;case L.LogLevel.Warning:c.setLevel(D.Warning);break;case L.LogLevel.Error:c.setLevel(D.Error);break;case L.LogLevel.Off:c.setLevel(D.Off);break;default:throw new Error(`Invalid log level ${k}`)}}class d extends L.AbstractMessageLogger{constructor(k,w,v,S,E){super(),this.k=[],this.setLevel(E),this.l=this.n(k,w,v,S),this.B(this.onDidChangeLogLevel(T=>{this.m&&P(this.m,T)}))}async n(k,w,v,S){const E=v?6:1,T=30/E*N.ByteSize.MB,l=await R(k,w,T,E,S);if(l){this.m=l,P(this.m,this.getLevel());for(const{level:u,message:m}of this.k)I(this.m,u,m);this.k=[]}}g(k,w){this.m?I(this.m,k,w):this.getLevel()<=k&&this.k.push({level:k,message:w})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=d}),define(ne[124],re([0,1,28,5,123]),function(H,e,N,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class R extends L.AbstractLoggerService{m(P,d,c){return new D.SpdLogLogger((0,N.generateUuid)(),P.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,d)}}e.LoggerService=R}),define(ne[38],re([0,1,4,65,2,9]),function(H,e,N,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class I extends D.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new N.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const k=Object.keys(this.f).length;return this.f={...c,...this.f},k!==Object.keys(this.f).length&&await this.i(c),L.Iterable.reduce(this.g.entries(),(w,[v,S])=>({...w,[v]:S}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(c,[k,w])=>({...c,[k]:{definition:w,value:this.g.get(k)}}),{})}}e.AbstractPolicyService=I;class P{constructor(){this.onDidChange=N.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ne[125],re([0,1,6,4,65,3,13,5,38]),function(H,e,N,L,D,R,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(w,v){const S=[];for(const E of new Set(D.Iterable.concat(w.keys(),v.keys())))w.get(E)!==v.get(E)&&S.push(E);return S}let k=class extends d.AbstractPolicyService{constructor(v,S,E){super(),this.j=v,this.k=S,this.l=E,this.c=this.B(new N.ThrottledDelayer(500));const T=L.Event.filter(S.onDidFilesChange,l=>l.affects(v));this.B(S.watch(v)),this.B(T(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const v=new Map;try{const S=await this.k.readFile(this.j),E=JSON.parse(S.value.toString());if(!(0,R.isObject)(E))throw new Error("Policy file isn't a JSON object");for(const T of Object.keys(E))this.f[T]&&v.set(T,E[T])}catch(S){S.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",S)}return v}async p(){const v=await this.n(),S=c(this.g,v);this.g=v,S.length>0&&this.h.fire(S)}};k=de([ie(1,I.IFileService),ie(2,P.ILogService)],k),e.FilePolicyService=k}),define(ne[126],re([0,1,38,6,165,2,5]),function(H,e,N,L,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let P=class extends N.AbstractPolicyService{constructor(c,k){super(),this.j=c,this.k=k,this.a=new L.Throttler,this.b=this.B(new R.MutableDisposable)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((k,w)=>{try{this.b.value=(0,D.createWatcher)(this.k,c,v=>{this.m(v),k()})}catch(v){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),w(v)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const k in c){const w=c[k];w===void 0?this.g.delete(k):this.g.set(k,w)}this.h.fire(Object.keys(c))}};P=de([ie(0,I.ILogService)],P),e.NativePolicyService=P}),define(ne[31],re([0,1,9]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,N.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[37],re([0,1,70,3]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(I,P){N.ok(L.isString(I)),N.ok(L.isObject(P)),N.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,P)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.Registry=new D}),define(ne[127],re([0,1,4,37]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this.b=new N.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,c){this.a[D(d)]=c,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const I=new R;L.Registry.add(e.Extensions.JSONContribution,I)}),define(ne[42],re([0,1,19,4,3,86,24,127,37]),function(H,e,N,L,D,R,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(c=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=d.Registry.as(P.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const i=new Set;this.n(t,s,i),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const s=new Set;this.o(t,s),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const i=new Set;this.o(s,i),this.n(t,!1,i),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const i=[];for(const{overrides:n,source:r}of t)for(const a in n)if(s.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const o=this.a.get(a),h=o?.valuesSources??new Map;if(r)for(const _ of Object.keys(n[a]))h.set(_,r);const f={...o?.value||{},...n[a]};this.a.set(a,{source:r,value:f,valuesSources:h});const O=(0,I.getLanguageTagSettingPlainKey)(a),x={type:"object",default:f,description:R.localize(1,null,O),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:D.isString(r)?void 0:r,defaultValueSource:r};i.push(...T(a)),this.d[a]=x,this.b.properties[a]=x}else{this.a.set(a,{value:n[a],source:r});const o=this.d[a];o&&(this.w(a,o),this.r(a,o))}this.m(i)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:i,source:n}of t)for(const r in i){const a=this.a.get(r),o=D.isString(n)?n:n?.id,h=D.isString(a?.source)?a?.source:a?.source?.id;if(o===h)if(s.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const f=this.d[r];f&&(this.w(r,f),this.r(r,f))}}this.u()}deltaConfiguration(t){let s=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,i){t.forEach(n=>{this.p(n,s,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,s){const i=n=>{if(n.properties)for(const r in n.properties){s.add(r);const a=this.d[r];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,s=!0,i,n,r=3,a){r=D.isUndefinedOrNull(t.scope)?r:t.scope;const o=t.properties;if(o)for(const f in o){const O=o[f];if(s&&p(f,O)){delete o[f];continue}if(O.source=i,O.defaultDefaultValue=o[f].default,this.w(f,O),e.OVERRIDE_PROPERTY_REGEX.test(f)?O.scope=void 0:(O.scope=D.isUndefinedOrNull(O.scope)?r:O.scope,O.restricted=D.isUndefinedOrNull(O.restricted)?!!n?.includes(f):O.restricted),o[f].hasOwnProperty("included")&&!o[f].included){this.f[f]=o[f],delete o[f];continue}else this.d[f]=o[f],o[f].policy?.name&&this.e.set(o[f].policy.name,f);!o[f].deprecationMessage&&o[f].markdownDeprecationMessage&&(o[f].deprecationMessage=o[f].markdownDeprecationMessage),a.add(f)}const h=t.allOf;if(h)for(const f of h)this.p(f,s,i,n,r,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=i=>{const n=i.properties;if(n)for(const a in n)this.r(a,n[a]);i.allOf?.forEach(s)};s(t)}r(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,s){const i=this.a.get(t);let n=i?.value,r=i?.source;D.isUndefined(n)&&(n=s.defaultDefaultValue,r=void 0),D.isUndefined(n)&&(n=u(s.type)),s.default=n,s.defaultValueSource=r}}const S="\\[([^\\]]+)\\]",E=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function T(b){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(b)){let s=E.exec(b);for(;s?.length;){const i=s[1].trim();i&&t.push(i),s=E.exec(b)}}return(0,N.distinct)(t)}e.overrideIdentifiersFromKey=T;function l(b){return b.reduce((t,s)=>`${t}[${s}]`,"")}e.keyFromOverrideIdentifiers=l;function u(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const m=new v;d.Registry.add(e.Extensions.Configuration,m);function p(b,t){return b.trim()?e.OVERRIDE_PROPERTY_REGEX.test(b)?R.localize(7,null,b):m.getConfigurationProperties()[b]!==void 0?R.localize(8,null,b):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,b,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=p;function g(){const b=[],t=m.getConfigurationProperties();for(const s of Object.keys(t))b.push([s,t[s].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=g}),define(ne[66],re([0,1,19,4,50,2,36,30,3,11,24,42,37]),function(H,e,N,L,D,R,I,P,d,c,k,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function S(s){return Object.isFrozen(s)?s:P.deepFreeze(s)}class E{constructor(i={},n=[],r=[],a){this.b=i,this.c=n,this.d=r,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof E)return n;const r=new T("");return r.parseRaw(n),r.configurationModel});this.f=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,k.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),a=n?this.rawConfiguration.getOverrideValue(i,n):void 0,o=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:a,merged:o}}getOverrideValue(i,n){const r=this.i(n);return r?i?(0,k.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return N.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return N.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=P.deepClone(this.contents),r=P.deepClone(this.overrides),a=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const h of i)if(o.push(...h.raw?.length?h.raw:[h]),!h.isEmpty()){this.h(n,h.contents);for(const f of h.overrides){const[O]=r.filter(x=>N.equals(x.identifiers,f.identifiers));O?(this.h(O.contents,f.contents),O.keys.push(...f.keys),O.keys=N.distinct(O.keys)):r.push(P.deepClone(f))}for(const f of h.keys)a.indexOf(f)===-1&&a.push(f)}return new E(n,a,r,o.every(h=>h instanceof E)?void 0:o)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const a of N.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[a];const h=n[a];h&&(typeof o=="object"&&typeof h=="object"?(o=P.deepClone(o),this.h(o,h)):o=h),r[a]=o}return new E(r,this.keys,this.overrides)}h(i,n){for(const r of Object.keys(n)){if(r in i&&d.isObject(i[r])&&d.isObject(n[r])){this.h(i[r],n[r]);continue}i[r]=P.deepClone(n[r])}}i(i){let n=null,r=null;const a=o=>{o&&(r?this.h(r,o):r=P.deepClone(o))};for(const o of this.overrides)N.equals(o.identifiers,[i])?n=o.contents:o.identifiers.includes(i)&&a(o.contents);return a(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,k.removeFromValueTree)(this.contents,i),w.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>N.equals(r.identifiers,(0,w.overrideIdentifiersFromKey)(i))),1))}j(i,n,r){(0,k.addToValueTree)(this.contents,i,n,a=>console.error(a)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),w.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,k.toValuesTree)(this.contents[i],a=>console.error(a))})}}e.ConfigurationModel=E;class T{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!d.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:a,overrides:o,restricted:h,hasExcludedProperties:f}=this.h(i,n);this.b=new E(r,a,o,f?[i]:void 0),this.c=h||[]}g(i){let n={},r=null,a=[];const o=[],h=[];function f(x){Array.isArray(a)?a.push(x):r!==null&&(a[r]=x)}const O={onObjectBegin:()=>{const x={};f(x),o.push(a),a=x,r=null},onObjectProperty:x=>{r=x},onObjectEnd:()=>{a=o.pop()},onArrayBegin:()=>{const x=[];f(x),o.push(a),a=x,r=null},onArrayEnd:()=>{a=o.pop()},onLiteralValue:f,onError:(x,_,ee)=>{h.push({error:x,offset:_,length:ee})}};if(i)try{D.visit(i,O),n=a[0]||{}}catch(x){console.error(`Error while parsing settings file ${this.f}: ${x}`),this.d=[x]}return n}h(i,n){const r=v.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),a=this.i(i,r,!0,n);i=a.raw;const o=(0,k.toValuesTree)(i,O=>console.error(`Conflict in settings file ${this.f}: ${O}`)),h=Object.keys(i),f=this.j(i,O=>console.error(`Conflict in settings file ${this.f}: ${O}`));return{contents:o,keys:h,overrides:f,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(i,n,r,a){let o=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:o};const h={},f=[];for(const O in i)if(w.OVERRIDE_PROPERTY_REGEX.test(O)&&r){const x=this.i(i[O],n,!1,a);h[O]=x.raw,o=o||x.hasExcludedProperties,f.push(...x.restricted)}else{const x=n[O],_=x?typeof x.scope<"u"?x.scope:3:void 0;x?.restricted&&f.push(O),(_===void 0||a.scopes===void 0||a.scopes.includes(_))&&!(a.skipRestricted&&x?.restricted)?h[O]=i[O]:o=!0}return{raw:h,restricted:f,hasExcludedProperties:o}}j(i,n){const r=[];for(const a of Object.keys(i))if(w.OVERRIDE_PROPERTY_REGEX.test(a)){const o={};for(const h in i[a])o[h]=i[a][h];r.push({identifiers:(0,w.overrideIdentifiersFromKey)(a),keys:Object.keys(o),contents:(0,k.toValuesTree)(o,n)})}return r}}e.ConfigurationModelParser=T;class l extends R.Disposable{constructor(i,n,r,a){super(),this.f=i,this.g=n,this.h=a,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.a=new T(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(L.Event.any(L.Event.filter(this.h.onDidFilesChange,o=>o.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&r.isEqual(o.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new E}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=l;class u{constructor(i,n,r,a,o,h,f,O,x,_,ee,se,oe){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=a,this.d=o,this.f=h,this.g=f,this.h=O,this.i=x,this.j=_,this.k=ee,this.l=se,this.m=oe}get value(){return S(this.c)}n(i,n,r){const a=i.inspect(n,r);return{get value(){return S(a.value)},get override(){return S(a.override)},get merged(){return S(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(i,n,r,a,o=new E,h=new E,f=new I.ResourceMap,O=new E,x=new I.ResourceMap){this.c=i,this.d=n,this.f=r,this.g=a,this.h=o,this.i=h,this.j=f,this.l=O,this.m=x,this.a=null,this.b=new I.ResourceMap,this.n=null}getValue(i,n,r){return this.q(i,n,r).getValue(i)}updateValue(i,n,r={}){let a;r.resource?(a=this.m.get(r.resource),a||(a=new E,this.m.set(r.resource,a))):a=this.l,n===void 0?a.removeValue(i):a.setValue(i,n),r.resource||(this.a=null)}inspect(i,n,r){const a=this.q(i,n,r),o=this.u(n.resource,r),h=n.resource?this.m.get(n.resource)||this.l:this.l,f=new Set;for(const O of a.overrides)for(const x of O.identifiers)a.getOverrideValue(i,x)!==void 0&&f.add(x);return new u(i,n,a.getValue(i),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,o||void 0,h)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:a,updated:o,removed:h}=b(this.c,i);n=[...a,...o,...h]}for(const a of n)for(const o of(0,w.overrideIdentifiersFromKey)(a)){const h=this.c.getKeysForOverrideIdentifier(o),f=i.getKeysForOverrideIdentifier(o),O=[...f.filter(x=>h.indexOf(x)===-1),...h.filter(x=>f.indexOf(x)===-1),...h.filter(x=>!P.equals(this.c.override(o).getValue(x),i.override(o).getValue(x)))];r.push([o,O])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:a}=b(this.d,i),o=[...n,...r,...a];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:a,overrides:o}=b(this.applicationConfiguration,i),h=[...n,...r,...a];return h.length&&this.updateApplicationConfiguration(i),{keys:h,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:a,overrides:o}=b(this.localUserConfiguration,i),h=[...n,...r,...a];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:a,overrides:o}=b(this.remoteUserConfiguration,i),h=[...n,...r,...a];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:a,overrides:o}=b(this.workspaceConfiguration,i),h=[...n,...r,...a];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:o}}compareAndUpdateFolderConfiguration(i,n){const r=this.p.get(i),{added:a,updated:o,removed:h,overrides:f}=b(r,n),O=[...a,...o,...h];return(O.length||!r)&&this.updateFolderConfiguration(i,n),{keys:O,overrides:f}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:a,removed:o,overrides:h}=b(n,void 0);return{keys:[...r,...a,...o],overrides:h}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,r){let a=this.r(n,r);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(a=a.merge(this.d)),a}r({resource:i},n){let r=this.s();if(n&&i){const a=n.getFolder(i);a&&(r=this.t(a.uri)||r);const o=this.m.get(i);o&&(r=r.merge(o))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const r=this.s(),a=this.j.get(i);a?(n=r.merge(a),this.b.set(i,n)):n=r}return n}u(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:r,overrides:a,keys:o}=this.j.get(n);return i.push([n,{contents:r,overrides:a,keys:o}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a))),[...n.values()]}static parse(i){const n=this.x(i.defaults),r=this.x(i.policy),a=this.x(i.application),o=this.x(i.user),h=this.x(i.workspace),f=i.folders.reduce((O,x)=>(O.set(c.URI.revive(x[0]),this.x(x[1])),O),new I.ResourceMap);return new m(n,r,a,o,new E,h,f,new E,new I.ResourceMap)}static x(i){return new E(i.contents,i.keys,i.overrides)}}e.Configuration=m;function p(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,n=new Map;for(const a of s)a.keys.forEach(o=>i.add(o)),a.overrides.forEach(([o,h])=>{const f=(0,I.getOrSet)(n,o,new Set);h.forEach(O=>f.add(O))});const r=[];return n.forEach((a,o)=>r.push([o,[...a.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=p;class g{constructor(i,n,r,a){this.change=i,this.f=n,this.g=r,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of i.keys)this.affectedKeys.add(o);for(const[,o]of i.overrides)for(const h of o)this.affectedKeys.add(h);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(i,n){const r=this.a+i,a=this.d.indexOf(r);if(a<0)return!1;const o=a+r.length;if(o>=this.d.length)return!1;const h=this.d.charCodeAt(o);if(h!==this.b&&h!==this.c)return!1;if(n){const f=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,O=this.g.getValue(i,n,this.h);return!P.equals(f,O)}return!0}}e.ConfigurationChangeEvent=g;function b(s,i){const{added:n,removed:r,updated:a}=t(i?.rawConfiguration,s?.rawConfiguration),o=[],h=s?.getAllOverrideIdentifiers()||[],f=i?.getAllOverrideIdentifiers()||[];if(i){const O=f.filter(x=>!h.includes(x));for(const x of O)o.push([x,i.getKeysForOverrideIdentifier(x)])}if(s){const O=h.filter(x=>!f.includes(x));for(const x of O)o.push([x,s.getKeysForOverrideIdentifier(x)])}if(i&&s){for(const O of h)if(f.includes(O)){const x=t({contents:s.getOverrideValue(void 0,O)||{},keys:s.getKeysForOverrideIdentifier(O)},{contents:i.getOverrideValue(void 0,O)||{},keys:i.getKeysForOverrideIdentifier(O)});o.push([O,[...x.added,...x.removed,...x.updated]])}}return{added:n,removed:r,updated:a,overrides:o}}function t(s,i){const n=s?i?s.keys.filter(o=>i.keys.indexOf(o)===-1):[...s.keys]:[],r=i?s?i.keys.filter(o=>s.keys.indexOf(o)===-1):[...i.keys]:[],a=[];if(s&&i){for(const o of i.keys)if(s.keys.indexOf(o)!==-1){const h=(0,k.getConfigurationValue)(i.contents,o),f=(0,k.getConfigurationValue)(s.contents,o);P.equals(h,f)||a.push(o)}}return{added:n,removed:r,updated:a}}}),define(ne[128],re([0,1,19,4,2,30,3,66,42,5,38,37]),function(H,e,N,L,D,R,I,P,d,c,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class v extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:l,defaultsOverrides:u})=>this.c(Array.from(l),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(l,u){this.h(l,w.Registry.as(d.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:l})}f(){return{}}g(){this.b=new P.ConfigurationModel;const l=w.Registry.as(d.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(l),l)}h(l,u){const m=this.f();for(const p of l){const g=m[p],b=u[p];g!==void 0?this.b.addValue(p,g):b?this.b.addValue(p,b.default):this.b.removeValue(p)}}}e.DefaultConfiguration=v;class S{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let E=class extends D.Disposable{get configurationModel(){return this.b}constructor(l,u,m){super(),this.c=l,this.f=u,this.g=m,this.a=this.B(new L.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(l=>this.i(l))),this.B(this.c.onDidChangeConfiguration(async({properties:l})=>this.j(await this.h(l),!0))),this.b}async h(l){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",l);const u={},m=[],p=w.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const g of l){const b=p[g];if(!b){m.push(g);continue}if(b.policy){if(b.type!=="string"&&b.type!=="number"){this.g.warn(`Policy ${b.policy.name} has unsupported type ${b.type}`);continue}m.push(g),u[b.policy.name]={type:b.type}}}return(0,I.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),m}i(l){this.g.trace("PolicyConfiguration#onDidChangePolicies",l);const u=w.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),m=(0,N.coalesce)(l.map(p=>u.get(p)));this.j(m,!0)}j(l,u){this.g.trace("PolicyConfiguration#update",l);const m=w.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),p=[],g=this.b.isEmpty();for(const b of l){const t=m[b]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(g?s!==void 0:!(0,R.equals)(this.b.getValue(b),s))&&p.push([b,s])}else this.b.getValue(b)!==void 0&&p.push([b,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const b=this.b;this.b=new P.ConfigurationModel;for(const t of b.keys)this.b.setValue(t,b.getValue(t));for(const[t,s]of p)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);u&&this.a.fire(this.b)}}};E=de([ie(1,k.IPolicyService),ie(2,c.ILogService)],E),e.PolicyConfiguration=E}),define(ne[129],re([0,1,6,4,2,17,24,66,128,38]),function(H,e,N,L,D,R,I,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class k extends D.Disposable{constructor(v,S,E,T){super(),this.i=v,this.h=this.B(new L.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.DefaultConfiguration),this.c=E instanceof c.NullPolicyService?new d.NullPolicyConfiguration:this.B(new d.PolicyConfiguration(this.b,E,T)),this.f=this.B(new P.UserSettings(this.i,void 0,R.extUriBiasedIgnorePathCase,S)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new N.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:l,properties:u})=>this.k(l,u))),this.B(this.c.onDidChangeConfiguration(l=>this.l(l))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,S,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(v,S,new P.ConfigurationModel,E)}getConfigurationData(){return this.a.toData()}getValue(v,S){const E=typeof v=="string"?v:void 0,T=(0,I.isConfigurationOverrides)(v)?v:(0,I.isConfigurationOverrides)(S)?S:{};return this.a.getValue(E,T,void 0)}updateValue(v,S,E,T){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.j(v)}j(v){const S=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(v);this.m(E,S,2)}k(v,S){const E=this.a.toData(),T=this.a.compareAndUpdateDefaultConfiguration(v,S);this.m(T,E,7)}l(v){const S=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(v);this.m(E,S,7)}m(v,S,E){const T=new P.ConfigurationChangeEvent(v,{data:S},this.a);T.source=E,T.sourceConfig=this.n(E),this.h.fire(T)}n(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=k}),define(ne[67],re([0,1,16]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(c){return c.scheme===N.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=L;function D(c){if(!c)return;const k=c.indexOf("+");return k<0?c:c.substr(0,k)}e.getRemoteName=D;function R(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=R;function I(c){const{host:k,port:w}=d(c);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:k,port:w}}e.parseAuthorityWithPort=I;function P(c,k){let{host:w,port:v}=d(c);return typeof v>"u"&&(v=k),{host:w,port:v}}e.parseAuthorityWithOptionalPort=P;function d(c){const k=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const w=c.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const v=c.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:c,port:void 0}}}),define(ne[32],re([0,1,29,9,67]),function(H,e,N,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(T){if(typeof T=="object"&&T!==null&&T.supported!==!0)return T.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(T){T[T.System=0]="System",T[T.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var P;(function(T){T.WIN32_X64="win32-x64",T.WIN32_IA32="win32-ia32",T.WIN32_ARM64="win32-arm64",T.LINUX_X64="linux-x64",T.LINUX_ARM64="linux-arm64",T.LINUX_ARMHF="linux-armhf",T.ALPINE_X64="alpine-x64",T.ALPINE_ARM64="alpine-arm64",T.DARWIN_X64="darwin-x64",T.DARWIN_ARM64="darwin-arm64",T.WEB="web",T.UNIVERSAL="universal",T.UNKNOWN="unknown",T.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class d{constructor(l){this.value=l,this.c=l.toLowerCase()}static equals(l,u){if(typeof l>"u"||l===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof l=="string"||typeof u=="string"){const m=typeof l=="string"?l:l.value,p=typeof u=="string"?u:u.value;return N.equalsIgnoreCase(m,p)}return l.c===u.c}static toKey(l){return typeof l=="string"?l.toLowerCase():l.c}}e.ExtensionIdentifier=d;class c{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const u of l)this.add(u)}add(l){this.c.add(d.toKey(l))}delete(l){return this.c.delete(d.toKey(l))}has(l){return this.c.has(d.toKey(l))}}e.ExtensionIdentifierSet=c;class k{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete(d.toKey(l))}get(l){return this.c.get(d.toKey(l))}has(l){return this.c.has(d.toKey(l))}set(l,u){this.c.set(d.toKey(l),u)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=k;function w(T){return v(T)}e.isApplicationScopedExtension=w;function v(T){return T.contributes&&T.contributes.localizations?T.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function S(T){return T.contributes&&T.contributes.authentication?T.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function E(T,l){if(l){const u=`onResolveRemoteAuthority:${(0,D.getRemoteName)(l)}`;return!!T.activationEvents?.includes(u)}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[130],re([0,1,2,15,20,32]),function(H,e,N,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class I extends N.Disposable{constructor(d,c){super(),this.b=d,this.a=(0,L.join)(this.b.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this.B(c.onDidInstallExtensions(k=>this.c(k))),this.B(c.onDidUninstallExtension(k=>this.f(k)))}c(d){d.some(c=>!!c.local)&&this.invalidate()}f(d){d.error||this.invalidate()}invalidate(){D.Promises.rm(this.a,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=I}),define(ne[43],re([0,1,14,7,2,99,42,9,5,37]),function(H,e,N,L,D,R,I,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,P.createDecorator)("requestService");class k extends D.Disposable{constructor(g,b){super(),this.b=0,this.a=b.createLogger("request",{name:g?(0,R.localize)(0,null):(0,R.localize)(1,null),when:d.CONTEXT_LOG_LEVEL.isEqualTo((0,d.LogLevelToString)(d.LogLevel.Trace)).serialize()})}async c(g,b,t){const s=`${g} #${++this.b}: ${b.url}`;this.a.trace(`${s} - begin`,b.type,b.headers);try{const i=await t();return this.a.trace(`${s} - end`,b.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${s} - error`,b.type,(0,L.getErrorMessage)(i)),i}}}e.AbstractRequestService=k;function w(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=w;function v(p){return p.res.statusCode===204}async function S(p){return v(p)?null:(await(0,N.streamToBuffer)(p.stream)).toString()}e.asText=S;async function E(p){if(!w(p))throw new Error("Server returned "+p.res.statusCode);return S(p)}e.asTextOrError=E;async function T(p){if(!w(p))throw new Error("Server returned "+p.res.statusCode);if(v(p))return null;const b=(await(0,N.streamToBuffer)(p.stream)).toString();try{return JSON.parse(b)}catch(t){throw t.message+=`:
`+b,t}}e.asJson=T;function l(p){m(p)}e.updateProxyConfigurationsScope=l;let u;function m(p){const g=c.Registry.as(I.Extensions.Configuration),b=u;u={id:"http",order:15,title:(0,R.localize)(2,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0}}},g.updateConfigurations({add:[u],remove:b?[b]:[]})}m(2)}),define(ne[131],re([0,1,23,16,13,43]),function(H,e,N,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let I=class{constructor(d,c){this.a=d,this.b=c}async download(d,c,k=N.CancellationToken.None){if(d.scheme===L.Schemas.file||d.scheme===L.Schemas.vscodeRemote){await this.b.copy(d,c);return}const w={type:"GET",url:d.toString(!0)},v=await this.a.request(w,k);if(v.res.statusCode===200)await this.b.writeFile(c,v.stream);else{const S=await(0,R.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${S}`)}}};I=de([ie(0,R.IRequestService),ie(1,D.IFileService)],I),e.DownloadService=I}),define(ne[132],re([0,1,133,3]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(I,P){return I.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:I.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function R(I,P,d={}){const c=(0,N.parse)(I),k=d.proxyUrl||D(c,P);if(!k)return null;const w=(0,N.parse)(k);if(!/^https?:$/.test(w.protocol||""))return null;const v={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,L.isBoolean)(d.strictSSL)?d.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((S,E)=>{H(["http-proxy-agent"],S,E)}))(v):new(await new Promise((S,E)=>{H(["https-proxy-agent"],S,E)}))(v)}e.getProxyAgent=R}),define(ne[134],re([0,1,58,15,100,23,34,7,12,28,82,166,6,71]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let E;async function T(u,m,p,g){return p["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(g)&&!p["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(g)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=v.Promises.withAsyncBody(async(b,t)=>{const s=new R.CancellationTokenSource;let i=1e4;const n=u.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,S.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),t(new Error((0,D.localize)(0,null)))},i);try{b(await l(m,s.token))}catch(a){!(0,P.isCancellationError)(a)&&!s.token.isCancellationRequested?t(new Error((0,D.localize)(1,null,(0,I.toErrorMessage)(a)))):b({})}finally{clearTimeout(r),s.dispose()}})),E)}e.getResolvedShellEnv=T;async function l(u,m){const p=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",p);const g=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",g);const b=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(b+"({.*})"+b),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",s);const i=await(0,k.getSystemShell)(d.OS,s);return u.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(m.isCancellationRequested)return r(new P.CancellationError);const a=(0,L.basename)(i);let o,h;const f=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(o=`& '${process.execPath}' ${f} -p '''${b}'' + JSON.stringify(process.env) + ''${b}'''`,h=["-Login","-Command"]):(o=`'${process.execPath}' ${f} -p '"${b}" + JSON.stringify(process.env) + "${b}"'`,a==="tcsh"||a==="csh"?h=["-ic"]:h=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),o);const O=(0,N.spawn)(i,[...h,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});m.onCancellationRequested(()=>(O.kill(),r(new P.CancellationError))),O.on("error",ee=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,I.toErrorMessage)(ee)),r(ee)});const x=[];O.stdout.on("data",ee=>x.push(ee));const _=[];O.stderr.on("data",ee=>_.push(ee)),O.on("close",(ee,se)=>{const oe=Buffer.concat(x).toString("utf8");u.trace("getUnixShellEnvironment#raw",oe);const ae=Buffer.concat(_).toString("utf8");if(ae.trim()&&u.trace("getUnixShellEnvironment#stderr",ae),ee||se)return r(new Error((0,D.localize)(2,null,ee,se)));const Y=t.exec(oe),y=Y?Y[1]:"{}";try{const M=JSON.parse(y);p?M.ELECTRON_RUN_AS_NODE=p:delete M.ELECTRON_RUN_AS_NODE,g?M.ELECTRON_NO_ATTACH_CONSOLE=g:delete M.ELECTRON_NO_ATTACH_CONSOLE,delete M.VSCODE_RESOLVING_ENVIRONMENT,delete M.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",M),n(M)}catch(M){u.error("getUnixShellEnvironment#errorCaught",(0,I.toErrorMessage)(M)),r(M)}})})}}),define(ne[135],re([0,1,9]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,N.createDecorator)("stateReadService"),e.IStateService=(0,N.createDecorator)("stateService")}),define(ne[68],re([0,1,6,14,3,18,13,5]),function(H,e,N,L,D,R,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var d;(function(v){v[v.IMMEDIATE=0]="IMMEDIATE",v[v.DELAYED=1]="DELAYED"})(d=e.SaveStrategy||(e.SaveStrategy={}));class c{constructor(S,E,T,l){this.f=S,this.g=T,this.h=l,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=E===0?void 0:new N.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(S){S.fileOperationResult!==1&&this.g.error(S)}}getItem(S,E){const T=this.a[S];return(0,D.isUndefinedOrNull)(T)?E:T}setItem(S,E){this.setItems([{key:S,data:E}])}setItems(S){let E=!1;for(const{key:T,data:l}of S)this.a[T]!==l&&((0,D.isUndefinedOrNull)(l)?(0,D.isUndefined)(this.a[T])||(this.a[T]=void 0,E=!0):(this.a[T]=l,E=!0));E&&this.j()}removeItem(S){(0,D.isUndefined)(this.a[S])||(this.a[S]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const S=JSON.stringify(this.a,null,4);if(S!==this.b)try{await this.h.writeFile(this.f,L.VSBuffer.fromString(S)),this.b=S}catch(E){this.g.error(E)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=c;let k=class{constructor(S,E,T,l){this.a=new c(E.stateResource,S,T,l)}async init(){await this.a.init()}getItem(S,E){return this.a.getItem(S,E)}};k=de([ie(1,R.IEnvironmentService),ie(2,P.ILogService),ie(3,I.IFileService)],k),e.StateReadonlyService=k;class w extends k{setItem(S,E){this.a.setItem(S,E)}setItems(S){this.a.setItems(S)}removeItem(S){this.a.removeItem(S)}close(){return this.a.close()}}e.StateService=w}),define(ne[69],re([0,1,12,35,11,28]),function(H,e,N,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(c){if(N.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function P(c,k,w,v,S,E,T,l,u,m){const p=Object.create(null);p["common.machineId"]=T,p.sessionID=(0,R.generateUuid)()+Date.now(),p.commitHash=S,p.version=E,p["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,N.PlatformToString)(N.platform),p["common.nodePlatform"]=L.platform,p["common.nodeArch"]=v,p["common.product"]=m||"desktop",l&&(p["common.msftInternal"]=l);let g=0;const b=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),N.isLinuxSnap&&(p["common.snap"]="true");const t=I(w);t&&(p["common.platformDetail"]=t);try{const s=await c.readFile(D.URI.file(u));p["common.source"]=s.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=P;function d(c){const k=L.env.USERDNSDOMAIN;if(!k)return!1;const w=k.toLowerCase();return c.some(v=>w===v)}e.verifyMicrosoftInternalDomain=d}),define(ne[25],re([0,1,9]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,N.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,N.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[39],re([0,1,30,3,4,24,67,69,25]),function(H,e,N,L,D,R,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(o){this.value=o}}e.TelemetryTrustedValue=c;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,h){return Promise.resolve(void 0)}publicLog2(o,h){return this.publicLog(o,h)}publicLogError(o,h){return Promise.resolve(void 0)}publicLogError2(o,h){return this.publicLogError(o,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class w{async publicLog(o,h,f){}async publicLogError(o,h,f){}}e.NullEndpointTelemetryService=w,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(a,o){return D.Event.debounce(o.onDidChangeConfiguration,(f,O)=>{const x=f?new Set([...f.affectedKeys,...O.affectedKeys]):O.affectedKeys;return{...O,affectedKeys:x}},1e3,!0)(f=>{f.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(f.source),configurationKeys:g(f.affectedKeys)})})}e.configurationTelemetry=v;function S(a,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!a.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=S;function E(a,o){return!(o.isBuilt||o.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=E;function T(a){const o=a.getValue(d.TELEMETRY_SETTING_ID),h=a.getValue(d.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(d.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=T;function l(a){const o={},h={},f={};p(a,f);for(let O in f){O=O.length>150?O.substr(O.length-149):O;const x=f[O];typeof x=="number"?h[O]=x:typeof x=="boolean"?h[O]=x?1:0:typeof x=="string"?(x.length>8192&&console.warn(`Telemetry property: ${O} has been trimmed to 8192, the original length is ${x.length}`),o[O]=x.substring(0,8191)):typeof x<"u"&&x!==null&&(o[O]=x)}return{properties:o,measurements:h}}e.validateTelemetryData=l;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(a){if(!a)return"none";const o=(0,I.getRemoteName)(a);return u.has(o)?o:"other"}e.cleanRemoteAuthority=m;function p(a,o,h=0,f){if(!!a)for(const O of Object.getOwnPropertyNames(a)){const x=a[O],_=f?f+O:O;Array.isArray(x)?o[_]=(0,N.safeStringify)(x):x instanceof Date?o[_]=x.toISOString():(0,L.isObject)(x)?h<2?p(x,o,h+1,_+"."):o[_]=(0,N.safeStringify)(x):o[_]=x}}function g(a){if(!a)return[];const o=[];return b(o,"",a),o}function b(a,o,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(f=>b(a,o?`${o}.${f}`:f,h[f])):a.push(o)}function t(a,o){const h=a.msftInternalDomains||[],f=o.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(h)||f}e.isInternalTelemetry=t;function s(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=s;function i(a,o){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let h=a;const f=[];for(const ee of o)for(;;){const se=ee.exec(a);if(!se)break;f.push([se.index,ee.lastIndex])}const O=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,x=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let _=0;for(h="";;){const ee=x.exec(a);if(!ee)break;const se=f.some(([oe,ae])=>ee.index<ae&&oe<x.lastIndex);!O.test(ee[0])&&!se&&(h+=a.substring(_,ee.index)+"<REDACTED: user-file-path>",_=x.lastIndex)}return _<a.length&&(h+=a.substr(_)),h}function n(a){if(!a)return a;const o=a.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of h)if(f.regex.test(o))return`<REDACTED: ${f.label}>`;return a}function r(a,o){return(0,N.cloneAndChange)(a,h=>{if(h instanceof c)return h.value;if(typeof h=="string"){let f=h.replaceAll("%20"," ");f=i(f,o);for(const O of o)f=f.replace(O,"");return f=n(f),f}})}e.cleanData=r}),define(ne[26],re([0,1,29,21,32,12,11,7,35,39]),function(H,e,N,L,D,R,I,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,N.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=k;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(n){const r=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new v(n.identifier,r,a)}static parse(n){const r=w.exec(n);return r&&r[1]&&r[2]?new v({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,a="undefined"){this.version=r,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof v?k(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=v;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(i){const n=S.exec(i);return n&&n[1]?[l(n[1]),n[2]]:[l(i),void 0]}e.getIdAndVersion=E;function T(i,n){return`${i}.${n}`}e.getExtensionId=T;function l(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=l;function u(i,n){return l(T(i,n))}e.getGalleryExtensionId=u;function m(i,n){const r=[],a=o=>{for(const h of r)if(h.some(f=>k(n(f),n(o))))return h;return null};for(const o of i){const h=a(o);h?h.push(o):r.push([o])}return r}e.groupByExtension=m;function p(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function g(i){return{id:new c.TelemetryTrustedValue(i.identifier.id),name:new c.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function b(i,n){const r=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const o=a.shift();if(o&&r.every(h=>!k(h.identifier,{id:o}))){const h=i.filter(f=>k(f.identifier,{id:o}));h.length===1&&(r.push(h[0]),a.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=b;async function t(i,n){if(!R.isLinux)return!1;let r;try{r=(await i.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){n.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(o))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(i,n){const r=await t(i,n),a=(0,L.getTargetPlatform)(r?"alpine":R.platform,d.arch);return n.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=s}),define(ne[136],re([0,1,23,7,16,17,41,11,89,21,26,32]),function(H,e,N,L,D,R,I,P,d,c,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const v=l=>(0,d.localize)(0,null,l),S=(0,d.localize)(1,null,"ms-dotnettools.csharp");function E(l,u){return u?`${l.publisher}.${l.name}@${l.version}`:`${l.publisher}.${l.name}`}let T=class{constructor(u,m){this.a=u,this.b=m}get d(){}async listExtensions(u,m,p,g=console){let b=await this.a.getInstalled(1,p);const t=w.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(m&&m!==""){if(t.indexOf(m.toLowerCase())<0){g.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}b=b.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(m.toLowerCase())>-1:!1)}else if(m===""){g.log("Possible Categories: "),t.forEach(i=>{g.log(i)});return}this.d&&g.log((0,d.localize)(2,null,this.d)),b=b.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let s;for(const i of b)s!==i.identifier.id&&(s=i.identifier.id,g.log(E(i.manifest,u)))}async installExtensions(u,m,p,g,b=console){const t=[],s=[];u.length&&b.log(this.d?(0,d.localize)(3,null,this.d):(0,d.localize)(4,null));const i=await this.a.getInstalled(1,p.profileLocation),n=(h,f)=>{const O=i.find(x=>(0,k.areSameExtensions)(x.identifier,{id:h}));if(O){if(!g&&(!f||f==="prerelease"&&O.preRelease))return b.log((0,d.localize)(5,null,h,O.manifest.version,h)),!1;if(f&&O.manifest.version===f)return b.log((0,d.localize)(6,null,`${h}@${f}`)),!1}return!0},r=(h,f,O)=>{o.push({id:h,version:f!=="prerelease"?f:void 0,installOptions:{...p,isBuiltin:O,installPreReleaseVersion:f==="prerelease"||p.installPreReleaseVersion}})},a=[],o=[];for(const h of u)if(h instanceof P.URI)a.push(h);else{const[f,O]=(0,k.getIdAndVersion)(h);n(f,O)&&r(f,O,!1)}for(const h of m){const[f,O]=(0,k.getIdAndVersion)(h);n(f,O)&&r(f,O,!0)}if(a.length&&await Promise.all(a.map(async h=>{try{const f=await this.f(h,{...p,isBuiltin:!1},g,b);f&&s.push(f)}catch(f){b.error(f.message||f.stack||f),t.push(h.toString())}})),o.length){const h=await this.g(o);await Promise.all(o.map(async f=>{const O=h.get(f.id.toLowerCase());if(O)try{const x=await this.h(f,O,i,g,b);x&&s.push(x)}catch(x){b.error(x.message||x.stack||x),t.push(f.id)}else b.error(`${v(f.version?`${f.id}@${f.version}`:f.id)}
${S}`),t.push(f.id)}))}if(t.length)throw new Error((0,d.localize)(7,null,t.join(", ")))}async f(u,m,p,g){const b=await this.a.getManifest(u);if(!b)throw new Error("Invalid vsix");if(await this.k(b,p,m.profileLocation,g))try{return await this.a.install(u,m),g.log((0,d.localize)(8,null,(0,R.basename)(u))),b}catch(s){if((0,L.isCancellationError)(s))return g.log((0,d.localize)(9,null,(0,R.basename)(u))),null;throw s}return null}async g(u){const m=new Map,p=u.some(b=>b.installOptions.installPreReleaseVersion),g=await this.b.getExtensions(u.map(b=>({...b,preRelease:p})),N.CancellationToken.None);for(const b of g)m.set(b.identifier.id.toLowerCase(),b);return m}async h({id:u,version:m,installOptions:p},g,b,t,s){const i=await this.b.getManifest(g,N.CancellationToken.None);if(i&&!this.j(i,s))return null;const n=b.find(r=>(0,k.areSameExtensions)(r.identifier,g.identifier));if(n){if(g.version===n.manifest.version)return s.log((0,d.localize)(10,null,m?`${u}@${m}`:u)),null;s.log((0,d.localize)(11,null,u,g.version))}try{p.isBuiltin?s.log(m?(0,d.localize)(12,null,u,m):(0,d.localize)(13,null,u)):s.log(m?(0,d.localize)(14,null,u,m):(0,d.localize)(15,null,u));const r=await this.a.installFromGallery(g,{...p,installGivenVersion:!!m});return s.log((0,d.localize)(16,null,u,r.manifest.version)),i}catch(r){if((0,L.isCancellationError)(r))return s.log((0,d.localize)(17,null,u)),null;throw r}}j(u,m){return!0}async k(u,m,p,g){const b={id:(0,k.getGalleryExtensionId)(u.publisher,u.name)},s=(await this.a.getInstalled(1,p)).find(i=>(0,k.areSameExtensions)(b,i.identifier)&&(0,I.gt)(i.manifest.version,u.version));return s&&!m?(g.log((0,d.localize)(18,null,s.identifier.id,s.manifest.version,u.version)),!1):this.j(u,g)}async uninstallExtensions(u,m,p,g=console){const b=async s=>{if(s instanceof P.URI){const i=await this.a.getManifest(s);return E(i)}return s},t=[];for(const s of u){const i=await b(s),r=(await this.a.getInstalled(void 0,p)).filter(a=>(0,k.areSameExtensions)(a.identifier,{id:i}));if(!r.length)throw new Error(`${this.l(i)}
${S}`);if(r.some(a=>a.type===0)){g.log((0,d.localize)(19,null,i));return}if(!m&&r.some(a=>a.isBuiltin)){g.log((0,d.localize)(20,null,i));return}g.log((0,d.localize)(21,null,i));for(const a of r)await this.a.uninstall(a,{profileLocation:p}),t.push(a);this.d?g.log((0,d.localize)(22,null,i,this.d)):g.log((0,d.localize)(23,null,i))}}async locateExtension(u,m=console){const p=await this.a.getInstalled();u.forEach(g=>{p.forEach(b=>{if(b.identifier.id===g&&b.location.scheme===D.Schemas.file){m.log(b.location.fsPath);return}})})}l(u){return this.d?(0,d.localize)(24,null,u,this.d):(0,d.localize)(25,null,u)}};T=de([ie(0,c.IExtensionManagementService),ie(1,c.IExtensionGalleryService)],T),e.ExtensionManagementCLI=T}),define(ne[137],re([0,1,4,2,36,26,32]),function(H,e,N,L,D,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends L.Disposable{constructor(c,k,w,v,S,E,T){super(),this.f=c,this.g=k,this.h=w,this.i=v,this.j=S,this.k=E,this.l=T,this.a=this.B(new N.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.DisposableMap),this.m().then(null,l=>T.error(l))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(c=>this.p(c.added,c.removed))),this.B(this.i.onAddExtensions(c=>this.r(c))),this.B(this.i.onDidAddExtensions(c=>this.s(c))),this.B(this.i.onRemoveExtensions(c=>this.t(c))),this.B(this.i.onDidRemoveExtensions(c=>this.u(c))),this.B(this.k.onDidFilesChange(c=>this.v(c)))}async p(c,k){try{await Promise.all(k.map(w=>(this.c.deleteAndDispose(w.id),this.z(w.extensionsResource)))),c.length&&await Promise.all(c.map(w=>(this.c.set(w.id,(0,L.combinedDisposable)(this.k.watch(this.j.extUri.dirname(w.extensionsResource)),this.k.watch(w.extensionsResource))),this.y(w.extensionsResource))))}catch(w){throw this.l.error(w),w}}async r(c){for(const k of c.extensions)this.D(this.G(k.identifier,k.version),c.profileLocation)}async s(c){for(const k of c.extensions){const w=this.G(k.identifier,k.version);c.error?this.F(w,c.profileLocation):this.D(w,c.profileLocation)}}async t(c){for(const k of c.extensions)this.F(this.G(k.identifier,k.version),c.profileLocation)}async u(c){const k=[],w=[];for(const v of c.extensions){const S=this.G(v.identifier,v.version);c.error?this.D(S,c.profileLocation):(this.F(S,c.profileLocation),this.b.has(S)||(this.l.debug("Extension is removed from all profiles",v.identifier.id,v.version),w.push(this.f.scanInstalledExtensionAtLocation(v.location).then(E=>{E?k.push(E):this.l.info("Extension not found at the location",v.location.toString())},E=>this.l.error(E)))))}try{await Promise.all(w),k.length&&await this.C(k)}catch(v){this.l.error(v)}}v(c){for(const k of this.h.profiles)c.contains(k.extensionsResource,0,1)&&this.w(k.extensionsResource)}async w(c){const k=[],w=[],v=await this.i.scanProfileExtensions(c),S=new Set,E=new Set;for(const[T,l]of this.b)l.has(c)&&E.add(T);for(const T of v){const l=this.G(T.identifier,T.version);S.add(l),E.has(l)||(k.push(T.identifier),this.D(l,c))}for(const T of E)if(!S.has(T)){const l=this.H(T);l&&(w.push(l.identifier),this.F(T,c))}(k.length||w.length)&&this.a.fire({added:k.length?{extensions:k,profileLocation:c}:void 0,removed:w.length?{extensions:w,profileLocation:c}:void 0})}async y(c){const k=await this.i.scanProfileExtensions(c);for(const w of k)this.D(this.G(w.identifier,w.version),c)}async z(c){for(const k of[...this.b.keys()])this.F(k,c);await this.C()}async C(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(w=>!this.b.has(this.G(w.identifier,w.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}D(c,k){let w=this.b.get(c);w||this.b.set(c,w=new D.ResourceSet(v=>this.j.extUri.getComparisonKey(v))),w.add(k)}F(c,k){const w=this.b.get(c);w&&w.delete(k),w?.size||this.b.delete(c)}G(c,k){return`${I.ExtensionIdentifier.toKey(c.id)}@${k}`}H(c){const[k,w]=(0,R.getIdAndVersion)(c);return w?{identifier:{id:k},version:w}:void 0}}e.ExtensionsWatcher=P}),define(ne[138],re([0,1,109,39]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(R,I,P,d,c,k,w){const v={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${I.nameShort})`};if((0,L.supportsTelemetry)(I,P)&&(0,L.getTelemetryLevel)(d)===3){const S=await(0,N.getServiceMachineId)(P,c,k),{machineId:E}=await w.getTelemetryInfo();v["X-Market-User-Id"]=S,v["VSCode-SessionId"]=E||S}return v}e.resolveMarketplaceHeaders=D}),define(ne[139],re([0,1,167,19,6,2,16,15,20,18,21,26,5,64,11]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let T=class extends S.LanguagePackBaseService{constructor(p,g,b,t){super(b),this.h=p,this.i=t,this.g=this.B(new l(g,t)),this.h.registerParticipant({postInstall:async s=>this.j(s),postUninstall:async s=>this.k(s)})}async getBuiltInExtensionTranslationsUri(p,g){const t=(await this.g.getLanguagePacks())[g];if(!t){this.i.warn(`No language pack found for ${g}`);return}const s=t.translations[p];return s?E.URI.file(s):void 0}async getInstalledLanguages(){const p=await this.g.getLanguagePacks(),g=Object.keys(p).map(b=>{const t=p[b];return{...this.f(b,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort((b,t)=>b.label.localeCompare(t.label)),g}async j(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",p.identifier.id),await this.update())}async k(p){const g=await this.g.getLanguagePacks();Object.keys(g).some(b=>g[b]&&g[b].extensions.some(t=>(0,w.areSameExtensions)(t.extensionIdentifier,p.identifier)))&&(this.i.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),b=await this.g.update(g);return!(0,L.equals)(Object.keys(p),Object.keys(b))}};T=de([ie(0,k.IExtensionManagementService),ie(1,c.INativeEnvironmentService),ie(2,k.IExtensionGalleryService),ie(3,v.ILogService)],T),e.NativeLanguagePackService=T;let l=class extends R.Disposable{constructor(p,g){super(),this.i=g,this.c={},this.f=(0,P.join)(p.userDataPath,"languagepacks.json"),this.g=new D.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(p){return this.m(g=>{Object.keys(g).forEach(b=>delete g[b]),this.j(g,...p)}).then(()=>this.c)}j(p,...g){for(const b of g)b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&this.k(p,b);Object.keys(p).forEach(b=>this.l(p[b]))}k(p,g){const b=g.identifier,t=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const s of t)if(g.location.scheme===I.Schemas.file&&u(s)){let i=p[s.languageId];i||(i={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},p[s.languageId]=i);const n=i.extensions.filter(r=>(0,w.areSameExtensions)(r.extensionIdentifier,b))[0];n?n.version=g.manifest.version:i.extensions.push({extensionIdentifier:b,version:g.manifest.version});for(const r of s.translations)i.translations[r.id]=(0,P.join)(g.location.fsPath,r.path)}}l(p){if(p){const g=(0,N.createHash)("md5");for(const b of p.extensions)g.update(b.extensionIdentifier.uuid||b.extensionIdentifier.id).update(b.version);p.hash=g.digest("hex")}}m(p=()=>null){return this.g.queue(()=>{let g=null;return d.Promises.readFile(this.f,"utf8").then(void 0,b=>b.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(b)).then(b=>{try{return JSON.parse(b)}catch{return{}}}).then(b=>(g=p(b),b)).then(b=>{for(const s of Object.keys(b))b[s]||delete b[s];this.c=b,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),d.Promises.writeFile(this.f,t)}).then(()=>g,b=>this.i.error(b))})}};l=de([ie(0,c.INativeEnvironmentService),ie(1,v.ILogService)],l);function u(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const p of m.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(ne[140],re([0,1,7,30,39]),function(H,e,N,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function P(c,k,w){const v=await new Promise((u,m)=>{H(["@microsoft/1ds-core-js"],u,m)}),S=await new Promise((u,m)=>{H(["@microsoft/1ds-post-js"],u,m)}),E=new v.AppInsightsCore,T=new S.PostChannel,l={instrumentationKey:c,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[T]]};if(w){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:w};l.extensionConfig[T.identifier]=u}return E.initialize(l,[]),E.addTelemetryInitializer(u=>{k&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),E}class d{constructor(k,w,v,S,E){this.e=k,this.f=w,this.g=v,this.h=E,this.c=R,this.d=I,this.g||(this.g={}),typeof S=="function"?this.a=S():this.a=S,this.b=null}i(k){if(!!this.a){if(typeof this.a!="string"){k(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(w=>{k(w)},w=>{(0,N.onUnexpectedError)(w),console.error(w)})}}log(k,w){if(!this.a)return;w=(0,L.mixin)(w,this.g),w=(0,D.validateTelemetryData)(w);const v=this.f+"/"+k;try{this.i(S=>{S.pluginVersionString=w?.properties.version??"Unknown",S.track({name:v,baseData:{name:v,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(k=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,k(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=d}),define(ne[141],re([0,1,2,30,12,29,101,24,42,142,31,37,25,39]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(u,m,p){this.k=m,this.l=p,this.d={},this.i=new N.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,R.escapeRegExpCharacters)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.escapeRegExpCharacters)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(v.TELEMETRY_SETTING_ID)||g.affectsConfiguration(v.TELEMETRY_OLD_SETTING_ID)||g.affectsConfiguration(v.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,m){this.d[u]=m}m(){let u=(0,S.getTelemetryLevel)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const p=m.usage?3:m.error?2:0;u=Math.min(u,p)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,m=u.sessionID,p=u["common.machineId"],g=u["common.firstSessionDate"],b=u["common.msftInternal"];return{sessionId:m,machineId:p,firstSessionDate:g,msftInternal:b}}dispose(){this.i.dispose()}n(u,m,p){return this.g<m?Promise.resolve(void 0):this.c.then(g=>{p=(0,L.mixin)(p,this.d),p=(0,S.cleanData)(p,this.j),p=(0,L.mixin)(p,g),this.b.forEach(b=>b.log(u,p))},g=>{console.error(g)})}publicLog(u,m){return this.n(u,3,m)}publicLog2(u,m){return this.publicLog(u,m)}publicLogError(u,m){return this.h?this.n(u,2,m):Promise.resolve(void 0)}publicLogError2(u,m){return this.publicLogError(u,m)}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=de([ie(1,P.IConfigurationService),ie(2,k.IProductService)],E),e.TelemetryService=E;function T(){const l=(0,I.localize)(0,null,c.default.nameLong),u=c.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=D.isWeb?"":(0,I.localize)(3,null),p=(0,I.localize)(4,null),g=(0,I.localize)(5,null),b=(0,I.localize)(6,null),t=(0,I.localize)(7,null),s=`
|       | ${p} | ${g} | ${b} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,I.localize)(8,null);return`
${l} ${u} ${m}

&nbsp;

${t}
${s}

&nbsp;

${i}
`}w.Registry.as(d.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:T(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(d.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,I.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,I.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[143],re([0,1,168,140]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends L.AbstractOneDataSystemAppender{constructor(I,P,d,c){const k={sendPOST:(w,v)=>{const S={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const E=N.request(w.urlString,S,T=>{T.on("data",function(l){v(T.statusCode??200,T.headers,l.toString())}),T.on("error",function(l){v(0,{})})});E.write(w.data),E.end()}catch{v(0,{})}}};super(I,P,d,c,k)}}e.OneDataSystemAppender=D}),define(ne[144],re([0,1,15,20]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function D(R,I){const P=Object.create(null),d=(k,w)=>{const v=JSON.parse(k);P[w]=v};if(I){const k=[],w=await L.Promises.readdir(I);for(const S of w)try{(await L.Promises.stat((0,N.join)(I,S))).isDirectory()&&k.push(S)}catch{}const v=[];for(const S of k)(await L.Promises.readdir((0,N.join)(I,S))).filter(T=>T==="telemetry.json").length===1&&v.push(S);for(const S of v){const E=(await L.Promises.readFile((0,N.join)(I,S,"telemetry.json"))).toString();d(E,S)}}let c=(await L.Promises.readFile((0,N.join)(R,"telemetry-core.json"))).toString();return d(c,"vscode-core"),c=(await L.Promises.readFile((0,N.join)(R,"telemetry-extensions.json"))).toString(),d(c,"vscode-extensions"),JSON.stringify(P,null,4)}e.buildTelemetryMessage=D}),define(ne[145],re([0,1,12,80,25]),function(H,e,N,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function R(I){let P=I.getItem(D.machineIdKey);return(typeof P!="string"||N.isMacintosh&&P==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(P=await(0,L.getMachineId)()),P}e.resolveMachineId=R}),define(ne[27],re([0,1,9]),function(H,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,N.createDecorator)("IUriIdentityService")}),define(ne[146],re([0,1,27,110,13,17,72,4,2]),function(H,e,N,L,D,R,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(v){this.uri=v,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let k=class{constructor(v){this.g=v,this.c=new d.DisposableStore,this.f=2**16;const S=new Map,E=T=>{let l=S.get(T.scheme);return l===void 0&&(l=v.hasProvider(T)&&!this.g.hasCapability(T,1024),S.set(T.scheme,l)),l};this.c.add(P.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(T=>{S.delete(T.scheme)})),this.extUri=new R.ExtUri(E),this.d=new I.SkipList((T,l)=>this.extUri.compare(T,l,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,R.normalizePath)(v));const S=this.d.get(v);return S?S.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new c(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((E,T)=>E[1].time<T[1].time?1:E[1].time>T[1].time?-1:0);c._clock=0,this.d.clear();const S=this.f*.5;for(let E=0;E<S;E++)this.d.set(v[E][0],v[E][1].touch())}};k=de([ie(0,D.IFileService)],k),e.UriIdentityService=k,(0,L.registerSingleton)(N.IUriIdentityService,k,1)}),define(ne[147],re([0,1,103,15,55,17,11,9,16]),function(H,e,N,L,D,R,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function c(n){const r=n;return typeof r?.id=="string"&&I.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=c;function k(n){return typeof n?.id=="string"&&!c(n)&&!v(n)}e.isEmptyWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,L.basename)(n)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=n;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.toWorkspaceIdentifier=w;function v(n){const r=n;return typeof r?.id=="string"&&I.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=v;function S(n){const r=n;if(r?.uri)return{id:r.id,uri:I.URI.revive(r.uri)};const a=n;if(a?.configPath)return{id:a.id,configPath:I.URI.revive(a.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=S;var E;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function T(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=T;function l(n){const r=n;return!!(r&&typeof r=="object"&&I.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=l;class u{constructor(r,a,o,h,f){this.h=r,this.j=o,this.k=h,this.l=f,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class m{constructor(r,a){this.raw=a,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,R.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function p(n){return new m({uri:n,index:0,name:(0,R.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,N.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(n,r){return R.extUriBiasedIgnorePathCase.isEqualOrParent(n,r.untitledWorkspacesHome)}e.isUntitledWorkspace=g;function b(n){let r;return I.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=b,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function s(n,r){return!g(n,r)&&!b(n)}e.isSavedWorkspace=s;function i(n){return(typeof n=="string"?(0,L.extname)(n):(0,R.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ne[22],re([0,1,52,4,2,17,11,102,18,13,9,5,147,36,27,6,28,29,3]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S,E,T,l,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&I.URI.isUri(n.location)&&I.URI.isUri(n.globalStorageHome)&&I.URI.isUri(n.settingsResource)&&I.URI.isUri(n.keybindingsResource)&&I.URI.isUri(n.tasksResource)&&I.URI.isUri(n.snippetsHome)&&I.URI.isUri(n.extensionsResource))}e.isUserDataProfile=p,e.IUserDataProfilesService=(0,k.createDecorator)("IUserDataProfilesService");function g(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:I.URI.revive(i.location).with({scheme:n}),globalStorageHome:I.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:I.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:I.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:I.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:I.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:I.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=g;function b(i,n,r,a){return{id:i,name:n,location:r,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,R.joinPath)(r,"globalStorage"),settingsResource:(0,R.joinPath)(r,"settings.json"),keybindingsResource:(0,R.joinPath)(r,"keybindings.json"),tasksResource:(0,R.joinPath)(r,"tasks.json"),snippetsHome:(0,R.joinPath)(r,"snippets"),extensionsResource:(0,R.joinPath)(r,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=b;let t=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,a,o){super(),this.m=n,this.n=r,this.r=a,this.s=o,this.f=!0,this.g=this.B(new L.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new L.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new L.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new L.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new S.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)try{for(const h of this.I()){if(!h.name||!(0,m.isString)(h.name)||!h.location){this.s.warn("Skipping the invalid stored profile",h.location||h.name);continue}n.push(b((0,R.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}}catch(h){this.s.error(h)}const r=new S.ResourceMap,a=new Map,o=this.v();if(n.unshift({...o,extensionsResource:this.N()??o.extensionsResource,isDefault:!0}),n.length)try{const h=this.L();if(h.workspaces)for(const[f,O]of Object.entries(h.workspaces)){const x=I.URI.parse(f),_=n.find(ee=>ee.id===O);_&&r.set(x,_)}if(h.emptyWindows)for(const[f,O]of Object.entries(h.emptyWindows)){const x=n.find(_=>_.id===O);x&&a.set(f,x)}}catch(h){this.s.error(h)}this.t={profiles:n,workspaces:r,emptyWindows:a}}return this.t}v(){return b("__default__profile__",(0,P.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(n){const r="Temp",a=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let o=0;for(const f of this.profiles){const O=a.exec(f.name),x=O?parseInt(O[1]):0;o=x>o?x:o}const h=`${r} ${o+1}`;return this.createProfile((0,N.hash)((0,l.generateUuid)()).toString(16),h,{transient:!0},n)}async createNamedProfile(n,r,a){return this.createProfile((0,N.hash)((0,l.generateUuid)()).toString(16),n,r,a)}async createProfile(n,r,a,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.w(n,r,a);return o&&await this.setProfileForWorkspace(o,h),h}async w(n,r,a){if(!(0,m.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.k.get(r);return o||(o=(async()=>{try{const h=this.profiles.find(x=>x.name===r||x.id===n);if(h)return h;const f=b(n,r,(0,R.joinPath)(this.profilesHome,n),a);await this.n.createFolder(f.location);const O=[];return this.h.fire({profile:f,join(x){O.push(x)}}),await T.Promises.settled(O),this.C([f],[],[]),f}finally{this.k.delete(r)}})(),this.k.set(r,o)),o}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(o=>o.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=b(a.id,r.name??a.name,a.location,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags}),this.C([],[],[a]),a}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(o=>o.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const a=[];this.i.fire({profile:r,join(o){a.push(o)}});try{await Promise.allSettled(a)}catch(o){this.s.error(o)}for(const o of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(o)?.id&&this.u.emptyWindows.delete(o);for(const o of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(o)?.id&&this.u.workspaces.delete(o);this.G(),this.C([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(o){this.s.error(o)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(o=>o.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.F(n,a)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.r.extUri.isEqual(a.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.z(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.y(n);return I.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}y(n){return(0,v.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,v.isWorkspaceIdentifier)(n)?n.configPath:n.id}z(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}C(n,r,a){const o=[...this.profiles,...n],h=[];this.l.profiles=[];for(let f of o)f.isDefault||r.some(O=>f.id===O.id)||(f=a.find(O=>f.id===O.id)??f,f.isTransient?this.l.profiles.push(f):h.push({location:f.location,name:f.name,shortName:f.shortName,useDefaultFlags:f.useDefaultFlags}));this.J(h),this.t=void 0,this.D(n,r,a)}D(n,r,a){this.g.fire({added:n,removed:r,updated:a,all:this.profiles})}F(n,r,a){a=r?.isTransient?!0:a,a||this.F(n,void 0,!0);const o=this.y(n),h=a?this.l:this.u;I.URI.isUri(o)?(h.workspaces.delete(o),r&&h.workspaces.set(o,r)):(h.emptyWindows.delete(o),r&&h.emptyWindows.set(o,r)),a||this.G()}G(){const n={};for(const[a,o]of this.u.workspaces.entries())n[a.toString()]=o.id;const r={};for(const[a,o]of this.u.emptyWindows.entries())r[a.toString()]=o.id;this.M({workspaces:n,emptyWindows:r}),this.t=void 0}H(n){const r={},a=this.v();if(n.workspaces)for(const[h,f]of Object.entries(n.workspaces)){const O=I.URI.parse(f);r[h]=this.r.extUri.isEqual(O,a.location)?a.id:this.r.extUri.basename(O)}const o={};if(n.emptyWindows)for(const[h,f]of Object.entries(n.emptyWindows)){const O=I.URI.parse(f);o[h]=this.r.extUri.isEqual(O,a.location)?a.id:this.r.extUri.basename(O)}return{workspaces:r,emptyWindows:o}}I(){return[]}J(n){throw new Error("not implemented")}L(){return{}}M(n){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=de([ie(0,d.IEnvironmentService),ie(1,c.IFileService),ie(2,E.IUriIdentityService),ie(3,w.ILogService)],t),e.UserDataProfilesService=t;class s extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(n){this.a=n}L(){return this.Q}M(n){this.Q=n}}e.InMemoryUserDataProfilesService=s}),define(ne[148],re([0,1,19,6,23,7,4,2,12,11,87,21,26,32,5,31,25,22]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S,E,T,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var m;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(m=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let p=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,r,a,o,h){super(),this.t=n,this.u=r,this.v=a,this.w=o,this.y=h,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new I.Emitter),this.m=this.B(new I.Emitter),this.n=this.B(new I.Emitter),this.p=this.B(new I.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:f})=>f.cancel()),this.k.forEach(f=>f.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,w.isTargetPlatformCompatible)(a,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.t.isEnabled())throw new w.ExtensionManagementError(k.localize(0,null),w.ExtensionManagementErrorCode.Internal);const a=await this.G(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(a.manifest,a.extension,r)}catch(a){throw t(this.u,"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(n),error:a}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(a),b(a)}}async uninstall(n,r={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,r,a){const o={...a,installOnlyNewlyAddedFromExtensionPack:c.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,S.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},h=se=>`${v.ExtensionKey.create(se).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!c.URI.isUri(r)){const se=this.j.get(h(r));if(se)return this.v.info("Extensions is already requested to install",r.identifier.id),se.task.waitUntilTaskIsFinished()}const f=[],O=[],x=[],_=this.Q(n,r,o);c.URI.isUri(r)||this.j.set(h(r),{task:_,waitingTasks:[]}),this.l.fire({identifier:_.identifier,source:r,profileLocation:o.profileLocation}),this.v.info("Installing extension:",_.identifier.id),f.push({task:_,manifest:n});let ee=!1;try{if(o.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",_.identifier.id);else try{const oe=await this.F(_.identifier,n,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),ae=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:Y,manifest:y}of(0,N.distinct)(oe,({gallery:M})=>M.identifier.id)){ee=ee||!!y.extensionDependencies?.some($=>(0,v.areSameExtensions)({id:$},_.identifier));const M=h(Y),U=this.j.get(M);if(U){if(this.C(_,U.task)){const $=U.task.identifier;this.v.info("Waiting for already requested installing extension",$.id,_.identifier.id),U.waitingTasks.push(_),O.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,V=>V.some(j=>(0,v.areSameExtensions)(j.identifier,$)))).then(V=>{if(this.v.info("Finished waiting for already requested installing extension",$.id,_.identifier.id),!V.find(W=>(0,v.areSameExtensions)(W.identifier,$))?.local)throw new Error(`Extension ${$.id} is not installed`)}))}}else if(!ae.some(({identifier:$})=>(0,v.areSameExtensions)($,Y.identifier))){const $=this.Q(y,Y,{...o,donotIncludePackAndDependencies:!0});this.j.set(M,{task:$,waitingTasks:[_]}),this.l.fire({identifier:$.identifier,source:Y,profileLocation:o.profileLocation}),this.v.info("Installing extension:",$.identifier.id,_.identifier.id),f.push({task:$,manifest:y})}}}catch(oe){if(c.URI.isUri(_.source))(0,N.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",_.identifier.id,oe.message),(0,N.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",_.identifier.id,oe.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",_.identifier.id),oe}const se=f.reduce((oe,{task:ae,manifest:Y})=>(oe.set(ae.identifier.id.toLowerCase(),{task:ae,manifest:Y}),oe),new Map);for(;se.size;){let oe;const ae=[...se.values()].filter(({manifest:Y})=>!Y.extensionDependencies?.some(y=>se.has(y.toLowerCase())));ae.length?oe=se.size===1?ae:ae.filter(({task:Y})=>!(Y===_&&!ee)):(this.v.info("Found extensions with circular dependencies",ae.map(({task:Y})=>Y.identifier.id)),oe=[...se.values()]),await this.D(oe.map(async({task:Y})=>{const y=new Date().getTime();try{const M=await Y.run();if(await this.D(this.s.map(U=>U.postInstall(M,Y.source,o,D.CancellationToken.None))),!c.URI.isUri(Y.source)){const U=Y.operation===3,$=U?void 0:(new Date().getTime()-Y.source.lastUpdated)/1e3;if(t(this.u,U?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(Y.source),verificationStatus:Y.verificationStatus,duration:new Date().getTime()-y,durationSinceUpdate:$}),d.isWeb&&Y.operation!==3)try{await this.t.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch{}}x.push({local:M,identifier:Y.identifier,operation:Y.operation,source:Y.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})}catch(M){throw c.URI.isUri(Y.source)||t(this.u,Y.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(Y.source),verificationStatus:Y.verificationStatus,duration:new Date().getTime()-y,error:M}),this.v.error("Error while installing the extension:",Y.identifier.id),M}finally{se.delete(Y.identifier.id.toLowerCase())}}))}return O.length&&await this.D(O),x.forEach(({identifier:oe})=>this.v.info("Extension installed successfully:",oe.id)),this.m.fire(x),x.filter(({identifier:oe})=>(0,v.areSameExtensions)(oe,_.identifier))[0].local}catch(se){if(f.forEach(({task:oe})=>oe.cancel()),x.length)try{const oe=await Promise.allSettled(x.map(({local:ae})=>this.R(ae,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let ae=0;ae<oe.length;ae++){const Y=oe[ae],{identifier:y}=x[ae];Y.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",y.id):this.v.warn("Rollback: Error while uninstalling extension",y.id,(0,R.getErrorMessage)(Y.reason))}}catch(oe){this.v.warn("Error while rolling back extensions",(0,R.getErrorMessage)(oe),x.map(({identifier:ae})=>ae.id))}throw this.m.fire(f.map(({task:oe})=>({identifier:oe.identifier,operation:2,source:oe.source,context:o.context,profileLocation:o.profileLocation}))),se}finally{for(const{task:se}of f)se.source&&!c.URI.isUri(se.source)&&this.j.delete(h(se.source))}}C(n,r){for(const[,{task:a,waitingTasks:o}]of this.j.entries())if(a===n&&(o.includes(r)||o.some(h=>this.C(h,r)))||a===r&&o[0]&&!this.C(n,o[0]))return!1;return!0}async D(n){const r=[],a=[],o=await Promise.allSettled(n);for(const h of o)h.status==="fulfilled"?r.push(h.value):a.push(h.reason);if(a.length)throw g(a);return r}async F(n,r,a,o,h){if(!this.t.isEnabled())return[];const f=await this.getInstalled(void 0,h),O=[],x=[],_=async(ee,se)=>{O.push(ee);const oe=se.extensionDependencies||[],ae=[...oe];if(se.extensionPack){const Y=a?f.find(y=>(0,v.areSameExtensions)(y.identifier,ee)):void 0;for(const y of se.extensionPack)Y&&Y.manifest.extensionPack&&Y.manifest.extensionPack.some(M=>(0,v.areSameExtensions)({id:M},{id:y}))||ae.every(M=>!(0,v.areSameExtensions)({id:M},{id:y}))&&ae.push(y)}if(ae.length){const Y=ae.filter(y=>O.every(M=>!(0,v.areSameExtensions)(M,{id:y})));if(Y.length){const y=await this.t.getExtensions(Y.map(M=>({id:M,preRelease:o})),D.CancellationToken.None);for(const M of y){if(O.find(V=>(0,v.areSameExtensions)(V,M.identifier)))continue;const U=oe.some(V=>(0,v.areSameExtensions)({id:V},M.identifier));let $;try{$=await this.G(M,!1,o)}catch(V){if(V instanceof w.ExtensionManagementError&&V.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!U){this.v.info("Skipping the packed extension as it cannot be installed",M.identifier.id);continue}else throw V}x.push({gallery:$.extension,manifest:$.manifest}),await _($.extension.identifier,$.manifest)}}}};return await _(n,r),x}async G(n,r,a){if((await this.getExtensionsControlManifest()).malicious.some(O=>(0,v.areSameExtensions)(n.identifier,O)))throw new w.ExtensionManagementError(k.localize(1,null,n.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const O=await this.getTargetPlatform();throw new w.ExtensionManagementError(k.localize(2,null,n.identifier.id,this.w.nameLong,(0,w.TargetPlatformToString)(O)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const h=await this.H(n,r,a);if(h){if(a&&!r&&n.hasPreReleaseVersion&&!h.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(k.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],D.CancellationToken.None))[0]?new w.ExtensionManagementError(k.localize(4,null,n.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(k.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",h.identifier.id);const f=await this.t.getManifest(h,D.CancellationToken.None);if(f===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(f.version!==h.version)throw new w.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:h,manifest:f}}async H(n,r,a){const o=await this.getTargetPlatform();let h=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(h=(await this.t.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:o,compatible:!0},D.CancellationToken.None))[0]||null),!h&&await this.t.isExtensionCompatible(n,a,o)&&(h=n),h||(r?h=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:o,compatible:!0},D.CancellationToken.None))[0]||null:h=await this.t.getCompatibleExtension(n,a,o)),h}async I(n,r){const a={...r,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},o=ee=>`${ee.id.toLowerCase()}${a.versionOnly?`-${n.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,h=this.k.get(o(n.identifier));if(h)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),h.waitUntilTaskIsFinished();const f=ee=>{const se=this.R(ee,a);return this.k.set(o(se.extension.identifier),se),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${ee.identifier.id}@${ee.manifest.version}`),this.n.fire({identifier:ee.identifier,profileLocation:a.profileLocation,applicationScoped:ee.isApplicationScoped}),se},O=(ee,se)=>{se?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,a.profileLocation.toString(),se.message):this.v.error("Failed to uninstall extension:",`${ee.identifier.id}@${ee.manifest.version}`,se.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${ee.identifier.id}@${ee.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${ee.identifier.id}@${ee.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,v.getLocalExtensionTelemetryData)(ee),error:se}),this.p.fire({identifier:ee.identifier,error:se?.code,profileLocation:a.profileLocation,applicationScoped:ee.isApplicationScoped})},x=[],_=[];try{x.push(f(n));const ee=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const se=this.M(n,ee);for(const oe of se)this.k.has(o(oe.identifier))?this.v.info("Extensions is already requested to uninstall",oe.identifier.id):x.push(f(oe))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(x.map(se=>se.extension),ee,n),await this.D(x.map(async se=>{try{if(await se.run(),await this.D(this.s.map(oe=>oe.postUninstall(se.extension,a,D.CancellationToken.None))),se.extension.identifier.uuid)try{await this.t.reportStatistic(se.extension.manifest.publisher,se.extension.manifest.name,se.extension.manifest.version,"uninstall")}catch{}O(se.extension)}catch(oe){const ae=oe instanceof w.ExtensionManagementError?oe:new w.ExtensionManagementError((0,R.getErrorMessage)(oe),w.ExtensionManagementErrorCode.Internal);throw O(se.extension,ae),ae}finally{_.push(se)}}))}catch(ee){const se=ee instanceof w.ExtensionManagementError?ee:new w.ExtensionManagementError((0,R.getErrorMessage)(ee),w.ExtensionManagementErrorCode.Internal);for(const oe of x){try{oe.cancel()}catch{}_.includes(oe)||O(oe.extension,se)}throw se}finally{for(const ee of x)this.k.delete(o(ee.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",ee.extension.identifier.id)}}J(n,r,a){for(const o of n){const h=this.N(o,r);if(h.length){const f=h.filter(O=>!n.some(x=>(0,v.areSameExtensions)(x.identifier,O.identifier)));if(f.length)throw new Error(this.L(o,f,a))}}}L(n,r,a){return a===n?r.length===1?k.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?k.localize(9,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?k.localize(10,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):k.localize(11,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(n,r,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const o=n.manifest.extensionPack?n.manifest.extensionPack:[];if(o.length){const h=r.filter(O=>!O.isBuiltin&&o.some(x=>(0,v.areSameExtensions)({id:x},O.identifier))),f=[];for(const O of h)f.push(...this.M(O,r,a));return[...h,...f]}return[]}N(n,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(o=>(0,v.areSameExtensions)({id:o},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};p=de([ie(0,w.IExtensionGalleryService),ie(1,l.ITelemetryService),ie(2,E.ILogService),ie(3,T.IProductService),ie(4,u.IUserDataProfilesService)],p),e.AbstractExtensionManagementService=p;function g(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=g;function b(i){if(i instanceof w.ExtensionManagementError)return i;const n=new w.ExtensionManagementError(i.message,w.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:a,duration:o,error:h,durationSinceUpdate:f}){let O,x;h&&(h instanceof w.ExtensionManagementError?(O=h.code,h.code===w.ExtensionManagementErrorCode.Signature&&(x=h.message)):O=w.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:a,success:!h,duration:o,errorcode:O,errorcodeDetail:x,durationSinceUpdate:f})}class s{constructor(){this.d=new L.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,L.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.createCancelablePromise)(n=>new Promise((r,a)=>{const o=n.onCancellationRequested(()=>{o.dispose(),a(new R.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=s}),define(ne[40],re([0,1,6,14,2,4,36,11,21,26,13,9,5,22,27,3,7,25]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S,E,T,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class p extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=p,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let g=class extends D.Disposable{constructor(i,n,r,a,o,h){super(),this.i=i,this.j=n,this.k=r,this.l=a,this.m=o,this.n=h,this.b=this.B(new R.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new R.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new I.ResourceMap}scanProfileExtensions(i,n){return this.p(i,void 0,n)}async addExtensionsToProfile(i,n){const r=[],a=[];try{return await this.p(n,o=>{const h=[];for(const f of o)i.some(([O])=>(0,c.areSameExtensions)(O.identifier,f.identifier)&&O.manifest.version!==f.version)?r.push(f):h.push(f);for(const[f,O]of i)if(!h.some(x=>(0,c.areSameExtensions)(x.identifier,f.identifier)&&x.version===f.manifest.version)){const x={identifier:f.identifier,version:f.manifest.version,location:f.location,metadata:O};a.push(x),h.push(x)}return a.length&&this.b.fire({extensions:a,profileLocation:n}),r.length&&this.f.fire({extensions:r,profileLocation:n}),h}),a.length&&this.c.fire({extensions:a,profileLocation:n}),r.length&&this.g.fire({extensions:r,profileLocation:n}),a}catch(o){throw a.length&&this.c.fire({extensions:a,error:o,profileLocation:n}),r.length&&this.g.fire({extensions:r,error:o,profileLocation:n}),o}}async updateMetadata(i,n){const r=[];return await this.p(n,a=>{const o=[];for(const h of a){const f=i.find(([O])=>(0,c.areSameExtensions)(O.identifier,h.identifier)&&O.manifest.version===h.version);f&&(h.metadata={...h.metadata,...f[1]},r.push(h)),o.push(h)}return o}),r}async removeExtensionFromProfile(i,n){const r=[];this.f.fire({extensions:r,profileLocation:n});try{await this.p(n,a=>{const o=[];for(const h of a)(0,c.areSameExtensions)(h.identifier,i.identifier)?r.push(h):o.push(h);return r.length&&this.f.fire({extensions:r,profileLocation:n}),o}),r.length&&this.g.fire({extensions:r,profileLocation:n})}catch(a){throw r.length&&this.g.fire({extensions:r,error:a,profileLocation:n}),a}}async p(i,n,r){return this.w(i).queue(async()=>{let a=[],o;try{const h=await this.j.readFile(i);o=JSON.parse(h.value.toString().trim()||"[]")}catch(h){if((0,k.toFileOperationResult)(h)!==1)throw h;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(o=await this.v()),!o&&r?.bailOutWhenFileNotFound)throw new p((0,l.getErrorMessage)(h),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.r(i);let h=!1;for(const f of o){b(f)||this.r(i);let O;if((0,T.isString)(f.relativeLocation)&&f.relativeLocation)O=this.t(f.relativeLocation);else if((0,T.isString)(f.location))O=this.t(f.location),h=!0,f.relativeLocation=f.location,f.location=O.toJSON();else{O=P.URI.revive(f.location);const x=this.s(O);x&&(h=!0,f.relativeLocation=x)}a.push({identifier:f.identifier,location:O,version:f.version,metadata:f.metadata})}h&&await this.j.writeFile(i,L.VSBuffer.fromString(JSON.stringify(o)))}if(n){a=n(a);const h=a.map(f=>({identifier:f.identifier,version:f.version,location:f.location.toJSON(),relativeLocation:this.s(f.location),metadata:f.metadata}));await this.j.writeFile(i,L.VSBuffer.fromString(JSON.stringify(h)))}return a})}r(i){const n=new p(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let r;try{r=(await this.j.readFile(i)).value.toString()}catch(o){if((0,k.toFileOperationResult)(o)===1)return;throw o}this.n.info("Migrating extensions from old default profile location",i.toString());let a;try{const o=JSON.parse(r);Array.isArray(o)&&o.every(h=>b(h))?a=o:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.n.error(o)}if(a)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(o){if((0,k.toFileOperationResult)(o)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw o}try{await this.j.del(i)}catch(o){(0,k.toFileOperationResult)(o)!==1&&this.n.error(o)}try{await this.j.del(n)}catch(o){(0,k.toFileOperationResult)(o)!==1&&this.n.error(o)}return a})()),this.u}w(i){let n=this.h.get(i);return n||(n=new N.Queue,this.h.set(i,n)),n}};g=de([ie(1,k.IFileService),ie(2,S.IUserDataProfilesService),ie(3,E.IUriIdentityService),ie(4,u.ITelemetryService),ie(5,v.ILogService)],g),e.AbstractExtensionsProfileScannerService=g;function b(s){return(0,T.isObject)(s)&&(0,d.isIExtensionIdentifier)(s.identifier)&&(t(s.location)||(0,T.isString)(s.location)&&s.location)&&((0,T.isUndefined)(s.relativeLocation)||(0,T.isString)(s.relativeLocation))&&s.version&&(0,T.isString)(s.version)}function t(s){return s?(0,T.isString)(s.path)&&(0,T.isString)(s.scheme):!1}}),define(ne[47],re([0,1,19,6,30,14,7,50,78,2,16,15,12,17,41,53,3,11,91,18,26,32,45,13,9,5,31,4,54,40,22,27,108]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S,E,T,l,u,m,p,g,b,t,s,i,n,r,a,o,h,f,O,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var _;(function(M){function U($,V){if($===V)return!0;const j=Object.keys($),W=new Set;for(const G of Object.keys(V))W.add(G);if(j.length!==W.size)return!1;for(const G of j){if($[G]!==V[G])return!1;W.delete(G)}return W.size===0}M.equals=U})(_=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let ee=class extends c.Disposable{constructor(U,$,V,j,W,G,K,J,F,C,A,z){super(),this.systemExtensionsLocation=U,this.userExtensionsLocation=$,this.l=V,this.m=j,this.n=W,this.p=G,this.r=K,this.s=J,this.t=F,this.u=C,this.v=A,this.w=z,this.g=this.B(new a.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,S.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ae,(0,S.joinPath)(this.m,b.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ae,(0,S.joinPath)(this.m,b.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(oe,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,g.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(U,$,V){const[j,W]=await Promise.all([this.scanSystemExtensions(U),this.scanUserExtensions($)]),G=V?await this.scanExtensionsUnderDevelopment(U,[...j,...W]):[];return this.F(j,W,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(U){const $=[];$.push(this.G(!!U.useCache,U.language)),$.push(this.H(U.language,!!U.checkControlFile));const[V,j]=await Promise.all($);return this.D([...V,...j],0,U,!1)}async scanUserExtensions(U){const $=U.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",$);const V=this.v.extUri.isEqual(U.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,j=await this.J($,!!U.profileLocation,1,!U.includeUninstalled,U.language,!0,V),W=U.useCache&&!j.devMode&&j.excludeObsolete?this.j:this.k;let G;try{G=await W.scanExtensions(j)}catch(K){if(K instanceof h.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),G=await W.scanExtensions(j);else throw K}return G=await this.D(G,1,U,!0),this.s.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(U,$){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const V=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(j=>j.scheme===k.Schemas.file).map(async j=>{const W=await this.J(j,!1,1,!0,U.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(K=>(K.type=$.find(J=>(0,g.areSameExtensions)(J.identifier,K.identifier))?.type??K.type,this.k.validate(K,W)))}))).flat();return this.D(V,"development",U,!0)}return[]}async scanExistingExtension(U,$,V){const j=await this.J(U,!1,$,!0,V.language,!0,void 0),W=await this.k.scanExtension(j);return!W||!V.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(U,$,V){const j=await this.J(U,!1,$,!0,V.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions(j);return this.D(W,$,V,!0)}async scanMetadata(U){const $=(0,S.joinPath)(U,"package.json"),V=(await this.r.readFile($)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(U,$){const V=(0,S.joinPath)(U,"package.json"),j=(await this.r.readFile(V)).value.toString(),W=JSON.parse(j);$.isMachineScoped=$.isMachineScoped||void 0,$.isBuiltin=$.isBuiltin||void 0,W.__metadata={...W.__metadata,...$},await this.r.writeFile((0,S.joinPath)(U,"package.json"),R.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(U){if(U instanceof h.ExtensionsProfileScanningError&&U.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw U}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const U=await this.scanUserExtensions({includeInvalid:!0});if(U.length)await this.p.addExtensionsToProfile(U.map($=>[$,$.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify([])))}catch($){(0,s.toFileOperationResult)($)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.getErrorMessage)($))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(U){this.s.error(U)}finally{this.z=void 0}})()),this.z}async D(U,$,V,j){return V.includeAllVersions||(U=this.F($===0?U:void 0,$===1?U:void 0,$==="development"?U:void 0,await this.getTargetPlatform(),j)),V.includeInvalid||(U=U.filter(W=>W.isValid)),U.sort((W,G)=>{const K=w.basename(W.location.fsPath),J=w.basename(G.location.fsPath);return K<J?-1:K>J?1:0})}F(U,$,V,j,W){const G=(J,F,C)=>{if(J.isValid&&!F.isValid)return!1;if(J.isValid===F.isValid){if(W&&E.gt(J.manifest.version,F.manifest.version))return this.s.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${J.location.path} with version ${J.manifest.version}`),!1;if(E.eq(J.manifest.version,F.manifest.version)){if(J.type===0)return this.s.debug(`Skipping extension ${F.location.path} in favour of system extension ${J.location.path} with same version`),!1;if(J.targetPlatform===j)return this.s.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return C?this.s.warn(`Overwriting user extension ${J.location.path} with ${F.location.path}.`):this.s.debug(`Overwriting user extension ${J.location.path} with ${F.location.path}.`),!0},K=new b.ExtensionIdentifierMap;return U?.forEach(J=>{const F=K.get(J.identifier.id);(!F||G(F,J,!1))&&K.set(J.identifier.id,J)}),$?.forEach(J=>{const F=K.get(J.identifier.id);if(!F&&U&&J.type===0){this.s.debug(`Skipping obsolete system extension ${J.location.path}.`);return}(!F||G(F,J,!1))&&K.set(J.identifier.id,J)}),V?.forEach(J=>{const F=K.get(J.identifier.id);(!F||G(F,J,!0))&&K.set(J.identifier.id,J),K.set(J.identifier.id,J)}),[...K.values()]}async G(U,$){this.s.trace("Started scanning system extensions");const V=await this.J(this.systemExtensionsLocation,!1,0,!0,$,!0,void 0),W=await(U&&!V.devMode?this.i:this.k).scanExtensions(V);return this.s.trace("Scanned system extensions:",W.length),W}async H(U,$){const V=this.t.isBuilt?[]:this.u.builtInExtensions;if(!V?.length)return[];this.s.trace("Started scanning dev system extensions");const j=$?await this.I():{},W=[],G=u.URI.file(w.normalize(w.join(k.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const J of V){const F=j[J.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":W.push((0,S.joinPath)(G,J.name));break;default:W.push(u.URI.file(F));break}}const K=await Promise.all(W.map(async J=>this.k.scanExtension(await this.J(J,!1,0,!0,U,!0,void 0))));return this.s.trace("Scanned dev system extensions:",K.length),(0,N.coalesce)(K)}async I(){try{const U=await this.r.readFile(this.l);return JSON.parse(U.value.toString())}catch{return{}}}async J(U,$,V,j,W,G,K){const J=await this.f(W??v.language),F=await this.L(U),C=$&&!this.v.extUri.isEqual(U,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,A=C?await this.L(C):void 0;return new se(U,F,C,A,$,K,V,j,G,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,W,J)}async L(U){try{const $=await this.r.stat(U);if(typeof $.mtime=="number")return $.mtime}catch{}}};ee=de([ie(4,f.IUserDataProfilesService),ie(5,h.IExtensionsProfileScannerService),ie(6,s.IFileService),ie(7,n.ILogService),ie(8,p.IEnvironmentService),ie(9,r.IProductService),ie(10,O.IUriIdentityService),ie(11,i.IInstantiationService)],ee),e.AbstractExtensionsScannerService=ee;class se{constructor(U,$,V,j,W,G,K,J,F,C,A,z,B,Q,Z){this.location=U,this.mtime=$,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=j,this.profile=W,this.profileScanOptions=G,this.type=K,this.excludeObsolete=J,this.validate=F,this.productVersion=C,this.productDate=A,this.productCommit=z,this.devMode=B,this.language=Q,this.translations=Z}static createNlsConfiguration(U){return{language:U.language,pseudo:U.language==="pseudo",devMode:U.devMode,translations:U.translations}}static equals(U,$){return(0,S.isEqual)(U.location,$.location)&&U.mtime===$.mtime&&(0,S.isEqual)(U.applicationExtensionslocation,$.applicationExtensionslocation)&&U.applicationExtensionslocationMtime===$.applicationExtensionslocationMtime&&U.profile===$.profile&&D.equals(U.profileScanOptions,$.profileScanOptions)&&U.type===$.type&&U.excludeObsolete===$.excludeObsolete&&U.validate===$.validate&&U.productVersion===$.productVersion&&U.productDate===$.productDate&&U.productCommit===$.productCommit&&U.devMode===$.devMode&&U.language===$.language&&_.equals(U.translations,$.translations)}}e.ExtensionScannerInput=se;let oe=class extends c.Disposable{constructor(U,$,V,j,W){super(),this.f=U,this.g=$,this.h=V,this.i=j,this.j=W}async scanExtensions(U){const $=U.profile?await this.l(U):await this.k(U);let V={};if(U.excludeObsolete&&U.type===1)try{const j=(await this.i.readFile(this.f)).value.toString();V=JSON.parse(j)}catch{}return(0,l.isEmptyObject)(V)?$:$.filter(j=>!V[g.ExtensionKey.create(j).toString()])}async k(U){const $=await this.i.resolve(U.location);if(!$.children?.length)return[];const V=await Promise.all($.children.map(async j=>{if(!j.isDirectory||U.type===1&&(0,S.basename)(j.resource).indexOf(".")===0)return null;const W=new se(j.resource,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(W)}));return(0,N.coalesce)(V).sort((j,W)=>j.location.path<W.location.path?-1:1)}async l(U){let $=await this.m(U.location,()=>!0,U);if(U.applicationExtensionslocation&&!this.h.extUri.isEqual(U.location,U.applicationExtensionslocation)){$=$.filter(j=>!j.metadata?.isApplicationScoped);const V=await this.m(U.applicationExtensionslocation,j=>!!j.metadata?.isApplicationScoped,U);$.push(...V)}return $}async m(U,$,V){const j=await this.g.scanProfileExtensions(U,V.profileScanOptions);if(!j.length)return[];const W=await Promise.all(j.map(async G=>{if($(G)){const K=new se(G.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(K,G.metadata)}return null}));return(0,N.coalesce)(W)}async scanOneOrMultipleExtensions(U){try{if(await this.i.exists((0,S.joinPath)(U.location,"package.json"))){const $=await this.scanExtension(U);return $?[$]:[]}else return await this.scanExtensions(U)}catch($){return this.j.error(`Error scanning extensions at ${U.location.path}:`,(0,I.getErrorMessage)($)),[]}}async scanExtension(U,$){try{let V=await this.scanExtensionManifest(U.location);if(V){V.publisher||(V.publisher=b.UNDEFINED_PUBLISHER),$=$??V.__metadata,delete V.__metadata;const j=(0,g.getGalleryExtensionId)(V.publisher,V.name),W=$?.id?{id:j,uuid:$.id}:{id:j},G=$?.isSystem?0:U.type,K=G===0||!!$?.isBuiltin;V=await this.n(U.location,V,se.createNlsConfiguration(U));const J={type:G,identifier:W,manifest:V,location:U.location,isBuiltin:K,targetPlatform:$?.targetPlatform??"undefined",metadata:$,isValid:!0,validations:[]};return U.validate?this.validate(J,U):J}}catch(V){U.type!==0&&this.j.error(V)}return null}validate(U,$){let V=!0;const j=(0,t.validateExtensionManifest)($.productVersion,$.productDate,$.location,U.manifest,U.isBuiltin);for(const[W,G]of j)W===T.default.Error&&(V=!1,this.j.error(this.t($.location,G)));return U.isValid=V,U.validations=j,U}async scanExtensionManifest(U){const $=(0,S.joinPath)(U,"package.json");let V;try{V=(await this.i.readFile($)).value.toString()}catch(W){return(0,s.toFileOperationResult)(W)!==1&&this.j.error(this.t(U,(0,m.localize)(0,null,$.path,W.message))),null}let j;try{j=JSON.parse(V)}catch{const G=[];(0,P.parse)(V,G);for(const K of G)this.j.error(this.t(U,(0,m.localize)(1,null,$.path,K.offset,K.length,(0,d.getParseErrorMessage)(K.error))));return null}return(0,P.getNodeType)(j)!=="object"?(this.j.error(this.t(U,(0,m.localize)(2,null,$.path))),null):j}async n(U,$,V){const j=await this.p(U,$,V);if(j)try{const W=[],G=await this.r(j.default,W);if(W.length>0)return W.forEach(J=>{this.j.error(this.t(U,(0,m.localize)(3,null,j.default?.path,(0,d.getParseErrorMessage)(J.error))))}),$;if((0,P.getNodeType)(j)!=="object")return this.j.error(this.t(U,(0,m.localize)(4,null,j.default?.path))),$;const K=j.values||Object.create(null);return(0,x.localizeManifest)($,K,G)}catch{}return $}async p(U,$,V){const j=(0,S.joinPath)(U,"package.nls.json"),W=(F,C)=>{C.forEach(A=>{this.j.error(this.t(U,(0,m.localize)(5,null,F?.path,(0,d.getParseErrorMessage)(A.error))))})},G=F=>{this.j.error(this.t(U,(0,m.localize)(6,null,F?.path)))},K=`${$.publisher}.${$.name}`,J=V.translations[K];if(J)try{const F=u.URI.file(J),C=(await this.i.readFile(F)).value.toString(),A=[],z=(0,P.parse)(C,A);return A.length>0?(W(F,A),{values:void 0,default:j}):(0,P.getNodeType)(z)!=="object"?(G(F),{values:void 0,default:j}):{values:z.contents?z.contents.package:void 0,default:j}}catch{return{values:void 0,default:j}}else{if(!await this.i.exists(j))return;let C;try{C=await this.s(U,V)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const A=(await this.i.readFile(C.localized)).value.toString(),z=[],B=(0,P.parse)(A,z);return z.length>0?(W(C.localized,z),{values:void 0,default:C.original}):(0,P.getNodeType)(B)!=="object"?(G(C.localized),{values:void 0,default:C.original}):{values:B,default:C.original}}catch{return{values:void 0,default:C.original}}}}async r(U,$){if(U)try{const V=(await this.i.readFile(U)).value.toString();return(0,P.parse)(V,$)}catch{}}s(U,$){return new Promise((V,j)=>{const W=G=>{const K=(0,S.joinPath)(U,`package.nls.${G}.json`);this.i.exists(K).then(J=>{J&&V({localized:K,original:(0,S.joinPath)(U,"package.nls.json")});const F=G.lastIndexOf("-");F===-1?V({localized:(0,S.joinPath)(U,"package.nls.json"),original:null}):(G=G.substring(0,F),W(G))})};if($.devMode||$.pseudo||!$.language)return V({localized:(0,S.joinPath)(U,"package.nls.json"),original:null});W($.language)})}t(U,$){return`[${U.path}]: ${$}`}};oe=de([ie(1,h.IExtensionsProfileScannerService),ie(2,O.IUriIdentityService),ie(3,s.IFileService),ie(4,n.ILogService)],oe);let ae=class extends oe{constructor(U,$,V,j,W,G){super($,V,j,W,G),this.y=U,this.v=this.B(new L.ThrottledDelayer(3e3)),this.w=this.B(new a.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(U){const $=await this.z();if(this.u=U,$&&$.input&&se.equals($.input,this.u))return this.j.debug("Using cached extensions scan result",U.location.toString()),this.v.trigger(()=>this.D()),$.result.map(j=>(j.location=u.URI.revive(j.location),j));const V=await super.scanExtensions(U);return await this.C({input:U,result:V}),V}async z(){try{const U=await this.i.readFile(this.y),$=JSON.parse(U.value.toString());return{result:$.result,input:(0,o.revive)($.input)}}catch(U){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,I.getErrorMessage)(U))}return null}async C(U){try{await this.i.writeFile(this.y,R.VSBuffer.fromString(JSON.stringify(U)))}catch($){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,I.getErrorMessage)($))}}async D(){if(!this.u)return;const U=await this.z();if(!U)return;const $=U.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!D.equals(V,$))try{await this.i.del(this.y),this.w.fire()}catch(j){this.j.error(j)}}};ae=de([ie(2,h.IExtensionsProfileScannerService),ie(3,O.IUriIdentityService),ie(4,s.IFileService),ie(5,n.ILogService)],ae);function Y(M,U){const $=(0,g.getExtensionId)(M.manifest.publisher,M.manifest.name);return{id:$,identifier:new b.ExtensionIdentifier($),isBuiltin:M.type===0,isUserBuiltin:M.type===1&&M.isBuiltin,isUnderDevelopment:U,extensionLocation:M.location,uuid:M.identifier.uuid,targetPlatform:M.targetPlatform,...M.manifest}}e.toExtensionDescription=Y;class y extends ee{constructor(U,$,V,j,W,G,K,J,F,C,A,z){super(U,$,(0,S.joinPath)(V,".vscode-oss-dev","extensions","control.json"),(0,S.joinPath)(j,b.MANIFEST_CACHE_FOLDER),W,G,K,J,F,C,A,z),this.M=(async()=>{if(v.translationsConfigFile)try{const B=await this.r.readFile(u.URI.file(v.translationsConfigFile));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(U){return this.M}}e.NativeExtensionsScannerService=y}),define(ne[149],re([0,1,58,6,34,4,2,16,15,20,5,22]),function(H,e,N,L,D,R,I,P,d,c,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends I.Disposable{constructor(E,T){super(),this.b=E,this.f=T,this.a=new L.Limiter(5)}async postUninstall(E){const T=this.g(E,"uninstall");T&&(this.f.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(T.script,"uninstall",T.args,!0,E),this.f.info("Finished running post uninstall script",E.identifier.id,E.manifest.version)}catch(l){this.f.error("Failed to run post uninstall script",E.identifier.id,E.manifest.version),this.f.error(l)}}));try{await c.Promises.rm(this.j(E))}catch(l){this.f.error("Error while removing extension storage path",E.identifier.id),this.f.error(l)}}g(E,T){const l=`vscode:${T}`;if(E.location.scheme===P.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[l]=="string"){const u=E.manifest.scripts[l].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(E.identifier.id,E.manifest.version,`${l} should be a node script`),null):{script:(0,d.join)(E.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(E,T,l,u,m){return new Promise((p,g)=>{const b=this.i(E,T,l,m);let t;const s=i=>{t&&(clearTimeout(t),t=null),i?g(i):p(void 0)};b.on("error",i=>{s((0,D.toErrorMessage)(i)||"Unknown")}),b.on("exit",(i,n)=>{s(i?`post-${T} process exited with code ${i}`:void 0)}),u&&(t=setTimeout(()=>{t=null,b.kill(),g("timed out")},5e3))})}i(E,T,l,u){const m={silent:!0,execArgv:void 0},p=(0,N.fork)(E,[`--type=extension-post-${T}`,...l],m);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const g=R.Event.fromNodeEventEmitter(p.stdout,"data"),b=R.Event.fromNodeEventEmitter(p.stderr,"data");g(i=>this.f.info(u.identifier.id,u.manifest.version,`post-${T}`,i)),b(i=>this.f.error(u.identifier.id,u.manifest.version,`post-${T}`,i));const t=R.Event.any(R.Event.map(g,i=>({data:`%c${i}`,format:[""]})),R.Event.map(b,i=>({data:`%c${i}`,format:["color: red"]})));return R.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(u.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),p}j(E){return(0,d.join)(this.b.defaultProfile.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};v=de([ie(0,w.IUserDataProfilesService),ie(1,k.ILogService)],v),e.ExtensionsLifecycle=v}),define(ne[150],re([0,1,5,22,27,25,40,13,18,11]),function(H,e,N,L,D,R,I,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let k=class extends I.AbstractExtensionsProfileScannerService{constructor(v,S,E,T,l,u){super(c.URI.file(v.extensionsPath),S,E,T,l,u)}};k=de([ie(0,d.INativeEnvironmentService),ie(1,P.IFileService),ie(2,L.IUserDataProfilesService),ie(3,D.IUriIdentityService),ie(4,R.ITelemetryService),ie(5,N.ILogService)],k),e.ExtensionsProfileScannerService=k}),define(ne[151],re([0,1,11,18,40,47,13,9,5,31,27,22]),function(H,e,N,L,D,R,I,P,d,c,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let v=class extends R.NativeExtensionsScannerService{constructor(E,T,l,u,m,p,g,b){super(N.URI.file(m.builtinExtensionsPath),N.URI.file(m.extensionsPath),m.userHome,N.URI.file(m.userDataPath),E,T,l,u,m,p,g,b)}};v=de([ie(0,w.IUserDataProfilesService),ie(1,D.IExtensionsProfileScannerService),ie(2,I.IFileService),ie(3,d.ILogService),ie(4,L.INativeEnvironmentService),ie(5,c.IProductService),ie(6,k.IUriIdentityService),ie(7,P.IInstantiationService)],v),e.ExtensionsScannerService=v}),define(ne[152],re([0,1,6,4,2,119,3,84,9,22]),function(H,e,N,L,D,R,I,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,d.createDecorator)("storageService");var k;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(k=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var v;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(v=e.StorageTarget||(e.StorageTarget={}));function S(m){const p=m.get(e.TARGET_KEY);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}e.loadKeyTargets=S;class E extends D.Disposable{constructor(p={flushInterval:E.a}){super(),this.j=p,this.b=this.B(new L.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new L.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new N.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,N.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.J()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(p,g){if(g===e.TARGET_KEY){switch(p){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:g,target:this.F(p)[g]})}r(p){this.f.fire({reason:p})}get(p,g,b){return this.L(g)?.get(p,b)}getBoolean(p,g,b){return this.L(g)?.getBoolean(p,b)}getNumber(p,g,b){return this.L(g)?.getNumber(p,b)}store(p,g,b,t){if((0,I.isUndefinedOrNull)(g)){this.remove(p,b);return}this.t(()=>{this.u(p,b,t),this.L(b)?.set(p,g)})}remove(p,g){this.t(()=>{this.u(p,g,void 0),this.L(g)?.delete(p)})}t(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,g){const b=[],t=this.F(p);for(const s of Object.keys(t))t[s]===g&&b.push(s);return b}u(p,g,b){const t=this.F(g);typeof b=="number"?t[p]!==b&&(t[p]=b,this.L(g)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[p]=="number"&&(delete t[p],this.L(g)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(p){switch(p){case-1:return this.D;case 0:return this.z;default:return this.w}}G(p){const g=this.L(p);return g?S(g):Object.create(null)}isNew(p){return this.getBoolean(e.IS_NEW_KEY,p)===!0}async flush(p=k.NONE){this.f.fire({reason:p});const g=this.L(-1),b=this.L(0),t=this.L(1);switch(p){case k.NONE:await N.Promises.settled([g?.whenFlushed()??Promise.resolve(),b?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case k.SHUTDOWN:await N.Promises.settled([g?.flush(0)??Promise.resolve(),b?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.L(-1)?.items??new Map,g=this.L(0)?.items??new Map,b=this.L(1)?.items??new Map;return u(p,g,b,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(p,g){return this.r(k.NONE),(0,c.isUserDataProfile)(p)?this.N(p,g):this.O(p,g)}H(p,g){return!(p.id===g.id||T(g)&&T(p))}I(p,g,b,t){this.t(()=>{if(t)for(const[s,i]of p)g.set(s,i);else{const s=new Set;for(const[i,n]of p)s.add(i),g.get(i)!==n&&this.n(b,i);for(const[i]of g.items)s.has(i)||this.n(b,i)}})}}E.a=60*1e3,e.AbstractStorageService=E;function T(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=T;class l extends E{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(p=>this.n(1,p))),this.B(this.P.onDidChangeStorage(p=>this.n(0,p))),this.B(this.p.onDidChangeStorage(p=>this.n(-1,p)))}L(p){switch(p){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(p){return!1}}e.InMemoryStorageService=l;async function u(m,p,g,b,t,s){const i=_=>{try{return JSON.parse(_)}catch{return _}},n=new Map,r=new Map;m.forEach((_,ee)=>{n.set(ee,_),r.set(ee,i(_))});const a=new Map,o=new Map;p.forEach((_,ee)=>{a.set(ee,_),o.set(ee,i(_))});const h=new Map,f=new Map;g.forEach((_,ee)=>{h.set(ee,_),f.set(ee,i(_))}),console.group(b!==t?`Storage: Application (path: ${b})`:`Storage: Application & Profile (path: ${b}, default profile)`);const O=[];if(n.forEach((_,ee)=>{O.push({key:ee,value:_})}),console.table(O),console.groupEnd(),console.log(r),b!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const _=[];a.forEach((ee,se)=>{_.push({key:se,value:ee})}),console.table(_),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${s})`);const x=[];h.forEach((_,ee)=>{x.push({key:ee,value:_})}),console.table(x),console.groupEnd(),console.log(f)}e.logStorage=u}),define(ne[153],re([0,1,19,23,7,12,35,3,11,24,18,21,26,45,13,5,31,43,138,152,25]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S,E,T,l,u,m,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const b=R.isWeb?"web":(0,w.getTargetPlatform)(R.platform,I.arch),t="X-Market-Search-Activity-Id";var s;(function(C){C[C.None=0]="None",C[C.IncludeVersions=1]="IncludeVersions",C[C.IncludeFiles=2]="IncludeFiles",C[C.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",C[C.IncludeSharedAccounts=8]="IncludeSharedAccounts",C[C.IncludeVersionProperties=16]="IncludeVersionProperties",C[C.ExcludeNonValidated=32]="ExcludeNonValidated",C[C.IncludeInstallationTargets=64]="IncludeInstallationTargets",C[C.IncludeAssetUri=128]="IncludeAssetUri",C[C.IncludeStatistics=256]="IncludeStatistics",C[C.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",C[C.Unpublished=4096]="Unpublished",C[C.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...C){return String(C.reduce((A,z)=>A|z,0))}var n;(function(C){C[C.Tag=1]="Tag",C[C.ExtensionId=4]="ExtensionId",C[C.Category=5]="Category",C[C.ExtensionName=7]="ExtensionName",C[C.Target=8]="Target",C[C.Featured=9]="Featured",C[C.SearchText=10]="SearchText",C[C.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class f{constructor(A=h){this.d=A}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(A,z=this.d.pageSize){return new f({...this.d,pageNumber:A,pageSize:z})}withFilter(A,...z){const B=[...this.d.criteria,...z.length?z.map(Q=>({filterType:A,value:Q})):[{filterType:A}]];return new f({...this.d,criteria:B})}withSortBy(A){return new f({...this.d,sortBy:A})}withSortOrder(A){return new f({...this.d,sortOrder:A})}withFlags(...A){return new f({...this.d,flags:A.reduce((z,B)=>z|B,0)})}withAssetTypes(...A){return new f({...this.d,assetTypes:A})}withSource(A){return new f({...this.d,source:A})}get raw(){const{criteria:A,pageNumber:z,pageSize:B,sortBy:Q,sortOrder:Z,flags:le,assetTypes:ue}=this.d;return{filters:[{criteria:A,pageNumber:z,pageSize:B,sortBy:Q,sortOrder:Z}],assetTypes:ue,flags:le}}get searchText(){const A=this.d.criteria.filter(z=>z.filterType===n.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(A=>String(A.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function O(C,A){const z=(C||[]).filter(B=>B.statisticName===A)[0];return z?z.value:0}function x(C){const A="Microsoft.VisualStudio.Code.Translation.";return C.files.filter(B=>B.assetType.indexOf(A)===0).reduce((B,Q)=>{const Z=se(C,Q.assetType);return Z&&B.push([Q.assetType.substring(A.length),Z]),B},[])}function _(C){if(C.properties){const A=C.properties.filter(Q=>Q.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=A.filter(Q=>z.test(Q.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return se(C,r.Repository)}function ee(C){return{uri:`${C.fallbackAssetUri}/${r.VSIX}?redirect=true${C.targetPlatform?`&targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${r.VSIX}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}}function se(C,A){return C.files.filter(B=>B.assetType===A)[0]?{uri:`${C.assetUri}/${A}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`,fallbackUri:`${C.fallbackAssetUri}/${A}${C.targetPlatform?`?targetPlatform=${C.targetPlatform}`:""}`}:null}function oe(C,A){const z=C.properties?C.properties.filter(Q=>Q.key===A):[],B=z.length>0&&z[0].value;return B?B.split(",").map(Q=>(0,v.adoptToGalleryExtensionId)(Q)):[]}function ae(C){const A=C.properties?C.properties.filter(z=>z.key===a.Engine):[];return A.length>0&&A[0].value||""}function Y(C){const A=C.properties?C.properties.filter(z=>z.key===a.PreRelease):[];return A.length>0&&A[0].value==="true"}function y(C){const A=C.properties?C.properties.filter(B=>B.key===a.LocalizedLanguages):[],z=A.length>0&&A[0].value||"";return z?z.split(","):[]}function M(C){return C.properties?.find(A=>A.key===a.SponsorLink)?.value}function U(C){return C.indexOf("preview")!==-1}function $(C){return C.targetPlatform?(0,w.toTargetPlatform)(C.targetPlatform):"undefined"}function V(C){const A=(0,N.distinct)(C.versions.map($)),z=!!C.tags?.includes(w.WEB_EXTENSION_TAG),B=A.indexOf("web");return z?B===-1&&A.push("web"):B!==-1&&A.splice(B,1),A}function j(C,A){const z=(0,w.getFallbackTargetPlarforms)(A);for(let B=0;B<C.length;B++){const Q=C[B];if(Q.version===C[B-1]?.version){let Z=B;const le=$(Q);if(le===A)for(;Z>0&&C[Z-1].version===Q.version;)Z--;else if(z.includes(le))for(;Z>0&&C[Z-1].version===Q.version&&$(C[Z-1])!==A;)Z--;Z!==B&&(C.splice(B,1),C.splice(Z,0,Q))}}return C}e.sortExtensionVersions=j;function W(C,A,z){C.telemetryData={index:A,querySource:z,queryActivityId:C.queryContext?.[t]}}function G(C,A,z,B){const Q=C.versions[0],Z={manifest:se(A,r.Manifest),readme:se(A,r.Details),changelog:se(A,r.Changelog),license:se(A,r.License),repository:_(A),download:ee(A),icon:se(A,r.Icon),signature:se(A,r.Signature),coreTranslations:x(A)};return{identifier:{id:(0,v.getGalleryExtensionId)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},name:C.extensionName,version:A.version,displayName:C.displayName,publisherId:C.publisher.publisherId,publisher:C.publisher.publisherName,publisherDisplayName:C.publisher.displayName,publisherDomain:C.publisher.domain?{link:C.publisher.domain,verified:!!C.publisher.isDomainVerified}:void 0,publisherSponsorLink:M(Q),description:C.shortDescription||"",installCount:O(C.statistics,"install"),rating:O(C.statistics,"averagerating"),ratingCount:O(C.statistics,"ratingcount"),categories:C.categories||[],tags:C.tags||[],releaseDate:Date.parse(C.releaseDate),lastUpdated:Date.parse(C.lastUpdated),allTargetPlatforms:z,assets:Z,properties:{dependencies:oe(A,a.Dependency),extensionPack:oe(A,a.ExtensionPack),engine:ae(A),localizedLanguages:y(A),targetPlatform:$(A),isPreReleaseVersion:Y(A)},hasPreReleaseVersion:Y(Q),hasReleaseVersion:!0,preview:U(C.flags),isSigned:!!Z.signature,queryContext:B}}let K=class{constructor(A,z,B,Q,Z,le,ue,Ee){this.k=z,this.l=B,this.n=Q,this.o=Z,this.q=le,this.u=ue,this.w=Ee;const pe=ue.extensionsGallery,fe=pe?.servicePPEUrl&&Ee.getValue("_extensionsGallery.enablePPE");this.d=fe?pe.servicePPEUrl:pe?.serviceUrl,this.g=fe?void 0:pe?.searchUrl,this.h=pe?.controlUrl,this.j=(0,m.resolveMarketplaceHeaders)(ue.version,ue,this.n,this.w,this.q,A,this.o)}x(A=""){return`${this.d}${A}`}isEnabled(){return!!this.d}async getExtensions(A,z,B){const Q=L.CancellationToken.isCancellationToken(z)?{}:z,Z=L.CancellationToken.isCancellationToken(z)?z:B,le=[],ue=[],Ee=[],pe=[];let fe=!0;for(const ce of A){ce.uuid?ue.push(ce.uuid):le.push(ce.id);const ve=!!(ce.version||ce.preRelease);Ee.push({id:ce.id,uuid:ce.uuid,includePreRelease:ve}),ce.version&&pe.push({id:ce.id,uuid:ce.uuid,version:ce.version}),fe=fe&&!!ce.hasPreRelease&&!ve}if(!ue.length&&!le.length)return[];let ge=new f().withPage(1,A.length);ue.length&&(ge=ge.withFilter(n.ExtensionId,...ue)),le.length&&(ge=ge.withFilter(n.ExtensionName,...le)),(Q.queryAllVersions||fe)&&(ge=ge.withFlags(ge.flags,s.IncludeVersions)),Q.source&&(ge=ge.withSource(Q.source));const{extensions:me}=await this.z(ge,{targetPlatform:Q.targetPlatform??b,includePreRelease:Ee,versions:pe,compatible:!!Q.compatible},Z);return Q.source&&me.forEach((ce,ve)=>W(ce,ve,Q.source)),me}async getCompatibleExtension(A,z,B){if((0,w.isNotWebExtensionInWebTargetPlatform)(A.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(A,z,B))return A;const Q=new f().withFlags(s.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,A.identifier.uuid),{extensions:Z}=await this.z(Q,{targetPlatform:B,compatible:!0,includePreRelease:z},L.CancellationToken.None);return Z[0]||null}async isExtensionCompatible(A,z,B){if(!(0,w.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,B)||!z&&A.properties.isPreReleaseVersion)return!1;let Q=A.properties.engine;if(!Q){const Z=await this.getManifest(A,L.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");Q=Z.engines.vscode}return(0,S.isEngineValid)(Q,this.u.version,this.u.date)}async y(A,z,B,Q,Z){if(!(0,w.isTargetPlatformCompatible)($(A),Q,Z)||z!=="any"&&Y(A)!==(z==="prerelease"))return!1;if(B)try{const le=await this.E(A);if(!(0,S.isEngineValid)(le,this.u.version,this.u.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${A.version}.`,(0,D.getErrorMessage)(le)),!1}return!0}async query(A,z){let B=A.text||"";const Q=A.pageSize??50;let Z=new f().withPage(1,Q);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ge,me)=>(Z=Z.withFilter(n.Category,me||ge),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,ge,me)=>(Z=Z.withFilter(n.Tag,me||ge),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(Z=Z.withFilter(n.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),Z=Z.withFilter(n.SearchText,B)),Z=Z.withSortBy(0)):A.ids?Z=Z.withFilter(n.ExtensionId,...A.ids):A.names?Z=Z.withFilter(n.ExtensionName,...A.names):Z=Z.withSortBy(4),typeof A.sortBy=="number"&&(Z=Z.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(Z=Z.withSortOrder(A.sortOrder)),A.source&&(Z=Z.withSource(A.source));const le=async(fe,ge)=>{const{extensions:me,total:ce}=await this.z(fe,{targetPlatform:b,compatible:!1,includePreRelease:!!A.includePreRelease},ge);return me.forEach((ve,Se)=>W(ve,(fe.pageNumber-1)*fe.pageSize+Se,A.source)),{extensions:me,total:ce}},{extensions:ue,total:Ee}=await le(Z,z),pe=async(fe,ge)=>{if(ge.isCancellationRequested)throw new D.CancellationError;const{extensions:me}=await le(Z.withPage(fe+1),ge);return me};return{firstPage:ue,total:Ee,pageSize:Z.pageSize,getPage:pe}}async z(A,z,B){const Q=A.flags;!!(A.flags&s.IncludeLatestVersionOnly)&&!!(A.flags&s.IncludeVersions)&&(A=A.withFlags(A.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(A.flags&s.IncludeLatestVersionOnly)&&!(A.flags&s.IncludeVersions)&&(A=A.withFlags(A.flags,s.IncludeLatestVersionOnly)),z.versions?.length&&(A=A.withFlags(A.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),A=A.withFlags(A.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:Z,total:le,context:ue}=await this.B(A,B);if(!(A.flags&s.IncludeLatestVersionOnly)){const ge=[];for(const me of Z){const ce=await this.A(me,z,ue);ce&&ge.push(ce)}return{extensions:ge,total:le}}const pe=[],fe=new Map;for(let ge=0;ge<Z.length;ge++){const me=Z[ge],ce={id:(0,v.getGalleryExtensionId)(me.publisher.publisherName,me.extensionName),uuid:me.extensionId},ve=(0,P.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Le=>(0,v.areSameExtensions)(Le,ce))?.includePreRelease;if(z.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(V(me),z.targetPlatform))continue;const Se=await this.A(me,z,ue);!Se||Se.properties.isPreReleaseVersion&&(!ve||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==z.targetPlatform&&Se.hasPreReleaseVersion?fe.set(me.extensionId,ge):pe.push([ge,Se])}if(fe.size){const ge=new Date().getTime(),me=new f().withFlags(Q&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,fe.size).withFilter(n.ExtensionId,...fe.keys()),{extensions:ce}=await this.z(me,z,B);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:fe.size});for(const ve of ce){const Se=fe.get(ve.identifier.uuid);pe.push([Se,ve])}}return{extensions:pe.sort((ge,me)=>ge[0]-me[0]).map(([,ge])=>ge),total:le}}async A(A,z,B){const Q={id:(0,v.getGalleryExtensionId)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},Z=z.versions?.find(pe=>(0,v.areSameExtensions)(pe,Q))?.version,le=(0,P.isBoolean)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(pe=>(0,v.areSameExtensions)(pe,Q))?.includePreRelease,ue=V(A),Ee=j(A.versions,z.targetPlatform);if(z.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(ue,z.targetPlatform))return null;for(let pe=0;pe<Ee.length;pe++){const fe=Ee[pe];if(!(Z&&fe.version!==Z)){if(await this.y(fe,le?"any":"release",z.compatible,ue,z.targetPlatform))return G(A,fe,ue,B);if(Z&&fe.version===Z)return null}}return Z||z.compatible?null:G(A,A.versions[0],ue)}async B(A,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,s.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(s.Unpublished));const B=await this.j,Q=JSON.stringify(A.raw),Z={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},le=new Date().getTime();let ue,Ee,pe=0;try{if(ue=await this.k.request({type:"POST",url:this.g&&A.criteria.some(ge=>ge.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:Q,headers:Z},z),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:pe};const fe=await(0,u.asJson)(ue);if(fe){const ge=fe.results[0],me=ge.extensions,ce=ge.resultMetadata&&ge.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return pe=ce&&ce.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:pe,context:{[t]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:pe}}catch(fe){throw Ee=fe,fe}finally{this.o.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-le,success:!!ue&&(0,u.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:Ee?(0,D.isCancellationError)(Ee)?"canceled":(0,D.getErrorMessage)(Ee).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(pe)})}}async reportStatistic(A,z,B,Q){if(!this.isEnabled())return;const Z=R.isWeb?this.x(`/itemName/${A}.${z}/version/${B}/statType/${Q==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${A}/extensions/${z}/${B}/stats?statType=${Q}`),le=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.j,Accept:le};try{await this.k.request({type:"POST",url:Z,headers:Ee},L.CancellationToken.None)}catch{}}async download(A,z,B){this.l.trace("ExtensionGalleryService#download",A.identifier.id);const Q=(0,v.getGalleryExtensionTelemetryData)(A),Z=new Date().getTime(),le=ge=>this.o.publicLog("galleryService:downloadVSIX",{...Q,duration:ge}),ue=B===2?"install":B===3?"update":"",Ee=ue?{uri:`${A.assets.download.uri}${d.URI.parse(A.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${A.assets.download.fallbackUri}${d.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:A.assets.download,pe=A.queryContext?.[t]?{[t]:A.queryContext[t]}:void 0,fe=await this.D(Ee,pe?{headers:pe}:void 0);await this.q.writeFile(z,fe.stream),le(new Date().getTime()-Z)}async downloadSignatureArchive(A,z){if(!A.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",A.identifier.id);const B=await this.D(A.assets.signature);await this.q.writeFile(z,B.stream)}async getReadme(A,z){if(A.assets.readme){const B=await this.D(A.assets.readme,{},z);return await(0,u.asTextOrError)(B)||""}return""}async getManifest(A,z){if(A.assets.manifest){const B=await this.D(A.assets.manifest,{},z),Q=await(0,u.asTextOrError)(B);return Q?JSON.parse(Q):null}return null}async C(A,z){const B=se(A,r.Manifest);if(!B)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},Z=await this.D(B,{headers:Q});return await(0,u.asJson)(Z)}async getCoreTranslation(A,z){const B=A.assets.coreTranslations.filter(Q=>Q[0]===z.toUpperCase())[0];if(B){const Q=await this.D(B[1]),Z=await(0,u.asTextOrError)(Q);return Z?JSON.parse(Z):null}return null}async getChangelog(A,z){if(A.assets.changelog){const B=await this.D(A.assets.changelog,{},z);return await(0,u.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(A,z,B){let Q=new f().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);A.identifier.uuid?Q=Q.withFilter(n.ExtensionId,A.identifier.uuid):Q=Q.withFilter(n.ExtensionName,A.identifier.id);const{galleryExtensions:Z}=await this.B(Q,L.CancellationToken.None);if(!Z.length)return[];const le=V(Z[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(le,B))return[];const ue=[];await Promise.all(Z[0].versions.map(async fe=>{try{await this.y(fe,z?"any":"release",!0,le,B)&&ue.push(fe)}catch{}}));const Ee=[],pe=new Set;for(const fe of j(ue,B))pe.has(fe.version)||(pe.add(fe.version),Ee.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:Y(fe)}));return Ee}async D(A,z={},B=L.CancellationToken.None){const Q=await this.j,Z={type:"GET"},le={...Q,...z.headers||{}};z={...z,...Z,headers:le};const ue=A.uri,Ee=A.fallbackUri,pe={...z,url:ue};try{const fe=await this.k.request(pe,B);if(fe.res.statusCode===200)return fe;const ge=await(0,u.asTextOrError)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${ge}`)}catch(fe){if((0,D.isCancellationError)(fe))throw fe;const ge=(0,D.getErrorMessage)(fe);this.o.publicLog2("galleryService:cdnFallback",{url:ue,message:ge});const me={...z,url:Ee};return this.k.request(me,B)}}async E(A){let z=ae(A);if(!z){const B=await this.C(A,L.CancellationToken.None);if(!B)throw new Error("Manifest was not found");z=B.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const A=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,u.asJson)(A),B=[],Q={};if(z){for(const Z of z.malicious)B.push({id:Z});if(z.migrateToPreRelease)for(const[Z,le]of Object.entries(z.migrateToPreRelease))(!le.engine||(0,S.isEngineValid)(le.engine,this.u.version,this.u.date))&&(Q[Z.toLowerCase()]={disallowInstall:!0,extension:{id:le.id,displayName:le.displayName,autoMigrate:{storage:!!le.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[Z,le]of Object.entries(z.deprecated))le&&(Q[Z.toLowerCase()]=(0,P.isBoolean)(le)?{}:le)}return{malicious:B,deprecated:Q}}};K=de([ie(1,u.IRequestService),ie(2,T.ILogService),ie(3,k.IEnvironmentService),ie(4,g.ITelemetryService),ie(5,E.IFileService),ie(6,l.IProductService),ie(7,c.IConfigurationService)],K);let J=class extends K{constructor(A,z,B,Q,Z,le,ue,Ee){super(A,z,B,Q,Z,le,ue,Ee)}};J=de([ie(0,p.IStorageService),ie(1,u.IRequestService),ie(2,T.ILogService),ie(3,k.IEnvironmentService),ie(4,g.ITelemetryService),ie(5,E.IFileService),ie(6,l.IProductService),ie(7,c.IConfigurationService)],J),e.ExtensionGalleryService=J;let F=class extends K{constructor(A,z,B,Q,Z,le,ue){super(void 0,A,z,B,Q,Z,le,ue)}};F=de([ie(0,u.IRequestService),ie(1,T.ILogService),ie(2,k.IEnvironmentService),ie(3,g.ITelemetryService),ie(4,E.IFileService),ie(5,l.IProductService),ie(6,c.IConfigurationService)],F),e.ExtensionGalleryServiceWithNoStorageService=F}),define(ne[154],re([0,1,11,18,13,5,135,27,22,3,68]),function(H,e,N,L,D,R,I,P,d,c,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let w=class Ve extends d.UserDataProfilesService{constructor(T,l,u,m,p){super(u,m,l,p),this.O=T,this.P=u}I(){return this.O.getItem(Ve.b,[]).map(l=>({...l,location:(0,c.isString)(l.location)?this.r.extUri.joinPath(this.profilesHome,l.location):N.URI.revive(l.location)}))}L(){const T=this.O.getItem(Ve.c,{});return this.O.getItem(Ve.a,!1)?T:this.H(T)}N(){return this.r.extUri.joinPath(N.URI.file(this.P.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};w.a="profileAssociationsMigration",w=de([ie(0,I.IStateReadService),ie(1,P.IUriIdentityService),ie(2,L.INativeEnvironmentService),ie(3,D.IFileService),ie(4,R.ILogService)],w),e.UserDataProfilesReadonlyService=w;let v=class ze extends w{constructor(T,l,u,m,p){super(T,l,u,m,p),this.U=T}J(T){T.length?this.U.setItem(ze.b,T.map(l=>({...l,location:this.r.extUri.basename(l.location)}))):this.U.removeItem(ze.b)}I(){const T=super.I();return this.U.getItem("userDataProfilesMigration",!1)||(this.J(T),this.U.setItem("userDataProfilesMigration",!0)),T}M(T){T.emptyWindows||T.workspaces?this.U.setItem(ze.c,T):this.U.removeItem(ze.c)}L(){const T="workspaceAndProfileInfo",l=this.U.getItem(T,void 0);if(l){this.U.removeItem(T);const m=l.reduce((p,{workspace:g,profile:b})=>(p[N.URI.revive(g).toString()]=N.URI.revive(b).toString(),p),{});this.U.setItem(ze.c,{workspaces:m})}const u=super.L();return this.U.getItem(ze.a,!1)||(this.M(u),this.U.setItem(ze.a,!0)),u}};v=de([ie(0,I.IStateService),ie(1,P.IUriIdentityService),ie(2,L.INativeEnvironmentService),ie(3,D.IFileService),ie(4,R.ILogService)],v),e.UserDataProfilesService=v;let S=class extends v{constructor(T,l,u,m){super(new k.StateService(0,l,m,u),T,l,u,m)}async init(){return await this.U.init(),super.init()}};S=de([ie(0,P.IUriIdentityService),ie(1,L.INativeEnvironmentService),ie(2,D.IFileService),ie(3,R.ILogService)],S),e.ServerUserDataProfilesService=S}),define(ne[48],re([0,1,121,6,15,3,20,85,169,170]),function(H,e,N,L,D,R,I,P,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const k=new RegExp(e.CorruptZipMessage);class w extends Error{constructor(s,i){let n=i.message;switch(s){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=s,this.cause=i}}e.ExtractError=w;function v(t){const s=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>s&i).reduce((i,n)=>i+n,s&61440)}function S(t){if(t instanceof w)return t;let s;return k.test(t.message)&&(s="CorruptZip"),new w(s,t)}function E(t,s,i,n,r,a){const o=D.dirname(s),h=D.join(n,o);if(!h.startsWith(n))return Promise.reject(new Error(P.localize(0,null,s)));const f=D.join(n,s);let O;return a.onCancellationRequested(()=>{O?.destroy()}),Promise.resolve(I.Promises.mkdir(h,{recursive:!0})).then(()=>new Promise((x,_)=>{if(!a.isCancellationRequested)try{O=(0,N.createWriteStream)(f,{mode:i}),O.once("close",()=>x()),O.once("error",_),t.once("error",_),t.pipe(O)}catch(ee){_(ee)}}))}function T(t,s,i,n){let r=(0,L.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{r.cancel(),t.close()}),new Promise((o,h)=>{const f=new L.Sequencer,O=x=>{x.isCancellationRequested||(a++,t.readEntry())};t.once("error",h),t.once("close",()=>r.then(()=>{n.isCancellationRequested||t.entryCount===a?o():h(new w("Incomplete",new Error(P.localize(1,null,a,t.entryCount))))},h)),t.readEntry(),t.on("entry",x=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(x.fileName)){O(n);return}const _=x.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(_)){const oe=D.join(s,_);r=(0,L.createCancelablePromise)(ae=>I.Promises.mkdir(oe,{recursive:!0}).then(()=>O(ae)).then(void 0,h));return}const ee=u(t,x),se=v(x);r=(0,L.createCancelablePromise)(oe=>f.queue(()=>ee.then(ae=>E(ae,_,se,s,i,oe).then(()=>O(oe)))).then(null,h))})})}function l(t,s=!1){return new Promise((i,n)=>{(0,d.open)(t,s?{lazyEntries:!0}:void 0,(r,a)=>{r?n(S(r)):i((0,R.assertIsDefined)(a))})})}function u(t,s){return new Promise((i,n)=>{t.openReadStream(s,(r,a)=>{r?n(S(r)):i((0,R.assertIsDefined)(a))})})}function m(t,s){return new Promise((i,n)=>{const r=new c.ZipFile;s.forEach(o=>{o.contents?r.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&r.addFile(o.localPath,o.path)}),r.end();const a=(0,N.createWriteStream)(t);r.outputStream.pipe(a),r.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(t))})}e.zip=m;function p(t,s,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=l(t,!0);return i.overwrite&&(a=a.then(o=>I.Promises.rm(s).then(()=>o))),a.then(o=>T(o,s,{sourcePathRegex:r},n))}e.extract=p;function g(t,s){return l(t).then(i=>new Promise((n,r)=>{i.on("entry",a=>{a.fileName===s&&u(i,a).then(o=>n(o),o=>r(o))}),i.once("close",()=>r(new Error(P.localize(2,null,s))))}))}function b(t,s){return g(t,s).then(i=>new Promise((n,r)=>{const a=[];i.once("error",r),i.on("data",o=>a.push(o)),i.on("end",()=>n(Buffer.concat(a)))}))}e.buffer=b}),define(ne[155],re([0,1,6,7,2,16,12,17,41,3,28,20,48,24,18,21,26,60,13,5]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S,E,T,l,u,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let g=class Be extends D.Disposable{constructor(t,s,i,n,r,a){super(),this.h=s,this.i=i,this.j=n,this.k=r,this.l=a,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,s){await this.g;const i=(0,P.joinPath)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,i,r=>this.i.download(t,r,s))}catch(r){throw new T.ExtensionManagementError(r.message,T.ExtensionManagementErrorCode.Download)}let n="Unverified";if(this.m(t)){const r=await this.n(t);try{await this.k.verify(i.fsPath,r.fsPath,this.l.getLevel()===p.LogLevel.Trace)&&(n="Verified"),this.l.info(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`)}catch(a){const o=a,h=o.code;if(o.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${o.output}`),h==="UnknownError")n="UnknownError",this.l.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`);else{if(h==="PackageIsInvalidZip"||h==="SignatureArchiveIsInvalidZip")throw new T.ExtensionManagementError(v.CorruptZipMessage,T.ExtensionManagementErrorCode.CorruptZip);if(!o.didExecute)this.l.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n} (${h})`);else throw await this.delete(i),new T.ExtensionManagementError(h,T.ExtensionManagementErrorCode.Signature)}}finally{try{await this.delete(r)}catch(a){this.l.error(a)}}}return{location:i,verificationStatus:n}}m(t){if(!t.isSigned)return!1;const s=this.j.getValue("extensions.verifySignature");return(0,c.isBoolean)(s)?s:!0}async n(t){await this.g;const s=(0,P.joinPath)(this.extensionsDownloadDir,`${this.v(t)}${Be.c}`);return await this.r(t,s,i=>this.i.downloadSignatureArchive(t,i)),s}async r(t,s,i){if(await this.h.exists(s))return;if(s.scheme!==R.Schemas.file){await i(s);return}const n=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,k.generateUuid)()}`);await this.h.exists(n)||await i(n);try{await this.t(n,s,Date.now()+2*60*1e3)}catch(r){try{await this.h.del(n)}catch{}if(r.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.l.info(`Rename failed because of ${(0,L.getErrorMessage)(r)}. Deleted the file from downloaded location`,n.path),r}}async delete(t){await this.g,await this.h.del(t)}async t(t,s,i){try{await w.Promises.rename(t.fsPath,s.fsPath)}catch(n){if(I.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.l.info(`Failed renaming ${t} to ${s} with 'EPERM' error. Trying again...`),this.t(t,s,i);throw n}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],i=[],n=[];for(const o of t.children)if(o.name.endsWith(Be.c))n.push(o.resource);else{const h=l.ExtensionKey.parse(o.name);h&&i.push([h,o])}const r=(0,l.groupByExtension)(i,([o])=>o),a=[];for(const o of r)o.sort((h,f)=>d.rcompare(h[0].version,f[0].version)),s.push(...o.slice(1).map(h=>h[1].resource)),a.push(o[0][1]);a.sort((o,h)=>o.mtime-h.mtime),s.push(...a.slice(0,Math.max(0,a.length-this.f)).map(o=>o.resource)),s.push(...n),await N.Promises.settled(s.map(o=>(this.l.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(t){this.l.error(t)}}v(t){return this.f?l.ExtensionKey.create(t).toString().toLowerCase():(0,k.generateUuid)()}};g.c=".sigzip",g=de([ie(0,E.INativeEnvironmentService),ie(1,m.IFileService),ie(2,T.IExtensionGalleryService),ie(3,S.IConfigurationService),ie(4,u.IExtensionSignatureVerificationService),ie(5,p.ILogService)],g),e.ExtensionsDownloader=g}),define(ne[156],re([0,1,48,93]),function(H,e,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(R){return(0,N.buffer)(R,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}e.getManifest=D}),define(ne[157],re([0,1,6,14,23,34,7,4,2,36,16,15,12,17,41,3,11,28,20,48,92,59,18,148,21,26,40,47,155,149,156,130,137,32,45,13,9,5,31,25,27,22]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S,E,T,l,u,m,p,g,b,t,s,i,n,r,a,o,h,f,O,x,_,ee,se,oe,ae,Y,y,M,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,oe.refineServiceDecorator)(i.IExtensionManagementService);let $=class extends s.AbstractExtensionManagementService{constructor(F,C,A,z,B,Q,Z,le,ue,Ee,pe,fe){super(F,C,A,Ee,fe),this.Z=B,this.ab=Q,this.bb=Z,this.cb=ue,this.db=pe,this.X=this.B(new P.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new c.ResourceSet;const ge=this.B(le.createInstance(h.ExtensionsLifecycle));this.S=this.B(le.createInstance(V,ce=>ge.postUninstall(ce))),this.U=this.B(new O.ExtensionsManifestCache(z,this)),this.W=this.B(le.createInstance(o.ExtensionsDownloader));const me=this.B(new x.ExtensionsWatcher(this,this.Z,fe,Q,pe,ue,A));this.B(me.onDidChangeExtensionsByAnotherSource(ce=>this.kb(ce))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,n.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(F){this.v.trace("ExtensionManagementService#zip",F.identifier.id);const C=await this.jb(F),A=await(0,p.zip)((0,S.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,C);return l.URI.file(A)}async unzip(F){return this.v.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:C,cleanup:A}=await this.fb(F),z=w.resolve(C.fsPath);try{return await(0,f.getManifest)(z)}finally{await A()}}getInstalled(F,C=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(F??null,C)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.S.scanUserExtensionAtLocation(F)}async install(F,C={}){this.v.trace("ExtensionManagementService#install",F.toString());const{location:A,cleanup:z}=await this.fb(F);try{const B=await(0,f.getManifest)(w.resolve(A.fsPath));if(B.engines&&B.engines.vscode&&!(0,ee.isEngineValid)(B.engines.vscode,this.w.version,this.w.date))throw new Error(g.localize(0,null,(0,n.getGalleryExtensionId)(B.publisher,B.name),this.w.version));return await this.z(B,A,C)}finally{await z()}}async installFromLocation(F,C){this.v.trace("ExtensionManagementService#installFromLocation",F.toString());const A=await this.S.scanUserExtensionAtLocation(F);if(!A)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.ob([[A,void 0]],C),this.v.info("Successfully installed extension",A.identifier.id,C.toString()),A}async installExtensionsFromProfile(F,C,A){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",F,C.toString(),A.toString());const z=(await this.S.scanExtensions(1,C)).filter(B=>F.some(Q=>(0,n.areSameExtensions)(Q,B.identifier)));if(z.length){const B=await Promise.all(z.map(Q=>this.S.scanMetadata(Q,C)));await this.ob(z.map((Q,Z)=>[Q,B[Z]]),A),this.v.info("Successfully installed extensions",z.map(Q=>Q.identifier.id),A.toString())}return z}async updateMetadata(F,C,A=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",F.identifier.id),C.isPreReleaseVersion&&(C.preRelease=!0),C.isMachineScoped=C.isMachineScoped||void 0,C.isBuiltin=C.isBuiltin||void 0,C.pinned=C.pinned||void 0,F=await this.S.updateMetadata(F,C,A),this.U.invalidate(),this.X.fire(F),F}async reinstallFromGallery(F){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.t.isEnabled())throw new Error(g.localize(1,null));const C=await this.getTargetPlatform(),[A]=await this.t.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:C,compatible:!0},D.CancellationToken.None);if(!A)throw new Error(g.localize(2,null));await this.S.setUninstalled(F);try{await this.S.removeUninstalledExtension(F)}catch(z){throw new Error(g.localize(3,null,(0,R.toErrorMessage)(z)))}return this.installFromGallery(A)}copyExtensions(F,C){return this.S.copyExtensions(F,C)}markAsUninstalled(...F){return this.S.setUninstalled(...F)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(F){this.v.error(F)}}async download(F,C){const{location:A}=await this.W.download(F,C);return A}async fb(F){if(F.scheme===k.Schemas.file)return{location:F,async cleanup(){}};this.v.trace("Downloading extension from",F.toString());const C=(0,S.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.bb.download(F,C),this.v.info("Downloaded extension to",C.toString()),{location:C,cleanup:async()=>{try{await this.cb.del(C)}catch(z){this.v.error(z)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(F,C,A){if(l.URI.isUri(C))return new G(F,C,A,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const z=n.ExtensionKey.create(C).toString();let B=this.Y.get(z);return B||(this.Y.set(z,B=new W(F,C,A,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),B.waitUntilTaskIsFinished().then(()=>this.Y.delete(z))),B}R(F,C){return new K(F,C.profileLocation,this.ab)}async jb(F){const C=async z=>{let B=await m.Promises.readdir(z);B=B.map(le=>w.join(z,le));const Q=await Promise.all(B.map(le=>m.Promises.stat(le)));let Z=Promise.resolve([]);return Q.forEach((le,ue)=>{const Ee=B[ue];le.isFile()&&(Z=Z.then(pe=>[...pe,Ee])),le.isDirectory()&&(Z=Z.then(pe=>C(Ee).then(fe=>[...pe,...fe])))}),Z};return(await C(F.location.fsPath)).map(z=>({path:`extension/${w.relative(F.location.fsPath,z)}`,localPath:z}))}async kb({added:F,removed:C}){if(C)for(const A of C.extensions)this.v.info("Extensions removed from another source",A.id,C.profileLocation.toString()),this.p.fire({identifier:A,profileLocation:C.profileLocation});if(F){const z=(await this.S.scanExtensions(1,F.profileLocation)).filter(B=>F.extensions.some(Q=>(0,n.areSameExtensions)(Q,B.identifier)));this.m.fire(z.map(B=>(this.v.info("Extensions added from another source",B.identifier.id,F.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:F.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(C=>this.lb.add(C)));const F=await this.cb.resolve(this.Z.userExtensionsLocation);for(const C of F.children??[])C.isDirectory&&this.lb.add(C.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(C=>this.nb(C)))}async nb(F){if(!F.affects(this.Z.userExtensionsLocation,1))return;const C=[];for(const A of F.rawAdded){if(this.lb.has(A)||!this.db.extUri.isEqual(this.db.extUri.dirname(A),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(A,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(A).startsWith(".")||!(await this.cb.stat(A)).isDirectory)continue;const z=await this.S.scanUserExtensionAtLocation(A);z&&z.installedTimestamp===void 0&&(this.lb.add(A),C.push(z))}C.length&&(await this.ob(C.map(A=>[A,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",C.map(A=>A.identifier.id)))}async ob(F,C){const A=F.map(z=>z[0]);await this.pb(A),await this.ab.addExtensionsToProfile(F,C),this.m.fire(A.map(z=>({local:z,identifier:z.identifier,operation:1,profileLocation:C})))}async pb(F){const C=await this.S.getUninstalledExtensions();for(const A of F){const z=n.ExtensionKey.create(A);!C[z.toString()]||(this.v.trace("Removing the extension from uninstalled list:",z.id),await this.S.setInstalled(z),this.v.info("Removed the extension from uninstalled list:",z.id))}}};$=de([ie(0,i.IExtensionGalleryService),ie(1,y.ITelemetryService),ie(2,ae.ILogService),ie(3,t.INativeEnvironmentService),ie(4,a.IExtensionsScannerService),ie(5,r.IExtensionsProfileScannerService),ie(6,b.IDownloadService),ie(7,oe.IInstantiationService),ie(8,se.IFileService),ie(9,Y.IProductService),ie(10,M.IUriIdentityService),ie(11,U.IUserDataProfilesService)],$),e.ExtensionManagementService=$;let V=class extends d.Disposable{constructor(F,C,A,z,B,Q){super(),this.k=F,this.l=C,this.m=A,this.n=z,this.p=B,this.s=Q,this.h=this.B(new P.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,S.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new N.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(F,C){const A={includeInvalid:!0,profileLocation:C};let z=[];return F===null||F===0?z.push(...await this.m.scanAllExtensions({includeInvalid:!0},A,!1)):F===1&&z.push(...await this.m.scanUserExtensions(A)),z=F!==null?z.filter(B=>B.type===F):z,Promise.all(z.map(B=>this.y(B)))}async scanAllUserExtensions(F){const C=await this.m.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(C.map(A=>this.y(A)))}async scanUserExtensionAtLocation(F){try{const C=await this.m.scanExistingExtension(F,1,{includeInvalid:!0});if(C)return await this.y(C)}catch(C){this.s.error(C)}return null}async extractUserExtension(F,C,A,z){await this.j.catch(()=>{});const B=F.toString(),Q=w.join(this.m.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),Z=w.join(this.m.userExtensionsLocation.fsPath,B);try{await m.Promises.rm(Z)}catch{throw new i.ExtensionManagementError(g.localize(4,null,Z,F.id),i.ExtensionManagementErrorCode.Delete)}await this.u(F,C,Q,z),await this.m.updateMetadata(l.URI.file(Q),A);try{this.h.fire(l.URI.file(Z)),await this.v(F,Q,Z,Date.now()+2*60*1e3),this.s.info("Renamed to",Z)}catch(le){try{await m.Promises.rm(Q)}catch{}if(le.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.s.info(`Rename failed because of ${(0,I.getErrorMessage)(le)}. Deleted from extracted location`,Q),le}return this.w(l.URI.file(Z),1)}async scanMetadata(F,C){return C?(await this.n.scanProfileExtensions(C)).find(z=>(0,n.areSameExtensions)(z.identifier,F.identifier))?.metadata:this.m.scanMetadata(F.location)}async updateMetadata(F,C,A){return A?await this.n.updateMetadata([[F,C]],A):await this.m.updateMetadata(F.location,C),this.w(F.location,F.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...F){const C=F.map(A=>n.ExtensionKey.create(A));await this.t(A=>C.forEach(z=>{A[z.toString()]=!0,this.s.info("Marked extension as uninstalled",z.toString())}))}async setInstalled(F){await this.t(C=>delete C[F.toString()])}async removeExtension(F,C){this.s.trace(`Deleting ${C} extension from disk`,F.identifier.id,F.location.fsPath);const A=this.p.extUri.joinPath(this.p.extUri.dirname(F.location),`.${(0,u.generateUuid)()}`);await this.v(F.identifier,F.location.fsPath,A.fsPath,Date.now()+2*60*1e3),await this.l.del(A,{recursive:!0}),this.s.info("Deleted from disk",F.identifier.id,F.location.fsPath)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.t(C=>delete C[n.ExtensionKey.create(F).toString()])}async copyExtensions(F,C){const A=await this.scanExtensions(1,F),z=await Promise.all(A.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,F)]));await this.n.addExtensionsToProfile(z,C)}async t(F){return this.g.queue(async()=>{let C;try{C=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(z){if((0,se.toFileOperationResult)(z)!==1)throw z}let A={};if(C)try{A=JSON.parse(C)}catch{}return F&&(F(A),Object.keys(A).length?await this.l.writeFile(this.c,L.VSBuffer.fromString(JSON.stringify(A))):await this.l.del(this.c)),A})}async u(F,C,A,z){this.s.trace(`Started extracting the extension from ${C} to ${A}`);try{await m.Promises.rm(A)}catch(B){throw new i.ExtensionManagementError(this.D(B).message,i.ExtensionManagementErrorCode.Delete)}try{await(0,p.extract)(C,A,{sourcePath:"extension",overwrite:!0},z),this.s.info(`Extracted extension to ${A}:`,F.id)}catch(B){try{await m.Promises.rm(A)}catch{}let Q=i.ExtensionManagementErrorCode.Extract;throw B instanceof p.ExtractError&&(B.type==="CorruptZip"?Q=i.ExtensionManagementErrorCode.CorruptZip:B.type==="Incomplete"&&(Q=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(B.message,Q)}}async v(F,C,A,z){try{await m.Promises.rename(C,A)}catch(B){if(v.isWindows&&B&&B.code==="EPERM"&&Date.now()<z)return this.s.info(`Failed renaming ${C} to ${A} with 'EPERM' error. Trying again...`,F.id),this.v(F,C,A,z);throw new i.ExtensionManagementError(B.message||g.localize(5,null,C,A),B.code||i.ExtensionManagementErrorCode.Rename)}}async w(F,C){const A=await this.m.scanExistingExtension(F,C,{includeInvalid:!0});if(A)return this.y(A);throw new Error(g.localize(6,null,F.path))}async y(F){const C=await this.l.resolve(F.location);let A,z;return C.children&&(A=C.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,z=C.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:A,changelogUrl:z,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async z(){const F=await this.getUninstalledExtensions();this.s.debug("Removing uninstalled extensions:",Object.keys(F));const C=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),A=new Set;for(const B of C)F[n.ExtensionKey.create(B).toString()]||A.add(B.identifier.id.toLowerCase());try{const B=(0,n.groupByExtension)(C,Q=>Q.identifier);await N.Promises.settled(B.map(async Q=>{const Z=Q.sort((le,ue)=>E.rcompare(le.manifest.version,ue.manifest.version))[0];A.has(Z.identifier.id.toLowerCase())||await this.k(await this.y(Z))}))}catch(B){this.s.error(B)}const z=C.filter(B=>B.metadata&&F[n.ExtensionKey.create(B).toString()]);await Promise.allSettled(z.map(B=>this.removeUninstalledExtension(B)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const F=[];let C;try{C=await this.l.resolve(this.m.userExtensionsLocation)}catch(A){(0,se.toFileOperationResult)(A)!==1&&this.s.error(A)}for(const A of C?.children??[])A.isDirectory&&A.name.startsWith(".")&&(0,u.isUUID)(A.name.substring(1))&&F.push((async()=>{this.s.trace("Deleting the generated extension folder",A.resource.toString());try{await this.l.del(A.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",A.resource.toString())}catch(z){this.s.error(z)}})());await Promise.allSettled(F)}D(F){const C=Array.isArray(F)?F:[F];return C.length===1?C[0]instanceof Error?C[0]:new Error(C[0]):C.reduce((A,z)=>new Error(`${A.message}${A.message?",":""}${z instanceof Error?z.message:z}`),new Error(""))}};V=de([ie(1,se.IFileService),ie(2,a.IExtensionsScannerService),ie(3,r.IExtensionsProfileScannerService),ie(4,M.IUriIdentityService),ie(5,ae.ILogService)],V),e.ExtensionsScanner=V;class j extends s.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,T.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(F,C,A,z,B,Q,Z,le,ue){super(),this.identifier=F,this.source=C,this.l=A,this.m=z,this.n=B,this.o=Q,this.p=Z,this.q=le,this.s=ue,this.j="Unverified",this.k=2}async h(F){const[C,A]=await this.x(F);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[C,A]],this.l.profileLocation),C}async u({zipPath:F,key:C,metadata:A},z){let B=await this.v(C);return B||(this.s.trace("Extracting extension...",C.id),B=await this.m.extractUserExtension(C,F,A,z),this.s.info("Extracting extension completed.",C.id)),B}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(z=>n.ExtensionKey.create(z).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class W extends j{constructor(F,C,A,z,B,Q,Z,le,ue,Ee){super(C.identifier,C,A,B,Q,Z,le,ue,Ee),this.y=F,this.z=C,this.A=z}async x(F){const A=(await this.m.scanExtensions(null,this.l.profileLocation)).find(Z=>(0,n.areSameExtensions)(Z.identifier,this.z.identifier));A&&(this.k=3);const z={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,_.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||A?.isMachineScoped,isBuiltin:this.l.isBuiltin||A?.isBuiltin,isSystem:A?.type===0?!0:void 0,updated:!!A,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,T.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:A?.preRelease)};if(A?.manifest.version===this.z.version)return[await this.m.updateMetadata(A,z),z];const{location:B,verificationStatus:Q}=await this.A.download(this.z,this.k);try{return this.j=Q,this.C(B.fsPath),[await this.u({zipPath:B.fsPath,key:n.ExtensionKey.create(this.z),metadata:z},F),z]}catch(Z){try{await this.A.delete(B)}catch(le){this.s.warn("Error while deleting the downloaded file",B.toString(),(0,I.getErrorMessage)(le))}throw Z}}async C(F){try{await(0,f.getManifest)(F)}catch(C){throw new i.ExtensionManagementError((0,s.joinErrors)(C).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=W;class G extends j{constructor(F,C,A,z,B,Q,Z,le,ue,Ee){super({id:(0,n.getGalleryExtensionId)(F.publisher,F.name)},C,A,B,Q,Z,le,ue,Ee),this.y=F,this.z=C,this.A=z}async x(F){const C=new n.ExtensionKey(this.identifier,this.y.version),z=(await this.m.scanExtensions(1,this.l.profileLocation)).find(Z=>(0,n.areSameExtensions)(this.identifier,Z.identifier)),B=await this.C(this.identifier.id,this.y.version,F);if(B.isApplicationScoped=(0,_.isApplicationScopedExtension)(this.y),B.isMachineScoped=this.l.isMachineScoped||z?.isMachineScoped,B.isBuiltin=this.l.isBuiltin||z?.isBuiltin,B.installedTimestamp=Date.now(),B.pinned=this.l.installGivenVersion?!0:void 0,z)if(this.k=3,C.equals(new n.ExtensionKey(z.identifier,z.manifest.version)))try{await this.m.removeExtension(z,"existing")}catch{throw new Error(g.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&E.gt(z.manifest.version,this.y.version)&&await this.m.setUninstalled(z);else{const Z=await this.v(C);if(Z)try{await this.m.removeExtension(Z,"existing")}catch{throw new Error(g.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.resolve(this.z.fsPath),key:C,metadata:B},F),B]}async C(F,C,A){try{let[z]=await this.A.getExtensions([{id:F,version:C}],A);if(z||([z]=await this.A.getExtensions([{id:F}],A)),z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId,isPreReleaseVersion:z.properties.isPreReleaseVersion,preRelease:z.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class K extends s.AbstractExtensionTask{constructor(F,C,A){super(),this.extension=F,this.j=C,this.k=A}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[158],re([0,1,133,6,14,7,3,24,18,134,5,43,132,171]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let E=class extends w.AbstractRequestService{constructor(l,u,m,p){super(!!u.isRemoteServer,p),this.j=l,this.k=u,this.l=m,this.m(),this.B(l.onDidChangeConfiguration(g=>{g.affectsConfiguration("http")&&this.m()}))}m(){const l=this.j.getValue("http");this.f=l?.proxy,this.g=!!l?.proxyStrictSSL,this.h=l?.proxyAuthorization}async request(l,u){const{f:m,g:p}=this;let g;try{g=await(0,c.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(s){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,R.getErrorMessage)(s)))}const b={...process.env,...g},t=l.agent?l.agent:await(0,v.getProxyAgent)(l.url||"",b,{proxyUrl:m,strictSSL:p});return l.agent=t,l.strictSSL=p,this.h&&(l.headers={...l.headers||{},"Proxy-Authorization":this.h}),this.p(l,u)}async n(l){return((0,N.parse)(l.url).protocol==="https:"?await new Promise((p,g)=>{H(["https"],p,g)}):await new Promise((p,g)=>{H(["http"],p,g)})).request}p(l,u){return this.c(l.isChromiumNetwork?"electron":"node",l,()=>L.Promises.withAsyncBody(async(m,p)=>{const g=(0,N.parse)(l.url),b=l.getRawRequest?l.getRawRequest(l):await this.n(l),t={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,I.isBoolean)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(t.auth=l.user+":"+l.password);const s=b(t,i=>{const n=(0,I.isNumber)(l.followRedirects)?l.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.p({...l,url:i.headers.location,followRedirects:n-1},u).then(m,p);else{let r=i;!l.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,S.createGunzip)())),m({res:i,stream:(0,D.streamToBufferReadableStream)(r)})}});s.on("error",p),l.timeout&&s.setTimeout(l.timeout),l.isChromiumNetwork&&s.removeHeader("Content-Length"),l.data&&typeof l.data=="string"&&s.write(l.data),s.end(),u.onCancellationRequested(()=>{s.abort(),p(new R.CancellationError)})}))}async resolveProxy(l){}};E=de([ie(0,P.IConfigurationService),ie(1,d.INativeEnvironmentService),ie(2,k.ILogService),ie(3,k.ILoggerService)],E),e.RequestService=E}),define(ne[172],re([0,1,33,6,14,34,7,2,16,15,12,35,11,20,24,129,59,131,18,107,153,21,60,136,40,47,157,151,13,118,120,46,116,63,64,139,5,125,38,126,142,31,43,158,68,69,25,141,39,143,144,27,146,22,154,145,150,122,124,8]),function(H,e,N,L,D,R,I,P,d,c,k,w,v,S,E,T,l,u,m,p,g,b,t,s,i,n,r,a,o,h,f,O,x,_,ee,se,oe,ae,Y,y,M,U,$,V,j,W,G,K,J,F,C,A,z,B,Q,Z,le,ue,Ee,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class fe extends P.Disposable{constructor(ce){super(),this.b=ce,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[ce,ve]=await this.f();return ce.invokeFunction(async Se=>{const Le=Se.get(oe.ILogService),Fe=Se.get(o.IFileService),q=Se.get(m.INativeEnvironmentService),X=Se.get(B.IUserDataProfilesService);Le.info("CLI main",this.b),this.g(Le),await this.h(q,Fe,X,ce),await Promise.all(ve.map(te=>{(0,L.raceTimeout)(te.flush(),1e3)}))})}async f(){const ce=new _.ServiceCollection,ve={_serviceBrand:void 0,...M.default};ce.set(U.IProductService,ve);const Se=new p.NativeEnvironmentService(this.b,ve);ce.set(m.INativeEnvironmentService,Se),await Promise.all([Se.appSettingsHome.fsPath,Se.extensionsPath].map(Re=>Re?S.Promises.mkdir(Re,{recursive:!0}):void 0));const Le=new Ee.LoggerService((0,oe.getLogLevel)(Se),Se.logsHome);ce.set(oe.ILoggerService,Le);const Fe=this.B(Le.createLogger("cli",{name:(0,pe.localize)(0,null)})),q=[];Le.getLogLevel()===oe.LogLevel.Trace&&q.push(new oe.ConsoleLogger(Le.getLogLevel()));const X=this.B(new ue.LogService(Fe,q));ce.set(oe.ILogService,X);const te=this.B(new h.FileService(X));ce.set(o.IFileService,te);const he=this.B(new f.DiskFileSystemProvider(X));te.registerProvider(d.Schemas.file,he);const ye=new z.UriIdentityService(te);ce.set(A.IUriIdentityService,ye);const Oe=new j.StateReadonlyService(1,Se,X,te),Ie=new Q.UserDataProfilesReadonlyService(Oe,ye,Se,te,X);ce.set(B.IUserDataProfilesService,Ie);const Ae=k.isWindows&&ve.win32RegValueName?this.B(new y.NativePolicyService(X,ve.win32RegValueName)):Se.policyFile?this.B(new ae.FilePolicyService(Se.policyFile,te,X)):new Y.NullPolicyService;ce.set(Y.IPolicyService,Ae);const De=this.B(new T.ConfigurationService(Ie.defaultProfile.settingsResource,te,Ae,X));ce.set(E.IConfigurationService,De),await Promise.all([Oe.init(),De.initialize()]),Ie.init(),ce.set(A.IUriIdentityService,new z.UriIdentityService(te)),ce.set($.IRequestService,new O.SyncDescriptor(V.RequestService,void 0,!0)),ce.set(l.IDownloadService,new O.SyncDescriptor(u.DownloadService,void 0,!0)),ce.set(i.IExtensionsProfileScannerService,new O.SyncDescriptor(le.ExtensionsProfileScannerService,void 0,!0)),ce.set(n.IExtensionsScannerService,new O.SyncDescriptor(a.ExtensionsScannerService,void 0,!0)),ce.set(t.IExtensionSignatureVerificationService,new O.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),ce.set(r.INativeServerExtensionManagementService,new O.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),ce.set(b.IExtensionGalleryService,new O.SyncDescriptor(g.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),ce.set(ee.ILanguagePackService,new O.SyncDescriptor(se.NativeLanguagePackService,void 0,!1));const Ne=[],Ue=(0,J.isInternalTelemetry)(ve,De);if((0,J.supportsTelemetry)(ve,Se)){ve.aiConfig&&ve.aiConfig.ariaKey&&Ne.push(new F.OneDataSystemAppender(Ue,"monacoworkbench",null,ve.aiConfig.ariaKey));const{installSourcePath:Re}=Se,Te={appenders:Ne,sendErrorTelemetry:!1,commonProperties:(async()=>{let Ce;try{Ce=await(0,Z.resolveMachineId)(Oe)}catch(je){je.code!=="ENOENT"&&X.error(je)}return(0,W.resolveCommonProperties)(te,(0,N.release)(),(0,N.hostname)(),process.arch,ve.commit,ve.version,Ce,Ue,Re)})(),piiPaths:(0,J.getPiiPathsFromEnvironment)(Se)};ce.set(G.ITelemetryService,new O.SyncDescriptor(K.TelemetryService,[Te],!1))}else ce.set(G.ITelemetryService,J.NullTelemetryService);return[new x.InstantiationService(ce),Ne]}g(ce){(0,I.setUnexpectedErrorHandler)(ve=>{const Se=(0,R.toErrorMessage)(ve,!0);!Se||ce.error(`[uncaught exception in CLI]: ${Se}`)}),process.on("uncaughtException",ve=>{(0,I.isSigPipeError)(ve)||(0,I.onUnexpectedError)(ve)}),process.on("unhandledRejection",ve=>(0,I.onUnexpectedError)(ve))}async h(ce,ve,Se,Le){let Fe;if(ce.args.profile&&(Fe=Se.profiles.find(X=>X.name===ce.args.profile),!Fe))throw new Error(`Profile '${ce.args.profile}' not found.`);const q=(Fe??Se.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(ce,ve,this.b["install-source"]);if(this.b["list-extensions"])return Le.createInstance(s.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,q);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const X={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:q};return Le.createInstance(s.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],X,!!this.b.force)}else{if(this.b["uninstall-extension"])return Le.createInstance(s.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,q);if(this.b["locate-extension"])return Le.createInstance(s.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,C.buildTelemetryMessage)(ce.appRoot,ce.extensionsPath))}}i(ce){return ce.map(ve=>/\.vsix$/i.test(ve)?v.URI.file((0,c.isAbsolute)(ve)?ve:(0,c.join)((0,w.cwd)(),ve)):ve)}async j(ce,ve,Se){await ve.writeFile(v.URI.file(ce.installSourcePath),D.VSBuffer.fromString(Se.slice(0,30)))}}async function ge(me){const ce=new fe(me);try{await ce.run()}finally{ce.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e4a11014fd91da8f2d82ba144097df21a483334d/core/vs/code/node/cliProcessMain.js.map
