/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/base/common/uri","vs/base/common/types","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/network","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/parts/sandbox/node/electronTypes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","vs/platform/environment/node/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/ipc/node/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionTipsService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/node/sharedProcess/sharedProcessMain"],oe=function(_){for(var e=[],L=0,O=_.length;L<O;L++)e[L]=re[_[L]];return e};define(re[61],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function L(k){return(P,C,b)=>{let I=null,w=null;if(typeof b.value=="function"?(I="value",w=b.value):typeof b.get=="function"&&(I="get",w=b.get),!w)throw new Error("not supported");b[I]=k(w,C)}}function O(k,P,C){let b=null,I=null;if(typeof C.value=="function"?(b="value",I=C.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(b="get",I=C.get),!I)throw new Error("not supported");const w=`$memoize$${P}`;C[b]=function(...y){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,y)}),this[w]}}e.memoize=O;function l(k,P,C){return L((b,I)=>{const w=`$debounce$${I}`,y=`$debounce$result$${I}`;return function(...p){this[y]||(this[y]=C?C():void 0),clearTimeout(this[w]),P&&(this[y]=P(this[y],...p),p=[this[y]]),this[w]=setTimeout(()=>{b.apply(this,p),this[y]=C?C():void 0},k)}})}e.debounce=l;function D(k,P,C){return L((b,I)=>{const w=`$throttle$timer$${I}`,y=`$throttle$result$${I}`,p=`$throttle$lastRun$${I}`,d=`$throttle$pending$${I}`;return function(...E){if(this[y]||(this[y]=C?C():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),P&&(this[y]=P(this[y],...E)),this[d])return;const c=this[p]+k;c<=Date.now()?(this[p]=Date.now(),b.apply(this,[this[y]]),this[y]=C?C():void 0):(this[d]=!0,this[w]=setTimeout(()=>{this[d]=!1,this[p]=Date.now(),b.apply(this,[this[y]]),this[y]=C?C():void 0},c-Date.now()))}})}e.throttle=D}),define(re[9],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?S.isErrorNoTelemetry(r)?new S(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(t=>{t(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.ErrorHandler=L,e.errorHandler=new L;function O(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=O;function l(i){if(!i||typeof i!="object")return!1;const r=i;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function D(i){b(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=D;function k(i){b(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=k;function P(i){if(i instanceof Error){const{name:r,message:t}=i,n=i.stacktrace||i.stack;return{$isError:!0,name:r,message:t,stack:n,noTelemetry:S.isErrorNoTelemetry(i)}}return i}e.transformErrorForSerialization=P;const C="Canceled";function b(i){return i instanceof I?!0:i instanceof Error&&i.name===C&&i.message===C}e.isCancellationError=b;class I extends Error{constructor(){super(C),this.name=this.message}}e.CancellationError=I;function w(){const i=new Error(C);return i.name=i.message,i}e.canceled=w;function y(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=y;function p(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=p;function d(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function E(i){const r=new Error(`${i} has been disposed`);return r.name="DISPOSED",r}e.disposed=E;function c(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=c;class u extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=u;class g extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=g;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=f;class S extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof S)return r;const t=new S;return t.message=r.message,t.stack=r.stack,t}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=S;class R extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,R.prototype);debugger}}e.BugIndicatingError=R}),define(re[21],oe([0,1,9]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function O(K,Q=0){return K[K.length-(1+Q)]}e.tail=O;function l(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.tail2=l;function D(K,Q,ie=(le,he)=>le===he){if(K===Q)return!0;if(!K||!Q||K.length!==Q.length)return!1;for(let le=0,he=K.length;le<he;le++)if(!ie(K[le],Q[le]))return!1;return!0}e.equals=D;function k(K,Q){const ie=K.length-1;Q<ie&&(K[Q]=K[ie]),K.pop()}e.removeFastWithoutKeepingOrder=k;function P(K,Q,ie){return C(K.length,le=>ie(K[le],Q))}e.binarySearch=P;function C(K,Q){let ie=0,le=K-1;for(;ie<=le;){const he=(ie+le)/2|0,pe=Q(he);if(pe<0)ie=he+1;else if(pe>0)le=he-1;else return he}return-(ie+1)}e.binarySearch2=C;function b(K,Q){let ie=0,le=K.length;if(le===0)return 0;for(;ie<le;){const he=Math.floor((ie+le)/2);Q(K[he])?le=he:ie=he+1}return ie}e.findFirstInSorted=b;function I(K,Q,ie){if(K=K|0,K>=Q.length)throw new TypeError("invalid index");const le=Q[Math.floor(Q.length*Math.random())],he=[],pe=[],me=[];for(const be of Q){const Ce=ie(be,le);Ce<0?he.push(be):Ce>0?pe.push(be):me.push(be)}return K<he.length?I(K,he,ie):K<he.length+me.length?me[0]:I(K-(he.length+me.length),pe,ie)}e.quickSelect=I;function w(K,Q){const ie=[];let le;for(const he of K.slice(0).sort(Q))!le||Q(le[0],he)!==0?(le=[he],ie.push(le)):le.push(he);return ie}e.groupBy=w;function y(K,Q,ie){const le=[];function he(be,Ce,De){if(Ce===0&&De.length===0)return;const ke=le[le.length-1];ke&&ke.start+ke.deleteCount===be?(ke.deleteCount+=Ce,ke.toInsert.push(...De)):le.push({start:be,deleteCount:Ce,toInsert:De})}let pe=0,me=0;for(;;){if(pe===K.length){he(pe,0,Q.slice(me));break}if(me===Q.length){he(pe,K.length-pe,[]);break}const be=K[pe],Ce=Q[me],De=ie(be,Ce);De===0?(pe+=1,me+=1):De<0?(he(pe,1,[]),pe+=1):De>0&&(he(pe,0,[Ce]),me+=1)}return le}e.sortedDiff=y;function p(K,Q,ie){const le=y(K,Q,ie),he=[],pe=[];for(const me of le)he.push(...K.slice(me.start,me.start+me.deleteCount)),pe.push(...me.toInsert);return{removed:he,added:pe}}e.delta=p;function d(K,Q,ie){if(ie===0)return[];const le=K.slice(0,ie).sort(Q);return c(K,Q,le,ie,K.length),le}e.top=d;function E(K,Q,ie,le,he){return ie===0?Promise.resolve([]):new Promise((pe,me)=>{(async()=>{const be=K.length,Ce=K.slice(0,ie).sort(Q);for(let De=ie,ke=Math.min(ie+le,be);De<be;De=ke,ke=Math.min(ke+le,be)){if(De>ie&&await new Promise(We=>setTimeout(We)),he&&he.isCancellationRequested)throw new L.CancellationError;c(K,Q,Ce,De,ke)}return Ce})().then(pe,me)})}e.topAsync=E;function c(K,Q,ie,le,he){for(const pe=ie.length;le<he;le++){const me=K[le];if(Q(me,ie[pe-1])<0){ie.pop();const be=b(ie,Ce=>Q(me,Ce)<0);ie.splice(be,0,me)}}}function u(K){return K.filter(Q=>!!Q)}e.coalesce=u;function g(K){let Q=0;for(let ie=0;ie<K.length;ie++)K[ie]&&(K[Q]=K[ie],Q+=1);K.length=Q}e.coalesceInPlace=g;function f(K,Q,ie){K.splice(ie,0,K.splice(Q,1)[0])}e.move=f;function S(K){return!Array.isArray(K)||K.length===0}e.isFalsyOrEmpty=S;function R(K){return Array.isArray(K)&&K.length>0}e.isNonEmptyArray=R;function i(K,Q=ie=>ie){const ie=new Set;return K.filter(le=>{const he=Q(le);return ie.has(he)?!1:(ie.add(he),!0)})}e.distinct=i;function r(K){const Q=new Set;return ie=>{const le=K(ie);return Q.has(le)?!1:(Q.add(le),!0)}}e.uniqueFilter=r;function t(K,Q){const ie=n(K,Q);if(ie!==-1)return K[ie]}e.findLast=t;function n(K,Q){for(let ie=K.length-1;ie>=0;ie--){const le=K[ie];if(Q(le))return ie}return-1}e.lastIndex=n;function s(K,Q){return K.length>0?K[0]:Q}e.firstOrDefault=s;function a(K,Q){return K.length>0?K[K.length-1]:Q}e.lastOrDefault=a;function o(K,Q,ie=(le,he)=>le===he){let le=0;for(let he=0,pe=Math.min(K.length,Q.length);he<pe&&ie(K[he],Q[he]);he++)le++;return le}e.commonPrefixLength=o;function h(K){return[].concat(...K)}e.flatten=h;function m(K,Q){let ie=typeof Q=="number"?K:0;typeof Q=="number"?ie=K:(ie=0,Q=K);const le=[];if(ie<=Q)for(let he=ie;he<Q;he++)le.push(he);else for(let he=ie;he>Q;he--)le.push(he);return le}e.range=m;function v(K,Q,ie){return K.reduce((le,he)=>(le[Q(he)]=ie?ie(he):he,le),Object.create(null))}e.index=v;function A(K,Q){return K.push(Q),()=>T(K,Q)}e.insert=A;function T(K,Q){const ie=K.indexOf(Q);if(ie>-1)return K.splice(ie,1),Q}e.remove=T;function M(K,Q,ie){const le=K.slice(0,Q),he=K.slice(Q);return le.concat(ie,he)}e.arrayInsert=M;function z(K,Q){let ie;if(typeof Q=="number"){let le=Q;ie=()=>{const he=Math.sin(le++)*179426549;return he-Math.floor(he)}}else ie=Math.random;for(let le=K.length-1;le>0;le-=1){const he=Math.floor(ie()*(le+1)),pe=K[le];K[le]=K[he],K[he]=pe}}e.shuffle=z;function H(K,Q){const ie=K.indexOf(Q);ie>-1&&(K.splice(ie,1),K.unshift(Q))}e.pushToStart=H;function J(K,Q){const ie=K.indexOf(Q);ie>-1&&(K.splice(ie,1),K.push(Q))}e.pushToEnd=J;function W(K,Q){for(const ie of Q)K.push(ie)}e.pushMany=W;function N(K,Q){return Array.isArray(K)?K.map(Q):Q(K)}e.mapArrayOrNot=N;function j(K){return Array.isArray(K)?K:[K]}e.asArray=j;function q(K){return K[Math.floor(Math.random()*K.length)]}e.getRandomElement=q;function x(K,Q){for(const ie of K){const le=Q(ie);if(le!==void 0)return le}}e.mapFind=x;function Y(K,Q,ie){const le=Z(K,Q),he=K.length,pe=ie.length;K.length=he+pe;for(let me=he-1;me>=le;me--)K[me+pe]=K[me];for(let me=0;me<pe;me++)K[me+le]=ie[me]}e.insertInto=Y;function F(K,Q,ie,le){const he=Z(K,Q),pe=K.splice(he,ie);return Y(K,he,le),pe}e.splice=F;function Z(K,Q){return Q<0?Math.max(Q+K.length,0):Math.min(Q,K.length)}var te;(function(K){function Q(he){return he<0}K.isLessThan=Q;function ie(he){return he>0}K.isGreaterThan=ie;function le(he){return he===0}K.isNeitherLessOrGreaterThan=le,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(te=e.CompareResult||(e.CompareResult={}));function se(K,Q){return(ie,le)=>Q(K(ie),K(le))}e.compareBy=se;function ae(...K){return(Q,ie)=>{for(const le of K){const he=le(Q,ie);if(!te.isNeitherLessOrGreaterThan(he))return he}return te.neitherLessOrGreaterThan}}e.tieBreakComparators=ae;const V=(K,Q)=>K-Q;e.numberComparator=V;function B(K,Q){if(K.length===0)return;let ie=K[0];for(let le=1;le<K.length;le++){const he=K[le];Q(he,ie)>0&&(ie=he)}return ie}e.findMaxBy=B;function U(K,Q){if(K.length===0)return;let ie=K[0];for(let le=1;le<K.length;le++){const he=K[le];Q(he,ie)>=0&&(ie=he)}return ie}e.findLastMaxBy=U;function $(K,Q){return B(K,(ie,le)=>-Q(ie,le))}e.findMinBy=$;class G{constructor(Q){this.f=Q,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let ie=this.c;for(;ie<this.f.length&&Q(this.f[ie]);)ie++;const le=ie===this.c?null:this.f.slice(this.c,ie);return this.c=ie,le}takeFromEndWhile(Q){let ie=this.d;for(;ie>=0&&Q(this.f[ie]);)ie--;const le=ie===this.d?null:this.f.slice(ie+1,this.d+1);return this.d=ie,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Q=this.f[this.c];return this.c++,Q}removeLast(){const Q=this.f[this.d];return this.d--,Q}takeCount(Q){const ie=this.f.slice(this.c,this.c+Q);return this.c+=Q,ie}}e.ArrayQueue=G;class ee{constructor(Q){this.iterate=Q}forEach(Q){this.iterate(ie=>(Q(ie),!0))}toArray(){const Q=[];return this.iterate(ie=>(Q.push(ie),!0)),Q}filter(Q){return new ee(ie=>this.iterate(le=>Q(le)?ie(le):!0))}map(Q){return new ee(ie=>this.iterate(le=>ie(Q(le))))}some(Q){let ie=!1;return this.iterate(le=>(ie=Q(le),!ie)),ie}findFirst(Q){let ie;return this.iterate(le=>Q(le)?(ie=le,!1):!0),ie}findLast(Q){let ie;return this.iterate(le=>(Q(le)&&(ie=le),!0)),ie}findLastMaxBy(Q){let ie,le=!0;return this.iterate(he=>((le||te.isGreaterThan(Q(he,ie)))&&(le=!1,ie=he),!0)),ie}}ee.empty=new ee(K=>{}),e.CallbackIterable=ee}),define(re[129],oe([0,1,9]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(C,b){if(!C)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=O;function l(C,b="Unreachable"){throw new Error(b)}e.assertNever=l;function D(C){if(!C)throw new L.BugIndicatingError("Assertion Failed")}e.assert=D;function k(C){if(!C()){debugger;C(),(0,L.onUnexpectedError)(new L.BugIndicatingError("Assertion Failed"))}}e.assertFn=k;function P(C,b){let I=0;for(;I<C.length-1;){const w=C[I],y=C[I+1];if(!b(w,y))return!1;I++}return!0}e.checkAdjacentItems=P}),define(re[81],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(O){const l=this;let D=!1,k;return function(){return D||(D=!0,k=O.apply(l,arguments)),k}}e.once=L}),define(re[62],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(O){function l(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}O.is=l;const D=Object.freeze([]);function k(){return D}O.empty=k;function*P(S){yield S}O.single=P;function C(S){return l(S)?S:P(S)}O.wrap=C;function b(S){return S||D}O.from=b;function I(S){return!S||S[Symbol.iterator]().next().done===!0}O.isEmpty=I;function w(S){return S[Symbol.iterator]().next().value}O.first=w;function y(S,R){for(const i of S)if(R(i))return!0;return!1}O.some=y;function p(S,R){for(const i of S)if(R(i))return i}O.find=p;function*d(S,R){for(const i of S)R(i)&&(yield i)}O.filter=d;function*E(S,R){let i=0;for(const r of S)yield R(r,i++)}O.map=E;function*c(...S){for(const R of S)for(const i of R)yield i}O.concat=c;function u(S,R,i){let r=i;for(const t of S)r=R(r,t);return r}O.reduce=u;function*g(S,R,i=S.length){for(R<0&&(R+=S.length),i<0?i+=S.length:i>S.length&&(i=S.length);R<i;R++)yield S[R]}O.slice=g;function f(S,R=Number.POSITIVE_INFINITY){const i=[];if(R===0)return[i,S];const r=S[Symbol.iterator]();for(let t=0;t<R;t++){const n=r.next();if(n.done)return[i,O.empty()];i.push(n.value)}return[i,{[Symbol.iterator](){return r}}]}O.consume=f})(L=e.Iterable||(e.Iterable={}))}),define(re[35],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var O;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(O=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(i){i.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function k(i,r=!1){let t=0;const n=i.length;let s="",a=0,o=16,h=0;function m(J){let W=0,N=0;for(;W<J;){const j=i.charCodeAt(t);if(j>=48&&j<=57)N=N*16+j-48;else if(j>=65&&j<=70)N=N*16+j-65+10;else if(j>=97&&j<=102)N=N*16+j-97+10;else break;t++,W++}return W<J&&(N=-1),N}function v(J){t=J,s="",a=0,o=16,h=0}function A(){const J=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&b(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&b(i.charCodeAt(t)))for(t++;t<i.length&&b(i.charCodeAt(t));)t++;else return h=3,i.substring(J,t);let W=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&b(i.charCodeAt(t))){for(t++;t<i.length&&b(i.charCodeAt(t));)t++;W=t}else h=3;return i.substring(J,W)}function T(){let J="",W=t;for(;;){if(t>=n){J+=i.substring(W,t),h=2;break}const N=i.charCodeAt(t);if(N===34){J+=i.substring(W,t),t++;break}if(N===92){if(J+=i.substring(W,t),t++,t>=n){h=2;break}switch(i.charCodeAt(t++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const q=m(4);q>=0?J+=String.fromCharCode(q):h=4;break}default:h=5}W=t;continue}if(N>=0&&N<=31)if(C(N)){J+=i.substring(W,t),h=2;break}else h=6;t++}return J}function M(){if(s="",h=0,a=t,t>=n)return a=n,o=17;let J=i.charCodeAt(t);if(P(J)){do t++,s+=String.fromCharCode(J),J=i.charCodeAt(t);while(P(J));return o=15}if(C(J))return t++,s+=String.fromCharCode(J),J===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),o=14;switch(J){case 123:return t++,o=1;case 125:return t++,o=2;case 91:return t++,o=3;case 93:return t++,o=4;case 58:return t++,o=6;case 44:return t++,o=5;case 34:return t++,s=T(),o=10;case 47:{const W=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!C(i.charCodeAt(t));)t++;return s=i.substring(W,t),o=12}if(i.charCodeAt(t+1)===42){t+=2;const N=n-1;let j=!1;for(;t<N;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,j=!0;break}t++}return j||(t++,h=1),s=i.substring(W,t),o=13}return s+=String.fromCharCode(J),t++,o=16}case 45:if(s+=String.fromCharCode(J),t++,t===n||!b(i.charCodeAt(t)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=A(),o=11;default:for(;t<n&&z(J);)t++,J=i.charCodeAt(t);if(a!==t){switch(s=i.substring(a,t),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(J),t++,o=16}}function z(J){if(P(J)||C(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let J;do J=M();while(J>=12&&J<=15);return J}return{setPosition:v,getPosition:()=>t,scan:r?H:M,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>t-a,getTokenError:()=>h}}e.createScanner=k;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function C(i){return i===10||i===13||i===8232||i===8233}function b(i){return i>=48&&i<=57}var I;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(I||(I={}));function w(i,r){const t=[],n=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function h(m,v,A,T){a.value=m,a.offset=v,a.length=A,a.type=T,a.colonOffset=void 0,s=a}try{f(i,{onObjectBegin:(m,v)=>{if(r<=m)throw n;s=void 0,o=r>m,t.push("")},onObjectProperty:(m,v,A)=>{if(r<v||(h(m,v,A,"property"),t[t.length-1]=m,r<=v+A))throw n},onObjectEnd:(m,v)=>{if(r<=m)throw n;s=void 0,t.pop()},onArrayBegin:(m,v)=>{if(r<=m)throw n;s=void 0,t.push(0)},onArrayEnd:(m,v)=>{if(r<=m)throw n;s=void 0,t.pop()},onLiteralValue:(m,v,A)=>{if(r<v||(h(m,v,A,R(m)),r<=v+A))throw n},onSeparator:(m,v,A)=>{if(r<=v)throw n;if(m===":"&&s&&s.type==="property")s.colonOffset=v,o=!1,s=void 0;else if(m===","){const T=t[t.length-1];typeof T=="number"?t[t.length-1]=T+1:(o=!0,t[t.length-1]=""),s=void 0}}})}catch(m){if(m!==n)throw m}return{path:t,previousNode:s,isAtPropertyKey:o,matches:m=>{let v=0;for(let A=0;v<m.length&&A<t.length;A++)if(m[v]===t[A]||m[v]==="*")v++;else if(m[v]!=="**")return!1;return v===m.length}}}e.getLocation=w;function y(i,r=[],t=D.DEFAULT){let n=null,s=[];const a=[];function o(m){Array.isArray(s)?s.push(m):n!==null&&(s[n]=m)}return f(i,{onObjectBegin:()=>{const m={};o(m),a.push(s),s=m,n=null},onObjectProperty:m=>{n=m},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const m=[];o(m),a.push(s),s=m,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:o,onError:(m,v,A)=>{r.push({error:m,offset:v,length:A})}},t),s[0]}e.parse=y;function p(i,r=[],t=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(m){n.type==="property"&&(n.length=m-n.offset,n=n.parent)}function a(m){return n.children.push(m),m}f(i,{onObjectBegin:m=>{n=a({type:"object",offset:m,length:-1,parent:n,children:[]})},onObjectProperty:(m,v,A)=>{n=a({type:"property",offset:v,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:m,offset:v,length:A,parent:n})},onObjectEnd:(m,v)=>{n.length=m+v-n.offset,n=n.parent,s(m+v)},onArrayBegin:(m,v)=>{n=a({type:"array",offset:m,length:-1,parent:n,children:[]})},onArrayEnd:(m,v)=>{n.length=m+v-n.offset,n=n.parent,s(m+v)},onLiteralValue:(m,v,A)=>{a({type:R(m),offset:v,length:A,parent:n,value:m}),s(v+A)},onSeparator:(m,v,A)=>{n.type==="property"&&(m===":"?n.colonOffset=v:m===","&&s(v))},onError:(m,v,A)=>{r.push({error:m,offset:v,length:A})}},t);const h=n.children[0];return h&&delete h.parent,h}e.parseTree=p;function d(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const a of t.children)if(Array.isArray(a.children)&&a.children[0].value===n){t=a.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=d;function E(i){if(!i.parent||!i.parent.children)return[];const r=E(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}e.getNodePath=E;function c(i){switch(i.type){case"array":return i.children.map(c);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=c(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=c;function u(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}e.contains=u;function g(i,r,t=!1){if(u(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const a=g(n[s],r,t);if(a)return a}return i}}e.findNodeAtOffset=g;function f(i,r,t=D.DEFAULT){const n=k(i,!1);function s(se){return se?()=>se(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(se){return se?ae=>se(ae,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=s(r.onObjectBegin),h=a(r.onObjectProperty),m=s(r.onObjectEnd),v=s(r.onArrayBegin),A=s(r.onArrayEnd),T=a(r.onLiteralValue),M=a(r.onSeparator),z=s(r.onComment),H=a(r.onError),J=t&&t.disallowComments,W=t&&t.allowTrailingComma;function N(){for(;;){const se=n.scan();switch(n.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:J||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(se){case 12:case 13:J?j(10):z();break;case 16:j(1);break;case 15:case 14:break;default:return se}}}function j(se,ae=[],V=[]){if(H(se),ae.length+V.length>0){let B=n.getToken();for(;B!==17;){if(ae.indexOf(B)!==-1){N();break}else if(V.indexOf(B)!==-1)break;B=N()}}}function q(se){const ae=n.getTokenValue();return se?T(ae):h(ae),N(),!0}function x(){switch(n.getToken()){case 11:{let se=0;try{se=JSON.parse(n.getTokenValue()),typeof se!="number"&&(j(2),se=0)}catch{j(2)}T(se);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return N(),!0}function Y(){return n.getToken()!==10?(j(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(M(":"),N(),te()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function F(){o(),N();let se=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(se||j(4,[],[]),M(","),N(),n.getToken()===2&&W)break}else se&&j(6,[],[]);Y()||j(4,[],[2,5]),se=!0}return m(),n.getToken()!==2?j(7,[2],[]):N(),!0}function Z(){v(),N();let se=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(se||j(4,[],[]),M(","),N(),n.getToken()===4&&W)break}else se&&j(6,[],[]);te()||j(4,[],[4,5]),se=!0}return A(),n.getToken()!==4?j(8,[4],[]):N(),!0}function te(){switch(n.getToken()){case 3:return Z();case 1:return F();case 10:return q(!0);default:return x()}}return N(),n.getToken()===17?t.allowEmptyContent?!0:(j(4,[],[]),!1):te()?(n.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=f;function S(i,r){const t=k(i),n=[];let s,a=0,o;do switch(o=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:a!==o&&n.push(i.substring(a,o)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),a=t.getPosition();break}while(s!==17);return n.join("")}e.stripComments=S;function R(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=R}),define(re[42],oe([0,1,35]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function O(b,I,w){let y,p,d,E,c;if(I){for(E=I.offset,c=E+I.length,d=E;d>0&&!C(b,d-1);)d--;let o=c;for(;o<b.length&&!C(b,o);)o++;p=b.substring(d,o),y=k(p,w)}else p=b,y=0,d=0,E=0,c=b.length;const u=P(w,b);let g=!1,f=0,S;w.insertSpaces?S=D(" ",w.tabSize||4):S="	";const R=(0,L.createScanner)(p,!1);let i=!1;function r(){return u+D(S,y+f)}function t(){let o=R.scan();for(g=!1;o===15||o===14;)g=g||o===14,o=R.scan();return i=o===16||R.getTokenError()!==0,o}const n=[];function s(o,h,m){!i&&h<c&&m>E&&b.substring(h,m)!==o&&n.push({offset:h,length:m-h,content:o})}let a=t();if(a!==17){const o=R.getTokenOffset()+d,h=D(S,y);s(h,d,o)}for(;a!==17;){let o=R.getTokenOffset()+R.getTokenLength()+d,h=t(),m="";for(;!g&&(h===12||h===13);){const A=R.getTokenOffset()+d;s(" ",o,A),o=R.getTokenOffset()+R.getTokenLength()+d,m=h===12?r():"",h=t()}if(h===2)a!==1&&(f--,m=r());else if(h===4)a!==3&&(f--,m=r());else{switch(a){case 3:case 1:f++,m=r();break;case 5:case 12:m=r();break;case 13:g?m=r():m=" ";break;case 6:m=" ";break;case 10:if(h===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?m=" ":h!==5&&h!==17&&(i=!0);break;case 16:i=!0;break}g&&(h===12||h===13)&&(m=r())}const v=R.getTokenOffset()+d;s(m,o,v),a=h}return n}e.format=O;function l(b,I){const w=JSON.stringify(b,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?w.replace(/\r\n|\r|\n/g,I.eol):w}e.toFormattedString=l;function D(b,I){let w="";for(let y=0;y<I;y++)w+=b;return w}function k(b,I){let w=0,y=0;const p=I.tabSize||4;for(;w<b.length;){const d=b.charAt(w);if(d===" ")y++;else if(d==="	")y+=p;else break;w++}return Math.floor(y/p)}function P(b,I){for(let w=0;w<I.length;w++){const y=I.charAt(w);if(y==="\r")return w+1<I.length&&I.charAt(w+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=P;function C(b,I){return`\r
`.indexOf(b.charAt(I))!==-1}e.isEOL=C}),define(re[82],oe([0,1,35,42]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function l(b,I,w){return D(b,I,void 0,w)}e.removeProperty=l;function D(b,I,w,y,p){const d=I.slice(),E=[],c=(0,L.parseTree)(b,E);let u,g;for(;d.length>0&&(g=d.pop(),u=(0,L.findNodeAtLocation)(c,d),u===void 0&&w!==void 0);)typeof g=="string"?w={[g]:w}:w=[w];if(u)if(u.type==="object"&&typeof g=="string"&&Array.isArray(u.children)){const f=(0,L.findNodeAtLocation)(u,[g]);if(f!==void 0)if(w===void 0){if(!f.parent)throw new Error("Malformed AST");const S=u.children.indexOf(f.parent);let R,i=f.parent.offset+f.parent.length;if(S>0){const r=u.children[S-1];R=r.offset+r.length}else R=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return k(b,{offset:R,length:i-R,content:""},y)}else return k(b,{offset:f.offset,length:f.length,content:JSON.stringify(w)},y);else{if(w===void 0)return[];const S=`${JSON.stringify(g)}: ${JSON.stringify(w)}`,R=p?p(u.children.map(r=>r.children[0].value)):u.children.length;let i;if(R>0){const r=u.children[R-1];i={offset:r.offset+r.length,length:0,content:","+S}}else u.children.length===0?i={offset:u.offset+1,length:0,content:S}:i={offset:u.offset+1,length:0,content:S+","};return k(b,i,y)}}else if(u.type==="array"&&typeof g=="number"&&Array.isArray(u.children))if(w!==void 0){const f=`${JSON.stringify(w)}`;let S;if(u.children.length===0||g===0)S={offset:u.offset+1,length:0,content:u.children.length===0?f:f+","};else{const R=g===-1||g>u.children.length?u.children.length:g,i=u.children[R-1];S={offset:i.offset+i.length,length:0,content:","+f}}return k(b,S,y)}else{const f=g,S=u.children[f];let R;if(u.children.length===1)R={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===f){const i=u.children[f-1],r=i.offset+i.length,t=u.offset+u.length;R={offset:r,length:t-2-r,content:""}}else R={offset:S.offset,length:u.children[f+1].offset-S.offset,content:""};return k(b,R,y)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${u.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return k(b,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(w)},y)}}e.setProperty=D;function k(b,I,w){let y=P(b,I),p=I.offset,d=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;p>0&&!(0,O.isEOL)(y,p-1);)p--;for(;d<y.length&&!(0,O.isEOL)(y,d);)d++}const E=(0,O.format)(y,{offset:p,length:d-p},w);for(let u=E.length-1;u>=0;u--){const g=E[u];y=P(y,g),p=Math.min(p,g.offset),d=Math.max(d,g.offset+g.length),d+=g.content.length-g.length}const c=b.length-(y.length-d)-p;return[{offset:p,length:c,content:y.substring(p,d)}]}e.withFormatting=k;function P(b,I){return b.substring(0,I.offset)+I.content+b.substring(I.offset+I.length)}e.applyEdit=P;function C(b,I){const w=I.slice(0).sort((p,d)=>{const E=p.offset-d.offset;return E===0?p.length-d.length:E});let y=b.length;for(let p=w.length-1;p>=0;p--){const d=w[p];if(d.offset+d.length<=y)b=P(b,d);else throw new Error("Overlapping edit");y=d.offset}return b}e.applyEdits=C}),define(re[130],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=L}),define(re[2],oe([0,1,81,62]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let D=null;function k(a){D=a}if(e.setDisposableTracker=k,l){const a="__is_disposable_tracked__";k(new class{trackDisposable(o){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[a]||console.log(h)},3e3)}setParent(o,h){if(o&&o!==g.None)try{o[a]=!0}catch{}}markAsDisposed(o){if(o&&o!==g.None)try{o[a]=!0}catch{}}markAsSingleton(o){}})}function P(a){return D?.trackDisposable(a),a}function C(a){D?.markAsDisposed(a)}function b(a,o){D?.setParent(a,o)}function I(a,o){if(!!D)for(const h of a)D.setParent(h,o)}function w(a){return D?.markAsSingleton(a),a}e.markAsSingleton=w;function y(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.isDisposable=y;function p(a){if(O.Iterable.is(a)){const o=[];for(const h of a)if(h)try{h.dispose()}catch(m){o.push(m)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.dispose=p;function d(a){for(const o of a)y(o)&&o.dispose();return[]}e.disposeIfDisposable=d;function E(...a){const o=c(()=>p(a));return I(a,o),o}e.combinedDisposable=E;function c(a){const o=P({dispose:(0,L.once)(()=>{C(o),a()})});return o}e.toDisposable=c;class u{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(C(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{p(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return b(o,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class g{constructor(){this.q=new u,P(this),b(this.q,this)}dispose(){C(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}g.None=Object.freeze({dispose(){}}),e.Disposable=g;class f{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&b(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,C(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&b(o,null),o}}e.MutableDisposable=f;class S{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(o){let h=o;return this.unset=()=>h=void 0,this.isset=()=>h!==void 0,this.dispose=()=>{h&&(h(),h=void 0,C(this))},this}}e.SafeDisposable=R;class i{constructor(){this.a=new Map}acquire(o,...h){let m=this.a.get(o);m||(m={counter:0,object:this.b(o,...h)},this.a.set(o,m));const{object:v}=m,A=(0,L.once)(()=>{--m.counter===0&&(this.c(o,m.object),this.a.delete(o))});return m.counter++,{object:v,dispose:A}}}e.ReferenceCollection=i;class r{constructor(o){this.a=o}async acquire(o,...h){const m=this.a.acquire(o,...h);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(v){throw m.dispose(),v}}}e.AsyncReferenceCollection=r;class t{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=t;function n(a){const o=new u;try{a(o)}finally{o.dispose()}}e.disposeOnReturn=n;class s{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){C(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{p(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,h,m=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),m||this.a.get(o)?.dispose(),this.a.set(o,h)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(re[83],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(D){this.element=D,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class O{constructor(){this.a=L.Undefined,this.b=L.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===L.Undefined}clear(){let D=this.a;for(;D!==L.Undefined;){const k=D.next;D.prev=L.Undefined,D.next=L.Undefined,D=k}this.a=L.Undefined,this.b=L.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,k){const P=new L(D);if(this.a===L.Undefined)this.a=P,this.b=P;else if(k){const b=this.b;this.b=P,P.prev=b,b.next=P}else{const b=this.a;this.a=P,P.next=b,b.prev=P}this.c+=1;let C=!1;return()=>{C||(C=!0,this.e(P))}}shift(){if(this.a!==L.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==L.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==L.Undefined&&D.next!==L.Undefined){const k=D.prev;k.next=D.next,D.next.prev=k}else D.prev===L.Undefined&&D.next===L.Undefined?(this.a=L.Undefined,this.b=L.Undefined):D.next===L.Undefined?(this.b=this.b.prev,this.b.next=L.Undefined):D.prev===L.Undefined&&(this.a=this.a.next,this.a.prev=L.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==L.Undefined;)yield D.element,D=D.next}}e.LinkedList=O}),define(re[37],oe([0,1]),function(_,e){"use strict";var L,O,l;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function D(E,c,u){let g=E.get(c);return g===void 0&&(g=u,E.set(c,g)),g}e.getOrSet=D;function k(E){const c=[];return E.forEach((u,g)=>{c.push(`${g} => ${u}`)}),`Map(${E.size}) {${c.join(", ")}}`}e.mapToString=k;function P(E){const c=[];return E.forEach(u=>{c.push(u)}),`Set(${E.size}) {${c.join(", ")}}`}e.setToString=P;class C{constructor(c,u){this.uri=c,this.value=u}}class b{constructor(c,u){this[L]="ResourceMap",c instanceof b?(this.b=new Map(c.b),this.c=u??b.a):(this.b=new Map,this.c=c??b.a)}set(c,u){return this.b.set(this.c(c),new C(c,u)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,u){typeof u<"u"&&(c=c.bind(u));for(const[g,f]of this.b)c(f.value,f.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}b.a=E=>E.toString(),e.ResourceMap=b;class I{constructor(c,u){this[O]="ResourceSet",!c||typeof c=="function"?this.a=new b(c):(this.a=new b(u),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,u){this.a.forEach((g,f)=>c.call(u,f,f,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=I;var w;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class y{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,u=0){const g=this.a.get(c);if(!!g)return u!==0&&this.j(g,u),g.value}set(c,u,g=0){let f=this.a.get(c);if(f)f.value=u,g!==0&&this.j(f,g);else{switch(f={key:c,value:u,next:void 0,previous:void 0},g){case 0:this.h(f);break;case 1:this.g(f);break;case 2:this.h(f);break;default:this.h(f);break}this.a.set(c,f),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const u=this.a.get(c);if(!!u)return this.a.delete(c),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,u){const g=this.e;let f=this.b;for(;f;){if(u?c.bind(u)(f.value,f.key,this):c(f.value,f.key,this),this.e!==g)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const c=this,u=this.e;let g=this.b;const f={[Symbol.iterator](){return f},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(g){const S={value:g.key,done:!1};return g=g.next,S}else return{value:void 0,done:!0}}};return f}values(){const c=this,u=this.e;let g=this.b;const f={[Symbol.iterator](){return f},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(g){const S={value:g.value,done:!1};return g=g.next,S}else return{value:void 0,done:!0}}};return f}entries(){const c=this,u=this.e;let g=this.b;const f={[Symbol.iterator](){return f},next(){if(c.e!==u)throw new Error("LinkedMap got modified during iteration.");if(g){const S={value:[g.key,g.value],done:!1};return g=g.next,S}else return{value:void 0,done:!0}}};return f}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let u=this.b,g=this.size;for(;u&&g>c;)this.a.delete(u.key),u=u.next,g--;this.b=u,this.d=g,u&&(u.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const u=c.next,g=c.previous;if(!u||!g)throw new Error("Invalid list");u.previous=g,g.next=u}c.next=void 0,c.previous=void 0,this.e++}j(c,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(c===this.b)return;const g=c.next,f=c.previous;c===this.c?(f.next=void 0,this.c=f):(g.previous=f,f.next=g),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(u===2){if(c===this.c)return;const g=c.next,f=c.previous;c===this.b?(g.previous=void 0,this.b=g):(g.previous=f,f.next=g),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((u,g)=>{c.push([g,u])}),c}fromJSON(c){this.clear();for(const[u,g]of c)this.set(u,g)}}e.LinkedMap=y;class p extends y{constructor(c,u=1){super(),this.k=c,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,u=2){return super.get(c,u)}peek(c){return super.get(c,0)}set(c,u){return super.set(c,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=p;class d{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let u=this.a.get(c)||0;return u===0?!1:(u--,u===0?this.a.delete(c):this.a.set(c,u),!0)}has(c){return this.a.has(c)}}e.CounterSet=d}),define(re[84],oe([0,1,37]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const O=new L.LRUCache(1e4);function l(b){return C(b,"NFC",O)}e.normalizeNFC=l;const D=new L.LRUCache(1e4);function k(b){return C(b,"NFD",D)}e.normalizeNFD=k;const P=/[^\u0000-\u0080]/;function C(b,I,w){if(!b)return b;const y=w.get(b);if(y)return y;let p;return P.test(b)?p=b.normalize(I):p=b,w.set(b,p),p}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(I){return k(I).replace(b,"")}}()}),define(re[131],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function L(P,C,b){return Math.min(Math.max(P,C),b)}e.clamp=L;function O(P,C){return(C+P%C)%C}e.rot=O;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class D{constructor(){this.a=1,this.b=0}update(C){return this.b=this.b+(C-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=D;class k{constructor(C){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(C),this.c.fill(0,0,C)}update(C){const b=this.c[this.d];return this.c[this.d]=C,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=C,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=k}),function(){function _(l){const D=[];typeof l=="number"&&D.push("code/timeOrigin",l);function k(C){D.push(C,Date.now())}function P(){const C=[];for(let b=0;b<D.length;b+=2)C.push({name:D[b],startTime:D[b+1]});return C}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const k of performance.getEntriesByType("mark"))D.push({name:k.name,startTime:Math.round(l+k.startTime)});return D}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function L(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=L(O))}(),function(_,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var O in L)(typeof exports=="object"?exports:_)[O]=L[O]}}(typeof self<"u"?self:this,function(){return function(_){var e={};function L(O){if(e[O])return e[O].exports;var l=e[O]={i:O,l:!1,exports:{}};return _[O].call(l.exports,l,l.exports,L),l.l=!0,l.exports}return L.m=_,L.c=e,L.d=function(O,l,D){L.o(O,l)||Object.defineProperty(O,l,{enumerable:!0,get:D})},L.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},L.t=function(O,l){if(1&l&&(O=L(O)),8&l||4&l&&typeof O=="object"&&O&&O.__esModule)return O;var D=Object.create(null);if(L.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:O}),2&l&&typeof O!="string")for(var k in O)L.d(D,k,function(P){return O[P]}.bind(null,k));return D},L.n=function(O){var l=O&&O.__esModule?function(){return O.default}:function(){return O};return L.d(l,"a",l),l},L.o=function(O,l){return Object.prototype.hasOwnProperty.call(O,l)},L.p="",L(L.s=0)}([function(_,e,L){(function(O){var l;e=_.exports=V,l=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],C=e.src=[],b=0,I=b++;C[I]="0|[1-9]\\d*";var w=b++;C[w]="[0-9]+";var y=b++;C[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=b++;C[p]="("+C[I]+")\\.("+C[I]+")\\.("+C[I]+")";var d=b++;C[d]="("+C[w]+")\\.("+C[w]+")\\.("+C[w]+")";var E=b++;C[E]="(?:"+C[I]+"|"+C[y]+")";var c=b++;C[c]="(?:"+C[w]+"|"+C[y]+")";var u=b++;C[u]="(?:-("+C[E]+"(?:\\."+C[E]+")*))";var g=b++;C[g]="(?:-?("+C[c]+"(?:\\."+C[c]+")*))";var f=b++;C[f]="[0-9A-Za-z-]+";var S=b++;C[S]="(?:\\+("+C[f]+"(?:\\."+C[f]+")*))";var R=b++,i="v?"+C[p]+C[u]+"?"+C[S]+"?";C[R]="^"+i+"$";var r="[v=\\s]*"+C[d]+C[g]+"?"+C[S]+"?",t=b++;C[t]="^"+r+"$";var n=b++;C[n]="((?:<|>)?=?)";var s=b++;C[s]=C[w]+"|x|X|\\*";var a=b++;C[a]=C[I]+"|x|X|\\*";var o=b++;C[o]="[v=\\s]*("+C[a]+")(?:\\.("+C[a]+")(?:\\.("+C[a]+")(?:"+C[u]+")?"+C[S]+"?)?)?";var h=b++;C[h]="[v=\\s]*("+C[s]+")(?:\\.("+C[s]+")(?:\\.("+C[s]+")(?:"+C[g]+")?"+C[S]+"?)?)?";var m=b++;C[m]="^"+C[n]+"\\s*"+C[o]+"$";var v=b++;C[v]="^"+C[n]+"\\s*"+C[h]+"$";var A=b++;C[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=b++;C[T]="(?:~>?)";var M=b++;C[M]="(\\s*)"+C[T]+"\\s+",P[M]=new RegExp(C[M],"g");var z=b++;C[z]="^"+C[T]+C[o]+"$";var H=b++;C[H]="^"+C[T]+C[h]+"$";var J=b++;C[J]="(?:\\^)";var W=b++;C[W]="(\\s*)"+C[J]+"\\s+",P[W]=new RegExp(C[W],"g");var N=b++;C[N]="^"+C[J]+C[o]+"$";var j=b++;C[j]="^"+C[J]+C[h]+"$";var q=b++;C[q]="^"+C[n]+"\\s*("+r+")$|^$";var x=b++;C[x]="^"+C[n]+"\\s*("+i+")$|^$";var Y=b++;C[Y]="(\\s*)"+C[n]+"\\s*("+r+"|"+C[o]+")",P[Y]=new RegExp(C[Y],"g");var F=b++;C[F]="^\\s*("+C[o]+")\\s+-\\s+("+C[o]+")\\s*$";var Z=b++;C[Z]="^\\s*("+C[h]+")\\s+-\\s+("+C[h]+")\\s*$";var te=b++;C[te]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)l(se,C[se]),P[se]||(P[se]=new RegExp(C[se]));function ae(ce,fe){if(ce instanceof V)return ce;if(typeof ce!="string"||ce.length>D||!(fe?P[t]:P[R]).test(ce))return null;try{return new V(ce,fe)}catch{return null}}function V(ce,fe){if(ce instanceof V){if(ce.loose===fe)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof V))return new V(ce,fe);l("SemVer",ce,fe),this.loose=fe;var de=ce.trim().match(fe?P[t]:P[R]);if(!de)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Pe=+Ie;if(Pe>=0&&Pe<k)return Pe}return Ie}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ce,fe){var de=ae(ce,fe);return de?de.version:null},e.clean=function(ce,fe){var de=ae(ce.trim().replace(/^[=v]+/,""),fe);return de?de.version:null},e.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(ce){return l("SemVer.compare",this.version,this.loose,ce),ce instanceof V||(ce=new V(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},V.prototype.compareMain=function(ce){return ce instanceof V||(ce=new V(ce,this.loose)),U(this.major,ce.major)||U(this.minor,ce.minor)||U(this.patch,ce.patch)},V.prototype.comparePre=function(ce){if(ce instanceof V||(ce=new V(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var fe=0;do{var de=this.prerelease[fe],Ie=ce.prerelease[fe];if(l("prerelease compare",fe,de,Ie),de===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(de===void 0)return-1;if(de!==Ie)return U(de,Ie)}while(++fe)},V.prototype.inc=function(ce,fe){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,fe,de,Ie){typeof de=="string"&&(Ie=de,de=void 0);try{return new V(ce,de).inc(fe,Ie).version}catch{return null}},e.diff=function(ce,fe){if(K(ce,fe))return null;var de=ae(ce),Ie=ae(fe);if(de.prerelease.length||Ie.prerelease.length){for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==Ie[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==Ie[Pe])return Pe},e.compareIdentifiers=U;var B=/^[0-9]+$/;function U(ce,fe){var de=B.test(ce),Ie=B.test(fe);return de&&Ie&&(ce=+ce,fe=+fe),de&&!Ie?-1:Ie&&!de?1:ce<fe?-1:ce>fe?1:0}function $(ce,fe,de){return new V(ce,de).compare(new V(fe,de))}function G(ce,fe,de){return $(ce,fe,de)>0}function ee(ce,fe,de){return $(ce,fe,de)<0}function K(ce,fe,de){return $(ce,fe,de)===0}function Q(ce,fe,de){return $(ce,fe,de)!==0}function ie(ce,fe,de){return $(ce,fe,de)>=0}function le(ce,fe,de){return $(ce,fe,de)<=0}function he(ce,fe,de,Ie){var Pe;switch(fe){case"===":typeof ce=="object"&&(ce=ce.version),typeof de=="object"&&(de=de.version),Pe=ce===de;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof de=="object"&&(de=de.version),Pe=ce!==de;break;case"":case"=":case"==":Pe=K(ce,de,Ie);break;case"!=":Pe=Q(ce,de,Ie);break;case">":Pe=G(ce,de,Ie);break;case">=":Pe=ie(ce,de,Ie);break;case"<":Pe=ee(ce,de,Ie);break;case"<=":Pe=le(ce,de,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function pe(ce,fe){if(ce instanceof pe){if(ce.loose===fe)return ce;ce=ce.value}if(!(this instanceof pe))return new pe(ce,fe);l("comparator",ce,fe),this.loose=fe,this.parse(ce),this.semver===me?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(ce,fe){return U(fe,ce)},e.major=function(ce,fe){return new V(ce,fe).major},e.minor=function(ce,fe){return new V(ce,fe).minor},e.patch=function(ce,fe){return new V(ce,fe).patch},e.compare=$,e.compareLoose=function(ce,fe){return $(ce,fe,!0)},e.rcompare=function(ce,fe,de){return $(fe,ce,de)},e.sort=function(ce,fe){return ce.sort(function(de,Ie){return e.compare(de,Ie,fe)})},e.rsort=function(ce,fe){return ce.sort(function(de,Ie){return e.rcompare(de,Ie,fe)})},e.gt=G,e.lt=ee,e.eq=K,e.neq=Q,e.gte=ie,e.lte=le,e.cmp=he,e.Comparator=pe;var me={};function be(ce,fe){if(ce instanceof be)return ce.loose===fe?ce:new be(ce.raw,fe);if(ce instanceof pe)return new be(ce.value,fe);if(!(this instanceof be))return new be(ce,fe);if(this.loose=fe,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ce(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function De(ce,fe,de,Ie,Pe,Fe,Le,ze,Me,Ne,je,ne,ue){return((fe=Ce(de)?"":Ce(Ie)?">="+de+".0.0":Ce(Pe)?">="+de+"."+Ie+".0":">="+fe)+" "+(ze=Ce(Me)?"":Ce(Ne)?"<"+(+Me+1)+".0.0":Ce(je)?"<"+Me+"."+(+Ne+1)+".0":ne?"<="+Me+"."+Ne+"."+je+"-"+ne:"<="+ze)).trim()}function ke(ce,fe){for(var de=0;de<ce.length;de++)if(!ce[de].test(fe))return!1;if(fe.prerelease.length){for(de=0;de<ce.length;de++)if(l(ce[de].semver),ce[de].semver!==me&&ce[de].semver.prerelease.length>0){var Ie=ce[de].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function We(ce,fe,de){try{fe=new be(fe,de)}catch{return!1}return fe.test(ce)}function Ye(ce,fe,de,Ie){var Pe,Fe,Le,ze,Me;switch(ce=new V(ce,Ie),fe=new be(fe,Ie),de){case">":Pe=G,Fe=le,Le=ee,ze=">",Me=">=";break;case"<":Pe=ee,Fe=ie,Le=G,ze="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(We(ce,fe,Ie))return!1;for(var Ne=0;Ne<fe.set.length;++Ne){var je=fe.set[Ne],ne=null,ue=null;if(je.forEach(function(ge){ge.semver===me&&(ge=new pe(">=0.0.0")),ne=ne||ge,ue=ue||ge,Pe(ge.semver,ne.semver,Ie)?ne=ge:Le(ge.semver,ue.semver,Ie)&&(ue=ge)}),ne.operator===ze||ne.operator===Me||(!ue.operator||ue.operator===ze)&&Fe(ce,ue.semver)||ue.operator===Me&&Le(ce,ue.semver))return!1}return!0}pe.prototype.parse=function(ce){var fe=this.loose?P[q]:P[x],de=ce.match(fe);if(!de)throw new TypeError("Invalid comparator: "+ce);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new V(de[2],this.loose):this.semver=me},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ce){return l("Comparator.test",ce,this.loose),this.semver===me||(typeof ce=="string"&&(ce=new V(ce,this.loose)),he(ce,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ce,fe){if(!(ce instanceof pe))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new be(ce.value,fe),We(this.value,de,fe);if(ce.operator==="")return de=new be(this.value,fe),We(ce.semver,de,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Fe=this.semver.version===ce.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),ze=he(this.semver,"<",ce.semver,fe)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Me=he(this.semver,">",ce.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ie||Pe||Fe&&Le||ze||Me},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var fe=this.loose;ce=ce.trim(),l("range",ce,fe);var de=fe?P[Z]:P[F];ce=ce.replace(de,De),l("hyphen replace",ce),ce=ce.replace(P[Y],"$1$2$3"),l("comparator trim",ce,P[Y]),ce=(ce=(ce=ce.replace(P[M],"$1~")).replace(P[W],"$1^")).split(/\s+/).join(" ");var Ie=fe?P[q]:P[x],Pe=ce.split(" ").map(function(Fe){return function(Le,ze){return l("comp",Le),Le=function(Me,Ne){return Me.trim().split(/\s+/).map(function(je){return function(ne,ue){l("caret",ne,ue);var ge=ue?P[j]:P[N];return ne.replace(ge,function(Se,ve,Ee,Re,Ae){var Te;return l("caret",ne,Se,ve,Ee,Re,Ae),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(Re)?Te=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Ae?(l("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Re+Ae+" <"+ve+"."+Ee+"."+(+Re+1):">="+ve+"."+Ee+"."+Re+Ae+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Re+Ae+" <"+(+ve+1)+".0.0"):(l("no pr"),Te=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Re+" <"+ve+"."+Ee+"."+(+Re+1):">="+ve+"."+Ee+"."+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Re+" <"+(+ve+1)+".0.0"),l("caret return",Te),Te})}(je,Ne)}).join(" ")}(Le,ze),l("caret",Le),Le=function(Me,Ne){return Me.trim().split(/\s+/).map(function(je){return function(ne,ue){var ge=ue?P[H]:P[z];return ne.replace(ge,function(Se,ve,Ee,Re,Ae){var Te;return l("tilde",ne,Se,ve,Ee,Re,Ae),Ce(ve)?Te="":Ce(Ee)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ce(Re)?Te=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Ae?(l("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Te=">="+ve+"."+Ee+"."+Re+Ae+" <"+ve+"."+(+Ee+1)+".0"):Te=">="+ve+"."+Ee+"."+Re+" <"+ve+"."+(+Ee+1)+".0",l("tilde return",Te),Te})}(je,Ne)}).join(" ")}(Le,ze),l("tildes",Le),Le=function(Me,Ne){return l("replaceXRanges",Me,Ne),Me.split(/\s+/).map(function(je){return function(ne,ue){ne=ne.trim();var ge=ue?P[v]:P[m];return ne.replace(ge,function(Se,ve,Ee,Re,Ae,Te){l("xRange",ne,Se,ve,Ee,Re,Ae,Te);var Ue=Ce(Ee),$e=Ue||Ce(Re),Be=$e||Ce(Ae);return ve==="="&&Be&&(ve=""),Ue?Se=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Be?($e&&(Re=0),Be&&(Ae=0),ve===">"?(ve=">=",$e?(Ee=+Ee+1,Re=0,Ae=0):Be&&(Re=+Re+1,Ae=0)):ve==="<="&&(ve="<",$e?Ee=+Ee+1:Re=+Re+1),Se=ve+Ee+"."+Re+"."+Ae):$e?Se=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Be&&(Se=">="+Ee+"."+Re+".0 <"+Ee+"."+(+Re+1)+".0"),l("xRange return",Se),Se})}(je,Ne)}).join(" ")}(Le,ze),l("xrange",Le),Le=function(Me,Ne){return l("replaceStars",Me,Ne),Me.trim().replace(P[te],"")}(Le,ze),l("stars",Le),Le}(Fe,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Fe){return!!Fe.match(Ie)})),Pe=Pe.map(function(Fe){return new pe(Fe,fe)})},be.prototype.intersects=function(ce,fe){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Ie){return ce.set.some(function(Pe){return Pe.every(function(Fe){return Ie.intersects(Fe,fe)})})})})},e.toComparators=function(ce,fe){return new be(ce,fe).set.map(function(de){return de.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new V(ce,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],ce))return!0;return!1},e.satisfies=We,e.maxSatisfying=function(ce,fe,de){var Ie=null,Pe=null;try{var Fe=new be(fe,de)}catch{return null}return ce.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==-1||(Pe=new V(Ie=Le,de)))}),Ie},e.minSatisfying=function(ce,fe,de){var Ie=null,Pe=null;try{var Fe=new be(fe,de)}catch{return null}return ce.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==1||(Pe=new V(Ie=Le,de)))}),Ie},e.validRange=function(ce,fe){try{return new be(ce,fe).range||"*"}catch{return null}},e.ltr=function(ce,fe,de){return Ye(ce,fe,"<",de)},e.gtr=function(ce,fe,de){return Ye(ce,fe,">",de)},e.outside=Ye,e.prerelease=function(ce,fe){var de=ae(ce,fe);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(ce,fe,de){return ce=new be(ce,de),fe=new be(fe,de),ce.intersects(fe)},e.coerce=function(ce){if(ce instanceof V)return ce;if(typeof ce!="string")return null;var fe=ce.match(P[A]);return fe==null?null:ae((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,L(1))},function(_,e){var L,O,l=_.exports={};function D(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function P(c){if(L===setTimeout)return setTimeout(c,0);if((L===D||!L)&&setTimeout)return L=setTimeout,setTimeout(c,0);try{return L(c,0)}catch{try{return L.call(null,c,0)}catch{return L.call(this,c,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:D}catch{L=D}try{O=typeof clearTimeout=="function"?clearTimeout:k}catch{O=k}})();var C,b=[],I=!1,w=-1;function y(){I&&C&&(I=!1,C.length?b=C.concat(b):w=-1,b.length&&p())}function p(){if(!I){var c=P(y);I=!0;for(var u=b.length;u;){for(C=b,b=[];++w<u;)C&&C[w].run();w=-1,u=b.length}C=null,I=!1,function(g){if(O===clearTimeout)return clearTimeout(g);if((O===k||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(g);try{O(g)}catch{try{return O.call(null,g)}catch{return O.call(this,g)}}}(c)}}function d(c,u){this.fun=c,this.array=u}function E(){}l.nextTick=function(c){var u=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)u[g-1]=arguments[g];b.push(new d(c,u)),b.length!==1||I||P(p)},d.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=E,l.addListener=E,l.once=E,l.off=E,l.removeListener=E,l.removeAllListeners=E,l.emit=E,l.prependListener=E,l.prependOnceListener=E,l.listeners=function(c){return[]},l.binding=function(c){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(c){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(re[132],oe([0,1]),function(_,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(P,C,b){this.level=P,this.key=C,this.value=b,this.forward=[]}}const l=void 0;class D{constructor(P,C=2**16){this.comparator=P,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(C)|0),this.e=new O(this.c,l,l)}get size(){return this.f}clear(){this.e=new O(this.c,l,l)}has(P){return Boolean(D.g(this,P,this.comparator))}get(P){return D.g(this,P,this.comparator)?.value}set(P,C){return D.h(this,P,C,this.comparator)&&(this.f+=1),this}delete(P){const C=D.k(this,P,this.comparator);return C&&(this.f-=1),C}forEach(P,C){let b=this.e.forward[0];for(;b;)P.call(C,b.value,b.key,this),b=b.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",C=this.e.forward[0];for(;C;)P+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return P}static g(P,C,b){let I=P.e;for(let w=P.d-1;w>=0;w--)for(;I.forward[w]&&b(I.forward[w].key,C)<0;)I=I.forward[w];if(I=I.forward[0],I&&b(I.key,C)===0)return I}static h(P,C,b,I){const w=[];let y=P.e;for(let p=P.d-1;p>=0;p--){for(;y.forward[p]&&I(y.forward[p].key,C)<0;)y=y.forward[p];w[p]=y}if(y=y.forward[0],y&&I(y.key,C)===0)return y.value=b,!1;{const p=D.j(P);if(p>P.d){for(let d=P.d;d<p;d++)w[d]=P.e;P.d=p}y=new O(p,C,b);for(let d=0;d<p;d++)y.forward[d]=w[d].forward[d],w[d].forward[d]=y;return!0}}static j(P,C=.5){let b=1;for(;Math.random()<C&&b<P.c;)b+=1;return b}static k(P,C,b){const I=[];let w=P.e;for(let y=P.d-1;y>=0;y--){for(;w.forward[y]&&b(w.forward[y].key,C)<0;)w=w.forward[y];I[y]=w}if(w=w.forward[0],!w||b(w.key,C)!==0)return!1;for(let y=0;y<P.d&&I[y].forward[y]===w;y++)I[y].forward[y]=w.forward[y];for(;P.d>0&&P.e.forward[P.d-1]===l;)P.d-=1;return!0}}e.SkipList=D}),define(re[43],oe([0,1,9,2]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(S){const R=S;return R?typeof R.read=="function":!1}e.isReadable=l;function D(S){const R=S;return R?[R.on,R.pause,R.resume,R.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=D;function k(S){const R=S;return R?D(R.stream)&&Array.isArray(R.buffer)&&typeof R.ended=="boolean":!1}e.isReadableBufferedStream=k;function P(S,R){return new C(S,R)}e.newWriteableStream=P;class C{constructor(R,i){this.e=R,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(R){if(!this.a.destroyed){if(this.a.flowing)this.g(R);else if(this.b.data.push(R),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(R){this.a.destroyed||(this.a.flowing?this.h(R):this.b.error.push(R))}end(R){this.a.destroyed||(typeof R<"u"&&this.write(R),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(R){this.c.data.slice(0).forEach(i=>i(R))}h(R){this.c.error.length===0?(0,L.onUnexpectedError)(R):this.c.error.slice(0).forEach(i=>i(R))}i(){this.c.end.slice(0).forEach(R=>R())}on(R,i){if(!this.a.destroyed)switch(R){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(R,i){if(this.a.destroyed)return;let r;switch(R){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const R=this.e(this.b.data);this.g(R),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const R of this.b.error)this.h(R);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(S,R){const i=[];let r;for(;(r=S.read())!==null;)i.push(r);return R(i)}e.consumeReadable=b;function I(S,R,i){const r=[];let t;for(;(t=S.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?R(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return S.read()}}}e.peekReadable=I;function w(S,R){return new Promise((i,r)=>{const t=[];y(S,{onData:n=>{R&&t.push(n)},onError:n=>{R?r(n):i(void 0)},onEnd:()=>{i(R?R(t):void 0)}})})}e.consumeStream=w;function y(S,R){let i=!1;return S.on("error",r=>{i||R.onError(r)}),S.on("end",()=>{i||R.onEnd()}),S.on("data",r=>{i||R.onData(r)}),(0,O.toDisposable)(()=>i=!0)}e.listenStream=y;function p(S,R){return new Promise((i,r)=>{const t=new O.DisposableStore,n=[],s=h=>{if(n.push(h),n.length>R)return t.dispose(),S.pause(),i({stream:S,buffer:n,ended:!1})},a=h=>r(h),o=()=>i({stream:S,buffer:n,ended:!0});t.add((0,O.toDisposable)(()=>S.removeListener("error",a))),S.on("error",a),t.add((0,O.toDisposable)(()=>S.removeListener("end",o))),S.on("end",o),t.add((0,O.toDisposable)(()=>S.removeListener("data",s))),S.on("data",s)})}e.peekStream=p;function d(S,R){const i=P(R);return i.end(S),i}e.toStream=d;function E(){const S=P(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=E;function c(S){let R=!1;return{read:()=>R?null:(R=!0,S)}}e.toReadable=c;function u(S,R,i){const r=P(i);return y(S,{onData:t=>r.write(R.data(t)),onError:t=>r.error(R.error?R.error(t):t),onEnd:()=>r.end()}),r}e.transform=u;function g(S,R,i){let r=!1;return{read:()=>{const t=R.read();return r?t:(r=!0,t!==null?i([S,t]):S)}}}e.prefixedReadable=g;function f(S,R,i){let r=!1;const t=P(i);return y(R,{onData:n=>r?t.write(n):(r=!0,t.write(i([S,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(S)),t.end()}}),t}e.prefixedStream=f}),define(re[16],oe([0,1,43]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer<"u";let l,D;class k{static alloc(h){return O?new k(Buffer.allocUnsafe(h)):new k(new Uint8Array(h))}static wrap(h){return O&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new k(h)}static fromString(h,m){return!(m?.dontUseNodeBuffer||!1)&&O?new k(Buffer.from(h)):(l||(l=new TextEncoder),new k(l.encode(h)))}static fromByteArray(h){const m=k.alloc(h.length);for(let v=0,A=h.length;v<A;v++)m.buffer[v]=h[v];return m}static concat(h,m){if(typeof m>"u"){m=0;for(let T=0,M=h.length;T<M;T++)m+=h[T].byteLength}const v=k.alloc(m);let A=0;for(let T=0,M=h.length;T<M;T++){const z=h[T];v.set(z,A),A+=z.byteLength}return v}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=k.alloc(this.byteLength);return h.set(this),h}toString(){return O?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(h,m){return new k(this.buffer.subarray(h,m))}set(h,m){if(h instanceof k)this.buffer.set(h.buffer,m);else if(h instanceof Uint8Array)this.buffer.set(h,m);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),m);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return b(this.buffer,h)}writeUInt32BE(h,m){I(this.buffer,h,m)}readUInt32LE(h){return w(this.buffer,h)}writeUInt32LE(h,m){y(this.buffer,h,m)}readUInt8(h){return p(this.buffer,h)}writeUInt8(h,m){d(this.buffer,h,m)}}e.VSBuffer=k;function P(o,h){return o[h+0]<<0>>>0|o[h+1]<<8>>>0}e.readUInt16LE=P;function C(o,h,m){o[m+0]=h&255,h=h>>>8,o[m+1]=h&255}e.writeUInt16LE=C;function b(o,h){return o[h]*2**24+o[h+1]*2**16+o[h+2]*2**8+o[h+3]}e.readUInt32BE=b;function I(o,h,m){o[m+3]=h,h=h>>>8,o[m+2]=h,h=h>>>8,o[m+1]=h,h=h>>>8,o[m]=h}e.writeUInt32BE=I;function w(o,h){return o[h+0]<<0>>>0|o[h+1]<<8>>>0|o[h+2]<<16>>>0|o[h+3]<<24>>>0}e.readUInt32LE=w;function y(o,h,m){o[m+0]=h&255,h=h>>>8,o[m+1]=h&255,h=h>>>8,o[m+2]=h&255,h=h>>>8,o[m+3]=h&255}e.writeUInt32LE=y;function p(o,h){return o[h]}e.readUInt8=p;function d(o,h,m){o[m]=h}e.writeUInt8=d;function E(o){return L.consumeReadable(o,h=>k.concat(h))}e.readableToBuffer=E;function c(o){return L.toReadable(o)}e.bufferToReadable=c;function u(o){return L.consumeStream(o,h=>k.concat(h))}e.streamToBuffer=u;async function g(o){return o.ended?k.concat(o.buffer):k.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=g;function f(o){return L.toStream(o,h=>k.concat(h))}e.bufferToStream=f;function S(o){return L.transform(o,{data:h=>typeof h=="string"?k.fromString(h):k.wrap(h)},h=>k.concat(h))}e.streamToBufferReadableStream=S;function R(o){return L.newWriteableStream(h=>k.concat(h),o)}e.newWriteableBufferStream=R;function i(o,h){return L.prefixedReadable(o,h,m=>k.concat(m))}e.prefixedBufferReadable=i;function r(o,h){return L.prefixedStream(o,h,m=>k.concat(m))}e.prefixedBufferStream=r;function t(o){let h=0,m=0,v=0;const A=new Uint8Array(Math.floor(o.length/4*3)),T=z=>{switch(m){case 3:A[v++]=h|z,m=0;break;case 2:A[v++]=h|z>>>2,h=z<<6,m=3;break;case 1:A[v++]=h|z>>>4,h=z<<4,m=2;break;default:h=z<<2,m=1}};for(let z=0;z<o.length;z++){const H=o.charCodeAt(z);if(H>=65&&H<=90)T(H-65);else if(H>=97&&H<=122)T(H-97+26);else if(H>=48&&H<=57)T(H-48+52);else if(H===43||H===45)T(62);else if(H===47||H===95)T(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${o[z]}`)}}const M=v;for(;m>0;)T(0);return k.wrap(A).slice(0,M)}e.decodeBase64=t;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:o},h=!0,m=!1){const v=m?s:n;let A="";const T=o.byteLength%3;let M=0;for(;M<o.byteLength-T;M+=3){const z=o[M+0],H=o[M+1],J=o[M+2];A+=v[z>>>2],A+=v[(z<<4|H>>>4)&63],A+=v[(H<<2|J>>>6)&63],A+=v[J&63]}if(T===1){const z=o[M+0];A+=v[z>>>2],A+=v[z<<4&63],h&&(A+="==")}else if(T===2){const z=o[M+0],H=o[M+1];A+=v[z>>>2],A+=v[(z<<4|H>>>4)&63],A+=v[H<<2&63],h&&(A+="=")}return A}e.encodeBase64=a}),define(re[133],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(re[12],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function L(r){return typeof r=="string"}e.isString=L;function O(r){return Array.isArray(r)&&r.every(t=>L(t))}e.isStringArray=O;function l(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=l;function D(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=D;function k(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=k;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function C(r){return r===!0||r===!1}e.isBoolean=C;function b(r){return typeof r>"u"}e.isUndefined=b;function I(r){return!w(r)}e.isDefined=I;function w(r){return b(r)||r===null}e.isUndefinedOrNull=w;function y(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=y;function p(r){if(w(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=p;function d(...r){const t=[];for(let n=0;n<r.length;n++){const s=r[n];if(w(s))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(s)}return t}e.assertAllDefined=d;const E=Object.prototype.hasOwnProperty;function c(r){if(!l(r))return!1;for(const t in r)if(E.call(r,t))return!1;return!0}e.isEmptyObject=c;function u(r){return typeof r=="function"}e.isFunction=u;function g(...r){return r.length>0&&r.every(u)}e.areFunctions=g;function f(r,t){const n=Math.min(r.length,t.length);for(let s=0;s<n;s++)S(r[s],t[s])}e.validateConstraints=f;function S(r,t){if(L(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(r instanceof t)return}catch{}if(!w(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function R(r){return r===null?void 0:r}e.withNullAsUndefined=R;function i(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=i}),define(re[52],oe([0,1,12]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const O=Object.create(null);function l(P,C){if((0,L.isString)(C)){const b=O[C];if(b===void 0)throw new Error(`${P} references an unknown codicon: ${C}`);C=b}return O[P]=C,{id:P}}function D(){return O}e.getCodiconFontCharacters=D;function k(){return Object.values(e.Codicon)}e.getAllCodicons=k,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(re[32],oe([0,1,12]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const g=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([f,S])=>{g[f]=S&&typeof S=="object"?O(S):S}),g}e.deepClone=O;function l(u){if(!u||typeof u!="object")return u;const g=[u];for(;g.length>0;){const f=g.shift();Object.freeze(f);for(const S in f)if(D.call(f,S)){const R=f[S];typeof R=="object"&&!Object.isFrozen(R)&&!(0,L.isTypedArray)(R)&&g.push(R)}}return u}e.deepFreeze=l;const D=Object.prototype.hasOwnProperty;function k(u,g){return P(u,g,new Set)}e.cloneAndChange=k;function P(u,g,f){if((0,L.isUndefinedOrNull)(u))return u;const S=g(u);if(typeof S<"u")return S;if(Array.isArray(u)){const R=[];for(const i of u)R.push(P(i,g,f));return R}if((0,L.isObject)(u)){if(f.has(u))throw new Error("Cannot clone recursive data-structure");f.add(u);const R={};for(const i in u)D.call(u,i)&&(R[i]=P(u[i],g,f));return f.delete(u),R}return u}function C(u,g,f=!0){return(0,L.isObject)(u)?((0,L.isObject)(g)&&Object.keys(g).forEach(S=>{S in u?f&&((0,L.isObject)(u[S])&&(0,L.isObject)(g[S])?C(u[S],g[S],f):u[S]=g[S]):u[S]=g[S]}),u):g}e.mixin=C;function b(u,g){if(u===g)return!0;if(u==null||g===null||g===void 0||typeof u!=typeof g||typeof u!="object"||Array.isArray(u)!==Array.isArray(g))return!1;let f,S;if(Array.isArray(u)){if(u.length!==g.length)return!1;for(f=0;f<u.length;f++)if(!b(u[f],g[f]))return!1}else{const R=[];for(S in u)R.push(S);R.sort();const i=[];for(S in g)i.push(S);if(i.sort(),!b(R,i))return!1;for(f=0;f<R.length;f++)if(!b(u[R[f]],g[R[f]]))return!1}return!0}e.equals=b;function I(u){const g=new Set;return JSON.stringify(u,(f,S)=>{if((0,L.isObject)(S)||Array.isArray(S)){if(g.has(S))return"[Circular]";g.add(S)}return S})}e.safeStringify=I;function w(u,g){const f=Object.create(null);return!u||!g||Object.keys(g).forEach(R=>{const i=u[R],r=g[R];b(i,r)||(f[R]=r)}),f}e.distinct=w;function y(u,g){const f=g.toLowerCase(),S=Object.keys(u).find(R=>R.toLowerCase()===f);return S?u[S]:u[g]}e.getCaseInsensitive=y;function p(u,g){const f=Object.create(null);for(const[S,R]of Object.entries(u))g(S,R)&&(f[S]=R);return f}e.filter=p;function d(u){let g=[],f=Object.getPrototypeOf(u);for(;Object.prototype!==f;)g=g.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return g}e.getAllPropertyNames=d;function E(u){const g=[];for(const f of d(u))typeof u[f]=="function"&&g.push(f);return g}e.getAllMethodNames=E;function c(u,g){const f=R=>function(){const i=Array.prototype.slice.call(arguments,0);return g(R,i)},S={};for(const R of u)S[R]=f(R);return S}e.createProxyObject=c}),define(re[134],oe([0,1,52]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var O;(function(k){function P(C){return C&&typeof C=="object"&&typeof C.id=="string"}k.isThemeColor=P})(O=e.ThemeColor||(e.ThemeColor={}));function l(k){return{id:k}}e.themeColorFromId=l;var D;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function C(g){const f=P.exec(g.id);if(!f)return C(L.Codicon.error);const[,S,R]=f,i=["codicon","codicon-"+S];return R&&i.push("codicon-modifier-"+R.substring(1)),i}k.asClassNameArray=C;function b(g){return C(g).join(" ")}k.asClassName=b;function I(g){return"."+C(g).join(".")}k.asCSSSelector=I;function w(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||O.isThemeColor(g.color))}k.isThemeIcon=w;const y=new RegExp(`^\\$\\((${k.iconNameExpression}(?:${k.iconModifierExpression})?)\\)$`);function p(g){const f=y.exec(g);if(!f)return;const[,S]=f;return{id:S}}k.fromString=p;function d(g){return{id:g}}k.fromId=d;function E(g,f){let S=g.id;const R=S.lastIndexOf("~");return R!==-1&&(S=S.substring(0,R)),f&&(S=`${S}~${f}`),{id:S}}k.modify=E;function c(g){const f=g.id.lastIndexOf("~");if(f!==-1)return g.id.substring(f+1)}k.getModifier=c;function u(g,f){return g.id===f.id&&g.color?.id===f.color?.id}k.isEqual=u})(D=e.ThemeIcon||(e.ThemeIcon={}))}),define(re[31],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(l){return L.test(l)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(P){for(let C=0;C<P.length;C++)P[C]=Math.floor(Math.random()*256);return P};const D=new Uint8Array(16),k=[];for(let P=0;P<256;P++)k.push(P.toString(16).padStart(2,"0"));return function(){l(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let C=0,b="";return b+=k[D[C++]],b+=k[D[C++]],b+=k[D[C++]],b+=k[D[C++]],b+="-",b+=k[D[C++]],b+=k[D[C++]],b+="-",b+=k[D[C++]],b+=k[D[C++]],b+="-",b+=k[D[C++]],b+=k[D[C++]],b+="-",b+=k[D[C++]],b+=k[D[C++]],b+=k[D[C++]],b+=k[D[C++]],b+=k[D[C++]],b+=k[D[C++]],b}}()}),define(re[135],oe([0,1,34]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function l(k){const P=k.replace(/\-/g,":").toLowerCase();return!O.has(P)}function D(){const k=(0,L.networkInterfaces)();for(const P in k){const C=k[P];if(C){for(const{mac:b}of C)if(l(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(re[136],oe([0,1,85]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function O(P,C,b,I=1){let w=!1;return new Promise(y=>{const p=setTimeout(()=>{if(!w)return w=!0,y(0)},b);l(P,C,I,d=>{if(!w)return w=!0,clearTimeout(p),y(d)})})}e.findFreePort=O;function l(P,C,b,I){if(C===0)return I(0);const w=new L.Socket;w.once("connect",()=>(k(w),l(P+b,C-1,b,I))),w.once("data",()=>{}),w.once("error",y=>(k(w),y.code!=="ECONNREFUSED"?l(P+b,C-1,b,I):I(P))),w.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(P,C,b,I="127.0.0.1"){let w=!1,y,p=1;const d=L.createServer({pauseOnConnect:!0});function E(c,u){w||(w=!0,d.removeAllListeners(),d.close(),y&&clearTimeout(y),u(c))}return new Promise(c=>{y=setTimeout(()=>{E(0,c)},b),d.on("listening",()=>{E(P,c)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&p<C?(P++,p++,d.listen(P,I)):E(0,c)}),d.on("close",()=>{E(0,c)}),d.listen(P,I)})}e.findFreePortFaster=D;function k(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(C){console.error(C)}}}),define(re[86],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function L(O){return!!O.parentPort}e.isUtilityProcess=L}),define(re[137],oe([10,7]),function(_,e){return _.create("vs/base/common/date",e)}),define(re[63],oe([0,1,137]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,l=O*60,D=l*24,k=D*7,P=D*30,C=D*365;function b(w,y,p,d){typeof w!="number"&&(w=w.getTime());const E=Math.round((new Date().getTime()-w)/1e3);if(E<-30)return(0,L.localize)(0,null,b(new Date().getTime()+E*1e3,!1));if(!d&&E<30)return(0,L.localize)(1,null);let c;return E<O?(c=E,y?c===1?p?(0,L.localize)(2,null,c):(0,L.localize)(3,null,c):p?(0,L.localize)(4,null,c):(0,L.localize)(5,null,c):c===1?p?(0,L.localize)(6,null,c):(0,L.localize)(7,null,c):p?(0,L.localize)(8,null,c):(0,L.localize)(9,null,c)):E<l?(c=Math.floor(E/O),y?c===1?p?(0,L.localize)(10,null,c):(0,L.localize)(11,null,c):p?(0,L.localize)(12,null,c):(0,L.localize)(13,null,c):c===1?p?(0,L.localize)(14,null,c):(0,L.localize)(15,null,c):p?(0,L.localize)(16,null,c):(0,L.localize)(17,null,c)):E<D?(c=Math.floor(E/l),y?c===1?p?(0,L.localize)(18,null,c):(0,L.localize)(19,null,c):p?(0,L.localize)(20,null,c):(0,L.localize)(21,null,c):c===1?p?(0,L.localize)(22,null,c):(0,L.localize)(23,null,c):p?(0,L.localize)(24,null,c):(0,L.localize)(25,null,c)):E<k?(c=Math.floor(E/D),y?c===1?(0,L.localize)(26,null,c):(0,L.localize)(27,null,c):c===1?(0,L.localize)(28,null,c):(0,L.localize)(29,null,c)):E<P?(c=Math.floor(E/k),y?c===1?p?(0,L.localize)(30,null,c):(0,L.localize)(31,null,c):p?(0,L.localize)(32,null,c):(0,L.localize)(33,null,c):c===1?p?(0,L.localize)(34,null,c):(0,L.localize)(35,null,c):p?(0,L.localize)(36,null,c):(0,L.localize)(37,null,c)):E<C?(c=Math.floor(E/P),y?c===1?p?(0,L.localize)(38,null,c):(0,L.localize)(39,null,c):p?(0,L.localize)(40,null,c):(0,L.localize)(41,null,c):c===1?p?(0,L.localize)(42,null,c):(0,L.localize)(43,null,c):p?(0,L.localize)(44,null,c):(0,L.localize)(45,null,c)):(c=Math.floor(E/C),y?c===1?p?(0,L.localize)(46,null,c):(0,L.localize)(47,null,c):p?(0,L.localize)(48,null,c):(0,L.localize)(49,null,c):c===1?p?(0,L.localize)(50,null,c):(0,L.localize)(51,null,c):p?(0,L.localize)(52,null,c):(0,L.localize)(53,null,c))}e.fromNow=b;function I(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(re[138],oe([10,7]),function(_,e){return _.create("vs/base/common/errorMessage",e)}),define(re[38],oe([0,1,21,12,138]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(w,y){return y&&(w.stack||w.stacktrace)?l.localize(0,null,P(w),k(w.stack)||k(w.stacktrace)):P(w)}function k(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?l.localize(1,null,w.message):w.message||l.localize(2,null)}function C(w=null,y=!1){if(!w)return l.localize(3,null);if(Array.isArray(w)){const p=L.coalesce(w),d=C(p[0],y);return p.length>1?l.localize(4,null,d,p.length):d}if(O.isString(w))return w;if(w.detail){const p=w.detail;if(p.error)return D(p.error,y);if(p.exception)return D(p.exception,y)}return w.stack?D(w,y):w.message?w.message:l.localize(5,null)}e.toErrorMessage=C;function b(w){const y=w;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=b;function I(w,y){let p;return typeof w=="string"?p=new Error(w):p=w,p.actions=y,p}e.createErrorWithActions=I}),define(re[139],oe([10,7]),function(_,e){return _.create("vs/base/common/jsonErrorMessages",e)}),define(re[140],oe([0,1,139]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(l){switch(l){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(re[141],oe([10,7]),function(_,e){return _.create("vs/base/common/platform",e)}),define(re[4],oe([0,1,141]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let O=!1,l=!1,D=!1,k=!1,P=!1,C=!1,b=!1,I=!1,w=!1,y=!1,p,d=e.LANGUAGE_DEFAULT,E,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const g=typeof u?.versions?.electron=="string",f=g&&u?.type==="renderer";if(typeof navigator=="object"&&!f)c=navigator.userAgent,O=c.indexOf("Windows")>=0,l=c.indexOf("Macintosh")>=0,I=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=c.indexOf("Linux")>=0,y=c?.indexOf("Mobi")>=0,C=!0,p=L.getConfiguredDefaultLocale(L.localize(0,null))||e.LANGUAGE_DEFAULT,d=p;else if(typeof u=="object"){O=u.platform==="win32",l=u.platform==="darwin",D=u.platform==="linux",k=D&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,b=g,w=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const o=u.env.VSCODE_NLS_CONFIG;if(o)try{const h=JSON.parse(o),m=h.availableLanguages["*"];p=h.locale,d=m||e.LANGUAGE_DEFAULT,E=h._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var S;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function R(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=R;let i=0;l?i=1:O?i=3:D&&(i=2),e.isWindows=O,e.isMacintosh=l,e.isLinux=D,e.isLinuxSnap=k,e.isNative=P,e.isElectron=b,e.isWeb=C,e.isWebWorker=C&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isMobile=y,e.isCI=w,e.platform=i,e.userAgent=c,e.language=d;var r;(function(o){function h(){return e.language}o.value=h;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=m;function v(){return e.language==="en"}o.isDefault=v})(r=e.Language||(e.Language={})),e.locale=p,e.translationsConfigFile=E,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let v=0,A=o.length;v<A;v++){const T=o[v];if(T.id===m.data.vscodeScheduleAsyncWork){o.splice(v,1),T.callback();return}}});let h=0;return m=>{const v=++h;o.push({id:v,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:v},"*")}}return o=>setTimeout(o)})();var t;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||I?2:O?1:3;let n=!0,s=!1;function a(){if(!s){s=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,n=new Uint16Array(o.buffer)[0]===(2<<8)+1}return n}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],oe([0,1,4]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let O;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.process<"u"){const l=L.globals.vscode.process;O={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.platform=O.platform,e.arch=O.arch}),define(re[13],oe([0,1,36]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const O=65,l=97,D=90,k=122,P=46,C=47,b=92,I=58,w=63;class y extends Error{constructor(r,t,n){let s;typeof t=="string"&&t.indexOf("not ")===0?(s="must not be",t=t.replace(/^not /,"")):s="must be";const a=r.indexOf(".")!==-1?"property":"argument";let o=`The "${r}" ${a} ${s} of type ${t}`;o+=`. Received type ${typeof n}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function p(i,r){if(i===null||typeof i!="object")throw new y(r,"Object",i)}function d(i,r){if(typeof i!="string")throw new y(r,"string",i)}const E=L.platform==="win32";function c(i){return i===C||i===b}function u(i){return i===C}function g(i){return i>=O&&i<=D||i>=l&&i<=k}function f(i,r,t,n){let s="",a=0,o=-1,h=0,m=0;for(let v=0;v<=i.length;++v){if(v<i.length)m=i.charCodeAt(v);else{if(n(m))break;m=C}if(n(m)){if(!(o===v-1||h===1))if(h===2){if(s.length<2||a!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const A=s.lastIndexOf(t);A===-1?(s="",a=0):(s=s.slice(0,A),a=s.length-1-s.lastIndexOf(t)),o=v,h=0;continue}else if(s.length!==0){s="",a=0,o=v,h=0;continue}}r&&(s+=s.length>0?`${t}..`:"..",a=2)}else s.length>0?s+=`${t}${i.slice(o+1,v)}`:s=i.slice(o+1,v),a=v-o-1;o=v,h=0}else m===P&&h!==-1?++h:h=-1}return s}function S(i,r){p(r,"pathObject");const t=r.dir||r.root,n=r.base||`${r.name||""}${r.ext||""}`;return t?t===r.root?`${t}${n}`:`${t}${i}${n}`:n}e.win32={resolve(...i){let r="",t="",n=!1;for(let s=i.length-1;s>=-1;s--){let a;if(s>=0){if(a=i[s],d(a,"path"),a.length===0)continue}else r.length===0?a=L.cwd():(a=L.env[`=${r}`]||L.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==r.toLowerCase()&&a.charCodeAt(2)===b)&&(a=`${r}\\`));const o=a.length;let h=0,m="",v=!1;const A=a.charCodeAt(0);if(o===1)c(A)&&(h=1,v=!0);else if(c(A))if(v=!0,c(a.charCodeAt(1))){let T=2,M=T;for(;T<o&&!c(a.charCodeAt(T));)T++;if(T<o&&T!==M){const z=a.slice(M,T);for(M=T;T<o&&c(a.charCodeAt(T));)T++;if(T<o&&T!==M){for(M=T;T<o&&!c(a.charCodeAt(T));)T++;(T===o||T!==M)&&(m=`\\\\${z}\\${a.slice(M,T)}`,h=T)}}}else h=1;else g(A)&&a.charCodeAt(1)===I&&(m=a.slice(0,2),h=2,o>2&&c(a.charCodeAt(2))&&(v=!0,h=3));if(m.length>0)if(r.length>0){if(m.toLowerCase()!==r.toLowerCase())continue}else r=m;if(n){if(r.length>0)break}else if(t=`${a.slice(h)}\\${t}`,n=v,v&&r.length>0)break}return t=f(t,!n,"\\",c),n?`${r}\\${t}`:`${r}${t}`||"."},normalize(i){d(i,"path");const r=i.length;if(r===0)return".";let t=0,n,s=!1;const a=i.charCodeAt(0);if(r===1)return u(a)?"\\":i;if(c(a))if(s=!0,c(i.charCodeAt(1))){let h=2,m=h;for(;h<r&&!c(i.charCodeAt(h));)h++;if(h<r&&h!==m){const v=i.slice(m,h);for(m=h;h<r&&c(i.charCodeAt(h));)h++;if(h<r&&h!==m){for(m=h;h<r&&!c(i.charCodeAt(h));)h++;if(h===r)return`\\\\${v}\\${i.slice(m)}\\`;h!==m&&(n=`\\\\${v}\\${i.slice(m,h)}`,t=h)}}}else t=1;else g(a)&&i.charCodeAt(1)===I&&(n=i.slice(0,2),t=2,r>2&&c(i.charCodeAt(2))&&(s=!0,t=3));let o=t<r?f(i.slice(t),!s,"\\",c):"";return o.length===0&&!s&&(o="."),o.length>0&&c(i.charCodeAt(r-1))&&(o+="\\"),n===void 0?s?`\\${o}`:o:s?`${n}\\${o}`:`${n}${o}`},isAbsolute(i){d(i,"path");const r=i.length;if(r===0)return!1;const t=i.charCodeAt(0);return c(t)||r>2&&g(t)&&i.charCodeAt(1)===I&&c(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,t;for(let a=0;a<i.length;++a){const o=i[a];d(o,"path"),o.length>0&&(r===void 0?r=t=o:r+=`\\${o}`)}if(r===void 0)return".";let n=!0,s=0;if(typeof t=="string"&&c(t.charCodeAt(0))){++s;const a=t.length;a>1&&c(t.charCodeAt(1))&&(++s,a>2&&(c(t.charCodeAt(2))?++s:n=!1))}if(n){for(;s<r.length&&c(r.charCodeAt(s));)s++;s>=2&&(r=`\\${r.slice(s)}`)}return e.win32.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r)return"";const t=e.win32.resolve(i),n=e.win32.resolve(r);if(t===n||(i=t.toLowerCase(),r=n.toLowerCase(),i===r))return"";let s=0;for(;s<i.length&&i.charCodeAt(s)===b;)s++;let a=i.length;for(;a-1>s&&i.charCodeAt(a-1)===b;)a--;const o=a-s;let h=0;for(;h<r.length&&r.charCodeAt(h)===b;)h++;let m=r.length;for(;m-1>h&&r.charCodeAt(m-1)===b;)m--;const v=m-h,A=o<v?o:v;let T=-1,M=0;for(;M<A;M++){const H=i.charCodeAt(s+M);if(H!==r.charCodeAt(h+M))break;H===b&&(T=M)}if(M!==A){if(T===-1)return n}else{if(v>A){if(r.charCodeAt(h+M)===b)return n.slice(h+M+1);if(M===2)return n.slice(h+M)}o>A&&(i.charCodeAt(s+M)===b?T=M:M===2&&(T=3)),T===-1&&(T=0)}let z="";for(M=s+T+1;M<=a;++M)(M===a||i.charCodeAt(M)===b)&&(z+=z.length===0?"..":"\\..");return h+=T,z.length>0?`${z}${n.slice(h,m)}`:(n.charCodeAt(h)===b&&++h,n.slice(h,m))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const r=e.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===b){if(r.charCodeAt(1)===b){const t=r.charCodeAt(2);if(t!==w&&t!==P)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(g(r.charCodeAt(0))&&r.charCodeAt(1)===I&&r.charCodeAt(2)===b)return`\\\\?\\${r}`;return i},dirname(i){d(i,"path");const r=i.length;if(r===0)return".";let t=-1,n=0;const s=i.charCodeAt(0);if(r===1)return c(s)?i:".";if(c(s)){if(t=n=1,c(i.charCodeAt(1))){let h=2,m=h;for(;h<r&&!c(i.charCodeAt(h));)h++;if(h<r&&h!==m){for(m=h;h<r&&c(i.charCodeAt(h));)h++;if(h<r&&h!==m){for(m=h;h<r&&!c(i.charCodeAt(h));)h++;if(h===r)return i;h!==m&&(t=n=h+1)}}}}else g(s)&&i.charCodeAt(1)===I&&(t=r>2&&c(i.charCodeAt(2))?3:2,n=t);let a=-1,o=!0;for(let h=r-1;h>=n;--h)if(c(i.charCodeAt(h))){if(!o){a=h;break}}else o=!1;if(a===-1){if(t===-1)return".";a=t}return i.slice(0,a)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let t=0,n=-1,s=!0,a;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===I&&(t=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let o=r.length-1,h=-1;for(a=i.length-1;a>=t;--a){const m=i.charCodeAt(a);if(c(m)){if(!s){t=a+1;break}}else h===-1&&(s=!1,h=a+1),o>=0&&(m===r.charCodeAt(o)?--o===-1&&(n=a):(o=-1,n=h))}return t===n?n=h:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=t;--a)if(c(i.charCodeAt(a))){if(!s){t=a+1;break}}else n===-1&&(s=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){d(i,"path");let r=0,t=-1,n=0,s=-1,a=!0,o=0;i.length>=2&&i.charCodeAt(1)===I&&g(i.charCodeAt(0))&&(r=n=2);for(let h=i.length-1;h>=r;--h){const m=i.charCodeAt(h);if(c(m)){if(!a){n=h+1;break}continue}s===-1&&(a=!1,s=h+1),m===P?t===-1?t=h:o!==1&&(o=1):t!==-1&&(o=-1)}return t===-1||s===-1||o===0||o===1&&t===s-1&&t===n+1?"":i.slice(t,s)},format:S.bind(null,"\\"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const t=i.length;let n=0,s=i.charCodeAt(0);if(t===1)return c(s)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(c(s)){if(n=1,c(i.charCodeAt(1))){let T=2,M=T;for(;T<t&&!c(i.charCodeAt(T));)T++;if(T<t&&T!==M){for(M=T;T<t&&c(i.charCodeAt(T));)T++;if(T<t&&T!==M){for(M=T;T<t&&!c(i.charCodeAt(T));)T++;T===t?n=T:T!==M&&(n=T+1)}}}}else if(g(s)&&i.charCodeAt(1)===I){if(t<=2)return r.root=r.dir=i,r;if(n=2,c(i.charCodeAt(2))){if(t===3)return r.root=r.dir=i,r;n=3}}n>0&&(r.root=i.slice(0,n));let a=-1,o=n,h=-1,m=!0,v=i.length-1,A=0;for(;v>=n;--v){if(s=i.charCodeAt(v),c(s)){if(!m){o=v+1;break}continue}h===-1&&(m=!1,h=v+1),s===P?a===-1?a=v:A!==1&&(A=1):a!==-1&&(A=-1)}return h!==-1&&(a===-1||A===0||A===1&&a===h-1&&a===o+1?r.base=r.name=i.slice(o,h):(r.name=i.slice(o,a),r.base=i.slice(o,h),r.ext=i.slice(a,h))),o>0&&o!==n?r.dir=i.slice(0,o-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const R=(()=>{if(E){const i=/\\/g;return()=>{const r=L.cwd().replace(i,"/");return r.slice(r.indexOf("/"))}}return()=>L.cwd()})();e.posix={resolve(...i){let r="",t=!1;for(let n=i.length-1;n>=-1&&!t;n--){const s=n>=0?i[n]:R();d(s,"path"),s.length!==0&&(r=`${s}/${r}`,t=s.charCodeAt(0)===C)}return r=f(r,!t,"/",u),t?`/${r}`:r.length>0?r:"."},normalize(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===C,t=i.charCodeAt(i.length-1)===C;return i=f(i,!r,"/",u),i.length===0?r?"/":t?"./":".":(t&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return d(i,"path"),i.length>0&&i.charCodeAt(0)===C},join(...i){if(i.length===0)return".";let r;for(let t=0;t<i.length;++t){const n=i[t];d(n,"path"),n.length>0&&(r===void 0?r=n:r+=`/${n}`)}return r===void 0?".":e.posix.normalize(r)},relative(i,r){if(d(i,"from"),d(r,"to"),i===r||(i=e.posix.resolve(i),r=e.posix.resolve(r),i===r))return"";const t=1,n=i.length,s=n-t,a=1,o=r.length-a,h=s<o?s:o;let m=-1,v=0;for(;v<h;v++){const T=i.charCodeAt(t+v);if(T!==r.charCodeAt(a+v))break;T===C&&(m=v)}if(v===h)if(o>h){if(r.charCodeAt(a+v)===C)return r.slice(a+v+1);if(v===0)return r.slice(a+v)}else s>h&&(i.charCodeAt(t+v)===C?m=v:v===0&&(m=0));let A="";for(v=t+m+1;v<=n;++v)(v===n||i.charCodeAt(v)===C)&&(A+=A.length===0?"..":"/..");return`${A}${r.slice(a+m)}`},toNamespacedPath(i){return i},dirname(i){if(d(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===C;let t=-1,n=!0;for(let s=i.length-1;s>=1;--s)if(i.charCodeAt(s)===C){if(!n){t=s;break}}else n=!1;return t===-1?r?"/":".":r&&t===1?"//":i.slice(0,t)},basename(i,r){r!==void 0&&d(r,"ext"),d(i,"path");let t=0,n=-1,s=!0,a;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let o=r.length-1,h=-1;for(a=i.length-1;a>=0;--a){const m=i.charCodeAt(a);if(m===C){if(!s){t=a+1;break}}else h===-1&&(s=!1,h=a+1),o>=0&&(m===r.charCodeAt(o)?--o===-1&&(n=a):(o=-1,n=h))}return t===n?n=h:n===-1&&(n=i.length),i.slice(t,n)}for(a=i.length-1;a>=0;--a)if(i.charCodeAt(a)===C){if(!s){t=a+1;break}}else n===-1&&(s=!1,n=a+1);return n===-1?"":i.slice(t,n)},extname(i){d(i,"path");let r=-1,t=0,n=-1,s=!0,a=0;for(let o=i.length-1;o>=0;--o){const h=i.charCodeAt(o);if(h===C){if(!s){t=o+1;break}continue}n===-1&&(s=!1,n=o+1),h===P?r===-1?r=o:a!==1&&(a=1):r!==-1&&(a=-1)}return r===-1||n===-1||a===0||a===1&&r===n-1&&r===t+1?"":i.slice(r,n)},format:S.bind(null,"/"),parse(i){d(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const t=i.charCodeAt(0)===C;let n;t?(r.root="/",n=1):n=0;let s=-1,a=0,o=-1,h=!0,m=i.length-1,v=0;for(;m>=n;--m){const A=i.charCodeAt(m);if(A===C){if(!h){a=m+1;break}continue}o===-1&&(h=!1,o=m+1),A===P?s===-1?s=m:v!==1&&(v=1):s!==-1&&(v=-1)}if(o!==-1){const A=a===0&&t?1:a;s===-1||v===0||v===1&&s===o-1&&s===a+1?r.base=r.name=i.slice(A,o):(r.name=i.slice(A,s),r.base=i.slice(A,o),r.ext=i.slice(s,o))}return a>0?r.dir=i.slice(0,a-1):t&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E?e.win32.normalize:e.posix.normalize,e.isAbsolute=E?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E?e.win32.join:e.posix.join,e.resolve=E?e.win32.resolve:e.posix.resolve,e.relative=E?e.win32.relative:e.posix.relative,e.dirname=E?e.win32.dirname:e.posix.dirname,e.basename=E?e.win32.basename:e.posix.basename,e.extname=E?e.win32.extname:e.posix.extname,e.format=E?e.win32.format:e.posix.format,e.parse=E?e.win32.parse:e.posix.parse,e.toNamespacedPath=E?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E?e.win32.sep:e.posix.sep,e.delimiter=E?e.win32.delimiter:e.posix.delimiter}),define(re[142],oe([0,1,13]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(I){const w=(0,L.extname)(I),y=O[w.toLowerCase()];return y!==void 0?y:k(I)}e.getMediaOrTextMime=D;function k(I){const w=(0,L.extname)(I);return l[w.toLowerCase()]}e.getMediaMime=k;function P(I){for(const w in l)if(l[w]===I)return w}e.getExtensionForMimeType=P;const C=/^(.+)\/(.+?)(;.+)?$/;function b(I,w){const y=C.exec(I);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:w?void 0:I}e.normalizeMimeType=b}),define(re[87],oe([0,1,4]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(O=e.Source||(e.Source={}));var l;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(P,...C){const b=C.reduce((y,p)=>(y[p]=!0,y),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(y=>!b[y]).forEach(y=>{for(let p=0;p<I.length;p++)if(y.search(I[p])!==-1){delete P[y];break}})}e.sanitizeProcessEnvironment=D;function k(P){!P||(delete P.DEBUG,L.isMacintosh&&delete P.DYLD_LIBRARY_PATH,L.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=k}),define(re[88],oe([0,1,4]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const O=L.globals.performance&&typeof L.globals.performance.now=="function";class l{static create(k=!0){return new l(k)}constructor(k){this.a=O&&k,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?L.globals.performance.now():Date.now()}}e.StopWatch=l}),define(re[3],oe([0,1,9,81,2,83,88]),function(_,e,L,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,C=!1;var b;(function(a){a.None=()=>l.Disposable.None;function o($){if(C){const{onDidAddListener:G}=$,ee=d.create();let K=0;$.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),G?.()}}}function h($,G){return W($,()=>{},0,void 0,!0,void 0,G)}a.defer=h;function m($){return(G,ee=null,K)=>{let Q=!1,ie;return ie=$(le=>{if(!Q)return ie?ie.dispose():Q=!0,G.call(ee,le)},null,K),Q&&ie.dispose(),ie}}a.once=m;function v($,G,ee){return J((K,Q=null,ie)=>$(le=>K.call(Q,G(le)),null,ie),ee)}a.map=v;function A($,G,ee){return J((K,Q=null,ie)=>$(le=>{G(le),K.call(Q,le)},null,ie),ee)}a.forEach=A;function T($,G,ee){return J((K,Q=null,ie)=>$(le=>G(le)&&K.call(Q,le),null,ie),ee)}a.filter=T;function M($){return $}a.signal=M;function z(...$){return(G,ee=null,K)=>(0,l.combinedDisposable)(...$.map(Q=>Q(ie=>G.call(ee,ie),null,K)))}a.any=z;function H($,G,ee,K){let Q=ee;return v($,ie=>(Q=G(Q,ie),Q),K)}a.reduce=H;function J($,G){let ee;const K={onWillAddFirstListener(){ee=$(Q.fire,Q)},onDidRemoveLastListener(){ee?.dispose()}};G||o(K);const Q=new c(K);return G?.add(Q),Q.event}function W($,G,ee=100,K=!1,Q=!1,ie,le){let he,pe,me,be=0,Ce;const De={leakWarningThreshold:ie,onWillAddFirstListener(){he=$(We=>{be++,pe=G(pe,We),K&&!me&&(ke.fire(pe),pe=void 0),Ce=()=>{const Ye=pe;pe=void 0,me=void 0,(!K||be>1)&&ke.fire(Ye),be=0},typeof ee=="number"?(clearTimeout(me),me=setTimeout(Ce,ee)):me===void 0&&(me=0,queueMicrotask(Ce))})},onWillRemoveListener(){Q&&be>0&&Ce?.()},onDidRemoveLastListener(){Ce=void 0,he.dispose()}};le||o(De);const ke=new c(De);return le?.add(ke),ke.event}a.debounce=W;function N($,G=0,ee){return a.debounce($,(K,Q)=>K?(K.push(Q),K):[Q],G,void 0,!0,void 0,ee)}a.accumulate=N;function j($,G=(K,Q)=>K===Q,ee){let K=!0,Q;return T($,ie=>{const le=K||!G(ie,Q);return K=!1,Q=ie,le},ee)}a.latch=j;function q($,G,ee){return[a.filter($,G,ee),a.filter($,K=>!G(K),ee)]}a.split=q;function x($,G=!1,ee=[]){let K=ee.slice(),Q=$(he=>{K?K.push(he):le.fire(he)});const ie=()=>{K?.forEach(he=>le.fire(he)),K=null},le=new c({onWillAddFirstListener(){Q||(Q=$(he=>le.fire(he)))},onDidAddFirstListener(){K&&(G?setTimeout(ie):ie())},onDidRemoveLastListener(){Q&&Q.dispose(),Q=null}});return le.event}a.buffer=x;class Y{constructor(G){this.event=G,this.c=new l.DisposableStore}map(G){return new Y(v(this.event,G,this.c))}forEach(G){return new Y(A(this.event,G,this.c))}filter(G){return new Y(T(this.event,G,this.c))}reduce(G,ee){return new Y(H(this.event,G,ee,this.c))}latch(){return new Y(j(this.event,void 0,this.c))}debounce(G,ee=100,K=!1,Q=!1,ie){return new Y(W(this.event,G,ee,K,Q,ie,this.c))}on(G,ee,K){return this.event(G,ee,K)}once(G,ee,K){return m(this.event)(G,ee,K)}dispose(){this.c.dispose()}}function F($){return new Y($)}a.chain=F;function Z($,G,ee=K=>K){const K=(...he)=>le.fire(ee(...he)),Q=()=>$.on(G,K),ie=()=>$.removeListener(G,K),le=new c({onWillAddFirstListener:Q,onDidRemoveLastListener:ie});return le.event}a.fromNodeEventEmitter=Z;function te($,G,ee=K=>K){const K=(...he)=>le.fire(ee(...he)),Q=()=>$.addEventListener(G,K),ie=()=>$.removeEventListener(G,K),le=new c({onWillAddFirstListener:Q,onDidRemoveLastListener:ie});return le.event}a.fromDOMEventEmitter=te;function se($){return new Promise(G=>m($)(G))}a.toPromise=se;function ae($,G){return G(void 0),$(ee=>G(ee))}a.runAndSubscribe=ae;function V($,G){let ee=null;function K(ie){ee?.dispose(),ee=new l.DisposableStore,G(ie,ee)}K(void 0);const Q=$(ie=>K(ie));return(0,l.toDisposable)(()=>{Q.dispose(),ee?.dispose()})}a.runAndSubscribeWithStore=V;class B{constructor(G,ee){this.obs=G,this.c=0,this.d=!1;const K={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};ee||o(K),this.emitter=new c(K),ee&&ee.add(this.emitter)}beginUpdate(G){this.c++}handleChange(G,ee){this.d=!0}endUpdate(G){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function U($,G){return new B($,G).emitter.event}a.fromObservable=U})(b=e.Event||(e.Event={}));class I{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${I.c++}`,I.all.add(this)}start(o){this.d=new k.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}I.all=new Set,I.c=0,e.EventProfiling=I;let w=-1;function y(a){const o=w;return w=a,{dispose(){w=o}}}e.setGlobalLeakWarningThreshold=y;class p{constructor(o,h=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=h,this.d=0}dispose(){this.c?.clear()}check(o,h){const m=this.threshold;if(m<=0||h<m)return;this.c||(this.c=new Map);const v=this.c.get(o.value)||0;if(this.c.set(o.value,v+1),this.d-=1,this.d<=0){this.d=m*.5;let A,T=0;for(const[M,z]of this.c)(!A||T<z)&&(A=M,T=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${T}):`),console.warn(A)}return()=>{const A=this.c.get(o.value)||0;this.c.set(o.value,A-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(o,h,m){this.callback=o,this.callbackThis=h,this.stack=m,this.subscription=new l.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class c{constructor(o){this.j=!1,this.d=o,this.f=w>0||this.d?.leakWarningThreshold?new p(this.d?.leakWarningThreshold??w):void 0,this.g=this.d?._profName?new I(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const o=Array.from(this.q);queueMicrotask(()=>{for(const h of o)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,h,m)=>{if(this.q||(this.q=new D.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const v=this.q.isEmpty();v&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let A,T;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(T=d.create(),A=this.f.check(T,this.q.size+1)),P&&(T=T??d.create());const M=new E(o,h,T),z=this.q.push(M);v&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,h);const H=M.subscription.set(()=>{A?.(),this.j||(this.d?.onWillRemoveListener?.(this),z(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return m instanceof l.DisposableStore?m.add(H):Array.isArray(m)&&m.push(H),H}),this.l}fire(o){if(this.q){this.m||(this.m=new g);for(const h of this.q)this.m.push(this,h,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=c;class u{constructor(){this.c=new D.LinkedList}get size(){return this.c.size}push(o,h,m){this.c.push(new f(o,h,m))}clear(o){const h=new D.LinkedList;for(const m of this.c)m.emitter!==o&&h.push(m);this.c=h}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(h){(0,L.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=u;class g extends u{clear(o){this.c.clear()}}class f{constructor(o,h,m){this.emitter=o,this.listener=h,this.event=m}}class S extends c{async fireAsync(o,h,m){if(!!this.q){this.c||(this.c=new D.LinkedList);for(const v of this.q)this.c.push([v,o]);for(;this.c.size>0&&!h.isCancellationRequested;){const[v,A]=this.c.shift(),T=[],M={...A,token:h,waitUntil:z=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");m&&(z=m(z,v.callback)),T.push(z)}};try{v.invoke(M)}catch(z){(0,L.onUnexpectedError)(z);continue}Object.freeze(T),await Promise.allSettled(T).then(z=>{for(const H of z)H.status==="rejected"&&(0,L.onUnexpectedError)(H.reason)})}}}}e.AsyncEmitter=S;class R extends c{constructor(o){super(o),this.h=0,this.s=new D.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=R;class i extends R{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=i;class r extends c{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(h=>super.fire(h)),this.c=[]}))}}e.MicrotaskEmitter=r;class t{constructor(){this.d=!1,this.f=[],this.c=new c({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const h={event:o,listener:null};this.f.push(h),this.d&&this.j(h);const m=()=>{this.d&&this.k(h);const v=this.f.indexOf(h);this.f.splice(v,1)};return(0,l.toDisposable)((0,O.once)(m))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(h=>this.c.fire(h))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class n{constructor(){this.c=[]}wrapEvent(o){return(h,m,v)=>o(A=>{const T=this.c[this.c.length-1];T?T.push(()=>h.call(m,A)):h.call(m,A)},void 0,v)}bufferEvents(o){const h=[];this.c.push(h);const m=o();return this.c.pop(),h.forEach(v=>v()),m}}e.EventBufferer=n;class s{constructor(){this.c=!1,this.d=b.None,this.f=l.Disposable.None,this.g=new c({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(re[25],oe([0,1,3]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const O=Object.freeze(function(P,C){const b=setTimeout(P.bind(C),0);return{dispose(){clearTimeout(b)}}});var l;(function(P){function C(b){return b===P.None||b===P.Cancelled||b instanceof D?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=C,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(l=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new L.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class k{constructor(C){this.a=void 0,this.b=void 0,this.b=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new D),this.a}cancel(){this.a?this.a instanceof D&&this.a.cancel():this.a=l.Cancelled}dispose(C=!1){C&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof D&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=k}),define(re[143],oe([0,1,25]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class O{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new L.CancellationTokenSource,C=this.b(P.token);return this.a={promise:C,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=O;class l{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const C=JSON.stringify(P);return this.b!==C&&(this.b=C,this.a=this.c(P)),this.a}}e.LRUCachedFunction=l;class D{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const C=this.b(P);return this.a.set(P,C),C}}e.CachedFunction=D}),define(re[27],oe([0,1,143,130]),function(_,e,L,O){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=D;const k=/{(\d+)}/g;function P(ne,...ue){return ue.length===0?ne:ne.replace(k,function(ge,Se){const ve=parseInt(Se,10);return isNaN(ve)||ve<0||ve>=ue.length?ge:ue[ve]})}e.format=P;const C=/{([^}]+)}/g;function b(ne,ue){return ne.replace(C,(ge,Se)=>ue[Se]??ge)}e.format2=b;function I(ne){return ne.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=I;function w(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function y(ne,ue){let ge=0;const Se=ue.charCodeAt(0);for(let ve=ne.length-1;ve>=0;ve--)ne.charCodeAt(ve)===Se&&ge++;return ge}e.count=y;function p(ne,ue,ge="\u2026"){return ne.length<=ue?ne:`${ne.substr(0,ue)}${ge}`}e.truncate=p;function d(ne,ue=" "){const ge=E(ne,ue);return c(ge,ue)}e.trim=d;function E(ne,ue){if(!ne||!ue)return ne;const ge=ue.length;if(ge===0||ne.length===0)return ne;let Se=0;for(;ne.indexOf(ue,Se)===Se;)Se=Se+ge;return ne.substring(Se)}e.ltrim=E;function c(ne,ue){if(!ne||!ue)return ne;const ge=ue.length,Se=ne.length;if(ge===0||Se===0)return ne;let ve=Se,Ee=-1;for(;Ee=ne.lastIndexOf(ue,ve-1),!(Ee===-1||Ee+ge!==ve);){if(Ee===0)return"";ve=Ee}return ne.substring(0,ve)}e.rtrim=c;function u(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function g(ne){return ne.replace(/\*/g,"")}e.stripWildcards=g;function f(ne,ue,ge={}){if(!ne)throw new Error("Cannot create regex from empty string");ue||(ne=w(ne)),ge.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let Se="";return ge.global&&(Se+="g"),ge.matchCase||(Se+="i"),ge.multiline&&(Se+="m"),ge.unicode&&(Se+="u"),new RegExp(ne,Se)}e.createRegExp=f;function S(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function R(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=R;function i(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=i;function r(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=r;function t(ne){for(let ue=0,ge=ne.length;ue<ge;ue++){const Se=ne.charCodeAt(ue);if(Se!==32&&Se!==9)return ue}return-1}e.firstNonWhitespaceIndex=t;function n(ne,ue=0,ge=ne.length){for(let Se=ue;Se<ge;Se++){const ve=ne.charCodeAt(Se);if(ve!==32&&ve!==9)return ne.substring(ue,Se)}return ne.substring(ue,ge)}e.getLeadingWhitespace=n;function s(ne,ue=ne.length-1){for(let ge=ue;ge>=0;ge--){const Se=ne.charCodeAt(ge);if(Se!==32&&Se!==9)return ge}return-1}e.lastNonWhitespaceIndex=s;function a(ne,ue,ge){const Se=[];let ve=0;for(const Ee of ne.matchAll(ue)){if(Se.push(ne.slice(ve,Ee.index)),Ee.index===void 0)throw new Error("match.index should be defined");ve=Ee.index+Ee[0].length,Se.push(ge(Ee[0],...Ee.slice(1),Ee.index,ne,Ee.groups))}return Se.push(ne.slice(ve)),Promise.all(Se).then(Ee=>Ee.join(""))}e.replaceAsync=a;function o(ne,ue){return ne<ue?-1:ne>ue?1:0}e.compare=o;function h(ne,ue,ge=0,Se=ne.length,ve=0,Ee=ue.length){for(;ge<Se&&ve<Ee;ge++,ve++){const Te=ne.charCodeAt(ge),Ue=ue.charCodeAt(ve);if(Te<Ue)return-1;if(Te>Ue)return 1}const Re=Se-ge,Ae=Ee-ve;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstring=h;function m(ne,ue){return v(ne,ue,0,ne.length,0,ue.length)}e.compareIgnoreCase=m;function v(ne,ue,ge=0,Se=ne.length,ve=0,Ee=ue.length){for(;ge<Se&&ve<Ee;ge++,ve++){let Te=ne.charCodeAt(ge),Ue=ue.charCodeAt(ve);if(Te===Ue)continue;if(Te>=128||Ue>=128)return h(ne.toLowerCase(),ue.toLowerCase(),ge,Se,ve,Ee);T(Te)&&(Te-=32),T(Ue)&&(Ue-=32);const $e=Te-Ue;if($e!==0)return $e}const Re=Se-ge,Ae=Ee-ve;return Re<Ae?-1:Re>Ae?1:0}e.compareSubstringIgnoreCase=v;function A(ne){return ne>=48&&ne<=57}e.isAsciiDigit=A;function T(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=T;function M(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=M;function z(ne,ue){return ne.length===ue.length&&v(ne,ue)===0}e.equalsIgnoreCase=z;function H(ne,ue){const ge=ue.length;return ue.length>ne.length?!1:v(ne,ue,0,ge)===0}e.startsWithIgnoreCase=H;function J(ne,ue){const ge=Math.min(ne.length,ue.length);let Se;for(Se=0;Se<ge;Se++)if(ne.charCodeAt(Se)!==ue.charCodeAt(Se))return Se;return ge}e.commonPrefixLength=J;function W(ne,ue){const ge=Math.min(ne.length,ue.length);let Se;const ve=ne.length-1,Ee=ue.length-1;for(Se=0;Se<ge;Se++)if(ne.charCodeAt(ve-Se)!==ue.charCodeAt(Ee-Se))return Se;return ge}e.commonSuffixLength=W;function N(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=N;function j(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=j;function q(ne,ue){return(ne-55296<<10)+(ue-56320)+65536}e.computeCodePoint=q;function x(ne,ue,ge){const Se=ne.charCodeAt(ge);if(N(Se)&&ge+1<ue){const ve=ne.charCodeAt(ge+1);if(j(ve))return q(Se,ve)}return Se}e.getNextCodePoint=x;function Y(ne,ue){const ge=ne.charCodeAt(ue-1);if(j(ge)&&ue>1){const Se=ne.charCodeAt(ue-2);if(N(Se))return q(Se,ge)}return ge}class F{get offset(){return this.e}constructor(ue,ge=0){this.c=ue,this.d=ue.length,this.e=ge}setOffset(ue){this.e=ue}prevCodePoint(){const ue=Y(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=x(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=F;class Z{get offset(){return this.c.offset}constructor(ue,ge=0){this.c=new F(ue,ge)}nextGraphemeLength(){const ue=Ie.getInstance(),ge=this.c,Se=ge.offset;let ve=ue.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ee=ge.offset,Re=ue.getGraphemeBreakType(ge.nextCodePoint());if(fe(ve,Re)){ge.setOffset(Ee);break}ve=Re}return ge.offset-Se}prevGraphemeLength(){const ue=Ie.getInstance(),ge=this.c,Se=ge.offset;let ve=ue.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ee=ge.offset,Re=ue.getGraphemeBreakType(ge.prevCodePoint());if(fe(Re,ve)){ge.setOffset(Ee);break}ve=Re}return Se-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Z;function te(ne,ue){return new Z(ne,ue).nextGraphemeLength()}e.nextCharLength=te;function se(ne,ue){return new Z(ne,ue).prevGraphemeLength()}e.prevCharLength=se;function ae(ne,ue){ue>0&&j(ne.charCodeAt(ue))&&ue--;const ge=ue+te(ne,ue);return[ge-se(ne,ge),ge]}e.getCharContainingOffset=ae;function V(ne){const ue=new Z(ne);let ge=0;for(;!ue.eol();)ge++,ue.nextGraphemeLength();return ge}e.charCount=V;let B;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function $(ne){return B||(B=U()),B.test(ne)}e.containsRTL=$;const G=/^[\t\n\r\x20-\x7E]*$/;function ee(ne){return G.test(ne)}e.isBasicASCII=ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function K(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=K;function Q(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=Q;function ie(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=ie;function le(ne,ue){if(ne.length<ue)return ne;const ge=/\b/g;let Se=0;for(;ge.test(ne)&&!(ne.length-ge.lastIndex<ue);)Se=ge.lastIndex,ge.lastIndex+=1;return ne.substring(Se).replace(/^\s/,"")}e.lcut=le;const he=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function pe(ne){return ne&&(ne=ne.replace(he,"")),ne}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function me(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=me;function be(ne){return me(ne)?ne.substr(1):ne}e.stripUTF8BOM=be;function Ce(ne,ue){if(!ne||!ue||ne.length<ue.length)return!1;const ge=ue.length,Se=ne.toLowerCase();let ve=0,Ee=-1;for(;ve<ge;){const Re=Se.indexOf(ue[ve],Ee+1);if(Re<0)return!1;Ee=Re,ve++}return!0}e.fuzzyContains=Ce;function De(ne,ue=!1){return ne?(ue&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=De;function ke(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=ke;function We(ne,ue=1){if(ue===0)return"";let ge=-1;do ge=ne.indexOf(`
`,ge+1),ue--;while(ue>0&&ge>=0);return ge===-1?ne:(ne[ge-1]==="\r"&&ge--,ne.substr(0,ge))}e.getNLines=We;function Ye(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=Ye;function ce(ne){return Ie.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=ce;function fe(ne,ue){return ne===0?ue!==5&&ue!==7:ne===2&&ue===3?!1:ne===4||ne===2||ne===3||ue===4||ue===2||ue===3?!0:!(ne===8&&(ue===8||ue===9||ue===11||ue===12)||(ne===11||ne===9)&&(ue===9||ue===10)||(ne===12||ne===10)&&ue===10||ue===5||ue===13||ue===7||ne===1||ne===13&&ue===14||ne===6&&ue===6)}var de;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(de=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Pe()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const ge=this.d,Se=ge.length/3;let ve=1;for(;ve<=Se;)if(ue<ge[3*ve])ve=2*ve;else if(ue>ge[3*ve+1])ve=2*ve+1;else return ge[3*ve+2];return 0}}Ie.c=null;function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(ne,ue){if(ne===0)return 0;const ge=Le(ne,ue);if(ge!==void 0)return ge;const Se=new F(ue,ne);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=Fe;function Le(ne,ue){const ge=new F(ue,ne);let Se=ge.prevCodePoint();for(;ze(Se)||Se===65039||Se===8419;){if(ge.offset===0)return;Se=ge.prevCodePoint()}if(!ie(Se))return;let ve=ge.offset;return ve>0&&ge.prevCodePoint()===8205&&(ve=ge.offset),ve}function ze(ne){return 127995<=ne&&ne<=127999}var Me;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.noBreakWhitespace="\xA0";class Ne{static getInstance(ue){return Ne.d.get(Array.from(ue))}static getLocales(){return Ne.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=Ne,Ne.c=new O.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ne.d=new L.LRUCachedFunction(ne=>{function ue(Ue){const $e=new Map;for(let Be=0;Be<Ue.length;Be+=2)$e.set(Ue[Be],Ue[Be+1]);return $e}function ge(Ue,$e){const Be=new Map(Ue);for(const[et,nt]of $e)Be.set(et,nt);return Be}function Se(Ue,$e){if(!Ue)return $e;const Be=new Map;for(const[et,nt]of Ue)$e.has(et)&&Be.set(et,nt);return Be}const ve=l.c.value;let Ee=ne.filter(Ue=>!Ue.startsWith("_")&&Ue in ve);Ee.length===0&&(Ee=["_default"]);let Re;for(const Ue of Ee){const $e=ue(ve[Ue]);Re=Se(Re,$e)}const Ae=ue(ve._common),Te=ge(Ae,Re);return new Ne(Te)}),Ne.e=new O.Lazy(()=>Object.keys(Ne.c.value).filter(ne=>!ne.startsWith("_"))),e.AmbiguousCharacters=Ne;class je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(je.c())),this.d}static isInvisibleCharacter(ue){return je.e().has(ue)}static get codePoints(){return je.e()}}je.d=void 0,e.InvisibleCharacters=je}),define(re[48],oe([0,1,13,4,27,12]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function P(s){return s.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=P;function C(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=C;function b(s,a=L.posix.sep){if(!s)return"";const o=s.length,h=s.charCodeAt(0);if(k(h)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let v=3;const A=v;for(;v<o&&!k(s.charCodeAt(v));v++);if(A!==v&&!k(s.charCodeAt(v+1))){for(v+=1;v<o;v++)if(k(s.charCodeAt(v)))return s.slice(0,v+1).replace(/[\\/]/g,a)}}return a}else if(u(h)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let m=s.indexOf("://");if(m!==-1){for(m+=3;m<o;m++)if(k(s.charCodeAt(m)))return s.slice(0,m+1)}return""}e.getRoot=b;function I(s){if(!O.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let o=2;const h=o;for(;o<s.length&&(a=s.charCodeAt(o),a!==92);o++);return!(h===o||(a=s.charCodeAt(o+1),isNaN(a)||a===92))}e.isUNC=I;const w=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,a=O.isWindows){const o=a?w:y;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||a&&p.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function E(s,a,o){const h=s===a;return!o||h?h:!s||!a?!1:(0,l.equalsIgnoreCase)(s,a)}e.isEqual=E;function c(s,a,o,h=L.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(o){if(!(0,l.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let v=a.length;return a.charAt(a.length-1)===h&&v--,s.charAt(v)===h}return a.charAt(a.length-1)!==h&&(a+=h),s.indexOf(a)===0}e.isEqualOrParent=c;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function g(s,a){return O.isWindows&&s.endsWith(":")&&(s+=L.sep),(0,L.isAbsolute)(s)||(s=(0,L.join)(a,s)),s=(0,L.normalize)(s),O.isWindows?(s=(0,l.rtrim)(s,L.sep),s.endsWith(":")&&(s+=L.sep)):(s=(0,l.rtrim)(s,L.sep),s||(s=L.sep)),s}e.sanitizeFilePath=g;function f(s){const a=(0,L.normalize)(s);return O.isWindows?s.length>3?!1:S(a)&&(s.length===2||a.charCodeAt(2)===92):a===L.posix.sep}e.isRootOrDriveLetter=f;function S(s,a=O.isWindows){return a?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function R(s){return S(s)?s[0]:void 0}e.getDriveLetter=R;function i(s,a,o){return a.length>s.length?-1:s===a?0:(o&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=i;function r(s){const a=s.split(":");let o,h,m;for(const v of a){const A=Number(v);(0,D.isNumber)(A)?h===void 0?h=A:m===void 0&&(m=A):o=o?[o,v].join(":"):v}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:h!==void 0?h:void 0,column:m!==void 0?m:h!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,a,o=8){let h="";for(let v=0;v<o;v++)h+=t.charAt(Math.floor(Math.random()*t.length));let m;return a?m=`${a}-${h}`:m=h,s?(0,L.join)(s,m):m}e.randomPath=n}),define(re[64],oe([0,1,27]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(u){return l(u,0)}e.hash=O;function l(u,g){switch(typeof u){case"object":return u===null?D(349,g):Array.isArray(u)?C(u,g):b(u,g);case"string":return P(u,g);case"boolean":return k(u,g);case"number":return D(u,g);case"undefined":return D(937,g);default:return D(617,g)}}e.doHash=l;function D(u,g){return(g<<5)-g+u|0}e.numberHash=D;function k(u,g){return D(u?433:863,g)}function P(u,g){g=D(149417,g);for(let f=0,S=u.length;f<S;f++)g=D(u.charCodeAt(f),g);return g}e.stringHash=P;function C(u,g){return g=D(104579,g),u.reduce((f,S)=>l(S,f),g)}function b(u,g){return g=D(181387,g),Object.keys(u).sort().reduce((f,S)=>(f=P(S,f),l(u[S],f)),g)}class I{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=l(g,this.g),this.g}}e.Hasher=I;var w;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function y(u,g,f=32){const S=f-g,R=~((1<<S)-1);return(u<<g|(R&u)>>>S)>>>0}function p(u,g=0,f=u.byteLength,S=0){for(let R=0;R<f;R++)u[g+R]=S}function d(u,g,f="0"){for(;u.length<g;)u=f+u;return u}function E(u,g=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(f=>f.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),g/4)}e.toHexString=E;class c{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const f=g.length;if(f===0)return;const S=this.p;let R=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=g.charCodeAt(0),t=0);;){let n=r;if(L.isHighSurrogate(r))if(t+1<f){const s=g.charCodeAt(t+1);L.isLowSurrogate(s)?(t++,n=L.computeCodePoint(r,s)):n=65533}else{i=r;break}else L.isLowSurrogate(r)&&(n=65533);if(R=this.w(S,R,n),t++,t<f)r=g.charCodeAt(t);else break}this.r=R,this.u=i}w(g,f,S){return S<128?g[f++]=S:S<2048?(g[f++]=192|(S&1984)>>>6,g[f++]=128|(S&63)>>>0):S<65536?(g[f++]=224|(S&61440)>>>12,g[f++]=128|(S&4032)>>>6,g[f++]=128|(S&63)>>>0):(g[f++]=240|(S&1835008)>>>18,g[f++]=128|(S&258048)>>>12,g[f++]=128|(S&4032)>>>6,g[f++]=128|(S&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=c.g,f=this.q;for(let o=0;o<64;o+=4)g.setUint32(o,f.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)g.setUint32(o,y(g.getUint32(o-12,!1)^g.getUint32(o-32,!1)^g.getUint32(o-56,!1)^g.getUint32(o-64,!1),1),!1);let S=this.h,R=this.l,i=this.m,r=this.n,t=this.o,n,s,a;for(let o=0;o<80;o++)o<20?(n=R&i|~R&r,s=1518500249):o<40?(n=R^i^r,s=1859775393):o<60?(n=R&i|R&r|i&r,s=2400959708):(n=R^i^r,s=3395469782),a=y(S,5)+n+t+s+g.getUint32(o*4,!1)&4294967295,t=r,r=i,i=y(R,30),R=S,S=a;this.h=this.h+S&4294967295,this.l=this.l+R&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}c.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=c}),define(re[89],oe([0,1,27]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(O||(O={})),function(l){const D="error",k="warning",P="warn",C="info",b="ignore";function I(y){return y?L.equalsIgnoreCase(D,y)?l.Error:L.equalsIgnoreCase(k,y)||L.equalsIgnoreCase(P,y)?l.Warning:L.equalsIgnoreCase(C,y)?l.Info:l.Ignore:l.Ignore}l.fromValue=I;function w(y){switch(y){case l.Error:return D;case l.Warning:return k;case l.Info:return C;default:return b}}l.toString=w}(O||(O={})),e.default=O}),define(re[49],oe([0,1,21,27]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const d=p.charCodeAt(0),E=this.b.charCodeAt(this.c);return d-E}value(){return this.b[this.c]}}e.StringIterator=l;class D{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,O.compareSubstring)(p,this.b,0,p.length,this.c,this.d):(0,O.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=D;class k{constructor(p=!0,d=!0){this.f=p,this.g=d}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let d=p.length-1;d>=0;d--,this.c--){const E=this.b.charCodeAt(d);if(!(E===47||this.f&&E===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,O.compareSubstring)(p,this.b,0,p.length,this.d,this.e):(0,O.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=k;var P;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(P||(P={}));class C{constructor(p,d){this.f=p,this.g=d,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new k(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,O.compareIgnoreCase)(p,this.c.scheme);if(this.d[this.e]===2)return(0,O.compareIgnoreCase)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,O.compare)(p,this.c.query);if(this.d[this.e]===5)return(0,O.compare)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=C;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(I||(I={}));class w{static forUris(p=()=>!1,d=()=>!1){return new w(new C(p,d))}static forPaths(p=!1){return new w(new k(void 0,!p))}static forStrings(){return new w(new l)}static forConfigKeys(){return new w(new D)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,d){if(d){const E=d.slice(0);(0,L.shuffle)(E);for(const c of E)this.set(c,p)}else{const E=p.slice(0);(0,L.shuffle)(E);for(const c of E)this.set(c[0],c[1])}}set(p,d){const E=this.b.reset(p);let c;this.c||(this.c=new b,this.c.segment=E.value());const u=[];for(c=this.c;;){const f=E.cmp(c.segment);if(f>0)c.left||(c.left=new b,c.left.segment=E.value()),u.push([-1,c]),c=c.left;else if(f<0)c.right||(c.right=new b,c.right.segment=E.value()),u.push([1,c]),c=c.right;else if(E.hasNext())E.next(),c.mid||(c.mid=new b,c.mid.segment=E.value()),u.push([0,c]),c=c.mid;else break}const g=c.value;c.value=d,c.key=p;for(let f=u.length-1;f>=0;f--){const S=u[f][1];S.updateHeight();const R=S.balanceFactor();if(R<-1||R>1){const i=u[f][0],r=u[f+1][0];if(i===1&&r===1)u[f][1]=S.rotateLeft();else if(i===-1&&r===-1)u[f][1]=S.rotateRight();else if(i===1&&r===-1)S.right=u[f+1][1]=u[f+1][1].rotateRight(),u[f][1]=S.rotateLeft();else if(i===-1&&r===1)S.left=u[f+1][1]=u[f+1][1].rotateLeft(),u[f][1]=S.rotateRight();else throw new Error;if(f>0)switch(u[f-1][0]){case-1:u[f-1][1].left=u[f][1];break;case 1:u[f-1][1].right=u[f][1];break;case 0:u[f-1][1].mid=u[f][1];break}else this.c=u[0][1]}}return g}get(p){return this.d(p)?.value}d(p){const d=this.b.reset(p);let E=this.c;for(;E;){const c=d.cmp(E.segment);if(c>0)E=E.left;else if(c<0)E=E.right;else if(d.hasNext())d.next(),E=E.mid;else break}return E}has(p){const d=this.d(p);return!(d?.value===void 0&&d?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,d){const E=this.b.reset(p),c=[];let u=this.c;for(;u;){const g=E.cmp(u.segment);if(g>0)c.push([-1,u]),u=u.left;else if(g<0)c.push([1,u]),u=u.right;else if(E.hasNext())E.next(),c.push([0,u]),u=u.mid;else break}if(!!u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const g=this.f(u.right);if(g.key){const{key:f,value:S,segment:R}=g;this.e(g.key,!1),u.key=f,u.value=S,u.segment=R}}else{const g=u.left??u.right;if(c.length>0){const[f,S]=c[c.length-1];switch(f){case-1:S.left=g;break;case 0:S.mid=g;break;case 1:S.right=g;break}}else this.c=g}for(let g=c.length-1;g>=0;g--){const f=c[g][1];f.updateHeight();const S=f.balanceFactor();if(S>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),c[g][1]=f.rotateLeft()):S<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),c[g][1]=f.rotateRight()),g>0)switch(c[g-1][0]){case-1:c[g-1][1].left=c[g][1];break;case 1:c[g-1][1].right=c[g][1];break;case 0:c[g-1][1].mid=c[g][1];break}else this.c=c[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const d=this.b.reset(p);let E=this.c,c;for(;E;){const u=d.cmp(E.segment);if(u>0)E=E.left;else if(u<0)E=E.right;else if(d.hasNext())d.next(),c=E.value||c,E=E.mid;else break}return E&&E.value||c}findSuperstr(p){return this.g(p,!1)}g(p,d){const E=this.b.reset(p);let c=this.c;for(;c;){const u=E.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(E.hasNext())E.next(),c=c.mid;else return c.mid?this.h(c.mid):d?c.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[d,E]of this)p(E,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const d=[];return this.j(p,d),d[Symbol.iterator]()}j(p,d){!p||(p.left&&this.j(p.left,d),p.value&&d.push([p.key,p.value]),p.mid&&this.j(p.mid,d),p.right&&this.j(p.right,d))}_isBalanced(){const p=d=>{if(!d)return!0;const E=d.balanceFactor();return E<-1||E>1?!1:p(d.left)&&p(d.right)};return p(this.c)}}e.TernarySearchTree=w}),define(re[11],oe([0,1,13,4]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,D=/^\//,k=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!l.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!D.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(t,n){return!t&&!n?"file":t}function b(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const I="",w="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(n){return n instanceof p?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,s,a,o,h,m=!1){typeof n=="object"?(this.scheme=n.scheme||I,this.authority=n.authority||I,this.path=n.path||I,this.query=n.query||I,this.fragment=n.fragment||I):(this.scheme=C(n,m),this.authority=s||I,this.path=b(this.scheme,a||I),this.query=o||I,this.fragment=h||I,P(this,m))}get fsPath(){return f(this,!1)}with(n){if(!n)return this;let{scheme:s,authority:a,path:o,query:h,fragment:m}=n;return s===void 0?s=this.scheme:s===null&&(s=I),a===void 0?a=this.authority:a===null&&(a=I),o===void 0?o=this.path:o===null&&(o=I),h===void 0?h=this.query:h===null&&(h=I),m===void 0?m=this.fragment:m===null&&(m=I),s===this.scheme&&a===this.authority&&o===this.path&&h===this.query&&m===this.fragment?this:new E(s,a,o,h,m)}static parse(n,s=!1){const a=y.exec(n);return a?new E(a[2]||I,r(a[4]||I),r(a[5]||I),r(a[7]||I),r(a[9]||I),s):new E(I,I,I,I,I)}static file(n){let s=I;if(O.isWindows&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const a=n.indexOf(w,2);a===-1?(s=n.substring(2),n=w):(s=n.substring(2,a),n=n.substring(a)||w)}return new E("file",s,n,I,I)}static from(n){const s=new E(n.scheme,n.authority,n.path,n.query,n.fragment);return P(s,!0),s}static joinPath(n,...s){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return O.isWindows&&n.scheme==="file"?a=p.file(L.win32.join(f(n,!0),...s)).path:a=L.posix.join(n.path,...s),n.with({path:a})}toString(n=!1){return S(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof p)return n;{const s=new E(n);return s._formatted=n.external,s._fsPath=n._sep===d?n.fsPath:null,s}}else return n}}e.URI=p;const d=O.isWindows?1:void 0;class E extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(n=!1){return n?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=d),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(t,n,s){let a,o=-1;for(let h=0;h<t.length;h++){const m=t.charCodeAt(h);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||n&&m===47||s&&m===91||s&&m===93||s&&m===58)o!==-1&&(a+=encodeURIComponent(t.substring(o,h)),o=-1),a!==void 0&&(a+=t.charAt(h));else{a===void 0&&(a=t.substr(0,h));const v=c[m];v!==void 0?(o!==-1&&(a+=encodeURIComponent(t.substring(o,h)),o=-1),a+=v):o===-1&&(o=h)}}return o!==-1&&(a+=encodeURIComponent(t.substring(o))),a!==void 0?a:t}function g(t){let n;for(let s=0;s<t.length;s++){const a=t.charCodeAt(s);a===35||a===63?(n===void 0&&(n=t.substr(0,s)),n+=c[a]):n!==void 0&&(n+=t[s])}return n!==void 0?n:t}function f(t,n){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,O.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function S(t,n){const s=n?g:u;let a="",{scheme:o,authority:h,path:m,query:v,fragment:A}=t;if(o&&(a+=o,a+=":"),(h||o==="file")&&(a+=w,a+=w),h){let T=h.indexOf("@");if(T!==-1){const M=h.substr(0,T);h=h.substr(T+1),T=M.lastIndexOf(":"),T===-1?a+=s(M,!1,!1):(a+=s(M.substr(0,T),!1,!1),a+=":",a+=s(M.substr(T+1),!1,!0)),a+="@"}h=h.toLowerCase(),T=h.lastIndexOf(":"),T===-1?a+=s(h,!1,!0):(a+=s(h.substr(0,T),!1,!0),a+=h.substr(T))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const T=m.charCodeAt(1);T>=65&&T<=90&&(m=`/${String.fromCharCode(T+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const T=m.charCodeAt(0);T>=65&&T<=90&&(m=`${String.fromCharCode(T+32)}:${m.substr(2)}`)}a+=s(m,!0,!1)}return v&&(a+="?",a+=s(v,!1,!1)),A&&(a+="#",a+=n?A:u(A,!1,!1)),a}function R(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+R(t.substr(3)):t}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(i)?t.replace(i,n=>R(n)):t}}),define(re[144],oe([0,1,11]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(b){const I=b;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=O;function l(b){const I=[];let w;try{const y=JSON.parse(b.arguments),p=y[y.length-1];p&&p.__$stack&&(y.pop(),w=p.__$stack),I.push(...y)}catch{I.push("Unable to log remote console arguments",b.arguments)}return{args:I,stack:w}}e.parse=l;function D(b){if(typeof b!="string")return D(l(b).stack);const I=b;if(I){const w=k(I),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(y&&y.length===4)return{uri:L.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=D;function k(b){if(!b)return b;const I=b.indexOf(`
`);return I===-1?b:b.substring(0,I)}function P(b,I){const{args:w,stack:y}=l(b),p=typeof w[0]=="string"&&w.length===1;let d=k(y);d&&(d=`(${d.trim()})`);let E=[];if(typeof w[0]=="string"?d&&p?E=[`%c[${I}] %c${w[0]} %c${d}`,C("blue"),C(""),C("grey")]:E=[`%c[${I}] %c${w[0]}`,C("blue"),C(""),...w.slice(1)]:E=[`%c[${I}]%`,C("blue"),...w],d&&!p&&E.push(d),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,E)}e.log=P;function C(b){return`color: ${b}`}}),define(re[90],oe([0,1,16,27,11]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(b){return JSON.stringify(b,P)}e.stringify=D;function k(b){let I=JSON.parse(b);return I=C(I),I}e.parse=k;function P(b,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,O.regExpFlags)(I)}:I}function C(b,I=0){if(!b||I>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return l.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 16:return new Date(b.source)}if(b instanceof L.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let w=0;w<b.length;++w)b[w]=C(b[w],I+1);else for(const w in b)Object.hasOwnProperty.call(b,w)&&(b[w]=C(b[w],I+1))}return b}e.revive=C}),define(re[22],oe([0,1,9,4,11]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(I){this.d=I}setDelegate(I){this.e=I}setServerRootPath(I){this.f=`${I}/${D.vscodeRemoteResource}`}set(I,w,y){this.a[I]=w,this.b[I]=y}setConnectionToken(I,w){this.c[I]=w}getPreferredWebSchema(){return this.d}rewrite(I){if(this.e)try{return this.e(I)}catch(c){return L.onUnexpectedError(c),I}const w=I.authority;let y=this.a[w];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const p=this.b[w],d=this.c[w];let E=`path=${encodeURIComponent(I.path)}`;return typeof d=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(d)}`),l.URI.from({scheme:O.isWeb?this.d:D.vscodeRemoteResource,authority:`${y}:${p}`,path:this.f,query:E})}}e.RemoteAuthorities=new k,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(I){const w=this.b(I,_);return this.uriToBrowserUri(w)}uriToBrowserUri(I){return I.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===D.file&&(O.isNative||O.isWebWorker&&O.globals.origin===`${D.vscodeFileResource}://${P.a}`)?I.with({scheme:D.vscodeFileResource,authority:I.authority||P.a,query:null,fragment:null}):I}asFileUri(I){const w=this.b(I,_);return this.uriToFileUri(w)}uriToFileUri(I){return I.scheme===D.vscodeFileResource?I.with({scheme:D.file,authority:I.authority!==P.a?I.authority:null,query:null,fragment:null}):I}b(I,w){return l.URI.isUri(I)?I:l.URI.parse(w.toUrl(I))}}P.a="vscode-app",e.FileAccess=new P;var C;(function(b){const I=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(I.get("3"));const w="vscode-coi";function y(d){let E;typeof d=="string"?E=new URL(d).searchParams:d instanceof URL?E=d.searchParams:l.URI.isUri(d)&&(E=new URL(d.toString(!0)).searchParams);const c=E?.get(w);if(!!c)return I.get(c)}b.getHeadersFromQuery=y;function p(d,E,c){if(!globalThis.crossOriginIsolated)return;const u=E&&c?"3":c?"2":"1";d instanceof URLSearchParams?d.set(w,u):d[w]=u}b.addSearchParam=p})(C=e.COI||(e.COI={}))}),define(re[23],oe([0,1,48,22,13,4,27,11]),function(_,e,L,O,l,D,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(p){return(0,P.uriToFsPath)(p,!0)}e.originalFSPath=C;class b{constructor(d){this.a=d}compare(d,E,c=!1){return d===E?0:(0,k.compare)(this.getComparisonKey(d,c),this.getComparisonKey(E,c))}isEqual(d,E,c=!1){return d===E?!0:!d||!E?!1:this.getComparisonKey(d,c)===this.getComparisonKey(E,c)}getComparisonKey(d,E=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,E,c=!1){if(d.scheme===E.scheme){if(d.scheme===O.Schemas.file)return L.isEqualOrParent(C(d),C(E),this.a(d))&&d.query===E.query&&(c||d.fragment===E.fragment);if((0,e.isEqualAuthority)(d.authority,E.authority))return L.isEqualOrParent(d.path,E.path,this.a(d),"/")&&d.query===E.query&&(c||d.fragment===E.fragment)}return!1}joinPath(d,...E){return P.URI.joinPath(d,...E)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return l.posix.basename(d.path)}extname(d){return l.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let E;return d.scheme===O.Schemas.file?E=P.URI.file(l.dirname(C(d))).path:(E=l.posix.dirname(d.path),d.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),E="/")),d.with({path:E})}normalizePath(d){if(!d.path.length)return d;let E;return d.scheme===O.Schemas.file?E=P.URI.file(l.normalize(C(d))).path:E=l.posix.normalize(d.path),d.with({path:E})}relativePath(d,E){if(d.scheme!==E.scheme||!(0,e.isEqualAuthority)(d.authority,E.authority))return;if(d.scheme===O.Schemas.file){const g=l.relative(C(d),C(E));return D.isWindows?L.toSlashes(g):g}let c=d.path||"/";const u=E.path||"/";if(this.a(d)){let g=0;for(const f=Math.min(c.length,u.length);g<f&&!(c.charCodeAt(g)!==u.charCodeAt(g)&&c.charAt(g).toLowerCase()!==u.charAt(g).toLowerCase());g++);c=u.substr(0,g)+c.substr(g)}return l.posix.relative(c,u)}resolvePath(d,E){if(d.scheme===O.Schemas.file){const c=P.URI.file(l.resolve(C(d),E));return d.with({authority:c.authority,path:c.path})}return E=L.toPosixPath(E),d.with({path:l.posix.resolve(d.path,E)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,E){return d===E||d!==void 0&&E!==void 0&&(0,k.equalsIgnoreCase)(d,E)}hasTrailingPathSeparator(d,E=l.sep){if(d.scheme===O.Schemas.file){const c=C(d);return c.length>L.getRoot(c).length&&c[c.length-1]===E}else{const c=d.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,E=l.sep){return(0,e.hasTrailingPathSeparator)(d,E)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,E=l.sep){let c=!1;if(d.scheme===O.Schemas.file){const u=C(d);c=u!==void 0&&u.length===L.getRoot(u).length&&u[u.length-1]===E}else{E="/";const u=d.path;c=u.length===1&&u.charCodeAt(u.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(d,E)?d.with({path:d.path+"/"}):d}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(p=>p.scheme===O.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new b(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(p,d){const E=[];for(let c=0;c<p.length;c++){const u=d(p[c]);p.some((g,f)=>f===c?!1:(0,e.isEqualOrParent)(u,d(g)))||E.push(p[c])}return E}e.distinctParents=I;var w;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function d(E){const c=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(f=>{const[S,R]=f.split(":");S&&R&&c.set(S,R)});const g=E.path.substring(0,E.path.indexOf(";"));return g&&c.set(p.META_DATA_MIME,g),c}p.parseMetaData=d})(w=e.DataUri||(e.DataUri={}));function y(p,d,E){if(d){let c=p.path;return c&&c[0]!==l.posix.sep&&(c=l.posix.sep+c),p.with({scheme:E,authority:d,path:c})}return p.with({scheme:E})}e.toLocalResource=y}),define(re[6],oe([0,1,25,9,3,2,23,4,133]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(V){return!!V&&typeof V.then=="function"}e.isThenable=b;function I(V){const B=new L.CancellationTokenSource,U=V(B.token),$=new Promise((G,ee)=>{const K=B.token.onCancellationRequested(()=>{K.dispose(),B.dispose(),ee(new O.CancellationError)});Promise.resolve(U).then(Q=>{K.dispose(),B.dispose(),G(Q)},Q=>{K.dispose(),B.dispose(),ee(Q)})});return new class{cancel(){B.cancel()}then(G,ee){return $.then(G,ee)}catch(G){return this.then(void 0,G)}finally(G){return $.finally(G)}}}e.createCancelablePromise=I;function w(V,B,U){return new Promise(($,G)=>{const ee=B.onCancellationRequested(()=>{ee.dispose(),$(U)});V.then($,G).finally(()=>ee.dispose())})}e.raceCancellation=w;function y(V,B){return new Promise((U,$)=>{const G=B.onCancellationRequested(()=>{G.dispose(),$(new O.CancellationError)});V.then(U,$).finally(()=>G.dispose())})}e.raceCancellationError=y;async function p(V){let B=-1;const U=V.map((G,ee)=>G.then(K=>(B=ee,K))),$=await Promise.race(U);return V.forEach((G,ee)=>{ee!==B&&G.cancel()}),$}e.raceCancellablePromises=p;function d(V,B,U){let $;const G=setTimeout(()=>{$?.(void 0),U?.()},B);return Promise.race([V.finally(()=>clearTimeout(G)),new Promise(ee=>$=ee)])}e.raceTimeout=d;function E(V){return new Promise((B,U)=>{const $=V();b($)?$.then(B,U):B($)})}e.asPromise=E;class c{constructor(){this.a=null,this.b=null,this.d=null}queue(B){if(this.a){if(this.d=B,!this.b){const U=()=>{this.b=null;const $=this.queue(this.d);return this.d=null,$};this.b=new Promise($=>{this.a.then(U,U).then($)})}return new Promise((U,$)=>{this.b.then(U,$)})}return this.a=B(),new Promise((U,$)=>{this.a.then(G=>{this.a=null,U(G)},G=>{this.a=null,$(G)})})}}e.Throttler=c;class u{constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}e.Sequencer=u;class g{constructor(){this.a=new Map}queue(B,U){const G=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(B)===G&&this.a.delete(B)});return this.a.set(B,G),G}}e.SequencerByKey=g;const f=(V,B)=>{let U=!0;const $=setTimeout(()=>{U=!1,B()},V);return{isTriggered:()=>U,dispose:()=>{clearTimeout($),U=!1}}},S=V=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,V())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class R{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,U=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((G,ee)=>{this.d=G,this.f=ee}).then(()=>{if(this.b=null,this.d=null,this.g){const G=this.g;return this.g=null,G()}}));const $=()=>{this.a=null,this.d?.(null)};return this.a=U===C.MicrotaskDelay?S($):f(U,$),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=R;class i{constructor(B){this.a=new R(B),this.b=new c}trigger(B,U){return this.a.trigger(()=>this.b.queue(B),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class r{constructor(){this.a=!1,this.b=new Promise((B,U)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class t extends r{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=t;function n(V,B){return B?new Promise((U,$)=>{const G=setTimeout(()=>{ee.dispose(),U()},V),ee=B.onCancellationRequested(()=>{clearTimeout(G),ee.dispose(),$(new O.CancellationError)})}):I(U=>n(V,U))}e.timeout=n;function s(V,B=0){const U=setTimeout(V,B);return(0,D.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=s;function a(V){const B=[];let U=0;const $=V.length;function G(){return U<$?V[U++]():null}function ee(K){K!=null&&B.push(K);const Q=G();return Q?Q.then(ee):Promise.resolve(B)}return Promise.resolve(null).then(ee)}e.sequence=a;function o(V,B=$=>!!$,U=null){let $=0;const G=V.length,ee=()=>{if($>=G)return Promise.resolve(U);const K=V[$++];return Promise.resolve(K()).then(ie=>B(ie)?Promise.resolve(ie):ee())};return ee()}e.first=o;function h(V,B=$=>!!$,U=null){if(V.length===0)return Promise.resolve(U);let $=V.length;const G=()=>{$=-1;for(const ee of V)ee.cancel?.()};return new Promise((ee,K)=>{for(const Q of V)Q.then(ie=>{--$>=0&&B(ie)?(G(),ee(ie)):$===0&&ee(U)}).catch(ie=>{--$>=0&&(G(),K(ie))})})}e.firstParallel=h;class m{constructor(B){this.a=0,this.d=B,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(B){return this.a++,new Promise((U,$)=>{this.f.push({factory:B,c:U,e:$}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const B=this.f.shift();this.b++;const U=B.factory();U.then(B.c,B.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=m;class v extends m{constructor(){super(1)}}e.Queue=v;class A{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const B=new Y;return this.b.add(B),B.p}d(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueFor(B,U=k.extUri){const $=U.getComparisonKey(B);let G=this.a.get($);return G||(G=new v,l.Event.once(G.onDrained)(()=>{G?.dispose(),this.a.delete($),this.f()}),this.a.set($,G)),G}f(){!this.d()||this.g()}g(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.g()}}e.ResourceQueue=A;class T{constructor(B,U){this.a=-1,typeof B=="function"&&typeof U=="number"&&this.setIfNotSet(B,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},U)}setIfNotSet(B,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},U))}}e.TimeoutTimer=T;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(B,U){this.cancel(),this.a=setInterval(()=>{B()},U)}}e.IntervalTimer=M;class z{constructor(B,U){this.b=-1,this.a=B,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=z;class H{constructor(B,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=B,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=H;class J extends z{constructor(B,U){super(B,U),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=J;class W extends D.Disposable{constructor(B,U){super(),this.g=B,this.h=U,this.a=[],this.b=this.B(new D.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of B)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{(0,P.setTimeout0)(()=>{if(B)return;const U=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let B=!1;return{dispose(){B||(B=!0)}}}:e.runWhenIdle=(V,B)=>{const U=requestIdleCallback(V,typeof B=="number"?{timeout:B}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(U))}}}}();class N{constructor(B){this.d=!1,this.a=()=>{try{this.f=B()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=N;async function j(V,B,U){let $;for(let G=0;G<U;G++)try{return await V()}catch(ee){$=ee,await n(B)}throw $}e.retry=j;class q{hasPending(B){return this.a?typeof B=="number"?this.a.taskId===B:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(B,U,$){return this.a={taskId:B,cancel:()=>$?.(),promise:U},U.then(()=>this.d(B),()=>this.d(B)),U}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this.b)this.b.run=B;else{let U,$;const G=new Promise((ee,K)=>{U=ee,$=K});this.b={run:B,promise:G,promiseResolve:U,promiseReject:$}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=q;class x{constructor(B,U=()=>Date.now()){this.d=B,this.f=U,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}e.IntervalCounter=x;class Y{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((B,U)=>{this.a=B,this.b=U})}complete(B){return new Promise(U=>{this.a(B),this.f=!0,U()})}error(B){return new Promise(U=>{this.b(B),this.d=!0,U()})}cancel(){new Promise(B=>{this.b(new O.CancellationError),this.d=!0,B()})}}e.DeferredPromise=Y;var F;(function(V){async function B($){let G;const ee=await Promise.all($.map(K=>K.then(Q=>Q,Q=>{G||(G=Q)})));if(typeof G<"u")throw G;return ee}V.settled=B;function U($){return new Promise(async(G,ee)=>{try{await $(G,ee)}catch(K){ee(K)}})}V.withAsyncBody=U})(F=e.Promises||(e.Promises={}));var Z;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(Z||(Z={}));class te{static fromArray(B){return new te(U=>{U.emitMany(B)})}static fromPromise(B){return new te(async U=>{U.emitMany(await B)})}static fromPromises(B){return new te(async U=>{await Promise.all(B.map(async $=>U.emitOne(await $)))})}static merge(B){return new te(async U=>{await Promise.all(B.map(async $=>{for await(const G of $)U.emitOne(G)}))})}constructor(B){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const U={emitOne:$=>this.g($),emitMany:$=>this.h($),reject:$=>this.k($)};try{await Promise.resolve(B(U)),this.j()}catch($){this.k($)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(B,U){return new te(async $=>{for await(const G of B)$.emitOne(U(G))})}map(B){return te.map(this,B)}static filter(B,U){return new te(async $=>{for await(const G of B)U(G)&&$.emitOne(G)})}filter(B){return te.filter(this,B)}static coalesce(B){return te.filter(B,U=>!!U)}coalesce(){return te.coalesce(this)}static async toPromise(B){const U=[];for await(const $ of B)U.push($);return U}toPromise(){return te.toPromise(this)}g(B){this.a===0&&(this.b.push(B),this.f.fire())}h(B){this.a===0&&(this.b=this.b.concat(B),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(B){this.a===0&&(this.a=2,this.d=B,this.f.fire())}}te.EMPTY=te.fromArray([]),e.AsyncIterableObject=te;class se extends te{constructor(B,U){super(U),this.l=B}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=se;function ae(V){const B=new L.CancellationTokenSource,U=V(B.token);return new se(B,async $=>{const G=B.token.onCancellationRequested(()=>{G.dispose(),B.dispose(),$.reject(new O.CancellationError)});try{for await(const ee of U){if(B.token.isCancellationRequested)return;$.emitOne(ee)}G.dispose(),B.dispose()}catch(ee){G.dispose(),B.dispose(),$.reject(ee)}})}e.createCancelableAsyncIterable=ae}),define(re[91],oe([0,1,21,6,48,37,13,4,27]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",w="[^/\\\\]",y=/\//g;function p(x,Y){switch(x){case 0:return"";case 1:return`${w}*?`;default:return`(?:${I}|${w}+${I}${Y?`|${I}${w}+`:""})*?`}}function d(x,Y){if(!x)return[];const F=[];let Z=!1,te=!1,se="";for(const ae of x){switch(ae){case Y:if(!Z&&!te){F.push(se),se="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":te=!0;break;case"]":te=!1;break}se+=ae}return se&&F.push(se),F}e.splitGlobAware=d;function E(x){if(!x)return"";let Y="";const F=d(x,e.GLOB_SPLIT);if(F.every(Z=>Z===e.GLOBSTAR))Y=".*";else{let Z=!1;F.forEach((te,se)=>{if(te===e.GLOBSTAR){if(Z)return;Y+=p(2,se===F.length-1)}else{let ae=!1,V="",B=!1,U="";for(const $ of te){if($!=="}"&&ae){V+=$;continue}if(B&&($!=="]"||!U)){let G;$==="-"?G=$:($==="^"||$==="!")&&!U?G="^":$===e.GLOB_SPLIT?G="":G=(0,C.escapeRegExpCharacters)($),U+=G;continue}switch($){case"{":ae=!0;continue;case"[":B=!0;continue;case"}":{Y+=`(?:${d(V,",").map(K=>E(K)).join("|")})`,ae=!1,V="";break}case"]":{Y+="["+U+"]",B=!1,U="";break}case"?":Y+=w;continue;case"*":Y+=p(1);continue;default:Y+=(0,C.escapeRegExpCharacters)($)}}se<F.length-1&&(F[se+1]!==e.GLOBSTAR||se+2<F.length)&&(Y+=I)}Z=te===e.GLOBSTAR})}return Y}const c=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,R=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new D.LRUCache(1e4),r=function(){return!1},t=function(){return null};function n(x,Y){if(!x)return t;let F;typeof x!="string"?F=x.pattern:F=x,F=F.trim();const Z=`${F}_${!!Y.trimForExclusions}`;let te=i.get(Z);if(te)return s(te,x);let se;return c.test(F)?te=o(F.substr(4),F):(se=u.exec(a(F,Y)))?te=h(se[1],F):(Y.trimForExclusions?f:g).test(F)?te=m(F,Y):(se=S.exec(a(F,Y)))?te=v(se[1].substr(1),F,!0):(se=R.exec(a(F,Y)))?te=v(se[1],F,!1):te=A(F),i.set(Z,te),s(te,x)}function s(x,Y){if(typeof Y=="string")return x;const F=function(Z,te){return(0,l.isEqualOrParent)(Z,Y.base,!P.isLinux)?x((0,C.ltrim)(Z.substr(Y.base.length),k.sep),te):null};return F.allBasenames=x.allBasenames,F.allPaths=x.allPaths,F.basenames=x.basenames,F.patterns=x.patterns,F}function a(x,Y){return Y.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function o(x,Y){return function(F,Z){return typeof F=="string"&&F.endsWith(x)?Y:null}}function h(x,Y){const F=`/${x}`,Z=`\\${x}`,te=function(ae,V){return typeof ae!="string"?null:V?V===x?Y:null:ae===x||ae.endsWith(F)||ae.endsWith(Z)?Y:null},se=[x];return te.basenames=se,te.patterns=[Y],te.allBasenames=se,te}function m(x,Y){const F=j(x.slice(1,-1).split(",").map(V=>n(V,Y)).filter(V=>V!==t),x),Z=F.length;if(!Z)return t;if(Z===1)return F[0];const te=function(V,B){for(let U=0,$=F.length;U<$;U++)if(F[U](V,B))return x;return null},se=F.find(V=>!!V.allBasenames);se&&(te.allBasenames=se.allBasenames);const ae=F.reduce((V,B)=>B.allPaths?V.concat(B.allPaths):V,[]);return ae.length&&(te.allPaths=ae),te}function v(x,Y,F){const Z=k.sep===k.posix.sep,te=Z?x:x.replace(y,k.sep),se=k.sep+te,ae=k.posix.sep+x;let V;return F?V=function(B,U){return typeof B=="string"&&(B===te||B.endsWith(se)||!Z&&(B===x||B.endsWith(ae)))?Y:null}:V=function(B,U){return typeof B=="string"&&(B===te||!Z&&B===x)?Y:null},V.allPaths=[(F?"*/":"./")+x],V}function A(x){try{const Y=new RegExp(`^${E(x)}$`);return function(F){return Y.lastIndex=0,typeof F=="string"&&Y.test(F)?x:null}}catch{return t}}function T(x,Y,F){return!x||typeof Y!="string"?!1:M(x)(Y,void 0,F)}e.match=T;function M(x,Y={}){if(!x)return r;if(typeof x=="string"||z(x)){const F=n(x,Y);if(F===t)return r;const Z=function(te,se){return!!F(te,se)};return F.allBasenames&&(Z.allBasenames=F.allBasenames),F.allPaths&&(Z.allPaths=F.allPaths),Z}return W(x,Y)}e.parse=M;function z(x){const Y=x;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}e.isRelativePattern=z;function H(x){return x.allBasenames||[]}e.getBasenameTerms=H;function J(x){return x.allPaths||[]}e.getPathTerms=J;function W(x,Y){const F=j(Object.getOwnPropertyNames(x).map(V=>N(V,x[V],Y)).filter(V=>V!==t)),Z=F.length;if(!Z)return t;if(!F.some(V=>!!V.requiresSiblings)){if(Z===1)return F[0];const V=function($,G){let ee;for(let K=0,Q=F.length;K<Q;K++){const ie=F[K]($,G);if(typeof ie=="string")return ie;(0,O.isThenable)(ie)&&(ee||(ee=[]),ee.push(ie))}return ee?(async()=>{for(const K of ee){const Q=await K;if(typeof Q=="string")return Q}return null})():null},B=F.find($=>!!$.allBasenames);B&&(V.allBasenames=B.allBasenames);const U=F.reduce(($,G)=>G.allPaths?$.concat(G.allPaths):$,[]);return U.length&&(V.allPaths=U),V}const te=function(V,B,U){let $,G;for(let ee=0,K=F.length;ee<K;ee++){const Q=F[ee];Q.requiresSiblings&&U&&(B||(B=(0,k.basename)(V)),$||($=B.substr(0,B.length-(0,k.extname)(V).length)));const ie=Q(V,B,$,U);if(typeof ie=="string")return ie;(0,O.isThenable)(ie)&&(G||(G=[]),G.push(ie))}return G?(async()=>{for(const ee of G){const K=await ee;if(typeof K=="string")return K}return null})():null},se=F.find(V=>!!V.allBasenames);se&&(te.allBasenames=se.allBasenames);const ae=F.reduce((V,B)=>B.allPaths?V.concat(B.allPaths):V,[]);return ae.length&&(te.allPaths=ae),te}function N(x,Y,F){if(Y===!1)return t;const Z=n(x,F);if(Z===t)return t;if(typeof Y=="boolean")return Z;if(Y){const te=Y.when;if(typeof te=="string"){const se=(ae,V,B,U)=>{if(!U||!Z(ae,V))return null;const $=te.replace("$(basename)",()=>B),G=U($);return(0,O.isThenable)(G)?G.then(ee=>ee?x:null):G?x:null};return se.requiresSiblings=!0,se}}return Z}function j(x,Y){const F=x.filter(V=>!!V.basenames);if(F.length<2)return x;const Z=F.reduce((V,B)=>{const U=B.basenames;return U?V.concat(U):V},[]);let te;if(Y){te=[];for(let V=0,B=Z.length;V<B;V++)te.push(Y)}else te=F.reduce((V,B)=>{const U=B.patterns;return U?V.concat(U):V},[]);const se=function(V,B){if(typeof V!="string")return null;if(!B){let $;for($=V.length;$>0;$--){const G=V.charCodeAt($-1);if(G===47||G===92)break}B=V.substr($)}const U=Z.indexOf(B);return U!==-1?te[U]:null};se.basenames=Z,se.patterns=te,se.allBasenames=Z;const ae=x.filter(V=>!V.basenames);return ae.push(se),ae}function q(x,Y){return(0,L.equals)(x,Y,(F,Z)=>typeof F=="string"&&typeof Z=="string"?F===Z:typeof F!="string"&&typeof Z!="string"?F.base===Z.base&&F.pattern===Z.pattern:!1)}e.patternsEquals=q}),define(re[92],oe([0,1,16,11]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(w){return w.toJSON()}class D{constructor(y){this.a=y}transformIncoming(y){const p=this.a.transformIncoming(y);return p===y?y:l(O.URI.from(p))}transformOutgoing(y){const p=this.a.transformOutgoing(y);return p===y?y:l(O.URI.from(p))}transformOutgoingURI(y){const p=this.a.transformOutgoing(y);return p===y?y:O.URI.from(p)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function k(w,y,p){if(!w||p>200)return null;if(typeof w=="object"){if(w instanceof O.URI)return y.transformOutgoing(w);for(const d in w)if(Object.hasOwnProperty.call(w,d)){const E=k(w[d],y,p+1);E!==null&&(w[d]=E)}}return null}function P(w,y){const p=k(w,y,0);return p===null?w:p}e.transformOutgoingURIs=P;function C(w,y,p,d){if(!w||d>200)return null;if(typeof w=="object"){if(w.$mid===1)return p?O.URI.revive(y.transformIncoming(w)):y.transformIncoming(w);if(w instanceof L.VSBuffer)return null;for(const E in w)if(Object.hasOwnProperty.call(w,E)){const c=C(w[E],y,p,d+1);c!==null&&(w[E]=c)}}return null}function b(w,y){const p=C(w,y,!1,0);return p===null?w:p}e.transformIncomingURIs=b;function I(w,y){const p=C(w,y,!0,0);return p===null?w:p}e.transformAndReviveIncomingURIs=I}),define(re[145],oe([0,1,34,9,49,31,135]),function(_,e,L,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(I){return this.a||(this.a=l.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(I)}value(){if(this.b===void 0){let I=0,w=0;const y=(0,L.networkInterfaces)();for(const p in y){const d=y[p];if(d)for(const{mac:E,internal:c}of d)c||(w+=1,this.c(E.toUpperCase())&&(I+=1))}this.b=w>0?I/w:0}return this.b}};let P;async function C(){return P||(P=(async()=>await b()||D.generateUuid())()),P}e.getMachineId=C;async function b(){try{const I=await new Promise((y,p)=>{_(["crypto"],y,p)}),w=(0,k.getMac)();return I.createHash("sha256").update(w,"utf8").digest("hex")}catch(I){O.onUnexpectedError(I);return}}}),define(re[28],oe([0,1,53,34,289,6,48,84,13,4,23,11]),function(_,e,L,O,l,D,k,P,C,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(W){W[W.UNLINK=0]="UNLINK",W[W.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function p(W,N=y.UNLINK){if((0,k.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");return N===y.UNLINK?E(W):d(W)}async function d(W){try{const N=(0,k.randomPath)((0,O.tmpdir)());try{await L.promises.rename(W,N)}catch(j){return j.code==="ENOENT"?void 0:E(W)}E(N).catch(j=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function E(W){return(0,l.promisify)(L.rm)(W,{recursive:!0,force:!0,maxRetries:3})}function c(W){if((0,k.isRootOrDriveLetter)(W))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(W,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function u(W,N){return S(await(N?g(W):(0,l.promisify)(L.readdir)(W)))}async function g(W){try{return await(0,l.promisify)(L.readdir)(W,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const N=[],j=await u(W);for(const q of j){let x=!1,Y=!1,F=!1;try{const Z=await e.Promises.lstat((0,C.join)(W,q));x=Z.isFile(),Y=Z.isDirectory(),F=Z.isSymbolicLink()}catch(Z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Z)}N.push({name:q,isFile:()=>x,isDirectory:()=>Y,isSymbolicLink:()=>F})}return N}function f(W){return S(L.readdirSync(W))}e.readdirSync=f;function S(W){return W.map(N=>typeof N=="string"?b.isMacintosh?(0,P.normalizeNFC)(N):N:(N.name=b.isMacintosh?(0,P.normalizeNFC)(N.name):N.name,N))}async function R(W){const N=await u(W),j=[];for(const q of N)await r.existsDirectory((0,C.join)(W,q))&&j.push(q);return j}function i(W,N=1e3){return new Promise(j=>{let q=!1;const x=setInterval(()=>{q||(q=!0,L.access(W,Y=>{q=!1,Y&&(clearInterval(x),j(void 0))}))},N)})}e.whenDeleted=i;var r;(function(W){async function N(x){let Y;try{if(Y=await e.Promises.lstat(x),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(b.isWindows&&F.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(Z){if(Z.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw Z}throw F}}W.stat=N;async function j(x){try{const{stat:Y,symbolicLink:F}=await W.stat(x);return Y.isFile()&&F?.dangling!==!0}catch{}return!1}W.existsFile=j;async function q(x){try{const{stat:Y,symbolicLink:F}=await W.stat(x);return Y.isDirectory()&&F?.dangling!==!0}catch{}return!1}W.existsDirectory=q})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new D.ResourceQueue;function n(W,N,j){return t.queueFor(w.URI.file(W),I.extUriBiasedIgnorePathCase).queue(()=>{const q=m(j);return new Promise((x,Y)=>o(W,N,q,F=>F?Y(F):x()))})}let s=!0;function a(W){s=W}e.configureFlushOnWrite=a;function o(W,N,j,q){if(!s)return L.writeFile(W,N,{mode:j.mode,flag:j.flag},q);L.open(W,j.flag,j.mode,(x,Y)=>{if(x)return q(x);L.writeFile(Y,N,F=>{if(F)return L.close(Y,()=>q(F));L.fdatasync(Y,Z=>(Z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Z),a(!1)),L.close(Y,te=>q(te))))})})}function h(W,N,j){const q=m(j);if(!s)return L.writeFileSync(W,N,{mode:q.mode,flag:q.flag});const x=L.openSync(W,q.flag,q.mode);try{L.writeFileSync(x,N);try{L.fdatasyncSync(x)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),a(!1)}}finally{L.closeSync(x)}}e.writeFileSync=h;function m(W){return W?{mode:typeof W.mode=="number"?W.mode:438,flag:typeof W.flag=="string"?W.flag:"w"}:{mode:438,flag:"w"}}async function v(W,N){if(W!==N)try{await e.Promises.rename(W,N)}catch(j){if(W.toLowerCase()!==N.toLowerCase()&&j.code==="EXDEV"||W.endsWith("."))await A(W,N,{preserveSymlinks:!1}),await p(W,y.MOVE);else throw j}}async function A(W,N,j){return M(W,N,{root:{source:W,target:N},options:j,handledSourcePaths:new Set})}const T=511;async function M(W,N,j){if(j.handledSourcePaths.has(W))return;j.handledSourcePaths.add(W);const{stat:q,symbolicLink:x}=await r.stat(W);if(x){if(j.options.preserveSymlinks)try{return await J(W,N,j)}catch(Y){console.warn("[node.js fs] copy of symlink failed: ",Y)}if(x.dangling)return}return q.isDirectory()?z(W,N,q.mode&T,j):H(W,N,q.mode&T)}async function z(W,N,j,q){await e.Promises.mkdir(N,{recursive:!0,mode:j});const x=await u(W);for(const Y of x)await M((0,C.join)(W,Y),(0,C.join)(N,Y),q)}async function H(W,N,j){await e.Promises.copyFile(W,N),await e.Promises.chmod(N,j)}async function J(W,N,j){let q=await e.Promises.readlink(W);(0,k.isEqualOrParent)(q,j.root.source,!b.isLinux)&&(q=(0,C.join)(j.root.target,q.substr(j.root.source.length+1))),await e.Promises.symlink(q,N)}e.Promises=new class{get access(){return(0,l.promisify)(L.access)}get stat(){return(0,l.promisify)(L.stat)}get lstat(){return(0,l.promisify)(L.lstat)}get utimes(){return(0,l.promisify)(L.utimes)}get read(){return(W,N,j,q,x)=>new Promise((Y,F)=>{L.read(W,N,j,q,x,(Z,te,se)=>Z?F(Z):Y({bytesRead:te,buffer:se}))})}get readFile(){return(0,l.promisify)(L.readFile)}get write(){return(W,N,j,q,x)=>new Promise((Y,F)=>{L.write(W,N,j,q,x,(Z,te,se)=>Z?F(Z):Y({bytesWritten:te,buffer:se}))})}get appendFile(){return(0,l.promisify)(L.appendFile)}get fdatasync(){return(0,l.promisify)(L.fdatasync)}get truncate(){return(0,l.promisify)(L.truncate)}get rename(){return(0,l.promisify)(L.rename)}get copyFile(){return(0,l.promisify)(L.copyFile)}get open(){return(0,l.promisify)(L.open)}get close(){return(0,l.promisify)(L.close)}get symlink(){return(0,l.promisify)(L.symlink)}get readlink(){return(0,l.promisify)(L.readlink)}get chmod(){return(0,l.promisify)(L.chmod)}get mkdir(){return(0,l.promisify)(L.mkdir)}get unlink(){return(0,l.promisify)(L.unlink)}get rmdir(){return(0,l.promisify)(L.rmdir)}get realpath(){return(0,l.promisify)(L.realpath)}async exists(W){try{return await e.Promises.access(W),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return R}get writeFile(){return n}get rm(){return p}get move(){return v}get copy(){return A}}}),define(re[146],oe([0,1,53,13,4,27,28]),function(_,e,L,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(y){if(l.isLinux)return y;const p=(0,O.dirname)(y);if(y===p)return y;const d=((0,O.basename)(y)||y).toLowerCase();try{const c=(0,k.readdirSync)(p).filter(u=>u.toLowerCase()===d);if(c.length===1){const u=P(p);if(u)return(0,O.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(d);if(u>=0){const g=P(p);if(g)return(0,O.join)(g,c[u])}}}catch{}return null}e.realcaseSync=P;async function C(y){if(l.isLinux)return y;const p=(0,O.dirname)(y);if(y===p)return y;const d=((0,O.basename)(y)||y).toLowerCase();try{const c=(await k.Promises.readdir(p)).filter(u=>u.toLowerCase()===d);if(c.length===1){const u=await C(p);if(u)return(0,O.join)(u,c[0])}else if(c.length>1){const u=c.indexOf(d);if(u>=0){const g=await C(p);if(g)return(0,O.join)(g,c[u])}}}catch{}return null}e.realcase=C;async function b(y){try{return await k.Promises.realpath(y)}catch{const d=w(y);return await k.Promises.access(d,L.constants.R_OK),d}}e.realpath=b;function I(y){try{return L.realpathSync(y)}catch{const d=w(y);return L.accessSync(d,L.constants.R_OK),d}}e.realpathSync=I;function w(y){return(0,D.rtrim)((0,O.normalize)(y),O.sep)}}),define(re[93],oe([0,1,34,13,28]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,k=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var C;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(C||(C={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class w{constructor(R,i,r){this.exePath=R,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await l.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:S=!1}={}){return S?b===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:S=!1,findPreview:R=!1}={}){const i=y({useAlternateBitness:S});if(!i)return null;const r=O.join(i,"PowerShell");if(!await l.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const o of await l.Promises.readdir(r)){let h=-1;if(R){const v=o.indexOf("-");if(v<0)continue;const A=o.substring(0,v);if(!D.test(A)||o.substring(v+1)!=="preview")continue;h=parseInt(A,10)}else{if(!D.test(o))continue;h=parseInt(o,10)}if(h<=t)continue;const m=O.join(r,o,"pwsh.exe");!await l.SymlinkSupport.existsFile(m)||(n=m,t=h)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",a=R?" Preview":"";return new w(n,`PowerShell${a}${s}`,!0)}async function d({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const R=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await l.SymlinkSupport.existsDirectory(R))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=S?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const t of await l.Promises.readdir(R))if(i.test(t)){const n=O.join(R,t,"pwsh.exe");return new w(n,r)}return null}function E(){const S=O.join(L.homedir(),".dotnet","tools","pwsh.exe");return new w(S,".NET Core PowerShell Global Tool")}function c(){const S=O.join(process.env.windir,b===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(S,"Windows PowerShell",!0)}async function*u(){let S=await p();S&&(yield S),S=await p({useAlternateBitness:!0}),S&&(yield S),S=await d(),S&&(yield S),S=E(),S&&(yield S),S=await p({findPreview:!0}),S&&(yield S),S=await d({findPreview:!0}),S&&(yield S),S=await p({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=c(),S&&(yield S)}async function*g(){for await(const S of u())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=g;async function f(){for await(const S of g())return S;return null}e.getFirstAvailablePowerShellInstallation=f}),define(re[94],oe([0,1,13,4,36,87,12,28]),function(_,e,L,O,l,D,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function C(w=l.env){return w.comspec||"cmd.exe"}e.getWindowsShell=C;function b(w){let y=[],p=!1;const d=function(E){if(p){y.push(E);return}(!w.send(E,u=>{if(u&&console.error(u),p=!1,y.length>0){const g=y.slice(0);y=[],g.forEach(f=>d(f))}})||O.isWindows)&&(p=!0)};return{send:d}}e.createQueuedSender=b;var I;(function(w){async function y(p,d,E){if(L.isAbsolute(p))return p;if(d===void 0&&(d=l.cwd()),L.dirname(p)!=="."||(E===void 0&&k.isString(l.env.PATH)&&(E=l.env.PATH.split(L.delimiter)),E===void 0||E.length===0))return L.join(d,p);async function u(g){if(await P.Promises.exists(g)){let f;try{f=await P.Promises.stat(g)}catch(S){S.message.startsWith("EACCES")&&(f=await P.Promises.lstat(g))}return f?!f.isDirectory():!1}return!1}for(const g of E){let f;if(L.isAbsolute(g)?f=L.join(g,p):f=L.join(d,g,p),await u(f))return f;let S=f+".com";if(await u(S)||(S=f+".exe",await u(S)))return S}return L.join(d,p)}w.findExecutable=y})(I=e.win32||(e.win32={}))}),define(re[147],oe([0,1,50,22]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function l(k){return new Promise((P,C)=>{let b;const I=new Map;function w(p,d,E,c,u){const g=I.get(d);if(p===k||g){const f={name:y(E),cmd:E,pid:p,ppid:d,load:c,mem:u};I.set(p,f),p===k&&(b=f),g&&(g.children||(g.children=[]),g.children.push(f),g.children.length>1&&(g.children=g.children.sort((S,R)=>S.pid-R.pid)))}}function y(p){const d=/--vscode-window-kind=shared-process/i,E=/--vscode-window-kind=issue-reporter/i,c=/--vscode-window-kind=process-explorer/i,u=/--utility-sub-type=network/i,g=/--vscode-utility-kind=extensionHost/i,f=/--vscode-utility-kind=fileWatcher/i,S=/--vscode-utility-kind=shared-process/i,R=/--ms-enable-electron-run-as-node/i,i=/--crashes-directory/i,r=/\\pipe\\winpty-control/i,t=/conhost\.exe/i,n=/--type=([a-zA-Z-]+)/;if(i.exec(p))return"electron-crash-reporter";if(r.exec(p))return"winpty-process";if(t.exec(p))return"console-window-host (Windows internal process)";let s=n.exec(p);if(s&&s.length===2)return s[1]==="renderer"?d.exec(p)?"shared-process":E.exec(p)?"issue-reporter":c.exec(p)?"process-explorer":"window":s[1]==="utility"?u.exec(p)?"utility-network-service":g.exec(p)?"extension-host":f.exec(p)?"file-watcher":S.exec(p)?"shared-process":"utility-process":s[1]==="extensionHost"?"extension-host":s[1];const a=/[a-zA-Z-]+\.js/g;let o="";do s=a.exec(p),s&&(o+=s+" ");while(s);return o&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron-nodejs (${o})`:R.exec(p)?`electron-nodejs (${p})`:p}if(process.platform==="win32"){const p=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,E)=>{_(["windows-process-tree"],d,E)}).then(d=>{d.getProcessList(k,E=>{if(!E){C(new Error(`Root process ${k} not found`));return}d.getProcessCpuUsage(E,c=>{const u=new Map;c.forEach(g=>{const f=p(g.commandLine||"");u.set(g.pid,{name:y(f),cmd:f,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),b=u.get(k),b?(u.forEach(g=>{const f=u.get(g.ppid);f&&(f.children||(f.children=[]),f.children.push(g))}),u.forEach(g=>{g.children&&(g.children=g.children.sort((f,S)=>f.pid-S.pid))}),P(b)):C(new Error(`Root process ${k} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let p=function(){let d=[b];const E=[];for(;d.length;){const u=d.shift();u&&(E.push(u.pid),u.children&&(d=d.concat(u.children)))}let c=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+E.join(" "),(0,L.exec)(c,{},(u,g,f)=>{if(u||f)C(u||new Error(f.toString()));else{const S=g.toString().split(`
`);for(let R=0;R<E.length;R++){const i=I.get(E[R]);i.load=parseFloat(S[R])}if(!b){C(new Error(`Root process ${k} not found`));return}P(b)}})};(0,L.exec)("which ps",{},(d,E,c)=>{if(d||c)if(process.platform!=="linux")C(d||new Error(c.toString()));else{const u=JSON.stringify(O.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(u,{},(g,f,S)=>{g||S?C(g||new Error(S.toString())):(D(f,w),p())})}else{const u=E.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${u} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,S,R)=>{f||R&&!R.includes("screen size is bogus")?C(f||new Error(R.toString())):(D(S,w),process.platform==="linux"?p():b?P(b):C(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=l;function D(k,P){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=k.toString().split(`
`);for(const I of b){const w=C.exec(I.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(re[148],oe([0,1,34,4,93,94]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function k(w,y){return w===1?O.isWindows?I():D.getWindowsShell(y):C(w,y)}e.getSystemShell=k;let P=null;function C(w,y){if(O.isLinux&&w===2||O.isMacintosh&&w===3)return"/bin/bash";if(!P){let p;if(O.isWindows)p="/bin/bash";else{if(p=y.SHELL,!p)try{p=(0,L.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}P=p}return P}let b=null;async function I(){return b||(b=(await(0,l.getFirstAvailablePowerShellInstallation)()).exePath),b}});var ye=this&&this.__decorate||function(_,e,L,O){var l=arguments.length,D=l<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,L):O,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(_,e,L,O);else for(var P=_.length-1;P>=0;P--)(k=_[P])&&(D=(l<3?k(D):l>3?k(e,L,D):k(e,L))||D);return l>3&&D&&Object.defineProperty(e,L,D),D};define(re[39],oe([0,1,21,6,16,25,61,9,3,2,90,27,12]),function(_,e,L,O,l,D,k,P,C,b,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var p;(function(Y){Y[Y.Promise=100]="Promise",Y[Y.PromiseCancel=101]="PromiseCancel",Y[Y.EventListen=102]="EventListen",Y[Y.EventDispose=103]="EventDispose"})(p||(p={}));function d(Y){switch(Y){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(Y){Y[Y.Initialize=200]="Initialize",Y[Y.PromiseSuccess=201]="PromiseSuccess",Y[Y.PromiseError=202]="PromiseError",Y[Y.PromiseErrorObj=203]="PromiseErrorObj",Y[Y.EventFire=204]="EventFire"})(E||(E={}));function c(Y){switch(Y){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(Y){Y[Y.Uninitialized=0]="Uninitialized",Y[Y.Idle=1]="Idle"})(u||(u={}));function g(Y){let F=0;for(let Z=0;;Z+=7){const te=Y.read(1);if(F|=(te.buffer[0]&127)<<Z,!(te.buffer[0]&128))return F}}const f=t(0);function S(Y,F){if(F===0){Y.write(f);return}let Z=0;for(let se=F;se!==0;se=se>>>7)Z++;const te=l.VSBuffer.alloc(Z);for(let se=0;F!==0;se++)te.buffer[se]=F&127,F=F>>>7,F>0&&(te.buffer[se]|=128);Y.write(te)}class R{constructor(F){this.b=F,this.a=0}read(F){const Z=this.b.slice(this.a,this.a+F);return this.a+=Z.byteLength,Z}}e.BufferReader=R;class i{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write(F){this.a.push(F)}}e.BufferWriter=i;var r;(function(Y){Y[Y.Undefined=0]="Undefined",Y[Y.String=1]="String",Y[Y.Buffer=2]="Buffer",Y[Y.VSBuffer=3]="VSBuffer",Y[Y.Array=4]="Array",Y[Y.Object=5]="Object",Y[Y.Int=6]="Int"})(r||(r={}));function t(Y){const F=l.VSBuffer.alloc(1);return F.writeUInt8(Y,0),F}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function a(Y,F){if(typeof F>"u")Y.write(n.Undefined);else if(typeof F=="string"){const Z=l.VSBuffer.fromString(F);Y.write(n.String),S(Y,Z.byteLength),Y.write(Z)}else if(s&&Buffer.isBuffer(F)){const Z=l.VSBuffer.wrap(F);Y.write(n.Buffer),S(Y,Z.byteLength),Y.write(Z)}else if(F instanceof l.VSBuffer)Y.write(n.VSBuffer),S(Y,F.byteLength),Y.write(F);else if(Array.isArray(F)){Y.write(n.Array),S(Y,F.length);for(const Z of F)a(Y,Z)}else if(typeof F=="number"&&(F|0)===F)Y.write(n.Uint),S(Y,F);else{const Z=l.VSBuffer.fromString(JSON.stringify(F));Y.write(n.Object),S(Y,Z.byteLength),Y.write(Z)}}e.serialize=a;function o(Y){switch(Y.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return Y.read(g(Y)).toString();case r.Buffer:return Y.read(g(Y)).buffer;case r.VSBuffer:return Y.read(g(Y));case r.Array:{const Z=g(Y),te=[];for(let se=0;se<Z;se++)te.push(o(Y));return te}case r.Object:return JSON.parse(Y.read(g(Y)).toString());case r.Int:return g(Y)}}e.deserialize=o;class h{constructor(F,Z,te=null,se=1e3){this.h=F,this.j=Z,this.k=te,this.l=se,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(F,Z){this.b.set(F,Z),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const Z=this.o([F.type]);this.k?.logOutgoing(Z,0,1,c(F.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([F.type,F.id],F.data);this.k?.logOutgoing(Z,F.id,1,c(F.type),F.data);return}}}o(F,Z=void 0){const te=new i;return a(te,F),a(te,Z),this.p(te.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const Z=new R(F),te=o(Z),se=o(Z),ae=te[0];switch(ae){case 100:return this.k?.logIncoming(F.byteLength,te[1],1,`${d(ae)}: ${te[2]}.${te[3]}`,se),this.s({type:ae,id:te[1],channelName:te[2],name:te[3],arg:se});case 102:return this.k?.logIncoming(F.byteLength,te[1],1,`${d(ae)}: ${te[2]}.${te[3]}`,se),this.t({type:ae,id:te[1],channelName:te[2],name:te[3],arg:se});case 101:return this.k?.logIncoming(F.byteLength,te[1],1,`${d(ae)}`),this.u({type:ae,id:te[1]});case 103:return this.k?.logIncoming(F.byteLength,te[1],1,`${d(ae)}`),this.u({type:ae,id:te[1]})}}s(F){const Z=this.b.get(F.channelName);if(!Z){this.v(F);return}const te=new D.CancellationTokenSource;let se;try{se=Z.call(this.j,F.name,F.arg,te.token)}catch(B){se=Promise.reject(B)}const ae=F.id;se.then(B=>{this.m({id:ae,data:B,type:201}),this.d.delete(F.id)},B=>{B instanceof Error?this.m({id:ae,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.m({id:ae,data:B,type:203}),this.d.delete(F.id)});const V=(0,b.toDisposable)(()=>te.cancel());this.d.set(F.id,V)}t(F){const Z=this.b.get(F.channelName);if(!Z){this.v(F);return}const te=F.id,ae=Z.listen(this.j,F.name,F.arg)(V=>this.m({id:te,data:V,type:204}));this.d.set(F.id,ae)}u(F){const Z=this.d.get(F.id);Z&&(Z.dispose(),this.d.delete(F.id))}v(F){let Z=this.g.get(F.channelName);Z||(Z=[],this.g.set(F.channelName,Z));const te=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:F,timeoutTimer:te})}w(F){const Z=this.g.get(F);if(Z){for(const te of Z)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.s(te.request);break;case 102:this.t(te.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=h;var m;(function(Y){Y[Y.LocalSide=0]="LocalSide",Y[Y.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(F,Z=null){this.l=F,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new C.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(te=>this.s(te)),this.j=Z}getChannel(F){const Z=this;return{call(te,se,ae){return Z.a?Promise.reject(new P.CancellationError):Z.m(F,te,se,ae)},listen(te,se){return Z.a?C.Event.None:Z.o(F,te,se)}}}m(F,Z,te,se=D.CancellationToken.None){const ae=this.g++,B={id:ae,type:100,channelName:F,name:Z,arg:te};if(se.isCancellationRequested)return Promise.reject(new P.CancellationError);let U;return new Promise((G,ee)=>{if(se.isCancellationRequested)return ee(new P.CancellationError);const K=()=>{const he=pe=>{switch(pe.type){case 201:this.f.delete(ae),G(pe.data);break;case 202:{this.f.delete(ae);const me=new Error(pe.data.message);me.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,me.name=pe.data.name,ee(me);break}case 203:this.f.delete(ae),ee(pe.data);break}};this.f.set(ae,he),this.p(B)};let Q=null;this.b===u.Idle?K():(Q=(0,O.createCancelablePromise)(he=>this.u()),Q.then(()=>{Q=null,K()}));const ie=()=>{Q?(Q.cancel(),Q=null):this.p({id:ae,type:101}),ee(new P.CancellationError)},le=se.onCancellationRequested(ie);U=(0,b.combinedDisposable)((0,b.toDisposable)(ie),le),this.d.add(U)}).finally(()=>{this.d.delete(U)})}o(F,Z,te){const se=this.g++,V={id:se,type:102,channelName:F,name:Z,arg:te};let B=null;const U=new C.Emitter({onWillAddFirstListener:()=>{B=(0,O.createCancelablePromise)(G=>this.u()),B.then(()=>{B=null,this.d.add(U),this.p(V)})},onDidRemoveLastListener:()=>{B?(B.cancel(),B=null):(this.d.delete(U),this.p({id:se,type:103}))}}),$=G=>U.fire(G.data);return this.f.set(se,$),U.event}p(F){switch(F.type){case 100:case 102:{const Z=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(Z,F.id,0,`${d(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const Z=this.q([F.type,F.id]);this.j?.logOutgoing(Z,F.id,0,d(F.type));return}}}q(F,Z=void 0){const te=new i;return a(te,F),a(te,Z),this.r(te.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const Z=new R(F),te=o(Z),se=o(Z),ae=te[0];switch(ae){case 200:return this.j?.logIncoming(F.byteLength,0,0,c(ae)),this.t({type:te[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,te[1],0,c(ae),se),this.t({type:te[0],id:te[1],data:se})}}t(F){if(F.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.dispose)(this.d.values()),this.d.clear()}}ye([k.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class A{get connections(){const F=[];return this.f.forEach(Z=>F.push(Z)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new C.Emitter,this.onDidAddConnection=this.g.event,this.h=new C.Emitter,this.onDidRemoveConnection=this.h.event,F(({protocol:Z,onDidClientDisconnect:te})=>{C.Event.once(Z.onMessage)(ae=>{const V=new R(ae),B=o(V),U=new h(Z,B),$=new v(Z);this.a.forEach((ee,K)=>U.registerChannel(K,ee));const G={channelServer:U,channelClient:$,ctx:B};this.f.add(G),this.g.fire(G),te(()=>{U.dispose(),$.dispose(),this.f.delete(G),this.h.fire(G)})})})}getChannel(F,Z){const te=this;return{call(se,ae,V){let B;if((0,y.isFunction)(Z)){const $=(0,L.getRandomElement)(te.connections.filter(Z));B=$?Promise.resolve($):C.Event.toPromise(C.Event.filter(te.onDidAddConnection,Z))}else B=Z.routeCall(te,se,ae);const U=B.then($=>$.channelClient.getChannel(F));return M(U).call(se,ae,V)},listen(se,ae){if((0,y.isFunction)(Z))return te.j(F,Z,se,ae);const V=Z.routeEvent(te,se,ae).then(B=>B.channelClient.getChannel(F));return M(V).listen(se,ae)}}}j(F,Z,te,se){const ae=this;let V=new b.DisposableStore;const B=new C.Emitter({onWillAddFirstListener:()=>{V=new b.DisposableStore;const U=new C.EventMultiplexer,$=new Map,G=K=>{const ie=K.channelClient.getChannel(F).listen(te,se),le=U.add(ie);$.set(K,le)},ee=K=>{const Q=$.get(K);!Q||(Q.dispose(),$.delete(K))};ae.connections.filter(Z).forEach(G),C.Event.filter(ae.onDidAddConnection,Z)(G,void 0,V),ae.onDidRemoveConnection(ee,void 0,V),U.event(B.fire,B,V),V.add(U)},onDidRemoveLastListener:()=>{V.dispose()}});return B.event}registerChannel(F,Z){this.a.set(F,Z),this.f.forEach(te=>{te.channelServer.registerChannel(F,Z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=A;class T{constructor(F,Z,te=null){const se=new i;a(se,Z),F.send(se.buffer),this.a=new v(F,te),this.d=new h(F,Z,te)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,Z){this.d.registerChannel(F,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=T;function M(Y){return{call(F,Z,te){return Y.then(se=>se.call(F,Z,te))},listen(F,Z){const te=new C.Relay;return Y.then(se=>te.input=se.listen(F,Z)),te.event}}}e.getDelayedChannel=M;function z(Y){let F=!1;return{call(Z,te,se){return F?Y.call(Z,te,se):(0,O.timeout)(0).then(()=>F=!0).then(()=>Y.call(Z,te,se))},listen(Z,te){if(F)return Y.listen(Z,te);const se=new C.Relay;return(0,O.timeout)(0).then(()=>F=!0).then(()=>se.input=Y.listen(Z,te)),se.event}}}e.getNextTickChannel=z;class H{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const Z of F.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await C.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.StaticRouter=H;var J;(function(Y){function F(ae,V){const B=ae,U=V&&V.disableMarshalling,$=new Map;for(const G in B)te(G)&&$.set(G,C.Event.buffer(B[G],!0));return new class{listen(G,ee,K){const Q=$.get(ee);if(Q)return Q;if(se(ee)){const ie=B[ee];if(typeof ie=="function")return ie.call(B,K)}throw new Error(`Event not found: ${ee}`)}call(G,ee,K){const Q=B[ee];if(typeof Q=="function"){if(!U&&Array.isArray(K))for(let ie=0;ie<K.length;ie++)K[ie]=(0,I.revive)(K[ie]);return Q.apply(B,K)}throw new Error(`Method not found: ${ee}`)}}}Y.fromService=F;function Z(ae,V){const B=V&&V.disableMarshalling;return new Proxy({},{get(U,$){if(typeof $=="string")return V?.properties?.has($)?V.properties.get($):se($)?function(G){return ae.listen($,G)}:te($)?ae.listen($):async function(...G){let ee;V&&!(0,y.isUndefinedOrNull)(V.context)?ee=[V.context,...G]:ee=G;const K=await ae.call($,ee);return B?K:(0,I.revive)(K)};throw new Error(`Property not found: ${String($)}`)}})}Y.toService=Z;function te(ae){return ae[0]==="o"&&ae[1]==="n"&&w.isUpperAsciiLetter(ae.charCodeAt(2))}function se(ae){return/^onDynamic/.test(ae)&&w.isUpperAsciiLetter(ae.charCodeAt(9))}})(J=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(Y){if(Array.isArray(Y))return Y;if(Y&&typeof Y=="object"&&typeof Y.toString=="function"){const F=Y.toString();if(F!=="[object Object]")return F}return Y}function j(Y){return Array.isArray(Y)?Y.map(N):N(Y)}function q(Y,F,Z,te,se,ae,V){V=j(V);const B=W[se],U=B[te%B.length];let $=[`%c[${Y}]%c[${String(F).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ae)?($=$.concat(V),$.push(")")):$.push(V),console.log.apply(console,$)}class x{constructor(F,Z){this.d=F,this.f=Z,this.a=0,this.b=0}logOutgoing(F,Z,te,se,ae){this.b+=F,q(this.d,this.b,F,Z,te,se,ae)}logIncoming(F,Z,te,se,ae){this.a+=F,q(this.f,this.a,F,Z,te,se,ae)}}e.IPCLogger=x}),define(re[149],oe([0,1,16,3,39]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class D{constructor(C){this.a=C,this.onMessage=O.Event.fromDOMEventEmitter(this.a,"message",b=>L.VSBuffer.wrap(b.data)),C.start()}send(C){this.a.postMessage(C.buffer)}disconnect(){this.a.close()}}e.Protocol=D;class k extends l.IPCClient{constructor(C,b){const I=new D(C);super(I,b),this.b=I}dispose(){this.b.disconnect()}}e.Client=k}),define(re[95],oe([0,1,6,16,3,2,39]),function(_,e,L,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(v){v.Created="created",v.Read="read",v.Write="write",v.Open="open",v.Error="error",v.Close="close",v.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",v.NodeEndReceived="nodeEndReceived",v.NodeEndSent="nodeEndSent",v.NodeDrainBegin="nodeDrainBegin",v.NodeDrainEnd="nodeDrainEnd",v.zlibInflateError="zlibInflateError",v.zlibInflateData="zlibInflateData",v.zlibInflateInitialWrite="zlibInflateInitialWrite",v.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",v.zlibInflateWrite="zlibInflateWrite",v.zlibInflateFlushFired="zlibInflateFlushFired",v.zlibDeflateError="zlibDeflateError",v.zlibDeflateData="zlibDeflateData",v.zlibDeflateWrite="zlibDeflateWrite",v.zlibDeflateFlushFired="zlibDeflateFlushFired",v.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",v.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",v.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",v.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",v.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",v.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",v.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",v.ProtocolHeaderRead="protocolHeaderRead",v.ProtocolMessageRead="protocolMessageRead",v.ProtocolHeaderWrite="protocolHeaderWrite",v.ProtocolMessageWrite="protocolMessageWrite",v.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var C;(function(v){v.enableDiagnostics=!1,v.records=[];const A=new WeakMap;let T=0;function M(H,J){if(!A.has(H)){const W=String(++T);A.set(H,W)}return A.get(H)}function z(H,J,W,N){if(!v.enableDiagnostics)return;const j=M(H,J);if(N instanceof O.VSBuffer||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const q=O.VSBuffer.alloc(N.byteLength);q.set(N),v.records.push({timestamp:Date.now(),id:j,label:J,type:W,buff:q})}else v.records.push({timestamp:Date.now(),id:j,label:J,type:W,data:N})}v.traceSocketEvent=z})(C=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(v){v[v.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",v[v.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function w(){return I||(I=O.VSBuffer.alloc(0)),I}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(A){this.a.push(A),this.b+=A.byteLength}read(A){return this.c(A,!0)}peek(A){return this.c(A,!1)}c(A,T){if(A===0)return w();if(A>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===A){const J=this.a[0];return T&&(this.a.shift(),this.b-=A),J}if(this.a[0].byteLength>A){const J=this.a[0].slice(0,A);return T&&(this.a[0]=this.a[0].slice(A),this.b-=A),J}const M=O.VSBuffer.alloc(A);let z=0,H=0;for(;A>0;){const J=this.a[H];if(J.byteLength>A){const W=J.slice(0,A);M.set(W,z),z+=A,T&&(this.a[H]=J.slice(A),this.b-=A),A-=A}else M.set(J,z),z+=J.byteLength,T?(this.a.shift(),this.b-=J.byteLength):H++,A-=J.byteLength}return M}}e.ChunkStream=y;var p;(function(v){v[v.None=0]="None",v[v.Regular=1]="Regular",v[v.Control=2]="Control",v[v.Ack=3]="Ack",v[v.Disconnect=5]="Disconnect",v[v.ReplayRequest=6]="ReplayRequest",v[v.Pause=7]="Pause",v[v.Resume=8]="Resume",v[v.KeepAlive=9]="KeepAlive",v[v.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",v[v.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(p||(p={}));function d(v){switch(v){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var E;(function(v){v[v.HeaderLength=13]="HeaderLength",v[v.AcknowledgeTime=2e3]="AcknowledgeTime",v[v.TimeoutTime=2e4]="TimeoutTime",v[v.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",v[v.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",v[v.KeepAliveSendTime=5e3]="KeepAliveSendTime",v[v.LatencySampleTime=6e4]="LatencySampleTime",v[v.LatencySampleCount=5]="LatencySampleCount",v[v.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",v[v.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(A,T,M,z){this.type=A,this.id=T,this.ack=M,this.data=z,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends D.Disposable{constructor(A){super(),this.f=this.B(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=A,this.b=!1,this.c=new y,this.B(this.a.onData(T=>this.acceptChunk(T))),this.lastReadTime=Date.now()}acceptChunk(A){if(!(!A||A.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(A);this.c.byteLength>=this.g.readLen;){const T=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=T.readUInt32BE(9),this.g.messageType=T.readUInt8(0),this.g.id=T.readUInt32BE(1),this.g.ack=T.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const M=this.g.messageType,z=this.g.id,H=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",T),this.f.fire(new c(M,z,H,T)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(A){this.k=null,this.a=!1,this.b=!1,this.c=A,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(A){if(this.a)return;A.writtenTime=Date.now(),this.lastWriteTime=Date.now();const T=O.VSBuffer.alloc(13);T.writeUInt8(A.type,0),T.writeUInt32BE(A.id,1),T.writeUInt32BE(A.ack,5),T.writeUInt32BE(A.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(A.type),id:A.id,ack:A.ack,messageSize:A.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",A.data),this.j(T,A.data)}g(A,T){const M=this.f===0;return this.d.push(A,T),this.f+=A.byteLength+T.byteLength,M}h(){const A=O.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,A}j(A,T){this.g(A,T)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const A=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:A.byteLength}),this.c.write(A)}}class f extends D.Disposable{constructor(A){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=A,this.b=this.B(new g(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(T=>{T.type===1&&this.f.fire(T.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(A){this.b.write(new c(1,0,0,A))}}e.Protocol=f;class S extends k.IPCClient{static fromSocket(A,T){return new S(new f(A),T)}get onDidDispose(){return this.b.onDidDispose}constructor(A,T,M=null){super(A,T,M),this.b=A}dispose(){super.dispose();const A=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),A.end()}}e.Client=S;class R{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(A){this.b?this.d.length>0?this.d.push(A):this.a.fire(A):this.d.push(A)}flushBuffer(){this.d=[]}}e.BufferedEmitter=R;class i{constructor(A){this.data=A,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let A=0,T=this.a;for(;T;)T=T.next,A++;return A}peek(){return this.a?this.a.data:null}toArray(){const A=[];let T=0,M=this.a;for(;M;)A[T++]=M.data,M=M.next;return A}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(A){const T=new i(A);if(!this.a){this.a=T,this.b=T;return}this.b.next=T,this.b=T}}class t{static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const A=Date.now();for(let T=0;T<t.a;T++)this.c[T]=A-1e3*T;setInterval(()=>{for(let T=t.a;T>=1;T--)this.c[T]=this.c[T-1];this.c[0]=Date.now()},1e3)}d(){const A=Date.now(),T=(1+t.a)*1e3;let M=0;for(let z=0;z<t.a;z++)A-this.c[z]<=T&&M++;return 1-M/t.a}hasHighLoad(){return this.d()>=.5}}t.a=10,t.b=null;var n;(function(v){v[v.Good=0]="Good",v[v.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function s(v){switch(v){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class a{constructor(A){this.connectionHealth=A}}e.ConnectionHealthChangedEvent=a;class o{constructor(A,T){this.roundTripTime=A,this.recentHighRoundTripCount=T}}e.HighRoundTripTimeEvent=o;class h{get unacknowledgedCount(){return this.c-this.d}constructor(A){this.x=new R,this.onControlMessage=this.x.event,this.y=new R,this.onMessage=this.y.event,this.z=new R,this.onDidDispose=this.z.event,this.A=new R,this.onSocketClose=this.A.event,this.B=new R,this.onSocketTimeout=this.B.event,this.C=new R,this.onHighRoundTripTime=this.C.event,this.D=new R,this.onDidChangeConnectionHealth=this.D.event,this.u=A.loadEstimator??t.getInstance(),this.v=A.measureRoundTripTime??!1,this.w=A.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new D.DisposableStore,this.o=A.socket,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(T=>this.E(T))),this.t.add(this.o.onClose(T=>this.A.fire(T))),this.r=this.t.add(new m),this.t.add(this.r.onSendLatencyRequest(T=>this.J(T))),this.t.add(this.r.onHighRoundTripTime(T=>this.C.fire(T))),this.t.add(this.r.onDidChangeConnectionHealth(T=>this.D.fire(T))),this.v&&this.r.start(),A.initialChunk&&this.q.acceptChunk(A.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const A=new c(5,0,0,w());this.p.write(A),this.p.flush()}sendPause(){const A=new c(7,0,0,w());this.p.write(A)}sendResume(){const A=new c(8,0,0,w());this.p.write(A)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(A,T){this.a=!0,this.t.dispose(),this.t=new D.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=A,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(M=>this.E(M))),this.t.add(this.o.onClose(M=>this.A.fire(M))),this.r=this.t.add(new m),this.t.add(this.r.onSendLatencyRequest(M=>this.J(M))),this.t.add(this.r.onHighRoundTripTime(M=>this.C.fire(M))),this.t.add(this.r.onDidChangeConnectionHealth(M=>this.D.fire(M))),this.q.acceptChunk(T)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const A=new c(3,0,this.h,w());this.p.write(A);const T=this.b.toArray();for(let M=0,z=T.length;M<z;M++)this.p.write(T[M]);this.G()}acceptDisconnect(){this.z.fire()}E(A){if(A.ack>this.d){this.d=A.ack;do{const T=this.b.peek();if(T&&T.id<=A.ack)this.b.pop();else break}while(!0)}switch(A.type){case 0:break;case 1:{if(A.id>this.g)if(A.id!==this.g+1){const T=Date.now();T-this.m>1e4&&(this.m=T,this.p.write(new c(6,0,0,w())))}else this.g=A.id,this.j=Date.now(),this.F(),this.y.fire(A.data);break}case 2:{this.x.fire(A.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const T=this.b.toArray();for(let M=0,z=T.length;M<z;M++)this.p.write(T[M]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(A.data);break}case 11:{this.r.handleResponse(A.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(A){const T=++this.c;this.h=this.g;const M=new c(1,T,this.h,A);this.b.push(M),this.a||(this.p.write(M),this.G())}sendControl(A){const T=new c(2,0,0,A);this.p.write(T)}F(){if(this.g<=this.h||this.k)return;const A=Date.now()-this.j;if(A>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-A+5)}G(){if(this.c<=this.d||this.f||this.a)return;const A=this.b.peek(),T=Date.now()-A.writtenTime,M=Date.now()-this.q.lastReadTime,z=Date.now()-this.n;if(T>=2e4&&M>=2e4&&z>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:T,timeSinceLastReceivedSomeData:M});return}const H=Math.max(2e4-T,2e4-M,2e4-z,500);this.f=setTimeout(()=>{this.f=null,this.G()},H)}H(){if(this.g<=this.h)return;this.h=this.g;const A=new c(3,0,this.h,w());this.p.write(A)}I(){this.h=this.g;const A=new c(9,0,this.h,w());this.p.write(A)}J(A){this.h=this.g;const T=new c(10,0,this.h,A);this.p.write(T)}K(A){this.h=this.g;const T=new c(11,0,this.h,A);this.p.write(T)}}e.PersistentProtocol=h;class m extends D.Disposable{constructor(){super(),this.a=this.B(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new L.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},A=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const A=++this.h,T=O.VSBuffer.alloc(4);T.writeUInt32BE(A,0),this.a.fire(T)},6e4)}handleResponse(A){if(A.byteLength!==4)return;const T=A.readUInt32BE(0);if(this.g<=0||T!==this.h)return;const M=Date.now()-this.g,z=this.k++;this.j[z%this.j.length]=M;const H=this.l,J=this.j.filter(W=>W>=1e3).length;this.l=J>=3?1:0,M>1e3&&this.b.fire(new o(M,J)),H!==this.l&&this.c.fire(this.l)}}}),define(re[150],oe([0,1,151,3,39,149]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends l.IPCServer{static b(){const C=O.Event.fromNodeEventEmitter(L.ipcRenderer,"vscode:createMessageChannel",(b,I)=>I);return O.Event.map(C,b=>{const{port1:I,port2:w}=new MessageChannel,p={protocol:new D.Protocol(I),onDidClientDisconnect:O.Event.fromDOMEventEmitter(I,"close")};return L.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[w]),p})}constructor(){super(k.b())}}e.Server=k}),define(re[65],oe([0,1,50,6,16,25,144,9,3,2,32,94,87,39]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends p.ChannelServer{constructor(u){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",g=>l.VSBuffer.wrap(Buffer.from(g,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=d;class E{constructor(u,g){this.i=u,this.j=g,this.c=new Set,this.g=new Map,this.h=new C.Emitter,this.onDidProcessExit=this.h.event;const f=g&&g.timeout?g.timeout:6e4;this.b=new O.Delayer(f),this.d=null,this.f=null}getChannel(u){const g=this;return{call(f,S,R){return g.k(u,f,S,R)},listen(f,S){return g.l(u,f,S)}}}k(u,g,f,S=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const R=this.n(u),i=(0,O.createCancelablePromise)(n=>R.call(g,f,n)),r=S.onCancellationRequested(()=>i.cancel()),t=(0,b.toDisposable)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(u,g,f){if(!this.b)return C.Event.None;this.b.cancel();let S;const R=new C.Emitter({onWillAddFirstListener:()=>{S=this.n(u).listen(g,f)(R.fire,R),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return R.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,y.removeDangerousEnvVariables)(g.env),this.d=(0,L.fork)(this.i,u,g);const f=new C.Emitter;C.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,k.isRemoteConsoleLog)(s)){(0,k.log)(s,`IPC Library: ${this.j.serverName}`);return}f.fire(l.VSBuffer.wrap(Buffer.from(s,"base64")))});const R=this.j.useQueue?(0,w.createQueuedSender)(this.d):this.d,i=s=>this.d&&this.d.connected&&R.send(s.buffer.toString("base64")),r=f.event,t={send:i,onMessage:r};this.f=new p.ChannelClient(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,a)=>{process.removeListener("exit",n),this.c.forEach(o=>(0,b.dispose)(o)),this.c.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:a})})}return this.f}n(u){let g=this.g.get(u);return g||(g=this.m.getChannel(u),this.g.set(u,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=E}),define(re[152],oe([0,1,86,16,39,3,12,21]),function(_,e,L,O,l,D,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class C{constructor(y){this.a=y,this.onMessage=D.Event.fromNodeEventEmitter(this.a,"message",p=>O.VSBuffer.wrap(p.data)),y.start()}send(y){this.a.postMessage(y.buffer)}disconnect(){this.a.close()}}class b extends l.IPCServer{static b(){(0,k.assertType)((0,L.isUtilityProcess)(process),"Electron Utility Process");const y=new D.Emitter;return process.parentPort.on("message",p=>{const d=(0,P.firstOrDefault)(p.ports);d&&y.fire(d)}),D.Event.map(y.event,p=>({protocol:new C(p),onDidClientDisconnect:D.Event.fromNodeEventEmitter(p,"close")}))}constructor(){super(b.b())}}e.Server=b;function I(w,y,p){const d=E=>{E.data===y&&(w.removeListener("message",d),p())};w.on("message",d)}e.once=I}),define(re[153],oe([0,1,16,9,3,2,13,4,31,39,95]),function(_,e,L,O,l,D,k,P,C,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class y{traceSocketEvent(o,h){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,h)}constructor(o,h=""){this.f=!0,this.debugLabel=h,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=m=>{if(this.traceSocketEvent("error",{code:m?.code,message:m?.message}),m){if(m.code==="EPIPE")return;(0,O.onUnexpectedError)(m)}},this.socket.on("error",this.a),this.b=m=>{this.traceSocketEvent("close",{hadError:m}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const h=m=>{this.traceSocketEvent("read",m),o(L.VSBuffer.wrap(m))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(o){const h=m=>{o({type:0,hadError:m,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(o){const h=()=>{o()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,O.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,O.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const m=()=>{this.socket.off("close",m),this.socket.off("end",m),this.socket.off("error",m),this.socket.off("timeout",m),this.socket.off("drain",m),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",m),this.socket.on("end",m),this.socket.on("error",m),this.socket.on("timeout",m),this.socket.on("drain",m)})}}e.NodeSocket=y;var p;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize",a[a.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var d;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(d||(d={}));class E extends D.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,h){this.socket.traceSocketEvent(o,h)}constructor(o,h,m,v){super(),this.f=this.B(new l.Emitter),this.g=this.B(new l.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:m?.byteLength||0,recordInflateBytes:v}),this.a=this.B(new c(this,h,m,v,this.f,(A,T)=>this.k(A,T))),this.B(this.a.onError(A=>{console.error(A),(0,O.onUnexpectedError)(A),this.g.fire({type:0,hadError:!0,error:A})})),this.b=new I.ChunkStream,this.B(this.socket.onData(A=>this.l(A))),this.B(this.socket.onClose(async A=>{this.a.isProcessingReadQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(A)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){let h=0;for(;h<o.byteLength;)this.a.writeMessage(o.slice(h,Math.min(h+262144,o.byteLength))),h+=262144}k(o,h){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let m=2;o.byteLength<126?m+=0:o.byteLength<2**16?m+=2:m+=8;const v=L.VSBuffer.alloc(m);if(h?v.writeUInt8(194,0):v.writeUInt8(130,0),o.byteLength<126)v.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){v.writeUInt8(126,1);let A=1;v.writeUInt8(o.byteLength>>>8&255,++A),v.writeUInt8(o.byteLength>>>0&255,++A)}else{v.writeUInt8(127,1);let A=1;v.writeUInt8(0,++A),v.writeUInt8(0,++A),v.writeUInt8(0,++A),v.writeUInt8(0,++A),v.writeUInt8(o.byteLength>>>24&255,++A),v.writeUInt8(o.byteLength>>>16&255,++A),v.writeUInt8(o.byteLength>>>8&255,++A),v.writeUInt8(o.byteLength>>>0&255,++A)}this.socket.write(L.VSBuffer.concat([v,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const h=this.b.peek(this.j.readLen),m=h.readUInt8(0),v=(m&128)>>>7,A=(m&64)>>>6,T=h.readUInt8(1),M=(T&128)>>>7,z=T&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(z===126?2:0)+(z===127?8:0),this.j.fin=v,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(A)),this.j.firstFrameOfMessage=Boolean(v),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const h=this.b.read(this.j.readLen),m=h.readUInt8(1),v=(m&128)>>>7;let A=m&127,T=1;A===126?A=h.readUInt8(++T)*2**8+h.readUInt8(++T):A===127&&(A=h.readUInt8(++T)*0+h.readUInt8(++T)*0+h.readUInt8(++T)*0+h.readUInt8(++T)*0+h.readUInt8(++T)*2**24+h.readUInt8(++T)*2**16+h.readUInt8(++T)*2**8+h.readUInt8(++T));let M=0;v&&(M=h.readUInt8(++T)*2**24+h.readUInt8(++T)*2**16+h.readUInt8(++T)*2**8+h.readUInt8(++T)),this.j.state=3,this.j.readLen=A,this.j.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const h=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),f(h,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(h,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=E;class c extends D.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.VSBuffer.alloc(0)}constructor(o,h,m,v,A,T){super(),this.l=o,this.m=A,this.n=T,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new l.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new l.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,h?(this.b=this.B(new u(this.l,v,m,{windowBits:15})),this.f=this.B(new g(this.l,{windowBits:15})),this.B(this.b.onError(M=>this.a.fire(M))),this.B(this.f.onError(M=>this.a.fire(M)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const h=await this.s(this.f,o);this.n(h,!0)}else this.n(o,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(o,h){return new Promise((m,v)=>{o.write(h),o.flush(A=>m(A))})}acceptFrame(o,h,m){this.h.push({data:o,isCompressed:h,isLastFrameOfMessage:m}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const h=await this.w(this.b,o.data,o.isLastFrameOfMessage);this.m.fire(h)}else this.m.fire(o.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(o,h,m){return new Promise((v,A)=>{o.write(h),m&&o.write(L.VSBuffer.fromByteArray([0,0,255,255])),o.flush(T=>v(T))})}}class u extends D.Disposable{get recordedInflateBytes(){return this.j?L.VSBuffer.concat(this.f):L.VSBuffer.alloc(0)}constructor(o,h,m,v){super(),this.h=o,this.j=h,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=w().zlib.createInflateRaw(v),this.b.on("error",A=>{this.h.traceSocketEvent("zlibInflateError",{message:A?.message,code:A?.code}),this.a.fire(A)}),this.b.on("data",A=>{this.h.traceSocketEvent("zlibInflateData",A),this.g.push(L.VSBuffer.wrap(A))}),m&&(this.h.traceSocketEvent("zlibInflateInitialWrite",m.buffer),this.b.write(m.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const h=L.VSBuffer.concat(this.g);this.g.length=0,o(h)})}}class g extends D.Disposable{constructor(o,h){super(),this.g=o,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.b=w().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",m=>{this.g.traceSocketEvent("zlibDeflateError",{message:m?.message,code:m?.code}),this.a.fire(m)}),this.b.on("data",m=>{this.g.traceSocketEvent("zlibDeflateData",m),this.f.push(L.VSBuffer.wrap(m))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let h=L.VSBuffer.concat(this.f);this.f.length=0,h=h.slice(0,h.byteLength-4),o(h)})}}function f(a,o){if(o===0)return;const h=a.byteLength>>>2;for(let z=0;z<h;z++){const H=a.readUInt32BE(z*4);a.writeUInt32BE(H^o,z*4)}const m=h*4,v=a.byteLength-m,A=o>>>24&255,T=o>>>16&255,M=o>>>8&255;v>=1&&a.writeUInt8(a.readUInt8(m)^A,m),v>=2&&a.writeUInt8(a.readUInt8(m+1)^T,m+1),v>=3&&a.writeUInt8(a.readUInt8(m+2)^M,m+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const S={[2]:107,[1]:103};function R(){const a=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;const o=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:w().os.tmpdir(),h=(0,k.join)(o,`vscode-ipc-${a}.sock`);return r(h),h}e.createRandomIPCHandle=R;function i(a,o,h){const m=w().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${m}-${h}-${o}-sock`;const v=h.substr(0,4),A=o.substr(0,6),T=m.substr(0,8);let M;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?M=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${T}-${v}-${A}.sock`):M=(0,k.join)(a,`${v}-${A}.sock`),r(M),M}e.createStaticIPCHandle=i;function r(a){const o=S[P.platform];typeof o=="number"&&a.length>=o&&console.warn(`WARNING: IPC handle "${a}" is longer than ${o} chars, try a shorter --user-data-dir`)}class t extends b.IPCServer{static b(o){const h=l.Event.fromNodeEventEmitter(o,"connection");return l.Event.map(h,m=>({protocol:new I.Protocol(new y(m,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(m,"close"))}))}constructor(o){super(t.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function n(a){return new Promise((o,h)=>{const m=w().net.createServer();m.on("error",h),m.listen(a,()=>{m.removeListener("error",h),o(new t(m))})})}e.serve=n;function s(a,o){return new Promise((h,m)=>{const v=w().net.createConnection(a,()=>{v.removeListener("error",m),h(I.Client.fromSocket(new y(v,`ipc-client${o}`),o))});v.once("error",m)})}e.connect=s}),define(re[66],oe([0,1,6,3,2,12]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k=e.StorageHint||(e.StorageHint={}));function P(w){const y=w;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var C;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(C=e.StorageState||(e.StorageState={}));class b extends l.Disposable{constructor(y,p=Object.create(null)){super(),this.m=y,this.n=p,this.b=this.B(new O.Emitter),this.onDidChangeStorage=this.b.event,this.c=C.None,this.f=new Map,this.g=new L.ThrottledDelayer(b.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(y=>this.r(y)))}r(y){y.changed?.forEach((p,d)=>this.s(d,p)),y.deleted?.forEach(p=>this.s(p,void 0))}s(y,p){if(this.c===C.Closed)return;let d=!1;(0,D.isUndefinedOrNull)(p)?d=this.f.delete(y):this.f.get(y)!==p&&(this.f.set(y,p),d=!0),d&&this.b.fire(y)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===C.None&&(this.c=C.Initialized,this.n.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(y,p){const d=this.f.get(y);return(0,D.isUndefinedOrNull)(d)?p:d}getBoolean(y,p){const d=this.get(y);return(0,D.isUndefinedOrNull)(d)?p:d==="true"}getNumber(y,p){const d=this.get(y);return(0,D.isUndefinedOrNull)(d)?p:parseInt(d,10)}async set(y,p){if(this.c===C.Closed)return;if((0,D.isUndefinedOrNull)(p))return this.delete(y);const d=String(p);if(this.f.get(y)!==d)return this.f.set(y,d),this.j.set(y,d),this.h.delete(y),this.b.fire(y),this.w()}async delete(y){if(!(this.c===C.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire(y),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=C.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(y).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(y){if(!!this.u)return this.w(y)}async w(y){return this.g.trigger(()=>this.v(),y)}async whenFlushed(){if(!!this.u)return new Promise(y=>this.l.push(y))}isInMemory(){return this.n.hint===k.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}b.a=100,e.Storage=b;class I{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((p,d)=>this.a.set(d,p)),y.delete?.forEach(p=>this.a.delete(p))}async close(){}}e.InMemoryStorageDatabase=I}),define(re[154],oe([10,7]),function(_,e){return _.create("vs/base/node/zip",e)}),define(re[155],oe([10,7]),function(_,e){return _.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[156],oe([10,7]),function(_,e){return _.create("vs/platform/environment/node/argv",e)}),define(re[157],oe([10,7]),function(_,e){return _.create("vs/platform/environment/node/argvHelper",e)}),define(re[158],oe([10,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[159],oe([10,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[160],oe([10,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[161],oe([10,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionTipsService",e)}),define(re[162],oe([10,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[163],oe([10,7]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[164],oe([10,7]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[165],oe([10,7]),function(_,e){return _.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[166],oe([10,7]),function(_,e){return _.create("vs/platform/files/common/fileService",e)}),define(re[167],oe([10,7]),function(_,e){return _.create("vs/platform/files/common/files",e)}),define(re[168],oe([10,7]),function(_,e){return _.create("vs/platform/files/common/io",e)}),define(re[169],oe([10,7]),function(_,e){return _.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[170],oe([10,7]),function(_,e){return _.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[171],oe([10,7]),function(_,e){return _.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(re[172],oe([10,7]),function(_,e){return _.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(re[173],oe([10,7]),function(_,e){return _.create("vs/platform/request/common/request",e)}),define(re[174],oe([10,7]),function(_,e){return _.create("vs/platform/shell/node/shellEnv",e)}),define(re[175],oe([10,7]),function(_,e){return _.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(re[176],oe([10,7]),function(_,e){return _.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[177],oe([10,7]),function(_,e){return _.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[178],oe([10,7]),function(_,e){return _.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[179],oe([10,7]),function(_,e){return _.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[180],oe([10,7]),function(_,e){return _.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[181],oe([10,7]),function(_,e){return _.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[182],oe([10,7]),function(_,e){return _.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[183],oe([10,7]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[184],oe([10,7]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[185],oe([10,7]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(re[186],oe([10,7]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[187],oe([10,7]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[188],oe([10,7]),function(_,e){return _.create("vs/platform/workspace/common/workspace",e)}),define(re[189],oe([0,1,9]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var O;(function(D){D[D.LParen=0]="LParen",D[D.RParen=1]="RParen",D[D.Neg=2]="Neg",D[D.Eq=3]="Eq",D[D.NotEq=4]="NotEq",D[D.Lt=5]="Lt",D[D.LtEq=6]="LtEq",D[D.Gt=7]="Gt",D[D.GtEq=8]="GtEq",D[D.RegexOp=9]="RegexOp",D[D.RegexStr=10]="RegexStr",D[D.True=11]="True",D[D.False=12]="False",D[D.In=13]="In",D[D.Not=14]="Not",D[D.And=15]="And",D[D.Or=16]="Or",D[D.Str=17]="Str",D[D.QuotedStr=18]="QuotedStr",D[D.Error=19]="Error",D[D.EOF=20]="EOF"})(O=e.TokenType||(e.TokenType={}));class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(k){if(k.type!==19)throw(0,L.illegalArgument)(`expected an error token but got ${JSON.stringify(k)}`);switch(k.lexeme){case"=":return`Unexpected token '${k.lexeme}' at offset ${k.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${k.lexeme}' at offset ${k.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${k.lexeme}' at offset ${k.offset}. Did you mean '||'?`;default:{const P=k.lexeme;return P&&P.length>1&&P.startsWith("'")?`Unexpected token '${k.lexeme}' at offset ${k.offset}. Did you forget to close the string?`:P&&P.length>1&&P.endsWith("'")?`Unexpected token '${k.lexeme}' at offset ${k.offset}. Did you forget to open the string?`:`Unexpected token '${k.lexeme}' at offset ${k.offset}`}}}static getLexeme(k){switch(k.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return k.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return k.lexeme;case 18:return k.lexeme;case 19:return k.lexeme;case 20:return"EOF";default:throw(0,L.illegalState)(`unhandled token type: ${JSON.stringify(k)}; have you forgotten to add a case?`)}}get errorTokens(){return this.g}reset(k){return this.c=k,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:this.k(this.h(61)?4:2);break;case 39:this.o();break;case 47:this.q();break;case 61:this.h(61)?this.k(3):this.h(126)?this.k(9):this.l();break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l();break;case 124:this.h(124)?this.k(16):this.l();break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(k){return this.r()||this.c.charCodeAt(this.e)!==k?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(k){this.f.push({type:k,offset:this.d})}l(){const k={type:19,offset:this.d,lexeme:this.c.substring(this.d,this.e)};this.g.push(k),this.f.push(k)}n(){this.m.lastIndex=this.d;const k=this.m.exec(this.c);if(k){this.e=this.d+k[0].length;const P=this.c.substring(this.d,this.e),C=l.b.get(P);C?this.k(C):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l();return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let k=this.e,P=!1,C=!1;for(;;){if(k>=this.c.length){this.e=k,this.l();return}const I=this.c.charCodeAt(k);if(P)P=!1;else if(I===47&&!C){k++;break}else I===91?C=!0:I===92?P=!0:I===93&&(C=!1);k++}for(;k<this.c.length&&l.a.has(this.c.charCodeAt(k));)k++;this.e=k;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}l.a=new Set(["i","g","s","m","y","u"].map(D=>D.charCodeAt(0))),l.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=l}),define(re[190],oe([0,1,63,61,22,13,36,23,11]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class b{get appRoot(){return(0,D.dirname)(l.FileAccess.asFileUri("").fsPath)}get userHome(){return C.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return C.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.b.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const p=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",p)}return C.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(C.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=k.env.VSCODE_PORTABLE;return p?C.URI.file((0,D.join)(p,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,D.resolve)(p):(0,D.normalize)((0,D.join)(l.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?C.URI.file((0,D.resolve)(p)):C.URI.file((0,D.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,D.resolve)(p);const d=k.env.VSCODE_EXTENSIONS;if(d)return d;const E=k.env.VSCODE_PORTABLE;return E?(0,D.join)(E,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(d=>/^[^:/?#]+?:\/\//.test(d)?C.URI.parse(d):C.URI.file((0,D.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?C.URI.parse(p):C.URI.file((0,D.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(p))}get extensionLogLevel(){const p=[];for(const d of this.args.log||[]){const E=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(d);E&&E[1]&&E[2]&&p.push([E[1],E[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=k.env.VSCODE_PORTABLE;return p?C.URI.file((0,D.join)(p,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,d,E){this.a=p,this.b=d,this.c=E,this.editSessionId=this.args.editSessionId}}ye([O.memoize],b.prototype,"appRoot",null),ye([O.memoize],b.prototype,"userHome",null),ye([O.memoize],b.prototype,"userDataPath",null),ye([O.memoize],b.prototype,"appSettingsHome",null),ye([O.memoize],b.prototype,"tmpDir",null),ye([O.memoize],b.prototype,"cacheHome",null),ye([O.memoize],b.prototype,"stateResource",null),ye([O.memoize],b.prototype,"userRoamingDataHome",null),ye([O.memoize],b.prototype,"userDataSyncHome",null),ye([O.memoize],b.prototype,"sync",null),ye([O.memoize],b.prototype,"machineSettingsResource",null),ye([O.memoize],b.prototype,"workspaceStorageHome",null),ye([O.memoize],b.prototype,"localHistoryHome",null),ye([O.memoize],b.prototype,"keyboardLayoutResource",null),ye([O.memoize],b.prototype,"argvResource",null),ye([O.memoize],b.prototype,"isExtensionDevelopment",null),ye([O.memoize],b.prototype,"untitledWorkspacesHome",null),ye([O.memoize],b.prototype,"installSourcePath",null),ye([O.memoize],b.prototype,"builtinExtensionsPath",null),ye([O.memoize],b.prototype,"extensionsPath",null),ye([O.memoize],b.prototype,"extensionDevelopmentLocationURI",null),ye([O.memoize],b.prototype,"extensionDevelopmentKind",null),ye([O.memoize],b.prototype,"extensionTestsLocationURI",null),ye([O.memoize],b.prototype,"debugExtensionHost",null),ye([O.memoize],b.prototype,"logLevel",null),ye([O.memoize],b.prototype,"extensionLogLevel",null),ye([O.memoize],b.prototype,"serviceMachineIdResource",null),ye([O.memoize],b.prototype,"disableTelemetry",null),ye([O.memoize],b.prototype,"disableWorkspaceTrust",null),ye([O.memoize],b.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=b;function I(y,p){return w(y["inspect-extensions"],y["inspect-brk-extensions"],5870,p,y.debugId,y.extensionEnvironment)}e.parseExtensionHostDebugPort=I;function w(y,p,d,E,c,u){const f=Number(p||y)||(E?null:d),S=f?Boolean(!!p):!1;let R;if(u)try{R=JSON.parse(u)}catch{}return{port:f,break:S,debugId:c,env:R}}e.parseDebugParams=w}),define(re[191],oe([0,1,290,4,156]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,l.localize)(0,null),e:(0,l.localize)(1,null),t:(0,l.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,l.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,l.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,l.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,l.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,l.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,l.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,l.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,l.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,l.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,l.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,l.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,l.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,l.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,l.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,l.localize)(17,null)},category:{type:"string",cat:"e",description:(0,l.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,l.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,l.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,l.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,l.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,l.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,l.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,l.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,l.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,l.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,l.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,l.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,l.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,l.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,l.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,l.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,l.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,l.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(E,c,u=k){const g=E.find(a=>a.length>0&&a[0]!=="-"),f={},S=["_"],R=[],i={};let r;for(const a in c){const o=c[a];o.type==="subcommand"?a===g&&(r=o):(o.alias&&(f[a]=o.alias),o.type==="string"||o.type==="string[]"?(S.push(a),o.deprecates&&S.push(...o.deprecates)):o.type==="boolean"&&(R.push(a),o.deprecates&&R.push(...o.deprecates)),o.global&&(i[a]=o))}if(r&&g){const a=i;for(const v in r.options)a[v]=r.options[v];const o=E.filter(v=>v!==g),h=u.getSubcommandReporter?u.getSubcommandReporter(g):void 0,m=P(o,a,h);return{[g]:m,_:[]}}const t=L(E,{string:S,boolean:R,alias:f}),n={},s=t;n._=t._.map(a=>String(a)).filter(a=>a.length>0),delete s._;for(const a in c){const o=c[a];if(o.type==="subcommand")continue;o.alias&&delete s[o.alias];let h=s[a];if(o.deprecates)for(const m of o.deprecates)s.hasOwnProperty(m)&&(h||(h=s[m],h&&u.onDeprecatedOption(m,o.deprecationMessage||(0,l.localize)(36,null,a))),delete s[m]);if(typeof h<"u"){if(o.type==="string[]"){if(Array.isArray(h)||(h=[h]),!o.allowEmptyValue){const m=h.filter(v=>v.length>0);m.length!==h.length&&(u.onEmptyValue(a),h=m.length>0?m:void 0)}}else o.type==="string"&&(Array.isArray(h)?(h=h.pop(),u.onMultipleValues(a,h)):!h&&!o.allowEmptyValue&&(u.onEmptyValue(a),h=void 0));n[a]=h,o.deprecationMessage&&u.onDeprecatedOption(a,o.deprecationMessage)}delete s[a]}for(const a in s)u.onUnknownOption(a);return n}e.parseArgs=P;function C(E,c){let u="";return c.args&&(Array.isArray(c.args)?u=` <${c.args.join("> <")}>`:u=` <${c.args}>`),c.alias?`-${c.alias} --${E}${u}`:`--${E}${u}`}function b(E,c){const u=[];for(const g in E){const f=E[g],S=C(g,f);u.push([S,f.description])}return I(u,c)}e.formatOptions=b;function I(E,c){const g=E.reduce((R,i)=>Math.max(R,i[0].length),12)+2+1;if(c-g<25)return E.reduce((R,i)=>R.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const f=c-g-1,S=[];for(const R of E){const i=R[0],r=y(R[1],f),t=w(g-i.length-2);S.push("  "+i+t+r[0]);for(let n=1;n<r.length;n++)S.push(w(g)+r[n])}return S}function w(E){return" ".repeat(E)}function y(E,c){const u=[];for(;E.length;){const g=E.length<c?E.length:E.lastIndexOf(" ",c),f=E.slice(0,g).trim();E=E.slice(g),u.push(f)}return u}function p(E,c,u,g,f){const S=process.stdout.isTTY&&process.stdout.columns||80,R=f?.noInputFiles!==!0?`[${(0,l.localize)(37,null)}...]`:"",i=[`${E} ${u}`];i.push(""),i.push(`${(0,l.localize)(38,null)}: ${c} [${(0,l.localize)(39,null)}]${R}`),i.push(""),f?.noPipe!==!0&&(O.isWindows?i.push((0,l.localize)(40,null,c)):i.push((0,l.localize)(41,null,c)),i.push(""));const r={},t=[];for(const n in g){const s=g[n];if(s.type==="subcommand")s.description&&t.push({command:n,description:s.description});else if(s.description&&s.cat){let a=r[s.cat];a||(r[s.cat]=a={}),a[n]=s}}for(const n in r){const s=n,a=r[s];a&&(i.push(D[s]),i.push(...b(a,S)),i.push(""))}return t.length&&(i.push((0,l.localize)(42,null)),i.push(...I(t.map(n=>[n.command,n.description]),S)),i.push("")),i.join(`
`)}e.buildHelpMessage=p;function d(E,c){return`${E||(0,l.localize)(43,null)}
${c||(0,l.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(re[192],oe([0,1,291,157,191]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const D=2048;function k(y,p){const d=(S,R)=>{console.warn((0,O.localize)(0,null,S,R))},E=S=>{console.warn((0,O.localize)(1,null,S))},c=(S,R)=>{console.warn((0,O.localize)(2,null,S,R))},u=S=>({onUnknownOption:R=>{S!=="tunnel"&&console.warn((0,O.localize)(3,null,R,S))},onMultipleValues:d,onEmptyValue:E,onDeprecatedOption:c,getSubcommandReporter:S!=="tunnel"?u:void 0}),g={onUnknownOption:S=>{console.warn((0,O.localize)(4,null,S))},onMultipleValues:d,onEmptyValue:E,onDeprecatedOption:c,getSubcommandReporter:u},f=(0,l.parseArgs)(y,l.OPTIONS,p?g:void 0);return f.goto&&f._.forEach(S=>L(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,O.localize)(5,null))),f["max-memory"]&&L(parseInt(f["max-memory"])>=D,`The max-memory argument cannot be specified lower than ${D} MB.`),f}function P(y){const p=y.findIndex(d=>!/^-/.test(d));if(p>-1)return[...y.slice(0,p),...y.slice(p+1)]}function C(y){let[,...p]=y;process.env.VSCODE_DEV&&(p=P(p)||[]);const d=!w(process.env);return k(p,d)}e.parseMainProcessArgv=C;function b(y){let[,,...p]=y;return process.env.VSCODE_DEV&&(p=P(p)||[]),k(p,!0)}e.parseCLIProcessArgv=b;function I(y,...p){const d=y.indexOf("--");return d===-1?y.push(...p):y.splice(d,0,...p),y}e.addArg=I;function w(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function _(e,L,O){function l(k,P){const C=D(k,P),b=[C];return e.isAbsolute(C)||b.unshift(O),e.resolve(...b)}function D(k,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,P);const I=k["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(w,"AppData","Roaming")}break;case"darwin":b=e.join(L.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,P)}return{getUserDataPath:l}}if(typeof define=="function")define(re[193],oe([292,34,36]),function(e,L,O){return _(e,L,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=_(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[96],oe([0,1,34,190,193]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class D extends O.AbstractNativeEnvironmentService{constructor(b,I){super(b,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,l.getUserDataPath)(b,I.nameShort)},I)}}e.NativeEnvironmentService=D;function k(C,b){return(0,O.parseDebugParams)(C["inspect-ptyhost"],C["inspect-brk-ptyhost"],5877,b,C.extensionEnvironment)}e.parsePtyHostDebugPort=k;function P(C,b){return(0,O.parseDebugParams)(C["inspect-sharedprocess"],C["inspect-brk-sharedprocess"],5879,b,C.extensionEnvironment)}e.parseSharedProcessDebugPort=P}),define(re[194],oe([0,1,11]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const O=/^([^@:]+@)?([^:]+):/,l=/^([^@:]+@)?([^:]+):(.+)$/,D=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,C=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(c){const u=c.match(k);return u?u[1]:null}function I(c){if(c.indexOf("://")===-1){const u=c.match(O);return u?b(u[2]):null}try{const u=L.URI.parse(c);if(u.authority)return b(u.authority)}catch{}return null}function w(c,u){const g=new Set;let f;for(;f=P.exec(c);){const R=I(f[1]);R&&g.add(R)}const S=new Set(u);return Array.from(g).map(R=>S.has(R)?R:R.replace(C,"a"))}e.getDomainsOfRemotes=w;function y(c){const u=c.match(D);return u?u[2]:null}function p(c,u,g){return c&&u?(g&&u.endsWith(".git")&&(u=u.substr(0,u.length-4)),u.indexOf("/")===0?`${c}${u}`:`${c}/${u}`):null}function d(c,u){if(c.indexOf("://")===-1){const g=c.match(l);if(g)return p(g[2],g[3],u)}try{const g=L.URI.parse(c);if(g.authority)return p(y(g.authority),g.path,u)}catch{}return null}function E(c,u=!1){const g=[];let f;for(;f=P.exec(c);){const S=d(f[1],u);S&&g.push(S)}return g}e.getRemotes=E}),define(re[195],oe([0,1,12,160]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function l(k,P,C){try{D(k,P,C)}catch(b){console.error(b?.message??b)}return k}e.localizeManifest=l;function D(k,P,C){const b=(I,w,y)=>{const p=I[w];if((0,L.isString)(p)){const d=p,E=d.length;if(E>1&&d[0]==="%"&&d[E-1]==="%"){const c=d.substr(1,E-2);let u=P[c];u===void 0&&C&&(u=C[c]);const g=typeof u=="string"?u:u?.message,f=C?.[c],S=typeof f=="string"?f:f?.message;if(!g){S||console.warn(`[${k.name}]: ${(0,O.localize)(0,null,c)}`);return}if(y&&(w==="title"||w==="category")&&S&&S!==g){const R={value:g,original:S};I[w]=R}else I[w]=g}}else if((0,L.isObject)(p))for(const d in p)p.hasOwnProperty(d)&&(d==="commands"?b(p,d,!0):b(p,d,y));else if(Array.isArray(p))for(let d=0;d<p.length;d++)b(p,d,y)};for(const I in k)k.hasOwnProperty(I)&&b(k,I)}}),define(re[196],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(D){this.a=D}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(D,k,P,C){return this.a.call("promptImportantExtensionsInstallNotification",[D,k,P,C])}promptWorkspaceRecommendations(D){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class O{constructor(D){this.a=D}listen(D,k){throw new Error(`Event not found: ${k}`)}call(D,k,P){switch(k){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=O}),define(re[67],oe([0,1,23,89,165,54]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function C(u){return u=u.trim(),u==="*"||k.test(u)}e.isValidVersionStr=C;function b(u){if(!C(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=u.match(k);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=b;function I(u){if(!u)return null;const g=u.majorBase,f=u.majorMustEqual,S=u.minorBase;let R=u.minorMustEqual;const i=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(g===0||(R=!1),r=!1);let t=0;if(u.preRelease){const n=P.exec(u.preRelease);if(n){const[,s,a,o]=n;t=Date.UTC(Number(s),Number(a)-1,Number(o))}}return{majorBase:g,majorMustEqual:f,minorBase:S,minorMustEqual:R,patchBase:i,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:t}}e.normalizeVersion=I;function w(u,g,f){let S;typeof u=="string"?S=I(b(u)):S=u;let R;g instanceof Date?R=g.getTime():typeof g=="string"&&(R=new Date(g).getTime());let i;if(typeof f=="string"?i=I(b(f)):i=f,!S||!i)return!1;const r=S.majorBase,t=S.minorBase,n=S.patchBase;let s=i.majorBase,a=i.minorBase,o=i.patchBase;const h=i.notBefore;let m=i.majorMustEqual,v=i.minorMustEqual,A=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>a?!0:t<a||R&&R<h?!1:n>=o:(r===1&&s===0&&(!m||!v||!A)&&(s=1,a=0,o=0,m=!0,v=!1,A=!1),r<s?!1:r>s?!m:t<a?!1:t>a?!v:n<o?!1:n>o?!A:!(R&&R<h))}e.isValidVersion=w;function y(u,g,f,S,R){const i=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return i.push([O.default.Error,l.localize(0,null)]),i;if(typeof S.name!="string")return i.push([O.default.Error,l.localize(1,null,"name")]),i;if(typeof S.version!="string")return i.push([O.default.Error,l.localize(2,null,"version")]),i;if(!S.engines)return i.push([O.default.Error,l.localize(3,null,"engines")]),i;if(typeof S.engines.vscode!="string")return i.push([O.default.Error,l.localize(4,null,"engines.vscode")]),i;if(typeof S.extensionDependencies<"u"&&!c(S.extensionDependencies))return i.push([O.default.Error,l.localize(5,null,"extensionDependencies")]),i;if(typeof S.activationEvents<"u"){if(!c(S.activationEvents))return i.push([O.default.Error,l.localize(6,null,"activationEvents")]),i;if(typeof S.main>"u"&&typeof S.browser>"u")return i.push([O.default.Error,l.localize(7,null,"activationEvents","main")]),i}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&i.push([O.default.Warning,l.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return i.push([O.default.Error,l.localize(9,null,"main")]),i;{const n=(0,L.joinPath)(f,S.main);(0,L.isEqualOrParent)(n,f)||i.push([O.default.Warning,l.localize(10,null,n.path,f.path)])}if(typeof S.activationEvents>"u")return i.push([O.default.Error,l.localize(11,null,"activationEvents","main")]),i}if(typeof S.browser<"u"){if(typeof S.browser!="string")return i.push([O.default.Error,l.localize(12,null,"browser")]),i;{const n=(0,L.joinPath)(f,S.browser);(0,L.isEqualOrParent)(n,f)||i.push([O.default.Warning,l.localize(13,null,n.path,f.path)])}if(typeof S.activationEvents>"u")return i.push([O.default.Error,l.localize(14,null,"activationEvents","browser")]),i}if(!D.valid(S.version))return i.push([O.default.Error,l.localize(15,null)]),i;const r=[];if(!p(u,g,S,R,r))for(const n of r)i.push([O.default.Error,n]);return i}e.validateExtensionManifest=y;function p(u,g,f,S,R){return S||typeof f.main>"u"&&typeof f.browser>"u"?!0:E(u,g,f.engines.vscode,R)}e.isValidExtensionVersion=p;function d(u,g,f){return u==="*"||E(g,f,u)}e.isEngineValid=d;function E(u,g,f,S=[]){const R=I(b(f));if(!R)return S.push(l.localize(16,null,f)),!1;if(R.majorBase===0){if(!R.majorMustEqual||!R.minorMustEqual)return S.push(l.localize(17,null,f)),!1}else if(!R.majorMustEqual)return S.push(l.localize(18,null,f)),!1;return w(u,g,R)?!0:(S.push(l.localize(19,null,u,f)),!1)}function c(u){if(!Array.isArray(u))return!1;for(let g=0,f=u.length;g<f;g++)if(typeof u[g]!="string")return!1;return!0}}),define(re[44],oe([0,1,16,31]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function l(D,k,P){let C=P&&P.get("storage.serviceMachineId",-1)||null;if(C)return C;try{const I=(await k.readFile(D.serviceMachineIdResource)).value.toString();C=(0,O.isUUID)(I)?I:null}catch{C=null}if(!C){C=(0,O.generateUuid)();try{await k.writeFile(D.serviceMachineIdResource,L.VSBuffer.fromString(C))}catch{}}return P?.store("storage.serviceMachineId",C,-1,1),C}e.getServiceMachineId=l}),define(re[68],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(l,D=[],k=!1){this.ctor=l,this.staticArguments=D,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=L}),define(re[197],oe([0,1,68]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var l;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function D(P,C,b){C instanceof L.SyncDescriptor||(C=new L.SyncDescriptor(C,[],Boolean(b))),O.push([P,C])}e.registerSingleton=D;function k(){return O}e.getSingletonServiceDescriptors=k}),define(re[198],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(D,k){this.key=D,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=L;class O{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const k of this.a.values())k.outgoing.size===0&&D.push(k);return D}insertEdge(D,k){const P=this.lookupOrInsertNode(D),C=this.lookupOrInsertNode(k);P.outgoing.set(C.key,C),C.incoming.set(P.key,P)}removeNode(D){const k=this.b(D);this.a.delete(k);for(const P of this.a.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(D){const k=this.b(D);let P=this.a.get(k);return P||(P=new L(k,D),this.a.set(k,P)),P}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[k,P]of this.a)D.push(`${k}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,k]of this.a){const P=new Set([D]),C=this.c(k,P);if(C)return C}}c(D,k){for(const[P,C]of D.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const b=this.c(C,k);if(b)return b;k.delete(P)}}}e.Graph=O}),define(re[5],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function P(C){return C[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=P})(L=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function O(k,P,C){P[L.DI_TARGET]===P?P[L.DI_DEPENDENCIES].push({id:k,index:C}):(P[L.DI_DEPENDENCIES]=[{id:k,index:C}],P[L.DI_TARGET]=P)}function l(k){if(L.serviceIds.has(k))return L.serviceIds.get(k);const P=function(C,b,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(P,C,I)};return P.toString=()=>k,L.serviceIds.set(k,P),P}e.createDecorator=l;function D(k){return k}e.refineServiceDecorator=D}),define(re[199],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(re[17],oe([0,1,12,11,5]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function D(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationOverrides=D;function k(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=k;var P;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=C;function b(c,u){const g=Object.create(null);for(const f in c)I(g,f,c[f],u);return g}e.toValuesTree=b;function I(c,u,g,f){const S=u.split("."),R=S.pop();let i=c;for(let r=0;r<S.length;r++){const t=S[r];let n=i[t];switch(typeof n){case"undefined":n=i[t]=Object.create(null);break;case"object":break;default:f(`Ignoring ${u} as ${S.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}i=n}if(typeof i=="object"&&i!==null)try{i[R]=g}catch{f(`Ignoring ${u} as ${S.join(".")} is ${JSON.stringify(i)}`)}else f(`Ignoring ${u} as ${S.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=I;function w(c,u){const g=u.split(".");y(c,g)}e.removeFromValueTree=w;function y(c,u){const g=u.shift();if(u.length===0){delete c[g];return}if(Object.keys(c).indexOf(g)!==-1){const f=c[g];typeof f=="object"&&!Array.isArray(f)&&(y(f,u),Object.keys(f).length===0&&delete c[g])}}function p(c,u,g){function f(i,r){let t=i;for(const n of r){if(typeof t!="object"||t===null)return;t=t[n]}return t}const S=u.split("."),R=f(c,S);return typeof R>"u"?g:R}e.getConfigurationValue=p;function d(c,u,g){Object.keys(u).forEach(f=>{f!=="__proto__"&&(f in c?L.isObject(c[f])&&L.isObject(u[f])?d(c[f],u[f],g):g&&(c[f]=u[f]):c[f]=u[f])})}e.merge=d;function E(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(re[97],oe([0,1,4,27,189,5]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",L.isMacintosh),k.set("isLinux",L.isLinux),k.set("isWindows",L.isWindows),k.set("isWeb",L.isWeb),k.set("isMacNative",L.isMacintosh&&!L.isWeb),k.set("isEdge",L.isEdge),k.set("isFirefox",L.isFirefox),k.set("isChrome",L.isChrome),k.set("isSafari",L.isSafari);const P=Object.prototype.hasOwnProperty;var C;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return d.INSTANCE}static true(){return E.INSTANCE}static has(N){return c.create(N)}static equals(N,j){return u.create(N,j)}static notEquals(N,j){return S.create(N,j)}static regex(N,j){return a.create(N,j)}static in(N,j){return g.create(N,j)}static notIn(N,j){return f.create(N,j)}static not(N){return R.create(N)}static and(...N){return m.create(N,null,!0)}static or(...N){return v.create(N,null,!0)}static greater(N,j){return r.create(N,j)}static greaterEquals(N,j){return t.create(N,j)}static smaller(N,j){return n.create(N,j)}static smallerEquals(N,j){return s.create(N,j)}static deserializeOrErrorNew(N){if(!N)return{type:"error",lexingErrors:[],parsingErrors:[]};const j=new w,q=j.parse(N);return q===void 0?{type:"error",lexingErrors:j.lexingErrors.map(x=>l.Scanner.reportError(x)),parsingErrors:j.parsingErrors}:{type:"ok",expr:q}}static deserialize(N){if(!!N)return this.c(N)}static c(N){const j=N.split("||");return v.create(j.map(q=>this.d(q)),null,!0)}static d(N){const j=N.split("&&");return m.create(j.map(q=>this.f(q)),null,!0)}static f(N){if(N=N.trim(),N.indexOf("!=")>=0){const j=N.split("!=");return S.create(j[0].trim(),this.g(j[1]))}if(N.indexOf("==")>=0){const j=N.split("==");return u.create(j[0].trim(),this.g(j[1]))}if(N.indexOf("=~")>=0){const j=N.split("=~");return a.create(j[0].trim(),this.h(j[1]))}if(N.indexOf(" not in ")>=0){const j=N.split(" not in ");return f.create(j[0].trim(),this.g(j[1]))}if(N.indexOf(" in ")>=0){const j=N.split(" in ");return g.create(j[0].trim(),this.g(j[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(N)){const j=N.split(">=");return t.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(N)){const j=N.split(">");return r.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(N)){const j=N.split("<=");return s.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(N)){const j=N.split("<");return n.create(j[0].trim(),j[1].trim())}return/^\!\s*/.test(N)?R.create(N.substr(1).trim()):c.create(N)}static g(N){if(N=N.trim(),N==="true")return!0;if(N==="false")return!1;const j=/^'([^']*)'$/.exec(N);return j?j[1].trim():N}static h(N){if((0,O.isFalsyOrWhitespace)(N))return null;const j=N.indexOf("/"),q=N.lastIndexOf("/");if(j===q||j<0)return null;const x=N.slice(j+1,q),Y=N[q+1]==="i"?"i":"";try{return new RegExp(x,Y)}catch{return null}}}e.ContextKeyExpr=b;class I extends Error{}class w{constructor(){this.c=new l.Scanner,this.d=[],this.f=0,this.g=[]}get lexingErrors(){return this.c.errorTokens}get parsingErrors(){return this.g}parse(N){if(N===""){this.g.push("Expected an expression but got an empty string");return}this.d=this.c.reset(N).scan(),this.f=0,this.g=[];try{const j=this.h();if(!this.D())throw this.z(this.C());return j}catch(j){if(!(j instanceof I)){const q=this.C();this.g.push(`Unexpected error: ${j} for token ${l.Scanner.getLexeme(q)} at offset ${q.offset}.`)}return}}h(){return this.k()}k(){const N=[this.l()];for(;this.v(16);){const j=this.l();N.push(j)}return N.length===1?N[0]:b.or(...N)}l(){const N=[this.o()];for(;this.v(15);){const j=this.o();N.push(j)}return N.length===1?N[0]:b.and(...N)}o(){if(this.v(2)){const N=this.C();switch(N.type){case 17:return this.w(),b.not(N.lexeme);case 11:return this.w(),b.false();case 12:return this.w(),b.true();default:throw this.y("KEY, 'true', or 'false'",N)}}return this.s()}s(){const N=this.C();switch(N.type){case 11:return this.w(),b.true();case 12:return this.w(),b.false();case 0:{this.w();const j=this.h();return this.x(1,"')'"),j}case 17:{const j=N.lexeme;if(this.w(),this.v(9)){const x=this.C();switch(x.type){case 10:case 19:{const Y=[x.lexeme];this.w();let F=this.C(),Z=0;for(let B=0;B<x.lexeme.length;B++)x.lexeme.charCodeAt(B)===40?Z++:x.lexeme.charCodeAt(B)===41&&Z--;for(;!this.D()&&F.type!==15&&F.type!==16;){switch(F.type){case 0:Z++;break;case 1:Z--;break;case 10:case 18:for(let B=0;B<F.lexeme.length;B++)F.lexeme.charCodeAt(B)===40?Z++:x.lexeme.charCodeAt(B)===41&&Z--}if(Z<0)break;Y.push(l.Scanner.getLexeme(F)),this.w(),F=this.C()}const te=Y.join(""),se=te.lastIndexOf("/"),ae=se===te.length-1?void 0:te.substring(se+1),V=new RegExp(te.substring(1,se),ae);return b.regex(j,V)}case 18:{const Y=x.lexeme;this.w();let F=null;if(!(0,O.isFalsyOrWhitespace)(Y)){const Z=Y.indexOf("/"),te=Y.lastIndexOf("/");if(Z!==te&&Z>=0){const se=Y.slice(Z+1,te),ae=Y[te+1]==="i"?"i":"";try{F=new RegExp(se,ae)}catch{}}}if(F===null)throw this.y("REGEX",x);return a.create(j,F)}default:throw this.y("REGEX",this.C())}}if(this.v(14)){this.x(13,"'in' after 'not'");const x=this.t();return b.notIn(j,x)}switch(this.C().type){case 3:{this.w();const x=this.t();switch(x){case"true":return b.has(j);case"false":return b.not(j);default:return b.equals(j,x)}}case 4:{this.w();const x=this.t();switch(x){case"true":return b.not(j);case"false":return b.has(j);default:return b.notEquals(j,x)}}case 5:return this.w(),n.create(j,this.t());case 6:return this.w(),s.create(j,this.t());case 7:return this.w(),r.create(j,this.t());case 8:return this.w(),t.create(j,this.t());case 13:return this.w(),b.in(j,this.t());default:return b.has(j)}}default:throw this.y("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this.C())}}t(){const N=this.C();switch(N.type){case 17:case 18:return this.w(),N.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(N){return this.B(N)?(this.w(),!0):!1}w(){return this.D()||this.f++,this.u()}x(N,j){if(this.B(N))return this.w();throw this.y(j,this.C())}y(N,j){return this.A(`Expected ${N} but got '${l.Scanner.getLexeme(j)}' at offset ${j.offset}.`)}z(N){return this.A(`Unexpected '${l.Scanner.getLexeme(N)}' at offset ${N.offset}.`)}A(N){return this.g.push(N),new I}B(N){return this.C().type===N}C(){return this.d[this.f]}D(){return this.C().type===20}}e.Parser=w;function y(W,N){const j=W?W.substituteConstants():void 0,q=N?N.substituteConstants():void 0;return!j&&!q?!0:!j||!q?!1:j.equals(q)}e.expressionsAreEqualWithConstantSubstitution=y;function p(W,N){return W.cmp(N)}class d{constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return E.INSTANCE}}d.INSTANCE=new d,e.ContextKeyFalseExpr=d;class E{constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return d.INSTANCE}}E.INSTANCE=new E,e.ContextKeyTrueExpr=E;class c{static create(N,j=null){const q=k.get(N);return typeof q=="boolean"?q?E.INSTANCE:d.INSTANCE:new c(N,j)}constructor(N,j){this.key=N,this.c=j,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:T(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=k.get(this.key);return typeof N=="boolean"?N?E.INSTANCE:d.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=c;class u{static create(N,j,q=null){if(typeof j=="boolean")return j?c.create(N,q):R.create(N,q);const x=k.get(N);return typeof x=="boolean"?j===(x?"true":"false")?E.INSTANCE:d.INSTANCE:new u(N,j,q)}constructor(N,j,q){this.c=N,this.d=j,this.f=q,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:M(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=k.get(this.c);if(typeof N=="boolean"){const j=N?"true":"false";return this.d===j?E.INSTANCE:d.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=u;class g{static create(N,j){return new g(N,j)}constructor(N,j){this.d=N,this.f=j,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:M(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const j=N.getValue(this.f),q=N.getValue(this.d);return Array.isArray(j)?j.includes(q):typeof q=="string"&&typeof j=="object"&&j!==null?P.call(j,q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=g;class f{static create(N,j){return new f(N,j)}constructor(N,j){this.d=N,this.f=j,this.type=11,this.c=g.create(N,j)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=f;class S{static create(N,j,q=null){if(typeof j=="boolean")return j?R.create(N,q):c.create(N,q);const x=k.get(N);return typeof x=="boolean"?j===(x?"true":"false")?d.INSTANCE:E.INSTANCE:new S(N,j,q)}constructor(N,j,q){this.c=N,this.d=j,this.f=q,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:M(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=k.get(this.c);if(typeof N=="boolean"){const j=N?"true":"false";return this.d===j?d.INSTANCE:E.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=S;class R{static create(N,j=null){const q=k.get(N);return typeof q=="boolean"?q?d.INSTANCE:E.INSTANCE:new R(N,j)}constructor(N,j){this.c=N,this.d=j,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:T(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=k.get(this.c);return typeof N=="boolean"?N?d.INSTANCE:E.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.ContextKeyNotExpr=R;function i(W,N){if(typeof W=="string"){const j=parseFloat(W);isNaN(j)||(W=j)}return typeof W=="string"||typeof W=="number"?N(W):d.INSTANCE}class r{static create(N,j,q=null){return i(j,x=>new r(N,x,q))}constructor(N,j,q){this.c=N,this.d=j,this.f=q,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:M(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=r;class t{static create(N,j,q=null){return i(j,x=>new t(N,x,q))}constructor(N,j,q){this.c=N,this.d=j,this.f=q,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:M(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=t;class n{static create(N,j,q=null){return i(j,x=>new n(N,x,q))}constructor(N,j,q){this.c=N,this.d=j,this.f=q,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:M(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=t.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class s{static create(N,j,q=null){return i(j,x=>new s(N,x,q))}constructor(N,j,q){this.c=N,this.d=j,this.f=q,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:M(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=s;class a{static create(N,j){return new a(N,j)}constructor(N,j){this.d=N,this.f=j,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const j=this.f?this.f.source:"",q=N.f?N.f.source:"";return j<q?-1:j>q?1:0}equals(N){if(N.type===this.type){const j=this.f?this.f.source:"",q=N.f?N.f.source:"";return this.d===N.d&&j===q}return!1}substituteConstants(){return this}evaluate(N){const j=N.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=o.create(this)),this.c}}e.ContextKeyRegexExpr=a;class o{static create(N){return new o(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(N){return new o(this.c.map(N))}negate(){return this.c}}e.ContextKeyNotRegexExpr=o;function h(W){let N=null;for(let j=0,q=W.length;j<q;j++){const x=W[j].substituteConstants();if(W[j]!==x&&N===null){N=[];for(let Y=0;Y<j;Y++)N[Y]=W[Y]}N!==null&&(N[j]=x)}return N===null?W:N}class m{static create(N,j,q){return m.d(N,j,q)}constructor(N,j){this.expr=N,this.c=j,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let j=0,q=this.expr.length;j<q;j++){const x=p(this.expr[j],N.expr[j]);if(x!==0)return x}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let j=0,q=this.expr.length;j<q;j++)if(!this.expr[j].equals(N.expr[j]))return!1;return!0}return!1}substituteConstants(){const N=h(this.expr);return N===this.expr?this:m.create(N,this.c,!1)}evaluate(N){for(let j=0,q=this.expr.length;j<q;j++)if(!this.expr[j].evaluate(N))return!1;return!0}static d(N,j,q){const x=[];let Y=!1;for(const F of N)if(!!F){if(F.type===1){Y=!0;continue}if(F.type===0)return d.INSTANCE;if(F.type===6){x.push(...F.expr);continue}x.push(F)}if(x.length===0&&Y)return E.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(p);for(let F=1;F<x.length;F++)x[F-1].equals(x[F])&&(x.splice(F,1),F--);if(x.length===1)return x[0];for(;x.length>1;){const F=x[x.length-1];if(F.type!==9)break;x.pop();const Z=x.pop(),te=x.length===0,se=v.create(F.expr.map(ae=>m.create([ae,Z],null,q)),null,te);se&&(x.push(se),x.sort(p))}if(x.length===1)return x[0];if(q){for(let F=0;F<x.length;F++)for(let Z=F+1;Z<x.length;Z++)if(x[F].negate().equals(x[Z]))return d.INSTANCE;if(x.length===1)return x[0]}return new m(x,j)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const j of this.expr)N.push(...j.keys());return N}map(N){return new m(this.expr.map(j=>j.map(N)),null)}negate(){if(!this.c){const N=[];for(const j of this.expr)N.push(j.negate());this.c=v.create(N,this,!0)}return this.c}}class v{static create(N,j,q){return v.d(N,j,q)}constructor(N,j){this.expr=N,this.c=j,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let j=0,q=this.expr.length;j<q;j++){const x=p(this.expr[j],N.expr[j]);if(x!==0)return x}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let j=0,q=this.expr.length;j<q;j++)if(!this.expr[j].equals(N.expr[j]))return!1;return!0}return!1}substituteConstants(){const N=h(this.expr);return N===this.expr?this:v.create(N,this.c,!1)}evaluate(N){for(let j=0,q=this.expr.length;j<q;j++)if(this.expr[j].evaluate(N))return!0;return!1}static d(N,j,q){let x=[],Y=!1;if(N){for(let F=0,Z=N.length;F<Z;F++){const te=N[F];if(!!te){if(te.type===0){Y=!0;continue}if(te.type===1)return E.INSTANCE;if(te.type===9){x=x.concat(te.expr);continue}x.push(te)}}if(x.length===0&&Y)return d.INSTANCE;x.sort(p)}if(x.length!==0){if(x.length===1)return x[0];for(let F=1;F<x.length;F++)x[F-1].equals(x[F])&&(x.splice(F,1),F--);if(x.length===1)return x[0];if(q){for(let F=0;F<x.length;F++)for(let Z=F+1;Z<x.length;Z++)if(x[F].negate().equals(x[Z]))return E.INSTANCE;if(x.length===1)return x[0]}return new v(x,j)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const j of this.expr)N.push(...j.keys());return N}map(N){return new v(this.expr.map(j=>j.map(N)),null)}negate(){if(!this.c){const N=[];for(const j of this.expr)N.push(j.negate());for(;N.length>1;){const j=N.shift(),q=N.shift(),x=[];for(const Y of J(j))for(const F of J(q))x.push(m.create([Y,F],null,!1));N.unshift(v.create(x,null,!1))}this.c=v.create(N,this,!0)}return this.c}}class A extends c{static all(){return A.d.values()}constructor(N,j,q){super(N,null),this.f=j,typeof q=="object"?A.d.push({...q,key:N}):q!==!0&&A.d.push({key:N,description:q,type:j!=null?typeof j:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return u.create(this.key,N)}notEqualsTo(N){return S.create(this.key,N)}}A.d=[],e.RawContextKey=A,e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function T(W,N){return W<N?-1:W>N?1:0}function M(W,N,j,q){return W<j?-1:W>j?1:N<q?-1:N>q?1:0}function z(W,N){if(W.type===0||N.type===1)return!0;if(W.type===9)return N.type===9?H(W.expr,N.expr):!1;if(N.type===9){for(const j of N.expr)if(z(W,j))return!0;return!1}if(W.type===6){if(N.type===6)return H(N.expr,W.expr);for(const j of W.expr)if(z(j,N))return!0;return!1}return W.equals(N)}e.implies=z;function H(W,N){let j=0,q=0;for(;j<W.length&&q<N.length;){const x=W[j].cmp(N[q]);if(x<0)return!1;x===0&&j++,q++}return j===W.length}function J(W){return W.type===9?W.expr:[W]}}),define(re[98],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function O(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=O;class l{async getPerformanceInfo(k,P){return{}}async getSystemInfo(k,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,P){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=l}),define(re[99],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(re[15],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(re[29],oe([0,1,159,5]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function D(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function k(u,g){switch(u){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=k;function P(u,g){return g==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function C(u,g,f){return P(g,f)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===f?!0:b(f).includes(u)}e.isTargetPlatformCompatible=C;function b(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function I(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=I;var w;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var y;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var p;(function(u){u.Install="install",u.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var E;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(g,f){super(g),this.code=f,this.name=f}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,L.localize)(1,null),original:"Preferences"}}),define(re[200],oe([0,1,3,2,32,11,92,29]),function(_,e,L,O,l,D,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(c,u){return c?D.URI.revive(u?u.transformIncoming(c):c):void 0}function b(c,u){return u?u.transformOutgoingURI(c):c}function I(c,u){u=u||k.DefaultURITransformer;const g=c.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...c,manifest:void 0},u),manifest:g}}function w(c,u){return c?.profileLocation?(0,k.transformAndReviveIncomingURIs)(c,u??k.DefaultURITransformer):c}function y(c,u){return u?(0,l.cloneAndChange)(c,g=>g instanceof D.URI?u.transformOutgoingURI(g):void 0):c}class p{constructor(u,g){this.a=u,this.b=g,this.onInstallExtension=L.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=L.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,g){const f=this.b(u);switch(g){case"onInstallExtension":return L.Event.map(this.onInstallExtension,S=>({...S,profileLocation:S.profileLocation?b(S.profileLocation,f):S.profileLocation}));case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,S=>S.map(R=>({...R,local:R.local?y(R.local,f):R.local,profileLocation:R.profileLocation?b(R.profileLocation,f):R.profileLocation})));case"onUninstallExtension":return L.Event.map(this.onUninstallExtension,S=>({...S,profileLocation:S.profileLocation?b(S.profileLocation,f):S.profileLocation}));case"onDidUninstallExtension":return L.Event.map(this.onDidUninstallExtension,S=>({...S,profileLocation:S.profileLocation?b(S.profileLocation,f):S.profileLocation}));case"onDidUpdateExtensionMetadata":return L.Event.map(this.onDidUpdateExtensionMetadata,S=>y(S,f))}throw new Error("Invalid listen")}async call(u,g,f){const S=this.b(u);switch(g){case"zip":{const R=I(f[0],S),i=await this.a.zip(R);return b(i,S)}case"unzip":return this.a.unzip(C(f[0],S));case"install":return this.a.install(C(f[0],S),w(f[1],S));case"installFromLocation":return this.a.installFromLocation(C(f[0],S),C(f[1],S));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(f[0],C(f[1],S),C(f[2],S));case"getManifest":return this.a.getManifest(C(f[0],S));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(f[0]);case"installFromGallery":return this.a.installFromGallery(f[0],w(f[1],S));case"uninstall":return this.a.uninstall(I(f[0],S),w(f[1],S));case"reinstallFromGallery":return this.a.reinstallFromGallery(I(f[0],S));case"getInstalled":return(await this.a.getInstalled(f[0],C(f[1],S))).map(i=>y(i,S));case"copyExtensions":return this.a.copyExtensions(C(f[0],S),C(f[1],S));case"updateMetadata":{const R=await this.a.updateMetadata(I(f[0],S),f[1],C(f[2],S));return y(R,S)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(f[0],f[1]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=p;class d extends O.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.k=u,this.c=this.B(new L.Emitter),this.f=this.B(new L.Emitter),this.g=this.B(new L.Emitter),this.h=this.B(new L.Emitter),this.j=this.B(new L.Emitter),this.B(this.k.listen("onInstallExtension")(g=>this.l(this.c,{...g,source:this.m(g.source)?D.URI.revive(g.source):g.source,profileLocation:D.URI.revive(g.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(g=>this.l(this.f,g.map(f=>({...f,local:f.local?I(f.local,null):f.local,source:this.m(f.source)?D.URI.revive(f.source):f.source,profileLocation:D.URI.revive(f.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(g=>this.l(this.g,{...g,profileLocation:D.URI.revive(g.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(g=>this.l(this.h,{...g,profileLocation:D.URI.revive(g.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(g=>this.j.fire(I(g,null))))}l(u,g){u.fire(g)}m(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(u){const g=await this.getTargetPlatform();return u.allTargetPlatforms.some(f=>(0,P.isTargetPlatformCompatible)(f,u.allTargetPlatforms,g))}zip(u){return Promise.resolve(this.k.call("zip",[u]).then(g=>D.URI.revive(g)))}unzip(u){return Promise.resolve(this.k.call("unzip",[u]))}install(u,g){return Promise.resolve(this.k.call("install",[u,g])).then(f=>I(f,null))}installFromLocation(u,g){return Promise.resolve(this.k.call("installFromLocation",[u,g])).then(f=>I(f,null))}async installExtensionsFromProfile(u,g,f){return(await this.k.call("installExtensionsFromProfile",[u,g,f])).map(R=>I(R,null))}getManifest(u){return Promise.resolve(this.k.call("getManifest",[u]))}installFromGallery(u,g){return Promise.resolve(this.k.call("installFromGallery",[u,g])).then(f=>I(f,null))}uninstall(u,g){return Promise.resolve(this.k.call("uninstall",[u,g]))}reinstallFromGallery(u){return Promise.resolve(this.k.call("reinstallFromGallery",[u])).then(g=>I(g,null))}getInstalled(u=null,g){return Promise.resolve(this.k.call("getInstalled",[u,g])).then(f=>f.map(S=>I(S,null)))}updateMetadata(u,g,f){return Promise.resolve(this.k.call("updateMetadata",[u,g,f])).then(S=>I(S,null))}copyExtensions(u,g){return this.k.call("copyExtensions",[u,g])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(u,g){const f=await this.k.call("download",[u,g]);return D.URI.revive(f)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class E{constructor(u){this.a=u}listen(u,g){throw new Error("Invalid listen")}call(u,g,f){switch(g){case"getConfigBasedTips":return this.a.getConfigBasedTips(D.URI.revive(f[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=E}),define(re[100],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,L.createDecorator)("IExtensionSignatureVerificationService");class O{b(){return this.a||(this.a=new Promise((D,k)=>_(["node-vsce-sign"],async P=>D(P),k))),this.a}async verify(D,k,P){let C;try{C=await this.b()}catch{return!1}return C.verify(D,k,P)}}e.ExtensionSignatureVerificationService=O}),define(re[101],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var O;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(O=e.RecommendationSource||(e.RecommendationSource={}));function l(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=l;var D;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(D=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[14],oe([0,1,49,13,27,12,11,167,5,4,22]),function(_,e,L,O,l,D,k,P,C,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function w(F){return F.create===!0}e.isFileOpenForWriteOptions=w;var y;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var p;(function(F){F[F.Readonly=1]="Readonly"})(p=e.FilePermission||(e.FilePermission={}));var d;(function(F){F[F.None=0]="None",F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock",F[F.FileAtomicRead=16384]="FileAtomicRead",F[F.FileClone=32768]="FileClone"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=E;function c(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=c;function u(F){return!!(F.capabilities&32768)}e.hasFileCloneCapability=u;function g(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function f(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=f;function S(F){return E(F)?!!(F.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var R;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(R=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{static create(Z,te){const se=new i(Z.toString(),te);return n(se,te),se}constructor(Z,te){super(Z),this.code=te}}e.FileSystemProviderError=i;function r(F,Z){return i.create(F,Z)}e.createFileSystemProviderError=r;function t(F){return F||r((0,P.localize)(0,null),R.Unknown)}e.ensureFileSystemProviderError=t;function n(F,Z){return F.name=Z?`${Z} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=n;function s(F){if(!F)return R.Unknown;if(F instanceof i)return F.code;const Z=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!Z)return R.Unknown;switch(Z[1]){case R.FileExists:return R.FileExists;case R.FileIsADirectory:return R.FileIsADirectory;case R.FileNotADirectory:return R.FileNotADirectory;case R.FileNotFound:return R.FileNotFound;case R.FileExceedsMemoryLimit:return R.FileExceedsMemoryLimit;case R.FileTooLarge:return R.FileTooLarge;case R.FileWriteLocked:return R.FileWriteLocked;case R.NoPermissions:return R.NoPermissions;case R.Unavailable:return R.Unavailable}return R.Unknown}e.toFileSystemProviderErrorCode=s;function a(F){if(F instanceof T)return F.fileOperationResult;switch(s(F)){case R.FileNotFound:return 1;case R.FileIsADirectory:return 0;case R.FileNotADirectory:return 10;case R.FileWriteLocked:return 5;case R.NoPermissions:return 6;case R.FileExists:return 4;case R.FileExceedsMemoryLimit:return 9;case R.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var o;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY",F[F.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class h{constructor(Z,te,se){this.resource=Z,this.operation=te,this.target=se}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=h;var m;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(m=e.FileChangeType||(e.FileChangeType={}));class v{constructor(Z,te){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const ae of Z){const V=se.get(ae.type);switch(V?V.push([ae.resource,ae]):se.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,V]of se)switch(ae){case 1:this.a=L.TernarySearchTree.forUris(()=>te),this.a.fill(V);break;case 0:this.b=L.TernarySearchTree.forUris(()=>te),this.b.fill(V);break;case 2:this.c=L.TernarySearchTree.forUris(()=>te),this.c.fill(V);break}}contains(Z,...te){return this.d(Z,{includeChildren:!1},...te)}affects(Z,...te){return this.d(Z,{includeChildren:!0},...te)}d(Z,te,...se){if(!Z)return!1;const ae=se.length>0;return!!((!ae||se.includes(1))&&(this.a?.get(Z)||te.includeChildren&&this.a?.findSuperstr(Z))||(!ae||se.includes(0))&&(this.b?.get(Z)||te.includeChildren&&this.b?.findSuperstr(Z))||(!ae||se.includes(2))&&(this.c?.findSubstr(Z)||te.includeChildren&&this.c?.findSuperstr(Z)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=v;function A(F,Z,te){return!F||!Z||F===Z||Z.length>F.length?!1:(Z.charAt(Z.length-1)!==O.sep&&(Z+=O.sep),te?(0,l.startsWithIgnoreCase)(F,Z):F.indexOf(Z)===0)}e.isParent=A;class T extends Error{constructor(Z,te,se){super(Z),this.fileOperationResult=te,this.options=se}}e.FileOperationError=T;class M extends T{constructor(Z,te,se,ae){super(Z,te,ae),this.fileOperationResult=te,this.size=se}}e.TooLargeFileOperationError=M;class z extends T{constructor(Z,te,se){super(Z,2,se),this.stat=te}}e.NotModifiedSinceFileOperationError=z;var H;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(H=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var J;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(J=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function W(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=W;async function N(F,Z){if(!Z.hasProvider(k.URI.from({scheme:F.scheme})))return new Promise(te=>{const se=Z.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===F.scheme&&ae.added&&(se.dispose(),te())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class j{static formatSize(Z){return(0,D.isNumber)(Z)||(Z=0),Z<j.KB?(0,P.localize)(1,null,Z.toFixed(0)):Z<j.MB?(0,P.localize)(2,null,(Z/j.KB).toFixed(2)):Z<j.GB?(0,P.localize)(3,null,(Z/j.MB).toFixed(2)):Z<j.TB?(0,P.localize)(4,null,(Z/j.GB).toFixed(2)):(0,P.localize)(5,null,(Z/j.TB).toFixed(2))}}j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB,e.ByteSize=j;var q;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function x(F){return{maxFileSize:F===0?300*j.MB:16*j.GB,maxHeapSize:F===0?700*j.MB:2*700*j.MB}}e.getPlatformFileLimits=x;function Y(F){const Z=typeof F=="string"||F?.scheme===I.Schemas.vscodeRemote;return typeof F!="string"&&F?.scheme===I.Schemas.file?1024*j.MB:Z?10*j.MB:b.isWeb?50*j.MB:1024*j.MB}e.getLargeFileConfirmationLimit=Y});var X=this&&this.__param||function(_,e){return function(L,O){e(L,O,_)}};define(re[201],oe([0,1,102,43,14]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let D=class{constructor(P){this.a=P}async checksum(P){const C=(await this.a.readFileStream(P)).value;return new Promise((b,I)=>{const w=(0,L.createHash)("md5");(0,O.listenStream)(C,{onData:y=>w.update(y.buffer),onError:y=>I(y),onEnd:()=>b(w.digest("base64").replace(/=+$/,""))})})}};D=ye([X(0,l.IFileService)],D),e.ChecksumService=D}),define(re[202],oe([0,1,16,38,9,3,2,43,11,31,14]),function(_,e,L,O,l,D,k,P,C,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends k.Disposable{constructor(p,d){super(),this.a=p,this.b=d,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.h=(0,b.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(p){return this.a.call("stat",[p])}readdir(p){return this.a.call("readdir",[p])}async readFile(p,d){const{buffer:E}=await this.a.call("readFile",[p,d]);return E}readFileStream(p,d,E){const c=(0,P.newWriteableStream)(g=>L.VSBuffer.concat(g.map(f=>L.VSBuffer.wrap(f))).buffer),u=this.a.listen("readFileStream",[p,d])(g=>{if(g instanceof L.VSBuffer)c.write(g.buffer);else{if(g==="end")c.end();else{let f;if(g instanceof Error)f=g;else{const S=g;f=(0,I.createFileSystemProviderError)(S.message??(0,O.toErrorMessage)(S),S.code??I.FileSystemProviderErrorCode.Unknown)}c.error(f),c.end()}u.dispose()}});return E.onCancellationRequested(()=>{c.error((0,l.canceled)()),c.end(),u.dispose()}),c}writeFile(p,d,E){return this.a.call("writeFile",[p,L.VSBuffer.wrap(d),E])}open(p,d){return this.a.call("open",[p,d])}close(p){return this.a.call("close",[p])}async read(p,d,E,c,u){const[g,f]=await this.a.call("read",[p,d,u]);return E.set(g.buffer.slice(0,f),c),f}write(p,d,E,c,u){return this.a.call("write",[p,d,L.VSBuffer.wrap(E),c,u])}mkdir(p){return this.a.call("mkdir",[p])}delete(p,d){return this.a.call("delete",[p,d])}rename(p,d,E){return this.a.call("rename",[p,d,E])}copy(p,d,E){return this.a.call("copy",[p,d,E])}cloneFile(p,d){return this.a.call("cloneFile",[p,d])}i(){this.B(this.a.listen("fileChange",[this.h])(p=>{if(Array.isArray(p)){const d=p;this.f.fire(d.map(E=>({resource:C.URI.revive(E.resource),type:E.type})))}else{const d=p;this.g.fire(d)}}))}watch(p,d){const E=(0,b.generateUuid)();return this.a.call("watch",[this.h,E,p,d]),(0,k.toDisposable)(()=>this.a.call("unwatch",[this.h,E]))}}e.DiskFileSystemProviderClient=w}),define(re[103],oe([0,1,16,9,168,14]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(I,w,y,p,d,E){let c;try{await P(I,w,y,p,d,E)}catch(u){c=u}finally{c&&d.errorTransformer&&(c=d.errorTransformer(c)),typeof c<"u"&&y.error(c),y.end()}}e.readFileIntoStream=k;async function P(I,w,y,p,d,E){C(E);const c=await I.open(w,{create:!1});try{C(E);let u=0,g=0,f=d&&typeof d.length=="number"?d.length:void 0,S=L.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),R=d&&typeof d.position=="number"?d.position:0,i=0;do g=await I.read(c,R,S.buffer,i,S.byteLength-i),R+=g,i+=g,u+=g,typeof f=="number"&&(f-=g),i===S.byteLength&&(await y.write(p(S)),S=L.VSBuffer.alloc(Math.min(d.bufferSize,typeof f=="number"?f:d.bufferSize)),i=0);while(g>0&&(typeof f!="number"||f>0)&&C(E)&&b(u,d));if(i>0){let r=i;typeof f=="number"&&(r=Math.min(i,f)),y.write(p(S.slice(0,r)))}}catch(u){throw(0,D.ensureFileSystemProviderError)(u)}finally{await I.close(c)}}function C(I){if(I.isCancellationRequested)throw(0,O.canceled)();return!0}function b(I,w){if(w?.limits){if(typeof w.limits.memory=="number"&&I>w.limits.memory)throw(0,D.createFileSystemProviderError)((0,l.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&I>w.limits.size)throw(0,D.createFileSystemProviderError)((0,l.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[55],oe([0,1,91,2,13,4,11,14]),function(_,e,L,O,l,D,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function C(u){return u.recursive===!0}e.isRecursiveWatchRequest=C;class b extends O.Disposable{constructor(g,f,S,R){super(),this.h=g,this.i=f,this.j=S,this.k=R,this.c=this.B(new O.MutableDisposable),this.f=void 0,this.g=0}m(){const g=new O.DisposableStore;this.c.value=g,this.b=this.l(g),this.b.setVerboseLogging(this.j),g.add(this.b.onDidChangeFile(f=>this.h(f))),g.add(this.b.onDidLogMessage(f=>this.i(f))),g.add(this.b.onDidError(f=>this.n(f)))}n(g){this.k.restartOnError?this.g<b.a&&this.f?(this.r(`restarting watcher after error: ${g}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${g}`):this.r(g)}p(g){this.g++,this.m(),this.watch(g)}async watch(g){this.f=g,await this.b?.watch(g)}async setVerboseLogging(g){this.j=g,await this.b?.setVerboseLogging(g)}r(g){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${g}`})}s(g){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${g}`})}dispose(){return this.b=void 0,super.dispose()}}b.a=5,e.AbstractWatcherClient=b;class I extends b{constructor(g,f,S){super(g,f,S,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=I;class w extends b{constructor(g,f,S){super(g,f,S,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function y(u){return u.map(g=>({type:g.type,resource:k.URI.file(g.path)}))}e.toFileChanges=y;function p(u){const g=new c;for(const f of u)g.processEvent(f);return g.coalesce()}e.coalesceEvents=p;function d(u,g){return typeof g=="string"&&!g.startsWith(L.GLOBSTAR)&&!(0,l.isAbsolute)(g)?{base:u,pattern:g}:g}e.normalizeWatcherPattern=d;function E(u,g){const f=[];for(const S of g)f.push((0,L.parse)(d(u,S)));return f}e.parseWatcherPatterns=E;class c{constructor(){this.a=new Set,this.b=new Map}c(g){return D.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const f=this.b.get(this.c(g));let S=!1;if(f){const R=f.type,i=g.type;f.path!==g.path&&(g.type===2||g.type===1)?S=!0:R===1&&i===2?(this.b.delete(this.c(g)),this.a.delete(f)):R===2&&i===1?f.type=0:R===1&&i===0||(f.type=i)}else S=!0;S&&(this.a.add(g),this.b.set(this.c(g),g))}coalesce(){const g=[],f=[];return Array.from(this.a).filter(S=>S.type!==2?(g.push(S),!1):!0).sort((S,R)=>S.path.length-R.path.length).filter(S=>f.some(R=>(0,P.isParent)(S.path,R,!D.isLinux))?!1:(f.push(S.path),!0)).concat(g)}}}),define(re[203],oe([0,1,53,6,25,48,2,84,13,4,146,28,55]),function(_,e,L,O,l,D,k,P,C,b,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class p extends k.Disposable{constructor(c,u,g,f){super(),this.j=c,this.k=u,this.l=g,this.m=f,this.c=this.B(new O.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.k(S))),this.f=this.B(new O.RunOnceWorker(S=>this.u(S),p.b)),this.g=(0,y.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,y.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new l.CancellationTokenSource,this.ready=this.n()}async n(){try{const c=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const u=await w.Promises.stat(c);this.B(await this.s(c,u.isDirectory()))}catch(c){c.code!=="ENOENT"?this.w(c):this.z(c)}}async r(c){let u=c.path;try{u=await w.Promises.realpath(c.path),c.path===u&&(u=await(0,I.realcase)(c.path)??c.path),c.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${u})`)}catch{}return u}async s(c,u){if(b.isMacintosh&&(0,D.isEqualOrParent)(c,"/Volumes/",!0))return this.w(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const g=new l.CancellationTokenSource(this.i.token),f=new k.DisposableStore;try{const S=(0,C.basename)(c),R=(0,L.watch)(c);f.add((0,k.toDisposable)(()=>{R.removeAllListeners(),R.close()})),this.z(`Started watching: '${c}'`);const i=new Set;if(u)try{for(const t of await w.Promises.readdir(c))i.add(t)}catch(t){this.w(t)}const r=new Map;f.add((0,k.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),R.on("error",(t,n)=>{this.w(`Failed to watch ${c} for changes using fs.watch() (${t}, ${n})`),this.dispose()}),R.on("change",(t,n)=>{if(g.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${n}`);let s="";if(n&&(s=n.toString(),b.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(u)if(t==="rename"){r.get(s)?.dispose();const a=setTimeout(async()=>{if(r.delete(s),s===S&&!await w.Promises.exists(c)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,C.join)(c,s));if(g.token.isCancellationRequested)return;let h;o?i.has(s)?h=0:(h=1,i.add(s)):(i.delete(s),h=2),this.t({path:(0,C.join)(this.j.path,s),type:h})},p.a);r.set(s,(0,k.toDisposable)(()=>clearTimeout(a)))}else{let a;i.has(s)?a=0:(a=1,i.add(s)),this.t({path:(0,C.join)(this.j.path,s),type:a})}else if(t==="rename"||s!==S){const a=setTimeout(async()=>{const o=await w.Promises.exists(c);g.token.isCancellationRequested||(o?(this.t({path:this.j.path,type:0},!0),f.add(await this.s(c,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},p.a);f.clear(),f.add((0,k.toDisposable)(()=>clearTimeout(a)))}else this.t({path:this.j.path,type:0},!0)})}catch(S){await w.Promises.exists(c)&&!g.token.isCancellationRequested&&this.w(`Failed to watch ${c} for changes using fs.watch() (${S.toString()})`)}return(0,k.toDisposable)(()=>{g.dispose(!0),f.dispose()})}t(c,u=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!u&&this.g.some(g=>g(c.path))?this.m&&this.z(` >> ignored (excluded) ${c.path}`):!u&&this.h&&this.h.length>0&&!this.h.some(g=>g(c.path))?this.m&&this.z(` >> ignored (not included) ${c.path}`):this.f.work(c))}u(c){const u=(0,y.coalesceEvents)(c);if(u.length>0){if(this.m)for(const f of u)this.z(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(c){if(b.isLinux)return w.Promises.exists(c);try{const u=(0,C.basename)(c);return(await w.Promises.readdir((0,C.dirname)(c))).some(f=>f===u)}catch(u){return this.z(u),!1}}setVerboseLogging(c){this.m=c}w(c){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}y(c){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}z(c){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}p.a=100,p.b=75,e.NodeJSFileWatcherLibrary=p;async function d(E,c,u,g,f=512){const S=await w.Promises.open(E,"r"),R=Buffer.allocUnsafe(f),i=new l.CancellationTokenSource(g);let r,t=!1;const n={path:E,excludes:[],recursive:!1},s=new p(n,a=>{(async()=>{for(const{type:o}of a)if(o===0){if(t)return;t=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:h}=await w.Promises.read(S,R,0,f,null);if(!h||i.token.isCancellationRequested)break;c(R.slice(0,h))}}catch(h){r=new Error(h),i.dispose(!0)}finally{t=!1}}})()});return await s.ready,u(),new Promise((a,o)=>{i.token.onCancellationRequested(async()=>{s.dispose();try{await w.Promises.close(S)}catch(h){r=new Error(h)}r?o(r):a()})})}e.watchFileContents=d}),define(re[204],oe([0,1,3,91,2,4,203]),function(_,e,L,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new L.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(b){const I=this.i(b),w=I.filter(p=>{const d=this.c.get(p.path);return d?!(0,O.patternsEquals)(d.request.excludes,p.excludes)||!(0,O.patternsEquals)(d.request.includes,p.includes):!0}),y=Array.from(this.c.values()).filter(({request:p})=>!I.find(d=>d.path===p.path&&(0,O.patternsEquals)(d.excludes,p.excludes)&&(0,O.patternsEquals)(d.includes,p.includes))).map(({request:p})=>p.path);w.length&&this.j(`Request to start watching: ${w.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"})`).join(",")}`),y.length&&this.j(`Request to stop watching: ${y.join(",")}`);for(const p of y)this.h(p);for(const p of w)this.g(p)}g(b){const I=new k.NodeJSFileWatcherLibrary(b,y=>this.a.fire(y),y=>this.b.fire(y),this.f),w={request:b,instance:I};this.c.set(b.path,w)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const I=this.c.get(b);I&&(this.c.delete(b),I.instance.dispose())}i(b){const I=new Map;for(const w of b){const y=D.isLinux?w.path:w.path.toLowerCase();I.set(y,w)}return Array.from(I.values())}async setVerboseLogging(b){this.f=b;for(const[,I]of this.c)I.instance.setVerboseLogging(b)}j(b){this.f&&this.b.fire({type:"trace",message:this.k(b)})}k(b,I){return I?`[File Watcher (node.js)] ${b} (path: ${I.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=P}),define(re[205],oe([0,1,55,204]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class l extends L.AbstractNonRecursiveWatcherClient{constructor(k,P,C){super(k,P,C),this.m()}l(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=l}),define(re[206],oe([0,1,22,39,65,55]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends D.AbstractUniversalWatcherClient{constructor(C,b,I){super(C,b,I),this.m()}l(C){const b=C.add(new l.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(b.onDidProcessExit(({code:I,signal:w})=>this.n(`terminated by itself with code ${I}, signal: ${w}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(re[69],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...l){this.a=new Map;for(const[D,k]of l)this.set(D,k)}set(l,D){const k=this.a.get(l);return this.a.set(l,D),k}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=L}),define(re[207],oe([0,1,6,9,2,68,198,5,69,83]),function(_,e,L,O,l,D,k,P,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class w extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class y{constructor(c=new C.ServiceCollection,u=!1,g,f=I){this.f=c,this.g=u,this.h=g,this.i=f,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=f?g?._globalGraph??new k.Graph(S=>S):void 0}createChild(c){return new y(c,this.g,this,this.i)}invokeFunction(c,...u){const g=d.traceInvocation(this.i,c);let f=!1;try{return c({get:R=>{if(f)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(R,g);if(!i)throw new Error(`[invokeFunction] unknown service '${R}'`);return i}},...u)}finally{f=!0,g.stop()}}createInstance(c,...u){let g,f;return c instanceof D.SyncDescriptor?(g=d.traceCreation(this.i,c.ctor),f=this.j(c.ctor,c.staticArguments.concat(u),g)):(g=d.traceCreation(this.i,c),f=this.j(c,u,g)),g.stop(),f}j(c,u=[],g){const f=P._util.getServiceDependencies(c).sort((i,r)=>i.index-r.index),S=[];for(const i of f){const r=this.m(i.id,g);r||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${i.id}.`,!1),S.push(r)}const R=f.length>0?f[0].index:u.length;if(u.length!==R){console.trace(`[createInstance] First service dependency of ${c.name} at position ${R+1} conflicts with ${u.length} static arguments`);const i=R-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,R)}return Reflect.construct(c,u.concat(S))}k(c,u){if(this.f.get(c)instanceof D.SyncDescriptor)this.f.set(c,u);else if(this.h)this.h.k(c,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const u=this.f.get(c);return!u&&this.h?this.h.l(c):u}m(c,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const g=this.l(c);return g instanceof D.SyncDescriptor?this.q(c,g,u.branch(c,!0)):(u.branch(c,!1),g)}q(c,u,g){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,u,g)}finally{this.o.delete(c)}}r(c,u,g){const f=new k.Graph(i=>i.id.toString());let S=0;const R=[{id:c,desc:u,_trace:g}];for(;R.length;){const i=R.pop();if(f.lookupOrInsertNode(i),S++>1e3)throw new w(f);for(const r of P._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${c} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof D.SyncDescriptor){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};f.insertEdge(i,n),R.push(n)}}}for(;;){const i=f.roots();if(i.length===0){if(!f.isEmpty())throw new w(f);break}for(const{data:r}of i){if(this.l(r.id)instanceof D.SyncDescriptor){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}f.removeNode(r)}}return this.l(c)}s(c,u,g=[],f,S){if(this.f.get(c)instanceof D.SyncDescriptor)return this.t(c,u,g,f,S);if(this.h)return this.h.s(c,u,g,f,S);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(c,u,g=[],f,S){if(f){const R=new y(void 0,this.g,this,this.i);R.c=String(c);const i=new Map,r=new L.IdleValue(()=>{const t=R.j(u,g,S);for(const[n,s]of i){const a=t[n];if(typeof a=="function")for(const o of s)a.apply(t,o)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=i.get(n);return o||(o=new b.LinkedList,i.set(n,o)),(m,v,A)=>{const T=o.push([m,v,A]);return(0,l.toDisposable)(T)}}if(n in t)return t[n];const s=r.value;let a=s[n];return typeof a!="function"||(a=a.bind(s),t[n]=a),a},set(t,n,s){return r.value[n]=s,!0},getPrototypeOf(t){return u.prototype}})}else return this.j(u,g,S)}u(c,u){if(u&&console.warn(c),this.g)throw new Error(c)}}e.InstantiationService=y;var p;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(p||(p={}));class d{static traceInvocation(c,u){return c?new d(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(c,u){return c?new d(1,u.name):d.c}constructor(c,u){this.type=c,this.name=u,this.g=Date.now(),this.h=[]}branch(c,u){const g=new d(3,c.toString());return this.h.push([c,u,g]),g}stop(){const c=Date.now()-this.g;d.f+=c;let u=!1;function g(S,R){const i=[],r=new Array(S+1).join("	");for(const[t,n,s]of R.h)if(n&&s){u=!0,i.push(`${r}CREATES -> ${t}`);const a=g(S+1,s);a&&i.push(a)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(c>2||u)&&d.all.add(f.join(`
`))}}d.all=new Set,d.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}},d.f=0,e.Trace=d}),define(re[70],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,L.createDecorator)("mainProcessService");class O{constructor(D,k){this.a=D,this.b=k}getChannel(D){return this.a.getChannel(D,this.b)}registerChannel(D,k){this.a.registerChannel(D,k)}}e.MainProcessService=O}),define(re[71],oe([0,1,25,2,4,170,29,5]),function(_,e,L,O,l,D,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function C(I){return I.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=C,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let b=class extends O.Disposable{constructor(w){super(),this.c=w}async getAvailableLanguages(){const w=new L.CancellationTokenSource;setTimeout(()=>w.cancel(),1e3);let y;try{y=await this.c.query({text:'category:"language packs"',pageSize:20},w.token)}catch{return[]}const d=y.firstPage.filter(E=>E.properties.localizedLanguages?.length&&E.tags.some(c=>c.startsWith("lp-"))).map(E=>{const c=E.properties.localizedLanguages?.[0],u=C(E);return{...this.f(u,c,E),extensionId:E.identifier.id,galleryExtension:E}});return d.push(this.f("en","English")),d}f(w,y,p){const d=y??w;let E;if(d!==w&&(E=`(${w})`),w.toLowerCase()===l.language.toLowerCase()&&(E??="",E+=(0,D.localize)(0,null)),p?.installCount){E??="";const c=p.installCount;let u;c>1e6?u=`${Math.floor(c/1e5)/10}M`:c>1e3?u=`${Math.floor(c/1e3)}K`:u=String(c),E+=` $(cloud-download) ${u}`}return{id:w,label:d,description:E}}};b=ye([X(0,k.IExtensionGalleryService)],b),e.LanguagePackBaseService=b}),define(re[208],oe([0,1,2,71]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let l=class extends L.Disposable{constructor(k){super(),this.a=k,this.b()}b(){this.a.update()}};l=ye([X(0,O.ILanguagePackService)],l),e.LocalizationsUpdater=l}),define(re[8],oe([0,1,38,3,2,37,4,23,12,11,97,5]),function(_,e,L,O,l,D,k,P,C,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function y(){return new Date().toISOString()}function p(h){return(0,C.isNumber)(h)}e.isLogLevel=p;var d;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function E(h,m,v){switch(m){case d.Trace:h.trace(v);break;case d.Debug:h.debug(v);break;case d.Info:h.info(v);break;case d.Warning:h.warn(v);break;case d.Error:h.error(v);break;case d.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=E;function c(h){let m="";for(let v=0;v<h.length;v++){let A=h[v];if(typeof A=="object")try{A=JSON.stringify(A)}catch{}m+=(v>0?" ":"")+A}return m}e.format=c;class u extends l.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new O.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==d.Off&&this.b<=m}}e.AbstractLogger=u;class g extends u{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...v){this.f(d.Trace)&&this.g(d.Trace,c([m,...v]))}debug(m,...v){this.f(d.Debug)&&this.g(d.Debug,c([m,...v]))}info(m,...v){this.f(d.Info)&&this.g(d.Info,c([m,...v]))}warn(m,...v){this.f(d.Warning)&&this.g(d.Warning,c([m,...v]))}error(m,...v){if(this.f(d.Error))if(m instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=m.stack,this.g(d.Error,c(A))}else this.g(d.Error,c([m,...v]))}flush(){}}e.AbstractMessageLogger=g;class f extends u{constructor(m=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(m),this.g=!k.isWindows}trace(m,...v){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,m,...v):console.log(`[main ${y()}]`,m,...v))}debug(m,...v){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,m,...v):console.log(`[main ${y()}]`,m,...v))}info(m,...v){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,m,...v):console.log(`[main ${y()}]`,m,...v))}warn(m,...v){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,m,...v):console.warn(`[main ${y()}]`,m,...v))}error(m,...v){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,m,...v):console.error(`[main ${y()}]`,m,...v))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class S extends u{constructor(m=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(m)}trace(m,...v){this.f(d.Trace)&&console.log("%cTRACE","color: #888",m,...v)}debug(m,...v){this.f(d.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",m,...v)}info(m,...v){this.f(d.Info)&&console.log("%c INFO","color: #33f",m,...v)}warn(m,...v){this.f(d.Warning)&&console.log("%c WARN","color: #993",m,...v)}error(m,...v){this.f(d.Error)&&console.log("%c  ERR","color: #f33",m,...v)}dispose(){}flush(){}}e.ConsoleLogger=S;class R extends u{constructor(m,v=e.DEFAULT_LOG_LEVEL){super(),this.g=m,this.setLevel(v)}trace(m,...v){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(m),...v])}debug(m,...v){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(m),...v])}info(m,...v){this.f(d.Info)&&this.g.log(d.Info,[this.h(m),...v])}warn(m,...v){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(m),...v])}error(m,...v){this.f(d.Error)&&this.g.log(d.Error,[this.h(m),...v])}h(m){return typeof m=="string"?m:(0,L.toErrorMessage)(m,this.f(d.Trace))}dispose(){}flush(){}}e.AdapterLogger=R;class i extends u{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const v of this.g)v.setLevel(m);super.setLevel(m)}trace(m,...v){for(const A of this.g)A.trace(m,...v)}debug(m,...v){for(const A of this.g)A.debug(m,...v)}info(m,...v){for(const A of this.g)A.info(m,...v)}warn(m,...v){for(const A of this.g)A.warn(m,...v)}error(m,...v){for(const A of this.g)A.error(m,...v)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose()}}e.MultiplexLogger=i;class r extends l.Disposable{constructor(m,v,A){if(super(),this.h=m,this.j=v,this.b=new D.ResourceMap,this.c=this.B(new O.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.Emitter),this.onDidChangeVisibility=this.g.event,A)for(const T of A)this.b.set(T.resource,{logger:void 0,info:T})}k(m){return(0,C.isString)(m)?[...this.b.values()].find(v=>v.info.id===m):this.b.get(m)}getLogger(m){return this.k(m)?.logger}createLogger(m,v){const A=this.l(m);let T=this.b.get(A)?.logger;const M=v?.logLevel==="always"?d.Trace:v?.logLevel;T||(T=this.m(A,M??this.getLogLevel(A)??this.h,v));const z={logger:T,info:{resource:A,id:v?.id??A.toString(),logLevel:M,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId,when:v?.when}};return this.registerLogger(z.info),this.b.set(A,z),T}l(m){return(0,C.isString)(m)?(0,P.joinPath)(this.j,`${m}.log`):m}setLogLevel(m,v){if(b.URI.isUri(m)){const A=m,T=v,M=this.b.get(A);M&&T!==M.info.logLevel&&(M.info.logLevel=T===this.h?void 0:T,M.logger?.setLevel(T),this.b.set(M.info.resource,M),this.f.fire([A,T]))}else{this.h=m;for(const[A,T]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,v){const A=this.k(m);A&&v!==!A.info.hidden&&(A.info.hidden=!v,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,v]))}getLogLevel(m){let v;return m&&(v=this.b.get(m)?.info.logLevel),v??this.h}registerLogger(m){const v=this.b.get(m.resource);v?v.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const v=this.b.get(m);v&&(v.logger&&v.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[v.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=r;class t{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(m){}getLevel(){return d.Info}trace(m,...v){}debug(m,...v){}info(m,...v){}warn(m,...v){}error(m,...v){}critical(m,...v){}dispose(){}flush(){}}e.NullLogger=t;class n extends t{}e.NullLogService=n;function s(h){if(h.verbose)return d.Trace;if(typeof h.logLevel=="string"){const m=o(h.logLevel.toLowerCase());if(m!==void 0)return m}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function a(h){switch(h){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=a;function o(h){switch(h){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=o,e.CONTEXT_LOG_LEVEL=new I.RawContextKey("logLevel",a(d.Info))}),define(re[209],oe([0,1,6,9,2,23,28,15,8]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends l.Disposable{constructor(w,y){super(),this.a=w,this.b=y,this.B(new L.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,D.basename)(this.a.logsHome),y=(0,D.dirname)(this.a.logsHome),E=(await k.Promises.readdir(y.fsPath)).filter(u=>/^\d{8}T\d{6}$/.test(u)).sort().filter(u=>u!==w),c=E.slice(0,Math.max(0,E.length-9));c.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${c.join(", ")}'`),await Promise.all(c.map(u=>k.Promises.rm((0,D.joinPath)(y,u).fsPath))))}catch(w){(0,O.onUnexpectedError)(w)}}};b=ye([X(0,P.IEnvironmentService),X(1,C.ILogService)],b),e.LogsDataCleaner=b}),define(re[210],oe([0,1,21,6,9,3,2,13,55,8]),function(_,e,L,O,l,D,k,P,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends k.Disposable{constructor(y,p){super(),this.a=y,this.b=p,this.c=this.B(new D.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new O.ThrottledDelayer(0)),this.s=[],this.t=this.B(new O.ThrottledDelayer(0))}watch(y,p){return p.recursive||this.b?.watcher?.forceUniversal?this.l(y,p):this.u(y,p)}l(y,p){const d={path:this.C(y),excludes:p.excludes,includes:p.includes,recursive:p.recursive},E=(0,L.insert)(this.j,d);return this.m(),(0,k.toDisposable)(()=>{E(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(y=>(0,l.onUnexpectedError)(y))}n(){this.h||(this.h=this.B(this.p(p=>this.c.fire((0,C.toFileChanges)(p)),p=>this.z(p),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const p of this.j)(0,C.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const p of this.j)(0,C.isRecursiveWatchRequest)(p)&&y.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(y,p){const d={path:this.C(y),excludes:p.excludes,includes:p.includes,recursive:!1},E=(0,L.insert)(this.s,d);return this.v(),(0,k.toDisposable)(()=>{E(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(y=>(0,l.onUnexpectedError)(y))}w(){return this.r||(this.r=this.B(this.y(y=>this.c.fire((0,C.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.r.watch(this.s)}z(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}C(y){return(0,P.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(re[211],oe([0,1,21,6,16,25,3,64,62,2,49,22,104,23,43,166,14,103,8,9]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends b.Disposable{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new k.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new k.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new k.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new k.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new O.ResourceQueue)}registerProvider(i,r){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${i}`);const t=new b.DisposableStore;return this.h.set(i,r),this.c.fire({added:!0,scheme:i,provider:r}),t.add(r.onDidChangeFile(n=>this.R.fire(new c.FileChangesEvent(n,!this.O(r))))),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(n=>this.S.fire(new Error(n)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:i}))),(0,b.toDisposable)(()=>{this.c.fire({added:!1,scheme:i,provider:r}),this.h.delete(i),(0,b.dispose)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const r=[];this.f.fire({scheme:i,join(t){r.push(t)}}),!this.h.has(i)&&await O.Promises.settled(r)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,r){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return C.Iterable.map(this.h,([i,r])=>({scheme:i,capabilities:r.capabilities}))}async j(i){if(!(0,p.isAbsolutePath)(i))throw new c.FileOperationError((0,E.localize)(0,null,this.nb(i)),8);await this.activateProvider(i.scheme);const r=this.h.get(i.scheme);if(!r){const t=new f.ErrorNoTelemetry;throw t.message=(0,E.localize)(1,null,i.toString()),t}return r}async k(i){const r=await this.j(i);if((0,c.hasOpenReadWriteCloseCapability)(r)||(0,c.hasReadWriteCapability)(r)||(0,c.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(i){const r=await this.j(i);if((0,c.hasOpenReadWriteCloseCapability)(r)||(0,c.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,r){try{return await this.n(i,r)}catch(t){throw(0,c.toFileSystemProviderErrorCode)(t)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,E.localize)(2,null,this.nb(i)),1):(0,c.ensureFileSystemProviderError)(t)}}async n(i,r){const t=await this.j(i),n=this.O(t),s=r?.resolveTo,a=r?.resolveSingleChildDescendants,o=r?.resolveMetadata,h=await t.stat(i);let m;return this.p(t,i,h,void 0,!!o,(v,A)=>(m||(m=I.TernarySearchTree.forUris(()=>!n),m.set(i,!0),s&&m.fill(!0,s)),m.get(v.resource)||m.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&a?A===1:!1))}async p(i,r,t,n,s,a){const{providerExtUri:o}=this.N(i),h={resource:r,name:o.basename(r),isFile:(t.type&c.FileType.File)!==0,isDirectory:(t.type&c.FileType.Directory)!==0,isSymbolicLink:(t.type&c.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&c.FilePermission.Readonly)||Boolean(i.capabilities&2048),etag:(0,c.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(h.isDirectory&&a(h,n)){try{const m=await i.readdir(r),v=await O.Promises.settled(m.map(async([A,T])=>{try{const M=o.joinPath(r,A),z=s?await i.stat(M):{type:T};return await this.p(i,M,z,m.length,s,a)}catch(M){return this.b.trace(M),null}}));h.children=(0,L.coalesce)(v)}catch(m){this.b.trace(m),h.children=[]}return h}return h}async resolveAll(i){return O.Promises.settled(i.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const r=await this.j(i),t=await r.stat(i);return this.p(r,i,t,void 0,!0,()=>!1)}async exists(i){const r=await this.j(i);try{return!!await r.stat(i)}catch{return!1}}async canCreateFile(i,r){try{await this.r(i,r)}catch(t){return t}return!0}async r(i,r){if(!r?.overwrite&&await this.exists(i))throw new c.FileOperationError((0,E.localize)(3,null,this.nb(i)),3,r)}async createFile(i,r=l.VSBuffer.fromString(""),t){await this.r(i,t);const n=await this.writeFile(i,r);return this.m.fire(new c.FileOperationEvent(i,0,n)),n}async writeFile(i,r,t){const n=this.lb(await this.l(i),i),{providerExtUri:s}=this.N(n);try{await this.s(n,i,t)||await this.P(n,s.dirname(i));let o;if((0,c.hasReadWriteCapability)(n)&&!(r instanceof l.VSBuffer))if((0,d.isReadableStream)(r)){const h=await(0,d.peekStream)(r,3);h.ended?o=l.VSBuffer.concat(h.buffer):o=h}else o=(0,d.peekReadable)(r,h=>l.VSBuffer.concat(h),3);else o=r;!(0,c.hasOpenReadWriteCloseCapability)(n)||(0,c.hasReadWriteCapability)(n)&&o instanceof l.VSBuffer?await this.cb(n,i,t,o):await this.Y(n,i,t,o instanceof l.VSBuffer?(0,l.bufferToReadable)(o):o),this.m.fire(new c.FileOperationEvent(i,4))}catch(a){throw new c.FileOperationError((0,E.localize)(4,null,this.nb(i),(0,c.ensureFileSystemProviderError)(a).toString()),(0,c.toFileOperationResult)(a),t)}return this.resolve(i,{resolveMetadata:!0})}async s(i,r,t){if(!!t?.unlock&&!(i.capabilities&8192))throw new Error((0,E.localize)(5,null,this.nb(r)));let s;try{s=await i.stat(r)}catch{return}if((s.type&c.FileType.Directory)!==0)throw new c.FileOperationError((0,E.localize)(6,null,this.nb(r)),0,t);if(this.mb(r,s),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==c.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,c.etag)({mtime:t.mtime,size:s.size}))throw new c.FileOperationError((0,E.localize)(7,null),3,t);return s}async readFile(i,r,t){const n=await this.k(i);return r?.atomic?this.t(n,i,r,t):this.u(n,i,r,t)}async t(i,r,t,n){return new Promise((s,a)=>{this.X.queueFor(r,this.N(i).providerExtUri).queue(async()=>{try{const o=await this.u(i,r,t,n);s(o)}catch(o){a(o)}})})}async u(i,r,t,n){const s=await this.v(i,r,{...t,preferUnbuffered:!0},n);return{...s,value:await(0,l.streamToBuffer)(s.value)}}async readFileStream(i,r,t){const n=await this.k(i);return this.v(n,i,r,t)}async v(i,r,t,n){const s=new D.CancellationTokenSource(n),a=this.F(r,t).then(h=>h,h=>{throw s.cancel(),h});let o;try{return typeof t?.etag=="string"&&t.etag!==c.ETAG_DISABLED&&await a,t?.atomic&&(0,c.hasFileAtomicReadCapability)(i)||!((0,c.hasOpenReadWriteCloseCapability)(i)||(0,c.hasFileReadStreamCapability)(i))||(0,c.hasReadWriteCapability)(i)&&t?.preferUnbuffered?o=this.D(i,r,t):(0,c.hasFileReadStreamCapability)(i)?o=this.z(i,r,s.token,t):o=this.C(i,r,s.token,t),{...await a,value:o}}catch(h){throw o&&await(0,d.consumeStream)(o),this.w(h,r,t)}}w(i,r,t){const n=(0,E.localize)(8,null,this.nb(r),(0,c.ensureFileSystemProviderError)(i).toString());return i instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(n,i.stat,t):i instanceof c.TooLargeFileOperationError?new c.TooLargeFileOperationError(n,i.fileOperationResult,i.size,i.options):new c.FileOperationError(n,(0,c.toFileOperationResult)(i),t)}z(i,r,t,n=Object.create(null)){const s=i.readFileStream(r,n,t);return(0,d.transform)(s,{data:a=>a instanceof l.VSBuffer?a:l.VSBuffer.wrap(a),error:a=>this.w(a,r,n)},a=>l.VSBuffer.concat(a))}C(i,r,t,n=Object.create(null)){const s=(0,l.newWriteableBufferStream)();return(0,u.readFileIntoStream)(i,r,s,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>this.w(a,r,n)},t),s}D(i,r,t){const n=(0,d.newWriteableStream)(s=>l.VSBuffer.concat(s));return(async()=>{try{let s;t?.atomic&&(0,c.hasFileAtomicReadCapability)(i)?s=await i.readFile(r,{atomic:!0}):s=await i.readFile(r),typeof t?.position=="number"&&(s=s.slice(t.position)),typeof t?.length=="number"&&(s=s.slice(0,t.length)),this.G(r,s.byteLength,t),n.end(l.VSBuffer.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async F(i,r){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new c.FileOperationError((0,E.localize)(9,null,this.nb(i)),0,r);if(typeof r?.etag=="string"&&r.etag!==c.ETAG_DISABLED&&r.etag===t.etag)throw new c.NotModifiedSinceFileOperationError((0,E.localize)(10,null),t,r);return this.G(i,t.size,r),t}G(i,r,t){if(t?.limits){let n;if(typeof t.limits.memory=="number"&&r>t.limits.memory&&(n=9),typeof t.limits.size=="number"&&r>t.limits.size&&(n=7),typeof n=="number")throw new c.TooLargeFileOperationError((0,E.localize)(11,null,this.nb(i)),n,r,t)}}async canMove(i,r,t){return this.H(i,r,"move",t)}async canCopy(i,r,t){return this.H(i,r,"copy",t)}async H(i,r,t,n){if(i.toString()!==r.toString())try{const s=t==="move"?this.lb(await this.l(i),i):await this.k(i),a=this.lb(await this.l(r),r);await this.M(s,i,a,r,t,n)}catch(s){return s}return!0}async move(i,r,t){const n=this.lb(await this.l(i),i),s=this.lb(await this.l(r),r),a=await this.I(n,i,s,r,"move",!!t),o=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(i,a==="move"?2:3,o)),o}async copy(i,r,t){const n=await this.k(i),s=this.lb(await this.l(r),r),a=await this.I(n,i,s,r,"copy",!!t),o=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(i,a==="copy"?3:2,o)),o}async I(i,r,t,n,s,a){if(r.toString()===n.toString())return s;const{exists:o,isSameResourceWithDifferentPathCase:h}=await this.M(i,r,t,n,s,a);if(o&&!h&&a&&await this.del(n,{recursive:!0}),await this.P(t,this.N(t).providerExtUri.dirname(n)),s==="copy"){if(i===t&&(0,c.hasFileFolderCopyCapability)(i))await i.copy(r,n,{overwrite:a});else{const m=await this.resolve(r);m.isDirectory?await this.L(i,m,t,n):await this.J(i,r,t,n)}return s}else return i===t?(await i.rename(r,n,{overwrite:a}),s):(await this.I(i,r,t,n,"copy",a),await this.del(r,{recursive:!0}),"copy")}async J(i,r,t,n){if((0,c.hasOpenReadWriteCloseCapability)(i)&&(0,c.hasOpenReadWriteCloseCapability)(t))return this.eb(i,r,t,n);if((0,c.hasOpenReadWriteCloseCapability)(i)&&(0,c.hasReadWriteCapability)(t))return this.kb(i,r,t,n);if((0,c.hasReadWriteCapability)(i)&&(0,c.hasOpenReadWriteCloseCapability)(t))return this.ib(i,r,t,n);if((0,c.hasReadWriteCapability)(i)&&(0,c.hasReadWriteCapability)(t))return this.gb(i,r,t,n)}async L(i,r,t,n){await t.mkdir(n),Array.isArray(r.children)&&await O.Promises.settled(r.children.map(async s=>{const a=this.N(t).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.L(i,await this.resolve(s.resource),t,a):this.J(i,s.resource,t,a)}))}async M(i,r,t,n,s,a){let o=!1;if(i===t){const{providerExtUri:m,isPathCaseSensitive:v}=this.N(i);if(v||(o=m.isEqual(r,n)),o&&s==="copy")throw new Error((0,E.localize)(12,null,this.nb(r),this.nb(n)));if(!o&&m.isEqualOrParent(n,r))throw new Error((0,E.localize)(13,null,this.nb(r),this.nb(n)))}const h=await this.exists(n);if(h&&!o){if(!a)throw new c.FileOperationError((0,E.localize)(14,null,this.nb(r),this.nb(n)),4);if(i===t){const{providerExtUri:m}=this.N(i);if(m.isEqualOrParent(r,n))throw new Error((0,E.localize)(15,null,this.nb(r),this.nb(n)))}}return{exists:h,isSameResourceWithDifferentPathCase:o}}N(i){const r=this.O(i);return{providerExtUri:r?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:r}}O(i){return!!(i.capabilities&1024)}async createFolder(i){const r=this.lb(await this.j(i),i);await this.P(r,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(i,0,t)),t}async P(i,r){const t=[],{providerExtUri:n}=this.N(i);for(;!n.isEqual(r,n.dirname(r));)try{if(((await i.stat(r)).type&c.FileType.Directory)===0)throw new Error((0,E.localize)(16,null,this.nb(r)));break}catch(s){if((0,c.toFileSystemProviderErrorCode)(s)!==c.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(n.basename(r)),r=n.dirname(r)}for(let s=t.length-1;s>=0;s--){r=n.joinPath(r,t[s]);try{await i.mkdir(r)}catch(a){if((0,c.toFileSystemProviderErrorCode)(a)!==c.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(i,r){try{await this.Q(i,r)}catch(t){return t}return!0}async Q(i,r){const t=this.lb(await this.j(i),i);if(!!r?.useTrash&&!(t.capabilities&4096))throw new Error((0,E.localize)(17,null,this.nb(i)));let s;try{s=await t.stat(i)}catch{}if(s)this.mb(i,s);else throw new c.FileOperationError((0,E.localize)(18,null,this.nb(i)),1);if(!!!r?.recursive){const o=await this.resolve(i);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,E.localize)(19,null,this.nb(i)))}return t}async del(i,r){const t=await this.Q(i,r),n=!!r?.useTrash,s=!!r?.recursive;await t.delete(i,{recursive:s,useTrash:n}),this.m.fire(new c.FileOperationEvent(i,1))}async cloneFile(i,r){const t=await this.j(i),n=this.lb(await this.l(r),r);if(t===n&&this.N(t).providerExtUri.isEqual(i,r))return;if(t===n&&(0,c.hasFileCloneCapability)(t))return t.cloneFile(i,r);await this.P(n,this.N(n).providerExtUri.dirname(r));const s=this.X.queueFor(i,this.N(t).providerExtUri);return t===n&&(0,c.hasFileFolderCopyCapability)(t)?s.queue(()=>t.copy(i,r,{overwrite:!0})):s.queue(()=>this.J(t,i,n,r))}watch(i,r={recursive:!1,excludes:[]}){const t=new b.DisposableStore;let n=!1,s=()=>{n=!0};return t.add((0,b.toDisposable)(()=>s())),(async()=>{try{const a=await this.W(i,r);n?(0,b.dispose)(a):s=()=>(0,b.dispose)(a)}catch(a){this.b.error(a)}})(),t}async W(i,r){const t=await this.j(i),n=(0,P.hash)([this.N(t).providerExtUri.getComparisonKey(i),r]);let s=this.U.get(n);return s||(s={count:0,disposable:t.watch(i,r)},this.U.set(n,s)),s.count+=1,(0,b.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,b.dispose)(s.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,i]of this.U)(0,b.dispose)(i.disposable);this.U.clear()}async Y(i,r,t,n){return this.X.queueFor(r,this.N(i).providerExtUri).queue(async()=>{const s=await i.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,d.isReadableStream)(n)||(0,d.isReadableBufferedStream)(n)?await this.Z(i,s,n):await this.ab(i,s,n)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await i.close(s)}})}async Z(i,r,t){let n=0,s;if((0,d.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=l.VSBuffer.concat(t.buffer);await this.bb(i,r,a,a.byteLength,n,0),n+=a.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise((a,o)=>{(0,d.listenStream)(s,{onData:async h=>{s.pause();try{await this.bb(i,r,h,h.byteLength,n,0)}catch(m){return o(m)}n+=h.byteLength,setTimeout(()=>s.resume())},onError:h=>o(h),onEnd:()=>a()})})}async ab(i,r,t){let n=0,s;for(;(s=t.read())!==null;)await this.bb(i,r,s,s.byteLength,n,0),n+=s.byteLength}async bb(i,r,t,n,s,a){let o=0;for(;o<n;)o+=await i.write(r,s+o,t.buffer,a+o,n-o)}async cb(i,r,t,n){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.db(i,r,t,n))}async db(i,r,t,n){let s;n instanceof l.VSBuffer?s=n:(0,d.isReadableStream)(n)?s=await(0,l.streamToBuffer)(n):(0,d.isReadableBufferedStream)(n)?s=await(0,l.bufferedStreamToBuffer)(n):s=(0,l.readableToBuffer)(n),await i.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async eb(i,r,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.fb(i,r,t,n))}async fb(i,r,t,n){let s,a;try{s=await i.open(r,{create:!1}),a=await t.open(n,{create:!0,unlock:!1});const o=l.VSBuffer.alloc(this.a);let h=0,m=0,v=0;do v=await i.read(s,h,o.buffer,m,o.byteLength-m),await this.bb(t,a,o,v,h,m),h+=v,m+=v,m===o.byteLength&&(m=0);while(v>0)}catch(o){throw(0,c.ensureFileSystemProviderError)(o)}finally{await O.Promises.settled([typeof s=="number"?i.close(s):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async gb(i,r,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.hb(i,r,t,n))}async hb(i,r,t,n){return t.writeFile(n,await i.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async ib(i,r,t,n){return this.X.queueFor(n,this.N(t).providerExtUri).queue(()=>this.jb(i,r,t,n))}async jb(i,r,t,n){const s=await t.open(n,{create:!0,unlock:!1});try{const a=await i.readFile(r);await this.bb(t,s,l.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await t.close(s)}}async kb(i,r,t,n){const s=await(0,l.streamToBuffer)(this.C(i,r,D.CancellationToken.None));await this.cb(t,n,void 0,s)}lb(i,r){if(i.capabilities&2048)throw new c.FileOperationError((0,E.localize)(20,null,this.nb(r)),6);return i}mb(i,r){if((r.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,E.localize)(21,null,this.nb(i)),6)}nb(i){return i.scheme===w.Schemas.file?i.fsPath:i.toString(!0)}};S=ye([X(0,g.ILogService)],S),e.FileService=S}),define(re[212],oe([0,1,53,293,6,37,16,3,48,2,13,4,23,43,28,169,14,103,210,38,206,205]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g,f,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(L)}catch(r){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(r)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(t,n){super(t,n),this.onDidChangeCapabilities=P.Event.None,this.H=new D.ResourceMap(s=>y.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,w.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:n,symbolicLink:s}=await d.SymlinkSupport.stat(this.C(t));return{type:this.G(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(t){try{const n=await d.Promises.readdir(this.C(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async a=>{try{let o;a.isSymbolicLink()?o=(await this.stat((0,y.joinPath)(t,a.name))).type:o=this.G(a),s.push([a.name,o])}catch(o){this.a.trace(o)}})),s}catch(n){throw this.Y(n)}}G(t,n){let s;return n?.dangling?s=c.FileType.Unknown:t.isFile()?s=c.FileType.File:t.isDirectory()?s=c.FileType.Directory:s=c.FileType.Unknown,n&&(s|=c.FileType.SymbolicLink),s}async I(t){const n=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const a=new l.Barrier;return this.H.set(t,a),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(t)===a&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),s=await this.I(t));const a=this.C(t);return await d.Promises.readFile(a)}catch(a){throw this.Y(a)}finally{s?.dispose()}}J(t){i.D&&this.a.trace(t)}readFileStream(t,n,s){const a=(0,p.newWriteableStream)(o=>k.VSBuffer.concat(o.map(h=>k.VSBuffer.wrap(h))).buffer);return(0,u.readFileIntoStream)(this,t,a,o=>o.buffer,{...n,bufferSize:256*1024},s),a}async writeFile(t,n,s){let a;try{const o=this.C(t);if(!s.create||!s.overwrite){if(await d.Promises.exists(o)){if(!s.overwrite)throw(0,c.createFileSystemProviderError)((0,E.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,c.createFileSystemProviderError)((0,E.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(o){throw await this.Z(t,o)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(t){i.O=t}async open(t,n){const s=this.C(t);let a;(0,c.isFileOpenForWriteOptions)(n)&&(a=await this.I(t));let o;try{if((0,c.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:m}=await d.SymlinkSupport.stat(s);m.mode&128||await d.Promises.chmod(s,m.mode|128)}catch(m){this.a.trace(m)}let h;if((0,c.isFileOpenForWriteOptions)(n)){if(w.isWindows)try{await d.Promises.truncate(s,0),h="r+"}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}h||(h="w")}else h="r";o=await d.Promises.open(s,h)}catch(h){throw a?.dispose(),(0,c.isFileOpenForWriteOptions)(n)?await this.Z(t,h):this.Y(h)}if(this.L.set(o,0),(0,c.isFileOpenForWriteOptions)(n)&&this.N.set(o,t),a){const h=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${s})`),this.M.set(o,a),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${s})`),h.dispose())}return o}async close(t){const n=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&i.O)try{await d.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await d.Promises.close(t)}catch(s){throw this.Y(s)}finally{n&&(this.M.get(t)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,a,o){const h=this.P(t,n);let m=null;try{m=(await d.Promises.read(t,s,a,o,h)).bytesRead}catch(v){throw this.Y(v)}finally{this.Q(t,h,m)}return m}P(t,n){return n===this.L.get(t)?null:n}Q(t,n,s){const a=this.L.get(t);typeof a=="number"&&(typeof n=="number"||(typeof s=="number"?this.L.set(t,a+s):this.L.delete(t)))}async write(t,n,s,a,o){return(0,l.retry)(()=>this.R(t,n,s,a,o),100,3)}async R(t,n,s,a,o){const h=this.P(t,n);let m=null;try{m=(await d.Promises.write(t,s,a,o,h)).bytesWritten}catch(v){throw await this.Z(this.N.get(t),v)}finally{this.Q(t,h,m)}return m}async mkdir(t){try{await d.Promises.mkdir(this.C(t))}catch(n){throw this.Y(n)}}async delete(t,n){try{const s=this.C(t);n.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(t,n,s){const a=this.C(t),o=this.C(n);if(a!==o)try{await this.S(t,n,"move",s.overwrite),await d.Promises.move(a,o)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,E.localize)(2,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(o)),h.toString()))),this.Y(h)}}async copy(t,n,s){const a=this.C(t),o=this.C(n);if(a!==o)try{await this.S(t,n,"copy",s.overwrite),await d.Promises.copy(a,o,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,E.localize)(3,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(o)),h.toString()))),this.Y(h)}}async S(t,n,s,a){const o=this.C(t),h=this.C(n);let m=!1;if(!!(this.capabilities&1024)||(m=(0,C.isEqual)(o,h,!0)),m&&s==="copy")throw(0,c.createFileSystemProviderError)((0,E.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!m&&await d.Promises.exists(h)){if(!a)throw(0,c.createFileSystemProviderError)((0,E.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(t,n){return this.U(t,n,!1)}async U(t,n,s){const a=this.C(t),o=this.C(n),h=!!(this.capabilities&1024);if((0,C.isEqual)(a,o,!h))return;const m=new b.DisposableStore;try{const[v,A]=await Promise.all([this.I(t),this.I(n)]);m.add(v),m.add(A),s&&await d.Promises.mkdir((0,I.dirname)(o),{recursive:!0}),await d.Promises.copyFile(a,o)}catch(v){if(v.code==="ENOENT"&&!s)return this.U(t,n,!0);throw this.Y(v)}finally{m.dispose()}}p(t,n,s){return new S.UniversalWatcherClient(a=>t(a),a=>n(a),s)}y(t,n,s){return new R.NodeJSWatcherClient(a=>t(a),a=>n(a),s)}Y(t){if(t instanceof c.FileSystemProviderError)return t;let n;switch(t.code){case"ENOENT":n=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=c.FileSystemProviderErrorCode.NoPermissions;break;default:n=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(t,n)}async Z(t,n){let s=this.Y(n);if(t&&s.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await d.SymlinkSupport.stat(this.C(t));a.mode&128||(s=(0,c.createFileSystemProviderError)(n,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return s}}i.D=!1,i.O=!0,e.DiskFileSystemProvider=i}),define(re[105],oe([0,1,3,2,5,8]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,l.createDecorator)("sharedProcessLifecycleService");let k=class extends O.Disposable{constructor(C){super(),this.b=C,this.a=this.B(new L.Emitter),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};k=ye([X(0,D.ILogService)],k),e.SharedProcessLifecycleService=k}),define(re[106],oe([0,1,11,3,8,2]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class k extends l.AbstractLoggerService{constructor(w,y,p,d,E){super(y,p,d),this.n=w,this.p=E,this.B(E.listen("onDidChangeLogLevel",w)(c=>{(0,l.isLogLevel)(c)?super.setLogLevel(c):super.setLogLevel(L.URI.revive(c[0]),c[1])})),this.B(E.listen("onDidChangeVisibility",w)(([c,u])=>super.setVisibility(L.URI.revive(c),u))),this.B(E.listen("onDidChangeLoggers",w)(({added:c,removed:u})=>{for(const g of c)super.registerLogger({...g,resource:L.URI.revive(g.resource)});for(const g of u)super.deregisterLogger(g.resource)}))}createConsoleMainLogger(){return new l.AdapterLogger({log:(w,y)=>{this.p.call("consoleLog",[w,y])}})}registerLogger(w){super.registerLogger(w),this.p.call("registerLogger",[w,this.n])}deregisterLogger(w){super.deregisterLogger(w),this.p.call("deregisterLogger",[w,this.n])}setLogLevel(w,y){super.setLogLevel(w,y),this.p.call("setLogLevel",[w,y])}setVisibility(w,y){super.setVisibility(w,y),this.p.call("setVisibility",[w,y])}m(w,y,p){return new P(this.p,w,y,p,this.n)}static setLogLevel(w,y,p){return w.call("setLogLevel",[y,p])}}e.LoggerChannelClient=k;class P extends l.AbstractMessageLogger{constructor(w,y,p,d,E){super(d?.logLevel==="always"),this.m=w,this.n=y,this.k=!1,this.l=[],this.setLevel(p),this.m.call("createLogger",[y,d,E]).then(()=>{this.r(this.l),this.k=!0})}g(w,y){const p=[[w,y]];this.k?this.r(p):this.l.push(...p)}r(w){this.m.call("log",[this.n,w])}}class C{constructor(w,y){this.a=w,this.b=y}listen(w,y){const p=this.b(w);switch(y){case"onDidChangeLoggers":return O.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(E=>this.c(E,p)),removed:[...d.removed].map(E=>this.c(E,p))}));case"onDidChangeVisibility":return O.Event.map(this.a.onDidChangeVisibility,d=>[p.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return O.Event.map(this.a.onDidChangeLogLevel,d=>(0,l.isLogLevel)(d)?d:[p.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${y}`)}async call(w,y,p){const d=this.b(w);switch(y){case"setLogLevel":return(0,l.isLogLevel)(p[0])?this.a.setLogLevel(p[0]):this.a.setLogLevel(L.URI.revive(d.transformIncoming(p[0][0])),p[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(E=>this.c(E,d)))}throw new Error(`Call not found: ${y}`)}c(w,y){return{...w,resource:y.transformOutgoingURI(w.resource)}}}e.LoggerChannel=C;class b extends D.Disposable{constructor(w,y){super(),y.call("setLogLevel",[w.getLogLevel()]),this.B(w.onDidChangeLogLevel(p=>y.call("setLogLevel",[p]))),y.call("getRegisteredLoggers").then(p=>{for(const d of p)w.registerLogger({...d,resource:L.URI.revive(d.resource)})}),this.B(y.listen("onDidChangeVisibility")(([p,d])=>w.setVisibility(L.URI.revive(p),d))),this.B(y.listen("onDidChangeLoggers")(({added:p,removed:d})=>{for(const E of p)w.registerLogger({...E,resource:L.URI.revive(E.resource)});for(const E of d)w.deregisterLogger(E.resource)}))}}e.RemoteLoggerChannelClient=b}),define(re[213],oe([0,1,2,8]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends L.Disposable{constructor(k,P=[]){super(),this.a=new O.MultiplexLogger([k,...P]),this.B(k.onDidChangeLogLevel(C=>this.setLevel(C)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(k){this.a.setLevel(k)}getLevel(){return this.a.getLevel()}trace(k,...P){this.a.trace(k,...P)}debug(k,...P){this.a.debug(k,...P)}info(k,...P){this.a.info(k,...P)}warn(k,...P){this.a.warn(k,...P)}error(k,...P){this.a.error(k,...P)}flush(){this.a.flush()}}e.LogService=l}),define(re[56],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(re[57],oe([0,1,3,62,2,5]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,D.createDecorator)("policy");class k extends l.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const I=Object.keys(this.f).length;return this.f={...b,...this.f},I!==Object.keys(this.f).length&&await this.i(b),O.Iterable.reduce(this.g.entries(),(w,[y,p])=>({...w,[y]:p}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(b,[I,w])=>({...b,[I]:{definition:w,value:this.g.get(I)}}),{})}}e.AbstractPolicyService=k;class P{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(re[214],oe([0,1,3,2,57]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class D{constructor(C){this.b=C,this.a=new O.DisposableStore}listen(C,b){switch(b){case"onDidChange":return L.Event.map(this.b.onDidChange,I=>I.reduce((w,y)=>({...w,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${b}`)}call(C,b,I){switch(b){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(I)}throw new Error(`Call not found: ${b}`)}dispose(){this.a.dispose()}}e.PolicyChannel=D;class k extends l.AbstractPolicyService{constructor(C,b){super(),this.a=b;for(const I in C){const{definition:w,value:y}=C[I];this.f[I]=w,y!==void 0&&this.g.set(I,y)}this.a.listen("onDidChange")(I=>{for(const w in I){const y=I[w];y===null?this.g.delete(w):this.g.set(w,y)}this.h.fire(Object.keys(I))})}async i(C){const b=await this.a.call("updatePolicyDefinitions",C);for(const I in b)this.g.set(I,b[I])}}e.PolicyChannelClient=k}),define(re[107],oe([0,1,4,36]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof L.globals.vscode<"u"&&typeof L.globals.vscode.context<"u"){const D=L.globals.vscode.context.configuration();if(D)l=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:D.version})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(re[26],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[215],oe([0,1,6,9,2,13,28,8,26]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends l.Disposable{constructor(w,y,p){super(),this.b=y,this.c=p,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this.B(new L.RunOnceScheduler(()=>{this.f(w)},3e4)).schedule()}async f(w){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const y=Date.now(),p=(0,D.dirname)(w),d=(0,D.basename)(w),E=await k.Promises.readdir(p);await Promise.all(E.map(async c=>{if(c===d)return;const u=(0,D.join)(p,c),g=await k.Promises.stat(u);if(g.isDirectory()&&y-g.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${c}.`),k.Promises.rm(u)}))}catch(y){(0,O.onUnexpectedError)(y)}}};b=ye([X(1,C.IProductService),X(2,P.ILogService)],b),e.CodeCacheCleaner=b}),define(re[216],oe([0,1,6,9,2,13,28,15,8,26]),function(_,e,L,O,l,D,k,P,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends l.Disposable{constructor(y,p,d){super(),this.b=y,this.c=p,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new L.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const y=Object.create(null),p=JSON.parse(await k.Promises.readFile((0,D.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(p)){const f=p[g];y[`${f.hash}.${g}`]=!0}const d=(0,D.join)(this.b.userDataPath,"clp");if(!await k.Promises.exists(d))return;const c=await k.Promises.readdir(d);for(const g of c){if(y[g]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await k.Promises.rm((0,D.join)(d,g))}const u=Date.now();for(const g of Object.keys(y)){const f=(0,D.join)(d,g),S=await k.Promises.readdir(f);for(const R of S){if(R==="tcf.json")continue;const i=(0,D.join)(f,R),r=await k.Promises.stat(i);r.isDirectory()&&u-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,D.join)(g,R)}`),await k.Promises.rm(i))}}}catch(y){(0,O.onUnexpectedError)(y)}}};I=ye([X(0,P.INativeEnvironmentService),X(1,C.ILogService),X(2,b.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(re[217],oe([0,1,13,5]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,O.createDecorator)("IV8InspectProfilingService");var l;(function(D){function k(C){return Boolean(C.samples&&C.timeDeltas)}D.isValidProfile=k;function P(C,b="noAbsolutePaths"){for(const I of C.nodes)I.callFrame&&I.callFrame.url&&((0,L.isAbsolute)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(I.callFrame.url))&&(I.callFrame.url=(0,L.join)(b,(0,L.basename)(I.callFrame.url)));return C}D.rewriteAbsolutePaths=P})(l=e.Utils||(e.Utils={}))}),define(re[218],oe([0,1,31]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class O{constructor(){this.a=new Map}async startProfiling(D){const P=await(await new Promise((b,I)=>{_(["v8-inspect-profiler"],b,I)})).startProfiling({port:D.port,checkForPaused:!0}),C=(0,L.generateUuid)();return this.a.set(C,P),C}async stopProfiling(D){const k=this.a.get(D);if(!k)throw new Error(`UNKNOWN session '${D}'`);const P=await k.stop();return this.a.delete(D),P.profile}}e.InspectProfilingService=O}),define(re[40],oe([0,1,129,12]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(k,P){L.ok(O.isString(k)),L.ok(O.isObject(P)),L.ok(!this.a.has(k),"There is already an extension with this id"),this.a.set(k,P)}knows(k){return this.a.has(k)}as(k){return this.a.get(k)||null}}e.Registry=new l}),define(re[108],oe([0,1,3,40]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class D{constructor(){this.b=new L.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(C,b){this.a[l(C)]=b,this.b.fire(C)}notifySchemaChanged(C){this.b.fire(C)}getSchemaContributions(){return{schemas:this.a}}}const k=new D;O.Registry.add(e.Extensions.JSONContribution,k)}),define(re[45],oe([0,1,21,3,12,155,17,108,40]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(R){R.Multiline="multilineText",R.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(R){R[R.APPLICATION=1]="APPLICATION",R[R.MACHINE=2]="MACHINE",R[R.WINDOW=3]="WINDOW",R[R.RESOURCE=4]="RESOURCE",R[R.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",R[R.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=C.Registry.as(P.Extensions.JSONContribution);class y{constructor(){this.h=new Set,this.i=new O.Emitter,this.onDidSchemaChange=this.i.event,this.j=new O.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const a in n)if(r.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const o=this.a.get(a),h=o?.valuesSources??new Map;if(s)for(const T of Object.keys(n[a]))h.set(T,s);const m={...o?.value||{},...n[a]};this.a.set(a,{source:s,value:m,valuesSources:h});const v=(0,k.getLanguageTagSettingPlainKey)(a),A={type:"object",default:m,description:D.localize(1,null,v),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:l.isString(s)?void 0:s,defaultValueSource:s};t.push(...E(a)),this.d[a]=A,this.b.properties[a]=A}else{this.a.set(a,{value:n[a],source:s});const o=this.d[a];o&&(this.w(a,o),this.r(a,o))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const a=this.a.get(s),o=l.isString(n)?n:n?.id,h=l.isString(a?.source)?a?.source:a?.source?.id;if(o===h)if(r.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const m=this.d[s];m&&(this.w(s,m),this.r(s,m))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const a=this.d[s];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,a){s=l.isUndefinedOrNull(i.scope)?s:i.scope;const o=i.properties;if(o)for(const m in o){const v=o[m];if(r&&f(m,v)){delete o[m];continue}if(v.source=t,v.defaultDefaultValue=o[m].default,this.w(m,v),e.OVERRIDE_PROPERTY_REGEX.test(m)?v.scope=void 0:(v.scope=l.isUndefinedOrNull(v.scope)?s:v.scope,v.restricted=l.isUndefinedOrNull(v.restricted)?!!n?.includes(m):v.restricted),o[m].hasOwnProperty("included")&&!o[m].included){this.f[m]=o[m],delete o[m];continue}else this.d[m]=o[m],o[m].policy?.name&&this.e.set(o[m].policy.name,m);!o[m].deprecationMessage&&o[m].markdownDeprecationMessage&&(o[m].deprecationMessage=o[m].markdownDeprecationMessage),a.add(m)}const h=i.allOf;if(h)for(const m of h)this.p(m,r,t,n,s,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const a in n)this.r(a,n[a]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.allSettings.properties[i]=r,r.scope){case 1:e.applicationSettings.properties[i]=r;break;case 2:e.machineSettings.properties[i]=r;break;case 6:e.machineOverridableSettings.properties[i]=r;break;case 3:e.windowSettings.properties[i]=r;break;case 4:e.resourceSettings.properties[i]=r;break;case 5:e.resourceSettings.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.allSettings.properties[i],r.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}}v(){const i={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;l.isUndefined(n)&&(n=r.defaultDefaultValue,s=void 0),l.isUndefined(n)&&(n=u(r.type)),r.default=n,r.defaultValueSource=s}}const p="\\[([^\\]]+)\\]",d=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(R){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(R)){let r=d.exec(R);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=d.exec(R)}}return(0,L.distinct)(i)}e.overrideIdentifiersFromKey=E;function c(R){return R.reduce((i,r)=>`${i}[${r}]`,"")}e.keyFromOverrideIdentifiers=c;function u(R){switch(Array.isArray(R)?R[0]:R){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const g=new y;C.Registry.add(e.Extensions.Configuration,g);function f(R,i){return R.trim()?e.OVERRIDE_PROPERTY_REGEX.test(R)?D.localize(7,null,R):g.getConfigurationProperties()[R]!==void 0?D.localize(8,null,R):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?D.localize(9,null,R,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:D.localize(6,null)}e.validateProperty=f;function S(){const R=[],i=g.getConfigurationProperties();for(const r of Object.keys(i))R.push([r,i[r].scope]);return R.push(["launch",4]),R.push(["task",4]),R}e.getScopes=S}),define(re[72],oe([0,1,21,3,35,2,37,32,12,11,17,45,40]),function(_,e,L,O,l,D,k,P,C,b,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function p(r){return Object.isFrozen(r)?r:P.deepFreeze(r)}class d{constructor(t={},n=[],s=[],a){this.b=t,this.c=n,this.d=s,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof d)return n;const s=new E("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,I.getConfigurationValue)(this.contents,t):this.contents}inspect(t,n){const s=this.rawConfiguration.getValue(t),a=n?this.rawConfiguration.getOverrideValue(t,n):void 0,o=n?this.rawConfiguration.override(n).getValue(t):s;return{value:s,override:a,merged:o}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,I.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return L.distinct(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return L.distinct(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=P.deepClone(this.contents),s=P.deepClone(this.overrides),a=[...this.keys],o=this.raw?.length?[...this.raw]:[this];for(const h of t)if(o.push(...h.raw?.length?h.raw:[h]),!h.isEmpty()){this.h(n,h.contents);for(const m of h.overrides){const[v]=s.filter(A=>L.equals(A.identifiers,m.identifiers));v?(this.h(v.contents,m.contents),v.keys.push(...m.keys),v.keys=L.distinct(v.keys)):s.push(P.deepClone(m))}for(const m of h.keys)a.indexOf(m)===-1&&a.push(m)}return new d(n,a,s,o.every(h=>h instanceof d)?void 0:o)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const a of L.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[a];const h=n[a];h&&(typeof o=="object"&&typeof h=="object"?(o=P.deepClone(o),this.h(o,h)):o=h),s[a]=o}return new d(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&C.isObject(t[s])&&C.isObject(n[s])){this.h(t[s],n[s]);continue}t[s]=P.deepClone(n[s])}}i(t){let n=null,s=null;const a=o=>{o&&(s?this.h(s,o):s=P.deepClone(o))};for(const o of this.overrides)L.equals(o.identifiers,[t])?n=o.contents:o.identifiers.includes(t)&&a(o.contents);return a(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,I.removeFromValueTree)(this.contents,t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>L.equals(s.identifiers,(0,w.overrideIdentifiersFromKey)(t))),1))}j(t,n,s){(0,I.addToValueTree)(this.contents,t,n,a=>console.error(a)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),w.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,I.toValuesTree)(this.contents[t],a=>console.error(a))})}}e.ConfigurationModel=d;class E{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!C.isUndefinedOrNull(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:a,overrides:o,restricted:h,hasExcludedProperties:m}=this.h(t,n);this.b=new d(s,a,o,m?[t]:void 0),this.c=h||[]}g(t){let n={},s=null,a=[];const o=[],h=[];function m(A){Array.isArray(a)?a.push(A):s!==null&&(a[s]=A)}const v={onObjectBegin:()=>{const A={};m(A),o.push(a),a=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{a=o.pop()},onArrayBegin:()=>{const A=[];m(A),o.push(a),a=A,s=null},onArrayEnd:()=>{a=o.pop()},onLiteralValue:m,onError:(A,T,M)=>{h.push({error:A,offset:T,length:M})}};if(t)try{l.visit(t,v),n=a[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return n}h(t,n){const s=y.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),a=this.i(t,s,!0,n);t=a.raw;const o=(0,I.toValuesTree)(t,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),h=Object.keys(t),m=this.j(t,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:o,keys:h,overrides:m,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(t,n,s,a){let o=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:o};const h={},m=[];for(const v in t)if(w.OVERRIDE_PROPERTY_REGEX.test(v)&&s){const A=this.i(t[v],n,!1,a);h[v]=A.raw,o=o||A.hasExcludedProperties,m.push(...A.restricted)}else{const A=n[v],T=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&m.push(v),(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&!(a.skipRestricted&&A?.restricted)?h[v]=t[v]:o=!0}return{raw:h,restricted:m,hasExcludedProperties:o}}j(t,n){const s=[];for(const a of Object.keys(t))if(w.OVERRIDE_PROPERTY_REGEX.test(a)){const o={};for(const h in t[a])o[h]=t[a][h];s.push({identifiers:(0,w.overrideIdentifiersFromKey)(a),keys:Object.keys(o),contents:(0,I.toValuesTree)(o,n)})}return s}}e.ConfigurationModelParser=E;class c extends D.Disposable{constructor(t,n,s,a){super(),this.f=t,this.g=n,this.h=a,this.c=this.B(new O.Emitter),this.onDidChange=this.c.event,this.a=new E(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(O.Event.any(O.Event.filter(this.h.onDidFilesChange,o=>o.contains(this.f)),O.Event.filter(this.h.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&s.isEqual(o.resource,t)))(()=>this.c.fire()))}async loadConfiguration(){try{const t=await this.h.readFile(this.f);return this.a.parse(t.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new d}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=c;class u{constructor(t,n,s,a,o,h,m,v,A,T,M,z,H){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=a,this.d=o,this.f=h,this.g=m,this.h=v,this.i=A,this.j=T,this.k=M,this.l=z,this.m=H}get value(){return p(this.c)}n(t,n,s){const a=t.inspect(n,s);return{get value(){return p(a.value)},get override(){return p(a.override)},get merged(){return p(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(t,n,s,a,o=new d,h=new d,m=new k.ResourceMap,v=new d,A=new k.ResourceMap){this.c=t,this.d=n,this.f=s,this.g=a,this.h=o,this.i=h,this.j=m,this.l=v,this.m=A,this.a=null,this.b=new k.ResourceMap,this.n=null}getValue(t,n,s){return this.q(t,n,s).getValue(t)}updateValue(t,n,s={}){let a;s.resource?(a=this.m.get(s.resource),a||(a=new d,this.m.set(s.resource,a))):a=this.l,n===void 0?a.removeValue(t):a.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const a=this.q(t,n,s),o=this.u(n.resource,s),h=n.resource?this.m.get(n.resource)||this.l:this.l,m=new Set;for(const v of a.overrides)for(const A of v.identifiers)a.getOverrideValue(t,A)!==void 0&&m.add(A);return new u(t,n,a.getValue(t),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,o||void 0,h)}keys(t){const n=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:a,updated:o,removed:h}=R(this.c,t);n=[...a,...o,...h]}for(const a of n)for(const o of(0,w.overrideIdentifiersFromKey)(a)){const h=this.c.getKeysForOverrideIdentifier(o),m=t.getKeysForOverrideIdentifier(o),v=[...m.filter(A=>h.indexOf(A)===-1),...h.filter(A=>m.indexOf(A)===-1),...h.filter(A=>!P.equals(this.c.override(o).getValue(A),t.override(o).getValue(A)))];s.push([o,v])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:a}=R(this.d,t),o=[...n,...s,...a];return o.length&&this.updatePolicyConfiguration(t),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:a,overrides:o}=R(this.applicationConfiguration,t),h=[...n,...s,...a];return h.length&&this.updateApplicationConfiguration(t),{keys:h,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:a,overrides:o}=R(this.localUserConfiguration,t),h=[...n,...s,...a];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:a,overrides:o}=R(this.remoteUserConfiguration,t),h=[...n,...s,...a];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:a,overrides:o}=R(this.workspaceConfiguration,t),h=[...n,...s,...a];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:o}}compareAndUpdateFolderConfiguration(t,n){const s=this.p.get(t),{added:a,updated:o,removed:h,overrides:m}=R(s,n),v=[...a,...o,...h];return(v.length||!s)&&this.updateFolderConfiguration(t,n),{keys:v,overrides:m}}compareAndDeleteFolderConfiguration(t){const n=this.p.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:a,removed:o,overrides:h}=R(n,void 0);return{keys:[...s,...a,...o],overrides:h}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,n,s){let a=this.r(n,s);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(a=a.merge(this.d)),a}r({resource:t},n){let s=this.s();if(n&&t){const a=n.getFolder(t);a&&(s=this.t(a.uri)||s);const o=this.m.get(t);o&&(s=s.merge(o))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let n=this.b.get(t);if(!n){const s=this.s(),a=this.j.get(t);a?(n=s.merge(a),this.b.set(t,n)):n=s}return n}u(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:a,keys:o}=this.j.get(n);return t.push([n,{contents:s,overrides:a,keys:o}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}w(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a))),[...n.values()]}static parse(t){const n=this.x(t.defaults),s=this.x(t.policy),a=this.x(t.application),o=this.x(t.user),h=this.x(t.workspace),m=t.folders.reduce((v,A)=>(v.set(b.URI.revive(A[0]),this.x(A[1])),v),new k.ResourceMap);return new g(n,s,a,o,new d,h,m,new d,new k.ResourceMap)}static x(t){return new d(t.contents,t.keys,t.overrides)}}e.Configuration=g;function f(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const a of r)a.keys.forEach(o=>t.add(o)),a.overrides.forEach(([o,h])=>{const m=(0,k.getOrSet)(n,o,new Set);h.forEach(v=>m.add(v))});const s=[];return n.forEach((a,o)=>s.push([o,[...a.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=f;class S{constructor(t,n,s,a){this.change=t,this.f=n,this.g=s,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const o of t.keys)this.affectedKeys.add(o);for(const[,o]of t.overrides)for(const h of o)this.affectedKeys.add(h);this.d=this.a;for(const o of this.affectedKeys)this.d+=o+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,a=this.d.indexOf(s);if(a<0)return!1;const o=a+s.length;if(o>=this.d.length)return!1;const h=this.d.charCodeAt(o);if(h!==this.b&&h!==this.c)return!1;if(n){const m=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,v=this.g.getValue(t,n,this.h);return!P.equals(m,v)}return!0}}e.ConfigurationChangeEvent=S;function R(r,t){const{added:n,removed:s,updated:a}=i(t?.rawConfiguration,r?.rawConfiguration),o=[],h=r?.getAllOverrideIdentifiers()||[],m=t?.getAllOverrideIdentifiers()||[];if(t){const v=m.filter(A=>!h.includes(A));for(const A of v)o.push([A,t.getKeysForOverrideIdentifier(A)])}if(r){const v=h.filter(A=>!m.includes(A));for(const A of v)o.push([A,r.getKeysForOverrideIdentifier(A)])}if(t&&r){for(const v of h)if(m.includes(v)){const A=i({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:t.getOverrideValue(void 0,v)||{},keys:t.getKeysForOverrideIdentifier(v)});o.push([v,[...A.added,...A.removed,...A.updated]])}}return{added:n,removed:s,updated:a,overrides:o}}function i(r,t){const n=r?t?r.keys.filter(o=>t.keys.indexOf(o)===-1):[...r.keys]:[],s=t?r?t.keys.filter(o=>r.keys.indexOf(o)===-1):[...t.keys]:[],a=[];if(r&&t){for(const o of t.keys)if(r.keys.indexOf(o)!==-1){const h=(0,I.getConfigurationValue)(t.contents,o),m=(0,I.getConfigurationValue)(r.contents,o);P.equals(h,m)||a.push(o)}}return{added:n,removed:s,updated:a}}}),define(re[219],oe([0,1,21,3,2,32,12,72,45,8,57,40]),function(_,e,L,O,l,D,k,P,C,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class y extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:u})=>this.c(Array.from(c),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,u){this.h(c,w.Registry.as(C.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new P.ConfigurationModel;const c=w.Registry.as(C.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,u){const g=this.f();for(const f of c){const S=g[f],R=u[f];S!==void 0?this.b.addValue(f,S):R?this.b.addValue(f,R.default):this.b.removeValue(f)}}}e.DefaultConfiguration=y;class p{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=p;let d=class extends l.Disposable{get configurationModel(){return this.b}constructor(c,u,g){super(),this.c=c,this.f=u,this.g=g,this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(c=>this.i(c))),this.B(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const u={},g=[],f=w.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(const S of c){const R=f[S];if(!R){g.push(S);continue}if(R.policy){if(R.type!=="string"&&R.type!=="number"){this.g.warn(`Policy ${R.policy.name} has unsupported type ${R.type}`);continue}g.push(S),u[R.policy.name]={type:R.type}}}return(0,k.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),g}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const u=w.Registry.as(C.Extensions.Configuration).getPolicyConfigurations(),g=(0,L.coalesce)(c.map(f=>u.get(f)));this.j(g,!0)}j(c,u){this.g.trace("PolicyConfiguration#update",c);const g=w.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),f=[],S=this.b.isEmpty();for(const R of c){const i=g[R]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(S?r!==void 0:!(0,D.equals)(this.b.getValue(R),r))&&f.push([R,r])}else this.b.getValue(R)!==void 0&&f.push([R,void 0])}if(f.length){this.g.trace("PolicyConfiguration#changed",f);const R=this.b;this.b=new P.ConfigurationModel;for(const i of R.keys)this.b.setValue(i,R.getValue(i));for(const[i,r]of f)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);u&&this.a.fire(this.b)}}};d=ye([X(1,I.IPolicyService),X(2,b.ILogService)],d),e.PolicyConfiguration=d}),define(re[220],oe([0,1,6,3,2,23,17,72,219,57]),function(_,e,L,O,l,D,k,P,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends l.Disposable{constructor(y,p,d,E){super(),this.i=y,this.h=this.B(new O.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new C.DefaultConfiguration),this.c=d instanceof b.NullPolicyService?new C.NullPolicyConfiguration:this.B(new C.PolicyConfiguration(this.b,d,E)),this.f=this.B(new P.UserSettings(this.i,void 0,D.extUriBiasedIgnorePathCase,p)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:u})=>this.k(c,u))),this.B(this.c.onDidChangeConfiguration(c=>this.l(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,p,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(y,p,new P.ConfigurationModel,d)}getConfigurationData(){return this.a.toData()}getValue(y,p){const d=typeof y=="string"?y:void 0,E=(0,k.isConfigurationOverrides)(y)?y:(0,k.isConfigurationOverrides)(p)?p:{};return this.a.getValue(d,E,void 0)}updateValue(y,p,d,E){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.j(y)}j(y){const p=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(y);this.m(d,p,2)}k(y,p){const d=this.a.toData(),E=this.a.compareAndUpdateDefaultConfiguration(y,p);this.m(E,d,7)}l(y){const p=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(y);this.m(d,p,7)}m(y,p,d){const E=new P.ConfigurationChangeEvent(y,{data:p},this.a);E.source=d,E.sourceConfig=this.n(d),this.h.fire(E)}n(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(re[221],oe([0,1,9,5]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,O.createDecorator)("remoteAuthorityResolverService");var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends L.ErrorNoTelemetry{static isNotAvailable(C){return C instanceof D&&C._code===l.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof D&&C._code===l.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof D&&C._code===l.NoResolverFound}static isHandled(C){return C instanceof D&&C.isHandled}constructor(C,b=l.Unknown,I){super(C),this._message=C,this._code=b,this._detail=I,this.isHandled=b===l.NotAvailable&&I===!0,Object.setPrototypeOf(this,D.prototype)}}e.RemoteAuthorityResolverError=D;function k(P){const C=P.indexOf("+");return C===-1?P:P.substring(0,C)}e.getRemoteAuthorityPrefix=k}),define(re[73],oe([0,1,22]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(b){return b.scheme===L.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=O;function l(b){if(!b)return;const I=b.indexOf("+");return I<0?b:b.substr(0,I)}e.getRemoteName=l;function D(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.getRemoteServerRootPath=D;function k(b){const{host:I,port:w}=C(b);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:w}}e.parseAuthorityWithPort=k;function P(b,I){let{host:w,port:y}=C(b);return typeof y>"u"&&(y=I),{host:w,port:y}}e.parseAuthorityWithOptionalPort=P;function C(b){const I=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const w=b.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const y=b.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:b,port:void 0}}}),define(re[46],oe([0,1,27,5,73]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));var P;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(c){this.value=c,this.c=c.toLowerCase()}static equals(c,u){if(typeof c>"u"||c===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof c=="string"||typeof u=="string"){const g=typeof c=="string"?c:c.value,f=typeof u=="string"?u:u.value;return L.equalsIgnoreCase(g,f)}return c.c===u.c}static toKey(c){return typeof c=="string"?c.toLowerCase():c.c}}e.ExtensionIdentifier=C;class b{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const u of c)this.add(u)}add(c){this.c.add(C.toKey(c))}delete(c){return this.c.delete(C.toKey(c))}has(c){return this.c.has(C.toKey(c))}}e.ExtensionIdentifierSet=b;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(C.toKey(c))}get(c){return this.c.get(C.toKey(c))}has(c){return this.c.has(C.toKey(c))}set(c,u){this.c.set(C.toKey(c),u)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=I;function w(E){return y(E)}e.isApplicationScopedExtension=w;function y(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function p(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=p;function d(E,c){if(c){const u=`onResolveRemoteAuthority:${(0,l.getRemoteName)(c)}`;return!!E.activationEvents?.includes(u)}return!1}e.isResolverExtension=d,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[222],oe([0,1,2,13,28,46]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends L.Disposable{constructor(C,b){super(),this.b=C,this.a=(0,O.join)(this.b.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this.B(b.onDidInstallExtensions(I=>this.c(I))),this.B(b.onDidUninstallExtension(I=>this.f(I)))}c(C){C.some(b=>!!b.local)&&this.invalidate()}f(C){C.error||this.invalidate()}invalidate(){l.Promises.rm(this.a,l.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(re[223],oe([0,1,6,16,25,9,3,2,104,88,31,95,221,73]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const d=30*1e3;var E;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function c(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(U){const $=new l.CancellationTokenSource;return setTimeout(()=>$.cancel(),U),$.token}function g(U,$){if(U.isCancellationRequested||$.isCancellationRequested)return l.CancellationToken.Cancelled;const G=new l.CancellationTokenSource;return U.onCancellationRequested(()=>G.cancel()),$.onCancellationRequested(()=>G.cancel()),G.token}class f{get didTimeout(){return this.c==="timedout"}constructor($){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((G,ee)=>{this.f=G,this.g=ee}),$.isCancellationRequested?this.h():this.d.add($.onCancellationRequested(()=>this.h()))}registerDisposable($){this.c==="pending"?this.d.add($):$.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const $=new Error("Time limit reached");return $.code="ETIMEDOUT",$.syscall="connect",$}resolve($){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f($))}reject($){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g($))}}function S(U,$){const G=new f($);return G.registerDisposable(U.onControlMessage(ee=>{const K=JSON.parse(ee.toString()),Q=Z(K);Q?G.reject(Q):G.resolve(K)})),G.promise}function R(U,$,G,ee,K,Q,ie,le,he){const pe=new f(he),me=b.StopWatch.create(!1);return U.info(`Creating a socket (${le})...`),C.mark(`code/willCreateSocket/${ie}`),$.connect(G,ee,K,Q,le,(be,Ce)=>{pe.didTimeout?(C.mark(`code/didCreateSocketError/${ie}`),U.info(`Creating a socket (${le}) finished after ${me.elapsed()} ms, but this is too late and has timed out already.`),be&&U.error(be),Ce?.dispose()):be||!Ce?(C.mark(`code/didCreateSocketError/${ie}`),U.info(`Creating a socket (${le}) returned an error after ${me.elapsed()} ms.`),pe.reject(be)):(C.mark(`code/didCreateSocketOK/${ie}`),U.info(`Creating a socket (${le}) was successful after ${me.elapsed()} ms.`),pe.resolve(Ce))}),pe.promise}function i(U,$){const G=new f($);return U.then(ee=>{G.didTimeout||G.resolve(ee)},ee=>{G.didTimeout||G.reject(ee)}),G.promise}async function r(U,$,G,ee){const K=V(U,$);U.logService.trace(`${K} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await R(U.logService,U.socketFactory,U.host,U.port,(0,p.getRemoteServerRootPath)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,c($),`renderer-${c($)}-${U.reconnectionToken}`,ee)}catch(me){throw U.logService.error(`${K} socketFactory.connect() failed or timed out. Error:`),U.logService.error(me),me}U.logService.trace(`${K} 2/6. socketFactory.connect() was successful.`);let ie,le;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(Q,null),ie=U.reconnectionProtocol,le=!1):(ie=new w.PersistentProtocol({socket:Q,measureRoundTripTime:!0}),le=!0),U.logService.trace(`${K} 3/6. sending AuthRequest control message.`);const he=await i(U.signService.createNewMessage((0,I.generateUuid)()),ee),pe={type:"auth",auth:U.connectionToken||"00000000000000000000",data:he.data};ie.sendControl(O.VSBuffer.fromString(JSON.stringify(pe)));try{const me=await S(ie,g(ee,u(1e4)));if(me.type!=="sign"||typeof me.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(U.logService.trace(`${K} 4/6. received SignRequest control message.`),!await i(U.signService.validate(he,me.signedData),ee)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Ce=await i(U.signService.sign(me.data),ee),De={type:"connectionType",commit:U.commit,signedData:Ce,desiredConnectionType:$};return G&&(De.args=G),U.logService.trace(`${K} 5/6. sending ConnectionTypeRequest control message.`),ie.sendControl(O.VSBuffer.fromString(JSON.stringify(De))),{protocol:ie,ownsProtocol:le}}catch(me){throw me&&me.code==="ETIMEDOUT"&&(U.logService.error(`${K} the handshake timed out. Error:`),U.logService.error(me)),me&&me.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${K} received error control message when negotiating connection. Error:`),U.logService.error(me)),le&&F(ie),me}}async function t(U,$,G,ee){const K=Date.now(),Q=V(U,$),{protocol:ie,ownsProtocol:le}=await r(U,$,G,ee),he=new f(ee);return he.registerDisposable(ie.onControlMessage(pe=>{const me=JSON.parse(pe.toString()),be=Z(me);be?(U.logService.error(`${Q} received error control message when negotiating connection. Error:`),U.logService.error(be),le&&F(ie),he.reject(be)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${B(K)}!`),he.resolve({protocol:ie,firstMessage:me}))})),he.promise}async function n(U,$){const{protocol:G}=await t(U,1,void 0,$);return{protocol:G}}async function s(U,$,G){const{protocol:ee,firstMessage:K}=await t(U,2,$,G),Q=K&&K.debugPort;return{protocol:ee,debugPort:Q}}async function a(U,$,G){const ee=Date.now(),K=V(U,3),{protocol:Q}=await r(U,3,$,G);return U.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${B(ee)}!`),Q}async function o(U,$,G){const{host:ee,port:K,connectionToken:Q}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,host:ee,port:K,connectionToken:Q,reconnectionToken:$,reconnectionProtocol:G,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function h(U,$,G){return v(U,async ee=>{const{protocol:K}=await n(ee,l.CancellationToken.None);return new x(U,$,G,ee.reconnectionToken,K)})}e.connectRemoteAgentManagement=h;async function m(U,$){return v(U,async G=>{const{protocol:ee,debugPort:K}=await s(G,$,l.CancellationToken.None);return new Y(U,$,G.reconnectionToken,ee,K)})}e.connectRemoteAgentExtensionHost=m;async function v(U,$){for(let ee=1;;ee++)try{const K=(0,I.generateUuid)(),Q=await o(U,K,null);return await $(Q)}catch(K){if(ee<5)U.logService.error(`[remote-connection][attempt ${ee}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(K);else throw U.logService.error(`[remote-connection][attempt ${ee}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(K),q.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(K)),K}}async function A(U,$,G){const ee=await o(U,(0,I.generateUuid)(),null);return await a(ee,{host:$,port:G},l.CancellationToken.None)}e.connectRemoteAgentTunnel=A;function T(U){return(0,L.createCancelablePromise)($=>new Promise((G,ee)=>{const K=setTimeout(G,U*1e3);$.onCancellationRequested(()=>{clearTimeout(K),G()})}))}var M;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain",U[U.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(M=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class z{constructor($,G){this.reconnectionToken=$,this.millisSinceLastIncomingData=G,this.type=0}}e.ConnectionLostEvent=z;class H{constructor($,G,ee,K){this.reconnectionToken=$,this.millisSinceLastIncomingData=G,this.durationSeconds=ee,this.c=K,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=H;class J{constructor($,G,ee){this.reconnectionToken=$,this.millisSinceLastIncomingData=G,this.attempt=ee,this.type=2}}e.ReconnectionRunningEvent=J;class W{constructor($,G,ee){this.reconnectionToken=$,this.millisSinceLastIncomingData=G,this.attempt=ee,this.type=4}}e.ConnectionGainEvent=W;class N{constructor($,G){this.reconnectionToken=$,this.connectionHealth=G,this.type=5}}e.ConnectionHealthChangedEvent=N;class j{constructor($,G,ee,K){this.reconnectionToken=$,this.millisSinceLastIncomingData=G,this.attempt=ee,this.handled=K,this.type=3}}e.ReconnectionPermanentFailureEvent=j;class q extends P.Disposable{static triggerPermanentFailure($,G,ee){this._permanentFailure=!0,this.f=$,this.g=G,this.h=ee,this.i.forEach(K=>K.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach($=>$.s())}static debugPauseSocketWriting(){this.i.forEach($=>$.w())}get k(){return this.c||q._permanentFailure}constructor($,G,ee,K,Q){super(),this.n=$,this.p=G,this.reconnectionToken=ee,this.protocol=K,this.r=Q,this.j=this.B(new k.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new W(this.reconnectionToken,0,0)),this.B(K.onSocketClose(ie=>{const le=ae(this.n,this.reconnectionToken,!0);ie?ie.type===0?(this.p.logService.info(`${le} received socket close event (hadError: ${ie.hadError}).`),ie.error&&this.p.logService.error(ie.error)):(this.p.logService.info(`${le} received socket close event (wasClean: ${ie.wasClean}, code: ${ie.code}, reason: ${ie.reason}).`),ie.event&&this.p.logService.error(ie.event)):this.p.logService.info(`${le} received socket close event.`),this.s()})),this.B(K.onSocketTimeout(ie=>{const le=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${ie.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ie.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ie.timeSinceLastReceivedSomeData}).`),this.s()})),this.B(K.onHighRoundTripTime(ie=>{const le=se(this.n,this.reconnectionToken);this.p.logService.info(`${le} high roundtrip time: ${ie.roundTripTime}ms (${ie.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(K.onDidChangeConnectionHealth(ie=>{this.j.fire(new N(this.reconnectionToken,ie))})),q.i.push(this),this.B((0,P.toDisposable)(()=>{const ie=q.i.indexOf(this);ie>=0&&q.i.splice(ie,1)})),this.k&&this.v(q.f,q.g,q.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const $=ae(this.n,this.reconnectionToken,!0);this.p.logService.info(`${$} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const G=[0,5,5,10,10,10,10,10,30];let ee=-1;do{ee++;const K=ee<G.length?G[ee]:G[G.length-1];try{if(K>0){const ie=T(K);this.j.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,ie)),this.p.logService.info(`${$} waiting for ${K} seconds before reconnecting...`);try{await ie}catch{}}if(this.k){this.p.logService.error(`${$} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1)),this.p.logService.info(`${$} resolving connection...`);const Q=await o(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${$} connecting to ${Q.host}:${Q.port}...`),await this.y(Q,u(d)),this.p.logService.info(`${$} reconnected!`),this.j.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${$} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(Q),this.u(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(ee>360){this.p.logService.error(`${$} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(Q),this.u(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Q)){this.p.logService.info(`${$} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this.p.logService.info(`${$} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Q);continue}if((0,D.isCancellationError)(Q)){this.p.logService.info(`${$} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Q);continue}if(Q instanceof y.RemoteAuthorityResolverError){this.p.logService.error(`${$} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(Q),this.u(this.protocol.getMillisSinceLastIncomingData(),ee+1,y.RemoteAuthorityResolverError.isHandled(Q));break}this.p.logService.error(`${$} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(Q),this.u(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}}while(!this.k&&!this.m)}u($,G,ee){this.r?q.triggerPermanentFailure($,G,ee):this.v($,G,ee)}v($,G,ee){this.j.fire(new j(this.reconnectionToken,$,G,ee)),F(this.protocol)}w(){this.protocol.pauseSocketWriting()}}q._permanentFailure=!1,q.f=0,q.g=0,q.h=!1,q.i=[],e.PersistentConnection=q;class x extends q{constructor($,G,ee,K,Q){super(1,$,K,Q,!0),this.client=this.B(new w.Client(Q,{remoteAuthority:G,clientId:ee},$.ipcLogger))}async y($,G){await n($,G)}}e.ManagementPersistentConnection=x;class Y extends q{constructor($,G,ee,K,Q){super(2,$,ee,K,!1),this.z=G,this.debugPort=Q}async y($,G){await s($,this.z,G)}}e.ExtensionHostPersistentConnection=Y;function F(U){try{U.acceptDisconnect();const $=U.getSocket();U.dispose(),$.dispose()}catch($){(0,D.onUnexpectedError)($)}}function Z(U){if(U&&U.type==="error"){const $=new Error(`Connection error: ${U.reason}`);return $.code="VSCODE_CONNECTION_ERROR",$}return null}function te(U,$){for(;U.length<$;)U+=" ";return U}function se(U,$){return`[remote-connection][${te(c(U),13)}][${$.substr(0,5)}\u2026]`}function ae(U,$,G){return`${se(U,$)}[${G?"reconnect":"initial"}]`}function V(U,$){return`${ae($,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function B(U){return`${Date.now()-U} ms`}}),define(re[224],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[225],oe([0,1,85,153]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(l,D,k,P,C,b){const I=y=>b(y,void 0),w=L.createConnection({host:l,port:D},()=>{w.removeListener("error",I);const y=Buffer.alloc(16);for(let c=0;c<16;c++)y[c]=Math.round(Math.random()*256);const p=y.toString("base64"),d=[`GET ws://${/:/.test(l)?`[${l}]`:l}:${D}${k}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`];w.write(d.join(`\r
`)+`\r
\r
`);const E=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",E),b(void 0,new O.NodeSocket(w,C)))};w.on("data",E)});w.setNoDelay(!0),w.once("error",I)}}}),define(re[109],oe([0,1,5,171]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,L.createDecorator)("IRemoteTunnelService");var l;(function(D){D.disconnected={type:"disconnected"},D.uninitialized={type:"uninitialized"},D.connected=k=>({type:"connected",info:k}),D.connecting=k=>({type:"connecting",progress:k})})(l=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,O.localize)(0,null)}),define(re[58],oe([0,1,16,9,2,173,45,5,8,40]),function(_,e,L,O,l,D,k,P,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,P.createDecorator)("requestService");class I extends l.Disposable{constructor(S,R){super(),this.b=0,this.a=R.createLogger("request",{name:S?(0,D.localize)(0,null):(0,D.localize)(1,null),when:C.CONTEXT_LOG_LEVEL.isEqualTo((0,C.LogLevelToString)(C.LogLevel.Trace)).serialize()})}async c(S,R,i){const r=`${S} #${++this.b}: ${R.url}`;this.a.trace(`${r} - begin`,R.type,R.headers);try{const t=await i();return this.a.trace(`${r} - end`,R.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,R.type,(0,O.getErrorMessage)(t)),t}}}e.AbstractRequestService=I;function w(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=w;function y(f){return f.res.statusCode===204}async function p(f){return y(f)?null:(await(0,L.streamToBuffer)(f.stream)).toString()}e.asText=p;async function d(f){if(!w(f))throw new Error("Server returned "+f.res.statusCode);return p(f)}e.asTextOrError=d;async function E(f){if(!w(f))throw new Error("Server returned "+f.res.statusCode);if(y(f))return null;const R=(await(0,L.streamToBuffer)(f.stream)).toString();try{return JSON.parse(R)}catch(i){throw i.message+=`:
`+R,i}}e.asJson=E;function c(f){g(f)}e.updateProxyConfigurationsScope=c;let u;function g(f){const S=b.Registry.as(k.Extensions.Configuration),R=u;u={id:"http",order:15,title:(0,D.localize)(2,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(6,null),(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null)],default:"override",description:(0,D.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11,null),restricted:!0}}},S.updateConfigurations({add:[u],remove:R?[R]:[]})}g(2)}),define(re[226],oe([0,1,25,22,14,58]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(C,b){this.a=C,this.b=b}async download(C,b,I=L.CancellationToken.None){if(C.scheme===O.Schemas.file||C.scheme===O.Schemas.vscodeRemote){await this.b.copy(C,b);return}const w={type:"GET",url:C.toString(!0)},y=await this.a.request(w,I);if(y.res.statusCode===200)await this.b.writeFile(b,y.stream);else{const p=await(0,D.asTextOrError)(y);throw new Error(`Expected 200, got back ${y.res.statusCode} instead.

${p}`)}}};k=ye([X(0,D.IRequestService),X(1,l.IFileService)],k),e.DownloadService=k}),define(re[227],oe([0,1,16,25]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class l{constructor(P){this.a=P}listen(P,C){throw new Error("Invalid listen")}call(P,C,b,I=O.CancellationToken.None){switch(C){case"request":return this.a.request(b[0],I).then(async({res:w,stream:y})=>{const p=await(0,L.streamToBuffer)(y);return[{statusCode:w.statusCode,headers:w.headers},p]});case"resolveProxy":return this.a.resolveProxy(b[0])}throw new Error("Invalid call")}}e.RequestChannel=l;class D{constructor(P){this.a=P}async request(P,C){const[b,I]=await this.a.call("request",[P],C);return{res:b,stream:(0,L.bufferToStream)(I)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=D}),define(re[110],oe([0,1,64,5]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISharedProcessWorkerService=e.hash=void 0;function l(D){return(0,L.hash)({moduleId:D.process.moduleId,windowId:D.reply.windowId})}e.hash=l,e.ISharedProcessWorkerService=(0,O.createDecorator)("sharedProcessWorkerService")}),define(re[228],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var L;(function(O){O.Spawn="vscode:shared-process->shared-process-worker=spawn",O.Terminate="vscode:shared-process->shared-process-worker=terminate",O.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",O.Ready="vscode:shared-process-worker->shared-process=ready",O.Ack="vscode:shared-process-worker->shared-process=ack",O.Trace="vscode:shared-process-worker->shared-process=trace",O.Info="vscode:shared-process-worker->shared-process=info",O.Warn="vscode:shared-process-worker->shared-process=warn",O.Error="vscode:shared-process-worker->shared-process=error"})(L=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[229],oe([0,1,151,6,25,3,2,22,31,8,110,228]),function(_,e,L,O,l,D,k,P,C,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let y=class{constructor(E){this.d=E,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(E){const c=`window: ${E.reply.windowId}, moduleId: ${E.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${c})`);const u=(0,I.hash)(E);this.b.has(u)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${c})`),this.f(E));const g=new l.CancellationTokenSource;let f,S,R;this.b.set(u,n=>{g.dispose(!0),f?.terminate(E,l.CancellationToken.None),S?.close(),R?.close(),this.b.delete(u);const s=this.c.get(u);s&&(this.c.delete(u),s({reason:n}))}),f=await this.e(E);const i=new Promise(n=>{this.c.set(u,n)});if(g.token.isCancellationRequested)return i;const{port1:r,port2:t}=new MessageChannel;return S=r,R=t,await f.spawn(E,R,g.token),g.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${c})`),L.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",E,[S])),i}e(E){let c=this.a.get(E.process.moduleId);if(!c){this.d.trace(`SharedProcess: creating new web worker (${E.process.moduleId})`);const u=new p(E.process.type,this.d);c=u.init(),u.onDidProcessSelfTerminate(({configuration:g,reason:f})=>{this.f(g,f)}),this.a.set(E.process.moduleId,c)}return c}async disposeWorker(E){return this.f(E)}f(E,c){const u=this.b.get((0,I.hash)(E));u&&(this.d.trace(`SharedProcess: disposeWorker (window: ${E.reply.windowId}, moduleId: ${E.process.moduleId})`),u(c))}};y=ye([X(0,b.ILogService)],y),e.SharedProcessWorkerService=y;class p extends k.Disposable{constructor(E,c){super(),this.f=E,this.g=c,this.a=this.B(new D.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const E=new O.DeferredPromise,c=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return c.onerror=u=>{this.g.error(`SharedProcess: worker error (${this.f})`,u.message)},c.onmessageerror=u=>{this.g.error(`SharedProcess: worker message error (${this.f})`,u)},c.onmessage=u=>{const{id:g,message:f,configuration:S,nonce:R}=u.data;switch(g){case w.SharedProcessWorkerMessages.Ready:E.complete(c);break;case w.SharedProcessWorkerMessages.Ack:if(R){const i=this.c.get(R);i&&(this.c.delete(R),i())}break;case w.SharedProcessWorkerMessages.SelfTerminated:S&&f&&this.a.fire({configuration:S,reason:JSON.parse(f)});break;case w.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,f);break;case w.SharedProcessWorkerMessages.Info:f&&this.g.info(f);break;case w.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,f);break;case w.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,f);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,u)}},c.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),E.p}async i(E,c,u){const g=await this.b;if(!c.isCancellationRequested)return new Promise(f=>{const S=(0,C.generateUuid)();this.c.set(S,f);const R={...E,nonce:S};u?g.postMessage(R,[u]):g.postMessage(R),c.onCancellationRequested(()=>{this.c.delete(S)&&f()})})}spawn(E,c,u){const g={id:w.SharedProcessWorkerMessages.Spawn,configuration:E,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(g,u,c)}terminate(E,c){const u={id:w.SharedProcessWorkerMessages.Terminate,configuration:E};return this.i(u,c)}}}),define(re[230],oe([0,1,61,22,96]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class D extends l.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:O.Schemas.vscodeUserData})}}ye([L.memoize],D.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=D}),define(re[231],oe([0,1,50,13,174,25,38,9,4,31,148,192,6,131]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let d;async function E(u,g,f,S){return f["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(S)&&!f["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(S)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=y.Promises.withAsyncBody(async(R,i)=>{const r=new D.CancellationTokenSource;let t=1e4;const n=u.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,p.clamp)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,l.localize)(0,null)))},t);try{R(await c(g,r.token))}catch(a){!(0,P.isCancellationError)(a)&&!r.token.isCancellationRequested?i(new Error((0,l.localize)(1,null,(0,k.toErrorMessage)(a)))):R({})}finally{clearTimeout(s),r.dispose()}})),d)}e.getResolvedShellEnv=E;async function c(u,g){const f=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",f);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",S);const R=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(R+"({.*})"+R),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",r);const t=await(0,I.getSystemShell)(C.OS,r);return u.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(g.isCancellationRequested)return s(new P.CancellationError);const a=(0,O.basename)(t);let o,h;const m=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(o=`& '${process.execPath}' ${m} -p '''${R}'' + JSON.stringify(process.env) + ''${R}'''`,h=["-Login","-Command"]):(o=`'${process.execPath}' ${m} -p '"${R}" + JSON.stringify(process.env) + "${R}"'`,a==="tcsh"||a==="csh"?h=["-ic"]:h=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),o);const v=(0,L.spawn)(t,[...h,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});g.onCancellationRequested(()=>(v.kill(),s(new P.CancellationError))),v.on("error",M=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(M)),s(M)});const A=[];v.stdout.on("data",M=>A.push(M));const T=[];v.stderr.on("data",M=>T.push(M)),v.on("close",(M,z)=>{const H=Buffer.concat(A).toString("utf8");u.trace("getUnixShellEnvironment#raw",H);const J=Buffer.concat(T).toString("utf8");if(J.trim()&&u.trace("getUnixShellEnvironment#stderr",J),M||z)return s(new Error((0,l.localize)(2,null,M,z)));const W=i.exec(H),N=W?W[1]:"{}";try{const j=JSON.parse(N);f?j.ELECTRON_RUN_AS_NODE=f:delete j.ELECTRON_RUN_AS_NODE,S?j.ELECTRON_NO_ATTACH_CONSOLE=S:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.VSCODE_RESOLVING_ENVIRONMENT,delete j.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",j),n(j)}catch(j){u.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(j)),s(j)}})})}}),define(re[111],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[232],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L{constructor(){this.b=new Map}c(){return new Promise((l,D)=>_(["vsda"],l,D))}async createNewMessage(l){try{const D=await this.c(),k=new D.validator;if(k){const P=String(L.a++);return this.b.set(P,k),{id:P,data:k.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,D){if(!l.id)return!0;const k=this.b.get(l.id);if(!k)return!1;this.b.delete(l.id);try{return k.validate(D)==="ok"}catch{return!1}}async sign(l){try{const D=await this.c(),k=new D.signer;if(k)return k.sign(l)}catch{}return l}}L.a=1,e.SignService=L}),define(re[74],oe([0,1,3,2]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class l extends O.Disposable{constructor(w,y,p){super(),this.a=w,this.b=y,this.c=p}async getItems(){const w={profile:this.b,workspace:this.c},y=await this.a.call("getItems",w);return new Map(y)}updateItems(w){const y={profile:this.b,workspace:this.c};return w.insert&&(y.insert=Array.from(w.insert.entries())),w.delete&&(y.delete=Array.from(w.delete.values())),this.a.call("updateItems",y)}}class D extends l{constructor(w,y){super(w,y,void 0),this.f=this.B(new L.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(w=>this.h(w)))}h(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this.f.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}}class k extends D{constructor(w){super(w,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=k;class P extends D{constructor(w,y){super(w,y)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class C extends l{constructor(w,y){super(w,void 0,y),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=C;class b{constructor(w){this.a=w}isUsed(w){const y={payload:w,profile:void 0,workspace:void 0};return this.a.call("isUsed",y)}}e.StorageClient=b}),define(re[112],oe([0,1,4,36,11,31]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(b){if(L.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,I,w,y,p,d,E,c,u,g){const f=Object.create(null);f["common.machineId"]=E,f.sessionID=(0,D.generateUuid)()+Date.now(),f.commitHash=p,f.version=d,f["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,L.PlatformToString)(L.platform),f["common.nodePlatform"]=O.platform,f["common.nodeArch"]=y,f["common.product"]=g||"desktop",c&&(f["common.msftInternal"]=c);let S=0;const R=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-R,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),L.isLinuxSnap&&(f["common.snap"]="true");const i=k(w);i&&(f["common.platformDetail"]=i);try{const r=await b.readFile(l.URI.file(u));f["common.source"]=r.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=P;function C(b){const I=O.env.USERDNSDOMAIN;if(!I)return!1;const w=I.toLowerCase();return b.some(y=>w===y)}e.verifyMicrosoftInternalDomain=C}),define(re[19],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(O=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[233],oe([0,1,34,6,35,22,13,4,11,145,28,147,98,14,26,19]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const c=new Map;async function u(i,r){const t=`${i}::${r.join(":")}`,n=c.get(t);if(n)return n;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,o=new Map,h=2e4;function m(A,T,M,z){const H=T.substring(A.length+1);return O.Promises.withAsyncBody(async J=>{let W;try{W=await I.Promises.readdir(T,{withFileTypes:!0})}catch{J();return}if(z.count>=h){z.count+=W.length,z.maxReached=!0,J();return}let N=W.length;if(N===0){J();return}let j=W;z.count+W.length>h&&(z.maxReached=!0,N=h-z.count,j=W.slice(0,N)),z.count+=W.length;for(const q of j)if(q.isDirectory()){if(M.includes(q.name)||await m(A,(0,k.join)(T,q.name),M,z),--N===0){J();return}}else{const x=q.name.lastIndexOf(".");if(x>=0){const Y=q.name.substring(x+1);Y&&a.set(Y,(a.get(Y)??0)+1)}for(const Y of s)Y.relativePathPattern?.test(H)!==!1&&Y.filePattern.test(q.name)&&o.set(Y.tag,(o.get(Y.tag)??0)+1);if(--N===0){J();return}}})}const v=O.Promises.withAsyncBody(async A=>{const T={count:0,maxReached:!1};await m(i,i,r,T);const M=await S(i);A({configFiles:g(o),fileTypes:g(a),fileCount:T.count,maxFilesReached:T.maxReached,launchConfigFiles:M})});return c.set(t,v),v}e.collectWorkspaceStats=u;function g(i){return Array.from(i.entries(),([r,t])=>({name:r,count:t})).sort((r,t)=>t.count-r.count)}function f(){const i={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},r=L.cpus();return r&&r.length>0&&(i.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),i}e.getMachineInfo=f;async function S(i){try{const r=new Map,t=(0,k.join)(i,".vscode","launch.json"),n=await I.Promises.readFile(t),s=[],a=(0,l.parse)(n.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,l.getNodeType)(a)==="object"&&a.configurations)for(const o of a.configurations){const h=o.type;h&&(r.has(h)?r.set(h,r.get(h)+1):r.set(h,1))}return g(r)}catch{return[]}}e.collectLaunchConfigs=S;let R=class{constructor(r,t){this.c=r,this.d=t}f(r){const t=[];return t.push(`OS Version:       ${r.os}`),t.push(`CPUs:             ${r.cpus}`),t.push(`Memory (System):  ${r.memory}`),t.push(`VM:               ${r.vmHint}`),t.join(`
`)}g(r){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const n=L.cpus();return n&&n.length>0&&t.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),t.push(`Memory (System):  ${(L.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||t.push(`Load (avg):       ${L.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${r.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(r,t){return Promise.all([(0,w.listProcesses)(r.mainPID),this.k(r)]).then(async n=>{let[s,a]=n,o=this.m(r,s);return t.forEach(h=>{if((0,y.isRemoteDiagnosticError)(h))o+=`
${h.errorMessage}`,a+=`
${h.errorMessage}`;else if(o+=`

Remote: ${h.hostName}`,h.processes&&(o+=`
${this.m(r,h.processes)}`),h.workspaceMetadata){a+=`
|  Remote: ${h.hostName}`;for(const m of Object.keys(h.workspaceMetadata)){const v=h.workspaceMetadata[m];let A=`${v.fileCount} files`;v.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${m}): ${A}`,a+=this.h(v)}}}),{processInfo:o,workspaceInfo:a}})}async getSystemInfo(r,t){const{memory:n,vmHint:s,os:a,cpus:o}=f(),h={os:a,memory:n,cpus:o,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:t};return P.isWindows||(h.load=`${L.loadavg().map(m=>Math.round(m)).join(", ")}`),P.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(r,t){const n=[];return(0,w.listProcesses)(r.mainPID).then(async s=>(n.push(""),n.push(this.g(r)),n.push(""),n.push(this.m(r,s)),r.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(r))),t.forEach(a=>{if((0,y.isRemoteDiagnosticError)(a))n.push(`
${a.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${a.hostName}`),n.push(this.f(a.machineInfo)),a.processes&&n.push(this.m(r,a.processes)),a.workspaceMetadata)for(const o of Object.keys(a.workspaceMetadata)){const h=a.workspaceMetadata[o];let m=`${h.fileCount} files`;h.maxFilesReached&&(m=`more than ${m}`),n.push(`Folder (${o}): ${m}`),n.push(this.h(h))}}),n.push(""),n.push(""),n.join(`
`)))}h(r){const t=[];let s=0;const a=(v,A)=>{const T=` ${v}(${A})`;s+T.length>60?(t.push(o),o="|                 ",s=o.length):s+=T.length,o+=T};let o="|      File types:";const h=10,m=r.fileTypes.length>h?h:r.fileTypes.length;for(let v=0;v<m;v++){const A=r.fileTypes[v];a(A.name,A.count)}if(t.push(o),r.configFiles.length>=0&&(o="|      Conf files:",s=0,r.configFiles.forEach(v=>{a(v.name,v.count)}),t.push(o)),r.launchConfigFiles.length>0){let v="|      Launch Configs:";r.launchConfigFiles.forEach(A=>{v+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),t.push(v)}return t.join(`
`)}j(r){const t=Math.max(...Object.keys(r).map(n=>n.length));return Object.keys(r).map(n=>`${n}:  ${" ".repeat(t-n.length)}  ${r[n]}`).join(`
                  `)}k(r){const t=[],n=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(a=>{const o=C.URI.revive(a);if(o.scheme===D.Schemas.file){const h=o.fsPath;n.push(u(h,["node_modules",".git"]).then(m=>{let v=`${m.fileCount} files`;m.maxFilesReached&&(v=`more than ${v}`),t.push(`|    Folder (${(0,k.basename)(h)}): ${v}`),t.push(this.h(m))}).catch(m=>{t.push(`|      Error: Unable to collect workspace stats for folder ${h} (${m.toString()})`)}))}else t.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(r,t){const n=new Map;r.windows.forEach(a=>n.set(a.pid,a.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.n(r.mainPID,n,s,t,0),s.join(`
`)}n(r,t,n,s,a){const o=a===0;let h;o?h=s.pid===r?`${this.d.applicationName} main`:"remote agent":(h=`${"  ".repeat(a)} ${s.name}`,s.name==="window"&&(h=`${h} (${t.get(s.pid)})`));const m=process.platform==="win32"?s.mem:L.totalmem()*(s.mem/100);n.push(`${s.load.toFixed(0).padStart(5," ")}	${(m/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(s.children)&&s.children.forEach(v=>this.n(r,t,n,v,a+1))}async getWorkspaceFileExtensions(r){const t=new Set;for(const{uri:n}of r.folders){const s=C.URI.revive(n);if(s.scheme!==D.Schemas.file)continue;const a=s.fsPath;try{(await u(a,["node_modules",".git"])).fileTypes.forEach(h=>t.add(h.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(r){for(const{uri:t}of r.folders){const n=C.URI.revive(t);if(n.scheme!==D.Schemas.file)continue;const s=n.fsPath;try{const a=await u(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),a.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),a.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})}),a.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};R=ye([X(0,E.ITelemetryService),X(1,d.IProductService)],R),e.DiagnosticsService=R}),define(re[234],oe([0,1,109,3,19,15,2,8,13,50,26,4,6,105,17,172,34]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const u=[L.CONFIGURATION_KEY_HOST_NAME,L.CONFIGURATION_KEY_PREVENT_SLEEP];let g=class extends k.Disposable{constructor(S,R,i,r,t,n){super(),this.r=S,this.s=R,this.t=i,this.u=n,this.b=new O.Emitter,this.onDidTokenFailed=this.b.event,this.f=new O.Emitter,this.onDidChangeTunnelStatus=this.f.event,this.g=new O.Emitter,this.onDidChangeAccount=this.g.event,this.k=L.TunnelStates.disconnected,this.h=this.B(r.createLogger(L.LOG_ID,{name:L.LOGGER_NAME})),this.n=new y.Delayer(100),this.B(this.h.onDidChangeLogLevel(s=>this.h.info("Log level changed to "+(0,P.LogLevelToString)(s)))),this.B(t.onWillShutdown(()=>{this.j?.cancel(),this.j=void 0,this.dispose()})),this.B(n.onDidChangeConfiguration(s=>{u.some(a=>s.affectsConfiguration(a))&&this.n.trigger(()=>this.w())}))}async getAccount(){return this.i}async updateAccount(S){if(S&&this.i?S.token!==this.i.token||S.providerId!==this.i.providerId:S!==this.i){this.i=S,this.g.fire(S),S?this.h.info(`Account updated: ${S.accountLabel} (${S.providerId})`):this.h.info("Account reset"),this.r.publicLog2("remoteTunnel.enablement",{enabled:!!S});try{await this.n.trigger(()=>this.w())}catch(R){this.h.error(R)}}return this.k}v(){if(!this.p){let S;w.isMacintosh?S=this.t.appRoot:S=(0,C.dirname)((0,C.dirname)(this.t.appRoot)),this.p=(0,C.join)(S,"bin",`${this.s.tunnelApplicationName}${w.isWindows?".exe":""}`)}return this.p}async w(){if(this.j&&(this.j.cancel(),this.j=void 0),!this.i){this.y(L.TunnelStates.disconnected);return}const{token:S,providerId:R,accountLabel:i}=this.i;this.y(L.TunnelStates.connecting((0,E.localize)(0,null,i,R)));const r=(o,h)=>{o=o.replaceAll(S,"*".repeat(4)),h?this.h.error(o):this.h.info(o),!this.t.isBuilt&&o.startsWith("   Compiling")&&this.y(L.TunnelStates.connecting((0,E.localize)(1,null)))},t=this.z("login",["user","login","--provider",R,"--access-token",S,"--log",(0,P.LogLevelToString)(this.h.getLevel())],r);this.j=t;try{if(await t,this.j!==t)return}catch(o){this.h.error(o),this.j=void 0,this.b.fire(!0),this.y(L.TunnelStates.disconnected);return}const n=this.D();n?this.y(L.TunnelStates.connecting((0,E.localize)(2,null,n))):this.y(L.TunnelStates.connecting((0,E.localize)(3,null)));const s=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,P.LogLevelToString)(this.h.getLevel())];n?s.push("--name",n):s.push("--random-name"),this.C()&&s.push("--no-sleep");const a=this.z("tunnel",s,(o,h)=>{h?this.h.error(o):this.h.info(o);const m=o.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(m){const v={link:m[1],domain:m[2],hostName:m[4]};this.y(L.TunnelStates.connected(v))}else o.match(/error refreshing token/)&&(a.cancel(),this.b.fire(!0),this.y(L.TunnelStates.disconnected))});this.j=a,a.finally(()=>{a===this.j&&(this.h.info("tunnel process terminated"),this.j=void 0,this.i=void 0,this.y(L.TunnelStates.disconnected))})}async getTunnelStatus(){return this.k}y(S){this.k=S,this.f.fire(S)}z(S,R,i=()=>{}){return(0,y.createCancelablePromise)(r=>new Promise((t,n)=>{r.isCancellationRequested&&t();let s;if(r.onCancellationRequested(()=>{s&&(this.h.info(`${S} terminating(${s.pid})`),s.kill())}),!this.t.isBuilt)i("Building tunnel CLI from sources and run",!1),i(`${S} Spawning: cargo run -- tunnel ${R.join(" ")}`,!1),s=(0,b.spawn)("cargo",["run","--","tunnel",...R],{cwd:(0,C.join)(this.t.appRoot,"cli")});else{i("Running tunnel CLI",!1);const a=this.v();i(`${S} Spawning: ${a} tunnel ${R.join(" ")}`,!1),s=(0,b.spawn)(a,["tunnel",...R],{cwd:(0,c.homedir)()})}s.stdout.on("data",a=>{if(s){const o=a.toString();i(o,!1)}}),s.stderr.on("data",a=>{if(s){const o=a.toString();i(o,!0)}}),s.on("exit",a=>{s&&(i(`${S} exit(${s.pid}): + ${a} `,!1),s=void 0,a===0?t():n())}),s.on("error",a=>{s&&(i(`${S} error(${s.pid}): + ${a} `,!0),s=void 0,n())})}))}async getHostName(){return this.D()}C(){return!!this.u.getValue(L.CONFIGURATION_KEY_PREVENT_SLEEP)}D(){let S=this.u.getValue(L.CONFIGURATION_KEY_HOST_NAME)||(0,c.hostname)();return S=S.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),S||void 0}};g=ye([X(0,l.ITelemetryService),X(1,I.IProductService),X(2,D.INativeEnvironmentService),X(3,P.ILoggerService),X(4,p.ISharedProcessLifecycleService),X(5,d.IConfigurationService)],g),e.RemoteTunnelService=g}),define(re[113],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(D){this.b=D}listen(D,k){throw new Error(`Event not found: ${k}`)}call(D,k,{eventName:P,data:C}){return this.b.forEach(b=>b.log(P,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class O{constructor(D){this.b=D}log(D,k){return this.b.call("log",{eventName:D,data:k}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=O}),define(re[47],oe([0,1,32,12,3,17,73,112,19]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class b{constructor(o){this.value=o}}e.TelemetryTrustedValue=b;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,h){return Promise.resolve(void 0)}publicLog2(o,h){return this.publicLog(o,h)}publicLogError(o,h){return Promise.resolve(void 0)}publicLogError2(o,h){return this.publicLogError(o,h)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class w{async publicLog(o,h,m){}async publicLogError(o,h,m){}}e.NullEndpointTelemetryService=w,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(a,o){return l.Event.debounce(o.onDidChangeConfiguration,(m,v)=>{const A=m?new Set([...m.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:A}},1e3,!0)(m=>{m.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(m.source),configurationKeys:S(m.affectedKeys)})})}e.configurationTelemetry=y;function p(a,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!a.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=p;function d(a,o){return!(o.isBuilt||o.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=d;function E(a){const o=a.getValue(C.TELEMETRY_SETTING_ID),h=a.getValue(C.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||h===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function c(a){const o={},h={},m={};f(a,m);for(let v in m){v=v.length>150?v.substr(v.length-149):v;const A=m[v];typeof A=="number"?h[v]=A:typeof A=="boolean"?h[v]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${A.length}`),o[v]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(o[v]=A)}return{properties:o,measurements:h}}e.validateTelemetryData=c;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(a){if(!a)return"none";const o=(0,k.getRemoteName)(a);return u.has(o)?o:"other"}e.cleanRemoteAuthority=g;function f(a,o,h=0,m){if(!!a)for(const v of Object.getOwnPropertyNames(a)){const A=a[v],T=m?m+v:v;Array.isArray(A)?o[T]=(0,L.safeStringify)(A):A instanceof Date?o[T]=A.toISOString():(0,O.isObject)(A)?h<2?f(A,o,h+1,T+"."):o[T]=(0,L.safeStringify)(A):o[T]=A}}function S(a){if(!a)return[];const o=[];return R(o,"",a),o}function R(a,o,h){h&&typeof h=="object"&&!Array.isArray(h)?Object.keys(h).forEach(m=>R(a,o?`${o}.${m}`:m,h[m])):a.push(o)}function i(a,o){const h=a.msftInternalDomains||[],m=o.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(h)||m}e.isInternalTelemetry=i;function r(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=r;function t(a,o){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let h=a;const m=[];for(const M of o)for(;;){const z=M.exec(a);if(!z)break;m.push([z.index,M.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let T=0;for(h="";;){const M=A.exec(a);if(!M)break;const z=m.some(([H,J])=>M.index<J&&H<A.lastIndex);!v.test(M[0])&&!z&&(h+=a.substring(T,M.index)+"<REDACTED: user-file-path>",T=A.lastIndex)}return T<a.length&&(h+=a.substr(T)),h}function n(a){if(!a)return a;const o=a.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of h)if(m.regex.test(o))return`<REDACTED: ${m.label}>`;return a}function s(a,o){return(0,L.cloneAndChange)(a,h=>{if(h instanceof b)return h.value;if(typeof h=="string"){let m=h.replaceAll("%20"," ");m=t(m,o);for(const v of o)m=m.replace(v,"");return m=n(m),m}})}e.cleanData=s}),define(re[33],oe([0,1,27,29,46,4,11,9,36,47]),function(_,e,L,O,l,D,k,P,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,L.compareIgnoreCase)(t.id,n.id)===0}e.areSameExtensions=I;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(n){const s=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new y(n.identifier,s,a)}static parse(n){const s=w.exec(n);return s&&s[1]&&s[2]?new y({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof y?I(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=y;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(t){const n=p.exec(t);return n&&n[1]?[c(n[1]),n[2]]:[c(t),void 0]}e.getIdAndVersion=d;function E(t,n){return`${t}.${n}`}e.getExtensionId=E;function c(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function u(t,n){return c(E(t,n))}e.getGalleryExtensionId=u;function g(t,n){const s=[],a=o=>{for(const h of s)if(h.some(m=>I(n(m),n(o))))return h;return null};for(const o of t){const h=a(o);h?h.push(o):s.push([o])}return s}e.groupByExtension=g;function f(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=f;function S(t){return{id:new b.TelemetryTrustedValue(t.identifier.id),name:new b.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function R(t,n){const s=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const o=a.shift();if(o&&s.every(h=>!I(h.identifier,{id:o}))){const h=t.filter(m=>I(m.identifier,{id:o}));h.length===1&&(s.push(h[0]),a.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=R;async function i(t,n){if(!D.isLinux)return!1;let s;try{s=(await t.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){n.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(o))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,n){const s=await i(t,n),a=(0,O.getTargetPlatform)(s?"alpine":D.platform,C.arch);return n.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=r}),define(re[235],oe([0,1,21,2,23,11,194,14,26,6,3,13,4,36,161,33]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let c=class extends O.Disposable{constructor(R,i){super(),this.b=R,this.c=i,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,r])=>this.a.set(r.configPath,r))}getConfigBasedTips(R){return this.f(R)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(R){const i=[];for(const[r,t]of this.a)if(!(t.configScheme&&t.configScheme!==R.scheme))try{const n=await this.b.readFile((0,l.joinPath)(R,r)),s=new Map;Object.entries(t.recommendations).forEach(([o,h])=>{if((0,L.isNonEmptyArray)(h.remotes))for(const m of h.remotes)s.set(m,{extensionId:o,extensionName:h.name,configName:t.configName,important:!!h.important,isExtensionPack:!!h.isExtensionPack,whenNotInstalled:h.whenNotInstalled});else i.push({extensionId:o,extensionName:h.name,configName:t.configName,important:!!h.important,isExtensionPack:!!h.isExtensionPack,whenNotInstalled:h.whenNotInstalled})});const a=(0,k.getDomainsOfRemotes)(n.value.toString(),[...s.keys()]);for(const o of a){const h=s.get(o);h&&i.push(h)}}catch{}return i}};c=ye([X(0,P.IFileService),X(1,C.IProductService)],c),e.ExtensionTipsService=c;const u="extensionTips/promptedExecutableTips",g="extensionTips/lastPromptedMediumImpExeTime";class f extends c{constructor(R,i,r,t,n,s,a,o){super(a,o),this.m=R,this.n=i,this.p=r,this.r=t,this.s=n,this.t=s,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,o.exeBasedExtensionTips&&Object.entries(o.exeBasedExtensionTips).forEach(([h,m])=>{const v=[],A=[],T=[];Object.entries(m.recommendations).forEach(([M,z])=>{z.important?m.important?v.push({extensionId:M,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):A.push({extensionId:M,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):T.push({extensionId:M,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),v.length&&this.g.set(h,{exeFriendlyName:m.friendlyName,windowsPath:m.windowsPath,recommendations:v}),A.length&&this.h.set(h,{exeFriendlyName:m.friendlyName,windowsPath:m.windowsPath,recommendations:A}),T.length&&this.j.set(h,{exeFriendlyName:m.friendlyName,windowsPath:m.windowsPath,recommendations:T})}),(0,b.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.z()})}async getImportantExecutableBasedTips(){const R=await this.J(this.g),i=await this.J(this.h);return[...R,...i]}getOtherExecutableBasedTips(){return this.J(this.j)}async u(){const R=await this.J(this.g),i=await this.J(this.h),r=await this.r.getInstalled();this.k=this.v(R,r),this.l=this.v(i,r)}v(R,i){const r=new Map;R.forEach(o=>r.set(o.extensionId.toLowerCase(),o));const{installed:t,uninstalled:n}=this.I([...r.keys()],i);for(const o of t){const h=r.get(o);h&&this.p.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:o,exeName:h.exeName})}for(const o of n){const h=r.get(o);h&&this.p.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:o,exeName:h.exeName})}const s=this.G(),a=new Map;for(const o of n){const h=r.get(o);if(h&&(!s[h.exeName]||!s[h.exeName].includes(h.extensionId))){let m=a.get(h.exeName);m||(m=[],a.set(h.exeName,m)),m.push(h)}}return a}w(){if(this.k.size===0)return;const[R,i]=[...this.k.entries()][0];this.C(i).then(r=>{switch(r){case"reacted":this.H(i[0].exeName,i);break;case"ignored":this.k.delete(R);break;case"incompatibleWindow":{const t=I.Event.once(I.Event.latch(I.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(t(()=>this.w()));break}case"toomany":{const t=this.B((0,b.disposableTimeout)(()=>{t.dispose(),this.w()},36e5));break}}})}z(){if(this.l.size===0)return;const R=this.D(),i=Date.now()-R,r=7*24*60*60*1e3;if(i<r){const s=this.B((0,b.disposableTimeout)(()=>{s.dispose(),this.z()},r-i));return}const[t,n]=[...this.l.entries()][0];this.C(n).then(s=>{switch(s){case"reacted":{this.F(Date.now()),this.l.delete(t),this.H(n[0].exeName,n);const a=this.B((0,b.disposableTimeout)(()=>{a.dispose(),this.z()},r));break}case"ignored":this.l.delete(t),this.z();break;case"incompatibleWindow":{const a=I.Event.once(I.Event.latch(I.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(a(()=>this.z()));break}case"toomany":{const a=this.B((0,b.disposableTimeout)(()=>{a.dispose(),this.z()},36e5));break}}})}async C(R){const i=await this.r.getInstalled(1),r=R.filter(n=>!n.whenNotInstalled||n.whenNotInstalled.every(s=>i.every(a=>!(0,E.areSameExtensions)(a.identifier,{id:s})))).map(({extensionId:n})=>n.toLowerCase()),t=(0,d.localize)(0,null,R[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(r,t,`@exe:"${R[0].exeName}"`,3)}D(){let R=this.s.getNumber(g,-1);return R||(R=Date.now(),this.F(R)),R}F(R){this.s.store(g,R,-1,1)}G(){return JSON.parse(this.s.get(u,-1,"{}"))}H(R,i){const r=this.G();r[R]=i.map(({extensionId:t})=>t.toLowerCase()),this.s.store(u,JSON.stringify(r),-1,0)}I(R,i){const r=[],t=[],n=i.reduce((s,a)=>(s.add(a.identifier.id.toLowerCase()),s),new Set);return R.forEach(s=>{n.has(s.toLowerCase())?r.push(s):t.push(s)}),{installed:r,uninstalled:t}}async J(R){const i=[],r=new Map;for(const t of R.keys()){const n=R.get(t);if(!n||!(0,L.isNonEmptyArray)(n.recommendations))continue;const s=[];y.isWindows?n.windowsPath&&s.push(n.windowsPath.replace("%USERPROFILE%",()=>p.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>p.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>p.env.ProgramFiles).replace("%APPDATA%",()=>p.env.APPDATA).replace("%WINDIR%",()=>p.env.WINDIR)):(s.push((0,w.join)("/usr/local/bin",t)),s.push((0,w.join)("/usr/bin",t)),s.push((0,w.join)(this.m.fsPath,t)));for(const a of s){let o=r.get(a);if(o===void 0&&(o=await this.b.exists(D.URI.file(a)),r.set(a,o)),o)for(const{extensionId:h,extensionName:m,isExtensionPack:v,whenNotInstalled:A}of n.recommendations)i.push({extensionId:h,extensionName:m,isExtensionPack:v,exeName:t,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:A})}}return i}}e.AbstractNativeExtensionTipsService=f}),define(re[236],oe([0,1,25,33]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function l(D,k,P,C,b){try{const I=await D.getExtensionsControlManifest();if(!I.deprecated)return;const w=await D.getInstalled(1);for(const[y,p]of Object.entries(I.deprecated)){if(!p?.extension)continue;const{id:d,autoMigrate:E,preRelease:c}=p.extension;if(!E)continue;const u=w.find(f=>(0,O.areSameExtensions)(f.identifier,{id:y}));if(!u)continue;const g=(await k.getExtensions([{id:d,preRelease:c}],{targetPlatform:await D.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!g){b.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{b.info(`Migrating '${u.identifier.id}' extension to '${d}' extension...`);const f=!C.getDisabledExtensions().some(R=>(0,O.areSameExtensions)(R,u.identifier));await D.uninstall(u),b.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let S=w.find(R=>(0,O.areSameExtensions)(R.identifier,{id:d}));(!S||!S.isPreReleaseVersion&&f)&&(S=await D.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),b.info(`Installed the pre-release extension '${S.identifier.id}'`),f||(await C.disableExtension(S.identifier),b.info(`Disabled the pre-release extension '${S.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),E.storage&&(P.addToMigrationList((0,O.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,O.getExtensionId)(S.manifest.publisher,S.manifest.name)),b.info("Added pre-release extension to the storage migration list"))),b.info(`Migrated '${u.identifier.id}' extension to '${d}' extension.`)}catch(f){b.error(f)}}}catch(I){b.error(I)}}e.migrateUnsupportedExtensions=l}),define(re[237],oe([0,1,3,2,37,33,46]),function(_,e,L,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends O.Disposable{constructor(b,I,w,y,p,d,E){super(),this.f=b,this.g=I,this.h=w,this.i=y,this.j=p,this.k=d,this.l=E,this.a=this.B(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.DisposableMap),this.m().then(null,c=>E.error(c))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(b=>this.p(b.added,b.removed))),this.B(this.i.onAddExtensions(b=>this.r(b))),this.B(this.i.onDidAddExtensions(b=>this.s(b))),this.B(this.i.onRemoveExtensions(b=>this.t(b))),this.B(this.i.onDidRemoveExtensions(b=>this.u(b))),this.B(this.k.onDidFilesChange(b=>this.v(b)))}async p(b,I){try{await Promise.all(I.map(w=>(this.c.deleteAndDispose(w.id),this.z(w.extensionsResource)))),b.length&&await Promise.all(b.map(w=>(this.c.set(w.id,(0,O.combinedDisposable)(this.k.watch(this.j.extUri.dirname(w.extensionsResource)),this.k.watch(w.extensionsResource))),this.y(w.extensionsResource))))}catch(w){throw this.l.error(w),w}}async r(b){for(const I of b.extensions)this.D(this.G(I.identifier,I.version),b.profileLocation)}async s(b){for(const I of b.extensions){const w=this.G(I.identifier,I.version);b.error?this.F(w,b.profileLocation):this.D(w,b.profileLocation)}}async t(b){for(const I of b.extensions)this.F(this.G(I.identifier,I.version),b.profileLocation)}async u(b){const I=[],w=[];for(const y of b.extensions){const p=this.G(y.identifier,y.version);b.error?this.D(p,b.profileLocation):(this.F(p,b.profileLocation),this.b.has(p)||(this.l.debug("Extension is removed from all profiles",y.identifier.id,y.version),w.push(this.f.scanInstalledExtensionAtLocation(y.location).then(d=>{d?I.push(d):this.l.info("Extension not found at the location",y.location.toString())},d=>this.l.error(d)))))}try{await Promise.all(w),I.length&&await this.C(I)}catch(y){this.l.error(y)}}v(b){for(const I of this.h.profiles)b.contains(I.extensionsResource,0,1)&&this.w(I.extensionsResource)}async w(b){const I=[],w=[],y=await this.i.scanProfileExtensions(b),p=new Set,d=new Set;for(const[E,c]of this.b)c.has(b)&&d.add(E);for(const E of y){const c=this.G(E.identifier,E.version);p.add(c),d.has(c)||(I.push(E.identifier),this.D(c,b))}for(const E of d)if(!p.has(E)){const c=this.H(E);c&&(w.push(c.identifier),this.F(E,b))}(I.length||w.length)&&this.a.fire({added:I.length?{extensions:I,profileLocation:b}:void 0,removed:w.length?{extensions:w,profileLocation:b}:void 0})}async y(b){const I=await this.i.scanProfileExtensions(b);for(const w of I)this.D(this.G(w.identifier,w.version),b)}async z(b){for(const I of[...this.b.keys()])this.F(I,b);await this.C()}async C(b){b||(b=(await this.f.scanAllUserInstalledExtensions()).filter(w=>!this.b.has(this.G(w.identifier,w.manifest.version)))),b.length&&await this.f.markAsUninstalled(...b)}D(b,I){let w=this.b.get(b);w||this.b.set(b,w=new l.ResourceSet(y=>this.j.extUri.getComparisonKey(y))),w.add(I)}F(b,I){const w=this.b.get(b);w&&w.delete(I),w?.size||this.b.delete(b)}G(b,I){return`${k.ExtensionIdentifier.toKey(b.id)}@${I}`}H(b){const[I,w]=(0,D.getIdAndVersion)(b);return w?{identifier:{id:I},version:w}:void 0}}e.ExtensionsWatcher=P}),define(re[238],oe([0,1,44,47]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function l(D,k,P,C,b,I,w){const y={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${k.nameShort})`};if((0,O.supportsTelemetry)(k,P)&&(0,O.getTelemetryLevel)(C)===3){const p=await(0,L.getServiceMachineId)(P,b,I),{machineId:d}=await w.getTelemetryInfo();y["X-Market-User-Id"]=p,y["VSCode-SessionId"]=d||p}return y}e.resolveMarketplaceHeaders=l}),define(re[239],oe([0,1,102,21,6,2,22,13,28,15,29,33,8,71,11]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends p.LanguagePackBaseService{constructor(f,S,R,i){super(R),this.h=f,this.i=i,this.g=this.B(new c(S,i)),this.h.registerParticipant({postInstall:async r=>this.j(r),postUninstall:async r=>this.k(r)})}async getBuiltInExtensionTranslationsUri(f,S){const i=(await this.g.getLanguagePacks())[S];if(!i){this.i.warn(`No language pack found for ${S}`);return}const r=i.translations[f];return r?d.URI.file(r):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),S=Object.keys(f).map(R=>{const i=f[R];return{...this.f(R,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return S.push(this.f("en","English")),S.sort((R,i)=>R.label.localeCompare(i.label)),S}async j(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",f.identifier.id),await this.update())}async k(f){const S=await this.g.getLanguagePacks();Object.keys(S).some(R=>S[R]&&S[R].extensions.some(i=>(0,w.areSameExtensions)(i.extensionIdentifier,f.identifier)))&&(this.i.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,S]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),R=await this.g.update(S);return!(0,O.equals)(Object.keys(f),Object.keys(R))}};E=ye([X(0,I.IExtensionManagementService),X(1,b.INativeEnvironmentService),X(2,I.IExtensionGalleryService),X(3,y.ILogService)],E),e.NativeLanguagePackService=E;let c=class extends D.Disposable{constructor(f,S){super(),this.i=S,this.c={},this.f=(0,P.join)(f.userDataPath,"languagepacks.json"),this.g=new l.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.m(S=>{Object.keys(S).forEach(R=>delete S[R]),this.j(S,...f)}).then(()=>this.c)}j(f,...S){for(const R of S)R&&R.manifest&&R.manifest.contributes&&R.manifest.contributes.localizations&&R.manifest.contributes.localizations.length&&this.k(f,R);Object.keys(f).forEach(R=>this.l(f[R]))}k(f,S){const R=S.identifier,i=S.manifest.contributes&&S.manifest.contributes.localizations?S.manifest.contributes.localizations:[];for(const r of i)if(S.location.scheme===k.Schemas.file&&u(r)){let t=f[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},f[r.languageId]=t);const n=t.extensions.filter(s=>(0,w.areSameExtensions)(s.extensionIdentifier,R))[0];n?n.version=S.manifest.version:t.extensions.push({extensionIdentifier:R,version:S.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,P.join)(S.location.fsPath,s.path)}}l(f){if(f){const S=(0,L.createHash)("md5");for(const R of f.extensions)S.update(R.extensionIdentifier.uuid||R.extensionIdentifier.id).update(R.version);f.hash=S.digest("hex")}}m(f=()=>null){return this.g.queue(()=>{let S=null;return C.Promises.readFile(this.f,"utf8").then(void 0,R=>R.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(R)).then(R=>{try{return JSON.parse(R)}catch{return{}}}).then(R=>(S=f(R),R)).then(R=>{for(const r of Object.keys(R))R[r]||delete R[r];this.c=R,this.h=!0;const i=JSON.stringify(this.c);return this.i.debug("Writing language packs",i),C.Promises.writeFile(this.f,i)}).then(()=>S,R=>this.i.error(R))})}};c=ye([X(0,b.INativeEnvironmentService),X(1,y.ILogService)],c);function u(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const f of g.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(re[240],oe([0,1,9,32,47]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function P(b,I,w){const y=await new Promise((u,g)=>{_(["@microsoft/1ds-core-js"],u,g)}),p=await new Promise((u,g)=>{_(["@microsoft/1ds-post-js"],u,g)}),d=new y.AppInsightsCore,E=new p.PostChannel,c={instrumentationKey:b,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(w){c.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:w};c.extensionConfig[E.identifier]=u}return d.initialize(c,[]),d.addTelemetryInitializer(u=>{I&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),d}class C{constructor(I,w,y,p,d){this.e=I,this.f=w,this.g=y,this.h=d,this.c=D,this.d=k,this.g||(this.g={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}i(I){if(!!this.a){if(typeof this.a!="string"){I(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(w=>{I(w)},w=>{(0,L.onUnexpectedError)(w),console.error(w)})}}log(I,w){if(!this.a)return;w=(0,O.mixin)(w,this.g),w=(0,l.validateTelemetryData)(w);const y=this.f+"/"+I;try{this.i(p=>{p.pluginVersionString=w?.properties.version??"Unknown",p.track({name:y,baseData:{name:y,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(I=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=C}),define(re[114],oe([0,1,2,175,15,8,26,47]),function(_,e,L,O,l,D,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let C=class extends L.Disposable{constructor(I,w,y,p,d=""){super(),this.b=d;const E=w.getLogger(P.telemetryLogId);if(E)this.a=this.B(E);else{const u=(0,P.isLoggingOnly)(p,y)?" (Not Sent)":"",g=()=>(0,P.supportsTelemetry)(p,y)&&I.getLevel()===D.LogLevel.Trace;this.a=this.B(w.createLogger(P.telemetryLogId,{name:(0,O.localize)(0,null,u),hidden:!g()})),this.B(I.onDidChangeLogLevel(()=>w.setVisibility(P.telemetryLogId,g()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(I,w){this.a.trace(`${this.b}telemetry/${I}`,(0,P.validateTelemetryData)(w))}};C=ye([X(0,D.ILogService),X(1,D.ILoggerService),X(2,l.IEnvironmentService),X(3,k.IProductService)],C),e.TelemetryLogAppender=C}),define(re[115],oe([0,1,2,32,4,27,176,17,45,107,26,40,19,47]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(u,g,f){this.k=g,this.l=f,this.d={},this.i=new L.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,D.escapeRegExpCharacters)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.escapeRegExpCharacters)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(y.TELEMETRY_SETTING_ID)||S.affectsConfiguration(y.TELEMETRY_OLD_SETTING_ID)||S.affectsConfiguration(y.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(u,g){this.d[u]=g}m(){let u=(0,p.getTelemetryLevel)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const f=g.usage?3:g.error?2:0;u=Math.min(u,f)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,g=u.sessionID,f=u["common.machineId"],S=u["common.firstSessionDate"],R=u["common.msftInternal"];return{sessionId:g,machineId:f,firstSessionDate:S,msftInternal:R}}dispose(){this.i.dispose()}n(u,g,f){return this.g<g?Promise.resolve(void 0):this.c.then(S=>{f=(0,O.mixin)(f,this.d),f=(0,p.cleanData)(f,this.j),f=(0,O.mixin)(f,S),this.b.forEach(R=>R.log(u,f))},S=>{console.error(S)})}publicLog(u,g){return this.n(u,3,g)}publicLog2(u,g){return this.publicLog(u,g)}publicLogError(u,g){return this.h?this.n(u,2,g):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=ye([X(1,P.IConfigurationService),X(2,I.IProductService)],d),e.TelemetryService=d;function E(){const c=(0,k.localize)(0,null,b.default.nameLong),u=b.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=l.isWeb?"":(0,k.localize)(3,null),f=(0,k.localize)(4,null),S=(0,k.localize)(5,null),R=(0,k.localize)(6,null),i=(0,k.localize)(7,null),r=`
|       | ${f} | ${S} | ${R} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,k.localize)(8,null);return`
${c} ${u} ${g}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}w.Registry.as(C.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.Registry.as(C.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,k.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,k.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[241],oe([0,1,294,240]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class l extends O.AbstractOneDataSystemAppender{constructor(k,P,C,b){const I={sendPOST:(w,y)=>{const p={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const d=L.request(w.urlString,p,E=>{E.on("data",function(c){y(E.statusCode??200,E.headers,c.toString())}),E.on("error",function(c){y(0,{})})});d.write(w.data),d.end()}catch{y(0,{})}}};super(k,P,C,b,I)}}e.OneDataSystemAppender=l}),define(re[242],oe([0,1,22,65,17,15,8,26,19,113,114,115]),function(_,e,L,O,l,D,k,P,C,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let y=class{constructor(d,E,c,u,g,f){this.b=d,this.c=E,this.d=c,this.e=u,this.f=g,this.g=f,this.a=new Map}async h(d){if(!this.a.has(d.id)){const{machineId:E,sessionId:c}=await this.c.getTelemetryInfo(),u=Object.create(null);u["common.vscodemachineid"]=E,u["common.vscodesessionid"]=c;const g=[d.id,JSON.stringify(u),d.aiKey],S=new O.Client(L.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),R=[new b.TelemetryAppenderClient(S),new I.TelemetryLogAppender(this.d,this.e,this.f,this.g,`[${d.id}] `)];this.a.set(d.id,new w.TelemetryService({appenders:R,sendErrorTelemetry:d.sendErrorTelemetry},this.b,this.g))}return this.a.get(d.id)}async publicLog(d,E,c){await(await this.h(d)).publicLog(E,c)}async publicLogError(d,E,c){await(await this.h(d)).publicLogError(E,c)}};y=ye([X(0,l.IConfigurationService),X(1,C.ITelemetryService),X(2,k.ILogService),X(3,k.ILoggerService),X(4,D.IEnvironmentService),X(5,P.IProductService)],y),e.CustomEndpointTelemetryService=y}),define(re[116],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var L;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(re[243],oe([0,1,4,116]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class l{constructor(C){this.collections=C,this.map=new Map,C.forEach((b,I)=>{const w=b.map.entries();let y=w.next();for(;!y.done;){const p=y.value[0];let d=this.map.get(p);if(d||(d=[],this.map.set(p,d)),d.length>0&&d[0].type===O.EnvironmentVariableMutatorType.Replace){y=w.next();continue}const E=y.value[1];d.unshift({extensionIdentifier:I,value:E.value,type:E.type}),y=w.next()}})}async applyToProcessEnvironment(C,b){let I;L.isWindows&&(I={},Object.keys(C).forEach(w=>I[w.toLowerCase()]=w));for(const[w,y]of this.map){const p=L.isWindows&&I[w.toLowerCase()]||w;for(const d of y){const E=b?await b(d.value):d.value;switch(d.type){case O.EnvironmentVariableMutatorType.Append:C[p]=(C[p]||"")+E;break;case O.EnvironmentVariableMutatorType.Prepend:C[p]=E+(C[p]||"");break;case O.EnvironmentVariableMutatorType.Replace:C[p]=E;break}}}}diff(C){const b=new Map,I=new Map,w=new Map;if(C.map.forEach((y,p)=>{const d=this.map.get(p),E=D(y,d);E&&b.set(p,E)}),this.map.forEach((y,p)=>{const d=C.map.get(p),E=D(y,d);E&&w.set(p,E)}),this.map.forEach((y,p)=>{const d=C.map.get(p),E=k(y,d);E&&I.set(p,E)}),!(b.size===0&&I.size===0&&w.size===0))return{added:b,changed:I,removed:w}}}e.MergedEnvironmentVariableCollection=l;function D(P,C){if(!C)return P;const b=new Set;C.forEach(w=>b.add(w.extensionIdentifier));const I=[];return P.forEach(w=>{b.has(w.extensionIdentifier)||I.push(w)}),I.length===0?void 0:I}function k(P,C){if(!C)return;const b=new Map;C.forEach(w=>b.set(w.extensionIdentifier,w));const I=[];return P.forEach(w=>{const y=b.get(w.extensionIdentifier);y&&(w.type!==y.type||w.value!==y.value)&&I.push(y)}),I.length===0?void 0:I}}),define(re[244],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function L(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=L;function O(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=O;function l(k){return Array.from(k.entries()).map(P=>[P[0],L(P[1].map)])}e.serializeEnvironmentVariableCollections=l;function D(k){return new Map(k.map(P=>[P[0],{map:O(P[1])}]))}e.deserializeEnvironmentVariableCollections=D}),define(re[245],oe([0,1,6,25,3,2,8]),function(_,e,L,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends D.Disposable{constructor(b,I){super(),this.h=I,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new l.Emitter),this.onCreateRequest=this.g.event,this.b=b===void 0?15e3:b}createRequest(b){return new Promise((I,w)=>{const y=++this.a;this.c.set(y,I),this.g.fire({requestId:y,...b});const p=new O.CancellationTokenSource;(0,L.timeout)(this.b,p.token).then(()=>w(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,D.toDisposable)(()=>p.cancel())])})}acceptReply(b,I){const w=this.c.get(b);w?(this.c.delete(b),(0,D.dispose)(this.f.get(b)||[]),this.f.delete(b),w(I)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=ye([X(1,k.ILogService)],P),e.RequestStore=P}),define(re[117],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var O;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(O=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var l;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsDefaultColor="terminal.integrated.tabs.defaultColor",f.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.TabStopWidth="terminal.integrated.tabStopWidth",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.TabFocusMode="terminal.integrated.tabFocusMode",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",f.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",f.SmoothScrolling="terminal.integrated.smoothScrolling"})(l=e.TerminalSettingId||(e.TerminalSettingId={}));var D;(function(f){f.FileName="ptyhost"})(D=e.TerminalLogConstants||(e.TerminalLogConstants={}));var k;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(k=e.PosixShellType||(e.PosixShellType={}));var P;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var C;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(C=e.TitleEventSource||(e.TitleEventSource={}));var b;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Logger="logger",f.Heartbeat="heartbeat"})(b=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,L.createDecorator)("ptyService");var I;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions",f.FailedShellIntegrationActivation="failedShellIntegrationActivation",f.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(I=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var y;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(y=e.TerminalLocation||(e.TerminalLocation={}));var p;(function(f){f.TerminalView="view",f.Editor="editor"})(p=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var E;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(E=e.FlowControlConstants||(e.FlowControlConstants={}));var c;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(c=e.ProfileSource||(e.ProfileSource={}));var u;(function(f){f[f.Off=0]="Off",f[f.FinalTerm=1]="FinalTerm",f[f.VSCode=2]="VSCode"})(u=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(f){f[f.Unknown=0]="Unknown",f[f.Shutdown=1]="Shutdown",f[f.Process=2]="Process",f[f.User=3]="User",f[f.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(re[246],oe([0,1,52,11,178,134]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function k(y,p){const d=[{name:null,description:(0,l.localize)(0,null)}];return d.push(...y.map(E=>({name:E.profileName,description:P(E)}))),p&&d.push(...p.map(E=>({name:E.title,description:C(E)}))),{values:d.map(E=>E.name),markdownDescriptions:d.map(E=>E.description)}}e.createProfileSchemaEnums=k;function P(y){let p=`$(${D.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:L.Codicon.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?p+=`
- args: "${y.args}"`:p+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(p+=`
- overrideName: ${y.overrideName}`),y.color&&(p+=`
- color: ${y.color}`),y.env&&(p+=`
- env: ${JSON.stringify(y.env)}`),p}function C(y){return`$(${D.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:L.Codicon.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function b(y,p){if(!y&&!p)return!0;if(typeof y=="string"&&typeof p=="string")return y===p;if(Array.isArray(y)&&Array.isArray(p)){if(y.length!==p.length)return!1;for(let d=0;d<y.length;d++)if(y[d]!==p[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function I(y,p){if(!y&&!p)return!0;if(!y||!p)return!1;if(D.ThemeIcon.isThemeIcon(y)&&D.ThemeIcon.isThemeIcon(p))return y.id===p.id&&y.color===p.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof p=="object"&&"light"in p&&"dark"in p){const d=y,E=p;if((O.URI.isUri(d.light)||w(d.light))&&(O.URI.isUri(d.dark)||w(d.dark))&&(O.URI.isUri(E.light)||w(E.light))&&(O.URI.isUri(E.dark)||w(E.dark)))return d.light.path===E.light.path&&d.dark.path===E.dark.path}if(O.URI.isUri(y)&&O.URI.isUri(p)||w(y)||w(p)){const d=y,E=p;return d.path===E.path&&d.scheme===E.scheme}return!1}e.terminalIconsEqual=I;function w(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.isUriComponents=w}),define(re[247],oe([0,1,52,177,45,40,246]),function(_,e,L,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,L.getAllCodicons)(),S=>S.id),markdownEnumDescriptions:Array.from((0,L.getAllCodicons)(),S=>`$(${S.id})`)};const P={args:{description:(0,O.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,O.localize)(1,null),type:"boolean"},icon:{description:(0,O.localize)(2,null),...e.terminalIconSchema},color:{description:(0,O.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,O.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},C={type:"object",required:["path"],properties:{path:{description:(0,O.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b={type:"object",required:["path"],properties:{path:{description:(0,O.localize)(6,null),type:["string"],items:{type:"string"}},...P}},I=(0,O.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,O.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),y=(0,O.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,O.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,O.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),E=(0,O.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),c={id:"terminal",order:100,title:(0,O.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,O.localize)(26,null)}},{type:"string",markdownDescription:(0,O.localize)(27,null)}],default:[],markdownDeprecationMessage:y},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,O.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(30,null),type:"string"},id:{description:(0,O.localize)(31,null),type:"string"},title:{description:(0,O.localize)(32,null),type:"string"},...P}},{type:"null"},C]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(34,null),type:"string"},id:{description:(0,O.localize)(35,null),type:"string"},title:{description:(0,O.localize)(36,null),type:"string"},...P}},{type:"null"},C]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,O.localize)(38,null),type:"string"},id:{description:(0,O.localize)(39,null),type:"string"},title:{description:(0,O.localize)(40,null),type:"string"},...P}},{type:"null"},C]}},["terminal.integrated.useWslProfiles"]:{description:(0,O.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,O.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,O.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,O.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,O.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){D.Registry.as(l.Extensions.Configuration).registerConfiguration(c),f()}e.registerTerminalPlatformConfiguration=u;let g;function f(S,R){const i=D.Registry.as(l.Extensions.Configuration);let r;S&&(r=(0,k.createProfileSchemaEnums)(S?.profiles,R));const t=g;g={id:"terminal",order:100,title:(0,O.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,O.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:S?.os===3?r?.values:void 0,markdownEnumDescriptions:S?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,O.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:S?.os===2?r?.values:void 0,markdownEnumDescriptions:S?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,O.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:S?.os===1?r?.values:void 0,markdownEnumDescriptions:S?.os===1?r?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[g],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=f}),define(re[248],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,L.createDecorator)("localPtyService")}),define(re[249],oe([0,1,34,22,32,13,4,36,27,12,28,116,244,243]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function d(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(L.release());let s=0;return n&&n.length===4&&(s=parseInt(n[3])),s}e.getWindowsBuildNumber=d;async function E(n,s,a,o=P.env,h=I.Promises.exists){if(D.isAbsolute(n))return await h(n)?n:void 0;if(s===void 0&&(s=P.cwd()),D.dirname(n)!=="."){const T=D.join(s,n);return await h(T)?T:void 0}const v=(0,l.getCaseInsensitive)(o,"PATH");if(a===void 0&&(0,b.isString)(v)&&(a=v.split(D.delimiter)),a===void 0||a.length===0){const T=D.join(s,n);return await h(T)?T:void 0}for(const T of a){let M;if(D.isAbsolute(T)?M=D.join(T,n):M=D.join(s,T,n),await h(M))return M;if(k.isWindows){let z=M+".com";if(await h(z)||(z=M+".exe",await h(z)))return z}}const A=D.join(s,n);return await h(A)?A:void 0}e.findExecutable=E;function c(n,s,a,o,h){const m=k.isWindows&&(!s.windowsEnableConpty||d()<18309);if(!s.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||m)return;const v=n.args,A=P.platform==="win32"?D.basename(n.executable).toLowerCase():D.basename(n.executable),T=D.dirname(O.FileAccess.asFileUri("").fsPath);let M;const z={VSCODE_INJECTION:"1"};if(k.isWindows){if(A==="pwsh.exe"||A==="powershell.exe")return!v||r(v)?M=f.get(g.WindowsPwsh):i(v)&&(M=f.get(g.WindowsPwshLogin)),M?(M=[...M],M[M.length-1]=(0,C.format)(M[M.length-1],T,""),s.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),{newArgs:M,envMixin:z}):void 0;o.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(A){case"bash":return!v||v.length===0?M=f.get(g.Bash):t(v)&&(z.VSCODE_SHELL_LOGIN="1",u(s,z),M=f.get(g.Bash)),M?(M=[...M],M[M.length-1]=(0,C.format)(M[M.length-1],T),{newArgs:M,envMixin:z}):void 0;case"fish":{const H=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",J=D.join(T,"out/vs/workbench/contrib/xdg_data");return z.XDG_DATA_DIRS=`${H}:${J}`,u(s,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!v||r(v)?M=f.get(g.Pwsh):i(v)&&(M=f.get(g.PwshLogin)),M?(s.shellIntegration.suggestEnabled&&(z.VSCODE_SUGGEST="1"),M=[...M],M[M.length-1]=(0,C.format)(M[M.length-1],T,""),{newArgs:M,envMixin:z}):void 0;case"zsh":{if(!v||v.length===0?M=f.get(g.Zsh):t(v)?(M=f.get(g.ZshLogin),u(s,z)):(v===f.get(g.Zsh)||v===f.get(g.ZshLogin))&&(M=v),!M)return;M=[...M],M[M.length-1]=(0,C.format)(M[M.length-1],T);let H;try{H=L.userInfo().username}catch{H="unknown"}const J=D.join(L.tmpdir(),`${H}-${h.applicationName}-zsh`);z.ZDOTDIR=J;const W=a?.ZDOTDIR??L.homedir()??"~";z.USER_ZDOTDIR=W;const N=[];return N.push({source:D.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.join(J,".zshrc")}),N.push({source:D.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.join(J,".zprofile")}),N.push({source:D.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.join(J,".zshenv")}),N.push({source:D.join(T,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.join(J,".zlogin")}),{newArgs:M,envMixin:z,filesToCopy:N}}}o.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.getShellIntegrationInjection=c;function u(n,s){if(k.isMacintosh&&n.environmentVariableCollections){const a=(0,y.deserializeEnvironmentVariableCollections)(n.environmentVariableCollections),h=new p.MergedEnvironmentVariableCollection(a).map.get("PATH"),m=[];if(h)for(const v of h)v.type===w.EnvironmentVariableMutatorType.Prepend&&m.push(v.value);m.length>0&&(s.VSCODE_PATH_PREFIX=m.join(""))}}var g;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(g||(g={}));const f=new Map;f.set(g.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(g.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(g.Zsh,["-i"]),f.set(g.ZshLogin,["-il"]),f.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],R=["-nol","-nologo"];function i(n){return typeof n=="string"?S.includes(n.toLowerCase()):n.length===1&&S.includes(n[0].toLowerCase())||n.length===2&&(S.includes(n[0].toLowerCase())||S.includes(n[1].toLowerCase()))&&(R.includes(n[0].toLowerCase())||R.includes(n[1].toLowerCase()))}function r(n){return typeof n=="string"?R.includes(n.toLowerCase()):n.length===0||n?.length===1&&R.includes(n[0].toLowerCase())}function t(n){return n==="string"&&S.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&S.includes(n[0].toLowerCase())}}),define(re[250],oe([0,1,50,52,13,4,12,28,93,249]),function(_,e,L,O,l,D,k,P,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,w=!0;function y(r,t,n,s,a=process.env,o,h,m,v){return o=o||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},D.isWindows?p(n,o,a,h,s.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),v,m):S(o,h,n,r&&typeof r=="object"?{...r}:s.getValue(D.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(D.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),v,m,a)}e.detectAvailableProfiles=y;async function p(r,t,n,s,a,o,h,m,v){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),T=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let M=!1;(0,b.getWindowsBuildNumber)()>=16299&&(M=!0),await c(m);const z=new Map;if(r){z.set("PowerShell",{source:"PowerShell",icon:O.Codicon.terminalPowershell,isAutoDetected:!0}),z.set("Windows PowerShell",{path:`${T}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.Codicon.terminalPowershell,isAutoDetected:!0}),z.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),z.set("Command Prompt",{path:`${T}\\cmd.exe`,icon:O.Codicon.terminalCmd,isAutoDetected:!0}),z.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),z.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.Codicon.terminalBash,isAutoDetected:!0});const J=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;z.set("Cmder",{path:`${T}\\cmd.exe`,args:["/K",J],requiresPath:process.env.CMDER_ROOT?J:{path:J,isUnsafe:!0},isAutoDetected:!0})}R(o,z);const H=await d(z.entries(),h,t,n,s,v);if(r||a)try{const J=await g(`${T}\\${M?"wsl":"bash"}.exe`,h);for(const W of J)(!o||!(W.profileName in o))&&H.push(W)}catch{w&&(s?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return H}async function d(r,t,n,s=process.env,a,o){const h=[];for(const[m,v]of r){if(v===null)continue;let A,T,M;if("source"in v){const W=I?.get(v.source);if(!W)continue;A=W.paths,T=v.args||W.args,v.icon?M=E(v.icon):W.icon&&(M=W.icon)}else A=Array.isArray(v.path)?v.path:[v.path],T=D.isWindows||Array.isArray(v.args)?v.args:void 0,M=E(v.icon);let z;if(o){const W=A.map(j=>typeof j=="string"?j:j.path),N=await o(W);z=new Array(A.length);for(let j=0;j<A.length;j++)typeof A[j]=="string"?z[j]=N[j]:z[j]={path:N[j],isUnsafe:!0}}else z=A.slice();let H;if(v.requiresPath){let W;if((0,k.isString)(v.requiresPath)?W=v.requiresPath:(W=v.requiresPath.path,v.requiresPath.isUnsafe&&(H=W)),!await n.existsFile(W))continue}const J=await i(m,t,z,n,s,T,v.env,v.overrideName,v.isAutoDetected,H);J?(J.isAutoDetected=v.isAutoDetected,J.icon=M,J.color=v.color,h.push(J)):a?.debug("Terminal profile not validated",m,A)}return a?.debug("Validated terminal profiles",h),h}function E(r){return typeof r=="string"?{id:r}:r}async function c(r){I&&!r||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),I.set("PowerShell",{profileName:"PowerShell",paths:r||await u(),icon:O.Codicon.terminalPowershell}))}async function u(){const r=[];for await(const t of(0,C.enumeratePowerShellInstallations)())r.push(t.exePath);return r}async function g(r,t){const n=[],s=await new Promise((h,m)=>{L.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(v,A)=>{if(v)return m("Problem occurred when getting wsl distros");h(A)})});if(!s)return[];const a=new RegExp(/[\r?\n]/),o=s.split(a).filter(h=>h.trim().length>0&&h!=="");for(const h of o){if(h===""||h.startsWith("docker-desktop"))continue;const m=`${h} (WSL)`,v={profileName:m,path:r,args:["-d",`${h}`],isDefault:m===t,icon:f(h),isAutoDetected:!1};n.push(v)}return n}function f(r){return r.includes("Ubuntu")?O.Codicon.terminalUbuntu:r.includes("Debian")?O.Codicon.terminalDebian:O.Codicon.terminalLinux}async function S(r,t,n,s,a,o,h,m){const v=new Map;if(n){const A=(await r.readFile("/etc/shells")).toString(),T=o||A.split(`
`).filter(z=>z.trim().includes("#")&&z.trim().length>0),M=new Map;for(const z of T){let H=(0,l.basename)(z),J=M.get(H)||0;J++,J>1&&(H=`${H} (${J})`),M.set(H,J),v.set(H,{path:z,isAutoDetected:!0})}}return R(s,v),await d(v.entries(),a,r,m,t,h)}function R(r,t){if(!!r)for(const[n,s]of Object.entries(r))s===null||typeof s!="object"||!("path"in s)&&!("source"in s)?t.delete(n):(s.icon=s.icon||t.get(n)?.icon,t.set(n,s))}async function i(r,t,n,s,a,o,h,m,v,A){if(n.length===0)return Promise.resolve(void 0);const T=n.shift();if(T==="")return i(r,t,n,s,a,o,h,m,v);const M=typeof T!="string"&&T.isUnsafe,z=typeof T=="string"?T:T.path,H={profileName:r,path:z,args:o,env:h,overrideName:m,isAutoDetected:v,isDefault:r===t,isUnsafePath:M,requiresUnsafePath:A};if((0,l.basename)(z)===z){const W=a.PATH?a.PATH.split(l.delimiter):void 0,N=await(0,b.findExecutable)(z,void 0,W,void 0,s.existsFile);return N?(H.path=N,H.isFromPath=!0,H):i(r,t,n,s,a,o)}return await s.existsFile((0,l.normalize)(z))?H:i(r,t,n,s,a,o,h,m,v)}}),define(re[251],oe([0,1,3,2,22,4,39,65,17,15,96,231,8,245,117,247,250,106]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(R){R[R.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let f=0,S=class extends O.Disposable{constructor(i,r,t,n,s,a){super(),this.C=i,this.D=r,this.F=t,this.G=n,this.H=s,this.I=a,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new L.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new L.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new L.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new L.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new L.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new L.Emitter),this.onProcessData=this.s.event,this.t=this.B(new L.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new L.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new L.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new L.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new L.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new L.Emitter),this.onProcessExit=this.z.event,(0,E.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,O.toDisposable)(()=>this.O())),this.f=this.B(new p.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(D.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(i){return this.H.error("ptyHost was unable to resolve shell environment",i),{}}}N(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:f,VSCODE_PTY_LOG_NAME:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},r=(0,I.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);r&&(r.break&&r.port?i.debugBrk=r.port:!r.break&&r.port&&(i.debug=r.port));const t=new P.Client(l.FileAccess.asFileUri("bootstrap-fork").fsPath,i);this.m.fire(),k.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(t.onDidProcessExit(a=>{this.l.fire(a.code),this.i||(this.g<=g.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))})),this.B(new u.RemoteLoggerChannelClient(this.I,t.getChannel(d.TerminalIpcChannels.Logger)));const s=k.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.PtyHost));return this.B(s.onProcessData(a=>this.s.fire(a))),this.B(s.onProcessReady(a=>this.t.fire(a))),this.B(s.onProcessExit(a=>this.z.fire(a))),this.B(s.onDidChangeProperty(a=>this.y.fire(a))),this.B(s.onProcessReplay(a=>this.u.fire(a))),this.B(s.onProcessOrphanQuestion(a=>this.v.fire(a))),this.B(s.onDidRequestDetach(a=>this.w.fire(a))),[t,s]}dispose(){this.i=!0,super.dispose()}async createProcess(i,r,t,n,s,a,o,h,m,v,A){const T=setTimeout(()=>this.S(),d.HeartbeatConstants.CreateProcessTimeout),M=await this.b.createProcess(i,r,t,n,s,a,o,h,m,v,A);return clearTimeout(T),f=Math.max(f,M),M}updateTitle(i,r,t){return this.b.updateTitle(i,r,t)}updateIcon(i,r,t,n){return this.b.updateIcon(i,r,t,n)}attachToProcess(i){return this.b.attachToProcess(i)}detachFromProcess(i,r){return this.b.detachFromProcess(i,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(i){return this.b.start(i)}shutdown(i,r){return this.b.shutdown(i,r)}input(i,r){return this.b.input(i,r)}processBinary(i,r){return this.b.processBinary(i,r)}resize(i,r,t){return this.b.resize(i,r,t)}acknowledgeDataEvent(i,r){return this.b.acknowledgeDataEvent(i,r)}setUnicodeVersion(i,r){return this.b.setUnicodeVersion(i,r)}getInitialCwd(i){return this.b.getInitialCwd(i)}getCwd(i){return this.b.getCwd(i)}getLatency(i){return this.b.getLatency(i)}orphanQuestionReply(i){return this.b.orphanQuestionReply(i)}installAutoReply(i,r){return this.b.installAutoReply(i,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(i){return this.b.uninstallAutoReply(i)}getDefaultSystemShell(i){return this.b.getDefaultSystemShell(i)}async getProfiles(i,r,t,n=!1){const s=await this.c;return(0,c.detectAvailableProfiles)(r,t,n,this.F,s,void 0,this.H,this.W.bind(this,i))}getEnvironment(){return this.b.getEnvironment()}getWslPath(i,r){return this.b.getWslPath(i,r)}getRevivedPtyNewId(i){return this.b.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this.b.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this.b.getTerminalLayoutInfo(i)}async requestDetachInstance(i,r){return this.b.requestDetachInstance(i,r)}async acceptDetachInstanceReply(i,r){return this.b.acceptDetachInstanceReply(i,r)}async freePortKillProcess(i){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(i)}async serializeTerminalState(i){return this.b.serializeTerminalState(i)}async reviveTerminalProcesses(i,r){return this.b.reviveTerminalProcesses(i,r)}async refreshProperty(i,r){return this.b.refreshProperty(i,r)}async updateProperty(i,r,t){return this.b.updateProperty(i,r,t)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(i,r){return this.f.createRequest({workspaceId:i,originalText:r})}async acceptPtyHostResolvedVariables(i,r){this.f.acceptReply(i,r)}};S=ye([X(2,C.IConfigurationService),X(3,b.IEnvironmentService),X(4,y.ILogService),X(5,y.ILoggerService)],S),e.PtyHostService=S}),define(re[75],oe([0,1,3,17,5,8]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var k;(function(E){E.Http="http",E.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=w;function y(E,c,u,g){if(u===1)return!1;if(u===2&&w(c)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(f?.length===4&&parseInt(f[1])>=18)return!1}return E<1024}e.isPortPrivileged=y;class p{constructor(c,u,g){this.remoteAddress=c,this.localAddress=u,this.b=g,this.a=new L.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=p;let d=class{constructor(c,u){this.i=c,this.j=u,this.a=new L.Emitter,this.onTunnelOpened=this.a.event,this.b=new L.Emitter,this.onTunnelClosed=this.b.event,this.c=new L.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const c=this.j.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.e=c,c?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.f=c.elevation,this.g=c.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const c=[],u=Array.from(this.d.values());for(const g of u){const f=Array.from(g.values());for(const S of f){const R=await S.value;R&&c.push(R)}}return c}async dispose(){for(const c of this.d.values()){for(const{value:u}of c.values())await u.then(g=>g?.dispose());c.clear()}this.d.clear()}setEnvironmentTunnel(c,u,g,f,S){this.o(c,u,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:u,localAddress:g,privacy:f,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,u){(w(c)||I(c))&&(c=e.LOCALHOST_ADDRESSES[0]);const g=this.q(c,u);if(g)return++g.refcount,g.value}openTunnel(c,u,g,f,S,R=!1,i,r){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${g} on local port ${S}.`),!c)return;if(u||(u="localhost"),f||(f=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.r(c,u,g,f,S,R,i,r);return t?t.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}m(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this.d.get(c.tunnelRemoteHost);if(u){const g=u.get(c.tunnelRemotePort);g&&(g.refcount--,await this.n(c.tunnelRemoteHost,c.tunnelRemotePort,g))}}}}async n(c,u,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const f=g.value.then(async S=>{S&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.d.has(c)&&this.d.get(c).delete(u),f}}async closeTunnel(c,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const g=this.d.get(c);if(g&&g.has(u)){const f=g.get(u);f.refcount=0,await this.n(c,u,f)}}o(c,u,g){this.d.has(c)||this.d.set(c,new Map),this.d.get(c).set(u,{refcount:1,value:g})}async p(c,u){const g=this.d.get(c);g&&(await g.get(u)||g.delete(u),g.size===0&&this.d.delete(c))}q(c,u){const g=[c];I(c)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(c)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const f=g.map(S=>this.d.get(S));for(const S of f){const R=S?.get(u);if(R)return R}}canTunnel(c){return!!b(c)}s(c,u,g,f,S,R,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${g} on local port ${f}.`);const r=g;this.h.add(r);const t=f===void 0?g:f,n={elevationRequired:S?this.isPortPrivileged(t):!1},s={remoteAddress:{host:u,port:g},localAddressPort:f,privacy:R,public:R?R!==P.Private:void 0,protocol:i},a=c.forwardPort(s,n);return a?(this.o(u,g,a),a.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),a}};d=ye([X(0,D.ILogService),X(1,O.IConfigurationService)],d),e.AbstractTunnelService=d}),define(re[252],oe([0,1,8,75,2,9,6]),function(_,e,L,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends l.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new k.DeferredPromise),this.b.p)}setAddress(I){this.a=I,this.b&&(this.b.complete(I),this.b=null)}setTunnel(I){this.B(I)}}let C=class Dt extends l.Disposable{constructor(I,w){super(),this.f=I,this.g=w,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Dt.a)}}async startTunnel(I,w,y,p,d,E,c){const u=new P,g=await Promise.resolve(this.f.openTunnel(I,u,y,p,d,E,c));if(!g)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${y}:${p} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(w))throw this.c.delete(w),u.dispose(),await g.dispose(),(0,D.canceled)();return u.setTunnel(g),this.b.set(w,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${g.localAddress} (local) to ${y}:${p} (remote).`),{tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress}}async setAddress(I,w){const y=this.b.get(I);!y||y.setAddress(w)}async destroyTunnel(I){const w=this.b.get(I);if(w){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this.b.delete(I),await w.dispose();return}this.c.add(I)}};C.a=0,C=ye([X(0,O.ISharedTunnelsService),X(1,L.ILogService)],C),e.SharedProcessTunnelService=C}),define(re[253],oe([0,1,85,34,136,225,6,2,17,8,26,223,75,111,4]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function E(S,R,i,r,t){let n;for(let s=3;s&&(n?.dispose(),n=await new c(S,R,i,r,t).waitForReady(),!(t&&l.BROWSER_RESTRICTED_PORTS[t]||!l.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));s--);return n}class c extends P.Disposable{constructor(R,i,r,t,n){super(),this.j=i,this.k=n,this.privacy=y.TunnelPrivacyId.Private,this.i=new Map,this.a=R,this.b=L.createServer(),this.c=new k.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const R=this.k??this.tunnelRemotePort,i=(0,y.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,l.findFreePortFaster)(R,2,1e3,i),t=null;return this.b.listen(r,this.j),await this.c.wait(),t=this.b.address(),t||(r=0,this.b.listen(r,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(R){R.pause();const i=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,w.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),t=r.getSocket().socket,n=r.readEntireBuffer();r.dispose(),n.byteLength>0&&R.write(n.buffer),R.on("end",()=>{R.localAddress&&this.i.delete(R.localAddress),t.end()}),R.on("close",()=>t.end()),R.on("error",()=>{R.localAddress&&this.i.delete(R.localAddress),t.destroy()}),t.on("end",()=>R.end()),t.on("close",()=>R.end()),t.on("error",()=>{R.destroy()}),R.pipe(t),t.pipe(R),R.localAddress&&this.i.set(R.localAddress,()=>{R.end(),t.end()})}}let u=class extends y.AbstractTunnelService{constructor(R,i,r,t,n){super(i,n),this.t=R,this.u=r,this.v=t}isPortPrivileged(R){return(0,y.isPortPrivileged)(R,this.k,d.OS,O.release())}r(R,i,r,t,n,s,a,o){const h=this.q(i,r);if(h)return++h.refcount,h.value;if(this.e)return this.s(this.e,i,r,n,s,a,o);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${r} on local port ${n}.`);const m={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:R,signService:this.u,logService:this.i,ipcLogger:null},v=E(m,t,i,r,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,r,v),v}}};u=ye([X(1,b.ILogService),X(2,p.ISignService),X(3,I.IProductService),X(4,C.IConfigurationService)],u),e.BaseTunnelService=u;let g=class extends u{constructor(R,i,r,t){super(D.nodeSocketFactory,R,i,r,t)}};g=ye([X(0,b.ILogService),X(1,p.ISignService),X(2,I.IProductService),X(3,C.IConfigurationService)],g),e.TunnelService=g;let f=class extends P.Disposable{constructor(R,i,r,t){super(),this.b=R,this.c=i,this.f=r,this.g=t,this.a=new Map}async openTunnel(R,i,r,t,n,s,a,o,h){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${t} on local port ${s}.`),!this.a.has(R)){const m=new g(this.b,this.f,this.c,this.g);this.B(m),this.a.set(R,m),m.onTunnelClosed(async()=>{(await m.tunnels).length===0&&(m.dispose(),this.a.delete(R))})}return this.a.get(R).openTunnel(i,r,t,n,s,a,o,h)}};f=ye([X(0,b.ILogService),X(1,I.IProductService),X(2,p.ISignService),X(3,C.IConfigurationService)],f),e.SharedTunnelsService=f}),define(re[30],oe([0,1,5]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(re[254],oe([0,1,30,197,14,23,132,3,2]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(y){this.uri=y,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let I=class{constructor(y){this.g=y,this.c=new C.DisposableStore,this.f=2**16;const p=new Map,d=E=>{let c=p.get(E.scheme);return c===void 0&&(c=y.hasProvider(E)&&!this.g.hasCapability(E,1024),p.set(E.scheme,c)),c};this.c.add(P.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(E=>{p.delete(E.scheme)})),this.extUri=new D.ExtUri(d),this.d=new k.SkipList((E,c)=>this.extUri.compare(E,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,D.normalizePath)(y));const p=this.d.get(y);return p?p.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new b(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((d,E)=>d[1].time<E[1].time?1:d[1].time>E[1].time?-1:0);b._clock=0,this.d.clear();const p=this.f*.5;for(let d=0;d<p;d++)this.d.set(y[d][0],y[d][1].touch())}};I=ye([X(0,l.IFileService)],I),e.UriIdentityService=I,(0,O.registerSingleton)(L.IUriIdentityService,I,1)}),define(re[255],oe([0,1,3,2,14,43,49,16]),function(_,e,L,O,l,D,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class C extends O.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(I,w,y,p){super(),this.c=I,this.f=w,this.g=y,this.h=p,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new L.Emitter),this.onDidChangeFile=this.a.event,this.b=k.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(d=>this.i(d)))}watch(I,w){this.b.set(I,I);const y=this.f.watch(this.j(I),w);return(0,O.toDisposable)(()=>{this.b.delete(I),y.dispose()})}stat(I){return this.f.stat(this.j(I))}mkdir(I){return this.f.mkdir(this.j(I))}rename(I,w,y){return this.f.rename(this.j(I),this.j(w),y)}readFile(I){return this.f.readFile(this.j(I),{atomic:!0})}readFileStream(I,w,y){const p=(0,D.newWriteableStream)(d=>P.VSBuffer.concat(d.map(E=>P.VSBuffer.wrap(E))).buffer);return(async()=>{try{const d=await this.readFile(I);p.end(d)}catch(d){p.error(d),p.end()}})(),p}readdir(I){return this.f.readdir(this.j(I))}writeFile(I,w,y){return this.f.writeFile(this.j(I),w,y)}delete(I,w){return this.f.delete(this.j(I),w)}copy(I,w,y){if((0,l.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(I),this.j(w),y);throw new Error("copy not supported")}i(I){const w=[];for(const y of I){if(y.resource.scheme!==this.c)continue;const p=this.k(y.resource);this.b.findSubstr(p)&&w.push({resource:p,type:y.type})}w.length&&(this.h.debug("User data changed"),this.a.fire(w))}j(I){return I.with({scheme:this.c})}k(I){return I.with({scheme:this.g})}}e.FileUserDataProvider=C}),define(re[59],oe([0,1,82]),function(_,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function O(k,P,C,b){const I=(0,L.setProperty)(k,P,C,b)[0];return I&&(k=k.substring(0,I.offset)+I.content+k.substring(I.offset+I.length)),k}e.edit=O;function l(k,P,C){let b=C;for(;b>=0;){if(k.charAt(b)===P.charAt(P.length-1)&&P.length===1)return b+1;if(b--,P.length===2&&b>=0&&k.charAt(b)===P.charAt(0))return b+2}return 0}e.getLineStartOffset=l;function D(k,P,C){let b=C;for(;b>=0;)if(k.charAt(b)===P.charAt(P.length-1)&&P.length===1||(b++,P.length===2&&b>=0&&k.charAt(b)===P.charAt(1)))return b;return k.length-1}e.getLineEndOffset=D}),define(re[256],oe([0,1,32,54,12]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(p,d,E,c,u,g){const f=[],S=[],R=[];if(!d){const J=p.filter(({identifier:W})=>u.every(N=>N.toLowerCase()!==W.id.toLowerCase()));return{local:{added:f,removed:S,updated:R},remote:J.length>0?{added:J,updated:[],removed:[],all:J}:null}}p=p.map(w),d=d.map(w),E=E?E.map(w):null;const i=new Map,r=J=>{J.uuid&&i.set(J.id.toLowerCase(),J.uuid)};p.forEach(({identifier:J})=>r(J)),d.forEach(({identifier:J})=>r(J)),E?.forEach(({identifier:J})=>r(J));const t=J=>{const W=J.identifier.uuid||i.get(J.identifier.id.toLowerCase());return W?`uuid:${W}`:`id:${J.identifier.id.toLowerCase()}`},n=(J,W)=>(J.set(t(W),W),J),s=p.reduce(n,new Map),a=d.reduce(n,new Map),o=d.reduce((J,W)=>n(J,(0,L.deepClone)(W)),new Map),h=E?E.reduce(n,new Map):null,m=c.reduce(n,new Map),v=u.reduce((J,W)=>{const N=i.get(W.toLowerCase());return J.add(N?`uuid:${N}`:`id:${W.toLowerCase()}`)},new Set),A=g?g.reduce((J,{id:W,uuid:N})=>(N=N??i.get(W.toLowerCase()),J.add(N?`uuid:${N}`:`id:${W.toLowerCase()}`)),new Set):null,T=k(s,a,v,!1);if(T.added.size>0||T.removed.size>0||T.updated.size>0){const J=k(h,s,v,!1),W=k(h,a,v,!0),N=(j,q,x,Y)=>{let F,Z,te;return q.installed?(F=Y.pinned,te=Y.preRelease,F&&(Z=Y.version)):(F=x.pinned,te=x.preRelease,F&&(Z=x.version)),F===void 0&&(F=q.pinned,F&&(Z=q.version)),te===void 0&&(te=q.preRelease),{...Y,installed:q.installed||x.installed,pinned:F,preRelease:te,version:Z??(x.version&&(!q.installed||O.gt(x.version,q.version))?x.version:q.version),state:C(q,x,h?.get(j))}};for(const j of W.removed.values()){const q=s.get(j);if(!q)continue;const x=(0,l.assertIsDefined)(h?.get(j)),Y=A&&!A.has(j)&&x.installed;q.installed&&Y?S.push(q.identifier):o.set(j,q)}for(const j of W.added.values()){const q=(0,l.assertIsDefined)(a.get(j)),x=s.get(j);if(x){if(T.updated.has(j)){const Y=N(j,x,q,q);P(x,q,!1,!1)||R.push(y(Y,j)),o.set(j,Y)}}else q.installed&&f.push(y(q,j))}for(const j of W.updated.values()){const q=(0,l.assertIsDefined)(a.get(j)),x=(0,l.assertIsDefined)(h?.get(j)),Y=s.get(j);if(Y)if(A&&!A.has(j)&&x.installed&&Y.installed&&!q.installed)S.push(Y.identifier);else{const Z=N(j,Y,q,q);R.push(y(Z,j)),o.set(j,Z)}else q.installed&&f.push(y(q,j))}for(const j of J.added.values())W.added.has(j)||o.set(j,(0,l.assertIsDefined)(s.get(j)));for(const j of J.updated.values()){if(W.removed.has(j)||W.updated.has(j))continue;const q=(0,l.assertIsDefined)(s.get(j)),x=(0,l.assertIsDefined)(a.get(j));o.set(j,N(j,q,x,q))}for(const j of J.removed.values())W.updated.has(j)||W.removed.has(j)||m.has(j)||!(0,l.assertIsDefined)(a.get(j)).installed||!A||A.has(j)||!(0,l.assertIsDefined)(h?.get(j)).installed||o.delete(j)}const M=[],z=k(a,o,new Set,!0),H=z.added.size>0||z.updated.size>0||z.removed.size>0;return H&&o.forEach((J,W)=>M.push(y(J,W))),{local:{added:f,removed:S,updated:R},remote:H?{added:[...z.added].map(J=>o.get(J)),updated:[...z.updated].map(J=>o.get(J)),removed:[...z.removed].map(J=>a.get(J)),all:M}:null}}e.merge=D;function k(p,d,E,c){const u=p?[...p.keys()].filter(i=>!E.has(i)):[],g=[...d.keys()].filter(i=>!E.has(i)),f=g.filter(i=>u.indexOf(i)===-1).reduce((i,r)=>(i.add(r),i),new Set),S=u.filter(i=>g.indexOf(i)===-1).reduce((i,r)=>(i.add(r),i),new Set),R=new Set;for(const i of u){if(S.has(i))continue;const r=p.get(i),t=d.get(i);(!t||!P(r,t,c,!0))&&R.add(i)}return{added:f,removed:S,updated:R}}function P(p,d,E,c){return!(p.disabled!==d.disabled||c&&p.installed!==d.installed||p.installed&&d.installed&&(p.preRelease!==d.preRelease||p.pinned!==d.pinned||d.pinned&&p.version!==d.version)||!I(p.state,d.state)||E&&p.version!==d.version)}function C(p,d,E){const c=p.state,u=d.state,g=E?.state;if(!d.version||c&&O.gt(p.version,d.version))return c;if(u&&O.gt(d.version,p.version)||!c)return u;if(!u)return c;const f=(0,L.deepClone)(c),S=g?b(g,u):{added:Object.keys(u).reduce((i,r)=>(i.add(r),i),new Set),removed:new Set,updated:new Set},R=g?b(g,c):{added:Object.keys(c).reduce((i,r)=>(i.add(r),i),new Set),removed:new Set,updated:new Set};for(const i of[...S.added.values(),...S.updated.values()])f[i]=u[i];for(const i of S.removed.values())R.updated.has(i)||delete f[i];return f}function b(p,d){const E=Object.keys(p),c=Object.keys(d),u=c.filter(S=>E.indexOf(S)===-1).reduce((S,R)=>(S.add(R),S),new Set),g=E.filter(S=>c.indexOf(S)===-1).reduce((S,R)=>(S.add(R),S),new Set),f=new Set;for(const S of E){if(g.has(S))continue;const R=p[S],i=d[S];(0,L.equals)(R,i)||f.add(S)}return{added:u,removed:g,updated:f}}function I(p={},d={}){const{added:E,removed:c,updated:u}=b(p,d);return E.size===0&&c.size===0&&u.size===0}function w(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function y(p,d){const E={identifier:{id:p.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},version:p.version,preRelease:!!p.preRelease,pinned:!!p.pinned};return p.disabled&&(E.disabled=!0),p.installed&&(E.installed=!0),p.state&&(E.state=p.state),E}}),define(re[118],oe([0,1,21,17,5]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,l.createDecorator)("IIgnoredExtensionsManagementService");let D=class{constructor(P){this.a=P}hasToNeverSyncExtension(P){return this.b().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.b().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,C){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==P&&I!==`-${P}`),C&&b.push(P.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}updateSynchronizedExtensions(P,C){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return b=b.filter(I=>I!==P&&I!==`-${P}`),C&&b.push(`-${P.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}getIgnoredExtensions(P){const C=P.filter(y=>y.isMachineScoped).map(y=>y.identifier.id.toLowerCase()),b=this.b().map(y=>y.toLowerCase()),I=[],w=[];if(Array.isArray(b))for(const y of b)y.startsWith("-")?w.push(y.substring(1)):I.push(y);return(0,L.distinct)([...C,...I].filter(y=>w.indexOf(y)===-1))}b(){let P=this.a.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.a.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};D=ye([X(0,O.IConfigurationService)],D),e.IgnoredExtensionsManagementService=D}),define(re[257],oe([0,1,21,35,32,97,59]),function(_,e,L,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function P(S){return(0,O.parse)(S)||[]}async function C(S,R,i,r,t){const n=P(S),s=P(R),a=i?P(i):null,o=[...n,...s,...a||[]].map(N=>N.key),h=await t.resolveUserBindings(o),m=I(n,s,a,h);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:S,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:R,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};const v=y(n),A=y(s),T=a?y(a):null,M=d(v,A,h),z=T?d(T,v,h):{added:[...v.keys()].reduce((N,j)=>(N.add(j),N),new Set),removed:new Set,updated:new Set},H=T?d(T,A,h):{added:[...A.keys()].reduce((N,j)=>(N.add(j),N),new Set),removed:new Set,updated:new Set},J=b(M,z,H);let W=S;for(const N of J.removed.values())J.conflicts.has(N)||(W=g(W,N,r));for(const N of J.added.values()){if(J.conflicts.has(N))continue;const j=A.get(N);if(j.some(q=>q.command!==`-${N}`&&m.conflicts.has(h[q.key]))){J.conflicts.add(N);continue}W=u(W,j,r)}for(const N of J.updated.values()){if(J.conflicts.has(N))continue;const j=A.get(N);if(j.some(q=>q.command!==`-${N}`&&m.conflicts.has(h[q.key]))){J.conflicts.add(N);continue}W=f(W,N,j,r)}return{mergeContent:W,hasChanges:!0,hasConflicts:J.conflicts.size>0}}e.merge=C;function b(S,R,i){const r=new Set,t=new Set,n=new Set,s=new Set;for(const a of R.removed.values())i.updated.has(a)&&s.add(a);for(const a of i.removed.values())s.has(a)||(R.updated.has(a)?s.add(a):t.add(a));for(const a of R.added.values())s.has(a)||i.added.has(a)&&S.updated.has(a)&&s.add(a);for(const a of i.added.values())s.has(a)||(R.added.has(a)?S.updated.has(a)&&s.add(a):r.add(a));for(const a of R.updated.values())s.has(a)||i.updated.has(a)&&S.updated.has(a)&&s.add(a);for(const a of i.updated.values())s.has(a)||(R.updated.has(a)?S.updated.has(a)&&s.add(a):n.add(a));return{added:r,removed:t,updated:n,conflicts:s}}function I(S,R,i,r){const t=new Set,n=w(S,r),s=w(R,r),a=i?w(i,r):null,o=p(n,s);if(o.added.size===0&&o.removed.size===0&&o.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const h=a?p(a,n):{added:[...n.keys()].reduce((z,H)=>(z.add(H),z),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const m=a?p(a,s):{added:[...s.keys()].reduce((z,H)=>(z.add(H),z),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:v,removed:A,updated:T,conflicts:M}=b(o,h,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:v,removed:A,updated:T,conflicts:M}}function w(S,R){const i=new Map;for(const r of S){const t=R[r.key];let n=i.get(t);n||(n=[],i.set(t,n)),n.push(r)}return i}function y(S){const R=new Map;for(const i of S){const r=i.command[0]==="-"?i.command.substring(1):i.command;let t=R.get(r);t||(t=[],R.set(r,t)),t.push(i)}return R}function p(S,R){const i=[...S.keys()],r=[...R.keys()],t=r.filter(a=>i.indexOf(a)===-1).reduce((a,o)=>(a.add(o),a),new Set),n=i.filter(a=>r.indexOf(a)===-1).reduce((a,o)=>(a.add(o),a),new Set),s=new Set;for(const a of i){if(n.has(a))continue;const o=S.get(a).map(m=>({...m,key:a})),h=R.get(a).map(m=>({...m,key:a}));(0,L.equals)(o,h,(m,v)=>c(m,v))||s.add(a)}return{added:t,removed:n,updated:s}}function d(S,R,i){const r=[...S.keys()],t=[...R.keys()],n=t.filter(o=>r.indexOf(o)===-1).reduce((o,h)=>(o.add(h),o),new Set),s=r.filter(o=>t.indexOf(o)===-1).reduce((o,h)=>(o.add(h),o),new Set),a=new Set;for(const o of r){if(s.has(o))continue;const h=S.get(o).map(v=>({...v,key:i[v.key]})),m=R.get(o).map(v=>({...v,key:i[v.key]}));E(h,m)||a.add(o)}return{added:n,removed:s,updated:a}}function E(S,R){return!(!(0,L.equals)(S.filter(({command:i})=>i[0]!=="-"),R.filter(({command:i})=>i[0]!=="-"),(i,r)=>c(i,r))||!(0,L.equals)(S.filter(({command:i})=>i[0]==="-"),R.filter(({command:i})=>i[0]==="-"),(i,r)=>c(i,r)))}function c(S,R){if(S.command!==R.command||S.key!==R.key)return!1;const i=D.ContextKeyExpr.deserialize(S.when),r=D.ContextKeyExpr.deserialize(R.when);return!(i&&!r||!i&&r||i&&r&&!i.equals(r)||!l.equals(S.args,R.args))}function u(S,R,i){for(const r of R)S=k.edit(S,[-1],r,i);return S}function g(S,R,i){const r=P(S);for(let t=r.length-1;t>=0;t--)(r[t].command===R||r[t].command===`-${R}`)&&(S=k.edit(S,[t],void 0,i));return S}function f(S,R,i,r){const t=P(S),n=t.findIndex(s=>s.command===R||s.command===`-${R}`);for(let s=t.length-1;s>=0;s--)(t[s].command===R||t[s].command===`-${R}`)&&(S=k.edit(S,[s],void 0,r));for(let s=i.length-1;s>=0;s--)S=k.edit(S,[n],i[s],r);return S}}),define(re[258],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(D,k,P){const C={},b={},I=new Set;if(!k)return{local:{added:C,updated:b,removed:[...I.values()]},remote:{added:D,updated:{},removed:[]},conflicts:[]};const w=O(D,k);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:C,updated:b,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const y=O(P,D),p=O(P,k),d={},E={},c=new Set,u=new Set;for(const g of y.removed.values())p.updated.has(g)?C[g]=k[g]:c.add(g);for(const g of p.removed.values())u.has(g)||(y.updated.has(g)?u.add(g):I.add(g));for(const g of y.updated.values())u.has(g)||(p.updated.has(g)?w.updated.has(g)&&u.add(g):E[g]=D[g]);for(const g of p.updated.values())u.has(g)||(y.updated.has(g)?w.updated.has(g)&&u.add(g):D[g]!==void 0&&(b[g]=k[g]));for(const g of y.added.values())u.has(g)||(p.added.has(g)?w.updated.has(g)&&u.add(g):d[g]=D[g]);for(const g of p.added.values())u.has(g)||(y.added.has(g)?w.updated.has(g)&&u.add(g):C[g]=k[g]);return{local:{added:C,removed:[...I.values()],updated:b},remote:{added:d,removed:[...c.values()],updated:E},conflicts:[...u.values()]}}e.merge=L;function O(D,k){const P=D?Object.keys(D):[],C=k?Object.keys(k):[],b=C.filter(y=>P.indexOf(y)===-1).reduce((y,p)=>(y.add(p),y),new Set),I=P.filter(y=>C.indexOf(y)===-1).reduce((y,p)=>(y.add(p),y),new Set),w=new Set;for(const y of P){if(I.has(y))continue;const p=D[y],d=k[y];p!==d&&w.add(y)}return{added:b,removed:I,updated:w}}function l(D,k){const{added:P,removed:C,updated:b}=O(D,k);return P.size===0&&C.size===0&&b.size===0}e.areSame=l}),define(re[259],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(l,D,k,P){const C={added:[],removed:[],updated:[]};let b={added:[],removed:[],updated:[]};if(!D){const w=l.filter(({id:y})=>!P.includes(y));return w.length?b.added=w:b=null,{local:C,remote:b}}const I=O(l,D,P);if(I.added.length>0||I.removed.length>0||I.updated.length>0){const w=O(k,l,P),y=O(k,D,P);for(const p of y.removed){const d=l.find(E=>E.id===p);d&&C.removed.push(d)}for(const p of y.added){const d=D.find(E=>E.id===p);w.added.includes(p)?I.updated.includes(p)&&C.updated.push(d):C.added.push(d)}for(const p of y.updated)C.updated.push(D.find(d=>d.id===p));for(const p of w.added)y.added.includes(p)||b.added.push(l.find(d=>d.id===p));for(const p of w.updated)y.removed.includes(p)||y.updated.includes(p)||b.updated.push(l.find(d=>d.id===p));for(const p of w.removed){const d=D.find(E=>E.id===p);d&&b.removed.push(d)}}return b.added.length===0&&b.removed.length===0&&b.updated.length===0&&(b=null),{local:C,remote:b}}e.merge=L;function O(l,D,k){l=l?l.filter(({id:y})=>!k.includes(y)):[],D=D.filter(({id:y})=>!k.includes(y));const P=l.map(({id:y})=>y),C=D.map(({id:y})=>y),b=C.filter(y=>P.indexOf(y)===-1),I=P.filter(y=>C.indexOf(y)===-1),w=[];for(const{id:y,name:p,shortName:d}of l){if(I.includes(y))continue;const E=D.find(c=>c.id===y);(!E||E.name!==p||E.shortName!==d)&&w.push(y)}return{added:b,removed:I,updated:w}}}),define(re[24],oe([0,1,21,12,184,45,29,5,108,40]),function(_,e,L,O,l,D,k,P,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const s=b.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(a=>!!s[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function w(){const s=b.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(s).filter(m=>!!s[m].ignoreSync),o=Object.keys(s).filter(m=>s[m].scope===2||s[m].scope===6),h=I();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...o,...h])}e.getDefaultIgnoredSettings=w,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function y(){const s="vscode://schemas/ignoredSettings",a=b.Registry.as(D.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,l.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,l.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,l.localize)(2,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,l.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,l.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const o=b.Registry.as(C.Extensions.JSONContribution),h=()=>{const m=I(),v=w().filter(z=>z!==e.CONFIGURATION_SYNC_STORE_KEY),A=Object.keys(D.allSettings.properties).filter(z=>v.indexOf(z)===-1),T=v.filter(z=>m.indexOf(z)===-1),M={items:{type:"string",enum:[...A,...T.map(z=>`-${z}`)]}};o.registerSchema(s,M)};return a.onDidUpdateConfiguration(()=>h())}e.registerConfiguration=y;function p(s){return s&&(0,O.isObject)(s)&&(0,O.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=p;var d;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(d=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function E(s,...a){return s?[s,...a]:a}e.getPathSegments=E;function c(s,a,o,h){return h.joinPath(o.userDataSyncHome,...E(s,a,`lastSync${a}.json`))}e.getLastSyncResourceUri=c,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(s){const a={};return a[e.HEADER_EXECUTION_ID]=s,a}e.createSyncHeaders=u;var g;(function(s){s.Unauthorized="Unauthorized",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(g=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class f extends Error{constructor(a,o,h,m){super(a),this.code=o,this.resource=h,this.operationId=m,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=f;class S extends f{constructor(a,o,h,m,v){super(a,h,void 0,v),this.url=o,this.serverCode=m}}e.UserDataSyncStoreError=S;class R extends f{constructor(a,o){super(a,o)}}e.UserDataAutoSyncError=R,function(s){function a(o){if(o instanceof s)return o;const h=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(o.name);if(h&&h[1]){const m=h[2]==="unknown"?void 0:h[2],v=h[3]==="unknown"?void 0:h[3];return new s(o.message,h[1],m,v)}return new s(o.message,"Unknown")}s.toUserDataSyncError=a}(f=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function n(s){return`sync.enable.${s}`}e.getEnablementKey=n,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,P.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(re[260],oe([0,1,32,24]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function l(k,P,C,b,I){if(!P)return{remote:{added:Object.keys(k),removed:[],updated:[],all:Object.keys(k).length>0?k:null},local:{added:{},removed:[],updated:{}}};const w=D(k,P);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const y=C?D(C,P):{added:Object.keys(P).reduce((g,f)=>(g.add(f),g),new Set),removed:new Set,updated:new Set},p=C?D(C,k):{added:Object.keys(k).reduce((g,f)=>(g.add(f),g),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},E=L.deepClone(P),c=!C;for(const g of p.added.values())g!==O.SYNC_SERVICE_URL_TYPE&&c&&y.added.has(g)||(E[g]=k[g]);for(const g of p.updated.values())E[g]=k[g];for(const g of p.removed.values())b.unregistered.includes(g)||delete E[g];for(const g of y.added.values()){const f=P[g];if(b.machine.includes(g)){I.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(C&&p.added.has(g))continue;const S=k[g];S&&S.value===f.value||g===O.SYNC_SERVICE_URL_TYPE&&c&&p.added.has(g)||(S?d.updated[g]=f:d.added[g]=f)}for(const g of y.updated.values()){const f=P[g];if(b.machine.includes(g)){I.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(p.updated.has(g)||p.removed.has(g))continue;const S=k[g];S&&S.value===f.value||(d.updated[g]=f)}for(const g of y.removed.values()){if(b.machine.includes(g)){I.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}p.updated.has(g)||p.removed.has(g)||d.removed.push(g)}const u=D(P,E);return{local:d,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:E}}}e.merge=l;function D(k,P){const C=Object.keys(k),b=Object.keys(P),I=b.filter(p=>C.indexOf(p)===-1).reduce((p,d)=>(p.add(d),p),new Set),w=C.filter(p=>b.indexOf(p)===-1).reduce((p,d)=>(p.add(d),p),new Set),y=new Set;for(const p of C){if(w.has(p))continue;const d=k[p],E=P[p];L.equals(d,E)||y.add(p)}return{added:I,removed:w,updated:y}}}),define(re[261],oe([0,1,21,35,82,42,32,59,24]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function b(o,h,m){let v=[];m?v=w(m):v=I(h);const A=[],T=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const M of v)M.startsWith("-")?T.push(M.substring(1)):A.push(M);return(0,L.distinct)([...o,...A].filter(M=>T.indexOf(M)===-1))}e.getIgnoredSettings=b;function I(o){let h=o.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=o.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:o.getValue("settingsSync.ignoredSettings")||[]}function w(o){const h=(0,O.parse)(o);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function y(o,h){const m=(0,O.parse)(o)||{};let v="{}";for(const A of Object.keys(m)){const T=(0,l.setProperty)(v,[A],m[A],h);v=(0,l.applyEdits)(v,T)}return v}e.removeComments=y;function p(o,h,m,v){if(m.length){const A=a(h),T=(0,O.parse)(h)||{},M=(0,O.parse)(o);if(!M)return o;const z=[];for(const H of m){const J=T[H],W=M[H];J===void 0?o=P.edit(o,[H],void 0,v):W!==void 0?o=P.edit(o,[H],J,v):z.push(i(H,A))}z.sort((H,J)=>H.startOffset-J.startOffset),z.forEach(H=>o=g(H.setting.key,h,o,v))}return o}e.updateIgnoredSettings=p;function d(o,h,m,v,A,T){const M=p(o,h,v,T),z=m!==M,H=m!==h;if(!z&&!H)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!H)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(H&&!z)return{conflictsSettings:[],localContent:p(h,o,v,T),remoteContent:null,hasConflicts:!1};if(m===null&&c(o)){const $=E(o,h,v)?null:p(h,o,v,T);return{conflictsSettings:[],localContent:$,remoteContent:null,hasConflicts:!1}}let J=o,W=h;const N=(0,O.parse)(o),j=(0,O.parse)(h),q=m?(0,O.parse)(m):null,x=v.reduce(($,G)=>($.add(G),$),new Set),Y=u(N,j,x),F=u(q,N,x),Z=u(q,j,x),te=new Map,se=new Set,ae=$=>{se.add($);const G=A.filter(({key:ee})=>ee===$)[0];G?(J=P.edit(J,[$],G.value,T),W=P.edit(W,[$],G.value,T)):te.set($,{key:$,localValue:N[$],remoteValue:j[$]})};for(const $ of F.removed.values())Z.updated.has($)?ae($):W=P.edit(W,[$],void 0,T);for(const $ of Z.removed.values())se.has($)||(F.updated.has($)?ae($):J=P.edit(J,[$],void 0,T));for(const $ of F.updated.values())se.has($)||(Z.updated.has($)?Y.updated.has($)&&ae($):W=P.edit(W,[$],N[$],T));for(const $ of Z.updated.values())se.has($)||(F.updated.has($)?Y.updated.has($)&&ae($):J=P.edit(J,[$],j[$],T));for(const $ of F.added.values())se.has($)||(Z.added.has($)?Y.updated.has($)&&ae($):W=g($,J,W,T));for(const $ of Z.added.values())se.has($)||(F.added.has($)?Y.updated.has($)&&ae($):J=g($,W,J,T));const V=te.size>0||!E(J,W,v),B=V||!E(J,o,[]),U=V||!E(W,h,[]);return{localContent:B?J:null,remoteContent:U?W:null,conflictsSettings:[...te.values()],hasConflicts:V}}e.merge=d;function E(o,h,m){if(o===h)return!0;const v=(0,O.parse)(o),A=(0,O.parse)(h),T=m.reduce((H,J)=>(H.add(J),H),new Set),M=a(o).filter(H=>!(H.setting&&T.has(H.setting.key))),z=a(h).filter(H=>!(H.setting&&T.has(H.setting.key)));if(M.length!==z.length)return!1;for(let H=0;H<M.length;H++){const J=M[H],W=z[H];if(J.setting&&W.setting){if(J.setting.key!==W.setting.key||!k.equals(v[J.setting.key],A[J.setting.key]))return!1}else if(!J.setting&&!W.setting){if(J.value!==W.value)return!1}else return!1}return!0}function c(o){return o?a(o).length===0:!0}e.isEmpty=c;function u(o,h,m){const v=o?Object.keys(o).filter(H=>!m.has(H)):[],A=Object.keys(h).filter(H=>!m.has(H)),T=A.filter(H=>v.indexOf(H)===-1).reduce((H,J)=>(H.add(J),H),new Set),M=v.filter(H=>A.indexOf(H)===-1).reduce((H,J)=>(H.add(J),H),new Set),z=new Set;if(o)for(const H of v){if(M.has(H))continue;const J=o[H],W=h[H];k.equals(J,W)||z.add(H)}return{added:T,removed:M,updated:z}}function g(o,h,m,v){const A=(0,O.parse)(h),T=a(h),M=a(m),z=f(o,T,M);return S(m,o,A[o],z,M,v)}e.addSetting=g;function f(o,h,m){const v=h.findIndex(T=>T.setting?.key===o),A=h[v-1];if(A){if(A.setting){const M=i(A.setting.key,m);if(M)return{index:m.indexOf(M),insertAfter:!0}}else{const M=r(v,h);if(M){const z=i(M.setting.key,m);if(z){const H=t(m.indexOf(z),m),J=n(h,M,h[v]);if(H){const W=n(m,z,H),N=s(J,W);return N?{index:m.indexOf(N),insertAfter:!0}:{index:m.indexOf(H),insertAfter:!1}}else{const W=n(m,z,m[m.length-1]),N=s(J,W);return N?{index:m.indexOf(N),insertAfter:!0}:{index:m.length-1,insertAfter:!0}}}}}const T=h[v+1];if(T)if(T.setting){const M=i(T.setting.key,m);if(M)return{index:m.indexOf(M),insertAfter:!1}}else{const M=t(v,h);if(M){const z=i(M.setting.key,m);if(z){const H=r(m.indexOf(z),m),J=n(h,h[v],M);if(H){const W=n(m,H,z),N=s(J.reverse(),W.reverse());return N?{index:m.indexOf(N),insertAfter:!1}:{index:m.indexOf(H),insertAfter:!0}}else{const W=n(m,m[0],z),N=s(J.reverse(),W.reverse());return N?{index:m.indexOf(N),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:m.length-1,insertAfter:!0}}function S(o,h,m,v,A,T){let M;return v.index===-1?M=(0,l.setProperty)(o,[h],m,T):M=R(o,h,m,v,A,T).map(z=>(0,l.withFormatting)(o,z,T)[0]),(0,l.applyEdits)(o,M)}function R(o,h,m,v,A,T){const M=`${JSON.stringify(h)}: ${JSON.stringify(m)}`,z=(0,D.getEOL)(T,o),H=A[v.index];if(v.insertAfter){const J=[];if(H.setting)J.push({offset:H.endOffset,length:0,content:","+M});else{const W=t(v.index,A),N=r(v.index,A),j=N?.setting?.commaOffset;N&&j===void 0&&J.push({offset:N.endOffset,length:0,content:","});const q=j!==void 0&&j>H.endOffset;J.push({offset:q?j+1:H.endOffset,length:0,content:W?z+M+",":z+M})}return J}else{if(H.setting)return[{offset:H.startOffset,length:0,content:M+","}];const J=(A[v.index-1]&&!A[v.index-1].setting?z:"")+M+(t(v.index,A)?",":"")+z;return[{offset:H.startOffset,length:0,content:J}]}}function i(o,h){return h.filter(m=>m.setting?.key===o)[0]}function r(o,h){for(let m=o-1;m>=0;m--)if(h[m].setting)return h[m]}function t(o,h){for(let m=o+1;m<h.length;m++)if(h[m].setting)return h[m]}function n(o,h,m){const v=o.indexOf(h),A=o.indexOf(m);return o.filter((T,M)=>v<M&&M<A)}function s(o,h){if(o.length&&h.length){let m=0;for(;m<h.length&&m<o.length;m++)if(o[m].value!==h[m].value)return h[m-1];return h[m-1]}}function a(o){const h=[];let m=-1,v,A;const T={onObjectBegin:M=>{m++},onObjectProperty:(M,z,H)=>{m===0&&(v=z,A=M)},onObjectEnd:(M,z)=>{m--,m===0&&h.push({startOffset:v,endOffset:M+z,value:o.substring(v,M+z),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(M,z)=>{m++},onArrayEnd:(M,z)=>{m--,m===0&&h.push({startOffset:v,endOffset:M+z,value:o.substring(v,M+z),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(M,z,H)=>{m===0&&h.push({startOffset:v,endOffset:z+H,value:o.substring(v,z+H),setting:{key:A,commaOffset:void 0}})},onSeparator:(M,z,H)=>{if(m===0&&M===","){let J=h.length-1;for(;J>=0&&!h[J].setting;J--);const W=h[J];W&&h.splice(J,1,{startOffset:W.startOffset,endOffset:W.endOffset,value:W.value,setting:{key:W.setting.key,commaOffset:z}})}},onComment:(M,z)=>{m===0&&h.push({startOffset:M,endOffset:M+z,value:o.substring(M,M+z)})}};return(0,O.visit)(o,T),h}}),define(re[76],oe([0,1,3,2,5,24]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,l.createDecorator)("IUserDataSyncAccountService");let k=class extends O.Disposable{get account(){return this.a}constructor(C,b){super(),this.g=C,this.h=b,this.b=this.B(new L.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new L.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(C.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(C.onTokenSucceed(()=>this.f=!1))}async updateAccount(C){(C&&this.a?C.token!==this.a.token||C.authenticationProviderId!==this.a.authenticationProviderId:C!==this.a)&&(this.a=C,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(C))}};k=ye([X(0,D.IUserDataSyncStoreService),X(1,D.IUserDataSyncLogService)],k),e.UserDataSyncAccountService=k}),define(re[262],oe([0,1,2,11]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class l{constructor(y){this.a=y}listen(y,p){switch(p){case"onError":return this.a.onError}throw new Error(`Event not found: ${p}`)}call(y,p,d){switch(p){case"triggerSync":return this.a.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=l;class D{constructor(y){this.a=y}listen(y,p){throw new Error(`Event not found: ${p}`)}call(y,p,d){switch(p){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(O.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=D;class k{constructor(y){this.a=y}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(y){return this.a.call("resolveUserKeybindings",[y])}async resolveFormattingOptions(y){return this.a.call("resolveFormattingOptions",[y])}}e.UserDataSyncUtilServiceClient=k;class P{constructor(y){this.a=y}listen(y,p){switch(p){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${p}`)}async call(y,p,d){switch(p){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(d[0],d[1]);case"setEnablements":return this.a.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class C{constructor(y){this.a=y}listen(y,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(y,p,d){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class b{constructor(y){this.a=y}listen(y,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(y,p,d){switch(p){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class I extends L.Disposable{constructor(y){super(),this.a=y,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(y){return this.a.call("switch",[y])}async getPreviousUserDataSyncStore(){const y=await this.a.call("getPreviousUserDataSyncStore");return this.b(y)}b(y){return{url:O.URI.revive(y.url),type:y.type,defaultUrl:O.URI.revive(y.defaultUrl),insidersUrl:O.URI.revive(y.insidersUrl),stableUrl:O.URI.revive(y.stableUrl),canSwitch:y.canSwitch,authenticationProviders:y.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(re[263],oe([0,1,185,8,24]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends O.AbstractLogger{constructor(P){super(),this.g=this.B(P.createLogger(l.USER_DATA_SYNC_LOG_ID,{name:(0,L.localize)(0,null)}))}trace(P,...C){this.g.trace(P,...C)}debug(P,...C){this.g.debug(P,...C)}info(P,...C){this.g.info(P,...C)}warn(P,...C){this.g.warn(P,...C)}error(P,...C){this.g.error(P,...C)}flush(){this.g.flush()}};D=ye([X(0,O.ILoggerService)],D),e.UserDataSyncLogService=D}),define(re[264],oe([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(re[265],oe([0,1,6,3,2]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class D extends l.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:C,getActiveWindowId:b}){super(),this.a=this.B(new l.DisposableStore),O.Event.latch(O.Event.any(P,C))(this.f,this,this.a),this.b=(0,L.createCancelablePromise)(()=>b()),(async()=>{try{const w=await this.b;this.c=typeof this.c=="number"?this.c:w}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=D}),define(re[119],oe([0,1,188,13,49,23,11,5,22]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function b(n){const s=n;return typeof s?.id=="string"&&k.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=b;function I(n){return typeof n?.id=="string"&&!b(n)&&!y(n)}e.isEmptyWorkspaceIdentifier=I,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,O.basename)(n)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const a=n;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.toWorkspaceIdentifier=w;function y(n){const s=n;return typeof s?.id=="string"&&k.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=y;function p(n){const s=n;if(s?.uri)return{id:s.id,uri:k.URI.revive(s.uri)};const a=n;if(a?.configPath)return{id:a.id,configPath:k.URI.revive(a.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=p;var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d=e.WorkbenchState||(e.WorkbenchState={}));function E(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=E;function c(n){const s=n;return!!(s&&typeof s=="object"&&k.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=c;class u{constructor(s,a,o,h,m){this.h=s,this.j=o,this.k=h,this.l=m,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class g{constructor(s,a){this.raw=a,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,D.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function f(n){return new g({uri:n,index:0,name:(0,D.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=f,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,L.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(n,s){return D.extUriBiasedIgnorePathCase.isEqualOrParent(n,s.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function R(n){let s;return k.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===C.Schemas.tmp}e.isTemporaryWorkspace=R,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function r(n,s){return!S(n,s)&&!R(n)}e.isSavedWorkspace=r;function t(n){return(typeof n=="string"?(0,O.extname)(n):(0,D.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(re[18],oe([0,1,64,3,2,23,11,179,15,14,5,8,119,37,30,6,31,27,12]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function f(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&k.URI.isUri(n.location)&&k.URI.isUri(n.globalStorageHome)&&k.URI.isUri(n.settingsResource)&&k.URI.isUri(n.keybindingsResource)&&k.URI.isUri(n.tasksResource)&&k.URI.isUri(n.snippetsHome)&&k.URI.isUri(n.extensionsResource))}e.isUserDataProfile=f,e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function S(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:k.URI.revive(t.location).with({scheme:n}),globalStorageHome:k.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:k.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:k.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:k.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:k.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:k.URI.revive(t.extensionsResource)?.with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=S;function R(t,n,s,a){return{id:t,name:n,location:s,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,D.joinPath)(s,"globalStorage"),settingsResource:(0,D.joinPath)(s,"settings.json"),keybindingsResource:(0,D.joinPath)(s,"keybindings.json"),tasksResource:(0,D.joinPath)(s,"tasks.json"),snippetsHome:(0,D.joinPath)(s,"snippets"),extensionsResource:(0,D.joinPath)(s,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=R;let i=class extends l.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,s,a,o){super(),this.m=n,this.n=s,this.r=a,this.s=o,this.f=!0,this.g=this.B(new O.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new O.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new O.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new O.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new p.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,D.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)try{for(const h of this.I()){if(!h.name||!(0,g.isString)(h.name)||!h.location){this.s.warn("Skipping the invalid stored profile",h.location||h.name);continue}n.push(R((0,D.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}}catch(h){this.s.error(h)}const s=new p.ResourceMap,a=new Map,o=this.v();if(n.unshift({...o,extensionsResource:this.N()??o.extensionsResource,isDefault:!0}),n.length)try{const h=this.L();if(h.workspaces)for(const[m,v]of Object.entries(h.workspaces)){const A=k.URI.parse(m),T=n.find(M=>M.id===v);T&&s.set(A,T)}if(h.emptyWindows)for(const[m,v]of Object.entries(h.emptyWindows)){const A=n.find(T=>T.id===v);A&&a.set(m,A)}}catch(h){this.s.error(h)}this.t={profiles:n,workspaces:s,emptyWindows:a}}return this.t}v(){return R("__default__profile__",(0,P.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(n){const s="Temp",a=new RegExp(`${(0,u.escapeRegExpCharacters)(s)}\\s(\\d+)`);let o=0;for(const m of this.profiles){const v=a.exec(m.name),A=v?parseInt(v[1]):0;o=A>o?A:o}const h=`${s} ${o+1}`;return this.createProfile((0,L.hash)((0,c.generateUuid)()).toString(16),h,{transient:!0},n)}async createNamedProfile(n,s,a){return this.createProfile((0,L.hash)((0,c.generateUuid)()).toString(16),n,s,a)}async createProfile(n,s,a,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.w(n,s,a);return o&&await this.setProfileForWorkspace(o,h),h}async w(n,s,a){if(!(0,g.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.k.get(s);return o||(o=(async()=>{try{const h=this.profiles.find(A=>A.name===s||A.id===n);if(h)return h;const m=R(n,s,(0,D.joinPath)(this.profilesHome,n),a);await this.n.createFolder(m.location);const v=[];return this.h.fire({profile:m,join(A){v.push(A)}}),await E.Promises.settled(v),this.C([m],[],[]),m}finally{this.k.delete(s)}})(),this.k.set(s,o)),o}async updateProfile(n,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(o=>o.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=R(a.id,s.name??a.name,a.location,{shortName:s.shortName??a.shortName,transient:s.transient??a.isTransient,useDefaultFlags:s.useDefaultFlags??a.useDefaultFlags}),this.C([],[],[a]),a}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(o=>o.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const a=[];this.i.fire({profile:s,join(o){a.push(o)}});try{await Promise.allSettled(a)}catch(o){this.s.error(o)}for(const o of[...this.u.emptyWindows.keys()])s.id===this.u.emptyWindows.get(o)?.id&&this.u.emptyWindows.delete(o);for(const o of[...this.u.workspaces.keys()])s.id===this.u.workspaces.get(o)?.id&&this.u.workspaces.delete(o);this.G(),this.C([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(o){this.s.error(o)}}async setProfileForWorkspace(n,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(o=>o.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);this.F(n,a)}unsetWorkspace(n,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(n,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(a=>!this.r.extUri.isEqual(a.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(s=>!this.z(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.y(n);return k.URI.isUri(s)?this.l.workspaces.get(s)??this.u.workspaces.get(s):this.l.emptyWindows.get(s)??this.u.emptyWindows.get(s)}y(n){return(0,y.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,y.isWorkspaceIdentifier)(n)?n.configPath:n.id}z(n){return!!([...this.l.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.l.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.u.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.u.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,n.location)))}C(n,s,a){const o=[...this.profiles,...n],h=[];this.l.profiles=[];for(let m of o)m.isDefault||s.some(v=>m.id===v.id)||(m=a.find(v=>m.id===v.id)??m,m.isTransient?this.l.profiles.push(m):h.push({location:m.location,name:m.name,shortName:m.shortName,useDefaultFlags:m.useDefaultFlags}));this.J(h),this.t=void 0,this.D(n,s,a)}D(n,s,a){this.g.fire({added:n,removed:s,updated:a,all:this.profiles})}F(n,s,a){a=s?.isTransient?!0:a,a||this.F(n,void 0,!0);const o=this.y(n),h=a?this.l:this.u;k.URI.isUri(o)?(h.workspaces.delete(o),s&&h.workspaces.set(o,s)):(h.emptyWindows.delete(o),s&&h.emptyWindows.set(o,s)),a||this.G()}G(){const n={};for(const[a,o]of this.u.workspaces.entries())n[a.toString()]=o.id;const s={};for(const[a,o]of this.u.emptyWindows.entries())s[a.toString()]=o.id;this.M({workspaces:n,emptyWindows:s}),this.t=void 0}H(n){const s={},a=this.v();if(n.workspaces)for(const[h,m]of Object.entries(n.workspaces)){const v=k.URI.parse(m);s[h]=this.r.extUri.isEqual(v,a.location)?a.id:this.r.extUri.basename(v)}const o={};if(n.emptyWindows)for(const[h,m]of Object.entries(n.emptyWindows)){const v=k.URI.parse(m);o[h]=this.r.extUri.isEqual(v,a.location)?a.id:this.r.extUri.basename(v)}return{workspaces:s,emptyWindows:o}}I(){return[]}J(n){throw new Error("not implemented")}L(){return{}}M(n){throw new Error("not implemented")}N(){}};i.b="userDataProfiles",i.c="profileAssociations",i=ye([X(0,C.IEnvironmentService),X(1,b.IFileService),X(2,d.IUriIdentityService),X(3,w.ILogService)],i),e.UserDataProfilesService=i;class r extends i{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(n){this.a=n}L(){return this.Q}M(n){this.Q=n}}e.InMemoryUserDataProfilesService=r}),define(re[266],oe([0,1,6,2,18]),function(_,e,L,O,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let D=class extends O.Disposable{constructor(P){super(),this.B(new L.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};D=ye([X(0,l.IUserDataProfilesService)],D),e.UserDataProfilesCleaner=D}),define(re[267],oe([0,1,21,6,25,9,3,2,4,11,158,29,33,46,8,26,19,18]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var g;(function(t){t.Verified="Verified",t.Unverified="Unverified",t.UnknownError="UnknownError"})(g=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let f=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,s,a,o,h){super(),this.t=n,this.u=s,this.v=a,this.w=o,this.y=h,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new k.Emitter),this.m=this.B(new k.Emitter),this.n=this.B(new k.Emitter),this.p=this.B(new k.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:m})=>m.cancel()),this.k.forEach(m=>m.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const s=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,w.isTargetPlatformCompatible)(a,n.allTargetPlatforms,s))}async installFromGallery(n,s={}){try{if(!this.t.isEnabled())throw new w.ExtensionManagementError(I.localize(0,null),w.ExtensionManagementErrorCode.Internal);const a=await this.G(n,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.z(a.manifest,a.extension,s)}catch(a){throw i(this.u,"extensionGallery:install",{extensionData:(0,y.getGalleryExtensionTelemetryData)(n),error:a}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(a),R(a)}}async uninstall(n,s={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,s)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,s,a){const o={...a,installOnlyNewlyAddedFromExtensionPack:b.URI.isUri(s)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,p.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},h=z=>`${y.ExtensionKey.create(z).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!b.URI.isUri(s)){const z=this.j.get(h(s));if(z)return this.v.info("Extensions is already requested to install",s.identifier.id),z.task.waitUntilTaskIsFinished()}const m=[],v=[],A=[],T=this.Q(n,s,o);b.URI.isUri(s)||this.j.set(h(s),{task:T,waitingTasks:[]}),this.l.fire({identifier:T.identifier,source:s,profileLocation:o.profileLocation}),this.v.info("Installing extension:",T.identifier.id),m.push({task:T,manifest:n});let M=!1;try{if(o.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",T.identifier.id);else try{const H=await this.F(T.identifier,n,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),J=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:W,manifest:N}of(0,L.distinct)(H,({gallery:j})=>j.identifier.id)){M=M||!!N.extensionDependencies?.some(x=>(0,y.areSameExtensions)({id:x},T.identifier));const j=h(W),q=this.j.get(j);if(q){if(this.C(T,q.task)){const x=q.task.identifier;this.v.info("Waiting for already requested installing extension",x.id,T.identifier.id),q.waitingTasks.push(T),v.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,Y=>Y.some(F=>(0,y.areSameExtensions)(F.identifier,x)))).then(Y=>{if(this.v.info("Finished waiting for already requested installing extension",x.id,T.identifier.id),!Y.find(Z=>(0,y.areSameExtensions)(Z.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else if(!J.some(({identifier:x})=>(0,y.areSameExtensions)(x,W.identifier))){const x=this.Q(N,W,{...o,donotIncludePackAndDependencies:!0});this.j.set(j,{task:x,waitingTasks:[T]}),this.l.fire({identifier:x.identifier,source:W,profileLocation:o.profileLocation}),this.v.info("Installing extension:",x.identifier.id,T.identifier.id),m.push({task:x,manifest:N})}}}catch(H){if(b.URI.isUri(T.source))(0,L.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",T.identifier.id,H.message),(0,L.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",T.identifier.id,H.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",T.identifier.id),H}const z=m.reduce((H,{task:J,manifest:W})=>(H.set(J.identifier.id.toLowerCase(),{task:J,manifest:W}),H),new Map);for(;z.size;){let H;const J=[...z.values()].filter(({manifest:W})=>!W.extensionDependencies?.some(N=>z.has(N.toLowerCase())));J.length?H=z.size===1?J:J.filter(({task:W})=>!(W===T&&!M)):(this.v.info("Found extensions with circular dependencies",J.map(({task:W})=>W.identifier.id)),H=[...z.values()]),await this.D(H.map(async({task:W})=>{const N=new Date().getTime();try{const j=await W.run();if(await this.D(this.s.map(q=>q.postInstall(j,W.source,o,l.CancellationToken.None))),!b.URI.isUri(W.source)){const q=W.operation===3,x=q?void 0:(new Date().getTime()-W.source.lastUpdated)/1e3;if(i(this.u,q?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,y.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-N,durationSinceUpdate:x}),C.isWeb&&W.operation!==3)try{await this.t.reportStatistic(j.manifest.publisher,j.manifest.name,j.manifest.version,"install")}catch{}}A.push({local:j,identifier:W.identifier,operation:W.operation,source:W.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:j.isApplicationScoped})}catch(j){throw b.URI.isUri(W.source)||i(this.u,W.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,y.getGalleryExtensionTelemetryData)(W.source),verificationStatus:W.verificationStatus,duration:new Date().getTime()-N,error:j}),this.v.error("Error while installing the extension:",W.identifier.id),j}finally{z.delete(W.identifier.id.toLowerCase())}}))}return v.length&&await this.D(v),A.forEach(({identifier:H})=>this.v.info("Extension installed successfully:",H.id)),this.m.fire(A),A.filter(({identifier:H})=>(0,y.areSameExtensions)(H,T.identifier))[0].local}catch(z){if(m.forEach(({task:H})=>H.cancel()),A.length)try{const H=await Promise.allSettled(A.map(({local:J})=>this.R(J,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let J=0;J<H.length;J++){const W=H[J],{identifier:N}=A[J];W.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",N.id):this.v.warn("Rollback: Error while uninstalling extension",N.id,(0,D.getErrorMessage)(W.reason))}}catch(H){this.v.warn("Error while rolling back extensions",(0,D.getErrorMessage)(H),A.map(({identifier:J})=>J.id))}throw this.m.fire(m.map(({task:H})=>({identifier:H.identifier,operation:2,source:H.source,context:o.context,profileLocation:o.profileLocation}))),z}finally{for(const{task:z}of m)z.source&&!b.URI.isUri(z.source)&&this.j.delete(h(z.source))}}C(n,s){for(const[,{task:a,waitingTasks:o}]of this.j.entries())if(a===n&&(o.includes(s)||o.some(h=>this.C(h,s)))||a===s&&o[0]&&!this.C(n,o[0]))return!1;return!0}async D(n){const s=[],a=[],o=await Promise.allSettled(n);for(const h of o)h.status==="fulfilled"?s.push(h.value):a.push(h.reason);if(a.length)throw S(a);return s}async F(n,s,a,o,h){if(!this.t.isEnabled())return[];const m=await this.getInstalled(void 0,h),v=[],A=[],T=async(M,z)=>{v.push(M);const H=z.extensionDependencies||[],J=[...H];if(z.extensionPack){const W=a?m.find(N=>(0,y.areSameExtensions)(N.identifier,M)):void 0;for(const N of z.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(j=>(0,y.areSameExtensions)({id:j},{id:N}))||J.every(j=>!(0,y.areSameExtensions)({id:j},{id:N}))&&J.push(N)}if(J.length){const W=J.filter(N=>v.every(j=>!(0,y.areSameExtensions)(j,{id:N})));if(W.length){const N=await this.t.getExtensions(W.map(j=>({id:j,preRelease:o})),l.CancellationToken.None);for(const j of N){if(v.find(Y=>(0,y.areSameExtensions)(Y,j.identifier)))continue;const q=H.some(Y=>(0,y.areSameExtensions)({id:Y},j.identifier));let x;try{x=await this.G(j,!1,o)}catch(Y){if(Y instanceof w.ExtensionManagementError&&Y.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!q){this.v.info("Skipping the packed extension as it cannot be installed",j.identifier.id);continue}else throw Y}A.push({gallery:x.extension,manifest:x.manifest}),await T(x.extension.identifier,x.manifest)}}}};return await T(n,s),A}async G(n,s,a){if((await this.getExtensionsControlManifest()).malicious.some(v=>(0,y.areSameExtensions)(n.identifier,v)))throw new w.ExtensionManagementError(I.localize(1,null,n.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const v=await this.getTargetPlatform();throw new w.ExtensionManagementError(I.localize(2,null,n.identifier.id,this.w.nameLong,(0,w.TargetPlatformToString)(v)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const h=await this.H(n,s,a);if(h){if(a&&!s&&n.hasPreReleaseVersion&&!h.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(I.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],l.CancellationToken.None))[0]?new w.ExtensionManagementError(I.localize(4,null,n.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(I.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),w.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",h.identifier.id);const m=await this.t.getManifest(h,l.CancellationToken.None);if(m===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(m.version!==h.version)throw new w.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:h,manifest:m}}async H(n,s,a){const o=await this.getTargetPlatform();let h=null;return!s&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(h=(await this.t.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:o,compatible:!0},l.CancellationToken.None))[0]||null),!h&&await this.t.isExtensionCompatible(n,a,o)&&(h=n),h||(s?h=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:o,compatible:!0},l.CancellationToken.None))[0]||null:h=await this.t.getCompatibleExtension(n,a,o)),h}async I(n,s){const a={...s,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},o=M=>`${M.id.toLowerCase()}${a.versionOnly?`-${n.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,h=this.k.get(o(n.identifier));if(h)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),h.waitUntilTaskIsFinished();const m=M=>{const z=this.R(M,a);return this.k.set(o(z.extension.identifier),z),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.n.fire({identifier:M.identifier,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped}),z},v=(M,z)=>{z?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString(),z.message):this.v.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,z.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),i(this.u,"extensionGallery:uninstall",{extensionData:(0,y.getLocalExtensionTelemetryData)(M),error:z}),this.p.fire({identifier:M.identifier,error:z?.code,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped})},A=[],T=[];try{A.push(m(n));const M=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const z=this.M(n,M);for(const H of z)this.k.has(o(H.identifier))?this.v.info("Extensions is already requested to uninstall",H.identifier.id):A.push(m(H))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(A.map(z=>z.extension),M,n),await this.D(A.map(async z=>{try{if(await z.run(),await this.D(this.s.map(H=>H.postUninstall(z.extension,a,l.CancellationToken.None))),z.extension.identifier.uuid)try{await this.t.reportStatistic(z.extension.manifest.publisher,z.extension.manifest.name,z.extension.manifest.version,"uninstall")}catch{}v(z.extension)}catch(H){const J=H instanceof w.ExtensionManagementError?H:new w.ExtensionManagementError((0,D.getErrorMessage)(H),w.ExtensionManagementErrorCode.Internal);throw v(z.extension,J),J}finally{T.push(z)}}))}catch(M){const z=M instanceof w.ExtensionManagementError?M:new w.ExtensionManagementError((0,D.getErrorMessage)(M),w.ExtensionManagementErrorCode.Internal);for(const H of A){try{H.cancel()}catch{}T.includes(H)||v(H.extension,z)}throw z}finally{for(const M of A)this.k.delete(o(M.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}J(n,s,a){for(const o of n){const h=this.N(o,s);if(h.length){const m=h.filter(v=>!n.some(A=>(0,y.areSameExtensions)(A.identifier,v.identifier)));if(m.length)throw new Error(this.L(o,m,a))}}}L(n,s,a){return a===n?s.length===1?I.localize(6,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?I.localize(7,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):I.localize(8,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?I.localize(9,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?I.localize(10,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):I.localize(11,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}M(n,s,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const o=n.manifest.extensionPack?n.manifest.extensionPack:[];if(o.length){const h=s.filter(v=>!v.isBuiltin&&o.some(A=>(0,y.areSameExtensions)({id:A},v.identifier))),m=[];for(const v of h)m.push(...this.M(v,s,a));return[...h,...m]}return[]}N(n,s){return s.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(o=>(0,y.areSameExtensions)({id:o},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};f=ye([X(0,w.IExtensionGalleryService),X(1,c.ITelemetryService),X(2,d.ILogService),X(3,E.IProductService),X(4,u.IUserDataProfilesService)],f),e.AbstractExtensionManagementService=f;function S(t){const n=Array.isArray(t)?t:[t];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=S;function R(t){if(t instanceof w.ExtensionManagementError)return t;const n=new w.ExtensionManagementError(t.message,w.ExtensionManagementErrorCode.Internal);return n.stack=t.stack,n}function i(t,n,{extensionData:s,verificationStatus:a,duration:o,error:h,durationSinceUpdate:m}){let v,A;h&&(h instanceof w.ExtensionManagementError?(v=h.code,h.code===w.ExtensionManagementErrorCode.Signature&&(A=h.message)):v=w.ExtensionManagementErrorCode.Internal),t.publicLog(n,{...s,verificationStatus:a,success:!h,duration:o,errorcode:v,errorcodeDetail:A,durationSinceUpdate:m})}class r{constructor(){this.d=new O.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.createCancelablePromise)(n=>new Promise((s,a)=>{const o=n.onCancellationRequested(()=>{o.dispose(),a(new D.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=r}),define(re[51],oe([0,1,6,16,2,3,37,11,29,33,14,5,8,18,30,12,9,19]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class f extends Error{constructor(t,n){super(t),this.code=n}}e.ExtensionsProfileScanningError=f,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let S=class extends l.Disposable{constructor(t,n,s,a,o,h){super(),this.i=t,this.j=n,this.k=s,this.l=a,this.m=o,this.n=h,this.b=this.B(new D.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new D.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new k.ResourceMap}scanProfileExtensions(t,n){return this.p(t,void 0,n)}async addExtensionsToProfile(t,n){const s=[],a=[];try{return await this.p(n,o=>{const h=[];for(const m of o)t.some(([v])=>(0,b.areSameExtensions)(v.identifier,m.identifier)&&v.manifest.version!==m.version)?s.push(m):h.push(m);for(const[m,v]of t)if(!h.some(A=>(0,b.areSameExtensions)(A.identifier,m.identifier)&&A.version===m.manifest.version)){const A={identifier:m.identifier,version:m.manifest.version,location:m.location,metadata:v};a.push(A),h.push(A)}return a.length&&this.b.fire({extensions:a,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),h}),a.length&&this.c.fire({extensions:a,profileLocation:n}),s.length&&this.g.fire({extensions:s,profileLocation:n}),a}catch(o){throw a.length&&this.c.fire({extensions:a,error:o,profileLocation:n}),s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async updateMetadata(t,n){const s=[];return await this.p(n,a=>{const o=[];for(const h of a){const m=t.find(([v])=>(0,b.areSameExtensions)(v.identifier,h.identifier)&&v.manifest.version===h.version);m&&(h.metadata={...h.metadata,...m[1]},s.push(h)),o.push(h)}return o}),s}async removeExtensionFromProfile(t,n){const s=[];this.f.fire({extensions:s,profileLocation:n});try{await this.p(n,a=>{const o=[];for(const h of a)(0,b.areSameExtensions)(h.identifier,t.identifier)?s.push(h):o.push(h);return s.length&&this.f.fire({extensions:s,profileLocation:n}),o}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(a){throw s.length&&this.g.fire({extensions:s,error:a,profileLocation:n}),a}}async p(t,n,s){return this.w(t).queue(async()=>{let a=[],o;try{const h=await this.j.readFile(t);o=JSON.parse(h.value.toString().trim()||"[]")}catch(h){if((0,I.toFileOperationResult)(h)!==1)throw h;if(this.l.extUri.isEqual(t,this.k.defaultProfile.extensionsResource)&&(o=await this.v()),!o&&s?.bailOutWhenFileNotFound)throw new f((0,c.getErrorMessage)(h),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.r(t);let h=!1;for(const m of o){R(m)||this.r(t);let v;if((0,E.isString)(m.relativeLocation)&&m.relativeLocation)v=this.t(m.relativeLocation);else if((0,E.isString)(m.location))v=this.t(m.location),h=!0,m.relativeLocation=m.location,m.location=v.toJSON();else{v=P.URI.revive(m.location);const A=this.s(v);A&&(h=!0,m.relativeLocation=A)}a.push({identifier:m.identifier,location:v,version:m.version,metadata:m.metadata})}h&&await this.j.writeFile(t,O.VSBuffer.fromString(JSON.stringify(o)))}if(n){a=n(a);const h=a.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),relativeLocation:this.s(m.location),metadata:m.metadata}));await this.j.writeFile(t,O.VSBuffer.fromString(JSON.stringify(h)))}return a})}r(t){const n=new f(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(t){return this.l.extUri.isEqual(this.l.extUri.dirname(t),this.i)?this.l.extUri.basename(t):void 0}t(t){return this.l.extUri.joinPath(this.i,t)}async v(){return this.u||(this.u=(async()=>{const t=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let s;try{s=(await this.j.readFile(t)).value.toString()}catch(o){if((0,I.toFileOperationResult)(o)===1)return;throw o}this.n.info("Migrating extensions from old default profile location",t.toString());let a;try{const o=JSON.parse(s);Array.isArray(o)&&o.every(h=>R(h))?a=o:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",o)}catch(o){this.n.error(o)}if(a)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",t.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(o){if((0,I.toFileOperationResult)(o)===3)this.n.info("Migration from old default profile location to new location is done by another window",t.toString(),this.k.defaultProfile.extensionsResource.toString());else throw o}try{await this.j.del(t)}catch(o){(0,I.toFileOperationResult)(o)!==1&&this.n.error(o)}try{await this.j.del(n)}catch(o){(0,I.toFileOperationResult)(o)!==1&&this.n.error(o)}return a})()),this.u}w(t){let n=this.h.get(t);return n||(n=new L.Queue,this.h.set(t,n)),n}};S=ye([X(1,I.IFileService),X(2,p.IUserDataProfilesService),X(3,d.IUriIdentityService),X(4,u.ITelemetryService),X(5,y.ILogService)],S),e.AbstractExtensionsProfileScannerService=S;function R(r){return(0,E.isObject)(r)&&(0,C.isIExtensionIdentifier)(r.identifier)&&(i(r.location)||(0,E.isString)(r.location)&&r.location)&&((0,E.isUndefined)(r.relativeLocation)||(0,E.isString)(r.relativeLocation))&&r.version&&(0,E.isString)(r.version)}function i(r){return r?(0,E.isString)(r.path)&&(0,E.isString)(r.scheme):!1}}),define(re[77],oe([0,1,21,6,32,16,9,35,140,2,22,13,4,23,54,89,12,11,162,15,33,46,67,14,5,8,26,3,90,51,18,30,195]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g,f,S,R,i,r,t,n,s,a,o,h,m,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var T;(function(j){function q(x,Y){if(x===Y)return!0;const F=Object.keys(x),Z=new Set;for(const te of Object.keys(Y))Z.add(te);if(F.length!==Z.size)return!1;for(const te of F){if(x[te]!==Y[te])return!1;Z.delete(te)}return Z.size===0}j.equals=q})(T=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let M=class extends b.Disposable{constructor(q,x,Y,F,Z,te,se,ae,V,B,U,$){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=x,this.l=Y,this.m=F,this.n=Z,this.p=te,this.r=se,this.s=ae,this.t=V,this.u=B,this.v=U,this.w=$,this.g=this.B(new a.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,p.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(J,(0,p.joinPath)(this.m,R.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(J,(0,p.joinPath)(this.m,R.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(H,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,S.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(q,x,Y){const[F,Z]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(x)]),te=Y?await this.scanExtensionsUnderDevelopment(q,[...F,...Z]):[];return this.F(F,Z,te,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const x=[];x.push(this.G(!!q.useCache,q.language)),x.push(this.H(q.language,!!q.checkControlFile));const[Y,F]=await Promise.all(x);return this.D([...Y,...F],0,q,!1)}async scanUserExtensions(q){const x=q.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",x);const Y=this.v.extUri.isEqual(q.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.J(x,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,Y),Z=q.useCache&&!F.devMode&&F.excludeObsolete?this.j:this.k;let te;try{te=await Z.scanExtensions(F)}catch(se){if(se instanceof h.ExtensionsProfileScanningError&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),te=await Z.scanExtensions(F);else throw se}return te=await this.D(te,1,q,!0),this.s.trace("Scanned user extensions:",te.length),te}async scanExtensionsUnderDevelopment(q,x){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const Y=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(F=>F.scheme===I.Schemas.file).map(async F=>{const Z=await this.J(F,!1,1,!0,q.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Z)).map(se=>(se.type=x.find(ae=>(0,S.areSameExtensions)(ae.identifier,se.identifier))?.type??se.type,this.k.validate(se,Z)))}))).flat();return this.D(Y,"development",q,!0)}return[]}async scanExistingExtension(q,x,Y){const F=await this.J(q,!1,x,!0,Y.language,!0,void 0),Z=await this.k.scanExtension(F);return!Z||!Y.includeInvalid&&!Z.isValid?null:Z}async scanOneOrMultipleExtensions(q,x,Y){const F=await this.J(q,!1,x,!0,Y.language,!0,void 0),Z=await this.k.scanOneOrMultipleExtensions(F);return this.D(Z,x,Y,!0)}async scanMetadata(q){const x=(0,p.joinPath)(q,"package.json"),Y=(await this.r.readFile(x)).value.toString();return JSON.parse(Y).__metadata}async updateMetadata(q,x){const Y=(0,p.joinPath)(q,"package.json"),F=(await this.r.readFile(Y)).value.toString(),Z=JSON.parse(F);x.isMachineScoped=x.isMachineScoped||void 0,x.isBuiltin=x.isBuiltin||void 0,Z.__metadata={...Z.__metadata,...x},await this.r.writeFile((0,p.joinPath)(q,"package.json"),D.VSBuffer.fromString(JSON.stringify(Z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof h.ExtensionsProfileScanningError&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw q}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.p.addExtensionsToProfile(q.map(x=>[x,x.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify([])))}catch(x){(0,r.toFileOperationResult)(x)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(x))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.s.error(q)}finally{this.z=void 0}})()),this.z}async D(q,x,Y,F){return Y.includeAllVersions||(q=this.F(x===0?q:void 0,x===1?q:void 0,x==="development"?q:void 0,await this.getTargetPlatform(),F)),Y.includeInvalid||(q=q.filter(Z=>Z.isValid)),q.sort((Z,te)=>{const se=w.basename(Z.location.fsPath),ae=w.basename(te.location.fsPath);return se<ae?-1:se>ae?1:0})}F(q,x,Y,F,Z){const te=(ae,V,B)=>{if(ae.isValid&&!V.isValid)return!1;if(ae.isValid===V.isValid){if(Z&&d.gt(ae.manifest.version,V.manifest.version))return this.s.debug(`Skipping extension ${V.location.path} with lower version ${V.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(d.eq(ae.manifest.version,V.manifest.version)){if(ae.type===0)return this.s.debug(`Skipping extension ${V.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===F)return this.s.debug(`Skipping extension ${V.location.path} from different target platform ${V.targetPlatform}`),!1}}return B?this.s.warn(`Overwriting user extension ${ae.location.path} with ${V.location.path}.`):this.s.debug(`Overwriting user extension ${ae.location.path} with ${V.location.path}.`),!0},se=new R.ExtensionIdentifierMap;return q?.forEach(ae=>{const V=se.get(ae.identifier.id);(!V||te(V,ae,!1))&&se.set(ae.identifier.id,ae)}),x?.forEach(ae=>{const V=se.get(ae.identifier.id);if(!V&&q&&ae.type===0){this.s.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!V||te(V,ae,!1))&&se.set(ae.identifier.id,ae)}),Y?.forEach(ae=>{const V=se.get(ae.identifier.id);(!V||te(V,ae,!0))&&se.set(ae.identifier.id,ae),se.set(ae.identifier.id,ae)}),[...se.values()]}async G(q,x){this.s.trace("Started scanning system extensions");const Y=await this.J(this.systemExtensionsLocation,!1,0,!0,x,!0,void 0),Z=await(q&&!Y.devMode?this.i:this.k).scanExtensions(Y);return this.s.trace("Scanned system extensions:",Z.length),Z}async H(q,x){const Y=this.t.isBuilt?[]:this.u.builtInExtensions;if(!Y?.length)return[];this.s.trace("Started scanning dev system extensions");const F=x?await this.I():{},Z=[],te=u.URI.file(w.normalize(w.join(I.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of Y){const V=F[ae.name]||"marketplace";switch(V){case"disabled":break;case"marketplace":Z.push((0,p.joinPath)(te,ae.name));break;default:Z.push(u.URI.file(V));break}}const se=await Promise.all(Z.map(async ae=>this.k.scanExtension(await this.J(ae,!1,0,!0,q,!0,void 0))));return this.s.trace("Scanned dev system extensions:",se.length),(0,L.coalesce)(se)}async I(){try{const q=await this.r.readFile(this.l);return JSON.parse(q.value.toString())}catch{return{}}}async J(q,x,Y,F,Z,te,se){const ae=await this.f(Z??y.language),V=await this.L(q),B=x&&!this.v.extUri.isEqual(q,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,U=B?await this.L(B):void 0;return new z(q,V,B,U,x,se,Y,F,te,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Z,ae)}async L(q){try{const x=await this.r.stat(q);if(typeof x.mtime=="number")return x.mtime}catch{}}};M=ye([X(4,m.IUserDataProfilesService),X(5,h.IExtensionsProfileScannerService),X(6,r.IFileService),X(7,n.ILogService),X(8,f.IEnvironmentService),X(9,s.IProductService),X(10,v.IUriIdentityService),X(11,t.IInstantiationService)],M),e.AbstractExtensionsScannerService=M;class z{constructor(q,x,Y,F,Z,te,se,ae,V,B,U,$,G,ee,K){this.location=q,this.mtime=x,this.applicationExtensionslocation=Y,this.applicationExtensionslocationMtime=F,this.profile=Z,this.profileScanOptions=te,this.type=se,this.excludeObsolete=ae,this.validate=V,this.productVersion=B,this.productDate=U,this.productCommit=$,this.devMode=G,this.language=ee,this.translations=K}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,x){return(0,p.isEqual)(q.location,x.location)&&q.mtime===x.mtime&&(0,p.isEqual)(q.applicationExtensionslocation,x.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===x.applicationExtensionslocationMtime&&q.profile===x.profile&&l.equals(q.profileScanOptions,x.profileScanOptions)&&q.type===x.type&&q.excludeObsolete===x.excludeObsolete&&q.validate===x.validate&&q.productVersion===x.productVersion&&q.productDate===x.productDate&&q.productCommit===x.productCommit&&q.devMode===x.devMode&&q.language===x.language&&T.equals(q.translations,x.translations)}}e.ExtensionScannerInput=z;let H=class extends b.Disposable{constructor(q,x,Y,F,Z){super(),this.f=q,this.g=x,this.h=Y,this.i=F,this.j=Z}async scanExtensions(q){const x=q.profile?await this.l(q):await this.k(q);let Y={};if(q.excludeObsolete&&q.type===1)try{const F=(await this.i.readFile(this.f)).value.toString();Y=JSON.parse(F)}catch{}return(0,c.isEmptyObject)(Y)?x:x.filter(F=>!Y[S.ExtensionKey.create(F).toString()])}async k(q){const x=await this.i.resolve(q.location);if(!x.children?.length)return[];const Y=await Promise.all(x.children.map(async F=>{if(!F.isDirectory||q.type===1&&(0,p.basename)(F.resource).indexOf(".")===0)return null;const Z=new z(F.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(Z)}));return(0,L.coalesce)(Y).sort((F,Z)=>F.location.path<Z.location.path?-1:1)}async l(q){let x=await this.m(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){x=x.filter(F=>!F.metadata?.isApplicationScoped);const Y=await this.m(q.applicationExtensionslocation,F=>!!F.metadata?.isApplicationScoped,q);x.push(...Y)}return x}async m(q,x,Y){const F=await this.g.scanProfileExtensions(q,Y.profileScanOptions);if(!F.length)return[];const Z=await Promise.all(F.map(async te=>{if(x(te)){const se=new z(te.location,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(se,te.metadata)}return null}));return(0,L.coalesce)(Z)}async scanOneOrMultipleExtensions(q){try{if(await this.i.exists((0,p.joinPath)(q.location,"package.json"))){const x=await this.scanExtension(q);return x?[x]:[]}else return await this.scanExtensions(q)}catch(x){return this.j.error(`Error scanning extensions at ${q.location.path}:`,(0,k.getErrorMessage)(x)),[]}}async scanExtension(q,x){try{let Y=await this.scanExtensionManifest(q.location);if(Y){Y.publisher||(Y.publisher=R.UNDEFINED_PUBLISHER),x=x??Y.__metadata,delete Y.__metadata;const F=(0,S.getGalleryExtensionId)(Y.publisher,Y.name),Z=x?.id?{id:F,uuid:x.id}:{id:F},te=x?.isSystem?0:q.type,se=te===0||!!x?.isBuiltin;Y=await this.n(q.location,Y,z.createNlsConfiguration(q));const ae={type:te,identifier:Z,manifest:Y,location:q.location,isBuiltin:se,targetPlatform:x?.targetPlatform??"undefined",metadata:x,isValid:!0,validations:[]};return q.validate?this.validate(ae,q):ae}}catch(Y){q.type!==0&&this.j.error(Y)}return null}validate(q,x){let Y=!0;const F=(0,i.validateExtensionManifest)(x.productVersion,x.productDate,x.location,q.manifest,q.isBuiltin);for(const[Z,te]of F)Z===E.default.Error&&(Y=!1,this.j.error(this.t(x.location,te)));return q.isValid=Y,q.validations=F,q}async scanExtensionManifest(q){const x=(0,p.joinPath)(q,"package.json");let Y;try{Y=(await this.i.readFile(x)).value.toString()}catch(Z){return(0,r.toFileOperationResult)(Z)!==1&&this.j.error(this.t(q,(0,g.localize)(0,null,x.path,Z.message))),null}let F;try{F=JSON.parse(Y)}catch{const te=[];(0,P.parse)(Y,te);for(const se of te)this.j.error(this.t(q,(0,g.localize)(1,null,x.path,se.offset,se.length,(0,C.getParseErrorMessage)(se.error))));return null}return(0,P.getNodeType)(F)!=="object"?(this.j.error(this.t(q,(0,g.localize)(2,null,x.path))),null):F}async n(q,x,Y){const F=await this.p(q,x,Y);if(F)try{const Z=[],te=await this.r(F.default,Z);if(Z.length>0)return Z.forEach(ae=>{this.j.error(this.t(q,(0,g.localize)(3,null,F.default?.path,(0,C.getParseErrorMessage)(ae.error))))}),x;if((0,P.getNodeType)(F)!=="object")return this.j.error(this.t(q,(0,g.localize)(4,null,F.default?.path))),x;const se=F.values||Object.create(null);return(0,A.localizeManifest)(x,se,te)}catch{}return x}async p(q,x,Y){const F=(0,p.joinPath)(q,"package.nls.json"),Z=(V,B)=>{B.forEach(U=>{this.j.error(this.t(q,(0,g.localize)(5,null,V?.path,(0,C.getParseErrorMessage)(U.error))))})},te=V=>{this.j.error(this.t(q,(0,g.localize)(6,null,V?.path)))},se=`${x.publisher}.${x.name}`,ae=Y.translations[se];if(ae)try{const V=u.URI.file(ae),B=(await this.i.readFile(V)).value.toString(),U=[],$=(0,P.parse)(B,U);return U.length>0?(Z(V,U),{values:void 0,default:F}):(0,P.getNodeType)($)!=="object"?(te(V),{values:void 0,default:F}):{values:$.contents?$.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.i.exists(F))return;let B;try{B=await this.s(q,Y)}catch{return}if(!B.localized)return{values:void 0,default:B.original};try{const U=(await this.i.readFile(B.localized)).value.toString(),$=[],G=(0,P.parse)(U,$);return $.length>0?(Z(B.localized,$),{values:void 0,default:B.original}):(0,P.getNodeType)(G)!=="object"?(te(B.localized),{values:void 0,default:B.original}):{values:G,default:B.original}}catch{return{values:void 0,default:B.original}}}}async r(q,x){if(q)try{const Y=(await this.i.readFile(q)).value.toString();return(0,P.parse)(Y,x)}catch{}}s(q,x){return new Promise((Y,F)=>{const Z=te=>{const se=(0,p.joinPath)(q,`package.nls.${te}.json`);this.i.exists(se).then(ae=>{ae&&Y({localized:se,original:(0,p.joinPath)(q,"package.nls.json")});const V=te.lastIndexOf("-");V===-1?Y({localized:(0,p.joinPath)(q,"package.nls.json"),original:null}):(te=te.substring(0,V),Z(te))})};if(x.devMode||x.pseudo||!x.language)return Y({localized:(0,p.joinPath)(q,"package.nls.json"),original:null});Z(x.language)})}t(q,x){return`[${q.path}]: ${x}`}};H=ye([X(1,h.IExtensionsProfileScannerService),X(2,v.IUriIdentityService),X(3,r.IFileService),X(4,n.ILogService)],H);let J=class extends H{constructor(q,x,Y,F,Z,te){super(x,Y,F,Z,te),this.y=q,this.v=this.B(new O.ThrottledDelayer(3e3)),this.w=this.B(new a.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(q){const x=await this.z();if(this.u=q,x&&x.input&&z.equals(x.input,this.u))return this.j.debug("Using cached extensions scan result",q.location.toString()),this.v.trigger(()=>this.D()),x.result.map(F=>(F.location=u.URI.revive(F.location),F));const Y=await super.scanExtensions(q);return await this.C({input:q,result:Y}),Y}async z(){try{const q=await this.i.readFile(this.y),x=JSON.parse(q.value.toString());return{result:x.result,input:(0,o.revive)(x.input)}}catch(q){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,k.getErrorMessage)(q))}return null}async C(q){try{await this.i.writeFile(this.y,D.VSBuffer.fromString(JSON.stringify(q)))}catch(x){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,k.getErrorMessage)(x))}}async D(){if(!this.u)return;const q=await this.z();if(!q)return;const x=q.result,Y=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!l.equals(Y,x))try{await this.i.del(this.y),this.w.fire()}catch(F){this.j.error(F)}}};J=ye([X(2,h.IExtensionsProfileScannerService),X(3,v.IUriIdentityService),X(4,r.IFileService),X(5,n.ILogService)],J);function W(j,q){const x=(0,S.getExtensionId)(j.manifest.publisher,j.manifest.name);return{id:x,identifier:new R.ExtensionIdentifier(x),isBuiltin:j.type===0,isUserBuiltin:j.type===1&&j.isBuiltin,isUnderDevelopment:q,extensionLocation:j.location,uuid:j.identifier.uuid,targetPlatform:j.targetPlatform,...j.manifest}}e.toExtensionDescription=W;class N extends M{constructor(q,x,Y,F,Z,te,se,ae,V,B,U,$){super(q,x,(0,p.joinPath)(Y,".vscode-oss-dev","extensions","control.json"),(0,p.joinPath)(F,R.MANIFEST_CACHE_FOLDER),Z,te,se,ae,V,B,U,$),this.M=(async()=>{if(y.translationsConfigFile)try{const G=await this.r.readFile(u.URI.file(y.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(q){return this.M}}e.NativeExtensionsScannerService=N}),define(re[268],oe([0,1,50,6,38,3,2,22,13,28,8,18]),function(_,e,L,O,l,D,k,P,C,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let y=class extends k.Disposable{constructor(d,E){super(),this.b=d,this.f=E,this.a=new O.Limiter(5)}async postUninstall(d){const E=this.g(d,"uninstall");E&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(E.script,"uninstall",E.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(c){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(c)}}));try{await b.Promises.rm(this.j(d))}catch(c){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(c)}}g(d,E){const c=`vscode:${E}`;if(d.location.scheme===P.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[c]=="string"){const u=d.manifest.scripts[c].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${c} should be a node script`),null):{script:(0,C.join)(d.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(d,E,c,u,g){return new Promise((f,S)=>{const R=this.i(d,E,c,g);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?S(t):f(void 0)};R.on("error",t=>{r((0,l.toErrorMessage)(t)||"Unknown")}),R.on("exit",(t,n)=>{r(t?`post-${E} process exited with code ${t}`:void 0)}),u&&(i=setTimeout(()=>{i=null,R.kill(),S("timed out")},5e3))})}i(d,E,c,u){const g={silent:!0,execArgv:void 0},f=(0,L.fork)(d,[`--type=extension-post-${E}`,...c],g);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const S=D.Event.fromNodeEventEmitter(f.stdout,"data"),R=D.Event.fromNodeEventEmitter(f.stderr,"data");S(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${E}`,t)),R(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${E}`,t));const i=D.Event.any(D.Event.map(S,t=>({data:`%c${t}`,format:[""]})),D.Event.map(R,t=>({data:`%c${t}`,format:["color: red"]})));return D.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),f}j(d){return(0,C.join)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};y=ye([X(0,w.IUserDataProfilesService),X(1,I.ILogService)],y),e.ExtensionsLifecycle=y}),define(re[269],oe([0,1,8,18,30,19,51,14,15,11]),function(_,e,L,O,l,D,k,P,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let I=class extends k.AbstractExtensionsProfileScannerService{constructor(y,p,d,E,c,u){super(b.URI.file(y.extensionsPath),p,d,E,c,u)}};I=ye([X(0,C.INativeEnvironmentService),X(1,P.IFileService),X(2,O.IUserDataProfilesService),X(3,l.IUriIdentityService),X(4,D.ITelemetryService),X(5,L.ILogService)],I),e.ExtensionsProfileScannerService=I}),define(re[270],oe([0,1,11,15,51,77,14,5,8,26,30,18]),function(_,e,L,O,l,D,k,P,C,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends D.NativeExtensionsScannerService{constructor(d,E,c,u,g,f,S,R){super(L.URI.file(g.builtinExtensionsPath),L.URI.file(g.extensionsPath),g.userHome,L.URI.file(g.userDataPath),d,E,c,u,g,f,S,R)}};y=ye([X(0,w.IUserDataProfilesService),X(1,l.IExtensionsProfileScannerService),X(2,k.IFileService),X(3,C.ILogService),X(4,O.INativeEnvironmentService),X(5,b.IProductService),X(6,I.IUriIdentityService),X(7,P.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(re[20],oe([0,1,6,3,2,104,12,66,5,18]),function(_,e,L,O,l,D,k,P,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,C.createDecorator)("storageService");var I;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var y;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));function p(g){const f=g.get(e.TARGET_KEY);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.loadKeyTargets=p;class d extends l.Disposable{constructor(f={flushInterval:d.a}){super(),this.j=f,this.b=this.B(new O.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new O.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new L.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new l.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,L.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,l.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.J()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(f,S){if(S===e.TARGET_KEY){switch(f){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:f})}else this.b.fire({scope:f,key:S,target:this.F(f)[S]})}r(f){this.f.fire({reason:f})}get(f,S,R){return this.L(S)?.get(f,R)}getBoolean(f,S,R){return this.L(S)?.getBoolean(f,R)}getNumber(f,S,R){return this.L(S)?.getNumber(f,R)}store(f,S,R,i){if((0,k.isUndefinedOrNull)(S)){this.remove(f,R);return}this.t(()=>{this.u(f,R,i),this.L(R)?.set(f,S)})}remove(f,S){this.t(()=>{this.u(f,S,void 0),this.L(S)?.delete(f)})}t(f){this.b.pause(),this.c.pause();try{f()}finally{this.b.resume(),this.c.resume()}}keys(f,S){const R=[],i=this.F(f);for(const r of Object.keys(i))i[r]===S&&R.push(r);return R}u(f,S,R){const i=this.F(S);typeof R=="number"?i[f]!==R&&(i[f]=R,this.L(S)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[f]=="number"&&(delete i[f],this.L(S)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(f){switch(f){case-1:return this.D;case 0:return this.z;default:return this.w}}G(f){const S=this.L(f);return S?p(S):Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=I.NONE){this.f.fire({reason:f});const S=this.L(-1),R=this.L(0),i=this.L(1);switch(f){case I.NONE:await L.Promises.settled([S?.whenFlushed()??Promise.resolve(),R?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await L.Promises.settled([S?.flush(0)??Promise.resolve(),R?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.L(-1)?.items??new Map,S=this.L(0)?.items??new Map,R=this.L(1)?.items??new Map;return u(f,S,R,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(f,S){return this.r(I.NONE),(0,b.isUserDataProfile)(f)?this.N(f,S):this.O(f,S)}H(f,S){return!(f.id===S.id||E(S)&&E(f))}I(f,S,R,i){this.t(()=>{if(i)for(const[r,t]of f)S.set(r,t);else{const r=new Set;for(const[t,n]of f)r.add(t),S.get(t)!==n&&this.n(R,t);for(const[t]of S.items)r.has(t)||this.n(R,t)}})}}d.a=60*1e3,e.AbstractStorageService=d;function E(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=E;class c extends d{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(f=>this.n(1,f))),this.B(this.P.onDidChangeStorage(f=>this.n(0,f))),this.B(this.p.onDidChangeStorage(f=>this.n(-1,f)))}L(f){switch(f){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(f){return!1}}e.InMemoryStorageService=c;async function u(g,f,S,R,i,r){const t=T=>{try{return JSON.parse(T)}catch{return T}},n=new Map,s=new Map;g.forEach((T,M)=>{n.set(M,T),s.set(M,t(T))});const a=new Map,o=new Map;f.forEach((T,M)=>{a.set(M,T),o.set(M,t(T))});const h=new Map,m=new Map;S.forEach((T,M)=>{h.set(M,T),m.set(M,t(T))}),console.group(R!==i?`Storage: Application (path: ${R})`:`Storage: Application & Profile (path: ${R}, default profile)`);const v=[];if(n.forEach((T,M)=>{v.push({key:M,value:T})}),console.table(v),console.groupEnd(),console.log(s),R!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const T=[];a.forEach((M,z)=>{T.push({key:z,value:M})}),console.table(T),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${r})`);const A=[];h.forEach((T,M)=>{A.push({key:M,value:T})}),console.table(A),console.groupEnd(),console.log(m)}e.logStorage=u}),define(re[120],oe([0,1,3,2,12,29,33,20]),function(_,e,L,O,l,D,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=class extends O.Disposable{constructor(w,y){super(),this.a=new L.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new b(w)),this.B(this.b.onDidChange(p=>this.a.fire({extensions:p,source:"storage"}))),this.B(y.onDidInstallExtensions(p=>p.forEach(({local:d,operation:E})=>{d&&E===4&&this.f(d.identifier)})))}async enableExtension(w,y){return this.f(w)?(this.a.fire({extensions:[w],source:y}),!0):!1}async disableExtension(w,y){return this.c(w)?(this.a.fire({extensions:[w],source:y}),!0):!1}getDisabledExtensions(){return this.h(D.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(w){const y=this.getDisabledExtensions();return y.every(p=>!(0,k.areSameExtensions)(p,w))?(y.push(w),this.g(y),!0):!1}f(w){const y=this.getDisabledExtensions();for(let p=0;p<y.length;p++){const d=y[p];if((0,k.areSameExtensions)(d,w))return y.splice(p,1),this.g(y),!0}return!1}g(w){this.i(D.DISABLED_EXTENSIONS_STORAGE_PATH,w)}h(w){return this.b.get(w,0)}i(w,y){this.b.set(w,y,0)}};C=ye([X(0,P.IStorageService),X(1,D.IExtensionManagementService)],C),e.GlobalExtensionEnablementService=C;class b extends O.Disposable{constructor(w){super(),this.c=w,this.a=Object.create(null),this.b=this.B(new L.Emitter),this.onDidChange=this.b.event,this.B(w.onDidChangeValue(y=>this.f(y)))}get(w,y){let p;return y===0?((0,l.isUndefinedOrNull)(this.a[w])&&(this.a[w]=this.g(w,y)),p=this.a[w]):p=this.g(w,y),JSON.parse(p)}set(w,y,p){const d=JSON.stringify(y.map(({id:c,uuid:u})=>({id:c,uuid:u})));this.g(w,p)!==d&&(p===0&&(y.length?this.a[w]=d:delete this.a[w]),this.h(w,y.length?d:void 0,p))}f(w){if(w.scope===0&&!(0,l.isUndefinedOrNull)(this.a[w.key])&&this.g(w.key,w.scope)!==this.a[w.key]){const p=this.get(w.key,w.scope);delete this.a[w.key];const d=this.get(w.key,w.scope),E=p.filter(u=>!d.some(g=>(0,k.areSameExtensions)(u,g))),c=d.filter(u=>!p.some(g=>(0,k.areSameExtensions)(g,u)));(E.length||c.length)&&this.b.fire([...E,...c])}}g(w,y){return this.c.get(w,y,"[]")}h(w,y,p){y?this.c.store(w,y,p,1):this.c.remove(w,p)}}e.StorageManager=b}),define(re[271],oe([0,1,21,25,9,4,36,12,11,17,15,29,33,67,14,8,26,58,238,20,19]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const R=D.isWeb?"web":(0,w.getTargetPlatform)(D.platform,k.arch),i="X-Market-Search-Activity-Id";var r;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished",B[B.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function t(...B){return String(B.reduce((U,$)=>U|$,0))}var n;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class m{constructor(U=h){this.d=U}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(U,$=this.d.pageSize){return new m({...this.d,pageNumber:U,pageSize:$})}withFilter(U,...$){const G=[...this.d.criteria,...$.length?$.map(ee=>({filterType:U,value:ee})):[{filterType:U}]];return new m({...this.d,criteria:G})}withSortBy(U){return new m({...this.d,sortBy:U})}withSortOrder(U){return new m({...this.d,sortOrder:U})}withFlags(...U){return new m({...this.d,flags:U.reduce(($,G)=>$|G,0)})}withAssetTypes(...U){return new m({...this.d,assetTypes:U})}withSource(U){return new m({...this.d,source:U})}get raw(){const{criteria:U,pageNumber:$,pageSize:G,sortBy:ee,sortOrder:K,flags:Q,assetTypes:ie}=this.d;return{filters:[{criteria:U,pageNumber:$,pageSize:G,sortBy:ee,sortOrder:K}],assetTypes:ie,flags:Q}}get searchText(){const U=this.d.criteria.filter($=>$.filterType===n.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(U=>String(U.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function v(B,U){const $=(B||[]).filter(G=>G.statisticName===U)[0];return $?$.value:0}function A(B){const U="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(G=>G.assetType.indexOf(U)===0).reduce((G,ee)=>{const K=z(B,ee.assetType);return K&&G.push([ee.assetType.substring(U.length),K]),G},[])}function T(B){if(B.properties){const U=B.properties.filter(ee=>ee.key===s.Repository),$=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=U.filter(ee=>$.test(ee.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return z(B,s.Repository)}function M(B){return{uri:`${B.fallbackAssetUri}/${s.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${s.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function z(B,U){return B.files.filter(G=>G.assetType===U)[0]?{uri:`${B.assetUri}/${U}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${U}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}:null}function H(B,U){const $=B.properties?B.properties.filter(ee=>ee.key===U):[],G=$.length>0&&$[0].value;return G?G.split(",").map(ee=>(0,y.adoptToGalleryExtensionId)(ee)):[]}function J(B){const U=B.properties?B.properties.filter($=>$.key===a.Engine):[];return U.length>0&&U[0].value||""}function W(B){const U=B.properties?B.properties.filter($=>$.key===a.PreRelease):[];return U.length>0&&U[0].value==="true"}function N(B){const U=B.properties?B.properties.filter(G=>G.key===a.LocalizedLanguages):[],$=U.length>0&&U[0].value||"";return $?$.split(","):[]}function j(B){return B.properties?.find(U=>U.key===a.SponsorLink)?.value}function q(B){return B.indexOf("preview")!==-1}function x(B){return B.targetPlatform?(0,w.toTargetPlatform)(B.targetPlatform):"undefined"}function Y(B){const U=(0,L.distinct)(B.versions.map(x)),$=!!B.tags?.includes(w.WEB_EXTENSION_TAG),G=U.indexOf("web");return $?G===-1&&U.push("web"):G!==-1&&U.splice(G,1),U}function F(B,U){const $=(0,w.getFallbackTargetPlarforms)(U);for(let G=0;G<B.length;G++){const ee=B[G];if(ee.version===B[G-1]?.version){let K=G;const Q=x(ee);if(Q===U)for(;K>0&&B[K-1].version===ee.version;)K--;else if($.includes(Q))for(;K>0&&B[K-1].version===ee.version&&x(B[K-1])!==U;)K--;K!==G&&(B.splice(G,1),B.splice(K,0,ee))}}return B}e.sortExtensionVersions=F;function Z(B,U,$){B.telemetryData={index:U,querySource:$,queryActivityId:B.queryContext?.[i]}}function te(B,U,$,G){const ee=B.versions[0],K={manifest:z(U,s.Manifest),readme:z(U,s.Details),changelog:z(U,s.Changelog),license:z(U,s.License),repository:T(U),download:M(U),icon:z(U,s.Icon),signature:z(U,s.Signature),coreTranslations:A(U)};return{identifier:{id:(0,y.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:U.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,publisherDomain:B.publisher.domain?{link:B.publisher.domain,verified:!!B.publisher.isDomainVerified}:void 0,publisherSponsorLink:j(ee),description:B.shortDescription||"",installCount:v(B.statistics,"install"),rating:v(B.statistics,"averagerating"),ratingCount:v(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:$,assets:K,properties:{dependencies:H(U,a.Dependency),extensionPack:H(U,a.ExtensionPack),engine:J(U),localizedLanguages:N(U),targetPlatform:x(U),isPreReleaseVersion:W(U)},hasPreReleaseVersion:W(ee),hasReleaseVersion:!0,preview:q(B.flags),isSigned:!!K.signature,queryContext:G}}let se=class{constructor(U,$,G,ee,K,Q,ie,le){this.k=$,this.l=G,this.n=ee,this.o=K,this.q=Q,this.u=ie,this.w=le;const he=ie.extensionsGallery,pe=he?.servicePPEUrl&&le.getValue("_extensionsGallery.enablePPE");this.d=pe?he.servicePPEUrl:he?.serviceUrl,this.g=pe?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,g.resolveMarketplaceHeaders)(ie.version,ie,this.n,this.w,this.q,U,this.o)}x(U=""){return`${this.d}${U}`}isEnabled(){return!!this.d}async getExtensions(U,$,G){const ee=O.CancellationToken.isCancellationToken($)?{}:$,K=O.CancellationToken.isCancellationToken($)?$:G,Q=[],ie=[],le=[],he=[];let pe=!0;for(const Ce of U){Ce.uuid?ie.push(Ce.uuid):Q.push(Ce.id);const De=!!(Ce.version||Ce.preRelease);le.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:De}),Ce.version&&he.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),pe=pe&&!!Ce.hasPreRelease&&!De}if(!ie.length&&!Q.length)return[];let me=new m().withPage(1,U.length);ie.length&&(me=me.withFilter(n.ExtensionId,...ie)),Q.length&&(me=me.withFilter(n.ExtensionName,...Q)),(ee.queryAllVersions||pe)&&(me=me.withFlags(me.flags,r.IncludeVersions)),ee.source&&(me=me.withSource(ee.source));const{extensions:be}=await this.z(me,{targetPlatform:ee.targetPlatform??R,includePreRelease:le,versions:he,compatible:!!ee.compatible},K);return ee.source&&be.forEach((Ce,De)=>Z(Ce,De,ee.source)),be}async getCompatibleExtension(U,$,G){if((0,w.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(U,$,G))return U;const ee=new m().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,U.identifier.uuid),{extensions:K}=await this.z(ee,{targetPlatform:G,compatible:!0,includePreRelease:$},O.CancellationToken.None);return K[0]||null}async isExtensionCompatible(U,$,G){if(!(0,w.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,G)||!$&&U.properties.isPreReleaseVersion)return!1;let ee=U.properties.engine;if(!ee){const K=await this.getManifest(U,O.CancellationToken.None);if(!K)throw new Error("Manifest was not found");ee=K.engines.vscode}return(0,p.isEngineValid)(ee,this.u.version,this.u.date)}async y(U,$,G,ee,K){if(!(0,w.isTargetPlatformCompatible)(x(U),ee,K)||$!=="any"&&W(U)!==($==="prerelease"))return!1;if(G)try{const Q=await this.E(U);if(!(0,p.isEngineValid)(Q,this.u.version,this.u.date))return!1}catch(Q){return this.l.error(`Error while getting the engine for the version ${U.version}.`,(0,l.getErrorMessage)(Q)),!1}return!0}async query(U,$){let G=U.text||"";const ee=U.pageSize??50;let K=new m().withPage(1,ee);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,me,be)=>(K=K.withFilter(n.Category,be||me),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,me,be)=>(K=K.withFilter(n.Tag,be||me),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(K=K.withFilter(n.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),K=K.withFilter(n.SearchText,G)),K=K.withSortBy(0)):U.ids?K=K.withFilter(n.ExtensionId,...U.ids):U.names?K=K.withFilter(n.ExtensionName,...U.names):K=K.withSortBy(4),typeof U.sortBy=="number"&&(K=K.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(K=K.withSortOrder(U.sortOrder)),U.source&&(K=K.withSource(U.source));const Q=async(pe,me)=>{const{extensions:be,total:Ce}=await this.z(pe,{targetPlatform:R,compatible:!1,includePreRelease:!!U.includePreRelease},me);return be.forEach((De,ke)=>Z(De,(pe.pageNumber-1)*pe.pageSize+ke,U.source)),{extensions:be,total:Ce}},{extensions:ie,total:le}=await Q(K,$),he=async(pe,me)=>{if(me.isCancellationRequested)throw new l.CancellationError;const{extensions:be}=await Q(K.withPage(pe+1),me);return be};return{firstPage:ie,total:le,pageSize:K.pageSize,getPage:he}}async z(U,$,G){const ee=U.flags;!!(U.flags&r.IncludeLatestVersionOnly)&&!!(U.flags&r.IncludeVersions)&&(U=U.withFlags(U.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(U.flags&r.IncludeLatestVersionOnly)&&!(U.flags&r.IncludeVersions)&&(U=U.withFlags(U.flags,r.IncludeLatestVersionOnly)),$.versions?.length&&(U=U.withFlags(U.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),U=U.withFlags(U.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:K,total:Q,context:ie}=await this.B(U,G);if(!(U.flags&r.IncludeLatestVersionOnly)){const me=[];for(const be of K){const Ce=await this.A(be,$,ie);Ce&&me.push(Ce)}return{extensions:me,total:Q}}const he=[],pe=new Map;for(let me=0;me<K.length;me++){const be=K[me],Ce={id:(0,y.getGalleryExtensionId)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},De=(0,P.isBoolean)($.includePreRelease)?$.includePreRelease:!!$.includePreRelease.find(We=>(0,y.areSameExtensions)(We,Ce))?.includePreRelease;if($.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(Y(be),$.targetPlatform))continue;const ke=await this.A(be,$,ie);!ke||ke.properties.isPreReleaseVersion&&(!De||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==$.targetPlatform&&ke.hasPreReleaseVersion?pe.set(be.extensionId,me):he.push([me,ke])}if(pe.size){const me=new Date().getTime(),be=new m().withFlags(ee&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,pe.size).withFilter(n.ExtensionId,...pe.keys()),{extensions:Ce}=await this.z(be,$,G);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-me,count:pe.size});for(const De of Ce){const ke=pe.get(De.identifier.uuid);he.push([ke,De])}}return{extensions:he.sort((me,be)=>me[0]-be[0]).map(([,me])=>me),total:Q}}async A(U,$,G){const ee={id:(0,y.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},K=$.versions?.find(he=>(0,y.areSameExtensions)(he,ee))?.version,Q=(0,P.isBoolean)($.includePreRelease)?$.includePreRelease:!!$.includePreRelease.find(he=>(0,y.areSameExtensions)(he,ee))?.includePreRelease,ie=Y(U),le=F(U.versions,$.targetPlatform);if($.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(ie,$.targetPlatform))return null;for(let he=0;he<le.length;he++){const pe=le[he];if(!(K&&pe.version!==K)){if(await this.y(pe,Q?"any":"release",$.compatible,ie,$.targetPlatform))return te(U,pe,ie,G);if(K&&pe.version===K)return null}}return K||$.compatible?null:te(U,U.versions[0],ie)}async B(U,$){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,t(r.Unpublished));const G=await this.j,ee=JSON.stringify(U.raw),K={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Q=new Date().getTime();let ie,le,he=0;try{if(ie=await this.k.request({type:"POST",url:this.g&&U.criteria.some(me=>me.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:K},$),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:he};const pe=await(0,u.asJson)(ie);if(pe){const me=pe.results[0],be=me.extensions,Ce=me.resultMetadata&&me.resultMetadata.filter(De=>De.metadataType==="ResultCount")[0];return he=Ce&&Ce.metadataItems.filter(De=>De.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:he,context:{[i]:ie.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(pe){throw le=pe,pe}finally{this.o.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(ee.length),duration:new Date().getTime()-Q,success:!!ie&&(0,u.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:le?(0,l.isCancellationError)(le)?"canceled":(0,l.getErrorMessage)(le).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(U,$,G,ee){if(!this.isEnabled())return;const K=D.isWeb?this.x(`/itemName/${U}.${$}/version/${G}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${U}/extensions/${$}/${G}/stats?statType=${ee}`),Q=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",le={...await this.j,Accept:Q};try{await this.k.request({type:"POST",url:K,headers:le},O.CancellationToken.None)}catch{}}async download(U,$,G){this.l.trace("ExtensionGalleryService#download",U.identifier.id);const ee=(0,y.getGalleryExtensionTelemetryData)(U),K=new Date().getTime(),Q=me=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:me}),ie=G===2?"install":G===3?"update":"",le=ie?{uri:`${U.assets.download.uri}${C.URI.parse(U.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${U.assets.download.fallbackUri}${C.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:U.assets.download,he=U.queryContext?.[i]?{[i]:U.queryContext[i]}:void 0,pe=await this.D(le,he?{headers:he}:void 0);await this.q.writeFile($,pe.stream),Q(new Date().getTime()-K)}async downloadSignatureArchive(U,$){if(!U.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const G=await this.D(U.assets.signature);await this.q.writeFile($,G.stream)}async getReadme(U,$){if(U.assets.readme){const G=await this.D(U.assets.readme,{},$);return await(0,u.asTextOrError)(G)||""}return""}async getManifest(U,$){if(U.assets.manifest){const G=await this.D(U.assets.manifest,{},$),ee=await(0,u.asTextOrError)(G);return ee?JSON.parse(ee):null}return null}async C(U,$){const G=z(U,s.Manifest);if(!G)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},K=await this.D(G,{headers:ee});return await(0,u.asJson)(K)}async getCoreTranslation(U,$){const G=U.assets.coreTranslations.filter(ee=>ee[0]===$.toUpperCase())[0];if(G){const ee=await this.D(G[1]),K=await(0,u.asTextOrError)(ee);return K?JSON.parse(K):null}return null}async getChangelog(U,$){if(U.assets.changelog){const G=await this.D(U.assets.changelog,{},$);return await(0,u.asTextOrError)(G)||""}return""}async getAllCompatibleVersions(U,$,G){let ee=new m().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?ee=ee.withFilter(n.ExtensionId,U.identifier.uuid):ee=ee.withFilter(n.ExtensionName,U.identifier.id);const{galleryExtensions:K}=await this.B(ee,O.CancellationToken.None);if(!K.length)return[];const Q=Y(K[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(Q,G))return[];const ie=[];await Promise.all(K[0].versions.map(async pe=>{try{await this.y(pe,$?"any":"release",!0,Q,G)&&ie.push(pe)}catch{}}));const le=[],he=new Set;for(const pe of F(ie,G))he.has(pe.version)||(he.add(pe.version),le.push({version:pe.version,date:pe.lastUpdated,isPreReleaseVersion:W(pe)}));return le}async D(U,$={},G=O.CancellationToken.None){const ee=await this.j,K={type:"GET"},Q={...ee,...$.headers||{}};$={...$,...K,headers:Q};const ie=U.uri,le=U.fallbackUri,he={...$,url:ie};try{const pe=await this.k.request(he,G);if(pe.res.statusCode===200)return pe;const me=await(0,u.asTextOrError)(pe);throw new Error(`Expected 200, got back ${pe.res.statusCode} instead.

${me}`)}catch(pe){if((0,l.isCancellationError)(pe))throw pe;const me=(0,l.getErrorMessage)(pe);this.o.publicLog2("galleryService:cdnFallback",{url:ie,message:me});const be={...$,url:le};return this.k.request(be,G)}}async E(U){let $=J(U);if(!$){const G=await this.C(U,O.CancellationToken.None);if(!G)throw new Error("Manifest was not found");$=G.engines.vscode}return $}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const U=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const $=await(0,u.asJson)(U),G=[],ee={};if($){for(const K of $.malicious)G.push({id:K});if($.migrateToPreRelease)for(const[K,Q]of Object.entries($.migrateToPreRelease))(!Q.engine||(0,p.isEngineValid)(Q.engine,this.u.version,this.u.date))&&(ee[K.toLowerCase()]={disallowInstall:!0,extension:{id:Q.id,displayName:Q.displayName,autoMigrate:{storage:!!Q.migrateStorage},preRelease:!0}});if($.deprecated)for(const[K,Q]of Object.entries($.deprecated))Q&&(ee[K.toLowerCase()]=(0,P.isBoolean)(Q)?{}:Q)}return{malicious:G,deprecated:ee}}};se=ye([X(1,u.IRequestService),X(2,E.ILogService),X(3,I.IEnvironmentService),X(4,S.ITelemetryService),X(5,d.IFileService),X(6,c.IProductService),X(7,b.IConfigurationService)],se);let ae=class extends se{constructor(U,$,G,ee,K,Q,ie,le){super(U,$,G,ee,K,Q,ie,le)}};ae=ye([X(0,f.IStorageService),X(1,u.IRequestService),X(2,E.ILogService),X(3,I.IEnvironmentService),X(4,S.ITelemetryService),X(5,d.IFileService),X(6,c.IProductService),X(7,b.IConfigurationService)],ae),e.ExtensionGalleryService=ae;let V=class extends se{constructor(U,$,G,ee,K,Q,ie){super(void 0,U,$,G,ee,K,Q,ie)}};V=ye([X(0,u.IRequestService),X(1,E.ILogService),X(2,I.IEnvironmentService),X(3,S.ITelemetryService),X(4,d.IFileService),X(5,c.IProductService),X(6,b.IConfigurationService)],V),e.ExtensionGalleryServiceWithNoStorageService=V}),define(re[78],oe([0,1,5,3,2,20,33,26,21,8,12]),function(_,e,L,O,l,D,k,P,C,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,L.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let y=class Xe extends l.Disposable{static b(d){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static c(d){const E=w.exec(d);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(d,E){const c=await d.getInstalled(),u=[];for(const[g,f]of Xe.f(E)){const S=c.find(R=>(0,k.areSameExtensions)(R.identifier,{id:g}))?.manifest.version;for(const R of f)S!==R&&u.push(Xe.b({id:g,version:R}))}for(const g of u)E.remove(g,0)}static f(d){const E=new Map,c=d.keys(0,1);for(const u of c){const g=Xe.c(u);if(g){let f=E.get(g.id.toLowerCase());f||E.set(g.id.toLowerCase(),f=[]),f.push(g.version)}}return E}constructor(d,E,c){super(),this.i=d,this.j=E,this.k=c,this.g=this.B(new O.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Xe.f(d),this.B(this.i.onDidChangeValue(u=>this.l(u)))}l(d){if(d.scope!==0)return;if(this.h.has(d.key.toLowerCase())){this.g.fire();return}const E=Xe.c(d.key);if(E){if(this.i.get(d.key,0)===void 0)this.h.delete(E.id.toLowerCase());else{let c=this.h.get(E.id.toLowerCase());c||this.h.set(E.id.toLowerCase(),c=[]),c.push(E.version),this.g.fire()}return}}m(d){if((0,I.isString)(d))return d;const E=d.manifest?d.manifest.publisher:d.publisher,c=d.manifest?d.manifest.name:d.name;return(0,k.getExtensionId)(E,c)}getExtensionState(d,E){const c=this.m(d),u=this.getExtensionStateRaw(d,E);if(u)try{return JSON.parse(u)}catch(g){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${E}): ${g}`)}}getExtensionStateRaw(d,E){const c=this.m(d),u=this.i.get(c,E?0:1);return u&&u?.length>Xe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${E}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(d,E,c){const u=this.m(d);E===void 0?this.i.remove(u,c?0:1):this.i.store(u,JSON.stringify(E),c?0:1,1)}setKeysForSync(d,E){this.i.store(Xe.b(d),JSON.stringify(E),0,1)}getKeysForSync(d){const E=this.j.extensionSyncedKeys?.[d.id.toLowerCase()],c=this.i.get(Xe.b(d),0),u=c?JSON.parse(c):void 0;return u&&E?(0,C.distinct)([...u,...E]):u||E}addToMigrationList(d,E){if(d!==E){const c=this.n.filter(u=>!u.includes(d)&&!u.includes(E));c.push([d,E]),this.n=c}}getSourceExtensionToMigrate(d){const E=this.n.find(([,c])=>d===c);return E?E[0]:void 0}get n(){const d=this.i.get("extensionStorage.migrationList",-1,"[]");try{const E=JSON.parse(d);if(Array.isArray(E))return E}catch{}return[]}set n(d){d.length?this.i.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};y.a=512*1024,y=ye([X(0,D.IStorageService),X(1,P.IProductService),X(2,b.ILogService)],y),e.ExtensionStorageService=y}),define(re[272],oe([0,1,29,14,26,15,101,56,20,19,235]),function(_,e,L,O,l,D,k,P,C,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let w=class extends I.AbstractNativeExtensionTipsService{constructor(p,d,E,c,u,g,f,S){super(p.userHome,u,d,E,c,g,f,S)}};w=ye([X(0,D.INativeEnvironmentService),X(1,b.ITelemetryService),X(2,L.IExtensionManagementService),X(3,C.IStorageService),X(4,P.INativeHostService),X(5,k.IExtensionRecommendationNotificationService),X(6,O.IFileService),X(7,l.IProductService)],w),e.ExtensionTipsService=w}),define(re[273],oe([0,1,6,2,23,66,20,74,18]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class b extends k.AbstractStorageService{constructor(w,y,p,d){super(),this.X=w,this.Y=y,this.Z=p,this.ab=d,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new O.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new O.DisposableStore),this.W=this.db(this.X)}bb(){const w=this.B(new P.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),y=this.B(new D.Storage(w));return this.B(y.onDidChangeStorage(p=>this.n(-1,p))),y}cb(w){this.Q.clear(),this.P=w;let y;if((0,k.isProfileUsingDefaultStorage)(w))y=this.s;else{const p=this.Q.add(new P.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),w));y=this.Q.add(new D.Storage(p))}return this.Q.add(y.onDidChangeStorage(p=>this.n(0,p))),y}db(w){this.U.clear(),this.S=w?.id;let y;if(w){const p=this.U.add(new P.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),w));y=this.U.add(new D.Storage(p)),this.U.add(y.onDidChangeStorage(d=>this.n(1,d)))}return y}async J(){await L.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(w){switch(w){case-1:return this.s;case 0:return this.R;default:return this.W}}M(w){switch(w){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,l.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(k.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(w,y){if(!this.H(this.P,w))return;const p=this.R,d=p.items;p!==this.s&&await p.close(),this.R=this.cb(w),await this.R.init(),this.I(d,this.R,0,y)}async O(w,y){const p=this.W,d=p?.items??new Map;await p?.close(),this.W=this.db(w),await this.W.init(),this.I(d,this.W,1,y)}hasScope(w){return(0,C.isUserDataProfile)(w)?this.P.id===w.id:this.S===w.id}}e.RemoteStorageService=b}),define(re[274],oe([0,1,3,2,18,92]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class k{constructor(b,I){this.a=b,this.b=I}listen(b,I){const w=this.b(b);switch(I){case"onDidChangeProfiles":return L.Event.map(this.a.onDidChangeProfiles,y=>({all:y.all.map(p=>(0,D.transformOutgoingURIs)({...p},w)),added:y.added.map(p=>(0,D.transformOutgoingURIs)({...p},w)),removed:y.removed.map(p=>(0,D.transformOutgoingURIs)({...p},w)),updated:y.updated.map(p=>(0,D.transformOutgoingURIs)({...p},w))}))}throw new Error(`Invalid listen ${I}`)}async call(b,I,w){const y=this.b(b);switch(I){case"createProfile":{const p=await this.a.createProfile(w[0],w[1],w[2]);return(0,D.transformOutgoingURIs)({...p},y)}case"updateProfile":{let p=(0,l.reviveProfile)((0,D.transformIncomingURIs)(w[0],y),this.a.profilesHome.scheme);return p=await this.a.updateProfile(p,w[1]),(0,D.transformOutgoingURIs)({...p},y)}case"removeProfile":{const p=(0,l.reviveProfile)((0,D.transformIncomingURIs)(w[0],y),this.a.profilesHome.scheme);return this.a.removeProfile(p)}}throw new Error(`Invalid call ${I}`)}}e.RemoteUserDataProfilesServiceChannel=k;class P extends O.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,I,w){super(),this.profilesHome=I,this.f=w,this.a=[],this.b=this.B(new L.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map(y=>(0,l.reviveProfile)(y,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(y=>{const p=y.added.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),d=y.removed.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),E=y.updated.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme));this.a=y.all.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),this.b.fire({added:p,removed:d,updated:E,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,I,w){const y=await this.f.call("createNamedProfile",[b,I,w]);return(0,l.reviveProfile)(y,this.profilesHome.scheme)}async createProfile(b,I,w,y){const p=await this.f.call("createProfile",[b,I,w,y]);return(0,l.reviveProfile)(p,this.profilesHome.scheme)}async createTransientProfile(b){const I=await this.f.call("createTransientProfile",[b]);return(0,l.reviveProfile)(I,this.profilesHome.scheme)}async setProfileForWorkspace(b,I){await this.f.call("setProfileForWorkspace",[b,I])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,I){const w=await this.f.call("updateProfile",[b,I]);return(0,l.reviveProfile)(w,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=P}),define(re[60],oe([0,1,2,66,5,20,3,74,18]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,l.createDecorator)("IUserDataProfileStorageService");let b=class extends L.Disposable{constructor(p){super(),this.a=p}async readStorageData(p){return this.withProfileScopedStorageService(p,async d=>this.b(d))}async updateStorageData(p,d,E){return this.withProfileScopedStorageService(p,async c=>this.c(c,d,E))}async withProfileScopedStorageService(p,d){if(this.a.hasScope(p))return d(this.a);const E=await this.g(p),c=new w(E);try{await c.initialize();const u=await d(c);return await c.flush(),u}finally{c.dispose(),await this.f(E)}}b(p){const d=new Map,E=c=>{for(const u of p.keys(0,c))d.set(u,{value:p.get(u,0),target:c})};return E(0),E(1),d}c(p,d,E){for(const[c,u]of d)p.store(c,u,0,E)}async f(p){try{await p.close()}finally{(0,L.isDisposable)(p)&&p.dispose()}}};b=ye([X(0,D.IStorageService)],b),e.AbstractUserDataProfileStorageService=b;class I extends b{constructor(p,d,E,c){super(E),this.i=p;const u=p.getChannel("profileStorageListener"),g=this.B(new L.MutableDisposable);this.h=this.B(new k.Emitter({onWillAddFirstListener:()=>{g.value=u.listen("onDidChange")(f=>{c.trace("profile storage changes",f),this.h.fire({targetChanges:f.targetChanges.map(S=>(0,C.reviveProfile)(S,d.profilesHome.scheme)),valueChanges:f.valueChanges.map(S=>({...S,profile:(0,C.reviveProfile)(S.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>g.value=void 0})),this.onDidChange=this.h.event}async g(p){const d=this.i.getChannel("storage");return(0,D.isProfileUsingDefaultStorage)(p)?new P.ApplicationStorageDatabaseClient(d):new P.ProfileStorageDatabaseClient(d,p)}}e.RemoteUserDataProfileStorageService=I;class w extends D.AbstractStorageService{constructor(p){super({flushInterval:100}),this.p=this.B(new O.Storage(p))}J(){return this.p.init()}L(p){return p===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(re[275],oe([0,1,20,8,18,70,60]),function(_,e,L,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let P=class extends k.RemoteUserDataProfileStorageService{constructor(b,I,w,y){super(b,I,w,y)}};P=ye([X(0,D.IMainProcessService),X(1,l.IUserDataProfilesService),X(2,L.IStorageService),X(3,O.ILogService)],P),e.NativeUserDataProfileStorageService=P}),define(re[41],oe([0,1,21,6,16,25,3,35,2,27,12,180,17,15,14,8,44,20,19,30,24,18]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g,f,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function i(h){return!!(h&&h.ref!==void 0&&typeof h.ref=="string"&&h.ref!==""&&h.syncData!==void 0&&(h.syncData===null||r(h.syncData)))}e.isRemoteUserData=i;function r(h){return!!(h&&h.version!==void 0&&typeof h.version=="number"&&h.content!==void 0&&typeof h.content=="string"&&(Object.keys(h).length===2||Object.keys(h).length===3&&h.machineId!==void 0&&typeof h.machineId=="string"))}e.isSyncData=r;function t(h,m){return`${(0,b.uppercaseFirstLetter)(h)}${m.isDefault?"":` (${m.name})`}`}e.getSyncResourceLogLabel=t;let n=class extends C.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(m,v,A,T,M,z,H,J,W,N,j,q){super(),this.syncResource=m,this.collection=v,this.C=A,this.D=T,this.F=M,this.G=z,this.H=H,this.I=J,this.J=W,this.L=N,this.M=j,this.c=null,this.k="idle",this.l=this.B(new k.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new k.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new O.ThrottledDelayer(50),this.t=this.B(new k.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(m.syncResource,m.profile),this.h=q.extUri,this.f=this.h.joinPath(T.userDataSyncHome,...(0,S.getPathSegments)(m.profile.isDefault?void 0:m.profile.id,m.syncResource)),this.g=this.h.joinPath(this.f,S.PREVIEW_DIR_NAME),this.u=(0,S.getLastSyncResourceUri)(m.profile.isDefault?void 0:m.profile.id,m.syncResource,T,this.h),this.j=(0,c.getServiceMachineId)(T,A,M)}N(){this.s.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const m=await this.c;this.c=null;const v=await this.U(m.remoteUserData,m.lastSyncUserData,!0,this.mb());this.P(v)}else{this.L.trace(`${this.y}: Checking for local changes...`);const m=await this.getLastSyncUserData();(m?await this.sb(m):!0)&&this.t.fire()}}P(m){this.k!==m&&(this.k=m,this.l.fire(m))}async sync(m,v={}){await this.Q(m,!0,this.mb(),v)}async preview(m,v,A={}){return this.Q(m,!1,v,A)}async apply(m,v={}){try{this.z={...v};const A=await this.Y(m);return this.P(A),this.c}finally{this.z={}}}async Q(m,v,A,T){try{if(this.z={...T},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let M="idle";try{const z=await this.getLastSyncUserData(),H=await this.S(m,z);return M=await this.U(H,z,v,A),M==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(M)}}finally{this.z={}}}async replace(m){const v=this.ib(m);if(!v)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const A=await this.getLastSyncUserData(),T=await this.S(null,A),M=await this.R(T),z=await this.ob({ref:T.ref,syncData:v},A,M,this.mb(),D.CancellationToken.None),H=[];for(const J of z){const W=await this.qb(J,J.remoteResource,void 0,D.CancellationToken.None),{remoteChange:N}=await this.qb(J,J.previewResource,J.remoteContent,D.CancellationToken.None);H.push([J,{...W,remoteChange:N!==0?N:2}])}await this.rb(T,A,H,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(m){const v=await this.j;return!!m.syncData?.machineId&&m.syncData.machineId===v}async S(m,v){if(v){const A=m?m[this.resource]:void 0;if(v.ref===A||A===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async U(m,v,A,T){if(m.syncData&&m.syncData.version>this.nb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new S.UserDataSyncError((0,w.localize)(0,null,this.resource,this.nb,m.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(m,v,A,T)}catch(M){if(M instanceof S.UserDataSyncError)switch(M.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.U(m,v,A,T);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),m=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.U(m,v,A,T)}throw M}}async W(m,v,A,T){try{const M=await this.R(m),z=!M&&v===null&&this.eb()!==void 0,H=A&&!z;this.c||(this.c=(0,O.createCancelablePromise)(W=>this.cb(m,v,M,H,T,W)));let J=await this.c;if(A&&z){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const W of J.resourcePreviews)J=await this.accept(W.remoteResource)||J}return this.ab(J.resourcePreviews),J.resourcePreviews.some(({mergeState:W})=>W==="conflict")?"hasConflicts":A?await this.Y(!1):"syncing"}catch(M){throw this.c=null,M}}async merge(m){return await this.X(m,async v=>{const A=await this.pb(v,D.CancellationToken.None);await this.C.writeFile(v.previewResource,l.VSBuffer.fromString(A?.content||""));const T=A&&!A.hasConflicts?await this.qb(v,v.previewResource,void 0,D.CancellationToken.None):void 0;return v.acceptResult=T,v.mergeState=A.hasConflicts?"conflict":T?"accepted":"preview",v.localChange=T?T.localChange:A.localChange,v.remoteChange=T?T.remoteChange:A.remoteChange,v}),this.c}async accept(m,v){return await this.X(m,async A=>{const T=await this.qb(A,m,v,D.CancellationToken.None);return A.acceptResult=T,A.mergeState="accepted",A.localChange=T.localChange,A.remoteChange=T.remoteChange,A}),this.c}async discard(m){return await this.X(m,async v=>{const A=await this.pb(v,D.CancellationToken.None);return await this.C.writeFile(v.previewResource,l.VSBuffer.fromString(A.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=A.localChange,v.remoteChange=A.remoteChange,v}),this.c}async X(m,v){if(!this.c)return;let A=await this.c;const T=A.resourcePreviews.findIndex(({localResource:M,remoteResource:z,previewResource:H})=>this.h.isEqual(M,m)||this.h.isEqual(z,m)||this.h.isEqual(H,m));T!==-1&&(this.c=(0,O.createCancelablePromise)(async M=>{const z=[...A.resourcePreviews];return z[T]=await v(z[T]),{...A,resourcePreviews:z}}),A=await this.c,this.ab(A.resourcePreviews),A.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(m){if(!this.c)return"idle";const v=await this.c;return v.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:A})=>A!=="accepted")?"syncing":(await this.rb(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(A=>[A,A.acceptResult]),m),this.c=null,await this.Z(),"idle")}async Z(){try{await this.C.del(this.g,{recursive:!0})}catch{}}ab(m){const v=m.filter(({mergeState:A})=>A==="conflict");(0,L.equals)(this.m,v,(A,T)=>this.h.isEqual(A.previewResource,T.previewResource))||(this.m=v,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const m=await this.getLastSyncUserData();return!!m&&m.syncData!==null}async bb(m){const v=this.c?await this.c:null;if(v)for(const A of v.resourcePreviews){if(this.h.isEqual(A.acceptedResource,m))return A.acceptResult?A.acceptResult.content:null;if(this.h.isEqual(A.remoteResource,m))return A.remoteContent;if(this.h.isEqual(A.localResource,m))return A.localContent;if(this.h.isEqual(A.baseResource,m))return A.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(m){(0,d.toFileOperationResult)(m)!==1&&this.L.error(m)}}async cb(m,v,A,T,M,z){const H=await this.ob(m,v,A,M,z),J=[];for(const W of H){const N=W.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(W.localChange===0&&W.remoteChange===0)J.push({...W,acceptedResource:N,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const j=T?await this.pb(W,z):void 0;if(z.isCancellationRequested)break;await this.C.writeFile(W.previewResource,l.VSBuffer.fromString(j?.content||""));const q=j&&!j.hasConflicts?await this.qb(W,W.previewResource,void 0,z):void 0;J.push({...W,acceptResult:q,mergeState:j?.hasConflicts?"conflict":q?"accepted":"preview",localChange:q?q.localChange:j?j.localChange:W.localChange,remoteChange:q?q.remoteChange:j?j.remoteChange:W.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:m,lastSyncUserData:v,resourcePreviews:J,isLastSyncFromCurrentMachine:A}}async getLastSyncUserData(){let m=this.eb();if(m||(m=await this.hb()),!m)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const v=JSON.parse(m),A=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!v.version&&!!A&&v.version!==A,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${A}.`),await this.resetLocal(),null;let T,M=1;for(;T===void 0&&M++<6;)try{const z=await this.fb();z&&(z.ref===v.ref?T=z.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(z){if(z instanceof d.FileOperationError&&z.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(z instanceof S.UserDataSyncError)throw z;this.L.error(z,M)}}if(T===void 0)try{const z=await this.G.resolveResourceContent(this.resource,v.ref,this.collection,this.z);T=z===null?null:this.ib(z),await this.gb({ref:v.ref,syncData:T})}catch(z){if(z instanceof S.UserDataSyncError&&z.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw z}return T===void 0?null:{...v,syncData:T}}async db(m,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const A=this.I.getResourceSyncStateVersion(this.resource),T={ref:m.ref,version:A,...v};this.F.store(this.v,JSON.stringify(T),-1,1),await this.gb(m)}eb(){return this.F.get(this.v,-1)}async fb(){const m=(await this.C.readFile(this.u)).value.toString();try{const v=m?JSON.parse(m):void 0;if(i(v))return v}catch(v){this.L.error(v)}}async gb(m){await this.C.writeFile(this.u,l.VSBuffer.fromString(JSON.stringify(m)))}async hb(){try{const m=await this.C.readFile(this.u),v=JSON.parse(m.value.toString());await this.C.del(this.u),v.ref&&v.content!==void 0?(this.F.store(this.v,JSON.stringify({...v,content:void 0}),-1,1),await this.gb({ref:v.ref,syncData:v.content===null?null:JSON.parse(v.content)})):this.L.info(`${this.y}: Migrating last sync user data. Invalid data.`,v)}catch(m){m instanceof d.FileOperationError&&m.fileOperationResult===1?this.L.info(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(m)}return this.F.get(this.v,-1)}async getRemoteUserData(m){const{ref:v,content:A}=await this.jb(m);let T=null;return A!==null&&(T=this.ib(A)),{ref:v,syncData:T}}ib(m){try{const v=JSON.parse(m);if(r(v))return v}catch(v){this.L.error(v)}throw new S.UserDataSyncError((0,w.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async jb(m){const v=m?{ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null}:null;return this.G.readResource(this.resource,v,this.collection,this.z)}async kb(m,v){const A=await this.j,T={version:this.nb,machineId:A,content:m};try{return v=await this.G.writeResource(this.resource,JSON.stringify(T),v,this.collection,this.z),{ref:v,syncData:T}}catch(M){throw M instanceof S.UserDataSyncError&&M.code==="TooLarge"&&(M=new S.UserDataSyncError(M.message,M.code,this.resource)),M}}async lb(m){const v={version:this.nb,content:m};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(v))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.ab([]),await this.Z(),this.P("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}mb(){return this.M.getValue(S.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};n=ye([X(2,d.IFileService),X(3,p.IEnvironmentService),X(4,u.IStorageService),X(5,S.IUserDataSyncStoreService),X(6,S.IUserDataSyncBackupStoreService),X(7,S.IUserDataSyncEnablementService),X(8,g.ITelemetryService),X(9,S.IUserDataSyncLogService),X(10,y.IConfigurationService),X(11,f.IUriIdentityService)],n),e.AbstractSynchroniser=n;let s=class extends n{constructor(m,v,A,T,M,z,H,J,W,N,j,q,x){super(v,A,T,M,z,H,J,W,N,j,q,x),this.i=m,this.B(this.C.watch(this.h.dirname(m))),this.B(this.C.onDidFilesChange(Y=>this.ub(Y)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(m,v,A){try{v?await this.C.writeFile(this.i,l.VSBuffer.fromString(m),A?void 0:v):await this.C.createFile(this.i,l.VSBuffer.fromString(m),{overwrite:A})}catch(T){throw T instanceof d.FileOperationError&&T.fileOperationResult===1||T instanceof d.FileOperationError&&T.fileOperationResult===3?new S.UserDataSyncError(T.message,"LocalPreconditionFailed"):T}}async tb(){try{await this.C.del(this.i)}catch(m){if(!(m instanceof d.FileOperationError&&m.fileOperationResult===1))throw m}}ub(m){!m.contains(this.i)||this.N()}};s=ye([X(3,d.IFileService),X(4,p.IEnvironmentService),X(5,u.IStorageService),X(6,S.IUserDataSyncStoreService),X(7,S.IUserDataSyncBackupStoreService),X(8,S.IUserDataSyncEnablementService),X(9,g.ITelemetryService),X(10,S.IUserDataSyncLogService),X(11,y.IConfigurationService),X(12,f.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let a=class extends s{constructor(m,v,A,T,M,z,H,J,W,N,j,q,x,Y){super(m,v,A,T,M,z,H,J,W,N,j,x,Y),this.vb=q,this.xb=void 0}wb(m,v){const A=[],T=(0,P.parse)(m,A,{allowEmptyContent:!0,allowTrailingComma:!0});return A.length>0||!(0,I.isUndefined)(T)&&v!==Array.isArray(T)}yb(){return this.xb||(this.xb=this.vb.resolveFormattingOptions(this.i)),this.xb}};a=ye([X(3,d.IFileService),X(4,p.IEnvironmentService),X(5,u.IStorageService),X(6,S.IUserDataSyncStoreService),X(7,S.IUserDataSyncBackupStoreService),X(8,S.IUserDataSyncEnablementService),X(9,g.ITelemetryService),X(10,S.IUserDataSyncLogService),X(11,S.IUserDataSyncUtilService),X(12,y.IConfigurationService),X(13,f.IUriIdentityService)],a),e.AbstractJsonFileSynchroniser=a;let o=class{constructor(m,v,A,T,M,z,H){this.resource=m,this.g=v,this.h=A,this.j=T,this.k=M,this.l=z,this.d=H.extUri,this.f=(0,S.getLastSyncResourceUri)(void 0,this.resource,A,this.d)}async initialize({ref:m,content:v}){if(!v){this.j.info("Remote content does not exist.",this.resource);return}const A=this.m(v);if(!!A)try{await this.o({ref:m,syncData:A})}catch(T){this.j.error(T)}}m(m){try{const v=JSON.parse(m);if(r(v))return v}catch(v){this.j.error(v)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(m,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const A={ref:m.ref,version:void 0,...v};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(A),-1,1),await this.k.writeFile(this.f,l.VSBuffer.fromString(JSON.stringify(m)))}};o=ye([X(1,R.IUserDataProfilesService),X(2,p.IEnvironmentService),X(3,E.ILogService),X(4,d.IFileService),X(5,u.IStorageService),X(6,f.IUriIdentityService)],o),e.AbstractInitializer=o}),define(re[121],oe([0,1,6,25,9,3,42,2,27,17,15,120,29,33,78,14,5,69,8,20,19,30,18,41,256,118,24,60]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g,f,S,R,i,r,t,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function o(M,z){const H=JSON.parse(M.content);if(M.version===1||M.version===2){const J=(await z.getInstalled(0)).filter(W=>W.isBuiltin);for(const W of H)M.version===1&&(W.enabled===!1&&(W.disabled=!0),delete W.enabled),M.version===2&&J.every(N=>!(0,p.areSameExtensions)(N.identifier,W.identifier))&&(W.installed=!0)}return H}function h(M){return JSON.parse(M.content)}e.parseExtensions=h;function m(M,z){return M.sort((H,J)=>!H.identifier.uuid&&J.identifier.uuid?-1:H.identifier.uuid&&!J.identifier.uuid?1:(0,C.compare)(H.identifier.id,J.identifier.id)),z?(0,k.toFormattedString)(M,{}):JSON.stringify(M)}e.stringify=m;let v=class extends r.AbstractSynchroniser{constructor(z,H,J,W,N,j,q,x,Y,F,Z,te,se,ae,V,B,U){super({syncResource:"extensions",profile:z},H,W,J,N,j,q,te,se,F,Z,V),this.zb=x,this.Ab=Y,this.Bb=U,this.nb=5,this.tb=this.h.joinPath(this.g,"extensions.json"),this.ub=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.vb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.wb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.xb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.yb=this.Bb.createInstance(A),this.B(D.Event.any(D.Event.filter(this.zb.onDidInstallExtensions,$=>$.some(({local:G})=>!!G)),D.Event.filter(this.zb.onDidUninstallExtension,$=>!$.error),D.Event.filter(B.onDidChange,$=>$.valueChanges.some(({profile:G,changes:ee})=>this.syncResource.profile.id===G.id&&ee.some(K=>K.key===y.DISABLED_EXTENSIONS_STORAGE_PATH))),ae.onDidChangeExtensionStorageToSync)(()=>this.N()))}async ob(z,H){const J=z.syncData?await o(z.syncData,this.zb):null,W=H?.skippedExtensions??[],N=H?.builtinExtensions??null,j=H?.syncData?await o(H.syncData,this.zb):null,{localExtensions:q,ignoredExtensions:x}=await this.yb.getLocalExtensions(this.syncResource.profile);J?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:Y,remote:F}=(0,t.merge)(q,J,j,W,x,N),Z={local:Y,remote:F,content:this.Eb(q,Y.added,Y.updated,Y.removed),localChange:Y.added.length>0||Y.removed.length>0||Y.updated.length>0?2:0,remoteChange:F!==null?2:0},te=this.Lb(q,!1);return[{skippedExtensions:W,builtinExtensions:N,baseResource:this.ub,baseContent:j?this.Lb(j,!1):te,localResource:this.vb,localContent:te,localExtensions:q,remoteResource:this.wb,remoteExtensions:J,remoteContent:J?this.Lb(J,!1):null,previewResource:this.tb,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.xb}]}async sb(z){const H=z.syncData?await o(z.syncData,this.zb):null,{localExtensions:J,ignoredExtensions:W}=await this.yb.getLocalExtensions(this.syncResource.profile),{remote:N}=(0,t.merge)(J,H,H,z.skippedExtensions||[],W,z.builtinExtensions||[]);return N!==null}Eb(z,H,J,W){const N=[...H,...J],j=new Set,q=x=>{j.add(x.id.toLowerCase()),x.uuid&&j.add(x.uuid)};N.forEach(({identifier:x})=>q(x)),W.forEach(q);for(const x of z)j.has(x.identifier.id.toLowerCase())||x.identifier.uuid&&j.has(x.identifier.uuid)||N.push(x);return this.Lb(N,!1)}async pb(z,H){return{...z.previewResult,hasConflicts:!1}}async qb(z,H,J,W){if(this.h.isEqual(H,this.vb))return this.Hb(z);if(this.h.isEqual(H,this.wb))return this.Ib(z);if(this.h.isEqual(H,this.tb))return z.previewResult;throw new Error(`Invalid Resource: ${H.toString()}`)}async Hb(z){const H=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),J=this.Ab.getIgnoredExtensions(H),W=(0,t.merge)(z.localExtensions,null,null,z.skippedExtensions,J,z.builtinExtensions),{local:N,remote:j}=W;return{content:z.localContent,local:N,remote:j,localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:j!==null?2:0}}async Ib(z){const H=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),J=this.Ab.getIgnoredExtensions(H),W=z.remoteContent?JSON.parse(z.remoteContent):null;if(W!==null){const N=(0,t.merge)(z.localExtensions,W,z.localExtensions,[],J,z.builtinExtensions),{local:j,remote:q}=N;return{content:z.remoteContent,local:j,remote:q,localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:q!==null?2:0}}else return{content:z.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(z,H,J,W){let{skippedExtensions:N,builtinExtensions:j,localExtensions:q}=J[0][0];const{local:x,remote:Y,localChange:F,remoteChange:Z}=J[0][1];if(F===0&&Z===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),F!==0&&(await this.lb(JSON.stringify(q)),N=await this.yb.updateLocalExtensions(x.added,x.removed,x.updated,N,this.syncResource.profile)),Y){this.L.trace(`${this.y}: Updating remote extensions...`);const te=JSON.stringify(Y.all);z=await this.kb(te,W?null:z.ref),this.L.info(`${this.y}: Updated remote extensions.${Y.added.length?` Added: ${JSON.stringify(Y.added.map(se=>se.identifier.id))}.`:""}${Y.updated.length?` Updated: ${JSON.stringify(Y.updated.map(se=>se.identifier.id))}.`:""}${Y.removed.length?` Removed: ${JSON.stringify(Y.removed.map(se=>se.identifier.id))}.`:""}`)}H?.ref!==z.ref&&(this.L.trace(`${this.y}: Updating last synchronized extensions...`),j=this.Kb(q,j),await this.db(z,{skippedExtensions:N,builtinExtensions:j}),this.L.info(`${this.y}: Updated last synchronized extensions.${N.length?` Skipped: ${JSON.stringify(N.map(te=>te.identifier.id))}.`:""}`))}Kb(z,H){const J=new Set,W=[];for(const N of z)J.add(N.identifier.id.toLowerCase()),N.installed||W.push(N.identifier);if(H)for(const N of H)J.has(N.id.toLowerCase())||W.push(N);return W}async resolveContent(z){if(this.h.isEqual(this.wb,z)||this.h.isEqual(this.ub,z)||this.h.isEqual(this.vb,z)||this.h.isEqual(this.xb,z)){const H=await this.bb(z);return H&&this.Lb(JSON.parse(H),!0)}return null}Lb(z,H){return m(z,H)}async hasLocalData(){try{const{localExtensions:z}=await this.yb.getLocalExtensions(this.syncResource.profile);if(z.some(H=>H.installed||H.disabled))return!0}catch{}return!1}};v=ye([X(2,I.IEnvironmentService),X(3,E.IFileService),X(4,f.IStorageService),X(5,s.IUserDataSyncStoreService),X(6,s.IUserDataSyncBackupStoreService),X(7,y.IExtensionManagementService),X(8,n.IIgnoredExtensionsManagementService),X(9,s.IUserDataSyncLogService),X(10,b.IConfigurationService),X(11,s.IUserDataSyncEnablementService),X(12,S.ITelemetryService),X(13,d.IExtensionStorageService),X(14,R.IUriIdentityService),X(15,a.IUserDataProfileStorageService),X(16,c.IInstantiationService)],v),e.ExtensionsSynchroniser=v;let A=class{constructor(z,H,J,W,N,j){this.a=z,this.b=H,this.c=J,this.d=W,this.f=N,this.g=j}async getLocalExtensions(z){const H=await this.a.getInstalled(void 0,z.extensionsResource),J=this.d.getIgnoredExtensions(H);return{localExtensions:await this.j(z,async(N,j)=>{const q=N.getDisabledExtensions();return H.map(x=>{const{identifier:Y,isBuiltin:F,manifest:Z,preRelease:te,pinned:se}=x,ae={identifier:Y,preRelease:te,version:Z.version,pinned:!!se};q.some(V=>(0,p.areSameExtensions)(V,Y))&&(ae.disabled=!0),F||(ae.installed=!0);try{const V=j.getKeysForSync({id:Y.id,version:Z.version});if(V){const B=j.getExtensionState(x,!0)||{};ae.state=Object.keys(B).reduce((U,$)=>(V.includes($)&&(U[$]=B[$]),U),{})}}catch(V){this.g.info(`${(0,r.getSyncResourceLogLabel)("extensions",z)}: Error while parsing extension state`,(0,l.getErrorMessage)(V))}return ae})}),ignoredExtensions:J}}async updateLocalExtensions(z,H,J,W,N){const j=(0,r.getSyncResourceLogLabel)("extensions",N),q=[],x=[],Y=[],F=await this.a.getInstalled(void 0,N.extensionsResource);if((z.length||J.length)&&await this.j(N,async(te,se)=>{await L.Promises.settled([...z,...J].map(async ae=>{const V=F.find($=>(0,p.areSameExtensions)($.identifier,ae.identifier));if(V&&V.isBuiltin){ae.state&&V.manifest.version===ae.version&&this.h(ae.state,V,V.manifest.version,se),te.getDisabledExtensions().some(G=>(0,p.areSameExtensions)(G,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.g.trace(`${j}: Disabling extension...`,ae.identifier.id),await te.disableExtension(ae.identifier),this.g.info(`${j}: Disabled extension`,ae.identifier.id)):(this.g.trace(`${j}: Enabling extension...`,ae.identifier.id),await te.enableExtension(ae.identifier),this.g.info(`${j}: Enabled extension`,ae.identifier.id))),x.push(ae.identifier);return}const B=ae.pinned?ae.version:void 0,U=(await this.c.getExtensions([{...ae.identifier,version:B,preRelease:B?void 0:ae.preRelease}],O.CancellationToken.None))[0];if(ae.state&&(V?V.manifest.version===ae.version:!!U)&&this.h(ae.state,V||U,V?.manifest.version,se),U)try{te.getDisabledExtensions().some(G=>(0,p.areSameExtensions)(G,ae.identifier))!==!!ae.disabled&&(ae.disabled?(this.g.trace(`${j}: Disabling extension...`,ae.identifier.id,U.version),await te.disableExtension(U.identifier),this.g.info(`${j}: Disabled extension`,ae.identifier.id,U.version)):(this.g.trace(`${j}: Enabling extension...`,ae.identifier.id,U.version),await te.enableExtension(U.identifier),this.g.info(`${j}: Enabled extension`,ae.identifier.id,U.version))),(!V||V.preRelease!==ae.preRelease||V.pinned!==ae.pinned||B&&V.manifest.version!==B)&&(await this.a.canInstall(U)?q.push([ae,U]):(this.g.info(`${j}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),Y.push(ae)))}catch($){Y.push(ae),this.g.error($),this.g.info(`${j}: Skipped synchronizing extension`,U.displayName||U.identifier.id)}else Y.push(ae),this.g.info(`${j}: Skipped synchronizing extension because the extension is not found.`,ae.identifier.id)}))}),H.length){const te=F.filter(({identifier:se,isBuiltin:ae})=>!ae&&H.some(V=>(0,p.areSameExtensions)(se,V)));await L.Promises.settled(te.map(async se=>{this.g.trace(`${j}: Uninstalling local extension...`,se.identifier.id),await this.a.uninstall(se,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:N.extensionsResource}),this.g.info(`${j}: Uninstalled local extension.`,se.identifier.id),x.push(se.identifier)}))}for(const[te,se]of q)try{this.g.trace(`${j}: Installing extension...`,se.identifier.id,se.version),await this.a.installFromGallery(se,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:te.pinned&&!!te.version,installPreReleaseVersion:te.preRelease,profileLocation:N.extensionsResource,context:{[y.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[y.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.g.info(`${j}: Installed extension.`,se.identifier.id,se.version),x.push(se.identifier)}catch(ae){Y.push(te),ae instanceof y.ExtensionManagementError&&[y.ExtensionManagementErrorCode.Incompatible,y.ExtensionManagementErrorCode.IncompatiblePreRelease,y.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(ae.code)?this.g.info(`${j}: Skipped synchronizing extension because the compatible extension is not found.`,se.displayName||se.identifier.id):(this.g.error(ae),this.g.info(`${j}: Skipped synchronizing extension`,se.displayName||se.identifier.id))}const Z=[];for(const te of W)x.some(se=>(0,p.areSameExtensions)(se,te.identifier))||Z.push(te);for(const te of Y)Z.some(se=>(0,p.areSameExtensions)(se.identifier,te.identifier))||Z.push(te);return Z}h(z,H,J,W){const N=W.getExtensionState(H,!0)||{},j=J?W.getKeysForSync({id:H.identifier.id,version:J}):void 0;j?j.forEach(q=>{N[q]=z[q]}):Object.keys(z).forEach(q=>N[q]=z[q]),W.setExtensionState(H,N,!0)}async j(z,H){return this.b.withProfileScopedStorageService(z,async J=>{const W=new P.DisposableStore,N=this.f.createChild(new u.ServiceCollection([f.IStorageService,J])),j=W.add(N.createInstance(w.GlobalExtensionEnablementService)),q=W.add(N.createInstance(d.ExtensionStorageService));try{return await H(j,q)}finally{W.dispose()}})}};A=ye([X(0,y.IExtensionManagementService),X(1,a.IUserDataProfileStorageService),X(2,y.IExtensionGalleryService),X(3,n.IIgnoredExtensionsManagementService),X(4,c.IInstantiationService),X(5,s.IUserDataSyncLogService)],A),e.LocalExtensionsProvider=A;let T=class extends r.AbstractInitializer{constructor(z,H,J,W,N,j,q,x){super("extensions",W,N,j,J,q,x),this.p=z,this.q=H}async t(z){return z.syncData?await o(z.syncData,this.p):null}u(z,H){const J=[],W=[],N=[];for(const j of z){if(this.q.hasToNeverSyncExtension(j.identifier.id))continue;const q=H.find(x=>(0,p.areSameExtensions)(x.identifier,j.identifier));q?(J.push(q),j.disabled&&N.push(j.identifier)):j.installed&&(W.push({...j.identifier,preRelease:!!j.preRelease}),j.disabled&&N.push(j.identifier))}return{installedExtensions:J,newExtensions:W,disabledExtensions:N,remoteExtensions:z}}};T=ye([X(0,y.IExtensionManagementService),X(1,n.IIgnoredExtensionsManagementService),X(2,E.IFileService),X(3,i.IUserDataProfilesService),X(4,I.IEnvironmentService),X(5,g.ILogService),X(6,f.IStorageService),X(7,R.IUriIdentityService)],T),e.AbstractExtensionsInitializer=T}),define(re[122],oe([0,1,16,9,3,35,42,4,31,17,15,14,8,44,20,19,30,41,59,260,24,18,60,5]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g,f,S,R,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",n=["locale"];function s(A,T){const M=A.storage?Object.keys(A.storage).sort():[],z={};return M.forEach(H=>z[H]=A.storage[H]),A.storage=z,T?(0,k.toFormattedString)(A,{}):JSON.stringify(A)}e.stringify=s;const a=1;let o=class extends u.AbstractSynchroniser{constructor(T,M,z,H,J,W,N,j,q,x,Y,F,Z,te){super({syncResource:"globalState",profile:T},M,H,j,F,J,W,q,x,N,Y,Z),this.xb=z,this.nb=a,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.tb=this.p.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.ub=this.p.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.vb=this.p.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.wb=te.createInstance(h),this.B(H.watch(this.h.dirname(this.D.argvResource))),this.B(l.Event.any(l.Event.filter(H.onDidFilesChange,se=>se.contains(this.D.argvResource)),l.Event.filter(z.onDidChange,se=>!!(se.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||se.valueChanges.some(({profile:ae,changes:V})=>this.syncResource.profile.id===ae.id&&V.some(B=>B.target===0)))))(()=>this.N()))}async ob(T,M,z){const H=T.syncData?JSON.parse(T.syncData.content):null;M=M===null&&z?T:M;const J=M&&M.syncData?JSON.parse(M.syncData.content):null,W=await this.wb.getLocalGlobalState(this.syncResource.profile);H?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const N=await this.Fb(J),{local:j,remote:q}=(0,f.merge)(W.storage,H?H.storage:null,J?J.storage:null,N,this.L),x={content:null,local:j,remote:q,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:q.all!==null?2:0},Y=s(W,!1);return[{baseResource:this.r,baseContent:J?s(J,!1):Y,localResource:this.tb,localContent:Y,localUserData:W,remoteResource:this.ub,remoteContent:H?s(H,!1):null,previewResource:this.p,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.vb,storageKeys:N}]}async sb(T){const M=T.syncData?JSON.parse(T.syncData.content):null;if(M===null)return!0;const z=await this.wb.getLocalGlobalState(this.syncResource.profile),H=await this.Fb(M),{remote:J}=(0,f.merge)(z.storage,M.storage,M.storage,H,this.L);return J.all!==null}async pb(T,M){return{...T.previewResult,hasConflicts:!1}}async qb(T,M,z,H){if(this.h.isEqual(M,this.tb))return this.Cb(T);if(this.h.isEqual(M,this.ub))return this.Db(T);if(this.h.isEqual(M,this.p))return T.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Cb(T){return{content:T.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(T.localUserData.storage),removed:[],updated:[],all:T.localUserData.storage},localChange:0,remoteChange:2}}async Db(T){if(T.remoteContent!==null){const M=JSON.parse(T.remoteContent),{local:z,remote:H}=(0,f.merge)(T.localUserData.storage,M.storage,null,T.storageKeys,this.L);return{content:T.remoteContent,local:z,remote:H,localChange:Object.keys(z.added).length>0||Object.keys(z.updated).length>0||z.removed.length>0?2:0,remoteChange:H!==null?2:0}}else return{content:T.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async rb(T,M,z,H){const{localUserData:J}=z[0][0],{local:W,remote:N,localChange:j,remoteChange:q}=z[0][1];if(j===0&&q===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),j!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.lb(JSON.stringify(J)),await this.wb.writeLocalGlobalState(W,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),q!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const x=JSON.stringify({storage:N.all});T=await this.kb(x,H?null:T.ref),this.L.info(`${this.y}: Updated remote ui state.${N.added.length?` Added: ${N.added}.`:""}${N.updated.length?` Updated: ${N.updated}.`:""}${N.removed.length?` Removed: ${N.removed}.`:""}`)}M?.ref!==T.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.db(T),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(T){if(this.h.isEqual(this.ub,T)||this.h.isEqual(this.r,T)||this.h.isEqual(this.tb,T)||this.h.isEqual(this.vb,T)){const M=await this.bb(T);return M&&s(JSON.parse(M),!0)}return null}async hasLocalData(){try{const{storage:T}=await this.wb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(T).length>1||T[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Fb(T){const M=await this.xb.readStorageData(this.syncResource.profile),z=[],H=[];for(const[N,j]of M)j.target===0?z.push(N):j.target===1&&H.push(N);const J=[...z,...H],W=T?.storage?Object.keys(T.storage).filter(N=>!N.startsWith(t)&&!J.includes(N)&&M.get(N)!==void 0):[];if(!P.isWeb){const N=[...S.ALL_SYNC_RESOURCES.map(j=>(0,S.getEnablementKey)(j)),S.SYNC_SERVICE_URL_TYPE];W.push(...N),H.push(...N)}return{user:z,machine:H,unregistered:W}}};o=ye([X(2,i.IUserDataProfileStorageService),X(3,w.IFileService),X(4,S.IUserDataSyncStoreService),X(5,S.IUserDataSyncBackupStoreService),X(6,S.IUserDataSyncLogService),X(7,I.IEnvironmentService),X(8,S.IUserDataSyncEnablementService),X(9,E.ITelemetryService),X(10,b.IConfigurationService),X(11,d.IStorageService),X(12,c.IUriIdentityService),X(13,r.IInstantiationService)],o),e.GlobalStateSynchroniser=o;let h=class{constructor(T,M,z,H){this.a=T,this.b=M,this.c=z,this.d=H}async getLocalGlobalState(T){const M={};if(T.isDefault){const H=await this.f(),J=(0,D.parse)(H);for(const W of n)J[W]!==void 0&&(M[`${t}${W}`]={version:1,value:J[W]})}const z=await this.c.readStorageData(T);for(const[H,J]of z)J.value&&J.target===0&&(M[H]={version:1,value:J.value});return{storage:M}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const T=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),T.value.toString()}catch(T){this.d.debug((0,O.getErrorMessage)(T))}return"{}"}async writeLocalGlobalState({added:T,removed:M,updated:z},H){const J=(0,u.getSyncResourceLogLabel)("globalState",H),W={},N=new Map,j=await this.c.readStorageData(H),q=(x,Y)=>{for(const F of x){if(F.startsWith(t)){W[F.substring(t.length)]=Y?Y[F].value:void 0;continue}if(Y){const Z=Y[F];Z.value!==j.get(F)?.value&&N.set(F,Z.value)}else j.get(F)!==void 0&&N.set(F,void 0)}};if(q(Object.keys(T),T),q(Object.keys(z),z),q(M),Object.keys(W).length){this.d.trace(`${J}: Updating locale...`);const x=await this.f();let Y=x;for(const F of Object.keys(W))Y=(0,g.edit)(Y,[F],W[F],{});x!==Y&&(this.d.trace(`${J}: Updating locale...`),await this.a.writeFile(this.b.argvResource,L.VSBuffer.fromString(Y)),this.d.info(`${J}: Updated locale.`)),this.d.info(`${J}: Updated locale`)}N.size&&(this.d.trace(`${J}: Updating global state...`),await this.c.updateStorageData(H,N,0),this.d.info(`${J}: Updated global state`,[...N.keys()]))}};h=ye([X(0,w.IFileService),X(1,I.IEnvironmentService),X(2,i.IUserDataProfileStorageService),X(3,S.IUserDataSyncLogService)],h),e.LocalGlobalStateProvider=h;let m=class extends u.AbstractInitializer{constructor(T,M,z,H,J,W){super("globalState",z,H,J,M,T,W)}async o(T){const M=T.syncData?JSON.parse(T.syncData.content):null;if(!M){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const z={},H={};for(const J of Object.keys(M.storage))J.startsWith(t)?z[J.substring(t.length)]=M.storage[J].value:this.l.get(J,0)===void 0&&(H[J]=M.storage[J].value);if(Object.keys(z).length){let J="{}";try{J=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const W of Object.keys(z))J=(0,g.edit)(J,[W],z[W],{});await this.k.writeFile(this.h.argvResource,L.VSBuffer.fromString(J))}if(Object.keys(H).length)for(const J of Object.keys(H))this.l.store(J,H[J],0,0)}};m=ye([X(0,d.IStorageService),X(1,w.IFileService),X(2,R.IUserDataProfilesService),X(3,I.IEnvironmentService),X(4,S.IUserDataSyncLogService),X(5,c.IUriIdentityService)],m),e.GlobalStateInitializer=m;let v=class{constructor(T,M,z,H,J){this.a=T,this.b=M,this.c=z,this.d=H,this.f=J}getSyncStoreType(T){return this.h(T)?.storage[S.SYNC_SERVICE_URL_TYPE]?.value}async sync(T){const M=(0,S.createSyncHeaders)((0,C.generateUuid)());try{return await this.g(T,M)}catch(z){if(z instanceof S.UserDataSyncError)switch(z.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(T,M)}throw z}}async g(T,M){const z=await this.a.readResource("globalState",null,void 0,M),H=this.h(z)||{storage:{}};H.storage[S.SYNC_SERVICE_URL_TYPE]={value:T,version:a};const J=await(0,p.getServiceMachineId)(this.c,this.d,this.b),W={version:a,machineId:J,content:s(H,!1)};await this.a.writeResource("globalState",JSON.stringify(W),z.ref,void 0,M)}h({content:T}){if(!T)return null;const M=JSON.parse(T);if((0,u.isSyncData)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};v=ye([X(1,d.IStorageService),X(2,I.IEnvironmentService),X(3,w.IFileService),X(4,y.ILogService)],v),e.UserDataSyncStoreTypeSynchronizer=v}),define(re[123],oe([0,1,21,16,3,35,4,12,181,17,15,14,20,19,30,18,41,257,24]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function f(i,r,t){try{const n=JSON.parse(i);if(!r)return(0,P.isUndefined)(n.all)?null:n.all;switch(k.OS){case 2:return(0,P.isUndefined)(n.mac)?null:n.mac;case 3:return(0,P.isUndefined)(n.linux)?null:n.linux;case 1:return(0,P.isUndefined)(n.windows)?null:n.windows}}catch(n){return t.error(n),null}}e.getKeybindingsContentFromSyncContent=f;let S=class extends c.AbstractJsonFileSynchroniser{constructor(r,t,n,s,a,o,h,m,v,A,T,M,z){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},t,m,v,A,n,s,h,M,a,T,o,z),this.nb=2,this.Ab=this.h.joinPath(this.g,"keybindings.json"),this.Bb=this.Ab.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Cb=this.Ab.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Db=this.Ab.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Eb=this.Ab.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(l.Event.filter(o.onDidChangeConfiguration,H=>H.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.N()))}async ob(r,t,n,s){const a=r.syncData?f(r.syncData.content,s.keybindingsPerPlatform??this.Mb(),this.L):null;t=t===null&&n?r:t;const o=t?this.Kb(t):null,h=await this.p(),m=await this.yb();let v=null,A=!1,T=!1,M=!1;if(a){let J=h?h.value.toString():"[]";if(J=J||"[]",this.wb(J,!0))throw new g.UserDataSyncError((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==J||o!==a){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const W=await(0,u.merge)(J,a,o,m,this.vb);W.hasChanges&&(v=W.mergeContent,M=W.hasConflicts,A=M||W.mergeContent!==J,T=M||W.mergeContent!==a)}}else h&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=h.value.toString(),T=!0);const z={content:M?o:v,localChange:A?h?2:1:0,remoteChange:T?2:0,hasConflicts:M},H=h?h.value.toString():null;return[{fileContent:h,baseResource:this.Bb,baseContent:o,localResource:this.Cb,localContent:H,localChange:z.localChange,remoteResource:this.Db,remoteContent:a,remoteChange:z.remoteChange,previewResource:this.Ab,previewResult:z,acceptedResource:this.Eb}]}async sb(r){const t=this.Kb(r);if(t===null)return!0;const n=await this.p(),s=n?n.value.toString():"",a=await this.yb(),o=await(0,u.merge)(s||"[]",t,t,a,this.vb);return o.hasConflicts||o.mergeContent!==t}async pb(r,t){return r.previewResult}async qb(r,t,n,s){if(this.h.isEqual(t,this.Cb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Db))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.Ab))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(r,t,n,s){const{fileContent:a}=n[0][0];let{content:o,localChange:h,remoteChange:m}=n[0][1];if(h===0&&m===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.wb(o,!0)))throw new g.UserDataSyncError((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(h!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),a&&await this.lb(this.Lb(a.value.toString())),await this.r(o||"[]",a,s),this.L.info(`${this.y}: Updated local keybindings`)),m!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const v=this.Lb(o||"[]",r.syncData?.content);r=await this.kb(v,s?null:r.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.Ab)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.db(r,{platformSpecific:this.Mb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=(0,D.parse)(r.value.toString());if((0,L.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Db,r)||this.h.isEqual(this.Bb,r)||this.h.isEqual(this.Cb,r)||this.h.isEqual(this.Eb,r)?this.bb(r):null}Kb(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Mb()?null:f(r.syncData.content,this.Mb(),this.L)}Lb(r,t){let n={};try{n=JSON.parse(t||"{}")}catch(s){this.L.error(s)}switch(this.Mb()?delete n.all:n.all=r,k.OS){case 2:n.mac=r;break;case 3:n.linux=r;break;case 1:n.windows=r;break}return JSON.stringify(n)}Mb(){return!!this.M.getValue(g.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};S=ye([X(2,g.IUserDataSyncStoreService),X(3,g.IUserDataSyncBackupStoreService),X(4,g.IUserDataSyncLogService),X(5,b.IConfigurationService),X(6,g.IUserDataSyncEnablementService),X(7,w.IFileService),X(8,I.IEnvironmentService),X(9,y.IStorageService),X(10,g.IUserDataSyncUtilService),X(11,p.ITelemetryService),X(12,d.IUriIdentityService)],S),e.KeybindingsSynchroniser=S;let R=class extends c.AbstractInitializer{constructor(r,t,n,s,a,o){super("keybindings",t,n,s,r,a,o)}async o(r){const t=r.syncData?this.p(r.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,O.VSBuffer.fromString(t)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,D.parse)(r.value.toString());return!(0,L.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}p(r){try{return f(r,!0,this.j)}catch(t){return this.j.error(t),null}}};R=ye([X(0,w.IFileService),X(1,E.IUserDataProfilesService),X(2,I.IEnvironmentService),X(3,g.IUserDataSyncLogService),X(4,y.IStorageService),X(5,d.IUriIdentityService)],R),e.KeybindingsInitializer=R}),define(re[124],oe([0,1,16,3,182,17,72,15,29,14,20,19,30,18,41,59,261,24]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function f(i){const r=JSON.parse(i);return g(r)?r:{settings:i}}e.parseSettingsSyncContent=f;let S=class extends d.AbstractJsonFileSynchroniser{constructor(r,t,n,s,a,o,h,m,v,A,T,M,z,H){super(r.settingsResource,{syncResource:"settings",profile:r},t,n,s,a,o,h,T,M,m,v,A,H),this.Ab=z,this.nb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Kb=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),n=await this.S(r,t),s=this.Hb(n),a=new k.ConfigurationModelParser(u.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&a.parse(s.settings),a.configurationModel.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async ob(r,t,n){const s=await this.p(),a=await this.yb(),o=this.Hb(r);t=t===null&&n?r:t;const h=t?this.Hb(t):null,m=await this.Lb();let v=null,A=!1,T=!1,M=!1;if(o){let W=s?s.value.toString().trim():"{}";W=W||"{}",this.Mb(W),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const N=(0,c.merge)(W,o.settings,h?h.settings:null,m,[],a);v=N.localContent||N.remoteContent,A=N.localContent!==null,T=N.remoteContent!==null,M=N.hasConflicts}else s&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),v=s.value.toString().trim()||"{}",this.Mb(v),T=!0);const z=s?s.value.toString():null,H=h?.settings??null,J={content:M?H:v,localChange:A?2:0,remoteChange:T?2:0,hasConflicts:M};return[{fileContent:s,baseResource:this.baseResource,baseContent:H,localResource:this.localResource,localContent:z,localChange:J.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:J.remoteChange,previewResource:this.previewResource,previewResult:J,acceptedResource:this.acceptedResource}]}async sb(r){const t=this.Hb(r);if(t===null)return!0;const n=await this.p(),s=n?n.value.toString().trim():"",a=await this.Lb(),o=await this.yb();return(0,c.merge)(s||"{}",t.settings,t.settings,a,[],o).remoteContent!==null}async pb(r,t){const n=await this.yb(),s=await this.Lb();return{...r.previewResult,content:r.previewResult.content?(0,c.updateIgnoredSettings)(r.previewResult.content,"{}",s,n):null}}async qb(r,t,n,s){const a=await this.yb(),o=await this.Lb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,c.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,a):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,c.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,a):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n!==null?(0,c.updateIgnoredSettings)(n,r.fileContent?r.fileContent.value.toString():"{}",o,a):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(r,t,n,s){const{fileContent:a}=n[0][0];let{content:o,localChange:h,remoteChange:m}=n[0][1];if(h===0&&m===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Mb(o),h!==0&&(this.L.trace(`${this.y}: Updating local settings...`),a&&await this.lb(JSON.stringify(this.Jb(a.value.toString()))),await this.r(o,a,s),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),m!==0){const v=await this.yb(),A=this.Hb(r),T=await this.Lb(o);o=(0,c.updateIgnoredSettings)(o,A?A.settings:"{}",T,v),this.L.trace(`${this.y}: Updating remote settings...`),r=await this.kb(JSON.stringify(this.Jb(o)),s?null:r.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.db(r),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=await this.yb(),n=(0,E.edit)(r.value.toString(),[u.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,c.isEmpty)(n)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.bb(r):null}async bb(r){let t=await super.bb(r);if(t){const n=await this.yb(),s=await this.Lb();t=(0,c.updateIgnoredSettings)(t,"{}",s,n)}return t}Hb(r){return r.syncData?this.Ib(r.syncData.content):null}Ib(r){try{return f(r)}catch(t){this.L.error(t)}return null}Jb(r){return{settings:r}}async Lb(r){if(!this.Kb){this.Kb=this.vb.resolveDefaultIgnoredSettings();const n=O.Event.any(O.Event.filter(this.Ab.onDidInstallExtensions,s=>s.some(({local:a})=>!!a)),O.Event.filter(this.Ab.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Kb=void 0})}const t=await this.Kb;return(0,c.getIgnoredSettings)(t,this.M,r)}Mb(r){if(this.wb(r,!1))throw new u.UserDataSyncError((0,l.localize)(0,null),"LocalInvalidContent",this.resource)}};S=ye([X(2,b.IFileService),X(3,P.IEnvironmentService),X(4,I.IStorageService),X(5,u.IUserDataSyncStoreService),X(6,u.IUserDataSyncBackupStoreService),X(7,u.IUserDataSyncLogService),X(8,u.IUserDataSyncUtilService),X(9,D.IConfigurationService),X(10,u.IUserDataSyncEnablementService),X(11,w.ITelemetryService),X(12,C.IExtensionManagementService),X(13,y.IUriIdentityService)],S),e.SettingsSynchroniser=S;let R=class extends d.AbstractInitializer{constructor(r,t,n,s,a,o){super("settings",t,n,s,r,a,o)}async o(r){const t=r.syncData?this.p(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,L.VSBuffer.fromString(t.settings)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,c.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}p(r){try{return f(r)}catch(t){this.j.error(t)}return null}};R=ye([X(0,b.IFileService),X(1,p.IUserDataProfilesService),X(2,P.IEnvironmentService),X(3,u.IUserDataSyncLogService),X(4,I.IStorageService),X(5,y.IUriIdentityService)],R),e.SettingsInitializer=R}),define(re[125],oe([0,1,16,3,32,17,15,14,20,19,30,18,41,258,24]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function E(g){return JSON.parse(g.content)}e.parseSnippets=E;let c=class extends y.AbstractSynchroniser{constructor(f,S,R,i,r,t,n,s,a,o,h,m){super({syncResource:"snippets",profile:f},S,i,R,r,t,n,o,h,s,a,m),this.nb=1,this.p=f.snippetsHome,this.B(this.C.watch(R.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(O.Event.filter(this.C.onDidFilesChange,v=>v.affects(this.p))(()=>this.N()))}async ob(f,S,R){const i=await this.Db(),r=this.Cb(i),t=f.syncData?this.Bb(f.syncData):null;S=S===null&&R?f:S;const n=S&&S.syncData?this.Bb(S.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,p.merge)(r,t,n);return this.xb(s,i,t||{},n||{})}async sb(f){const S=f.syncData?this.Bb(f.syncData):null;if(S===null)return!0;const R=await this.Db(),i=this.Cb(R),r=(0,p.merge)(i,S,S);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async pb(f,S){return f.previewResult}async qb(f,S,R,i){if(this.h.isEqualOrParent(S,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:f.fileContent?f.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(S,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:f.remoteContent,localChange:f.remoteContent!==null?f.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(S,this.g))return R===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:R,localChange:R===null?f.fileContent!==null?3:0:2,remoteChange:R===null?f.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${S.toString()}`)}async rb(f,S,R,i){const r=R.map(([t,n])=>({...t,acceptResult:n}));r.every(({localChange:t,remoteChange:n})=>t===0&&n===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),r.some(({localChange:t})=>t!==0)&&(await this.yb(r),await this.zb(r,i)),r.some(({remoteChange:t})=>t!==0)&&(f=await this.Ab(r,f,i)),S?.ref!==f.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.db(f),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of r)try{await this.C.del(t)}catch{}}xb(f,S,R,i){const r=new Map;for(const t of Object.keys(f.local.added)){const n={content:f.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(f.local.updated)){const n={content:f.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=S[t]?S[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of f.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=S[t]?S[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(f.remote.added)){const n={content:f.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=S[t]?S[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(f.remote.updated)){const n={content:f.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=S[t]?S[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of f.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t],previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of f.conflicts){const n={content:i[t]??null,hasConflicts:!0,localChange:S[t]?2:1,remoteChange:R[t]?2:1},s=S[t]?S[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(S))if(!r.has(t)){const n={content:S[t]?S[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=S[t]?S[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:R[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(f){return this.h.isEqualOrParent(f,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(f,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(f,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(f,this.g.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.bb(f):null}async hasLocalData(){try{const f=await this.Db();if(Object.keys(f).length)return!0}catch{}return!1}async yb(f){const S={};for(const R of f)R.fileContent&&(S[this.h.basename(R.localResource)]=R.fileContent);await this.lb(JSON.stringify(this.Cb(S)))}async zb(f,S){for(const{fileContent:R,acceptResult:i,localResource:r,remoteResource:t,localChange:n}of f)if(n!==0){const s=t?this.h.basename(t):this.h.basename(r),a=this.h.joinPath(this.p,s);n===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(a)),await this.C.del(a),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(a))):n===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(a)),await this.C.createFile(a,L.VSBuffer.fromString(i.content),{overwrite:S}),this.L.info(`${this.y}: Created snippet`,this.h.basename(a))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(a)),await this.C.writeFile(a,L.VSBuffer.fromString(i.content),S?void 0:R),this.L.info(`${this.y}: Updated snippet`,this.h.basename(a)))}}async Ab(f,S,R){const i=S.syncData?this.Bb(S.syncData):{},r=(0,l.deepClone)(i);for(const{acceptResult:t,localResource:n,remoteResource:s,remoteChange:a}of f)if(a!==0){const o=n?this.h.basename(n):this.h.basename(s);a===3?delete r[o]:r[o]=t.content}return(0,p.areSame)(i,r)||(this.L.trace(`${this.y}: Updating remote snippets...`),S=await this.kb(JSON.stringify(r),R?null:S.ref),this.L.info(`${this.y}: Updated remote snippets`)),S}Bb(f){return E(f)}Cb(f){const S={};for(const R of Object.keys(f))S[R]=f[R].value.toString();return S}async Db(){const f={};let S;try{S=await this.C.resolve(this.p)}catch(R){if(R instanceof P.FileOperationError&&R.fileOperationResult===1)return f;throw R}for(const R of S.children||[]){const i=R.resource,r=this.h.extname(i);if(r===".json"||r===".code-snippets"){const t=this.h.relativePath(this.p,i),n=await this.C.readFile(i);f[t]=n}}return f}};c=ye([X(2,k.IEnvironmentService),X(3,P.IFileService),X(4,C.IStorageService),X(5,d.IUserDataSyncStoreService),X(6,d.IUserDataSyncBackupStoreService),X(7,d.IUserDataSyncLogService),X(8,D.IConfigurationService),X(9,d.IUserDataSyncEnablementService),X(10,b.ITelemetryService),X(11,I.IUriIdentityService)],c),e.SnippetsSynchroniser=c;let u=class extends y.AbstractInitializer{constructor(f,S,R,i,r,t){super("snippets",S,R,i,f,r,t)}async o(f){const S=f.syncData?JSON.parse(f.syncData.content):null;if(!S){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(S)){const r=S[i];if(r){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(t,L.VSBuffer.fromString(r)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(f)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(f){return f.fileOperationResult===1}}};u=ye([X(0,P.IFileService),X(1,w.IUserDataProfilesService),X(2,k.IEnvironmentService),X(3,d.IUserDataSyncLogService),X(4,C.IStorageService),X(5,I.IUriIdentityService)],u),e.SnippetsInitializer=u}),define(re[126],oe([0,1,16,17,15,14,20,19,30,18,41,24]),function(_,e,L,O,l,D,k,P,C,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function y(c,u){try{return JSON.parse(c).tasks??null}catch(g){return u.error(g),null}}e.getTasksContentFromSyncContent=y;let p=class extends I.AbstractFileSynchroniser{constructor(u,g,f,S,R,i,r,t,n,s,a,o){super(u.tasksResource,{syncResource:"tasks",profile:u},g,t,n,s,f,S,r,a,R,i,o),this.nb=1,this.wb=this.h.joinPath(this.g,"tasks.json"),this.xb=this.wb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.yb=this.wb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.zb=this.wb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Ab=this.wb.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async ob(u,g,f,S){const R=u.syncData?y(u.syncData.content,this.L):null;g=g===null&&f?u:g;const i=g?.syncData?y(g.syncData.content,this.L):null,r=await this.p();let t=null,n=!1,s=!1,a=!1;if(u.syncData){const m=r?r.value.toString():null;if(!i||i!==m||i!==R){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const v=E(m,R,i);t=v.content,a=v.hasConflicts,n=v.hasLocalChanged,s=v.hasRemoteChanged}}else r&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),s=!0);const o={content:a?i:t,localChange:n?r?2:1:0,remoteChange:s?2:0,hasConflicts:a},h=r?r.value.toString():null;return[{fileContent:r,baseResource:this.xb,baseContent:i,localResource:this.yb,localContent:h,localChange:o.localChange,remoteResource:this.zb,remoteContent:R,remoteChange:o.remoteChange,previewResource:this.wb,previewResult:o,acceptedResource:this.Ab}]}async sb(u){const g=u?.syncData?y(u.syncData.content,this.L):null;if(g===null)return!0;const f=await this.p(),S=f?f.value.toString():null,R=E(S,g,g);return R.hasLocalChanged||R.hasRemoteChanged}async pb(u,g){return u.previewResult}async qb(u,g,f,S){if(this.h.isEqual(g,this.yb))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(g,this.zb))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(g,this.wb))return f===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:f,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async rb(u,g,f,S){const{fileContent:R}=f[0][0],{content:i,localChange:r,remoteChange:t}=f[0][1];if(r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),r!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),R&&await this.lb(JSON.stringify(this.Gb(R.value.toString()))),i?await this.r(i,R,S):await this.tb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const n=JSON.stringify(this.Gb(i));u=await this.kb(n,S?null:u.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.wb)}catch{}g?.ref!==u.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.db(u),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(u){return this.h.isEqual(this.zb,u)||this.h.isEqual(this.xb,u)||this.h.isEqual(this.yb,u)||this.h.isEqual(this.Ab,u)?this.bb(u):null}Gb(u){return u?{tasks:u}:{}}};p=ye([X(2,w.IUserDataSyncStoreService),X(3,w.IUserDataSyncBackupStoreService),X(4,w.IUserDataSyncLogService),X(5,O.IConfigurationService),X(6,w.IUserDataSyncEnablementService),X(7,D.IFileService),X(8,l.IEnvironmentService),X(9,k.IStorageService),X(10,P.ITelemetryService),X(11,C.IUriIdentityService)],p),e.TasksSynchroniser=p;let d=class extends I.AbstractInitializer{constructor(u,g,f,S,R,i){super("tasks",g,f,S,u,R,i),this.c=this.g.defaultProfile.tasksResource}async o(u){const g=u.syncData?y(u.syncData.content,this.j):null;if(!g){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,L.VSBuffer.fromString(g)),await this.n(u)}async p(){return this.k.exists(this.c)}};d=ye([X(0,D.IFileService),X(1,b.IUserDataProfilesService),X(2,l.IEnvironmentService),X(3,w.IUserDataSyncLogService),X(4,k.IStorageService),X(5,C.IUriIdentityService)],d),e.TasksInitializer=d;function E(c,u,g){if(c===null&&u===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(c===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const f=g!==c,S=g!==u;return!f&&!S?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:f&&!S?{content:c,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:S&&!f?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:c,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[127],oe([0,1,42,17,15,14,20,19,30,18,41,259,24]),function(_,e,L,O,l,D,k,P,C,b,I,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let p=class extends I.AbstractSynchroniser{constructor(u,g,f,S,R,i,r,t,n,s,a,o,h){super({syncResource:"profiles",profile:u},g,S,R,i,r,t,a,o,n,s,h),this.r=f,this.nb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?E(u.syncData):null}async getRemoteSyncedProfiles(u){const g=await this.getLastSyncUserData(),f=await this.S(u,g);return f?.syncData?E(f.syncData):null}async ob(u,g,f){if(!this.r.isEnabled())throw new y.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const S=u.syncData?E(u.syncData):null,R=g?.syncData?E(g.syncData):null,i=this.Ab(),{local:r,remote:t}=(0,w.merge)(i,S,R,[]),n={local:r,remote:t,content:R?this.Bb(R):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:t!==null?2:0},s=d(i,!1);return[{baseResource:this.baseResource,baseContent:R?this.Bb(R):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:S?this.Bb(S):null,remoteProfiles:S,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async sb(u){const g=u?.syncData?E(u.syncData):null,f=this.Ab(),{remote:S}=(0,w.merge)(f,g,g,[]);return!!S?.added.length||!!S?.removed.length||!!S?.updated.length}async pb(u,g){return{...u.previewResult,hasConflicts:!1}}async qb(u,g,f,S){if(this.h.isEqual(g,this.localResource))return this.xb(u);if(this.h.isEqual(g,this.remoteResource))return this.yb(u);if(this.h.isEqual(g,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${g.toString()}`)}async xb(u){const g=this.Ab(),f=(0,w.merge)(g,null,null,[]),{local:S,remote:R}=f;return{content:u.localContent,local:S,remote:R,localChange:S.added.length>0||S.removed.length>0||S.updated.length>0?2:0,remoteChange:R!==null?2:0}}async yb(u){const g=u.remoteContent?JSON.parse(u.remoteContent):null,f=[],S=[];for(const R of this.Ab()){const i=g?.find(r=>r.id===R.id);i&&(f.push({id:R.id,name:R.name,collection:i.collection}),S.push(R))}if(g!==null){const R=(0,w.merge)(S,g,f,[]),{local:i,remote:r}=R;return{content:u.remoteContent,local:i,remote:r,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(u,g,f,S){const{local:R,remote:i,localChange:r,remoteChange:t}=f[0][1];r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const n=f[0][0].remoteProfiles||[];if(n.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new y.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0){await this.lb(d(this.Ab(),!1));const s=[];for(const a of R.added)s.push((async()=>{this.L.trace(`${this.y}: Creating '${a.name}' profile...`),await this.r.createProfile(a.id,a.name,{shortName:a.shortName}),this.L.info(`${this.y}: Created profile '${a.name}'.`)})());for(const a of R.removed)s.push((async()=>{this.L.trace(`${this.y}: Removing '${a.name}' profile...`),await this.r.removeProfile(a),this.L.info(`${this.y}: Removed profile '${a.name}'.`)})());for(const a of R.updated){const o=this.r.profiles.find(h=>h.id===a.id);o?s.push((async()=>{this.L.trace(`${this.y}: Updating '${a.name}' profile...`),await this.r.updateProfile(o,{name:a.name,shortName:a.shortName}),this.L.info(`${this.y}: Updated profile '${a.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${a.id}' to update.`)}await Promise.all(s)}if(t!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const s=[],a=n.length+(i?.added.length??0)<=20;if(a)for(const o of i?.added||[]){const h=await this.G.createCollection(this.z);s.push(h),n.push({id:o.id,name:o.name,collection:h,shortName:o.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const o of i?.removed||[])n.splice(n.findIndex(({id:h})=>o.id===h),1);for(const o of i?.updated||[]){const h=n.find(({id:m})=>o.id===m);h&&n.splice(n.indexOf(h),1,{id:o.id,name:o.name,collection:h.collection,shortName:o.shortName})}try{u=await this.updateRemoteProfiles(n,S?null:u.ref),this.L.info(`${this.y}: Updated remote profiles.${a&&i?.added.length?` Added: ${JSON.stringify(i.added.map(o=>o.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(o=>o.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(o=>o.name))}.`:""}`)}catch(o){if(s.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const h of s)await this.G.deleteCollection(h,this.z)}throw o}for(const o of i?.removed||[])await this.G.deleteCollection(o.collection,this.z)}g?.ref!==u.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.db(u),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,g){return this.kb(this.Bb(u),g)}async hasLocalData(){return this.Ab().length>0}async resolveContent(u){if(this.h.isEqual(this.remoteResource,u)||this.h.isEqual(this.baseResource,u)||this.h.isEqual(this.localResource,u)||this.h.isEqual(this.acceptedResource,u)){const g=await this.bb(u);return g&&(0,L.toFormattedString)(JSON.parse(g),{})}return null}Ab(){return this.r.profiles.filter(u=>!u.isDefault&&!u.isTransient)}Bb(u){return JSON.stringify([...u].sort((g,f)=>g.name.localeCompare(f.name)))}};p=ye([X(2,b.IUserDataProfilesService),X(3,D.IFileService),X(4,l.IEnvironmentService),X(5,k.IStorageService),X(6,y.IUserDataSyncStoreService),X(7,y.IUserDataSyncBackupStoreService),X(8,y.IUserDataSyncLogService),X(9,O.IConfigurationService),X(10,y.IUserDataSyncEnablementService),X(11,P.ITelemetryService),X(12,C.IUriIdentityService)],p),e.UserDataProfilesManifestSynchroniser=p;function d(c,u){const g=[...c].sort((f,S)=>f.name.localeCompare(S.name)).map(f=>({id:f.id,name:f.name}));return u?(0,L.toFormattedString)(g,{}):JSON.stringify(g)}e.stringifyLocalProfiles=d;function E(c){return JSON.parse(c.content)}e.parseUserDataProfilesManifest=E}),define(re[276],oe([0,1,6,16,63,2,23,17,15,14,18,24]),function(_,e,L,O,l,D,k,P,C,b,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let y=class extends D.Disposable{constructor(d,E,c,u,g){super(),this.a=d,this.b=E,this.c=c,this.f=u,this.g=g,this.h()}async h(){for(const E of this.g.profiles)for(const c of w.ALL_SYNC_RESOURCES)try{await this.j(this.i(E,c))}catch(u){this.f.error(u)}let d;try{d=await this.b.resolve(this.a.userDataSyncHome)}catch(E){(0,b.toFileOperationResult)(E)!==1&&this.f.error(E);return}if(d.children){for(const E of d.children)if(E.isDirectory&&!this.g.profiles.some(c=>c.id===E.name))try{this.f.info("Deleting non existing profile from backup",E.resource.path),await this.b.del(E.resource,{recursive:!0})}catch(c){this.f.error(c)}}}async getAllRefs(d,E){const c=this.i(d,E);try{const u=await this.b.resolve(c);if(u.children)return u.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort().reverse().map(f=>({ref:f.name,created:this.k(f)}))}catch(u){if((0,b.toFileOperationResult)(u)!==1)throw u}return[]}async resolveContent(d,E,c){const u=this.i(d,E),g=(0,k.joinPath)(u,c);try{return(await this.b.readFile(g)).value.toString()}catch(f){return this.f.error(f),null}}async backup(d,E,c){const u=this.i(d,E),g=(0,k.joinPath)(u,`${(0,l.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(g,O.VSBuffer.fromString(c))}catch(f){this.f.error(f)}try{this.j(u)}catch{}}i(d,E){return(0,k.joinPath)(this.a.userDataSyncHome,...d.isDefault?[E]:[d.id,E])}async j(d){try{try{if(!await this.b.exists(d))return}catch{return}const E=await this.b.resolve(d);if(E.children){const c=E.children.filter(S=>S.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(S.name)).sort(),u=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let g=c.filter(S=>Date.now()-this.k(S)>u);const f=c.length-g.length;f<10&&(g=g.slice(10-f)),await L.Promises.settled(g.map(async S=>{this.f.info("Deleting from backup",S.resource.path),await this.b.del(S.resource)}))}}catch(E){this.f.error(E)}}k(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};y=ye([X(0,C.IEnvironmentService),X(1,b.IFileService),X(2,P.IConfigurationService),X(3,w.IUserDataSyncLogService),X(4,I.IUserDataProfilesService)],y),e.UserDataSyncBackupStoreService=y}),define(re[277],oe([0,1,3,2,4,15,20,19,24]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const b="sync.enable";let I=class extends O.Disposable{constructor(y,p,d,E){super(),this.c=y,this.f=p,this.g=d,this.h=E,this.a=new L.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new L.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(y.onDidChangeValue(c=>this.j(c)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(b,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(y){y&&!this.canToggleEnablement()||(this.f.publicLog2(b,{enabled:y}),this.c.store(b,y,-1,1))}isResourceEnabled(y){return this.c.getBoolean((0,C.getEnablementKey)(y),-1,!0)}setResourceEnablement(y,p){if(this.isResourceEnabled(y)!==p){const d=(0,C.getEnablementKey)(y);this.i(d,p)}}getResourceSyncStateVersion(y){}i(y,p){this.c.store(y,p,-1,l.isWeb?0:1)}j(y){if(y.scope!==-1)return;if(b===y.key){this.a.fire(this.isEnabled());return}const p=C.ALL_SYNC_RESOURCES.filter(d=>(0,C.getEnablementKey)(d)===y.key)[0];if(p){this.b.fire([p,this.isResourceEnabled(p)]);return}}};I=ye([X(0,k.IStorageService),X(1,P.ITelemetryService),X(2,D.IEnvironmentService),X(3,C.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(re[79],oe([0,1,3,2,4,27,186,15,14,5,26,44,20,24]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",E="Safari",c="Chrome",u="Edge",g="Firefox",f="Android";function S(r){switch(r){case E:case c:case u:case g:case f:case(0,l.PlatformToString)(0):return!0}return!1}e.isWebPlatform=S;function R(){return l.isSafari?E:l.isChrome?c:l.isEdge?u:l.isFirefox?g:l.isAndroid?f:(0,l.PlatformToString)(l.isWeb?0:l.platform)}let i=class it extends O.Disposable{constructor(t,n,s,a,o,h){super(),this.h=s,this.i=a,this.j=o,this.k=h,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,w.getServiceMachineId)(t,n,s)}async getMachines(t){const n=await this.f;return(await this.m(t)).machines.map(a=>({...a,isCurrent:a.id===n}))}async addCurrentMachine(t){const n=await this.f,s=await this.m(t);s.machines.some(({id:a})=>a===n)||(s.machines.push({id:n,name:this.l(s.machines),platform:R()}),await this.n(s))}async removeCurrentMachine(t){const n=await this.f,s=await this.m(t),a=s.machines.filter(({id:o})=>o!==n);a.length!==s.machines.length&&(s.machines=a,await this.n(s))}async renameMachine(t,n,s){const a=await this.m(s),o=a.machines.find(({id:h})=>h===t);if(o){o.name=n,await this.n(a);const h=await this.f;t===h&&this.h.store(d,n,-1,1)}}async setEnablements(t){const n=await this.m();for(const[s,a]of t){const o=n.machines.find(h=>h.id===s);o&&(o.disabled=a?void 0:!0)}await this.n(n)}l(t){const n=this.h.get(d,-1);if(n)return n;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${R()} (${this.k.nameShort})`,a=new RegExp(`${(0,D.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let o=0;for(const h of t){const m=a.exec(h.name),v=m?parseInt(m[1]):0;o=v>o?v:o}return`${s} #${o+1}`}async m(t){this.g=await this.p(t);const n=this.r(this.g);if(n.version!==it.a)throw new Error((0,k.localize)(0,null,this.k.nameLong));return n}async n(t){const n=JSON.stringify(t),s=await this.i.writeResource(it.b,n,this.g?.ref||null);this.g={ref:s,content:n},this.c.fire()}async p(t){if(this.g){const n=t&&t.latest?t.latest[it.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.i.readResource(it.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(n){this.j.error(n)}return{version:it.a,machines:[]}}};i.a=1,i.b="machines",i=ye([X(0,P.IEnvironmentService),X(1,C.IFileService),X(2,y.IStorageService),X(3,p.IUserDataSyncStoreService),X(4,p.IUserDataSyncLogService),X(5,I.IProductService)],i),e.UserDataSyncMachinesService=i}),define(re[278],oe([0,1,6,63,38,9,3,2,4,23,11,183,26,20,19,24,76,79]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",f="sync.sessionId",S="sync.storeUrl",R="sync.productQuality";let i=class extends P.Disposable{get j(){const n=this.z.get(S,-1);return n?I.URI.parse(n):void 0}set j(n){n?this.z.store(S,n.toString(),-1,1):this.z.remove(S,-1)}get l(){return this.z.get(R,-1)}set l(n){n?this.z.store(R,n,-1,1):this.z.remove(R,-1)}constructor(n,s,a,o,h,m,v,A,T,M){super(),this.n=s,this.p=a,this.r=o,this.s=h,this.u=m,this.v=v,this.w=A,this.y=T,this.z=M,this.a=this.B(new P.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new k.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new L.ThrottledDelayer(this.O())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=n.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(v.onDidChangeAccount(()=>this.C())),this.B(a.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(h.onDidChangeLocal(z=>this.triggerSync([z],!1,!1))),this.B(k.Event.filter(this.r.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:n,message:s}=this.F();n?this.a.value===void 0&&(this.a.value=new r(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(a=>this.I(a))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.u.info(s),this.a.clear()):s&&this.r.isEnabled()&&this.u.info(s))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,O.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(n,s,a){try{this.v.account&&!a&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(f,-1),n?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(o){if(this.u.error(o),s)this.G(!1);else throw o}}G(n){this.r.isEnabled()!==n&&(this.r.setEnablement(n),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(n){if(!n){this.b=0;return}const s=E.UserDataSyncError.toUserDataSyncError(n);s instanceof E.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?C.isWeb&&s.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(s),this.b++),this.h.fire(s)}async J(){this.z.store(g,!0,-1,1),await(0,L.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(g,-1,!1)}M(){this.z.remove(g,-1)}async triggerSync(n,s,a){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...n),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const o=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:o}),this.N=[],this.a.value&&await this.a.value.sync("Activity",a)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};i=ye([X(0,y.IProductService),X(1,E.IUserDataSyncStoreManagementService),X(2,E.IUserDataSyncStoreService),X(3,E.IUserDataSyncEnablementService),X(4,E.IUserDataSyncService),X(5,E.IUserDataSyncLogService),X(6,c.IUserDataSyncAccountService),X(7,d.ITelemetryService),X(8,u.IUserDataSyncMachinesService),X(9,p.IStorageService)],i),e.UserDataAutoSyncService=i;class r extends P.Disposable{constructor(n,s,a,o,h,m,v,A){super(),this.j=n,this.k=s,this.l=a,this.m=o,this.n=h,this.p=m,this.r=v,this.s=A,this.b=this.B(new P.MutableDisposable),this.c=this.B(new k.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new k.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,P.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}u(){this.b.value=(0,L.disposableTimeout)(()=>this.sync(r.a,!1),this.k)}sync(n,s){const a=(0,L.createCancelablePromise)(async o=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(h){if((0,D.isCancellationError)(h))return}return this.y(n,s,o)});return this.i=a,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,b.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const n=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!n&&(!(0,b.isEqual)(s.defaultUrl,n.defaultUrl)||!(0,b.isEqual)(s.insidersUrl,n.insidersUrl)||!(0,b.isEqual)(s.stableUrl,n.stableUrl))}async y(n,s,a){this.r.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let o;try{await this.z(s,a)}catch(h){if(this.r.error(h),o=h,E.UserDataSyncError.toUserDataSyncError(h).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(s,a),o=void 0}catch(m){this.r.error(m),o=m}}this.f.fire(o)}async z(n,s){if(this.h=await this.n.createSyncTask(this.g,n),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new E.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const a=this.s.get(f,-1);if(a&&this.g&&a!==this.g.session)throw this.v()?await this.w()?new E.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const o=await this.p.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const h=o.find(m=>m.isCurrent);if(h?.disabled)throw new E.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(m){throw new E.UserDataAutoSyncError((0,l.toErrorMessage)(m),m instanceof E.UserDataSyncError?m.code:"Unknown")}this.g&&this.g.session!==a&&this.s.store(f,this.g.session,-1,1),!s.isCancellationRequested&&(h||await this.p.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}r.a="Interval"}),define(re[279],oe([0,1,11,187,15,14,44,20,30,24,18,41,125,124,123,17,126,121,122,5,127,42]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g,f,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let i=class He{constructor(t,n,s,a,o,h,m,v,A,T){this.e=t,this.f=n,this.g=s,this.h=o,this.i=h,this.j=m,this.k=v,this.l=A,this.m=T,this.d=a.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const n=this.K(t.content,"profiles");return(0,S.parseUserDataProfilesManifest)(n)}return[]}async getRemoteSyncResourceHandles(t,n){return(await this.e.getAllResourceRefs(t,n?.collection)).map(({created:a,ref:o})=>({created:a,uri:this.I({remote:!0,syncResource:t,profile:n?.id??this.k.defaultProfile.id,collection:n?.collection,ref:o,node:void 0})}))}async getLocalSyncResourceHandles(t,n){return(await this.f.getAllRefs(n,t)).map(({created:a,ref:o})=>({created:a,uri:this.I({remote:!1,syncResource:t,profile:n.id,collection:void 0,ref:o,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const n=this.J(t),s=n?this.k.profiles.find(a=>a.id===n.profile):void 0;return n&&s?{profile:s,syncResource:n?.syncResource}:void 0}async getAssociatedResources({uri:t}){const n=this.J(t);if(!n)return[];const s=this.k.profiles.find(a=>a.id===n.profile);switch(n.syncResource){case"settings":return this.r(t,s);case"keybindings":return this.t(t,s);case"tasks":return this.v(t,s);case"snippets":return this.x(t,s);case"globalState":return this.C(t,s);case"extensions":return this.z(t,s);case"profiles":return this.F(t,s)}}async getMachineId({uri:t}){const n=this.J(t);if(!!n){if(n.remote){if(n.ref){const{content:s}=await this.L(n.syncResource,n.ref,n.collection);if(s)return this.K(s,n.syncResource)?.machineId}return}return(0,k.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const n=this.J(t);if(!n||n.node===He.a)return null;if(n.ref){const s=await this.n(n.remote,n.syncResource,n.profile,n.collection,n.ref);return n.node&&s?this.o(n.syncResource,s,n.node):s}return!n.remote&&!n.node?this.q(n.syncResource,n.profile):null}async n(t,n,s,a,o){if(t){const{content:m}=await this.L(n,o,a);return m}const h=this.k.profiles.find(m=>m.id===s);return h?this.f.resolveContent(h,n,o):null}o(t,n,s){const a=this.K(n,t);switch(t){case"settings":return this.s(a,s);case"keybindings":return this.u(a,s);case"tasks":return this.w(a,s);case"snippets":return this.y(a,s);case"globalState":return this.D(a,s);case"extensions":return this.A(a,s);case"profiles":return this.G(a,s)}}async q(t,n){const s=this.k.profiles.find(a=>a.id===n);if(!s)return null;switch(t){case"globalState":return this.E(s);case"extensions":return this.B(s);case"profiles":return this.H(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,n){const s=this.d.joinPath(t,"settings.json"),a=n?n.settingsResource:this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}s(t,n){switch(n){case"settings.json":return(0,p.parseSettingsSyncContent)(t.content).settings}return null}t(t,n){const s=this.d.joinPath(t,"keybindings.json"),a=n?n.keybindingsResource:this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}u(t,n){switch(n){case"keybindings.json":return(0,d.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(b.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,n){const s=this.d.joinPath(t,"tasks.json"),a=n?n.tasksResource:this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}w(t,n){switch(n){case"tasks.json":return(0,c.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,n){const s=await this.resolveContent(t);if(s){const a=this.K(s,"snippets");if(a){const o=(0,y.parseSnippets)(a),h=[];for(const m of Object.keys(o)){const v=this.d.joinPath(t,m),A=n?this.d.joinPath(n.snippetsHome,m):this.d.joinPath(t,He.a);h.push({resource:v,comparableResource:A})}return h}}return[]}y(t,n){return(0,y.parseSnippets)(t)[n]||null}z(t,n){const s=this.d.joinPath(t,"extensions.json"),a=n?this.I({remote:!1,syncResource:"extensions",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}A(t,n){switch(n){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:n}=await this.m.createInstance(u.LocalExtensionsProvider).getLocalExtensions(t);return(0,u.stringify)(n,!0)}C(t,n){const s=this.d.joinPath(t,"globalState.json"),a=n?this.I({remote:!1,syncResource:"globalState",profile:n.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,He.a);return[{resource:s,comparableResource:a}]}D(t,n){switch(n){case"globalState.json":return(0,g.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const n=await this.m.createInstance(g.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,g.stringify)(n,!0)}F(t,n){const s=this.d.joinPath(t,"profiles.json"),a=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:a}]}G(t,n){switch(n){case"profiles.json":return(0,R.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,S.stringifyLocalProfiles)(this.k.profiles.filter(n=>!n.isDefault&&!n.isTransient),!0)}I(t){const n=t.remote?He.b:He.c,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.d.joinPath(L.URI.from({scheme:b.USER_DATA_SYNC_SCHEME,authority:n,path:"/"}),...s)}J(t){if(t.scheme!==b.USER_DATA_SYNC_SCHEME||t.authority!==He.c&&t.authority!==He.b)return;const n=[];for(;t.path!=="/";)n.unshift(this.d.basename(t)),t=this.d.dirname(t);if(n.length<2)return;const s=t.authority===He.b,a=n.shift(),o=n.shift();let h,m,v;for(;n.length;){const A=n.shift();A.startsWith("collection:")?h=A.substring(11):A.startsWith("ref:")?m=A.substring(4):v=A}return{remote:s,syncResource:a,profile:o,collection:h,ref:m,node:v}}K(t,n){try{const s=JSON.parse(t);if((0,w.isSyncData)(s))return s}catch(s){this.g.error(s)}throw new b.UserDataSyncError((0,O.localize)(0,null),"IncompatibleRemoteContent",n)}async L(t,n,s){const a=await this.e.resolveResourceContent(t,n,s);return{ref:n,content:a}}};i.a="not-existing-resource",i.b="remote-backup",i.c="local-backup",i=ye([X(0,b.IUserDataSyncStoreService),X(1,b.IUserDataSyncBackupStoreService),X(2,b.IUserDataSyncLogService),X(3,C.IUriIdentityService),X(4,l.IEnvironmentService),X(5,P.IStorageService),X(6,D.IFileService),X(7,I.IUserDataProfilesService),X(8,E.IConfigurationService),X(9,f.IInstantiationService)],i),e.UserDataSyncResourceProviderService=i}),define(re[280],oe([0,1,21,6,25,38,3,2,23,12,31,17,29,5,20,19,18,121,122,123,124,125,126,127,24]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g,f,S,R,i,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const n="sync.lastSyncTime";let s=class extends P.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(v,A,T,M,z,H,J,W,N){super(),this.v=v,this.w=A,this.y=T,this.z=M,this.C=z,this.D=H,this.F=J,this.G=W,this.H=N,this.f="uninitialized",this.g=this.B(new k.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new k.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new k.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new k.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new k.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new k.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new k.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=A.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(n,-1,void 0),this.B((0,P.toDisposable)(()=>this.W()))}async createSyncTask(v,A){this.X(),this.z.info("Sync started.");const T=new Date().getTime(),M=(0,I.generateUuid)();try{const W=(0,t.createSyncHeaders)(M);A&&(W["Cache-Control"]="no-cache"),v=await this.v.manifest(v,W)}catch(W){const N=t.UserDataSyncError.toUserDataSyncError(W);throw h(N,M,this.w,this.C),N}const z=!1,H=this;let J;return{manifest:v,async run(){if(z)throw new Error("Can run a task only once");J=(0,O.createCancelablePromise)(W=>H.I(v,!1,M,W)),await J.finally(()=>J=void 0),H.z.info(`Sync done. Took ${new Date().getTime()-T}ms`),H.S()},stop(){return J?.cancel(),H.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const v=new Date().getTime(),A=(0,I.generateUuid)(),T=(0,t.createSyncHeaders)(A);let M;try{M=await this.v.manifest(null,T)}catch(J){const W=t.UserDataSyncError.toUserDataSyncError(J);throw h(W,A,this.w,this.C),W}await this.resetLocal();const z=this,H=new l.CancellationTokenSource;return{id:A,async merge(){return z.I(M,!0,A,H.token)},async apply(){try{try{await z.L(M,A,H.token)}catch(J){if(t.UserDataSyncError.toUserDataSyncError(J).code==="MethodNotFound")z.z.info("Client is making invalid requests. Cleaning up data..."),await z.cleanUpRemoteData(),z.z.info("Applying manual sync again..."),await z.L(M,A,H.token);else throw J}}catch(J){throw z.z.error(J),J}z.z.info(`Sync done. Took ${new Date().getTime()-v}ms`),z.S()},async stop(){H.cancel(),await z.N(),await z.resetLocal()}}}async I(v,A,T,M){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const z=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(z,v,A,T,M));const H=z.enabled.find(J=>J.resource==="profiles");if(H){const J=await H.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.J(J,v,A,T,M)}}finally{this.l.fire(this.k)}}async J(v,A,T,M,z){for(const H of v){if(z.isCancellationRequested)return;const J=this.G.profiles.find(N=>N.id===H.id);if(!J){this.z.error(`Profile with id:${H.id} and name: ${H.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",H.name);const W=this.getOrCreateActiveProfileSynchronizer(J,H);this.k.push(...await this.M(W,A,T,M,z))}for(const[H,J]of this.u.entries())this.G.profiles.some(W=>W.id===J[0].profile.id)||(J[1].dispose(),this.u.delete(H))}async L(v,A,T){const M=this.U();for(const N of M){if(T.isCancellationRequested)return;await N.apply(A,T)}const z=M.find(N=>N.profile.isDefault);if(!z)return;const H=z.enabled.find(N=>N.resource==="profiles");if(!H)return;const W=(await H.getRemoteSyncedProfiles(v?.latest??null)||[]).filter(N=>M.every(j=>j.profile.id!==N.id));W.length&&await this.J(W,v,!1,A,T)}async M(v,A,T,M,z){return(await v.sync(A,T,M,z)).map(([J,W])=>({profile:v.profile,syncResource:J,error:W}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(v=>v.stop()))}async resolveContent(v){const A=await this.H.resolveContent(v);if(A)return A;for(const T of this.U())for(const M of T.enabled){const z=await M.resolveContent(v);if(z)return z}return null}async replace(v){this.X();const A=this.H.resolveUserDataSyncResource(v);if(!A)return;const T=await this.resolveContent(v.uri);!T||await this.O(A.profile,async M=>{if(A.syncResource===M.resource)return await M.replace(T),!0})}async accept(v,A,T,M){this.X(),await this.O(v.profile,async z=>{if(v.syncResource===z.resource)return await z.accept(A,T),M&&await z.apply((0,b.isBoolean)(M)?!1:M.force,(0,t.createSyncHeaders)((0,I.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(v,A){return this.H.getRemoteSyncResourceHandles(v,A)}async getLocalSyncResourceHandles(v,A){return this.H.getLocalSyncResourceHandles(v,A??this.G.defaultProfile)}async getAssociatedResources(v){return this.H.getAssociatedResources(v)}async getMachineId(v){return this.H.getMachineId(v)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async A=>{if(A.resource!=="globalState"&&await A.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async A=>{if(await A.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(v){this.z.error(v)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(n,-1);for(const[v]of this.u.values())try{await v.resetLocal()}catch(A){this.z.error(A)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const v=await this.H.getRemoteSyncedProfiles(),A=v.map(H=>H.collection),T=await this.v.getAllCollections(),M=T.filter(H=>!A.includes(H));M.length&&(this.z.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(H=>this.v.deleteCollection(H))),this.z.info("Deleted redundant collections on server"));const z=v.filter(H=>T.includes(H.collection));if(z.length!==v.length){this.z.info("Updating remote profiles with invalid collections on server");const H=this.y.createInstance(r.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await H.updateRemoteProfiles(z,null),this.z.info("Updated remote profiles on server")}finally{H.dispose()}}}async O(v,A){const T=new P.DisposableStore;try{const M=this.u.get(v.id);if(M){const N=await this.P(M[0],A,T);return(0,b.isUndefined)(N)?null:N}if(v.isDefault){const N=T.add(this.y.createInstance(a,v,void 0)),j=await this.P(N,A,T);return(0,b.isUndefined)(j)?null:j}if(this.G.isEnabled())return null;const z=T.add(this.y.createInstance(r.UserDataProfilesManifestSynchroniser,v,void 0)),H=await this.v.manifest(null),W=(await z.getRemoteSyncedProfiles(H?.latest??null)||[]).find(N=>N.id===v.id);if(W){const N=T.add(this.y.createInstance(a,v,W.collection)),j=await this.P(N,A,T);return(0,b.isUndefined)(j)?null:j}return null}finally{T.dispose()}}async P(v,A,T){const M=[...v.enabled,...v.disabled.map(z=>T.add(v.createSynchronizer(z)))];for(const z of M){const H=await A(z);if(!(0,b.isUndefined)(H))return H}}Q(v){const A=this.f;this.f!==v&&(this.f=v,this.g.fire(v),A==="hasConflicts"&&this.S())}R(){const v=this.U().map(A=>A.conflicts).flat();(0,L.equals)(this.i,v,(A,T)=>A.profile.id===T.profile.id&&A.syncResource===T.syncResource&&(0,L.equals)(A.conflicts,T.conflicts,(M,z)=>(0,C.isEqual)(M.previewResource,z.previewResource)))||(this.i=v,this.j.fire(v))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(n,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(v,A){let T=this.u.get(v.id);if(T&&T[0].collection!==A?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.u.delete(v.id)),!T){const M=new P.DisposableStore,z=M.add(this.y.createInstance(a,v,A?.collection));M.add(z.onDidChangeStatus(H=>this.Q(H))),M.add(z.onDidChangeConflicts(H=>this.R())),M.add(z.onDidChangeLocal(H=>this.h.fire(H))),this.u.set(v.id,T=[z,M])}return T[0]}U(){const v=[];for(const[A]of this.u.values())v.push(A);return v}W(){this.u.forEach(([,v])=>v.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};s=ye([X(0,t.IUserDataSyncStoreService),X(1,t.IUserDataSyncStoreManagementService),X(2,p.IInstantiationService),X(3,t.IUserDataSyncLogService),X(4,E.ITelemetryService),X(5,d.IStorageService),X(6,t.IUserDataSyncEnablementService),X(7,c.IUserDataProfilesService),X(8,t.IUserDataSyncResourceProviderService)],s),e.UserDataSyncService=s;let a=class extends P.Disposable{get enabled(){return this.f.sort((v,A)=>v[1]-A[1]).map(([v])=>v)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(v=>!this.l.isResourceEnabled(v))}get status(){return this.g}get conflicts(){return this.j}constructor(v,A,T,M,z,H,J,W,N,j){super(),this.profile=v,this.collection=A,this.l=T,this.m=M,this.n=z,this.r=H,this.t=J,this.u=W,this.v=N,this.w=j,this.f=[],this.g="idle",this.h=this.B(new k.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new k.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new k.Emitter),this.onDidChangeConflicts=this.k.event,this.B(T.onDidChangeResourceEnablement(([q,x])=>this.y(q,x))),this.B((0,P.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,q])=>q.dispose())));for(const q of t.ALL_SYNC_RESOURCES)T.isResourceEnabled(q)&&this.z(q)}y(v,A){A?this.z(v):this.C(v)}z(v){if(this.f.some(([z])=>z.resource===v))return;if(v==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(v==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const A=new P.DisposableStore,T=A.add(this.createSynchronizer(v));A.add(T.onDidChangeStatus(()=>this.G())),A.add(T.onDidChangeConflicts(()=>this.H())),A.add(T.onDidChangeLocal(()=>this.i.fire(v)));const M=this.I(v);this.f.push([T,M,A])}C(v){const A=this.f.findIndex(([T])=>T.resource===v);if(A!==-1){const[[T,,M]]=this.f.splice(A,1);M.dispose(),this.G(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,z=>this.u.error(z))}}createSynchronizer(v){switch(v){case"settings":return this.m.createInstance(S.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(f.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(R.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(i.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(g.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(u.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(r.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(v,A,T,M){if(M.isCancellationRequested)return[];const z=this.enabled;if(!z.length)return[];try{const H=[],J=(0,t.createSyncHeaders)(T),W=(this.collection?v?.collections?.[this.collection]?.latest:v?.latest)??null,N=A?await this.D(W):{};for(const j of z){if(M.isCancellationRequested)return[];if(!this.l.isResourceEnabled(j.resource))return[];try{if(A){const q=await j.preview(W,N,J);if(q)for(const x of q.resourcePreviews)(x.localChange!==0||x.remoteChange!==0)&&x.mergeState==="preview"&&await j.merge(x.previewResource)}else await j.sync(W,J)}catch(q){const x=t.UserDataSyncError.toUserDataSyncError(q);if(h(x,T,this.r,this.t),o(q))throw x;this.u.error(q),this.u.error(`${j.resource}: ${(0,D.toErrorMessage)(q)}`),H.push([j.resource,x])}}return H}finally{this.G()}}async apply(v,A){const T=(0,t.createSyncHeaders)(v);for(const M of this.enabled){if(A.isCancellationRequested)return;try{await M.apply(!1,T)}catch(z){const H=t.UserDataSyncError.toUserDataSyncError(z);if(h(H,v,this.r,this.t),o(z))throw H;this.u.error(z),this.u.error(`${M.resource}: ${(0,D.toErrorMessage)(z)}`)}}}async stop(){for(const v of this.enabled)try{v.status!=="idle"&&await v.stop()}catch(A){this.u.error(A)}}async resetLocal(){for(const v of this.enabled)try{await v.resetLocal()}catch(A){this.u.error(`${v.resource}: ${(0,D.toErrorMessage)(A)}`),this.u.error(A)}}async D(v){if(!this.profile.isDefault)return{};const A=this.w.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),T=this.enabled.find(M=>M instanceof S.SettingsSynchroniser);if(T){const M=await T.getRemoteUserDataSyncConfiguration(v);return{...A,...M}}return A}F(v){this.g!==v&&(this.g=v,this.h.fire(v))}G(){return this.H(),this.enabled.some(v=>v.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(v=>v.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const v=this.enabled.filter(A=>A.status==="hasConflicts").filter(A=>A.conflicts.conflicts.length>0).map(A=>A.conflicts);(0,L.equals)(this.j,v,(A,T)=>A.syncResource===T.syncResource&&(0,L.equals)(A.conflicts,T.conflicts,(M,z)=>(0,C.isEqual)(M.previewResource,z.previewResource)))||(this.j=v,this.k.fire(v))}I(v){switch(v){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};a=ye([X(2,t.IUserDataSyncEnablementService),X(3,p.IInstantiationService),X(4,y.IExtensionGalleryService),X(5,t.IUserDataSyncStoreManagementService),X(6,E.ITelemetryService),X(7,t.IUserDataSyncLogService),X(8,c.IUserDataProfilesService),X(9,w.IConfigurationService)],a);function o(m){if(m instanceof t.UserDataSyncError)switch(m.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function h(m,v,A,T){T.publicLog2("sync/error",{code:m.code,serverCode:m instanceof t.UserDataSyncStoreError?String(m.serverCode):void 0,url:m instanceof t.UserDataSyncStoreError?m.url:void 0,resource:m.resource,executionId:v,service:A.userDataSyncStore.url.toString()})}}),define(re[281],oe([0,1,3,2,11,18,24]),function(_,e,L,O,l,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(y,p){return{...y,profile:(0,D.reviveProfile)(y.profile,p.profilesHome.scheme)}}function C(y){return{created:y.created,uri:l.URI.revive(y.uri)}}class b{constructor(p,d,E){this.c=p,this.d=d,this.f=E,this.a=new Map,this.b=new L.Emitter}listen(p,d){switch(d){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${d}`)}async call(p,d,E){try{return await this.g(p,d,E)}catch(c){throw this.f.error(c),c}}async g(p,d,E){switch(d){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(l.URI.revive(E[0]));case"accept":return this.c.accept(P(E[0],this.d),l.URI.revive(E[1]),E[2],E[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(E[0],E[1]?(0,D.reviveProfile)(E[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(E[0],E[1]);case"replace":return this.c.replace(C(E[0]));case"getAssociatedResources":return this.c.getAssociatedResources(C(E[0]));case"getMachineId":return this.c.getMachineId(C(E[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(d.startsWith("manualSync/")){const c=d.substring(11),u=E[0],g=this.h(u);switch(E=E.slice(1),c){case"merge":return g.merge();case"apply":return g.apply().then(()=>this.a.delete(this.j(g.id)));case"stop":return g.stop().finally(()=>this.a.delete(this.j(g.id)))}}throw new Error("Invalid call")}h(p){const d=this.a.get(this.j(p));if(!d)throw new Error(`Manual sync taks not found: ${p}`);return d}async i(){const p=await this.c.createManualSyncTask();return this.a.set(this.j(p.id),p),p.id}j(p){return`manualSyncTask-${p}`}}e.UserDataSyncChannel=b;let I=class extends O.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(p,d){super(),this.k=d,this.b="uninitialized",this.c=this.B(new L.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new L.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new L.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new L.Emitter),this.onSyncErrors=this.j.event,this.a={call(E,c,u){return p.call(E,c,u).then(null,g=>{throw k.UserDataSyncError.toUserDataSyncError(g)})},listen(E,c){return p.listen(E,c)}},this.a.call("_getInitialData").then(([E,c,u])=>{this.l(E),this.m(c),u&&this.n(u),this.B(this.a.listen("onDidChangeStatus")(g=>this.l(g))),this.B(this.a.listen("onDidChangeLastSyncTime")(g=>this.n(g)))}),this.B(this.a.listen("onDidChangeConflicts")(E=>this.m(E))),this.B(this.a.listen("onSyncErrors")(E=>this.j.fire(E.map(c=>({...c,error:k.UserDataSyncError.toUserDataSyncError(c.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const p=await this.a.call("createManualSyncTask"),d=this;return new w(p,{async call(c,u,g){return d.a.call(`manualSync/${c}`,[p,...Array.isArray(u)?u:[u]],g)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(p,d,E,c){return this.a.call("accept",[p,d,E,c])}resolveContent(p){return this.a.call("resolveContent",[p])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(p,d){return(await this.a.call("getLocalSyncResourceHandles",[p,d])).map(({created:c,uri:u})=>({created:c,uri:l.URI.revive(u)}))}async getRemoteSyncResourceHandles(p,d){return(await this.a.call("getRemoteSyncResourceHandles",[p,d])).map(({created:c,uri:u})=>({created:c,uri:l.URI.revive(u)}))}async getAssociatedResources(p){return(await this.a.call("getAssociatedResources",[p])).map(({resource:E,comparableResource:c})=>({resource:l.URI.revive(E),comparableResource:l.URI.revive(c)}))}getMachineId(p){return this.a.call("getMachineId",[p])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(p){return this.a.call("replace",[p])}async l(p){this.b=p,this.c.fire(p)}async m(p){this.f=p.map(d=>({syncResource:d.syncResource,profile:(0,D.reviveProfile)(d.profile,this.k.profilesHome.scheme),conflicts:d.conflicts.map(E=>({...E,baseResource:l.URI.revive(E.baseResource),localResource:l.URI.revive(E.localResource),remoteResource:l.URI.revive(E.remoteResource),previewResource:l.URI.revive(E.previewResource)}))})),this.g.fire(this.f)}n(p){this.h!==p&&(this.h=p,this.i.fire(p))}};I=ye([X(1,D.IUserDataProfilesService)],I),e.UserDataSyncChannelClient=I;class w extends O.Disposable{constructor(p,d){super(),this.id=p,this.a=d}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(re[282],oe([0,1,6,25,9,3,2,142,4,23,12,11,31,17,15,14,26,58,44,20,24]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const R="sync.previous.store",i="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",n=100,s=1e3*60*5;let a=class extends k.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(S.SYNC_SERVICE_URL_TYPE,-1)}set c(T){this.h.store(S.SYNC_SERVICE_URL_TYPE,T,-1,C.isWeb?0:1)}constructor(T,M,z){super(),this.f=T,this.g=M,this.h=z,this.a=this.B(new D.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(D.Event.filter(z.onDidChangeValue,H=>H.key===S.SYNC_SERVICE_URL_TYPE&&H.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[S.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(S.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(T,M){T=C.isWeb&&T?.web?{...T,...T.web}:T;const z={...T||{},...M||{}};if(z&&(0,I.isString)(z.url)&&(0,I.isObject)(z.authenticationProviders)&&Object.keys(z.authenticationProviders).every(H=>Array.isArray(z.authenticationProviders[H].scopes))){const H=z,J=!!H.canSwitch&&!M?.url,W=H.url===H.insidersUrl?"insiders":"stable",N=(J?this.c:void 0)||W,j=M?.url||(N==="insiders"?H.insidersUrl:N==="stable"?H.stableUrl:H.url);return{url:w.URI.parse(j),type:N,defaultType:W,defaultUrl:w.URI.parse(H.url),stableUrl:w.URI.parse(H.stableUrl),insidersUrl:w.URI.parse(H.insidersUrl),canSwitch:J,authenticationProviders:Object.keys(H.authenticationProviders).reduce((q,x)=>(q.push({id:x,scopes:H.authenticationProviders[x].scopes}),q),[])}}}};a=ye([X(0,c.IProductService),X(1,p.IConfigurationService),X(2,f.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let o=class extends a{constructor(T,M,z){super(T,M,z);const H=this.h.get(R,-1);H&&(this.k=JSON.parse(H));const J=this.f[S.CONFIGURATION_SYNC_STORE_KEY];J?this.h.store(R,JSON.stringify(J),-1,1):this.h.remove(R,-1)}async switch(T){T!==this.c&&(this.c=T,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};o=ye([X(0,c.IProductService),X(1,p.IConfigurationService),X(2,f.IStorageService)],o),e.UserDataSyncStoreManagementService=o;let h=class extends k.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(T,M,z,H,J,W,N){super(),this.k=z,this.l=H,this.n=N,this.g=this.B(new D.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new D.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new D.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(T),this.c=(0,g.getServiceMachineId)(J,W,N).then(j=>{const q={"X-Client-Name":`${M.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(q["X-Client-Commit"]=M.commit),q}),this.f=new v(n,s,this.k,this.l),this.r(),this.B((0,k.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(T,M){this.b={token:T,type:M}}p(T){this.a=T?(0,b.joinPath)(T,"v1"):void 0}r(){const T=this.n.getNumber(i,-1);T&&Date.now()<T&&this.t(new Date(T))}t(T){this.i?.getTime()!==T?.getTime()&&(this.i=T,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(i,this.i.getTime(),-1,1),this.s=(0,L.createCancelablePromise)(M=>(0,L.timeout)(this.i.getTime()-Date.now(),M).then(()=>this.t(void 0))),this.s.then(null,M=>null)):this.n.remove(i,-1),this.j.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const z=await this.w(M,{type:"GET",headers:T},[],O.CancellationToken.None);return(await(0,u.asJson)(z))?.map(({id:H})=>H)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.a,"collection").toString();T={...T},T["Content-Type"]=P.Mimes.text;const z=await this.w(M,{type:"POST",headers:T},[],O.CancellationToken.None),H=await(0,u.asTextOrError)(z);if(!H)throw new S.UserDataSyncStoreError("Server did not return the collection id",M,"NoCollection",z.res.statusCode,z.res.headers[S.HEADER_OPERATION_ID]);return H}async deleteCollection(T,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=T?(0,b.joinPath)(this.a,"collection",T).toString():(0,b.joinPath)(this.a,"collection").toString();M={...M},await this.w(z,{type:"DELETE",headers:M},[],O.CancellationToken.None)}async getAllResourceRefs(T,M){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.u(this.a,M,T),H={},J=await this.w(z.toString(),{type:"GET",headers:H},[],O.CancellationToken.None);return(await(0,u.asJson)(J)||[]).map(({url:N,created:j})=>({ref:(0,b.relativePath)(z,z.with({path:N})),created:j*1e3}))}async resolveResourceContent(T,M,z,H={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=(0,b.joinPath)(this.u(this.a,z,T),M).toString();H={...H},H["Cache-Control"]="no-cache";const W=await this.w(J,{type:"GET",headers:H},[],O.CancellationToken.None);return await(0,u.asTextOrError)(W)}async deleteResource(T,M,z){if(!this.a)throw new Error("No settings sync store url configured.");const H=M!==null?(0,b.joinPath)(this.u(this.a,z,T),M).toString():this.u(this.a,z,T).toString(),J={};await this.w(H,{type:"DELETE",headers:J},[],O.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,b.joinPath)(this.a,"resource").toString(),M={"Content-Type":P.Mimes.text};await this.w(T,{type:"DELETE",headers:M},[],O.CancellationToken.None)}async readResource(T,M,z,H={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=(0,b.joinPath)(this.u(this.a,z,T),"latest").toString();H={...H},H["Cache-Control"]="no-cache",M&&(H["If-None-Match"]=M.ref);const W=await this.w(J,{type:"GET",headers:H},[304],O.CancellationToken.None);let N=null;if(W.res.statusCode===304&&(N=M),N===null){const j=W.res.headers.etag;if(!j)throw new S.UserDataSyncStoreError("Server did not return the ref",J,"NoRef",W.res.statusCode,W.res.headers[S.HEADER_OPERATION_ID]);const q=await(0,u.asTextOrError)(W);if(!q&&W.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",J,"EmptyResponse",W.res.statusCode,W.res.headers[S.HEADER_OPERATION_ID]);N={ref:j,content:q}}return N}async writeResource(T,M,z,H,J={}){if(!this.a)throw new Error("No settings sync store url configured.");const W=this.u(this.a,H,T).toString();J={...J},J["Content-Type"]=P.Mimes.text,z&&(J["If-Match"]=z);const N=await this.w(W,{type:"POST",data:M,headers:J},[],O.CancellationToken.None),j=N.res.headers.etag;if(!j)throw new S.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",N.res.statusCode,N.res.headers[S.HEADER_OPERATION_ID]);return j}async manifest(T,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,b.joinPath)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",T&&(M["If-None-Match"]=T.ref);const H=await this.w(z,{type:"GET",headers:M},[304],O.CancellationToken.None);let J=null;if(H.res.statusCode===304&&(J=T),!J){const N=H.res.headers.etag;if(!N)throw new S.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",H.res.statusCode,H.res.headers[S.HEADER_OPERATION_ID]);const j=await(0,u.asTextOrError)(H);if(!j&&H.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",z,"EmptyResponse",H.res.statusCode,H.res.headers[S.HEADER_OPERATION_ID]);j&&(J={...JSON.parse(j),ref:N})}const W=this.n.get(r,-1);return W&&J&&W!==J.session&&this.v(),J===null&&W&&this.v(),J&&this.n.store(r,J.session,-1,1),J}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(T,M,z){return M?(0,b.joinPath)(T,"collection",M,"resource",z):(0,b.joinPath)(T,"resource",z)}v(){this.n.remove(r,-1),this.n.remove(t,-1)}async w(T,M,z,H){if(!this.b)throw new S.UserDataSyncStoreError("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new S.UserDataSyncStoreError(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const J=await this.c;M.headers={...M.headers||{},...J,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(M.headers),this.l.trace("Sending request to server",{url:T,type:M.type,headers:{...M.headers,authorization:void 0}});let W;try{W=await this.f.request(T,M,H)}catch(Y){if(!(Y instanceof S.UserDataSyncStoreError)){let F="RequestFailed";const Z=(0,l.getErrorMessage)(Y).toLowerCase();Z.includes("xhr timeout")?F="RequestTimeout":Z.includes("protocol")&&Z.includes("not supported")?F="RequestProtocolNotSupported":Z.includes("request path contains unescaped characters")?F="RequestPathNotEscaped":Z.includes("headers must be an object")?F="RequestHeadersNotObject":(0,l.isCancellationError)(Y)&&(F="RequestCanceled"),Y=new S.UserDataSyncStoreError(`Connection refused for the request '${T}'.`,T,F,void 0,void 0)}throw this.l.info("Request failed",T),Y}const N=W.res.headers[S.HEADER_OPERATION_ID],j={url:T,status:W.res.statusCode,"execution-id":M.headers[S.HEADER_EXECUTION_ID],"operation-id":N},q=(0,u.isSuccess)(W)||W.res.statusCode&&z.indexOf(W.res.statusCode)!==-1;let x="";if(q?this.l.trace("Request succeeded",j):(this.l.info("Request failed",j),x=await(0,u.asText)(W)||""),W.res.statusCode===401)throw this.b=void 0,this.g.fire(),new S.UserDataSyncStoreError(`Request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",W.res.statusCode,N);if(this.h.fire(),W.res.statusCode===404)throw new S.UserDataSyncStoreError(`${M.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",W.res.statusCode,N);if(W.res.statusCode===405)throw new S.UserDataSyncStoreError(`${M.type} request '${T}' failed because the requested endpoint is not found (405). ${x}`,T,"MethodNotFound",W.res.statusCode,N);if(W.res.statusCode===409)throw new S.UserDataSyncStoreError(`${M.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",W.res.statusCode,N);if(W.res.statusCode===410)throw new S.UserDataSyncStoreError(`${M.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",W.res.statusCode,N);if(W.res.statusCode===412)throw new S.UserDataSyncStoreError(`${M.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",W.res.statusCode,N);if(W.res.statusCode===413)throw new S.UserDataSyncStoreError(`${M.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",W.res.statusCode,N);if(W.res.statusCode===426)throw new S.UserDataSyncStoreError(`${M.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",W.res.statusCode,N);if(W.res.statusCode===429){const Y=W.res.headers["retry-after"];throw Y?(this.t(new Date(Date.now()+parseInt(Y)*1e3)),new S.UserDataSyncStoreError(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",W.res.statusCode,N)):new S.UserDataSyncStoreError(`${M.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",W.res.statusCode,N)}if(!q)throw new S.UserDataSyncStoreError("Server returned "+W.res.statusCode,T,"Unknown",W.res.statusCode,N);return W}y(T){let M=this.n.get(t,-1);M===void 0&&(M=(0,y.generateUuid)(),this.n.store(t,M,-1,1)),T["X-Machine-Session-Id"]=M;const z=this.n.get(r,-1);z!==void 0&&(T["X-User-Session-Id"]=z)}};h=ye([X(1,c.IProductService),X(2,u.IRequestService),X(3,S.IUserDataSyncLogService),X(4,d.IEnvironmentService),X(5,E.IFileService),X(6,f.IStorageService)],h),e.UserDataSyncStoreClient=h;let m=class extends h{constructor(T,M,z,H,J,W,N){super(T.userDataSyncStore?.url,M,z,H,J,W,N),this.B(T.onDidChangeUserDataSyncStore(()=>this.p(T.userDataSyncStore?.url)))}};m=ye([X(0,S.IUserDataSyncStoreManagementService),X(1,c.IProductService),X(2,u.IRequestService),X(3,S.IUserDataSyncLogService),X(4,d.IEnvironmentService),X(5,E.IFileService),X(6,f.IStorageService)],m),e.UserDataSyncStoreService=m;class v{constructor(T,M,z,H){this.c=T,this.d=M,this.f=z,this.g=H,this.a=[],this.b=void 0}request(T,M,z){if(this.h()&&this.i(),M.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new S.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(M,z)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=v}),define(re[283],oe([0,1,3,56,26,20,19,278,24,76,79]),function(_,e,L,O,l,D,k,P,C,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends P.UserDataAutoSyncService{constructor(p,d,E,c,u,g,f,S,R,i,r){super(p,d,E,c,u,f,S,R,i,r),this.B(L.Event.debounce(L.Event.any(L.Event.map(g.onDidFocusWindow,()=>"windowFocus"),L.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(t,n)=>t?[...t,n]:[n],1e3)(t=>this.triggerSync(t,!0,!1)))}};w=ye([X(0,l.IProductService),X(1,C.IUserDataSyncStoreManagementService),X(2,C.IUserDataSyncStoreService),X(3,C.IUserDataSyncEnablementService),X(4,C.IUserDataSyncService),X(5,O.INativeHostService),X(6,C.IUserDataSyncLogService),X(7,b.IUserDataSyncAccountService),X(8,k.ITelemetryService),X(9,I.IUserDataSyncMachinesService),X(10,D.IStorageService)],w),e.UserDataAutoSyncService=w}),define(re[284],oe([0,1,102,22,4,23]),function(_,e,L,O,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function k(b){function I(){let w=b.scheme===O.Schemas.file?(0,D.originalFSPath)(b):b.toString();return l.isLinux||(w=w.toLowerCase()),(0,L.createHash)("md5").update(w).digest("hex")}return{id:I(),configPath:b}}e.getWorkspaceIdentifier=k;function P(b,I){function w(){if(b.scheme!==O.Schemas.file)return(0,L.createHash)("md5").update(b.toString()).digest("hex");if(!I)return;let p;return l.isLinux?p=I.ino:l.isMacintosh?p=I.birthtime.getTime():l.isWindows&&(typeof I.birthtimeMs=="number"?p=Math.floor(I.birthtimeMs):p=I.birthtime.getTime()),(0,L.createHash)("md5").update(b.fsPath).update(p?String(p):"").digest("hex")}const y=w();if(typeof y=="string")return{id:y,uri:b}}e.getSingleFolderWorkspaceIdentifier=P;function C(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=C}),define(re[285],oe([0,1,6,9,2,13,28,15,8,74,119,284,56,70]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let d=class extends l.Disposable{constructor(c,u,g,f){super(),this.a=c,this.b=u,this.c=g,this.f=f,this.B(new L.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=await k.Promises.readdir(this.a.workspaceStorageHome.fsPath),u=new b.StorageClient(this.f.getChannel("storage"));await Promise.all(c.map(async g=>{const f=(0,D.join)(this.a.workspaceStorageHome.fsPath,g);g.length===w.NON_EMPTY_WORKSPACE_ID_LENGTH||g===I.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(i=>i.workspace?.id===g)||await u.isUsed(f)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await k.Promises.rm(f))}))}catch(c){(0,O.onUnexpectedError)(c)}}};d=ye([X(0,P.INativeEnvironmentService),X(1,C.ILogService),X(2,y.INativeHostService),X(3,p.IMainProcessService)],d),e.UnusedWorkspaceStorageDataCleaner=d}),define(re[80],oe([0,1,53,6,13,12,28,154,295,296]),function(_,e,L,O,l,D,k,P,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const I=new RegExp(e.CorruptZipMessage);class w extends Error{constructor(r,t){let n=t.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=r,this.cause=t}}e.ExtractError=w;function y(i){const r=i.externalFileAttributes>>16||33188;return[448,56,7].map(t=>r&t).reduce((t,n)=>t+n,r&61440)}function p(i){if(i instanceof w)return i;let r;return I.test(i.message)&&(r="CorruptZip"),new w(r,i)}function d(i,r,t,n,s,a){const o=l.dirname(r),h=l.join(n,o);if(!h.startsWith(n))return Promise.reject(new Error(P.localize(0,null,r)));const m=l.join(n,r);let v;return a.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(k.Promises.mkdir(h,{recursive:!0})).then(()=>new Promise((A,T)=>{if(!a.isCancellationRequested)try{v=(0,L.createWriteStream)(m,{mode:t}),v.once("close",()=>A()),v.once("error",T),i.once("error",T),i.pipe(v)}catch(M){T(M)}}))}function E(i,r,t,n){let s=(0,O.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{s.cancel(),i.close()}),new Promise((o,h)=>{const m=new O.Sequencer,v=A=>{A.isCancellationRequested||(a++,i.readEntry())};i.once("error",h),i.once("close",()=>s.then(()=>{n.isCancellationRequested||i.entryCount===a?o():h(new w("Incomplete",new Error(P.localize(1,null,a,i.entryCount))))},h)),i.readEntry(),i.on("entry",A=>{if(n.isCancellationRequested)return;if(!t.sourcePathRegex.test(A.fileName)){v(n);return}const T=A.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(T)){const H=l.join(r,T);s=(0,O.createCancelablePromise)(J=>k.Promises.mkdir(H,{recursive:!0}).then(()=>v(J)).then(void 0,h));return}const M=u(i,A),z=y(A);s=(0,O.createCancelablePromise)(H=>m.queue(()=>M.then(J=>d(J,T,z,r,t,H).then(()=>v(H)))).then(null,h))})})}function c(i,r=!1){return new Promise((t,n)=>{(0,C.open)(i,r?{lazyEntries:!0}:void 0,(s,a)=>{s?n(p(s)):t((0,D.assertIsDefined)(a))})})}function u(i,r){return new Promise((t,n)=>{i.openReadStream(r,(s,a)=>{s?n(p(s)):t((0,D.assertIsDefined)(a))})})}function g(i,r){return new Promise((t,n)=>{const s=new b.ZipFile;r.forEach(o=>{o.contents?s.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&s.addFile(o.localPath,o.path)}),s.end();const a=(0,L.createWriteStream)(i);s.outputStream.pipe(a),s.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>t(i))})}e.zip=g;function f(i,r,t={},n){const s=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let a=c(i,!0);return t.overwrite&&(a=a.then(o=>k.Promises.rm(r).then(()=>o))),a.then(o=>E(o,r,{sourcePathRegex:s},n))}e.extract=f;function S(i,r){return c(i).then(t=>new Promise((n,s)=>{t.on("entry",a=>{a.fileName===r&&u(t,a).then(o=>n(o),o=>s(o))}),t.once("close",()=>s(new Error(P.localize(2,null,r))))}))}function R(i,r){return S(i,r).then(t=>new Promise((n,s)=>{const a=[];t.once("error",s),t.on("data",o=>a.push(o)),t.on("end",()=>n(Buffer.concat(a)))}))}e.buffer=R}),define(re[286],oe([0,1,6,9,2,22,4,23,54,12,31,28,80,17,15,29,33,100,14,8]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let S=class yt extends l.Disposable{constructor(i,r,t,n,s,a){super(),this.h=r,this.i=t,this.j=n,this.k=s,this.l=a,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(i,r){await this.g;const t=(0,P.joinPath)(this.extensionsDownloadDir,this.v(i));try{await this.r(i,t,s=>this.i.download(i,s,r))}catch(s){throw new E.ExtensionManagementError(s.message,E.ExtensionManagementErrorCode.Download)}let n="Unverified";if(this.m(i)){const s=await this.n(i);try{await this.k.verify(t.fsPath,s.fsPath,this.l.getLevel()===f.LogLevel.Trace)&&(n="Verified"),this.l.info(`Extension signature verification: ${i.identifier.id}. Verification status: ${n}.`)}catch(a){const o=a,h=o.code;if(o.output&&this.l.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${o.output}`),h==="UnknownError")n="UnknownError",this.l.warn(`Extension signature verification: ${i.identifier.id}. Verification status: ${n}.`);else{if(h==="PackageIsInvalidZip"||h==="SignatureArchiveIsInvalidZip")throw new E.ExtensionManagementError(y.CorruptZipMessage,E.ExtensionManagementErrorCode.CorruptZip);if(!o.didExecute)this.l.warn(`Extension signature verification: ${i.identifier.id}. Verification status: ${n} (${h})`);else throw await this.delete(t),new E.ExtensionManagementError(h,E.ExtensionManagementErrorCode.Signature)}}finally{try{await this.delete(s)}catch(a){this.l.error(a)}}}return{location:t,verificationStatus:n}}m(i){if(!i.isSigned)return!1;const r=this.j.getValue("extensions.verifySignature");return(0,b.isBoolean)(r)?r:!0}async n(i){await this.g;const r=(0,P.joinPath)(this.extensionsDownloadDir,`${this.v(i)}${yt.c}`);return await this.r(i,r,t=>this.i.downloadSignatureArchive(i,t)),r}async r(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==D.Schemas.file){await t(r);return}const n=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.h.exists(n)||await t(n);try{await this.t(n,r,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.l.info(`Rename failed because of ${(0,O.getErrorMessage)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async t(i,r,t){try{await w.Promises.rename(i.fsPath,r.fsPath)}catch(n){if(k.isWindows&&n&&n.code==="EPERM"&&Date.now()<t)return this.l.info(`Failed renaming ${i} to ${r} with 'EPERM' error. Trying again...`),this.t(i,r,t);throw n}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const o of i.children)if(o.name.endsWith(yt.c))n.push(o.resource);else{const h=c.ExtensionKey.parse(o.name);h&&t.push([h,o])}const s=(0,c.groupByExtension)(t,([o])=>o),a=[];for(const o of s)o.sort((h,m)=>C.rcompare(h[0].version,m[0].version)),r.push(...o.slice(1).map(h=>h[1].resource)),a.push(o[0][1]);a.sort((o,h)=>o.mtime-h.mtime),r.push(...a.slice(0,Math.max(0,a.length-this.f)).map(o=>o.resource)),r.push(...n),await L.Promises.settled(r.map(o=>(this.l.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(i){this.l.error(i)}}v(i){return this.f?c.ExtensionKey.create(i).toString().toLowerCase():(0,I.generateUuid)()}};S.c=".sigzip",S=ye([X(0,d.INativeEnvironmentService),X(1,g.IFileService),X(2,E.IExtensionGalleryService),X(3,p.IConfigurationService),X(4,u.IExtensionSignatureVerificationService),X(5,f.ILogService)],S),e.ExtensionsDownloader=S}),define(re[287],oe([0,1,80,164]),function(_,e,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function l(D){return(0,L.buffer)(D,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=l}),define(re[128],oe([0,1,6,16,25,38,9,3,2,37,22,13,4,23,54,12,11,31,28,80,163,99,15,267,29,33,51,77,286,268,287,222,237,46,67,14,5,8,26,19,30,18]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g,f,S,R,i,r,t,n,s,a,o,h,m,v,A,T,M,z,H,J,W,N,j,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,H.refineServiceDecorator)(t.IExtensionManagementService);let x=class extends r.AbstractExtensionManagementService{constructor(V,B,U,$,G,ee,K,Q,ie,le,he,pe){super(V,B,U,le,pe),this.Z=G,this.ab=ee,this.bb=K,this.cb=ie,this.db=he,this.X=this.B(new P.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new b.ResourceSet;const me=this.B(Q.createInstance(h.ExtensionsLifecycle));this.S=this.B(Q.createInstance(Y,Ce=>me.postUninstall(Ce))),this.U=this.B(new v.ExtensionsManifestCache($,this)),this.W=this.B(Q.createInstance(o.ExtensionsDownloader));const be=this.B(new A.ExtensionsWatcher(this,this.Z,pe,ee,he,ie,U));this.B(be.onDidChangeExtensionsByAnotherSource(Ce=>this.kb(Ce))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,n.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(V){this.v.trace("ExtensionManagementService#zip",V.identifier.id);const B=await this.jb(V),U=await(0,f.zip)((0,p.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,B);return c.URI.file(U)}async unzip(V){return this.v.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const{location:B,cleanup:U}=await this.fb(V),$=w.resolve(B.fsPath);try{return await(0,m.getManifest)($)}finally{await U()}}getInstalled(V,B=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(V??null,B)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(V){return this.S.scanUserExtensionAtLocation(V)}async install(V,B={}){this.v.trace("ExtensionManagementService#install",V.toString());const{location:U,cleanup:$}=await this.fb(V);try{const G=await(0,m.getManifest)(w.resolve(U.fsPath));if(G.engines&&G.engines.vscode&&!(0,M.isEngineValid)(G.engines.vscode,this.w.version,this.w.date))throw new Error(S.localize(0,null,(0,n.getGalleryExtensionId)(G.publisher,G.name),this.w.version));return await this.z(G,U,B)}finally{await $()}}async installFromLocation(V,B){this.v.trace("ExtensionManagementService#installFromLocation",V.toString());const U=await this.S.scanUserExtensionAtLocation(V);if(!U)throw new Error(`Cannot find a valid extension from the location ${V.toString()}`);return await this.ob([[U,void 0]],B),this.v.info("Successfully installed extension",U.identifier.id,B.toString()),U}async installExtensionsFromProfile(V,B,U){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",V,B.toString(),U.toString());const $=(await this.S.scanExtensions(1,B)).filter(G=>V.some(ee=>(0,n.areSameExtensions)(ee,G.identifier)));if($.length){const G=await Promise.all($.map(ee=>this.S.scanMetadata(ee,B)));await this.ob($.map((ee,K)=>[ee,G[K]]),U),this.v.info("Successfully installed extensions",$.map(ee=>ee.identifier.id),U.toString())}return $}async updateMetadata(V,B,U=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",V.identifier.id),B.isPreReleaseVersion&&(B.preRelease=!0),B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,B.pinned=B.pinned||void 0,V=await this.S.updateMetadata(V,B,U),this.U.invalidate(),this.X.fire(V),V}async reinstallFromGallery(V){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",V.identifier.id),!this.t.isEnabled())throw new Error(S.localize(1,null));const B=await this.getTargetPlatform(),[U]=await this.t.getExtensions([{...V.identifier,preRelease:V.preRelease}],{targetPlatform:B,compatible:!0},l.CancellationToken.None);if(!U)throw new Error(S.localize(2,null));await this.S.setUninstalled(V);try{await this.S.removeUninstalledExtension(V)}catch($){throw new Error(S.localize(3,null,(0,D.toErrorMessage)($)))}return this.installFromGallery(U)}copyExtensions(V,B){return this.S.copyExtensions(V,B)}markAsUninstalled(...V){return this.S.setUninstalled(...V)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(V){this.v.error(V)}}async download(V,B){const{location:U}=await this.W.download(V,B);return U}async fb(V){if(V.scheme===I.Schemas.file)return{location:V,async cleanup(){}};this.v.trace("Downloading extension from",V.toString());const B=(0,p.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.bb.download(V,B),this.v.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.cb.del(B)}catch($){this.v.error($)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(V,B,U){if(c.URI.isUri(B))return new te(V,B,U,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const $=n.ExtensionKey.create(B).toString();let G=this.Y.get($);return G||(this.Y.set($,G=new Z(V,B,U,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),G.waitUntilTaskIsFinished().then(()=>this.Y.delete($))),G}R(V,B){return new se(V,B.profileLocation,this.ab)}async jb(V){const B=async $=>{let G=await g.Promises.readdir($);G=G.map(Q=>w.join($,Q));const ee=await Promise.all(G.map(Q=>g.Promises.stat(Q)));let K=Promise.resolve([]);return ee.forEach((Q,ie)=>{const le=G[ie];Q.isFile()&&(K=K.then(he=>[...he,le])),Q.isDirectory()&&(K=K.then(he=>B(le).then(pe=>[...he,...pe])))}),K};return(await B(V.location.fsPath)).map($=>({path:`extension/${w.relative(V.location.fsPath,$)}`,localPath:$}))}async kb({added:V,removed:B}){if(B)for(const U of B.extensions)this.v.info("Extensions removed from another source",U.id,B.profileLocation.toString()),this.p.fire({identifier:U,profileLocation:B.profileLocation});if(V){const $=(await this.S.scanExtensions(1,V.profileLocation)).filter(G=>V.extensions.some(ee=>(0,n.areSameExtensions)(ee,G.identifier)));this.m.fire($.map(G=>(this.v.info("Extensions added from another source",G.identifier.id,V.profileLocation.toString()),{identifier:G.identifier,local:G,profileLocation:V.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(B=>this.lb.add(B)));const V=await this.cb.resolve(this.Z.userExtensionsLocation);for(const B of V.children??[])B.isDirectory&&this.lb.add(B.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(B=>this.nb(B)))}async nb(V){if(!V.affects(this.Z.userExtensionsLocation,1))return;const B=[];for(const U of V.rawAdded){if(this.lb.has(U)||!this.db.extUri.isEqual(this.db.extUri.dirname(U),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(U,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(U).startsWith(".")||!(await this.cb.stat(U)).isDirectory)continue;const $=await this.S.scanUserExtensionAtLocation(U);$&&$.installedTimestamp===void 0&&(this.lb.add(U),B.push($))}B.length&&(await this.ob(B.map(U=>[U,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",B.map(U=>U.identifier.id)))}async ob(V,B){const U=V.map($=>$[0]);await this.pb(U),await this.ab.addExtensionsToProfile(V,B),this.m.fire(U.map($=>({local:$,identifier:$.identifier,operation:1,profileLocation:B})))}async pb(V){const B=await this.S.getUninstalledExtensions();for(const U of V){const $=n.ExtensionKey.create(U);!B[$.toString()]||(this.v.trace("Removing the extension from uninstalled list:",$.id),await this.S.setInstalled($),this.v.info("Removed the extension from uninstalled list:",$.id))}}};x=ye([X(0,t.IExtensionGalleryService),X(1,N.ITelemetryService),X(2,J.ILogService),X(3,i.INativeEnvironmentService),X(4,a.IExtensionsScannerService),X(5,s.IExtensionsProfileScannerService),X(6,R.IDownloadService),X(7,H.IInstantiationService),X(8,z.IFileService),X(9,W.IProductService),X(10,j.IUriIdentityService),X(11,q.IUserDataProfilesService)],x),e.ExtensionManagementService=x;let Y=class extends C.Disposable{constructor(V,B,U,$,G,ee){super(),this.k=V,this.l=B,this.m=U,this.n=$,this.p=G,this.s=ee,this.h=this.B(new P.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,p.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new L.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(V,B){const U={includeInvalid:!0,profileLocation:B};let $=[];return V===null||V===0?$.push(...await this.m.scanAllExtensions({includeInvalid:!0},U,!1)):V===1&&$.push(...await this.m.scanUserExtensions(U)),$=V!==null?$.filter(G=>G.type===V):$,Promise.all($.map(G=>this.y(G)))}async scanAllUserExtensions(V){const B=await this.m.scanUserExtensions({includeAllVersions:!V,includeInvalid:!0});return Promise.all(B.map(U=>this.y(U)))}async scanUserExtensionAtLocation(V){try{const B=await this.m.scanExistingExtension(V,1,{includeInvalid:!0});if(B)return await this.y(B)}catch(B){this.s.error(B)}return null}async extractUserExtension(V,B,U,$){await this.j.catch(()=>{});const G=V.toString(),ee=w.join(this.m.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),K=w.join(this.m.userExtensionsLocation.fsPath,G);try{await g.Promises.rm(K)}catch{throw new t.ExtensionManagementError(S.localize(4,null,K,V.id),t.ExtensionManagementErrorCode.Delete)}await this.u(V,B,ee,$),await this.m.updateMetadata(c.URI.file(ee),U);try{this.h.fire(c.URI.file(K)),await this.v(V,ee,K,Date.now()+2*60*1e3),this.s.info("Renamed to",K)}catch(Q){try{await g.Promises.rm(ee)}catch{}if(Q.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",V.id);else throw this.s.info(`Rename failed because of ${(0,k.getErrorMessage)(Q)}. Deleted from extracted location`,ee),Q}return this.w(c.URI.file(K),1)}async scanMetadata(V,B){return B?(await this.n.scanProfileExtensions(B)).find($=>(0,n.areSameExtensions)($.identifier,V.identifier))?.metadata:this.m.scanMetadata(V.location)}async updateMetadata(V,B,U){return U?await this.n.updateMetadata([[V,B]],U):await this.m.updateMetadata(V.location,B),this.w(V.location,V.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...V){const B=V.map(U=>n.ExtensionKey.create(U));await this.t(U=>B.forEach($=>{U[$.toString()]=!0,this.s.info("Marked extension as uninstalled",$.toString())}))}async setInstalled(V){await this.t(B=>delete B[V.toString()])}async removeExtension(V,B){this.s.trace(`Deleting ${B} extension from disk`,V.identifier.id,V.location.fsPath);const U=this.p.extUri.joinPath(this.p.extUri.dirname(V.location),`.${(0,u.generateUuid)()}`);await this.v(V.identifier,V.location.fsPath,U.fsPath,Date.now()+2*60*1e3),await this.l.del(U,{recursive:!0}),this.s.info("Deleted from disk",V.identifier.id,V.location.fsPath)}async removeUninstalledExtension(V){await this.removeExtension(V,"uninstalled"),await this.t(B=>delete B[n.ExtensionKey.create(V).toString()])}async copyExtensions(V,B){const U=await this.scanExtensions(1,V),$=await Promise.all(U.filter(G=>!G.isApplicationScoped).map(async G=>[G,await this.scanMetadata(G,V)]));await this.n.addExtensionsToProfile($,B)}async t(V){return this.g.queue(async()=>{let B;try{B=(await this.l.readFile(this.c,"utf8")).value.toString()}catch($){if((0,z.toFileOperationResult)($)!==1)throw $}let U={};if(B)try{U=JSON.parse(B)}catch{}return V&&(V(U),Object.keys(U).length?await this.l.writeFile(this.c,O.VSBuffer.fromString(JSON.stringify(U))):await this.l.del(this.c)),U})}async u(V,B,U,$){this.s.trace(`Started extracting the extension from ${B} to ${U}`);try{await g.Promises.rm(U)}catch(G){throw new t.ExtensionManagementError(this.D(G).message,t.ExtensionManagementErrorCode.Delete)}try{await(0,f.extract)(B,U,{sourcePath:"extension",overwrite:!0},$),this.s.info(`Extracted extension to ${U}:`,V.id)}catch(G){try{await g.Promises.rm(U)}catch{}let ee=t.ExtensionManagementErrorCode.Extract;throw G instanceof f.ExtractError&&(G.type==="CorruptZip"?ee=t.ExtensionManagementErrorCode.CorruptZip:G.type==="Incomplete"&&(ee=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(G.message,ee)}}async v(V,B,U,$){try{await g.Promises.rename(B,U)}catch(G){if(y.isWindows&&G&&G.code==="EPERM"&&Date.now()<$)return this.s.info(`Failed renaming ${B} to ${U} with 'EPERM' error. Trying again...`,V.id),this.v(V,B,U,$);throw new t.ExtensionManagementError(G.message||S.localize(5,null,B,U),G.code||t.ExtensionManagementErrorCode.Rename)}}async w(V,B){const U=await this.m.scanExistingExtension(V,B,{includeInvalid:!0});if(U)return this.y(U);throw new Error(S.localize(6,null,V.path))}async y(V){const B=await this.l.resolve(V.location);let U,$;return B.children&&(U=B.children.find(({name:G})=>/^readme(\.txt|\.md|)$/i.test(G))?.resource,$=B.children.find(({name:G})=>/^changelog(\.txt|\.md|)$/i.test(G))?.resource),{identifier:V.identifier,type:V.type,isBuiltin:V.isBuiltin||!!V.metadata?.isBuiltin,location:V.location,manifest:V.manifest,targetPlatform:V.targetPlatform,validations:V.validations,isValid:V.isValid,readmeUrl:U,changelogUrl:$,publisherDisplayName:V.metadata?.publisherDisplayName||null,publisherId:V.metadata?.publisherId||null,isApplicationScoped:!!V.metadata?.isApplicationScoped,isMachineScoped:!!V.metadata?.isMachineScoped,isPreReleaseVersion:!!V.metadata?.isPreReleaseVersion,preRelease:!!V.metadata?.preRelease,installedTimestamp:V.metadata?.installedTimestamp,updated:!!V.metadata?.updated,pinned:!!V.metadata?.pinned}}async z(){const V=await this.getUninstalledExtensions();this.s.debug("Removing uninstalled extensions:",Object.keys(V));const B=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=new Set;for(const G of B)V[n.ExtensionKey.create(G).toString()]||U.add(G.identifier.id.toLowerCase());try{const G=(0,n.groupByExtension)(B,ee=>ee.identifier);await L.Promises.settled(G.map(async ee=>{const K=ee.sort((Q,ie)=>d.rcompare(Q.manifest.version,ie.manifest.version))[0];U.has(K.identifier.id.toLowerCase())||await this.k(await this.y(K))}))}catch(G){this.s.error(G)}const $=B.filter(G=>G.metadata&&V[n.ExtensionKey.create(G).toString()]);await Promise.allSettled($.map(G=>this.removeUninstalledExtension(G)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const V=[];let B;try{B=await this.l.resolve(this.m.userExtensionsLocation)}catch(U){(0,z.toFileOperationResult)(U)!==1&&this.s.error(U)}for(const U of B?.children??[])U.isDirectory&&U.name.startsWith(".")&&(0,u.isUUID)(U.name.substring(1))&&V.push((async()=>{this.s.trace("Deleting the generated extension folder",U.resource.toString());try{await this.l.del(U.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",U.resource.toString())}catch($){this.s.error($)}})());await Promise.allSettled(V)}D(V){const B=Array.isArray(V)?V:[V];return B.length===1?B[0]instanceof Error?B[0]:new Error(B[0]):B.reduce((U,$)=>new Error(`${U.message}${U.message?",":""}${$ instanceof Error?$.message:$}`),new Error(""))}};Y=ye([X(1,z.IFileService),X(2,a.IExtensionsScannerService),X(3,s.IExtensionsProfileScannerService),X(4,j.IUriIdentityService),X(5,J.ILogService)],Y),e.ExtensionsScanner=Y;class F extends r.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,E.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(V,B,U,$,G,ee,K,Q,ie){super(),this.identifier=V,this.source=B,this.l=U,this.m=$,this.n=G,this.o=ee,this.p=K,this.q=Q,this.s=ie,this.j="Unverified",this.k=2}async h(V){const[B,U]=await this.x(V);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[B,U]],this.l.profileLocation),B}async u({zipPath:V,key:B,metadata:U},$){let G=await this.v(B);return G||(this.s.trace("Extracting extension...",B.id),G=await this.m.extractUserExtension(B,V,U,$),this.s.info("Extracting extension completed.",B.id)),G}async v(V){return await this.w(V)?(this.s.trace("Removing the extension from uninstalled list:",V.id),await this.m.setInstalled(V),this.s.info("Removed the extension from uninstalled list:",V.id),(await this.m.scanAllUserExtensions(!0)).find($=>n.ExtensionKey.create($).equals(V))):void 0}async w(V){return!!(await this.m.getUninstalledExtensions())[V.toString()]}}class Z extends F{constructor(V,B,U,$,G,ee,K,Q,ie,le){super(B.identifier,B,U,G,ee,K,Q,ie,le),this.y=V,this.z=B,this.A=$}async x(V){const U=(await this.m.scanExtensions(null,this.l.profileLocation)).find(K=>(0,n.areSameExtensions)(K.identifier,this.z.identifier));U&&(this.k=3);const $={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,T.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||U?.isMachineScoped,isBuiltin:this.l.isBuiltin||U?.isBuiltin,isSystem:U?.type===0?!0:void 0,updated:!!U,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,E.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:U?.preRelease)};if(U?.manifest.version===this.z.version)return[await this.m.updateMetadata(U,$),$];const{location:G,verificationStatus:ee}=await this.A.download(this.z,this.k);try{return this.j=ee,this.C(G.fsPath),[await this.u({zipPath:G.fsPath,key:n.ExtensionKey.create(this.z),metadata:$},V),$]}catch(K){try{await this.A.delete(G)}catch(Q){this.s.warn("Error while deleting the downloaded file",G.toString(),(0,k.getErrorMessage)(Q))}throw K}}async C(V){try{await(0,m.getManifest)(V)}catch(B){throw new t.ExtensionManagementError((0,r.joinErrors)(B).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=Z;class te extends F{constructor(V,B,U,$,G,ee,K,Q,ie,le){super({id:(0,n.getGalleryExtensionId)(V.publisher,V.name)},B,U,G,ee,K,Q,ie,le),this.y=V,this.z=B,this.A=$}async x(V){const B=new n.ExtensionKey(this.identifier,this.y.version),$=(await this.m.scanExtensions(1,this.l.profileLocation)).find(K=>(0,n.areSameExtensions)(this.identifier,K.identifier)),G=await this.C(this.identifier.id,this.y.version,V);if(G.isApplicationScoped=(0,T.isApplicationScopedExtension)(this.y),G.isMachineScoped=this.l.isMachineScoped||$?.isMachineScoped,G.isBuiltin=this.l.isBuiltin||$?.isBuiltin,G.installedTimestamp=Date.now(),G.pinned=this.l.installGivenVersion?!0:void 0,$)if(this.k=3,B.equals(new n.ExtensionKey($.identifier,$.manifest.version)))try{await this.m.removeExtension($,"existing")}catch{throw new Error(S.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&d.gt($.manifest.version,this.y.version)&&await this.m.setUninstalled($);else{const K=await this.v(B);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(S.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:w.resolve(this.z.fsPath),key:B,metadata:G},V),G]}async C(V,B,U){try{let[$]=await this.A.getExtensions([{id:V,version:B}],U);if($||([$]=await this.A.getExtensions([{id:V}],U)),$)return{id:$.identifier.uuid,publisherDisplayName:$.publisherDisplayName,publisherId:$.publisherId,isPreReleaseVersion:$.properties.isPreReleaseVersion,preRelease:$.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class se extends r.AbstractExtensionTask{constructor(V,B,U){super(),this.extension=V,this.j=B,this.k=U}async h(V){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[288],oe([0,1,2,29,78,236,128,8,20]),function(_,e,L,O,l,D,k,P,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let b=class extends L.Disposable{constructor(w,y,p,d,E,c){super(),w.cleanUp(),(0,D.migrateUnsupportedExtensions)(w,y,p,d,c),l.ExtensionStorageService.removeOutdatedExtensionVersions(w,E)}};b=ye([X(0,k.INativeServerExtensionManagementService),X(1,O.IExtensionGalleryService),X(2,l.IExtensionStorageService),X(3,O.IGlobalExtensionEnablementService),X(4,C.IStorageService),X(5,P.ILogService)],b),e.ExtensionsContributions=b}),define(re[297],oe([0,1,150,229,248,34,38,9,2,22,11,39,152,215,216,208,209,285,199,201,17,220,98,233,99,226,15,230,120,271,29,100,200,128,101,14,211,212,68,5,207,69,71,239,8,106,107,26,58,20,112,19,113,114,115,47,242,117,251,78,118,24,76,276,262,263,79,277,280,281,282,60,275,265,111,232,75,253,224,252,110,30,254,4,255,202,218,217,77,270,18,51,214,57,274,241,266,109,279,288,7,213,264,86,105,234,269,227,196,56,283,272,70,273]),function(_,e,L,O,l,D,k,P,C,b,I,w,y,p,d,E,c,u,g,f,S,R,i,r,t,n,s,a,o,h,m,v,A,T,M,z,H,J,W,N,j,q,x,Y,F,Z,te,se,ae,V,B,U,$,G,ee,K,Q,ie,le,he,pe,me,be,Ce,De,ke,We,Ye,ce,fe,de,Ie,Pe,Fe,Le,ze,Me,Ne,je,ne,ue,ge,Se,ve,Ee,Re,Ae,Te,Ue,$e,Be,et,nt,vt,kt,Lt,At,St,Ot,Tt,wt,Nt,Ut,Ze,bt,Mt,Ft,jt,$t,Bt,zt,Wt,Et,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class xt extends C.Disposable{constructor(we,Oe){super(),this.f=we,this.g=Oe,this.b=void 0,this.c=void 0,(0,Ze.isUtilityProcess)(process)?this.a=this.B(new y.Server):this.a=this.B(new L.Server),this.h()}h(){let we=!1;const Oe=()=>{we||(we=!0,this.c?.fireOnWillShutdown(),this.dispose())};if(process.once("exit",Oe),(0,Ze.isUtilityProcess)(process)?(0,y.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Oe):this.g.once("vscode:electron-main->shared-process=exit",Oe),!(0,Ze.isUtilityProcess)(process)){const xe="vscode:electron-main->shared-process=disposeWorker",qe=(st,Ve)=>{this.i(Ve)};this.g.on(xe,qe),this.B((0,C.toDisposable)(()=>this.g.removeListener(xe,qe)))}}i(we){this.b?.disposeWorker(we)}async init(){const we=await this.j();(0,me.registerConfiguration)(),we.invokeFunction(Oe=>{const xe=Oe.get(F.ILogService);xe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.k(Oe),this.l(xe)}),this.B((0,C.combinedDisposable)(we.createInstance(p.CodeCacheCleaner,this.f.codeCachePath),we.createInstance(d.LanguagePackCachedDataCleaner),we.createInstance(u.UnusedWorkspaceStorageDataCleaner),we.createInstance(c.LogsDataCleaner),we.createInstance(E.LocalizationsUpdater),we.createInstance(Tt.ExtensionsContributions),we.createInstance(At.UserDataProfilesCleaner)))}async j(){const we=new q.ServiceCollection,Oe={_serviceBrand:void 0,...te.default};we.set(se.IProductService,Oe);const xe=new w.StaticRouter(Ke=>Ke==="main"),qe=new Et.MainProcessService(this.a,xe);we.set(Et.IMainProcessService,qe);const st=this.f.policiesData?new nt.PolicyChannelClient(this.f.policiesData,qe.getChannel("policy")):new vt.NullPolicyService;we.set(vt.IPolicyService,st);const Ve=new a.SharedProcessEnvironmentService(this.f.args,Oe);we.set(s.INativeEnvironmentService,Ve);const _e=new Z.LoggerChannelClient(void 0,this.f.logLevel,Ve.logsHome,this.f.loggers.map(Ke=>({...Ke,resource:I.URI.revive(Ke.resource)})),qe.getChannel("logger"));we.set(F.ILoggerService,_e);const ct=this.B(_e.createLogger("sharedprocess",{name:(0,wt.localize)(0,null)})),ht=this.B(new F.ConsoleLogger(ct.getLevel())),Ge=this.B(new Nt.LogService(ct,[ht]));we.set(F.ILogService,Ge),this.c=this.B(new bt.SharedProcessLifecycleService(Ge)),we.set(bt.ISharedProcessLifecycleService,this.c),this.b=new O.SharedProcessWorkerService(Ge),we.set(ue.ISharedProcessWorkerService,this.b);const Qe=this.B(new H.FileService(Ge));we.set(z.IFileService,Qe);const ft=this.B(new J.DiskFileSystemProvider(Ge));Qe.registerProvider(b.Schemas.file,ft);const dt=this.B(new Ee.FileUserDataProvider(b.Schemas.file,this.B(new Re.DiskFileSystemProviderClient(qe.getChannel(Re.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:ve.isLinux})),b.Schemas.vscodeUserData,Ge));Qe.registerProvider(b.Schemas.vscodeUserData,dt);const tt=this.B(new kt.UserDataProfilesService(this.f.profiles.all,I.URI.revive(this.f.profiles.home).with({scheme:Ve.userRoamingDataHome.scheme}),qe.getChannel("userDataProfiles")));we.set(Be.IUserDataProfilesService,tt);const Je=this.B(new R.ConfigurationService(tt.defaultProfile.settingsResource,Qe,st,Ge));we.set(S.IConfigurationService,Je);const rt=new qt.RemoteStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},qe,Ve);we.set(V.IStorageService,rt),this.B((0,C.toDisposable)(()=>rt.flush())),await Promise.all([Je.initialize(),rt.initialize()]);const gt=new Se.UriIdentityService(Qe);we.set(ge.IUriIdentityService,gt),we.set(ae.IRequestService,new jt.RequestChannelClient(qe.getChannel("request"))),we.set(g.IChecksumService,new W.SyncDescriptor(f.ChecksumService,void 0,!1)),we.set(Te.IV8InspectProfilingService,new W.SyncDescriptor(Ae.InspectProfilingService,void 0,!1));const lt=w.ProxyChannel.toService(qe.getChannel("nativeHost"),{context:this.f.windowId});we.set(Bt.INativeHostService,lt),we.set(t.IDownloadService,new W.SyncDescriptor(n.DownloadService,void 0,!0));const mt=this.B(new Fe.ActiveWindowManager(lt)),Vt=new w.StaticRouter(Ke=>mt.getActiveClientId().then(pt=>Ke===pt));we.set(M.IExtensionRecommendationNotificationService,new $t.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",Vt)));let ut;const ot=[],It=(0,K.isInternalTelemetry)(Oe,Je);if((0,K.supportsTelemetry)(Oe,Ve)){const Ke=new G.TelemetryLogAppender(Ge,_e,Ve,Oe);ot.push(Ke);const{installSourcePath:pt}=Ve;if(Oe.aiConfig?.ariaKey){const Rt=new Lt.OneDataSystemAppender(It,"monacoworkbench",null,Oe.aiConfig.ariaKey);this.B((0,C.toDisposable)(()=>Rt.flush())),ot.push(Rt)}ut=new ee.TelemetryService({appenders:ot,commonProperties:(0,B.resolveCommonProperties)(Qe,(0,D.release)(),(0,D.hostname)(),process.arch,Oe.commit,Oe.version,this.f.machineId,It,pt),sendErrorTelemetry:!0,piiPaths:(0,K.getPiiPathsFromEnvironment)(Ve)},Je,Oe)}else{ut=K.NullTelemetryService;const Ke=K.NullAppender;ot.push(Ke)}this.a.registerChannel("telemetryAppender",new $.TelemetryAppenderChannel(ot)),we.set(U.ITelemetryService,ut);const Ht=new Q.CustomEndpointTelemetryService(Je,ut,Ge,_e,Ve,Oe);we.set(U.ICustomEndpointTelemetryService,Ht),we.set(et.IExtensionsProfileScannerService,new W.SyncDescriptor(Ft.ExtensionsProfileScannerService,void 0,!0)),we.set(Ue.IExtensionsScannerService,new W.SyncDescriptor($e.ExtensionsScannerService,void 0,!0)),we.set(v.IExtensionSignatureVerificationService,new W.SyncDescriptor(v.ExtensionSignatureVerificationService,void 0,!0)),we.set(T.INativeServerExtensionManagementService,new W.SyncDescriptor(T.ExtensionManagementService,void 0,!0)),we.set(m.IExtensionGalleryService,new W.SyncDescriptor(h.ExtensionGalleryService,void 0,!0)),we.set(m.IExtensionTipsService,new W.SyncDescriptor(Wt.ExtensionTipsService,void 0,!1)),we.set(x.ILanguagePackService,new W.SyncDescriptor(Y.NativeLanguagePackService,void 0,!1)),we.set(i.IDiagnosticsService,new W.SyncDescriptor(r.DiagnosticsService,void 0,!1)),we.set(be.IUserDataSyncAccountService,new W.SyncDescriptor(be.UserDataSyncAccountService,void 0,!0)),we.set(me.IUserDataSyncLogService,new W.SyncDescriptor(ke.UserDataSyncLogService,void 0,!0)),we.set(me.IUserDataSyncUtilService,new De.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),we.set(m.IGlobalExtensionEnablementService,new W.SyncDescriptor(o.GlobalExtensionEnablementService,void 0,!1)),we.set(pe.IIgnoredExtensionsManagementService,new W.SyncDescriptor(pe.IgnoredExtensionsManagementService,void 0,!0)),we.set(he.IExtensionStorageService,new W.SyncDescriptor(he.ExtensionStorageService)),we.set(me.IUserDataSyncStoreManagementService,new W.SyncDescriptor(de.UserDataSyncStoreManagementService,void 0,!0)),we.set(me.IUserDataSyncStoreService,new W.SyncDescriptor(de.UserDataSyncStoreService,void 0,!0)),we.set(We.IUserDataSyncMachinesService,new W.SyncDescriptor(We.UserDataSyncMachinesService,void 0,!0)),we.set(me.IUserDataSyncBackupStoreService,new W.SyncDescriptor(Ce.UserDataSyncBackupStoreService,void 0,!1)),we.set(me.IUserDataSyncEnablementService,new W.SyncDescriptor(Ye.UserDataSyncEnablementService,void 0,!0)),we.set(me.IUserDataSyncService,new W.SyncDescriptor(ce.UserDataSyncService,void 0,!1)),we.set(Ie.IUserDataProfileStorageService,new W.SyncDescriptor(Pe.NativeUserDataProfileStorageService,void 0,!0)),we.set(me.IUserDataSyncResourceProviderService,new W.SyncDescriptor(Ot.UserDataSyncResourceProviderService,void 0,!0));const Pt=new le.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Je.getValue("terminal.integrated.persistentSessionScrollback")??100},(0,wt.localize)(1,null),Je,Ve,Ge,_e);return Pt.initialize(),we.set(l.ILocalPtyService,this.B(Pt)),we.set(Le.ISignService,new W.SyncDescriptor(ze.SignService,void 0,!1)),we.set(Me.ISharedTunnelsService,new W.SyncDescriptor(Ne.SharedTunnelsService)),we.set(je.ISharedProcessTunnelService,new W.SyncDescriptor(ne.SharedProcessTunnelService)),we.set(St.IRemoteTunnelService,new W.SyncDescriptor(Mt.RemoteTunnelService)),new j.InstantiationService(we)}k(we){const Oe=new A.ExtensionManagementChannel(we.get(m.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",Oe);const xe=w.ProxyChannel.fromService(we.get(x.ILanguagePackService));this.a.registerChannel("languagePacks",xe);const qe=w.ProxyChannel.fromService(we.get(i.IDiagnosticsService));this.a.registerChannel("diagnostics",qe);const st=new A.ExtensionTipsChannel(we.get(m.IExtensionTipsService));this.a.registerChannel("extensionTipsService",st);const Ve=w.ProxyChannel.fromService(we.get(g.IChecksumService));this.a.registerChannel("checksum",Ve);const _e=w.ProxyChannel.fromService(we.get(Te.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",_e);const ct=new De.UserDataSyncMachinesServiceChannel(we.get(We.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ct);const ht=w.ProxyChannel.fromService(we.get(U.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",ht);const Ge=new De.UserDataSyncAccountServiceChannel(we.get(be.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",Ge);const Qe=new De.UserDataSyncStoreManagementServiceChannel(we.get(me.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",Qe);const ft=new fe.UserDataSyncChannel(we.get(me.IUserDataSyncService),we.get(Be.IUserDataProfilesService),we.get(F.ILogService));this.a.registerChannel("userDataSync",ft);const dt=this.B(we.get(N.IInstantiationService).createInstance(zt.UserDataAutoSyncService)),tt=new De.UserDataAutoSyncChannel(dt);this.a.registerChannel("userDataAutoSync",tt);const Je=we.get(l.ILocalPtyService),rt=w.ProxyChannel.fromService(Je);this.a.registerChannel(ie.TerminalIpcChannels.LocalPty,rt);const gt=w.ProxyChannel.fromService(we.get(je.ISharedProcessTunnelService));this.a.registerChannel(je.ipcSharedProcessTunnelChannelName,gt);const lt=w.ProxyChannel.fromService(we.get(ue.ISharedProcessWorkerService));this.a.registerChannel(Ut.ipcUtilityProcessWorkerChannelName,lt);const mt=w.ProxyChannel.fromService(we.get(St.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",mt)}l(we){(0,Ze.isUtilityProcess)(process)?(process.on("uncaughtException",Oe=>(0,P.onUnexpectedError)(Oe)),process.on("unhandledRejection",Oe=>(0,P.onUnexpectedError)(Oe))):globalThis.addEventListener("unhandledrejection",Oe=>{(0,P.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,P.setUnexpectedErrorHandler)(Oe=>{const xe=(0,k.toErrorMessage)(Oe,!0);!xe||we.error(`[uncaught exception in sharedProcess]: ${xe}`)})}}async function Ct(at){let we;(0,Ze.isUtilityProcess)(process)||(we=(await new Promise((xe,qe)=>{_(["electron"],xe,qe)})).ipcRenderer);const Oe=new xt(at,we);(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"):we.send("vscode:shared-process->electron-main=ipc-ready"),await Oe.init(),(0,Ze.isUtilityProcess)(process)?process.parentPort.postMessage("vscode:shared-process->electron-main=init-done"):we.send("vscode:shared-process->electron-main=init-done")}e.main=Ct,(0,Ze.isUtilityProcess)(process)&&process.parentPort.once("message",at=>{Ct(at.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e4a11014fd91da8f2d82ba144097df21a483334d/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
