/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/types","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/network","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/files/common/files","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(ie){for(var e=[],a=0,R=ie.length;a<R;a++)e[a]=De[ie[a]];return e};define(De[61],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(E,T){const S=Object.create(null);for(const I of E){const N=T(I);let A=S[N];A||(A=S[N]=[]),A.push(I)}return S}e.groupBy=a;function R(E,T){const S=[],I=[];for(const N of E)T.has(N)||S.push(N);for(const N of T)E.has(N)||I.push(N);return{removed:S,added:I}}e.diffSets=R;function c(E,T){const S=[],I=[];for(const[N,A]of E)T.has(N)||S.push(A);for(const[N,A]of T)E.has(N)||I.push(A);return{removed:S,added:I}}e.diffMaps=c;class L{constructor(){this.a=new Map}add(T,S){let I=this.a.get(T);I||(I=new Set,this.a.set(T,I)),I.add(S)}delete(T,S){const I=this.a.get(T);!I||(I.delete(S),I.size===0&&this.a.delete(T))}forEach(T,S){const I=this.a.get(T);!I||I.forEach(S)}}e.SetMap=L}),define(De[62],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(E){return(T,S,I)=>{let N=null,A=null;if(typeof I.value=="function"?(N="value",A=I.value):typeof I.get=="function"&&(N="get",A=I.get),!A)throw new Error("not supported");I[N]=E(A,S)}}function R(E,T,S){let I=null,N=null;if(typeof S.value=="function"?(I="value",N=S.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(I="get",N=S.get),!N)throw new Error("not supported");const A=`$memoize$${T}`;S[I]=function(...D){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,D)}),this[A]}}e.memoize=R;function c(E,T,S){return a((I,N)=>{const A=`$debounce$${N}`,D=`$debounce$result$${N}`;return function(...k){this[D]||(this[D]=S?S():void 0),clearTimeout(this[A]),T&&(this[D]=T(this[D],...k),k=[this[D]]),this[A]=setTimeout(()=>{I.apply(this,k),this[D]=S?S():void 0},E)}})}e.debounce=c;function L(E,T,S){return a((I,N)=>{const A=`$throttle$timer$${N}`,D=`$throttle$result$${N}`,k=`$throttle$lastRun$${N}`,C=`$throttle$pending$${N}`;return function(...m){if(this[D]||(this[D]=S?S():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),T&&(this[D]=T(this[D],...m)),this[C])return;const o=this[k]+E;o<=Date.now()?(this[k]=Date.now(),I.apply(this,[this[D]]),this[D]=S?S():void 0):(this[C]=!0,this[A]=setTimeout(()=>{this[C]=!1,this[k]=Date.now(),I.apply(this,[this[D]]),this[D]=S?S():void 0},o-Date.now()))}})}e.throttle=L}),define(De[10],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?y.isErrorNoTelemetry(s)?new y(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(r=>{r(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.ErrorHandler=a,e.errorHandler=new a;function R(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=R;function c(t){if(!t||typeof t!="object")return!1;const s=t;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=c;function L(t){I(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=L;function E(t){I(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=E;function T(t){if(t instanceof Error){const{name:s,message:r}=t,l=t.stacktrace||t.stack;return{$isError:!0,name:s,message:r,stack:l,noTelemetry:y.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=T;const S="Canceled";function I(t){return t instanceof N?!0:t instanceof Error&&t.name===S&&t.message===S}e.isCancellationError=I;class N extends Error{constructor(){super(S),this.name=this.message}}e.CancellationError=N;function A(){const t=new Error(S);return t.name=t.message,t}e.canceled=A;function D(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=D;function k(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=k;function C(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function m(t){const s=new Error(`${t} has been disposed`);return s.name="DISPOSED",s}e.disposed=m;function o(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=o;class d extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=d;class f extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=f;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class y extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof y)return s;const r=new y;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=y;class g extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(De[15],Ce([1,0,10]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function R(re,le=0){return re[re.length-(1+le)]}e.tail=R;function c(re){if(re.length===0)throw new Error("Invalid tail call");return[re.slice(0,re.length-1),re[re.length-1]]}e.tail2=c;function L(re,le,de=(te,ae)=>te===ae){if(re===le)return!0;if(!re||!le||re.length!==le.length)return!1;for(let te=0,ae=re.length;te<ae;te++)if(!de(re[te],le[te]))return!1;return!0}e.equals=L;function E(re,le){const de=re.length-1;le<de&&(re[le]=re[de]),re.pop()}e.removeFastWithoutKeepingOrder=E;function T(re,le,de){return S(re.length,te=>de(re[te],le))}e.binarySearch=T;function S(re,le){let de=0,te=re-1;for(;de<=te;){const ae=(de+te)/2|0,se=le(ae);if(se<0)de=ae+1;else if(se>0)te=ae-1;else return ae}return-(de+1)}e.binarySearch2=S;function I(re,le){let de=0,te=re.length;if(te===0)return 0;for(;de<te;){const ae=Math.floor((de+te)/2);le(re[ae])?te=ae:de=ae+1}return de}e.findFirstInSorted=I;function N(re,le,de){if(re=re|0,re>=le.length)throw new TypeError("invalid index");const te=le[Math.floor(le.length*Math.random())],ae=[],se=[],F=[];for(const $ of le){const q=de($,te);q<0?ae.push($):q>0?se.push($):F.push($)}return re<ae.length?N(re,ae,de):re<ae.length+F.length?F[0]:N(re-(ae.length+F.length),se,de)}e.quickSelect=N;function A(re,le){const de=[];let te;for(const ae of re.slice(0).sort(le))!te||le(te[0],ae)!==0?(te=[ae],de.push(te)):te.push(ae);return de}e.groupBy=A;function D(re,le,de){const te=[];function ae($,q,J){if(q===0&&J.length===0)return;const ue=te[te.length-1];ue&&ue.start+ue.deleteCount===$?(ue.deleteCount+=q,ue.toInsert.push(...J)):te.push({start:$,deleteCount:q,toInsert:J})}let se=0,F=0;for(;;){if(se===re.length){ae(se,0,le.slice(F));break}if(F===le.length){ae(se,re.length-se,[]);break}const $=re[se],q=le[F],J=de($,q);J===0?(se+=1,F+=1):J<0?(ae(se,1,[]),se+=1):J>0&&(ae(se,0,[q]),F+=1)}return te}e.sortedDiff=D;function k(re,le,de){const te=D(re,le,de),ae=[],se=[];for(const F of te)ae.push(...re.slice(F.start,F.start+F.deleteCount)),se.push(...F.toInsert);return{removed:ae,added:se}}e.delta=k;function C(re,le,de){if(de===0)return[];const te=re.slice(0,de).sort(le);return o(re,le,te,de,re.length),te}e.top=C;function m(re,le,de,te,ae){return de===0?Promise.resolve([]):new Promise((se,F)=>{(async()=>{const $=re.length,q=re.slice(0,de).sort(le);for(let J=de,ue=Math.min(de+te,$);J<$;J=ue,ue=Math.min(ue+te,$)){if(J>de&&await new Promise(we=>setTimeout(we)),ae&&ae.isCancellationRequested)throw new a.CancellationError;o(re,le,q,J,ue)}return q})().then(se,F)})}e.topAsync=m;function o(re,le,de,te,ae){for(const se=de.length;te<ae;te++){const F=re[te];if(le(F,de[se-1])<0){de.pop();const $=I(de,q=>le(F,q)<0);de.splice($,0,F)}}}function d(re){return re.filter(le=>!!le)}e.coalesce=d;function f(re){let le=0;for(let de=0;de<re.length;de++)re[de]&&(re[le]=re[de],le+=1);re.length=le}e.coalesceInPlace=f;function p(re,le,de){re.splice(de,0,re.splice(le,1)[0])}e.move=p;function y(re){return!Array.isArray(re)||re.length===0}e.isFalsyOrEmpty=y;function g(re){return Array.isArray(re)&&re.length>0}e.isNonEmptyArray=g;function t(re,le=de=>de){const de=new Set;return re.filter(te=>{const ae=le(te);return de.has(ae)?!1:(de.add(ae),!0)})}e.distinct=t;function s(re){const le=new Set;return de=>{const te=re(de);return le.has(te)?!1:(le.add(te),!0)}}e.uniqueFilter=s;function r(re,le){const de=l(re,le);if(de!==-1)return re[de]}e.findLast=r;function l(re,le){for(let de=re.length-1;de>=0;de--){const te=re[de];if(le(te))return de}return-1}e.lastIndex=l;function u(re,le){return re.length>0?re[0]:le}e.firstOrDefault=u;function b(re,le){return re.length>0?re[re.length-1]:le}e.lastOrDefault=b;function i(re,le,de=(te,ae)=>te===ae){let te=0;for(let ae=0,se=Math.min(re.length,le.length);ae<se&&de(re[ae],le[ae]);ae++)te++;return te}e.commonPrefixLength=i;function n(re){return[].concat(...re)}e.flatten=n;function h(re,le){let de=typeof le=="number"?re:0;typeof le=="number"?de=re:(de=0,le=re);const te=[];if(de<=le)for(let ae=de;ae<le;ae++)te.push(ae);else for(let ae=de;ae>le;ae--)te.push(ae);return te}e.range=h;function w(re,le,de){return re.reduce((te,ae)=>(te[le(ae)]=de?de(ae):ae,te),Object.create(null))}e.index=w;function v(re,le){return re.push(le),()=>O(re,le)}e.insert=v;function O(re,le){const de=re.indexOf(le);if(de>-1)return re.splice(de,1),le}e.remove=O;function j(re,le,de){const te=re.slice(0,le),ae=re.slice(le);return te.concat(de,ae)}e.arrayInsert=j;function V(re,le){let de;if(typeof le=="number"){let te=le;de=()=>{const ae=Math.sin(te++)*179426549;return ae-Math.floor(ae)}}else de=Math.random;for(let te=re.length-1;te>0;te-=1){const ae=Math.floor(de()*(te+1)),se=re[te];re[te]=re[ae],re[ae]=se}}e.shuffle=V;function Q(re,le){const de=re.indexOf(le);de>-1&&(re.splice(de,1),re.unshift(le))}e.pushToStart=Q;function G(re,le){const de=re.indexOf(le);de>-1&&(re.splice(de,1),re.push(le))}e.pushToEnd=G;function U(re,le){for(const de of le)re.push(de)}e.pushMany=U;function P(re,le){return Array.isArray(re)?re.map(le):le(re)}e.mapArrayOrNot=P;function M(re){return Array.isArray(re)?re:[re]}e.asArray=M;function B(re){return re[Math.floor(Math.random()*re.length)]}e.getRandomElement=B;function Z(re,le){for(const de of re){const te=le(de);if(te!==void 0)return te}}e.mapFind=Z;function Y(re,le,de){const te=_(re,le),ae=re.length,se=de.length;re.length=ae+se;for(let F=ae-1;F>=te;F--)re[F+se]=re[F];for(let F=0;F<se;F++)re[F+te]=de[F]}e.insertInto=Y;function H(re,le,de,te){const ae=_(re,le),se=re.splice(ae,de);return Y(re,ae,te),se}e.splice=H;function _(re,le){return le<0?Math.max(le+re.length,0):Math.min(le,re.length)}var ee;(function(re){function le(ae){return ae<0}re.isLessThan=le;function de(ae){return ae>0}re.isGreaterThan=de;function te(ae){return ae===0}re.isNeitherLessOrGreaterThan=te,re.greaterThan=1,re.lessThan=-1,re.neitherLessOrGreaterThan=0})(ee=e.CompareResult||(e.CompareResult={}));function be(re,le){return(de,te)=>le(re(de),re(te))}e.compareBy=be;function ce(...re){return(le,de)=>{for(const te of re){const ae=te(le,de);if(!ee.isNeitherLessOrGreaterThan(ae))return ae}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=ce;const oe=(re,le)=>re-le;e.numberComparator=oe;function x(re,le){if(re.length===0)return;let de=re[0];for(let te=1;te<re.length;te++){const ae=re[te];le(ae,de)>0&&(de=ae)}return de}e.findMaxBy=x;function he(re,le){if(re.length===0)return;let de=re[0];for(let te=1;te<re.length;te++){const ae=re[te];le(ae,de)>=0&&(de=ae)}return de}e.findLastMaxBy=he;function pe(re,le){return x(re,(de,te)=>-le(de,te))}e.findMinBy=pe;class Se{constructor(le){this.f=le,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(le){let de=this.c;for(;de<this.f.length&&le(this.f[de]);)de++;const te=de===this.c?null:this.f.slice(this.c,de);return this.c=de,te}takeFromEndWhile(le){let de=this.d;for(;de>=0&&le(this.f[de]);)de--;const te=de===this.d?null:this.f.slice(de+1,this.d+1);return this.d=de,te}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const le=this.f[this.c];return this.c++,le}removeLast(){const le=this.f[this.d];return this.d--,le}takeCount(le){const de=this.f.slice(this.c,this.c+le);return this.c+=le,de}}e.ArrayQueue=Se;class Re{constructor(le){this.iterate=le}forEach(le){this.iterate(de=>(le(de),!0))}toArray(){const le=[];return this.iterate(de=>(le.push(de),!0)),le}filter(le){return new Re(de=>this.iterate(te=>le(te)?de(te):!0))}map(le){return new Re(de=>this.iterate(te=>de(le(te))))}some(le){let de=!1;return this.iterate(te=>(de=le(te),!de)),de}findFirst(le){let de;return this.iterate(te=>le(te)?(de=te,!1):!0),de}findLast(le){let de;return this.iterate(te=>(le(te)&&(de=te),!0)),de}findLastMaxBy(le){let de,te=!0;return this.iterate(ae=>((te||ee.isGreaterThan(le(ae,de)))&&(te=!1,de=ae),!0)),de}}Re.empty=new Re(re=>{}),e.CallbackIterable=Re}),define(De[51],Ce([1,0,10]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(S,I){if(!S)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=R;function c(S,I="Unreachable"){throw new Error(I)}e.assertNever=c;function L(S){if(!S)throw new a.BugIndicatingError("Assertion Failed")}e.assert=L;function E(S){if(!S()){debugger;S(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=E;function T(S,I){let N=0;for(;N<S.length-1;){const A=S[N],D=S[N+1];if(!I(A,D))return!1;N++}return!0}e.checkAdjacentItems=T}),define(De[63],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(R){const c=this;let L=!1,E;return function(){return L||(L=!0,E=R.apply(c,arguments)),E}}e.once=a}),define(De[101],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(c){this.a=c,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(De[64],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(R){function c(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}R.is=c;const L=Object.freeze([]);function E(){return L}R.empty=E;function*T(y){yield y}R.single=T;function S(y){return c(y)?y:T(y)}R.wrap=S;function I(y){return y||L}R.from=I;function N(y){return!y||y[Symbol.iterator]().next().done===!0}R.isEmpty=N;function A(y){return y[Symbol.iterator]().next().value}R.first=A;function D(y,g){for(const t of y)if(g(t))return!0;return!1}R.some=D;function k(y,g){for(const t of y)if(g(t))return t}R.find=k;function*C(y,g){for(const t of y)g(t)&&(yield t)}R.filter=C;function*m(y,g){let t=0;for(const s of y)yield g(s,t++)}R.map=m;function*o(...y){for(const g of y)for(const t of g)yield t}R.concat=o;function d(y,g,t){let s=t;for(const r of y)s=g(s,r);return s}R.reduce=d;function*f(y,g,t=y.length){for(g<0&&(g+=y.length),t<0?t+=y.length:t>y.length&&(t=y.length);g<t;g++)yield y[g]}R.slice=f;function p(y,g=Number.POSITIVE_INFINITY){const t=[];if(g===0)return[t,y];const s=y[Symbol.iterator]();for(let r=0;r<g;r++){const l=s.next();if(l.done)return[t,R.empty()];t.push(l.value)}return[t,{[Symbol.iterator](){return s}}]}R.consume=p})(a=e.Iterable||(e.Iterable={}))}),define(De[147],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var c;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(c=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function E(t,s=!1){let r=0;const l=t.length;let u="",b=0,i=16,n=0;function h(G){let U=0,P=0;for(;U<G;){const M=t.charCodeAt(r);if(M>=48&&M<=57)P=P*16+M-48;else if(M>=65&&M<=70)P=P*16+M-65+10;else if(M>=97&&M<=102)P=P*16+M-97+10;else break;r++,U++}return U<G&&(P=-1),P}function w(G){r=G,u="",b=0,i=16,n=0}function v(){const G=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&I(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&I(t.charCodeAt(r)))for(r++;r<t.length&&I(t.charCodeAt(r));)r++;else return n=3,t.substring(G,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&I(t.charCodeAt(r))){for(r++;r<t.length&&I(t.charCodeAt(r));)r++;U=r}else n=3;return t.substring(G,U)}function O(){let G="",U=r;for(;;){if(r>=l){G+=t.substring(U,r),n=2;break}const P=t.charCodeAt(r);if(P===34){G+=t.substring(U,r),r++;break}if(P===92){if(G+=t.substring(U,r),r++,r>=l){n=2;break}switch(t.charCodeAt(r++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:{const B=h(4);B>=0?G+=String.fromCharCode(B):n=4;break}default:n=5}U=r;continue}if(P>=0&&P<=31)if(S(P)){G+=t.substring(U,r),n=2;break}else n=6;r++}return G}function j(){if(u="",n=0,b=r,r>=l)return b=l,i=17;let G=t.charCodeAt(r);if(T(G)){do r++,u+=String.fromCharCode(G),G=t.charCodeAt(r);while(T(G));return i=15}if(S(G))return r++,u+=String.fromCharCode(G),G===13&&t.charCodeAt(r)===10&&(r++,u+=`
`),i=14;switch(G){case 123:return r++,i=1;case 125:return r++,i=2;case 91:return r++,i=3;case 93:return r++,i=4;case 58:return r++,i=6;case 44:return r++,i=5;case 34:return r++,u=O(),i=10;case 47:{const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<l&&!S(t.charCodeAt(r));)r++;return u=t.substring(U,r),i=12}if(t.charCodeAt(r+1)===42){r+=2;const P=l-1;let M=!1;for(;r<P;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,M=!0;break}r++}return M||(r++,n=1),u=t.substring(U,r),i=13}return u+=String.fromCharCode(G),r++,i=16}case 45:if(u+=String.fromCharCode(G),r++,r===l||!I(t.charCodeAt(r)))return i=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=v(),i=11;default:for(;r<l&&V(G);)r++,G=t.charCodeAt(r);if(b!==r){switch(u=t.substring(b,r),u){case"true":return i=8;case"false":return i=9;case"null":return i=7}return i=16}return u+=String.fromCharCode(G),r++,i=16}}function V(G){if(T(G)||S(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let G;do G=j();while(G>=12&&G<=15);return G}return{setPosition:w,getPosition:()=>r,scan:s?Q:j,getToken:()=>i,getTokenValue:()=>u,getTokenOffset:()=>b,getTokenLength:()=>r-b,getTokenError:()=>n}}e.createScanner=E;function T(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var N;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(N||(N={}));function A(t,s){const r=[],l=new Object;let u;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let i=!1;function n(h,w,v,O){b.value=h,b.offset=w,b.length=v,b.type=O,b.colonOffset=void 0,u=b}try{p(t,{onObjectBegin:(h,w)=>{if(s<=h)throw l;u=void 0,i=s>h,r.push("")},onObjectProperty:(h,w,v)=>{if(s<w||(n(h,w,v,"property"),r[r.length-1]=h,s<=w+v))throw l},onObjectEnd:(h,w)=>{if(s<=h)throw l;u=void 0,r.pop()},onArrayBegin:(h,w)=>{if(s<=h)throw l;u=void 0,r.push(0)},onArrayEnd:(h,w)=>{if(s<=h)throw l;u=void 0,r.pop()},onLiteralValue:(h,w,v)=>{if(s<w||(n(h,w,v,g(h)),s<=w+v))throw l},onSeparator:(h,w,v)=>{if(s<=w)throw l;if(h===":"&&u&&u.type==="property")u.colonOffset=w,i=!1,u=void 0;else if(h===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(i=!0,r[r.length-1]=""),u=void 0}}})}catch(h){if(h!==l)throw h}return{path:r,previousNode:u,isAtPropertyKey:i,matches:h=>{let w=0;for(let v=0;w<h.length&&v<r.length;v++)if(h[w]===r[v]||h[w]==="*")w++;else if(h[w]!=="**")return!1;return w===h.length}}}e.getLocation=A;function D(t,s=[],r=L.DEFAULT){let l=null,u=[];const b=[];function i(h){Array.isArray(u)?u.push(h):l!==null&&(u[l]=h)}return p(t,{onObjectBegin:()=>{const h={};i(h),b.push(u),u=h,l=null},onObjectProperty:h=>{l=h},onObjectEnd:()=>{u=b.pop()},onArrayBegin:()=>{const h=[];i(h),b.push(u),u=h,l=null},onArrayEnd:()=>{u=b.pop()},onLiteralValue:i,onError:(h,w,v)=>{s.push({error:h,offset:w,length:v})}},r),u[0]}e.parse=D;function k(t,s=[],r=L.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(h){l.type==="property"&&(l.length=h-l.offset,l=l.parent)}function b(h){return l.children.push(h),h}p(t,{onObjectBegin:h=>{l=b({type:"object",offset:h,length:-1,parent:l,children:[]})},onObjectProperty:(h,w,v)=>{l=b({type:"property",offset:w,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:h,offset:w,length:v,parent:l})},onObjectEnd:(h,w)=>{l.length=h+w-l.offset,l=l.parent,u(h+w)},onArrayBegin:(h,w)=>{l=b({type:"array",offset:h,length:-1,parent:l,children:[]})},onArrayEnd:(h,w)=>{l.length=h+w-l.offset,l=l.parent,u(h+w)},onLiteralValue:(h,w,v)=>{b({type:g(h),offset:w,length:v,parent:l,value:h}),u(w+v)},onSeparator:(h,w,v)=>{l.type==="property"&&(h===":"?l.colonOffset=w:h===","&&u(w))},onError:(h,w,v)=>{s.push({error:h,offset:w,length:v})}},r);const n=l.children[0];return n&&delete n.parent,n}e.parseTree=k;function C(t,s){if(!t)return;let r=t;for(const l of s)if(typeof l=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const b of r.children)if(Array.isArray(b.children)&&b.children[0].value===l){r=b.children[1],u=!0;break}if(!u)return}else{const u=l;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}e.findNodeAtLocation=C;function m(t){if(!t.parent||!t.parent.children)return[];const s=m(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=m;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const s=Object.create(null);for(const r of t.children){const l=r.children[1];l&&(s[r.children[0].value]=o(l))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=o;function d(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=d;function f(t,s,r=!1){if(d(t,s,r)){const l=t.children;if(Array.isArray(l))for(let u=0;u<l.length&&l[u].offset<=s;u++){const b=f(l[u],s,r);if(b)return b}return t}}e.findNodeAtOffset=f;function p(t,s,r=L.DEFAULT){const l=E(t,!1);function u(be){return be?()=>be(l.getTokenOffset(),l.getTokenLength()):()=>!0}function b(be){return be?ce=>be(ce,l.getTokenOffset(),l.getTokenLength()):()=>!0}const i=u(s.onObjectBegin),n=b(s.onObjectProperty),h=u(s.onObjectEnd),w=u(s.onArrayBegin),v=u(s.onArrayEnd),O=b(s.onLiteralValue),j=b(s.onSeparator),V=u(s.onComment),Q=b(s.onError),G=r&&r.disallowComments,U=r&&r.allowTrailingComma;function P(){for(;;){const be=l.scan();switch(l.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:G||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(be){case 12:case 13:G?M(10):V();break;case 16:M(1);break;case 15:case 14:break;default:return be}}}function M(be,ce=[],oe=[]){if(Q(be),ce.length+oe.length>0){let x=l.getToken();for(;x!==17;){if(ce.indexOf(x)!==-1){P();break}else if(oe.indexOf(x)!==-1)break;x=P()}}}function B(be){const ce=l.getTokenValue();return be?O(ce):n(ce),P(),!0}function Z(){switch(l.getToken()){case 11:{let be=0;try{be=JSON.parse(l.getTokenValue()),typeof be!="number"&&(M(2),be=0)}catch{M(2)}O(be);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return P(),!0}function Y(){return l.getToken()!==10?(M(3,[],[2,5]),!1):(B(!1),l.getToken()===6?(j(":"),P(),ee()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function H(){i(),P();let be=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(be||M(4,[],[]),j(","),P(),l.getToken()===2&&U)break}else be&&M(6,[],[]);Y()||M(4,[],[2,5]),be=!0}return h(),l.getToken()!==2?M(7,[2],[]):P(),!0}function _(){w(),P();let be=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(be||M(4,[],[]),j(","),P(),l.getToken()===4&&U)break}else be&&M(6,[],[]);ee()||M(4,[],[4,5]),be=!0}return v(),l.getToken()!==4?M(8,[4],[]):P(),!0}function ee(){switch(l.getToken()){case 3:return _();case 1:return H();case 10:return B(!0);default:return Z()}}return P(),l.getToken()===17?r.allowEmptyContent?!0:(M(4,[],[]),!1):ee()?(l.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=p;function y(t,s){const r=E(t),l=[];let u,b=0,i;do switch(i=r.getPosition(),u=r.scan(),u){case 12:case 13:case 17:b!==i&&l.push(t.substring(b,i)),s!==void 0&&l.push(r.getTokenValue().replace(/[^\r\n]/g,s)),b=r.getPosition();break}while(u!==17);return l.join("")}e.stripComments=y;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(De[65],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(c){this.d=c,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(c){this.c=c}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=a}),define(De[6],Ce([1,0,63,64]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const c=!1;let L=null;function E(b){L=b}if(e.setDisposableTracker=E,c){const b="__is_disposable_tracked__";E(new class{trackDisposable(i){const n=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[b]||console.log(n)},3e3)}setParent(i,n){if(i&&i!==f.None)try{i[b]=!0}catch{}}markAsDisposed(i){if(i&&i!==f.None)try{i[b]=!0}catch{}}markAsSingleton(i){}})}function T(b){return L?.trackDisposable(b),b}function S(b){L?.markAsDisposed(b)}function I(b,i){L?.setParent(b,i)}function N(b,i){if(!!L)for(const n of b)L.setParent(n,i)}function A(b){return L?.markAsSingleton(b),b}e.markAsSingleton=A;function D(b){return typeof b.dispose=="function"&&b.dispose.length===0}e.isDisposable=D;function k(b){if(R.Iterable.is(b)){const i=[];for(const n of b)if(n)try{n.dispose()}catch(h){i.push(h)}if(i.length===1)throw i[0];if(i.length>1)throw new AggregateError(i,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}e.dispose=k;function C(b){for(const i of b)D(i)&&i.dispose();return[]}e.disposeIfDisposable=C;function m(...b){const i=o(()=>k(b));return N(b,i),i}e.combinedDisposable=m;function o(b){const i=T({dispose:(0,a.once)(()=>{S(i),b()})});return i}e.toDisposable=o;class d{constructor(){this.c=new Set,this.f=!1,T(this)}dispose(){this.f||(S(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{k(this.c)}finally{this.c.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return I(i,this),this.f?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(i),i}}d.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=d;class f{constructor(){this.q=new d,T(this),I(this.q,this)}dispose(){S(this),this.q.dispose()}B(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(i)}}f.None=Object.freeze({dispose(){}}),e.Disposable=f;class p{constructor(){this.b=!1,T(this)}get value(){return this.b?void 0:this.a}set value(i){this.b||i===this.a||(this.a?.dispose(),i&&I(i,this),this.a=i)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const i=this.a;return this.a=void 0,i&&I(i,null),i}}e.MutableDisposable=p;class y{constructor(i){this.b=i,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=y;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,T(this)}set(i){let n=i;return this.unset=()=>n=void 0,this.isset=()=>n!==void 0,this.dispose=()=>{n&&(n(),n=void 0,S(this))},this}}e.SafeDisposable=g;class t{constructor(){this.a=new Map}acquire(i,...n){let h=this.a.get(i);h||(h={counter:0,object:this.b(i,...n)},this.a.set(i,h));const{object:w}=h,v=(0,a.once)(()=>{--h.counter===0&&(this.c(i,h.object),this.a.delete(i))});return h.counter++,{object:w,dispose:v}}}e.ReferenceCollection=t;class s{constructor(i){this.a=i}async acquire(i,...n){const h=this.a.acquire(i,...n);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(w){throw h.dispose(),w}}}e.AsyncReferenceCollection=s;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r;function l(b){const i=new d;try{b(i)}finally{i.dispose()}}e.disposeOnReturn=l;class u{constructor(){this.a=new Map,this.b=!1,T(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{k(this.a.values())}finally{this.a.clear()}}has(i){return this.a.has(i)}get(i){return this.a.get(i)}set(i,n,h=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),h||this.a.get(i)?.dispose(),this.a.set(i,n)}deleteAndDispose(i){this.a.get(i)?.dispose(),this.a.delete(i)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=u}),define(De[66],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(L){this.element=L,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class R{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let L=this.a;for(;L!==a.Undefined;){const E=L.next;L.prev=a.Undefined,L.next=a.Undefined,L=E}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,E){const T=new a(L);if(this.a===a.Undefined)this.a=T,this.b=T;else if(E){const I=this.b;this.b=T,T.prev=I,I.next=T}else{const I=this.a;this.a=T,T.next=I,I.prev=T}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(T))}}shift(){if(this.a!==a.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==a.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==a.Undefined&&L.next!==a.Undefined){const E=L.prev;E.next=L.next,L.next.prev=E}else L.prev===a.Undefined&&L.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):L.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):L.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==a.Undefined;)yield L.element,L=L.next}}e.LinkedList=R}),define(De[28],Ce([1,0]),function(ie,e){"use strict";var a,R,c;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(m,o,d){let f=m.get(o);return f===void 0&&(f=d,m.set(o,f)),f}e.getOrSet=L;function E(m){const o=[];return m.forEach((d,f)=>{o.push(`${f} => ${d}`)}),`Map(${m.size}) {${o.join(", ")}}`}e.mapToString=E;function T(m){const o=[];return m.forEach(d=>{o.push(d)}),`Set(${m.size}) {${o.join(", ")}}`}e.setToString=T;class S{constructor(o,d){this.uri=o,this.value=d}}class I{constructor(o,d){this[a]="ResourceMap",o instanceof I?(this.b=new Map(o.b),this.c=d??I.a):(this.b=new Map,this.c=o??I.a)}set(o,d){return this.b.set(this.c(o),new S(o,d)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,d){typeof d<"u"&&(o=o.bind(d));for(const[f,p]of this.b)o(p.value,p.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}I.a=m=>m.toString(),e.ResourceMap=I;class N{constructor(o,d){this[R]="ResourceSet",!o||typeof o=="function"?this.a=new I(o):(this.a=new I(d),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,d){this.a.forEach((f,p)=>o.call(d,p,p,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=N;var A;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(A=e.Touch||(e.Touch={}));class D{constructor(){this[c]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,d=0){const f=this.a.get(o);if(!!f)return d!==0&&this.j(f,d),f.value}set(o,d,f=0){let p=this.a.get(o);if(p)p.value=d,f!==0&&this.j(p,f);else{switch(p={key:o,value:d,next:void 0,previous:void 0},f){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(o,p),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const d=this.a.get(o);if(!!d)return this.a.delete(o),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,d){const f=this.e;let p=this.b;for(;p;){if(d?o.bind(d)(p.value,p.key,this):o(p.value,p.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const o=this,d=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(o.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const y={value:f.key,done:!1};return f=f.next,y}else return{value:void 0,done:!0}}};return p}values(){const o=this,d=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(o.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const y={value:f.value,done:!1};return f=f.next,y}else return{value:void 0,done:!0}}};return p}entries(){const o=this,d=this.e;let f=this.b;const p={[Symbol.iterator](){return p},next(){if(o.e!==d)throw new Error("LinkedMap got modified during iteration.");if(f){const y={value:[f.key,f.value],done:!1};return f=f.next,y}else return{value:void 0,done:!0}}};return p}[(c=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let d=this.b,f=this.size;for(;d&&f>o;)this.a.delete(d.key),d=d.next,f--;this.b=d,this.d=f,d&&(d.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const d=o.next,f=o.previous;if(!d||!f)throw new Error("Invalid list");d.previous=f,f.next=d}o.next=void 0,o.previous=void 0,this.e++}j(o,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(o===this.b)return;const f=o.next,p=o.previous;o===this.c?(p.next=void 0,this.c=p):(f.previous=p,p.next=f),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(d===2){if(o===this.c)return;const f=o.next,p=o.previous;o===this.b?(f.previous=void 0,this.b=f):(f.previous=p,p.next=f),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((d,f)=>{o.push([f,d])}),o}fromJSON(o){this.clear();for(const[d,f]of o)this.set(d,f)}}e.LinkedMap=D;class k extends D{constructor(o,d=1){super(),this.k=o,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,d=2){return super.get(o,d)}peek(o){return super.get(o,0)}set(o,d){return super.set(o,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=k;class C{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let d=this.a.get(o)||0;return d===0?!1:(d--,d===0?this.a.delete(o):this.a.set(o,d),!0)}has(o){return this.a.has(o)}}e.CounterSet=C}),function(ie,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[148],Ce([0]),e):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(re,le){for(var de=0;de<le.length;de++){var te=le[de];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(re,te.key,te)}}function a(re,le,de){return le&&e(re.prototype,le),de&&e(re,de),Object.defineProperty(re,"prototype",{writable:!1}),re}function R(re,le){if(!!re){if(typeof re=="string")return c(re,le);var de=Object.prototype.toString.call(re).slice(8,-1);if(de==="Object"&&re.constructor&&(de=re.constructor.name),de==="Map"||de==="Set")return Array.from(re);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return c(re,le)}}function c(re,le){(le==null||le>re.length)&&(le=re.length);for(var de=0,te=new Array(le);de<le;de++)te[de]=re[de];return te}function L(re,le){var de=typeof Symbol<"u"&&re[Symbol.iterator]||re["@@iterator"];if(de)return(de=de.call(re)).next.bind(de);if(Array.isArray(re)||(de=R(re))||le&&re&&typeof re.length=="number"){de&&(re=de);var te=0;return function(){return te>=re.length?{done:!0}:{done:!1,value:re[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function E(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=E();function T(re){ie.defaults=re}var S=/[&<>"']/,I=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,D={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(le){return D[le]};function C(re,le){if(le){if(S.test(re))return re.replace(I,k)}else if(N.test(re))return re.replace(A,k);return re}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(re){return re.replace(m,function(le,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var d=/(^|[^\[])\^/g;function f(re,le){re=typeof re=="string"?re:re.source,le=le||"";var de={replace:function(ae,se){return se=se.source||se,se=se.replace(d,"$1"),re=re.replace(ae,se),de},getRegex:function(){return new RegExp(re,le)}};return de}var p=/[^\w:]/g,y=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(re,le,de){if(re){var te;try{te=decodeURIComponent(o(de)).replace(p,"").toLowerCase()}catch{return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}le&&!y.test(de)&&(de=u(le,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},s=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(re,le){t[" "+re]||(s.test(re)?t[" "+re]=re+"/":t[" "+re]=h(re,"/",!0)),re=t[" "+re];var de=re.indexOf(":")===-1;return le.substring(0,2)==="//"?de?le:re.replace(r,"$1")+le:le.charAt(0)==="/"?de?le:re.replace(l,"$1")+le:re+le}var b={exec:function(){}};function i(re){for(var le=1,de,te;le<arguments.length;le++){de=arguments[le];for(te in de)Object.prototype.hasOwnProperty.call(de,te)&&(re[te]=de[te])}return re}function n(re,le){var de=re.replace(/\|/g,function(se,F,$){for(var q=!1,J=F;--J>=0&&$[J]==="\\";)q=!q;return q?"|":" |"}),te=de.split(/ \|/),ae=0;if(te[0].trim()||te.shift(),te.length>0&&!te[te.length-1].trim()&&te.pop(),te.length>le)te.splice(le);else for(;te.length<le;)te.push("");for(;ae<te.length;ae++)te[ae]=te[ae].trim().replace(/\\\|/g,"|");return te}function h(re,le,de){var te=re.length;if(te===0)return"";for(var ae=0;ae<te;){var se=re.charAt(te-ae-1);if(se===le&&!de)ae++;else if(se!==le&&de)ae++;else break}return re.slice(0,te-ae)}function w(re,le){if(re.indexOf(le[1])===-1)return-1;for(var de=re.length,te=0,ae=0;ae<de;ae++)if(re[ae]==="\\")ae++;else if(re[ae]===le[0])te++;else if(re[ae]===le[1]&&(te--,te<0))return ae;return-1}function v(re){re&&re.sanitize&&!re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function O(re,le){if(le<1)return"";for(var de="";le>1;)le&1&&(de+=re),le>>=1,re+=re;return de+re}function j(re,le,de,te){var ae=le.href,se=le.title?C(le.title):null,F=re[1].replace(/\\([\[\]])/g,"$1");if(re[0].charAt(0)!=="!"){te.state.inLink=!0;var $={type:"link",raw:de,href:ae,title:se,text:F,tokens:te.inlineTokens(F)};return te.state.inLink=!1,$}return{type:"image",raw:de,href:ae,title:se,text:C(F)}}function V(re,le){var de=re.match(/^(\s+)(?:```)/);if(de===null)return le;var te=de[1];return le.split(`
`).map(function(ae){var se=ae.match(/^\s+/);if(se===null)return ae;var F=se[0];return F.length>=te.length?ae.slice(te.length):ae}).join(`
`)}var Q=function(){function re(de){this.options=de||ie.defaults}var le=re.prototype;return le.space=function(te){var ae=this.rules.block.newline.exec(te);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(te){var ae=this.rules.block.code.exec(te);if(ae){var se=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?se:h(se,`
`)}}},le.fences=function(te){var ae=this.rules.block.fences.exec(te);if(ae){var se=ae[0],F=V(se,ae[3]||"");return{type:"code",raw:se,lang:ae[2]?ae[2].trim():ae[2],text:F}}},le.heading=function(te){var ae=this.rules.block.heading.exec(te);if(ae){var se=ae[2].trim();if(/#$/.test(se)){var F=h(se,"#");(this.options.pedantic||!F||/ $/.test(F))&&(se=F.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:se,tokens:this.lexer.inline(se)}}},le.hr=function(te){var ae=this.rules.block.hr.exec(te);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(te){var ae=this.rules.block.blockquote.exec(te);if(ae){var se=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},le.list=function(te){var ae=this.rules.block.list.exec(te);if(ae){var se,F,$,q,J,ue,we,Ae,ve,Ie,ke,He,qe=ae[1].trim(),nt=qe.length>1,Qe={type:"list",raw:"",ordered:nt,start:nt?+qe.slice(0,-1):"",loose:!1,items:[]};qe=nt?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=nt?qe:"[*+-]");for(var tt=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");te&&(He=!1,!(!(ae=tt.exec(te))||this.rules.block.hr.test(te)));){if(se=ae[0],te=te.substring(se.length),Ae=ae[2].split(`
`,1)[0],ve=te.split(`
`,1)[0],this.options.pedantic?(q=2,ke=Ae.trimLeft()):(q=ae[2].search(/[^ ]/),q=q>4?1:q,ke=Ae.slice(q),q+=ae[1].length),ue=!1,!Ae&&/^ *$/.test(ve)&&(se+=ve+`
`,te=te.substring(ve.length+1),He=!0),!He)for(var rt=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Be=new RegExp("^ {0,"+Math.min(3,q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:```|~~~)"),z=new RegExp("^ {0,"+Math.min(3,q-1)+"}#");te&&(Ie=te.split(`
`,1)[0],Ae=Ie,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Ae)||z.test(Ae)||rt.test(Ae)||Be.test(te)));){if(Ae.search(/[^ ]/)>=q||!Ae.trim())ke+=`
`+Ae.slice(q);else if(!ue)ke+=`
`+Ae;else break;!ue&&!Ae.trim()&&(ue=!0),se+=Ie+`
`,te=te.substring(Ie.length+1)}Qe.loose||(we?Qe.loose=!0:/\n *\n *$/.test(se)&&(we=!0)),this.options.gfm&&(F=/^\[[ xX]\] /.exec(ke),F&&($=F[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:se,task:!!F,checked:$,loose:!1,text:ke}),Qe.raw+=se}Qe.items[Qe.items.length-1].raw=se.trimRight(),Qe.items[Qe.items.length-1].text=ke.trimRight(),Qe.raw=Qe.raw.trimRight();var X=Qe.items.length;for(J=0;J<X;J++){this.lexer.state.top=!1,Qe.items[J].tokens=this.lexer.blockTokens(Qe.items[J].text,[]);var fe=Qe.items[J].tokens.filter(function(Ne){return Ne.type==="space"}),Le=fe.every(function(Ne){for(var je=Ne.raw.split(""),_e=0,Xe=L(je),st;!(st=Xe()).done;){var at=st.value;if(at===`
`&&(_e+=1),_e>1)return!0}return!1});!Qe.loose&&fe.length&&Le&&(Qe.loose=!0,Qe.items[J].loose=!0)}return Qe}},le.html=function(te){var ae=this.rules.block.html.exec(te);if(ae){var se={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var F=this.options.sanitizer?this.options.sanitizer(ae[0]):C(ae[0]);se.type="paragraph",se.text=F,se.tokens=this.lexer.inline(F)}return se}},le.def=function(te){var ae=this.rules.block.def.exec(te);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var se=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(te){var ae=this.rules.block.table.exec(te);if(ae){var se={type:"table",header:n(ae[1]).map(function(we){return{text:we}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=ae[0];var F=se.align.length,$,q,J,ue;for($=0;$<F;$++)/^ *-+: *$/.test(se.align[$])?se.align[$]="right":/^ *:-+: *$/.test(se.align[$])?se.align[$]="center":/^ *:-+ *$/.test(se.align[$])?se.align[$]="left":se.align[$]=null;for(F=se.rows.length,$=0;$<F;$++)se.rows[$]=n(se.rows[$],se.header.length).map(function(we){return{text:we}});for(F=se.header.length,q=0;q<F;q++)se.header[q].tokens=this.lexer.inline(se.header[q].text);for(F=se.rows.length,q=0;q<F;q++)for(ue=se.rows[q],J=0;J<ue.length;J++)ue[J].tokens=this.lexer.inline(ue[J].text);return se}}},le.lheading=function(te){var ae=this.rules.block.lheading.exec(te);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(te){var ae=this.rules.block.paragraph.exec(te);if(ae){var se=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:se,tokens:this.lexer.inline(se)}}},le.text=function(te){var ae=this.rules.block.text.exec(te);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(te){var ae=this.rules.inline.escape.exec(te);if(ae)return{type:"escape",raw:ae[0],text:C(ae[1])}},le.tag=function(te){var ae=this.rules.inline.tag.exec(te);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):C(ae[0]):ae[0]}},le.link=function(te){var ae=this.rules.inline.link.exec(te);if(ae){var se=ae[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var F=h(se.slice(0,-1),"\\");if((se.length-F.length)%2===0)return}else{var $=w(ae[2],"()");if($>-1){var q=ae[0].indexOf("!")===0?5:4,J=q+ae[1].length+$;ae[2]=ae[2].substring(0,$),ae[0]=ae[0].substring(0,J).trim(),ae[3]=""}}var ue=ae[2],we="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ue);Ae&&(ue=Ae[1],we=Ae[3])}else we=ae[3]?ae[3].slice(1,-1):"";return ue=ue.trim(),/^</.test(ue)&&(this.options.pedantic&&!/>$/.test(se)?ue=ue.slice(1):ue=ue.slice(1,-1)),j(ae,{href:ue&&ue.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(te,ae){var se;if((se=this.rules.inline.reflink.exec(te))||(se=this.rules.inline.nolink.exec(te))){var F=(se[2]||se[1]).replace(/\s+/g," ");if(F=ae[F.toLowerCase()],!F||!F.href){var $=se[0].charAt(0);return{type:"text",raw:$,text:$}}return j(se,F,se[0],this.lexer)}},le.emStrong=function(te,ae,se){se===void 0&&(se="");var F=this.rules.inline.emStrong.lDelim.exec(te);if(!!F&&!(F[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=F[1]||F[2]||"";if(!$||$&&(se===""||this.rules.inline.punctuation.exec(se))){var q=F[0].length-1,J,ue,we=q,Ae=0,ve=F[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ve.lastIndex=0,ae=ae.slice(-1*te.length+q);(F=ve.exec(ae))!=null;)if(J=F[1]||F[2]||F[3]||F[4]||F[5]||F[6],!!J){if(ue=J.length,F[3]||F[4]){we+=ue;continue}else if((F[5]||F[6])&&q%3&&!((q+ue)%3)){Ae+=ue;continue}if(we-=ue,!(we>0)){if(ue=Math.min(ue,ue+we+Ae),Math.min(q,ue)%2){var Ie=te.slice(1,q+F.index+ue);return{type:"em",raw:te.slice(0,q+F.index+ue+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}var ke=te.slice(2,q+F.index+ue-1);return{type:"strong",raw:te.slice(0,q+F.index+ue+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},le.codespan=function(te){var ae=this.rules.inline.code.exec(te);if(ae){var se=ae[2].replace(/\n/g," "),F=/[^ ]/.test(se),$=/^ /.test(se)&&/ $/.test(se);return F&&$&&(se=se.substring(1,se.length-1)),se=C(se,!0),{type:"codespan",raw:ae[0],text:se}}},le.br=function(te){var ae=this.rules.inline.br.exec(te);if(ae)return{type:"br",raw:ae[0]}},le.del=function(te){var ae=this.rules.inline.del.exec(te);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(te,ae){var se=this.rules.inline.autolink.exec(te);if(se){var F,$;return se[2]==="@"?(F=C(this.options.mangle?ae(se[1]):se[1]),$="mailto:"+F):(F=C(se[1]),$=F),{type:"link",raw:se[0],text:F,href:$,tokens:[{type:"text",raw:F,text:F}]}}},le.url=function(te,ae){var se;if(se=this.rules.inline.url.exec(te)){var F,$;if(se[2]==="@")F=C(this.options.mangle?ae(se[0]):se[0]),$="mailto:"+F;else{var q;do q=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(q!==se[0]);F=C(se[0]),se[1]==="www."?$="http://"+F:$=F}return{type:"link",raw:se[0],text:F,href:$,tokens:[{type:"text",raw:F,text:F}]}}},le.inlineText=function(te,ae){var se=this.rules.inline.text.exec(te);if(se){var F;return this.lexer.state.inRawBlock?F=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):C(se[0]):se[0]:F=C(this.options.smartypants?ae(se[0]):se[0]),{type:"text",raw:se[0],text:F}}},re}(),G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:b,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=f(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=f(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=f(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=f(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=f(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=f(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=i({},G),G.gfm=i({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=f(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.gfm.paragraph=f(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",G.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=i({},G.normal,{html:f(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:b,paragraph:f(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:b,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:b,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=f(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=f(G._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=f(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=f(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=f(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=f(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=f(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=f(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=f(U.reflink).replace("label",U._label).replace("ref",G._label).getRegex(),U.nolink=f(U.nolink).replace("ref",G._label).getRegex(),U.reflinkSearch=f(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=i({},U),U.pedantic=i({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:f(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:f(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=i({},U.normal,{escape:f(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=f(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=i({},U.gfm,{br:f(U.br).replace("{2,}","*").getRegex(),text:f(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function P(re){return re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function M(re){var le="",de,te,ae=re.length;for(de=0;de<ae;de++)te=re.charCodeAt(de),Math.random()>.5&&(te="x"+te.toString(16)),le+="&#"+te+";";return le}var B=function(){function re(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||ie.defaults,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:G.normal,inline:U.normal};this.options.pedantic?(te.block=G.pedantic,te.inline=U.pedantic):this.options.gfm&&(te.block=G.gfm,this.options.breaks?te.inline=U.breaks:te.inline=U.gfm),this.tokenizer.rules=te}re.lex=function(te,ae){var se=new re(ae);return se.lex(te)},re.lexInline=function(te,ae){var se=new re(ae);return se.inlineTokens(te)};var le=re.prototype;return le.lex=function(te){te=te.replace(/\r\n|\r/g,`
`),this.blockTokens(te,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(te,ae){var se=this;ae===void 0&&(ae=[]),this.options.pedantic?te=te.replace(/\t/g,"    ").replace(/^ +$/gm,""):te=te.replace(/^( *)(\t+)/gm,function(we,Ae,ve){return Ae+"    ".repeat(ve.length)});for(var F,$,q,J;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(F=we.call({lexer:se},te,ae))?(te=te.substring(F.raw.length),ae.push(F),!0):!1}))){if(F=this.tokenizer.space(te)){te=te.substring(F.raw.length),F.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(F);continue}if(F=this.tokenizer.code(te)){te=te.substring(F.raw.length),$=ae[ae.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+F.raw,$.text+=`
`+F.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):ae.push(F);continue}if(F=this.tokenizer.fences(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.heading(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.hr(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.blockquote(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.list(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.html(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.def(te)){te=te.substring(F.raw.length),$=ae[ae.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+F.raw,$.text+=`
`+F.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[F.tag]||(this.tokens.links[F.tag]={href:F.href,title:F.title});continue}if(F=this.tokenizer.table(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.lheading(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(q=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Ae=te.slice(1),ve=void 0;se.options.extensions.startBlock.forEach(function(Ie){ve=Ie.call({lexer:this},Ae),typeof ve=="number"&&ve>=0&&(we=Math.min(we,ve))}),we<1/0&&we>=0&&(q=te.substring(0,we+1))}(),this.state.top&&(F=this.tokenizer.paragraph(q))){$=ae[ae.length-1],J&&$.type==="paragraph"?($.raw+=`
`+F.raw,$.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ae.push(F),J=q.length!==te.length,te=te.substring(F.raw.length);continue}if(F=this.tokenizer.text(te)){te=te.substring(F.raw.length),$=ae[ae.length-1],$&&$.type==="text"?($.raw+=`
`+F.raw,$.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ae.push(F);continue}if(te){var ue="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(ue);break}else throw new Error(ue)}}return this.state.top=!0,ae},le.inline=function(te,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:te,tokens:ae}),ae},le.inlineTokens=function(te,ae){var se=this;ae===void 0&&(ae=[]);var F,$,q,J=te,ue,we,Ae;if(this.tokens.links){var ve=Object.keys(this.tokens.links);if(ve.length>0)for(;(ue=this.tokenizer.rules.inline.reflinkSearch.exec(J))!=null;)ve.includes(ue[0].slice(ue[0].lastIndexOf("[")+1,-1))&&(J=J.slice(0,ue.index)+"["+O("a",ue[0].length-2)+"]"+J.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ue=this.tokenizer.rules.inline.blockSkip.exec(J))!=null;)J=J.slice(0,ue.index)+"["+O("a",ue[0].length-2)+"]"+J.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ue=this.tokenizer.rules.inline.escapedEmSt.exec(J))!=null;)J=J.slice(0,ue.index)+"++"+J.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(we||(Ae=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(F=ke.call({lexer:se},te,ae))?(te=te.substring(F.raw.length),ae.push(F),!0):!1}))){if(F=this.tokenizer.escape(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.tag(te)){te=te.substring(F.raw.length),$=ae[ae.length-1],$&&F.type==="text"&&$.type==="text"?($.raw+=F.raw,$.text+=F.text):ae.push(F);continue}if(F=this.tokenizer.link(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(F.raw.length),$=ae[ae.length-1],$&&F.type==="text"&&$.type==="text"?($.raw+=F.raw,$.text+=F.text):ae.push(F);continue}if(F=this.tokenizer.emStrong(te,J,Ae)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.codespan(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.br(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.del(te)){te=te.substring(F.raw.length),ae.push(F);continue}if(F=this.tokenizer.autolink(te,M)){te=te.substring(F.raw.length),ae.push(F);continue}if(!this.state.inLink&&(F=this.tokenizer.url(te,M))){te=te.substring(F.raw.length),ae.push(F);continue}if(q=te,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,He=te.slice(1),qe=void 0;se.options.extensions.startInline.forEach(function(nt){qe=nt.call({lexer:this},He),typeof qe=="number"&&qe>=0&&(ke=Math.min(ke,qe))}),ke<1/0&&ke>=0&&(q=te.substring(0,ke+1))}(),F=this.tokenizer.inlineText(q,P)){te=te.substring(F.raw.length),F.raw.slice(-1)!=="_"&&(Ae=F.raw.slice(-1)),we=!0,$=ae[ae.length-1],$&&$.type==="text"?($.raw+=F.raw,$.text+=F.text):ae.push(F);continue}if(te){var Ie="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return ae},a(re,null,[{key:"rules",get:function(){return{block:G,inline:U}}}]),re}(),Z=function(){function re(de){this.options=de||ie.defaults}var le=re.prototype;return le.code=function(te,ae,se){var F=(ae||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(te,F);$!=null&&$!==te&&(se=!0,te=$)}return te=te.replace(/\n$/,"")+`
`,F?'<pre><code class="'+this.options.langPrefix+C(F,!0)+'">'+(se?te:C(te,!0))+`</code></pre>
`:"<pre><code>"+(se?te:C(te,!0))+`</code></pre>
`},le.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},le.html=function(te){return te},le.heading=function(te,ae,se,F){if(this.options.headerIds){var $=this.options.headerPrefix+F.slug(se);return"<h"+ae+' id="'+$+'">'+te+"</h"+ae+`>
`}return"<h"+ae+">"+te+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(te,ae,se){var F=ae?"ol":"ul",$=ae&&se!==1?' start="'+se+'"':"";return"<"+F+$+`>
`+te+"</"+F+`>
`},le.listitem=function(te){return"<li>"+te+`</li>
`},le.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(te){return"<p>"+te+`</p>
`},le.table=function(te,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+ae+`</table>
`},le.tablerow=function(te){return`<tr>
`+te+`</tr>
`},le.tablecell=function(te,ae){var se=ae.header?"th":"td",F=ae.align?"<"+se+' align="'+ae.align+'">':"<"+se+">";return F+te+("</"+se+`>
`)},le.strong=function(te){return"<strong>"+te+"</strong>"},le.em=function(te){return"<em>"+te+"</em>"},le.codespan=function(te){return"<code>"+te+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(te){return"<del>"+te+"</del>"},le.link=function(te,ae,se){if(te=g(this.options.sanitize,this.options.baseUrl,te),te===null)return se;var F='<a href="'+C(te)+'"';return ae&&(F+=' title="'+ae+'"'),F+=">"+se+"</a>",F},le.image=function(te,ae,se){if(te=g(this.options.sanitize,this.options.baseUrl,te),te===null)return se;var F='<img src="'+te+'" alt="'+se+'"';return ae&&(F+=' title="'+ae+'"'),F+=this.options.xhtml?"/>":">",F},le.text=function(te){return te},re}(),Y=function(){function re(){}var le=re.prototype;return le.strong=function(te){return te},le.em=function(te){return te},le.codespan=function(te){return te},le.del=function(te){return te},le.html=function(te){return te},le.text=function(te){return te},le.link=function(te,ae,se){return""+se},le.image=function(te,ae,se){return""+se},le.br=function(){return""},re}(),H=function(){function re(){this.seen={}}var le=re.prototype;return le.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(te,ae){var se=te,F=0;if(this.seen.hasOwnProperty(se)){F=this.seen[te];do F++,se=te+"-"+F;while(this.seen.hasOwnProperty(se))}return ae||(this.seen[te]=F,this.seen[se]=0),se},le.slug=function(te,ae){ae===void 0&&(ae={});var se=this.serialize(te);return this.getNextSafeSlug(se,ae.dryrun)},re}(),_=function(){function re(de){this.options=de||ie.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new H}re.parse=function(te,ae){var se=new re(ae);return se.parse(te)},re.parseInline=function(te,ae){var se=new re(ae);return se.parseInline(te)};var le=re.prototype;return le.parse=function(te,ae){ae===void 0&&(ae=!0);var se="",F,$,q,J,ue,we,Ae,ve,Ie,ke,He,qe,nt,Qe,tt,rt,Be,it,z,X=te.length;for(F=0;F<X;F++){if(ke=te[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(z=this.options.extensions.renderers[ke.type].call({parser:this},ke),z!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){se+=z||"";continue}switch(ke.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,o(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(ve="",Ae="",J=ke.header.length,$=0;$<J;$++)Ae+=this.renderer.tablecell(this.parseInline(ke.header[$].tokens),{header:!0,align:ke.align[$]});for(ve+=this.renderer.tablerow(Ae),Ie="",J=ke.rows.length,$=0;$<J;$++){for(we=ke.rows[$],Ae="",ue=we.length,q=0;q<ue;q++)Ae+=this.renderer.tablecell(this.parseInline(we[q].tokens),{header:!1,align:ke.align[q]});Ie+=this.renderer.tablerow(Ae)}se+=this.renderer.table(ve,Ie);continue}case"blockquote":{Ie=this.parse(ke.tokens),se+=this.renderer.blockquote(Ie);continue}case"list":{for(He=ke.ordered,qe=ke.start,nt=ke.loose,J=ke.items.length,Ie="",$=0;$<J;$++)tt=ke.items[$],rt=tt.checked,Be=tt.task,Qe="",tt.task&&(it=this.renderer.checkbox(rt),nt?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=it+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=it+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:it}):Qe+=it),Qe+=this.parse(tt.tokens,nt),Ie+=this.renderer.listitem(Qe,Be,rt);se+=this.renderer.list(Ie,He,qe);continue}case"html":{se+=this.renderer.html(ke.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Ie=ke.tokens?this.parseInline(ke.tokens):ke.text;F+1<X&&te[F+1].type==="text";)ke=te[++F],Ie+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);se+=ae?this.renderer.paragraph(Ie):Ie;continue}default:{var fe='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(fe);return}else throw new Error(fe)}}}return se},le.parseInline=function(te,ae){ae=ae||this.renderer;var se="",F,$,q,J=te.length;for(F=0;F<J;F++){if($=te[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(q=this.options.extensions.renderers[$.type].call({parser:this},$),q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){se+=q||"";continue}switch($.type){case"escape":{se+=ae.text($.text);break}case"html":{se+=ae.html($.text);break}case"link":{se+=ae.link($.href,$.title,this.parseInline($.tokens,ae));break}case"image":{se+=ae.image($.href,$.title,$.text);break}case"strong":{se+=ae.strong(this.parseInline($.tokens,ae));break}case"em":{se+=ae.em(this.parseInline($.tokens,ae));break}case"codespan":{se+=ae.codespan($.text);break}case"br":{se+=ae.br();break}case"del":{se+=ae.del(this.parseInline($.tokens,ae));break}case"text":{se+=ae.text($.text);break}default:{var ue='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(ue);return}else throw new Error(ue)}}}return se},re}();function ee(re,le,de){if(typeof re>"u"||re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");if(typeof le=="function"&&(de=le,le=null),le=i({},ee.defaults,le||{}),v(le),de){var te=le.highlight,ae;try{ae=B.lex(re,le)}catch(J){return de(J)}var se=function(ue){var we;if(!ue)try{le.walkTokens&&ee.walkTokens(ae,le.walkTokens),we=_.parse(ae,le)}catch(Ae){ue=Ae}return le.highlight=te,ue?de(ue):de(null,we)};if(!te||te.length<3||(delete le.highlight,!ae.length))return se();var F=0;ee.walkTokens(ae,function(J){J.type==="code"&&(F++,setTimeout(function(){te(J.text,J.lang,function(ue,we){if(ue)return se(ue);we!=null&&we!==J.text&&(J.text=we,J.escaped=!0),F--,F===0&&se()})},0))}),F===0&&se();return}function $(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+C(J.message+"",!0)+"</pre>";throw J}try{var q=B.lex(re,le);if(le.walkTokens){if(le.async)return Promise.all(ee.walkTokens(q,le.walkTokens)).then(function(){return _.parse(q,le)}).catch($);ee.walkTokens(q,le.walkTokens)}return _.parse(q,le)}catch(J){$(J)}}ee.options=ee.setOptions=function(re){return i(ee.defaults,re),T(ee.defaults),ee},ee.getDefaults=E,ee.defaults=ie.defaults,ee.use=function(){for(var re=arguments.length,le=new Array(re),de=0;de<re;de++)le[de]=arguments[de];var te=i.apply(void 0,[{}].concat(le)),ae=ee.defaults.extensions||{renderers:{},childTokens:{}},se;le.forEach(function(F){if(F.extensions&&(se=!0,F.extensions.forEach(function(q){if(!q.name)throw new Error("extension name required");if(q.renderer){var J=ae.renderers?ae.renderers[q.name]:null;J?ae.renderers[q.name]=function(){for(var ue=arguments.length,we=new Array(ue),Ae=0;Ae<ue;Ae++)we[Ae]=arguments[Ae];var ve=q.renderer.apply(this,we);return ve===!1&&(ve=J.apply(this,we)),ve}:ae.renderers[q.name]=q.renderer}if(q.tokenizer){if(!q.level||q.level!=="block"&&q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[q.level]?ae[q.level].unshift(q.tokenizer):ae[q.level]=[q.tokenizer],q.start&&(q.level==="block"?ae.startBlock?ae.startBlock.push(q.start):ae.startBlock=[q.start]:q.level==="inline"&&(ae.startInline?ae.startInline.push(q.start):ae.startInline=[q.start]))}q.childTokens&&(ae.childTokens[q.name]=q.childTokens)})),F.renderer&&function(){var q=ee.defaults.renderer||new Z,J=function(Ae){var ve=q[Ae];q[Ae]=function(){for(var Ie=arguments.length,ke=new Array(Ie),He=0;He<Ie;He++)ke[He]=arguments[He];var qe=F.renderer[Ae].apply(q,ke);return qe===!1&&(qe=ve.apply(q,ke)),qe}};for(var ue in F.renderer)J(ue);te.renderer=q}(),F.tokenizer&&function(){var q=ee.defaults.tokenizer||new Q,J=function(Ae){var ve=q[Ae];q[Ae]=function(){for(var Ie=arguments.length,ke=new Array(Ie),He=0;He<Ie;He++)ke[He]=arguments[He];var qe=F.tokenizer[Ae].apply(q,ke);return qe===!1&&(qe=ve.apply(q,ke)),qe}};for(var ue in F.tokenizer)J(ue);te.tokenizer=q}(),F.walkTokens){var $=ee.defaults.walkTokens;te.walkTokens=function(q){var J=[];return J.push(F.walkTokens.call(this,q)),$&&(J=J.concat($.call(this,q))),J}}se&&(te.extensions=ae),ee.setOptions(te)})},ee.walkTokens=function(re,le){for(var de=[],te=function(){var $=se.value;switch(de=de.concat(le.call(ee,$)),$.type){case"table":{for(var q=L($.header),J;!(J=q()).done;){var ue=J.value;de=de.concat(ee.walkTokens(ue.tokens,le))}for(var we=L($.rows),Ae;!(Ae=we()).done;)for(var ve=Ae.value,Ie=L(ve),ke;!(ke=Ie()).done;){var He=ke.value;de=de.concat(ee.walkTokens(He.tokens,le))}break}case"list":{de=de.concat(ee.walkTokens($.items,le));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[$.type]?ee.defaults.extensions.childTokens[$.type].forEach(function(qe){de=de.concat(ee.walkTokens($[qe],le))}):$.tokens&&(de=de.concat(ee.walkTokens($.tokens,le)))}},ae=L(re),se;!(se=ae()).done;)te();return de},ee.parseInline=function(re,le){if(typeof re>"u"||re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");le=i({},ee.defaults,le||{}),v(le);try{var de=B.lexInline(re,le);return le.walkTokens&&ee.walkTokens(de,le.walkTokens),_.parseInline(de,le)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+C(te.message+"",!0)+"</pre>";throw te}},ee.Parser=_,ee.parser=_.parse,ee.Renderer=Z,ee.TextRenderer=Y,ee.Lexer=B,ee.lexer=B.lex,ee.Tokenizer=Q,ee.Slugger=H,ee.parse=ee;var be=ee.options,ce=ee.setOptions,oe=ee.use,x=ee.walkTokens,he=ee.parseInline,pe=ee,Se=_.parse,Re=B.lex;ie.Lexer=B,ie.Parser=_,ie.Renderer=Z,ie.Slugger=H,ie.TextRenderer=Y,ie.Tokenizer=Q,ie.getDefaults=E,ie.lexer=Re,ie.marked=ee,ie.options=be,ie.parse=pe,ie.parseInline=he,ie.parser=Se,ie.setOptions=ce,ie.use=oe,ie.walkTokens=x,Object.defineProperty(ie,"__esModule",{value:!0})}),define(De[86],Ce([1,0,28]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new a.LRUCache(1e4);function c(I){return S(I,"NFC",R)}e.normalizeNFC=c;const L=new a.LRUCache(1e4);function E(I){return S(I,"NFD",L)}e.normalizeNFD=E;const T=/[^\u0000-\u0080]/;function S(I,N,A){if(!I)return I;const D=A.get(I);if(D)return D;let k;return T.test(I)?k=I.normalize(N):k=I,A.set(I,k),k}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(N){return E(N).replace(I,"")}}()}),define(De[102],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(T,S,I){return Math.min(Math.max(T,S),I)}e.clamp=a;function R(T,S){return(S+T%S)%S}e.rot=R;class c{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=c;class L{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=L;class E{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const I=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=E}),function(){function ie(c){const L=[];typeof c=="number"&&L.push("code/timeOrigin",c);function E(S){L.push(S,Date.now())}function T(){const S=[];for(let I=0;I<L.length;I+=2)S.push({name:L[I],startTime:L[I+1]});return S}return{mark:E,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(c){performance.mark(c)},getMarks(){let c=performance.timeOrigin;typeof c!="number"&&(c=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(c)}];for(const E of performance.getEntriesByType("mark"))L.push({name:E.name,startTime:Math.round(c+E.startTime)});return L}};if(typeof process=="object"){const c=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(c)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function a(c){return c.MonacoPerformanceMarks||(c.MonacoPerformanceMarks=e()),c.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=a(R))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var R in a)(typeof exports=="object"?exports:ie)[R]=a[R]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function a(R){if(e[R])return e[R].exports;var c=e[R]={i:R,l:!1,exports:{}};return ie[R].call(c.exports,c,c.exports,a),c.l=!0,c.exports}return a.m=ie,a.c=e,a.d=function(R,c,L){a.o(R,c)||Object.defineProperty(R,c,{enumerable:!0,get:L})},a.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},a.t=function(R,c){if(1&c&&(R=a(R)),8&c||4&c&&typeof R=="object"&&R&&R.__esModule)return R;var L=Object.create(null);if(a.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:R}),2&c&&typeof R!="string")for(var E in R)a.d(L,E,function(T){return R[T]}.bind(null,E));return L},a.n=function(R){var c=R&&R.__esModule?function(){return R.default}:function(){return R};return a.d(c,"a",c),c},a.o=function(R,c){return Object.prototype.hasOwnProperty.call(R,c)},a.p="",a(a.s=0)}([function(ie,e,a){(function(R){var c;e=ie.exports=oe,c=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var ve=Array.prototype.slice.call(arguments,0);ve.unshift("SEMVER"),console.log.apply(console,ve)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,E=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],S=e.src=[],I=0,N=I++;S[N]="0|[1-9]\\d*";var A=I++;S[A]="[0-9]+";var D=I++;S[D]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=I++;S[k]="("+S[N]+")\\.("+S[N]+")\\.("+S[N]+")";var C=I++;S[C]="("+S[A]+")\\.("+S[A]+")\\.("+S[A]+")";var m=I++;S[m]="(?:"+S[N]+"|"+S[D]+")";var o=I++;S[o]="(?:"+S[A]+"|"+S[D]+")";var d=I++;S[d]="(?:-("+S[m]+"(?:\\."+S[m]+")*))";var f=I++;S[f]="(?:-?("+S[o]+"(?:\\."+S[o]+")*))";var p=I++;S[p]="[0-9A-Za-z-]+";var y=I++;S[y]="(?:\\+("+S[p]+"(?:\\."+S[p]+")*))";var g=I++,t="v?"+S[k]+S[d]+"?"+S[y]+"?";S[g]="^"+t+"$";var s="[v=\\s]*"+S[C]+S[f]+"?"+S[y]+"?",r=I++;S[r]="^"+s+"$";var l=I++;S[l]="((?:<|>)?=?)";var u=I++;S[u]=S[A]+"|x|X|\\*";var b=I++;S[b]=S[N]+"|x|X|\\*";var i=I++;S[i]="[v=\\s]*("+S[b]+")(?:\\.("+S[b]+")(?:\\.("+S[b]+")(?:"+S[d]+")?"+S[y]+"?)?)?";var n=I++;S[n]="[v=\\s]*("+S[u]+")(?:\\.("+S[u]+")(?:\\.("+S[u]+")(?:"+S[f]+")?"+S[y]+"?)?)?";var h=I++;S[h]="^"+S[l]+"\\s*"+S[i]+"$";var w=I++;S[w]="^"+S[l]+"\\s*"+S[n]+"$";var v=I++;S[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=I++;S[O]="(?:~>?)";var j=I++;S[j]="(\\s*)"+S[O]+"\\s+",T[j]=new RegExp(S[j],"g");var V=I++;S[V]="^"+S[O]+S[i]+"$";var Q=I++;S[Q]="^"+S[O]+S[n]+"$";var G=I++;S[G]="(?:\\^)";var U=I++;S[U]="(\\s*)"+S[G]+"\\s+",T[U]=new RegExp(S[U],"g");var P=I++;S[P]="^"+S[G]+S[i]+"$";var M=I++;S[M]="^"+S[G]+S[n]+"$";var B=I++;S[B]="^"+S[l]+"\\s*("+s+")$|^$";var Z=I++;S[Z]="^"+S[l]+"\\s*("+t+")$|^$";var Y=I++;S[Y]="(\\s*)"+S[l]+"\\s*("+s+"|"+S[i]+")",T[Y]=new RegExp(S[Y],"g");var H=I++;S[H]="^\\s*("+S[i]+")\\s+-\\s+("+S[i]+")\\s*$";var _=I++;S[_]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var ee=I++;S[ee]="(<|>)?=?\\s*\\*";for(var be=0;be<35;be++)c(be,S[be]),T[be]||(T[be]=new RegExp(S[be]));function ce(ve,Ie){if(ve instanceof oe)return ve;if(typeof ve!="string"||ve.length>L||!(Ie?T[r]:T[g]).test(ve))return null;try{return new oe(ve,Ie)}catch{return null}}function oe(ve,Ie){if(ve instanceof oe){if(ve.loose===Ie)return ve;ve=ve.version}else if(typeof ve!="string")throw new TypeError("Invalid Version: "+ve);if(ve.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof oe))return new oe(ve,Ie);c("SemVer",ve,Ie),this.loose=Ie;var ke=ve.trim().match(Ie?T[r]:T[g]);if(!ke)throw new TypeError("Invalid Version: "+ve);if(this.raw=ve,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>E||this.major<0)throw new TypeError("Invalid major version");if(this.minor>E||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>E||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(He){if(/^[0-9]+$/.test(He)){var qe=+He;if(qe>=0&&qe<E)return qe}return He}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=ce,e.valid=function(ve,Ie){var ke=ce(ve,Ie);return ke?ke.version:null},e.clean=function(ve,Ie){var ke=ce(ve.trim().replace(/^[=v]+/,""),Ie);return ke?ke.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(ve){return c("SemVer.compare",this.version,this.loose,ve),ve instanceof oe||(ve=new oe(ve,this.loose)),this.compareMain(ve)||this.comparePre(ve)},oe.prototype.compareMain=function(ve){return ve instanceof oe||(ve=new oe(ve,this.loose)),he(this.major,ve.major)||he(this.minor,ve.minor)||he(this.patch,ve.patch)},oe.prototype.comparePre=function(ve){if(ve instanceof oe||(ve=new oe(ve,this.loose)),this.prerelease.length&&!ve.prerelease.length)return-1;if(!this.prerelease.length&&ve.prerelease.length)return 1;if(!this.prerelease.length&&!ve.prerelease.length)return 0;var Ie=0;do{var ke=this.prerelease[Ie],He=ve.prerelease[Ie];if(c("prerelease compare",Ie,ke,He),ke===void 0&&He===void 0)return 0;if(He===void 0)return 1;if(ke===void 0)return-1;if(ke!==He)return he(ke,He)}while(++Ie)},oe.prototype.inc=function(ve,Ie){switch(ve){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ie);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ie);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ie),this.inc("pre",Ie);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ie),this.inc("pre",Ie);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}Ie&&(this.prerelease[0]===Ie?isNaN(this.prerelease[1])&&(this.prerelease=[Ie,0]):this.prerelease=[Ie,0]);break;default:throw new Error("invalid increment argument: "+ve)}return this.format(),this.raw=this.version,this},e.inc=function(ve,Ie,ke,He){typeof ke=="string"&&(He=ke,ke=void 0);try{return new oe(ve,ke).inc(Ie,He).version}catch{return null}},e.diff=function(ve,Ie){if(re(ve,Ie))return null;var ke=ce(ve),He=ce(Ie);if(ke.prerelease.length||He.prerelease.length){for(var qe in ke)if((qe==="major"||qe==="minor"||qe==="patch")&&ke[qe]!==He[qe])return"pre"+qe;return"prerelease"}for(var qe in ke)if((qe==="major"||qe==="minor"||qe==="patch")&&ke[qe]!==He[qe])return qe},e.compareIdentifiers=he;var x=/^[0-9]+$/;function he(ve,Ie){var ke=x.test(ve),He=x.test(Ie);return ke&&He&&(ve=+ve,Ie=+Ie),ke&&!He?-1:He&&!ke?1:ve<Ie?-1:ve>Ie?1:0}function pe(ve,Ie,ke){return new oe(ve,ke).compare(new oe(Ie,ke))}function Se(ve,Ie,ke){return pe(ve,Ie,ke)>0}function Re(ve,Ie,ke){return pe(ve,Ie,ke)<0}function re(ve,Ie,ke){return pe(ve,Ie,ke)===0}function le(ve,Ie,ke){return pe(ve,Ie,ke)!==0}function de(ve,Ie,ke){return pe(ve,Ie,ke)>=0}function te(ve,Ie,ke){return pe(ve,Ie,ke)<=0}function ae(ve,Ie,ke,He){var qe;switch(Ie){case"===":typeof ve=="object"&&(ve=ve.version),typeof ke=="object"&&(ke=ke.version),qe=ve===ke;break;case"!==":typeof ve=="object"&&(ve=ve.version),typeof ke=="object"&&(ke=ke.version),qe=ve!==ke;break;case"":case"=":case"==":qe=re(ve,ke,He);break;case"!=":qe=le(ve,ke,He);break;case">":qe=Se(ve,ke,He);break;case">=":qe=de(ve,ke,He);break;case"<":qe=Re(ve,ke,He);break;case"<=":qe=te(ve,ke,He);break;default:throw new TypeError("Invalid operator: "+Ie)}return qe}function se(ve,Ie){if(ve instanceof se){if(ve.loose===Ie)return ve;ve=ve.value}if(!(this instanceof se))return new se(ve,Ie);c("comparator",ve,Ie),this.loose=Ie,this.parse(ve),this.semver===F?this.value="":this.value=this.operator+this.semver.version,c("comp",this)}e.rcompareIdentifiers=function(ve,Ie){return he(Ie,ve)},e.major=function(ve,Ie){return new oe(ve,Ie).major},e.minor=function(ve,Ie){return new oe(ve,Ie).minor},e.patch=function(ve,Ie){return new oe(ve,Ie).patch},e.compare=pe,e.compareLoose=function(ve,Ie){return pe(ve,Ie,!0)},e.rcompare=function(ve,Ie,ke){return pe(Ie,ve,ke)},e.sort=function(ve,Ie){return ve.sort(function(ke,He){return e.compare(ke,He,Ie)})},e.rsort=function(ve,Ie){return ve.sort(function(ke,He){return e.rcompare(ke,He,Ie)})},e.gt=Se,e.lt=Re,e.eq=re,e.neq=le,e.gte=de,e.lte=te,e.cmp=ae,e.Comparator=se;var F={};function $(ve,Ie){if(ve instanceof $)return ve.loose===Ie?ve:new $(ve.raw,Ie);if(ve instanceof se)return new $(ve.value,Ie);if(!(this instanceof $))return new $(ve,Ie);if(this.loose=Ie,this.raw=ve,this.set=ve.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ve);this.format()}function q(ve){return!ve||ve.toLowerCase()==="x"||ve==="*"}function J(ve,Ie,ke,He,qe,nt,Qe,tt,rt,Be,it,z,X){return((Ie=q(ke)?"":q(He)?">="+ke+".0.0":q(qe)?">="+ke+"."+He+".0":">="+Ie)+" "+(tt=q(rt)?"":q(Be)?"<"+(+rt+1)+".0.0":q(it)?"<"+rt+"."+(+Be+1)+".0":z?"<="+rt+"."+Be+"."+it+"-"+z:"<="+tt)).trim()}function ue(ve,Ie){for(var ke=0;ke<ve.length;ke++)if(!ve[ke].test(Ie))return!1;if(Ie.prerelease.length){for(ke=0;ke<ve.length;ke++)if(c(ve[ke].semver),ve[ke].semver!==F&&ve[ke].semver.prerelease.length>0){var He=ve[ke].semver;if(He.major===Ie.major&&He.minor===Ie.minor&&He.patch===Ie.patch)return!0}return!1}return!0}function we(ve,Ie,ke){try{Ie=new $(Ie,ke)}catch{return!1}return Ie.test(ve)}function Ae(ve,Ie,ke,He){var qe,nt,Qe,tt,rt;switch(ve=new oe(ve,He),Ie=new $(Ie,He),ke){case">":qe=Se,nt=te,Qe=Re,tt=">",rt=">=";break;case"<":qe=Re,nt=de,Qe=Se,tt="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(ve,Ie,He))return!1;for(var Be=0;Be<Ie.set.length;++Be){var it=Ie.set[Be],z=null,X=null;if(it.forEach(function(fe){fe.semver===F&&(fe=new se(">=0.0.0")),z=z||fe,X=X||fe,qe(fe.semver,z.semver,He)?z=fe:Qe(fe.semver,X.semver,He)&&(X=fe)}),z.operator===tt||z.operator===rt||(!X.operator||X.operator===tt)&&nt(ve,X.semver)||X.operator===rt&&Qe(ve,X.semver))return!1}return!0}se.prototype.parse=function(ve){var Ie=this.loose?T[B]:T[Z],ke=ve.match(Ie);if(!ke)throw new TypeError("Invalid comparator: "+ve);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new oe(ke[2],this.loose):this.semver=F},se.prototype.toString=function(){return this.value},se.prototype.test=function(ve){return c("Comparator.test",ve,this.loose),this.semver===F||(typeof ve=="string"&&(ve=new oe(ve,this.loose)),ae(ve,this.operator,this.semver,this.loose))},se.prototype.intersects=function(ve,Ie){if(!(ve instanceof se))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new $(ve.value,Ie),we(this.value,ke,Ie);if(ve.operator==="")return ke=new $(this.value,Ie),we(ve.semver,ke,Ie);var He=!(this.operator!==">="&&this.operator!==">"||ve.operator!==">="&&ve.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ve.operator!=="<="&&ve.operator!=="<"),nt=this.semver.version===ve.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||ve.operator!==">="&&ve.operator!=="<="),tt=ae(this.semver,"<",ve.semver,Ie)&&(this.operator===">="||this.operator===">")&&(ve.operator==="<="||ve.operator==="<"),rt=ae(this.semver,">",ve.semver,Ie)&&(this.operator==="<="||this.operator==="<")&&(ve.operator===">="||ve.operator===">");return He||qe||nt&&Qe||tt||rt},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(ve){return ve.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(ve){var Ie=this.loose;ve=ve.trim(),c("range",ve,Ie);var ke=Ie?T[_]:T[H];ve=ve.replace(ke,J),c("hyphen replace",ve),ve=ve.replace(T[Y],"$1$2$3"),c("comparator trim",ve,T[Y]),ve=(ve=(ve=ve.replace(T[j],"$1~")).replace(T[U],"$1^")).split(/\s+/).join(" ");var He=Ie?T[B]:T[Z],qe=ve.split(" ").map(function(nt){return function(Qe,tt){return c("comp",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(it){return function(z,X){c("caret",z,X);var fe=X?T[M]:T[P];return z.replace(fe,function(Le,Ne,je,_e,Xe){var st;return c("caret",z,Le,Ne,je,_e,Xe),q(Ne)?st="":q(je)?st=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":q(_e)?st=Ne==="0"?">="+Ne+"."+je+".0 <"+Ne+"."+(+je+1)+".0":">="+Ne+"."+je+".0 <"+(+Ne+1)+".0.0":Xe?(c("replaceCaret pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),st=Ne==="0"?je==="0"?">="+Ne+"."+je+"."+_e+Xe+" <"+Ne+"."+je+"."+(+_e+1):">="+Ne+"."+je+"."+_e+Xe+" <"+Ne+"."+(+je+1)+".0":">="+Ne+"."+je+"."+_e+Xe+" <"+(+Ne+1)+".0.0"):(c("no pr"),st=Ne==="0"?je==="0"?">="+Ne+"."+je+"."+_e+" <"+Ne+"."+je+"."+(+_e+1):">="+Ne+"."+je+"."+_e+" <"+Ne+"."+(+je+1)+".0":">="+Ne+"."+je+"."+_e+" <"+(+Ne+1)+".0.0"),c("caret return",st),st})}(it,Be)}).join(" ")}(Qe,tt),c("caret",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(it){return function(z,X){var fe=X?T[Q]:T[V];return z.replace(fe,function(Le,Ne,je,_e,Xe){var st;return c("tilde",z,Le,Ne,je,_e,Xe),q(Ne)?st="":q(je)?st=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":q(_e)?st=">="+Ne+"."+je+".0 <"+Ne+"."+(+je+1)+".0":Xe?(c("replaceTilde pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),st=">="+Ne+"."+je+"."+_e+Xe+" <"+Ne+"."+(+je+1)+".0"):st=">="+Ne+"."+je+"."+_e+" <"+Ne+"."+(+je+1)+".0",c("tilde return",st),st})}(it,Be)}).join(" ")}(Qe,tt),c("tildes",Qe),Qe=function(rt,Be){return c("replaceXRanges",rt,Be),rt.split(/\s+/).map(function(it){return function(z,X){z=z.trim();var fe=X?T[w]:T[h];return z.replace(fe,function(Le,Ne,je,_e,Xe,st){c("xRange",z,Le,Ne,je,_e,Xe,st);var at=q(je),mt=at||q(_e),gt=mt||q(Xe);return Ne==="="&&gt&&(Ne=""),at?Le=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&gt?(mt&&(_e=0),gt&&(Xe=0),Ne===">"?(Ne=">=",mt?(je=+je+1,_e=0,Xe=0):gt&&(_e=+_e+1,Xe=0)):Ne==="<="&&(Ne="<",mt?je=+je+1:_e=+_e+1),Le=Ne+je+"."+_e+"."+Xe):mt?Le=">="+je+".0.0 <"+(+je+1)+".0.0":gt&&(Le=">="+je+"."+_e+".0 <"+je+"."+(+_e+1)+".0"),c("xRange return",Le),Le})}(it,Be)}).join(" ")}(Qe,tt),c("xrange",Qe),Qe=function(rt,Be){return c("replaceStars",rt,Be),rt.trim().replace(T[ee],"")}(Qe,tt),c("stars",Qe),Qe}(nt,Ie)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(nt){return!!nt.match(He)})),qe=qe.map(function(nt){return new se(nt,Ie)})},$.prototype.intersects=function(ve,Ie){if(!(ve instanceof $))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(He){return ve.set.some(function(qe){return qe.every(function(nt){return He.intersects(nt,Ie)})})})})},e.toComparators=function(ve,Ie){return new $(ve,Ie).set.map(function(ke){return ke.map(function(He){return He.value}).join(" ").trim().split(" ")})},$.prototype.test=function(ve){if(!ve)return!1;typeof ve=="string"&&(ve=new oe(ve,this.loose));for(var Ie=0;Ie<this.set.length;Ie++)if(ue(this.set[Ie],ve))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(ve,Ie,ke){var He=null,qe=null;try{var nt=new $(Ie,ke)}catch{return null}return ve.forEach(function(Qe){nt.test(Qe)&&(He&&qe.compare(Qe)!==-1||(qe=new oe(He=Qe,ke)))}),He},e.minSatisfying=function(ve,Ie,ke){var He=null,qe=null;try{var nt=new $(Ie,ke)}catch{return null}return ve.forEach(function(Qe){nt.test(Qe)&&(He&&qe.compare(Qe)!==1||(qe=new oe(He=Qe,ke)))}),He},e.validRange=function(ve,Ie){try{return new $(ve,Ie).range||"*"}catch{return null}},e.ltr=function(ve,Ie,ke){return Ae(ve,Ie,"<",ke)},e.gtr=function(ve,Ie,ke){return Ae(ve,Ie,">",ke)},e.outside=Ae,e.prerelease=function(ve,Ie){var ke=ce(ve,Ie);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(ve,Ie,ke){return ve=new $(ve,ke),Ie=new $(Ie,ke),ve.intersects(Ie)},e.coerce=function(ve){if(ve instanceof oe)return ve;if(typeof ve!="string")return null;var Ie=ve.match(T[v]);return Ie==null?null:ce((Ie[1]||"0")+"."+(Ie[2]||"0")+"."+(Ie[3]||"0"))}}).call(this,a(1))},function(ie,e){var a,R,c=ie.exports={};function L(){throw new Error("setTimeout has not been defined")}function E(){throw new Error("clearTimeout has not been defined")}function T(o){if(a===setTimeout)return setTimeout(o,0);if((a===L||!a)&&setTimeout)return a=setTimeout,setTimeout(o,0);try{return a(o,0)}catch{try{return a.call(null,o,0)}catch{return a.call(this,o,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:L}catch{a=L}try{R=typeof clearTimeout=="function"?clearTimeout:E}catch{R=E}})();var S,I=[],N=!1,A=-1;function D(){N&&S&&(N=!1,S.length?I=S.concat(I):A=-1,I.length&&k())}function k(){if(!N){var o=T(D);N=!0;for(var d=I.length;d;){for(S=I,I=[];++A<d;)S&&S[A].run();A=-1,d=I.length}S=null,N=!1,function(f){if(R===clearTimeout)return clearTimeout(f);if((R===E||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(f);try{R(f)}catch{try{return R.call(null,f)}catch{return R.call(this,f)}}}(o)}}function C(o,d){this.fun=o,this.array=d}function m(){}c.nextTick=function(o){var d=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)d[f-1]=arguments[f];I.push(new C(o,d)),I.length!==1||N||T(k)},C.prototype.run=function(){this.fun.apply(null,this.array)},c.title="browser",c.browser=!0,c.env={},c.argv=[],c.version="",c.versions={},c.on=m,c.addListener=m,c.once=m,c.off=m,c.removeListener=m,c.removeAllListeners=m,c.emit=m,c.prependListener=m,c.prependOnceListener=m,c.listeners=function(o){return[]},c.binding=function(o){throw new Error("process.binding is not supported")},c.cwd=function(){return"/"},c.chdir=function(o){throw new Error("process.chdir is not supported")},c.umask=function(){return 0}}])}),define(De[103],Ce([1,0,10,6]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function c(y){const g=y;return g?typeof g.read=="function":!1}e.isReadable=c;function L(y){const g=y;return g?[g.on,g.pause,g.resume,g.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=L;function E(y){const g=y;return g?L(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=E;function T(y,g){return new S(y,g)}e.newWriteableStream=T;class S{constructor(g,t){this.e=g,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(t=>t(g))}h(g){this.c.error.length===0?(0,a.onUnexpectedError)(g):this.c.error.slice(0).forEach(t=>t(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,t){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(g,t){if(this.a.destroyed)return;let s;switch(g){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const r=s.indexOf(t);r>=0&&s.splice(r,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function I(y,g){const t=[];let s;for(;(s=y.read())!==null;)t.push(s);return g(t)}e.consumeReadable=I;function N(y,g,t){const s=[];let r;for(;(r=y.read())!==null&&s.length<t;)s.push(r);return r===null&&s.length>0?g(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const l=r;return r=void 0,l}return y.read()}}}e.peekReadable=N;function A(y,g){return new Promise((t,s)=>{const r=[];D(y,{onData:l=>{g&&r.push(l)},onError:l=>{g?s(l):t(void 0)},onEnd:()=>{t(g?g(r):void 0)}})})}e.consumeStream=A;function D(y,g){let t=!1;return y.on("error",s=>{t||g.onError(s)}),y.on("end",()=>{t||g.onEnd()}),y.on("data",s=>{t||g.onData(s)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=D;function k(y,g){return new Promise((t,s)=>{const r=new R.DisposableStore,l=[],u=n=>{if(l.push(n),l.length>g)return r.dispose(),y.pause(),t({stream:y,buffer:l,ended:!1})},b=n=>s(n),i=()=>t({stream:y,buffer:l,ended:!0});r.add((0,R.toDisposable)(()=>y.removeListener("error",b))),y.on("error",b),r.add((0,R.toDisposable)(()=>y.removeListener("end",i))),y.on("end",i),r.add((0,R.toDisposable)(()=>y.removeListener("data",u))),y.on("data",u)})}e.peekStream=k;function C(y,g){const t=T(g);return t.end(y),t}e.toStream=C;function m(){const y=T(()=>{throw new Error("not supported")});return y.end(),y}e.emptyStream=m;function o(y){let g=!1;return{read:()=>g?null:(g=!0,y)}}e.toReadable=o;function d(y,g,t){const s=T(t);return D(y,{onData:r=>s.write(g.data(r)),onError:r=>s.error(g.error?g.error(r):r),onEnd:()=>s.end()}),s}e.transform=d;function f(y,g,t){let s=!1;return{read:()=>{const r=g.read();return s?r:(s=!0,r!==null?t([y,r]):y)}}}e.prefixedReadable=f;function p(y,g,t){let s=!1;const r=T(t);return D(g,{onData:l=>s?r.write(l):(s=!0,r.write(t([y,l]))),onError:l=>r.error(l),onEnd:()=>{s||(s=!0,r.write(y)),r.end()}}),r}e.prefixedStream=p}),define(De[22],Ce([1,0,103]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let c,L;class E{static alloc(n){return R?new E(Buffer.allocUnsafe(n)):new E(new Uint8Array(n))}static wrap(n){return R&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new E(n)}static fromString(n,h){return!(h?.dontUseNodeBuffer||!1)&&R?new E(Buffer.from(n)):(c||(c=new TextEncoder),new E(c.encode(n)))}static fromByteArray(n){const h=E.alloc(n.length);for(let w=0,v=n.length;w<v;w++)h.buffer[w]=n[w];return h}static concat(n,h){if(typeof h>"u"){h=0;for(let O=0,j=n.length;O<j;O++)h+=n[O].byteLength}const w=E.alloc(h);let v=0;for(let O=0,j=n.length;O<j;O++){const V=n[O];w.set(V,v),v+=V.byteLength}return w}constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}clone(){const n=E.alloc(this.byteLength);return n.set(this),n}toString(){return R?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(n,h){return new E(this.buffer.subarray(n,h))}set(n,h){if(n instanceof E)this.buffer.set(n.buffer,h);else if(n instanceof Uint8Array)this.buffer.set(n,h);else if(n instanceof ArrayBuffer)this.buffer.set(new Uint8Array(n),h);else if(ArrayBuffer.isView(n))this.buffer.set(new Uint8Array(n.buffer,n.byteOffset,n.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(n){return I(this.buffer,n)}writeUInt32BE(n,h){N(this.buffer,n,h)}readUInt32LE(n){return A(this.buffer,n)}writeUInt32LE(n,h){D(this.buffer,n,h)}readUInt8(n){return k(this.buffer,n)}writeUInt8(n,h){C(this.buffer,n,h)}}e.VSBuffer=E;function T(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0}e.readUInt16LE=T;function S(i,n,h){i[h+0]=n&255,n=n>>>8,i[h+1]=n&255}e.writeUInt16LE=S;function I(i,n){return i[n]*2**24+i[n+1]*2**16+i[n+2]*2**8+i[n+3]}e.readUInt32BE=I;function N(i,n,h){i[h+3]=n,n=n>>>8,i[h+2]=n,n=n>>>8,i[h+1]=n,n=n>>>8,i[h]=n}e.writeUInt32BE=N;function A(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0|i[n+2]<<16>>>0|i[n+3]<<24>>>0}e.readUInt32LE=A;function D(i,n,h){i[h+0]=n&255,n=n>>>8,i[h+1]=n&255,n=n>>>8,i[h+2]=n&255,n=n>>>8,i[h+3]=n&255}e.writeUInt32LE=D;function k(i,n){return i[n]}e.readUInt8=k;function C(i,n,h){i[h]=n}e.writeUInt8=C;function m(i){return a.consumeReadable(i,n=>E.concat(n))}e.readableToBuffer=m;function o(i){return a.toReadable(i)}e.bufferToReadable=o;function d(i){return a.consumeStream(i,n=>E.concat(n))}e.streamToBuffer=d;async function f(i){return i.ended?E.concat(i.buffer):E.concat([...i.buffer,await d(i.stream)])}e.bufferedStreamToBuffer=f;function p(i){return a.toStream(i,n=>E.concat(n))}e.bufferToStream=p;function y(i){return a.transform(i,{data:n=>typeof n=="string"?E.fromString(n):E.wrap(n)},n=>E.concat(n))}e.streamToBufferReadableStream=y;function g(i){return a.newWriteableStream(n=>E.concat(n),i)}e.newWriteableBufferStream=g;function t(i,n){return a.prefixedReadable(i,n,h=>E.concat(h))}e.prefixedBufferReadable=t;function s(i,n){return a.prefixedStream(i,n,h=>E.concat(h))}e.prefixedBufferStream=s;function r(i){let n=0,h=0,w=0;const v=new Uint8Array(Math.floor(i.length/4*3)),O=V=>{switch(h){case 3:v[w++]=n|V,h=0;break;case 2:v[w++]=n|V>>>2,n=V<<6,h=3;break;case 1:v[w++]=n|V>>>4,n=V<<4,h=2;break;default:n=V<<2,h=1}};for(let V=0;V<i.length;V++){const Q=i.charCodeAt(V);if(Q>=65&&Q<=90)O(Q-65);else if(Q>=97&&Q<=122)O(Q-97+26);else if(Q>=48&&Q<=57)O(Q-48+52);else if(Q===43||Q===45)O(62);else if(Q===47||Q===95)O(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${i[V]}`)}}const j=w;for(;h>0;)O(0);return E.wrap(v).slice(0,j)}e.decodeBase64=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:i},n=!0,h=!1){const w=h?u:l;let v="";const O=i.byteLength%3;let j=0;for(;j<i.byteLength-O;j+=3){const V=i[j+0],Q=i[j+1],G=i[j+2];v+=w[V>>>2],v+=w[(V<<4|Q>>>4)&63],v+=w[(Q<<2|G>>>6)&63],v+=w[G&63]}if(O===1){const V=i[j+0];v+=w[V>>>2],v+=w[V<<4&63],n&&(v+="==")}else if(O===2){const V=i[j+0],Q=i[j+1];v+=w[V>>>2],v+=w[(V<<4|Q>>>4)&63],v+=w[Q<<2&63],n&&(v+="=")}return v}e.encodeBase64=b}),define(De[149],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(De[9],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(s){return typeof s=="string"}e.isString=a;function R(s){return Array.isArray(s)&&s.every(r=>a(r))}e.isStringArray=R;function c(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=c;function L(s){const r=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof r}e.isTypedArray=L;function E(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=E;function T(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=T;function S(s){return s===!0||s===!1}e.isBoolean=S;function I(s){return typeof s>"u"}e.isUndefined=I;function N(s){return!A(s)}e.isDefined=N;function A(s){return I(s)||s===null}e.isUndefinedOrNull=A;function D(s,r){if(!s)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=D;function k(s){if(A(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=k;function C(...s){const r=[];for(let l=0;l<s.length;l++){const u=s[l];if(A(u))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);r.push(u)}return r}e.assertAllDefined=C;const m=Object.prototype.hasOwnProperty;function o(s){if(!c(s))return!1;for(const r in s)if(m.call(s,r))return!1;return!0}e.isEmptyObject=o;function d(s){return typeof s=="function"}e.isFunction=d;function f(...s){return s.length>0&&s.every(d)}e.areFunctions=f;function p(s,r){const l=Math.min(s.length,r.length);for(let u=0;u<l;u++)y(s[u],r[u])}e.validateConstraints=p;function y(s,r){if(a(r)){if(typeof s!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(d(r)){try{if(s instanceof r)return}catch{}if(!A(s)&&s.constructor===r||r.length===1&&r.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=y;function g(s){return s===null?void 0:s}e.withNullAsUndefined=g;function t(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=t}),define(De[67],Ce([1,0,9]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const R=Object.create(null);function c(T,S){if((0,a.isString)(S)){const I=R[S];if(I===void 0)throw new Error(`${T} references an unknown codicon: ${S}`);S=I}return R[T]=S,{id:T}}function L(){return R}e.getCodiconFontCharacters=L;function E(){return Object.values(e.Codicon)}e.getAllCodicons=E,e.Codicon={add:c("add",6e4),plus:c("plus",6e4),gistNew:c("gist-new",6e4),repoCreate:c("repo-create",6e4),lightbulb:c("lightbulb",60001),lightBulb:c("light-bulb",60001),repo:c("repo",60002),repoDelete:c("repo-delete",60002),gistFork:c("gist-fork",60003),repoForked:c("repo-forked",60003),gitPullRequest:c("git-pull-request",60004),gitPullRequestAbandoned:c("git-pull-request-abandoned",60004),recordKeys:c("record-keys",60005),keyboard:c("keyboard",60005),tag:c("tag",60006),tagAdd:c("tag-add",60006),tagRemove:c("tag-remove",60006),person:c("person",60007),personFollow:c("person-follow",60007),personOutline:c("person-outline",60007),personFilled:c("person-filled",60007),gitBranch:c("git-branch",60008),gitBranchCreate:c("git-branch-create",60008),gitBranchDelete:c("git-branch-delete",60008),sourceControl:c("source-control",60008),mirror:c("mirror",60009),mirrorPublic:c("mirror-public",60009),star:c("star",60010),starAdd:c("star-add",60010),starDelete:c("star-delete",60010),starEmpty:c("star-empty",60010),comment:c("comment",60011),commentAdd:c("comment-add",60011),alert:c("alert",60012),warning:c("warning",60012),search:c("search",60013),searchSave:c("search-save",60013),logOut:c("log-out",60014),signOut:c("sign-out",60014),logIn:c("log-in",60015),signIn:c("sign-in",60015),eye:c("eye",60016),eyeUnwatch:c("eye-unwatch",60016),eyeWatch:c("eye-watch",60016),circleFilled:c("circle-filled",60017),primitiveDot:c("primitive-dot",60017),closeDirty:c("close-dirty",60017),debugBreakpoint:c("debug-breakpoint",60017),debugBreakpointDisabled:c("debug-breakpoint-disabled",60017),debugHint:c("debug-hint",60017),primitiveSquare:c("primitive-square",60018),edit:c("edit",60019),pencil:c("pencil",60019),info:c("info",60020),issueOpened:c("issue-opened",60020),gistPrivate:c("gist-private",60021),gitForkPrivate:c("git-fork-private",60021),lock:c("lock",60021),mirrorPrivate:c("mirror-private",60021),close:c("close",60022),removeClose:c("remove-close",60022),x:c("x",60022),repoSync:c("repo-sync",60023),sync:c("sync",60023),clone:c("clone",60024),desktopDownload:c("desktop-download",60024),beaker:c("beaker",60025),microscope:c("microscope",60025),vm:c("vm",60026),deviceDesktop:c("device-desktop",60026),file:c("file",60027),fileText:c("file-text",60027),more:c("more",60028),ellipsis:c("ellipsis",60028),kebabHorizontal:c("kebab-horizontal",60028),mailReply:c("mail-reply",60029),reply:c("reply",60029),organization:c("organization",60030),organizationFilled:c("organization-filled",60030),organizationOutline:c("organization-outline",60030),newFile:c("new-file",60031),fileAdd:c("file-add",60031),newFolder:c("new-folder",60032),fileDirectoryCreate:c("file-directory-create",60032),trash:c("trash",60033),trashcan:c("trashcan",60033),history:c("history",60034),clock:c("clock",60034),folder:c("folder",60035),fileDirectory:c("file-directory",60035),symbolFolder:c("symbol-folder",60035),logoGithub:c("logo-github",60036),markGithub:c("mark-github",60036),github:c("github",60036),terminal:c("terminal",60037),console:c("console",60037),repl:c("repl",60037),zap:c("zap",60038),symbolEvent:c("symbol-event",60038),error:c("error",60039),stop:c("stop",60039),variable:c("variable",60040),symbolVariable:c("symbol-variable",60040),array:c("array",60042),symbolArray:c("symbol-array",60042),symbolModule:c("symbol-module",60043),symbolPackage:c("symbol-package",60043),symbolNamespace:c("symbol-namespace",60043),symbolObject:c("symbol-object",60043),symbolMethod:c("symbol-method",60044),symbolFunction:c("symbol-function",60044),symbolConstructor:c("symbol-constructor",60044),symbolBoolean:c("symbol-boolean",60047),symbolNull:c("symbol-null",60047),symbolNumeric:c("symbol-numeric",60048),symbolNumber:c("symbol-number",60048),symbolStructure:c("symbol-structure",60049),symbolStruct:c("symbol-struct",60049),symbolParameter:c("symbol-parameter",60050),symbolTypeParameter:c("symbol-type-parameter",60050),symbolKey:c("symbol-key",60051),symbolText:c("symbol-text",60051),symbolReference:c("symbol-reference",60052),goToFile:c("go-to-file",60052),symbolEnum:c("symbol-enum",60053),symbolValue:c("symbol-value",60053),symbolRuler:c("symbol-ruler",60054),symbolUnit:c("symbol-unit",60054),activateBreakpoints:c("activate-breakpoints",60055),archive:c("archive",60056),arrowBoth:c("arrow-both",60057),arrowDown:c("arrow-down",60058),arrowLeft:c("arrow-left",60059),arrowRight:c("arrow-right",60060),arrowSmallDown:c("arrow-small-down",60061),arrowSmallLeft:c("arrow-small-left",60062),arrowSmallRight:c("arrow-small-right",60063),arrowSmallUp:c("arrow-small-up",60064),arrowUp:c("arrow-up",60065),bell:c("bell",60066),bold:c("bold",60067),book:c("book",60068),bookmark:c("bookmark",60069),debugBreakpointConditionalUnverified:c("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:c("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:c("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:c("debug-breakpoint-data-unverified",60072),debugBreakpointData:c("debug-breakpoint-data",60073),debugBreakpointDataDisabled:c("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:c("debug-breakpoint-log-unverified",60074),debugBreakpointLog:c("debug-breakpoint-log",60075),debugBreakpointLogDisabled:c("debug-breakpoint-log-disabled",60075),briefcase:c("briefcase",60076),broadcast:c("broadcast",60077),browser:c("browser",60078),bug:c("bug",60079),calendar:c("calendar",60080),caseSensitive:c("case-sensitive",60081),check:c("check",60082),checklist:c("checklist",60083),chevronDown:c("chevron-down",60084),dropDownButton:c("drop-down-button",60084),chevronLeft:c("chevron-left",60085),chevronRight:c("chevron-right",60086),chevronUp:c("chevron-up",60087),chromeClose:c("chrome-close",60088),chromeMaximize:c("chrome-maximize",60089),chromeMinimize:c("chrome-minimize",60090),chromeRestore:c("chrome-restore",60091),circle:c("circle",60092),circleOutline:c("circle-outline",60092),debugBreakpointUnverified:c("debug-breakpoint-unverified",60092),circleSlash:c("circle-slash",60093),circuitBoard:c("circuit-board",60094),clearAll:c("clear-all",60095),clippy:c("clippy",60096),closeAll:c("close-all",60097),cloudDownload:c("cloud-download",60098),cloudUpload:c("cloud-upload",60099),code:c("code",60100),collapseAll:c("collapse-all",60101),colorMode:c("color-mode",60102),commentDiscussion:c("comment-discussion",60103),compareChanges:c("compare-changes",60157),creditCard:c("credit-card",60105),dash:c("dash",60108),dashboard:c("dashboard",60109),database:c("database",60110),debugContinue:c("debug-continue",60111),debugDisconnect:c("debug-disconnect",60112),debugPause:c("debug-pause",60113),debugRestart:c("debug-restart",60114),debugStart:c("debug-start",60115),debugStepInto:c("debug-step-into",60116),debugStepOut:c("debug-step-out",60117),debugStepOver:c("debug-step-over",60118),debugStop:c("debug-stop",60119),debug:c("debug",60120),deviceCameraVideo:c("device-camera-video",60121),deviceCamera:c("device-camera",60122),deviceMobile:c("device-mobile",60123),diffAdded:c("diff-added",60124),diffIgnored:c("diff-ignored",60125),diffModified:c("diff-modified",60126),diffRemoved:c("diff-removed",60127),diffRenamed:c("diff-renamed",60128),diff:c("diff",60129),discard:c("discard",60130),editorLayout:c("editor-layout",60131),emptyWindow:c("empty-window",60132),exclude:c("exclude",60133),extensions:c("extensions",60134),eyeClosed:c("eye-closed",60135),fileBinary:c("file-binary",60136),fileCode:c("file-code",60137),fileMedia:c("file-media",60138),filePdf:c("file-pdf",60139),fileSubmodule:c("file-submodule",60140),fileSymlinkDirectory:c("file-symlink-directory",60141),fileSymlinkFile:c("file-symlink-file",60142),fileZip:c("file-zip",60143),files:c("files",60144),filter:c("filter",60145),flame:c("flame",60146),foldDown:c("fold-down",60147),foldUp:c("fold-up",60148),fold:c("fold",60149),folderActive:c("folder-active",60150),folderOpened:c("folder-opened",60151),gear:c("gear",60152),gift:c("gift",60153),gistSecret:c("gist-secret",60154),gist:c("gist",60155),gitCommit:c("git-commit",60156),gitCompare:c("git-compare",60157),gitMerge:c("git-merge",60158),githubAction:c("github-action",60159),githubAlt:c("github-alt",60160),globe:c("globe",60161),grabber:c("grabber",60162),graph:c("graph",60163),gripper:c("gripper",60164),heart:c("heart",60165),home:c("home",60166),horizontalRule:c("horizontal-rule",60167),hubot:c("hubot",60168),inbox:c("inbox",60169),issueClosed:c("issue-closed",60324),issueReopened:c("issue-reopened",60171),issues:c("issues",60172),italic:c("italic",60173),jersey:c("jersey",60174),json:c("json",60175),bracket:c("bracket",60175),kebabVertical:c("kebab-vertical",60176),key:c("key",60177),law:c("law",60178),lightbulbAutofix:c("lightbulb-autofix",60179),linkExternal:c("link-external",60180),link:c("link",60181),listOrdered:c("list-ordered",60182),listUnordered:c("list-unordered",60183),liveShare:c("live-share",60184),loading:c("loading",60185),location:c("location",60186),mailRead:c("mail-read",60187),mail:c("mail",60188),markdown:c("markdown",60189),megaphone:c("megaphone",60190),mention:c("mention",60191),milestone:c("milestone",60192),mortarBoard:c("mortar-board",60193),move:c("move",60194),multipleWindows:c("multiple-windows",60195),mute:c("mute",60196),noNewline:c("no-newline",60197),note:c("note",60198),octoface:c("octoface",60199),openPreview:c("open-preview",60200),package_:c("package",60201),paintcan:c("paintcan",60202),pin:c("pin",60203),play:c("play",60204),run:c("run",60204),plug:c("plug",60205),preserveCase:c("preserve-case",60206),preview:c("preview",60207),project:c("project",60208),pulse:c("pulse",60209),question:c("question",60210),quote:c("quote",60211),radioTower:c("radio-tower",60212),reactions:c("reactions",60213),references:c("references",60214),refresh:c("refresh",60215),regex:c("regex",60216),remoteExplorer:c("remote-explorer",60217),remote:c("remote",60218),remove:c("remove",60219),replaceAll:c("replace-all",60220),replace:c("replace",60221),repoClone:c("repo-clone",60222),repoForcePush:c("repo-force-push",60223),repoPull:c("repo-pull",60224),repoPush:c("repo-push",60225),report:c("report",60226),requestChanges:c("request-changes",60227),rocket:c("rocket",60228),rootFolderOpened:c("root-folder-opened",60229),rootFolder:c("root-folder",60230),rss:c("rss",60231),ruby:c("ruby",60232),saveAll:c("save-all",60233),saveAs:c("save-as",60234),save:c("save",60235),screenFull:c("screen-full",60236),screenNormal:c("screen-normal",60237),searchStop:c("search-stop",60238),server:c("server",60240),settingsGear:c("settings-gear",60241),settings:c("settings",60242),shield:c("shield",60243),smiley:c("smiley",60244),sortPrecedence:c("sort-precedence",60245),splitHorizontal:c("split-horizontal",60246),splitVertical:c("split-vertical",60247),squirrel:c("squirrel",60248),starFull:c("star-full",60249),starHalf:c("star-half",60250),symbolClass:c("symbol-class",60251),symbolColor:c("symbol-color",60252),symbolCustomColor:c("symbol-customcolor",60252),symbolConstant:c("symbol-constant",60253),symbolEnumMember:c("symbol-enum-member",60254),symbolField:c("symbol-field",60255),symbolFile:c("symbol-file",60256),symbolInterface:c("symbol-interface",60257),symbolKeyword:c("symbol-keyword",60258),symbolMisc:c("symbol-misc",60259),symbolOperator:c("symbol-operator",60260),symbolProperty:c("symbol-property",60261),wrench:c("wrench",60261),wrenchSubaction:c("wrench-subaction",60261),symbolSnippet:c("symbol-snippet",60262),tasklist:c("tasklist",60263),telescope:c("telescope",60264),textSize:c("text-size",60265),threeBars:c("three-bars",60266),thumbsdown:c("thumbsdown",60267),thumbsup:c("thumbsup",60268),tools:c("tools",60269),triangleDown:c("triangle-down",60270),triangleLeft:c("triangle-left",60271),triangleRight:c("triangle-right",60272),triangleUp:c("triangle-up",60273),twitter:c("twitter",60274),unfold:c("unfold",60275),unlock:c("unlock",60276),unmute:c("unmute",60277),unverified:c("unverified",60278),verified:c("verified",60279),versions:c("versions",60280),vmActive:c("vm-active",60281),vmOutline:c("vm-outline",60282),vmRunning:c("vm-running",60283),watch:c("watch",60284),whitespace:c("whitespace",60285),wholeWord:c("whole-word",60286),window:c("window",60287),wordWrap:c("word-wrap",60288),zoomIn:c("zoom-in",60289),zoomOut:c("zoom-out",60290),listFilter:c("list-filter",60291),listFlat:c("list-flat",60292),listSelection:c("list-selection",60293),selection:c("selection",60293),listTree:c("list-tree",60294),debugBreakpointFunctionUnverified:c("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:c("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:c("debug-breakpoint-function-disabled",60296),debugStackframeActive:c("debug-stackframe-active",60297),circleSmallFilled:c("circle-small-filled",60298),debugStackframeDot:c("debug-stackframe-dot",60298),debugStackframe:c("debug-stackframe",60299),debugStackframeFocused:c("debug-stackframe-focused",60299),debugBreakpointUnsupported:c("debug-breakpoint-unsupported",60300),symbolString:c("symbol-string",60301),debugReverseContinue:c("debug-reverse-continue",60302),debugStepBack:c("debug-step-back",60303),debugRestartFrame:c("debug-restart-frame",60304),callIncoming:c("call-incoming",60306),callOutgoing:c("call-outgoing",60307),menu:c("menu",60308),expandAll:c("expand-all",60309),feedback:c("feedback",60310),groupByRefType:c("group-by-ref-type",60311),ungroupByRefType:c("ungroup-by-ref-type",60312),account:c("account",60313),bellDot:c("bell-dot",60314),debugConsole:c("debug-console",60315),library:c("library",60316),output:c("output",60317),runAll:c("run-all",60318),syncIgnored:c("sync-ignored",60319),pinned:c("pinned",60320),githubInverted:c("github-inverted",60321),debugAlt:c("debug-alt",60305),serverProcess:c("server-process",60322),serverEnvironment:c("server-environment",60323),pass:c("pass",60324),stopCircle:c("stop-circle",60325),playCircle:c("play-circle",60326),record:c("record",60327),debugAltSmall:c("debug-alt-small",60328),vmConnect:c("vm-connect",60329),cloud:c("cloud",60330),merge:c("merge",60331),exportIcon:c("export",60332),graphLeft:c("graph-left",60333),magnet:c("magnet",60334),notebook:c("notebook",60335),redo:c("redo",60336),checkAll:c("check-all",60337),pinnedDirty:c("pinned-dirty",60338),passFilled:c("pass-filled",60339),circleLargeFilled:c("circle-large-filled",60340),circleLarge:c("circle-large",60341),circleLargeOutline:c("circle-large-outline",60341),combine:c("combine",60342),gather:c("gather",60342),table:c("table",60343),variableGroup:c("variable-group",60344),typeHierarchy:c("type-hierarchy",60345),typeHierarchySub:c("type-hierarchy-sub",60346),typeHierarchySuper:c("type-hierarchy-super",60347),gitPullRequestCreate:c("git-pull-request-create",60348),runAbove:c("run-above",60349),runBelow:c("run-below",60350),notebookTemplate:c("notebook-template",60351),debugRerun:c("debug-rerun",60352),workspaceTrusted:c("workspace-trusted",60353),workspaceUntrusted:c("workspace-untrusted",60354),workspaceUnspecified:c("workspace-unspecified",60355),terminalCmd:c("terminal-cmd",60356),terminalDebian:c("terminal-debian",60357),terminalLinux:c("terminal-linux",60358),terminalPowershell:c("terminal-powershell",60359),terminalTmux:c("terminal-tmux",60360),terminalUbuntu:c("terminal-ubuntu",60361),terminalBash:c("terminal-bash",60362),arrowSwap:c("arrow-swap",60363),copy:c("copy",60364),personAdd:c("person-add",60365),filterFilled:c("filter-filled",60366),wand:c("wand",60367),debugLineByLine:c("debug-line-by-line",60368),inspect:c("inspect",60369),layers:c("layers",60370),layersDot:c("layers-dot",60371),layersActive:c("layers-active",60372),compass:c("compass",60373),compassDot:c("compass-dot",60374),compassActive:c("compass-active",60375),azure:c("azure",60376),issueDraft:c("issue-draft",60377),gitPullRequestClosed:c("git-pull-request-closed",60378),gitPullRequestDraft:c("git-pull-request-draft",60379),debugAll:c("debug-all",60380),debugCoverage:c("debug-coverage",60381),runErrors:c("run-errors",60382),folderLibrary:c("folder-library",60383),debugContinueSmall:c("debug-continue-small",60384),beakerStop:c("beaker-stop",60385),graphLine:c("graph-line",60386),graphScatter:c("graph-scatter",60387),pieChart:c("pie-chart",60388),bracketDot:c("bracket-dot",60389),bracketError:c("bracket-error",60390),lockSmall:c("lock-small",60391),azureDevops:c("azure-devops",60392),verifiedFilled:c("verified-filled",60393),newLine:c("newline",60394),layout:c("layout",60395),layoutActivitybarLeft:c("layout-activitybar-left",60396),layoutActivitybarRight:c("layout-activitybar-right",60397),layoutPanelLeft:c("layout-panel-left",60398),layoutPanelCenter:c("layout-panel-center",60399),layoutPanelJustify:c("layout-panel-justify",60400),layoutPanelRight:c("layout-panel-right",60401),layoutPanel:c("layout-panel",60402),layoutSidebarLeft:c("layout-sidebar-left",60403),layoutSidebarRight:c("layout-sidebar-right",60404),layoutStatusbar:c("layout-statusbar",60405),layoutMenubar:c("layout-menubar",60406),layoutCentered:c("layout-centered",60407),layoutSidebarRightOff:c("layout-sidebar-right-off",60416),layoutPanelOff:c("layout-panel-off",60417),layoutSidebarLeftOff:c("layout-sidebar-left-off",60418),target:c("target",60408),indent:c("indent",60409),recordSmall:c("record-small",60410),errorSmall:c("error-small",60411),arrowCircleDown:c("arrow-circle-down",60412),arrowCircleLeft:c("arrow-circle-left",60413),arrowCircleRight:c("arrow-circle-right",60414),arrowCircleUp:c("arrow-circle-up",60415),heartFilled:c("heart-filled",60420),map:c("map",60421),mapFilled:c("map-filled",60422),circleSmall:c("circle-small",60423),bellSlash:c("bell-slash",60424),bellSlashDot:c("bell-slash-dot",60425),commentUnresolved:c("comment-unresolved",60426),gitPullRequestGoToChanges:c("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:c("git-pull-request-new-changes",60428),searchFuzzy:c("search-fuzzy",60429),commentDraft:c("comment-draft",60430),dialogError:c("dialog-error","error"),dialogWarning:c("dialog-warning","warning"),dialogInfo:c("dialog-info","info"),dialogClose:c("dialog-close","close"),treeItemExpanded:c("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:c("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:c("tree-filter-on-type-off","list-selection"),treeFilterClear:c("tree-filter-clear","close"),treeItemLoading:c("tree-item-loading","loading"),menuSelection:c("menu-selection","check"),menuSubmenu:c("menu-submenu","chevron-right"),menuBarMore:c("menubar-more","more"),scrollbarButtonLeft:c("scrollbar-button-left","triangle-left"),scrollbarButtonRight:c("scrollbar-button-right","triangle-right"),scrollbarButtonUp:c("scrollbar-button-up","triangle-up"),scrollbarButtonDown:c("scrollbar-button-down","triangle-down"),toolBarMore:c("toolbar-more","more"),quickInputBack:c("quick-input-back","arrow-left")}}),define(De[23],Ce([1,0,9]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const f=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([p,y])=>{f[p]=y&&typeof y=="object"?R(y):y}),f}e.deepClone=R;function c(d){if(!d||typeof d!="object")return d;const f=[d];for(;f.length>0;){const p=f.shift();Object.freeze(p);for(const y in p)if(L.call(p,y)){const g=p[y];typeof g=="object"&&!Object.isFrozen(g)&&!(0,a.isTypedArray)(g)&&f.push(g)}}return d}e.deepFreeze=c;const L=Object.prototype.hasOwnProperty;function E(d,f){return T(d,f,new Set)}e.cloneAndChange=E;function T(d,f,p){if((0,a.isUndefinedOrNull)(d))return d;const y=f(d);if(typeof y<"u")return y;if(Array.isArray(d)){const g=[];for(const t of d)g.push(T(t,f,p));return g}if((0,a.isObject)(d)){if(p.has(d))throw new Error("Cannot clone recursive data-structure");p.add(d);const g={};for(const t in d)L.call(d,t)&&(g[t]=T(d[t],f,p));return p.delete(d),g}return d}function S(d,f,p=!0){return(0,a.isObject)(d)?((0,a.isObject)(f)&&Object.keys(f).forEach(y=>{y in d?p&&((0,a.isObject)(d[y])&&(0,a.isObject)(f[y])?S(d[y],f[y],p):d[y]=f[y]):d[y]=f[y]}),d):f}e.mixin=S;function I(d,f){if(d===f)return!0;if(d==null||f===null||f===void 0||typeof d!=typeof f||typeof d!="object"||Array.isArray(d)!==Array.isArray(f))return!1;let p,y;if(Array.isArray(d)){if(d.length!==f.length)return!1;for(p=0;p<d.length;p++)if(!I(d[p],f[p]))return!1}else{const g=[];for(y in d)g.push(y);g.sort();const t=[];for(y in f)t.push(y);if(t.sort(),!I(g,t))return!1;for(p=0;p<g.length;p++)if(!I(d[g[p]],f[g[p]]))return!1}return!0}e.equals=I;function N(d){const f=new Set;return JSON.stringify(d,(p,y)=>{if((0,a.isObject)(y)||Array.isArray(y)){if(f.has(y))return"[Circular]";f.add(y)}return y})}e.safeStringify=N;function A(d,f){const p=Object.create(null);return!d||!f||Object.keys(f).forEach(g=>{const t=d[g],s=f[g];I(t,s)||(p[g]=s)}),p}e.distinct=A;function D(d,f){const p=f.toLowerCase(),y=Object.keys(d).find(g=>g.toLowerCase()===p);return y?d[y]:d[f]}e.getCaseInsensitive=D;function k(d,f){const p=Object.create(null);for(const[y,g]of Object.entries(d))f(y,g)&&(p[y]=g);return p}e.filter=k;function C(d){let f=[],p=Object.getPrototypeOf(d);for(;Object.prototype!==p;)f=f.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return f}e.getAllPropertyNames=C;function m(d){const f=[];for(const p of C(d))typeof d[p]=="function"&&f.push(p);return f}e.getAllMethodNames=m;function o(d,f){const p=g=>function(){const t=Array.prototype.slice.call(arguments,0);return f(g,t)},y={};for(const g of d)y[g]=p(g);return y}e.createProxyObject=o}),define(De[52],Ce([1,0,67]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var R;(function(E){function T(S){return S&&typeof S=="object"&&typeof S.id=="string"}E.isThemeColor=T})(R=e.ThemeColor||(e.ThemeColor={}));function c(E){return{id:E}}e.themeColorFromId=c;var L;(function(E){E.iconNameSegment="[A-Za-z0-9]+",E.iconNameExpression="[A-Za-z0-9-]+",E.iconModifierExpression="~[A-Za-z]+",E.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${E.iconNameExpression})(${E.iconModifierExpression})?$`);function S(f){const p=T.exec(f.id);if(!p)return S(a.Codicon.error);const[,y,g]=p,t=["codicon","codicon-"+y];return g&&t.push("codicon-modifier-"+g.substring(1)),t}E.asClassNameArray=S;function I(f){return S(f).join(" ")}E.asClassName=I;function N(f){return"."+S(f).join(".")}E.asCSSSelector=N;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||R.isThemeColor(f.color))}E.isThemeIcon=A;const D=new RegExp(`^\\$\\((${E.iconNameExpression}(?:${E.iconModifierExpression})?)\\)$`);function k(f){const p=D.exec(f);if(!p)return;const[,y]=p;return{id:y}}E.fromString=k;function C(f){return{id:f}}E.fromId=C;function m(f,p){let y=f.id;const g=y.lastIndexOf("~");return g!==-1&&(y=y.substring(0,g)),p&&(y=`${y}~${p}`),{id:y}}E.modify=m;function o(f){const p=f.id.lastIndexOf("~");if(p!==-1)return f.id.substring(p+1)}E.getModifier=o;function d(f,p){return f.id===p.id&&f.color?.id===p.color?.id}E.isEqual=d})(L=e.ThemeIcon||(e.ThemeIcon={}))}),define(De[104],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function R(L){return L<0?0:L>255?255:L|0}e.toUint8=R;function c(L){return L<0?0:L>4294967295?4294967295:L|0}e.toUint32=c}),define(De[30],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(c){return a.test(c)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let c;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?c=crypto.getRandomValues.bind(crypto):c=function(T){for(let S=0;S<T.length;S++)T[S]=Math.floor(Math.random()*256);return T};const L=new Uint8Array(16),E=[];for(let T=0;T<256;T++)E.push(T.toString(16).padStart(2,"0"));return function(){c(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,I="";return I+=E[L[S++]],I+=E[L[S++]],I+=E[L[S++]],I+=E[L[S++]],I+="-",I+=E[L[S++]],I+=E[L[S++]],I+="-",I+=E[L[S++]],I+=E[L[S++]],I+="-",I+=E[L[S++]],I+=E[L[S++]],I+="-",I+=E[L[S++]],I+=E[L[S++]],I+=E[L[S++]],I+=E[L[S++]],I+=E[L[S++]],I+=E[L[S++]],I}}()}),define(De[150],Ce([1,0,15,30]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function c(T){return{id:(0,R.generateUuid)(),asString:async()=>T,asFile:()=>{},value:typeof T=="string"?T:void 0}}e.createStringDataTransferItem=c;function L(T,S,I){return{id:(0,R.generateUuid)(),asString:async()=>"",asFile:()=>({name:T,uri:S,data:I}),value:void 0}}e.createFileDataTransferItem=L;class E{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,I){const N=this.a.get(S);N?N.push(I):this.a.set(this.b(S),[I])}replace(S,I){this.a.set(this.b(S),[I])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,I]of this.a.entries())for(const N of I)yield[S,N]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[I,N]of this.entries())S(N,I)}b(S){return S.toLowerCase()}}e.VSDataTransfer=E,e.UriList=Object.freeze({create:T=>(0,a.distinct)(T.map(S=>S.toString())).join(`\r
`),split:T=>T.split(`\r
`),parse:T=>e.UriList.split(T).filter(S=>!S.startsWith("#"))})}),define(De[105],Ce([1,0,104]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(T){const S=(0,a.toUint8)(T);this.c=S,this.a=R.d(S),this.b=new Map}static d(T){const S=new Uint8Array(256);return S.fill(T),S}set(T,S){const I=(0,a.toUint8)(S);T>=0&&T<256?this.a[T]=I:this.b.set(T,I)}get(T){return T>=0&&T<256?this.a[T]:this.b.get(T)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=R;var c;(function(E){E[E.False=0]="False",E[E.True=1]="True"})(c||(c={}));class L{constructor(){this.a=new R(0)}add(T){this.a.set(T,1)}has(T){return this.a.get(T)===1}clear(){return this.a.clear()}}e.CharacterSet=L}),define(De[53],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(c,L){this.lineNumber=c,this.column=L}with(c=this.lineNumber,L=this.column){return c===this.lineNumber&&L===this.column?this:new a(c,L)}delta(c=0,L=0){return this.with(this.lineNumber+c,this.column+L)}equals(c){return a.equals(this,c)}static equals(c,L){return!c&&!L?!0:!!c&&!!L&&c.lineNumber===L.lineNumber&&c.column===L.column}isBefore(c){return a.isBefore(this,c)}static isBefore(c,L){return c.lineNumber<L.lineNumber?!0:L.lineNumber<c.lineNumber?!1:c.column<L.column}isBeforeOrEqual(c){return a.isBeforeOrEqual(this,c)}static isBeforeOrEqual(c,L){return c.lineNumber<L.lineNumber?!0:L.lineNumber<c.lineNumber?!1:c.column<=L.column}static compare(c,L){const E=c.lineNumber|0,T=L.lineNumber|0;if(E===T){const S=c.column|0,I=L.column|0;return S-I}return E-T}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(c){return new a(c.lineNumber,c.column)}static isIPosition(c){return c&&typeof c.lineNumber=="number"&&typeof c.column=="number"}}e.Position=a}),define(De[32],Ce([1,0,53]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(L,E,T,S){L>T||L===T&&E>S?(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=L,this.endColumn=E):(this.startLineNumber=L,this.startColumn=E,this.endLineNumber=T,this.endColumn=S)}isEmpty(){return R.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return R.containsPosition(this,L)}static containsPosition(L,E){return!(E.lineNumber<L.startLineNumber||E.lineNumber>L.endLineNumber||E.lineNumber===L.startLineNumber&&E.column<L.startColumn||E.lineNumber===L.endLineNumber&&E.column>L.endColumn)}static strictContainsPosition(L,E){return!(E.lineNumber<L.startLineNumber||E.lineNumber>L.endLineNumber||E.lineNumber===L.startLineNumber&&E.column<=L.startColumn||E.lineNumber===L.endLineNumber&&E.column>=L.endColumn)}containsRange(L){return R.containsRange(this,L)}static containsRange(L,E){return!(E.startLineNumber<L.startLineNumber||E.endLineNumber<L.startLineNumber||E.startLineNumber>L.endLineNumber||E.endLineNumber>L.endLineNumber||E.startLineNumber===L.startLineNumber&&E.startColumn<L.startColumn||E.endLineNumber===L.endLineNumber&&E.endColumn>L.endColumn)}strictContainsRange(L){return R.strictContainsRange(this,L)}static strictContainsRange(L,E){return!(E.startLineNumber<L.startLineNumber||E.endLineNumber<L.startLineNumber||E.startLineNumber>L.endLineNumber||E.endLineNumber>L.endLineNumber||E.startLineNumber===L.startLineNumber&&E.startColumn<=L.startColumn||E.endLineNumber===L.endLineNumber&&E.endColumn>=L.endColumn)}plusRange(L){return R.plusRange(this,L)}static plusRange(L,E){let T,S,I,N;return E.startLineNumber<L.startLineNumber?(T=E.startLineNumber,S=E.startColumn):E.startLineNumber===L.startLineNumber?(T=E.startLineNumber,S=Math.min(E.startColumn,L.startColumn)):(T=L.startLineNumber,S=L.startColumn),E.endLineNumber>L.endLineNumber?(I=E.endLineNumber,N=E.endColumn):E.endLineNumber===L.endLineNumber?(I=E.endLineNumber,N=Math.max(E.endColumn,L.endColumn)):(I=L.endLineNumber,N=L.endColumn),new R(T,S,I,N)}intersectRanges(L){return R.intersectRanges(this,L)}static intersectRanges(L,E){let T=L.startLineNumber,S=L.startColumn,I=L.endLineNumber,N=L.endColumn;const A=E.startLineNumber,D=E.startColumn,k=E.endLineNumber,C=E.endColumn;return T<A?(T=A,S=D):T===A&&(S=Math.max(S,D)),I>k?(I=k,N=C):I===k&&(N=Math.min(N,C)),T>I||T===I&&S>N?null:new R(T,S,I,N)}equalsRange(L){return R.equalsRange(this,L)}static equalsRange(L,E){return!L&&!E?!0:!!L&&!!E&&L.startLineNumber===E.startLineNumber&&L.startColumn===E.startColumn&&L.endLineNumber===E.endLineNumber&&L.endColumn===E.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(L){return new a.Position(L.endLineNumber,L.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(L){return new a.Position(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,E){return new R(this.startLineNumber,this.startColumn,L,E)}setStartPosition(L,E){return new R(L,E,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(L){return new R(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(L){return new R(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new R(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,E=L){return new R(L.lineNumber,L.column,E.lineNumber,E.column)}static lift(L){return L?new R(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,E){return!(L.endLineNumber<E.startLineNumber||L.endLineNumber===E.startLineNumber&&L.endColumn<E.startColumn||E.endLineNumber<L.startLineNumber||E.endLineNumber===L.startLineNumber&&E.endColumn<L.startColumn)}static areIntersecting(L,E){return!(L.endLineNumber<E.startLineNumber||L.endLineNumber===E.startLineNumber&&L.endColumn<=E.startColumn||E.endLineNumber<L.startLineNumber||E.endLineNumber===L.startLineNumber&&E.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,E){if(L&&E){const I=L.startLineNumber|0,N=E.startLineNumber|0;if(I===N){const A=L.startColumn|0,D=E.startColumn|0;if(A===D){const k=L.endLineNumber|0,C=E.endLineNumber|0;if(k===C){const m=L.endColumn|0,o=E.endColumn|0;return m-o}return k-C}return A-D}return I-N}return(L?1:0)-(E?1:0)}static compareRangesUsingEnds(L,E){return L.endLineNumber===E.endLineNumber?L.endColumn===E.endColumn?L.startLineNumber===E.startLineNumber?L.startColumn-E.startColumn:L.startLineNumber-E.startLineNumber:L.endColumn-E.endColumn:L.endLineNumber-E.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.Range=R}),define(De[151],Ce([1,0,53,32]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var c;(function(E){E[E.LTR=0]="LTR",E[E.RTL=1]="RTL"})(c=e.SelectionDirection||(e.SelectionDirection={}));class L extends R.Range{constructor(T,S,I,N){super(T,S,I,N),this.selectionStartLineNumber=T,this.selectionStartColumn=S,this.positionLineNumber=I,this.positionColumn=N}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(T){return L.selectionsEqual(this,T)}static selectionsEqual(T,S){return T.selectionStartLineNumber===S.selectionStartLineNumber&&T.selectionStartColumn===S.selectionStartColumn&&T.positionLineNumber===S.positionLineNumber&&T.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(T,S){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,T,S):new L(T,S,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(T,S){return this.getDirection()===0?new L(T,S,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,T,S)}static fromPositions(T,S=T){return new L(T.lineNumber,T.column,S.lineNumber,S.column)}static fromRange(T,S){return S===0?new L(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):new L(T.endLineNumber,T.endColumn,T.startLineNumber,T.startColumn)}static liftSelection(T){return new L(T.selectionStartLineNumber,T.selectionStartColumn,T.positionLineNumber,T.positionColumn)}static selectionsArrEqual(T,S){if(T&&!S||!T&&S)return!1;if(!T&&!S)return!0;if(T.length!==S.length)return!1;for(let I=0,N=T.length;I<N;I++)if(!this.selectionsEqual(T[I],S[I]))return!1;return!0}static isISelection(T){return T&&typeof T.selectionStartLineNumber=="number"&&typeof T.selectionStartColumn=="number"&&typeof T.positionLineNumber=="number"&&typeof T.positionColumn=="number"}static createWithDirection(T,S,I,N,A){return A===0?new L(T,S,I,N):new L(I,N,T,S)}}e.Selection=L}),define(De[152],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[153],Ce([1,0,105]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(E){E[E.Regular=0]="Regular",E[E.Whitespace=1]="Whitespace",E[E.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class c extends a.CharacterClassifier{constructor(T){super(0);for(let S=0,I=T.length;S<I;S++)this.set(T.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=c;function L(E){const T={};return S=>(T.hasOwnProperty(S)||(T[S]=E(S)),T[S])}e.getMapForWordSeparators=L(E=>new c(E))}),define(De[106],Ce([1,0,64,6,66]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(A=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)A.indexOf(k)>=0||(D+="\\"+k);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=L();function E(A){let D=e.DEFAULT_WORD_REGEXP;if(A&&A instanceof RegExp)if(A.global)D=A;else{let k="g";A.ignoreCase&&(k+="i"),A.multiline&&(k+="m"),A.unicode&&(k+="u"),D=new RegExp(A.source,k)}return D.lastIndex=0,D}e.ensureValidWordDefinition=E;const T=new c.LinkedList;T.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(A){const D=T.unshift(A);return(0,R.toDisposable)(D)}e.setDefaultGetWordAtTextConfig=S;function I(A,D,k,C,m){if(m||(m=a.Iterable.first(T)),k.length>m.maxLen){let y=A-m.maxLen/2;return y<0?y=0:C+=y,k=k.substring(y,A+m.maxLen/2),I(A,D,k,C,m)}const o=Date.now(),d=A-1-C;let f=-1,p=null;for(let y=1;!(Date.now()-o>=m.timeBudget);y++){const g=d-m.windowSize*y;D.lastIndex=Math.max(0,g);const t=N(D,k,d,f);if(!t&&p||(p=t,g<=0))break;f=g}if(p){const y={word:p[0],startColumn:C+1+p.index,endColumn:C+1+p.index+p[0].length};return D.lastIndex=0,y}return null}e.getWordAtText=I;function N(A,D,k,C){let m;for(;m=A.exec(D);){const o=m.index||0;if(o<=k&&A.lastIndex>=k)return m;if(C>0&&o>C)return null}return null}}),define(De[154],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(E){E[E.None=0]="None",E[E.Indent=1]="Indent",E[E.IndentOutdent=2]="IndentOutdent",E[E.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class R{constructor(T){if(this.e=null,this.f=!1,this.open=T.open,this.close=T.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(T.notIn))for(let S=0,I=T.notIn.length;S<I;S++)switch(T.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(T,S){if(T.getTokenCount()===0)return!0;const I=T.findTokenIndexAtOffset(S-2),N=T.getStandardTokenType(I);return this.isOK(N)}g(T,S){for(let I=T;I<=S;I++){const N=String.fromCharCode(I);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=R;class c{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of T)L(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),L(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),L(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),L(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&L(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=c;function L(E,T,S){E.has(T)?E.get(T).push(S):E.set(T,[S])}}),define(De[155],Ce([1,0,105]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var R;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class c{constructor(C,m,o){const d=new Uint8Array(C*m);for(let f=0,p=C*m;f<p;f++)d[f]=o;this.a=d,this.rows=C,this.cols=m}get(C,m){return this.a[C*this.cols+m]}set(C,m,o){this.a[C*this.cols+m]=o}}class L{constructor(C){let m=0,o=0;for(let f=0,p=C.length;f<p;f++){const[y,g,t]=C[f];g>m&&(m=g),y>o&&(o=y),t>o&&(o=t)}m++,o++;const d=new c(o,m,0);for(let f=0,p=C.length;f<p;f++){const[y,g,t]=C[f];d.set(y,g,t)}this.a=d,this.b=m}nextState(C,m){return m<0||m>=this.b?0:this.a.get(C,m)}}e.StateMachine=L;let E=null;function T(){return E===null&&(E=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),E}var S;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let I=null;function N(){if(I===null){I=new a.CharacterClassifier(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<k.length;m++)I.set(k.charCodeAt(m),1);const C=".,;:";for(let m=0;m<C.length;m++)I.set(C.charCodeAt(m),2)}return I}class A{static a(C,m,o,d,f){let p=f-1;do{const y=m.charCodeAt(p);if(C.get(y)!==2)break;p--}while(p>d);if(d>0){const y=m.charCodeAt(d-1),g=m.charCodeAt(p);(y===40&&g===41||y===91&&g===93||y===123&&g===125)&&p--}return{range:{startLineNumber:o,startColumn:d+1,endLineNumber:o,endColumn:p+2},url:m.substring(d,p+1)}}static computeLinks(C,m=T()){const o=N(),d=[];for(let f=1,p=C.getLineCount();f<=p;f++){const y=C.getLineContent(f),g=y.length;let t=0,s=0,r=0,l=1,u=!1,b=!1,i=!1,n=!1;for(;t<g;){let h=!1;const w=y.charCodeAt(t);if(l===13){let v;switch(w){case 40:u=!0,v=0;break;case 41:v=u?0:1;break;case 91:i=!0,b=!0,v=0;break;case 93:i=!1,v=b?0:1;break;case 123:n=!0,v=0;break;case 125:v=n?0:1;break;case 39:case 34:case 96:r===w?v=1:r===39||r===34||r===96?v=0:v=1;break;case 42:v=r===42?1:0;break;case 124:v=r===124?1:0;break;case 32:v=i?0:1;break;default:v=o.get(w)}v===1&&(d.push(A.a(o,y,f,s,t)),h=!0)}else if(l===12){let v;w===91?(b=!0,v=0):v=o.get(w),v===1?h=!0:l=13}else l=m.nextState(l,w),l===0&&(h=!0);h&&(l=1,u=!1,b=!1,n=!1,s=t+1,r=w),t++}l===13&&d.push(A.a(o,y,f,s,g))}return d}}e.LinkComputer=A;function D(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:A.computeLinks(k)}e.computeLinks=D}),define(De[107],Ce([1,0,23]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var R;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(R=e.OverviewRulerLane||(e.OverviewRulerLane={}));var c;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(c=e.MinimapPosition||(e.MinimapPosition={}));var L;(function(p){p[p.Both=0]="Both",p[p.Right=1]="Right",p[p.Left=2]="Left",p[p.None=3]="None"})(L=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var E;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(E=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(y){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,y.tabSize|0),y.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,y.indentSize|0),this.a=!1),this.insertSpaces=Boolean(y.insertSpaces),this.defaultEOL=y.defaultEOL|0,this.trimAutoWhitespace=Boolean(y.trimAutoWhitespace),this.bracketPairColorizationOptions=y.bracketPairColorizationOptions}equals(y){return this.tabSize===y.tabSize&&this.a===y.a&&this.indentSize===y.indentSize&&this.insertSpaces===y.insertSpaces&&this.defaultEOL===y.defaultEOL&&this.trimAutoWhitespace===y.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,y.bracketPairColorizationOptions)}createChangeEvent(y){return{tabSize:this.tabSize!==y.tabSize,indentSize:this.indentSize!==y.indentSize,insertSpaces:this.insertSpaces!==y.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==y.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class N{constructor(y,g){this._findMatchBrand=void 0,this.range=y,this.matches=g}}e.FindMatch=N;var A;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(A=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function D(p){return p&&typeof p.read=="function"}e.isITextSnapshot=D;var k;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None",p[p.LeftOfInjectedText=3]="LeftOfInjectedText",p[p.RightOfInjectedText=4]="RightOfInjectedText"})(k=e.PositionAffinity||(e.PositionAffinity={}));var C;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(C=e.ModelConstants||(e.ModelConstants={}));class m{constructor(y,g,t,s,r,l){this.identifier=y,this.range=g,this.text=t,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=r,this._isTracked=l}}e.ValidAnnotatedEditOperation=m;class o{constructor(y,g,t){this.regex=y,this.wordSeparators=g,this.simpleSearch=t}}e.SearchData=o;class d{constructor(y,g,t){this.reverseEdits=y,this.changes=g,this.trimAutoWhitespaceLineNumbers=t}}e.ApplyEditsResult=d;function f(p){return!p.isTooLargeForSyncing()&&!p.isForSimpleWidget}e.shouldSynchronizeModel=f}),define(De[156],Ce([1,0,15,104]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class c{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,I){S=(0,R.toUint32)(S);const N=this.a,A=this.b,D=I.length;return D===0?!1:(this.a=new Uint32Array(N.length+D),this.a.set(N.subarray(0,S),0),this.a.set(N.subarray(S),S+D),this.a.set(I,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}setValue(S,I){return S=(0,R.toUint32)(S),I=(0,R.toUint32)(I),this.a[S]===I?!1:(this.a[S]=I,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,I){S=(0,R.toUint32)(S),I=(0,R.toUint32)(I);const N=this.a,A=this.b;if(S>=N.length)return!1;const D=N.length-S;return I>=D&&(I=D),I===0?!1:(this.a=new Uint32Array(N.length-I),this.a.set(N.subarray(0,S),0),this.a.set(N.subarray(S+I),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,R.toUint32)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let I=this.c[0]+1;I===0&&(this.b[0]=this.a[0],I++),S>=this.a.length&&(S=this.a.length-1);for(let N=I;N<=S;N++)this.b[N]=this.b[N-1]+this.a[N];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let I=0,N=this.a.length-1,A=0,D=0,k=0;for(;I<=N;)if(A=I+(N-I)/2|0,D=this.b[A],k=D-this.a[A],S<k)N=A-1;else if(S>=D)I=A+1;else break;return new E(A,S-k)}}e.PrefixSumComputer=c;class L{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const I=this.e[S],N=I>0?this.d[I-1]:0;return new E(I,S-N)}removeValues(S,I){this.a.splice(S,I),this.f(S)}insertValues(S,I){this.a=(0,a.arrayInsert)(this.a,S,I),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,I=this.a.length;S<I;S++){const N=this.a[S],A=S>0?this.d[S-1]:0;this.d[S]=A+N;for(let D=0;D<N;D++)this.e[A+D]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,I){this.a[S]!==I&&(this.a[S]=I,this.f(S))}}e.ConstantTimePrefixSumComputer=L;class E{constructor(S,I){this.index=S,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=I}}e.PrefixSumIndexOfResult=E}),define(De[157],Ce([17,18]),function(ie,e){return ie.create("vs/base/common/actions",e)}),define(De[158],Ce([17,18]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(De[159],Ce([1,0,158]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,c=R*60,L=c*24,E=L*7,T=L*30,S=L*365;function I(A,D,k,C){typeof A!="number"&&(A=A.getTime());const m=Math.round((new Date().getTime()-A)/1e3);if(m<-30)return(0,a.localize)(0,null,I(new Date().getTime()+m*1e3,!1));if(!C&&m<30)return(0,a.localize)(1,null);let o;return m<R?(o=m,D?o===1?k?(0,a.localize)(2,null,o):(0,a.localize)(3,null,o):k?(0,a.localize)(4,null,o):(0,a.localize)(5,null,o):o===1?k?(0,a.localize)(6,null,o):(0,a.localize)(7,null,o):k?(0,a.localize)(8,null,o):(0,a.localize)(9,null,o)):m<c?(o=Math.floor(m/R),D?o===1?k?(0,a.localize)(10,null,o):(0,a.localize)(11,null,o):k?(0,a.localize)(12,null,o):(0,a.localize)(13,null,o):o===1?k?(0,a.localize)(14,null,o):(0,a.localize)(15,null,o):k?(0,a.localize)(16,null,o):(0,a.localize)(17,null,o)):m<L?(o=Math.floor(m/c),D?o===1?k?(0,a.localize)(18,null,o):(0,a.localize)(19,null,o):k?(0,a.localize)(20,null,o):(0,a.localize)(21,null,o):o===1?k?(0,a.localize)(22,null,o):(0,a.localize)(23,null,o):k?(0,a.localize)(24,null,o):(0,a.localize)(25,null,o)):m<E?(o=Math.floor(m/L),D?o===1?(0,a.localize)(26,null,o):(0,a.localize)(27,null,o):o===1?(0,a.localize)(28,null,o):(0,a.localize)(29,null,o)):m<T?(o=Math.floor(m/E),D?o===1?k?(0,a.localize)(30,null,o):(0,a.localize)(31,null,o):k?(0,a.localize)(32,null,o):(0,a.localize)(33,null,o):o===1?k?(0,a.localize)(34,null,o):(0,a.localize)(35,null,o):k?(0,a.localize)(36,null,o):(0,a.localize)(37,null,o)):m<S?(o=Math.floor(m/T),D?o===1?k?(0,a.localize)(38,null,o):(0,a.localize)(39,null,o):k?(0,a.localize)(40,null,o):(0,a.localize)(41,null,o):o===1?k?(0,a.localize)(42,null,o):(0,a.localize)(43,null,o):k?(0,a.localize)(44,null,o):(0,a.localize)(45,null,o)):(o=Math.floor(m/S),D?o===1?k?(0,a.localize)(46,null,o):(0,a.localize)(47,null,o):k?(0,a.localize)(48,null,o):(0,a.localize)(49,null,o):o===1?k?(0,a.localize)(50,null,o):(0,a.localize)(51,null,o):k?(0,a.localize)(52,null,o):(0,a.localize)(53,null,o))}e.fromNow=I;function N(A){return A.getFullYear()+"-"+String(A.getMonth()+1).padStart(2,"0")+"-"+String(A.getDate()).padStart(2,"0")+"T"+String(A.getHours()).padStart(2,"0")+":"+String(A.getMinutes()).padStart(2,"0")+":"+String(A.getSeconds()).padStart(2,"0")+"."+(A.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(De[160],Ce([17,18]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(De[45],Ce([1,0,15,9,160]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(A,D){return D&&(A.stack||A.stacktrace)?c.localize(0,null,T(A),E(A.stack)||E(A.stacktrace)):T(A)}function E(A){return Array.isArray(A)?A.join(`
`):A}function T(A){return typeof A.code=="string"&&typeof A.errno=="number"&&typeof A.syscall=="string"?c.localize(1,null,A.message):A.message||c.localize(2,null)}function S(A=null,D=!1){if(!A)return c.localize(3,null);if(Array.isArray(A)){const k=a.coalesce(A),C=S(k[0],D);return k.length>1?c.localize(4,null,C,k.length):C}if(R.isString(A))return A;if(A.detail){const k=A.detail;if(k.error)return L(k.error,D);if(k.exception)return L(k.exception,D)}return A.stack?L(A,D):A.message?A.message:c.localize(5,null)}e.toErrorMessage=S;function I(A){const D=A;return D instanceof Error&&Array.isArray(D.actions)}e.isErrorWithActions=I;function N(A,D){let k;return typeof A=="string"?k=new Error(A):k=A,k.actions=D,k}e.createErrorWithActions=N}),define(De[161],Ce([17,18]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(De[11],Ce([1,0,161]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let R=!1,c=!1,L=!1,E=!1,T=!1,S=!1,I=!1,N=!1,A=!1,D=!1,k,C=e.LANGUAGE_DEFAULT,m,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const f=typeof d?.versions?.electron=="string",p=f&&d?.type==="renderer";if(typeof navigator=="object"&&!p)o=navigator.userAgent,R=o.indexOf("Windows")>=0,c=o.indexOf("Macintosh")>=0,N=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=o.indexOf("Linux")>=0,D=o?.indexOf("Mobi")>=0,S=!0,k=a.getConfiguredDefaultLocale(a.localize(0,null))||e.LANGUAGE_DEFAULT,C=k;else if(typeof d=="object"){R=d.platform==="win32",c=d.platform==="darwin",L=d.platform==="linux",E=L&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,I=f,A=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.LANGUAGE_DEFAULT,C=e.LANGUAGE_DEFAULT;const i=d.env.VSCODE_NLS_CONFIG;if(i)try{const n=JSON.parse(i),h=n.availableLanguages["*"];k=n.locale,C=h||e.LANGUAGE_DEFAULT,m=n._translationsConfigFile}catch{}T=!0}else console.error("Unable to resolve platform.");var y;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function g(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let t=0;c?t=1:R?t=3:L&&(t=2),e.isWindows=R,e.isMacintosh=c,e.isLinux=L,e.isLinuxSnap=E,e.isNative=T,e.isElectron=I,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=N,e.isMobile=D,e.isCI=A,e.platform=t,e.userAgent=o,e.language=C;var s;(function(i){function n(){return e.language}i.value=n;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=h;function w(){return e.language==="en"}i.isDefault=w})(s=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const i=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let w=0,v=i.length;w<v;w++){const O=i[w];if(O.id===h.data.vscodeScheduleAsyncWork){i.splice(w,1),O.callback();return}}});let n=0;return h=>{const w=++n;i.push({id:w,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:w},"*")}}return i=>setTimeout(i)})();var r;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=c||N?2:R?1:3;let l=!0,u=!1;function b(){if(!u){u=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,l=new Uint16Array(i.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=b,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(De[36],Ce([1,0,11]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let R;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const c=a.globals.vscode.process;R={get platform(){return c.platform},get arch(){return c.arch},get env(){return c.env},cwd(){return c.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.arch=R.arch}),define(De[12],Ce([1,0,36]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,c=97,L=90,E=122,T=46,S=47,I=92,N=58,A=63;class D extends Error{constructor(s,r,l){let u;typeof r=="string"&&r.indexOf("not ")===0?(u="must not be",r=r.replace(/^not /,"")):u="must be";const b=s.indexOf(".")!==-1?"property":"argument";let i=`The "${s}" ${b} ${u} of type ${r}`;i+=`. Received type ${typeof l}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,s){if(t===null||typeof t!="object")throw new D(s,"Object",t)}function C(t,s){if(typeof t!="string")throw new D(s,"string",t)}const m=a.platform==="win32";function o(t){return t===S||t===I}function d(t){return t===S}function f(t){return t>=R&&t<=L||t>=c&&t<=E}function p(t,s,r,l){let u="",b=0,i=-1,n=0,h=0;for(let w=0;w<=t.length;++w){if(w<t.length)h=t.charCodeAt(w);else{if(l(h))break;h=S}if(l(h)){if(!(i===w-1||n===1))if(n===2){if(u.length<2||b!==2||u.charCodeAt(u.length-1)!==T||u.charCodeAt(u.length-2)!==T){if(u.length>2){const v=u.lastIndexOf(r);v===-1?(u="",b=0):(u=u.slice(0,v),b=u.length-1-u.lastIndexOf(r)),i=w,n=0;continue}else if(u.length!==0){u="",b=0,i=w,n=0;continue}}s&&(u+=u.length>0?`${r}..`:"..",b=2)}else u.length>0?u+=`${r}${t.slice(i+1,w)}`:u=t.slice(i+1,w),b=w-i-1;i=w,n=0}else h===T&&n!==-1?++n:n=-1}return u}function y(t,s){k(s,"pathObject");const r=s.dir||s.root,l=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${l}`:`${r}${t}${l}`:l}e.win32={resolve(...t){let s="",r="",l=!1;for(let u=t.length-1;u>=-1;u--){let b;if(u>=0){if(b=t[u],C(b,"path"),b.length===0)continue}else s.length===0?b=a.cwd():(b=a.env[`=${s}`]||a.cwd(),(b===void 0||b.slice(0,2).toLowerCase()!==s.toLowerCase()&&b.charCodeAt(2)===I)&&(b=`${s}\\`));const i=b.length;let n=0,h="",w=!1;const v=b.charCodeAt(0);if(i===1)o(v)&&(n=1,w=!0);else if(o(v))if(w=!0,o(b.charCodeAt(1))){let O=2,j=O;for(;O<i&&!o(b.charCodeAt(O));)O++;if(O<i&&O!==j){const V=b.slice(j,O);for(j=O;O<i&&o(b.charCodeAt(O));)O++;if(O<i&&O!==j){for(j=O;O<i&&!o(b.charCodeAt(O));)O++;(O===i||O!==j)&&(h=`\\\\${V}\\${b.slice(j,O)}`,n=O)}}}else n=1;else f(v)&&b.charCodeAt(1)===N&&(h=b.slice(0,2),n=2,i>2&&o(b.charCodeAt(2))&&(w=!0,n=3));if(h.length>0)if(s.length>0){if(h.toLowerCase()!==s.toLowerCase())continue}else s=h;if(l){if(s.length>0)break}else if(r=`${b.slice(n)}\\${r}`,l=w,w&&s.length>0)break}return r=p(r,!l,"\\",o),l?`${s}\\${r}`:`${s}${r}`||"."},normalize(t){C(t,"path");const s=t.length;if(s===0)return".";let r=0,l,u=!1;const b=t.charCodeAt(0);if(s===1)return d(b)?"\\":t;if(o(b))if(u=!0,o(t.charCodeAt(1))){let n=2,h=n;for(;n<s&&!o(t.charCodeAt(n));)n++;if(n<s&&n!==h){const w=t.slice(h,n);for(h=n;n<s&&o(t.charCodeAt(n));)n++;if(n<s&&n!==h){for(h=n;n<s&&!o(t.charCodeAt(n));)n++;if(n===s)return`\\\\${w}\\${t.slice(h)}\\`;n!==h&&(l=`\\\\${w}\\${t.slice(h,n)}`,r=n)}}}else r=1;else f(b)&&t.charCodeAt(1)===N&&(l=t.slice(0,2),r=2,s>2&&o(t.charCodeAt(2))&&(u=!0,r=3));let i=r<s?p(t.slice(r),!u,"\\",o):"";return i.length===0&&!u&&(i="."),i.length>0&&o(t.charCodeAt(s-1))&&(i+="\\"),l===void 0?u?`\\${i}`:i:u?`${l}\\${i}`:`${l}${i}`},isAbsolute(t){C(t,"path");const s=t.length;if(s===0)return!1;const r=t.charCodeAt(0);return o(r)||s>2&&f(r)&&t.charCodeAt(1)===N&&o(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,r;for(let b=0;b<t.length;++b){const i=t[b];C(i,"path"),i.length>0&&(s===void 0?s=r=i:s+=`\\${i}`)}if(s===void 0)return".";let l=!0,u=0;if(typeof r=="string"&&o(r.charCodeAt(0))){++u;const b=r.length;b>1&&o(r.charCodeAt(1))&&(++u,b>2&&(o(r.charCodeAt(2))?++u:l=!1))}if(l){for(;u<s.length&&o(s.charCodeAt(u));)u++;u>=2&&(s=`\\${s.slice(u)}`)}return e.win32.normalize(s)},relative(t,s){if(C(t,"from"),C(s,"to"),t===s)return"";const r=e.win32.resolve(t),l=e.win32.resolve(s);if(r===l||(t=r.toLowerCase(),s=l.toLowerCase(),t===s))return"";let u=0;for(;u<t.length&&t.charCodeAt(u)===I;)u++;let b=t.length;for(;b-1>u&&t.charCodeAt(b-1)===I;)b--;const i=b-u;let n=0;for(;n<s.length&&s.charCodeAt(n)===I;)n++;let h=s.length;for(;h-1>n&&s.charCodeAt(h-1)===I;)h--;const w=h-n,v=i<w?i:w;let O=-1,j=0;for(;j<v;j++){const Q=t.charCodeAt(u+j);if(Q!==s.charCodeAt(n+j))break;Q===I&&(O=j)}if(j!==v){if(O===-1)return l}else{if(w>v){if(s.charCodeAt(n+j)===I)return l.slice(n+j+1);if(j===2)return l.slice(n+j)}i>v&&(t.charCodeAt(u+j)===I?O=j:j===2&&(O=3)),O===-1&&(O=0)}let V="";for(j=u+O+1;j<=b;++j)(j===b||t.charCodeAt(j)===I)&&(V+=V.length===0?"..":"\\..");return n+=O,V.length>0?`${V}${l.slice(n,h)}`:(l.charCodeAt(n)===I&&++n,l.slice(n,h))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.win32.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===I){if(s.charCodeAt(1)===I){const r=s.charCodeAt(2);if(r!==A&&r!==T)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(f(s.charCodeAt(0))&&s.charCodeAt(1)===N&&s.charCodeAt(2)===I)return`\\\\?\\${s}`;return t},dirname(t){C(t,"path");const s=t.length;if(s===0)return".";let r=-1,l=0;const u=t.charCodeAt(0);if(s===1)return o(u)?t:".";if(o(u)){if(r=l=1,o(t.charCodeAt(1))){let n=2,h=n;for(;n<s&&!o(t.charCodeAt(n));)n++;if(n<s&&n!==h){for(h=n;n<s&&o(t.charCodeAt(n));)n++;if(n<s&&n!==h){for(h=n;n<s&&!o(t.charCodeAt(n));)n++;if(n===s)return t;n!==h&&(r=l=n+1)}}}}else f(u)&&t.charCodeAt(1)===N&&(r=s>2&&o(t.charCodeAt(2))?3:2,l=r);let b=-1,i=!0;for(let n=s-1;n>=l;--n)if(o(t.charCodeAt(n))){if(!i){b=n;break}}else i=!1;if(b===-1){if(r===-1)return".";b=r}return t.slice(0,b)},basename(t,s){s!==void 0&&C(s,"ext"),C(t,"path");let r=0,l=-1,u=!0,b;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===N&&(r=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let i=s.length-1,n=-1;for(b=t.length-1;b>=r;--b){const h=t.charCodeAt(b);if(o(h)){if(!u){r=b+1;break}}else n===-1&&(u=!1,n=b+1),i>=0&&(h===s.charCodeAt(i)?--i===-1&&(l=b):(i=-1,l=n))}return r===l?l=n:l===-1&&(l=t.length),t.slice(r,l)}for(b=t.length-1;b>=r;--b)if(o(t.charCodeAt(b))){if(!u){r=b+1;break}}else l===-1&&(u=!1,l=b+1);return l===-1?"":t.slice(r,l)},extname(t){C(t,"path");let s=0,r=-1,l=0,u=-1,b=!0,i=0;t.length>=2&&t.charCodeAt(1)===N&&f(t.charCodeAt(0))&&(s=l=2);for(let n=t.length-1;n>=s;--n){const h=t.charCodeAt(n);if(o(h)){if(!b){l=n+1;break}continue}u===-1&&(b=!1,u=n+1),h===T?r===-1?r=n:i!==1&&(i=1):r!==-1&&(i=-1)}return r===-1||u===-1||i===0||i===1&&r===u-1&&r===l+1?"":t.slice(r,u)},format:y.bind(null,"\\"),parse(t){C(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.length;let l=0,u=t.charCodeAt(0);if(r===1)return o(u)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(o(u)){if(l=1,o(t.charCodeAt(1))){let O=2,j=O;for(;O<r&&!o(t.charCodeAt(O));)O++;if(O<r&&O!==j){for(j=O;O<r&&o(t.charCodeAt(O));)O++;if(O<r&&O!==j){for(j=O;O<r&&!o(t.charCodeAt(O));)O++;O===r?l=O:O!==j&&(l=O+1)}}}}else if(f(u)&&t.charCodeAt(1)===N){if(r<=2)return s.root=s.dir=t,s;if(l=2,o(t.charCodeAt(2))){if(r===3)return s.root=s.dir=t,s;l=3}}l>0&&(s.root=t.slice(0,l));let b=-1,i=l,n=-1,h=!0,w=t.length-1,v=0;for(;w>=l;--w){if(u=t.charCodeAt(w),o(u)){if(!h){i=w+1;break}continue}n===-1&&(h=!1,n=w+1),u===T?b===-1?b=w:v!==1&&(v=1):b!==-1&&(v=-1)}return n!==-1&&(b===-1||v===0||v===1&&b===n-1&&b===i+1?s.base=s.name=t.slice(i,n):(s.name=t.slice(i,b),s.base=t.slice(i,n),s.ext=t.slice(b,n))),i>0&&i!==l?s.dir=t.slice(0,i-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(m){const t=/\\/g;return()=>{const s=a.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>a.cwd()})();e.posix={resolve(...t){let s="",r=!1;for(let l=t.length-1;l>=-1&&!r;l--){const u=l>=0?t[l]:g();C(u,"path"),u.length!==0&&(s=`${u}/${s}`,r=u.charCodeAt(0)===S)}return s=p(s,!r,"/",d),r?`/${s}`:s.length>0?s:"."},normalize(t){if(C(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===S,r=t.charCodeAt(t.length-1)===S;return t=p(t,!s,"/",d),t.length===0?s?"/":r?"./":".":(r&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return C(t,"path"),t.length>0&&t.charCodeAt(0)===S},join(...t){if(t.length===0)return".";let s;for(let r=0;r<t.length;++r){const l=t[r];C(l,"path"),l.length>0&&(s===void 0?s=l:s+=`/${l}`)}return s===void 0?".":e.posix.normalize(s)},relative(t,s){if(C(t,"from"),C(s,"to"),t===s||(t=e.posix.resolve(t),s=e.posix.resolve(s),t===s))return"";const r=1,l=t.length,u=l-r,b=1,i=s.length-b,n=u<i?u:i;let h=-1,w=0;for(;w<n;w++){const O=t.charCodeAt(r+w);if(O!==s.charCodeAt(b+w))break;O===S&&(h=w)}if(w===n)if(i>n){if(s.charCodeAt(b+w)===S)return s.slice(b+w+1);if(w===0)return s.slice(b+w)}else u>n&&(t.charCodeAt(r+w)===S?h=w:w===0&&(h=0));let v="";for(w=r+h+1;w<=l;++w)(w===l||t.charCodeAt(w)===S)&&(v+=v.length===0?"..":"/..");return`${v}${s.slice(b+h)}`},toNamespacedPath(t){return t},dirname(t){if(C(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===S;let r=-1,l=!0;for(let u=t.length-1;u>=1;--u)if(t.charCodeAt(u)===S){if(!l){r=u;break}}else l=!1;return r===-1?s?"/":".":s&&r===1?"//":t.slice(0,r)},basename(t,s){s!==void 0&&C(s,"ext"),C(t,"path");let r=0,l=-1,u=!0,b;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let i=s.length-1,n=-1;for(b=t.length-1;b>=0;--b){const h=t.charCodeAt(b);if(h===S){if(!u){r=b+1;break}}else n===-1&&(u=!1,n=b+1),i>=0&&(h===s.charCodeAt(i)?--i===-1&&(l=b):(i=-1,l=n))}return r===l?l=n:l===-1&&(l=t.length),t.slice(r,l)}for(b=t.length-1;b>=0;--b)if(t.charCodeAt(b)===S){if(!u){r=b+1;break}}else l===-1&&(u=!1,l=b+1);return l===-1?"":t.slice(r,l)},extname(t){C(t,"path");let s=-1,r=0,l=-1,u=!0,b=0;for(let i=t.length-1;i>=0;--i){const n=t.charCodeAt(i);if(n===S){if(!u){r=i+1;break}continue}l===-1&&(u=!1,l=i+1),n===T?s===-1?s=i:b!==1&&(b=1):s!==-1&&(b=-1)}return s===-1||l===-1||b===0||b===1&&s===l-1&&s===r+1?"":t.slice(s,l)},format:y.bind(null,"/"),parse(t){C(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.charCodeAt(0)===S;let l;r?(s.root="/",l=1):l=0;let u=-1,b=0,i=-1,n=!0,h=t.length-1,w=0;for(;h>=l;--h){const v=t.charCodeAt(h);if(v===S){if(!n){b=h+1;break}continue}i===-1&&(n=!1,i=h+1),v===T?u===-1?u=h:w!==1&&(w=1):u!==-1&&(w=-1)}if(i!==-1){const v=b===0&&r?1:b;u===-1||w===0||w===1&&u===i-1&&u===b+1?s.base=s.name=t.slice(v,i):(s.name=t.slice(v,u),s.base=t.slice(v,i),s.ext=t.slice(u,i))}return b>0?s.dir=t.slice(0,b-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m?e.win32.normalize:e.posix.normalize,e.isAbsolute=m?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m?e.win32.join:e.posix.join,e.resolve=m?e.win32.resolve:e.posix.resolve,e.relative=m?e.win32.relative:e.posix.relative,e.dirname=m?e.win32.dirname:e.posix.dirname,e.basename=m?e.win32.basename:e.posix.basename,e.extname=m?e.win32.extname:e.posix.extname,e.format=m?e.win32.format:e.posix.format,e.parse=m?e.win32.parse:e.posix.parse,e.toNamespacedPath=m?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m?e.win32.sep:e.posix.sep,e.delimiter=m?e.win32.delimiter:e.posix.delimiter}),define(De[108],Ce([1,0,65,12]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const c=new a.Lazy(()=>{const n=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:n,collatorIsNumeric:n.resolvedOptions().numeric}}),L=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),E=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(n,h,w=!1){const v=n||"",O=h||"",j=c.value.collator.compare(v,O);return c.value.collatorIsNumeric&&j===0&&v!==O?v<O?-1:1:j}e.compareFileNames=T;function S(n,h){const w=L.value.collator;return n=n||"",h=h||"",y(w,n,h)}e.compareFileNamesDefault=S;function I(n,h){const w=L.value.collator;return n=n||"",h=h||"",r(n,h)||y(w,n,h)}e.compareFileNamesUpper=I;function N(n,h){const w=L.value.collator;return n=n||"",h=h||"",s(n,h)||y(w,n,h)}e.compareFileNamesLower=N;function A(n,h){return n=n||"",h=h||"",n===h?0:n<h?-1:1}e.compareFileNamesUnicode=A;function D(n,h){const[w,v]=f(n),[O,j]=f(h);let V=c.value.collator.compare(v,j);if(V===0){if(c.value.collatorIsNumeric&&v!==j)return v<j?-1:1;if(V=c.value.collator.compare(w,O),c.value.collatorIsNumeric&&V===0&&w!==O)return w<O?-1:1}return V}e.compareFileExtensions=D;function k(n,h){n=n||"",h=h||"";const w=p(n),v=p(h),O=L.value.collator,j=E.value.collator;return y(j,w,v)||y(O,n,h)}e.compareFileExtensionsDefault=k;function C(n,h){n=n||"",h=h||"";const w=p(n),v=p(h),O=L.value.collator,j=E.value.collator;return y(j,w,v)||r(n,h)||y(O,n,h)}e.compareFileExtensionsUpper=C;function m(n,h){n=n||"",h=h||"";const w=p(n),v=p(h),O=L.value.collator,j=E.value.collator;return y(j,w,v)||s(n,h)||y(O,n,h)}e.compareFileExtensionsLower=m;function o(n,h){n=n||"",h=h||"";const w=p(n).toLowerCase(),v=p(h).toLowerCase();return w!==v?w<v?-1:1:n!==h?n<h?-1:1:0}e.compareFileExtensionsUnicode=o;const d=/^(.*?)(\.([^.]*))?$/;function f(n,h=!1){const w=n?d.exec(n):[];let v=[w&&w[1]||"",w&&w[3]||""];return h&&(!v[0]&&v[1]||v[0]&&v[0].charAt(0)===".")&&(v=[v[0]+"."+v[1],""]),v}function p(n){const h=n?d.exec(n):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function y(n,h,w){const v=n.compare(h,w);return v!==0?v:h.length!==w.length?h.length<w.length?-1:1:0}function g(n){const h=n.charAt(0);return h.toLocaleUpperCase()!==h}function t(n){const h=n.charAt(0);return h.toLocaleLowerCase()!==h}function s(n,h){return g(n)&&t(h)?-1:t(n)&&g(h)?1:0}function r(n,h){return t(n)&&g(h)?-1:g(n)&&t(h)?1:0}function l(n,h,w=!1){return w||(n=n&&n.toLowerCase(),h=h&&h.toLowerCase()),n===h?0:n<h?-1:1}function u(n,h,w=!1){const v=n.split(R.sep),O=h.split(R.sep),j=v.length-1,V=O.length-1;let Q,G;for(let U=0;;U++){if(Q=j===U,G=V===U,Q&&G)return T(v[U],O[U],w);if(Q)return-1;if(G)return 1;const P=l(v[U],O[U],w);if(P!==0)return P}}e.comparePaths=u;function b(n,h,w){const v=n.toLowerCase(),O=h.toLowerCase(),j=i(n,h,w);if(j)return j;const V=v.endsWith(w),Q=O.endsWith(w);if(V!==Q)return V?-1:1;const G=T(v,O);return G!==0?G:v.localeCompare(O)}e.compareAnything=b;function i(n,h,w){const v=n.toLowerCase(),O=h.toLowerCase(),j=v.startsWith(w),V=O.startsWith(w);if(j!==V)return j?-1:1;if(j&&V){if(v.length<O.length)return-1;if(v.length>O.length)return 1}return 0}e.compareByPrefix=i}),define(De[87],Ce([1,0,12]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},c={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(N){const A=(0,a.extname)(N),D=R[A.toLowerCase()];return D!==void 0?D:E(N)}e.getMediaOrTextMime=L;function E(N){const A=(0,a.extname)(N);return c[A.toLowerCase()]}e.getMediaMime=E;function T(N){for(const A in c)if(c[A]===N)return A}e.getExtensionForMimeType=T;const S=/^(.+)\/(.+?)(;.+)?$/;function I(N,A){const D=S.exec(N);return D?`${D[1].toLowerCase()}/${D[2].toLowerCase()}${D[3]??""}`:A?void 0:N}e.normalizeMimeType=I}),define(De[109],Ce([1,0,11]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var c;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(c=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(T,...S){const I=S.reduce((D,k)=>(D[k]=!0,D),{}),N=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(D=>!I[D]).forEach(D=>{for(let k=0;k<N.length;k++)if(D.search(N[k])!==-1){delete T[D];break}})}e.sanitizeProcessEnvironment=L;function E(T){!T||(delete T.DEBUG,a.isMacintosh&&delete T.DYLD_LIBRARY_PATH,a.isLinux&&delete T.LD_PRELOAD)}e.removeDangerousEnvVariables=E}),define(De[43],Ce([1,0,11]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=a.globals.performance&&typeof a.globals.performance.now=="function";class c{static create(E=!0){return new c(E)}constructor(E){this.a=R&&E,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?a.globals.performance.now():Date.now()}}e.StopWatch=c}),define(De[3],Ce([1,0,10,63,6,66,43]),function(ie,e,a,R,c,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const T=!1,S=!1;var I;(function(b){b.None=()=>c.Disposable.None;function i(pe){if(S){const{onDidAddListener:Se}=pe,Re=C.create();let re=0;pe.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Re.print()),Se?.()}}}function n(pe,Se){return U(pe,()=>{},0,void 0,!0,void 0,Se)}b.defer=n;function h(pe){return(Se,Re=null,re)=>{let le=!1,de;return de=pe(te=>{if(!le)return de?de.dispose():le=!0,Se.call(Re,te)},null,re),le&&de.dispose(),de}}b.once=h;function w(pe,Se,Re){return G((re,le=null,de)=>pe(te=>re.call(le,Se(te)),null,de),Re)}b.map=w;function v(pe,Se,Re){return G((re,le=null,de)=>pe(te=>{Se(te),re.call(le,te)},null,de),Re)}b.forEach=v;function O(pe,Se,Re){return G((re,le=null,de)=>pe(te=>Se(te)&&re.call(le,te),null,de),Re)}b.filter=O;function j(pe){return pe}b.signal=j;function V(...pe){return(Se,Re=null,re)=>(0,c.combinedDisposable)(...pe.map(le=>le(de=>Se.call(Re,de),null,re)))}b.any=V;function Q(pe,Se,Re,re){let le=Re;return w(pe,de=>(le=Se(le,de),le),re)}b.reduce=Q;function G(pe,Se){let Re;const re={onWillAddFirstListener(){Re=pe(le.fire,le)},onDidRemoveLastListener(){Re?.dispose()}};Se||i(re);const le=new o(re);return Se?.add(le),le.event}function U(pe,Se,Re=100,re=!1,le=!1,de,te){let ae,se,F,$=0,q;const J={leakWarningThreshold:de,onWillAddFirstListener(){ae=pe(we=>{$++,se=Se(se,we),re&&!F&&(ue.fire(se),se=void 0),q=()=>{const Ae=se;se=void 0,F=void 0,(!re||$>1)&&ue.fire(Ae),$=0},typeof Re=="number"?(clearTimeout(F),F=setTimeout(q,Re)):F===void 0&&(F=0,queueMicrotask(q))})},onWillRemoveListener(){le&&$>0&&q?.()},onDidRemoveLastListener(){q=void 0,ae.dispose()}};te||i(J);const ue=new o(J);return te?.add(ue),ue.event}b.debounce=U;function P(pe,Se=0,Re){return b.debounce(pe,(re,le)=>re?(re.push(le),re):[le],Se,void 0,!0,void 0,Re)}b.accumulate=P;function M(pe,Se=(re,le)=>re===le,Re){let re=!0,le;return O(pe,de=>{const te=re||!Se(de,le);return re=!1,le=de,te},Re)}b.latch=M;function B(pe,Se,Re){return[b.filter(pe,Se,Re),b.filter(pe,re=>!Se(re),Re)]}b.split=B;function Z(pe,Se=!1,Re=[]){let re=Re.slice(),le=pe(ae=>{re?re.push(ae):te.fire(ae)});const de=()=>{re?.forEach(ae=>te.fire(ae)),re=null},te=new o({onWillAddFirstListener(){le||(le=pe(ae=>te.fire(ae)))},onDidAddFirstListener(){re&&(Se?setTimeout(de):de())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return te.event}b.buffer=Z;class Y{constructor(Se){this.event=Se,this.c=new c.DisposableStore}map(Se){return new Y(w(this.event,Se,this.c))}forEach(Se){return new Y(v(this.event,Se,this.c))}filter(Se){return new Y(O(this.event,Se,this.c))}reduce(Se,Re){return new Y(Q(this.event,Se,Re,this.c))}latch(){return new Y(M(this.event,void 0,this.c))}debounce(Se,Re=100,re=!1,le=!1,de){return new Y(U(this.event,Se,Re,re,le,de,this.c))}on(Se,Re,re){return this.event(Se,Re,re)}once(Se,Re,re){return h(this.event)(Se,Re,re)}dispose(){this.c.dispose()}}function H(pe){return new Y(pe)}b.chain=H;function _(pe,Se,Re=re=>re){const re=(...ae)=>te.fire(Re(...ae)),le=()=>pe.on(Se,re),de=()=>pe.removeListener(Se,re),te=new o({onWillAddFirstListener:le,onDidRemoveLastListener:de});return te.event}b.fromNodeEventEmitter=_;function ee(pe,Se,Re=re=>re){const re=(...ae)=>te.fire(Re(...ae)),le=()=>pe.addEventListener(Se,re),de=()=>pe.removeEventListener(Se,re),te=new o({onWillAddFirstListener:le,onDidRemoveLastListener:de});return te.event}b.fromDOMEventEmitter=ee;function be(pe){return new Promise(Se=>h(pe)(Se))}b.toPromise=be;function ce(pe,Se){return Se(void 0),pe(Re=>Se(Re))}b.runAndSubscribe=ce;function oe(pe,Se){let Re=null;function re(de){Re?.dispose(),Re=new c.DisposableStore,Se(de,Re)}re(void 0);const le=pe(de=>re(de));return(0,c.toDisposable)(()=>{le.dispose(),Re?.dispose()})}b.runAndSubscribeWithStore=oe;class x{constructor(Se,Re){this.obs=Se,this.c=0,this.d=!1;const re={onWillAddFirstListener:()=>{Se.addObserver(this)},onDidRemoveLastListener:()=>{Se.removeObserver(this)}};Re||i(re),this.emitter=new o(re),Re&&Re.add(this.emitter)}beginUpdate(Se){this.c++}handleChange(Se,Re){this.d=!0}endUpdate(Se){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function he(pe,Se){return new x(pe,Se).emitter.event}b.fromObservable=he})(I=e.Event||(e.Event={}));class N{constructor(i){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${i}_${N.c++}`,N.all.add(this)}start(i){this.d=new E.StopWatch(!0),this.listenerCount=i}stop(){if(this.d){const i=this.d.elapsed();this.durations.push(i),this.elapsedOverall+=i,this.invocationCount+=1,this.d=void 0}}}N.all=new Set,N.c=0,e.EventProfiling=N;let A=-1;function D(b){const i=A;return A=b,{dispose(){A=i}}}e.setGlobalLeakWarningThreshold=D;class k{constructor(i,n=Math.random().toString(18).slice(2,5)){this.threshold=i,this.name=n,this.d=0}dispose(){this.c?.clear()}check(i,n){const h=this.threshold;if(h<=0||n<h)return;this.c||(this.c=new Map);const w=this.c.get(i.value)||0;if(this.c.set(i.value,w+1),this.d-=1,this.d<=0){this.d=h*.5;let v,O=0;for(const[j,V]of this.c)(!v||O<V)&&(v=j,O=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${n} listeners already. MOST frequent listener (${O}):`),console.warn(v)}return()=>{const v=this.c.get(i.value)||0;this.c.set(i.value,v-1)}}}class C{static create(){return new C(new Error().stack??"")}constructor(i){this.value=i}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class m{constructor(i,n,h){this.callback=i,this.callbackThis=n,this.stack=h,this.subscription=new c.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class o{constructor(i){this.j=!1,this.d=i,this.f=A>0||this.d?.leakWarningThreshold?new k(this.d?.leakWarningThreshold??A):void 0,this.g=this.d?._profName?new N(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(T){const i=Array.from(this.q);queueMicrotask(()=>{for(const n of i)n.subscription.isset()&&(n.subscription.unset(),n.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(i,n,h)=>{if(this.q||(this.q=new L.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),c.Disposable.None;const w=this.q.isEmpty();w&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let v,O;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(O=C.create(),v=this.f.check(O,this.q.size+1)),T&&(O=O??C.create());const j=new m(i,n,O),V=this.q.push(j);w&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,i,n);const Q=j.subscription.set(()=>{v?.(),this.j||(this.d?.onWillRemoveListener?.(this),V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return h instanceof c.DisposableStore?h.add(Q):Array.isArray(h)&&h.push(Q),Q}),this.l}fire(i){if(this.q){this.m||(this.m=new f);for(const n of this.q)this.m.push(this,n,i);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=o;class d{constructor(){this.c=new L.LinkedList}get size(){return this.c.size}push(i,n,h){this.c.push(new p(i,n,h))}clear(i){const n=new L.LinkedList;for(const h of this.c)h.emitter!==i&&n.push(h);this.c=n}deliver(){for(;this.c.size>0;){const i=this.c.shift();try{i.listener.invoke(i.event)}catch(n){(0,a.onUnexpectedError)(n)}}}}e.EventDeliveryQueue=d;class f extends d{clear(i){this.c.clear()}}class p{constructor(i,n,h){this.emitter=i,this.listener=n,this.event=h}}class y extends o{async fireAsync(i,n,h){if(!!this.q){this.c||(this.c=new L.LinkedList);for(const w of this.q)this.c.push([w,i]);for(;this.c.size>0&&!n.isCancellationRequested;){const[w,v]=this.c.shift(),O=[],j={...v,token:n,waitUntil:V=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");h&&(V=h(V,w.callback)),O.push(V)}};try{w.invoke(j)}catch(V){(0,a.onUnexpectedError)(V);continue}Object.freeze(O),await Promise.allSettled(O).then(V=>{for(const Q of V)Q.status==="rejected"&&(0,a.onUnexpectedError)(Q.reason)})}}}}e.AsyncEmitter=y;class g extends o{constructor(i){super(i),this.h=0,this.s=new L.LinkedList,this.t=i?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const i=Array.from(this.s);this.s.clear(),super.fire(this.t(i))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(i){this.q&&(this.h!==0?this.s.push(i):super.fire(i))}}e.PauseableEmitter=g;class t extends g{constructor(i){super(i),this.c=i.delay??100}fire(i){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(i)}}e.DebounceEmitter=t;class s extends o{constructor(i){super(i),this.c=[],this.h=i?.merge}fire(i){!this.hasListeners()||(this.c.push(i),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(n=>super.fire(n)),this.c=[]}))}}e.MicrotaskEmitter=s;class r{constructor(){this.d=!1,this.f=[],this.c=new o({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(i){const n={event:i,listener:null};this.f.push(n),this.d&&this.j(n);const h=()=>{this.d&&this.k(n);const w=this.f.indexOf(n);this.f.splice(w,1)};return(0,c.toDisposable)((0,R.once)(h))}g(){this.d=!0,this.f.forEach(i=>this.j(i))}h(){this.d=!1,this.f.forEach(i=>this.k(i))}j(i){i.listener=i.event(n=>this.c.fire(n))}k(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class l{constructor(){this.c=[]}wrapEvent(i){return(n,h,w)=>i(v=>{const O=this.c[this.c.length-1];O?O.push(()=>n.call(h,v)):n.call(h,v)},void 0,w)}bufferEvents(i){const n=[];this.c.push(n);const h=i();return this.c.pop(),n.forEach(w=>w()),h}}e.EventBufferer=l;class u{constructor(){this.c=!1,this.d=I.None,this.f=c.Disposable.None,this.g=new o({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(i){this.d=i,this.c&&(this.f.dispose(),this.f=i(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=u}),define(De[162],Ce([1,0,3,6,157]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class L extends R.Disposable{constructor(D,k="",C="",m=!0,o){super(),this.h=this.B(new a.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=D,this.m=k,this.u=C,this.w=m,this.C=o}get id(){return this.j}get label(){return this.m}set label(D){this.D(D)}D(D){this.m!==D&&(this.m=D,this.h.fire({label:D}))}get tooltip(){return this.n||""}set tooltip(D){this.F(D)}F(D){this.n!==D&&(this.n=D,this.h.fire({tooltip:D}))}get class(){return this.u}set class(D){this.G(D)}G(D){this.u!==D&&(this.u=D,this.h.fire({class:D}))}get enabled(){return this.w}set enabled(D){this.H(D)}H(D){this.w!==D&&(this.w=D,this.h.fire({enabled:D}))}get checked(){return this.z}set checked(D){this.I(D)}I(D){this.z!==D&&(this.z=D,this.h.fire({checked:D}))}async run(D,k){this.C&&await this.C(D)}}e.Action=L;class E extends R.Disposable{constructor(){super(...arguments),this.f=this.B(new a.Emitter),this.onWillRun=this.f.event,this.h=this.B(new a.Emitter),this.onDidRun=this.h.event}async run(D,k){if(!D.enabled)return;this.f.fire({action:D});let C;try{await this.runAction(D,k)}catch(m){C=m}this.h.fire({action:D,error:C})}async runAction(D,k){await D.run(k)}}e.ActionRunner=E;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...D){let k=[];for(const C of D)C.length&&(k.length?k=[...k,new T,...C]:k=C);return k}async run(){}}T.ID="vs.actions.separator",e.Separator=T;class S{get actions(){return this.a}constructor(D,k,C,m){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=D,this.label=k,this.class=m,this.a=C}async run(){}}e.SubmenuAction=S;class I extends L{constructor(){super(I.ID,c.localize(0,null),void 0,!1)}}I.ID="vs.actions.empty",e.EmptySubmenuAction=I;function N(A){return{id:A.id,label:A.label,class:void 0,enabled:A.enabled??!0,checked:A.checked??!1,run:async()=>A.run(),tooltip:A.label}}e.toAction=N}),define(De[21],Ce([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(T,S){const I=setTimeout(T.bind(S),0);return{dispose(){clearTimeout(I)}}});var c;(function(T){function S(I){return I===T.None||I===T.Cancelled||I instanceof L?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}T.isCancellationToken=S,T.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),T.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(c=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new a.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class E{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new L),this.a}cancel(){this.a?this.a instanceof L&&this.a.cancel():this.a=c.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof L&&this.a.dispose():this.a=c.None}}e.CancellationTokenSource=E}),define(De[163],Ce([1,0,21]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class R{constructor(T){this.b=T,this.a=null}get(){if(this.a)return this.a;const T=new a.CancellationTokenSource,S=this.b(T.token);return this.a={promise:S,dispose:()=>{this.a=null,T.cancel(),T.dispose()}},this.a}}e.Cache=R;class c{constructor(T){this.c=T,this.a=void 0,this.b=void 0}get(T){const S=JSON.stringify(T);return this.b!==S&&(this.b=S,this.a=this.c(T)),this.a}}e.LRUCachedFunction=c;class L{get cachedValues(){return this.a}constructor(T){this.b=T,this.a=new Map}get(T){if(this.a.has(T))return this.a.get(T);const S=this.b(T);return this.a.set(T,S),S}}e.CachedFunction=L}),define(De[8],Ce([1,0,163,65]),function(ie,e,a,R){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=L;const E=/{(\d+)}/g;function T(z,...X){return X.length===0?z:z.replace(E,function(fe,Le){const Ne=parseInt(Le,10);return isNaN(Ne)||Ne<0||Ne>=X.length?fe:X[Ne]})}e.format=T;const S=/{([^}]+)}/g;function I(z,X){return z.replace(S,(fe,Le)=>X[Le]??fe)}e.format2=I;function N(z){return z.replace(/[<>&]/g,function(X){switch(X){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return X}})}e.escape=N;function A(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=A;function D(z,X){let fe=0;const Le=X.charCodeAt(0);for(let Ne=z.length-1;Ne>=0;Ne--)z.charCodeAt(Ne)===Le&&fe++;return fe}e.count=D;function k(z,X,fe="\u2026"){return z.length<=X?z:`${z.substr(0,X)}${fe}`}e.truncate=k;function C(z,X=" "){const fe=m(z,X);return o(fe,X)}e.trim=C;function m(z,X){if(!z||!X)return z;const fe=X.length;if(fe===0||z.length===0)return z;let Le=0;for(;z.indexOf(X,Le)===Le;)Le=Le+fe;return z.substring(Le)}e.ltrim=m;function o(z,X){if(!z||!X)return z;const fe=X.length,Le=z.length;if(fe===0||Le===0)return z;let Ne=Le,je=-1;for(;je=z.lastIndexOf(X,Ne-1),!(je===-1||je+fe!==Ne);){if(je===0)return"";Ne=je}return z.substring(0,Ne)}e.rtrim=o;function d(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function f(z){return z.replace(/\*/g,"")}e.stripWildcards=f;function p(z,X,fe={}){if(!z)throw new Error("Cannot create regex from empty string");X||(z=A(z)),fe.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let Le="";return fe.global&&(Le+="g"),fe.matchCase||(Le+="i"),fe.multiline&&(Le+="m"),fe.unicode&&(Le+="u"),new RegExp(z,Le)}e.createRegExp=p;function y(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=y;function g(z){return!!z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function t(z){return(z.global?"g":"")+(z.ignoreCase?"i":"")+(z.multiline?"m":"")+(z.unicode?"u":"")}e.regExpFlags=t;function s(z){return z.split(/\r\n|\r|\n/)}e.splitLines=s;function r(z){for(let X=0,fe=z.length;X<fe;X++){const Le=z.charCodeAt(X);if(Le!==32&&Le!==9)return X}return-1}e.firstNonWhitespaceIndex=r;function l(z,X=0,fe=z.length){for(let Le=X;Le<fe;Le++){const Ne=z.charCodeAt(Le);if(Ne!==32&&Ne!==9)return z.substring(X,Le)}return z.substring(X,fe)}e.getLeadingWhitespace=l;function u(z,X=z.length-1){for(let fe=X;fe>=0;fe--){const Le=z.charCodeAt(fe);if(Le!==32&&Le!==9)return fe}return-1}e.lastNonWhitespaceIndex=u;function b(z,X,fe){const Le=[];let Ne=0;for(const je of z.matchAll(X)){if(Le.push(z.slice(Ne,je.index)),je.index===void 0)throw new Error("match.index should be defined");Ne=je.index+je[0].length,Le.push(fe(je[0],...je.slice(1),je.index,z,je.groups))}return Le.push(z.slice(Ne)),Promise.all(Le).then(je=>je.join(""))}e.replaceAsync=b;function i(z,X){return z<X?-1:z>X?1:0}e.compare=i;function n(z,X,fe=0,Le=z.length,Ne=0,je=X.length){for(;fe<Le&&Ne<je;fe++,Ne++){const st=z.charCodeAt(fe),at=X.charCodeAt(Ne);if(st<at)return-1;if(st>at)return 1}const _e=Le-fe,Xe=je-Ne;return _e<Xe?-1:_e>Xe?1:0}e.compareSubstring=n;function h(z,X){return w(z,X,0,z.length,0,X.length)}e.compareIgnoreCase=h;function w(z,X,fe=0,Le=z.length,Ne=0,je=X.length){for(;fe<Le&&Ne<je;fe++,Ne++){let st=z.charCodeAt(fe),at=X.charCodeAt(Ne);if(st===at)continue;if(st>=128||at>=128)return n(z.toLowerCase(),X.toLowerCase(),fe,Le,Ne,je);O(st)&&(st-=32),O(at)&&(at-=32);const mt=st-at;if(mt!==0)return mt}const _e=Le-fe,Xe=je-Ne;return _e<Xe?-1:_e>Xe?1:0}e.compareSubstringIgnoreCase=w;function v(z){return z>=48&&z<=57}e.isAsciiDigit=v;function O(z){return z>=97&&z<=122}e.isLowerAsciiLetter=O;function j(z){return z>=65&&z<=90}e.isUpperAsciiLetter=j;function V(z,X){return z.length===X.length&&w(z,X)===0}e.equalsIgnoreCase=V;function Q(z,X){const fe=X.length;return X.length>z.length?!1:w(z,X,0,fe)===0}e.startsWithIgnoreCase=Q;function G(z,X){const fe=Math.min(z.length,X.length);let Le;for(Le=0;Le<fe;Le++)if(z.charCodeAt(Le)!==X.charCodeAt(Le))return Le;return fe}e.commonPrefixLength=G;function U(z,X){const fe=Math.min(z.length,X.length);let Le;const Ne=z.length-1,je=X.length-1;for(Le=0;Le<fe;Le++)if(z.charCodeAt(Ne-Le)!==X.charCodeAt(je-Le))return Le;return fe}e.commonSuffixLength=U;function P(z){return 55296<=z&&z<=56319}e.isHighSurrogate=P;function M(z){return 56320<=z&&z<=57343}e.isLowSurrogate=M;function B(z,X){return(z-55296<<10)+(X-56320)+65536}e.computeCodePoint=B;function Z(z,X,fe){const Le=z.charCodeAt(fe);if(P(Le)&&fe+1<X){const Ne=z.charCodeAt(fe+1);if(M(Ne))return B(Le,Ne)}return Le}e.getNextCodePoint=Z;function Y(z,X){const fe=z.charCodeAt(X-1);if(M(fe)&&X>1){const Le=z.charCodeAt(X-2);if(P(Le))return B(Le,fe)}return fe}class H{get offset(){return this.e}constructor(X,fe=0){this.c=X,this.d=X.length,this.e=fe}setOffset(X){this.e=X}prevCodePoint(){const X=Y(this.c,this.e);return this.e-=X>=65536?2:1,X}nextCodePoint(){const X=Z(this.c,this.d,this.e);return this.e+=X>=65536?2:1,X}eol(){return this.e>=this.d}}e.CodePointIterator=H;class _{get offset(){return this.c.offset}constructor(X,fe=0){this.c=new H(X,fe)}nextGraphemeLength(){const X=He.getInstance(),fe=this.c,Le=fe.offset;let Ne=X.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const je=fe.offset,_e=X.getGraphemeBreakType(fe.nextCodePoint());if(Ie(Ne,_e)){fe.setOffset(je);break}Ne=_e}return fe.offset-Le}prevGraphemeLength(){const X=He.getInstance(),fe=this.c,Le=fe.offset;let Ne=X.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const je=fe.offset,_e=X.getGraphemeBreakType(fe.prevCodePoint());if(Ie(_e,Ne)){fe.setOffset(je);break}Ne=_e}return Le-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=_;function ee(z,X){return new _(z,X).nextGraphemeLength()}e.nextCharLength=ee;function be(z,X){return new _(z,X).prevGraphemeLength()}e.prevCharLength=be;function ce(z,X){X>0&&M(z.charCodeAt(X))&&X--;const fe=X+ee(z,X);return[fe-be(z,fe),fe]}e.getCharContainingOffset=ce;function oe(z){const X=new _(z);let fe=0;for(;!X.eol();)fe++,X.nextGraphemeLength();return fe}e.charCount=oe;let x;function he(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function pe(z){return x||(x=he()),x.test(z)}e.containsRTL=pe;const Se=/^[\t\n\r\x20-\x7E]*$/;function Re(z){return Se.test(z)}e.isBasicASCII=Re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function re(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=re;function le(z){return z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=le;function de(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129008||z>=129280&&z<=129535||z>=129648&&z<=129782}e.isEmojiImprecise=de;function te(z,X){if(z.length<X)return z;const fe=/\b/g;let Le=0;for(;fe.test(z)&&!(z.length-fe.lastIndex<X);)Le=fe.lastIndex,fe.lastIndex+=1;return z.substring(Le).replace(/^\s/,"")}e.lcut=te;const ae=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function se(z){return z&&(z=z.replace(ae,"")),z}e.removeAnsiEscapeCodes=se,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function F(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=F;function $(z){return F(z)?z.substr(1):z}e.stripUTF8BOM=$;function q(z,X){if(!z||!X||z.length<X.length)return!1;const fe=X.length,Le=z.toLowerCase();let Ne=0,je=-1;for(;Ne<fe;){const _e=Le.indexOf(X[Ne],je+1);if(_e<0)return!1;je=_e,Ne++}return!0}e.fuzzyContains=q;function J(z,X=!1){return z?(X&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=J;function ue(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=ue;function we(z,X=1){if(X===0)return"";let fe=-1;do fe=z.indexOf(`
`,fe+1),X--;while(X>0&&fe>=0);return fe===-1?z:(z[fe-1]==="\r"&&fe--,z.substr(0,fe))}e.getNLines=we;function Ae(z){return z=z%(2*26),z<26?String.fromCharCode(97+z):String.fromCharCode(65+z-26)}e.singleLetterHash=Ae;function ve(z){return He.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=ve;function Ie(z,X){return z===0?X!==5&&X!==7:z===2&&X===3?!1:z===4||z===2||z===3||X===4||X===2||X===3?!0:!(z===8&&(X===8||X===9||X===11||X===12)||(z===11||z===9)&&(X===9||X===10)||(z===12||z===10)&&X===10||X===5||X===13||X===7||z===1||z===13&&X===14||z===6&&X===6)}var ke;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(ke=e.GraphemeBreakType||(e.GraphemeBreakType={}));class He{static getInstance(){return He.c||(He.c=new He),He.c}constructor(){this.d=qe()}getGraphemeBreakType(X){if(X<32)return X===10?3:X===13?2:4;if(X<127)return 0;const fe=this.d,Le=fe.length/3;let Ne=1;for(;Ne<=Le;)if(X<fe[3*Ne])Ne=2*Ne;else if(X>fe[3*Ne+1])Ne=2*Ne+1;else return fe[3*Ne+2];return 0}}He.c=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt(z,X){if(z===0)return 0;const fe=Qe(z,X);if(fe!==void 0)return fe;const Le=new H(X,z);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function Qe(z,X){const fe=new H(X,z);let Le=fe.prevCodePoint();for(;tt(Le)||Le===65039||Le===8419;){if(fe.offset===0)return;Le=fe.prevCodePoint()}if(!de(Le))return;let Ne=fe.offset;return Ne>0&&fe.prevCodePoint()===8205&&(Ne=fe.offset),Ne}function tt(z){return 127995<=z&&z<=127999}var rt;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(X){return Be.d.get(Array.from(X))}static getLocales(){return Be.e.value}constructor(X){this.f=X}isAmbiguous(X){return this.f.has(X)}getPrimaryConfusable(X){return this.f.get(X)}getConfusableCodePoints(){return new Set(this.f.keys())}}c=Be,Be.c=new R.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.d=new a.LRUCachedFunction(z=>{function X(at){const mt=new Map;for(let gt=0;gt<at.length;gt+=2)mt.set(at[gt],at[gt+1]);return mt}function fe(at,mt){const gt=new Map(at);for(const[Et,Lt]of mt)gt.set(Et,Lt);return gt}function Le(at,mt){if(!at)return mt;const gt=new Map;for(const[Et,Lt]of at)mt.has(Et)&&gt.set(Et,Lt);return gt}const Ne=c.c.value;let je=z.filter(at=>!at.startsWith("_")&&at in Ne);je.length===0&&(je=["_default"]);let _e;for(const at of je){const mt=X(Ne[at]);_e=Le(_e,mt)}const Xe=X(Ne._common),st=fe(Xe,_e);return new Be(st)}),Be.e=new R.Lazy(()=>Object.keys(Be.c.value).filter(z=>!z.startsWith("_"))),e.AmbiguousCharacters=Be;class it{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(it.c())),this.d}static isInvisibleCharacter(X){return it.e().has(X)}static get codePoints(){return it.e()}}it.d=void 0,e.InvisibleCharacters=it}),define(De[33],Ce([1,0,12,11,8,9]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(u){return u===47||u===92}e.isPathSeparator=E;function T(u){return u.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=T;function S(u){return u.indexOf("/")===-1&&(u=T(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.toPosixPath=S;function I(u,b=a.posix.sep){if(!u)return"";const i=u.length,n=u.charCodeAt(0);if(E(n)){if(E(u.charCodeAt(1))&&!E(u.charCodeAt(2))){let w=3;const v=w;for(;w<i&&!E(u.charCodeAt(w));w++);if(v!==w&&!E(u.charCodeAt(w+1))){for(w+=1;w<i;w++)if(E(u.charCodeAt(w)))return u.slice(0,w+1).replace(/[\\/]/g,b)}}return b}else if(d(n)&&u.charCodeAt(1)===58)return E(u.charCodeAt(2))?u.slice(0,2)+b:u.slice(0,2);let h=u.indexOf("://");if(h!==-1){for(h+=3;h<i;h++)if(E(u.charCodeAt(h)))return u.slice(0,h+1)}return""}e.getRoot=I;function N(u){if(!R.isWindows||!u||u.length<5)return!1;let b=u.charCodeAt(0);if(b!==92||(b=u.charCodeAt(1),b!==92))return!1;let i=2;const n=i;for(;i<u.length&&(b=u.charCodeAt(i),b!==92);i++);return!(n===i||(b=u.charCodeAt(i+1),isNaN(b)||b===92))}e.isUNC=N;const A=/[\\/:\*\?"<>\|]/g,D=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function C(u,b=R.isWindows){const i=b?A:D;return!(!u||u.length===0||/^\s+$/.test(u)||(i.lastIndex=0,i.test(u))||b&&k.test(u)||u==="."||u===".."||b&&u[u.length-1]==="."||b&&u.length!==u.trim().length||u.length>255)}e.isValidBasename=C;function m(u,b,i){const n=u===b;return!i||n?n:!u||!b?!1:(0,c.equalsIgnoreCase)(u,b)}e.isEqual=m;function o(u,b,i,n=a.sep){if(u===b)return!0;if(!u||!b||b.length>u.length)return!1;if(i){if(!(0,c.startsWithIgnoreCase)(u,b))return!1;if(b.length===u.length)return!0;let w=b.length;return b.charAt(b.length-1)===n&&w--,u.charAt(w)===n}return b.charAt(b.length-1)!==n&&(b+=n),u.indexOf(b)===0}e.isEqualOrParent=o;function d(u){return u>=65&&u<=90||u>=97&&u<=122}e.isWindowsDriveLetter=d;function f(u,b){return R.isWindows&&u.endsWith(":")&&(u+=a.sep),(0,a.isAbsolute)(u)||(u=(0,a.join)(b,u)),u=(0,a.normalize)(u),R.isWindows?(u=(0,c.rtrim)(u,a.sep),u.endsWith(":")&&(u+=a.sep)):(u=(0,c.rtrim)(u,a.sep),u||(u=a.sep)),u}e.sanitizeFilePath=f;function p(u){const b=(0,a.normalize)(u);return R.isWindows?u.length>3?!1:y(b)&&(u.length===2||b.charCodeAt(2)===92):b===a.posix.sep}e.isRootOrDriveLetter=p;function y(u,b=R.isWindows){return b?d(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.hasDriveLetter=y;function g(u){return y(u)?u[0]:void 0}e.getDriveLetter=g;function t(u,b,i){return b.length>u.length?-1:u===b?0:(i&&(u=u.toLowerCase(),b=b.toLowerCase()),u.indexOf(b))}e.indexOfPath=t;function s(u){const b=u.split(":");let i,n,h;for(const w of b){const v=Number(w);(0,L.isNumber)(v)?n===void 0?n=v:h===void 0&&(h=v):i=i?[i,w].join(":"):w}if(!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:n!==void 0?n:void 0,column:h!==void 0?h:n!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(u,b,i=8){let n="";for(let w=0;w<i;w++)n+=r.charAt(Math.floor(Math.random()*r.length));let h;return b?h=`${b}-${n}`:h=n,u?(0,a.join)(u,h):h}e.randomPath=l}),define(De[110],Ce([1,0,28,8]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function c(...se){return function(F,$){for(let q=0,J=se.length;q<J;q++){const ue=se[q](F,$);if(ue)return ue}return null}}e.or=c,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(se,F,$){if(!$||$.length<F.length)return null;let q;return se?q=R.startsWithIgnoreCase($,F):q=$.indexOf(F)===0,q?F.length>0?[{start:0,end:F.length}]:[]:null}function E(se,F){const $=F.toLowerCase().indexOf(se.toLowerCase());return $===-1?null:[{start:$,end:$+se.length}]}e.matchesContiguousSubString=E;function T(se,F){return S(se.toLowerCase(),F.toLowerCase(),0,0)}e.matchesSubString=T;function S(se,F,$,q){if($===se.length)return[];if(q===F.length)return null;if(se[$]===F[q]){let J=null;return(J=S(se,F,$+1,q+1))?d({start:q,end:q+1},J):null}return S(se,F,$,q+1)}function I(se){return 97<=se&&se<=122}function N(se){return 65<=se&&se<=90}e.isUpper=N;function A(se){return 48<=se&&se<=57}function D(se){return se===32||se===9||se===10||se===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>k.add(se.charCodeAt(0)));function C(se){return D(se)||k.has(se)}function m(se,F){return se===F||C(se)&&C(F)}function o(se){return I(se)||N(se)||A(se)}function d(se,F){return F.length===0?F=[se]:se.end===F[0].start?F[0].start=se.start:F.unshift(se),F}function f(se,F){for(let $=F;$<se.length;$++){const q=se.charCodeAt($);if(N(q)||A(q)||$>0&&!o(se.charCodeAt($-1)))return $}return se.length}function p(se,F,$,q){if($===se.length)return[];if(q===F.length)return null;if(se[$]!==F[q].toLowerCase())return null;{let J=null,ue=q+1;for(J=p(se,F,$+1,q+1);!J&&(ue=f(F,ue))<F.length;)J=p(se,F,$+1,ue),ue++;return J===null?null:d({start:q,end:q+1},J)}}function y(se){let F=0,$=0,q=0,J=0,ue=0;for(let ke=0;ke<se.length;ke++)ue=se.charCodeAt(ke),N(ue)&&F++,I(ue)&&$++,o(ue)&&q++,A(ue)&&J++;const we=F/se.length,Ae=$/se.length,ve=q/se.length,Ie=J/se.length;return{upperPercent:we,lowerPercent:Ae,alphaPercent:ve,numericPercent:Ie}}function g(se){const{upperPercent:F,lowerPercent:$}=se;return $===0&&F>.6}function t(se){const{upperPercent:F,lowerPercent:$,alphaPercent:q,numericPercent:J}=se;return $>.2&&F<.8&&q>.6&&J<.2}function s(se){let F=0,$=0,q=0,J=0;for(let ue=0;ue<se.length;ue++)q=se.charCodeAt(ue),N(q)&&F++,I(q)&&$++,D(q)&&J++;return(F===0||$===0)&&J===0?se.length<=30:F<=5}function r(se,F){if(!F||(F=F.trim(),F.length===0)||!s(se)||F.length>60)return null;const $=y(F);if(!t($)){if(!g($))return null;F=F.toLowerCase()}let q=null,J=0;for(se=se.toLowerCase();J<F.length&&(q=p(se,F,0,J))===null;)J=f(F,J+1);return q}e.matchesCamelCase=r;function l(se,F,$=!1){if(!F||F.length===0)return null;let q=null,J=0;for(se=se.toLowerCase(),F=F.toLowerCase();J<F.length&&(q=u(se,F,0,J,$))===null;)J=b(F,J+1);return q}e.matchesWords=l;function u(se,F,$,q,J){if($===se.length)return[];if(q===F.length)return null;if(m(se.charCodeAt($),F.charCodeAt(q))){let ue=null,we=q+1;if(ue=u(se,F,$+1,q+1,J),!J)for(;!ue&&(we=b(F,we))<F.length;)ue=u(se,F,$+1,we,J),we++;return ue?se.charCodeAt($)!==F.charCodeAt(q)?ue:d({start:q,end:q+1},ue):null}else return null}function b(se,F){for(let $=F;$<se.length;$++)if(C(se.charCodeAt($))||$>0&&C(se.charCodeAt($-1)))return $;return se.length}const i=c(e.matchesPrefix,r,E),n=c(e.matchesPrefix,r,T),h=new a.LRUCache(1e4);function w(se,F,$=!1){if(typeof se!="string"||typeof F!="string")return null;let q=h.get(se);q||(q=new RegExp(R.convertSimple2RegExpPattern(se),"i"),h.set(se,q));const J=q.exec(F);return J?[{start:J.index,end:J.index+J[0].length}]:$?n(se,F):i(se,F)}e.matchesFuzzy=w;function v(se,F){const $=Se(se,se.toLowerCase(),0,F,F.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?j($):null}e.matchesFuzzy2=v;function O(se,F,$,q,J,ue){const we=Math.min(13,se.length);for(;$<we;$++){const Ae=Se(se,F,$,q,J,ue,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,ue]}e.anyScore=O;function j(se){if(typeof se>"u")return[];const F=[],$=se[1];for(let q=se.length-1;q>1;q--){const J=se[q]+$,ue=F[F.length-1];ue&&ue.end===J?ue.end=J+1:F.push({start:J,end:J+1})}return F}e.createMatches=j;const V=128;function Q(){const se=[],F=[];for(let $=0;$<=V;$++)F[$]=0;for(let $=0;$<=V;$++)se.push(F.slice(0));return se}function G(se){const F=[];for(let $=0;$<=se;$++)F[$]=0;return F}const U=G(2*V),P=G(2*V),M=Q(),B=Q(),Z=Q(),Y=!1;function H(se,F,$,q,J){function ue(Ae,ve,Ie=" "){for(;Ae.length<ve;)Ae=Ie+Ae;return Ae}let we=` |   |${q.split("").map(Ae=>ue(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=$;Ae++)Ae===0?we+=" |":we+=`${F[Ae-1]}|`,we+=se[Ae].slice(0,J+1).map(ve=>ue(ve.toString(),3)).join("|")+`
`;return we}function _(se,F,$,q){se=se.substr(F),$=$.substr(q),console.log(H(B,se,se.length,$,$.length)),console.log(H(Z,se,se.length,$,$.length)),console.log(H(M,se,se.length,$,$.length))}function ee(se,F){if(F<0||F>=se.length)return!1;const $=se.codePointAt(F);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise($)}}function be(se,F){if(F<0||F>=se.length)return!1;switch(se.charCodeAt(F)){case 32:case 9:return!0;default:return!1}}function ce(se,F,$){return F[se]!==$[se]}function oe(se,F,$,q,J,ue,we=!1){for(;F<$&&J<ue;)se[F]===q[J]&&(we&&(U[F]=J),F+=1),J+=1;return F===$}e.isPatternInWord=oe;var x;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(x||(x={}));var he;(function(se){se.Default=[-100,0];function F($){return!$||$.length===2&&$[0]===-100&&$[1]===0}se.isDefault=F})(he=e.FuzzyScore||(e.FuzzyScore={}));class pe{constructor(F,$){this.firstMatchCanBeWeak=F,this.boostFullMatch=$}}pe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=pe;function Se(se,F,$,q,J,ue,we=pe.default){const Ae=se.length>V?V:se.length,ve=q.length>V?V:q.length;if($>=Ae||ue>=ve||Ae-$>ve-ue||!oe(F,$,Ae,J,ue,ve,!0))return;Re(Ae,ve,$,ue,F,J);let Ie=1,ke=1,He=$,qe=ue;const nt=[!1];for(Ie=1,He=$;He<Ae;Ie++,He++){const it=U[He],z=P[He],X=He+1<Ae?P[He+1]:ve;for(ke=it-ue+1,qe=it;qe<X;ke++,qe++){let fe=Number.MIN_SAFE_INTEGER,Le=!1;qe<=z&&(fe=re(se,F,He,$,q,J,qe,ve,ue,M[Ie-1][ke-1]===0,nt));let Ne=0;fe!==Number.MAX_SAFE_INTEGER&&(Le=!0,Ne=fe+B[Ie-1][ke-1]);const je=qe>it,_e=je?B[Ie][ke-1]+(M[Ie][ke-1]>0?-5:0):0,Xe=qe>it+1&&M[Ie][ke-1]>0,st=Xe?B[Ie][ke-2]+(M[Ie][ke-2]>0?-5:0):0;if(Xe&&(!je||st>=_e)&&(!Le||st>=Ne))B[Ie][ke]=st,Z[Ie][ke]=3,M[Ie][ke]=0;else if(je&&(!Le||_e>=Ne))B[Ie][ke]=_e,Z[Ie][ke]=2,M[Ie][ke]=0;else if(Le)B[Ie][ke]=Ne,Z[Ie][ke]=1,M[Ie][ke]=M[Ie-1][ke-1]+1;else throw new Error("not possible")}}if(Y&&_(se,$,q,ue),!nt[0]&&!we.firstMatchCanBeWeak)return;Ie--,ke--;const Qe=[B[Ie][ke],ue];let tt=0,rt=0;for(;Ie>=1;){let it=ke;do{const z=Z[Ie][it];if(z===3)it=it-2;else if(z===2)it=it-1;else break}while(it>=1);tt>1&&F[$+Ie-1]===J[ue+ke-1]&&!ce(it+ue-1,q,J)&&tt+1>M[Ie][it]&&(it=ke),it===ke?tt++:tt=1,rt||(rt=it),Ie--,ke=it-1,Qe.push(ke)}ve===Ae&&we.boostFullMatch&&(Qe[0]+=2);const Be=rt-Ae;return Qe[0]-=Be,Qe}e.fuzzyScore=Se;function Re(se,F,$,q,J,ue){let we=se-1,Ae=F-1;for(;we>=$&&Ae>=q;)J[we]===ue[Ae]&&(P[we]=Ae,we--),Ae--}function re(se,F,$,q,J,ue,we,Ae,ve,Ie,ke){if(F[$]!==ue[we])return Number.MIN_SAFE_INTEGER;let He=1,qe=!1;return we===$-q?He=se[$]===J[we]?7:5:ce(we,J,ue)&&(we===0||!ce(we-1,J,ue))?(He=se[$]===J[we]?7:5,qe=!0):ee(ue,we)&&(we===0||!ee(ue,we-1))?He=5:(ee(ue,we-1)||be(ue,we-1))&&(He=5,qe=!0),He>1&&$===q&&(ke[0]=!0),qe||(qe=ce(we,J,ue)||ee(ue,we-1)||be(ue,we-1)),$===q?we>ve&&(He-=qe?3:5):Ie?He+=qe?2:0:He+=qe?0:1,we+1===Ae&&(He-=qe?3:5),He}function le(se,F,$,q,J,ue,we){return te(se,F,$,q,J,ue,!0,we)}e.fuzzyScoreGracefulAggressive=le;function de(se,F,$,q,J,ue,we){return te(se,F,$,q,J,ue,!1,we)}e.fuzzyScoreGraceful=de;function te(se,F,$,q,J,ue,we,Ae){let ve=Se(se,F,$,q,J,ue,Ae);if(ve&&!we)return ve;if(se.length>=3){const Ie=Math.min(7,se.length-1);for(let ke=$+1;ke<Ie;ke++){const He=ae(se,ke);if(He){const qe=Se(He,He.toLowerCase(),$,q,J,ue,Ae);qe&&(qe[0]-=3,(!ve||qe[0]>ve[0])&&(ve=qe))}}}return ve}function ae(se,F){if(F+1>=se.length)return;const $=se[F],q=se[F+1];if($!==q)return se.slice(0,F)+q+$+se.slice(F+2)}}),define(De[88],Ce([1,0,8]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(d){return c(d,0)}e.hash=R;function c(d,f){switch(typeof d){case"object":return d===null?L(349,f):Array.isArray(d)?S(d,f):I(d,f);case"string":return T(d,f);case"boolean":return E(d,f);case"number":return L(d,f);case"undefined":return L(937,f);default:return L(617,f)}}e.doHash=c;function L(d,f){return(f<<5)-f+d|0}e.numberHash=L;function E(d,f){return L(d?433:863,f)}function T(d,f){f=L(149417,f);for(let p=0,y=d.length;p<y;p++)f=L(d.charCodeAt(p),f);return f}e.stringHash=T;function S(d,f){return f=L(104579,f),d.reduce((p,y)=>c(y,p),f)}function I(d,f){return f=L(181387,f),Object.keys(d).sort().reduce((p,y)=>(p=T(y,p),c(d[y],p)),f)}class N{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=c(f,this.g),this.g}}e.Hasher=N;var A;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function D(d,f,p=32){const y=p-f,g=~((1<<y)-1);return(d<<f|(g&d)>>>y)>>>0}function k(d,f=0,p=d.byteLength,y=0){for(let g=0;g<p;g++)d[f+g]=y}function C(d,f,p="0"){for(;d.length<f;)d=p+d;return d}function m(d,f=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(p=>p.toString(16).padStart(2,"0")).join(""):C((d>>>0).toString(16),f/4)}e.toHexString=m;class o{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const p=f.length;if(p===0)return;const y=this.p;let g=this.r,t=this.u,s,r;for(t!==0?(s=t,r=-1,t=0):(s=f.charCodeAt(0),r=0);;){let l=s;if(a.isHighSurrogate(s))if(r+1<p){const u=f.charCodeAt(r+1);a.isLowSurrogate(u)?(r++,l=a.computeCodePoint(s,u)):l=65533}else{t=s;break}else a.isLowSurrogate(s)&&(l=65533);if(g=this.w(y,g,l),r++,r<p)s=f.charCodeAt(r);else break}this.r=g,this.u=t}w(f,p,y){return y<128?f[p++]=y:y<2048?(f[p++]=192|(y&1984)>>>6,f[p++]=128|(y&63)>>>0):y<65536?(f[p++]=224|(y&61440)>>>12,f[p++]=128|(y&4032)>>>6,f[p++]=128|(y&63)>>>0):(f[p++]=240|(y&1835008)>>>18,f[p++]=128|(y&258048)>>>12,f[p++]=128|(y&4032)>>>6,f[p++]=128|(y&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=o.g,p=this.q;for(let i=0;i<64;i+=4)f.setUint32(i,p.getUint32(i,!1),!1);for(let i=64;i<320;i+=4)f.setUint32(i,D(f.getUint32(i-12,!1)^f.getUint32(i-32,!1)^f.getUint32(i-56,!1)^f.getUint32(i-64,!1),1),!1);let y=this.h,g=this.l,t=this.m,s=this.n,r=this.o,l,u,b;for(let i=0;i<80;i++)i<20?(l=g&t|~g&s,u=1518500249):i<40?(l=g^t^s,u=1859775393):i<60?(l=g&t|g&s|t&s,u=2400959708):(l=g^t^s,u=3395469782),b=D(y,5)+l+r+u+f.getUint32(i*4,!1)&4294967295,r=s,s=t,t=D(g,30),g=y,y=b;this.h=this.h+y&4294967295,this.l=this.l+g&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+r&4294967295}}o.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=o}),define(De[111],Ce([1,0,108,110,88,12,11,8]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,I=[S,[]];function N(M,B,Z,Y){if(!M||!B)return I;const H=M.length,_=B.length;if(H<_)return I;const ee=M.toLowerCase();return A(B,Z,_,M,ee,H,Y)}e.scoreFuzzy=N;function A(M,B,Z,Y,H,_,ee){const be=[],ce=[];for(let pe=0;pe<Z;pe++){const Se=pe*_,Re=Se-_,re=pe>0,le=M[pe],de=B[pe];for(let te=0;te<_;te++){const ae=te>0,se=Se+te,F=se-1,$=Re+te-1,q=ae?be[F]:0,J=re&&ae?be[$]:0,ue=re&&ae?ce[$]:0;let we;!J&&re?we=0:we=D(le,de,Y,H,te,ue),we&&J+we>=q&&(ee||re||H.startsWith(B,te))?(ce[se]=ue+1,be[se]=J+we):(ce[se]=S,be[se]=q)}}const oe=[];let x=Z-1,he=_-1;for(;x>=0&&he>=0;){const pe=x*_+he;ce[pe]===S||(oe.push(he),x--),he--}return[be[Z*_-1],oe.reverse()]}function D(M,B,Z,Y,H,_){let ee=0;if(!k(B,Y[H]))return ee;if(ee+=1,_>0&&(ee+=_*5),M===Z[H]&&(ee+=1),H===0)ee+=8;else{const be=C(Z.charCodeAt(H-1));be?ee+=be:(0,R.isUpper)(Z.charCodeAt(H))&&_===0&&(ee+=2)}return ee}function k(M,B){return M===B?!0:M==="/"||M==="\\"?B==="/"||B==="\\":!1}function C(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const m=[void 0,[]];function o(M,B,Z=0,Y=0){const H=B;return H.values&&H.values.length>1?d(M,H.values,Z,Y):f(M,B,Z,Y)}e.scoreFuzzy2=o;function d(M,B,Z,Y){let H=0;const _=[];for(const ee of B){const[be,ce]=f(M,ee,Z,Y);if(typeof be!="number")return m;H+=be,_.push(...ce)}return[H,n(_)]}function f(M,B,Z,Y){const H=(0,R.fuzzyScore)(B.original,B.originalLowercase,Z,M,M.toLowerCase(),Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?[H[0],(0,R.createMatches)(H)]:m}const p=Object.freeze({score:0}),y=1<<18,g=1<<17,t=1<<16;function s(M,B,Z,Y){const H=Y.values?Y.values:[Y];return(0,c.hash)({[Y.normalized]:{values:H.map(ee=>({value:ee.normalized,expectContiguousMatch:ee.expectContiguousMatch})),label:M,description:B,allowNonContiguousMatches:Z}})}function r(M,B,Z,Y,H){if(!M||!B.normalized)return p;const _=Y.getItemLabel(M);if(!_)return p;const ee=Y.getItemDescription(M),be=s(_,ee,Z,B),ce=H[be];if(ce)return ce;const oe=l(_,ee,Y.getItemPath(M),B,Z);return H[be]=oe,oe}e.scoreItemFuzzy=r;function l(M,B,Z,Y,H){const _=!Z||!Y.containsPathSeparator;return Z&&(E.isLinux?Y.pathNormalized===Z:(0,T.equalsIgnoreCase)(Y.pathNormalized,Z))?{score:y,labelMatch:[{start:0,end:M.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:Y.values&&Y.values.length>1?u(M,B,Z,Y.values,_,H):b(M,B,Z,Y,_,H)}function u(M,B,Z,Y,H,_){let ee=0;const be=[],ce=[];for(const oe of Y){const{score:x,labelMatch:he,descriptionMatch:pe}=b(M,B,Z,oe,H,_);if(x===S)return p;ee+=x,he&&be.push(...he),pe&&ce.push(...pe)}return{score:ee,labelMatch:n(be),descriptionMatch:n(ce)}}function b(M,B,Z,Y,H,_){if(H||!B){const[ee,be]=N(M,Y.normalized,Y.normalizedLowercase,_&&!Y.expectContiguousMatch);if(ee){const ce=(0,R.matchesPrefix)(Y.normalized,M);let oe;return ce?(oe=g,oe+=Math.round(Y.normalized.length/M.length*100)):oe=t,{score:oe+ee,labelMatch:ce||i(be)}}}if(B){let ee=B;Z&&(ee=`${B}${L.sep}`);const be=ee.length,ce=`${ee}${M}`,[oe,x]=N(ce,Y.normalized,Y.normalizedLowercase,_&&!Y.expectContiguousMatch);if(oe){const he=i(x),pe=[],Se=[];return he.forEach(Re=>{Re.start<be&&Re.end>be?(pe.push({start:0,end:Re.end-be}),Se.push({start:Re.start,end:be})):Re.start>=be?pe.push({start:Re.start-be,end:Re.end-be}):Se.push(Re)}),{score:oe,labelMatch:pe,descriptionMatch:Se}}}return p}function i(M){const B=[];if(!M)return B;let Z;for(const Y of M)Z&&Z.end===Y?Z.end+=1:(Z={start:Y,end:Y+1},B.push(Z));return B}function n(M){const B=M.sort((H,_)=>H.start-_.start),Z=[];let Y;for(const H of B)!Y||!h(Y,H)?(Y=H,Z.push(H)):(Y.start=Math.min(Y.start,H.start),Y.end=Math.max(Y.end,H.end));return Z}function h(M,B){return!(M.end<B.start||B.end<M.start)}function w(M,B,Z,Y,H,_){const ee=r(M,Z,Y,H,_),be=r(B,Z,Y,H,_),ce=ee.score,oe=be.score;if((ce===y||oe===y)&&ce!==oe)return ce===y?-1:1;if(ce>t||oe>t){if(ce!==oe)return ce>oe?-1:1;if(ce<g&&oe<g){const le=O(ee.labelMatch,be.labelMatch);if(le!==0)return le}const Re=H.getItemLabel(M)||"",re=H.getItemLabel(B)||"";if(Re.length!==re.length)return Re.length-re.length}if(ce!==oe)return ce>oe?-1:1;const x=Array.isArray(ee.labelMatch)&&ee.labelMatch.length>0,he=Array.isArray(be.labelMatch)&&be.labelMatch.length>0;if(x&&!he)return-1;if(he&&!x)return 1;const pe=v(M,ee,H),Se=v(B,be,H);return pe&&Se&&pe!==Se?Se>pe?-1:1:j(M,B,Z,H)}e.compareItemsByFuzzyScore=w;function v(M,B,Z){let Y=-1,H=-1;if(B.descriptionMatch&&B.descriptionMatch.length?Y=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(Y=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(H=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const _=Z.getItemDescription(M);_&&(H+=_.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(H=B.descriptionMatch[B.descriptionMatch.length-1].end);return H-Y}function O(M,B){if(!M&&!B||(!M||!M.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!M||!M.length)return 1;const Z=M[0].start,H=M[M.length-1].end-Z,_=B[0].start,be=B[B.length-1].end-_;return H===be?0:be<H?1:-1}function j(M,B,Z,Y){const H=Y.getItemLabel(M)||"",_=Y.getItemLabel(B)||"",ee=Y.getItemDescription(M),be=Y.getItemDescription(B),ce=H.length+(ee?ee.length:0),oe=_.length+(be?be.length:0);if(ce!==oe)return ce-oe;const x=Y.getItemPath(M),he=Y.getItemPath(B);return x&&he&&x.length!==he.length?x.length-he.length:H!==_?(0,a.compareAnything)(H,_,Z.normalized):ee&&be&&ee!==be?(0,a.compareAnything)(ee,be,Z.normalized):x&&he&&x!==he?(0,a.compareAnything)(x,he,Z.normalized):0}function V(M){return M.startsWith('"')&&M.endsWith('"')}const Q=" ";function G(M){typeof M!="string"&&(M="");const B=M.toLowerCase(),{pathNormalized:Z,normalized:Y,normalizedLowercase:H}=U(M),_=Z.indexOf(L.sep)>=0,ee=V(M);let be;const ce=M.split(Q);if(ce.length>1)for(const oe of ce){const x=V(oe),{pathNormalized:he,normalized:pe,normalizedLowercase:Se}=U(oe);pe&&(be||(be=[]),be.push({original:oe,originalLowercase:oe.toLowerCase(),pathNormalized:he,normalized:pe,normalizedLowercase:Se,expectContiguousMatch:x}))}return{original:M,originalLowercase:B,pathNormalized:Z,normalized:Y,normalizedLowercase:H,values:be,containsPathSeparator:_,expectContiguousMatch:ee}}e.prepareQuery=G;function U(M){let B;E.isWindows?B=M.replace(/\//g,L.sep):B=M.replace(/\\/g,L.sep);const Z=(0,T.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:Z,normalizedLowercase:Z.toLowerCase()}}function P(M){return Array.isArray(M)?G(M.map(B=>B.original).join(Q)):G(M.original)}e.pieceToQuery=P}),define(De[164],Ce([1,0,110,8,52]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",E=new RegExp(`\\$\\(${c.ThemeIcon.iconNameExpression}(?:${c.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${E.source}`,"g");function S(d){return d.replace(T,(f,p)=>p?f:`\\${f}`)}e.escapeIcons=S;const I=new RegExp(`\\\\${E.source}`,"g");function N(d){return d.replace(I,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=N;const A=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function D(d){return d.indexOf(L)===-1?d:d.replace(A,(f,p,y,g)=>y?f:p||g||"")}e.stripIcons=D;function k(d){return d?d.replace(/\$\((.*?)\)/g,(f,p)=>` ${p} `).trim():""}e.getCodiconAriaLabel=k;const C=new RegExp(`\\$\\(${c.ThemeIcon.iconNameCharacter}+\\)`,"g");function m(d){C.lastIndex=0;let f="";const p=[];let y=0;for(;;){const g=C.lastIndex,t=C.exec(d),s=d.substring(g,t?.index);if(s.length>0){f+=s;for(let r=0;r<s.length;r++)p.push(y)}if(!t)break;y+=t[0].length}return{text:f,iconOffsets:p}}e.parseLabelWithIcons=m;function o(d,f,p=!1){const{text:y,iconOffsets:g}=f;if(!g||g.length===0)return(0,a.matchesFuzzy)(d,y,p);const t=(0,R.ltrim)(y," "),s=y.length-t.length,r=(0,a.matchesFuzzy)(d,t,p);if(r)for(const l of r){const u=g[l.start+s]+s;l.start+=u,l.end+=u}return r}e.matchesFuzzyIconAware=o}),define(De[37],Ce([1,0,8]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(c){c[c.Ignore=0]="Ignore",c[c.Info=1]="Info",c[c.Warning=2]="Warning",c[c.Error=3]="Error"})(R||(R={})),function(c){const L="error",E="warning",T="warn",S="info",I="ignore";function N(D){return D?a.equalsIgnoreCase(L,D)?c.Error:a.equalsIgnoreCase(E,D)||a.equalsIgnoreCase(T,D)?c.Warning:a.equalsIgnoreCase(S,D)?c.Info:c.Ignore:c.Ignore}c.fromValue=N;function A(D){switch(D){case c.Error:return L;case c.Warning:return E;case c.Info:return S;default:return I}}c.toString=A}(R||(R={})),e.default=R}),define(De[68],Ce([1,0,15,8]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class c{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const C=k.charCodeAt(0),m=this.b.charCodeAt(this.c);return C-m}value(){return this.b[this.c]}}e.StringIterator=c;class L{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,R.compareSubstring)(k,this.b,0,k.length,this.c,this.d):(0,R.compareSubstringIgnoreCase)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=L;class E{constructor(k=!0,C=!0){this.f=k,this.g=C}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let C=k.length-1;C>=0;C--,this.c--){const m=this.b.charCodeAt(C);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const C=this.b.charCodeAt(this.e);if(C===47||this.f&&C===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,R.compareSubstring)(k,this.b,0,k.length,this.d,this.e):(0,R.compareSubstringIgnoreCase)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=E;var T;(function(D){D[D.Scheme=1]="Scheme",D[D.Authority=2]="Authority",D[D.Path=3]="Path",D[D.Query=4]="Query",D[D.Fragment=5]="Fragment"})(T||(T={}));class S{constructor(k,C){this.f=k,this.g=C,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new E(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,R.compareIgnoreCase)(k,this.c.scheme);if(this.d[this.e]===2)return(0,R.compareIgnoreCase)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,R.compare)(k,this.c.query);if(this.d[this.e]===5)return(0,R.compare)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(D){D[D.Left=-1]="Left",D[D.Mid=0]="Mid",D[D.Right=1]="Right"})(N||(N={}));class A{static forUris(k=()=>!1,C=()=>!1){return new A(new S(k,C))}static forPaths(k=!1){return new A(new E(void 0,!k))}static forStrings(){return new A(new c)}static forConfigKeys(){return new A(new L)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,C){if(C){const m=C.slice(0);(0,a.shuffle)(m);for(const o of m)this.set(o,k)}else{const m=k.slice(0);(0,a.shuffle)(m);for(const o of m)this.set(o[0],o[1])}}set(k,C){const m=this.b.reset(k);let o;this.c||(this.c=new I,this.c.segment=m.value());const d=[];for(o=this.c;;){const p=m.cmp(o.segment);if(p>0)o.left||(o.left=new I,o.left.segment=m.value()),d.push([-1,o]),o=o.left;else if(p<0)o.right||(o.right=new I,o.right.segment=m.value()),d.push([1,o]),o=o.right;else if(m.hasNext())m.next(),o.mid||(o.mid=new I,o.mid.segment=m.value()),d.push([0,o]),o=o.mid;else break}const f=o.value;o.value=C,o.key=k;for(let p=d.length-1;p>=0;p--){const y=d[p][1];y.updateHeight();const g=y.balanceFactor();if(g<-1||g>1){const t=d[p][0],s=d[p+1][0];if(t===1&&s===1)d[p][1]=y.rotateLeft();else if(t===-1&&s===-1)d[p][1]=y.rotateRight();else if(t===1&&s===-1)y.right=d[p+1][1]=d[p+1][1].rotateRight(),d[p][1]=y.rotateLeft();else if(t===-1&&s===1)y.left=d[p+1][1]=d[p+1][1].rotateLeft(),d[p][1]=y.rotateRight();else throw new Error;if(p>0)switch(d[p-1][0]){case-1:d[p-1][1].left=d[p][1];break;case 1:d[p-1][1].right=d[p][1];break;case 0:d[p-1][1].mid=d[p][1];break}else this.c=d[0][1]}}return f}get(k){return this.d(k)?.value}d(k){const C=this.b.reset(k);let m=this.c;for(;m;){const o=C.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(C.hasNext())C.next(),m=m.mid;else break}return m}has(k){const C=this.d(k);return!(C?.value===void 0&&C?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,C){const m=this.b.reset(k),o=[];let d=this.c;for(;d;){const f=m.cmp(d.segment);if(f>0)o.push([-1,d]),d=d.left;else if(f<0)o.push([1,d]),d=d.right;else if(m.hasNext())m.next(),o.push([0,d]),d=d.mid;else break}if(!!d){if(C?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const f=this.f(d.right);if(f.key){const{key:p,value:y,segment:g}=f;this.e(f.key,!1),d.key=p,d.value=y,d.segment=g}}else{const f=d.left??d.right;if(o.length>0){const[p,y]=o[o.length-1];switch(p){case-1:y.left=f;break;case 0:y.mid=f;break;case 1:y.right=f;break}}else this.c=f}for(let f=o.length-1;f>=0;f--){const p=o[f][1];p.updateHeight();const y=p.balanceFactor();if(y>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),o[f][1]=p.rotateLeft()):y<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),o[f][1]=p.rotateRight()),f>0)switch(o[f-1][0]){case-1:o[f-1][1].left=o[f][1];break;case 1:o[f-1][1].right=o[f][1];break;case 0:o[f-1][1].mid=o[f][1];break}else this.c=o[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const C=this.b.reset(k);let m=this.c,o;for(;m;){const d=C.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(C.hasNext())C.next(),o=m.value||o,m=m.mid;else break}return m&&m.value||o}findSuperstr(k){return this.g(k,!1)}g(k,C){const m=this.b.reset(k);let o=this.c;for(;o;){const d=m.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(m.hasNext())m.next(),o=o.mid;else return o.mid?this.h(o.mid):C?o.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[C,m]of this)k(m,C)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const C=[];return this.j(k,C),C[Symbol.iterator]()}j(k,C){!k||(k.left&&this.j(k.left,C),k.value&&C.push([k.key,k.value]),k.mid&&this.j(k.mid,C),k.right&&this.j(k.right,C))}_isBalanced(){const k=C=>{if(!C)return!0;const m=C.balanceFactor();return m<-1||m>1?!1:k(C.left)&&k(C.right)};return k(this.c)}}e.TernarySearchTree=A}),define(De[2],Ce([1,0,12,11]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const c=/^\w[\w\d+.-]*$/,L=/^\//,E=/^\/\//;function T(r,l){if(!r.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!c.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!L.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(r,l){return!r&&!l?"file":r}function I(r,l){switch(r){case"https":case"http":case"file":l?l[0]!==A&&(l=A+l):l=A;break}return l}const N="",A="/",D=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(l){return l instanceof k?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,u,b,i,n,h=!1){typeof l=="object"?(this.scheme=l.scheme||N,this.authority=l.authority||N,this.path=l.path||N,this.query=l.query||N,this.fragment=l.fragment||N):(this.scheme=S(l,h),this.authority=u||N,this.path=I(this.scheme,b||N),this.query=i||N,this.fragment=n||N,T(this,h))}get fsPath(){return p(this,!1)}with(l){if(!l)return this;let{scheme:u,authority:b,path:i,query:n,fragment:h}=l;return u===void 0?u=this.scheme:u===null&&(u=N),b===void 0?b=this.authority:b===null&&(b=N),i===void 0?i=this.path:i===null&&(i=N),n===void 0?n=this.query:n===null&&(n=N),h===void 0?h=this.fragment:h===null&&(h=N),u===this.scheme&&b===this.authority&&i===this.path&&n===this.query&&h===this.fragment?this:new m(u,b,i,n,h)}static parse(l,u=!1){const b=D.exec(l);return b?new m(b[2]||N,s(b[4]||N),s(b[5]||N),s(b[7]||N),s(b[9]||N),u):new m(N,N,N,N,N)}static file(l){let u=N;if(R.isWindows&&(l=l.replace(/\\/g,A)),l[0]===A&&l[1]===A){const b=l.indexOf(A,2);b===-1?(u=l.substring(2),l=A):(u=l.substring(2,b),l=l.substring(b)||A)}return new m("file",u,l,N,N)}static from(l){const u=new m(l.scheme,l.authority,l.path,l.query,l.fragment);return T(u,!0),u}static joinPath(l,...u){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return R.isWindows&&l.scheme==="file"?b=k.file(a.win32.join(p(l,!0),...u)).path:b=a.posix.join(l.path,...u),l.with({path:b})}toString(l=!1){return y(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof k)return l;{const u=new m(l);return u._formatted=l.external,u._fsPath=l._sep===C?l.fsPath:null,u}}else return l}}e.URI=k;const C=R.isWindows?1:void 0;class m extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(l=!1){return l?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=C),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(r,l,u){let b,i=-1;for(let n=0;n<r.length;n++){const h=r.charCodeAt(n);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||l&&h===47||u&&h===91||u&&h===93||u&&h===58)i!==-1&&(b+=encodeURIComponent(r.substring(i,n)),i=-1),b!==void 0&&(b+=r.charAt(n));else{b===void 0&&(b=r.substr(0,n));const w=o[h];w!==void 0?(i!==-1&&(b+=encodeURIComponent(r.substring(i,n)),i=-1),b+=w):i===-1&&(i=n)}}return i!==-1&&(b+=encodeURIComponent(r.substring(i))),b!==void 0?b:r}function f(r){let l;for(let u=0;u<r.length;u++){const b=r.charCodeAt(u);b===35||b===63?(l===void 0&&(l=r.substr(0,u)),l+=o[b]):l!==void 0&&(l+=r[u])}return l!==void 0?l:r}function p(r,l){let u;return r.authority&&r.path.length>1&&r.scheme==="file"?u=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?l?u=r.path.substr(1):u=r.path[1].toLowerCase()+r.path.substr(2):u=r.path,R.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=p;function y(r,l){const u=l?f:d;let b="",{scheme:i,authority:n,path:h,query:w,fragment:v}=r;if(i&&(b+=i,b+=":"),(n||i==="file")&&(b+=A,b+=A),n){let O=n.indexOf("@");if(O!==-1){const j=n.substr(0,O);n=n.substr(O+1),O=j.lastIndexOf(":"),O===-1?b+=u(j,!1,!1):(b+=u(j.substr(0,O),!1,!1),b+=":",b+=u(j.substr(O+1),!1,!0)),b+="@"}n=n.toLowerCase(),O=n.lastIndexOf(":"),O===-1?b+=u(n,!1,!0):(b+=u(n.substr(0,O),!1,!0),b+=n.substr(O))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const O=h.charCodeAt(1);O>=65&&O<=90&&(h=`/${String.fromCharCode(O+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const O=h.charCodeAt(0);O>=65&&O<=90&&(h=`${String.fromCharCode(O+32)}:${h.substr(2)}`)}b+=u(h,!0,!1)}return w&&(b+="?",b+=u(w,!1,!1)),v&&(b+="#",b+=l?v:d(v,!1,!1)),b}function g(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+g(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,l=>g(l)):r}}),define(De[69],Ce([1,0,22,8,2]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(I){return JSON.stringify(I,T)}e.stringify=L;function E(I){let N=JSON.parse(I);return N=S(N),N}e.parse=E;function T(I,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,R.regExpFlags)(N)}:N}function S(I,N=0){if(!I||N>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return c.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 16:return new Date(I.source)}if(I instanceof a.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let A=0;A<I.length;++A)I[A]=S(I[A],N+1);else for(const A in I)Object.hasOwnProperty.call(I,A)&&(I[A]=S(I[A],N+1))}return I}e.revive=S}),define(De[16],Ce([1,0,10,11,2]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(N){this.d=N}setDelegate(N){this.e=N}setServerRootPath(N){this.f=`${N}/${L.vscodeRemoteResource}`}set(N,A,D){this.a[N]=A,this.b[N]=D}setConnectionToken(N,A){this.c[N]=A}getPreferredWebSchema(){return this.d}rewrite(N){if(this.e)try{return this.e(N)}catch(o){return a.onUnexpectedError(o),N}const A=N.authority;let D=this.a[A];D&&D.indexOf(":")!==-1&&D.indexOf("[")===-1&&(D=`[${D}]`);const k=this.b[A],C=this.c[A];let m=`path=${encodeURIComponent(N.path)}`;return typeof C=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(C)}`),c.URI.from({scheme:R.isWeb?this.d:L.vscodeRemoteResource,authority:`${D}:${k}`,path:this.f,query:m})}}e.RemoteAuthorities=new E,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class T{asBrowserUri(N){const A=this.b(N,ie);return this.uriToBrowserUri(A)}uriToBrowserUri(N){return N.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(N):N.scheme===L.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${L.vscodeFileResource}://${T.a}`)?N.with({scheme:L.vscodeFileResource,authority:N.authority||T.a,query:null,fragment:null}):N}asFileUri(N){const A=this.b(N,ie);return this.uriToFileUri(A)}uriToFileUri(N){return N.scheme===L.vscodeFileResource?N.with({scheme:L.file,authority:N.authority!==T.a?N.authority:null,query:null,fragment:null}):N}b(N,A){return c.URI.isUri(N)?N:c.URI.parse(A.toUrl(N))}}T.a="vscode-app",e.FileAccess=new T;var S;(function(I){const N=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(N.get("3"));const A="vscode-coi";function D(C){let m;typeof C=="string"?m=new URL(C).searchParams:C instanceof URL?m=C.searchParams:c.URI.isUri(C)&&(m=new URL(C.toString(!0)).searchParams);const o=m?.get(A);if(!!o)return N.get(o)}I.getHeadersFromQuery=D;function k(C,m,o){if(!globalThis.crossOriginIsolated)return;const d=m&&o?"3":o?"2":"1";C instanceof URLSearchParams?C.set(A,d):C[A]=d}I.addSearchParam=k})(S=e.COI||(e.COI={}))}),define(De[24],Ce([1,0,33,16,12,11,8,2]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(k){return(0,T.uriToFsPath)(k,!0)}e.originalFSPath=S;class I{constructor(C){this.a=C}compare(C,m,o=!1){return C===m?0:(0,E.compare)(this.getComparisonKey(C,o),this.getComparisonKey(m,o))}isEqual(C,m,o=!1){return C===m?!0:!C||!m?!1:this.getComparisonKey(C,o)===this.getComparisonKey(m,o)}getComparisonKey(C,m=!1){return C.with({path:this.a(C)?C.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(C){return this.a(C)}isEqualOrParent(C,m,o=!1){if(C.scheme===m.scheme){if(C.scheme===R.Schemas.file)return a.isEqualOrParent(S(C),S(m),this.a(C))&&C.query===m.query&&(o||C.fragment===m.fragment);if((0,e.isEqualAuthority)(C.authority,m.authority))return a.isEqualOrParent(C.path,m.path,this.a(C),"/")&&C.query===m.query&&(o||C.fragment===m.fragment)}return!1}joinPath(C,...m){return T.URI.joinPath(C,...m)}basenameOrAuthority(C){return(0,e.basename)(C)||C.authority}basename(C){return c.posix.basename(C.path)}extname(C){return c.posix.extname(C.path)}dirname(C){if(C.path.length===0)return C;let m;return C.scheme===R.Schemas.file?m=T.URI.file(c.dirname(S(C))).path:(m=c.posix.dirname(C.path),C.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${C.toString})) resulted in a relative path`),m="/")),C.with({path:m})}normalizePath(C){if(!C.path.length)return C;let m;return C.scheme===R.Schemas.file?m=T.URI.file(c.normalize(S(C))).path:m=c.posix.normalize(C.path),C.with({path:m})}relativePath(C,m){if(C.scheme!==m.scheme||!(0,e.isEqualAuthority)(C.authority,m.authority))return;if(C.scheme===R.Schemas.file){const f=c.relative(S(C),S(m));return L.isWindows?a.toSlashes(f):f}let o=C.path||"/";const d=m.path||"/";if(this.a(C)){let f=0;for(const p=Math.min(o.length,d.length);f<p&&!(o.charCodeAt(f)!==d.charCodeAt(f)&&o.charAt(f).toLowerCase()!==d.charAt(f).toLowerCase());f++);o=d.substr(0,f)+o.substr(f)}return c.posix.relative(o,d)}resolvePath(C,m){if(C.scheme===R.Schemas.file){const o=T.URI.file(c.resolve(S(C),m));return C.with({authority:o.authority,path:o.path})}return m=a.toPosixPath(m),C.with({path:c.posix.resolve(C.path,m)})}isAbsolutePath(C){return!!C.path&&C.path[0]==="/"}isEqualAuthority(C,m){return C===m||C!==void 0&&m!==void 0&&(0,E.equalsIgnoreCase)(C,m)}hasTrailingPathSeparator(C,m=c.sep){if(C.scheme===R.Schemas.file){const o=S(C);return o.length>a.getRoot(o).length&&o[o.length-1]===m}else{const o=C.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(C.fsPath)}}removeTrailingPathSeparator(C,m=c.sep){return(0,e.hasTrailingPathSeparator)(C,m)?C.with({path:C.path.substr(0,C.path.length-1)}):C}addTrailingPathSeparator(C,m=c.sep){let o=!1;if(C.scheme===R.Schemas.file){const d=S(C);o=d!==void 0&&d.length===a.getRoot(d).length&&d[d.length-1]===m}else{m="/";const d=C.path;o=d.length===1&&d.charCodeAt(d.length-1)===47}return!o&&!(0,e.hasTrailingPathSeparator)(C,m)?C.with({path:C.path+"/"}):C}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(k=>k.scheme===R.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new I(k=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(k,C){const m=[];for(let o=0;o<k.length;o++){const d=C(k[o]);k.some((f,p)=>p===o?!1:(0,e.isEqualOrParent)(d,C(f)))||m.push(k[o])}return m}e.distinctParents=N;var A;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function C(m){const o=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(p=>{const[y,g]=p.split(":");y&&g&&o.set(y,g)});const f=m.path.substring(0,m.path.indexOf(";"));return f&&o.set(k.META_DATA_MIME,f),o}k.parseMetaData=C})(A=e.DataUri||(e.DataUri={}));function D(k,C,m){if(C){let o=k.path;return o&&o[0]!==c.posix.sep&&(o=c.posix.sep+o),k.with({scheme:m,authority:C,path:o})}return k.with({scheme:m})}e.toLocalResource=D}),define(De[19],Ce([1,0,21,10,3,6,24,11,149]),function(ie,e,a,R,c,L,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(oe){return!!oe&&typeof oe.then=="function"}e.isThenable=I;function N(oe){const x=new a.CancellationTokenSource,he=oe(x.token),pe=new Promise((Se,Re)=>{const re=x.token.onCancellationRequested(()=>{re.dispose(),x.dispose(),Re(new R.CancellationError)});Promise.resolve(he).then(le=>{re.dispose(),x.dispose(),Se(le)},le=>{re.dispose(),x.dispose(),Re(le)})});return new class{cancel(){x.cancel()}then(Se,Re){return pe.then(Se,Re)}catch(Se){return this.then(void 0,Se)}finally(Se){return pe.finally(Se)}}}e.createCancelablePromise=N;function A(oe,x,he){return new Promise((pe,Se)=>{const Re=x.onCancellationRequested(()=>{Re.dispose(),pe(he)});oe.then(pe,Se).finally(()=>Re.dispose())})}e.raceCancellation=A;function D(oe,x){return new Promise((he,pe)=>{const Se=x.onCancellationRequested(()=>{Se.dispose(),pe(new R.CancellationError)});oe.then(he,pe).finally(()=>Se.dispose())})}e.raceCancellationError=D;async function k(oe){let x=-1;const he=oe.map((Se,Re)=>Se.then(re=>(x=Re,re))),pe=await Promise.race(he);return oe.forEach((Se,Re)=>{Re!==x&&Se.cancel()}),pe}e.raceCancellablePromises=k;function C(oe,x,he){let pe;const Se=setTimeout(()=>{pe?.(void 0),he?.()},x);return Promise.race([oe.finally(()=>clearTimeout(Se)),new Promise(Re=>pe=Re)])}e.raceTimeout=C;function m(oe){return new Promise((x,he)=>{const pe=oe();I(pe)?pe.then(x,he):x(pe)})}e.asPromise=m;class o{constructor(){this.a=null,this.b=null,this.d=null}queue(x){if(this.a){if(this.d=x,!this.b){const he=()=>{this.b=null;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(he,he).then(pe)})}return new Promise((he,pe)=>{this.b.then(he,pe)})}return this.a=x(),new Promise((he,pe)=>{this.a.then(Se=>{this.a=null,he(Se)},Se=>{this.a=null,pe(Se)})})}}e.Throttler=o;class d{constructor(){this.a=Promise.resolve(null)}queue(x){return this.a=this.a.then(()=>x(),()=>x())}}e.Sequencer=d;class f{constructor(){this.a=new Map}queue(x,he){const Se=(this.a.get(x)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.a.get(x)===Se&&this.a.delete(x)});return this.a.set(x,Se),Se}}e.SequencerByKey=f;const p=(oe,x)=>{let he=!0;const pe=setTimeout(()=>{he=!1,x()},oe);return{isTriggered:()=>he,dispose:()=>{clearTimeout(pe),he=!1}}},y=oe=>{let x=!0;return queueMicrotask(()=>{x&&(x=!1,oe())}),{isTriggered:()=>x,dispose:()=>{x=!1}}};class g{constructor(x){this.defaultDelay=x,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(x,he=this.defaultDelay){this.g=x,this.h(),this.b||(this.b=new Promise((Se,Re)=>{this.d=Se,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const Se=this.g;return this.g=null,Se()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=he===S.MicrotaskDelay?y(pe):p(he,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=g;class t{constructor(x){this.a=new g(x),this.b=new o}trigger(x,he){return this.a.trigger(()=>this.b.queue(x),he)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class s{constructor(){this.a=!1,this.b=new Promise((x,he)=>{this.d=x})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class r extends s{constructor(x){super(),this.f=setTimeout(()=>this.open(),x)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function l(oe,x){return x?new Promise((he,pe)=>{const Se=setTimeout(()=>{Re.dispose(),he()},oe),Re=x.onCancellationRequested(()=>{clearTimeout(Se),Re.dispose(),pe(new R.CancellationError)})}):N(he=>l(oe,he))}e.timeout=l;function u(oe,x=0){const he=setTimeout(oe,x);return(0,L.toDisposable)(()=>clearTimeout(he))}e.disposableTimeout=u;function b(oe){const x=[];let he=0;const pe=oe.length;function Se(){return he<pe?oe[he++]():null}function Re(re){re!=null&&x.push(re);const le=Se();return le?le.then(Re):Promise.resolve(x)}return Promise.resolve(null).then(Re)}e.sequence=b;function i(oe,x=pe=>!!pe,he=null){let pe=0;const Se=oe.length,Re=()=>{if(pe>=Se)return Promise.resolve(he);const re=oe[pe++];return Promise.resolve(re()).then(de=>x(de)?Promise.resolve(de):Re())};return Re()}e.first=i;function n(oe,x=pe=>!!pe,he=null){if(oe.length===0)return Promise.resolve(he);let pe=oe.length;const Se=()=>{pe=-1;for(const Re of oe)Re.cancel?.()};return new Promise((Re,re)=>{for(const le of oe)le.then(de=>{--pe>=0&&x(de)?(Se(),Re(de)):pe===0&&Re(he)}).catch(de=>{--pe>=0&&(Se(),re(de))})})}e.firstParallel=n;class h{constructor(x){this.a=0,this.d=x,this.f=[],this.b=0,this.g=new c.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(x){return this.a++,new Promise((he,pe)=>{this.f.push({factory:x,c:he,e:pe}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const x=this.f.shift();this.b++;const he=x.factory();he.then(x.c,x.e),he.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class w extends h{constructor(){super(1)}}e.Queue=w;class v{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const x=new Y;return this.b.add(x),x.p}d(){for(const[,x]of this.a)if(x.size>0)return!1;return!0}queueFor(x,he=E.extUri){const pe=he.getComparisonKey(x);let Se=this.a.get(pe);return Se||(Se=new w,c.Event.once(Se.onDrained)(()=>{Se?.dispose(),this.a.delete(pe),this.f()}),this.a.set(pe,Se)),Se}f(){!this.d()||this.g()}g(){for(const x of this.b)x.complete();this.b.clear()}dispose(){for(const[,x]of this.a)x.dispose();this.a.clear(),this.g()}}e.ResourceQueue=v;class O{constructor(x,he){this.a=-1,typeof x=="function"&&typeof he=="number"&&this.setIfNotSet(x,he)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(x,he){this.cancel(),this.a=setTimeout(()=>{this.a=-1,x()},he)}setIfNotSet(x,he){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,x()},he))}}e.TimeoutTimer=O;class j{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(x,he){this.cancel(),this.a=setInterval(()=>{x()},he)}}e.IntervalTimer=j;class V{constructor(x,he){this.b=-1,this.a=x,this.d=he,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(x=this.d){this.cancel(),this.b=setTimeout(this.f,x)}get delay(){return this.d}set delay(x){this.d=x}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=V;class Q{constructor(x,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.a=x,this.b=he,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(x=this.b){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(x/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=Q;class G extends V{constructor(x,he){super(x,he),this.j=[]}work(x){this.j.push(x),this.isScheduled()||this.schedule()}h(){const x=this.j;this.j=[],this.a?.(x)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=G;class U extends L.Disposable{constructor(x,he){super(),this.g=x,this.h=he,this.a=[],this.b=this.B(new L.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(x){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+x.length>this.g.maxBufferedWork)return!1}else if(this.pending+x.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const he of x)this.a.push(he);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=oe=>{(0,T.setTimeout0)(()=>{if(x)return;const he=Date.now()+15;oe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.runWhenIdle=(oe,x)=>{const he=requestIdleCallback(oe,typeof x=="number"?{timeout:x}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,cancelIdleCallback(he))}}}}();class P{constructor(x){this.d=!1,this.a=()=>{try{this.f=x()}catch(he){this.g=he}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=P;async function M(oe,x,he){let pe;for(let Se=0;Se<he;Se++)try{return await oe()}catch(Re){pe=Re,await l(x)}throw pe}e.retry=M;class B{hasPending(x){return this.a?typeof x=="number"?this.a.taskId===x:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(x,he,pe){return this.a={taskId:x,cancel:()=>pe?.(),promise:he},he.then(()=>this.d(x),()=>this.d(x)),he}d(x){this.a&&x===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const x=this.b;this.b=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this.b)this.b.run=x;else{let he,pe;const Se=new Promise((Re,re)=>{he=Re,pe=re});this.b={run:x,promise:Se,promiseResolve:he,promiseReject:pe}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=B;class Z{constructor(x,he=()=>Date.now()){this.d=x,this.f=he,this.a=0,this.b=0}increment(){const x=this.f();return x-this.a>this.d&&(this.a=x,this.b=0),this.b++,this.b}}e.IntervalCounter=Z;class Y{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((x,he)=>{this.a=x,this.b=he})}complete(x){return new Promise(he=>{this.a(x),this.f=!0,he()})}error(x){return new Promise(he=>{this.b(x),this.d=!0,he()})}cancel(){new Promise(x=>{this.b(new R.CancellationError),this.d=!0,x()})}}e.DeferredPromise=Y;var H;(function(oe){async function x(pe){let Se;const Re=await Promise.all(pe.map(re=>re.then(le=>le,le=>{Se||(Se=le)})));if(typeof Se<"u")throw Se;return Re}oe.settled=x;function he(pe){return new Promise(async(Se,Re)=>{try{await pe(Se,Re)}catch(re){Re(re)}})}oe.withAsyncBody=he})(H=e.Promises||(e.Promises={}));var _;(function(oe){oe[oe.Initial=0]="Initial",oe[oe.DoneOK=1]="DoneOK",oe[oe.DoneError=2]="DoneError"})(_||(_={}));class ee{static fromArray(x){return new ee(he=>{he.emitMany(x)})}static fromPromise(x){return new ee(async he=>{he.emitMany(await x)})}static fromPromises(x){return new ee(async he=>{await Promise.all(x.map(async pe=>he.emitOne(await pe)))})}static merge(x){return new ee(async he=>{await Promise.all(x.map(async pe=>{for await(const Se of pe)he.emitOne(Se)}))})}constructor(x){this.a=0,this.b=[],this.d=null,this.f=new c.Emitter,queueMicrotask(async()=>{const he={emitOne:pe=>this.g(pe),emitMany:pe=>this.h(pe),reject:pe=>this.k(pe)};try{await Promise.resolve(x(he)),this.j()}catch(pe){this.k(pe)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let x=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(x<this.b.length)return{done:!1,value:this.b[x++]};if(this.a===1)return{done:!0,value:void 0};await c.Event.toPromise(this.f.event)}while(!0)}}}static map(x,he){return new ee(async pe=>{for await(const Se of x)pe.emitOne(he(Se))})}map(x){return ee.map(this,x)}static filter(x,he){return new ee(async pe=>{for await(const Se of x)he(Se)&&pe.emitOne(Se)})}filter(x){return ee.filter(this,x)}static coalesce(x){return ee.filter(x,he=>!!he)}coalesce(){return ee.coalesce(this)}static async toPromise(x){const he=[];for await(const pe of x)he.push(pe);return he}toPromise(){return ee.toPromise(this)}g(x){this.a===0&&(this.b.push(x),this.f.fire())}h(x){this.a===0&&(this.b=this.b.concat(x),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(x){this.a===0&&(this.a=2,this.d=x,this.f.fire())}}ee.EMPTY=ee.fromArray([]),e.AsyncIterableObject=ee;class be extends ee{constructor(x,he){super(he),this.l=x}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=be;function ce(oe){const x=new a.CancellationTokenSource,he=oe(x.token);return new be(x,async pe=>{const Se=x.token.onCancellationRequested(()=>{Se.dispose(),x.dispose(),pe.reject(new R.CancellationError)});try{for await(const Re of he){if(x.token.isCancellationRequested)return;pe.emitOne(Re)}Se.dispose(),x.dispose()}catch(Re){Se.dispose(),x.dispose(),pe.reject(Re)}})}e.createCancelableAsyncIterable=ce}),define(De[38],Ce([1,0,15,19,33,28,12,11,8]),function(ie,e,a,R,c,L,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const N="[/\\\\]",A="[^/\\\\]",D=/\//g;function k(Z,Y){switch(Z){case 0:return"";case 1:return`${A}*?`;default:return`(?:${N}|${A}+${N}${Y?`|${N}${A}+`:""})*?`}}function C(Z,Y){if(!Z)return[];const H=[];let _=!1,ee=!1,be="";for(const ce of Z){switch(ce){case Y:if(!_&&!ee){H.push(be),be="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}be+=ce}return be&&H.push(be),H}e.splitGlobAware=C;function m(Z){if(!Z)return"";let Y="";const H=C(Z,e.GLOB_SPLIT);if(H.every(_=>_===e.GLOBSTAR))Y=".*";else{let _=!1;H.forEach((ee,be)=>{if(ee===e.GLOBSTAR){if(_)return;Y+=k(2,be===H.length-1)}else{let ce=!1,oe="",x=!1,he="";for(const pe of ee){if(pe!=="}"&&ce){oe+=pe;continue}if(x&&(pe!=="]"||!he)){let Se;pe==="-"?Se=pe:(pe==="^"||pe==="!")&&!he?Se="^":pe===e.GLOB_SPLIT?Se="":Se=(0,S.escapeRegExpCharacters)(pe),he+=Se;continue}switch(pe){case"{":ce=!0;continue;case"[":x=!0;continue;case"}":{Y+=`(?:${C(oe,",").map(re=>m(re)).join("|")})`,ce=!1,oe="";break}case"]":{Y+="["+he+"]",x=!1,he="";break}case"?":Y+=A;continue;case"*":Y+=k(1);continue;default:Y+=(0,S.escapeRegExpCharacters)(pe)}}be<H.length-1&&(H[be+1]!==e.GLOBSTAR||be+2<H.length)&&(Y+=N)}_=ee===e.GLOBSTAR})}return Y}const o=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),s=function(){return!1},r=function(){return null};function l(Z,Y){if(!Z)return r;let H;typeof Z!="string"?H=Z.pattern:H=Z,H=H.trim();const _=`${H}_${!!Y.trimForExclusions}`;let ee=t.get(_);if(ee)return u(ee,Z);let be;return o.test(H)?ee=i(H.substr(4),H):(be=d.exec(b(H,Y)))?ee=n(be[1],H):(Y.trimForExclusions?p:f).test(H)?ee=h(H,Y):(be=y.exec(b(H,Y)))?ee=w(be[1].substr(1),H,!0):(be=g.exec(b(H,Y)))?ee=w(be[1],H,!1):ee=v(H),t.set(_,ee),u(ee,Z)}function u(Z,Y){if(typeof Y=="string")return Z;const H=function(_,ee){return(0,c.isEqualOrParent)(_,Y.base,!T.isLinux)?Z((0,S.ltrim)(_.substr(Y.base.length),E.sep),ee):null};return H.allBasenames=Z.allBasenames,H.allPaths=Z.allPaths,H.basenames=Z.basenames,H.patterns=Z.patterns,H}function b(Z,Y){return Y.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function i(Z,Y){return function(H,_){return typeof H=="string"&&H.endsWith(Z)?Y:null}}function n(Z,Y){const H=`/${Z}`,_=`\\${Z}`,ee=function(ce,oe){return typeof ce!="string"?null:oe?oe===Z?Y:null:ce===Z||ce.endsWith(H)||ce.endsWith(_)?Y:null},be=[Z];return ee.basenames=be,ee.patterns=[Y],ee.allBasenames=be,ee}function h(Z,Y){const H=M(Z.slice(1,-1).split(",").map(oe=>l(oe,Y)).filter(oe=>oe!==r),Z),_=H.length;if(!_)return r;if(_===1)return H[0];const ee=function(oe,x){for(let he=0,pe=H.length;he<pe;he++)if(H[he](oe,x))return Z;return null},be=H.find(oe=>!!oe.allBasenames);be&&(ee.allBasenames=be.allBasenames);const ce=H.reduce((oe,x)=>x.allPaths?oe.concat(x.allPaths):oe,[]);return ce.length&&(ee.allPaths=ce),ee}function w(Z,Y,H){const _=E.sep===E.posix.sep,ee=_?Z:Z.replace(D,E.sep),be=E.sep+ee,ce=E.posix.sep+Z;let oe;return H?oe=function(x,he){return typeof x=="string"&&(x===ee||x.endsWith(be)||!_&&(x===Z||x.endsWith(ce)))?Y:null}:oe=function(x,he){return typeof x=="string"&&(x===ee||!_&&x===Z)?Y:null},oe.allPaths=[(H?"*/":"./")+Z],oe}function v(Z){try{const Y=new RegExp(`^${m(Z)}$`);return function(H){return Y.lastIndex=0,typeof H=="string"&&Y.test(H)?Z:null}}catch{return r}}function O(Z,Y,H){return!Z||typeof Y!="string"?!1:j(Z)(Y,void 0,H)}e.match=O;function j(Z,Y={}){if(!Z)return s;if(typeof Z=="string"||V(Z)){const H=l(Z,Y);if(H===r)return s;const _=function(ee,be){return!!H(ee,be)};return H.allBasenames&&(_.allBasenames=H.allBasenames),H.allPaths&&(_.allPaths=H.allPaths),_}return U(Z,Y)}e.parse=j;function V(Z){const Y=Z;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}e.isRelativePattern=V;function Q(Z){return Z.allBasenames||[]}e.getBasenameTerms=Q;function G(Z){return Z.allPaths||[]}e.getPathTerms=G;function U(Z,Y){const H=M(Object.getOwnPropertyNames(Z).map(oe=>P(oe,Z[oe],Y)).filter(oe=>oe!==r)),_=H.length;if(!_)return r;if(!H.some(oe=>!!oe.requiresSiblings)){if(_===1)return H[0];const oe=function(pe,Se){let Re;for(let re=0,le=H.length;re<le;re++){const de=H[re](pe,Se);if(typeof de=="string")return de;(0,R.isThenable)(de)&&(Re||(Re=[]),Re.push(de))}return Re?(async()=>{for(const re of Re){const le=await re;if(typeof le=="string")return le}return null})():null},x=H.find(pe=>!!pe.allBasenames);x&&(oe.allBasenames=x.allBasenames);const he=H.reduce((pe,Se)=>Se.allPaths?pe.concat(Se.allPaths):pe,[]);return he.length&&(oe.allPaths=he),oe}const ee=function(oe,x,he){let pe,Se;for(let Re=0,re=H.length;Re<re;Re++){const le=H[Re];le.requiresSiblings&&he&&(x||(x=(0,E.basename)(oe)),pe||(pe=x.substr(0,x.length-(0,E.extname)(oe).length)));const de=le(oe,x,pe,he);if(typeof de=="string")return de;(0,R.isThenable)(de)&&(Se||(Se=[]),Se.push(de))}return Se?(async()=>{for(const Re of Se){const re=await Re;if(typeof re=="string")return re}return null})():null},be=H.find(oe=>!!oe.allBasenames);be&&(ee.allBasenames=be.allBasenames);const ce=H.reduce((oe,x)=>x.allPaths?oe.concat(x.allPaths):oe,[]);return ce.length&&(ee.allPaths=ce),ee}function P(Z,Y,H){if(Y===!1)return r;const _=l(Z,H);if(_===r)return r;if(typeof Y=="boolean")return _;if(Y){const ee=Y.when;if(typeof ee=="string"){const be=(ce,oe,x,he)=>{if(!he||!_(ce,oe))return null;const pe=ee.replace("$(basename)",()=>x),Se=he(pe);return(0,R.isThenable)(Se)?Se.then(Re=>Re?Z:null):Se?Z:null};return be.requiresSiblings=!0,be}}return _}function M(Z,Y){const H=Z.filter(oe=>!!oe.basenames);if(H.length<2)return Z;const _=H.reduce((oe,x)=>{const he=x.basenames;return he?oe.concat(he):oe},[]);let ee;if(Y){ee=[];for(let oe=0,x=_.length;oe<x;oe++)ee.push(Y)}else ee=H.reduce((oe,x)=>{const he=x.patterns;return he?oe.concat(he):oe},[]);const be=function(oe,x){if(typeof oe!="string")return null;if(!x){let pe;for(pe=oe.length;pe>0;pe--){const Se=oe.charCodeAt(pe-1);if(Se===47||Se===92)break}x=oe.substr(pe)}const he=_.indexOf(x);return he!==-1?ee[he]:null};be.basenames=_,be.patterns=ee,be.allBasenames=_;const ce=Z.filter(oe=>!oe.basenames);return ce.push(be),ce}function B(Z,Y){return(0,a.equals)(Z,Y,(H,_)=>typeof H=="string"&&typeof _=="string"?H===_:typeof H!="string"&&typeof _!="string"?H.base===_.base&&H.pattern===_.pattern:!1)}e.patternsEquals=B}),define(De[112],Ce([1,0,10,164,24,8,2]),function(ie,e,a,R,c,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(d="",f=!1){if(this.value=d,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=f.isTrusted??void 0,this.supportThemeIcons=f.supportThemeIcons??!1,this.supportHtml=f.supportHtml??!1)}appendText(d,f=0){return this.value+=D(this.supportThemeIcons?(0,R.escapeIcons)(d):d).replace(/([ \t]+)/g,(p,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,f){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=f,this.value+="\n```\n",this}appendLink(d,f,p){return this.value+="[",this.value+=this.c(f,"]"),this.value+="](",this.value+=this.c(String(d),")"),p&&(this.value+=` "${this.c(this.c(p,'"'),")")}"`),this.value+=")",this}c(d,f){const p=new RegExp((0,L.escapeRegExpCharacters)(f),"g");return d.replace(p,(y,g)=>d.charAt(g-1)!=="\\"?`\\${y}`:y)}}e.MarkdownString=S;function I(o){return N(o)?!o.value:Array.isArray(o)?o.every(I):!0}e.isEmptyMarkdownString=I;function N(o){return o instanceof S?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function A(o,d){return o===d?!0:!o||!d?!1:o.value===d.value&&o.isTrusted===d.isTrusted&&o.supportThemeIcons===d.supportThemeIcons&&o.supportHtml===d.supportHtml&&(o.baseUri===d.baseUri||!!o.baseUri&&!!d.baseUri&&(0,c.isEqual)(E.URI.from(o.baseUri),E.URI.from(d.baseUri)))}e.markdownStringEqual=A;function D(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function k(o){return o.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=k;function C(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=C;function m(o){const d=[],f=o.split("|").map(y=>y.trim());o=f[0];const p=f[1];if(p){const y=/height=(\d+)/.exec(p),g=/width=(\d+)/.exec(p),t=y?y[1]:"",s=g?g[1]:"",r=isFinite(parseInt(s)),l=isFinite(parseInt(t));r&&d.push(`width="${s}"`),l&&d.push(`height="${t}"`)}return{href:o,dimensions:d}}e.parseHrefAndDimensions=m}),define(De[113],Ce([1,0,15,33,12,11,24,8]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(r,l){const{os:u,tildify:b,relative:i}=l;if(i){const w=I(r,i,u);if(typeof w=="string")return w}let n=r.fsPath;if(u===1&&!L.isWindows?n=n.replace(/\//g,"\\"):u!==1&&L.isWindows&&(n=n.replace(/\\/g,"/")),u!==1&&b?.userHome){const w=b.userHome.fsPath;let v;r.scheme!==b.userHome.scheme&&r.path.startsWith(c.posix.sep)?v=b.userHome.with({path:r.path}).fsPath:v=r.fsPath,n=D(v,w,u)}return(u===1?c.win32:c.posix).normalize(N(n,u===1))}e.getPathLabel=S;function I(r,l,u){const b=u===1?c.win32:c.posix,i=u===3?E.extUri:E.extUriIgnorePathCase,n=l.getWorkspace(),h=(0,a.firstOrDefault)(n.folders);if(!h)return;r.scheme!==h.uri.scheme&&r.path.startsWith(c.posix.sep)&&(r=h.uri.with({path:r.path}));const w=l.getWorkspaceFolder(r);if(!w)return;let v;if(i.isEqual(w.uri,r)?v="":v=i.relativePath(w.uri,r)??"",v&&(v=b.normalize(v)),n.folders.length>1&&!l.noPrefix){const O=w.name?w.name:i.basenameOrAuthority(w.uri);v=v?`${O} \u2022 ${v}`:O}return v}function N(r,l=L.isWindows){return(0,R.hasDriveLetter)(r,l)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=N;let A=Object.create(null);function D(r,l,u=L.OS){if(u===1||!r||!l)return r;let b=A.original===l?A.normalized:void 0;b||(b=l,L.isWindows&&(b=(0,R.toSlashes)(b)),b=`${(0,T.rtrim)(b,c.posix.sep)}${c.posix.sep}`,A={original:l,normalized:b});let i=r;return L.isWindows&&(i=(0,R.toSlashes)(i)),(u===3?i.startsWith(b):(0,T.startsWithIgnoreCase)(i,b))?`~/${i.substr(b.length)}`:r}e.tildify=D;function k(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=k;const C="\u2026",m="\\\\",o="~";function d(r,l=c.sep){const u=new Array(r.length);let b=!1;for(let i=0;i<r.length;i++){const n=r[i];if(n===""){u[i]=`.${l}`;continue}if(!n){u[i]=n;continue}b=!0;let h="",w=n;w.indexOf(m)===0?(h=w.substr(0,w.indexOf(m)+m.length),w=w.substr(w.indexOf(m)+m.length)):w.indexOf(l)===0?(h=w.substr(0,w.indexOf(l)+l.length),w=w.substr(w.indexOf(l)+l.length)):w.indexOf(o)===0&&(h=w.substr(0,w.indexOf(o)+o.length),w=w.substr(w.indexOf(o)+o.length));const v=w.split(l);for(let O=1;b&&O<=v.length;O++)for(let j=v.length-O;b&&j>=0;j--){b=!1;let V=v.slice(j,j+O).join(l);for(let Q=0;!b&&Q<r.length;Q++)if(Q!==i&&r[Q]&&r[Q].indexOf(V)>-1){const G=j+O===v.length,U=j>0&&r[Q].indexOf(l)>-1?l+V:V,P=r[Q].endsWith(U);b=!G||P}if(!b){let Q="";(v[0].endsWith(":")||h!=="")&&(j===1&&(j=0,O++,V=v[0]+l+V),j>0&&(Q=v[0]+l),Q=h+Q),j>0&&(Q=Q+C+l),Q=Q+V,j+O<v.length&&(Q=Q+l+C),u[i]=Q}}b&&(u[i]=n)}return u}e.shorten=d;var f;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function p(r,l=Object.create(null)){const u=[];let b=!1,i="";for(const n of r)if(n==="$"||b&&n==="{")i&&u.push({value:i,type:f.TEXT}),i="",b=!0;else if(n==="}"&&b){const h=l[i];if(typeof h=="string")h.length&&u.push({value:h,type:f.VARIABLE});else if(h){const w=u[u.length-1];(!w||w.type!==f.SEPARATOR)&&u.push({value:h.label,type:f.SEPARATOR})}i="",b=!1}else i+=n;return i&&!b&&u.push({value:i,type:f.TEXT}),u.filter((n,h)=>{if(n.type===f.SEPARATOR){const w=u[h-1],v=u[h+1];return[w,v].every(O=>O&&(O.type===f.VARIABLE||O.type===f.TEXT)&&O.value.length>0)}return!0}).map(n=>n.value).join("")}e.template=p;function y(r,l){return L.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):r.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function g(r,l){return L.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):L.isWindows?r.replace(/&&|&/g,u=>u==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=g;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function s(r){const l=r.indexOf("/")!==-1?c.posix:c.win32,u=l.basename(r),b=l.dirname(r);return u.length?{name:u,parentPath:b}:{name:b,parentPath:""}}e.splitName=s}),define(De[114],Ce([1,0,22,2]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function c(A){return A.toJSON()}class L{constructor(D){this.a=D}transformIncoming(D){const k=this.a.transformIncoming(D);return k===D?D:c(R.URI.from(k))}transformOutgoing(D){const k=this.a.transformOutgoing(D);return k===D?D:c(R.URI.from(k))}transformOutgoingURI(D){const k=this.a.transformOutgoing(D);return k===D?D:R.URI.from(k)}transformOutgoingScheme(D){return this.a.transformOutgoingScheme(D)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function E(A,D,k){if(!A||k>200)return null;if(typeof A=="object"){if(A instanceof R.URI)return D.transformOutgoing(A);for(const C in A)if(Object.hasOwnProperty.call(A,C)){const m=E(A[C],D,k+1);m!==null&&(A[C]=m)}}return null}function T(A,D){const k=E(A,D,0);return k===null?A:k}e.transformOutgoingURIs=T;function S(A,D,k,C){if(!A||C>200)return null;if(typeof A=="object"){if(A.$mid===1)return k?R.URI.revive(D.transformIncoming(A)):D.transformIncoming(A);if(A instanceof a.VSBuffer)return null;for(const m in A)if(Object.hasOwnProperty.call(A,m)){const o=S(A[m],D,k,C+1);o!==null&&(A[m]=o)}}return null}function I(A,D){const k=S(A,D,!1,0);return k===null?A:k}e.transformIncomingURIs=I;function N(A,D){const k=S(A,D,!0,0);return k===null?A:k}e.transformAndReviveIncomingURIs=N}),define(De[29],Ce([1,0,70,89,319,19,33,86,12,11,24,2]),function(ie,e,a,R,c,L,E,T,S,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var D;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(D=e.RimRafMode||(e.RimRafMode={}));async function k(U,P=D.UNLINK){if((0,E.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return P===D.UNLINK?m(U):C(U)}async function C(U){try{const P=(0,E.randomPath)((0,R.tmpdir)());try{await a.promises.rename(U,P)}catch(M){return M.code==="ENOENT"?void 0:m(U)}m(P).catch(M=>{})}catch(P){if(P.code!=="ENOENT")throw P}}async function m(U){return(0,c.promisify)(a.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function o(U){if((0,E.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=o;async function d(U,P){return y(await(P?f(U):(0,c.promisify)(a.readdir)(U)))}async function f(U){try{return await(0,c.promisify)(a.readdir)(U,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const P=[],M=await d(U);for(const B of M){let Z=!1,Y=!1,H=!1;try{const _=await e.Promises.lstat((0,S.join)(U,B));Z=_.isFile(),Y=_.isDirectory(),H=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}P.push({name:B,isFile:()=>Z,isDirectory:()=>Y,isSymbolicLink:()=>H})}return P}function p(U){return y(a.readdirSync(U))}e.readdirSync=p;function y(U){return U.map(P=>typeof P=="string"?I.isMacintosh?(0,T.normalizeNFC)(P):P:(P.name=I.isMacintosh?(0,T.normalizeNFC)(P.name):P.name,P))}async function g(U){const P=await d(U),M=[];for(const B of P)await s.existsDirectory((0,S.join)(U,B))&&M.push(B);return M}function t(U,P=1e3){return new Promise(M=>{let B=!1;const Z=setInterval(()=>{B||(B=!0,a.access(U,Y=>{B=!1,Y&&(clearInterval(Z),M(void 0))}))},P)})}e.whenDeleted=t;var s;(function(U){async function P(Z){let Y;try{if(Y=await e.Promises.lstat(Z),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(I.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw _}throw H}}U.stat=P;async function M(Z){try{const{stat:Y,symbolicLink:H}=await U.stat(Z);return Y.isFile()&&H?.dangling!==!0}catch{}return!1}U.existsFile=M;async function B(Z){try{const{stat:Y,symbolicLink:H}=await U.stat(Z);return Y.isDirectory()&&H?.dangling!==!0}catch{}return!1}U.existsDirectory=B})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new L.ResourceQueue;function l(U,P,M){return r.queueFor(A.URI.file(U),N.extUriBiasedIgnorePathCase).queue(()=>{const B=h(M);return new Promise((Z,Y)=>i(U,P,B,H=>H?Y(H):Z()))})}let u=!0;function b(U){u=U}e.configureFlushOnWrite=b;function i(U,P,M,B){if(!u)return a.writeFile(U,P,{mode:M.mode,flag:M.flag},B);a.open(U,M.flag,M.mode,(Z,Y)=>{if(Z)return B(Z);a.writeFile(Y,P,H=>{if(H)return a.close(Y,()=>B(H));a.fdatasync(Y,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),b(!1)),a.close(Y,ee=>B(ee))))})})}function n(U,P,M){const B=h(M);if(!u)return a.writeFileSync(U,P,{mode:B.mode,flag:B.flag});const Z=a.openSync(U,B.flag,B.mode);try{a.writeFileSync(Z,P);try{a.fdatasyncSync(Z)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),b(!1)}}finally{a.closeSync(Z)}}e.writeFileSync=n;function h(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function w(U,P){if(U!==P)try{await e.Promises.rename(U,P)}catch(M){if(U.toLowerCase()!==P.toLowerCase()&&M.code==="EXDEV"||U.endsWith("."))await v(U,P,{preserveSymlinks:!1}),await k(U,D.MOVE);else throw M}}async function v(U,P,M){return j(U,P,{root:{source:U,target:P},options:M,handledSourcePaths:new Set})}const O=511;async function j(U,P,M){if(M.handledSourcePaths.has(U))return;M.handledSourcePaths.add(U);const{stat:B,symbolicLink:Z}=await s.stat(U);if(Z){if(M.options.preserveSymlinks)try{return await G(U,P,M)}catch(Y){console.warn("[node.js fs] copy of symlink failed: ",Y)}if(Z.dangling)return}return B.isDirectory()?V(U,P,B.mode&O,M):Q(U,P,B.mode&O)}async function V(U,P,M,B){await e.Promises.mkdir(P,{recursive:!0,mode:M});const Z=await d(U);for(const Y of Z)await j((0,S.join)(U,Y),(0,S.join)(P,Y),B)}async function Q(U,P,M){await e.Promises.copyFile(U,P),await e.Promises.chmod(P,M)}async function G(U,P,M){let B=await e.Promises.readlink(U);(0,E.isEqualOrParent)(B,M.root.source,!I.isLinux)&&(B=(0,S.join)(M.root.target,B.substr(M.root.source.length+1))),await e.Promises.symlink(B,P)}e.Promises=new class{get access(){return(0,c.promisify)(a.access)}get stat(){return(0,c.promisify)(a.stat)}get lstat(){return(0,c.promisify)(a.lstat)}get utimes(){return(0,c.promisify)(a.utimes)}get read(){return(U,P,M,B,Z)=>new Promise((Y,H)=>{a.read(U,P,M,B,Z,(_,ee,be)=>_?H(_):Y({bytesRead:ee,buffer:be}))})}get readFile(){return(0,c.promisify)(a.readFile)}get write(){return(U,P,M,B,Z)=>new Promise((Y,H)=>{a.write(U,P,M,B,Z,(_,ee,be)=>_?H(_):Y({bytesWritten:ee,buffer:be}))})}get appendFile(){return(0,c.promisify)(a.appendFile)}get fdatasync(){return(0,c.promisify)(a.fdatasync)}get truncate(){return(0,c.promisify)(a.truncate)}get rename(){return(0,c.promisify)(a.rename)}get copyFile(){return(0,c.promisify)(a.copyFile)}get open(){return(0,c.promisify)(a.open)}get close(){return(0,c.promisify)(a.close)}get symlink(){return(0,c.promisify)(a.symlink)}get readlink(){return(0,c.promisify)(a.readlink)}get chmod(){return(0,c.promisify)(a.chmod)}get mkdir(){return(0,c.promisify)(a.mkdir)}get unlink(){return(0,c.promisify)(a.unlink)}get rmdir(){return(0,c.promisify)(a.rmdir)}get realpath(){return(0,c.promisify)(a.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return g}get writeFile(){return l}get rm(){return k}get move(){return w}get copy(){return v}}}),define(De[115],Ce([1,0,70,12,11,8,29]),function(ie,e,a,R,c,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function T(D){if(c.isLinux)return D;const k=(0,R.dirname)(D);if(D===k)return D;const C=((0,R.basename)(D)||D).toLowerCase();try{const o=(0,E.readdirSync)(k).filter(d=>d.toLowerCase()===C);if(o.length===1){const d=T(k);if(d)return(0,R.join)(d,o[0])}else if(o.length>1){const d=o.indexOf(C);if(d>=0){const f=T(k);if(f)return(0,R.join)(f,o[d])}}}catch{}return null}e.realcaseSync=T;async function S(D){if(c.isLinux)return D;const k=(0,R.dirname)(D);if(D===k)return D;const C=((0,R.basename)(D)||D).toLowerCase();try{const o=(await E.Promises.readdir(k)).filter(d=>d.toLowerCase()===C);if(o.length===1){const d=await S(k);if(d)return(0,R.join)(d,o[0])}else if(o.length>1){const d=o.indexOf(C);if(d>=0){const f=await S(k);if(f)return(0,R.join)(f,o[d])}}}catch{}return null}e.realcase=S;async function I(D){try{return await E.Promises.realpath(D)}catch{const C=A(D);return await E.Promises.access(C,a.constants.R_OK),C}}e.realpath=I;function N(D){try{return a.realpathSync(D)}catch{const C=A(D);return a.accessSync(C,a.constants.R_OK),C}}e.realpathSync=N;function A(D){return(0,L.rtrim)((0,R.normalize)(D),R.sep)}}),define(De[116],Ce([1,0,12,11,36,109,9,29]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function S(A=c.env){return A.comspec||"cmd.exe"}e.getWindowsShell=S;function I(A){let D=[],k=!1;const C=function(m){if(k){D.push(m);return}(!A.send(m,d=>{if(d&&console.error(d),k=!1,D.length>0){const f=D.slice(0);D=[],f.forEach(p=>C(p))}})||R.isWindows)&&(k=!0)};return{send:C}}e.createQueuedSender=I;var N;(function(A){async function D(k,C,m){if(a.isAbsolute(k))return k;if(C===void 0&&(C=c.cwd()),a.dirname(k)!=="."||(m===void 0&&E.isString(c.env.PATH)&&(m=c.env.PATH.split(a.delimiter)),m===void 0||m.length===0))return a.join(C,k);async function d(f){if(await T.Promises.exists(f)){let p;try{p=await T.Promises.stat(f)}catch(y){y.message.startsWith("EACCES")&&(p=await T.Promises.lstat(f))}return p?!p.isDirectory():!1}return!1}for(const f of m){let p;if(a.isAbsolute(f)?p=a.join(f,k):p=a.join(C,f,k),await d(p))return p;let y=p+".com";if(await d(y)||(y=p+".exe",await d(y)))return y}return a.join(C,k)}A.findExecutable=D})(N=e.win32||(e.win32={}))});var Ve=this&&this.__decorate||function(ie,e,a,R){var c=arguments.length,L=c<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,a):R,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ie,e,a,R);else for(var T=ie.length-1;T>=0;T--)(E=ie[T])&&(L=(c<3?E(L):c>3?E(e,a,L):E(e,a))||L);return c>3&&L&&Object.defineProperty(e,a,L),L};define(De[117],Ce([1,0,15,19,22,21,62,10,3,6,69,8,9]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var k;(function(Y){Y[Y.Promise=100]="Promise",Y[Y.PromiseCancel=101]="PromiseCancel",Y[Y.EventListen=102]="EventListen",Y[Y.EventDispose=103]="EventDispose"})(k||(k={}));function C(Y){switch(Y){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(Y){Y[Y.Initialize=200]="Initialize",Y[Y.PromiseSuccess=201]="PromiseSuccess",Y[Y.PromiseError=202]="PromiseError",Y[Y.PromiseErrorObj=203]="PromiseErrorObj",Y[Y.EventFire=204]="EventFire"})(m||(m={}));function o(Y){switch(Y){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(Y){Y[Y.Uninitialized=0]="Uninitialized",Y[Y.Idle=1]="Idle"})(d||(d={}));function f(Y){let H=0;for(let _=0;;_+=7){const ee=Y.read(1);if(H|=(ee.buffer[0]&127)<<_,!(ee.buffer[0]&128))return H}}const p=r(0);function y(Y,H){if(H===0){Y.write(p);return}let _=0;for(let be=H;be!==0;be=be>>>7)_++;const ee=c.VSBuffer.alloc(_);for(let be=0;H!==0;be++)ee.buffer[be]=H&127,H=H>>>7,H>0&&(ee.buffer[be]|=128);Y.write(ee)}class g{constructor(H){this.b=H,this.a=0}read(H){const _=this.b.slice(this.a,this.a+H);return this.a+=_.byteLength,_}}e.BufferReader=g;class t{constructor(){this.a=[]}get buffer(){return c.VSBuffer.concat(this.a)}write(H){this.a.push(H)}}e.BufferWriter=t;var s;(function(Y){Y[Y.Undefined=0]="Undefined",Y[Y.String=1]="String",Y[Y.Buffer=2]="Buffer",Y[Y.VSBuffer=3]="VSBuffer",Y[Y.Array=4]="Array",Y[Y.Object=5]="Object",Y[Y.Int=6]="Int"})(s||(s={}));function r(Y){const H=c.VSBuffer.alloc(1);return H.writeUInt8(Y,0),H}const l={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},u=typeof Buffer<"u";function b(Y,H){if(typeof H>"u")Y.write(l.Undefined);else if(typeof H=="string"){const _=c.VSBuffer.fromString(H);Y.write(l.String),y(Y,_.byteLength),Y.write(_)}else if(u&&Buffer.isBuffer(H)){const _=c.VSBuffer.wrap(H);Y.write(l.Buffer),y(Y,_.byteLength),Y.write(_)}else if(H instanceof c.VSBuffer)Y.write(l.VSBuffer),y(Y,H.byteLength),Y.write(H);else if(Array.isArray(H)){Y.write(l.Array),y(Y,H.length);for(const _ of H)b(Y,_)}else if(typeof H=="number"&&(H|0)===H)Y.write(l.Uint),y(Y,H);else{const _=c.VSBuffer.fromString(JSON.stringify(H));Y.write(l.Object),y(Y,_.byteLength),Y.write(_)}}e.serialize=b;function i(Y){switch(Y.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return Y.read(f(Y)).toString();case s.Buffer:return Y.read(f(Y)).buffer;case s.VSBuffer:return Y.read(f(Y));case s.Array:{const _=f(Y),ee=[];for(let be=0;be<_;be++)ee.push(i(Y));return ee}case s.Object:return JSON.parse(Y.read(f(Y)).toString());case s.Int:return f(Y)}}e.deserialize=i;class n{constructor(H,_,ee=null,be=1e3){this.h=H,this.j=_,this.k=ee,this.l=be,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(H,_){this.b.set(H,_),setTimeout(()=>this.w(H),0)}m(H){switch(H.type){case 200:{const _=this.o([H.type]);this.k?.logOutgoing(_,0,1,o(H.type));return}case 201:case 202:case 204:case 203:{const _=this.o([H.type,H.id],H.data);this.k?.logOutgoing(_,H.id,1,o(H.type),H.data);return}}}o(H,_=void 0){const ee=new t;return b(ee,H),b(ee,_),this.p(ee.buffer)}p(H){try{return this.h.send(H),H.byteLength}catch{return 0}}q(H){const _=new g(H),ee=i(_),be=i(_),ce=ee[0];switch(ce){case 100:return this.k?.logIncoming(H.byteLength,ee[1],1,`${C(ce)}: ${ee[2]}.${ee[3]}`,be),this.s({type:ce,id:ee[1],channelName:ee[2],name:ee[3],arg:be});case 102:return this.k?.logIncoming(H.byteLength,ee[1],1,`${C(ce)}: ${ee[2]}.${ee[3]}`,be),this.t({type:ce,id:ee[1],channelName:ee[2],name:ee[3],arg:be});case 101:return this.k?.logIncoming(H.byteLength,ee[1],1,`${C(ce)}`),this.u({type:ce,id:ee[1]});case 103:return this.k?.logIncoming(H.byteLength,ee[1],1,`${C(ce)}`),this.u({type:ce,id:ee[1]})}}s(H){const _=this.b.get(H.channelName);if(!_){this.v(H);return}const ee=new L.CancellationTokenSource;let be;try{be=_.call(this.j,H.name,H.arg,ee.token)}catch(x){be=Promise.reject(x)}const ce=H.id;be.then(x=>{this.m({id:ce,data:x,type:201}),this.d.delete(H.id)},x=>{x instanceof Error?this.m({id:ce,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.m({id:ce,data:x,type:203}),this.d.delete(H.id)});const oe=(0,I.toDisposable)(()=>ee.cancel());this.d.set(H.id,oe)}t(H){const _=this.b.get(H.channelName);if(!_){this.v(H);return}const ee=H.id,ce=_.listen(this.j,H.name,H.arg)(oe=>this.m({id:ee,data:oe,type:204}));this.d.set(H.id,ce)}u(H){const _=this.d.get(H.id);_&&(_.dispose(),this.d.delete(H.id))}v(H){let _=this.g.get(H.channelName);_||(_=[],this.g.set(H.channelName,_));const ee=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.m({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);_.push({request:H,timeoutTimer:ee})}w(H){const _=this.g.get(H);if(_){for(const ee of _)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(H)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,I.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=n;var h;(function(Y){Y[Y.LocalSide=0]="LocalSide",Y[Y.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(H,_=null){this.l=H,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=_}getChannel(H){const _=this;return{call(ee,be,ce){return _.a?Promise.reject(new T.CancellationError):_.m(H,ee,be,ce)},listen(ee,be){return _.a?S.Event.None:_.o(H,ee,be)}}}m(H,_,ee,be=L.CancellationToken.None){const ce=this.g++,x={id:ce,type:100,channelName:H,name:_,arg:ee};if(be.isCancellationRequested)return Promise.reject(new T.CancellationError);let he;return new Promise((Se,Re)=>{if(be.isCancellationRequested)return Re(new T.CancellationError);const re=()=>{const ae=se=>{switch(se.type){case 201:this.f.delete(ce),Se(se.data);break;case 202:{this.f.delete(ce);const F=new Error(se.data.message);F.stack=Array.isArray(se.data.stack)?se.data.stack.join(`
`):se.data.stack,F.name=se.data.name,Re(F);break}case 203:this.f.delete(ce),Re(se.data);break}};this.f.set(ce,ae),this.p(x)};let le=null;this.b===d.Idle?re():(le=(0,R.createCancelablePromise)(ae=>this.u()),le.then(()=>{le=null,re()}));const de=()=>{le?(le.cancel(),le=null):this.p({id:ce,type:101}),Re(new T.CancellationError)},te=be.onCancellationRequested(de);he=(0,I.combinedDisposable)((0,I.toDisposable)(de),te),this.d.add(he)}).finally(()=>{this.d.delete(he)})}o(H,_,ee){const be=this.g++,oe={id:be,type:102,channelName:H,name:_,arg:ee};let x=null;const he=new S.Emitter({onWillAddFirstListener:()=>{x=(0,R.createCancelablePromise)(Se=>this.u()),x.then(()=>{x=null,this.d.add(he),this.p(oe)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(he),this.p({id:be,type:103}))}}),pe=Se=>he.fire(Se.data);return this.f.set(be,pe),he.event}p(H){switch(H.type){case 100:case 102:{const _=this.q([H.type,H.id,H.channelName,H.name],H.arg);this.j?.logOutgoing(_,H.id,0,`${C(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const _=this.q([H.type,H.id]);this.j?.logOutgoing(_,H.id,0,C(H.type));return}}}q(H,_=void 0){const ee=new t;return b(ee,H),b(ee,_),this.r(ee.buffer)}r(H){try{return this.l.send(H),H.byteLength}catch{return 0}}s(H){const _=new g(H),ee=i(_),be=i(_),ce=ee[0];switch(ce){case 200:return this.j?.logIncoming(H.byteLength,0,0,o(ce)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(H.byteLength,ee[1],0,o(ce),be),this.t({type:ee[0],id:ee[1],data:be})}}t(H){if(H.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(H.id)?.(H)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,I.dispose)(this.d.values()),this.d.clear()}}Ve([E.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class v{get connections(){const H=[];return this.f.forEach(_=>H.push(_)),H}constructor(H){this.a=new Map,this.f=new Set,this.g=new S.Emitter,this.onDidAddConnection=this.g.event,this.h=new S.Emitter,this.onDidRemoveConnection=this.h.event,H(({protocol:_,onDidClientDisconnect:ee})=>{S.Event.once(_.onMessage)(ce=>{const oe=new g(ce),x=i(oe),he=new n(_,x),pe=new w(_);this.a.forEach((Re,re)=>he.registerChannel(re,Re));const Se={channelServer:he,channelClient:pe,ctx:x};this.f.add(Se),this.g.fire(Se),ee(()=>{he.dispose(),pe.dispose(),this.f.delete(Se),this.h.fire(Se)})})})}getChannel(H,_){const ee=this;return{call(be,ce,oe){let x;if((0,D.isFunction)(_)){const pe=(0,a.getRandomElement)(ee.connections.filter(_));x=pe?Promise.resolve(pe):S.Event.toPromise(S.Event.filter(ee.onDidAddConnection,_))}else x=_.routeCall(ee,be,ce);const he=x.then(pe=>pe.channelClient.getChannel(H));return j(he).call(be,ce,oe)},listen(be,ce){if((0,D.isFunction)(_))return ee.j(H,_,be,ce);const oe=_.routeEvent(ee,be,ce).then(x=>x.channelClient.getChannel(H));return j(oe).listen(be,ce)}}}j(H,_,ee,be){const ce=this;let oe=new I.DisposableStore;const x=new S.Emitter({onWillAddFirstListener:()=>{oe=new I.DisposableStore;const he=new S.EventMultiplexer,pe=new Map,Se=re=>{const de=re.channelClient.getChannel(H).listen(ee,be),te=he.add(de);pe.set(re,te)},Re=re=>{const le=pe.get(re);!le||(le.dispose(),pe.delete(re))};ce.connections.filter(_).forEach(Se),S.Event.filter(ce.onDidAddConnection,_)(Se,void 0,oe),ce.onDidRemoveConnection(Re,void 0,oe),he.event(x.fire,x,oe),oe.add(he)},onDidRemoveLastListener:()=>{oe.dispose()}});return x.event}registerChannel(H,_){this.a.set(H,_),this.f.forEach(ee=>{ee.channelServer.registerChannel(H,_)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=v;class O{constructor(H,_,ee=null){const be=new t;b(be,_),H.send(be.buffer),this.a=new w(H,ee),this.d=new n(H,_,ee)}getChannel(H){return this.a.getChannel(H)}registerChannel(H,_){this.d.registerChannel(H,_)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=O;function j(Y){return{call(H,_,ee){return Y.then(be=>be.call(H,_,ee))},listen(H,_){const ee=new S.Relay;return Y.then(be=>ee.input=be.listen(H,_)),ee.event}}}e.getDelayedChannel=j;function V(Y){let H=!1;return{call(_,ee,be){return H?Y.call(_,ee,be):(0,R.timeout)(0).then(()=>H=!0).then(()=>Y.call(_,ee,be))},listen(_,ee){if(H)return Y.listen(_,ee);const be=new S.Relay;return(0,R.timeout)(0).then(()=>H=!0).then(()=>be.input=Y.listen(_,ee)),be.event}}}e.getNextTickChannel=V;class Q{constructor(H){this.a=H}routeCall(H){return this.b(H)}routeEvent(H){return this.b(H)}async b(H){for(const _ of H.connections)if(await Promise.resolve(this.a(_.ctx)))return Promise.resolve(_);return await S.Event.toPromise(H.onDidAddConnection),await this.b(H)}}e.StaticRouter=Q;var G;(function(Y){function H(ce,oe){const x=ce,he=oe&&oe.disableMarshalling,pe=new Map;for(const Se in x)ee(Se)&&pe.set(Se,S.Event.buffer(x[Se],!0));return new class{listen(Se,Re,re){const le=pe.get(Re);if(le)return le;if(be(Re)){const de=x[Re];if(typeof de=="function")return de.call(x,re)}throw new Error(`Event not found: ${Re}`)}call(Se,Re,re){const le=x[Re];if(typeof le=="function"){if(!he&&Array.isArray(re))for(let de=0;de<re.length;de++)re[de]=(0,N.revive)(re[de]);return le.apply(x,re)}throw new Error(`Method not found: ${Re}`)}}}Y.fromService=H;function _(ce,oe){const x=oe&&oe.disableMarshalling;return new Proxy({},{get(he,pe){if(typeof pe=="string")return oe?.properties?.has(pe)?oe.properties.get(pe):be(pe)?function(Se){return ce.listen(pe,Se)}:ee(pe)?ce.listen(pe):async function(...Se){let Re;oe&&!(0,D.isUndefinedOrNull)(oe.context)?Re=[oe.context,...Se]:Re=Se;const re=await ce.call(pe,Re);return x?re:(0,N.revive)(re)};throw new Error(`Property not found: ${String(pe)}`)}})}Y.toService=_;function ee(ce){return ce[0]==="o"&&ce[1]==="n"&&A.isUpperAsciiLetter(ce.charCodeAt(2))}function be(ce){return/^onDynamic/.test(ce)&&A.isUpperAsciiLetter(ce.charCodeAt(9))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function P(Y){if(Array.isArray(Y))return Y;if(Y&&typeof Y=="object"&&typeof Y.toString=="function"){const H=Y.toString();if(H!=="[object Object]")return H}return Y}function M(Y){return Array.isArray(Y)?Y.map(P):P(Y)}function B(Y,H,_,ee,be,ce,oe){oe=M(oe);const x=U[be],he=x[ee%x.length];let pe=[`%c[${Y}]%c[${String(H).padStart(7," ")}]%c[len: ${String(_).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${he}`];/\($/.test(ce)?(pe=pe.concat(oe),pe.push(")")):pe.push(oe),console.log.apply(console,pe)}class Z{constructor(H,_){this.d=H,this.f=_,this.a=0,this.b=0}logOutgoing(H,_,ee,be,ce){this.b+=H,B(this.d,this.b,H,_,ee,be,ce)}logIncoming(H,_,ee,be,ce){this.a+=H,B(this.f,this.a,H,_,ee,be,ce)}}e.IPCLogger=Z}),define(De[118],Ce([1,0,19,22,3,6,117]),function(ie,e,a,R,c,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(w){w.Created="created",w.Read="read",w.Write="write",w.Open="open",w.Error="error",w.Close="close",w.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",w.NodeEndReceived="nodeEndReceived",w.NodeEndSent="nodeEndSent",w.NodeDrainBegin="nodeDrainBegin",w.NodeDrainEnd="nodeDrainEnd",w.zlibInflateError="zlibInflateError",w.zlibInflateData="zlibInflateData",w.zlibInflateInitialWrite="zlibInflateInitialWrite",w.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",w.zlibInflateWrite="zlibInflateWrite",w.zlibInflateFlushFired="zlibInflateFlushFired",w.zlibDeflateError="zlibDeflateError",w.zlibDeflateData="zlibDeflateData",w.zlibDeflateWrite="zlibDeflateWrite",w.zlibDeflateFlushFired="zlibDeflateFlushFired",w.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",w.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",w.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",w.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",w.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",w.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",w.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",w.ProtocolHeaderRead="protocolHeaderRead",w.ProtocolMessageRead="protocolMessageRead",w.ProtocolHeaderWrite="protocolHeaderWrite",w.ProtocolMessageWrite="protocolMessageWrite",w.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(w){w.enableDiagnostics=!1,w.records=[];const v=new WeakMap;let O=0;function j(Q,G){if(!v.has(Q)){const U=String(++O);v.set(Q,U)}return v.get(Q)}function V(Q,G,U,P){if(!w.enableDiagnostics)return;const M=j(Q,G);if(P instanceof R.VSBuffer||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const B=R.VSBuffer.alloc(P.byteLength);B.set(P),w.records.push({timestamp:Date.now(),id:M,label:G,type:U,buff:B})}else w.records.push({timestamp:Date.now(),id:M,label:G,type:U,data:P})}w.traceSocketEvent=V})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(w){w[w.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",w[w.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let N=null;function A(){return N||(N=R.VSBuffer.alloc(0)),N}class D{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(v){this.a.push(v),this.b+=v.byteLength}read(v){return this.c(v,!0)}peek(v){return this.c(v,!1)}c(v,O){if(v===0)return A();if(v>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===v){const G=this.a[0];return O&&(this.a.shift(),this.b-=v),G}if(this.a[0].byteLength>v){const G=this.a[0].slice(0,v);return O&&(this.a[0]=this.a[0].slice(v),this.b-=v),G}const j=R.VSBuffer.alloc(v);let V=0,Q=0;for(;v>0;){const G=this.a[Q];if(G.byteLength>v){const U=G.slice(0,v);j.set(U,V),V+=v,O&&(this.a[Q]=G.slice(v),this.b-=v),v-=v}else j.set(G,V),V+=G.byteLength,O?(this.a.shift(),this.b-=G.byteLength):Q++,v-=G.byteLength}return j}}e.ChunkStream=D;var k;(function(w){w[w.None=0]="None",w[w.Regular=1]="Regular",w[w.Control=2]="Control",w[w.Ack=3]="Ack",w[w.Disconnect=5]="Disconnect",w[w.ReplayRequest=6]="ReplayRequest",w[w.Pause=7]="Pause",w[w.Resume=8]="Resume",w[w.KeepAlive=9]="KeepAlive",w[w.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",w[w.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(k||(k={}));function C(w){switch(w){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var m;(function(w){w[w.HeaderLength=13]="HeaderLength",w[w.AcknowledgeTime=2e3]="AcknowledgeTime",w[w.TimeoutTime=2e4]="TimeoutTime",w[w.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",w[w.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",w[w.KeepAliveSendTime=5e3]="KeepAliveSendTime",w[w.LatencySampleTime=6e4]="LatencySampleTime",w[w.LatencySampleCount=5]="LatencySampleCount",w[w.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",w[w.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class o{constructor(v,O,j,V){this.type=v,this.id=O,this.ack=j,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends L.Disposable{constructor(v){super(),this.f=this.B(new c.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=v,this.b=!1,this.c=new D,this.B(this.a.onData(O=>this.acceptChunk(O))),this.lastReadTime=Date.now()}acceptChunk(v){if(!(!v||v.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(v);this.c.byteLength>=this.g.readLen;){const O=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=O.readUInt32BE(9),this.g.messageType=O.readUInt8(0),this.g.id=O.readUInt32BE(1),this.g.ack=O.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:C(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const j=this.g.messageType,V=this.g.id,Q=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",O),this.f.fire(new o(j,V,Q,O)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(v){this.k=null,this.a=!1,this.b=!1,this.c=v,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(v){if(this.a)return;v.writtenTime=Date.now(),this.lastWriteTime=Date.now();const O=R.VSBuffer.alloc(13);O.writeUInt8(v.type,0),O.writeUInt32BE(v.id,1),O.writeUInt32BE(v.ack,5),O.writeUInt32BE(v.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:C(v.type),id:v.id,ack:v.ack,messageSize:v.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",v.data),this.j(O,v.data)}g(v,O){const j=this.f===0;return this.d.push(v,O),this.f+=v.byteLength+O.byteLength,j}h(){const v=R.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,v}j(v,O){this.g(v,O)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const v=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:v.byteLength}),this.c.write(v)}}class p extends L.Disposable{constructor(v){super(),this.f=new c.Emitter,this.onMessage=this.f.event,this.g=new c.Emitter,this.onDidDispose=this.g.event,this.a=v,this.b=this.B(new f(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(O=>{O.type===1&&this.f.fire(O.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(v){this.b.write(new o(1,0,0,v))}}e.Protocol=p;class y extends E.IPCClient{static fromSocket(v,O){return new y(new p(v),O)}get onDidDispose(){return this.b.onDidDispose}constructor(v,O,j=null){super(v,O,j),this.b=v}dispose(){super.dispose();const v=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),v.end()}}e.Client=y;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new c.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(v){this.b?this.d.length>0?this.d.push(v):this.a.fire(v):this.d.push(v)}flushBuffer(){this.d=[]}}e.BufferedEmitter=g;class t{constructor(v){this.data=v,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let v=0,O=this.a;for(;O;)O=O.next,v++;return v}peek(){return this.a?this.a.data:null}toArray(){const v=[];let O=0,j=this.a;for(;j;)v[O++]=j.data,j=j.next;return v}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(v){const O=new t(v);if(!this.a){this.a=O,this.b=O;return}this.b.next=O,this.b=O}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const v=Date.now();for(let O=0;O<r.a;O++)this.c[O]=v-1e3*O;setInterval(()=>{for(let O=r.a;O>=1;O--)this.c[O]=this.c[O-1];this.c[0]=Date.now()},1e3)}d(){const v=Date.now(),O=(1+r.a)*1e3;let j=0;for(let V=0;V<r.a;V++)v-this.c[V]<=O&&j++;return 1-j/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;var l;(function(w){w[w.Good=0]="Good",w[w.Poor=1]="Poor"})(l=e.ConnectionHealth||(e.ConnectionHealth={}));function u(w){switch(w){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=u;class b{constructor(v){this.connectionHealth=v}}e.ConnectionHealthChangedEvent=b;class i{constructor(v,O){this.roundTripTime=v,this.recentHighRoundTripCount=O}}e.HighRoundTripTimeEvent=i;class n{get unacknowledgedCount(){return this.c-this.d}constructor(v){this.x=new g,this.onControlMessage=this.x.event,this.y=new g,this.onMessage=this.y.event,this.z=new g,this.onDidDispose=this.z.event,this.A=new g,this.onSocketClose=this.A.event,this.B=new g,this.onSocketTimeout=this.B.event,this.C=new g,this.onHighRoundTripTime=this.C.event,this.D=new g,this.onDidChangeConnectionHealth=this.D.event,this.u=v.loadEstimator??r.getInstance(),this.v=v.measureRoundTripTime??!1,this.w=v.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new L.DisposableStore,this.o=v.socket,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(O=>this.E(O))),this.t.add(this.o.onClose(O=>this.A.fire(O))),this.r=this.t.add(new h),this.t.add(this.r.onSendLatencyRequest(O=>this.J(O))),this.t.add(this.r.onHighRoundTripTime(O=>this.C.fire(O))),this.t.add(this.r.onDidChangeConnectionHealth(O=>this.D.fire(O))),this.v&&this.r.start(),v.initialChunk&&this.q.acceptChunk(v.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const v=new o(5,0,0,A());this.p.write(v),this.p.flush()}sendPause(){const v=new o(7,0,0,A());this.p.write(v)}sendResume(){const v=new o(8,0,0,A());this.p.write(v)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(v,O){this.a=!0,this.t.dispose(),this.t=new L.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=v,this.p=this.t.add(new f(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(j=>this.E(j))),this.t.add(this.o.onClose(j=>this.A.fire(j))),this.r=this.t.add(new h),this.t.add(this.r.onSendLatencyRequest(j=>this.J(j))),this.t.add(this.r.onHighRoundTripTime(j=>this.C.fire(j))),this.t.add(this.r.onDidChangeConnectionHealth(j=>this.D.fire(j))),this.q.acceptChunk(O)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const v=new o(3,0,this.h,A());this.p.write(v);const O=this.b.toArray();for(let j=0,V=O.length;j<V;j++)this.p.write(O[j]);this.G()}acceptDisconnect(){this.z.fire()}E(v){if(v.ack>this.d){this.d=v.ack;do{const O=this.b.peek();if(O&&O.id<=v.ack)this.b.pop();else break}while(!0)}switch(v.type){case 0:break;case 1:{if(v.id>this.g)if(v.id!==this.g+1){const O=Date.now();O-this.m>1e4&&(this.m=O,this.p.write(new o(6,0,0,A())))}else this.g=v.id,this.j=Date.now(),this.F(),this.y.fire(v.data);break}case 2:{this.x.fire(v.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const O=this.b.toArray();for(let j=0,V=O.length;j<V;j++)this.p.write(O[j]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(v.data);break}case 11:{this.r.handleResponse(v.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(v){const O=++this.c;this.h=this.g;const j=new o(1,O,this.h,v);this.b.push(j),this.a||(this.p.write(j),this.G())}sendControl(v){const O=new o(2,0,0,v);this.p.write(O)}F(){if(this.g<=this.h||this.k)return;const v=Date.now()-this.j;if(v>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-v+5)}G(){if(this.c<=this.d||this.f||this.a)return;const v=this.b.peek(),O=Date.now()-v.writtenTime,j=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(O>=2e4&&j>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:O,timeSinceLastReceivedSomeData:j});return}const Q=Math.max(2e4-O,2e4-j,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},Q)}H(){if(this.g<=this.h)return;this.h=this.g;const v=new o(3,0,this.h,A());this.p.write(v)}I(){this.h=this.g;const v=new o(9,0,this.h,A());this.p.write(v)}J(v){this.h=this.g;const O=new o(10,0,this.h,v);this.p.write(O)}K(v){this.h=this.g;const O=new o(11,0,this.h,v);this.p.write(O)}}e.PersistentProtocol=n;class h extends L.Disposable{constructor(){super(),this.a=this.B(new c.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new c.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new c.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new a.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},v=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const v=++this.h,O=R.VSBuffer.alloc(4);O.writeUInt32BE(v,0),this.a.fire(O)},6e4)}handleResponse(v){if(v.byteLength!==4)return;const O=v.readUInt32BE(0);if(this.g<=0||O!==this.h)return;const j=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=j;const Q=this.l,G=this.j.filter(U=>U>=1e3).length;this.l=G>=3?1:0,j>1e3&&this.b.fire(new i(j,G)),Q!==this.l&&this.c.fire(this.l)}}}),define(De[119],Ce([1,0,22,10,3,6,12,11,30,117,118]),function(ie,e,a,R,c,L,E,T,S,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function A(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class D{traceSocketEvent(i,n){N.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,i,n)}constructor(i,n=""){this.f=!0,this.debugLabel=n,this.socket=i,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=h=>{if(this.traceSocketEvent("error",{code:h?.code,message:h?.message}),h){if(h.code==="EPIPE")return;(0,R.onUnexpectedError)(h)}},this.socket.on("error",this.a),this.b=h=>{this.traceSocketEvent("close",{hadError:h}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(i){const n=h=>{this.traceSocketEvent("read",h),i(a.VSBuffer.wrap(h))};return this.socket.on("data",n),{dispose:()=>this.socket.off("data",n)}}onClose(i){const n=h=>{i({type:0,hadError:h,error:void 0})};return this.socket.on("close",n),{dispose:()=>this.socket.off("close",n)}}onEnd(i){const n=()=>{i()};return this.socket.on("end",n),{dispose:()=>this.socket.off("end",n)}}write(i){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",i),this.socket.write(i.buffer,n=>{if(n){if(n.code==="EPIPE")return;(0,R.onUnexpectedError)(n)}})}catch(n){if(n.code==="EPIPE")return;(0,R.onUnexpectedError)(n)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((i,n)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),i();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),this.traceSocketEvent("nodeDrainEnd"),i()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=D;var k;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(k||(k={}));var C;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(C||(C={}));class m extends L.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(i,n){this.socket.traceSocketEvent(i,n)}constructor(i,n,h,w){super(),this.f=this.B(new c.Emitter),this.g=this.B(new c.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=i,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:n,inflateBytesLength:h?.byteLength||0,recordInflateBytes:w}),this.a=this.B(new o(this,n,h,w,this.f,(v,O)=>this.k(v,O))),this.B(this.a.onError(v=>{console.error(v),(0,R.onUnexpectedError)(v),this.g.fire({type:0,hadError:!0,error:v})})),this.b=new N.ChunkStream,this.B(this.socket.onData(v=>this.l(v))),this.B(this.socket.onClose(async v=>{this.a.isProcessingReadQueue()&&await c.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(v)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(i){return this.f.event(i)}onClose(i){return this.g.event(i)}onEnd(i){return this.socket.onEnd(i)}write(i){let n=0;for(;n<i.byteLength;)this.a.writeMessage(i.slice(n,Math.min(n+262144,i.byteLength))),n+=262144}k(i,n){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",i);let h=2;i.byteLength<126?h+=0:i.byteLength<2**16?h+=2:h+=8;const w=a.VSBuffer.alloc(h);if(n?w.writeUInt8(194,0):w.writeUInt8(130,0),i.byteLength<126)w.writeUInt8(i.byteLength,1);else if(i.byteLength<2**16){w.writeUInt8(126,1);let v=1;w.writeUInt8(i.byteLength>>>8&255,++v),w.writeUInt8(i.byteLength>>>0&255,++v)}else{w.writeUInt8(127,1);let v=1;w.writeUInt8(0,++v),w.writeUInt8(0,++v),w.writeUInt8(0,++v),w.writeUInt8(0,++v),w.writeUInt8(i.byteLength>>>24&255,++v),w.writeUInt8(i.byteLength>>>16&255,++v),w.writeUInt8(i.byteLength>>>8&255,++v),w.writeUInt8(i.byteLength>>>0&255,++v)}this.socket.write(a.VSBuffer.concat([w,i]))}end(){this.h=!0,this.socket.end()}l(i){if(i.byteLength!==0){for(this.b.acceptChunk(i);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const n=this.b.peek(this.j.readLen),h=n.readUInt8(0),w=(h&128)>>>7,v=(h&64)>>>6,O=n.readUInt8(1),j=(O&128)>>>7,V=O&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=w,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(v)),this.j.firstFrameOfMessage=Boolean(w),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const n=this.b.read(this.j.readLen),h=n.readUInt8(1),w=(h&128)>>>7;let v=h&127,O=1;v===126?v=n.readUInt8(++O)*2**8+n.readUInt8(++O):v===127&&(v=n.readUInt8(++O)*0+n.readUInt8(++O)*0+n.readUInt8(++O)*0+n.readUInt8(++O)*0+n.readUInt8(++O)*2**24+n.readUInt8(++O)*2**16+n.readUInt8(++O)*2**8+n.readUInt8(++O));let j=0;w&&(j=n.readUInt8(++O)*2**24+n.readUInt8(++O)*2**16+n.readUInt8(++O)*2**8+n.readUInt8(++O)),this.j.state=3,this.j.readLen=v,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const n=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",n),p(n,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",n),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(n,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await c.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=m;class o extends L.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(i,n,h,w,v,O){super(),this.l=i,this.m=v,this.n=O,this.a=this.B(new c.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new c.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new c.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,n?(this.b=this.B(new d(this.l,w,h,{windowBits:15})),this.f=this.B(new f(this.l,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(i){this.g.push(i),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const i=this.g.shift();if(this.f){const n=await this.s(this.f,i);this.n(n,!0)}else this.n(i,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(i,n){return new Promise((h,w)=>{i.write(n),i.flush(v=>h(v))})}acceptFrame(i,n,h){this.h.push({data:i,isCompressed:n,isLastFrameOfMessage:h}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const i=this.h.shift();if(this.b&&i.isCompressed){const n=await this.w(this.b,i.data,i.isLastFrameOfMessage);this.m.fire(n)}else this.m.fire(i.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(i,n,h){return new Promise((w,v)=>{i.write(n),h&&i.write(a.VSBuffer.fromByteArray([0,0,255,255])),i.flush(O=>w(O))})}}class d extends L.Disposable{get recordedInflateBytes(){return this.j?a.VSBuffer.concat(this.f):a.VSBuffer.alloc(0)}constructor(i,n,h,w){super(),this.h=i,this.j=n,this.a=this.B(new c.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=A().zlib.createInflateRaw(w),this.b.on("error",v=>{this.h.traceSocketEvent("zlibInflateError",{message:v?.message,code:v?.code}),this.a.fire(v)}),this.b.on("data",v=>{this.h.traceSocketEvent("zlibInflateData",v),this.g.push(a.VSBuffer.wrap(v))}),h&&(this.h.traceSocketEvent("zlibInflateInitialWrite",h.buffer),this.b.write(h.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(i){this.j&&this.f.push(i.clone()),this.h.traceSocketEvent("zlibInflateWrite",i),this.b.write(i.buffer)}flush(i){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const n=a.VSBuffer.concat(this.g);this.g.length=0,i(n)})}}class f extends L.Disposable{constructor(i,n){super(),this.g=i,this.a=this.B(new c.Emitter),this.onError=this.a.event,this.f=[],this.b=A().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",h=>{this.g.traceSocketEvent("zlibDeflateError",{message:h?.message,code:h?.code}),this.a.fire(h)}),this.b.on("data",h=>{this.g.traceSocketEvent("zlibDeflateData",h),this.f.push(a.VSBuffer.wrap(h))})}write(i){this.g.traceSocketEvent("zlibDeflateWrite",i.buffer),this.b.write(i.buffer)}flush(i){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let n=a.VSBuffer.concat(this.f);this.f.length=0,n=n.slice(0,n.byteLength-4),i(n)})}}function p(b,i){if(i===0)return;const n=b.byteLength>>>2;for(let V=0;V<n;V++){const Q=b.readUInt32BE(V*4);b.writeUInt32BE(Q^i,V*4)}const h=n*4,w=b.byteLength-h,v=i>>>24&255,O=i>>>16&255,j=i>>>8&255;w>=1&&b.writeUInt8(b.readUInt8(h)^v,h),w>=2&&b.writeUInt8(b.readUInt8(h+1)^O,h+1),w>=3&&b.writeUInt8(b.readUInt8(h+2)^j,h+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const y={[2]:107,[1]:103};function g(){const b=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const i=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:A().os.tmpdir(),n=(0,E.join)(i,`vscode-ipc-${b}.sock`);return s(n),n}e.createRandomIPCHandle=g;function t(b,i,n){const h=A().crypto.createHash("md5").update(b).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${n}-${i}-sock`;const w=n.substr(0,4),v=i.substr(0,6),O=h.substr(0,8);let j;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?j=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${O}-${w}-${v}.sock`):j=(0,E.join)(b,`${w}-${v}.sock`),s(j),j}e.createStaticIPCHandle=t;function s(b){const i=y[T.platform];typeof i=="number"&&b.length>=i&&console.warn(`WARNING: IPC handle "${b}" is longer than ${i} chars, try a shorter --user-data-dir`)}class r extends I.IPCServer{static b(i){const n=c.Event.fromNodeEventEmitter(i,"connection");return c.Event.map(n,h=>({protocol:new N.Protocol(new D(h,"ipc-server-connection")),onDidClientDisconnect:c.Event.once(c.Event.fromNodeEventEmitter(h,"close"))}))}constructor(i){super(r.b(i)),this.d=i}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=r;function l(b){return new Promise((i,n)=>{const h=A().net.createServer();h.on("error",n),h.listen(b,()=>{h.removeListener("error",n),i(new r(h))})})}e.serve=l;function u(b,i){return new Promise((n,h)=>{const w=A().net.createConnection(b,()=>{w.removeListener("error",h),n(N.Client.fromSocket(new D(w,`ipc-client${i}`),i))});w.once("error",h)})}e.connect=u}),define(De[165],Ce([1,0,38,12]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function c(L,E,T,S,I,N){if(Array.isArray(L)){let A=0;for(const D of L){const k=c(D,E,T,S,I,N);if(k===10)return k;k>A&&(A=k)}return A}else{if(typeof L=="string")return S?L==="*"?5:L===T?10:0:0;if(L){const{language:A,pattern:D,scheme:k,hasAccessToAllModels:C,notebookType:m}=L;if(!S&&!C)return 0;m&&I&&(E=I);let o=0;if(k)if(k===E.scheme)o=10;else if(k==="*")o=5;else return 0;if(A)if(A===T)o=10;else if(A==="*")o=Math.max(o,5);else return 0;if(m)if(m===N)o=10;else if(m==="*"&&N!==void 0)o=Math.max(o,5);else return 0;if(D){let d;if(typeof D=="string"?d=D:d={...D,base:(0,R.normalize)(D.base)},d===E.fsPath||(0,a.match)(d,E.fsPath))o=10;else return 0}return o}else return 0}}e.score=c}),define(De[166],Ce([1,0,8,53,156]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class L{constructor(T,S,I,N){this.c=T,this.d=S,this.f=I,this.g=N,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(T){T.eol&&T.eol!==this.f&&(this.f=T.eol,this.h=null);const S=T.changes;for(const I of S)this.n(I.range),this.o(new R.Position(I.range.startLineNumber,I.range.startColumn),I.text);this.g=T.versionId,this.j=null}k(){if(!this.h){const T=this.f.length,S=this.d.length,I=new Uint32Array(S);for(let N=0;N<S;N++)I[N]=this.d[N].length+T;this.h=new c.PrefixSumComputer(I)}}l(T,S){this.d[T]=S,this.h&&this.h.setValue(T,this.d[T].length+this.f.length)}n(T){if(T.startLineNumber===T.endLineNumber){if(T.startColumn===T.endColumn)return;this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.startLineNumber-1].substring(T.endColumn-1));return}this.l(T.startLineNumber-1,this.d[T.startLineNumber-1].substring(0,T.startColumn-1)+this.d[T.endLineNumber-1].substring(T.endColumn-1)),this.d.splice(T.startLineNumber,T.endLineNumber-T.startLineNumber),this.h&&this.h.removeValues(T.startLineNumber,T.endLineNumber-T.startLineNumber)}o(T,S){if(S.length===0)return;const I=(0,a.splitLines)(S);if(I.length===1){this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+I[0]+this.d[T.lineNumber-1].substring(T.column-1));return}I[I.length-1]+=this.d[T.lineNumber-1].substring(T.column-1),this.l(T.lineNumber-1,this.d[T.lineNumber-1].substring(0,T.column-1)+I[0]);const N=new Uint32Array(I.length-1);for(let A=1;A<I.length;A++)this.d.splice(T.lineNumber+A-1,0,I[A]),N[A-1]=I[A].length+this.f.length;this.h&&this.h.insertValues(T.lineNumber,N)}}e.MirrorTextModel=L}),define(De[167],Ce([1,0,8,153,53,32,107]),function(ie,e,a,R,c,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class S{constructor(f,p,y,g){this.searchString=f,this.isRegex=p,this.matchCase=y,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let f;this.isRegex?f=I(this.searchString):f=this.searchString.indexOf(`
`)>=0;let p=null;try{p=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:f,global:!0,unicode:!0})}catch{return null}if(!p)return null;let y=!this.isRegex&&!f;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new E.SearchData(p,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}e.SearchParams=S;function I(d){if(!d||d.length===0)return!1;for(let f=0,p=d.length;f<p;f++){const y=d.charCodeAt(f);if(y===10)return!0;if(y===92){if(f++,f>=p)break;const g=d.charCodeAt(f);if(g===110||g===114||g===87)return!0}}return!1}e.isMultilineRegexSource=I;function N(d,f,p){if(!p)return new E.FindMatch(d,null);const y=[];for(let g=0,t=f.length;g<t;g++)y[g]=f[g];return new E.FindMatch(d,y)}e.createFindMatch=N;class A{constructor(f){const p=[];let y=0;for(let g=0,t=f.length;g<t;g++)f.charCodeAt(g)===10&&(p[y++]=g);this.a=p}findLineFeedCountBeforeOffset(f){const p=this.a;let y=0,g=p.length-1;if(g===-1||f<=p[0])return 0;for(;y<g;){const t=y+((g-y)/2>>0);p[t]>=f?g=t-1:p[t+1]>=f?(y=t,g=t):y=t+1}return y+1}}class D{static findMatches(f,p,y,g,t){const s=p.parseSearchRequest();return s?s.regex.multiline?this.b(f,y,new o(s.wordSeparators,s.regex),g,t):this.c(f,y,s,g,t):[]}static a(f,p,y,g,t,s){let r,l=0;g?(l=g.findLineFeedCountBeforeOffset(t),r=p+t+l):r=p+t;let u;if(g){const h=g.findLineFeedCountBeforeOffset(t+s.length)-l;u=r+s.length+h}else u=r+s.length;const b=f.getPositionAt(r),i=f.getPositionAt(u);return new L.Range(b.lineNumber,b.column,i.lineNumber,i.column)}static b(f,p,y,g,t){const s=f.getOffsetAt(p.getStartPosition()),r=f.getValueInRange(p,1),l=f.getEOL()===`\r
`?new A(r):null,u=[];let b=0,i;for(y.reset(0);i=y.next(r);)if(u[b++]=N(this.a(f,s,r,l,i.index,i[0]),i,g),b>=t)return u;return u}static c(f,p,y,g,t){const s=[];let r=0;if(p.startLineNumber===p.endLineNumber){const u=f.getLineContent(p.startLineNumber).substring(p.startColumn-1,p.endColumn-1);return r=this.d(y,u,p.startLineNumber,p.startColumn-1,r,s,g,t),s}const l=f.getLineContent(p.startLineNumber).substring(p.startColumn-1);r=this.d(y,l,p.startLineNumber,p.startColumn-1,r,s,g,t);for(let u=p.startLineNumber+1;u<p.endLineNumber&&r<t;u++)r=this.d(y,f.getLineContent(u),u,0,r,s,g,t);if(r<t){const u=f.getLineContent(p.endLineNumber).substring(0,p.endColumn-1);r=this.d(y,u,p.endLineNumber,0,r,s,g,t)}return s}static d(f,p,y,g,t,s,r,l){const u=f.wordSeparators;if(!r&&f.simpleSearch){const n=f.simpleSearch,h=n.length,w=p.length;let v=-h;for(;(v=p.indexOf(n,v+h))!==-1;)if((!u||m(u,p,w,v,h))&&(s[t++]=new E.FindMatch(new L.Range(y,v+1+g,y,v+1+h+g),null),t>=l))return t;return t}const b=new o(f.wordSeparators,f.regex);let i;b.reset(0);do if(i=b.next(p),i&&(s[t++]=N(new L.Range(y,i.index+1+g,y,i.index+1+i[0].length+g),i,r),t>=l))return t;while(i);return t}static findNextMatch(f,p,y,g){const t=p.parseSearchRequest();if(!t)return null;const s=new o(t.wordSeparators,t.regex);return t.regex.multiline?this.e(f,y,s,g):this.f(f,y,s,g)}static e(f,p,y,g){const t=new c.Position(p.lineNumber,1),s=f.getOffsetAt(t),r=f.getLineCount(),l=f.getValueInRange(new L.Range(t.lineNumber,t.column,r,f.getLineMaxColumn(r)),1),u=f.getEOL()===`\r
`?new A(l):null;y.reset(p.column-1);const b=y.next(l);return b?N(this.a(f,s,l,u,b.index,b[0]),b,g):p.lineNumber!==1||p.column!==1?this.e(f,new c.Position(1,1),y,g):null}static f(f,p,y,g){const t=f.getLineCount(),s=p.lineNumber,r=f.getLineContent(s),l=this.g(y,r,s,p.column,g);if(l)return l;for(let u=1;u<=t;u++){const b=(s+u-1)%t,i=f.getLineContent(b+1),n=this.g(y,i,b+1,1,g);if(n)return n}return null}static g(f,p,y,g,t){f.reset(g-1);const s=f.next(p);return s?N(new L.Range(y,s.index+1,y,s.index+1+s[0].length),s,t):null}static findPreviousMatch(f,p,y,g){const t=p.parseSearchRequest();if(!t)return null;const s=new o(t.wordSeparators,t.regex);return t.regex.multiline?this.h(f,y,s,g):this.j(f,y,s,g)}static h(f,p,y,g){const t=this.b(f,new L.Range(1,1,p.lineNumber,p.column),y,g,10*T);if(t.length>0)return t[t.length-1];const s=f.getLineCount();return p.lineNumber!==s||p.column!==f.getLineMaxColumn(s)?this.h(f,new c.Position(s,f.getLineMaxColumn(s)),y,g):null}static j(f,p,y,g){const t=f.getLineCount(),s=p.lineNumber,r=f.getLineContent(s).substring(0,p.column-1),l=this.k(y,r,s,g);if(l)return l;for(let u=1;u<=t;u++){const b=(t+s-u-1)%t,i=f.getLineContent(b+1),n=this.k(y,i,b+1,g);if(n)return n}return null}static k(f,p,y,g){let t=null,s;for(f.reset(0);s=f.next(p);)t=N(new L.Range(y,s.index+1,y,s.index+1+s[0].length),s,g);return t}}e.TextModelSearch=D;function k(d,f,p,y,g){if(y===0)return!0;const t=f.charCodeAt(y-1);if(d.get(t)!==0||t===13||t===10)return!0;if(g>0){const s=f.charCodeAt(y);if(d.get(s)!==0)return!0}return!1}function C(d,f,p,y,g){if(y+g===p)return!0;const t=f.charCodeAt(y+g);if(d.get(t)!==0||t===13||t===10)return!0;if(g>0){const s=f.charCodeAt(y+g-1);if(d.get(s)!==0)return!0}return!1}function m(d,f,p,y,g){return k(d,f,p,y,g)&&C(d,f,p,y,g)}e.isValidMatch=m;class o{constructor(f,p){this._wordSeparators=f,this.a=p,this.b=-1,this.c=0}reset(f){this.a.lastIndex=f,this.b=-1,this.c=0}next(f){const p=f.length;let y;do{if(this.b+this.c===p||(y=this.a.exec(f),!y))return null;const g=y.index,t=y[0].length;if(g===this.b&&t===this.c){if(t===0){a.getNextCodePoint(f,p,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=g,this.c=t,!this._wordSeparators||m(this._wordSeparators,f,p,g,t))return y}while(y);return null}}e.Searcher=o}),define(De[120],Ce([1,0,22,11]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var c;(function(A){A[A.Full=1]="Full",A[A.Delta=2]="Delta"})(c||(c={}));function L(A){for(let D=0,k=A.length;D<k;D+=4){const C=A[D+0],m=A[D+1],o=A[D+2],d=A[D+3];A[D+0]=d,A[D+1]=o,A[D+2]=m,A[D+3]=C}}function E(A){const D=new Uint8Array(A.buffer,A.byteOffset,A.length*4);return R.isLittleEndian()||L(D),a.VSBuffer.wrap(D)}function T(A){const D=A.buffer;if(R.isLittleEndian()||L(D),D.byteOffset%4===0)return new Uint32Array(D.buffer,D.byteOffset,D.length/4);{const k=new Uint8Array(D.byteLength);return k.set(D),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function S(A){const D=new Uint32Array(I(A));let k=0;if(D[k++]=A.id,A.type==="full")D[k++]=1,D[k++]=A.data.length,D.set(A.data,k),k+=A.data.length;else{D[k++]=2,D[k++]=A.deltas.length;for(const C of A.deltas)D[k++]=C.start,D[k++]=C.deleteCount,C.data?(D[k++]=C.data.length,D.set(C.data,k),k+=C.data.length):D[k++]=0}return E(D)}e.encodeSemanticTokensDto=S;function I(A){let D=0;if(D+=1+1,A.type==="full")D+=1+A.data.length;else{D+=1,D+=(1+1+1)*A.deltas.length;for(const k of A.deltas)k.data&&(D+=k.data.length)}return D}function N(A){const D=T(A);let k=0;const C=D[k++];if(D[k++]===1){const f=D[k++],p=D.subarray(k,k+f);return k+=f,{id:C,type:"full",data:p}}const o=D[k++],d=[];for(let f=0;f<o;f++){const p=D[k++],y=D[k++],g=D[k++];let t;g>0&&(t=D.subarray(k,k+g),k+=g),d[f]={start:p,deleteCount:y,data:t}}return{id:C,type:"delta",deltas:d}}e.decodeSemanticTokensDto=N}),define(De[168],Ce([1,0,3,6]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class c{constructor(){this.a=new Map,this.b=new Map,this.c=new a.Emitter,this.onDidChange=this.c.event,this.d=null}fire(T){this.c.fire({changedLanguages:T,changedColorMap:!1})}register(T,S){return this.a.set(T,S),this.fire([T]),(0,R.toDisposable)(()=>{this.a.get(T)===S&&(this.a.delete(T),this.fire([T]))})}registerFactory(T,S){this.b.get(T)?.dispose();const I=new L(this,T,S);return this.b.set(T,I),(0,R.toDisposable)(()=>{const N=this.b.get(T);!N||N!==I||(this.b.delete(T),N.dispose())})}async getOrCreate(T){const S=this.get(T);if(S)return S;const I=this.b.get(T);return!I||I.isResolved?null:(await I.resolve(),this.get(T))}get(T){return this.a.get(T)||null}isResolved(T){if(this.get(T))return!0;const I=this.b.get(T);return!!(!I||I.isResolved)}setColorMap(T){this.d=T,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=c;class L extends R.Disposable{get isResolved(){return this.c}constructor(T,S,I){super(),this.f=T,this.g=S,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const T=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,T&&!this.a&&this.B(this.f.register(this.g,T))}}}),define(De[71],Ce([1,0,67,2,32,168]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class E{constructor(h,w,v){this.offset=h,this.type=w,this.language=v,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=E;class T{constructor(h,w){this.tokens=h,this.endState=w,this._tokenizationResultBrand=void 0}}e.TokenizationResult=T;class S{constructor(h,w){this.tokens=h,this.endState=w,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=S;var I;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(I=e.CompletionItemKind||(e.CompletionItemKind={}));var N;(function(n){const h=new Map;h.set(0,a.Codicon.symbolMethod),h.set(1,a.Codicon.symbolFunction),h.set(2,a.Codicon.symbolConstructor),h.set(3,a.Codicon.symbolField),h.set(4,a.Codicon.symbolVariable),h.set(5,a.Codicon.symbolClass),h.set(6,a.Codicon.symbolStruct),h.set(7,a.Codicon.symbolInterface),h.set(8,a.Codicon.symbolModule),h.set(9,a.Codicon.symbolProperty),h.set(10,a.Codicon.symbolEvent),h.set(11,a.Codicon.symbolOperator),h.set(12,a.Codicon.symbolUnit),h.set(13,a.Codicon.symbolValue),h.set(15,a.Codicon.symbolEnum),h.set(14,a.Codicon.symbolConstant),h.set(15,a.Codicon.symbolEnum),h.set(16,a.Codicon.symbolEnumMember),h.set(17,a.Codicon.symbolKeyword),h.set(27,a.Codicon.symbolSnippet),h.set(18,a.Codicon.symbolText),h.set(19,a.Codicon.symbolColor),h.set(20,a.Codicon.symbolFile),h.set(21,a.Codicon.symbolReference),h.set(22,a.Codicon.symbolCustomColor),h.set(23,a.Codicon.symbolFolder),h.set(24,a.Codicon.symbolTypeParameter),h.set(25,a.Codicon.account),h.set(26,a.Codicon.issues);function w(j){let V=h.get(j);return V||(console.info("No codicon found for CompletionItemKind "+j),V=a.Codicon.symbolProperty),V}n.toIcon=w;const v=new Map;v.set("method",0),v.set("function",1),v.set("constructor",2),v.set("field",3),v.set("variable",4),v.set("class",5),v.set("struct",6),v.set("interface",7),v.set("module",8),v.set("property",9),v.set("event",10),v.set("operator",11),v.set("unit",12),v.set("value",13),v.set("constant",14),v.set("enum",15),v.set("enum-member",16),v.set("enumMember",16),v.set("keyword",17),v.set("snippet",27),v.set("text",18),v.set("color",19),v.set("file",20),v.set("reference",21),v.set("customcolor",22),v.set("folder",23),v.set("type-parameter",24),v.set("typeParameter",24),v.set("account",25),v.set("issue",26);function O(j,V){let Q=v.get(j);return typeof Q>"u"&&!V&&(Q=9),Q}n.fromString=O})(N=e.CompletionItemKinds||(e.CompletionItemKinds={}));var A;(function(n){n[n.Deprecated=1]="Deprecated"})(A=e.CompletionItemTag||(e.CompletionItemTag={}));var D;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(D=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var k;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(k=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var C;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(C=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var m;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(m=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function f(n){return n&&R.URI.isUri(n.uri)&&c.Range.isIRange(n.range)&&(c.Range.isIRange(n.originSelectionRange)||c.Range.isIRange(n.targetSelectionRange))}e.isLocationLink=f;var p;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(p=e.SymbolKind||(e.SymbolKind={}));var y;(function(n){n[n.Deprecated=1]="Deprecated"})(y=e.SymbolTag||(e.SymbolTag={}));var g;(function(n){const h=new Map;h.set(0,a.Codicon.symbolFile),h.set(1,a.Codicon.symbolModule),h.set(2,a.Codicon.symbolNamespace),h.set(3,a.Codicon.symbolPackage),h.set(4,a.Codicon.symbolClass),h.set(5,a.Codicon.symbolMethod),h.set(6,a.Codicon.symbolProperty),h.set(7,a.Codicon.symbolField),h.set(8,a.Codicon.symbolConstructor),h.set(9,a.Codicon.symbolEnum),h.set(10,a.Codicon.symbolInterface),h.set(11,a.Codicon.symbolFunction),h.set(12,a.Codicon.symbolVariable),h.set(13,a.Codicon.symbolConstant),h.set(14,a.Codicon.symbolString),h.set(15,a.Codicon.symbolNumber),h.set(16,a.Codicon.symbolBoolean),h.set(17,a.Codicon.symbolArray),h.set(18,a.Codicon.symbolObject),h.set(19,a.Codicon.symbolKey),h.set(20,a.Codicon.symbolNull),h.set(21,a.Codicon.symbolEnumMember),h.set(22,a.Codicon.symbolStruct),h.set(23,a.Codicon.symbolEvent),h.set(24,a.Codicon.symbolOperator),h.set(25,a.Codicon.symbolTypeParameter);function w(v){let O=h.get(v);return O||(console.info("No codicon found for SymbolKind "+v),O=a.Codicon.symbolProperty),O}n.toIcon=w})(g=e.SymbolKinds||(e.SymbolKinds={}));class t{static fromValue(h){switch(h){case"comment":return t.Comment;case"imports":return t.Imports;case"region":return t.Region}return new t(h)}constructor(h){this.value=h}}t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region"),e.FoldingRangeKind=t;var s;(function(n){function h(w){return!w||typeof w!="object"?!1:typeof w.id=="string"&&typeof w.title=="string"}n.is=h})(s=e.Command||(e.Command={}));var r;(function(n){n[n.Collapsed=0]="Collapsed",n[n.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var l;(function(n){n[n.Unresolved=0]="Unresolved",n[n.Resolved=1]="Resolved"})(l=e.CommentThreadState||(e.CommentThreadState={}));var u;(function(n){n[n.Editing=0]="Editing",n[n.Preview=1]="Preview"})(u=e.CommentMode||(e.CommentMode={}));var b;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new L.TokenizationRegistry;var i;(function(n){n[n.None=0]="None",n[n.Option=1]="Option",n[n.Default=2]="Default",n[n.Preferred=3]="Preferred"})(i=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(De[169],Ce([17,18]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(De[121],Ce([1,0,169,11,106,15,23,152]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=I;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class A{constructor(X,fe,Le,Ne){this.id=X,this.name=fe,this.defaultValue=Le,this.schema=Ne}applyUpdate(X,fe){return k(X,fe)}compute(X,fe,Le){return Le}}class D{constructor(X,fe){this.newValue=X,this.didChange=fe}}e.ApplyUpdateResult=D;function k(z,X){if(typeof z!="object"||typeof X!="object"||!z||!X)return new D(X,z!==X);if(Array.isArray(z)||Array.isArray(X)){const Le=Array.isArray(z)&&Array.isArray(X)&&L.equals(z,X);return new D(X,!Le)}let fe=!1;for(const Le in X)if(X.hasOwnProperty(Le)){const Ne=k(z[Le],X[Le]);Ne.didChange&&(z[Le]=Ne.newValue,fe=!0)}return new D(z,fe)}class C{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,fe){return k(X,fe)}validate(X){return this.defaultValue}}class m{constructor(X,fe,Le,Ne){this.id=X,this.name=fe,this.defaultValue=Le,this.schema=Ne}applyUpdate(X,fe){return k(X,fe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,fe,Le){return Le}}function o(z,X){return typeof z>"u"?X:z==="false"?!1:Boolean(z)}e.boolean=o;class d extends m{constructor(X,fe,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Le),super(X,fe,Le,Ne)}validate(X){return o(X,this.defaultValue)}}function f(z,X,fe,Le){if(typeof z>"u")return X;let Ne=parseInt(z,10);return isNaN(Ne)?X:(Ne=Math.max(fe,Ne),Ne=Math.min(Le,Ne),Ne|0)}e.clampedInt=f;class p extends m{static clampedInt(X,fe,Le,Ne){return f(X,fe,Le,Ne)}constructor(X,fe,Le,Ne,je,_e=void 0){typeof _e<"u"&&(_e.type="integer",_e.default=Le,_e.minimum=Ne,_e.maximum=je),super(X,fe,Le,_e),this.minimum=Ne,this.maximum=je}validate(X){return p.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class y extends m{static clamp(X,fe,Le){return X<fe?fe:X>Le?Le:X}static float(X,fe){if(typeof X=="number")return X;if(typeof X>"u")return fe;const Le=parseFloat(X);return isNaN(Le)?fe:Le}constructor(X,fe,Le,Ne,je){typeof je<"u"&&(je.type="number",je.default=Le),super(X,fe,Le,je),this.validationFn=Ne}validate(X){return this.validationFn(y.float(X,this.defaultValue))}}class g extends m{static string(X,fe){return typeof X!="string"?fe:X}constructor(X,fe,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Le),super(X,fe,Le,Ne)}validate(X){return g.string(X,this.defaultValue)}}function t(z,X,fe){return typeof z!="string"||fe.indexOf(z)===-1?X:z}e.stringSet=t;class s extends m{constructor(X,fe,Le,Ne,je=void 0){typeof je<"u"&&(je.type="string",je.enum=Ne,je.default=Le),super(X,fe,Le,je),this.c=Ne}validate(X){return t(X,this.defaultValue,this.c)}}class r extends A{constructor(X,fe,Le,Ne,je,_e,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=je,Xe.default=Ne),super(X,fe,Le,Xe),this.c=je,this.d=_e}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function l(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends A{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,fe,Le){return Le===0?X.accessibilitySupport:Le}}class b extends A{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:a.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertSpace:o(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function n(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(z){switch(z){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function v(z){switch(z){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class O extends C{constructor(){super(135)}compute(X,fe,Le){const Ne=["monaco-editor"];return fe.get(36)&&Ne.push(fe.get(36)),X.extraEditorClassName&&Ne.push(X.extraEditorClassName),fe.get(70)==="default"?Ne.push("mouse-default"):fe.get(70)==="copy"&&Ne.push("mouse-copy"),fe.get(105)&&Ne.push("showUnused"),fe.get(133)&&Ne.push("showDeprecated"),Ne.join(" ")}}class j extends d{constructor(){super(34,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(X,fe,Le){return Le&&X.emptySelectionClipboard}}class V extends A{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:a.localize(16,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:a.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{cursorMoveOnType:o(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":t(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":t(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(fe.loop,this.defaultValue.loop)}}}class Q extends A{constructor(){super(48,"fontLigatures",Q.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?Q.OFF:X==="true"?Q.ON:X:Boolean(X)?Q.ON:Q.OFF}}Q.OFF='"liga" off, "calt" off',Q.ON='"liga" on, "calt" on',e.EditorFontLigatures=Q;class G extends A{constructor(){super(51,"fontVariations",G.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?G.OFF:X==="true"?G.TRANSLATE:X:Boolean(X)?G.TRANSLATE:G.OFF}compute(X,fe,Le){return X.fontInfo.fontVariationSettings}}G.OFF="normal",G.TRANSLATE="translate",e.EditorFontVariations=G;class U extends C{constructor(){super(47)}compute(X,fe,Le){return X.fontInfo}}class P extends m{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(X){const fe=y.float(X,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:y.clamp(fe,6,100)}compute(X,fe,Le){return X.fontInfo.fontSize}}class M extends A{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:M.d,maximum:M.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:M.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(p.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,M.d,M.e))}}M.c=["normal","bold","100","200","300","400","500","600","700","800","900"],M.d=1,M.e=1e3;class B extends A{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...fe},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...fe},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Le,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Le,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Le,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Le,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Le,description:a.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{multiple:t(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??t(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??t(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??t(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??t(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??t(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends A{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:a.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:a.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:o(fe.enabled,this.defaultValue.enabled),delay:p.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:o(fe.sticky,this.defaultValue.sticky),above:o(fe.above,this.defaultValue.above)}}}var Y;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(Y=e.RenderMinimap||(e.RenderMinimap={}));class H extends C{constructor(){super(138)}compute(X,fe,Le){return H.computeLayout(fe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const fe=X.height/X.lineHeight,Le=Math.floor(X.paddingTop/X.lineHeight);let Ne=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Ne=Math.max(Ne,fe-1));const je=(Le+X.viewLineCount+Ne)/(X.pixelRatio*X.height),_e=Math.floor(X.viewLineCount/je);return{typicalViewportLineCount:fe,extraLinesBeforeFirstLine:Le,extraLinesBeyondLastLine:Ne,desiredRatio:je,minimapLineCount:_e}}static c(X,fe){const Le=X.outerWidth,Ne=X.outerHeight,je=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const _e=fe.stableMinimapLayoutInput,Xe=_e&&X.outerHeight===_e.outerHeight&&X.lineHeight===_e.lineHeight&&X.typicalHalfwidthCharacterWidth===_e.typicalHalfwidthCharacterWidth&&X.pixelRatio===_e.pixelRatio&&X.scrollBeyondLastLine===_e.scrollBeyondLastLine&&X.paddingTop===_e.paddingTop&&X.paddingBottom===_e.paddingBottom&&X.minimap.enabled===_e.minimap.enabled&&X.minimap.side===_e.minimap.side&&X.minimap.size===_e.minimap.size&&X.minimap.showSlider===_e.minimap.showSlider&&X.minimap.renderCharacters===_e.minimap.renderCharacters&&X.minimap.maxColumn===_e.minimap.maxColumn&&X.minimap.scale===_e.minimap.scale&&X.verticalScrollbarWidth===_e.verticalScrollbarWidth&&X.isViewportWrapping===_e.isViewportWrapping,st=X.lineHeight,at=X.typicalHalfwidthCharacterWidth,mt=X.scrollBeyondLastLine,gt=X.minimap.renderCharacters;let Et=je>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Lt=X.minimap.maxColumn,lt=X.minimap.size,wt=X.minimap.side,Ht=X.verticalScrollbarWidth,Ft=X.viewLineCount,It=X.remainingWidth,pt=X.isViewportWrapping,Tt=gt?2:3;let Mt=Math.floor(je*Ne);const Ot=Mt/je;let Ke=!1,xt=!1,Nt=Tt*Et,Bt=Et/je,Pe=1;if(lt==="fill"||lt==="fit"){const{typicalViewportLineCount:xe,extraLinesBeforeFirstLine:et,extraLinesBeyondLastLine:ut,desiredRatio:ft,minimapLineCount:kt}=H.computeContainedMinimapLineCount({viewLineCount:Ft,scrollBeyondLastLine:mt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Ne,lineHeight:st,pixelRatio:je});if(Ft/kt>1)Ke=!0,xt=!0,Et=1,Nt=1,Bt=Et/je;else{let St=!1,Pt=Et+1;if(lt==="fit"){const zt=Math.ceil((et+Ft+ut)*Nt);pt&&Xe&&It<=fe.stableFitRemainingWidth?(St=!0,Pt=fe.stableFitMaxMinimapScale):St=zt>Mt}if(lt==="fill"||St){Ke=!0;const zt=Et;Nt=Math.min(st*je,Math.max(1,Math.floor(1/ft))),pt&&Xe&&It<=fe.stableFitRemainingWidth&&(Pt=fe.stableFitMaxMinimapScale),Et=Math.min(Pt,Math.max(1,Math.floor(Nt/Tt))),Et>zt&&(Pe=Math.min(2,Et/zt)),Bt=Et/je/Pe,Mt=Math.ceil(Math.max(xe,et+Ft+ut)*Nt),pt?(fe.stableMinimapLayoutInput=X,fe.stableFitRemainingWidth=It,fe.stableFitMaxMinimapScale=Et):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const Oe=Math.floor(Lt*Bt),ye=Math.min(Oe,Math.max(0,Math.floor((It-Ht-2)*Bt/(at+Bt)))+e.MINIMAP_GUTTER_WIDTH);let ne=Math.floor(je*ye);const Fe=ne/je;ne=Math.floor(ne*Pe);const We=gt?1:2,Ze=wt==="left"?0:Le-ye-Ht;return{renderMinimap:We,minimapLeft:Ze,minimapWidth:ye,minimapHeightIsEditorHeight:Ke,minimapIsSampling:xt,minimapScale:Et,minimapLineHeight:Nt,minimapCanvasInnerWidth:ne,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:Ot}}static computeLayout(X,fe){const Le=fe.outerWidth|0,Ne=fe.outerHeight|0,je=fe.lineHeight|0,_e=fe.lineNumbersDigitCount|0,Xe=fe.typicalHalfwidthCharacterWidth,st=fe.maxDigitWidth,at=fe.pixelRatio,mt=fe.viewLineCount,gt=X.get(130),Et=gt==="inherit"?X.get(129):gt,Lt=Et==="inherit"?X.get(125):Et,lt=X.get(128),wt=fe.isDominatedByLongLines,Ht=X.get(54),Ft=X.get(64).renderType!==0,It=X.get(65),pt=X.get(99),Tt=X.get(80),Mt=X.get(69),Ot=X.get(97),Ke=Ot.verticalScrollbarSize,xt=Ot.verticalHasArrows,Nt=Ot.arrowSize,Bt=Ot.horizontalScrollbarSize,Pe=X.get(40),Oe=X.get(104)!=="never";let ye=X.get(62);Pe&&Oe&&(ye+=16);let ne=0;if(Ft){const ti=Math.max(_e,It);ne=Math.round(ti*st)}let Fe=0;Ht&&(Fe=je);let We=0,Ze=We+Fe,xe=Ze+ne,et=xe+ye;const ut=Le-Fe-ne-ye;let ft=!1,kt=!1,bt=-1;Et==="inherit"&&wt?(ft=!0,kt=!0):Lt==="on"||Lt==="bounded"?kt=!0:Lt==="wordWrapColumn"&&(bt=lt);const St=H.c({outerWidth:Le,outerHeight:Ne,lineHeight:je,typicalHalfwidthCharacterWidth:Xe,pixelRatio:at,scrollBeyondLastLine:pt,paddingTop:Tt.top,paddingBottom:Tt.bottom,minimap:Mt,verticalScrollbarWidth:Ke,viewLineCount:mt,remainingWidth:ut,isViewportWrapping:kt},fe.memory||new N);St.renderMinimap!==0&&St.minimapLeft===0&&(We+=St.minimapWidth,Ze+=St.minimapWidth,xe+=St.minimapWidth,et+=St.minimapWidth);const Pt=ut-St.minimapWidth,zt=Math.max(1,Math.floor((Pt-Ke-2)/Xe)),At=xt?Nt:0;return kt&&(bt=Math.max(1,zt),Lt==="bounded"&&(bt=Math.min(bt,lt))),{width:Le,height:Ne,glyphMarginLeft:We,glyphMarginWidth:Fe,lineNumbersLeft:Ze,lineNumbersWidth:ne,decorationsLeft:xe,decorationsWidth:ye,contentLeft:et,contentWidth:Pt,minimap:St,viewportColumn:zt,isWordWrapMinified:ft,isViewportWrapping:kt,wrappingColumn:bt,verticalScrollbarWidth:Ke,horizontalScrollbarHeight:Bt,overviewRuler:{top:At,width:Ke,height:Ne-2*At,right:0}}}}e.EditorLayoutInfoComputer=H;class _ extends A{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(46,null),a.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(48,null)}})}validate(X){return t(X,"simple",["simple","advanced"])}compute(X,fe,Le){return fe.get(2)===2?"advanced":Le}}class ee extends A{constructor(){const X={enabled:!0};super(61,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:a.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:o(X.enabled,this.defaultValue.enabled)}}}class be extends A{constructor(){const X={enabled:!1,maxLineCount:5};super(109,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:a.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:a.localize(51,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:o(fe.enabled,this.defaultValue.enabled),maxLineCount:p.clampedInt(fe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class ce extends A{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:a.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(53,null),a.localize(54,null,R.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(55,null,R.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:a.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:a.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:a.localize(59,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return typeof fe.enabled=="boolean"&&(fe.enabled=fe.enabled?"on":"off"),{enabled:t(fe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:p.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(fe.fontFamily,this.defaultValue.fontFamily),padding:o(fe.padding,this.defaultValue.padding)}}}class oe extends A{constructor(){super(62,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):p.clampedInt(X,this.defaultValue,0,1e3)}compute(X,fe,Le){return Le<0?p.clampedInt(-Le*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Le}}class x extends y{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>y.clamp(X,0,150),{markdownDescription:a.localize(60,null)})}compute(X,fe,Le){return X.fontInfo.lineHeight}}class he extends A{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:a.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:a.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(63,null),a.localize(64,null),a.localize(65,null)],default:X.size,description:a.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:a.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:a.localize(68,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:a.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:a.localize(71,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:o(fe.enabled,this.defaultValue.enabled),autohide:o(fe.autohide,this.defaultValue.autohide),size:t(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(fe.side,this.defaultValue.side,["right","left"]),showSlider:t(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(fe.renderCharacters,this.defaultValue.renderCharacters),scale:p.clampedInt(fe.scale,1,1,3),maxColumn:p.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(z){return z==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Se extends A{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{top:p.clampedInt(fe.top,0,0,1e3),bottom:p.clampedInt(fe.bottom,0,0,1e3)}}}class Re extends A{constructor(){const X={enabled:!0,cycle:!0};super(81,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:a.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:a.localize(75,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:o(fe.enabled,this.defaultValue.enabled),cycle:o(fe.cycle,this.defaultValue.cycle)}}}class re extends C{constructor(){super(136)}compute(X,fe,Le){return X.pixelRatio}}class le extends A{constructor(){const X={other:"on",comments:"off",strings:"off"},fe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(76,null),a.localize(77,null),a.localize(78,null)]}];super(84,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:fe,default:X.strings,description:a.localize(79,null)},comments:{anyOf:fe,default:X.comments,description:a.localize(80,null)},other:{anyOf:fe,default:X.other,description:a.localize(81,null)}},default:X,markdownDescription:a.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const at=X?"on":"off";return{comments:at,strings:at,other:at}}if(!X||typeof X!="object")return this.defaultValue;const{other:fe,comments:Le,strings:Ne}=X,je=["on","inline","off"];let _e,Xe,st;return typeof fe=="boolean"?_e=fe?"on":"off":_e=t(fe,this.defaultValue.other,je),typeof Le=="boolean"?Xe=Le?"on":"off":Xe=t(Le,this.defaultValue.comments,je),typeof Ne=="boolean"?st=Ne?"on":"off":st=t(Ne,this.defaultValue.strings,je),{other:_e,comments:Xe,strings:st}}}var de;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(de=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class te extends A{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(83,null),a.localize(84,null),a.localize(85,null),a.localize(86,null)],default:"on",description:a.localize(87,null)})}validate(X){let fe=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(fe=4,Le=X):X==="interval"?fe=3:X==="relative"?fe=2:X==="on"?fe=1:fe=0),{renderType:fe,renderFn:Le}}}function ae(z){const X=z.get(92);return X==="editable"?z.get(86):X!=="on"}e.filterValidationDecorations=ae;class se extends A{constructor(){const X=[],fe={type:"number",description:a.localize(88,null)};super(96,"rulers",X,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:a.localize(89,null),format:"color-hex"}}}]},default:X,description:a.localize(90,null)})}validate(X){if(Array.isArray(X)){const fe=[];for(const Le of X)if(typeof Le=="number")fe.push({column:p.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Ne=Le;fe.push({column:p.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return fe.sort((Le,Ne)=>Le.column-Ne.column),fe}return this.defaultValue}}function F(z,X){if(typeof z!="string")return X;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends A{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(91,null),a.localize(92,null),a.localize(93,null)],default:"auto",description:a.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(95,null),a.localize(96,null),a.localize(97,null)],default:"auto",description:a.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:a.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:a.localize(101,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X,Le=p.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=p.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:p.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:F(fe.vertical,this.defaultValue.vertical),horizontal:F(fe.horizontal,this.defaultValue.horizontal),useShadows:o(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:p.clampedInt(fe.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:p.clampedInt(fe.verticalSliderSize,Ne,0,1e3),scrollByPage:o(fe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends A{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:a.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:a.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:a.localize(108,null)}})}applyUpdate(X,fe){let Le=!1;fe.allowedCharacters&&X&&(E.equals(X.allowedCharacters,fe.allowedCharacters)||(X={...X,allowedCharacters:fe.allowedCharacters},Le=!0)),fe.allowedLocales&&X&&(E.equals(X.allowedLocales,fe.allowedLocales)||(X={...X,allowedLocales:fe.allowedLocales},Le=!0));const Ne=super.applyUpdate(X,fe);return Le?new D(Ne.newValue,!0):Ne}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{nonBasicASCII:Ae(fe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(fe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(fe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(fe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(fe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,fe){if(typeof X!="object"||!X)return fe;const Le={};for(const[Ne,je]of Object.entries(X))je===!0&&(Le[Ne]=!0);return Le}}class J extends A{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:a.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[a.localize(110,null),a.localize(111,null)],description:a.localize(112,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:o(fe.enabled,this.defaultValue.enabled),mode:t(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:t(fe.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class ue extends A{constructor(){const X={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:a.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:a.localize(114,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:o(fe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(fe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends A{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(115,null),a.localize(116,null),a.localize(117,null)],default:X.bracketPairs,description:a.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(119,null),a.localize(120,null),a.localize(121,null)],default:X.bracketPairsHorizontal,description:a.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:a.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:a.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(125,null),a.localize(126,null),a.localize(127,null)],default:X.highlightActiveIndentation,description:a.localize(128,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{bracketPairs:Ae(fe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(fe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(fe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(fe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(fe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae(z,X,fe){const Le=fe.indexOf(z);return Le===-1?X:fe[Le]}class ve extends A{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(129,null),a.localize(130,null)],default:X.insertMode,description:a.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:a.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:a.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:a.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(135,null),a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:X.selectionMode,markdownDescription:a.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:a.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:a.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:a.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:a.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:a.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertMode:t(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(fe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(fe.showIcons,this.defaultValue.showIcons),showStatusBar:o(fe.showStatusBar,this.defaultValue.showStatusBar),preview:o(fe.preview,this.defaultValue.preview),previewMode:t(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(fe.showMethods,this.defaultValue.showMethods),showFunctions:o(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:o(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(fe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(fe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(fe.showFields,this.defaultValue.showFields),showVariables:o(fe.showVariables,this.defaultValue.showVariables),showClasses:o(fe.showClasses,this.defaultValue.showClasses),showStructs:o(fe.showStructs,this.defaultValue.showStructs),showInterfaces:o(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:o(fe.showModules,this.defaultValue.showModules),showProperties:o(fe.showProperties,this.defaultValue.showProperties),showEvents:o(fe.showEvents,this.defaultValue.showEvents),showOperators:o(fe.showOperators,this.defaultValue.showOperators),showUnits:o(fe.showUnits,this.defaultValue.showUnits),showValues:o(fe.showValues,this.defaultValue.showValues),showConstants:o(fe.showConstants,this.defaultValue.showConstants),showEnums:o(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:o(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(fe.showKeywords,this.defaultValue.showKeywords),showWords:o(fe.showWords,this.defaultValue.showWords),showColors:o(fe.showColors,this.defaultValue.showColors),showFiles:o(fe.showFiles,this.defaultValue.showFiles),showReferences:o(fe.showReferences,this.defaultValue.showReferences),showFolders:o(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:o(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(fe.showSnippets,this.defaultValue.showSnippets),showUsers:o(fe.showUsers,this.defaultValue.showUsers),showIssues:o(fe.showIssues,this.defaultValue.showIssues)}}}class Ie extends A{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(177,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var ke;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(ke=e.WrappingIndent||(e.WrappingIndent={}));class He extends A{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(178,null),a.localize(179,null),a.localize(180,null),a.localize(181,null)],description:a.localize(182,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,fe,Le){return fe.get(2)===2?0:Le}}class qe extends C{constructor(){super(139)}compute(X,fe,Le){const Ne=fe.get(138);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class nt extends A{constructor(){const X={enabled:!0};super(33,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:a.localize(183,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:o(X.enabled,this.defaultValue.enabled)}}}const Qe="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?tt:R.isLinux?rt:Qe,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(z){return e.editorOptionsRegistry[z.id]=z,z}var it;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.bracketPairColorization=12]="bracketPairColorization",z[z.guides=13]="guides",z[z.codeLens=14]="codeLens",z[z.codeLensFontFamily=15]="codeLensFontFamily",z[z.codeLensFontSize=16]="codeLensFontSize",z[z.colorDecorators=17]="colorDecorators",z[z.colorDecoratorsLimit=18]="colorDecoratorsLimit",z[z.columnSelection=19]="columnSelection",z[z.comments=20]="comments",z[z.contextmenu=21]="contextmenu",z[z.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",z[z.cursorBlinking=23]="cursorBlinking",z[z.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",z[z.cursorStyle=25]="cursorStyle",z[z.cursorSurroundingLines=26]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",z[z.cursorWidth=28]="cursorWidth",z[z.disableLayerHinting=29]="disableLayerHinting",z[z.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",z[z.domReadOnly=31]="domReadOnly",z[z.dragAndDrop=32]="dragAndDrop",z[z.dropIntoEditor=33]="dropIntoEditor",z[z.emptySelectionClipboard=34]="emptySelectionClipboard",z[z.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",z[z.extraEditorClassName=36]="extraEditorClassName",z[z.fastScrollSensitivity=37]="fastScrollSensitivity",z[z.find=38]="find",z[z.fixedOverflowWidgets=39]="fixedOverflowWidgets",z[z.folding=40]="folding",z[z.foldingStrategy=41]="foldingStrategy",z[z.foldingHighlight=42]="foldingHighlight",z[z.foldingImportsByDefault=43]="foldingImportsByDefault",z[z.foldingMaximumRegions=44]="foldingMaximumRegions",z[z.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=46]="fontFamily",z[z.fontInfo=47]="fontInfo",z[z.fontLigatures=48]="fontLigatures",z[z.fontSize=49]="fontSize",z[z.fontWeight=50]="fontWeight",z[z.fontVariations=51]="fontVariations",z[z.formatOnPaste=52]="formatOnPaste",z[z.formatOnType=53]="formatOnType",z[z.glyphMargin=54]="glyphMargin",z[z.gotoLocation=55]="gotoLocation",z[z.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",z[z.hover=57]="hover",z[z.inDiffEditor=58]="inDiffEditor",z[z.inlineSuggest=59]="inlineSuggest",z[z.letterSpacing=60]="letterSpacing",z[z.lightbulb=61]="lightbulb",z[z.lineDecorationsWidth=62]="lineDecorationsWidth",z[z.lineHeight=63]="lineHeight",z[z.lineNumbers=64]="lineNumbers",z[z.lineNumbersMinChars=65]="lineNumbersMinChars",z[z.linkedEditing=66]="linkedEditing",z[z.links=67]="links",z[z.matchBrackets=68]="matchBrackets",z[z.minimap=69]="minimap",z[z.mouseStyle=70]="mouseStyle",z[z.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=72]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",z[z.multiCursorModifier=74]="multiCursorModifier",z[z.multiCursorPaste=75]="multiCursorPaste",z[z.multiCursorLimit=76]="multiCursorLimit",z[z.occurrencesHighlight=77]="occurrencesHighlight",z[z.overviewRulerBorder=78]="overviewRulerBorder",z[z.overviewRulerLanes=79]="overviewRulerLanes",z[z.padding=80]="padding",z[z.parameterHints=81]="parameterHints",z[z.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",z[z.quickSuggestions=84]="quickSuggestions",z[z.quickSuggestionsDelay=85]="quickSuggestionsDelay",z[z.readOnly=86]="readOnly",z[z.renameOnType=87]="renameOnType",z[z.renderControlCharacters=88]="renderControlCharacters",z[z.renderFinalNewline=89]="renderFinalNewline",z[z.renderLineHighlight=90]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=92]="renderValidationDecorations",z[z.renderWhitespace=93]="renderWhitespace",z[z.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",z[z.roundedSelection=95]="roundedSelection",z[z.rulers=96]="rulers",z[z.scrollbar=97]="scrollbar",z[z.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=99]="scrollBeyondLastLine",z[z.scrollPredominantAxis=100]="scrollPredominantAxis",z[z.selectionClipboard=101]="selectionClipboard",z[z.selectionHighlight=102]="selectionHighlight",z[z.selectOnLineNumbers=103]="selectOnLineNumbers",z[z.showFoldingControls=104]="showFoldingControls",z[z.showUnused=105]="showUnused",z[z.snippetSuggestions=106]="snippetSuggestions",z[z.smartSelect=107]="smartSelect",z[z.smoothScrolling=108]="smoothScrolling",z[z.stickyScroll=109]="stickyScroll",z[z.stickyTabStops=110]="stickyTabStops",z[z.stopRenderingLineAfter=111]="stopRenderingLineAfter",z[z.suggest=112]="suggest",z[z.suggestFontSize=113]="suggestFontSize",z[z.suggestLineHeight=114]="suggestLineHeight",z[z.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",z[z.suggestSelection=116]="suggestSelection",z[z.tabCompletion=117]="tabCompletion",z[z.tabIndex=118]="tabIndex",z[z.unicodeHighlighting=119]="unicodeHighlighting",z[z.unusualLineTerminators=120]="unusualLineTerminators",z[z.useShadowDOM=121]="useShadowDOM",z[z.useTabStops=122]="useTabStops",z[z.wordBreak=123]="wordBreak",z[z.wordSeparators=124]="wordSeparators",z[z.wordWrap=125]="wordWrap",z[z.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=128]="wordWrapColumn",z[z.wordWrapOverride1=129]="wordWrapOverride1",z[z.wordWrapOverride2=130]="wordWrapOverride2",z[z.wrappingIndent=131]="wrappingIndent",z[z.wrappingStrategy=132]="wrappingStrategy",z[z.showDeprecated=133]="showDeprecated",z[z.inlayHints=134]="inlayHints",z[z.editorClassName=135]="editorClassName",z[z.pixelRatio=136]="pixelRatio",z[z.tabFocusMode=137]="tabFocusMode",z[z.layoutInfo=138]="layoutInfo",z[z.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(184,null)})),acceptSuggestionOnEnter:Be(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(185,null),""],markdownDescription:a.localize(186,null)})),accessibilitySupport:Be(new u),accessibilityPageSize:Be(new p(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(187,null),tags:["accessibility"]})),ariaLabel:Be(new g(4,"ariaLabel",a.localize(188,null))),autoClosingBrackets:Be(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(189,null),a.localize(190,null),""],description:a.localize(191,null)})),autoClosingDelete:Be(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(192,null),""],description:a.localize(193,null)})),autoClosingOvertype:Be(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(194,null),""],description:a.localize(195,null)})),autoClosingQuotes:Be(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(196,null),a.localize(197,null),""],description:a.localize(198,null)})),autoIndent:Be(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[a.localize(199,null),a.localize(200,null),a.localize(201,null),a.localize(202,null),a.localize(203,null)],description:a.localize(204,null)})),automaticLayout:Be(new d(10,"automaticLayout",!1)),autoSurround:Be(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(205,null),a.localize(206,null),a.localize(207,null),""],description:a.localize(208,null)})),bracketPairColorization:Be(new ue),bracketPairGuides:Be(new we),stickyTabStops:Be(new d(110,"stickyTabStops",!1,{description:a.localize(209,null)})),codeLens:Be(new d(14,"codeLens",!0,{description:a.localize(210,null)})),codeLensFontFamily:Be(new g(15,"codeLensFontFamily","",{description:a.localize(211,null)})),codeLensFontSize:Be(new p(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(212,null)})),colorDecorators:Be(new d(17,"colorDecorators",!0,{description:a.localize(213,null)})),colorDecoratorsLimit:Be(new p(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(214,null)})),columnSelection:Be(new d(19,"columnSelection",!1,{description:a.localize(215,null)})),comments:Be(new b),contextmenu:Be(new d(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new d(22,"copyWithSyntaxHighlighting",!0,{description:a.localize(216,null)})),cursorBlinking:Be(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],n,{description:a.localize(217,null)})),cursorSmoothCaretAnimation:Be(new s(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(218,null),a.localize(219,null),a.localize(220,null)],description:a.localize(221,null)})),cursorStyle:Be(new r(25,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],v,{description:a.localize(222,null)})),cursorSurroundingLines:Be(new p(26,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(223,null)})),cursorSurroundingLinesStyle:Be(new s(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(224,null),a.localize(225,null)],description:a.localize(226,null)})),cursorWidth:Be(new p(28,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(227,null)})),disableLayerHinting:Be(new d(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new d(30,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new d(31,"domReadOnly",!1)),dragAndDrop:Be(new d(32,"dragAndDrop",!0,{description:a.localize(228,null)})),emptySelectionClipboard:Be(new j),dropIntoEditor:Be(new nt),stickyScroll:Be(new be),experimentalWhitespaceRendering:Be(new s(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(229,null),a.localize(230,null),a.localize(231,null)],description:a.localize(232,null)})),extraEditorClassName:Be(new g(36,"extraEditorClassName","")),fastScrollSensitivity:Be(new y(37,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:a.localize(233,null)})),find:Be(new V),fixedOverflowWidgets:Be(new d(39,"fixedOverflowWidgets",!1)),folding:Be(new d(40,"folding",!0,{description:a.localize(234,null)})),foldingStrategy:Be(new s(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(235,null),a.localize(236,null)],description:a.localize(237,null)})),foldingHighlight:Be(new d(42,"foldingHighlight",!0,{description:a.localize(238,null)})),foldingImportsByDefault:Be(new d(43,"foldingImportsByDefault",!1,{description:a.localize(239,null)})),foldingMaximumRegions:Be(new p(44,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(240,null)})),unfoldOnClickAfterEndOfLine:Be(new d(45,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(241,null)})),fontFamily:Be(new g(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(242,null)})),fontInfo:Be(new U),fontLigatures2:Be(new Q),fontSize:Be(new P),fontWeight:Be(new M),fontVariations:Be(new G),formatOnPaste:Be(new d(52,"formatOnPaste",!1,{description:a.localize(243,null)})),formatOnType:Be(new d(53,"formatOnType",!1,{description:a.localize(244,null)})),glyphMargin:Be(new d(54,"glyphMargin",!0,{description:a.localize(245,null)})),gotoLocation:Be(new B),hideCursorInOverviewRuler:Be(new d(56,"hideCursorInOverviewRuler",!1,{description:a.localize(246,null)})),hover:Be(new Z),inDiffEditor:Be(new d(58,"inDiffEditor",!1)),letterSpacing:Be(new y(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>y.clamp(z,-5,20),{description:a.localize(247,null)})),lightbulb:Be(new ee),lineDecorationsWidth:Be(new oe),lineHeight:Be(new x),lineNumbers:Be(new te),lineNumbersMinChars:Be(new p(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new d(66,"linkedEditing",!1,{description:a.localize(248,null)})),links:Be(new d(67,"links",!0,{description:a.localize(249,null)})),matchBrackets:Be(new s(68,"matchBrackets","always",["always","near","never"],{description:a.localize(250,null)})),minimap:Be(new he),mouseStyle:Be(new s(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new y(71,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:a.localize(251,null)})),mouseWheelZoom:Be(new d(72,"mouseWheelZoom",!1,{markdownDescription:a.localize(252,null)})),multiCursorMergeOverlapping:Be(new d(73,"multiCursorMergeOverlapping",!0,{description:a.localize(253,null)})),multiCursorModifier:Be(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[a.localize(254,null),a.localize(255,null)],markdownDescription:a.localize(256,null)})),multiCursorPaste:Be(new s(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(257,null),a.localize(258,null)],markdownDescription:a.localize(259,null)})),multiCursorLimit:Be(new p(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(260,null)})),occurrencesHighlight:Be(new d(77,"occurrencesHighlight",!0,{description:a.localize(261,null)})),overviewRulerBorder:Be(new d(78,"overviewRulerBorder",!0,{description:a.localize(262,null)})),overviewRulerLanes:Be(new p(79,"overviewRulerLanes",3,0,3)),padding:Be(new Se),parameterHints:Be(new Re),peekWidgetDefaultFocus:Be(new s(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],description:a.localize(265,null)})),definitionLinkOpensInPeek:Be(new d(83,"definitionLinkOpensInPeek",!1,{description:a.localize(266,null)})),quickSuggestions:Be(new le),quickSuggestionsDelay:Be(new p(85,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(267,null)})),readOnly:Be(new d(86,"readOnly",!1)),renameOnType:Be(new d(87,"renameOnType",!1,{description:a.localize(268,null),markdownDeprecationMessage:a.localize(269,null)})),renderControlCharacters:Be(new d(88,"renderControlCharacters",!0,{description:a.localize(270,null),restricted:!0})),renderFinalNewline:Be(new s(89,"renderFinalNewline",R.isLinux?"dimmed":"on",["off","on","dimmed"],{description:a.localize(271,null)})),renderLineHighlight:Be(new s(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(272,null)],description:a.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Be(new d(91,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(274,null)})),renderValidationDecorations:Be(new s(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new s(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(275,null),a.localize(276,null),a.localize(277,null),""],description:a.localize(278,null)})),revealHorizontalRightPadding:Be(new p(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new d(95,"roundedSelection",!0,{description:a.localize(279,null)})),rulers:Be(new se),scrollbar:Be(new $),scrollBeyondLastColumn:Be(new p(98,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(280,null)})),scrollBeyondLastLine:Be(new d(99,"scrollBeyondLastLine",!0,{description:a.localize(281,null)})),scrollPredominantAxis:Be(new d(100,"scrollPredominantAxis",!0,{description:a.localize(282,null)})),selectionClipboard:Be(new d(101,"selectionClipboard",!0,{description:a.localize(283,null),included:R.isLinux})),selectionHighlight:Be(new d(102,"selectionHighlight",!0,{description:a.localize(284,null)})),selectOnLineNumbers:Be(new d(103,"selectOnLineNumbers",!0)),showFoldingControls:Be(new s(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(285,null),a.localize(286,null),a.localize(287,null)],description:a.localize(288,null)})),showUnused:Be(new d(105,"showUnused",!0,{description:a.localize(289,null)})),showDeprecated:Be(new d(133,"showDeprecated",!0,{description:a.localize(290,null)})),inlayHints:Be(new ce),snippetSuggestions:Be(new s(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(291,null),a.localize(292,null),a.localize(293,null),a.localize(294,null)],description:a.localize(295,null)})),smartSelect:Be(new Ie),smoothScrolling:Be(new d(108,"smoothScrolling",!1,{description:a.localize(296,null)})),stopRenderingLineAfter:Be(new p(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new ve),inlineSuggest:Be(new J),suggestFontSize:Be(new p(113,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new p(114,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new d(115,"suggestOnTriggerCharacters",!0,{description:a.localize(299,null)})),suggestSelection:Be(new s(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(300,null),a.localize(301,null),a.localize(302,null)],description:a.localize(303,null)})),tabCompletion:Be(new s(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(304,null),a.localize(305,null),a.localize(306,null)],description:a.localize(307,null)})),tabIndex:Be(new p(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new q),unusualLineTerminators:Be(new s(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(308,null),a.localize(309,null),a.localize(310,null)],description:a.localize(311,null)})),useShadowDOM:Be(new d(121,"useShadowDOM",!0)),useTabStops:Be(new d(122,"useTabStops",!0,{description:a.localize(312,null)})),wordBreak:Be(new s(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(313,null),a.localize(314,null)],description:a.localize(315,null)})),wordSeparators:Be(new g(124,"wordSeparators",c.USUAL_WORD_SEPARATORS,{description:a.localize(316,null)})),wordWrap:Be(new s(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(317,null),a.localize(318,null),a.localize(319,null),a.localize(320,null)],description:a.localize(321,null)})),wordWrapBreakAfterCharacters:Be(new g(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new g(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new p(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(322,null)})),wordWrapOverride1:Be(new s(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new s(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new O),pixelRatio:Be(new re),tabFocusMode:Be(new d(137,"tabFocusMode",!1,{markdownDescription:a.localize(323,null)})),layoutInfo:Be(new H),wrappingInfo:Be(new qe),wrappingIndent:Be(new He),wrappingStrategy:Be(new _)}}),define(De[170],Ce([17,18]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[171],Ce([17,18]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[172],Ce([17,18]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[173],Ce([17,18]),function(ie,e){return ie.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[174],Ce([17,18]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(De[175],Ce([17,18]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(De[176],Ce([17,18]),function(ie,e){return ie.create("vs/platform/theme/common/iconRegistry",e)}),define(De[177],Ce([17,18]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(De[178],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[179],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[180],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(De[181],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[182],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[183],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[184],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[185],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[186],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[187],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/api/node/extHostTunnelService",e)}),define(De[188],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(De[189],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/common/views",e)}),define(De[190],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[191],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[192],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[193],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[194],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[195],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[196],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[197],Ce([17,18]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[198],Ce([1,0,10]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var R;(function(L){L[L.LParen=0]="LParen",L[L.RParen=1]="RParen",L[L.Neg=2]="Neg",L[L.Eq=3]="Eq",L[L.NotEq=4]="NotEq",L[L.Lt=5]="Lt",L[L.LtEq=6]="LtEq",L[L.Gt=7]="Gt",L[L.GtEq=8]="GtEq",L[L.RegexOp=9]="RegexOp",L[L.RegexStr=10]="RegexStr",L[L.True=11]="True",L[L.False=12]="False",L[L.In=13]="In",L[L.Not=14]="Not",L[L.And=15]="And",L[L.Or=16]="Or",L[L.Str=17]="Str",L[L.QuotedStr=18]="QuotedStr",L[L.Error=19]="Error",L[L.EOF=20]="EOF"})(R=e.TokenType||(e.TokenType={}));class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(E){if(E.type!==19)throw(0,a.illegalArgument)(`expected an error token but got ${JSON.stringify(E)}`);switch(E.lexeme){case"=":return`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you mean '||'?`;default:{const T=E.lexeme;return T&&T.length>1&&T.startsWith("'")?`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you forget to close the string?`:T&&T.length>1&&T.endsWith("'")?`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you forget to open the string?`:`Unexpected token '${E.lexeme}' at offset ${E.offset}`}}}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,a.illegalState)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}get errorTokens(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:this.k(this.h(61)?4:2);break;case 39:this.o();break;case 47:this.q();break;case 61:this.h(61)?this.k(3):this.h(126)?this.k(9):this.l();break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l();break;case 124:this.h(124)?this.k(16):this.l();break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(){const E={type:19,offset:this.d,lexeme:this.c.substring(this.d,this.e)};this.g.push(E),this.f.push(E)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const T=this.c.substring(this.d,this.e),S=c.b.get(T);S?this.k(S):this.f.push({type:17,lexeme:T,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l();return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,T=!1,S=!1;for(;;){if(E>=this.c.length){this.e=E,this.l();return}const N=this.c.charCodeAt(E);if(T)T=!1;else if(N===47&&!S){E++;break}else N===91?S=!0:N===92?T=!0:N===93&&(S=!1);E++}for(;E<this.c.length&&c.a.has(this.c.charCodeAt(E));)E++;this.e=E;const I=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:I,offset:this.d})}r(){return this.e>=this.c.length}}c.a=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0))),c.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=c}),define(De[199],Ce([1,0,24,37,172,320]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const E=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function S(d){return d=d.trim(),d==="*"||E.test(d)}e.isValidVersionStr=S;function I(d){if(!S(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=d.match(E);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=I;function N(d){if(!d)return null;const f=d.majorBase,p=d.majorMustEqual,y=d.minorBase;let g=d.minorMustEqual;const t=d.patchBase;let s=d.patchMustEqual;d.hasCaret&&(f===0||(g=!1),s=!1);let r=0;if(d.preRelease){const l=T.exec(d.preRelease);if(l){const[,u,b,i]=l;r=Date.UTC(Number(u),Number(b)-1,Number(i))}}return{majorBase:f,majorMustEqual:p,minorBase:y,minorMustEqual:g,patchBase:t,patchMustEqual:s,isMinimum:d.hasGreaterEquals,notBefore:r}}e.normalizeVersion=N;function A(d,f,p){let y;typeof d=="string"?y=N(I(d)):y=d;let g;f instanceof Date?g=f.getTime():typeof f=="string"&&(g=new Date(f).getTime());let t;if(typeof p=="string"?t=N(I(p)):t=p,!y||!t)return!1;const s=y.majorBase,r=y.minorBase,l=y.patchBase;let u=t.majorBase,b=t.minorBase,i=t.patchBase;const n=t.notBefore;let h=t.majorMustEqual,w=t.minorMustEqual,v=t.patchMustEqual;return t.isMinimum?s>u?!0:s<u?!1:r>b?!0:r<b||g&&g<n?!1:l>=i:(s===1&&u===0&&(!h||!w||!v)&&(u=1,b=0,i=0,h=!0,w=!1,v=!1),s<u?!1:s>u?!h:r<b?!1:r>b?!w:l<i?!1:l>i?!v:!(g&&g<n))}e.isValidVersion=A;function D(d,f,p,y,g){const t=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return t.push([R.default.Error,c.localize(0,null)]),t;if(typeof y.name!="string")return t.push([R.default.Error,c.localize(1,null,"name")]),t;if(typeof y.version!="string")return t.push([R.default.Error,c.localize(2,null,"version")]),t;if(!y.engines)return t.push([R.default.Error,c.localize(3,null,"engines")]),t;if(typeof y.engines.vscode!="string")return t.push([R.default.Error,c.localize(4,null,"engines.vscode")]),t;if(typeof y.extensionDependencies<"u"&&!o(y.extensionDependencies))return t.push([R.default.Error,c.localize(5,null,"extensionDependencies")]),t;if(typeof y.activationEvents<"u"){if(!o(y.activationEvents))return t.push([R.default.Error,c.localize(6,null,"activationEvents")]),t;if(typeof y.main>"u"&&typeof y.browser>"u")return t.push([R.default.Error,c.localize(7,null,"activationEvents","main")]),t}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&t.push([R.default.Warning,c.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return t.push([R.default.Error,c.localize(9,null,"main")]),t;{const l=(0,a.joinPath)(p,y.main);(0,a.isEqualOrParent)(l,p)||t.push([R.default.Warning,c.localize(10,null,l.path,p.path)])}if(typeof y.activationEvents>"u")return t.push([R.default.Error,c.localize(11,null,"activationEvents","main")]),t}if(typeof y.browser<"u"){if(typeof y.browser!="string")return t.push([R.default.Error,c.localize(12,null,"browser")]),t;{const l=(0,a.joinPath)(p,y.browser);(0,a.isEqualOrParent)(l,p)||t.push([R.default.Warning,c.localize(13,null,l.path,p.path)])}if(typeof y.activationEvents>"u")return t.push([R.default.Error,c.localize(14,null,"activationEvents","browser")]),t}if(!L.valid(y.version))return t.push([R.default.Error,c.localize(15,null)]),t;const s=[];if(!k(d,f,y,g,s))for(const l of s)t.push([R.default.Error,l]);return t}e.validateExtensionManifest=D;function k(d,f,p,y,g){return y||typeof p.main>"u"&&typeof p.browser>"u"?!0:m(d,f,p.engines.vscode,g)}e.isValidExtensionVersion=k;function C(d,f,p){return d==="*"||m(f,p,d)}e.isEngineValid=C;function m(d,f,p,y=[]){const g=N(I(p));if(!g)return y.push(c.localize(16,null,p)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return y.push(c.localize(17,null,p)),!1}else if(!g.majorMustEqual)return y.push(c.localize(18,null,p)),!1;return A(d,f,g)?!0:(y.push(c.localize(19,null,d,p)),!1)}function o(d){if(!Array.isArray(d))return!1;for(let f=0,p=d.length;f<p;f++)if(typeof d[f]!="string")return!1;return!0}}),define(De[122],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(c,L=[],E=!1){this.ctor=c,this.staticArguments=L,this.supportsDelayedInstantiation=E}}e.SyncDescriptor=a}),define(De[90],Ce([1,0,122]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var c;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(c=e.InstantiationType||(e.InstantiationType={}));function L(T,S,I){S instanceof a.SyncDescriptor||(S=new a.SyncDescriptor(S,[],Boolean(I))),R.push([T,S])}e.registerSingleton=L;function E(){return R}e.getSingletonServiceDescriptors=E}),define(De[200],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(L,E){this.key=L,this.data=E,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class R{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const E of this.a.values())E.outgoing.size===0&&L.push(E);return L}insertEdge(L,E){const T=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(E);T.outgoing.set(S.key,S),S.incoming.set(T.key,T)}removeNode(L){const E=this.b(L);this.a.delete(E);for(const T of this.a.values())T.outgoing.delete(E),T.incoming.delete(E)}lookupOrInsertNode(L){const E=this.b(L);let T=this.a.get(E);return T||(T=new a(E,L),this.a.set(E,T)),T}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[E,T]of this.a)L.push(`${E}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,E]of this.a){const T=new Set([L]),S=this.c(E,T);if(S)return S}}c(L,E){for(const[T,S]of L.outgoing){if(E.has(T))return[...E,T].join(" -> ");E.add(T);const I=this.c(S,E);if(I)return I;E.delete(T)}}}e.Graph=R}),define(De[4],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function T(S){return S[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=T})(a=e._util||(e._util={})),e.IInstantiationService=c("instantiationService");function R(E,T,S){T[a.DI_TARGET]===T?T[a.DI_DEPENDENCIES].push({id:E,index:S}):(T[a.DI_DEPENDENCIES]=[{id:E,index:S}],T[a.DI_TARGET]=T)}function c(E){if(a.serviceIds.has(E))return a.serviceIds.get(E);const T=function(S,I,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(T,S,N)};return T.toString=()=>E,a.serviceIds.set(E,T),T}e.createDecorator=c;function L(E){return E}e.refineServiceDecorator=L}),define(De[54],Ce([1,0,9,2,4]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,c.createDecorator)("configurationService");function L(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof R.URI)}e.isConfigurationOverrides=L;function E(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=E;var T;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function I(o,d){const f=Object.create(null);for(const p in o)N(f,p,o[p],d);return f}e.toValuesTree=I;function N(o,d,f,p){const y=d.split("."),g=y.pop();let t=o;for(let s=0;s<y.length;s++){const r=y[s];let l=t[r];switch(typeof l){case"undefined":l=t[r]=Object.create(null);break;case"object":break;default:p(`Ignoring ${d} as ${y.slice(0,s+1).join(".")} is ${JSON.stringify(l)}`);return}t=l}if(typeof t=="object"&&t!==null)try{t[g]=f}catch{p(`Ignoring ${d} as ${y.join(".")} is ${JSON.stringify(t)}`)}else p(`Ignoring ${d} as ${y.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=N;function A(o,d){const f=d.split(".");D(o,f)}e.removeFromValueTree=A;function D(o,d){const f=d.shift();if(d.length===0){delete o[f];return}if(Object.keys(o).indexOf(f)!==-1){const p=o[f];typeof p=="object"&&!Array.isArray(p)&&(D(p,d),Object.keys(p).length===0&&delete o[f])}}function k(o,d,f){function p(t,s){let r=t;for(const l of s){if(typeof r!="object"||r===null)return;r=r[l]}return r}const y=d.split("."),g=p(o,y);return typeof g>"u"?f:g}e.getConfigurationValue=k;function C(o,d,f){Object.keys(d).forEach(p=>{p!=="__proto__"&&(p in o?a.isObject(o[p])&&a.isObject(d[p])?C(o[p],d[p],f):f&&(o[p]=d[p]):o[p]=d[p])})}e.merge=C;function m(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(De[46],Ce([1,0,11,8,198,4]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",a.isMacintosh),E.set("isLinux",a.isLinux),E.set("isWindows",a.isWindows),E.set("isWeb",a.isWeb),E.set("isMacNative",a.isMacintosh&&!a.isWeb),E.set("isEdge",a.isEdge),E.set("isFirefox",a.isFirefox),E.set("isChrome",a.isChrome),E.set("isSafari",a.isSafari);const T=Object.prototype.hasOwnProperty;var S;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return C.INSTANCE}static true(){return m.INSTANCE}static has(P){return o.create(P)}static equals(P,M){return d.create(P,M)}static notEquals(P,M){return y.create(P,M)}static regex(P,M){return b.create(P,M)}static in(P,M){return f.create(P,M)}static notIn(P,M){return p.create(P,M)}static not(P){return g.create(P)}static and(...P){return h.create(P,null,!0)}static or(...P){return w.create(P,null,!0)}static greater(P,M){return s.create(P,M)}static greaterEquals(P,M){return r.create(P,M)}static smaller(P,M){return l.create(P,M)}static smallerEquals(P,M){return u.create(P,M)}static deserializeOrErrorNew(P){if(!P)return{type:"error",lexingErrors:[],parsingErrors:[]};const M=new A,B=M.parse(P);return B===void 0?{type:"error",lexingErrors:M.lexingErrors.map(Z=>c.Scanner.reportError(Z)),parsingErrors:M.parsingErrors}:{type:"ok",expr:B}}static deserialize(P){if(!!P)return this.c(P)}static c(P){const M=P.split("||");return w.create(M.map(B=>this.d(B)),null,!0)}static d(P){const M=P.split("&&");return h.create(M.map(B=>this.f(B)),null,!0)}static f(P){if(P=P.trim(),P.indexOf("!=")>=0){const M=P.split("!=");return y.create(M[0].trim(),this.g(M[1]))}if(P.indexOf("==")>=0){const M=P.split("==");return d.create(M[0].trim(),this.g(M[1]))}if(P.indexOf("=~")>=0){const M=P.split("=~");return b.create(M[0].trim(),this.h(M[1]))}if(P.indexOf(" not in ")>=0){const M=P.split(" not in ");return p.create(M[0].trim(),this.g(M[1]))}if(P.indexOf(" in ")>=0){const M=P.split(" in ");return f.create(M[0].trim(),this.g(M[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(P)){const M=P.split(">=");return r.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(P)){const M=P.split(">");return s.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(P)){const M=P.split("<=");return u.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(P)){const M=P.split("<");return l.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(P)?g.create(P.substr(1).trim()):o.create(P)}static g(P){if(P=P.trim(),P==="true")return!0;if(P==="false")return!1;const M=/^'([^']*)'$/.exec(P);return M?M[1].trim():P}static h(P){if((0,R.isFalsyOrWhitespace)(P))return null;const M=P.indexOf("/"),B=P.lastIndexOf("/");if(M===B||M<0)return null;const Z=P.slice(M+1,B),Y=P[B+1]==="i"?"i":"";try{return new RegExp(Z,Y)}catch{return null}}}e.ContextKeyExpr=I;class N extends Error{}class A{constructor(){this.c=new c.Scanner,this.d=[],this.f=0,this.g=[]}get lexingErrors(){return this.c.errorTokens}get parsingErrors(){return this.g}parse(P){if(P===""){this.g.push("Expected an expression but got an empty string");return}this.d=this.c.reset(P).scan(),this.f=0,this.g=[];try{const M=this.h();if(!this.D())throw this.z(this.C());return M}catch(M){if(!(M instanceof N)){const B=this.C();this.g.push(`Unexpected error: ${M} for token ${c.Scanner.getLexeme(B)} at offset ${B.offset}.`)}return}}h(){return this.k()}k(){const P=[this.l()];for(;this.v(16);){const M=this.l();P.push(M)}return P.length===1?P[0]:I.or(...P)}l(){const P=[this.o()];for(;this.v(15);){const M=this.o();P.push(M)}return P.length===1?P[0]:I.and(...P)}o(){if(this.v(2)){const P=this.C();switch(P.type){case 17:return this.w(),I.not(P.lexeme);case 11:return this.w(),I.false();case 12:return this.w(),I.true();default:throw this.y("KEY, 'true', or 'false'",P)}}return this.s()}s(){const P=this.C();switch(P.type){case 11:return this.w(),I.true();case 12:return this.w(),I.false();case 0:{this.w();const M=this.h();return this.x(1,"')'"),M}case 17:{const M=P.lexeme;if(this.w(),this.v(9)){const Z=this.C();switch(Z.type){case 10:case 19:{const Y=[Z.lexeme];this.w();let H=this.C(),_=0;for(let x=0;x<Z.lexeme.length;x++)Z.lexeme.charCodeAt(x)===40?_++:Z.lexeme.charCodeAt(x)===41&&_--;for(;!this.D()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let x=0;x<H.lexeme.length;x++)H.lexeme.charCodeAt(x)===40?_++:Z.lexeme.charCodeAt(x)===41&&_--}if(_<0)break;Y.push(c.Scanner.getLexeme(H)),this.w(),H=this.C()}const ee=Y.join(""),be=ee.lastIndexOf("/"),ce=be===ee.length-1?void 0:ee.substring(be+1),oe=new RegExp(ee.substring(1,be),ce);return I.regex(M,oe)}case 18:{const Y=Z.lexeme;this.w();let H=null;if(!(0,R.isFalsyOrWhitespace)(Y)){const _=Y.indexOf("/"),ee=Y.lastIndexOf("/");if(_!==ee&&_>=0){const be=Y.slice(_+1,ee),ce=Y[ee+1]==="i"?"i":"";try{H=new RegExp(be,ce)}catch{}}}if(H===null)throw this.y("REGEX",Z);return b.create(M,H)}default:throw this.y("REGEX",this.C())}}if(this.v(14)){this.x(13,"'in' after 'not'");const Z=this.t();return I.notIn(M,Z)}switch(this.C().type){case 3:{this.w();const Z=this.t();switch(Z){case"true":return I.has(M);case"false":return I.not(M);default:return I.equals(M,Z)}}case 4:{this.w();const Z=this.t();switch(Z){case"true":return I.not(M);case"false":return I.has(M);default:return I.notEquals(M,Z)}}case 5:return this.w(),l.create(M,this.t());case 6:return this.w(),u.create(M,this.t());case 7:return this.w(),s.create(M,this.t());case 8:return this.w(),r.create(M,this.t());case 13:return this.w(),I.in(M,this.t());default:return I.has(M)}}default:throw this.y("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this.C())}}t(){const P=this.C();switch(P.type){case 17:case 18:return this.w(),P.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(P){return this.B(P)?(this.w(),!0):!1}w(){return this.D()||this.f++,this.u()}x(P,M){if(this.B(P))return this.w();throw this.y(M,this.C())}y(P,M){return this.A(`Expected ${P} but got '${c.Scanner.getLexeme(M)}' at offset ${M.offset}.`)}z(P){return this.A(`Unexpected '${c.Scanner.getLexeme(P)}' at offset ${P.offset}.`)}A(P){return this.g.push(P),new N}B(P){return this.C().type===P}C(){return this.d[this.f]}D(){return this.C().type===20}}e.Parser=A;function D(U,P){const M=U?U.substituteConstants():void 0,B=P?P.substituteConstants():void 0;return!M&&!B?!0:!M||!B?!1:M.equals(B)}e.expressionsAreEqualWithConstantSubstitution=D;function k(U,P){return U.cmp(P)}class C{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return m.INSTANCE}}C.INSTANCE=new C,e.ContextKeyFalseExpr=C;class m{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return C.INSTANCE}}m.INSTANCE=new m,e.ContextKeyTrueExpr=m;class o{static create(P,M=null){const B=E.get(P);return typeof B=="boolean"?B?m.INSTANCE:C.INSTANCE:new o(P,M)}constructor(P,M){this.key=P,this.c=M,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:O(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=E.get(this.key);return typeof P=="boolean"?P?m.INSTANCE:C.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=o;class d{static create(P,M,B=null){if(typeof M=="boolean")return M?o.create(P,B):g.create(P,B);const Z=E.get(P);return typeof Z=="boolean"?M===(Z?"true":"false")?m.INSTANCE:C.INSTANCE:new d(P,M,B)}constructor(P,M,B){this.c=P,this.d=M,this.f=B,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:j(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=E.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?m.INSTANCE:C.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=d;class f{static create(P,M){return new f(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:j(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.f),B=P.getValue(this.d);return Array.isArray(M)?M.includes(B):typeof B=="string"&&typeof M=="object"&&M!==null?T.call(M,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=f;class p{static create(P,M){return new p(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=11,this.c=f.create(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=p;class y{static create(P,M,B=null){if(typeof M=="boolean")return M?g.create(P,B):o.create(P,B);const Z=E.get(P);return typeof Z=="boolean"?M===(Z?"true":"false")?C.INSTANCE:m.INSTANCE:new y(P,M,B)}constructor(P,M,B){this.c=P,this.d=M,this.f=B,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:j(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=E.get(this.c);if(typeof P=="boolean"){const M=P?"true":"false";return this.d===M?C.INSTANCE:m.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=y;class g{static create(P,M=null){const B=E.get(P);return typeof B=="boolean"?B?C.INSTANCE:m.INSTANCE:new g(P,M)}constructor(P,M){this.c=P,this.d=M,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:O(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=E.get(this.c);return typeof P=="boolean"?P?C.INSTANCE:m.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=o.create(this.c,this)),this.d}}e.ContextKeyNotExpr=g;function t(U,P){if(typeof U=="string"){const M=parseFloat(U);isNaN(M)||(U=M)}return typeof U=="string"||typeof U=="number"?P(U):C.INSTANCE}class s{static create(P,M,B=null){return t(M,Z=>new s(P,Z,B))}constructor(P,M,B){this.c=P,this.d=M,this.f=B,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:j(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=s;class r{static create(P,M,B=null){return t(M,Z=>new r(P,Z,B))}constructor(P,M,B){this.c=P,this.d=M,this.f=B,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:j(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=r;class l{static create(P,M,B=null){return t(M,Z=>new l(P,Z,B))}constructor(P,M,B){this.c=P,this.d=M,this.f=B,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:j(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=l;class u{static create(P,M,B=null){return t(M,Z=>new u(P,Z,B))}constructor(P,M,B){this.c=P,this.d=M,this.f=B,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:j(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=u;class b{static create(P,M){return new b(P,M)}constructor(P,M){this.d=P,this.f=M,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const M=this.f?this.f.source:"",B=P.f?P.f.source:"";return M<B?-1:M>B?1:0}equals(P){if(P.type===this.type){const M=this.f?this.f.source:"",B=P.f?P.f.source:"";return this.d===P.d&&M===B}return!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=i.create(this)),this.c}}e.ContextKeyRegexExpr=b;class i{static create(P){return new i(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(P){return new i(this.c.map(P))}negate(){return this.c}}e.ContextKeyNotRegexExpr=i;function n(U){let P=null;for(let M=0,B=U.length;M<B;M++){const Z=U[M].substituteConstants();if(U[M]!==Z&&P===null){P=[];for(let Y=0;Y<M;Y++)P[Y]=U[Y]}P!==null&&(P[M]=Z)}return P===null?U:P}class h{static create(P,M,B){return h.d(P,M,B)}constructor(P,M){this.expr=P,this.c=M,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,B=this.expr.length;M<B;M++){const Z=k(this.expr[M],P.expr[M]);if(Z!==0)return Z}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,B=this.expr.length;M<B;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=n(this.expr);return P===this.expr?this:h.create(P,this.c,!1)}evaluate(P){for(let M=0,B=this.expr.length;M<B;M++)if(!this.expr[M].evaluate(P))return!1;return!0}static d(P,M,B){const Z=[];let Y=!1;for(const H of P)if(!!H){if(H.type===1){Y=!0;continue}if(H.type===0)return C.INSTANCE;if(H.type===6){Z.push(...H.expr);continue}Z.push(H)}if(Z.length===0&&Y)return m.INSTANCE;if(Z.length!==0){if(Z.length===1)return Z[0];Z.sort(k);for(let H=1;H<Z.length;H++)Z[H-1].equals(Z[H])&&(Z.splice(H,1),H--);if(Z.length===1)return Z[0];for(;Z.length>1;){const H=Z[Z.length-1];if(H.type!==9)break;Z.pop();const _=Z.pop(),ee=Z.length===0,be=w.create(H.expr.map(ce=>h.create([ce,_],null,B)),null,ee);be&&(Z.push(be),Z.sort(k))}if(Z.length===1)return Z[0];if(B){for(let H=0;H<Z.length;H++)for(let _=H+1;_<Z.length;_++)if(Z[H].negate().equals(Z[_]))return C.INSTANCE;if(Z.length===1)return Z[0]}return new h(Z,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new h(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());this.c=w.create(P,this,!0)}return this.c}}class w{static create(P,M,B){return w.d(P,M,B)}constructor(P,M){this.expr=P,this.c=M,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,B=this.expr.length;M<B;M++){const Z=k(this.expr[M],P.expr[M]);if(Z!==0)return Z}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,B=this.expr.length;M<B;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=n(this.expr);return P===this.expr?this:w.create(P,this.c,!1)}evaluate(P){for(let M=0,B=this.expr.length;M<B;M++)if(this.expr[M].evaluate(P))return!0;return!1}static d(P,M,B){let Z=[],Y=!1;if(P){for(let H=0,_=P.length;H<_;H++){const ee=P[H];if(!!ee){if(ee.type===0){Y=!0;continue}if(ee.type===1)return m.INSTANCE;if(ee.type===9){Z=Z.concat(ee.expr);continue}Z.push(ee)}}if(Z.length===0&&Y)return C.INSTANCE;Z.sort(k)}if(Z.length!==0){if(Z.length===1)return Z[0];for(let H=1;H<Z.length;H++)Z[H-1].equals(Z[H])&&(Z.splice(H,1),H--);if(Z.length===1)return Z[0];if(B){for(let H=0;H<Z.length;H++)for(let _=H+1;_<Z.length;_++)if(Z[H].negate().equals(Z[_]))return m.INSTANCE;if(Z.length===1)return Z[0]}return new w(Z,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const M of this.expr)P.push(...M.keys());return P}map(P){return new w(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.c){const P=[];for(const M of this.expr)P.push(M.negate());for(;P.length>1;){const M=P.shift(),B=P.shift(),Z=[];for(const Y of G(M))for(const H of G(B))Z.push(h.create([Y,H],null,!1));P.unshift(w.create(Z,null,!1))}this.c=w.create(P,this,!0)}return this.c}}class v extends o{static all(){return v.d.values()}constructor(P,M,B){super(P,null),this.f=M,typeof B=="object"?v.d.push({...B,key:P}):B!==!0&&v.d.push({key:P,description:B,type:M!=null?typeof M:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return d.create(this.key,P)}notEqualsTo(P){return y.create(this.key,P)}}v.d=[],e.RawContextKey=v,e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function O(U,P){return U<P?-1:U>P?1:0}function j(U,P,M,B){return U<M?-1:U>M?1:P<B?-1:P>B?1:0}function V(U,P){if(U.type===0||P.type===1)return!0;if(U.type===9)return P.type===9?Q(U.expr,P.expr):!1;if(P.type===9){for(const M of P.expr)if(V(U,M))return!0;return!1}if(U.type===6){if(P.type===6)return Q(P.expr,U.expr);for(const M of U.expr)if(V(M,P))return!0;return!1}return U.equals(P)}e.implies=V;function Q(U,P){let M=0,B=0;for(;M<U.length&&B<P.length;){const Z=U[M].cmp(P[B]);if(Z<0)return!1;Z===0&&M++,B++}return M===U.length}function G(U){return U.type===9?U.expr:[U]}}),define(De[201],Ce([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(De[123],Ce([1,0,171,4]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function c(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=c;function L(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function E(d,f){switch(d){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=E;function T(d,f){return f==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function S(d,f,p){return T(f,p)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===p?!0:I(p).includes(d)}e.isTargetPlatformCompatible=S;function I(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function N(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=N;var A;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var D;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(D=e.SortOrder||(e.SortOrder={}));var k;(function(d){d.Install="install",d.Uninstall="uninstall"})(k=e.StatisticType||(e.StatisticType={}));var C;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var m;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal",d.Signature="Signature"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class o extends Error{constructor(f,p){super(f),this.code=p,this.name=p}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,a.localize)(1,null),original:"Preferences"}}),define(De[202],Ce([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(De[203],Ce([1,0,47,16,12,11,109,29,116,173,202]),function(ie,e,a,R,c,L,E,T,S,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const A=I.localize(0,null);class D{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends D{openTerminal(y,g){return this.spawnTerminal(a,y,S.getWindowsShell(),g)}spawnTerminal(y,g,t,s){const r=g.windowsExec||k.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const l=c.basename(r,".exe").toLowerCase();if(l==="cmder")return y.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return r.indexOf(" ")>=0&&u.push('""'),u.push(r),l==="wt"&&u.push("-d ."),new Promise((b,i)=>{const n=o(process),h=y.spawn(t,u,{cwd:s,env:n});h.on("error",i),h.on("exit",()=>b())})}runInTerminal(y,g,t,s,r){const l="windowsExec"in r&&r.windowsExec?r.windowsExec:k.getDefaultTerminalWindows();return new Promise((u,b)=>{const i=`"${g} - ${A}"`,n=`""${t.join('" "')}" & pause"`,h=Object.assign({},o(process),s);Object.keys(h).filter(V=>h[V]===null).forEach(V=>delete h[V]);const w={cwd:g,env:h,windowsVerbatimArguments:!0};let v,O;c.basename(l,".exe")==="wt"?(v=l,O=["-d",".",k.b,"/c",n]):(v=k.b,O=["/c","start",i,"/wait",l,"/c",n]),a.spawn(v,O,w).on("error",V=>{b(d(V))}),u(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const y=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${y?"Sysnative":"System32"}\\cmd.exe`}return k.d}}k.b="cmd.exe",e.WindowsExternalTerminalService=k;class C extends D{openTerminal(y,g){return this.spawnTerminal(a,y,g)}runInTerminal(y,g,t,s,r){const l=r.osxExec||N.DEFAULT_TERMINAL_OSX;return new Promise((u,b)=>{if(l===N.DEFAULT_TERMINAL_OSX||l==="iTerm.app"){const i=l===N.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[R.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${i}.scpt`).fsPath,"-t",y||A,"-w",g];for(const O of t)h.push("-a"),h.push(O);if(s){const O=Object.assign({},o(process),s);for(const j in O){const V=O[j];V===null?(h.push("-u"),h.push(j)):(h.push("-e"),h.push(`${j}=${V}`))}}let w="";const v=a.spawn(C.b,h);v.on("error",O=>{b(d(O))}),v.stderr.on("data",O=>{w+=O.toString()}),v.on("exit",O=>{if(O===0)u(void 0);else if(w){const j=w.split(`
`,1);b(new Error(j[0]))}else b(new Error(I.localize(1,null,i,O)))})}else b(new Error(I.localize(2,null,l)))})}spawnTerminal(y,g,t){const s=g.osxExec||N.DEFAULT_TERMINAL_OSX;return new Promise((r,l)=>{const u=["-a",s];t&&u.push(t);const b=o(process),i=y.spawn("/usr/bin/open",u,{cwd:t,env:b});i.on("error",l),i.on("exit",()=>r())})}}C.b="/usr/bin/osascript",e.MacExternalTerminalService=C;class m extends D{openTerminal(y,g){return this.spawnTerminal(a,y,g)}runInTerminal(y,g,t,s,r){const l=r.linuxExec?Promise.resolve(r.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((u,b)=>{const i=[];l.then(n=>{n.indexOf("gnome-terminal")>=0?i.push("-x"):i.push("-e"),i.push("bash"),i.push("-c");const h=`${f(t)}; echo; read -p "${m.b}" -n1;`;i.push(`''${h}''`);const w=Object.assign({},o(process),s);Object.keys(w).filter(V=>w[V]===null).forEach(V=>delete w[V]);const v={cwd:g,env:w};let O="";const j=a.spawn(n,i,v);j.on("error",V=>{b(d(V))}),j.stderr.on("data",V=>{O+=V.toString()}),j.on("exit",V=>{if(V===0)u(void 0);else if(O){const Q=O.split(`
`,1);b(new Error(Q[0]))}else b(new Error(I.localize(4,null,n,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!L.isLinux)m.d=Promise.resolve("xterm");else{const y=await T.Promises.exists("/etc/debian_version");m.d=new Promise(g=>{y?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return m.d}spawnTerminal(y,g,t){const s=g.linuxExec?Promise.resolve(g.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,l)=>{s.then(u=>{const b=o(process),i=y.spawn(u,[],{cwd:t,env:b});i.on("error",l),i.on("exit",()=>r())})})}}m.b=I.localize(3,null),e.LinuxExternalTerminalService=m;function o(p){const y={...p.env};return(0,E.sanitizeProcessEnvironment)(y),y}function d(p){return"errno"in p&&p.errno==="ENOENT"&&"path"in p&&typeof p.path=="string"?new Error(I.localize(5,null,p.path)):p}function f(p){let y="";for(const g of p)g.indexOf(" ")>=0?y+='"'+g+'"':y+=g,y+=" ";return y}}),define(De[44],Ce([1,0,68,12,8,9,2,174,4,11,16]),function(ie,e,a,R,c,L,E,T,S,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function A(H){return H.create===!0}e.isFileOpenForWriteOptions=A;var D;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(D=e.FileType||(e.FileType={}));var k;(function(H){H[H.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var C;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=m;function o(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=o;function d(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=d;function f(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function p(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=p;function y(H){return m(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var g;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(_,ee){const be=new t(_.toString(),ee);return l(be,ee),be}constructor(_,ee){super(_),this.code=ee}}e.FileSystemProviderError=t;function s(H,_){return t.create(H,_)}e.createFileSystemProviderError=s;function r(H){return H||s((0,T.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=r;function l(H,_){return H.name=_?`${_} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=l;function u(H){if(!H)return g.Unknown;if(H instanceof t)return H.code;const _=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!_)return g.Unknown;switch(_[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=u;function b(H){if(H instanceof O)return H.fileOperationResult;switch(u(H)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=b;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class n{constructor(_,ee,be){this.resource=_,this.operation=ee,this.target=be}isOperation(_){return this.operation===_}}e.FileOperationEvent=n;var h;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class w{constructor(_,ee){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const be=new Map;for(const ce of _){const oe=be.get(ce.type);switch(oe?oe.push([ce.resource,ce]):be.set(ce.type,[[ce.resource,ce]]),ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}}for(const[ce,oe]of be)switch(ce){case 1:this.a=a.TernarySearchTree.forUris(()=>ee),this.a.fill(oe);break;case 0:this.b=a.TernarySearchTree.forUris(()=>ee),this.b.fill(oe);break;case 2:this.c=a.TernarySearchTree.forUris(()=>ee),this.c.fill(oe);break}}contains(_,...ee){return this.d(_,{includeChildren:!1},...ee)}affects(_,...ee){return this.d(_,{includeChildren:!0},...ee)}d(_,ee,...be){if(!_)return!1;const ce=be.length>0;return!!((!ce||be.includes(1))&&(this.a?.get(_)||ee.includeChildren&&this.a?.findSuperstr(_))||(!ce||be.includes(0))&&(this.b?.get(_)||ee.includeChildren&&this.b?.findSuperstr(_))||(!ce||be.includes(2))&&(this.c?.findSubstr(_)||ee.includeChildren&&this.c?.findSuperstr(_)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=w;function v(H,_,ee){return!H||!_||H===_||_.length>H.length?!1:(_.charAt(_.length-1)!==R.sep&&(_+=R.sep),ee?(0,c.startsWithIgnoreCase)(H,_):H.indexOf(_)===0)}e.isParent=v;class O extends Error{constructor(_,ee,be){super(_),this.fileOperationResult=ee,this.options=be}}e.FileOperationError=O;class j extends O{constructor(_,ee,be,ce){super(_,ee,ce),this.fileOperationResult=ee,this.size=be}}e.TooLargeFileOperationError=j;class V extends O{constructor(_,ee,be){super(_,2,be),this.stat=ee}}e.NotModifiedSinceFileOperationError=V;var Q;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var G;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(G=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=U;async function P(H,_){if(!_.hasProvider(E.URI.from({scheme:H.scheme})))return new Promise(ee=>{const be=_.onDidChangeFileSystemProviderRegistrations(ce=>{ce.scheme===H.scheme&&ce.added&&(be.dispose(),ee())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(_){return(0,L.isNumber)(_)||(_=0),_<M.KB?(0,T.localize)(1,null,_.toFixed(0)):_<M.MB?(0,T.localize)(2,null,(_/M.KB).toFixed(2)):_<M.GB?(0,T.localize)(3,null,(_/M.MB).toFixed(2)):_<M.TB?(0,T.localize)(4,null,(_/M.GB).toFixed(2)):(0,T.localize)(5,null,(_/M.TB).toFixed(2))}}M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB,e.ByteSize=M;var B;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function Z(H){return{maxFileSize:H===0?300*M.MB:16*M.GB,maxHeapSize:H===0?700*M.MB:2*700*M.MB}}e.getPlatformFileLimits=Z;function Y(H){const _=typeof H=="string"||H?.scheme===N.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===N.Schemas.file?1024*M.MB:_?10*M.MB:I.isWeb?50*M.MB:1024*M.MB}e.getLargeFileConfirmationLimit=Y}),define(De[91],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...c){this.a=new Map;for(const[L,E]of c)this.set(L,E)}set(c,L){const E=this.a.get(c);return this.a.set(c,L),E}has(c){return this.a.has(c)}get(c){return this.a.get(c)}}e.ServiceCollection=a}),define(De[204],Ce([1,0,19,10,6,122,200,4,91,66]),function(ie,e,a,R,c,L,E,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const N=!1;class A extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class D{constructor(o=new S.ServiceCollection,d=!1,f,p=N){this.f=o,this.g=d,this.h=f,this.i=p,this.o=new Set,this.f.set(T.IInstantiationService,this),this._globalGraph=p?f?._globalGraph??new E.Graph(y=>y):void 0}createChild(o){return new D(o,this.g,this,this.i)}invokeFunction(o,...d){const f=C.traceInvocation(this.i,o);let p=!1;try{return o({get:g=>{if(p)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(g,f);if(!t)throw new Error(`[invokeFunction] unknown service '${g}'`);return t}},...d)}finally{p=!0,f.stop()}}createInstance(o,...d){let f,p;return o instanceof L.SyncDescriptor?(f=C.traceCreation(this.i,o.ctor),p=this.j(o.ctor,o.staticArguments.concat(d),f)):(f=C.traceCreation(this.i,o),p=this.j(o,d,f)),f.stop(),p}j(o,d=[],f){const p=T._util.getServiceDependencies(o).sort((t,s)=>t.index-s.index),y=[];for(const t of p){const s=this.m(t.id,f);s||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),y.push(s)}const g=p.length>0?p[0].index:d.length;if(d.length!==g){console.trace(`[createInstance] First service dependency of ${o.name} at position ${g+1} conflicts with ${d.length} static arguments`);const t=g-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,g)}return Reflect.construct(o,d.concat(y))}k(o,d){if(this.f.get(o)instanceof L.SyncDescriptor)this.f.set(o,d);else if(this.h)this.h.k(o,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const d=this.f.get(o);return!d&&this.h?this.h.l(o):d}m(o,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const f=this.l(o);return f instanceof L.SyncDescriptor?this.q(o,f,d.branch(o,!0)):(d.branch(o,!1),f)}q(o,d,f){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,d,f)}finally{this.o.delete(o)}}r(o,d,f){const p=new E.Graph(t=>t.id.toString());let y=0;const g=[{id:o,desc:d,_trace:f}];for(;g.length;){const t=g.pop();if(p.lookupOrInsertNode(t),y++>1e3)throw new A(p);for(const s of T._util.getServiceDependencies(t.desc.ctor)){const r=this.l(s.id);if(r||this.u(`[createInstance] ${o} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),r instanceof L.SyncDescriptor){const l={id:s.id,desc:r,_trace:t._trace.branch(s.id,!0)};p.insertEdge(t,l),g.push(l)}}}for(;;){const t=p.roots();if(t.length===0){if(!p.isEmpty())throw new A(p);break}for(const{data:s}of t){if(this.l(s.id)instanceof L.SyncDescriptor){const l=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,l)}p.removeNode(s)}}return this.l(o)}s(o,d,f=[],p,y){if(this.f.get(o)instanceof L.SyncDescriptor)return this.t(o,d,f,p,y);if(this.h)return this.h.s(o,d,f,p,y);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(o,d,f=[],p,y){if(p){const g=new D(void 0,this.g,this,this.i);g.c=String(o);const t=new Map,s=new a.IdleValue(()=>{const r=g.j(d,f,y);for(const[l,u]of t){const b=r[l];if(typeof b=="function")for(const i of u)b.apply(r,i)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,l){if(!s.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let i=t.get(l);return i||(i=new I.LinkedList,t.set(l,i)),(h,w,v)=>{const O=i.push([h,w,v]);return(0,c.toDisposable)(O)}}if(l in r)return r[l];const u=s.value;let b=u[l];return typeof b!="function"||(b=b.bind(u),r[l]=b),b},set(r,l,u){return s.value[l]=u,!0},getPrototypeOf(r){return d.prototype}})}else return this.j(d,f,y)}u(o,d){if(d&&console.warn(o),this.g)throw new Error(o)}}e.InstantiationService=D;var k;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(k||(k={}));class C{static traceInvocation(o,d){return o?new C(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):C.c}static traceCreation(o,d){return o?new C(1,d.name):C.c}constructor(o,d){this.type=o,this.name=d,this.g=Date.now(),this.h=[]}branch(o,d){const f=new C(3,o.toString());return this.h.push([o,d,f]),f}stop(){const o=Date.now()-this.g;C.f+=o;let d=!1;function f(y,g){const t=[],s=new Array(y+1).join("	");for(const[r,l,u]of g.h)if(l&&u){d=!0,t.push(`${s}CREATES -> ${r}`);const b=f(y+1,u);b&&t.push(b)}else t.push(`${s}uses -> ${r}`);return t.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${C.f.toFixed(2)}ms)`];(o>2||d)&&C.all.add(p.join(`
`))}}C.all=new Set,C.c=new class extends C{constructor(){super(0,null)}stop(){}branch(){return this}},C.f=0,e.Trace=C}),define(De[13],Ce([1,0,45,3,6,28,11,24,9,2,46,4]),function(ie,e,a,R,c,L,E,T,S,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function D(){return new Date().toISOString()}function k(n){return(0,S.isNumber)(n)}e.isLogLevel=k;var C;(function(n){n[n.Off=0]="Off",n[n.Trace=1]="Trace",n[n.Debug=2]="Debug",n[n.Info=3]="Info",n[n.Warning=4]="Warning",n[n.Error=5]="Error"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function m(n,h,w){switch(h){case C.Trace:n.trace(w);break;case C.Debug:n.debug(w);break;case C.Info:n.info(w);break;case C.Warning:n.warn(w);break;case C.Error:n.error(w);break;case C.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=m;function o(n){let h="";for(let w=0;w<n.length;w++){let v=n[w];if(typeof v=="object")try{v=JSON.stringify(v)}catch{}h+=(w>0?" ":"")+v}return h}e.format=o;class d extends c.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(h){this.b!==h&&(this.b=h,this.c.fire(this.b))}getLevel(){return this.b}f(h){return this.b!==C.Off&&this.b<=h}}e.AbstractLogger=d;class f extends d{constructor(h){super(),this.h=h}f(h){return this.h||super.f(h)}trace(h,...w){this.f(C.Trace)&&this.g(C.Trace,o([h,...w]))}debug(h,...w){this.f(C.Debug)&&this.g(C.Debug,o([h,...w]))}info(h,...w){this.f(C.Info)&&this.g(C.Info,o([h,...w]))}warn(h,...w){this.f(C.Warning)&&this.g(C.Warning,o([h,...w]))}error(h,...w){if(this.f(C.Error))if(h instanceof Error){const v=Array.prototype.slice.call(arguments);v[0]=h.stack,this.g(C.Error,o(v))}else this.g(C.Error,o([h,...w]))}flush(){}}e.AbstractMessageLogger=f;class p extends d{constructor(h=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(h),this.g=!E.isWindows}trace(h,...w){this.f(C.Trace)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,h,...w):console.log(`[main ${D()}]`,h,...w))}debug(h,...w){this.f(C.Debug)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,h,...w):console.log(`[main ${D()}]`,h,...w))}info(h,...w){this.f(C.Info)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,h,...w):console.log(`[main ${D()}]`,h,...w))}warn(h,...w){this.f(C.Warning)&&(this.g?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,h,...w):console.warn(`[main ${D()}]`,h,...w))}error(h,...w){this.f(C.Error)&&(this.g?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,h,...w):console.error(`[main ${D()}]`,h,...w))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class y extends d{constructor(h=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(h)}trace(h,...w){this.f(C.Trace)&&console.log("%cTRACE","color: #888",h,...w)}debug(h,...w){this.f(C.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",h,...w)}info(h,...w){this.f(C.Info)&&console.log("%c INFO","color: #33f",h,...w)}warn(h,...w){this.f(C.Warning)&&console.log("%c WARN","color: #993",h,...w)}error(h,...w){this.f(C.Error)&&console.log("%c  ERR","color: #f33",h,...w)}dispose(){}flush(){}}e.ConsoleLogger=y;class g extends d{constructor(h,w=e.DEFAULT_LOG_LEVEL){super(),this.g=h,this.setLevel(w)}trace(h,...w){this.f(C.Trace)&&this.g.log(C.Trace,[this.h(h),...w])}debug(h,...w){this.f(C.Debug)&&this.g.log(C.Debug,[this.h(h),...w])}info(h,...w){this.f(C.Info)&&this.g.log(C.Info,[this.h(h),...w])}warn(h,...w){this.f(C.Warning)&&this.g.log(C.Warning,[this.h(h),...w])}error(h,...w){this.f(C.Error)&&this.g.log(C.Error,[this.h(h),...w])}h(h){return typeof h=="string"?h:(0,a.toErrorMessage)(h,this.f(C.Trace))}dispose(){}flush(){}}e.AdapterLogger=g;class t extends d{constructor(h){super(),this.g=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const w of this.g)w.setLevel(h);super.setLevel(h)}trace(h,...w){for(const v of this.g)v.trace(h,...w)}debug(h,...w){for(const v of this.g)v.debug(h,...w)}info(h,...w){for(const v of this.g)v.info(h,...w)}warn(h,...w){for(const v of this.g)v.warn(h,...w)}error(h,...w){for(const v of this.g)v.error(h,...w)}flush(){for(const h of this.g)h.flush()}dispose(){for(const h of this.g)h.dispose()}}e.MultiplexLogger=t;class s extends c.Disposable{constructor(h,w,v){if(super(),this.h=h,this.j=w,this.b=new L.ResourceMap,this.c=this.B(new R.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeVisibility=this.g.event,v)for(const O of v)this.b.set(O.resource,{logger:void 0,info:O})}k(h){return(0,S.isString)(h)?[...this.b.values()].find(w=>w.info.id===h):this.b.get(h)}getLogger(h){return this.k(h)?.logger}createLogger(h,w){const v=this.l(h);let O=this.b.get(v)?.logger;const j=w?.logLevel==="always"?C.Trace:w?.logLevel;O||(O=this.m(v,j??this.getLogLevel(v)??this.h,w));const V={logger:O,info:{resource:v,id:w?.id??v.toString(),logLevel:j,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(V.info),this.b.set(v,V),O}l(h){return(0,S.isString)(h)?(0,T.joinPath)(this.j,`${h}.log`):h}setLogLevel(h,w){if(I.URI.isUri(h)){const v=h,O=w,j=this.b.get(v);j&&O!==j.info.logLevel&&(j.info.logLevel=O===this.h?void 0:O,j.logger?.setLevel(O),this.b.set(j.info.resource,j),this.f.fire([v,O]))}else{this.h=h;for(const[v,O]of this.b.entries())this.b.get(v)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(h,w){const v=this.k(h);v&&w!==!v.info.hidden&&(v.info.hidden=!w,this.b.set(v.info.resource,v),this.g.fire([v.info.resource,w]))}getLogLevel(h){let w;return h&&(w=this.b.get(h)?.info.logLevel),w??this.h}registerLogger(h){const w=this.b.get(h.resource);w?w.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this.b.set(h.resource,{info:h,logger:void 0}),this.c.fire({added:[h],removed:[]}))}deregisterLogger(h){const w=this.b.get(h);w&&(w.logger&&w.logger.dispose(),this.b.delete(h),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const h of this.b.values())yield h.info}getRegisteredLogger(h){return this.b.get(h)?.info}dispose(){this.b.forEach(h=>h.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=s;class r{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(h){}getLevel(){return C.Info}trace(h,...w){}debug(h,...w){}info(h,...w){}warn(h,...w){}error(h,...w){}critical(h,...w){}dispose(){}flush(){}}e.NullLogger=r;class l extends r{}e.NullLogService=l;function u(n){if(n.verbose)return C.Trace;if(typeof n.logLevel=="string"){const h=i(n.logLevel.toLowerCase());if(h!==void 0)return h}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function b(n){switch(n){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Off:return"off"}}e.LogLevelToString=b;function i(n){switch(n){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Error;case"off":return C.Off}}e.parseLogLevel=i,e.CONTEXT_LOG_LEVEL=new N.RawContextKey("logLevel",b(C.Info))}),define(De[205],Ce([1,0,6,13]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class c extends a.Disposable{constructor(E,T=[]){super(),this.a=new R.MultiplexLogger([E,...T]),this.B(E.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(E){this.a.setLevel(E)}getLevel(){return this.a.getLevel()}trace(E,...T){this.a.trace(E,...T)}debug(E,...T){this.a.debug(E,...T)}info(E,...T){this.a.info(E,...T)}warn(E,...T){this.a.warn(E,...T)}error(E,...T){this.a.error(E,...T)}flush(){this.a.flush()}}e.LogService=c}),define(De[206],Ce([1,0,44,13]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var c;(function(I){I[I.Trace=0]="Trace",I[I.Debug=1]="Debug",I[I.Info=2]="Info",I[I.Warning=3]="Warning",I[I.Error=4]="Error",I[I.Critical=5]="Critical",I[I.Off=6]="Off"})(c||(c={}));async function L(I,N,A,D,k){try{const C=await new Promise((o,d)=>{ie(["spdlog"],o,d)});C.setFlushOn(c.Trace);const m=await C.createAsyncRotatingLogger(I,N,A,D);return k?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(C){console.error(C)}return null}function E(I,N,A){switch(N){case R.LogLevel.Trace:I.trace(A);break;case R.LogLevel.Debug:I.debug(A);break;case R.LogLevel.Info:I.info(A);break;case R.LogLevel.Warning:I.warn(A);break;case R.LogLevel.Error:I.error(A);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${N}`)}}function T(I,N){switch(N){case R.LogLevel.Trace:I.setLevel(c.Trace);break;case R.LogLevel.Debug:I.setLevel(c.Debug);break;case R.LogLevel.Info:I.setLevel(c.Info);break;case R.LogLevel.Warning:I.setLevel(c.Warning);break;case R.LogLevel.Error:I.setLevel(c.Error);break;case R.LogLevel.Off:I.setLevel(c.Off);break;default:throw new Error(`Invalid log level ${N}`)}}class S extends R.AbstractMessageLogger{constructor(N,A,D,k,C){super(),this.k=[],this.setLevel(C),this.l=this.n(N,A,D,k),this.B(this.onDidChangeLogLevel(m=>{this.m&&T(this.m,m)}))}async n(N,A,D,k){const C=D?6:1,m=30/C*a.ByteSize.MB,o=await L(N,A,m,C,k);if(o){this.m=o,T(this.m,this.getLevel());for(const{level:d,message:f}of this.k)E(this.m,d,f);this.k=[]}}g(N,A){this.m?E(this.m,N,A):this.getLevel()<=N&&this.k.push({level:N,message:A})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=S}),define(De[124],Ce([1,0,37,175,4]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(L=e.MarkerTag||(e.MarkerTag={}));var E;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(E=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function I(C,m){return m-C}S.compare=I;const N=Object.create(null);N[S.Error]=(0,R.localize)(0,null),N[S.Warning]=(0,R.localize)(1,null),N[S.Info]=(0,R.localize)(2,null);function A(C){return N[C]||""}S.toString=A;function D(C){switch(C){case a.default.Error:return S.Error;case a.default.Warning:return S.Warning;case a.default.Info:return S.Info;case a.default.Ignore:return S.Hint}}S.fromSeverity=D;function k(C){switch(C){case S.Error:return a.default.Error;case S.Warning:return a.default.Warning;case S.Info:return a.default.Info;case S.Hint:return a.default.Ignore}}S.toSeverity=k}(E=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(S){const I="";function N(D){return A(D,!0)}S.makeKey=N;function A(D,k){const C=[I];return D.source?C.push(D.source.replace("\xA6","\\\xA6")):C.push(I),D.code?typeof D.code=="string"?C.push(D.code.replace("\xA6","\\\xA6")):C.push(D.code.value.replace("\xA6","\\\xA6")):C.push(I),D.severity!==void 0&&D.severity!==null?C.push(E.toString(D.severity)):C.push(I),D.message&&k?C.push(D.message.replace("\xA6","\\\xA6")):C.push(I),D.startLineNumber!==void 0&&D.startLineNumber!==null?C.push(D.startLineNumber.toString()):C.push(I),D.startColumn!==void 0&&D.startColumn!==null?C.push(D.startColumn.toString()):C.push(I),D.endLineNumber!==void 0&&D.endLineNumber!==null?C.push(D.endLineNumber.toString()):C.push(I),D.endColumn!==void 0&&D.endColumn!==null?C.push(D.endColumn.toString()):C.push(I),C.push(I),C.join("\xA6")}S.makeKeyOptionalMessage=A})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,c.createDecorator)("markerService")}),define(De[207],Ce([1,0,3,37,4]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=R.default,e.INotificationService=(0,c.createDecorator)("notificationService");var L;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(L=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var E;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(E=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new S,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=T;class S{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=S}),define(De[125],Ce([1,0,8,2,4]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,c.createDecorator)("openerService");function L(I,N){return R.URI.isUri(I)?(0,a.equalsIgnoreCase)(I.scheme,N):(0,a.startsWithIgnoreCase)(I,N+":")}e.matchesScheme=L;function E(I,...N){return N.some(A=>L(I,A))}e.matchesSomeScheme=E;function T(I,N){return I.with({fragment:`${N.startLineNumber},${N.startColumn}${N.endLineNumber?`-${N.endLineNumber}${N.endColumn?`,${N.endColumn}`:""}`:""}`})}e.withSelection=T;function S(I){let N;const A=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(I.fragment);return A&&(N={startLineNumber:parseInt(A[1]),startColumn:A[2]?parseInt(A[2]):1,endLineNumber:A[4]?parseInt(A[4]):void 0,endColumn:A[4]?A[5]?parseInt(A[5]):1:void 0},I=I.with({fragment:""})),{selection:N,uri:I}}e.extractSelection=S}),define(De[208],Ce([1,0,11,36]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let c;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.context<"u"){const L=a.globals.vscode.context.configuration();if(L)c=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(c=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(c,{nameShort:`${c.nameShort} Dev`,nameLong:`${c.nameLong} Dev`,dataFolderName:`${c.dataFolderName}-dev`,serverDataFolderName:c.serverDataFolderName?`${c.serverDataFolderName}-dev`:void 0}),!c.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(c,{version:L.version})}}else c={},Object.keys(c).length===0&&Object.assign(c,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=c}),define(De[209],Ce([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__param||function(ie,e){return function(a,R){e(a,R,ie)}};define(De[126],Ce([1,0,19,21,6,4]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var E;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(E=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{get value(){return this.a}constructor(A){this.b=A}report(A){this.a=A,this.b(this.a)}}T.None=Object.freeze({report(){}}),e.Progress=T;let S=class extends c.Disposable{constructor(A,D){super(),this.a=new a.DeferredPromise,D.withProgress(A,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,c.toDisposable)(()=>this.a.complete()))}report(A){this.b?this.b.report(A):this.c=A}};S=Ve([ze(1,e.IProgressService)],S),e.UnmanagedProgress=S;class I extends c.Disposable{constructor(A){super(),this.g=A,this.a=0,this.b=this.B(new c.DisposableStore)}start(A){this.stop();const D=++this.a,k=new R.CancellationTokenSource;return this.f=setTimeout(()=>{D===this.a&&(this.c=this.g.show(!0))},A),this.b.add((0,c.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,c.toDisposable)(()=>k.cancel())),this.b.add((0,c.toDisposable)(()=>this.c?this.c.done():void 0)),{id:D,token:k.token,stop:()=>this.h(D),isCurrent:()=>this.a===D}}stop(){this.h(this.a)}h(A){this.a===A&&this.b.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(De[39],Ce([1,0,51,9]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class c{constructor(){this.a=new Map}add(E,T){a.ok(R.isString(E)),a.ok(R.isObject(T)),a.ok(!this.a.has(E),"There is already an extension with this id"),this.a.set(E,T)}knows(E){return this.a.has(E)}as(E){return this.a.get(E)||null}}e.Registry=new c}),define(De[92],Ce([1,0,3,39]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function c(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class L{constructor(){this.b=new a.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,I){this.a[c(S)]=I,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const E=new L;R.Registry.add(e.Extensions.JSONContribution,E)}),define(De[127],Ce([1,0,15,3,9,170,54,92,39]),function(ie,e,a,R,c,L,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var N;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const A=S.Registry.as(T.Extensions.JSONContribution);class D{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},A.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const r=new Set;this.n(t,s,r),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const s=new Set;this.o(t,s),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const r=new Set;this.o(s,r),this.n(t,!1,r),A.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const r=[];for(const{overrides:l,source:u}of t)for(const b in l)if(s.add(b),e.OVERRIDE_PROPERTY_REGEX.test(b)){const i=this.a.get(b),n=i?.valuesSources??new Map;if(u)for(const O of Object.keys(l[b]))n.set(O,u);const h={...i?.value||{},...l[b]};this.a.set(b,{source:u,value:h,valuesSources:n});const w=(0,E.getLanguageTagSettingPlainKey)(b),v={type:"object",default:h,description:L.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:c.isString(u)?void 0:u,defaultValueSource:u};r.push(...m(b)),this.d[b]=v,this.b.properties[b]=v}else{this.a.set(b,{value:l[b],source:u});const i=this.d[b];i&&(this.w(b,i),this.r(b,i))}this.m(r)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:r,source:l}of t)for(const u in r){const b=this.a.get(u),i=c.isString(l)?l:l?.id,n=c.isString(b?.source)?b?.source:b?.source?.id;if(i===n)if(s.add(u),this.a.delete(u),e.OVERRIDE_PROPERTY_REGEX.test(u))delete this.d[u],delete this.b.properties[u];else{const h=this.d[u];h&&(this.w(u,h),this.r(u,h))}}this.u()}deltaConfiguration(t){let s=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,r){t.forEach(l=>{this.p(l,s,l.extensionInfo,l.restrictedProperties,void 0,r),this.c.push(l),this.q(l)})}o(t,s){const r=l=>{if(l.properties)for(const u in l.properties){s.add(u);const b=this.d[u];b?.policy?.name&&this.e.delete(b.policy.name),delete this.d[u],this.s(u,l.properties[u])}l.allOf?.forEach(u=>r(u))};for(const l of t){r(l);const u=this.c.indexOf(l);u!==-1&&this.c.splice(u,1)}}p(t,s=!0,r,l,u=3,b){u=c.isUndefinedOrNull(t.scope)?u:t.scope;const i=t.properties;if(i)for(const h in i){const w=i[h];if(s&&p(h,w)){delete i[h];continue}if(w.source=r,w.defaultDefaultValue=i[h].default,this.w(h,w),e.OVERRIDE_PROPERTY_REGEX.test(h)?w.scope=void 0:(w.scope=c.isUndefinedOrNull(w.scope)?u:w.scope,w.restricted=c.isUndefinedOrNull(w.restricted)?!!l?.includes(h):w.restricted),i[h].hasOwnProperty("included")&&!i[h].included){this.f[h]=i[h],delete i[h];continue}else this.d[h]=i[h],i[h].policy?.name&&this.e.set(i[h].policy.name,h);!i[h].deprecationMessage&&i[h].markdownDeprecationMessage&&(i[h].deprecationMessage=i[h].markdownDeprecationMessage),b.add(h)}const n=t.allOf;if(n)for(const h of n)this.p(h,s,r,l,u,b)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=r=>{const l=r.properties;if(l)for(const b in l)this.r(b,l[b]);r.allOf?.forEach(s)};s(t)}r(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,r={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,r),e.allSettings.properties[s]=r,e.applicationSettings.properties[s]=r,e.machineSettings.properties[s]=r,e.machineOverridableSettings.properties[s]=r,e.windowSettings.properties[s]=r,e.resourceSettings.properties[s]=r}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,s){const r=this.a.get(t);let l=r?.value,u=r?.source;c.isUndefined(l)&&(l=s.defaultDefaultValue,u=void 0),c.isUndefined(l)&&(l=d(s.type)),s.default=l,s.defaultValueSource=u}}const k="\\[([^\\]]+)\\]",C=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function m(g){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let s=C.exec(g);for(;s?.length;){const r=s[1].trim();r&&t.push(r),s=C.exec(g)}}return(0,a.distinct)(t)}e.overrideIdentifiersFromKey=m;function o(g){return g.reduce((t,s)=>`${t}[${s}]`,"")}e.keyFromOverrideIdentifiers=o;function d(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const f=new D;S.Registry.add(e.Extensions.Configuration,f);function p(g,t){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?L.localize(7,null,g):f.getConfigurationProperties()[g]!==void 0?L.localize(8,null,g):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,g,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.validateProperty=p;function y(){const g=[],t=f.getConfigurationProperties();for(const s of Object.keys(t))g.push([s,t[s].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=y}),define(De[210],Ce([1,0,15,3,147,6,28,23,9,2,54,127,39]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function k(s){return Object.isFrozen(s)?s:T.deepFreeze(s)}class C{constructor(r={},l=[],u=[],b){this.b=r,this.c=l,this.d=u,this.raw=b,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(l=>{if(l instanceof C)return l;const u=new m("");return u.parseRaw(l),u.configurationModel});this.f=r.reduce((l,u)=>u===l?u:l.merge(u),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,N.getConfigurationValue)(this.contents,r):this.contents}inspect(r,l){const u=this.rawConfiguration.getValue(r),b=l?this.rawConfiguration.getOverrideValue(r,l):void 0,i=l?this.rawConfiguration.override(l).getValue(r):u;return{value:u,override:b,merged:i}}getOverrideValue(r,l){const u=this.i(l);return u?r?(0,N.getConfigurationValue)(u,r):u:void 0}getKeysForOverrideIdentifier(r){const l=[];for(const u of this.overrides)u.identifiers.includes(r)&&l.push(...u.keys);return a.distinct(l)}getAllOverrideIdentifiers(){const r=[];for(const l of this.overrides)r.push(...l.identifiers);return a.distinct(r)}override(r){let l=this.a.get(r);return l||(l=this.g(r),this.a.set(r,l)),l}merge(...r){const l=T.deepClone(this.contents),u=T.deepClone(this.overrides),b=[...this.keys],i=this.raw?.length?[...this.raw]:[this];for(const n of r)if(i.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.h(l,n.contents);for(const h of n.overrides){const[w]=u.filter(v=>a.equals(v.identifiers,h.identifiers));w?(this.h(w.contents,h.contents),w.keys.push(...h.keys),w.keys=a.distinct(w.keys)):u.push(T.deepClone(h))}for(const h of n.keys)b.indexOf(h)===-1&&b.push(h)}return new C(l,b,u,i.every(n=>n instanceof C)?void 0:i)}g(r){const l=this.i(r);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const u={};for(const b of a.distinct([...Object.keys(this.contents),...Object.keys(l)])){let i=this.contents[b];const n=l[b];n&&(typeof i=="object"&&typeof n=="object"?(i=T.deepClone(i),this.h(i,n)):i=n),u[b]=i}return new C(u,this.keys,this.overrides)}h(r,l){for(const u of Object.keys(l)){if(u in r&&S.isObject(r[u])&&S.isObject(l[u])){this.h(r[u],l[u]);continue}r[u]=T.deepClone(l[u])}}i(r){let l=null,u=null;const b=i=>{i&&(u?this.h(u,i):u=T.deepClone(i))};for(const i of this.overrides)a.equals(i.identifiers,[r])?l=i.contents:i.identifiers.includes(r)&&b(i.contents);return b(l),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,l){this.j(r,l,!0)}setValue(r,l){this.j(r,l,!1)}removeValue(r){const l=this.keys.indexOf(r);l!==-1&&(this.keys.splice(l,1),(0,N.removeFromValueTree)(this.contents,r),A.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(u=>a.equals(u.identifiers,(0,A.overrideIdentifiersFromKey)(r))),1))}j(r,l,u){(0,N.addToValueTree)(this.contents,r,l,b=>console.error(b)),u=u||this.keys.indexOf(r)===-1,u&&this.keys.push(r),A.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,A.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,N.toValuesTree)(this.contents[r],b=>console.error(b))})}}e.ConfigurationModel=C;class m{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new C}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,l){if(!S.isUndefinedOrNull(r)){const u=this.g(r);this.parseRaw(u,l)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,l){this.a=r;const{contents:u,keys:b,overrides:i,restricted:n,hasExcludedProperties:h}=this.h(r,l);this.b=new C(u,b,i,h?[r]:void 0),this.c=n||[]}g(r){let l={},u=null,b=[];const i=[],n=[];function h(v){Array.isArray(b)?b.push(v):u!==null&&(b[u]=v)}const w={onObjectBegin:()=>{const v={};h(v),i.push(b),b=v,u=null},onObjectProperty:v=>{u=v},onObjectEnd:()=>{b=i.pop()},onArrayBegin:()=>{const v=[];h(v),i.push(b),b=v,u=null},onArrayEnd:()=>{b=i.pop()},onLiteralValue:h,onError:(v,O,j)=>{n.push({error:v,offset:O,length:j})}};if(r)try{c.visit(r,w),l=b[0]||{}}catch(v){console.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return l}h(r,l){const u=D.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),b=this.i(r,u,!0,l);r=b.raw;const i=(0,N.toValuesTree)(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),n=Object.keys(r),h=this.j(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:i,keys:n,overrides:h,restricted:b.restricted,hasExcludedProperties:b.hasExcludedProperties}}i(r,l,u,b){let i=!1;if(!b?.scopes&&!b?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:i};const n={},h=[];for(const w in r)if(A.OVERRIDE_PROPERTY_REGEX.test(w)&&u){const v=this.i(r[w],l,!1,b);n[w]=v.raw,i=i||v.hasExcludedProperties,h.push(...v.restricted)}else{const v=l[w],O=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&h.push(w),(O===void 0||b.scopes===void 0||b.scopes.includes(O))&&!(b.skipRestricted&&v?.restricted)?n[w]=r[w]:i=!0}return{raw:n,restricted:h,hasExcludedProperties:i}}j(r,l){const u=[];for(const b of Object.keys(r))if(A.OVERRIDE_PROPERTY_REGEX.test(b)){const i={};for(const n in r[b])i[n]=r[b][n];u.push({identifiers:(0,A.overrideIdentifiersFromKey)(b),keys:Object.keys(i),contents:(0,N.toValuesTree)(i,l)})}return u}}e.ConfigurationModelParser=m;class o extends L.Disposable{constructor(r,l,u,b){super(),this.f=r,this.g=l,this.h=b,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new m(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(u.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,i=>i.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,i=>(i.isOperation(0)||i.isOperation(3)||i.isOperation(1)||i.isOperation(4))&&u.isEqual(i.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new C}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=o;class d{constructor(r,l,u,b,i,n,h,w,v,O,j,V,Q){this.a=r,this.b=l,this.c=u,this.overrideIdentifiers=b,this.d=i,this.f=n,this.g=h,this.h=w,this.i=v,this.j=O,this.k=j,this.l=V,this.m=Q}get value(){return k(this.c)}n(r,l,u){const b=r.inspect(l,u);return{get value(){return k(b.value)},get override(){return k(b.override)},get merged(){return k(b.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(r,l,u,b,i=new C,n=new C,h=new E.ResourceMap,w=new C,v=new E.ResourceMap){this.c=r,this.d=l,this.f=u,this.g=b,this.h=i,this.i=n,this.j=h,this.l=w,this.m=v,this.a=null,this.b=new E.ResourceMap,this.n=null}getValue(r,l,u){return this.q(r,l,u).getValue(r)}updateValue(r,l,u={}){let b;u.resource?(b=this.m.get(u.resource),b||(b=new C,this.m.set(u.resource,b))):b=this.l,l===void 0?b.removeValue(r):b.setValue(r,l),u.resource||(this.a=null)}inspect(r,l,u){const b=this.q(r,l,u),i=this.u(l.resource,u),n=l.resource?this.m.get(l.resource)||this.l:this.l,h=new Set;for(const w of b.overrides)for(const v of w.identifiers)b.getOverrideValue(r,v)!==void 0&&h.add(v);return new d(r,l,b.getValue(r),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.i:void 0,i||void 0,n)}keys(r){const l=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,l){this.j.set(r,l),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,l){const u=[];if(!l){const{added:b,updated:i,removed:n}=g(this.c,r);l=[...b,...i,...n]}for(const b of l)for(const i of(0,A.overrideIdentifiersFromKey)(b)){const n=this.c.getKeysForOverrideIdentifier(i),h=r.getKeysForOverrideIdentifier(i),w=[...h.filter(v=>n.indexOf(v)===-1),...n.filter(v=>h.indexOf(v)===-1),...n.filter(v=>!T.equals(this.c.override(i).getValue(v),r.override(i).getValue(v)))];u.push([i,w])}return this.updateDefaultConfiguration(r),{keys:l,overrides:u}}compareAndUpdatePolicyConfiguration(r){const{added:l,updated:u,removed:b}=g(this.d,r),i=[...l,...u,...b];return i.length&&this.updatePolicyConfiguration(r),{keys:i,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:l,updated:u,removed:b,overrides:i}=g(this.applicationConfiguration,r),n=[...l,...u,...b];return n.length&&this.updateApplicationConfiguration(r),{keys:n,overrides:i}}compareAndUpdateLocalUserConfiguration(r){const{added:l,updated:u,removed:b,overrides:i}=g(this.localUserConfiguration,r),n=[...l,...u,...b];return n.length&&this.updateLocalUserConfiguration(r),{keys:n,overrides:i}}compareAndUpdateRemoteUserConfiguration(r){const{added:l,updated:u,removed:b,overrides:i}=g(this.remoteUserConfiguration,r),n=[...l,...u,...b];return n.length&&this.updateRemoteUserConfiguration(r),{keys:n,overrides:i}}compareAndUpdateWorkspaceConfiguration(r){const{added:l,updated:u,removed:b,overrides:i}=g(this.workspaceConfiguration,r),n=[...l,...u,...b];return n.length&&this.updateWorkspaceConfiguration(r),{keys:n,overrides:i}}compareAndUpdateFolderConfiguration(r,l){const u=this.p.get(r),{added:b,updated:i,removed:n,overrides:h}=g(u,l),w=[...b,...i,...n];return(w.length||!u)&&this.updateFolderConfiguration(r,l),{keys:w,overrides:h}}compareAndDeleteFolderConfiguration(r){const l=this.p.get(r);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:u,updated:b,removed:i,overrides:n}=g(l,void 0);return{keys:[...u,...b,...i],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,l,u){let b=this.r(l,u);return l.overrideIdentifier&&(b=b.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(b=b.merge(this.d)),b}r({resource:r},l){let u=this.s();if(l&&r){const b=l.getFolder(r);b&&(u=this.t(b.uri)||u);const i=this.m.get(r);i&&(u=u.merge(i))}return u}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let l=this.b.get(r);if(!l){const u=this.s(),b=this.j.get(r);b?(l=u.merge(b),this.b.set(r,l)):l=u}return l}u(r,l){if(l&&r){const u=l.getFolder(r);if(u)return this.j.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,l)=>{const{contents:u,overrides:b,keys:i}=this.j.get(l);return r.push([l,{contents:u,overrides:b,keys:i}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(l=>r.add(l)),this.userConfiguration.keys.forEach(l=>r.add(l)),this.i.keys.forEach(l=>r.add(l)),this.j.forEach(l=>l.keys.forEach(u=>r.add(u))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>r.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(u=>r.add(u))),[...r.values()]}w(r){const l=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(u=>l.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(u=>l.add(u)),this.i.getKeysForOverrideIdentifier(r).forEach(u=>l.add(u)),this.j.forEach(u=>u.getKeysForOverrideIdentifier(r).forEach(b=>l.add(b))),[...l.values()]}static parse(r){const l=this.x(r.defaults),u=this.x(r.policy),b=this.x(r.application),i=this.x(r.user),n=this.x(r.workspace),h=r.folders.reduce((w,v)=>(w.set(I.URI.revive(v[0]),this.x(v[1])),w),new E.ResourceMap);return new f(l,u,b,i,new C,n,h,new C,new E.ResourceMap)}static x(r){return new C(r.contents,r.keys,r.overrides)}}e.Configuration=f;function p(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,l=new Map;for(const b of s)b.keys.forEach(i=>r.add(i)),b.overrides.forEach(([i,n])=>{const h=(0,E.getOrSet)(l,i,new Set);n.forEach(w=>h.add(w))});const u=[];return l.forEach((b,i)=>u.push([i,[...b.values()]])),{keys:[...r.values()],overrides:u}}e.mergeChanges=p;class y{constructor(r,l,u,b){this.change=r,this.f=l,this.g=u,this.h=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const i of r.keys)this.affectedKeys.add(i);for(const[,i]of r.overrides)for(const n of i)this.affectedKeys.add(n);this.d=this.a;for(const i of this.affectedKeys)this.d+=i+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(r,l){const u=this.a+r,b=this.d.indexOf(u);if(b<0)return!1;const i=b+u.length;if(i>=this.d.length)return!1;const n=this.d.charCodeAt(i);if(n!==this.b&&n!==this.c)return!1;if(l){const h=this.previousConfiguration?this.previousConfiguration.getValue(r,l,this.f?.workspace):void 0,w=this.g.getValue(r,l,this.h);return!T.equals(h,w)}return!0}}e.ConfigurationChangeEvent=y;function g(s,r){const{added:l,removed:u,updated:b}=t(r?.rawConfiguration,s?.rawConfiguration),i=[],n=s?.getAllOverrideIdentifiers()||[],h=r?.getAllOverrideIdentifiers()||[];if(r){const w=h.filter(v=>!n.includes(v));for(const v of w)i.push([v,r.getKeysForOverrideIdentifier(v)])}if(s){const w=n.filter(v=>!h.includes(v));for(const v of w)i.push([v,s.getKeysForOverrideIdentifier(v)])}if(r&&s){for(const w of n)if(h.includes(w)){const v=t({contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)},{contents:r.getOverrideValue(void 0,w)||{},keys:r.getKeysForOverrideIdentifier(w)});i.push([w,[...v.added,...v.removed,...v.updated]])}}return{added:l,removed:u,updated:b,overrides:i}}function t(s,r){const l=s?r?s.keys.filter(i=>r.keys.indexOf(i)===-1):[...s.keys]:[],u=r?s?r.keys.filter(i=>s.keys.indexOf(i)===-1):[...r.keys]:[],b=[];if(s&&r){for(const i of r.keys)if(s.keys.indexOf(i)!==-1){const n=(0,N.getConfigurationValue)(r.contents,i),h=(0,N.getConfigurationValue)(s.contents,i);T.equals(n,h)||b.push(i)}}return{added:l,removed:u,updated:b}}}),define(De[128],Ce([1,0,10,4]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var c;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(c=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends a.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof L&&S._code===c.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof L&&S._code===c.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof L&&S._code===c.NoResolverFound}static isHandled(S){return S instanceof L&&S.isHandled}constructor(S,I=c.Unknown,N){super(S),this._message=S,this._code=I,this._detail=N,this.isHandled=I===c.NotAvailable&&N===!0,Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L;function E(T){const S=T.indexOf("+");return S===-1?T:T.substring(0,S)}e.getRemoteAuthorityPrefix=E}),define(De[72],Ce([1,0,16]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(I){return I.scheme===a.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=R;function c(I){if(!I)return;const N=I.indexOf("+");return N<0?I:I.substr(0,N)}e.getRemoteName=c;function L(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=L;function E(I){const{host:N,port:A}=S(I);if(typeof A>"u")throw new Error("Remote authority doesn't contain a port!");return{host:N,port:A}}e.parseAuthorityWithPort=E;function T(I,N){let{host:A,port:D}=S(I);return typeof D>"u"&&(D=N),{host:A,port:D}}e.parseAuthorityWithOptionalPort=T;function S(I){const N=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(N)return{host:N[1],port:parseInt(N[2],10)};const A=I.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const D=I.match(/(.*):(\d+)$/);return D?{host:D[1],port:parseInt(D[2],10)}:{host:I,port:void 0}}}),define(De[25],Ce([1,0,8,4,72]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));var T;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(T=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(o){this.value=o,this.c=o.toLowerCase()}static equals(o,d){if(typeof o>"u"||o===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof o=="string"||typeof d=="string"){const f=typeof o=="string"?o:o.value,p=typeof d=="string"?d:d.value;return a.equalsIgnoreCase(f,p)}return o.c===d.c}static toKey(o){return typeof o=="string"?o.toLowerCase():o.c}}e.ExtensionIdentifier=S;class I{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const d of o)this.add(d)}add(o){this.c.add(S.toKey(o))}delete(o){return this.c.delete(S.toKey(o))}has(o){return this.c.has(S.toKey(o))}}e.ExtensionIdentifierSet=I;class N{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(S.toKey(o))}get(o){return this.c.get(S.toKey(o))}has(o){return this.c.has(S.toKey(o))}set(o,d){this.c.set(S.toKey(o),d)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=N;function A(m){return D(m)}e.isApplicationScopedExtension=A;function D(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function k(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=k;function C(m,o){if(o){const d=`onResolveRemoteAuthority:${(0,c.getRemoteName)(o)}`;return!!m.activationEvents?.includes(d)}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[129],Ce([1,0,10,25]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class c{constructor(){this.a=new Map,this.b=new WeakMap}register(E,T){this.a.set(E,T)}readActivationEvents(E){return this.b.has(E)||this.b.set(E,this.c(E)),this.b.get(E)}createActivationEventsMap(E){const T=Object.create(null);for(const S of E){const I=this.readActivationEvents(S);I.length>0&&(T[R.ExtensionIdentifier.toKey(S.identifier)]=I)}return T}c(E){if(typeof E.main>"u"&&typeof E.browser>"u")return[];const T=Array.isArray(E.activationEvents)?E.activationEvents.slice(0):[];if(!E.contributes)return T;for(const S in E.contributes){const I=this.a.get(S);if(!I)continue;const N=E.contributes[S],A=Array.isArray(N)?N:[N];try{I(A,T)}catch(D){(0,a.onUnexpectedError)(D)}}return T}}e.ImplicitActivationEventsImpl=c,e.ImplicitActivationEvents=new c}),define(De[211],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.b=new Map}c(){return new Promise((c,L)=>ie(["vsda"],c,L))}async createNewMessage(c){try{const L=await this.c(),E=new L.validator;if(E){const T=String(a.a++);return this.b.set(T,E),{id:T,data:E.createNewMessage(c)}}}catch{}return{id:"",data:c}}async validate(c,L){if(!c.id)return!0;const E=this.b.get(c.id);if(!E)return!1;this.b.delete(c.id);try{return E.validate(L)==="ok"}catch{return!1}}async sign(c){try{const L=await this.c(),E=new L.signer;if(E)return E.sign(c)}catch{}return c}}a.a=1,e.SignService=a}),define(De[212],Ce([1,0,11,36,2,30]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(I){if(a.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function T(I,N,A,D,k,C,m,o,d,f){const p=Object.create(null);p["common.machineId"]=m,p.sessionID=(0,L.generateUuid)()+Date.now(),p.commitHash=k,p.version=C,p["common.platformVersion"]=(N||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,a.PlatformToString)(a.platform),p["common.nodePlatform"]=R.platform,p["common.nodeArch"]=D,p["common.product"]=f||"desktop",o&&(p["common.msftInternal"]=o);let y=0;const g=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>y++,enumerable:!0}}),a.isLinuxSnap&&(p["common.snap"]="true");const t=E(A);t&&(p["common.platformDetail"]=t);try{const s=await I.readFile(c.URI.file(d));p["common.source"]=s.value.toString().slice(0,30)}catch{}return p}e.resolveCommonProperties=T;function S(I){const N=R.env.USERDNSDOMAIN;if(!N)return!1;const A=N.toLowerCase();return I.some(D=>A===D)}e.verifyMicrosoftInternalDomain=S}),define(De[213],Ce([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var c;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(c=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(De[73],Ce([1,0,23,9,3,54,72,212,213]),function(ie,e,a,R,c,L,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class I{constructor(i){this.value=i}}e.TelemetryTrustedValue=I;class N{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(i,n){return Promise.resolve(void 0)}publicLog2(i,n){return this.publicLog(i,n)}publicLogError(i,n){return Promise.resolve(void 0)}publicLogError2(i,n){return this.publicLogError(i,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=N,e.NullTelemetryService=new N;class A{async publicLog(i,n,h){}async publicLogError(i,n,h){}}e.NullEndpointTelemetryService=A,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function D(b,i){return c.Event.debounce(i.onDidChangeConfiguration,(h,w)=>{const v=h?new Set([...h.affectedKeys,...w.affectedKeys]):w.affectedKeys;return{...w,affectedKeys:v}},1e3,!0)(h=>{h.source!==7&&b.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(h.source),configurationKeys:y(h.affectedKeys)})})}e.configurationTelemetry=D;function k(b,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!b.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=k;function C(b,i){return!(i.isBuilt||i.disableTelemetry||b.enableTelemetry&&b.aiConfig?.ariaKey)}e.isLoggingOnly=C;function m(b){const i=b.getValue(S.TELEMETRY_SETTING_ID),n=b.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(b.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function o(b){const i={},n={},h={};p(b,h);for(let w in h){w=w.length>150?w.substr(w.length-149):w;const v=h[w];typeof v=="number"?n[w]=v:typeof v=="boolean"?n[w]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${v.length}`),i[w]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(i[w]=v)}return{properties:i,measurements:n}}e.validateTelemetryData=o;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(b){if(!b)return"none";const i=(0,E.getRemoteName)(b);return d.has(i)?i:"other"}e.cleanRemoteAuthority=f;function p(b,i,n=0,h){if(!!b)for(const w of Object.getOwnPropertyNames(b)){const v=b[w],O=h?h+w:w;Array.isArray(v)?i[O]=(0,a.safeStringify)(v):v instanceof Date?i[O]=v.toISOString():(0,R.isObject)(v)?n<2?p(v,i,n+1,O+"."):i[O]=(0,a.safeStringify)(v):i[O]=v}}function y(b){if(!b)return[];const i=[];return g(i,"",b),i}function g(b,i,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(h=>g(b,i?`${i}.${h}`:h,n[h])):b.push(i)}function t(b,i){const n=b.msftInternalDomains||[],h=i.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(n)||h}e.isInternalTelemetry=t;function s(b){return[b.appRoot,b.extensionsPath,b.userHome.fsPath,b.tmpDir.fsPath,b.userDataPath]}e.getPiiPathsFromEnvironment=s;function r(b,i){if(!b||!b.includes("/")&&!b.includes("\\"))return b;let n=b;const h=[];for(const j of i)for(;;){const V=j.exec(b);if(!V)break;h.push([V.index,j.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let O=0;for(n="";;){const j=v.exec(b);if(!j)break;const V=h.some(([Q,G])=>j.index<G&&Q<v.lastIndex);!w.test(j[0])&&!V&&(n+=b.substring(O,j.index)+"<REDACTED: user-file-path>",O=v.lastIndex)}return O<b.length&&(n+=b.substr(O)),n}function l(b){if(!b)return b;const i=b.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of n)if(h.regex.test(i))return`<REDACTED: ${h.label}>`;return b}function u(b,i){return(0,a.cloneAndChange)(b,n=>{if(n instanceof I)return n.value;if(typeof n=="string"){let h=n.replaceAll("%20"," ");h=r(h,i);for(const w of i)h=h.replace(w,"");return h=l(h),h}})}e.cleanData=u}),define(De[214],Ce([1,0,8,123,25,11,2,10,36,73]),function(ie,e,a,R,c,L,E,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function N(r,l){return r.uuid&&l.uuid?r.uuid===l.uuid:r.id===l.id?!0:(0,a.compareIgnoreCase)(r.id,l.id)===0}e.areSameExtensions=N;const A=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class D{static create(l){const u=l.manifest?l.manifest.version:l.version,b=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new D(l.identifier,u,b)}static parse(l){const u=A.exec(l);return u&&u[1]&&u[2]?new D({id:u[1]},u[2],u[4]||void 0):null}constructor(l,u,b="undefined"){this.version=u,this.targetPlatform=b,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof D?N(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=D;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function C(r){const l=k.exec(r);return l&&l[1]?[o(l[1]),l[2]]:[o(r),void 0]}e.getIdAndVersion=C;function m(r,l){return`${r}.${l}`}e.getExtensionId=m;function o(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=o;function d(r,l){return o(m(r,l))}e.getGalleryExtensionId=d;function f(r,l){const u=[],b=i=>{for(const n of u)if(n.some(h=>N(l(h),l(i))))return n;return null};for(const i of r){const n=b(i);n?n.push(i):u.push([i])}return u}e.groupByExtension=f;function p(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function y(r){return{id:new I.TelemetryTrustedValue(r.identifier.id),name:new I.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new c.ExtensionIdentifier("pprice.better-merge");function g(r,l){const u=[],b=l.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const i=b.shift();if(i&&u.every(n=>!N(n.identifier,{id:i}))){const n=r.filter(h=>N(h.identifier,{id:i}));n.length===1&&(u.push(n[0]),b.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.getExtensionDependencies=g;async function t(r,l){if(!L.isLinux)return!1;let u;try{u=(await r.readFile(E.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await r.readFile(E.URI.file("/usr/lib/os-release"))).value.toString()}catch(i){l.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(i))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,l){const u=await t(r,l),b=(0,R.getTargetPlatform)(u?"alpine":L.platform,S.arch);return l.debug("ComputeTargetPlatform:",b),b}e.computeTargetPlatform=s}),define(De[215],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=a;function R(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=R;function c(E){return Array.from(E.entries()).map(T=>[T[0],a(T[1].map)])}e.serializeEnvironmentVariableCollections=c;function L(E){return new Map(E.map(T=>[T[0],{map:R(T[1])}]))}e.deserializeEnvironmentVariableCollections=L}),define(De[216],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(c){this.b=c,this.a=new Map}dispose(){for(const c of this.a.values())c.dispose()}startBuffering(c,L,E=5){const T=L(S=>{const I=typeof S=="string"?S:S.data;let N=this.a.get(c);if(N){N.data.push(I);return}const A=setTimeout(()=>this.flushBuffer(c),E);N={data:[I],timeoutId:A,dispose:()=>{clearTimeout(A),this.flushBuffer(c),T.dispose()}},this.a.set(c,N)});return T}stopBuffering(c){this.a.get(c)?.dispose()}flushBuffer(c){const L=this.a.get(c);L&&(this.a.delete(c),this.b(c,L.data.join("")))}}e.TerminalDataBufferer=a}),define(De[217],Ce([1,0,19,67,52,3,9,2,176,92,39]),function(ie,e,a,R,c,L,E,T,S,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var A;(function(y){function g(t,s){let r=t.defaults;for(;c.ThemeIcon.isThemeIcon(r);){const l=C.getIcon(r.id);if(!l)return;r=l.defaults}return r}y.getDefinition=g})(A=e.IconContribution||(e.IconContribution={}));var D;(function(y){function g(s){return{weight:s.weight,style:s.style,src:s.src.map(r=>({format:r.format,location:r.location.toString()}))}}y.toJSONObject=g;function t(s){const r=l=>(0,E.isString)(l)?l:void 0;if(s&&Array.isArray(s.src)&&s.src.every(l=>(0,E.isString)(l.format)&&(0,E.isString)(l.location)))return{weight:r(s.weight),style:r(s.style),src:s.src.map(l=>({format:l.format,location:T.URI.parse(l.location)}))}}y.fromJSONObject=t})(D=e.IconFontDefinition||(e.IconFontDefinition={}));class k{constructor(){this.a=new L.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${c.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,t,s,r){const l=this.b[g];if(l){if(s&&!l.description){l.description=s,this.d.properties[g].markdownDescription=`${s} $(${g})`;const i=this.e.enum.indexOf(g);i!==-1&&(this.e.enumDescriptions[i]=s),this.a.fire()}return l}const u={id:g,description:s,defaults:t,deprecationMessage:r};this.b[g]=u;const b={$ref:"#/definitions/icons"};return r&&(b.deprecationMessage=r),s&&(b.markdownDescription=`${s}: $(${g})`),this.d.properties[g]=b,this.e.enum.push(g),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const t=this.e.enum.indexOf(g);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,t){const s=this.f[g];return s||(this.f[g]=t,this.a.fire(),t)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(l,u)=>l.id.localeCompare(u.id),t=l=>{for(;c.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(l=>this.b[l]);for(const l of r.filter(u=>!!u.description).sort(g))s.push(`|<i class="${t(l)}"></i>|${l.id}|${c.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const l of r.filter(u=>!c.ThemeIcon.isThemeIcon(u.defaults)).sort(g))s.push(`|<i class="${t(l)}"></i>|${l.id}|`);return s.join(`
`)}}const C=new k;N.Registry.add(e.Extensions.IconContribution,C);function m(y,g,t,s){return C.registerIcon(y,g,t,s)}e.registerIcon=m;function o(){return C}e.getIconRegistry=o;function d(){const y=(0,R.getCodiconFontCharacters)();for(const g in y){const t="\\"+y[g].toString(16);C.registerIcon(g,{fontCharacter:t})}}d(),e.iconsSchemaId="vscode://schemas/icons";const f=N.Registry.as(I.Extensions.JSONContribution);f.registerSchema(e.iconsSchemaId,C.getIconSchema());const p=new a.RunOnceScheduler(()=>f.notifySchemaChanged(e.iconsSchemaId),200);C.onDidChange(()=>{p.isScheduled()||p.schedule()}),e.widgetClose=m("widget-close",R.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=m("goto-previous-location",R.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=m("goto-next-location",R.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=c.ThemeIcon.modify(R.Codicon.sync,"spin"),e.spinningLoading=c.ThemeIcon.modify(R.Codicon.loading,"spin")}),define(De[130],Ce([1,0,3,54,4,13]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,c.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,c.createDecorator)("sharedTunnelsService");var E;(function(m){m.Http="http",m.Https="https"})(E=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(!!o)return{address:o[1],port:+o[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(m){return e.LOCALHOST_ADDRESSES.indexOf(m)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function A(m){return e.ALL_INTERFACES_ADDRESSES.indexOf(m)>=0}e.isAllInterfaces=A;function D(m,o,d,f){if(d===1)return!1;if(d===2&&A(o)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(p?.length===4&&parseInt(p[1])>=18)return!1}return m<1024}e.isPortPrivileged=D;class k{constructor(o,d,f){this.remoteAddress=o,this.localAddress=d,this.b=f,this.a=new a.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=k;let C=class{constructor(o,d){this.i=o,this.j=d,this.a=new a.Emitter,this.onTunnelOpened=this.a.event,this.b=new a.Emitter,this.onTunnelClosed=this.b.event,this.c=new a.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const o=this.j.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.e=o,o?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.f=o.elevation,this.g=o.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const o=[],d=Array.from(this.d.values());for(const f of d){const p=Array.from(f.values());for(const y of p){const g=await y.value;g&&o.push(g)}}return o}async dispose(){for(const o of this.d.values()){for(const{value:d}of o.values())await d.then(f=>f?.dispose());o.clear()}this.d.clear()}setEnvironmentTunnel(o,d,f,p,y){this.o(o,d,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:d,localAddress:f,privacy:p,protocol:y,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,d){(A(o)||N(o))&&(o=e.LOCALHOST_ADDRESSES[0]);const f=this.q(o,d);if(f)return++f.refcount,f.value}openTunnel(o,d,f,p,y,g=!1,t,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${f} on local port ${y}.`),!o)return;if(d||(d="localhost"),p||(p=this.k),this.e&&this.h.has(f)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(o,d,f,p,y,g,t,s);return r?r.then(l=>{if(!l){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(d,f);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.m(l);return(l.tunnelRemoteHost!==d||l.tunnelRemotePort!==f)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(u),u}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const d=this.d.get(o.tunnelRemoteHost);if(d){const f=d.get(o.tunnelRemotePort);f&&(f.refcount--,await this.n(o.tunnelRemoteHost,o.tunnelRemotePort,f))}}}}async n(o,d,f){if(f.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${d}.`);const p=f.value.then(async y=>{y&&(await y.dispose(!0),this.b.fire({host:y.tunnelRemoteHost,port:y.tunnelRemotePort}))});return this.d.has(o)&&this.d.get(o).delete(d),p}}async closeTunnel(o,d){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${d} `);const f=this.d.get(o);if(f&&f.has(d)){const p=f.get(d);p.refcount=0,await this.n(o,d,p)}}o(o,d,f){this.d.has(o)||this.d.set(o,new Map),this.d.get(o).set(d,{refcount:1,value:f})}async p(o,d){const f=this.d.get(o);f&&(await f.get(d)||f.delete(d),f.size===0&&this.d.delete(o))}q(o,d){const f=[o];N(o)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):A(o)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const p=f.map(y=>this.d.get(y));for(const y of p){const g=y?.get(d);if(g)return g}}canTunnel(o){return!!I(o)}s(o,d,f,p,y,g,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${f} on local port ${p}.`);const s=f;this.h.add(s);const r=p===void 0?f:p,l={elevationRequired:y?this.isPortPrivileged(r):!1},u={remoteAddress:{host:d,port:f},localAddressPort:p,privacy:g,public:g?g!==T.Private:void 0,protocol:t},b=o.forwardPort(u,l);return b?(this.o(d,f,b),b.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),b}};C=Ve([ze(0,L.ILogService),ze(1,R.IConfigurationService)],C),e.AbstractTunnelService=C}),define(De[218],Ce([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var R;(function(c){c[c.Complete=100]="Complete",c[c.Partial=50]="Partial",c[c.None=0]="None"})(R=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(De[219],Ce([1,0,16]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function R(S){return S.scheme!==a.Schemas.file&&S.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=R;function c(S){if(S.folders.length)return S.folders.every(I=>R(I.uri))?S.folders[0].uri:void 0;if(S.configuration&&R(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=c;function L(S){return c(S)?.scheme}e.getVirtualWorkspaceScheme=L;function E(S){return c(S)?.authority}e.getVirtualWorkspaceAuthority=E;function T(S){return c(S)!==void 0}e.isVirtualWorkspace=T}),define(De[48],Ce([1,0,177,12,68,24,2,4,16]),function(ie,e,a,R,c,L,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function I(l){const u=l;return typeof u?.id=="string"&&E.URI.isUri(u.uri)}e.isSingleFolderWorkspaceIdentifier=I;function N(l){return typeof l?.id=="string"&&!I(l)&&!D(l)}e.isEmptyWorkspaceIdentifier=N,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function A(l,u){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,R.basename)(l)}:u?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const b=l;return b.configuration?{id:b.id,configPath:b.configuration}:b.folders.length===1?{id:b.id,uri:b.folders[0].uri}:{id:b.id}}e.toWorkspaceIdentifier=A;function D(l){const u=l;return typeof u?.id=="string"&&E.URI.isUri(u.configPath)}e.isWorkspaceIdentifier=D;function k(l){const u=l;if(u?.uri)return{id:u.id,uri:E.URI.revive(u.uri)};const b=l;if(b?.configPath)return{id:b.id,configPath:E.URI.revive(b.configPath)};if(l?.id)return{id:l.id}}e.reviveIdentifier=k;var C;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(C=e.WorkbenchState||(e.WorkbenchState={}));function m(l){const u=l;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=m;function o(l){const u=l;return!!(u&&typeof u=="object"&&E.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=o;class d{constructor(u,b,i,n,h){this.h=u,this.j=i,this.k=n,this.l=h,this.c=c.TernarySearchTree.forUris(this.l,()=>!0),this.folders=b}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=c.TernarySearchTree.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class f{constructor(u,b){this.raw=b,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,L.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function p(l){return new f({uri:l,index:0,name:(0,L.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(l,u){return L.extUriBiasedIgnorePathCase.isEqualOrParent(l,u.untitledWorkspacesHome)}e.isUntitledWorkspace=y;function g(l){let u;return E.URI.isUri(l)?u=l:u=l.configuration,u?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=g,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function s(l,u){return!y(l,u)&&!g(l)}e.isSavedWorkspace=s;function r(l){return(typeof l=="string"?(0,R.extname)(l):(0,L.extname)(l))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(De[74],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(c){this.d=c,this.b=new Map,this.c=1}add(c){const L=this.c++;return this.b.set(L,c),this.e(),L}get(c,L){return this.b.has(c)?this.b.get(c)[L]:void 0}delete(c){this.b.delete(c),this.e()}e(){!a.a||console.log(`${this.d} cache size - ${this.b.size}`)}}a.a=!1,e.Cache=a}),define(De[49],Ce([1,0,16,24,4]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this.a=new Set(Object.keys(a.Schemas)),this.b=new Map,this.extUri=new R.ExtUri(T=>{const S=this.b.get(T.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(T,S){S===null?this.b.delete(T.scheme):this.b.set(T.scheme,S)}isFreeScheme(T){return!this.b.has(T)&&!this.a.has(T)}getCapabilities(T){return this.b.get(T)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,c.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ce([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(De[220],Ce([1,0,13,205,26]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends R.LogService{constructor(T,S){super(T.createLogger(S.logFile,{name:S.logName}))}};L=Ve([ze(0,a.ILoggerService),ze(1,c.IExtHostInitDataService)],L),e.ExtHostLogService=L}),define(De[221],Ce([1,0,19]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(E,T,S){this.h=new Map,this.a=E,this.b=T,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(I=>(this.f=I,this)),this.g=this.c.onDidChangeStorage(I=>{I.shared===this.b&&I.key===this.a&&(this.f=I.value)}),this.i=new a.RunOnceScheduler(()=>{const I=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of I.values())N.complete()}catch(N){for(const A of I.values())A.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,E])=>E!==void 0).map(([E])=>E)}get whenReady(){return this.d}get(E,T){let S=this.f[E];return typeof S>"u"&&(S=T),S}update(E,T){this.f[E]=T;const S=this.h.get(E);if(S!==void 0)return S.p;const I=new a.DeferredPromise;return this.h.set(E,I),this.i.isScheduled()||this.i.schedule(),I.p}dispose(){this.g.dispose()}}e.ExtensionMemento=R;class c extends R{setKeysForSync(E){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},E)}constructor(E,T){super(E.identifier.value,!0,T),this.j=E}}e.ExtensionGlobalMemento=c}),define(De[222],Ce([1,0,3,2]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class c{constructor(E){this.c=E,this.a=new a.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new a.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(E,T,S,I){const A=this.c.getNotebookDocument(R.URI.revive(E)).acceptModelChanged(T.value,S,I);this.b.fire(A)}$acceptDirtyStateChanged(E,T){this.c.getNotebookDocument(R.URI.revive(E)).acceptDirty(T)}$acceptModelSaved(E){const T=this.c.getNotebookDocument(R.URI.revive(E));this.a.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=c}),define(De[20],Ce([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class R{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=R});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,R,c){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!c)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!c:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?c.call(ie,a):c?c.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!R:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(ie):R?R.value:e.get(ie)};define(De[223],Ce([1,0,25,3]),function(ie,e,a,R){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(T,S){c.set(this,void 0),this.b=new R.Emitter,this.onDidChange=this.b.event,this.a=a.ExtensionIdentifier.toKey(T.identifier),Je(this,c,S,"f"),Ue(this,c,"f").onDidChangePassword(I=>{I.extensionId===this.a&&this.b.fire({key:I.key})})}get(T){return Ue(this,c,"f").get(this.a,T)}store(T,S){return Ue(this,c,"f").store(this.a,T,S)}delete(T){return Ue(this,c,"f").delete(this.a,T)}}e.ExtensionSecrets=L,c=new WeakMap}),define(De[55],Ce([1,0,4,130,3,20]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var E;(function(S){function I(A){return{remoteAddress:A.remoteAddress,localAddress:A.localAddress,public:!!A.public,privacy:A.privacy??(A.public?R.TunnelPrivacyId.Public:R.TunnelPrivacyId.Private),protocol:A.protocol}}S.fromApiTunnel=I;function N(A){return{remoteAddress:{host:A.tunnelRemoteHost,port:A.tunnelRemotePort},localAddress:A.localAddress,public:A.privacy!==R.TunnelPrivacyId.ConstantPrivate&&A.privacy!==R.TunnelPrivacyId.ConstantPrivate,privacy:A.privacy,protocol:A.protocol}}S.fromServiceTunnel=N})(E=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let T=class{constructor(I){this.onDidChangeTunnels=new c.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,N){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,N){return{dispose:()=>{}}}async $providePortAttributes(I,N,A,D,k){return[]}async $forwardPort(I,N){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=Ve([ze(0,L.IExtHostRpcService)],T),e.ExtHostTunnelService=T}),define(De[56],Ce([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class R{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=E=>E,this.transformOutgoing=E=>E,this.transformOutgoingURI=E=>E,this.transformOutgoingScheme=E=>E)}}e.URITransformerService=R}),define(De[224],Ce([1,0,22]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(S){let I=this.buffers.indexOf(S);return I<0&&(I=this.buffers.length,this.buffers.push(S)),I}}function c(T,S){if(S.serializeBuffersForPostMessage){const I=new R,N=(k,C)=>{if(C instanceof ArrayBuffer){const m=I.add(C);return{$$vscode_array_buffer_reference$$:!0,index:m}}else if(ArrayBuffer.isView(C)){const m=L(C);if(m){const o=I.add(C.buffer);return{$$vscode_array_buffer_reference$$:!0,index:o,view:{type:m,byteLength:C.byteLength,byteOffset:C.byteOffset}}}}return C},A=JSON.stringify(T,N),D=I.buffers.map(k=>{const C=new Uint8Array(k);return a.VSBuffer.wrap(C)});return{message:A,buffers:D}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=c;function L(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function E(T,S){const I=S.map(D=>{const k=new ArrayBuffer(D.byteLength);return new Uint8Array(k).set(D.buffer),k}),N=S.length?(D,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const C=k,{index:m}=C,o=I[m];if(C.view)switch(C.view.type){case 1:return new Int8Array(o,C.view.byteOffset,C.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,C.view.byteOffset,C.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,C.view.byteOffset,C.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,C.view.byteOffset,C.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,C.view.byteOffset,C.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,C.view.byteOffset,C.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,C.view.byteOffset,C.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,C.view.byteOffset,C.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,C.view.byteOffset,C.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,C.view.byteOffset,C.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,C.view.byteOffset,C.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return k}:void 0;return{message:JSON.parse(T,N),arrayBuffers:I}}e.deserializeWebviewMessage=E}),define(De[225],Ce([1,0,114]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function R(L){return{transformIncoming:E=>E.scheme==="vscode-remote"?{scheme:"file",path:E.path,query:E.query,fragment:E.fragment}:E.scheme==="file"?{scheme:"vscode-local",path:E.path,query:E.query,fragment:E.fragment}:E,transformOutgoing:E=>E.scheme==="file"?{scheme:"vscode-remote",authority:L,path:E.path,query:E.query,fragment:E.fragment}:E.scheme==="vscode-local"?{scheme:"file",path:E.path,query:E.query,fragment:E.fragment}:E,transformOutgoingScheme:E=>E==="file"?"vscode-remote":E==="vscode-local"?"file":E}}function c(L){return new a.URITransformer(R(L))}e.createURITransformer=c}),define(De[131],Ce([1,0,188,9,2,6,4,39,44,16,45,162,37]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(k=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var C;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(C=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(ce){const oe=ce;return!!oe&&typeof oe.getSelection=="function"&&!!oe.onDidChangeSelection}e.isEditorPaneWithSelection=m;function o(ce,oe,x){for(const he of x.visibleEditorPanes)if(he.group.id===oe&&ce.matches(he.input))return he.getViewState()}e.findViewStateForEditor=o;function d(ce){if(n(ce))return!1;const oe=ce;return c.URI.isUri(oe?.resource)}e.isResourceEditorInput=d;function f(ce){if(n(ce))return!1;const oe=ce;return oe?.original!==void 0&&oe.modified!==void 0}e.isResourceDiffEditorInput=f;function p(ce){if(n(ce)||f(ce))return!1;const oe=ce;return oe?.primary!==void 0&&oe.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function y(ce){if(n(ce))return!1;const oe=ce;return oe?oe.resource===void 0||oe.resource.scheme===I.Schemas.untitled||oe.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=y;const g=/Untitled-\d+/;function t(ce){return ce.scheme===I.Schemas.untitled&&ce.path.length>1&&!g.test(ce.path)}e.isUntitledWithAssociatedResource=t;function s(ce){if(n(ce))return!1;const oe=ce;return c.URI.isUri(oe?.base?.resource)&&c.URI.isUri(oe?.input1?.resource)&&c.URI.isUri(oe?.input2?.resource)&&c.URI.isUri(oe?.result?.resource)}e.isResourceMergeEditorInput=s;var r;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var l;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class u{constructor(){this.a=new Map}registerSource(oe,x){let he=this.a.get(oe);return he||(he={source:oe,label:x},this.a.set(oe,he)),he.source}getSourceLabel(oe){return this.a.get(oe)?.label??oe}}e.SaveSourceRegistry=new u;var b;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends L.Disposable{}e.AbstractEditorInput=i;function n(ce){return ce instanceof i}e.isEditorInput=n;function h(ce){const oe=ce;return c.URI.isUri(oe?.preferredResource)}function w(ce){const oe=ce;return n(oe?.primary)&&n(oe?.secondary)}e.isSideBySideEditorInput=w;function v(ce){const oe=ce;return n(oe?.modified)&&n(oe?.original)}e.isDiffEditorInput=v;function O(ce,oe,x,he,pe){return be(he,[(0,A.toAction)({id:"workbench.action.openLargeFile",label:(0,a.localize)(2,null),run:()=>{const Se={...x,limits:{size:Number.MAX_VALUE}};ce.openEditor(oe,Se)}}),(0,A.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,a.localize)(3,null),run:()=>pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:D.default.Warning})}e.createTooLargeFileError=O;function j(ce){return n(ce?.editor)}e.isEditorInputWithOptions=j;function V(ce){const oe=ce;return j(ce)&&oe?.group!==void 0}e.isEditorInputWithOptionsAndGroup=V;function Q(ce){const oe=ce;return typeof oe?.groupId=="number"&&n(oe.editor)}e.isEditorIdentifier=Q;var G;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(G=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var P;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(P=e.SideBySideEditor||(e.SideBySideEditor={}));class M{getOriginalUri(oe,x){if(!oe)return;if(s(oe))return e.EditorResourceAccessor.getOriginalUri(oe.result,x);if(x?.supportSideBySide){const{primary:pe,secondary:Se}=this.a(oe);if(pe&&Se){if(x?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(pe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(Se,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===P.ANY)return this.getOriginalUri(pe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(Se,{filterByScheme:x.filterByScheme});oe=x.supportSideBySide===P.PRIMARY?pe:Se}}if(f(oe)||p(oe)||s(oe))return;const he=h(oe)?oe.preferredResource:oe.resource;return!he||!x||!x.filterByScheme?he:this.b(he,x.filterByScheme)}a(oe){return w(oe)||p(oe)?{primary:oe.primary,secondary:oe.secondary}:v(oe)||f(oe)?{primary:oe.modified,secondary:oe.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(oe,x){if(!oe)return;if(s(oe))return e.EditorResourceAccessor.getCanonicalUri(oe.result,x);if(x?.supportSideBySide){const{primary:pe,secondary:Se}=this.a(oe);if(pe&&Se){if(x?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(pe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(Se,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===P.ANY)return this.getCanonicalUri(pe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(Se,{filterByScheme:x.filterByScheme});oe=x.supportSideBySide===P.PRIMARY?pe:Se}}if(f(oe)||p(oe)||s(oe))return;const he=oe.resource;return!he||!x||!x.filterByScheme?he:this.b(he,x.filterByScheme)}b(oe,x){if(Array.isArray(x)){if(x.some(he=>oe.scheme===he))return oe}else if(x===oe.scheme)return oe}}e.EditorResourceAccessor=new M;var B;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(B=e.CloseDirection||(e.CloseDirection={}));class Z{constructor(){this.c=new Map,this.d=new Map}start(oe){const x=this.a=oe.get(E.IInstantiationService);for(const[he,pe]of this.c)this.e(he,pe,x);this.c.clear()}e(oe,x,he){const pe=he.createInstance(x);this.d.set(oe,pe)}registerFileEditorFactory(oe){if(this.b)throw new Error("Can only register one file editor factory.");this.b=oe}getFileEditorFactory(){return(0,R.assertIsDefined)(this.b)}registerEditorSerializer(oe,x){if(this.c.has(oe)||this.d.has(oe))throw new Error(`A editor serializer with type ID '${oe}' was already registered.`);return this.a?this.e(oe,x,this.a):this.c.set(oe,x),(0,L.toDisposable)(()=>{this.c.delete(oe),this.d.delete(oe)})}getEditorSerializer(oe){return this.d.get(typeof oe=="string"?oe:oe.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new Z);async function Y(ce,oe,x){return!ce||!ce.length?[]:await Promise.all(ce.map(async he=>{const pe=c.URI.revive(he.fileUri);if(!pe){x.info("Cannot resolve the path because it is not valid.",he);return}if(!await oe.canHandleResource(pe)){x.info("Cannot resolve the path because it cannot be handled",he);return}let Re=he.exists,re=he.type;if(typeof Re!="boolean"||typeof re!="number")try{re=(await oe.stat(pe)).isDirectory?S.FileType.Directory:S.FileType.Unknown,Re=!0}catch(de){x.error(de),Re=!1}if(!Re&&he.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",he);return}if(re===S.FileType.Directory){x.info("Cannot resolve the path because it is a directory",he);return}const le={...he.options,pinned:!0};return Re?{resource:pe,options:le}:{resource:pe,options:le,forceUntitled:!0}}))}e.pathsToEditors=Y;var H;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(H=e.EditorsOrder||(e.EditorsOrder={}));function _(ce){const oe=ce;if(!oe)return!1;const x=oe;if(x.modified)return _(x.modified);const he=oe;return!!(he.contributionsState&&he.viewState&&Array.isArray(he.cursorState))}e.isTextEditorViewState=_;function ee(ce){return(0,N.isErrorWithActions)(ce)}e.isEditorOpenError=ee;function be(ce,oe,x){const he=(0,N.createErrorWithActions)(ce,oe);return he.forceMessage=x?.forceMessage,he.forceSeverity=x?.forceSeverity,he.allowDialog=x?.allowDialog,he}e.createEditorOpenError=be}),define(De[226],Ce([1,0,3,189,4,6,28,39,15,61,23,67,217]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,D.registerIcon)("default-view-icon",A.Codicon.window,(0,R.localize)(0,null));var k;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(k=e.Extensions||(e.Extensions={}));var C;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(C=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function m(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=m;class o extends L.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new a.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.flatten)([...this.g.values()])}registerViewContainer(l,u,b){const i=this.get(l.id);if(i)return i;const n=l;return n.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:n.openCommandActionDescriptor??{id:n.id},(0,E.getOrSet)(this.g,u,[]).push(n),b?.isDefault&&this.h.push(n),this.c.fire({viewContainer:n,viewContainerLocation:u}),n}deregisterViewContainer(l){for(const u of this.g.keys()){const b=this.g.get(u),i=b?.indexOf(l);if(i!==-1){b?.splice(i,1),b.length===0&&this.g.delete(u),this.f.fire({viewContainer:l,viewContainerLocation:u});return}}}get(l){return this.all.filter(u=>u.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(u=>this.getViewContainers(u).filter(b=>b?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(u=>this.getViewContainerLocation(u)===l)}}T.Registry.add(k.ViewContainersRegistry,new o);var d;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function f(r,l){const u=r.group??d.More,b=l.group??d.More;return u!==b?u.localeCompare(b):(r.order??5)-(l.order??5)}class p extends L.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new a.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new a.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new a.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new I.SetMap}registerViews(l,u){this.registerViews2([{views:l,viewContainer:u}])}registerViews2(l){l.forEach(({views:u,viewContainer:b})=>this.l(u,b)),this.c.fire(l)}deregisterViews(l,u){const b=this.m(l,u);b.length&&this.f.fire({views:b,viewContainer:u})}moveViews(l,u){for(const b of this.j.keys())if(b!==u){const i=this.m(l,b);i.length&&(this.l(i,u),this.g.fire({views:i,from:b,to:u}))}}getViews(l){return this.j.get(l)||[]}getView(l){for(const u of this.i){const b=(this.j.get(u)||[]).filter(i=>i.id===l)[0];if(b)return b}return null}getViewContainer(l){for(const u of this.i)if((this.j.get(u)||[]).filter(i=>i.id===l)[0])return u;return null}registerViewWelcomeContent(l,u){return this.k.add(l,u),this.h.fire(l),(0,L.toDisposable)(()=>{this.k.delete(l,u),this.h.fire(l)})}registerViewWelcomeContent2(l,u){const b=new Map;for(const[i,n]of u)this.k.add(l,n),b.set(i,(0,L.toDisposable)(()=>{this.k.delete(l,n),this.h.fire(l)}));return this.h.fire(l),b}getViewWelcomeContent(l){const u=[];return this.k.forEach(l,b=>u.push(b)),u.sort(f)}l(l,u){let b=this.j.get(u);b||(b=[],this.j.set(u,b),this.i.push(u));for(const i of l){if(this.getView(i.id)!==null)throw new Error((0,R.localize)(1,null,i.id));b.push(i)}}m(l,u){const b=this.j.get(u);if(!b)return[];const i=[],n=[];for(const h of b)l.includes(h)?i.push(h):n.push(h);return i.length&&(n.length?this.j.set(u,n):(this.j.delete(u),this.i.splice(this.i.indexOf(u),1))),i}}T.Registry.add(k.ViewsRegistry,new p),e.IViewsService=(0,c.createDecorator)("viewsService"),e.IViewDescriptorService=(0,c.createDecorator)("viewDescriptorService");var y;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(y=e.ViewVisibilityState||(e.ViewVisibilityState={}));var g;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(g=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(l,u){this.c=!1,this.d=!1,(0,N.mixin)(this,l),this.d=!!u,this.resolve=async b=>{if(u&&!this.c){const i=await u(b);i&&(this.tooltip=this.tooltip??i.tooltip,this.command=this.command??i.command)}b.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class s extends Error{constructor(l){super((0,R.localize)(2,null,l))}}e.NoTreeViewError=s}),define(De[132],Ce([1,0,3,19,190]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new a.Emitter,this.n=new a.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(T){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=T}onEvent(T){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=T}onRequest(T){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.s("response",T)}sendRequest(T,S,I,N){const A={command:T};if(S&&Object.keys(S).length>0&&(A.arguments=S),this.s("request",A),typeof N=="number"){const D=setTimeout(()=>{clearTimeout(D);const k=this.f.get(A.seq);if(k){this.f.delete(A.seq);const C={type:"response",seq:0,request_seq:A.seq,success:!1,command:T,message:(0,c.localize)(0,null,N,T)};k(C)}},N)}return I&&this.f.set(A.seq,I),A.seq}acceptMessage(T){this.j?this.j(T):(this.k.push(T),this.k.length===1&&this.q())}o(T,S){return T.type!=="event"||S.type!=="event"}async q(){let T;for(;this.k.length;){if((!T||this.o(this.k[0],T))&&await(0,R.timeout)(0),T=this.k.shift(),!T)return;switch(T.type){case"event":this.i?.(T);break;case"request":this.g?.(T);break;case"response":{const S=T,I=this.f.get(S.request_seq);I&&(this.f.delete(S.request_seq),I(S));break}}}}s(T,S){S.type=T,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((S,I)=>T.set(I,S)),await(0,R.timeout)(500),T.forEach((S,I)=>{S({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.f.delete(I)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=L}),define(De[227],Ce([1,0,191,46,4]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new R.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new R.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new R.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new R.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new R.RawContextKey("hasDebugged",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new R.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new R.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new R.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new R.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new R.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new R.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new R.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new R.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new R.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new R.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new R.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new R.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new R.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new R.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new R.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new R.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new R.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new R.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new R.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new R.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new R.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new R.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new R.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new R.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new R.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new R.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new R.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new R.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new R.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new R.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new R.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new R.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new R.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new R.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new R.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new R.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new R.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new R.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new R.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new R.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new R.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new R.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new R.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new R.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new R.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new R.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const L=D=>a.localize(51,null,D);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var E;(function(D){D[D.Inactive=0]="Inactive",D[D.Initializing=1]="Initializing",D[D.Stopped=2]="Stopped",D[D.Running=3]="Running"})(E=e.State||(e.State={}));function T(D){switch(D){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var S;(function(D){D[D.Valid=0]="Valid",D[D.Unreadable=1]="Unreadable",D[D.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(D){D[D.Initial=1]="Initial",D[D.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var N;(function(D){D.UnverifiedBreakpoints="unverifiedBreakpoints"})(N=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,c.createDecorator)("debugService");var A;(function(D){D[D.CONDITION=0]="CONDITION",D[D.HIT_COUNT=1]="HIT_COUNT",D[D.LOG_MESSAGE=2]="LOG_MESSAGE"})(A=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[228],Ce([1,0,8,2,12,23,16,32,21,15]),function(ie,e,a,R,c,L,E,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const N=/{([^}]+)}/g;function A(i,n,h){return i.replace(N,function(w,v){return n&&v.length>0&&v[0]!=="_"?w:h&&h.hasOwnProperty(v)?h[v]:w})}e.formatPII=A;function D(i){const n={};for(const h of Object.keys(i))h.startsWith("!")||(n[h]=i[h]);return n}e.filterExceptionsFromTelemetry=D;function k(i){return i.configuration.request==="attach"&&!C(i)&&(!i.parentSession||k(i.parentSession))}e.isSessionAttach=k;function C(i){let n=i.configuration.type;if(!!n)return n==="vslsShare"&&(n=i.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(n,"extensionhost")||(0,a.equalsIgnoreCase)(n,"pwa-extensionhost")?i:i.parentSession?C(i.parentSession):void 0}e.getExtensionHostDebugSession=C;function m(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=m;function o(i,n,h){let w,v=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=O.exec(i);){const V=j.index+1,Q=V+j[0].length;if(V<=n&&Q>=h){w=j[0],v=V;break}}if(w){const V=/\w+/g;let Q=null;for(;(Q=V.exec(w))&&!(Q.index+1+v+Q[0].length>=h););Q&&(w=w.substring(0,V.lastIndex))}return w?{start:v,end:v+w.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=o;async function d(i,n,h,w){if(i.evaluatableExpressionProvider.has(n)){const v=i.evaluatableExpressionProvider.ordered(n),O=(0,I.coalesce)(await Promise.all(v.map(async j=>{try{return await j.provideEvaluatableExpression(n,h,w??S.CancellationToken.None)}catch{return}})));if(O.length>0){let j=O[0].expression;const V=O[0].range;return j||(j=n.getLineContent(h.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:j}}}else{const v=n.getLineContent(h.lineNumber),{start:O,end:j}=o(v,h.column,h.column),V=v.substring(O-1,j);return{matchingExpression:V,range:new T.Range(h.lineNumber,O,h.lineNumber,O+V.length)}}return null}e.getEvaluatableExpressionAtPosition=d;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(i){return!!(i&&i.match(f))}e.isUri=p;function y(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(p(i.path))return R.URI.parse(i.path);if((0,c.isAbsolute)(i.path))return R.URI.file(i.path)}return i.path}function g(i){if(typeof i.path=="object"){const n=R.URI.revive(i.path);if(n)return n.scheme===E.Schemas.file?n.fsPath:n.toString()}return i.path}function t(i,n){const h=n?y:g,w=(0,L.deepClone)(i);return r(w,(v,O)=>{v&&O&&(O.path=h(O))}),w}e.convertToDAPaths=t;function s(i,n){const h=n?y:g,w=(0,L.deepClone)(i);return r(w,(v,O)=>{!v&&O&&(O.path=h(O))}),w}e.convertToVSCPaths=s;function r(i,n){switch(i.type){case"event":{const h=i;switch(h.event){case"output":n(!1,h.body.source);break;case"loadedSource":n(!1,h.body.source);break;case"breakpoint":n(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=i;switch(h.command){case"setBreakpoints":n(!0,h.arguments.source);break;case"breakpointLocations":n(!0,h.arguments.source);break;case"source":n(!0,h.arguments.source);break;case"gotoTargets":n(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(w=>n(!1,w));break;default:break}break}case"response":{const h=i;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(w=>n(!1,w.source));break;case"loadedSources":h.body.sources.forEach(w=>n(!1,w));break;case"scopes":h.body.scopes.forEach(w=>n(!1,w.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(w=>n(!1,w.source));break;case"setBreakpoints":h.body.breakpoints.forEach(w=>n(!1,w.source));break;case"disassemble":h.body?.instructions.forEach(v=>n(!1,v.location));break;default:break}break}}}function l(i){return i.filter(n=>!n.presentation?.hidden).sort((n,h)=>n.presentation?h.presentation?n.presentation.group?h.presentation.group?n.presentation.group!==h.presentation.group?n.presentation.group.localeCompare(h.presentation.group):u(n.presentation.order,h.presentation.order):-1:h.presentation.group?1:u(n.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=l;function u(i,n){return typeof i!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:i-n}async function b(i,n){const h=i.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(h!=="none"&&(await n.saveAll(),h==="allEditorsInActiveGroup")){const w=n.activeEditorPane;w&&w.input.resource?.scheme===E.Schemas.untitled&&await n.save({editor:w.input,groupId:w.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=b}),define(De[229],Ce([1,0,47,230,23,12,11,8,29,192,132]),function(ie,e,a,R,c,L,E,T,S,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class A extends N.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(d,f){this.p=f,this.r=Buffer.allocUnsafe(0),this.t=-1,d.on("data",p=>this.w(p))}sendMessage(d){if(this.p){const f=JSON.stringify(d);this.p.write(`Content-Length: ${Buffer.byteLength(f,"utf8")}${A.a}${f}`,"utf8")}}w(d){for(this.r=Buffer.concat([this.r,d]);;){if(this.t>=0){if(this.r.length>=this.t){const f=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,f.length>0)try{this.acceptMessage(JSON.parse(f))}catch(p){this.m.fire(new Error((p.message||p)+`
`+f))}continue}}else{const f=this.r.indexOf(A.a);if(f!==-1){const y=this.r.toString("utf8",0,f).split(A.b);for(const g of y){const t=g.split(A.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(f+A.a.length);continue}}break}}}A.a=`\r
\r
`,A.b=/\r?\n/,A.l=/: */,e.StreamDebugAdapter=A;class D extends A{startSession(){return new Promise((d,f)=>{let p=!1;this.x=this.y(()=>{this.v(this.x,this.x),d(),p=!0}),this.x.on("close",()=>{p?this.m.fire(new Error("connection closed")):f(new Error("connection closed"))}),this.x.on("error",y=>{p?this.m.fire(y):f(y)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=D;class k extends D{constructor(d){super(),this.z=d}y(d){return R.createConnection(this.z.port,this.z.host||"127.0.0.1",d)}}e.SocketDebugAdapter=k;class C extends D{constructor(d){super(),this.z=d}y(d){return R.createConnection(this.z.path,d)}}e.NamedPipeDebugAdapter=C;class m extends A{constructor(d,f){super(),this.y=d,this.z=f}async startSession(){const d=this.y.command,f=this.y.args,p=this.y.options||{};try{if(d)if(L.isAbsolute(d)){if(!await S.Promises.exists(d))throw new Error(I.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.z));let y=process.env;if(p.env&&Object.keys(p.env).length>0&&(y=c.mixin(c.deepClone(process.env),p.env)),d==="node")if(Array.isArray(f)&&f.length>0){const g=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:y,execArgv:g?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};p.cwd&&(t.cwd=p.cwd);const s=a.fork(f[0],f.slice(1),t);if(!s.pid)throw new Error(I.localize(2,null,f[0]));this.x=s}else throw new Error(I.localize(3,null));else{const g={env:y};p.cwd&&(g.cwd=p.cwd),this.x=a.spawn(d,f,g)}this.x.on("error",g=>{this.m.fire(g)}),this.x.on("exit",(g,t)=>{this.n.fire(g)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",g=>{this.m.fire(g)}),this.x.stdin.on("error",g=>{this.m.fire(g)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(y){this.m.fire(y)}}async stopSession(){return this.x?(await this.u(),E.isWindows?new Promise((d,f)=>{const p=a.exec(`taskkill /F /T /PID ${this.x.pid}`,function(y,g,t){if(y)return f(y)});p.on("exit",d),p.on("error",f)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(d,f){if(!d)return;const p=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?p.runtime=L.join(f,d.runtime):p.runtime=d.runtime),d.runtimeArgs&&(p.runtimeArgs=d.runtimeArgs),d.program&&(L.isAbsolute(d.program)?p.program=d.program:p.program=L.join(f,d.program)),d.args&&(p.args=d.args);const y=d;return y.win&&(p.win=m.A(y.win,f)),y.winx86&&(p.winx86=m.A(y.winx86,f)),y.windows&&(p.windows=m.A(y.windows,f)),y.osx&&(p.osx=m.A(y.osx,f)),y.linux&&(p.linux=m.A(y.linux,f)),p}static platformAdapterExecutable(d,f){let p=Object.create(null);f=f.toLowerCase();for(const l of d)if(l.contributes){const u=l.contributes.debuggers;u&&u.length>0&&u.filter(b=>typeof b.type=="string"&&T.equalsIgnoreCase(b.type,f)).forEach(b=>{const i=m.A(b,l.extensionLocation.fsPath);p=c.mixin(p,i,l.isBuiltin)})}let y;E.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?y=p.winx86||p.win||p.windows:E.isWindows?y=p.win||p.windows:E.isMacintosh?y=p.osx:E.isLinux&&(y=p.linux),y=y||p;const g=y.program||p.program,t=y.args||p.args,s=y.runtime||p.runtime,r=y.runtimeArgs||p.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof g=="string"?[g]:[]).concat(t||[])};if(g)return{type:"executable",command:g,args:t||[]}}}e.ExecutableDebugAdapter=m}),define(De[231],Ce([1,0,47,33,11]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function L(I,N){return new Promise((A,D)=>{let k="";const C=a.spawn(I,N);C.pid&&C.stdout.on("data",m=>{k+=m.toString()}),C.on("error",m=>{D(m)}),C.on("close",m=>{A(k)})})}async function E(I){if(I)if(c.isWindows){const N=await new Promise((A,D)=>{ie(["windows-process-tree"],A,D)});return new Promise(A=>{N.getProcessTree(I,D=>{A(!!D&&D.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(I)]).then(N=>{const A=N.trim();return!(A.length===0||A.indexOf(" tmux")>=0)},N=>!0);return Promise.resolve(!0)}e.hasChildProcesses=E;var T;(function(I){I[I.cmd=0]="cmd",I[I.powershell=1]="powershell",I[I.bash=2]="bash"})(T||(T={}));function S(I,N,A,D,k){I=I.trim().toLowerCase();let C;I.indexOf("powershell")>=0||I.indexOf("pwsh")>=0?C=1:I.indexOf("cmd.exe")>=0?C=0:I.indexOf("bash")>=0?C=2:c.isWindows?C=0:C=2;let m,o=" ";switch(C){case 1:if(m=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),D){const d=(0,R.getDriveLetter)(D);d&&(o+=`${d}:; `),o+=`cd ${m(D)}; `}if(k)for(const d in k){const f=k[d];f===null?o+=`Remove-Item env:${d}; `:o+=`\${env:${d}}='${f}'; `}if(N.length>0){const d=N.shift(),f=A?d:m(d);o+=f[0]==="'"?`& ${f} `:`${f} `;for(const p of N)o+=p==="<"||p===">"||A?p:m(p),o+=" "}break;case 0:if(m=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(f=>d.includes(f))||d.length===0?`"${d}"`:d),D){const d=(0,R.getDriveLetter)(D);d&&(o+=`${d}: && `),o+=`cd ${m(D)} && `}if(k){o+='cmd /C "';for(const d in k){let f=k[d];f===null?o+=`set "${d}=" && `:(f=f.replace(/[&^|<>]/g,p=>`^${p}`),o+=`set "${d}=${f}" && `)}}for(const d of N)o+=d==="<"||d===">"||A?d:m(d),o+=" ";k&&(o+='"');break;case 2:{m=f=>(f=f.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),f.length===0?'""':f);const d=f=>/[^\w@%\/+=,.:^-]/.test(f)?`'${f.replace(/'/g,"'\\''")}'`:f;if(D&&(o+=`cd ${m(D)} ; `),k){o+="/usr/bin/env";for(const f in k){const p=k[f];p===null?o+=` -u ${d(f)}`:o+=` ${d(`${f}=${p}`)}`}o+=" "}for(const f of N)o+=f==="<"||f===">"||A?f:m(f),o+=" ";break}}return o}e.prepareCommand=S}),define(De[93],Ce([1,0,22,38,64,87,16,12,11,46]),function(ie,e,a,R,c,L,E,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var N;(function(P){P[P.Markup=1]="Markup",P[P.Code=2]="Code"})(N=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var A;(function(P){P[P.Running=1]="Running",P[P.Idle=2]="Idle"})(A=e.NotebookRunState||(e.NotebookRunState={}));var D;(function(P){P[P.Unconfirmed=1]="Unconfirmed",P[P.Pending=2]="Pending",P[P.Executing=3]="Executing"})(D=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(P){P[P.WithHardKernelDependency=0]="WithHardKernelDependency",P[P.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",P[P.Pure=2]="Pure",P[P.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(P){P.Always="always",P.Never="never",P.Optional="optional"})(C=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var m;(function(P){P[P.ModelChange=1]="ModelChange",P[P.Move=2]="Move",P[P.ChangeCellLanguage=5]="ChangeCellLanguage",P[P.Initialize=6]="Initialize",P[P.ChangeCellMetadata=7]="ChangeCellMetadata",P[P.Output=8]="Output",P[P.OutputItem=9]="OutputItem",P[P.ChangeCellContent=10]="ChangeCellContent",P[P.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",P[P.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",P[P.ChangeCellMime=13]="ChangeCellMime",P[P.Unknown=100]="Unknown"})(m=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(P){P[P.Handle=0]="Handle",P[P.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(P){P[P.Replace=1]="Replace",P[P.Output=2]="Output",P[P.Metadata=3]="Metadata",P[P.CellLanguage=4]="CellLanguage",P[P.DocumentMetadata=5]="DocumentMetadata",P[P.Move=6]="Move",P[P.OutputItems=7]="OutputItems",P[P.PartialMetadata=8]="PartialMetadata",P[P.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var f;(function(P){P.scheme=E.Schemas.vscodeNotebookCell;const M=["W","X","Y","Z","a","b","c","d","e","f"],B=new RegExp(`^[${M.join("")}]+`),Z=7;function Y(oe,x){const he=x.toString(Z),Se=`${he.length<M.length?M[he.length-1]:"z"}${he}s${(0,a.encodeBase64)(a.VSBuffer.fromString(oe.scheme),!0,!0)}`;return oe.with({scheme:P.scheme,fragment:Se})}P.generate=Y;function H(oe){if(oe.scheme!==P.scheme)return;const x=oe.fragment.indexOf("s");if(x<0)return;const he=parseInt(oe.fragment.substring(0,x).replace(B,""),Z),pe=(0,a.decodeBase64)(oe.fragment.substring(x+1)).toString();if(!isNaN(he))return{handle:he,notebook:oe.with({scheme:pe,fragment:null})}}P.parse=H;function _(oe,x){return oe.with({scheme:E.Schemas.vscodeNotebookCellOutput,fragment:`op${x??""},${oe.scheme!==E.Schemas.file?oe.scheme:""}`})}P.generateCellOutputUri=_;function ee(oe){if(oe.scheme!==E.Schemas.vscodeNotebookCellOutput)return;const x=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!x)return;const he=x[1]&&x[1]!==""?x[1]:void 0,pe=x[2];return{outputId:he,notebook:oe.with({scheme:pe||E.Schemas.file,fragment:null})}}P.parseCellOutputUri=ee;function be(oe,x,he){return P.generate(oe,x).with({scheme:he})}P.generateCellPropertyUri=be;function ce(oe,x){if(oe.scheme===x)return P.parse(oe.with({scheme:P.scheme}))}P.parseCellPropertyUri=ce})(f=e.CellUri||(e.CellUri={}));const p=P=>S.isWindows?P.replace(/\//g,"\\"):P;class y{constructor(M=[],B=e.NOTEBOOK_DISPLAY_ORDER){this.e=B,this.d=[...new Set(M)].map(Z=>({pattern:Z,matches:R.parse(p(Z))}))}sort(M){const B=new Map(c.Iterable.map(M,Y=>[Y,p(Y)]));let Z=[];for(const{matches:Y}of this.d)for(const[H,_]of B)if(Y(_)){Z.push(H),B.delete(H);break}return B.size&&(Z=Z.concat([...B.keys()].sort((Y,H)=>this.e.indexOf(Y)-this.e.indexOf(H)))),Z}prioritize(M,B){const Z=this.f(M);if(Z===-1){this.d.unshift({pattern:M,matches:R.parse(p(M))});return}const Y=new Set(B.map(_=>this.f(_,Z)));Y.delete(-1);const H=Array.from(Y).sort();this.d.splice(Z+1,0,...H.map(_=>this.d[_]));for(let _=H.length-1;_>=0;_--)this.d.splice(H[_],1)}toArray(){return this.d.map(M=>M.pattern)}f(M,B=this.d.length){const Z=p(M);for(let Y=0;Y<B;Y++)if(this.d[Y].matches(Z))return Y;return-1}}e.MimeTypeDisplayOrder=y;function g(P,M,B,Z=(Y,H)=>Y===H){const Y=[];function H(be,ce,oe){if(ce===0&&oe.length===0)return;const x=Y[Y.length-1];x&&x.start+x.deleteCount===be?(x.deleteCount+=ce,x.toInsert.push(...oe)):Y.push({start:be,deleteCount:ce,toInsert:oe})}let _=0,ee=0;for(;;){if(_===P.length){H(_,0,M.slice(ee));break}if(ee===M.length){H(_,P.length-_,[]);break}const be=P[_],ce=M[ee];if(Z(be,ce)){_+=1,ee+=1;continue}B(ce)?(H(_,1,[]),_+=1):(H(_,0,[ce]),ee+=1)}return Y}e.diff=g,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(P){P.default="default",P.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(P){const M=P;return!!((typeof M.include=="string"||R.isRelativePattern(M.include))&&(typeof M.exclude=="string"||R.isRelativePattern(M.exclude)))}e.isDocumentExcludePattern=s;function r(P,M,B){if(Array.isArray(P.viewType)&&P.viewType.indexOf(M)>=0||P.viewType===M)return!0;if(P.filenamePattern){const Z=s(P.filenamePattern)?P.filenamePattern.include:P.filenamePattern,Y=s(P.filenamePattern)?P.filenamePattern.exclude:void 0;if(R.match(Z,(0,T.basename)(B.fsPath).toLowerCase()))return!(Y&&R.match(Y,(0,T.basename)(B.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",outputWordWrap:"notebook.output.wordWrap",logging:"notebook.logging"};var l;(function(P){P[P.Left=1]="Left",P[P.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(M){return`${u.d}${M}`}static parse(M){if(M.startsWith(u.d))return M.substring(u.d.length)}}u.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=u;function b(P){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(P)}e.isTextStreamMime=b;const i=new TextDecoder;function n(P){const M=[];let B=!1;for(const Z of P)(M.length===0||B)&&(M.push(Z),B=!0);return O(M),U(a.VSBuffer.concat(M.map(Z=>a.VSBuffer.wrap(Z))))}e.compressOutputItemStreams=n;const h=`${String.fromCharCode(27)}[A`,w=h.split("").map(P=>P.charCodeAt(0)),v=10;function O(P){P.forEach((M,B)=>{if(B===0||M.length<h.length)return;const Z=P[B-1],Y=M.subarray(0,h.length);if(Y[0]===w[0]&&Y[1]===w[1]&&Y[2]===w[2]){const H=Z.lastIndexOf(v);if(H===-1)return;P[B-1]=Z.subarray(0,H),P[B]=M.subarray(h.length)}})}function j(P){let M=P;do P=M,M=P.replace(/[^\n]\x08/gm,"");while(M.length<P.length);return P}function V(P){for(P=P.replace(/\r+\n/gm,`
`);P.search(/\r[^$]/g)>-1;){const M=P.match(/^(.*)\r+/m)[1];let B=P.match(/\r+(.*)$/m)[1];B=B+M.slice(B.length,M.length),P=P.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return P}const Q="\b".charCodeAt(0),G="\r".charCodeAt(0);function U(P){return!P.buffer.includes(Q)&&!P.buffer.includes(G)?P:a.VSBuffer.fromString(V(j(i.decode(P.buffer))))}}),define(De[232],Ce([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var R;(function(c){c[c.Output=1]="Output",c[c.OutputItems=2]="OutputItems",c[c.ExecutionState=3]="ExecutionState"})(R=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(De[57],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(L){L.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var R;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(R=e.TestPosition||(e.TestPosition={}));class c{static fromExtHostTestItem(E,T,S=E.parent){if(E._isRoot)return new c([T]);const I=[E.id];for(let N=S;N&&N.id!==T;N=N.parent)I.push(N.id);return I.push(T),new c(I.reverse())}static isRoot(E){return!E.includes("\0")}static root(E){const T=E.indexOf("\0");return T===-1?E:E.slice(0,T)}static fromString(E){return new c(E.split("\0"))}static join(E,T){return new c([...E.path,T])}static joinToString(E,T){return E.toString()+"\0"+T}static parentId(E){const T=E.lastIndexOf("\0");return T===-1?void 0:E.slice(0,T)}static localId(E){const T=E.lastIndexOf("\0");return T===-1?E:E.slice(T+1)}static compare(E,T){return E===T?0:T.startsWith(E+"\0")?2:E.startsWith(T+"\0")?3:1}constructor(E,T=E.length){if(this.path=E,this.d=T,E.length===0||T<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new c(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let E=1;E<=this.d;E++)yield new c(this.path,E)}*idsToRoot(){for(let E=this.d;E>0;E--)yield new c(this.path,E)}compare(E){if(typeof E=="string")return c.compare(this.toString(),E);for(let T=0;T<E.d&&T<this.d;T++)if(E.path[T]!==this.path[T])return 1;return E.d>this.d?2:E.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let E=1;E<this.d;E++)this.c+="\0",this.c+=this.path[E]}return this.c}}e.TestId=c}),define(De[75],Ce([1,0,2,32,57]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var L;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(L=e.TestResultState||(e.TestResultState={}));var E;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable",i[i.SupportsContinuousRun=64]="SupportsContinuousRun"})(E=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const T=i=>"runId"in i;e.isStartControllerTests=T;var S;(function(i){i.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),i.deserialize=n=>({range:R.Range.lift(n.range),uri:a.URI.revive(n.uri)})})(S=e.IRichLocation||(e.IRichLocation={}));var I;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(I=e.TestMessageType||(e.TestMessageType={}));var N;(function(i){i.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&S.serialize(n.location)}),i.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&S.deserialize(n.location)})})(N=e.ITestErrorMessage||(e.ITestErrorMessage={}));const A=(i,n)=>`${n?"s":"e"}${i}`;e.getMarkId=A;var D;(function(i){i.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&S.serialize(n.location)}),i.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&S.deserialize(n.location)})})(D=e.ITestOutputMessage||(e.ITestOutputMessage={}));var k;(function(i){i.serialize=n=>n.type===0?N.serialize(n):D.serialize(n),i.deserialize=n=>n.type===0?N.deserialize(n):D.deserialize(n)})(k=e.ITestMessage||(e.ITestMessage={}));var C;(function(i){i.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),i.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(k.serialize)}),i.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(k.deserialize)})})(C=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",o=(i,n)=>i+m+n;e.namespaceTestTag=o;const d=i=>{const n=i.indexOf(m);return{ctrlId:i.slice(0,n),tagId:i.slice(n+1)}};e.denamespaceTestTag=d;var f;(function(i){i.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),i.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?a.URI.revive(n.uri):void 0,range:n.range?R.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(f=e.ITestItem||(e.ITestItem={}));var p;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));var y;(function(i){i.serialize=n=>({expand:n.expand,item:f.serialize(n.item)}),i.deserialize=n=>({controllerId:c.TestId.root(n.item.extId),expand:n.expand,item:f.deserialize(n.item)})})(y=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(i){i.serialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.uri!==void 0&&(h.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(h.range=n.item.range?.toJSON()),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}},i.deserialize=n=>{let h;return n.item&&(h={},n.item.label!==void 0&&(h.label=n.item.label),n.item.tags!==void 0&&(h.tags=n.item.tags),n.item.busy!==void 0&&(h.busy=n.item.busy),n.item.range!==void 0&&(h.range=n.item.range?R.Range.lift(n.item.range):null),n.item.description!==void 0&&(h.description=n.item.description),n.item.error!==void 0&&(h.error=n.item.error),n.item.sortText!==void 0&&(h.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:h}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(i,n)=>{n.expand!==void 0&&(i.expand=n.expand),n.item!==void 0&&(i.item=i.item?Object.assign(i.item,n.item):n.item)};e.applyTestItemUpdate=t;var s;(function(i){i.serializeWithoutMessages=n=>({...y.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.serializeWithoutMessages),retired:n.retired}),i.serialize=n=>({...y.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.serialize),retired:n.retired}),i.deserialize=n=>({...y.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var r;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var l;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.DocumentSynced=2]="DocumentSynced",i[i.Remove=3]="Remove",i[i.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",i[i.Retire=5]="Retire",i[i.AddTag=6]="AddTag",i[i.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(i){i.deserialize=n=>n.op===0?{op:n.op,item:y.deserialize(n.item)}:n.op===1?{op:n.op,item:g.deserialize(n.item)}:n.op===2?{op:n.op,uri:a.URI.revive(n.uri),docv:n.docv}:n,i.serialize=n=>n.op===0?{op:n.op,item:y.serialize(n.item)}:n.op===1?{op:n.op,item:g.serialize(n.item)}:n})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class b{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const h=this.o();for(const w of n)switch(w.op){case 0:this.j(y.deserialize(w.item),h);break;case 1:this.k(g.deserialize(w.item),h);break;case 3:this.l(w.itemId,h);break;case 5:this.m(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.c.set(w.tag.id,w.tag);break;case 7:this.c.delete(w.id);break}h.complete?.()}j(n,h){const w=c.TestId.parentId(n.item.extId)?.toString();let v;if(!w)v=this.p(n),this.f.add(v),this.d.set(n.item.extId,v);else if(this.d.has(w)){const O=this.d.get(w);O.children.add(n.item.extId),v=this.p(n,O),this.d.set(n.item.extId,v)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return h.add?.(v),n.expand===2&&this.g++,v}k(n,h){const w=this.d.get(n.extId);if(!!w)return n.expand!==void 0&&(w.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(w,n),h.update?.(w),w}l(n,h){const w=this.d.get(n);if(!w)return;const v=c.TestId.parentId(w.item.extId)?.toString();v?this.d.get(v).children.delete(w.item.extId):this.f.delete(w);const O=[[n]];for(;O.length;)for(const j of O.pop()){const V=this.d.get(j);V&&(O.push(V.children),this.d.delete(j),h.remove?.(V,V!==w),V.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=b}),define(De[94],Ce([1,0,19,3,6,51,75,57]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(f,p)=>f===p,A=Object.entries({range:(f,p)=>f===p?!0:!f||!p?!1:f.equalsRange(p),busy:I,label:I,description:I,error:I,sortText:I,tags:(f,p)=>!(f.length!==p.length||f.some(y=>!p.includes(y)))}),D=(f,p)=>{let y;for(const[g,t]of A)t(f[g],p[g])||(y?y[g]=p[g]:y={[g]:p[g]});return y};class k extends c.Disposable{get root(){return this.m.root}constructor(p){super(),this.m=p,this.f=this.B(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new R.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(p){this.h=p;for(const y of this.tree.values())this.G(y)}get resolveHandler(){return this.h}collectDiff(){const p=this.k;return this.k=[],p}pushDiff(p){switch(p.op){case 2:{for(const y of this.k)if(y.op===2&&y.uri===p.uri){y.docv=p.docv;return}break}case 1:{const y=this.k[this.k.length-1];if(y){if(y.op===1&&y.item.extId===p.item.extId){(0,E.applyTestItemUpdate)(y.item,p.item);return}if(y.op===0&&y.item.item.extId===p.item.extId){(0,E.applyTestItemUpdate)(y.item,p.item);return}}break}}this.k.push(p),this.f.isScheduled()||this.f.schedule()}expand(p,y){const g=this.tree.get(p);if(!!g){if((g.expandLevels===void 0||y>g.expandLevels)&&(g.expandLevels=y),g.expand===1){const t=this.I(g);return t.isOpen()?this.H(g,y-1):t.wait().then(()=>this.H(g,y-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.H(g,y-1)):this.H(g,y-1)}}dispose(){for(const p of this.tree.values())this.m.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(p,y){switch(y.op){case 3:this.L(T.TestId.joinToString(p.fullId,y.id));break;case 0:this.u(y.item,p);break;case 5:for(const g of y.ops)this.p(p,g);break;case 1:this.w(y.new,y.old,p.fullId.toString());break;case 2:this.G(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:y.update}});break;case 6:this.s(p.actual.uri);break;default:(0,L.assertNever)(y)}}s(p){p&&this.pushDiff({op:2,uri:p,docv:this.m.getDocumentVersion(p)})}u(p,y){const g=T.TestId.fromExtHostTestItem(p,this.root.id,y?.actual),t=this.m.getApiFor(p);t.parent&&t.parent!==y?.actual&&this.m.getChildren(t.parent).delete(p.id);let s=this.tree.get(g.toString());if(!s){s={fullId:g,actual:p,expandLevels:y?.expandLevels?y.expandLevels-1:void 0,expand:0},p.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(p,y),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(p)}}),this.F(p,s,y);return}if(s.actual===p){this.D(p,s,y);return}if(s.actual.uri?.toString()!==p.uri?.toString())return this.L(g.toString()),this.u(p,y);const r=this.m.getChildren(s.actual),l=s.actual,u=D(this.m.toITestItem(l),this.m.toITestItem(p));this.m.getApiFor(l).listener=void 0,s.actual=p,s.expand=0,u&&(u.hasOwnProperty("tags")&&(this.w(p.tags,l.tags,g.toString()),delete u.tags),this.p(s,{op:4,update:u})),this.F(p,s,y);for(const[b,i]of r)this.m.getChildren(p).get(i.id)||this.L(T.TestId.joinToString(g,i.id));this.s(s.actual.uri)}w(p,y,g){const t=new Set(y.map(s=>s.id));for(const s of p)t.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:g,item:{tags:p.map(s=>(0,E.namespaceTestTag)(this.m.controllerId,s.id))}}}),t.forEach(this.z,this)}y(p){const y=this.j.get(p.id);y?y.refCount++:(this.j.set(p.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,E.namespaceTestTag)(this.m.controllerId,p.id)}}))}z(p){const y=this.j.get(p);y&&!--y.refCount&&(this.j.delete(p),this.pushDiff({op:7,id:(0,E.namespaceTestTag)(this.m.controllerId,p)}))}C(p,y){this.m.getApiFor(p).parent=y&&y.actual!==this.root?y.actual:void 0}D(p,y,g){this.C(p,g);const t=this.m.getApiFor(p);t.parent=g?.actual,t.listener=s=>this.p(y,s),this.G(y)}F(p,y,g){this.D(p,y,g);for(const[t,s]of this.m.getChildren(p))this.u(s,y)}G(p){let y;this.h?p.resolveBarrier?y=p.resolveBarrier.isOpen()?3:2:y=p.actual.canResolveChildren?1:0:y=0,y!==p.expand&&(p.expand=y,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:y}}),y===1&&p.expandLevels!==void 0&&this.I(p))}H(p,y){if(y<0)return;const g=[];for(const[t,s]of this.m.getChildren(p.actual)){const r=this.expand(T.TestId.joinToString(p.fullId,s.id),y);(0,a.isThenable)(r)&&g.push(r)}if(g.length)return Promise.all(g).then(()=>{})}I(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this.h){const s=new a.Barrier;return s.open(),s}p.expand=2,this.J(p);const y=p.resolveBarrier=new a.Barrier,g=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let t;try{t=this.h(p.actual===this.root?void 0:p.actual)}catch(s){g(s)}return(0,a.isThenable)(t)?t.catch(g).then(()=>{y.open(),this.G(p)}):(y.open(),this.G(p)),p.resolveBarrier}J(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}L(p){const y=this.tree.get(p);if(!y)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:p});const g=[y];for(;g.length;){const t=g.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.z(s.id);this.tree.delete(t.fullId.toString());for(const[s,r]of this.m.getChildren(t.actual))g.push(this.tree.get(T.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.g.fire(p)}}e.TestItemCollection=k;class C extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.DuplicateTestItemError=C;class m extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class o extends Error{constructor(p,y,g){super(`TestItem with ID "${p}" is from controller "${y}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=o;const d=(f,p,y)=>{let g=new Map;return{get size(){return g.size},forEach(t,s){for(const r of g.values())t.call(s,r,this)},[Symbol.iterator](){return g.entries()},replace(t){const s=new Map,r=new Set(g.keys()),l={op:5,ops:[]};for(const u of t){if(!(u instanceof y))throw new m(u.id);const b=p(u).controllerId;if(b!==f.controllerId)throw new o(u.id,b,f.controllerId);if(s.has(u.id))throw new C(u.id);s.set(u.id,u),r.delete(u.id),l.ops.push({op:0,item:u})}for(const u of r.keys())l.ops.push({op:3,id:u});f.listener?.(l),g=s},add(t){if(!(t instanceof y))throw new m(t.id);g.set(t.id,t),f.listener?.({op:0,item:t})},delete(t){g.delete(t)&&f.listener?.({op:3,id:t})},get(t){return g.get(t)},toJSON(){return Array.from(g.values())}}};e.createTestItemChildren=d}),define(De[133],Ce([1,0,94]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const R=new WeakMap,c=(E,T)=>{const S={controllerId:T};return R.set(E,S),S};e.createPrivateApiFor=c;const L=E=>{const T=R.get(E);if(!T)throw new a.InvalidTestItemError(E?.id||"<unknown>");return T};e.getPrivateApiFor=L}),define(De[95],Ce([1,0,16,2]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function c(T,S){return T.scheme===a.Schemas.http||T.scheme===a.Schemas.https?T:(S&&S.authority&&S.isRemote&&T.scheme===a.Schemas.file&&(T=R.URI.from({scheme:a.Schemas.vscodeRemote,authority:S.authority,path:T.path})),R.URI.from({scheme:a.Schemas.https,authority:`${T.scheme}+${L(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=c;function L(T){return T.replace(/./g,S=>{const I=S.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?S:"-"+I.toString(16).padStart(4,"0")})}function E(T){return T.replace(/-([0-9a-f]{4})/g,(S,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=E}),define(De[233],Ce([1,0,3,6,95]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(T,S,I){this.d=T,this.e=S,this.f=I,this.a=0,this.b=new R.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const N=S.getVisibleTextEditors();for(const A of this.c.values())N.indexOf(A.editor)<0&&A.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,S,I,N,A){let D;for(const p of this.e.getVisibleTextEditors(!0))if(p.value===T){D=p;break}if(!D)throw new Error("not a visible editor");const k=this,C=this.a++,m=new a.Emitter,o=new a.Emitter,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(p){return(0,c.asWebviewUri)(p,k.f)}get cspSource(){return c.webviewGenericCspSource}set options(p){this.b=p,k.d.$setOptions(C,p)}get options(){return this.b}set html(p){this.a=p,k.d.$setHtml(C,p)}get html(){return this.a}get onDidReceiveMessage(){return m.event}postMessage(p){return k.d.$postMessage(C,p)}},f=new class{constructor(){this.editor=T,this.line=S,this.height=I,this.webview=d,this.onDidDispose=o.event}dispose(){k.c.has(C)&&(k.c.delete(C),k.d.$disposeEditorInset(C),o.fire(),o.dispose(),m.dispose())}};return this.d.$createEditorInset(C,D.id,D.value.document.uri,S+1,I,N||{},A.identifier,A.extensionLocation),this.c.set(C,{editor:T,inset:f,onDidReceiveMessage:m}),f}$onDidDispose(T){const S=this.c.get(T);S&&S.inset.dispose()}$onDidReceiveMessage(T,S){this.c.get(T)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=L}),define(De[234],Ce([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var R;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(R=e.VariableKind||(e.VariableKind={}));class c extends Error{constructor(E,T){super(T),this.variable=E}}e.VariableError=c}),define(De[235],Ce([1,0,12,36,9,23,11,113,195,234,8]),function(ie,e,a,R,c,L,E,T,S,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class A{constructor(k,C,m,o){this.g=new Map,this.a=k,this.b=C,this.d=m,o&&(this.c=o.then(d=>this.h(d)))}h(k){if(E.isWindows){const C=Object.create(null);return Object.keys(k).forEach(m=>{C[m.toLowerCase()]=k[m]}),C}return k}resolveWithEnvironment(k,C,m){return this.j({env:this.h(k),userHome:void 0},C?C.uri:void 0,m)}async resolveAsync(k,C){const m={env:await this.c,userHome:await this.d};return this.j(m,k?k.uri:void 0,C)}async i(k,C,m,o){const d=L.deepClone(C);E.isWindows&&d.windows?Object.keys(d.windows).forEach(p=>d[p]=d.windows[p]):E.isMacintosh&&d.osx?Object.keys(d.osx).forEach(p=>d[p]=d.osx[p]):E.isLinux&&d.linux&&Object.keys(d.linux).forEach(p=>d[p]=d.linux[p]),delete d.windows,delete d.osx,delete d.linux;const f={env:await this.c,userHome:await this.d};return this.j(f,k?k.uri:void 0,d,m,o)}async resolveAnyAsync(k,C,m){return this.i(k,C,m)}async resolveAnyMap(k,C,m){const o=new Map;return{newConfig:await this.i(k,C,m,o),resolvedVariables:o}}resolveWithInteractionReplace(k,C,m,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,C,m,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,C){if(this.g.has(k))throw new Error("Variable "+k+" is contributed twice.");this.g.set(k,C)}async j(k,C,m,o,d){if(c.isString(m))return this.l(k,C,m,o,d);if(Array.isArray(m))return Promise.all(m.map(f=>this.j(k,C,f,o,d)));if(c.isObject(m)){const f=Object.create(null),p=await Promise.all(Object.keys(m).map(async y=>[await this.l(k,C,y,o,d),await this.j(k,C,m[y],o,d)]));for(const[y,g]of p)f[y]=g;return f}return m}l(k,C,m,o,d){return(0,N.replaceAsync)(m,A.VARIABLE_REGEXP,async(f,p)=>{if(p.includes(A.VARIABLE_LHS))return f;let y=await this.n(k,f,p,C,o);return d?.set(p,y),y!==f&&c.isString(y)&&y.match(A.VARIABLE_REGEXP)&&(y=await this.l(k,C,y,o,d)),y})}m(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async n(k,C,m,o,d){let f;const p=m.split(":");p.length>1&&(m=p[0],f=p[1]);const y=s=>{const r=this.a.getFilePath();if(r)return(0,T.normalizeDriveLetter)(r);throw new I.VariableError(s,(0,S.localize)(0,null,C))},g=s=>{const r=y(s);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,T.normalizeDriveLetter)(l)}throw new I.VariableError(s,(0,S.localize)(1,null,C,a.basename(r)))},t=s=>{if(f){const r=this.a.getFolderUri(f);if(r)return r;throw new I.VariableError(s,(0,S.localize)(2,null,C,f))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new I.VariableError(s,(0,S.localize)(3,null,C)):new I.VariableError(s,(0,S.localize)(4,null,C))};switch(m){case"env":if(f){if(k.env){const s=k.env[E.isWindows?f.toLowerCase():f];if(c.isString(s))return s}return""}throw new I.VariableError(I.VariableKind.Env,(0,S.localize)(5,null,C));case"config":if(f){const s=this.a.getConfigurationValue(o,f);if(c.isUndefinedOrNull(s))throw new I.VariableError(I.VariableKind.Config,(0,S.localize)(6,null,C,f));if(c.isObject(s))throw new I.VariableError(I.VariableKind.Config,(0,S.localize)(7,null,C,f));return s}throw new I.VariableError(I.VariableKind.Config,(0,S.localize)(8,null,C));case"command":return this.o(I.VariableKind.Command,C,f,d,"command");case"input":return this.o(I.VariableKind.Input,C,f,d,"input");case"extensionInstallFolder":if(f){const s=await this.a.getExtension(f);if(!s)throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,C,f));return this.m(s.extensionLocation)}throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,C));default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.m(t(I.VariableKind.WorkspaceFolder)));case"cwd":return o||f?(0,T.normalizeDriveLetter)(this.m(t(I.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.normalizeDriveLetter)(a.basename(this.m(t(I.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new I.VariableError(I.VariableKind.UserHome,(0,S.localize)(11,null,C))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new I.VariableError(I.VariableKind.LineNumber,(0,S.localize)(12,null,C))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new I.VariableError(I.VariableKind.SelectedText,(0,S.localize)(13,null,C))}case"file":return y(I.VariableKind.File);case"fileWorkspaceFolder":return g(I.VariableKind.FileWorkspaceFolder);case"relativeFile":return o||f?a.relative(this.m(t(I.VariableKind.RelativeFile)),y(I.VariableKind.RelativeFile)):y(I.VariableKind.RelativeFile);case"relativeFileDirname":{const s=a.dirname(y(I.VariableKind.RelativeFileDirname));if(o||f){const r=a.relative(this.m(t(I.VariableKind.RelativeFileDirname)),s);return r.length===0?".":r}return s}case"fileDirname":return a.dirname(y(I.VariableKind.FileDirname));case"fileExtname":return a.extname(y(I.VariableKind.FileExtname));case"fileBasename":return a.basename(y(I.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=a.basename(y(I.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-a.extname(s).length)}case"fileDirnameBasename":return a.basename(a.dirname(y(I.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||C}case"execInstallFolder":{const s=this.a.getAppRoot();return s||C}case"pathSeparator":return a.sep;default:try{const s=f?`${m}:${f}`:m;return this.o(I.VariableKind.Unknown,C,s,d,void 0)}catch{return C}}}}o(k,C,m,o,d){if(m&&o){const f=d===void 0?o[m]:o[d+":"+m];if(typeof f=="string")return f;throw new I.VariableError(k,(0,S.localize)(14,null,C))}return C}}A.VARIABLE_LHS="${",A.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=A}),define(De[134],Ce([1,0,4,131]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var c;(function(C){C[C.UP=0]="UP",C[C.DOWN=1]="DOWN",C[C.LEFT=2]="LEFT",C[C.RIGHT=3]="RIGHT"})(c=e.GroupDirection||(e.GroupDirection={}));var L;(function(C){C[C.HORIZONTAL=0]="HORIZONTAL",C[C.VERTICAL=1]="VERTICAL"})(L=e.GroupOrientation||(e.GroupOrientation={}));var E;(function(C){C[C.FIRST=0]="FIRST",C[C.LAST=1]="LAST",C[C.NEXT=2]="NEXT",C[C.PREVIOUS=3]="PREVIOUS"})(E=e.GroupLocation||(e.GroupLocation={}));var T;(function(C){C[C.MAXIMIZE=0]="MAXIMIZE",C[C.EVEN=1]="EVEN",C[C.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(C){C[C.COPY_EDITORS=0]="COPY_EDITORS",C[C.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function I(C){const m=C;return(0,R.isEditorInput)(m?.editor)&&(0,R.isEditorInput)(m?.replacement)}e.isEditorReplacement=I;var N;(function(C){C[C.CREATION_TIME=0]="CREATION_TIME",C[C.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",C[C.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var A;(function(C){C[C.NEW_EDITOR=1]="NEW_EDITOR",C[C.MOVE_EDITOR=2]="MOVE_EDITOR",C[C.COPY_EDITOR=3]="COPY_EDITOR"})(A=e.OpenEditorContext||(e.OpenEditorContext={}));function D(C){const m=C;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.isEditorGroup=D;function k(C){return C.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(De[236],Ce([1,0,4,134]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function c(L){const E=L;return typeof L=="number"||(0,R.isEditorGroup)(E)}e.isPreferredGroup=c}),define(De[237],Ce([1,0,4,201]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(R.IEnvironmentService)}),define(De[135],Ce([1,0,25,3,12,6]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class E{constructor(o){this.removedDueToLooping=o}}e.DeltaExtensionsResult=E;class T{static isHostExtension(o,d,f){if(d.getExtensionDescription(o))return!1;const p=f.getExtensionDescription(o);return p?!!((p.main||p.browser)&&p.api==="none"):!1}constructor(o,d){this.h=o,this.c=new R.Emitter,this.onDidChange=this.c.event,this.d=d,this.j()}j(){this.d.sort(k),this.e=new a.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const o of this.d){if(this.e.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.e.set(o.identifier,o),this.f.push(o);const d=this.h.readActivationEvents(o);if(Array.isArray(d))for(let f of d)f==="onUri"&&(f=`onUri:${a.ExtensionIdentifier.toKey(o.identifier)}`),this.g.has(f)||this.g.set(f,[]),this.g.get(f).push(o)}}set(o){this.d=o,this.j(),this.c.fire(void 0)}deltaExtensions(o,d){this.d=C(this.d,d),this.d=this.d.concat(o);const f=T.k(this.d);return this.d=C(this.d,f.map(p=>p.identifier)),this.j(),this.c.fire(void 0),new E(f)}static k(o){const d=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(t){this.d.has(t)||(this.d.add(t),this.e.push(t))}addArc(t,s){this.addNode(t),this.addNode(s),this.c.has(t)?this.c.get(t).push(s):this.c.set(t,[s])}getArcs(t){return this.c.has(t)?this.c.get(t):[]}hasOnlyGoodArcs(t,s){const r=d.getArcs(t);for(let l=0;l<r.length;l++)if(!s.has(r[l]))return!1;return!0}getNodes(){return this.e}},f=new a.ExtensionIdentifierMap;for(const t of o)if(f.set(t.identifier,t),t.extensionDependencies)for(const s of t.extensionDependencies)d.addArc(a.ExtensionIdentifier.toKey(t.identifier),a.ExtensionIdentifier.toKey(s));const p=new Set;d.getNodes().filter(t=>d.getArcs(t).length===0).forEach(t=>p.add(t));const y=d.getNodes().filter(t=>!p.has(t));let g;do{g=!1;for(let t=0;t<y.length;t++){const s=y[t];d.hasOnlyGoodArcs(s,p)&&(y.splice(t,1),t--,p.add(s),g=!0)}}while(g);return y.map(t=>f.get(t))}containsActivationEvent(o){return this.g.has(o)}containsExtension(o){return this.e.has(o)}getExtensionDescriptionsForActivationEvent(o){const d=this.g.get(o);return d?d.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(o){const d=this.e.get(o);return d||void 0}getExtensionDescriptionByUUID(o){for(const d of this.f)if(d.uuid===o)return d}getExtensionDescriptionByIdOrUUID(o,d){return this.getExtensionDescription(o)??(d?this.getExtensionDescriptionByUUID(d):void 0)}}e.ExtensionDescriptionRegistry=T,e.basicActivationEventsReader={readActivationEvents:m=>m.activationEvents};class S{constructor(o){this.d=new A,this.c=new T(o,[])}async acquireLock(o){const d=await this.d.acquire(o);return new I(this,d)}deltaExtensions(o,d,f){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(d,f)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,d){return this.c.getExtensionDescriptionByIdOrUUID(o,d)}}e.LockableExtensionDescriptionRegistry=S;class I extends L.Disposable{constructor(o,d){super(),this.f=o,this.c=!1,this.B(d)}isAcquiredFor(o){return!this.c&&this.f===o}}e.ExtensionDescriptionRegistryLock=I;class N{constructor(o){this.name=o,this.promise=new Promise((d,f)=>{this.c=d})}resolve(o){this.c(o)}}class A{constructor(){this.c=[],this.d=!1}async acquire(o){const d=new N(o);return this.c.push(d),this.e(),d.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let d=!0;const f=setTimeout(()=>{d&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),p=()=>{!d||(clearTimeout(f),d=!1,this.d=!1,this.e())};o.resolve((0,L.toDisposable)(p))}}var D;(function(m){m[m.Builtin=0]="Builtin",m[m.User=1]="User",m[m.Dev=2]="Dev"})(D||(D={}));function k(m,o){const d=m.isBuiltin?0:m.isUnderDevelopment?2:1,f=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(d!==f)return d-f;const p=c.posix.basename(m.extensionLocation.path),y=c.posix.basename(o.extensionLocation.path);return p<y?-1:p>y?1:0}function C(m,o){const d=new a.ExtensionIdentifierSet(o);return m.filter(f=>!d.has(f.identifier))}}),define(De[238],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(N){N[N.IPC=1]="IPC",N[N.Socket=2]="Socket",N[N.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class R{constructor(A){this.pipeName=A,this.type=1}serialize(A){A[R.ENV_KEY]=this.pipeName}}R.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=R;class c{constructor(){this.type=2}serialize(A){A[c.ENV_KEY]="1"}}c.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=c;class L{constructor(){this.type=3}serialize(A){A[L.ENV_KEY]="1"}}L.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=L;function E(N){delete N[R.ENV_KEY],delete N[c.ENV_KEY],delete N[L.ENV_KEY]}function T(N,A){E(A),N.serialize(A)}e.writeExtHostConnection=T;function S(N){if(N[R.ENV_KEY])return I(N,new R(N[R.ENV_KEY]));if(N[c.ENV_KEY])return I(N,new c);if(N[L.ENV_KEY])return I(N,new L);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function I(N,A){return E(N),A}}),define(De[96],Ce([1,0,22]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(R=e.UIKind||(e.UIKind={}));var c;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(c=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var L;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(L=e.MessageType||(e.MessageType={}));function E(I){const N=a.VSBuffer.alloc(1);switch(I){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}e.createMessageOfType=E;function T(I,N){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}e.isMessageOfType=T;var S;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[76],Ce([1,0,4,3,13,26,96,72,73,23,2,6,182]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let k=class extends A.Disposable{constructor(d,f){super(),this.m=d,this.n=f,this.a=this.B(new R.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=N.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=f.createLogger(this.j,{id:S.extensionTelemetryLogChannelId,name:(0,D.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(f.onDidChangeLogLevel(p=>{(0,c.isLogLevel)(p)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===c.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(d,f,p){const y=this.getTelemetryDetails(),g=new C(f,p,d,this.k,this.i,this.getBuiltInCommonProperties(d),{isUsageEnabled:y.isUsageEnabled,isErrorsEnabled:y.isErrorsEnabled});return this.l.set(d.identifier.value,g),g.apiTelemetryLogger}$initializeTelemetryLevel(d,f,p){this.f=d,this.g=f,this.c=p??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(d){const f={};switch(f["common.extname"]=`${d.publisher}.${d.name}`,f["common.extversion"]=d.version,f["common.vscodemachineid"]=this.m.telemetryInfo.machineId,f["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,f["common.vscodeversion"]=this.m.version,f["common.isnewappinstall"]=m(this.m.telemetryInfo.firstSessionDate),f["common.product"]=this.m.environment.appHost,this.m.uiKind){case E.UIKind.Web:f["common.uikind"]="web";break;case E.UIKind.Desktop:f["common.uikind"]="desktop";break;default:f["common.uikind"]="unknown"}return f["common.remotename"]=(0,T.getRemoteName)((0,S.cleanRemoteAuthority)(this.m.remote.authority)),f}$onDidChangeTelemetryLevel(d){this.h=this.getTelemetryConfiguration(),this.f=d;const f=this.getTelemetryDetails();this.l.forEach(p=>{p.updateTelemetryEnablements(f.isUsageEnabled,f.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(d,f){const p=this.l.get(d.value);return!p||p.ignoreUnhandledExtHostErrors?!1:(p.logError(f),!0)}};k=Ve([ze(0,L.IExtHostInitDataService),ze(1,c.ILoggerService)],k),e.ExtHostTelemetry=k;class C{static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,f,p,y,g,t,s){this.g=p,this.h=y,this.i=g,this.j=t,this.a=new R.Emitter,this.ignoreUnhandledExtHostErrors=f?.ignoreUnhandledErrors??!1,this.b=f?.ignoreBuiltInCommonProperties??!1,this.c=f?.additionalCommonProperties,this.f=d,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(d,f){this.e&&(this.d={isUsageEnabled:d,isErrorsEnabled:f},this.a.fire(this.e))}mixInCommonPropsAndCleanData(d){let f=d.properties??d;return f=(0,S.cleanData)(f,[]),this.c&&(f=(0,I.mixin)(f,this.c)),this.b||(f=(0,I.mixin)(f,this.j)),d.properties?d.properties=f:d=f,d}k(d,f){!this.f||(this.g.publisher==="vscode"?d=this.g.name+"/"+d:d=this.g.identifier.value+"/"+d,f=this.mixInCommonPropsAndCleanData(f||{}),this.i||this.f?.sendEventData(d,f),this.h.trace(d,f))}logUsage(d,f){!this.d.isUsageEnabled||this.k(d,f)}logError(d,f){!this.d.isErrorsEnabled||!this.f||(typeof d=="string"?this.k(d,f):this.f.sendErrorData(d,f))}get apiTelemetryLogger(){if(!this.e){const d=this,f={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.d.isUsageEnabled},get isErrorsEnabled(){return d.d.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.a.event.bind(d)};this.e=Object.freeze(f)}return this.e}dispose(){this.f?.flush&&(Promise.resolve(this.f.flush()).then(this.f=void 0),this.e=void 0)}}e.ExtHostTelemetryLogger=C;function m(o){const d=Date.now()-new Date(o).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=m,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(De[27],Ce([1,0,3,2,214,129,25,4]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new E.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class S{constructor(g){this.dependency=g}}e.MissingExtensionDependency=S;var I;(function(y){y[y.EagerAutoStart=1]="EagerAutoStart",y[y.EagerManualStart=2]="EagerManualStart",y[y.Lazy=3]="Lazy"})(I=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class N{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:L.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(g,t){const s=[],r=[],l=[],u=[],b=A(this.c),i=A(g),n=(j,V)=>j.extensionLocation.toString()===V.extensionLocation.toString()||j.isBuiltin===V.isBuiltin||j.isUserBuiltin===V.isUserBuiltin||j.isUnderDevelopment===V.isUnderDevelopment;for(const j of this.c){const V=i.get(j.identifier);if(!V){s.push(j.identifier),b.delete(j.identifier);continue}if(!n(j,V)){s.push(j.identifier),b.delete(j.identifier);continue}}for(const j of g){const V=b.get(j.identifier);if(!V){r.push(j);continue}if(!n(V,j)){s.push(V.identifier),b.delete(V.identifier);continue}}const h=new E.ExtensionIdentifierSet(this.d),w=new E.ExtensionIdentifierSet(t);for(const j of this.d)w.has(j)||l.push(j);for(const j of t)h.has(j)||u.push(j);const v=L.ImplicitActivationEvents.createActivationEventsMap(r),O={toRemove:s,toAdd:r,addActivationEvents:v,myToRemove:l,myToAdd:u};return this.delta(O),O}delta(g){const{toRemove:t,toAdd:s,myToRemove:r,myToAdd:l}=g,u=new E.ExtensionIdentifierSet(t),b=new E.ExtensionIdentifierSet(r);for(let i=0;i<this.c.length;i++)u.has(this.c[i].identifier)&&(this.c.splice(i,1),i--);for(let i=0;i<this.d.length;i++)b.has(this.d[i])&&(this.d.splice(i,1),i--);for(const i of s)this.c.push(i);for(const i of l)this.d.push(i)}containsExtension(g){for(const t of this.d)if(E.ExtensionIdentifier.equals(t,g))return!0;return!1}}e.ExtensionHostExtensions=N;function A(y){const g=new E.ExtensionIdentifierMap;for(const t of y)g.set(t.identifier,t);return g}function D(y,g){return y.enabledApiProposals?y.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=D;function k(y,g){if(!D(y,g))throw new Error(`Extension '${y.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${y.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${y.identifier.value}`)}e.checkProposedApiEnabled=k;class C{constructor(g,t,s,r){this.codeLoadingTime=g,this.activateCallTime=t,this.activateResolvedTime=s,this.activationReason=r}}e.ActivationTimes=C;class m{constructor(g,t){this.description=g,this.value=t}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var o;(function(y){y[y.Normal=0]="Normal",y[y.Immediate=1]="Immediate"})(o=e.ActivationKind||(e.ActivationKind={}));function d(y){return{type:y.isBuiltin?0:1,isBuiltin:y.isBuiltin||y.isUserBuiltin,identifier:{id:(0,c.getGalleryExtensionId)(y.publisher,y.name),uuid:y.uuid},manifest:y,location:y.extensionLocation,targetPlatform:y.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function f(y,g){return{identifier:new E.ExtensionIdentifier((0,c.getExtensionId)(y.manifest.publisher,y.manifest.name)),isBuiltin:y.type===0,isUserBuiltin:y.type===1&&y.isBuiltin,isUnderDevelopment:!!g,extensionLocation:y.location,...y.manifest,uuid:y.identifier.uuid,targetPlatform:y.targetPlatform,browserNlsBundleUris:y.browserNlsBundleUris}}e.toExtensionDescription=f;class p{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(g){return Promise.resolve(void 0)}activationEventIsDone(g){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(g,t){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=p}),define(De[239],Ce([1,0,10,135,25,27,13,19]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(d,f,p,y){this.startup=d,this.codeLoadingTime=f,this.activateCallTime=p,this.activateResolvedTime=y}}S.NONE=new S(!1,-1,-1,-1),e.ExtensionActivationTimes=S;class I{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,f){return d===-1||f===-1?-1:f-d}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=I;class N{constructor(d,f,p,y,g,t){this.activationFailed=d,this.activationFailedError=f,this.activationTimes=p,this.module=y,this.exports=g,this.subscriptions=t}}e.ActivatedExtension=N;class A extends N{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class D extends N{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=D;class k extends N{constructor(d){super(!0,d,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let C=class{constructor(d,f,p,y){this.g=y,this.a=d,this.b=f,this.c=p,this.d=new c.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[d,f]of this.d)f.dispose()}isActivated(d){const f=this.d.get(d);return Boolean(f&&f.value)}getActivatedExtension(d){const f=this.d.get(d);if(!f||!f.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return f.value}async activateByEvent(d,f){if(this.f[d])return;const p=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(p.map(y=>({id:y.identifier,reason:{startup:f,extensionId:y.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,f){const p=this.a.getExtensionDescription(d);if(!p)throw new Error(`Extension '${d}' is not known`);return this.h([{id:p.identifier,reason:f}])}async h(d){const f=d.filter(p=>!this.isActivated(p.id)).map(p=>this.j(p));await Promise.all(f.map(p=>p.wait()))}j(d){if(this.d.has(d.id))return this.d.get(d.id);if(this.l(d.id))return this.k(d,null,[],null);const f=this.a.getExtensionDescription(d.id);if(!f){const g=new Error(`Cannot activate unknown extension '${d.id.value}'`),t=this.k(d,null,[],new k(g));return this.c.onExtensionActivationError(d.id,g,new L.MissingExtensionDependency(d.id.value)),t}const p=[],y=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const g of y){if(this.m(g))continue;const t=this.d.get(g);if(t){p.push(t);continue}if(this.l(g)){p.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:d.reason}));continue}const s=this.a.getExtensionDescription(g);if(s){if(!s.main&&!s.browser)continue;p.push(this.j({id:s.identifier,reason:d.reason}));continue}const r=f.displayName||f.identifier.value,l=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${g}'`),u=this.k(d,f.displayName,[],new k(l));return this.c.onExtensionActivationError(f.identifier,l,new L.MissingExtensionDependency(g)),u}return this.k(d,f.displayName,p,null)}k(d,f,p,y){const g=new m(d.id,f,d.reason,p,y,this.c,this.g);return this.d.set(d.id,g),g}l(d){return R.ExtensionDescriptionRegistry.isHostExtension(d,this.a,this.b)}m(d){const f=this.b.getExtensionDescription(d);return f?!f.main&&!f.browser:!1}};C=Ve([ze(3,E.ILogService)],C),e.ExtensionsActivator=C;let m=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,f,p,y,g,t,s){this.c=d,this.d=f,this.f=p,this.g=y,this.h=g,this.j=t,this.k=s,this.a=new T.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const f=this.g[d];if(f.value&&!f.value.activationFailed){this.g.splice(d,1),d--;continue}if(f.value&&f.value.activationFailed){const p=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);p.detail=f.value.activationFailedError,this.h=new k(p),this.j.onExtensionActivationError(this.c,p,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const f=new Error;if(d&&d.name&&(f.name=d.name),d&&d.message?f.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:f.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(f.stack=d.stack),this.h=new k(f),this.b&&a.isCancellationError(d))return;this.j.onExtensionActivationError(this.c,f,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};m=Ve([ze(6,E.ILogService)],m)});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,R,c){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!c)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!c:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?c.call(ie,a):c?c.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!R:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(ie):R?R.value:e.get(ie)};define(De[7],Ce([1,0,15,10,112,28,87,8,9,2,30,44,128,93,27]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C){"use strict";var m,o,d,f,p,y,g,t,s,r,l,u,b,i,n,h,w,v,O,j,V,Q,G;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function U(K){return Object.assign(K,{apply:function(){const me=arguments.length===1?[]:arguments[1];return Reflect.construct(K,me,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(K,[]);{const[me,...Te]=arguments;return Reflect.construct(K,Te,me.constructor)}}})}var P;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(P=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var M;(function(K){K[K.Command=0]="Command",K[K.Opener=1]="Opener"})(M=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let B=y=class{static from(...W){let me=W;return new y(function(){if(me){for(const Te of me)Te&&typeof Te.dispose=="function"&&Te.dispose();me=void 0}})}constructor(W){m.set(this,void 0),Je(this,m,W,"f")}dispose(){typeof Ue(this,m,"f")=="function"&&(Ue(this,m,"f").call(this),Je(this,m,void 0,"f"))}};m=new WeakMap,B=y=Ve([U],B),e.Disposable=B;let Z=g=class{static Min(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Te=1;Te<W.length;Te++){const Ge=W[Te];Ge.isBefore(me)&&(me=Ge)}return me}static Max(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Te=1;Te<W.length;Te++){const Ge=W[Te];Ge.isAfter(me)&&(me=Ge)}return me}static isPosition(W){if(!W)return!1;if(W instanceof g)return!0;const{line:me,character:Te}=W;return typeof me=="number"&&typeof Te=="number"}static of(W){if(W instanceof g)return W;if(this.isPosition(W))return new g(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,me){if(W<0)throw(0,R.illegalArgument)("line must be non-negative");if(me<0)throw(0,R.illegalArgument)("character must be non-negative");this.c=W,this.e=me}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,me=0){if(W===null||me===null)throw(0,R.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,me=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&me===0?this:new g(this.line+Te,this.character+me)}with(W,me=this.character){if(W===null||me===null)throw(0,R.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,me=typeof W.character=="number"?W.character:this.character),Te===this.line&&me===this.character?this:new g(Te,me)}toJSON(){return{line:this.line,character:this.character}}};Z=g=Ve([U],Z),e.Position=Z;let Y=t=class{static isRange(W){return W instanceof t?!0:W?Z.isPosition(W.start)&&Z.isPosition(W.end):!1}static of(W){if(W instanceof t)return W;if(this.isRange(W))return new t(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,me,Te,Ge){let Ye,ct;if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ge=="number"?(Ye=new Z(W,me),ct=new Z(Te,Ge)):Z.isPosition(W)&&Z.isPosition(me)&&(Ye=Z.of(W),ct=Z.of(me)),!Ye||!ct)throw new Error("Invalid arguments");Ye.isBefore(ct)?(this.c=Ye,this.e=ct):(this.c=ct,this.e=Ye)}contains(W){return t.isRange(W)?this.contains(W.start)&&this.contains(W.end):Z.isPosition(W)?!(Z.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const me=Z.Max(W.start,this.c),Te=Z.Min(W.end,this.e);if(!me.isAfter(Te))return new t(me,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const me=Z.Min(W.start,this.c),Te=Z.Max(W.end,this.end);return new t(me,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,me=this.end){if(W===null||me===null)throw(0,R.illegalArgument)();let Te;return W?Z.isPosition(W)?Te=W:(Te=W.start||this.start,me=W.end||this.end):Te=this.start,Te.isEqual(this.c)&&me.isEqual(this.end)?this:new t(Te,me)}toJSON(){return[this.start,this.end]}};Y=t=Ve([U],Y),e.Range=Y;let H=s=class extends Y{static isSelection(W){return W instanceof s?!0:W?Y.isRange(W)&&Z.isPosition(W.anchor)&&Z.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,me,Te,Ge){let Ye,ct;if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ge=="number"?(Ye=new Z(W,me),ct=new Z(Te,Ge)):Z.isPosition(W)&&Z.isPosition(me)&&(Ye=Z.of(W),ct=Z.of(me)),!Ye||!ct)throw new Error("Invalid arguments");super(Ye,ct),this.f=Ye,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};H=s=Ve([U],H),e.Selection=H;class _{constructor(W,me,Te){if(typeof W!="string"||W.length===0)throw(0,R.illegalArgument)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,R.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,R.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(me),this.connectionToken=Te}}e.ResolvedAuthority=_;class ee extends Error{static NotAvailable(W,me){return new ee(W,D.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(W){return new ee(W,D.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,me=D.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=me,this._detail=Te,Object.setPrototypeOf(this,ee.prototype)}}e.RemoteAuthorityResolverError=ee;var be;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(be=e.EndOfLine||(e.EndOfLine={}));var ce;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(ce=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let oe=r=class{static isTextEdit(W){return W instanceof r?!0:W?Y.isRange(W)&&typeof W.newText=="string":!1}static replace(W,me){return new r(W,me)}static insert(W,me){return r.replace(new Y(W,W),me)}static delete(W){return r.replace(W,"")}static setEndOfLine(W){const me=new r(new Y(new Z(0,0),new Z(0,0)),"");return me.newEol=W,me}get range(){return this.c}set range(W){if(W&&!Y.isRange(W))throw(0,R.illegalArgument)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,R.illegalArgument)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,R.illegalArgument)("newEol");this.f=W}constructor(W,me){this.c=W,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};oe=r=Ve([U],oe),e.TextEdit=oe;let x=l=class{static isNotebookCellEdit(W){return W instanceof l?!0:W?Gt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,me){return new l(W,me)}static insertCells(W,me){return new l(new Gt(W,W),me)}static deleteCells(W){return new l(W,[])}static updateCellMetadata(W,me){const Te=new l(new Gt(W,W),[]);return Te.newCellMetadata=me,Te}static updateNotebookMetadata(W){const me=new l(new Gt(0,0),[]);return me.newNotebookMetadata=W,me}constructor(W,me){this.range=W,this.newCells=me}};x=l=Ve([U],x),e.NotebookEdit=x;class he{static isSnippetTextEdit(W){return W instanceof he?!0:W?Y.isRange(W.range)&&Re.isSnippetString(W.snippet):!1}static replace(W,me){return new he(W,me)}static insert(W,me){return he.replace(new Y(W,W),me)}constructor(W,me){this.range=W,this.snippet=me}}e.SnippetTextEdit=he;var pe;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(pe=e.FileEditType||(e.FileEditType={}));let Se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,me,Te,Ge){this.c.push({_type:1,from:W,to:me,options:Te,metadata:Ge})}createFile(W,me,Te){this.c.push({_type:1,from:void 0,to:W,options:me,metadata:Te})}deleteFile(W,me,Te){this.c.push({_type:1,from:W,to:void 0,options:me,metadata:Te})}e(W,me,Te){this.c.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:me},notebookMetadata:me})}f(W,me,Te,Ge){const Ye=me.start,ct=me.end;(Ye!==ct||Te.length>0)&&this.c.push({_type:5,uri:W,index:Ye,count:ct-Ye,cells:Te,metadata:Ge})}g(W,me,Te,Ge){this.c.push({_type:3,metadata:Ge,uri:W,edit:{editType:8,index:me,metadata:Te}})}replace(W,me,Te,Ge){this.c.push({_type:2,uri:W,edit:new oe(me,Te),metadata:Ge})}insert(W,me,Te,Ge){this.replace(W,new Y(me,me),Te,Ge)}delete(W,me,Te){this.replace(W,me,"",Te)}has(W){return this.c.some(me=>me._type===2&&me.uri.toString()===W.toString())}set(W,me){if(me)for(const Te of me){if(!Te)continue;let Ge,Ye;Array.isArray(Te)?(Ge=Te[0],Ye=Te[1]):Ge=Te,x.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(W,Ge.range.start,Ge.newCellMetadata,Ye):Ge.newNotebookMetadata?this.e(W,Ge.newNotebookMetadata,Ye):this.f(W,Ge.range,Ge.newCells,Ye):he.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:W,range:Ge.range,edit:Ge.snippet,metadata:Ye}):this.c.push({_type:2,uri:W,edit:Ge,metadata:Ye})}else{for(let Te=0;Te<this.c.length;Te++){const Ge=this.c[Te];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===W.toString()&&(this.c[Te]=void 0);break}}(0,a.coalesceInPlace)(this.c)}}get(W){const me=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===W.toString()&&me.push(Te.edit);return me}entries(){const W=new L.ResourceMap;for(const me of this.c)if(me._type===2){let Te=W.get(me.uri);Te||(Te=[me.uri,[]],W.set(me.uri,Te)),Te[1].push(me.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Se=Ve([U],Se),e.WorkspaceEdit=Se;let Re=u=class{static isSnippetString(W){return W instanceof u?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=u.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,me=this.e++){if(typeof W=="function"){const Te=new u;Te.e=this.e,W(Te),this.e=Te.e,W=Te.value}else W=u.c(W);return this.value+="${",this.value+=me,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,me=this.e++){const Te=W.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,me){if(typeof me=="function"){const Te=new u;Te.e=this.e,me(Te),this.e=Te.e,me=Te.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,me&&(this.value+=":",this.value+=me),this.value+="}",this}};Re=u=Ve([U],Re),e.SnippetString=Re;var re;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(re=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=b=class{static isLocation(W){return W instanceof b?!0:W?Y.isRange(W.range)&&I.URI.isUri(W.uri):!1}constructor(W,me){if(this.uri=W,me)if(Y.isRange(me))this.range=Y.of(me);else if(Z.isPosition(me))this.range=new Y(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};de=b=Ve([U],de),e.Location=de;let te=class{static is(W){return W?typeof W.message=="string"&&W.location&&Y.isRange(W.location.range)&&I.URI.isUri(W.location.uri):!1}constructor(W,me){this.location=W,this.message=me}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.location.range.isEqual(me.location.range)&&W.location.uri.toString()===me.location.uri.toString()}};te=Ve([U],te),e.DiagnosticRelatedInformation=te;let ae=class{constructor(W,me,Te=le.Error){if(!Y.isRange(W))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=W,this.message=me,this.severity=Te}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.severity===me.severity&&W.code===me.code&&W.severity===me.severity&&W.source===me.source&&W.range.isEqual(me.range)&&(0,a.equals)(W.tags,me.tags)&&(0,a.equals)(W.relatedInformation,me.relatedInformation,te.isEqual)}};ae=Ve([U],ae),e.Diagnostic=ae;let se=class{constructor(W,me){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=me}};se=Ve([U],se),e.Hover=se;var F;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(F=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(W,me=F.Text){this.range=W,this.kind=me}toJSON(){return{range:this.range,kind:F[this.kind]}}};$=Ve([U],$),e.DocumentHighlight=$;var q;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(q=e.SymbolKind||(e.SymbolKind={}));var J;(function(K){K[K.Deprecated=1]="Deprecated"})(J=e.SymbolTag||(e.SymbolTag={}));let ue=i=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,me,Te,Ge,Ye){this.name=W,this.kind=me,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ge instanceof de?this.location=Ge:Te instanceof Y&&(this.location=new de(Ge,Te)),i.validate(this)}toJSON(){return{name:this.name,kind:q[this.kind],location:this.location,containerName:this.containerName}}};ue=i=Ve([U],ue),e.SymbolInformation=ue;let we=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(n.validate)}constructor(W,me,Te,Ge,Ye){this.name=W,this.detail=me,this.kind=Te,this.range=Ge,this.selectionRange=Ye,this.children=[],n.validate(this)}};we=n=Ve([U],we),e.DocumentSymbol=we;var Ae;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(Ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ve=class{constructor(W,me){this.title=W,this.kind=me}};ve=Ve([U],ve),e.CodeAction=ve;let Ie=h=class{constructor(W){this.value=W}append(W){return new h(this.value?this.value+h.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+h.c)}};Ie.c=".",Ie=h=Ve([U],Ie),e.CodeActionKind=Ie,Ie.Empty=new Ie(""),Ie.QuickFix=Ie.Empty.append("quickfix"),Ie.Refactor=Ie.Empty.append("refactor"),Ie.RefactorExtract=Ie.Refactor.append("extract"),Ie.RefactorInline=Ie.Refactor.append("inline"),Ie.RefactorMove=Ie.Refactor.append("move"),Ie.RefactorRewrite=Ie.Refactor.append("rewrite"),Ie.Source=Ie.Empty.append("source"),Ie.SourceOrganizeImports=Ie.Source.append("organizeImports"),Ie.SourceFixAll=Ie.Source.append("fixAll");let ke=class{constructor(W,me){if(this.range=W,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=Ve([U],ke),e.SelectionRange=ke;class He{constructor(W,me,Te,Ge,Ye,ct){this.kind=W,this.name=me,this.detail=Te,this.uri=Ge,this.range=Ye,this.selectionRange=ct}}e.CallHierarchyItem=He;class qe{constructor(W,me){this.fromRanges=me,this.from=W}}e.CallHierarchyIncomingCall=qe;class nt{constructor(W,me){this.fromRanges=me,this.to=W}}e.CallHierarchyOutgoingCall=nt;var Qe;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor(W,me){this.range=W,this.command=me}get isResolved(){return!!this.command}};tt=Ve([U],tt),e.CodeLens=tt;let rt=w=class{static isMarkdownString(W){return W instanceof w?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,me=!1){o.set(this,void 0),Je(this,o,new c.MarkdownString(W,{supportThemeIcons:me}),"f")}get value(){return Ue(this,o,"f").value}set value(W){Ue(this,o,"f").value=W}get isTrusted(){return Ue(this,o,"f").isTrusted}set isTrusted(W){Ue(this,o,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,o,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,o,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,o,"f").supportHtml}set supportHtml(W){Ue(this,o,"f").supportHtml=W}get baseUri(){return Ue(this,o,"f").baseUri}set baseUri(W){Ue(this,o,"f").baseUri=W}appendText(W){return Ue(this,o,"f").appendText(W),this}appendMarkdown(W){return Ue(this,o,"f").appendMarkdown(W),this}appendCodeblock(W,me){return Ue(this,o,"f").appendCodeblock(me??"",W),this}};o=new WeakMap,rt=w=Ve([U],rt),e.MarkdownString=rt;let Be=class{constructor(W,me){this.label=W,this.documentation=me}};Be=Ve([U],Be),e.ParameterInformation=Be;let it=class{constructor(W,me){this.label=W,this.documentation=me,this.parameters=[]}};it=Ve([U],it),e.SignatureInformation=it;let z=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};z=Ve([U],z),e.SignatureHelp=z;var X;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var fe;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(fe=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(W){this.value=W}};Le=Ve([U],Le),e.InlayHintLabelPart=Le;let Ne=class{constructor(W,me,Te){this.position=W,this.label=me,this.kind=Te}};Ne=Ve([U],Ne),e.InlayHint=Ne;var je;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _e;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(_e=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(K){K[K.Deprecated=1]="Deprecated"})(Xe=e.CompletionItemTag||(e.CompletionItemTag={}));let st=class{constructor(W,me){this.label=W,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&_e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};st=Ve([U],st),e.CompletionItem=st;let at=class{constructor(W=[],me=!1){this.items=W,this.isIncomplete=me}};at=Ve([U],at),e.CompletionList=at;let mt=class{constructor(W,me,Te){this.insertText=W,this.range=me,this.command=Te}};mt=Ve([U],mt),e.InlineSuggestion=mt;let gt=class{constructor(W){this.commands=void 0,this.items=W}};gt=Ve([U],gt),e.InlineSuggestionList=gt;var Et;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var Lt;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var lt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(lt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var wt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(wt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ht;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ht=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ft;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var It;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(It=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var pt;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(pt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(K){function W(me){switch(me){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=W}(Ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Tt=class{constructor(W,me){if(me&&!I.URI.isUri(me))throw(0,R.illegalArgument)("target");if(!Y.isRange(W)||W.isEmpty)throw(0,R.illegalArgument)("range");this.range=W,this.target=me}};Tt=Ve([U],Tt),e.DocumentLink=Tt;let Mt=class{constructor(W,me,Te,Ge){this.red=W,this.green=me,this.blue=Te,this.alpha=Ge}};Mt=Ve([U],Mt),e.Color=Mt;let Ot=class{constructor(W,me){if(me&&!(me instanceof Mt))throw(0,R.illegalArgument)("color");if(!Y.isRange(W)||W.isEmpty)throw(0,R.illegalArgument)("range");this.range=W,this.color=me}};Ot=Ve([U],Ot),e.ColorInformation=Ot;let Ke=class{constructor(W){if(!W||typeof W!="string")throw(0,R.illegalArgument)("label");this.label=W}};Ke=Ve([U],Ke),e.ColorPresentation=Ke;var xt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(xt=e.ColorFormat||(e.ColorFormat={}));var Nt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Nt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Bt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(Bt=e.TerminalExitReason||(e.TerminalExitReason={}));class Pe{constructor(W,me,Te){if(this.startIndex=W,this.length=me,this.tooltip=Te,typeof W!="number"||W<0)throw(0,R.illegalArgument)("startIndex");if(typeof me!="number"||me<1)throw(0,R.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=Pe;class Oe{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=Oe;class ye{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=ye;var ne;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor(W){if(this.options=W,typeof W!="object")throw(0,R.illegalArgument)("options")}}e.TerminalProfile=Fe;var We;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(We=e.TaskRevealKind||(e.TaskRevealKind={}));var Ze;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(Ze=e.TaskPanelKind||(e.TaskPanelKind={}));let xe=v=class{static from(W){switch(W){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}constructor(W,me){if(this.label=me,typeof W!="string"||typeof me!="string")throw(0,R.illegalArgument)("name");this.c=W}get id(){return this.c}};xe.Clean=new v("clean","Clean"),xe.Build=new v("build","Build"),xe.Rebuild=new v("rebuild","Rebuild"),xe.Test=new v("test","Test"),xe=v=Ve([U],xe),e.TaskGroup=xe;function et(K){let W="";for(let me=0;me<K.length;me++)W+=K[me].replace(/,/g,",,")+",";return W}let ut=class{constructor(W,me,Te){if(typeof W!="string")throw(0,R.illegalArgument)("process");this.e=[],this.c=W,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Te):this.f=me)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,R.illegalArgument)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const me of this.e)W.push(me);return et(W)}};ut=Ve([U],ut),e.ProcessExecution=ut;let ft=class{constructor(W,me,Te){if(this.f=[],Array.isArray(me)){if(!W)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,R.illegalArgument)("command");this.e=W,this.f=me,this.g=Te}else{if(typeof W!="string")throw(0,R.illegalArgument)("commandLine");this.c=W,this.g=me}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,R.illegalArgument)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,R.illegalArgument)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)W.push(typeof me=="string"?me:me.value);return et(W)}};ft=Ve([U],ft),e.ShellExecution=ft;var kt;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(kt=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class St{constructor(W){this.c=W}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(W){this.c=W}get callback(){return this.c}}e.CustomExecution=St;let Pt=O=class{constructor(W,me,Te,Ge,Ye,ct){this.j=!1,this.k=this.definition=W;let dt;typeof me=="string"?(this.m=this.name=me,this.t=this.source=Te,this.execution=Ge,dt=Ye,this.j=!0):me===bt.Global||me===bt.Workspace?(this.target=me,this.m=this.name=Te,this.t=this.source=Ge,this.execution=Ye,dt=ct):(this.target=me,this.m=this.name=Te,this.t=this.source=Ge,this.execution=Ye,dt=ct),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ut?this.k={type:O.e,id:this.n.computeId()}:this.n instanceof ft?this.k={type:O.f,id:this.n.computeId()}:this.n instanceof St?this.k={type:O.c,id:this.n.computeId()}:this.k={type:O.g,id:(0,N.generateUuid)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,R.illegalArgument)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const me=this.k.type;(O.g===me||O.e===me||O.f===me||O.c===me)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};Pt.c="customExecution",Pt.e="process",Pt.f="shell",Pt.g="$empty",Pt=O=Ve([U],Pt),e.Task=Pt;var zt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(zt=e.ProgressLocation||(e.ProgressLocation={}));var At;(function(K){function W(me){const Te=me;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}K.isViewBadge=W})(At=e.ViewBadge||(e.ViewBadge={}));let ti=j=class{static isTreeItem(W,me){const Te=W;if(Te.checkboxState!==void 0){(0,C.checkProposedApiEnabled)(me,"treeItemCheckbox");const Ge=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Ct.Checked&&Ge!==Ct.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(W instanceof j)return!0;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!I.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const Ge=Te.iconPath;if(!Ge||!(0,S.isString)(Ge.light)&&!I.URI.isUri(Ge.light)&&!(0,S.isString)(Ge.dark)&&!I.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!I.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof rt)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<oi.None&&Te.collapsibleState>oi.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(W,me=oi.None){this.collapsibleState=me,I.URI.isUri(W)?this.resourceUri=W:this.label=W}};ti=j=Ve([U],ti),e.TreeItem=ti;var oi;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(oi=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Ct;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Ct=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ai=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,me){this.value=W,this.id=me??(0,N.generateUuid)()}};ai=Ve([U],ai),e.DataTransferItem=ai;let ci=class{constructor(W){d.set(this,new Map);for(const[me,Te]of W??[]){const Ge=Ue(this,d,"f").get(me);Ge?Ge.push(Te):Ue(this,d,"f").set(me,[Te])}}get(W){return Ue(this,d,"f").get(W)?.[0]}set(W,me){Ue(this,d,"f").set(W,[me])}forEach(W,me){for(const[Te,Ge]of Ue(this,d,"f"))for(const Ye of Ge)W.call(me,Ye,Te,this)}*[(d=new WeakMap,Symbol.iterator)](){for(const[W,me]of Ue(this,d,"f"))for(const Te of me)yield[W,Te]}};ci=Ve([U],ci),e.DataTransfer=ci;let Jt=class{constructor(W){this.insertText=W}};Jt=Ve([U],Jt),e.DocumentDropEdit=Jt;let Ei=class{constructor(W){this.insertText=W}};Ei=Ve([U],Ei),e.DocumentPasteEdit=Ei;let yt=class{constructor(W,me){this.id=W,this.color=me}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};yt=Ve([U],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let li=class{constructor(W){this.id=W}};li=Ve([U],li),e.ThemeColor=li;var Ui;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Ui=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Zt=class{get base(){return this.c}set base(W){this.c=W,this.e=I.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,me){if(typeof W!="string"&&(!W||!I.URI.isUri(W)&&!I.URI.isUri(W.uri)))throw(0,R.illegalArgument)("base");if(typeof me!="string")throw(0,R.illegalArgument)("pattern");typeof W=="string"?this.baseUri=I.URI.file(W):I.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Zt=Ve([U],Zt),e.RelativePattern=Zt;const ii=new WeakMap;function ht(K,W){ii.set(K,W)}e.setBreakpointId=ht;let ei=class{constructor(W,me,Te,Ge){this.enabled=typeof W=="boolean"?W:!0,typeof me=="string"&&(this.condition=me),typeof Te=="string"&&(this.hitCondition=Te),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=ii.get(this)??(0,N.generateUuid)()),this.c}};ei=Ve([U],ei),e.Breakpoint=ei;let jt=class extends ei{constructor(W,me,Te,Ge,Ye){if(super(me,Te,Ge,Ye),W===null)throw(0,R.illegalArgument)("location");this.location=W}};jt=Ve([U],jt),e.SourceBreakpoint=jt;let Xt=class extends ei{constructor(W,me,Te,Ge,Ye){super(me,Te,Ge,Ye),this.functionName=W}};Xt=Ve([U],Xt),e.FunctionBreakpoint=Xt;let ui=class extends ei{constructor(W,me,Te,Ge,Ye,ct,dt){if(super(Ge,Ye,ct,dt),!me)throw(0,R.illegalArgument)("dataId");this.label=W,this.dataId=me,this.canPersist=Te}};ui=Ve([U],ui),e.DataBreakpoint=ui;let Si=class{constructor(W,me,Te){this.command=W,this.args=me||[],this.options=Te}};Si=Ve([U],Si),e.DebugAdapterExecutable=Si;let yi=class{constructor(W,me){this.port=W,this.host=me}};yi=Ve([U],yi),e.DebugAdapterServer=yi;let di=class{constructor(W){this.path=W}};di=Ve([U],di),e.DebugAdapterNamedPipeServer=di;let Di=class{constructor(W){this.implementation=W}};Di=Ve([U],Di),e.DebugAdapterInlineImplementation=Di;let hi=class{constructor(W,me){this.range=W,this.expression=me}};hi=Ve([U],hi),e.EvaluatableExpression=hi;var fi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(fi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ci=class{constructor(W,me){this.range=W,this.text=me}};Ci=Ve([U],Ci),e.InlineValueText=Ci;let ni=class{constructor(W,me,Te=!0){this.range=W,this.variableName=me,this.caseSensitiveLookup=Te}};ni=Ve([U],ni),e.InlineValueVariableLookup=ni;let ri=class{constructor(W,me){this.range=W,this.expression=me}};ri=Ve([U],ri),e.InlineValueEvaluatableExpression=ri;let Ii=class{constructor(W,me){this.frameId=W,this.stoppedLocation=me}};Ii=Ve([U],Ii),e.InlineValueContext=Ii;var Bi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Bi=e.FileChangeType||(e.FileChangeType={}));let Qt=V=class extends Error{static FileExists(W){return new V(W,A.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(W){return new V(W,A.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(W){return new V(W,A.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(W){return new V(W,A.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(W){return new V(W,A.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(W){return new V(W,A.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(W,me=A.FileSystemProviderErrorCode.Unknown,Te){super(I.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,A.markAsFileSystemProviderError)(this,me),Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Qt=V=Ve([U],Qt),e.FileSystemError=Qt;let ki=class{constructor(W,me,Te){this.start=W,this.end=me,this.kind=Te}};ki=Ve([U],ki),e.FoldingRange=ki;var $i;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})($i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var zi;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(zi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Wi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Wi=e.CommentMode||(e.CommentMode={}));var Hi;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(Hi=e.CommentThreadState||(e.CommentThreadState={}));class Ti{constructor(W,me=[]){this.tokenTypes=W,this.tokenModifiers=me}}e.SemanticTokensLegend=Ti;function Li(K){return typeof K>"u"||(0,S.isStringArray)(K)}class mi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let me=0,Te=W.tokenTypes.length;me<Te;me++)this.j.set(W.tokenTypes[me],me);for(let me=0,Te=W.tokenModifiers.length;me<Te;me++)this.k.set(W.tokenModifiers[me],me)}}push(W,me,Te,Ge,Ye){if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ge=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(W,me,Te,Ge,Ye);if(Y.isRange(W)&&typeof me=="string"&&Li(Te))return this.m(W,me,Te);throw(0,R.illegalArgument)()}m(W,me,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(me))throw new Error("`tokenType` is not in the provided legend");const Ge=W.start.line,Ye=W.start.character,ct=W.end.character-W.start.character,dt=this.j.get(me);let Ut=0;if(Te)for(const Wt of Te){if(!this.k.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const Vt=this.k.get(Wt);Ut|=1<<Vt>>>0}this.n(Ge,Ye,ct,dt,Ut)}n(W,me,Te,Ge,Ye){if(this.f&&(W<this.c||W===this.c&&me<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Wt=0,Vt=0;for(let Kt=0;Kt<Ut;Kt++){let _t=this.g[5*Kt],Ai=this.g[5*Kt+1];_t===0?(_t=Wt,Ai+=Vt):_t+=Wt,this.g[5*Kt]=_t,this.g[5*Kt+1]=Ai,Wt=_t,Vt=Ai}}let ct=W,dt=me;this.f&&this.h>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ge,this.g[this.h++]=Ye,this.c=W,this.e=me}static o(W){const me=[],Te=W.length/5|0;for(let dt=0;dt<Te;dt++)me[dt]=dt;me.sort((dt,Ut)=>{const Wt=W[5*dt],Vt=W[5*Ut];if(Wt===Vt){const Kt=W[5*dt+1],_t=W[5*Ut+1];return Kt-_t}return Wt-Vt});const Ge=new Uint32Array(W.length);let Ye=0,ct=0;for(let dt=0;dt<Te;dt++){const Ut=5*me[dt],Wt=W[Ut+0],Vt=W[Ut+1],Kt=W[Ut+2],_t=W[Ut+3],Ai=W[Ut+4],sn=Wt-Ye,Rn=sn===0?Vt-ct:Vt,Ri=5*dt;Ge[Ri+0]=sn,Ge[Ri+1]=Rn,Ge[Ri+2]=Kt,Ge[Ri+3]=_t,Ge[Ri+4]=Ai,Ye=Wt,ct=Vt}return Ge}build(W){return this.f?new $e(new Uint32Array(this.g),W):new $e(mi.o(this.g),W)}}e.SemanticTokensBuilder=mi;class $e{constructor(W,me){this.resultId=me,this.data=W}}e.SemanticTokens=$e;class qt{constructor(W,me,Te){this.start=W,this.deleteCount=me,this.data=Te}}e.SemanticTokensEdit=qt;class Oi{constructor(W,me){this.resultId=me,this.edits=W}}e.SemanticTokensEdits=Oi;var vt;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(vt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let gi=class{constructor(){}};gi.Back={iconPath:new yt("arrow-left")},gi=Ve([U],gi),e.QuickInputButtons=gi;var ji;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(ji=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Ni;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(Ni=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Vi;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(Vi=e.ExtensionKind||(e.ExtensionKind={}));class pi{static validate(W){if(typeof W.badge=="string"){let me=(0,T.nextCharLength)(W.badge,0);if(me<W.badge.length&&(me+=(0,T.nextCharLength)(W.badge,me)),W.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!yt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,me,Te){this.badge=W,this.tooltip=me,this.color=Te}}e.FileDecoration=pi;let Pi=class{constructor(W){this.kind=W}};Pi=Ve([U],Pi),e.ColorTheme=Pi;var xi;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(xi=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{static isNotebookRange(W){return W instanceof Gt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,me){if(W<0)throw(0,R.illegalArgument)("start must be positive");if(me<0)throw(0,R.illegalArgument)("end must be positive");W<=me?(this.c=W,this.e=me):(this.c=me,this.e=W)}with(W){let me=this.c,Te=this.e;return W.start!==void 0&&(me=W.start),W.end!==void 0&&(Te=W.end),me===this.c&&Te===this.e?this:new Gt(me,Te)}}e.NotebookRange=Gt;class si{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(me=>si.isNotebookCellData(me))}static isNotebookCellData(W){return!0}constructor(W,me,Te,Ge,Ye,ct,dt){this.kind=W,this.value=me,this.languageId=Te,this.mime=Ge,this.outputs=Ye??[],this.metadata=ct,this.executionSummary=dt,si.validate(this)}}e.NotebookCellData=si;class qi{constructor(W){this.cells=W}}e.NotebookData=qi;class $t{static isNotebookCellOutputItem(W){return W instanceof $t?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const me={name:W.name,message:W.message,stack:W.stack};return $t.json(me,"application/vnd.code.notebook.error")}static stdout(W){return $t.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return $t.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,me="application/octet-stream"){return new $t(W,me)}static text(W,me=E.Mimes.text){const Te=Ue($t,f,"f",p).encode(String(W));return new $t(Te,me)}static json(W,me="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return $t.text(Te,me)}constructor(W,me){this.data=W,this.mime=me;const Te=(0,E.normalizeMimeType)(me,!0);if(!Te)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}f=$t,p={value:new TextEncoder},e.NotebookCellOutputItem=$t;class bi{static isNotebookCellOutput(W){return W instanceof bi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,me=!1){const Te=new Set,Ge=new Set;for(let Ye=0;Ye<W.length;Ye++){const ct=W[Ye],dt=(0,E.normalizeMimeType)(ct.mime);if(!Te.has(dt)||(0,k.isTextStreamMime)(dt)){Te.add(dt);continue}Ge.add(Ye),me&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ge.size===0?W:W.filter((Ye,ct)=>!Ge.has(ct))}constructor(W,me,Te){this.items=bi.ensureUniqueMimeTypes(W,!0),typeof me=="string"?(this.id=me,this.metadata=Te):(this.id=(0,N.generateUuid)(),this.metadata=me??Te)}}e.NotebookCellOutput=bi;var Gi;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(Gi=e.NotebookCellKind||(e.NotebookCellKind={}));var Ki;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(Ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Xi;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Xi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var ge;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(ge=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ee{constructor(W,me){this.text=W,this.alignment=me}}e.NotebookCellStatusBarItem=Ee;var Me;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(Me=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var ot;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(ot=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Dt{constructor(W,me=[]){this.uri=W,this.provides=(0,a.asArray)(me)}}e.NotebookRendererScript=Dt;class Rt{constructor(W){this.label=W}}e.NotebookKernelSourceAction=Rt;let Qi=class{constructor(W,me){this.label=W,this.timestamp=me}};Qi=Ve([U],Qi),e.TimelineItem=Qi;var un;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(W,me){this.ranges=W,this.wordPattern=me}}e.LinkedEditingRanges=fn;class mn{constructor(W,me){this.c=W,this.e=me}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(W=void 0,me=void 0,Te=void 0){this.include=W,this.exclude=me,this.profile=Te}};Fi=Ve([U],Fi),e.TestRunRequest=Fi;let _i=class extends Fi{constructor(W=void 0,me=void 0,Te=void 0,Ge=!1){super(W,me,Te),this.continuous=Ge}};_i=Ve([U],_i),e.TestRunRequest2=_i;let Yi=Q=class{static diff(W,me,Te){const Ge=new Q(W);return Ge.expectedOutput=me,Ge.actualOutput=Te,Ge}constructor(W){this.message=W}};Yi=Q=Ve([U],Yi),e.TestMessage=Yi;let Ji=class{constructor(W){this.id=W}};Ji=Ve([U],Ji),e.TestTag=Ji;let vi=class{constructor(W,me){this.covered=W,this.total=me}};vi=Ve([U],vi),e.CoveredCount=vi;let Zi=G=class{static fromDetails(W,me){const Te=new vi(0,0),Ge=new vi(0,0),Ye=new vi(0,0);for(const dt of me)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Ut of dt.branches)Ge.total+=1,Ge.covered+=Ut.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ct=new G(W,Te,Ge.total>0?Ge:void 0,Ye.total>0?Ye:void 0);return ct.detailedCoverage=me,ct}constructor(W,me,Te,Ge){this.uri=W,this.statementCoverage=me,this.branchCoverage=Te,this.functionCoverage=Ge}};Zi=G=Ve([U],Zi),e.FileCoverage=Zi;let en=class{constructor(W,me,Te=[]){this.executionCount=W,this.location=me,this.branches=Te}};en=Ve([U],en),e.StatementCoverage=en;let tn=class{constructor(W,me){this.executionCount=W,this.location=me}};tn=Ve([U],tn),e.BranchCoverage=tn;let nn=class{constructor(W,me){this.executionCount=W,this.location=me}};nn=Ve([U],nn),e.FunctionCoverage=nn;var bn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(bn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var vn;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var wn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class En{constructor(W,me,Te,Ge,Ye,ct){this.kind=W,this.name=me,this.detail=Te,this.uri=Ge,this.range=Ye,this.selectionRange=ct}}e.TypeHierarchyItem=En;class Sn{constructor(W){this.uri=W}}e.TextTabInput=Sn;class yn{constructor(W,me){this.original=W,this.modified=me}}e.TextDiffTabInput=yn;class Dn{constructor(W,me,Te,Ge){this.base=W,this.input1=me,this.input2=Te,this.result=Ge}}e.TextMergeTabInput=Dn;class Cn{constructor(W,me){this.uri=W,this.viewType=me}}e.CustomEditorTabInput=Cn;class In{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=In;class kn{constructor(W,me){this.uri=W,this.notebookType=me}}e.NotebookEditorTabInput=kn;class Tn{constructor(W,me,Te){this.original=W,this.modified=me,this.notebookType=Te}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(W,me){this.uri=W,this.inputBoxUri=me}}e.InteractiveWindowInput=An}),define(De[136],Ce([1,0,51,16,8,166,106,7,15]),function(ie,e,a,R,c,L,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const I=new Map;function N(C,m){m?I.set(C,m):I.delete(C)}e.setWordDefinitionFor=N;function A(C){return I.get(C)}class D extends L.MirrorTextModel{constructor(m,o,d,f,p,y,g,t){super(o,d,f,p),this.m=m,this.p=y,this.q=g,this.notebook=t,this.b=!1}dispose(){(0,a.ok)(!this.b),this.b=!0,this.q=!1}equalLines(m){return(0,S.equals)(this.d,m)}get document(){if(!this.a){const m=this;this.a={get uri(){return m.c},get fileName(){return m.c.fsPath},get isUntitled(){return m.c.scheme===R.Schemas.untitled},get languageId(){return m.p},get version(){return m.g},get isClosed(){return m.b},get isDirty(){return m.q},save(){return m.r()},getText(o){return o?m.s(o):m.getText()},get eol(){return m.f===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return m.d.length},lineAt(o){return m.t(o)},offsetAt(o){return m.u(o)},positionAt(o){return m.v(o)},validateRange(o){return m.w(o)},validatePosition(o){return m.x(o)},getWordRangeAtPosition(o,d){return m.y(o,d)}}}return Object.freeze(this.a)}_acceptLanguageId(m){(0,a.ok)(!this.b),this.p=m}_acceptIsDirty(m){(0,a.ok)(!this.b),this.q=m}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(m){const o=this.w(m);if(o.isEmpty)return"";if(o.isSingleLine)return this.d[o.start.line].substring(o.start.character,o.end.character);const d=this.f,f=o.start.line,p=o.end.line,y=[];y.push(this.d[f].substring(o.start.character));for(let g=f+1;g<p;g++)y.push(this.d[g]);return y.push(this.d[p].substring(0,o.end.character)),y.join(d)}t(m){let o;if(m instanceof T.Position?o=m.line:typeof m=="number"&&(o=m),typeof o!="number"||o<0||o>=this.d.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new k(o,this.d[o],o===this.d.length-1)}u(m){return m=this.x(m),this.k(),this.h.getPrefixSum(m.line-1)+m.character}v(m){m=Math.floor(m),m=Math.max(0,m),this.k();const o=this.h.getIndexOf(m),d=this.d[o.index].length;return new T.Position(o.index,Math.min(o.remainder,d))}w(m){if(!(m instanceof T.Range))throw new Error("Invalid argument");const o=this.x(m.start),d=this.x(m.end);return o===m.start&&d===m.end?m:new T.Range(o.line,o.character,d.line,d.character)}x(m){if(!(m instanceof T.Position))throw new Error("Invalid argument");if(this.d.length===0)return m.with(0,0);let{line:o,character:d}=m,f=!1;if(o<0)o=0,d=0,f=!0;else if(o>=this.d.length)o=this.d.length-1,d=this.d[o].length,f=!0;else{const p=this.d[o].length;d<0?(d=0,f=!0):d>p&&(d=p,f=!0)}return f?new T.Position(o,d):m}y(m,o){const d=this.x(m);if(!o)o=A(this.p);else if((0,c.regExpLeadsToEndlessLoop)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const f=(0,E.getWordAtText)(d.character+1,(0,E.ensureValidWordDefinition)(o),this.d[d.line],0);if(f)return new T.Range(d.line,f.startColumn-1,d.line,f.endColumn-1)}}e.ExtHostDocumentData=D;class k{constructor(m,o,d){this.a=m,this.b=o,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=k}),define(De[240],Ce([1,0,7,20,3]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(T){this.a=new a.ColorTheme(a.ColorThemeKind.Dark),this.b=new c.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(T){let S;switch(T){case"light":S=a.ColorThemeKind.Light;break;case"hcDark":S=a.ColorThemeKind.HighContrast;break;case"hcLight":S=a.ColorThemeKind.HighContrastLight;break;default:S=a.ColorThemeKind.Dark}this.a=new a.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};L=Ve([ze(0,R.IExtHostRpcService)],L),e.ExtHostTheming=L}),define(De[14],Ce([1,0,15,22,150,63,112,28,148,69,87,23,9,2,32,71,124,133,131,93,57,75,236,7]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f,p,y,g,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Pe){function Oe(ne){const{selectionStartLineNumber:Fe,selectionStartColumn:We,positionLineNumber:Ze,positionColumn:xe}=ne,et=new s.Position(Fe-1,We-1),ut=new s.Position(Ze-1,xe-1);return new s.Selection(et,ut)}Pe.to=Oe;function ye(ne){const{anchor:Fe,active:We}=ne;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Pe.from=ye})(r=e.Selection||(e.Selection={}));var l;(function(Pe){function Oe(ne){if(!ne)return;const{start:Fe,end:We}=ne;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Pe.from=Oe;function ye(ne){if(!ne)return;const{startLineNumber:Fe,startColumn:We,endLineNumber:Ze,endColumn:xe}=ne;return new s.Range(Fe-1,We-1,Ze-1,xe-1)}Pe.to=ye})(l=e.Range||(e.Range={}));var u;(function(Pe){function Oe(ye){switch(ye){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Pe.to=Oe})(u=e.TokenType||(e.TokenType={}));var b;(function(Pe){function Oe(ne){return new s.Position(ne.lineNumber-1,ne.column-1)}Pe.to=Oe;function ye(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Pe.from=ye})(b=e.Position||(e.Position={}));var i;(function(Pe){function Oe(Fe,We){return(0,a.coalesce)((0,a.asArray)(Fe).map(Ze=>ye(Ze,We)))}Pe.from=Oe;function ye(Fe,We){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ne(Fe.scheme,We),pattern:fe.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function ne(Fe,We){return We&&typeof Fe=="string"?We.transformOutgoingScheme(Fe):Fe}})(i=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(Pe){function Oe(ne){switch(ne){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Pe.from=Oe;function ye(ne){switch(ne){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Pe.to=ye})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var h;(function(Pe){function Oe(ne){let Fe;return ne.code&&((0,D.isString)(ne.code)||(0,D.isNumber)(ne.code)?Fe=String(ne.code):Fe={value:String(ne.code.value),target:ne.code.target}),{...l.from(ne.range),message:ne.message,source:ne.source,code:Fe,severity:v.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(w.from),tags:Array.isArray(ne.tags)?(0,a.coalesce)(ne.tags.map(n.from)):void 0}}Pe.from=Oe;function ye(ne){const Fe=new s.Diagnostic(l.to(ne),ne.message,v.to(ne.severity));return Fe.source=ne.source,Fe.code=(0,D.isString)(ne.code)?ne.code:ne.code?.value,Fe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(w.to),Fe.tags=ne.tags&&(0,a.coalesce)(ne.tags.map(n.to)),Fe}Pe.to=ye})(h=e.Diagnostic||(e.Diagnostic={}));var w;(function(Pe){function Oe(ne){return{...l.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Pe.from=Oe;function ye(ne){return new s.DiagnosticRelatedInformation(new s.Location(ne.resource,l.to(ne)),ne.message)}Pe.to=ye})(w=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var v;(function(Pe){function Oe(ne){switch(ne){case s.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Pe.from=Oe;function ye(ne){switch(ne){case o.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Pe.to=ye})(v=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var O;(function(Pe){function Oe(ne){return typeof ne=="number"&&ne>=s.ViewColumn.One?ne-1:ne===s.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Pe.from=Oe;function ye(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=ye})(O=e.ViewColumn||(e.ViewColumn={}));function j(Pe){return typeof Pe.range<"u"}function V(Pe){return Pe.length===0?!0:!!j(Pe[0])}e.isDecorationOptionsArr=V;var Q;(function(Pe){function Oe(xe){return xe.map(Pe.from)}Pe.fromMany=Oe;function ye(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function ne(xe){let et;if(ye(xe)){const{language:bt,value:St}=xe;et={value:"```"+bt+`
`+St+"\n```\n"}}else s.MarkdownString.isMarkdownString(xe)?et={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml,baseUri:xe.baseUri}:typeof xe=="string"?et={value:xe}:et={value:""};const ut=Object.create(null);et.uris=ut;const ft=bt=>{try{let St=k.URI.parse(bt,!0);St=St.with({query:Fe(St.query,ut)}),ut[bt]=St}catch{}return""},kt=new S.marked.Renderer;return kt.link=ft,kt.image=bt=>typeof bt=="string"?ft(E.parseHrefAndDimensions(bt).href):"",(0,S.marked)(et.value,{renderer:kt}),et}Pe.from=ne;function Fe(xe,et){if(!xe)return xe;let ut;try{ut=(0,I.parse)(xe)}catch{}if(!ut)return xe;let ft=!1;return ut=(0,A.cloneAndChange)(ut,kt=>{if(k.URI.isUri(kt)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[bt]=kt,ft=!0,bt}else return}),ft?JSON.stringify(ut):xe}function We(xe){const et=new s.MarkdownString(xe.value,xe.supportThemeIcons);return et.isTrusted=xe.isTrusted,et.supportHtml=xe.supportHtml,et.baseUri=xe.baseUri?k.URI.from(xe.baseUri):void 0,et}Pe.to=We;function Ze(xe){if(!!xe)return typeof xe=="string"?xe:Pe.from(xe)}Pe.fromStrict=Ze})(Q=e.MarkdownString||(e.MarkdownString={}));function G(Pe){return V(Pe)?Pe.map(Oe=>({range:l.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?Q.fromMany(Oe.hoverMessage):Oe.hoverMessage?Q.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Pe.map(Oe=>({range:l.from(Oe)}))}e.fromRangeOrRangeWithMessage=G;function U(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?k.URI.file(Pe):Pe}e.pathOrURIToURI=U;var P;(function(Pe){function Oe(ye){return typeof ye>"u"?ye:{contentText:ye.contentText,contentIconPath:ye.contentIconPath?U(ye.contentIconPath):void 0,border:ye.border,borderColor:ye.borderColor,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,color:ye.color,backgroundColor:ye.backgroundColor,margin:ye.margin,width:ye.width,height:ye.height}}Pe.from=Oe})(P=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var M;(function(Pe){function Oe(ye){return typeof ye>"u"?ye:{backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?U(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?P.from(ye.before):void 0,after:ye.after?P.from(ye.after):void 0}}Pe.from=Oe})(M=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var B;(function(Pe){function Oe(ye){if(typeof ye>"u")return ye;switch(ye){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Oe})(B=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var Z;(function(Pe){function Oe(ye){return{isWholeLine:ye.isWholeLine,rangeBehavior:ye.rangeBehavior?B.from(ye.rangeBehavior):void 0,overviewRulerLane:ye.overviewRulerLane,light:ye.light?M.from(ye.light):void 0,dark:ye.dark?M.from(ye.dark):void 0,backgroundColor:ye.backgroundColor,outline:ye.outline,outlineColor:ye.outlineColor,outlineStyle:ye.outlineStyle,outlineWidth:ye.outlineWidth,border:ye.border,borderColor:ye.borderColor,borderRadius:ye.borderRadius,borderSpacing:ye.borderSpacing,borderStyle:ye.borderStyle,borderWidth:ye.borderWidth,fontStyle:ye.fontStyle,fontWeight:ye.fontWeight,textDecoration:ye.textDecoration,cursor:ye.cursor,color:ye.color,opacity:ye.opacity,letterSpacing:ye.letterSpacing,gutterIconPath:ye.gutterIconPath?U(ye.gutterIconPath):void 0,gutterIconSize:ye.gutterIconSize,overviewRulerColor:ye.overviewRulerColor,before:ye.before?P.from(ye.before):void 0,after:ye.after?P.from(ye.after):void 0}}Pe.from=Oe})(Z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Y;(function(Pe){function Oe(ne){return{text:ne.newText,eol:ne.newEol&&rt.from(ne.newEol),range:l.from(ne.range)}}Pe.from=Oe;function ye(ne){const Fe=new s.TextEdit(l.to(ne.range),ne.text);return Fe.newEol=typeof ne.eol>"u"?void 0:rt.to(ne.eol),Fe}Pe.to=ye})(Y=e.TextEdit||(e.TextEdit={}));var H;(function(Pe){function Oe(ne,Fe){const We={edits:[]};if(ne instanceof s.WorkspaceEdit){const Ze=new T.ResourceSet;for(const xe of ne._allEntries())xe._type===1&&k.URI.isUri(xe.to)&&xe.from===void 0&&Ze.add(xe.to);for(const xe of ne._allEntries())xe._type===1?We.edits.push({oldResource:xe.from,newResource:xe.to,options:{...xe.options,contentsBase64:xe.options?.contents&&(0,R.encodeBase64)(R.VSBuffer.wrap(xe.options.contents))},metadata:xe.metadata}):xe._type===2?We.edits.push({resource:xe.uri,textEdit:Y.from(xe.edit),versionId:Ze.has(xe.uri)?void 0:Fe?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===6?We.edits.push({resource:xe.uri,textEdit:{range:l.from(xe.range),text:xe.edit.value,insertAsSnippet:!0},versionId:Ze.has(xe.uri)?void 0:Fe?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===3?We.edits.push({metadata:xe.metadata,resource:xe.uri,cellEdit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(xe.uri)}):xe._type===5&&We.edits.push({metadata:xe.metadata,resource:xe.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(xe.uri),cellEdit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(at.from)}})}return We}Pe.from=Oe;function ye(ne){const Fe=new s.WorkspaceEdit;for(const We of ne.edits)We.textEdit?Fe.replace(k.URI.revive(We.resource),l.to(We.textEdit.range),We.textEdit.text):Fe.renameFile(k.URI.revive(We.oldResource),k.URI.revive(We.newResource),We.options);return Fe}Pe.to=ye})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var _;(function(Pe){const Oe=Object.create(null);Oe[s.SymbolKind.File]=0,Oe[s.SymbolKind.Module]=1,Oe[s.SymbolKind.Namespace]=2,Oe[s.SymbolKind.Package]=3,Oe[s.SymbolKind.Class]=4,Oe[s.SymbolKind.Method]=5,Oe[s.SymbolKind.Property]=6,Oe[s.SymbolKind.Field]=7,Oe[s.SymbolKind.Constructor]=8,Oe[s.SymbolKind.Enum]=9,Oe[s.SymbolKind.Interface]=10,Oe[s.SymbolKind.Function]=11,Oe[s.SymbolKind.Variable]=12,Oe[s.SymbolKind.Constant]=13,Oe[s.SymbolKind.String]=14,Oe[s.SymbolKind.Number]=15,Oe[s.SymbolKind.Boolean]=16,Oe[s.SymbolKind.Array]=17,Oe[s.SymbolKind.Object]=18,Oe[s.SymbolKind.Key]=19,Oe[s.SymbolKind.Null]=20,Oe[s.SymbolKind.EnumMember]=21,Oe[s.SymbolKind.Struct]=22,Oe[s.SymbolKind.Event]=23,Oe[s.SymbolKind.Operator]=24,Oe[s.SymbolKind.TypeParameter]=25;function ye(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Pe.from=ye;function ne(Fe){for(const We in Oe)if(Oe[We]===Fe)return Number(We);return s.SymbolKind.Property}Pe.to=ne})(_=e.SymbolKind||(e.SymbolKind={}));var ee;(function(Pe){function Oe(ne){switch(ne){case s.SymbolTag.Deprecated:return 1}}Pe.from=Oe;function ye(ne){switch(ne){case 1:return s.SymbolTag.Deprecated}}Pe.to=ye})(ee=e.SymbolTag||(e.SymbolTag={}));var be;(function(Pe){function Oe(ne){return{name:ne.name,kind:_.from(ne.kind),tags:ne.tags&&ne.tags.map(ee.from),containerName:ne.containerName,location:pe.from(ne.location)}}Pe.from=Oe;function ye(ne){const Fe=new s.SymbolInformation(ne.name,_.to(ne.kind),ne.containerName,pe.to(ne.location));return Fe.tags=ne.tags&&ne.tags.map(ee.to),Fe}Pe.to=ye})(be=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ce;(function(Pe){function Oe(ne){const Fe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:l.from(ne.range),selectionRange:l.from(ne.selectionRange),kind:_.from(ne.kind),tags:ne.tags?.map(ee.from)??[]};return ne.children&&(Fe.children=ne.children.map(Oe)),Fe}Pe.from=Oe;function ye(ne){const Fe=new s.DocumentSymbol(ne.name,ne.detail,_.to(ne.kind),l.to(ne.range),l.to(ne.selectionRange));return(0,a.isNonEmptyArray)(ne.tags)&&(Fe.tags=ne.tags.map(ee.to)),ne.children&&(Fe.children=ne.children.map(ye)),Fe}Pe.to=ye})(ce=e.DocumentSymbol||(e.DocumentSymbol={}));var oe;(function(Pe){function Oe(ne){const Fe=new s.CallHierarchyItem(_.to(ne.kind),ne.name,ne.detail||"",k.URI.revive(ne.uri),l.to(ne.range),l.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Pe.to=Oe;function ye(ne,Fe,We){if(Fe=Fe??ne._sessionId,We=We??ne._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,name:ne.name,detail:ne.detail,kind:_.from(ne.kind),uri:ne.uri,range:l.from(ne.range),selectionRange:l.from(ne.selectionRange),tags:ne.tags?.map(ee.from)}}Pe.from=ye})(oe=e.CallHierarchyItem||(e.CallHierarchyItem={}));var x;(function(Pe){function Oe(ye){return new s.CallHierarchyIncomingCall(oe.to(ye.from),ye.fromRanges.map(ne=>l.to(ne)))}Pe.to=Oe})(x=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var he;(function(Pe){function Oe(ye){return new s.CallHierarchyOutgoingCall(oe.to(ye.to),ye.fromRanges.map(ne=>l.to(ne)))}Pe.to=Oe})(he=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(Pe){function Oe(ne){return{range:ne.range&&l.from(ne.range),uri:ne.uri}}Pe.from=Oe;function ye(ne){return new s.Location(k.URI.revive(ne.uri),l.to(ne.range))}Pe.to=ye})(pe=e.location||(e.location={}));var Se;(function(Pe){function Oe(ne){const Fe=ne,We=ne;return{originSelectionRange:Fe.originSelectionRange?l.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:We.uri,range:l.from(Fe.targetRange?Fe.targetRange:We.range),targetSelectionRange:Fe.targetSelectionRange?l.from(Fe.targetSelectionRange):void 0}}Pe.from=Oe;function ye(ne){return{targetUri:k.URI.revive(ne.uri),targetRange:l.to(ne.range),targetSelectionRange:ne.targetSelectionRange?l.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?l.to(ne.originSelectionRange):void 0}}Pe.to=ye})(Se=e.DefinitionLink||(e.DefinitionLink={}));var Re;(function(Pe){function Oe(ne){return{range:l.from(ne.range),contents:Q.fromMany(ne.contents)}}Pe.from=Oe;function ye(ne){return new s.Hover(ne.contents.map(Q.to),l.to(ne.range))}Pe.to=ye})(Re=e.Hover||(e.Hover={}));var re;(function(Pe){function Oe(ne){return{range:l.from(ne.range),expression:ne.expression}}Pe.from=Oe;function ye(ne){return new s.EvaluatableExpression(l.to(ne.range),ne.expression)}Pe.to=ye})(re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(Pe){function Oe(ne){if(ne instanceof s.InlineValueText)return{type:"text",range:l.from(ne.range),text:ne.text};if(ne instanceof s.InlineValueVariableLookup)return{type:"variable",range:l.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Oe;function ye(ne){switch(ne.type){case"text":return{range:l.to(ne.range),text:ne.text};case"variable":return{range:l.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:l.to(ne.range),expression:ne.expression}}}Pe.to=ye})(le=e.InlineValue||(e.InlineValue={}));var de;(function(Pe){function Oe(ne){return{frameId:ne.frameId,stoppedLocation:l.from(ne.stoppedLocation)}}Pe.from=Oe;function ye(ne){return new s.InlineValueContext(ne.frameId,l.to(ne.stoppedLocation))}Pe.to=ye})(de=e.InlineValueContext||(e.InlineValueContext={}));var te;(function(Pe){function Oe(ne){return{range:l.from(ne.range),kind:ne.kind}}Pe.from=Oe;function ye(ne){return new s.DocumentHighlight(l.to(ne.range),ne.kind)}Pe.to=ye})(te=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(Pe){function Oe(ye){switch(ye){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Pe.to=Oe})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var se;(function(Pe){function Oe(ye){return{triggerKind:ae.to(ye.triggerKind),triggerCharacter:ye.triggerCharacter}}Pe.to=Oe})(se=e.CompletionContext||(e.CompletionContext={}));var F;(function(Pe){function Oe(ne){switch(ne){case s.CompletionItemTag.Deprecated:return 1}}Pe.from=Oe;function ye(ne){switch(ne){case 1:return s.CompletionItemTag.Deprecated}}Pe.to=ye})(F=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(Pe){const Oe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ye(We){return Oe.get(We)??9}Pe.from=ye;const ne=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(We){return ne.get(We)??s.CompletionItemKind.Property}Pe.to=Fe})($=e.CompletionItemKind||(e.CompletionItemKind={}));var q;(function(Pe){function Oe(ye,ne){const Fe=new s.CompletionItem(ye.label);return Fe.insertText=ye.insertText,Fe.kind=$.to(ye.kind),Fe.tags=ye.tags?.map(F.to),Fe.detail=ye.detail,Fe.documentation=E.isMarkdownString(ye.documentation)?Q.to(ye.documentation):ye.documentation,Fe.sortText=ye.sortText,Fe.filterText=ye.filterText,Fe.preselect=ye.preselect,Fe.commitCharacters=ye.commitCharacters,C.Range.isIRange(ye.range)?Fe.range=l.to(ye.range):typeof ye.range=="object"&&(Fe.range={inserting:l.to(ye.range.insert),replacing:l.to(ye.range.replace)}),Fe.keepWhitespace=typeof ye.insertTextRules>"u"?!1:Boolean(ye.insertTextRules&1),typeof ye.insertTextRules<"u"&&ye.insertTextRules&4?Fe.insertText=new s.SnippetString(ye.insertText):(Fe.insertText=ye.insertText,Fe.textEdit=Fe.range instanceof s.Range?new s.TextEdit(Fe.range,Fe.insertText):void 0),ye.additionalTextEdits&&ye.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ye.additionalTextEdits.map(We=>Y.to(We))),Fe.command=ne&&ye.command?ne.fromInternal(ye.command):void 0,Fe}Pe.to=Oe})(q=e.CompletionItem||(e.CompletionItem={}));var J;(function(Pe){function Oe(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:Q.fromStrict(ne.documentation)}}Pe.from=Oe;function ye(ne){return{label:ne.label,documentation:E.isMarkdownString(ne.documentation)?Q.to(ne.documentation):ne.documentation}}Pe.to=ye})(J=e.ParameterInformation||(e.ParameterInformation={}));var ue;(function(Pe){function Oe(ne){return{label:ne.label,documentation:Q.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(J.from):[],activeParameter:ne.activeParameter}}Pe.from=Oe;function ye(ne){return{label:ne.label,documentation:E.isMarkdownString(ne.documentation)?Q.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(J.to):[],activeParameter:ne.activeParameter}}Pe.to=ye})(ue=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(Pe){function Oe(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(ue.from):[]}}Pe.from=Oe;function ye(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(ue.to):[]}}Pe.to=ye})(we=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Pe){function Oe(ye,ne){const Fe=new s.InlayHint(b.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(ve.to.bind(void 0,ye)),ne.kind&&Ie.to(ne.kind));return Fe.textEdits=ne.textEdits&&ne.textEdits.map(Y.to),Fe.tooltip=E.isMarkdownString(ne.tooltip)?Q.to(ne.tooltip):ne.tooltip,Fe.paddingLeft=ne.paddingLeft,Fe.paddingRight=ne.paddingRight,Fe}Pe.to=Oe})(Ae=e.InlayHint||(e.InlayHint={}));var ve;(function(Pe){function Oe(ye,ne){const Fe=new s.InlayHintLabelPart(ne.label);return Fe.tooltip=E.isMarkdownString(ne.tooltip)?Q.to(ne.tooltip):ne.tooltip,m.Command.is(ne.command)&&(Fe.command=ye.fromInternal(ne.command)),ne.location&&(Fe.location=pe.to(ne.location)),Fe}Pe.to=Oe})(ve=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ie;(function(Pe){function Oe(ne){return ne}Pe.from=Oe;function ye(ne){return ne}Pe.to=ye})(Ie=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Pe){function Oe(ne){return{range:l.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Pe.from=Oe;function ye(ne){let Fe;if(ne.url)try{Fe=typeof ne.url=="string"?k.URI.parse(ne.url,!0):k.URI.revive(ne.url)}catch{}return new s.DocumentLink(l.to(ne.range),Fe)}Pe.to=ye})(ke=e.DocumentLink||(e.DocumentLink={}));var He;(function(Pe){function Oe(ne){const Fe=new s.ColorPresentation(ne.label);return ne.textEdit&&(Fe.textEdit=Y.to(ne.textEdit)),ne.additionalTextEdits&&(Fe.additionalTextEdits=ne.additionalTextEdits.map(We=>Y.to(We))),Fe}Pe.to=Oe;function ye(ne){return{label:ne.label,textEdit:ne.textEdit?Y.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Fe=>Y.from(Fe)):void 0}}Pe.from=ye})(He=e.ColorPresentation||(e.ColorPresentation={}));var qe;(function(Pe){function Oe(ne){return new s.Color(ne[0],ne[1],ne[2],ne[3])}Pe.to=Oe;function ye(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Pe.from=ye})(qe=e.Color||(e.Color={}));var nt;(function(Pe){function Oe(ne){return{range:l.from(ne.range)}}Pe.from=Oe;function ye(ne){return new s.SelectionRange(l.to(ne.range))}Pe.to=ye})(nt=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Pe){function Oe(ye){switch(ye){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Pe.to=Oe})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(Pe){function Oe(ne){switch(ne){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Oe;function ye(ne){switch(ne){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Pe.to=ye})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(Pe){function Oe(ne){if(ne===s.EndOfLine.CRLF)return 1;if(ne===s.EndOfLine.LF)return 0}Pe.from=Oe;function ye(ne){if(ne===1)return s.EndOfLine.CRLF;if(ne===0)return s.EndOfLine.LF}Pe.to=ye})(rt=e.EndOfLine||(e.EndOfLine={}));var Be;(function(Pe){function Oe(ye){if(typeof ye=="object")return ye.viewId;switch(ye){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Oe})(Be=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(Pe){function Oe(ne){const Fe={start:ne.start+1,end:ne.end+1};return ne.kind&&(Fe.kind=z.from(ne.kind)),Fe}Pe.from=Oe;function ye(ne){const Fe={start:ne.start-1,end:ne.end-1};return ne.kind&&(Fe.kind=z.to(ne.kind)),Fe}Pe.to=ye})(it=e.FoldingRange||(e.FoldingRange={}));var z;(function(Pe){function Oe(ne){if(ne)switch(ne){case s.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}Pe.from=Oe;function ye(ne){if(ne)switch(ne.value){case m.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case m.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case m.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}Pe.to=ye})(z=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(Pe){function Oe(ye){if(ye)return{pinned:typeof ye.preview=="boolean"?!ye.preview:void 0,inactive:ye.background,preserveFocus:ye.preserveFocus,selection:typeof ye.selection=="object"?l.from(ye.selection):void 0,override:typeof ye.override=="boolean"?f.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Pe.from=Oe})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var fe;(function(Pe){function Oe(We){return We instanceof s.RelativePattern?We.toJSON():typeof We=="string"?We:ye(We)||ne(We)?new s.RelativePattern(We.baseUri??We.base,We.pattern).toJSON():We}Pe.from=Oe;function ye(We){const Ze=We;return Ze?k.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function ne(We){const Ze=We;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Fe(We){return typeof We=="string"?We:new s.RelativePattern(k.URI.revive(We.baseUri),We.pattern)}Pe.to=Fe})(fe=e.GlobPattern||(e.GlobPattern={}));var Le;(function(Pe){function Oe(ye){if(ye){if(Array.isArray(ye))return ye.map(Oe);if(typeof ye=="string")return ye;{const ne=ye;return{language:ne.language,scheme:ne.scheme,pattern:fe.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Pe.from=Oe})(Le=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(Pe){function Oe(ne){return{start:ne.start,end:ne.end}}Pe.from=Oe;function ye(ne){return new s.NotebookRange(ne.start,ne.end)}Pe.to=ye})(Ne=e.NotebookRange||(e.NotebookRange={}));var je;(function(Pe){function Oe(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Pe.to=Oe;function ye(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Pe.from=ye})(je=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var _e;(function(Pe){function Oe(ye){if(ye===p.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(ye===p.NotebookCellExecutionState.Pending)return;if(ye===p.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ye}`)}Pe.to=Oe})(_e=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Xe;(function(Pe){function Oe(ne){switch(ne){case s.NotebookCellKind.Markup:return p.CellKind.Markup;case s.NotebookCellKind.Code:default:return p.CellKind.Code}}Pe.from=Oe;function ye(ne){switch(ne){case p.CellKind.Markup:return s.NotebookCellKind.Markup;case p.CellKind.Code:default:return s.NotebookCellKind.Code}}Pe.to=ye})(Xe=e.NotebookCellKind||(e.NotebookCellKind={}));var st;(function(Pe){function Oe(ne){const Fe={metadata:ne.metadata??Object.create(null),cells:[]};for(const We of ne.cells)s.NotebookCellData.validate(We),Fe.cells.push(at.from(We));return Fe}Pe.from=Oe;function ye(ne){const Fe=new s.NotebookData(ne.cells.map(at.to));return(0,D.isEmptyObject)(ne.metadata)||(Fe.metadata=ne.metadata),Fe}Pe.to=ye})(st=e.NotebookData||(e.NotebookData={}));var at;(function(Pe){function Oe(ne){return{cellKind:Xe.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:je.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(gt.from):[]}}Pe.from=Oe;function ye(ne){return new s.NotebookCellData(Xe.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(gt.to):void 0,ne.metadata,ne.internalMetadata?je.to(ne.internalMetadata):void 0)}Pe.to=ye})(at=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Pe){function Oe(ne){return{mime:ne.mime,valueBytes:R.VSBuffer.wrap(ne.data)}}Pe.from=Oe;function ye(ne){return new s.NotebookCellOutputItem(ne.valueBytes.buffer,ne.mime)}Pe.to=ye})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var gt;(function(Pe){function Oe(ne){return{outputId:ne.id,items:ne.items.map(mt.from),metadata:ne.metadata}}Pe.from=Oe;function ye(ne){const Fe=ne.items.map(mt.to);return new s.NotebookCellOutput(Fe,ne.outputId,ne.metadata)}Pe.to=ye})(gt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Et;(function(Pe){function Oe(Fe){return ne(Fe)?{include:(0,D.withNullAsUndefined)(fe.from(Fe.include)),exclude:(0,D.withNullAsUndefined)(fe.from(Fe.exclude))}:(0,D.withNullAsUndefined)(fe.from(Fe))}Pe.from=Oe;function ye(Fe){return ne(Fe)?{include:fe.to(Fe.include),exclude:fe.to(Fe.exclude)}:fe.to(Fe)}Pe.to=ye;function ne(Fe){const We=Fe;return We?!(0,D.isUndefinedOrNull)(We.include)&&!(0,D.isUndefinedOrNull)(We.exclude):!1}})(Et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Lt;(function(Pe){function Oe(ye,ne,Fe){const We=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{alignment:ye.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(We,Fe),text:ye.text,tooltip:ye.tooltip,accessibilityInformation:ye.accessibilityInformation,priority:ye.priority}}Pe.from=Oe})(Lt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var lt;(function(Pe){function Oe(ye,ne,Fe){const We=typeof ye.command=="string"?{title:"",command:ye.command}:ye.command;return{command:ne.toInternal(We,Fe),label:ye.label,description:ye.description,detail:ye.detail,documentation:ye.documentation}}Pe.from=Oe})(lt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var wt;(function(Pe){function Oe(ye){return{transientOutputs:ye?.transientOutputs??!1,transientCellMetadata:ye?.transientCellMetadata??{},transientDocumentMetadata:ye?.transientDocumentMetadata??{},cellContentMetadata:ye?.cellContentMetadata??{}}}Pe.from=Oe})(wt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ht;(function(Pe){function Oe(ne){return{uri:ne.uri,provides:ne.provides}}Pe.from=Oe;function ye(ne){return new s.NotebookRendererScript(k.URI.revive(ne.uri),ne.provides)}Pe.to=ye})(Ht=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ft;(function(Pe){function Oe(ne){return{message:Q.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,location:ne.location&&{range:l.from(ne.location.range),uri:ne.location.uri}}}Pe.from=Oe;function ye(ne){const Fe=new s.TestMessage(typeof ne.message=="string"?ne.message:Q.to(ne.message));return Fe.actualOutput=ne.actual,Fe.expectedOutput=ne.expected,Fe.location=ne.location?pe.to(ne.location):void 0,Fe}Pe.to=ye})(Ft=e.TestMessage||(e.TestMessage={}));var It;(function(Pe){Pe.namespace=g.namespaceTestTag,Pe.denamespace=g.denamespaceTestTag})(It=e.TestTag||(e.TestTag={}));var pt;(function(Pe){function Oe(ne){const Fe=(0,d.getPrivateApiFor)(ne).controllerId;return{extId:y.TestId.fromExtHostTestItem(ne,Fe).toString(),label:ne.label,uri:k.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(We=>It.namespace(Fe,We.id)),range:C.Range.lift(l.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&Q.fromStrict(ne.error)||null}}Pe.from=Oe;function ye(ne){return{parent:void 0,error:void 0,id:y.TestId.fromString(ne.extId).localId,label:ne.label,uri:k.URI.revive(ne.uri),tags:(ne.tags||[]).map(Fe=>{const{tagId:We}=It.denamespace(Fe);return new s.TestTag(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Pe.toPlain=ye})(pt=e.TestItem||(e.TestItem={})),function(Pe){function Oe(ne){return{id:ne.id}}Pe.from=Oe;function ye(ne){return new s.TestTag(ne.id)}Pe.to=ye}(It=e.TestTag||(e.TestTag={}));var Tt;(function(Pe){const Oe=(ne,Fe)=>{const We=[];for(const[xe,et]of Fe)y.TestId.compare(et.item.extId,xe)===2&&(Fe.delete(xe),We.push(et));const Ze={...pt.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(xe=>({state:xe.state,duration:xe.duration,messages:xe.messages.filter(et=>et.type===0).map(Ft.to)})),children:We.map(xe=>Oe(xe,Fe))};for(const xe of Ze.children)xe.parent=Ze;return Ze};function ye(ne){const Fe=[],We=new Map;for(const Ze of ne.items){We.set(Ze.item.extId,Ze);const xe=y.TestId.root(Ze.item.extId);ne.request.targets.some(et=>et.controllerId===xe&&et.testIds.includes(Ze.item.extId))&&Fe.push(Ze)}return{completedAt:ne.completedAt,results:Fe.map(Ze=>Oe(Ze,We))}}Pe.to=ye})(Tt=e.TestResults||(e.TestResults={}));var Mt;(function(Pe){function Oe(We){return{covered:We.covered,total:We.covered}}function ye(We){return"line"in We?b.from(We):l.from(We)}function ne(We){return"branches"in We?{count:We.executionCount,location:ye(We.location),type:1,branches:We.branches.length?We.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ye(Ze.location)})):void 0}:{type:0,count:We.executionCount,location:ye(We.location)}}Pe.fromDetailed=ne;function Fe(We){return{uri:We.uri,statement:Oe(We.statementCoverage),branch:We.branchCoverage&&Oe(We.branchCoverage),function:We.functionCoverage&&Oe(We.functionCoverage),details:We.detailedCoverage?.map(ne)}}Pe.fromFile=Fe})(Mt=e.TestCoverage||(e.TestCoverage={}));var Ot;(function(Pe){function Oe(ye){switch(ye){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Pe.to=Oe})(Ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ke;(function(Pe){function Oe(ne){const Fe=new s.TypeHierarchyItem(_.to(ne.kind),ne.name,ne.detail||"",k.URI.revive(ne.uri),l.to(ne.range),l.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Pe.to=Oe;function ye(ne,Fe,We){if(Fe=Fe??ne._sessionId,We=We??ne._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,kind:_.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:l.from(ne.range),selectionRange:l.from(ne.selectionRange),tags:ne.tags?.map(ee.from)}}Pe.from=ye})(Ke=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var xt;(function(Pe){function Oe(ye){if(!!ye)return{value:ye.value,tooltip:ye.tooltip}}Pe.from=Oe})(xt=e.ViewBadge||(e.ViewBadge={}));var Nt;(function(Pe){function Oe(We,Ze,xe){const et=Ze.fileData;return et?new class extends s.DataTransferItem{asFile(){return{name:et.name,uri:k.URI.revive(et.uri),data:(0,L.once)(()=>xe())}}}("",Ze.id):We===N.Mimes.uriList&&Ze.uriListData?new s.DataTransferItem(Fe(Ze.uriListData)):new s.DataTransferItem(Ze.asString)}Pe.to=Oe;async function ye(We,Ze){const xe=await Ze.asString();if(We===N.Mimes.uriList)return{id:Ze.id,asString:xe,fileData:void 0,uriListData:ne(xe)};const et=Ze.asFile();return{id:Ze.id,asString:xe,fileData:et?{name:et.name,uri:et.uri}:void 0}}Pe.from=ye;function ne(We){return c.UriList.split(We).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return k.URI.parse(Ze)}catch{}return Ze})}function Fe(We){return c.UriList.create(We.map(Ze=>typeof Ze=="string"?Ze:k.URI.revive(Ze)))}})(Nt=e.DataTransferItem||(e.DataTransferItem={}));var Bt;(function(Pe){function Oe(ne,Fe){const We=ne.items.map(([Ze,xe])=>[Ze,Nt.to(Ze,xe,()=>Fe(xe.id))]);return new s.DataTransfer(We)}Pe.toDataTransfer=Oe;async function ye(ne){const Fe={items:[]},We=[];return ne.forEach((Ze,xe)=>{We.push((async()=>{Fe.items.push([xe,await Nt.from(xe,Ze)])})())}),await Promise.all(We),Fe}Pe.toDataTransferDTO=ye})(Bt=e.DataTransfer||(e.DataTransfer={}))}),define(De[241],Ce([1,0,2,10,7,14,66]),function(ie,e,a,R,c,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(I,N,A,D={timeout:1500,errors:3}){this.c=I,this.d=N,this.f=A,this.g=D,this.a=new E.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(N,A,D)=>{const C={dispose:this.a.push([N,A,I])};return Array.isArray(D)&&D.push(C),C}}async $participateInSave(I,N){const A=a.URI.revive(I);let D=!1;const k=setTimeout(()=>D=!0,this.g.timeout),C=[];try{for(const m of[...this.a]){if(D)break;const o=this.d.getDocument(A),d=await this.h(m,{document:o,reason:L.TextDocumentSaveReason.to(N)});C.push(d)}}finally{clearTimeout(k)}return C}h([I,N,A],D){const k=this.b.get(I);return typeof k=="number"&&k>this.g.errors?Promise.resolve(!1):this.i(A,I,N,D).then(()=>!0,C=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' threw ERROR`),this.c.error(C),!(C instanceof Error)||C.message!=="concurrent_edits"){const m=this.b.get(I);this.b.set(I,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,N,A,D){const k=[],C=Date.now(),{document:m,reason:o}=D,{version:d}=m,f=Object.freeze({document:m,reason:o,waitUntil(p){if(Object.isFrozen(k))throw(0,R.illegalState)("waitUntil can not be called async");k.push(Promise.resolve(p))}});try{N.apply(A,[f])}catch(p){return Promise.reject(p)}return Object.freeze(k),new Promise((p,y)=>{const g=setTimeout(()=>y(new Error("timeout")),this.g.timeout);return Promise.all(k).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-C}ms`),clearTimeout(g),p(t)}).catch(t=>{clearTimeout(g),y(t)})}).then(p=>{const y={edits:[]};for(const g of p)if(Array.isArray(g)&&g.every(t=>t instanceof c.TextEdit))for(const{newText:t,newEol:s,range:r}of g)y.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:r&&L.Range.from(r),text:t,eol:s&&L.EndOfLine.from(s)}});if(y.edits.length!==0)return d===m.version?this.f.$tryApplyWorkspaceEdit(y):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(De[242],Ce([1,0,16,2,14,7,93]),function(ie,e,a,R,c,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(A,D,k,C){this.start=A,this.deletedCount=D,this.deletedItems=k,this.items=C}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(A=>A.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(A,D){return{EOL:D.eol,lines:D.source,languageId:D.language,uri:D.uri,isDirty:!1,versionId:1,notebook:A}}constructor(A,D,k){this.notebook=A,this.h=D,this.j=k,this.handle=k.handle,this.uri=R.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(c.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(c.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const A=this,D=this.h.getDocument(this.uri);if(!D)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return A.notebook.getCellIndex(A)},notebook:A.notebook.apiNotebook,kind:c.NotebookCellKind.to(this.j.cellKind),document:D.document,get mime(){return A.g},set mime(C){A.g=C},get outputs(){return A.a.slice(0)},get metadata(){return A.b},get executionSummary(){return A.d}};this.f=Object.freeze(k)}return this.f}setOutputs(A){this.a=A.map(c.NotebookCellOutput.to)}setOutputItems(A,D,k){const C=k.map(c.NotebookCellOutputItem.to),m=this.a.find(o=>o.id===A);if(m&&(D||(m.items.length=0),m.items.push(...C),m.items.length>1&&m.items.every(o=>E.isTextStreamMime(o.mime)))){const o=new Map,d=[];m.items.forEach(f=>{let p;o.has(f.mime)?p=o.get(f.mime):(p=[],o.set(f.mime,p),d.push(f.mime)),p.push(f.data)}),m.items.length=0,d.forEach(f=>{const p=E.compressOutputItemStreams(o.get(f));m.items.push({mime:f,data:p.buffer})})}}setMetadata(A){this.b=Object.freeze(A)}setInternalMetadata(A){this.e=A,this.d=Object.freeze(c.NotebookCellExecutionSummary.to(A))}setMime(A){}}e.ExtHostCell=S;class I{constructor(A,D,k,C,m){this.k=A,this.l=D,this.m=k,this.uri=C,this.handle=I.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=m.viewType,this.f=Object.freeze(m.metadata??Object.create(null)),this.r([[0,0,m.cells]],!0,void 0),this.g=m.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const A=this,D={get uri(){return A.uri},get version(){return A.g},get notebookType(){return A.d},get isDirty(){return A.h},get isUntitled(){return A.uri.scheme===a.Schemas.untitled},get isClosed(){return A.j},get metadata(){return A.f},get cellCount(){return A.b.length},cellAt(k){return k=A.n(k),A.b[k].apiCell},getCells(k){return(k?A.p(k):A.b).map(m=>m.apiCell)},save(){return A.q()}};this.e=Object.freeze(D)}return this.e}acceptDocumentPropertiesChanged(A){A.metadata&&(this.f=Object.freeze({...this.f,...A.metadata}))}acceptDirty(A){this.h=A}acceptModelChanged(A,D,k){this.g=A.versionId,this.h=D,this.acceptDocumentPropertiesChanged({metadata:k});const C={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},m=[];for(const d of A.rawEvents)d.kind===E.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,C.contentChanges):d.kind===E.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,C.contentChanges):d.kind===E.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),m.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===E.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),m.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===E.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),m.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===E.NotebookCellsChangeType.ChangeCellContent?m.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===E.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===E.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),m.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===E.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),m.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const o=new Map;for(let d=0;d<m.length;d++){const f=m[d],p=o.get(f.cell);if(p===void 0){const y=C.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...f});o.set(f.cell,y-1)}else C.cellChanges[p]={...C.cellChanges[p],...f}}return Object.freeze(C),Object.freeze(C.cellChanges),Object.freeze(C.contentChanges),C}n(A){return A=A|0,A<0?0:A>=this.b.length?this.b.length-1:A}o(A){let D=A.start|0,k=A.end|0;return D<0&&(D=0),k>this.b.length&&(k=this.b.length),A.with({start:D,end:k})}p(A){A=this.o(A);const D=[];for(let k=A.start;k<A.end;k++)D.push(this.b[k]);return D}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(A,D,k){if(this.j)return;const C=[],m=[],o=[];if(A.reverse().forEach(d=>{const p=d[2].map(t=>{const s=new S(this,this.l,t);return D||m.push(S.asModelAddData(this.apiNotebook,t)),s}),y=new T(d[0],d[1],[],p),g=this.b.splice(d[0],d[1],...p);for(const t of g)o.push(t.uri),y.deletedItems.push(t.apiCell);C.push(y)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:o}),k)for(const d of C)k.push(d.asApiEvent())}s(A,D,k,C){const m=this.b.splice(A,D);this.b.splice(k,0,...m);const o=[new T(A,D,m.map(d=>d.apiCell),[]),new T(k,0,[],m)];for(const d of o)C.push(d.asApiEvent())}t(A,D){this.b[A].setOutputs(D)}u(A,D,k,C){this.b[A].setOutputItems(D,k,C)}v(A,D){const k=this.b[A];k.apiCell.document.languageId!==D&&this.m.$acceptModelLanguageChanged(k.uri,D)}w(A,D){const k=this.b[A];k.apiCell.mime=D}x(A,D){this.b[A].setMetadata(D)}y(A,D){this.b[A].setInternalMetadata(D)}getCellFromApiCell(A){return this.b.find(D=>D.apiCell===A)}getCellFromIndex(A){return this.b[A]}getCell(A){return this.b.find(D=>D.handle===A)}getCellIndex(A){return this.b.indexOf(A)}}I.a=0,e.ExtHostNotebookDocument=I}),define(De[137],Ce([1,0,10,14,7]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(T,S,I,N,A,D){this.id=T,this.f=S,this.notebookData=I,this.a=[],this.b=[],this.d=!1,this.a=A,this.b=N,this.c=D}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(S){this.selections=[S]},get selections(){return T.a},set selections(S){if(!Array.isArray(S)||!S.every(c.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");T.a=S,T.g(S)},get visibleRanges(){return T.b},revealRange(S,I){T.f.$tryRevealRange(T.id,R.NotebookRange.from(S),I??c.NotebookEditorRevealType.Default)},get viewColumn(){return T.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(R.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}L.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=L}),define(De[243],Ce([1,0,3,13,14]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let L=class{constructor(T,S){this.c=T,this.d=S,this.a=new a.Emitter,this.b=new a.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,S);const I=this.d.getEditorById(T);S.visibleRanges&&I._acceptVisibleRanges(S.visibleRanges.ranges.map(c.NotebookRange.to)),S.selections&&I._acceptSelections(S.selections.selections.map(c.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const S in T)this.d.getEditorById(S)._acceptViewColumn(c.ViewColumn.to(T[S]))}};L=Ve([ze(0,R.ILogService)],L),e.ExtHostNotebookEditors=L}),define(De[244],Ce([1,0,14,126,180,21,62,10]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,k,C){const m=this.b++,{title:o,location:d,cancellable:f}=k,p={label:(0,c.localize)(0,null,D.displayName||D.name),id:D.identifier.value};return this.a.$startProgress(m,{location:a.ProgressLocation.from(d),title:o,source:p,cancellable:f},D.isUnderDevelopment?void 0:D.identifier.value).catch(T.onUnexpectedExternalError),this.d(m,C,!!f)}d(D,k,C){let m;C&&(m=new L.CancellationTokenSource,this.c.set(D,m));const o=f=>{this.a.$progressEnd(f),this.c.delete(f),m?.dispose()};let d;try{d=k(new N(this.a,D),C&&m?m.token:L.CancellationToken.None)}catch(f){throw o(D),f}return d.then(f=>o(D),f=>o(D)),d}$acceptProgressCanceled(D){const k=this.c.get(D);k&&(k.cancel(),this.c.delete(D))}}e.ExtHostProgress=S;function I(A,D){return A.message=D.message,typeof D.increment=="number"&&(typeof A.increment=="number"?A.increment+=D.increment:A.increment=D.increment),A}class N extends R.Progress{constructor(D,k){super(C=>this.throttledReport(C)),this.c=D,this.d=k}throttledReport(D){this.c.$progressReport(this.d,D)}}Ve([(0,E.throttle)(100,(A,D)=>I(A,D),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(De[138],Ce([1,0,32,133,57,94,75,14,2]),function(ie,e,a,R,c,L,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(p,y,g,t)=>{let s=y;return{enumerable:!0,configurable:!1,get(){return s},set(r){if(!g(s,r)){const l=s;s=r,p.listener?.(t(r,l))}}}},N=(p,y)=>p===y,A={range:(p,y)=>p===y?!0:!p||!y?!1:p.isEqual(y),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(p,y)=>!(p.length!==y.length||p.some(g=>!y.find(t=>g.id===t.id)))},D=p=>y=>({op:4,update:p(y)}),k=(p,y)=>({range:(()=>{let g;const t=D(s=>({range:a.Range.lift(T.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return g},set(s){p.listener?.({op:6}),A.range(g,s)||(g=s,p.listener?.(t(s)))}}})(),label:I(p,y,A.label,D(g=>({label:g}))),description:I(p,void 0,A.description,D(g=>({description:g}))),sortText:I(p,void 0,A.sortText,D(g=>({sortText:g}))),canResolveChildren:I(p,!1,A.canResolveChildren,g=>({op:2,state:g})),busy:I(p,!1,A.busy,D(g=>({busy:g}))),error:I(p,void 0,A.error,D(g=>({error:T.MarkdownString.fromStrict(g)||null}))),tags:I(p,[],A.tags,(g,t)=>({op:1,new:g.map(T.TestTag.from),old:t.map(T.TestTag.from)}))}),C=p=>{const y=c.TestId.fromString(p.extId),g=new o(y.controllerId,y.localId,p.label,S.URI.revive(p.uri)||void 0);return g.range=T.Range.to(p.range||void 0),g.description=p.description||void 0,g.sortText=p.sortText||void 0,g.tags=p.tags.map(t=>T.TestTag.to({id:(0,E.denamespaceTestTag)(t).tagId})),g},m=p=>{let y;for(const g of p.tests){const t=C(g.item);(0,R.getPrivateApiFor)(t).parent=y,y=t}return y};e.toItemFromContext=m;class o{constructor(y,g,t,s){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const r=(0,R.createPrivateApiFor)(this,y);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof d?void 0:r.parent}},children:{value:(0,L.createTestItemChildren)(r,R.getPrivateApiFor,o),enumerable:!0,writable:!1},...k(r,t)})}}e.TestItemImpl=o;class d extends o{constructor(y,g){super(y,y,g,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class f extends L.TestItemCollection{constructor(y,g,t){super({controllerId:y,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:R.getPrivateApiFor,getChildren:s=>s.children,root:new d(y,g),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=f}),define(De[139],Ce([1,0,51,10,101,14,7]),function(ie,e,a,R,c,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class T{constructor(D,k,C){const m=T.c.nextId();D.$registerTextEditorDecorationType(k.identifier,m,L.DecorationRenderOptions.from(C)),this.value=Object.freeze({key:m,dispose(){D.$removeTextEditorDecorationType(m)}})}}T.c=new c.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=T;class S{constructor(D,k){this.g=[],this.h=void 0,this.j=!1,this.c=D,this.d=D.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(D,k){this.k();let C=null;if(D instanceof E.Position)C=new E.Range(D,D);else if(D instanceof E.Range)C=D;else throw new Error("Unrecognized location");this.l(C,k,!1)}insert(D,k){this.k(),this.l(new E.Range(D,D),k,!0)}delete(D){this.k();let k=null;if(D instanceof E.Range)k=D;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(D,k,C){const m=this.c.validateRange(D);this.g.push({range:m,text:k,forceMoveMarkers:C})}setEndOfLine(D){if(this.k(),D!==E.EndOfLine.LF&&D!==E.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this.h=D}}class I{constructor(D,k,C,m){this.c=D,this.d=k,this._accept(C),this.e=m;const o=this;this.value={get tabSize(){return o.f},set tabSize(d){o.m(d)},get indentSize(){return o.g},set indentSize(d){o.o(d)},get insertSpaces(){return o.h},set insertSpaces(d){o.q(d)},get cursorStyle(){return o.j},set cursorStyle(d){o.s(d)},get lineNumbers(){return o.k},set lineNumbers(d){o.t(d)}}}_accept(D){this.f=D.tabSize,this.g=D.indentSize,this.h=D.insertSpaces,this.j=D.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(D.lineNumbers)}l(D){if(D==="auto")return"auto";if(typeof D=="number"){const k=Math.floor(D);return k>0?k:null}if(typeof D=="string"){const k=parseInt(D,10);return isNaN(k)?null:k>0?k:null}return null}m(D){const k=this.l(D);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}n(D){if(D==="tabSize")return"tabSize";if(typeof D=="number"){const k=Math.floor(D);return k>0?k:null}if(typeof D=="string"){const k=parseInt(D,10);return isNaN(k)?null:k>0?k:null}return null}o(D){const k=this.n(D);if(k!==null){if(typeof k=="number"){if(this.g===k)return;this.g=k}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}p(D){return D==="auto"?"auto":D==="false"?!1:Boolean(D)}q(D){const k=this.p(D);if(typeof k=="boolean"){if(this.h===k)return;this.h=k}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}s(D){this.j!==D&&(this.j=D,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:D})))}t(D){this.k!==D&&(this.k=D,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(D)})))}assign(D){const k={};let C=!1;if(typeof D.tabSize<"u"){const m=this.l(D.tabSize);m==="auto"?(C=!0,k.tabSize=m):typeof m=="number"&&this.f!==m&&(this.f=m,C=!0,k.tabSize=m)}if(typeof D.indentSize<"u"){const m=this.n(D.indentSize);m==="tabSize"?(C=!0,k.indentSize=m):typeof m=="number"&&this.g!==m&&(this.g=m,C=!0,k.indentSize=m)}if(typeof D.insertSpaces<"u"){const m=this.p(D.insertSpaces);m==="auto"?(C=!0,k.insertSpaces=m):this.h!==m&&(this.h=m,C=!0,k.insertSpaces=m)}typeof D.cursorStyle<"u"&&this.j!==D.cursorStyle&&(this.j=D.cursorStyle,C=!0,k.cursorStyle=D.cursorStyle),typeof D.lineNumbers<"u"&&this.k!==D.lineNumbers&&(this.k=D.lineNumbers,C=!0,k.lineNumbers=L.TextEditorLineNumbersStyle.from(D.lineNumbers)),C&&this.u("setOptions",this.c.$trySetOptions(this.d,k))}u(D,k){k.catch(C=>{this.e.warn(`ExtHostTextEditorOptions '${D}' failed:'`),this.e.warn(C)})}}e.ExtHostTextEditorOptions=I;class N{constructor(D,k,C,m,o,d,f,p){this.id=D,this.j=k,this.k=C,this.g=!1,this.h=new Set,this.c=o,this.d=new I(this.j,this.id,d,C),this.e=f,this.f=p;const y=this;this.value=Object.freeze({get document(){return m.value},set document(g){throw(0,R.readonly)("document")},get selection(){return y.c&&y.c[0]},set selection(g){if(!(g instanceof E.Selection))throw(0,R.illegalArgument)("selection");y.c=[g],y.l()},get selections(){return y.c},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof E.Selection)))throw(0,R.illegalArgument)("selections");y.c=g,y.l()},get visibleRanges(){return y.e},set visibleRanges(g){throw(0,R.readonly)("visibleRanges")},get options(){return y.d.value},set options(g){y.g||y.d.assign(g)},get viewColumn(){return y.f},set viewColumn(g){throw(0,R.readonly)("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new S(m.value,t);return g(s),y.m(s)},insertSnippet(g,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=y.c.map(l=>L.Range.from(l));else if(t instanceof E.Position){const{lineNumber:l,column:u}=L.Position.from(t);r=[{startLineNumber:l,startColumn:u,endLineNumber:l,endColumn:u}]}else if(t instanceof E.Range)r=[L.Range.from(t)];else{r=[];for(const l of t)if(l instanceof E.Range)r.push(L.Range.from(l));else{const{lineNumber:u,column:b}=L.Position.from(l);r.push({startLineNumber:u,startColumn:b,endLineNumber:u,endColumn:b})}}return k.$tryInsertSnippet(D,m.value.version,g.value,r,s)},setDecorations(g,t){const s=t.length===0;s&&!y.h.has(g.key)||(s?y.h.delete(g.key):y.h.add(g.key),y.n(()=>{if(L.isDecorationOptionsArr(t))return k.$trySetDecorations(D,g.key,L.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let l=0,u=t.length;l<u;l++){const b=t[l];r[4*l]=b.start.line+1,r[4*l+1]=b.start.character+1,r[4*l+2]=b.end.line+1,r[4*l+3]=b.end.character+1}return k.$trySetDecorationsFast(D,g.key,r)}}))},revealRange(g,t){y.n(()=>k.$tryRevealRange(D,L.Range.from(g),t||E.TextEditorRevealType.Default))},show(g){k.$tryShowEditor(D,L.ViewColumn.from(g))},hide(){k.$tryHideEditor(D)}})}dispose(){(0,a.ok)(!this.g),this.g=!0}_acceptOptions(D){(0,a.ok)(!this.g),this.d._accept(D)}_acceptVisibleRanges(D){(0,a.ok)(!this.g),this.e=D}_acceptViewColumn(D){(0,a.ok)(!this.g),this.f=D}_acceptSelections(D){(0,a.ok)(!this.g),this.c=D}async l(){const D=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,D)),this.value}m(D){const k=D.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const C=k.edits.map(o=>o.range);C.sort((o,d)=>o.end.line===d.end.line?o.end.character===d.end.character?o.start.line===d.start.line?o.start.character-d.start.character:o.start.line-d.start.line:o.end.character-d.end.character:o.end.line-d.end.line);for(let o=0,d=C.length-1;o<d;o++){const f=C[o].end;if(C[o+1].start.isBefore(f))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=k.edits.map(o=>({range:L.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,m,{setEndOfLine:typeof k.setEndOfLine=="number"?L.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(D){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):D().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.ExtHostTextEditor=N}),define(De[245],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[246],Ce([1,0,196,10,37,123,92,39,25,245,209,129]),function(ie,e,a,R,c,L,E,T,S,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const D=T.Registry.as(E.Extensions.JSONContribution);class k{constructor(g,t,s){this.a=g,this.b=t,this.c=s}d(g,t){this.a({type:g,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(g){this.d(c.default.Error,g)}warn(g){this.d(c.default.Warning,g)}info(g){this.d(c.default.Info,g)}}e.ExtensionMessageCollector=k;class C{static a(g){const t=new S.ExtensionIdentifierSet;for(let s=0,r=g.length;s<r;s++)t.add(g[s].description.identifier);return t}static compute(g,t){if(!g||!g.length)return new C(t,[]);if(!t||!t.length)return new C([],g);const s=this.a(g),r=this.a(t),l=t.filter(b=>!s.has(b.description.identifier)),u=g.filter(b=>!r.has(b.description.identifier));return new C(l,u)}constructor(g,t){this.added=g,this.removed=t}}e.ExtensionPointUserDelta=C;class m{constructor(g,t){this.name=g,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(g){if(this.a!==null)throw new Error("Handler already set!");this.a=g,this.d()}acceptUsers(g){this.c=C.compute(this.b,g),this.b=g,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(g){(0,R.onUnexpectedError)(g)}}}e.ExtensionPoint=m;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},api:{markdownDescription:a.localize(15,null),type:"string",enum:["none"],enumDescriptions:[a.localize(16,null)]},activationEvents:{description:a.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(32,null)},{label:"onUri",body:"onUri",description:a.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(37,null)},{label:"onRenderer",description:a.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(41,null)},{label:"*",description:a.localize(42,null),body:"*"}]}},badges:{type:"array",description:a.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(44,null)},href:{type:"string",description:a.localize(45,null)},description:{type:"string",description:a.localize(46,null)}}}},markdown:{type:"string",description:a.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(51,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(52,null)},{body:["workspace"],description:a.localize(53,null)},{body:["ui","workspace"],description:a.localize(54,null)},{body:["workspace","ui"],description:a.localize(55,null)},{body:[],description:a.localize(56,null)}]},capabilities:{description:a.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(60,null),a.localize(61,null),a.localize(62,null)]},description:{type:"string",markdownDescription:a.localize(63,null)}}},untrustedWorkspaces:{description:a.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null)]},restrictedConfigurations:{description:a.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(70,null)}}}}},sponsor:{description:a.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(73,null),type:"string"},"vscode:uninstall":{description:a.localize(74,null),type:"string"}}},icon:{type:"string",description:a.localize(75,null)},l10n:{type:"string",description:a.localize(76,null)}}};class f{constructor(){this.a=new Map}registerExtensionPoint(g){if(this.a.has(g.extensionPoint))throw new Error("Duplicate extension point: "+g.extensionPoint);const t=new m(g.extensionPoint,g.defaultExtensionKind);return this.a.set(g.extensionPoint,t),g.activationEventsGenerator&&A.ImplicitActivationEvents.register(g.extensionPoint,g.activationEventsGenerator),e.schema.properties.contributes.properties[g.extensionPoint]=g.jsonSchema,D.registerSchema(d,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=f;const p={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(p.ExtensionsRegistry,new f),e.ExtensionsRegistry=T.Registry.as(p.ExtensionsRegistry),D.registerSchema(d,e.schema),D.registerSchema(N.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(De[247],Ce([1,0,193,9,23,246,46,3]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var I;(function(D){function k(C,m,o){if(!C)return;const d=R.isString(C.type)?C.type:void 0;if(!d||d.length===0){o.error(a.localize(3,null));return}const f=[];if(Array.isArray(C.required))for(const p of C.required)R.isString(p)&&f.push(p);return{extensionId:m.value,taskType:d,required:f,properties:C.properties?c.deepClone(C.properties):{},when:C.when?E.ContextKeyExpr.deserialize(C.when):void 0}}D.from=k})(I||(I={}));const N=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(D,k)=>{for(const C of D)C.type&&k.push(`onTaskType:${C.type}`)},jsonSchema:{description:a.localize(4,null),type:"array",items:S}});class A{constructor(){this.d=new T.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,C)=>{N.setHandler((m,o)=>{this.c=void 0;try{for(const d of o.removed){const f=d.value;for(const p of f)this.a&&p.type&&this.a[p.type]&&delete this.a[p.type]}for(const d of o.added){const f=d.value;for(const p of f){const y=I.from(p,d.description.identifier,d.collector);y&&(this.a[y.taskType]=y)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const C of this.all()){const m={type:"object",additionalProperties:!1};C.required.length>0&&(m.required=C.required.slice(0)),C.properties!==void 0?m.properties=c.deepClone(C.properties):m.properties=Object.create(null),m.properties.type={type:"string",enum:[C.taskType]},k.push(m)}this.c={oneOf:k}}return this.c}}e.TaskDefinitionRegistry=new A}),define(De[248],Ce([1,0,194,9,24,23,46,247]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new E.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var S;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function P(M){if(!M)return U.Strong;switch(M.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=P}(S=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var N;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(N=e.RevealKind||(e.RevealKind={})),function(U){function P(M){switch(M.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=P}(N=e.RevealKind||(e.RevealKind={}));var A;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(A=e.RevealProblemKind||(e.RevealProblemKind={})),function(U){function P(M){switch(M.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=P}(A=e.RevealProblemKind||(e.RevealProblemKind={}));var D;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(D=e.PanelKind||(e.PanelKind={})),function(U){function P(M){switch(M.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=P}(D=e.PanelKind||(e.PanelKind={}));var k;(function(U){U.defaults={echo:!0,reveal:N.Always,revealProblems:A.Never,focus:!1,panel:D.Shared,showReuseMessage:!0,clear:!1}})(k=e.PresentationOptions||(e.PresentationOptions={}));var C;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(C=e.RuntimeType||(e.RuntimeType={})),function(U){function P(B){switch(B.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=P;function M(B){switch(B){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=M}(C=e.RuntimeType||(e.RuntimeType={}));var m;(function(U){function P(M){return R.isString(M)?M:M.value}U.value=P})(m=e.CommandString||(e.CommandString={}));var o;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function P(B){return B===U.Clean._id||B===U.Build._id||B===U.Rebuild._id||B===U.Test._id}U.is=P;function M(B){if(B!==void 0)return R.isString(B)?P(B)?{_id:B,isDefault:!1}:void 0:B}U.from=M})(o=e.TaskGroup||(e.TaskGroup={}));var d;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(d=e.TaskScope||(e.TaskScope={}));var f;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function P(M){switch(M){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=P})(f=e.TaskSourceKind||(e.TaskSourceKind={}));var p;(function(U){U.parallel="parallel",U.sequence="sequence"})(p=e.DependsOrder||(e.DependsOrder={}));var y;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(y=e.RunOnOptions||(e.RunOnOptions={}));var g;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:y.default,instanceLimit:1}})(g=e.RunOptions||(e.RunOptions={}));class t{constructor(P,M,B,Z,Y,H){this._label="",this._id=P,M&&(this._label=M),B&&(this.type=B),this.runOptions=Z,this.configurationProperties=Y,this._source=H}getDefinition(P){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const P={folder:this.d(),id:this._id};return JSON.stringify(P)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(P,M=!1){if(P===void 0)return!1;if(R.isString(P))return P===this._label||P===this.configurationProperties.identifier||M&&P===this._id;const B=this.getDefinition(!0);return B!==void 0&&B._key===P._key}getQualifiedLabel(){const P=this.getWorkspaceFolder();return P?`${this._label} (${P.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(P){this.c===void 0&&(this.c=[]),P&&(this.c=this.c.concat(P))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class s extends t{constructor(P,M,B,Z,Y,H,_,ee){super(P,B,void 0,_,ee,M),this.command={},this._source=M,this.hasDefinedMatchers=H,Y&&(this.command=Y)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(P=!1){if(P&&this._source.customizes!==void 0)return this._source.customizes;{let M;switch(this.command?this.command.runtime:void 0){case C.Shell:M="shell";break;case C.Process:M="process";break;case C.CustomExecution:M="customExecution";break;case void 0:M="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:M,_key:this._id,id:this._id}}}static is(P){return P instanceof s}getMapKey(){const P=this._source.config.workspaceFolder;return P?`${P.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===f.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const P=this.d();if(!P)return;let M=this.configurationProperties.identifier;this._source.kind!==f.Workspace&&(M+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:P,id:M};return JSON.stringify(B)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?c.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(P){return new s(P._id,P._source,P._label,P.type,P.command,P.hasDefinedMatchers,P.runOptions,P.configurationProperties)}}e.CustomTask=s;class r extends t{constructor(P,M,B,Z,Y,H,_){super(P,B,Z,H,_,M),this._source=M,this.configures=Y}static is(P){return P instanceof r}f(P){return P}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?c.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===f.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const P=this.d();if(!P)return;let M=this.configurationProperties.identifier;this._source.kind!==f.Workspace&&(M+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:P,id:M};return JSON.stringify(B)}}e.ConfiguringTask=r;class l extends t{constructor(P,M,B,Z,Y,H,_,ee,be){super(P,B,Z,ee,be,M),this.defines=Y,this.hasDefinedMatchers=_,this.command=H,this.icon=be.icon,this.hide=be.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(P){return P instanceof l}getMapKey(){const P=this._source.workspaceFolder;return P?`${this._source.scope.toString()}|${P.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const P={type:"contributed",scope:this._source.scope,id:this._id};return P.folder=this.d(),JSON.stringify(P)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(P){return new l(P._id,P._source,P._label,P.type,P.defines,P.command,P.hasDefinedMatchers,P.runOptions,P.configurationProperties)}}e.ContributedTask=l;class u extends t{constructor(P,M,B,Z,Y,H){super(P,B,Z,Y,H,M),this._source=M}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(P){return P instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(P){return new u(P._id,P._source,P._label,P.type,P.runOptions,P.configurationProperties)}}e.InMemoryTask=u;var b;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(b=e.ExecutionEngine||(e.ExecutionEngine={})),function(U){U._default=U.Terminal}(b=e.ExecutionEngine||(e.ExecutionEngine={}));var i;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(i=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class n{constructor(P){this.c=new Map;for(let M=0;M<P.length;M++)this.c.set(P[M].uri.toString(),M)}compare(P,M){const B=P.getWorkspaceFolder(),Z=M.getWorkspaceFolder();if(B&&Z){let Y=this.c.get(B.uri.toString());Y=Y===void 0?0:Y+1;let H=this.c.get(Z.uri.toString());return H=H===void 0?0:H+1,Y===H?P._label.localeCompare(M._label):Y-H}else return!B&&Z?-1:B&&!Z?1:0}}e.TaskSorter=n;var h;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var w;(function(U){U.SingleRun="singleRun",U.Background="background"})(w=e.TaskRunType||(e.TaskRunType={}));var v;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(v=e.TaskRunSource||(e.TaskRunSource={}));var O;(function(U){function P(M,B,Z,Y){if(B){const H={kind:M,taskId:B._id,taskName:B.configurationProperties.name,runType:B.configurationProperties.isBackground?"background":"singleRun",group:B.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:Z,__task:B};return M==="start"?H.resolvedVariables=Y:M==="processStarted"?H.processId=Y:M==="processEnded"&&(H.exitCode=Y),Object.freeze(H)}else return Object.freeze({kind:"changed"})}U.create=P})(O=e.TaskEvent||(e.TaskEvent={}));var j;(function(U){function P(B){const Z=Object.keys(B).sort();let Y="";for(const H of Z){let _=B[H];_ instanceof Object?_=P(_):typeof _=="string"&&(_=_.replace(/,/g,",,")),Y+=H+","+_+","}return Y}function M(B){const Y={_key:P(B),type:B.taskType};return Object.assign(Y,B),Y}U.create=M})(j=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var Q;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(Q=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var G;(function(U){function P(M,B){const Z=T.TaskDefinitionRegistry.get(M.type);if(Z===void 0){const ee=L.deepClone(M);return delete ee._key,j.create(ee)}const Y=Object.create(null);Y.type=Z.taskType;const H=new Set;Z.required.forEach(ee=>H.add(ee));const _=Z.properties;for(const ee of Object.keys(_)){const be=M[ee];if(be!=null)Y[ee]=be;else if(H.has(ee)){const ce=_[ee];if(ce.default!==void 0)Y[ee]=L.deepClone(ce.default);else switch(ce.type){case"boolean":Y[ee]=!1;break;case"number":case"integer":Y[ee]=0;break;case"string":Y[ee]="";break;default:B.error(a.localize(2,null,JSON.stringify(M,void 0,0),ee));return}}}return j.create(Y)}U.createTaskIdentifier=P})(G=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[249],Ce([1,0,10]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((E,T)=>{this.b=E,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(E){this.f||this.h||(this.f=!0,this.g=E,this.a&&this.b(E))}resolveErr(E){this.f||this.h||(this.h=!0,this.i=E,this.a?this.d(E):(0,a.onUnexpectedError)(E))}then(E,T){return this.j().then(E,T)}catch(E){return this.j().then(void 0,E)}finally(E){return this.j().finally(E)}}e.LazyPromise=R;class c extends R{constructor(){super(),this.h=!0,this.i=new a.CancellationError}}e.CanceledLazyPromise=c}),define(De[58],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++a.count}}a.count=0,e.ProxyIdentifier=a;const R=[];function c(T){const S=new a(T);return R[S.nid]=S,S}e.createProxyIdentifier=c;function L(T){return R[T].sid}e.getStringIdentifierForProxy=L;class E{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=E}),define(De[5],Ce([1,0,58]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var c;(function(m){m[m.UnknownInput=0]="UnknownInput",m[m.TextInput=1]="TextInput",m[m.TextDiffInput=2]="TextDiffInput",m[m.TextMergeInput=3]="TextMergeInput",m[m.NotebookInput=4]="NotebookInput",m[m.NotebookDiffInput=5]="NotebookDiffInput",m[m.CustomEditorInput=6]="CustomEditorInput",m[m.WebviewEditorInput=7]="WebviewEditorInput",m[m.TerminalEditorInput=8]="TerminalEditorInput",m[m.InteractiveEditorInput=9]="InteractiveEditorInput"})(c=e.TabInputKind||(e.TabInputKind={}));var L;(function(m){m[m.TAB_OPEN=0]="TAB_OPEN",m[m.TAB_CLOSE=1]="TAB_CLOSE",m[m.TAB_UPDATE=2]="TAB_UPDATE",m[m.TAB_MOVE=3]="TAB_MOVE"})(L=e.TabModelOperationKind||(e.TabModelOperationKind={}));var E;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(E=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var T;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(T=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var N;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(N=e.CandidatePortSource||(e.CandidatePortSource={}));class A{static mixin(o){return o._id=A.a++,o}}A.a=0,e.IdObject=A;var D;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.kindModifier="m",m.commandIdent="n",m.commandId="o",m.commandArguments="p"})(D=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var k;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(k=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var C;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(C=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,a.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,a.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(De[77],Ce([1,0,4,13,5,20]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let E=class{constructor(S,I){this.c=I,this.a=new Set,this.b=S.getProxy(c.MainContext.MainThreadTelemetry)}report(S,I,N){const A=this.d(S,I);this.a.has(A)||(this.a.add(A),I.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:S}))}d(S,I){return`${S}-${I.identifier.value}`}};E=Ve([ze(0,L.IExtHostRpcService),ze(1,R.ILogService)],E),e.ExtHostApiDeprecationService=E,e.NullApiDeprecationService=Object.freeze(new class{report(T,S,I){}})}),define(De[250],Ce([1,0,3,5,7,25]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class E{constructor(S){this.b=new Map,this.c=[],this.d=new a.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,I,N,A={}){const D=L.ExtensionIdentifier.toKey(S.identifier),k=this.f.get(D)||[],C=[...N].sort().join(" ");let m=k.find(o=>o.providerId===I&&o.scopes===C);if(m)return m.result;{const o=this.g(S,D,I,N,A);m={providerId:I,scopes:C,result:o},k.push(m),this.f.set(D,k);try{await o}finally{const d=k.findIndex(f=>f.providerId===I&&f.scopes===C);d>-1&&(k.splice(d),this.f.set(D,k))}return o}}async g(S,I,N,A,D={}){await this.a.$ensureProvider(N);const k=S.displayName||S.name;return this.a.$getSession(N,A,I,k,D)}async removeSession(S,I){const N=this.b.get(S);return N?N.provider.removeSession(I):this.a.$removeSession(S,I)}registerAuthenticationProvider(S,I,N,A){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:I,provider:N,options:A??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===S)||this.c.push({id:S,label:I});const D=N.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(S,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(S,I,A?.supportsMultipleAccounts??!1),new c.Disposable(()=>{D.dispose(),this.b.delete(S);const k=this.c.findIndex(C=>C.id===S);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,I){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,I){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,I){const N=this.b.get(S);if(N)return Promise.resolve(N.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,I){return this.d.fire({provider:{id:S,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=E}),define(De[251],Ce([1,0,5,20,14]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(T,S){this.a=T.getProxy(a.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>S.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(T,S,I){const N=c.WorkspaceEdit.from(T,this.b);return this.a.$tryApplyWorkspaceEdit(N,void 0,I?.isRefactoring??!1)}};L=Ve([ze(0,R.IExtHostRpcService)],L),e.ExtHostBulkEdits=L}),define(De[252],Ce([1,0,5]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(L){const E=L.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return E.$readText()},writeText(T){return E.$writeText(T)}})}}e.ExtHostClipboard=R});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,R,c){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!c)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!c:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?c.call(ie,a):c?c.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!R:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(ie):R?R.value:e.get(ie)};define(De[40],Ce([1,0,9,7,14,23,5,15,13,69,32,53,2,6,4,20,138,22,58,45,43,73,76]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f,p,y,g,t){"use strict";var s,r,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let u=class{constructor(v,O,j){s.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),l.set(this,void 0),Je(this,s,v.getProxy(E.MainContext.MainThreadCommands),"f"),this.d=O,Je(this,l,j,"f"),Je(this,r,v.getProxy(E.MainContext.MainThreadTelemetry),"f"),this.converter=new b(this,V=>{const Q=this.c.get(V);return Q?.result===n.Void?Q:void 0},O),this.f=[{processArgument(V){return(0,I.revive)(V)}},{processArgument(V){return(0,L.cloneAndChange)(V,function(Q){if(N.Range.isIRange(Q))return c.Range.to(Q);if(A.Position.isIPosition(Q))return c.Position.to(Q);if(N.Range.isIRange(Q.range)&&D.URI.isUri(Q.uri))return c.location.to(Q);if(Q instanceof d.VSBuffer)return Q.buffer.buffer;if(!Array.isArray(Q))return Q})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const O=this.registerCommand(!1,v.id,async(...j)=>{const V=v.args.map((G,U)=>{if(!G.validate(j[U]))throw new Error(`Invalid argument '${G.name}' when running '${v.id}', received: ${j[U]}`);return G.convert(j[U])}),Q=await this.executeCommand(v.internalId,...V);return v.result.convert(Q,j,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new R.Disposable(()=>{O.dispose(),this.c.delete(v.id)})}registerCommand(v,O,j,V,Q,G){if(this.d.trace("ExtHostCommands#registerCommand",O),!O.trim().length)throw new Error("invalid id");if(this.b.has(O))throw new Error(`command '${O}' already exists`);return this.b.set(O,{callback:j,thisArg:V,description:Q,extension:G}),v&&Ue(this,s,"f").$registerCommand(O),new R.Disposable(()=>{this.b.delete(O)&&v&&Ue(this,s,"f").$unregisterCommand(O)})}executeCommand(v,...O){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,O,!0)}async g(v,O,j){if(this.b.has(v))return Ue(this,s,"f").$fireCommandActivationEvent(v),this.h(v,O,!1);{let V=!1;const Q=(0,L.cloneAndChange)(O,function(G){if(G instanceof R.Position)return c.Position.from(G);if(G instanceof R.Range)return c.Range.from(G);if(G instanceof R.Location)return c.location.from(G);if(R.NotebookRange.isNotebookRange(G))return c.NotebookRange.from(G);if(G instanceof ArrayBuffer)return V=!0,d.VSBuffer.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return V=!0,d.VSBuffer.wrap(G);if(G instanceof d.VSBuffer)return V=!0,G;if(!Array.isArray(G))return G});try{const G=await Ue(this,s,"f").$executeCommand(v,V?new f.SerializableObjectWithBuffers(Q):Q,j);return(0,I.revive)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(v,O,!1);throw G}}}async h(v,O,j){const V=this.b.get(v);if(!V)throw new Error("Unknown command");const{callback:Q,thisArg:G,description:U}=V;if(U)for(let M=0;M<U.args.length;M++)try{(0,a.validateConstraint)(O[M],U.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${U.args[M].name}' - ${U.args[M].description}`)}const P=y.StopWatch.create();try{return await Q.apply(G,O)}catch(M){if(v===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...O);B&&(v=B.command)}if(this.d.error(M,v,V.extension?.identifier),!j)throw M;if(V.extension?.identifier){const B=Ue(this,l,"f").onExtensionError(V.extension.identifier,M);this.d.trace("forwarded error to extension?",B,V.extension?.identifier)}throw new class extends Error{constructor(){super((0,p.toErrorMessage)(M)),this.id=v,this.source=V.extension?.displayName??V.extension?.name}}}finally{this.j(V,v,P.elapsed())}}j(v,O,j){!v.extension||Ue(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new g.TelemetryTrustedValue(O),duration:j})}$executeContributedCommand(v,...O){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const j=this.b.get(v);return j?(O=O.map(V=>this.f.reduce((Q,G)=>G.processArgument(Q,j.extension?.identifier),V)),this.h(v,O,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),Ue(this,s,"f").$getCommands().then(O=>(v&&(O=O.filter(j=>j[0]!=="_")),O))}$getContributedCommandHandlerDescriptions(){const v=Object.create(null);for(const[O,j]of this.b){const{description:V}=j;V&&(v[O]=V)}return Promise.resolve(v)}};s=new WeakMap,r=new WeakMap,l=new WeakMap,u=Ve([ze(0,m.IExtHostRpcService),ze(1,S.ILogService),ze(2,t.IExtHostTelemetry)],u),e.ExtHostCommands=u,e.IExtHostCommands=(0,C.createDecorator)("IExtHostCommands");class b{constructor(v,O,j){this.d=v,this.f=O,this.g=j,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,O){if(!v)return;const j={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return j;const V=this.f(v.command);if(V)j.id=V.internalId,j.arguments=V.args.map((Q,G)=>Q.convert(v.arguments&&v.arguments[G]));else if((0,T.isNonEmptyArray)(v.arguments)){const Q=`${v.command}/${++this.c}`;this.b.set(Q,v),O.add((0,k.toDisposable)(()=>{this.b.delete(Q),this.g.trace("CommandsConverter#DISPOSE",Q)})),j.$ident=Q,j.id=this.delegatingCommandId,j.arguments=[Q],this.g.trace("CommandsConverter#CREATE",v.command,Q)}return j}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const O=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],O?O.command:"MISSING"),O?this.d.executeCommand(O.command,...O.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.CommandsConverter=b;class i{constructor(v,O,j,V){this.name=v,this.description=O,this.validate=j,this.convert=V}optional(){return new i(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,O){return new i(v??this.name,O??this.description,this.validate,this.convert)}}i.Uri=new i("uri","Uri of a text document",w=>D.URI.isUri(w),w=>w),i.Position=new i("position","A position in a text document",w=>R.Position.isPosition(w),c.Position.from),i.Range=new i("range","A range in a text document",w=>R.Range.isRange(w),c.Range.from),i.Selection=new i("selection","A selection in a text document",w=>R.Selection.isSelection(w),c.Selection.from),i.Number=new i("number","",w=>typeof w=="number",w=>w),i.String=new i("string","",w=>typeof w=="string",w=>w),i.CallHierarchyItem=new i("item","A call hierarchy item",w=>w instanceof R.CallHierarchyItem,c.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",w=>w instanceof R.TypeHierarchyItem,c.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",w=>w instanceof o.TestItemImpl,c.TestItem.from),e.ApiCommandArgument=i;class n{constructor(v,O){this.description=v,this.convert=O}}n.Void=new n("no result",w=>w),e.ApiCommandResult=n;class h{constructor(v,O,j,V,Q){this.id=v,this.internalId=O,this.description=j,this.args=V,this.result=Q}}e.ApiCommand=h}),define(De[253],Ce([1,0,2,14,7,71,40,15,120,125,16]),function(ie,e,a,R,c,L,E,T,S,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const A=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",k(R.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(m,o)=>{if((0,T.isFalsyOrEmpty)(m))return;class d extends c.SymbolInformation{static to(p){const y=new d(p.name,R.SymbolKind.to(p.kind),p.containerName||"",new c.Location(o[0],R.Range.to(p.range)));return y.detail=p.detail,y.range=y.location.range,y.selectionRange=R.Range.to(p.selectionRange),y.children=p.children?p.children.map(d.to):[],y}}return m.map(d.to)})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(R.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(R.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",m=>typeof m=="string",m=>m),new E.ApiCommandArgument("options","Formatting options",m=>!0,m=>m)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(R.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",C)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",k(R.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",k(R.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",m=>Array.isArray(m)&&m.every(o=>c.Position.isPosition(o)),m=>m.map(R.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",m=>m.map(o=>{let d;for(const f of o.reverse())d=new c.SelectionRange(R.Range.to(f),d);return d}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",m=>m.map(R.WorkspaceSymbol.to))),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",m=>m.map(R.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",m=>m.map(R.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",m=>m.map(R.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to a range and placeholder text.",m=>{if(!!m)return{range:R.Range.to(m.range),placeholder:m.text}})),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",m=>{if(!!m){if(m.rejectReason)throw new Error(m.rejectReason);return R.WorkspaceEdit.to(m)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",m=>m.map(R.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new c.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const o=(0,S.decodeSemanticTokensDto)(m);if(o.type==="full")return new c.SemanticTokens(o.data,void 0)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range.optional()],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",m=>{if(!!m)return new c.SemanticTokensLegend(m.tokenTypes,m.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",m=>{if(!m)return;const o=(0,S.decodeSemanticTokensDto)(m);if(o.type==="full")return new c.SemanticTokens(o.data,void 0)})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(m,o,d)=>{if(!m)return new c.CompletionList([]);const f=m.suggestions.map(p=>R.CompletionItem.to(p,d));return new c.CompletionList(f,m.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",m=>{if(m)return R.SignatureHelp.to(m)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(m,o,d)=>k(f=>new c.CodeLens(R.Range.to(f.range),f.command&&d.fromInternal(f.command)))(m))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",m=>c.Range.isRange(m),m=>c.Selection.isSelection(m)?R.Selection.from(m):R.Range.from(m)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(m,o,d)=>k(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(f.command)}else{const p=new c.CodeAction(f.title,f.kind?new c.CodeActionKind(f.kind):void 0);return f.edit&&(p.edit=R.WorkspaceEdit.to(f.edit)),f.command&&(p.command=d.fromInternal(f.command)),p.isPreferred=f.isPreferred,p}})(m))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",m=>m?m.map(o=>new c.ColorInformation(R.Range.to(o.range),R.Color.to(o.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",m=>m instanceof c.Color,R.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",m=>!0,m=>({uri:m.uri,range:R.Range.from(m.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",m=>m?m.map(R.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",(m,o,d)=>m.map(R.InlayHint.to.bind(void 0,d)))),new E.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(m,o)=>{if(m)return m.map(R.FoldingRange.to)})),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",k(m=>({viewType:m.viewType,displayName:m.displayName,options:{transientOutputs:m.options.transientOutputs,transientCellMetadata:m.options.transientCellMetadata,transientDocumentMetadata:m.options.transientDocumentMetadata},filenamePattern:m.filenamePattern.map(o=>R.NotebookExclusiveDocumentPattern.to(o))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",m=>m.map(R.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new E.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",m=>a.URI.isUri(m)||typeof m=="string"&&(0,I.matchesSomeScheme)(m,N.Schemas.http,N.Schemas.https),m=>m),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[R.ViewColumn.from(m),void 0]:[R.ViewColumn.from(m.viewColumn),R.TextEditorOpenOptions.from(m)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="number"||typeof m=="object",m=>m&&(typeof m=="number"?[R.ViewColumn.from(m),void 0]:[R.ViewColumn.from(m.viewColumn),R.TextEditorOpenOptions.from(m)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",m=>m===void 0||typeof m=="object",m=>m&&[R.ViewColumn.from(m.viewColumn),R.TextEditorOpenOptions.from(m)]).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(R.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(R.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",m=>m.map(R.TypeHierarchyItem.to))),new E.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[E.ApiCommandArgument.TestItem],E.ApiCommandResult.Void),new E.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[E.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],E.ApiCommandResult.Void),new E.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[E.ApiCommandArgument.String.with("name","The context key name"),new E.ApiCommandArgument("value","The context key value",()=>!0,m=>m)],E.ApiCommandResult.Void)];class D{static register(o){A.forEach(o.registerApiCommand,o)}}e.ExtHostApiCommands=D;function k(m){return o=>{if(Array.isArray(o))return o.map(m)}}function C(m){if(!Array.isArray(m))return;const o=[];for(const d of m)L.isLocationLink(d)?o.push(R.DefinitionLink.to(d)):o.push(R.location.to(d));return o}}),define(De[254],Ce([1,0,19,62,3,6,2,71,25,14,7,5]),function(ie,e,a,R,c,L,E,T,S,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function D(k,C,m){const o=k.getProxy(A.MainContext.MainThreadComments);class d{constructor(){this.b=new Map,this.c=new S.ExtensionIdentifierMap,C.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const b=this.b.get(u.handle);return b?b.value:u}else if(u&&u.$mid===7){const b=this.b.get(u.commentControlHandle);if(!b)return u;const i=b.getCommentThread(u.commentThreadHandle);return i?i.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const b=this.b.get(u.thread.commentControlHandle);if(!b)return u;const i=b.getCommentThread(u.thread.commentThreadHandle);return i?u.$mid===8?i.value:{thread:i.value,text:u.text}:u}else if(u&&u.$mid===10){const b=this.b.get(u.thread.commentControlHandle);if(!b)return u;const i=b.getCommentThread(u.thread.commentThreadHandle);if(!i)return u;const n=u.commentUniqueId,h=i.getCommentByUniqueId(n);return h||u}else if(u&&u.$mid===11){const b=this.b.get(u.thread.commentControlHandle);if(!b)return u;const i=b.getCommentThread(u.thread.commentThreadHandle);if(!i)return u;const n=u.text,h=u.commentUniqueId,w=i.getCommentByUniqueId(h);return w?(typeof w.body=="string"?w.body=n:w.body=new N.MarkdownString(n),w):u}return u}})}createCommentController(u,b,i){const n=d.a++,h=new p(u,n,b,i);this.b.set(h.handle,h);const w=this.c.get(u.identifier)||[];return w.push(h),this.c.set(u.identifier,w),h.value}$createCommentThreadTemplate(u,b,i){const n=this.b.get(u);!n||n.$createCommentThreadTemplate(b,i)}async $updateCommentThreadTemplate(u,b,i){const n=this.b.get(u);!n||n.$updateCommentThreadTemplate(b,i)}$deleteCommentThread(u,b){this.b.get(u)?.$deleteCommentThread(b)}$provideCommentingRanges(u,b,i){const n=this.b.get(u);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const h=m.getDocument(E.URI.revive(b));return(0,a.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(h,i)).then(w=>w?w.map(v=>I.Range.from(v)):void 0)}$toggleReaction(u,b,i,n,h){const w=this.b.get(u);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const v=w.getCommentThread(b);if(v){const O=v.getCommentByUniqueId(n.uniqueIdInThread);if(w!==void 0&&O&&w.reactionHandler)return w.reactionHandler(O,t(h))}return Promise.resolve(void 0)})}dispose(){}}d.a=0;class f{set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){u.isEqual(this.p)||(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return this.h}set state(u){this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,b,i,n,h,w,v,O){this.m=b,this.n=i,this.o=n,this.p=h,this.q=w,this.extensionDescription=v,this.r=O,this.handle=f.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new c.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.MutableDisposable,this.l.value=new L.DisposableStore,this.n===void 0&&(this.n=`${u}.${this.handle}`),o.$createCommentThread(b,this.handle,this.n,this.o,I.Range.from(this.p),v.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{o.$deleteCommentThread(b,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(V){j.range=V},get comments(){return j.comments},set comments(V){j.comments=V},get collapsibleState(){return j.collapsibleState},set collapsibleState(V){j.collapsibleState=V},get canReply(){return j.canReply},set canReply(V){j.canReply=V},get contextValue(){return j.contextValue},set contextValue(V){j.contextValue=V},get label(){return j.label},set label(V){j.label=V},get state(){return j.state},set state(V){j.state=V},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.DisposableStore);const u=i=>Object.prototype.hasOwnProperty.call(this.b,i),b={};u("range")&&(b.range=I.Range.from(this.p)),u("label")&&(b.label=this.label),u("contextValue")&&(b.contextValue=this.contextValue??null),u("comments")&&(b.comments=this.q.map(i=>y(this,i,this.k))),u("collapsibleState")&&(b.collapseState=s(this.g)),u("canReply")&&(b.canReply=this.canReply),u("state")&&(b.state=r(this.h)),u("isTemplate")&&(b.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,b)}getCommentByUniqueId(u){for(const b of this.k){const i=b[0],n=b[1];if(u===n)return i}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}f.a=0,Ve([(0,R.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class p{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,b,i,n){this.f=u,this.g=b,this.h=i,this.i=n,this.a=new Map,o.$registerCommentController(this.handle,i,n);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(w){h.options=w},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(w){h.commentingRangeProvider=w},get reactionHandler(){return h.reactionHandler},set reactionHandler(w){h.reactionHandler=w},createCommentThread(w,v,O){return h.createCommentThread(w,v,O).value},dispose:()=>{h.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(u,b,i,n){if(typeof u=="string"){const h=new f(this.id,this.handle,u,b,i,n,this.f,!1);return this.a.set(h.handle,h),h}else{const h=new f(this.id,this.handle,void 0,u,b,i,this.f,!1);return this.a.set(h.handle,h),h}}$createCommentThreadTemplate(u,b){const i=new f(this.id,this.handle,void 0,E.URI.revive(u),I.Range.to(b),[],this.f,!0);return i.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this.a.set(i.handle,i),i}$updateCommentThreadTemplate(u,b){const i=this.a.get(u);i&&(i.range=I.Range.to(b))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function y(l,u,b){let i=b.get(u);i||(i=++l.commentHandle,b.set(u,i));const n=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;return{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:i,body:typeof u.body=="string"?u.body:I.MarkdownString.from(u.body),userName:u.author.name,userIconPath:n,label:u.label,commentReactions:u.reactions?u.reactions.map(h=>g(h)):void 0,timestamp:u.timestamp?.toJSON()}}function g(l){return{label:l.label,iconPath:l.iconPath?I.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function t(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?E.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function s(l){if(l!==void 0)switch(l){case N.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function r(l){if(l!==void 0)switch(l){case N.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new d}e.createExtHostComments=D}),define(De[255],Ce([1,0,23,5,26,20]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let E=class{constructor(N,A){this.a=N.getProxy(R.MainContext.MainThreadConsole),this.b=A.consoleForward.includeStack,this.c=A.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(N,A){const D=this,k=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){D.e(N,A,k,arguments)}})}e(N,A,D,k){this.a.$logExtensionHostMessage({type:"__$console",severity:A,arguments:S(k,this.b)}),this.c&&this.f(N,D,k)}};E=Ve([ze(0,L.IExtHostRpcService),ze(1,c.IExtHostInitDataService)],E),e.AbstractExtHostConsoleForwarder=E;const T=1e5;function S(I,N){const A=[];if(I.length)for(let D=0;D<I.length;D++){let k=I[D];if(typeof k>"u")k="undefined";else if(k instanceof Error){const C=k;C.stack?k=C.stack:k=C.toString()}A.push(k)}if(N){const D=new Error().stack;D&&A.push({__$stack:D.split(`
`).slice(3).join(`
`)})}try{const D=(0,a.safeStringify)(A);return D.length>T?"Output omitted for a large object that exceeds the limits":D}catch(D){return`Output omitted for an object that cannot be inspected ('${D.toString()}')`}}}),define(De[140],Ce([1,0,2,5,7,4,20,13,15,8,12,27]),function(ie,e,a,R,c,L,E,T,S,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let D=class Mi{constructor(C,m){this.h=m,this.f=new Map,this.g=C.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(C,m){const o=Mi.c++;this.f.set(o,{provider:C,extensionDescription:m}),this.g.$registerDecorationProvider(o,m.identifier.value);const d=C.onDidChangeFileDecorations&&C.onDidChangeFileDecorations(f=>{if(!f){this.g.$onDidChange(o,null);return}const p=(0,S.asArray)(f);if(p.length<=Mi.d){this.g.$onDidChange(o,p);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,p.length);const y=p.map(s=>({uri:s,rank:(0,I.count)(s.path,"/")})),g=(0,S.groupBy)(y,(s,r)=>s.rank-r.rank||(0,I.compare)(s.uri.path,r.uri.path)),t=[];e:for(const s of g){let r;for(const l of s){const u=(0,N.dirname)(l.uri.path);if(r!==u&&(r=u,t.push(l.uri)>=Mi.d))break e}}this.g.$onDidChange(o,t)});return new c.Disposable(()=>{d?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(C,m,o){if(!this.f.has(C))return Object.create(null);const d=Object.create(null),{provider:f,extensionDescription:p}=this.f.get(C);return await Promise.all(m.map(async y=>{try{const{uri:g,id:t}=y,s=await Promise.resolve(f.provideFileDecoration(a.URI.revive(g),o));if(!s)return;try{c.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,A.checkProposedApiEnabled)(p,"codiconDecoration"),d[t]=[s.propagate,s.tooltip,s.badge,s.color]}catch(r){this.h.warn(`INVALID decoration from extension '${p}': ${r}`)}}catch(g){this.h.error(g)}})),d}};D.c=0,D.d=250,D=Ve([ze(0,E.IExtHostRpcService),ze(1,T.ILogService)],D),e.ExtHostDecorations=D,e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,R,c){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!c)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!c:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?c.call(ie,a):c?c.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!R:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(ie):R?R.value:e.get(ie)};define(De[256],Ce([1,0,178,124,2,5,7,14,3,13,28,49]),function(ie,e,a,R,c,L,E,T,S,I,N,A){"use strict";var D,k,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class m{constructor(f,p,y,g,t,s,r){this.d=f,this.e=p,this.f=y,this.g=g,D.set(this,void 0),k.set(this,void 0),C.set(this,void 0),this.c=!1,Je(this,C,new N.ResourceMap(l=>t.getComparisonKey(l)),"f"),Je(this,D,s,"f"),Je(this,k,r,"f")}dispose(){this.c||(Ue(this,k,"f").fire([...Ue(this,C,"f").keys()]),Ue(this,D,"f")?.$clear(this.e),Ue(this,C,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(f,p){if(!f){this.clear();return}this.h();let y=[];if(c.URI.isUri(f)){if(!p){this.delete(f);return}Ue(this,C,"f").set(f,p.slice()),y=[f]}else if(Array.isArray(f)){y=[];let t;f=[...f].sort(m.j);for(const s of f){const[r,l]=s;if((!t||r.toString()!==t.toString())&&(t&&Ue(this,C,"f").get(t).length===0&&Ue(this,C,"f").delete(t),t=r,y.push(r),Ue(this,C,"f").set(r,[])),l)Ue(this,C,"f").get(r)?.push(...l);else{const u=Ue(this,C,"f").get(r);u&&(u.length=0)}}}if(Ue(this,k,"f").fire(y),!Ue(this,D,"f"))return;const g=[];for(const t of y){let s=[];const r=Ue(this,C,"f").get(t);if(r)if(r.length>this.f){s=[];const l=[E.DiagnosticSeverity.Error,E.DiagnosticSeverity.Warning,E.DiagnosticSeverity.Information,E.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const b of r)if(b.severity===l[u]&&s.push({...T.Diagnostic.from(b),modelVersionId:this.g(t)})===this.f)break e;s.push({severity:R.MarkerSeverity.Info,message:(0,a.localize)(0,null,r.length-this.f),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=r.map(l=>({...T.Diagnostic.from(l),modelVersionId:this.g(t)}));g.push([t,s])}Ue(this,D,"f").$changeMany(this.e,g)}delete(f){this.h(),Ue(this,k,"f").fire([f]),Ue(this,C,"f").delete(f),Ue(this,D,"f")?.$changeMany(this.e,[[f,void 0]])}clear(){this.h(),Ue(this,k,"f").fire([...Ue(this,C,"f").keys()]),Ue(this,C,"f").clear(),Ue(this,D,"f")?.$clear(this.e)}forEach(f,p){this.h();for(const[y,g]of this)f.call(p,y,g,this)}*[(D=new WeakMap,k=new WeakMap,C=new WeakMap,Symbol.iterator)](){this.h();for(const f of Ue(this,C,"f").keys())yield[f,this.get(f)]}get(f){this.h();const p=Ue(this,C,"f").get(f);return Array.isArray(p)?Object.freeze(p.slice(0)):[]}has(f){return this.h(),Array.isArray(Ue(this,C,"f").get(f))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(f,p){return f[0].toString()<p[0].toString()?-1:f[0].toString()>p[0].toString()?1:0}}e.DiagnosticCollection=m;let o=class wi{static _mapper(f){const p=new N.ResourceMap;for(const y of f)p.set(y,y);return{uris:Object.freeze(Array.from(p.values()))}}constructor(f,p,y,g){this.h=p,this.j=y,this.k=g,this.f=new Map,this.g=new S.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,wi._mapper),this.e=f.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(f,p){const{f:y,e:g,g:t,h:s,j:r,k:l}=this,u=new class{$changeMany(n,h){g.$changeMany(n,h),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,n,h.length===0?"CLEARING":h)}$clear(n){g.$clear(n),s.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,n)}dispose(){g.dispose()}};let b;if(!p)p="_generated_diagnostic_collection_name_#"+wi.c++,b=p;else if(!y.has(p))b=p;else{this.h.warn(`DiagnosticCollection with name '${p}' does already exist.`);do b=p+wi.c++;while(y.has(b))}return new class extends m{constructor(){super(p,b,wi.d,n=>l.getDocument(n)?.version,r.extUri,u,t),y.set(b,this)}dispose(){super.dispose(),y.delete(b)}}}getDiagnostics(f){if(f)return this.l(f);{const p=new Map,y=[];for(const g of this.f.values())g.forEach((t,s)=>{let r=p.get(t.toString());typeof r>"u"&&(r=y.length,p.set(t.toString(),r),y.push([t,[]])),y[r][1]=y[r][1].concat(...s)});return y}}l(f){let p=[];for(const y of this.f.values())y.has(f)&&(p=p.concat(y.get(f)));return p}$acceptMarkersChange(f){if(!this.m){const p="_generated_mirror",y=new m(p,p,wi.d,g=>{},this.j.extUri,void 0,this.g);this.f.set(p,y),this.m=y}for(const[p,y]of f)this.m.set(c.URI.revive(p),y.map(T.Diagnostic.to))}};o.c=0,o.d=1e3,o=Ve([ze(1,I.ILogService),ze(2,A.IExtHostFileSystemInfo)],o),e.ExtHostDiagnostics=o}),define(De[257],Ce([1,0,2,5,27]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class L{constructor(T){this.a=T.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(T,S){return S?.allowUIResources&&(0,c.checkProposedApiEnabled)(T,"showLocal"),this.a.$showOpenDialog(S).then(I=>I?I.map(N=>a.URI.revive(N)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(S=>S?a.URI.revive(S):void 0)}}e.ExtHostDialogs=L}),define(De[258],Ce([1,0,10,2,7,5,16,21,8]),function(ie,e,a,R,c,L,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(A,D,k){this.d=D,this.e=k,this.b=new Map,this.c=A.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(A,D){if(Object.keys(E.Schemas).indexOf(A)>=0)throw new Error(`scheme '${A}' already registered`);const k=I.a++;this.b.set(k,D),this.c.$registerTextContentProvider(k,A);let C;return typeof D.onDidChange=="function"&&(C=D.onDidChange(m=>{if(m.scheme!==A){this.e.warn(`Provider for scheme '${A}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this.d.getDocument(m)&&this.$provideTextDocumentContent(k,m).then(o=>{if(!o&&typeof o!="string")return;const d=this.d.getDocument(m);if(!d)return;const f=(0,S.splitLines)(o);if(!d.equalLines(f))return this.c.$onVirtualDocumentChange(m,o)},a.onUnexpectedError)})),new c.Disposable(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),C&&(C.dispose(),C=void 0)})}$provideTextDocumentContent(A,D){const k=this.b.get(A);return k?Promise.resolve(k.provideTextDocumentContent(R.URI.revive(D),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${D.scheme}`))}}I.a=0,e.ExtHostDocumentContentProvider=I}),define(De[259],Ce([1,0,3,6,2,5,136,14,9,23,7]),function(ie,e,a,R,c,L,E,T,S,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class A{constructor(k,C){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.DisposableStore,this.h=new Map,this.f=k.getProxy(L.MainContext.MainThreadDocuments),this.g=C,this.g.onDidRemoveDocuments(m=>{for(const o of m)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(m=>{for(const o of m)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const C=this.g.getDocument(k);if(C)return C}getDocument(k){const C=this.getDocumentData(k);if(!C?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return C.document}ensureDocumentData(k){const C=this.g.getDocument(k);if(C)return Promise.resolve(C);let m=this.h.get(k.toString());return m||(m=this.f.$tryOpenDocument(k).then(o=>{this.h.delete(k.toString());const d=c.URI.revive(o);return(0,S.assertIsDefined)(this.g.getDocument(d))},o=>(this.h.delete(k.toString()),Promise.reject(o))),this.h.set(k.toString(),m)),m}createDocumentData(k){return this.f.$tryCreateDocument(k).then(C=>c.URI.revive(C))}$acceptModelLanguageChanged(k,C){const m=c.URI.revive(k),o=this.g.getDocument(m);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(C),this.a.fire(o.document)}$acceptModelSaved(k){const C=c.URI.revive(k),m=this.g.getDocument(C);if(!m)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(m.document)}$acceptDirtyStateChanged(k,C){const m=c.URI.revive(k),o=this.g.getDocument(m);if(!o)throw new Error("unknown document");o._acceptIsDirty(C),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,C,m){const o=c.URI.revive(k),d=this.g.getDocument(o);if(!d)throw new Error("unknown document");d._acceptIsDirty(m),d.onEvents(C);let f;C.isUndoing?f=N.TextDocumentChangeReason.Undo:C.isRedoing&&(f=N.TextDocumentChangeReason.Redo),this.c.fire((0,I.deepFreeze)({document:d.document,contentChanges:C.changes.map(p=>({range:T.Range.to(p.range),rangeOffset:p.rangeOffset,rangeLength:p.rangeLength,text:p.text})),reason:f}))}setWordDefinitionFor(k,C){(0,E.setWordDefinitionFor)(k,C)}}e.ExtHostDocuments=A}),define(De[59],Ce([1,0,51,3,6,2,4,5,136,20,139,14,13,28,16,64,65]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(y){this.value=y,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let f=class{constructor(y,g){this.h=y,this.i=g,this.a=null,this.b=new Map,this.c=new k.ResourceMap,this.d=new R.Emitter,this.e=new R.Emitter,this.f=new R.Emitter,this.g=new R.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(y){this.acceptDocumentsAndEditorsDelta(y)}acceptDocumentsAndEditorsDelta(y){const g=[],t=[],s=[];if(y.removedDocuments)for(const r of y.removedDocuments){const l=L.URI.revive(r),u=this.c.get(l);u?.unref()&&(this.c.delete(l),g.push(u.value))}if(y.addedDocuments)for(const r of y.addedDocuments){const l=L.URI.revive(r.uri);let u=this.c.get(l);if(u&&l.scheme!==C.Schemas.vscodeNotebookCell&&l.scheme!==C.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);u||(u=new d(new S.ExtHostDocumentData(this.h.getProxy(T.MainContext.MainThreadDocuments),l,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(l,u),t.push(u.value)),u.ref()}if(y.removedEditors)for(const r of y.removedEditors){const l=this.b.get(r);this.b.delete(r),l&&s.push(l)}if(y.addedEditors)for(const r of y.addedEditors){const l=L.URI.revive(r.documentUri);a.ok(this.c.has(l),`document '${l}' does not exist`),a.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const u=this.c.get(l).value,b=new N.ExtHostTextEditor(r.id,this.h.getProxy(T.MainContext.MainThreadTextEditors),this.i,new o.Lazy(()=>u.document),r.selections.map(A.Selection.to),r.options,r.visibleRanges.map(i=>A.Range.to(i)),typeof r.editorPosition=="number"?A.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,b)}y.newActiveEditor!==void 0&&(a.ok(y.newActiveEditor===null||this.b.has(y.newActiveEditor),`active editor '${y.newActiveEditor}' does not exist`),this.a=y.newActiveEditor),(0,c.dispose)(g),(0,c.dispose)(s),y.removedDocuments&&this.e.fire(g),y.addedDocuments&&this.d.fire(t),(y.removedEditors||y.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),y.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(y){return this.c.get(y)?.value}allDocuments(){return m.Iterable.map(this.c.values(),y=>y.value)}getEditor(y){return this.b.get(y)}activeEditor(y){if(!this.a)return;const g=this.b.get(this.a);return y?g:g?.value}allEditors(){return[...this.b.values()]}};f=Ve([ze(0,I.IExtHostRpcService),ze(1,D.ILogService)],f),e.ExtHostDocumentsAndEditors=f,e.IExtHostDocumentsAndEditors=(0,E.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[60],Ce([1,0,14,5,2,3,4,7,20,9,61]),function(ie,e,a,R,c,L,E,T,S,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,E.createDecorator)("IExtHostEditorTabs");class A{constructor(o,d,f){this.e=f,this.d=d,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,d={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.TextTabInput(c.URI.revive(this.b.input.uri));case 2:return new T.TextDiffTabInput(c.URI.revive(this.b.input.original),c.URI.revive(this.b.input.modified));case 3:return new T.TextMergeTabInput(c.URI.revive(this.b.input.base),c.URI.revive(this.b.input.input1),c.URI.revive(this.b.input.input2),c.URI.revive(this.b.input.result));case 6:return new T.CustomEditorTabInput(c.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.WebviewEditorTabInput(this.b.input.viewType);case 4:return new T.NotebookEditorTabInput(c.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(c.URI.revive(this.b.input.original),c.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(c.URI.revive(this.b.input.uri),c.URI.revive(this.b.input.inputBoxUri));default:return}}}class D{constructor(o,d){this.c=[],this.d="",this.b=o,this.e=d;for(const f of o.tabs)f.isActive&&(this.d=f.id),this.c.push(new A(f,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,d={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return a.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(f=>f.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(f=>f.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const f=new A(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,f),o.tabDto.isActive&&(this.d=f.tabId),f}else if(o.kind===1){const f=this.c.splice(o.index,1)[0];if(!f)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return f.tabId===this.d&&(this.d=""),f}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const f=this.c.splice(o.oldIndex,1)[0];if(!f)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,f),f}const d=this.c.find(f=>f.tabId===o.tabDto.id);if(!d)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(o.tabDto),d}activeTabId(){return this.d}}let k=class{constructor(o){this.b=new L.Emitter,this.c=new L.Emitter,this.e=[],this.a=o.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,d={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(f=>f.apiObject))},get activeTabGroup(){const f=o.d;return(0,I.assertIsDefined)(o.e.find(y=>y.groupId===f)?.apiObject)},close:async(f,p)=>{const y=Array.isArray(f)?f:[f];return y.length?C(y[0])?this.j(y,p):this.i(y,p):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(o){const d=new Set(this.e.map(r=>r.groupId)),f=new Set(o.map(r=>r.groupId)),p=(0,N.diffSets)(d,f),y=this.e.filter(r=>p.removed.includes(r.groupId)).map(r=>r.apiObject),g=[],t=[];this.e=o.map(r=>{const l=new D(r,()=>this.d);return p.added.includes(l.groupId)?g.push(l.apiObject):t.push(l.apiObject),l});const s=(0,I.assertIsDefined)(o.find(r=>r.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:g,closed:y,changed:t}))}$acceptTabGroupUpdate(o){const d=this.e.find(f=>f.groupId===o.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const d=this.e.find(p=>p.groupId===o.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const f=d.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[f.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[f.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[f.apiObject]}));return}}g(o){for(const d of this.e)for(const f of d.tabs)if(f.apiObject===o)return f}h(o){return this.e.find(d=>d.apiObject===o)}async i(o,d){const f=[];for(const p of o){const y=this.g(p);if(!y)throw new Error("Tab close: Invalid tab not found!");f.push(y.tabId)}return this.a.$closeTab(f,d)}async j(o,d){const f=[];for(const p of o){const y=this.h(p);if(!y)throw new Error("Group close: Invalid group not found!");f.push(y.groupId)}return this.a.$closeGroup(f,d)}};k=Ve([ze(0,S.IExtHostRpcService)],k),e.ExtHostEditorTabs=k;function C(m){return m.tabs!==void 0}}),define(De[260],Ce([1,0,2,5,6,7,14,155,8,22,27]),function(ie,e,a,R,c,L,E,T,S,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class A{constructor(){this.a=[]}add(C){this.b=void 0,this.a.push(C)}delete(C){const m=this.a.indexOf(C);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const C=this.a.sort(),m=[];let o,d,f=14,p=14;for(const y of C){let g=o?(0,S.commonPrefixLength)(o,y):0;for(g===0?d=1:d=p;g<y.length;g++)g+1===y.length?(f=p,p=9):p+=1,m.push([d,y.toUpperCase().charCodeAt(g),p]),m.push([d,y.toLowerCase().charCodeAt(g),p]),d=p;o=y,p=f}m.push([9,58,10]),m.push([10,47,12]),this.b=new T.StateMachine(m)}}provideDocumentLinks(C){this.c();const m=[],o=T.LinkComputer.computeLinks({getLineContent(d){return C.lineAt(d-1).text},getLineCount(){return C.lineCount}},this.b);for(const d of o){const f=E.DocumentLink.to(d);f.target&&m.push(f)}return m}}class D{constructor(C,m){this.i=m,this.b=new A,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=C.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(C,m,o,d={}){if(D.j(o),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(C,"*",this.b));const f=this.h++;this.b.add(m),this.d.add(m),this.c.set(f,o);let p=2;d.isCaseSensitive&&(p+=1024),d.isReadonly&&(p+=2048),typeof o.copy=="function"&&(p+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,N.checkProposedApiEnabled)(C,"fsChunks"),p+=4),this.a.$registerFileSystemProvider(f,m,p).catch(g=>{console.error(`FAILED to register filesystem provider of ${C.identifier.value}-extension for the scheme ${m}`),console.error(g)});const y=o.onDidChangeFile(g=>{const t=[];for(const s of g){const{uri:r,type:l}=s;if(r.scheme!==m)continue;let u;switch(l){case L.FileChangeType.Changed:u=0;break;case L.FileChangeType.Created:u=1;break;case L.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:u})}this.a.$onFileSystemChange(f,t)});return(0,c.toDisposable)(()=>{y.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(f),this.a.$unregisterProvider(f)})}static j(C){if(!C)throw new Error("MISSING provider");if(typeof C.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof C.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof C.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof C.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof C.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof C.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof C.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof C.rename!="function")throw new Error("Provider does NOT implement rename")}static k(C){const{type:m,ctime:o,mtime:d,size:f,permissions:p}=C;return{type:m,ctime:o,mtime:d,size:f,permissions:p}}$stat(C,m){return Promise.resolve(this.l(C).stat(a.URI.revive(m))).then(o=>D.k(o))}$readdir(C,m){return Promise.resolve(this.l(C).readDirectory(a.URI.revive(m)))}$readFile(C,m){return Promise.resolve(this.l(C).readFile(a.URI.revive(m))).then(o=>I.VSBuffer.wrap(o))}$writeFile(C,m,o,d){return Promise.resolve(this.l(C).writeFile(a.URI.revive(m),o.buffer,d))}$delete(C,m,o){return Promise.resolve(this.l(C).delete(a.URI.revive(m),o))}$rename(C,m,o,d){return Promise.resolve(this.l(C).rename(a.URI.revive(m),a.URI.revive(o),d))}$copy(C,m,o,d){const f=this.l(C);if(!f.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(f.copy(a.URI.revive(m),a.URI.revive(o),d))}$mkdir(C,m){return Promise.resolve(this.l(C).createDirectory(a.URI.revive(m)))}$watch(C,m,o,d){const f=this.l(C).watch(a.URI.revive(o),d);this.f.set(m,f)}$unwatch(C,m){const o=this.f.get(m);o&&(o.dispose(),this.f.delete(m))}$open(C,m,o){const d=this.l(C);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(a.URI.revive(m),o))}$close(C,m){const o=this.l(C);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(m))}$read(C,m,o,d){const f=this.l(C);if(!f.read)throw new Error('FileSystemProvider does not implement "read"');const p=I.VSBuffer.alloc(d);return Promise.resolve(f.read(m,o,p.buffer,0,d)).then(y=>p.slice(0,y))}$write(C,m,o,d){const f=this.l(C);if(!f.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(f.write(m,o,d.buffer,0,d.byteLength))}l(C){const m=this.c.get(C);if(!m){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return m}}e.ExtHostFileSystem=D}),define(De[78],Ce([1,0,5,44,7,22,4,20,49,6]),function(ie,e,a,R,c,L,E,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class Yt{constructor(D,k){this.b=new Map,this.a=D.getProxy(a.MainContext.MainThreadFileSystem);const C=this;this.value=Object.freeze({async stat(m){try{const o=C.b.get(m.scheme);if(!o)return await C.a.$stat(m);await C.a.$ensureActivation(m.scheme);const d=await o.stat(m);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(o){Yt.c(o)}},async readDirectory(m){try{const o=C.b.get(m.scheme);return o?(await C.a.$ensureActivation(m.scheme),(await o.readDirectory(m)).slice()):await C.a.$readdir(m)}catch(o){return Yt.c(o)}},async createDirectory(m){try{return await C.a.$mkdir(m)}catch(o){return Yt.c(o)}},async readFile(m){try{const o=C.b.get(m.scheme);return o?(await C.a.$ensureActivation(m.scheme),(await o.readFile(m)).slice()):(await C.a.$readFile(m)).buffer}catch(o){return Yt.c(o)}},async writeFile(m,o){try{return await C.a.$writeFile(m,L.VSBuffer.wrap(o))}catch(d){return Yt.c(d)}},async delete(m,o){try{const d=C.b.get(m.scheme);return d?(await C.a.$ensureActivation(m.scheme),await d.delete(m,{recursive:!1,...o})):await C.a.$delete(m,{recursive:!1,useTrash:!1,...o})}catch(d){return Yt.c(d)}},async rename(m,o,d){try{return await C.a.$rename(m,o,{overwrite:!1,...d})}catch(f){return Yt.c(f)}},async copy(m,o,d){try{return await C.a.$copy(m,o,{overwrite:!1,...d})}catch(f){return Yt.c(f)}},isWritableFileSystem(m){const o=k.getCapabilities(m);if(typeof o=="number")return!(o&2048)}})}static c(D){if(D instanceof c.FileSystemError)throw D;if(!(D instanceof Error))throw new c.FileSystemError(String(D));if(D.name==="ENOPRO"||D.message.includes("ENOPRO"))throw c.FileSystemError.Unavailable(D.message);switch(D.name){case R.FileSystemProviderErrorCode.FileExists:throw c.FileSystemError.FileExists(D.message);case R.FileSystemProviderErrorCode.FileNotFound:throw c.FileSystemError.FileNotFound(D.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw c.FileSystemError.FileNotADirectory(D.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw c.FileSystemError.FileIsADirectory(D.message);case R.FileSystemProviderErrorCode.NoPermissions:throw c.FileSystemError.NoPermissions(D.message);case R.FileSystemProviderErrorCode.Unavailable:throw c.FileSystemError.Unavailable(D.message);default:throw new c.FileSystemError(D.message,D.name)}}addFileSystemProvider(D,k){return this.b.set(D,k),(0,I.toDisposable)(()=>this.b.delete(D))}};N=Ve([ze(0,T.IExtHostRpcService),ze(1,S.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,E.createDecorator)("IExtHostConsumerFileSystem")}),define(De[261],Ce([1,0,3,38,2,5,14,7]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(A,D,k,C,m,o,d,f){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter;const p=this.h(A,k,m);this.g=0,o&&(this.g+=1),d&&(this.g+=2),f&&(this.g+=4);const y=(0,R.parse)(m),g=typeof m=="string",t=C(s=>{if(!o)for(const r of s.created){const l=c.URI.revive(r);y(l.fsPath)&&(!g||D.getWorkspaceFolder(l))&&this.a.fire(l)}if(!d)for(const r of s.changed){const l=c.URI.revive(r);y(l.fsPath)&&(!g||D.getWorkspaceFolder(l))&&this.b.fire(l)}if(!f)for(const r of s.deleted){const l=c.URI.revive(r);y(l.fsPath)&&(!g||D.getWorkspaceFolder(l))&&this.c.fire(l)}});this.d=T.Disposable.from(p,this.a,this.b,this.c,t)}h(A,D,k){const C=T.Disposable.from();if(typeof k=="string")return C;const m=A.getProxy(L.MainContext.MainThreadFileSystem);let o=!1;(k.pattern.includes(R.GLOBSTAR)||k.pattern.includes(R.GLOB_SPLIT))&&(o=!0);const d=Math.random();return m.$watch(D.identifier.value,d,k.baseUri,{recursive:o,excludes:[]}),T.Disposable.from({dispose:()=>m.$unwatch(d)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class I{constructor(A,D,k){this.j=A,this.k=D,this.l=k,this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.g=new a.AsyncEmitter,this.h=new a.AsyncEmitter,this.i=new a.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(A,D,k,C,m,o){return new S(this.j,A,D,this.a.event,E.GlobPattern.from(k),C,m,o)}$onFileEvent(A){this.a.fire(A)}$onDidRunFileOperation(A,D){switch(A){case 2:this.b.fire(Object.freeze({files:D.map(k=>({oldUri:c.URI.revive(k.source),newUri:c.URI.revive(k.target)}))}));break;case 1:this.d.fire(Object.freeze({files:D.map(k=>c.URI.revive(k.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:D.map(k=>c.URI.revive(k.target))}));break;default:}}getOnWillRenameFileEvent(A){return this.m(A,this.g)}getOnWillCreateFileEvent(A){return this.m(A,this.h)}getOnWillDeleteFileEvent(A){return this.m(A,this.i)}m(A,D){return(k,C,m)=>{const o=function(f){k.call(C,f)};return o.extension=A,D.event(o,void 0,m)}}async $onWillRunFileOperation(A,D,k,C){switch(A){case 2:return await this.n(this.g,{files:D.map(m=>({oldUri:c.URI.revive(m.source),newUri:c.URI.revive(m.target)}))},k,C);case 1:return await this.n(this.i,{files:D.map(m=>c.URI.revive(m.target))},k,C);case 0:case 3:return await this.n(this.h,{files:D.map(m=>c.URI.revive(m.target))},k,C)}}async n(A,D,k,C){const m=new Set,o=[];if(await A.fireAsync(D,C,async(f,p)=>{const y=Date.now(),g=await Promise.resolve(f);g instanceof T.WorkspaceEdit&&(o.push([p.extension,g]),m.add(p.extension.displayName??p.extension.identifier.value)),Date.now()-y>k&&this.k.warn("SLOW file-participant",p.extension.identifier)}),C.isCancellationRequested||o.length===0)return;const d={edits:[]};for(const[,f]of o){const{edits:p}=E.WorkspaceEdit.from(f,{getTextDocumentVersion:y=>this.l.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}});d.edits=d.edits.concat(p)}return{edit:d,extensionNames:Array.from(m)}}}e.ExtHostFileSystemEventService=I}),define(De[262],Ce([1,0,2,40]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class c{constructor(E,T,S,I,N){this.a=T,this.b=S,this.c=I;const A=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",D=>!0,D=>D),new R.ApiCommandArgument("resource","Interactive resource Uri",D=>!0,D=>D),new R.ApiCommandArgument("controllerId","Notebook controller Id",D=>!0,D=>D),new R.ApiCommandArgument("title","Interactive editor title",D=>!0,D=>D)],new R.ApiCommandResult("Notebook and input URI",D=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",D.notebookEditorId),D.notebookEditorId!==void 0){const k=this.a.getEditorById(D.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:a.URI.revive(D.notebookUri),inputUri:a.URI.revive(D.inputUri),notebookEditor:k.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",D.notebookUri,D.inputUri),{notebookUri:a.URI.revive(D.notebookUri),inputUri:a.URI.revive(D.inputUri)}}));this.c.registerApiCommand(A)}$willAddInteractiveDocument(E,T,S,I){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:S,uri:E,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(a.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(E,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[E]})}}e.ExtHostInteractive=c}),define(De[263],Ce([1,0,6,5]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class c{constructor(E){this.b=0,this.a=E.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(E){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,E),(0,a.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=c}),define(De[264],Ce([1,0,2,23,14,7,71,5,8,32,15,9,151,21,6,120,101,74,43,10,19,27]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f,p,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(F,$){this.d=F,this.e=$}async provideDocumentSymbols(F,$){const q=this.d.getDocument(F),J=await this.e.provideDocumentSymbols(q,$);if(!(0,N.isFalsyOrEmpty)(J))return J[0]instanceof L.DocumentSymbol?J.map(c.DocumentSymbol.from):t.f(J)}static f(F){F=F.slice(0).sort((J,ue)=>{let we=J.location.range.start.compareTo(ue.location.range.start);return we===0&&(we=ue.location.range.end.compareTo(J.location.range.end)),we});const $=[],q=[];for(const J of F){const ue={name:J.name||"!!MISSING: name!!",kind:c.SymbolKind.from(J.kind),tags:J.tags?.map(c.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:c.Range.from(J.location.range),selectionRange:c.Range.from(J.location.range),children:[]};for(;;){if(q.length===0){q.push(ue),$.push(ue);break}const we=q[q.length-1];if(I.Range.containsRange(we.range,ue.range)&&!I.Range.equalsRange(we.range,ue.range)){we.children?.push(ue),q.push(ue);break}q.pop()}}return $}}class s{constructor(F,$,q){this.g=F,this.h=$,this.j=q,this.e=new d.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(F,$){const q=this.g.getDocument(F),J=await this.j.provideCodeLenses(q,$);if(!J||$.isCancellationRequested)return;const ue=this.e.add(J),we=new C.DisposableStore;this.f.set(ue,we);const Ae={cacheId:ue,lenses:[]};for(let ve=0;ve<J.length;ve++)Ae.lenses.push({cacheId:[ue,ve],range:c.Range.from(J[ve].range),command:this.h.toInternal(J[ve].command,we)});return Ae}async resolveCodeLens(F,$){const q=F.cacheId&&this.e.get(...F.cacheId);if(!q)return;let J;if(typeof this.j.resolveCodeLens!="function"||q.isResolved?J=q:J=await this.j.resolveCodeLens(q,$),J||(J=q),$.isCancellationRequested)return;const ue=F.cacheId&&this.f.get(F.cacheId[0]);if(!!ue)return F.command=this.h.toInternal(J.command??s.d,ue),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}s.d={command:"missing",title:"!!MISSING: command!!"};function r(se){return Array.isArray(se)?se.map(c.DefinitionLink.from):se?[c.DefinitionLink.from(se)]:[]}class l{constructor(F,$){this.d=F,this.e=$}async provideDefinition(F,$,q){const J=this.d.getDocument(F),ue=c.Position.to($),we=await this.e.provideDefinition(J,ue,q);return r(we)}}class u{constructor(F,$){this.d=F,this.e=$}async provideDeclaration(F,$,q){const J=this.d.getDocument(F),ue=c.Position.to($),we=await this.e.provideDeclaration(J,ue,q);return r(we)}}class b{constructor(F,$){this.d=F,this.e=$}async provideImplementation(F,$,q){const J=this.d.getDocument(F),ue=c.Position.to($),we=await this.e.provideImplementation(J,ue,q);return r(we)}}class i{constructor(F,$){this.d=F,this.e=$}async provideTypeDefinition(F,$,q){const J=this.d.getDocument(F),ue=c.Position.to($),we=await this.e.provideTypeDefinition(J,ue,q);return r(we)}}class n{constructor(F,$){this.d=F,this.e=$}async provideHover(F,$,q){const J=this.d.getDocument(F),ue=c.Position.to($),we=await this.e.provideHover(J,ue,q);if(!(!we||(0,N.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=J.getWordRangeAtPosition(ue)),we.range||(we.range=new L.Range(ue,ue)),c.Hover.from(we)}}class h{constructor(F,$){this.d=F,this.e=$}async provideEvaluatableExpression(F,$,q){const J=this.d.getDocument(F),ue=c.Position.to($),we=await this.e.provideEvaluatableExpression(J,ue,q);if(we)return c.EvaluatableExpression.from(we)}}class w{constructor(F,$){this.d=F,this.e=$}async provideInlineValues(F,$,q,J){const ue=this.d.getDocument(F),we=await this.e.provideInlineValues(ue,c.Range.to($),c.InlineValueContext.to(q),J);if(Array.isArray(we))return we.map(Ae=>c.InlineValue.from(Ae))}}class v{constructor(F,$){this.d=F,this.e=$}async provideDocumentHighlights(F,$,q){const J=this.d.getDocument(F),ue=c.Position.to($),we=await this.e.provideDocumentHighlights(J,ue,q);if(Array.isArray(we))return we.map(c.DocumentHighlight.from)}}class O{constructor(F,$){this.d=F,this.e=$}async provideLinkedEditingRanges(F,$,q){const J=this.d.getDocument(F),ue=c.Position.to($),we=await this.e.provideLinkedEditingRanges(J,ue,q);if(we&&Array.isArray(we.ranges))return{ranges:(0,N.coalesce)(we.ranges.map(c.Range.from)),wordPattern:we.wordPattern}}}class j{constructor(F,$){this.d=F,this.e=$}async provideReferences(F,$,q,J){const ue=this.d.getDocument(F),we=c.Position.to($),Ae=await this.e.provideReferences(ue,we,q,J);if(Array.isArray(Ae))return Ae.map(c.location.from)}}class V{constructor(F,$,q,J,ue,we,Ae){this.g=F,this.h=$,this.j=q,this.k=J,this.l=ue,this.m=we,this.n=Ae,this.e=new d.Cache("CodeAction"),this.f=new Map}async provideCodeActions(F,$,q,J){const ue=this.g.getDocument(F),we=D.Selection.isISelection($)?c.Selection.to($):c.Range.to($),Ae=[];for(const nt of this.j.getDiagnostics(F))if(we.intersection(nt.range)&&Ae.push(nt)>V.d)break;const ve={diagnostics:Ae,only:q.only?new L.CodeActionKind(q.only):void 0,triggerKind:c.CodeActionTriggerKind.to(q.trigger)},Ie=await this.k.provideCodeActions(ue,we,ve,J);if(!(0,N.isNonEmptyArray)(Ie)||J.isCancellationRequested)return;const ke=this.e.add(Ie),He=new C.DisposableStore;this.f.set(ke,He);const qe=[];for(let nt=0;nt<Ie.length;nt++){const Qe=Ie[nt];!Qe||(V.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,He)})):(ve.only&&(Qe.kind?ve.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[ke,nt],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,He),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(c.Diagnostic.from),edit:Qe.edit&&c.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:ke,actions:qe}}async resolveCodeAction(F,$){const[q,J]=F,ue=this.e.get(q,J);if(!ue||V.o(ue)||!this.k.resolveCodeAction)return;const we=await this.k.resolveCodeAction(ue,$)??ue;return we?.edit?c.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}V.d=1e3;class Q{constructor(F,$,q,J){this.d=F,this.e=$,this.f=q,this.g=J}async prepareDocumentPaste(F,$,q,J){if(!this.f.prepareDocumentPaste)return;const ue=this.e.getDocument(F),we=$.map(ve=>c.Range.to(ve)),Ae=c.DataTransfer.toDataTransfer(q,()=>{throw new p.NotImplementedError});return await this.f.prepareDocumentPaste(ue,we,Ae,J),c.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(F,$,q,J,ue){const we=this.e.getDocument($),Ae=q.map(ke=>c.Range.to(ke)),ve=c.DataTransfer.toDataTransfer(J,async ke=>(await this.d.$resolvePasteFileData(this.g,F,ke)).buffer),Ie=await this.f.provideDocumentPasteEdits(we,Ae,ve,ue);if(!!Ie)return{insertText:typeof Ie.insertText=="string"?Ie.insertText:{snippet:Ie.insertText.value},additionalEdit:Ie.additionalEdit?c.WorkspaceEdit.from(Ie.additionalEdit,void 0):void 0}}}class G{constructor(F,$){this.d=F,this.e=$}async provideDocumentFormattingEdits(F,$,q){const J=this.d.getDocument(F),ue=await this.e.provideDocumentFormattingEdits(J,$,q);if(Array.isArray(ue))return ue.map(c.TextEdit.from)}}class U{constructor(F,$){this.d=F,this.e=$}async provideDocumentRangeFormattingEdits(F,$,q,J){const ue=this.d.getDocument(F),we=c.Range.to($),Ae=await this.e.provideDocumentRangeFormattingEdits(ue,we,q,J);if(Array.isArray(Ae))return Ae.map(c.TextEdit.from)}}class P{constructor(F,$){this.d=F,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,$,q,J,ue){const we=this.d.getDocument(F),Ae=c.Position.to($),ve=await this.e.provideOnTypeFormattingEdits(we,Ae,q,J,ue);if(Array.isArray(ve))return ve.map(c.TextEdit.from)}}class M{constructor(F,$){this.e=F,this.f=$,this.d=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(F,$){const q=await this.e.provideWorkspaceSymbols(F,$);if(!(0,N.isNonEmptyArray)(q))return{symbols:[]};const J=this.d.add(q),ue={cacheId:J,symbols:[]};for(let we=0;we<q.length;we++){const Ae=q[we];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}ue.symbols.push({...c.WorkspaceSymbol.from(Ae),cacheId:[J,we]})}return ue}async resolveWorkspaceSymbol(F,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const q=this.d.get(...F.cacheId);if(q){const J=await this.e.resolveWorkspaceSymbol(q,$);return J&&(0,R.mixin)(F,c.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class B{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,$,q){this.d=F,this.e=$,this.f=q}async provideRenameEdits(F,$,q,J){const ue=this.d.getDocument(F),we=c.Position.to($);try{const Ae=await this.e.provideRenameEdits(ue,we,q,J);return Ae?c.WorkspaceEdit.from(Ae):void 0}catch(Ae){const ve=B.g(Ae);return ve?{rejectReason:ve,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(F,$,q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(F),ue=c.Position.to($);try{const we=await this.e.prepareRename(J,ue,q);let Ae,ve;if(L.Range.isRange(we)?(Ae=we,ve=J.getText(we)):(0,A.isObject)(we)&&(Ae=we.range,ve=we.placeholder),!Ae||!ve)return;if(Ae.start.line>ue.line||Ae.end.line<ue.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:c.Range.from(Ae),text:ve}}catch(we){const Ae=B.g(we);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(we)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class Z{constructor(F,$){this.resultId=F,this.tokens=$}}class Y{constructor(F,$){this.f=F,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,$,q){const J=this.f.getDocument(F),ue=$!==0?this.d.get($):null;let we=typeof ue?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,ue.resultId,q):await this.g.provideDocumentSemanticTokens(J,q);return ue&&this.d.delete($),we?(we=Y.h(we),this.o(Y.n(ue,we),we)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return Y.j(F)?Y.k(F)?F:new L.SemanticTokens(new Uint32Array(F.data),F.resultId):Y.l(F)?Y.m(F)?F:new L.SemanticTokensEdits(F.edits.map($=>new L.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const $ of F.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(F,$){if(!Y.j($)||!F||!F.tokens)return $;const q=F.tokens,J=q.length,ue=$.data,we=ue.length;let Ae=0;const ve=Math.min(J,we);for(;Ae<ve&&q[Ae]===ue[Ae];)Ae++;if(Ae===J&&Ae===we)return new L.SemanticTokensEdits([],$.resultId);let Ie=0;const ke=ve-Ae;for(;Ie<ke&&q[J-Ie-1]===ue[we-Ie-1];)Ie++;return new L.SemanticTokensEdits([{start:Ae,deleteCount:J-Ae-Ie,data:ue.subarray(Ae,we-Ie)}],$.resultId)}o(F,$){if(Y.j(F)){const q=this.e++;return this.d.set(q,new Z(F.resultId,F.data)),(0,m.encodeSemanticTokensDto)({id:q,type:"full",data:F.data})}if(Y.l(F)){const q=this.e++;return Y.j($)?this.d.set(q,new Z($.resultId,$.data)):this.d.set(q,new Z(F.resultId)),(0,m.encodeSemanticTokensDto)({id:q,type:"delta",deltas:(F.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class H{constructor(F,$){this.d=F,this.e=$}async provideDocumentRangeSemanticTokens(F,$,q){const J=this.d.getDocument(F),ue=await this.e.provideDocumentRangeSemanticTokens(J,c.Range.to($),q);return ue?this.f(ue):null}f(F){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:F.data})}}class _{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,$,q,J,ue){this.f=F,this.g=$,this.h=q,this.j=J,this.k=ue,this.d=new d.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(F,$,q,J){const ue=this.f.getDocument(F),we=c.Position.to($),Ae=ue.getWordRangeAtPosition(we)||new L.Range(we,we),ve=Ae.with({end:we}),Ie=new f.StopWatch(!0),ke=await this.h.provideCompletionItems(ue,we,J,c.CompletionContext.to(q));if(!ke||J.isCancellationRequested)return;const He=Array.isArray(ke)?new L.CompletionList(ke):ke,qe=_.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),nt=new C.DisposableStore;this.e.set(qe,nt);const Qe=[],tt={x:qe,b:Qe,a:{replace:c.Range.from(Ae),insert:c.Range.from(ve)},c:He.isIncomplete||void 0,d:Ie.elapsed()};for(let rt=0;rt<He.items.length;rt++){const Be=He.items[rt],it=this.l(Be,[qe,rt],ve,Ae);Qe.push(it)}return tt}async resolveCompletionItem(F,$){if(typeof this.h.resolveCompletionItem!="function")return;const q=this.d.get(...F);if(!q)return;const J=await this.h.resolveCompletionItem(q,$);if(!!J)return this.l(J,F)}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,$,q,J){const ue=this.e.get($[0]);if(!ue)throw Error("DisposableStore is missing...");const we=this.g.toInternal(F.command,ue),Ae={x:$,a:F.label,b:F.kind!==void 0?c.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(c.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:c.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(c.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=F.textEdit.newText):typeof F.insertText=="string"?Ae.h=F.insertText:F.insertText instanceof L.SnippetString&&(Ae.h=F.insertText.value,Ae.i|=4);let ve;return F.textEdit?ve=F.textEdit.range:F.range&&(ve=F.range),L.Range.isRange(ve)?Ae.j=c.Range.from(ve):ve&&(!q?.isEqual(ve.inserting)||!J?.isEqual(ve.replacing))&&(Ae.j={insert:c.Range.from(ve.inserting),replace:c.Range.from(ve.replacing)}),Ae}}class ee{async provideInlineCompletions(F,$,q,J){}disposeCompletions(F){}handleDidShowCompletionItem(F,$){}handlePartialAccept(F,$,q){}}class be extends ee{constructor(F,$,q,J){super(),this.f=F,this.g=$,this.h=q,this.j=J,this.d=new ce,this.e=(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[E.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[E.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,$,q,J){const ue=this.g.getDocument(F),we=c.Position.to($),Ae=await this.h.provideInlineCompletionItems(ue,we,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:c.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[q.triggerKind]},J);if(!Ae||J.isCancellationRequested)return;const ve=Array.isArray(Ae)?Ae:Ae.items,Ie=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:ve}),items:ve.map((qe,nt)=>{let Qe;qe.command&&(ke||(ke=new C.DisposableStore),Qe=this.j.toInternal(qe.command,ke));const tt=qe.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:qe.filterText,range:qe.range?c.Range.from(qe.range):void 0,command:Qe,idx:nt,completeBracketPairs:this.e?qe.completeBracketPairs:!1}}),commands:Ie.map(qe=>(ke||(ke=new C.DisposableStore),this.j.toInternal(qe,ke)))}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,$){const q=this.d.get(F)?.items[$];q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(q)}handlePartialAccept(F,$,q){const J=this.d.get(F)?.items[$];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,q)}}class ce{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const $=this.e++;return this.d.set($,F),$}disposeReferenceId(F){const $=this.d.get(F);return this.d.delete(F),$}get(F){return this.d.get(F)}}class oe{constructor(F,$){this.e=F,this.f=$,this.d=new d.Cache("SignatureHelp")}async provideSignatureHelp(F,$,q,J){const ue=this.e.getDocument(F),we=c.Position.to($),Ae=this.g(q),ve=await this.f.provideSignatureHelp(ue,we,J,Ae);if(ve){const Ie=this.d.add([ve]);return{...c.SignatureHelp.from(ve),id:Ie}}}g(F){let $;if(F.activeSignatureHelp){const q=c.SignatureHelp.to(F.activeSignatureHelp),J=this.d.get(F.activeSignatureHelp.id,0);J?($=J,$.activeSignature=q.activeSignature,$.activeParameter=q.activeParameter):$=q}return{...F,activeSignatureHelp:$}}releaseSignatureHelp(F){this.d.delete(F)}}class x{constructor(F,$,q,J,ue){this.f=F,this.g=$,this.h=q,this.j=J,this.k=ue,this.d=new d.Cache("InlayHints"),this.e=new Map}async provideInlayHints(F,$,q){const J=this.f.getDocument(F),ue=c.Range.to($),we=await this.h.provideInlayHints(J,ue,q);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(q.isCancellationRequested)return;const Ae=this.d.add(we);this.e.set(Ae,new C.DisposableStore);const ve={hints:[],cacheId:Ae};for(let Ie=0;Ie<we.length;Ie++)this.l(we[Ie],ue)&&ve.hints.push(this.m(we[Ie],[Ae,Ie]));return this.j.trace(`[InlayHints] ${ve.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),ve}async resolveInlayHint(F,$){if(typeof this.h.resolveInlayHint!="function")return;const q=this.d.get(...F);if(!q)return;const J=await this.h.resolveInlayHint(q,$);if(!!J&&!!this.l(J))return this.m(J,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,$){return F.label.length===0||Array.isArray(F.label)&&F.label.every(q=>q.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!($&&!$.contains(F.position))}m(F,$){const q=this.e.get($[0]);if(!q)throw Error("DisposableStore is missing...");const J={label:"",cacheId:$,tooltip:c.MarkdownString.fromStrict(F.tooltip),position:c.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(c.TextEdit.from),kind:F.kind&&c.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?J.label=F.label:J.label=F.label.map(ue=>{const we={label:ue.value};return we.tooltip=c.MarkdownString.fromStrict(ue.tooltip),L.Location.isLocation(ue.location)&&(we.location=c.location.from(ue.location)),ue.command&&(we.command=this.g.toInternal(ue.command,q)),we}),J}}class he{constructor(F,$){this.e=F,this.f=$,this.d=new d.Cache("DocumentLink")}async provideLinks(F,$){const q=this.e.getDocument(F),J=await this.f.provideDocumentLinks(q,$);if(!(!Array.isArray(J)||J.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(he.g).map(c.DocumentLink.from)};{const ue=this.d.add(J),we={links:[],cacheId:ue};for(let Ae=0;Ae<J.length;Ae++){if(!he.g(J[Ae]))continue;const ve=c.DocumentLink.from(J[Ae]);ve.cacheId=[ue,Ae],we.links.push(ve)}return we}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,$){if(typeof this.f.resolveDocumentLink!="function")return;const q=this.d.get(...F);if(!q)return;const J=await this.f.resolveDocumentLink(q,$);if(!(!J||!he.g(J)))return c.DocumentLink.from(J)}releaseLinks(F){this.d.delete(F)}}class pe{constructor(F,$){this.d=F,this.e=$}async provideColors(F,$){const q=this.d.getDocument(F),J=await this.e.provideDocumentColors(q,$);return Array.isArray(J)?J.map(we=>({color:c.Color.from(we.color),range:c.Range.from(we.range)})):[]}async provideColorPresentations(F,$,q){const J=this.d.getDocument(F),ue=c.Range.to($.range),we=c.Color.to($.color),Ae=await this.e.provideColorPresentations(we,{document:J,range:ue},q);if(!!Array.isArray(Ae))return Ae.map(c.ColorPresentation.from)}}class Se{constructor(F,$){this.d=F,this.e=$}async provideFoldingRanges(F,$,q){const J=this.d.getDocument(F),ue=await this.e.provideFoldingRanges(J,$,q);if(!!Array.isArray(ue))return ue.map(c.FoldingRange.from)}}class Re{constructor(F,$,q){this.d=F,this.e=$,this.f=q}async provideSelectionRanges(F,$,q){const J=this.d.getDocument(F),ue=$.map(c.Position.to),we=await this.e.provideSelectionRanges(J,ue,q);if(!(0,N.isNonEmptyArray)(we))return[];if(we.length!==ue.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let ve=0;ve<ue.length;ve++){const Ie=[];Ae.push(Ie);let ke=ue[ve],He=we[ve];for(;;){if(!He.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Ie.push(c.SelectionRange.from(He)),!He.parent)break;ke=He.range,He=He.parent}}return Ae}}class re{constructor(F,$){this.f=F,this.g=$,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(F,$,q){const J=this.f.getDocument(F),ue=c.Position.to($),we=await this.g.prepareCallHierarchy(J,ue,q);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(ve=>this.h(Ae,ve)):[this.h(Ae,we)]}async provideCallsTo(F,$,q){const J=this.j(F,$);if(!J)throw new Error("missing call hierarchy item");const ue=await this.g.provideCallHierarchyIncomingCalls(J,q);if(!!ue)return ue.map(we=>({from:this.h(F,we.from),fromRanges:we.fromRanges.map(Ae=>c.Range.from(Ae))}))}async provideCallsFrom(F,$,q){const J=this.j(F,$);if(!J)throw new Error("missing call hierarchy item");const ue=await this.g.provideCallHierarchyOutgoingCalls(J,q);if(!!ue)return ue.map(we=>({to:this.h(F,we.to),fromRanges:we.fromRanges.map(Ae=>c.Range.from(Ae))}))}releaseSession(F){this.e.delete(F)}h(F,$){const q=this.e.get(F),J=c.CallHierarchyItem.from($,F,q.size.toString(36));return q.set(J._itemId,$),J}j(F,$){return this.e.get(F)?.get($)}}class le{constructor(F,$){this.f=F,this.g=$,this.d=new o.IdGenerator(""),this.e=new Map}async prepareSession(F,$,q){const J=this.f.getDocument(F),ue=c.Position.to($),we=await this.g.prepareTypeHierarchy(J,ue,q);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(ve=>this.h(Ae,ve)):[this.h(Ae,we)]}async provideSupertypes(F,$,q){const J=this.j(F,$);if(!J)throw new Error("missing type hierarchy item");const ue=await this.g.provideTypeHierarchySupertypes(J,q);if(!!ue)return ue.map(we=>this.h(F,we))}async provideSubtypes(F,$,q){const J=this.j(F,$);if(!J)throw new Error("missing type hierarchy item");const ue=await this.g.provideTypeHierarchySubtypes(J,q);if(!!ue)return ue.map(we=>this.h(F,we))}releaseSession(F){this.e.delete(F)}h(F,$){const q=this.e.get(F),J=c.TypeHierarchyItem.from($,F,q.size.toString(36));return q.set(J._itemId,$),J}j(F,$){return this.e.get(F)?.get($)}}class de{constructor(F,$,q,J){this.d=F,this.e=$,this.f=q,this.g=J}async provideDocumentOnDropEdits(F,$,q,J,ue){const we=this.e.getDocument($),Ae=c.Position.to(q),ve=c.DataTransfer.toDataTransfer(J,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,ke)).buffer),Ie=await this.f.provideDocumentDropEdits(we,Ae,ve,ue);if(!!Ie)return{insertText:typeof Ie.insertText=="string"?Ie.insertText:{snippet:Ie.insertText.value},additionalEdit:Ie.additionalEdit?c.WorkspaceEdit.from(Ie.additionalEdit,void 0):void 0}}}class te{constructor(F,$){this.adapter=F,this.extension=$}}class ae{constructor(F,$,q,J,ue,we,Ae,ve){this.g=$,this.h=q,this.j=J,this.k=ue,this.l=we,this.m=Ae,this.n=ve,this.f=new Map,this.e=F.getProxy(T.MainContext.MainThreadLanguageFeatures)}o(F){return c.DocumentSelector.from(F,this.g)}p(F){return new L.Disposable(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return ae.d++}async s(F,$,q,J,ue,we=!1){const Ae=this.f.get(F);if(!Ae||!(Ae.adapter instanceof $))return J;const ve=Date.now();we||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${q.toString().replace(/[\r\n]/g,"")}'`);const Ie=q(Ae.adapter,Ae.extension);return Promise.resolve(Ie).catch(ke=>{(0,p.isCancellationError)(ke)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Ae.extension.identifier,ke))}).finally(()=>{we||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-ve}ms`)}),k.CancellationToken.isCancellationToken(ue)?(0,y.raceCancellationError)(Ie,ue):Ie}t(F,$){const q=this.q();return this.f.set(q,new te(F,$)),q}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,$,q,J){const ue=this.t(new t(this.h,q),F),we=J&&J.label||ae.u(F);return this.e.$registerDocumentSymbolProvider(ue,this.o($),we),this.p(ue)}$provideDocumentSymbols(F,$,q){return this.s(F,t,J=>J.provideDocumentSymbols(a.URI.revive($),q),void 0,q)}registerCodeLensProvider(F,$,q){const J=this.q(),ue=typeof q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new te(new s(this.h,this.j.converter,q),F)),this.e.$registerCodeLensSupport(J,this.o($),ue);let we=this.p(J);if(ue!==void 0){const Ae=q.onDidChangeCodeLenses(ve=>this.e.$emitCodeLensEvent(ue));we=L.Disposable.from(we,Ae)}return we}$provideCodeLenses(F,$,q){return this.s(F,s,J=>J.provideCodeLenses(a.URI.revive($),q),void 0,q)}$resolveCodeLens(F,$,q){return this.s(F,s,J=>J.resolveCodeLens($,q),void 0,void 0)}$releaseCodeLenses(F,$){this.s(F,s,q=>Promise.resolve(q.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(F,$,q){const J=this.t(new l(this.h,q),F);return this.e.$registerDefinitionSupport(J,this.o($)),this.p(J)}$provideDefinition(F,$,q,J){return this.s(F,l,ue=>ue.provideDefinition(a.URI.revive($),q,J),[],J)}registerDeclarationProvider(F,$,q){const J=this.t(new u(this.h,q),F);return this.e.$registerDeclarationSupport(J,this.o($)),this.p(J)}$provideDeclaration(F,$,q,J){return this.s(F,u,ue=>ue.provideDeclaration(a.URI.revive($),q,J),[],J)}registerImplementationProvider(F,$,q){const J=this.t(new b(this.h,q),F);return this.e.$registerImplementationSupport(J,this.o($)),this.p(J)}$provideImplementation(F,$,q,J){return this.s(F,b,ue=>ue.provideImplementation(a.URI.revive($),q,J),[],J)}registerTypeDefinitionProvider(F,$,q){const J=this.t(new i(this.h,q),F);return this.e.$registerTypeDefinitionSupport(J,this.o($)),this.p(J)}$provideTypeDefinition(F,$,q,J){return this.s(F,i,ue=>ue.provideTypeDefinition(a.URI.revive($),q,J),[],J)}registerHoverProvider(F,$,q,J){const ue=this.t(new n(this.h,q),F);return this.e.$registerHoverProvider(ue,this.o($)),this.p(ue)}$provideHover(F,$,q,J){return this.s(F,n,ue=>ue.provideHover(a.URI.revive($),q,J),void 0,J)}registerEvaluatableExpressionProvider(F,$,q,J){const ue=this.t(new h(this.h,q),F);return this.e.$registerEvaluatableExpressionProvider(ue,this.o($)),this.p(ue)}$provideEvaluatableExpression(F,$,q,J){return this.s(F,h,ue=>ue.provideEvaluatableExpression(a.URI.revive($),q,J),void 0,J)}registerInlineValuesProvider(F,$,q,J){const ue=typeof q.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new w(this.h,q),F);this.e.$registerInlineValuesProvider(we,this.o($),ue);let Ae=this.p(we);if(ue!==void 0){const ve=q.onDidChangeInlineValues(Ie=>this.e.$emitInlineValuesEvent(ue));Ae=L.Disposable.from(Ae,ve)}return Ae}$provideInlineValues(F,$,q,J,ue){return this.s(F,w,we=>we.provideInlineValues(a.URI.revive($),q,J,ue),void 0,ue)}registerDocumentHighlightProvider(F,$,q){const J=this.t(new v(this.h,q),F);return this.e.$registerDocumentHighlightProvider(J,this.o($)),this.p(J)}$provideDocumentHighlights(F,$,q,J){return this.s(F,v,ue=>ue.provideDocumentHighlights(a.URI.revive($),q,J),void 0,J)}registerLinkedEditingRangeProvider(F,$,q){const J=this.t(new O(this.h,q),F);return this.e.$registerLinkedEditingRangeProvider(J,this.o($)),this.p(J)}$provideLinkedEditingRanges(F,$,q,J){return this.s(F,O,async ue=>{const we=await ue.provideLinkedEditingRanges(a.URI.revive($),q,J);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ae.w(we.wordPattern):void 0}},void 0,J)}registerReferenceProvider(F,$,q){const J=this.t(new j(this.h,q),F);return this.e.$registerReferenceSupport(J,this.o($)),this.p(J)}$provideReferences(F,$,q,J,ue){return this.s(F,j,we=>we.provideReferences(a.URI.revive($),q,J,ue),void 0,ue)}registerCodeActionProvider(F,$,q,J){const ue=new C.DisposableStore,we=this.t(new V(this.h,this.j.converter,this.k,q,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(we,this.o($),{providedKinds:J?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:J?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,ue)}))},ae.u(F),Boolean(q.resolveCodeAction)),ue.add(this.p(we)),ue}$provideCodeActions(F,$,q,J,ue){return this.s(F,V,we=>we.provideCodeActions(a.URI.revive($),q,J,ue),void 0,ue)}$resolveCodeAction(F,$,q){return this.s(F,V,J=>J.resolveCodeAction($,q),void 0,void 0)}$releaseCodeActions(F,$){this.s(F,V,q=>Promise.resolve(q.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(F,$,q){const J=this.t(new G(this.h,q),F);return this.e.$registerDocumentFormattingSupport(J,this.o($),F.identifier,F.displayName||F.name),this.p(J)}$provideDocumentFormattingEdits(F,$,q,J){return this.s(F,G,ue=>ue.provideDocumentFormattingEdits(a.URI.revive($),q,J),void 0,J)}registerDocumentRangeFormattingEditProvider(F,$,q){const J=this.t(new U(this.h,q),F);return this.e.$registerRangeFormattingSupport(J,this.o($),F.identifier,F.displayName||F.name),this.p(J)}$provideDocumentRangeFormattingEdits(F,$,q,J,ue){return this.s(F,U,we=>we.provideDocumentRangeFormattingEdits(a.URI.revive($),q,J,ue),void 0,ue)}registerOnTypeFormattingEditProvider(F,$,q,J){const ue=this.t(new P(this.h,q),F);return this.e.$registerOnTypeFormattingSupport(ue,this.o($),J,F.identifier),this.p(ue)}$provideOnTypeFormattingEdits(F,$,q,J,ue,we){return this.s(F,P,Ae=>Ae.provideOnTypeFormattingEdits(a.URI.revive($),q,J,ue,we),void 0,we)}registerWorkspaceSymbolProvider(F,$){const q=this.t(new M($,this.l),F);return this.e.$registerNavigateTypeSupport(q,typeof $.resolveWorkspaceSymbol=="function"),this.p(q)}$provideWorkspaceSymbols(F,$,q){return this.s(F,M,J=>J.provideWorkspaceSymbols($,q),{symbols:[]},q)}$resolveWorkspaceSymbol(F,$,q){return this.s(F,M,J=>J.resolveWorkspaceSymbol($,q),void 0,void 0)}$releaseWorkspaceSymbols(F,$){this.s(F,M,q=>q.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(F,$,q){const J=this.t(new B(this.h,q,this.l),F);return this.e.$registerRenameSupport(J,this.o($),B.supportsResolving(q)),this.p(J)}$provideRenameEdits(F,$,q,J,ue){return this.s(F,B,we=>we.provideRenameEdits(a.URI.revive($),q,J,ue),void 0,ue)}$resolveRenameLocation(F,$,q,J){return this.s(F,B,ue=>ue.resolveRenameLocation(a.URI.revive($),q,J),void 0,J)}registerDocumentSemanticTokensProvider(F,$,q,J){const ue=this.t(new Y(this.h,q),F),we=typeof q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ue,this.o($),J,we);let Ae=this.p(ue);if(we){const ve=q.onDidChangeSemanticTokens(Ie=>this.e.$emitDocumentSemanticTokensEvent(we));Ae=L.Disposable.from(Ae,ve)}return Ae}$provideDocumentSemanticTokens(F,$,q,J){return this.s(F,Y,ue=>ue.provideDocumentSemanticTokens(a.URI.revive($),q,J),null,J)}$releaseDocumentSemanticTokens(F,$){this.s(F,Y,q=>q.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,$,q,J){const ue=this.t(new H(this.h,q),F);return this.e.$registerDocumentRangeSemanticTokensProvider(ue,this.o($),J),this.p(ue)}$provideDocumentRangeSemanticTokens(F,$,q,J){return this.s(F,H,ue=>ue.provideDocumentRangeSemanticTokens(a.URI.revive($),q,J),null,J)}registerCompletionItemProvider(F,$,q,J){const ue=this.t(new _(this.h,this.j.converter,q,this.m,F),F);return this.e.$registerCompletionsProvider(ue,this.o($),J,_.supportsResolving(q),`${F.identifier.value}(${J.join("")})`),this.p(ue)}$provideCompletionItems(F,$,q,J,ue){return this.s(F,_,we=>we.provideCompletionItems(a.URI.revive($),q,J,ue),void 0,ue)}$resolveCompletionItem(F,$,q){return this.s(F,_,J=>J.resolveCompletionItem($,q),void 0,q)}$releaseCompletionItems(F,$){this.s(F,_,q=>q.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(F,$,q){const J=new be(F,this.h,q,this.j.converter),ue=this.t(J,F);return this.e.$registerInlineCompletionsSupport(ue,this.o($),J.supportsHandleEvents),this.p(ue)}$provideInlineCompletions(F,$,q,J,ue){return this.s(F,ee,we=>we.provideInlineCompletions(a.URI.revive($),q,J,ue),void 0,ue)}$handleInlineCompletionDidShow(F,$,q){this.s(F,ee,async J=>{J.handleDidShowCompletionItem($,q)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,$,q,J){this.s(F,ee,async ue=>{ue.handlePartialAccept($,q,J)},void 0,void 0)}$freeInlineCompletionsList(F,$){this.s(F,ee,async q=>{q.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(F,$,q,J){const ue=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,we=this.t(new oe(this.h,q),F);return this.e.$registerSignatureHelpProvider(we,this.o($),ue),this.p(we)}$provideSignatureHelp(F,$,q,J,ue){return this.s(F,oe,we=>we.provideSignatureHelp(a.URI.revive($),q,J,ue),void 0,ue)}$releaseSignatureHelp(F,$){this.s(F,oe,q=>q.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(F,$,q){const J=typeof q.onDidChangeInlayHints=="function"?this.q():void 0,ue=this.t(new x(this.h,this.j.converter,q,this.l,F),F);this.e.$registerInlayHintsProvider(ue,this.o($),typeof q.resolveInlayHint=="function",J,ae.u(F));let we=this.p(ue);if(J!==void 0){const Ae=q.onDidChangeInlayHints(ve=>this.e.$emitInlayHintsEvent(J));we=L.Disposable.from(we,Ae)}return we}$provideInlayHints(F,$,q,J){return this.s(F,x,ue=>ue.provideInlayHints(a.URI.revive($),q,J),void 0,J)}$resolveInlayHint(F,$,q){return this.s(F,x,J=>J.resolveInlayHint($,q),void 0,q)}$releaseInlayHints(F,$){this.s(F,x,q=>q.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(F,$,q){const J=this.t(new he(this.h,q),F);return this.e.$registerDocumentLinkProvider(J,this.o($),typeof q.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(F,$,q){return this.s(F,he,J=>J.provideLinks(a.URI.revive($),q),void 0,q,$.scheme==="output")}$resolveDocumentLink(F,$,q){return this.s(F,he,J=>J.resolveLink($,q),void 0,void 0,!0)}$releaseDocumentLinks(F,$){this.s(F,he,q=>q.releaseLinks($),void 0,void 0,!0)}registerColorProvider(F,$,q){const J=this.t(new pe(this.h,q),F);return this.e.$registerDocumentColorProvider(J,this.o($)),this.p(J)}$provideDocumentColors(F,$,q){return this.s(F,pe,J=>J.provideColors(a.URI.revive($),q),[],q)}$provideColorPresentations(F,$,q,J){return this.s(F,pe,ue=>ue.provideColorPresentations(a.URI.revive($),q,J),void 0,J)}registerFoldingRangeProvider(F,$,q){const J=this.q(),ue=typeof q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new te(new Se(this.h,q),F)),this.e.$registerFoldingRangeProvider(J,this.o($),F.identifier,ue);let we=this.p(J);if(ue!==void 0){const Ae=q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ue));we=L.Disposable.from(we,Ae)}return we}$provideFoldingRanges(F,$,q,J){return this.s(F,Se,ue=>ue.provideFoldingRanges(a.URI.revive($),q,J),void 0,J)}registerSelectionRangeProvider(F,$,q){const J=this.t(new Re(this.h,q,this.l),F);return this.e.$registerSelectionRangeProvider(J,this.o($)),this.p(J)}$provideSelectionRanges(F,$,q,J){return this.s(F,Re,ue=>ue.provideSelectionRanges(a.URI.revive($),q,J),[],J)}registerCallHierarchyProvider(F,$,q){const J=this.t(new re(this.h,q),F);return this.e.$registerCallHierarchyProvider(J,this.o($)),this.p(J)}$prepareCallHierarchy(F,$,q,J){return this.s(F,re,ue=>Promise.resolve(ue.prepareSession(a.URI.revive($),q,J)),void 0,J)}$provideCallHierarchyIncomingCalls(F,$,q,J){return this.s(F,re,ue=>ue.provideCallsTo($,q,J),void 0,J)}$provideCallHierarchyOutgoingCalls(F,$,q,J){return this.s(F,re,ue=>ue.provideCallsFrom($,q,J),void 0,J)}$releaseCallHierarchy(F,$){this.s(F,re,q=>Promise.resolve(q.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(F,$,q){const J=this.t(new le(this.h,q),F);return this.e.$registerTypeHierarchyProvider(J,this.o($)),this.p(J)}$prepareTypeHierarchy(F,$,q,J){return this.s(F,le,ue=>Promise.resolve(ue.prepareSession(a.URI.revive($),q,J)),void 0,J)}$provideTypeHierarchySupertypes(F,$,q,J){return this.s(F,le,ue=>ue.provideSupertypes($,q,J),void 0,J)}$provideTypeHierarchySubtypes(F,$,q,J){return this.s(F,le,ue=>ue.provideSubtypes($,q,J),void 0,J)}$releaseTypeHierarchy(F,$){this.s(F,le,q=>Promise.resolve(q.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(F,$,q){const J=this.q();return this.f.set(J,new te(new de(this.e,this.h,q,J),F)),this.e.$registerDocumentOnDropEditProvider(J,this.o($)),this.p(J)}$provideDocumentOnDropEdits(F,$,q,J,ue,we){return this.s(F,de,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits($,a.URI.revive(q),J,ue,we)),void 0,void 0)}registerDocumentPasteEditProvider(F,$,q,J){const ue=this.q();return this.f.set(ue,new te(new Q(this.e,this.h,q,ue),F)),this.e.$registerPasteEditProvider(ue,this.o($),!!q.prepareDocumentPaste,J.pasteMimeTypes),this.p(ue)}$prepareDocumentPaste(F,$,q,J,ue){return this.s(F,Q,we=>we.prepareDocumentPaste(a.URI.revive($),q,J,ue),void 0,ue)}$providePasteEdits(F,$,q,J,ue,we){return this.s(F,Q,Ae=>Ae.providePasteEdits($,a.URI.revive(q),J,ue,we),void 0,we)}static w(F){return{pattern:F.source,flags:(0,S.regExpFlags)(F)}}static y(F){return{decreaseIndentPattern:ae.w(F.decreaseIndentPattern),increaseIndentPattern:ae.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?ae.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?ae.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:ae.w(F.beforeText),afterText:F.afterText?ae.w(F.afterText):void 0,previousLineText:F.previousLineText?ae.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(ae.z)}setLanguageConfiguration(F,$,q){const{wordPattern:J}=q;if(J&&(0,S.regExpLeadsToEndlessLoop)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor($,J):this.h.setWordDefinitionFor($,void 0),q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const ue=this.q(),we={comments:q.comments,brackets:q.brackets,wordPattern:q.wordPattern?ae.w(q.wordPattern):void 0,indentationRules:q.indentationRules?ae.y(q.indentationRules):void 0,onEnterRules:q.onEnterRules?ae.B(q.onEnterRules):void 0,__electricCharacterSupport:q.__electricCharacterSupport,__characterPairSupport:q.__characterPairSupport};return this.e.$setLanguageConfiguration(ue,$,we),this.p(ue)}$setWordDefinitions(F){for(const $ of F)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}ae.d=0,e.ExtHostLanguageFeatures=ae}),define(De[265],Ce([1,0,5,14,7,37,19,6]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(N,A,D,k){this.c=A,this.d=D,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=N.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this.b=N}async getLanguages(){return this.b.slice(0)}async changeLanguage(N,A){await this.a.$changeLanguage(N,A);const D=this.c.getDocumentData(N);if(!D)throw new Error(`document '${N.toString()}' NOT found`);return D.document}async tokenAtPosition(N,A){const D=N.version,k=R.Position.from(A),C=await this.a.$tokensAtPosition(N.uri,k),m={type:c.StandardTokenType.Other,range:N.getWordRangeAtPosition(A)??new c.Range(A.line,A.character,A.line,A.character)};if(!C)return m;const o={range:R.Range.to(C.range),type:R.TokenType.to(C.type)};return!o.range.contains(A)||D!==N.version?m:o}createLanguageStatusItem(N,A,D){const k=this.f++,C=this.a,m=this.g,o=`${N.identifier.value}/${A}`;if(m.has(o))throw new Error(`LanguageStatusItem with id '${A}' ALREADY exists`);m.add(o);const d={selector:D,id:A,name:N.displayName??N.name,severity:c.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let f;const p=new T.DisposableStore,y=()=>{f?.dispose(),f=(0,E.disposableTimeout)(()=>{p.clear(),this.a.$setLanguageStatus(k,{id:o,name:d.name??N.displayName??N.name,source:N.displayName??N.name,selector:R.DocumentSelector.from(d.selector,this.e),label:d.text,detail:d.detail??"",severity:d.severity===c.LanguageStatusSeverity.Error?L.default.Error:d.severity===c.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:d.command&&this.d.toInternal(d.command,p),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},g={dispose(){p.dispose(),f?.dispose(),C.$removeLanguageStatus(k),m.delete(o)},get id(){return d.id},get name(){return d.name},set name(t){d.name=t,y()},get selector(){return d.selector},set selector(t){d.selector=t,y()},get text(){return d.text},set text(t){d.text=t,y()},get detail(){return d.detail},set detail(t){d.detail=t,y()},get severity(){return d.severity},set severity(t){d.severity=t,y()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(t){d.accessibilityInformation=t,y()},get command(){return d.command},set command(t){d.command=t,y()},get busy(){return d.busy},set busy(t){d.busy=t,y()}};return y(),g}}e.ExtHostLanguages=S}),define(De[97],Ce([1,0,11,8,2,4,13,5,26,20]),function(ie,e,a,R,c,L,E,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let N=class{constructor(D,k,C){this.f=C,this.d=new Map,this.a=k.getProxy(T.MainContext.MainThreadLocalization),this.b=D.environment.appLanguage,this.c=this.b===a.LANGUAGE_DEFAULT}getMessage(D,k){const{message:C,args:m,comment:o}=k;if(this.c)return(0,R.format2)(C,m??{});let d=C;o&&o.length>0&&(d+=`/${Array.isArray(o)?o.join(""):o}`);const f=this.d.get(D)?.contents[d];return f||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,R.format2)(f??C,m??{})}getBundle(D){return this.d.get(D)?.contents}getBundleUri(D){return this.d.get(D)?.uri}async initializeLocalizedMessages(D){if(this.c||!D.l10n&&!D.isBuiltin||this.d.has(D.identifier.value))return;let k;const C=await this.g(D);if(!C){this.f.error(`No bundle location found for extension ${D.identifier.value}`);return}try{const m=await this.a.$fetchBundleContents(C),o=JSON.parse(m);k=D.isBuiltin?o.contents?.bundle:o}catch(m){this.f.error(`Failed to load translations for ${D.identifier.value} from ${C}: ${m.message}`);return}k&&this.d.set(D.identifier.value,{contents:k,uri:C})}async g(D){if(D.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(D.identifier.value,this.b);return c.URI.revive(k)}return D.l10n?c.URI.joinPath(D.extensionLocation,D.l10n,`bundle.l10n.${this.b}.json`):void 0}};N=Ve([ze(0,S.IExtHostInitDataService),ze(1,I.IExtHostRpcService),ze(2,E.ILogService)],N),e.ExtHostLocalizationService=N,e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(De[141],Ce([1,0,13,5,26,20,2,69]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let S=class extends a.AbstractLoggerService{constructor(A,D){super(D.logLevel,D.logsLocation,D.loggers.map(k=>(0,T.revive)(k))),this.n=A.getProxy(R.MainContext.MainThreadLogger)}$setLogLevel(A,D){D?this.setLogLevel(E.URI.revive(D),A):this.setLogLevel(A)}setVisibility(A,D){super.setVisibility(A,D),this.n.$setVisibility(A,D)}m(A,D,k){return new I(this.n,A,D,k)}};S=Ve([ze(0,L.IExtHostRpcService),ze(1,c.IExtHostInitDataService)],S),e.ExtHostLoggerService=S;class I extends a.AbstractMessageLogger{constructor(A,D,k,C){super(C?.logLevel==="always"),this.m=A,this.n=D,this.k=!1,this.l=[],this.setLevel(k),this.m.$createLogger(D,C).then(()=>{this.r(this.l),this.k=!0})}g(A,D){const k=[[A,D]];this.k?this.r(k):this.l.push(...k)}r(A){this.m.$log(this.n,A)}}}),define(De[266],Ce([1,0,5,13,27]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(T){return T&&T.title}let E=class{constructor(S,I){this.b=I,this.a=S.getProxy(a.MainContext.MainThreadMessageService)}showMessage(S,I,N,A,D){const k={source:{identifier:S.identifier,label:S.displayName||S.name}};let C;typeof A=="string"||L(A)?C=[A,...D]:(k.modal=A?.modal,k.useCustom=A?.useCustom,k.detail=A?.detail,C=D),k.useCustom&&(0,c.checkProposedApiEnabled)(S,"resolvers");const m=[];for(let o=0;o<C.length;o++){const d=C[o];if(typeof d=="string")m.push({title:d,handle:o,isCloseAffordance:!1});else if(typeof d=="object"){const{title:f,isCloseAffordance:p}=d;m.push({title:f,isCloseAffordance:!!p,handle:o})}else this.b.warn("Invalid message item:",d)}return this.a.$showMessage(I,N,k,m).then(o=>{if(typeof o=="number")return C[o]})}};E=Ve([ze(1,R.ILogService)],E),e.ExtHostMessageService=E}),define(De[267],Ce([1,0,22,3,6,28,8,9,2,74,5,40,14,7,58,242,137]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class d{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(p=>p.apiEditor)}constructor(p,y,g,t){this.q=g,this.r=t,this.f=new Map,this.g=new L.ResourceMap,this.h=new Map,this.j=new R.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=p.getProxy(N.MainContext.MainThreadNotebook),this.c=p.getProxy(N.MainContext.MainThreadNotebookDocuments),this.d=p.getProxy(N.MainContext.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const r=s.notebookEditor?.notebookUri,l=s.cell.handle,b=this.g.get(r)?.getCell(l);if(b)return b.apiCell}if(s&&s.$mid===14){const r=s.uri,l=this.g.get(r);if(l)return l.apiNotebook}return s}}),d.x(y)}getEditorById(p){const y=this.h.get(p);if(!y)throw new Error(`unknown text editor: ${p}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(p){for(const[y,g]of this.h)if(g.apiEditor===p)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(p,y){const g=this.g.get(p);if(!g&&!y)throw new Error(`NO notebook document for '${p}'`);return g}static s(p,y){if(!y)return;const g=y.filenamePattern.map(t=>D.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(y.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:p.identifier,providerDisplayName:p.displayName||p.name,displayName:y.displayName,filenamePattern:g,exclusive:y.exclusive||!1}}registerNotebookCellStatusBarItemProvider(p,y,g){const t=d.a++,s=typeof g.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(t,g),this.b.$registerNotebookCellStatusBarItemProvider(t,s,y);let r;return s!==void 0&&(r=g.onDidChangeCellStatusBarItems(l=>this.b.$emitCellStatusBarEvent(s))),new k.Disposable(()=>{this.f.delete(t),this.b.$unregisterNotebookCellStatusBarItemProvider(t,s),r?.dispose()})}async createNotebookDocument(p){const y=await this.c.$tryCreateNotebook({viewType:p.viewType,content:p.content&&D.NotebookData.from(p.content)});return S.URI.revive(y)}async openNotebookDocument(p){const y=this.g.get(p);if(y)return y.apiNotebook;const g=await this.c.$tryOpenNotebook(p),t=this.g.get(S.URI.revive(g));return(0,T.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(p,y){S.URI.isUri(p)&&(p=await this.openNotebookDocument(p));let g;typeof y=="object"?g={position:D.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(D.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:g={preserveFocus:!1};const t=await this.d.$tryShowNotebookDocument(p.uri,p.notebookType,g),s=t&&this.h.get(t)?.apiEditor;if(s)return s;throw t?new Error(`Could NOT open editor for "${p.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${p.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(p,y,g,t){const s=this.f.get(p),r=S.URI.revive(y),l=this.g.get(r);if(!l||!s)return;const u=l.getCellFromIndex(g);if(!u)return;const b=await s.provideCellStatusBarItems(u.apiCell,t);if(!b)return;const i=new c.DisposableStore,n=this.p.add([i]),w=(Array.isArray(b)?b:[b]).map(v=>D.NotebookStatusBarItem.from(v,this.i,i));return{cacheId:n,items:w}}$releaseNotebookCellStatusBarItems(p){this.p.delete(p)}registerNotebookSerializer(p,y,g,t,s){if((0,E.isFalsyOrWhitespace)(y))throw new Error("viewType cannot be empty or just whitespace");const r=this.t++;return this.u.set(r,g),this.b.$registerNotebookSerializer(r,{id:p.identifier,location:p.extensionLocation},y,D.NotebookDocumentContentOptions.from(t),d.s(p,s)),(0,c.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(r)})}async $dataToNotebook(p,y,g){const t=this.u.get(p);if(!t)throw new Error("NO serializer found");const s=await t.deserializeNotebook(y.buffer,g);return new C.SerializableObjectWithBuffers(D.NotebookData.from(s))}async $notebookToData(p,y,g){const t=this.u.get(p);if(!t)throw new Error("NO serializer found");const s=await t.serializeNotebook(D.NotebookData.to(y.value),g);return a.VSBuffer.wrap(s)}w(p,y,g){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const t=new o.ExtHostNotebookEditor(y,this.d,p,g.visibleRanges.map(D.NotebookRange.to),g.selections.map(D.NotebookRange.to),typeof g.viewColumn=="number"?D.ViewColumn.to(g.viewColumn):void 0);this.h.set(y,t)}$acceptDocumentAndEditorsDelta(p){if(p.value.removedDocuments)for(const g of p.value.removedDocuments){const t=S.URI.revive(g),s=this.g.get(t);s&&(s.dispose(),this.g.delete(t),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(r=>r.document.uri)}),this.n.fire(s.apiNotebook));for(const r of this.h.values())r.notebookData.uri.toString()===t.toString()&&this.h.delete(r.id)}if(p.value.addedDocuments){const g=[];for(const t of p.value.addedDocuments){const s=S.URI.revive(t.uri);if(this.g.has(s))throw new Error(`adding EXISTING notebook ${s} `);const r=new m.ExtHostNotebookDocument(this.c,this.q,this.r,s,t);g.push(...t.cells.map(l=>m.ExtHostCell.asModelAddData(r.apiNotebook,l))),this.g.get(s)?.dispose(),this.g.set(s,r),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(r.apiNotebook)}}if(p.value.addedEditors)for(const g of p.value.addedEditors){if(this.h.has(g.id))return;const t=S.URI.revive(g.documentUri),s=this.g.get(t);s&&this.w(s,g.id,g)}const y=[];if(p.value.removedEditors)for(const g of p.value.removedEditors){const t=this.h.get(g);t&&(this.h.delete(g),this.k?.id===t.id&&(this.k=void 0),y.push(t))}if(p.value.visibleEditors){this.l=p.value.visibleEditors.map(t=>this.h.get(t)).filter(t=>!!t);const g=new Set;this.l.forEach(t=>g.add(t.id));for(const t of this.h.values()){const s=g.has(t.id);t._acceptVisibility(s)}this.l=[...this.h.values()].map(t=>t).filter(t=>t.visible),this.o.fire(this.visibleNotebookEditors)}p.value.newActiveEditor===null?this.k=void 0:p.value.newActiveEditor&&(this.h.get(p.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${p.value.newActiveEditor}`),this.k=this.h.get(p.value.newActiveEditor)),p.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(p){const y=A.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new A.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new A.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>a.VSBuffer.wrap(s))],new A.ApiCommandResult("Notebook Data",s=>D.NotebookData.to(s.value))),t=new A.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new A.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new C.SerializableObjectWithBuffers(D.NotebookData.from(s)))],new A.ApiCommandResult("Bytes",s=>s.buffer));p.registerApiCommand(g),p.registerApiCommand(t)}}d.a=0,e.ExtHostNotebookController=d}),define(De[268],Ce([1,0,15,19,21,3,6,28,2,25,13,74,5,40,14,7,95,232,27,58]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let y=class{constructor(u,b,i,n,h){this.k=b,this.l=i,this.m=n,this.n=h,this.b=new T.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new A.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=u.getProxy(D.MainContext.MainThreadNotebookKernels);const w=new k.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new k.ApiCommandArgument("options","Select kernel options",v=>!0,v=>{if(v&&"notebookEditor"in v&&"id"in v){const O=this.l.getIdByEditor(v.notebookEditor);return{id:v.id,extension:v.extension,notebookEditorId:O}}else if(v&&"notebookEditor"in v){const O=this.l.getIdByEditor(v.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${v.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return v})],k.ApiCommandResult.Void);this.m.registerApiCommand(w)}createNotebookController(u,b,i,n,h,w){for(const ee of this.h.values())if(ee.controller.id===b&&I.ExtensionIdentifier.equals(u.identifier,ee.extensionId))throw new Error(`notebook controller with id '${b}' ALREADY exist`);const v=this.i++,O=this;this.n.trace(`NotebookController[${v}], CREATED by ${u.identifier.value}, ${b}`);const j=()=>console.warn(`NO execute handler from notebook controller '${P.id}' of extension: '${u.identifier}'`);let V=!1;const Q=new E.DisposableStore,G=new L.Emitter,U=new L.Emitter,P={id:r(u.identifier,b),notebookType:i,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:n||u.identifier.value,preloads:w?w.map(C.NotebookRendererScript.from):[]};let M=h??j,B;this.a.$addKernel(v,P).catch(ee=>{console.log(ee),V=!0});let Z=0;const Y=()=>{if(V)return;const ee=++Z;Promise.resolve().then(()=>{ee===Z&&this.a.$updateKernel(v,P)})},H=new T.ResourceMap,_={get id(){return b},get notebookType(){return P.notebookType},onDidChangeSelectedNotebooks:G.event,get label(){return P.label},set label(ee){P.label=ee??u.displayName??u.name,Y()},get detail(){return P.detail??""},set detail(ee){P.detail=ee,Y()},get description(){return P.description??""},set description(ee){P.description=ee,Y()},get kind(){return(0,f.checkProposedApiEnabled)(u,"notebookControllerKind"),P.kind??""},set kind(ee){(0,f.checkProposedApiEnabled)(u,"notebookControllerKind"),P.kind=ee,Y()},get supportedLanguages(){return P.supportedLanguages},set supportedLanguages(ee){P.supportedLanguages=ee,Y()},get supportsExecutionOrder(){return P.supportsExecutionOrder??!1},set supportsExecutionOrder(ee){P.supportsExecutionOrder=ee,Y()},get rendererScripts(){return P.preloads?P.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(ee){M=ee??j},get interruptHandler(){return B},set interruptHandler(ee){B=ee,P.supportsInterrupt=Boolean(ee),Y()},createNotebookCellExecution(ee){if(V)throw new Error("notebook controller is DISPOSED");if(!H.has(ee.notebook.uri))throw O.n.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(be=>be.toString())),new Error(`notebook controller is NOT associated to notebook: ${ee.notebook.uri.toString()}`);return O._createNotebookCellExecution(ee,r(u.identifier,this.id))},dispose:()=>{V||(this.n.trace(`NotebookController[${v}], DISPOSED`),V=!0,this.h.delete(v),Q.dispose(),G.dispose(),U.dispose(),this.a.$removeKernel(v))},updateNotebookAffinity(ee,be){be===m.NotebookControllerAffinity2.Hidden&&(0,f.checkProposedApiEnabled)(u,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(v,ee.uri,be)},onDidReceiveMessage:U.event,postMessage(ee,be){return(0,f.checkProposedApiEnabled)(u,"notebookMessaging"),O.a.$postMessage(v,be&&O.l.getIdByEditor(be),ee)},asWebviewUri(ee){return(0,f.checkProposedApiEnabled)(u,"notebookMessaging"),(0,o.asWebviewUri)(ee,O.k.remote)}};return this.h.set(v,{extensionId:u.identifier,controller:_,onDidReceiveMessage:U,onDidChangeSelection:G,associatedNotebooks:H}),_}getIdByController(u){for(const[b,i]of this.h)if(i.controller===u)return r(i.extensionId,u.id);return null}createNotebookControllerDetectionTask(u,b){const i=this.d++,n=this;this.n.trace(`NotebookControllerDetectionTask[${i}], CREATED by ${u.identifier.value}`),this.a.$addKernelDetectionTask(i,b);const h={dispose:()=>{this.c.delete(i),n.a.$removeKernelDetectionTask(i)}};return this.c.set(i,h),h}registerKernelSourceActionProvider(u,b,i){const n=this.f++,h=typeof i.onDidChangeNotebookKernelSourceActions=="function"?n:void 0,w=this;this.e.set(n,i),this.n.trace(`NotebookKernelSourceActionProvider[${n}], CREATED by ${u.identifier.value}`),this.a.$addKernelSourceActionProvider(n,n,b);let v;return h!==void 0&&(v=i.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(h))),{dispose:()=>{this.e.delete(n),w.a.$removeKernelSourceActionProvider(n,n),v?.dispose()}}}async $provideKernelSourceActions(u,b){const i=this.e.get(u);if(i){const n=new E.DisposableStore;return this.g.add([n]),(await i.provideNotebookKernelSourceActions(b)??[]).map(w=>C.NotebookKernelSourceAction.from(w,this.m.converter,n))}return[]}$acceptNotebookAssociation(u,b,i){const n=this.h.get(u);if(n){const h=this.l.getNotebookDocument(S.URI.revive(b));i?n.associatedNotebooks.set(h.uri,!0):n.associatedNotebooks.delete(h.uri),this.n.trace(`NotebookController[${u}] ASSOCIATE notebook`,h.uri.toString(),i),n.onDidChangeSelection.fire({selected:i,notebook:h.apiNotebook})}}async $executeCells(u,b,i){const n=this.h.get(u);if(!n)return;const h=this.l.getNotebookDocument(S.URI.revive(b)),w=[];for(const v of i){const O=h.getCell(v);O&&w.push(O.apiCell)}try{this.n.trace(`NotebookController[${u}] EXECUTE cells`,h.uri.toString(),w.length),await n.controller.executeHandler.call(n.controller,w,h.apiNotebook,n.controller)}catch(v){this.n.error(`NotebookController[${u}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(u,b,i){const n=this.h.get(u);if(!n)return;const h=this.l.getNotebookDocument(S.URI.revive(b));if(n.controller.interruptHandler)await n.controller.interruptHandler.call(n.controller,h.apiNotebook);else for(const w of i){const v=h.getCell(w);v&&this.b.get(v.uri)?.cancel()}}$acceptKernelMessageFromRenderer(u,b,i){const n=this.h.get(u);if(!n)return;const h=this.l.getEditorById(b);n.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:i}))}$cellExecutionChanged(u,b,i){const h=this.l.getNotebookDocument(S.URI.revive(u)).getCell(b);if(h){const w=i?C.NotebookCellExecutionState.to(i):m.NotebookCellExecutionState.Idle;w!==void 0&&this.j.fire({cell:h.apiCell,state:w})}}_createNotebookCellExecution(u,b){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this.l.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!n)throw new Error("invalid cell");if(this.b.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const h=new t(b,n,this.a);this.b.set(n.uri,h);const w=h.onDidChangeState(()=>{h.state===g.Resolved&&(h.dispose(),w.dispose(),this.b.delete(n.uri))});return h.asApiObject()}};y=Ve([ze(4,N.ILogService)],y),e.ExtHostNotebookKernels=y;var g;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(g||(g={}));class t extends E.Disposable{get state(){return this.f}constructor(u,b,i){super(),this.j=b,this.k=i,this.b=t.a++,this.c=new L.Emitter,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new c.CancellationTokenSource),this.h=new s(10,n=>this.m(n)),this.i=b.internalMetadata.executionOrder,this.k.$createExecution(this.b,u,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(u){await this.h.addItem(u)}async m(u){const b=Array.isArray(u)?u:[u];return this.k.$updateExecution(this.b,new p.SerializableObjectWithBuffers(b))}n(){if(this.f===g.Init)throw new Error("Must call start before modifying cell output");if(this.f===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(u){let b=this.j;if(u&&(b=this.j.notebook.getCellFromApiCell(u)),!b)throw new Error("INVALID cell");return b.handle}s(u){return u.map(b=>{const i=m.NotebookCellOutput.ensureUniqueMimeTypes(b.items,!0);return i===b.items?C.NotebookCellOutput.from(b):C.NotebookCellOutput.from({items:i,id:b.id,metadata:b.metadata})})}async t(u,b,i){const n=this.r(b),h=this.s((0,a.asArray)(u));return this.l({editType:d.CellExecutionUpdateType.Output,cellHandle:n,append:i,outputs:h})}async w(u,b,i){return u=m.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(u),!0),this.l({editType:d.CellExecutionUpdateType.OutputItems,items:u.map(C.NotebookCellOutputItem.from),outputId:b.id,append:i})}asApiObject(){const u=this;return Object.freeze({get token(){return u.g.token},get cell(){return u.j.apiCell},get executionOrder(){return u.i},set executionOrder(i){u.i=i,u.m([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:u.i}])},start(i){if(u.f===g.Resolved||u.f===g.Started)throw new Error("Cannot call start again");u.f=g.Started,u.c.fire(),u.m({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,n){if(u.f===g.Resolved)throw new Error("Cannot call resolve twice");u.f=g.Resolved,u.c.fire(),u.h.flush(),u.k.$completeExecution(u.b,new p.SerializableObjectWithBuffers({runEndTime:n,lastRunSuccess:i}))},clearOutput(i){return u.n(),u.t([],i,!1)},appendOutput(i,n){return u.n(),u.t(i,n,!0)},replaceOutput(i,n){return u.n(),u.t(i,n,!1)},appendOutputItems(i,n){return u.n(),u.w(i,n,!0)},replaceOutputItems(i,n){return u.n(),u.w(i,n,!1)}})}}t.a=0;class s{constructor(u,b){this.d=u,this.e=b,this.a=[],this.b=Date.now()}addItem(u){return this.a.push(u),this.c||(this.c=new R.DeferredPromise,this.b=Date.now(),(0,R.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const u=this.c;this.c=void 0;const b=this.a;return this.a=[],this.e(b).finally(()=>u.complete())}}function r(l,u){return`${l.value}/${u}`}e.createKernelId=r}),define(De[269],Ce([1,0,3,5,137]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(T,S){this.c=S,this.a=new Map,this.b=T.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,S,I){const N=this.c.getEditorById(T);this.a.get(S)?.fire({editor:N.apiEditor,message:I})}createRendererMessaging(T,S){if(!T.contributes?.notebookRenderer?.some(N=>N.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(N,A,D)=>this.d(S).event(N,A,D),postMessage:(N,A)=>{c.ExtHostNotebookEditor.apiEditorsToExtHost.has(N)&&([N,A]=[A,N]);const D=A&&c.ExtHostNotebookEditor.apiEditorsToExtHost.get(A);return this.b.$postMessage(D?.id,S,N)}}}d(T){let S=this.a.get(T);return S||(S=new a.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(T)}}),this.a.set(T,S),S)}}e.ExtHostNotebookRenderers=L}),define(De[270],Ce([1,0,6,9,2,27,5]),function(ie,e,a,R,c,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class T{constructor(I){this.b=new Map,this.a=I.getProxy(E.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(I,N,A){if((0,L.checkProposedApiEnabled)(I,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,A),this.a.$registerProfileContentHandler(N,A.name,A.description,I.identifier.value),(0,a.toDisposable)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(I,N,A,D){const k=this.b.get(I);if(!k)throw new Error(`Unknown handler with id: ${I}`);return k.saveProfile(N,A,D)}async $readProfile(I,N,A){const D=this.b.get(I);if(!D)throw new Error(`Unknown handler with id: ${I}`);return D.readProfile((0,R.isString)(N)?N:c.URI.revive(N),A)}}e.ExtHostProfileContentHandlers=T}),define(De[271],Ce([1,0,2,5,19,14]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class E{constructor(S,I){this.d=I,this.c=new Map,this.b=S.getProxy(R.MainContext.MainThreadQuickDiff)}$provideOriginalResource(S,I,N){const A=a.URI.revive(I),D=this.c.get(S);return D?(0,c.asPromise)(()=>D.provideOriginalResource(A,N)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(S,I,N,A){const D=E.a++;return this.c.set(D,I),this.b.$registerQuickDiffProvider(D,L.DocumentSelector.from(S,this.d),N,A),{dispose:()=>{this.b.$unregisterQuickDiffProvider(D),this.c.delete(D)}}}}E.a=0,e.ExtHostQuickDiff=E}),define(De[272],Ce([1,0,21,3,6,5,2,7,10,15,37,52,27,14]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function C(m,o,d){const f=m.getProxy(L.MainContext.MainThreadQuickOpen);class p{constructor(i,n){this.e=new Map,this.f=0,this.a=i,this.b=n}showQuickPick(i,n,h,w=a.CancellationToken.None){this.c=void 0;const v=Promise.resolve(n),O=++this.f,j=f.$show(O,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},w),V={},Q=j.then(()=>V);return Promise.race([Q,v]).then(G=>{if(G===V)return;const U=(0,D.isProposedApiEnabled)(i,"quickPickItemTooltip");return v.then(P=>{const M=[];for(let B=0;B<P.length;B++){const Z=P[B];typeof Z=="string"?M.push({label:Z,handle:B}):Z.kind===T.QuickPickItemKind.Separator?M.push({type:"separator",label:Z.label}):(Z.tooltip&&!U&&console.warn(`Extension '${i.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${i.identifier.value}`),M.push({label:Z.label,description:Z.description,detail:Z.detail,picked:Z.picked,alwaysShow:Z.alwaysShow,tooltip:U?k.MarkdownString.fromStrict(Z.tooltip):void 0,handle:B}))}return h&&typeof h.onDidSelectItem=="function"&&(this.c=B=>{h.onDidSelectItem(P[B])}),f.$setItems(O,M),j.then(B=>{if(typeof B=="number")return P[B];if(Array.isArray(B))return B.map(Z=>P[Z])})})}).then(void 0,G=>{if(!(0,S.isCancellationError)(G))return f.$setError(O,G),Promise.reject(G)})}$onItemSelected(i){this.c?.(i)}showInput(i,n=a.CancellationToken.None){return this.d=i?.validateInput,f.$input(i,typeof this.d=="function",n).then(void 0,h=>{if(!(0,S.isCancellationError)(h))return Promise.reject(h)})}async $validateInput(i){if(!this.d)return;const n=await this.d(i);if(!n||typeof n=="string")return n;let h;switch(n.severity){case T.InputBoxValidationSeverity.Info:h=N.default.Info;break;case T.InputBoxValidationSeverity.Warning:h=N.default.Warning;break;case T.InputBoxValidationSeverity.Error:h=N.default.Error;break;default:h=n.message?N.default.Error:N.default.Ignore;break}return{content:n.message,severity:h}}async showWorkspaceFolderPick(i,n=a.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!h)return;const w=await this.a.getWorkspaceFolders2();if(!!w)return w.find(v=>v.uri.toString()===h.uri.toString())}createQuickPick(i){const n=new l(i,()=>this.e.delete(n._id));return this.e.set(n._id,n),n}createInputBox(i){const n=new u(i,()=>this.e.delete(n._id));return this.e.set(n._id,n),n}$onDidChangeValue(i,n){this.e.get(i)?._fireDidChangeValue(n)}$onDidAccept(i){this.e.get(i)?._fireDidAccept()}$onDidChangeActive(i,n){const h=this.e.get(i);h instanceof l&&h._fireDidChangeActive(n)}$onDidChangeSelection(i,n){const h=this.e.get(i);h instanceof l&&h._fireDidChangeSelection(n)}$onDidTriggerButton(i,n){this.e.get(i)?._fireDidTriggerButton(n)}$onDidTriggerItemButton(i,n,h){const w=this.e.get(i);w instanceof l&&w._fireDidTriggerItemButton(n,h)}$onDidHide(i){this.e.get(i)?._fireDidHide()}}class y{constructor(i,n){this.x=i,this.y=n,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.Emitter,this.q=new R.Emitter,this.r=new R.Emitter,this.s=new R.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(i){this.b=i,this.z({title:i})}get step(){return this.c}set step(i){this.c=i,this.z({step:i})}get totalSteps(){return this.d}set totalSteps(i){this.d=i,this.z({totalSteps:i})}get enabled(){return this.g}set enabled(i){this.g=i,this.z({enabled:i})}get busy(){return this.j}set busy(i){this.j=i,this.z({busy:i})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(i){this.k=i,this.z({ignoreFocusOut:i})}get value(){return this.l}set value(i){this.l=i,this.z({value:i})}get placeholder(){return this.m}set placeholder(i){this.m=i,this.z({placeholder:i})}get buttons(){return this.n}set buttons(i){this.n=i.slice(),this.o.clear(),i.forEach((n,h)=>{const w=n===T.QuickInputButtons.Back?-1:h;this.o.set(w,n)}),this.z({buttons:i.map((n,h)=>({...r(n),tooltip:n.tooltip,handle:n===T.QuickInputButtons.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(i){this.l=i,this.q.fire(i)}_fireDidTriggerButton(i){const n=this.o.get(i);n&&this.r.fire(n)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,c.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),f.$dispose(this._id))}z(i){if(!this.v){for(const n of Object.keys(i)){const h=i[n];this.u[n]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){f.$createOrUpdate(this.u),this.u={id:this._id}}}y.a=1;function g(b){if(b instanceof T.ThemeIcon)return{id:b.id};const i=s(b),n=t(b);return{dark:typeof i=="string"?E.URI.file(i):i,light:typeof n=="string"?E.URI.file(n):n}}function t(b){return typeof b=="object"&&"light"in b?b.light:b}function s(b){return typeof b=="object"&&"dark"in b?b.dark:b}function r(b){const i=g(b.iconPath);let n,h;return"id"in i?h=A.ThemeIcon.asClassName(i):n=i,{iconPath:n,iconClass:h}}class l extends y{constructor(i,n){super(i.identifier,n),this.O=i,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.Emitter,this.L=[],this.M=new R.Emitter,this.N=new R.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(i){this.B=i.slice(),this.C.clear(),this.D.clear(),i.forEach((w,v)=>{this.C.set(v,w),this.D.set(w,v)});const n=(0,D.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),h=[];for(let w=0;w<i.length;w++){const v=i[w];v.kind===T.QuickPickItemKind.Separator?h.push({type:"separator",label:v.label}):(v.tooltip&&!n&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),h.push({handle:w,label:v.label,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,tooltip:n?k.MarkdownString.fromStrict(v.tooltip):void 0,buttons:v.buttons?.map((O,j)=>({...r(O),tooltip:O.tooltip,handle:j}))}))}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(i){this.E=i,this.z({canSelectMany:i})}get matchOnDescription(){return this.F}set matchOnDescription(i){this.F=i,this.z({matchOnDescription:i})}get matchOnDetail(){return this.G}set matchOnDetail(i){this.G=i,this.z({matchOnDetail:i})}get sortByLabel(){return this.H}set sortByLabel(i){this.H=i,this.z({sortByLabel:i})}get keepScrollPosition(){return this.I}set keepScrollPosition(i){this.I=i,this.z({keepScrollPosition:i})}get activeItems(){return this.J}set activeItems(i){this.J=i.filter(n=>this.D.has(n)),this.z({activeItems:this.J.map(n=>this.D.get(n))})}get selectedItems(){return this.L}set selectedItems(i){this.L=i.filter(n=>this.D.has(n)),this.z({selectedItems:this.L.map(n=>this.D.get(n))})}_fireDidChangeActive(i){const n=(0,I.coalesce)(i.map(h=>this.C.get(h)));this.J=n,this.K.fire(n)}_fireDidChangeSelection(i){const n=(0,I.coalesce)(i.map(h=>this.C.get(h)));this.L=n,this.M.fire(n)}_fireDidTriggerItemButton(i,n){const h=this.C.get(i);if(!h||!h.buttons||!h.buttons.length)return;const w=h.buttons[n];w&&this.N.fire({button:w,item:h})}}class u extends y{constructor(i,n){super(i.identifier,n),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(i){this.B=i,this.z({password:i})}get prompt(){return this.C}set prompt(i){this.C=i,this.z({prompt:i})}get valueSelection(){return this.D}set valueSelection(i){this.D=i,this.z({valueSelection:i})}get validationMessage(){return this.E}set validationMessage(i){this.E=i,i?typeof i=="string"?this.z({validationMessage:i,severity:N.default.Error}):this.z({validationMessage:i.message,severity:i.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new p(o,d)}e.createExtHostQuickOpen=C});var Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!R:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(ie):R?R.value:e.get(ie)},Je=this&&this.__classPrivateFieldSet||function(ie,e,a,R,c){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!c)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!c:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?c.call(ie,a):c?c.value=a:e.set(ie,a),a};define(De[273],Ce([1,0,2,3,62,6,19,5,15,108,13,25,52,14,27]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C){"use strict";var m,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(n){if(n)return typeof n.iconPath=="string"?a.URI.file(n.iconPath):a.URI.isUri(n.iconPath)||D.ThemeIcon.isThemeIcon(n.iconPath)?n.iconPath:void 0}function f(n,h){if(!n.iconPath&&!h.iconPath)return 0;if(n.iconPath){if(!h.iconPath)return 1}else return-1;const w=typeof n.iconPath=="string"?n.iconPath:a.URI.isUri(n.iconPath)?n.iconPath.fsPath:n.iconPath.id,v=typeof h.iconPath=="string"?h.iconPath:a.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,I.comparePaths)(w,v)}function p(n,h){let w=0;if(n.strikeThrough!==h.strikeThrough)return n.strikeThrough?1:-1;if(n.faded!==h.faded)return n.faded?1:-1;if(n.tooltip!==h.tooltip)return(n.tooltip||"").localeCompare(h.tooltip||"");if(w=f(n,h),w!==0)return w;if(n.light&&h.light)w=f(n.light,h.light);else{if(n.light)return 1;if(h.light)return-1}if(w!==0)return w;if(n.dark&&h.dark)w=f(n.dark,h.dark);else{if(n.dark)return 1;if(h.dark)return-1}return w}function y(n,h){if(n.command!==h.command)return n.command<h.command?-1:1;if(n.title!==h.title)return n.title<h.title?-1:1;if(n.tooltip!==h.tooltip){if(n.tooltip!==void 0&&h.tooltip!==void 0)return n.tooltip<h.tooltip?-1:1;if(n.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(n.arguments===h.arguments)return 0;if(n.arguments)if(h.arguments){if(n.arguments.length!==h.arguments.length)return n.arguments.length-h.arguments.length}else return 1;else return-1;for(let w=0;w<n.arguments.length;w++){const v=n.arguments[w],O=h.arguments[w];if(v!==O)return v<O?-1:1}return 0}function g(n,h){let w=(0,I.comparePaths)(n.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(w!==0)return w;if(n.command&&h.command)w=y(n.command,h.command);else{if(n.command)return 1;if(h.command)return-1}if(w!==0)return w;if(n.decorations&&h.decorations)w=p(n.decorations,h.decorations);else{if(n.decorations)return 1;if(h.decorations)return-1}return w}function t(n,h){for(let w=0;w<n.length;w++)if(n[w]!==h[w])return!1;return!0}function s(n,h){return n.command===h.command&&n.title===h.title&&n.tooltip===h.tooltip&&(n.arguments&&h.arguments?t(n.arguments,h.arguments):n.arguments===h.arguments)}function r(n,h){return(0,S.equals)(n,h,s)}class l{get value(){return this.d}set value(h){h=h??"",Ue(this,m,"f").$setInputBoxValue(this.l,h),this.m(h)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(h){Ue(this,m,"f").$setInputBoxPlaceholder(this.l,h),this.f=h}get validateInput(){return(0,C.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(h){if((0,C.checkProposedApiEnabled)(this.k,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=h,Ue(this,m,"f").$setValidationProviderIsEnabled(this.l,!!h)}get enabled(){return this.h}set enabled(h){h=!!h,this.h!==h&&(this.h=h,Ue(this,m,"f").$setInputBoxEnablement(this.l,h))}get visible(){return this.j}set visible(h){h=!!h,this.j!==h&&(this.j=h,Ue(this,m,"f").$setInputBoxVisibility(this.l,h))}constructor(h,w,v){this.k=h,this.l=v,m.set(this,void 0),this.d="",this.e=new R.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,m,w,"f")}showValidationMessage(h,w){(0,C.checkProposedApiEnabled)(this.k,"scmValidation"),Ue(this,m,"f").$showValidationMessage(this.l,h,w)}$onInputBoxValueChange(h){this.m(h)}m(h){this.d=h,this.e.fire(h)}}e.ExtHostSCMInputBox=l,m=new WeakMap;class u{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(h){this.v=h,this.q.$updateGroupLabel(this.t,this.handle,h)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(h){this.p=h,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(h){this.f=[...h],this.k.fire()}constructor(h,w,v,O,j){this.q=h,this.s=w,this.t=v,this.u=O,this.v=j,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new R.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=u.d++}getResourceState(h){return this.g.get(h)}$executeResourceCommand(h,w){const v=this.h.get(h);return v?(0,E.asPromise)(()=>this.s.executeCommand(v.command,...v.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this.f].sort(g),v=(0,S.sortedDiff)(this.o,h,g).map(V=>{const Q=V.toInsert.map(G=>{const U=this.e++;this.g.set(U,G);const P=G.resourceUri;let M;if(G.command)if(G.command.command==="vscode.open"||G.command.command==="vscode.diff"){const x=new L.DisposableStore;M=this.s.converter.toInternal(G.command,x),this.j.set(U,x)}else this.h.set(U,G.command);const B=d(G.decorations),Z=G.decorations&&d(G.decorations.light)||B,Y=G.decorations&&d(G.decorations.dark)||B,H=[Z,Y],_=G.decorations&&G.decorations.tooltip||"",ee=G.decorations&&!!G.decorations.strikeThrough,be=G.decorations&&!!G.decorations.faded,ce=G.contextValue||"";return{rawResource:[U,P,H,_,ee,be,ce,M],handle:U}});return{start:V.start,deleteCount:V.deleteCount,toInsert:Q}}),O=v.map(({start:V,deleteCount:Q,toInsert:G})=>[V,Q,G.map(U=>U.rawResource)]),j=v.reverse();for(const{start:V,deleteCount:Q,toInsert:G}of j){const U=G.map(M=>M.handle),P=this.n.splice(V,Q,...U);for(const M of P)this.g.delete(M),this.h.delete(M),this.j.get(M)?.dispose(),this.j.delete(M)}return this.o=h,O}dispose(){this.l=!0,this.m.fire()}}u.d=0;class b{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(h){this.g!==h&&(this.g=h,Ue(this,o,"f").$updateSourceControl(this.t,{count:h}))}get quickDiffProvider(){return this.h}set quickDiffProvider(h){this.h=h,h?.label&&(0,C.checkProposedApiEnabled)(this.u,"quickDiffProvider"),Ue(this,o,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!h,quickDiffLabel:h?.label})}get commitTemplate(){return this.j}set commitTemplate(h){h!==this.j&&(this.j=h,Ue(this,o,"f").$updateSourceControl(this.t,{commitTemplate:h}))}get acceptInputCommand(){return this.l}set acceptInputCommand(h){this.k.value=new L.DisposableStore,this.l=h;const w=this.v.converter.toInternal(h,this.k.value);Ue(this,o,"f").$updateSourceControl(this.t,{acceptInputCommand:w})}get actionButton(){return(0,C.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(h){(0,C.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new L.DisposableStore,this.n=h;const w=h!==void 0?{command:this.v.converter.toInternal(h.command,this.m.value),secondaryCommands:h.secondaryCommands?.map(v=>v.map(O=>this.v.converter.toInternal(O,this.m.value))),description:h.description,enabled:h.enabled}:void 0;Ue(this,o,"f").$updateSourceControl(this.t,{actionButton:w??null})}get statusBarCommands(){return this.p}set statusBarCommands(h){if(this.p&&h&&r(this.p,h))return;this.o.value=new L.DisposableStore,this.p=h;const w=(h||[]).map(v=>this.v.converter.toInternal(v,this.o.value));Ue(this,o,"f").$updateSourceControl(this.t,{statusBarCommands:w})}get selected(){return this.q}constructor(h,w,v,O,j,V){this.u=h,this.v=v,this.w=O,this.x=j,this.y=V,o.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.MutableDisposable,this.l=void 0,this.m=new L.MutableDisposable,this.o=new L.MutableDisposable,this.p=void 0,this.q=!1,this.s=new R.Emitter,this.onDidChangeSelection=this.s.event,this.t=b.d++,this.z=new Map,this.A=new Set,Je(this,o,w,"f"),this.f=new l(h,Ue(this,o,"f"),this.t),Ue(this,o,"f").$registerSourceControl(this.t,O,j,V)}createResourceGroup(h,w){const v=new u(Ue(this,o,"f"),this.v,this.t,h,w),O=R.Event.once(v.onDidDispose)(()=>this.z.delete(v));return this.z.set(v,O),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const h=[],w=[];for(const[v,O]of this.z){O.dispose();const j=v.onDidUpdateResourceStates(()=>{this.A.add(v),this.eventuallyUpdateResourceStates()});R.Event.once(v.onDidDispose)(()=>{this.A.delete(v),j.dispose(),this.e.delete(v.handle),Ue(this,o,"f").$unregisterGroup(this.t,v.handle)}),h.push([v.handle,v.id,v.label,v.features]);const V=v._takeResourceStateSnapshot();V.length>0&&w.push([v.handle,V]),this.e.set(v.handle,v)}Ue(this,o,"f").$registerGroups(this.t,h,w),this.z.clear()}eventuallyUpdateResourceStates(){const h=[];this.A.forEach(w=>{const v=w._takeResourceStateSnapshot();v.length!==0&&h.push([w.handle,v])}),h.length>0&&Ue(this,o,"f").$spliceResourceStates(this.t,h),this.A.clear()}getResourceGroup(h){return this.e.get(h)}setSelectionState(h){this.q=h,this.s.fire(h)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(h=>h.dispose()),Ue(this,o,"f").$unregisterSourceControl(this.t)}}o=new WeakMap,b.d=0,Ve([(0,c.debounce)(100)],b.prototype,"eventuallyAddResourceGroups",null),Ve([(0,c.debounce)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let i=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(h,w,v){this.l=w,this.m=v,this.g=new Map,this.h=new A.ExtensionIdentifierMap,this.j=new R.Emitter,this.e=h.getProxy(T.MainContext.MainThreadSCM),this.f=h.getProxy(T.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const j=this.g.get(O.sourceControlHandle);if(!j)return O;const V=j.getResourceGroup(O.groupHandle);return V?V.getResourceState(O.handle):O}else if(O&&O.$mid===4){const j=this.g.get(O.sourceControlHandle);return j?j.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const j=this.g.get(O.handle);return j||O}return O}})}createSourceControl(h,w,v,O){this.m.trace("ExtHostSCM#createSourceControl",h.identifier.value,w,v,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const j=on.d++,V=new b(h,this.e,this.l,w,v,O);this.g.set(j,V);const Q=this.h.get(h.identifier)||[];return Q.push(V),this.h.set(h.identifier,Q),V}getLastInputBox(h){this.m.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const w=this.h.get(h.identifier),v=w&&w[w.length-1];return v&&v.inputBox}$provideOriginalResource(h,w,v){const O=a.URI.revive(w);this.m.trace("ExtHostSCM#$provideOriginalResource",h,O.toString());const j=this.g.get(h);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,E.asPromise)(()=>j.quickDiffProvider.provideOriginalResource(O,v)).then(V=>V||null)}$onInputBoxValueChange(h,w){this.m.trace("ExtHostSCM#$onInputBoxValueChange",h);const v=this.g.get(h);return v&&v.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(h,w,v,O){this.m.trace("ExtHostSCM#$executeResourceCommand",h,w,v);const j=this.g.get(h);if(!j)return Promise.resolve(void 0);const V=j.getResourceGroup(w);return V?V.$executeResourceCommand(v,O):Promise.resolve(void 0)}$validateInput(h,w,v){this.m.trace("ExtHostSCM#$validateInput",h);const O=this.g.get(h);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,E.asPromise)(()=>O.inputBox.validateInput(w,v)).then(j=>{if(!j)return Promise.resolve(void 0);const V=k.MarkdownString.fromStrict(j.message);return V?Promise.resolve([V,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this.g.get(h)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=h,Promise.resolve(void 0)}};i.d=0,i=Ve([ze(2,N.ILogService)],i),e.ExtHostSCM=i}),define(De[98],Ce([1,0,5,3,4]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(T){this.b=new R.Emitter,this.onDidChangePassword=this.b.event,this.a=T.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,S){return this.a.$getPassword(T,S)}store(T,S,I){return this.a.$setPassword(T,S,I)}delete(T,S){return this.a.$deletePassword(T,S)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,c.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,R,c){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!c)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!c:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?c.call(ie,a):c?c.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!R:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(ie):R?R.value:e.get(ie)};define(De[274],Ce([1,0,7,5,181,6,14,9]),function(ie,e,a,R,c,L,E,T){"use strict";var S,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(C,m,o,d,f=a.StatusBarAlignment.Left,p){S.set(this,void 0),I.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new L.DisposableStore,Je(this,S,C,"f"),Je(this,I,m,"f"),this.c=N.a++,this.e=o,this.f=d,this.g=f,this.h=this.u(p)}u(C){if(!!(0,T.isNumber)(C))return C===Number.POSITIVE_INFINITY?Number.MAX_VALUE:C===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:C}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(C){this.k=C,this.v()}set name(C){this.m=C,this.v()}set tooltip(C){this.l=C,this.v()}set color(C){this.n=C,this.v()}set backgroundColor(C){C&&!N.b.has(C.id)&&(C=void 0),this.o=C,this.v()}set command(C){this.r?.fromApi!==C&&(this.p&&this.q.add(this.p),this.p=new L.DisposableStore,typeof C=="string"?this.r={fromApi:C,internal:Ue(this,I,"f").toInternal({title:"",command:C},this.p)}:C?this.r={fromApi:C,internal:Ue(this,I,"f").toInternal(C,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(C){this.t=C,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ue(this,S,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let C;this.e?this.f?C=`${this.e.identifier.value}.${this.f}`:C=this.e.identifier.value:C=this.f;let m;this.m?m=this.m:m=(0,c.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=N.b.get(this.o.id));const d=E.MarkdownString.fromStrict(this.l);Ue(this,S,"f").$setEntry(this.c,C,m,this.k,d,this.r?.internal,o,this.o,this.g===a.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}S=new WeakMap,I=new WeakMap,N.a=0,N.b=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=N;class A{constructor(C){this.b=[],this.a=C.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,c.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(C){const m={message:C};return this.b.unshift(m),this.c(),new a.Disposable(()=>{const o=this.b.indexOf(m);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class D{constructor(C,m){this.a=C.getProxy(R.MainContext.MainThreadStatusBar),this.b=m,this.c=new A(this)}createStatusBarEntry(C,m,o,d){return new N(this.a,this.b,C,m,o,d)}setStatusBarMessage(C,m){const o=this.c.setMessage(C);let d;return typeof m=="number"?d=setTimeout(()=>o.dispose(),m):typeof m<"u"&&m.then(()=>o.dispose(),()=>o.dispose()),new a.Disposable(()=>{o.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=D}),define(De[99],Ce([1,0,5,3,4]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(T,S){this.c=S,this.b=new R.Emitter,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,S){this.a.$registerExtensionStorageKeysToSync(T,S)}async initializeExtensionStorage(T,S,I){const N=await this.a.$initializeExtensionStorage(T,S);let A;return N&&(A=this.d(T,S,N)),A||I}setValue(T,S,I){return this.a.$setValue(T,S,I)}$acceptValue(T,S,I){const N=this.d(T,S,I);N&&this.b.fire({shared:T,key:S,value:N})}d(T,S,I){try{return JSON.parse(I)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${T}): ${N}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,c.createDecorator)("IExtHostStorage")}),define(De[79],Ce([1,0,4,26,13,78,2]),function(ie,e,a,R,c,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let T=class{constructor(I,N,A){this.d=N,this.f=A,this.a=I.workspace??void 0,this.b=I.environment,this.whenReady=this.h().then(D=>this.c=D)}async g(I){return E.URI.joinPath(this.b.workspaceStorageHome,I)}async h(){if(!this.a)return Promise.resolve(void 0);const I=this.a.id,N=await this.g(I);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(E.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:E.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(A){this.d.error("[ExtHostStorage]",A);return}}workspaceValue(I){if(this.c)return E.URI.joinPath(this.c,I.identifier.value)}globalValue(I){return E.URI.joinPath(this.b.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=Ve([ze(0,R.IExtHostInitDataService),ze(1,c.ILogService),ze(2,L.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(De[41],Ce([1,0,3,5,4,2,20,6,7,183,10,215,21,30,216,52,9,19,14]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,c.createDecorator)("IExtHostTerminalService");class p{constructor(i,n,h,w){this.k=i,this._id=n,this.l=h,this.m=w,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(O=>this.f=O);const v=this;this.value={get name(){return v.m||""},get processId(){return v.b},get creationOptions(){return v.l},get exitStatus(){return v.h},get state(){return v.j},sendText(O,j=!0){v.o(),v.k.$sendText(v._id,O,j)},show(O){v.o(),v.k.$show(v._id,O)},hide(){v.o(),v.k.$hide(v._id)},dispose(){v.a||(v.a=!0,v.k.$dispose(v._id))},get dimensions(){if(!(v.d===void 0||v.g===void 0))return{columns:v.d,rows:v.g}}}}async create(i,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:i.name,shellPath:(0,o.withNullAsUndefined)(i.shellPath),shellArgs:(0,o.withNullAsUndefined)(i.shellArgs),cwd:(0,o.withNullAsUndefined)(i.cwd),env:(0,o.withNullAsUndefined)(i.env),icon:(0,o.withNullAsUndefined)(l(i.iconPath)),color:m.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,o.withNullAsUndefined)(i.message),strictEnv:(0,o.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,o.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,o.withNullAsUndefined)(n?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,o.withNullAsUndefined)(n?.useShellEnvironment),location:n?.location||this.n(i.location,n?.resolvedExtHostIdentifier),isTransient:(0,o.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,n,h,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:h,color:m.ThemeColor.isThemeColor(w)?w.id:void 0,location:this.n(i,n),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(i,n){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&n?{parentTerminal:n}:"viewColumn"in i?{viewColumn:f.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus}:void 0:i}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(i){this.m=i}setExitStatus(i,n){this.h=Object.freeze({code:i,reason:n})}setDimensions(i,n){return i===this.d&&n===this.g||i===0||n===0?!1:(this.d=i,this.g=n,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(i){this.f?(this.f(i),this.f=void 0):this.b.then(n=>{n!==i&&(this.b=Promise.resolve(i))})}}e.ExtHostTerminal=p;class y{get onProcessReady(){return this.b.event}constructor(i){this.g=i,this.id=0,this.shouldPersist=!1,this.a=new a.Emitter,this.onProcessData=this.a.event,this.b=new a.Emitter,this.d=new a.Emitter,this.onDidChangeProperty=this.d.event,this.f=new a.Emitter,this.onProcessExit=this.f.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,n){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${n}`)}async start(){}shutdown(){this.g.close()}input(i){this.g.handleInput?.(i)}resize(i,n){this.g.setDimensions?.({columns:i,rows:n})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this.g.onDidWrite(n=>this.a.fire(n)),this.g.onDidClose?.((n=void 0)=>{this.f.fire(n===void 0?void 0:n)}),this.g.onDidOverrideDimensions?.(n=>{n&&this.d.fire({type:"overrideDimensions",value:{cols:n.columns,rows:n.rows}})}),this.g.onDidChangeName?.(n=>{this.d.fire({type:"title",value:n})}),this.g.open(i||void 0),i&&this.g.setDimensions?.(i),this.b.fire({pid:-1,cwd:""})}}let g=1,t=class extends T.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(i=>i.value)}get onDidWriteTerminalData(){return this.I.event}constructor(i,n){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new a.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new a.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new a.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new a.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new a.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new a.Emitter,this.onDidChangeShell=this.J.event,this.a=n.getProxy(R.MainContext.MainThreadTerminalService),this.s=new C.TerminalDataBufferer(this.a.$sendProcessData),this.I=new a.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(i),this.B({dispose:()=>{for(const[h,w]of this.g)w.shutdown(!0)}})}getDefaultShell(i){return(i?this.n:this.m)?.path||""}getDefaultShellArgs(i){return(i?this.n:this.m)?.args||[]}createExtensionTerminal(i,n){const h=new p(this.a,(0,k.generateUuid)(),i,i.name),w=new y(i.pty);return h.createExtensionTerminal(i.location,this.L(i,n).resolvedExtHostIdentifier,l(i.iconPath),u(i.color)).then(v=>{const O=this.M(v,w);this.h[v]=O}),this.f.push(h),h.value}L(i,n){if(n=n||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const h=i.location.parentTerminal;if(h){const w=this.f.find(v=>v.value===h);w&&(n.resolvedExtHostIdentifier=w._id)}}else i.location&&typeof i.location!="object"?n.location=i.location:n.location&&typeof n.location=="object"&&"splitActiveTerminal"in n.location&&(n.location={splitActiveTerminal:!0});return n}attachPtyToTerminal(i,n){if(!this.O(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const w=new y(n),v=this.M(i,w);this.h[i]=v}async $acceptActiveTerminalChanged(i){const n=this.b;if(i===null){this.b=void 0,n!==this.b&&this.F.fire(this.b);return}const h=this.O(i);h&&(this.b=h,n!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(i,n){const h=this.O(i);h&&this.I.fire({terminal:h.value,data:n})}async $acceptTerminalDimensions(i,n,h){const w=this.O(i);w&&w.setDimensions(n,h)&&this.G.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(i,n,h){this.g.get(i)?.resize(n,h)}async $acceptTerminalTitleChange(i,n){const h=this.O(i);h&&(h.name=n)}async $acceptTerminalClosed(i,n,h){const w=this.Q(this.f,i);if(w!==null){const v=this.f.splice(w,1)[0];v.setExitStatus(n,h),this.C.fire(v.value)}}$acceptTerminalOpened(i,n,h,w){if(n){const j=this.Q(this.f,n);if(j!==null){this.f[j]._id=i,this.D.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const v={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:L.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},O=new p(this.a,i,v,h);this.f.push(O),this.D.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(i,n){this.O(i)?._setProcessId(n)}async $startExtensionTerminal(i,n){const h=this.O(i);if(!h)return{message:(0,I.localize)(0,null,i)};h.isOpen||await new Promise(v=>{const O=this.onDidOpenTerminal(async j=>{j===h.value&&(O.dispose(),v())})});const w=this.g.get(i);w?w.startSendingEvents(n):this.j[i]={initialDimensions:n}}M(i,n){const h=new T.DisposableStore;h.add(n.onProcessReady(v=>this.a.$sendProcessReady(i,v.pid,v.cwd))),h.add(n.onDidChangeProperty(v=>this.a.$sendProcessProperty(i,v))),this.s.startBuffering(i,n.onProcessData),h.add(n.onProcessExit(v=>this.N(i,v))),this.g.set(i,n);const w=this.j[i];return w&&n instanceof y&&(n.startSendingEvents(w.initialDimensions),delete this.j[i]),h}$acceptProcessAckDataEvent(i,n){this.g.get(i)?.acknowledgeDataEvent(n)}$acceptProcessInput(i,n){this.g.get(i)?.input(n)}$acceptTerminalInteraction(i){const n=this.O(i);n?.setInteractedWith()&&this.H.fire(n.value)}$acceptProcessResize(i,n,h){try{this.g.get(i)?.resize(n,h)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(i,n){this.g.get(i)?.shutdown(n)}$acceptProcessRequestInitialCwd(i){this.g.get(i)?.getInitialCwd().then(n=>this.a.$sendProcessProperty(i,{type:"initialCwd",value:n}))}$acceptProcessRequestCwd(i){this.g.get(i)?.getCwd().then(n=>this.a.$sendProcessProperty(i,{type:"cwd",value:n}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this.u.add(i),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(i),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(i,n,h){if(this.v.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this.v.set(n,h),this.a.$registerProfileProvider(n,i.identifier.value),new S.Disposable(()=>{this.v.delete(n),this.a.$unregisterProfileProvider(n)})}registerTerminalQuickFixProvider(i,n,h){if(this.w.has(i))throw new Error(`Terminal quick fix provider "${i}" is already registered`);return this.w.set(i,h),this.a.$registerQuickFixProvider(i,n),new S.Disposable(()=>{this.w.delete(i),this.a.$unregisterQuickFixProvider(i)})}async $provideTerminalQuickFixes(i,n){const h=new D.CancellationTokenSource().token;if(h.isCancellationRequested)return;const w=this.w.get(i);if(!w)return;const v=await w.provideTerminalQuickFixes(n,h);if(v!==null)return v}async $createContributedProfileTerminal(i,n){const h=new D.CancellationTokenSource().token;let w=await this.v.get(i)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(w&&!("options"in w)&&(w={options:w}),!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,n);return}this.createTerminalFromOptions(w.options,n)}}async $provideLinks(i,n){const h=this.O(i);if(!h)return[];this.y.delete(i),this.z.get(i)?.dispose(!0);const v=new D.CancellationTokenSource;this.z.set(i,v);const O=[],j={terminal:h.value,line:n},V=[];for(const U of this.u)V.push(d.Promises.withAsyncBody(async P=>{v.token.onCancellationRequested(()=>P({provider:U,links:[]}));const M=await U.provideTerminalLinks(j,v.token)||[];v.token.isCancellationRequested||P({provider:U,links:M})}));const Q=await Promise.all(V);if(v.token.isCancellationRequested)return[];const G=new Map;for(const U of Q)U&&U.links.length>0&&O.push(...U.links.map(P=>{const M={id:g++,startIndex:P.startIndex,length:P.length,label:P.tooltip};return G.set(M.id,{provider:U.provider,link:P}),M}));return this.y.set(i,G),O}$activateLink(i,n){const h=this.y.get(i)?.get(n);!h||h.provider.handleTerminalLink(h.link)}N(i,n){this.s.stopBuffering(i),this.g.delete(i),delete this.j[i];const h=this.h[i];h&&(h.dispose(),delete this.h[i]),this.a.$sendProcessExit(i,n)}O(i){return this.P(this.f,i)}P(i,n){const h=this.Q(i,n);return h!==null?i[h]:null}Q(i,n){let h=null;return i.some((w,v)=>w._id===n?(h=v,!0):!1),h}getEnvironmentVariableCollection(i){let n=this.l.get(i.identifier.value);return n||(n=new s,this.S(i.identifier.value,n)),n}R(i,n){const h=(0,A.serializeEnvironmentVariableCollection)(n.map);this.a.$setEnvironmentVariableCollection(i,n.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(i){i.forEach(n=>{const h=n[0],w=new s(n[1]);this.S(h,w)})}$acceptDefaultProfile(i,n){const h=this.m;this.m=i,this.n=n,h?.path!==i.path&&this.J.fire(i.path)}S(i,n){this.l.set(i,n),n.onDidChangeCollection(()=>{this.R(i,n)})}};t=Ve([ze(1,E.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class s{get persistent(){return this.a}set persistent(i){this.a=i,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(i){this.map=new Map,this.a=!0,this.b=new a.Emitter,this.map=new Map(i)}get size(){return this.map.size}replace(i,n){this.d(i,{value:n,type:S.EnvironmentVariableMutatorType.Replace})}append(i,n){this.d(i,{value:n,type:S.EnvironmentVariableMutatorType.Append})}prepend(i,n){this.d(i,{value:n,type:S.EnvironmentVariableMutatorType.Prepend})}d(i,n){const h=this.map.get(i);(!h||h.value!==n.value||h.type!==n.type)&&(this.map.set(i,n),this.b.fire())}get(i){return this.map.get(i)}forEach(i,n){this.map.forEach((h,w)=>i.call(n,w,h,this))}[Symbol.iterator](){return this.map.entries()}delete(i){this.map.delete(i),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let r=class extends t{constructor(i){super(!1,i)}createTerminal(i,n,h){throw new N.NotSupportedError}createTerminalFromOptions(i,n){throw new N.NotSupportedError}};r=Ve([ze(0,E.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function l(b){if(!(!b||typeof b=="string"))return"id"in b?{id:b.id,color:b.color}:b}function u(b){return m.ThemeColor.isThemeColor(b)?b:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!R:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(ie):R?R.value:e.get(ie)},Je=this&&this.__classPrivateFieldSet||function(ie,e,a,R,c){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!c)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!c:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?c.call(ie,a):c?c.value=a:e.set(ie,a),a};define(De[275],Ce([1,0,15,19,22,21,3,63,88,6,23,9,30,5,20,138,14,7,57,94,75,27]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f,p,y,g){"use strict";var t,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(U,P,M){this.j=M,this.c=new E.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=U.getProxy(k.MainContext.MainThreadTesting),this.h=new j(this.f),this.g=new i(this.f),P.registerArgumentProcessor({processArgument:B=>{if(B?.$mid!==15)return B;const Z=B,Y=Z.tests[Z.tests.length-1].item.extId;return this.d.get(f.TestId.root(Y))?.collection.tree.get(Y)?.actual??(0,m.toItemFromContext)(B)}})}createTestController(U,P,M,B){if(this.d.has(P))throw new Error(`Attempt to insert a duplicate controller with ID "${P}"`);const Z=new I.DisposableStore,Y=Z.add(new m.ExtHostTestItemCollection(P,M,this.j));Y.root.label=M;const H=new Map,_=this.f,ee={items:Y.root.children,get label(){return M},set label(ce){M=ce,Y.root.label=ce,_.$updateController(P,{label:M})},get refreshHandler(){return B},set refreshHandler(ce){B=ce,_.$updateController(P,{canRefresh:!!ce})},get id(){return P},createRunProfile:(ce,oe,x,he,pe,Se)=>{let Re=(0,S.hash)(ce);for(;H.has(Re);)Re++;return Se!==void 0&&(0,g.checkProposedApiEnabled)(U,"testContinuousRun"),new V(this.f,H,P,Re,ce,oe,x,he,pe,Se)},createTestItem(ce,oe,x){return new m.TestItemImpl(P,ce,oe,x)},createTestRun:(ce,oe,x=!0)=>this.g.createTestRun(P,Y,ce,oe,x),set resolveHandler(ce){Y.resolveHandler=ce},get resolveHandler(){return Y.resolveHandler},dispose:()=>{Z.dispose()}};_.$registerTestController(P,M,!!B),Z.add((0,I.toDisposable)(()=>_.$unregisterTestController(P)));const be={controller:ee,collection:Y,profiles:H};return this.d.set(P,be),Z.add((0,I.toDisposable)(()=>this.d.delete(P))),Z.add(Y.onDidGenerateDiff(ce=>_.$publishDiff(P,ce.map(y.TestsDiffOp.serialize)))),ee}createTestObserver(){return this.h.checkout()}async runTests(U,P=L.CancellationToken.None){const M=n(U);if(!M)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.d.get(M.controllerId);if(!B)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(Z=>f.TestId.fromExtHostTestItem(Z,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:Q[M.kind],profileId:M.profileId,controllerId:M.controllerId}],exclude:U.exclude?.map(Z=>Z.id)},P)}$syncTests(){for(const{collection:U}of this.d.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,P,M){return(0,a.mapFind)(this.g.trackers,Z=>Z.id===U?Z.getCoverage(P):void 0)?.provideFileCoverage(M)??Promise.resolve([])}$resolveFileCoverage(U,P,M,B){return(0,a.mapFind)(this.g.trackers,Y=>Y.id===U?Y.getCoverage(P):void 0)?.resolveFileCoverage(M,B)??Promise.resolve([])}$configureRunProfile(U,P){this.d.get(U)?.profiles.get(P)?.configureHandler?.()}async $refreshTests(U,P){await this.d.get(U)?.controller.refreshHandler?.(P)}$publishTestResults(U){this.results=Object.freeze(U.map(P=>(0,N.deepFreeze)(o.TestResults.to(P))).concat(this.results).sort((P,M)=>M.completedAt-P.completedAt).slice(0,32)),this.c.fire()}async $expandTest(U,P){const M=this.d.get(f.TestId.fromString(U).controllerId)?.collection;M&&(await M.expand(U,P<0?1/0:P),M.flushDiff())}$acceptDiff(U){this.h.applyDiff(U.map(y.TestsDiffOp.deserialize))}async $runControllerTests(U,P){return Promise.all(U.map(M=>this.k(M,!1,P)))}async $startContinuousRun(U,P){const M=new L.CancellationTokenSource(P),B=await Promise.all(U.map(Z=>this.k(Z,!0,M.token)));return!P.isCancellationRequested&&!B.some(Z=>Z.error)&&await new Promise(Z=>P.onCancellationRequested(Z)),M.dispose(!0),B}async k(U,P,M){const B=this.d.get(U.controllerId);if(!B)return{};const{collection:Z,profiles:Y}=B,H=Y.get(U.profileId);if(!H)return{};const _=U.testIds.map(oe=>Z.tree.get(oe)).filter(A.isDefined),ee=U.excludeExtIds.map(oe=>B.collection.tree.get(oe)).filter(A.isDefined).filter(oe=>_.some(x=>x.fullId.compare(oe.fullId)===2));if(!_.length)return{};const be=new d.TestRunRequest2(_.some(oe=>oe.actual instanceof m.TestItemRootImpl)?void 0:_.map(oe=>oe.actual),ee.map(oe=>oe.actual),H,P),ce=(0,y.isStartControllerTests)(U)&&this.g.prepareForMainThreadTestRun(be,h.fromInternal(U,B.collection),M);try{return await H.runHandler(be,M),{}}catch(oe){return{error:String(oe)}}finally{ce&&(ce.hasRunningTasks&&!M.isCancellationRequested&&await E.Event.toPromise(ce.onEnd),ce.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.g.cancelAllRuns():this.g.cancelRunById(U)}};r=Ve([ze(0,C.IExtHostRpcService)],r),e.ExtHostTesting=r;const l=1e4;var u;(function(G){G[G.Running=0]="Running",G[G.Cancelling=1]="Cancelling",G[G.Ended=2]="Ended"})(u||(u={}));class b extends I.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(U,P,M){super(),this.k=U,this.l=P,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new E.Emitter),this.onEnd=this.j.event,this.h=this.B(new L.CancellationTokenSource(M));const B=this.B(new R.RunOnceScheduler(()=>this.m(),l));this.B(this.h.token.onCancellationRequested(()=>B.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const P=this.k.id,M=this.k.controllerId,B=(0,D.generateUuid)(),Z=new w(this.l,P,B),Y=be=>(ce,...oe)=>{if(_){console.warn(`Setting the state of test "${ce.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(ce)||(this.s(ce),be(ce,...oe))},H=(be,ce)=>{const oe=ce instanceof Array?ce.map(o.TestMessage.from):[o.TestMessage.from(ce)];if(be.uri&&be.range){const x={range:o.Range.from(be.range),uri:be.uri};for(const he of oe)he.location=he.location||x}this.l.$appendTestMessagesInRun(P,B,f.TestId.fromExtHostTestItem(be,M).toString(),oe)};let _=!1;const ee={isPersisted:this.k.isPersisted,token:this.h.token,name:U,get coverageProvider(){return Z.coverageProvider},set coverageProvider(be){Z.coverageProvider=be},enqueued:Y(be=>{this.l.$updateTestStateInRun(P,B,f.TestId.fromExtHostTestItem(be,M).toString(),1)}),skipped:Y(be=>{this.l.$updateTestStateInRun(P,B,f.TestId.fromExtHostTestItem(be,M).toString(),5)}),started:Y(be=>{this.l.$updateTestStateInRun(P,B,f.TestId.fromExtHostTestItem(be,M).toString(),2)}),errored:Y((be,ce,oe)=>{H(be,ce),this.l.$updateTestStateInRun(P,B,f.TestId.fromExtHostTestItem(be,M).toString(),6,oe)}),failed:Y((be,ce,oe)=>{H(be,ce),this.l.$updateTestStateInRun(P,B,f.TestId.fromExtHostTestItem(be,M).toString(),4,oe)}),passed:Y((be,ce)=>{this.l.$updateTestStateInRun(P,B,f.TestId.fromExtHostTestItem(be,this.k.controllerId).toString(),3,ce)}),appendOutput:(be,ce,oe)=>{_||(oe&&(this.k.isIncluded(oe)?this.s(oe):oe=void 0),this.l.$appendOutputToRun(P,B,c.VSBuffer.fromString(be),ce&&o.location.from(ce),oe&&f.TestId.fromExtHostTestItem(oe,M).toString()))},end:()=>{_||(_=!0,this.l.$finishedTestRunTask(P,B),this.f.delete(B),this.f.size||this.p())}};return this.f.set(B,{run:ee,coverage:Z}),this.l.$startedTestRunTask(P,{id:B,name:U,running:!0}),ee}m(){for(const{run:U}of this.f.values())U.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(U){if(!(U instanceof m.TestItemImpl))throw new p.InvalidTestItemError(U.id);if(this.g.has(f.TestId.fromExtHostTestItem(U,this.k.controllerId).toString()))return;const P=[],M=this.k.colllection.root;for(;;){const B=o.TestItem.from(U);if(P.unshift(B),this.g.has(B.extId)||(this.g.add(B.extId),U===M))break;U=U.parent||M}this.l.$addTestsToRun(this.k.controllerId,this.k.id,P)}}class i{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,P,M){return this.f(U,P,M)}cancelRunById(U){for(const P of this.c.values())if(P.id===U){P.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,P,M,B,Z){const Y=this.c.get(M);if(Y)return Y.createRun(B);const H=h.fromPublic(U,P,M,Z),_=n(M);this.d.$startedExtensionTestRun({controllerId:U,continuous:!!M.continuous,profile:_&&{group:Q[_.kind],id:_.profileId},exclude:M.exclude?.map(be=>f.TestId.fromExtHostTestItem(be,P.root.id).toString())??[],id:H.id,include:M.include?.map(be=>f.TestId.fromExtHostTestItem(be,P.root.id).toString())??[P.root.id],persist:Z});const ee=this.f(M,H);return ee.onEnd(()=>{this.d.$finishedExtensionTestRun(H.id),ee.dispose()}),ee.createRun(B)}f(U,P,M){const B=new b(P,this.d,M);return this.c.set(U,B),B.onEnd(()=>this.c.delete(U)),B}}e.TestRunCoordinator=i;const n=G=>{if(!!G.profile){if(!(G.profile instanceof V))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return G.profile}};class h{static fromPublic(U,P,M,B){return new h(U,(0,D.generateUuid)(),M.include?.map(Z=>f.TestId.fromExtHostTestItem(Z,U).toString())??[U],M.exclude?.map(Z=>f.TestId.fromExtHostTestItem(Z,U).toString())??[],B,P)}static fromInternal(U,P){return new h(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,P)}constructor(U,P,M,B,Z,Y){this.controllerId=U,this.id=P,this.isPersisted=Z,this.colllection=Y,this.c=M.map(H=>H+"\0"),this.d=B.map(H=>H+"\0")}isIncluded(U){const P=f.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const M of this.d)if(P===M||P.startsWith(M))return!1;for(const M of this.c)if(P===M||P.startsWith(M))return!0;return!1}}e.TestRunDto=h;class w{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,P,M){this.f=U,this.g=P,this.h=M}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(o.TestCoverage.fromFile)??[]}catch(P){throw this.d=void 0,P}}async resolveFileCoverage(U,P){const M=await this.d;let B=M?.[U];return!this.c||!M||!B?[]:(B.detailedCoverage||(B=M[U]=await this.c.resolveFileCoverage?.(B,P)??B),B.detailedCoverage?.map(o.TestCoverage.fromDetailed)??[])}}class v{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,o.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const P=f.TestId.parentId(U.item.extId);if(P&&this.g.has(P.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:P,f:M}=this;return{get added(){return[...U].map(B=>B.revived)},get updated(){return[...P].map(B=>B.revived)},get removed(){return[...M].map(B=>B.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class O extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new E.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,P){return{...U,revived:o.TestItem.toPlain(U.item),depth:P?P.depth+1:0,children:new Set}}o(){return new v(this.q)}}class j{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(P=>P.revived)},dispose:(0,T.once)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new O;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class V{get label(){return this.d}set label(U){U!==this.d&&(this.d=U,Ue(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,Ue(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,Ue(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Ue(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?o.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,Ue(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,P,M,B,Z,Y,H,_=!1,ee=void 0,be=!1){this.controllerId=M,this.profileId=B,this.d=Z,this.kind=Y,this.runHandler=H,this.f=_,this._tag=ee,this.g=be,t.set(this,void 0),s.set(this,void 0),Je(this,t,U,"f"),Je(this,s,P,"f"),P.set(B,this);const ce=Q[Y];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);Ue(this,t,"f").$publishTestRunProfile({profileId:B,controllerId:M,tag:ee?o.TestTag.namespace(this.controllerId,ee.id):null,label:Z,group:ce,isDefault:_,hasConfigurationHandler:!1,supportsContinuousRun:be})}dispose(){Ue(this,s,"f")?.delete(this.profileId)&&(Je(this,s,void 0,"f"),Ue(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=V,t=new WeakMap,s=new WeakMap;const Q={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(De[276],Ce([1,0,15,3,5,139,14,7]),function(ie,e,a,R,c,L,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(N,A){this.i=A,this.a=new R.Emitter,this.b=new R.Emitter,this.c=new R.Emitter,this.d=new R.Emitter,this.f=new R.Emitter,this.g=new R.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(c.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(D=>this.g.fire(D)),this.i.onDidChangeActiveTextEditor(D=>this.f.fire(D))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const A=this.i.allEditors();return N?A:A.map(D=>D.value)}async showTextDocument(N,A,D){let k;typeof A=="number"?k={position:E.ViewColumn.from(A),preserveFocus:D}:typeof A=="object"?k={position:E.ViewColumn.from(A.viewColumn),preserveFocus:A.preserveFocus,selection:typeof A.selection=="object"?E.Range.from(A.selection):void 0,pinned:typeof A.preview=="boolean"?!A.preview:void 0}:k={preserveFocus:!1};const C=await this.h.$tryShowTextDocument(N.uri,k),m=C&&this.i.getEditor(C);if(m)return m.value;throw C?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,A){return new L.TextEditorDecorationType(this.h,N,A).value}$acceptEditorPropertiesChanged(N,A){const D=this.i.getEditor(N);if(!D)throw new Error("unknown text editor");if(A.options&&D._acceptOptions(A.options),A.selections){const k=A.selections.selections.map(E.Selection.to);D._acceptSelections(k)}if(A.visibleRanges){const k=a.coalesce(A.visibleRanges.map(E.Range.to));D._acceptVisibleRanges(k)}if(A.options&&this.b.fire({textEditor:D.value,options:{...A.options,lineNumbers:E.TextEditorLineNumbersStyle.to(A.options.lineNumbers)}}),A.selections){const k=T.TextEditorSelectionChangeKind.fromValue(A.selections.source),C=A.selections.selections.map(E.Selection.to);this.a.fire({textEditor:D.value,selections:C,kind:k})}if(A.visibleRanges){const k=a.coalesce(A.visibleRanges.map(E.Range.to));this.c.fire({textEditor:D.value,visibleRanges:k})}}$acceptEditorPositionData(N){for(const A in N){const D=this.i.getEditor(A);if(!D)throw new Error("Unknown text editor");const k=E.ViewColumn.to(N[A]);D.value.viewColumn!==k&&(D._acceptViewColumn(k),this.d.fire({textEditor:D.value,viewColumn:k}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.ExtHostEditors=S}),define(De[277],Ce([1,0,2,4,5,6,7,14,25,9]),function(ie,e,a,R,c,L,E,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class N{constructor(k,C){this.b=new Map,this.c=new Map,this.a=k.getProxy(c.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:(m,o)=>{if(m&&m.$mid===12)if(this.b.get(m.source)&&S.ExtensionIdentifier.equals(o,this.b.get(m.source)?.extension)){const d=m.uri===void 0?void 0:a.URI.revive(m.uri);return this.c.get(m.source)?.get(A(d))?.get(m.handle)}else return;return m}})}async $getTimeline(k,C,m,o){return this.b.get(k)?.provider.provideTimeline(a.URI.revive(C),m,o)}registerTimelineProvider(k,C,m,o){const d=new L.DisposableStore,f=this.d(C.id,o,d).bind(this);let p;C.onDidChange&&(p=C.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:C.id}),this));const y=this.c;return this.f({...C,scheme:k,onDidChange:void 0,async provideTimeline(g,t,s){t?.resetCache&&(d.clear(),y.get(C.id)?.clear());const r=await C.provideTimeline(g,t,s);if(r==null)return;const l=f(g,t);return{...r,source:C.id,items:r.items.map(l)}},dispose(){for(const g of y.values())g.get(C.id)?.clear();p?.dispose(),d.dispose()}},m)}d(k,C,m){return(o,d)=>{let f;if(d?.cacheResults){let p=this.c.get(k);p===void 0&&(p=new Map,this.c.set(k,p));const y=A(o);f=p.get(y),f===void 0&&(f=new Map,p.set(y,f))}return p=>{const{iconPath:y,...g}=p,t=`${k}|${p.id??p.timestamp}`;f?.set(t,p);let s,r,l;p.iconPath&&(y instanceof E.ThemeIcon?l={id:y.id,color:y.color}:a.URI.isUri(y)?(s=y,r=y):{light:s,dark:r}=y);let u;return E.MarkdownString.isMarkdownString(g.tooltip)?u=T.MarkdownString.from(g.tooltip):(0,I.isString)(g.tooltip)?u=g.tooltip:E.MarkdownString.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=T.MarkdownString.from(g.detail)):(0,I.isString)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=g.detail),{...g,id:g.id??void 0,handle:t,source:k,command:p.command?C.toInternal(p.command,m):void 0,icon:s,iconDark:r,themeIcon:l,tooltip:u,accessibilityInformation:p.accessibilityInformation}}}}f(k,C){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:C}),(0,L.toDisposable)(()=>{for(const o of this.c.values())o.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.ExtHostTimeline=N;function A(D){return D?.toString()}}),define(De[278],Ce([1,0,6,16,2,5]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class E{constructor(S){this.c=new Map,this.b=S.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,I,N,A){if(this.c.has(I))throw new Error(`Opener with id '${I}' already registered`);const D=A.schemes.find(k=>!E.a.has(k));if(D)throw new Error(`Scheme '${D}' is not supported. Only http and https are currently supported.`);return this.c.set(I,N),this.b.$registerUriOpener(I,A.schemes,S,A.label),(0,a.toDisposable)(()=>{this.c.delete(I),this.b.$unregisterUriOpener(I)})}async $canOpenUri(S,I,N){const A=this.c.get(S);if(!A)throw new Error(`Unknown opener with id: ${S}`);const D=c.URI.revive(I);return A.canOpenExternalUri(D,N)}async $openUri(S,I,N){const A=this.c.get(S);if(!A)throw new Error(`Unknown opener id: '${S}'`);return A.openExternalUri(c.URI.revive(I.resolvedUri),{sourceUri:c.URI.revive(I.sourceUri)},N)}}E.a=new Set([R.Schemas.http,R.Schemas.https]),e.ExtHostUriOpeners=E}),define(De[279],Ce([1,0,5,2,6,10,25]),function(ie,e,a,R,c,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(I){this.c=new E.ExtensionIdentifierSet,this.d=new Map,this.b=I.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(I,N){if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const A=T.a++;return this.c.add(I),this.d.set(A,N),this.b.$registerUriHandler(A,I),(0,c.toDisposable)(()=>{this.c.delete(I),this.d.delete(A),this.b.$unregisterUriHandler(A)})}$handleExternalUri(I,N){const A=this.d.get(I);if(!A)return Promise.resolve(void 0);try{A.handleUri(R.URI.revive(N))}catch(D){(0,L.onUnexpectedError)(D)}return Promise.resolve(void 0)}async createAppUri(I){return R.URI.revive(await this.b.$createAppUri(I))}}T.a=0,e.ExtHostUrls=T});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,R,c){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!c)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!c:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?c.call(ie,a):c?c.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!R:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(ie):R?R.value:e.get(ie)};define(De[80],Ce([1,0,3,16,23,2,199,224,95,5]),function(ie,e,a,R,c,L,E,T,S,I){"use strict";var N,A,D,k,C,m,o,d,f,p,y,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(v,O,j,V,Q,G,U){N.set(this,void 0),A.set(this,void 0),D.set(this,void 0),k.set(this,void 0),C.set(this,void 0),m.set(this,void 0),o.set(this,""),d.set(this,void 0),f.set(this,!1),p.set(this,!1),y.set(this,void 0),g.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new a.Emitter),this._onDidDispose=Ue(this,t,"f").event,Je(this,N,v,"f"),Je(this,A,O,"f"),Je(this,d,j,"f"),Je(this,k,V,"f"),Je(this,C,Q,"f"),Je(this,m,G,"f"),Je(this,y,r(G),"f"),Je(this,g,l(G),"f"),Je(this,D,U,"f")}dispose(){Je(this,f,!0,"f"),Ue(this,t,"f").fire(),Ue(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return Je(this,p,!0,"f"),(0,S.asWebviewUri)(v,Ue(this,k,"f"))}get cspSource(){const v=Ue(this,m,"f").extensionLocation;if(v.scheme===R.Schemas.https||v.scheme===R.Schemas.http){let O=v.toString();return O.endsWith("/")||(O+="/"),O+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Ue(this,o,"f")}set html(v){this.a(),Ue(this,o,"f")!==v&&(Je(this,o,v,"f"),Ue(this,g,"f")&&!Ue(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(Je(this,p,!0,"f"),Ue(this,D,"f").report("Webview vscode-resource: uris",Ue(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,A,"f").$setHtml(Ue(this,N,"f"),this.b(v)))}get options(){return this.a(),Ue(this,d,"f")}set options(v){this.a(),c.equals(Ue(this,d,"f"),v)||Ue(this,A,"f").$setOptions(Ue(this,N,"f"),i(Ue(this,m,"f"),Ue(this,C,"f"),v)),Je(this,d,v,"f")}async postMessage(v){if(Ue(this,f,"f"))return!1;const O=(0,T.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Ue(this,y,"f")});return Ue(this,A,"f").$postMessage(Ue(this,N,"f"),O.message,...O.buffers)}a(){if(Ue(this,f,"f"))throw new Error("Webview is disposed")}b(v){if(!Ue(this,g,"f"))return v;const O=Ue(this,m,"f").extensionLocation?.scheme===R.Schemas.vscodeRemote,j=Ue(this,m,"f").extensionLocation.scheme===R.Schemas.vscodeRemote?Ue(this,m,"f").extensionLocation.authority:void 0;return v.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,Q,G,U,P,M)=>{const B=L.URI.from({scheme:U||"file",path:decodeURIComponent(P)}),Z=(0,S.asWebviewUri)(B,{isRemote:O,authority:j}).toString();return`${Q}${Z}${M}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,Q,G,U,P,M)=>{const B=L.URI.from({scheme:U||"file",path:decodeURIComponent(P)}),Z=(0,S.asWebviewUri)(B,{isRemote:O,authority:j}).toString();return`${Q}${Z}${M}`})}}e.ExtHostWebview=s,N=new WeakMap,A=new WeakMap,D=new WeakMap,k=new WeakMap,C=new WeakMap,m=new WeakMap,o=new WeakMap,d=new WeakMap,f=new WeakMap,p=new WeakMap,y=new WeakMap,g=new WeakMap,t=new WeakMap;function r(w){try{const v=(0,E.normalizeVersion)((0,E.parseVersion)(w.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function l(w){try{const v=(0,E.normalizeVersion)((0,E.parseVersion)(w.engines.vscode));return v?v.majorBase<1||v.majorBase===1&&v.minorBase<60:!1}catch{return!1}}class u{constructor(v,O,j,V,Q){this.c=O,this.d=j,this.e=V,this.f=Q,this.b=new Map,this.a=v.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(v,O,j){const V=this.g(v);if(V){const{message:Q}=(0,T.deserializeWebviewMessage)(O,j.value);V._onMessageEmitter.fire(Q)}}$onMissingCsp(v,O){this.e.warn(`${O} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,O,j){const V=new s(v,this.a,n(O),this.c,this.d,j,this.f);return this.b.set(v,V),V._onDidDispose(()=>{this.b.delete(v)}),V}deleteWebview(v){this.b.delete(v)}g(v){return this.b.get(v)}}e.ExtHostWebviews=u;function b(w){return{id:w.identifier,location:w.extensionLocation}}e.toExtensionData=b;function i(w,v,O){return{enableCommandUris:O.enableCommandUris,enableScripts:O.enableScripts,enableForms:O.enableForms,portMapping:O.portMapping,localResourceRoots:O.localResourceRoots||h(w,v)}}e.serializeWebviewOptions=i;function n(w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,enableForms:w.enableForms,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots?.map(v=>L.URI.from(v))}}function h(w,v){return[...(v?.getWorkspaceFolders()||[]).map(O=>O.uri),w.extensionLocation]}}),define(De[280],Ce([1,0,21,88,6,16,24,2,14,80,74,5,7]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class k{constructor(s,r){this.document=s,this.b=r,this.a=1,this.c=new N.Cache("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,r){await this.f(s).undo(),r||this.disposeBackup()}async redo(s,r){await this.f(s).redo(),r||this.disposeBackup()}disposeEdits(s){for(const r of s)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=g(this.document.uri)+this.a++;return(0,E.joinPath)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const r=this.c.get(s,0);if(!r)throw new Error("No edit found");return r}}class C{constructor(){this.a=new Map}get(s,r){return this.a.get(this.b(s,r))}add(s,r,l){const u=this.b(s,r.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${s} resource:${r.uri}`);const b=new k(r,l);return this.a.set(u,b),b}delete(s,r){const l=this.b(s,r.uri);this.a.delete(l)}b(s,r){return`${s}@@@${r}`}}var m;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(m||(m={}));class o{constructor(){this.a=new Map}addTextProvider(s,r,l){return this.b(0,s,r,l)}addCustomProvider(s,r,l){return this.b(1,s,r,l)}get(s){return this.a.get(s)}b(s,r,l,u){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:s,extension:l,provider:u}),new D.Disposable(()=>this.a.delete(r))}}class d{constructor(s,r,l,u,b){this.d=r,this.f=l,this.g=u,this.h=b,this.b=new o,this.c=new C,this.a=s.getProxy(A.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,r,l,u){const b=new c.DisposableStore;return p(l)?(b.add(this.b.addTextProvider(r,s,l)),this.a.$registerTextEditorProvider((0,I.toExtensionData)(s),r,u.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(s))):(b.add(this.b.addCustomProvider(r,s,l)),f(l)&&b.add(l.onDidChangeCustomDocument(i=>{const n=this.i(r,i.document.uri);if(y(i)){const h=n.addEdit(i);this.a.$onDidEdit(i.document.uri,r,h,i.label)}else this.a.$onContentChange(i.document.uri,r)})),this.a.$registerCustomEditorProvider((0,I.toExtensionData)(s),r,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(s))),D.Disposable.from(b,new D.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(s,r,l,u,b){const i=this.b.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${r}'`);const n=T.URI.revive(s),h=await i.provider.openCustomDocument(n,{backupId:l,untitledDocumentData:u?.buffer},b);let w;return f(i.provider)&&this.f&&(w=this.f.workspaceValue(i.extension)??this.f.globalValue(i.extension)),this.c.add(r,h,w),{editable:f(i.provider)}}async $disposeCustomDocument(s,r){const l=this.b.get(r);if(!l)throw new Error(`No provider found for '${r}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${r}'`);const u=T.URI.revive(s),{document:b}=this.i(r,u);this.c.delete(r,b),b.dispose()}async $resolveCustomEditor(s,r,l,u,b,i){const n=this.b.get(l);if(!n)throw new Error(`No provider found for '${l}'`);const h=S.ViewColumn.to(b),w=this.g.createNewWebview(r,u.contentOptions,n.extension),v=this.h.createNewWebviewPanel(r,l,u.title,h,u.options,w,!0),O=T.URI.revive(s);switch(n.type){case 1:{const{document:j}=this.i(l,O);return n.provider.resolveCustomEditor(j,v,i)}case 0:{const j=this.d.getDocument(O);return n.provider.resolveCustomTextEditor(j,v,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,r,l){this.i(r,s).disposeEdits(l)}async $onMoveCustomEditor(s,r,l){const u=this.b.get(l);if(!u)throw new Error(`No provider found for '${l}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const b=this.h.getWebviewPanel(s);if(!b)throw new Error("No webview found");const i=T.URI.revive(r),n=this.d.getDocument(i);await u.provider.moveCustomTextEditor(n,b,a.CancellationToken.None)}async $undo(s,r,l,u){return this.i(r,s).undo(l,u)}async $redo(s,r,l,u){return this.i(r,s).redo(l,u)}async $revert(s,r,l){const u=this.i(r,s);await this.j(r).revertCustomDocument(u.document,l),u.disposeBackup()}async $onSave(s,r,l){const u=this.i(r,s);await this.j(r).saveCustomDocument(u.document,l),u.disposeBackup()}async $onSaveAs(s,r,l,u){const b=this.i(r,s);return this.j(r).saveCustomDocumentAs(b.document,T.URI.revive(l),u)}async $backup(s,r,l){const u=this.i(r,s),i=await this.j(r).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},l);return u.updateBackup(i),i.id}i(s,r){const l=this.c.get(s,T.URI.revive(r));if(!l)throw new Error("No custom document found");return l}j(s){const l=this.b.get(s)?.provider;if(!l||!f(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=d;function f(t){return!!t.onDidChangeCustomDocument}function p(t){return typeof t.resolveCustomTextEditor=="function"}function y(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function g(t){const s=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,R.hash)(s)+""}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,R,c){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!c)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!c:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?c.call(ie,a):c?c.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!R:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(ie):R?R.value:e.get(ie)};define(De[281],Ce([1,0,3,6,2,30,14,80,5,7]),function(ie,e,a,R,c,L,E,T,S,I){"use strict";var N,A,D,k,C,m,o,d,f,p,y,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends R.Disposable{constructor(b,i,n,h){super(),N.set(this,void 0),A.set(this,void 0),D.set(this,void 0),k.set(this,void 0),C.set(this,void 0),m.set(this,void 0),o.set(this,void 0),d.set(this,void 0),f.set(this,!0),p.set(this,void 0),y.set(this,!1),g.set(this,this.B(new a.Emitter)),this.onDidDispose=Ue(this,g,"f").event,t.set(this,this.B(new a.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,Je(this,N,b,"f"),Je(this,A,i,"f"),Je(this,k,n,"f"),Je(this,D,h.viewType,"f"),Je(this,C,h.panelOptions,"f"),Je(this,d,h.viewColumn,"f"),Je(this,m,h.title,"f"),Je(this,p,h.active,"f")}dispose(){Ue(this,y,"f")||(Je(this,y,!0,"f"),Ue(this,g,"f").fire(),Ue(this,A,"f").$disposeWebview(Ue(this,N,"f")),Ue(this,k,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,k,"f")}get viewType(){return this.c(),Ue(this,D,"f")}get title(){return this.c(),Ue(this,m,"f")}set title(b){this.c(),Ue(this,m,"f")!==b&&(Je(this,m,b,"f"),Ue(this,A,"f").$setTitle(Ue(this,N,"f"),b))}get iconPath(){return this.c(),Ue(this,o,"f")}set iconPath(b){this.c(),Ue(this,o,"f")!==b&&(Je(this,o,b,"f"),Ue(this,A,"f").$setIconPath(Ue(this,N,"f"),c.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return Ue(this,C,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,d,"f")=="number"&&Ue(this,d,"f")<0))return Ue(this,d,"f")}get active(){return this.c(),Ue(this,p,"f")}get visible(){return this.c(),Ue(this,f,"f")}_updateViewState(b){Ue(this,y,"f")||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(Je(this,p,b.active,"f"),Je(this,f,b.visible,"f"),Je(this,d,b.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(b,i){this.c(),Ue(this,A,"f").$reveal(Ue(this,N,"f"),{viewColumn:typeof b>"u"?void 0:E.ViewColumn.from(b),preserveFocus:!!i})}c(){if(Ue(this,y,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,A=new WeakMap,D=new WeakMap,k=new WeakMap,C=new WeakMap,m=new WeakMap,o=new WeakMap,d=new WeakMap,f=new WeakMap,p=new WeakMap,y=new WeakMap,g=new WeakMap,t=new WeakMap;class r{static c(){return(0,L.generateUuid)()}constructor(b,i,n){this.g=i,this.h=n,this.e=new Map,this.f=new Map,this.d=b.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(b,i,n,h,w={}){const v=typeof h=="object"?h.viewColumn:h,O={viewColumn:E.ViewColumn.from(v),preserveFocus:typeof h=="object"&&!!h.preserveFocus},j=(0,T.shouldSerializeBuffersForPostMessage)(b),V=r.c();this.d.$createWebviewPanel((0,T.toExtensionData)(b),V,i,{title:n,panelOptions:l(w),webviewOptions:(0,T.serializeWebviewOptions)(b,this.h,w),serializeBuffersForPostMessage:j},O);const Q=this.g.createNewWebview(V,w,b);return this.createNewWebviewPanel(V,i,n,v,w,Q,!0)}$onDidChangeWebviewPanelViewStates(b){const i=Object.keys(b);i.sort((n,h)=>{const w=b[n],v=b[h];return w.active?1:v.active?-1:+w.visible-+v.visible});for(const n of i){const h=this.getWebviewPanel(n);if(!h)continue;const w=b[n];h._updateViewState({active:w.active,visible:w.visible,viewColumn:E.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.e.delete(b),this.g.deleteWebview(b)}registerWebviewPanelSerializer(b,i,n){if(this.f.has(i))throw new Error(`Serializer for '${i}' already registered`);return this.f.set(i,{serializer:n,extension:b}),this.d.$registerSerializer(i,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(b)}),new I.Disposable(()=>{this.f.delete(i),this.d.$unregisterSerializer(i)})}async $deserializeWebviewPanel(b,i,n,h){const w=this.f.get(i);if(!w)throw new Error(`No serializer found for '${i}'`);const{serializer:v,extension:O}=w,j=this.g.createNewWebview(b,n.webviewOptions,O),V=this.createNewWebviewPanel(b,i,n.title,h,n.panelOptions,j,n.active);await v.deserializeWebviewPanel(V,n.state)}createNewWebviewPanel(b,i,n,h,w,v,O){const j=new s(b,this.d,v,{viewType:i,title:n,viewColumn:h,panelOptions:w,active:O});return this.e.set(b,j),j}getWebviewPanel(b){return this.e.get(b)}}e.ExtHostWebviewPanels=r;function l(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,R,c){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!c)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!c:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?c.call(ie,a):c?c.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!R:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(ie):R?R.value:e.get(ie)};define(De[282],Ce([1,0,3,6,80,14,5,7]),function(ie,e,a,R,c,L,E,T){"use strict";var S,I,N,A,D,k,C,m,o,d,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends R.Disposable{constructor(t,s,r,l,u,b){super(),S.set(this,void 0),I.set(this,void 0),N.set(this,void 0),A.set(this,void 0),D.set(this,!1),k.set(this,void 0),C.set(this,void 0),m.set(this,void 0),o.set(this,void 0),d.set(this,this.B(new a.Emitter)),this.onDidChangeVisibility=Ue(this,d,"f").event,f.set(this,this.B(new a.Emitter)),this.onDidDispose=Ue(this,f,"f").event,Je(this,N,r,"f"),Je(this,C,l,"f"),Je(this,S,t,"f"),Je(this,I,s,"f"),Je(this,A,u,"f"),Je(this,k,b,"f")}dispose(){Ue(this,D,"f")||(Je(this,D,!0,"f"),Ue(this,f,"f").fire(),Ue(this,A,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,C,"f")}set title(t){this.a(),Ue(this,C,"f")!==t&&(Je(this,C,t,"f"),Ue(this,I,"f").$setWebviewViewTitle(Ue(this,S,"f"),t))}get description(){return this.a(),Ue(this,m,"f")}set description(t){this.a(),Ue(this,m,"f")!==t&&(Je(this,m,t,"f"),Ue(this,I,"f").$setWebviewViewDescription(Ue(this,S,"f"),t))}get visible(){return Ue(this,k,"f")}get webview(){return Ue(this,A,"f")}get viewType(){return Ue(this,N,"f")}_setVisible(t){t===Ue(this,k,"f")||Ue(this,D,"f")||(Je(this,k,t,"f"),Ue(this,d,"f").fire())}get badge(){return this.a(),Ue(this,o,"f")}set badge(t){this.a(),!(t?.value===Ue(this,o,"f")?.value&&t?.tooltip===Ue(this,o,"f")?.tooltip)&&(Je(this,o,L.ViewBadge.from(t),"f"),Ue(this,I,"f").$setWebviewViewBadge(Ue(this,S,"f"),t))}show(t){this.a(),Ue(this,I,"f").$show(Ue(this,S,"f"),!!t)}a(){if(Ue(this,D,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,I=new WeakMap,N=new WeakMap,A=new WeakMap,D=new WeakMap,k=new WeakMap,C=new WeakMap,m=new WeakMap,o=new WeakMap,d=new WeakMap,f=new WeakMap;class y{constructor(t,s){this.d=s,this.b=new Map,this.c=new Map,this.a=t.getProxy(E.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,s,r,l){if(this.b.has(s))throw new Error(`View provider for '${s}' already registered`);return this.b.set(s,{provider:r,extension:t}),this.a.$registerWebviewViewProvider((0,c.toExtensionData)(t),s,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,c.shouldSerializeBuffersForPostMessage)(t)}),new T.Disposable(()=>{this.b.delete(s),this.a.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(t,s,r,l,u){const b=this.b.get(s);if(!b)throw new Error(`No view provider found for '${s}'`);const{provider:i,extension:n}=b,h=this.d.createNewWebview(t,{},n),w=new p(t,this.a,s,r,h,!0);this.c.set(t,w),await i.resolveWebviewView(w,{state:l},u)}async $onDidChangeWebviewViewVisibility(t,s){this.e(t)._setVisible(s)}async $disposeWebviewView(t){const s=this.e(t);this.c.delete(t),s.dispose(),this.d.deleteWebview(t)}e(t){const s=this.c.get(t);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=y}),define(De[142],Ce([1,0,3,5,2,16,8,4,20]),function(ie,e,a,R,c,L,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class an{get state(){return this.d}constructor(A){this.c=new a.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=A.getProxy(R.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(D=>this.$onDidChangeWindowFocus(D))}$onDidChangeWindowFocus(A){A!==this.d.focused&&(this.d={...this.d,focused:A},this.c.fire(this.d))}openUri(A,D){let k;if(typeof A=="string"){k=A;try{A=c.URI.parse(A)}catch{return Promise.reject(`Invalid uri - '${A}'`)}}return(0,E.isFalsyOrWhitespace)(A.scheme)?Promise.reject("Invalid scheme - cannot be empty"):A.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${A.scheme}'`):this.b.$openUri(A,k,D)}async asExternalUri(A,D){if((0,E.isFalsyOrWhitespace)(A.scheme))return Promise.reject("Invalid scheme - cannot be empty");const k=await this.b.$asExternalUri(A,D);return c.URI.from(k)}};I.a={focused:!0},I=Ve([ze(0,S.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(De[283],Ce([1,0,119,284,70,40,2,13,48]),function(ie,e,a,R,c,L,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(D,k,C){this.b=D,this.c=k,this.f=C,this.a=R.createServer((m,o)=>this.h(m,o)),this.g().catch(m=>(k.error(m),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",D=>this.c.error(D))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(D,k){const C=(o,d)=>{k.writeHead(o,{"content-type":"application/json"}),k.end(JSON.stringify(d||null),f=>f&&this.c.error(f))},m=[];D.setEncoding("utf8"),D.on("data",o=>m.push(o)),D.on("end",async()=>{try{const o=JSON.parse(m.join(""));let d;switch(o.type){case"open":d=await this.i(o);break;case"openExternal":d=await this.j(o);break;case"status":d=await this.l(o);break;case"extensionManagement":d=await this.k(o);break;default:C(404,`Unknown message type: ${o.type}`);break}C(200,d)}catch(o){const d=o instanceof Error?o.message:JSON.stringify(o);C(500,d),this.c.error("Error while processing pipe request",o)}})}async i(D){const{fileURIs:k,folderURIs:C,forceNewWindow:m,diffMode:o,mergeMode:d,addMode:f,forceReuseWindow:p,gotoLineMode:y,waitMarkerFilePath:g,remoteAuthority:t}=D,s=[];if(Array.isArray(C))for(const b of C)try{s.push({folderUri:E.URI.parse(b)})}catch{}if(Array.isArray(k))for(const b of k)try{(0,S.hasWorkspaceFileExtension)(b)?s.push({workspaceUri:E.URI.parse(b)}):s.push({fileUri:E.URI.parse(b)})}catch{}const r=g?E.URI.file(g):void 0,u={forceNewWindow:m,diffMode:o,mergeMode:d,addMode:f,gotoLineMode:y,forceReuseWindow:p,preferNewWindow:!p&&!r&&!f,waitMarkerFileURI:r,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",s,u),""}async j(D){for(const k of D.uris){const C=E.URI.parse(k),m=C.scheme==="file"?C:k;await this.b.executeCommand("_remoteCLI.openExternal",m)}}async k(D){const k=m=>m?.map(o=>/\.vsix$/i.test(o)?E.URI.parse(o):o),C={list:D.list,install:k(D.install),uninstall:k(D.uninstall),force:D.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",C)}async l(D){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&c.existsSync(this.f)&&c.unlinkSync(this.f)}}e.CLIServerBase=I;let N=class extends I{constructor(D,k){super(D,k,(0,a.createRandomIPCHandle)())}};N=Ve([ze(0,L.IExtHostCommands),ze(1,T.ILogService)],N),e.CLIServer=N}),define(De[285],Ce([1,0,255,26,20]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const L=1024*1024;let E=class extends a.AbstractExtHostConsoleForwarder{constructor(S,I){super(S,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,I,N){const A=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,A.write(`
START_NATIVE_LOG
`),I.apply(console,N),A.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,I){const N=process[S],A=N.write;let D="";Object.defineProperty(N,"write",{set:()=>{},get:()=>(k,C,m)=>{if(!this.g){D+=k.toString(C);const o=D.length>L?D.length:D.lastIndexOf(`
`);o!==-1&&(console[I](D.slice(0,o)),D=D.slice(o+1))}A.call(N,k,C,m)}})}};E=Ve([ze(0,c.IExtHostRpcService),ze(1,R.IExtHostInitDataService)],E),e.ExtHostConsoleForwarder=E}),define(De[286],Ce([1,0,12,89,30,40,6,5,2,20]),function(ie,e,a,R,c,L,E,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let N=class extends E.Disposable{constructor(D,k){super();const C=D.getProxy(T.MainContext.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async m=>{const o=S.URI.file((0,a.join)((0,R.tmpdir)(),(0,c.generateUuid)()));return await C.$download(m,o),o})}};N=Ve([ze(0,I.IExtHostRpcService),ze(1,L.IExtHostCommands)],N),e.ExtHostDownloadService=N}),define(De[287],Ce([1,0,141,16,206,30]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class E extends a.ExtHostLoggerService{m(S,I,N){return S.scheme===R.Schemas.file?new c.SpdLogLogger(N?.name||(0,L.generateUuid)(),S.fsPath,!N?.donotRotate,!!N?.donotUseFormatters,I):super.m(S,I,N)}registerLogger(S){super.registerLogger(S),this.n.$registerLogger(S)}deregisterLogger(S){super.deregisterLogger(S),this.n.$deregisterLogger(S)}}e.ExtHostLoggerService=E}),define(De[288],Ce([1,0,70,12,2,79,6,16,19,29]),function(ie,e,a,R,c,L,E,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class N extends L.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(t){const s=await super.g(t);if(s.scheme!==T.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const r=s.fsPath;let l=0;do{let u;l===0?u=r:u=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${l}`:`${r}-${l}`,await A(u);const b=R.join(u,"vscode.lock"),i=await m(this.d,b,!1);if(i)return this.i=i,process.on("exit",()=>{i.dispose()}),c.URI.file(u);l++}while(l<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=N;async function A(g){try{await I.Promises.stat(g);return}catch{}try{await I.Promises.mkdir(g,{recursive:!0})}catch{}}const D=1e3,k=10*60*1e3;class C extends E.Disposable{constructor(t,s){super(),this.b=t,this.c=s,this.a=this.B(new S.IntervalTimer),this.a.cancelAndSet(async()=>{const r=await o(t,s);(!r||r.pid!==process.pid)&&(t.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await I.Promises.utimes(s,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${s}': Could not update mtime.`)}},D)}dispose(){super.dispose();try{a.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+t};await I.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function m(g,t,s){try{const l={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){g.error(l)}const r=await o(g,t);return!r||r.pid!==process.pid?s?(g.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),p(g,t)):(g.info(`Lock '${t}': Lock acquired.`),new C(g,t))}async function o(g,t){let s;try{s=await I.Promises.readFile(t)}catch(r){return g.error(r),null}try{return JSON.parse(String(s))}catch(r){return g.error(r),null}}async function d(g,t){let s;try{s=await I.Promises.stat(t)}catch(r){return g.error(r),0}return s.mtime.getTime()}function f(g){try{return process.kill(g,0),!0}catch{return!1}}async function p(g,t){const s=await o(g,t);if(!s)return g.info(`Lock '${t}': Could not read pid of lock holder.`),y(g,t);if(s.willReleaseAt){let i=s.willReleaseAt-Date.now();if(i<5e3){for(i>0?g.info(`Lock '${t}': The lockfile is scheduled to be released in ${i} ms.`):g.info(`Lock '${t}': The lockfile is scheduled to have been released.`);i>0;){if(await(0,S.timeout)(Math.min(100,i)),await d(g,t)===0)return y(g,t);i=s.willReleaseAt-Date.now()}return y(g,t)}}if(!f(s.pid))return g.info(`Lock '${t}': The pid ${s.pid} appears to be gone.`),y(g,t);const r=await d(g,t),l=Date.now()-r;if(l<=k)return g.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;g.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const u=await d(g,t),b=Date.now()-u;return b<=k?(g.info(`Lock '${t}': The lock does not look stale, elapsed: ${b} ms, giving up.`),null):(g.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),y(g,t))}async function y(g,t){g.info(`Lock '${t}': Deleting a stale lock.`);try{await I.Promises.unlink(t)}catch{}return m(g,t,!0)}}),define(De[289],Ce([1,0,30,20,41]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let L=class extends c.BaseExtHostTerminalService{constructor(T){super(!0,T)}createTerminal(T,S,I){return this.createTerminalFromOptions({name:T,shellPath:S,shellArgs:I})}createTerminalFromOptions(T,S){const I=new c.ExtHostTerminal(this.a,(0,a.generateUuid)(),T,T.name);return this.f.push(I),I.create(T,this.L(T,S)),I.value}};L=Ve([ze(0,R.IExtHostRpcService)],L),e.ExtHostTerminalService=L}),define(De[290],Ce([1,0,5,20,187,6,26,2,47,24,29,7,11,55,3,130,102,13]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class f extends m.DisposableTunnel{}function p(i){const n=i.trim().split(`
`),h=[];return n.forEach(v=>{const O=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(v);O&&O.length>=3&&h.push({pid:parseInt(O[1],10),socket:parseInt(O[2],10)})}),h.reduce((v,O)=>(v[O.socket]=O,v),{})}e.getSockets=p;function y(...i){const n=[].concat(...i.map(t));return[...new Map(n.filter(h=>h.st==="0A").map(h=>{const w=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:g(w[0]),port:parseInt(w[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=y;function g(i){let n="";if(i.length===8)for(let h=i.length-2;h>=0;h-=2)n+=parseInt(i.substr(h,2),16),h!==0&&(n+=".");else for(let h=i.length-4;h>=0;h-=4)n+=parseInt(i.substr(h,4),16).toString(16),h!==0&&(n+=":");return n}function t(i){const n=i.trim().split(`
`),h=n.shift().trim().split(/\s+/).filter(v=>v!=="rx_queue"&&v!=="tm->when");return n.map(v=>v.trim().split(/\s+/).reduce((O,j,V)=>(O[h[V]||V]=j,O),{}))}e.loadConnectionTable=t;function s(i){return!!i.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||i.indexOf("out/server-main.js")!==-1||i.indexOf("_productName=VSCode")!==-1}function r(i){const n=i.trim().split(`
`),h=[];return n.forEach(w=>{const v=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);v&&v.length>=4&&h.push({pid:parseInt(v[1],10),ppid:parseInt(v[2]),cmd:v[3]})}),h}e.getRootProcesses=r;async function l(i,n,h){const w=h.reduce((O,j)=>(O[j.pid]=j,O),{}),v=[];return i.forEach(({socket:O,ip:j,port:V})=>{const Q=n[O]?n[O].pid:void 0,G=Q?w[Q]?.cmd:void 0;Q&&G&&!s(G)&&v.push({host:j,port:V,detail:G,pid:Q})}),v}e.findPorts=l;function u(i,n,h){const w=new Map,v=r(n);for(const O of i){const j=h.get(O.port);if(j){w.set(O.port,j);continue}const V=v.find(Q=>Q.cmd.includes(`${O.port}`));if(V){let Q=V,G;do G=v.find(U=>U.ppid===Q.pid),G&&(Q=G);while(G);w.set(O.port,{host:O.ip,port:O.port,pid:Q.pid,detail:Q.cmd,ppid:Q.ppid})}else w.set(O.port,{host:O.ip,port:O.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=u;let b=class extends L.Disposable{constructor(n,h,w){super(),this.n=w,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new C.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=n.getProxy(a.MainContext.MainThreadTunnelService),D.isLinux&&h.remote.isRemote&&h.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(n,h){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${n.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const w=await this.a.$openTunnel(h,n.displayName);if(w){const v=new f(w.remoteAddress,w.localAddress,()=>this.a.$closeTunnel(w.remoteAddress));return this.B(v),v}}async getTunnels(){return this.a.$getTunnels()}p(n){return Math.max(n*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(n,h){const w=this.r();return this.l.set(w,{selector:n,provider:h}),this.a.$registerPortsAttributesProvider(n,w),new A.Disposable(()=>{this.l.delete(w),this.a.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(n,h,w,v,O){const j=[];for(const Q of n){const G=this.l.get(Q);if(!G)return[];j.push(...await Promise.all(h.map(async U=>G.provider.providePortAttributes(U,w,v,O))))}const V=j.filter(Q=>!!Q);return V.length>0?V.map(Q=>({autoForwardAction:Q.autoForwardAction,port:Q.port})):[]}async $registerCandidateFinder(n){if(n&&this.h)return;this.h=n;const h=new o.MovingAverage;let w;for(;this.h;){const v=new Date().getTime(),O=(await this.findCandidatePorts()).filter(V=>(0,m.isLocalhost)(V.host)||(0,m.isAllInterfaces)(V.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(V=>V.port).join(", ")}`);const j=new Date().getTime()-v;h.update(j),(!w||JSON.stringify(w)!==JSON.stringify(O))&&(w=O,await this.a.$onFoundNewCandidates(w)),await new Promise(V=>setTimeout(()=>V(),this.p(h.value)))}}async setTunnelFactory(n){if(n){if(n.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(n.candidatePortSource),n.showCandidatePort&&(this.c=n.showCandidatePort,this.a.$setCandidateFilter()),n.tunnelFactory){this.b=n.tunnelFactory;let h=n.tunnelFeatures?.privacyOptions??[];n.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:c.localize(0,null),themeIcon:"lock"},{id:"public",label:c.localize(1,null),themeIcon:"eye"}]);const w=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,public:!!n.tunnelFeatures?.public,privacyOptions:h}:void 0;this.a.$setTunnelProvider(w)}}else this.b=void 0;return(0,L.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(n,h){if(this.f.has(n.host)){const w=this.f.get(n.host);w.has(n.port)&&(h&&w.get(n.port).disposeListener.dispose(),await w.get(n.port).tunnel.dispose(),w.delete(n.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(n,h){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this.b(n,h);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const v=await w;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(n.remoteAddress.host)||this.f.set(n.remoteAddress.host,new Map);const O=this.B(v.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(v.remoteAddress))));return this.f.get(n.remoteAddress.host).set(n.remoteAddress.port,{tunnel:v,disposeListener:O}),k.TunnelDtoConverter.fromApiTunnel(v)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(n){const h=await Promise.all(n.map(v=>this.c(v.host,v.port,v.detail??""))),w=n.filter((v,O)=>h[O]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${n.map(v=>v.port).join(", ")} to ${w.map(v=>v.port).join(", ")}`),w}async findCandidatePorts(){let n="",h="";try{n=await N.Promises.readFile("/proc/net/tcp","utf8"),h=await N.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=y(n,h),v=await new Promise(M=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(B,Z,Y)=>{M(Z)})}),O=p(v),j=await N.Promises.readdir("/proc"),V=[];for(const M of j)try{const B=Number(M),Z=I.joinPath(T.URI.file("/proc"),M);if((await N.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(B)){const H=await N.Promises.readlink(I.joinPath(Z,"cwd").fsPath),_=await N.Promises.readFile(I.joinPath(Z,"cmdline").fsPath,"utf8");V.push({pid:B,cwd:H,cmd:_})}}catch{}const Q=[],G=w.filter(M=>{const B=O[M.socket];return B||Q.push(M),B}),U=l(G,O,V);let P;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${Q.length}`),Q.length>0){const M=await new Promise(B=>{(0,S.exec)("ps -F -A -l | grep root",(Z,Y,H)=>{B(Y)})});this.j=u(Q,M,this.j),P=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${P.map(B=>B.port).join(", ")}`)}return U.then(M=>P?M.concat(P):M)}};b=Ve([ze(0,R.IExtHostRpcService),ze(1,E.IExtHostInitDataService),ze(2,d.ILogService)],b),e.ExtHostTunnelService=b}),define(De[291],Ce([1,0,19,22,21,10,3,6,114,249,58]),function(ie,e,a,R,c,L,E,T,S,I,N){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function D(w,v){try{return JSON.stringify(w,v)}catch{return"null"}}const k="$$ref$$",C={[k]:-1};class m{constructor(v,O){this.jsonString=v,this.referencedBuffers=O}}function o(w,v=null,O=!1){const j=[];return{jsonString:(O?D:JSON.stringify)(w,(Q,G)=>{if(typeof G>"u")return C;if(typeof G=="object"){if(G instanceof R.VSBuffer){const U=j.push(G)-1;return{[k]:U}}if(v)return v(Q,G)}return G}),referencedBuffers:j}}e.stringifyJsonWithBufferRefs=o;function d(w,v,O){return JSON.parse(w,(j,V)=>{if(V){const Q=V[k];if(typeof Q=="number")return v[Q];if(O&&V.$mid===1)return O.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=d;function f(w,v){return JSON.stringify(w,v)}function p(w){return w?(v,O)=>O&&O.$mid===1?w.transformOutgoing(O):O:null}var y;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},s=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class l extends T.Disposable{constructor(v,O=null,j=null){super(),this[A]=!0,this.b=this.B(new E.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=v,this.f=O,this.g=j,this.h=p(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,Q=N.ProxyIdentifier.count;V<Q;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new a.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(v=>{this.s[v].resolveErr(L.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(v){this.u===0&&(this.v=Date.now()+l.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(v){this.v=Date.now()+l.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(v){this.t!==v&&(this.t=v,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(v){return this.g?(0,S.transformIncomingURIs)(v,this.g):v}getProxy(v){const{nid:O,sid:j}=v;return this.l[O]||(this.l[O]=this.F(O,j)),this.l[O]}F(v,O){const j={get:(V,Q)=>(typeof Q=="string"&&!V[Q]&&Q.charCodeAt(0)===36&&(V[Q]=(...G)=>this.O(v,Q,G)),Q===r?O:V[Q])};return new Proxy(Object.create(null),j)}set(v,O){return this.k[v.nid]=O,O}assertRegistered(v){for(let O=0,j=v.length;O<j;O++){const V=v[O];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(v){if(this.j)return;const O=v.byteLength,j=u.read(v,0),V=j.readUInt8(),Q=j.readUInt32();switch(V){case 1:case 2:{let{rpcId:G,method:U,args:P}=i.deserializeRequestJSONArgs(j);this.g&&(P=(0,S.transformIncomingURIs)(P,this.g)),this.H(O,Q,G,U,P,V===2);break}case 3:case 4:{let{rpcId:G,method:U,args:P}=i.deserializeRequestMixedArgs(j);this.g&&(P=(0,S.transformIncomingURIs)(P,this.g)),this.H(O,Q,G,U,P,V===4);break}case 5:{this.f?.logIncoming(O,Q,0,"ack"),this.z(Q);break}case 6:{this.I(O,Q);break}case 7:{this.J(O,Q,void 0);break}case 9:{let G=i.deserializeReplyOKJSON(j);this.g&&(G=(0,S.transformIncomingURIs)(G,this.g)),this.J(O,Q,G);break}case 10:{const G=i.deserializeReplyOKJSONWithBuffers(j,this.g);this.J(O,Q,G);break}case 8:{const G=i.deserializeReplyOKVSBuffer(j);this.J(O,Q,G);break}case 11:{let G=i.deserializeReplyErrError(j);this.g&&(G=(0,S.transformIncomingURIs)(G,this.g)),this.L(O,Q,G);break}case 12:{this.L(O,Q,void 0);break}default:console.error("received unexpected message"),console.error(v)}}H(v,O,j,V,Q,G){this.f?.logIncoming(v,O,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(j)}.${V}(`,Q);const U=String(O);let P,M;if(G){const Z=new c.CancellationTokenSource;Q.push(Z.token),P=this.M(j,V,Q),M=()=>Z.cancel()}else P=this.M(j,V,Q),M=t;this.p[U]=M;const B=i.serializeAcknowledged(O);this.f?.logOutgoing(B.byteLength,O,1,"ack"),this.c.send(B),P.then(Z=>{delete this.p[U];const Y=i.serializeReplyOK(O,Z,this.h);this.f?.logOutgoing(Y.byteLength,O,1,"reply:",Z),this.c.send(Y)},Z=>{delete this.p[U];const Y=i.serializeReplyErr(O,Z);this.f?.logOutgoing(Y.byteLength,O,1,"replyErr:",Z),this.c.send(Y)})}I(v,O){this.f?.logIncoming(v,O,1,"receiveCancel");const j=String(O);this.p[j]?.()}J(v,O,j){this.f?.logIncoming(v,O,0,"receiveReply:",j);const V=String(O);if(!this.s.hasOwnProperty(V))return;const Q=this.s[V];delete this.s[V],Q.resolveOk(j)}L(v,O,j){this.f?.logIncoming(v,O,0,"receiveReplyErr:",j);const V=String(O);if(!this.s.hasOwnProperty(V))return;const Q=this.s[V];delete this.s[V];let G;j&&(j.$isError?(G=new Error,G.name=j.name,G.message=j.message,G.stack=j.stack):G=j),Q.resolveErr(G)}M(v,O,j){try{return Promise.resolve(this.N(v,O,j))}catch(V){return Promise.reject(V)}}N(v,O,j){const V=this.k[v];if(!V)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(v));const Q=V[O];if(typeof Q!="function")throw new Error("Unknown method "+O+" on actor "+(0,N.getStringIdentifierForProxy)(v));return Q.apply(V,j)}O(v,O,j){if(this.j)return new I.CanceledLazyPromise;let V=null;if(j.length>0&&c.CancellationToken.isCancellationToken(j[j.length-1])&&(V=j.pop()),V&&V.isCancellationRequested)return Promise.reject(L.canceled());const Q=i.serializeRequestArguments(j,this.h),G=++this.m,U=String(G),P=new I.LazyPromise;V&&V.onCancellationRequested(()=>{const B=i.serializeCancel(G);this.f?.logOutgoing(B.byteLength,G,0,"cancel"),this.c.send(i.serializeCancel(G))}),this.s[U]=P,this.y(G);const M=i.serializeRequest(G,v,O,Q,!!V);return this.f?.logOutgoing(M.byteLength,G,0,`request: ${(0,N.getStringIdentifierForProxy)(v)}.${O}(`,j),this.c.send(M),P}}A=s,l.a=3*1e3,e.RPCProtocol=l;class u{static alloc(v,O,j){const V=new u(R.VSBuffer.alloc(j+1+4),0);return V.writeUInt8(v),V.writeUInt32(O),V}static read(v,O){return new u(v,O)}get buffer(){return this.a}constructor(v,O){this.a=v,this.b=O}static sizeUInt8(){return 1}writeUInt8(v){this.a.writeUInt8(v,this.b),this.b+=1}readUInt8(){const v=this.a.readUInt8(this.b);return this.b+=1,v}writeUInt32(v){this.a.writeUInt32BE(v,this.b),this.b+=4}readUInt32(){const v=this.a.readUInt32BE(this.b);return this.b+=4,v}static sizeShortString(v){return 1+v.byteLength}writeShortString(v){this.a.writeUInt8(v.byteLength,this.b),this.b+=1,this.a.set(v,this.b),this.b+=v.byteLength}readShortString(){const v=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+v).toString();return this.b+=v,j}static sizeLongString(v){return 4+v.byteLength}writeLongString(v){this.a.writeUInt32BE(v.byteLength,this.b),this.b+=4,this.a.set(v,this.b),this.b+=v.byteLength}readLongString(){const v=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+v).toString();return this.b+=v,j}writeBuffer(v){this.a.writeUInt32BE(v.byteLength,this.b),this.b+=4,this.a.set(v,this.b),this.b+=v.byteLength}static sizeVSBuffer(v){return 4+v.byteLength}writeVSBuffer(v){this.a.writeUInt32BE(v.byteLength,this.b),this.b+=4,this.a.set(v,this.b),this.b+=v.byteLength}readVSBuffer(){const v=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+v);return this.b+=v,O}static sizeMixedArray(v){let O=0;O+=1;for(let j=0,V=v.length;j<V;j++){const Q=v[j];switch(O+=1,Q.type){case 1:O+=this.sizeLongString(Q.value);break;case 2:O+=this.sizeVSBuffer(Q.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(Q.value);for(let G=0;G<Q.buffers.length;++G)O+=this.sizeVSBuffer(Q.buffers[G]);break;case 4:break}}return O}writeMixedArray(v){this.a.writeUInt8(v.length,this.b),this.b+=1;for(let O=0,j=v.length;O<j;O++){const V=v[O];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let Q=0;Q<V.buffers.length;++Q)this.writeBuffer(V.buffers[Q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const v=this.a.readUInt8(this.b);this.b+=1;const O=new Array(v);for(let j=0;j<v;j++)switch(this.readUInt8()){case 1:O[j]=this.readLongString();break;case 2:O[j]=this.readVSBuffer();break;case 3:{const Q=this.readUInt32(),G=this.readLongString(),U=[];for(let P=0;P<Q;++P)U.push(this.readVSBuffer());O[j]=new N.SerializableObjectWithBuffers(d(G,U,null));break}case 4:O[j]=void 0;break}return O}}u.sizeUInt32=4;var b;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(b||(b={}));class i{static a(v){for(let O=0,j=v.length;O<j;O++)if(v[O]instanceof R.VSBuffer||v[O]instanceof N.SerializableObjectWithBuffers||typeof v[O]>"u")return!0;return!1}static serializeRequestArguments(v,O){if(this.a(v)){const j=[];for(let V=0,Q=v.length;V<Q;V++){const G=v[V];if(G instanceof R.VSBuffer)j[V]={type:2,value:G};else if(typeof G>"u")j[V]={type:4};else if(G instanceof N.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:P}=o(G.value,O);j[V]={type:3,value:R.VSBuffer.fromString(U),buffers:P}}else j[V]={type:1,value:R.VSBuffer.fromString(f(G,O))}}return{type:1,args:j}}return{type:0,args:f(v,O)}}static serializeRequest(v,O,j,V,Q){switch(V.type){case 0:return this.b(v,O,j,V.args,Q);case 1:return this.c(v,O,j,V.args,Q)}}static b(v,O,j,V,Q){const G=R.VSBuffer.fromString(j),U=R.VSBuffer.fromString(V);let P=0;P+=u.sizeUInt8(),P+=u.sizeShortString(G),P+=u.sizeLongString(U);const M=u.alloc(Q?2:1,v,P);return M.writeUInt8(O),M.writeShortString(G),M.writeLongString(U),M.buffer}static deserializeRequestJSONArgs(v){const O=v.readUInt8(),j=v.readShortString(),V=v.readLongString();return{rpcId:O,method:j,args:JSON.parse(V)}}static c(v,O,j,V,Q){const G=R.VSBuffer.fromString(j);let U=0;U+=u.sizeUInt8(),U+=u.sizeShortString(G),U+=u.sizeMixedArray(V);const P=u.alloc(Q?4:3,v,U);return P.writeUInt8(O),P.writeShortString(G),P.writeMixedArray(V),P.buffer}static deserializeRequestMixedArgs(v){const O=v.readUInt8(),j=v.readShortString(),V=v.readMixedArray(),Q=new Array(V.length);for(let G=0,U=V.length;G<U;G++){const P=V[G];typeof P=="string"?Q[G]=JSON.parse(P):Q[G]=P}return{rpcId:O,method:j,args:Q}}static serializeAcknowledged(v){return u.alloc(5,v,0).buffer}static serializeCancel(v){return u.alloc(6,v,0).buffer}static serializeReplyOK(v,O,j){if(typeof O>"u")return this.d(v);if(O instanceof R.VSBuffer)return this.e(v,O);if(O instanceof N.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:Q}=o(O.value,j,!0);return this.g(v,V,Q)}else return this.f(v,D(O,j))}static d(v){return u.alloc(7,v,0).buffer}static e(v,O){let j=0;j+=u.sizeVSBuffer(O);const V=u.alloc(8,v,j);return V.writeVSBuffer(O),V.buffer}static deserializeReplyOKVSBuffer(v){return v.readVSBuffer()}static f(v,O){const j=R.VSBuffer.fromString(O);let V=0;V+=u.sizeLongString(j);const Q=u.alloc(9,v,V);return Q.writeLongString(j),Q.buffer}static g(v,O,j){const V=R.VSBuffer.fromString(O);let Q=0;Q+=u.sizeUInt32,Q+=u.sizeLongString(V);for(const U of j)Q+=u.sizeVSBuffer(U);const G=u.alloc(10,v,Q);G.writeUInt32(j.length),G.writeLongString(V);for(const U of j)G.writeBuffer(U);return G.buffer}static deserializeReplyOKJSON(v){const O=v.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(v,O){const j=v.readUInt32(),V=v.readLongString(),Q=[];for(let G=0;G<j;++G)Q.push(v.readVSBuffer());return new N.SerializableObjectWithBuffers(d(V,Q,O))}static serializeReplyErr(v,O){const j=O?D(L.transformErrorForSerialization(O),null):void 0;if(typeof j!="string")return this.h(v);const V=R.VSBuffer.fromString(j);let Q=0;Q+=u.sizeLongString(V);const G=u.alloc(11,v,Q);return G.writeLongString(V),G.buffer}static deserializeReplyErrError(v){const O=v.readLongString();return JSON.parse(O)}static h(v){return u.alloc(12,v,0).buffer}}var n;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(n||(n={}));var h;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(h||(h={}))}),define(De[292],Ce([1,0,3,39,46,4]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new c.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new c.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new c.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)("outputService");var E;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(E=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new a.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new a.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(I){this.a.has(I.id)||(this.a.set(I.id,I),this.b.fire(I.id))}getChannels(){const I=[];return this.a.forEach(N=>I.push(N)),I}getChannel(I){return this.a.get(I)}removeChannel(I){this.a.delete(I),this.c.fire(I)}}R.Registry.add(e.Extensions.OutputChannels,new T),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new c.RawContextKey("activeOutputChannel","")}),define(De[143],Ce([1,0,5,4,20,25,13,292,78,26,49,159,22,9,44,3,6]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class d extends E.AbstractMessageLogger{get disposed(){return this.l}constructor(g,t,s,r,l){super(),this.id=g,this.name=t,this.m=s,this.n=r,this.extension=l,this.k=0,this.l=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(g){this.append(g+`
`)}append(g){this.info(g)}clear(){const g=this.k;this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Clear,g)}replace(g){const t=this.k;this.info(g),this.n.$update(this.id,T.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(g,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof g=="boolean"?g:t))}hide(){this.n.$close(this.id)}g(g,t){this.k+=D.VSBuffer.fromString(t).byteLength,(0,E.log)(this.m,g,t),this.visible&&(this.m.flush(),this.n.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class f extends d{appendLine(g){this.append(g)}}let p=class{constructor(g,t,s,r,l,u){this.i=t,this.j=s,this.k=r,this.l=l,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=g.getProxy(a.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,A.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.h=g;for(const[t,s]of this.g)s.visible=t===this.h}createOutputChannel(g,t,s){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,l=(0,k.isString)(t)?t:void 0;if((0,k.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const b=this.i.environment.extensionLogLevel?.find(([n])=>L.ExtensionIdentifier.equals(s.identifier,n))?.[1];b&&(u=(0,E.parseLogLevel)(b));const i=r?this.o(g,u,s):this.n(g,l,s);return i.then(n=>{this.g.set(n.id,n),n.visible=n.id===this.h}),r?this.r(g,u??this.m.getLevel(),i):this.q(g,i)}async n(g,t,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,l=this.k.extUri.joinPath(r,`${this.f++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),b=await this.a.$register(g,l,t,s.identifier.value);return new d(b,g,u,this.a,s)}async o(g,t,s){const r=await this.p(s),l=this.k.extUri.joinPath(r,`${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=l.toString(),b=this.l.createLogger(l,{id:u,name:g,logLevel:t,extensionId:s.identifier.value});return new f(u,g,b,this.a,s)}p(g){let t=this.d.get(g.identifier.value);if(!t){const s=this.k.extUri.joinPath(this.i.logsLocation,g.identifier.value);this.d.set(g.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(s)}catch(r){if((0,C.toFileSystemProviderErrorCode)(r)!==C.FileSystemProviderErrorCode.FileExists)throw r}return s})())}return t}q(g,t){let s=!1;const r=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return g},append(l){r(),t.then(u=>u.append(l))},appendLine(l){r(),t.then(u=>u.appendLine(l))},clear(){r(),t.then(l=>l.clear())},replace(l){r(),t.then(u=>u.replace(l))},show(l,u){r(),t.then(b=>b.show(l,u))},hide(){r(),t.then(l=>l.hide())},dispose(){s=!0,t.then(l=>l.dispose())}}}r(g,t,s){const r=new o.DisposableStore,l=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},u=r.add(new m.Emitter);function b(i){t=i,u.fire(i)}return s.then(i=>{r.add(i),i.logLevel!==t&&b(i.logLevel),r.add(i.onDidChangeLogLevel(n=>b(n)))}),{...this.q(g,s),get logLevel(){return t},onDidChangeLogLevel:u.event,trace(i,...n){l(),s.then(h=>h.trace(i,...n))},debug(i,...n){l(),s.then(h=>h.debug(i,...n))},info(i,...n){l(),s.then(h=>h.info(i,...n))},warn(i,...n){l(),s.then(h=>h.warn(i,...n))},error(i,...n){l(),s.then(h=>h.error(i,...n))},dispose(){r.dispose()}}}};p=Ve([ze(0,c.IExtHostRpcService),ze(1,I.IExtHostInitDataService),ze(2,S.IExtHostConsumerFileSystem),ze(3,N.IExtHostFileSystemInfo),ze(4,E.ILoggerService),ze(5,E.ILogService)],p),e.ExtHostOutputService=p,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(De[293],Ce([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(De[294],Ce([1,0,33,16,12,11,24,2,4,219,48,237,293]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let k=class cn{constructor(m,o,d,f){this.d=m,this.e=o,this.f=d,this.g=f,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const p=await this.e.getEnvironment();return this.c=p?.userHome??m})()}hasValidBasename(m,o,d){return typeof o=="string"||typeof o>"u"?this.a.then(f=>this.h(m,f,o)):this.h(m,o,d)}h(m,o,d){return m.scheme===R.Schemas.file||m.scheme===R.Schemas.vscodeRemote?(0,a.isValidBasename)(d??(0,E.basename)(m),o===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,o){if(m.remoteAuthority)return R.Schemas.vscodeRemote;const d=(0,I.getVirtualWorkspaceScheme)(o.getWorkspace());if(d)return d;const f=o.getWorkspace().folders[0];if(f)return f.uri.scheme;const p=o.getWorkspace().configuration;return p?p.scheme:R.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?c.win32:c.posix)}async fileURI(m){let o="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const f=m.indexOf("/",2);f===-1?(o=m.substring(2),m="/"):(o=m.substring(2,f),m=m.substring(f)||"/")}return T.URI.from({scheme:R.Schemas.file,authority:o,path:m,query:"",fragment:""})}};k=Ve([ze(1,D.IRemoteAgentService),ze(2,A.IWorkbenchEnvironmentService),ze(3,N.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(De[81],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(E,T){this.line=E,this.character=T}isBefore(E){return!1}isBeforeOrEqual(E){return!1}isAfter(E){return!1}isAfterOrEqual(E){return!1}isEqual(E){return!1}compareTo(E){return 0}translate(E,T){return new a(0,0)}with(E){return new a(0,0)}}e.Position=a;class R{constructor(E,T,S,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(E,T),this.end=new a(S,I)}contains(E){return!1}isEqual(E){return!1}intersection(E){}union(E){return new R(0,0,0,0)}with(E){return new R(0,0,0,0)}}e.Range=R;var c;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(c=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[31],Ce([1,0,15,38,23,33,8,4,12,10,81,19]),function(ie,e,a,R,c,L,E,T,S,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const D="\u27EA ",k=" characters skipped \u27EB",C=(D.length+k.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var m;(function(_){_[_.file=0]="file",_[_.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(_){_[_.File=1]="File",_[_.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function d(_){return!!_.preview}e.resultIsMatch=d;function f(_){return!!_.resource}e.isFileMatch=f;function p(_){return!!_.message}e.isProgressMessage=p;var y;(function(_){_[_.Normal=0]="Normal",_[_.NewSearchStarted=1]="NewSearchStarted"})(y=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(ee){this.resource=ee,this.results=[]}}e.FileMatch=g;class t{constructor(ee,be,ce){this.ranges=be;const oe=Array.isArray(be)?be:[be];if(ce&&ce.matchLines===1&&s(oe)){ee=(0,E.getNLines)(ee,ce.matchLines);let x="",he=0,pe=0;const Se=Math.floor(ce.charsPerLine/5),Re=[];for(const re of oe){const le=Math.max(re.startColumn-Se,0),de=re.startColumn+ce.charsPerLine;if(le>pe+Se+C){const te=D+(le-pe)+k;x+=te+ee.slice(le,de),he+=le-(pe+te.length)}else x+=ee.slice(pe,de);Re.push(new l(0,re.startColumn-he,re.endColumn-he)),pe=de}this.preview={text:x,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const x=Array.isArray(be)?be[0].startLineNumber:be.startLineNumber;this.preview={text:ee,matches:(0,a.mapArrayOrNot)(be,he=>new r(he.startLineNumber-x,he.startColumn,he.endLineNumber-x,he.endColumn))}}}}e.TextSearchMatch=t;function s(_){const ee=_[0].startLineNumber;for(const be of _)if(be.startLineNumber!==ee||be.endLineNumber!==ee)return!1;return!0}class r{constructor(ee,be,ce,oe){this.startLineNumber=ee,this.startColumn=be,this.endLineNumber=ce,this.endColumn=oe}}e.SearchRange=r;class l extends r{constructor(ee,be,ce){super(ee,be,ee,ce)}}e.OneLineRange=l;var u;(function(_){_.List="list",_.Tree="tree"})(u=e.ViewMode||(e.ViewMode={}));var b;(function(_){_.Default="default",_.FileNames="fileNames",_.Type="type",_.Modified="modified",_.CountDescending="countDescending",_.CountAscending="countAscending"})(b=e.SearchSortOrder||(e.SearchSortOrder={}));function i(_,ee=!0){const be=_&&_.files&&_.files.exclude,ce=ee&&_&&_.search&&_.search.exclude;if(!be&&!ce)return;if(!be||!ce)return be||ce;let oe=Object.create(null);return oe=c.mixin(oe,c.deepClone(be)),oe=c.mixin(oe,c.deepClone(ce),!0),oe}e.getExcludes=i;function n(_,ee){return _.excludePattern&&R.match(_.excludePattern,ee)?!1:_.includePattern||_.usingSearchPaths?_.includePattern&&R.match(_.includePattern,ee)?!0:_.usingSearchPaths?!!_.folderQueries&&_.folderQueries.some(be=>{const ce=be.folder.fsPath;if(L.isEqualOrParent(ee,ce)){const oe=S.relative(ce,ee);return!be.includePattern||!!R.match(be.includePattern,oe)}else return!1}):!1:!0}e.pathIncludedInQuery=n;var h;(function(_){_[_.unknownEncoding=1]="unknownEncoding",_[_.regexParseError=2]="regexParseError",_[_.globParseError=3]="globParseError",_[_.invalidLiteral=4]="invalidLiteral",_[_.rgProcessError=5]="rgProcessError",_[_.other=6]="other",_[_.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(ee,be){super(ee),this.code=be}}e.SearchError=w;function v(_){const ee=_.message;if((0,I.isCancellationError)(_))return new w(ee,h.canceled);try{const be=JSON.parse(ee);return new w(be.message,be.code)}catch{return new w(ee,h.other)}}e.deserializeSearchError=v;function O(_){const ee={message:_.message,code:_.code};return new Error(JSON.stringify(ee))}e.serializeSearchError=O;function j(_){return _.type==="error"?!0:_.type==="success"}e.isSerializedSearchComplete=j;function V(_){return _.type==="success"}e.isSerializedSearchSuccess=V;function Q(_){return!!_.path}e.isSerializedFileMatch=Q;function G(_,ee){const be=_.searchPath?_.searchPath:_.relativePath;return(0,E.fuzzyContains)(be,ee)}e.isFilePatternMatch=G;class U{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function P(_,ee){const be={..._||{},...ee||{}};return Object.keys(be).filter(ce=>{const oe=be[ce];return typeof oe=="boolean"&&oe})}e.resolvePatternsForProvider=P;class M{constructor(ee,be){this.c=null,this.a={...ee.excludePattern||{},...be.excludePattern||{}},this.b=R.parse(this.a);let ce=ee.includePattern;be.includePattern&&(ce?ce={...ce,...be.includePattern}:ce=be.includePattern),ce&&(this.c=R.parse(ce))}matchesExcludesSync(ee,be,ce){return!!(this.b&&this.b(ee,be,ce))}includedInQuerySync(ee,be,ce){return!(this.b&&this.b(ee,be,ce)||this.c&&!this.c(ee,be,ce))}includedInQuery(ee,be,ce){const oe=this.b(ee,be,ce),x=()=>this.c?!!this.c(ee,be,ce):!0;return(0,A.isThenable)(oe)?oe.then(he=>he?!1:x()):x()}hasSiblingExcludeClauses(){return B(this.a)}}e.QueryGlobTester=M;function B(_){for(const ee in _)if(typeof _[ee]!="boolean")return!0;return!1}function Z(_){if(!_)return;let ee;return be=>(ee||(ee=(_()||Promise.resolve([])).then(ce=>ce?H(ce):{})),ee.then(ce=>!!ce[be]))}e.hasSiblingPromiseFn=Z;function Y(_){if(!_)return;let ee;return be=>{if(!ee){const ce=_();ee=ce?H(ce):{}}return!!ee[be]}}e.hasSiblingFn=Y;function H(_){const ee={};for(const be of _)ee[be]=!0;return ee}}),define(De[34],Ce([1,0,15,19,21,3,6,68,16,102,24,8,9,2,185,4,13,207,48,49,26,20,14,7,56,31,5]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f,p,y,g,t,s,r,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function b(V,Q,G){return new N.ExtUri(U=>w(U,G)).isEqual(V,Q)}function i(V,Q,G){return b(V.uri,Q.uri,G)?0:(0,A.compare)(V.uri.toString(),Q.uri.toString())}function n(V,Q,G){return V.index!==Q.index?V.index<Q.index?-1:1:b(V.uri,Q.uri,G)?(0,A.compare)(V.name,Q.name):(0,A.compare)(V.uri.toString(),Q.uri.toString())}function h(V,Q,G,U){const P=V.slice(0).sort((B,Z)=>G(B,Z,U)),M=Q.slice(0).sort((B,Z)=>G(B,Z,U));return(0,a.delta)(P,M,(B,Z)=>G(B,Z,U))}function w(V,Q){const G=Q.getCapabilities(V.scheme);return!(G&&G&1024)}class v extends f.Workspace{static toExtHostWorkspace(Q,G,U,P){if(!Q)return{workspace:null,added:[],removed:[]};const{id:M,name:B,folders:Z,configuration:Y,transient:H,isUntitled:_}=Q,ee=[],be=G;G?Z.forEach((he,pe)=>{const Se=k.URI.revive(he.uri),Re=v.o(U||G,Se,P);Re?(Re.name=he.name,Re.index=he.index,ee.push(Re)):ee.push({uri:Se,name:he.name,index:pe})}):ee.push(...Z.map(({uri:he,name:pe,index:Se})=>({uri:k.URI.revive(he),name:pe,index:Se}))),ee.sort((he,pe)=>he.index<pe.index?-1:1);const ce=new v(M,B,ee,!!H,Y?k.URI.revive(Y):null,!!_,he=>w(he,P)),{added:oe,removed:x}=h(be?be.workspaceFolders:[],ce.workspaceFolders,i,P);return{workspace:ce,added:oe,removed:x}}static o(Q,G,U){for(let P=0;P<Q.folders.length;P++){const M=Q.workspaceFolders[P];if(b(M.uri,G,U))return M}}constructor(Q,G,U,P,M,B,Z){super(Q,U.map(Y=>new f.WorkspaceFolder(Y)),P,M,Z),this.t=G,this.u=B,this.q=[],this.s=T.TernarySearchTree.forUris(Z),U.forEach(Y=>{this.q.push(Y),this.s.set(Y.uri,Y)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(Q,G){return G&&this.s.get(Q)&&(Q=(0,N.dirname)(Q)),this.s.findSubstr(Q)}resolveWorkspaceFolder(Q){return this.s.get(Q)}}let O=class{constructor(Q,G,U,P,M){this.c=new L.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new L.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.AsyncEmitter,this.h=P,this.s=U,this.t=M,this.j=new I.Counter,this.k=new R.Barrier,this.o=Q.getProxy(u.MainContext.MainThreadWorkspace),this.q=Q.getProxy(u.MainContext.MainThreadMessageService);const B=G.workspace;this.l=B?new v(B.id,B.name,[],!!B.transient,B.configuration?k.URI.revive(B.configuration):null,!!B.isUntitled,Z=>w(Z,U)):void 0}$initializeWorkspace(Q,G){this.v=G,this.$acceptWorkspaceData(Q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?k.URI.from({scheme:S.Schemas.untitled,path:(0,N.basename)((0,N.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(Q,G,U,...P){const M=[];if(Array.isArray(P)&&P.forEach(_=>{k.URI.isUri(_.uri)&&!M.some(ee=>b(ee.uri,_.uri,this.s))&&M.push({uri:_.uri,name:_.name||(0,N.basenameOrAuthority)(_.uri)})}),this.n||[G,U].some(_=>typeof _!="number"||_<0)||U===0&&M.length===0)return!1;const B=this.x?this.x.workspaceFolders:[];if(G+U>B.length)return!1;const Z=B.slice(0);Z.splice(G,U,...M.map(_=>({uri:_.uri,name:_.name||(0,N.basenameOrAuthority)(_.uri),index:void 0})));for(let _=0;_<Z.length;_++){const ee=Z[_];if(Z.some((be,ce)=>ce!==_&&b(ee.uri,be.uri,this.s)))return!1}Z.forEach((_,ee)=>_.index=ee);const{added:Y,removed:H}=h(B,Z,n,this.s);if(Y.length===0&&H.length===0)return!1;if(this.o){const _=Q.displayName||Q.name;this.o.$updateWorkspaceFolders(_,G,U,M).then(void 0,ee=>{this.n=void 0;const be={source:{identifier:Q.identifier,label:Q.displayName||Q.name}};this.q.$showMessage(d.Severity.Error,(0,C.localize)(0,null,_,ee.toString()),be,[])})}return this.y(Z),!0}getWorkspaceFolder(Q,G){if(!!this.x)return this.x.getWorkspaceFolder(Q,G)}async getWorkspaceFolder2(Q,G){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(Q,G)}async resolveWorkspaceFolder(Q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(Q)}getPath(){if(!this.x)return;const{folders:Q}=this.x;if(Q.length!==0)return Q[0].uri.fsPath}getRelativePath(Q,G){let U,P="";if(typeof Q=="string"?(U=k.URI.file(Q),P=Q):typeof Q<"u"&&(U=Q,P=Q.fsPath),!U)return P;const M=this.getWorkspaceFolder(U,!0);if(!M)return P;typeof G>"u"&&this.x&&(G=this.x.folders.length>1);let B=(0,N.relativePath)(M.uri,U);return G&&M.name&&(B=`${M.name}/${B}`),B}y(Q){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:Q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(Q){const{workspace:G,added:U,removed:P}=v.toExtHostWorkspace(Q,this.l,this.n,this.s);this.l=G||void 0,this.n=void 0,this.c.fire(Object.freeze({added:U,removed:P}))}findFiles(Q,G,U,P,M=c.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${P.value}, entryPoint: findFiles`);let B;if(G===null?B=!1:G&&(typeof G=="string"?B=G:B=G.pattern),M&&M.isCancellationRequested)return Promise.resolve([]);const{includePattern:Z,folder:Y}=j(t.GlobPattern.from(Q));return this.o.$startFileSearch((0,D.withUndefinedAsNull)(Z),(0,D.withUndefinedAsNull)(Y),(0,D.withUndefinedAsNull)(B),(0,D.withUndefinedAsNull)(U),M).then(H=>Array.isArray(H)?H.map(_=>k.URI.revive(_)):[])}async findTextInFiles(Q,G,U,P,M=c.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${P.value}, entryPoint: findTextInFiles`);const B=this.j.getNext(),Z=typeof G.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:G.previewOptions,{includePattern:Y,folder:H}=j(t.GlobPattern.from(G.include)),_=typeof G.exclude=="string"?G.exclude:G.exclude?G.exclude.pattern:void 0,ee={ignoreSymlinks:typeof G.followSymlinks=="boolean"?!G.followSymlinks:void 0,disregardIgnoreFiles:typeof G.useIgnoreFiles=="boolean"?!G.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof G.useGlobalIgnoreFiles=="boolean"?!G.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof G.useParentIgnoreFiles=="boolean"?!G.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof G.useDefaultExcludes=="boolean"?!G.useDefaultExcludes:!0,fileEncoding:G.encoding,maxResults:G.maxResults,previewOptions:Z,afterContext:G.afterContext,beforeContext:G.beforeContext,includePattern:Y,excludePattern:_},be=!1;if(this.u[B]=ce=>{if(be)return;const oe=k.URI.revive(ce.resource);ce.results.forEach(x=>{(0,l.resultIsMatch)(x)?U({uri:oe,preview:{text:x.preview.text,matches:(0,a.mapArrayOrNot)(x.preview.matches,he=>new s.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,a.mapArrayOrNot)(x.ranges,he=>new s.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):U({uri:oe,text:x.text,lineNumber:x.lineNumber})})},M.isCancellationRequested)return{};try{const ce=await this.o.$startTextSearch(Q,(0,D.withUndefinedAsNull)(H),ee,B,M);return delete this.u[B],ce||{}}catch(ce){throw delete this.u[B],ce}}$handleTextSearchResult(Q,G){this.u[G]?.(Q)}saveAll(Q){return this.o.$saveAll(Q)}resolveProxy(Q){return this.o.$resolveProxy(Q)}get trusted(){return this.v}requestWorkspaceTrust(Q){return this.o.$requestWorkspaceTrust(Q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(Q,G){if(this.w.has(Q))throw new Error(`A provider has already been registered for scheme ${Q}`);this.w.set(Q,G);const U=this.t.transformOutgoingScheme(Q),P=this.z++;return this.o.$registerEditSessionIdentityProvider(P,U),(0,E.toDisposable)(()=>{this.w.delete(Q),this.o.$unregisterEditSessionIdentityProvider(P)})}async $getEditSessionIdentifier(Q,G){this.h.info("Getting edit session identifier for workspaceFolder",Q);const U=await this.resolveWorkspaceFolder(k.URI.revive(Q));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const P=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!P),!P)return;const M=await P.provideEditSessionIdentity(U,G);if(this.h.info("Provider returned edit session identifier: ",M),!!M)return M}async $provideEditSessionIdentityMatch(Q,G,U,P){this.h.info("Getting edit session identifier for workspaceFolder",Q);const M=await this.resolveWorkspaceFolder(k.URI.revive(Q));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const B=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!B),!B)return;const Z=await B.provideEditSessionIdentityMatch?.(G,U,P);if(this.h.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(Q){return(G,U,P)=>{const M=function(Z){G.call(U,Z)};return M.extension=Q,this.A.event(M,void 0,P)}}async $onWillCreateEditSessionIdentity(Q,G,U){const P=await this.resolveWorkspaceFolder(k.URI.revive(Q));if(P===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:P},G,async(M,B)=>{const Z=Date.now();await Promise.resolve(M),Date.now()-Z>U&&this.h.warn("SLOW edit session create-participant",B.extension.identifier)}),G.isCancellationRequested}};O=Ve([ze(0,g.IExtHostRpcService),ze(1,y.IExtHostInitDataService),ze(2,p.IExtHostFileSystemInfo),ze(3,o.ILogService),ze(4,r.IURITransformerService)],O),e.ExtHostWorkspace=O,e.IExtHostWorkspace=(0,m.createDecorator)("IExtHostWorkspace");function j(V){let Q,G;return V&&(typeof V=="string"?Q=V:(Q=V.pattern,G=k.URI.revive(V.baseUri))),{includePattern:Q,folder:G}}}),define(De[35],Ce([1,0,23,3,34,5,7,210,127,9,19,4,20,13,2]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(s,r){if(r){const l=r.split(".");let u=s;for(let b=0;u&&b<l.length;b++)u=u[l[b]];return u}}function o(s){return s instanceof C.URI}function d(s){return s&&s.uri instanceof C.URI&&s.languageId&&typeof s.languageId=="string"}function f(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function p(s){return s&&s.uri instanceof C.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function y(s){if(o(s))return{resource:s};if(d(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(f(s))return{overrideIdentifier:s.languageId};if(p(s))return{resource:s.uri};if(s===null)return{resource:null}}let g=class{constructor(r,l,u){this.a=r.getProxy(L.MainContext.MainThreadConfiguration),this.c=l,this.b=u,this.d=new N.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,l){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(r,l))}};g=Ve([ze(0,D.IExtHostRpcService),ze(1,c.IExtHostWorkspace),ze(2,k.ILogService)],g),e.ExtHostConfiguration=g;class t{constructor(r,l,u,b){this.a=new R.Emitter,this.b=r,this.f=b,this.c=l,this.e=T.Configuration.parse(u),this.d=this.k(u.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,l){const u={data:this.e.toData(),workspace:this.c.workspace};this.e=T.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(l,u))}getConfiguration(r,l,u){const b=y(l)||{},i=this.g(r?m(this.e.getValue(void 0,b,this.c.workspace),r):this.e.getValue(void 0,b,this.c.workspace));r&&this.h(r,b,u?.identifier);function n(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case E.ConfigurationTarget.Global:return 2;case E.ConfigurationTarget.Workspace:return 5;case E.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(w){return typeof m(i,w)<"u"},get:(w,v)=>{this.h(r?`${r}.${w}`:w,b,u?.identifier);let O=m(i,w);if(typeof O>"u")O=v;else{let j;const V=(Q,G)=>{let U;const P=()=>{j=j||(0,a.deepClone)(i),U=U||m(j,G)};return(0,I.isObject)(Q)?new Proxy(Q,{get:(M,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return P(),()=>U;if(j)return U=U||m(j,G),U[B];const Z=M[B];return typeof B=="string"?V(Z,`${G}.${B}`):Z},set:(M,B,Z)=>(P(),U&&(U[B]=Z),!0),deleteProperty:(M,B)=>(P(),U&&delete U[B],!0),defineProperty:(M,B,Z)=>(P(),U&&Object.defineProperty(U,B,Z),!0)}):Q};O=V(O,w)}return O},update:(w,v,O,j)=>{w=r?`${r}.${w}`:w;const V=n(O);return v!==void 0?this.b.$updateConfigurationOption(V,w,v,b,j):this.b.$removeConfigurationOption(V,w,b,j)},inspect:w=>{w=r?`${r}.${w}`:w;const v=this.e.inspect(w,b,this.c.workspace);if(v)return{key:w,defaultValue:(0,a.deepClone)(v.policy?.value??v.default?.value),globalValue:(0,a.deepClone)(v.user?.value??v.application?.value),workspaceValue:(0,a.deepClone)(v.workspace?.value),workspaceFolderValue:(0,a.deepClone)(v.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(v.default?.override),globalLanguageValue:(0,a.deepClone)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,a.deepClone)(v.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(v.workspaceFolder?.override),languageIds:(0,a.deepClone)(v.overrideIdentifiers)}}};return typeof i=="object"&&(0,a.mixin)(h,i,!1),Object.freeze(h)}g(r){const l=u=>(0,I.isObject)(u)?new Proxy(u,{get:(b,i)=>l(b[i]),set:(b,i,n)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(i)}' of object`)},deleteProperty:(b,i)=>{throw new Error(`TypeError: Cannot delete read only property '${String(i)}' of object`)},defineProperty:(b,i)=>{throw new Error(`TypeError: Cannot define property '${String(i)}' for a readonly object`)},setPrototypeOf:b=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return l(r)}h(r,l,u){const b=S.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),i=u?`[${u.value}] `:"";if(b===4){typeof l?.resource>"u"&&this.f.warn(`${i}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(b===3){l?.resource&&this.f.warn(`${i}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,l){const u=new T.ConfigurationChangeEvent(r,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(b,i)=>u.affectsConfiguration(b,y(i))})}k(r){return r.reduce((l,u)=>(l.set(u[0],u[1]),l),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,A.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,R,c){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!c)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!c:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?c.call(ie,a):c?c.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!R:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(ie):R?R.value:e.get(ie)};define(De[82],Ce([1,0,2,19,3,5,7,34,59,35,21,41,20,26,4,16,11,13,77,248,10]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f,p,y){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(Q){function G(P){if(P!=null)return P}Q.from=G;function U(P){if(P!=null)return P}Q.to=U})(t||(t={}));var s;(function(Q){function G(P){if(P!=null)return P}Q.from=G;function U(P){if(P!=null)return P}Q.to=U})(s||(s={}));var r;(function(Q){function G(P){if(P!=null)return P}Q.from=G;function U(P){if(P!=null)return P}Q.to=U})(r||(r={}));var l;(function(Q){function G(M){if(M){const B=M;return B&&!!B.process}else return!1}Q.is=G;function U(M){if(M==null)return;const B={process:M.process,args:M.args};return M.options&&(B.options=r.from(M.options)),B}Q.from=U;function P(M){if(M!=null)return new E.ProcessExecution(M.process,M.args,M.options)}Q.to=P})(l||(l={}));var u;(function(Q){function G(P){if(P!=null)return P}Q.from=G;function U(P){if(P!=null)return P}Q.to=U})(u||(u={}));var b;(function(Q){function G(M){if(M){const B=M;return B&&(!!B.commandLine||!!B.command)}else return!1}Q.is=G;function U(M){if(M==null)return;const B={};return M.commandLine!==void 0?B.commandLine=M.commandLine:(B.command=M.command,B.args=M.args),M.options&&(B.options=u.from(M.options)),B}Q.from=U;function P(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new E.ShellExecution(M.commandLine,M.options):new E.ShellExecution(M.command,M.args?M.args:[],M.options)}Q.to=P})(b||(b={}));var i;(function(Q){function G(M){if(M){const B=M;return B&&B.customExecution==="customExecution"}else return!1}Q.is=G;function U(M){return{customExecution:"customExecution"}}Q.from=U;function P(M,B){return B.get(M)}Q.to=P})(i=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var n;(function(Q){function G(U,P){let M;return U.scope!==void 0&&typeof U.scope!="number"?M=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===E.TaskScope.Workspace&&P&&P.workspaceFile?M=P.workspaceFile:M=p.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:M}}Q.from=G})(n=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(Q){function G(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}Q.from=G})(h||(h={}));var w;(function(Q){function G(M,B){if(M==null)return[];const Z=[];for(const Y of M){const H=U(Y,B);H&&Z.push(H)}return Z}Q.fromMany=G;function U(M,B){if(M==null)return;let Z;M.execution instanceof E.ProcessExecution?Z=l.from(M.execution):M.execution instanceof E.ShellExecution?Z=b.from(M.execution):M.execution&&M.execution instanceof E.CustomExecution&&(Z=i.from(M.execution));const Y=t.from(M.definition);let H;return M.scope?typeof M.scope=="number"?H=M.scope:H=M.scope.uri:H=E.TaskScope.Workspace,!Y||!H?void 0:{_id:M._id,definition:Y,name:M.name,source:{extensionId:B.identifier.value,label:M.source,scope:H},execution:Z,isBackground:M.isBackground,group:h.from(M.group),presentationOptions:s.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}Q.from=U;async function P(M,B,Z){if(M==null)return;let Y;l.is(M.execution)?Y=l.to(M.execution):b.is(M.execution)?Y=b.to(M.execution):i.is(M.execution)&&(Y=i.to(M._id,Z));const H=t.to(M.definition);let _;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?_=M.source.scope:_=await B.resolveWorkspaceFolder(a.URI.revive(M.source.scope)):_=E.TaskScope.Workspace),!H||!_)return;const ee=new E.Task(H,_,M.name,M.source.label,Y,M.problemMatchers);return M.isBackground!==void 0&&(ee.isBackground=M.isBackground),M.group!==void 0&&(ee.group=E.TaskGroup.from(M.group._id),ee.group&&M.group.isDefault&&(ee.group=new E.TaskGroup(ee.group.id,ee.group.label),M.group.isDefault===!0&&(ee.group.isDefault=M.group.isDefault))),M.presentationOptions&&(ee.presentationOptions=s.to(M.presentationOptions)),M._id&&(ee._id=M._id),M.detail&&(ee.detail=M.detail),ee}Q.to=P})(w=e.TaskDTO||(e.TaskDTO={}));var v;(function(Q){function G(P){return P}Q.from=G;function U(P){if(!!P)return Object.assign(Object.create(null),P)}Q.to=U})(v||(v={}));class O{constructor(G,U,P){this._id=U,this.a=P,g.set(this,void 0),Je(this,g,G,"f")}get task(){return this.a}terminate(){Ue(this,g,"f").terminateTask(this)}fireDidStartProcess(G){}fireDidEndProcess(G){}}g=new WeakMap;let j=class{constructor(G,U,P,M,B,Z,Y,H){this.q=new c.Emitter,this.r=new c.Emitter,this.s=new c.Emitter,this.t=new c.Emitter,this.a=G.getProxy(L.MainContext.MainThreadTask),this.b=P,this.c=M,this.d=B,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Y,this.g=H,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(G,U,P){if(!P)return new E.Disposable(()=>{});const M=this.w();return this.j.set(M,{type:U,provider:P,extension:G}),this.a.$registerTaskProvider(M,U),new E.Disposable(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(G,U){this.a.$registerTaskSystem(G,U)}fetchTasks(G){return this.a.$fetchTasks(v.from(G)).then(async U=>{const P=[];for(const M of U){const B=await w.to(M,this.b,this.m);B&&P.push(B)}return P})}get taskExecutions(){const G=[];return this.k.forEach(U=>G.push(U)),G}terminateTask(G){if(!(G instanceof O))throw new Error("No valid task execution provided");return this.a.$terminateTask(G._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(G,U,P){const M=this.m.get(G.id);M&&(this.o.set(G.id,M),this.e.attachPtyToTerminal(U,await M.callback(P))),this.p=G.id,this.q.fire({execution:await this.y(G)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(G){const U=await this.y(G);this.l.delete(G.id),this.k.delete(G.id),this.A(G),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(G){const U=await this.y(G.id);this.s.fire({execution:U,processId:G.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(G){const U=await this.y(G.id);this.t.fire({execution:U,exitCode:G.exitCode})}$provideTasks(G,U){const P=this.j.get(G);if(!P)return Promise.reject(new Error("no handler found"));const M=[],B=(0,R.asPromise)(()=>P.provider.provideTasks(N.CancellationToken.None)).then(Z=>this.u(U,M,P,Z));return new Promise(Z=>{B.then(Y=>{Promise.all(M).then(()=>{Z(Y)})})})}async $resolveTask(G,U){const P=this.j.get(G);if(!P)return Promise.reject(new Error("no handler found"));if(U.definition.type!==P.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${P.type}].`);const M=await w.to(U,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const B=await P.provider.resolveTask(M,N.CancellationToken.None);if(!B)return;this.z(B,P);const Z=w.from(B,P.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return i.is(Z.execution)&&await this.x(Z,B,!0),await this.v(Z)}w(){return this.h++}async x(G,U,P){const M=await this.a.$createTaskId(G);!P&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,U.execution)),this.m.set(M,U.execution)}async y(G,U){if(typeof G=="string"){const B=this.l.get(G);if(!B)throw new y.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return B}const P=this.l.get(G.id);if(P)return P;const M=new Promise((B,Z)=>{function Y(H,_,ee){ee?B(new O(H,_.id,ee)):Z("Unexpected: Task does not exist.")}U?Y(this,G,U):w.to(G.task,this.b,this.m).then(H=>Y(this,G,H))});return this.l.set(G.id,M),M.then(B=>(this.k.set(G.id,B),B),B=>Promise.reject(B))}z(G,U){G._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(G){this.o.get(G.id)&&this.o.delete(G.id),this.n.has(G.id)&&this.p!==G.id&&(this.m.delete(G.id),this.n.delete(G.id));const P=this.n.values();let M=P.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=P.next()}};j=Ve([ze(0,D.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,T.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,A.IExtHostTerminalService),ze(6,d.ILogService),ze(7,f.IExtHostApiDeprecationService)],j),e.ExtHostTaskBase=j;let V=class extends j{constructor(G,U,P,M,B,Z,Y,H){super(G,U,P,M,B,Z,Y,H),this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:o.PlatformToString(0)})}async executeTask(G,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const P=w.from(U,G);if(P===void 0)throw new Error("Task is not valid");if(i.is(P.execution))await this.x(P,U,!1);else throw new y.NotSupportedError;const M=await this.y(await this.a.$getTaskExecution(P),U);return this.a.$executeTask(P).catch(B=>{throw new Error(B)}),M}u(G,U,P,M){const B=[];if(M)for(const Z of M){this.z(Z,P),(!Z.definition||!G[Z.definition.type])&&this.f.warn(`The task [${Z.source}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`);const Y=w.from(Z,P.extension);Y&&i.is(Y.execution)?(B.push(Y),U.push(this.x(Y,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:P.extension}}async v(G){if(i.is(G.execution))return G;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(G,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(G,U,P){}};V=Ve([ze(0,D.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,T.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,A.IExtHostTerminalService),ze(6,d.ILogService),ze(7,f.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,C.createDecorator)("IExtHostTask")}),define(De[295],Ce([1,0,12,21,45,38,24,43,31]),function(ie,e,a,R,c,L,E,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(D,k,C){this.k=D,this.l=k,this.o=C,this.e=!1,this.f=0,this.g=!1,this.a=D.filePattern,this.b=D.includePattern&&L.parse(D.includePattern),this.c=D.maxResults||void 0,this.d=D.exists,this.h=new Set,this.j=D.excludePattern&&L.parse(D.excludePattern)}cancel(){this.g=!0,this.h.forEach(D=>D.cancel()),this.h=new Set}search(D){const k=this.k.folderQueries||[];return new Promise((C,m)=>{const o=d=>{this.f++,D(d)};if(this.g)return C({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(d=>{const f=d.toString(),p=a.basename(f);this.j&&this.j(f,p)||this.v(o,{base:d,basename:p})}),Promise.all(k.map(d=>this.p(d,o))).then(d=>{C({limitHit:this.e,stats:d[0]||void 0})},d=>{m(new Error((0,c.toErrorMessage)(d)))})})}async p(D,k){const C=new R.CancellationTokenSource,m=this.q(D),o=this.r(),d=new S.QueryGlobTester(this.k,D),f=!d.hasSiblingExcludeClauses();let p;try{this.h.add(C),p=T.StopWatch.create();const y=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},m,C.token),g=p.elapsed(),t=T.StopWatch.create();return this.g&&!this.e||(y&&y.forEach(s=>{const r=a.posix.relative(D.folder.path,s.path);if(f){const l=a.basename(s.path);this.v(k,{base:D.folder,relativePath:r,basename:l});return}this.s(o,D.folder,r,k)}),this.g&&!this.e)?null:(this.u(o,d,k),{providerTime:g,postProcessTime:t.elapsed()})}finally{C.dispose(),this.h.delete(C)}}q(D){const k=(0,S.resolvePatternsForProvider)(this.k.includePattern,D.includePattern),C=(0,S.resolvePatternsForProvider)(this.k.excludePattern,D.excludePattern);return{folder:D.folder,excludes:C,includes:k,useIgnoreFiles:!D.disregardIgnoreFiles,useGlobalIgnoreFiles:!D.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!D.disregardParentIgnoreFiles,followSymlinks:!D.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const D={rootEntries:[],pathToEntries:Object.create(null)};return D.pathToEntries["."]=D.rootEntries,D}s({pathToEntries:D},k,C,m){if(C===this.a){const d=a.basename(this.a);this.v(m,{base:k,relativePath:this.a,basename:d})}function o(d){const f=a.basename(d),p=a.dirname(d);let y=D[p];y||(y=D[p]=[],o(p)),y.push({base:k,relativePath:d,basename:f})}o(C)}u({rootEntries:D,pathToEntries:k},C,m){const o=this,d=this.a;function f(p){const y=(0,S.hasSiblingFn)(()=>p.map(g=>g.basename));for(let g=0,t=p.length;g<t;g++){const s=p[g],{relativePath:r,basename:l}=s;if(C.matchesExcludesSync(r,l,d!==l?y:void 0))continue;const u=k[r];if(u)f(u);else{if(r===d)continue;o.v(m,s)}if(o.e)break}}f(D)}v(D,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||D(k))}}class N{constructor(){this.b=new Map}fileSearch(D,k,C,m){const o=this.c(D.cacheKey),d=new I(D,k,o&&o.token);let f=0;const p=y=>{f+=y.length,C(y.map(g=>this.d(g)))};return this.e(d,N.a,p,m).then(y=>({limitHit:y.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:f,detailStats:y.stats}}))}clearCache(D){this.c(D)?.cancel()}c(D){if(!!D)return this.b.has(D)||this.b.set(D,new R.CancellationTokenSource),this.b.get(D)}d(D){return D.relativePath?{resource:E.joinPath(D.base,D.relativePath)}:{resource:D.base}}e(D,k,C,m){m.onCancellationRequested(()=>{D.cancel()});const o=f=>{f&&(d.push(f),k>0&&d.length>=k&&(C(d),d=[]))};let d=[];return D.search(o).then(f=>(d.length&&C(d),f),f=>(d.length&&C(d),Promise.reject(f)))}}N.a=512,e.FileSearchManager=N}),define(De[296],Ce([1,0,15,61,38,113,28,16,12,24,8,9,2,167,197,54,13,48,134,294,31]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(w,v,O,j,V){this.a=w,this.b=v,this.c=O,this.d=j,this.e=V}text(w,v,O={}){w=this.f(w,O);const j=this.a.getValue(),V=v&&v.some(G=>!this.a.getValue({resource:G}).search.useRipgrep);return{...this.h(v?.map(d.toWorkspaceFolder),O),type:2,contentPattern:w,previewOptions:O.previewOptions,maxFileSize:O.maxFileSize,usePCRE2:j.search.usePCRE2||V||!1,beforeContext:O.beforeContext,afterContext:O.afterContext,userDisabledExcludesAndIgnoreFiles:O.disregardExcludeSettings&&O.disregardIgnoreFiles}}f(w,v){const O=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const j={...w,wordSeparators:O.editor.wordSeparators};return this.j(w,v)&&(j.isCaseSensitive=!0),this.k(w)&&(j.isMultiline=!0),j}file(w,v={}){return{...this.h(w,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}g(w,v){return w?(w=Array.isArray(w)?w.map(u):u(w),v?this.parseSearchPaths(w):{pattern:s(...Array.isArray(w)?w:[w])}):{}}h(w=[],v={}){const O=this.g(v.includePattern,v.expandPatterns),j=this.g(v.excludePattern,v.expandPatterns),V=w.length>1,Q=(O.searchPaths&&O.searchPaths.length?O.searchPaths.map(P=>this.q(P,v,j)):w.map(P=>this.r(P,v,j,V))).filter(P=>!!P),G={_reason:v._reason,folderQueries:Q,usingSearchPaths:!!(O.searchPaths&&O.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:j.pattern,includePattern:O.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const P=a.coalesce(a.flatten(this.c.groups.map(Z=>Z.editors.map(Y=>Y.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(P));const M=P.filter(Z=>(0,y.pathIncludedInQuery)(G,Z.fsPath)),B=this.i(M);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...G,...B}}const U=v.extraFileResources&&v.extraFileResources.filter(P=>(0,y.pathIncludedInQuery)(G,P.fsPath));return G.extraFileResources=U&&U.length?U:void 0,G}i(w){const v=[],O=new E.ResourceMap,j={};let V=!1;return w.forEach(Q=>{if(Q.scheme===T.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(Q)){const U=this.b.getWorkspaceFolder(Q)?.uri??Q.with({path:S.dirname(Q.fsPath)});let P=O.get(U);P||(V=!0,P={folder:U,includePattern:{}},v.push(P),O.set(U,P));const M=S.relative(U.fsPath,Q.fsPath);(0,A.assertIsDefined)(P.includePattern)[M.replace(/\\/g,"/")]=!0}else Q.fsPath&&(V=!0,j[Q.fsPath]=!0)}),{folderQueries:v,includePattern:j,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(w,v){if(v.isSmartCase){if(w.isRegExp){if(N.containsUppercaseCharacter(w.pattern,!0))return!0}else if(N.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,k.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const v=B=>S.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),j=(Array.isArray(w)?w:r(w)).map(B=>{const Z=this.e.resolvedUserHome;return Z?(0,L.untildify)(B,Z.scheme===T.Schemas.file?Z.fsPath:Z.path):B}),V=R.groupBy(j,B=>v(B)?"searchPaths":"exprSegments"),Q=(V.exprSegments||[]).map(B=>N.rtrim(B,"/")).map(B=>N.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),l(B))),G={},U=this.m(V.searchPaths||[]);U&&U.length&&(G.searchPaths=U);const P=a.flatten(Q),M=s(...P);return M&&(G.pattern=M),G}l(w,v){return v.disregardExcludeSettings?void 0:(0,y.getExcludes)(w,!v.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const v=w.flatMap(j=>{let{pathPortion:V,globPortion:Q}=t(j);return Q&&(Q=b(Q)),this.n(V).flatMap(U=>this.o(U,Q))}),O=new Map;return v.forEach(j=>{const V=j.searchPath.toString(),Q=O.get(V);Q?j.pattern&&(Q.pattern=Q.pattern||{},Q.pattern[j.pattern]=!0):O.set(V,{searchPath:j.searchPath,pattern:j.pattern?s(j.pattern):void 0})}),Array.from(O.values())}n(w){if(S.isAbsolute(w)){const v=this.b.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==T.Schemas.file?[{searchPath:v[0].uri.with({path:w})}]:[{searchPath:D.URI.file(S.normalize(w))}]}if(this.b.getWorkbenchState()===2){const v=this.b.getWorkspace().folders[0].uri;if(w=u(w),w.startsWith("../")||w===".."){const j=S.posix.resolve(v.path,w);return[{searchPath:v.with({path:j})}]}const O=b(w);return[{searchPath:v,pattern:O}]}else{if(w==="./"||w===".\\")return[];{const v=w.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(V=>{const Q=v.match(new RegExp(`^${N.escapeRegExpCharacters(V.name)}(?:/(.*)|$)`));return Q?{match:Q,folder:V}:null}).filter(A.isDefined);if(j.length)return j.map(V=>{const Q=V.match[1];return{searchPath:V.folder.uri,pattern:Q&&b(Q)}});{const V=w.match(/\.[\/\\](.+)[\/\\]?/),Q=V?V[1]:w,G=C.localize(0,null,Q);throw new Error(G)}}}}o(w,v){const O=w.pattern&&v?`${w.pattern}/${v}`:w.pattern||v,j=[{searchPath:w.searchPath,pattern:O}];return O&&!O.endsWith("**")&&j.push({searchPath:w.searchPath,pattern:O+"/**"}),j}q(w,v,O){const j=this.r((0,d.toWorkspaceFolder)(w.searchPath),v,O,!1);return j?{...j,includePattern:w.pattern}:null}r(w,v,O,j){let V;const Q=D.URI.isUri(w)?w:w.uri;if(O.searchPaths){const B=O.searchPaths.filter(Z=>(0,I.isEqual)(Z.searchPath,Q))[0];if(B&&!B.pattern)return null;B&&(V=B.pattern)}const G=this.a.getValue({resource:Q}),P={...this.l(G,v)||{},...V||{}},M=D.URI.isUri(w)?(0,I.basename)(w):w.name;return{folder:Q,folderName:j?M:void 0,excludePattern:Object.keys(P).length>0?P:void 0,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!G.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!G.search.followSymlinks}}};g=Ve([ze(0,m.IConfigurationService),ze(1,d.IWorkspaceContextService),ze(2,f.IEditorGroupsService),ze(3,o.ILogService),ze(4,p.IPathService)],g),e.QueryBuilder=g;function t(h){const w=h.match(/[\*\{\}\(\)\[\]\?]/);if(w){const v=w.index,O=h.substr(0,v).match(/[/|\\][^/\\]*$/);if(O){let j=h.substr(0,O.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:h.substr((O.index||0)+1)}}}return{pathPortion:h}}function s(...h){return h.length?h.reduce((w,v)=>(w[v]=!0,w),Object.create(null)):void 0}function r(h){return c.splitGlobAware(h,",").map(w=>w.trim()).filter(w=>!!w.length)}function l(h){return[`**/${h}/**`,`**/${h}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function u(h){return h.replace(/\\/g,"/")}function b(h){return u(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function i(h){return h.replace(/([?*[\]])/g,"[$1]")}function n(h,w){h=a.distinct(h,j=>j.toString());const v=[],O=w.getWorkspace();return h&&h.forEach(j=>{let V;if(w.getWorkbenchState()===2)V=(0,I.relativePath)(O.folders[0].uri,j),V&&V!=="."&&(V="./"+V);else{const Q=w.getWorkspaceFolder(j);if(Q){const G=Q.name;if(O.folders.filter(P=>P.name===G).length===1){const P=(0,I.relativePath)(Q.uri,j);P===""?V=`./${Q.name}`:V=`./${Q.name}/${P}`}else V=j.fsPath}}V&&v.push(i(V))}),v}e.resolveResourcesForSearchIncludes=n}),define(De[297],Ce([1,0,24,2,21,10,4,296,31,48]),function(ie,e,a,R,c,L,E,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function A(m,o){const d=o.activationEvents;if(!d)return Promise.resolve(void 0);const f=[],p=[];for(const l of d)if(/^workspaceContains:/.test(l)){const u=l.substr(18);u.indexOf("*")>=0||u.indexOf("?")>=0||m.forceUsingSearch?p.push(u):f.push(u)}if(f.length===0&&p.length===0)return Promise.resolve(void 0);let y;const g=new Promise((l,u)=>{y=l}),t=l=>y({activationEvent:l}),s=Promise.all(f.map(l=>D(m,l,t))).then(()=>{}),r=k(m,o.identifier,p,t);return Promise.all([s,r]).then(()=>{y(void 0)}),g}e.checkActivateWorkspaceContainsExtension=A;async function D(m,o,d){for(const f of m.folders)if(await m.exists(a.joinPath(R.URI.revive(f),o))){d(`workspaceContains:${o}`);return}}async function k(m,o,d,f){if(d.length===0)return Promise.resolve(void 0);const p=new c.CancellationTokenSource,y=m.checkExists(m.folders,d,p.token),g=setTimeout(async()=>{p.cancel(),m.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},N);let t=!1;try{t=await y}catch(s){L.isCancellationError(s)||L.onUnexpectedError(s)}p.dispose(),clearTimeout(g),t&&f(`workspaceContains:${d.join(",")}`)}function C(m,o,d,f){const p=m.get(E.IInstantiationService),y=m.get(S.ISearchService),t=p.createInstance(T.QueryBuilder).file(o.map(s=>(0,I.toWorkspaceFolder)(R.URI.revive(s))),{_reason:"checkExists",includePattern:d,exists:!0});return y.fileSearch(t,f).then(s=>!!s.limitHit,s=>L.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=C});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,R,c){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!c)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!c:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?c.call(ie,a):c?c.value=a:e.set(ie,a),a},Ue=this&&this.__classPrivateFieldGet||function(ie,e,a,R){if(a==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!R:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?R:a==="a"?R.call(ie):R?R.value:e.get(ie)};define(De[42],Ce([1,0,179,12,83,24,19,6,68,2,13,5,35,239,99,34,27,135,10,25,22,221,7,128,4,26,79,20,91,55,41,3,297,98,223,16,97,43,11]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f,p,y,g,t,s,r,l,u,b,i,n,h,w,v,O,j,V,Q,G,U){"use strict";var P,M,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let Z=class ln extends T.Disposable{constructor(x,he,pe,Se,Re,re,le,de,te,ae,se){super(),this.a=this.B(new w.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=he,this.g=pe,this.f=le,this.j=Se,this.k=Re,this.l=re,this.m=te,this.p=ae,this.s=se,this.t=this.g.getProxy(A.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(A.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(A.MainContext.MainThreadExtensionService),this.w=new E.Barrier,this.y=new E.Barrier,this.z=new E.Barrier,this.C=new E.Barrier,this.D=new ce(this.f.activationEvents),this.G=new d.ExtensionDescriptionRegistry(this.D,this.f.allExtensions);const F=new p.ExtensionIdentifierSet(this.f.myExtensions);this.F=new d.ExtensionDescriptionRegistry(this.D,ee(this.G,F)),this.H=new C.ExtHostStorage(this.g,this.l),this.I=new O.ExtHostSecretState(this.g),this.J=de,this.h=x.createChild(new i.ServiceCollection([C.IExtHostStorage,this.H],[O.IExtHostSecretState,this.I])),this.L=this.B(new k.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:($,q,J)=>{this.v.$onExtensionActivationError($,f.transformErrorForSerialization(q),J)},actualActivateExtension:async($,q)=>{if(d.ExtensionDescriptionRegistry.isHostExtension($,this.F,this.G))return await this.v.$activateExtension($,q),new k.HostExtension;const J=this.F.getExtensionDescription($);return this.Z(J,q)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.ob(),this.w.open(),await this.j.waitForInitializeCall(),c.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.mb()}catch(x){f.onUnexpectedError(x)}}async R(){this.J.onWillDeactivateAll();let x=[];try{x=this.F.getAllExtensionDescriptions().map(Re=>Re.identifier).filter(Re=>this.isActivated(Re)).map(Re=>this.Y(Re))}catch{}await Promise.all(x)}terminate(x,he=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${x}`),this.l.flush(),this.p.dispose(),this.L.dispose(),f.setUnexpectedErrorHandler(Se=>{this.l.error(Se)}),this.g.dispose();const pe=this.R();Promise.race([(0,E.timeout)(5e3),pe]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${he}`):this.l.info(`Extension host exiting with code ${he}`),this.l.flush(),this.l.dispose(),this.c.exit(he)})}isActivated(x){return this.z.isOpen()?this.L.isActivated(x):!1}async getExtension(x){const he=await this.v.$getExtension(x);let pe;if(he?.browserNlsBundleUris){pe={};for(const Se of Object.keys(he.browserNlsBundleUris))pe[Se]=I.URI.revive(he.browserNlsBundleUris[Se])}return he&&{...he,identifier:new p.ExtensionIdentifier(he.identifier.value),extensionLocation:I.URI.revive(he.extensionLocation),browserNlsBundleUris:pe}}S(x,he){return this.L.activateByEvent(x,he)}U(x,he){return this.L.activateById(x,he)}activateByIdWithErrors(x,he){return this.U(x,he).then(()=>{const pe=this.L.getActivatedExtension(x);if(pe.activationFailed)return Promise.reject(pe.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(x=>this.F)}getExtensionExports(x){return this.z.isOpen()?this.L.getActivatedExtension(x).exports:null}async W(x){if(x.scheme!==V.Schemas.file)return x;const he=await this.c.realpath(x.fsPath);return I.URI.file(he)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(x=>new be(x))),this.M}async X(x){const he=S.TernarySearchTree.forUris(pe=>L.extUriBiasedIgnorePathCase.ignorePathCasing(pe));return await Promise.all(x.map(async pe=>{if(this.pb(pe)){const Se=await this.W(pe.extensionLocation);he.set(Se,pe)}})),he}Y(x){let he=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(x))return he;const pe=this.L.getActivatedExtension(x);if(!pe)return he;try{typeof pe.module.deactivate=="function"&&(he=Promise.resolve(pe.module.deactivate()).then(void 0,Se=>(this.l.error(Se),Promise.resolve(void 0))))}catch(Se){this.l.error(`An error occurred when deactivating the extension '${x.value}':`),this.l.error(Se)}try{(0,T.dispose)(pe.subscriptions)}catch(Se){this.l.error(`An error occurred when deactivating the subscriptions for extension '${x.value}':`),this.l.error(Se)}return he}async Z(x,he){return this.f.remote.isRemote?this.v.$onWillActivateExtension(x.identifier):await this.v.$onWillActivateExtension(x.identifier),this.bb(x,he).then(pe=>{const Se=pe.activationTimes;return this.v.$onDidActivateExtension(x.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,he),this.ab(x,he,"success",Se),pe},pe=>{throw this.ab(x,he,"failure"),pe})}ab(x,he,pe,Se){const Re=H(x,he);this.u.$publicLog2("extensionActivationTimes",{...Re,...Se||{},outcome:pe})}bb(x,he){const pe=H(x,he);this.u.$publicLog2("activatePlugin",pe);const Se=this.pb(x);if(!Se)return Promise.resolve(new k.EmptyExtension(k.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${x.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this.l.flush();const Re=new k.ExtensionActivationTimesBuilder(he.startup);return Promise.all([this.qb(x,(0,L.joinPath)(x.extensionLocation,Se),Re),this.cb(x)]).then(re=>(c.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),ln.db(this.l,x.identifier,re[0],re[1],Re))).then(re=>(c.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),re))}cb(x){const he=new g.ExtensionGlobalMemento(x,this.H),pe=new g.ExtensionMemento(x.identifier.value,!1,this.H),Se=new j.ExtensionSecrets(x,this.I),Re=x.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,re=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([he.whenReady,pe.whenReady,this.J.whenReady]).then(()=>{const le=this;let de,te;const ae=(0,o.isProposedApiEnabled)(x,"ipc")?this.f.messagePorts?.get(p.ExtensionIdentifier.toKey(x.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:pe,secrets:Se,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(se){return R.join(x.extensionLocation.fsPath,se)},get storagePath(){return le.J.workspaceValue(x)?.fsPath},get globalStoragePath(){return le.J.globalValue(x).fsPath},get logPath(){return R.join(le.f.logsLocation.fsPath,x.identifier.value)},get logUri(){return I.URI.joinPath(le.f.logsLocation,x.identifier.value)},get storageUri(){return le.J.workspaceValue(x)},get globalStorageUri(){return le.J.globalValue(x)},get extensionMode(){return Re},get extension(){return de===void 0&&(de=new _(le,x.identifier,x,re,!1)),de},get extensionRuntime(){return(0,o.checkProposedApiEnabled)(x,"extensionRuntime"),le.extensionRuntime},get environmentVariableCollection(){return le.p.getEnvironmentVariableCollection(x)},get messagePassingProtocol(){if(!te){if(!ae)return;const se=w.Event.buffer(w.Event.fromDOMEventEmitter(ae,"message",F=>F.data));ae.start(),te={onDidReceiveMessage:se,postMessage:ae.postMessage.bind(ae)}}return te}})})}static db(x,he,pe,Se,Re){return pe=pe||{activate:void 0,deactivate:void 0},this.eb(x,he,pe,Se,Re).then(re=>new k.ActivatedExtension(!1,null,Re.build(),pe,re,Se.subscriptions))}static eb(x,he,pe,Se,Re){if(typeof pe.activate=="function")try{Re.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${he.value}`);const re=typeof global=="object"?global:self,le=pe.activate.apply(re,[Se]);return Re.activateCallStop(),Re.activateResolveStart(),Promise.resolve(le).then(de=>(Re.activateResolveStop(),de))}catch(re){return Promise.reject(re)}else return Promise.resolve(pe)}fb(x,he){this.U(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:he}).then(void 0,pe=>{this.l.error(pe)})}gb(x,he=0){const Se=Date.now();(0,U.setTimeout0)(()=>{for(let Re=he;Re<x.length;Re+=1){const re=x[Re];for(const le of re.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-Se>50){this.gb(x,Re);break}else this.fb(re,le)}})}hb(){this.v.$setPerformanceMarks(c.getMarks()),this.k.getConfigProvider().then(x=>{const he=x.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),pe=this.F.getAllExtensionDescriptions();if(he)this.gb(pe);else for(const Se of pe)if(Se.activationEvents)for(const Re of Se.activationEvents)Re==="onStartupFinished"&&this.fb(Se,Re)})}ib(){const x=this.S("*",!0).then(void 0,Re=>{this.l.error(Re)});this.B(this.j.onDidChangeWorkspace(Re=>this.jb(Re.added)));const he=this.j.workspace?this.j.workspace.folders:[],pe=this.jb(he),Se=Promise.all([x,pe]).then(()=>{});return Promise.race([Se,(0,E.timeout)(1e4)]).then(()=>{this.hb()}),Se}jb(x){return x.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(he=>this.kb(x,he))).then(()=>{})}async kb(x,he){if(this.isActivated(he.identifier))return;const pe=!this.f.remote.isRemote&&!!this.f.remote.authority,Se={logService:this.l,folders:x.map(re=>re.uri),forceUsingSearch:pe,exists:re=>this.c.exists(re.fsPath),checkExists:(re,le,de)=>this.t.$checkExists(re,le,de)},Re=await(0,v.checkActivateWorkspaceContainsExtension)(Se,he);if(!!Re)return this.U(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:Re.activationEvent}).then(void 0,re=>this.l.error(re))}async $extensionTestsExecute(){await this.C.wait();try{return await this.lb()}catch(x){throw console.error(x),x}}async lb(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:he}=this.f.environment;if(!x||!he)throw new Error(a.localize(0,null));const pe=await this.qb(null,he,new k.ExtensionActivationTimesBuilder(!1));if(!pe||typeof pe.run!="function")throw new Error(a.localize(1,null,he.toString()));return new Promise((Se,Re)=>{const re=(te,ae)=>{te?Re(te):Se(typeof ae=="number"&&ae>0?1:0)},le=(0,L.originalFSPath)(he),de=pe.run(le,re);de&&de.then&&de.then(()=>{Se(0)}).catch(te=>{Re(te instanceof Error&&te.stack?te.stack:String(te))})})}mb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(x,he){return this.N[x]=he,(0,T.toDisposable)(()=>{delete this.N[x]})}async nb(x){const he=x.indexOf("+");if(he===-1)throw new Error("Not an authority that can be resolved!");const pe=x.substr(0,he);return await this.w.wait(),await this.S(`onResolveRemoteAuthority:${pe}`,!1),{authorityPrefix:pe,resolver:this.N[pe]}}async $resolveAuthority(x,he){const pe=G.StopWatch.create(!1),Se=()=>`[resolveAuthority(${(0,s.getRemoteAuthorityPrefix)(x)},${he})][${pe.elapsed()}ms] `,Re=ae=>this.l.info(`${Se()}${ae}`),re=(ae,se=void 0)=>this.l.error(`${Se()}${ae}`,se);Re("activating resolver...");const{authorityPrefix:le,resolver:de}=await this.nb(x);if(!de)return re("no resolver"),{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${le}.`,detail:void 0}};const te=new E.IntervalTimer;try{Re("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(de)),te.cancelAndSet(()=>Re("waiting..."),1e3),Re("invoking resolve()..."),c.mark(`code/extHost/willResolveAuthority/${le}`);const ae=await de.resolve(x,{resolveAttempt:he});c.mark(`code/extHost/didResolveAuthorityOK/${le}`),te.dispose(),Re(`returned ${ae.host}:${ae.port}`);const se={authority:x,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},F={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:se,options:F,tunnelInformation:{environmentTunnels:ae.environmentTunnels,features:ae.tunnelFeatures}}}}catch(ae){if(c.mark(`code/extHost/didResolveAuthorityError/${le}`),te.dispose(),re("returned an error",ae),ae instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(x,he){this.l.info(`$getCanonicalURI invoked for authority (${(0,s.getRemoteAuthorityPrefix)(x)})`);const{resolver:pe}=await this.nb(x);if(!pe)return null;const Se=I.URI.revive(he);if(typeof pe.getCanonicalURI>"u")return Se;const Re=await(0,E.asPromise)(()=>pe.getCanonicalURI(Se));return Re||Se}$startExtensionHost(x){x.toAdd.forEach(Se=>Se.extensionLocation=I.URI.revive(Se.extensionLocation));const{globalRegistry:he,myExtensions:pe}=Y(this.D,this.G,this.F,x);return this.G.set(he.getAllExtensionDescriptions()),this.F.set(pe),this.mb()}$activateByEvent(x,he){return he===1?this.S(x,!1):this.z.wait().then(pe=>this.S(x,!1))}async $activate(x,he){return await this.z.wait(),this.F.getExtensionDescription(x)?(await this.U(x,he),!0):!1}async $deltaExtensions(x){x.toAdd.forEach(re=>re.extensionLocation=I.URI.revive(re.extensionLocation));const{globalRegistry:he,myExtensions:pe}=Y(this.D,this.G,this.F,x),Se=await this.X(pe);return(await this.getExtensionPathIndex()).setSearchTree(Se),this.G.set(he.getAllExtensionDescriptions()),this.F.set(pe),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){const he=y.VSBuffer.alloc(x),pe=Math.random()%256;for(let Se=0;Se<x;Se++)he.writeUInt8(pe,Se);return he}async $updateRemoteConnectionData(x){this.Q=x,this.a.fire()}};Z=Ve([ze(0,r.IInstantiationService),ze(1,e.IHostUtils),ze(2,b.IExtHostRpcService),ze(3,m.IExtHostWorkspace),ze(4,D.IExtHostConfiguration),ze(5,N.ILogService),ze(6,l.IExtHostInitDataService),ze(7,u.IExtensionStoragePaths),ze(8,n.IExtHostTunnelService),ze(9,h.IExtHostTerminalService),ze(10,Q.IExtHostLocalizationService)],Z),e.AbstractExtHostExtensionService=Z;function Y(oe,x,he,pe){oe.addActivationEvents(pe.addActivationEvents);const Se=new d.ExtensionDescriptionRegistry(oe,x.getAllExtensionDescriptions());Se.deltaExtensions(pe.toAdd,pe.toRemove);const Re=new p.ExtensionIdentifierSet(he.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of pe.myToRemove)Re.delete(le);for(const le of pe.myToAdd)Re.add(le);const re=ee(Se,Re);return{globalRegistry:Se,myExtensions:re}}function H(oe,x){return{id:oe.identifier.value,name:oe.name,extensionVersion:oe.version,publisherDisplayName:oe.publisher,activationEvents:oe.activationEvents?oe.activationEvents.join(","):null,isBuiltin:oe.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class _{constructor(x,he,pe,Se,Re){P.set(this,void 0),M.set(this,void 0),B.set(this,void 0),Je(this,P,x,"f"),Je(this,M,he,"f"),Je(this,B,pe.identifier,"f"),this.id=pe.identifier.value,this.extensionUri=pe.extensionLocation,this.extensionPath=R.normalize((0,L.originalFSPath)(pe.extensionLocation)),this.packageJSON=pe,this.extensionKind=Se,this.isFromDifferentExtensionHost=Re}get isActive(){return Ue(this,P,"f").isActivated(Ue(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,P,"f").getExtensionExports(Ue(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,P,"f").activateByIdWithErrors(Ue(this,B,"f"),{startup:!1,extensionId:Ue(this,M,"f"),activationEvent:"api"}),this.exports}}e.Extension=_,P=new WeakMap,M=new WeakMap,B=new WeakMap;function ee(oe,x){return oe.getAllExtensionDescriptions().filter(he=>x.has(he.identifier))}class be{constructor(x){this.a=x}setSearchTree(x){this.a=x}findSubstr(x){return this.a.findSubstr(x)}forEach(x){return this.a.forEach(x)}}e.ExtensionPaths=be;class ce{constructor(x){this.a=new p.ExtensionIdentifierMap,this.addActivationEvents(x)}readActivationEvents(x){return this.a.get(x.identifier)}addActivationEvents(x){for(const he of Object.keys(x))this.a.set(he,x[he])}}}),define(De[298],Ce([1,0,83,2,5,35,27,25,20,26,4,42,36,13,8]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let m=class{constructor(g,t,s,r,l,u,b){this.c=g,this.d=t,this.e=s,this.f=r,this.g=l,this.h=u,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),a.mark("code/extHost/willWaitForConfig");const g=await this.f.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new d(this.c,t,this.d,g,this.i)),this.register(this.e.createInstance(f,t)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(p,t,this.h.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const t of g.nodeModuleName)this.a.set(t,g);else this.a.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this.b.push(t=>g.alternativeModuleName(t))}};m=Ve([ze(2,N.IInstantiationService),ze(3,L.IExtHostConfiguration),ze(4,A.IExtHostExtensionService),ze(5,I.IExtHostInitDataService),ze(6,k.ILogService)],m),e.RequireInterceptor=m;let o=class rn{constructor(g){if(g.environment.appRoot&&rn.a.size){const t=(0,C.escapeRegExpCharacters)(this.c(g.environment.appRoot.fsPath)),s="[a-z0-9_.-]",r=`@${s}+\\/${s}+|${s}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${l}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(g){if(!this.b)return;const t=this.b.exec(this.c(g));if(!t)return;const[,s,r,l]=t,u=rn.a.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),s+u+l}c(g){return g.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=Ve([ze(0,I.IExtHostInitDataService)],o);class d{constructor(g,t,s,r,l){this.c=g,this.d=t,this.e=s,this.f=r,this.g=l,this.nodeModuleName="vscode",this.a=new T.ExtensionIdentifierMap}load(g,t){const s=this.d.findSubstr(t);if(s){let r=this.a.get(s.identifier);return r||(r=this.c(s,this.e,this.f),this.a.set(s.identifier,r)),r}if(!this.b){let r="";this.d.forEach((l,u)=>r+=`	${u} -> ${l.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this.b=this.c(E.nullExtensionDescription,this.e,this.f)}return this.b}}let f=class{constructor(g,t,s){this.d=g,this.nodeModuleName="keytar",this.a=t.getProxy(c.MainContext.MainThreadTelemetry);const{environment:r}=s,l=t.getProxy(c.MainContext.MainThreadKeytar);if(r.appRoot){let u=r.appRoot.fsPath;D.platform==="win32"&&(u=u.replace(/\\/g,"/")),u[u.length-1]==="/"&&(u=u.substr(0,u.length-1)),this.b=new Set,this.b.add(`${u}/node_modules.asar/keytar`),this.b.add(`${u}/node_modules/keytar`)}this.c={getPassword:(u,b)=>l.$getPassword(u,b),setPassword:(u,b,i)=>l.$setPassword(u,b,i),deletePassword:(u,b)=>l.$deletePassword(u,b),findPassword:u=>l.$findPassword(u),findCredentials(u){return l.$findCredentials(u)}}}load(g,t){const s=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(g){const t=g.length;if(t<=7||!this.b)return;const s=t-7;if((g.charAt(s)==="/"||g.charAt(s)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.b.has(g)))return"keytar"}};f=Ve([ze(1,S.IExtHostRpcService),ze(2,I.IExtHostInitDataService)],f);let p=class{constructor(g,t,s){this.e=g,this.f=t,this.nodeModuleName=["open","opn"],this.d=s.getProxy(c.MainContext.MainThreadTelemetry);const r=s.getProxy(c.MainContext.MainThreadWindow);this.c=(l,u)=>{const b=R.URI.parse(l);return u?this.g(l,u):b.scheme==="http"||b.scheme==="https"?r.$openUri(b,l,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?r.$openUri(b,l,{}):this.g(l,u)}}load(g,t,s){const r=this.e.findSubstr(t);return r&&(this.a=r.identifier.value,this.h()),this.b=s(g),this.c}g(g,t){return this.i(),this.b(g,t)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};p=Ve([ze(2,S.IExtHostRpcService)],p)}),define(De[50],Ce([1,0,65,6,12,36,4,59,60,42,7,34,235,35]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,E.createDecorator)("IExtHostVariableResolverProvider");class C extends D.AbstractVariableResolverService{constructor(d,f,p,y,g,t,s){function r(){if(p){const l=p.activeEditor();if(l)return l.document.uri;const u=y.tabGroups.all.find(b=>b.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof N.TextDiffTabInput||u.input instanceof N.NotebookDiffEditorTabInput)return u.input.modified;if(u.input instanceof N.TextTabInput||u.input instanceof N.NotebookEditorTabInput||u.input instanceof N.CustomEditorTabInput)return u.input.uri}}}super({getFolderUri:l=>{const u=t.folders.filter(b=>b.name===l);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,u)=>g.getConfiguration(void 0,l).get(u),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=r();if(l)return c.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(f){const l=r();if(l){const u=f.getWorkspaceFolder(l);if(u)return c.normalize(u.uri.fsPath)}}},getSelectedText:()=>{if(p){const l=p.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(p){const l=p.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>d.getExtension(l)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(L.env))}}let m=class extends R.Disposable{constructor(d,f,p,y,g){super(),this.b=d,this.c=f,this.g=p,this.h=y,this.i=g,this.a=new a.Lazy(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new C(this.b,this.c,this.g,this.i,t,r,this.j())})}getResolver(){return this.a.value}j(){}};m=Ve([ze(0,I.IExtHostExtensionService),ze(1,A.IExtHostWorkspace),ze(2,T.IExtHostDocumentsAndEditors),ze(3,k.IExtHostConfiguration),ze(4,S.IExtHostEditorTabs)],m),e.ExtHostVariableResolverProviderService=m}),define(De[84],Ce([1,0,19,3,9,2,4,5,60,42,20,7,34,132,228,35,50]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,l,u,b,i,n){this.D=l,this.E=u,this.F=b,this.G=i,this.H=n,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new R.Emitter,this.n=new R.Emitter,this.o=new R.Emitter,this.u=new R.Emitter,this.k=r.getProxy(T.MainContext.MainThreadDebugService),this.z=new R.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new p(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(h=>{h.onDidChange(w=>{this.I(h)}),this.I(h)})}asDebugSourceUri(r,l){const u=r;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let b=`debug:${encodeURIComponent(u.path||"")}`,i="?";return l&&(b+=`${i}session=${encodeURIComponent(l.id)}`,i="&"),b+=`${i}ref=${u.sourceReference}`,L.URI.parse(b)}else{if(u.path)return L.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(r){const l=[];for(const u of r.getAllExtensionDescriptions())if(u.contributes){const b=u.contributes.debuggers;if(b&&b.length>0)for(const i of b)(0,C.isDebuggerMainContribution)(i)&&l.push(i.type)}this.k.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const r=[];return this.w.forEach(l=>r.push(l)),r}addBreakpoints(r){this.T();const l=r.filter(i=>{const n=i.id;return this.w.has(n)?!1:(this.w.set(n,i),!0)});this.U(l,[],[]);const u=[],b=new Map;for(const i of l)if(i instanceof A.SourceBreakpoint){let n=b.get(i.location.uri.toString());n||(n={type:"sourceMulti",uri:i.location.uri,lines:[]},b.set(i.location.uri.toString(),n),u.push(n)),n.lines.push({id:i.id,enabled:i.enabled,condition:i.condition,hitCondition:i.hitCondition,logMessage:i.logMessage,line:i.location.range.start.line,character:i.location.range.start.character})}else i instanceof A.FunctionBreakpoint&&u.push({type:"function",id:i.id,enabled:i.enabled,hitCondition:i.hitCondition,logMessage:i.logMessage,condition:i.condition,functionName:i.functionName});return this.k.$registerBreakpoints(u)}removeBreakpoints(r){this.T();const l=r.filter(n=>this.w.delete(n.id));this.U([],l,[]);const u=l.filter(n=>n instanceof A.SourceBreakpoint).map(n=>n.id),b=l.filter(n=>n instanceof A.FunctionBreakpoint).map(n=>n.id),i=l.filter(n=>n instanceof A.DataBreakpoint).map(n=>n.id);return this.k.$unregisterBreakpoints(u,b,i)}startDebugging(r,l,u){return this.k.$startDebugging(r?r.uri:void 0,l,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,suppressSaveBeforeStart:u.suppressSaveBeforeStart,suppressDebugStatusbar:u.suppressDebugStatusbar??u.debugUI?.simple,suppressDebugToolbar:u.suppressDebugToolbar??u.debugUI?.simple,suppressDebugView:u.suppressDebugView??u.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,l,u){if(!l)return new A.Disposable(()=>{});const b=this.d++;return this.f.push({type:r,handle:b,provider:l}),this.k.$registerDebugConfigurationProvider(r,u,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,b),new A.Disposable(()=>{this.f=this.f.filter(i=>i.provider!==l),this.k.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(r,l,u){if(!u)return new A.Disposable(()=>{});if(!this.P(r,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.M(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this.g++;return this.h.push({type:l,handle:b,factory:u}),this.k.$registerDebugAdapterDescriptorFactory(l,b),new A.Disposable(()=>{this.h=this.h.filter(i=>i.factory!==u),this.k.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(r,l){if(!l)return new A.Disposable(()=>{});const u=this.i++;return this.j.push({type:r,handle:u,factory:l}),new A.Disposable(()=>{this.j=this.j.filter(b=>b.factory!==l)})}async $runInTerminal(r,l){return Promise.resolve(void 0)}async $substituteVariables(r,l){let u;const b=await this.W(r);return b&&(u={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(u,l)}J(r,l){if(r.type==="implementation")return new g(r.implementation)}K(){}async $startDASession(r,l){const u=this,b=await this.V(l);return this.R(this.M(b.type),b).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const n=this.L(i),h=this.J(n,b);if(!h)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const w=h;return this.A.set(r,w),this.Q(b).then(v=>(v&&this.B.set(r,v),w.onMessage(async O=>{if(O.type==="request"&&O.command==="handshake"){const j=O,V={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const Q=await this.C.sign(j.arguments.value);V.body={signature:Q},w.sendResponse(V)}else throw new Error("no signer")}catch(Q){V.success=!1,V.message=Q.message,w.sendResponse(V)}}else v&&v.onDidSendMessage&&v.onDidSendMessage(O),O=(0,C.convertToVSCPaths)(O,!0),u.k.$acceptDAMessage(r,O)}),w.onError(O=>{v&&v.onError&&v.onError(O),this.k.$acceptDAError(r,O.name,O.message,O.stack)}),w.onExit(O=>{v&&v.onExit&&v.onExit((0,c.withNullAsUndefined)(O),void 0),this.k.$acceptDAExit(r,(0,c.withNullAsUndefined)(O),void 0)}),v&&v.onWillStartSession&&v.onWillStartSession(),w.startSession()))})}$sendDAMessage(r,l){l=(0,C.convertToDAPaths)(l,!1);const u=this.B.get(r);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(l),this.A.get(r)?.sendMessage(l)}$stopDASession(r){const l=this.B.get(r);this.B.delete(r),l&&l.onWillStopSession&&l.onWillStopSession();const u=this.A.get(r);return this.A.delete(r),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const l=[],u=[],b=[];if(r.added)for(const i of r.added){const n=i.id;if(n&&!this.w.has(n)){let h;if(i.type==="function")h=new A.FunctionBreakpoint(i.functionName,i.enabled,i.condition,i.hitCondition,i.logMessage);else if(i.type==="data")h=new A.DataBreakpoint(i.label,i.dataId,i.canPersist,i.enabled,i.hitCondition,i.condition,i.logMessage);else{const w=L.URI.revive(i.uri);h=new A.SourceBreakpoint(new A.Location(w,new A.Position(i.line,i.character)),i.enabled,i.condition,i.hitCondition,i.logMessage)}(0,A.setBreakpointId)(h,n),this.w.set(n,h),l.push(h)}}if(r.removed)for(const i of r.removed){const n=this.w.get(i);n&&(this.w.delete(i),u.push(n))}if(r.changed){for(const i of r.changed)if(i.id){const n=this.w.get(i.id);if(n){if(n instanceof A.FunctionBreakpoint&&i.type==="function"){const h=n;h.enabled=i.enabled,h.condition=i.condition,h.hitCondition=i.hitCondition,h.logMessage=i.logMessage,h.functionName=i.functionName}else if(n instanceof A.SourceBreakpoint&&i.type==="source"){const h=n;h.enabled=i.enabled,h.condition=i.condition,h.hitCondition=i.hitCondition,h.logMessage=i.logMessage,h.location=new A.Location(L.URI.revive(i.uri),new A.Position(i.line,i.character))}b.push(n)}}}this.U(l,u,b)}$provideDebugConfigurations(r,l,u){return(0,a.asPromise)(async()=>{const b=this.O(r);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const i=await this.W(l);return b.provideDebugConfigurations(i,u)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(r,l,u,b){return(0,a.asPromise)(async()=>{const i=this.O(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const n=await this.W(l);return i.resolveDebugConfiguration(n,u,b)})}$resolveDebugConfigurationWithSubstitutedVariables(r,l,u,b){return(0,a.asPromise)(async()=>{const i=this.O(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const n=await this.W(l);return i.resolveDebugConfigurationWithSubstitutedVariables(n,u,b)})}async $provideDebugAdapter(r,l){const u=this.N(r);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.V(l);return this.R(u,b).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.L(i)})}async $acceptDebugSessionStarted(r){const l=await this.V(r);this.m.fire(l)}async $acceptDebugSessionTerminated(r){const l=await this.V(r);l&&(this.n.fire(l),this.l.delete(l.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,l){(await this.V(r))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(r,l){const b={session:await this.V(r),event:l.event,body:l.body};this.u.fire(b)}L(r){if(r instanceof A.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof A.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}M(r){const l=this.h.filter(u=>u.type===r);if(l.length>0)return l[0].factory}N(r){const l=this.h.filter(u=>u.handle===r);if(l.length>0)return l[0].factory}O(r){const l=this.f.filter(u=>u.handle===r);if(l.length>0)return l[0].provider}P(r,l){if(r.contributes){const u=r.contributes.debuggers;if(u&&u.length>0){for(const b of u)if(b.label&&b.type&&b.type===l)return!0}}return!1}Q(r){const u=r.configuration.type,b=this.j.filter(i=>i.type===u||i.type==="*").map(i=>(0,a.asPromise)(()=>i.factory.createDebugAdapterTracker(r)).then(n=>n,n=>null));return Promise.race([Promise.all(b).then(i=>{const n=i.filter(h=>!!h);if(n.length>0)return new y(n)}),new Promise(i=>setTimeout(()=>i(void 0),1e3))]).catch(i=>{})}async R(r,l){const u=l.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new A.DebugAdapterServer(u));if(r){const i=await this.E.getExtensionRegistry();return(0,a.asPromise)(()=>r.createDebugAdapterDescriptor(l,this.S(l,i))).then(n=>{if(n)return n})}const b=await this.E.getExtensionRegistry();return Promise.resolve(this.S(l,b))}S(r,l){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(r,l,u){(r.length>0||l.length>0||u.length>0)&&this.z.fire(Object.freeze({added:r,removed:l,changed:u}))}async V(r){if(r)if(typeof r=="string"){const l=this.l.get(r);if(l)return l}else{let l=this.l.get(r.id);if(!l){const u=await this.W(r.folderUri),b=r.parent?this.l.get(r.parent):void 0;l=new f(this.k,r.id,r.type,r.name,u,r.configuration,b),this.l.set(l.id,l),this.k.$sessionCached(l.id)}return l}throw new Error("cannot find session")}W(r){if(r){const l=L.URI.revive(r);return this.D.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};d=Ve([ze(0,N.IExtHostRpcService),ze(1,D.IExtHostWorkspace),ze(2,I.IExtHostExtensionService),ze(3,m.IExtHostConfiguration),ze(4,S.IExtHostEditorTabs),ze(5,o.IExtHostVariableResolverProvider)],d),e.ExtHostDebugServiceBase=d;class f{constructor(r,l,u,b,i,n,h){this.d=r,this.f=l,this.g=u,this.h=b,this.i=i,this.j=n,this.k=h}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,l){return this.d.$customDebugAdapterRequest(this.f,r,l)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=f;class p{constructor(r){this.value=Object.freeze({append(l){r.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=p;class y{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(l=>l.onError?l.onError(r):void 0)}onExit(r,l){this.d.forEach(u=>u.onExit?u.onExit(r,l):void 0)}}class g extends k.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=class extends d{constructor(r,l,u,b,i,n){super(r,l,u,b,i,n)}};t=Ve([ze(0,N.IExtHostRpcService),ze(1,D.IExtHostWorkspace),ze(2,I.IExtHostExtensionService),ze(3,m.IExtHostConfiguration),ze(4,S.IExtHostEditorTabs),ze(5,o.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(De[299],Ce([1,0,10,83,2,5,291,13,90,91,26,204,20,56,42,76]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class o{static async installEarlyHandler(p){const y=p.get(T.ILogService),t=p.get(D.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(s=>{y.error(s);const r=a.transformErrorForSerialization(s);t.$onUnexpectedError(r)})}static async installFullHandler(p){const y=p.get(T.ILogService),g=p.get(D.IExtHostRpcService),t=p.get(C.IExtHostExtensionService),s=p.get(m.IExtHostTelemetry),r=g.getProxy(L.MainContext.MainThreadExtensionService),l=g.getProxy(L.MainContext.MainThreadErrors),u=await t.getExtensionPathIndex(),b=new WeakMap;Error.prepareStackTrace=(i,n)=>{let h="",w,v;for(const O of n)h+=`
	at ${O.toString()}`,v=O.getFileName(),!w&&v&&(w=u.findSubstr(c.URI.file(v)));return b.set(i,w?.identifier),`${i.name||"Error"}: ${i.message||""}${h}`},a.setUnexpectedErrorHandler(i=>{y.error(i);const n=a.transformErrorForSerialization(i),h=b.get(i);if(!h){l.$onUnexpectedError(n);return}r.$onExtensionRuntimeError(h,n);const w=s.onExtensionError(h,i);y.trace("forwarded error to extension?",w,h)})}}Error.stackTraceLimit=100;class d{constructor(p,y,g,t,s){this.a=g,this.b=new E.RPCProtocol(p,null,t),y=d.e(y,this.b);const r=new I.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());r.set(N.IExtHostInitDataService,{_serviceBrand:void 0,...y,messagePorts:s}),r.set(D.IExtHostRpcService,new D.ExtHostRpcService(this.b)),r.set(k.IURITransformerService,new k.URITransformerService(t)),r.set(C.IHostUtils,g);const l=new A.InstantiationService(r,!0);l.invokeFunction(o.installEarlyHandler),this.d=l.invokeFunction(u=>u.get(T.ILogService)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",y),this.c=l.invokeFunction(u=>u.get(C.IExtHostExtensionService)),this.c.initialize(),l.invokeFunction(o.installFullHandler)}async asBrowserUri(p){const y=this.b.getProxy(L.MainContext.MainThreadExtensionService);return c.URI.revive(await y.$asBrowserUri(p))}terminate(p){this.c.terminate(p)}static e(p,y){p.allExtensions.forEach(t=>{t.extensionLocation=c.URI.revive(y.transformIncomingURIs(t.extensionLocation));const s={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(r=>s[r]=c.URI.revive(y.transformIncomingURIs(t.browserNlsBundleUris[r]))),t.browserNlsBundleUris=s)}),p.environment.appRoot=c.URI.revive(y.transformIncomingURIs(p.environment.appRoot));const g=p.environment.extensionDevelopmentLocationURI;return g&&(p.environment.extensionDevelopmentLocationURI=g.map(t=>c.URI.revive(y.transformIncomingURIs(t)))),p.environment.extensionTestsLocationURI=c.URI.revive(y.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=c.URI.revive(y.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=c.URI.revive(y.transformIncomingURIs(p.environment.workspaceStorageHome)),p.environment.extensionTelemetryLogResource=c.URI.revive(y.transformIncomingURIs(p.environment.extensionTelemetryLogResource)),p.nlsBaseUrl=c.URI.revive(y.transformIncomingURIs(p.nlsBaseUrl)),p.logsLocation=c.URI.revive(y.transformIncomingURIs(p.logsLocation)),p.logFile=c.URI.revive(y.transformIncomingURIs(p.logFile)),p.workspace=y.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=d}),define(De[300],Ce([1,0,19,11,186,203,211,84,60,42,20,41,7,50,34,229,231,35]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let f=class extends T.ExtHostDebugServiceBase{constructor(s,r,l,u,b,i,n){super(s,r,l,u,i,n),this.Z=b,this.X=new g}J(s,r){switch(s.type){case"server":return new m.SocketDebugAdapter(s);case"pipeServer":return new m.NamedPipeDebugAdapter(s);case"executable":return new m.ExecutableDebugAdapter(s,r.type)}return super.J(s,r)}S(s,r){const l=m.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),s.type);if(l)return new D.DebugAdapterExecutable(l.command,l.args,l.options)}K(){return new E.SignService}async $runInTerminal(s,r){if(s.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(Q=>{this.X.onTerminalClosed(Q)}));const l=await this.F.getConfigProvider(),u=this.Z.getDefaultShell(!0),b=this.Z.getDefaultShellArgs(!0),i=s.title||c.localize(0,null),n=JSON.stringify({shell:u,shellArgs:b});let h=await this.X.checkout(n,i),w,v=!1;if(h)w=s.cwd;else{const Q={shellPath:u,shellArgs:b,cwd:s.cwd,name:i,iconPath:new D.ThemeIcon("debug")};v=!0,h=this.Z.createTerminalFromOptions(Q,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(h,n)}h.show(!0);const O=await h.processId;v?await new Promise(Q=>setTimeout(Q,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0||u.indexOf("cmd.exe")>=0?h.sendText("cls"):u.indexOf("bash")>=0?h.sendText("clear"):R.isWindows?h.sendText("cls"):h.sendText("clear"));const j=(0,o.prepareCommand)(u,s.args,!!s.argsCanBeInterpretedByShell,w,s.env);h.sendText(j);const V=this.onDidTerminateDebugSession(Q=>{Q.id===r&&(this.X.free(h),V.dispose())});return O}else if(s.kind==="external")return y(s,await this.F.getConfigProvider());return super.$runInTerminal(s,r)}};f=Ve([ze(0,N.IExtHostRpcService),ze(1,C.IExtHostWorkspace),ze(2,I.IExtHostExtensionService),ze(3,d.IExtHostConfiguration),ze(4,A.IExtHostTerminalService),ze(5,S.IExtHostEditorTabs),ze(6,k.IExtHostVariableResolverProvider)],f),e.ExtHostDebugService=f;let p;function y(t,s){if(!p)if(R.isWindows)p=new L.WindowsExternalTerminalService;else if(R.isMacintosh)p=new L.MacExternalTerminalService;else if(R.isLinux)p=new L.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=s.getConfiguration("terminal");return p.runInTerminal(t.title,t.cwd,t.args,t.env||{},r.external||{})}class g{constructor(){this.b=new Map}async checkout(s,r){const u=[...this.b.entries()].map(([b,i])=>(0,a.createCancelablePromise)(async n=>{if(b.name!==r||i.lastUsedAt!==-1&&await(0,o.hasChildProcesses)(await b.processId))return null;const h=Date.now();return i.lastUsedAt+g.a>h||n.isCancellationRequested||i.config!==s?null:(i.lastUsedAt=h,b)}));return await(0,a.firstParallel)(u,b=>!!b)}insert(s,r){this.b.set(s,{lastUsedAt:Date.now(),config:r})}free(s){const r=this.b.get(s);r&&(r.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}g.a=1e3}),define(De[301],Ce([1,0,12,2,116,34,59,35,48,41,20,26,82,16,13,77,24,89,50]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let p=class extends D.ExtHostTaskBase{constructor(g,t,s,r,l,u,b,i,n){super(g,t,s,r,l,u,b,i),this.B=s,this.C=n,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,t){const s=t;if(!t.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const r=D.TaskHandleDTO.from(s,this.B),l=await this.a.$getTaskExecution(r);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.y(l,t);return this.a.$executeTask(r).catch(()=>{}),u}else{const r=D.TaskDTO.from(t,g);if(r===void 0)return Promise.reject(new Error("Task is not valid"));D.CustomExecutionDTO.is(r.execution)&&await this.x(r,t,!1);const l=await this.y(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),l}}u(g,t,s,r){const l=[];if(r)for(const u of r){this.z(u,s),(!u.definition||!g[u.definition.type])&&this.f.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const b=D.TaskDTO.from(u,s.extension);b&&(l.push(b),D.CustomExecutionDTO.is(b.execution)&&t.push(this.x(b,u,!0)))}return{tasks:l,extension:s.extension}}async v(g){return g}async F(g){let t=g&&g.length>0?g[0]:void 0;if(!t){const s=R.URI.file((0,d.homedir)());t=new S.WorkspaceFolder({uri:s,name:o.basename(s),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,t){const s=R.URI.revive(g),r={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(s),u=await this.b.getWorkspaceFolders2()??[],b=await this.C.getResolver(),i=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(u);for(const n of t.variables)r.variables[n]=await b.resolveAsync(i,n);if(t.process!==void 0){let n;if(t.process.path!==void 0){n=t.process.path.split(a.delimiter);for(let h=0;h<n.length;h++)n[h]=await b.resolveAsync(i,n[h])}r.process=await c.win32.findExecutable(await b.resolveAsync(i,t.process.name),t.process.cwd!==void 0?await b.resolveAsync(i,t.process.cwd):void 0,n)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(g,t,s){return c.win32.findExecutable(g,t,s)}};p=Ve([ze(0,N.IExtHostRpcService),ze(1,A.IExtHostInitDataService),ze(2,L.IExtHostWorkspace),ze(3,E.IExtHostDocumentsAndEditors),ze(4,T.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,C.ILogService),ze(7,m.IExtHostApiDeprecationService),ze(8,f.IExtHostVariableResolverProvider)],p),e.ExtHostTask=p}),define(De[302],Ce([1,0,89,50]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class c extends R.ExtHostVariableResolverProviderService{j(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=c}),define(De[144],Ce([1,0,15,19,21,45,16,12,24,2,31]),function(ie,e,a,R,c,L,E,T,S,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class A{constructor(f,p,y,g){this.d=f,this.e=p,this.f=y,this.g=g,this.a=null,this.b=!1,this.c=0}search(f,p){const y=this.d.folderQueries||[],g=new c.CancellationTokenSource;return p.onCancellationRequested(()=>g.cancel()),new Promise((t,s)=>{this.a=new k(f);let r=!1;const l=(u,b)=>{if(!r&&!this.b){const i=this.h(u);m(u)&&typeof this.d.maxResults=="number"&&this.c+i>this.d.maxResults&&(this.b=!0,r=!0,g.cancel(),u=this.j(u,this.d.maxResults-this.c));const n=this.h(u);this.c+=n,(n>0||!m(u))&&this.a.add(u,b)}};Promise.all(y.map((u,b)=>this.k(u,i=>l(i,b),g.token))).then(u=>{g.dispose(),this.a.flush();const b=u.some(i=>!!i&&!!i.limitHit);t({limitHit:this.b||b,messages:(0,a.flatten)(u.map(i=>i?.message?Array.isArray(i.message)?i.message:[i.message]:[])),stats:{type:this.g}})},u=>{g.dispose();const b=(0,L.toErrorMessage)(u);s(new Error(b))})})}h(f){return m(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}j(f,p){const y=Array.isArray(f.ranges)?f.ranges:[f.ranges],g=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:y.slice(0,p),preview:{matches:g.slice(0,p),text:f.preview.text},uri:f.uri}}async k(f,p,y){const g=new N.QueryGlobTester(this.d,f),t=[],s={report:u=>{if(!this.l(u))return;const b=f.folder.scheme===E.Schemas.file?(0,N.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(u.uri))):void 0,i=S.relativePath(f.folder,u.uri);if(i){const n=g.includedInQuery(i,T.basename(i),b);(0,R.isThenable)(n)?t.push(n.then(h=>{h&&p(u)})):n&&p(u)}}},r=this.n(f),l=await this.e.provideTextSearchResults(D(this.d.contentPattern),r,s,y);return t.length&&await Promise.all(t),l}l(f){if(m(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(f){const p=(0,N.resolvePatternsForProvider)(this.d.includePattern,f.includePattern),y=(0,N.resolvePatternsForProvider)(this.d.excludePattern,f.excludePattern),g={folder:I.URI.from(f.folder),excludes:y,includes:p,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.f.toCanonicalName(f.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return g.usePCRE2=this.d.usePCRE2,g}}e.TextSearchManager=A;function D(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class k{constructor(f){this.e=f,this.b=-1,this.d=null,this.a=new o(512,p=>this.g(p))}add(f,p){this.d&&(this.b!==p||!S.isEqual(this.c,f.uri))&&(this.f(),this.d=null),this.d||(this.b=p,this.d={resource:f.uri,results:[]}),this.d.results.push(C(f))}f(){const f=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,f)}flush(){this.f(),this.a.flush()}g(f){this.e(f)}}e.TextSearchResultsCollector=k;function C(d){return m(d)?{preview:{matches:(0,a.mapArrayOrNot)(d.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:d.preview.text},ranges:(0,a.mapArrayOrNot)(d.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function m(d){return!!d.preview}e.extensionResultIsMatch=m;class o{constructor(f,p){this.g=f,this.h=p,this.c=0,this.d=[],this.e=0}addItem(f,p){!f||this.j(f,p)}addItems(f,p){!f||this.k(f,p)}j(f,p){this.d.push(f),this.e+=p,this.l()}k(f,p){this.d=this.d.concat(f),this.e+=p,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}o.a=4e3,o.b=50,e.BatchedCollector=o}),define(De[85],Ce([1,0,6,5,4,295,20,56,13,2,144]),function(ie,e,a,R,c,L,E,T,S,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,c.createDecorator)("IExtHostSearch");let A=class{constructor(m,o,d){this.k=m,this.l=o,this.n=d,this.c=this.k.getProxy(R.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.FileSearchManager}o(m){return this.l.transformOutgoingScheme(m)}registerTextSearchProvider(m,o){if(this.g.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this.g.add(m);const d=this.d++;return this.e.set(d,o),this.c.$registerTextSearchProvider(d,this.o(m)),(0,a.toDisposable)(()=>{this.g.delete(m),this.e.delete(d),this.c.$unregisterProvider(d)})}registerFileSearchProvider(m,o){if(this.i.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this.i.add(m);const d=this.d++;return this.h.set(d,o),this.c.$registerFileSearchProvider(d,this.o(m)),(0,a.toDisposable)(()=>{this.i.delete(m),this.h.delete(d),this.c.$unregisterProvider(d)})}$provideFileSearchResults(m,o,d,f){const p=D(d),y=this.h.get(m);if(y)return this.j.fileSearch(p,y,g=>{this.c.$handleFileMatch(m,o,g.map(t=>t.resource))},f);throw new Error("unknown provider: "+m)}$clearCache(m){return this.j.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,o,d,f){const p=this.e.get(m);if(!p||!p.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const y=D(d);return this.q(y,p).search(t=>this.c.$handleTextMatch(m,o,t),f)}$enableExtensionHostSearch(){}q(m,o){return new N.TextSearchManager(m,o,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};A=Ve([ze(0,E.IExtHostRpcService),ze(1,T.IURITransformerService),ze(2,S.ILogService)],A),e.ExtHostSearch=A;function D(C){return{...C,folderQueries:C.folderQueries&&C.folderQueries.map(k),extraFileResources:C.extraFileResources&&C.extraFileResources.map(m=>I.URI.revive(m))}}e.reviveQuery=D;function k(C){return{...C,folder:I.URI.revive(C.folder)}}}),define(De[303],Ce([1,0,90,143,34,140,35,40,59,41,82,84,85,99,55,77,142,78,49,98,76,60,141,13,220,50,97]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f,p,y,g,t,s,r,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(u.IExtHostLocalizationService,u.ExtHostLocalizationService,1),(0,a.registerSingleton)(s.ILoggerService,t.ExtHostLoggerService,1),(0,a.registerSingleton)(s.ILogService,r.ExtHostLogService,1),(0,a.registerSingleton)(m.IExtHostApiDeprecationService,m.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands,0),(0,a.registerSingleton)(E.IExtHostConfiguration,E.ExtHostConfiguration,0),(0,a.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(A.IExtHostDebugService,A.WorkerExtHostDebugService,0),(0,a.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,a.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(f.IExtHostFileSystemInfo,f.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService,1),(0,a.registerSingleton)(D.IExtHostSearch,D.ExtHostSearch,0),(0,a.registerSingleton)(k.IExtHostStorage,k.ExtHostStorage,0),(0,a.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask,0),(0,a.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(C.IExtHostTunnelService,C.ExtHostTunnelService,0),(0,a.registerSingleton)(o.IExtHostWindow,o.ExtHostWindow,0),(0,a.registerSingleton)(c.IExtHostWorkspace,c.ExtHostWorkspace,0),(0,a.registerSingleton)(p.IExtHostSecretState,p.ExtHostSecretState,0),(0,a.registerSingleton)(y.IExtHostTelemetry,y.ExtHostTelemetry,0),(0,a.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs,0),(0,a.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(De[100],Ce([1,0,15,13,31,81]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function E(A){return A.startsWith("**")||A.startsWith("/")?A:`/${A}`}e.anchorGlob=E;function T(A,D,k,C){const m=(0,a.mapArrayOrNot)(k,S),o=new c.TextSearchMatch(D,m,C),d=o.preview.matches;return{ranges:(0,a.mapArrayOrNot)(m,I),uri:A,preview:{text:o.preview.text,matches:(0,a.mapArrayOrNot)(d,I)}}}e.createTextSearchResult=T;function S(A){return new c.SearchRange(A.start.line,A.start.character,A.end.line,A.end.character)}function I(A){return new L.Range(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn)}let N=class{constructor(D,k){this.a=D,this.b=k}appendLine(D){this.b.debug(`${this.a}#search`,D)}};N=Ve([ze(1,R.ILogService)],N),e.OutputChannel=N}),define(De[304],Ce([1,0,47,12,86,33,11,8,100,305]),function(ie,e,a,R,c,L,E,T,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const N=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function A(p,y,g,t){const s=D(p,y,g,t),r=y.folder.fsPath;return{cmd:a.spawn(N,s.args,{cwd:r}),rgDiskPath:N,siblingClauses:s.siblingClauses,rgArgs:s,cwd:r}}e.spawnRipgrepCmd=A;function D(p,y,g,t){const s=["--files","--hidden","--case-sensitive"];C([y],g,!1).forEach(l=>{const u=(0,S.anchorGlob)(l);if(s.push("-g",u),E.isMacintosh){const b=(0,c.normalizeNFD)(u);b!==u&&s.push("-g",b)}});const r=k([y],t,void 0,!1);return r.globArgs.forEach(l=>{const u=`!${(0,S.anchorGlob)(l)}`;if(s.push("-g",u),E.isMacintosh){const b=(0,c.normalizeNFD)(u);b!==u&&s.push("-g",b)}}),y.disregardIgnoreFiles!==!1?s.push("--no-ignore"):y.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),y.ignoreSymlinks||s.push("--follow"),p.exists&&s.push("--quiet"),s.push("--no-config"),y.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:r.siblingClauses}}function k(p,y,g,t=!0){const s=[];let r={};return p.forEach(l=>{const u=Object.assign({},l.excludePattern||{},y||{}),b=m(u,t?l.folder.fsPath:void 0,g);s.push(...b.globArgs),b.siblingClauses&&(r=Object.assign(r,b.siblingClauses))}),{globArgs:s,siblingClauses:r}}function C(p,y,g=!0){const t=[];return p.forEach(s=>{const r=Object.assign({},y||{},s.includePattern||{}),l=m(r,g?s.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function m(p,y,g){const t=[],s={};return Object.keys(p).forEach(r=>{if(g&&g.has(r)||!r)return;const l=p[r];r=d(y?o(y,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof l=="boolean"&&l?(r.startsWith("\\\\")&&(r+="**"),t.push(f(r))):l&&l.when&&(s[r]=l)}),{globArgs:t,siblingClauses:s}}function o(p,y){return R.isAbsolute(y)?y:R.join(p,y)}e.getAbsoluteGlob=o;function d(p){return p=T.rtrim(p,"\\"),T.rtrim(p,"/")}function f(p){return L.getRoot(p).toLowerCase()==="c:/"?p.replace(/^c:[/\\]/i,"/"):p}e.fixDriveC=f}),define(De[306],Ce([1,0,47,70,12,307,15,45,38,86,33,11,43,8,9,29,31,304,111]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const p=new Set;process.on("exit",()=>{p.forEach(r=>r())});class y{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&S.parse(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,f.prepareQuery)(this.b).normalizedLowercase),this.u=l.excludePattern&&S.parse(l.excludePattern),this.t=new Map,l.folderQueries.forEach(u=>{const b=Object.assign({},u.excludePattern||{},this.a.excludePattern||{}),i=u.folder.fsPath;l.folderQueries.map(n=>n.folder.fsPath).filter(n=>n!==i).forEach(n=>{(0,N.isEqualOrParent)(n,i)&&(b[c.relative(i,n)]=!0)}),this.t.set(i,new t(b,i))})}cancel(){this.l=!0,p.forEach(l=>l())}walk(l,u,b,i,n){if(this.m=D.StopWatch.create(!1),this.l)return n(null,this.j);u.forEach(h=>{const w=c.basename(h.fsPath);this.u&&this.u(h.fsPath,w)||this.J(b,{relativePath:h.fsPath,searchPath:void 0})}),this.r=D.StopWatch.create(!1),this.w(l,(h,w)=>{this.x(this.y,this,h,b,i,v=>{if(v){const O=(0,T.toErrorMessage)(v);console.error(O),this.q.push(O),w(v,void 0)}else w(null,void 0)})},(h,w)=>{this.m.stop();const v=h?E.coalesce(h)[0]:null;n(v,this.j)})}w(l,u,b){const i=new Array(l.length),n=new Array(l.length);let h=!1,w=0;if(l.length===0)return b(null,[]);l.forEach((v,O)=>{u(v,(j,V)=>{if(j?(h=!0,i[O]=null,n[O]=j):(i[O]=V,n[O]=null),++w===l.length)return b(h?n:null,i)})})}x(l,u,...b){try{l.apply(u,b)}catch(i){b[b.length-1](i)}}y(l,u,b,i){const n=l.folder.fsPath,h=A.isMacintosh,w=()=>Q&&Q.kill();p.add(w);let v=M=>{p.delete(w),v=()=>{},i(M)},O="";const j=this.D(),V=(0,d.spawnRipgrepCmd)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),Q=V.cmd,G=!Object.keys(V.siblingClauses).length,U=V.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let P=`${V.rgDiskPath} ${U}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(P+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),b({message:P}),this.s=0,this.z(Q,"utf8",b,(M,B,Z)=>{if(M){v(M);return}if(this.j){v();return}const H=(O+(h?I.normalizeNFC(B||""):B)).split(`
`);if(Z){const _=H.length;H[_-1]=H[_-1].trim(),H[_-1]||H.pop()}else O=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=H.length,G){for(const _ of H)if(this.J(u,{base:n,relativePath:_,searchPath:this.N(l,_)}),this.j){w();break}(Z||this.j)&&v();return}this.G(l,j,n,H,u),Z&&(this.H(j,n,u),v())})}spawnFindCmd(l){const u=this.t.get(l.folder.fsPath),b=u.getBasenameTerms(),i=u.getPathTerms(),n=["-L","."];if(b.length||i.length){n.push("-not","(","(");for(const h of b)n.push("-name",h),n.push("-o");for(const h of i)n.push("-path",h),n.push("-o");n.pop(),n.push(")","-prune",")")}return n.push("-type","f"),a.spawn("find",n,{cwd:l.folder.fsPath})}readStdout(l,u,b){let i="";this.z(l,u,()=>{},(n,h,w)=>{if(n){b(n);return}i+=h,w&&b(null,i)})}z(l,u,b,i){let n=(v,O,j)=>{(v||j)&&(n=()=>{},this.r?.stop()),i(v,O,j)},h=!1;l.stdout?(this.A(l.stdout,u,n),l.stdout.once("data",()=>h=!0)):b({message:"stdout is null"});let w;l.stderr?w=this.B(l.stderr):b({message:"stderr is null"}),l.on("error",v=>{n(v)}),l.on("close",v=>{let O;!h&&(O=this.C(w,u))&&s(O)?n(new Error(`command failed with error code ${v}: ${this.C(w,u)}`)):(this.g&&v===0&&(this.j=!0),n(null,"",!0))})}A(l,u,b){const i=new L.StringDecoder(u);return l.on("data",n=>{b(null,i.write(n))}),i}B(l){const u=[];return l.on("data",b=>{u.push(b)}),u}C(l,u){const b=new L.StringDecoder(u);return l.map(i=>b.write(i)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:u},b,i,n){i.indexOf(this.b)!==-1&&this.J(n,{base:b,relativePath:this.b,searchPath:this.N(l,this.b)});const h=w=>{const v=c.basename(w),O=c.dirname(w);let j=u[O];j||(j=u[O]=[],h(O)),j.push({base:b,relativePath:w,basename:v,searchPath:this.N(l,w)})};i.forEach(h)}H({rootEntries:l,pathToEntries:u},b,i){const n=this,h=this.t.get(b),w=this.b;function v(O){n.o++;const j=(0,o.hasSiblingFn)(()=>O.map(V=>V.basename));for(let V=0,Q=O.length;V<Q;V++){const G=O[V],{relativePath:U,basename:P}=G;if(h.test(U,P,w!==P?j:void 0))continue;const M=u[U];if(M)v(M);else{if(n.p++,U===w)continue;n.J(i,G)}if(n.j)break}}v(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,u,b,i,n){const h=l.folder,w=(0,o.hasSiblingFn)(()=>b);this.w(b,(v,O)=>{if(this.l||this.j)return O(null);const j=u?[u,v].join(c.sep):v;if(this.t.get(l.folder.fsPath).test(j,v,this.a.filePattern!==v?w:void 0))return O(null);const V=[h.fsPath,j].join(c.sep);R.lstat(V,(Q,G)=>{if(Q||this.l||this.j)return O(null);this.L(V,G,(U,P)=>U||this.l||this.j?O(null):P.isDirectory()?(this.o++,this.M(V,G,(M,B)=>M||this.l||this.j||(B=B||"",this.v[B])?O(null):(this.v[B]=!0,m.Promises.readdir(V).then(Z=>{if(this.l||this.j)return O(null);this.I(l,j,Z,i,Y=>O(Y||null))},Z=>{O(null)})))):(this.p++,j===this.b||this.h&&C.isNumber(P.size)&&P.size>this.h||this.J(i,{base:h.fsPath,relativePath:j,searchPath:this.N(l,j)}),O(null,void 0)))})},v=>{const O=v&&E.coalesce(v);return n(O&&O.length>0?O[0]:void 0)})}J(l,u){this.K(u)&&(!this.d||this.d(u.relativePath,c.basename(u.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(u))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,o.isFilePatternMatch)(l,this.c)}return!0}L(l,u,b){return u.isSymbolicLink()?R.stat(l,b):b(null,u)}M(l,u,b){return u.isSymbolicLink()?R.realpath(l,(i,n)=>i?b(i):b(null,n)):b(null,l)}N(l,u){return l.folderName?c.join(l.folderName,u):u}}e.FileWalker=y;class g{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new y(l)}search(l,u,b){this.c.walk(this.a,this.b,l,u,(i,n)=>{b(i,{limitHit:n,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=g;class t{constructor(l,u){this.expression=l,this.c=u,this.d(l)}d(l){let u,b;Object.keys(l).filter(i=>l[i]).forEach(i=>{c.isAbsolute(i)?(u=u||S.getEmptyExpression(),u[i]=l[i]):(b=b||S.getEmptyExpression(),b[i]=l[i])}),this.a=u&&S.parse(u,{trimForExclusions:!0}),this.b=b&&S.parse(b,{trimForExclusions:!0})}test(l,u,b){return this.b&&this.b(l,u,b)||this.a&&this.a(c.join(this.c,l),u,b)}getBasenameTerms(){const l=[];return this.a&&l.push(...S.getBasenameTerms(this.a)),this.b&&l.push(...S.getBasenameTerms(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...S.getPathTerms(this.a)),this.b&&l.push(...S.getPathTerms(this.b)),l}}function s(r){const l=r.trim().split(`
`),u=l[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return k.uppercaseFirstLetter(l[l.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}}),define(De[308],Ce([1,0,103,22]),function(ie,e,a,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function c(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(l=>l===r)}e.isUTFEncoding=c,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const L=512,E=512,T=512*8,S=512*128;var I;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class N extends Error{constructor(l,u){super(l),this.decodeStreamErrorKind=u}}e.DecodeStreamError=N;class A{static async create(l){let u;if(l!==e.UTF8)u=(await new Promise((i,n)=>{ie(["@vscode/iconv-lite-umd"],i,n)})).getDecoder(m(l));else{const b=new TextDecoder;u={write(i){return b.decode(i,{stream:!0})},end(){return b.decode()}}}return new A(u)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function D(r,l){const u=l.minBytesRequiredForDetection??l.guessEncoding?T:E;return new Promise((b,i)=>{const n=(0,a.newWriteableStream)(V=>V.join("")),h=[];let w=0,v;const O=async()=>{try{const V=await s({buffer:R.VSBuffer.concat(h),bytesRead:w},l.guessEncoding);if(V.seemsBinary&&l.acceptTextOnly)throw new N("Stream is binary but only text is accepted for decoding",1);V.encoding=await l.overwriteEncoding(V.encoding),v=await A.create(V.encoding);const Q=v.write(R.VSBuffer.concat(h).buffer);n.write(Q),h.length=0,w=0,b({stream:n,detected:V})}catch(V){j?.dispose(),n.destroy(),i(V)}},j=(0,a.listenStream)(r,{onData:async V=>{v?n.write(v.write(V.buffer)):(h.push(V),w+=V.byteLength,w>=u&&(r.pause(),await O(),setTimeout(()=>r.resume())))},onError:V=>n.error(V),onEnd:async()=>{v||await O(),n.end(v?.end())}})})}e.toDecodeStream=D;async function k(r,l,u){const i=(await new Promise((w,v)=>{ie(["@vscode/iconv-lite-umd"],w,v)})).getEncoder(m(l),u);let n=!1,h=!1;return{read(){if(h)return null;const w=r.read();if(typeof w!="string"){if(h=!0,!n&&u?.addBOM)switch(l){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const v=i.end();return v&&v.length>0?(n=!0,R.VSBuffer.wrap(v)):null}return n=!0,R.VSBuffer.wrap(i.write(w))}}}e.toEncodeReadable=k;async function C(r){return(await new Promise((u,b)=>{ie(["@vscode/iconv-lite-umd"],u,b)})).encodingExists(m(r))}e.encodingExists=C;function m(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=m;function o(r,l){if(!r||l<e.UTF16be_BOM.length)return null;const u=r.readUInt8(0),b=r.readUInt8(1);if(u===e.UTF16be_BOM[0]&&b===e.UTF16be_BOM[1])return e.UTF16be;if(u===e.UTF16le_BOM[0]&&b===e.UTF16le_BOM[1])return e.UTF16le;if(l<e.UTF8_BOM.length)return null;const i=r.readUInt8(2);return u===e.UTF8_BOM[0]&&b===e.UTF8_BOM[1]&&i===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=o;const d=["ascii","utf-16","utf-32"];async function f(r){const l=await new Promise((h,w)=>{ie(["jschardet"],h,w)}),u=r.slice(0,S),b=g(u.buffer),i=l.detect(b);if(!i||!i.encoding)return null;const n=i.encoding.toLowerCase();return 0<=d.indexOf(n)?null:y(i.encoding)}const p={ibm866:"cp866",big5:"cp950"};function y(r){const l=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return p[l]||l}function g(r){let l="";for(let u=0;u<r.length;u++)l+=String.fromCharCode(r[u]);return l}function t(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=r.match(/windows(\d+)/);return l?"windows-"+l[1]:r}}}e.toCanonicalName=t;function s({buffer:r,bytesRead:l},u){let b=o(r,l),i=!1;if(b!==e.UTF16be&&b!==e.UTF16le&&r){let n=!0,h=!0,w=!1;for(let v=0;v<l&&v<L;v++){const O=v%2===1,j=r.readUInt8(v)===0;if(j&&(w=!0),n&&(O&&!j||!O&&j)&&(n=!1),h&&(O&&j||!O&&!j)&&(h=!1),j&&!n&&!h)break}w&&(n?b=e.UTF16le:h?b=e.UTF16be:i=!0)}return u&&!i&&!b&&r?f(r.slice(0,l)).then(n=>({seemsBinary:!1,encoding:n})):{seemsBinary:i,encoding:b}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[145],Ce([1,0,308,29,144]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class L extends c.TextSearchManager{constructor(T,S,I=R,N="searchProcess"){super(T,S,{readdir:A=>I.Promises.readdir(A.fsPath),toCanonicalName:A=>(0,a.toCanonicalName)(A)},N)}}e.NativeTextSearchManager=L}),define(De[309],Ce([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(c){if(c&&this.a.has(c)){const L=this.a.get(c);return this.a.delete(c),L}}addDragOperationTransfer(c,L){this.a.set(c,L)}getRenderedTreeElement(c){if(this.b.has(c))return this.b.get(c)}addRenderedTreeItemElement(c,L){this.b.set(c,L)}removeRenderedTreeItemElement(c){this.b.has(c)&&this.b.delete(c)}}e.TreeviewsService=a}),define(De[310],Ce([1,0,184,7,24,2,3,6,226,19,7,9,15,14,21,309,27]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(y,g){if((0,A.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let t;return Array.isArray(y.highlights)&&(t=y.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),t=t.length?t:void 0),{label:y.label,highlights:t}}}class f{constructor(g,t,s){this.d=g,this.e=t,this.f=s,this.a=new Map,this.b=new m.TreeviewsService;function r(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>r(l)?this.i(l):Array.isArray(l)&&l.length>0?l.map(u=>r(u)?this.i(u):u):l})}registerTreeDataProvider(g,t,s){const r=this.createTreeView(g,{treeDataProvider:t},s);return{dispose:()=>r.dispose()}}createTreeView(g,t,s){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],u=!!t.dragAndDropController?.handleDrag,b=!!t.dragAndDropController?.handleDrop,i=this.h(g,t,s),n=this.d.$registerTreeViewDataProvider(g,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:l,hasHandleDrag:u,hasHandleDrop:b});return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,o.checkProposedApiEnabled)(s,"treeItemCheckbox"),i.onDidChangeCheckboxState},get message(){return i.message},set message(h){i.message=h},get title(){return i.title},set title(h){i.title=h},get description(){return i.description},set description(h){i.description=h},get badge(){return i.badge},set badge(h){h!==void 0&&N.ViewBadge.isViewBadge(h)?i.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(i.badge=void 0)},reveal:(h,w)=>i.reveal(h,w),dispose:async()=>{await n,this.a.delete(g),i.dispose()}}}$getChildren(g,t){const s=this.a.get(g);return s?s.getChildren(t):Promise.reject(new S.NoTreeViewError(g))}async $handleDrop(g,t,s,r,l,u,b,i){const n=this.a.get(g);if(!n)return Promise.reject(new S.NoTreeViewError(g));const h=k.DataTransfer.toDataTransfer(s,async w=>(await this.d.$resolveDropFileData(g,t,w)).buffer);return b===g&&i&&await this.g(h,n,i,l,u),n.onDrop(h,r,l)}async g(g,t,s,r,l){const u=this.b.removeDragOperationTransfer(l);if(u)(await u)?.forEach((b,i)=>{b&&g.set(i,b)});else if(l&&t.handleDrag){const b=t.handleDrag(s,g,r);this.b.addDragOperationTransfer(l,b),await b}return g}async $handleDrag(g,t,s,r){const l=this.a.get(g);if(!l)return Promise.reject(new S.NoTreeViewError(g));const u=await this.g(new R.DataTransfer,l,t,r,s);if(!!u)return k.DataTransfer.toDataTransferDTO(u)}async $hasResolve(g){const t=this.a.get(g);if(!t)throw new S.NoTreeViewError(g);return t.hasResolve}$resolve(g,t,s){const r=this.a.get(g);if(!r)throw new S.NoTreeViewError(g);return r.resolveTreeItem(t,s)}$setExpanded(g,t,s){const r=this.a.get(g);if(!r)throw new S.NoTreeViewError(g);r.setExpanded(t,s)}$setSelection(g,t){const s=this.a.get(g);if(!s)throw new S.NoTreeViewError(g);s.setSelection(t)}$setFocus(g,t){const s=this.a.get(g);if(!s)throw new S.NoTreeViewError(g);s.setFocus(t)}$setVisible(g,t){const s=this.a.get(g);if(!s)throw new S.NoTreeViewError(g);s.setVisible(t)}$changeCheckboxState(g,t){const s=this.a.get(g);if(!s)throw new S.NoTreeViewError(g);s.setCheckboxState(t)}h(g,t,s){const r=new p(g,t,this.d,this.e.converter,this.f,s);return this.a.set(g,r),r}i(g){const t=this.a.get(g.$treeViewId);return t&&"$treeItemHandle"in g?t.getExtensionElement(g.$treeItemHandle):t&&"$focusedTreeItem"in g&&g.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=f;class p extends T.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(g=>this.getExtensionElement(g)).filter(g=>!(0,A.isUndefinedOrNull)(g))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(g,t,s,r,l,u){if(super(),this.C=g,this.D=s,this.F=r,this.G=l,this.H=u,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new E.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new E.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new E.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new E.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new E.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new E.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new C.CancellationTokenSource,u.contributes&&u.contributes.views)for(const n in u.contributes.views)for(const h of u.contributes.views[n])h.id===g&&(this.J=h.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let b,i;this.B(E.Event.debounce(this.w.event,(n,h)=>(n||(n={message:!1,elements:[]}),h.element!==!1&&(b||(b=new Promise(w=>i=w),this.y=this.y.then(()=>b)),Array.isArray(h.element)?n.elements.push(...h.element):n.elements.push(h.element)),h.message&&(n.message=!0),n),200,!0)(({message:n,elements:h})=>{h.length&&(this.z=this.z.then(()=>{const w=i;return b=null,this.U(h).then(()=>w())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(g){const t=g?this.getExtensionElement(g):void 0;if(g&&!t)return this.G.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let s=this.Q(g);return s||(s=await this.R(t)),s?s.map(r=>r.item):void 0}getExtensionElement(g){return this.i.get(g)}reveal(g,t){t=t||{select:!0,focus:!1};const s=(0,A.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,A.isUndefinedOrNull)(t.focus)?!1:t.focus,l=(0,A.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.y.then(()=>this.N(g)).then(u=>this.P(g,u[u.length-1]).then(b=>this.D.$reveal(this.C,{item:b.item,parentChain:u.map(i=>i.item)},{select:s,focus:r,expand:l})),u=>this.G.error(u)):this.D.$reveal(this.C,void 0,{select:s,focus:r,expand:l})}get message(){return this.I}set message(g){this.I=g,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(g){this.J=g,this.D.$setTitle(this.C,g,this.L)}get description(){return this.L}set description(g){this.L=g,this.D.$setTitle(this.C,this.J,g)}get badge(){return this.M}set badge(g){this.M?.value===g?.value&&this.M?.tooltip===g?.tooltip||(this.M=k.ViewBadge.from(g),this.D.$setBadge(this.C,g))}setExpanded(g,t){const s=this.getExtensionElement(g);s&&(t?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(g){(0,D.equals)(this.l,g)||(this.l=g,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(g){this.m=g}setVisible(g){g!==this.k&&(this.k=g,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(g){const t=(await Promise.all(g.map(async s=>{const r=this.getExtensionElement(s.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:s.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);t.forEach(s=>{s.treeItem.checkboxState=s.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}),this.v.fire({items:t.map(s=>[s.extensionItem,s.newState])})}async handleDrag(g,t,s){const r=[];for(const l of g){const u=this.getExtensionElement(l);u&&r.push(u)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,s),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,t,s){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,I.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,g,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,t){if(!this.f.resolveTreeItem)return;const s=this.i.get(g);if(s){const r=this.j.get(s);if(r){const l=await this.f.resolveTreeItem(r.extensionItem,s,t)??r.extensionItem;return this.db(l),r.item.tooltip=this.ab(l.tooltip),r.item.command=this.bb(r.disposableStore,l.command),r.item}}}N(g){return this.O(g).then(t=>t?this.N(t).then(s=>this.P(t,s[s.length-1]).then(r=>(s.push(r),s))):Promise.resolve([]))}O(g){const t=this.j.get(g);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,I.asPromise)(()=>this.f.getParent(g))}P(g,t){const s=this.j.get(g);return s?Promise.resolve(s):(0,I.asPromise)(()=>this.f.getTreeItem(g)).then(r=>this.gb(g,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(r);if(l){const u=this.j.get(l);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(g){if(g){let t;if(typeof g=="string"){const s=this.getExtensionElement(g);t=s?this.j.get(s):void 0}else t=g;return t&&t.children||void 0}return this.h}async R(g){this.nb(g);const t=new C.CancellationTokenSource(this.S.token);try{const s=g?this.j.get(g):void 0,r=await this.f.getChildren(g);if(t.token.isCancellationRequested)return;const l=await Promise.all((0,D.coalesce)(r||[]).map(async u=>{const b=await this.f.getTreeItem(u);return b&&!t.token.isCancellationRequested?this.Z(u,b,s):null}));return t.token.isCancellationRequested?void 0:(0,D.coalesce)(l)}finally{t.dispose()}}U(g){if(g.some(s=>!s))return this.S.dispose(!0),this.S=new C.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const s=this.W(g);if(s.length)return this.X(s)}return Promise.resolve(void 0)}W(g){const t=new Set,s=g.map(l=>this.j.get(l));for(const l of s)if(l&&!t.has(l.item.handle)){let u=l;for(;u&&u.parent&&s.findIndex(b=>u&&u.parent&&b&&b.item.handle===u.parent.item.handle)===-1;){const b=this.i.get(u.parent.item.handle);u=b?this.j.get(b):void 0}u&&!u.parent&&t.add(l.item.handle)}const r=[];return t.forEach(l=>{const u=this.i.get(l);if(u){const b=this.j.get(u);b&&(!b.parent||!t.has(b.parent.item.handle))&&r.push(l)}}),r}X(g){const t={};return Promise.all(g.map(s=>this.Y(s).then(r=>{r&&(t[s]=r.item)}))).then(()=>Object.keys(t).length?this.D.$refresh(this.C,t):void 0)}Y(g){const t=this.getExtensionElement(g);if(t){const s=this.j.get(t);if(s)return this.nb(t),(0,I.asPromise)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const l=this.eb(t,r,s.parent);return this.lb(t,l,s,s.parent),s.dispose(),l}return null})}return Promise.resolve(null)}Z(g,t,s){const r=this.eb(g,t,s);if(t.id&&this.i.has(r.item.handle))throw new Error((0,a.localize)(0,null,t.id));return this.kb(g,r),this.mb(r,s),r}ab(g){return N.MarkdownString.isMarkdownString(g)?k.MarkdownString.from(g):g}bb(g,t){return t?{...this.F.toInternal(t,g),originalId:t.command}:void 0}cb(g){if(!g.checkboxState)return;let t,s;return typeof g.checkboxState=="number"?t=g.checkboxState:(t=g.checkboxState.state,s=g.checkboxState.tooltip),{isChecked:t===N.TreeItemCheckboxState.Checked,tooltip:s}}db(g){if(!N.TreeItem.isTreeItem(g,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(g,t,s){this.db(t);const r=new T.DisposableStore,l=this.gb(g,t,s),u=this.hb(t);return{item:{handle:l,parentHandle:s?s.item.handle:void 0,label:d(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(r,t.command),contextValue:t.contextValue,icon:u,iconDark:this.ib(t)||u,themeIcon:this.fb(t),collapsibleState:(0,A.isUndefinedOrNull)(t.collapsibleState)?N.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:s,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(g){return g.iconPath instanceof N.ThemeIcon?g.iconPath:void 0}gb(g,{id:t,label:s,resourceUri:r},l,u){if(t)return`${p.b}/${t}`;const b=d(s,this.H),i=l?l.item.handle:p.a;let n=b?b.label:r?(0,c.basename)(r):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const h=this.j.has(g)?this.j.get(g).item.handle:void 0,w=this.Q(l)||[];let v,O=0;do{if(v=`${i}/${O}:${n}`,u||!this.i.has(v)||h===v)break;O++}while(O<=w.length);return v}hb(g){if(g.iconPath&&!(g.iconPath instanceof N.ThemeIcon))return typeof g.iconPath=="string"||L.URI.isUri(g.iconPath)?this.jb(g.iconPath):this.jb(g.iconPath.light)}ib(g){if(g.iconPath&&!(g.iconPath instanceof N.ThemeIcon)&&g.iconPath.dark)return this.jb(g.iconPath.dark)}jb(g){return L.URI.isUri(g)?g:L.URI.file(g)}kb(g,t){this.i.set(t.item.handle,g),this.j.set(g,t)}lb(g,t,s,r){this.i.delete(t.item.handle),this.j.delete(g),t.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(g,t);const l=this.Q(r)||[],u=l.filter(b=>b.item.handle===s.item.handle)[0];u&&l.splice(l.indexOf(u),1,t)}mb(g,t){t?(t.children||(t.children=[]),t.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}nb(g){if(g){const t=this.j.get(g);if(t){if(t.children)for(const s of t.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}t.children=void 0}}else this.pb()}ob(g){const t=this.j.get(g);if(t){if(t.children)for(const s of t.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}this.j.delete(g),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(g=>g.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}p.a="0",p.b="1"}),define(De[311],Ce([1,0,21,10,3,37,2,121,107,154,165,44,5,96,253,252,40,254,35,256,257,258,241,259,59,42,260,261,264,265,266,143,244,272,273,274,99,41,276,310,14,7,73,279,80,142,34,25,233,263,72,140,82,84,85,13,56,20,26,267,240,55,77,250,277,79,78,282,280,281,251,49,275,278,98,60,76,268,81,269,16,125,243,222,262,6,27,227,97,218,270,271]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f,p,y,g,t,s,r,l,u,b,i,n,h,w,v,O,j,V,Q,G,U,P,M,B,Z,Y,H,_,ee,be,ce,oe,x,he,pe,Se,Re,re,le,de,te,ae,se,F,$,q,J,ue,we,Ae,ve,Ie,ke,He,qe,nt,Qe,tt,rt,Be,it,z,X,fe,Le,Ne,je,_e,Xe,st,at,mt,gt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Lt(lt){const wt=lt.get(te.IExtHostInitDataService),Ht=lt.get(He.IExtHostFileSystemInfo),Ft=lt.get(we.IExtHostConsumerFileSystem),It=lt.get(l.IExtHostExtensionService),pt=lt.get(ee.IExtHostWorkspace),Tt=lt.get(rt.IExtHostTelemetry),Mt=lt.get(f.IExtHostConfiguration),Ot=lt.get(le.IURITransformerService),Ke=lt.get(de.IExtHostRpcService),xt=lt.get(Q.IExtHostStorage),Nt=lt.get(ue.IExtensionStoragePaths),Bt=lt.get(re.ILoggerService),Pe=lt.get(re.ILogService),Oe=lt.get(F.IExtHostTunnelService),ye=lt.get($.IExtHostApiDeprecationService),ne=lt.get(_.IExtHostWindow),Fe=lt.get(Qe.IExtHostSecretState),We=lt.get(tt.IExtHostEditorTabs);Ke.set(D.ExtHostContext.ExtHostFileSystemInfo,Ht),Ke.set(D.ExtHostContext.ExtHostLogLevelServiceShape,Bt),Ke.set(D.ExtHostContext.ExtHostWorkspace,pt),Ke.set(D.ExtHostContext.ExtHostConfiguration,Mt),Ke.set(D.ExtHostContext.ExtHostExtensionService,It),Ke.set(D.ExtHostContext.ExtHostStorage,xt),Ke.set(D.ExtHostContext.ExtHostTunnelService,Oe),Ke.set(D.ExtHostContext.ExtHostWindow,ne),Ke.set(D.ExtHostContext.ExtHostSecretState,Fe),Ke.set(D.ExtHostContext.ExtHostTelemetry,Tt),Ke.set(D.ExtHostContext.ExtHostEditorTabs,We);const Ze=Ke.set(D.ExtHostContext.ExtHostDecorations,lt.get(he.IExtHostDecorations)),xe=Ke.set(D.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(r.IExtHostDocumentsAndEditors)),et=Ke.set(D.ExtHostContext.ExtHostCommands,lt.get(o.IExtHostCommands)),ut=Ke.set(D.ExtHostContext.ExtHostTerminalService,lt.get(G.IExtHostTerminalService)),ft=Ke.set(D.ExtHostContext.ExtHostDebugService,lt.get(Se.IExtHostDebugService)),kt=Ke.set(D.ExtHostContext.ExtHostSearch,lt.get(Re.IExtHostSearch)),bt=Ke.set(D.ExtHostContext.ExtHostTask,lt.get(pe.IExtHostTask)),St=Ke.set(D.ExtHostContext.ExtHostOutputService,lt.get(w.IExtHostOutputService)),Pt=Ke.set(D.ExtHostContext.ExtHostLocalization,lt.get(at.IExtHostLocalizationService)),zt=Ke.set(D.ExtHostContext.ExtHostUrls,new Y.ExtHostUrls(Ke)),At=Ke.set(D.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Ke,xe)),ti=Ke.set(D.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(Ke,xe,Pe)),oi=Ke.set(D.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Pe,At,Ke.getProxy(D.MainContext.MainThreadBulkEdits))),Ct=Ke.set(D.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Ke,et,xe,At)),ai=Ke.set(D.ExtHostContext.ExtHostNotebookDocuments,new Ne.ExtHostNotebookDocuments(Ct)),ci=Ke.set(D.ExtHostContext.ExtHostNotebookEditors,new Le.ExtHostNotebookEditors(Pe,Ct)),Jt=Ke.set(D.ExtHostContext.ExtHostNotebookKernels,new Be.ExtHostNotebookKernels(Ke,wt,Ct,et,Pe)),Ei=Ke.set(D.ExtHostContext.ExtHostNotebookRenderers,new z.ExtHostNotebookRenderers(Ke,Ct)),yt=Ke.set(D.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Ke,xe)),li=Ke.set(D.ExtHostContext.ExtHostTreeViews,new P.ExtHostTreeViews(Ke.getProxy(D.MainContext.MainThreadTreeViews),et,Pe)),Ui=Ke.set(D.ExtHostContext.ExtHostEditorInsets,new ce.ExtHostEditorInsets(Ke.getProxy(D.MainContext.MainThreadEditorInsets),yt,wt.remote)),Zt=Ke.set(D.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(Ke,Pe,Ht,xe)),ii=Ke.set(D.ExtHostContext.ExtHostLanguages,new n.ExtHostLanguages(Ke,At,et.converter,Ot)),ht=Ke.set(D.ExtHostContext.ExtHostLanguageFeatures,new i.ExtHostLanguageFeatures(Ke,Ot,At,et,Zt,Pe,ye,Tt)),ei=Ke.set(D.ExtHostContext.ExtHostFileSystem,new u.ExtHostFileSystem(Ke,ht)),jt=Ke.set(D.ExtHostContext.ExtHostFileSystemEventService,new b.ExtHostFileSystemEventService(Ke,Pe,xe)),Xt=Ke.set(D.ExtHostContext.ExtHostQuickOpen,(0,O.createExtHostQuickOpen)(Ke,pt,et)),ui=Ke.set(D.ExtHostContext.ExtHostSCM,new j.ExtHostSCM(Ke,et,Pe)),Si=Ke.set(D.ExtHostContext.ExtHostQuickDiff,new Et.ExtHostQuickDiff(Ke,Ot)),yi=Ke.set(D.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(Ke,et,At)),di=Ke.set(D.ExtHostContext.ExtHostProgress,new v.ExtHostProgress(Ke.getProxy(D.MainContext.MainThreadProgress))),Di=Ke.set(D.ExtHostContext.ExtHosLabelService,new oe.ExtHostLabelService(Ke)),hi=Ke.set(D.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(Ke)),fi=Ke.set(D.ExtHostContext.ExtHostAuthentication,new q.ExtHostAuthentication(Ke)),Ci=Ke.set(D.ExtHostContext.ExtHostTimeline,new J.ExtHostTimeline(Ke,et)),ni=Ke.set(D.ExtHostContext.ExtHostWebviews,new H.ExtHostWebviews(Ke,wt.remote,pt,Pe,ye)),ri=Ke.set(D.ExtHostContext.ExtHostWebviewPanels,new Ie.ExtHostWebviewPanels(Ke,ni,pt)),Ii=Ke.set(D.ExtHostContext.ExtHostCustomEditors,new ve.ExtHostCustomEditors(Ke,At,Nt,ni,ri)),Bi=Ke.set(D.ExtHostContext.ExtHostWebviewViews,new Ae.ExtHostWebviewViews(Ke,ni)),Qt=Ke.set(D.ExtHostContext.ExtHostTesting,new qe.ExtHostTesting(Ke,et,xe)),ki=Ke.set(D.ExtHostContext.ExtHostUriOpeners,new nt.ExtHostUriOpeners(Ke)),$i=Ke.set(D.ExtHostContext.ExtHostProfileContentHandlers,new gt.ExtHostProfileContentHandlers(Ke));Ke.set(D.ExtHostContext.ExtHostInteractive,new je.ExtHostInteractive(Ke,Ct,xe,et,Pe));const zi=Object.values(D.ExtHostContext);Ke.assertRegistered(zi);const Wi=new ke.ExtHostBulkEdits(Ke,xe),Hi=new m.ExtHostClipboard(Ke),Ti=new h.ExtHostMessageService(Ke,Pe),Li=new y.ExtHostDialogs(Ke),mi=new V.ExtHostStatusBar(Ke,et.converter);return C.ExtHostApiCommands.register(et),function($e,qt,Oi){const vt=function(){let ge=!$e.isUnderDevelopment;function Ee(){ge||(Pe.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Me(ot){if(Array.isArray(ot))ot.forEach(Me);else if(typeof ot=="string")Ee();else{const Dt=ot;typeof Dt.scheme>"u"&&Ee(),typeof Dt.exclusive=="boolean"&&(0,Xe.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ot}}(),gi={getSession(ge,Ee,Me){return fi.getSession($e,ge,Ee,Me)},async hasSession(ge,Ee){return(0,Xe.checkProposedApiEnabled)($e,"authSession"),!!await fi.getSession($e,ge,Ee,{silent:!0})},get onDidChangeSessions(){return fi.onDidChangeSessions},registerAuthenticationProvider(ge,Ee,Me,ot){return fi.registerAuthenticationProvider(ge,Ee,Me,ot)}},ji={registerCommand(ge,Ee,Me){return et.registerCommand(!0,ge,Ee,Me,void 0,$e)},registerTextEditorCommand(ge,Ee,Me){return et.registerCommand(!0,ge,(...ot)=>{const Dt=yt.getActiveTextEditor();if(!Dt){Pe.warn("Cannot execute "+ge+" because there is no active text editor.");return}return Dt.edit(Rt=>{Ee.apply(Me,[Dt,Rt,...ot])}).then(Rt=>{Rt||Pe.warn("Edits from command "+ge+" were not applied.")},Rt=>{Pe.warn("An error occurred while running command "+ge,Rt)})},void 0,void 0,$e)},registerDiffInformationCommand:(ge,Ee,Me)=>((0,Xe.checkProposedApiEnabled)($e,"diffCommand"),et.registerCommand(!0,ge,async(...ot)=>{const Dt=xe.activeEditor(!0);if(!Dt){Pe.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Rt=await yt.getDiffInformation(Dt.id);Ee.apply(Me,[Rt,...ot])},void 0,void 0,$e)),executeCommand(ge,...Ee){return et.executeCommand(ge,...Ee)},getCommands(ge=!1){return et.getCommands(ge)}},Ni={get machineId(){return wt.telemetryInfo.machineId},get sessionId(){return wt.telemetryInfo.sessionId},get language(){return wt.environment.appLanguage},get appName(){return wt.environment.appName},get appRoot(){return wt.environment.appRoot?.fsPath??""},get appHost(){return wt.environment.appHost},get uriScheme(){return wt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return ut.getDefaultShell(!1)},get onDidChangeShell(){return(0,Xe.checkProposedApiEnabled)($e,"envShellEvent"),ut.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)($e,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)($e,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,rt.isNewAppInstall)(wt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge){return rt.ExtHostTelemetryLogger.validateSender(ge),Tt.instantiateLogger($e,ge)},openExternal(ge,Ee){return ne.openUri(ge,{allowTunneling:!!wt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===wt.environment.appUriScheme)return zt.createAppUri(ge);try{return await ne.asExternalUri(ge,{allowTunneling:!!wt.remote.authority})}catch(Ee){if((0,fe.matchesScheme)(ge,X.Schemas.http)||(0,fe.matchesScheme)(ge,X.Schemas.https))return ge;throw Ee}},get remoteName(){return(0,x.getRemoteName)(wt.remote.authority)},get remoteAuthority(){return(0,Xe.checkProposedApiEnabled)($e,"resolvers"),wt.remote.authority},get uiKind(){return wt.uiKind},get logLevel(){return Pe.getLevel()},get onDidChangeLogLevel(){return Pe.onDidChangeLogLevel}};wt.environment.extensionTestsLocationURI||Object.freeze(Ni);const Vi={createTestController(ge,Ee,Me){return Qt.createTestController($e,ge,Ee,Me)},createTestObserver(){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),Qt.createTestObserver()},runTests(ge){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),Qt.runTests(ge)},get onDidChangeTestResults(){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,Xe.checkProposedApiEnabled)($e,"testObserver"),Qt.results}},pi=wt.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,Pi={getExtension(ge,Ee){(0,Xe.isProposedApiEnabled)($e,"extensionsAny")||(Ee=!1);const Me=qt.mine.getExtensionDescription(ge);if(Me)return new l.Extension(It,$e.identifier,Me,pi,!1);if(Ee){const ot=qt.all.getExtensionDescription(ge);if(ot)return new l.Extension(It,$e.identifier,ot,pi,!0)}},get all(){const ge=[];for(const Ee of qt.mine.getAllExtensionDescriptions())ge.push(new l.Extension(It,$e.identifier,Ee,pi,!1));return ge},get allAcrossExtensionHosts(){(0,Xe.checkProposedApiEnabled)($e,"extensionsAny");const ge=new be.ExtensionIdentifierSet(qt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),Ee=[];for(const Me of qt.all.getAllExtensionDescriptions()){const ot=!ge.has(Me.identifier);Ee.push(new l.Extension(It,$e.identifier,Me,pi,ot))}return Ee},get onDidChange(){return(0,Xe.isProposedApiEnabled)($e,"extensionsAny")?c.Event.any(qt.mine.onDidChange,qt.all.onDidChange):qt.mine.onDidChange}},xi={createDiagnosticCollection(ge){return Zt.createDiagnosticCollection($e.identifier,ge)},get onDidChangeDiagnostics(){return Zt.onDidChangeDiagnostics},getDiagnostics:ge=>Zt.getDiagnostics(ge),getLanguages(){return ii.getLanguages()},setTextDocumentLanguage(ge,Ee){return ii.changeLanguage(ge.uri,Ee)},match(ge,Ee){const Me=At.getDocumentData(Ee.uri)?.notebook;return(0,N.score)(M.LanguageSelector.from(ge),Ee.uri,Ee.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(ge,Ee,Me){return ht.registerCodeActionProvider($e,vt(ge),Ee,Me)},registerDocumentPasteEditProvider(ge,Ee,Me){return(0,Xe.checkProposedApiEnabled)($e,"documentPaste"),ht.registerDocumentPasteEditProvider($e,vt(ge),Ee,Me)},registerCodeLensProvider(ge,Ee){return ht.registerCodeLensProvider($e,vt(ge),Ee)},registerDefinitionProvider(ge,Ee){return ht.registerDefinitionProvider($e,vt(ge),Ee)},registerDeclarationProvider(ge,Ee){return ht.registerDeclarationProvider($e,vt(ge),Ee)},registerImplementationProvider(ge,Ee){return ht.registerImplementationProvider($e,vt(ge),Ee)},registerTypeDefinitionProvider(ge,Ee){return ht.registerTypeDefinitionProvider($e,vt(ge),Ee)},registerHoverProvider(ge,Ee){return ht.registerHoverProvider($e,vt(ge),Ee,$e.identifier)},registerEvaluatableExpressionProvider(ge,Ee){return ht.registerEvaluatableExpressionProvider($e,vt(ge),Ee,$e.identifier)},registerInlineValuesProvider(ge,Ee){return ht.registerInlineValuesProvider($e,vt(ge),Ee,$e.identifier)},registerDocumentHighlightProvider(ge,Ee){return ht.registerDocumentHighlightProvider($e,vt(ge),Ee)},registerLinkedEditingRangeProvider(ge,Ee){return ht.registerLinkedEditingRangeProvider($e,vt(ge),Ee)},registerReferenceProvider(ge,Ee){return ht.registerReferenceProvider($e,vt(ge),Ee)},registerRenameProvider(ge,Ee){return ht.registerRenameProvider($e,vt(ge),Ee)},registerDocumentSymbolProvider(ge,Ee,Me){return ht.registerDocumentSymbolProvider($e,vt(ge),Ee,Me)},registerWorkspaceSymbolProvider(ge){return ht.registerWorkspaceSymbolProvider($e,ge)},registerDocumentFormattingEditProvider(ge,Ee){return ht.registerDocumentFormattingEditProvider($e,vt(ge),Ee)},registerDocumentRangeFormattingEditProvider(ge,Ee){return ht.registerDocumentRangeFormattingEditProvider($e,vt(ge),Ee)},registerOnTypeFormattingEditProvider(ge,Ee,Me,...ot){return ht.registerOnTypeFormattingEditProvider($e,vt(ge),Ee,[Me].concat(ot))},registerDocumentSemanticTokensProvider(ge,Ee,Me){return ht.registerDocumentSemanticTokensProvider($e,vt(ge),Ee,Me)},registerDocumentRangeSemanticTokensProvider(ge,Ee,Me){return ht.registerDocumentRangeSemanticTokensProvider($e,vt(ge),Ee,Me)},registerSignatureHelpProvider(ge,Ee,Me,...ot){return typeof Me=="object"?ht.registerSignatureHelpProvider($e,vt(ge),Ee,Me):ht.registerSignatureHelpProvider($e,vt(ge),Ee,typeof Me>"u"?[]:[Me,...ot])},registerCompletionItemProvider(ge,Ee,...Me){return ht.registerCompletionItemProvider($e,vt(ge),Ee,Me)},registerInlineCompletionItemProvider(ge,Ee){return Ee.handleDidShowCompletionItem&&(0,Xe.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,Xe.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider($e,vt(ge),Ee)},registerDocumentLinkProvider(ge,Ee){return ht.registerDocumentLinkProvider($e,vt(ge),Ee)},registerColorProvider(ge,Ee){return ht.registerColorProvider($e,vt(ge),Ee)},registerFoldingRangeProvider(ge,Ee){return ht.registerFoldingRangeProvider($e,vt(ge),Ee)},registerSelectionRangeProvider(ge,Ee){return ht.registerSelectionRangeProvider($e,ge,Ee)},registerCallHierarchyProvider(ge,Ee){return ht.registerCallHierarchyProvider($e,ge,Ee)},registerTypeHierarchyProvider(ge,Ee){return ht.registerTypeHierarchyProvider($e,ge,Ee)},setLanguageConfiguration:(ge,Ee)=>ht.setLanguageConfiguration($e,ge,Ee),getTokenInformationAtPosition(ge,Ee){return(0,Xe.checkProposedApiEnabled)($e,"tokenInformation"),ii.tokenAtPosition(ge,Ee)},registerInlayHintsProvider(ge,Ee){return ht.registerInlayHintsProvider($e,ge,Ee)},createLanguageStatusItem(ge,Ee){return ii.createLanguageStatusItem($e,ge,Ee)},registerDocumentDropEditProvider(ge,Ee){return ht.registerDocumentOnDropEditProvider($e,ge,Ee)}},Gt={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(ge,Ee,Me){const ot=await(E.URI.isUri(ge)?Promise.resolve(si.openTextDocument(ge)):Promise.resolve(ge));return yt.showTextDocument(ot,Ee,Me)},createTextEditorDecorationType(ge){return yt.createTextEditorDecorationType($e,ge)},onDidChangeActiveTextEditor(ge,Ee,Me){return yt.onDidChangeActiveTextEditor(ge,Ee,Me)},onDidChangeVisibleTextEditors(ge,Ee,Me){return yt.onDidChangeVisibleTextEditors(ge,Ee,Me)},onDidChangeTextEditorSelection(ge,Ee,Me){return yt.onDidChangeTextEditorSelection(ge,Ee,Me)},onDidChangeTextEditorOptions(ge,Ee,Me){return yt.onDidChangeTextEditorOptions(ge,Ee,Me)},onDidChangeTextEditorVisibleRanges(ge,Ee,Me){return yt.onDidChangeTextEditorVisibleRanges(ge,Ee,Me)},onDidChangeTextEditorViewColumn(ge,Ee,Me){return yt.onDidChangeTextEditorViewColumn(ge,Ee,Me)},onDidCloseTerminal(ge,Ee,Me){return ut.onDidCloseTerminal(ge,Ee,Me)},onDidOpenTerminal(ge,Ee,Me){return ut.onDidOpenTerminal(ge,Ee,Me)},onDidChangeActiveTerminal(ge,Ee,Me){return ut.onDidChangeActiveTerminal(ge,Ee,Me)},onDidChangeTerminalDimensions(ge,Ee,Me){return(0,Xe.checkProposedApiEnabled)($e,"terminalDimensions"),ut.onDidChangeTerminalDimensions(ge,Ee,Me)},onDidChangeTerminalState(ge,Ee,Me){return ut.onDidChangeTerminalState(ge,Ee,Me)},onDidWriteTerminalData(ge,Ee,Me){return(0,Xe.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),ut.onDidWriteTerminalData(ge,Ee,Me)},get state(){return ne.state},onDidChangeWindowState(ge,Ee,Me){return ne.onDidChangeWindowState(ge,Ee,Me)},showInformationMessage(ge,...Ee){return Ti.showMessage($e,L.default.Info,ge,Ee[0],Ee.slice(1))},showWarningMessage(ge,...Ee){return Ti.showMessage($e,L.default.Warning,ge,Ee[0],Ee.slice(1))},showErrorMessage(ge,...Ee){return Ti.showMessage($e,L.default.Error,ge,Ee[0],Ee.slice(1))},showQuickPick(ge,Ee,Me){return Xt.showQuickPick($e,ge,Ee,Me)},showWorkspaceFolderPick(ge){return Xt.showWorkspaceFolderPick(ge)},showInputBox(ge,Ee){return Xt.showInput(ge,Ee)},showOpenDialog(ge){return Li.showOpenDialog($e,ge)},showSaveDialog(ge){return Li.showSaveDialog(ge)},createStatusBarItem(ge,Ee,Me){let ot,Dt,Rt;return typeof ge=="string"?(ot=ge,Dt=Ee,Rt=Me):(Dt=ge,Rt=Ee),mi.createStatusBarEntry($e,ot,Dt,Rt)},setStatusBarMessage(ge,Ee){return mi.setStatusBarMessage(ge,Ee)},withScmProgress(ge){return ye.report("window.withScmProgress",$e,"Use 'withProgress' instead."),di.withProgress($e,{location:B.ProgressLocation.SourceControl},(Ee,Me)=>ge({report(ot){}}))},withProgress(ge,Ee){return di.withProgress($e,ge,Ee)},createOutputChannel(ge,Ee){return St.createOutputChannel(ge,Ee,$e)},createWebviewPanel(ge,Ee,Me,ot){return ri.createWebviewPanel($e,ge,Ee,Me,ot)},createWebviewTextEditorInset(ge,Ee,Me,ot){return(0,Xe.checkProposedApiEnabled)($e,"editorInsets"),Ui.createWebviewEditorInset(ge,Ee,Me,ot,$e)},createTerminal(ge,Ee,Me){return typeof ge=="object"?"pty"in ge?ut.createExtensionTerminal(ge):ut.createTerminalFromOptions(ge):ut.createTerminal(ge,Ee,Me)},registerTerminalLinkProvider(ge){return ut.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,Ee){return ut.registerProfileProvider($e,ge,Ee)},registerTerminalQuickFixProvider(ge,Ee){return(0,Xe.checkProposedApiEnabled)($e,"terminalQuickFixProvider"),ut.registerTerminalQuickFixProvider(ge,$e.identifier.value,Ee)},registerTreeDataProvider(ge,Ee){return li.registerTreeDataProvider(ge,Ee,$e)},createTreeView(ge,Ee){return li.createTreeView(ge,Ee,$e)},registerWebviewPanelSerializer:(ge,Ee)=>ri.registerWebviewPanelSerializer($e,ge,Ee),registerCustomEditorProvider:(ge,Ee,Me={})=>Ii.registerCustomEditorProvider($e,ge,Ee,Me),registerFileDecorationProvider(ge){return Ze.registerFileDecorationProvider(ge,$e)},registerUriHandler(ge){return zt.registerUriHandler($e.identifier,ge)},createQuickPick(){return Xt.createQuickPick($e)},createInputBox(){return Xt.createInputBox($e)},get activeColorTheme(){return hi.activeColorTheme},onDidChangeActiveColorTheme(ge,Ee,Me){return hi.onDidChangeActiveColorTheme(ge,Ee,Me)},registerWebviewViewProvider(ge,Ee,Me){return Bi.registerWebviewViewProvider($e,ge,Ee,Me?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,Ee,Me){return Ct.onDidChangeActiveNotebookEditor(ge,Ee,Me)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,Ee,Me){return ci.onDidChangeNotebookEditorSelection(ge,Ee,Me)},onDidChangeNotebookEditorVisibleRanges(ge,Ee,Me){return ci.onDidChangeNotebookEditorVisibleRanges(ge,Ee,Me)},showNotebookDocument(ge,Ee){return Ct.showNotebookDocument(ge,Ee)},registerExternalUriOpener(ge,Ee,Me){return(0,Xe.checkProposedApiEnabled)($e,"externalUriOpener"),ki.registerExternalUriOpener($e.identifier,ge,Ee,Me)},registerProfileContentHandler(ge,Ee){return(0,Xe.checkProposedApiEnabled)($e,"profileContentHandlers"),$i.registrProfileContentHandler($e,ge,Ee)},registerQuickDiffProvider(ge,Ee,Me,ot){return(0,Xe.checkProposedApiEnabled)($e,"quickDiffProvider"),Si.registerQuickDiffProvider(vt(ge),Ee,Me,ot)},get tabGroups(){return We.tabGroups}},si={get rootPath(){return ye.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(ge){throw R.readonly()},getWorkspaceFolder(ge){return pt.getWorkspaceFolder(ge)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(ge){throw R.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(ge){throw R.readonly()},updateWorkspaceFolders:(ge,Ee,...Me)=>pt.updateWorkspaceFolders($e,ge,Ee||0,...Me),onDidChangeWorkspaceFolders:function(ge,Ee,Me){return pt.onDidChangeWorkspace(ge,Ee,Me)},asRelativePath:(ge,Ee)=>pt.getRelativePath(ge,Ee),findFiles:(ge,Ee,Me,ot)=>pt.findFiles(ge,Ee,Me,$e.identifier,ot),findTextInFiles:(ge,Ee,Me,ot)=>{(0,Xe.checkProposedApiEnabled)($e,"findTextInFiles");let Dt,Rt;return typeof Ee=="object"?(Dt=Ee,Rt=Me):(Dt={},Rt=Ee,ot=Me),pt.findTextInFiles(ge,Dt||{},Rt,$e.identifier,ot)},saveAll:ge=>pt.saveAll(ge),applyEdit(ge,Ee){return Wi.applyWorkspaceEdit(ge,$e,Ee)},createFileSystemWatcher:(ge,Ee,Me,ot)=>jt.createFileSystemWatcher(pt,$e,ge,Ee,Me,ot),get textDocuments(){return At.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw R.readonly()},openTextDocument(ge){let Ee;const Me=ge;if(typeof ge=="string")Ee=Promise.resolve(E.URI.file(ge));else if(E.URI.isUri(ge))Ee=Promise.resolve(ge);else if(!Me||typeof Me=="object")Ee=At.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ot=>At.ensureDocumentData(ot).then(Dt=>Dt.document))},onDidOpenTextDocument:(ge,Ee,Me)=>At.onDidAddDocument(ge,Ee,Me),onDidCloseTextDocument:(ge,Ee,Me)=>At.onDidRemoveDocument(ge,Ee,Me),onDidChangeTextDocument:(ge,Ee,Me)=>At.onDidChangeDocument(ge,Ee,Me),onDidSaveTextDocument:(ge,Ee,Me)=>At.onDidSaveDocument(ge,Ee,Me),onWillSaveTextDocument:(ge,Ee,Me)=>oi.getOnWillSaveTextDocumentEvent($e)(ge,Ee,Me),get notebookDocuments(){return Ct.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,Ee){let Me;if(E.URI.isUri(ge))Me=ge,await Ct.openNotebookDocument(ge);else if(typeof ge=="string")Me=E.URI.revive(await Ct.createNotebookDocument({viewType:ge,content:Ee}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(ge,Ee,Me){return ai.onDidSaveNotebookDocument(ge,Ee,Me)},onDidChangeNotebookDocument(ge,Ee,Me){return ai.onDidChangeNotebookDocument(ge,Ee,Me)},get onDidOpenNotebookDocument(){return Ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Ct.onDidCloseNotebookDocument},registerNotebookSerializer(ge,Ee,Me,ot){return Ct.registerNotebookSerializer($e,ge,Ee,Me,(0,Xe.isProposedApiEnabled)($e,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ge,Ee,Me)=>Oi.onDidChangeConfiguration(ge,Ee,Me),getConfiguration(ge,Ee){return Ee=arguments.length===1?void 0:Ee,Oi.getConfiguration(ge,Ee,$e)},registerTextDocumentContentProvider(ge,Ee){return ti.registerTextDocumentContentProvider(ge,Ee)},registerTaskProvider:(ge,Ee)=>(ye.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider($e,ge,Ee)),registerFileSystemProvider(ge,Ee,Me){return(0,_e.combinedDisposable)(ei.registerFileSystemProvider($e,ge,Ee,Me),Ft.addFileSystemProvider(ge,Ee))},get fs(){return Ft.value},registerFileSearchProvider:(ge,Ee)=>((0,Xe.checkProposedApiEnabled)($e,"fileSearchProvider"),kt.registerFileSearchProvider(ge,Ee)),registerTextSearchProvider:(ge,Ee)=>((0,Xe.checkProposedApiEnabled)($e,"textSearchProvider"),kt.registerTextSearchProvider(ge,Ee)),registerRemoteAuthorityResolver:(ge,Ee)=>((0,Xe.checkProposedApiEnabled)($e,"resolvers"),It.registerRemoteAuthorityResolver(ge,Ee)),registerResourceLabelFormatter:ge=>((0,Xe.checkProposedApiEnabled)($e,"resolvers"),Di.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,Ee,Me)=>jt.onDidCreateFile(ge,Ee,Me),onDidDeleteFiles:(ge,Ee,Me)=>jt.onDidDeleteFile(ge,Ee,Me),onDidRenameFiles:(ge,Ee,Me)=>jt.onDidRenameFile(ge,Ee,Me),onWillCreateFiles:(ge,Ee,Me)=>jt.getOnWillCreateFileEvent($e)(ge,Ee,Me),onWillDeleteFiles:(ge,Ee,Me)=>jt.getOnWillDeleteFileEvent($e)(ge,Ee,Me),onWillRenameFiles:(ge,Ee,Me)=>jt.getOnWillRenameFileEvent($e)(ge,Ee,Me),openTunnel:ge=>((0,Xe.checkProposedApiEnabled)($e,"tunnels"),Oe.openTunnel($e,ge).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,Xe.checkProposedApiEnabled)($e,"tunnels"),Oe.getTunnels()},onDidChangeTunnels:(ge,Ee,Me)=>((0,Xe.checkProposedApiEnabled)($e,"tunnels"),Oe.onDidChangeTunnels(ge,Ee,Me)),registerPortAttributesProvider:(ge,Ee)=>((0,Xe.checkProposedApiEnabled)($e,"portsAttributes"),Oe.registerPortsAttributesProvider(ge,Ee)),registerTimelineProvider:(ge,Ee)=>((0,Xe.checkProposedApiEnabled)($e,"timeline"),Ci.registerTimelineProvider(ge,Ee,$e.identifier,et.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:ge=>((0,Xe.checkProposedApiEnabled)($e,"workspaceTrust"),pt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,Ee,Me)=>pt.onDidGrantWorkspaceTrust(ge,Ee,Me),registerEditSessionIdentityProvider:(ge,Ee)=>((0,Xe.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(ge,Ee)),onWillCreateEditSessionIdentity:(ge,Ee,Me)=>((0,Xe.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),pt.getOnWillCreateEditSessionIdentityEvent($e)(ge,Ee,Me))},qi={get inputBox(){return ye.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),ui.getLastInputBox($e)},createSourceControl(ge,Ee,Me){return ui.createSourceControl($e,ge,Ee,Me)}},$t={createCommentController(ge,Ee){return yi.createCommentController($e,ge,Ee)}},bi={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},onDidStartDebugSession(ge,Ee,Me){return ft.onDidStartDebugSession(ge,Ee,Me)},onDidTerminateDebugSession(ge,Ee,Me){return ft.onDidTerminateDebugSession(ge,Ee,Me)},onDidChangeActiveDebugSession(ge,Ee,Me){return ft.onDidChangeActiveDebugSession(ge,Ee,Me)},onDidReceiveDebugSessionCustomEvent(ge,Ee,Me){return ft.onDidReceiveDebugSessionCustomEvent(ge,Ee,Me)},onDidChangeBreakpoints(ge,Ee,Me){return ft.onDidChangeBreakpoints(ge,Ee,Me)},registerDebugConfigurationProvider(ge,Ee,Me){return ft.registerDebugConfigurationProvider(ge,Ee,Me||st.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,Ee){return ft.registerDebugAdapterDescriptorFactory($e,ge,Ee)},registerDebugAdapterTrackerFactory(ge,Ee){return ft.registerDebugAdapterTrackerFactory(ge,Ee)},startDebugging(ge,Ee,Me){return!Me||typeof Me=="object"&&"configuration"in Me?ft.startDebugging(ge,Ee,{parentSession:Me}):ft.startDebugging(ge,Ee,Me||{})},stopDebugging(ge){return ft.stopDebugging(ge)},addBreakpoints(ge){return ft.addBreakpoints(ge)},removeBreakpoints(ge){return ft.removeBreakpoints(ge)},asDebugSourceUri(ge,Ee){return ft.asDebugSourceUri(ge,Ee)}},Gi={registerTaskProvider:(ge,Ee)=>bt.registerTaskProvider($e,ge,Ee),fetchTasks:ge=>bt.fetchTasks(ge),executeTask:ge=>bt.executeTask($e,ge),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(ge,Ee,Me)=>bt.onDidStartTask(ge,Ee,Me),onDidEndTask:(ge,Ee,Me)=>bt.onDidEndTask(ge,Ee,Me),onDidStartTaskProcess:(ge,Ee,Me)=>bt.onDidStartTaskProcess(ge,Ee,Me),onDidEndTaskProcess:(ge,Ee,Me)=>bt.onDidEndTaskProcess(ge,Ee,Me)},Ki={createNotebookController(ge,Ee,Me,ot,Dt){return Jt.createNotebookController($e,ge,Ee,Me,ot,(0,Xe.isProposedApiEnabled)($e,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,Ee)=>Ct.registerNotebookCellStatusBarItemProvider($e,ge,Ee),createRendererMessaging(ge){return Ei.createRendererMessaging($e,ge)},createNotebookControllerDetectionTask(ge){return(0,Xe.checkProposedApiEnabled)($e,"notebookKernelSource"),Jt.createNotebookControllerDetectionTask($e,ge)},registerKernelSourceActionProvider(ge,Ee){return(0,Xe.checkProposedApiEnabled)($e,"notebookKernelSource"),Jt.registerKernelSourceActionProvider($e,ge,Ee)},onDidChangeNotebookCellExecutionState(ge,Ee,Me){return(0,Xe.checkProposedApiEnabled)($e,"notebookCellExecutionState"),Jt.onDidChangeNotebookCellExecutionState(ge,Ee,Me)}},Xi={t(...ge){if(typeof ge[0]=="string"){const Ee=ge.shift(),Me=!ge||typeof ge[0]!="object"?ge:ge[0];return Pt.getMessage($e.identifier.value,{message:Ee,args:Me})}return Pt.getMessage($e.identifier.value,ge[0])},get bundle(){return Pt.getBundle($e.identifier.value)},get uri(){return Pt.getBundleUri($e.identifier.value)}};return{version:wt.version,authentication:gi,commands:ji,comments:$t,debug:bi,env:Ni,extensions:Pi,l10n:Xi,languages:xi,notebooks:Ki,scm:qi,tasks:Gi,tests:Vi,window:Gt,workspace:si,Breakpoint:B.Breakpoint,TerminalOutputAnchor:B.TerminalOutputAnchor,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:D.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CommentThreadState:B.CommentThreadState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:st.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:c.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileDecoration2:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:A.FileType,FilePermission:A.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestionList,Hover:B.Hover,IndentAction:I.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalQuickFixCommand:B.TerminalQuickFixCommand,TerminalQuickFixOpener:B.TerminalQuickFixOpener,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TerminalExitReason:B.TerminalExitReason,TerminalQuickFixType:B.TerminalQuickFixType,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,SnippetTextEdit:B.SnippetTextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItem2:B.TreeItem,TreeItemCheckboxState:B.TreeItemCheckboxState,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:k.UIKind,Uri:E.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,DocumentDropEdit:B.DocumentDropEdit,DocumentPasteEdit:B.DocumentPasteEdit,InlayHint:B.InlayHint,InlayHintLabelPart:B.InlayHintLabelPart,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,NotebookControllerAffinity2:B.NotebookControllerAffinity2,NotebookEdit:B.NotebookEdit,NotebookKernelSourceAction:B.NotebookKernelSourceAction,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestRunRequest2:B.TestRunRequest2,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:B.DataTransfer,DataTransferItem:B.DataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind,InputBoxValidationSeverity:B.InputBoxValidationSeverity,TabInputText:B.TextTabInput,TabInputTextDiff:B.TextDiffTabInput,TabInputTextMerge:B.TextMergeTabInput,TabInputCustom:B.CustomEditorTabInput,TabInputNotebook:B.NotebookEditorTabInput,TabInputNotebookDiff:B.NotebookDiffEditorTabInput,TabInputWebview:B.WebviewEditorTabInput,TabInputTerminal:B.TerminalEditorTabInput,TabInputInteractiveWindow:B.InteractiveWindowInput,TelemetryTrustedValue:Z.TelemetryTrustedValue,LogLevel:re.LogLevel,EditSessionIdentityMatch:mt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Lt}),define(De[312],Ce([1,0,284,321,322,2,323]),function(ie,e,a,R,c,L,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function T(A,D,k,C,m,o){const d=o.environment.useHostProxy,f=typeof d=="boolean"?d:!o.remote.isRemote,p=(0,E.createProxyResolver)({resolveProxy:g=>A.resolveProxy(g),getHttpProxySetting:()=>D.getConfiguration("http").get("proxy"),log:(g,t,...s)=>{switch(g){case E.LogLevel.Trace:C.trace(t,...s);break;case E.LogLevel.Debug:C.debug(t,...s);break;case E.LogLevel.Info:C.info(t,...s);break;case E.LogLevel.Warning:C.warn(t,...s);break;case E.LogLevel.Error:C.error(t,...s);break;case E.LogLevel.Critical:C.error(t,...s);break;case E.LogLevel.Off:break;default:r(g,t,s);break}function r(l,u,...b){C.error("Unknown log level",l),C.error(u,...b)}},getLogLevel:()=>C.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:f,env:process.env}),y=S(D,p);return N(k,y)}e.connectProxyResolver=T;function S(A,D){const k={config:A.getConfiguration("http").get("proxySupport")||"off"};A.onDidChangeConfiguration(m=>{k.config=A.getConfiguration("http").get("proxySupport")||"off"});const C={config:!!A.getConfiguration("http").get("systemCertificates")};return A.onDidChangeConfiguration(m=>{C.config=!!A.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,E.createHttpPatch)(a,D,{config:"off"},C,!0)),on:Object.assign({},a,(0,E.createHttpPatch)(a,D,{config:"on"},C,!0)),override:Object.assign({},a,(0,E.createHttpPatch)(a,D,{config:"override"},C,!0)),onRequest:Object.assign({},a,(0,E.createHttpPatch)(a,D,k,C,!0)),default:Object.assign(a,(0,E.createHttpPatch)(a,D,k,C,!1))},https:{off:Object.assign({},R,(0,E.createHttpPatch)(R,D,{config:"off"},C,!0)),on:Object.assign({},R,(0,E.createHttpPatch)(R,D,{config:"on"},C,!0)),override:Object.assign({},R,(0,E.createHttpPatch)(R,D,{config:"override"},C,!0)),onRequest:Object.assign({},R,(0,E.createHttpPatch)(R,D,k,C,!0)),default:Object.assign(R,(0,E.createHttpPatch)(R,D,k,C,!1))},tls:Object.assign(c,(0,E.createTlsPatch)(c))}}const I=new Map;function N(A,D){return A.getExtensionPathIndex().then(k=>{const C=globalThis._VSCODE_NODE_MODULES.module,m=C._load;C._load=function(d,f,p){if(d==="tls")return D.tls;if(d!=="http"&&d!=="https")return m.apply(this,arguments);const y=D[d],g=k.findSubstr(L.URI.file(f.filename));let t=I.get(g);if(t||I.set(g,t={}),!t[d]){const s=y.default;t[d]={...s}}return t[d]}})}}),define(De[313],Ce([1,0,83,311,298,312,42,286,2,16,7,283,115,285]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class C extends c.RequireInterceptor{j(){const d=this,f=globalThis._VSCODE_NODE_MODULES.module,p=f._load;f._load=function(s,r,l){return s=g(s),d.a.has(s)?d.a.get(s).load(s,S.URI.file((0,D.realpathSync)(r.filename)),u=>p.apply(this,[u,r,l])):p.apply(this,arguments)};const y=f._resolveLookupPaths;f._resolveLookupPaths=(t,s)=>y.call(this,g(t),s);const g=t=>{for(const s of d.b){const r=s(t);if(r){t=r;break}}return t}}}class m extends E.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=N.ExtensionRuntime.Node}async ob(){this.h.createInstance(k.ExtHostConsoleForwarder);const d=this.h.invokeFunction(R.createApiFactoryAndRegisterActors);if(this.h.createInstance(T.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const y=this.h.createInstance(A.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=y.ipcHandlePath}await this.h.createInstance(C,d,{mine:this.F,all:this.G}).install(),a.mark("code/extHost/didInitAPI");const p=await this.k.getConfigProvider();await(0,L.connectProxyResolver)(this.j,p,this,this.l,this.u,this.f),a.mark("code/extHost/didInitProxyResolver")}pb(d){return d.main}async qb(d,f,p){if(f.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${f}', must be of file-scheme`);let y=null;p.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${f.toString(!0)}`),this.l.flush();const g=d?.identifier.value;d&&await this.s.initializeLocalizedMessages(d);try{g&&a.mark(`code/extHost/willLoadExtensionCode/${g}`),y=ie.__$__nodeRequire(f.fsPath)}finally{g&&a.mark(`code/extHost/didLoadExtensionCode/${g}`),p.codeLoadingStop()}return y}async $setRemoteEnvironment(d){if(!!this.f.remote.isRemote)for(const f in d){const p=d[f];p===null?delete process.env[f]:process.env[f]=p}}}e.ExtHostExtensionService=m}),define(De[146],Ce([1,0,47,324,307,15,61,38,12,8,2,31,81,325,305,100]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const o=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class d{constructor(v){this.a=v}provideTextSearchResults(v,O,j,V){return this.a.appendLine(`provideTextSearchResults ${v.pattern}, ${JSON.stringify({...O,folder:O.folder.toString()})}`),new Promise((Q,G)=>{V.onCancellationRequested(()=>_());const U=s(v,O),P=O.folder.fsPath,M=U.map(x=>x.match(/^-/)?x:`'${x}'`).join(" ");this.a.appendLine(`${o} ${M}
 - cwd: ${P}`);let B=a.spawn(o,U,{cwd:P});B.on("error",x=>{console.error(x),this.a.appendLine("Error: "+(x&&x.message)),G((0,A.serializeSearchError)(new A.SearchError(x&&x.message,A.SearchErrorCode.rgProcessError)))});let Z=!1;const Y=new y(O.maxResults,P,O.previewOptions);Y.on("result",x=>{Z=!0,be="",j.report(x)});let H=!1;const _=()=>{H=!0,B?.kill(),Y?.cancel()};let ee=!1;Y.on("hitLimit",()=>{ee=!0,_()});let be="";B.stdout.on("data",x=>{Y.handleData(x),Z||(be+=x)});let ce=!1;B.stdout.once("data",()=>ce=!0);let oe="";B.stderr.on("data",x=>{const he=x.toString();this.a.appendLine(he),oe.length+he.length<1e6&&(oe+=he)}),B.on("close",()=>{if(this.a.appendLine(ce?"Got data from stdout":"No data from stdout"),this.a.appendLine(Z?"Got result from parser":"No result from parser"),be&&this.a.appendLine(`Got data without result: ${be}`),this.a.appendLine(""),H)Q({limitHit:ee});else{Y.flush(),B=null;let x;oe&&!ce&&(x=f(oe))?G((0,A.serializeSearchError)(new A.SearchError(x.message,x.code))):Q({limitHit:ee})}})})}}e.RipgrepTextSearchEngine=d;function f(w){const v=w.split(`
`),O=v[0].trim();if(v.some(V=>V.startsWith("regex parse error")))return new A.SearchError(p(v),A.SearchErrorCode.regexParseError);const j=O.match(/grep config error: unknown encoding: (.*)/);if(j)return new A.SearchError(`Unknown encoding: ${j[1]}`,A.SearchErrorCode.unknownEncoding);if(O.startsWith("error parsing glob"))return new A.SearchError(O.charAt(0).toUpperCase()+O.substr(1),A.SearchErrorCode.globParseError);if(O.startsWith("the literal"))return new A.SearchError(O.charAt(0).toUpperCase()+O.substr(1),A.SearchErrorCode.invalidLiteral);if(O.startsWith("PCRE2: error compiling pattern"))return new A.SearchError(O,A.SearchErrorCode.regexParseError)}function p(w){const v=["Regex parse error"],O=w.filter(j=>j.startsWith("PCRE2:"));if(O.length>=1){const j=O[0].replace("PCRE2:","");if(j.indexOf(":")!==-1&&j.split(":").length>=2){const V=j.split(":")[1];v.push(":"+V)}}return v.join("")}class y extends R.EventEmitter{constructor(v,O,j){super(),this.g=v,this.h=O,this.j=j,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new c.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(v,O){return super.on(v,O),this}handleData(v){if(this.b)return;const O=typeof v=="string"?v:this.d.write(v);this.k(O)}k(v){let O=v.indexOf(`
`);const j=this.a+v;if(O>=0)O+=this.a.length;else{this.a=j;return}let V=0;for(;O>=0;)this.m(j.substring(V,O).trim()),V=O+1,O=j.indexOf(`
`,V);this.a=j.substring(V)}m(v){if(this.b||!v)return;let O;try{O=JSON.parse(v)}catch{throw new Error(`malformed line from rg: ${v}`)}if(O.type==="match"){const j=g(O.data.path),V=N.URI.file(S.join(this.h,j)),Q=this.n(O.data,V);this.p(Q),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(O.type==="context"){const j=g(O.data.path),V=N.URI.file(S.join(this.h,j));this.o(O.data,V).forEach(G=>this.p(G))}}n(v,O){const j=v.line_number-1,V=g(v.lines),Q=Buffer.from(V);let G=0,U=0,P=j;v.submatches.length===0&&v.submatches.push(V.length?{start:0,end:1,match:{text:V[0]}}:{start:0,end:0,match:{text:""}});const M=(0,L.coalesce)(v.submatches.map((B,Z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Y=g(B.match),H=Q.slice(G,B.start).toString(),_=t(H),ee=_.numLines>0?_.lastLineLength:_.lastLineLength+U,be=t(Y),ce=_.numLines+P,oe=be.numLines+ce,x=be.numLines>0?be.lastLineLength:be.lastLineLength+ee;return G=B.end,U=x,P=oe,new D.Range(ce,ee,oe,x)}));return(0,m.createTextSearchResult)(O,V,M,this.j)}o(v,O){const j=g(v.lines),V=v.line_number;return j.replace(/\r?\n$/,"").split(`
`).map((Q,G)=>({text:Q,uri:O,lineNumber:V+G}))}p(v){this.emit("result",v)}}e.RipgrepParser=y;function g(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function t(w){const v=/\n/g;let O=0,j=-1,V;for(;V=v.exec(w);)O++,j=V.index;const Q=j>=0?w.length-j-1:w.length;return{numLines:O,lastLineLength:Q}}function s(w,v){const O=["--hidden"];O.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:j,otherIncludes:V}=(0,E.groupBy)(v.includes,G=>G.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(V&&V.length){const G=new Set;V.forEach(U=>{G.add(U)}),O.push("-g","!*"),G.forEach(U=>{r(U).map(m.anchorGlob).forEach(P=>{O.push("-g",P)})})}j&&j.length&&j.forEach(G=>{O.push("-g",G)}),v.excludes.map(m.anchorGlob).forEach(G=>O.push("-g",`!${G}`)),v.maxFileSize&&O.push("--max-filesize",v.maxFileSize+""),v.useIgnoreFiles?v.useParentIgnoreFiles||O.push("--no-ignore-parent"):O.push("--no-ignore"),v.followSymlinks&&O.push("--follow"),v.encoding&&v.encoding!=="utf8"&&O.push("--encoding",v.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,I.escapeRegExpCharacters)(w.pattern),w.isRegExp=!0),v.usePCRE2&&O.push("--pcre2"),O.push("--crlf"),w.isRegExp&&(w.pattern=l(w.pattern),O.push("--engine","auto"));let Q;if(w.isWordMatch){const U=(0,I.createRegExp)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");O.push("--regexp",U)}else if(w.isRegExp){let G=b(w.pattern);G=i(G),O.push("--regexp",G)}else Q=w.pattern,O.push("--fixed-strings");return O.push("--no-config"),v.useGlobalIgnoreFiles||O.push("--no-ignore-global"),O.push("--json"),w.isMultiline&&O.push("--multiline"),v.beforeContext&&O.push("--before-context",v.beforeContext+""),v.afterContext&&O.push("--after-context",v.afterContext+""),O.push("--"),Q&&O.push(Q),O.push("."),O}e.getRgArgs=s;function r(w){return h(w).flatMap(O=>{const j=(0,T.splitGlobAware)(O,"/");return j.map((V,Q)=>j.slice(0,Q+1).join("/"))})}function l(w){const v=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(v);)w=w.replace(v,"$1\\x{$2}");const O=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(O);)w=w.replace(O,"$1\\x{$2}");return w}e.unicodeEscapesToPCRE2=l;const u=w=>w.type==="Assertion"&&w.kind==="lookbehind";function b(w){let v;try{v=new k.RegExpParser().parsePattern(w)}catch{return w}let O="",j=0;const V=(U,P,M)=>{O+=w.slice(j,U)+M,j=P},Q=[];return new k.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const P=Q[0];if(!P)V(U.start,U.end,"\\r?\\n");else if(!Q.some(u))if(P.type==="CharacterClass")if(P.negate){const M=w.slice(P.start+2,U.start)+w.slice(U.end,P.end-1);P.parent?.type==="Quantifier"?V(P.start,P.end,M?`[^${M}]`:"."):V(P.start,P.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=w.slice(P.start+1,U.start)+w.slice(U.end,P.end-1);V(P.start,P.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else P.type==="Quantifier"&&V(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){Q.unshift(U)},onQuantifierLeave(){Q.shift()},onCharacterClassRangeEnter(U){Q.unshift(U)},onCharacterClassRangeLeave(){Q.shift()},onCharacterClassEnter(U){Q.unshift(U)},onCharacterClassLeave(){Q.shift()},onAssertionEnter(U){u(U)&&Q.push(U)},onAssertionLeave(U){Q[0]===U&&Q.shift()}}).visit(v),O+=w.slice(j),O}e.fixRegexNewline=b;function i(w){return w.replace(/\n/g,"\\r?\\n")}e.fixNewline=i;function n(w){let v=!1,O=!1,j="",V="";for(let Q=0;Q<w.length;Q++){const G=w[Q];switch(G){case"\\":O?(v?V+="\\"+G:j+="\\"+G,O=!1):O=!0;break;case"{":if(O)v?V+=G:j+=G,O=!1;else{if(v)return{strInBraces:j+"{"+V+"{"+w.substring(Q+1)};v=!0}break;case"}":if(O)v?V+=G:j+=G,O=!1;else{if(v)return{fixedStart:j,strInBraces:V,fixedEnd:w.substring(Q+1)};j+=G}break;default:v?V+=(O?"\\":"")+G:j+=(O?"\\":"")+G,O=!1;break}}return{strInBraces:j+(v?"{"+V:"")}}function h(w){const{fixedStart:v,strInBraces:O,fixedEnd:j}=n(w);if(v===void 0||j===void 0)return[O];let V=(0,T.splitGlobAware)(O,",");V.length||(V=[""]);const Q=h(j);return V.flatMap(G=>{const U=v+G;return Q.map(P=>U+P)})}e.performBraceExpansionForRipgrep=h}),define(De[314],Ce([1,0,21,146,126,16]),function(ie,e,a,R,c,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class E{constructor(I){this.b=I,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(I,N,A,D){const k=new R.RipgrepTextSearchEngine(this.b);if(N.folder.scheme===L.Schemas.vscodeUserData){const C={...N,folder:N.folder.with({scheme:L.Schemas.file})},m=new c.Progress(o=>A.report({...o,uri:o.uri.with({scheme:N.folder.scheme})}));return this.c(D,o=>k.provideTextSearchResults(I,C,m,o))}else return this.c(D,C=>k.provideTextSearchResults(I,N,A,C))}async c(I,N){const A=T(I);this.a.add(A);const D=await N(A.token);return this.a.delete(A),D}d(){this.a.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=E;function T(S){const I=new a.CancellationTokenSource;return S.onCancellationRequested(()=>I.cancel()),I}}),define(De[315],Ce([1,0,29,146,145]),function(ie,e,a,R,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class L{constructor(S){this.a=S}search(S,I,N){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const A={appendLine(k){N({message:k})}},D=new c.NativeTextSearchManager(this.a,new R.RipgrepTextSearchEngine(A),a);return new Promise((k,C)=>D.search(m=>{I(m.map(E))},S).then(m=>k({limitHit:m.limitHit,type:"success",stats:m.stats}),C))}}e.TextSearchEngineAdapter=L;function E(T){return{path:T.resource&&T.resource.fsPath,results:T.results,numMatches:(T.results||[]).reduce((S,I)=>{if(I.ranges){const N=I;return S+(Array.isArray(N.ranges)?N.ranges.length:1)}else return S+1},0)}}}),define(De[316],Ce([1,0,15,19,10,3,111,12,43,2,44,31,306,315]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class C{constructor(y="searchProcess"){this.d=y,this.b=Object.create(null)}fileSearch(y){let g;const t=d(y),s=new L.Emitter({onDidAddFirstListener:()=>{g=(0,R.createCancelablePromise)(r=>this.doFileSearchWithEngine(D.Engine,t,l=>s.fire(l),r)),g.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return s.event}textSearch(y){let g;const t=d(y),s=new L.Emitter({onDidAddFirstListener:()=>{g=(0,R.createCancelablePromise)(r=>this.f(t,l=>s.fire(l),r)),g.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return s.event}f(y,g,t){return y.maxFileSize=(0,N.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new k.TextSearchEngineAdapter(y).search(t,g,g)}doFileSearch(y,g,t){return this.doFileSearchWithEngine(D.Engine,y,g,t)}doFileSearchWithEngine(y,g,t,s,r=C.a){let l=0;const u=i=>{Array.isArray(i)?(l+=i.length,t(i.map(n=>this.g(n)))):i.relativePath?(l++,t(this.g(i))):t(i)};if(g.sortByScore){let i=this.k(g,u,s);if(!i){const n=g.maxResults?Object.assign({},g,{maxResults:null}):g,h=new y(n);i=this.h(h,g,t,u,s)}return new Promise((n,h)=>{i.then(([w,v])=>{const O=v.map(j=>this.g(j));this.n(O,t,r),n(w)},h)})}const b=new y(g);return this.q(b,u,r,s).then(i=>({limitHit:i.limitHit,type:"success",stats:{detailStats:i.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}g(y){return{path:y.base?(0,T.join)(y.base,y.relativePath):y.relativePath}}h(y,g,t,s,r){const l=new L.Emitter;let u=(0,R.createCancelablePromise)(i=>{let n=[];const h=w=>{Array.isArray(w)?n=w:(s(w),l.fire(w))};return this.q(y,h,-1,i).then(w=>[w,n])}),b;if(g.cacheKey){b=this.j(g.cacheKey);const i={promise:u,event:l.event,resolved:!1};b.resultsToSearchCache[g.filePattern||""]=i,u.then(()=>{i.resolved=!0},n=>{delete b.resultsToSearchCache[g.filePattern||""]}),u=this.r(u)}return u.then(([i,n])=>{const h=b?b.scorerCache:Object.create(null),w=(typeof g.maxResults!="number"||g.maxResults>0)&&S.StopWatch.create(!1);return this.l(g,n,h,r).then(v=>{const O=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:i.stats,sortingTime:O,fromCache:!1,type:this.d,workspaceFolderCount:g.folderQueries.length,resultCount:v.length},messages:i.messages,limitHit:i.limitHit||typeof g.maxResults=="number"&&n.length>g.maxResults},v]})})}j(y){const g=this.b[y];return g||(this.b[y]=new m)}k(y,g,t){const s=y.cacheKey&&this.b[y.cacheKey];if(!s)return;const r=this.o(s,y.filePattern||"",g,t);if(r)return r.then(([l,u,b])=>{const i=S.StopWatch.create(!1);return this.l(y,u,s.scorerCache,t).then(n=>{const h=i.elapsed(),w={fromCache:!0,detailStats:b,type:this.d,resultCount:u.length,sortingTime:h};return[{type:"success",limitHit:l.limitHit||typeof y.maxResults=="number"&&u.length>y.maxResults,stats:w},n]})})}l(y,g,t,s){const r=(0,E.prepareQuery)(y.filePattern||""),l=(b,i)=>(0,E.compareItemsByFuzzyScore)(b,i,r,!0,o,t),u=typeof y.maxResults=="number"?y.maxResults:Number.MAX_VALUE;return a.topAsync(g,l,u,1e4,s)}n(y,g,t){if(t&&t>0)for(let s=0;s<y.length;s+=t)g(y.slice(s,s+t));else g(y)}o(y,g,t,s){const r=S.StopWatch.create(!1),l=g.indexOf(T.sep)>=0;let u;for(const h in y.resultsToSearchCache)if(g.startsWith(h)){if(l&&h.indexOf(T.sep)<0&&h!=="")continue;const w=y.resultsToSearchCache[h];u={promise:this.r(w.promise),event:w.event,resolved:w.resolved};break}if(!u)return null;const b=r.elapsed(),i=S.StopWatch.create(!1),n=u.event(t);return s&&s.onCancellationRequested(()=>{n.dispose()}),u.promise.then(([h,w])=>{if(s&&s.isCancellationRequested)throw(0,c.canceled)();const v=[],O=(0,E.prepareQuery)(g).normalizedLowercase;for(const j of w)!(0,A.isFilePatternMatch)(j,O)||v.push(j);return[h,v,{cacheWasResolved:u.resolved,cacheLookupTime:b,cacheFilterTime:i.elapsed(),cacheEntryCount:w.length}]})}q(y,g,t,s){return new Promise((r,l)=>{let u=[];s?.onCancellationRequested(()=>y.cancel()),y.search(b=>{b&&(t?(u.push(b),t>0&&u.length>=t&&(g(u),u=[])):g(b))},b=>{g(b)},(b,i)=>{u.length&&g(u),b?l(b):r(i)})})}clearCache(y){return delete this.b[y],Promise.resolve(void 0)}r(y){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,t){return y.then(g,t)}catch(g){return this.then(void 0,g)}finally(g){return y.finally(g)}}}}C.a=512,e.SearchService=C;class m{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const o=new class{getItemLabel(p){return(0,T.basename)(p.relativePath)}getItemDescription(p){return(0,T.dirname)(p.relativePath)}getItemPath(p){return p.relativePath}};function d(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(f),extraFileResources:p.extraFileResources&&p.extraFileResources.map(y=>I.URI.revive(y))}}function f(p){return{...p,folder:I.URI.revive(p.folder)}}}),define(De[317],Ce([1,0,6,16,2,29,13,26,20,85,56,31,316,314,100,145]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let o=class extends I.ExtHostSearch{constructor(f,p,y,g){super(f,y,g),this.s=L,this.t=-1,this.v=null,this.w=!1;const t=new C.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(R.Schemas.vscodeUserData,new k.RipgrepSearchProvider(t)),p.remote.isRemote&&p.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const f=new C.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(R.Schemas.file,new k.RipgrepSearchProvider(f)),this.y(R.Schemas.file,new D.SearchService("fileSearchProvider"))}y(f,p){const y=this.d++;return this.v=p,this.t=y,this.c.$registerFileSearchProvider(y,this.o(f)),(0,a.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(y)})}$provideFileSearchResults(f,p,y,g){const t=(0,I.reviveQuery)(y);return f===this.t?this.z(f,p,t,g):super.$provideFileSearchResults(f,p,y,g)}z(f,p,y,g){const t=s=>{if((0,A.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this.c.$handleFileMatch(f,p,s.map(r=>c.URI.file(r.path)));return}s.message&&this.n.debug("ExtHostSearch",s.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(y,t,g)}$clearCache(f){return this.v?.clearCache(f),super.$clearCache(f)}q(f,p){return new m.NativeTextSearchManager(f,p,void 0,"textSearchProvider")}};o=Ve([ze(0,S.IExtHostRpcService),ze(1,T.IExtHostInitDataService),ze(2,N.IURITransformerService),ze(3,E.ILogService)],o),e.NativeExtHostSearch=o}),define(De[318],Ce([1,0,90,289,301,300,317,313,290,84,42,85,82,41,55,79,288,287,13,302,50]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d,f,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(N.IExtHostExtensionService,T.ExtHostExtensionService,0),(0,a.registerSingleton)(f.ILoggerService,d.ExtHostLoggerService,1),(0,a.registerSingleton)(m.IExtensionStoragePaths,o.ExtensionStoragePaths,0),(0,a.registerSingleton)(I.IExtHostDebugService,L.ExtHostDebugService,0),(0,a.registerSingleton)(A.IExtHostSearch,E.NativeExtHostSearch,0),(0,a.registerSingleton)(D.IExtHostTask,c.ExtHostTask,0),(0,a.registerSingleton)(k.IExtHostTerminalService,R.ExtHostTerminalService,0),(0,a.registerSingleton)(C.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,a.registerSingleton)(y.IExtHostVariableResolverProvider,p.NodeExtHostVariableResolverProviderService,0)}),define(De[326],Ce([1,0,230,327,83,10,118,119,208,96,299,22,29,115,19,121,225,238,303,318]),function(ie,e,a,R,c,L,E,T,S,I,N,A,D,k,C,m,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let b=0;b<process.execArgv.length;b++)process.execArgv[b]==="--inspect-port=0"&&(process.execArgv.splice(b,1),b--)}();const f=R(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const u=globalThis._VSCODE_NODE_MODULES.module,b=u._load;u._load=function(i){if(i==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return b.apply(this,arguments)}})();const p=process.exit.bind(process);function y(u){process.exit=function(b){if(u)p(b);else{const i=new Error("An extension called process.exit() and this was prevented.");console.warn(i.stack)}},process.crash=function(){const b=new Error("An extension called process.crash() and this was prevented.");console.warn(b.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(u){p()};function t(){const u=(0,d.readExtHostConnection)(process.env);if(u.type===3)return new Promise((b,i)=>{const n=h=>{const w=h[0],v=new E.BufferedEmitter;w.on("message",O=>v.fire(A.VSBuffer.wrap(O.data))),w.on("close",()=>{g("renderer closed the MessagePort")}),w.start(),b({onMessage:v.event,send:O=>w.postMessage(O.buffer)})};process.parentPort.on("message",h=>n(h.ports))});if(u.type===2)return new Promise((b,i)=>{let n=null;const h=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),w=108e5,v=3e5,O=new C.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (1)"),w),j=new C.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (2)"),v);process.on("message",(Q,G)=>{if(Q&&Q.type==="VSCODE_EXTHOST_IPC_SOCKET"){G.setNoDelay(!0);const U=A.VSBuffer.wrap(Buffer.from(Q.initialDataChunk,"base64"));let P;if(Q.skipWebSocketFrames)P=new T.NodeSocket(G,"extHost-socket");else{const M=A.VSBuffer.wrap(Buffer.from(Q.inflateBytes,"base64"));P=new T.WebSocketNodeSocket(new T.NodeSocket(G,"extHost-socket"),Q.permessageDeflate,M,!1)}n?(O.cancel(),j.cancel(),n.beginAcceptReconnection(P,U),n.endAcceptReconnection(),n.sendResume()):(clearTimeout(h),n=new E.PersistentProtocol({socket:P,initialChunk:U}),n.sendResume(),n.onDidDispose(()=>g("renderer disconnected")),b(n),n.onSocketClose(()=>{O.schedule()}))}if(Q&&Q.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(j.isScheduled())return;O.isScheduled()&&j.schedule()}});const V={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(V)});{const b=u.pipeName;return new Promise((i,n)=>{const h=a.createConnection(b,()=>{h.removeListener("error",n);const w=new E.PersistentProtocol({socket:new T.NodeSocket(h,"extHost-renderer")});w.sendResume(),i(w)});h.once("error",n),h.on("close",()=>{g("renderer closed the socket")})})}}async function s(){const u=await t();return new class{constructor(){this.a=new E.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,u.onMessage(b=>{(0,I.isMessageOfType)(b,2)?(this.b=!0,g("received terminate message from renderer")):this.a.fire(b)})}send(b){this.b||u.send(b)}async drain(){if(u.drain)return u.drain()}}}function r(u){return new Promise(b=>{const i=u.onMessage(n=>{i.dispose();const h=JSON.parse(n.toString()),w=h.commit,v=S.default.commit;if(w&&v&&w!==v&&p(55),h.parentPid){let O=0;setInterval(function(){try{process.kill(h.parentPid,0),O=0}catch(V){V&&V.code==="EPERM"?(O++,O>=3&&g(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):g(`parent process ${h.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let j;try{j=globalThis._VSCODE_NODE_MODULES["native-watchdog"],j.start(h.parentPid)}catch(V){(0,L.onUnexpectedError)(V)}}u.send((0,I.createMessageOfType)(0)),b({protocol:u,initData:h})});u.send((0,I.createMessageOfType)(1))})}async function l(){const u=[];process.on("unhandledRejection",(O,j)=>{u.push(j),setTimeout(()=>{const V=u.indexOf(j);V>=0&&j.catch(Q=>{u.splice(V,1),(0,L.isCancellationError)(Q)||(console.warn(`rejected promise not handled within 1 second: ${Q}`),Q&&Q.stack&&console.warn(`stack trace: ${Q.stack}`),O&&(0,L.onUnexpectedError)(O))})},1e3)}),process.on("rejectionHandled",O=>{const j=u.indexOf(O);j>=0&&u.splice(j,1)}),process.on("uncaughtException",function(O){(0,L.isSigPipeError)(O)||(0,L.onUnexpectedError)(O)}),c.mark("code/extHost/willConnectToRenderer");const b=await s();c.mark("code/extHost/didConnectToRenderer");const i=await r(b);c.mark("code/extHost/didWaitForInitData");const{initData:n}=i;y(!!n.environment.extensionTestsLocationURI),n.environment.useHostProxy=f.useHostProxy!==void 0?f.useHostProxy!=="false":void 0,n.environment.skipWorkspaceStorageLock=(0,m.boolean)(f.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(j){p(j)}exists(j){return D.Promises.exists(j)}realpath(j){return(0,k.realpath)(j)}};let w=null;n.remote.authority&&f.transformURIs&&(w=(0,o.createURITransformer)(n.remote.authority));const v=new N.ExtensionHostMain(i.protocol,n,h,w);g=O=>v.terminate(O)}l().catch(u=>console.log(u))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e4a11014fd91da8f2d82ba144097df21a483334d/core/vs/workbench/api/node/extensionHostProcess.js.map
