/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Te=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Pe=function(te){for(var e=[],n=0,A=te.length;n<A;n++)e[n]=Te[te[n]];return e};define(Te[63],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(E,O){const S=Object.create(null);for(const P of E){const M=O(P);let T=S[M];T||(T=S[M]=[]),T.push(P)}return S}e.groupBy=n;function A(E,O){const S=[],P=[];for(const M of E)O.has(M)||S.push(M);for(const M of O)E.has(M)||P.push(M);return{removed:S,added:P}}e.diffSets=A;function D(E,O){const S=[],P=[];for(const[M,T]of E)O.has(M)||S.push(T);for(const[M,T]of O)E.has(M)||P.push(T);return{removed:S,added:P}}e.diffMaps=D;class N{constructor(){this.a=new Map}add(O,S){let P=this.a.get(O);P||(P=new Set,this.a.set(O,P)),P.add(S)}delete(O,S){const P=this.a.get(O);!P||(P.delete(S),P.size===0&&this.a.delete(O))}forEach(O,S){const P=this.a.get(O);!P||P.forEach(S)}}e.SetMap=N}),define(Te[64],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(E){return(O,S,P)=>{let M=null,T=null;if(typeof P.value=="function"?(M="value",T=P.value):typeof P.get=="function"&&(M="get",T=P.get),!T)throw new Error("not supported");P[M]=E(T,S)}}function A(E,O,S){let P=null,M=null;if(typeof S.value=="function"?(P="value",M=S.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(P="get",M=S.get),!M)throw new Error("not supported");const T=`$memoize$${O}`;S[P]=function(...m){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,m)}),this[T]}}e.memoize=A;function D(E,O,S){return n((P,M)=>{const T=`$debounce$${M}`,m=`$debounce$result$${M}`;return function(...w){this[m]||(this[m]=S?S():void 0),clearTimeout(this[T]),O&&(this[m]=O(this[m],...w),w=[this[m]]),this[T]=setTimeout(()=>{P.apply(this,w),this[m]=S?S():void 0},E)}})}e.debounce=D;function N(E,O,S){return n((P,M)=>{const T=`$throttle$timer$${M}`,m=`$throttle$result$${M}`,w=`$throttle$lastRun$${M}`,f=`$throttle$pending$${M}`;return function(...u){if(this[m]||(this[m]=S?S():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),O&&(this[m]=O(this[m],...u)),this[f])return;const t=this[w]+E;t<=Date.now()?(this[w]=Date.now(),P.apply(this,[this[m]]),this[m]=S?S():void 0):(this[f]=!0,this[T]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),P.apply(this,[this[m]]),this[m]=S?S():void 0},t-Date.now()))}})}e.throttle=N}),define(Te[83],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(D){this.a=D,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Te[112],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var N;(function(i){i.DEFAULT={allowTrailingComma:!0}})(N=e.ParseOptions||(e.ParseOptions={}));function E(i,d=!1){let s=0;const l=i.length;let o="",I=0,r=16,c=0;function h(j){let L=0,g=0;for(;L<j;){const F=i.charCodeAt(s);if(F>=48&&F<=57)g=g*16+F-48;else if(F>=65&&F<=70)g=g*16+F-65+10;else if(F>=97&&F<=102)g=g*16+F-97+10;else break;s++,L++}return L<j&&(g=-1),g}function y(j){s=j,o="",I=0,r=16,c=0}function C(){const j=s;if(i.charCodeAt(s)===48)s++;else for(s++;s<i.length&&P(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===46)if(s++,s<i.length&&P(i.charCodeAt(s)))for(s++;s<i.length&&P(i.charCodeAt(s));)s++;else return c=3,i.substring(j,s);let L=s;if(s<i.length&&(i.charCodeAt(s)===69||i.charCodeAt(s)===101))if(s++,(s<i.length&&i.charCodeAt(s)===43||i.charCodeAt(s)===45)&&s++,s<i.length&&P(i.charCodeAt(s))){for(s++;s<i.length&&P(i.charCodeAt(s));)s++;L=s}else c=3;return i.substring(j,L)}function H(){let j="",L=s;for(;;){if(s>=l){j+=i.substring(L,s),c=2;break}const g=i.charCodeAt(s);if(g===34){j+=i.substring(L,s),s++;break}if(g===92){if(j+=i.substring(L,s),s++,s>=l){c=2;break}switch(i.charCodeAt(s++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const B=h(4);B>=0?j+=String.fromCharCode(B):c=4;break}default:c=5}L=s;continue}if(g>=0&&g<=31)if(S(g)){j+=i.substring(L,s),c=2;break}else c=6;s++}return j}function K(){if(o="",c=0,I=s,s>=l)return I=l,r=17;let j=i.charCodeAt(s);if(O(j)){do s++,o+=String.fromCharCode(j),j=i.charCodeAt(s);while(O(j));return r=15}if(S(j))return s++,o+=String.fromCharCode(j),j===13&&i.charCodeAt(s)===10&&(s++,o+=`
`),r=14;switch(j){case 123:return s++,r=1;case 125:return s++,r=2;case 91:return s++,r=3;case 93:return s++,r=4;case 58:return s++,r=6;case 44:return s++,r=5;case 34:return s++,o=H(),r=10;case 47:{const L=s-1;if(i.charCodeAt(s+1)===47){for(s+=2;s<l&&!S(i.charCodeAt(s));)s++;return o=i.substring(L,s),r=12}if(i.charCodeAt(s+1)===42){s+=2;const g=l-1;let F=!1;for(;s<g;){if(i.charCodeAt(s)===42&&i.charCodeAt(s+1)===47){s+=2,F=!0;break}s++}return F||(s++,c=1),o=i.substring(L,s),r=13}return o+=String.fromCharCode(j),s++,r=16}case 45:if(o+=String.fromCharCode(j),s++,s===l||!P(i.charCodeAt(s)))return r=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=C(),r=11;default:for(;s<l&&Q(j);)s++,j=i.charCodeAt(s);if(I!==s){switch(o=i.substring(I,s),o){case"true":return r=8;case"false":return r=9;case"null":return r=7}return r=16}return o+=String.fromCharCode(j),s++,r=16}}function Q(j){if(O(j)||S(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function _(){let j;do j=K();while(j>=12&&j<=15);return j}return{setPosition:y,getPosition:()=>s,scan:d?_:K,getToken:()=>r,getTokenValue:()=>o,getTokenOffset:()=>I,getTokenLength:()=>s-I,getTokenError:()=>c}}e.createScanner=E;function O(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function S(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var M;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(M||(M={}));function T(i,d){const s=[],l=new Object;let o;const I={value:{},offset:0,length:0,type:"object",parent:void 0};let r=!1;function c(h,y,C,H){I.value=h,I.offset=y,I.length=C,I.type=H,I.colonOffset=void 0,o=I}try{b(i,{onObjectBegin:(h,y)=>{if(d<=h)throw l;o=void 0,r=d>h,s.push("")},onObjectProperty:(h,y,C)=>{if(d<y||(c(h,y,C,"property"),s[s.length-1]=h,d<=y+C))throw l},onObjectEnd:(h,y)=>{if(d<=h)throw l;o=void 0,s.pop()},onArrayBegin:(h,y)=>{if(d<=h)throw l;o=void 0,s.push(0)},onArrayEnd:(h,y)=>{if(d<=h)throw l;o=void 0,s.pop()},onLiteralValue:(h,y,C)=>{if(d<y||(c(h,y,C,v(h)),d<=y+C))throw l},onSeparator:(h,y,C)=>{if(d<=y)throw l;if(h===":"&&o&&o.type==="property")o.colonOffset=y,r=!1,o=void 0;else if(h===","){const H=s[s.length-1];typeof H=="number"?s[s.length-1]=H+1:(r=!0,s[s.length-1]=""),o=void 0}}})}catch(h){if(h!==l)throw h}return{path:s,previousNode:o,isAtPropertyKey:r,matches:h=>{let y=0;for(let C=0;y<h.length&&C<s.length;C++)if(h[y]===s[C]||h[y]==="*")y++;else if(h[y]!=="**")return!1;return y===h.length}}}e.getLocation=T;function m(i,d=[],s=N.DEFAULT){let l=null,o=[];const I=[];function r(h){Array.isArray(o)?o.push(h):l!==null&&(o[l]=h)}return b(i,{onObjectBegin:()=>{const h={};r(h),I.push(o),o=h,l=null},onObjectProperty:h=>{l=h},onObjectEnd:()=>{o=I.pop()},onArrayBegin:()=>{const h=[];r(h),I.push(o),o=h,l=null},onArrayEnd:()=>{o=I.pop()},onLiteralValue:r,onError:(h,y,C)=>{d.push({error:h,offset:y,length:C})}},s),o[0]}e.parse=m;function w(i,d=[],s=N.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(h){l.type==="property"&&(l.length=h-l.offset,l=l.parent)}function I(h){return l.children.push(h),h}b(i,{onObjectBegin:h=>{l=I({type:"object",offset:h,length:-1,parent:l,children:[]})},onObjectProperty:(h,y,C)=>{l=I({type:"property",offset:y,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:h,offset:y,length:C,parent:l})},onObjectEnd:(h,y)=>{l.length=h+y-l.offset,l=l.parent,o(h+y)},onArrayBegin:(h,y)=>{l=I({type:"array",offset:h,length:-1,parent:l,children:[]})},onArrayEnd:(h,y)=>{l.length=h+y-l.offset,l=l.parent,o(h+y)},onLiteralValue:(h,y,C)=>{I({type:v(h),offset:y,length:C,parent:l,value:h}),o(y+C)},onSeparator:(h,y,C)=>{l.type==="property"&&(h===":"?l.colonOffset=y:h===","&&o(y))},onError:(h,y,C)=>{d.push({error:h,offset:y,length:C})}},s);const c=l.children[0];return c&&delete c.parent,c}e.parseTree=w;function f(i,d){if(!i)return;let s=i;for(const l of d)if(typeof l=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const I of s.children)if(Array.isArray(I.children)&&I.children[0].value===l){s=I.children[1],o=!0;break}if(!o)return}else{const o=l;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}e.findNodeAtLocation=f;function u(i){if(!i.parent||!i.parent.children)return[];const d=u(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;d.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&d.push(s)}return d}e.getNodePath=u;function t(i){switch(i.type){case"array":return i.children.map(t);case"object":{const d=Object.create(null);for(const s of i.children){const l=s.children[1];l&&(d[s.children[0].value]=t(l))}return d}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=t;function a(i,d,s=!1){return d>=i.offset&&d<i.offset+i.length||s&&d===i.offset+i.length}e.contains=a;function p(i,d,s=!1){if(a(i,d,s)){const l=i.children;if(Array.isArray(l))for(let o=0;o<l.length&&l[o].offset<=d;o++){const I=p(l[o],d,s);if(I)return I}return i}}e.findNodeAtOffset=p;function b(i,d,s=N.DEFAULT){const l=E(i,!1);function o(De){return De?()=>De(l.getTokenOffset(),l.getTokenLength()):()=>!0}function I(De){return De?de=>De(de,l.getTokenOffset(),l.getTokenLength()):()=>!0}const r=o(d.onObjectBegin),c=I(d.onObjectProperty),h=o(d.onObjectEnd),y=o(d.onArrayBegin),C=o(d.onArrayEnd),H=I(d.onLiteralValue),K=I(d.onSeparator),Q=o(d.onComment),_=I(d.onError),j=s&&s.disallowComments,L=s&&s.allowTrailingComma;function g(){for(;;){const De=l.scan();switch(l.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:j||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(De){case 12:case 13:j?F(10):Q();break;case 16:F(1);break;case 15:case 14:break;default:return De}}}function F(De,de=[],ie=[]){if(_(De),de.length+ie.length>0){let q=l.getToken();for(;q!==17;){if(de.indexOf(q)!==-1){g();break}else if(ie.indexOf(q)!==-1)break;q=g()}}}function B(De){const de=l.getTokenValue();return De?H(de):c(de),g(),!0}function Y(){switch(l.getToken()){case 11:{let De=0;try{De=JSON.parse(l.getTokenValue()),typeof De!="number"&&(F(2),De=0)}catch{F(2)}H(De);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return g(),!0}function me(){return l.getToken()!==10?(F(3,[],[2,5]),!1):(B(!1),l.getToken()===6?(K(":"),g(),ue()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function Z(){r(),g();let De=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(De||F(4,[],[]),K(","),g(),l.getToken()===2&&L)break}else De&&F(6,[],[]);me()||F(4,[],[2,5]),De=!0}return h(),l.getToken()!==2?F(7,[2],[]):g(),!0}function se(){y(),g();let De=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(De||F(4,[],[]),K(","),g(),l.getToken()===4&&L)break}else De&&F(6,[],[]);ue()||F(4,[],[4,5]),De=!0}return C(),l.getToken()!==4?F(8,[4],[]):g(),!0}function ue(){switch(l.getToken()){case 3:return se();case 1:return Z();case 10:return B(!0);default:return Y()}}return g(),l.getToken()===17?s.allowEmptyContent?!0:(F(4,[],[]),!1):ue()?(l.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=b;function R(i,d){const s=E(i),l=[];let o,I=0,r;do switch(r=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:I!==r&&l.push(i.substring(I,r)),d!==void 0&&l.push(s.getTokenValue().replace(/[^\r\n]/g,d)),I=s.getPosition();break}while(o!==17);return l.join("")}e.stripComments=R;function v(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Te[28],Pe([1,0]),function(te,e){"use strict";var n,A,D;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function N(u,t,a){let p=u.get(t);return p===void 0&&(p=a,u.set(t,p)),p}e.getOrSet=N;function E(u){const t=[];return u.forEach((a,p)=>{t.push(`${p} => ${a}`)}),`Map(${u.size}) {${t.join(", ")}}`}e.mapToString=E;function O(u){const t=[];return u.forEach(a=>{t.push(a)}),`Set(${u.size}) {${t.join(", ")}}`}e.setToString=O;class S{constructor(t,a){this.uri=t,this.value=a}}class P{constructor(t,a){this[n]="ResourceMap",t instanceof P?(this.b=new Map(t.b),this.c=a??P.a):(this.b=new Map,this.c=t??P.a)}set(t,a){return this.b.set(this.c(t),new S(t,a)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,a){typeof a<"u"&&(t=t.bind(a));for(const[p,b]of this.b)t(b.value,b.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}P.a=u=>u.toString(),e.ResourceMap=P;class M{constructor(t,a){this[A]="ResourceSet",!t||typeof t=="function"?this.a=new P(t):(this.a=new P(a),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,a){this.a.forEach((p,b)=>t.call(a,b,b,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=M;var T;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(T=e.Touch||(e.Touch={}));class m{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,a=0){const p=this.a.get(t);if(!!p)return a!==0&&this.j(p,a),p.value}set(t,a,p=0){let b=this.a.get(t);if(b)b.value=a,p!==0&&this.j(b,p);else{switch(b={key:t,value:a,next:void 0,previous:void 0},p){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(t,b),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const a=this.a.get(t);if(!!a)return this.a.delete(t),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,a){const p=this.e;let b=this.b;for(;b;){if(a?t.bind(a)(b.value,b.key,this):t(b.value,b.key,this),this.e!==p)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const t=this,a=this.e;let p=this.b;const b={[Symbol.iterator](){return b},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(p){const R={value:p.key,done:!1};return p=p.next,R}else return{value:void 0,done:!0}}};return b}values(){const t=this,a=this.e;let p=this.b;const b={[Symbol.iterator](){return b},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(p){const R={value:p.value,done:!1};return p=p.next,R}else return{value:void 0,done:!0}}};return b}entries(){const t=this,a=this.e;let p=this.b;const b={[Symbol.iterator](){return b},next(){if(t.e!==a)throw new Error("LinkedMap got modified during iteration.");if(p){const R={value:[p.key,p.value],done:!1};return p=p.next,R}else return{value:void 0,done:!0}}};return b}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let a=this.b,p=this.size;for(;a&&p>t;)this.a.delete(a.key),a=a.next,p--;this.b=a,this.d=p,a&&(a.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const a=t.next,p=t.previous;if(!a||!p)throw new Error("Invalid list");a.previous=p,p.next=a}t.next=void 0,t.previous=void 0,this.e++}j(t,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(t===this.b)return;const p=t.next,b=t.previous;t===this.c?(b.next=void 0,this.c=b):(p.previous=b,b.next=p),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(a===2){if(t===this.c)return;const p=t.next,b=t.previous;t===this.b?(p.previous=void 0,this.b=p):(p.previous=b,b.next=p),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((a,p)=>{t.push([p,a])}),t}fromJSON(t){this.clear();for(const[a,p]of t)this.set(a,p)}}e.LinkedMap=m;class w extends m{constructor(t,a=1){super(),this.k=t,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,a=2){return super.get(t,a)}peek(t){return super.get(t,0)}set(t,a){return super.set(t,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=w;class f{constructor(){this.a=new Map}add(t){return this.a.set(t,(this.a.get(t)||0)+1),this}delete(t){let a=this.a.get(t)||0;return a===0?!1:(a--,a===0?this.a.delete(t):this.a.set(t,a),!0)}has(t){return this.a.has(t)}}e.CounterSet=f}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Te[113],Pe([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Ce,Se){for(var ke=0;ke<Se.length;ke++){var oe=Se[ke];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Ce,oe.key,oe)}}function n(Ce,Se,ke){return Se&&e(Ce.prototype,Se),ke&&e(Ce,ke),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function A(Ce,Se){if(!!Ce){if(typeof Ce=="string")return D(Ce,Se);var ke=Object.prototype.toString.call(Ce).slice(8,-1);if(ke==="Object"&&Ce.constructor&&(ke=Ce.constructor.name),ke==="Map"||ke==="Set")return Array.from(Ce);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return D(Ce,Se)}}function D(Ce,Se){(Se==null||Se>Ce.length)&&(Se=Ce.length);for(var ke=0,oe=new Array(Se);ke<Se;ke++)oe[ke]=Ce[ke];return oe}function N(Ce,Se){var ke=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(ke)return(ke=ke.call(Ce)).next.bind(ke);if(Array.isArray(Ce)||(ke=A(Ce))||Se&&Ce&&typeof Ce.length=="number"){ke&&(Ce=ke);var oe=0;return function(){return oe>=Ce.length?{done:!0}:{done:!1,value:Ce[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function E(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=E();function O(Ce){te.defaults=Ce}var S=/[&<>"']/,P=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(Se){return m[Se]};function f(Ce,Se){if(Se){if(S.test(Ce))return Ce.replace(P,w)}else if(M.test(Ce))return Ce.replace(T,w);return Ce}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(Ce){return Ce.replace(u,function(Se,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var a=/(^|[^\[])\^/g;function p(Ce,Se){Ce=typeof Ce=="string"?Ce:Ce.source,Se=Se||"";var ke={replace:function(ae,J){return J=J.source||J,J=J.replace(a,"$1"),Ce=Ce.replace(ae,J),ke},getRegex:function(){return new RegExp(Ce,Se)}};return ke}var b=/[^\w:]/g,R=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Ce,Se,ke){if(Ce){var oe;try{oe=decodeURIComponent(t(ke)).replace(b,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Se&&!R.test(ke)&&(ke=o(Se,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var i={},d=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(Ce,Se){i[" "+Ce]||(d.test(Ce)?i[" "+Ce]=Ce+"/":i[" "+Ce]=h(Ce,"/",!0)),Ce=i[" "+Ce];var ke=Ce.indexOf(":")===-1;return Se.substring(0,2)==="//"?ke?Se:Ce.replace(s,"$1")+Se:Se.charAt(0)==="/"?ke?Se:Ce.replace(l,"$1")+Se:Ce+Se}var I={exec:function(){}};function r(Ce){for(var Se=1,ke,oe;Se<arguments.length;Se++){ke=arguments[Se];for(oe in ke)Object.prototype.hasOwnProperty.call(ke,oe)&&(Ce[oe]=ke[oe])}return Ce}function c(Ce,Se){var ke=Ce.replace(/\|/g,function(J,k,$){for(var W=!1,V=k;--V>=0&&$[V]==="\\";)W=!W;return W?"|":" |"}),oe=ke.split(/ \|/),ae=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>Se)oe.splice(Se);else for(;oe.length<Se;)oe.push("");for(;ae<oe.length;ae++)oe[ae]=oe[ae].trim().replace(/\\\|/g,"|");return oe}function h(Ce,Se,ke){var oe=Ce.length;if(oe===0)return"";for(var ae=0;ae<oe;){var J=Ce.charAt(oe-ae-1);if(J===Se&&!ke)ae++;else if(J!==Se&&ke)ae++;else break}return Ce.slice(0,oe-ae)}function y(Ce,Se){if(Ce.indexOf(Se[1])===-1)return-1;for(var ke=Ce.length,oe=0,ae=0;ae<ke;ae++)if(Ce[ae]==="\\")ae++;else if(Ce[ae]===Se[0])oe++;else if(Ce[ae]===Se[1]&&(oe--,oe<0))return ae;return-1}function C(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function H(Ce,Se){if(Se<1)return"";for(var ke="";Se>1;)Se&1&&(ke+=Ce),Se>>=1,Ce+=Ce;return ke+Ce}function K(Ce,Se,ke,oe){var ae=Se.href,J=Se.title?f(Se.title):null,k=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){oe.state.inLink=!0;var $={type:"link",raw:ke,href:ae,title:J,text:k,tokens:oe.inlineTokens(k)};return oe.state.inLink=!1,$}return{type:"image",raw:ke,href:ae,title:J,text:f(k)}}function Q(Ce,Se){var ke=Ce.match(/^(\s+)(?:```)/);if(ke===null)return Se;var oe=ke[1];return Se.split(`
`).map(function(ae){var J=ae.match(/^\s+/);if(J===null)return ae;var k=J[0];return k.length>=oe.length?ae.slice(oe.length):ae}).join(`
`)}var _=function(){function Ce(ke){this.options=ke||te.defaults}var Se=Ce.prototype;return Se.space=function(oe){var ae=this.rules.block.newline.exec(oe);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},Se.code=function(oe){var ae=this.rules.block.code.exec(oe);if(ae){var J=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?J:h(J,`
`)}}},Se.fences=function(oe){var ae=this.rules.block.fences.exec(oe);if(ae){var J=ae[0],k=Q(J,ae[3]||"");return{type:"code",raw:J,lang:ae[2]?ae[2].trim():ae[2],text:k}}},Se.heading=function(oe){var ae=this.rules.block.heading.exec(oe);if(ae){var J=ae[2].trim();if(/#$/.test(J)){var k=h(J,"#");(this.options.pedantic||!k||/ $/.test(k))&&(J=k.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:J,tokens:this.lexer.inline(J)}}},Se.hr=function(oe){var ae=this.rules.block.hr.exec(oe);if(ae)return{type:"hr",raw:ae[0]}},Se.blockquote=function(oe){var ae=this.rules.block.blockquote.exec(oe);if(ae){var J=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},Se.list=function(oe){var ae=this.rules.block.list.exec(oe);if(ae){var J,k,$,W,V,ee,fe,Ie,le,ve,Ee,We,je=ae[1].trim(),it=je.length>1,Ge={type:"list",raw:"",ordered:it,start:it?+je.slice(0,-1):"",loose:!1,items:[]};je=it?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=it?je:"[*+-]");for(var tt=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(We=!1,!(!(ae=tt.exec(oe))||this.rules.block.hr.test(oe)));){if(J=ae[0],oe=oe.substring(J.length),Ie=ae[2].split(`
`,1)[0],le=oe.split(`
`,1)[0],this.options.pedantic?(W=2,Ee=Ie.trimLeft()):(W=ae[2].search(/[^ ]/),W=W>4?1:W,Ee=Ie.slice(W),W+=ae[1].length),ee=!1,!Ie&&/^ *$/.test(le)&&(J+=le+`
`,oe=oe.substring(le.length+1),We=!0),!We)for(var nt=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ne=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),G=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");oe&&(ve=oe.split(`
`,1)[0],Ie=ve,this.options.pedantic&&(Ie=Ie.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(Ie)||G.test(Ie)||nt.test(Ie)||Ne.test(oe)));){if(Ie.search(/[^ ]/)>=W||!Ie.trim())Ee+=`
`+Ie.slice(W);else if(!ee)Ee+=`
`+Ie;else break;!ee&&!Ie.trim()&&(ee=!0),J+=ve+`
`,oe=oe.substring(ve.length+1)}Ge.loose||(fe?Ge.loose=!0:/\n *\n *$/.test(J)&&(fe=!0)),this.options.gfm&&(k=/^\[[ xX]\] /.exec(Ee),k&&($=k[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:J,task:!!k,checked:$,loose:!1,text:Ee}),Ge.raw+=J}Ge.items[Ge.items.length-1].raw=J.trimRight(),Ge.items[Ge.items.length-1].text=Ee.trimRight(),Ge.raw=Ge.raw.trimRight();var X=Ge.items.length;for(V=0;V<X;V++){this.lexer.state.top=!1,Ge.items[V].tokens=this.lexer.blockTokens(Ge.items[V].text,[]);var pe=Ge.items[V].tokens.filter(function(Be){return Be.type==="space"}),ze=pe.every(function(Be){for(var Qe=Be.raw.split(""),_e=0,Xe=N(Qe),at;!(at=Xe()).done;){var bt=at.value;if(bt===`
`&&(_e+=1),_e>1)return!0}return!1});!Ge.loose&&pe.length&&ze&&(Ge.loose=!0,Ge.items[V].loose=!0)}return Ge}},Se.html=function(oe){var ae=this.rules.block.html.exec(oe);if(ae){var J={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var k=this.options.sanitizer?this.options.sanitizer(ae[0]):f(ae[0]);J.type="paragraph",J.text=k,J.tokens=this.lexer.inline(k)}return J}},Se.def=function(oe){var ae=this.rules.block.def.exec(oe);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var J=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:ae[0],href:ae[2],title:ae[3]}}},Se.table=function(oe){var ae=this.rules.block.table.exec(oe);if(ae){var J={type:"table",header:c(ae[1]).map(function(fe){return{text:fe}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=ae[0];var k=J.align.length,$,W,V,ee;for($=0;$<k;$++)/^ *-+: *$/.test(J.align[$])?J.align[$]="right":/^ *:-+: *$/.test(J.align[$])?J.align[$]="center":/^ *:-+ *$/.test(J.align[$])?J.align[$]="left":J.align[$]=null;for(k=J.rows.length,$=0;$<k;$++)J.rows[$]=c(J.rows[$],J.header.length).map(function(fe){return{text:fe}});for(k=J.header.length,W=0;W<k;W++)J.header[W].tokens=this.lexer.inline(J.header[W].text);for(k=J.rows.length,W=0;W<k;W++)for(ee=J.rows[W],V=0;V<ee.length;V++)ee[V].tokens=this.lexer.inline(ee[V].text);return J}}},Se.lheading=function(oe){var ae=this.rules.block.lheading.exec(oe);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},Se.paragraph=function(oe){var ae=this.rules.block.paragraph.exec(oe);if(ae){var J=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:J,tokens:this.lexer.inline(J)}}},Se.text=function(oe){var ae=this.rules.block.text.exec(oe);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},Se.escape=function(oe){var ae=this.rules.inline.escape.exec(oe);if(ae)return{type:"escape",raw:ae[0],text:f(ae[1])}},Se.tag=function(oe){var ae=this.rules.inline.tag.exec(oe);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):f(ae[0]):ae[0]}},Se.link=function(oe){var ae=this.rules.inline.link.exec(oe);if(ae){var J=ae[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var k=h(J.slice(0,-1),"\\");if((J.length-k.length)%2===0)return}else{var $=y(ae[2],"()");if($>-1){var W=ae[0].indexOf("!")===0?5:4,V=W+ae[1].length+$;ae[2]=ae[2].substring(0,$),ae[0]=ae[0].substring(0,V).trim(),ae[3]=""}}var ee=ae[2],fe="";if(this.options.pedantic){var Ie=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ee);Ie&&(ee=Ie[1],fe=Ie[3])}else fe=ae[3]?ae[3].slice(1,-1):"";return ee=ee.trim(),/^</.test(ee)&&(this.options.pedantic&&!/>$/.test(J)?ee=ee.slice(1):ee=ee.slice(1,-1)),K(ae,{href:ee&&ee.replace(this.rules.inline._escapes,"$1"),title:fe&&fe.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},Se.reflink=function(oe,ae){var J;if((J=this.rules.inline.reflink.exec(oe))||(J=this.rules.inline.nolink.exec(oe))){var k=(J[2]||J[1]).replace(/\s+/g," ");if(k=ae[k.toLowerCase()],!k||!k.href){var $=J[0].charAt(0);return{type:"text",raw:$,text:$}}return K(J,k,J[0],this.lexer)}},Se.emStrong=function(oe,ae,J){J===void 0&&(J="");var k=this.rules.inline.emStrong.lDelim.exec(oe);if(!!k&&!(k[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=k[1]||k[2]||"";if(!$||$&&(J===""||this.rules.inline.punctuation.exec(J))){var W=k[0].length-1,V,ee,fe=W,Ie=0,le=k[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(le.lastIndex=0,ae=ae.slice(-1*oe.length+W);(k=le.exec(ae))!=null;)if(V=k[1]||k[2]||k[3]||k[4]||k[5]||k[6],!!V){if(ee=V.length,k[3]||k[4]){fe+=ee;continue}else if((k[5]||k[6])&&W%3&&!((W+ee)%3)){Ie+=ee;continue}if(fe-=ee,!(fe>0)){if(ee=Math.min(ee,ee+fe+Ie),Math.min(W,ee)%2){var ve=oe.slice(1,W+k.index+ee);return{type:"em",raw:oe.slice(0,W+k.index+ee+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var Ee=oe.slice(2,W+k.index+ee-1);return{type:"strong",raw:oe.slice(0,W+k.index+ee+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Se.codespan=function(oe){var ae=this.rules.inline.code.exec(oe);if(ae){var J=ae[2].replace(/\n/g," "),k=/[^ ]/.test(J),$=/^ /.test(J)&&/ $/.test(J);return k&&$&&(J=J.substring(1,J.length-1)),J=f(J,!0),{type:"codespan",raw:ae[0],text:J}}},Se.br=function(oe){var ae=this.rules.inline.br.exec(oe);if(ae)return{type:"br",raw:ae[0]}},Se.del=function(oe){var ae=this.rules.inline.del.exec(oe);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},Se.autolink=function(oe,ae){var J=this.rules.inline.autolink.exec(oe);if(J){var k,$;return J[2]==="@"?(k=f(this.options.mangle?ae(J[1]):J[1]),$="mailto:"+k):(k=f(J[1]),$=k),{type:"link",raw:J[0],text:k,href:$,tokens:[{type:"text",raw:k,text:k}]}}},Se.url=function(oe,ae){var J;if(J=this.rules.inline.url.exec(oe)){var k,$;if(J[2]==="@")k=f(this.options.mangle?ae(J[0]):J[0]),$="mailto:"+k;else{var W;do W=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(W!==J[0]);k=f(J[0]),J[1]==="www."?$="http://"+k:$=k}return{type:"link",raw:J[0],text:k,href:$,tokens:[{type:"text",raw:k,text:k}]}}},Se.inlineText=function(oe,ae){var J=this.rules.inline.text.exec(oe);if(J){var k;return this.lexer.state.inRawBlock?k=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):f(J[0]):J[0]:k=f(this.options.smartypants?ae(J[0]):J[0]),{type:"text",raw:J[0],text:k}}},Ce}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=p(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=p(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=p(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=p(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=p(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=p(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=r({},j),j.gfm=r({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=p(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=p(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=r({},j.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:p(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=p(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=p(j._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=p(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=p(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=p(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=p(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=p(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=p(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=p(L.reflink).replace("label",L._label).replace("ref",j._label).getRegex(),L.nolink=p(L.nolink).replace("ref",j._label).getRegex(),L.reflinkSearch=p(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=r({},L),L.pedantic=r({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=r({},L.normal,{escape:p(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=p(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=r({},L.gfm,{br:p(L.br).replace("{2,}","*").getRegex(),text:p(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function g(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(Ce){var Se="",ke,oe,ae=Ce.length;for(ke=0;ke<ae;ke++)oe=Ce.charCodeAt(ke),Math.random()>.5&&(oe="x"+oe.toString(16)),Se+="&#"+oe+";";return Se}var B=function(){function Ce(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||te.defaults,this.options.tokenizer=this.options.tokenizer||new _,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:j.normal,inline:L.normal};this.options.pedantic?(oe.block=j.pedantic,oe.inline=L.pedantic):this.options.gfm&&(oe.block=j.gfm,this.options.breaks?oe.inline=L.breaks:oe.inline=L.gfm),this.tokenizer.rules=oe}Ce.lex=function(oe,ae){var J=new Ce(ae);return J.lex(oe)},Ce.lexInline=function(oe,ae){var J=new Ce(ae);return J.inlineTokens(oe)};var Se=Ce.prototype;return Se.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},Se.blockTokens=function(oe,ae){var J=this;ae===void 0&&(ae=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(fe,Ie,le){return Ie+"    ".repeat(le.length)});for(var k,$,W,V;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(fe){return(k=fe.call({lexer:J},oe,ae))?(oe=oe.substring(k.raw.length),ae.push(k),!0):!1}))){if(k=this.tokenizer.space(oe)){oe=oe.substring(k.raw.length),k.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(k);continue}if(k=this.tokenizer.code(oe)){oe=oe.substring(k.raw.length),$=ae[ae.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+k.raw,$.text+=`
`+k.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):ae.push(k);continue}if(k=this.tokenizer.fences(oe)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.heading(oe)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.hr(oe)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.blockquote(oe)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.list(oe)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.html(oe)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.def(oe)){oe=oe.substring(k.raw.length),$=ae[ae.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+k.raw,$.text+=`
`+k.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[k.tag]||(this.tokens.links[k.tag]={href:k.href,title:k.title});continue}if(k=this.tokenizer.table(oe)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.lheading(oe)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(W=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var fe=1/0,Ie=oe.slice(1),le=void 0;J.options.extensions.startBlock.forEach(function(ve){le=ve.call({lexer:this},Ie),typeof le=="number"&&le>=0&&(fe=Math.min(fe,le))}),fe<1/0&&fe>=0&&(W=oe.substring(0,fe+1))}(),this.state.top&&(k=this.tokenizer.paragraph(W))){$=ae[ae.length-1],V&&$.type==="paragraph"?($.raw+=`
`+k.raw,$.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ae.push(k),V=W.length!==oe.length,oe=oe.substring(k.raw.length);continue}if(k=this.tokenizer.text(oe)){oe=oe.substring(k.raw.length),$=ae[ae.length-1],$&&$.type==="text"?($.raw+=`
`+k.raw,$.text+=`
`+k.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ae.push(k);continue}if(oe){var ee="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return this.state.top=!0,ae},Se.inline=function(oe,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:oe,tokens:ae}),ae},Se.inlineTokens=function(oe,ae){var J=this;ae===void 0&&(ae=[]);var k,$,W,V=oe,ee,fe,Ie;if(this.tokens.links){var le=Object.keys(this.tokens.links);if(le.length>0)for(;(ee=this.tokenizer.rules.inline.reflinkSearch.exec(V))!=null;)le.includes(ee[0].slice(ee[0].lastIndexOf("[")+1,-1))&&(V=V.slice(0,ee.index)+"["+H("a",ee[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ee=this.tokenizer.rules.inline.blockSkip.exec(V))!=null;)V=V.slice(0,ee.index)+"["+H("a",ee[0].length-2)+"]"+V.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ee=this.tokenizer.rules.inline.escapedEmSt.exec(V))!=null;)V=V.slice(0,ee.index)+"++"+V.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(fe||(Ie=""),fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(k=Ee.call({lexer:J},oe,ae))?(oe=oe.substring(k.raw.length),ae.push(k),!0):!1}))){if(k=this.tokenizer.escape(oe)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.tag(oe)){oe=oe.substring(k.raw.length),$=ae[ae.length-1],$&&k.type==="text"&&$.type==="text"?($.raw+=k.raw,$.text+=k.text):ae.push(k);continue}if(k=this.tokenizer.link(oe)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(k.raw.length),$=ae[ae.length-1],$&&k.type==="text"&&$.type==="text"?($.raw+=k.raw,$.text+=k.text):ae.push(k);continue}if(k=this.tokenizer.emStrong(oe,V,Ie)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.codespan(oe)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.br(oe)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.del(oe)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(k=this.tokenizer.autolink(oe,F)){oe=oe.substring(k.raw.length),ae.push(k);continue}if(!this.state.inLink&&(k=this.tokenizer.url(oe,F))){oe=oe.substring(k.raw.length),ae.push(k);continue}if(W=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,We=oe.slice(1),je=void 0;J.options.extensions.startInline.forEach(function(it){je=it.call({lexer:this},We),typeof je=="number"&&je>=0&&(Ee=Math.min(Ee,je))}),Ee<1/0&&Ee>=0&&(W=oe.substring(0,Ee+1))}(),k=this.tokenizer.inlineText(W,g)){oe=oe.substring(k.raw.length),k.raw.slice(-1)!=="_"&&(Ie=k.raw.slice(-1)),fe=!0,$=ae[ae.length-1],$&&$.type==="text"?($.raw+=k.raw,$.text+=k.text):ae.push(k);continue}if(oe){var ve="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ae},n(Ce,null,[{key:"rules",get:function(){return{block:j,inline:L}}}]),Ce}(),Y=function(){function Ce(ke){this.options=ke||te.defaults}var Se=Ce.prototype;return Se.code=function(oe,ae,J){var k=(ae||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(oe,k);$!=null&&$!==oe&&(J=!0,oe=$)}return oe=oe.replace(/\n$/,"")+`
`,k?'<pre><code class="'+this.options.langPrefix+f(k,!0)+'">'+(J?oe:f(oe,!0))+`</code></pre>
`:"<pre><code>"+(J?oe:f(oe,!0))+`</code></pre>
`},Se.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Se.html=function(oe){return oe},Se.heading=function(oe,ae,J,k){if(this.options.headerIds){var $=this.options.headerPrefix+k.slug(J);return"<h"+ae+' id="'+$+'">'+oe+"</h"+ae+`>
`}return"<h"+ae+">"+oe+"</h"+ae+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(oe,ae,J){var k=ae?"ol":"ul",$=ae&&J!==1?' start="'+J+'"':"";return"<"+k+$+`>
`+oe+"</"+k+`>
`},Se.listitem=function(oe){return"<li>"+oe+`</li>
`},Se.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(oe){return"<p>"+oe+`</p>
`},Se.table=function(oe,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ae+`</table>
`},Se.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Se.tablecell=function(oe,ae){var J=ae.header?"th":"td",k=ae.align?"<"+J+' align="'+ae.align+'">':"<"+J+">";return k+oe+("</"+J+`>
`)},Se.strong=function(oe){return"<strong>"+oe+"</strong>"},Se.em=function(oe){return"<em>"+oe+"</em>"},Se.codespan=function(oe){return"<code>"+oe+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(oe){return"<del>"+oe+"</del>"},Se.link=function(oe,ae,J){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return J;var k='<a href="'+f(oe)+'"';return ae&&(k+=' title="'+ae+'"'),k+=">"+J+"</a>",k},Se.image=function(oe,ae,J){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return J;var k='<img src="'+oe+'" alt="'+J+'"';return ae&&(k+=' title="'+ae+'"'),k+=this.options.xhtml?"/>":">",k},Se.text=function(oe){return oe},Ce}(),me=function(){function Ce(){}var Se=Ce.prototype;return Se.strong=function(oe){return oe},Se.em=function(oe){return oe},Se.codespan=function(oe){return oe},Se.del=function(oe){return oe},Se.html=function(oe){return oe},Se.text=function(oe){return oe},Se.link=function(oe,ae,J){return""+J},Se.image=function(oe,ae,J){return""+J},Se.br=function(){return""},Ce}(),Z=function(){function Ce(){this.seen={}}var Se=Ce.prototype;return Se.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(oe,ae){var J=oe,k=0;if(this.seen.hasOwnProperty(J)){k=this.seen[oe];do k++,J=oe+"-"+k;while(this.seen.hasOwnProperty(J))}return ae||(this.seen[oe]=k,this.seen[J]=0),J},Se.slug=function(oe,ae){ae===void 0&&(ae={});var J=this.serialize(oe);return this.getNextSafeSlug(J,ae.dryrun)},Ce}(),se=function(){function Ce(ke){this.options=ke||te.defaults,this.options.renderer=this.options.renderer||new Y,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new me,this.slugger=new Z}Ce.parse=function(oe,ae){var J=new Ce(ae);return J.parse(oe)},Ce.parseInline=function(oe,ae){var J=new Ce(ae);return J.parseInline(oe)};var Se=Ce.prototype;return Se.parse=function(oe,ae){ae===void 0&&(ae=!0);var J="",k,$,W,V,ee,fe,Ie,le,ve,Ee,We,je,it,Ge,tt,nt,Ne,rt,G,X=oe.length;for(k=0;k<X;k++){if(Ee=oe[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(G=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),G!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){J+=G||"";continue}switch(Ee.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,t(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(le="",Ie="",V=Ee.header.length,$=0;$<V;$++)Ie+=this.renderer.tablecell(this.parseInline(Ee.header[$].tokens),{header:!0,align:Ee.align[$]});for(le+=this.renderer.tablerow(Ie),ve="",V=Ee.rows.length,$=0;$<V;$++){for(fe=Ee.rows[$],Ie="",ee=fe.length,W=0;W<ee;W++)Ie+=this.renderer.tablecell(this.parseInline(fe[W].tokens),{header:!1,align:Ee.align[W]});ve+=this.renderer.tablerow(Ie)}J+=this.renderer.table(le,ve);continue}case"blockquote":{ve=this.parse(Ee.tokens),J+=this.renderer.blockquote(ve);continue}case"list":{for(We=Ee.ordered,je=Ee.start,it=Ee.loose,V=Ee.items.length,ve="",$=0;$<V;$++)tt=Ee.items[$],nt=tt.checked,Ne=tt.task,Ge="",tt.task&&(rt=this.renderer.checkbox(nt),it?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=rt+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=rt+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:rt}):Ge+=rt),Ge+=this.parse(tt.tokens,it),ve+=this.renderer.listitem(Ge,Ne,nt);J+=this.renderer.list(ve,We,je);continue}case"html":{J+=this.renderer.html(Ee.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(ve=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;k+1<X&&oe[k+1].type==="text";)Ee=oe[++k],ve+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);J+=ae?this.renderer.paragraph(ve):ve;continue}default:{var pe='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(pe);return}else throw new Error(pe)}}}return J},Se.parseInline=function(oe,ae){ae=ae||this.renderer;var J="",k,$,W,V=oe.length;for(k=0;k<V;k++){if($=oe[k],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(W=this.options.extensions.renderers[$.type].call({parser:this},$),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){J+=W||"";continue}switch($.type){case"escape":{J+=ae.text($.text);break}case"html":{J+=ae.html($.text);break}case"link":{J+=ae.link($.href,$.title,this.parseInline($.tokens,ae));break}case"image":{J+=ae.image($.href,$.title,$.text);break}case"strong":{J+=ae.strong(this.parseInline($.tokens,ae));break}case"em":{J+=ae.em(this.parseInline($.tokens,ae));break}case"codespan":{J+=ae.codespan($.text);break}case"br":{J+=ae.br();break}case"del":{J+=ae.del(this.parseInline($.tokens,ae));break}case"text":{J+=ae.text($.text);break}default:{var ee='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(ee);return}else throw new Error(ee)}}}return J},Ce}();function ue(Ce,Se,ke){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof Se=="function"&&(ke=Se,Se=null),Se=r({},ue.defaults,Se||{}),C(Se),ke){var oe=Se.highlight,ae;try{ae=B.lex(Ce,Se)}catch(V){return ke(V)}var J=function(ee){var fe;if(!ee)try{Se.walkTokens&&ue.walkTokens(ae,Se.walkTokens),fe=se.parse(ae,Se)}catch(Ie){ee=Ie}return Se.highlight=oe,ee?ke(ee):ke(null,fe)};if(!oe||oe.length<3||(delete Se.highlight,!ae.length))return J();var k=0;ue.walkTokens(ae,function(V){V.type==="code"&&(k++,setTimeout(function(){oe(V.text,V.lang,function(ee,fe){if(ee)return J(ee);fe!=null&&fe!==V.text&&(V.text=fe,V.escaped=!0),k--,k===0&&J()})},0))}),k===0&&J();return}function $(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(V.message+"",!0)+"</pre>";throw V}try{var W=B.lex(Ce,Se);if(Se.walkTokens){if(Se.async)return Promise.all(ue.walkTokens(W,Se.walkTokens)).then(function(){return se.parse(W,Se)}).catch($);ue.walkTokens(W,Se.walkTokens)}return se.parse(W,Se)}catch(V){$(V)}}ue.options=ue.setOptions=function(Ce){return r(ue.defaults,Ce),O(ue.defaults),ue},ue.getDefaults=E,ue.defaults=te.defaults,ue.use=function(){for(var Ce=arguments.length,Se=new Array(Ce),ke=0;ke<Ce;ke++)Se[ke]=arguments[ke];var oe=r.apply(void 0,[{}].concat(Se)),ae=ue.defaults.extensions||{renderers:{},childTokens:{}},J;Se.forEach(function(k){if(k.extensions&&(J=!0,k.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var V=ae.renderers?ae.renderers[W.name]:null;V?ae.renderers[W.name]=function(){for(var ee=arguments.length,fe=new Array(ee),Ie=0;Ie<ee;Ie++)fe[Ie]=arguments[Ie];var le=W.renderer.apply(this,fe);return le===!1&&(le=V.apply(this,fe)),le}:ae.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[W.level]?ae[W.level].unshift(W.tokenizer):ae[W.level]=[W.tokenizer],W.start&&(W.level==="block"?ae.startBlock?ae.startBlock.push(W.start):ae.startBlock=[W.start]:W.level==="inline"&&(ae.startInline?ae.startInline.push(W.start):ae.startInline=[W.start]))}W.childTokens&&(ae.childTokens[W.name]=W.childTokens)})),k.renderer&&function(){var W=ue.defaults.renderer||new Y,V=function(Ie){var le=W[Ie];W[Ie]=function(){for(var ve=arguments.length,Ee=new Array(ve),We=0;We<ve;We++)Ee[We]=arguments[We];var je=k.renderer[Ie].apply(W,Ee);return je===!1&&(je=le.apply(W,Ee)),je}};for(var ee in k.renderer)V(ee);oe.renderer=W}(),k.tokenizer&&function(){var W=ue.defaults.tokenizer||new _,V=function(Ie){var le=W[Ie];W[Ie]=function(){for(var ve=arguments.length,Ee=new Array(ve),We=0;We<ve;We++)Ee[We]=arguments[We];var je=k.tokenizer[Ie].apply(W,Ee);return je===!1&&(je=le.apply(W,Ee)),je}};for(var ee in k.tokenizer)V(ee);oe.tokenizer=W}(),k.walkTokens){var $=ue.defaults.walkTokens;oe.walkTokens=function(W){var V=[];return V.push(k.walkTokens.call(this,W)),$&&(V=V.concat($.call(this,W))),V}}J&&(oe.extensions=ae),ue.setOptions(oe)})},ue.walkTokens=function(Ce,Se){for(var ke=[],oe=function(){var $=J.value;switch(ke=ke.concat(Se.call(ue,$)),$.type){case"table":{for(var W=N($.header),V;!(V=W()).done;){var ee=V.value;ke=ke.concat(ue.walkTokens(ee.tokens,Se))}for(var fe=N($.rows),Ie;!(Ie=fe()).done;)for(var le=Ie.value,ve=N(le),Ee;!(Ee=ve()).done;){var We=Ee.value;ke=ke.concat(ue.walkTokens(We.tokens,Se))}break}case"list":{ke=ke.concat(ue.walkTokens($.items,Se));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[$.type]?ue.defaults.extensions.childTokens[$.type].forEach(function(je){ke=ke.concat(ue.walkTokens($[je],Se))}):$.tokens&&(ke=ke.concat(ue.walkTokens($.tokens,Se)))}},ae=N(Ce),J;!(J=ae()).done;)oe();return ke},ue.parseInline=function(Ce,Se){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");Se=r({},ue.defaults,Se||{}),C(Se);try{var ke=B.lexInline(Ce,Se);return Se.walkTokens&&ue.walkTokens(ke,Se.walkTokens),se.parseInline(ke,Se)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(oe.message+"",!0)+"</pre>";throw oe}},ue.Parser=se,ue.parser=se.parse,ue.Renderer=Y,ue.TextRenderer=me,ue.Lexer=B,ue.lexer=B.lex,ue.Tokenizer=_,ue.Slugger=Z,ue.parse=ue;var De=ue.options,de=ue.setOptions,ie=ue.use,q=ue.walkTokens,ce=ue.parseInline,be=ue,Ae=se.parse,Ue=B.lex;te.Lexer=B,te.Parser=se,te.Renderer=Y,te.Slugger=Z,te.TextRenderer=me,te.Tokenizer=_,te.getDefaults=E,te.lexer=Ue,te.marked=ue,te.options=De,te.parse=be,te.parseInline=ce,te.parser=Ae,te.setOptions=de,te.use=ie,te.walkTokens=q,Object.defineProperty(te,"__esModule",{value:!0})}),define(Te[114],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(O,S,P){return Math.min(Math.max(O,S),P)}e.clamp=n;function A(O,S){return(S+O%S)%S}e.rot=A;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class N{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=N;class E{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const P=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=P,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=E}),function(){function te(D){const N=[];typeof D=="number"&&N.push("code/timeOrigin",D);function E(S){N.push(S,Date.now())}function O(){const S=[];for(let P=0;P<N.length;P+=2)S.push({name:N[P],startTime:N[P+1]});return S}return{mark:E,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const E of performance.getEntriesByType("mark"))N.push({name:E.name,startTime:Math.round(D+E.startTime)});return N}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function n(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=n(A))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var A in n)(typeof exports=="object"?exports:te)[A]=n[A]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function n(A){if(e[A])return e[A].exports;var D=e[A]={i:A,l:!1,exports:{}};return te[A].call(D.exports,D,D.exports,n),D.l=!0,D.exports}return n.m=te,n.c=e,n.d=function(A,D,N){n.o(A,D)||Object.defineProperty(A,D,{enumerable:!0,get:N})},n.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},n.t=function(A,D){if(1&D&&(A=n(A)),8&D||4&D&&typeof A=="object"&&A&&A.__esModule)return A;var N=Object.create(null);if(n.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:A}),2&D&&typeof A!="string")for(var E in A)n.d(N,E,function(O){return A[O]}.bind(null,E));return N},n.n=function(A){var D=A&&A.__esModule?function(){return A.default}:function(){return A};return n.d(D,"a",D),D},n.o=function(A,D){return Object.prototype.hasOwnProperty.call(A,D)},n.p="",n(n.s=0)}([function(te,e,n){(function(A){var D;e=te.exports=ie,D=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,E=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],S=e.src=[],P=0,M=P++;S[M]="0|[1-9]\\d*";var T=P++;S[T]="[0-9]+";var m=P++;S[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=P++;S[w]="("+S[M]+")\\.("+S[M]+")\\.("+S[M]+")";var f=P++;S[f]="("+S[T]+")\\.("+S[T]+")\\.("+S[T]+")";var u=P++;S[u]="(?:"+S[M]+"|"+S[m]+")";var t=P++;S[t]="(?:"+S[T]+"|"+S[m]+")";var a=P++;S[a]="(?:-("+S[u]+"(?:\\."+S[u]+")*))";var p=P++;S[p]="(?:-?("+S[t]+"(?:\\."+S[t]+")*))";var b=P++;S[b]="[0-9A-Za-z-]+";var R=P++;S[R]="(?:\\+("+S[b]+"(?:\\."+S[b]+")*))";var v=P++,i="v?"+S[w]+S[a]+"?"+S[R]+"?";S[v]="^"+i+"$";var d="[v=\\s]*"+S[f]+S[p]+"?"+S[R]+"?",s=P++;S[s]="^"+d+"$";var l=P++;S[l]="((?:<|>)?=?)";var o=P++;S[o]=S[T]+"|x|X|\\*";var I=P++;S[I]=S[M]+"|x|X|\\*";var r=P++;S[r]="[v=\\s]*("+S[I]+")(?:\\.("+S[I]+")(?:\\.("+S[I]+")(?:"+S[a]+")?"+S[R]+"?)?)?";var c=P++;S[c]="[v=\\s]*("+S[o]+")(?:\\.("+S[o]+")(?:\\.("+S[o]+")(?:"+S[p]+")?"+S[R]+"?)?)?";var h=P++;S[h]="^"+S[l]+"\\s*"+S[r]+"$";var y=P++;S[y]="^"+S[l]+"\\s*"+S[c]+"$";var C=P++;S[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=P++;S[H]="(?:~>?)";var K=P++;S[K]="(\\s*)"+S[H]+"\\s+",O[K]=new RegExp(S[K],"g");var Q=P++;S[Q]="^"+S[H]+S[r]+"$";var _=P++;S[_]="^"+S[H]+S[c]+"$";var j=P++;S[j]="(?:\\^)";var L=P++;S[L]="(\\s*)"+S[j]+"\\s+",O[L]=new RegExp(S[L],"g");var g=P++;S[g]="^"+S[j]+S[r]+"$";var F=P++;S[F]="^"+S[j]+S[c]+"$";var B=P++;S[B]="^"+S[l]+"\\s*("+d+")$|^$";var Y=P++;S[Y]="^"+S[l]+"\\s*("+i+")$|^$";var me=P++;S[me]="(\\s*)"+S[l]+"\\s*("+d+"|"+S[r]+")",O[me]=new RegExp(S[me],"g");var Z=P++;S[Z]="^\\s*("+S[r]+")\\s+-\\s+("+S[r]+")\\s*$";var se=P++;S[se]="^\\s*("+S[c]+")\\s+-\\s+("+S[c]+")\\s*$";var ue=P++;S[ue]="(<|>)?=?\\s*\\*";for(var De=0;De<35;De++)D(De,S[De]),O[De]||(O[De]=new RegExp(S[De]));function de(le,ve){if(le instanceof ie)return le;if(typeof le!="string"||le.length>N||!(ve?O[s]:O[v]).test(le))return null;try{return new ie(le,ve)}catch{return null}}function ie(le,ve){if(le instanceof ie){if(le.loose===ve)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof ie))return new ie(le,ve);D("SemVer",le,ve),this.loose=ve;var Ee=le.trim().match(ve?O[s]:O[v]);if(!Ee)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>E||this.major<0)throw new TypeError("Invalid major version");if(this.minor>E||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>E||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var je=+We;if(je>=0&&je<E)return je}return We}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=de,e.valid=function(le,ve){var Ee=de(le,ve);return Ee?Ee.version:null},e.clean=function(le,ve){var Ee=de(le.trim().replace(/^[=v]+/,""),ve);return Ee?Ee.version:null},e.SemVer=ie,ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ie.prototype.toString=function(){return this.version},ie.prototype.compare=function(le){return D("SemVer.compare",this.version,this.loose,le),le instanceof ie||(le=new ie(le,this.loose)),this.compareMain(le)||this.comparePre(le)},ie.prototype.compareMain=function(le){return le instanceof ie||(le=new ie(le,this.loose)),ce(this.major,le.major)||ce(this.minor,le.minor)||ce(this.patch,le.patch)},ie.prototype.comparePre=function(le){if(le instanceof ie||(le=new ie(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var ve=0;do{var Ee=this.prerelease[ve],We=le.prerelease[ve];if(D("prerelease compare",ve,Ee,We),Ee===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==We)return ce(Ee,We)}while(++ve)},ie.prototype.inc=function(le,ve){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,ve,Ee,We){typeof Ee=="string"&&(We=Ee,Ee=void 0);try{return new ie(le,Ee).inc(ve,We).version}catch{return null}},e.diff=function(le,ve){if(Ce(le,ve))return null;var Ee=de(le),We=de(ve);if(Ee.prerelease.length||We.prerelease.length){for(var je in Ee)if((je==="major"||je==="minor"||je==="patch")&&Ee[je]!==We[je])return"pre"+je;return"prerelease"}for(var je in Ee)if((je==="major"||je==="minor"||je==="patch")&&Ee[je]!==We[je])return je},e.compareIdentifiers=ce;var q=/^[0-9]+$/;function ce(le,ve){var Ee=q.test(le),We=q.test(ve);return Ee&&We&&(le=+le,ve=+ve),Ee&&!We?-1:We&&!Ee?1:le<ve?-1:le>ve?1:0}function be(le,ve,Ee){return new ie(le,Ee).compare(new ie(ve,Ee))}function Ae(le,ve,Ee){return be(le,ve,Ee)>0}function Ue(le,ve,Ee){return be(le,ve,Ee)<0}function Ce(le,ve,Ee){return be(le,ve,Ee)===0}function Se(le,ve,Ee){return be(le,ve,Ee)!==0}function ke(le,ve,Ee){return be(le,ve,Ee)>=0}function oe(le,ve,Ee){return be(le,ve,Ee)<=0}function ae(le,ve,Ee,We){var je;switch(ve){case"===":typeof le=="object"&&(le=le.version),typeof Ee=="object"&&(Ee=Ee.version),je=le===Ee;break;case"!==":typeof le=="object"&&(le=le.version),typeof Ee=="object"&&(Ee=Ee.version),je=le!==Ee;break;case"":case"=":case"==":je=Ce(le,Ee,We);break;case"!=":je=Se(le,Ee,We);break;case">":je=Ae(le,Ee,We);break;case">=":je=ke(le,Ee,We);break;case"<":je=Ue(le,Ee,We);break;case"<=":je=oe(le,Ee,We);break;default:throw new TypeError("Invalid operator: "+ve)}return je}function J(le,ve){if(le instanceof J){if(le.loose===ve)return le;le=le.value}if(!(this instanceof J))return new J(le,ve);D("comparator",le,ve),this.loose=ve,this.parse(le),this.semver===k?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(le,ve){return ce(ve,le)},e.major=function(le,ve){return new ie(le,ve).major},e.minor=function(le,ve){return new ie(le,ve).minor},e.patch=function(le,ve){return new ie(le,ve).patch},e.compare=be,e.compareLoose=function(le,ve){return be(le,ve,!0)},e.rcompare=function(le,ve,Ee){return be(ve,le,Ee)},e.sort=function(le,ve){return le.sort(function(Ee,We){return e.compare(Ee,We,ve)})},e.rsort=function(le,ve){return le.sort(function(Ee,We){return e.rcompare(Ee,We,ve)})},e.gt=Ae,e.lt=Ue,e.eq=Ce,e.neq=Se,e.gte=ke,e.lte=oe,e.cmp=ae,e.Comparator=J;var k={};function $(le,ve){if(le instanceof $)return le.loose===ve?le:new $(le.raw,ve);if(le instanceof J)return new $(le.value,ve);if(!(this instanceof $))return new $(le,ve);if(this.loose=ve,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function W(le){return!le||le.toLowerCase()==="x"||le==="*"}function V(le,ve,Ee,We,je,it,Ge,tt,nt,Ne,rt,G,X){return((ve=W(Ee)?"":W(We)?">="+Ee+".0.0":W(je)?">="+Ee+"."+We+".0":">="+ve)+" "+(tt=W(nt)?"":W(Ne)?"<"+(+nt+1)+".0.0":W(rt)?"<"+nt+"."+(+Ne+1)+".0":G?"<="+nt+"."+Ne+"."+rt+"-"+G:"<="+tt)).trim()}function ee(le,ve){for(var Ee=0;Ee<le.length;Ee++)if(!le[Ee].test(ve))return!1;if(ve.prerelease.length){for(Ee=0;Ee<le.length;Ee++)if(D(le[Ee].semver),le[Ee].semver!==k&&le[Ee].semver.prerelease.length>0){var We=le[Ee].semver;if(We.major===ve.major&&We.minor===ve.minor&&We.patch===ve.patch)return!0}return!1}return!0}function fe(le,ve,Ee){try{ve=new $(ve,Ee)}catch{return!1}return ve.test(le)}function Ie(le,ve,Ee,We){var je,it,Ge,tt,nt;switch(le=new ie(le,We),ve=new $(ve,We),Ee){case">":je=Ae,it=oe,Ge=Ue,tt=">",nt=">=";break;case"<":je=Ue,it=ke,Ge=Ae,tt="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(fe(le,ve,We))return!1;for(var Ne=0;Ne<ve.set.length;++Ne){var rt=ve.set[Ne],G=null,X=null;if(rt.forEach(function(pe){pe.semver===k&&(pe=new J(">=0.0.0")),G=G||pe,X=X||pe,je(pe.semver,G.semver,We)?G=pe:Ge(pe.semver,X.semver,We)&&(X=pe)}),G.operator===tt||G.operator===nt||(!X.operator||X.operator===tt)&&it(le,X.semver)||X.operator===nt&&Ge(le,X.semver))return!1}return!0}J.prototype.parse=function(le){var ve=this.loose?O[B]:O[Y],Ee=le.match(ve);if(!Ee)throw new TypeError("Invalid comparator: "+le);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new ie(Ee[2],this.loose):this.semver=k},J.prototype.toString=function(){return this.value},J.prototype.test=function(le){return D("Comparator.test",le,this.loose),this.semver===k||(typeof le=="string"&&(le=new ie(le,this.loose)),ae(le,this.operator,this.semver,this.loose))},J.prototype.intersects=function(le,ve){if(!(le instanceof J))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new $(le.value,ve),fe(this.value,Ee,ve);if(le.operator==="")return Ee=new $(this.value,ve),fe(le.semver,Ee,ve);var We=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),it=this.semver.version===le.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),tt=ae(this.semver,"<",le.semver,ve)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),nt=ae(this.semver,">",le.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return We||je||it&&Ge||tt||nt},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(le){var ve=this.loose;le=le.trim(),D("range",le,ve);var Ee=ve?O[se]:O[Z];le=le.replace(Ee,V),D("hyphen replace",le),le=le.replace(O[me],"$1$2$3"),D("comparator trim",le,O[me]),le=(le=(le=le.replace(O[K],"$1~")).replace(O[L],"$1^")).split(/\s+/).join(" ");var We=ve?O[B]:O[Y],je=le.split(" ").map(function(it){return function(Ge,tt){return D("comp",Ge),Ge=function(nt,Ne){return nt.trim().split(/\s+/).map(function(rt){return function(G,X){D("caret",G,X);var pe=X?O[F]:O[g];return G.replace(pe,function(ze,Be,Qe,_e,Xe){var at;return D("caret",G,ze,Be,Qe,_e,Xe),W(Be)?at="":W(Qe)?at=">="+Be+".0.0 <"+(+Be+1)+".0.0":W(_e)?at=Be==="0"?">="+Be+"."+Qe+".0 <"+Be+"."+(+Qe+1)+".0":">="+Be+"."+Qe+".0 <"+(+Be+1)+".0.0":Xe?(D("replaceCaret pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),at=Be==="0"?Qe==="0"?">="+Be+"."+Qe+"."+_e+Xe+" <"+Be+"."+Qe+"."+(+_e+1):">="+Be+"."+Qe+"."+_e+Xe+" <"+Be+"."+(+Qe+1)+".0":">="+Be+"."+Qe+"."+_e+Xe+" <"+(+Be+1)+".0.0"):(D("no pr"),at=Be==="0"?Qe==="0"?">="+Be+"."+Qe+"."+_e+" <"+Be+"."+Qe+"."+(+_e+1):">="+Be+"."+Qe+"."+_e+" <"+Be+"."+(+Qe+1)+".0":">="+Be+"."+Qe+"."+_e+" <"+(+Be+1)+".0.0"),D("caret return",at),at})}(rt,Ne)}).join(" ")}(Ge,tt),D("caret",Ge),Ge=function(nt,Ne){return nt.trim().split(/\s+/).map(function(rt){return function(G,X){var pe=X?O[_]:O[Q];return G.replace(pe,function(ze,Be,Qe,_e,Xe){var at;return D("tilde",G,ze,Be,Qe,_e,Xe),W(Be)?at="":W(Qe)?at=">="+Be+".0.0 <"+(+Be+1)+".0.0":W(_e)?at=">="+Be+"."+Qe+".0 <"+Be+"."+(+Qe+1)+".0":Xe?(D("replaceTilde pr",Xe),Xe.charAt(0)!=="-"&&(Xe="-"+Xe),at=">="+Be+"."+Qe+"."+_e+Xe+" <"+Be+"."+(+Qe+1)+".0"):at=">="+Be+"."+Qe+"."+_e+" <"+Be+"."+(+Qe+1)+".0",D("tilde return",at),at})}(rt,Ne)}).join(" ")}(Ge,tt),D("tildes",Ge),Ge=function(nt,Ne){return D("replaceXRanges",nt,Ne),nt.split(/\s+/).map(function(rt){return function(G,X){G=G.trim();var pe=X?O[y]:O[h];return G.replace(pe,function(ze,Be,Qe,_e,Xe,at){D("xRange",G,ze,Be,Qe,_e,Xe,at);var bt=W(Qe),kt=bt||W(_e),Dt=kt||W(Xe);return Be==="="&&Dt&&(Be=""),bt?ze=Be===">"||Be==="<"?"<0.0.0":"*":Be&&Dt?(kt&&(_e=0),Dt&&(Xe=0),Be===">"?(Be=">=",kt?(Qe=+Qe+1,_e=0,Xe=0):Dt&&(_e=+_e+1,Xe=0)):Be==="<="&&(Be="<",kt?Qe=+Qe+1:_e=+_e+1),ze=Be+Qe+"."+_e+"."+Xe):kt?ze=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":Dt&&(ze=">="+Qe+"."+_e+".0 <"+Qe+"."+(+_e+1)+".0"),D("xRange return",ze),ze})}(rt,Ne)}).join(" ")}(Ge,tt),D("xrange",Ge),Ge=function(nt,Ne){return D("replaceStars",nt,Ne),nt.trim().replace(O[ue],"")}(Ge,tt),D("stars",Ge),Ge}(it,ve)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(it){return!!it.match(We)})),je=je.map(function(it){return new J(it,ve)})},$.prototype.intersects=function(le,ve){if(!(le instanceof $))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(We){return le.set.some(function(je){return je.every(function(it){return We.intersects(it,ve)})})})})},e.toComparators=function(le,ve){return new $(le,ve).set.map(function(Ee){return Ee.map(function(We){return We.value}).join(" ").trim().split(" ")})},$.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new ie(le,this.loose));for(var ve=0;ve<this.set.length;ve++)if(ee(this.set[ve],le))return!0;return!1},e.satisfies=fe,e.maxSatisfying=function(le,ve,Ee){var We=null,je=null;try{var it=new $(ve,Ee)}catch{return null}return le.forEach(function(Ge){it.test(Ge)&&(We&&je.compare(Ge)!==-1||(je=new ie(We=Ge,Ee)))}),We},e.minSatisfying=function(le,ve,Ee){var We=null,je=null;try{var it=new $(ve,Ee)}catch{return null}return le.forEach(function(Ge){it.test(Ge)&&(We&&je.compare(Ge)!==1||(je=new ie(We=Ge,Ee)))}),We},e.validRange=function(le,ve){try{return new $(le,ve).range||"*"}catch{return null}},e.ltr=function(le,ve,Ee){return Ie(le,ve,"<",Ee)},e.gtr=function(le,ve,Ee){return Ie(le,ve,">",Ee)},e.outside=Ie,e.prerelease=function(le,ve){var Ee=de(le,ve);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(le,ve,Ee){return le=new $(le,Ee),ve=new $(ve,Ee),le.intersects(ve)},e.coerce=function(le){if(le instanceof ie)return le;if(typeof le!="string")return null;var ve=le.match(O[C]);return ve==null?null:de((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,n(1))},function(te,e){var n,A,D=te.exports={};function N(){throw new Error("setTimeout has not been defined")}function E(){throw new Error("clearTimeout has not been defined")}function O(t){if(n===setTimeout)return setTimeout(t,0);if((n===N||!n)&&setTimeout)return n=setTimeout,setTimeout(t,0);try{return n(t,0)}catch{try{return n.call(null,t,0)}catch{return n.call(this,t,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:N}catch{n=N}try{A=typeof clearTimeout=="function"?clearTimeout:E}catch{A=E}})();var S,P=[],M=!1,T=-1;function m(){M&&S&&(M=!1,S.length?P=S.concat(P):T=-1,P.length&&w())}function w(){if(!M){var t=O(m);M=!0;for(var a=P.length;a;){for(S=P,P=[];++T<a;)S&&S[T].run();T=-1,a=P.length}S=null,M=!1,function(p){if(A===clearTimeout)return clearTimeout(p);if((A===E||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(p);try{A(p)}catch{try{return A.call(null,p)}catch{return A.call(this,p)}}}(t)}}function f(t,a){this.fun=t,this.array=a}function u(){}D.nextTick=function(t){var a=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)a[p-1]=arguments[p];P.push(new f(t,a)),P.length!==1||M||O(w)},f.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=u,D.addListener=u,D.once=u,D.off=u,D.removeListener=u,D.removeAllListeners=u,D.emit=u,D.prependListener=u,D.prependOnceListener=u,D.listeners=function(t){return[]},D.binding=function(t){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(t){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Te[115],Pe([1,0,11,6]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(R){const v=R;return v?typeof v.read=="function":!1}e.isReadable=D;function N(R){const v=R;return v?[v.on,v.pause,v.resume,v.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=N;function E(R){const v=R;return v?N(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=E;function O(R,v){return new S(R,v)}e.newWriteableStream=O;class S{constructor(v,i){this.e=v,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(i=>i(v))}h(v){this.c.error.length===0?(0,n.onUnexpectedError)(v):this.c.error.slice(0).forEach(i=>i(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,i){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(v,i){if(this.a.destroyed)return;let d;switch(v){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const s=d.indexOf(i);s>=0&&d.splice(s,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function P(R,v){const i=[];let d;for(;(d=R.read())!==null;)i.push(d);return v(i)}e.consumeReadable=P;function M(R,v,i){const d=[];let s;for(;(s=R.read())!==null&&d.length<i;)d.push(s);return s===null&&d.length>0?v(d):{read:()=>{if(d.length>0)return d.shift();if(typeof s<"u"){const l=s;return s=void 0,l}return R.read()}}}e.peekReadable=M;function T(R,v){return new Promise((i,d)=>{const s=[];m(R,{onData:l=>{v&&s.push(l)},onError:l=>{v?d(l):i(void 0)},onEnd:()=>{i(v?v(s):void 0)}})})}e.consumeStream=T;function m(R,v){let i=!1;return R.on("error",d=>{i||v.onError(d)}),R.on("end",()=>{i||v.onEnd()}),R.on("data",d=>{i||v.onData(d)}),(0,A.toDisposable)(()=>i=!0)}e.listenStream=m;function w(R,v){return new Promise((i,d)=>{const s=new A.DisposableStore,l=[],o=c=>{if(l.push(c),l.length>v)return s.dispose(),R.pause(),i({stream:R,buffer:l,ended:!1})},I=c=>d(c),r=()=>i({stream:R,buffer:l,ended:!0});s.add((0,A.toDisposable)(()=>R.removeListener("error",I))),R.on("error",I),s.add((0,A.toDisposable)(()=>R.removeListener("end",r))),R.on("end",r),s.add((0,A.toDisposable)(()=>R.removeListener("data",o))),R.on("data",o)})}e.peekStream=w;function f(R,v){const i=O(v);return i.end(R),i}e.toStream=f;function u(){const R=O(()=>{throw new Error("not supported")});return R.end(),R}e.emptyStream=u;function t(R){let v=!1;return{read:()=>v?null:(v=!0,R)}}e.toReadable=t;function a(R,v,i){const d=O(i);return m(R,{onData:s=>d.write(v.data(s)),onError:s=>d.error(v.error?v.error(s):s),onEnd:()=>d.end()}),d}e.transform=a;function p(R,v,i){let d=!1;return{read:()=>{const s=v.read();return d?s:(d=!0,s!==null?i([R,s]):R)}}}e.prefixedReadable=p;function b(R,v,i){let d=!1;const s=O(i);return m(v,{onData:l=>d?s.write(l):(d=!0,s.write(i([R,l]))),onError:l=>s.error(l),onEnd:()=>{d||(d=!0,s.write(R)),s.end()}}),s}e.prefixedStream=b}),define(Te[25],Pe([1,0,115]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let D,N;class E{static alloc(c){return A?new E(Buffer.allocUnsafe(c)):new E(new Uint8Array(c))}static wrap(c){return A&&!Buffer.isBuffer(c)&&(c=Buffer.from(c.buffer,c.byteOffset,c.byteLength)),new E(c)}static fromString(c,h){return!(h?.dontUseNodeBuffer||!1)&&A?new E(Buffer.from(c)):(D||(D=new TextEncoder),new E(D.encode(c)))}static fromByteArray(c){const h=E.alloc(c.length);for(let y=0,C=c.length;y<C;y++)h.buffer[y]=c[y];return h}static concat(c,h){if(typeof h>"u"){h=0;for(let H=0,K=c.length;H<K;H++)h+=c[H].byteLength}const y=E.alloc(h);let C=0;for(let H=0,K=c.length;H<K;H++){const Q=c[H];y.set(Q,C),C+=Q.byteLength}return y}constructor(c){this.buffer=c,this.byteLength=this.buffer.byteLength}clone(){const c=E.alloc(this.byteLength);return c.set(this),c}toString(){return A?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(c,h){return new E(this.buffer.subarray(c,h))}set(c,h){if(c instanceof E)this.buffer.set(c.buffer,h);else if(c instanceof Uint8Array)this.buffer.set(c,h);else if(c instanceof ArrayBuffer)this.buffer.set(new Uint8Array(c),h);else if(ArrayBuffer.isView(c))this.buffer.set(new Uint8Array(c.buffer,c.byteOffset,c.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(c){return P(this.buffer,c)}writeUInt32BE(c,h){M(this.buffer,c,h)}readUInt32LE(c){return T(this.buffer,c)}writeUInt32LE(c,h){m(this.buffer,c,h)}readUInt8(c){return w(this.buffer,c)}writeUInt8(c,h){f(this.buffer,c,h)}}e.VSBuffer=E;function O(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0}e.readUInt16LE=O;function S(r,c,h){r[h+0]=c&255,c=c>>>8,r[h+1]=c&255}e.writeUInt16LE=S;function P(r,c){return r[c]*2**24+r[c+1]*2**16+r[c+2]*2**8+r[c+3]}e.readUInt32BE=P;function M(r,c,h){r[h+3]=c,c=c>>>8,r[h+2]=c,c=c>>>8,r[h+1]=c,c=c>>>8,r[h]=c}e.writeUInt32BE=M;function T(r,c){return r[c+0]<<0>>>0|r[c+1]<<8>>>0|r[c+2]<<16>>>0|r[c+3]<<24>>>0}e.readUInt32LE=T;function m(r,c,h){r[h+0]=c&255,c=c>>>8,r[h+1]=c&255,c=c>>>8,r[h+2]=c&255,c=c>>>8,r[h+3]=c&255}e.writeUInt32LE=m;function w(r,c){return r[c]}e.readUInt8=w;function f(r,c,h){r[h]=c}e.writeUInt8=f;function u(r){return n.consumeReadable(r,c=>E.concat(c))}e.readableToBuffer=u;function t(r){return n.toReadable(r)}e.bufferToReadable=t;function a(r){return n.consumeStream(r,c=>E.concat(c))}e.streamToBuffer=a;async function p(r){return r.ended?E.concat(r.buffer):E.concat([...r.buffer,await a(r.stream)])}e.bufferedStreamToBuffer=p;function b(r){return n.toStream(r,c=>E.concat(c))}e.bufferToStream=b;function R(r){return n.transform(r,{data:c=>typeof c=="string"?E.fromString(c):E.wrap(c)},c=>E.concat(c))}e.streamToBufferReadableStream=R;function v(r){return n.newWriteableStream(c=>E.concat(c),r)}e.newWriteableBufferStream=v;function i(r,c){return n.prefixedReadable(r,c,h=>E.concat(h))}e.prefixedBufferReadable=i;function d(r,c){return n.prefixedStream(r,c,h=>E.concat(h))}e.prefixedBufferStream=d;function s(r){let c=0,h=0,y=0;const C=new Uint8Array(Math.floor(r.length/4*3)),H=Q=>{switch(h){case 3:C[y++]=c|Q,h=0;break;case 2:C[y++]=c|Q>>>2,c=Q<<6,h=3;break;case 1:C[y++]=c|Q>>>4,c=Q<<4,h=2;break;default:c=Q<<2,h=1}};for(let Q=0;Q<r.length;Q++){const _=r.charCodeAt(Q);if(_>=65&&_<=90)H(_-65);else if(_>=97&&_<=122)H(_-97+26);else if(_>=48&&_<=57)H(_-48+52);else if(_===43||_===45)H(62);else if(_===47||_===95)H(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${r[Q]}`)}}const K=y;for(;h>0;)H(0);return E.wrap(C).slice(0,K)}e.decodeBase64=s;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:r},c=!0,h=!1){const y=h?o:l;let C="";const H=r.byteLength%3;let K=0;for(;K<r.byteLength-H;K+=3){const Q=r[K+0],_=r[K+1],j=r[K+2];C+=y[Q>>>2],C+=y[(Q<<4|_>>>4)&63],C+=y[(_<<2|j>>>6)&63],C+=y[j&63]}if(H===1){const Q=r[K+0];C+=y[Q>>>2],C+=y[Q<<4&63],c&&(C+="==")}else if(H===2){const Q=r[K+0],_=r[K+1];C+=y[Q>>>2],C+=y[(Q<<4|_>>>4)&63],C+=y[_<<2&63],c&&(C+="=")}return C}e.encodeBase64=I}),define(Te[116],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Te[39],Pe([1,0,84]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(E){function O(S){return S&&typeof S=="object"&&typeof S.id=="string"}E.isThemeColor=O})(A=e.ThemeColor||(e.ThemeColor={}));function D(E){return{id:E}}e.themeColorFromId=D;var N;(function(E){E.iconNameSegment="[A-Za-z0-9]+",E.iconNameExpression="[A-Za-z0-9-]+",E.iconModifierExpression="~[A-Za-z]+",E.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${E.iconNameExpression})(${E.iconModifierExpression})?$`);function S(p){const b=O.exec(p.id);if(!b)return S(n.Codicon.error);const[,R,v]=b,i=["codicon","codicon-"+R];return v&&i.push("codicon-modifier-"+v.substring(1)),i}E.asClassNameArray=S;function P(p){return S(p).join(" ")}E.asClassName=P;function M(p){return"."+S(p).join(".")}E.asCSSSelector=M;function T(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||A.isThemeColor(p.color))}E.isThemeIcon=T;const m=new RegExp(`^\\$\\((${E.iconNameExpression}(?:${E.iconModifierExpression})?)\\)$`);function w(p){const b=m.exec(p);if(!b)return;const[,R]=b;return{id:R}}E.fromString=w;function f(p){return{id:p}}E.fromId=f;function u(p,b){let R=p.id;const v=R.lastIndexOf("~");return v!==-1&&(R=R.substring(0,v)),b&&(R=`${R}~${b}`),{id:R}}E.modify=u;function t(p){const b=p.id.lastIndexOf("~");if(b!==-1)return p.id.substring(b+1)}E.getModifier=t;function a(p,b){return p.id===b.id&&p.color?.id===b.color?.id}E.isEqual=a})(N=e.ThemeIcon||(e.ThemeIcon={}))}),define(Te[34],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(D){return n.test(D)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(O){for(let S=0;S<O.length;S++)O[S]=Math.floor(Math.random()*256);return O};const N=new Uint8Array(16),E=[];for(let O=0;O<256;O++)E.push(O.toString(16).padStart(2,"0"));return function(){D(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let S=0,P="";return P+=E[N[S++]],P+=E[N[S++]],P+=E[N[S++]],P+=E[N[S++]],P+="-",P+=E[N[S++]],P+=E[N[S++]],P+="-",P+=E[N[S++]],P+=E[N[S++]],P+="-",P+=E[N[S++]],P+=E[N[S++]],P+="-",P+=E[N[S++]],P+=E[N[S++]],P+=E[N[S++]],P+=E[N[S++]],P+=E[N[S++]],P+=E[N[S++]],P}}()}),define(Te[117],Pe([1,0,16,34]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function D(O){return{id:(0,A.generateUuid)(),asString:async()=>O,asFile:()=>{},value:typeof O=="string"?O:void 0}}e.createStringDataTransferItem=D;function N(O,S,P){return{id:(0,A.generateUuid)(),asString:async()=>"",asFile:()=>({name:O,uri:S,data:P}),value:void 0}}e.createFileDataTransferItem=N;class E{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,P){const M=this.a.get(S);M?M.push(P):this.a.set(this.b(S),[P])}replace(S,P){this.a.set(this.b(S),[P])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,P]of this.a.entries())for(const M of P)yield[S,M]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[P,M]of this.entries())S(M,P)}b(S){return S.toLowerCase()}}e.VSDataTransfer=E,e.UriList=Object.freeze({create:O=>(0,n.distinct)(O.map(S=>S.toString())).join(`\r
`),split:O=>O.split(`\r
`),parse:O=>e.UriList.split(O).filter(S=>!S.startsWith("#"))})}),define(Te[118],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Te[119],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(E){E[E.None=0]="None",E[E.Indent=1]="Indent",E[E.IndentOutdent=2]="IndentOutdent",E[E.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class A{constructor(O){if(this.e=null,this.f=!1,this.open=O.open,this.close=O.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(O.notIn))for(let S=0,P=O.notIn.length;S<P;S++)switch(O.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(O){switch(O){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(O,S){if(O.getTokenCount()===0)return!0;const P=O.findTokenIndexAtOffset(S-2),M=O.getStandardTokenType(P);return this.isOK(M)}g(O,S){for(let P=O;P<=S;P++){const M=String.fromCharCode(P);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=A;class D{constructor(O){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of O)N(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),N(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),N(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),N(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&N(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=D;function N(E,O,S){E.has(O)?E.get(O).push(S):E.set(O,[S])}}),define(Te[120],Pe([13,14]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Te[121],Pe([13,14]),function(te,e){return te.create("vs/base/common/date",e)}),define(Te[122],Pe([1,0,121]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,D=A*60,N=D*24,E=N*7,O=N*30,S=N*365;function P(T,m,w,f){typeof T!="number"&&(T=T.getTime());const u=Math.round((new Date().getTime()-T)/1e3);if(u<-30)return(0,n.localize)(0,null,P(new Date().getTime()+u*1e3,!1));if(!f&&u<30)return(0,n.localize)(1,null);let t;return u<A?(t=u,m?t===1?w?(0,n.localize)(2,null,t):(0,n.localize)(3,null,t):w?(0,n.localize)(4,null,t):(0,n.localize)(5,null,t):t===1?w?(0,n.localize)(6,null,t):(0,n.localize)(7,null,t):w?(0,n.localize)(8,null,t):(0,n.localize)(9,null,t)):u<D?(t=Math.floor(u/A),m?t===1?w?(0,n.localize)(10,null,t):(0,n.localize)(11,null,t):w?(0,n.localize)(12,null,t):(0,n.localize)(13,null,t):t===1?w?(0,n.localize)(14,null,t):(0,n.localize)(15,null,t):w?(0,n.localize)(16,null,t):(0,n.localize)(17,null,t)):u<N?(t=Math.floor(u/D),m?t===1?w?(0,n.localize)(18,null,t):(0,n.localize)(19,null,t):w?(0,n.localize)(20,null,t):(0,n.localize)(21,null,t):t===1?w?(0,n.localize)(22,null,t):(0,n.localize)(23,null,t):w?(0,n.localize)(24,null,t):(0,n.localize)(25,null,t)):u<E?(t=Math.floor(u/N),m?t===1?(0,n.localize)(26,null,t):(0,n.localize)(27,null,t):t===1?(0,n.localize)(28,null,t):(0,n.localize)(29,null,t)):u<O?(t=Math.floor(u/E),m?t===1?w?(0,n.localize)(30,null,t):(0,n.localize)(31,null,t):w?(0,n.localize)(32,null,t):(0,n.localize)(33,null,t):t===1?w?(0,n.localize)(34,null,t):(0,n.localize)(35,null,t):w?(0,n.localize)(36,null,t):(0,n.localize)(37,null,t)):u<S?(t=Math.floor(u/O),m?t===1?w?(0,n.localize)(38,null,t):(0,n.localize)(39,null,t):w?(0,n.localize)(40,null,t):(0,n.localize)(41,null,t):t===1?w?(0,n.localize)(42,null,t):(0,n.localize)(43,null,t):w?(0,n.localize)(44,null,t):(0,n.localize)(45,null,t)):(t=Math.floor(u/S),m?t===1?w?(0,n.localize)(46,null,t):(0,n.localize)(47,null,t):w?(0,n.localize)(48,null,t):(0,n.localize)(49,null,t):t===1?w?(0,n.localize)(50,null,t):(0,n.localize)(51,null,t):w?(0,n.localize)(52,null,t):(0,n.localize)(53,null,t))}e.fromNow=P;function M(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=M}),define(Te[123],Pe([13,14]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Te[40],Pe([1,0,16,9,123]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function N(T,m){return m&&(T.stack||T.stacktrace)?D.localize(0,null,O(T),E(T.stack)||E(T.stacktrace)):O(T)}function E(T){return Array.isArray(T)?T.join(`
`):T}function O(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?D.localize(1,null,T.message):T.message||D.localize(2,null)}function S(T=null,m=!1){if(!T)return D.localize(3,null);if(Array.isArray(T)){const w=n.coalesce(T),f=S(w[0],m);return w.length>1?D.localize(4,null,f,w.length):f}if(A.isString(T))return T;if(T.detail){const w=T.detail;if(w.error)return N(w.error,m);if(w.exception)return N(w.exception,m)}return T.stack?N(T,m):T.message?T.message:D.localize(5,null)}e.toErrorMessage=S;function P(T){const m=T;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=P;function M(T,m){let w;return typeof T=="string"?w=new Error(T):w=T,w.actions=m,w}e.createErrorWithActions=M}),define(Te[124],Pe([1,0,85,19]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new n.Lazy(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),N=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),E=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(c,h,y=!1){const C=c||"",H=h||"",K=D.value.collator.compare(C,H);return D.value.collatorIsNumeric&&K===0&&C!==H?C<H?-1:1:K}e.compareFileNames=O;function S(c,h){const y=N.value.collator;return c=c||"",h=h||"",R(y,c,h)}e.compareFileNamesDefault=S;function P(c,h){const y=N.value.collator;return c=c||"",h=h||"",s(c,h)||R(y,c,h)}e.compareFileNamesUpper=P;function M(c,h){const y=N.value.collator;return c=c||"",h=h||"",d(c,h)||R(y,c,h)}e.compareFileNamesLower=M;function T(c,h){return c=c||"",h=h||"",c===h?0:c<h?-1:1}e.compareFileNamesUnicode=T;function m(c,h){const[y,C]=p(c),[H,K]=p(h);let Q=D.value.collator.compare(C,K);if(Q===0){if(D.value.collatorIsNumeric&&C!==K)return C<K?-1:1;if(Q=D.value.collator.compare(y,H),D.value.collatorIsNumeric&&Q===0&&y!==H)return y<H?-1:1}return Q}e.compareFileExtensions=m;function w(c,h){c=c||"",h=h||"";const y=b(c),C=b(h),H=N.value.collator,K=E.value.collator;return R(K,y,C)||R(H,c,h)}e.compareFileExtensionsDefault=w;function f(c,h){c=c||"",h=h||"";const y=b(c),C=b(h),H=N.value.collator,K=E.value.collator;return R(K,y,C)||s(c,h)||R(H,c,h)}e.compareFileExtensionsUpper=f;function u(c,h){c=c||"",h=h||"";const y=b(c),C=b(h),H=N.value.collator,K=E.value.collator;return R(K,y,C)||d(c,h)||R(H,c,h)}e.compareFileExtensionsLower=u;function t(c,h){c=c||"",h=h||"";const y=b(c).toLowerCase(),C=b(h).toLowerCase();return y!==C?y<C?-1:1:c!==h?c<h?-1:1:0}e.compareFileExtensionsUnicode=t;const a=/^(.*?)(\.([^.]*))?$/;function p(c,h=!1){const y=c?a.exec(c):[];let C=[y&&y[1]||"",y&&y[3]||""];return h&&(!C[0]&&C[1]||C[0]&&C[0].charAt(0)===".")&&(C=[C[0]+"."+C[1],""]),C}function b(c){const h=c?a.exec(c):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function R(c,h,y){const C=c.compare(h,y);return C!==0?C:h.length!==y.length?h.length<y.length?-1:1:0}function v(c){const h=c.charAt(0);return h.toLocaleUpperCase()!==h}function i(c){const h=c.charAt(0);return h.toLocaleLowerCase()!==h}function d(c,h){return v(c)&&i(h)?-1:i(c)&&v(h)?1:0}function s(c,h){return i(c)&&v(h)?-1:v(c)&&i(h)?1:0}function l(c,h,y=!1){return y||(c=c&&c.toLowerCase(),h=h&&h.toLowerCase()),c===h?0:c<h?-1:1}function o(c,h,y=!1){const C=c.split(A.sep),H=h.split(A.sep),K=C.length-1,Q=H.length-1;let _,j;for(let L=0;;L++){if(_=K===L,j=Q===L,_&&j)return O(C[L],H[L],y);if(_)return-1;if(j)return 1;const g=l(C[L],H[L],y);if(g!==0)return g}}e.comparePaths=o;function I(c,h,y){const C=c.toLowerCase(),H=h.toLowerCase(),K=r(c,h,y);if(K)return K;const Q=C.endsWith(y),_=H.endsWith(y);if(Q!==_)return Q?-1:1;const j=O(C,H);return j!==0?j:C.localeCompare(H)}e.compareAnything=I;function r(c,h,y){const C=c.toLowerCase(),H=h.toLowerCase(),K=C.startsWith(y),Q=H.startsWith(y);if(K!==Q)return K?-1:1;if(K&&Q){if(C.length<H.length)return-1;if(C.length>H.length)return 1}return 0}e.compareByPrefix=r}),define(Te[65],Pe([1,0,19]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(M){const T=(0,n.extname)(M),m=A[T.toLowerCase()];return m!==void 0?m:E(M)}e.getMediaOrTextMime=N;function E(M){const T=(0,n.extname)(M);return D[T.toLowerCase()]}e.getMediaMime=E;function O(M){for(const T in D)if(D[T]===M)return T}e.getExtensionForMimeType=O;const S=/^(.+)\/(.+?)(;.+)?$/;function P(M,T){const m=S.exec(M);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:T?void 0:M}e.normalizeMimeType=P}),define(Te[125],Pe([1,0,4,6,120]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class N extends A.Disposable{constructor(m,w="",f="",u=!0,t){super(),this.h=this.B(new n.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=w,this.u=f,this.w=u,this.C=t}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,w){this.C&&await this.C(m)}}e.Action=N;class E extends A.Disposable{constructor(){super(...arguments),this.f=this.B(new n.Emitter),this.onWillRun=this.f.event,this.h=this.B(new n.Emitter),this.onDidRun=this.h.event}async run(m,w){if(!m.enabled)return;this.f.fire({action:m});let f;try{await this.runAction(m,w)}catch(u){f=u}this.h.fire({action:m,error:f})}async runAction(m,w){await m.run(w)}}e.ActionRunner=E;class O{constructor(){this.id=O.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let w=[];for(const f of m)f.length&&(w.length?w=[...w,new O,...f]:w=f);return w}async run(){}}O.ID="vs.actions.separator",e.Separator=O;class S{get actions(){return this.a}constructor(m,w,f,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=w,this.class=u,this.a=f}async run(){}}e.SubmenuAction=S;class P extends N{constructor(){super(P.ID,D.localize(0,null),void 0,!1)}}P.ID="vs.actions.empty",e.EmptySubmenuAction=P;function M(T){return{id:T.id,label:T.label,class:void 0,enabled:T.enabled??!0,checked:T.checked??!1,run:async()=>T.run(),tooltip:T.label}}e.toAction=M}),define(Te[41],Pe([1,0,19,20,10,9]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(o){return o===47||o===92}e.isPathSeparator=E;function O(o){return o.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=O;function S(o){return o.indexOf("/")===-1&&(o=O(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=S;function P(o,I=n.posix.sep){if(!o)return"";const r=o.length,c=o.charCodeAt(0);if(E(c)){if(E(o.charCodeAt(1))&&!E(o.charCodeAt(2))){let y=3;const C=y;for(;y<r&&!E(o.charCodeAt(y));y++);if(C!==y&&!E(o.charCodeAt(y+1))){for(y+=1;y<r;y++)if(E(o.charCodeAt(y)))return o.slice(0,y+1).replace(/[\\/]/g,I)}}return I}else if(a(c)&&o.charCodeAt(1)===58)return E(o.charCodeAt(2))?o.slice(0,2)+I:o.slice(0,2);let h=o.indexOf("://");if(h!==-1){for(h+=3;h<r;h++)if(E(o.charCodeAt(h)))return o.slice(0,h+1)}return""}e.getRoot=P;function M(o){if(!A.isWindows||!o||o.length<5)return!1;let I=o.charCodeAt(0);if(I!==92||(I=o.charCodeAt(1),I!==92))return!1;let r=2;const c=r;for(;r<o.length&&(I=o.charCodeAt(r),I!==92);r++);return!(c===r||(I=o.charCodeAt(r+1),isNaN(I)||I===92))}e.isUNC=M;const T=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(o,I=A.isWindows){const r=I?T:m;return!(!o||o.length===0||/^\s+$/.test(o)||(r.lastIndex=0,r.test(o))||I&&w.test(o)||o==="."||o===".."||I&&o[o.length-1]==="."||I&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=f;function u(o,I,r){const c=o===I;return!r||c?c:!o||!I?!1:(0,D.equalsIgnoreCase)(o,I)}e.isEqual=u;function t(o,I,r,c=n.sep){if(o===I)return!0;if(!o||!I||I.length>o.length)return!1;if(r){if(!(0,D.startsWithIgnoreCase)(o,I))return!1;if(I.length===o.length)return!0;let y=I.length;return I.charAt(I.length-1)===c&&y--,o.charAt(y)===c}return I.charAt(I.length-1)!==c&&(I+=c),o.indexOf(I)===0}e.isEqualOrParent=t;function a(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=a;function p(o,I){return A.isWindows&&o.endsWith(":")&&(o+=n.sep),(0,n.isAbsolute)(o)||(o=(0,n.join)(I,o)),o=(0,n.normalize)(o),A.isWindows?(o=(0,D.rtrim)(o,n.sep),o.endsWith(":")&&(o+=n.sep)):(o=(0,D.rtrim)(o,n.sep),o||(o=n.sep)),o}e.sanitizeFilePath=p;function b(o){const I=(0,n.normalize)(o);return A.isWindows?o.length>3?!1:R(I)&&(o.length===2||I.charCodeAt(2)===92):I===n.posix.sep}e.isRootOrDriveLetter=b;function R(o,I=A.isWindows){return I?a(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=R;function v(o){return R(o)?o[0]:void 0}e.getDriveLetter=v;function i(o,I,r){return I.length>o.length?-1:o===I?0:(r&&(o=o.toLowerCase(),I=I.toLowerCase()),o.indexOf(I))}e.indexOfPath=i;function d(o){const I=o.split(":");let r,c,h;for(const y of I){const C=Number(y);(0,N.isNumber)(C)?c===void 0?c=C:h===void 0&&(h=C):r=r?[r,y].join(":"):y}if(!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:c!==void 0?c:void 0,column:h!==void 0?h:c!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function l(o,I,r=8){let c="";for(let y=0;y<r;y++)c+=s.charAt(Math.floor(Math.random()*s.length));let h;return I?h=`${I}-${c}`:h=c,o?(0,n.join)(o,h):h}e.randomPath=l}),define(Te[126],Pe([1,0,28,10]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...J){return function(k,$){for(let W=0,V=J.length;W<V;W++){const ee=J[W](k,$);if(ee)return ee}return null}}e.or=D,e.matchesStrictPrefix=N.bind(void 0,!1),e.matchesPrefix=N.bind(void 0,!0);function N(J,k,$){if(!$||$.length<k.length)return null;let W;return J?W=A.startsWithIgnoreCase($,k):W=$.indexOf(k)===0,W?k.length>0?[{start:0,end:k.length}]:[]:null}function E(J,k){const $=k.toLowerCase().indexOf(J.toLowerCase());return $===-1?null:[{start:$,end:$+J.length}]}e.matchesContiguousSubString=E;function O(J,k){return S(J.toLowerCase(),k.toLowerCase(),0,0)}e.matchesSubString=O;function S(J,k,$,W){if($===J.length)return[];if(W===k.length)return null;if(J[$]===k[W]){let V=null;return(V=S(J,k,$+1,W+1))?a({start:W,end:W+1},V):null}return S(J,k,$,W+1)}function P(J){return 97<=J&&J<=122}function M(J){return 65<=J&&J<=90}e.isUpper=M;function T(J){return 48<=J&&J<=57}function m(J){return J===32||J===9||J===10||J===13}const w=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>w.add(J.charCodeAt(0)));function f(J){return m(J)||w.has(J)}function u(J,k){return J===k||f(J)&&f(k)}function t(J){return P(J)||M(J)||T(J)}function a(J,k){return k.length===0?k=[J]:J.end===k[0].start?k[0].start=J.start:k.unshift(J),k}function p(J,k){for(let $=k;$<J.length;$++){const W=J.charCodeAt($);if(M(W)||T(W)||$>0&&!t(J.charCodeAt($-1)))return $}return J.length}function b(J,k,$,W){if($===J.length)return[];if(W===k.length)return null;if(J[$]!==k[W].toLowerCase())return null;{let V=null,ee=W+1;for(V=b(J,k,$+1,W+1);!V&&(ee=p(k,ee))<k.length;)V=b(J,k,$+1,ee),ee++;return V===null?null:a({start:W,end:W+1},V)}}function R(J){let k=0,$=0,W=0,V=0,ee=0;for(let Ee=0;Ee<J.length;Ee++)ee=J.charCodeAt(Ee),M(ee)&&k++,P(ee)&&$++,t(ee)&&W++,T(ee)&&V++;const fe=k/J.length,Ie=$/J.length,le=W/J.length,ve=V/J.length;return{upperPercent:fe,lowerPercent:Ie,alphaPercent:le,numericPercent:ve}}function v(J){const{upperPercent:k,lowerPercent:$}=J;return $===0&&k>.6}function i(J){const{upperPercent:k,lowerPercent:$,alphaPercent:W,numericPercent:V}=J;return $>.2&&k<.8&&W>.6&&V<.2}function d(J){let k=0,$=0,W=0,V=0;for(let ee=0;ee<J.length;ee++)W=J.charCodeAt(ee),M(W)&&k++,P(W)&&$++,m(W)&&V++;return(k===0||$===0)&&V===0?J.length<=30:k<=5}function s(J,k){if(!k||(k=k.trim(),k.length===0)||!d(J)||k.length>60)return null;const $=R(k);if(!i($)){if(!v($))return null;k=k.toLowerCase()}let W=null,V=0;for(J=J.toLowerCase();V<k.length&&(W=b(J,k,0,V))===null;)V=p(k,V+1);return W}e.matchesCamelCase=s;function l(J,k,$=!1){if(!k||k.length===0)return null;let W=null,V=0;for(J=J.toLowerCase(),k=k.toLowerCase();V<k.length&&(W=o(J,k,0,V,$))===null;)V=I(k,V+1);return W}e.matchesWords=l;function o(J,k,$,W,V){if($===J.length)return[];if(W===k.length)return null;if(u(J.charCodeAt($),k.charCodeAt(W))){let ee=null,fe=W+1;if(ee=o(J,k,$+1,W+1,V),!V)for(;!ee&&(fe=I(k,fe))<k.length;)ee=o(J,k,$+1,fe,V),fe++;return ee?J.charCodeAt($)!==k.charCodeAt(W)?ee:a({start:W,end:W+1},ee):null}else return null}function I(J,k){for(let $=k;$<J.length;$++)if(f(J.charCodeAt($))||$>0&&f(J.charCodeAt($-1)))return $;return J.length}const r=D(e.matchesPrefix,s,E),c=D(e.matchesPrefix,s,O),h=new n.LRUCache(1e4);function y(J,k,$=!1){if(typeof J!="string"||typeof k!="string")return null;let W=h.get(J);W||(W=new RegExp(A.convertSimple2RegExpPattern(J),"i"),h.set(J,W));const V=W.exec(k);return V?[{start:V.index,end:V.index+V[0].length}]:$?c(J,k):r(J,k)}e.matchesFuzzy=y;function C(J,k){const $=Ae(J,J.toLowerCase(),0,k,k.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?K($):null}e.matchesFuzzy2=C;function H(J,k,$,W,V,ee){const fe=Math.min(13,J.length);for(;$<fe;$++){const Ie=Ae(J,k,$,W,V,ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ie)return Ie}return[0,ee]}e.anyScore=H;function K(J){if(typeof J>"u")return[];const k=[],$=J[1];for(let W=J.length-1;W>1;W--){const V=J[W]+$,ee=k[k.length-1];ee&&ee.end===V?ee.end=V+1:k.push({start:V,end:V+1})}return k}e.createMatches=K;const Q=128;function _(){const J=[],k=[];for(let $=0;$<=Q;$++)k[$]=0;for(let $=0;$<=Q;$++)J.push(k.slice(0));return J}function j(J){const k=[];for(let $=0;$<=J;$++)k[$]=0;return k}const L=j(2*Q),g=j(2*Q),F=_(),B=_(),Y=_(),me=!1;function Z(J,k,$,W,V){function ee(Ie,le,ve=" "){for(;Ie.length<le;)Ie=ve+Ie;return Ie}let fe=` |   |${W.split("").map(Ie=>ee(Ie,3)).join("|")}
`;for(let Ie=0;Ie<=$;Ie++)Ie===0?fe+=" |":fe+=`${k[Ie-1]}|`,fe+=J[Ie].slice(0,V+1).map(le=>ee(le.toString(),3)).join("|")+`
`;return fe}function se(J,k,$,W){J=J.substr(k),$=$.substr(W),console.log(Z(B,J,J.length,$,$.length)),console.log(Z(Y,J,J.length,$,$.length)),console.log(Z(F,J,J.length,$,$.length))}function ue(J,k){if(k<0||k>=J.length)return!1;const $=J.codePointAt(k);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise($)}}function De(J,k){if(k<0||k>=J.length)return!1;switch(J.charCodeAt(k)){case 32:case 9:return!0;default:return!1}}function de(J,k,$){return k[J]!==$[J]}function ie(J,k,$,W,V,ee,fe=!1){for(;k<$&&V<ee;)J[k]===W[V]&&(fe&&(L[k]=V),k+=1),V+=1;return k===$}e.isPatternInWord=ie;var q;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(q||(q={}));var ce;(function(J){J.Default=[-100,0];function k($){return!$||$.length===2&&$[0]===-100&&$[1]===0}J.isDefault=k})(ce=e.FuzzyScore||(e.FuzzyScore={}));class be{constructor(k,$){this.firstMatchCanBeWeak=k,this.boostFullMatch=$}}be.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=be;function Ae(J,k,$,W,V,ee,fe=be.default){const Ie=J.length>Q?Q:J.length,le=W.length>Q?Q:W.length;if($>=Ie||ee>=le||Ie-$>le-ee||!ie(k,$,Ie,V,ee,le,!0))return;Ue(Ie,le,$,ee,k,V);let ve=1,Ee=1,We=$,je=ee;const it=[!1];for(ve=1,We=$;We<Ie;ve++,We++){const rt=L[We],G=g[We],X=We+1<Ie?g[We+1]:le;for(Ee=rt-ee+1,je=rt;je<X;Ee++,je++){let pe=Number.MIN_SAFE_INTEGER,ze=!1;je<=G&&(pe=Ce(J,k,We,$,W,V,je,le,ee,F[ve-1][Ee-1]===0,it));let Be=0;pe!==Number.MAX_SAFE_INTEGER&&(ze=!0,Be=pe+B[ve-1][Ee-1]);const Qe=je>rt,_e=Qe?B[ve][Ee-1]+(F[ve][Ee-1]>0?-5:0):0,Xe=je>rt+1&&F[ve][Ee-1]>0,at=Xe?B[ve][Ee-2]+(F[ve][Ee-2]>0?-5:0):0;if(Xe&&(!Qe||at>=_e)&&(!ze||at>=Be))B[ve][Ee]=at,Y[ve][Ee]=3,F[ve][Ee]=0;else if(Qe&&(!ze||_e>=Be))B[ve][Ee]=_e,Y[ve][Ee]=2,F[ve][Ee]=0;else if(ze)B[ve][Ee]=Be,Y[ve][Ee]=1,F[ve][Ee]=F[ve-1][Ee-1]+1;else throw new Error("not possible")}}if(me&&se(J,$,W,ee),!it[0]&&!fe.firstMatchCanBeWeak)return;ve--,Ee--;const Ge=[B[ve][Ee],ee];let tt=0,nt=0;for(;ve>=1;){let rt=Ee;do{const G=Y[ve][rt];if(G===3)rt=rt-2;else if(G===2)rt=rt-1;else break}while(rt>=1);tt>1&&k[$+ve-1]===V[ee+Ee-1]&&!de(rt+ee-1,W,V)&&tt+1>F[ve][rt]&&(rt=Ee),rt===Ee?tt++:tt=1,nt||(nt=rt),ve--,Ee=rt-1,Ge.push(Ee)}le===Ie&&fe.boostFullMatch&&(Ge[0]+=2);const Ne=nt-Ie;return Ge[0]-=Ne,Ge}e.fuzzyScore=Ae;function Ue(J,k,$,W,V,ee){let fe=J-1,Ie=k-1;for(;fe>=$&&Ie>=W;)V[fe]===ee[Ie]&&(g[fe]=Ie,fe--),Ie--}function Ce(J,k,$,W,V,ee,fe,Ie,le,ve,Ee){if(k[$]!==ee[fe])return Number.MIN_SAFE_INTEGER;let We=1,je=!1;return fe===$-W?We=J[$]===V[fe]?7:5:de(fe,V,ee)&&(fe===0||!de(fe-1,V,ee))?(We=J[$]===V[fe]?7:5,je=!0):ue(ee,fe)&&(fe===0||!ue(ee,fe-1))?We=5:(ue(ee,fe-1)||De(ee,fe-1))&&(We=5,je=!0),We>1&&$===W&&(Ee[0]=!0),je||(je=de(fe,V,ee)||ue(ee,fe-1)||De(ee,fe-1)),$===W?fe>le&&(We-=je?3:5):ve?We+=je?2:0:We+=je?0:1,fe+1===Ie&&(We-=je?3:5),We}function Se(J,k,$,W,V,ee,fe){return oe(J,k,$,W,V,ee,!0,fe)}e.fuzzyScoreGracefulAggressive=Se;function ke(J,k,$,W,V,ee,fe){return oe(J,k,$,W,V,ee,!1,fe)}e.fuzzyScoreGraceful=ke;function oe(J,k,$,W,V,ee,fe,Ie){let le=Ae(J,k,$,W,V,ee,Ie);if(le&&!fe)return le;if(J.length>=3){const ve=Math.min(7,J.length-1);for(let Ee=$+1;Ee<ve;Ee++){const We=ae(J,Ee);if(We){const je=Ae(We,We.toLowerCase(),$,W,V,ee,Ie);je&&(je[0]-=3,(!le||je[0]>le[0])&&(le=je))}}}return le}function ae(J,k){if(k+1>=J.length)return;const $=J[k],W=J[k+1];if($!==W)return J.slice(0,k)+W+$+J.slice(k+2)}}),define(Te[127],Pe([1,0,126,10,39]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const N="$(",E=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(`(\\\\)?${E.source}`,"g");function S(a){return a.replace(O,(p,b)=>b?p:`\\${p}`)}e.escapeIcons=S;const P=new RegExp(`\\\\${E.source}`,"g");function M(a){return a.replace(P,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=M;const T=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function m(a){return a.indexOf(N)===-1?a:a.replace(T,(p,b,R,v)=>R?p:b||v||"")}e.stripIcons=m;function w(a){return a?a.replace(/\$\((.*?)\)/g,(p,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=w;const f=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(a){f.lastIndex=0;let p="";const b=[];let R=0;for(;;){const v=f.lastIndex,i=f.exec(a),d=a.substring(v,i?.index);if(d.length>0){p+=d;for(let s=0;s<d.length;s++)b.push(R)}if(!i)break;R+=i[0].length}return{text:p,iconOffsets:b}}e.parseLabelWithIcons=u;function t(a,p,b=!1){const{text:R,iconOffsets:v}=p;if(!v||v.length===0)return(0,n.matchesFuzzy)(a,R,b);const i=(0,A.ltrim)(R," "),d=R.length-i.length,s=(0,n.matchesFuzzy)(a,i,b);if(s)for(const l of s){const o=v[l.start+d]+d;l.start+=o,l.end+=o}return s}e.matchesFuzzyIconAware=t}),define(Te[29],Pe([1,0,10]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(A||(A={})),function(D){const N="error",E="warning",O="warn",S="info",P="ignore";function M(m){return m?n.equalsIgnoreCase(N,m)?D.Error:n.equalsIgnoreCase(E,m)||n.equalsIgnoreCase(O,m)?D.Warning:n.equalsIgnoreCase(S,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=M;function T(m){switch(m){case D.Error:return N;case D.Warning:return E;case D.Info:return S;default:return P}}D.toString=T}(A||(A={})),e.default=A}),define(Te[48],Pe([1,0,16,10]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const f=w.charCodeAt(0),u=this.b.charCodeAt(this.c);return f-u}value(){return this.b[this.c]}}e.StringIterator=D;class N{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,A.compareSubstring)(w,this.b,0,w.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=N;class E{constructor(w=!0,f=!0){this.f=w,this.g=f}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let f=w.length-1;f>=0;f--,this.c--){const u=this.b.charCodeAt(f);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,A.compareSubstring)(w,this.b,0,w.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=E;var O;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(O||(O={}));class S{constructor(w,f){this.f=w,this.g=f,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new E(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(w,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,A.compare)(w,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class P{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(M||(M={}));class T{static forUris(w=()=>!1,f=()=>!1){return new T(new S(w,f))}static forPaths(w=!1){return new T(new E(void 0,!w))}static forStrings(){return new T(new D)}static forConfigKeys(){return new T(new N)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,f){if(f){const u=f.slice(0);(0,n.shuffle)(u);for(const t of u)this.set(t,w)}else{const u=w.slice(0);(0,n.shuffle)(u);for(const t of u)this.set(t[0],t[1])}}set(w,f){const u=this.b.reset(w);let t;this.c||(this.c=new P,this.c.segment=u.value());const a=[];for(t=this.c;;){const b=u.cmp(t.segment);if(b>0)t.left||(t.left=new P,t.left.segment=u.value()),a.push([-1,t]),t=t.left;else if(b<0)t.right||(t.right=new P,t.right.segment=u.value()),a.push([1,t]),t=t.right;else if(u.hasNext())u.next(),t.mid||(t.mid=new P,t.mid.segment=u.value()),a.push([0,t]),t=t.mid;else break}const p=t.value;t.value=f,t.key=w;for(let b=a.length-1;b>=0;b--){const R=a[b][1];R.updateHeight();const v=R.balanceFactor();if(v<-1||v>1){const i=a[b][0],d=a[b+1][0];if(i===1&&d===1)a[b][1]=R.rotateLeft();else if(i===-1&&d===-1)a[b][1]=R.rotateRight();else if(i===1&&d===-1)R.right=a[b+1][1]=a[b+1][1].rotateRight(),a[b][1]=R.rotateLeft();else if(i===-1&&d===1)R.left=a[b+1][1]=a[b+1][1].rotateLeft(),a[b][1]=R.rotateRight();else throw new Error;if(b>0)switch(a[b-1][0]){case-1:a[b-1][1].left=a[b][1];break;case 1:a[b-1][1].right=a[b][1];break;case 0:a[b-1][1].mid=a[b][1];break}else this.c=a[0][1]}}return p}get(w){return this.d(w)?.value}d(w){const f=this.b.reset(w);let u=this.c;for(;u;){const t=f.cmp(u.segment);if(t>0)u=u.left;else if(t<0)u=u.right;else if(f.hasNext())f.next(),u=u.mid;else break}return u}has(w){const f=this.d(w);return!(f?.value===void 0&&f?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,f){const u=this.b.reset(w),t=[];let a=this.c;for(;a;){const p=u.cmp(a.segment);if(p>0)t.push([-1,a]),a=a.left;else if(p<0)t.push([1,a]),a=a.right;else if(u.hasNext())u.next(),t.push([0,a]),a=a.mid;else break}if(!!a){if(f?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const p=this.f(a.right);if(p.key){const{key:b,value:R,segment:v}=p;this.e(p.key,!1),a.key=b,a.value=R,a.segment=v}}else{const p=a.left??a.right;if(t.length>0){const[b,R]=t[t.length-1];switch(b){case-1:R.left=p;break;case 0:R.mid=p;break;case 1:R.right=p;break}}else this.c=p}for(let p=t.length-1;p>=0;p--){const b=t[p][1];b.updateHeight();const R=b.balanceFactor();if(R>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),t[p][1]=b.rotateLeft()):R<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),t[p][1]=b.rotateRight()),p>0)switch(t[p-1][0]){case-1:t[p-1][1].left=t[p][1];break;case 1:t[p-1][1].right=t[p][1];break;case 0:t[p-1][1].mid=t[p][1];break}else this.c=t[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const f=this.b.reset(w);let u=this.c,t;for(;u;){const a=f.cmp(u.segment);if(a>0)u=u.left;else if(a<0)u=u.right;else if(f.hasNext())f.next(),t=u.value||t,u=u.mid;else break}return u&&u.value||t}findSuperstr(w){return this.g(w,!1)}g(w,f){const u=this.b.reset(w);let t=this.c;for(;t;){const a=u.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(u.hasNext())u.next(),t=t.mid;else return t.mid?this.h(t.mid):f?t.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[f,u]of this)w(u,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const f=[];return this.j(w,f),f[Symbol.iterator]()}j(w,f){!w||(w.left&&this.j(w.left,f),w.value&&f.push([w.key,w.value]),w.mid&&this.j(w.mid,f),w.right&&this.j(w.right,f))}_isBalanced(){const w=f=>{if(!f)return!0;const u=f.balanceFactor();return u<-1||u>1?!1:w(f.left)&&w(f.right)};return w(this.c)}}e.TernarySearchTree=T}),define(Te[66],Pe([1,0,25,10,2]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function N(P){return JSON.stringify(P,O)}e.stringify=N;function E(P){let M=JSON.parse(P);return M=S(M),M}e.parse=E;function O(P,M){return M instanceof RegExp?{$mid:2,source:M.source,flags:(0,A.regExpFlags)(M)}:M}function S(P,M=0){if(!P||M>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return D.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 16:return new Date(P.source)}if(P instanceof n.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let T=0;T<P.length;++T)P[T]=S(P[T],M+1);else for(const T in P)Object.hasOwnProperty.call(P,T)&&(P[T]=S(P[T],M+1))}return P}e.revive=S}),define(Te[15],Pe([1,0,11,20,2]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var N;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.vscodeUserData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls",P.vscodeSourceControl="vscode-scm"})(N=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${N.vscodeRemoteResource}`}setPreferredWebSchema(M){this.d=M}setDelegate(M){this.e=M}setServerRootPath(M){this.f=`${M}/${N.vscodeRemoteResource}`}set(M,T,m){this.a[M]=T,this.b[M]=m}setConnectionToken(M,T){this.c[M]=T}getPreferredWebSchema(){return this.d}rewrite(M){if(this.e)try{return this.e(M)}catch(t){return n.onUnexpectedError(t),M}const T=M.authority;let m=this.a[T];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const w=this.b[T],f=this.c[T];let u=`path=${encodeURIComponent(M.path)}`;return typeof f=="string"&&(u+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),D.URI.from({scheme:A.isWeb?this.d:N.vscodeRemoteResource,authority:`${m}:${w}`,path:this.f,query:u})}}e.RemoteAuthorities=new E,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class O{asBrowserUri(M){const T=this.b(M,te);return this.uriToBrowserUri(T)}uriToBrowserUri(M){return M.scheme===N.vscodeRemote?e.RemoteAuthorities.rewrite(M):M.scheme===N.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${N.vscodeFileResource}://${O.a}`)?M.with({scheme:N.vscodeFileResource,authority:M.authority||O.a,query:null,fragment:null}):M}asFileUri(M){const T=this.b(M,te);return this.uriToFileUri(T)}uriToFileUri(M){return M.scheme===N.vscodeFileResource?M.with({scheme:N.file,authority:M.authority!==O.a?M.authority:null,query:null,fragment:null}):M}b(M,T){return D.URI.isUri(M)?M:D.URI.parse(T.toUrl(M))}}O.a="vscode-app",e.FileAccess=new O;var S;(function(P){const M=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);P.CoopAndCoep=Object.freeze(M.get("3"));const T="vscode-coi";function m(f){let u;typeof f=="string"?u=new URL(f).searchParams:f instanceof URL?u=f.searchParams:D.URI.isUri(f)&&(u=new URL(f.toString(!0)).searchParams);const t=u?.get(T);if(!!t)return M.get(t)}P.getHeadersFromQuery=m;function w(f,u,t){if(!globalThis.crossOriginIsolated)return;const a=u&&t?"3":t?"2":"1";f instanceof URLSearchParams?f.set(T,a):f[T]=a}P.addSearchParam=w})(S=e.COI||(e.COI={}))}),define(Te[22],Pe([1,0,41,15,19,20,10,2]),function(te,e,n,A,D,N,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(w){return(0,O.uriToFsPath)(w,!0)}e.originalFSPath=S;class P{constructor(f){this.a=f}compare(f,u,t=!1){return f===u?0:(0,E.compare)(this.getComparisonKey(f,t),this.getComparisonKey(u,t))}isEqual(f,u,t=!1){return f===u?!0:!f||!u?!1:this.getComparisonKey(f,t)===this.getComparisonKey(u,t)}getComparisonKey(f,u=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,u,t=!1){if(f.scheme===u.scheme){if(f.scheme===A.Schemas.file)return n.isEqualOrParent(S(f),S(u),this.a(f))&&f.query===u.query&&(t||f.fragment===u.fragment);if((0,e.isEqualAuthority)(f.authority,u.authority))return n.isEqualOrParent(f.path,u.path,this.a(f),"/")&&f.query===u.query&&(t||f.fragment===u.fragment)}return!1}joinPath(f,...u){return O.URI.joinPath(f,...u)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return D.posix.basename(f.path)}extname(f){return D.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let u;return f.scheme===A.Schemas.file?u=O.URI.file(D.dirname(S(f))).path:(u=D.posix.dirname(f.path),f.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),u="/")),f.with({path:u})}normalizePath(f){if(!f.path.length)return f;let u;return f.scheme===A.Schemas.file?u=O.URI.file(D.normalize(S(f))).path:u=D.posix.normalize(f.path),f.with({path:u})}relativePath(f,u){if(f.scheme!==u.scheme||!(0,e.isEqualAuthority)(f.authority,u.authority))return;if(f.scheme===A.Schemas.file){const p=D.relative(S(f),S(u));return N.isWindows?n.toSlashes(p):p}let t=f.path||"/";const a=u.path||"/";if(this.a(f)){let p=0;for(const b=Math.min(t.length,a.length);p<b&&!(t.charCodeAt(p)!==a.charCodeAt(p)&&t.charAt(p).toLowerCase()!==a.charAt(p).toLowerCase());p++);t=a.substr(0,p)+t.substr(p)}return D.posix.relative(t,a)}resolvePath(f,u){if(f.scheme===A.Schemas.file){const t=O.URI.file(D.resolve(S(f),u));return f.with({authority:t.authority,path:t.path})}return u=n.toPosixPath(u),f.with({path:D.posix.resolve(f.path,u)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,u){return f===u||f!==void 0&&u!==void 0&&(0,E.equalsIgnoreCase)(f,u)}hasTrailingPathSeparator(f,u=D.sep){if(f.scheme===A.Schemas.file){const t=S(f);return t.length>n.getRoot(t).length&&t[t.length-1]===u}else{const t=f.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,u=D.sep){return(0,e.hasTrailingPathSeparator)(f,u)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,u=D.sep){let t=!1;if(f.scheme===A.Schemas.file){const a=S(f);t=a!==void 0&&a.length===n.getRoot(a).length&&a[a.length-1]===u}else{u="/";const a=f.path;t=a.length===1&&a.charCodeAt(a.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(f,u)?f.with({path:f.path+"/"}):f}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(w=>w.scheme===A.Schemas.file?!N.isLinux:!0),e.extUriIgnorePathCase=new P(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function M(w,f){const u=[];for(let t=0;t<w.length;t++){const a=f(w[t]);w.some((p,b)=>b===t?!1:(0,e.isEqualOrParent)(a,f(p)))||u.push(w[t])}return u}e.distinctParents=M;var T;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function f(u){const t=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(b=>{const[R,v]=b.split(":");R&&v&&t.set(R,v)});const p=u.path.substring(0,u.path.indexOf(";"));return p&&t.set(w.META_DATA_MIME,p),t}w.parseMetaData=f})(T=e.DataUri||(e.DataUri={}));function m(w,f,u){if(f){let t=w.path;return t&&t[0]!==D.posix.sep&&(t=D.posix.sep+t),w.with({scheme:u,authority:f,path:t})}return w.with({scheme:u})}e.toLocalResource=m}),define(Te[17],Pe([1,0,21,11,4,6,22,20,116]),function(te,e,n,A,D,N,E,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(ie){return!!ie&&typeof ie.then=="function"}e.isThenable=P;function M(ie){const q=new n.CancellationTokenSource,ce=ie(q.token),be=new Promise((Ae,Ue)=>{const Ce=q.token.onCancellationRequested(()=>{Ce.dispose(),q.dispose(),Ue(new A.CancellationError)});Promise.resolve(ce).then(Se=>{Ce.dispose(),q.dispose(),Ae(Se)},Se=>{Ce.dispose(),q.dispose(),Ue(Se)})});return new class{cancel(){q.cancel()}then(Ae,Ue){return be.then(Ae,Ue)}catch(Ae){return this.then(void 0,Ae)}finally(Ae){return be.finally(Ae)}}}e.createCancelablePromise=M;function T(ie,q,ce){return new Promise((be,Ae)=>{const Ue=q.onCancellationRequested(()=>{Ue.dispose(),be(ce)});ie.then(be,Ae).finally(()=>Ue.dispose())})}e.raceCancellation=T;function m(ie,q){return new Promise((ce,be)=>{const Ae=q.onCancellationRequested(()=>{Ae.dispose(),be(new A.CancellationError)});ie.then(ce,be).finally(()=>Ae.dispose())})}e.raceCancellationError=m;async function w(ie){let q=-1;const ce=ie.map((Ae,Ue)=>Ae.then(Ce=>(q=Ue,Ce))),be=await Promise.race(ce);return ie.forEach((Ae,Ue)=>{Ue!==q&&Ae.cancel()}),be}e.raceCancellablePromises=w;function f(ie,q,ce){let be;const Ae=setTimeout(()=>{be?.(void 0),ce?.()},q);return Promise.race([ie.finally(()=>clearTimeout(Ae)),new Promise(Ue=>be=Ue)])}e.raceTimeout=f;function u(ie){return new Promise((q,ce)=>{const be=ie();P(be)?be.then(q,ce):q(be)})}e.asPromise=u;class t{constructor(){this.a=null,this.b=null,this.d=null}queue(q){if(this.a){if(this.d=q,!this.b){const ce=()=>{this.b=null;const be=this.queue(this.d);return this.d=null,be};this.b=new Promise(be=>{this.a.then(ce,ce).then(be)})}return new Promise((ce,be)=>{this.b.then(ce,be)})}return this.a=q(),new Promise((ce,be)=>{this.a.then(Ae=>{this.a=null,ce(Ae)},Ae=>{this.a=null,be(Ae)})})}}e.Throttler=t;class a{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.Sequencer=a;class p{constructor(){this.a=new Map}queue(q,ce){const Ae=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(ce).finally(()=>{this.a.get(q)===Ae&&this.a.delete(q)});return this.a.set(q,Ae),Ae}}e.SequencerByKey=p;const b=(ie,q)=>{let ce=!0;const be=setTimeout(()=>{ce=!1,q()},ie);return{isTriggered:()=>ce,dispose:()=>{clearTimeout(be),ce=!1}}},R=ie=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,ie())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class v{constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,ce=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((Ae,Ue)=>{this.d=Ae,this.f=Ue}).then(()=>{if(this.b=null,this.d=null,this.g){const Ae=this.g;return this.g=null,Ae()}}));const be=()=>{this.a=null,this.d?.(null)};return this.a=ce===S.MicrotaskDelay?R(be):b(ce,be),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=v;class i{constructor(q){this.a=new v(q),this.b=new t}trigger(q,ce){return this.a.trigger(()=>this.b.queue(q),ce)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class d{constructor(){this.a=!1,this.b=new Promise((q,ce)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=d;class s extends d{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function l(ie,q){return q?new Promise((ce,be)=>{const Ae=setTimeout(()=>{Ue.dispose(),ce()},ie),Ue=q.onCancellationRequested(()=>{clearTimeout(Ae),Ue.dispose(),be(new A.CancellationError)})}):M(ce=>l(ie,ce))}e.timeout=l;function o(ie,q=0){const ce=setTimeout(ie,q);return(0,N.toDisposable)(()=>clearTimeout(ce))}e.disposableTimeout=o;function I(ie){const q=[];let ce=0;const be=ie.length;function Ae(){return ce<be?ie[ce++]():null}function Ue(Ce){Ce!=null&&q.push(Ce);const Se=Ae();return Se?Se.then(Ue):Promise.resolve(q)}return Promise.resolve(null).then(Ue)}e.sequence=I;function r(ie,q=be=>!!be,ce=null){let be=0;const Ae=ie.length,Ue=()=>{if(be>=Ae)return Promise.resolve(ce);const Ce=ie[be++];return Promise.resolve(Ce()).then(ke=>q(ke)?Promise.resolve(ke):Ue())};return Ue()}e.first=r;function c(ie,q=be=>!!be,ce=null){if(ie.length===0)return Promise.resolve(ce);let be=ie.length;const Ae=()=>{be=-1;for(const Ue of ie)Ue.cancel?.()};return new Promise((Ue,Ce)=>{for(const Se of ie)Se.then(ke=>{--be>=0&&q(ke)?(Ae(),Ue(ke)):be===0&&Ue(ce)}).catch(ke=>{--be>=0&&(Ae(),Ce(ke))})})}e.firstParallel=c;class h{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((ce,be)=>{this.f.push({factory:q,c:ce,e:be}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const ce=q.factory();ce.then(q.c,q.e),ce.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class y extends h{constructor(){super(1)}}e.Queue=y;class C{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const q=new me;return this.b.add(q),q.p}d(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,ce=E.extUri){const be=ce.getComparisonKey(q);let Ae=this.a.get(be);return Ae||(Ae=new y,D.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(be),this.f()}),this.a.set(be,Ae)),Ae}f(){!this.d()||this.g()}g(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.g()}}e.ResourceQueue=C;class H{constructor(q,ce){this.a=-1,typeof q=="function"&&typeof ce=="number"&&this.setIfNotSet(q,ce)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,ce){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},ce)}setIfNotSet(q,ce){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},ce))}}e.TimeoutTimer=H;class K{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,ce){this.cancel(),this.a=setInterval(()=>{q()},ce)}}e.IntervalTimer=K;class Q{constructor(q,ce){this.b=-1,this.a=q,this.d=ce,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=Q;class _{constructor(q,ce){ce%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ce}ms is not a multiple of 1000ms.`),this.a=q,this.b=ce,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=_;class j extends Q{constructor(q,ce){super(q,ce),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=j;class L extends N.Disposable{constructor(q,ce){super(),this.g=q,this.h=ce,this.a=[],this.b=this.B(new N.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ce of q)this.a.push(ce);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ie=>{(0,O.setTimeout0)(()=>{if(q)return;const ce=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.runWhenIdle=(ie,q)=>{const ce=requestIdleCallback(ie,typeof q=="number"?{timeout:q}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(ce))}}}}();class g{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(ce){this.g=ce}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=g;async function F(ie,q,ce){let be;for(let Ae=0;Ae<ce;Ae++)try{return await ie()}catch(Ue){be=Ue,await l(q)}throw be}e.retry=F;class B{hasPending(q){return this.a?typeof q=="number"?this.a.taskId===q:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(q,ce,be){return this.a={taskId:q,cancel:()=>be?.(),promise:ce},ce.then(()=>this.d(q),()=>this.d(q)),ce}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}setNext(q){if(this.b)this.b.run=q;else{let ce,be;const Ae=new Promise((Ue,Ce)=>{ce=Ue,be=Ce});this.b={run:q,promise:Ae,promiseResolve:ce,promiseReject:be}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=B;class Y{constructor(q,ce=()=>Date.now()){this.d=q,this.f=ce,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.IntervalCounter=Y;class me{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((q,ce)=>{this.a=q,this.b=ce})}complete(q){return new Promise(ce=>{this.a(q),this.f=!0,ce()})}error(q){return new Promise(ce=>{this.b(q),this.d=!0,ce()})}cancel(){new Promise(q=>{this.b(new A.CancellationError),this.d=!0,q()})}}e.DeferredPromise=me;var Z;(function(ie){async function q(be){let Ae;const Ue=await Promise.all(be.map(Ce=>Ce.then(Se=>Se,Se=>{Ae||(Ae=Se)})));if(typeof Ae<"u")throw Ae;return Ue}ie.settled=q;function ce(be){return new Promise(async(Ae,Ue)=>{try{await be(Ae,Ue)}catch(Ce){Ue(Ce)}})}ie.withAsyncBody=ce})(Z=e.Promises||(e.Promises={}));var se;(function(ie){ie[ie.Initial=0]="Initial",ie[ie.DoneOK=1]="DoneOK",ie[ie.DoneError=2]="DoneError"})(se||(se={}));class ue{static fromArray(q){return new ue(ce=>{ce.emitMany(q)})}static fromPromise(q){return new ue(async ce=>{ce.emitMany(await q)})}static fromPromises(q){return new ue(async ce=>{await Promise.all(q.map(async be=>ce.emitOne(await be)))})}static merge(q){return new ue(async ce=>{await Promise.all(q.map(async be=>{for await(const Ae of be)ce.emitOne(Ae)}))})}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const ce={emitOne:be=>this.g(be),emitMany:be=>this.h(be),reject:be=>this.k(be)};try{await Promise.resolve(q(ce)),this.j()}catch(be){this.k(be)}finally{ce.emitOne=void 0,ce.emitMany=void 0,ce.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(q,ce){return new ue(async be=>{for await(const Ae of q)be.emitOne(ce(Ae))})}map(q){return ue.map(this,q)}static filter(q,ce){return new ue(async be=>{for await(const Ae of q)ce(Ae)&&be.emitOne(Ae)})}filter(q){return ue.filter(this,q)}static coalesce(q){return ue.filter(q,ce=>!!ce)}coalesce(){return ue.coalesce(this)}static async toPromise(q){const ce=[];for await(const be of q)ce.push(be);return ce}toPromise(){return ue.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}ue.EMPTY=ue.fromArray([]),e.AsyncIterableObject=ue;class De extends ue{constructor(q,ce){super(ce),this.l=q}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=De;function de(ie){const q=new n.CancellationTokenSource,ce=ie(q.token);return new De(q,async be=>{const Ae=q.token.onCancellationRequested(()=>{Ae.dispose(),q.dispose(),be.reject(new A.CancellationError)});try{for await(const Ue of ce){if(q.token.isCancellationRequested)return;be.emitOne(Ue)}Ae.dispose(),q.dispose()}catch(Ue){Ae.dispose(),q.dispose(),be.reject(Ue)}})}e.createCancelableAsyncIterable=de}),define(Te[35],Pe([1,0,16,17,41,28,19,20,10]),function(te,e,n,A,D,N,E,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const M="[/\\\\]",T="[^/\\\\]",m=/\//g;function w(Y,me){switch(Y){case 0:return"";case 1:return`${T}*?`;default:return`(?:${M}|${T}+${M}${me?`|${M}${T}+`:""})*?`}}function f(Y,me){if(!Y)return[];const Z=[];let se=!1,ue=!1,De="";for(const de of Y){switch(de){case me:if(!se&&!ue){Z.push(De),De="";continue}break;case"{":se=!0;break;case"}":se=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}De+=de}return De&&Z.push(De),Z}e.splitGlobAware=f;function u(Y){if(!Y)return"";let me="";const Z=f(Y,e.GLOB_SPLIT);if(Z.every(se=>se===e.GLOBSTAR))me=".*";else{let se=!1;Z.forEach((ue,De)=>{if(ue===e.GLOBSTAR){if(se)return;me+=w(2,De===Z.length-1)}else{let de=!1,ie="",q=!1,ce="";for(const be of ue){if(be!=="}"&&de){ie+=be;continue}if(q&&(be!=="]"||!ce)){let Ae;be==="-"?Ae=be:(be==="^"||be==="!")&&!ce?Ae="^":be===e.GLOB_SPLIT?Ae="":Ae=(0,S.escapeRegExpCharacters)(be),ce+=Ae;continue}switch(be){case"{":de=!0;continue;case"[":q=!0;continue;case"}":{me+=`(?:${f(ie,",").map(Ce=>u(Ce)).join("|")})`,de=!1,ie="";break}case"]":{me+="["+ce+"]",q=!1,ce="";break}case"?":me+=T;continue;case"*":me+=w(1);continue;default:me+=(0,S.escapeRegExpCharacters)(be)}}De<Z.length-1&&(Z[De+1]!==e.GLOBSTAR||De+2<Z.length)&&(me+=M)}se=ue===e.GLOBSTAR})}return me}const t=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,R=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new N.LRUCache(1e4),d=function(){return!1},s=function(){return null};function l(Y,me){if(!Y)return s;let Z;typeof Y!="string"?Z=Y.pattern:Z=Y,Z=Z.trim();const se=`${Z}_${!!me.trimForExclusions}`;let ue=i.get(se);if(ue)return o(ue,Y);let De;return t.test(Z)?ue=r(Z.substr(4),Z):(De=a.exec(I(Z,me)))?ue=c(De[1],Z):(me.trimForExclusions?b:p).test(Z)?ue=h(Z,me):(De=R.exec(I(Z,me)))?ue=y(De[1].substr(1),Z,!0):(De=v.exec(I(Z,me)))?ue=y(De[1],Z,!1):ue=C(Z),i.set(se,ue),o(ue,Y)}function o(Y,me){if(typeof me=="string")return Y;const Z=function(se,ue){return(0,D.isEqualOrParent)(se,me.base,!O.isLinux)?Y((0,S.ltrim)(se.substr(me.base.length),E.sep),ue):null};return Z.allBasenames=Y.allBasenames,Z.allPaths=Y.allPaths,Z.basenames=Y.basenames,Z.patterns=Y.patterns,Z}function I(Y,me){return me.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function r(Y,me){return function(Z,se){return typeof Z=="string"&&Z.endsWith(Y)?me:null}}function c(Y,me){const Z=`/${Y}`,se=`\\${Y}`,ue=function(de,ie){return typeof de!="string"?null:ie?ie===Y?me:null:de===Y||de.endsWith(Z)||de.endsWith(se)?me:null},De=[Y];return ue.basenames=De,ue.patterns=[me],ue.allBasenames=De,ue}function h(Y,me){const Z=F(Y.slice(1,-1).split(",").map(ie=>l(ie,me)).filter(ie=>ie!==s),Y),se=Z.length;if(!se)return s;if(se===1)return Z[0];const ue=function(ie,q){for(let ce=0,be=Z.length;ce<be;ce++)if(Z[ce](ie,q))return Y;return null},De=Z.find(ie=>!!ie.allBasenames);De&&(ue.allBasenames=De.allBasenames);const de=Z.reduce((ie,q)=>q.allPaths?ie.concat(q.allPaths):ie,[]);return de.length&&(ue.allPaths=de),ue}function y(Y,me,Z){const se=E.sep===E.posix.sep,ue=se?Y:Y.replace(m,E.sep),De=E.sep+ue,de=E.posix.sep+Y;let ie;return Z?ie=function(q,ce){return typeof q=="string"&&(q===ue||q.endsWith(De)||!se&&(q===Y||q.endsWith(de)))?me:null}:ie=function(q,ce){return typeof q=="string"&&(q===ue||!se&&q===Y)?me:null},ie.allPaths=[(Z?"*/":"./")+Y],ie}function C(Y){try{const me=new RegExp(`^${u(Y)}$`);return function(Z){return me.lastIndex=0,typeof Z=="string"&&me.test(Z)?Y:null}}catch{return s}}function H(Y,me,Z){return!Y||typeof me!="string"?!1:K(Y)(me,void 0,Z)}e.match=H;function K(Y,me={}){if(!Y)return d;if(typeof Y=="string"||Q(Y)){const Z=l(Y,me);if(Z===s)return d;const se=function(ue,De){return!!Z(ue,De)};return Z.allBasenames&&(se.allBasenames=Z.allBasenames),Z.allPaths&&(se.allPaths=Z.allPaths),se}return L(Y,me)}e.parse=K;function Q(Y){const me=Y;return me?typeof me.base=="string"&&typeof me.pattern=="string":!1}e.isRelativePattern=Q;function _(Y){return Y.allBasenames||[]}e.getBasenameTerms=_;function j(Y){return Y.allPaths||[]}e.getPathTerms=j;function L(Y,me){const Z=F(Object.getOwnPropertyNames(Y).map(ie=>g(ie,Y[ie],me)).filter(ie=>ie!==s)),se=Z.length;if(!se)return s;if(!Z.some(ie=>!!ie.requiresSiblings)){if(se===1)return Z[0];const ie=function(be,Ae){let Ue;for(let Ce=0,Se=Z.length;Ce<Se;Ce++){const ke=Z[Ce](be,Ae);if(typeof ke=="string")return ke;(0,A.isThenable)(ke)&&(Ue||(Ue=[]),Ue.push(ke))}return Ue?(async()=>{for(const Ce of Ue){const Se=await Ce;if(typeof Se=="string")return Se}return null})():null},q=Z.find(be=>!!be.allBasenames);q&&(ie.allBasenames=q.allBasenames);const ce=Z.reduce((be,Ae)=>Ae.allPaths?be.concat(Ae.allPaths):be,[]);return ce.length&&(ie.allPaths=ce),ie}const ue=function(ie,q,ce){let be,Ae;for(let Ue=0,Ce=Z.length;Ue<Ce;Ue++){const Se=Z[Ue];Se.requiresSiblings&&ce&&(q||(q=(0,E.basename)(ie)),be||(be=q.substr(0,q.length-(0,E.extname)(ie).length)));const ke=Se(ie,q,be,ce);if(typeof ke=="string")return ke;(0,A.isThenable)(ke)&&(Ae||(Ae=[]),Ae.push(ke))}return Ae?(async()=>{for(const Ue of Ae){const Ce=await Ue;if(typeof Ce=="string")return Ce}return null})():null},De=Z.find(ie=>!!ie.allBasenames);De&&(ue.allBasenames=De.allBasenames);const de=Z.reduce((ie,q)=>q.allPaths?ie.concat(q.allPaths):ie,[]);return de.length&&(ue.allPaths=de),ue}function g(Y,me,Z){if(me===!1)return s;const se=l(Y,Z);if(se===s)return s;if(typeof me=="boolean")return se;if(me){const ue=me.when;if(typeof ue=="string"){const De=(de,ie,q,ce)=>{if(!ce||!se(de,ie))return null;const be=ue.replace("$(basename)",()=>q),Ae=ce(be);return(0,A.isThenable)(Ae)?Ae.then(Ue=>Ue?Y:null):Ae?Y:null};return De.requiresSiblings=!0,De}}return se}function F(Y,me){const Z=Y.filter(ie=>!!ie.basenames);if(Z.length<2)return Y;const se=Z.reduce((ie,q)=>{const ce=q.basenames;return ce?ie.concat(ce):ie},[]);let ue;if(me){ue=[];for(let ie=0,q=se.length;ie<q;ie++)ue.push(me)}else ue=Z.reduce((ie,q)=>{const ce=q.patterns;return ce?ie.concat(ce):ie},[]);const De=function(ie,q){if(typeof ie!="string")return null;if(!q){let be;for(be=ie.length;be>0;be--){const Ae=ie.charCodeAt(be-1);if(Ae===47||Ae===92)break}q=ie.substr(be)}const ce=se.indexOf(q);return ce!==-1?ue[ce]:null};De.basenames=se,De.patterns=ue,De.allBasenames=se;const de=Y.filter(ie=>!ie.basenames);return de.push(De),de}function B(Y,me){return(0,n.equals)(Y,me,(Z,se)=>typeof Z=="string"&&typeof se=="string"?Z===se:typeof Z!="string"&&typeof se!="string"?Z.base===se.base&&Z.pattern===se.pattern:!1)}e.patternsEquals=B}),define(Te[86],Pe([1,0,11,127,22,10,2]),function(te,e,n,A,D,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var O;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(O=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(a="",p=!1){if(this.value=a,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(a,p=0){return this.value+=m(this.supportThemeIcons?(0,A.escapeIcons)(a):a).replace(/([ \t]+)/g,(b,R)=>"&nbsp;".repeat(R.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,p){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(a,p,b){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(a),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(a,p){const b=new RegExp((0,N.escapeRegExpCharacters)(p),"g");return a.replace(b,(R,v)=>a.charAt(v-1)!=="\\"?`\\${R}`:R)}}e.MarkdownString=S;function P(t){return M(t)?!t.value:Array.isArray(t)?t.every(P):!0}e.isEmptyMarkdownString=P;function M(t){return t instanceof S?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=M;function T(t,a){return t===a?!0:!t||!a?!1:t.value===a.value&&t.isTrusted===a.isTrusted&&t.supportThemeIcons===a.supportThemeIcons&&t.supportHtml===a.supportHtml&&(t.baseUri===a.baseUri||!!t.baseUri&&!!a.baseUri&&(0,D.isEqual)(E.URI.from(t.baseUri),E.URI.from(a.baseUri)))}e.markdownStringEqual=T;function m(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function w(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=w;function f(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=f;function u(t){const a=[],p=t.split("|").map(R=>R.trim());t=p[0];const b=p[1];if(b){const R=/height=(\d+)/.exec(b),v=/width=(\d+)/.exec(b),i=R?R[1]:"",d=v?v[1]:"",s=isFinite(parseInt(d)),l=isFinite(parseInt(i));s&&a.push(`width="${d}"`),l&&a.push(`height="${i}"`)}return{href:t,dimensions:a}}e.parseHrefAndDimensions=u}),define(Te[87],Pe([1,0,16,41,19,20,22,10]),function(te,e,n,A,D,N,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(s,l){const{os:o,tildify:I,relative:r}=l;if(r){const y=P(s,r,o);if(typeof y=="string")return y}let c=s.fsPath;if(o===1&&!N.isWindows?c=c.replace(/\//g,"\\"):o!==1&&N.isWindows&&(c=c.replace(/\\/g,"/")),o!==1&&I?.userHome){const y=I.userHome.fsPath;let C;s.scheme!==I.userHome.scheme&&s.path.startsWith(D.posix.sep)?C=I.userHome.with({path:s.path}).fsPath:C=s.fsPath,c=m(C,y,o)}return(o===1?D.win32:D.posix).normalize(M(c,o===1))}e.getPathLabel=S;function P(s,l,o){const I=o===1?D.win32:D.posix,r=o===3?E.extUri:E.extUriIgnorePathCase,c=l.getWorkspace(),h=(0,n.firstOrDefault)(c.folders);if(!h)return;s.scheme!==h.uri.scheme&&s.path.startsWith(D.posix.sep)&&(s=h.uri.with({path:s.path}));const y=l.getWorkspaceFolder(s);if(!y)return;let C;if(r.isEqual(y.uri,s)?C="":C=r.relativePath(y.uri,s)??"",C&&(C=I.normalize(C)),c.folders.length>1&&!l.noPrefix){const H=y.name?y.name:r.basenameOrAuthority(y.uri);C=C?`${H} \u2022 ${C}`:H}return C}function M(s,l=N.isWindows){return(0,A.hasDriveLetter)(s,l)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=M;let T=Object.create(null);function m(s,l,o=N.OS){if(o===1||!s||!l)return s;let I=T.original===l?T.normalized:void 0;I||(I=l,N.isWindows&&(I=(0,A.toSlashes)(I)),I=`${(0,O.rtrim)(I,D.posix.sep)}${D.posix.sep}`,T={original:l,normalized:I});let r=s;return N.isWindows&&(r=(0,A.toSlashes)(r)),(o===3?r.startsWith(I):(0,O.startsWithIgnoreCase)(r,I))?`~/${r.substr(I.length)}`:s}e.tildify=m;function w(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=w;const f="\u2026",u="\\\\",t="~";function a(s,l=D.sep){const o=new Array(s.length);let I=!1;for(let r=0;r<s.length;r++){const c=s[r];if(c===""){o[r]=`.${l}`;continue}if(!c){o[r]=c;continue}I=!0;let h="",y=c;y.indexOf(u)===0?(h=y.substr(0,y.indexOf(u)+u.length),y=y.substr(y.indexOf(u)+u.length)):y.indexOf(l)===0?(h=y.substr(0,y.indexOf(l)+l.length),y=y.substr(y.indexOf(l)+l.length)):y.indexOf(t)===0&&(h=y.substr(0,y.indexOf(t)+t.length),y=y.substr(y.indexOf(t)+t.length));const C=y.split(l);for(let H=1;I&&H<=C.length;H++)for(let K=C.length-H;I&&K>=0;K--){I=!1;let Q=C.slice(K,K+H).join(l);for(let _=0;!I&&_<s.length;_++)if(_!==r&&s[_]&&s[_].indexOf(Q)>-1){const j=K+H===C.length,L=K>0&&s[_].indexOf(l)>-1?l+Q:Q,g=s[_].endsWith(L);I=!j||g}if(!I){let _="";(C[0].endsWith(":")||h!=="")&&(K===1&&(K=0,H++,Q=C[0]+l+Q),K>0&&(_=C[0]+l),_=h+_),K>0&&(_=_+f+l),_=_+Q,K+H<C.length&&(_=_+l+f),o[r]=_}}I&&(o[r]=c)}return o}e.shorten=a;var p;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function b(s,l=Object.create(null)){const o=[];let I=!1,r="";for(const c of s)if(c==="$"||I&&c==="{")r&&o.push({value:r,type:p.TEXT}),r="",I=!0;else if(c==="}"&&I){const h=l[r];if(typeof h=="string")h.length&&o.push({value:h,type:p.VARIABLE});else if(h){const y=o[o.length-1];(!y||y.type!==p.SEPARATOR)&&o.push({value:h.label,type:p.SEPARATOR})}r="",I=!1}else r+=c;return r&&!I&&o.push({value:r,type:p.TEXT}),o.filter((c,h)=>{if(c.type===p.SEPARATOR){const y=o[h-1],C=o[h+1];return[y,C].every(H=>H&&(H.type===p.VARIABLE||H.type===p.TEXT)&&H.value.length>0)}return!0}).map(c=>c.value).join("")}e.template=b;function R(s,l){return N.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.isMacintosh?"&":"&&"):s.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=R;function v(s,l){return N.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):N.isWindows?s.replace(/&&|&/g,o=>o==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function i(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=i;function d(s){const l=s.indexOf("/")!==-1?D.posix:D.win32,o=l.basename(s),I=l.dirname(s);return o.length?{name:o,parentPath:I}:{name:I,parentPath:""}}e.splitName=d}),define(Te[128],Pe([1,0,25,2]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(T){return T.toJSON()}class N{constructor(m){this.a=m}transformIncoming(m){const w=this.a.transformIncoming(m);return w===m?m:D(A.URI.from(w))}transformOutgoing(m){const w=this.a.transformOutgoing(m);return w===m?m:D(A.URI.from(w))}transformOutgoingURI(m){const w=this.a.transformOutgoing(m);return w===m?m:A.URI.from(w)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.URITransformer=N,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function E(T,m,w){if(!T||w>200)return null;if(typeof T=="object"){if(T instanceof A.URI)return m.transformOutgoing(T);for(const f in T)if(Object.hasOwnProperty.call(T,f)){const u=E(T[f],m,w+1);u!==null&&(T[f]=u)}}return null}function O(T,m){const w=E(T,m,0);return w===null?T:w}e.transformOutgoingURIs=O;function S(T,m,w,f){if(!T||f>200)return null;if(typeof T=="object"){if(T.$mid===1)return w?A.URI.revive(m.transformIncoming(T)):m.transformIncoming(T);if(T instanceof n.VSBuffer)return null;for(const u in T)if(Object.hasOwnProperty.call(T,u)){const t=S(T[u],m,w,f+1);t!==null&&(T[u]=t)}}return null}function P(T,m){const w=S(T,m,!1,0);return w===null?T:w}e.transformIncomingURIs=P;function M(T,m){const w=S(T,m,!0,0);return w===null?T:w}e.transformAndReviveIncomingURIs=M}),define(Te[129],Pe([1,0,35,19]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(N,E,O,S,P,M){if(Array.isArray(N)){let T=0;for(const m of N){const w=D(m,E,O,S,P,M);if(w===10)return w;w>T&&(T=w)}return T}else{if(typeof N=="string")return S?N==="*"?5:N===O?10:0:0;if(N){const{language:T,pattern:m,scheme:w,hasAccessToAllModels:f,notebookType:u}=N;if(!S&&!f)return 0;u&&P&&(E=P);let t=0;if(w)if(w===E.scheme)t=10;else if(w==="*")t=5;else return 0;if(T)if(T===O)t=10;else if(T==="*")t=Math.max(t,5);else return 0;if(u)if(u===M)t=10;else if(u==="*"&&M!==void 0)t=Math.max(t,5);else return 0;if(m){let a;if(typeof m=="string"?a=m:a={...m,base:(0,A.normalize)(m.base)},a===E.fsPath||(0,n.match)(a,E.fsPath))t=10;else return 0}return t}else return 0}}e.score=D}),define(Te[88],Pe([1,0,25,20]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(D||(D={}));function N(T){for(let m=0,w=T.length;m<w;m+=4){const f=T[m+0],u=T[m+1],t=T[m+2],a=T[m+3];T[m+0]=a,T[m+1]=t,T[m+2]=u,T[m+3]=f}}function E(T){const m=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return A.isLittleEndian()||N(m),n.VSBuffer.wrap(m)}function O(T){const m=T.buffer;if(A.isLittleEndian()||N(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const w=new Uint8Array(m.byteLength);return w.set(m),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function S(T){const m=new Uint32Array(P(T));let w=0;if(m[w++]=T.id,T.type==="full")m[w++]=1,m[w++]=T.data.length,m.set(T.data,w),w+=T.data.length;else{m[w++]=2,m[w++]=T.deltas.length;for(const f of T.deltas)m[w++]=f.start,m[w++]=f.deleteCount,f.data?(m[w++]=f.data.length,m.set(f.data,w),w+=f.data.length):m[w++]=0}return E(m)}e.encodeSemanticTokensDto=S;function P(T){let m=0;if(m+=1+1,T.type==="full")m+=1+T.data.length;else{m+=1,m+=(1+1+1)*T.deltas.length;for(const w of T.deltas)w.data&&(m+=w.data.length)}return m}function M(T){const m=O(T);let w=0;const f=m[w++];if(m[w++]===1){const p=m[w++],b=m.subarray(w,w+p);return w+=p,{id:f,type:"full",data:b}}const t=m[w++],a=[];for(let p=0;p<t;p++){const b=m[w++],R=m[w++],v=m[w++];let i;v>0&&(i=m.subarray(w,w+v),w+=v),a[p]={start:b,deleteCount:R,data:i}}return{id:f,type:"delta",deltas:a}}e.decodeSemanticTokensDto=M}),define(Te[130],Pe([13,14]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Te[131],Pe([1,0,130,20,132,16,23,118]),function(te,e,n,A,D,N,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=P;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class T{constructor(X,pe,ze,Be){this.id=X,this.name=pe,this.defaultValue=ze,this.schema=Be}applyUpdate(X,pe){return w(X,pe)}compute(X,pe,ze){return ze}}class m{constructor(X,pe){this.newValue=X,this.didChange=pe}}e.ApplyUpdateResult=m;function w(G,X){if(typeof G!="object"||typeof X!="object"||!G||!X)return new m(X,G!==X);if(Array.isArray(G)||Array.isArray(X)){const ze=Array.isArray(G)&&Array.isArray(X)&&N.equals(G,X);return new m(X,!ze)}let pe=!1;for(const ze in X)if(X.hasOwnProperty(ze)){const Be=w(G[ze],X[ze]);Be.didChange&&(G[ze]=Be.newValue,pe=!0)}return new m(G,pe)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,pe){return w(X,pe)}validate(X){return this.defaultValue}}class u{constructor(X,pe,ze,Be){this.id=X,this.name=pe,this.defaultValue=ze,this.schema=Be}applyUpdate(X,pe){return w(X,pe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,pe,ze){return ze}}function t(G,X){return typeof G>"u"?X:G==="false"?!1:Boolean(G)}e.boolean=t;class a extends u{constructor(X,pe,ze,Be=void 0){typeof Be<"u"&&(Be.type="boolean",Be.default=ze),super(X,pe,ze,Be)}validate(X){return t(X,this.defaultValue)}}function p(G,X,pe,ze){if(typeof G>"u")return X;let Be=parseInt(G,10);return isNaN(Be)?X:(Be=Math.max(pe,Be),Be=Math.min(ze,Be),Be|0)}e.clampedInt=p;class b extends u{static clampedInt(X,pe,ze,Be){return p(X,pe,ze,Be)}constructor(X,pe,ze,Be,Qe,_e=void 0){typeof _e<"u"&&(_e.type="integer",_e.default=ze,_e.minimum=Be,_e.maximum=Qe),super(X,pe,ze,_e),this.minimum=Be,this.maximum=Qe}validate(X){return b.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class R extends u{static clamp(X,pe,ze){return X<pe?pe:X>ze?ze:X}static float(X,pe){if(typeof X=="number")return X;if(typeof X>"u")return pe;const ze=parseFloat(X);return isNaN(ze)?pe:ze}constructor(X,pe,ze,Be,Qe){typeof Qe<"u"&&(Qe.type="number",Qe.default=ze),super(X,pe,ze,Qe),this.validationFn=Be}validate(X){return this.validationFn(R.float(X,this.defaultValue))}}class v extends u{static string(X,pe){return typeof X!="string"?pe:X}constructor(X,pe,ze,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.default=ze),super(X,pe,ze,Be)}validate(X){return v.string(X,this.defaultValue)}}function i(G,X,pe){return typeof G!="string"||pe.indexOf(G)===-1?X:G}e.stringSet=i;class d extends u{constructor(X,pe,ze,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.enum=Be,Qe.default=ze),super(X,pe,ze,Qe),this.c=Be}validate(X){return i(X,this.defaultValue,this.c)}}class s extends T{constructor(X,pe,ze,Be,Qe,_e,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Qe,Xe.default=Be),super(X,pe,ze,Xe),this.c=Qe,this.d=_e}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function l(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,pe,ze){return ze===0?X.accessibilitySupport:ze}}class I extends T{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:n.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertSpace:t(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function y(G){switch(G){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function C(G){switch(G){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class H extends f{constructor(){super(135)}compute(X,pe,ze){const Be=["monaco-editor"];return pe.get(36)&&Be.push(pe.get(36)),X.extraEditorClassName&&Be.push(X.extraEditorClassName),pe.get(70)==="default"?Be.push("mouse-default"):pe.get(70)==="copy"&&Be.push("mouse-copy"),pe.get(105)&&Be.push("showUnused"),pe.get(133)&&Be.push("showDeprecated"),Be.join(" ")}}class K extends a{constructor(){super(34,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(X,pe,ze){return ze&&X.emptySelectionClipboard}}class Q extends T{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:n.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:n.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{cursorMoveOnType:t(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":i(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":i(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(pe.loop,this.defaultValue.loop)}}}class _ extends T{constructor(){super(48,"fontLigatures",_.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?_.OFF:X==="true"?_.ON:X:Boolean(X)?_.ON:_.OFF}}_.OFF='"liga" off, "calt" off',_.ON='"liga" on, "calt" on',e.EditorFontLigatures=_;class j extends T{constructor(){super(51,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?j.OFF:X==="true"?j.TRANSLATE:X:Boolean(X)?j.TRANSLATE:j.OFF}compute(X,pe,ze){return X.fontInfo.fontVariationSettings}}j.OFF="normal",j.TRANSLATE="translate",e.EditorFontVariations=j;class L extends f{constructor(){super(47)}compute(X,pe,ze){return X.fontInfo}}class g extends u{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(X){const pe=R.float(X,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:R.clamp(pe,6,100)}compute(X,pe,ze){return X.fontInfo.fontSize}}class F extends T{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:F.d,maximum:F.e,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:F.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(b.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,F.d,F.e))}}F.c=["normal","bold","100","200","300","400","500","600","700","800","900"],F.d=1,F.e=1e3;class B extends T{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},ze=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:ze,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:ze,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:ze,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:ze,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:ze,description:n.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{multiple:i(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??i(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??i(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??i(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??i(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??i(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Y extends T{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:n.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),delay:b.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:t(pe.sticky,this.defaultValue.sticky),above:t(pe.above,this.defaultValue.above)}}}var me;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(me=e.RenderMinimap||(e.RenderMinimap={}));class Z extends f{constructor(){super(138)}compute(X,pe,ze){return Z.computeLayout(pe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const pe=X.height/X.lineHeight,ze=Math.floor(X.paddingTop/X.lineHeight);let Be=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Be=Math.max(Be,pe-1));const Qe=(ze+X.viewLineCount+Be)/(X.pixelRatio*X.height),_e=Math.floor(X.viewLineCount/Qe);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:ze,extraLinesBeyondLastLine:Be,desiredRatio:Qe,minimapLineCount:_e}}static c(X,pe){const ze=X.outerWidth,Be=X.outerHeight,Qe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const _e=pe.stableMinimapLayoutInput,Xe=_e&&X.outerHeight===_e.outerHeight&&X.lineHeight===_e.lineHeight&&X.typicalHalfwidthCharacterWidth===_e.typicalHalfwidthCharacterWidth&&X.pixelRatio===_e.pixelRatio&&X.scrollBeyondLastLine===_e.scrollBeyondLastLine&&X.paddingTop===_e.paddingTop&&X.paddingBottom===_e.paddingBottom&&X.minimap.enabled===_e.minimap.enabled&&X.minimap.side===_e.minimap.side&&X.minimap.size===_e.minimap.size&&X.minimap.showSlider===_e.minimap.showSlider&&X.minimap.renderCharacters===_e.minimap.renderCharacters&&X.minimap.maxColumn===_e.minimap.maxColumn&&X.minimap.scale===_e.minimap.scale&&X.verticalScrollbarWidth===_e.verticalScrollbarWidth&&X.isViewportWrapping===_e.isViewportWrapping,at=X.lineHeight,bt=X.typicalHalfwidthCharacterWidth,kt=X.scrollBeyondLastLine,Dt=X.minimap.renderCharacters;let St=Qe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Bt=X.minimap.maxColumn,ct=X.minimap.size,pt=X.minimap.side,Ht=X.verticalScrollbarWidth,Ft=X.viewLineCount,It=X.remainingWidth,ft=X.isViewportWrapping,Tt=Dt?2:3;let Nt=Math.floor(Qe*Be);const Ot=Nt/Qe;let Ke=!1,qt=!1,Lt=Tt*St,Ut=St/Qe,ye=1;if(ct==="fill"||ct==="fit"){const{typicalViewportLineCount:He,extraLinesBeforeFirstLine:et,extraLinesBeyondLastLine:ut,desiredRatio:ht,minimapLineCount:Ct}=Z.computeContainedMinimapLineCount({viewLineCount:Ft,scrollBeyondLastLine:kt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Be,lineHeight:at,pixelRatio:Qe});if(Ft/Ct>1)Ke=!0,qt=!0,St=1,Lt=1,Ut=St/Qe;else{let vt=!1,Pt=St+1;if(ct==="fit"){const zt=Math.ceil((et+Ft+ut)*Lt);ft&&Xe&&It<=pe.stableFitRemainingWidth?(vt=!0,Pt=pe.stableFitMaxMinimapScale):vt=zt>Nt}if(ct==="fill"||vt){Ke=!0;const zt=St;Lt=Math.min(at*Qe,Math.max(1,Math.floor(1/ht))),ft&&Xe&&It<=pe.stableFitRemainingWidth&&(Pt=pe.stableFitMaxMinimapScale),St=Math.min(Pt,Math.max(1,Math.floor(Lt/Tt))),St>zt&&(ye=Math.min(2,St/zt)),Ut=St/Qe/ye,Nt=Math.ceil(Math.max(He,et+Ft+ut)*Lt),ft?(pe.stableMinimapLayoutInput=X,pe.stableFitRemainingWidth=It,pe.stableFitMaxMinimapScale=St):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Re=Math.floor(Bt*Ut),ge=Math.min(Re,Math.max(0,Math.floor((It-Ht-2)*Ut/(bt+Ut)))+e.MINIMAP_GUTTER_WIDTH);let x=Math.floor(Qe*ge);const Oe=x/Qe;x=Math.floor(x*ye);const $e=Dt?1:2,Ze=pt==="left"?0:ze-ge-Ht;return{renderMinimap:$e,minimapLeft:Ze,minimapWidth:ge,minimapHeightIsEditorHeight:Ke,minimapIsSampling:qt,minimapScale:St,minimapLineHeight:Lt,minimapCanvasInnerWidth:x,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:Oe,minimapCanvasOuterHeight:Ot}}static computeLayout(X,pe){const ze=pe.outerWidth|0,Be=pe.outerHeight|0,Qe=pe.lineHeight|0,_e=pe.lineNumbersDigitCount|0,Xe=pe.typicalHalfwidthCharacterWidth,at=pe.maxDigitWidth,bt=pe.pixelRatio,kt=pe.viewLineCount,Dt=X.get(130),St=Dt==="inherit"?X.get(129):Dt,Bt=St==="inherit"?X.get(125):St,ct=X.get(128),pt=pe.isDominatedByLongLines,Ht=X.get(54),Ft=X.get(64).renderType!==0,It=X.get(65),ft=X.get(99),Tt=X.get(80),Nt=X.get(69),Ot=X.get(97),Ke=Ot.verticalScrollbarSize,qt=Ot.verticalHasArrows,Lt=Ot.arrowSize,Ut=Ot.horizontalScrollbarSize,ye=X.get(40),Re=X.get(104)!=="never";let ge=X.get(62);ye&&Re&&(ge+=16);let x=0;if(Ft){const ti=Math.max(_e,It);x=Math.round(ti*at)}let Oe=0;Ht&&(Oe=Qe);let $e=0,Ze=$e+Oe,He=Ze+x,et=He+ge;const ut=ze-Oe-x-ge;let ht=!1,Ct=!1,mt=-1;St==="inherit"&&pt?(ht=!0,Ct=!0):Bt==="on"||Bt==="bounded"?Ct=!0:Bt==="wordWrapColumn"&&(mt=ct);const vt=Z.c({outerWidth:ze,outerHeight:Be,lineHeight:Qe,typicalHalfwidthCharacterWidth:Xe,pixelRatio:bt,scrollBeyondLastLine:ft,paddingTop:Tt.top,paddingBottom:Tt.bottom,minimap:Nt,verticalScrollbarWidth:Ke,viewLineCount:kt,remainingWidth:ut,isViewportWrapping:Ct},pe.memory||new M);vt.renderMinimap!==0&&vt.minimapLeft===0&&($e+=vt.minimapWidth,Ze+=vt.minimapWidth,He+=vt.minimapWidth,et+=vt.minimapWidth);const Pt=ut-vt.minimapWidth,zt=Math.max(1,Math.floor((Pt-Ke-2)/Xe)),At=qt?Lt:0;return Ct&&(mt=Math.max(1,zt),Bt==="bounded"&&(mt=Math.min(mt,ct))),{width:ze,height:Be,glyphMarginLeft:$e,glyphMarginWidth:Oe,lineNumbersLeft:Ze,lineNumbersWidth:x,decorationsLeft:He,decorationsWidth:ge,contentLeft:et,contentWidth:Pt,minimap:vt,viewportColumn:zt,isWordWrapMinified:ht,isViewportWrapping:Ct,wrappingColumn:mt,verticalScrollbarWidth:Ke,horizontalScrollbarHeight:Ut,overviewRuler:{top:At,width:Ke,height:Be-2*At,right:0}}}}e.EditorLayoutInfoComputer=Z;class se extends T{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(X){return i(X,"simple",["simple","advanced"])}compute(X,pe,ze){return pe.get(2)===2?"advanced":ze}}class ue extends T{constructor(){const X={enabled:!0};super(61,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:n.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:t(X.enabled,this.defaultValue.enabled)}}}class De extends T{constructor(){const X={enabled:!1,maxLineCount:5};super(109,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class de extends T{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:n.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(53,null),n.localize(54,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(55,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:n.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:n.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:n.localize(59,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:i(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(pe.fontFamily,this.defaultValue.fontFamily),padding:t(pe.padding,this.defaultValue.padding)}}}class ie extends T{constructor(){super(62,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):b.clampedInt(X,this.defaultValue,0,1e3)}compute(X,pe,ze){return ze<0?b.clampedInt(-ze*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):ze}}class q extends R{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>R.clamp(X,0,150),{markdownDescription:n.localize(60,null)})}compute(X,pe,ze){return X.fontInfo.lineHeight}}class ce extends T{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:n.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:n.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(63,null),n.localize(64,null),n.localize(65,null)],default:X.size,description:n.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:n.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:n.localize(68,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:n.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:n.localize(71,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),autohide:t(pe.autohide,this.defaultValue.autohide),size:i(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(pe.side,this.defaultValue.side,["right","left"]),showSlider:i(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(pe.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(pe.scale,1,1,3),maxColumn:b.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function be(G){return G==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ae extends T{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{top:b.clampedInt(pe.top,0,0,1e3),bottom:b.clampedInt(pe.bottom,0,0,1e3)}}}class Ue extends T{constructor(){const X={enabled:!0,cycle:!0};super(81,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:n.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:n.localize(75,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),cycle:t(pe.cycle,this.defaultValue.cycle)}}}class Ce extends f{constructor(){super(136)}compute(X,pe,ze){return X.pixelRatio}}class Se extends T{constructor(){const X={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(76,null),n.localize(77,null),n.localize(78,null)]}];super(84,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:X.strings,description:n.localize(79,null)},comments:{anyOf:pe,default:X.comments,description:n.localize(80,null)},other:{anyOf:pe,default:X.other,description:n.localize(81,null)}},default:X,markdownDescription:n.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const bt=X?"on":"off";return{comments:bt,strings:bt,other:bt}}if(!X||typeof X!="object")return this.defaultValue;const{other:pe,comments:ze,strings:Be}=X,Qe=["on","inline","off"];let _e,Xe,at;return typeof pe=="boolean"?_e=pe?"on":"off":_e=i(pe,this.defaultValue.other,Qe),typeof ze=="boolean"?Xe=ze?"on":"off":Xe=i(ze,this.defaultValue.comments,Qe),typeof Be=="boolean"?at=Be?"on":"off":at=i(Be,this.defaultValue.strings,Qe),{other:_e,comments:Xe,strings:at}}}var ke;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends T{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(83,null),n.localize(84,null),n.localize(85,null),n.localize(86,null)],default:"on",description:n.localize(87,null)})}validate(X){let pe=this.defaultValue.renderType,ze=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(pe=4,ze=X):X==="interval"?pe=3:X==="relative"?pe=2:X==="on"?pe=1:pe=0),{renderType:pe,renderFn:ze}}}function ae(G){const X=G.get(92);return X==="editable"?G.get(86):X!=="on"}e.filterValidationDecorations=ae;class J extends T{constructor(){const X=[],pe={type:"number",description:n.localize(88,null)};super(96,"rulers",X,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:n.localize(89,null),format:"color-hex"}}}]},default:X,description:n.localize(90,null)})}validate(X){if(Array.isArray(X)){const pe=[];for(const ze of X)if(typeof ze=="number")pe.push({column:b.clampedInt(ze,0,0,1e4),color:null});else if(ze&&typeof ze=="object"){const Be=ze;pe.push({column:b.clampedInt(Be.column,0,0,1e4),color:Be.color})}return pe.sort((ze,Be)=>ze.column-Be.column),pe}return this.defaultValue}}function k(G,X){if(typeof G!="string")return X;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends T{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(91,null),n.localize(92,null),n.localize(93,null)],default:"auto",description:n.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(95,null),n.localize(96,null),n.localize(97,null)],default:"auto",description:n.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:n.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:n.localize(101,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X,ze=b.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=b.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:k(pe.vertical,this.defaultValue.vertical),horizontal:k(pe.horizontal,this.defaultValue.horizontal),useShadows:t(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ze,horizontalSliderSize:b.clampedInt(pe.horizontalSliderSize,ze,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:b.clampedInt(pe.verticalSliderSize,Be,0,1e3),scrollByPage:t(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends T{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:n.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:n.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:n.localize(108,null)}})}applyUpdate(X,pe){let ze=!1;pe.allowedCharacters&&X&&(E.equals(X.allowedCharacters,pe.allowedCharacters)||(X={...X,allowedCharacters:pe.allowedCharacters},ze=!0)),pe.allowedLocales&&X&&(E.equals(X.allowedLocales,pe.allowedLocales)||(X={...X,allowedLocales:pe.allowedLocales},ze=!0));const Be=super.applyUpdate(X,pe);return ze?new m(Be.newValue,!0):Be}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{nonBasicASCII:Ie(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ie(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ie(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,pe){if(typeof X!="object"||!X)return pe;const ze={};for(const[Be,Qe]of Object.entries(X))Qe===!0&&(ze[Be]=!0);return ze}}class V extends T{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:n.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[n.localize(110,null),n.localize(111,null)],description:n.localize(112,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),mode:i(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class ee extends T{constructor(){const X={enabled:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:n.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:n.localize(114,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:t(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class fe extends T{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(115,null),n.localize(116,null),n.localize(117,null)],default:X.bracketPairs,description:n.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(119,null),n.localize(120,null),n.localize(121,null)],default:X.bracketPairsHorizontal,description:n.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:n.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:n.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(125,null),n.localize(126,null),n.localize(127,null)],default:X.highlightActiveIndentation,description:n.localize(128,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{bracketPairs:Ie(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ie(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ie(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ie(G,X,pe){const ze=pe.indexOf(G);return ze===-1?X:pe[ze]}class le extends T{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(129,null),n.localize(130,null)],default:X.insertMode,description:n.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:n.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:n.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:n.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(135,null),n.localize(136,null),n.localize(137,null),n.localize(138,null)],default:X.selectionMode,markdownDescription:n.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:n.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:n.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:n.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:n.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:n.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(176,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertMode:i(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(pe.showIcons,this.defaultValue.showIcons),showStatusBar:t(pe.showStatusBar,this.defaultValue.showStatusBar),preview:t(pe.preview,this.defaultValue.preview),previewMode:i(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(pe.showMethods,this.defaultValue.showMethods),showFunctions:t(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:t(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(pe.showFields,this.defaultValue.showFields),showVariables:t(pe.showVariables,this.defaultValue.showVariables),showClasses:t(pe.showClasses,this.defaultValue.showClasses),showStructs:t(pe.showStructs,this.defaultValue.showStructs),showInterfaces:t(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:t(pe.showModules,this.defaultValue.showModules),showProperties:t(pe.showProperties,this.defaultValue.showProperties),showEvents:t(pe.showEvents,this.defaultValue.showEvents),showOperators:t(pe.showOperators,this.defaultValue.showOperators),showUnits:t(pe.showUnits,this.defaultValue.showUnits),showValues:t(pe.showValues,this.defaultValue.showValues),showConstants:t(pe.showConstants,this.defaultValue.showConstants),showEnums:t(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:t(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(pe.showKeywords,this.defaultValue.showKeywords),showWords:t(pe.showWords,this.defaultValue.showWords),showColors:t(pe.showColors,this.defaultValue.showColors),showFiles:t(pe.showFiles,this.defaultValue.showFiles),showReferences:t(pe.showReferences,this.defaultValue.showReferences),showFolders:t(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:t(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(pe.showSnippets,this.defaultValue.showSnippets),showUsers:t(pe.showUsers,this.defaultValue.showUsers),showIssues:t(pe.showIssues,this.defaultValue.showIssues)}}}class ve extends T{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(177,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var Ee;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Ee=e.WrappingIndent||(e.WrappingIndent={}));class We extends T{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(178,null),n.localize(179,null),n.localize(180,null),n.localize(181,null)],description:n.localize(182,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,pe,ze){return pe.get(2)===2?0:ze}}class je extends f{constructor(){super(139)}compute(X,pe,ze){const Be=pe.get(138);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}class it extends T{constructor(){const X={enabled:!0};super(33,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:n.localize(183,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:t(X.enabled,this.defaultValue.enabled)}}}const Ge="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?tt:A.isLinux?nt:Ge,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(G){return e.editorOptionsRegistry[G.id]=G,G}var rt;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.colorDecoratorsLimit=18]="colorDecoratorsLimit",G[G.columnSelection=19]="columnSelection",G[G.comments=20]="comments",G[G.contextmenu=21]="contextmenu",G[G.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",G[G.cursorBlinking=23]="cursorBlinking",G[G.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",G[G.cursorStyle=25]="cursorStyle",G[G.cursorSurroundingLines=26]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",G[G.cursorWidth=28]="cursorWidth",G[G.disableLayerHinting=29]="disableLayerHinting",G[G.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",G[G.domReadOnly=31]="domReadOnly",G[G.dragAndDrop=32]="dragAndDrop",G[G.dropIntoEditor=33]="dropIntoEditor",G[G.emptySelectionClipboard=34]="emptySelectionClipboard",G[G.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",G[G.extraEditorClassName=36]="extraEditorClassName",G[G.fastScrollSensitivity=37]="fastScrollSensitivity",G[G.find=38]="find",G[G.fixedOverflowWidgets=39]="fixedOverflowWidgets",G[G.folding=40]="folding",G[G.foldingStrategy=41]="foldingStrategy",G[G.foldingHighlight=42]="foldingHighlight",G[G.foldingImportsByDefault=43]="foldingImportsByDefault",G[G.foldingMaximumRegions=44]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=46]="fontFamily",G[G.fontInfo=47]="fontInfo",G[G.fontLigatures=48]="fontLigatures",G[G.fontSize=49]="fontSize",G[G.fontWeight=50]="fontWeight",G[G.fontVariations=51]="fontVariations",G[G.formatOnPaste=52]="formatOnPaste",G[G.formatOnType=53]="formatOnType",G[G.glyphMargin=54]="glyphMargin",G[G.gotoLocation=55]="gotoLocation",G[G.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",G[G.hover=57]="hover",G[G.inDiffEditor=58]="inDiffEditor",G[G.inlineSuggest=59]="inlineSuggest",G[G.letterSpacing=60]="letterSpacing",G[G.lightbulb=61]="lightbulb",G[G.lineDecorationsWidth=62]="lineDecorationsWidth",G[G.lineHeight=63]="lineHeight",G[G.lineNumbers=64]="lineNumbers",G[G.lineNumbersMinChars=65]="lineNumbersMinChars",G[G.linkedEditing=66]="linkedEditing",G[G.links=67]="links",G[G.matchBrackets=68]="matchBrackets",G[G.minimap=69]="minimap",G[G.mouseStyle=70]="mouseStyle",G[G.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=72]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",G[G.multiCursorModifier=74]="multiCursorModifier",G[G.multiCursorPaste=75]="multiCursorPaste",G[G.multiCursorLimit=76]="multiCursorLimit",G[G.occurrencesHighlight=77]="occurrencesHighlight",G[G.overviewRulerBorder=78]="overviewRulerBorder",G[G.overviewRulerLanes=79]="overviewRulerLanes",G[G.padding=80]="padding",G[G.parameterHints=81]="parameterHints",G[G.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",G[G.quickSuggestions=84]="quickSuggestions",G[G.quickSuggestionsDelay=85]="quickSuggestionsDelay",G[G.readOnly=86]="readOnly",G[G.renameOnType=87]="renameOnType",G[G.renderControlCharacters=88]="renderControlCharacters",G[G.renderFinalNewline=89]="renderFinalNewline",G[G.renderLineHighlight=90]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=92]="renderValidationDecorations",G[G.renderWhitespace=93]="renderWhitespace",G[G.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",G[G.roundedSelection=95]="roundedSelection",G[G.rulers=96]="rulers",G[G.scrollbar=97]="scrollbar",G[G.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=99]="scrollBeyondLastLine",G[G.scrollPredominantAxis=100]="scrollPredominantAxis",G[G.selectionClipboard=101]="selectionClipboard",G[G.selectionHighlight=102]="selectionHighlight",G[G.selectOnLineNumbers=103]="selectOnLineNumbers",G[G.showFoldingControls=104]="showFoldingControls",G[G.showUnused=105]="showUnused",G[G.snippetSuggestions=106]="snippetSuggestions",G[G.smartSelect=107]="smartSelect",G[G.smoothScrolling=108]="smoothScrolling",G[G.stickyScroll=109]="stickyScroll",G[G.stickyTabStops=110]="stickyTabStops",G[G.stopRenderingLineAfter=111]="stopRenderingLineAfter",G[G.suggest=112]="suggest",G[G.suggestFontSize=113]="suggestFontSize",G[G.suggestLineHeight=114]="suggestLineHeight",G[G.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",G[G.suggestSelection=116]="suggestSelection",G[G.tabCompletion=117]="tabCompletion",G[G.tabIndex=118]="tabIndex",G[G.unicodeHighlighting=119]="unicodeHighlighting",G[G.unusualLineTerminators=120]="unusualLineTerminators",G[G.useShadowDOM=121]="useShadowDOM",G[G.useTabStops=122]="useTabStops",G[G.wordBreak=123]="wordBreak",G[G.wordSeparators=124]="wordSeparators",G[G.wordWrap=125]="wordWrap",G[G.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=128]="wordWrapColumn",G[G.wordWrapOverride1=129]="wordWrapOverride1",G[G.wordWrapOverride2=130]="wordWrapOverride2",G[G.wrappingIndent=131]="wrappingIndent",G[G.wrappingStrategy=132]="wrappingStrategy",G[G.showDeprecated=133]="showDeprecated",G[G.inlayHints=134]="inlayHints",G[G.editorClassName=135]="editorClassName",G[G.pixelRatio=136]="pixelRatio",G[G.tabFocusMode=137]="tabFocusMode",G[G.layoutInfo=138]="layoutInfo",G[G.wrappingInfo=139]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(184,null)})),acceptSuggestionOnEnter:Ne(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(185,null),""],markdownDescription:n.localize(186,null)})),accessibilitySupport:Ne(new o),accessibilityPageSize:Ne(new b(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(187,null),tags:["accessibility"]})),ariaLabel:Ne(new v(4,"ariaLabel",n.localize(188,null))),autoClosingBrackets:Ne(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(189,null),n.localize(190,null),""],description:n.localize(191,null)})),autoClosingDelete:Ne(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(192,null),""],description:n.localize(193,null)})),autoClosingOvertype:Ne(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(194,null),""],description:n.localize(195,null)})),autoClosingQuotes:Ne(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(196,null),n.localize(197,null),""],description:n.localize(198,null)})),autoIndent:Ne(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[n.localize(199,null),n.localize(200,null),n.localize(201,null),n.localize(202,null),n.localize(203,null)],description:n.localize(204,null)})),automaticLayout:Ne(new a(10,"automaticLayout",!1)),autoSurround:Ne(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(205,null),n.localize(206,null),n.localize(207,null),""],description:n.localize(208,null)})),bracketPairColorization:Ne(new ee),bracketPairGuides:Ne(new fe),stickyTabStops:Ne(new a(110,"stickyTabStops",!1,{description:n.localize(209,null)})),codeLens:Ne(new a(14,"codeLens",!0,{description:n.localize(210,null)})),codeLensFontFamily:Ne(new v(15,"codeLensFontFamily","",{description:n.localize(211,null)})),codeLensFontSize:Ne(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(212,null)})),colorDecorators:Ne(new a(17,"colorDecorators",!0,{description:n.localize(213,null)})),colorDecoratorsLimit:Ne(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(214,null)})),columnSelection:Ne(new a(19,"columnSelection",!1,{description:n.localize(215,null)})),comments:Ne(new I),contextmenu:Ne(new a(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new a(22,"copyWithSyntaxHighlighting",!0,{description:n.localize(216,null)})),cursorBlinking:Ne(new s(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:n.localize(217,null)})),cursorSmoothCaretAnimation:Ne(new d(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(218,null),n.localize(219,null),n.localize(220,null)],description:n.localize(221,null)})),cursorStyle:Ne(new s(25,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:n.localize(222,null)})),cursorSurroundingLines:Ne(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(223,null)})),cursorSurroundingLinesStyle:Ne(new d(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(224,null),n.localize(225,null)],description:n.localize(226,null)})),cursorWidth:Ne(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(227,null)})),disableLayerHinting:Ne(new a(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new a(30,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new a(31,"domReadOnly",!1)),dragAndDrop:Ne(new a(32,"dragAndDrop",!0,{description:n.localize(228,null)})),emptySelectionClipboard:Ne(new K),dropIntoEditor:Ne(new it),stickyScroll:Ne(new De),experimentalWhitespaceRendering:Ne(new d(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(229,null),n.localize(230,null),n.localize(231,null)],description:n.localize(232,null)})),extraEditorClassName:Ne(new v(36,"extraEditorClassName","")),fastScrollSensitivity:Ne(new R(37,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:n.localize(233,null)})),find:Ne(new Q),fixedOverflowWidgets:Ne(new a(39,"fixedOverflowWidgets",!1)),folding:Ne(new a(40,"folding",!0,{description:n.localize(234,null)})),foldingStrategy:Ne(new d(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(235,null),n.localize(236,null)],description:n.localize(237,null)})),foldingHighlight:Ne(new a(42,"foldingHighlight",!0,{description:n.localize(238,null)})),foldingImportsByDefault:Ne(new a(43,"foldingImportsByDefault",!1,{description:n.localize(239,null)})),foldingMaximumRegions:Ne(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(240,null)})),unfoldOnClickAfterEndOfLine:Ne(new a(45,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(241,null)})),fontFamily:Ne(new v(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(242,null)})),fontInfo:Ne(new L),fontLigatures2:Ne(new _),fontSize:Ne(new g),fontWeight:Ne(new F),fontVariations:Ne(new j),formatOnPaste:Ne(new a(52,"formatOnPaste",!1,{description:n.localize(243,null)})),formatOnType:Ne(new a(53,"formatOnType",!1,{description:n.localize(244,null)})),glyphMargin:Ne(new a(54,"glyphMargin",!0,{description:n.localize(245,null)})),gotoLocation:Ne(new B),hideCursorInOverviewRuler:Ne(new a(56,"hideCursorInOverviewRuler",!1,{description:n.localize(246,null)})),hover:Ne(new Y),inDiffEditor:Ne(new a(58,"inDiffEditor",!1)),letterSpacing:Ne(new R(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>R.clamp(G,-5,20),{description:n.localize(247,null)})),lightbulb:Ne(new ue),lineDecorationsWidth:Ne(new ie),lineHeight:Ne(new q),lineNumbers:Ne(new oe),lineNumbersMinChars:Ne(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new a(66,"linkedEditing",!1,{description:n.localize(248,null)})),links:Ne(new a(67,"links",!0,{description:n.localize(249,null)})),matchBrackets:Ne(new d(68,"matchBrackets","always",["always","near","never"],{description:n.localize(250,null)})),minimap:Ne(new ce),mouseStyle:Ne(new d(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new R(71,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:n.localize(251,null)})),mouseWheelZoom:Ne(new a(72,"mouseWheelZoom",!1,{markdownDescription:n.localize(252,null)})),multiCursorMergeOverlapping:Ne(new a(73,"multiCursorMergeOverlapping",!0,{description:n.localize(253,null)})),multiCursorModifier:Ne(new s(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],be,{markdownEnumDescriptions:[n.localize(254,null),n.localize(255,null)],markdownDescription:n.localize(256,null)})),multiCursorPaste:Ne(new d(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(257,null),n.localize(258,null)],markdownDescription:n.localize(259,null)})),multiCursorLimit:Ne(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(260,null)})),occurrencesHighlight:Ne(new a(77,"occurrencesHighlight",!0,{description:n.localize(261,null)})),overviewRulerBorder:Ne(new a(78,"overviewRulerBorder",!0,{description:n.localize(262,null)})),overviewRulerLanes:Ne(new b(79,"overviewRulerLanes",3,0,3)),padding:Ne(new Ae),parameterHints:Ne(new Ue),peekWidgetDefaultFocus:Ne(new d(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(263,null),n.localize(264,null)],description:n.localize(265,null)})),definitionLinkOpensInPeek:Ne(new a(83,"definitionLinkOpensInPeek",!1,{description:n.localize(266,null)})),quickSuggestions:Ne(new Se),quickSuggestionsDelay:Ne(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(267,null)})),readOnly:Ne(new a(86,"readOnly",!1)),renameOnType:Ne(new a(87,"renameOnType",!1,{description:n.localize(268,null),markdownDeprecationMessage:n.localize(269,null)})),renderControlCharacters:Ne(new a(88,"renderControlCharacters",!0,{description:n.localize(270,null),restricted:!0})),renderFinalNewline:Ne(new d(89,"renderFinalNewline",A.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(271,null)})),renderLineHighlight:Ne(new d(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(272,null)],description:n.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Ne(new a(91,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(274,null)})),renderValidationDecorations:Ne(new d(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new d(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(275,null),n.localize(276,null),n.localize(277,null),""],description:n.localize(278,null)})),revealHorizontalRightPadding:Ne(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new a(95,"roundedSelection",!0,{description:n.localize(279,null)})),rulers:Ne(new J),scrollbar:Ne(new $),scrollBeyondLastColumn:Ne(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(280,null)})),scrollBeyondLastLine:Ne(new a(99,"scrollBeyondLastLine",!0,{description:n.localize(281,null)})),scrollPredominantAxis:Ne(new a(100,"scrollPredominantAxis",!0,{description:n.localize(282,null)})),selectionClipboard:Ne(new a(101,"selectionClipboard",!0,{description:n.localize(283,null),included:A.isLinux})),selectionHighlight:Ne(new a(102,"selectionHighlight",!0,{description:n.localize(284,null)})),selectOnLineNumbers:Ne(new a(103,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new d(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(285,null),n.localize(286,null),n.localize(287,null)],description:n.localize(288,null)})),showUnused:Ne(new a(105,"showUnused",!0,{description:n.localize(289,null)})),showDeprecated:Ne(new a(133,"showDeprecated",!0,{description:n.localize(290,null)})),inlayHints:Ne(new de),snippetSuggestions:Ne(new d(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(291,null),n.localize(292,null),n.localize(293,null),n.localize(294,null)],description:n.localize(295,null)})),smartSelect:Ne(new ve),smoothScrolling:Ne(new a(108,"smoothScrolling",!1,{description:n.localize(296,null)})),stopRenderingLineAfter:Ne(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new le),inlineSuggest:Ne(new V),suggestFontSize:Ne(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new a(115,"suggestOnTriggerCharacters",!0,{description:n.localize(299,null)})),suggestSelection:Ne(new d(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(300,null),n.localize(301,null),n.localize(302,null)],description:n.localize(303,null)})),tabCompletion:Ne(new d(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(304,null),n.localize(305,null),n.localize(306,null)],description:n.localize(307,null)})),tabIndex:Ne(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new W),unusualLineTerminators:Ne(new d(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(308,null),n.localize(309,null),n.localize(310,null)],description:n.localize(311,null)})),useShadowDOM:Ne(new a(121,"useShadowDOM",!0)),useTabStops:Ne(new a(122,"useTabStops",!0,{description:n.localize(312,null)})),wordBreak:Ne(new d(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(313,null),n.localize(314,null)],description:n.localize(315,null)})),wordSeparators:Ne(new v(124,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:n.localize(316,null)})),wordWrap:Ne(new d(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(317,null),n.localize(318,null),n.localize(319,null),n.localize(320,null)],description:n.localize(321,null)})),wordWrapBreakAfterCharacters:Ne(new v(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new v(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(322,null)})),wordWrapOverride1:Ne(new d(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new d(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new H),pixelRatio:Ne(new Ce),tabFocusMode:Ne(new a(137,"tabFocusMode",!1,{markdownDescription:n.localize(323,null)})),layoutInfo:Ne(new Z),wrappingInfo:Ne(new je),wrappingIndent:Ne(new We),wrappingStrategy:Ne(new se)}}),define(Te[133],Pe([13,14]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Te[134],Pe([13,14]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Te[135],Pe([13,14]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Te[136],Pe([13,14]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Te[137],Pe([13,14]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Te[138],Pe([13,14]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Te[139],Pe([13,14]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Te[140],Pe([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Te[141],Pe([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Te[142],Pe([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Te[143],Pe([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Te[144],Pe([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Te[145],Pe([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Te[146],Pe([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Te[147],Pe([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Te[148],Pe([13,14]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Te[149],Pe([13,14]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Te[150],Pe([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Te[151],Pe([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Te[152],Pe([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Te[153],Pe([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Te[154],Pe([13,14]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Te[155],Pe([13,14]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Te[156],Pe([13,14]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Te[157],Pe([1,0,11]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var A;(function(N){N[N.LParen=0]="LParen",N[N.RParen=1]="RParen",N[N.Neg=2]="Neg",N[N.Eq=3]="Eq",N[N.NotEq=4]="NotEq",N[N.Lt=5]="Lt",N[N.LtEq=6]="LtEq",N[N.Gt=7]="Gt",N[N.GtEq=8]="GtEq",N[N.RegexOp=9]="RegexOp",N[N.RegexStr=10]="RegexStr",N[N.True=11]="True",N[N.False=12]="False",N[N.In=13]="In",N[N.Not=14]="Not",N[N.And=15]="And",N[N.Or=16]="Or",N[N.Str=17]="Str",N[N.QuotedStr=18]="QuotedStr",N[N.Error=19]="Error",N[N.EOF=20]="EOF"})(A=e.TokenType||(e.TokenType={}));class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(E){if(E.type!==19)throw(0,n.illegalArgument)(`expected an error token but got ${JSON.stringify(E)}`);switch(E.lexeme){case"=":return`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you mean '||'?`;default:{const O=E.lexeme;return O&&O.length>1&&O.startsWith("'")?`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you forget to close the string?`:O&&O.length>1&&O.endsWith("'")?`Unexpected token '${E.lexeme}' at offset ${E.offset}. Did you forget to open the string?`:`Unexpected token '${E.lexeme}' at offset ${E.offset}`}}}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,n.illegalState)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}get errorTokens(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:this.k(this.h(61)?4:2);break;case 39:this.o();break;case 47:this.q();break;case 61:this.h(61)?this.k(3):this.h(126)?this.k(9):this.l();break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l();break;case 124:this.h(124)?this.k(16):this.l();break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(){const E={type:19,offset:this.d,lexeme:this.c.substring(this.d,this.e)};this.g.push(E),this.f.push(E)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const O=this.c.substring(this.d,this.e),S=D.b.get(O);S?this.k(S):this.f.push({type:17,lexeme:O,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l();return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,O=!1,S=!1;for(;;){if(E>=this.c.length){this.e=E,this.l();return}const M=this.c.charCodeAt(E);if(O)O=!1;else if(M===47&&!S){E++;break}else M===91?S=!0:M===92?O=!0:M===93&&(S=!1);E++}for(;E<this.c.length&&D.a.has(this.c.charCodeAt(E));)E++;this.e=E;const P=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:P,offset:this.d})}r(){return this.e>=this.c.length}}D.a=new Set(["i","g","s","m","y","u"].map(N=>N.charCodeAt(0))),D.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=D}),define(Te[158],Pe([1,0,22,29,135,258]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const E=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,O=/^-(\d{4})(\d{2})(\d{2})$/;function S(a){return a=a.trim(),a==="*"||E.test(a)}e.isValidVersionStr=S;function P(a){if(!S(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=a.match(E);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=P;function M(a){if(!a)return null;const p=a.majorBase,b=a.majorMustEqual,R=a.minorBase;let v=a.minorMustEqual;const i=a.patchBase;let d=a.patchMustEqual;a.hasCaret&&(p===0||(v=!1),d=!1);let s=0;if(a.preRelease){const l=O.exec(a.preRelease);if(l){const[,o,I,r]=l;s=Date.UTC(Number(o),Number(I)-1,Number(r))}}return{majorBase:p,majorMustEqual:b,minorBase:R,minorMustEqual:v,patchBase:i,patchMustEqual:d,isMinimum:a.hasGreaterEquals,notBefore:s}}e.normalizeVersion=M;function T(a,p,b){let R;typeof a=="string"?R=M(P(a)):R=a;let v;p instanceof Date?v=p.getTime():typeof p=="string"&&(v=new Date(p).getTime());let i;if(typeof b=="string"?i=M(P(b)):i=b,!R||!i)return!1;const d=R.majorBase,s=R.minorBase,l=R.patchBase;let o=i.majorBase,I=i.minorBase,r=i.patchBase;const c=i.notBefore;let h=i.majorMustEqual,y=i.minorMustEqual,C=i.patchMustEqual;return i.isMinimum?d>o?!0:d<o?!1:s>I?!0:s<I||v&&v<c?!1:l>=r:(d===1&&o===0&&(!h||!y||!C)&&(o=1,I=0,r=0,h=!0,y=!1,C=!1),d<o?!1:d>o?!h:s<I?!1:s>I?!y:l<r?!1:l>r?!C:!(v&&v<c))}e.isValidVersion=T;function m(a,p,b,R,v){const i=[];if(typeof R.publisher<"u"&&typeof R.publisher!="string")return i.push([A.default.Error,D.localize(0,null)]),i;if(typeof R.name!="string")return i.push([A.default.Error,D.localize(1,null,"name")]),i;if(typeof R.version!="string")return i.push([A.default.Error,D.localize(2,null,"version")]),i;if(!R.engines)return i.push([A.default.Error,D.localize(3,null,"engines")]),i;if(typeof R.engines.vscode!="string")return i.push([A.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof R.extensionDependencies<"u"&&!t(R.extensionDependencies))return i.push([A.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof R.activationEvents<"u"){if(!t(R.activationEvents))return i.push([A.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof R.main>"u"&&typeof R.browser>"u")return i.push([A.default.Error,D.localize(7,null,"activationEvents","main")]),i}if(typeof R.extensionKind<"u"&&typeof R.main>"u"&&i.push([A.default.Warning,D.localize(8,null,"extensionKind")]),typeof R.main<"u"){if(typeof R.main!="string")return i.push([A.default.Error,D.localize(9,null,"main")]),i;{const l=(0,n.joinPath)(b,R.main);(0,n.isEqualOrParent)(l,b)||i.push([A.default.Warning,D.localize(10,null,l.path,b.path)])}if(typeof R.activationEvents>"u")return i.push([A.default.Error,D.localize(11,null,"activationEvents","main")]),i}if(typeof R.browser<"u"){if(typeof R.browser!="string")return i.push([A.default.Error,D.localize(12,null,"browser")]),i;{const l=(0,n.joinPath)(b,R.browser);(0,n.isEqualOrParent)(l,b)||i.push([A.default.Warning,D.localize(13,null,l.path,b.path)])}if(typeof R.activationEvents>"u")return i.push([A.default.Error,D.localize(14,null,"activationEvents","browser")]),i}if(!N.valid(R.version))return i.push([A.default.Error,D.localize(15,null)]),i;const d=[];if(!w(a,p,R,v,d))for(const l of d)i.push([A.default.Error,l]);return i}e.validateExtensionManifest=m;function w(a,p,b,R,v){return R||typeof b.main>"u"&&typeof b.browser>"u"?!0:u(a,p,b.engines.vscode,v)}e.isValidExtensionVersion=w;function f(a,p,b){return a==="*"||u(p,b,a)}e.isEngineValid=f;function u(a,p,b,R=[]){const v=M(P(b));if(!v)return R.push(D.localize(16,null,b)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return R.push(D.localize(17,null,b)),!1}else if(!v.majorMustEqual)return R.push(D.localize(18,null,b)),!1;return T(a,p,v)?!0:(R.push(D.localize(19,null,a,b)),!1)}function t(a){if(!Array.isArray(a))return!1;for(let p=0,b=a.length;p<b;p++)if(typeof a[p]!="string")return!1;return!0}}),define(Te[89],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(D,N=[],E=!1){this.ctor=D,this.staticArguments=N,this.supportsDelayedInstantiation=E}}e.SyncDescriptor=n}),define(Te[67],Pe([1,0,89]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var D;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function N(O,S,P){S instanceof n.SyncDescriptor||(S=new n.SyncDescriptor(S,[],Boolean(P))),A.push([O,S])}e.registerSingleton=N;function E(){return A}e.getSingletonServiceDescriptors=E}),define(Te[159],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(N,E){this.key=N,this.data=E,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class A{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const E of this.a.values())E.outgoing.size===0&&N.push(E);return N}insertEdge(N,E){const O=this.lookupOrInsertNode(N),S=this.lookupOrInsertNode(E);O.outgoing.set(S.key,S),S.incoming.set(O.key,O)}removeNode(N){const E=this.b(N);this.a.delete(E);for(const O of this.a.values())O.outgoing.delete(E),O.incoming.delete(E)}lookupOrInsertNode(N){const E=this.b(N);let O=this.a.get(E);return O||(O=new n(E,N),this.a.set(E,O)),O}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[E,O]of this.a)N.push(`${E}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,E]of this.a){const O=new Set([N]),S=this.c(E,O);if(S)return S}}c(N,E){for(const[O,S]of N.outgoing){if(E.has(O))return[...E,O].join(" -> ");E.add(O);const P=this.c(S,E);if(P)return P;E.delete(O)}}}e.Graph=A}),define(Te[3],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(E){E.serviceIds=new Map,E.DI_TARGET="$di$target",E.DI_DEPENDENCIES="$di$dependencies";function O(S){return S[E.DI_DEPENDENCIES]||[]}E.getServiceDependencies=O})(n=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function A(E,O,S){O[n.DI_TARGET]===O?O[n.DI_DEPENDENCIES].push({id:E,index:S}):(O[n.DI_DEPENDENCIES]=[{id:E,index:S}],O[n.DI_TARGET]=O)}function D(E){if(n.serviceIds.has(E))return n.serviceIds.get(E);const O=function(S,P,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(O,S,M)};return O.toString=()=>E,n.serviceIds.set(E,O),O}e.createDecorator=D;function N(E){return E}e.refineServiceDecorator=N}),define(Te[42],Pe([1,0,9,2,3]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function N(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof A.URI)}e.isConfigurationOverrides=N;function E(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=E;var O;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(O=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function P(t,a){const p=Object.create(null);for(const b in t)M(p,b,t[b],a);return p}e.toValuesTree=P;function M(t,a,p,b){const R=a.split("."),v=R.pop();let i=t;for(let d=0;d<R.length;d++){const s=R[d];let l=i[s];switch(typeof l){case"undefined":l=i[s]=Object.create(null);break;case"object":break;default:b(`Ignoring ${a} as ${R.slice(0,d+1).join(".")} is ${JSON.stringify(l)}`);return}i=l}if(typeof i=="object"&&i!==null)try{i[v]=p}catch{b(`Ignoring ${a} as ${R.join(".")} is ${JSON.stringify(i)}`)}else b(`Ignoring ${a} as ${R.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=M;function T(t,a){const p=a.split(".");m(t,p)}e.removeFromValueTree=T;function m(t,a){const p=a.shift();if(a.length===0){delete t[p];return}if(Object.keys(t).indexOf(p)!==-1){const b=t[p];typeof b=="object"&&!Array.isArray(b)&&(m(b,a),Object.keys(b).length===0&&delete t[p])}}function w(t,a,p){function b(i,d){let s=i;for(const l of d){if(typeof s!="object"||s===null)return;s=s[l]}return s}const R=a.split("."),v=b(t,R);return typeof v>"u"?p:v}e.getConfigurationValue=w;function f(t,a,p){Object.keys(a).forEach(b=>{b!=="__proto__"&&(b in t?n.isObject(t[b])&&n.isObject(a[b])?f(t[b],a[b],p):p&&(t[b]=a[b]):t[b]=a[b])})}e.merge=f;function u(t){return t.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=u}),define(Te[36],Pe([1,0,20,10,157,3]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",n.isMacintosh),E.set("isLinux",n.isLinux),E.set("isWindows",n.isWindows),E.set("isWeb",n.isWeb),E.set("isMacNative",n.isMacintosh&&!n.isWeb),E.set("isEdge",n.isEdge),E.set("isFirefox",n.isFirefox),E.set("isChrome",n.isChrome),E.set("isSafari",n.isSafari);const O=Object.prototype.hasOwnProperty;var S;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return f.INSTANCE}static true(){return u.INSTANCE}static has(g){return t.create(g)}static equals(g,F){return a.create(g,F)}static notEquals(g,F){return R.create(g,F)}static regex(g,F){return I.create(g,F)}static in(g,F){return p.create(g,F)}static notIn(g,F){return b.create(g,F)}static not(g){return v.create(g)}static and(...g){return h.create(g,null,!0)}static or(...g){return y.create(g,null,!0)}static greater(g,F){return d.create(g,F)}static greaterEquals(g,F){return s.create(g,F)}static smaller(g,F){return l.create(g,F)}static smallerEquals(g,F){return o.create(g,F)}static deserializeOrErrorNew(g){if(!g)return{type:"error",lexingErrors:[],parsingErrors:[]};const F=new T,B=F.parse(g);return B===void 0?{type:"error",lexingErrors:F.lexingErrors.map(Y=>D.Scanner.reportError(Y)),parsingErrors:F.parsingErrors}:{type:"ok",expr:B}}static deserialize(g){if(!!g)return this.c(g)}static c(g){const F=g.split("||");return y.create(F.map(B=>this.d(B)),null,!0)}static d(g){const F=g.split("&&");return h.create(F.map(B=>this.f(B)),null,!0)}static f(g){if(g=g.trim(),g.indexOf("!=")>=0){const F=g.split("!=");return R.create(F[0].trim(),this.g(F[1]))}if(g.indexOf("==")>=0){const F=g.split("==");return a.create(F[0].trim(),this.g(F[1]))}if(g.indexOf("=~")>=0){const F=g.split("=~");return I.create(F[0].trim(),this.h(F[1]))}if(g.indexOf(" not in ")>=0){const F=g.split(" not in ");return b.create(F[0].trim(),this.g(F[1]))}if(g.indexOf(" in ")>=0){const F=g.split(" in ");return p.create(F[0].trim(),this.g(F[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(g)){const F=g.split(">=");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(g)){const F=g.split(">");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(g)){const F=g.split("<=");return o.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(g)){const F=g.split("<");return l.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(g)?v.create(g.substr(1).trim()):t.create(g)}static g(g){if(g=g.trim(),g==="true")return!0;if(g==="false")return!1;const F=/^'([^']*)'$/.exec(g);return F?F[1].trim():g}static h(g){if((0,A.isFalsyOrWhitespace)(g))return null;const F=g.indexOf("/"),B=g.lastIndexOf("/");if(F===B||F<0)return null;const Y=g.slice(F+1,B),me=g[B+1]==="i"?"i":"";try{return new RegExp(Y,me)}catch{return null}}}e.ContextKeyExpr=P;class M extends Error{}class T{constructor(){this.c=new D.Scanner,this.d=[],this.f=0,this.g=[]}get lexingErrors(){return this.c.errorTokens}get parsingErrors(){return this.g}parse(g){if(g===""){this.g.push("Expected an expression but got an empty string");return}this.d=this.c.reset(g).scan(),this.f=0,this.g=[];try{const F=this.h();if(!this.D())throw this.z(this.C());return F}catch(F){if(!(F instanceof M)){const B=this.C();this.g.push(`Unexpected error: ${F} for token ${D.Scanner.getLexeme(B)} at offset ${B.offset}.`)}return}}h(){return this.k()}k(){const g=[this.l()];for(;this.v(16);){const F=this.l();g.push(F)}return g.length===1?g[0]:P.or(...g)}l(){const g=[this.o()];for(;this.v(15);){const F=this.o();g.push(F)}return g.length===1?g[0]:P.and(...g)}o(){if(this.v(2)){const g=this.C();switch(g.type){case 17:return this.w(),P.not(g.lexeme);case 11:return this.w(),P.false();case 12:return this.w(),P.true();default:throw this.y("KEY, 'true', or 'false'",g)}}return this.s()}s(){const g=this.C();switch(g.type){case 11:return this.w(),P.true();case 12:return this.w(),P.false();case 0:{this.w();const F=this.h();return this.x(1,"')'"),F}case 17:{const F=g.lexeme;if(this.w(),this.v(9)){const Y=this.C();switch(Y.type){case 10:case 19:{const me=[Y.lexeme];this.w();let Z=this.C(),se=0;for(let q=0;q<Y.lexeme.length;q++)Y.lexeme.charCodeAt(q)===40?se++:Y.lexeme.charCodeAt(q)===41&&se--;for(;!this.D()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:se++;break;case 1:se--;break;case 10:case 18:for(let q=0;q<Z.lexeme.length;q++)Z.lexeme.charCodeAt(q)===40?se++:Y.lexeme.charCodeAt(q)===41&&se--}if(se<0)break;me.push(D.Scanner.getLexeme(Z)),this.w(),Z=this.C()}const ue=me.join(""),De=ue.lastIndexOf("/"),de=De===ue.length-1?void 0:ue.substring(De+1),ie=new RegExp(ue.substring(1,De),de);return P.regex(F,ie)}case 18:{const me=Y.lexeme;this.w();let Z=null;if(!(0,A.isFalsyOrWhitespace)(me)){const se=me.indexOf("/"),ue=me.lastIndexOf("/");if(se!==ue&&se>=0){const De=me.slice(se+1,ue),de=me[ue+1]==="i"?"i":"";try{Z=new RegExp(De,de)}catch{}}}if(Z===null)throw this.y("REGEX",Y);return I.create(F,Z)}default:throw this.y("REGEX",this.C())}}if(this.v(14)){this.x(13,"'in' after 'not'");const Y=this.t();return P.notIn(F,Y)}switch(this.C().type){case 3:{this.w();const Y=this.t();switch(Y){case"true":return P.has(F);case"false":return P.not(F);default:return P.equals(F,Y)}}case 4:{this.w();const Y=this.t();switch(Y){case"true":return P.not(F);case"false":return P.has(F);default:return P.notEquals(F,Y)}}case 5:return this.w(),l.create(F,this.t());case 6:return this.w(),o.create(F,this.t());case 7:return this.w(),d.create(F,this.t());case 8:return this.w(),s.create(F,this.t());case 13:return this.w(),P.in(F,this.t());default:return P.has(F)}}default:throw this.y("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this.C())}}t(){const g=this.C();switch(g.type){case 17:case 18:return this.w(),g.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(g){return this.B(g)?(this.w(),!0):!1}w(){return this.D()||this.f++,this.u()}x(g,F){if(this.B(g))return this.w();throw this.y(F,this.C())}y(g,F){return this.A(`Expected ${g} but got '${D.Scanner.getLexeme(F)}' at offset ${F.offset}.`)}z(g){return this.A(`Unexpected '${D.Scanner.getLexeme(g)}' at offset ${g.offset}.`)}A(g){return this.g.push(g),new M}B(g){return this.C().type===g}C(){return this.d[this.f]}D(){return this.C().type===20}}e.Parser=T;function m(L,g){const F=L?L.substituteConstants():void 0,B=g?g.substituteConstants():void 0;return!F&&!B?!0:!F||!B?!1:F.equals(B)}e.expressionsAreEqualWithConstantSubstitution=m;function w(L,g){return L.cmp(g)}class f{constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return u.INSTANCE}}f.INSTANCE=new f,e.ContextKeyFalseExpr=f;class u{constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return f.INSTANCE}}u.INSTANCE=new u,e.ContextKeyTrueExpr=u;class t{static create(g,F=null){const B=E.get(g);return typeof B=="boolean"?B?u.INSTANCE:f.INSTANCE:new t(g,F)}constructor(g,F){this.key=g,this.c=F,this.type=2}cmp(g){return g.type!==this.type?this.type-g.type:H(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=E.get(this.key);return typeof g=="boolean"?g?u.INSTANCE:f.INSTANCE:this}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return this.c||(this.c=v.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=t;class a{static create(g,F,B=null){if(typeof F=="boolean")return F?t.create(g,B):v.create(g,B);const Y=E.get(g);return typeof Y=="boolean"?F===(Y?"true":"false")?u.INSTANCE:f.INSTANCE:new a(g,F,B)}constructor(g,F,B){this.c=g,this.d=F,this.f=B,this.type=4}cmp(g){return g.type!==this.type?this.type-g.type:K(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){const g=E.get(this.c);if(typeof g=="boolean"){const F=g?"true":"false";return this.d===F?u.INSTANCE:f.INSTANCE}return this}evaluate(g){return g.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(g){return g.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=a;class p{static create(g,F){return new p(g,F)}constructor(g,F){this.d=g,this.f=F,this.type=10,this.c=null}cmp(g){return g.type!==this.type?this.type-g.type:K(this.d,this.f,g.d,g.f)}equals(g){return g.type===this.type?this.d===g.d&&this.f===g.f:!1}substituteConstants(){return this}evaluate(g){const F=g.getValue(this.f),B=g.getValue(this.d);return Array.isArray(F)?F.includes(B):typeof B=="string"&&typeof F=="object"&&F!==null?O.call(F,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(g){return g.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=p;class b{static create(g,F){return new b(g,F)}constructor(g,F){this.d=g,this.f=F,this.type=11,this.c=p.create(g,F)}cmp(g){return g.type!==this.type?this.type-g.type:this.c.cmp(g.c)}equals(g){return g.type===this.type?this.c.equals(g.c):!1}substituteConstants(){return this}evaluate(g){return!this.c.evaluate(g)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(g){return g.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=b;class R{static create(g,F,B=null){if(typeof F=="boolean")return F?v.create(g,B):t.create(g,B);const Y=E.get(g);return typeof Y=="boolean"?F===(Y?"true":"false")?f.INSTANCE:u.INSTANCE:new R(g,F,B)}constructor(g,F,B){this.c=g,this.d=F,this.f=B,this.type=5}cmp(g){return g.type!==this.type?this.type-g.type:K(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){const g=E.get(this.c);if(typeof g=="boolean"){const F=g?"true":"false";return this.d===F?f.INSTANCE:u.INSTANCE}return this}evaluate(g){return g.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(g){return g.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=a.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=R;class v{static create(g,F=null){const B=E.get(g);return typeof B=="boolean"?B?f.INSTANCE:u.INSTANCE:new v(g,F)}constructor(g,F){this.c=g,this.d=F,this.type=3}cmp(g){return g.type!==this.type?this.type-g.type:H(this.c,g.c)}equals(g){return g.type===this.type?this.c===g.c:!1}substituteConstants(){const g=E.get(this.c);return typeof g=="boolean"?g?f.INSTANCE:u.INSTANCE:this}evaluate(g){return!g.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(g){return g.mapNot(this.c)}negate(){return this.d||(this.d=t.create(this.c,this)),this.d}}e.ContextKeyNotExpr=v;function i(L,g){if(typeof L=="string"){const F=parseFloat(L);isNaN(F)||(L=F)}return typeof L=="string"||typeof L=="number"?g(L):f.INSTANCE}class d{static create(g,F,B=null){return i(F,Y=>new d(g,Y,B))}constructor(g,F,B){this.c=g,this.d=F,this.f=B,this.type=12}cmp(g){return g.type!==this.type?this.type-g.type:K(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(g){return g.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=d;class s{static create(g,F,B=null){return i(F,Y=>new s(g,Y,B))}constructor(g,F,B){this.c=g,this.d=F,this.f=B,this.type=13}cmp(g){return g.type!==this.type?this.type-g.type:K(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(g){return g.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=s;class l{static create(g,F,B=null){return i(F,Y=>new l(g,Y,B))}constructor(g,F,B){this.c=g,this.d=F,this.f=B,this.type=14}cmp(g){return g.type!==this.type?this.type-g.type:K(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(g){return g.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=l;class o{static create(g,F,B=null){return i(F,Y=>new o(g,Y,B))}constructor(g,F,B){this.c=g,this.d=F,this.f=B,this.type=15}cmp(g){return g.type!==this.type?this.type-g.type:K(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(g){return g.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=o;class I{static create(g,F){return new I(g,F)}constructor(g,F){this.d=g,this.f=F,this.type=7,this.c=null}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.d<g.d)return-1;if(this.d>g.d)return 1;const F=this.f?this.f.source:"",B=g.f?g.f.source:"";return F<B?-1:F>B?1:0}equals(g){if(g.type===this.type){const F=this.f?this.f.source:"",B=g.f?g.f.source:"";return this.d===g.d&&F===B}return!1}substituteConstants(){return this}evaluate(g){const F=g.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const g=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${g}`}keys(){return[this.d]}map(g){return g.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=r.create(this)),this.c}}e.ContextKeyRegexExpr=I;class r{static create(g){return new r(g)}constructor(g){this.c=g,this.type=8}cmp(g){return g.type!==this.type?this.type-g.type:this.c.cmp(g.c)}equals(g){return g.type===this.type?this.c.equals(g.c):!1}substituteConstants(){return this}evaluate(g){return!this.c.evaluate(g)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(g){return new r(this.c.map(g))}negate(){return this.c}}e.ContextKeyNotRegexExpr=r;function c(L){let g=null;for(let F=0,B=L.length;F<B;F++){const Y=L[F].substituteConstants();if(L[F]!==Y&&g===null){g=[];for(let me=0;me<F;me++)g[me]=L[me]}g!==null&&(g[F]=Y)}return g===null?L:g}class h{static create(g,F,B){return h.d(g,F,B)}constructor(g,F){this.expr=g,this.c=F,this.type=6}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const Y=w(this.expr[F],g.expr[F]);if(Y!==0)return Y}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(g.expr[F]))return!1;return!0}return!1}substituteConstants(){const g=c(this.expr);return g===this.expr?this:h.create(g,this.c,!1)}evaluate(g){for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].evaluate(g))return!1;return!0}static d(g,F,B){const Y=[];let me=!1;for(const Z of g)if(!!Z){if(Z.type===1){me=!0;continue}if(Z.type===0)return f.INSTANCE;if(Z.type===6){Y.push(...Z.expr);continue}Y.push(Z)}if(Y.length===0&&me)return u.INSTANCE;if(Y.length!==0){if(Y.length===1)return Y[0];Y.sort(w);for(let Z=1;Z<Y.length;Z++)Y[Z-1].equals(Y[Z])&&(Y.splice(Z,1),Z--);if(Y.length===1)return Y[0];for(;Y.length>1;){const Z=Y[Y.length-1];if(Z.type!==9)break;Y.pop();const se=Y.pop(),ue=Y.length===0,De=y.create(Z.expr.map(de=>h.create([de,se],null,B)),null,ue);De&&(Y.push(De),Y.sort(w))}if(Y.length===1)return Y[0];if(B){for(let Z=0;Z<Y.length;Z++)for(let se=Z+1;se<Y.length;se++)if(Y[Z].negate().equals(Y[se]))return f.INSTANCE;if(Y.length===1)return Y[0]}return new h(Y,F)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(const F of this.expr)g.push(...F.keys());return g}map(g){return new h(this.expr.map(F=>F.map(g)),null)}negate(){if(!this.c){const g=[];for(const F of this.expr)g.push(F.negate());this.c=y.create(g,this,!0)}return this.c}}class y{static create(g,F,B){return y.d(g,F,B)}constructor(g,F){this.expr=g,this.c=F,this.type=9}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const Y=w(this.expr[F],g.expr[F]);if(Y!==0)return Y}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(g.expr[F]))return!1;return!0}return!1}substituteConstants(){const g=c(this.expr);return g===this.expr?this:y.create(g,this.c,!1)}evaluate(g){for(let F=0,B=this.expr.length;F<B;F++)if(this.expr[F].evaluate(g))return!0;return!1}static d(g,F,B){let Y=[],me=!1;if(g){for(let Z=0,se=g.length;Z<se;Z++){const ue=g[Z];if(!!ue){if(ue.type===0){me=!0;continue}if(ue.type===1)return u.INSTANCE;if(ue.type===9){Y=Y.concat(ue.expr);continue}Y.push(ue)}}if(Y.length===0&&me)return f.INSTANCE;Y.sort(w)}if(Y.length!==0){if(Y.length===1)return Y[0];for(let Z=1;Z<Y.length;Z++)Y[Z-1].equals(Y[Z])&&(Y.splice(Z,1),Z--);if(Y.length===1)return Y[0];if(B){for(let Z=0;Z<Y.length;Z++)for(let se=Z+1;se<Y.length;se++)if(Y[Z].negate().equals(Y[se]))return u.INSTANCE;if(Y.length===1)return Y[0]}return new y(Y,F)}}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(const F of this.expr)g.push(...F.keys());return g}map(g){return new y(this.expr.map(F=>F.map(g)),null)}negate(){if(!this.c){const g=[];for(const F of this.expr)g.push(F.negate());for(;g.length>1;){const F=g.shift(),B=g.shift(),Y=[];for(const me of j(F))for(const Z of j(B))Y.push(h.create([me,Z],null,!1));g.unshift(y.create(Y,null,!1))}this.c=y.create(g,this,!0)}return this.c}}class C extends t{static all(){return C.d.values()}constructor(g,F,B){super(g,null),this.f=F,typeof B=="object"?C.d.push({...B,key:g}):B!==!0&&C.d.push({key:g,description:B,type:F!=null?typeof F:void 0})}bindTo(g){return g.createKey(this.key,this.f)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(g){return a.create(this.key,g)}notEqualsTo(g){return R.create(this.key,g)}}C.d=[],e.RawContextKey=C,e.IContextKeyService=(0,N.createDecorator)("contextKeyService");function H(L,g){return L<g?-1:L>g?1:0}function K(L,g,F,B){return L<F?-1:L>F?1:g<B?-1:g>B?1:0}function Q(L,g){if(L.type===0||g.type===1)return!0;if(L.type===9)return g.type===9?_(L.expr,g.expr):!1;if(g.type===9){for(const F of g.expr)if(Q(L,F))return!0;return!1}if(L.type===6){if(g.type===6)return _(g.expr,L.expr);for(const F of L.expr)if(Q(F,g))return!0;return!1}return L.equals(g)}e.implies=Q;function _(L,g){let F=0,B=0;for(;F<L.length&&B<g.length;){const Y=L[F].cmp(g[B]);if(Y<0)return!1;Y===0&&F++,B++}return F===L.length}function j(L){return L.type===9?L.expr:[L]}}),define(Te[160],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Te[90],Pe([1,0,134,3]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function D(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function N(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=N;function E(a,p){switch(a){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=E;function O(a,p){return p==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=O;function S(a,p,b){return O(p,b)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===b?!0:P(b).includes(a)}e.isTargetPlatformCompatible=S;function P(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function M(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=M;var T;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var m;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var w;(function(a){a.Install="install",a.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var f;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var u;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal",a.Signature="Signature"})(u=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class t extends Error{constructor(p,b){super(p),this.code=b,this.name=b}}e.ExtensionManagementError=t,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,n.localize)(1,null),original:"Preferences"}}),define(Te[43],Pe([1,0,48,19,10,9,2,136,3,20,15]),function(te,e,n,A,D,N,E,O,S,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function T(Z){return Z.create===!0}e.isFileOpenForWriteOptions=T;var m;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(m=e.FileType||(e.FileType={}));var w;(function(Z){Z[Z.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var f;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileClone=32768]="FileClone"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function u(Z){return!!(Z.capabilities&2)}e.hasReadWriteCapability=u;function t(Z){return!!(Z.capabilities&8)}e.hasFileFolderCopyCapability=t;function a(Z){return!!(Z.capabilities&32768)}e.hasFileCloneCapability=a;function p(Z){return!!(Z.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function b(Z){return!!(Z.capabilities&16)}e.hasFileReadStreamCapability=b;function R(Z){return u(Z)?!!(Z.capabilities&16384):!1}e.hasFileAtomicReadCapability=R;var v;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{static create(se,ue){const De=new i(se.toString(),ue);return l(De,ue),De}constructor(se,ue){super(se),this.code=ue}}e.FileSystemProviderError=i;function d(Z,se){return i.create(Z,se)}e.createFileSystemProviderError=d;function s(Z){return Z||d((0,O.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=s;function l(Z,se){return Z.name=se?`${se} (FileSystemError)`:"FileSystemError",Z}e.markAsFileSystemProviderError=l;function o(Z){if(!Z)return v.Unknown;if(Z instanceof i)return Z.code;const se=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!se)return v.Unknown;switch(se[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=o;function I(Z){if(Z instanceof H)return Z.fileOperationResult;switch(o(Z)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=I;var r;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class c{constructor(se,ue,De){this.resource=se,this.operation=ue,this.target=De}isOperation(se){return this.operation===se}}e.FileOperationEvent=c;var h;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class y{constructor(se,ue){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const De=new Map;for(const de of se){const ie=De.get(de.type);switch(ie?ie.push([de.resource,de]):De.set(de.type,[[de.resource,de]]),de.type){case 1:this.rawAdded.push(de.resource);break;case 0:this.rawUpdated.push(de.resource);break;case 2:this.rawDeleted.push(de.resource);break}}for(const[de,ie]of De)switch(de){case 1:this.a=n.TernarySearchTree.forUris(()=>ue),this.a.fill(ie);break;case 0:this.b=n.TernarySearchTree.forUris(()=>ue),this.b.fill(ie);break;case 2:this.c=n.TernarySearchTree.forUris(()=>ue),this.c.fill(ie);break}}contains(se,...ue){return this.d(se,{includeChildren:!1},...ue)}affects(se,...ue){return this.d(se,{includeChildren:!0},...ue)}d(se,ue,...De){if(!se)return!1;const de=De.length>0;return!!((!de||De.includes(1))&&(this.a?.get(se)||ue.includeChildren&&this.a?.findSuperstr(se))||(!de||De.includes(0))&&(this.b?.get(se)||ue.includeChildren&&this.b?.findSuperstr(se))||(!de||De.includes(2))&&(this.c?.findSubstr(se)||ue.includeChildren&&this.c?.findSuperstr(se)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=y;function C(Z,se,ue){return!Z||!se||Z===se||se.length>Z.length?!1:(se.charAt(se.length-1)!==A.sep&&(se+=A.sep),ue?(0,D.startsWithIgnoreCase)(Z,se):Z.indexOf(se)===0)}e.isParent=C;class H extends Error{constructor(se,ue,De){super(se),this.fileOperationResult=ue,this.options=De}}e.FileOperationError=H;class K extends H{constructor(se,ue,De,de){super(se,ue,de),this.fileOperationResult=ue,this.size=De}}e.TooLargeFileOperationError=K;class Q extends H{constructor(se,ue,De){super(se,2,De),this.stat=ue}}e.NotModifiedSinceFileOperationError=Q;var _;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",Z[Z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var j;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(j=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}e.etag=L;async function g(Z,se){if(!se.hasProvider(E.URI.from({scheme:Z.scheme})))return new Promise(ue=>{const De=se.onDidChangeFileSystemProviderRegistrations(de=>{de.scheme===Z.scheme&&de.added&&(De.dispose(),ue())})})}e.whenProviderRegistered=g,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(se){return(0,N.isNumber)(se)||(se=0),se<F.KB?(0,O.localize)(1,null,se.toFixed(0)):se<F.MB?(0,O.localize)(2,null,(se/F.KB).toFixed(2)):se<F.GB?(0,O.localize)(3,null,(se/F.MB).toFixed(2)):se<F.TB?(0,O.localize)(4,null,(se/F.GB).toFixed(2)):(0,O.localize)(5,null,(se/F.TB).toFixed(2))}}F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB,e.ByteSize=F;var B;(function(Z){Z[Z.IA32=0]="IA32",Z[Z.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function Y(Z){return{maxFileSize:Z===0?300*F.MB:16*F.GB,maxHeapSize:Z===0?700*F.MB:2*700*F.MB}}e.getPlatformFileLimits=Y;function me(Z){const se=typeof Z=="string"||Z?.scheme===M.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===M.Schemas.file?1024*F.MB:se?10*F.MB:P.isWeb?50*F.MB:1024*F.MB}e.getLargeFileConfirmationLimit=me}),define(Te[68],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...D){this.a=new Map;for(const[N,E]of D)this.set(N,E)}set(D,N){const E=this.a.get(D);return this.a.set(D,N),E}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=n}),define(Te[161],Pe([1,0,17,11,6,89,159,3,68,162]),function(te,e,n,A,D,N,E,O,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const M=!1;class T extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class m{constructor(t=new S.ServiceCollection,a=!1,p,b=M){this.f=t,this.g=a,this.h=p,this.i=b,this.o=new Set,this.f.set(O.IInstantiationService,this),this._globalGraph=b?p?._globalGraph??new E.Graph(R=>R):void 0}createChild(t){return new m(t,this.g,this,this.i)}invokeFunction(t,...a){const p=f.traceInvocation(this.i,t);let b=!1;try{return t({get:v=>{if(b)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(v,p);if(!i)throw new Error(`[invokeFunction] unknown service '${v}'`);return i}},...a)}finally{b=!0,p.stop()}}createInstance(t,...a){let p,b;return t instanceof N.SyncDescriptor?(p=f.traceCreation(this.i,t.ctor),b=this.j(t.ctor,t.staticArguments.concat(a),p)):(p=f.traceCreation(this.i,t),b=this.j(t,a,p)),p.stop(),b}j(t,a=[],p){const b=O._util.getServiceDependencies(t).sort((i,d)=>i.index-d.index),R=[];for(const i of b){const d=this.m(i.id,p);d||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${i.id}.`,!1),R.push(d)}const v=b.length>0?b[0].index:a.length;if(a.length!==v){console.trace(`[createInstance] First service dependency of ${t.name} at position ${v+1} conflicts with ${a.length} static arguments`);const i=v-a.length;i>0?a=a.concat(new Array(i)):a=a.slice(0,v)}return Reflect.construct(t,a.concat(R))}k(t,a){if(this.f.get(t)instanceof N.SyncDescriptor)this.f.set(t,a);else if(this.h)this.h.k(t,a);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const a=this.f.get(t);return!a&&this.h?this.h.l(t):a}m(t,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const p=this.l(t);return p instanceof N.SyncDescriptor?this.q(t,p,a.branch(t,!0)):(a.branch(t,!1),p)}q(t,a,p){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,a,p)}finally{this.o.delete(t)}}r(t,a,p){const b=new E.Graph(i=>i.id.toString());let R=0;const v=[{id:t,desc:a,_trace:p}];for(;v.length;){const i=v.pop();if(b.lookupOrInsertNode(i),R++>1e3)throw new T(b);for(const d of O._util.getServiceDependencies(i.desc.ctor)){const s=this.l(d.id);if(s||this.u(`[createInstance] ${t} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(d.id)),s instanceof N.SyncDescriptor){const l={id:d.id,desc:s,_trace:i._trace.branch(d.id,!0)};b.insertEdge(i,l),v.push(l)}}}for(;;){const i=b.roots();if(i.length===0){if(!b.isEmpty())throw new T(b);break}for(const{data:d}of i){if(this.l(d.id)instanceof N.SyncDescriptor){const l=this.s(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.k(d.id,l)}b.removeNode(d)}}return this.l(t)}s(t,a,p=[],b,R){if(this.f.get(t)instanceof N.SyncDescriptor)return this.t(t,a,p,b,R);if(this.h)return this.h.s(t,a,p,b,R);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}t(t,a,p=[],b,R){if(b){const v=new m(void 0,this.g,this,this.i);v.c=String(t);const i=new Map,d=new n.IdleValue(()=>{const s=v.j(a,p,R);for(const[l,o]of i){const I=s[l];if(typeof I=="function")for(const r of o)I.apply(s,r)}return i.clear(),s});return new Proxy(Object.create(null),{get(s,l){if(!d.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let r=i.get(l);return r||(r=new P.LinkedList,i.set(l,r)),(h,y,C)=>{const H=r.push([h,y,C]);return(0,D.toDisposable)(H)}}if(l in s)return s[l];const o=d.value;let I=o[l];return typeof I!="function"||(I=I.bind(o),s[l]=I),I},set(s,l,o){return d.value[l]=o,!0},getPrototypeOf(s){return a.prototype}})}else return this.j(a,p,R)}u(t,a){if(a&&console.warn(t),this.g)throw new Error(t)}}e.InstantiationService=m;var w;(function(u){u[u.None=0]="None",u[u.Creation=1]="Creation",u[u.Invocation=2]="Invocation",u[u.Branch=3]="Branch"})(w||(w={}));class f{static traceInvocation(t,a){return t?new f(2,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(t,a){return t?new f(1,a.name):f.c}constructor(t,a){this.type=t,this.name=a,this.g=Date.now(),this.h=[]}branch(t,a){const p=new f(3,t.toString());return this.h.push([t,a,p]),p}stop(){const t=Date.now()-this.g;f.f+=t;let a=!1;function p(R,v){const i=[],d=new Array(R+1).join("	");for(const[s,l,o]of v.h)if(l&&o){a=!0,i.push(`${d}CREATES -> ${s}`);const I=p(R+1,o);I&&i.push(I)}else i.push(`${d}uses -> ${s}`);return i.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(t>2||a)&&f.all.add(b.join(`
`))}}f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0,e.Trace=f}),define(Te[12],Pe([1,0,40,4,6,28,20,22,9,2,36,3]),function(te,e,n,A,D,N,E,O,S,P,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function m(){return new Date().toISOString()}function w(c){return(0,S.isNumber)(c)}e.isLogLevel=w;var f;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;function u(c,h,y){switch(h){case f.Trace:c.trace(y);break;case f.Debug:c.debug(y);break;case f.Info:c.info(y);break;case f.Warning:c.warn(y);break;case f.Error:c.error(y);break;case f.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=u;function t(c){let h="";for(let y=0;y<c.length;y++){let C=c[y];if(typeof C=="object")try{C=JSON.stringify(C)}catch{}h+=(y>0?" ":"")+C}return h}e.format=t;class a extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(h){this.b!==h&&(this.b=h,this.c.fire(this.b))}getLevel(){return this.b}f(h){return this.b!==f.Off&&this.b<=h}}e.AbstractLogger=a;class p extends a{constructor(h){super(),this.h=h}f(h){return this.h||super.f(h)}trace(h,...y){this.f(f.Trace)&&this.g(f.Trace,t([h,...y]))}debug(h,...y){this.f(f.Debug)&&this.g(f.Debug,t([h,...y]))}info(h,...y){this.f(f.Info)&&this.g(f.Info,t([h,...y]))}warn(h,...y){this.f(f.Warning)&&this.g(f.Warning,t([h,...y]))}error(h,...y){if(this.f(f.Error))if(h instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=h.stack,this.g(f.Error,t(C))}else this.g(f.Error,t([h,...y]))}flush(){}}e.AbstractMessageLogger=p;class b extends a{constructor(h=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(h),this.g=!E.isWindows}trace(h,...y){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,h,...y):console.log(`[main ${m()}]`,h,...y))}debug(h,...y){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,h,...y):console.log(`[main ${m()}]`,h,...y))}info(h,...y){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,h,...y):console.log(`[main ${m()}]`,h,...y))}warn(h,...y){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,h,...y):console.warn(`[main ${m()}]`,h,...y))}error(h,...y){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,h,...y):console.error(`[main ${m()}]`,h,...y))}dispose(){}flush(){}}e.ConsoleMainLogger=b;class R extends a{constructor(h=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(h)}trace(h,...y){this.f(f.Trace)&&console.log("%cTRACE","color: #888",h,...y)}debug(h,...y){this.f(f.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",h,...y)}info(h,...y){this.f(f.Info)&&console.log("%c INFO","color: #33f",h,...y)}warn(h,...y){this.f(f.Warning)&&console.log("%c WARN","color: #993",h,...y)}error(h,...y){this.f(f.Error)&&console.log("%c  ERR","color: #f33",h,...y)}dispose(){}flush(){}}e.ConsoleLogger=R;class v extends a{constructor(h,y=e.DEFAULT_LOG_LEVEL){super(),this.g=h,this.setLevel(y)}trace(h,...y){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(h),...y])}debug(h,...y){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(h),...y])}info(h,...y){this.f(f.Info)&&this.g.log(f.Info,[this.h(h),...y])}warn(h,...y){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(h),...y])}error(h,...y){this.f(f.Error)&&this.g.log(f.Error,[this.h(h),...y])}h(h){return typeof h=="string"?h:(0,n.toErrorMessage)(h,this.f(f.Trace))}dispose(){}flush(){}}e.AdapterLogger=v;class i extends a{constructor(h){super(),this.g=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const y of this.g)y.setLevel(h);super.setLevel(h)}trace(h,...y){for(const C of this.g)C.trace(h,...y)}debug(h,...y){for(const C of this.g)C.debug(h,...y)}info(h,...y){for(const C of this.g)C.info(h,...y)}warn(h,...y){for(const C of this.g)C.warn(h,...y)}error(h,...y){for(const C of this.g)C.error(h,...y)}flush(){for(const h of this.g)h.flush()}dispose(){for(const h of this.g)h.dispose()}}e.MultiplexLogger=i;class d extends D.Disposable{constructor(h,y,C){if(super(),this.h=h,this.j=y,this.b=new N.ResourceMap,this.c=this.B(new A.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeVisibility=this.g.event,C)for(const H of C)this.b.set(H.resource,{logger:void 0,info:H})}k(h){return(0,S.isString)(h)?[...this.b.values()].find(y=>y.info.id===h):this.b.get(h)}getLogger(h){return this.k(h)?.logger}createLogger(h,y){const C=this.l(h);let H=this.b.get(C)?.logger;const K=y?.logLevel==="always"?f.Trace:y?.logLevel;H||(H=this.m(C,K??this.getLogLevel(C)??this.h,y));const Q={logger:H,info:{resource:C,id:y?.id??C.toString(),logLevel:K,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(Q.info),this.b.set(C,Q),H}l(h){return(0,S.isString)(h)?(0,O.joinPath)(this.j,`${h}.log`):h}setLogLevel(h,y){if(P.URI.isUri(h)){const C=h,H=y,K=this.b.get(C);K&&H!==K.info.logLevel&&(K.info.logLevel=H===this.h?void 0:H,K.logger?.setLevel(H),this.b.set(K.info.resource,K),this.f.fire([C,H]))}else{this.h=h;for(const[C,H]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&H.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(h,y){const C=this.k(h);C&&y!==!C.info.hidden&&(C.info.hidden=!y,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,y]))}getLogLevel(h){let y;return h&&(y=this.b.get(h)?.info.logLevel),y??this.h}registerLogger(h){const y=this.b.get(h.resource);y?y.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this.b.set(h.resource,{info:h,logger:void 0}),this.c.fire({added:[h],removed:[]}))}deregisterLogger(h){const y=this.b.get(h);y&&(y.logger&&y.logger.dispose(),this.b.delete(h),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const h of this.b.values())yield h.info}getRegisteredLogger(h){return this.b.get(h)?.info}dispose(){this.b.forEach(h=>h.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=d;class s{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(h){}getLevel(){return f.Info}trace(h,...y){}debug(h,...y){}info(h,...y){}warn(h,...y){}error(h,...y){}critical(h,...y){}dispose(){}flush(){}}e.NullLogger=s;class l extends s{}e.NullLogService=l;function o(c){if(c.verbose)return f.Trace;if(typeof c.logLevel=="string"){const h=r(c.logLevel.toLowerCase());if(h!==void 0)return h}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function I(c){switch(c){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.LogLevelToString=I;function r(c){switch(c){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.parseLogLevel=r,e.CONTEXT_LOG_LEVEL=new M.RawContextKey("logLevel",I(f.Info))}),define(Te[163],Pe([1,0,6,12]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends n.Disposable{constructor(E,O=[]){super(),this.a=new A.MultiplexLogger([E,...O]),this.B(E.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(E){this.a.setLevel(E)}getLevel(){return this.a.getLevel()}trace(E,...O){this.a.trace(E,...O)}debug(E,...O){this.a.debug(E,...O)}info(E,...O){this.a.info(E,...O)}warn(E,...O){this.a.warn(E,...O)}error(E,...O){this.a.error(E,...O)}flush(){this.a.flush()}}e.LogService=D}),define(Te[91],Pe([1,0,29,137,3]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(N=e.MarkerTag||(e.MarkerTag={}));var E;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(E=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function P(f,u){return u-f}S.compare=P;const M=Object.create(null);M[S.Error]=(0,A.localize)(0,null),M[S.Warning]=(0,A.localize)(1,null),M[S.Info]=(0,A.localize)(2,null);function T(f){return M[f]||""}S.toString=T;function m(f){switch(f){case n.default.Error:return S.Error;case n.default.Warning:return S.Warning;case n.default.Info:return S.Info;case n.default.Ignore:return S.Hint}}S.fromSeverity=m;function w(f){switch(f){case S.Error:return n.default.Error;case S.Warning:return n.default.Warning;case S.Info:return n.default.Info;case S.Hint:return n.default.Ignore}}S.toSeverity=w}(E=e.MarkerSeverity||(e.MarkerSeverity={}));var O;(function(S){const P="";function M(m){return T(m,!0)}S.makeKey=M;function T(m,w){const f=[P];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(P),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(P),m.severity!==void 0&&m.severity!==null?f.push(E.toString(m.severity)):f.push(P),m.message&&w?f.push(m.message.replace("\xA6","\\\xA6")):f.push(P),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(P),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(P),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(P),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(P),f.push(P),f.join("\xA6")}S.makeKeyOptionalMessage=T})(O=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(Te[164],Pe([1,0,4,29,3]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,D.createDecorator)("notificationService");var N;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(N=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var E;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(E=e.NotificationsFilter||(e.NotificationsFilter={}));class O{constructor(){this.progress=new S,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(M){}updateMessage(M){}updateActions(M){}close(){}}e.NoOpNotification=O;class S{infinite(){}done(){}total(M){}worked(M){}}e.NoOpProgress=S}),define(Te[92],Pe([1,0,10,2,3]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService");function N(P,M){return A.URI.isUri(P)?(0,n.equalsIgnoreCase)(P.scheme,M):(0,n.startsWithIgnoreCase)(P,M+":")}e.matchesScheme=N;function E(P,...M){return M.some(T=>N(P,T))}e.matchesSomeScheme=E;function O(P,M){return P.with({fragment:`${M.startLineNumber},${M.startColumn}${M.endLineNumber?`-${M.endLineNumber}${M.endColumn?`,${M.endColumn}`:""}`:""}`})}e.withSelection=O;function S(P){let M;const T=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(P.fragment);return T&&(M={startLineNumber:parseInt(T[1]),startColumn:T[2]?parseInt(T[2]):1,endLineNumber:T[4]?parseInt(T[4]):void 0,endColumn:T[4]?T[5]?parseInt(T[5]):1:void 0},P=P.with({fragment:""})),{selection:M,uri:P}}e.extractSelection=S}),define(Te[165],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(te,e,n,A){var D=arguments.length,N=D<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,n):A,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(te,e,n,A);else for(var O=te.length-1;O>=0;O--)(E=te[O])&&(N=(D<3?E(N):D>3?E(e,n,N):E(e,n))||N);return D>3&&N&&Object.defineProperty(e,n,N),N},Ve=this&&this.__param||function(te,e){return function(n,A){e(n,A,te)}};define(Te[166],Pe([1,0,17,21,6,3]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,N.createDecorator)("progressService");var E;(function(M){M[M.Explorer=1]="Explorer",M[M.Scm=3]="Scm",M[M.Extensions=5]="Extensions",M[M.Window=10]="Window",M[M.Notification=15]="Notification",M[M.Dialog=20]="Dialog"})(E=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class O{get value(){return this.a}constructor(T){this.b=T}report(T){this.a=T,this.b(this.a)}}O.None=Object.freeze({report(){}}),e.Progress=O;let S=class extends D.Disposable{constructor(T,m){super(),this.a=new n.DeferredPromise,m.withProgress(T,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,D.toDisposable)(()=>this.a.complete()))}report(T){this.b?this.b.report(T):this.c=T}};S=qe([Ve(1,e.IProgressService)],S),e.UnmanagedProgress=S;class P extends D.Disposable{constructor(T){super(),this.g=T,this.a=0,this.b=this.B(new D.DisposableStore)}start(T){this.stop();const m=++this.a,w=new A.CancellationTokenSource;return this.f=setTimeout(()=>{m===this.a&&(this.c=this.g.show(!0))},T),this.b.add((0,D.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,D.toDisposable)(()=>w.cancel())),this.b.add((0,D.toDisposable)(()=>this.c?this.c.done():void 0)),{id:m,token:w.token,stop:()=>this.h(m),isCurrent:()=>this.a===m}}stop(){this.h(this.a)}h(T){this.a===T&&this.b.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,N.createDecorator)("editorProgressService")}),define(Te[30],Pe([1,0,49,9]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(E,O){n.ok(A.isString(E)),n.ok(A.isObject(O)),n.ok(!this.a.has(E),"There is already an extension with this id"),this.a.set(E,O)}knows(E){return this.a.has(E)}as(E){return this.a.get(E)||null}}e.Registry=new D}),define(Te[69],Pe([1,0,4,30]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class N{constructor(){this.b=new n.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,P){this.a[D(S)]=P,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const E=new N;A.Registry.add(e.Extensions.JSONContribution,E)}),define(Te[93],Pe([1,0,16,4,9,133,42,69,30]),function(te,e,n,A,D,N,E,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var M;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=S.Registry.as(O.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,d=!0){this.registerConfigurations([i],d)}registerConfigurations(i,d=!0){const s=new Set;this.n(i,d,s),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(i){const d=new Set;this.o(i,d),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:i,remove:d}){const s=new Set;this.o(d,s),this.n(i,!1,s),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(i){const d=new Set;this.k(i,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(i,d){const s=[];for(const{overrides:l,source:o}of i)for(const I in l)if(d.add(I),e.OVERRIDE_PROPERTY_REGEX.test(I)){const r=this.a.get(I),c=r?.valuesSources??new Map;if(o)for(const H of Object.keys(l[I]))c.set(H,o);const h={...r?.value||{},...l[I]};this.a.set(I,{source:o,value:h,valuesSources:c});const y=(0,E.getLanguageTagSettingPlainKey)(I),C={type:"object",default:h,description:N.localize(1,null,y),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:D.isString(o)?void 0:o,defaultValueSource:o};s.push(...u(I)),this.d[I]=C,this.b.properties[I]=C}else{this.a.set(I,{value:l[I],source:o});const r=this.d[I];r&&(this.w(I,r),this.r(I,r))}this.m(s)}deregisterDefaultConfigurations(i){const d=new Set;this.l(i,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(i,d){for(const{overrides:s,source:l}of i)for(const o in s){const I=this.a.get(o),r=D.isString(l)?l:l?.id,c=D.isString(I?.source)?I?.source:I?.source?.id;if(r===c)if(d.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const h=this.d[o];h&&(this.w(o,h),this.r(o,h))}}this.u()}deltaConfiguration(i){let d=!1;const s=new Set;i.removedDefaults&&(this.l(i.removedDefaults,s),d=!0),i.addedDefaults&&(this.k(i.addedDefaults,s),d=!0),i.removedConfigurations&&this.o(i.removedConfigurations,s),i.addedConfigurations&&this.n(i.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const d of i)this.h.add(d);this.u()}n(i,d,s){i.forEach(l=>{this.p(l,d,l.extensionInfo,l.restrictedProperties,void 0,s),this.c.push(l),this.q(l)})}o(i,d){const s=l=>{if(l.properties)for(const o in l.properties){d.add(o);const I=this.d[o];I?.policy?.name&&this.e.delete(I.policy.name),delete this.d[o],this.s(o,l.properties[o])}l.allOf?.forEach(o=>s(o))};for(const l of i){s(l);const o=this.c.indexOf(l);o!==-1&&this.c.splice(o,1)}}p(i,d=!0,s,l,o=3,I){o=D.isUndefinedOrNull(i.scope)?o:i.scope;const r=i.properties;if(r)for(const h in r){const y=r[h];if(d&&b(h,y)){delete r[h];continue}if(y.source=s,y.defaultDefaultValue=r[h].default,this.w(h,y),e.OVERRIDE_PROPERTY_REGEX.test(h)?y.scope=void 0:(y.scope=D.isUndefinedOrNull(y.scope)?o:y.scope,y.restricted=D.isUndefinedOrNull(y.restricted)?!!l?.includes(h):y.restricted),r[h].hasOwnProperty("included")&&!r[h].included){this.f[h]=r[h],delete r[h];continue}else this.d[h]=r[h],r[h].policy?.name&&this.e.set(r[h].policy.name,h);!r[h].deprecationMessage&&r[h].markdownDeprecationMessage&&(r[h].deprecationMessage=r[h].markdownDeprecationMessage),I.add(h)}const c=i.allOf;if(c)for(const h of c)this.p(h,d,s,l,o,I)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const d=s=>{const l=s.properties;if(l)for(const I in l)this.r(I,l[I]);s.allOf?.forEach(d)};d(i)}r(i,d){switch(e.allSettings.properties[i]=d,d.scope){case 1:e.applicationSettings.properties[i]=d;break;case 2:e.machineSettings.properties[i]=d;break;case 6:e.machineOverridableSettings.properties[i]=d;break;case 3:e.windowSettings.properties[i]=d;break;case 4:e.resourceSettings.properties[i]=d;break;case 5:e.resourceSettings.properties[i]=d,this.g.properties[i]=d;break}}s(i,d){switch(delete e.allSettings.properties[i],d.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const d=`[${i}]`,s={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(d,s),e.allSettings.properties[d]=s,e.applicationSettings.properties[d]=s,e.machineSettings.properties[d]=s,e.machineOverridableSettings.properties[d]=s,e.windowSettings.properties[d]=s,e.resourceSettings.properties[d]=s}}v(){const i={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,d){const s=this.a.get(i);let l=s?.value,o=s?.source;D.isUndefined(l)&&(l=d.defaultDefaultValue,o=void 0),D.isUndefined(l)&&(l=a(d.type)),d.default=l,d.defaultValueSource=o}}const w="\\[([^\\]]+)\\]",f=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function u(v){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let d=f.exec(v);for(;d?.length;){const s=d[1].trim();s&&i.push(s),d=f.exec(v)}}return(0,n.distinct)(i)}e.overrideIdentifiersFromKey=u;function t(v){return v.reduce((i,d)=>`${i}[${d}]`,"")}e.keyFromOverrideIdentifiers=t;function a(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const p=new m;S.Registry.add(e.Extensions.Configuration,p);function b(v,i){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?N.localize(7,null,v):p.getConfigurationProperties()[v]!==void 0?N.localize(8,null,v):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?N.localize(9,null,v,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:N.localize(6,null)}e.validateProperty=b;function R(){const v=[],i=p.getConfigurationProperties();for(const d of Object.keys(i))v.push([d,i[d].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=R}),define(Te[167],Pe([1,0,16,4,112,6,28,23,9,2,42,93,30]),function(te,e,n,A,D,N,E,O,S,P,M,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function w(d){return Object.isFrozen(d)?d:O.deepFreeze(d)}class f{constructor(s={},l=[],o=[],I){this.b=s,this.c=l,this.d=o,this.raw=I,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(l=>{if(l instanceof f)return l;const o=new u("");return o.parseRaw(l),o.configurationModel});this.f=s.reduce((l,o)=>o===l?o:l.merge(o),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,M.getConfigurationValue)(this.contents,s):this.contents}inspect(s,l){const o=this.rawConfiguration.getValue(s),I=l?this.rawConfiguration.getOverrideValue(s,l):void 0,r=l?this.rawConfiguration.override(l).getValue(s):o;return{value:o,override:I,merged:r}}getOverrideValue(s,l){const o=this.i(l);return o?s?(0,M.getConfigurationValue)(o,s):o:void 0}getKeysForOverrideIdentifier(s){const l=[];for(const o of this.overrides)o.identifiers.includes(s)&&l.push(...o.keys);return n.distinct(l)}getAllOverrideIdentifiers(){const s=[];for(const l of this.overrides)s.push(...l.identifiers);return n.distinct(s)}override(s){let l=this.a.get(s);return l||(l=this.g(s),this.a.set(s,l)),l}merge(...s){const l=O.deepClone(this.contents),o=O.deepClone(this.overrides),I=[...this.keys],r=this.raw?.length?[...this.raw]:[this];for(const c of s)if(r.push(...c.raw?.length?c.raw:[c]),!c.isEmpty()){this.h(l,c.contents);for(const h of c.overrides){const[y]=o.filter(C=>n.equals(C.identifiers,h.identifiers));y?(this.h(y.contents,h.contents),y.keys.push(...h.keys),y.keys=n.distinct(y.keys)):o.push(O.deepClone(h))}for(const h of c.keys)I.indexOf(h)===-1&&I.push(h)}return new f(l,I,o,r.every(c=>c instanceof f)?void 0:r)}g(s){const l=this.i(s);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const o={};for(const I of n.distinct([...Object.keys(this.contents),...Object.keys(l)])){let r=this.contents[I];const c=l[I];c&&(typeof r=="object"&&typeof c=="object"?(r=O.deepClone(r),this.h(r,c)):r=c),o[I]=r}return new f(o,this.keys,this.overrides)}h(s,l){for(const o of Object.keys(l)){if(o in s&&S.isObject(s[o])&&S.isObject(l[o])){this.h(s[o],l[o]);continue}s[o]=O.deepClone(l[o])}}i(s){let l=null,o=null;const I=r=>{r&&(o?this.h(o,r):o=O.deepClone(r))};for(const r of this.overrides)n.equals(r.identifiers,[s])?l=r.contents:r.identifiers.includes(s)&&I(r.contents);return I(l),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,l){this.j(s,l,!0)}setValue(s,l){this.j(s,l,!1)}removeValue(s){const l=this.keys.indexOf(s);l!==-1&&(this.keys.splice(l,1),(0,M.removeFromValueTree)(this.contents,s),T.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(o=>n.equals(o.identifiers,(0,T.overrideIdentifiersFromKey)(s))),1))}j(s,l,o){(0,M.addToValueTree)(this.contents,s,l,I=>console.error(I)),o=o||this.keys.indexOf(s)===-1,o&&this.keys.push(s),T.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,T.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,M.toValuesTree)(this.contents[s],I=>console.error(I))})}}e.ConfigurationModel=f;class u{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,l){if(!S.isUndefinedOrNull(s)){const o=this.g(s);this.parseRaw(o,l)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,l){this.a=s;const{contents:o,keys:I,overrides:r,restricted:c,hasExcludedProperties:h}=this.h(s,l);this.b=new f(o,I,r,h?[s]:void 0),this.c=c||[]}g(s){let l={},o=null,I=[];const r=[],c=[];function h(C){Array.isArray(I)?I.push(C):o!==null&&(I[o]=C)}const y={onObjectBegin:()=>{const C={};h(C),r.push(I),I=C,o=null},onObjectProperty:C=>{o=C},onObjectEnd:()=>{I=r.pop()},onArrayBegin:()=>{const C=[];h(C),r.push(I),I=C,o=null},onArrayEnd:()=>{I=r.pop()},onLiteralValue:h,onError:(C,H,K)=>{c.push({error:C,offset:H,length:K})}};if(s)try{D.visit(s,y),l=I[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return l}h(s,l){const o=m.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),I=this.i(s,o,!0,l);s=I.raw;const r=(0,M.toValuesTree)(s,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),c=Object.keys(s),h=this.j(s,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:r,keys:c,overrides:h,restricted:I.restricted,hasExcludedProperties:I.hasExcludedProperties}}i(s,l,o,I){let r=!1;if(!I?.scopes&&!I?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:r};const c={},h=[];for(const y in s)if(T.OVERRIDE_PROPERTY_REGEX.test(y)&&o){const C=this.i(s[y],l,!1,I);c[y]=C.raw,r=r||C.hasExcludedProperties,h.push(...C.restricted)}else{const C=l[y],H=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&h.push(y),(H===void 0||I.scopes===void 0||I.scopes.includes(H))&&!(I.skipRestricted&&C?.restricted)?c[y]=s[y]:r=!0}return{raw:c,restricted:h,hasExcludedProperties:r}}j(s,l){const o=[];for(const I of Object.keys(s))if(T.OVERRIDE_PROPERTY_REGEX.test(I)){const r={};for(const c in s[I])r[c]=s[I][c];o.push({identifiers:(0,T.overrideIdentifiersFromKey)(I),keys:Object.keys(r),contents:(0,M.toValuesTree)(r,l)})}return o}}e.ConfigurationModelParser=u;class t extends N.Disposable{constructor(s,l,o,I){super(),this.f=s,this.g=l,this.h=I,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new u(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,r=>r.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,r=>(r.isOperation(0)||r.isOperation(3)||r.isOperation(1)||r.isOperation(4))&&o.isEqual(r.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new f}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=t;class a{constructor(s,l,o,I,r,c,h,y,C,H,K,Q,_){this.a=s,this.b=l,this.c=o,this.overrideIdentifiers=I,this.d=r,this.f=c,this.g=h,this.h=y,this.i=C,this.j=H,this.k=K,this.l=Q,this.m=_}get value(){return w(this.c)}n(s,l,o){const I=s.inspect(l,o);return{get value(){return w(I.value)},get override(){return w(I.override)},get merged(){return w(I.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(s,l,o,I,r=new f,c=new f,h=new E.ResourceMap,y=new f,C=new E.ResourceMap){this.c=s,this.d=l,this.f=o,this.g=I,this.h=r,this.i=c,this.j=h,this.l=y,this.m=C,this.a=null,this.b=new E.ResourceMap,this.n=null}getValue(s,l,o){return this.q(s,l,o).getValue(s)}updateValue(s,l,o={}){let I;o.resource?(I=this.m.get(o.resource),I||(I=new f,this.m.set(o.resource,I))):I=this.l,l===void 0?I.removeValue(s):I.setValue(s,l),o.resource||(this.a=null)}inspect(s,l,o){const I=this.q(s,l,o),r=this.u(l.resource,o),c=l.resource?this.m.get(l.resource)||this.l:this.l,h=new Set;for(const y of I.overrides)for(const C of y.identifiers)I.getOverrideValue(s,C)!==void 0&&h.add(C);return new a(s,l,I.getValue(s),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,r||void 0,c)}keys(s){const l=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,l){this.j.set(s,l),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,l){const o=[];if(!l){const{added:I,updated:r,removed:c}=v(this.c,s);l=[...I,...r,...c]}for(const I of l)for(const r of(0,T.overrideIdentifiersFromKey)(I)){const c=this.c.getKeysForOverrideIdentifier(r),h=s.getKeysForOverrideIdentifier(r),y=[...h.filter(C=>c.indexOf(C)===-1),...c.filter(C=>h.indexOf(C)===-1),...c.filter(C=>!O.equals(this.c.override(r).getValue(C),s.override(r).getValue(C)))];o.push([r,y])}return this.updateDefaultConfiguration(s),{keys:l,overrides:o}}compareAndUpdatePolicyConfiguration(s){const{added:l,updated:o,removed:I}=v(this.d,s),r=[...l,...o,...I];return r.length&&this.updatePolicyConfiguration(s),{keys:r,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:l,updated:o,removed:I,overrides:r}=v(this.applicationConfiguration,s),c=[...l,...o,...I];return c.length&&this.updateApplicationConfiguration(s),{keys:c,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:l,updated:o,removed:I,overrides:r}=v(this.localUserConfiguration,s),c=[...l,...o,...I];return c.length&&this.updateLocalUserConfiguration(s),{keys:c,overrides:r}}compareAndUpdateRemoteUserConfiguration(s){const{added:l,updated:o,removed:I,overrides:r}=v(this.remoteUserConfiguration,s),c=[...l,...o,...I];return c.length&&this.updateRemoteUserConfiguration(s),{keys:c,overrides:r}}compareAndUpdateWorkspaceConfiguration(s){const{added:l,updated:o,removed:I,overrides:r}=v(this.workspaceConfiguration,s),c=[...l,...o,...I];return c.length&&this.updateWorkspaceConfiguration(s),{keys:c,overrides:r}}compareAndUpdateFolderConfiguration(s,l){const o=this.p.get(s),{added:I,updated:r,removed:c,overrides:h}=v(o,l),y=[...I,...r,...c];return(y.length||!o)&&this.updateFolderConfiguration(s,l),{keys:y,overrides:h}}compareAndDeleteFolderConfiguration(s){const l=this.p.get(s);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:o,updated:I,removed:r,overrides:c}=v(l,void 0);return{keys:[...o,...I,...r],overrides:c}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,l,o){let I=this.r(l,o);return l.overrideIdentifier&&(I=I.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(I=I.merge(this.d)),I}r({resource:s},l){let o=this.s();if(l&&s){const I=l.getFolder(s);I&&(o=this.t(I.uri)||o);const r=this.m.get(s);r&&(o=o.merge(r))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let l=this.b.get(s);if(!l){const o=this.s(),I=this.j.get(s);I?(l=o.merge(I),this.b.set(s,l)):l=o}return l}u(s,l){if(l&&s){const o=l.getFolder(s);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,l)=>{const{contents:o,overrides:I,keys:r}=this.j.get(l);return s.push([l,{contents:o,overrides:I,keys:r}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(l=>s.add(l)),this.userConfiguration.keys.forEach(l=>s.add(l)),this.i.keys.forEach(l=>s.add(l)),this.j.forEach(l=>l.keys.forEach(o=>s.add(o))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>s.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(o=>s.add(o))),[...s.values()]}w(s){const l=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(o=>l.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>l.add(o)),this.i.getKeysForOverrideIdentifier(s).forEach(o=>l.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(s).forEach(I=>l.add(I))),[...l.values()]}static parse(s){const l=this.x(s.defaults),o=this.x(s.policy),I=this.x(s.application),r=this.x(s.user),c=this.x(s.workspace),h=s.folders.reduce((y,C)=>(y.set(P.URI.revive(C[0]),this.x(C[1])),y),new E.ResourceMap);return new p(l,o,I,r,new f,c,h,new f,new E.ResourceMap)}static x(s){return new f(s.contents,s.keys,s.overrides)}}e.Configuration=p;function b(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const s=new Set,l=new Map;for(const I of d)I.keys.forEach(r=>s.add(r)),I.overrides.forEach(([r,c])=>{const h=(0,E.getOrSet)(l,r,new Set);c.forEach(y=>h.add(y))});const o=[];return l.forEach((I,r)=>o.push([r,[...I.values()]])),{keys:[...s.values()],overrides:o}}e.mergeChanges=b;class R{constructor(s,l,o,I){this.change=s,this.f=l,this.g=o,this.h=I,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const r of s.keys)this.affectedKeys.add(r);for(const[,r]of s.overrides)for(const c of r)this.affectedKeys.add(c);this.d=this.a;for(const r of this.affectedKeys)this.d+=r+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(s,l){const o=this.a+s,I=this.d.indexOf(o);if(I<0)return!1;const r=I+o.length;if(r>=this.d.length)return!1;const c=this.d.charCodeAt(r);if(c!==this.b&&c!==this.c)return!1;if(l){const h=this.previousConfiguration?this.previousConfiguration.getValue(s,l,this.f?.workspace):void 0,y=this.g.getValue(s,l,this.h);return!O.equals(h,y)}return!0}}e.ConfigurationChangeEvent=R;function v(d,s){const{added:l,removed:o,updated:I}=i(s?.rawConfiguration,d?.rawConfiguration),r=[],c=d?.getAllOverrideIdentifiers()||[],h=s?.getAllOverrideIdentifiers()||[];if(s){const y=h.filter(C=>!c.includes(C));for(const C of y)r.push([C,s.getKeysForOverrideIdentifier(C)])}if(d){const y=c.filter(C=>!h.includes(C));for(const C of y)r.push([C,d.getKeysForOverrideIdentifier(C)])}if(s&&d){for(const y of c)if(h.includes(y)){const C=i({contents:d.getOverrideValue(void 0,y)||{},keys:d.getKeysForOverrideIdentifier(y)},{contents:s.getOverrideValue(void 0,y)||{},keys:s.getKeysForOverrideIdentifier(y)});r.push([y,[...C.added,...C.removed,...C.updated]])}}return{added:l,removed:o,updated:I,overrides:r}}function i(d,s){const l=d?s?d.keys.filter(r=>s.keys.indexOf(r)===-1):[...d.keys]:[],o=s?d?s.keys.filter(r=>d.keys.indexOf(r)===-1):[...s.keys]:[],I=[];if(d&&s){for(const r of s.keys)if(d.keys.indexOf(r)!==-1){const c=(0,M.getConfigurationValue)(s.contents,r),h=(0,M.getConfigurationValue)(d.contents,r);O.equals(c,h)||I.push(r)}}return{added:l,removed:o,updated:I}}}),define(Te[94],Pe([1,0,11,3]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var D;(function(O){O.Unknown="Unknown",O.NotAvailable="NotAvailable",O.TemporarilyNotAvailable="TemporarilyNotAvailable",O.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class N extends n.ErrorNoTelemetry{static isNotAvailable(S){return S instanceof N&&S._code===D.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof N&&S._code===D.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof N&&S._code===D.NoResolverFound}static isHandled(S){return S instanceof N&&S.isHandled}constructor(S,P=D.Unknown,M){super(S),this._message=S,this._code=P,this._detail=M,this.isHandled=P===D.NotAvailable&&M===!0,Object.setPrototypeOf(this,N.prototype)}}e.RemoteAuthorityResolverError=N;function E(O){const S=O.indexOf("+");return S===-1?O:O.substring(0,S)}e.getRemoteAuthorityPrefix=E}),define(Te[50],Pe([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(P){return P.scheme===n.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=A;function D(P){if(!P)return;const M=P.indexOf("+");return M<0?P:P.substr(0,M)}e.getRemoteName=D;function N(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=N;function E(P){const{host:M,port:T}=S(P);if(typeof T>"u")throw new Error("Remote authority doesn't contain a port!");return{host:M,port:T}}e.parseAuthorityWithPort=E;function O(P,M){let{host:T,port:m}=S(P);return typeof m>"u"&&(m=M),{host:T,port:m}}e.parseAuthorityWithOptionalPort=O;function S(P){const M=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(M)return{host:M[1],port:parseInt(M[2],10)};const T=P.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const m=P.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:P,port:void 0}}}),define(Te[24],Pe([1,0,10,3,50]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function N(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.getWorkspaceSupportTypeMessage=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));var O;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(O=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(t){this.value=t,this.c=t.toLowerCase()}static equals(t,a){if(typeof t>"u"||t===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof t=="string"||typeof a=="string"){const p=typeof t=="string"?t:t.value,b=typeof a=="string"?a:a.value;return n.equalsIgnoreCase(p,b)}return t.c===a.c}static toKey(t){return typeof t=="string"?t.toLowerCase():t.c}}e.ExtensionIdentifier=S;class P{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const a of t)this.add(a)}add(t){this.c.add(S.toKey(t))}delete(t){return this.c.delete(S.toKey(t))}has(t){return this.c.has(S.toKey(t))}}e.ExtensionIdentifierSet=P;class M{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(S.toKey(t))}get(t){return this.c.get(S.toKey(t))}has(t){return this.c.has(S.toKey(t))}set(t,a){this.c.set(S.toKey(t),a)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=M;function T(u){return m(u)}e.isApplicationScopedExtension=T;function m(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function w(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function f(u,t){if(t){const a=`onResolveRemoteAuthority:${(0,D.getRemoteName)(t)}`;return!!u.activationEvents?.includes(a)}return!1}e.isResolverExtension=f,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(Te[95],Pe([1,0,11,24]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class D{constructor(){this.a=new Map,this.b=new WeakMap}register(E,O){this.a.set(E,O)}readActivationEvents(E){return this.b.has(E)||this.b.set(E,this.c(E)),this.b.get(E)}createActivationEventsMap(E){const O=Object.create(null);for(const S of E){const P=this.readActivationEvents(S);P.length>0&&(O[A.ExtensionIdentifier.toKey(S.identifier)]=P)}return O}c(E){if(typeof E.main>"u"&&typeof E.browser>"u")return[];const O=Array.isArray(E.activationEvents)?E.activationEvents.slice(0):[];if(!E.contributes)return O;for(const S in E.contributes){const P=this.a.get(S);if(!P)continue;const M=E.contributes[S],T=Array.isArray(M)?M:[M];try{P(T,O)}catch(m){(0,n.onUnexpectedError)(m)}}return O}}e.ImplicitActivationEventsImpl=D,e.ImplicitActivationEvents=new D}),define(Te[168],Pe([1,0,20,51,2,34]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(P){if(n.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}async function O(P,M,T,m,w,f,u,t,a,p){const b=Object.create(null);b["common.machineId"]=u,b.sessionID=(0,N.generateUuid)()+Date.now(),b.commitHash=w,b.version=f,b["common.platformVersion"]=(M||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,n.PlatformToString)(n.platform),b["common.nodePlatform"]=A.platform,b["common.nodeArch"]=m,b["common.product"]=p||"desktop",t&&(b["common.msftInternal"]=t);let R=0;const v=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>R++,enumerable:!0}}),n.isLinuxSnap&&(b["common.snap"]="true");const i=E(T);i&&(b["common.platformDetail"]=i);try{const d=await P.readFile(D.URI.file(a));b["common.source"]=d.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=O;function S(P){const M=A.env.USERDNSDOMAIN;if(!M)return!1;const T=M.toLowerCase();return P.some(m=>T===m)}e.verifyMicrosoftInternalDomain=S}),define(Te[169],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Te[52],Pe([1,0,23,9,4,42,50,168,169]),function(te,e,n,A,D,N,E,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class P{constructor(r){this.value=r}}e.TelemetryTrustedValue=P;class M{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(r,c){return Promise.resolve(void 0)}publicLog2(r,c){return this.publicLog(r,c)}publicLogError(r,c){return Promise.resolve(void 0)}publicLogError2(r,c){return this.publicLogError(r,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=M,e.NullTelemetryService=new M;class T{async publicLog(r,c,h){}async publicLogError(r,c,h){}}e.NullEndpointTelemetryService=T,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(I,r){return D.Event.debounce(r.onDidChangeConfiguration,(h,y)=>{const C=h?new Set([...h.affectedKeys,...y.affectedKeys]):y.affectedKeys;return{...y,affectedKeys:C}},1e3,!0)(h=>{h.source!==7&&I.publicLog2("updateConfiguration",{configurationSource:(0,N.ConfigurationTargetToString)(h.source),configurationKeys:R(h.affectedKeys)})})}e.configurationTelemetry=m;function w(I,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!I.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=w;function f(I,r){return!(r.isBuilt||r.disableTelemetry||I.enableTelemetry&&I.aiConfig?.ariaKey)}e.isLoggingOnly=f;function u(I){const r=I.getValue(S.TELEMETRY_SETTING_ID),c=I.getValue(S.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(I.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||c===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=u;function t(I){const r={},c={},h={};b(I,h);for(let y in h){y=y.length>150?y.substr(y.length-149):y;const C=h[y];typeof C=="number"?c[y]=C:typeof C=="boolean"?c[y]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${y} has been trimmed to 8192, the original length is ${C.length}`),r[y]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(r[y]=C)}return{properties:r,measurements:c}}e.validateTelemetryData=t;const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(I){if(!I)return"none";const r=(0,E.getRemoteName)(I);return a.has(r)?r:"other"}e.cleanRemoteAuthority=p;function b(I,r,c=0,h){if(!!I)for(const y of Object.getOwnPropertyNames(I)){const C=I[y],H=h?h+y:y;Array.isArray(C)?r[H]=(0,n.safeStringify)(C):C instanceof Date?r[H]=C.toISOString():(0,A.isObject)(C)?c<2?b(C,r,c+1,H+"."):r[H]=(0,n.safeStringify)(C):r[H]=C}}function R(I){if(!I)return[];const r=[];return v(r,"",I),r}function v(I,r,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(h=>v(I,r?`${r}.${h}`:h,c[h])):I.push(r)}function i(I,r){const c=I.msftInternalDomains||[],h=r.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(c)||h}e.isInternalTelemetry=i;function d(I){return[I.appRoot,I.extensionsPath,I.userHome.fsPath,I.tmpDir.fsPath,I.userDataPath]}e.getPiiPathsFromEnvironment=d;function s(I,r){if(!I||!I.includes("/")&&!I.includes("\\"))return I;let c=I;const h=[];for(const K of r)for(;;){const Q=K.exec(I);if(!Q)break;h.push([Q.index,K.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let H=0;for(c="";;){const K=C.exec(I);if(!K)break;const Q=h.some(([_,j])=>K.index<j&&_<C.lastIndex);!y.test(K[0])&&!Q&&(c+=I.substring(H,K.index)+"<REDACTED: user-file-path>",H=C.lastIndex)}return H<I.length&&(c+=I.substr(H)),c}function l(I){if(!I)return I;const r=I.toLowerCase(),c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of c)if(h.regex.test(r))return`<REDACTED: ${h.label}>`;return I}function o(I,r){return(0,n.cloneAndChange)(I,c=>{if(c instanceof P)return c.value;if(typeof c=="string"){let h=c.replaceAll("%20"," ");h=s(h,r);for(const y of r)h=h.replace(y,"");return h=l(h),h}})}e.cleanData=o}),define(Te[170],Pe([1,0,10,90,24,20,2,11,51,52]),function(te,e,n,A,D,N,E,O,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function M(s,l){return s.uuid&&l.uuid?s.uuid===l.uuid:s.id===l.id?!0:(0,n.compareIgnoreCase)(s.id,l.id)===0}e.areSameExtensions=M;const T=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(l){const o=l.manifest?l.manifest.version:l.version,I=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new m(l.identifier,o,I)}static parse(l){const o=T.exec(l);return o&&o[1]&&o[2]?new m({id:o[1]},o[2],o[4]||void 0):null}constructor(l,o,I="undefined"){this.version=o,this.targetPlatform=I,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof m?M(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=m;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(s){const l=w.exec(s);return l&&l[1]?[t(l[1]),l[2]]:[t(s),void 0]}e.getIdAndVersion=f;function u(s,l){return`${s}.${l}`}e.getExtensionId=u;function t(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=t;function a(s,l){return t(u(s,l))}e.getGalleryExtensionId=a;function p(s,l){const o=[],I=r=>{for(const c of o)if(c.some(h=>M(l(h),l(r))))return c;return null};for(const r of s){const c=I(r);c?c.push(r):o.push([r])}return o}e.groupByExtension=p;function b(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function R(s){return{id:new P.TelemetryTrustedValue(s.identifier.id),name:new P.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=R,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function v(s,l){const o=[],I=l.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const r=I.shift();if(r&&o.every(c=>!M(c.identifier,{id:r}))){const c=s.filter(h=>M(h.identifier,{id:r}));c.length===1&&(o.push(c[0]),I.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=v;async function i(s,l){if(!N.isLinux)return!1;let o;try{o=(await s.readFile(E.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await s.readFile(E.URI.file("/usr/lib/os-release"))).value.toString()}catch(r){l.debug("Error while getting the os-release file.",(0,O.getErrorMessage)(r))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(s,l){const o=await i(s,l),I=(0,A.getTargetPlatform)(o?"alpine":N.platform,S.arch);return l.debug("ComputeTargetPlatform:",I),I}e.computeTargetPlatform=d}),define(Te[171],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=n;function A(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=A;function D(E){return Array.from(E.entries()).map(O=>[O[0],n(O[1].map)])}e.serializeEnvironmentVariableCollections=D;function N(E){return new Map(E.map(O=>[O[0],{map:A(O[1])}]))}e.deserializeEnvironmentVariableCollections=N}),define(Te[172],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(D){this.b=D,this.a=new Map}dispose(){for(const D of this.a.values())D.dispose()}startBuffering(D,N,E=5){const O=N(S=>{const P=typeof S=="string"?S:S.data;let M=this.a.get(D);if(M){M.data.push(P);return}const T=setTimeout(()=>this.flushBuffer(D),E);M={data:[P],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(D),O.dispose()}},this.a.set(D,M)});return O}stopBuffering(D){this.a.get(D)?.dispose()}flushBuffer(D){const N=this.a.get(D);N&&(this.a.delete(D),this.b(D,N.data.join("")))}}e.TerminalDataBufferer=n}),define(Te[173],Pe([1,0,17,84,39,4,9,2,138,69,30]),function(te,e,n,A,D,N,E,O,S,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var T;(function(R){function v(i,d){let s=i.defaults;for(;D.ThemeIcon.isThemeIcon(s);){const l=f.getIcon(s.id);if(!l)return;s=l.defaults}return s}R.getDefinition=v})(T=e.IconContribution||(e.IconContribution={}));var m;(function(R){function v(d){return{weight:d.weight,style:d.style,src:d.src.map(s=>({format:s.format,location:s.location.toString()}))}}R.toJSONObject=v;function i(d){const s=l=>(0,E.isString)(l)?l:void 0;if(d&&Array.isArray(d.src)&&d.src.every(l=>(0,E.isString)(l.format)&&(0,E.isString)(l.location)))return{weight:s(d.weight),style:s(d.style),src:d.src.map(l=>({format:l.format,location:O.URI.parse(l.location)}))}}R.fromJSONObject=i})(m=e.IconFontDefinition||(e.IconFontDefinition={}));class w{constructor(){this.a=new N.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${D.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,i,d,s){const l=this.b[v];if(l){if(d&&!l.description){l.description=d,this.d.properties[v].markdownDescription=`${d} $(${v})`;const r=this.e.enum.indexOf(v);r!==-1&&(this.e.enumDescriptions[r]=d),this.a.fire()}return l}const o={id:v,description:d,defaults:i,deprecationMessage:s};this.b[v]=o;const I={$ref:"#/definitions/icons"};return s&&(I.deprecationMessage=s),d&&(I.markdownDescription=`${d}: $(${v})`),this.d.properties[v]=I,this.e.enum.push(v),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const i=this.e.enum.indexOf(v);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,i){const d=this.f[v];return d||(this.f[v]=i,this.a.fire(),i)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(l,o)=>l.id.localeCompare(o.id),i=l=>{for(;D.ThemeIcon.isThemeIcon(l.defaults);)l=this.b[l.defaults.id];return`codicon codicon-${l?l.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(l=>this.b[l]);for(const l of s.filter(o=>!!o.description).sort(v))d.push(`|<i class="${i(l)}"></i>|${l.id}|${D.ThemeIcon.isThemeIcon(l.defaults)?l.defaults.id:l.id}|${l.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const l of s.filter(o=>!D.ThemeIcon.isThemeIcon(o.defaults)).sort(v))d.push(`|<i class="${i(l)}"></i>|${l.id}|`);return d.join(`
`)}}const f=new w;M.Registry.add(e.Extensions.IconContribution,f);function u(R,v,i,d){return f.registerIcon(R,v,i,d)}e.registerIcon=u;function t(){return f}e.getIconRegistry=t;function a(){const R=(0,A.getCodiconFontCharacters)();for(const v in R){const i="\\"+R[v].toString(16);f.registerIcon(v,{fontCharacter:i})}}a(),e.iconsSchemaId="vscode://schemas/icons";const p=M.Registry.as(P.Extensions.JSONContribution);p.registerSchema(e.iconsSchemaId,f.getIconSchema());const b=new n.RunOnceScheduler(()=>p.notifySchemaChanged(e.iconsSchemaId),200);f.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=u("widget-close",A.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=u("goto-previous-location",A.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=u("goto-next-location",A.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=D.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=D.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(Te[174],Pe([1,0,4,42,3,12]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var E;(function(u){u.Http="http",u.Https="https"})(E=e.TunnelProtocol||(e.TunnelProtocol={}));var O;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(O=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(!!t)return{address:t[1],port:+t[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function M(u){return e.LOCALHOST_ADDRESSES.indexOf(u)>=0}e.isLocalhost=M,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function T(u){return e.ALL_INTERFACES_ADDRESSES.indexOf(u)>=0}e.isAllInterfaces=T;function m(u,t,a,p){if(a===1)return!1;if(a===2&&T(t)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(b?.length===4&&parseInt(b[1])>=18)return!1}return u<1024}e.isPortPrivileged=m;class w{constructor(t,a,p){this.remoteAddress=t,this.localAddress=a,this.b=p,this.a=new n.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=w;let f=class{constructor(t,a){this.i=t,this.j=a,this.a=new n.Emitter,this.onTunnelOpened=this.a.event,this.b=new n.Emitter,this.onTunnelClosed=this.b.event,this.c=new n.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const t=this.j.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.e=t,t?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.f=t.elevation,this.g=t.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const t=[],a=Array.from(this.d.values());for(const p of a){const b=Array.from(p.values());for(const R of b){const v=await R.value;v&&t.push(v)}}return t}async dispose(){for(const t of this.d.values()){for(const{value:a}of t.values())await a.then(p=>p?.dispose());t.clear()}this.d.clear()}setEnvironmentTunnel(t,a,p,b,R){this.o(t,a,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:a,localAddress:p,privacy:b,protocol:R,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,a){(T(t)||M(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const p=this.q(t,a);if(p)return++p.refcount,p.value}openTunnel(t,a,p,b,R,v=!1,i,d){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${p} on local port ${R}.`),!t)return;if(a||(a="localhost"),b||(b=this.k),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(t,a,p,b,R,v,i,d);return s?s.then(l=>{if(!l){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(a,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(l);return(l.tunnelRemoteHost!==a||l.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const a=this.d.get(t.tunnelRemoteHost);if(a){const p=a.get(t.tunnelRemotePort);p&&(p.refcount--,await this.n(t.tunnelRemoteHost,t.tunnelRemotePort,p))}}}}async n(t,a,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${a}.`);const b=p.value.then(async R=>{R&&(await R.dispose(!0),this.b.fire({host:R.tunnelRemoteHost,port:R.tunnelRemotePort}))});return this.d.has(t)&&this.d.get(t).delete(a),b}}async closeTunnel(t,a){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${a} `);const p=this.d.get(t);if(p&&p.has(a)){const b=p.get(a);b.refcount=0,await this.n(t,a,b)}}o(t,a,p){this.d.has(t)||this.d.set(t,new Map),this.d.get(t).set(a,{refcount:1,value:p})}async p(t,a){const p=this.d.get(t);p&&(await p.get(a)||p.delete(a),p.size===0&&this.d.delete(t))}q(t,a){const p=[t];M(t)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):T(t)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const b=p.map(R=>this.d.get(R));for(const R of b){const v=R?.get(a);if(v)return v}}canTunnel(t){return!!P(t)}s(t,a,p,b,R,v,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${p} on local port ${b}.`);const d=p;this.h.add(d);const s=b===void 0?p:b,l={elevationRequired:R?this.isPortPrivileged(s):!1},o={remoteAddress:{host:a,port:p},localAddressPort:b,privacy:v,public:v?v!==O.Private:void 0,protocol:i},I=t.forwardPort(o,l);return I?(this.o(a,p,I),I.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(d)})):this.h.delete(d),I}};f=qe([Ve(0,N.ILogService),Ve(1,A.IConfigurationService)],f),e.AbstractTunnelService=f}),define(Te[175],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var A;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(A=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Te[176],Pe([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(S){return S.scheme!==n.Schemas.file&&S.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=A;function D(S){if(S.folders.length)return S.folders.every(P=>A(P.uri))?S.folders[0].uri:void 0;if(S.configuration&&A(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=D;function N(S){return D(S)?.scheme}e.getVirtualWorkspaceScheme=N;function E(S){return D(S)?.authority}e.getVirtualWorkspaceAuthority=E;function O(S){return D(S)!==void 0}e.isVirtualWorkspace=O}),define(Te[53],Pe([1,0,139,19,48,22,2,3,15]),function(te,e,n,A,D,N,E,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,O.createDecorator)("contextService");function P(l){const o=l;return typeof o?.id=="string"&&E.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=P;function M(l){return typeof l?.id=="string"&&!P(l)&&!m(l)}e.isEmptyWorkspaceIdentifier=M,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function T(l,o){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,A.basename)(l)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const I=l;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}e.toWorkspaceIdentifier=T;function m(l){const o=l;return typeof o?.id=="string"&&E.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=m;function w(l){const o=l;if(o?.uri)return{id:o.id,uri:E.URI.revive(o.uri)};const I=l;if(I?.configPath)return{id:I.id,configPath:E.URI.revive(I.configPath)};if(l?.id)return{id:l.id}}e.reviveIdentifier=w;var f;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function u(l){const o=l;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=u;function t(l){const o=l;return!!(o&&typeof o=="object"&&E.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=t;class a{constructor(o,I,r,c,h){this.h=o,this.j=r,this.k=c,this.l=h,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=I}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=a;class p{constructor(o,I){this.raw=I,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,N.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function b(l){return new p({uri:l,index:0,name:(0,N.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function R(l,o){return N.extUriBiasedIgnorePathCase.isEqualOrParent(l,o.untitledWorkspacesHome)}e.isUntitledWorkspace=R;function v(l){let o;return E.URI.isUri(l)?o=l:o=l.configuration,o?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=v,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(l){return l.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function d(l,o){return!R(l,o)&&!v(l)}e.isSavedWorkspace=d;function s(l){return(typeof l=="string"?(0,A.extname)(l):(0,N.extname)(l))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Te[54],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(D){this.d=D,this.b=new Map,this.c=1}add(D){const N=this.c++;return this.b.set(N,D),this.e(),N}get(D,N){return this.b.has(D)?this.b.get(D)[N]:void 0}delete(D){this.b.delete(D),this.e()}e(){!n.a||console.log(`${this.d} cache size - ${this.b.size}`)}}n.a=!1,e.Cache=n}),define(Te[37],Pe([1,0,15,22,3]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class N{constructor(){this.a=new Set(Object.keys(n.Schemas)),this.b=new Map,this.extUri=new A.ExtUri(O=>{const S=this.b.get(O.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(O,S){S===null?this.b.delete(O.scheme):this.b.set(O.scheme,S)}isFreeScheme(O){return!this.b.has(O)&&!this.a.has(O)}getCapabilities(O){return this.b.get(O)}}e.ExtHostFileSystemInfo=N,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(Te[27],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Te[177],Pe([1,0,12,163,27]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let N=class extends A.LogService{constructor(O,S){super(O.createLogger(S.logFile,{name:S.logName}))}};N=qe([Ve(0,n.ILoggerService),Ve(1,D.IExtHostInitDataService)],N),e.ExtHostLogService=N}),define(Te[178],Pe([1,0,17]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(E,O,S){this.h=new Map,this.a=E,this.b=O,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(P=>(this.f=P,this)),this.g=this.c.onDidChangeStorage(P=>{P.shared===this.b&&P.key===this.a&&(this.f=P.value)}),this.i=new n.RunOnceScheduler(()=>{const P=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of P.values())M.complete()}catch(M){for(const T of P.values())T.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,E])=>E!==void 0).map(([E])=>E)}get whenReady(){return this.d}get(E,O){let S=this.f[E];return typeof S>"u"&&(S=O),S}update(E,O){this.f[E]=O;const S=this.h.get(E);if(S!==void 0)return S.p;const P=new n.DeferredPromise;return this.h.set(E,P),this.i.isScheduled()||this.i.schedule(),P.p}dispose(){this.g.dispose()}}e.ExtensionMemento=A;class D extends A{setKeysForSync(E){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},E)}constructor(E,O){super(E.identifier.value,!0,O),this.j=E}}e.ExtensionGlobalMemento=D}),define(Te[179],Pe([1,0,4,2]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(E){this.c=E,this.a=new n.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new n.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(E,O,S,P){const T=this.c.getNotebookDocument(A.URI.revive(E)).acceptModelChanged(O.value,S,P);this.b.fire(T)}$acceptDirtyStateChanged(E,O){this.c.getNotebookDocument(A.URI.revive(E)).acceptDirty(O)}$acceptModelSaved(E){const O=this.c.getNotebookDocument(A.URI.revive(E));this.a.fire(O.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(Te[18],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class A{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.ExtHostRpcService=A});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,A,D){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Fe=this&&this.__classPrivateFieldGet||function(te,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!A:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(te):A?A.value:e.get(te)};define(Te[180],Pe([1,0,24,4]),function(te,e,n,A){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class N{constructor(O,S){D.set(this,void 0),this.b=new A.Emitter,this.onDidChange=this.b.event,this.a=n.ExtensionIdentifier.toKey(O.identifier),Je(this,D,S,"f"),Fe(this,D,"f").onDidChangePassword(P=>{P.extensionId===this.a&&this.b.fire({key:P.key})})}get(O){return Fe(this,D,"f").get(this.a,O)}store(O,S){return Fe(this,D,"f").store(this.a,O,S)}delete(O){return Fe(this,D,"f").delete(this.a,O)}}e.ExtensionSecrets=N,D=new WeakMap}),define(Te[70],Pe([1,0,3,174,4,18]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var E;(function(S){function P(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public,privacy:T.privacy??(T.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:T.protocol}}S.fromApiTunnel=P;function M(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.privacy!==A.TunnelPrivacyId.ConstantPrivate&&T.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:T.privacy,protocol:T.protocol}}S.fromServiceTunnel=M})(E=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let O=class{constructor(P){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,M){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,M){return{dispose:()=>{}}}async $providePortAttributes(P,M,T,m,w){return[]}async $forwardPort(P,M){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};O=qe([Ve(0,N.IExtHostRpcService)],O),e.ExtHostTunnelService=O}),define(Te[55],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class A{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=E=>E,this.transformOutgoing=E=>E,this.transformOutgoingURI=E=>E,this.transformOutgoingScheme=E=>E)}}e.URITransformerService=A}),define(Te[181],Pe([1,0,25]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(S){let P=this.buffers.indexOf(S);return P<0&&(P=this.buffers.length,this.buffers.push(S)),P}}function D(O,S){if(S.serializeBuffersForPostMessage){const P=new A,M=(w,f)=>{if(f instanceof ArrayBuffer){const u=P.add(f);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(f)){const u=N(f);if(u){const t=P.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:t,view:{type:u,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},T=JSON.stringify(O,M),m=P.buffers.map(w=>{const f=new Uint8Array(w);return n.VSBuffer.wrap(f)});return{message:T,buffers:m}}else return{message:JSON.stringify(O),buffers:[]}}e.serializeWebviewMessage=D;function N(O){switch(O.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function E(O,S){const P=S.map(m=>{const w=new ArrayBuffer(m.byteLength);return new Uint8Array(w).set(m.buffer),w}),M=S.length?(m,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const f=w,{index:u}=f,t=P[u];if(f.view)switch(f.view.type){case 1:return new Int8Array(t,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return w}:void 0;return{message:JSON.parse(O,M),arrayBuffers:P}}e.deserializeWebviewMessage=E}),define(Te[96],Pe([1,0,148,9,2,6,3,30,43,15,40,125,29]),function(te,e,n,A,D,N,E,O,S,P,M,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var w;(function(de){de[de.PROGRAMMATIC=1]="PROGRAMMATIC",de[de.USER=2]="USER",de[de.EDIT=3]="EDIT",de[de.NAVIGATION=4]="NAVIGATION",de[de.JUMP=5]="JUMP"})(w=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var f;(function(de){de[de.IDENTICAL=1]="IDENTICAL",de[de.SIMILAR=2]="SIMILAR",de[de.DIFFERENT=3]="DIFFERENT"})(f=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function u(de){const ie=de;return!!ie&&typeof ie.getSelection=="function"&&!!ie.onDidChangeSelection}e.isEditorPaneWithSelection=u;function t(de,ie,q){for(const ce of q.visibleEditorPanes)if(ce.group.id===ie&&de.matches(ce.input))return ce.getViewState()}e.findViewStateForEditor=t;function a(de){if(c(de))return!1;const ie=de;return D.URI.isUri(ie?.resource)}e.isResourceEditorInput=a;function p(de){if(c(de))return!1;const ie=de;return ie?.original!==void 0&&ie.modified!==void 0}e.isResourceDiffEditorInput=p;function b(de){if(c(de)||p(de))return!1;const ie=de;return ie?.primary!==void 0&&ie.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function R(de){if(c(de))return!1;const ie=de;return ie?ie.resource===void 0||ie.resource.scheme===P.Schemas.untitled||ie.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=R;const v=/Untitled-\d+/;function i(de){return de.scheme===P.Schemas.untitled&&de.path.length>1&&!v.test(de.path)}e.isUntitledWithAssociatedResource=i;function d(de){if(c(de))return!1;const ie=de;return D.URI.isUri(ie?.base?.resource)&&D.URI.isUri(ie?.input1?.resource)&&D.URI.isUri(ie?.input2?.resource)&&D.URI.isUri(ie?.result?.resource)}e.isResourceMergeEditorInput=d;var s;(function(de){de[de.SHORT=0]="SHORT",de[de.MEDIUM=1]="MEDIUM",de[de.LONG=2]="LONG"})(s=e.Verbosity||(e.Verbosity={}));var l;(function(de){de[de.EXPLICIT=1]="EXPLICIT",de[de.AUTO=2]="AUTO",de[de.FOCUS_CHANGE=3]="FOCUS_CHANGE",de[de.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.a=new Map}registerSource(ie,q){let ce=this.a.get(ie);return ce||(ce={source:ie,label:q},this.a.set(ie,ce)),ce.source}getSourceLabel(ie){return this.a.get(ie)?.label??ie}}e.SaveSourceRegistry=new o;var I;(function(de){de[de.None=0]="None",de[de.Readonly=2]="Readonly",de[de.Untitled=4]="Untitled",de[de.Singleton=8]="Singleton",de[de.RequiresTrust=16]="RequiresTrust",de[de.CanSplitInGroup=32]="CanSplitInGroup",de[de.ForceDescription=64]="ForceDescription",de[de.CanDropIntoEditor=128]="CanDropIntoEditor",de[de.MultipleEditors=256]="MultipleEditors"})(I=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends N.Disposable{}e.AbstractEditorInput=r;function c(de){return de instanceof r}e.isEditorInput=c;function h(de){const ie=de;return D.URI.isUri(ie?.preferredResource)}function y(de){const ie=de;return c(ie?.primary)&&c(ie?.secondary)}e.isSideBySideEditorInput=y;function C(de){const ie=de;return c(ie?.modified)&&c(ie?.original)}e.isDiffEditorInput=C;function H(de,ie,q,ce,be){return De(ce,[(0,T.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const Ae={...q,limits:{size:Number.MAX_VALUE}};de.openEditor(ie,Ae)}}),(0,T.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>be.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.createTooLargeFileError=H;function K(de){return c(de?.editor)}e.isEditorInputWithOptions=K;function Q(de){const ie=de;return K(de)&&ie?.group!==void 0}e.isEditorInputWithOptionsAndGroup=Q;function _(de){const ie=de;return typeof ie?.groupId=="number"&&c(ie.editor)}e.isEditorIdentifier=_;var j;(function(de){de[de.UNKNOWN=0]="UNKNOWN",de[de.REPLACE=1]="REPLACE",de[de.MOVE=2]="MOVE",de[de.UNPIN=3]="UNPIN"})(j=e.EditorCloseContext||(e.EditorCloseContext={}));var L;(function(de){de[de.GROUP_ACTIVE=0]="GROUP_ACTIVE",de[de.GROUP_INDEX=1]="GROUP_INDEX",de[de.GROUP_LOCKED=2]="GROUP_LOCKED",de[de.EDITOR_OPEN=3]="EDITOR_OPEN",de[de.EDITOR_CLOSE=4]="EDITOR_CLOSE",de[de.EDITOR_MOVE=5]="EDITOR_MOVE",de[de.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",de[de.EDITOR_LABEL=7]="EDITOR_LABEL",de[de.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",de[de.EDITOR_PIN=9]="EDITOR_PIN",de[de.EDITOR_STICKY=10]="EDITOR_STICKY",de[de.EDITOR_DIRTY=11]="EDITOR_DIRTY",de[de.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(L=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var g;(function(de){de[de.PRIMARY=1]="PRIMARY",de[de.SECONDARY=2]="SECONDARY",de[de.BOTH=3]="BOTH",de[de.ANY=4]="ANY"})(g=e.SideBySideEditor||(e.SideBySideEditor={}));class F{getOriginalUri(ie,q){if(!ie)return;if(d(ie))return e.EditorResourceAccessor.getOriginalUri(ie.result,q);if(q?.supportSideBySide){const{primary:be,secondary:Ae}=this.a(ie);if(be&&Ae){if(q?.supportSideBySide===g.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(Ae,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===g.ANY)return this.getOriginalUri(be,{filterByScheme:q.filterByScheme})??this.getOriginalUri(Ae,{filterByScheme:q.filterByScheme});ie=q.supportSideBySide===g.PRIMARY?be:Ae}}if(p(ie)||b(ie)||d(ie))return;const ce=h(ie)?ie.preferredResource:ie.resource;return!ce||!q||!q.filterByScheme?ce:this.b(ce,q.filterByScheme)}a(ie){return y(ie)||b(ie)?{primary:ie.primary,secondary:ie.secondary}:C(ie)||p(ie)?{primary:ie.modified,secondary:ie.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ie,q){if(!ie)return;if(d(ie))return e.EditorResourceAccessor.getCanonicalUri(ie.result,q);if(q?.supportSideBySide){const{primary:be,secondary:Ae}=this.a(ie);if(be&&Ae){if(q?.supportSideBySide===g.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(Ae,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===g.ANY)return this.getCanonicalUri(be,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(Ae,{filterByScheme:q.filterByScheme});ie=q.supportSideBySide===g.PRIMARY?be:Ae}}if(p(ie)||b(ie)||d(ie))return;const ce=ie.resource;return!ce||!q||!q.filterByScheme?ce:this.b(ce,q.filterByScheme)}b(ie,q){if(Array.isArray(q)){if(q.some(ce=>ie.scheme===ce))return ie}else if(q===ie.scheme)return ie}}e.EditorResourceAccessor=new F;var B;(function(de){de[de.LEFT=0]="LEFT",de[de.RIGHT=1]="RIGHT"})(B=e.CloseDirection||(e.CloseDirection={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(ie){const q=this.a=ie.get(E.IInstantiationService);for(const[ce,be]of this.c)this.e(ce,be,q);this.c.clear()}e(ie,q,ce){const be=ce.createInstance(q);this.d.set(ie,be)}registerFileEditorFactory(ie){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ie}getFileEditorFactory(){return(0,A.assertIsDefined)(this.b)}registerEditorSerializer(ie,q){if(this.c.has(ie)||this.d.has(ie))throw new Error(`A editor serializer with type ID '${ie}' was already registered.`);return this.a?this.e(ie,q,this.a):this.c.set(ie,q),(0,N.toDisposable)(()=>{this.c.delete(ie),this.d.delete(ie)})}getEditorSerializer(ie){return this.d.get(typeof ie=="string"?ie:ie.typeId)}}O.Registry.add(e.EditorExtensions.EditorFactory,new Y);async function me(de,ie,q){return!de||!de.length?[]:await Promise.all(de.map(async ce=>{const be=D.URI.revive(ce.fileUri);if(!be){q.info("Cannot resolve the path because it is not valid.",ce);return}if(!await ie.canHandleResource(be)){q.info("Cannot resolve the path because it cannot be handled",ce);return}let Ue=ce.exists,Ce=ce.type;if(typeof Ue!="boolean"||typeof Ce!="number")try{Ce=(await ie.stat(be)).isDirectory?S.FileType.Directory:S.FileType.Unknown,Ue=!0}catch(ke){q.error(ke),Ue=!1}if(!Ue&&ce.openOnlyIfExists){q.info("Cannot resolve the path because it does not exist",ce);return}if(Ce===S.FileType.Directory){q.info("Cannot resolve the path because it is a directory",ce);return}const Se={...ce.options,pinned:!0};return Ue?{resource:be,options:Se}:{resource:be,options:Se,forceUntitled:!0}}))}e.pathsToEditors=me;var Z;(function(de){de[de.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",de[de.SEQUENTIAL=1]="SEQUENTIAL"})(Z=e.EditorsOrder||(e.EditorsOrder={}));function se(de){const ie=de;if(!ie)return!1;const q=ie;if(q.modified)return se(q.modified);const ce=ie;return!!(ce.contributionsState&&ce.viewState&&Array.isArray(ce.cursorState))}e.isTextEditorViewState=se;function ue(de){return(0,M.isErrorWithActions)(de)}e.isEditorOpenError=ue;function De(de,ie,q){const ce=(0,M.createErrorWithActions)(de,ie);return ce.forceMessage=q?.forceMessage,ce.forceSeverity=q?.forceSeverity,ce.allowDialog=q?.allowDialog,ce}e.createEditorOpenError=De}),define(Te[182],Pe([1,0,4,149,3,6,28,30,16,63,23,84,173]),function(te,e,n,A,D,N,E,O,S,P,M,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",T.Codicon.window,(0,A.localize)(0,null));var w;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(w=e.Extensions||(e.Extensions={}));var f;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(f=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function u(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=u;class t extends N.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new n.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.flatten)([...this.g.values()])}registerViewContainer(l,o,I){const r=this.get(l.id);if(r)return r;const c=l;return c.openCommandActionDescriptor=I?.doNotRegisterOpenCommand?void 0:c.openCommandActionDescriptor??{id:c.id},(0,E.getOrSet)(this.g,o,[]).push(c),I?.isDefault&&this.h.push(c),this.c.fire({viewContainer:c,viewContainerLocation:o}),c}deregisterViewContainer(l){for(const o of this.g.keys()){const I=this.g.get(o),r=I?.indexOf(l);if(r!==-1){I?.splice(r,1),I.length===0&&this.g.delete(o),this.f.fire({viewContainer:l,viewContainerLocation:o});return}}}get(l){return this.all.filter(o=>o.id===l)[0]}getViewContainers(l){return[...this.g.get(l)||[]]}getViewContainerLocation(l){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(I=>I?.id===l.id).length>0)[0]}getDefaultViewContainer(l){return this.h.find(o=>this.getViewContainerLocation(o)===l)}}O.Registry.add(w.ViewContainersRegistry,new t);var a;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(a=e.ViewContentGroups||(e.ViewContentGroups={}));function p(s,l){const o=s.group??a.More,I=l.group??a.More;return o!==I?o.localeCompare(I):(s.order??5)-(l.order??5)}class b extends N.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new n.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new n.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new n.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new P.SetMap}registerViews(l,o){this.registerViews2([{views:l,viewContainer:o}])}registerViews2(l){l.forEach(({views:o,viewContainer:I})=>this.l(o,I)),this.c.fire(l)}deregisterViews(l,o){const I=this.m(l,o);I.length&&this.f.fire({views:I,viewContainer:o})}moveViews(l,o){for(const I of this.j.keys())if(I!==o){const r=this.m(l,I);r.length&&(this.l(r,o),this.g.fire({views:r,from:I,to:o}))}}getViews(l){return this.j.get(l)||[]}getView(l){for(const o of this.i){const I=(this.j.get(o)||[]).filter(r=>r.id===l)[0];if(I)return I}return null}getViewContainer(l){for(const o of this.i)if((this.j.get(o)||[]).filter(r=>r.id===l)[0])return o;return null}registerViewWelcomeContent(l,o){return this.k.add(l,o),this.h.fire(l),(0,N.toDisposable)(()=>{this.k.delete(l,o),this.h.fire(l)})}registerViewWelcomeContent2(l,o){const I=new Map;for(const[r,c]of o)this.k.add(l,c),I.set(r,(0,N.toDisposable)(()=>{this.k.delete(l,c),this.h.fire(l)}));return this.h.fire(l),I}getViewWelcomeContent(l){const o=[];return this.k.forEach(l,I=>o.push(I)),o.sort(p)}l(l,o){let I=this.j.get(o);I||(I=[],this.j.set(o,I),this.i.push(o));for(const r of l){if(this.getView(r.id)!==null)throw new Error((0,A.localize)(1,null,r.id));I.push(r)}}m(l,o){const I=this.j.get(o);if(!I)return[];const r=[],c=[];for(const h of I)l.includes(h)?r.push(h):c.push(h);return r.length&&(c.length?this.j.set(o,c):(this.j.delete(o),this.i.splice(this.i.indexOf(o),1))),r}}O.Registry.add(w.ViewsRegistry,new b),e.IViewsService=(0,D.createDecorator)("viewsService"),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var R;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(R=e.ViewVisibilityState||(e.ViewVisibilityState={}));var v;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(v=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(l,o){this.c=!1,this.d=!1,(0,M.mixin)(this,l),this.d=!!o,this.resolve=async I=>{if(o&&!this.c){const r=await o(I);r&&(this.tooltip=this.tooltip??r.tooltip,this.command=this.command??r.command)}I.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class d extends Error{constructor(l){super((0,A.localize)(2,null,l))}}e.NoTreeViewError=d}),define(Te[183],Pe([1,0,4,17,150]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class N{constructor(){this.f=new Map,this.k=[],this.m=new n.Emitter,this.n=new n.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(O){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=O}onEvent(O){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=O}onRequest(O){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.s("response",O)}sendRequest(O,S,P,M){const T={command:O};if(S&&Object.keys(S).length>0&&(T.arguments=S),this.s("request",T),typeof M=="number"){const m=setTimeout(()=>{clearTimeout(m);const w=this.f.get(T.seq);if(w){this.f.delete(T.seq);const f={type:"response",seq:0,request_seq:T.seq,success:!1,command:O,message:(0,D.localize)(0,null,M,O)};w(f)}},M)}return P&&this.f.set(T.seq,P),T.seq}acceptMessage(O){this.j?this.j(O):(this.k.push(O),this.k.length===1&&this.q())}o(O,S){return O.type!=="event"||S.type!=="event"}async q(){let O;for(;this.k.length;){if((!O||this.o(this.k[0],O))&&await(0,A.timeout)(0),O=this.k.shift(),!O)return;switch(O.type){case"event":this.i?.(O);break;case"request":this.g?.(O);break;case"response":{const S=O,P=this.f.get(S.request_seq);P&&(this.f.delete(S.request_seq),P(S));break}}}}s(O,S){S.type=O,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach((S,P)=>O.set(P,S)),await(0,A.timeout)(500),O.forEach((S,P)=>{S({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.f.delete(P)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=N}),define(Te[184],Pe([1,0,151,36,3]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const N=m=>n.localize(51,null,m);e.debuggerDisabledMessage=N,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var E;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(E=e.State||(e.State={}));function O(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=O;var S;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var M;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(M=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,D.createDecorator)("debugService");var T;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(T=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Te[185],Pe([1,0,10,2,19,23,15,44,21,16]),function(te,e,n,A,D,N,E,O,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const M=/{([^}]+)}/g;function T(r,c,h){return r.replace(M,function(y,C){return c&&C.length>0&&C[0]!=="_"?y:h&&h.hasOwnProperty(C)?h[C]:y})}e.formatPII=T;function m(r){const c={};for(const h of Object.keys(r))h.startsWith("!")||(c[h]=r[h]);return c}e.filterExceptionsFromTelemetry=m;function w(r){return r.configuration.request==="attach"&&!f(r)&&(!r.parentSession||w(r.parentSession))}e.isSessionAttach=w;function f(r){let c=r.configuration.type;if(!!c)return c==="vslsShare"&&(c=r.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(c,"extensionhost")||(0,n.equalsIgnoreCase)(c,"pwa-extensionhost")?r:r.parentSession?f(r.parentSession):void 0}e.getExtensionHostDebugSession=f;function u(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=u;function t(r,c,h){let y,C=0;const H=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let K=null;for(;K=H.exec(r);){const Q=K.index+1,_=Q+K[0].length;if(Q<=c&&_>=h){y=K[0],C=Q;break}}if(y){const Q=/\w+/g;let _=null;for(;(_=Q.exec(y))&&!(_.index+1+C+_[0].length>=h););_&&(y=y.substring(0,Q.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function a(r,c,h,y){if(r.evaluatableExpressionProvider.has(c)){const C=r.evaluatableExpressionProvider.ordered(c),H=(0,P.coalesce)(await Promise.all(C.map(async K=>{try{return await K.provideEvaluatableExpression(c,h,y??S.CancellationToken.None)}catch{return}})));if(H.length>0){let K=H[0].expression;const Q=H[0].range;return K||(K=c.getLineContent(h.lineNumber).substring(Q.startColumn-1,Q.endColumn-1)),{range:Q,matchingExpression:K}}}else{const C=c.getLineContent(h.lineNumber),{start:H,end:K}=t(C,h.column,h.column),Q=C.substring(H-1,K);return{matchingExpression:Q,range:new O.Range(h.lineNumber,H,h.lineNumber,H+Q.length)}}return null}e.getEvaluatableExpressionAtPosition=a;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(r){return!!(r&&r.match(p))}e.isUri=b;function R(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(b(r.path))return A.URI.parse(r.path);if((0,D.isAbsolute)(r.path))return A.URI.file(r.path)}return r.path}function v(r){if(typeof r.path=="object"){const c=A.URI.revive(r.path);if(c)return c.scheme===E.Schemas.file?c.fsPath:c.toString()}return r.path}function i(r,c){const h=c?R:v,y=(0,N.deepClone)(r);return s(y,(C,H)=>{C&&H&&(H.path=h(H))}),y}e.convertToDAPaths=i;function d(r,c){const h=c?R:v,y=(0,N.deepClone)(r);return s(y,(C,H)=>{!C&&H&&(H.path=h(H))}),y}e.convertToVSCPaths=d;function s(r,c){switch(r.type){case"event":{const h=r;switch(h.event){case"output":c(!1,h.body.source);break;case"loadedSource":c(!1,h.body.source);break;case"breakpoint":c(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=r;switch(h.command){case"setBreakpoints":c(!0,h.arguments.source);break;case"breakpointLocations":c(!0,h.arguments.source);break;case"source":c(!0,h.arguments.source);break;case"gotoTargets":c(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(y=>c(!1,y));break;default:break}break}case"response":{const h=r;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(y=>c(!1,y.source));break;case"loadedSources":h.body.sources.forEach(y=>c(!1,y));break;case"scopes":h.body.scopes.forEach(y=>c(!1,y.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(y=>c(!1,y.source));break;case"setBreakpoints":h.body.breakpoints.forEach(y=>c(!1,y.source));break;case"disassemble":h.body?.instructions.forEach(C=>c(!1,C.location));break;default:break}break}}}function l(r){return r.filter(c=>!c.presentation?.hidden).sort((c,h)=>c.presentation?h.presentation?c.presentation.group?h.presentation.group?c.presentation.group!==h.presentation.group?c.presentation.group.localeCompare(h.presentation.group):o(c.presentation.order,h.presentation.order):-1:h.presentation.group?1:o(c.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=l;function o(r,c){return typeof r!="number"?typeof c!="number"?0:1:typeof c!="number"?-1:r-c}async function I(r,c){const h=r.getValue("debug.saveBeforeStart",{overrideIdentifier:c.activeTextEditorLanguageId});if(h!=="none"&&(await c.saveAll(),h==="allEditorsInActiveGroup")){const y=c.activeEditorPane;y&&y.input.resource?.scheme===E.Schemas.untitled&&await c.save({editor:y.input,groupId:y.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=I}),define(Te[71],Pe([1,0,25,35,186,65,15,19,20,36]),function(te,e,n,A,D,N,E,O,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var M;(function(g){g[g.Markup=1]="Markup",g[g.Code=2]="Code"})(M=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",N.Mimes.latex,N.Mimes.markdown,"image/png","image/jpeg",N.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[N.Mimes.latex,N.Mimes.markdown,"application/json",N.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(g){g[g.Running=1]="Running",g[g.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(g){g[g.Unconfirmed=1]="Unconfirmed",g[g.Pending=2]="Pending",g[g.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var w;(function(g){g[g.WithHardKernelDependency=0]="WithHardKernelDependency",g[g.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",g[g.Pure=2]="Pure",g[g.Never=3]="Never"})(w=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(g){g.Always="always",g.Never="never",g.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var u;(function(g){g[g.ModelChange=1]="ModelChange",g[g.Move=2]="Move",g[g.ChangeCellLanguage=5]="ChangeCellLanguage",g[g.Initialize=6]="Initialize",g[g.ChangeCellMetadata=7]="ChangeCellMetadata",g[g.Output=8]="Output",g[g.OutputItem=9]="OutputItem",g[g.ChangeCellContent=10]="ChangeCellContent",g[g.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",g[g.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",g[g.ChangeCellMime=13]="ChangeCellMime",g[g.Unknown=100]="Unknown"})(u=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var t;(function(g){g[g.Handle=0]="Handle",g[g.Index=1]="Index"})(t=e.SelectionStateType||(e.SelectionStateType={}));var a;(function(g){g[g.Replace=1]="Replace",g[g.Output=2]="Output",g[g.Metadata=3]="Metadata",g[g.CellLanguage=4]="CellLanguage",g[g.DocumentMetadata=5]="DocumentMetadata",g[g.Move=6]="Move",g[g.OutputItems=7]="OutputItems",g[g.PartialMetadata=8]="PartialMetadata",g[g.PartialInternalMetadata=9]="PartialInternalMetadata"})(a=e.CellEditType||(e.CellEditType={}));var p;(function(g){g.scheme=E.Schemas.vscodeNotebookCell;const F=["W","X","Y","Z","a","b","c","d","e","f"],B=new RegExp(`^[${F.join("")}]+`),Y=7;function me(ie,q){const ce=q.toString(Y),Ae=`${ce.length<F.length?F[ce.length-1]:"z"}${ce}s${(0,n.encodeBase64)(n.VSBuffer.fromString(ie.scheme),!0,!0)}`;return ie.with({scheme:g.scheme,fragment:Ae})}g.generate=me;function Z(ie){if(ie.scheme!==g.scheme)return;const q=ie.fragment.indexOf("s");if(q<0)return;const ce=parseInt(ie.fragment.substring(0,q).replace(B,""),Y),be=(0,n.decodeBase64)(ie.fragment.substring(q+1)).toString();if(!isNaN(ce))return{handle:ce,notebook:ie.with({scheme:be,fragment:null})}}g.parse=Z;function se(ie,q){return ie.with({scheme:E.Schemas.vscodeNotebookCellOutput,fragment:`op${q??""},${ie.scheme!==E.Schemas.file?ie.scheme:""}`})}g.generateCellOutputUri=se;function ue(ie){if(ie.scheme!==E.Schemas.vscodeNotebookCellOutput)return;const q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ie.fragment);if(!q)return;const ce=q[1]&&q[1]!==""?q[1]:void 0,be=q[2];return{outputId:ce,notebook:ie.with({scheme:be||E.Schemas.file,fragment:null})}}g.parseCellOutputUri=ue;function De(ie,q,ce){return g.generate(ie,q).with({scheme:ce})}g.generateCellPropertyUri=De;function de(ie,q){if(ie.scheme===q)return g.parse(ie.with({scheme:g.scheme}))}g.parseCellPropertyUri=de})(p=e.CellUri||(e.CellUri={}));const b=g=>S.isWindows?g.replace(/\//g,"\\"):g;class R{constructor(F=[],B=e.NOTEBOOK_DISPLAY_ORDER){this.e=B,this.d=[...new Set(F)].map(Y=>({pattern:Y,matches:A.parse(b(Y))}))}sort(F){const B=new Map(D.Iterable.map(F,me=>[me,b(me)]));let Y=[];for(const{matches:me}of this.d)for(const[Z,se]of B)if(me(se)){Y.push(Z),B.delete(Z);break}return B.size&&(Y=Y.concat([...B.keys()].sort((me,Z)=>this.e.indexOf(me)-this.e.indexOf(Z)))),Y}prioritize(F,B){const Y=this.f(F);if(Y===-1){this.d.unshift({pattern:F,matches:A.parse(b(F))});return}const me=new Set(B.map(se=>this.f(se,Y)));me.delete(-1);const Z=Array.from(me).sort();this.d.splice(Y+1,0,...Z.map(se=>this.d[se]));for(let se=Z.length-1;se>=0;se--)this.d.splice(Z[se],1)}toArray(){return this.d.map(F=>F.pattern)}f(F,B=this.d.length){const Y=b(F);for(let me=0;me<B;me++)if(this.d[me].matches(Y))return me;return-1}}e.MimeTypeDisplayOrder=R;function v(g,F,B,Y=(me,Z)=>me===Z){const me=[];function Z(De,de,ie){if(de===0&&ie.length===0)return;const q=me[me.length-1];q&&q.start+q.deleteCount===De?(q.deleteCount+=de,q.toInsert.push(...ie)):me.push({start:De,deleteCount:de,toInsert:ie})}let se=0,ue=0;for(;;){if(se===g.length){Z(se,0,F.slice(ue));break}if(ue===F.length){Z(se,g.length-se,[]);break}const De=g[se],de=F[ue];if(Y(De,de)){se+=1,ue+=1;continue}B(de)?(Z(se,1,[]),se+=1):(Z(se,0,[de]),ue+=1)}return me}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(g){g.default="default",g.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(g){const F=g;return!!((typeof F.include=="string"||A.isRelativePattern(F.include))&&(typeof F.exclude=="string"||A.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=d;function s(g,F,B){if(Array.isArray(g.viewType)&&g.viewType.indexOf(F)>=0||g.viewType===F)return!0;if(g.filenamePattern){const Y=d(g.filenamePattern)?g.filenamePattern.include:g.filenamePattern,me=d(g.filenamePattern)?g.filenamePattern.exclude:void 0;if(A.match(Y,(0,O.basename)(B.fsPath).toLowerCase()))return!(me&&A.match(me,(0,O.basename)(B.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",outputWordWrap:"notebook.output.wordWrap",logging:"notebook.logging"};var l;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(l=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(F){return`${o.d}${F}`}static parse(F){if(F.startsWith(o.d))return F.substring(o.d.length)}}o.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=o;function I(g){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(g)}e.isTextStreamMime=I;const r=new TextDecoder;function c(g){const F=[];let B=!1;for(const Y of g)(F.length===0||B)&&(F.push(Y),B=!0);return H(F),L(n.VSBuffer.concat(F.map(Y=>n.VSBuffer.wrap(Y))))}e.compressOutputItemStreams=c;const h=`${String.fromCharCode(27)}[A`,y=h.split("").map(g=>g.charCodeAt(0)),C=10;function H(g){g.forEach((F,B)=>{if(B===0||F.length<h.length)return;const Y=g[B-1],me=F.subarray(0,h.length);if(me[0]===y[0]&&me[1]===y[1]&&me[2]===y[2]){const Z=Y.lastIndexOf(C);if(Z===-1)return;g[B-1]=Y.subarray(0,Z),g[B]=F.subarray(h.length)}})}function K(g){let F=g;do g=F,F=g.replace(/[^\n]\x08/gm,"");while(F.length<g.length);return g}function Q(g){for(g=g.replace(/\r+\n/gm,`
`);g.search(/\r[^$]/g)>-1;){const F=g.match(/^(.*)\r+/m)[1];let B=g.match(/\r+(.*)$/m)[1];B=B+F.slice(B.length,F.length),g=g.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return g}const _="\b".charCodeAt(0),j="\r".charCodeAt(0);function L(g){return!g.buffer.includes(_)&&!g.buffer.includes(j)?g:n.VSBuffer.fromString(Q(K(r.decode(g.buffer))))}}),define(Te[187],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(A=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Te[45],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(N){N.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class D{static fromExtHostTestItem(E,O,S=E.parent){if(E._isRoot)return new D([O]);const P=[E.id];for(let M=S;M&&M.id!==O;M=M.parent)P.push(M.id);return P.push(O),new D(P.reverse())}static isRoot(E){return!E.includes("\0")}static root(E){const O=E.indexOf("\0");return O===-1?E:E.slice(0,O)}static fromString(E){return new D(E.split("\0"))}static join(E,O){return new D([...E.path,O])}static joinToString(E,O){return E.toString()+"\0"+O}static parentId(E){const O=E.lastIndexOf("\0");return O===-1?void 0:E.slice(0,O)}static localId(E){const O=E.lastIndexOf("\0");return O===-1?E:E.slice(O+1)}static compare(E,O){return E===O?0:O.startsWith(E+"\0")?2:E.startsWith(O+"\0")?3:1}constructor(E,O=E.length){if(this.path=E,this.d=O,E.length===0||O<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new D(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let E=1;E<=this.d;E++)yield new D(this.path,E)}*idsToRoot(){for(let E=this.d;E>0;E--)yield new D(this.path,E)}compare(E){if(typeof E=="string")return D.compare(this.toString(),E);for(let O=0;O<E.d&&O<this.d;O++)if(E.path[O]!==this.path[O])return 1;return E.d>this.d?2:E.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let E=1;E<this.d;E++)this.c+="\0",this.c+=this.path[E]}return this.c}}e.TestId=D}),define(Te[56],Pe([1,0,2,44,45]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var N;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(N=e.TestResultState||(e.TestResultState={}));var E;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable",r[r.SupportsContinuousRun=64]="SupportsContinuousRun"})(E=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const O=r=>"runId"in r;e.isStartControllerTests=O;var S;(function(r){r.serialize=c=>({range:c.range.toJSON(),uri:c.uri.toJSON()}),r.deserialize=c=>({range:A.Range.lift(c.range),uri:n.URI.revive(c.uri)})})(S=e.IRichLocation||(e.IRichLocation={}));var P;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(P=e.TestMessageType||(e.TestMessageType={}));var M;(function(r){r.serialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&S.serialize(c.location)}),r.deserialize=c=>({message:c.message,type:0,expected:c.expected,actual:c.actual,location:c.location&&S.deserialize(c.location)})})(M=e.ITestErrorMessage||(e.ITestErrorMessage={}));const T=(r,c)=>`${c?"s":"e"}${r}`;e.getMarkId=T;var m;(function(r){r.serialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&S.serialize(c.location)}),r.deserialize=c=>({message:c.message,type:1,offset:c.offset,length:c.length,location:c.location&&S.deserialize(c.location)})})(m=e.ITestOutputMessage||(e.ITestOutputMessage={}));var w;(function(r){r.serialize=c=>c.type===0?M.serialize(c):m.serialize(c),r.deserialize=c=>c.type===0?M.deserialize(c):m.deserialize(c)})(w=e.ITestMessage||(e.ITestMessage={}));var f;(function(r){r.serializeWithoutMessages=c=>({state:c.state,duration:c.duration,messages:[]}),r.serialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(w.serialize)}),r.deserialize=c=>({state:c.state,duration:c.duration,messages:c.messages.map(w.deserialize)})})(f=e.ITestTaskState||(e.ITestTaskState={}));const u="\0",t=(r,c)=>r+u+c;e.namespaceTestTag=t;const a=r=>{const c=r.indexOf(u);return{ctrlId:r.slice(0,c),tagId:r.slice(c+1)}};e.denamespaceTestTag=a;var p;(function(r){r.serialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?.toJSON(),range:c.range?.toJSON()||null,description:c.description,error:c.error,sortText:c.sortText}),r.deserialize=c=>({extId:c.extId,label:c.label,tags:c.tags,busy:c.busy,children:void 0,uri:c.uri?n.URI.revive(c.uri):void 0,range:c.range?A.Range.lift(c.range):null,description:c.description,error:c.error,sortText:c.sortText})})(p=e.ITestItem||(e.ITestItem={}));var b;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var R;(function(r){r.serialize=c=>({expand:c.expand,item:p.serialize(c.item)}),r.deserialize=c=>({controllerId:D.TestId.root(c.item.extId),expand:c.expand,item:p.deserialize(c.item)})})(R=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(r){r.serialize=c=>{let h;return c.item&&(h={},c.item.label!==void 0&&(h.label=c.item.label),c.item.tags!==void 0&&(h.tags=c.item.tags),c.item.busy!==void 0&&(h.busy=c.item.busy),c.item.uri!==void 0&&(h.uri=c.item.uri?.toJSON()),c.item.range!==void 0&&(h.range=c.item.range?.toJSON()),c.item.description!==void 0&&(h.description=c.item.description),c.item.error!==void 0&&(h.error=c.item.error),c.item.sortText!==void 0&&(h.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:h}},r.deserialize=c=>{let h;return c.item&&(h={},c.item.label!==void 0&&(h.label=c.item.label),c.item.tags!==void 0&&(h.tags=c.item.tags),c.item.busy!==void 0&&(h.busy=c.item.busy),c.item.range!==void 0&&(h.range=c.item.range?A.Range.lift(c.item.range):null),c.item.description!==void 0&&(h.description=c.item.description),c.item.error!==void 0&&(h.error=c.item.error),c.item.sortText!==void 0&&(h.sortText=c.item.sortText)),{extId:c.extId,expand:c.expand,item:h}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(r,c)=>{c.expand!==void 0&&(r.expand=c.expand),c.item!==void 0&&(r.item=r.item?Object.assign(r.item,c.item):c.item)};e.applyTestItemUpdate=i;var d;(function(r){r.serializeWithoutMessages=c=>({...R.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.serializeWithoutMessages),retired:c.retired}),r.serialize=c=>({...R.serialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.serialize),retired:c.retired}),r.deserialize=c=>({...R.deserialize(c),ownComputedState:c.ownComputedState,computedState:c.computedState,tasks:c.tasks.map(f.deserialize),retired:!0})})(d=e.TestResultItem||(e.TestResultItem={}));var s;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var l;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.DocumentSynced=2]="DocumentSynced",r[r.Remove=3]="Remove",r[r.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",r[r.Retire=5]="Retire",r[r.AddTag=6]="AddTag",r[r.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(r){r.deserialize=c=>c.op===0?{op:c.op,item:R.deserialize(c.item)}:c.op===1?{op:c.op,item:v.deserialize(c.item)}:c.op===2?{op:c.op,uri:n.URI.revive(c.uri),docv:c.docv}:c,r.serialize=c=>c.op===0?{op:c.op,item:R.serialize(c.item)}:c.op===1?{op:c.op,item:v.serialize(c.item)}:c})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class I{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(c){const h=this.o();for(const y of c)switch(y.op){case 0:this.j(R.deserialize(y.item),h);break;case 1:this.k(v.deserialize(y.item),h);break;case 3:this.l(y.itemId,h);break;case 5:this.m(y.itemId);break;case 4:this.updatePendingRoots(y.amount);break;case 6:this.c.set(y.tag.id,y.tag);break;case 7:this.c.delete(y.id);break}h.complete?.()}j(c,h){const y=D.TestId.parentId(c.item.extId)?.toString();let C;if(!y)C=this.p(c),this.f.add(C),this.d.set(c.item.extId,C);else if(this.d.has(y)){const H=this.d.get(y);H.children.add(c.item.extId),C=this.p(c,H),this.d.set(c.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(c)}`);return}return h.add?.(C),c.expand===2&&this.g++,C}k(c,h){const y=this.d.get(c.extId);if(!!y)return c.expand!==void 0&&(y.expand===2&&this.g--,c.expand===2&&this.g++),(0,e.applyTestItemUpdate)(y,c),h.update?.(y),y}l(c,h){const y=this.d.get(c);if(!y)return;const C=D.TestId.parentId(y.item.extId)?.toString();C?this.d.get(C).children.delete(y.item.extId):this.f.delete(y);const H=[[c]];for(;H.length;)for(const K of H.pop()){const Q=this.d.get(K);Q&&(H.push(Q.children),this.d.delete(K),h.remove?.(Q,Q!==y),Q.expand===2&&this.g--)}}m(c){}updatePendingRoots(c){this.h+=c}o(){return{}}}e.AbstractIncrementalTestCollection=I}),define(Te[72],Pe([1,0,17,4,6,49,56,45]),function(te,e,n,A,D,N,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(p,b)=>p===b,T=Object.entries({range:(p,b)=>p===b?!0:!p||!b?!1:p.equalsRange(b),busy:P,label:P,description:P,error:P,sortText:P,tags:(p,b)=>!(p.length!==b.length||p.some(R=>!b.includes(R)))}),m=(p,b)=>{let R;for(const[v,i]of T)i(p[v],b[v])||(R?R[v]=b[v]:R={[v]:b[v]});return R};class w extends D.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new A.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const R of this.tree.values())this.G(R)}get resolveHandler(){return this.h}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const R of this.k)if(R.op===2&&R.uri===b.uri){R.docv=b.docv;return}break}case 1:{const R=this.k[this.k.length-1];if(R){if(R.op===1&&R.item.extId===b.item.extId){(0,E.applyTestItemUpdate)(R.item,b.item);return}if(R.op===0&&R.item.item.extId===b.item.extId){(0,E.applyTestItemUpdate)(R.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,R){const v=this.tree.get(b);if(!!v){if((v.expandLevels===void 0||R>v.expandLevels)&&(v.expandLevels=R),v.expand===1){const i=this.I(v);return i.isOpen()?this.H(v,R-1):i.wait().then(()=>this.H(v,R-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.H(v,R-1)):this.H(v,R-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,R){switch(R.op){case 3:this.L(O.TestId.joinToString(b.fullId,R.id));break;case 0:this.u(R.item,b);break;case 5:for(const v of R.ops)this.p(b,v);break;case 1:this.w(R.new,R.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:R.update}});break;case 6:this.s(b.actual.uri);break;default:(0,N.assertNever)(R)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,R){const v=O.TestId.fromExtHostTestItem(b,this.root.id,R?.actual),i=this.m.getApiFor(b);i.parent&&i.parent!==R?.actual&&this.m.getChildren(i.parent).delete(b.id);let d=this.tree.get(v.toString());if(!d){d={fullId:v,actual:b,expandLevels:R?.expandLevels?R.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(d.fullId.toString(),d),this.C(b,R),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:d.expand,item:this.m.toITestItem(b)}}),this.F(b,d,R);return}if(d.actual===b){this.D(b,d,R);return}if(d.actual.uri?.toString()!==b.uri?.toString())return this.L(v.toString()),this.u(b,R);const s=this.m.getChildren(d.actual),l=d.actual,o=m(this.m.toITestItem(l),this.m.toITestItem(b));this.m.getApiFor(l).listener=void 0,d.actual=b,d.expand=0,o&&(o.hasOwnProperty("tags")&&(this.w(b.tags,l.tags,v.toString()),delete o.tags),this.p(d,{op:4,update:o})),this.F(b,d,R);for(const[I,r]of s)this.m.getChildren(b).get(r.id)||this.L(O.TestId.joinToString(v,r.id));this.s(d.actual.uri)}w(b,R,v){const i=new Set(R.map(d=>d.id));for(const d of b)i.delete(d.id)||this.y(d);this.pushDiff({op:1,item:{extId:v,item:{tags:b.map(d=>(0,E.namespaceTestTag)(this.m.controllerId,d.id))}}}),i.forEach(this.z,this)}y(b){const R=this.j.get(b.id);R?R.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,E.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const R=this.j.get(b);R&&!--R.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,E.namespaceTestTag)(this.m.controllerId,b)}))}C(b,R){this.m.getApiFor(b).parent=R&&R.actual!==this.root?R.actual:void 0}D(b,R,v){this.C(b,v);const i=this.m.getApiFor(b);i.parent=v?.actual,i.listener=d=>this.p(R,d),this.G(R)}F(b,R,v){this.D(b,R,v);for(const[i,d]of this.m.getChildren(b))this.u(d,R)}G(b){let R;this.h?b.resolveBarrier?R=b.resolveBarrier.isOpen()?3:2:R=b.actual.canResolveChildren?1:0:R=0,R!==b.expand&&(b.expand=R,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:R}}),R===1&&b.expandLevels!==void 0&&this.I(b))}H(b,R){if(R<0)return;const v=[];for(const[i,d]of this.m.getChildren(b.actual)){const s=this.expand(O.TestId.joinToString(b.fullId,d.id),R);(0,n.isThenable)(s)&&v.push(s)}if(v.length)return Promise.all(v).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const d=new n.Barrier;return d.open(),d}b.expand=2,this.J(b);const R=b.resolveBarrier=new n.Barrier,v=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,d)};let i;try{i=this.h(b.actual===this.root?void 0:b.actual)}catch(d){v(d)}return(0,n.isThenable)(i)?i.catch(v).then(()=>{R.open(),this.G(b)}):(R.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const R=this.tree.get(b);if(!R)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const v=[R];for(;v.length;){const i=v.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const d of i.actual.tags)this.z(d.id);this.tree.delete(i.fullId.toString());for(const[d,s]of this.m.getChildren(i.actual))v.push(this.tree.get(O.TestId.joinToString(i.fullId,s.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=w;class f extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=f;class u extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=u;class t extends Error{constructor(b,R,v){super(`TestItem with ID "${b}" is from controller "${R}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=t;const a=(p,b,R)=>{let v=new Map;return{get size(){return v.size},forEach(i,d){for(const s of v.values())i.call(d,s,this)},[Symbol.iterator](){return v.entries()},replace(i){const d=new Map,s=new Set(v.keys()),l={op:5,ops:[]};for(const o of i){if(!(o instanceof R))throw new u(o.id);const I=b(o).controllerId;if(I!==p.controllerId)throw new t(o.id,I,p.controllerId);if(d.has(o.id))throw new f(o.id);d.set(o.id,o),s.delete(o.id),l.ops.push({op:0,item:o})}for(const o of s.keys())l.ops.push({op:3,id:o});p.listener?.(l),v=d},add(i){if(!(i instanceof R))throw new u(i.id);v.set(i.id,i),p.listener?.({op:0,item:i})},delete(i){v.delete(i)&&p.listener?.({op:3,id:i})},get(i){return v.get(i)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=a}),define(Te[97],Pe([1,0,72]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,D=(E,O)=>{const S={controllerId:O};return A.set(E,S),S};e.createPrivateApiFor=D;const N=E=>{const O=A.get(E);if(!O)throw new n.InvalidTestItemError(E?.id||"<unknown>");return O};e.getPrivateApiFor=N}),define(Te[73],Pe([1,0,15,2]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(O,S){return O.scheme===n.Schemas.http||O.scheme===n.Schemas.https?O:(S&&S.authority&&S.isRemote&&O.scheme===n.Schemas.file&&(O=A.URI.from({scheme:n.Schemas.vscodeRemote,authority:S.authority,path:O.path})),A.URI.from({scheme:n.Schemas.https,authority:`${O.scheme}+${N(O.authority)}.${e.webviewRootResourceAuthority}`,path:O.path,fragment:O.fragment,query:O.query}))}e.asWebviewUri=D;function N(O){return O.replace(/./g,S=>{const P=S.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?S:"-"+P.toString(16).padStart(4,"0")})}function E(O){return O.replace(/-([0-9a-f]{4})/g,(S,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=E}),define(Te[188],Pe([1,0,4,6,73]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class N{constructor(O,S,P){this.d=O,this.e=S,this.f=P,this.a=0,this.b=new A.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const M=S.getVisibleTextEditors();for(const T of this.c.values())M.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,S,P,M,T){let m;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===O){m=b;break}if(!m)throw new Error("not a visible editor");const w=this,f=this.a++,u=new n.Emitter,t=new n.Emitter,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,D.asWebviewUri)(b,w.f)}get cspSource(){return D.webviewGenericCspSource}set options(b){this.b=b,w.d.$setOptions(f,b)}get options(){return this.b}set html(b){this.a=b,w.d.$setHtml(f,b)}get html(){return this.a}get onDidReceiveMessage(){return u.event}postMessage(b){return w.d.$postMessage(f,b)}},p=new class{constructor(){this.editor=O,this.line=S,this.height=P,this.webview=a,this.onDidDispose=t.event}dispose(){w.c.has(f)&&(w.c.delete(f),w.d.$disposeEditorInset(f),t.fire(),t.dispose(),u.dispose())}};return this.d.$createEditorInset(f,m.id,m.value.document.uri,S+1,P,M||{},T.identifier,T.extensionLocation),this.c.set(f,{editor:O,inset:p,onDidReceiveMessage:u}),p}$onDidDispose(O){const S=this.c.get(O);S&&S.inset.dispose()}$onDidReceiveMessage(O,S){this.c.get(O)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=N}),define(Te[189],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var A;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator"})(A=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(E,O){super(O),this.variable=E}}e.VariableError=D}),define(Te[190],Pe([1,0,19,51,9,23,20,87,154,189,10]),function(te,e,n,A,D,N,E,O,S,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(w,f,u,t){this.g=new Map,this.a=w,this.b=f,this.d=u,t&&(this.c=t.then(a=>this.h(a)))}h(w){if(E.isWindows){const f=Object.create(null);return Object.keys(w).forEach(u=>{f[u.toLowerCase()]=w[u]}),f}return w}resolveWithEnvironment(w,f,u){return this.j({env:this.h(w),userHome:void 0},f?f.uri:void 0,u)}async resolveAsync(w,f){const u={env:await this.c,userHome:await this.d};return this.j(u,w?w.uri:void 0,f)}async i(w,f,u,t){const a=N.deepClone(f);E.isWindows&&a.windows?Object.keys(a.windows).forEach(b=>a[b]=a.windows[b]):E.isMacintosh&&a.osx?Object.keys(a.osx).forEach(b=>a[b]=a.osx[b]):E.isLinux&&a.linux&&Object.keys(a.linux).forEach(b=>a[b]=a.linux[b]),delete a.windows,delete a.osx,delete a.linux;const p={env:await this.c,userHome:await this.d};return this.j(p,w?w.uri:void 0,a,u,t)}async resolveAnyAsync(w,f,u){return this.i(w,f,u)}async resolveAnyMap(w,f,u){const t=new Map;return{newConfig:await this.i(w,f,u,t),resolvedVariables:t}}resolveWithInteractionReplace(w,f,u,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,f,u,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,f){if(this.g.has(w))throw new Error("Variable "+w+" is contributed twice.");this.g.set(w,f)}async j(w,f,u,t,a){if(D.isString(u))return this.l(w,f,u,t,a);if(Array.isArray(u))return Promise.all(u.map(p=>this.j(w,f,p,t,a)));if(D.isObject(u)){const p=Object.create(null),b=await Promise.all(Object.keys(u).map(async R=>[await this.l(w,f,R,t,a),await this.j(w,f,u[R],t,a)]));for(const[R,v]of b)p[R]=v;return p}return u}l(w,f,u,t,a){return(0,M.replaceAsync)(u,T.VARIABLE_REGEXP,async(p,b)=>{if(b.includes(T.VARIABLE_LHS))return p;let R=await this.n(w,p,b,f,t);return a?.set(b,R),R!==p&&D.isString(R)&&R.match(T.VARIABLE_REGEXP)&&(R=await this.l(w,f,R,t,a)),R})}m(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async n(w,f,u,t,a){let p;const b=u.split(":");b.length>1&&(u=b[0],p=b[1]);const R=d=>{const s=this.a.getFilePath();if(s)return(0,O.normalizeDriveLetter)(s);throw new P.VariableError(d,(0,S.localize)(0,null,f))},v=d=>{const s=R(d);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,O.normalizeDriveLetter)(l)}throw new P.VariableError(d,(0,S.localize)(1,null,f,n.basename(s)))},i=d=>{if(p){const s=this.a.getFolderUri(p);if(s)return s;throw new P.VariableError(d,(0,S.localize)(2,null,f,p))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new P.VariableError(d,(0,S.localize)(3,null,f)):new P.VariableError(d,(0,S.localize)(4,null,f))};switch(u){case"env":if(p){if(w.env){const d=w.env[E.isWindows?p.toLowerCase():p];if(D.isString(d))return d}return""}throw new P.VariableError(P.VariableKind.Env,(0,S.localize)(5,null,f));case"config":if(p){const d=this.a.getConfigurationValue(t,p);if(D.isUndefinedOrNull(d))throw new P.VariableError(P.VariableKind.Config,(0,S.localize)(6,null,f,p));if(D.isObject(d))throw new P.VariableError(P.VariableKind.Config,(0,S.localize)(7,null,f,p));return d}throw new P.VariableError(P.VariableKind.Config,(0,S.localize)(8,null,f));case"command":return this.o(P.VariableKind.Command,f,p,a,"command");case"input":return this.o(P.VariableKind.Input,f,p,a,"input");case"extensionInstallFolder":if(p){const d=await this.a.getExtension(p);if(!d)throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,f,p));return this.m(d.extensionLocation)}throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,f));default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,O.normalizeDriveLetter)(this.m(i(P.VariableKind.WorkspaceFolder)));case"cwd":return t||p?(0,O.normalizeDriveLetter)(this.m(i(P.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.normalizeDriveLetter)(n.basename(this.m(i(P.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new P.VariableError(P.VariableKind.UserHome,(0,S.localize)(11,null,f))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new P.VariableError(P.VariableKind.LineNumber,(0,S.localize)(12,null,f))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new P.VariableError(P.VariableKind.SelectedText,(0,S.localize)(13,null,f))}case"file":return R(P.VariableKind.File);case"fileWorkspaceFolder":return v(P.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||p?n.relative(this.m(i(P.VariableKind.RelativeFile)),R(P.VariableKind.RelativeFile)):R(P.VariableKind.RelativeFile);case"relativeFileDirname":{const d=n.dirname(R(P.VariableKind.RelativeFileDirname));if(t||p){const s=n.relative(this.m(i(P.VariableKind.RelativeFileDirname)),d);return s.length===0?".":s}return d}case"fileDirname":return n.dirname(R(P.VariableKind.FileDirname));case"fileExtname":return n.extname(R(P.VariableKind.FileExtname));case"fileBasename":return n.basename(R(P.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=n.basename(R(P.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-n.extname(d).length)}case"fileDirnameBasename":return n.basename(n.dirname(R(P.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||f}case"execInstallFolder":{const d=this.a.getAppRoot();return d||f}case"pathSeparator":return n.sep;default:try{const d=p?`${u}:${p}`:u;return this.o(P.VariableKind.Unknown,f,d,a,void 0)}catch{return f}}}}o(w,f,u,t,a){if(u&&t){const p=a===void 0?t[u]:t[a+":"+u];if(typeof p=="string")return p;throw new P.VariableError(w,(0,S.localize)(14,null,f))}return f}}T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=T}),define(Te[98],Pe([1,0,3,96]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var D;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var N;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(N=e.GroupOrientation||(e.GroupOrientation={}));var E;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(E=e.GroupLocation||(e.GroupLocation={}));var O;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(O=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function P(f){const u=f;return(0,A.isEditorInput)(u?.editor)&&(0,A.isEditorInput)(u?.replacement)}e.isEditorReplacement=P;var M;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const u=f;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.isEditorGroup=m;function w(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=w}),define(Te[191],Pe([1,0,3,98]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(N){const E=N;return typeof N=="number"||(0,A.isEditorGroup)(E)}e.isPreferredGroup=D}),define(Te[192],Pe([1,0,3,160]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(A.IEnvironmentService)}),define(Te[99],Pe([1,0,24,4,19,6]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class E{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=E;class O{static isHostExtension(t,a,p){if(a.getExtensionDescription(t))return!1;const b=p.getExtensionDescription(t);return b?!!((b.main||b.browser)&&b.api==="none"):!1}constructor(t,a){this.h=t,this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=a,this.j()}j(){this.d.sort(w),this.e=new n.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const a=this.h.readActivationEvents(t);if(Array.isArray(a))for(let p of a)p==="onUri"&&(p=`onUri:${n.ExtensionIdentifier.toKey(t.identifier)}`),this.g.has(p)||this.g.set(p,[]),this.g.get(p).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,a){this.d=f(this.d,a),this.d=this.d.concat(t);const p=O.k(this.d);return this.d=f(this.d,p.map(b=>b.identifier)),this.j(),this.c.fire(void 0),new E(p)}static k(t){const a=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(i){this.d.has(i)||(this.d.add(i),this.e.push(i))}addArc(i,d){this.addNode(i),this.addNode(d),this.c.has(i)?this.c.get(i).push(d):this.c.set(i,[d])}getArcs(i){return this.c.has(i)?this.c.get(i):[]}hasOnlyGoodArcs(i,d){const s=a.getArcs(i);for(let l=0;l<s.length;l++)if(!d.has(s[l]))return!1;return!0}getNodes(){return this.e}},p=new n.ExtensionIdentifierMap;for(const i of t)if(p.set(i.identifier,i),i.extensionDependencies)for(const d of i.extensionDependencies)a.addArc(n.ExtensionIdentifier.toKey(i.identifier),n.ExtensionIdentifier.toKey(d));const b=new Set;a.getNodes().filter(i=>a.getArcs(i).length===0).forEach(i=>b.add(i));const R=a.getNodes().filter(i=>!b.has(i));let v;do{v=!1;for(let i=0;i<R.length;i++){const d=R[i];a.hasOnlyGoodArcs(d,b)&&(R.splice(i,1),i--,b.add(d),v=!0)}}while(v);return R.map(i=>p.get(i))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const a=this.g.get(t);return a?a.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const a=this.e.get(t);return a||void 0}getExtensionDescriptionByUUID(t){for(const a of this.f)if(a.uuid===t)return a}getExtensionDescriptionByIdOrUUID(t,a){return this.getExtensionDescription(t)??(a?this.getExtensionDescriptionByUUID(a):void 0)}}e.ExtensionDescriptionRegistry=O,e.basicActivationEventsReader={readActivationEvents:u=>u.activationEvents};class S{constructor(t){this.d=new T,this.c=new O(t,[])}async acquireLock(t){const a=await this.d.acquire(t);return new P(this,a)}deltaExtensions(t,a,p){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(a,p)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,a){return this.c.getExtensionDescriptionByIdOrUUID(t,a)}}e.LockableExtensionDescriptionRegistry=S;class P extends N.Disposable{constructor(t,a){super(),this.f=t,this.c=!1,this.B(a)}isAcquiredFor(t){return!this.c&&this.f===t}}e.ExtensionDescriptionRegistryLock=P;class M{constructor(t){this.name=t,this.promise=new Promise((a,p)=>{this.c=a})}resolve(t){this.c(t)}}class T{constructor(){this.c=[],this.d=!1}async acquire(t){const a=new M(t);return this.c.push(a),this.e(),a.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let a=!0;const p=setTimeout(()=>{a&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),b=()=>{!a||(clearTimeout(p),a=!1,this.d=!1,this.e())};t.resolve((0,N.toDisposable)(b))}}var m;(function(u){u[u.Builtin=0]="Builtin",u[u.User=1]="User",u[u.Dev=2]="Dev"})(m||(m={}));function w(u,t){const a=u.isBuiltin?0:u.isUnderDevelopment?2:1,p=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(a!==p)return a-p;const b=D.posix.basename(u.extensionLocation.path),R=D.posix.basename(t.extensionLocation.path);return b<R?-1:b>R?1:0}function f(u,t){const a=new n.ExtensionIdentifierSet(t);return u.filter(p=>!a.has(p.identifier))}}),define(Te[74],Pe([1,0,25]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(P){P[P.Desktop=1]="Desktop",P[P.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var D;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var N;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(N=e.MessageType||(e.MessageType={}));function E(P){const M=n.VSBuffer.alloc(1);switch(P){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.createMessageOfType=E;function O(P,M){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.isMessageOfType=O;var S;(function(P){P.Start="START_NATIVE_LOG",P.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Te[57],Pe([1,0,3,4,12,27,74,50,52,23,2,6,144]),function(te,e,n,A,D,N,E,O,S,P,M,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let w=class extends T.Disposable{constructor(a,p){super(),this.m=a,this.n=p,this.a=this.B(new A.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new A.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=M.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=p.createLogger(this.j,{id:S.extensionTelemetryLogChannelId,name:(0,m.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(p.onDidChangeLogLevel(b=>{(0,D.isLogLevel)(b)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===D.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(a,p,b){const R=this.getTelemetryDetails(),v=new f(p,b,a,this.k,this.i,this.getBuiltInCommonProperties(a),{isUsageEnabled:R.isUsageEnabled,isErrorsEnabled:R.isErrorsEnabled});return this.l.set(a.identifier.value,v),v.apiTelemetryLogger}$initializeTelemetryLevel(a,p,b){this.f=a,this.g=p,this.c=b??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(a){const p={};switch(p["common.extname"]=`${a.publisher}.${a.name}`,p["common.extversion"]=a.version,p["common.vscodemachineid"]=this.m.telemetryInfo.machineId,p["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,p["common.vscodeversion"]=this.m.version,p["common.isnewappinstall"]=u(this.m.telemetryInfo.firstSessionDate),p["common.product"]=this.m.environment.appHost,this.m.uiKind){case E.UIKind.Web:p["common.uikind"]="web";break;case E.UIKind.Desktop:p["common.uikind"]="desktop";break;default:p["common.uikind"]="unknown"}return p["common.remotename"]=(0,O.getRemoteName)((0,S.cleanRemoteAuthority)(this.m.remote.authority)),p}$onDidChangeTelemetryLevel(a){this.h=this.getTelemetryConfiguration(),this.f=a;const p=this.getTelemetryDetails();this.l.forEach(b=>{b.updateTelemetryEnablements(p.isUsageEnabled,p.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(a,p){const b=this.l.get(a.value);return!b||b.ignoreUnhandledExtHostErrors?!1:(b.logError(p),!0)}};w=qe([Ve(0,N.IExtHostInitDataService),Ve(1,D.ILoggerService)],w),e.ExtHostTelemetry=w;class f{static validateSender(a){if(typeof a!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof a.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof a.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof a.flush<"u"&&typeof a.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(a,p,b,R,v,i,d){this.g=b,this.h=R,this.i=v,this.j=i,this.a=new A.Emitter,this.ignoreUnhandledExtHostErrors=p?.ignoreUnhandledErrors??!1,this.b=p?.ignoreBuiltInCommonProperties??!1,this.c=p?.additionalCommonProperties,this.f=a,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(a,p){this.e&&(this.d={isUsageEnabled:a,isErrorsEnabled:p},this.a.fire(this.e))}mixInCommonPropsAndCleanData(a){let p=a.properties??a;return p=(0,S.cleanData)(p,[]),this.c&&(p=(0,P.mixin)(p,this.c)),this.b||(p=(0,P.mixin)(p,this.j)),a.properties?a.properties=p:a=p,a}k(a,p){!this.f||(this.g.publisher==="vscode"?a=this.g.name+"/"+a:a=this.g.identifier.value+"/"+a,p=this.mixInCommonPropsAndCleanData(p||{}),this.i||this.f?.sendEventData(a,p),this.h.trace(a,p))}logUsage(a,p){!this.d.isUsageEnabled||this.k(a,p)}logError(a,p){!this.d.isErrorsEnabled||!this.f||(typeof a=="string"?this.k(a,p):this.f.sendErrorData(a,p))}get apiTelemetryLogger(){if(!this.e){const a=this,p={logUsage:a.logUsage.bind(a),get isUsageEnabled(){return a.d.isUsageEnabled},get isErrorsEnabled(){return a.d.isErrorsEnabled},logError:a.logError.bind(a),dispose:a.dispose.bind(a),onDidChangeEnableStates:a.a.event.bind(a)};this.e=Object.freeze(p)}return this.e}dispose(){this.f?.flush&&(Promise.resolve(this.f.flush()).then(this.f=void 0),this.e=void 0)}}e.ExtHostTelemetryLogger=f;function u(t){const a=Date.now()-new Date(t).getTime();return isNaN(a)?!1:a<1e3*60*60*24}e.isNewAppInstall=u,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Te[26],Pe([1,0,4,2,170,95,24,3]),function(te,e,n,A,D,N,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new E.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,O.createDecorator)("extensionService");class S{constructor(v){this.dependency=v}}e.MissingExtensionDependency=S;var P;(function(R){R[R.EagerAutoStart=1]="EagerAutoStart",R[R.EagerManualStart=2]="EagerManualStart",R[R.Lazy=3]="Lazy"})(P=e.ExtensionHostStartup||(e.ExtensionHostStartup={}));class M{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:N.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(v,i){const d=[],s=[],l=[],o=[],I=T(this.c),r=T(v),c=(K,Q)=>K.extensionLocation.toString()===Q.extensionLocation.toString()||K.isBuiltin===Q.isBuiltin||K.isUserBuiltin===Q.isUserBuiltin||K.isUnderDevelopment===Q.isUnderDevelopment;for(const K of this.c){const Q=r.get(K.identifier);if(!Q){d.push(K.identifier),I.delete(K.identifier);continue}if(!c(K,Q)){d.push(K.identifier),I.delete(K.identifier);continue}}for(const K of v){const Q=I.get(K.identifier);if(!Q){s.push(K);continue}if(!c(Q,K)){d.push(Q.identifier),I.delete(Q.identifier);continue}}const h=new E.ExtensionIdentifierSet(this.d),y=new E.ExtensionIdentifierSet(i);for(const K of this.d)y.has(K)||l.push(K);for(const K of i)h.has(K)||o.push(K);const C=N.ImplicitActivationEvents.createActivationEventsMap(s),H={toRemove:d,toAdd:s,addActivationEvents:C,myToRemove:l,myToAdd:o};return this.delta(H),H}delta(v){const{toRemove:i,toAdd:d,myToRemove:s,myToAdd:l}=v,o=new E.ExtensionIdentifierSet(i),I=new E.ExtensionIdentifierSet(s);for(let r=0;r<this.c.length;r++)o.has(this.c[r].identifier)&&(this.c.splice(r,1),r--);for(let r=0;r<this.d.length;r++)I.has(this.d[r])&&(this.d.splice(r,1),r--);for(const r of d)this.c.push(r);for(const r of l)this.d.push(r)}containsExtension(v){for(const i of this.d)if(E.ExtensionIdentifier.equals(i,v))return!0;return!1}}e.ExtensionHostExtensions=M;function T(R){const v=new E.ExtensionIdentifierMap;for(const i of R)v.set(i.identifier,i);return v}function m(R,v){return R.enabledApiProposals?R.enabledApiProposals.includes(v):!1}e.isProposedApiEnabled=m;function w(R,v){if(!m(R,v))throw new Error(`Extension '${R.identifier.value}' CANNOT use API proposal: ${v}.
Its package.json#enabledApiProposals-property declares: ${R.enabledApiProposals?.join(", ")??"[]"} but NOT ${v}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${R.identifier.value}`)}e.checkProposedApiEnabled=w;class f{constructor(v,i,d,s){this.codeLoadingTime=v,this.activateCallTime=i,this.activateResolvedTime=d,this.activationReason=s}}e.ActivationTimes=f;class u{constructor(v,i){this.description=v,this.value=i}}e.ExtensionPointContribution=u,e.ExtensionHostLogFileName="exthost";var t;(function(R){R[R.Normal=0]="Normal",R[R.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function a(R){return{type:R.isBuiltin?0:1,isBuiltin:R.isBuiltin||R.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(R.publisher,R.name),uuid:R.uuid},manifest:R,location:R.extensionLocation,targetPlatform:R.targetPlatform,validations:[],isValid:!0}}e.toExtension=a;function p(R,v){return{identifier:new E.ExtensionIdentifier((0,D.getExtensionId)(R.manifest.publisher,R.manifest.name)),isBuiltin:R.type===0,isUserBuiltin:R.type===1&&R.isBuiltin,isUnderDevelopment:!!v,extensionLocation:R.location,...R.manifest,uuid:R.identifier.uuid,targetPlatform:R.targetPlatform,browserNlsBundleUris:R.browserNlsBundleUris}}e.toExtensionDescription=p;class b{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(v){return Promise.resolve(void 0)}activationEventIsDone(v){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(v,i){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=b}),define(Te[193],Pe([1,0,11,99,24,26,12,17]),function(te,e,n,A,D,N,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(a,p,b,R){this.startup=a,this.codeLoadingTime=p,this.activateCallTime=b,this.activateResolvedTime=R}}S.NONE=new S(!1,-1,-1,-1),e.ExtensionActivationTimes=S;class P{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,p){return a===-1||p===-1?-1:p-a}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=P;class M{constructor(a,p,b,R,v,i){this.activationFailed=a,this.activationFailedError=p,this.activationTimes=b,this.module=R,this.exports=v,this.subscriptions=i}}e.ActivatedExtension=M;class T extends M{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class m extends M{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=m;class w extends M{constructor(a){super(!0,a,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(a,p,b,R){this.g=R,this.a=a,this.b=p,this.c=b,this.d=new D.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[a,p]of this.d)p.dispose()}isActivated(a){const p=this.d.get(a);return Boolean(p&&p.value)}getActivatedExtension(a){const p=this.d.get(a);if(!p||!p.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return p.value}async activateByEvent(a,p){if(this.f[a])return;const b=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(b.map(R=>({id:R.identifier,reason:{startup:p,extensionId:R.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,p){const b=this.a.getExtensionDescription(a);if(!b)throw new Error(`Extension '${a}' is not known`);return this.h([{id:b.identifier,reason:p}])}async h(a){const p=a.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(p.map(b=>b.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const p=this.a.getExtensionDescription(a.id);if(!p){const v=new Error(`Cannot activate unknown extension '${a.id.value}'`),i=this.k(a,null,[],new w(v));return this.c.onExtensionActivationError(a.id,v,new N.MissingExtensionDependency(a.id.value)),i}const b=[],R=typeof p.extensionDependencies>"u"?[]:p.extensionDependencies;for(const v of R){if(this.m(v))continue;const i=this.d.get(v);if(i){b.push(i);continue}if(this.l(v)){b.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:a.reason}));continue}const d=this.a.getExtensionDescription(v);if(d){if(!d.main&&!d.browser)continue;b.push(this.j({id:d.identifier,reason:a.reason}));continue}const s=p.displayName||p.identifier.value,l=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${v}'`),o=this.k(a,p.displayName,[],new w(l));return this.c.onExtensionActivationError(p.identifier,l,new N.MissingExtensionDependency(v)),o}return this.k(a,p.displayName,b,null)}k(a,p,b,R){const v=new u(a.id,p,a.reason,b,R,this.c,this.g);return this.d.set(a.id,v),v}l(a){return A.ExtensionDescriptionRegistry.isHostExtension(a,this.a,this.b)}m(a){const p=this.b.getExtensionDescription(a);return p?!p.main&&!p.browser:!1}};f=qe([Ve(3,E.ILogService)],f),e.ExtensionsActivator=f;let u=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,p,b,R,v,i,d){this.c=a,this.d=p,this.f=b,this.g=R,this.h=v,this.j=i,this.k=d,this.a=new O.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const p=this.g[a];if(p.value&&!p.value.activationFailed){this.g.splice(a,1),a--;continue}if(p.value&&p.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);b.detail=p.value.activationFailedError,this.h=new w(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const p=new Error;if(a&&a.name&&(p.name=a.name),a&&a.message?p.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:p.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(p.stack=a.stack),this.h=new w(p),this.b&&n.isCancellationError(a))return;this.j.onExtensionActivationError(this.c,p,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};u=qe([Ve(6,E.ILogService)],u)});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,A,D){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Fe=this&&this.__classPrivateFieldGet||function(te,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!A:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(te):A?A.value:e.get(te)};define(Te[7],Pe([1,0,16,11,86,28,65,10,9,2,34,43,94,71,26]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f){"use strict";var u,t,a,p,b,R,v,i,d,s,l,o,I,r,c,h,y,C,H,K,Q,_,j;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function L(z){return Object.assign(z,{apply:function(){const ne=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ne,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ne,...we]=arguments;return Reflect.construct(z,we,ne.constructor)}}})}var g;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(g=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var F;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(F=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let B=R=class{static from(...U){let ne=U;return new R(function(){if(ne){for(const we of ne)we&&typeof we.dispose=="function"&&we.dispose();ne=void 0}})}constructor(U){u.set(this,void 0),Je(this,u,U,"f")}dispose(){typeof Fe(this,u,"f")=="function"&&(Fe(this,u,"f").call(this),Je(this,u,void 0,"f"))}};u=new WeakMap,B=R=qe([L],B),e.Disposable=B;let Y=v=class{static Min(...U){if(U.length===0)throw new TypeError;let ne=U[0];for(let we=1;we<U.length;we++){const xe=U[we];xe.isBefore(ne)&&(ne=xe)}return ne}static Max(...U){if(U.length===0)throw new TypeError;let ne=U[0];for(let we=1;we<U.length;we++){const xe=U[we];xe.isAfter(ne)&&(ne=xe)}return ne}static isPosition(U){if(!U)return!1;if(U instanceof v)return!0;const{line:ne,character:we}=U;return typeof ne=="number"&&typeof we=="number"}static of(U){if(U instanceof v)return U;if(this.isPosition(U))return new v(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,ne){if(U<0)throw(0,A.illegalArgument)("line must be non-negative");if(ne<0)throw(0,A.illegalArgument)("character must be non-negative");this.c=U,this.e=ne}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,ne=0){if(U===null||ne===null)throw(0,A.illegalArgument)();let we;return typeof U>"u"?we=0:typeof U=="number"?we=U:(we=typeof U.lineDelta=="number"?U.lineDelta:0,ne=typeof U.characterDelta=="number"?U.characterDelta:0),we===0&&ne===0?this:new v(this.line+we,this.character+ne)}with(U,ne=this.character){if(U===null||ne===null)throw(0,A.illegalArgument)();let we;return typeof U>"u"?we=this.line:typeof U=="number"?we=U:(we=typeof U.line=="number"?U.line:this.line,ne=typeof U.character=="number"?U.character:this.character),we===this.line&&ne===this.character?this:new v(we,ne)}toJSON(){return{line:this.line,character:this.character}}};Y=v=qe([L],Y),e.Position=Y;let me=i=class{static isRange(U){return U instanceof i?!0:U?Y.isPosition(U.start)&&Y.isPosition(U.end):!1}static of(U){if(U instanceof i)return U;if(this.isRange(U))return new i(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,ne,we,xe){let Ye,ot;if(typeof U=="number"&&typeof ne=="number"&&typeof we=="number"&&typeof xe=="number"?(Ye=new Y(U,ne),ot=new Y(we,xe)):Y.isPosition(U)&&Y.isPosition(ne)&&(Ye=Y.of(U),ot=Y.of(ne)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this.c=Ye,this.e=ot):(this.c=ot,this.e=Ye)}contains(U){return i.isRange(U)?this.contains(U.start)&&this.contains(U.end):Y.isPosition(U)?!(Y.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const ne=Y.Max(U.start,this.c),we=Y.Min(U.end,this.e);if(!ne.isAfter(we))return new i(ne,we)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ne=Y.Min(U.start,this.c),we=Y.Max(U.end,this.end);return new i(ne,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,ne=this.end){if(U===null||ne===null)throw(0,A.illegalArgument)();let we;return U?Y.isPosition(U)?we=U:(we=U.start||this.start,ne=U.end||this.end):we=this.start,we.isEqual(this.c)&&ne.isEqual(this.end)?this:new i(we,ne)}toJSON(){return[this.start,this.end]}};me=i=qe([L],me),e.Range=me;let Z=d=class extends me{static isSelection(U){return U instanceof d?!0:U?me.isRange(U)&&Y.isPosition(U.anchor)&&Y.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,ne,we,xe){let Ye,ot;if(typeof U=="number"&&typeof ne=="number"&&typeof we=="number"&&typeof xe=="number"?(Ye=new Y(U,ne),ot=new Y(we,xe)):Y.isPosition(U)&&Y.isPosition(ne)&&(Ye=Y.of(U),ot=Y.of(ne)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this.f=Ye,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};Z=d=qe([L],Z),e.Selection=Z;class se{constructor(U,ne,we){if(typeof U!="string"||U.length===0)throw(0,A.illegalArgument)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,A.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z_\-]+$/.test(we)))throw(0,A.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ne),this.connectionToken=we}}e.ResolvedAuthority=se;class ue extends Error{static NotAvailable(U,ne){return new ue(U,m.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(U){return new ue(U,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ne=m.RemoteAuthorityResolverErrorCode.Unknown,we){super(U),this._message=U,this._code=ne,this._detail=we,Object.setPrototypeOf(this,ue.prototype)}}e.RemoteAuthorityResolverError=ue;var De;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(De=e.EndOfLine||(e.EndOfLine={}));var de;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(de=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ie=s=class{static isTextEdit(U){return U instanceof s?!0:U?me.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ne){return new s(U,ne)}static insert(U,ne){return s.replace(new me(U,U),ne)}static delete(U){return s.replace(U,"")}static setEndOfLine(U){const ne=new s(new me(new Y(0,0),new Y(0,0)),"");return ne.newEol=U,ne}get range(){return this.c}set range(U){if(U&&!me.isRange(U))throw(0,A.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,A.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,A.illegalArgument)("newEol");this.f=U}constructor(U,ne){this.c=U,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};ie=s=qe([L],ie),e.TextEdit=ie;let q=l=class{static isNotebookCellEdit(U){return U instanceof l?!0:U?Kt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ne){return new l(U,ne)}static insertCells(U,ne){return new l(new Kt(U,U),ne)}static deleteCells(U){return new l(U,[])}static updateCellMetadata(U,ne){const we=new l(new Kt(U,U),[]);return we.newCellMetadata=ne,we}static updateNotebookMetadata(U){const ne=new l(new Kt(0,0),[]);return ne.newNotebookMetadata=U,ne}constructor(U,ne){this.range=U,this.newCells=ne}};q=l=qe([L],q),e.NotebookEdit=q;class ce{static isSnippetTextEdit(U){return U instanceof ce?!0:U?me.isRange(U.range)&&Ue.isSnippetString(U.snippet):!1}static replace(U,ne){return new ce(U,ne)}static insert(U,ne){return ce.replace(new me(U,U),ne)}constructor(U,ne){this.range=U,this.snippet=ne}}e.SnippetTextEdit=ce;var be;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(be=e.FileEditType||(e.FileEditType={}));let Ae=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,ne,we,xe){this.c.push({_type:1,from:U,to:ne,options:we,metadata:xe})}createFile(U,ne,we){this.c.push({_type:1,from:void 0,to:U,options:ne,metadata:we})}deleteFile(U,ne,we){this.c.push({_type:1,from:U,to:void 0,options:ne,metadata:we})}e(U,ne,we){this.c.push({_type:3,metadata:we,uri:U,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(U,ne,we,xe){const Ye=ne.start,ot=ne.end;(Ye!==ot||we.length>0)&&this.c.push({_type:5,uri:U,index:Ye,count:ot-Ye,cells:we,metadata:xe})}g(U,ne,we,xe){this.c.push({_type:3,metadata:xe,uri:U,edit:{editType:8,index:ne,metadata:we}})}replace(U,ne,we,xe){this.c.push({_type:2,uri:U,edit:new ie(ne,we),metadata:xe})}insert(U,ne,we,xe){this.replace(U,new me(ne,ne),we,xe)}delete(U,ne,we){this.replace(U,ne,"",we)}has(U){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===U.toString())}set(U,ne){if(ne)for(const we of ne){if(!we)continue;let xe,Ye;Array.isArray(we)?(xe=we[0],Ye=we[1]):xe=we,q.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(U,xe.range.start,xe.newCellMetadata,Ye):xe.newNotebookMetadata?this.e(U,xe.newNotebookMetadata,Ye):this.f(U,xe.range,xe.newCells,Ye):ce.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:U,range:xe.range,edit:xe.snippet,metadata:Ye}):this.c.push({_type:2,uri:U,edit:xe,metadata:Ye})}else{for(let we=0;we<this.c.length;we++){const xe=this.c[we];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===U.toString()&&(this.c[we]=void 0);break}}(0,n.coalesceInPlace)(this.c)}}get(U){const ne=[];for(const we of this.c)we._type===2&&we.uri.toString()===U.toString()&&ne.push(we.edit);return ne}entries(){const U=new N.ResourceMap;for(const ne of this.c)if(ne._type===2){let we=U.get(ne.uri);we||(we=[ne.uri,[]],U.set(ne.uri,we)),we[1].push(ne.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ae=qe([L],Ae),e.WorkspaceEdit=Ae;let Ue=o=class{static isSnippetString(U){return U instanceof o?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=o.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ne=this.e++){if(typeof U=="function"){const we=new o;we.e=this.e,U(we),this.e=we.e,U=we.value}else U=o.c(U);return this.value+="${",this.value+=ne,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ne=this.e++){const we=U.map(xe=>xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(U,ne){if(typeof ne=="function"){const we=new o;we.e=this.e,ne(we),this.e=we.e,ne=we.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};Ue=o=qe([L],Ue),e.SnippetString=Ue;var Ce;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Ce=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=I=class{static isLocation(U){return U instanceof I?!0:U?me.isRange(U.range)&&P.URI.isUri(U.uri):!1}constructor(U,ne){if(this.uri=U,ne)if(me.isRange(ne))this.range=me.of(ne);else if(Y.isPosition(ne))this.range=new me(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=I=qe([L],ke),e.Location=ke;let oe=class{static is(U){return U?typeof U.message=="string"&&U.location&&me.isRange(U.location.range)&&P.URI.isUri(U.location.uri):!1}constructor(U,ne){this.location=U,this.message=ne}static isEqual(U,ne){return U===ne?!0:!U||!ne?!1:U.message===ne.message&&U.location.range.isEqual(ne.location.range)&&U.location.uri.toString()===ne.location.uri.toString()}};oe=qe([L],oe),e.DiagnosticRelatedInformation=oe;let ae=class{constructor(U,ne,we=Se.Error){if(!me.isRange(U))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=U,this.message=ne,this.severity=we}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ne){return U===ne?!0:!U||!ne?!1:U.message===ne.message&&U.severity===ne.severity&&U.code===ne.code&&U.severity===ne.severity&&U.source===ne.source&&U.range.isEqual(ne.range)&&(0,n.equals)(U.tags,ne.tags)&&(0,n.equals)(U.relatedInformation,ne.relatedInformation,oe.isEqual)}};ae=qe([L],ae),e.Diagnostic=ae;let J=class{constructor(U,ne){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ne}};J=qe([L],J),e.Hover=J;var k;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(k=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(U,ne=k.Text){this.range=U,this.kind=ne}toJSON(){return{range:this.range,kind:k[this.kind]}}};$=qe([L],$),e.DocumentHighlight=$;var W;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(W=e.SymbolKind||(e.SymbolKind={}));var V;(function(z){z[z.Deprecated=1]="Deprecated"})(V=e.SymbolTag||(e.SymbolTag={}));let ee=r=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ne,we,xe,Ye){this.name=U,this.kind=ne,this.containerName=Ye,typeof we=="string"&&(this.containerName=we),xe instanceof ke?this.location=xe:we instanceof me&&(this.location=new ke(xe,we)),r.validate(this)}toJSON(){return{name:this.name,kind:W[this.kind],location:this.location,containerName:this.containerName}}};ee=r=qe([L],ee),e.SymbolInformation=ee;let fe=c=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(c.validate)}constructor(U,ne,we,xe,Ye){this.name=U,this.detail=ne,this.kind=we,this.range=xe,this.selectionRange=Ye,this.children=[],c.validate(this)}};fe=c=qe([L],fe),e.DocumentSymbol=fe;var Ie;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(Ie=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(U,ne){this.title=U,this.kind=ne}};le=qe([L],le),e.CodeAction=le;let ve=h=class{constructor(U){this.value=U}append(U){return new h(this.value?this.value+h.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+h.c)}};ve.c=".",ve=h=qe([L],ve),e.CodeActionKind=ve,ve.Empty=new ve(""),ve.QuickFix=ve.Empty.append("quickfix"),ve.Refactor=ve.Empty.append("refactor"),ve.RefactorExtract=ve.Refactor.append("extract"),ve.RefactorInline=ve.Refactor.append("inline"),ve.RefactorMove=ve.Refactor.append("move"),ve.RefactorRewrite=ve.Refactor.append("rewrite"),ve.Source=ve.Empty.append("source"),ve.SourceOrganizeImports=ve.Source.append("organizeImports"),ve.SourceFixAll=ve.Source.append("fixAll");let Ee=class{constructor(U,ne){if(this.range=U,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([L],Ee),e.SelectionRange=Ee;class We{constructor(U,ne,we,xe,Ye,ot){this.kind=U,this.name=ne,this.detail=we,this.uri=xe,this.range=Ye,this.selectionRange=ot}}e.CallHierarchyItem=We;class je{constructor(U,ne){this.fromRanges=ne,this.from=U}}e.CallHierarchyIncomingCall=je;class it{constructor(U,ne){this.fromRanges=ne,this.to=U}}e.CallHierarchyOutgoingCall=it;var Ge;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Ge=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor(U,ne){this.range=U,this.command=ne}get isResolved(){return!!this.command}};tt=qe([L],tt),e.CodeLens=tt;let nt=y=class{static isMarkdownString(U){return U instanceof y?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ne=!1){t.set(this,void 0),Je(this,t,new D.MarkdownString(U,{supportThemeIcons:ne}),"f")}get value(){return Fe(this,t,"f").value}set value(U){Fe(this,t,"f").value=U}get isTrusted(){return Fe(this,t,"f").isTrusted}set isTrusted(U){Fe(this,t,"f").isTrusted=U}get supportThemeIcons(){return Fe(this,t,"f").supportThemeIcons}set supportThemeIcons(U){Fe(this,t,"f").supportThemeIcons=U}get supportHtml(){return Fe(this,t,"f").supportHtml}set supportHtml(U){Fe(this,t,"f").supportHtml=U}get baseUri(){return Fe(this,t,"f").baseUri}set baseUri(U){Fe(this,t,"f").baseUri=U}appendText(U){return Fe(this,t,"f").appendText(U),this}appendMarkdown(U){return Fe(this,t,"f").appendMarkdown(U),this}appendCodeblock(U,ne){return Fe(this,t,"f").appendCodeblock(ne??"",U),this}};t=new WeakMap,nt=y=qe([L],nt),e.MarkdownString=nt;let Ne=class{constructor(U,ne){this.label=U,this.documentation=ne}};Ne=qe([L],Ne),e.ParameterInformation=Ne;let rt=class{constructor(U,ne){this.label=U,this.documentation=ne,this.parameters=[]}};rt=qe([L],rt),e.SignatureInformation=rt;let G=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};G=qe([L],G),e.SignatureHelp=G;var X;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var pe;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(pe=e.InlayHintKind||(e.InlayHintKind={}));let ze=class{constructor(U){this.value=U}};ze=qe([L],ze),e.InlayHintLabelPart=ze;let Be=class{constructor(U,ne,we){this.position=U,this.label=ne,this.kind=we}};Be=qe([L],Be),e.InlayHint=Be;var Qe;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _e;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(_e=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(z){z[z.Deprecated=1]="Deprecated"})(Xe=e.CompletionItemTag||(e.CompletionItemTag={}));let at=class{constructor(U,ne){this.label=U,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&_e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};at=qe([L],at),e.CompletionItem=at;let bt=class{constructor(U=[],ne=!1){this.items=U,this.isIncomplete=ne}};bt=qe([L],bt),e.CompletionList=bt;let kt=class{constructor(U,ne,we){this.insertText=U,this.range=ne,this.command=we}};kt=qe([L],kt),e.InlineSuggestion=kt;let Dt=class{constructor(U){this.commands=void 0,this.items=U}};Dt=qe([L],Dt),e.InlineSuggestionList=Dt;var St;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(St=e.ViewColumn||(e.ViewColumn={}));var Bt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Bt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ct;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(ct=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(pt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ht;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ht=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ft;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var It;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(It=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ft;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(ft=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function U(ne){switch(ne){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(Ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Tt=class{constructor(U,ne){if(ne&&!P.URI.isUri(ne))throw(0,A.illegalArgument)("target");if(!me.isRange(U)||U.isEmpty)throw(0,A.illegalArgument)("range");this.range=U,this.target=ne}};Tt=qe([L],Tt),e.DocumentLink=Tt;let Nt=class{constructor(U,ne,we,xe){this.red=U,this.green=ne,this.blue=we,this.alpha=xe}};Nt=qe([L],Nt),e.Color=Nt;let Ot=class{constructor(U,ne){if(ne&&!(ne instanceof Nt))throw(0,A.illegalArgument)("color");if(!me.isRange(U)||U.isEmpty)throw(0,A.illegalArgument)("range");this.range=U,this.color=ne}};Ot=qe([L],Ot),e.ColorInformation=Ot;let Ke=class{constructor(U){if(!U||typeof U!="string")throw(0,A.illegalArgument)("label");this.label=U}};Ke=qe([L],Ke),e.ColorPresentation=Ke;var qt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(qt=e.ColorFormat||(e.ColorFormat={}));var Lt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(Lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ut;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(Ut=e.TerminalExitReason||(e.TerminalExitReason={}));class ye{constructor(U,ne,we){if(this.startIndex=U,this.length=ne,this.tooltip=we,typeof U!="number"||U<0)throw(0,A.illegalArgument)("startIndex");if(typeof ne!="number"||ne<1)throw(0,A.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=ye;class Re{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Re;class ge{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=ge;var x;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(x=e.TerminalLocation||(e.TerminalLocation={}));class Oe{constructor(U){if(this.options=U,typeof U!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Oe;var $e;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})($e=e.TaskRevealKind||(e.TaskRevealKind={}));var Ze;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Ze=e.TaskPanelKind||(e.TaskPanelKind={}));let He=C=class{static from(U){switch(U){case"clean":return C.Clean;case"build":return C.Build;case"rebuild":return C.Rebuild;case"test":return C.Test;default:return}}constructor(U,ne){if(this.label=ne,typeof U!="string"||typeof ne!="string")throw(0,A.illegalArgument)("name");this.c=U}get id(){return this.c}};He.Clean=new C("clean","Clean"),He.Build=new C("build","Build"),He.Rebuild=new C("rebuild","Rebuild"),He.Test=new C("test","Test"),He=C=qe([L],He),e.TaskGroup=He;function et(z){let U="";for(let ne=0;ne<z.length;ne++)U+=z[ne].replace(/,/g,",,")+",";return U}let ut=class{constructor(U,ne,we){if(typeof U!="string")throw(0,A.illegalArgument)("process");this.e=[],this.c=U,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=we):this.f=ne)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,A.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)U.push(ne);return et(U)}};ut=qe([L],ut),e.ProcessExecution=ut;let ht=class{constructor(U,ne,we){if(this.f=[],Array.isArray(ne)){if(!U)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,A.illegalArgument)("command");this.e=U,this.f=ne,this.g=we}else{if(typeof U!="string")throw(0,A.illegalArgument)("commandLine");this.c=U,this.g=ne}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,A.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,A.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)U.push(typeof ne=="string"?ne:ne.value);return et(U)}};ht=qe([L],ht),e.ShellExecution=ht;var Ct;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Ct=e.ShellQuoting||(e.ShellQuoting={}));var mt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(mt=e.TaskScope||(e.TaskScope={}));class vt{constructor(U){this.c=U}computeId(){return"customExecution"+(0,M.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=vt;let Pt=H=class{constructor(U,ne,we,xe,Ye,ot){this.j=!1,this.k=this.definition=U;let lt;typeof ne=="string"?(this.m=this.name=ne,this.t=this.source=we,this.execution=xe,lt=Ye,this.j=!0):ne===mt.Global||ne===mt.Workspace?(this.target=ne,this.m=this.name=we,this.t=this.source=xe,this.execution=Ye,lt=ot):(this.target=ne,this.m=this.name=we,this.t=this.source=xe,this.execution=Ye,lt=ot),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ut?this.k={type:H.e,id:this.n.computeId()}:this.n instanceof ht?this.k={type:H.f,id:this.n.computeId()}:this.n instanceof vt?this.k={type:H.c,id:this.n.computeId()}:this.k={type:H.g,id:(0,M.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,A.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const ne=this.k.type;(H.g===ne||H.e===ne||H.f===ne||H.c===ne)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};Pt.c="customExecution",Pt.e="process",Pt.f="shell",Pt.g="$empty",Pt=H=qe([L],Pt),e.Task=Pt;var zt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(zt=e.ProgressLocation||(e.ProgressLocation={}));var At;(function(z){function U(ne){const we=ne;return(0,S.isNumber)(we.value)?we.tooltip&&!(0,S.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}z.isViewBadge=U})(At=e.ViewBadge||(e.ViewBadge={}));let ti=K=class{static isTreeItem(U,ne){const we=U;if(we.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(ne,"treeItemCheckbox");const xe=(0,S.isNumber)(we.checkboxState)?we.checkboxState:(0,S.isObject)(we.checkboxState)&&(0,S.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Ye=!(0,S.isNumber)(we.checkboxState)&&(0,S.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(xe===void 0||xe!==yt.Checked&&xe!==yt.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}if(U instanceof K)return!0;if(we.label!==void 0&&!(0,S.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,S.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,S.isString)(we.iconPath)&&!P.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,S.isString)(we.iconPath.id))){const xe=we.iconPath;if(!xe||!(0,S.isString)(xe.light)&&!P.URI.isUri(xe.light)&&!(0,S.isString)(xe.dark)&&!P.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}return we.description!==void 0&&!(0,S.isString)(we.description)&&typeof we.description!="boolean"?(console.log("INVALID tree item, invalid description",we.description),!1):we.resourceUri!==void 0&&!P.URI.isUri(we.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1):we.tooltip!==void 0&&!(0,S.isString)(we.tooltip)&&!(we.tooltip instanceof nt)?(console.log("INVALID tree item, invalid tooltip",we.tooltip),!1):we.command!==void 0&&!we.command.command?(console.log("INVALID tree item, invalid command",we.command),!1):we.collapsibleState!==void 0&&we.collapsibleState<oi.None&&we.collapsibleState>oi.Expanded?(console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1):we.contextValue!==void 0&&!(0,S.isString)(we.contextValue)?(console.log("INVALID tree item, invalid contextValue",we.contextValue),!1):we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1):!0}constructor(U,ne=oi.None){this.collapsibleState=ne,P.URI.isUri(U)?this.resourceUri=U:this.label=U}};ti=K=qe([L],ti),e.TreeItem=ti;var oi;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(oi=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var yt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(yt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ai=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,ne){this.value=U,this.id=ne??(0,M.generateUuid)()}};ai=qe([L],ai),e.DataTransferItem=ai;let ci=class{constructor(U){a.set(this,new Map);for(const[ne,we]of U??[]){const xe=Fe(this,a,"f").get(ne);xe?xe.push(we):Fe(this,a,"f").set(ne,[we])}}get(U){return Fe(this,a,"f").get(U)?.[0]}set(U,ne){Fe(this,a,"f").set(U,[ne])}forEach(U,ne){for(const[we,xe]of Fe(this,a,"f"))for(const Ye of xe)U.call(ne,Ye,we,this)}*[(a=new WeakMap,Symbol.iterator)](){for(const[U,ne]of Fe(this,a,"f"))for(const we of ne)yield[U,we]}};ci=qe([L],ci),e.DataTransfer=ci;let Jt=class{constructor(U){this.insertText=U}};Jt=qe([L],Jt),e.DocumentDropEdit=Jt;let wi=class{constructor(U){this.insertText=U}};wi=qe([L],wi),e.DocumentPasteEdit=wi;let Et=class{constructor(U,ne){this.id=U,this.color=ne}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};Et=qe([L],Et),e.ThemeIcon=Et,Et.File=new Et("file"),Et.Folder=new Et("folder");let ui=class{constructor(U){this.id=U}};ui=qe([L],ui),e.ThemeColor=ui;var Ui;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ui=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Zt=class{get base(){return this.c}set base(U){this.c=U,this.e=P.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,ne){if(typeof U!="string"&&(!U||!P.URI.isUri(U)&&!P.URI.isUri(U.uri)))throw(0,A.illegalArgument)("base");if(typeof ne!="string")throw(0,A.illegalArgument)("pattern");typeof U=="string"?this.baseUri=P.URI.file(U):P.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Zt=qe([L],Zt),e.RelativePattern=Zt;const ii=new WeakMap;function dt(z,U){ii.set(z,U)}e.setBreakpointId=dt;let ei=class{constructor(U,ne,we,xe){this.enabled=typeof U=="boolean"?U:!0,typeof ne=="string"&&(this.condition=ne),typeof we=="string"&&(this.hitCondition=we),typeof xe=="string"&&(this.logMessage=xe)}get id(){return this.c||(this.c=ii.get(this)??(0,M.generateUuid)()),this.c}};ei=qe([L],ei),e.Breakpoint=ei;let Vt=class extends ei{constructor(U,ne,we,xe,Ye){if(super(ne,we,xe,Ye),U===null)throw(0,A.illegalArgument)("location");this.location=U}};Vt=qe([L],Vt),e.SourceBreakpoint=Vt;let Xt=class extends ei{constructor(U,ne,we,xe,Ye){super(ne,we,xe,Ye),this.functionName=U}};Xt=qe([L],Xt),e.FunctionBreakpoint=Xt;let li=class extends ei{constructor(U,ne,we,xe,Ye,ot,lt){if(super(xe,Ye,ot,lt),!ne)throw(0,A.illegalArgument)("dataId");this.label=U,this.dataId=ne,this.canPersist=we}};li=qe([L],li),e.DataBreakpoint=li;let Si=class{constructor(U,ne,we){this.command=U,this.args=ne||[],this.options=we}};Si=qe([L],Si),e.DebugAdapterExecutable=Si;let yi=class{constructor(U,ne){this.port=U,this.host=ne}};yi=qe([L],yi),e.DebugAdapterServer=yi;let di=class{constructor(U){this.path=U}};di=qe([L],di),e.DebugAdapterNamedPipeServer=di;let Di=class{constructor(U){this.implementation=U}};Di=qe([L],Di),e.DebugAdapterInlineImplementation=Di;let hi=class{constructor(U,ne){this.range=U,this.expression=ne}};hi=qe([L],hi),e.EvaluatableExpression=hi;var fi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(fi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ii=class{constructor(U,ne){this.range=U,this.text=ne}};Ii=qe([L],Ii),e.InlineValueText=Ii;let ni=class{constructor(U,ne,we=!0){this.range=U,this.variableName=ne,this.caseSensitiveLookup=we}};ni=qe([L],ni),e.InlineValueVariableLookup=ni;let ri=class{constructor(U,ne){this.range=U,this.expression=ne}};ri=qe([L],ri),e.InlineValueEvaluatableExpression=ri;let Ci=class{constructor(U,ne){this.frameId=U,this.stoppedLocation=ne}};Ci=qe([L],Ci),e.InlineValueContext=Ci;var $i;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})($i=e.FileChangeType||(e.FileChangeType={}));let Qt=Q=class extends Error{static FileExists(U){return new Q(U,T.FileSystemProviderErrorCode.FileExists,Q.FileExists)}static FileNotFound(U){return new Q(U,T.FileSystemProviderErrorCode.FileNotFound,Q.FileNotFound)}static FileNotADirectory(U){return new Q(U,T.FileSystemProviderErrorCode.FileNotADirectory,Q.FileNotADirectory)}static FileIsADirectory(U){return new Q(U,T.FileSystemProviderErrorCode.FileIsADirectory,Q.FileIsADirectory)}static NoPermissions(U){return new Q(U,T.FileSystemProviderErrorCode.NoPermissions,Q.NoPermissions)}static Unavailable(U){return new Q(U,T.FileSystemProviderErrorCode.Unavailable,Q.Unavailable)}constructor(U,ne=T.FileSystemProviderErrorCode.Unknown,we){super(P.URI.isUri(U)?U.toString(!0):U),this.code=we?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,ne),Object.setPrototypeOf(this,Q.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};Qt=Q=qe([L],Qt),e.FileSystemError=Qt;let ki=class{constructor(U,ne,we){this.start=U,this.end=ne,this.kind=we}};ki=qe([L],ki),e.FoldingRange=ki;var Bi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Bi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var zi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(zi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Wi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Wi=e.CommentMode||(e.CommentMode={}));var Hi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Hi=e.CommentThreadState||(e.CommentThreadState={}));class Ti{constructor(U,ne=[]){this.tokenTypes=U,this.tokenModifiers=ne}}e.SemanticTokensLegend=Ti;function Oi(z){return typeof z>"u"||(0,S.isStringArray)(z)}class mi{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let ne=0,we=U.tokenTypes.length;ne<we;ne++)this.j.set(U.tokenTypes[ne],ne);for(let ne=0,we=U.tokenModifiers.length;ne<we;ne++)this.k.set(U.tokenModifiers[ne],ne)}}push(U,ne,we,xe,Ye){if(typeof U=="number"&&typeof ne=="number"&&typeof we=="number"&&typeof xe=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(U,ne,we,xe,Ye);if(me.isRange(U)&&typeof ne=="string"&&Oi(we))return this.m(U,ne,we);throw(0,A.illegalArgument)()}m(U,ne,we){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ne))throw new Error("`tokenType` is not in the provided legend");const xe=U.start.line,Ye=U.start.character,ot=U.end.character-U.start.character,lt=this.j.get(ne);let Mt=0;if(we)for(const Wt of we){if(!this.k.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const jt=this.k.get(Wt);Mt|=1<<jt>>>0}this.n(xe,Ye,ot,lt,Mt)}n(U,ne,we,xe,Ye){if(this.f&&(U<this.c||U===this.c&&ne<this.e)){this.f=!1;const Mt=this.g.length/5|0;let Wt=0,jt=0;for(let Gt=0;Gt<Mt;Gt++){let _t=this.g[5*Gt],Ai=this.g[5*Gt+1];_t===0?(_t=Wt,Ai+=jt):_t+=Wt,this.g[5*Gt]=_t,this.g[5*Gt+1]=Ai,Wt=_t,jt=Ai}}let ot=U,lt=ne;this.f&&this.h>0&&(ot-=this.c,ot===0&&(lt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=lt,this.g[this.h++]=we,this.g[this.h++]=xe,this.g[this.h++]=Ye,this.c=U,this.e=ne}static o(U){const ne=[],we=U.length/5|0;for(let lt=0;lt<we;lt++)ne[lt]=lt;ne.sort((lt,Mt)=>{const Wt=U[5*lt],jt=U[5*Mt];if(Wt===jt){const Gt=U[5*lt+1],_t=U[5*Mt+1];return Gt-_t}return Wt-jt});const xe=new Uint32Array(U.length);let Ye=0,ot=0;for(let lt=0;lt<we;lt++){const Mt=5*ne[lt],Wt=U[Mt+0],jt=U[Mt+1],Gt=U[Mt+2],_t=U[Mt+3],Ai=U[Mt+4],sn=Wt-Ye,Rn=sn===0?jt-ot:jt,Ri=5*lt;xe[Ri+0]=sn,xe[Ri+1]=Rn,xe[Ri+2]=Gt,xe[Ri+3]=_t,xe[Ri+4]=Ai,Ye=Wt,ot=jt}return xe}build(U){return this.f?new Me(new Uint32Array(this.g),U):new Me(mi.o(this.g),U)}}e.SemanticTokensBuilder=mi;class Me{constructor(U,ne){this.resultId=ne,this.data=U}}e.SemanticTokens=Me;class xt{constructor(U,ne,we){this.start=U,this.deleteCount=ne,this.data=we}}e.SemanticTokensEdit=xt;class Li{constructor(U,ne){this.resultId=ne,this.edits=U}}e.SemanticTokensEdits=Li;var gt;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let gi=class{constructor(){}};gi.Back={iconPath:new Et("arrow-left")},gi=qe([L],gi),e.QuickInputButtons=gi;var Vi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Vi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Fi;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(Fi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var ji;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(ji=e.ExtensionKind||(e.ExtensionKind={}));class pi{static validate(U){if(typeof U.badge=="string"){let ne=(0,O.nextCharLength)(U.badge,0);if(ne<U.badge.length&&(ne+=(0,O.nextCharLength)(U.badge,ne)),U.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!Et.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ne,we){this.badge=U,this.tooltip=ne,this.color=we}}e.FileDecoration=pi;let Pi=class{constructor(U){this.kind=U}};Pi=qe([L],Pi),e.ColorTheme=Pi;var qi;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(qi=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(U){return U instanceof Kt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,ne){if(U<0)throw(0,A.illegalArgument)("start must be positive");if(ne<0)throw(0,A.illegalArgument)("end must be positive");U<=ne?(this.c=U,this.e=ne):(this.c=ne,this.e=U)}with(U){let ne=this.c,we=this.e;return U.start!==void 0&&(ne=U.start),U.end!==void 0&&(we=U.end),ne===this.c&&we===this.e?this:new Kt(ne,we)}}e.NotebookRange=Kt;class si{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ne=>si.isNotebookCellData(ne))}static isNotebookCellData(U){return!0}constructor(U,ne,we,xe,Ye,ot,lt){this.kind=U,this.value=ne,this.languageId=we,this.mime=xe,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=lt,si.validate(this)}}e.NotebookCellData=si;class xi{constructor(U){this.cells=U}}e.NotebookData=xi;class $t{static isNotebookCellOutputItem(U){return U instanceof $t?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ne={name:U.name,message:U.message,stack:U.stack};return $t.json(ne,"application/vnd.code.notebook.error")}static stdout(U){return $t.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return $t.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ne="application/octet-stream"){return new $t(U,ne)}static text(U,ne=E.Mimes.text){const we=Fe($t,p,"f",b).encode(String(U));return new $t(we,ne)}static json(U,ne="text/x-json"){const we=JSON.stringify(U,void 0,"	");return $t.text(we,ne)}constructor(U,ne){this.data=U,this.mime=ne;const we=(0,E.normalizeMimeType)(ne,!0);if(!we)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}p=$t,b={value:new TextEncoder},e.NotebookCellOutputItem=$t;class vi{static isNotebookCellOutput(U){return U instanceof vi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ne=!1){const we=new Set,xe=new Set;for(let Ye=0;Ye<U.length;Ye++){const ot=U[Ye],lt=(0,E.normalizeMimeType)(ot.mime);if(!we.has(lt)||(0,w.isTextStreamMime)(lt)){we.add(lt);continue}xe.add(Ye),ne&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return xe.size===0?U:U.filter((Ye,ot)=>!xe.has(ot))}constructor(U,ne,we){this.items=vi.ensureUniqueMimeTypes(U,!0),typeof ne=="string"?(this.id=ne,this.metadata=we):(this.id=(0,M.generateUuid)(),this.metadata=ne??we)}}e.NotebookCellOutput=vi;var Ki;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Gi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Gi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Xi;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Xi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var re;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(re=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class he{constructor(U,ne){this.text=U,this.alignment=ne}}e.NotebookCellStatusBarItem=he;var Le;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(Le=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var st;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(st=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class wt{constructor(U,ne=[]){this.uri=U,this.provides=(0,n.asArray)(ne)}}e.NotebookRendererScript=wt;class Rt{constructor(U){this.label=U}}e.NotebookKernelSourceAction=Rt;let Qi=class{constructor(U,ne){this.label=U,this.timestamp=ne}};Qi=qe([L],Qi),e.TimelineItem=Qi;var ln;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(ln=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(U,ne){this.ranges=U,this.wordPattern=ne}}e.LinkedEditingRanges=fn;class mn{constructor(U,ne){this.c=U,this.e=ne}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ni=class{constructor(U=void 0,ne=void 0,we=void 0){this.include=U,this.exclude=ne,this.profile=we}};Ni=qe([L],Ni),e.TestRunRequest=Ni;let _i=class extends Ni{constructor(U=void 0,ne=void 0,we=void 0,xe=!1){super(U,ne,we),this.continuous=xe}};_i=qe([L],_i),e.TestRunRequest2=_i;let Yi=_=class{static diff(U,ne,we){const xe=new _(U);return xe.expectedOutput=ne,xe.actualOutput=we,xe}constructor(U){this.message=U}};Yi=_=qe([L],Yi),e.TestMessage=Yi;let Ji=class{constructor(U){this.id=U}};Ji=qe([L],Ji),e.TestTag=Ji;let bi=class{constructor(U,ne){this.covered=U,this.total=ne}};bi=qe([L],bi),e.CoveredCount=bi;let Zi=j=class{static fromDetails(U,ne){const we=new bi(0,0),xe=new bi(0,0),Ye=new bi(0,0);for(const lt of ne)if("branches"in lt){we.total+=1,we.covered+=lt.executionCount>0?1:0;for(const Mt of lt.branches)xe.total+=1,xe.covered+=Mt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=lt.executionCount>0?1:0;const ot=new j(U,we,xe.total>0?xe:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=ne,ot}constructor(U,ne,we,xe){this.uri=U,this.statementCoverage=ne,this.branchCoverage=we,this.functionCoverage=xe}};Zi=j=qe([L],Zi),e.FileCoverage=Zi;let en=class{constructor(U,ne,we=[]){this.executionCount=U,this.location=ne,this.branches=we}};en=qe([L],en),e.StatementCoverage=en;let tn=class{constructor(U,ne){this.executionCount=U,this.location=ne}};tn=qe([L],tn),e.BranchCoverage=tn;let nn=class{constructor(U,ne){this.executionCount=U,this.location=ne}};nn=qe([L],nn),e.FunctionCoverage=nn;var vn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(U,ne,we,xe,Ye,ot){this.kind=U,this.name=ne,this.detail=we,this.uri=xe,this.range=Ye,this.selectionRange=ot}}e.TypeHierarchyItem=wn;class Sn{constructor(U){this.uri=U}}e.TextTabInput=Sn;class yn{constructor(U,ne){this.original=U,this.modified=ne}}e.TextDiffTabInput=yn;class Dn{constructor(U,ne,we,xe){this.base=U,this.input1=ne,this.input2=we,this.result=xe}}e.TextMergeTabInput=Dn;class In{constructor(U,ne){this.uri=U,this.viewType=ne}}e.CustomEditorTabInput=In;class Cn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=Cn;class kn{constructor(U,ne){this.uri=U,this.notebookType=ne}}e.NotebookEditorTabInput=kn;class Tn{constructor(U,ne,we){this.original=U,this.modified=ne,this.notebookType=we}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(U,ne){this.uri=U,this.inputBoxUri=ne}}e.InteractiveWindowInput=An}),define(Te[100],Pe([1,0,49,15,10,259,132,7,16]),function(te,e,n,A,D,N,E,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const P=new Map;function M(f,u){u?P.set(f,u):P.delete(f)}e.setWordDefinitionFor=M;function T(f){return P.get(f)}class m extends N.MirrorTextModel{constructor(u,t,a,p,b,R,v,i){super(t,a,p,b),this.m=u,this.p=R,this.q=v,this.notebook=i,this.b=!1}dispose(){(0,n.ok)(!this.b),this.b=!0,this.q=!1}equalLines(u){return(0,S.equals)(this.d,u)}get document(){if(!this.a){const u=this;this.a={get uri(){return u.c},get fileName(){return u.c.fsPath},get isUntitled(){return u.c.scheme===A.Schemas.untitled},get languageId(){return u.p},get version(){return u.g},get isClosed(){return u.b},get isDirty(){return u.q},save(){return u.r()},getText(t){return t?u.s(t):u.getText()},get eol(){return u.f===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return u.d.length},lineAt(t){return u.t(t)},offsetAt(t){return u.u(t)},positionAt(t){return u.v(t)},validateRange(t){return u.w(t)},validatePosition(t){return u.x(t)},getWordRangeAtPosition(t,a){return u.y(t,a)}}}return Object.freeze(this.a)}_acceptLanguageId(u){(0,n.ok)(!this.b),this.p=u}_acceptIsDirty(u){(0,n.ok)(!this.b),this.q=u}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(u){const t=this.w(u);if(t.isEmpty)return"";if(t.isSingleLine)return this.d[t.start.line].substring(t.start.character,t.end.character);const a=this.f,p=t.start.line,b=t.end.line,R=[];R.push(this.d[p].substring(t.start.character));for(let v=p+1;v<b;v++)R.push(this.d[v]);return R.push(this.d[b].substring(0,t.end.character)),R.join(a)}t(u){let t;if(u instanceof O.Position?t=u.line:typeof u=="number"&&(t=u),typeof t!="number"||t<0||t>=this.d.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new w(t,this.d[t],t===this.d.length-1)}u(u){return u=this.x(u),this.k(),this.h.getPrefixSum(u.line-1)+u.character}v(u){u=Math.floor(u),u=Math.max(0,u),this.k();const t=this.h.getIndexOf(u),a=this.d[t.index].length;return new O.Position(t.index,Math.min(t.remainder,a))}w(u){if(!(u instanceof O.Range))throw new Error("Invalid argument");const t=this.x(u.start),a=this.x(u.end);return t===u.start&&a===u.end?u:new O.Range(t.line,t.character,a.line,a.character)}x(u){if(!(u instanceof O.Position))throw new Error("Invalid argument");if(this.d.length===0)return u.with(0,0);let{line:t,character:a}=u,p=!1;if(t<0)t=0,a=0,p=!0;else if(t>=this.d.length)t=this.d.length-1,a=this.d[t].length,p=!0;else{const b=this.d[t].length;a<0?(a=0,p=!0):a>b&&(a=b,p=!0)}return p?new O.Position(t,a):u}y(u,t){const a=this.x(u);if(!t)t=T(this.p);else if((0,D.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const p=(0,E.getWordAtText)(a.character+1,(0,E.ensureValidWordDefinition)(t),this.d[a.line],0);if(p)return new O.Range(a.line,p.startColumn-1,a.line,p.endColumn-1)}}e.ExtHostDocumentData=m;class w{constructor(u,t,a){this.a=u,this.b=t,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=w}),define(Te[194],Pe([1,0,7,18,4]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let N=class{constructor(O){this.a=new n.ColorTheme(n.ColorThemeKind.Dark),this.b=new D.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(O){let S;switch(O){case"light":S=n.ColorThemeKind.Light;break;case"hcDark":S=n.ColorThemeKind.HighContrast;break;case"hcLight":S=n.ColorThemeKind.HighContrastLight;break;default:S=n.ColorThemeKind.Dark}this.a=new n.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};N=qe([Ve(0,A.IExtHostRpcService)],N),e.ExtHostTheming=N}),define(Te[8],Pe([1,0,16,25,117,195,86,28,113,66,65,23,9,2,44,75,91,97,96,71,45,56,191,7]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t,a,p,b,R,v,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(ye){function Re(x){const{selectionStartLineNumber:Oe,selectionStartColumn:$e,positionLineNumber:Ze,positionColumn:He}=x,et=new d.Position(Oe-1,$e-1),ut=new d.Position(Ze-1,He-1);return new d.Selection(et,ut)}ye.to=Re;function ge(x){const{anchor:Oe,active:$e}=x;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}ye.from=ge})(s=e.Selection||(e.Selection={}));var l;(function(ye){function Re(x){if(!x)return;const{start:Oe,end:$e}=x;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}ye.from=Re;function ge(x){if(!x)return;const{startLineNumber:Oe,startColumn:$e,endLineNumber:Ze,endColumn:He}=x;return new d.Range(Oe-1,$e-1,Ze-1,He-1)}ye.to=ge})(l=e.Range||(e.Range={}));var o;(function(ye){function Re(ge){switch(ge){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}ye.to=Re})(o=e.TokenType||(e.TokenType={}));var I;(function(ye){function Re(x){return new d.Position(x.lineNumber-1,x.column-1)}ye.to=Re;function ge(x){return{lineNumber:x.line+1,column:x.character+1}}ye.from=ge})(I=e.Position||(e.Position={}));var r;(function(ye){function Re(Oe,$e){return(0,n.coalesce)((0,n.asArray)(Oe).map(Ze=>ge(Ze,$e)))}ye.from=Re;function ge(Oe,$e){if(typeof Oe=="string")return{$serialized:!0,language:Oe};if(Oe)return{$serialized:!0,language:Oe.language,scheme:x(Oe.scheme,$e),pattern:pe.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType}}function x(Oe,$e){return $e&&typeof Oe=="string"?$e.transformOutgoingScheme(Oe):Oe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var c;(function(ye){function Re(x){switch(x){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}ye.from=Re;function ge(x){switch(x){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}ye.to=ge})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var h;(function(ye){function Re(x){let Oe;return x.code&&((0,m.isString)(x.code)||(0,m.isNumber)(x.code)?Oe=String(x.code):Oe={value:String(x.code.value),target:x.code.target}),{...l.from(x.range),message:x.message,source:x.source,code:Oe,severity:C.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(y.from),tags:Array.isArray(x.tags)?(0,n.coalesce)(x.tags.map(c.from)):void 0}}ye.from=Re;function ge(x){const Oe=new d.Diagnostic(l.to(x),x.message,C.to(x.severity));return Oe.source=x.source,Oe.code=(0,m.isString)(x.code)?x.code:x.code?.value,Oe.relatedInformation=x.relatedInformation&&x.relatedInformation.map(y.to),Oe.tags=x.tags&&(0,n.coalesce)(x.tags.map(c.to)),Oe}ye.to=ge})(h=e.Diagnostic||(e.Diagnostic={}));var y;(function(ye){function Re(x){return{...l.from(x.location.range),message:x.message,resource:x.location.uri}}ye.from=Re;function ge(x){return new d.DiagnosticRelatedInformation(new d.Location(x.resource,l.to(x)),x.message)}ye.to=ge})(y=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var C;(function(ye){function Re(x){switch(x){case d.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}ye.from=Re;function ge(x){switch(x){case t.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}ye.to=ge})(C=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var H;(function(ye){function Re(x){return typeof x=="number"&&x>=d.ViewColumn.One?x-1:x===d.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}ye.from=Re;function ge(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=ge})(H=e.ViewColumn||(e.ViewColumn={}));function K(ye){return typeof ye.range<"u"}function Q(ye){return ye.length===0?!0:!!K(ye[0])}e.isDecorationOptionsArr=Q;var _;(function(ye){function Re(He){return He.map(ye.from)}ye.fromMany=Re;function ge(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function x(He){let et;if(ge(He)){const{language:mt,value:vt}=He;et={value:"```"+mt+`
`+vt+"\n```\n"}}else d.MarkdownString.isMarkdownString(He)?et={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?et={value:He}:et={value:""};const ut=Object.create(null);et.uris=ut;const ht=mt=>{try{let vt=w.URI.parse(mt,!0);vt=vt.with({query:Oe(vt.query,ut)}),ut[mt]=vt}catch{}return""},Ct=new S.marked.Renderer;return Ct.link=ht,Ct.image=mt=>typeof mt=="string"?ht(E.parseHrefAndDimensions(mt).href):"",(0,S.marked)(et.value,{renderer:Ct}),et}ye.from=x;function Oe(He,et){if(!He)return He;let ut;try{ut=(0,P.parse)(He)}catch{}if(!ut)return He;let ht=!1;return ut=(0,T.cloneAndChange)(ut,Ct=>{if(w.URI.isUri(Ct)){const mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[mt]=Ct,ht=!0,mt}else return}),ht?JSON.stringify(ut):He}function $e(He){const et=new d.MarkdownString(He.value,He.supportThemeIcons);return et.isTrusted=He.isTrusted,et.supportHtml=He.supportHtml,et.baseUri=He.baseUri?w.URI.from(He.baseUri):void 0,et}ye.to=$e;function Ze(He){if(!!He)return typeof He=="string"?He:ye.from(He)}ye.fromStrict=Ze})(_=e.MarkdownString||(e.MarkdownString={}));function j(ye){return Q(ye)?ye.map(Re=>({range:l.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?_.fromMany(Re.hoverMessage):Re.hoverMessage?_.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):ye.map(Re=>({range:l.from(Re)}))}e.fromRangeOrRangeWithMessage=j;function L(ye){return typeof ye>"u"?ye:typeof ye=="string"?w.URI.file(ye):ye}e.pathOrURIToURI=L;var g;(function(ye){function Re(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?L(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}ye.from=Re})(g=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(ye){function Re(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?L(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?g.from(ge.before):void 0,after:ge.after?g.from(ge.after):void 0}}ye.from=Re})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var B;(function(ye){function Re(ge){if(typeof ge>"u")return ge;switch(ge){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Re})(B=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var Y;(function(ye){function Re(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?B.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?F.from(ge.light):void 0,dark:ge.dark?F.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?L(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?g.from(ge.before):void 0,after:ge.after?g.from(ge.after):void 0}}ye.from=Re})(Y=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var me;(function(ye){function Re(x){return{text:x.newText,eol:x.newEol&&nt.from(x.newEol),range:l.from(x.range)}}ye.from=Re;function ge(x){const Oe=new d.TextEdit(l.to(x.range),x.text);return Oe.newEol=typeof x.eol>"u"?void 0:nt.to(x.eol),Oe}ye.to=ge})(me=e.TextEdit||(e.TextEdit={}));var Z;(function(ye){function Re(x,Oe){const $e={edits:[]};if(x instanceof d.WorkspaceEdit){const Ze=new O.ResourceSet;for(const He of x._allEntries())He._type===1&&w.URI.isUri(He.to)&&He.from===void 0&&Ze.add(He.to);for(const He of x._allEntries())He._type===1?$e.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contentsBase64:He.options?.contents&&(0,A.encodeBase64)(A.VSBuffer.wrap(He.options.contents))},metadata:He.metadata}):He._type===2?$e.edits.push({resource:He.uri,textEdit:me.from(He.edit),versionId:Ze.has(He.uri)?void 0:Oe?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?$e.edits.push({resource:He.uri,textEdit:{range:l.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Ze.has(He.uri)?void 0:Oe?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?$e.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(He.uri)}):He._type===5&&$e.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(bt.from)}})}return $e}ye.from=Re;function ge(x){const Oe=new d.WorkspaceEdit;for(const $e of x.edits)$e.textEdit?Oe.replace(w.URI.revive($e.resource),l.to($e.textEdit.range),$e.textEdit.text):Oe.renameFile(w.URI.revive($e.oldResource),w.URI.revive($e.newResource),$e.options);return Oe}ye.to=ge})(Z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var se;(function(ye){const Re=Object.create(null);Re[d.SymbolKind.File]=0,Re[d.SymbolKind.Module]=1,Re[d.SymbolKind.Namespace]=2,Re[d.SymbolKind.Package]=3,Re[d.SymbolKind.Class]=4,Re[d.SymbolKind.Method]=5,Re[d.SymbolKind.Property]=6,Re[d.SymbolKind.Field]=7,Re[d.SymbolKind.Constructor]=8,Re[d.SymbolKind.Enum]=9,Re[d.SymbolKind.Interface]=10,Re[d.SymbolKind.Function]=11,Re[d.SymbolKind.Variable]=12,Re[d.SymbolKind.Constant]=13,Re[d.SymbolKind.String]=14,Re[d.SymbolKind.Number]=15,Re[d.SymbolKind.Boolean]=16,Re[d.SymbolKind.Array]=17,Re[d.SymbolKind.Object]=18,Re[d.SymbolKind.Key]=19,Re[d.SymbolKind.Null]=20,Re[d.SymbolKind.EnumMember]=21,Re[d.SymbolKind.Struct]=22,Re[d.SymbolKind.Event]=23,Re[d.SymbolKind.Operator]=24,Re[d.SymbolKind.TypeParameter]=25;function ge(Oe){return typeof Re[Oe]=="number"?Re[Oe]:6}ye.from=ge;function x(Oe){for(const $e in Re)if(Re[$e]===Oe)return Number($e);return d.SymbolKind.Property}ye.to=x})(se=e.SymbolKind||(e.SymbolKind={}));var ue;(function(ye){function Re(x){switch(x){case d.SymbolTag.Deprecated:return 1}}ye.from=Re;function ge(x){switch(x){case 1:return d.SymbolTag.Deprecated}}ye.to=ge})(ue=e.SymbolTag||(e.SymbolTag={}));var De;(function(ye){function Re(x){return{name:x.name,kind:se.from(x.kind),tags:x.tags&&x.tags.map(ue.from),containerName:x.containerName,location:be.from(x.location)}}ye.from=Re;function ge(x){const Oe=new d.SymbolInformation(x.name,se.to(x.kind),x.containerName,be.to(x.location));return Oe.tags=x.tags&&x.tags.map(ue.to),Oe}ye.to=ge})(De=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var de;(function(ye){function Re(x){const Oe={name:x.name||"!!MISSING: name!!",detail:x.detail,range:l.from(x.range),selectionRange:l.from(x.selectionRange),kind:se.from(x.kind),tags:x.tags?.map(ue.from)??[]};return x.children&&(Oe.children=x.children.map(Re)),Oe}ye.from=Re;function ge(x){const Oe=new d.DocumentSymbol(x.name,x.detail,se.to(x.kind),l.to(x.range),l.to(x.selectionRange));return(0,n.isNonEmptyArray)(x.tags)&&(Oe.tags=x.tags.map(ue.to)),x.children&&(Oe.children=x.children.map(ge)),Oe}ye.to=ge})(de=e.DocumentSymbol||(e.DocumentSymbol={}));var ie;(function(ye){function Re(x){const Oe=new d.CallHierarchyItem(se.to(x.kind),x.name,x.detail||"",w.URI.revive(x.uri),l.to(x.range),l.to(x.selectionRange));return Oe._sessionId=x._sessionId,Oe._itemId=x._itemId,Oe}ye.to=Re;function ge(x,Oe,$e){if(Oe=Oe??x._sessionId,$e=$e??x._itemId,Oe===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:$e,name:x.name,detail:x.detail,kind:se.from(x.kind),uri:x.uri,range:l.from(x.range),selectionRange:l.from(x.selectionRange),tags:x.tags?.map(ue.from)}}ye.from=ge})(ie=e.CallHierarchyItem||(e.CallHierarchyItem={}));var q;(function(ye){function Re(ge){return new d.CallHierarchyIncomingCall(ie.to(ge.from),ge.fromRanges.map(x=>l.to(x)))}ye.to=Re})(q=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ce;(function(ye){function Re(ge){return new d.CallHierarchyOutgoingCall(ie.to(ge.to),ge.fromRanges.map(x=>l.to(x)))}ye.to=Re})(ce=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var be;(function(ye){function Re(x){return{range:x.range&&l.from(x.range),uri:x.uri}}ye.from=Re;function ge(x){return new d.Location(w.URI.revive(x.uri),l.to(x.range))}ye.to=ge})(be=e.location||(e.location={}));var Ae;(function(ye){function Re(x){const Oe=x,$e=x;return{originSelectionRange:Oe.originSelectionRange?l.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:$e.uri,range:l.from(Oe.targetRange?Oe.targetRange:$e.range),targetSelectionRange:Oe.targetSelectionRange?l.from(Oe.targetSelectionRange):void 0}}ye.from=Re;function ge(x){return{targetUri:w.URI.revive(x.uri),targetRange:l.to(x.range),targetSelectionRange:x.targetSelectionRange?l.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?l.to(x.originSelectionRange):void 0}}ye.to=ge})(Ae=e.DefinitionLink||(e.DefinitionLink={}));var Ue;(function(ye){function Re(x){return{range:l.from(x.range),contents:_.fromMany(x.contents)}}ye.from=Re;function ge(x){return new d.Hover(x.contents.map(_.to),l.to(x.range))}ye.to=ge})(Ue=e.Hover||(e.Hover={}));var Ce;(function(ye){function Re(x){return{range:l.from(x.range),expression:x.expression}}ye.from=Re;function ge(x){return new d.EvaluatableExpression(l.to(x.range),x.expression)}ye.to=ge})(Ce=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(ye){function Re(x){if(x instanceof d.InlineValueText)return{type:"text",range:l.from(x.range),text:x.text};if(x instanceof d.InlineValueVariableLookup)return{type:"variable",range:l.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:l.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Re;function ge(x){switch(x.type){case"text":return{range:l.to(x.range),text:x.text};case"variable":return{range:l.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:l.to(x.range),expression:x.expression}}}ye.to=ge})(Se=e.InlineValue||(e.InlineValue={}));var ke;(function(ye){function Re(x){return{frameId:x.frameId,stoppedLocation:l.from(x.stoppedLocation)}}ye.from=Re;function ge(x){return new d.InlineValueContext(x.frameId,l.to(x.stoppedLocation))}ye.to=ge})(ke=e.InlineValueContext||(e.InlineValueContext={}));var oe;(function(ye){function Re(x){return{range:l.from(x.range),kind:x.kind}}ye.from=Re;function ge(x){return new d.DocumentHighlight(l.to(x.range),x.kind)}ye.to=ge})(oe=e.DocumentHighlight||(e.DocumentHighlight={}));var ae;(function(ye){function Re(ge){switch(ge){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}ye.to=Re})(ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(ye){function Re(ge){return{triggerKind:ae.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}ye.to=Re})(J=e.CompletionContext||(e.CompletionContext={}));var k;(function(ye){function Re(x){switch(x){case d.CompletionItemTag.Deprecated:return 1}}ye.from=Re;function ge(x){switch(x){case 1:return d.CompletionItemTag.Deprecated}}ye.to=ge})(k=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(ye){const Re=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ge($e){return Re.get($e)??9}ye.from=ge;const x=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Oe($e){return x.get($e)??d.CompletionItemKind.Property}ye.to=Oe})($=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(ye){function Re(ge,x){const Oe=new d.CompletionItem(ge.label);return Oe.insertText=ge.insertText,Oe.kind=$.to(ge.kind),Oe.tags=ge.tags?.map(k.to),Oe.detail=ge.detail,Oe.documentation=E.isMarkdownString(ge.documentation)?_.to(ge.documentation):ge.documentation,Oe.sortText=ge.sortText,Oe.filterText=ge.filterText,Oe.preselect=ge.preselect,Oe.commitCharacters=ge.commitCharacters,f.Range.isIRange(ge.range)?Oe.range=l.to(ge.range):typeof ge.range=="object"&&(Oe.range={inserting:l.to(ge.range.insert),replacing:l.to(ge.range.replace)}),Oe.keepWhitespace=typeof ge.insertTextRules>"u"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Oe.insertText=new d.SnippetString(ge.insertText):(Oe.insertText=ge.insertText,Oe.textEdit=Oe.range instanceof d.Range?new d.TextEdit(Oe.range,Oe.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Oe.additionalTextEdits=ge.additionalTextEdits.map($e=>me.to($e))),Oe.command=x&&ge.command?x.fromInternal(ge.command):void 0,Oe}ye.to=Re})(W=e.CompletionItem||(e.CompletionItem={}));var V;(function(ye){function Re(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:_.fromStrict(x.documentation)}}ye.from=Re;function ge(x){return{label:x.label,documentation:E.isMarkdownString(x.documentation)?_.to(x.documentation):x.documentation}}ye.to=ge})(V=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(ye){function Re(x){return{label:x.label,documentation:_.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(V.from):[],activeParameter:x.activeParameter}}ye.from=Re;function ge(x){return{label:x.label,documentation:E.isMarkdownString(x.documentation)?_.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(V.to):[],activeParameter:x.activeParameter}}ye.to=ge})(ee=e.SignatureInformation||(e.SignatureInformation={}));var fe;(function(ye){function Re(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ee.from):[]}}ye.from=Re;function ge(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ee.to):[]}}ye.to=ge})(fe=e.SignatureHelp||(e.SignatureHelp={}));var Ie;(function(ye){function Re(ge,x){const Oe=new d.InlayHint(I.to(x.position),typeof x.label=="string"?x.label:x.label.map(le.to.bind(void 0,ge)),x.kind&&ve.to(x.kind));return Oe.textEdits=x.textEdits&&x.textEdits.map(me.to),Oe.tooltip=E.isMarkdownString(x.tooltip)?_.to(x.tooltip):x.tooltip,Oe.paddingLeft=x.paddingLeft,Oe.paddingRight=x.paddingRight,Oe}ye.to=Re})(Ie=e.InlayHint||(e.InlayHint={}));var le;(function(ye){function Re(ge,x){const Oe=new d.InlayHintLabelPart(x.label);return Oe.tooltip=E.isMarkdownString(x.tooltip)?_.to(x.tooltip):x.tooltip,u.Command.is(x.command)&&(Oe.command=ge.fromInternal(x.command)),x.location&&(Oe.location=be.to(x.location)),Oe}ye.to=Re})(le=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ve;(function(ye){function Re(x){return x}ye.from=Re;function ge(x){return x}ye.to=ge})(ve=e.InlayHintKind||(e.InlayHintKind={}));var Ee;(function(ye){function Re(x){return{range:l.from(x.range),url:x.target,tooltip:x.tooltip}}ye.from=Re;function ge(x){let Oe;if(x.url)try{Oe=typeof x.url=="string"?w.URI.parse(x.url,!0):w.URI.revive(x.url)}catch{}return new d.DocumentLink(l.to(x.range),Oe)}ye.to=ge})(Ee=e.DocumentLink||(e.DocumentLink={}));var We;(function(ye){function Re(x){const Oe=new d.ColorPresentation(x.label);return x.textEdit&&(Oe.textEdit=me.to(x.textEdit)),x.additionalTextEdits&&(Oe.additionalTextEdits=x.additionalTextEdits.map($e=>me.to($e))),Oe}ye.to=Re;function ge(x){return{label:x.label,textEdit:x.textEdit?me.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Oe=>me.from(Oe)):void 0}}ye.from=ge})(We=e.ColorPresentation||(e.ColorPresentation={}));var je;(function(ye){function Re(x){return new d.Color(x[0],x[1],x[2],x[3])}ye.to=Re;function ge(x){return[x.red,x.green,x.blue,x.alpha]}ye.from=ge})(je=e.Color||(e.Color={}));var it;(function(ye){function Re(x){return{range:l.from(x.range)}}ye.from=Re;function ge(x){return new d.SelectionRange(l.to(x.range))}ye.to=ge})(it=e.SelectionRange||(e.SelectionRange={}));var Ge;(function(ye){function Re(ge){switch(ge){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}ye.to=Re})(Ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(ye){function Re(x){switch(x){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Re;function ge(x){switch(x){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}ye.to=ge})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var nt;(function(ye){function Re(x){if(x===d.EndOfLine.CRLF)return 1;if(x===d.EndOfLine.LF)return 0}ye.from=Re;function ge(x){if(x===1)return d.EndOfLine.CRLF;if(x===0)return d.EndOfLine.LF}ye.to=ge})(nt=e.EndOfLine||(e.EndOfLine={}));var Ne;(function(ye){function Re(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Re})(Ne=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(ye){function Re(x){const Oe={start:x.start+1,end:x.end+1};return x.kind&&(Oe.kind=G.from(x.kind)),Oe}ye.from=Re;function ge(x){const Oe={start:x.start-1,end:x.end-1};return x.kind&&(Oe.kind=G.to(x.kind)),Oe}ye.to=ge})(rt=e.FoldingRange||(e.FoldingRange={}));var G;(function(ye){function Re(x){if(x)switch(x){case d.FoldingRangeKind.Comment:return u.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return u.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return u.FoldingRangeKind.Region}}ye.from=Re;function ge(x){if(x)switch(x.value){case u.FoldingRangeKind.Comment.value:return d.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports.value:return d.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region.value:return d.FoldingRangeKind.Region}}ye.to=ge})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(ye){function Re(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?l.from(ge.selection):void 0,override:typeof ge.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ye.from=Re})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var pe;(function(ye){function Re($e){return $e instanceof d.RelativePattern?$e.toJSON():typeof $e=="string"?$e:ge($e)||x($e)?new d.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}ye.from=Re;function ge($e){const Ze=$e;return Ze?w.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function x($e){const Ze=$e;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Oe($e){return typeof $e=="string"?$e:new d.RelativePattern(w.URI.revive($e.baseUri),$e.pattern)}ye.to=Oe})(pe=e.GlobPattern||(e.GlobPattern={}));var ze;(function(ye){function Re(ge){if(ge){if(Array.isArray(ge))return ge.map(Re);if(typeof ge=="string")return ge;{const x=ge;return{language:x.language,scheme:x.scheme,pattern:pe.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}ye.from=Re})(ze=e.LanguageSelector||(e.LanguageSelector={}));var Be;(function(ye){function Re(x){return{start:x.start,end:x.end}}ye.from=Re;function ge(x){return new d.NotebookRange(x.start,x.end)}ye.to=ge})(Be=e.NotebookRange||(e.NotebookRange={}));var Qe;(function(ye){function Re(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}ye.to=Re;function ge(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}ye.from=ge})(Qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var _e;(function(ye){function Re(ge){if(ge===b.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(ge===b.NotebookCellExecutionState.Pending)return;if(ge===b.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}ye.to=Re})(_e=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Xe;(function(ye){function Re(x){switch(x){case d.NotebookCellKind.Markup:return b.CellKind.Markup;case d.NotebookCellKind.Code:default:return b.CellKind.Code}}ye.from=Re;function ge(x){switch(x){case b.CellKind.Markup:return d.NotebookCellKind.Markup;case b.CellKind.Code:default:return d.NotebookCellKind.Code}}ye.to=ge})(Xe=e.NotebookCellKind||(e.NotebookCellKind={}));var at;(function(ye){function Re(x){const Oe={metadata:x.metadata??Object.create(null),cells:[]};for(const $e of x.cells)d.NotebookCellData.validate($e),Oe.cells.push(bt.from($e));return Oe}ye.from=Re;function ge(x){const Oe=new d.NotebookData(x.cells.map(bt.to));return(0,m.isEmptyObject)(x.metadata)||(Oe.metadata=x.metadata),Oe}ye.to=ge})(at=e.NotebookData||(e.NotebookData={}));var bt;(function(ye){function Re(x){return{cellKind:Xe.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:Qe.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(Dt.from):[]}}ye.from=Re;function ge(x){return new d.NotebookCellData(Xe.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(Dt.to):void 0,x.metadata,x.internalMetadata?Qe.to(x.internalMetadata):void 0)}ye.to=ge})(bt=e.NotebookCellData||(e.NotebookCellData={}));var kt;(function(ye){function Re(x){return{mime:x.mime,valueBytes:A.VSBuffer.wrap(x.data)}}ye.from=Re;function ge(x){return new d.NotebookCellOutputItem(x.valueBytes.buffer,x.mime)}ye.to=ge})(kt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Dt;(function(ye){function Re(x){return{outputId:x.id,items:x.items.map(kt.from),metadata:x.metadata}}ye.from=Re;function ge(x){const Oe=x.items.map(kt.to);return new d.NotebookCellOutput(Oe,x.outputId,x.metadata)}ye.to=ge})(Dt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var St;(function(ye){function Re(Oe){return x(Oe)?{include:(0,m.withNullAsUndefined)(pe.from(Oe.include)),exclude:(0,m.withNullAsUndefined)(pe.from(Oe.exclude))}:(0,m.withNullAsUndefined)(pe.from(Oe))}ye.from=Re;function ge(Oe){return x(Oe)?{include:pe.to(Oe.include),exclude:pe.to(Oe.exclude)}:pe.to(Oe)}ye.to=ge;function x(Oe){const $e=Oe;return $e?!(0,m.isUndefinedOrNull)($e.include)&&!(0,m.isUndefinedOrNull)($e.exclude):!1}})(St=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Bt;(function(ye){function Re(ge,x,Oe){const $e=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal($e,Oe),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}ye.from=Re})(Bt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ct;(function(ye){function Re(ge,x,Oe){const $e=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:x.toInternal($e,Oe),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}ye.from=Re})(ct=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var pt;(function(ye){function Re(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}ye.from=Re})(pt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ht;(function(ye){function Re(x){return{uri:x.uri,provides:x.provides}}ye.from=Re;function ge(x){return new d.NotebookRendererScript(w.URI.revive(x.uri),x.provides)}ye.to=ge})(Ht=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ft;(function(ye){function Re(x){return{message:_.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location&&{range:l.from(x.location.range),uri:x.location.uri}}}ye.from=Re;function ge(x){const Oe=new d.TestMessage(typeof x.message=="string"?x.message:_.to(x.message));return Oe.actualOutput=x.actual,Oe.expectedOutput=x.expected,Oe.location=x.location?be.to(x.location):void 0,Oe}ye.to=ge})(Ft=e.TestMessage||(e.TestMessage={}));var It;(function(ye){ye.namespace=v.namespaceTestTag,ye.denamespace=v.denamespaceTestTag})(It=e.TestTag||(e.TestTag={}));var ft;(function(ye){function Re(x){const Oe=(0,a.getPrivateApiFor)(x).controllerId;return{extId:R.TestId.fromExtHostTestItem(x,Oe).toString(),label:x.label,uri:w.URI.revive(x.uri),busy:x.busy,tags:x.tags.map($e=>It.namespace(Oe,$e.id)),range:f.Range.lift(l.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&_.fromStrict(x.error)||null}}ye.from=Re;function ge(x){return{parent:void 0,error:void 0,id:R.TestId.fromString(x.extId).localId,label:x.label,uri:w.URI.revive(x.uri),tags:(x.tags||[]).map(Oe=>{const{tagId:$e}=It.denamespace(Oe);return new d.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}ye.toPlain=ge})(ft=e.TestItem||(e.TestItem={})),function(ye){function Re(x){return{id:x.id}}ye.from=Re;function ge(x){return new d.TestTag(x.id)}ye.to=ge}(It=e.TestTag||(e.TestTag={}));var Tt;(function(ye){const Re=(x,Oe)=>{const $e=[];for(const[He,et]of Oe)R.TestId.compare(et.item.extId,He)===2&&(Oe.delete(He),$e.push(et));const Ze={...ft.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(et=>et.type===0).map(Ft.to)})),children:$e.map(He=>Re(He,Oe))};for(const He of Ze.children)He.parent=Ze;return Ze};function ge(x){const Oe=[],$e=new Map;for(const Ze of x.items){$e.set(Ze.item.extId,Ze);const He=R.TestId.root(Ze.item.extId);x.request.targets.some(et=>et.controllerId===He&&et.testIds.includes(Ze.item.extId))&&Oe.push(Ze)}return{completedAt:x.completedAt,results:Oe.map(Ze=>Re(Ze,$e))}}ye.to=ge})(Tt=e.TestResults||(e.TestResults={}));var Nt;(function(ye){function Re($e){return{covered:$e.covered,total:$e.covered}}function ge($e){return"line"in $e?I.from($e):l.from($e)}function x($e){return"branches"in $e?{count:$e.executionCount,location:ge($e.location),type:1,branches:$e.branches.length?$e.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&ge(Ze.location)})):void 0}:{type:0,count:$e.executionCount,location:ge($e.location)}}ye.fromDetailed=x;function Oe($e){return{uri:$e.uri,statement:Re($e.statementCoverage),branch:$e.branchCoverage&&Re($e.branchCoverage),function:$e.functionCoverage&&Re($e.functionCoverage),details:$e.detailedCoverage?.map(x)}}ye.fromFile=Oe})(Nt=e.TestCoverage||(e.TestCoverage={}));var Ot;(function(ye){function Re(ge){switch(ge){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}ye.to=Re})(Ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ke;(function(ye){function Re(x){const Oe=new d.TypeHierarchyItem(se.to(x.kind),x.name,x.detail||"",w.URI.revive(x.uri),l.to(x.range),l.to(x.selectionRange));return Oe._sessionId=x._sessionId,Oe._itemId=x._itemId,Oe}ye.to=Re;function ge(x,Oe,$e){if(Oe=Oe??x._sessionId,$e=$e??x._itemId,Oe===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:$e,kind:se.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:l.from(x.range),selectionRange:l.from(x.selectionRange),tags:x.tags?.map(ue.from)}}ye.from=ge})(Ke=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var qt;(function(ye){function Re(ge){if(!!ge)return{value:ge.value,tooltip:ge.tooltip}}ye.from=Re})(qt=e.ViewBadge||(e.ViewBadge={}));var Lt;(function(ye){function Re($e,Ze,He){const et=Ze.fileData;return et?new class extends d.DataTransferItem{asFile(){return{name:et.name,uri:w.URI.revive(et.uri),data:(0,N.once)(()=>He())}}}("",Ze.id):$e===M.Mimes.uriList&&Ze.uriListData?new d.DataTransferItem(Oe(Ze.uriListData)):new d.DataTransferItem(Ze.asString)}ye.to=Re;async function ge($e,Ze){const He=await Ze.asString();if($e===M.Mimes.uriList)return{id:Ze.id,asString:He,fileData:void 0,uriListData:x(He)};const et=Ze.asFile();return{id:Ze.id,asString:He,fileData:et?{name:et.name,uri:et.uri}:void 0}}ye.from=ge;function x($e){return D.UriList.split($e).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return w.URI.parse(Ze)}catch{}return Ze})}function Oe($e){return D.UriList.create($e.map(Ze=>typeof Ze=="string"?Ze:w.URI.revive(Ze)))}})(Lt=e.DataTransferItem||(e.DataTransferItem={}));var Ut;(function(ye){function Re(x,Oe){const $e=x.items.map(([Ze,He])=>[Ze,Lt.to(Ze,He,()=>Oe(He.id))]);return new d.DataTransfer($e)}ye.toDataTransfer=Re;async function ge(x){const Oe={items:[]},$e=[];return x.forEach((Ze,He)=>{$e.push((async()=>{Oe.items.push([He,await Lt.from(He,Ze)])})())}),await Promise.all($e),Oe}ye.toDataTransferDTO=ge})(Ut=e.DataTransfer||(e.DataTransfer={}))}),define(Te[196],Pe([1,0,2,11,7,8,162]),function(te,e,n,A,D,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class O{constructor(P,M,T,m={timeout:1500,errors:3}){this.c=P,this.d=M,this.f=T,this.g=m,this.a=new E.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(P){return(M,T,m)=>{const f={dispose:this.a.push([M,T,P])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(P,M){const T=n.URI.revive(P);let m=!1;const w=setTimeout(()=>m=!0,this.g.timeout),f=[];try{for(const u of[...this.a]){if(m)break;const t=this.d.getDocument(T),a=await this.h(u,{document:t,reason:N.TextDocumentSaveReason.to(M)});f.push(a)}}finally{clearTimeout(w)}return f}h([P,M,T],m){const w=this.b.get(P);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(T,P,M,m).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const u=this.b.get(P);this.b.set(P,u?u+1:1),typeof u=="number"&&u>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(P,M,T,m){const w=[],f=Date.now(),{document:u,reason:t}=m,{version:a}=u,p=Object.freeze({document:u,reason:t,waitUntil(b){if(Object.isFrozen(w))throw(0,A.illegalState)("waitUntil can not be called async");w.push(Promise.resolve(b))}});try{M.apply(T,[p])}catch(b){return Promise.reject(b)}return Object.freeze(w),new Promise((b,R)=>{const v=setTimeout(()=>R(new Error("timeout")),this.g.timeout);return Promise.all(w).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(v),b(i)}).catch(i=>{clearTimeout(v),R(i)})}).then(b=>{const R={edits:[]};for(const v of b)if(Array.isArray(v)&&v.every(i=>i instanceof D.TextEdit))for(const{newText:i,newEol:d,range:s}of v)R.edits.push({resource:u.uri,versionId:void 0,textEdit:{range:s&&N.Range.from(s),text:i,eol:d&&N.EndOfLine.from(d)}});if(R.edits.length!==0)return a===u.version?this.f.$tryApplyWorkspaceEdit(R):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=O}),define(Te[197],Pe([1,0,15,2,8,7,71]),function(te,e,n,A,D,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class O{constructor(T,m,w,f){this.start=T,this.deletedCount=m,this.deletedItems=w,this.items=f}asApiEvent(){return{range:new N.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(T=>T.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(T,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:T}}constructor(T,m,w){this.notebook=T,this.h=m,this.j=w,this.handle=w.handle,this.uri=A.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(D.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(D.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const T=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return T.notebook.getCellIndex(T)},notebook:T.notebook.apiNotebook,kind:D.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return T.g},set mime(f){T.g=f},get outputs(){return T.a.slice(0)},get metadata(){return T.b},get executionSummary(){return T.d}};this.f=Object.freeze(w)}return this.f}setOutputs(T){this.a=T.map(D.NotebookCellOutput.to)}setOutputItems(T,m,w){const f=w.map(D.NotebookCellOutputItem.to),u=this.a.find(t=>t.id===T);if(u&&(m||(u.items.length=0),u.items.push(...f),u.items.length>1&&u.items.every(t=>E.isTextStreamMime(t.mime)))){const t=new Map,a=[];u.items.forEach(p=>{let b;t.has(p.mime)?b=t.get(p.mime):(b=[],t.set(p.mime,b),a.push(p.mime)),b.push(p.data)}),u.items.length=0,a.forEach(p=>{const b=E.compressOutputItemStreams(t.get(p));u.items.push({mime:p,data:b.buffer})})}}setMetadata(T){this.b=Object.freeze(T)}setInternalMetadata(T){this.e=T,this.d=Object.freeze(D.NotebookCellExecutionSummary.to(T))}setMime(T){}}e.ExtHostCell=S;class P{constructor(T,m,w,f,u){this.k=T,this.l=m,this.m=w,this.uri=f,this.handle=P.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=u.viewType,this.f=Object.freeze(u.metadata??Object.create(null)),this.r([[0,0,u.cells]],!0,void 0),this.g=u.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const T=this,m={get uri(){return T.uri},get version(){return T.g},get notebookType(){return T.d},get isDirty(){return T.h},get isUntitled(){return T.uri.scheme===n.Schemas.untitled},get isClosed(){return T.j},get metadata(){return T.f},get cellCount(){return T.b.length},cellAt(w){return w=T.n(w),T.b[w].apiCell},getCells(w){return(w?T.p(w):T.b).map(u=>u.apiCell)},save(){return T.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(T){T.metadata&&(this.f=Object.freeze({...this.f,...T.metadata}))}acceptDirty(T){this.h=T}acceptModelChanged(T,m,w){this.g=T.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:w});const f={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},u=[];for(const a of T.rawEvents)a.kind===E.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,f.contentChanges):a.kind===E.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,f.contentChanges):a.kind===E.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),u.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===E.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),u.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===E.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),u.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===E.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===E.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===E.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),u.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===E.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),u.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const t=new Map;for(let a=0;a<u.length;a++){const p=u[a],b=t.get(p.cell);if(b===void 0){const R=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});t.set(p.cell,R-1)}else f.cellChanges[b]={...f.cellChanges[b],...p}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(T){return T=T|0,T<0?0:T>=this.b.length?this.b.length-1:T}o(T){let m=T.start|0,w=T.end|0;return m<0&&(m=0),w>this.b.length&&(w=this.b.length),T.with({start:m,end:w})}p(T){T=this.o(T);const m=[];for(let w=T.start;w<T.end;w++)m.push(this.b[w]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(T,m,w){if(this.j)return;const f=[],u=[],t=[];if(T.reverse().forEach(a=>{const b=a[2].map(i=>{const d=new S(this,this.l,i);return m||u.push(S.asModelAddData(this.apiNotebook,i)),d}),R=new O(a[0],a[1],[],b),v=this.b.splice(a[0],a[1],...b);for(const i of v)t.push(i.uri),R.deletedItems.push(i.apiCell);f.push(R)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:t}),w)for(const a of f)w.push(a.asApiEvent())}s(T,m,w,f){const u=this.b.splice(T,m);this.b.splice(w,0,...u);const t=[new O(T,m,u.map(a=>a.apiCell),[]),new O(w,0,[],u)];for(const a of t)f.push(a.asApiEvent())}t(T,m){this.b[T].setOutputs(m)}u(T,m,w,f){this.b[T].setOutputItems(m,w,f)}v(T,m){const w=this.b[T];w.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(w.uri,m)}w(T,m){const w=this.b[T];w.apiCell.mime=m}x(T,m){this.b[T].setMetadata(m)}y(T,m){this.b[T].setInternalMetadata(m)}getCellFromApiCell(T){return this.b.find(m=>m.apiCell===T)}getCellFromIndex(T){return this.b[T]}getCell(T){return this.b.find(m=>m.handle===T)}getCellIndex(T){return this.b.indexOf(T)}}P.a=0,e.ExtHostNotebookDocument=P}),define(Te[101],Pe([1,0,11,8,7]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class N{constructor(O,S,P,M,T,m){this.id=O,this.f=S,this.notebookData=P,this.a=[],this.b=[],this.d=!1,this.a=T,this.b=M,this.c=m}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection(S){this.selections=[S]},get selections(){return O.a},set selections(S){if(!Array.isArray(S)||!S.every(D.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");O.a=S,O.g(S)},get visibleRanges(){return O.b},revealRange(S,P){O.f.$tryRevealRange(O.id,A.NotebookRange.from(S),P??D.NotebookEditorRevealType.Default)},get viewColumn(){return O.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(A.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}N.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=N}),define(Te[198],Pe([1,0,4,12,8]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let N=class{constructor(O,S){this.c=O,this.d=S,this.a=new n.Emitter,this.b=new n.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,S);const P=this.d.getEditorById(O);S.visibleRanges&&P._acceptVisibleRanges(S.visibleRanges.ranges.map(D.NotebookRange.to)),S.selections&&P._acceptSelections(S.selections.selections.map(D.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const S in O)this.d.getEditorById(S)._acceptViewColumn(D.ViewColumn.to(O[S]))}};N=qe([Ve(0,A.ILogService)],N),e.ExtHostNotebookEditors=N}),define(Te[199],Pe([1,0,8,166,142,21,64,11]),function(te,e,n,A,D,N,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,w,f){const u=this.b++,{title:t,location:a,cancellable:p}=w,b={label:(0,D.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(u,{location:n.ProgressLocation.from(a),title:t,source:b,cancellable:p},m.isUnderDevelopment?void 0:m.identifier.value).catch(O.onUnexpectedExternalError),this.d(u,f,!!p)}d(m,w,f){let u;f&&(u=new N.CancellationTokenSource,this.c.set(m,u));const t=p=>{this.a.$progressEnd(p),this.c.delete(p),u?.dispose()};let a;try{a=w(new M(this.a,m),f&&u?u.token:N.CancellationToken.None)}catch(p){throw t(m),p}return a.then(p=>t(m),p=>t(m)),a}$acceptProgressCanceled(m){const w=this.c.get(m);w&&(w.cancel(),this.c.delete(m))}}e.ExtHostProgress=S;function P(T,m){return T.message=m.message,typeof m.increment=="number"&&(typeof T.increment=="number"?T.increment+=m.increment:T.increment=m.increment),T}class M extends A.Progress{constructor(m,w){super(f=>this.throttledReport(f)),this.c=m,this.d=w}throttledReport(m){this.c.$progressReport(this.d,m)}}qe([(0,E.throttle)(100,(T,m)=>P(T,m),()=>Object.create(null))],M.prototype,"throttledReport",null)}),define(Te[102],Pe([1,0,44,97,45,72,56,8,2]),function(te,e,n,A,D,N,E,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(b,R,v,i)=>{let d=R;return{enumerable:!0,configurable:!1,get(){return d},set(s){if(!v(d,s)){const l=d;d=s,b.listener?.(i(s,l))}}}},M=(b,R)=>b===R,T={range:(b,R)=>b===R?!0:!b||!R?!1:b.isEqual(R),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(b,R)=>!(b.length!==R.length||b.some(v=>!R.find(i=>v.id===i.id)))},m=b=>R=>({op:4,update:b(R)}),w=(b,R)=>({range:(()=>{let v;const i=m(d=>({range:n.Range.lift(O.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return v},set(d){b.listener?.({op:6}),T.range(v,d)||(v=d,b.listener?.(i(d)))}}})(),label:P(b,R,T.label,m(v=>({label:v}))),description:P(b,void 0,T.description,m(v=>({description:v}))),sortText:P(b,void 0,T.sortText,m(v=>({sortText:v}))),canResolveChildren:P(b,!1,T.canResolveChildren,v=>({op:2,state:v})),busy:P(b,!1,T.busy,m(v=>({busy:v}))),error:P(b,void 0,T.error,m(v=>({error:O.MarkdownString.fromStrict(v)||null}))),tags:P(b,[],T.tags,(v,i)=>({op:1,new:v.map(O.TestTag.from),old:i.map(O.TestTag.from)}))}),f=b=>{const R=D.TestId.fromString(b.extId),v=new t(R.controllerId,R.localId,b.label,S.URI.revive(b.uri)||void 0);return v.range=O.Range.to(b.range||void 0),v.description=b.description||void 0,v.sortText=b.sortText||void 0,v.tags=b.tags.map(i=>O.TestTag.to({id:(0,E.denamespaceTestTag)(i).tagId})),v},u=b=>{let R;for(const v of b.tests){const i=f(v.item);(0,A.getPrivateApiFor)(i).parent=R,R=i}return R};e.toItemFromContext=u;class t{constructor(R,v,i,d){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const s=(0,A.createPrivateApiFor)(this,R);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof a?void 0:s.parent}},children:{value:(0,N.createTestItemChildren)(s,A.getPrivateApiFor,t),enumerable:!0,writable:!1},...w(s,i)})}}e.TestItemImpl=t;class a extends t{constructor(R,v){super(R,R,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=a;class p extends N.TestItemCollection{constructor(R,v,i){super({controllerId:R,getDocumentVersion:d=>d&&i.getDocument(d)?.version,getApiFor:A.getPrivateApiFor,getChildren:d=>d.children,root:new a(R,v),toITestItem:O.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(Te[103],Pe([1,0,49,11,83,8,7]),function(te,e,n,A,D,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class O{constructor(m,w,f){const u=O.c.nextId();m.$registerTextEditorDecorationType(w.identifier,u,N.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:u,dispose(){m.$removeTextEditorDecorationType(u)}})}}O.c=new D.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=O;class S{constructor(m,w){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,w){this.k();let f=null;if(m instanceof E.Position)f=new E.Range(m,m);else if(m instanceof E.Range)f=m;else throw new Error("Unrecognized location");this.l(f,w,!1)}insert(m,w){this.k(),this.l(new E.Range(m,m),w,!0)}delete(m){this.k();let w=null;if(m instanceof E.Range)w=m;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(m,w,f){const u=this.c.validateRange(m);this.g.push({range:u,text:w,forceMoveMarkers:f})}setEndOfLine(m){if(this.k(),m!==E.EndOfLine.LF&&m!==E.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this.h=m}}class P{constructor(m,w,f,u){this.c=m,this.d=w,this._accept(f),this.e=u;const t=this;this.value={get tabSize(){return t.f},set tabSize(a){t.m(a)},get indentSize(){return t.g},set indentSize(a){t.o(a)},get insertSpaces(){return t.h},set insertSpaces(a){t.q(a)},get cursorStyle(){return t.j},set cursorStyle(a){t.s(a)},get lineNumbers(){return t.k},set lineNumbers(a){t.t(a)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=N.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const w=Math.floor(m);return w>0?w:null}if(typeof m=="string"){const w=parseInt(m,10);return isNaN(w)?null:w>0?w:null}return null}m(m){const w=this.l(m);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const w=Math.floor(m);return w>0?w:null}if(typeof m=="string"){const w=parseInt(m,10);return isNaN(w)?null:w>0?w:null}return null}o(m){const w=this.n(m);if(w!==null){if(typeof w=="number"){if(this.g===w)return;this.g=w}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}p(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}q(m){const w=this.p(m);if(typeof w=="boolean"){if(this.h===w)return;this.h=w}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(m)})))}assign(m){const w={};let f=!1;if(typeof m.tabSize<"u"){const u=this.l(m.tabSize);u==="auto"?(f=!0,w.tabSize=u):typeof u=="number"&&this.f!==u&&(this.f=u,f=!0,w.tabSize=u)}if(typeof m.indentSize<"u"){const u=this.n(m.indentSize);u==="tabSize"?(f=!0,w.indentSize=u):typeof u=="number"&&this.g!==u&&(this.g=u,f=!0,w.indentSize=u)}if(typeof m.insertSpaces<"u"){const u=this.p(m.insertSpaces);u==="auto"?(f=!0,w.insertSpaces=u):this.h!==u&&(this.h=u,f=!0,w.insertSpaces=u)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,f=!0,w.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,f=!0,w.lineNumbers=N.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this.u("setOptions",this.c.$trySetOptions(this.d,w))}u(m,w){w.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(f)})}}e.ExtHostTextEditorOptions=P;class M{constructor(m,w,f,u,t,a,p,b){this.id=m,this.j=w,this.k=f,this.g=!1,this.h=new Set,this.c=t,this.d=new P(this.j,this.id,a,f),this.e=p,this.f=b;const R=this;this.value=Object.freeze({get document(){return u.value},set document(v){throw(0,A.readonly)("document")},get selection(){return R.c&&R.c[0]},set selection(v){if(!(v instanceof E.Selection))throw(0,A.illegalArgument)("selection");R.c=[v],R.l()},get selections(){return R.c},set selections(v){if(!Array.isArray(v)||v.some(i=>!(i instanceof E.Selection)))throw(0,A.illegalArgument)("selections");R.c=v,R.l()},get visibleRanges(){return R.e},set visibleRanges(v){throw(0,A.readonly)("visibleRanges")},get options(){return R.d.value},set options(v){R.g||R.d.assign(v)},get viewColumn(){return R.f},set viewColumn(v){throw(0,A.readonly)("viewColumn")},edit(v,i={undoStopBefore:!0,undoStopAfter:!0}){if(R.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new S(u.value,i);return v(d),R.m(d)},insertSnippet(v,i,d={undoStopBefore:!0,undoStopAfter:!0}){if(R.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!i||Array.isArray(i)&&i.length===0)s=R.c.map(l=>N.Range.from(l));else if(i instanceof E.Position){const{lineNumber:l,column:o}=N.Position.from(i);s=[{startLineNumber:l,startColumn:o,endLineNumber:l,endColumn:o}]}else if(i instanceof E.Range)s=[N.Range.from(i)];else{s=[];for(const l of i)if(l instanceof E.Range)s.push(N.Range.from(l));else{const{lineNumber:o,column:I}=N.Position.from(l);s.push({startLineNumber:o,startColumn:I,endLineNumber:o,endColumn:I})}}return w.$tryInsertSnippet(m,u.value.version,v.value,s,d)},setDecorations(v,i){const d=i.length===0;d&&!R.h.has(v.key)||(d?R.h.delete(v.key):R.h.add(v.key),R.n(()=>{if(N.isDecorationOptionsArr(i))return w.$trySetDecorations(m,v.key,N.fromRangeOrRangeWithMessage(i));{const s=new Array(4*i.length);for(let l=0,o=i.length;l<o;l++){const I=i[l];s[4*l]=I.start.line+1,s[4*l+1]=I.start.character+1,s[4*l+2]=I.end.line+1,s[4*l+3]=I.end.character+1}return w.$trySetDecorationsFast(m,v.key,s)}}))},revealRange(v,i){R.n(()=>w.$tryRevealRange(m,N.Range.from(v),i||E.TextEditorRevealType.Default))},show(v){w.$tryShowEditor(m,N.ViewColumn.from(v))},hide(){w.$tryHideEditor(m)}})}dispose(){(0,n.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,n.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,n.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,n.ok)(!this.g),this.f=m}_acceptSelections(m){(0,n.ok)(!this.g),this.c=m}async l(){const m=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const w=m.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const f=w.edits.map(t=>t.range);f.sort((t,a)=>t.end.line===a.end.line?t.end.character===a.end.character?t.start.line===a.start.line?t.start.character-a.start.character:t.start.line-a.start.line:t.end.character-a.end.character:t.end.line-a.end.line);for(let t=0,a=f.length-1;t<a;t++){const p=f[t].end;if(f[t+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=w.edits.map(t=>({range:N.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,u,{setEndOfLine:typeof w.setEndOfLine=="number"?N.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.ExtHostTextEditor=M}),define(Te[200],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Te[201],Pe([1,0,155,11,29,90,69,30,24,200,165,95]),function(te,e,n,A,D,N,E,O,S,P,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const m=O.Registry.as(E.Extensions.JSONContribution);class w{constructor(v,i,d){this.a=v,this.b=i,this.c=d}d(v,i){this.a({type:v,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(D.default.Error,v)}warn(v){this.d(D.default.Warning,v)}info(v){this.d(D.default.Info,v)}}e.ExtensionMessageCollector=w;class f{static a(v){const i=new S.ExtensionIdentifierSet;for(let d=0,s=v.length;d<s;d++)i.add(v[d].description.identifier);return i}static compute(v,i){if(!v||!v.length)return new f(i,[]);if(!i||!i.length)return new f([],v);const d=this.a(v),s=this.a(i),l=i.filter(I=>!d.has(I.description.identifier)),o=v.filter(I=>!s.has(I.description.identifier));return new f(l,o)}constructor(v,i){this.added=v,this.removed=i}}e.ExtensionPointUserDelta=f;class u{constructor(v,i){this.name=v,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=f.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,A.onUnexpectedError)(v)}}}e.ExtensionPoint=u;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class p{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const i=new u(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,i),v.activationEventsGenerator&&T.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,m.registerSchema(a,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=p;const b={ExtensionsRegistry:"ExtensionsRegistry"};O.Registry.add(b.ExtensionsRegistry,new p),e.ExtensionsRegistry=O.Registry.as(b.ExtensionsRegistry),m.registerSchema(a,e.schema),m.registerSchema(M.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}}]}}}})}),define(Te[202],Pe([1,0,152,9,23,201,36,4]),function(te,e,n,A,D,N,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var P;(function(m){function w(f,u,t){if(!f)return;const a=A.isString(f.type)?f.type:void 0;if(!a||a.length===0){t.error(n.localize(3,null));return}const p=[];if(Array.isArray(f.required))for(const b of f.required)A.isString(b)&&p.push(b);return{extensionId:u.value,taskType:a,required:p,properties:f.properties?D.deepClone(f.properties):{},when:f.when?E.ContextKeyExpr.deserialize(f.when):void 0}}m.from=w})(P||(P={}));const M=N.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,w)=>{for(const f of m)f.type&&w.push(`onTaskType:${f.type}`)},jsonSchema:{description:n.localize(4,null),type:"array",items:S}});class T{constructor(){this.d=new O.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,f)=>{M.setHandler((u,t)=>{this.c=void 0;try{for(const a of t.removed){const p=a.value;for(const b of p)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const a of t.added){const p=a.value;for(const b of p){const R=P.from(b,a.description.identifier,a.collector);R&&(this.a[R.taskType]=R)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const f of this.all()){const u={type:"object",additionalProperties:!1};f.required.length>0&&(u.required=f.required.slice(0)),f.properties!==void 0?u.properties=D.deepClone(f.properties):u.properties=Object.create(null),u.properties.type={type:"string",enum:[f.taskType]},w.push(u)}this.c={oneOf:w}}return this.c}}e.TaskDefinitionRegistry=new T}),define(Te[203],Pe([1,0,153,9,22,23,36,202]),function(te,e,n,A,D,N,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new E.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var S;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(L){function g(F){if(!F)return L.Strong;switch(F.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=g}(S=e.ShellQuoting||(e.ShellQuoting={}));var P;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(P=e.CommandOptions||(e.CommandOptions={}));var M;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(M=e.RevealKind||(e.RevealKind={})),function(L){function g(F){switch(F.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=g}(M=e.RevealKind||(e.RevealKind={}));var T;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(T=e.RevealProblemKind||(e.RevealProblemKind={})),function(L){function g(F){switch(F.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=g}(T=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(L){function g(F){switch(F.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=g}(m=e.PanelKind||(e.PanelKind={}));var w;(function(L){L.defaults={echo:!0,reveal:M.Always,revealProblems:T.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(w=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(L){function g(B){switch(B.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=g;function F(B){switch(B){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=F}(f=e.RuntimeType||(e.RuntimeType={}));var u;(function(L){function g(F){return A.isString(F)?F:F.value}L.value=g})(u=e.CommandString||(e.CommandString={}));var t;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function g(B){return B===L.Clean._id||B===L.Build._id||B===L.Rebuild._id||B===L.Test._id}L.is=g;function F(B){if(B!==void 0)return A.isString(B)?g(B)?{_id:B,isDefault:!1}:void 0:B}L.from=F})(t=e.TaskGroup||(e.TaskGroup={}));var a;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(a=e.TaskScope||(e.TaskScope={}));var p;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function g(F){switch(F){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=g})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(L){L.parallel="parallel",L.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var R;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(R=e.RunOnOptions||(e.RunOnOptions={}));var v;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:R.default,instanceLimit:1}})(v=e.RunOptions||(e.RunOptions={}));class i{constructor(g,F,B,Y,me,Z){this._label="",this._id=g,F&&(this._label=F),B&&(this.type=B),this.runOptions=Y,this.configurationProperties=me,this._source=Z}getDefinition(g){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const g={folder:this.d(),id:this._id};return JSON.stringify(g)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(g,F=!1){if(g===void 0)return!1;if(A.isString(g))return g===this._label||g===this.configurationProperties.identifier||F&&g===this._id;const B=this.getDefinition(!0);return B!==void 0&&B._key===g._key}getQualifiedLabel(){const g=this.getWorkspaceFolder();return g?`${this._label} (${g.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(g){this.c===void 0&&(this.c=[]),g&&(this.c=this.c.concat(g))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class d extends i{constructor(g,F,B,Y,me,Z,se,ue){super(g,B,void 0,se,ue,F),this.command={},this._source=F,this.hasDefinedMatchers=Z,me&&(this.command=me)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(g=!1){if(g&&this._source.customizes!==void 0)return this._source.customizes;{let F;switch(this.command?this.command.runtime:void 0){case f.Shell:F="shell";break;case f.Process:F="process";break;case f.CustomExecution:F="customExecution";break;case void 0:F="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:F,_key:this._id,id:this._id}}}static is(g){return g instanceof d}getMapKey(){const g=this._source.config.workspaceFolder;return g?`${g.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const g=this.d();if(!g)return;let F=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(F+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:g,id:F};return JSON.stringify(B)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(g){return new d(g._id,g._source,g._label,g.type,g.command,g.hasDefinedMatchers,g.runOptions,g.configurationProperties)}}e.CustomTask=d;class s extends i{constructor(g,F,B,Y,me,Z,se){super(g,B,Y,Z,se,F),this._source=F,this.configures=me}static is(g){return g instanceof s}f(g){return g}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const g=this.d();if(!g)return;let F=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(F+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:g,id:F};return JSON.stringify(B)}}e.ConfiguringTask=s;class l extends i{constructor(g,F,B,Y,me,Z,se,ue,De){super(g,B,Y,ue,De,F),this.defines=me,this.hasDefinedMatchers=se,this.command=Z,this.icon=De.icon,this.hide=De.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(g){return g instanceof l}getMapKey(){const g=this._source.workspaceFolder;return g?`${this._source.scope.toString()}|${g.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const g={type:"contributed",scope:this._source.scope,id:this._id};return g.folder=this.d(),JSON.stringify(g)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(g){return new l(g._id,g._source,g._label,g.type,g.defines,g.command,g.hasDefinedMatchers,g.runOptions,g.configurationProperties)}}e.ContributedTask=l;class o extends i{constructor(g,F,B,Y,me,Z){super(g,B,Y,me,Z,F),this._source=F}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(g){return g instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(g){return new o(g._id,g._source,g._label,g.type,g.runOptions,g.configurationProperties)}}e.InMemoryTask=o;var I;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(I=e.ExecutionEngine||(e.ExecutionEngine={})),function(L){L._default=L.Terminal}(I=e.ExecutionEngine||(e.ExecutionEngine={}));var r;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(r=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class c{constructor(g){this.c=new Map;for(let F=0;F<g.length;F++)this.c.set(g[F].uri.toString(),F)}compare(g,F){const B=g.getWorkspaceFolder(),Y=F.getWorkspaceFolder();if(B&&Y){let me=this.c.get(B.uri.toString());me=me===void 0?0:me+1;let Z=this.c.get(Y.uri.toString());return Z=Z===void 0?0:Z+1,me===Z?g._label.localeCompare(F._label):me-Z}else return!B&&Y?-1:B&&!Y?1:0}}e.TaskSorter=c;var h;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var y;(function(L){L.SingleRun="singleRun",L.Background="background"})(y=e.TaskRunType||(e.TaskRunType={}));var C;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(C=e.TaskRunSource||(e.TaskRunSource={}));var H;(function(L){function g(F,B,Y,me){if(B){const Z={kind:F,taskId:B._id,taskName:B.configurationProperties.name,runType:B.configurationProperties.isBackground?"background":"singleRun",group:B.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:Y,__task:B};return F==="start"?Z.resolvedVariables=me:F==="processStarted"?Z.processId=me:F==="processEnded"&&(Z.exitCode=me),Object.freeze(Z)}else return Object.freeze({kind:"changed"})}L.create=g})(H=e.TaskEvent||(e.TaskEvent={}));var K;(function(L){function g(B){const Y=Object.keys(B).sort();let me="";for(const Z of Y){let se=B[Z];se instanceof Object?se=g(se):typeof se=="string"&&(se=se.replace(/,/g,",,")),me+=Z+","+se+","}return me}function F(B){const me={_key:g(B),type:B.taskType};return Object.assign(me,B),me}L.create=F})(K=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var Q;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection"})(Q=e.TaskSettingId||(e.TaskSettingId={}));var _;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(_=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var j;(function(L){function g(F,B){const Y=O.TaskDefinitionRegistry.get(F.type);if(Y===void 0){const ue=N.deepClone(F);return delete ue._key,K.create(ue)}const me=Object.create(null);me.type=Y.taskType;const Z=new Set;Y.required.forEach(ue=>Z.add(ue));const se=Y.properties;for(const ue of Object.keys(se)){const De=F[ue];if(De!=null)me[ue]=De;else if(Z.has(ue)){const de=se[ue];if(de.default!==void 0)me[ue]=N.deepClone(de.default);else switch(de.type){case"boolean":me[ue]=!1;break;case"number":case"integer":me[ue]=0;break;case"string":me[ue]="";break;default:B.error(n.localize(2,null,JSON.stringify(F,void 0,0),ue));return}}}return K.create(me)}L.createTaskIdentifier=g})(j=e.TaskDefinition||(e.TaskDefinition={}))}),define(Te[204],Pe([1,0,11]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((E,O)=>{this.b=E,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(E){this.f||this.h||(this.f=!0,this.g=E,this.a&&this.b(E))}resolveErr(E){this.f||this.h||(this.h=!0,this.i=E,this.a?this.d(E):(0,n.onUnexpectedError)(E))}then(E,O){return this.j().then(E,O)}catch(E){return this.j().then(void 0,E)}finally(E){return this.j().finally(E)}}e.LazyPromise=A;class D extends A{constructor(){super(),this.h=!0,this.i=new n.CancellationError}}e.CanceledLazyPromise=D}),define(Te[46],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++n.count}}n.count=0,e.ProxyIdentifier=n;const A=[];function D(O){const S=new n(O);return A[S.nid]=S,S}e.createProxyIdentifier=D;function N(O){return A[O].sid}e.getStringIdentifierForProxy=N;class E{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=E}),define(Te[5],Pe([1,0,46]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(u){u[u.UnknownInput=0]="UnknownInput",u[u.TextInput=1]="TextInput",u[u.TextDiffInput=2]="TextDiffInput",u[u.TextMergeInput=3]="TextMergeInput",u[u.NotebookInput=4]="NotebookInput",u[u.NotebookDiffInput=5]="NotebookDiffInput",u[u.CustomEditorInput=6]="CustomEditorInput",u[u.WebviewEditorInput=7]="WebviewEditorInput",u[u.TerminalEditorInput=8]="TerminalEditorInput",u[u.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var N;(function(u){u[u.TAB_OPEN=0]="TAB_OPEN",u[u.TAB_CLOSE=1]="TAB_CLOSE",u[u.TAB_UPDATE=2]="TAB_UPDATE",u[u.TAB_MOVE=3]="TAB_MOVE"})(N=e.TabModelOperationKind||(e.TabModelOperationKind={}));var E;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(E=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var O;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(O=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var M;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(M=e.CandidatePortSource||(e.CandidatePortSource={}));class T{static mixin(t){return t._id=T.a++,t}}T.a=0,e.IdObject=T;var m;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.kindModifier="m",u.commandIdent="n",u.commandId="o",u.commandArguments="p"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,n.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(Te[76],Pe([1,0,3,12,5,18]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let E=class{constructor(S,P){this.c=P,this.a=new Set,this.b=S.getProxy(D.MainContext.MainThreadTelemetry)}report(S,P,M){const T=this.d(S,P);this.a.has(T)||(this.a.add(T),P.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:S}))}d(S,P){return`${S}-${P.identifier.value}`}};E=qe([Ve(0,N.IExtHostRpcService),Ve(1,A.ILogService)],E),e.ExtHostApiDeprecationService=E,e.NullApiDeprecationService=Object.freeze(new class{report(O,S,P){}})}),define(Te[205],Pe([1,0,4,5,7,24]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class E{constructor(S){this.b=new Map,this.c=[],this.d=new n.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,P,M,T={}){const m=N.ExtensionIdentifier.toKey(S.identifier),w=this.f.get(m)||[],f=[...M].sort().join(" ");let u=w.find(t=>t.providerId===P&&t.scopes===f);if(u)return u.result;{const t=this.g(S,m,P,M,T);u={providerId:P,scopes:f,result:t},w.push(u),this.f.set(m,w);try{await t}finally{const a=w.findIndex(p=>p.providerId===P&&p.scopes===f);a>-1&&(w.splice(a),this.f.set(m,w))}return t}}async g(S,P,M,T,m={}){await this.a.$ensureProvider(M);const w=S.displayName||S.name;return this.a.$getSession(M,T,P,w,m)}async removeSession(S,P){const M=this.b.get(S);return M?M.provider.removeSession(P):this.a.$removeSession(S,P)}registerAuthenticationProvider(S,P,M,T){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:P,provider:M,options:T??{supportsMultipleAccounts:!1}}),this.c.find(w=>w.id===S)||this.c.push({id:S,label:P});const m=M.onDidChangeSessions(w=>{this.a.$sendDidChangeSessions(S,{added:w.added??[],changed:w.changed??[],removed:w.removed??[]})});return this.a.$registerAuthenticationProvider(S,P,T?.supportsMultipleAccounts??!1),new D.Disposable(()=>{m.dispose(),this.b.delete(S);const w=this.c.findIndex(f=>f.id===S);w>-1&&this.c.splice(w),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,P){const M=this.b.get(S);if(M)return Promise.resolve(M.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,P){const M=this.b.get(S);if(M)return Promise.resolve(M.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,P){const M=this.b.get(S);if(M)return Promise.resolve(M.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,P){return this.d.fire({provider:{id:S,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=E}),define(Te[206],Pe([1,0,5,18,8]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let N=class{constructor(O,S){this.a=O.getProxy(n.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:P=>S.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(O,S,P){const M=D.WorkspaceEdit.from(O,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,P?.isRefactoring??!1)}};N=qe([Ve(0,A.IExtHostRpcService)],N),e.ExtHostBulkEdits=N}),define(Te[207],Pe([1,0,5]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(N){const E=N.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return E.$readText()},writeText(O){return E.$writeText(O)}})}}e.ExtHostClipboard=A});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,A,D){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Fe=this&&this.__classPrivateFieldGet||function(te,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!A:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(te):A?A.value:e.get(te)};define(Te[38],Pe([1,0,9,7,8,23,5,16,12,66,44,260,2,6,3,18,102,25,46,40,77,52,57]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t,a,p,b,R,v,i){"use strict";var d,s,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(C,H,K){d.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),l.set(this,void 0),Je(this,d,C.getProxy(E.MainContext.MainThreadCommands),"f"),this.d=H,Je(this,l,K,"f"),Je(this,s,C.getProxy(E.MainContext.MainThreadTelemetry),"f"),this.converter=new I(this,Q=>{const _=this.c.get(Q);return _?.result===c.Void?_:void 0},H),this.f=[{processArgument(Q){return(0,P.revive)(Q)}},{processArgument(Q){return(0,N.cloneAndChange)(Q,function(_){if(M.Range.isIRange(_))return D.Range.to(_);if(T.Position.isIPosition(_))return D.Position.to(_);if(M.Range.isIRange(_.range)&&m.URI.isUri(_.uri))return D.location.to(_);if(_ instanceof a.VSBuffer)return _.buffer.buffer;if(!Array.isArray(_))return _})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const H=this.registerCommand(!1,C.id,async(...K)=>{const Q=C.args.map((j,L)=>{if(!j.validate(K[L]))throw new Error(`Invalid argument '${j.name}' when running '${C.id}', received: ${K[L]}`);return j.convert(K[L])}),_=await this.executeCommand(C.internalId,...Q);return C.result.convert(_,K,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new A.Disposable(()=>{H.dispose(),this.c.delete(C.id)})}registerCommand(C,H,K,Q,_,j){if(this.d.trace("ExtHostCommands#registerCommand",H),!H.trim().length)throw new Error("invalid id");if(this.b.has(H))throw new Error(`command '${H}' already exists`);return this.b.set(H,{callback:K,thisArg:Q,description:_,extension:j}),C&&Fe(this,d,"f").$registerCommand(H),new A.Disposable(()=>{this.b.delete(H)&&C&&Fe(this,d,"f").$unregisterCommand(H)})}executeCommand(C,...H){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,H,!0)}async g(C,H,K){if(this.b.has(C))return Fe(this,d,"f").$fireCommandActivationEvent(C),this.h(C,H,!1);{let Q=!1;const _=(0,N.cloneAndChange)(H,function(j){if(j instanceof A.Position)return D.Position.from(j);if(j instanceof A.Range)return D.Range.from(j);if(j instanceof A.Location)return D.location.from(j);if(A.NotebookRange.isNotebookRange(j))return D.NotebookRange.from(j);if(j instanceof ArrayBuffer)return Q=!0,a.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return Q=!0,a.VSBuffer.wrap(j);if(j instanceof a.VSBuffer)return Q=!0,j;if(!Array.isArray(j))return j});try{const j=await Fe(this,d,"f").$executeCommand(C,Q?new p.SerializableObjectWithBuffers(_):_,K);return(0,P.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this.g(C,H,!1);throw j}}}async h(C,H,K){const Q=this.b.get(C);if(!Q)throw new Error("Unknown command");const{callback:_,thisArg:j,description:L}=Q;if(L)for(let F=0;F<L.args.length;F++)try{(0,n.validateConstraint)(H[F],L.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${L.args[F].name}' - ${L.args[F].description}`)}const g=R.StopWatch.create();try{return await _.apply(j,H)}catch(F){if(C===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...H);B&&(C=B.command)}if(this.d.error(F,C,Q.extension?.identifier),!K)throw F;if(Q.extension?.identifier){const B=Fe(this,l,"f").onExtensionError(Q.extension.identifier,F);this.d.trace("forwarded error to extension?",B,Q.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.toErrorMessage)(F)),this.id=C,this.source=Q.extension?.displayName??Q.extension?.name}}}finally{this.j(Q,C,g.elapsed())}}j(C,H,K){!C.extension||Fe(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new v.TelemetryTrustedValue(H),duration:K})}$executeContributedCommand(C,...H){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const K=this.b.get(C);return K?(H=H.map(Q=>this.f.reduce((_,j)=>j.processArgument(_,K.extension?.identifier),Q)),this.h(C,H,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),Fe(this,d,"f").$getCommands().then(H=>(C&&(H=H.filter(K=>K[0]!=="_")),H))}$getContributedCommandHandlerDescriptions(){const C=Object.create(null);for(const[H,K]of this.b){const{description:Q}=K;Q&&(C[H]=Q)}return Promise.resolve(C)}};d=new WeakMap,s=new WeakMap,l=new WeakMap,o=qe([Ve(0,u.IExtHostRpcService),Ve(1,S.ILogService),Ve(2,i.IExtHostTelemetry)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class I{constructor(C,H,K){this.d=C,this.f=H,this.g=K,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,H){if(!C)return;const K={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return K;const Q=this.f(C.command);if(Q)K.id=Q.internalId,K.arguments=Q.args.map((_,j)=>_.convert(C.arguments&&C.arguments[j]));else if((0,O.isNonEmptyArray)(C.arguments)){const _=`${C.command}/${++this.c}`;this.b.set(_,C),H.add((0,w.toDisposable)(()=>{this.b.delete(_),this.g.trace("CommandsConverter#DISPOSE",_)})),K.$ident=_,K.id=this.delegatingCommandId,K.arguments=[_],this.g.trace("CommandsConverter#CREATE",C.command,_)}return K}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const H=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],H?H.command:"MISSING"),H?this.d.executeCommand(H.command,...H.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.CommandsConverter=I;class r{constructor(C,H,K,Q){this.name=C,this.description=H,this.validate=K,this.convert=Q}optional(){return new r(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,H){return new r(C??this.name,H??this.description,this.validate,this.convert)}}r.Uri=new r("uri","Uri of a text document",y=>m.URI.isUri(y),y=>y),r.Position=new r("position","A position in a text document",y=>A.Position.isPosition(y),D.Position.from),r.Range=new r("range","A range in a text document",y=>A.Range.isRange(y),D.Range.from),r.Selection=new r("selection","A selection in a text document",y=>A.Selection.isSelection(y),D.Selection.from),r.Number=new r("number","",y=>typeof y=="number",y=>y),r.String=new r("string","",y=>typeof y=="string",y=>y),r.CallHierarchyItem=new r("item","A call hierarchy item",y=>y instanceof A.CallHierarchyItem,D.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",y=>y instanceof A.TypeHierarchyItem,D.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",y=>y instanceof t.TestItemImpl,D.TestItem.from),e.ApiCommandArgument=r;class c{constructor(C,H){this.description=C,this.convert=H}}c.Void=new c("no result",y=>y),e.ApiCommandResult=c;class h{constructor(C,H,K,Q,_){this.id=C,this.internalId=H,this.description=K,this.args=Q,this.result=_}}e.ApiCommand=h}),define(Te[208],Pe([1,0,2,8,7,75,38,16,88,92,15]),function(te,e,n,A,D,N,E,O,S,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",w(A.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,t)=>{if((0,O.isFalsyOrEmpty)(u))return;class a extends D.SymbolInformation{static to(b){const R=new a(b.name,A.SymbolKind.to(b.kind),b.containerName||"",new D.Location(t[0],A.Range.to(b.range)));return R.detail=b.detail,R.range=R.location.range,R.selectionRange=A.Range.to(b.selectionRange),R.children=b.children?b.children.map(a.to):[],R}}return u.map(a.to)})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(A.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(A.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",u=>typeof u=="string",u=>u),new E.ApiCommandArgument("options","Formatting options",u=>!0,u=>u)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",w(A.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",w(A.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",w(A.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",u=>Array.isArray(u)&&u.every(t=>D.Position.isPosition(t)),u=>u.map(A.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",u=>u.map(t=>{let a;for(const p of t.reverse())a=new D.SelectionRange(A.Range.to(p),a);return a}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(A.WorkspaceSymbol.to))),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(A.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(A.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(A.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to a range and placeholder text.",u=>{if(!!u)return{range:A.Range.to(u.range),placeholder:u.text}})),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",u=>{if(!!u){if(u.rejectReason)throw new Error(u.rejectReason);return A.WorkspaceEdit.to(u)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(A.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new D.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const t=(0,S.decodeSemanticTokensDto)(u);if(t.type==="full")return new D.SemanticTokens(t.data,void 0)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range.optional()],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",u=>{if(!!u)return new D.SemanticTokensLegend(u.tokenTypes,u.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const t=(0,S.decodeSemanticTokensDto)(u);if(t.type==="full")return new D.SemanticTokens(t.data,void 0)})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(u,t,a)=>{if(!u)return new D.CompletionList([]);const p=u.suggestions.map(b=>A.CompletionItem.to(b,a));return new D.CompletionList(p,u.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",u=>{if(u)return A.SignatureHelp.to(u)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(u,t,a)=>w(p=>new D.CodeLens(A.Range.to(p.range),p.command&&a.fromInternal(p.command)))(u))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>D.Range.isRange(u),u=>D.Selection.isSelection(u)?A.Selection.from(u):A.Range.from(u)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(u,t,a)=>w(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(p.command)}else{const b=new D.CodeAction(p.title,p.kind?new D.CodeActionKind(p.kind):void 0);return p.edit&&(b.edit=A.WorkspaceEdit.to(p.edit)),p.command&&(b.command=a.fromInternal(p.command)),b.isPreferred=p.isPreferred,b}})(u))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(t=>new D.ColorInformation(A.Range.to(t.range),A.Color.to(t.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",u=>u instanceof D.Color,A.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:A.Range.from(u.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(A.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",(u,t,a)=>u.map(A.InlayHint.to.bind(void 0,a)))),new E.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(u,t)=>{if(u)return u.map(A.FoldingRange.to)})),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",w(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(t=>A.NotebookExclusiveDocumentPattern.to(t))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",u=>u.map(A.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new E.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",u=>n.URI.isUri(u)||typeof u=="string"&&(0,P.matchesSomeScheme)(u,M.Schemas.http,M.Schemas.https),u=>u),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[A.ViewColumn.from(u),void 0]:[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[A.ViewColumn.from(u),void 0]:[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)]).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new E.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[E.ApiCommandArgument.TypeHierarchyItem],new E.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new E.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[E.ApiCommandArgument.TestItem],E.ApiCommandResult.Void),new E.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[E.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],E.ApiCommandResult.Void),new E.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[E.ApiCommandArgument.String.with("name","The context key name"),new E.ApiCommandArgument("value","The context key value",()=>!0,u=>u)],E.ApiCommandResult.Void)];class m{static register(t){T.forEach(t.registerApiCommand,t)}}e.ExtHostApiCommands=m;function w(u){return t=>{if(Array.isArray(t))return t.map(u)}}function f(u){if(!Array.isArray(u))return;const t=[];for(const a of u)N.isLocationLink(a)?t.push(A.DefinitionLink.to(a)):t.push(A.location.to(a));return t}}),define(Te[209],Pe([1,0,17,64,4,6,2,75,24,8,7,5]),function(te,e,n,A,D,N,E,O,S,P,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function m(w,f,u){const t=w.getProxy(T.MainContext.MainThreadComments);class a{constructor(){this.b=new Map,this.c=new S.ExtensionIdentifierMap,f.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===6){const I=this.b.get(o.handle);return I?I.value:o}else if(o&&o.$mid===7){const I=this.b.get(o.commentControlHandle);if(!I)return o;const r=I.getCommentThread(o.commentThreadHandle);return r?r.value:o}else if(o&&(o.$mid===9||o.$mid===8)){const I=this.b.get(o.thread.commentControlHandle);if(!I)return o;const r=I.getCommentThread(o.thread.commentThreadHandle);return r?o.$mid===8?r.value:{thread:r.value,text:o.text}:o}else if(o&&o.$mid===10){const I=this.b.get(o.thread.commentControlHandle);if(!I)return o;const r=I.getCommentThread(o.thread.commentThreadHandle);if(!r)return o;const c=o.commentUniqueId,h=r.getCommentByUniqueId(c);return h||o}else if(o&&o.$mid===11){const I=this.b.get(o.thread.commentControlHandle);if(!I)return o;const r=I.getCommentThread(o.thread.commentThreadHandle);if(!r)return o;const c=o.text,h=o.commentUniqueId,y=r.getCommentByUniqueId(h);return y?(typeof y.body=="string"?y.body=c:y.body=new M.MarkdownString(c),y):o}return o}})}createCommentController(o,I,r){const c=a.a++,h=new b(o,c,I,r);this.b.set(h.handle,h);const y=this.c.get(o.identifier)||[];return y.push(h),this.c.set(o.identifier,y),h.value}$createCommentThreadTemplate(o,I,r){const c=this.b.get(o);!c||c.$createCommentThreadTemplate(I,r)}async $updateCommentThreadTemplate(o,I,r){const c=this.b.get(o);!c||c.$updateCommentThreadTemplate(I,r)}$deleteCommentThread(o,I){this.b.get(o)?.$deleteCommentThread(I)}$provideCommentingRanges(o,I,r){const c=this.b.get(o);if(!c||!c.commentingRangeProvider)return Promise.resolve(void 0);const h=u.getDocument(E.URI.revive(I));return(0,n.asPromise)(()=>c.commentingRangeProvider.provideCommentingRanges(h,r)).then(y=>y?y.map(C=>P.Range.from(C)):void 0)}$toggleReaction(o,I,r,c,h){const y=this.b.get(o);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const C=y.getCommentThread(I);if(C){const H=C.getCommentByUniqueId(c.uniqueIdInThread);if(y!==void 0&&H&&y.reactionHandler)return y.reactionHandler(H,i(h))}return Promise.resolve(void 0)})}dispose(){}}a.a=0;class p{set threadId(o){this.n=o}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(o){o.isEqual(this.p)||(this.p=o,this.b.range=o,this.c.fire())}get range(){return this.p}set canReply(o){this.d!==o&&(this.d=o,this.b.canReply=o,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(o){this.e=o,this.b.label=o,this.c.fire()}get contextValue(){return this.f}set contextValue(o){this.f=o,this.b.contextValue=o,this.c.fire()}get comments(){return this.q}set comments(o){this.q=o,this.b.comments=o,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(o){this.g=o,this.b.collapsibleState=o,this.c.fire()}get state(){return this.h}set state(o){this.h=o,this.b.state=o,this.c.fire()}get isDisposed(){return this.j}constructor(o,I,r,c,h,y,C,H){this.m=I,this.n=r,this.o=c,this.p=h,this.q=y,this.extensionDescription=C,this.r=H,this.handle=p.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new D.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.MutableDisposable,this.l.value=new N.DisposableStore,this.n===void 0&&(this.n=`${o}.${this.handle}`),t.$createCommentThread(I,this.handle,this.n,this.o,P.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{t.$deleteCommentThread(I,this.handle)}});const K=this;this.value={get uri(){return K.uri},get range(){return K.range},set range(Q){K.range=Q},get comments(){return K.comments},set comments(Q){K.comments=Q},get collapsibleState(){return K.collapsibleState},set collapsibleState(Q){K.collapsibleState=Q},get canReply(){return K.canReply},set canReply(Q){K.canReply=Q},get contextValue(){return K.contextValue},set contextValue(Q){K.contextValue=Q},get label(){return K.label},set label(Q){K.label=Q},get state(){return K.state},set state(Q){K.state=Q},dispose:()=>{K.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.DisposableStore);const o=r=>Object.prototype.hasOwnProperty.call(this.b,r),I={};o("range")&&(I.range=P.Range.from(this.p)),o("label")&&(I.label=this.label),o("contextValue")&&(I.contextValue=this.contextValue??null),o("comments")&&(I.comments=this.q.map(r=>R(this,r,this.k))),o("collapsibleState")&&(I.collapseState=d(this.g)),o("canReply")&&(I.canReply=this.canReply),o("state")&&(I.state=s(this.h)),o("isTemplate")&&(I.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(o){for(const I of this.k){const r=I[0],c=I[1];if(o===c)return r}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(o=>o.dispose())}}p.a=0,qe([(0,A.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(o){this.b=o,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(o){this.c=o,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this.d}set options(o){this.d=o,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(o,I,r,c){this.f=o,this.g=I,this.h=r,this.i=c,this.a=new Map,t.$registerCommentController(this.handle,r,c);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(y){h.options=y},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(y){h.commentingRangeProvider=y},get reactionHandler(){return h.reactionHandler},set reactionHandler(y){h.reactionHandler=y},createCommentThread(y,C,H){return h.createCommentThread(y,C,H).value},dispose:()=>{h.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(o,I,r,c){if(typeof o=="string"){const h=new p(this.id,this.handle,o,I,r,c,this.f,!1);return this.a.set(h.handle,h),h}else{const h=new p(this.id,this.handle,void 0,o,I,r,this.f,!1);return this.a.set(h.handle,h),h}}$createCommentThreadTemplate(o,I){const r=new p(this.id,this.handle,void 0,E.URI.revive(o),P.Range.to(I),[],this.f,!0);return r.collapsibleState=O.CommentThreadCollapsibleState.Expanded,this.a.set(r.handle,r),r}$updateCommentThreadTemplate(o,I){const r=this.a.get(o);r&&(r.range=P.Range.to(I))}$deleteCommentThread(o){this.a.get(o)?.dispose(),this.a.delete(o)}getCommentThread(o){return this.a.get(o)}dispose(){this.a.forEach(o=>{o.dispose()}),this.e.forEach(o=>o.dispose())}}function R(l,o,I){let r=I.get(o);r||(r=++l.commentHandle,I.set(o,r));const c=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:r,body:typeof o.body=="string"?o.body:P.MarkdownString.from(o.body),userName:o.author.name,userIconPath:c,label:o.label,commentReactions:o.reactions?o.reactions.map(h=>v(h)):void 0,timestamp:o.timestamp?.toJSON()}}function v(l){return{label:l.label,iconPath:l.iconPath?P.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function i(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?E.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function d(l){if(l!==void 0)switch(l){case M.CommentThreadCollapsibleState.Expanded:return O.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return O.CommentThreadCollapsibleState.Collapsed}return O.CommentThreadCollapsibleState.Collapsed}function s(l){if(l!==void 0)switch(l){case M.CommentThreadState.Unresolved:return O.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return O.CommentThreadState.Resolved}return O.CommentThreadState.Unresolved}return new a}e.createExtHostComments=m}),define(Te[210],Pe([1,0,23,5,27,18]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let E=class{constructor(M,T){this.a=M.getProxy(A.MainContext.MainThreadConsole),this.b=T.consoleForward.includeStack,this.c=T.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(M,T){const m=this,w=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){m.e(M,T,w,arguments)}})}e(M,T,m,w){this.a.$logExtensionHostMessage({type:"__$console",severity:T,arguments:S(w,this.b)}),this.c&&this.f(M,m,w)}};E=qe([Ve(0,N.IExtHostRpcService),Ve(1,D.IExtHostInitDataService)],E),e.AbstractExtHostConsoleForwarder=E;const O=1e5;function S(P,M){const T=[];if(P.length)for(let m=0;m<P.length;m++){let w=P[m];if(typeof w>"u")w="undefined";else if(w instanceof Error){const f=w;f.stack?w=f.stack:w=f.toString()}T.push(w)}if(M){const m=new Error().stack;m&&T.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,n.safeStringify)(T);return m.length>O?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Te[104],Pe([1,0,2,5,7,3,18,12,16,10,19,26]),function(te,e,n,A,D,N,E,O,S,P,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=class Mi{constructor(f,u){this.h=u,this.f=new Map,this.g=f.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,u){const t=Mi.c++;this.f.set(t,{provider:f,extensionDescription:u}),this.g.$registerDecorationProvider(t,u.identifier.value);const a=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(p=>{if(!p){this.g.$onDidChange(t,null);return}const b=(0,S.asArray)(p);if(b.length<=Mi.d){this.g.$onDidChange(t,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,b.length);const R=b.map(d=>({uri:d,rank:(0,P.count)(d.path,"/")})),v=(0,S.groupBy)(R,(d,s)=>d.rank-s.rank||(0,P.compare)(d.uri.path,s.uri.path)),i=[];e:for(const d of v){let s;for(const l of d){const o=(0,M.dirname)(l.uri.path);if(s!==o&&(s=o,i.push(l.uri)>=Mi.d))break e}}this.g.$onDidChange(t,i)});return new D.Disposable(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(f,u,t){if(!this.f.has(f))return Object.create(null);const a=Object.create(null),{provider:p,extensionDescription:b}=this.f.get(f);return await Promise.all(u.map(async R=>{try{const{uri:v,id:i}=R,d=await Promise.resolve(p.provideFileDecoration(n.URI.revive(v),t));if(!d)return;try{D.FileDecoration.validate(d),d.badge&&typeof d.badge!="string"&&(0,T.checkProposedApiEnabled)(b,"codiconDecoration"),a[i]=[d.propagate,d.tooltip,d.badge,d.color]}catch(s){this.h.warn(`INVALID decoration from extension '${b}': ${s}`)}}catch(v){this.h.error(v)}})),a}};m.c=0,m.d=250,m=qe([Ve(0,E.IExtHostRpcService),Ve(1,O.ILogService)],m),e.ExtHostDecorations=m,e.IExtHostDecorations=(0,N.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,A,D){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Fe=this&&this.__classPrivateFieldGet||function(te,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!A:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(te):A?A.value:e.get(te)};define(Te[211],Pe([1,0,140,91,2,5,7,8,4,12,28,37]),function(te,e,n,A,D,N,E,O,S,P,M,T){"use strict";var m,w,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class u{constructor(p,b,R,v,i,d,s){this.d=p,this.e=b,this.f=R,this.g=v,m.set(this,void 0),w.set(this,void 0),f.set(this,void 0),this.c=!1,Je(this,f,new M.ResourceMap(l=>i.getComparisonKey(l)),"f"),Je(this,m,d,"f"),Je(this,w,s,"f")}dispose(){this.c||(Fe(this,w,"f").fire([...Fe(this,f,"f").keys()]),Fe(this,m,"f")?.$clear(this.e),Fe(this,f,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(p,b){if(!p){this.clear();return}this.h();let R=[];if(D.URI.isUri(p)){if(!b){this.delete(p);return}Fe(this,f,"f").set(p,b.slice()),R=[p]}else if(Array.isArray(p)){R=[];let i;p=[...p].sort(u.j);for(const d of p){const[s,l]=d;if((!i||s.toString()!==i.toString())&&(i&&Fe(this,f,"f").get(i).length===0&&Fe(this,f,"f").delete(i),i=s,R.push(s),Fe(this,f,"f").set(s,[])),l)Fe(this,f,"f").get(s)?.push(...l);else{const o=Fe(this,f,"f").get(s);o&&(o.length=0)}}}if(Fe(this,w,"f").fire(R),!Fe(this,m,"f"))return;const v=[];for(const i of R){let d=[];const s=Fe(this,f,"f").get(i);if(s)if(s.length>this.f){d=[];const l=[E.DiagnosticSeverity.Error,E.DiagnosticSeverity.Warning,E.DiagnosticSeverity.Information,E.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const I of s)if(I.severity===l[o]&&d.push({...O.Diagnostic.from(I),modelVersionId:this.g(i)})===this.f)break e;d.push({severity:A.MarkerSeverity.Info,message:(0,n.localize)(0,null,s.length-this.f),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=s.map(l=>({...O.Diagnostic.from(l),modelVersionId:this.g(i)}));v.push([i,d])}Fe(this,m,"f").$changeMany(this.e,v)}delete(p){this.h(),Fe(this,w,"f").fire([p]),Fe(this,f,"f").delete(p),Fe(this,m,"f")?.$changeMany(this.e,[[p,void 0]])}clear(){this.h(),Fe(this,w,"f").fire([...Fe(this,f,"f").keys()]),Fe(this,f,"f").clear(),Fe(this,m,"f")?.$clear(this.e)}forEach(p,b){this.h();for(const[R,v]of this)p.call(b,R,v,this)}*[(m=new WeakMap,w=new WeakMap,f=new WeakMap,Symbol.iterator)](){this.h();for(const p of Fe(this,f,"f").keys())yield[p,this.get(p)]}get(p){this.h();const b=Fe(this,f,"f").get(p);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(p){return this.h(),Array.isArray(Fe(this,f,"f").get(p))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(p,b){return p[0].toString()<b[0].toString()?-1:p[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=u;let t=class Ei{static _mapper(p){const b=new M.ResourceMap;for(const R of p)b.set(R,R);return{uris:Object.freeze(Array.from(b.values()))}}constructor(p,b,R,v){this.h=b,this.j=R,this.k=v,this.f=new Map,this.g=new S.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,Ei._mapper),this.e=p.getProxy(N.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,b){const{f:R,e:v,g:i,h:d,j:s,k:l}=this,o=new class{$changeMany(c,h){v.$changeMany(c,h),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,c,h.length===0?"CLEARING":h)}$clear(c){v.$clear(c),d.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,c)}dispose(){v.dispose()}};let I;if(!b)b="_generated_diagnostic_collection_name_#"+Ei.c++,I=b;else if(!R.has(b))I=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do I=b+Ei.c++;while(R.has(I))}return new class extends u{constructor(){super(b,I,Ei.d,c=>l.getDocument(c)?.version,s.extUri,o,i),R.set(I,this)}dispose(){super.dispose(),R.delete(I)}}}getDiagnostics(p){if(p)return this.l(p);{const b=new Map,R=[];for(const v of this.f.values())v.forEach((i,d)=>{let s=b.get(i.toString());typeof s>"u"&&(s=R.length,b.set(i.toString(),s),R.push([i,[]])),R[s][1]=R[s][1].concat(...d)});return R}}l(p){let b=[];for(const R of this.f.values())R.has(p)&&(b=b.concat(R.get(p)));return b}$acceptMarkersChange(p){if(!this.m){const b="_generated_mirror",R=new u(b,b,Ei.d,v=>{},this.j.extUri,void 0,this.g);this.f.set(b,R),this.m=R}for(const[b,R]of p)this.m.set(D.URI.revive(b),R.map(O.Diagnostic.to))}};t.c=0,t.d=1e3,t=qe([Ve(1,P.ILogService),Ve(2,T.IExtHostFileSystemInfo)],t),e.ExtHostDiagnostics=t}),define(Te[212],Pe([1,0,2,5,26]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class N{constructor(O){this.a=O.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(O,S){return S?.allowUIResources&&(0,D.checkProposedApiEnabled)(O,"showLocal"),this.a.$showOpenDialog(S).then(P=>P?P.map(M=>n.URI.revive(M)):void 0)}showSaveDialog(O){return this.a.$showSaveDialog(O).then(S=>S?n.URI.revive(S):void 0)}}e.ExtHostDialogs=N}),define(Te[213],Pe([1,0,11,2,7,5,15,21,10]),function(te,e,n,A,D,N,E,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(T,m,w){this.d=m,this.e=w,this.b=new Map,this.c=T.getProxy(N.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,m){if(Object.keys(E.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const w=P.a++;this.b.set(w,m),this.c.$registerTextContentProvider(w,T);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(u=>{if(u.scheme!==T){this.e.warn(`Provider for scheme '${T}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this.d.getDocument(u)&&this.$provideTextDocumentContent(w,u).then(t=>{if(!t&&typeof t!="string")return;const a=this.d.getDocument(u);if(!a)return;const p=(0,S.splitLines)(t);if(!a.equalLines(p))return this.c.$onVirtualDocumentChange(u,t)},n.onUnexpectedError)})),new D.Disposable(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(T,m){const w=this.b.get(T);return w?Promise.resolve(w.provideTextDocumentContent(A.URI.revive(m),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}P.a=0,e.ExtHostDocumentContentProvider=P}),define(Te[214],Pe([1,0,4,6,2,5,100,8,9,23,7]),function(te,e,n,A,D,N,E,O,S,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(w,f){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new A.DisposableStore,this.h=new Map,this.f=w.getProxy(N.MainContext.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(u=>{for(const t of u)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const t of u)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const f=this.g.getDocument(w);if(f)return f}getDocument(w){const f=this.getDocumentData(w);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return f.document}ensureDocumentData(w){const f=this.g.getDocument(w);if(f)return Promise.resolve(f);let u=this.h.get(w.toString());return u||(u=this.f.$tryOpenDocument(w).then(t=>{this.h.delete(w.toString());const a=D.URI.revive(t);return(0,S.assertIsDefined)(this.g.getDocument(a))},t=>(this.h.delete(w.toString()),Promise.reject(t))),this.h.set(w.toString(),u)),u}createDocumentData(w){return this.f.$tryCreateDocument(w).then(f=>D.URI.revive(f))}$acceptModelLanguageChanged(w,f){const u=D.URI.revive(w),t=this.g.getDocument(u);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(f),this.a.fire(t.document)}$acceptModelSaved(w){const f=D.URI.revive(w),u=this.g.getDocument(f);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(w,f){const u=D.URI.revive(w),t=this.g.getDocument(u);if(!t)throw new Error("unknown document");t._acceptIsDirty(f),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,f,u){const t=D.URI.revive(w),a=this.g.getDocument(t);if(!a)throw new Error("unknown document");a._acceptIsDirty(u),a.onEvents(f);let p;f.isUndoing?p=M.TextDocumentChangeReason.Undo:f.isRedoing&&(p=M.TextDocumentChangeReason.Redo),this.c.fire((0,P.deepFreeze)({document:a.document,contentChanges:f.changes.map(b=>({range:O.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:p}))}setWordDefinitionFor(w,f){(0,E.setWordDefinitionFor)(w,f)}}e.ExtHostDocuments=T}),define(Te[58],Pe([1,0,49,4,6,2,3,5,100,18,103,8,12,28,15,186,85]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class a{constructor(R){this.value=R,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let p=class{constructor(R,v){this.h=R,this.i=v,this.a=null,this.b=new Map,this.c=new w.ResourceMap,this.d=new A.Emitter,this.e=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(R){this.acceptDocumentsAndEditorsDelta(R)}acceptDocumentsAndEditorsDelta(R){const v=[],i=[],d=[];if(R.removedDocuments)for(const s of R.removedDocuments){const l=N.URI.revive(s),o=this.c.get(l);o?.unref()&&(this.c.delete(l),v.push(o.value))}if(R.addedDocuments)for(const s of R.addedDocuments){const l=N.URI.revive(s.uri);let o=this.c.get(l);if(o&&l.scheme!==f.Schemas.vscodeNotebookCell&&l.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);o||(o=new a(new S.ExtHostDocumentData(this.h.getProxy(O.MainContext.MainThreadDocuments),l,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(l,o),i.push(o.value)),o.ref()}if(R.removedEditors)for(const s of R.removedEditors){const l=this.b.get(s);this.b.delete(s),l&&d.push(l)}if(R.addedEditors)for(const s of R.addedEditors){const l=N.URI.revive(s.documentUri);n.ok(this.c.has(l),`document '${l}' does not exist`),n.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const o=this.c.get(l).value,I=new M.ExtHostTextEditor(s.id,this.h.getProxy(O.MainContext.MainThreadTextEditors),this.i,new t.Lazy(()=>o.document),s.selections.map(T.Selection.to),s.options,s.visibleRanges.map(r=>T.Range.to(r)),typeof s.editorPosition=="number"?T.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,I)}R.newActiveEditor!==void 0&&(n.ok(R.newActiveEditor===null||this.b.has(R.newActiveEditor),`active editor '${R.newActiveEditor}' does not exist`),this.a=R.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(d),R.removedDocuments&&this.e.fire(v),R.addedDocuments&&this.d.fire(i),(R.removedEditors||R.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),R.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(R){return this.c.get(R)?.value}allDocuments(){return u.Iterable.map(this.c.values(),R=>R.value)}getEditor(R){return this.b.get(R)}activeEditor(R){if(!this.a)return;const v=this.b.get(this.a);return R?v:v?.value}allEditors(){return[...this.b.values()]}};p=qe([Ve(0,P.IExtHostRpcService),Ve(1,m.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,E.createDecorator)("IExtHostDocumentsAndEditors")}),define(Te[59],Pe([1,0,8,5,2,4,3,7,18,9,63]),function(te,e,n,A,D,N,E,O,S,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,E.createDecorator)("IExtHostEditorTabs");class T{constructor(t,a,p){this.e=p,this.d=a,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,a={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new O.TextTabInput(D.URI.revive(this.b.input.uri));case 2:return new O.TextDiffTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified));case 3:return new O.TextMergeTabInput(D.URI.revive(this.b.input.base),D.URI.revive(this.b.input.input1),D.URI.revive(this.b.input.input2),D.URI.revive(this.b.input.result));case 6:return new O.CustomEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new O.WebviewEditorTabInput(this.b.input.viewType);case 4:return new O.NotebookEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new O.NotebookDiffEditorTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new O.TerminalEditorTabInput;case 9:return new O.InteractiveWindowInput(D.URI.revive(this.b.input.uri),D.URI.revive(this.b.input.inputBoxUri));default:return}}}class m{constructor(t,a){this.c=[],this.d="",this.b=t,this.e=a;for(const p of t.tabs)p.isActive&&(this.d=p.id),this.c.push(new T(p,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,a={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return n.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(p=>p.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(p=>p.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const p=new T(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,p),t.tabDto.isActive&&(this.d=p.tabId),p}else if(t.kind===1){const p=this.c.splice(t.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return p.tabId===this.d&&(this.d=""),p}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this.c.splice(t.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,p),p}const a=this.c.find(p=>p.tabId===t.tabDto.id);if(!a)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(t.tabDto),a}activeTabId(){return this.d}}let w=class{constructor(t){this.b=new N.Emitter,this.c=new N.Emitter,this.e=[],this.a=t.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,a={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(p=>p.apiObject))},get activeTabGroup(){const p=t.d;return(0,P.assertIsDefined)(t.e.find(R=>R.groupId===p)?.apiObject)},close:async(p,b)=>{const R=Array.isArray(p)?p:[p];return R.length?f(R[0])?this.j(R,b):this.i(R,b):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(t){const a=new Set(this.e.map(s=>s.groupId)),p=new Set(t.map(s=>s.groupId)),b=(0,M.diffSets)(a,p),R=this.e.filter(s=>b.removed.includes(s.groupId)).map(s=>s.apiObject),v=[],i=[];this.e=t.map(s=>{const l=new m(s,()=>this.d);return b.added.includes(l.groupId)?v.push(l.apiObject):i.push(l.apiObject),l});const d=(0,P.assertIsDefined)(t.find(s=>s.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:v,closed:R,changed:i}))}$acceptTabGroupUpdate(t){const a=this.e.find(p=>p.groupId===t.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const a=this.e.find(b=>b.groupId===t.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const p=a.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}g(t){for(const a of this.e)for(const p of a.tabs)if(p.apiObject===t)return p}h(t){return this.e.find(a=>a.apiObject===t)}async i(t,a){const p=[];for(const b of t){const R=this.g(b);if(!R)throw new Error("Tab close: Invalid tab not found!");p.push(R.tabId)}return this.a.$closeTab(p,a)}async j(t,a){const p=[];for(const b of t){const R=this.h(b);if(!R)throw new Error("Group close: Invalid group not found!");p.push(R.groupId)}return this.a.$closeGroup(p,a)}};w=qe([Ve(0,S.IExtHostRpcService)],w),e.ExtHostEditorTabs=w;function f(u){return u.tabs!==void 0}}),define(Te[215],Pe([1,0,2,5,6,7,8,261,10,25,26]),function(te,e,n,A,D,N,E,O,S,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const u=this.a.indexOf(f);u>=0&&(this.a.splice(u,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),u=[];let t,a,p=14,b=14;for(const R of f){let v=t?(0,S.commonPrefixLength)(t,R):0;for(v===0?a=1:a=b;v<R.length;v++)v+1===R.length?(p=b,b=9):b+=1,u.push([a,R.toUpperCase().charCodeAt(v),b]),u.push([a,R.toLowerCase().charCodeAt(v),b]),a=b;t=R,b=p}u.push([9,58,10]),u.push([10,47,12]),this.b=new O.StateMachine(u)}}provideDocumentLinks(f){this.c();const u=[],t=O.LinkComputer.computeLinks({getLineContent(a){return f.lineAt(a-1).text},getLineCount(){return f.lineCount}},this.b);for(const a of t){const p=E.DocumentLink.to(a);p.target&&u.push(p)}return u}}class m{constructor(f,u){this.i=u,this.b=new T,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,u,t,a={}){if(m.j(t),this.d.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const p=this.h++;this.b.add(u),this.d.add(u),this.c.set(p,t);let b=2;a.isCaseSensitive&&(b+=1024),a.isReadonly&&(b+=2048),typeof t.copy=="function"&&(b+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,M.checkProposedApiEnabled)(f,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(p,u,b).catch(v=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${u}`),console.error(v)});const R=t.onDidChangeFile(v=>{const i=[];for(const d of v){const{uri:s,type:l}=d;if(s.scheme!==u)continue;let o;switch(l){case N.FileChangeType.Changed:o=0;break;case N.FileChangeType.Created:o=1;break;case N.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:s,type:o})}this.a.$onFileSystemChange(p,i)});return(0,D.toDisposable)(()=>{R.dispose(),this.b.delete(u),this.d.delete(u),this.c.delete(p),this.a.$unregisterProvider(p)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:u,ctime:t,mtime:a,size:p,permissions:b}=f;return{type:u,ctime:t,mtime:a,size:p,permissions:b}}$stat(f,u){return Promise.resolve(this.l(f).stat(n.URI.revive(u))).then(t=>m.k(t))}$readdir(f,u){return Promise.resolve(this.l(f).readDirectory(n.URI.revive(u)))}$readFile(f,u){return Promise.resolve(this.l(f).readFile(n.URI.revive(u))).then(t=>P.VSBuffer.wrap(t))}$writeFile(f,u,t,a){return Promise.resolve(this.l(f).writeFile(n.URI.revive(u),t.buffer,a))}$delete(f,u,t){return Promise.resolve(this.l(f).delete(n.URI.revive(u),t))}$rename(f,u,t,a){return Promise.resolve(this.l(f).rename(n.URI.revive(u),n.URI.revive(t),a))}$copy(f,u,t,a){const p=this.l(f);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(n.URI.revive(u),n.URI.revive(t),a))}$mkdir(f,u){return Promise.resolve(this.l(f).createDirectory(n.URI.revive(u)))}$watch(f,u,t,a){const p=this.l(f).watch(n.URI.revive(t),a);this.f.set(u,p)}$unwatch(f,u){const t=this.f.get(u);t&&(t.dispose(),this.f.delete(u))}$open(f,u,t){const a=this.l(f);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(n.URI.revive(u),t))}$close(f,u){const t=this.l(f);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(u))}$read(f,u,t,a){const p=this.l(f);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const b=P.VSBuffer.alloc(a);return Promise.resolve(p.read(u,t,b.buffer,0,a)).then(R=>b.slice(0,R))}$write(f,u,t,a){const p=this.l(f);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(u,t,a.buffer,0,a.byteLength))}l(f){const u=this.c.get(f);if(!u){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return u}}e.ExtHostFileSystem=m}),define(Te[60],Pe([1,0,5,43,7,25,3,18,37,6]),function(te,e,n,A,D,N,E,O,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let M=class Yt{constructor(m,w){this.b=new Map,this.a=m.getProxy(n.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(u){try{const t=f.b.get(u.scheme);if(!t)return await f.a.$stat(u);await f.a.$ensureActivation(u.scheme);const a=await t.stat(u);return{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions}}catch(t){Yt.c(t)}},async readDirectory(u){try{const t=f.b.get(u.scheme);return t?(await f.a.$ensureActivation(u.scheme),(await t.readDirectory(u)).slice()):await f.a.$readdir(u)}catch(t){return Yt.c(t)}},async createDirectory(u){try{return await f.a.$mkdir(u)}catch(t){return Yt.c(t)}},async readFile(u){try{const t=f.b.get(u.scheme);return t?(await f.a.$ensureActivation(u.scheme),(await t.readFile(u)).slice()):(await f.a.$readFile(u)).buffer}catch(t){return Yt.c(t)}},async writeFile(u,t){try{return await f.a.$writeFile(u,N.VSBuffer.wrap(t))}catch(a){return Yt.c(a)}},async delete(u,t){try{const a=f.b.get(u.scheme);return a?(await f.a.$ensureActivation(u.scheme),await a.delete(u,{recursive:!1,...t})):await f.a.$delete(u,{recursive:!1,useTrash:!1,...t})}catch(a){return Yt.c(a)}},async rename(u,t,a){try{return await f.a.$rename(u,t,{overwrite:!1,...a})}catch(p){return Yt.c(p)}},async copy(u,t,a){try{return await f.a.$copy(u,t,{overwrite:!1,...a})}catch(p){return Yt.c(p)}},isWritableFileSystem(u){const t=w.getCapabilities(u);if(typeof t=="number")return!(t&2048)}})}static c(m){if(m instanceof D.FileSystemError)throw m;if(!(m instanceof Error))throw new D.FileSystemError(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(m.message);switch(m.name){case A.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(m.message);case A.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(m.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(m.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(m.message);case A.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(m.message);case A.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(m.message);default:throw new D.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,w){return this.b.set(m,w),(0,P.toDisposable)(()=>this.b.delete(m))}};M=qe([Ve(0,O.IExtHostRpcService),Ve(1,S.IExtHostFileSystemInfo)],M),e.ExtHostConsumerFileSystem=M,e.IExtHostConsumerFileSystem=(0,E.createDecorator)("IExtHostConsumerFileSystem")}),define(Te[216],Pe([1,0,4,35,2,5,8,7]),function(te,e,n,A,D,N,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(T,m,w,f,u,t,a,p){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter;const b=this.h(T,w,u);this.g=0,t&&(this.g+=1),a&&(this.g+=2),p&&(this.g+=4);const R=(0,A.parse)(u),v=typeof u=="string",i=f(d=>{if(!t)for(const s of d.created){const l=D.URI.revive(s);R(l.fsPath)&&(!v||m.getWorkspaceFolder(l))&&this.a.fire(l)}if(!a)for(const s of d.changed){const l=D.URI.revive(s);R(l.fsPath)&&(!v||m.getWorkspaceFolder(l))&&this.b.fire(l)}if(!p)for(const s of d.deleted){const l=D.URI.revive(s);R(l.fsPath)&&(!v||m.getWorkspaceFolder(l))&&this.c.fire(l)}});this.d=O.Disposable.from(b,this.a,this.b,this.c,i)}h(T,m,w){const f=O.Disposable.from();if(typeof w=="string")return f;const u=T.getProxy(N.MainContext.MainThreadFileSystem);let t=!1;(w.pattern.includes(A.GLOBSTAR)||w.pattern.includes(A.GLOB_SPLIT))&&(t=!0);const a=Math.random();return u.$watch(m.identifier.value,a,w.baseUri,{recursive:t,excludes:[]}),O.Disposable.from({dispose:()=>u.$unwatch(a)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class P{constructor(T,m,w){this.j=T,this.k=m,this.l=w,this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.g=new n.AsyncEmitter,this.h=new n.AsyncEmitter,this.i=new n.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(T,m,w,f,u,t){return new S(this.j,T,m,this.a.event,E.GlobPattern.from(w),f,u,t)}$onFileEvent(T){this.a.fire(T)}$onDidRunFileOperation(T,m){switch(T){case 2:this.b.fire(Object.freeze({files:m.map(w=>({oldUri:D.URI.revive(w.source),newUri:D.URI.revive(w.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(w=>D.URI.revive(w.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(w=>D.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(T){return this.m(T,this.g)}getOnWillCreateFileEvent(T){return this.m(T,this.h)}getOnWillDeleteFileEvent(T){return this.m(T,this.i)}m(T,m){return(w,f,u)=>{const t=function(p){w.call(f,p)};return t.extension=T,m.event(t,void 0,u)}}async $onWillRunFileOperation(T,m,w,f){switch(T){case 2:return await this.n(this.g,{files:m.map(u=>({oldUri:D.URI.revive(u.source),newUri:D.URI.revive(u.target)}))},w,f);case 1:return await this.n(this.i,{files:m.map(u=>D.URI.revive(u.target))},w,f);case 0:case 3:return await this.n(this.h,{files:m.map(u=>D.URI.revive(u.target))},w,f)}}async n(T,m,w,f){const u=new Set,t=[];if(await T.fireAsync(m,f,async(p,b)=>{const R=Date.now(),v=await Promise.resolve(p);v instanceof O.WorkspaceEdit&&(t.push([b.extension,v]),u.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-R>w&&this.k.warn("SLOW file-participant",b.extension.identifier)}),f.isCancellationRequested||t.length===0)return;const a={edits:[]};for(const[,p]of t){const{edits:b}=E.WorkspaceEdit.from(p,{getTextDocumentVersion:R=>this.l.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(b)}return{edit:a,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=P}),define(Te[217],Pe([1,0,2,38]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(E,O,S,P,M){this.a=O,this.b=S,this.c=P;const T=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new A.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new A.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new A.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new A.ApiCommandResult("Notebook and input URI",m=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const w=this.a.getEditorById(m.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:n.URI.revive(m.notebookUri),inputUri:n.URI.revive(m.inputUri),notebookEditor:w.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:n.URI.revive(m.notebookUri),inputUri:n.URI.revive(m.inputUri)}}));this.c.registerApiCommand(T)}$willAddInteractiveDocument(E,O,S,P){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:S,uri:E,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(n.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(E,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[E]})}}e.ExtHostInteractive=D}),define(Te[218],Pe([1,0,6,5]),function(te,e,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(E){this.b=0,this.a=E.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(E){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,E),(0,n.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.ExtHostLabelService=D}),define(Te[219],Pe([1,0,2,23,8,7,75,5,10,44,16,9,262,21,6,88,83,54,77,11,17,26]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t,a,p,b,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(k,$){this.d=k,this.e=$}async provideDocumentSymbols(k,$){const W=this.d.getDocument(k),V=await this.e.provideDocumentSymbols(W,$);if(!(0,M.isFalsyOrEmpty)(V))return V[0]instanceof N.DocumentSymbol?V.map(D.DocumentSymbol.from):i.f(V)}static f(k){k=k.slice(0).sort((V,ee)=>{let fe=V.location.range.start.compareTo(ee.location.range.start);return fe===0&&(fe=ee.location.range.end.compareTo(V.location.range.end)),fe});const $=[],W=[];for(const V of k){const ee={name:V.name||"!!MISSING: name!!",kind:D.SymbolKind.from(V.kind),tags:V.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:D.Range.from(V.location.range),selectionRange:D.Range.from(V.location.range),children:[]};for(;;){if(W.length===0){W.push(ee),$.push(ee);break}const fe=W[W.length-1];if(P.Range.containsRange(fe.range,ee.range)&&!P.Range.equalsRange(fe.range,ee.range)){fe.children?.push(ee),W.push(ee);break}W.pop()}}return $}}class d{constructor(k,$,W){this.g=k,this.h=$,this.j=W,this.e=new a.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(k,$){const W=this.g.getDocument(k),V=await this.j.provideCodeLenses(W,$);if(!V||$.isCancellationRequested)return;const ee=this.e.add(V),fe=new f.DisposableStore;this.f.set(ee,fe);const Ie={cacheId:ee,lenses:[]};for(let le=0;le<V.length;le++)Ie.lenses.push({cacheId:[ee,le],range:D.Range.from(V[le].range),command:this.h.toInternal(V[le].command,fe)});return Ie}async resolveCodeLens(k,$){const W=k.cacheId&&this.e.get(...k.cacheId);if(!W)return;let V;if(typeof this.j.resolveCodeLens!="function"||W.isResolved?V=W:V=await this.j.resolveCodeLens(W,$),V||(V=W),$.isCancellationRequested)return;const ee=k.cacheId&&this.f.get(k.cacheId[0]);if(!!ee)return k.command=this.h.toInternal(V.command??d.d,ee),k}releaseCodeLenses(k){this.f.get(k)?.dispose(),this.f.delete(k),this.e.delete(k)}}d.d={command:"missing",title:"!!MISSING: command!!"};function s(J){return Array.isArray(J)?J.map(D.DefinitionLink.from):J?[D.DefinitionLink.from(J)]:[]}class l{constructor(k,$){this.d=k,this.e=$}async provideDefinition(k,$,W){const V=this.d.getDocument(k),ee=D.Position.to($),fe=await this.e.provideDefinition(V,ee,W);return s(fe)}}class o{constructor(k,$){this.d=k,this.e=$}async provideDeclaration(k,$,W){const V=this.d.getDocument(k),ee=D.Position.to($),fe=await this.e.provideDeclaration(V,ee,W);return s(fe)}}class I{constructor(k,$){this.d=k,this.e=$}async provideImplementation(k,$,W){const V=this.d.getDocument(k),ee=D.Position.to($),fe=await this.e.provideImplementation(V,ee,W);return s(fe)}}class r{constructor(k,$){this.d=k,this.e=$}async provideTypeDefinition(k,$,W){const V=this.d.getDocument(k),ee=D.Position.to($),fe=await this.e.provideTypeDefinition(V,ee,W);return s(fe)}}class c{constructor(k,$){this.d=k,this.e=$}async provideHover(k,$,W){const V=this.d.getDocument(k),ee=D.Position.to($),fe=await this.e.provideHover(V,ee,W);if(!(!fe||(0,M.isFalsyOrEmpty)(fe.contents)))return fe.range||(fe.range=V.getWordRangeAtPosition(ee)),fe.range||(fe.range=new N.Range(ee,ee)),D.Hover.from(fe)}}class h{constructor(k,$){this.d=k,this.e=$}async provideEvaluatableExpression(k,$,W){const V=this.d.getDocument(k),ee=D.Position.to($),fe=await this.e.provideEvaluatableExpression(V,ee,W);if(fe)return D.EvaluatableExpression.from(fe)}}class y{constructor(k,$){this.d=k,this.e=$}async provideInlineValues(k,$,W,V){const ee=this.d.getDocument(k),fe=await this.e.provideInlineValues(ee,D.Range.to($),D.InlineValueContext.to(W),V);if(Array.isArray(fe))return fe.map(Ie=>D.InlineValue.from(Ie))}}class C{constructor(k,$){this.d=k,this.e=$}async provideDocumentHighlights(k,$,W){const V=this.d.getDocument(k),ee=D.Position.to($),fe=await this.e.provideDocumentHighlights(V,ee,W);if(Array.isArray(fe))return fe.map(D.DocumentHighlight.from)}}class H{constructor(k,$){this.d=k,this.e=$}async provideLinkedEditingRanges(k,$,W){const V=this.d.getDocument(k),ee=D.Position.to($),fe=await this.e.provideLinkedEditingRanges(V,ee,W);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,M.coalesce)(fe.ranges.map(D.Range.from)),wordPattern:fe.wordPattern}}}class K{constructor(k,$){this.d=k,this.e=$}async provideReferences(k,$,W,V){const ee=this.d.getDocument(k),fe=D.Position.to($),Ie=await this.e.provideReferences(ee,fe,W,V);if(Array.isArray(Ie))return Ie.map(D.location.from)}}class Q{constructor(k,$,W,V,ee,fe,Ie){this.g=k,this.h=$,this.j=W,this.k=V,this.l=ee,this.m=fe,this.n=Ie,this.e=new a.Cache("CodeAction"),this.f=new Map}async provideCodeActions(k,$,W,V){const ee=this.g.getDocument(k),fe=m.Selection.isISelection($)?D.Selection.to($):D.Range.to($),Ie=[];for(const it of this.j.getDiagnostics(k))if(fe.intersection(it.range)&&Ie.push(it)>Q.d)break;const le={diagnostics:Ie,only:W.only?new N.CodeActionKind(W.only):void 0,triggerKind:D.CodeActionTriggerKind.to(W.trigger)},ve=await this.k.provideCodeActions(ee,fe,le,V);if(!(0,M.isNonEmptyArray)(ve)||V.isCancellationRequested)return;const Ee=this.e.add(ve),We=new f.DisposableStore;this.f.set(Ee,We);const je=[];for(let it=0;it<ve.length;it++){const Ge=ve[it];!Ge||(Q.o(Ge)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:Ge.title,command:this.h.toInternal(Ge,We)})):(le.only&&(Ge.kind?le.only.contains(Ge.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${le.only.value} 'requested but returned code action is of kind '${Ge.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[Ee,it],title:Ge.title,command:Ge.command&&this.h.toInternal(Ge.command,We),diagnostics:Ge.diagnostics&&Ge.diagnostics.map(D.Diagnostic.from),edit:Ge.edit&&D.WorkspaceEdit.from(Ge.edit,void 0),kind:Ge.kind&&Ge.kind.value,isPreferred:Ge.isPreferred,disabled:Ge.disabled?.reason})))}return{cacheId:Ee,actions:je}}async resolveCodeAction(k,$){const[W,V]=k,ee=this.e.get(W,V);if(!ee||Q.o(ee)||!this.k.resolveCodeAction)return;const fe=await this.k.resolveCodeAction(ee,$)??ee;return fe?.edit?D.WorkspaceEdit.from(fe.edit,void 0):void 0}releaseCodeActions(k){this.f.get(k)?.dispose(),this.f.delete(k),this.e.delete(k)}static o(k){return typeof k.command=="string"&&typeof k.title=="string"}}Q.d=1e3;class _{constructor(k,$,W,V){this.d=k,this.e=$,this.f=W,this.g=V}async prepareDocumentPaste(k,$,W,V){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(k),fe=$.map(le=>D.Range.to(le)),Ie=D.DataTransfer.toDataTransfer(W,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(ee,fe,Ie,V),D.DataTransfer.toDataTransferDTO(Ie)}async providePasteEdits(k,$,W,V,ee){const fe=this.e.getDocument($),Ie=W.map(Ee=>D.Range.to(Ee)),le=D.DataTransfer.toDataTransfer(V,async Ee=>(await this.d.$resolvePasteFileData(this.g,k,Ee)).buffer),ve=await this.f.provideDocumentPasteEdits(fe,Ie,le,ee);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?D.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class j{constructor(k,$){this.d=k,this.e=$}async provideDocumentFormattingEdits(k,$,W){const V=this.d.getDocument(k),ee=await this.e.provideDocumentFormattingEdits(V,$,W);if(Array.isArray(ee))return ee.map(D.TextEdit.from)}}class L{constructor(k,$){this.d=k,this.e=$}async provideDocumentRangeFormattingEdits(k,$,W,V){const ee=this.d.getDocument(k),fe=D.Range.to($),Ie=await this.e.provideDocumentRangeFormattingEdits(ee,fe,W,V);if(Array.isArray(Ie))return Ie.map(D.TextEdit.from)}}class g{constructor(k,$){this.d=k,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(k,$,W,V,ee){const fe=this.d.getDocument(k),Ie=D.Position.to($),le=await this.e.provideOnTypeFormattingEdits(fe,Ie,W,V,ee);if(Array.isArray(le))return le.map(D.TextEdit.from)}}class F{constructor(k,$){this.e=k,this.f=$,this.d=new a.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(k,$){const W=await this.e.provideWorkspaceSymbols(k,$);if(!(0,M.isNonEmptyArray)(W))return{symbols:[]};const V=this.d.add(W),ee={cacheId:V,symbols:[]};for(let fe=0;fe<W.length;fe++){const Ie=W[fe];if(!Ie||!Ie.name){this.f.warn("INVALID SymbolInformation",Ie);continue}ee.symbols.push({...D.WorkspaceSymbol.from(Ie),cacheId:[V,fe]})}return ee}async resolveWorkspaceSymbol(k,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!k.cacheId)return k;const W=this.d.get(...k.cacheId);if(W){const V=await this.e.resolveWorkspaceSymbol(W,$);return V&&(0,A.mixin)(k,D.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(k){this.d.delete(k)}}class B{static supportsResolving(k){return typeof k.prepareRename=="function"}constructor(k,$,W){this.d=k,this.e=$,this.f=W}async provideRenameEdits(k,$,W,V){const ee=this.d.getDocument(k),fe=D.Position.to($);try{const Ie=await this.e.provideRenameEdits(ee,fe,W,V);return Ie?D.WorkspaceEdit.from(Ie):void 0}catch(Ie){const le=B.g(Ie);return le?{rejectReason:le,edits:void 0}:Promise.reject(Ie)}}async resolveRenameLocation(k,$,W){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(k),ee=D.Position.to($);try{const fe=await this.e.prepareRename(V,ee,W);let Ie,le;if(N.Range.isRange(fe)?(Ie=fe,le=V.getText(fe)):(0,T.isObject)(fe)&&(Ie=fe.range,le=fe.placeholder),!Ie||!le)return;if(Ie.start.line>ee.line||Ie.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(Ie),text:le}}catch(fe){const Ie=B.g(fe);return Ie?{rejectReason:Ie,range:void 0,text:void 0}:Promise.reject(fe)}}static g(k){return typeof k=="string"?k:k instanceof Error&&typeof k.message=="string"?k.message:void 0}}class Y{constructor(k,$){this.resultId=k,this.tokens=$}}class me{constructor(k,$){this.f=k,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(k,$,W){const V=this.f.getDocument(k),ee=$!==0?this.d.get($):null;let fe=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,ee.resultId,W):await this.g.provideDocumentSemanticTokens(V,W);return ee&&this.d.delete($),fe?(fe=me.h(fe),this.o(me.n(ee,fe),fe)):null}async releaseDocumentSemanticColoring(k){this.d.delete(k)}static h(k){return me.j(k)?me.k(k)?k:new N.SemanticTokens(new Uint32Array(k.data),k.resultId):me.l(k)?me.m(k)?k:new N.SemanticTokensEdits(k.edits.map($=>new N.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),k.resultId):k}static j(k){return k&&!!k.data}static k(k){return k.data instanceof Uint32Array}static l(k){return k&&Array.isArray(k.edits)}static m(k){for(const $ of k.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(k,$){if(!me.j($)||!k||!k.tokens)return $;const W=k.tokens,V=W.length,ee=$.data,fe=ee.length;let Ie=0;const le=Math.min(V,fe);for(;Ie<le&&W[Ie]===ee[Ie];)Ie++;if(Ie===V&&Ie===fe)return new N.SemanticTokensEdits([],$.resultId);let ve=0;const Ee=le-Ie;for(;ve<Ee&&W[V-ve-1]===ee[fe-ve-1];)ve++;return new N.SemanticTokensEdits([{start:Ie,deleteCount:V-Ie-ve,data:ee.subarray(Ie,fe-ve)}],$.resultId)}o(k,$){if(me.j(k)){const W=this.e++;return this.d.set(W,new Y(k.resultId,k.data)),(0,u.encodeSemanticTokensDto)({id:W,type:"full",data:k.data})}if(me.l(k)){const W=this.e++;return me.j($)?this.d.set(W,new Y($.resultId,$.data)):this.d.set(W,new Y(k.resultId)),(0,u.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(k.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class Z{constructor(k,$){this.d=k,this.e=$}async provideDocumentRangeSemanticTokens(k,$,W){const V=this.d.getDocument(k),ee=await this.e.provideDocumentRangeSemanticTokens(V,D.Range.to($),W);return ee?this.f(ee):null}f(k){return(0,u.encodeSemanticTokensDto)({id:0,type:"full",data:k.data})}}class se{static supportsResolving(k){return typeof k.resolveCompletionItem=="function"}constructor(k,$,W,V,ee){this.f=k,this.g=$,this.h=W,this.j=V,this.k=ee,this.d=new a.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(k,$,W,V){const ee=this.f.getDocument(k),fe=D.Position.to($),Ie=ee.getWordRangeAtPosition(fe)||new N.Range(fe,fe),le=Ie.with({end:fe}),ve=new p.StopWatch(!0),Ee=await this.h.provideCompletionItems(ee,fe,V,D.CompletionContext.to(W));if(!Ee||V.isCancellationRequested)return;const We=Array.isArray(Ee)?new N.CompletionList(Ee):Ee,je=se.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),it=new f.DisposableStore;this.e.set(je,it);const Ge=[],tt={x:je,b:Ge,a:{replace:D.Range.from(Ie),insert:D.Range.from(le)},c:We.isIncomplete||void 0,d:ve.elapsed()};for(let nt=0;nt<We.items.length;nt++){const Ne=We.items[nt],rt=this.l(Ne,[je,nt],le,Ie);Ge.push(rt)}return tt}async resolveCompletionItem(k,$){if(typeof this.h.resolveCompletionItem!="function")return;const W=this.d.get(...k);if(!W)return;const V=await this.h.resolveCompletionItem(W,$);if(!!V)return this.l(V,k)}releaseCompletionItems(k){this.e.get(k)?.dispose(),this.e.delete(k),this.d.delete(k)}l(k,$,W,V){const ee=this.e.get($[0]);if(!ee)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(k.command,ee),Ie={x:$,a:k.label,b:k.kind!==void 0?D.CompletionItemKind.from(k.kind):void 0,m:k.tags&&k.tags.map(D.CompletionItemTag.from),c:k.detail,d:typeof k.documentation>"u"?void 0:D.MarkdownString.fromStrict(k.documentation),e:k.sortText!==k.label?k.sortText:void 0,f:k.filterText!==k.label?k.filterText:void 0,g:k.preselect||void 0,i:k.keepWhitespace?1:0,k:k.commitCharacters?.join(""),l:k.additionalTextEdits&&k.additionalTextEdits.map(D.TextEdit.from),n:fe?.$ident,o:fe?.id,p:fe?.$ident?void 0:fe?.arguments};k.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ie.h=k.textEdit.newText):typeof k.insertText=="string"?Ie.h=k.insertText:k.insertText instanceof N.SnippetString&&(Ie.h=k.insertText.value,Ie.i|=4);let le;return k.textEdit?le=k.textEdit.range:k.range&&(le=k.range),N.Range.isRange(le)?Ie.j=D.Range.from(le):le&&(!W?.isEqual(le.inserting)||!V?.isEqual(le.replacing))&&(Ie.j={insert:D.Range.from(le.inserting),replace:D.Range.from(le.replacing)}),Ie}}class ue{async provideInlineCompletions(k,$,W,V){}disposeCompletions(k){}handleDidShowCompletionItem(k,$){}handlePartialAccept(k,$,W){}}class De extends ue{constructor(k,$,W,V){super(),this.f=k,this.g=$,this.h=W,this.j=V,this.d=new de,this.e=(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[E.InlineCompletionTriggerKind.Automatic]:N.InlineCompletionTriggerKind.Automatic,[E.InlineCompletionTriggerKind.Explicit]:N.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(k,$,W,V){const ee=this.g.getDocument(k),fe=D.Position.to($),Ie=await this.h.provideInlineCompletionItems(ee,fe,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:D.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[W.triggerKind]},V);if(!Ie||V.isCancellationRequested)return;const le=Array.isArray(Ie)?Ie:Ie.items,ve=this.e?Array.isArray(Ie)?[]:Ie.commands||[]:[];let Ee;return{pid:this.d.createReferenceId({dispose(){Ee?.dispose()},items:le}),items:le.map((je,it)=>{let Ge;je.command&&(Ee||(Ee=new f.DisposableStore),Ge=this.j.toInternal(je.command,Ee));const tt=je.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:je.filterText,range:je.range?D.Range.from(je.range):void 0,command:Ge,idx:it,completeBracketPairs:this.e?je.completeBracketPairs:!1}}),commands:ve.map(je=>(Ee||(Ee=new f.DisposableStore),this.j.toInternal(je,Ee)))}}disposeCompletions(k){this.d.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,$){const W=this.d.get(k)?.items[$];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W)}handlePartialAccept(k,$,W){const V=this.d.get(k)?.items[$];V&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(V,W)}}class de{constructor(){this.d=new Map,this.e=1}createReferenceId(k){const $=this.e++;return this.d.set($,k),$}disposeReferenceId(k){const $=this.d.get(k);return this.d.delete(k),$}get(k){return this.d.get(k)}}class ie{constructor(k,$){this.e=k,this.f=$,this.d=new a.Cache("SignatureHelp")}async provideSignatureHelp(k,$,W,V){const ee=this.e.getDocument(k),fe=D.Position.to($),Ie=this.g(W),le=await this.f.provideSignatureHelp(ee,fe,V,Ie);if(le){const ve=this.d.add([le]);return{...D.SignatureHelp.from(le),id:ve}}}g(k){let $;if(k.activeSignatureHelp){const W=D.SignatureHelp.to(k.activeSignatureHelp),V=this.d.get(k.activeSignatureHelp.id,0);V?($=V,$.activeSignature=W.activeSignature,$.activeParameter=W.activeParameter):$=W}return{...k,activeSignatureHelp:$}}releaseSignatureHelp(k){this.d.delete(k)}}class q{constructor(k,$,W,V,ee){this.f=k,this.g=$,this.h=W,this.j=V,this.k=ee,this.d=new a.Cache("InlayHints"),this.e=new Map}async provideInlayHints(k,$,W){const V=this.f.getDocument(k),ee=D.Range.to($),fe=await this.h.provideInlayHints(V,ee,W);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(W.isCancellationRequested)return;const Ie=this.d.add(fe);this.e.set(Ie,new f.DisposableStore);const le={hints:[],cacheId:Ie};for(let ve=0;ve<fe.length;ve++)this.l(fe[ve],ee)&&le.hints.push(this.m(fe[ve],[Ie,ve]));return this.j.trace(`[InlayHints] ${le.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),le}async resolveInlayHint(k,$){if(typeof this.h.resolveInlayHint!="function")return;const W=this.d.get(...k);if(!W)return;const V=await this.h.resolveInlayHint(W,$);if(!!V&&!!this.l(V))return this.m(V,k)}releaseHints(k){this.e.get(k)?.dispose(),this.e.delete(k),this.d.delete(k)}l(k,$){return k.label.length===0||Array.isArray(k.label)&&k.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",k),!1):!($&&!$.contains(k.position))}m(k,$){const W=this.e.get($[0]);if(!W)throw Error("DisposableStore is missing...");const V={label:"",cacheId:$,tooltip:D.MarkdownString.fromStrict(k.tooltip),position:D.Position.from(k.position),textEdits:k.textEdits&&k.textEdits.map(D.TextEdit.from),kind:k.kind&&D.InlayHintKind.from(k.kind),paddingLeft:k.paddingLeft,paddingRight:k.paddingRight};return typeof k.label=="string"?V.label=k.label:V.label=k.label.map(ee=>{const fe={label:ee.value};return fe.tooltip=D.MarkdownString.fromStrict(ee.tooltip),N.Location.isLocation(ee.location)&&(fe.location=D.location.from(ee.location)),ee.command&&(fe.command=this.g.toInternal(ee.command,W)),fe}),V}}class ce{constructor(k,$){this.e=k,this.f=$,this.d=new a.Cache("DocumentLink")}async provideLinks(k,$){const W=this.e.getDocument(k),V=await this.f.provideDocumentLinks(W,$);if(!(!Array.isArray(V)||V.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(ce.g).map(D.DocumentLink.from)};{const ee=this.d.add(V),fe={links:[],cacheId:ee};for(let Ie=0;Ie<V.length;Ie++){if(!ce.g(V[Ie]))continue;const le=D.DocumentLink.from(V[Ie]);le.cacheId=[ee,Ie],fe.links.push(le)}return fe}}}static g(k){return k.target&&k.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(k,$){if(typeof this.f.resolveDocumentLink!="function")return;const W=this.d.get(...k);if(!W)return;const V=await this.f.resolveDocumentLink(W,$);if(!(!V||!ce.g(V)))return D.DocumentLink.from(V)}releaseLinks(k){this.d.delete(k)}}class be{constructor(k,$){this.d=k,this.e=$}async provideColors(k,$){const W=this.d.getDocument(k),V=await this.e.provideDocumentColors(W,$);return Array.isArray(V)?V.map(fe=>({color:D.Color.from(fe.color),range:D.Range.from(fe.range)})):[]}async provideColorPresentations(k,$,W){const V=this.d.getDocument(k),ee=D.Range.to($.range),fe=D.Color.to($.color),Ie=await this.e.provideColorPresentations(fe,{document:V,range:ee},W);if(!!Array.isArray(Ie))return Ie.map(D.ColorPresentation.from)}}class Ae{constructor(k,$){this.d=k,this.e=$}async provideFoldingRanges(k,$,W){const V=this.d.getDocument(k),ee=await this.e.provideFoldingRanges(V,$,W);if(!!Array.isArray(ee))return ee.map(D.FoldingRange.from)}}class Ue{constructor(k,$,W){this.d=k,this.e=$,this.f=W}async provideSelectionRanges(k,$,W){const V=this.d.getDocument(k),ee=$.map(D.Position.to),fe=await this.e.provideSelectionRanges(V,ee,W);if(!(0,M.isNonEmptyArray)(fe))return[];if(fe.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ie=[];for(let le=0;le<ee.length;le++){const ve=[];Ie.push(ve);let Ee=ee[le],We=fe[le];for(;;){if(!We.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(D.SelectionRange.from(We)),!We.parent)break;Ee=We.range,We=We.parent}}return Ie}}class Ce{constructor(k,$){this.f=k,this.g=$,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(k,$,W){const V=this.f.getDocument(k),ee=D.Position.to($),fe=await this.g.prepareCallHierarchy(V,ee,W);if(!fe)return;const Ie=this.d.nextId();return this.e.set(Ie,new Map),Array.isArray(fe)?fe.map(le=>this.h(Ie,le)):[this.h(Ie,fe)]}async provideCallsTo(k,$,W){const V=this.j(k,$);if(!V)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(V,W);if(!!ee)return ee.map(fe=>({from:this.h(k,fe.from),fromRanges:fe.fromRanges.map(Ie=>D.Range.from(Ie))}))}async provideCallsFrom(k,$,W){const V=this.j(k,$);if(!V)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(V,W);if(!!ee)return ee.map(fe=>({to:this.h(k,fe.to),fromRanges:fe.fromRanges.map(Ie=>D.Range.from(Ie))}))}releaseSession(k){this.e.delete(k)}h(k,$){const W=this.e.get(k),V=D.CallHierarchyItem.from($,k,W.size.toString(36));return W.set(V._itemId,$),V}j(k,$){return this.e.get(k)?.get($)}}class Se{constructor(k,$){this.f=k,this.g=$,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(k,$,W){const V=this.f.getDocument(k),ee=D.Position.to($),fe=await this.g.prepareTypeHierarchy(V,ee,W);if(!fe)return;const Ie=this.d.nextId();return this.e.set(Ie,new Map),Array.isArray(fe)?fe.map(le=>this.h(Ie,le)):[this.h(Ie,fe)]}async provideSupertypes(k,$,W){const V=this.j(k,$);if(!V)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(V,W);if(!!ee)return ee.map(fe=>this.h(k,fe))}async provideSubtypes(k,$,W){const V=this.j(k,$);if(!V)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(V,W);if(!!ee)return ee.map(fe=>this.h(k,fe))}releaseSession(k){this.e.delete(k)}h(k,$){const W=this.e.get(k),V=D.TypeHierarchyItem.from($,k,W.size.toString(36));return W.set(V._itemId,$),V}j(k,$){return this.e.get(k)?.get($)}}class ke{constructor(k,$,W,V){this.d=k,this.e=$,this.f=W,this.g=V}async provideDocumentOnDropEdits(k,$,W,V,ee){const fe=this.e.getDocument($),Ie=D.Position.to(W),le=D.DataTransfer.toDataTransfer(V,async Ee=>(await this.d.$resolveDocumentOnDropFileData(this.g,k,Ee)).buffer),ve=await this.f.provideDocumentDropEdits(fe,Ie,le,ee);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?D.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class oe{constructor(k,$){this.adapter=k,this.extension=$}}class ae{constructor(k,$,W,V,ee,fe,Ie,le){this.g=$,this.h=W,this.j=V,this.k=ee,this.l=fe,this.m=Ie,this.n=le,this.f=new Map,this.e=k.getProxy(O.MainContext.MainThreadLanguageFeatures)}o(k){return D.DocumentSelector.from(k,this.g)}p(k){return new N.Disposable(()=>{this.f.delete(k),this.e.$unregister(k)})}q(){return ae.d++}async s(k,$,W,V,ee,fe=!1){const Ie=this.f.get(k);if(!Ie||!(Ie.adapter instanceof $))return V;const le=Date.now();fe||this.l.trace(`[${Ie.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const ve=W(Ie.adapter,Ie.extension);return Promise.resolve(ve).catch(Ee=>{(0,b.isCancellationError)(Ee)||(this.l.error(`[${Ie.extension.identifier.value}] provider FAILED`),this.l.error(Ee),this.n.onExtensionError(Ie.extension.identifier,Ee))}).finally(()=>{fe||this.l.trace(`[${Ie.extension.identifier.value}] provider DONE after ${Date.now()-le}ms`)}),w.CancellationToken.isCancellationToken(ee)?(0,R.raceCancellationError)(ve,ee):ve}t(k,$){const W=this.q();return this.f.set(W,new oe(k,$)),W}static u(k){return k.displayName||k.name}registerDocumentSymbolProvider(k,$,W,V){const ee=this.t(new i(this.h,W),k),fe=V&&V.label||ae.u(k);return this.e.$registerDocumentSymbolProvider(ee,this.o($),fe),this.p(ee)}$provideDocumentSymbols(k,$,W){return this.s(k,i,V=>V.provideDocumentSymbols(n.URI.revive($),W),void 0,W)}registerCodeLensProvider(k,$,W){const V=this.q(),ee=typeof W.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new oe(new d(this.h,this.j.converter,W),k)),this.e.$registerCodeLensSupport(V,this.o($),ee);let fe=this.p(V);if(ee!==void 0){const Ie=W.onDidChangeCodeLenses(le=>this.e.$emitCodeLensEvent(ee));fe=N.Disposable.from(fe,Ie)}return fe}$provideCodeLenses(k,$,W){return this.s(k,d,V=>V.provideCodeLenses(n.URI.revive($),W),void 0,W)}$resolveCodeLens(k,$,W){return this.s(k,d,V=>V.resolveCodeLens($,W),void 0,void 0)}$releaseCodeLenses(k,$){this.s(k,d,W=>Promise.resolve(W.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(k,$,W){const V=this.t(new l(this.h,W),k);return this.e.$registerDefinitionSupport(V,this.o($)),this.p(V)}$provideDefinition(k,$,W,V){return this.s(k,l,ee=>ee.provideDefinition(n.URI.revive($),W,V),[],V)}registerDeclarationProvider(k,$,W){const V=this.t(new o(this.h,W),k);return this.e.$registerDeclarationSupport(V,this.o($)),this.p(V)}$provideDeclaration(k,$,W,V){return this.s(k,o,ee=>ee.provideDeclaration(n.URI.revive($),W,V),[],V)}registerImplementationProvider(k,$,W){const V=this.t(new I(this.h,W),k);return this.e.$registerImplementationSupport(V,this.o($)),this.p(V)}$provideImplementation(k,$,W,V){return this.s(k,I,ee=>ee.provideImplementation(n.URI.revive($),W,V),[],V)}registerTypeDefinitionProvider(k,$,W){const V=this.t(new r(this.h,W),k);return this.e.$registerTypeDefinitionSupport(V,this.o($)),this.p(V)}$provideTypeDefinition(k,$,W,V){return this.s(k,r,ee=>ee.provideTypeDefinition(n.URI.revive($),W,V),[],V)}registerHoverProvider(k,$,W,V){const ee=this.t(new c(this.h,W),k);return this.e.$registerHoverProvider(ee,this.o($)),this.p(ee)}$provideHover(k,$,W,V){return this.s(k,c,ee=>ee.provideHover(n.URI.revive($),W,V),void 0,V)}registerEvaluatableExpressionProvider(k,$,W,V){const ee=this.t(new h(this.h,W),k);return this.e.$registerEvaluatableExpressionProvider(ee,this.o($)),this.p(ee)}$provideEvaluatableExpression(k,$,W,V){return this.s(k,h,ee=>ee.provideEvaluatableExpression(n.URI.revive($),W,V),void 0,V)}registerInlineValuesProvider(k,$,W,V){const ee=typeof W.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new y(this.h,W),k);this.e.$registerInlineValuesProvider(fe,this.o($),ee);let Ie=this.p(fe);if(ee!==void 0){const le=W.onDidChangeInlineValues(ve=>this.e.$emitInlineValuesEvent(ee));Ie=N.Disposable.from(Ie,le)}return Ie}$provideInlineValues(k,$,W,V,ee){return this.s(k,y,fe=>fe.provideInlineValues(n.URI.revive($),W,V,ee),void 0,ee)}registerDocumentHighlightProvider(k,$,W){const V=this.t(new C(this.h,W),k);return this.e.$registerDocumentHighlightProvider(V,this.o($)),this.p(V)}$provideDocumentHighlights(k,$,W,V){return this.s(k,C,ee=>ee.provideDocumentHighlights(n.URI.revive($),W,V),void 0,V)}registerLinkedEditingRangeProvider(k,$,W){const V=this.t(new H(this.h,W),k);return this.e.$registerLinkedEditingRangeProvider(V,this.o($)),this.p(V)}$provideLinkedEditingRanges(k,$,W,V){return this.s(k,H,async ee=>{const fe=await ee.provideLinkedEditingRanges(n.URI.revive($),W,V);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?ae.w(fe.wordPattern):void 0}},void 0,V)}registerReferenceProvider(k,$,W){const V=this.t(new K(this.h,W),k);return this.e.$registerReferenceSupport(V,this.o($)),this.p(V)}$provideReferences(k,$,W,V,ee){return this.s(k,K,fe=>fe.provideReferences(n.URI.revive($),W,V,ee),void 0,ee)}registerCodeActionProvider(k,$,W,V){const ee=new f.DisposableStore,fe=this.t(new Q(this.h,this.j.converter,this.k,W,this.l,k,this.m),k);return this.e.$registerQuickFixSupport(fe,this.o($),{providedKinds:V?.providedCodeActionKinds?.map(Ie=>Ie.value),documentation:V?.documentation?.map(Ie=>({kind:Ie.kind.value,command:this.j.converter.toInternal(Ie.command,ee)}))},ae.u(k),Boolean(W.resolveCodeAction)),ee.add(this.p(fe)),ee}$provideCodeActions(k,$,W,V,ee){return this.s(k,Q,fe=>fe.provideCodeActions(n.URI.revive($),W,V,ee),void 0,ee)}$resolveCodeAction(k,$,W){return this.s(k,Q,V=>V.resolveCodeAction($,W),void 0,void 0)}$releaseCodeActions(k,$){this.s(k,Q,W=>Promise.resolve(W.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(k,$,W){const V=this.t(new j(this.h,W),k);return this.e.$registerDocumentFormattingSupport(V,this.o($),k.identifier,k.displayName||k.name),this.p(V)}$provideDocumentFormattingEdits(k,$,W,V){return this.s(k,j,ee=>ee.provideDocumentFormattingEdits(n.URI.revive($),W,V),void 0,V)}registerDocumentRangeFormattingEditProvider(k,$,W){const V=this.t(new L(this.h,W),k);return this.e.$registerRangeFormattingSupport(V,this.o($),k.identifier,k.displayName||k.name),this.p(V)}$provideDocumentRangeFormattingEdits(k,$,W,V,ee){return this.s(k,L,fe=>fe.provideDocumentRangeFormattingEdits(n.URI.revive($),W,V,ee),void 0,ee)}registerOnTypeFormattingEditProvider(k,$,W,V){const ee=this.t(new g(this.h,W),k);return this.e.$registerOnTypeFormattingSupport(ee,this.o($),V,k.identifier),this.p(ee)}$provideOnTypeFormattingEdits(k,$,W,V,ee,fe){return this.s(k,g,Ie=>Ie.provideOnTypeFormattingEdits(n.URI.revive($),W,V,ee,fe),void 0,fe)}registerWorkspaceSymbolProvider(k,$){const W=this.t(new F($,this.l),k);return this.e.$registerNavigateTypeSupport(W,typeof $.resolveWorkspaceSymbol=="function"),this.p(W)}$provideWorkspaceSymbols(k,$,W){return this.s(k,F,V=>V.provideWorkspaceSymbols($,W),{symbols:[]},W)}$resolveWorkspaceSymbol(k,$,W){return this.s(k,F,V=>V.resolveWorkspaceSymbol($,W),void 0,void 0)}$releaseWorkspaceSymbols(k,$){this.s(k,F,W=>W.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(k,$,W){const V=this.t(new B(this.h,W,this.l),k);return this.e.$registerRenameSupport(V,this.o($),B.supportsResolving(W)),this.p(V)}$provideRenameEdits(k,$,W,V,ee){return this.s(k,B,fe=>fe.provideRenameEdits(n.URI.revive($),W,V,ee),void 0,ee)}$resolveRenameLocation(k,$,W,V){return this.s(k,B,ee=>ee.resolveRenameLocation(n.URI.revive($),W,V),void 0,V)}registerDocumentSemanticTokensProvider(k,$,W,V){const ee=this.t(new me(this.h,W),k),fe=typeof W.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o($),V,fe);let Ie=this.p(ee);if(fe){const le=W.onDidChangeSemanticTokens(ve=>this.e.$emitDocumentSemanticTokensEvent(fe));Ie=N.Disposable.from(Ie,le)}return Ie}$provideDocumentSemanticTokens(k,$,W,V){return this.s(k,me,ee=>ee.provideDocumentSemanticTokens(n.URI.revive($),W,V),null,V)}$releaseDocumentSemanticTokens(k,$){this.s(k,me,W=>W.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(k,$,W,V){const ee=this.t(new Z(this.h,W),k);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o($),V),this.p(ee)}$provideDocumentRangeSemanticTokens(k,$,W,V){return this.s(k,Z,ee=>ee.provideDocumentRangeSemanticTokens(n.URI.revive($),W,V),null,V)}registerCompletionItemProvider(k,$,W,V){const ee=this.t(new se(this.h,this.j.converter,W,this.m,k),k);return this.e.$registerCompletionsProvider(ee,this.o($),V,se.supportsResolving(W),`${k.identifier.value}(${V.join("")})`),this.p(ee)}$provideCompletionItems(k,$,W,V,ee){return this.s(k,se,fe=>fe.provideCompletionItems(n.URI.revive($),W,V,ee),void 0,ee)}$resolveCompletionItem(k,$,W){return this.s(k,se,V=>V.resolveCompletionItem($,W),void 0,W)}$releaseCompletionItems(k,$){this.s(k,se,W=>W.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(k,$,W){const V=new De(k,this.h,W,this.j.converter),ee=this.t(V,k);return this.e.$registerInlineCompletionsSupport(ee,this.o($),V.supportsHandleEvents),this.p(ee)}$provideInlineCompletions(k,$,W,V,ee){return this.s(k,ue,fe=>fe.provideInlineCompletions(n.URI.revive($),W,V,ee),void 0,ee)}$handleInlineCompletionDidShow(k,$,W){this.s(k,ue,async V=>{V.handleDidShowCompletionItem($,W)},void 0,void 0)}$handleInlineCompletionPartialAccept(k,$,W,V){this.s(k,ue,async ee=>{ee.handlePartialAccept($,W,V)},void 0,void 0)}$freeInlineCompletionsList(k,$){this.s(k,ue,async W=>{W.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(k,$,W,V){const ee=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,fe=this.t(new ie(this.h,W),k);return this.e.$registerSignatureHelpProvider(fe,this.o($),ee),this.p(fe)}$provideSignatureHelp(k,$,W,V,ee){return this.s(k,ie,fe=>fe.provideSignatureHelp(n.URI.revive($),W,V,ee),void 0,ee)}$releaseSignatureHelp(k,$){this.s(k,ie,W=>W.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(k,$,W){const V=typeof W.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new q(this.h,this.j.converter,W,this.l,k),k);this.e.$registerInlayHintsProvider(ee,this.o($),typeof W.resolveInlayHint=="function",V,ae.u(k));let fe=this.p(ee);if(V!==void 0){const Ie=W.onDidChangeInlayHints(le=>this.e.$emitInlayHintsEvent(V));fe=N.Disposable.from(fe,Ie)}return fe}$provideInlayHints(k,$,W,V){return this.s(k,q,ee=>ee.provideInlayHints(n.URI.revive($),W,V),void 0,V)}$resolveInlayHint(k,$,W){return this.s(k,q,V=>V.resolveInlayHint($,W),void 0,W)}$releaseInlayHints(k,$){this.s(k,q,W=>W.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(k,$,W){const V=this.t(new ce(this.h,W),k);return this.e.$registerDocumentLinkProvider(V,this.o($),typeof W.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(k,$,W){return this.s(k,ce,V=>V.provideLinks(n.URI.revive($),W),void 0,W,$.scheme==="output")}$resolveDocumentLink(k,$,W){return this.s(k,ce,V=>V.resolveLink($,W),void 0,void 0,!0)}$releaseDocumentLinks(k,$){this.s(k,ce,W=>W.releaseLinks($),void 0,void 0,!0)}registerColorProvider(k,$,W){const V=this.t(new be(this.h,W),k);return this.e.$registerDocumentColorProvider(V,this.o($)),this.p(V)}$provideDocumentColors(k,$,W){return this.s(k,be,V=>V.provideColors(n.URI.revive($),W),[],W)}$provideColorPresentations(k,$,W,V){return this.s(k,be,ee=>ee.provideColorPresentations(n.URI.revive($),W,V),void 0,V)}registerFoldingRangeProvider(k,$,W){const V=this.q(),ee=typeof W.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new oe(new Ae(this.h,W),k)),this.e.$registerFoldingRangeProvider(V,this.o($),k.identifier,ee);let fe=this.p(V);if(ee!==void 0){const Ie=W.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));fe=N.Disposable.from(fe,Ie)}return fe}$provideFoldingRanges(k,$,W,V){return this.s(k,Ae,ee=>ee.provideFoldingRanges(n.URI.revive($),W,V),void 0,V)}registerSelectionRangeProvider(k,$,W){const V=this.t(new Ue(this.h,W,this.l),k);return this.e.$registerSelectionRangeProvider(V,this.o($)),this.p(V)}$provideSelectionRanges(k,$,W,V){return this.s(k,Ue,ee=>ee.provideSelectionRanges(n.URI.revive($),W,V),[],V)}registerCallHierarchyProvider(k,$,W){const V=this.t(new Ce(this.h,W),k);return this.e.$registerCallHierarchyProvider(V,this.o($)),this.p(V)}$prepareCallHierarchy(k,$,W,V){return this.s(k,Ce,ee=>Promise.resolve(ee.prepareSession(n.URI.revive($),W,V)),void 0,V)}$provideCallHierarchyIncomingCalls(k,$,W,V){return this.s(k,Ce,ee=>ee.provideCallsTo($,W,V),void 0,V)}$provideCallHierarchyOutgoingCalls(k,$,W,V){return this.s(k,Ce,ee=>ee.provideCallsFrom($,W,V),void 0,V)}$releaseCallHierarchy(k,$){this.s(k,Ce,W=>Promise.resolve(W.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(k,$,W){const V=this.t(new Se(this.h,W),k);return this.e.$registerTypeHierarchyProvider(V,this.o($)),this.p(V)}$prepareTypeHierarchy(k,$,W,V){return this.s(k,Se,ee=>Promise.resolve(ee.prepareSession(n.URI.revive($),W,V)),void 0,V)}$provideTypeHierarchySupertypes(k,$,W,V){return this.s(k,Se,ee=>ee.provideSupertypes($,W,V),void 0,V)}$provideTypeHierarchySubtypes(k,$,W,V){return this.s(k,Se,ee=>ee.provideSubtypes($,W,V),void 0,V)}$releaseTypeHierarchy(k,$){this.s(k,Se,W=>Promise.resolve(W.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(k,$,W){const V=this.q();return this.f.set(V,new oe(new ke(this.e,this.h,W,V),k)),this.e.$registerDocumentOnDropEditProvider(V,this.o($)),this.p(V)}$provideDocumentOnDropEdits(k,$,W,V,ee,fe){return this.s(k,ke,Ie=>Promise.resolve(Ie.provideDocumentOnDropEdits($,n.URI.revive(W),V,ee,fe)),void 0,void 0)}registerDocumentPasteEditProvider(k,$,W,V){const ee=this.q();return this.f.set(ee,new oe(new _(this.e,this.h,W,ee),k)),this.e.$registerPasteEditProvider(ee,this.o($),!!W.prepareDocumentPaste,V.pasteMimeTypes),this.p(ee)}$prepareDocumentPaste(k,$,W,V,ee){return this.s(k,_,fe=>fe.prepareDocumentPaste(n.URI.revive($),W,V,ee),void 0,ee)}$providePasteEdits(k,$,W,V,ee,fe){return this.s(k,_,Ie=>Ie.providePasteEdits($,n.URI.revive(W),V,ee,fe),void 0,fe)}static w(k){return{pattern:k.source,flags:(0,S.regExpFlags)(k)}}static y(k){return{decreaseIndentPattern:ae.w(k.decreaseIndentPattern),increaseIndentPattern:ae.w(k.increaseIndentPattern),indentNextLinePattern:k.indentNextLinePattern?ae.w(k.indentNextLinePattern):void 0,unIndentedLinePattern:k.unIndentedLinePattern?ae.w(k.unIndentedLinePattern):void 0}}static z(k){return{beforeText:ae.w(k.beforeText),afterText:k.afterText?ae.w(k.afterText):void 0,previousLineText:k.previousLineText?ae.w(k.previousLineText):void 0,action:k.action}}static B(k){return k.map(ae.z)}setLanguageConfiguration(k,$,W){const{wordPattern:V}=W;if(V&&(0,S.regExpLeadsToEndlessLoop)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor($,V):this.h.setWordDefinitionFor($,void 0),W.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",k,"Do not use."),W.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",k,"Do not use.");const ee=this.q(),fe={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?ae.w(W.wordPattern):void 0,indentationRules:W.indentationRules?ae.y(W.indentationRules):void 0,onEnterRules:W.onEnterRules?ae.B(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this.e.$setLanguageConfiguration(ee,$,fe),this.p(ee)}$setWordDefinitions(k){for(const $ of k)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}ae.d=0,e.ExtHostLanguageFeatures=ae}),define(Te[220],Pe([1,0,5,8,7,29,17,6]),function(te,e,n,A,D,N,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(M,T,m,w){this.c=T,this.d=m,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=M.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(M){this.b=M}async getLanguages(){return this.b.slice(0)}async changeLanguage(M,T){await this.a.$changeLanguage(M,T);const m=this.c.getDocumentData(M);if(!m)throw new Error(`document '${M.toString()}' NOT found`);return m.document}async tokenAtPosition(M,T){const m=M.version,w=A.Position.from(T),f=await this.a.$tokensAtPosition(M.uri,w),u={type:D.StandardTokenType.Other,range:M.getWordRangeAtPosition(T)??new D.Range(T.line,T.character,T.line,T.character)};if(!f)return u;const t={range:A.Range.to(f.range),type:A.TokenType.to(f.type)};return!t.range.contains(T)||m!==M.version?u:t}createLanguageStatusItem(M,T,m){const w=this.f++,f=this.a,u=this.g,t=`${M.identifier.value}/${T}`;if(u.has(t))throw new Error(`LanguageStatusItem with id '${T}' ALREADY exists`);u.add(t);const a={selector:m,id:T,name:M.displayName??M.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const b=new O.DisposableStore,R=()=>{p?.dispose(),p=(0,E.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(w,{id:t,name:a.name??M.displayName??M.name,source:M.displayName??M.name,selector:A.DocumentSelector.from(a.selector,this.e),label:a.text,detail:a.detail??"",severity:a.severity===D.LanguageStatusSeverity.Error?N.default.Error:a.severity===D.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:a.command&&this.d.toInternal(a.command,b),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},v={dispose(){b.dispose(),p?.dispose(),f.$removeLanguageStatus(w),u.delete(t)},get id(){return a.id},get name(){return a.name},set name(i){a.name=i,R()},get selector(){return a.selector},set selector(i){a.selector=i,R()},get text(){return a.text},set text(i){a.text=i,R()},get detail(){return a.detail},set detail(i){a.detail=i,R()},get severity(){return a.severity},set severity(i){a.severity=i,R()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(i){a.accessibilityInformation=i,R()},get command(){return a.command},set command(i){a.command=i,R()},get busy(){return a.busy},set busy(i){a.busy=i,R()}};return R(),v}}e.ExtHostLanguages=S}),define(Te[78],Pe([1,0,20,10,2,3,12,5,27,18]),function(te,e,n,A,D,N,E,O,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let M=class{constructor(m,w,f){this.f=f,this.d=new Map,this.a=w.getProxy(O.MainContext.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===n.LANGUAGE_DEFAULT}getMessage(m,w){const{message:f,args:u,comment:t}=w;if(this.c)return(0,A.format2)(f,u??{});let a=f;t&&t.length>0&&(a+=`/${Array.isArray(t)?t.join(""):t}`);const p=this.d.get(m)?.contents[a];return p||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,A.format2)(p??f,u??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let w;const f=await this.g(m);if(!f){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const u=await this.a.$fetchBundleContents(f),t=JSON.parse(u);w=m.isBuiltin?t.contents?.bundle:t}catch(u){this.f.error(`Failed to load translations for ${m.identifier.value} from ${f}: ${u.message}`);return}w&&this.d.set(m.identifier.value,{contents:w,uri:f})}async g(m){if(m.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return D.URI.revive(w)}return m.l10n?D.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};M=qe([Ve(0,S.IExtHostInitDataService),Ve(1,P.IExtHostRpcService),Ve(2,E.ILogService)],M),e.ExtHostLocalizationService=M,e.IExtHostLocalizationService=(0,N.createDecorator)("IExtHostLocalizationService")}),define(Te[221],Pe([1,0,12,5,27,18,2,66]),function(te,e,n,A,D,N,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let S=class extends n.AbstractLoggerService{constructor(T,m){super(m.logLevel,m.logsLocation,m.loggers.map(w=>(0,O.revive)(w))),this.n=T.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(T,m){m?this.setLogLevel(E.URI.revive(m),T):this.setLogLevel(T)}setVisibility(T,m){super.setVisibility(T,m),this.n.$setVisibility(T,m)}m(T,m,w){return new P(this.n,T,m,w)}};S=qe([Ve(0,N.IExtHostRpcService),Ve(1,D.IExtHostInitDataService)],S),e.ExtHostLoggerService=S;class P extends n.AbstractMessageLogger{constructor(T,m,w,f){super(f?.logLevel==="always"),this.m=T,this.n=m,this.k=!1,this.l=[],this.setLevel(w),this.m.$createLogger(m,f).then(()=>{this.r(this.l),this.k=!0})}g(T,m){const w=[[T,m]];this.k?this.r(w):this.l.push(...w)}r(T){this.m.$log(this.n,T)}}}),define(Te[222],Pe([1,0,5,12,26]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function N(O){return O&&O.title}let E=class{constructor(S,P){this.b=P,this.a=S.getProxy(n.MainContext.MainThreadMessageService)}showMessage(S,P,M,T,m){const w={source:{identifier:S.identifier,label:S.displayName||S.name}};let f;typeof T=="string"||N(T)?f=[T,...m]:(w.modal=T?.modal,w.useCustom=T?.useCustom,w.detail=T?.detail,f=m),w.useCustom&&(0,D.checkProposedApiEnabled)(S,"resolvers");const u=[];for(let t=0;t<f.length;t++){const a=f[t];if(typeof a=="string")u.push({title:a,handle:t,isCloseAffordance:!1});else if(typeof a=="object"){const{title:p,isCloseAffordance:b}=a;u.push({title:p,isCloseAffordance:!!b,handle:t})}else this.b.warn("Invalid message item:",a)}return this.a.$showMessage(P,M,w,u).then(t=>{if(typeof t=="number")return f[t]})}};E=qe([Ve(1,A.ILogService)],E),e.ExtHostMessageService=E}),define(Te[223],Pe([1,0,25,4,6,28,10,9,2,54,5,38,8,7,46,197,101]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class a{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,R,v,i){this.q=v,this.r=i,this.f=new Map,this.g=new N.ResourceMap,this.h=new Map,this.j=new A.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(M.MainContext.MainThreadNotebook),this.c=b.getProxy(M.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(M.MainContext.MainThreadNotebookEditors),this.i=R.converter,R.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===13){const s=d.notebookEditor?.notebookUri,l=d.cell.handle,I=this.g.get(s)?.getCell(l);if(I)return I.apiCell}if(d&&d.$mid===14){const s=d.uri,l=this.g.get(s);if(l)return l.apiNotebook}return d}}),a.x(R)}getEditorById(b){const R=this.h.get(b);if(!R)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return R}getIdByEditor(b){for(const[R,v]of this.h)if(v.apiEditor===b)return R}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,R){const v=this.g.get(b);if(!v&&!R)throw new Error(`NO notebook document for '${b}'`);return v}static s(b,R){if(!R)return;const v=R.filenamePattern.map(i=>m.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(R.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${R.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:R.displayName,filenamePattern:v,exclusive:R.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,R,v){const i=a.a++,d=typeof v.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(i,v),this.b.$registerNotebookCellStatusBarItemProvider(i,d,R);let s;return d!==void 0&&(s=v.onDidChangeCellStatusBarItems(l=>this.b.$emitCellStatusBarEvent(d))),new w.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,d),s?.dispose()})}async createNotebookDocument(b){const R=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&m.NotebookData.from(b.content)});return S.URI.revive(R)}async openNotebookDocument(b){const R=this.g.get(b);if(R)return R.apiNotebook;const v=await this.c.$tryOpenNotebook(b),i=this.g.get(S.URI.revive(v));return(0,O.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(b,R){S.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let v;typeof R=="object"?v={position:m.ViewColumn.from(R.viewColumn),preserveFocus:R.preserveFocus,selections:R.selections&&R.selections.map(m.NotebookRange.from),pinned:typeof R.preview=="boolean"?!R.preview:void 0}:v={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,v),d=i&&this.h.get(i)?.apiEditor;if(d)return d;throw i?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,R,v,i){const d=this.f.get(b),s=S.URI.revive(R),l=this.g.get(s);if(!l||!d)return;const o=l.getCellFromIndex(v);if(!o)return;const I=await d.provideCellStatusBarItems(o.apiCell,i);if(!I)return;const r=new D.DisposableStore,c=this.p.add([r]),y=(Array.isArray(I)?I:[I]).map(C=>m.NotebookStatusBarItem.from(C,this.i,r));return{cacheId:c,items:y}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,R,v,i,d){if((0,E.isFalsyOrWhitespace)(R))throw new Error("viewType cannot be empty or just whitespace");const s=this.t++;return this.u.set(s,v),this.b.$registerNotebookSerializer(s,{id:b.identifier,location:b.extensionLocation},R,m.NotebookDocumentContentOptions.from(i),a.s(b,d)),(0,D.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(s)})}async $dataToNotebook(b,R,v){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const d=await i.deserializeNotebook(R.buffer,v);return new f.SerializableObjectWithBuffers(m.NotebookData.from(d))}async $notebookToData(b,R,v){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const d=await i.serializeNotebook(m.NotebookData.to(R.value),v);return n.VSBuffer.wrap(d)}w(b,R,v){if(this.h.has(R))throw new Error(`editor with id ALREADY EXSIST: ${R}`);const i=new t.ExtHostNotebookEditor(R,this.d,b,v.visibleRanges.map(m.NotebookRange.to),v.selections.map(m.NotebookRange.to),typeof v.viewColumn=="number"?m.ViewColumn.to(v.viewColumn):void 0);this.h.set(R,i)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const v of b.value.removedDocuments){const i=S.URI.revive(v),d=this.g.get(i);d&&(d.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(s=>s.document.uri)}),this.n.fire(d.apiNotebook));for(const s of this.h.values())s.notebookData.uri.toString()===i.toString()&&this.h.delete(s.id)}if(b.value.addedDocuments){const v=[];for(const i of b.value.addedDocuments){const d=S.URI.revive(i.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const s=new u.ExtHostNotebookDocument(this.c,this.q,this.r,d,i);v.push(...i.cells.map(l=>u.ExtHostCell.asModelAddData(s.apiNotebook,l))),this.g.get(d)?.dispose(),this.g.set(d,s),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(s.apiNotebook)}}if(b.value.addedEditors)for(const v of b.value.addedEditors){if(this.h.has(v.id))return;const i=S.URI.revive(v.documentUri),d=this.g.get(i);d&&this.w(d,v.id,v)}const R=[];if(b.value.removedEditors)for(const v of b.value.removedEditors){const i=this.h.get(v);i&&(this.h.delete(v),this.k?.id===i.id&&(this.k=void 0),R.push(i))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const v=new Set;this.l.forEach(i=>v.add(i.id));for(const i of this.h.values()){const d=v.has(i.id);i._acceptVisibility(d)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.h.get(b.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${b.value.newActiveEditor}`),this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const R=T.ApiCommandArgument.String.with("notebookType","A notebook type"),v=new T.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[R,new T.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>n.VSBuffer.wrap(d))],new T.ApiCommandResult("Notebook Data",d=>m.NotebookData.to(d.value))),i=new T.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[R,new T.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new f.SerializableObjectWithBuffers(m.NotebookData.from(d)))],new T.ApiCommandResult("Bytes",d=>d.buffer));b.registerApiCommand(v),b.registerApiCommand(i)}}a.a=0,e.ExtHostNotebookController=a}),define(Te[224],Pe([1,0,16,17,21,4,6,28,2,24,12,54,5,38,8,7,73,187,26,46]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t,a,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let R=class{constructor(o,I,r,c,h){this.k=I,this.l=r,this.m=c,this.n=h,this.b=new O.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new T.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new N.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=o.getProxy(m.MainContext.MainThreadNotebookKernels);const y=new w.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new w.ApiCommandArgument("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const H=this.l.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:H}}else if(C&&"notebookEditor"in C){const H=this.l.getIdByEditor(C.notebookEditor);if(H===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:H}}return C})],w.ApiCommandResult.Void);this.m.registerApiCommand(y)}createNotebookController(o,I,r,c,h,y){for(const ue of this.h.values())if(ue.controller.id===I&&P.ExtensionIdentifier.equals(o.identifier,ue.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const C=this.i++,H=this;this.n.trace(`NotebookController[${C}], CREATED by ${o.identifier.value}, ${I}`);const K=()=>console.warn(`NO execute handler from notebook controller '${g.id}' of extension: '${o.identifier}'`);let Q=!1;const _=new E.DisposableStore,j=new N.Emitter,L=new N.Emitter,g={id:s(o.identifier,I),notebookType:r,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:c||o.identifier.value,preloads:y?y.map(f.NotebookRendererScript.from):[]};let F=h??K,B;this.a.$addKernel(C,g).catch(ue=>{console.log(ue),Q=!0});let Y=0;const me=()=>{if(Q)return;const ue=++Y;Promise.resolve().then(()=>{ue===Y&&this.a.$updateKernel(C,g)})},Z=new O.ResourceMap,se={get id(){return I},get notebookType(){return g.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return g.label},set label(ue){g.label=ue??o.displayName??o.name,me()},get detail(){return g.detail??""},set detail(ue){g.detail=ue,me()},get description(){return g.description??""},set description(ue){g.description=ue,me()},get kind(){return(0,p.checkProposedApiEnabled)(o,"notebookControllerKind"),g.kind??""},set kind(ue){(0,p.checkProposedApiEnabled)(o,"notebookControllerKind"),g.kind=ue,me()},get supportedLanguages(){return g.supportedLanguages},set supportedLanguages(ue){g.supportedLanguages=ue,me()},get supportsExecutionOrder(){return g.supportsExecutionOrder??!1},set supportsExecutionOrder(ue){g.supportsExecutionOrder=ue,me()},get rendererScripts(){return g.preloads?g.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return F},set executeHandler(ue){F=ue??K},get interruptHandler(){return B},set interruptHandler(ue){B=ue,g.supportsInterrupt=Boolean(ue),me()},createNotebookCellExecution(ue){if(Q)throw new Error("notebook controller is DISPOSED");if(!Z.has(ue.notebook.uri))throw H.n.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ue.notebook.uri.toString()}`);return H._createNotebookCellExecution(ue,s(o.identifier,this.id))},dispose:()=>{Q||(this.n.trace(`NotebookController[${C}], DISPOSED`),Q=!0,this.h.delete(C),_.dispose(),j.dispose(),L.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(ue,De){De===u.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(o,"notebookControllerAffinityHidden"),H.a.$updateNotebookPriority(C,ue.uri,De)},onDidReceiveMessage:L.event,postMessage(ue,De){return(0,p.checkProposedApiEnabled)(o,"notebookMessaging"),H.a.$postMessage(C,De&&H.l.getIdByEditor(De),ue)},asWebviewUri(ue){return(0,p.checkProposedApiEnabled)(o,"notebookMessaging"),(0,t.asWebviewUri)(ue,H.k.remote)}};return this.h.set(C,{extensionId:o.identifier,controller:se,onDidReceiveMessage:L,onDidChangeSelection:j,associatedNotebooks:Z}),se}getIdByController(o){for(const[I,r]of this.h)if(r.controller===o)return s(r.extensionId,o.id);return null}createNotebookControllerDetectionTask(o,I){const r=this.d++,c=this;this.n.trace(`NotebookControllerDetectionTask[${r}], CREATED by ${o.identifier.value}`),this.a.$addKernelDetectionTask(r,I);const h={dispose:()=>{this.c.delete(r),c.a.$removeKernelDetectionTask(r)}};return this.c.set(r,h),h}registerKernelSourceActionProvider(o,I,r){const c=this.f++,h=typeof r.onDidChangeNotebookKernelSourceActions=="function"?c:void 0,y=this;this.e.set(c,r),this.n.trace(`NotebookKernelSourceActionProvider[${c}], CREATED by ${o.identifier.value}`),this.a.$addKernelSourceActionProvider(c,c,I);let C;return h!==void 0&&(C=r.onDidChangeNotebookKernelSourceActions(H=>this.a.$emitNotebookKernelSourceActionsChangeEvent(h))),{dispose:()=>{this.e.delete(c),y.a.$removeKernelSourceActionProvider(c,c),C?.dispose()}}}async $provideKernelSourceActions(o,I){const r=this.e.get(o);if(r){const c=new E.DisposableStore;return this.g.add([c]),(await r.provideNotebookKernelSourceActions(I)??[]).map(y=>f.NotebookKernelSourceAction.from(y,this.m.converter,c))}return[]}$acceptNotebookAssociation(o,I,r){const c=this.h.get(o);if(c){const h=this.l.getNotebookDocument(S.URI.revive(I));r?c.associatedNotebooks.set(h.uri,!0):c.associatedNotebooks.delete(h.uri),this.n.trace(`NotebookController[${o}] ASSOCIATE notebook`,h.uri.toString(),r),c.onDidChangeSelection.fire({selected:r,notebook:h.apiNotebook})}}async $executeCells(o,I,r){const c=this.h.get(o);if(!c)return;const h=this.l.getNotebookDocument(S.URI.revive(I)),y=[];for(const C of r){const H=h.getCell(C);H&&y.push(H.apiCell)}try{this.n.trace(`NotebookController[${o}] EXECUTE cells`,h.uri.toString(),y.length),await c.controller.executeHandler.call(c.controller,y,h.apiNotebook,c.controller)}catch(C){this.n.error(`NotebookController[${o}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(o,I,r){const c=this.h.get(o);if(!c)return;const h=this.l.getNotebookDocument(S.URI.revive(I));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,h.apiNotebook);else for(const y of r){const C=h.getCell(y);C&&this.b.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,I,r){const c=this.h.get(o);if(!c)return;const h=this.l.getEditorById(I);c.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:r}))}$cellExecutionChanged(o,I,r){const h=this.l.getNotebookDocument(S.URI.revive(o)).getCell(I);if(h){const y=r?f.NotebookCellExecutionState.to(r):u.NotebookCellExecutionState.Idle;y!==void 0&&this.j.fire({cell:h.apiCell,state:y})}}_createNotebookCellExecution(o,I){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this.l.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!c)throw new Error("invalid cell");if(this.b.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const h=new i(I,c,this.a);this.b.set(c.uri,h);const y=h.onDidChangeState(()=>{h.state===v.Resolved&&(h.dispose(),y.dispose(),this.b.delete(c.uri))});return h.asApiObject()}};R=qe([Ve(4,M.ILogService)],R),e.ExtHostNotebookKernels=R;var v;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(v||(v={}));class i extends E.Disposable{get state(){return this.f}constructor(o,I,r){super(),this.j=I,this.k=r,this.b=i.a++,this.c=new N.Emitter,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new D.CancellationTokenSource),this.h=new d(10,c=>this.m(c)),this.i=I.internalMetadata.executionOrder,this.k.$createExecution(this.b,o,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(o){await this.h.addItem(o)}async m(o){const I=Array.isArray(o)?o:[o];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(I))}n(){if(this.f===v.Init)throw new Error("Must call start before modifying cell output");if(this.f===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(o){let I=this.j;if(o&&(I=this.j.notebook.getCellFromApiCell(o)),!I)throw new Error("INVALID cell");return I.handle}s(o){return o.map(I=>{const r=u.NotebookCellOutput.ensureUniqueMimeTypes(I.items,!0);return r===I.items?f.NotebookCellOutput.from(I):f.NotebookCellOutput.from({items:r,id:I.id,metadata:I.metadata})})}async t(o,I,r){const c=this.r(I),h=this.s((0,n.asArray)(o));return this.l({editType:a.CellExecutionUpdateType.Output,cellHandle:c,append:r,outputs:h})}async w(o,I,r){return o=u.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(o),!0),this.l({editType:a.CellExecutionUpdateType.OutputItems,items:o.map(f.NotebookCellOutputItem.from),outputId:I.id,append:r})}asApiObject(){const o=this;return Object.freeze({get token(){return o.g.token},get cell(){return o.j.apiCell},get executionOrder(){return o.i},set executionOrder(r){o.i=r,o.m([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:o.i}])},start(r){if(o.f===v.Resolved||o.f===v.Started)throw new Error("Cannot call start again");o.f=v.Started,o.c.fire(),o.m({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:r})},end(r,c){if(o.f===v.Resolved)throw new Error("Cannot call resolve twice");o.f=v.Resolved,o.c.fire(),o.h.flush(),o.k.$completeExecution(o.b,new b.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:r}))},clearOutput(r){return o.n(),o.t([],r,!1)},appendOutput(r,c){return o.n(),o.t(r,c,!0)},replaceOutput(r,c){return o.n(),o.t(r,c,!1)},appendOutputItems(r,c){return o.n(),o.w(r,c,!0)},replaceOutputItems(r,c){return o.n(),o.w(r,c,!1)}})}}i.a=0;class d{constructor(o,I){this.d=o,this.e=I,this.a=[],this.b=Date.now()}addItem(o){return this.a.push(o),this.c||(this.c=new A.DeferredPromise,this.b=Date.now(),(0,A.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const o=this.c;this.c=void 0;const I=this.a;return this.a=[],this.e(I).finally(()=>o.complete())}}function s(l,o){return`${l.value}/${o}`}e.createKernelId=s}),define(Te[225],Pe([1,0,4,5,101]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class N{constructor(O,S){this.c=S,this.a=new Map,this.b=O.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(O,S,P){const M=this.c.getEditorById(O);this.a.get(S)?.fire({editor:M.apiEditor,message:P})}createRendererMessaging(O,S){if(!O.contributes?.notebookRenderer?.some(M=>M.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(M,T,m)=>this.d(S).event(M,T,m),postMessage:(M,T)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(M)&&([M,T]=[T,M]);const m=T&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(T);return this.b.$postMessage(m?.id,S,M)}}}d(O){let S=this.a.get(O);return S||(S=new n.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(O)}}),this.a.set(O,S),S)}}e.ExtHostNotebookRenderers=N}),define(Te[226],Pe([1,0,6,9,2,26,5]),function(te,e,n,A,D,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class O{constructor(P){this.b=new Map,this.a=P.getProxy(E.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(P,M,T){if((0,N.checkProposedApiEnabled)(P,"profileContentHandlers"),this.b.has(M))throw new Error(`Handler with id '${M}' already registered`);return this.b.set(M,T),this.a.$registerProfileContentHandler(M,T.name,T.description,P.identifier.value),(0,n.toDisposable)(()=>{this.b.delete(M),this.a.$unregisterProfileContentHandler(M)})}async $saveProfile(P,M,T,m){const w=this.b.get(P);if(!w)throw new Error(`Unknown handler with id: ${P}`);return w.saveProfile(M,T,m)}async $readProfile(P,M,T){const m=this.b.get(P);if(!m)throw new Error(`Unknown handler with id: ${P}`);return m.readProfile((0,A.isString)(M)?M:D.URI.revive(M),T)}}e.ExtHostProfileContentHandlers=O}),define(Te[227],Pe([1,0,2,5,17,8]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class E{constructor(S,P){this.d=P,this.c=new Map,this.b=S.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(S,P,M){const T=n.URI.revive(P),m=this.c.get(S);return m?(0,D.asPromise)(()=>m.provideOriginalResource(T,M)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(S,P,M,T){const m=E.a++;return this.c.set(m,P),this.b.$registerQuickDiffProvider(m,N.DocumentSelector.from(S,this.d),M,T),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}E.a=0,e.ExtHostQuickDiff=E}),define(Te[228],Pe([1,0,21,4,6,5,2,7,11,16,29,39,26,8]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function f(u,t,a){const p=u.getProxy(N.MainContext.MainThreadQuickOpen);class b{constructor(r,c){this.e=new Map,this.f=0,this.a=r,this.b=c}showQuickPick(r,c,h,y=n.CancellationToken.None){this.c=void 0;const C=Promise.resolve(c),H=++this.f,K=p.$show(H,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},y),Q={},_=K.then(()=>Q);return Promise.race([_,C]).then(j=>{if(j===Q)return;const L=(0,m.isProposedApiEnabled)(r,"quickPickItemTooltip");return C.then(g=>{const F=[];for(let B=0;B<g.length;B++){const Y=g[B];typeof Y=="string"?F.push({label:Y,handle:B}):Y.kind===O.QuickPickItemKind.Separator?F.push({type:"separator",label:Y.label}):(Y.tooltip&&!L&&console.warn(`Extension '${r.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${r.identifier.value}`),F.push({label:Y.label,description:Y.description,detail:Y.detail,picked:Y.picked,alwaysShow:Y.alwaysShow,tooltip:L?w.MarkdownString.fromStrict(Y.tooltip):void 0,handle:B}))}return h&&typeof h.onDidSelectItem=="function"&&(this.c=B=>{h.onDidSelectItem(g[B])}),p.$setItems(H,F),K.then(B=>{if(typeof B=="number")return g[B];if(Array.isArray(B))return B.map(Y=>g[Y])})})}).then(void 0,j=>{if(!(0,S.isCancellationError)(j))return p.$setError(H,j),Promise.reject(j)})}$onItemSelected(r){this.c?.(r)}showInput(r,c=n.CancellationToken.None){return this.d=r?.validateInput,p.$input(r,typeof this.d=="function",c).then(void 0,h=>{if(!(0,S.isCancellationError)(h))return Promise.reject(h)})}async $validateInput(r){if(!this.d)return;const c=await this.d(r);if(!c||typeof c=="string")return c;let h;switch(c.severity){case O.InputBoxValidationSeverity.Info:h=M.default.Info;break;case O.InputBoxValidationSeverity.Warning:h=M.default.Warning;break;case O.InputBoxValidationSeverity.Error:h=M.default.Error;break;default:h=c.message?M.default.Error:M.default.Ignore;break}return{content:c.message,severity:h}}async showWorkspaceFolderPick(r,c=n.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!h)return;const y=await this.a.getWorkspaceFolders2();if(!!y)return y.find(C=>C.uri.toString()===h.uri.toString())}createQuickPick(r){const c=new l(r,()=>this.e.delete(c._id));return this.e.set(c._id,c),c}createInputBox(r){const c=new o(r,()=>this.e.delete(c._id));return this.e.set(c._id,c),c}$onDidChangeValue(r,c){this.e.get(r)?._fireDidChangeValue(c)}$onDidAccept(r){this.e.get(r)?._fireDidAccept()}$onDidChangeActive(r,c){const h=this.e.get(r);h instanceof l&&h._fireDidChangeActive(c)}$onDidChangeSelection(r,c){const h=this.e.get(r);h instanceof l&&h._fireDidChangeSelection(c)}$onDidTriggerButton(r,c){this.e.get(r)?._fireDidTriggerButton(c)}$onDidTriggerItemButton(r,c,h){const y=this.e.get(r);y instanceof l&&y._fireDidTriggerItemButton(c,h)}$onDidHide(r){this.e.get(r)?._fireDidHide()}}class R{constructor(r,c){this.x=r,this.y=c,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new A.Emitter,this.q=new A.Emitter,this.r=new A.Emitter,this.s=new A.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(r){this.b=r,this.z({title:r})}get step(){return this.c}set step(r){this.c=r,this.z({step:r})}get totalSteps(){return this.d}set totalSteps(r){this.d=r,this.z({totalSteps:r})}get enabled(){return this.g}set enabled(r){this.g=r,this.z({enabled:r})}get busy(){return this.j}set busy(r){this.j=r,this.z({busy:r})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(r){this.k=r,this.z({ignoreFocusOut:r})}get value(){return this.l}set value(r){this.l=r,this.z({value:r})}get placeholder(){return this.m}set placeholder(r){this.m=r,this.z({placeholder:r})}get buttons(){return this.n}set buttons(r){this.n=r.slice(),this.o.clear(),r.forEach((c,h)=>{const y=c===O.QuickInputButtons.Back?-1:h;this.o.set(y,c)}),this.z({buttons:r.map((c,h)=>({...s(c),tooltip:c.tooltip,handle:c===O.QuickInputButtons.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(r){this.l=r,this.q.fire(r)}_fireDidTriggerButton(r){const c=this.o.get(r);c&&this.r.fire(c)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,D.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),p.$dispose(this._id))}z(r){if(!this.v){for(const c of Object.keys(r)){const h=r[c];this.u[c]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){p.$createOrUpdate(this.u),this.u={id:this._id}}}R.a=1;function v(I){if(I instanceof O.ThemeIcon)return{id:I.id};const r=d(I),c=i(I);return{dark:typeof r=="string"?E.URI.file(r):r,light:typeof c=="string"?E.URI.file(c):c}}function i(I){return typeof I=="object"&&"light"in I?I.light:I}function d(I){return typeof I=="object"&&"dark"in I?I.dark:I}function s(I){const r=v(I.iconPath);let c,h;return"id"in r?h=T.ThemeIcon.asClassName(r):c=r,{iconPath:c,iconClass:h}}class l extends R{constructor(r,c){super(r.identifier,c),this.O=r,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new A.Emitter,this.L=[],this.M=new A.Emitter,this.N=new A.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(r){this.B=r.slice(),this.C.clear(),this.D.clear(),r.forEach((y,C)=>{this.C.set(C,y),this.D.set(y,C)});const c=(0,m.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),h=[];for(let y=0;y<r.length;y++){const C=r[y];C.kind===O.QuickPickItemKind.Separator?h.push({type:"separator",label:C.label}):(C.tooltip&&!c&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),h.push({handle:y,label:C.label,description:C.description,detail:C.detail,picked:C.picked,alwaysShow:C.alwaysShow,tooltip:c?w.MarkdownString.fromStrict(C.tooltip):void 0,buttons:C.buttons?.map((H,K)=>({...s(H),tooltip:H.tooltip,handle:K}))}))}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(r){this.E=r,this.z({canSelectMany:r})}get matchOnDescription(){return this.F}set matchOnDescription(r){this.F=r,this.z({matchOnDescription:r})}get matchOnDetail(){return this.G}set matchOnDetail(r){this.G=r,this.z({matchOnDetail:r})}get sortByLabel(){return this.H}set sortByLabel(r){this.H=r,this.z({sortByLabel:r})}get keepScrollPosition(){return this.I}set keepScrollPosition(r){this.I=r,this.z({keepScrollPosition:r})}get activeItems(){return this.J}set activeItems(r){this.J=r.filter(c=>this.D.has(c)),this.z({activeItems:this.J.map(c=>this.D.get(c))})}get selectedItems(){return this.L}set selectedItems(r){this.L=r.filter(c=>this.D.has(c)),this.z({selectedItems:this.L.map(c=>this.D.get(c))})}_fireDidChangeActive(r){const c=(0,P.coalesce)(r.map(h=>this.C.get(h)));this.J=c,this.K.fire(c)}_fireDidChangeSelection(r){const c=(0,P.coalesce)(r.map(h=>this.C.get(h)));this.L=c,this.M.fire(c)}_fireDidTriggerItemButton(r,c){const h=this.C.get(r);if(!h||!h.buttons||!h.buttons.length)return;const y=h.buttons[c];y&&this.N.fire({button:y,item:h})}}class o extends R{constructor(r,c){super(r.identifier,c),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(r){this.B=r,this.z({password:r})}get prompt(){return this.C}set prompt(r){this.C=r,this.z({prompt:r})}get valueSelection(){return this.D}set valueSelection(r){this.D=r,this.z({valueSelection:r})}get validationMessage(){return this.E}set validationMessage(r){this.E=r,r?typeof r=="string"?this.z({validationMessage:r,severity:M.default.Error}):this.z({validationMessage:r.message,severity:r.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new b(t,a)}e.createExtHostQuickOpen=f});var Fe=this&&this.__classPrivateFieldGet||function(te,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!A:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(te):A?A.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,A,D){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n};define(Te[229],Pe([1,0,2,4,64,6,17,5,16,124,12,24,39,8,26]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f){"use strict";var u,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(c){if(c)return typeof c.iconPath=="string"?n.URI.file(c.iconPath):n.URI.isUri(c.iconPath)||m.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function p(c,h){if(!c.iconPath&&!h.iconPath)return 0;if(c.iconPath){if(!h.iconPath)return 1}else return-1;const y=typeof c.iconPath=="string"?c.iconPath:n.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,C=typeof h.iconPath=="string"?h.iconPath:n.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,P.comparePaths)(y,C)}function b(c,h){let y=0;if(c.strikeThrough!==h.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==h.faded)return c.faded?1:-1;if(c.tooltip!==h.tooltip)return(c.tooltip||"").localeCompare(h.tooltip||"");if(y=p(c,h),y!==0)return y;if(c.light&&h.light)y=p(c.light,h.light);else{if(c.light)return 1;if(h.light)return-1}if(y!==0)return y;if(c.dark&&h.dark)y=p(c.dark,h.dark);else{if(c.dark)return 1;if(h.dark)return-1}return y}function R(c,h){if(c.command!==h.command)return c.command<h.command?-1:1;if(c.title!==h.title)return c.title<h.title?-1:1;if(c.tooltip!==h.tooltip){if(c.tooltip!==void 0&&h.tooltip!==void 0)return c.tooltip<h.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(c.arguments===h.arguments)return 0;if(c.arguments)if(h.arguments){if(c.arguments.length!==h.arguments.length)return c.arguments.length-h.arguments.length}else return 1;else return-1;for(let y=0;y<c.arguments.length;y++){const C=c.arguments[y],H=h.arguments[y];if(C!==H)return C<H?-1:1}return 0}function v(c,h){let y=(0,P.comparePaths)(c.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(y!==0)return y;if(c.command&&h.command)y=R(c.command,h.command);else{if(c.command)return 1;if(h.command)return-1}if(y!==0)return y;if(c.decorations&&h.decorations)y=b(c.decorations,h.decorations);else{if(c.decorations)return 1;if(h.decorations)return-1}return y}function i(c,h){for(let y=0;y<c.length;y++)if(c[y]!==h[y])return!1;return!0}function d(c,h){return c.command===h.command&&c.title===h.title&&c.tooltip===h.tooltip&&(c.arguments&&h.arguments?i(c.arguments,h.arguments):c.arguments===h.arguments)}function s(c,h){return(0,S.equals)(c,h,d)}class l{get value(){return this.d}set value(h){h=h??"",Fe(this,u,"f").$setInputBoxValue(this.l,h),this.m(h)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(h){Fe(this,u,"f").$setInputBoxPlaceholder(this.l,h),this.f=h}get validateInput(){return(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(h){if((0,f.checkProposedApiEnabled)(this.k,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=h,Fe(this,u,"f").$setValidationProviderIsEnabled(this.l,!!h)}get enabled(){return this.h}set enabled(h){h=!!h,this.h!==h&&(this.h=h,Fe(this,u,"f").$setInputBoxEnablement(this.l,h))}get visible(){return this.j}set visible(h){h=!!h,this.j!==h&&(this.j=h,Fe(this,u,"f").$setInputBoxVisibility(this.l,h))}constructor(h,y,C){this.k=h,this.l=C,u.set(this,void 0),this.d="",this.e=new A.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,u,y,"f")}showValidationMessage(h,y){(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),Fe(this,u,"f").$showValidationMessage(this.l,h,y)}$onInputBoxValueChange(h){this.m(h)}m(h){this.d=h,this.e.fire(h)}}e.ExtHostSCMInputBox=l,u=new WeakMap;class o{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(h){this.v=h,this.q.$updateGroupLabel(this.t,this.handle,h)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(h){this.p=h,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(h){this.f=[...h],this.k.fire()}constructor(h,y,C,H,K){this.q=h,this.s=y,this.t=C,this.u=H,this.v=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new A.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new A.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=o.d++}getResourceState(h){return this.g.get(h)}$executeResourceCommand(h,y){const C=this.h.get(h);return C?(0,E.asPromise)(()=>this.s.executeCommand(C.command,...C.arguments||[],y)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this.f].sort(v),C=(0,S.sortedDiff)(this.o,h,v).map(Q=>{const _=Q.toInsert.map(j=>{const L=this.e++;this.g.set(L,j);const g=j.resourceUri;let F;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const q=new N.DisposableStore;F=this.s.converter.toInternal(j.command,q),this.j.set(L,q)}else this.h.set(L,j.command);const B=a(j.decorations),Y=j.decorations&&a(j.decorations.light)||B,me=j.decorations&&a(j.decorations.dark)||B,Z=[Y,me],se=j.decorations&&j.decorations.tooltip||"",ue=j.decorations&&!!j.decorations.strikeThrough,De=j.decorations&&!!j.decorations.faded,de=j.contextValue||"";return{rawResource:[L,g,Z,se,ue,De,de,F],handle:L}});return{start:Q.start,deleteCount:Q.deleteCount,toInsert:_}}),H=C.map(({start:Q,deleteCount:_,toInsert:j})=>[Q,_,j.map(L=>L.rawResource)]),K=C.reverse();for(const{start:Q,deleteCount:_,toInsert:j}of K){const L=j.map(F=>F.handle),g=this.n.splice(Q,_,...L);for(const F of g)this.g.delete(F),this.h.delete(F),this.j.get(F)?.dispose(),this.j.delete(F)}return this.o=h,H}dispose(){this.l=!0,this.m.fire()}}o.d=0;class I{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(h){this.g!==h&&(this.g=h,Fe(this,t,"f").$updateSourceControl(this.t,{count:h}))}get quickDiffProvider(){return this.h}set quickDiffProvider(h){this.h=h,h?.label&&(0,f.checkProposedApiEnabled)(this.u,"quickDiffProvider"),Fe(this,t,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!h,quickDiffLabel:h?.label})}get commitTemplate(){return this.j}set commitTemplate(h){h!==this.j&&(this.j=h,Fe(this,t,"f").$updateSourceControl(this.t,{commitTemplate:h}))}get acceptInputCommand(){return this.l}set acceptInputCommand(h){this.k.value=new N.DisposableStore,this.l=h;const y=this.v.converter.toInternal(h,this.k.value);Fe(this,t,"f").$updateSourceControl(this.t,{acceptInputCommand:y})}get actionButton(){return(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(h){(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new N.DisposableStore,this.n=h;const y=h!==void 0?{command:this.v.converter.toInternal(h.command,this.m.value),secondaryCommands:h.secondaryCommands?.map(C=>C.map(H=>this.v.converter.toInternal(H,this.m.value))),description:h.description,enabled:h.enabled}:void 0;Fe(this,t,"f").$updateSourceControl(this.t,{actionButton:y??null})}get statusBarCommands(){return this.p}set statusBarCommands(h){if(this.p&&h&&s(this.p,h))return;this.o.value=new N.DisposableStore,this.p=h;const y=(h||[]).map(C=>this.v.converter.toInternal(C,this.o.value));Fe(this,t,"f").$updateSourceControl(this.t,{statusBarCommands:y})}get selected(){return this.q}constructor(h,y,C,H,K,Q){this.u=h,this.v=C,this.w=H,this.x=K,this.y=Q,t.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new N.MutableDisposable,this.l=void 0,this.m=new N.MutableDisposable,this.o=new N.MutableDisposable,this.p=void 0,this.q=!1,this.s=new A.Emitter,this.onDidChangeSelection=this.s.event,this.t=I.d++,this.z=new Map,this.A=new Set,Je(this,t,y,"f"),this.f=new l(h,Fe(this,t,"f"),this.t),Fe(this,t,"f").$registerSourceControl(this.t,H,K,Q)}createResourceGroup(h,y){const C=new o(Fe(this,t,"f"),this.v,this.t,h,y),H=A.Event.once(C.onDidDispose)(()=>this.z.delete(C));return this.z.set(C,H),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const h=[],y=[];for(const[C,H]of this.z){H.dispose();const K=C.onDidUpdateResourceStates(()=>{this.A.add(C),this.eventuallyUpdateResourceStates()});A.Event.once(C.onDidDispose)(()=>{this.A.delete(C),K.dispose(),this.e.delete(C.handle),Fe(this,t,"f").$unregisterGroup(this.t,C.handle)}),h.push([C.handle,C.id,C.label,C.features]);const Q=C._takeResourceStateSnapshot();Q.length>0&&y.push([C.handle,Q]),this.e.set(C.handle,C)}Fe(this,t,"f").$registerGroups(this.t,h,y),this.z.clear()}eventuallyUpdateResourceStates(){const h=[];this.A.forEach(y=>{const C=y._takeResourceStateSnapshot();C.length!==0&&h.push([y.handle,C])}),h.length>0&&Fe(this,t,"f").$spliceResourceStates(this.t,h),this.A.clear()}getResourceGroup(h){return this.e.get(h)}setSelectionState(h){this.q=h,this.s.fire(h)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(h=>h.dispose()),Fe(this,t,"f").$unregisterSourceControl(this.t)}}t=new WeakMap,I.d=0,qe([(0,D.debounce)(100)],I.prototype,"eventuallyAddResourceGroups",null),qe([(0,D.debounce)(100)],I.prototype,"eventuallyUpdateResourceStates",null);let r=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(h,y,C){this.l=y,this.m=C,this.g=new Map,this.h=new T.ExtensionIdentifierMap,this.j=new A.Emitter,this.e=h.getProxy(O.MainContext.MainThreadSCM),this.f=h.getProxy(O.MainContext.MainThreadTelemetry),y.registerArgumentProcessor({processArgument:H=>{if(H&&H.$mid===3){const K=this.g.get(H.sourceControlHandle);if(!K)return H;const Q=K.getResourceGroup(H.groupHandle);return Q?Q.getResourceState(H.handle):H}else if(H&&H.$mid===4){const K=this.g.get(H.sourceControlHandle);return K?K.getResourceGroup(H.groupHandle):H}else if(H&&H.$mid===5){const K=this.g.get(H.handle);return K||H}return H}})}createSourceControl(h,y,C,H){this.m.trace("ExtHostSCM#createSourceControl",h.identifier.value,y,C,H),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const K=on.d++,Q=new I(h,this.e,this.l,y,C,H);this.g.set(K,Q);const _=this.h.get(h.identifier)||[];return _.push(Q),this.h.set(h.identifier,_),Q}getLastInputBox(h){this.m.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const y=this.h.get(h.identifier),C=y&&y[y.length-1];return C&&C.inputBox}$provideOriginalResource(h,y,C){const H=n.URI.revive(y);this.m.trace("ExtHostSCM#$provideOriginalResource",h,H.toString());const K=this.g.get(h);return!K||!K.quickDiffProvider||!K.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,E.asPromise)(()=>K.quickDiffProvider.provideOriginalResource(H,C)).then(Q=>Q||null)}$onInputBoxValueChange(h,y){this.m.trace("ExtHostSCM#$onInputBoxValueChange",h);const C=this.g.get(h);return C&&C.inputBox.$onInputBoxValueChange(y),Promise.resolve(void 0)}$executeResourceCommand(h,y,C,H){this.m.trace("ExtHostSCM#$executeResourceCommand",h,y,C);const K=this.g.get(h);if(!K)return Promise.resolve(void 0);const Q=K.getResourceGroup(y);return Q?Q.$executeResourceCommand(C,H):Promise.resolve(void 0)}$validateInput(h,y,C){this.m.trace("ExtHostSCM#$validateInput",h);const H=this.g.get(h);return!H||!H.inputBox.validateInput?Promise.resolve(void 0):(0,E.asPromise)(()=>H.inputBox.validateInput(y,C)).then(K=>{if(!K)return Promise.resolve(void 0);const Q=w.MarkdownString.fromStrict(K.message);return Q?Promise.resolve([Q,K.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this.g.get(h)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=h,Promise.resolve(void 0)}};r.d=0,r=qe([Ve(2,M.ILogService)],r),e.ExtHostSCM=r}),define(Te[79],Pe([1,0,5,4,3]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class N{constructor(O){this.b=new A.Emitter,this.onDidChangePassword=this.b.event,this.a=O.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,S){return this.a.$getPassword(O,S)}store(O,S,P){return this.a.$setPassword(O,S,P)}delete(O,S){return this.a.$deletePassword(O,S)}}e.ExtHostSecretState=N,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,A,D){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Fe=this&&this.__classPrivateFieldGet||function(te,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!A:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(te):A?A.value:e.get(te)};define(Te[230],Pe([1,0,7,5,143,6,8,9]),function(te,e,n,A,D,N,E,O){"use strict";var S,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class M{constructor(f,u,t,a,p=n.StatusBarAlignment.Left,b){S.set(this,void 0),P.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new N.DisposableStore,Je(this,S,f,"f"),Je(this,P,u,"f"),this.c=M.a++,this.e=t,this.f=a,this.g=p,this.h=this.u(b)}u(f){if(!!(0,O.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(f){this.k=f,this.v()}set name(f){this.m=f,this.v()}set tooltip(f){this.l=f,this.v()}set color(f){this.n=f,this.v()}set backgroundColor(f){f&&!M.b.has(f.id)&&(f=void 0),this.o=f,this.v()}set command(f){this.r?.fromApi!==f&&(this.p&&this.q.add(this.p),this.p=new N.DisposableStore,typeof f=="string"?this.r={fromApi:f,internal:Fe(this,P,"f").toInternal({title:"",command:f},this.p)}:f?this.r={fromApi:f,internal:Fe(this,P,"f").toInternal(f,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(f){this.t=f,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Fe(this,S,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let u;this.m?u=this.m:u=(0,D.localize)(0,null,this.e.displayName||this.e.name);let t=this.n;this.o&&(t=M.b.get(this.o.id));const a=E.MarkdownString.fromStrict(this.l);Fe(this,S,"f").$setEntry(this.c,f,u,this.k,a,this.r?.internal,t,this.o,this.g===n.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}S=new WeakMap,P=new WeakMap,M.a=0,M.b=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=M;class T{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,D.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const u={message:f};return this.b.unshift(u),this.c(),new n.Disposable(()=>{const t=this.b.indexOf(u);t>=0&&(this.b.splice(t,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class m{constructor(f,u){this.a=f.getProxy(A.MainContext.MainThreadStatusBar),this.b=u,this.c=new T(this)}createStatusBarEntry(f,u,t,a){return new M(this.a,this.b,f,u,t,a)}setStatusBarMessage(f,u){const t=this.c.setMessage(f);let a;return typeof u=="number"?a=setTimeout(()=>t.dispose(),u):typeof u<"u"&&u.then(()=>t.dispose(),()=>t.dispose()),new n.Disposable(()=>{t.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=m}),define(Te[80],Pe([1,0,5,4,3]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class N{constructor(O,S){this.c=S,this.b=new A.Emitter,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(O,S){this.a.$registerExtensionStorageKeysToSync(O,S)}async initializeExtensionStorage(O,S,P){const M=await this.a.$initializeExtensionStorage(O,S);let T;return M&&(T=this.d(O,S,M)),T||P}setValue(O,S,P){return this.a.$setValue(O,S,P)}$acceptValue(O,S,P){const M=this.d(O,S,P);M&&this.b.fire({shared:O,key:S,value:M})}d(O,S,P){try{return JSON.parse(P)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${O}): ${M}`)}}}e.ExtHostStorage=N,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Te[81],Pe([1,0,3,27,12,60,2]),function(te,e,n,A,D,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let O=class{constructor(P,M,T){this.d=M,this.f=T,this.a=P.workspace??void 0,this.b=P.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(P){return E.URI.joinPath(this.b.workspaceStorageHome,P)}async h(){if(!this.a)return Promise.resolve(void 0);const P=this.a.id,M=await this.g(P);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(E.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:E.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(T){this.d.error("[ExtHostStorage]",T);return}}workspaceValue(P){if(this.c)return E.URI.joinPath(this.c,P.identifier.value)}globalValue(P){return E.URI.joinPath(this.b.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};O=qe([Ve(0,A.IExtHostInitDataService),Ve(1,D.ILogService),Ve(2,N.IExtHostConsumerFileSystem)],O),e.ExtensionStoragePaths=O}),define(Te[61],Pe([1,0,4,5,3,2,18,6,7,145,11,171,21,34,172,39,9,17,8]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class b{constructor(r,c,h,y){this.k=r,this._id=c,this.l=h,this.m=y,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(H=>this.f=H);const C=this;this.value={get name(){return C.m||""},get processId(){return C.b},get creationOptions(){return C.l},get exitStatus(){return C.h},get state(){return C.j},sendText(H,K=!0){C.o(),C.k.$sendText(C._id,H,K)},show(H){C.o(),C.k.$show(C._id,H)},hide(){C.o(),C.k.$hide(C._id)},dispose(){C.a||(C.a=!0,C.k.$dispose(C._id))},get dimensions(){if(!(C.d===void 0||C.g===void 0))return{columns:C.d,rows:C.g}}}}async create(r,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:r.name,shellPath:(0,t.withNullAsUndefined)(r.shellPath),shellArgs:(0,t.withNullAsUndefined)(r.shellArgs),cwd:(0,t.withNullAsUndefined)(r.cwd),env:(0,t.withNullAsUndefined)(r.env),icon:(0,t.withNullAsUndefined)(l(r.iconPath)),color:u.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:(0,t.withNullAsUndefined)(r.message),strictEnv:(0,t.withNullAsUndefined)(r.strictEnv),hideFromUser:(0,t.withNullAsUndefined)(r.hideFromUser),isFeatureTerminal:(0,t.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this.n(r.location,c?.resolvedExtHostIdentifier),isTransient:(0,t.withNullAsUndefined)(r.isTransient)})}async createExtensionTerminal(r,c,h,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:h,color:u.ThemeColor.isThemeColor(y)?y.id:void 0,location:this.n(r,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(r,c){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in r?{viewColumn:p.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus}:void 0:r}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(r){this.m=r}setExitStatus(r,c){this.h=Object.freeze({code:r,reason:c})}setDimensions(r,c){return r===this.d&&c===this.g||r===0||c===0?!1:(this.d=r,this.g=c,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(r){this.f?(this.f(r),this.f=void 0):this.b.then(c=>{c!==r&&(this.b=Promise.resolve(r))})}}e.ExtHostTerminal=b;class R{get onProcessReady(){return this.b.event}constructor(r){this.g=r,this.id=0,this.shouldPersist=!1,this.a=new n.Emitter,this.onProcessData=this.a.event,this.b=new n.Emitter,this.d=new n.Emitter,this.onDidChangeProperty=this.d.event,this.f=new n.Emitter,this.onProcessExit=this.f.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${c}`)}async start(){}shutdown(){this.g.close()}input(r){this.g.handleInput?.(r)}resize(r,c){this.g.setDimensions?.({columns:r,rows:c})}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(r){this.g.onDidWrite(c=>this.a.fire(c)),this.g.onDidClose?.((c=void 0)=>{this.f.fire(c===void 0?void 0:c)}),this.g.onDidOverrideDimensions?.(c=>{c&&this.d.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this.g.onDidChangeName?.(c=>{this.d.fire({type:"title",value:c})}),this.g.open(r||void 0),r&&this.g.setDimensions?.(r),this.b.fire({pid:-1,cwd:""})}}let v=1,i=class extends O.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(r=>r.value)}get onDidWriteTerminalData(){return this.I.event}constructor(r,c){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new n.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new n.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new n.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new n.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new n.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new n.Emitter,this.onDidChangeShell=this.J.event,this.a=c.getProxy(A.MainContext.MainThreadTerminalService),this.s=new f.TerminalDataBufferer(this.a.$sendProcessData),this.I=new n.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(r),this.B({dispose:()=>{for(const[h,y]of this.g)y.shutdown(!0)}})}getDefaultShell(r){return(r?this.n:this.m)?.path||""}getDefaultShellArgs(r){return(r?this.n:this.m)?.args||[]}createExtensionTerminal(r,c){const h=new b(this.a,(0,w.generateUuid)(),r,r.name),y=new R(r.pty);return h.createExtensionTerminal(r.location,this.L(r,c).resolvedExtHostIdentifier,l(r.iconPath),o(r.color)).then(C=>{const H=this.M(C,y);this.h[C]=H}),this.f.push(h),h.value}L(r,c){if(c=c||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const h=r.location.parentTerminal;if(h){const y=this.f.find(C=>C.value===h);y&&(c.resolvedExtHostIdentifier=y._id)}}else r.location&&typeof r.location!="object"?c.location=r.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(r,c){if(!this.O(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const y=new R(c),C=this.M(r,y);this.h[r]=C}async $acceptActiveTerminalChanged(r){const c=this.b;if(r===null){this.b=void 0,c!==this.b&&this.F.fire(this.b);return}const h=this.O(r);h&&(this.b=h,c!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(r,c){const h=this.O(r);h&&this.I.fire({terminal:h.value,data:c})}async $acceptTerminalDimensions(r,c,h){const y=this.O(r);y&&y.setDimensions(c,h)&&this.G.fire({terminal:y.value,dimensions:y.value.dimensions})}async $acceptTerminalMaximumDimensions(r,c,h){this.g.get(r)?.resize(c,h)}async $acceptTerminalTitleChange(r,c){const h=this.O(r);h&&(h.name=c)}async $acceptTerminalClosed(r,c,h){const y=this.Q(this.f,r);if(y!==null){const C=this.f.splice(y,1)[0];C.setExitStatus(c,h),this.C.fire(C.value)}}$acceptTerminalOpened(r,c,h,y){if(c){const K=this.Q(this.f,c);if(K!==null){this.f[K]._id=r,this.D.fire(this.terminals[K]),this.f[K].isOpen=!0;return}}const C={name:y.name,shellPath:y.executable,shellArgs:y.args,cwd:typeof y.cwd=="string"?y.cwd:N.URI.revive(y.cwd),env:y.env,hideFromUser:y.hideFromUser},H=new b(this.a,r,C,h);this.f.push(H),this.D.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(r,c){this.O(r)?._setProcessId(c)}async $startExtensionTerminal(r,c){const h=this.O(r);if(!h)return{message:(0,P.localize)(0,null,r)};h.isOpen||await new Promise(C=>{const H=this.onDidOpenTerminal(async K=>{K===h.value&&(H.dispose(),C())})});const y=this.g.get(r);y?y.startSendingEvents(c):this.j[r]={initialDimensions:c}}M(r,c){const h=new O.DisposableStore;h.add(c.onProcessReady(C=>this.a.$sendProcessReady(r,C.pid,C.cwd))),h.add(c.onDidChangeProperty(C=>this.a.$sendProcessProperty(r,C))),this.s.startBuffering(r,c.onProcessData),h.add(c.onProcessExit(C=>this.N(r,C))),this.g.set(r,c);const y=this.j[r];return y&&c instanceof R&&(c.startSendingEvents(y.initialDimensions),delete this.j[r]),h}$acceptProcessAckDataEvent(r,c){this.g.get(r)?.acknowledgeDataEvent(c)}$acceptProcessInput(r,c){this.g.get(r)?.input(c)}$acceptTerminalInteraction(r){const c=this.O(r);c?.setInteractedWith()&&this.H.fire(c.value)}$acceptProcessResize(r,c,h){try{this.g.get(r)?.resize(c,h)}catch(y){if(y.code!=="EPIPE"&&y.code!=="ERR_IPC_CHANNEL_CLOSED")throw y}}$acceptProcessShutdown(r,c){this.g.get(r)?.shutdown(c)}$acceptProcessRequestInitialCwd(r){this.g.get(r)?.getInitialCwd().then(c=>this.a.$sendProcessProperty(r,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(r){this.g.get(r)?.getCwd().then(c=>this.a.$sendProcessProperty(r,{type:"cwd",value:c}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this.u.add(r),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(r),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(r,c,h){if(this.v.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this.v.set(c,h),this.a.$registerProfileProvider(c,r.identifier.value),new S.Disposable(()=>{this.v.delete(c),this.a.$unregisterProfileProvider(c)})}registerTerminalQuickFixProvider(r,c,h){if(this.w.has(r))throw new Error(`Terminal quick fix provider "${r}" is already registered`);return this.w.set(r,h),this.a.$registerQuickFixProvider(r,c),new S.Disposable(()=>{this.w.delete(r),this.a.$unregisterQuickFixProvider(r)})}async $provideTerminalQuickFixes(r,c){const h=new m.CancellationTokenSource().token;if(h.isCancellationRequested)return;const y=this.w.get(r);if(!y)return;const C=await y.provideTerminalQuickFixes(c,h);if(C!==null)return C}async $createContributedProfileTerminal(r,c){const h=new m.CancellationTokenSource().token;let y=await this.v.get(r)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(y&&!("options"in y)&&(y={options:y}),!y||!("options"in y))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in y.options){this.createExtensionTerminal(y.options,c);return}this.createTerminalFromOptions(y.options,c)}}async $provideLinks(r,c){const h=this.O(r);if(!h)return[];this.y.delete(r),this.z.get(r)?.dispose(!0);const C=new m.CancellationTokenSource;this.z.set(r,C);const H=[],K={terminal:h.value,line:c},Q=[];for(const L of this.u)Q.push(a.Promises.withAsyncBody(async g=>{C.token.onCancellationRequested(()=>g({provider:L,links:[]}));const F=await L.provideTerminalLinks(K,C.token)||[];C.token.isCancellationRequested||g({provider:L,links:F})}));const _=await Promise.all(Q);if(C.token.isCancellationRequested)return[];const j=new Map;for(const L of _)L&&L.links.length>0&&H.push(...L.links.map(g=>{const F={id:v++,startIndex:g.startIndex,length:g.length,label:g.tooltip};return j.set(F.id,{provider:L.provider,link:g}),F}));return this.y.set(r,j),H}$activateLink(r,c){const h=this.y.get(r)?.get(c);!h||h.provider.handleTerminalLink(h.link)}N(r,c){this.s.stopBuffering(r),this.g.delete(r),delete this.j[r];const h=this.h[r];h&&(h.dispose(),delete this.h[r]),this.a.$sendProcessExit(r,c)}O(r){return this.P(this.f,r)}P(r,c){const h=this.Q(r,c);return h!==null?r[h]:null}Q(r,c){let h=null;return r.some((y,C)=>y._id===c?(h=C,!0):!1),h}getEnvironmentVariableCollection(r){let c=this.l.get(r.identifier.value);return c||(c=new d,this.S(r.identifier.value,c)),c}R(r,c){const h=(0,T.serializeEnvironmentVariableCollection)(c.map);this.a.$setEnvironmentVariableCollection(r,c.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(r){r.forEach(c=>{const h=c[0],y=new d(c[1]);this.S(h,y)})}$acceptDefaultProfile(r,c){const h=this.m;this.m=r,this.n=c,h?.path!==r.path&&this.J.fire(r.path)}S(r,c){this.l.set(r,c),c.onDidChangeCollection(()=>{this.R(r,c)})}};i=qe([Ve(1,E.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class d{get persistent(){return this.a}set persistent(r){this.a=r,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(r){this.map=new Map,this.a=!0,this.b=new n.Emitter,this.map=new Map(r)}get size(){return this.map.size}replace(r,c){this.d(r,{value:c,type:S.EnvironmentVariableMutatorType.Replace})}append(r,c){this.d(r,{value:c,type:S.EnvironmentVariableMutatorType.Append})}prepend(r,c){this.d(r,{value:c,type:S.EnvironmentVariableMutatorType.Prepend})}d(r,c){const h=this.map.get(r);(!h||h.value!==c.value||h.type!==c.type)&&(this.map.set(r,c),this.b.fire())}get(r){return this.map.get(r)}forEach(r,c){this.map.forEach((h,y)=>r.call(c,y,h,this))}[Symbol.iterator](){return this.map.entries()}delete(r){this.map.delete(r),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let s=class extends i{constructor(r){super(!1,r)}createTerminal(r,c,h){throw new M.NotSupportedError}createTerminalFromOptions(r,c){throw new M.NotSupportedError}};s=qe([Ve(0,E.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function l(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function o(I){return u.ThemeColor.isThemeColor(I)?I:void 0}});var Fe=this&&this.__classPrivateFieldGet||function(te,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!A:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(te):A?A.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,A,D){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n};define(Te[231],Pe([1,0,16,17,25,21,4,195,232,6,23,9,34,5,18,102,8,7,45,72,56,26]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t,a,p,b,R,v){"use strict";var i,d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(L,g,F){this.j=F,this.c=new E.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=L.getProxy(w.MainContext.MainThreadTesting),this.h=new K(this.f),this.g=new r(this.f),g.registerArgumentProcessor({processArgument:B=>{if(B?.$mid!==15)return B;const Y=B,me=Y.tests[Y.tests.length-1].item.extId;return this.d.get(p.TestId.root(me))?.collection.tree.get(me)?.actual??(0,u.toItemFromContext)(B)}})}createTestController(L,g,F,B){if(this.d.has(g))throw new Error(`Attempt to insert a duplicate controller with ID "${g}"`);const Y=new P.DisposableStore,me=Y.add(new u.ExtHostTestItemCollection(g,F,this.j));me.root.label=F;const Z=new Map,se=this.f,ue={items:me.root.children,get label(){return F},set label(de){F=de,me.root.label=de,se.$updateController(g,{label:F})},get refreshHandler(){return B},set refreshHandler(de){B=de,se.$updateController(g,{canRefresh:!!de})},get id(){return g},createRunProfile:(de,ie,q,ce,be,Ae)=>{let Ue=(0,S.hash)(de);for(;Z.has(Ue);)Ue++;return Ae!==void 0&&(0,v.checkProposedApiEnabled)(L,"testContinuousRun"),new Q(this.f,Z,g,Ue,de,ie,q,ce,be,Ae)},createTestItem(de,ie,q){return new u.TestItemImpl(g,de,ie,q)},createTestRun:(de,ie,q=!0)=>this.g.createTestRun(g,me,de,ie,q),set resolveHandler(de){me.resolveHandler=de},get resolveHandler(){return me.resolveHandler},dispose:()=>{Y.dispose()}};se.$registerTestController(g,F,!!B),Y.add((0,P.toDisposable)(()=>se.$unregisterTestController(g)));const De={controller:ue,collection:me,profiles:Z};return this.d.set(g,De),Y.add((0,P.toDisposable)(()=>this.d.delete(g))),Y.add(me.onDidGenerateDiff(de=>se.$publishDiff(g,de.map(R.TestsDiffOp.serialize)))),ue}createTestObserver(){return this.h.checkout()}async runTests(L,g=N.CancellationToken.None){const F=c(L);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.d.get(F.controllerId);if(!B)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(Y=>p.TestId.fromExtHostTestItem(Y,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:_[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:L.exclude?.map(Y=>Y.id)},g)}$syncTests(){for(const{collection:L}of this.d.values())L.flushDiff();return Promise.resolve()}$provideFileCoverage(L,g,F){return(0,n.mapFind)(this.g.trackers,Y=>Y.id===L?Y.getCoverage(g):void 0)?.provideFileCoverage(F)??Promise.resolve([])}$resolveFileCoverage(L,g,F,B){return(0,n.mapFind)(this.g.trackers,me=>me.id===L?me.getCoverage(g):void 0)?.resolveFileCoverage(F,B)??Promise.resolve([])}$configureRunProfile(L,g){this.d.get(L)?.profiles.get(g)?.configureHandler?.()}async $refreshTests(L,g){await this.d.get(L)?.controller.refreshHandler?.(g)}$publishTestResults(L){this.results=Object.freeze(L.map(g=>(0,M.deepFreeze)(t.TestResults.to(g))).concat(this.results).sort((g,F)=>F.completedAt-g.completedAt).slice(0,32)),this.c.fire()}async $expandTest(L,g){const F=this.d.get(p.TestId.fromString(L).controllerId)?.collection;F&&(await F.expand(L,g<0?1/0:g),F.flushDiff())}$acceptDiff(L){this.h.applyDiff(L.map(R.TestsDiffOp.deserialize))}async $runControllerTests(L,g){return Promise.all(L.map(F=>this.k(F,!1,g)))}async $startContinuousRun(L,g){const F=new N.CancellationTokenSource(g),B=await Promise.all(L.map(Y=>this.k(Y,!0,F.token)));return!g.isCancellationRequested&&!B.some(Y=>Y.error)&&await new Promise(Y=>g.onCancellationRequested(Y)),F.dispose(!0),B}async k(L,g,F){const B=this.d.get(L.controllerId);if(!B)return{};const{collection:Y,profiles:me}=B,Z=me.get(L.profileId);if(!Z)return{};const se=L.testIds.map(ie=>Y.tree.get(ie)).filter(T.isDefined),ue=L.excludeExtIds.map(ie=>B.collection.tree.get(ie)).filter(T.isDefined).filter(ie=>se.some(q=>q.fullId.compare(ie.fullId)===2));if(!se.length)return{};const De=new a.TestRunRequest2(se.some(ie=>ie.actual instanceof u.TestItemRootImpl)?void 0:se.map(ie=>ie.actual),ue.map(ie=>ie.actual),Z,g),de=(0,R.isStartControllerTests)(L)&&this.g.prepareForMainThreadTestRun(De,h.fromInternal(L,B.collection),F);try{return await Z.runHandler(De,F),{}}catch(ie){return{error:String(ie)}}finally{de&&(de.hasRunningTasks&&!F.isCancellationRequested&&await E.Event.toPromise(de.onEnd),de.dispose())}}$cancelExtensionTestRun(L){L===void 0?this.g.cancelAllRuns():this.g.cancelRunById(L)}};s=qe([Ve(0,f.IExtHostRpcService)],s),e.ExtHostTesting=s;const l=1e4;var o;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(o||(o={}));class I extends P.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(L,g,F){super(),this.k=L,this.l=g,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new E.Emitter),this.onEnd=this.j.event,this.h=this.B(new N.CancellationTokenSource(F));const B=this.B(new A.RunOnceScheduler(()=>this.m(),l));this.B(this.h.token.onCancellationRequested(()=>B.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(L){return this.f.get(L)?.coverage}createRun(L){const g=this.k.id,F=this.k.controllerId,B=(0,m.generateUuid)(),Y=new y(this.l,g,B),me=De=>(de,...ie)=>{if(se){console.warn(`Setting the state of test "${de.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(de)||(this.s(de),De(de,...ie))},Z=(De,de)=>{const ie=de instanceof Array?de.map(t.TestMessage.from):[t.TestMessage.from(de)];if(De.uri&&De.range){const q={range:t.Range.from(De.range),uri:De.uri};for(const ce of ie)ce.location=ce.location||q}this.l.$appendTestMessagesInRun(g,B,p.TestId.fromExtHostTestItem(De,F).toString(),ie)};let se=!1;const ue={isPersisted:this.k.isPersisted,token:this.h.token,name:L,get coverageProvider(){return Y.coverageProvider},set coverageProvider(De){Y.coverageProvider=De},enqueued:me(De=>{this.l.$updateTestStateInRun(g,B,p.TestId.fromExtHostTestItem(De,F).toString(),1)}),skipped:me(De=>{this.l.$updateTestStateInRun(g,B,p.TestId.fromExtHostTestItem(De,F).toString(),5)}),started:me(De=>{this.l.$updateTestStateInRun(g,B,p.TestId.fromExtHostTestItem(De,F).toString(),2)}),errored:me((De,de,ie)=>{Z(De,de),this.l.$updateTestStateInRun(g,B,p.TestId.fromExtHostTestItem(De,F).toString(),6,ie)}),failed:me((De,de,ie)=>{Z(De,de),this.l.$updateTestStateInRun(g,B,p.TestId.fromExtHostTestItem(De,F).toString(),4,ie)}),passed:me((De,de)=>{this.l.$updateTestStateInRun(g,B,p.TestId.fromExtHostTestItem(De,this.k.controllerId).toString(),3,de)}),appendOutput:(De,de,ie)=>{se||(ie&&(this.k.isIncluded(ie)?this.s(ie):ie=void 0),this.l.$appendOutputToRun(g,B,D.VSBuffer.fromString(De),de&&t.location.from(de),ie&&p.TestId.fromExtHostTestItem(ie,F).toString()))},end:()=>{se||(se=!0,this.l.$finishedTestRunTask(g,B),this.f.delete(B),this.f.size||this.p())}};return this.f.set(B,{run:ue,coverage:Y}),this.l.$startedTestRunTask(g,{id:B,name:L,running:!0}),ue}m(){for(const{run:L}of this.f.values())L.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(L){if(!(L instanceof u.TestItemImpl))throw new b.InvalidTestItemError(L.id);if(this.g.has(p.TestId.fromExtHostTestItem(L,this.k.controllerId).toString()))return;const g=[],F=this.k.colllection.root;for(;;){const B=t.TestItem.from(L);if(g.unshift(B),this.g.has(B.extId)||(this.g.add(B.extId),L===F))break;L=L.parent||F}this.l.$addTestsToRun(this.k.controllerId,this.k.id,g)}}class r{get trackers(){return this.c.values()}constructor(L){this.d=L,this.c=new Map}prepareForMainThreadTestRun(L,g,F){return this.f(L,g,F)}cancelRunById(L){for(const g of this.c.values())if(g.id===L){g.cancel();return}}cancelAllRuns(){for(const L of this.c.values())L.cancel()}createTestRun(L,g,F,B,Y){const me=this.c.get(F);if(me)return me.createRun(B);const Z=h.fromPublic(L,g,F,Y),se=c(F);this.d.$startedExtensionTestRun({controllerId:L,continuous:!!F.continuous,profile:se&&{group:_[se.kind],id:se.profileId},exclude:F.exclude?.map(De=>p.TestId.fromExtHostTestItem(De,g.root.id).toString())??[],id:Z.id,include:F.include?.map(De=>p.TestId.fromExtHostTestItem(De,g.root.id).toString())??[g.root.id],persist:Y});const ue=this.f(F,Z);return ue.onEnd(()=>{this.d.$finishedExtensionTestRun(Z.id),ue.dispose()}),ue.createRun(B)}f(L,g,F){const B=new I(g,this.d,F);return this.c.set(L,B),B.onEnd(()=>this.c.delete(L)),B}}e.TestRunCoordinator=r;const c=j=>{if(!!j.profile){if(!(j.profile instanceof Q))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class h{static fromPublic(L,g,F,B){return new h(L,(0,m.generateUuid)(),F.include?.map(Y=>p.TestId.fromExtHostTestItem(Y,L).toString())??[L],F.exclude?.map(Y=>p.TestId.fromExtHostTestItem(Y,L).toString())??[],B,g)}static fromInternal(L,g){return new h(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,g)}constructor(L,g,F,B,Y,me){this.controllerId=L,this.id=g,this.isPersisted=Y,this.colllection=me,this.c=F.map(Z=>Z+"\0"),this.d=B.map(Z=>Z+"\0")}isIncluded(L){const g=p.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const F of this.d)if(g===F||g.startsWith(F))return!1;for(const F of this.c)if(g===F||g.startsWith(F))return!0;return!1}}e.TestRunDto=h;class y{set coverageProvider(L){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this.c=L,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(L,g,F){this.f=L,this.g=g,this.h=F}async provideFileCoverage(L){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(L))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(g){throw this.d=void 0,g}}async resolveFileCoverage(L,g){const F=await this.d;let B=F?.[L];return!this.c||!F||!B?[]:(B.detailedCoverage||(B=F[L]=await this.c.resolveFileCoverage?.(B,g)??B),B.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class C{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(L){this.h=L,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(L){this.c.add(L)}update(L){Object.assign(L.revived,t.TestItem.toPlain(L.item)),this.c.has(L)||this.d.add(L)}remove(L){if(this.c.has(L)){this.c.delete(L);return}this.d.delete(L);const g=p.TestId.parentId(L.item.extId);if(g&&this.g.has(g.toString())){this.g.add(L.item.extId);return}this.f.add(L)}getChangeEvent(){const{c:L,d:g,f:F}=this;return{get added(){return[...L].map(B=>B.revived)},get updated(){return[...g].map(B=>B.revived)},get removed(){return[...F].map(B=>B.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class H extends R.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new E.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(L){return this.d.get(L)}getMirroredTestDataByReference(L){return this.d.get(L.id)}p(L,g){return{...L,revived:t.TestItem.toPlain(L.item),depth:g?g.depth+1:0,children:new Set}}o(){return new C(this.q)}}class K{constructor(L){this.d=L}checkout(){this.c||(this.c=this.f());const L=this.c;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(g=>g.revived)},dispose:(0,O.once)(()=>{--L.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(L){return this.c?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.c?.tests.apply(L)}f(){const L=new H;return this.d.$subscribeToDiffs(),{observers:0,tests:L}}}class Q{get label(){return this.d}set label(L){L!==this.d&&(this.d=L,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(L){L!==this.g&&(this.g=L,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:L}))}get isDefault(){return this.f}set isDefault(L){L!==this.f&&(this.f=L,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?t.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this.c}set configureHandler(L){L!==this.c&&(this.c=L,Fe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}constructor(L,g,F,B,Y,me,Z,se=!1,ue=void 0,De=!1){this.controllerId=F,this.profileId=B,this.d=Y,this.kind=me,this.runHandler=Z,this.f=se,this._tag=ue,this.g=De,i.set(this,void 0),d.set(this,void 0),Je(this,i,L,"f"),Je(this,d,g,"f"),g.set(B,this);const de=_[me];if(typeof de!="number")throw new Error(`Unknown TestRunProfile.group ${me}`);Fe(this,i,"f").$publishTestRunProfile({profileId:B,controllerId:F,tag:ue?t.TestTag.namespace(this.controllerId,ue.id):null,label:Y,group:de,isDefault:se,hasConfigurationHandler:!1,supportsContinuousRun:De})}dispose(){Fe(this,d,"f")?.delete(this.profileId)&&(Je(this,d,void 0,"f"),Fe(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=Q,i=new WeakMap,d=new WeakMap;const _={[a.TestRunProfileKind.Coverage]:8,[a.TestRunProfileKind.Debug]:4,[a.TestRunProfileKind.Run]:2}}),define(Te[233],Pe([1,0,16,4,5,103,8,7]),function(te,e,n,A,D,N,E,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(M,T){this.i=T,this.a=new A.Emitter,this.b=new A.Emitter,this.c=new A.Emitter,this.d=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=M.getProxy(D.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(M){const T=this.i.allEditors();return M?T:T.map(m=>m.value)}async showTextDocument(M,T,m){let w;typeof T=="number"?w={position:E.ViewColumn.from(T),preserveFocus:m}:typeof T=="object"?w={position:E.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?E.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:w={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(M.uri,w),u=f&&this.i.getEditor(f);if(u)return u.value;throw f?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,T){return new N.TextEditorDecorationType(this.h,M,T).value}$acceptEditorPropertiesChanged(M,T){const m=this.i.getEditor(M);if(!m)throw new Error("unknown text editor");if(T.options&&m._acceptOptions(T.options),T.selections){const w=T.selections.selections.map(E.Selection.to);m._acceptSelections(w)}if(T.visibleRanges){const w=n.coalesce(T.visibleRanges.map(E.Range.to));m._acceptVisibleRanges(w)}if(T.options&&this.b.fire({textEditor:m.value,options:{...T.options,lineNumbers:E.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const w=O.TextEditorSelectionChangeKind.fromValue(T.selections.source),f=T.selections.selections.map(E.Selection.to);this.a.fire({textEditor:m.value,selections:f,kind:w})}if(T.visibleRanges){const w=n.coalesce(T.visibleRanges.map(E.Range.to));this.c.fire({textEditor:m.value,visibleRanges:w})}}$acceptEditorPositionData(M){for(const T in M){const m=this.i.getEditor(T);if(!m)throw new Error("Unknown text editor");const w=E.ViewColumn.to(M[T]);m.value.viewColumn!==w&&(m._acceptViewColumn(w),this.d.fire({textEditor:m.value,viewColumn:w}))}}getDiffInformation(M){return Promise.resolve(this.h.$getDiffInformation(M))}}e.ExtHostEditors=S}),define(Te[234],Pe([1,0,2,3,5,6,7,8,24,9]),function(te,e,n,A,D,N,E,O,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class M{constructor(w,f){this.b=new Map,this.c=new Map,this.a=w.getProxy(D.MainContext.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(u,t)=>{if(u&&u.$mid===12)if(this.b.get(u.source)&&S.ExtensionIdentifier.equals(t,this.b.get(u.source)?.extension)){const a=u.uri===void 0?void 0:n.URI.revive(u.uri);return this.c.get(u.source)?.get(T(a))?.get(u.handle)}else return;return u}})}async $getTimeline(w,f,u,t){return this.b.get(w)?.provider.provideTimeline(n.URI.revive(f),u,t)}registerTimelineProvider(w,f,u,t){const a=new N.DisposableStore,p=this.d(f.id,t,a).bind(this);let b;f.onDidChange&&(b=f.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:f.id}),this));const R=this.c;return this.f({...f,scheme:w,onDidChange:void 0,async provideTimeline(v,i,d){i?.resetCache&&(a.clear(),R.get(f.id)?.clear());const s=await f.provideTimeline(v,i,d);if(s==null)return;const l=p(v,i);return{...s,source:f.id,items:s.items.map(l)}},dispose(){for(const v of R.values())v.get(f.id)?.clear();b?.dispose(),a.dispose()}},u)}d(w,f,u){return(t,a)=>{let p;if(a?.cacheResults){let b=this.c.get(w);b===void 0&&(b=new Map,this.c.set(w,b));const R=T(t);p=b.get(R),p===void 0&&(p=new Map,b.set(R,p))}return b=>{const{iconPath:R,...v}=b,i=`${w}|${b.id??b.timestamp}`;p?.set(i,b);let d,s,l;b.iconPath&&(R instanceof E.ThemeIcon?l={id:R.id,color:R.color}:n.URI.isUri(R)?(d=R,s=R):{light:d,dark:s}=R);let o;return E.MarkdownString.isMarkdownString(v.tooltip)?o=O.MarkdownString.from(v.tooltip):(0,P.isString)(v.tooltip)?o=v.tooltip:E.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=O.MarkdownString.from(v.detail)):(0,P.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=v.detail),{...v,id:v.id??void 0,handle:i,source:w,command:b.command?f.toInternal(b.command,u):void 0,icon:d,iconDark:s,themeIcon:l,tooltip:o,accessibilityInformation:b.accessibilityInformation}}}}f(w,f){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:f}),(0,N.toDisposable)(()=>{for(const t of this.c.values())t.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.ExtHostTimeline=M;function T(m){return m?.toString()}}),define(Te[235],Pe([1,0,6,15,2,5]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class E{constructor(S){this.c=new Map,this.b=S.getProxy(N.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,P,M,T){if(this.c.has(P))throw new Error(`Opener with id '${P}' already registered`);const m=T.schemes.find(w=>!E.a.has(w));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(P,M),this.b.$registerUriOpener(P,T.schemes,S,T.label),(0,n.toDisposable)(()=>{this.c.delete(P),this.b.$unregisterUriOpener(P)})}async $canOpenUri(S,P,M){const T=this.c.get(S);if(!T)throw new Error(`Unknown opener with id: ${S}`);const m=D.URI.revive(P);return T.canOpenExternalUri(m,M)}async $openUri(S,P,M){const T=this.c.get(S);if(!T)throw new Error(`Unknown opener id: '${S}'`);return T.openExternalUri(D.URI.revive(P.resolvedUri),{sourceUri:D.URI.revive(P.sourceUri)},M)}}E.a=new Set([A.Schemas.http,A.Schemas.https]),e.ExtHostUriOpeners=E}),define(Te[236],Pe([1,0,5,2,6,11,24]),function(te,e,n,A,D,N,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class O{constructor(P){this.c=new E.ExtensionIdentifierSet,this.d=new Map,this.b=P.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(P,M){if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const T=O.a++;return this.c.add(P),this.d.set(T,M),this.b.$registerUriHandler(T,P),(0,D.toDisposable)(()=>{this.c.delete(P),this.d.delete(T),this.b.$unregisterUriHandler(T)})}$handleExternalUri(P,M){const T=this.d.get(P);if(!T)return Promise.resolve(void 0);try{T.handleUri(A.URI.revive(M))}catch(m){(0,N.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(P){return A.URI.revive(await this.b.$createAppUri(P))}}O.a=0,e.ExtHostUrls=O});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,A,D){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Fe=this&&this.__classPrivateFieldGet||function(te,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!A:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(te):A?A.value:e.get(te)};define(Te[62],Pe([1,0,4,15,23,2,158,181,73,5]),function(te,e,n,A,D,N,E,O,S,P){"use strict";var M,T,m,w,f,u,t,a,p,b,R,v,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(C,H,K,Q,_,j,L){M.set(this,void 0),T.set(this,void 0),m.set(this,void 0),w.set(this,void 0),f.set(this,void 0),u.set(this,void 0),t.set(this,""),a.set(this,void 0),p.set(this,!1),b.set(this,!1),R.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new n.Emitter),this._onDidDispose=Fe(this,i,"f").event,Je(this,M,C,"f"),Je(this,T,H,"f"),Je(this,a,K,"f"),Je(this,w,Q,"f"),Je(this,f,_,"f"),Je(this,u,j,"f"),Je(this,R,s(j),"f"),Je(this,v,l(j),"f"),Je(this,m,L,"f")}dispose(){Je(this,p,!0,"f"),Fe(this,i,"f").fire(),Fe(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(C){return Je(this,b,!0,"f"),(0,S.asWebviewUri)(C,Fe(this,w,"f"))}get cspSource(){const C=Fe(this,u,"f").extensionLocation;if(C.scheme===A.Schemas.https||C.scheme===A.Schemas.http){let H=C.toString();return H.endsWith("/")||(H+="/"),H+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Fe(this,t,"f")}set html(C){this.a(),Fe(this,t,"f")!==C&&(Je(this,t,C,"f"),Fe(this,v,"f")&&!Fe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(C)&&(Je(this,b,!0,"f"),Fe(this,m,"f").report("Webview vscode-resource: uris",Fe(this,u,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Fe(this,T,"f").$setHtml(Fe(this,M,"f"),this.b(C)))}get options(){return this.a(),Fe(this,a,"f")}set options(C){this.a(),D.equals(Fe(this,a,"f"),C)||Fe(this,T,"f").$setOptions(Fe(this,M,"f"),r(Fe(this,u,"f"),Fe(this,f,"f"),C)),Je(this,a,C,"f")}async postMessage(C){if(Fe(this,p,"f"))return!1;const H=(0,O.serializeWebviewMessage)(C,{serializeBuffersForPostMessage:Fe(this,R,"f")});return Fe(this,T,"f").$postMessage(Fe(this,M,"f"),H.message,...H.buffers)}a(){if(Fe(this,p,"f"))throw new Error("Webview is disposed")}b(C){if(!Fe(this,v,"f"))return C;const H=Fe(this,u,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,K=Fe(this,u,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?Fe(this,u,"f").extensionLocation.authority:void 0;return C.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(Q,_,j,L,g,F)=>{const B=N.URI.from({scheme:L||"file",path:decodeURIComponent(g)}),Y=(0,S.asWebviewUri)(B,{isRemote:H,authority:K}).toString();return`${_}${Y}${F}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(Q,_,j,L,g,F)=>{const B=N.URI.from({scheme:L||"file",path:decodeURIComponent(g)}),Y=(0,S.asWebviewUri)(B,{isRemote:H,authority:K}).toString();return`${_}${Y}${F}`})}}e.ExtHostWebview=d,M=new WeakMap,T=new WeakMap,m=new WeakMap,w=new WeakMap,f=new WeakMap,u=new WeakMap,t=new WeakMap,a=new WeakMap,p=new WeakMap,b=new WeakMap,R=new WeakMap,v=new WeakMap,i=new WeakMap;function s(y){try{const C=(0,E.normalizeVersion)((0,E.parseVersion)(y.engines.vscode));return!!C&&C.majorBase>=1&&C.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function l(y){try{const C=(0,E.normalizeVersion)((0,E.parseVersion)(y.engines.vscode));return C?C.majorBase<1||C.majorBase===1&&C.minorBase<60:!1}catch{return!1}}class o{constructor(C,H,K,Q,_){this.c=H,this.d=K,this.e=Q,this.f=_,this.b=new Map,this.a=C.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(C,H,K){const Q=this.g(C);if(Q){const{message:_}=(0,O.deserializeWebviewMessage)(H,K.value);Q._onMessageEmitter.fire(_)}}$onMissingCsp(C,H){this.e.warn(`${H} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(C,H,K){const Q=new d(C,this.a,c(H),this.c,this.d,K,this.f);return this.b.set(C,Q),Q._onDidDispose(()=>{this.b.delete(C)}),Q}deleteWebview(C){this.b.delete(C)}g(C){return this.b.get(C)}}e.ExtHostWebviews=o;function I(y){return{id:y.identifier,location:y.extensionLocation}}e.toExtensionData=I;function r(y,C,H){return{enableCommandUris:H.enableCommandUris,enableScripts:H.enableScripts,enableForms:H.enableForms,portMapping:H.portMapping,localResourceRoots:H.localResourceRoots||h(y,C)}}e.serializeWebviewOptions=r;function c(y){return{enableCommandUris:y.enableCommandUris,enableScripts:y.enableScripts,enableForms:y.enableForms,portMapping:y.portMapping,localResourceRoots:y.localResourceRoots?.map(C=>N.URI.from(C))}}function h(y,C){return[...(C?.getWorkspaceFolders()||[]).map(H=>H.uri),y.extensionLocation]}}),define(Te[237],Pe([1,0,21,232,6,15,22,2,8,62,54,5,7]),function(te,e,n,A,D,N,E,O,S,P,M,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class w{constructor(d,s){this.document=d,this.b=s,this.a=1,this.c=new M.Cache("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,s){await this.f(d).undo(),s||this.disposeBackup()}async redo(d,s){await this.f(d).redo(),s||this.disposeBackup()}disposeEdits(d){for(const s of d)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=v(this.document.uri)+this.a++;return(0,E.joinPath)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const s=this.c.get(d,0);if(!s)throw new Error("No edit found");return s}}class f{constructor(){this.a=new Map}get(d,s){return this.a.get(this.b(d,s))}add(d,s,l){const o=this.b(d,s.uri);if(this.a.has(o))throw new Error(`Document already exists for viewType:${d} resource:${s.uri}`);const I=new w(s,l);return this.a.set(o,I),I}delete(d,s){const l=this.b(d,s.uri);this.a.delete(l)}b(d,s){return`${d}@@@${s}`}}var u;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(u||(u={}));class t{constructor(){this.a=new Map}addTextProvider(d,s,l){return this.b(0,d,s,l)}addCustomProvider(d,s,l){return this.b(1,d,s,l)}get(d){return this.a.get(d)}b(d,s,l,o){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:d,extension:l,provider:o}),new m.Disposable(()=>this.a.delete(s))}}class a{constructor(d,s,l,o,I){this.d=s,this.f=l,this.g=o,this.h=I,this.b=new t,this.c=new f,this.a=d.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,s,l,o){const I=new D.DisposableStore;return b(l)?(I.add(this.b.addTextProvider(s,d,l)),this.a.$registerTextEditorProvider((0,P.toExtensionData)(d),s,o.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(d))):(I.add(this.b.addCustomProvider(s,d,l)),p(l)&&I.add(l.onDidChangeCustomDocument(r=>{const c=this.i(s,r.document.uri);if(R(r)){const h=c.addEdit(r);this.a.$onDidEdit(r.document.uri,s,h,r.label)}else this.a.$onContentChange(r.document.uri,s)})),this.a.$registerCustomEditorProvider((0,P.toExtensionData)(d),s,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(d))),m.Disposable.from(I,new m.Disposable(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(d,s,l,o,I){const r=this.b.get(s);if(!r)throw new Error(`No provider found for '${s}'`);if(r.type!==1)throw new Error(`Invalid provide type for '${s}'`);const c=O.URI.revive(d),h=await r.provider.openCustomDocument(c,{backupId:l,untitledDocumentData:o?.buffer},I);let y;return p(r.provider)&&this.f&&(y=this.f.workspaceValue(r.extension)??this.f.globalValue(r.extension)),this.c.add(s,h,y),{editable:p(r.provider)}}async $disposeCustomDocument(d,s){const l=this.b.get(s);if(!l)throw new Error(`No provider found for '${s}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${s}'`);const o=O.URI.revive(d),{document:I}=this.i(s,o);this.c.delete(s,I),I.dispose()}async $resolveCustomEditor(d,s,l,o,I,r){const c=this.b.get(l);if(!c)throw new Error(`No provider found for '${l}'`);const h=S.ViewColumn.to(I),y=this.g.createNewWebview(s,o.contentOptions,c.extension),C=this.h.createNewWebviewPanel(s,l,o.title,h,o.options,y,!0),H=O.URI.revive(d);switch(c.type){case 1:{const{document:K}=this.i(l,H);return c.provider.resolveCustomEditor(K,C,r)}case 0:{const K=this.d.getDocument(H);return c.provider.resolveCustomTextEditor(K,C,r)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,s,l){this.i(s,d).disposeEdits(l)}async $onMoveCustomEditor(d,s,l){const o=this.b.get(l);if(!o)throw new Error(`No provider found for '${l}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const I=this.h.getWebviewPanel(d);if(!I)throw new Error("No webview found");const r=O.URI.revive(s),c=this.d.getDocument(r);await o.provider.moveCustomTextEditor(c,I,n.CancellationToken.None)}async $undo(d,s,l,o){return this.i(s,d).undo(l,o)}async $redo(d,s,l,o){return this.i(s,d).redo(l,o)}async $revert(d,s,l){const o=this.i(s,d);await this.j(s).revertCustomDocument(o.document,l),o.disposeBackup()}async $onSave(d,s,l){const o=this.i(s,d);await this.j(s).saveCustomDocument(o.document,l),o.disposeBackup()}async $onSaveAs(d,s,l,o){const I=this.i(s,d);return this.j(s).saveCustomDocumentAs(I.document,O.URI.revive(l),o)}async $backup(d,s,l){const o=this.i(s,d),r=await this.j(s).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},l);return o.updateBackup(r),r.id}i(d,s){const l=this.c.get(d,O.URI.revive(s));if(!l)throw new Error("No custom document found");return l}j(d){const l=this.b.get(d)?.provider;if(!l||!p(l))throw new Error("Custom document is not editable");return l}}e.ExtHostCustomEditors=a;function p(i){return!!i.onDidChangeCustomDocument}function b(i){return typeof i.resolveCustomTextEditor=="function"}function R(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function v(i){const d=i.scheme===N.Schemas.file||i.scheme===N.Schemas.untitled?i.fsPath:i.toString();return(0,A.hash)(d)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,A,D){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Fe=this&&this.__classPrivateFieldGet||function(te,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!A:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(te):A?A.value:e.get(te)};define(Te[238],Pe([1,0,4,6,2,34,8,62,5,7]),function(te,e,n,A,D,N,E,O,S,P){"use strict";var M,T,m,w,f,u,t,a,p,b,R,v,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends A.Disposable{constructor(I,r,c,h){super(),M.set(this,void 0),T.set(this,void 0),m.set(this,void 0),w.set(this,void 0),f.set(this,void 0),u.set(this,void 0),t.set(this,void 0),a.set(this,void 0),p.set(this,!0),b.set(this,void 0),R.set(this,!1),v.set(this,this.B(new n.Emitter)),this.onDidDispose=Fe(this,v,"f").event,i.set(this,this.B(new n.Emitter)),this.onDidChangeViewState=Fe(this,i,"f").event,Je(this,M,I,"f"),Je(this,T,r,"f"),Je(this,w,c,"f"),Je(this,m,h.viewType,"f"),Je(this,f,h.panelOptions,"f"),Je(this,a,h.viewColumn,"f"),Je(this,u,h.title,"f"),Je(this,b,h.active,"f")}dispose(){Fe(this,R,"f")||(Je(this,R,!0,"f"),Fe(this,v,"f").fire(),Fe(this,T,"f").$disposeWebview(Fe(this,M,"f")),Fe(this,w,"f").dispose(),super.dispose())}get webview(){return this.c(),Fe(this,w,"f")}get viewType(){return this.c(),Fe(this,m,"f")}get title(){return this.c(),Fe(this,u,"f")}set title(I){this.c(),Fe(this,u,"f")!==I&&(Je(this,u,I,"f"),Fe(this,T,"f").$setTitle(Fe(this,M,"f"),I))}get iconPath(){return this.c(),Fe(this,t,"f")}set iconPath(I){this.c(),Fe(this,t,"f")!==I&&(Je(this,t,I,"f"),Fe(this,T,"f").$setIconPath(Fe(this,M,"f"),D.URI.isUri(I)?{light:I,dark:I}:I))}get options(){return Fe(this,f,"f")}get viewColumn(){if(this.c(),!(typeof Fe(this,a,"f")=="number"&&Fe(this,a,"f")<0))return Fe(this,a,"f")}get active(){return this.c(),Fe(this,b,"f")}get visible(){return this.c(),Fe(this,p,"f")}_updateViewState(I){Fe(this,R,"f")||(this.active!==I.active||this.visible!==I.visible||this.viewColumn!==I.viewColumn)&&(Je(this,b,I.active,"f"),Je(this,p,I.visible,"f"),Je(this,a,I.viewColumn,"f"),Fe(this,i,"f").fire({webviewPanel:this}))}reveal(I,r){this.c(),Fe(this,T,"f").$reveal(Fe(this,M,"f"),{viewColumn:typeof I>"u"?void 0:E.ViewColumn.from(I),preserveFocus:!!r})}c(){if(Fe(this,R,"f"))throw new Error("Webview is disposed")}}M=new WeakMap,T=new WeakMap,m=new WeakMap,w=new WeakMap,f=new WeakMap,u=new WeakMap,t=new WeakMap,a=new WeakMap,p=new WeakMap,b=new WeakMap,R=new WeakMap,v=new WeakMap,i=new WeakMap;class s{static c(){return(0,N.generateUuid)()}constructor(I,r,c){this.g=r,this.h=c,this.e=new Map,this.f=new Map,this.d=I.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(I,r,c,h,y={}){const C=typeof h=="object"?h.viewColumn:h,H={viewColumn:E.ViewColumn.from(C),preserveFocus:typeof h=="object"&&!!h.preserveFocus},K=(0,O.shouldSerializeBuffersForPostMessage)(I),Q=s.c();this.d.$createWebviewPanel((0,O.toExtensionData)(I),Q,r,{title:c,panelOptions:l(y),webviewOptions:(0,O.serializeWebviewOptions)(I,this.h,y),serializeBuffersForPostMessage:K},H);const _=this.g.createNewWebview(Q,y,I);return this.createNewWebviewPanel(Q,r,c,C,y,_,!0)}$onDidChangeWebviewPanelViewStates(I){const r=Object.keys(I);r.sort((c,h)=>{const y=I[c],C=I[h];return y.active?1:C.active?-1:+y.visible-+C.visible});for(const c of r){const h=this.getWebviewPanel(c);if(!h)continue;const y=I[c];h._updateViewState({active:y.active,visible:y.visible,viewColumn:E.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(I){this.getWebviewPanel(I)?.dispose(),this.e.delete(I),this.g.deleteWebview(I)}registerWebviewPanelSerializer(I,r,c){if(this.f.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.f.set(r,{serializer:c,extension:I}),this.d.$registerSerializer(r,{serializeBuffersForPostMessage:(0,O.shouldSerializeBuffersForPostMessage)(I)}),new P.Disposable(()=>{this.f.delete(r),this.d.$unregisterSerializer(r)})}async $deserializeWebviewPanel(I,r,c,h){const y=this.f.get(r);if(!y)throw new Error(`No serializer found for '${r}'`);const{serializer:C,extension:H}=y,K=this.g.createNewWebview(I,c.webviewOptions,H),Q=this.createNewWebviewPanel(I,r,c.title,h,c.panelOptions,K,c.active);await C.deserializeWebviewPanel(Q,c.state)}createNewWebviewPanel(I,r,c,h,y,C,H){const K=new d(I,this.d,C,{viewType:r,title:c,viewColumn:h,panelOptions:y,active:H});return this.e.set(I,K),K}getWebviewPanel(I){return this.e.get(I)}}e.ExtHostWebviewPanels=s;function l(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,A,D){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Fe=this&&this.__classPrivateFieldGet||function(te,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!A:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(te):A?A.value:e.get(te)};define(Te[239],Pe([1,0,4,6,62,8,5,7]),function(te,e,n,A,D,N,E,O){"use strict";var S,P,M,T,m,w,f,u,t,a,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends A.Disposable{constructor(i,d,s,l,o,I){super(),S.set(this,void 0),P.set(this,void 0),M.set(this,void 0),T.set(this,void 0),m.set(this,!1),w.set(this,void 0),f.set(this,void 0),u.set(this,void 0),t.set(this,void 0),a.set(this,this.B(new n.Emitter)),this.onDidChangeVisibility=Fe(this,a,"f").event,p.set(this,this.B(new n.Emitter)),this.onDidDispose=Fe(this,p,"f").event,Je(this,M,s,"f"),Je(this,f,l,"f"),Je(this,S,i,"f"),Je(this,P,d,"f"),Je(this,T,o,"f"),Je(this,w,I,"f")}dispose(){Fe(this,m,"f")||(Je(this,m,!0,"f"),Fe(this,p,"f").fire(),Fe(this,T,"f").dispose(),super.dispose())}get title(){return this.a(),Fe(this,f,"f")}set title(i){this.a(),Fe(this,f,"f")!==i&&(Je(this,f,i,"f"),Fe(this,P,"f").$setWebviewViewTitle(Fe(this,S,"f"),i))}get description(){return this.a(),Fe(this,u,"f")}set description(i){this.a(),Fe(this,u,"f")!==i&&(Je(this,u,i,"f"),Fe(this,P,"f").$setWebviewViewDescription(Fe(this,S,"f"),i))}get visible(){return Fe(this,w,"f")}get webview(){return Fe(this,T,"f")}get viewType(){return Fe(this,M,"f")}_setVisible(i){i===Fe(this,w,"f")||Fe(this,m,"f")||(Je(this,w,i,"f"),Fe(this,a,"f").fire())}get badge(){return this.a(),Fe(this,t,"f")}set badge(i){this.a(),!(i?.value===Fe(this,t,"f")?.value&&i?.tooltip===Fe(this,t,"f")?.tooltip)&&(Je(this,t,N.ViewBadge.from(i),"f"),Fe(this,P,"f").$setWebviewViewBadge(Fe(this,S,"f"),i))}show(i){this.a(),Fe(this,P,"f").$show(Fe(this,S,"f"),!!i)}a(){if(Fe(this,m,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,P=new WeakMap,M=new WeakMap,T=new WeakMap,m=new WeakMap,w=new WeakMap,f=new WeakMap,u=new WeakMap,t=new WeakMap,a=new WeakMap,p=new WeakMap;class R{constructor(i,d){this.d=d,this.b=new Map,this.c=new Map,this.a=i.getProxy(E.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,d,s,l){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:s,extension:i}),this.a.$registerWebviewViewProvider((0,D.toExtensionData)(i),d,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(i)}),new O.Disposable(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(i,d,s,l,o){const I=this.b.get(d);if(!I)throw new Error(`No view provider found for '${d}'`);const{provider:r,extension:c}=I,h=this.d.createNewWebview(i,{},c),y=new b(i,this.a,d,s,h,!0);this.c.set(i,y),await r.resolveWebviewView(y,{state:l},o)}async $onDidChangeWebviewViewVisibility(i,d){this.e(i)._setVisible(d)}async $disposeWebviewView(i){const d=this.e(i);this.c.delete(i),d.dispose(),this.d.deleteWebview(i)}e(i){const d=this.c.get(i);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=R}),define(Te[105],Pe([1,0,4,5,2,15,10,3,18]),function(te,e,n,A,D,N,E,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class an{get state(){return this.d}constructor(T){this.c=new n.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=T.getProxy(A.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(T){T!==this.d.focused&&(this.d={...this.d,focused:T},this.c.fire(this.d))}openUri(T,m){let w;if(typeof T=="string"){w=T;try{T=D.URI.parse(T)}catch{return Promise.reject(`Invalid uri - '${T}'`)}}return(0,E.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this.b.$openUri(T,w,m)}async asExternalUri(T,m){if((0,E.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(T,m);return D.URI.from(w)}};P.a={focused:!0},P=qe([Ve(0,S.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,O.createDecorator)("IExtHostWindow")}),define(Te[240],Pe([1,0,210,27,18]),function(te,e,n,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let N=class extends n.AbstractExtHostConsoleForwarder{constructor(O,S){super(O,S)}f(O,S,P){S.apply(console,P)}};N=qe([Ve(0,D.IExtHostRpcService),Ve(1,A.IExtHostInitDataService)],N),e.ExtHostConsoleForwarder=N}),define(Te[241],Pe([1,0,17,25,21,11,4,6,128,204,46]),function(te,e,n,A,D,N,E,O,S,P,M){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const w="$$ref$$",f={[w]:-1};class u{constructor(C,H){this.jsonString=C,this.referencedBuffers=H}}function t(y,C=null,H=!1){const K=[];return{jsonString:(H?m:JSON.stringify)(y,(_,j)=>{if(typeof j>"u")return f;if(typeof j=="object"){if(j instanceof A.VSBuffer){const L=K.push(j)-1;return{[w]:L}}if(C)return C(_,j)}return j}),referencedBuffers:K}}e.stringifyJsonWithBufferRefs=t;function a(y,C,H){return JSON.parse(y,(K,Q)=>{if(Q){const _=Q[w];if(typeof _=="number")return C[_];if(H&&Q.$mid===1)return H.transformIncoming(Q)}return Q})}e.parseJsonAndRestoreBufferRefs=a;function p(y,C){return JSON.stringify(y,C)}function b(y){return y?(C,H)=>H&&H.$mid===1?y.transformOutgoing(H):H:null}var R;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(R=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},d=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class l extends O.Disposable{constructor(C,H=null,K=null){super(),this[T]=!0,this.b=this.B(new E.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=H,this.g=K,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let Q=0,_=M.ProxyIdentifier.count;Q<_;Q++)this.k[Q]=null,this.l[Q]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new n.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(Q=>this.G(Q))}dispose(){this.j=!0,Object.keys(this.s).forEach(C=>{this.s[C].resolveErr(N.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(C){this.u===0&&(this.v=Date.now()+l.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(C){this.v=Date.now()+l.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(C){this.t!==C&&(this.t=C,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(C){return this.g?(0,S.transformIncomingURIs)(C,this.g):C}getProxy(C){const{nid:H,sid:K}=C;return this.l[H]||(this.l[H]=this.F(H,K)),this.l[H]}F(C,H){const K={get:(Q,_)=>(typeof _=="string"&&!Q[_]&&_.charCodeAt(0)===36&&(Q[_]=(...j)=>this.O(C,_,j)),_===s?H:Q[_])};return new Proxy(Object.create(null),K)}set(C,H){return this.k[C.nid]=H,H}assertRegistered(C){for(let H=0,K=C.length;H<K;H++){const Q=C[H];if(!this.k[Q.nid])throw new Error(`Missing proxy instance ${Q.sid}`)}}G(C){if(this.j)return;const H=C.byteLength,K=o.read(C,0),Q=K.readUInt8(),_=K.readUInt32();switch(Q){case 1:case 2:{let{rpcId:j,method:L,args:g}=r.deserializeRequestJSONArgs(K);this.g&&(g=(0,S.transformIncomingURIs)(g,this.g)),this.H(H,_,j,L,g,Q===2);break}case 3:case 4:{let{rpcId:j,method:L,args:g}=r.deserializeRequestMixedArgs(K);this.g&&(g=(0,S.transformIncomingURIs)(g,this.g)),this.H(H,_,j,L,g,Q===4);break}case 5:{this.f?.logIncoming(H,_,0,"ack"),this.z(_);break}case 6:{this.I(H,_);break}case 7:{this.J(H,_,void 0);break}case 9:{let j=r.deserializeReplyOKJSON(K);this.g&&(j=(0,S.transformIncomingURIs)(j,this.g)),this.J(H,_,j);break}case 10:{const j=r.deserializeReplyOKJSONWithBuffers(K,this.g);this.J(H,_,j);break}case 8:{const j=r.deserializeReplyOKVSBuffer(K);this.J(H,_,j);break}case 11:{let j=r.deserializeReplyErrError(K);this.g&&(j=(0,S.transformIncomingURIs)(j,this.g)),this.L(H,_,j);break}case 12:{this.L(H,_,void 0);break}default:console.error("received unexpected message"),console.error(C)}}H(C,H,K,Q,_,j){this.f?.logIncoming(C,H,1,`receiveRequest ${(0,M.getStringIdentifierForProxy)(K)}.${Q}(`,_);const L=String(H);let g,F;if(j){const Y=new D.CancellationTokenSource;_.push(Y.token),g=this.M(K,Q,_),F=()=>Y.cancel()}else g=this.M(K,Q,_),F=i;this.p[L]=F;const B=r.serializeAcknowledged(H);this.f?.logOutgoing(B.byteLength,H,1,"ack"),this.c.send(B),g.then(Y=>{delete this.p[L];const me=r.serializeReplyOK(H,Y,this.h);this.f?.logOutgoing(me.byteLength,H,1,"reply:",Y),this.c.send(me)},Y=>{delete this.p[L];const me=r.serializeReplyErr(H,Y);this.f?.logOutgoing(me.byteLength,H,1,"replyErr:",Y),this.c.send(me)})}I(C,H){this.f?.logIncoming(C,H,1,"receiveCancel");const K=String(H);this.p[K]?.()}J(C,H,K){this.f?.logIncoming(C,H,0,"receiveReply:",K);const Q=String(H);if(!this.s.hasOwnProperty(Q))return;const _=this.s[Q];delete this.s[Q],_.resolveOk(K)}L(C,H,K){this.f?.logIncoming(C,H,0,"receiveReplyErr:",K);const Q=String(H);if(!this.s.hasOwnProperty(Q))return;const _=this.s[Q];delete this.s[Q];let j;K&&(K.$isError?(j=new Error,j.name=K.name,j.message=K.message,j.stack=K.stack):j=K),_.resolveErr(j)}M(C,H,K){try{return Promise.resolve(this.N(C,H,K))}catch(Q){return Promise.reject(Q)}}N(C,H,K){const Q=this.k[C];if(!Q)throw new Error("Unknown actor "+(0,M.getStringIdentifierForProxy)(C));const _=Q[H];if(typeof _!="function")throw new Error("Unknown method "+H+" on actor "+(0,M.getStringIdentifierForProxy)(C));return _.apply(Q,K)}O(C,H,K){if(this.j)return new P.CanceledLazyPromise;let Q=null;if(K.length>0&&D.CancellationToken.isCancellationToken(K[K.length-1])&&(Q=K.pop()),Q&&Q.isCancellationRequested)return Promise.reject(N.canceled());const _=r.serializeRequestArguments(K,this.h),j=++this.m,L=String(j),g=new P.LazyPromise;Q&&Q.onCancellationRequested(()=>{const B=r.serializeCancel(j);this.f?.logOutgoing(B.byteLength,j,0,"cancel"),this.c.send(r.serializeCancel(j))}),this.s[L]=g,this.y(j);const F=r.serializeRequest(j,C,H,_,!!Q);return this.f?.logOutgoing(F.byteLength,j,0,`request: ${(0,M.getStringIdentifierForProxy)(C)}.${H}(`,K),this.c.send(F),g}}T=d,l.a=3*1e3,e.RPCProtocol=l;class o{static alloc(C,H,K){const Q=new o(A.VSBuffer.alloc(K+1+4),0);return Q.writeUInt8(C),Q.writeUInt32(H),Q}static read(C,H){return new o(C,H)}get buffer(){return this.a}constructor(C,H){this.a=C,this.b=H}static sizeUInt8(){return 1}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+C).toString();return this.b+=C,K}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+C).toString();return this.b+=C,K}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const H=this.a.slice(this.b,this.b+C);return this.b+=C,H}static sizeMixedArray(C){let H=0;H+=1;for(let K=0,Q=C.length;K<Q;K++){const _=C[K];switch(H+=1,_.type){case 1:H+=this.sizeLongString(_.value);break;case 2:H+=this.sizeVSBuffer(_.value);break;case 3:H+=this.sizeUInt32,H+=this.sizeLongString(_.value);for(let j=0;j<_.buffers.length;++j)H+=this.sizeVSBuffer(_.buffers[j]);break;case 4:break}}return H}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let H=0,K=C.length;H<K;H++){const Q=C[H];switch(Q.type){case 1:this.writeUInt8(1),this.writeLongString(Q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(Q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(Q.buffers.length),this.writeLongString(Q.value);for(let _=0;_<Q.buffers.length;++_)this.writeBuffer(Q.buffers[_]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const H=new Array(C);for(let K=0;K<C;K++)switch(this.readUInt8()){case 1:H[K]=this.readLongString();break;case 2:H[K]=this.readVSBuffer();break;case 3:{const _=this.readUInt32(),j=this.readLongString(),L=[];for(let g=0;g<_;++g)L.push(this.readVSBuffer());H[K]=new M.SerializableObjectWithBuffers(a(j,L,null));break}case 4:H[K]=void 0;break}return H}}o.sizeUInt32=4;var I;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(I||(I={}));class r{static a(C){for(let H=0,K=C.length;H<K;H++)if(C[H]instanceof A.VSBuffer||C[H]instanceof M.SerializableObjectWithBuffers||typeof C[H]>"u")return!0;return!1}static serializeRequestArguments(C,H){if(this.a(C)){const K=[];for(let Q=0,_=C.length;Q<_;Q++){const j=C[Q];if(j instanceof A.VSBuffer)K[Q]={type:2,value:j};else if(typeof j>"u")K[Q]={type:4};else if(j instanceof M.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:g}=t(j.value,H);K[Q]={type:3,value:A.VSBuffer.fromString(L),buffers:g}}else K[Q]={type:1,value:A.VSBuffer.fromString(p(j,H))}}return{type:1,args:K}}return{type:0,args:p(C,H)}}static serializeRequest(C,H,K,Q,_){switch(Q.type){case 0:return this.b(C,H,K,Q.args,_);case 1:return this.c(C,H,K,Q.args,_)}}static b(C,H,K,Q,_){const j=A.VSBuffer.fromString(K),L=A.VSBuffer.fromString(Q);let g=0;g+=o.sizeUInt8(),g+=o.sizeShortString(j),g+=o.sizeLongString(L);const F=o.alloc(_?2:1,C,g);return F.writeUInt8(H),F.writeShortString(j),F.writeLongString(L),F.buffer}static deserializeRequestJSONArgs(C){const H=C.readUInt8(),K=C.readShortString(),Q=C.readLongString();return{rpcId:H,method:K,args:JSON.parse(Q)}}static c(C,H,K,Q,_){const j=A.VSBuffer.fromString(K);let L=0;L+=o.sizeUInt8(),L+=o.sizeShortString(j),L+=o.sizeMixedArray(Q);const g=o.alloc(_?4:3,C,L);return g.writeUInt8(H),g.writeShortString(j),g.writeMixedArray(Q),g.buffer}static deserializeRequestMixedArgs(C){const H=C.readUInt8(),K=C.readShortString(),Q=C.readMixedArray(),_=new Array(Q.length);for(let j=0,L=Q.length;j<L;j++){const g=Q[j];typeof g=="string"?_[j]=JSON.parse(g):_[j]=g}return{rpcId:H,method:K,args:_}}static serializeAcknowledged(C){return o.alloc(5,C,0).buffer}static serializeCancel(C){return o.alloc(6,C,0).buffer}static serializeReplyOK(C,H,K){if(typeof H>"u")return this.d(C);if(H instanceof A.VSBuffer)return this.e(C,H);if(H instanceof M.SerializableObjectWithBuffers){const{jsonString:Q,referencedBuffers:_}=t(H.value,K,!0);return this.g(C,Q,_)}else return this.f(C,m(H,K))}static d(C){return o.alloc(7,C,0).buffer}static e(C,H){let K=0;K+=o.sizeVSBuffer(H);const Q=o.alloc(8,C,K);return Q.writeVSBuffer(H),Q.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,H){const K=A.VSBuffer.fromString(H);let Q=0;Q+=o.sizeLongString(K);const _=o.alloc(9,C,Q);return _.writeLongString(K),_.buffer}static g(C,H,K){const Q=A.VSBuffer.fromString(H);let _=0;_+=o.sizeUInt32,_+=o.sizeLongString(Q);for(const L of K)_+=o.sizeVSBuffer(L);const j=o.alloc(10,C,_);j.writeUInt32(K.length),j.writeLongString(Q);for(const L of K)j.writeBuffer(L);return j.buffer}static deserializeReplyOKJSON(C){const H=C.readLongString();return JSON.parse(H)}static deserializeReplyOKJSONWithBuffers(C,H){const K=C.readUInt32(),Q=C.readLongString(),_=[];for(let j=0;j<K;++j)_.push(C.readVSBuffer());return new M.SerializableObjectWithBuffers(a(Q,_,H))}static serializeReplyErr(C,H){const K=H?m(N.transformErrorForSerialization(H),null):void 0;if(typeof K!="string")return this.h(C);const Q=A.VSBuffer.fromString(K);let _=0;_+=o.sizeLongString(Q);const j=o.alloc(11,C,_);return j.writeLongString(Q),j.buffer}static deserializeReplyErrError(C){const H=C.readLongString();return JSON.parse(H)}static h(C){return o.alloc(12,C,0).buffer}}var c;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(c||(c={}));var h;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(h||(h={}))}),define(Te[242],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(N){const E=O=>{globalThis.removeEventListener("message",E);const S=O.data;Object.defineProperties(globalThis,{postMessage:{value(P,M){S.postMessage(P,M)}},onmessage:{get(){return S.onmessage},set(P){S.onmessage=P}}}),S.addEventListener("message",P=>{globalThis.dispatchEvent(new MessageEvent("message",{data:P.data}))}),S.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",E)}.toString();class A extends EventTarget{constructor(N,E,O){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${n})('${E}'))`,P=new Blob([S],{type:"application/javascript"}),M=URL.createObjectURL(P),T=new MessageChannel,m=M,w={type:"_newWorker",id:m,port:T.port2,url:M,options:O};N(w,[T.port2]),this.postMessage=T.port1.postMessage.bind(T.port1),this.terminate=()=>{N({type:"_terminateWorker",id:m}),URL.revokeObjectURL(M),T.port1.close(),T.port2.close()},Object.defineProperties(this,{onmessage:{get(){return T.port1.onmessage},set(f){T.port1.onmessage=f}},onmessageerror:{get(){return T.port1.onmessageerror},set(f){T.port1.onmessageerror=f}}}),T.port1.addEventListener("messageerror",f=>{const u=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(u)}),T.port1.addEventListener("message",f=>{const u=new MessageEvent("message",{data:f.data});this.dispatchEvent(u)}),T.port1.start()}}e.NestedWorker=A}),define(Te[243],Pe([1,0,4,30,36,3]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,N.createDecorator)("outputService");var E;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(E=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new n.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new n.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(P){this.a.has(P.id)||(this.a.set(P.id,P),this.b.fire(P.id))}getChannels(){const P=[];return this.a.forEach(M=>P.push(M)),P}getChannel(P){return this.a.get(P)}removeChannel(P){this.a.delete(P),this.c.fire(P)}}A.Registry.add(e.Extensions.OutputChannels,new O),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(Te[106],Pe([1,0,5,3,18,24,12,243,60,27,37,122,25,9,43,4,6]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class a extends E.AbstractMessageLogger{get disposed(){return this.l}constructor(v,i,d,s,l){super(),this.id=v,this.name=i,this.m=d,this.n=s,this.extension=l,this.k=0,this.l=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(o=>this.setLevel(o)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.k;this.m.flush(),this.n.$update(this.id,O.OutputChannelUpdateMode.Clear,v)}replace(v){const i=this.k;this.info(v),this.n.$update(this.id,O.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(v,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof v=="boolean"?v:i))}hide(){this.n.$close(this.id)}g(v,i){this.k+=m.VSBuffer.fromString(i).byteLength,(0,E.log)(this.m,v,i),this.visible&&(this.m.flush(),this.n.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class p extends a{appendLine(v){this.append(v)}}let b=class{constructor(v,i,d,s,l,o){this.i=i,this.j=d,this.k=s,this.l=l,this.m=o,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(n.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[i,d]of this.g)d.visible=i===this.h}createOutputChannel(v,i,d){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const s=typeof i=="object"&&i.log,l=(0,w.isString)(i)?i:void 0;if((0,w.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let o;const I=this.i.environment.extensionLogLevel?.find(([c])=>N.ExtensionIdentifier.equals(d.identifier,c))?.[1];I&&(o=(0,E.parseLogLevel)(I));const r=s?this.o(v,o,d):this.n(v,l,d);return r.then(c=>{this.g.set(c.id,c),c.visible=c.id===this.h}),s?this.r(v,o??this.m.getLevel(),r):this.q(v,r)}async n(v,i,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,l=this.k.extUri.joinPath(s,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.a.$register(v,l,i,d.identifier.value);return new a(I,v,o,this.a,d)}async o(v,i,d){const s=await this.p(d),l=this.k.extUri.joinPath(s,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=l.toString(),I=this.l.createLogger(l,{id:o,name:v,logLevel:i,extensionId:d.identifier.value});return new p(o,v,I,this.a,d)}p(v){let i=this.d.get(v.identifier.value);if(!i){const d=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(d)}catch(s){if((0,f.toFileSystemProviderErrorCode)(s)!==f.FileSystemProviderErrorCode.FileExists)throw s}return d})())}return i}q(v,i){let d=!1;const s=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return v},append(l){s(),i.then(o=>o.append(l))},appendLine(l){s(),i.then(o=>o.appendLine(l))},clear(){s(),i.then(l=>l.clear())},replace(l){s(),i.then(o=>o.replace(l))},show(l,o){s(),i.then(I=>I.show(l,o))},hide(){s(),i.then(l=>l.hide())},dispose(){d=!0,i.then(l=>l.dispose())}}}r(v,i,d){const s=new t.DisposableStore,l=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},o=s.add(new u.Emitter);function I(r){i=r,o.fire(r)}return d.then(r=>{s.add(r),r.logLevel!==i&&I(r.logLevel),s.add(r.onDidChangeLogLevel(c=>I(c)))}),{...this.q(v,d),get logLevel(){return i},onDidChangeLogLevel:o.event,trace(r,...c){l(),d.then(h=>h.trace(r,...c))},debug(r,...c){l(),d.then(h=>h.debug(r,...c))},info(r,...c){l(),d.then(h=>h.info(r,...c))},warn(r,...c){l(),d.then(h=>h.warn(r,...c))},error(r,...c){l(),d.then(h=>h.error(r,...c))},dispose(){s.dispose()}}}};b=qe([Ve(0,D.IExtHostRpcService),Ve(1,P.IExtHostInitDataService),Ve(2,S.IExtHostConsumerFileSystem),Ve(3,M.IExtHostFileSystemInfo),Ve(4,E.ILoggerService),Ve(5,E.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(Te[244],Pe([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Te[245],Pe([1,0,41,15,19,20,22,2,3,176,53,192,244]),function(te,e,n,A,D,N,E,O,S,P,M,T,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let w=class cn{constructor(u,t,a,p){this.d=u,this.e=t,this.f=a,this.g=p,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??u})()}hasValidBasename(u,t,a){return typeof t=="string"||typeof t>"u"?this.a.then(p=>this.h(u,p,t)):this.h(u,t,a)}h(u,t,a){return u.scheme===A.Schemas.file||u.scheme===A.Schemas.vscodeRemote?(0,n.isValidBasename)(a??(0,E.basename)(u),t===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(u,t){if(u.remoteAuthority)return A.Schemas.vscodeRemote;const a=(0,P.getVirtualWorkspaceScheme)(t.getWorkspace());if(a)return a;const p=t.getWorkspace().folders[0];if(p)return p.uri.scheme;const b=t.getWorkspace().configuration;return b?b.scheme:A.Schemas.file}userHome(u){return u?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(u=>u===1?D.win32:D.posix)}async fileURI(u){let t="";if(await this.a===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const p=u.indexOf("/",2);p===-1?(t=u.substring(2),u="/"):(t=u.substring(2,p),u=u.substring(p)||"/")}return O.URI.from({scheme:A.Schemas.file,authority:t,path:u,query:"",fragment:""})}};w=qe([Ve(1,m.IRemoteAgentService),Ve(2,T.IWorkbenchEnvironmentService),Ve(3,M.IWorkspaceContextService)],w),e.AbstractPathService=w}),define(Te[107],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(E,O){this.line=E,this.character=O}isBefore(E){return!1}isBeforeOrEqual(E){return!1}isAfter(E){return!1}isAfterOrEqual(E){return!1}isEqual(E){return!1}compareTo(E){return 0}translate(E,O){return new n(0,0)}with(E){return new n(0,0)}}e.Position=n;class A{constructor(E,O,S,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(E,O),this.end=new n(S,P)}contains(E){return!1}isEqual(E){return!1}intersection(E){}union(E){return new A(0,0,0,0)}with(E){return new A(0,0,0,0)}}e.Range=A;var D;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Te[47],Pe([1,0,16,35,23,41,10,3,19,11,107,17]),function(te,e,n,A,D,N,E,O,S,P,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",w=" characters skipped \u27EB",f=(m.length+w.length+5)*2;e.ISearchService=(0,O.createDecorator)("searchService");var u;(function(se){se[se.file=0]="file",se[se.text=1]="text"})(u=e.SearchProviderType||(e.SearchProviderType={}));var t;(function(se){se[se.File=1]="File",se[se.Text=2]="Text"})(t=e.QueryType||(e.QueryType={}));function a(se){return!!se.preview}e.resultIsMatch=a;function p(se){return!!se.resource}e.isFileMatch=p;function b(se){return!!se.message}e.isProgressMessage=b;var R;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(R=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=v;class i{constructor(ue,De,de){this.ranges=De;const ie=Array.isArray(De)?De:[De];if(de&&de.matchLines===1&&d(ie)){ue=(0,E.getNLines)(ue,de.matchLines);let q="",ce=0,be=0;const Ae=Math.floor(de.charsPerLine/5),Ue=[];for(const Ce of ie){const Se=Math.max(Ce.startColumn-Ae,0),ke=Ce.startColumn+de.charsPerLine;if(Se>be+Ae+f){const oe=m+(Se-be)+w;q+=oe+ue.slice(Se,ke),ce+=Se-(be+oe.length)}else q+=ue.slice(be,ke);Ue.push(new l(0,Ce.startColumn-ce,Ce.endColumn-ce)),be=ke}this.preview={text:q,matches:Array.isArray(this.ranges)?Ue:Ue[0]}}else{const q=Array.isArray(De)?De[0].startLineNumber:De.startLineNumber;this.preview={text:ue,matches:(0,n.mapArrayOrNot)(De,ce=>new s(ce.startLineNumber-q,ce.startColumn,ce.endLineNumber-q,ce.endColumn))}}}}e.TextSearchMatch=i;function d(se){const ue=se[0].startLineNumber;for(const De of se)if(De.startLineNumber!==ue||De.endLineNumber!==ue)return!1;return!0}class s{constructor(ue,De,de,ie){this.startLineNumber=ue,this.startColumn=De,this.endLineNumber=de,this.endColumn=ie}}e.SearchRange=s;class l extends s{constructor(ue,De,de){super(ue,De,ue,de)}}e.OneLineRange=l;var o;(function(se){se.List="list",se.Tree="tree"})(o=e.ViewMode||(e.ViewMode={}));var I;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(I=e.SearchSortOrder||(e.SearchSortOrder={}));function r(se,ue=!0){const De=se&&se.files&&se.files.exclude,de=ue&&se&&se.search&&se.search.exclude;if(!De&&!de)return;if(!De||!de)return De||de;let ie=Object.create(null);return ie=D.mixin(ie,D.deepClone(De)),ie=D.mixin(ie,D.deepClone(de),!0),ie}e.getExcludes=r;function c(se,ue){return se.excludePattern&&A.match(se.excludePattern,ue)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&A.match(se.includePattern,ue)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some(De=>{const de=De.folder.fsPath;if(N.isEqualOrParent(ue,de)){const ie=S.relative(de,ue);return!De.includePattern||!!A.match(De.includePattern,ie)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var h;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class y extends Error{constructor(ue,De){super(ue),this.code=De}}e.SearchError=y;function C(se){const ue=se.message;if((0,P.isCancellationError)(se))return new y(ue,h.canceled);try{const De=JSON.parse(ue);return new y(De.message,De.code)}catch{return new y(ue,h.other)}}e.deserializeSearchError=C;function H(se){const ue={message:se.message,code:se.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=H;function K(se){return se.type==="error"?!0:se.type==="success"}e.isSerializedSearchComplete=K;function Q(se){return se.type==="success"}e.isSerializedSearchSuccess=Q;function _(se){return!!se.path}e.isSerializedFileMatch=_;function j(se,ue){const De=se.searchPath?se.searchPath:se.relativePath;return(0,E.fuzzyContains)(De,ue)}e.isFilePatternMatch=j;class L{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=L;function g(se,ue){const De={...se||{},...ue||{}};return Object.keys(De).filter(de=>{const ie=De[de];return typeof ie=="boolean"&&ie})}e.resolvePatternsForProvider=g;class F{constructor(ue,De){this.c=null,this.a={...ue.excludePattern||{},...De.excludePattern||{}},this.b=A.parse(this.a);let de=ue.includePattern;De.includePattern&&(de?de={...de,...De.includePattern}:de=De.includePattern),de&&(this.c=A.parse(de))}matchesExcludesSync(ue,De,de){return!!(this.b&&this.b(ue,De,de))}includedInQuerySync(ue,De,de){return!(this.b&&this.b(ue,De,de)||this.c&&!this.c(ue,De,de))}includedInQuery(ue,De,de){const ie=this.b(ue,De,de),q=()=>this.c?!!this.c(ue,De,de):!0;return(0,T.isThenable)(ie)?ie.then(ce=>ce?!1:q()):q()}hasSiblingExcludeClauses(){return B(this.a)}}e.QueryGlobTester=F;function B(se){for(const ue in se)if(typeof se[ue]!="boolean")return!0;return!1}function Y(se){if(!se)return;let ue;return De=>(ue||(ue=(se()||Promise.resolve([])).then(de=>de?Z(de):{})),ue.then(de=>!!de[De]))}e.hasSiblingPromiseFn=Y;function me(se){if(!se)return;let ue;return De=>{if(!ue){const de=se();ue=de?Z(de):{}}return!!ue[De]}}e.hasSiblingFn=me;function Z(se){const ue={};for(const De of se)ue[De]=!0;return ue}}),define(Te[31],Pe([1,0,16,17,21,4,6,48,15,114,22,10,9,2,147,3,12,164,53,37,27,18,8,7,55,47,5]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t,a,p,b,R,v,i,d,s,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function I(Q,_,j){return new M.ExtUri(L=>y(L,j)).isEqual(Q,_)}function r(Q,_,j){return I(Q.uri,_.uri,j)?0:(0,T.compare)(Q.uri.toString(),_.uri.toString())}function c(Q,_,j){return Q.index!==_.index?Q.index<_.index?-1:1:I(Q.uri,_.uri,j)?(0,T.compare)(Q.name,_.name):(0,T.compare)(Q.uri.toString(),_.uri.toString())}function h(Q,_,j,L){const g=Q.slice(0).sort((B,Y)=>j(B,Y,L)),F=_.slice(0).sort((B,Y)=>j(B,Y,L));return(0,n.delta)(g,F,(B,Y)=>j(B,Y,L))}function y(Q,_){const j=_.getCapabilities(Q.scheme);return!(j&&j&1024)}class C extends p.Workspace{static toExtHostWorkspace(_,j,L,g){if(!_)return{workspace:null,added:[],removed:[]};const{id:F,name:B,folders:Y,configuration:me,transient:Z,isUntitled:se}=_,ue=[],De=j;j?Y.forEach((ce,be)=>{const Ae=w.URI.revive(ce.uri),Ue=C.o(L||j,Ae,g);Ue?(Ue.name=ce.name,Ue.index=ce.index,ue.push(Ue)):ue.push({uri:Ae,name:ce.name,index:be})}):ue.push(...Y.map(({uri:ce,name:be,index:Ae})=>({uri:w.URI.revive(ce),name:be,index:Ae}))),ue.sort((ce,be)=>ce.index<be.index?-1:1);const de=new C(F,B,ue,!!Z,me?w.URI.revive(me):null,!!se,ce=>y(ce,g)),{added:ie,removed:q}=h(De?De.workspaceFolders:[],de.workspaceFolders,r,g);return{workspace:de,added:ie,removed:q}}static o(_,j,L){for(let g=0;g<_.folders.length;g++){const F=_.workspaceFolders[g];if(I(F.uri,j,L))return F}}constructor(_,j,L,g,F,B,Y){super(_,L.map(me=>new p.WorkspaceFolder(me)),g,F,Y),this.t=j,this.u=B,this.q=[],this.s=O.TernarySearchTree.forUris(Y),L.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(_,j){return j&&this.s.get(_)&&(_=(0,M.dirname)(_)),this.s.findSubstr(_)}resolveWorkspaceFolder(_){return this.s.get(_)}}let H=class{constructor(_,j,L,g,F){this.c=new N.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new N.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new N.AsyncEmitter,this.h=g,this.s=L,this.t=F,this.j=new P.Counter,this.k=new A.Barrier,this.o=_.getProxy(o.MainContext.MainThreadWorkspace),this.q=_.getProxy(o.MainContext.MainThreadMessageService);const B=j.workspace;this.l=B?new C(B.id,B.name,[],!!B.transient,B.configuration?w.URI.revive(B.configuration):null,!!B.isUntitled,Y=>y(Y,L)):void 0}$initializeWorkspace(_,j){this.v=j,this.$acceptWorkspaceData(_),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?w.URI.from({scheme:S.Schemas.untitled,path:(0,M.basename)((0,M.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(_,j,L,...g){const F=[];if(Array.isArray(g)&&g.forEach(se=>{w.URI.isUri(se.uri)&&!F.some(ue=>I(ue.uri,se.uri,this.s))&&F.push({uri:se.uri,name:se.name||(0,M.basenameOrAuthority)(se.uri)})}),this.n||[j,L].some(se=>typeof se!="number"||se<0)||L===0&&F.length===0)return!1;const B=this.x?this.x.workspaceFolders:[];if(j+L>B.length)return!1;const Y=B.slice(0);Y.splice(j,L,...F.map(se=>({uri:se.uri,name:se.name||(0,M.basenameOrAuthority)(se.uri),index:void 0})));for(let se=0;se<Y.length;se++){const ue=Y[se];if(Y.some((De,de)=>de!==se&&I(ue.uri,De.uri,this.s)))return!1}Y.forEach((se,ue)=>se.index=ue);const{added:me,removed:Z}=h(B,Y,c,this.s);if(me.length===0&&Z.length===0)return!1;if(this.o){const se=_.displayName||_.name;this.o.$updateWorkspaceFolders(se,j,L,F).then(void 0,ue=>{this.n=void 0;const De={source:{identifier:_.identifier,label:_.displayName||_.name}};this.q.$showMessage(a.Severity.Error,(0,f.localize)(0,null,se,ue.toString()),De,[])})}return this.y(Y),!0}getWorkspaceFolder(_,j){if(!!this.x)return this.x.getWorkspaceFolder(_,j)}async getWorkspaceFolder2(_,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(_,j)}async resolveWorkspaceFolder(_){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(_)}getPath(){if(!this.x)return;const{folders:_}=this.x;if(_.length!==0)return _[0].uri.fsPath}getRelativePath(_,j){let L,g="";if(typeof _=="string"?(L=w.URI.file(_),g=_):typeof _<"u"&&(L=_,g=_.fsPath),!L)return g;const F=this.getWorkspaceFolder(L,!0);if(!F)return g;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let B=(0,M.relativePath)(F.uri,L);return j&&F.name&&(B=`${F.name}/${B}`),B}y(_){this.x&&(this.n=C.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:_,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(_){const{workspace:j,added:L,removed:g}=C.toExtHostWorkspace(_,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:g}))}findFiles(_,j,L,g,F=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${g.value}, entryPoint: findFiles`);let B;if(j===null?B=!1:j&&(typeof j=="string"?B=j:B=j.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:Y,folder:me}=K(i.GlobPattern.from(_));return this.o.$startFileSearch((0,m.withUndefinedAsNull)(Y),(0,m.withUndefinedAsNull)(me),(0,m.withUndefinedAsNull)(B),(0,m.withUndefinedAsNull)(L),F).then(Z=>Array.isArray(Z)?Z.map(se=>w.URI.revive(se)):[])}async findTextInFiles(_,j,L,g,F=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${g.value}, entryPoint: findTextInFiles`);const B=this.j.getNext(),Y=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:me,folder:Z}=K(i.GlobPattern.from(j.include)),se=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,ue={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:Y,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:me,excludePattern:se},De=!1;if(this.u[B]=de=>{if(De)return;const ie=w.URI.revive(de.resource);de.results.forEach(q=>{(0,l.resultIsMatch)(q)?L({uri:ie,preview:{text:q.preview.text,matches:(0,n.mapArrayOrNot)(q.preview.matches,ce=>new d.Range(ce.startLineNumber,ce.startColumn,ce.endLineNumber,ce.endColumn))},ranges:(0,n.mapArrayOrNot)(q.ranges,ce=>new d.Range(ce.startLineNumber,ce.startColumn,ce.endLineNumber,ce.endColumn))}):L({uri:ie,text:q.text,lineNumber:q.lineNumber})})},F.isCancellationRequested)return{};try{const de=await this.o.$startTextSearch(_,(0,m.withUndefinedAsNull)(Z),ue,B,F);return delete this.u[B],de||{}}catch(de){throw delete this.u[B],de}}$handleTextSearchResult(_,j){this.u[j]?.(_)}saveAll(_){return this.o.$saveAll(_)}resolveProxy(_){return this.o.$resolveProxy(_)}get trusted(){return this.v}requestWorkspaceTrust(_){return this.o.$requestWorkspaceTrust(_)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(_,j){if(this.w.has(_))throw new Error(`A provider has already been registered for scheme ${_}`);this.w.set(_,j);const L=this.t.transformOutgoingScheme(_),g=this.z++;return this.o.$registerEditSessionIdentityProvider(g,L),(0,E.toDisposable)(()=>{this.w.delete(_),this.o.$unregisterEditSessionIdentityProvider(g)})}async $getEditSessionIdentifier(_,j){this.h.info("Getting edit session identifier for workspaceFolder",_);const L=await this.resolveWorkspaceFolder(w.URI.revive(_));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const g=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!g),!g)return;const F=await g.provideEditSessionIdentity(L,j);if(this.h.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch(_,j,L,g){this.h.info("Getting edit session identifier for workspaceFolder",_);const F=await this.resolveWorkspaceFolder(w.URI.revive(_));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const B=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!B),!B)return;const Y=await B.provideEditSessionIdentityMatch?.(j,L,g);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(_){return(j,L,g)=>{const F=function(Y){j.call(L,Y)};return F.extension=_,this.A.event(F,void 0,g)}}async $onWillCreateEditSessionIdentity(_,j,L){const g=await this.resolveWorkspaceFolder(w.URI.revive(_));if(g===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:g},j,async(F,B)=>{const Y=Date.now();await Promise.resolve(F),Date.now()-Y>L&&this.h.warn("SLOW edit session create-participant",B.extension.identifier)}),j.isCancellationRequested}};H=qe([Ve(0,v.IExtHostRpcService),Ve(1,R.IExtHostInitDataService),Ve(2,b.IExtHostFileSystemInfo),Ve(3,t.ILogService),Ve(4,s.IURITransformerService)],H),e.ExtHostWorkspace=H,e.IExtHostWorkspace=(0,u.createDecorator)("IExtHostWorkspace");function K(Q){let _,j;return Q&&(typeof Q=="string"?_=Q:(_=Q.pattern,j=w.URI.revive(Q.baseUri))),{includePattern:_,folder:j}}}),define(Te[32],Pe([1,0,23,4,31,5,7,167,93,9,17,3,18,12,2]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(d,s){if(s){const l=s.split(".");let o=d;for(let I=0;o&&I<l.length;I++)o=o[l[I]];return o}}function t(d){return d instanceof f.URI}function a(d){return d&&d.uri instanceof f.URI&&d.languageId&&typeof d.languageId=="string"}function p(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function b(d){return d&&d.uri instanceof f.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function R(d){if(t(d))return{resource:d};if(a(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(p(d))return{overrideIdentifier:d.languageId};if(b(d))return{resource:d.uri};if(d===null)return{resource:null}}let v=class{constructor(s,l,o){this.a=s.getProxy(N.MainContext.MainThreadConfiguration),this.c=l,this.b=o,this.d=new M.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new i(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,l){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,l))}};v=qe([Ve(0,m.IExtHostRpcService),Ve(1,D.IExtHostWorkspace),Ve(2,w.ILogService)],v),e.ExtHostConfiguration=v;class i{constructor(s,l,o,I){this.a=new A.Emitter,this.b=s,this.f=I,this.c=l,this.e=O.Configuration.parse(o),this.d=this.k(o.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,l){const o={data:this.e.toData(),workspace:this.c.workspace};this.e=O.Configuration.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(l,o))}getConfiguration(s,l,o){const I=R(l)||{},r=this.g(s?u(this.e.getValue(void 0,I,this.c.workspace),s):this.e.getValue(void 0,I,this.c.workspace));s&&this.h(s,I,o?.identifier);function c(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case E.ConfigurationTarget.Global:return 2;case E.ConfigurationTarget.Workspace:return 5;case E.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(y){return typeof u(r,y)<"u"},get:(y,C)=>{this.h(s?`${s}.${y}`:y,I,o?.identifier);let H=u(r,y);if(typeof H>"u")H=C;else{let K;const Q=(_,j)=>{let L;const g=()=>{K=K||(0,n.deepClone)(r),L=L||u(K,j)};return(0,P.isObject)(_)?new Proxy(_,{get:(F,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return g(),()=>L;if(K)return L=L||u(K,j),L[B];const Y=F[B];return typeof B=="string"?Q(Y,`${j}.${B}`):Y},set:(F,B,Y)=>(g(),L&&(L[B]=Y),!0),deleteProperty:(F,B)=>(g(),L&&delete L[B],!0),defineProperty:(F,B,Y)=>(g(),L&&Object.defineProperty(L,B,Y),!0)}):_};H=Q(H,y)}return H},update:(y,C,H,K)=>{y=s?`${s}.${y}`:y;const Q=c(H);return C!==void 0?this.b.$updateConfigurationOption(Q,y,C,I,K):this.b.$removeConfigurationOption(Q,y,I,K)},inspect:y=>{y=s?`${s}.${y}`:y;const C=this.e.inspect(y,I,this.c.workspace);if(C)return{key:y,defaultValue:(0,n.deepClone)(C.policy?.value??C.default?.value),globalValue:(0,n.deepClone)(C.user?.value??C.application?.value),workspaceValue:(0,n.deepClone)(C.workspace?.value),workspaceFolderValue:(0,n.deepClone)(C.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(C.default?.override),globalLanguageValue:(0,n.deepClone)(C.user?.override??C.application?.override),workspaceLanguageValue:(0,n.deepClone)(C.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(C.workspaceFolder?.override),languageIds:(0,n.deepClone)(C.overrideIdentifiers)}}};return typeof r=="object"&&(0,n.mixin)(h,r,!1),Object.freeze(h)}g(s){const l=o=>(0,P.isObject)(o)?new Proxy(o,{get:(I,r)=>l(I[r]),set:(I,r,c)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(r)}' of object`)},deleteProperty:(I,r)=>{throw new Error(`TypeError: Cannot delete read only property '${String(r)}' of object`)},defineProperty:(I,r)=>{throw new Error(`TypeError: Cannot define property '${String(r)}' for a readonly object`)},setPrototypeOf:I=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return l(s)}h(s,l,o){const I=S.OVERRIDE_PROPERTY_REGEX.test(s)?4:this.d.get(s),r=o?`[${o.value}] `:"";if(I===4){typeof l?.resource>"u"&&this.f.warn(`${r}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(I===3){l?.resource&&this.f.warn(`${r}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,l){const o=new O.ConfigurationChangeEvent(s,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(I,r)=>o.affectsConfiguration(I,R(r))})}k(s){return s.reduce((l,o)=>(l.set(o[0],o[1]),l),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,A,D){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Fe=this&&this.__classPrivateFieldGet||function(te,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!A:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(te):A?A.value:e.get(te)};define(Te[108],Pe([1,0,2,17,4,5,7,31,58,32,21,61,18,27,3,15,20,12,76,203,11]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t,a,p,b,R){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(_){function j(g){if(g!=null)return g}_.from=j;function L(g){if(g!=null)return g}_.to=L})(i||(i={}));var d;(function(_){function j(g){if(g!=null)return g}_.from=j;function L(g){if(g!=null)return g}_.to=L})(d||(d={}));var s;(function(_){function j(g){if(g!=null)return g}_.from=j;function L(g){if(g!=null)return g}_.to=L})(s||(s={}));var l;(function(_){function j(F){if(F){const B=F;return B&&!!B.process}else return!1}_.is=j;function L(F){if(F==null)return;const B={process:F.process,args:F.args};return F.options&&(B.options=s.from(F.options)),B}_.from=L;function g(F){if(F!=null)return new E.ProcessExecution(F.process,F.args,F.options)}_.to=g})(l||(l={}));var o;(function(_){function j(g){if(g!=null)return g}_.from=j;function L(g){if(g!=null)return g}_.to=L})(o||(o={}));var I;(function(_){function j(F){if(F){const B=F;return B&&(!!B.commandLine||!!B.command)}else return!1}_.is=j;function L(F){if(F==null)return;const B={};return F.commandLine!==void 0?B.commandLine=F.commandLine:(B.command=F.command,B.args=F.args),F.options&&(B.options=o.from(F.options)),B}_.from=L;function g(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new E.ShellExecution(F.commandLine,F.options):new E.ShellExecution(F.command,F.args?F.args:[],F.options)}_.to=g})(I||(I={}));var r;(function(_){function j(F){if(F){const B=F;return B&&B.customExecution==="customExecution"}else return!1}_.is=j;function L(F){return{customExecution:"customExecution"}}_.from=L;function g(F,B){return B.get(F)}_.to=g})(r=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var c;(function(_){function j(L,g){let F;return L.scope!==void 0&&typeof L.scope!="number"?F=L.scope.uri:L.scope!==void 0&&typeof L.scope=="number"&&(L.scope===E.TaskScope.Workspace&&g&&g.workspaceFile?F=g.workspaceFile:F=b.USER_TASKS_GROUP_KEY),{id:L._id,workspaceFolder:F}}_.from=j})(c=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(_){function j(L){if(L!=null)return{_id:L.id,isDefault:L.isDefault}}_.from=j})(h||(h={}));var y;(function(_){function j(F,B){if(F==null)return[];const Y=[];for(const me of F){const Z=L(me,B);Z&&Y.push(Z)}return Y}_.fromMany=j;function L(F,B){if(F==null)return;let Y;F.execution instanceof E.ProcessExecution?Y=l.from(F.execution):F.execution instanceof E.ShellExecution?Y=I.from(F.execution):F.execution&&F.execution instanceof E.CustomExecution&&(Y=r.from(F.execution));const me=i.from(F.definition);let Z;return F.scope?typeof F.scope=="number"?Z=F.scope:Z=F.scope.uri:Z=E.TaskScope.Workspace,!me||!Z?void 0:{_id:F._id,definition:me,name:F.name,source:{extensionId:B.identifier.value,label:F.source,scope:Z},execution:Y,isBackground:F.isBackground,group:h.from(F.group),presentationOptions:d.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}_.from=L;async function g(F,B,Y){if(F==null)return;let me;l.is(F.execution)?me=l.to(F.execution):I.is(F.execution)?me=I.to(F.execution):r.is(F.execution)&&(me=r.to(F._id,Y));const Z=i.to(F.definition);let se;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?se=F.source.scope:se=await B.resolveWorkspaceFolder(n.URI.revive(F.source.scope)):se=E.TaskScope.Workspace),!Z||!se)return;const ue=new E.Task(Z,se,F.name,F.source.label,me,F.problemMatchers);return F.isBackground!==void 0&&(ue.isBackground=F.isBackground),F.group!==void 0&&(ue.group=E.TaskGroup.from(F.group._id),ue.group&&F.group.isDefault&&(ue.group=new E.TaskGroup(ue.group.id,ue.group.label),F.group.isDefault===!0&&(ue.group.isDefault=F.group.isDefault))),F.presentationOptions&&(ue.presentationOptions=d.to(F.presentationOptions)),F._id&&(ue._id=F._id),F.detail&&(ue.detail=F.detail),ue}_.to=g})(y=e.TaskDTO||(e.TaskDTO={}));var C;(function(_){function j(g){return g}_.from=j;function L(g){if(!!g)return Object.assign(Object.create(null),g)}_.to=L})(C||(C={}));class H{constructor(j,L,g){this._id=L,this.a=g,v.set(this,void 0),Je(this,v,j,"f")}get task(){return this.a}terminate(){Fe(this,v,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}v=new WeakMap;let K=class{constructor(j,L,g,F,B,Y,me,Z){this.q=new D.Emitter,this.r=new D.Emitter,this.s=new D.Emitter,this.t=new D.Emitter,this.a=j.getProxy(N.MainContext.MainThreadTask),this.b=g,this.c=F,this.d=B,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=Z,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,L,g){if(!g)return new E.Disposable(()=>{});const F=this.w();return this.j.set(F,{type:L,provider:g,extension:j}),this.a.$registerTaskProvider(F,L),new E.Disposable(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(j,L){this.a.$registerTaskSystem(j,L)}fetchTasks(j){return this.a.$fetchTasks(C.from(j)).then(async L=>{const g=[];for(const F of L){const B=await y.to(F,this.b,this.m);B&&g.push(B)}return g})}get taskExecutions(){const j=[];return this.k.forEach(L=>j.push(L)),j}terminateTask(j){if(!(j instanceof H))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,L,g){const F=this.m.get(j.id);F&&(this.o.set(j.id,F),this.e.attachPtyToTerminal(L,await F.callback(g))),this.p=j.id,this.q.fire({execution:await this.y(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){const L=await this.y(j);this.l.delete(j.id),this.k.delete(j.id),this.A(j),this.r.fire({execution:L})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const L=await this.y(j.id);this.s.fire({execution:L,processId:j.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(j){const L=await this.y(j.id);this.t.fire({execution:L,exitCode:j.exitCode})}$provideTasks(j,L){const g=this.j.get(j);if(!g)return Promise.reject(new Error("no handler found"));const F=[],B=(0,A.asPromise)(()=>g.provider.provideTasks(M.CancellationToken.None)).then(Y=>this.u(L,F,g,Y));return new Promise(Y=>{B.then(me=>{Promise.all(F).then(()=>{Y(me)})})})}async $resolveTask(j,L){const g=this.j.get(j);if(!g)return Promise.reject(new Error("no handler found"));if(L.definition.type!==g.type)throw new Error(`Unexpected: Task of type [${L.definition.type}] cannot be resolved by provider of type [${g.type}].`);const F=await y.to(L,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const B=await g.provider.resolveTask(F,M.CancellationToken.None);if(!B)return;this.z(B,g);const Y=y.from(B,g.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return r.is(Y.execution)&&await this.x(Y,B,!0),await this.v(Y)}w(){return this.h++}async x(j,L,g){const F=await this.a.$createTaskId(j);!g&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,L.execution)),this.m.set(F,L.execution)}async y(j,L){if(typeof j=="string"){const B=this.l.get(j);if(!B)throw new R.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return B}const g=this.l.get(j.id);if(g)return g;const F=new Promise((B,Y)=>{function me(Z,se,ue){ue?B(new H(Z,se.id,ue)):Y("Unexpected: Task does not exist.")}L?me(this,j,L):y.to(j.task,this.b,this.m).then(Z=>me(this,j,Z))});return this.l.set(j.id,F),F.then(B=>(this.k.set(j.id,B),B),B=>Promise.reject(B))}z(j,L){j._deprecated&&this.g.report("Task.constructor",L.extension,"Use the Task constructor that takes a `scope` instead.")}A(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const g=this.n.values();let F=g.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=g.next()}};K=qe([Ve(0,m.IExtHostRpcService),Ve(1,w.IExtHostInitDataService),Ve(2,O.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,P.IExtHostConfiguration),Ve(5,T.IExtHostTerminalService),Ve(6,a.ILogService),Ve(7,p.IExtHostApiDeprecationService)],K),e.ExtHostTaskBase=K;let Q=class extends K{constructor(j,L,g,F,B,Y,me,Z){super(j,L,g,F,B,Y,me,Z),this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask(j,L){if(!L.execution)throw new Error("Tasks to execute must include an execution");const g=y.from(L,j);if(g===void 0)throw new Error("Task is not valid");if(r.is(g.execution))await this.x(g,L,!1);else throw new R.NotSupportedError;const F=await this.y(await this.a.$getTaskExecution(g),L);return this.a.$executeTask(g).catch(B=>{throw new Error(B)}),F}u(j,L,g,F){const B=[];if(F)for(const Y of F){this.z(Y,g),(!Y.definition||!j[Y.definition.type])&&this.f.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const me=y.from(Y,g.extension);me&&r.is(me.execution)?(B.push(me),L.push(this.x(me,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:g.extension}}async v(j){if(r.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,L){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,L,g){}};Q=qe([Ve(0,m.IExtHostRpcService),Ve(1,w.IExtHostInitDataService),Ve(2,O.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,P.IExtHostConfiguration),Ve(5,T.IExtHostTerminalService),Ve(6,a.ILogService),Ve(7,p.IExtHostApiDeprecationService)],Q),e.WorkerExtHostTask=Q,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Te[246],Pe([1,0,19,21,40,35,22,77,47]),function(te,e,n,A,D,N,E,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(m,w,f){this.k=m,this.l=w,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&N.parse(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&N.parse(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const w=this.k.folderQueries||[];return new Promise((f,u)=>{const t=a=>{this.f++,m(a)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const p=a.toString(),b=n.basename(p);this.j&&this.j(p,b)||this.v(t,{base:a,basename:b})}),Promise.all(w.map(a=>this.p(a,t))).then(a=>{f({limitHit:this.e,stats:a[0]||void 0})},a=>{u(new Error((0,D.toErrorMessage)(a)))})})}async p(m,w){const f=new A.CancellationTokenSource,u=this.q(m),t=this.r(),a=new S.QueryGlobTester(this.k,m),p=!a.hasSiblingExcludeClauses();let b;try{this.h.add(f),b=O.StopWatch.create();const R=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},u,f.token),v=b.elapsed(),i=O.StopWatch.create();return this.g&&!this.e||(R&&R.forEach(d=>{const s=n.posix.relative(m.folder.path,d.path);if(p){const l=n.basename(d.path);this.v(w,{base:m.folder,relativePath:s,basename:l});return}this.s(t,m.folder,s,w)}),this.g&&!this.e)?null:(this.u(t,a,w),{providerTime:v,postProcessTime:i.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(m){const w=(0,S.resolvePatternsForProvider)(this.k.includePattern,m.includePattern),f=(0,S.resolvePatternsForProvider)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:w,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},w,f,u){if(f===this.a){const a=n.basename(this.a);this.v(u,{base:w,relativePath:this.a,basename:a})}function t(a){const p=n.basename(a),b=n.dirname(a);let R=m[b];R||(R=m[b]=[],t(b)),R.push({base:w,relativePath:a,basename:p})}t(f)}u({rootEntries:m,pathToEntries:w},f,u){const t=this,a=this.a;function p(b){const R=(0,S.hasSiblingFn)(()=>b.map(v=>v.basename));for(let v=0,i=b.length;v<i;v++){const d=b[v],{relativePath:s,basename:l}=d;if(f.matchesExcludesSync(s,l,a!==l?R:void 0))continue;const o=w[s];if(o)p(o);else{if(s===a)continue;t.v(u,d)}if(t.e)break}}p(m)}v(m,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(w))}}class M{constructor(){this.b=new Map}fileSearch(m,w,f,u){const t=this.c(m.cacheKey),a=new P(m,w,t&&t.token);let p=0;const b=R=>{p+=R.length,f(R.map(v=>this.d(v)))};return this.e(a,M.a,b,u).then(R=>({limitHit:R.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:R.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(!!m)return this.b.has(m)||this.b.set(m,new A.CancellationTokenSource),this.b.get(m)}d(m){return m.relativePath?{resource:E.joinPath(m.base,m.relativePath)}:{resource:m.base}}e(m,w,f,u){u.onCancellationRequested(()=>{m.cancel()});const t=p=>{p&&(a.push(p),w>0&&a.length>=w&&(f(a),a=[]))};let a=[];return m.search(t).then(p=>(a.length&&f(a),p),p=>(a.length&&f(a),Promise.reject(p)))}}M.a=512,e.FileSearchManager=M}),define(Te[247],Pe([1,0,16,63,35,87,28,15,19,22,10,9,2,263,156,42,12,53,98,245,47]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t,a,p,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(y,C,H,K,Q){this.a=y,this.b=C,this.c=H,this.d=K,this.e=Q}text(y,C,H={}){y=this.f(y,H);const K=this.a.getValue(),Q=C&&C.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(C?.map(a.toWorkspaceFolder),H),type:2,contentPattern:y,previewOptions:H.previewOptions,maxFileSize:H.maxFileSize,usePCRE2:K.search.usePCRE2||Q||!1,beforeContext:H.beforeContext,afterContext:H.afterContext,userDisabledExcludesAndIgnoreFiles:H.disregardExcludeSettings&&H.disregardIgnoreFiles}}f(y,C){const H=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const K={...y,wordSeparators:H.editor.wordSeparators};return this.j(y,C)&&(K.isCaseSensitive=!0),this.k(y)&&(K.isMultiline=!0),K}file(y,C={}){return{...this.h(y,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}g(y,C){return y?(y=Array.isArray(y)?y.map(o):o(y),C?this.parseSearchPaths(y):{pattern:d(...Array.isArray(y)?y:[y])}):{}}h(y=[],C={}){const H=this.g(C.includePattern,C.expandPatterns),K=this.g(C.excludePattern,C.expandPatterns),Q=y.length>1,_=(H.searchPaths&&H.searchPaths.length?H.searchPaths.map(g=>this.q(g,C,K)):y.map(g=>this.r(g,C,K,Q))).filter(g=>!!g),j={_reason:C._reason,folderQueries:_,usingSearchPaths:!!(H.searchPaths&&H.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:K.pattern,includePattern:H.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const g=n.coalesce(n.flatten(this.c.groups.map(Y=>Y.editors.map(me=>me.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(g));const F=g.filter(Y=>(0,R.pathIncludedInQuery)(j,Y.fsPath)),B=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...j,...B}}const L=C.extraFileResources&&C.extraFileResources.filter(g=>(0,R.pathIncludedInQuery)(j,g.fsPath));return j.extraFileResources=L&&L.length?L:void 0,j}i(y){const C=[],H=new E.ResourceMap,K={};let Q=!1;return y.forEach(_=>{if(_.scheme===O.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(_)){const L=this.b.getWorkspaceFolder(_)?.uri??_.with({path:S.dirname(_.fsPath)});let g=H.get(L);g||(Q=!0,g={folder:L,includePattern:{}},C.push(g),H.set(L,g));const F=S.relative(L.fsPath,_.fsPath);(0,T.assertIsDefined)(g.includePattern)[F.replace(/\\/g,"/")]=!0}else _.fsPath&&(Q=!0,K[_.fsPath]=!0)}),{folderQueries:C,includePattern:K,usingSearchPaths:!0,excludePattern:Q?void 0:{"**/*":!0}}}j(y,C){if(C.isSmartCase){if(y.isRegExp){if(M.containsUppercaseCharacter(y.pattern,!0))return!0}else if(M.containsUppercaseCharacter(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,w.isMultilineRegexSource)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const C=B=>S.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),K=(Array.isArray(y)?y:s(y)).map(B=>{const Y=this.e.resolvedUserHome;return Y?(0,N.untildify)(B,Y.scheme===O.Schemas.file?Y.fsPath:Y.path):B}),Q=A.groupBy(K,B=>C(B)?"searchPaths":"exprSegments"),_=(Q.exprSegments||[]).map(B=>M.rtrim(B,"/")).map(B=>M.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),l(B))),j={},L=this.m(Q.searchPaths||[]);L&&L.length&&(j.searchPaths=L);const g=n.flatten(_),F=d(...g);return F&&(j.pattern=F),j}l(y,C){return C.disregardExcludeSettings?void 0:(0,R.getExcludes)(y,!C.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const C=y.flatMap(K=>{let{pathPortion:Q,globPortion:_}=i(K);return _&&(_=I(_)),this.n(Q).flatMap(L=>this.o(L,_))}),H=new Map;return C.forEach(K=>{const Q=K.searchPath.toString(),_=H.get(Q);_?K.pattern&&(_.pattern=_.pattern||{},_.pattern[K.pattern]=!0):H.set(Q,{searchPath:K.searchPath,pattern:K.pattern?d(K.pattern):void 0})}),Array.from(H.values())}n(y){if(S.isAbsolute(y)){const C=this.b.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==O.Schemas.file?[{searchPath:C[0].uri.with({path:y})}]:[{searchPath:m.URI.file(S.normalize(y))}]}if(this.b.getWorkbenchState()===2){const C=this.b.getWorkspace().folders[0].uri;if(y=o(y),y.startsWith("../")||y===".."){const K=S.posix.resolve(C.path,y);return[{searchPath:C.with({path:K})}]}const H=I(y);return[{searchPath:C,pattern:H}]}else{if(y==="./"||y===".\\")return[];{const C=y.replace(/^\.[\/\\]/,""),K=this.b.getWorkspace().folders.map(Q=>{const _=C.match(new RegExp(`^${M.escapeRegExpCharacters(Q.name)}(?:/(.*)|$)`));return _?{match:_,folder:Q}:null}).filter(T.isDefined);if(K.length)return K.map(Q=>{const _=Q.match[1];return{searchPath:Q.folder.uri,pattern:_&&I(_)}});{const Q=y.match(/\.[\/\\](.+)[\/\\]?/),_=Q?Q[1]:y,j=f.localize(0,null,_);throw new Error(j)}}}}o(y,C){const H=y.pattern&&C?`${y.pattern}/${C}`:y.pattern||C,K=[{searchPath:y.searchPath,pattern:H}];return H&&!H.endsWith("**")&&K.push({searchPath:y.searchPath,pattern:H+"/**"}),K}q(y,C,H){const K=this.r((0,a.toWorkspaceFolder)(y.searchPath),C,H,!1);return K?{...K,includePattern:y.pattern}:null}r(y,C,H,K){let Q;const _=m.URI.isUri(y)?y:y.uri;if(H.searchPaths){const B=H.searchPaths.filter(Y=>(0,P.isEqual)(Y.searchPath,_))[0];if(B&&!B.pattern)return null;B&&(Q=B.pattern)}const j=this.a.getValue({resource:_}),g={...this.l(j,C)||{},...Q||{}},F=m.URI.isUri(y)?(0,P.basename)(y):y.name;return{folder:_,folderName:K?F:void 0,excludePattern:Object.keys(g).length>0?g:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!j.search.followSymlinks}}};v=qe([Ve(0,u.IConfigurationService),Ve(1,a.IWorkspaceContextService),Ve(2,p.IEditorGroupsService),Ve(3,t.ILogService),Ve(4,b.IPathService)],v),e.QueryBuilder=v;function i(h){const y=h.match(/[\*\{\}\(\)\[\]\?]/);if(y){const C=y.index,H=h.substr(0,C).match(/[/|\\][^/\\]*$/);if(H){let K=h.substr(0,H.index);return K.match(/[/\\]/)||(K+="/"),{pathPortion:K,globPortion:h.substr((H.index||0)+1)}}}return{pathPortion:h}}function d(...h){return h.length?h.reduce((y,C)=>(y[C]=!0,y),Object.create(null)):void 0}function s(h){return D.splitGlobAware(h,",").map(y=>y.trim()).filter(y=>!!y.length)}function l(h){return[`**/${h}/**`,`**/${h}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function o(h){return h.replace(/\\/g,"/")}function I(h){return o(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function r(h){return h.replace(/([?*[\]])/g,"[$1]")}function c(h,y){h=n.distinct(h,K=>K.toString());const C=[],H=y.getWorkspace();return h&&h.forEach(K=>{let Q;if(y.getWorkbenchState()===2)Q=(0,P.relativePath)(H.folders[0].uri,K),Q&&Q!=="."&&(Q="./"+Q);else{const _=y.getWorkspaceFolder(K);if(_){const j=_.name;if(H.folders.filter(g=>g.name===j).length===1){const g=(0,P.relativePath)(_.uri,K);g===""?Q=`./${_.name}`:Q=`./${_.name}/${g}`}else Q=K.fsPath}}Q&&C.push(r(Q))}),C}e.resolveResourcesForSearchIncludes=c}),define(Te[248],Pe([1,0,22,2,21,11,3,247,47,53]),function(te,e,n,A,D,N,E,O,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const M=7e3;function T(u,t){const a=t.activationEvents;if(!a)return Promise.resolve(void 0);const p=[],b=[];for(const l of a)if(/^workspaceContains:/.test(l)){const o=l.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||u.forceUsingSearch?b.push(o):p.push(o)}if(p.length===0&&b.length===0)return Promise.resolve(void 0);let R;const v=new Promise((l,o)=>{R=l}),i=l=>R({activationEvent:l}),d=Promise.all(p.map(l=>m(u,l,i))).then(()=>{}),s=w(u,t.identifier,b,i);return Promise.all([d,s]).then(()=>{R(void 0)}),v}e.checkActivateWorkspaceContainsExtension=T;async function m(u,t,a){for(const p of u.folders)if(await u.exists(n.joinPath(A.URI.revive(p),t))){a(`workspaceContains:${t}`);return}}async function w(u,t,a,p){if(a.length===0)return Promise.resolve(void 0);const b=new D.CancellationTokenSource,R=u.checkExists(u.folders,a,b.token),v=setTimeout(async()=>{b.cancel(),u.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${a.join(",")}`)},M);let i=!1;try{i=await R}catch(d){N.isCancellationError(d)||N.onUnexpectedError(d)}b.dispose(),clearTimeout(v),i&&p(`workspaceContains:${a.join(",")}`)}function f(u,t,a,p){const b=u.get(E.IInstantiationService),R=u.get(S.ISearchService),i=b.createInstance(O.QueryBuilder).file(t.map(d=>(0,P.toWorkspaceFolder)(A.URI.revive(d))),{_reason:"checkExists",includePattern:a,exists:!0});return R.fileSearch(i,p).then(d=>!!d.limitHit,d=>N.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,A,D){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Fe=this&&this.__classPrivateFieldGet||function(te,e,n,A){if(n==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!A:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?A:n==="a"?A.call(te):A?A.value:e.get(te)};define(Te[33],Pe([1,0,141,19,82,22,17,6,48,2,12,5,32,193,80,31,26,99,11,24,25,178,7,94,3,27,81,18,68,70,61,4,248,79,180,15,78,77,20]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t,a,p,b,R,v,i,d,s,l,o,I,r,c,h,y,C,H,K,Q,_,j,L){"use strict";var g,F,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let Y=class un extends O.Disposable{constructor(q,ce,be,Ae,Ue,Ce,Se,ke,oe,ae,J){super(),this.a=this.B(new y.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=ce,this.g=be,this.f=Se,this.j=Ae,this.k=Ue,this.l=Ce,this.m=oe,this.p=ae,this.s=J,this.t=this.g.getProxy(T.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(T.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(T.MainContext.MainThreadExtensionService),this.w=new E.Barrier,this.y=new E.Barrier,this.z=new E.Barrier,this.C=new E.Barrier,this.D=new de(this.f.activationEvents),this.G=new a.ExtensionDescriptionRegistry(this.D,this.f.allExtensions);const k=new b.ExtensionIdentifierSet(this.f.myExtensions);this.F=new a.ExtensionDescriptionRegistry(this.D,ue(this.G,k)),this.H=new f.ExtHostStorage(this.g,this.l),this.I=new H.ExtHostSecretState(this.g),this.J=ke,this.h=q.createChild(new r.ServiceCollection([f.IExtHostStorage,this.H],[H.IExtHostSecretState,this.I])),this.L=this.B(new w.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:($,W,V)=>{this.v.$onExtensionActivationError($,p.transformErrorForSerialization(W),V)},actualActivateExtension:async($,W)=>{if(a.ExtensionDescriptionRegistry.isHostExtension($,this.F,this.G))return await this.v.$activateExtension($,W),new w.HostExtension;const V=this.F.getExtensionDescription($);return this.Z(V,W)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.ob(),this.w.open(),await this.j.waitForInitializeCall(),D.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.mb()}catch(q){p.onUnexpectedError(q)}}async R(){this.J.onWillDeactivateAll();let q=[];try{q=this.F.getAllExtensionDescriptions().map(Ue=>Ue.identifier).filter(Ue=>this.isActivated(Ue)).map(Ue=>this.Y(Ue))}catch{}await Promise.all(q)}terminate(q,ce=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${q}`),this.l.flush(),this.p.dispose(),this.L.dispose(),p.setUnexpectedErrorHandler(Ae=>{this.l.error(Ae)}),this.g.dispose();const be=this.R();Promise.race([(0,E.timeout)(5e3),be]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${ce}`):this.l.info(`Extension host exiting with code ${ce}`),this.l.flush(),this.l.dispose(),this.c.exit(ce)})}isActivated(q){return this.z.isOpen()?this.L.isActivated(q):!1}async getExtension(q){const ce=await this.v.$getExtension(q);let be;if(ce?.browserNlsBundleUris){be={};for(const Ae of Object.keys(ce.browserNlsBundleUris))be[Ae]=P.URI.revive(ce.browserNlsBundleUris[Ae])}return ce&&{...ce,identifier:new b.ExtensionIdentifier(ce.identifier.value),extensionLocation:P.URI.revive(ce.extensionLocation),browserNlsBundleUris:be}}S(q,ce){return this.L.activateByEvent(q,ce)}U(q,ce){return this.L.activateById(q,ce)}activateByIdWithErrors(q,ce){return this.U(q,ce).then(()=>{const be=this.L.getActivatedExtension(q);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(q=>this.F)}getExtensionExports(q){return this.z.isOpen()?this.L.getActivatedExtension(q).exports:null}async W(q){if(q.scheme!==Q.Schemas.file)return q;const ce=await this.c.realpath(q.fsPath);return P.URI.file(ce)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(q=>new De(q))),this.M}async X(q){const ce=S.TernarySearchTree.forUris(be=>N.extUriBiasedIgnorePathCase.ignorePathCasing(be));return await Promise.all(q.map(async be=>{if(this.pb(be)){const Ae=await this.W(be.extensionLocation);ce.set(Ae,be)}})),ce}Y(q){let ce=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(q))return ce;const be=this.L.getActivatedExtension(q);if(!be)return ce;try{typeof be.module.deactivate=="function"&&(ce=Promise.resolve(be.module.deactivate()).then(void 0,Ae=>(this.l.error(Ae),Promise.resolve(void 0))))}catch(Ae){this.l.error(`An error occurred when deactivating the extension '${q.value}':`),this.l.error(Ae)}try{(0,O.dispose)(be.subscriptions)}catch(Ae){this.l.error(`An error occurred when deactivating the subscriptions for extension '${q.value}':`),this.l.error(Ae)}return ce}async Z(q,ce){return this.f.remote.isRemote?this.v.$onWillActivateExtension(q.identifier):await this.v.$onWillActivateExtension(q.identifier),this.bb(q,ce).then(be=>{const Ae=be.activationTimes;return this.v.$onDidActivateExtension(q.identifier,Ae.codeLoadingTime,Ae.activateCallTime,Ae.activateResolvedTime,ce),this.ab(q,ce,"success",Ae),be},be=>{throw this.ab(q,ce,"failure"),be})}ab(q,ce,be,Ae){const Ue=Z(q,ce);this.u.$publicLog2("extensionActivationTimes",{...Ue,...Ae||{},outcome:be})}bb(q,ce){const be=Z(q,ce);this.u.$publicLog2("activatePlugin",be);const Ae=this.pb(q);if(!Ae)return Promise.resolve(new w.EmptyExtension(w.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${q.identifier.value}, startup: ${ce.startup}, activationEvent: '${ce.activationEvent}'${q.identifier.value!==ce.extensionId.value?`, root cause: ${ce.extensionId.value}`:""}`),this.l.flush();const Ue=new w.ExtensionActivationTimesBuilder(ce.startup);return Promise.all([this.qb(q,(0,N.joinPath)(q.extensionLocation,Ae),Ue),this.cb(q)]).then(Ce=>(D.mark(`code/extHost/willActivateExtension/${q.identifier.value}`),un.db(this.l,q.identifier,Ce[0],Ce[1],Ue))).then(Ce=>(D.mark(`code/extHost/didActivateExtension/${q.identifier.value}`),Ce))}cb(q){const ce=new v.ExtensionGlobalMemento(q,this.H),be=new v.ExtensionMemento(q.identifier.value,!1,this.H),Ae=new K.ExtensionSecrets(q,this.I),Ue=q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ce=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${q.identifier.value}`),Promise.all([ce.whenReady,be.whenReady,this.J.whenReady]).then(()=>{const Se=this;let ke,oe;const ae=(0,t.isProposedApiEnabled)(q,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(q.identifier)):void 0;return Object.freeze({globalState:ce,workspaceState:be,secrets:Ae,subscriptions:[],get extensionUri(){return q.extensionLocation},get extensionPath(){return q.extensionLocation.fsPath},asAbsolutePath(J){return A.join(q.extensionLocation.fsPath,J)},get storagePath(){return Se.J.workspaceValue(q)?.fsPath},get globalStoragePath(){return Se.J.globalValue(q).fsPath},get logPath(){return A.join(Se.f.logsLocation.fsPath,q.identifier.value)},get logUri(){return P.URI.joinPath(Se.f.logsLocation,q.identifier.value)},get storageUri(){return Se.J.workspaceValue(q)},get globalStorageUri(){return Se.J.globalValue(q)},get extensionMode(){return Ue},get extension(){return ke===void 0&&(ke=new se(Se,q.identifier,q,Ce,!1)),ke},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(q,"extensionRuntime"),Se.extensionRuntime},get environmentVariableCollection(){return Se.p.getEnvironmentVariableCollection(q)},get messagePassingProtocol(){if(!oe){if(!ae)return;const J=y.Event.buffer(y.Event.fromDOMEventEmitter(ae,"message",k=>k.data));ae.start(),oe={onDidReceiveMessage:J,postMessage:ae.postMessage.bind(ae)}}return oe}})})}static db(q,ce,be,Ae,Ue){return be=be||{activate:void 0,deactivate:void 0},this.eb(q,ce,be,Ae,Ue).then(Ce=>new w.ActivatedExtension(!1,null,Ue.build(),be,Ce,Ae.subscriptions))}static eb(q,ce,be,Ae,Ue){if(typeof be.activate=="function")try{Ue.activateCallStart(),q.trace(`ExtensionService#_callActivateOptional ${ce.value}`);const Ce=typeof global=="object"?global:self,Se=be.activate.apply(Ce,[Ae]);return Ue.activateCallStop(),Ue.activateResolveStart(),Promise.resolve(Se).then(ke=>(Ue.activateResolveStop(),ke))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(be)}fb(q,ce){this.U(q.identifier,{startup:!1,extensionId:q.identifier,activationEvent:ce}).then(void 0,be=>{this.l.error(be)})}gb(q,ce=0){const Ae=Date.now();(0,L.setTimeout0)(()=>{for(let Ue=ce;Ue<q.length;Ue+=1){const Ce=q[Ue];for(const Se of Ce.activationEvents??[])if(Se==="onStartupFinished")if(Date.now()-Ae>50){this.gb(q,Ue);break}else this.fb(Ce,Se)}})}hb(){this.v.$setPerformanceMarks(D.getMarks()),this.k.getConfigProvider().then(q=>{const ce=q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.F.getAllExtensionDescriptions();if(ce)this.gb(be);else for(const Ae of be)if(Ae.activationEvents)for(const Ue of Ae.activationEvents)Ue==="onStartupFinished"&&this.fb(Ae,Ue)})}ib(){const q=this.S("*",!0).then(void 0,Ue=>{this.l.error(Ue)});this.B(this.j.onDidChangeWorkspace(Ue=>this.jb(Ue.added)));const ce=this.j.workspace?this.j.workspace.folders:[],be=this.jb(ce),Ae=Promise.all([q,be]).then(()=>{});return Promise.race([Ae,(0,E.timeout)(1e4)]).then(()=>{this.hb()}),Ae}jb(q){return q.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(ce=>this.kb(q,ce))).then(()=>{})}async kb(q,ce){if(this.isActivated(ce.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,Ae={logService:this.l,folders:q.map(Ce=>Ce.uri),forceUsingSearch:be,exists:Ce=>this.c.exists(Ce.fsPath),checkExists:(Ce,Se,ke)=>this.t.$checkExists(Ce,Se,ke)},Ue=await(0,C.checkActivateWorkspaceContainsExtension)(Ae,ce);if(!!Ue)return this.U(ce.identifier,{startup:!0,extensionId:ce.identifier,activationEvent:Ue.activationEvent}).then(void 0,Ce=>this.l.error(Ce))}async $extensionTestsExecute(){await this.C.wait();try{return await this.lb()}catch(q){throw console.error(q),q}}async lb(){const{extensionDevelopmentLocationURI:q,extensionTestsLocationURI:ce}=this.f.environment;if(!q||!ce)throw new Error(n.localize(0,null));const be=await this.qb(null,ce,new w.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(n.localize(1,null,ce.toString()));return new Promise((Ae,Ue)=>{const Ce=(oe,ae)=>{oe?Ue(oe):Ae(typeof ae=="number"&&ae>0?1:0)},Se=(0,N.originalFSPath)(ce),ke=be.run(Se,Ce);ke&&ke.then&&ke.then(()=>{Ae(0)}).catch(oe=>{Ue(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}mb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(q,ce){return this.N[q]=ce,(0,O.toDisposable)(()=>{delete this.N[q]})}async nb(q){const ce=q.indexOf("+");if(ce===-1)throw new Error("Not an authority that can be resolved!");const be=q.substr(0,ce);return await this.w.wait(),await this.S(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.N[be]}}async $resolveAuthority(q,ce){const be=j.StopWatch.create(!1),Ae=()=>`[resolveAuthority(${(0,d.getRemoteAuthorityPrefix)(q)},${ce})][${be.elapsed()}ms] `,Ue=ae=>this.l.info(`${Ae()}${ae}`),Ce=(ae,J=void 0)=>this.l.error(`${Ae()}${ae}`,J);Ue("activating resolver...");const{authorityPrefix:Se,resolver:ke}=await this.nb(q);if(!ke)return Ce("no resolver"),{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Se}.`,detail:void 0}};const oe=new E.IntervalTimer;try{Ue("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(ke)),oe.cancelAndSet(()=>Ue("waiting..."),1e3),Ue("invoking resolve()..."),D.mark(`code/extHost/willResolveAuthority/${Se}`);const ae=await ke.resolve(q,{resolveAttempt:ce});D.mark(`code/extHost/didResolveAuthorityOK/${Se}`),oe.dispose(),Ue(`returned ${ae.host}:${ae.port}`);const J={authority:q,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},k={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:J,options:k,tunnelInformation:{environmentTunnels:ae.environmentTunnels,features:ae.tunnelFeatures}}}}catch(ae){if(D.mark(`code/extHost/didResolveAuthorityError/${Se}`),oe.dispose(),Ce("returned an error",ae),ae instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(q,ce){this.l.info(`$getCanonicalURI invoked for authority (${(0,d.getRemoteAuthorityPrefix)(q)})`);const{resolver:be}=await this.nb(q);if(!be)return null;const Ae=P.URI.revive(ce);if(typeof be.getCanonicalURI>"u")return Ae;const Ue=await(0,E.asPromise)(()=>be.getCanonicalURI(Ae));return Ue||Ae}$startExtensionHost(q){q.toAdd.forEach(Ae=>Ae.extensionLocation=P.URI.revive(Ae.extensionLocation));const{globalRegistry:ce,myExtensions:be}=me(this.D,this.G,this.F,q);return this.G.set(ce.getAllExtensionDescriptions()),this.F.set(be),this.mb()}$activateByEvent(q,ce){return ce===1?this.S(q,!1):this.z.wait().then(be=>this.S(q,!1))}async $activate(q,ce){return await this.z.wait(),this.F.getExtensionDescription(q)?(await this.U(q,ce),!0):!1}async $deltaExtensions(q){q.toAdd.forEach(Ce=>Ce.extensionLocation=P.URI.revive(Ce.extensionLocation));const{globalRegistry:ce,myExtensions:be}=me(this.D,this.G,this.F,q),Ae=await this.X(be);return(await this.getExtensionPathIndex()).setSearchTree(Ae),this.G.set(ce.getAllExtensionDescriptions()),this.F.set(be),Promise.resolve(void 0)}async $test_latency(q){return q}async $test_up(q){return q.byteLength}async $test_down(q){const ce=R.VSBuffer.alloc(q),be=Math.random()%256;for(let Ae=0;Ae<q;Ae++)ce.writeUInt8(be,Ae);return ce}async $updateRemoteConnectionData(q){this.Q=q,this.a.fire()}};Y=qe([Ve(0,s.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,I.IExtHostRpcService),Ve(3,u.IExtHostWorkspace),Ve(4,m.IExtHostConfiguration),Ve(5,M.ILogService),Ve(6,l.IExtHostInitDataService),Ve(7,o.IExtensionStoragePaths),Ve(8,c.IExtHostTunnelService),Ve(9,h.IExtHostTerminalService),Ve(10,_.IExtHostLocalizationService)],Y),e.AbstractExtHostExtensionService=Y;function me(ie,q,ce,be){ie.addActivationEvents(be.addActivationEvents);const Ae=new a.ExtensionDescriptionRegistry(ie,q.getAllExtensionDescriptions());Ae.deltaExtensions(be.toAdd,be.toRemove);const Ue=new b.ExtensionIdentifierSet(ce.getAllExtensionDescriptions().map(Se=>Se.identifier));for(const Se of be.myToRemove)Ue.delete(Se);for(const Se of be.myToAdd)Ue.add(Se);const Ce=ue(Ae,Ue);return{globalRegistry:Ae,myExtensions:Ce}}function Z(ie,q){return{id:ie.identifier.value,name:ie.name,extensionVersion:ie.version,publisherDisplayName:ie.publisher,activationEvents:ie.activationEvents?ie.activationEvents.join(","):null,isBuiltin:ie.isBuiltin,reason:q.activationEvent,reasonId:q.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class se{constructor(q,ce,be,Ae,Ue){g.set(this,void 0),F.set(this,void 0),B.set(this,void 0),Je(this,g,q,"f"),Je(this,F,ce,"f"),Je(this,B,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=A.normalize((0,N.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Ae,this.isFromDifferentExtensionHost=Ue}get isActive(){return Fe(this,g,"f").isActivated(Fe(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Fe(this,g,"f").getExtensionExports(Fe(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Fe(this,g,"f").activateByIdWithErrors(Fe(this,B,"f"),{startup:!1,extensionId:Fe(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=se,g=new WeakMap,F=new WeakMap,B=new WeakMap;function ue(ie,q){return ie.getAllExtensionDescriptions().filter(ce=>q.has(ce.identifier))}class De{constructor(q){this.a=q}setSearchTree(q){this.a=q}findSubstr(q){return this.a.findSubstr(q)}forEach(q){return this.a.forEach(q)}}e.ExtensionPaths=De;class de{constructor(q){this.a=new b.ExtensionIdentifierMap,this.addActivationEvents(q)}readActivationEvents(q){return this.a.get(q.identifier)}addActivationEvents(q){for(const ce of Object.keys(q))this.a.set(ce,q[ce])}}}),define(Te[249],Pe([1,0,82,2,5,32,26,24,18,27,3,33,51,12,10]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let u=class{constructor(v,i,d,s,l,o,I){this.c=v,this.d=i,this.e=d,this.f=s,this.g=l,this.h=o,this.i=I,this.a=new Map,this.b=[]}async install(){this.j(),n.mark("code/extHost/willWaitForConfig");const v=await this.f.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new a(this.c,i,this.d,v,this.i)),this.register(this.e.createInstance(p,i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,i,this.h.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const i of v.nodeModuleName)this.a.set(i,v);else this.a.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this.b.push(i=>v.alternativeModuleName(i))}};u=qe([Ve(2,M.IInstantiationService),Ve(3,N.IExtHostConfiguration),Ve(4,T.IExtHostExtensionService),Ve(5,P.IExtHostInitDataService),Ve(6,w.ILogService)],u),e.RequireInterceptor=u;let t=class rn{constructor(v){if(v.environment.appRoot&&rn.a.size){const i=(0,f.escapeRegExpCharacters)(this.c(v.environment.appRoot.fsPath)),d="[a-z0-9_.-]",s=`@${d}+\\/${d}+|${d}+`,l="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${l}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(v){if(!this.b)return;const i=this.b.exec(this.c(v));if(!i)return;const[,d,s,l]=i,o=rn.a.get(s);if(o!==void 0)return console.warn(`${s} as been renamed to ${o}, please update your imports`),d+o+l}c(v){return v.replace(/\\/g,"/")}};t.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=qe([Ve(0,P.IExtHostInitDataService)],t);class a{constructor(v,i,d,s,l){this.c=v,this.d=i,this.e=d,this.f=s,this.g=l,this.nodeModuleName="vscode",this.a=new O.ExtensionIdentifierMap}load(v,i){const d=this.d.findSubstr(i);if(d){let s=this.a.get(d.identifier);return s||(s=this.c(d,this.e,this.f),this.a.set(d.identifier,s)),s}if(!this.b){let s="";this.d.forEach((l,o)=>s+=`	${o} -> ${l.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${s}`),this.b=this.c(E.nullExtensionDescription,this.e,this.f)}return this.b}}let p=class{constructor(v,i,d){this.d=v,this.nodeModuleName="keytar",this.a=i.getProxy(D.MainContext.MainThreadTelemetry);const{environment:s}=d,l=i.getProxy(D.MainContext.MainThreadKeytar);if(s.appRoot){let o=s.appRoot.fsPath;m.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.b=new Set,this.b.add(`${o}/node_modules.asar/keytar`),this.b.add(`${o}/node_modules/keytar`)}this.c={getPassword:(o,I)=>l.$getPassword(o,I),setPassword:(o,I,r)=>l.$setPassword(o,I,r),deletePassword:(o,I)=>l.$deletePassword(o,I),findPassword:o=>l.$findPassword(o),findCredentials(o){return l.$findCredentials(o)}}}load(v,i){const d=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(v){const i=v.length;if(i<=7||!this.b)return;const d=i-7;if((v.charAt(d)==="/"||v.charAt(d)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.b.has(v)))return"keytar"}};p=qe([Ve(1,S.IExtHostRpcService),Ve(2,P.IExtHostInitDataService)],p);let b=class{constructor(v,i,d){this.e=v,this.f=i,this.nodeModuleName=["open","opn"],this.d=d.getProxy(D.MainContext.MainThreadTelemetry);const s=d.getProxy(D.MainContext.MainThreadWindow);this.c=(l,o)=>{const I=A.URI.parse(l);return o?this.g(l,o):I.scheme==="http"||I.scheme==="https"?s.$openUri(I,l,{allowTunneling:!0}):I.scheme==="mailto"||I.scheme===this.f?s.$openUri(I,l,{}):this.g(l,o)}}load(v,i,d){const s=this.e.findSubstr(i);return s&&(this.a=s.identifier.value,this.h()),this.b=d(v),this.c}g(v,i){return this.i(),this.b(v,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=qe([Ve(2,S.IExtHostRpcService)],b)}),define(Te[109],Pe([1,0,85,6,19,51,3,58,59,33,7,31,190,32]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,E.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(a,p,b,R,v,i,d){function s(){if(b){const l=b.activeEditor();if(l)return l.document.uri;const o=R.tabGroups.all.find(I=>I.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof M.TextDiffTabInput||o.input instanceof M.NotebookDiffEditorTabInput)return o.input.modified;if(o.input instanceof M.TextTabInput||o.input instanceof M.NotebookEditorTabInput||o.input instanceof M.CustomEditorTabInput)return o.input.uri}}}super({getFolderUri:l=>{const o=i.folders.filter(I=>I.name===l);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(l,o)=>v.getConfiguration(void 0,l).get(o),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=s();if(l)return D.normalize(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const l=s();if(l){const o=p.getWorkspaceFolder(l);if(o)return D.normalize(o.uri.fsPath)}}},getSelectedText:()=>{if(b){const l=b.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(b){const l=b.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>a.getExtension(l)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(N.env))}}let u=class extends A.Disposable{constructor(a,p,b,R,v){super(),this.b=a,this.c=p,this.g=b,this.h=R,this.i=v,this.a=new n.Lazy(async()=>{const i=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.i,i,s,this.j())})}getResolver(){return this.a.value}j(){}};u=qe([Ve(0,P.IExtHostExtensionService),Ve(1,T.IExtHostWorkspace),Ve(2,O.IExtHostDocumentsAndEditors),Ve(3,w.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs)],u),e.ExtHostVariableResolverProviderService=u}),define(Te[110],Pe([1,0,17,4,9,2,3,5,59,33,18,7,31,183,185,32,109]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,l,o,I,r,c){this.D=l,this.E=o,this.F=I,this.G=r,this.H=c,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new A.Emitter,this.n=new A.Emitter,this.o=new A.Emitter,this.u=new A.Emitter,this.k=s.getProxy(O.MainContext.MainThreadDebugService),this.z=new A.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(h=>{h.onDidChange(y=>{this.I(h)}),this.I(h)})}asDebugSourceUri(s,l){const o=s;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let I=`debug:${encodeURIComponent(o.path||"")}`,r="?";return l&&(I+=`${r}session=${encodeURIComponent(l.id)}`,r="&"),I+=`${r}ref=${o.sourceReference}`,N.URI.parse(I)}else{if(o.path)return N.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(s){const l=[];for(const o of s.getAllExtensionDescriptions())if(o.contributes){const I=o.contributes.debuggers;if(I&&I.length>0)for(const r of I)(0,f.isDebuggerMainContribution)(r)&&l.push(r.type)}this.k.$registerDebugTypes(l)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const s=[];return this.w.forEach(l=>s.push(l)),s}addBreakpoints(s){this.T();const l=s.filter(r=>{const c=r.id;return this.w.has(c)?!1:(this.w.set(c,r),!0)});this.U(l,[],[]);const o=[],I=new Map;for(const r of l)if(r instanceof T.SourceBreakpoint){let c=I.get(r.location.uri.toString());c||(c={type:"sourceMulti",uri:r.location.uri,lines:[]},I.set(r.location.uri.toString(),c),o.push(c)),c.lines.push({id:r.id,enabled:r.enabled,condition:r.condition,hitCondition:r.hitCondition,logMessage:r.logMessage,line:r.location.range.start.line,character:r.location.range.start.character})}else r instanceof T.FunctionBreakpoint&&o.push({type:"function",id:r.id,enabled:r.enabled,hitCondition:r.hitCondition,logMessage:r.logMessage,condition:r.condition,functionName:r.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(s){this.T();const l=s.filter(c=>this.w.delete(c.id));this.U([],l,[]);const o=l.filter(c=>c instanceof T.SourceBreakpoint).map(c=>c.id),I=l.filter(c=>c instanceof T.FunctionBreakpoint).map(c=>c.id),r=l.filter(c=>c instanceof T.DataBreakpoint).map(c=>c.id);return this.k.$unregisterBreakpoints(o,I,r)}startDebugging(s,l,o){return this.k.$startDebugging(s?s.uri:void 0,l,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,l,o){if(!l)return new T.Disposable(()=>{});const I=this.d++;return this.f.push({type:s,handle:I,provider:l}),this.k.$registerDebugConfigurationProvider(s,o,!!l.provideDebugConfigurations,!!l.resolveDebugConfiguration,!!l.resolveDebugConfigurationWithSubstitutedVariables,I),new T.Disposable(()=>{this.f=this.f.filter(r=>r.provider!==l),this.k.$unregisterDebugConfigurationProvider(I)})}registerDebugAdapterDescriptorFactory(s,l,o){if(!o)return new T.Disposable(()=>{});if(!this.P(s,l))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${l}' debugger.`);if(this.M(l))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const I=this.g++;return this.h.push({type:l,handle:I,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(l,I),new T.Disposable(()=>{this.h=this.h.filter(r=>r.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(I)})}registerDebugAdapterTrackerFactory(s,l){if(!l)return new T.Disposable(()=>{});const o=this.i++;return this.j.push({type:s,handle:o,factory:l}),new T.Disposable(()=>{this.j=this.j.filter(I=>I.factory!==l)})}async $runInTerminal(s,l){return Promise.resolve(void 0)}async $substituteVariables(s,l){let o;const I=await this.W(s);return I&&(o={uri:I.uri,name:I.name,index:I.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(o,l)}J(s,l){if(s.type==="implementation")return new v(s.implementation)}K(){}async $startDASession(s,l){const o=this,I=await this.V(l);return this.R(this.M(I.type),I).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}' (extension might have failed to activate)`);const c=this.L(r),h=this.J(c,I);if(!h)throw new Error(`Couldn't create a debug adapter for type '${I.type}'.`);const y=h;return this.A.set(s,y),this.Q(I).then(C=>(C&&this.B.set(s,C),y.onMessage(async H=>{if(H.type==="request"&&H.command==="handshake"){const K=H,Q={type:"response",seq:0,command:K.command,request_seq:K.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const _=await this.C.sign(K.arguments.value);Q.body={signature:_},y.sendResponse(Q)}else throw new Error("no signer")}catch(_){Q.success=!1,Q.message=_.message,y.sendResponse(Q)}}else C&&C.onDidSendMessage&&C.onDidSendMessage(H),H=(0,f.convertToVSCPaths)(H,!0),o.k.$acceptDAMessage(s,H)}),y.onError(H=>{C&&C.onError&&C.onError(H),this.k.$acceptDAError(s,H.name,H.message,H.stack)}),y.onExit(H=>{C&&C.onExit&&C.onExit((0,D.withNullAsUndefined)(H),void 0),this.k.$acceptDAExit(s,(0,D.withNullAsUndefined)(H),void 0)}),C&&C.onWillStartSession&&C.onWillStartSession(),y.startSession()))})}$sendDAMessage(s,l){l=(0,f.convertToDAPaths)(l,!1);const o=this.B.get(s);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(l),this.A.get(s)?.sendMessage(l)}$stopDASession(s){const l=this.B.get(s);this.B.delete(s),l&&l.onWillStopSession&&l.onWillStopSession();const o=this.A.get(s);return this.A.delete(s),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const l=[],o=[],I=[];if(s.added)for(const r of s.added){const c=r.id;if(c&&!this.w.has(c)){let h;if(r.type==="function")h=new T.FunctionBreakpoint(r.functionName,r.enabled,r.condition,r.hitCondition,r.logMessage);else if(r.type==="data")h=new T.DataBreakpoint(r.label,r.dataId,r.canPersist,r.enabled,r.hitCondition,r.condition,r.logMessage);else{const y=N.URI.revive(r.uri);h=new T.SourceBreakpoint(new T.Location(y,new T.Position(r.line,r.character)),r.enabled,r.condition,r.hitCondition,r.logMessage)}(0,T.setBreakpointId)(h,c),this.w.set(c,h),l.push(h)}}if(s.removed)for(const r of s.removed){const c=this.w.get(r);c&&(this.w.delete(r),o.push(c))}if(s.changed){for(const r of s.changed)if(r.id){const c=this.w.get(r.id);if(c){if(c instanceof T.FunctionBreakpoint&&r.type==="function"){const h=c;h.enabled=r.enabled,h.condition=r.condition,h.hitCondition=r.hitCondition,h.logMessage=r.logMessage,h.functionName=r.functionName}else if(c instanceof T.SourceBreakpoint&&r.type==="source"){const h=c;h.enabled=r.enabled,h.condition=r.condition,h.hitCondition=r.hitCondition,h.logMessage=r.logMessage,h.location=new T.Location(N.URI.revive(r.uri),new T.Position(r.line,r.character))}I.push(c)}}}this.U(l,o,I)}$provideDebugConfigurations(s,l,o){return(0,n.asPromise)(async()=>{const I=this.O(s);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const r=await this.W(l);return I.provideDebugConfigurations(r,o)}).then(I=>{if(!I)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return I})}$resolveDebugConfiguration(s,l,o,I){return(0,n.asPromise)(async()=>{const r=this.O(s);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const c=await this.W(l);return r.resolveDebugConfiguration(c,o,I)})}$resolveDebugConfigurationWithSubstitutedVariables(s,l,o,I){return(0,n.asPromise)(async()=>{const r=this.O(s);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const c=await this.W(l);return r.resolveDebugConfigurationWithSubstitutedVariables(c,o,I)})}async $provideDebugAdapter(s,l){const o=this.N(s);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const I=await this.V(l);return this.R(o,I).then(r=>{if(!r)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${I.type}'`);return this.L(r)})}async $acceptDebugSessionStarted(s){const l=await this.V(s);this.m.fire(l)}async $acceptDebugSessionTerminated(s){const l=await this.V(s);l&&(this.n.fire(l),this.l.delete(l.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,l){(await this.V(s))?._acceptNameChanged(l)}async $acceptDebugSessionCustomEvent(s,l){const I={session:await this.V(s),event:l.event,body:l.body};this.u.fire(I)}L(s){if(s instanceof T.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof T.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}M(s){const l=this.h.filter(o=>o.type===s);if(l.length>0)return l[0].factory}N(s){const l=this.h.filter(o=>o.handle===s);if(l.length>0)return l[0].factory}O(s){const l=this.f.filter(o=>o.handle===s);if(l.length>0)return l[0].provider}P(s,l){if(s.contributes){const o=s.contributes.debuggers;if(o&&o.length>0){for(const I of o)if(I.label&&I.type&&I.type===l)return!0}}return!1}Q(s){const o=s.configuration.type,I=this.j.filter(r=>r.type===o||r.type==="*").map(r=>(0,n.asPromise)(()=>r.factory.createDebugAdapterTracker(s)).then(c=>c,c=>null));return Promise.race([Promise.all(I).then(r=>{const c=r.filter(h=>!!h);if(c.length>0)return new R(c)}),new Promise(r=>setTimeout(()=>r(void 0),1e3))]).catch(r=>{})}async R(s,l){const o=l.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new T.DebugAdapterServer(o));if(s){const r=await this.E.getExtensionRegistry();return(0,n.asPromise)(()=>s.createDebugAdapterDescriptor(l,this.S(l,r))).then(c=>{if(c)return c})}const I=await this.E.getExtensionRegistry();return Promise.resolve(this.S(l,I))}S(s,l){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(s,l,o){(s.length>0||l.length>0||o.length>0)&&this.z.fire(Object.freeze({added:s,removed:l,changed:o}))}async V(s){if(s)if(typeof s=="string"){const l=this.l.get(s);if(l)return l}else{let l=this.l.get(s.id);if(!l){const o=await this.W(s.folderUri),I=s.parent?this.l.get(s.parent):void 0;l=new p(this.k,s.id,s.type,s.name,o,s.configuration,I),this.l.set(l.id,l),this.k.$sessionCached(l.id)}return l}throw new Error("cannot find session")}W(s){if(s){const l=N.URI.revive(s);return this.D.resolveWorkspaceFolder(l)}return Promise.resolve(void 0)}};a=qe([Ve(0,M.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,P.IExtHostExtensionService),Ve(3,u.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,t.IExtHostVariableResolverProvider)],a),e.ExtHostDebugServiceBase=a;class p{constructor(s,l,o,I,r,c,h){this.d=s,this.f=l,this.g=o,this.h=I,this.i=r,this.j=c,this.k=h}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,l){return this.d.$customDebugAdapterRequest(this.f,s,l)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.ExtHostDebugSession=p;class b{constructor(s){this.value=Object.freeze({append(l){s.$appendDebugConsole(l)},appendLine(l){this.append(l+`
`)}})}}e.ExtHostDebugConsole=b;class R{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(l=>l.onWillReceiveMessage?l.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(l=>l.onDidSendMessage?l.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(l=>l.onError?l.onError(s):void 0)}onExit(s,l){this.d.forEach(o=>o.onExit?o.onExit(s,l):void 0)}}class v extends w.AbstractDebugAdapter{constructor(s){super(),this.h=s,s.onDidSendMessage(l=>{this.acceptMessage(l)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends a{constructor(s,l,o,I,r,c){super(s,l,o,I,r,c)}};i=qe([Ve(0,M.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,P.IExtHostExtensionService),Ve(3,u.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,t.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(Te[250],Pe([1,0,11,82,2,5,241,12,67,68,27,161,18,55,33,57]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class t{static async installEarlyHandler(b){const R=b.get(O.ILogService),i=b.get(m.IExtHostRpcService).getProxy(N.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(d=>{R.error(d);const s=n.transformErrorForSerialization(d);i.$onUnexpectedError(s)})}static async installFullHandler(b){const R=b.get(O.ILogService),v=b.get(m.IExtHostRpcService),i=b.get(f.IExtHostExtensionService),d=b.get(u.IExtHostTelemetry),s=v.getProxy(N.MainContext.MainThreadExtensionService),l=v.getProxy(N.MainContext.MainThreadErrors),o=await i.getExtensionPathIndex(),I=new WeakMap;Error.prepareStackTrace=(r,c)=>{let h="",y,C;for(const H of c)h+=`
	at ${H.toString()}`,C=H.getFileName(),!y&&C&&(y=o.findSubstr(D.URI.file(C)));return I.set(r,y?.identifier),`${r.name||"Error"}: ${r.message||""}${h}`},n.setUnexpectedErrorHandler(r=>{R.error(r);const c=n.transformErrorForSerialization(r),h=I.get(r);if(!h){l.$onUnexpectedError(c);return}s.$onExtensionRuntimeError(h,c);const y=d.onExtensionError(h,r);R.trace("forwarded error to extension?",y,h)})}}Error.stackTraceLimit=100;class a{constructor(b,R,v,i,d){this.a=v,this.b=new E.RPCProtocol(b,null,i),R=a.e(R,this.b);const s=new P.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());s.set(M.IExtHostInitDataService,{_serviceBrand:void 0,...R,messagePorts:d}),s.set(m.IExtHostRpcService,new m.ExtHostRpcService(this.b)),s.set(w.IURITransformerService,new w.URITransformerService(i)),s.set(f.IHostUtils,v);const l=new T.InstantiationService(s,!0);l.invokeFunction(t.installEarlyHandler),this.d=l.invokeFunction(o=>o.get(O.ILogService)),A.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",R),this.c=l.invokeFunction(o=>o.get(f.IExtHostExtensionService)),this.c.initialize(),l.invokeFunction(t.installFullHandler)}async asBrowserUri(b){const R=this.b.getProxy(N.MainContext.MainThreadExtensionService);return D.URI.revive(await R.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,R){b.allExtensions.forEach(i=>{i.extensionLocation=D.URI.revive(R.transformIncomingURIs(i.extensionLocation));const d={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(s=>d[s]=D.URI.revive(R.transformIncomingURIs(i.browserNlsBundleUris[s]))),i.browserNlsBundleUris=d)}),b.environment.appRoot=D.URI.revive(R.transformIncomingURIs(b.environment.appRoot));const v=b.environment.extensionDevelopmentLocationURI;return v&&(b.environment.extensionDevelopmentLocationURI=v.map(i=>D.URI.revive(R.transformIncomingURIs(i)))),b.environment.extensionTestsLocationURI=D.URI.revive(R.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=D.URI.revive(R.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=D.URI.revive(R.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=D.URI.revive(R.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=D.URI.revive(R.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=D.URI.revive(R.transformIncomingURIs(b.logsLocation)),b.logFile=D.URI.revive(R.transformIncomingURIs(b.logFile)),b.workspace=R.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=a}),define(Te[251],Pe([1,0,16,17,21,40,15,19,22,2,47]),function(te,e,n,A,D,N,E,O,S,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class T{constructor(p,b,R,v){this.d=p,this.e=b,this.f=R,this.g=v,this.a=null,this.b=!1,this.c=0}search(p,b){const R=this.d.folderQueries||[],v=new D.CancellationTokenSource;return b.onCancellationRequested(()=>v.cancel()),new Promise((i,d)=>{this.a=new w(p);let s=!1;const l=(o,I)=>{if(!s&&!this.b){const r=this.h(o);u(o)&&typeof this.d.maxResults=="number"&&this.c+r>this.d.maxResults&&(this.b=!0,s=!0,v.cancel(),o=this.j(o,this.d.maxResults-this.c));const c=this.h(o);this.c+=c,(c>0||!u(o))&&this.a.add(o,I)}};Promise.all(R.map((o,I)=>this.k(o,r=>l(r,I),v.token))).then(o=>{v.dispose(),this.a.flush();const I=o.some(r=>!!r&&!!r.limitHit);i({limitHit:this.b||I,messages:(0,n.flatten)(o.map(r=>r?.message?Array.isArray(r.message)?r.message:[r.message]:[])),stats:{type:this.g}})},o=>{v.dispose();const I=(0,N.toErrorMessage)(o);d(new Error(I))})})}h(p){return u(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}j(p,b){const R=Array.isArray(p.ranges)?p.ranges:[p.ranges],v=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:R.slice(0,b),preview:{matches:v.slice(0,b),text:p.preview.text},uri:p.uri}}async k(p,b,R){const v=new M.QueryGlobTester(this.d,p),i=[],d={report:o=>{if(!this.l(o))return;const I=p.folder.scheme===E.Schemas.file?(0,M.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(o.uri))):void 0,r=S.relativePath(p.folder,o.uri);if(r){const c=v.includedInQuery(r,O.basename(r),I);(0,A.isThenable)(c)?i.push(c.then(h=>{h&&b(o)})):c&&b(o)}}},s=this.n(p),l=await this.e.provideTextSearchResults(m(this.d.contentPattern),s,d,R);return i.length&&await Promise.all(i),l}l(p){if(u(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(p){const b=(0,M.resolvePatternsForProvider)(this.d.includePattern,p.includePattern),R=(0,M.resolvePatternsForProvider)(this.d.excludePattern,p.excludePattern),v={folder:P.URI.from(p.folder),excludes:R,includes:b,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.f.toCanonicalName(p.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.TextSearchManager=T;function m(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class w{constructor(p){this.e=p,this.b=-1,this.d=null,this.a=new t(512,b=>this.g(b))}add(p,b){this.d&&(this.b!==b||!S.isEqual(this.c,p.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:p.uri,results:[]}),this.d.results.push(f(p))}f(){const p=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,p)}flush(){this.f(),this.a.flush()}g(p){this.e(p)}}e.TextSearchResultsCollector=w;function f(a){return u(a)?{preview:{matches:(0,n.mapArrayOrNot)(a.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:a.preview.text},ranges:(0,n.mapArrayOrNot)(a.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function u(a){return!!a.preview}e.extensionResultIsMatch=u;class t{constructor(p,b){this.g=p,this.h=b,this.c=0,this.d=[],this.e=0}addItem(p,b){!p||this.j(p,b)}addItems(p,b){!p||this.k(p,b)}j(p,b){this.d.push(p),this.e+=b,this.l()}k(p,b){this.d=this.d.concat(p),this.e+=b,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}t.a=4e3,t.b=50,e.BatchedCollector=t}),define(Te[111],Pe([1,0,6,5,3,246,18,55,12,2,251]),function(te,e,n,A,D,N,E,O,S,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let T=class{constructor(u,t,a){this.k=u,this.l=t,this.n=a,this.c=this.k.getProxy(A.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new N.FileSearchManager}o(u){return this.l.transformOutgoingScheme(u)}registerTextSearchProvider(u,t){if(this.g.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this.g.add(u);const a=this.d++;return this.e.set(a,t),this.c.$registerTextSearchProvider(a,this.o(u)),(0,n.toDisposable)(()=>{this.g.delete(u),this.e.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(u,t){if(this.i.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this.i.add(u);const a=this.d++;return this.h.set(a,t),this.c.$registerFileSearchProvider(a,this.o(u)),(0,n.toDisposable)(()=>{this.i.delete(u),this.h.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(u,t,a,p){const b=m(a),R=this.h.get(u);if(R)return this.j.fileSearch(b,R,v=>{this.c.$handleFileMatch(u,t,v.map(i=>i.resource))},p);throw new Error("unknown provider: "+u)}$clearCache(u){return this.j.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,t,a,p){const b=this.e.get(u);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const R=m(a);return this.q(R,b).search(i=>this.c.$handleTextMatch(u,t,i),p)}$enableExtensionHostSearch(){}q(u,t){return new M.TextSearchManager(u,t,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};T=qe([Ve(0,E.IExtHostRpcService),Ve(1,O.IURITransformerService),Ve(2,S.ILogService)],T),e.ExtHostSearch=T;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(w),extraFileResources:f.extraFileResources&&f.extraFileResources.map(u=>P.URI.revive(u))}}e.reviveQuery=m;function w(f){return{...f,folder:P.URI.revive(f.folder)}}}),define(Te[252],Pe([1,0,67,106,31,104,32,38,58,61,108,110,111,80,70,76,105,60,37,79,57,59,221,12,177,109,78]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t,a,p,b,R,v,i,d,s,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(o.IExtHostLocalizationService,o.ExtHostLocalizationService,1),(0,n.registerSingleton)(d.ILoggerService,i.ExtHostLoggerService,1),(0,n.registerSingleton)(d.ILogService,s.ExtHostLogService,1),(0,n.registerSingleton)(u.IExtHostApiDeprecationService,u.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(O.IExtHostCommands,O.ExtHostCommands,0),(0,n.registerSingleton)(E.IExtHostConfiguration,E.ExtHostConfiguration,0),(0,n.registerSingleton)(a.IExtHostConsumerFileSystem,a.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService,0),(0,n.registerSingleton)(N.IExtHostDecorations,N.ExtHostDecorations,0),(0,n.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,n.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,0),(0,n.registerSingleton)(w.IExtHostStorage,w.ExtHostStorage,0),(0,n.registerSingleton)(M.IExtHostTask,M.WorkerExtHostTask,0),(0,n.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,0),(0,n.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,n.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,0),(0,n.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,n.registerSingleton)(R.IExtHostTelemetry,R.ExtHostTelemetry,0),(0,n.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,n.registerSingleton)(l.IExtHostVariableResolverProvider,l.ExtHostVariableResolverProviderService,0)}),define(Te[253],Pe([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class n{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(D){if(D&&this.a.has(D)){const N=this.a.get(D);return this.a.delete(D),N}}addDragOperationTransfer(D,N){this.a.set(D,N)}getRenderedTreeElement(D){if(this.b.has(D))return this.b.get(D)}addRenderedTreeItemElement(D,N){this.b.set(D,N)}removeRenderedTreeItemElement(D){this.b.has(D)&&this.b.delete(D)}}e.TreeviewsService=n}),define(Te[254],Pe([1,0,146,7,22,2,4,6,182,17,7,9,16,8,21,253,26]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function a(R,v){if((0,T.isString)(R))return{label:R};if(R&&typeof R=="object"&&typeof R.label=="string"){let i;return Array.isArray(R.highlights)&&(i=R.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),i=i.length?i:void 0),{label:R.label,highlights:i}}}class p{constructor(v,i,d){this.d=v,this.e=i,this.f=d,this.a=new Map,this.b=new u.TreeviewsService;function s(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:l=>s(l)?this.i(l):Array.isArray(l)&&l.length>0?l.map(o=>s(o)?this.i(o):o):l})}registerTreeDataProvider(v,i,d){const s=this.createTreeView(v,{treeDataProvider:i},d);return{dispose:()=>s.dispose()}}createTreeView(v,i,d){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=i.dragAndDropController?.dropMimeTypes??[],l=i.dragAndDropController?.dragMimeTypes??[],o=!!i.dragAndDropController?.handleDrag,I=!!i.dragAndDropController?.handleDrop,r=this.h(v,i,d),c=this.d.$registerTreeViewDataProvider(v,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:s,dragMimeTypes:l,hasHandleDrag:o,hasHandleDrop:I});return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(d,"treeItemCheckbox"),r.onDidChangeCheckboxState},get message(){return r.message},set message(h){r.message=h},get title(){return r.title},set title(h){r.title=h},get description(){return r.description},set description(h){r.description=h},get badge(){return r.badge},set badge(h){h!==void 0&&M.ViewBadge.isViewBadge(h)?r.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(r.badge=void 0)},reveal:(h,y)=>r.reveal(h,y),dispose:async()=>{await c,this.a.delete(v),r.dispose()}}}$getChildren(v,i){const d=this.a.get(v);return d?d.getChildren(i):Promise.reject(new S.NoTreeViewError(v))}async $handleDrop(v,i,d,s,l,o,I,r){const c=this.a.get(v);if(!c)return Promise.reject(new S.NoTreeViewError(v));const h=w.DataTransfer.toDataTransfer(d,async y=>(await this.d.$resolveDropFileData(v,i,y)).buffer);return I===v&&r&&await this.g(h,c,r,l,o),c.onDrop(h,s,l)}async g(v,i,d,s,l){const o=this.b.removeDragOperationTransfer(l);if(o)(await o)?.forEach((I,r)=>{I&&v.set(r,I)});else if(l&&i.handleDrag){const I=i.handleDrag(d,v,s);this.b.addDragOperationTransfer(l,I),await I}return v}async $handleDrag(v,i,d,s){const l=this.a.get(v);if(!l)return Promise.reject(new S.NoTreeViewError(v));const o=await this.g(new A.DataTransfer,l,i,s,d);if(!!o)return w.DataTransfer.toDataTransferDTO(o)}async $hasResolve(v){const i=this.a.get(v);if(!i)throw new S.NoTreeViewError(v);return i.hasResolve}$resolve(v,i,d){const s=this.a.get(v);if(!s)throw new S.NoTreeViewError(v);return s.resolveTreeItem(i,d)}$setExpanded(v,i,d){const s=this.a.get(v);if(!s)throw new S.NoTreeViewError(v);s.setExpanded(i,d)}$setSelection(v,i){const d=this.a.get(v);if(!d)throw new S.NoTreeViewError(v);d.setSelection(i)}$setFocus(v,i){const d=this.a.get(v);if(!d)throw new S.NoTreeViewError(v);d.setFocus(i)}$setVisible(v,i){const d=this.a.get(v);if(!d)throw new S.NoTreeViewError(v);d.setVisible(i)}$changeCheckboxState(v,i){const d=this.a.get(v);if(!d)throw new S.NoTreeViewError(v);d.setCheckboxState(i)}h(v,i,d){const s=new b(v,i,this.d,this.e.converter,this.f,d);return this.a.set(v,s),s}i(v){const i=this.a.get(v.$treeViewId);return i&&"$treeItemHandle"in v?i.getExtensionElement(v.$treeItemHandle):i&&"$focusedTreeItem"in v&&v.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=p;class b extends O.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(v=>this.getExtensionElement(v)).filter(v=>!(0,T.isUndefinedOrNull)(v))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(v,i,d,s,l,o){if(super(),this.C=v,this.D=d,this.F=s,this.G=l,this.H=o,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new E.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new E.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new E.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new E.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new E.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new E.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new f.CancellationTokenSource,o.contributes&&o.contributes.views)for(const c in o.contributes.views)for(const h of o.contributes.views[c])h.id===v&&(this.J=h.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(c=>this.w.fire({message:!1,element:c})));let I,r;this.B(E.Event.debounce(this.w.event,(c,h)=>(c||(c={message:!1,elements:[]}),h.element!==!1&&(I||(I=new Promise(y=>r=y),this.y=this.y.then(()=>I)),Array.isArray(h.element)?c.elements.push(...h.element):c.elements.push(h.element)),h.message&&(c.message=!0),c),200,!0)(({message:c,elements:h})=>{h.length&&(this.z=this.z.then(()=>{const y=r;return I=null,this.U(h).then(()=>y())})),c&&this.D.$setMessage(this.C,this.I)}))}async getChildren(v){const i=v?this.getExtensionElement(v):void 0;if(v&&!i)return this.G.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let d=this.Q(v);return d||(d=await this.R(i)),d?d.map(s=>s.item):void 0}getExtensionElement(v){return this.i.get(v)}reveal(v,i){i=i||{select:!0,focus:!1};const d=(0,T.isUndefinedOrNull)(i.select)?!0:i.select,s=(0,T.isUndefinedOrNull)(i.focus)?!1:i.focus,l=(0,T.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.y.then(()=>this.N(v)).then(o=>this.P(v,o[o.length-1]).then(I=>this.D.$reveal(this.C,{item:I.item,parentChain:o.map(r=>r.item)},{select:d,focus:s,expand:l})),o=>this.G.error(o)):this.D.$reveal(this.C,void 0,{select:d,focus:s,expand:l})}get message(){return this.I}set message(v){this.I=v,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(v){this.J=v,this.D.$setTitle(this.C,v,this.L)}get description(){return this.L}set description(v){this.L=v,this.D.$setTitle(this.C,this.J,v)}get badge(){return this.M}set badge(v){this.M?.value===v?.value&&this.M?.tooltip===v?.tooltip||(this.M=w.ViewBadge.from(v),this.D.$setBadge(this.C,v))}setExpanded(v,i){const d=this.getExtensionElement(v);d&&(i?this.r.fire(Object.freeze({element:d})):this.s.fire(Object.freeze({element:d})))}setSelection(v){(0,m.equals)(this.l,v)||(this.l=v,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this.m=v}setVisible(v){v!==this.k&&(this.k=v,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(v){const i=(await Promise.all(v.map(async d=>{const s=this.getExtensionElement(d.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:d.newState?M.TreeItemCheckboxState.Checked:M.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);i.forEach(d=>{d.treeItem.checkboxState=d.newState?M.TreeItemCheckboxState.Checked:M.TreeItemCheckboxState.Unchecked}),this.v.fire({items:i.map(d=>[d.extensionItem,d.newState])})}async handleDrag(v,i,d){const s=[];for(const l of v){const o=this.getExtensionElement(l);o&&s.push(o)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,i,d),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,i,d){const s=i?this.getExtensionElement(i):void 0;if(!(!s&&i||!this.g?.handleDrop))return(0,P.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,v,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,i){if(!this.f.resolveTreeItem)return;const d=this.i.get(v);if(d){const s=this.j.get(d);if(s){const l=await this.f.resolveTreeItem(s.extensionItem,d,i)??s.extensionItem;return this.db(l),s.item.tooltip=this.ab(l.tooltip),s.item.command=this.bb(s.disposableStore,l.command),s.item}}}N(v){return this.O(v).then(i=>i?this.N(i).then(d=>this.P(i,d[d.length-1]).then(s=>(d.push(s),d))):Promise.resolve([]))}O(v){const i=this.j.get(v);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,P.asPromise)(()=>this.f.getParent(v))}P(v,i){const d=this.j.get(v);return d?Promise.resolve(d):(0,P.asPromise)(()=>this.f.getTreeItem(v)).then(s=>this.gb(v,s,i,!0)).then(s=>this.getChildren(i?i.item.handle:void 0).then(()=>{const l=this.getExtensionElement(s);if(l){const o=this.j.get(l);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(v){if(v){let i;if(typeof v=="string"){const d=this.getExtensionElement(v);i=d?this.j.get(d):void 0}else i=v;return i&&i.children||void 0}return this.h}async R(v){this.nb(v);const i=new f.CancellationTokenSource(this.S.token);try{const d=v?this.j.get(v):void 0,s=await this.f.getChildren(v);if(i.token.isCancellationRequested)return;const l=await Promise.all((0,m.coalesce)(s||[]).map(async o=>{const I=await this.f.getTreeItem(o);return I&&!i.token.isCancellationRequested?this.Z(o,I,d):null}));return i.token.isCancellationRequested?void 0:(0,m.coalesce)(l)}finally{i.dispose()}}U(v){if(v.some(d=>!d))return this.S.dispose(!0),this.S=new f.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const d=this.W(v);if(d.length)return this.X(d)}return Promise.resolve(void 0)}W(v){const i=new Set,d=v.map(l=>this.j.get(l));for(const l of d)if(l&&!i.has(l.item.handle)){let o=l;for(;o&&o.parent&&d.findIndex(I=>o&&o.parent&&I&&I.item.handle===o.parent.item.handle)===-1;){const I=this.i.get(o.parent.item.handle);o=I?this.j.get(I):void 0}o&&!o.parent&&i.add(l.item.handle)}const s=[];return i.forEach(l=>{const o=this.i.get(l);if(o){const I=this.j.get(o);I&&(!I.parent||!i.has(I.parent.item.handle))&&s.push(l)}}),s}X(v){const i={};return Promise.all(v.map(d=>this.Y(d).then(s=>{s&&(i[d]=s.item)}))).then(()=>Object.keys(i).length?this.D.$refresh(this.C,i):void 0)}Y(v){const i=this.getExtensionElement(v);if(i){const d=this.j.get(i);if(d)return this.nb(i),(0,P.asPromise)(()=>this.f.getTreeItem(i)).then(s=>{if(s){const l=this.eb(i,s,d.parent);return this.lb(i,l,d,d.parent),d.dispose(),l}return null})}return Promise.resolve(null)}Z(v,i,d){const s=this.eb(v,i,d);if(i.id&&this.i.has(s.item.handle))throw new Error((0,n.localize)(0,null,i.id));return this.kb(v,s),this.mb(s,d),s}ab(v){return M.MarkdownString.isMarkdownString(v)?w.MarkdownString.from(v):v}bb(v,i){return i?{...this.F.toInternal(i,v),originalId:i.command}:void 0}cb(v){if(!v.checkboxState)return;let i,d;return typeof v.checkboxState=="number"?i=v.checkboxState:(i=v.checkboxState.state,d=v.checkboxState.tooltip),{isChecked:i===M.TreeItemCheckboxState.Checked,tooltip:d}}db(v){if(!M.TreeItem.isTreeItem(v,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(v,i,d){this.db(i);const s=new O.DisposableStore,l=this.gb(v,i,d),o=this.hb(i);return{item:{handle:l,parentHandle:d?d.item.handle:void 0,label:a(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(s,i.command),contextValue:i.contextValue,icon:o,iconDark:this.ib(i)||o,themeIcon:this.fb(i),collapsibleState:(0,T.isUndefinedOrNull)(i.collapsibleState)?M.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:d,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(v){return v.iconPath instanceof M.ThemeIcon?v.iconPath:void 0}gb(v,{id:i,label:d,resourceUri:s},l,o){if(i)return`${b.b}/${i}`;const I=a(d,this.H),r=l?l.item.handle:b.a;let c=I?I.label:s?(0,D.basename)(s):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const h=this.j.has(v)?this.j.get(v).item.handle:void 0,y=this.Q(l)||[];let C,H=0;do{if(C=`${r}/${H}:${c}`,o||!this.i.has(C)||h===C)break;H++}while(H<=y.length);return C}hb(v){if(v.iconPath&&!(v.iconPath instanceof M.ThemeIcon))return typeof v.iconPath=="string"||N.URI.isUri(v.iconPath)?this.jb(v.iconPath):this.jb(v.iconPath.light)}ib(v){if(v.iconPath&&!(v.iconPath instanceof M.ThemeIcon)&&v.iconPath.dark)return this.jb(v.iconPath.dark)}jb(v){return N.URI.isUri(v)?v:N.URI.file(v)}kb(v,i){this.i.set(i.item.handle,v),this.j.set(v,i)}lb(v,i,d,s){this.i.delete(i.item.handle),this.j.delete(v),i.item.handle!==d.item.handle&&this.i.delete(d.item.handle),this.kb(v,i);const l=this.Q(s)||[],o=l.filter(I=>I.item.handle===d.item.handle)[0];o&&l.splice(l.indexOf(o),1,i)}mb(v,i){i?(i.children||(i.children=[]),i.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}nb(v){if(v){const i=this.j.get(v);if(i){if(i.children)for(const d of i.children){const s=this.i.get(d.item.handle);s&&this.ob(s)}i.children=void 0}}else this.pb()}ob(v){const i=this.j.get(v);if(i){if(i.children)for(const d of i.children){const s=this.i.get(d.item.handle);s&&this.ob(s)}this.j.delete(v),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(v=>v.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(Te[255],Pe([1,0,21,11,4,29,2,131,264,119,129,43,5,74,208,207,38,209,32,211,212,213,196,214,58,33,215,216,219,220,222,106,199,228,229,230,80,61,233,254,8,7,52,236,62,105,31,24,188,218,50,104,108,110,111,12,55,18,27,223,194,70,76,205,234,81,60,239,237,238,206,37,231,235,79,59,57,224,107,225,15,92,198,179,217,6,26,184,78,175,226,227]),function(te,e,n,A,D,N,E,O,S,P,M,T,m,w,f,u,t,a,p,b,R,v,i,d,s,l,o,I,r,c,h,y,C,H,K,Q,_,j,L,g,F,B,Y,me,Z,se,ue,De,de,ie,q,ce,be,Ae,Ue,Ce,Se,ke,oe,ae,J,k,$,W,V,ee,fe,Ie,le,ve,Ee,We,je,it,Ge,tt,nt,Ne,rt,G,X,pe,ze,Be,Qe,_e,Xe,at,bt,kt,Dt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Bt(ct){const pt=ct.get(oe.IExtHostInitDataService),Ht=ct.get(We.IExtHostFileSystemInfo),Ft=ct.get(fe.IExtHostConsumerFileSystem),It=ct.get(l.IExtHostExtensionService),ft=ct.get(ue.IExtHostWorkspace),Tt=ct.get(nt.IExtHostTelemetry),Nt=ct.get(p.IExtHostConfiguration),Ot=ct.get(Se.IURITransformerService),Ke=ct.get(ke.IExtHostRpcService),qt=ct.get(_.IExtHostStorage),Lt=ct.get(ee.IExtensionStoragePaths),Ut=ct.get(Ce.ILoggerService),ye=ct.get(Ce.ILogService),Re=ct.get(k.IExtHostTunnelService),ge=ct.get($.IExtHostApiDeprecationService),x=ct.get(se.IExtHostWindow),Oe=ct.get(Ge.IExtHostSecretState),$e=ct.get(tt.IExtHostEditorTabs);Ke.set(m.ExtHostContext.ExtHostFileSystemInfo,Ht),Ke.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Ut),Ke.set(m.ExtHostContext.ExtHostWorkspace,ft),Ke.set(m.ExtHostContext.ExtHostConfiguration,Nt),Ke.set(m.ExtHostContext.ExtHostExtensionService,It),Ke.set(m.ExtHostContext.ExtHostStorage,qt),Ke.set(m.ExtHostContext.ExtHostTunnelService,Re),Ke.set(m.ExtHostContext.ExtHostWindow,x),Ke.set(m.ExtHostContext.ExtHostSecretState,Oe),Ke.set(m.ExtHostContext.ExtHostTelemetry,Tt),Ke.set(m.ExtHostContext.ExtHostEditorTabs,$e);const Ze=Ke.set(m.ExtHostContext.ExtHostDecorations,ct.get(ce.IExtHostDecorations)),He=Ke.set(m.ExtHostContext.ExtHostDocumentsAndEditors,ct.get(s.IExtHostDocumentsAndEditors)),et=Ke.set(m.ExtHostContext.ExtHostCommands,ct.get(t.IExtHostCommands)),ut=Ke.set(m.ExtHostContext.ExtHostTerminalService,ct.get(j.IExtHostTerminalService)),ht=Ke.set(m.ExtHostContext.ExtHostDebugService,ct.get(Ae.IExtHostDebugService)),Ct=Ke.set(m.ExtHostContext.ExtHostSearch,ct.get(Ue.IExtHostSearch)),mt=Ke.set(m.ExtHostContext.ExtHostTask,ct.get(be.IExtHostTask)),vt=Ke.set(m.ExtHostContext.ExtHostOutputService,ct.get(y.IExtHostOutputService)),Pt=Ke.set(m.ExtHostContext.ExtHostLocalization,ct.get(bt.IExtHostLocalizationService)),zt=Ke.set(m.ExtHostContext.ExtHostUrls,new me.ExtHostUrls(Ke)),At=Ke.set(m.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Ke,He)),ti=Ke.set(m.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Ke,He,ye)),oi=Ke.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(ye,At,Ke.getProxy(m.MainContext.MainThreadBulkEdits))),yt=Ke.set(m.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(Ke,et,He,At)),ai=Ke.set(m.ExtHostContext.ExtHostNotebookDocuments,new Be.ExtHostNotebookDocuments(yt)),ci=Ke.set(m.ExtHostContext.ExtHostNotebookEditors,new ze.ExtHostNotebookEditors(ye,yt)),Jt=Ke.set(m.ExtHostContext.ExtHostNotebookKernels,new Ne.ExtHostNotebookKernels(Ke,pt,yt,et,ye)),wi=Ke.set(m.ExtHostContext.ExtHostNotebookRenderers,new G.ExtHostNotebookRenderers(Ke,yt)),Et=Ke.set(m.ExtHostContext.ExtHostEditors,new L.ExtHostEditors(Ke,He)),ui=Ke.set(m.ExtHostContext.ExtHostTreeViews,new g.ExtHostTreeViews(Ke.getProxy(m.MainContext.MainThreadTreeViews),et,ye)),Ui=Ke.set(m.ExtHostContext.ExtHostEditorInsets,new de.ExtHostEditorInsets(Ke.getProxy(m.MainContext.MainThreadEditorInsets),Et,pt.remote)),Zt=Ke.set(m.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Ke,ye,Ht,He)),ii=Ke.set(m.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(Ke,At,et.converter,Ot)),dt=Ke.set(m.ExtHostContext.ExtHostLanguageFeatures,new r.ExtHostLanguageFeatures(Ke,Ot,At,et,Zt,ye,ge,Tt)),ei=Ke.set(m.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(Ke,dt)),Vt=Ke.set(m.ExtHostContext.ExtHostFileSystemEventService,new I.ExtHostFileSystemEventService(Ke,ye,He)),Xt=Ke.set(m.ExtHostContext.ExtHostQuickOpen,(0,H.createExtHostQuickOpen)(Ke,ft,et)),li=Ke.set(m.ExtHostContext.ExtHostSCM,new K.ExtHostSCM(Ke,et,ye)),Si=Ke.set(m.ExtHostContext.ExtHostQuickDiff,new St.ExtHostQuickDiff(Ke,Ot)),yi=Ke.set(m.ExtHostContext.ExtHostComments,(0,a.createExtHostComments)(Ke,et,At)),di=Ke.set(m.ExtHostContext.ExtHostProgress,new C.ExtHostProgress(Ke.getProxy(m.MainContext.MainThreadProgress))),Di=Ke.set(m.ExtHostContext.ExtHosLabelService,new ie.ExtHostLabelService(Ke)),hi=Ke.set(m.ExtHostContext.ExtHostTheming,new J.ExtHostTheming(Ke)),fi=Ke.set(m.ExtHostContext.ExtHostAuthentication,new W.ExtHostAuthentication(Ke)),Ii=Ke.set(m.ExtHostContext.ExtHostTimeline,new V.ExtHostTimeline(Ke,et)),ni=Ke.set(m.ExtHostContext.ExtHostWebviews,new Z.ExtHostWebviews(Ke,pt.remote,ft,ye,ge)),ri=Ke.set(m.ExtHostContext.ExtHostWebviewPanels,new ve.ExtHostWebviewPanels(Ke,ni,ft)),Ci=Ke.set(m.ExtHostContext.ExtHostCustomEditors,new le.ExtHostCustomEditors(Ke,At,Lt,ni,ri)),$i=Ke.set(m.ExtHostContext.ExtHostWebviewViews,new Ie.ExtHostWebviewViews(Ke,ni)),Qt=Ke.set(m.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(Ke,et,He)),ki=Ke.set(m.ExtHostContext.ExtHostUriOpeners,new it.ExtHostUriOpeners(Ke)),Bi=Ke.set(m.ExtHostContext.ExtHostProfileContentHandlers,new Dt.ExtHostProfileContentHandlers(Ke));Ke.set(m.ExtHostContext.ExtHostInteractive,new Qe.ExtHostInteractive(Ke,yt,He,et,ye));const zi=Object.values(m.ExtHostContext);Ke.assertRegistered(zi);const Wi=new Ee.ExtHostBulkEdits(Ke,He),Hi=new u.ExtHostClipboard(Ke),Ti=new h.ExtHostMessageService(Ke,ye),Oi=new R.ExtHostDialogs(Ke),mi=new Q.ExtHostStatusBar(Ke,et.converter);return f.ExtHostApiCommands.register(et),function(Me,xt,Li){const gt=function(){let re=!Me.isUnderDevelopment;function he(){re||(ye.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Le(st){if(Array.isArray(st))st.forEach(Le);else if(typeof st=="string")he();else{const wt=st;typeof wt.scheme>"u"&&he(),typeof wt.exclusive=="boolean"&&(0,Xe.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return st}}(),gi={getSession(re,he,Le){return fi.getSession(Me,re,he,Le)},async hasSession(re,he){return(0,Xe.checkProposedApiEnabled)(Me,"authSession"),!!await fi.getSession(Me,re,he,{silent:!0})},get onDidChangeSessions(){return fi.onDidChangeSessions},registerAuthenticationProvider(re,he,Le,st){return fi.registerAuthenticationProvider(re,he,Le,st)}},Vi={registerCommand(re,he,Le){return et.registerCommand(!0,re,he,Le,void 0,Me)},registerTextEditorCommand(re,he,Le){return et.registerCommand(!0,re,(...st)=>{const wt=Et.getActiveTextEditor();if(!wt){ye.warn("Cannot execute "+re+" because there is no active text editor.");return}return wt.edit(Rt=>{he.apply(Le,[wt,Rt,...st])}).then(Rt=>{Rt||ye.warn("Edits from command "+re+" were not applied.")},Rt=>{ye.warn("An error occurred while running command "+re,Rt)})},void 0,void 0,Me)},registerDiffInformationCommand:(re,he,Le)=>((0,Xe.checkProposedApiEnabled)(Me,"diffCommand"),et.registerCommand(!0,re,async(...st)=>{const wt=He.activeEditor(!0);if(!wt){ye.warn("Cannot execute "+re+" because there is no active text editor.");return}const Rt=await Et.getDiffInformation(wt.id);he.apply(Le,[Rt,...st])},void 0,void 0,Me)),executeCommand(re,...he){return et.executeCommand(re,...he)},getCommands(re=!1){return et.getCommands(re)}},Fi={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return ut.getDefaultShell(!1)},get onDidChangeShell(){return(0,Xe.checkProposedApiEnabled)(Me,"envShellEvent"),ut.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(Me,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.checkProposedApiEnabled)(Me,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(re){return nt.ExtHostTelemetryLogger.validateSender(re),Tt.instantiateLogger(Me,re)},openExternal(re,he){return x.openUri(re,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===pt.environment.appUriScheme)return zt.createAppUri(re);try{return await x.asExternalUri(re,{allowTunneling:!!pt.remote.authority})}catch(he){if((0,pe.matchesScheme)(re,X.Schemas.http)||(0,pe.matchesScheme)(re,X.Schemas.https))return re;throw he}},get remoteName(){return(0,q.getRemoteName)(pt.remote.authority)},get remoteAuthority(){return(0,Xe.checkProposedApiEnabled)(Me,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return ye.getLevel()},get onDidChangeLogLevel(){return ye.onDidChangeLogLevel}};pt.environment.extensionTestsLocationURI||Object.freeze(Fi);const ji={createTestController(re,he,Le){return Qt.createTestController(Me,re,he,Le)},createTestObserver(){return(0,Xe.checkProposedApiEnabled)(Me,"testObserver"),Qt.createTestObserver()},runTests(re){return(0,Xe.checkProposedApiEnabled)(Me,"testObserver"),Qt.runTests(re)},get onDidChangeTestResults(){return(0,Xe.checkProposedApiEnabled)(Me,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,Xe.checkProposedApiEnabled)(Me,"testObserver"),Qt.results}},pi=pt.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,Pi={getExtension(re,he){(0,Xe.isProposedApiEnabled)(Me,"extensionsAny")||(he=!1);const Le=xt.mine.getExtensionDescription(re);if(Le)return new l.Extension(It,Me.identifier,Le,pi,!1);if(he){const st=xt.all.getExtensionDescription(re);if(st)return new l.Extension(It,Me.identifier,st,pi,!0)}},get all(){const re=[];for(const he of xt.mine.getAllExtensionDescriptions())re.push(new l.Extension(It,Me.identifier,he,pi,!1));return re},get allAcrossExtensionHosts(){(0,Xe.checkProposedApiEnabled)(Me,"extensionsAny");const re=new De.ExtensionIdentifierSet(xt.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),he=[];for(const Le of xt.all.getAllExtensionDescriptions()){const st=!re.has(Le.identifier);he.push(new l.Extension(It,Me.identifier,Le,pi,st))}return he},get onDidChange(){return(0,Xe.isProposedApiEnabled)(Me,"extensionsAny")?D.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},qi={createDiagnosticCollection(re){return Zt.createDiagnosticCollection(Me.identifier,re)},get onDidChangeDiagnostics(){return Zt.onDidChangeDiagnostics},getDiagnostics:re=>Zt.getDiagnostics(re),getLanguages(){return ii.getLanguages()},setTextDocumentLanguage(re,he){return ii.changeLanguage(re.uri,he)},match(re,he){const Le=At.getDocumentData(he.uri)?.notebook;return(0,M.score)(F.LanguageSelector.from(re),he.uri,he.languageId,!0,Le?.uri,Le?.notebookType)},registerCodeActionsProvider(re,he,Le){return dt.registerCodeActionProvider(Me,gt(re),he,Le)},registerDocumentPasteEditProvider(re,he,Le){return(0,Xe.checkProposedApiEnabled)(Me,"documentPaste"),dt.registerDocumentPasteEditProvider(Me,gt(re),he,Le)},registerCodeLensProvider(re,he){return dt.registerCodeLensProvider(Me,gt(re),he)},registerDefinitionProvider(re,he){return dt.registerDefinitionProvider(Me,gt(re),he)},registerDeclarationProvider(re,he){return dt.registerDeclarationProvider(Me,gt(re),he)},registerImplementationProvider(re,he){return dt.registerImplementationProvider(Me,gt(re),he)},registerTypeDefinitionProvider(re,he){return dt.registerTypeDefinitionProvider(Me,gt(re),he)},registerHoverProvider(re,he){return dt.registerHoverProvider(Me,gt(re),he,Me.identifier)},registerEvaluatableExpressionProvider(re,he){return dt.registerEvaluatableExpressionProvider(Me,gt(re),he,Me.identifier)},registerInlineValuesProvider(re,he){return dt.registerInlineValuesProvider(Me,gt(re),he,Me.identifier)},registerDocumentHighlightProvider(re,he){return dt.registerDocumentHighlightProvider(Me,gt(re),he)},registerLinkedEditingRangeProvider(re,he){return dt.registerLinkedEditingRangeProvider(Me,gt(re),he)},registerReferenceProvider(re,he){return dt.registerReferenceProvider(Me,gt(re),he)},registerRenameProvider(re,he){return dt.registerRenameProvider(Me,gt(re),he)},registerDocumentSymbolProvider(re,he,Le){return dt.registerDocumentSymbolProvider(Me,gt(re),he,Le)},registerWorkspaceSymbolProvider(re){return dt.registerWorkspaceSymbolProvider(Me,re)},registerDocumentFormattingEditProvider(re,he){return dt.registerDocumentFormattingEditProvider(Me,gt(re),he)},registerDocumentRangeFormattingEditProvider(re,he){return dt.registerDocumentRangeFormattingEditProvider(Me,gt(re),he)},registerOnTypeFormattingEditProvider(re,he,Le,...st){return dt.registerOnTypeFormattingEditProvider(Me,gt(re),he,[Le].concat(st))},registerDocumentSemanticTokensProvider(re,he,Le){return dt.registerDocumentSemanticTokensProvider(Me,gt(re),he,Le)},registerDocumentRangeSemanticTokensProvider(re,he,Le){return dt.registerDocumentRangeSemanticTokensProvider(Me,gt(re),he,Le)},registerSignatureHelpProvider(re,he,Le,...st){return typeof Le=="object"?dt.registerSignatureHelpProvider(Me,gt(re),he,Le):dt.registerSignatureHelpProvider(Me,gt(re),he,typeof Le>"u"?[]:[Le,...st])},registerCompletionItemProvider(re,he,...Le){return dt.registerCompletionItemProvider(Me,gt(re),he,Le)},registerInlineCompletionItemProvider(re,he){return he.handleDidShowCompletionItem&&(0,Xe.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Xe.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Me,gt(re),he)},registerDocumentLinkProvider(re,he){return dt.registerDocumentLinkProvider(Me,gt(re),he)},registerColorProvider(re,he){return dt.registerColorProvider(Me,gt(re),he)},registerFoldingRangeProvider(re,he){return dt.registerFoldingRangeProvider(Me,gt(re),he)},registerSelectionRangeProvider(re,he){return dt.registerSelectionRangeProvider(Me,re,he)},registerCallHierarchyProvider(re,he){return dt.registerCallHierarchyProvider(Me,re,he)},registerTypeHierarchyProvider(re,he){return dt.registerTypeHierarchyProvider(Me,re,he)},setLanguageConfiguration:(re,he)=>dt.setLanguageConfiguration(Me,re,he),getTokenInformationAtPosition(re,he){return(0,Xe.checkProposedApiEnabled)(Me,"tokenInformation"),ii.tokenAtPosition(re,he)},registerInlayHintsProvider(re,he){return dt.registerInlayHintsProvider(Me,re,he)},createLanguageStatusItem(re,he){return ii.createLanguageStatusItem(Me,re,he)},registerDocumentDropEditProvider(re,he){return dt.registerDocumentOnDropEditProvider(Me,re,he)}},Kt={get activeTextEditor(){return Et.getActiveTextEditor()},get visibleTextEditors(){return Et.getVisibleTextEditors()},get activeTerminal(){return ut.activeTerminal},get terminals(){return ut.terminals},async showTextDocument(re,he,Le){const st=await(E.URI.isUri(re)?Promise.resolve(si.openTextDocument(re)):Promise.resolve(re));return Et.showTextDocument(st,he,Le)},createTextEditorDecorationType(re){return Et.createTextEditorDecorationType(Me,re)},onDidChangeActiveTextEditor(re,he,Le){return Et.onDidChangeActiveTextEditor(re,he,Le)},onDidChangeVisibleTextEditors(re,he,Le){return Et.onDidChangeVisibleTextEditors(re,he,Le)},onDidChangeTextEditorSelection(re,he,Le){return Et.onDidChangeTextEditorSelection(re,he,Le)},onDidChangeTextEditorOptions(re,he,Le){return Et.onDidChangeTextEditorOptions(re,he,Le)},onDidChangeTextEditorVisibleRanges(re,he,Le){return Et.onDidChangeTextEditorVisibleRanges(re,he,Le)},onDidChangeTextEditorViewColumn(re,he,Le){return Et.onDidChangeTextEditorViewColumn(re,he,Le)},onDidCloseTerminal(re,he,Le){return ut.onDidCloseTerminal(re,he,Le)},onDidOpenTerminal(re,he,Le){return ut.onDidOpenTerminal(re,he,Le)},onDidChangeActiveTerminal(re,he,Le){return ut.onDidChangeActiveTerminal(re,he,Le)},onDidChangeTerminalDimensions(re,he,Le){return(0,Xe.checkProposedApiEnabled)(Me,"terminalDimensions"),ut.onDidChangeTerminalDimensions(re,he,Le)},onDidChangeTerminalState(re,he,Le){return ut.onDidChangeTerminalState(re,he,Le)},onDidWriteTerminalData(re,he,Le){return(0,Xe.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),ut.onDidWriteTerminalData(re,he,Le)},get state(){return x.state},onDidChangeWindowState(re,he,Le){return x.onDidChangeWindowState(re,he,Le)},showInformationMessage(re,...he){return Ti.showMessage(Me,N.default.Info,re,he[0],he.slice(1))},showWarningMessage(re,...he){return Ti.showMessage(Me,N.default.Warning,re,he[0],he.slice(1))},showErrorMessage(re,...he){return Ti.showMessage(Me,N.default.Error,re,he[0],he.slice(1))},showQuickPick(re,he,Le){return Xt.showQuickPick(Me,re,he,Le)},showWorkspaceFolderPick(re){return Xt.showWorkspaceFolderPick(re)},showInputBox(re,he){return Xt.showInput(re,he)},showOpenDialog(re){return Oi.showOpenDialog(Me,re)},showSaveDialog(re){return Oi.showSaveDialog(re)},createStatusBarItem(re,he,Le){let st,wt,Rt;return typeof re=="string"?(st=re,wt=he,Rt=Le):(wt=re,Rt=he),mi.createStatusBarEntry(Me,st,wt,Rt)},setStatusBarMessage(re,he){return mi.setStatusBarMessage(re,he)},withScmProgress(re){return ge.report("window.withScmProgress",Me,"Use 'withProgress' instead."),di.withProgress(Me,{location:B.ProgressLocation.SourceControl},(he,Le)=>re({report(st){}}))},withProgress(re,he){return di.withProgress(Me,re,he)},createOutputChannel(re,he){return vt.createOutputChannel(re,he,Me)},createWebviewPanel(re,he,Le,st){return ri.createWebviewPanel(Me,re,he,Le,st)},createWebviewTextEditorInset(re,he,Le,st){return(0,Xe.checkProposedApiEnabled)(Me,"editorInsets"),Ui.createWebviewEditorInset(re,he,Le,st,Me)},createTerminal(re,he,Le){return typeof re=="object"?"pty"in re?ut.createExtensionTerminal(re):ut.createTerminalFromOptions(re):ut.createTerminal(re,he,Le)},registerTerminalLinkProvider(re){return ut.registerLinkProvider(re)},registerTerminalProfileProvider(re,he){return ut.registerProfileProvider(Me,re,he)},registerTerminalQuickFixProvider(re,he){return(0,Xe.checkProposedApiEnabled)(Me,"terminalQuickFixProvider"),ut.registerTerminalQuickFixProvider(re,Me.identifier.value,he)},registerTreeDataProvider(re,he){return ui.registerTreeDataProvider(re,he,Me)},createTreeView(re,he){return ui.createTreeView(re,he,Me)},registerWebviewPanelSerializer:(re,he)=>ri.registerWebviewPanelSerializer(Me,re,he),registerCustomEditorProvider:(re,he,Le={})=>Ci.registerCustomEditorProvider(Me,re,he,Le),registerFileDecorationProvider(re){return Ze.registerFileDecorationProvider(re,Me)},registerUriHandler(re){return zt.registerUriHandler(Me.identifier,re)},createQuickPick(){return Xt.createQuickPick(Me)},createInputBox(){return Xt.createInputBox(Me)},get activeColorTheme(){return hi.activeColorTheme},onDidChangeActiveColorTheme(re,he,Le){return hi.onDidChangeActiveColorTheme(re,he,Le)},registerWebviewViewProvider(re,he,Le){return $i.registerWebviewViewProvider(Me,re,he,Le?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,he,Le){return yt.onDidChangeActiveNotebookEditor(re,he,Le)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,he,Le){return ci.onDidChangeNotebookEditorSelection(re,he,Le)},onDidChangeNotebookEditorVisibleRanges(re,he,Le){return ci.onDidChangeNotebookEditorVisibleRanges(re,he,Le)},showNotebookDocument(re,he){return yt.showNotebookDocument(re,he)},registerExternalUriOpener(re,he,Le){return(0,Xe.checkProposedApiEnabled)(Me,"externalUriOpener"),ki.registerExternalUriOpener(Me.identifier,re,he,Le)},registerProfileContentHandler(re,he){return(0,Xe.checkProposedApiEnabled)(Me,"profileContentHandlers"),Bi.registrProfileContentHandler(Me,re,he)},registerQuickDiffProvider(re,he,Le,st){return(0,Xe.checkProposedApiEnabled)(Me,"quickDiffProvider"),Si.registerQuickDiffProvider(gt(re),he,Le,st)},get tabGroups(){return $e.tabGroups}},si={get rootPath(){return ge.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(re){throw A.readonly()},getWorkspaceFolder(re){return ft.getWorkspaceFolder(re)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(re){throw A.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(re){throw A.readonly()},updateWorkspaceFolders:(re,he,...Le)=>ft.updateWorkspaceFolders(Me,re,he||0,...Le),onDidChangeWorkspaceFolders:function(re,he,Le){return ft.onDidChangeWorkspace(re,he,Le)},asRelativePath:(re,he)=>ft.getRelativePath(re,he),findFiles:(re,he,Le,st)=>ft.findFiles(re,he,Le,Me.identifier,st),findTextInFiles:(re,he,Le,st)=>{(0,Xe.checkProposedApiEnabled)(Me,"findTextInFiles");let wt,Rt;return typeof he=="object"?(wt=he,Rt=Le):(wt={},Rt=he,st=Le),ft.findTextInFiles(re,wt||{},Rt,Me.identifier,st)},saveAll:re=>ft.saveAll(re),applyEdit(re,he){return Wi.applyWorkspaceEdit(re,Me,he)},createFileSystemWatcher:(re,he,Le,st)=>Vt.createFileSystemWatcher(ft,Me,re,he,Le,st),get textDocuments(){return At.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw A.readonly()},openTextDocument(re){let he;const Le=re;if(typeof re=="string")he=Promise.resolve(E.URI.file(re));else if(E.URI.isUri(re))he=Promise.resolve(re);else if(!Le||typeof Le=="object")he=At.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>At.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(re,he,Le)=>At.onDidAddDocument(re,he,Le),onDidCloseTextDocument:(re,he,Le)=>At.onDidRemoveDocument(re,he,Le),onDidChangeTextDocument:(re,he,Le)=>At.onDidChangeDocument(re,he,Le),onDidSaveTextDocument:(re,he,Le)=>At.onDidSaveDocument(re,he,Le),onWillSaveTextDocument:(re,he,Le)=>oi.getOnWillSaveTextDocumentEvent(Me)(re,he,Le),get notebookDocuments(){return yt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,he){let Le;if(E.URI.isUri(re))Le=re,await yt.openNotebookDocument(re);else if(typeof re=="string")Le=E.URI.revive(await yt.createNotebookDocument({viewType:re,content:he}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(re,he,Le){return ai.onDidSaveNotebookDocument(re,he,Le)},onDidChangeNotebookDocument(re,he,Le){return ai.onDidChangeNotebookDocument(re,he,Le)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(re,he,Le,st){return yt.registerNotebookSerializer(Me,re,he,Le,(0,Xe.isProposedApiEnabled)(Me,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(re,he,Le)=>Li.onDidChangeConfiguration(re,he,Le),getConfiguration(re,he){return he=arguments.length===1?void 0:he,Li.getConfiguration(re,he,Me)},registerTextDocumentContentProvider(re,he){return ti.registerTextDocumentContentProvider(re,he)},registerTaskProvider:(re,he)=>(ge.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),mt.registerTaskProvider(Me,re,he)),registerFileSystemProvider(re,he,Le){return(0,_e.combinedDisposable)(ei.registerFileSystemProvider(Me,re,he,Le),Ft.addFileSystemProvider(re,he))},get fs(){return Ft.value},registerFileSearchProvider:(re,he)=>((0,Xe.checkProposedApiEnabled)(Me,"fileSearchProvider"),Ct.registerFileSearchProvider(re,he)),registerTextSearchProvider:(re,he)=>((0,Xe.checkProposedApiEnabled)(Me,"textSearchProvider"),Ct.registerTextSearchProvider(re,he)),registerRemoteAuthorityResolver:(re,he)=>((0,Xe.checkProposedApiEnabled)(Me,"resolvers"),It.registerRemoteAuthorityResolver(re,he)),registerResourceLabelFormatter:re=>((0,Xe.checkProposedApiEnabled)(Me,"resolvers"),Di.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,he,Le)=>Vt.onDidCreateFile(re,he,Le),onDidDeleteFiles:(re,he,Le)=>Vt.onDidDeleteFile(re,he,Le),onDidRenameFiles:(re,he,Le)=>Vt.onDidRenameFile(re,he,Le),onWillCreateFiles:(re,he,Le)=>Vt.getOnWillCreateFileEvent(Me)(re,he,Le),onWillDeleteFiles:(re,he,Le)=>Vt.getOnWillDeleteFileEvent(Me)(re,he,Le),onWillRenameFiles:(re,he,Le)=>Vt.getOnWillRenameFileEvent(Me)(re,he,Le),openTunnel:re=>((0,Xe.checkProposedApiEnabled)(Me,"tunnels"),Re.openTunnel(Me,re).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Xe.checkProposedApiEnabled)(Me,"tunnels"),Re.getTunnels()},onDidChangeTunnels:(re,he,Le)=>((0,Xe.checkProposedApiEnabled)(Me,"tunnels"),Re.onDidChangeTunnels(re,he,Le)),registerPortAttributesProvider:(re,he)=>((0,Xe.checkProposedApiEnabled)(Me,"portsAttributes"),Re.registerPortsAttributesProvider(re,he)),registerTimelineProvider:(re,he)=>((0,Xe.checkProposedApiEnabled)(Me,"timeline"),Ii.registerTimelineProvider(re,he,Me.identifier,et.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:re=>((0,Xe.checkProposedApiEnabled)(Me,"workspaceTrust"),ft.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,he,Le)=>ft.onDidGrantWorkspaceTrust(re,he,Le),registerEditSessionIdentityProvider:(re,he)=>((0,Xe.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(re,he)),onWillCreateEditSessionIdentity:(re,he,Le)=>((0,Xe.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Me)(re,he,Le))},xi={get inputBox(){return ge.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),li.getLastInputBox(Me)},createSourceControl(re,he,Le){return li.createSourceControl(Me,re,he,Le)}},$t={createCommentController(re,he){return yi.createCommentController(Me,re,he)}},vi={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},onDidStartDebugSession(re,he,Le){return ht.onDidStartDebugSession(re,he,Le)},onDidTerminateDebugSession(re,he,Le){return ht.onDidTerminateDebugSession(re,he,Le)},onDidChangeActiveDebugSession(re,he,Le){return ht.onDidChangeActiveDebugSession(re,he,Le)},onDidReceiveDebugSessionCustomEvent(re,he,Le){return ht.onDidReceiveDebugSessionCustomEvent(re,he,Le)},onDidChangeBreakpoints(re,he,Le){return ht.onDidChangeBreakpoints(re,he,Le)},registerDebugConfigurationProvider(re,he,Le){return ht.registerDebugConfigurationProvider(re,he,Le||at.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,he){return ht.registerDebugAdapterDescriptorFactory(Me,re,he)},registerDebugAdapterTrackerFactory(re,he){return ht.registerDebugAdapterTrackerFactory(re,he)},startDebugging(re,he,Le){return!Le||typeof Le=="object"&&"configuration"in Le?ht.startDebugging(re,he,{parentSession:Le}):ht.startDebugging(re,he,Le||{})},stopDebugging(re){return ht.stopDebugging(re)},addBreakpoints(re){return ht.addBreakpoints(re)},removeBreakpoints(re){return ht.removeBreakpoints(re)},asDebugSourceUri(re,he){return ht.asDebugSourceUri(re,he)}},Ki={registerTaskProvider:(re,he)=>mt.registerTaskProvider(Me,re,he),fetchTasks:re=>mt.fetchTasks(re),executeTask:re=>mt.executeTask(Me,re),get taskExecutions(){return mt.taskExecutions},onDidStartTask:(re,he,Le)=>mt.onDidStartTask(re,he,Le),onDidEndTask:(re,he,Le)=>mt.onDidEndTask(re,he,Le),onDidStartTaskProcess:(re,he,Le)=>mt.onDidStartTaskProcess(re,he,Le),onDidEndTaskProcess:(re,he,Le)=>mt.onDidEndTaskProcess(re,he,Le)},Gi={createNotebookController(re,he,Le,st,wt){return Jt.createNotebookController(Me,re,he,Le,st,(0,Xe.isProposedApiEnabled)(Me,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(re,he)=>yt.registerNotebookCellStatusBarItemProvider(Me,re,he),createRendererMessaging(re){return wi.createRendererMessaging(Me,re)},createNotebookControllerDetectionTask(re){return(0,Xe.checkProposedApiEnabled)(Me,"notebookKernelSource"),Jt.createNotebookControllerDetectionTask(Me,re)},registerKernelSourceActionProvider(re,he){return(0,Xe.checkProposedApiEnabled)(Me,"notebookKernelSource"),Jt.registerKernelSourceActionProvider(Me,re,he)},onDidChangeNotebookCellExecutionState(re,he,Le){return(0,Xe.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),Jt.onDidChangeNotebookCellExecutionState(re,he,Le)}},Xi={t(...re){if(typeof re[0]=="string"){const he=re.shift(),Le=!re||typeof re[0]!="object"?re:re[0];return Pt.getMessage(Me.identifier.value,{message:he,args:Le})}return Pt.getMessage(Me.identifier.value,re[0])},get bundle(){return Pt.getBundle(Me.identifier.value)},get uri(){return Pt.getBundleUri(Me.identifier.value)}};return{version:pt.version,authentication:gi,commands:Vi,comments:$t,debug:vi,env:Fi,extensions:Pi,l10n:Xi,languages:qi,notebooks:Gi,scm:xi,tasks:Ki,tests:ji,window:Kt,workspace:si,Breakpoint:B.Breakpoint,TerminalOutputAnchor:B.TerminalOutputAnchor,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CommentThreadState:B.CommentThreadState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:at.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileDecoration2:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestionList,Hover:B.Hover,IndentAction:P.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalQuickFixCommand:B.TerminalQuickFixCommand,TerminalQuickFixOpener:B.TerminalQuickFixOpener,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TerminalExitReason:B.TerminalExitReason,TerminalQuickFixType:B.TerminalQuickFixType,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,SnippetTextEdit:B.SnippetTextEdit,TextEditorCursorStyle:O.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItem2:B.TreeItem,TreeItemCheckboxState:B.TreeItemCheckboxState,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:w.UIKind,Uri:E.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,DocumentDropEdit:B.DocumentDropEdit,DocumentPasteEdit:B.DocumentPasteEdit,InlayHint:B.InlayHint,InlayHintLabelPart:B.InlayHintLabelPart,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,NotebookControllerAffinity2:B.NotebookControllerAffinity2,NotebookEdit:B.NotebookEdit,NotebookKernelSourceAction:B.NotebookKernelSourceAction,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestRunRequest2:B.TestRunRequest2,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:rt.TextSearchCompleteMessageType,DataTransfer:B.DataTransfer,DataTransferItem:B.DataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind,InputBoxValidationSeverity:B.InputBoxValidationSeverity,TabInputText:B.TextTabInput,TabInputTextDiff:B.TextDiffTabInput,TabInputTextMerge:B.TextMergeTabInput,TabInputCustom:B.CustomEditorTabInput,TabInputNotebook:B.NotebookEditorTabInput,TabInputNotebookDiff:B.NotebookDiffEditorTabInput,TabInputWebview:B.WebviewEditorTabInput,TabInputTerminal:B.TerminalEditorTabInput,TabInputInteractiveWindow:B.InteractiveWindowInput,TelemetryTrustedValue:Y.TelemetryTrustedValue,LogLevel:Ce.LogLevel,EditSessionIdentityMatch:kt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Bt}),define(Te[256],Pe([1,0,255,33,2,249,7,17,240]),function(te,e,n,A,D,N,E,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class P extends N.RequireInterceptor{j(){}getModule(w,f){for(const u of this.b){const t=u(w);if(t){w=t;break}}if(this.a.has(w))return this.a.get(w).load(w,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class M extends A.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=E.ExtensionRuntime.Webworker}async ob(){this.h.createInstance(S.ExtHostConsoleForwarder);const w=this.h.invokeFunction(n.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(P,w,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.ub()}pb(w){return w.browser}async qb(w,f,u){f=f.with({path:T(f.path,".js")});const t=w?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const a=D.URI.revive(await this.v.$asBrowserUri(f)),p=await fetch(a.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),p.status!==200)throw new Error(p.statusText);const b=await p.text(),R=`${f.toString(!0)}#vscode-extension`,v=`${b}
//# sourceURL=${R}`;let i;try{i=new Function("module","exports","require",v)}catch(o){throw console.error(t?`Loading code for extension ${t} failed: ${o.message}`:`Loading code failed: ${o.message}`),console.error(`${f.toString(!0)}${typeof o.line=="number"?` line ${o.line}`:""}${typeof o.column=="number"?` column ${o.column}`:""}`),console.error(o),o}w&&await this.s.initializeLocalizedMessages(w);const d={},s={exports:d},l=o=>{const I=this.r.getModule(o,f);if(I===void 0)throw new Error(`Cannot load module '${o}'`);return I};try{return u.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),i(s,d,l),s.exports!==d?s.exports:d}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),u.codeLoadingStop()}}async $setRemoteEnvironment(w){}async ub(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+w;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,O.timeout)(10)}}e.ExtHostExtensionService=M;function T(m,w){return m.endsWith(w)?m:m+w}}),define(Te[257],Pe([1,0,67,33,81,256]),function(te,e,n,A,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(A.IExtHostExtensionService,N.ExtHostExtensionService,0),(0,n.registerSingleton)(D.IExtensionStoragePaths,D.ExtensionStoragePaths,0)}),define(Te[265],Pe([1,0,25,4,74,250,242,19,82,15,2,252,257]),function(te,e,n,A,D,N,E,O,S,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const T=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(i){return/^(file|vscode-remote):/i.test(i)}const f=fetch.bind(self);function u(i){self.fetch=async function(d,s){return d instanceof Request||w(String(d))&&(d=(await i(M.URI.parse(String(d)))).toString(!0)),f(d,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,s,l,o,I){(async()=>(w(s.toString())&&(s=(await i(M.URI.parse(s.toString()))).toString(!0)),super.open(d,s,l??!0,o,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(d,s){if(/^file:/i.test(d.toString()))d=P.FileAccess.uriToBrowserUri(M.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const o=`(${function(h){function y(K){return typeof K=="string"||K instanceof URL?String(K).replace(/^file:\/\//i,"vscode-file://vscode-app"):K}const C=fetch.bind(self);self.fetch=function(K,Q){return K instanceof Request?C(K,Q):C(y(K),Q)},self.XMLHttpRequest=class extends XMLHttpRequest{open(K,Q,_,j,L){return super.open(K,y(Q),_??!0,j,L)}};const H=importScripts.bind(self);self.importScripts=(...K)=>{H(...K.map(y))},H(h)}.toString()}('${d}'))`;s=s||{},s.name=s.name||O.basename(d.toString());const I=new Blob([o],{type:"application/javascript"}),r=URL.createObjectURL(I);return new i(r,s)}}else self.Worker=class extends E.NestedWorker{constructor(i,d){super(m,i,{name:O.basename(i.toString()),...d})}};const t=new class{constructor(){this.pid=void 0}exit(i){T()}async exists(i){return!0}async realpath(i){return i}};class a{constructor(){const d=new MessageChannel,s=new A.Emitter;let l=!1;m(d.port2,[d.port2]),d.port1.onmessage=o=>{const{data:I}=o;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const r=n.VSBuffer.wrap(new Uint8Array(I,0,I.byteLength));if((0,D.isMessageOfType)(r,2)){l=!0,b("received terminate message from renderer");return}s.fire(r)},this.protocol={onMessage:s.event,send:o=>{if(!l){const I=o.buffer.buffer.slice(o.buffer.byteOffset,o.buffer.byteOffset+o.buffer.byteLength);d.port1.postMessage(I,[I])}}}}}function p(i){return new Promise(d=>{const s=i.onMessage(l=>{s.dispose();const o=JSON.parse(l.toString());i.send((0,D.createMessageOfType)(0)),d({protocol:i,initData:o})});i.send((0,D.createMessageOfType)(1))})}let b=i=>T();function R(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function v(){S.mark("code/extHost/willConnectToRenderer");const i=new a;return{onmessage(d){!R(d)||p(i.protocol).then(s=>{S.mark("code/extHost/didWaitForInitData");const l=new N.ExtensionHostMain(s.protocol,s.initData,t,null,d.data);u(o=>l.asBrowserUri(o)),b=o=>l.terminate(o)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e4a11014fd91da8f2d82ba144097df21a483334d/core/vs/workbench/api/worker/extensionHostWorker.js.map
